var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 320456;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 320496;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(321323);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,81,14,0,0,108,111,97,100,50,46,119,95,110,111,109,105,110,97,108,0,1,0,0,0,84,14,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,1,0,0,0,85,14,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,1,0,0,0,86,14,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,1,0,0,0,87,14,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,1,0,0,0,88,14,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,1,0,0,0,89,14,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,187,14,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,0,1,0,0,0,192,14,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,42,32,50,46,48,0,0,0,0,1,0,0,0,201,14,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,0,1,0,0,0,204,14,0,0,1,0,0,0,206,14,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,1,0,0,0,209,14,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,1,0,0,0,211,14,0,0,1,0,0,0,219,14,0,0,1,0,0,0,220,14,0,0,1,0,0,0,223,14,0,0,1,0,0,0,232,14,0,0,1,0,0,0,234,14,0,0,1,0,0,0,236,14,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,42,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,237,14,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,239,14,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,17,15,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,0,1,0,0,0,22,15,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,42,32,50,46,48,0,0,0,0,1,0,0,0,31,15,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,0,1,0,0,0,34,15,0,0,1,0,0,0,36,15,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,1,0,0,0,39,15,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,1,0,0,0,41,15,0,0,1,0,0,0,49,15,0,0,1,0,0,0,50,15,0,0,1,0,0,0,53,15,0,0,1,0,0,0,62,15,0,0,1,0,0,0,64,15,0,0,1,0,0,0,66,15,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,42,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,67,15,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,69,15,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,103,15,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,0,1,0,0,0,108,15,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,42,32,50,46,48,0,0,0,0,1,0,0,0,117,15,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,0,1,0,0,0,120,15,0,0,1,0,0,0,122,15,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,1,0,0,0,125,15,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,1,0,0,0,127,15,0,0,1,0,0,0,135,15,0,0,1,0,0,0,136,15,0,0,1,0,0,0,139,15,0,0,1,0,0,0,148,15,0,0,1,0,0,0,150,15,0,0,1,0,0,0,152,15,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,42,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,153,15,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,155,15,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,189,15,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,0,1,0,0,0,194,15,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,42,32,50,46,48,0,0,0,0,1,0,0,0,203,15,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,0,1,0,0,0,206,15,0,0,1,0,0,0,208,15,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,1,0,0,0,211,15,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,1,0,0,0,213,15,0,0,1,0,0,0,221,15,0,0,1,0,0,0,222,15,0,0,1,0,0,0,225,15,0,0,1,0,0,0,234,15,0,0,1,0,0,0,236,15,0,0,1,0,0,0,238,15,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,42,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,239,15,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,241,15,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,19,16,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,0,1,0,0,0,24,16,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,42,32,50,46,48,0,0,0,0,1,0,0,0,33,16,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,0,1,0,0,0,36,16,0,0,1,0,0,0,38,16,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,1,0,0,0,41,16,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,1,0,0,0,43,16,0,0,1,0,0,0,51,16,0,0,1,0,0,0,52,16,0,0,1,0,0,0,55,16,0,0,1,0,0,0,64,16,0,0,1,0,0,0,66,16,0,0,1,0,0,0,68,16,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,42,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,69,16,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,71,16,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,104,16,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,0,1,0,0,0,109,16,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,42,32,50,46,48,0,0,0,0,1,0,0,0,118,16,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,0,1,0,0,0,121,16,0,0,1,0,0,0,123,16,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,1,0,0,0,126,16,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,1,0,0,0,128,16,0,0,1,0,0,0,136,16,0,0,1,0,0,0,137,16,0,0,1,0,0,0,140,16,0,0,1,0,0,0,149,16,0,0,1,0,0,0,151,16,0,0,1,0,0,0,153,16,0,0,96,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,42,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,154,16,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,156,16,0,0,1,0,0,0,52,17,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,74,111,105,110,116,115,46,109,111,0,0,0,0,0,0,10,65,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,74,111,105,110,116,115,46,85,110,105,118,101,114,115,97,108,83,112,104,101,114,105,99,97,108,32,106,111,105,110,116,32,40,99,111,110,115,105,115,116,105,110,103,32,111,102,10,97,32,117,110,105,118,101,114,115,97,108,32,106,111,105,110,116,32,97,110,100,32,97,32,115,112,104,101,114,105,99,97,108,32,106,111,105,110,116,32,99,111,110,110,101,99,116,101,100,32,116,111,103,101,116,104,101,114,10,98,121,32,97,32,114,105,103,105,100,32,114,111,100,41,32,105,115,32,105,110,32,116,104,101,32,115,105,110,103,117,108,97,114,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,111,102,32,116,104,101,10,117,110,105,118,101,114,115,97,108,32,106,111,105,110,116,46,32,84,104,105,115,32,109,101,97,110,115,32,116,104,97,116,32,97,120,105,115,32,49,32,111,102,32,116,104,101,32,117,110,105,118,101,114,115,97,108,10,106,111,105,110,116,32,100,101,102,105,110,101,100,32,118,105,97,32,112,97,114,97,109,101,116,101,114,32,34,110,49,95,97,34,32,105,115,32,112,97,114,97,108,108,101,108,32,116,111,32,118,101,99,116,111,114,10,34,114,82,111,100,95,105,97,34,32,116,104,97,116,32,105,115,32,100,105,114,101,99,116,101,100,32,102,114,111,109,32,116,104,101,32,111,114,105,103,105,110,32,111,102,32,102,114,97,109,101,95,97,32,116,111,32,116,104,101,10,111,114,105,103,105,110,32,111,102,32,102,114,97,109,101,95,98,46,10,32,32,32,89,111,117,32,109,97,121,32,116,114,121,32,116,111,32,117,115,101,32,97,110,111,116,104,101,114,32,34,110,49,95,97,34,32,118,101,99,116,111,114,46,32,73,102,32,116,104,105,115,32,102,97,105,108,115,44,10,117,115,101,32,105,110,115,116,101,97,100,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,74,111,105,110,116,115,46,83,112,104,101,114,105,99,97,108,83,112,104,101,114,105,99,97,108,44,32,105,102,32,116,104,105,115,32,105,115,10,112,111,115,115,105,98,108,101,44,32,98,101,99,97,117,115,101,32,116,104,105,115,32,106,111,105,110,116,32,97,103,103,114,101,103,97,116,105,111,110,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,97,10,115,105,110,103,117,108,97,114,32,99,111,110,102,105,103,117,114,97,116,105,111,110,46,10,0,0,0,0,0,0,0,0,10,83,105,110,103,117,108,97,114,32,112,111,115,105,116,105,111,110,32,111,102,32,108,111,111,112,32,40,101,105,116,104,101,114,32,110,111,32,111,114,32,116,119,111,32,97,110,97,108,121,116,105,99,32,115,111,108,117,116,105,111,110,115,59,10,116,104,101,32,109,101,99,104,97,110,105,115,109,32,104,97,115,32,108,111,115,116,32,111,110,101,45,100,101,103,114,101,101,45,111,102,32,102,114,101,101,100,111,109,32,105,110,32,116,104,105,115,32,112,111,115,105,116,105,111,110,41,46,10,84,114,121,32,102,105,114,115,116,32,116,111,32,117,115,101,32,97,110,111,116,104,101,114,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,74,111,105,110,116,115,46,65,115,115,101,109,98,108,105,101,115,46,74,111,105,110,116,88,88,88,32,99,111,109,112,111,110,101,110,116,46,10,73,102,32,116,104,105,115,32,97,108,115,111,32,108,101,97,100,32,116,111,32,115,105,110,103,117,108,97,114,32,112,111,115,105,116,105,111,110,115,44,32,105,116,32,99,111,117,108,100,32,98,101,32,116,104,97,116,32,116,104,105,115,10,107,105,110,101,109,97,116,105,99,32,108,111,111,112,32,99,97,110,110,111,116,32,98,101,32,115,111,108,118,101,100,32,97,110,97,108,121,116,105,99,97,108,108,121,32,119,105,116,104,32,97,32,102,105,120,101,100,32,115,116,97,116,101,10,115,101,108,101,99,116,105,111,110,46,32,73,110,32,116,104,105,115,32,99,97,115,101,32,121,111,117,32,104,97,118,101,32,116,111,32,98,117,105,108,100,32,117,112,32,116,104,101,32,108,111,111,112,32,119,105,116,104,10,98,97,115,105,99,32,106,111,105,110,116,115,32,40,78,79,32,97,103,103,114,101,103,97,116,105,111,110,32,74,111,105,110,116,88,88,88,32,99,111,109,112,111,110,101,110,116,115,41,32,97,110,100,32,114,101,108,121,32,111,110,10,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,44,32,105,46,101,46,44,32,100,117,114,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,116,104,101,32,115,116,97,116,101,115,32,119,105,108,108,10,98,101,32,100,121,110,97,109,105,99,97,108,108,121,32,115,101,108,101,99,116,101,100,32,105,110,32,115,117,99,104,32,97,32,119,97,121,32,116,104,97,116,32,105,110,32,110,111,32,112,111,115,105,116,105,111,110,32,97,10,100,101,103,114,101,101,32,111,102,32,102,114,101,101,100,111,109,32,105,115,32,108,111,115,116,46,10,0,0,0,128,20,0,0,8,11,0,0,5,0,0,0,20,11,0,0,3,0,0,0,0,0,0,0,128,20,0,0,239,32,0,0,7,0,0,0,250,32,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,69,120,97,109,112,108,101,115,46,76,111,111,112,115,46,69,110,103,105,110,101,86,54,95,97,110,97,108,121,116,105,99,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,69,120,97,109,112,108,101,115,47,76,111,111,112,115,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,69,120,97,109,112,108,101,115,46,76,111,111,112,115,46,69,110,103,105,110,101,86,54,95,97,110,97,108,121,116,105,99,95,105,110,102,111,46,120,109,108,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,52,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,51,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,74,111,105,110,116,115,46,109,111,0,0,0,0,0,0,120,29,0,0,194,32,0,0,7,0,0,0,205,32,0,0,3,0,0,0,0,0,0,0,10,83,105,110,103,117,108,97,114,32,112,111,115,105,116,105,111,110,32,111,102,32,108,111,111,112,32,40,101,105,116,104,101,114,32,110,111,32,111,114,32,116,119,111,32,97,110,97,108,121,116,105,99,32,115,111,108,117,116,105,111,110,115,59,10,116,104,101,32,109,101,99,104,97,110,105,115,109,32,104,97,115,32,108,111,115,116,32,111,110,101,45,100,101,103,114,101,101,45,111,102,32,102,114,101,101,100,111,109,32,105,110,32,116,104,105,115,32,112,111,115,105,116,105,111,110,41,46,10,84,114,121,32,102,105,114,115,116,32,116,111,32,117,115,101,32,97,110,111,116,104,101,114,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,74,111,105,110,116,115,46,65,115,115,101,109,98,108,105,101,115,46,74,111,105,110,116,88,88,88,32,99,111,109,112,111,110,101,110,116,46,10,73,102,32,116,104,105,115,32,97,108,115,111,32,108,101,97,100,32,116,111,32,115,105,110,103,117,108,97,114,32,112,111,115,105,116,105,111,110,115,44,32,105,116,32,99,111,117,108,100,32,98,101,32,116,104,97,116,32,116,104,105,115,10,107,105,110,101,109,97,116,105,99,32,108,111,111,112,32,99,97,110,110,111,116,32,98,101,32,115,111,108,118,101,100,32,97,110,97,108,121,116,105,99,97,108,108,121,32,119,105,116,104,32,97,32,102,105,120,101,100,32,115,116,97,116,101,10,115,101,108,101,99,116,105,111,110,46,32,73,110,32,116,104,105,115,32,99,97,115,101,32,121,111,117,32,104,97,118,101,32,116,111,32,98,117,105,108,100,32,117,112,32,116,104,101,32,108,111,111,112,32,119,105,116,104,10,98,97,115,105,99,32,106,111,105,110,116,115,32,40,78,79,32,97,103,103,114,101,103,97,116,105,111,110,32,74,111,105,110,116,88,88,88,32,99,111,109,112,111,110,101,110,116,115,41,32,97,110,100,32,114,101,108,121,32,111,110,10,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,44,32,105,46,101,46,44,32,100,117,114,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,116,104,101,32,115,116,97,116,101,115,32,119,105,108,108,10,98,101,32,100,121,110,97,109,105,99,97,108,108,121,32,115,101,108,101,99,116,101,100,32,105,110,32,115,117,99,104,32,97,32,119,97,121,32,116,104,97,116,32,105,110,32,110,111,32,112,111,115,105,116,105,111,110,32,97,10,100,101,103,114,101,101,32,111,102,32,102,114,101,101,100,111,109,32,105,115,32,108,111,115,116,46,10,0,0,0,144,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,107,49,98,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,1,0,0,0,15,4,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,42,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,95,97,46,82,46,84,91,49,44,49,93,0,0,0,0,0,0,0,105,102,32,110,111,69,118,101,110,116,40,97,98,115,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,97,117,120,41,32,60,32,49,101,45,49,48,41,32,116,104,101,110,32,49,101,45,49,48,32,101,108,115,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,97,117,120,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,42,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,95,97,46,82,46,84,91,49,44,49,93,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,32,94,32,48,46,53,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,105,102,32,110,111,69,118,101,110,116,40,97,98,115,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,97,117,120,41,32,60,32,49,101,45,49,48,41,32,116,104,101,110,32,49,101,45,49,48,32,101,108,115,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,97,117,120,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,32,94,32,48,46,53,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,42,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,95,97,46,82,46,84,91,49,44,49,93,0,0,0,0,0,0,0,105,102,32,110,111,69,118,101,110,116,40,97,98,115,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,97,117,120,41,32,60,32,49,101,45,49,48,41,32,116,104,101,110,32,49,101,45,49,48,32,101,108,115,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,97,117,120,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,32,94,32,48,46,53,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,42,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,95,97,46,82,46,84,91,49,44,49,93,0,0,0,0,0,0,0,105,102,32,110,111,69,118,101,110,116,40,97,98,115,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,97,117,120,41,32,60,32,49,101,45,49,48,41,32,116,104,101,110,32,49,101,45,49,48,32,101,108,115,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,97,117,120,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,32,94,32,48,46,53,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,42,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,95,97,46,82,46,84,91,49,44,49,93,0,0,0,0,0,0,0,105,102,32,110,111,69,118,101,110,116,40,97,98,115,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([46,106,111,105,110,116,85,83,80,46,97,117,120,41,32,60,32,49,101,45,49,48,41,32,116,104,101,110,32,49,101,45,49,48,32,101,108,115,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,97,117,120,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,32,94,32,48,46,53,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,42,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,95,97,46,82,46,84,91,49,44,49,93,0,0,0,0,0,0,0,105,102,32,110,111,69,118,101,110,116,40,97,98,115,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,97,117,120,41,32,60,32,49,101,45,49,48,41,32,116,104,101,110,32,49,101,45,49,48,32,101,108,115,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,97,117,120,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,32,94,32,48,46,53,0,0,1,0,0,0,15,4,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,32,94,32,49,46,53,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,32,94,32,49,46,53,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,32,94,32,49,46,53,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,32,94,32,49,46,53,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,32,94,32,49,46,53,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,32,94,32,49,46,53,0,0,1,0,0,0,160,16,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,95,97,46,82,46,84,91,49,44,49,93,32,42,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,95,97,46,82,46,84,91,49,44,49,93,32,42,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,95,97,46,82,46,84,91,49,44,49,93,32,42,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,95,97,46,82,46,84,91,49,44,49,93,32,42,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,95,97,46,82,46,84,91,49,44,49,93,32,42,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,95,97,46,82,46,84,91,49,44,49,93,32,42,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,1,0,0,0,160,16,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,118,95,114,101,108,32,60,32,48,46,48,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,120,32,60,32,48,46,57,56,55,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,120,32,62,32,48,46,57,51,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,118,95,114,101,108,32,60,32,48,46,48,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,120,32,60,32,48,46,57,56,55,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,120,32,62,32,48,46,57,51,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,118,95,114,101,108,32,60,32,48,46,48,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,120,32,60,32,48,46,57,56,55,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,120,32,62,32,48,46,57,51,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,118,95,114,101,108,32,60,32,48,46,48,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,120,32,60,32,48,46,57,56,55,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,120,32,62,32,48,46,57,51,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,118,95,114,101,108,32,60,32,48,46,48,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,120,32,60,32,48,46,57,56,55,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,120,32,62,32,48,46,57,51,0,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,118,95,114,101,108,32,60,32,48,46,48,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,120,32,60,32,48,46,57,56,55,0,0,0,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,120,32,62,32,48,46,57,51,0,0,0,0,0,0,1,0,0,0,115,16,0,0,1,0,0,0,115,16,0,0,1,0,0,0,115,16,0,0,1,0,0,0,30,16,0,0,1,0,0,0,30,16,0,0,1,0,0,0,30,16,0,0,1,0,0,0,200,15,0,0,1,0,0,0,200,15,0,0,1,0,0,0,200,15,0,0,1,0,0,0,114,15,0,0,1,0,0,0,114,15,0,0,1,0,0,0,114,15,0,0,1,0,0,0,28,15,0,0,1,0,0,0,28,15,0,0,1,0,0,0,28,15,0,0,1,0,0,0,198,14,0,0,1,0,0,0,198,14,0,0,1,0,0,0,198,14,0,0,8,50,0,0,16,50,0,0,24,50,0,0,32,50,0,0,40,50,0,0,48,50,0,0,56,50,0,0,64,50,0,0,72,50,0,0,80,50,0,0,88,50,0,0,96,50,0,0,104,50,0,0,112,50,0,0,120,50,0,0,128,50,0,0,136,50,0,0,144,50,0,0,56,47,0,0,96,47,0,0,136,47,0,0,176,47,0,0,216,47,0,0,0,48,0,0,40,48,0,0,80,48,0,0,120,48,0,0,160,48,0,0,200,48,0,0,240,48,0,0,24,49,0,0,64,49,0,0,104,49,0,0,144,49,0,0,184,49,0,0,224,49,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,36,68,69,82,46,102,105,108,116,101,114,46,120,91,50,93,0,0,0,0,0,0,0,0,36,68,69,82,46,102,105,108,116,101,114,46,120,91,49,93,0,0,0,0,0,0,0,0,36,84,77,80,95,51,53,57,55,91,49,93,0,0,0,0,36,84,77,80,95,51,53,57,55,91,50,93,0,0,0,0,36,84,77,80,95,51,53,57,55,91,51,93,0,0,0,0,45,48,46,49,55,53,32,43,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,110,111,116,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,112,111,115,105,116,105,118,101,66,114,97,110,99,104,32,61,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,74,111,105,110,116,115,46,73,110,116,101,114,110,97,108,46,80,114,105,115,109,97,116,105,99,87,105,116,104,76,101,110,103,116,104,67,111,110,115,116,114,97,105,110,116,46,115,101,108,101,99,116,66,114,97,110,99,104,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,108,101,110,103,116,104,44,32,35,83,72,65,82,69,68,95,76,73,84,69,82,65,76,95,57,40,82,101,97,108,91,51,93,41,35,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,115,95,111,102,102,115,101,116,32,43,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,115,95,103,117,101,115,115,44,32,123,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,49,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,50,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,51,93,125,44,32,123,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,49,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,50,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,51,93,125,41,0,0,0,0,36,84,77,80,95,51,54,48,49,91,49,93,0,0,0,0,36,84,77,80,95,51,54,48,49,91,50,93,0,0,0,0,36,84,77,80,95,51,54,48,49,91,51,93,0,0,0,0,45,48,46,49,55,53,32,43,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,110,111,116,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,112,111,115,105,116,105,118,101,66,114,97,110,99,104,32,61,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,74,111,105,110,116,115,46,73,110,116,101,114,110,97,108,46,80,114,105,115,109,97,116,105,99,87,105,116,104,76,101,110,103,116,104,67,111,110,115,116,114,97,105,110,116,46,115,101,108,101,99,116,66,114,97,110,99,104,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,108,101,110,103,116,104,44,32,35,83,72,65,82,69,68,95,76,73,84,69,82,65,76,95,57,40,82,101,97,108,91,51,93,41,35,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,115,95,111,102,102,115,101,116,32,43,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,115,95,103,117,101,115,115,44,32,123,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,49,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,50,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,51,93,125,44,32,123,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,49,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,50,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,51,93,125,41,0,0,0,0,36,84,77,80,95,51,54,48,53,91,49,93,0,0,0,0,36,84,77,80,95,51,54,48,53,91,50,93,0,0,0,0,36,84,77,80,95,51,54,48,53,91,51,93,0,0,0,0,45,48,46,49,55,53,32,43,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,110,111,116,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,112,111,115,105,116,105,118,101,66,114,97,110,99,104,32,61,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,74,111,105,110,116,115,46,73,110,116,101,114,110,97,108,46,80,114,105,115,109,97,116,105,99,87,105,116,104,76,101,110,103,116,104,67,111,110,115,116,114,97,105,110,116,46,115,101,108,101,99,116,66,114,97,110,99,104,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,108,101,110,103,116,104,44,32,35,83,72,65,82,69,68,95,76,73,84,69,82,65,76,95,57,40,82,101,97,108,91,51,93,41,35,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,115,95,111,102,102,115,101,116,32,43,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,115,95,103,117,101,115,115,44,32,123,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,49,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,50,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,51,93,125,44,32,123,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,49,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,50,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,51,93,125,41,0,0,0,0,36,84,77,80,95,51,54,48,57,91,49,93,0,0,0,0,36,84,77,80,95,51,54,48,57,91,50,93,0,0,0,0,36,84,77,80,95,51,54,48,57,91,51,93,0,0,0,0,45,48,46,49,55,53,32,43,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,110,111,116,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,112,111,115,105,116,105,118,101,66,114,97,110,99,104,32,61,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,74,111,105,110,116,115,46,73,110,116,101,114,110,97,108,46,80,114,105,115,109,97,116,105,99,87,105,116,104,76,101,110,103,116,104,67,111,110,115,116,114,97,105,110,116,46,115,101,108,101,99,116,66,114,97,110,99,104,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,108,101,110,103,116,104,44,32,35,83,72,65,82,69,68,95,76,73,84,69,82,65,76,95,57,40,82,101,97,108,91,51,93,41,35,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,115,95,111,102,102,115,101,116,32,43,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,115,95,103,117,101,115,115,44,32,123,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,49,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,50,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,51,93,125,44,32,123,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,49,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,50,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,51,93,125,41,0,0,0,0,36,84,77,80,95,51,54,49,51,91,49,93,0,0,0,0,36,84,77,80,95,51,54,49,51,91,50,93,0,0,0,0,36,84,77,80,95,51,54,49,51,91,51,93,0,0,0,0,45,48,46,49,55,53,32,43,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,110,111,116,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,112,111,115,105,116,105,118,101,66,114,97,110,99,104,32,61,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,74,111,105,110,116,115,46,73,110,116,101,114,110,97,108,46,80,114,105,115,109,97,116,105,99,87,105,116,104,76,101,110,103,116,104,67,111,110,115,116,114,97,105,110,116,46,115,101,108,101,99,116,66,114,97,110,99,104,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,108,101,110,103,116,104,44,32,35,83,72,65,82,69,68,95,76,73,84,69,82,65,76,95,57,40,82,101,97,108,91,51,93,41,35,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,115,95,111,102,102,115,101,116,32,43,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,115,95,103,117,101,115,115,44,32,123,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,49,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,50,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,51,93,125,44,32,123,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,49,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,50,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,51,93,125,41,0,0,0,0,36,84,77,80,95,51,54,49,55,91,49,93,0,0,0,0,36,84,77,80,95,51,54,49,55,91,50,93,0,0,0,0,36,84,77,80,95,51,54,49,55,91,51,93,0,0,0,0,45,48,46,49,55,53,32,43,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,110,111,116,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,112,111,115,105,116,105,118,101,66,114,97,110,99,104,32,61,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,74,111,105,110,116,115,46,73,110,116,101,114,110,97,108,46,80,114,105,115,109,97,116,105,99,87,105,116,104,76,101,110,103,116,104,67,111,110,115,116,114,97,105,110,116,46,115,101,108,101,99,116,66,114,97,110,99,104,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,108,101,110,103,116,104,44,32,35,83,72,65,82,69,68,95,76,73,84,69,82,65,76,95,57,40,82,101,97,108,91,51,93,41,35,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,115,95,111,102,102,115,101,116,32,43,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,115,95,103,117,101,115,115,44,32,123,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,49,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,50,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,97,91,51,93,125,44,32,123,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,49,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,50,93,44,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,114,95,98,91,51,93,125,41,0,0,0,0,72,51,0,0,96,51,0,0,120,51,0,0,136,51,0,0,152,51,0,0,168,51,0,0,232,51,0,0,136,54,0,0,152,54,0,0,168,54,0,0,184,54,0,0,248,54,0,0,152,57,0,0,168,57,0,0,184,57,0,0,200,57,0,0,8,58,0,0,168,60,0,0,184,60,0,0,200,60,0,0,216,60,0,0,24,61,0,0,184,63,0,0,200,63,0,0,216,63,0,0,232,63,0,0,40,64,0,0,200,66,0,0,216,66,0,0,232,66,0,0,248,66,0,0,56,67,0,0,1,0,0,0,160,90,0,0,168,90,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,1,0,0,0,128,90,0,0,136,90,0,0,0,0,0,0,1,0,0,0,2,0,0,0,102,105,108,116,101,114,46,97,108,112,104,97,0,0,0,0,1,0,0,0,14,0,0,0,119,111,114,108,100,46,100,101,102,97,117,108,116,87,105,100,116,104,70,114,97,99,116,105,111,110,0,0,0,0,0,0,1,0,0,0,27,0,0,0,1,0,0,0,36,0,0,0,1,0,0,0,41,0,0,0,1,0,0,0,45,0,0,0,1,0,0,0,49,0,0,0,1,0,0,0,62,0,0,0,1,0,0,0,75,0,0,0,1,0,0,0,84,0,0,0,1,0,0,0,89,0,0,0,1,0,0,0,93,0,0,0,1,0,0,0,97,0,0,0,1,0,0,0,110,0,0,0,1,0,0,0,123,0,0,0,1,0,0,0,132,0,0,0,1,0,0,0,137,0,0,0,1,0,0,0,141,0,0,0,1,0,0,0,145,0,0,0,1,0,0,0,158,0,0,0,1,0,0,0,171,0,0,0,1,0,0,0,180,0,0,0,1,0,0,0,185,0,0,0,1,0,0,0,189,0,0,0,1,0,0,0,193,0,0,0,1,0,0,0,206,0,0,0,1,0,0,0,219,0,0,0,1,0,0,0,228,0,0,0,1,0,0,0,233,0,0,0,1,0,0,0,237,0,0,0,1,0,0,0,241,0,0,0,1,0,0,0,254,0,0,0,1,0,0,0,11,1,0,0,1,0,0,0,20,1,0,0,1,0,0,0,25,1,0,0,1,0,0,0,29,1,0,0,1,0,0,0,33,1,0,0,1,0,0,0,43,1,0,0,1,0,0,0,16,2,0,0,108,111,97,100,50,46,119,95,110,111,109,105,110,97,108,0,1,0,0,0,90,2,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,1,0,0,0,98,2,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,42,32,50,46,48,0,0,0,0,1,0,0,0,113,2,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,0,1,0,0,0,114,2,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,0,1,0,0,0,124,2,0,0,1,0,0,0,126,2,0,0,1,0,0,0,128,2,0,0,1,0,0,0,129,2,0,0,1,0,0,0,131,2,0,0,1,0,0,0,132,2,0,0,1,0,0,0,138,2,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,42,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,140,2,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,142,2,0,0,1,0,0,0,144,2,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,1,0,0,0,146,2,0,0,1,0,0,0,157,2,0,0,1,0,0,0,163,2,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,1,0,0,0,171,2,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,42,32,50,46,48,0,0,0,0,1,0,0,0,186,2,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,0,1,0,0,0,187,2,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,0,1,0,0,0,197,2,0,0,1,0,0,0,199,2,0,0,1,0,0,0,201,2,0,0,1,0,0,0,202,2,0,0,1,0,0,0,204,2,0,0,1,0,0,0,205,2,0,0,1,0,0,0,211,2,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,42,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,213,2,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,215,2,0,0,1,0,0,0,217,2,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,1,0,0,0,219,2,0,0,1,0,0,0,230,2,0,0,1,0,0,0,236,2,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,1,0,0,0,244,2,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,42,32,50,46,48,0,0,0,0,1,0,0,0,3,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,0,1,0,0,0,4,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,0,1,0,0,0,14,3,0,0,1,0,0,0,16,3,0,0,1,0,0,0,18,3,0,0,1,0,0,0,19,3,0,0,1,0,0,0,21,3,0,0,1,0,0,0,22,3,0,0,1,0,0,0,28,3,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,42,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,30,3,0,0,101,110,103,105,110,101,46,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,32,3,0,0,1,0,0,0,34,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,1,0,0,0,36,3,0,0,1,0,0,0,47,3,0,0,1,0,0,0,53,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,1,0,0,0,61,3,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,42,32,50,46,48,0,0,0,0,1,0,0,0,76,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,0,1,0,0,0,77,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,0,1,0,0,0,87,3,0,0,1,0,0,0,89,3,0,0,1,0,0,0,91,3,0,0,1,0,0,0,92,3,0,0,1,0,0,0,94,3,0,0,1,0,0,0,95,3,0,0,1,0,0,0,101,3,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,42,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,103,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,105,3,0,0,1,0,0,0,107,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,1,0,0,0,109,3,0,0,1,0,0,0,120,3,0,0,1,0,0,0,126,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,1,0,0,0,134,3,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,42,32,50,46,48,0,0,0,0,1,0,0,0,149,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,0,1,0,0,0,150,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,0,1,0,0,0,160,3,0,0,1,0,0,0,162,3,0,0,1,0,0,0,164,3,0,0,1,0,0,0,165,3,0,0,1,0,0,0,167,3,0,0,1,0,0,0,168,3,0,0,1,0,0,0,174,3,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,42,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,176,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,178,3,0,0,1,0,0,0,180,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,1,0,0,0,182,3,0,0,1,0,0,0,193,3,0,0,1,0,0,0,199,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,0,0,0,0,0,0,0,1,0,0,0,207,3,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,107,49,98,41,32,42,32,50,46,48,0,0,0,0,1,0,0,0,222,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,0,1,0,0,0,223,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,0,1,0,0,0,233,3,0,0,1,0,0,0,235,3,0,0,1,0,0,0,237,3,0,0,1,0,0,0,238,3,0,0,1,0,0,0,240,3,0,0,1,0,0,0,241,3,0,0,1,0,0,0,247,3,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,115,113,114,116,40,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,42,32,50,46,48,0,0,0,0,0,0,0,0,104,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,249,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,251,3,0,0,1,0,0,0,253,3,0,0,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,0,1,0,0,0,255,3,0,0,1,0,0,0,10,4,0,0,1,0,0,0,108,4,0,0,1,0,0,0,238,4,0,0,102,105,108,116,101,114,46,119,0,0,0,0,0,0,0,0,1,0,0,0,240,4,0,0,2,0,0,0,48,90,0,0,56,90,0,0,0,0,0,0,1,0,0,0,8,90,0,0,16,90,0,0,0,0,0,0,1,0,0,0,209,5,0,0,1,0,0,0,25,6,0,0,1,0,0,0,97,6,0,0,1,0,0,0,169,6,0,0,1,0,0,0,241,6,0,0,1,0,0,0,57,7,0,0,1,0,0,0,62,7,0,0,1,0,0,0,88,7,0,0,119,111,114,108,100,46,100,101,102,97,117,108,116,70,114,97,109,101,68,105,97,109,101,116,101,114,70,114,97,99,116,105,111,110,0,0,0,0,0,0,1,0,0,0,93,7,0,0,1,0,0,0,232,89,0,0,240,89,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,128,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,3,0,0,0,3,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,37,115,40,115,116,97,114,116,61,37,103,41,0,0,0,0,1,0,0,0,129,24,0,0,119,111,114,108,100,46,100,101,102,97,117,108,116,70,114,97,109,101,68,105,97,109,101,116,101,114,70,114,97,99,116,105,111,110,0,0,0,0,0,0,1,0,0,0,136,24,0,0,119,111,114,108,100,46,100,101,102,97,117,108,116,87,105,100,116,104,70,114,97,99,116,105,111,110,0,0,0,0,0,0,1,0,0,0,146,24,0,0,2,0,0,0,0,90,3,0,8,90,3,0,0,0,0,0,1,0,0,0,216,89,3,0,224,89,3,0,0,0,0,0,1,0,0,0,177,24,0,0,1,0,0,0,183,24,0,0,1,0,0,0,189,24,0,0,1,0,0,0,195,24,0,0,1,0,0,0,204,24,0,0,1,0,0,0,208,24,0,0,1,0,0,0,254,24,0,0,1,0,0,0,45,25,0,0,1,0,0,0,83,25,0,0,1,0,0,0,89,25,0,0,1,0,0,0,95,25,0,0,1,0,0,0,104,25,0,0,1,0,0,0,108,25,0,0,1,0,0,0,154,25,0,0,1,0,0,0,201,25,0,0,1,0,0,0,239,25,0,0,1,0,0,0,245,25,0,0,1,0,0,0,251,25,0,0,1,0,0,0,4,26,0,0,1,0,0,0,8,26,0,0,1,0,0,0,54,26,0,0,1,0,0,0,101,26,0,0,1,0,0,0,139,26,0,0,1,0,0,0,145,26,0,0,1,0,0,0,151,26,0,0,1,0,0,0,160,26,0,0,1,0,0,0,164,26,0,0,1,0,0,0,210,26,0,0,1,0,0,0,1,27,0,0,1,0,0,0,39,27,0,0,1,0,0,0,45,27,0,0,1,0,0,0,51,27,0,0,1,0,0,0,60,27,0,0,1,0,0,0,64,27,0,0,1,0,0,0,110,27,0,0,1,0,0,0,157,27,0,0,1,0,0,0,195,27,0,0,1,0,0,0,200,27,0,0,1,0,0,0,206,27,0,0,1,0,0,0,215,27,0,0,1,0,0,0,219,27,0,0,1,0,0,0,9,28,0,0,1,0,0,0,56,28,0,0,1,0,0,0,91,28,0,0,102,105,108,116,101,114,46,97,108,112,104,97,0,0,0,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,108,116,101,114,46,105,110,105,116,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,108,116,101,114,46,105,110,105,116,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,78,111,73,110,105,116,32,97,110,100,32,102,105,108,116,101,114,46,105,110,105,116,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,73,110,105,116,105,97,108,79,117,116,112,117,116,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,67,111,110,116,105,110,117,111,117,115,46,109,111,0,0,0,0,0,0,0,232,93,0,0,127,6,0,0,5,0,0,0,130,6,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,50,46,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,50,46,119,95,110,111,109,105,110,97,108,32,62,61,32,49,101,45,49,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,82,111,116,97,116,105,111,110,97,108,46,109,111,0,0,0,0,192,94,0,0,159,24,0,0,7,0,0,0,160,24,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,108,111,97,100,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,192,94,0,0,253,8,0,0,7,0,0,0,255,8,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,192,94,0,0,252,8,0,0,7,0,0,0,252,8,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,80,97,114,116,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,69,120,97,109,112,108,101,115,47,76,111,111,112,115,47,85,116,105,108,105,116,105,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,74,111,105,110,116,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,114,111,100,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,114,111,100,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,119,111,114,108,100,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,102,114,97,109,101,95,114,101,115,111,108,118,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,83,101,110,115,111,114,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,119,111,114,108,100,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,102,114,97,109,101,95,114,101,115,111,108,118,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,105,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,105,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,105,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,105,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,114,111,100,73,110,101,114,116,105,97,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,114,111,100,73,110,101,114,116,105,97,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,114,111,100,73,110,101,114,116,105,97,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,114,111,100,73,110,101,114,116,105,97,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,114,111,100,73,110,101,114,116,105,97,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,114,111,100,73,110,101,114,116,105,97,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,114,111,100,77,97,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,114,111,100,77,97,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,112,105,115,116,111,110,77,97,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,112,105,115,116,111,110,77,97,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+40960);
/* memory initializer */ allocate([110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,114,111,100,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,114,111,100,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,119,111,114,108,100,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,102,114,97,109,101,95,114,101,115,111,108,118,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,119,111,114,108,100,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,102,114,97,109,101,95,114,101,115,111,108,118,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+51200);
/* memory initializer */ allocate([116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,105,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,105,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,105,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,105,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,114,111,100,73,110,101,114,116,105,97,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,114,111,100,73,110,101,114,116,105,97,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,114,111,100,73,110,101,114,116,105,97,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,114,111,100,73,110,101,114,116,105,97,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,114,111,100,73,110,101,114,116,105,97,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,114,111,100,73,110,101,114,116,105,97,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,114,111,100,77,97,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,114,111,100,77,97,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,112,105,115,116,111,110,77,97,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,112,105,115,116,111,110,77,97,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+61440);
/* memory initializer */ allocate([100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,114,111,100,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,114,111,100,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,119,111,114,108,100,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,102,114,97,109,101,95,114,101,115,111,108,118,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,119,111,114,108,100,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,102,114,97,109,101,95,114,101,115,111,108,118,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+71680);
/* memory initializer */ allocate([110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,105,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,105,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,105,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,105,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,114,111,100,73,110,101,114,116,105,97,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,114,111,100,73,110,101,114,116,105,97,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,114,111,100,73,110,101,114,116,105,97,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,114,111,100,73,110,101,114,116,105,97,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,114,111,100,73,110,101,114,116,105,97,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,114,111,100,73,110,101,114,116,105,97,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,114,111,100,77,97,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,114,111,100,77,97,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,112,105,115,116,111,110,77,97,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,112,105,115,116,111,110,77,97,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+81920);
/* memory initializer */ allocate([51,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,114,111,100,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,114,111,100,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,119,111,114,108,100,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,102,114,97,109,101,95,114,101,115,111,108,118,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,119,111,114,108,100,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,102,114,97,109,101,95,114,101,115,111,108,118,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+92160);
/* memory initializer */ allocate([109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,105,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,105,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,105,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,105,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,114,111,100,73,110,101,114,116,105,97,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,114,111,100,73,110,101,114,116,105,97,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,114,111,100,73,110,101,114,116,105,97,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,114,111,100,73,110,101,114,116,105,97,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,114,111,100,73,110,101,114,116,105,97,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,114,111,100,73,110,101,114,116,105,97,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,114,111,100,77,97,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,114,111,100,77,97,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,112,105,115,116,111,110,77,97,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,112,105,115,116,111,110,77,97,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+102400);
/* memory initializer */ allocate([93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,114,111,100,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,114,111,100,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,119,111,114,108,100,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,102,114,97,109,101,95,114,101,115,111,108,118,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,119,111,114,108,100,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,102,114,97,109,101,95,114,101,115,111,108,118,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,105,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,105,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,105,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,105,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,46,104,101,105,103,104,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+112640);
/* memory initializer */ allocate([32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,114,111,100,73,110,101,114,116,105,97,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,114,111,100,73,110,101,114,116,105,97,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,114,111,100,73,110,101,114,116,105,97,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,114,111,100,73,110,101,114,116,105,97,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,114,111,100,73,110,101,114,116,105,97,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,114,111,100,73,110,101,114,116,105,97,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,114,111,100,77,97,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,114,111,100,77,97,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,112,105,115,116,111,110,77,97,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,112,105,115,116,111,110,77,97,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+122880);
/* memory initializer */ allocate([118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,152,139,0,0,18,1,0,0,5,0,0,0,18,1,0,0,51,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,136,140,0,0,72,26,0,0,7,0,0,0,73,26,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,114,111,100,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,114,111,100,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,136,140,0,0,76,26,0,0,7,0,0,0,78,26,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,136,140,0,0,102,10,0,0,5,0,0,0,104,10,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,136,140,0,0,99,10,0,0,5,0,0,0,101,10,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,114,111,100,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,136,140,0,0,139,10,0,0,5,0,0,0,140,10,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,136,140,0,0,115,10,0,0,5,0,0,0,119,10,0,0,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,140,0,0,111,10,0,0,5,0,0,0,114,10,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,140,0,0,90,10,0,0,5,0,0,0,92,10,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,140,0,0,99,32,0,0,7,0,0,0,100,32,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,112,114,105,115,109,97,116,105,99,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,136,140,0,0,96,32,0,0,7,0,0,0,98,32,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,136,140,0,0,51,20,0,0,7,0,0,0,52,20,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,50,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,136,140,0,0,11,20,0,0,7,0,0,0,13,20,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,136,140,0,0,24,20,0,0,7,0,0,0,25,20,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,136,140,0,0,4,20,0,0,7,0,0,0,7,20,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,136,140,0,0,35,20,0,0,7,0,0,0,39,20,0,0,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,136,140,0,0,31,20,0,0,7,0,0,0,34,20,0,0,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,136,140,0,0,21,20,0,0,7,0,0,0,23,20,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,136,140,0,0,254,19,0,0,7,0,0,0,0,20,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,119,111,114,108,100,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,102,114,97,109,101,95,114,101,115,111,108,118,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,240,154,0,0,195,11,0,0,7,0,0,0,198,11,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,119,111,114,108,100,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,101,108,97,116,105,118,101,80,111,115,105,116,105,111,110,46,114,101,115,111,108,118,101,73,110,70,114,97,109,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,101,115,111,108,118,101,73,110,70,114,97,109,101,65,66,46,102,114,97,109,101,95,114,101,115,111,108,118,101,32,104,97,115,32,118,97,108,117,101,58,32,0,240,154,0,0,203,5,0,0,5,0,0,0,206,5,0,0,105,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,140,0,0,69,26,0,0,7,0,0,0,71,26,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,140,0,0,59,26,0,0,7,0,0,0,61,26,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,136,140,0,0,56,26,0,0,7,0,0,0,58,26,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,216,96,0,0,166,1,0,0,5,0,0,0,169,1,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,216,96,0,0,161,1,0,0,5,0,0,0,165,1,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,216,96,0,0,123,1,0,0,5,0,0,0,127,1,0,0,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,216,96,0,0,102,1,0,0,5,0,0,0,104,1,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,105,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,105,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,105,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,105,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,46,104,101,105,103,104,116,32,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+133120);
/* memory initializer */ allocate([117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,114,111,100,73,110,101,114,116,105,97,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,114,111,100,73,110,101,114,116,105,97,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,152,139,0,0,15,2,0,0,5,0,0,0,17,2,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,114,111,100,73,110,101,114,116,105,97,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,114,111,100,73,110,101,114,116,105,97,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,152,139,0,0,12,2,0,0,5,0,0,0,14,2,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,114,111,100,73,110,101,114,116,105,97,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,114,111,100,73,110,101,114,116,105,97,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,152,139,0,0,9,2,0,0,5,0,0,0,11,2,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,114,111,100,77,97,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,114,111,100,77,97,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,152,139,0,0,7,2,0,0,5,0,0,0,8,2,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,152,139,0,0,254,1,0,0,5,0,0,0,0,2,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,152,139,0,0,251,1,0,0,5,0,0,0,253,1,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,112,105,115,116,111,110,73,110,101,114,116,105,97,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,152,139,0,0,248,1,0,0,5,0,0,0,250,1,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,112,105,115,116,111,110,77,97,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,112,105,115,116,111,110,77,97,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,152,139,0,0,246,1,0,0,5,0,0,0,247,1,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,216,96,0,0,139,4,0,0,5,0,0,0,143,4,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,216,96,0,0,123,4,0,0,5,0,0,0,126,4,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,216,96,0,0,118,4,0,0,5,0,0,0,122,4,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,216,96,0,0,225,2,0,0,5,0,0,0,229,2,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,216,96,0,0,214,2,0,0,5,0,0,0,218,2,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,216,96,0,0,248,2,0,0,5,0,0,0,251,2,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,216,96,0,0,190,2,0,0,5,0,0,0,192,2,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,216,96,0,0,165,2,0,0,5,0,0,0,167,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,216,96,0,0,162,2,0,0,5,0,0,0,164,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,216,96,0,0,159,2,0,0,5,0,0,0,161,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,216,96,0,0,156,2,0,0,5,0,0,0,158,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,216,96,0,0,153,2,0,0,5,0,0,0,155,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,216,96,0,0,150,2,0,0,5,0,0,0,152,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,216,96,0,0,149,2,0,0,5,0,0,0,149,2,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,216,96,0,0,195,0,0,0,5,0,0,0,198,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,216,96,0,0,190,0,0,0,5,0,0,0,194,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,216,96,0,0,162,4,0,0,5,0,0,0,165,4,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,216,96,0,0,66,4,0,0,5,0,0,0,68,4,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,216,96,0,0,41,4,0,0,5,0,0,0,43,4,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,216,96,0,0,38,4,0,0,5,0,0,0,40,4,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,216,96,0,0,35,4,0,0,5,0,0,0,37,4,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,216,96,0,0,32,4,0,0,5,0,0,0,34,4,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,216,96,0,0,29,4,0,0,5,0,0,0,31,4,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,216,96,0,0,26,4,0,0,5,0,0,0,28,4,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,216,96,0,0,25,4,0,0,5,0,0,0,25,4,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,136,140,0,0,247,0,0,0,5,0,0,0,249,0,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,136,140,0,0,244,0,0,0,5,0,0,0,246,0,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,98,101,97,114,105,110,103,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,98,101,97,114,105,110,103,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,101,110,103,105,110,101,46,98,101,97,114,105,110,103,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,136,140,0,0,1,1,0,0,5,0,0,0,2,1,0,0,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,224,77,2,0,189,4,0,0,3,0,0,0,193,4,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,224,77,2,0,167,4,0,0,3,0,0,0,169,4,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,224,77,2,0,164,4,0,0,3,0,0,0,166,4,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,100,101,102,97,117,108,116,78,109,95,116,111,95,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,100,101,102,97,117,108,116,78,109,95,116,111,95,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,224,77,2,0,243,4,0,0,3,0,0,0,245,4,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,100,101,102,97,117,108,116,78,95,116,111,95,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,100,101,102,97,117,108,116,78,95,116,111,95,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,224,77,2,0,240,4,0,0,3,0,0,0,242,4,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,100,101,102,97,117,108,116,83,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,100,101,102,97,117,108,116,83,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,224,77,2,0,237,4,0,0,3,0,0,0,239,4,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,224,77,2,0,198,4,0,0,3,0,0,0,202,4,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,109,117,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,109,117,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,224,77,2,0,156,4,0,0,3,0,0,0,160,4,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,71,114,97,118,105,116,121,84,121,112,101,115,46,78,111,71,114,97,118,105,116,121,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,71,114,97,118,105,116,121,84,121,112,101,115,46,80,111,105,110,116,71,114,97,118,105,116,121,32,104,97,115,32,118,97,108,117,101,58,32,0,224,77,2,0,148,4,0,0,3,0,0,0,149,4,0,0,155,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,86,105,115,117,97,108,105,122,101,114,115,46,109,111,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+143360);
/* memory initializer */ allocate([104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+153600);
/* memory initializer */ allocate([86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+163848);
/* memory initializer */ allocate([99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+174088);
/* memory initializer */ allocate([93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+184328);
/* memory initializer */ allocate([32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,83,104,97,112,101,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,184,83,2,0,28,0,0,0,5,0,0,0,30,0,0,0,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+194568);
/* memory initializer */ allocate([114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,114,111,100,49,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,136,140,0,0,8,20,0,0,7,0,0,0,10,20,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,136,140,0,0,40,20,0,0,7,0,0,0,43,20,0,0,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,106,111,105,110,116,85,83,80,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,136,140,0,0,1,20,0,0,7,0,0,0,3,20,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,136,140,0,0,62,26,0,0,7,0,0,0,64,26,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,106,111,105,110,116,82,82,80,46,114,111,100,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,136,140,0,0,79,26,0,0,7,0,0,0,81,26,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,216,96,0,0,182,1,0,0,5,0,0,0,187,1,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,216,96,0,0,219,2,0,0,5,0,0,0,224,2,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,216,96,0,0,133,4,0,0,5,0,0,0,138,4,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,114,97,110,107,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,114,97,110,107,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,99,114,97,110,107,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+204808);
/* memory initializer */ allocate([53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,216,96,0,0,205,0,0,0,5,0,0,0,210,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,101,110,103,105,110,101,46,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,136,140,0,0,250,0,0,0,5,0,0,0,252,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,51,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,50,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,49,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,224,77,2,0,172,4,0,0,3,0,0,0,174,4,0,0,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,224,77,2,0,203,4,0,0,3,0,0,0,206,4,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,224,77,2,0,194,4,0,0,3,0,0,0,197,4,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,83,104,97,112,101,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,83,104,97,112,101,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,83,104,97,112,101,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,83,104,97,112,101,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,83,104,97,112,101,46,108,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,83,104,97,112,101,46,108,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,83,104,97,112,101,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,83,104,97,112,101,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,83,104,97,112,101,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,83,104,97,112,101,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,83,104,97,112,101,46,108,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,83,104,97,112,101,46,108,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,83,104,97,112,101,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,83,104,97,112,101,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,83,104,97,112,101,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,83,104,97,112,101,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,83,104,97,112,101,46,108,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,83,104,97,112,101,46,108,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,83,104,97,112,101,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,83,104,97,112,101,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,83,104,97,112,101,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,83,104,97,112,101,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,83,104,97,112,101,46,108,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,83,104,97,112,101,46,108,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,83,104,97,112,101,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,83,104,97,112,101,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,83,104,97,112,101,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,83,104,97,112,101,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,83,104,97,112,101,46,108,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,83,104,97,112,101,46,108,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,83,104,97,112,101,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,83,104,97,112,101,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,184,83,2,0,26,0,0,0,5,0,0,0,27,0,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,83,104,97,112,101,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,83,104,97,112,101,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,184,83,2,0,24,0,0,0,5,0,0,0,25,0,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,83,104,97,112,101,46,108,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,83,104,97,112,101,46,108,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,184,83,2,0,22,0,0,0,5,0,0,0,23,0,0,0,73,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,3,0,0,0,3,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,69,120,97,109,112,108,101,115,47,76,111,111,112,115,47,85,116,105,108,105,116,105,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,216,90,3,0,29,1,0,0,5,0,0,0,29,1,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,110,103,105,110,101,46,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,216,90,3,0,33,1,0,0,5,0,0,0,33,1,0,0,21,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,99,104,97,110,105,99,115,95,77,117,108,116,105,66,111,100,121,95,69,120,97,109,112,108,101,115,95,76,111,111,112,115,95,69,110,103,105,110,101,86,54,95,95,97,110,97,108,121,116,105,99,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,52,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,51,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,52,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,52,44,52,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,52,44,48,93,32,61,32,122,101,114,111,115,40,52,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,51,44,52,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,51,44,48,93,32,61,32,122,101,114,111,115,40,51,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,52,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,51,93,59,10,10,32,32,82,101,97,108,32,120,95,80,102,105,108,116,101,114,80,120,108,66,49,114,66,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,102,105,108,116,101,114,80,120,108,66,50,114,66,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,108,111,97,100,80,119,32,61,32,120,91,51,93,59,10,32,32,82,101,97,108,32,120,95,80,108,111,97,100,80,112,104,105,32,61,32,120,91,52,93,59,10,32,32,32,32,32,32,82,101,97,108,32,121,95,80,102,105,108,116,101,114,101,100,69,110,103,105,110,101,84,111,114,113,117,101,32,61,32,121,91,49,93,59,10,32,32,82,101,97,108,32,121,95,80,101,110,103,105,110,101,84,111,114,113,117,101,32,61,32,121,91,50,93,59,10,32,32,82,101,97,108,32,121,95,80,101,110,103,105,110,101,83,112,101,101,100,95,114,112,109,32,61,32,121,91,51,93,59,10,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,99,104,97,110,105,99,115,95,77,117,108,116,105,66,111,100,121,95,69,120,97,109,112,108,101,115,95,76,111,111,112,115,95,69,110,103,105,110,101,86,54,95,95,97,110,97,108,121,116,105,99,59,10,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,103,3,0,64,103,3,0,80,103,3,0,104,103,3,0,136,103,3,0,152,103,3,0,176,103,3,0,192,103,3,0,216,103,3,0,248,103,3,0,32,104,3,0,56,104,3,0,88,104,3,0,112,104,3,0,152,104,3,0,184,104,3,0,232,104,3,0,24,105,3,0,48,105,3,0,104,105,3,0,128,105,3,0,176,105,3,0,208,105,3,0,8,106,3,0,48,106,3,0,104,106,3,0,152,106,3,0,168,106,3,0,200,106,3,0,240,106,3,0,16,107,3,0,56,107,3,0,96,107,3,0,120,107,3,0,144,107,3,0,160,107,3,0,184,107,3,0,232,107,3,0,56,108,3,0,120,108,3,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+215048);
/* memory initializer */ allocate([0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,168,122,3,0,56,121,3,0,192,119,3,0,72,118,3,0,72,118,3,0,208,116,3,0,192,119,3,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,112,133,3,0,248,129,3,0,136,128,3,0,24,127,3,0,24,127,3,0,168,125,3,0,136,128,3,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,184,131,3,0,200,131,3,0,216,131,3,0,168,116,3,0,224,131,3,0,240,131,3,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,80,135,3,0,88,135,3,0,96,135,3,0,104,135,3,0,224,134,3,0,112,135,3,0,128,135,3,0,136,135,3,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,117,116,105,108,47,98,97,115,101,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,97,45,62,110,100,105,109,115,32,33,61,32,98,45,62,110,100,105,109,115,44,32,37,100,32,33,61,32,37,100,10,0,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,33,61,32,98,45,62,100,105,109,95,115,105,122,101,91,37,100,93,44,32,37,100,32,33,61,32,37,100,10,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,99,108,111,110,101,95,98,97,115,101,95,97,114,114,97,121,95,115,112,101,99,0,0,0,100,101,115,116,45,62,100,105,109,95,115,105,122,101,0,0,0,0,0,0,0,0,0,0,80,137,3,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,176,137,3,0,192,137,3,0,200,137,3,0,208,137,3,0,224,137,3,0,240,137,3,0,248,137,3,0,8,138,3,0,24,138,3,0,40,138,3,0,56,138,3,0,72,138,3,0,88,138,3,0,104,138,3,0,120,138,3,0,128,138,3,0,136,138,3,0,152,138,3,0,160,138,3,0,176,138,3,0,192,138,3,0,208,138,3,0,224,138,3,0,240,138,3,0,0,139,3,0,16,139,3,0,32,139,3,0,48,139,3,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,184,139,3,0,192,139,3,0,192,139,3,0,224,139,3,0,16,140,3,0,48,140,3,0,104,140,3,0,152,140,3,0,200,140,3,0,232,140,3,0,24,141,3,0,48,141,3,0,80,141,3,0,120,141,3,0,152,141,3,0,200,141,3,0,232,141,3,0,16,142,3,0,48,142,3,0,88,142,3,0,136,142,3,0,192,142,3,0,232,142,3,0,24,143,3,0,72,143,3,0,112,143,3,0,160,143,3,0,168,143,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,184,139,3,0,168,146,3,0,176,146,3,0,184,146,3,0,200,137,3,0,192,146,3,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,24,148,3,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,48,148,3,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,72,148,3,0,80,148,3,0,88,148,3,0,104,148,3,0,120,148,3,0,128,148,3,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+225288);
/* memory initializer */ allocate([100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,100,101,115,116,41,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,115,104,97,112,101,95,101,113,40,115,111,117,114,99,101,44,32,100,101,115,116,41,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,95,109,101,109,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,0,160,3,0,0,0,0,0,120,159,3,0,0,0,0,0,240,158,3,0,0,0,0,0,104,158,3,0,0,0,0,0,96,157,3,0,0,0,0,0,88,156,3,0,0,0,0,0,80,155,3,0,0,0,0,0,72,154,3,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+235528);
/* memory initializer */ allocate([70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,136,160,3,0,152,160,3,0,160,160,3,0,168,160,3,0,184,160,3,0,192,160,3,0,200,160,3,0,208,160,3,0,216,160,3,0,224,160,3,0,232,160,3,0,248,160,3,0,0,161,3,0,16,161,3,0,32,161,3,0,48,161,3,0,56,161,3,0,72,161,3,0,80,161,3,0,96,161,3,0,104,161,3,0,128,161,3,0,136,161,3,0,144,161,3,0,160,161,3,0,168,161,3,0,184,161,3,0,200,161,3,0,208,161,3,0,216,161,3,0,224,161,3,0,232,161,3,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,120,162,3,0,128,162,3,0,200,162,3,0,248,162,3,0,40,163,3,0,112,163,3,0,176,163,3,0,248,163,3,0,40,164,3,0,112,164,3,0,136,164,3,0,168,164,3,0,224,164,3,0,8,165,3,0,48,165,3,0,104,165,3,0,184,165,3,0,24,166,3,0,72,166,3,0,128,166,3,0,176,166,3,0,248,166,3,0,32,167,3,0,80,167,3,0,128,167,3,0,216,167,3,0,32,168,3,0,144,168,3,0,192,168,3,0,8,169,3,0,40,169,3,0,232,161,3,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,120,162,3,0,232,169,3,0,144,170,3,0,248,162,3,0,40,163,3,0,248,170,3,0,176,163,3,0,248,163,3,0,128,171,3,0,192,171,3,0,136,164,3,0,168,164,3,0,96,172,3,0,160,172,3,0,224,172,3,0,104,165,3,0,184,165,3,0,32,173,3,0,88,173,3,0,224,173,3,0,8,174,3,0,248,166,3,0,32,167,3,0,80,167,3,0,112,174,3,0,248,174,3,0,248,175,3,0,144,168,3,0,192,168,3,0,8,169,3,0,40,169,3,0,232,161,3,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,181,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,181,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,181,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,181,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,181,3,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+237696);
/* memory initializer */ allocate([47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,144,199,3,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+247936);
/* memory initializer */ allocate([216,203,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,204,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,204,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,204,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,204,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,204,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,204,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,204,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,204,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,204,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,205,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,205,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,204,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,205,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,205,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,205,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,205,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,205,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,204,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,206,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,206,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,206,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,206,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,207,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,207,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,208,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,208,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,209,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,209,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,209,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,209,3,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,168,244,3,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,136,245,3,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,216,245,3,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,48,246,3,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,136,246,3,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,144,246,3,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,216,246,3,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,40,247,3,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,216,246,3,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,80,3,4,0,112,4,4,0,120,4,4,0,136,4,4,0,152,4,4,0,168,4,4,0,192,4,4,0,216,4,4,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,80,3,4,0,88,3,4,0,160,3,4,0,200,3,4,0,232,3,4,0,8,4,4,0,48,4,4,0,88,4,4,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,65,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,0,0,0,0,0,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,37,115,0,0,0,0,0,0,98,32,118,101,99,116,111,114,32,91,37,100,93,0,0,0,69,114,114,111,114,32,115,111,108,118,105,110,103,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,46,32,65,114,103,117,109,101,110,116,32,37,100,32,105,108,108,101,103,97,108,46,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,115,111,108,118,101,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,44,32,115,121,115,116,101,109,32,105,115,32,115,105,110,103,117,108,97,114,32,102,111,114,32,85,91,37,100,44,32,37,100,93,46,0,0,0,0,0,0,0,37,115,37,49,48,103,32,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,192,12,4,0,208,12,4,0,216,12,4,0,224,12,4,0,232,12,4,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,8,13,4,0,16,13,4,0,32,13,4,0,48,13,4,0,232,12,4,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111,114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+258316);
/* memory initializer */ allocate([37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,120,30,4,0,64,32,4,0,72,32,4,0,80,32,4,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,120,30,4,0,128,31,4,0,208,31,4,0,0,32,4,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,120,30,4,0,64,31,4,0,72,31,4,0,80,31,4,0,96,31,4,0,104,31,4,0,120,31,4,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,120,30,4,0,128,30,4,0,152,30,4,0,168,30,4,0,240,30,4,0,0,31,4,0,32,31,4,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,40,42,4,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,40,42,4,0,10,0,0,0,11,0,0,0,204,41,4,0,68,42,4,0,88,42,4,0,224,41,4,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,248,227,4,0,248,41,4,0,128,159,4,0,0,0,0,0,104,0,0,0,0,0,0,0,128,159,4,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,128,159,4,0,14,0,0,0,15,0,0,0,0,0,0,0,208,42,4,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,248,227,4,0,160,42,4,0,120,158,4,0,0,0,0,0,0,0,0,0,88,43,4,0,96,43,4,0,80,43,4,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,48,43,4,0,64,43,4,0,80,43,4,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108,32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114,32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,176,59,4,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,176,59,4,0,20,0,0,0,21,0,0,0,84,59,4,0,204,59,4,0,224,59,4,0,104,59,4,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,248,227,4,0,128,59,4,0,240,158,4,0,0,0,0,0,108,0,0,0,0,0,0,0,240,158,4,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,240,158,4,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+268556);
/* memory initializer */ allocate([99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,168,69,4,0,144,71,4,0,152,71,4,0,224,73,4,0,248,71,4,0,8,72,4,0,232,73,4,0,240,73,4,0,248,73,4,0,0,74,4,0,16,74,4,0,32,74,4,0,48,74,4,0,64,74,4,0,80,74,4,0,96,74,4,0,112,74,4,0,136,74,4,0,192,73,4,0,216,73,4,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,168,69,4,0,144,71,4,0,152,71,4,0,168,71,4,0,248,71,4,0,8,72,4,0,24,72,4,0,56,72,4,0,88,72,4,0,120,72,4,0,160,72,4,0,200,72,4,0,240,72,4,0,24,73,4,0,48,73,4,0,80,73,4,0,112,73,4,0,152,73,4,0,192,73,4,0,216,73,4,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,168,69,4,0,112,71,4,0,120,71,4,0,128,71,4,0,168,69,4,0,176,70,4,0,0,71,4,0,48,71,4,0,168,69,4,0,112,70,4,0,120,70,4,0,128,70,4,0,144,70,4,0,152,70,4,0,168,70,4,0,0,0,0,0,168,69,4,0,176,69,4,0,200,69,4,0,216,69,4,0,32,70,4,0,48,70,4,0,80,70,4,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,200,76,4,0,26,0,0,0,27,0,0,0,200,255,255,255,200,255,255,255,200,76,4,0,28,0,0,0,29,0,0,0,84,76,4,0,228,76,4,0,248,76,4,0,104,76,4,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,248,227,4,0,128,76,4,0,128,159,4,0,0,0,0,0,56,0,0,0,0,0,0,0,128,159,4,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,128,159,4,0,14,0,0,0,15,0,0,0,0,0,0,0,136,77,4,0,30,0,0,0,31,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,248,227,4,0,64,77,4,0,120,158,4,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,24,98,4,0,24,98,4,0,24,98,4,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,192,100,4,0,208,100,4,0,232,100,4,0,8,101,4,0,40,101,4,0,64,101,4,0,96,101,4,0,120,101,4,0,136,101,4,0,152,101,4,0,176,101,4,0,200,101,4,0,232,101,4,0,8,102,4,0,152,101,4,0,32,102,4,0,64,102,4,0,88,102,4,0,112,102,4,0,136,102,4,0,168,102,4,0,184,102,4,0,216,102,4,0,248,102,4,0,16,103,4,0,40,103,4,0,64,103,4,0,80,103,4,0,104,103,4,0,128,103,4,0,152,103,4,0,184,103,4,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+278796);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+293736);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,192,144,4,0,200,144,4,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,216,144,4,0,224,144,4,0,232,144,4,0,240,144,4,0,144,1,0,0,0,0,0,0,96,145,4,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+298960);
/* memory initializer */ allocate([56,152,4,0,32,0,0,0,33,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,248,227,4,0,24,152,4,0,184,158,4,0,0,0,0,0,0,0,0,0,160,152,4,0,34,0,0,0,35,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,248,227,4,0,136,152,4,0,184,158,4,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,56,153,4,0,36,0,0,0,37,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,248,227,4,0,24,153,4,0,120,158,4,0,0,0,0,0,0,0,0,0,160,153,4,0,38,0,0,0,39,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,248,227,4,0,136,153,4,0,120,158,4,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,208,227,4,0,176,153,4,0,0,0,0,0,24,154,4,0,40,0,0,0,41,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,192,154,4,0,42,0,0,0,43,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,248,227,4,0,8,154,4,0,0,0,0,0,0,0,0,0,0,0,0,0,88,154,4,0,40,0,0,0,44,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,248,227,4,0,64,154,4,0,24,154,4,0,0,0,0,0,0,0,0,0,152,154,4,0,40,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,248,227,4,0,128,154,4,0,24,154,4,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,248,227,4,0,168,154,4,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,8,155,4,0,46,0,0,0,47,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,248,227,4,0,240,154,4,0,192,154,4,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,208,227,4,0,24,155,4,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,248,227,4,0,64,155,4,0,56,155,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,240,157,4,0,48,0,0,0,49,0,0,0,0,0,0,0,120,158,4,0,50,0,0,0,51,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,184,158,4,0,52,0,0,0,53,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,240,158,4,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,240,158,4,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,56,159,4,0,54,0,0,0,55,0,0,0,248,255,255,255,248,255,255,255,56,159,4,0,56,0,0,0,57,0,0,0,4,0,0,0,0,0,0,0,128,159,4,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,128,159,4,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,200,159,4,0,58,0,0,0,59,0,0,0,252,255,255,255,252,255,255,255,200,159,4,0,60,0,0,0,61,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,157,4,0,62,0,0,0,63,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,184,157,4,0,64,0,0,0,65,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,248,227,4,0,112,157,4,0,8,155,4,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,208,227,4,0,160,157,4,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,248,227,4,0,192,157,4,0,184,157,4,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,248,227,4,0,0,158,4,0,184,157,4,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,208,227,4,0,64,158,4,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,208,227,4,0,128,158,4,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,88,228,4,0,192,158,4,0,0,0,0,0,1,0,0,0,240,157,4,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,88,228,4,0,8,159,4,0,0,0,0,0,1,0,0,0,48,158,4,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,88,228,4,0,80,159,4,0,0,0,0,0,1,0,0,0,240,157,4,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,88,228,4,0,152,159,4,0,0,0,0,0,1,0,0,0,48,158,4,0,3,244,255,255,0,0,0,0,40,160,4,0,66,0,0,0,67,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,248,227,4,0,8,160,4,0,88,155,4,0,0,0,0,0,0,0,0,0,80,174,4,0,68,0,0,0,69,0,0,0,70,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,174,4,0,71,0,0,0,72,0,0,0,70,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,179,4,0,73,0,0,0,74,0,0,0,70,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,192,179,4,0,75,0,0,0,76,0,0,0,70,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,180,4,0,77,0,0,0,78,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,181,4,0,79,0,0,0,80,0,0,0,70,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,64,176,4,0,81,0,0,0,82,0,0,0,70,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,64,176,4,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,224,176,4,0,83,0,0,0,84,0,0,0,70,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,224,176,4,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,112,177,4,0,85,0,0,0,86,0,0,0,70,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,177,4,0,87,0,0,0,88,0,0,0,70,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,174,4,0,89,0,0,0,90,0,0,0,70,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,175,4,0,91,0,0,0,92,0,0,0,70,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,175,4,0,93,0,0,0,94,0,0,0,70,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,175,4,0,95,0,0,0,96,0,0,0,70,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,181,4,0,97,0,0,0,98,0,0,0,70,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,56,182,4,0,99,0,0,0,100,0,0,0,70,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,200,182,4,0,101,0,0,0,102,0,0,0,70,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,88,183,4,0,103,0,0,0,104,0,0,0,70,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,178,4,0,105,0,0,0,106,0,0,0,70,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,178,4,0,107,0,0,0,108,0,0,0,70,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,40,174,4,0,109,0,0,0,110,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,171,4,0,111,0,0,0,112,0,0,0,70,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,171,4,0,113,0,0,0,114,0,0,0,70,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,173,4,0,115,0,0,0,116,0,0,0,70,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,0,174,4,0,117,0,0,0,118,0,0,0,70,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,56,170,4,0,119,0,0,0,120,0,0,0,70,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,248,227,4,0,32,170,4,0,208,153,4,0,0,0,0,0,0,0,0,0,200,170,4,0,119,0,0,0,121,0,0,0,70,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,208,227,4,0,168,170,4,0,88,228,4,0,144,170,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,192,170,4,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,88,228,4,0,232,170,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,192,170,4,0,2,0,0,0,0,0,0,0,152,171,4,0,119,0,0,0,122,0,0,0,70,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,208,227,4,0,120,171,4,0,88,228,4,0,80,171,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,144,171,4,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,88,228,4,0,184,171,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,144,171,4,0,2,0,0,0,0,0,0,0,88,172,4,0,119,0,0,0,123,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,88,228,4,0,48,172,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,144,171,4,0,2,0,0,0,0,0,0,0,208,172,4,0,119,0,0,0,124,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,88,228,4,0,168,172,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,144,171,4,0,2,0,0,0,0,0,0,0,72,173,4,0,119,0,0,0,125,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,248,227,4,0,32,173,4,0,208,172,4,0,0,0,0,0,0,0,0,0,176,173,4,0,119,0,0,0,126,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,248,227,4,0,136,173,4,0,208,172,4,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,248,227,4,0,192,173,4,0,56,170,4,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,248,227,4,0,232,173,4,0,56,170,4,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,248,227,4,0,16,174,4,0,56,170,4,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,248,227,4,0,56,174,4,0,56,170,4,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,248,227,4,0,96,174,4,0,56,170,4,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,208,227,4,0,168,174,4,0,88,228,4,0,136,174,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,192,174,4,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,88,228,4,0,232,174,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,192,174,4,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,88,228,4,0,40,175,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,192,174,4,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,88,228,4,0,104,175,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,192,174,4,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,208,227,4,0,240,175,4,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,208,227,4,0,16,176,4,0,88,228,4,0,168,175,4,0,0,0,0,0,3,0,0,0,56,170,4,0,2,0,0,0,8,176,4,0,2,0,0,0,56,176,4,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,208,227,4,0,176,176,4,0,88,228,4,0,104,176,4,0,0,0,0,0,3,0,0,0,56,170,4,0,2,0,0,0,8,176,4,0,2,0,0,0,216,176,4,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,208,227,4,0,80,177,4,0,88,228,4,0,8,177,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,104,177,4,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,88,228,4,0,144,177,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,104,177,4,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,208,227,4,0,16,178,4,0,88,228,4,0,248,177,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,40,178,4,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,88,228,4,0,80,178,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,40,178,4,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,208,227,4,0,232,178,4,0,88,228,4,0,208,178,4,0,0,0,0,0,1,0,0,0,8,179,4,0,0,0,0,0,88,228,4,0,136,178,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,16,179,4,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,88,228,4,0,144,179,4,0,0,0,0,0,1,0,0,0,8,179,4,0,0,0,0,0,88,228,4,0,72,179,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,168,179,4,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,208,227,4,0,64,180,4,0,88,228,4,0,40,180,4,0,0,0,0,0,1,0,0,0,96,180,4,0,0,0,0,0,88,228,4,0,224,179,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,104,180,4,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,88,228,4,0,232,180,4,0,0,0,0,0,1,0,0,0,96,180,4,0,0,0,0,0,88,228,4,0,160,180,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,0,181,4,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,208,227,4,0,128,181,4,0,88,228,4,0,56,181,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,160,181,4,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,208,227,4,0,16,182,4,0,88,228,4,0,200,181,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,48,182,4,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,208,227,4,0,160,182,4,0,88,228,4,0,88,182,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,192,182,4,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,208,227,4,0,48,183,4,0,88,228,4,0,232,182,4,0,0,0,0,0,2,0,0,0,56,170,4,0,2,0,0,0,80,183,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+301012);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,64,225,4,0,110,0,0,0,72,225,4,0,114,0,0,0,80,225,4,0,102,0,0,0,88,225,4,0,97,0,0,0,96,225,4,0,101,0,0,0,104,225,4,0,119,0,0,0,112,225,4,0,87,0,0,0,128,225,4,0,115,0,0,0,144,225,4,0,83,0,0,0,160,225,4,0,100,0,0,0,176,225,4,0,68,0,0,0,192,225,4,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,72,227,4,0,127,0,0,0,128,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,208,227,4,0,32,227,4,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,248,227,4,0,56,227,4,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,248,227,4,0,88,227,4,0,48,227,4,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,248,227,4,0,144,227,4,0,128,227,4,0,0,0,0,0,0,0,0,0,184,227,4,0,129,0,0,0,130,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,64,228,4,0,129,0,0,0,133,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,248,227,4,0,24,228,4,0,184,227,4,0,0,0,0,0,0,0,0,0,160,228,4,0,129,0,0,0,134,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,248,227,4,0,120,228,4,0,184,227,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,230,4,0,135,0,0,0,136,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,248,227,4,0,208,230,4,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+311352);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  function _lis_matrix_assemble() {
  Module['printErr']('missing function: lis_matrix_assemble'); abort(-1);
  }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }

  function _lis_matrix_set_type() {
  Module['printErr']('missing function: lis_matrix_set_type'); abort(-1);
  }


  var _cos=Math_cos;

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  function _fmin(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.min(x, y);
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }

  function _lis_vector_get_values() {
  Module['printErr']('missing function: lis_vector_get_values'); abort(-1);
  }


  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  function _lis_vector_set_value() {
  Module['printErr']('missing function: lis_vector_set_value'); abort(-1);
  }


  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


  function _lis_solve() {
  Module['printErr']('missing function: lis_solve'); abort(-1);
  }

   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  function _lis_matrix_create() {
  Module['printErr']('missing function: lis_matrix_create'); abort(-1);
  }

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _putc=_fputc;

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  var _fseeko=_fseek;

  function _lis_matrix_set_size() {
  Module['printErr']('missing function: lis_matrix_set_size'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_matrix_destroy() {
  Module['printErr']('missing function: lis_matrix_destroy'); abort(-1);
  }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  var _emscripten_setjmp=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiiiiiiiiiiiiiiiiiiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_viiiiii;var Ba=env.invoke_viidii;var Ca=env.invoke_iid;var Da=env.invoke_viiiiiii;var Ea=env.invoke_viiiiiid;var Fa=env.invoke_viiiiiiiii;var Ga=env.invoke_iii;var Ha=env.invoke_iiiiii;var Ia=env.invoke_iiiiidi;var Ja=env.invoke_dii;var Ka=env.invoke_i;var La=env.invoke_iiiiiiiiii;var Ma=env.invoke_viii;var Na=env.invoke_v;var Oa=env.invoke_iiiiiiiii;var Pa=env.invoke_iiiii;var Qa=env.invoke_viiii;var Ra=env._fabs;var Sa=env._lis_matrix_assemble;var Ta=env._strrchr;var Ua=env._pthread_key_create;var Va=env._vsscanf;var Wa=env.__ZSt9terminatev;var Xa=env.___cxa_guard_acquire;var Ya=env.__reallyNegative;var Za=env._fstat;var _a=env._pclose;var $a=env._lis_solver_create;var ab=env.___assert_fail;var bb=env.__ZSt18uncaught_exceptionv;var cb=env._longjmp;var db=env.__isLeapYear;var eb=env._clock_gettime;var fb=env._fsync;var gb=env._signal;var hb=env._GC_collect_a_little;var ib=env._sbrk;var jb=env._strtoull;var kb=env._emscripten_memcpy_big;var lb=env.__parseInt64;var mb=env._close;var nb=env._rewind;var ob=env._cos;var pb=env._fileno;var qb=env._fread;var rb=env._puts;var sb=env._isatty;var tb=env._lis_matrix_set_value;var ub=env._write;var vb=env._isblank;var wb=env._ftell;var xb=env.__ZNSt9exceptionD2Ev;var yb=env._xerbla_;var zb=env._round;var Ab=env.___cxa_does_inherit;var Bb=env._strtoll_l;var Cb=env._strstr;var Db=env.___cxa_rethrow;var Eb=env._llvm_lifetime_end;var Fb=env._catclose;var Gb=env._tmpnam;var Hb=env._lis_vector_get_values;var Ib=env._lis_vector_destroy;var Jb=env._lis_solver_set_option;var Kb=env._tmpfile;var Lb=env._send;var Mb=env._pow;var Nb=env._lis_matrix_set_size;var Ob=env.___cxa_free_exception;var Pb=env.___cxa_find_matching_catch;var Qb=env._isxdigit_l;var Rb=env.___cxa_guard_release;var Sb=env._truncate;var Tb=env._strtol;var Ub=env._sin;var Vb=env._strtok;var Wb=env.___setErrNo;var Xb=env._newlocale;var Yb=env._isdigit_l;var Zb=env.___resumeException;var _b=env._freelocale;var $b=env._srand;var ac=env._qsort;var bc=env._putchar;var cc=env._floor;var dc=env._pthread_mutex_unlock;var ec=env._printf;var fc=env._sprintf;var gc=env._fopen;var hc=env._vasprintf;var ic=env._emscripten_get_now;var jc=env._stat;var kc=env._lis_solve;var lc=env._strtoull_l;var mc=env._mkport;var nc=env._read;var oc=env.__addDays;var pc=env._fwrite;var qc=env._time;var rc=env._pthread_mutex_lock;var sc=env._catopen;var tc=env._exit;var uc=env._GC_strdup;var vc=env._freopen;var wc=env.___ctype_b_loc;var xc=env._fmod;var yc=env._strtok_r;var zc=env._lseek;var Ac=env._access;var Bc=env._vfprintf;var Cc=env.___cxa_allocate_exception;var Dc=env._atoi;var Ec=env._strtoll;var Fc=env._pwrite;var Gc=env._localtime_r;var Hc=env._tzset;var Ic=env._open;var Jc=env._uselocale;var Kc=env._snprintf;var Lc=env.___errno_location;var Mc=env._GC_malloc;var Nc=env.___cxa_end_catch;var Oc=env._perror;var Pc=env.___cxa_begin_catch;var Qc=env._strftime;var Rc=env._ftruncate;var Sc=env._GC_init;var Tc=env._lis_matrix_set_type;var Uc=env._fseek;var Vc=env._isxdigit;var Wc=env._fclose;var Xc=env._vsnprintf;var Yc=env.__parseInt;var Zc=env._log;var _c=env._pthread_cond_broadcast;var $c=env._popen;var ad=env._recv;var bd=env._fgetc;var cd=env._sysconf;var dd=env.__getFloat;var ed=env._lis_vector_set_value;var fd=env._abort;var gd=env._ceil;var hd=env._isspace;var id=env._localtime;var jd=env._lis_matrix_destroy;var kd=env._pthread_getspecific;var ld=env._pthread_cond_wait;var md=env._llvm_lifetime_start;var nd=env.___cxa_is_number_type;var od=env._ungetc;var pd=env._system;var qd=env._fmin;var rd=env._fmax;var sd=env._fflush;var td=env._strftime_l;var ud=env._fprintf;var vd=env._sscanf;var wd=env._catgets;var xd=env._lis_solver_destroy;var yd=env._strdup;var zd=env._asprintf;var Ad=env.__exit;var Bd=env.___ctype_toupper_loc;var Cd=env._bsearch;var Dd=env.__arraySum;var Ed=env.__formatString;var Fd=env._htonl;var Gd=env.___ctype_tolower_loc;var Hd=env._unlink;var Id=env._fputs;var Jd=env._GC_malloc_atomic;var Kd=env._pread;var Ld=env._lis_vector_set_size;var Md=env._fscanf;var Nd=env.__scanString;var Od=env._pthread_setspecific;var Pd=env._copysign;var Qd=env._fputc;var Rd=env.___cxa_throw;var Sd=env._lis_matrix_create;var Td=env._isdigit;var Ud=env._strerror;var Vd=env._emscripten_longjmp;var Wd=env._lis_vector_create;var Xd=env._atexit;var Yd=env._sqrt;var Zd=env._strerror_r;var _d=0.0;
// EMSCRIPTEN_START_FUNCS
function hv(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,W=0.0,X=0,Y=0,Z=0,_=0.0;e=i;pe[c[(d+8|0)>>2]&3](0,14,-(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7960>>3]*+h[(c[(b+416|0)>>2]|0)+25192>>3]),0,d);f=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](0,262,+h[f+17864>>3]*+h[f+25192>>3],1,d);f=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](0,264,-(+h[f+17848>>3]*+h[f+25192>>3]),2,d);pe[c[(d+8|0)>>2]&3](0,295,-(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7952>>3]*+h[(c[(b+416|0)>>2]|0)+25192>>3]),3,d);pe[c[(d+8|0)>>2]&3](0,381,-1.0,4,d);pe[c[(d+8|0)>>2]&3](1,264,-.006,5,d);pe[c[(d+8|0)>>2]&3](1,285,-+h[(c[(b+416|0)>>2]|0)+17856>>3],6,d);pe[c[(d+8|0)>>2]&3](1,380,-1.0,7,d);pe[c[(d+8|0)>>2]&3](1,381,+h[(c[(b+416|0)>>2]|0)+17848>>3],8,d);pe[c[(d+8|0)>>2]&3](2,266,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+240>>3],9,d);pe[c[(d+8|0)>>2]&3](2,274,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+320>>3],10,d);pe[c[(d+8|0)>>2]&3](2,379,1.0,11,d);pe[c[(d+8|0)>>2]&3](2,380,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+15504>>3],12,d);f=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+240>>3];m=+h[(c[(b+416|0)>>2]|0)+24976>>3];n=+h[k+15512>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+$Lb(c[b+536>>2]|0,m,8464,8456,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](3,268,-(l*o),13,d);f=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;k=c[j+8>>2]|0;o=+h[(c[(b+416|0)>>2]|0)+24976>>3]*+h[k+7920>>3];l=+h[k+15504>>3];do{if(o!=0.0){p=l/o}else{if(l==0.0){p=l;break}p=l/+$Lb(c[b+536>>2]|0,o,8520,8456,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](3,273,p,14,d);pe[c[(d+8|0)>>2]&3](3,378,1.0,15,d);f=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;k=c[j+8>>2]|0;p=+h[k+240>>3];o=+h[(c[(b+416|0)>>2]|0)+24976>>3];l=+h[k+15504>>3];do{if(o!=0.0){q=l/o}else{if(l==0.0){q=l;break}q=l/+$Lb(c[b+536>>2]|0,o,8464,8456,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](3,379,-(p*q),16,d);pe[c[(d+8|0)>>2]&3](4,269,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+320>>3],17,d);pe[c[(d+8|0)>>2]&3](4,377,1.0,18,d);pe[c[(d+8|0)>>2]&3](4,378,-1.0,19,d);pe[c[(d+8|0)>>2]&3](5,284,-1.0,20,d);pe[c[(d+8|0)>>2]&3](5,376,-1.0,21,d);pe[c[(d+8|0)>>2]&3](5,377,-1.0,22,d);pe[c[(d+8|0)>>2]&3](6,282,.4999999999999999,23,d);pe[c[(d+8|0)>>2]&3](6,375,1.0,24,d);pe[c[(d+8|0)>>2]&3](6,376,.8660254037844387,25,d);pe[c[(d+8|0)>>2]&3](7,223,1.0,26,d);pe[c[(d+8|0)>>2]&3](7,374,1.0,27,d);pe[c[(d+8|0)>>2]&3](7,375,-1.0,28,d);pe[c[(d+8|0)>>2]&3](8,277,-1.0,29,d);pe[c[(d+8|0)>>2]&3](8,280,-+h[(c[(b+416|0)>>2]|0)+9880>>3],30,d);pe[c[(d+8|0)>>2]&3](8,373,-1.0,31,d);pe[c[(d+8|0)>>2]&3](8,374,+h[(c[(b+416|0)>>2]|0)+9888>>3],32,d);pe[c[(d+8|0)>>2]&3](9,183,1.0,33,d);pe[c[(d+8|0)>>2]&3](9,372,1.0,34,d);pe[c[(d+8|0)>>2]&3](9,373,1.0,35,d);pe[c[(d+8|0)>>2]&3](10,170,+h[(c[(b+416|0)>>2]|0)+6872>>3],36,d);pe[c[(d+8|0)>>2]&3](10,279,-+h[(c[(b+416|0)>>2]|0)+6864>>3],37,d);pe[c[(d+8|0)>>2]&3](10,371,-1.0,38,d);pe[c[(d+8|0)>>2]&3](10,372,-1.0,39,d);pe[c[(d+8|0)>>2]&3](11,354,1.0,40,d);pe[c[(d+8|0)>>2]&3](11,370,1.0,41,d);pe[c[(d+8|0)>>2]&3](11,371,1.0,42,d);pe[c[(d+8|0)>>2]&3](12,346,-+h[(c[(b+416|0)>>2]|0)+3848>>3],43,d);pe[c[(d+8|0)>>2]&3](12,363,+h[(c[(b+416|0)>>2]|0)+3856>>3],44,d);pe[c[(d+8|0)>>2]&3](12,369,-1.0,45,d);pe[c[(d+8|0)>>2]&3](12,370,-1.0,46,d);pe[c[(d+8|0)>>2]&3](13,118,1.0,47,d);pe[c[(d+8|0)>>2]&3](13,368,1.0,48,d);pe[c[(d+8|0)>>2]&3](13,369,1.0,49,d);pe[c[(d+8|0)>>2]&3](14,345,-+h[(c[(b+416|0)>>2]|0)+832>>3],50,d);pe[c[(d+8|0)>>2]&3](14,364,+h[(c[(b+416|0)>>2]|0)+840>>3],51,d);pe[c[(d+8|0)>>2]&3](14,367,-1.0,52,d);pe[c[(d+8|0)>>2]&3](14,368,-1.0,53,d);pe[c[(d+8|0)>>2]&3](15,62,1.0,54,d);pe[c[(d+8|0)>>2]&3](15,366,1.0,55,d);pe[c[(d+8|0)>>2]&3](15,367,1.0,56,d);pe[c[(d+8|0)>>2]&3](16,2,-1.0,57,d);pe[c[(d+8|0)>>2]&3](16,344,-+h[(c[(b+416|0)>>2]|0)+272>>3],58,d);pe[c[(d+8|0)>>2]&3](16,365,+h[(c[(b+416|0)>>2]|0)+280>>3],59,d);pe[c[(d+8|0)>>2]&3](16,366,-1.0,60,d);pe[c[(d+8|0)>>2]&3](17,49,1.0,61,d);pe[c[(d+8|0)>>2]&3](17,364,-1.0,62,d);pe[c[(d+8|0)>>2]&3](17,365,1.0,63,d);pe[c[(d+8|0)>>2]&3](18,106,1.0,64,d);pe[c[(d+8|0)>>2]&3](18,363,-1.0,65,d);pe[c[(d+8|0)>>2]&3](18,364,1.0,66,d);pe[c[(d+8|0)>>2]&3](19,170,-1.0,67,d);pe[c[(d+8|0)>>2]&3](19,362,1.0,68,d);pe[c[(d+8|0)>>2]&3](19,363,1.0,69,d);pe[c[(d+8|0)>>2]&3](20,348,-.5000000000000001,70,d);pe[c[(d+8|0)>>2]&3](20,361,.8660254037844386,71,d);pe[c[(d+8|0)>>2]&3](20,362,1.0,72,d);pe[c[(d+8|0)>>2]&3](21,328,-1.0,73,d);pe[c[(d+8|0)>>2]&3](21,360,-1.0,74,d);pe[c[(d+8|0)>>2]&3](21,361,-1.0,75,d);pe[c[(d+8|0)>>2]&3](22,338,-1.0,76,d);pe[c[(d+8|0)>>2]&3](22,359,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2240>>3],77,d);pe[c[(d+8|0)>>2]&3](22,360,1.0,78,d);pe[c[(d+8|0)>>2]&3](23,339,-1.0,79,d);pe[c[(d+8|0)>>2]&3](23,358,1.0,80,d);pe[c[(d+8|0)>>2]&3](23,359,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7344>>3],81,d);pe[c[(d+8|0)>>2]&3](24,335,-1.0,82,d);pe[c[(d+8|0)>>2]&3](24,357,-1.0,83,d);pe[c[(d+8|0)>>2]&3](24,358,-1.0,84,d);pe[c[(d+8|0)>>2]&3](25,348,-+h[(c[(b+416|0)>>2]|0)+6952>>3],85,d);pe[c[(d+8|0)>>2]&3](25,351,1.0,86,d);pe[c[(d+8|0)>>2]&3](25,356,-1.0,87,d);pe[c[(d+8|0)>>2]&3](25,357,+h[(c[(b+416|0)>>2]|0)+6968>>3],88,d);pe[c[(d+8|0)>>2]&3](26,343,1.0,89,d);pe[c[(d+8|0)>>2]&3](26,347,+h[(c[(b+416|0)>>2]|0)+7440>>3],90,d);pe[c[(d+8|0)>>2]&3](26,354,-1.0,91,d);pe[c[(d+8|0)>>2]&3](26,362,-+h[(c[(b+416|0)>>2]|0)+7448>>3],92,d);pe[c[(d+8|0)>>2]&3](27,347,-+h[(c[(b+416|0)>>2]|0)+7432>>3],93,d);pe[c[(d+8|0)>>2]&3](27,352,.5000000000000001,94,d);pe[c[(d+8|0)>>2]&3](27,353,-1.0,95,d);pe[c[(d+8|0)>>2]&3](27,356,-.8660254037844386,96,d);pe[c[(d+8|0)>>2]&3](27,357,+h[(c[(b+416|0)>>2]|0)+7448>>3],97,d);pe[c[(d+8|0)>>2]&3](28,352,-.8660254037844386,98,d);pe[c[(d+8|0)>>2]&3](28,355,-1.0,99,d);pe[c[(d+8|0)>>2]&3](28,356,-.5000000000000001,100,d);pe[c[(d+8|0)>>2]&3](28,357,-+h[(c[(b+416|0)>>2]|0)+7440>>3],101,d);pe[c[(d+8|0)>>2]&3](28,362,+h[(c[(b+416|0)>>2]|0)+7432>>3],102,d);pe[c[(d+8|0)>>2]&3](29,350,1.0,103,d);pe[c[(d+8|0)>>2]&3](29,352,-1.0,104,d);pe[c[(d+8|0)>>2]&3](29,357,-+h[(c[(b+416|0)>>2]|0)+6960>>3],105,d);pe[c[(d+8|0)>>2]&3](29,361,+h[(c[(b+416|0)>>2]|0)+6952>>3],106,d);pe[c[(d+8|0)>>2]&3](30,324,-1.0,107,d);pe[c[(d+8|0)>>2]&3](30,349,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9896>>3],108,d);pe[c[(d+8|0)>>2]&3](30,351,-1.0,109,d);pe[c[(d+8|0)>>2]&3](30,358,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2120>>3],110,d);pe[c[(d+8|0)>>2]&3](31,340,-1.0,111,d);pe[c[(d+8|0)>>2]&3](31,350,-1.0,112,d);pe[c[(d+8|0)>>2]&3](31,358,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2128>>3],113,d);pe[c[(d+8|0)>>2]&3](31,360,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9896>>3],114,d);pe[c[(d+8|0)>>2]&3](32,341,-1.0,115,d);pe[c[(d+8|0)>>2]&3](32,349,1.0,116,d);pe[c[(d+8|0)>>2]&3](32,359,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2232>>3],117,d);pe[c[(d+8|0)>>2]&3](33,327,-1.0,118,d);pe[c[(d+8|0)>>2]&3](33,348,-1.0,119,d);pe[c[(d+8|0)>>2]&3](33,349,-1.0,120,d);pe[c[(d+8|0)>>2]&3](34,347,1.0,121,d);pe[c[(d+8|0)>>2]&3](34,348,.8660254037844386,122,d);pe[c[(d+8|0)>>2]&3](34,361,.5000000000000001,123,d);pe[c[(d+8|0)>>2]&3](35,279,-1.0,124,d);pe[c[(d+8|0)>>2]&3](35,346,1.0,125,d);pe[c[(d+8|0)>>2]&3](35,347,1.0,126,d);pe[c[(d+8|0)>>2]&3](36,107,1.0,127,d);pe[c[(d+8|0)>>2]&3](36,345,1.0,128,d);pe[c[(d+8|0)>>2]&3](36,346,-1.0,129,d);pe[c[(d+8|0)>>2]&3](37,50,1.0,130,d);pe[c[(d+8|0)>>2]&3](37,344,1.0,131,d);pe[c[(d+8|0)>>2]&3](37,345,-1.0,132,d);pe[c[(d+8|0)>>2]&3](38,342,1.0,133,d);pe[c[(d+8|0)>>2]&3](38,343,-1.0,134,d);pe[c[(d+8|0)>>2]&3](38,348,+h[(c[(b+416|0)>>2]|0)+6960>>3],135,d);pe[c[(d+8|0)>>2]&3](38,361,-+h[(c[(b+416|0)>>2]|0)+6968>>3],136,d);pe[c[(d+8|0)>>2]&3](39,325,-1.0,137,d);pe[c[(d+8|0)>>2]&3](39,342,-1.0,138,d);pe[c[(d+8|0)>>2]&3](39,349,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2128>>3],139,d);pe[c[(d+8|0)>>2]&3](39,360,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2120>>3],140,d);f=ZOb(+U(+(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+20144>>3])),1.0e-10)|0;j=c[(d+8|0)>>2]|0;do{if(f<<24>>24==0){k=c[c[(b+4|0)>>2]>>2]|0;q=+h[(c[k+8>>2]|0)+20144>>3];if(q!=0.0){r=q;break}r=+$Lb(c[b+536>>2]|0,q,8616,8456,+h[k>>3],(a[b+319|0]|0)!=0|0)}else{r=1.0e-10}}while(0);pe[j&3](40,317,1.0/r,141,d);j=ZOb(+U(+(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+20144>>3])),1.0e-10)|0;f=c[(d+8|0)>>2]|0;k=c[c[(b+4|0)>>2]>>2]|0;s=c[k+8>>2]|0;if(j<<24>>24!=0){t=1}else{t=+h[s+20144>>3]!=0.0}r=+h[s+14920>>3]*.8660254037844387+ +h[s+14912>>3]*-.4999999999999999;do{if(t){if(j<<24>>24!=0){u=1.0e-10}else{u=+h[s+20144>>3]}v=r/u}else{if(r==0.0){v=r;break}if(j<<24>>24!=0){w=1.0e-10}else{w=+h[s+20144>>3]}v=r/+$Lb(c[b+536>>2]|0,w,8616,8456,+h[k>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](40,338,v,142,d);f=ZOb(+U(+(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+20144>>3])),1.0e-10)|0;k=c[(d+8|0)>>2]|0;s=c[c[(b+4|0)>>2]>>2]|0;j=c[s+8>>2]|0;if(f<<24>>24!=0){x=1}else{x=+h[j+20144>>3]!=0.0}v=+h[j+14904>>3]*.8660254037844387+ +h[j+14896>>3]*-.4999999999999999;do{if(x){if(f<<24>>24!=0){y=1.0e-10}else{y=+h[j+20144>>3]}z=v/y}else{if(v==0.0){z=v;break}if(f<<24>>24!=0){B=1.0e-10}else{B=+h[j+20144>>3]}z=v/+$Lb(c[b+536>>2]|0,B,8616,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](40,341,z,143,d);pe[c[(d+8|0)>>2]&3](40,359,1.0,144,d);k=c[(d+8|0)>>2]|0;s=c[c[(b+4|0)>>2]>>2]|0;j=c[s+8>>2]|0;z=+h[j+2152>>3];B=+h[(c[(b+416|0)>>2]|0)+21880>>3];v=+h[j+15840>>3];do{if(B!=0.0){C=v/B}else{if(v==0.0){C=v;break}C=v/+$Lb(c[b+536>>2]|0,B,8736,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](41,324,-(z*C),145,d);k=c[(d+8|0)>>2]|0;s=c[c[(b+4|0)>>2]>>2]|0;j=c[s+8>>2]|0;C=+h[(c[(b+416|0)>>2]|0)+21880>>3]*+h[j+7320>>3];z=+h[j+15848>>3];do{if(C!=0.0){D=z/C}else{if(z==0.0){D=z;break}D=z/+$Lb(c[b+536>>2]|0,C,8792,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](41,325,D,146,d);k=c[(d+8|0)>>2]|0;s=c[c[(b+4|0)>>2]>>2]|0;j=c[s+8>>2]|0;D=+h[j+2152>>3];C=+h[(c[(b+416|0)>>2]|0)+21880>>3];z=+h[j+15848>>3];do{if(C!=0.0){E=z/C}else{if(z==0.0){E=z;break}E=z/+$Lb(c[b+536>>2]|0,C,8736,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](41,340,-(D*E),147,d);pe[c[(d+8|0)>>2]&3](41,341,1.0,148,d);k=c[(d+8|0)>>2]|0;s=c[c[(b+4|0)>>2]>>2]|0;j=c[s+8>>2]|0;E=+h[j+7320>>3];D=+h[(c[(b+416|0)>>2]|0)+21880>>3];C=+h[j+15840>>3];do{if(D!=0.0){F=C/D}else{if(C==0.0){F=C;break}F=C/+$Lb(c[b+536>>2]|0,D,8736,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](42,324,-(E*F),149,d);pe[c[(d+8|0)>>2]&3](42,339,1.0,150,d);k=c[(d+8|0)>>2]|0;s=c[c[(b+4|0)>>2]>>2]|0;j=c[s+8>>2]|0;F=+h[j+7320>>3];E=+h[(c[(b+416|0)>>2]|0)+21880>>3];D=+h[j+15848>>3];do{if(E!=0.0){G=D/E}else{if(D==0.0){G=D;break}G=D/+$Lb(c[b+536>>2]|0,E,8736,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](42,340,-(F*G),151,d);k=c[(d+8|0)>>2]|0;s=c[c[(b+4|0)>>2]>>2]|0;j=c[s+8>>2]|0;G=+h[j+2160>>3];F=+h[(c[(b+416|0)>>2]|0)+21880>>3];E=+h[j+15840>>3];do{if(F!=0.0){J=E/F}else{if(E==0.0){J=E;break}J=E/+$Lb(c[b+536>>2]|0,F,8736,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](43,324,-(G*J),152,d);k=c[(d+8|0)>>2]|0;s=c[c[(b+4|0)>>2]>>2]|0;j=c[s+8>>2]|0;J=+h[(c[(b+416|0)>>2]|0)+21880>>3]*+h[j+7320>>3];G=+h[j+15840>>3];do{if(J!=0.0){K=G/J}else{if(G==0.0){K=G;break}K=G/+$Lb(c[b+536>>2]|0,J,8792,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](43,325,K,153,d);pe[c[(d+8|0)>>2]&3](43,338,1.0,154,d);k=c[(d+8|0)>>2]|0;s=c[c[(b+4|0)>>2]>>2]|0;j=c[s+8>>2]|0;K=+h[j+2160>>3];J=+h[(c[(b+416|0)>>2]|0)+21880>>3];G=+h[j+15848>>3];do{if(J!=0.0){L=G/J}else{if(G==0.0){L=G;break}L=G/+$Lb(c[b+536>>2]|0,J,8736,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](43,340,-(K*L),155,d);pe[c[(d+8|0)>>2]&3](44,323,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2232>>3],156,d);pe[c[(d+8|0)>>2]&3](44,326,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2152>>3],157,d);pe[c[(d+8|0)>>2]&3](44,337,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+15848>>3],158,d);pe[c[(d+8|0)>>2]&3](44,340,1.0,159,d);pe[c[(d+8|0)>>2]&3](45,320,+h[(c[(b+416|0)>>2]|0)+8800>>3],160,d);pe[c[(d+8|0)>>2]&3](45,334,-.006,161,d);pe[c[(d+8|0)>>2]&3](45,336,-+h[(c[(b+416|0)>>2]|0)+8808>>3],162,d);pe[c[(d+8|0)>>2]&3](45,337,-1.0,163,d);pe[c[(d+8|0)>>2]&3](46,320,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7344>>3],164,d);pe[c[(d+8|0)>>2]&3](46,335,1.0,165,d);pe[c[(d+8|0)>>2]&3](46,336,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7320>>3],166,d);pe[c[(d+8|0)>>2]&3](47,136,-(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7328>>3]*+h[(c[(b+416|0)>>2]|0)+22096>>3]),167,d);pe[c[(d+8|0)>>2]&3](47,309,-(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7336>>3]*+h[(c[(b+416|0)>>2]|0)+22096>>3]),168,d);k=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](47,330,-(+h[k+8816>>3]*+h[k+22096>>3]),169,d);k=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](47,334,+h[k+8808>>3]*+h[k+22096>>3],170,d);pe[c[(d+8|0)>>2]&3](47,336,-1.0,171,d);pe[c[(d+8|0)>>2]&3](48,333,-1.0,172,d);pe[c[(d+8|0)>>2]&3](48,334,1.0,173,d);pe[c[(d+8|0)>>2]&3](49,313,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2160>>3],174,d);pe[c[(d+8|0)>>2]&3](49,332,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2152>>3],175,d);pe[c[(d+8|0)>>2]&3](49,333,1.0,176,d);k=c[(d+8|0)>>2]|0;s=c[c[(b+4|0)>>2]>>2]|0;j=c[s+8>>2]|0;L=+h[j+20080>>3];K=+h[j+2152>>3];do{if(L!=0.0){M=-K/L}else{if(K==-0.0){M=-K;break}M=-K/+$Lb(c[b+536>>2]|0,L,8888,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](50,313,M,177,d);pe[c[(d+8|0)>>2]&3](50,331,1.0,178,d);k=c[(d+8|0)>>2]|0;s=c[c[(b+4|0)>>2]>>2]|0;j=c[s+8>>2]|0;M=+h[j+20080>>3];L=+h[j+2160>>3];do{if(M!=0.0){N=L/M}else{if(L==0.0){N=L;break}N=L/+$Lb(c[b+536>>2]|0,M,8888,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](50,332,N,179,d);pe[c[(d+8|0)>>2]&3](51,303,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7344>>3],180,d);pe[c[(d+8|0)>>2]&3](51,330,1.0,181,d);pe[c[(d+8|0)>>2]&3](51,331,-1.0,182,d);pe[c[(d+8|0)>>2]&3](52,136,-(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7376>>3]*+h[(c[(b+416|0)>>2]|0)+22096>>3]),183,d);pe[c[(d+8|0)>>2]&3](52,309,-(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7384>>3]*+h[(c[(b+416|0)>>2]|0)+22096>>3]),184,d);k=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](52,321,-(+h[k+8808>>3]*+h[k+22096>>3]),185,d);pe[c[(d+8|0)>>2]&3](52,329,-1.0,186,d);k=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](52,330,+h[k+8800>>3]*+h[k+22096>>3],187,d);pe[c[(d+8|0)>>2]&3](53,320,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2240>>3],188,d);pe[c[(d+8|0)>>2]&3](53,328,1.0,189,d);pe[c[(d+8|0)>>2]&3](53,329,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+15840>>3],190,d);pe[c[(d+8|0)>>2]&3](53,336,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2160>>3],191,d);pe[c[(d+8|0)>>2]&3](54,320,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2232>>3],192,d);pe[c[(d+8|0)>>2]&3](54,327,1.0,193,d);pe[c[(d+8|0)>>2]&3](54,329,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+15848>>3],194,d);pe[c[(d+8|0)>>2]&3](54,336,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2152>>3],195,d);pe[c[(d+8|0)>>2]&3](55,320,-+h[(c[(b+416|0)>>2]|0)+8816>>3],196,d);pe[c[(d+8|0)>>2]&3](55,321,-.006,197,d);pe[c[(d+8|0)>>2]&3](55,326,-1.0,198,d);pe[c[(d+8|0)>>2]&3](55,329,+h[(c[(b+416|0)>>2]|0)+8808>>3],199,d);pe[c[(d+8|0)>>2]&3](56,323,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7344>>3],200,d);pe[c[(d+8|0)>>2]&3](56,325,1.0,201,d);pe[c[(d+8|0)>>2]&3](56,326,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7320>>3],202,d);pe[c[(d+8|0)>>2]&3](57,323,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2240>>3],203,d);pe[c[(d+8|0)>>2]&3](57,324,1.0,204,d);pe[c[(d+8|0)>>2]&3](57,326,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2160>>3],205,d);pe[c[(d+8|0)>>2]&3](57,337,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+15840>>3],206,d);pe[c[(d+8|0)>>2]&3](58,323,-1.0,207,d);pe[c[(d+8|0)>>2]&3](58,329,-+h[(c[(b+416|0)>>2]|0)+8800>>3],208,d);pe[c[(d+8|0)>>2]&3](58,330,-5.0e-4,209,d);pe[c[(d+8|0)>>2]&3](58,336,+h[(c[(b+416|0)>>2]|0)+8816>>3],210,d);pe[c[(d+8|0)>>2]&3](59,313,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+15840>>3],211,d);pe[c[(d+8|0)>>2]&3](59,322,1.0,212,d);pe[c[(d+8|0)>>2]&3](59,332,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+15848>>3],213,d);pe[c[(d+8|0)>>2]&3](60,303,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7320>>3],214,d);pe[c[(d+8|0)>>2]&3](60,321,1.0,215,d);pe[c[(d+8|0)>>2]&3](60,322,-1.0,216,d);pe[c[(d+8|0)>>2]&3](61,136,-(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7352>>3]*+h[(c[(b+416|0)>>2]|0)+22096>>3]),217,d);pe[c[(d+8|0)>>2]&3](61,309,-(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7360>>3]*+h[(c[(b+416|0)>>2]|0)+22096>>3]),218,d);pe[c[(d+8|0)>>2]&3](61,320,-1.0,219,d);k=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](61,321,+h[k+8816>>3]*+h[k+22096>>3],220,d);k=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](61,334,-(+h[k+8800>>3]*+h[k+22096>>3]),221,d);k=c[(d+8|0)>>2]|0;N=+h[(c[(b+416|0)>>2]|0)+21880>>3];s=c[c[(b+4|0)>>2]>>2]|0;M=+h[(c[s+8>>2]|0)+2128>>3];do{if(N!=0.0){O=M/N}else{if(M==0.0){O=M;break}O=M/+$Lb(c[b+536>>2]|0,N,8736,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](62,303,O,222,d);k=c[(d+8|0)>>2]|0;O=+h[(c[(b+416|0)>>2]|0)+21880>>3];s=c[c[(b+4|0)>>2]>>2]|0;N=+h[(c[s+8>>2]|0)+14904>>3];do{if(O!=0.0){P=-N/O}else{if(N==-0.0){P=-N;break}P=-N/+$Lb(c[b+536>>2]|0,O,8736,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](62,314,P,223,d);k=c[(d+8|0)>>2]|0;P=+h[(c[(b+416|0)>>2]|0)+21880>>3];s=c[c[(b+4|0)>>2]>>2]|0;O=+h[(c[s+8>>2]|0)+14896>>3];do{if(P!=0.0){Q=-O/P}else{if(O==-0.0){Q=-O;break}Q=-O/+$Lb(c[b+536>>2]|0,P,8736,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](62,319,Q,224,d);pe[c[(d+8|0)>>2]&3](62,332,1.0,225,d);pe[c[(d+8|0)>>2]&3](63,309,1.0,226,d);pe[c[(d+8|0)>>2]&3](63,318,-1.0,227,d);pe[c[(d+8|0)>>2]&3](63,319,1.0,228,d);pe[c[(d+8|0)>>2]&3](64,315,+h[(c[(b+416|0)>>2]|0)+22296>>3]*-.8660254037844387,229,d);pe[c[(d+8|0)>>2]&3](64,317,1.0,230,d);pe[c[(d+8|0)>>2]&3](64,318,+h[(c[(b+416|0)>>2]|0)+22296>>3]*.4999999999999999,231,d);pe[c[(d+8|0)>>2]&3](65,316,.4999999999999999,232,d);pe[c[(d+8|0)>>2]&3](65,318,1.0,233,d);pe[c[(d+8|0)>>2]&3](66,315,1.0,234,d);pe[c[(d+8|0)>>2]&3](66,316,-.8660254037844387,235,d);pe[c[(d+8|0)>>2]&3](67,136,1.0,236,d);pe[c[(d+8|0)>>2]&3](67,314,1.0,237,d);pe[c[(d+8|0)>>2]&3](67,315,-1.0,238,d);k=c[(d+8|0)>>2]|0;Q=+h[(c[(b+416|0)>>2]|0)+21880>>3];s=c[c[(b+4|0)>>2]>>2]|0;P=+h[(c[s+8>>2]|0)+2120>>3];do{if(Q!=0.0){R=-P/Q}else{if(P==-0.0){R=-P;break}R=-P/+$Lb(c[b+536>>2]|0,Q,8736,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](68,303,R,239,d);pe[c[(d+8|0)>>2]&3](68,313,1.0,240,d);k=c[(d+8|0)>>2]|0;R=+h[(c[(b+416|0)>>2]|0)+21880>>3];s=c[c[(b+4|0)>>2]>>2]|0;Q=+h[(c[s+8>>2]|0)+14920>>3];do{if(R!=0.0){S=-Q/R}else{if(Q==-0.0){S=-Q;break}S=-Q/+$Lb(c[b+536>>2]|0,R,8736,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](68,314,S,241,d);k=c[(d+8|0)>>2]|0;S=+h[(c[(b+416|0)>>2]|0)+21880>>3];s=c[c[(b+4|0)>>2]>>2]|0;R=+h[(c[s+8>>2]|0)+14912>>3];do{if(S!=0.0){T=-R/S}else{if(R==-0.0){T=-R;break}T=-R/+$Lb(c[b+536>>2]|0,S,8736,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](68,319,T,242,d);pe[c[(d+8|0)>>2]&3](69,304,-((a[(c[(b+424|0)>>2]|0)+131|0]|0)!=0?1.0:-1.0),243,d);pe[c[(d+8|0)>>2]&3](69,312,1.0,244,d);pe[c[(d+8|0)>>2]&3](69,316,-1.0,245,d);pe[c[(d+8|0)>>2]&3](70,311,-.5,246,d);pe[c[(d+8|0)>>2]&3](70,312,1.0,247,d);pe[c[(d+8|0)>>2]&3](71,310,2.0,248,d);pe[c[(d+8|0)>>2]&3](71,311,1.0,249,d);pe[c[(d+8|0)>>2]&3](72,136,-.8660254037844387,250,d);pe[c[(d+8|0)>>2]&3](72,309,.4999999999999999,251,d);pe[c[(d+8|0)>>2]&3](72,310,-1.0,252,d);pe[c[(d+8|0)>>2]&3](73,136,-.4999999999999999,253,d);pe[c[(d+8|0)>>2]&3](73,308,-1.0,254,d);pe[c[(d+8|0)>>2]&3](73,309,-.8660254037844387,255,d);pe[c[(d+8|0)>>2]&3](74,307,1.0,256,d);pe[c[(d+8|0)>>2]&3](74,308,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9936>>3]*-2.0,257,d);pe[c[(d+8|0)>>2]&3](74,310,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9928>>3]*-2.0,258,d);pe[c[(d+8|0)>>2]&3](75,306,1.0,259,d);pe[c[(d+8|0)>>2]&3](75,307,1.0,260,d);pe[c[(d+8|0)>>2]&3](75,312,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+20120>>3]*-2.0,261,d);pe[c[(d+8|0)>>2]&3](76,305,1.0,262,d);k=$Ob(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+20104>>3],1.0e-12)|0;pe[c[(d+8|0)>>2]&3](76,306,-(k<<24>>24!=0?1.0:0.0),263,d);pe[c[(d+8|0)>>2]&3](77,304,1.0,264,d);k=c[(d+8|0)>>2]|0;s=c[c[(b+4|0)>>2]>>2]|0;T=+V(+(+h[(c[s+8>>2]|0)+20096>>3]));if(T!=0.0){W=T}else{W=+$Lb(c[b+536>>2]|0,T,8944,8456,+h[s>>3],(a[b+319|0]|0)!=0|0)}pe[k&3](77,305,-.5/W,265,d);pe[c[(d+8|0)>>2]&3](78,9,-1.0,266,d);k=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;s=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](78,303,+h[k+14912>>3]*+h[s+6968>>3]- +h[k+14896>>3]*+h[s+6960>>3],267,d);pe[c[(d+8|0)>>2]&3](78,309,1.0,268,d);pe[c[(d+8|0)>>2]&3](79,302,1.0,269,d);s=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;k=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](79,303,+h[s+16200>>3]*+h[k+280>>3]- +h[s+16224>>3]*+h[k+272>>3],270,d);pe[c[(d+8|0)>>2]&3](80,301,1.0,271,d);pe[c[(d+8|0)>>2]&3](80,302,-1.0,272,d);k=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;s=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](80,303,+h[k+16200>>3]*+h[s+840>>3]- +h[k+16224>>3]*+h[s+832>>3],273,d);pe[c[(d+8|0)>>2]&3](81,300,1.0,274,d);pe[c[(d+8|0)>>2]&3](81,301,-1.0,275,d);c[e+8>>2]=b;c[e+16>>2]=d;c[e+2304>>2]=X;c[e+2312>>2]=Y;c[e+2320>>2]=Z;g[e+2328>>2]=_;c[e+11056>>2]=0;c[e+11060>>2]=0;_setLinearMatrixA1039$3(e);X=c[e+2304>>2]|0;Y=c[e+2312>>2]|0;Z=c[e+2320>>2]|0;_=+g[e+2328>>2];c[e+8>>2]=b;c[e+16>>2]=d;c[e+2304>>2]=X;c[e+2312>>2]=Y;c[e+2320>>2]=Z;g[e+2328>>2]=_;c[e+11048>>2]=0;c[e+11052>>2]=0;_setLinearMatrixA1039$2(e);c[e+8>>2]=b;c[e+16>>2]=d;c[e+11040>>2]=0;c[e+11044>>2]=0;_setLinearMatrixA1039$1(e);c[e+8>>2]=b;c[e+16>>2]=d;c[e+11032>>2]=0;c[e+11036>>2]=0;_setLinearMatrixA1039$0(e);H=c[e+11032>>2]|0;A=c[e+11036>>2]|0;I=+g[e+11036>>2];c[e+11032>>2]=0;c[e+11036>>2]=0;if((H|0)==5){return}}function _setLinearMatrixA1039$0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0.0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0.0,Za=0,_a=0,$a=0,ab=0,bb=0.0,cb=0.0,db=0,eb=0,fb=0,gb=0.0,hb=0,ib=0,jb=0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0.0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0.0,Fb=0.0,Gb=0,Hb=0,Ib=0,Jb=0.0,Kb=0,Lb=0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0.0,bc=0,cc=0,dc=0,ec=0,fc=0.0,gc=0.0,hc=0,ic=0,jc=0,kc=0.0,lc=0,mc=0,nc=0,oc=0.0,pc=0.0,qc=0.0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0.0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0.0,Jc=0.0,Kc=0,Lc=0,Mc=0,Nc=0.0,Oc=0,Pc=0,Qc=0,Rc=0.0,Sc=0.0,Tc=0.0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0.0,fd=0,gd=0,hd=0,id=0,jd=0.0,kd=0.0,ld=0,md=0,nd=0,od=0.0,pd=0,qd=0,rd=0,sd=0.0,td=0.0,ud=0.0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0.0,Id=0,Jd=0,Kd=0,Ld=0,Md=0.0,Nd=0.0,Od=0,Pd=0,Qd=0,Rd=0.0,Sd=0,Td=0,Ud=0,Vd=0.0,Wd=0.0,Xd=0.0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0.0,je=0,ke=0,le=0,me=0,ne=0.0,oe=0.0,qe=0,re=0,se=0,te=0.0,ue=0,ve=0,we=0,xe=0.0,ye=0.0,ze=0.0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0.0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0.0,Se=0.0,Te=0,Ue=0,Ve=0,We=0.0,Xe=0,Ye=0,Ze=0,_e=0.0,$e=0.0,af=0.0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0.0,pf=0,qf=0,rf=0,sf=0,tf=0.0,uf=0.0,vf=0,wf=0,xf=0,yf=0.0,zf=0,Af=0,Bf=0,Cf=0.0,Df=0.0,Ef=0.0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0.0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0.0,Xf=0.0,Yf=0,Zf=0,_f=0,$f=0.0,ag=0,bg=0,cg=0,dg=0.0,eg=0.0,fg=0.0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0.0,tg=0,ug=0,vg=0,wg=0,xg=0.0,yg=0.0,zg=0,Ag=0,Bg=0,Cg=0.0,Dg=0,Eg=0,Fg=0,Gg=0.0,Hg=0.0,Ig=0.0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0.0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0.0,$g=0.0,ah=0,bh=0,ch=0,dh=0.0,eh=0,fh=0,gh=0,hh=0.0,ih=0.0,jh=0.0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,th=0,uh=0,vh=0,wh=0.0,xh=0,yh=0,zh=0,Ah=0,Bh=0.0,Ch=0.0,Dh=0,Eh=0,Fh=0,Gh=0.0,Hh=0,Ih=0,Jh=0,Kh=0.0,Lh=0.0,Mh=0.0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0.0,_h=0,$h=0,ai=0,bi=0,ci=0.0,di=0.0,ei=0,fi=0,gi=0,hi=0.0,ii=0,ji=0,ki=0,li=0.0,mi=0.0,ni=0.0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=0,wi=0,xi=0,yi=0,zi=0,Ai=0.0,Bi=0,Ci=0,Di=0,Ei=0,Fi=0.0,Gi=0.0,Hi=0,Ii=0,Ji=0,Ki=0.0,Li=0,Mi=0,Ni=0,Oi=0.0,Pi=0.0,Qi=0.0,Ri=0,Si=0,Ti=0,Ui=0,Vi=0,Wi=0,Xi=0,Yi=0,Zi=0,_i=0,$i=0,aj=0,bj=0.0,cj=0,dj=0,ej=0,fj=0,gj=0.0,hj=0.0,ij=0,jj=0,kj=0,lj=0.0,mj=0,nj=0,oj=0,pj=0.0,qj=0.0,rj=0.0,sj=0,tj=0,uj=0,vj=0,wj=0,xj=0,yj=0.0,zj=0,Aj=0,Bj=0,Cj=0.0,Dj=0.0,Ej=0,Fj=0,Gj=0,Hj=0,Ij=0,Jj=0.0,Kj=0.0,Lj=0,Mj=0,Nj=0,Oj=0,Pj=0,Qj=0,Rj=0.0,Sj=0,Tj=0,Uj=0,Vj=0,Wj=0,Xj=0,Yj=0,Zj=0,_j=0,$j=0,ak=0.0,bk=0,ck=0,dk=0,ek=0.0,fk=0.0,gk=0.0,hk=0,ik=0,jk=0,kk=0,lk=0,mk=0,nk=0.0;d=c[b+8>>2]|0;e=c[b+16>>2]|0;a:do{f=c[(e+8|0)>>2]|0;g=c[c[(d+4|0)>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3600>>3];l=+h[(c[(d+416|0)>>2]|0)+19816>>3];m=+h[j+16032>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+$Lb(c[d+536>>2]|0,l,10384,8456,+h[g>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](328,58,-(k*n),1105,e);pe[c[(e+8|0)>>2]&3](329,46,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3680>>3],1106,e);pe[c[(e+8|0)>>2]&3](329,52,1.0,1107,e);pe[c[(e+8|0)>>2]&3](329,53,-1.0,1108,e);pe[c[(e+8|0)>>2]&3](330,41,-1.0,1109,e);pe[c[(e+8|0)>>2]&3](330,51,-1.0,1110,e);pe[c[(e+8|0)>>2]&3](330,52,-1.0,1111,e);pe[c[(e+8|0)>>2]&3](331,44,-.8660254037844387,1112,e);pe[c[(e+8|0)>>2]&3](331,50,1.0,1113,e);pe[c[(e+8|0)>>2]&3](331,51,.4999999999999999,1114,e);pe[c[(e+8|0)>>2]&3](332,44,-.4999999999999999,1115,e);pe[c[(e+8|0)>>2]&3](332,49,1.0,1116,e);pe[c[(e+8|0)>>2]&3](332,51,-.8660254037844387,1117,e);pe[c[(e+8|0)>>2]&3](333,44,+h[(c[(d+416|0)>>2]|0)+928>>3],1118,e);pe[c[(e+8|0)>>2]&3](333,47,1.0,1119,e);pe[c[(e+8|0)>>2]&3](333,48,-1.0,1120,e);pe[c[(e+8|0)>>2]&3](333,51,-+h[(c[(d+416|0)>>2]|0)+936>>3],1121,e);pe[c[(e+8|0)>>2]&3](334,38,-1.0,1122,e);pe[c[(e+8|0)>>2]&3](334,45,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3568>>3],1123,e);pe[c[(e+8|0)>>2]&3](334,47,-1.0,1124,e);pe[c[(e+8|0)>>2]&3](334,52,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3560>>3],1125,e);g=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20464>>3])),1.0e-10)|0;j=c[(e+8|0)>>2]|0;do{if(g<<24>>24==0){o=c[c[(d+4|0)>>2]>>2]|0;l=+h[(c[o+8>>2]|0)+20464>>3];if(l!=0.0){p=l;break}p=+$Lb(c[d+536>>2]|0,l,10592,8456,+h[o>>3],(a[d+319|0]|0)!=0|0)}else{p=1.0e-10}}while(0);pe[j&3](335,29,1.0/p,1126,e);g=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20464>>3])),1.0e-10)|0;f=c[(e+8|0)>>2]|0;o=c[c[(d+4|0)>>2]>>2]|0;q=c[o+8>>2]|0;if(g<<24>>24!=0){r=1}else{r=+h[q+20464>>3]!=0.0}k=+h[q+14808>>3]*.8660254037844387+ +h[q+14800>>3]*-.4999999999999999;do{if(r){if(g<<24>>24!=0){s=1.0e-10}else{s=+h[q+20464>>3]}t=k/s}else{if(k==0.0){t=k;break}if(g<<24>>24!=0){u=1.0e-10}else{u=+h[q+20464>>3]}t=k/+$Lb(c[d+536>>2]|0,u,10592,8456,+h[o>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](335,43,t,1127,e);pe[c[(e+8|0)>>2]&3](335,46,1.0,1128,e);o=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20464>>3])),1.0e-10)|0;q=c[(e+8|0)>>2]|0;g=c[c[(d+4|0)>>2]>>2]|0;j=c[g+8>>2]|0;if(o<<24>>24!=0){v=1}else{v=+h[j+20464>>3]!=0.0}k=+h[j+14824>>3]*.8660254037844387+ +h[j+14816>>3]*-.4999999999999999;do{if(v){if(o<<24>>24!=0){w=1.0e-10}else{w=+h[j+20464>>3]}x=k/w}else{if(k==0.0){x=k;break}if(o<<24>>24!=0){y=1.0e-10}else{y=+h[j+20464>>3]}x=k/+$Lb(c[d+536>>2]|0,y,10592,8456,+h[g>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[q&3](335,53,x,1129,e);pe[c[(e+8|0)>>2]&3](336,43,-1.0,1130,e);pe[c[(e+8|0)>>2]&3](336,45,1.0,1131,e);pe[c[(e+8|0)>>2]&3](336,46,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3672>>3],1132,e);pe[c[(e+8|0)>>2]&3](337,40,-1.0,1133,e);pe[c[(e+8|0)>>2]&3](337,44,-1.0,1134,e);pe[c[(e+8|0)>>2]&3](337,45,-1.0,1135,e);g=c[(e+8|0)>>2]|0;j=c[c[(d+4|0)>>2]>>2]|0;o=c[j+8>>2]|0;k=+h[(c[(d+416|0)>>2]|0)+19816>>3]*+h[o+6952>>3];l=+h[o+16040>>3];do{if(k!=0.0){z=l/k}else{if(l==0.0){z=l;break}z=l/+$Lb(c[d+536>>2]|0,k,10496,8456,+h[j>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](338,38,z,1136,e);j=c[(e+8|0)>>2]|0;q=c[c[(d+4|0)>>2]>>2]|0;o=c[q+8>>2]|0;k=+h[o+3592>>3];l=+h[(c[(d+416|0)>>2]|0)+19816>>3];m=+h[o+16040>>3];do{if(l!=0.0){A=m/l}else{if(m==0.0){A=m;break}A=m/+$Lb(c[d+536>>2]|0,l,10384,8456,+h[q>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[j&3](338,42,-(k*A),1137,e);pe[c[(e+8|0)>>2]&3](338,43,1.0,1138,e);q=c[(e+8|0)>>2]|0;g=c[c[(d+4|0)>>2]>>2]|0;o=c[g+8>>2]|0;l=+h[o+3592>>3];m=+h[(c[(d+416|0)>>2]|0)+19816>>3];B=+h[o+16032>>3];do{if(m!=0.0){C=B/m}else{if(B==0.0){C=B;break}C=B/+$Lb(c[d+536>>2]|0,m,10384,8456,+h[g>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[q&3](338,58,-(l*C),1139,e);pe[c[(e+8|0)>>2]&3](339,36,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3592>>3],1140,e);pe[c[(e+8|0)>>2]&3](339,39,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3672>>3],1141,e);pe[c[(e+8|0)>>2]&3](339,42,1.0,1142,e);pe[c[(e+8|0)>>2]&3](339,59,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+16040>>3],1143,e);pe[c[(e+8|0)>>2]&3](340,33,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3680>>3],1144,e);pe[c[(e+8|0)>>2]&3](340,37,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+16032>>3],1145,e);pe[c[(e+8|0)>>2]&3](340,41,1.0,1146,e);pe[c[(e+8|0)>>2]&3](340,67,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3600>>3],1147,e);pe[c[(e+8|0)>>2]&3](341,33,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3672>>3],1148,e);pe[c[(e+8|0)>>2]&3](341,37,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+16040>>3],1149,e);pe[c[(e+8|0)>>2]&3](341,40,1.0,1150,e);pe[c[(e+8|0)>>2]&3](341,67,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3592>>3],1151,e);pe[c[(e+8|0)>>2]&3](342,37,-+h[(c[(d+416|0)>>2]|0)+2768>>3],1152,e);pe[c[(e+8|0)>>2]&3](342,39,-1.0,1153,e);pe[c[(e+8|0)>>2]&3](342,67,+h[(c[(d+416|0)>>2]|0)+2784>>3],1154,e);pe[c[(e+8|0)>>2]&3](342,68,-5.0e-4,1155,e);pe[c[(e+8|0)>>2]&3](343,36,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6952>>3],1156,e);pe[c[(e+8|0)>>2]&3](343,38,1.0,1157,e);pe[c[(e+8|0)>>2]&3](343,39,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6976>>3],1158,e);pe[c[(e+8|0)>>2]&3](344,5,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7016>>3]*+h[(c[(d+416|0)>>2]|0)+20032>>3]),1159,e);g=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](344,31,-(+h[g+2776>>3]*+h[g+20032>>3]),1160,e);pe[c[(e+8|0)>>2]&3](344,37,-1.0,1161,e);g=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](344,68,+h[g+2768>>3]*+h[g+20032>>3],1162,e);pe[c[(e+8|0)>>2]&3](344,77,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7008>>3]*+h[(c[(d+416|0)>>2]|0)+20032>>3]),1163,e);pe[c[(e+8|0)>>2]&3](345,31,-.006,1164,e);pe[c[(e+8|0)>>2]&3](345,33,-+h[(c[(d+416|0)>>2]|0)+2784>>3],1165,e);pe[c[(e+8|0)>>2]&3](345,36,-1.0,1166,e);pe[c[(e+8|0)>>2]&3](345,37,+h[(c[(d+416|0)>>2]|0)+2776>>3],1167,e);pe[c[(e+8|0)>>2]&3](346,30,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3592>>3],1168,e);pe[c[(e+8|0)>>2]&3](346,35,1.0,1169,e);pe[c[(e+8|0)>>2]&3](346,70,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3600>>3],1170,e);pe[c[(e+8|0)>>2]&3](347,34,1.0,1171,e);pe[c[(e+8|0)>>2]&3](347,35,-1.0,1172,e);pe[c[(e+8|0)>>2]&3](348,5,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6992>>3]*+h[(c[(d+416|0)>>2]|0)+20032>>3]),1173,e);g=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](348,31,+h[g+2784>>3]*+h[g+20032>>3],1174,e);pe[c[(e+8|0)>>2]&3](348,33,-1.0,1175,e);g=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](348,34,-(+h[g+2768>>3]*+h[g+20032>>3]),1176,e);pe[c[(e+8|0)>>2]&3](348,77,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6984>>3]*+h[(c[(d+416|0)>>2]|0)+20032>>3]),1177,e);pe[c[(e+8|0)>>2]&3](349,30,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+16040>>3],1178,e);pe[c[(e+8|0)>>2]&3](349,32,1.0,1179,e);pe[c[(e+8|0)>>2]&3](349,70,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+16032>>3],1180,e);pe[c[(e+8|0)>>2]&3](350,31,1.0,1181,e);pe[c[(e+8|0)>>2]&3](350,32,-1.0,1182,e);pe[c[(e+8|0)>>2]&3](350,303,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6952>>3],1183,e);g=c[(e+8|0)>>2]|0;m=+h[(c[(d+416|0)>>2]|0)+19816>>3];j=c[c[(d+4|0)>>2]>>2]|0;B=+h[(c[j+8>>2]|0)+14800>>3];do{if(m!=0.0){D=-B/m}else{if(B==-0.0){D=-B;break}D=-B/+$Lb(c[d+536>>2]|0,m,10384,8456,+h[j>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](351,27,D,1184,e);pe[c[(e+8|0)>>2]&3](351,30,1.0,1185,e);j=c[(e+8|0)>>2]|0;m=+h[(c[(d+416|0)>>2]|0)+19816>>3];q=c[c[(d+4|0)>>2]>>2]|0;B=+h[(c[q+8>>2]|0)+14808>>3];do{if(m!=0.0){E=-B/m}else{if(B==-0.0){E=-B;break}E=-B/+$Lb(c[d+536>>2]|0,m,10384,8456,+h[q>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[j&3](351,71,E,1186,e);q=c[(e+8|0)>>2]|0;m=+h[(c[(d+416|0)>>2]|0)+19816>>3];g=c[c[(d+4|0)>>2]>>2]|0;B=+h[(c[g+8>>2]|0)+3568>>3];do{if(m!=0.0){F=B/m}else{if(B==0.0){F=B;break}F=B/+$Lb(c[d+536>>2]|0,m,10384,8456,+h[g>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[q&3](351,303,F,1187,e);pe[c[(e+8|0)>>2]&3](352,28,+h[(c[(d+416|0)>>2]|0)+20232>>3]*.4999999999999999,1188,e);pe[c[(e+8|0)>>2]&3](352,29,1.0,1189,e);pe[c[(e+8|0)>>2]&3](352,72,+h[(c[(d+416|0)>>2]|0)+20232>>3]*-.8660254037844387,1190,e);pe[c[(e+8|0)>>2]&3](353,28,1.0,1191,e);pe[c[(e+8|0)>>2]&3](353,73,.4999999999999999,1192,e);pe[c[(e+8|0)>>2]&3](354,5,1.0,1193,e);pe[c[(e+8|0)>>2]&3](354,27,1.0,1194,e);pe[c[(e+8|0)>>2]&3](354,28,-1.0,1195,e);pe[c[(e+8|0)>>2]&3](355,23,1.0,1196,e);pe[c[(e+8|0)>>2]&3](355,26,1.0,1197,e);pe[c[(e+8|0)>>2]&3](355,74,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20440>>3]*-2.0,1198,e);pe[c[(e+8|0)>>2]&3](356,25,1.0,1199,e);g=$Ob(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20424>>3],1.0e-12)|0;pe[c[(e+8|0)>>2]&3](356,26,-(g<<24>>24!=0?1.0:0.0),1200,e);pe[c[(e+8|0)>>2]&3](357,24,1.0,1201,e);g=c[(e+8|0)>>2]|0;j=c[c[(d+4|0)>>2]>>2]|0;m=+V(+(+h[(c[j+8>>2]|0)+20416>>3]));if(m!=0.0){G=m;H=-.5/G;pe[g&3](357,25,H,1202,e);I=c[(e+8|0)>>2]|0;J=c[(d+4|0)>>2]|0;K=c[J>>2]|0;L=K;M=L+8|0;N=M;O=c[N>>2]|0;P=O;Q=P+9696|0;R=Q;S=+h[R>>3];T=S*-2.0;pe[I&3](358,22,T,1203,e);W=c[(e+8|0)>>2]|0;pe[W&3](358,23,1.0,1204,e);X=c[(e+8|0)>>2]|0;Y=c[(d+4|0)>>2]|0;Z=c[Y>>2]|0;_=Z;$=_+8|0;aa=$;ba=c[aa>>2]|0;ca=ba;da=ca+9688|0;ea=da;fa=+h[ea>>3];ga=fa*-2.0;pe[X&3](358,76,ga,1205,e);ha=c[(e+8|0)>>2]|0;pe[ha&3](359,5,-.8660254037844387,1206,e);ia=c[(e+8|0)>>2]|0;pe[ia&3](359,22,-1.0,1207,e);ja=c[(e+8|0)>>2]|0;pe[ja&3](359,77,-.4999999999999999,1208,e);ka=c[(e+8|0)>>2]|0;pe[ka&3](360,21,1.0,1209,e);la=c[(e+8|0)>>2]|0;ma=c[(d+4|0)>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+16208|0;ua=ta;va=+h[ua>>3];wa=c[(d+416|0)>>2]|0;xa=wa;ya=xa+280|0;za=ya;Aa=+h[za>>3];Ba=va*Aa;Ca=ra;Da=Ca+16232|0;Ea=Da;Fa=+h[Ea>>3];Ga=wa;Ha=Ga+272|0;Ia=Ha;Ja=+h[Ia>>3];Ka=Fa*Ja;La=Ba-Ka;pe[la&3](360,303,La,1210,e);Ma=c[(e+8|0)>>2]|0;pe[Ma&3](361,20,1.0,1211,e);Na=c[(e+8|0)>>2]|0;pe[Na&3](361,21,-1.0,1212,e);Oa=c[(e+8|0)>>2]|0;Pa=c[(d+4|0)>>2]|0;Qa=c[Pa>>2]|0;Ra=Qa;Sa=Ra+8|0;Ta=Sa;Ua=c[Ta>>2]|0;Va=Ua;Wa=Va+16208|0;Xa=Wa;Ya=+h[Xa>>3];Za=c[(d+416|0)>>2]|0;_a=Za;$a=_a+840|0;ab=$a;bb=+h[ab>>3];cb=Ya*bb;db=Ua;eb=db+16232|0;fb=eb;gb=+h[fb>>3];hb=Za;ib=hb+832|0;jb=ib;kb=+h[jb>>3];lb=gb*kb;mb=cb-lb;pe[Oa&3](361,303,mb,1213,e);nb=c[(e+8|0)>>2]|0;pe[nb&3](362,19,1.0,1214,e);ob=c[(e+8|0)>>2]|0;pe[ob&3](362,20,-1.0,1215,e);pb=c[(e+8|0)>>2]|0;qb=c[(d+4|0)>>2]|0;rb=c[qb>>2]|0;sb=rb;tb=sb+8|0;ub=tb;vb=c[ub>>2]|0;wb=vb;xb=wb+16208|0;yb=xb;zb=+h[yb>>3];Ab=c[(d+416|0)>>2]|0;Bb=Ab;Cb=Bb+3856|0;Db=Cb;Eb=+h[Db>>3];Fb=zb*Eb;Gb=vb;Hb=Gb+16232|0;Ib=Hb;Jb=+h[Ib>>3];Kb=Ab;Lb=Kb+3848|0;Mb=Lb;Nb=+h[Mb>>3];Ob=Jb*Nb;Pb=Fb-Ob;pe[pb&3](362,303,Pb,1216,e);Qb=c[(e+8|0)>>2]|0;pe[Qb&3](363,18,1.0,1217,e);Rb=c[(e+8|0)>>2]|0;pe[Rb&3](363,19,-1.0,1218,e);Sb=c[(e+8|0)>>2]|0;Tb=c[(d+4|0)>>2]|0;Ub=c[Tb>>2]|0;Vb=Ub;Wb=Vb+8|0;Xb=Wb;Yb=c[Xb>>2]|0;Zb=Yb;_b=Zb+16208|0;$b=_b;ac=+h[$b>>3];bc=c[(d+416|0)>>2]|0;cc=bc;dc=cc+6872|0;ec=dc;fc=+h[ec>>3];gc=ac*fc;hc=Yb;ic=hc+16232|0;jc=ic;kc=+h[jc>>3];lc=bc;mc=lc+6864|0;nc=mc;oc=+h[nc>>3];pc=kc*oc;qc=gc-pc;pe[Sb&3](363,303,qc,1219,e);rc=c[(e+8|0)>>2]|0;pe[rc&3](364,17,1.0,1220,e);sc=c[(e+8|0)>>2]|0;pe[sc&3](364,18,-1.0,1221,e);tc=c[(e+8|0)>>2]|0;uc=c[(d+4|0)>>2]|0;vc=c[uc>>2]|0;wc=vc;xc=wc+8|0;yc=xc;zc=c[yc>>2]|0;Ac=zc;Bc=Ac+16208|0;Cc=Bc;Dc=+h[Cc>>3];Ec=c[(d+416|0)>>2]|0;Fc=Ec;Gc=Fc+9888|0;Hc=Gc;Ic=+h[Hc>>3];Jc=Dc*Ic;Kc=zc;Lc=Kc+16232|0;Mc=Lc;Nc=+h[Mc>>3];Oc=Ec;Pc=Oc+9880|0;Qc=Pc;Rc=+h[Qc>>3];Sc=Nc*Rc;Tc=Jc-Sc;pe[tc&3](364,303,Tc,1222,e);Uc=c[(e+8|0)>>2]|0;pe[Uc&3](365,16,1.0,1223,e);Vc=c[(e+8|0)>>2]|0;pe[Vc&3](365,17,-1.0,1224,e);Wc=c[(e+8|0)>>2]|0;Xc=c[(d+4|0)>>2]|0;Yc=c[Xc>>2]|0;Zc=Yc;_c=Zc+8|0;$c=_c;ad=c[$c>>2]|0;bd=ad;cd=bd+16208|0;dd=cd;ed=+h[dd>>3];fd=c[(d+416|0)>>2]|0;gd=fd;hd=gd+12904|0;id=hd;jd=+h[id>>3];kd=ed*jd;ld=ad;md=ld+16232|0;nd=md;od=+h[nd>>3];pd=fd;qd=pd+12896|0;rd=qd;sd=+h[rd>>3];td=od*sd;ud=kd-td;pe[Wc&3](365,303,ud,1225,e);vd=c[(e+8|0)>>2]|0;pe[vd&3](366,15,1.0,1226,e);wd=c[(e+8|0)>>2]|0;pe[wd&3](366,16,-1.0,1227,e);xd=c[(e+8|0)>>2]|0;yd=c[(d+4|0)>>2]|0;zd=c[yd>>2]|0;Ad=zd;Bd=Ad+8|0;Cd=Bd;Dd=c[Cd>>2]|0;Ed=Dd;Fd=Ed+16208|0;Gd=Fd;Hd=+h[Gd>>3];Id=c[(d+416|0)>>2]|0;Jd=Id;Kd=Jd+16496|0;Ld=Kd;Md=+h[Ld>>3];Nd=Hd*Md;Od=Dd;Pd=Od+16232|0;Qd=Pd;Rd=+h[Qd>>3];Sd=Id;Td=Sd+16488|0;Ud=Td;Vd=+h[Ud>>3];Wd=Rd*Vd;Xd=Nd-Wd;pe[xd&3](366,303,Xd,1228,e);Yd=c[(e+8|0)>>2]|0;pe[Yd&3](367,14,1.0,1229,e);Zd=c[(e+8|0)>>2]|0;pe[Zd&3](367,15,-1.0,1230,e);_d=c[(e+8|0)>>2]|0;$d=c[(d+4|0)>>2]|0;ae=c[$d>>2]|0;be=ae;ce=be+8|0;de=ce;ee=c[de>>2]|0;fe=ee;ge=fe+15056|0;he=ge;ie=+h[he>>3];je=c[(d+416|0)>>2]|0;ke=je;le=ke+16016|0;me=le;ne=+h[me>>3];oe=ie*ne;qe=ee;re=qe+15040|0;se=re;te=+h[se>>3];ue=je;ve=ue+16008|0;we=ve;xe=+h[we>>3];ye=te*xe;ze=oe-ye;pe[_d&3](367,303,ze,1231,e);Ae=c[(e+8|0)>>2]|0;pe[Ae&3](368,13,1.0,1232,e);Be=c[(e+8|0)>>2]|0;pe[Be&3](368,17,-1.0,1233,e);Ce=c[(e+8|0)>>2]|0;De=c[(d+4|0)>>2]|0;Ee=c[De>>2]|0;Fe=Ee;Ge=Fe+8|0;He=Ge;Ie=c[He>>2]|0;Je=Ie;Ke=Je+16208|0;Le=Ke;Me=+h[Le>>3];Ne=c[(d+416|0)>>2]|0;Oe=Ne;Pe=Oe+13480|0;Qe=Pe;Re=+h[Qe>>3];Se=Me*Re;Te=Ie;Ue=Te+16232|0;Ve=Ue;We=+h[Ve>>3];Xe=Ne;Ye=Xe+13472|0;Ze=Ye;_e=+h[Ze>>3];$e=We*_e;af=Se-$e;pe[Ce&3](368,303,af,1234,e);bf=c[(e+8|0)>>2]|0;pe[bf&3](369,12,1.0,1235,e);cf=c[(e+8|0)>>2]|0;pe[cf&3](369,13,-1.0,1236,e);df=c[(e+8|0)>>2]|0;ef=c[(d+4|0)>>2]|0;ff=c[ef>>2]|0;gf=ff;hf=gf+8|0;jf=hf;kf=c[jf>>2]|0;lf=kf;mf=lf+15008|0;nf=mf;of=+h[nf>>3];pf=c[(d+416|0)>>2]|0;qf=pf;rf=qf+13e3|0;sf=rf;tf=+h[sf>>3];uf=of*tf;vf=kf;wf=vf+14992|0;xf=wf;yf=+h[xf>>3];zf=pf;Af=zf+12992|0;Bf=Af;Cf=+h[Bf>>3];Df=yf*Cf;Ef=uf-Df;pe[df&3](369,303,Ef,1237,e);Ff=c[(e+8|0)>>2]|0;pe[Ff&3](370,11,1.0,1238,e);Gf=c[(e+8|0)>>2]|0;pe[Gf&3](370,18,-1.0,1239,e);Hf=c[(e+8|0)>>2]|0;If=c[(d+4|0)>>2]|0;Jf=c[If>>2]|0;Kf=Jf;Lf=Kf+8|0;Mf=Lf;Nf=c[Mf>>2]|0;Of=Nf;Pf=Of+16208|0;Qf=Pf;Rf=+h[Qf>>3];Sf=c[(d+416|0)>>2]|0;Tf=Sf;Uf=Tf+10464|0;Vf=Uf;Wf=+h[Vf>>3];Xf=Rf*Wf;Yf=Nf;Zf=Yf+16232|0;_f=Zf;$f=+h[_f>>3];ag=Sf;bg=ag+10456|0;cg=bg;dg=+h[cg>>3];eg=$f*dg;fg=Xf-eg;pe[Hf&3](370,303,fg,1240,e);gg=c[(e+8|0)>>2]|0;pe[gg&3](371,10,1.0,1241,e);hg=c[(e+8|0)>>2]|0;pe[hg&3](371,11,-1.0,1242,e);ig=c[(e+8|0)>>2]|0;jg=c[(d+4|0)>>2]|0;kg=c[jg>>2]|0;lg=kg;mg=lg+8|0;ng=mg;og=c[ng>>2]|0;pg=og;qg=pg+14960|0;rg=qg;sg=+h[rg>>3];tg=c[(d+416|0)>>2]|0;ug=tg;vg=ug+9984|0;wg=vg;xg=+h[wg>>3];yg=sg*xg;zg=og;Ag=zg+14944|0;Bg=Ag;Cg=+h[Bg>>3];Dg=tg;Eg=Dg+9976|0;Fg=Eg;Gg=+h[Fg>>3];Hg=Cg*Gg;Ig=yg-Hg;pe[ig&3](371,303,Ig,1243,e);Jg=c[(e+8|0)>>2]|0;pe[Jg&3](372,9,1.0,1244,e);Kg=c[(e+8|0)>>2]|0;pe[Kg&3](372,19,-1.0,1245,e);Lg=c[(e+8|0)>>2]|0;Mg=c[(d+4|0)>>2]|0;Ng=c[Mg>>2]|0;Og=Ng;Pg=Og+8|0;Qg=Pg;Rg=c[Qg>>2]|0;Sg=Rg;Tg=Sg+16208|0;Ug=Tg;Vg=+h[Ug>>3];Wg=c[(d+416|0)>>2]|0;Xg=Wg;Yg=Xg+7448|0;Zg=Yg;_g=+h[Zg>>3];$g=Vg*_g;ah=Rg;bh=ah+16232|0;ch=bh;dh=+h[ch>>3];eh=Wg;fh=eh+7440|0;gh=fh;hh=+h[gh>>3];ih=dh*hh;jh=$g-ih;pe[Lg&3](372,303,jh,1246,e);kh=c[(e+8|0)>>2]|0;pe[kh&3](373,8,1.0,1247,e);lh=c[(e+8|0)>>2]|0;pe[lh&3](373,20,-1.0,1248,e);mh=c[(e+8|0)>>2]|0;nh=c[(d+4|0)>>2]|0;oh=c[nh>>2]|0;ph=oh;qh=ph+8|0;rh=qh;sh=c[rh>>2]|0;th=sh;uh=th+16208|0;vh=uh;wh=+h[vh>>3];xh=c[(d+416|0)>>2]|0;yh=xh;zh=yh+4432|0;Ah=zh;Bh=+h[Ah>>3];Ch=wh*Bh;Dh=sh;Eh=Dh+16232|0;Fh=Eh;Gh=+h[Fh>>3];Hh=xh;Ih=Hh+4424|0;Jh=Ih;Kh=+h[Jh>>3];Lh=Gh*Kh;Mh=Ch-Lh;pe[mh&3](373,303,Mh,1249,e);Nh=c[(e+8|0)>>2]|0;pe[Nh&3](374,7,1.0,1250,e);Oh=c[(e+8|0)>>2]|0;pe[Oh&3](374,8,-1.0,1251,e);Ph=c[(e+8|0)>>2]|0;Qh=c[(d+4|0)>>2]|0;Rh=c[Qh>>2]|0;Sh=Rh;Th=Sh+8|0;Uh=Th;Vh=c[Uh>>2]|0;Wh=Vh;Xh=Wh+14864|0;Yh=Xh;Zh=+h[Yh>>3];_h=c[(d+416|0)>>2]|0;$h=_h;ai=$h+3952|0;bi=ai;ci=+h[bi>>3];di=Zh*ci;ei=Vh;fi=ei+14848|0;gi=fi;hi=+h[gi>>3];ii=_h;ji=ii+3944|0;ki=ji;li=+h[ki>>3];mi=hi*li;ni=di-mi;pe[Ph&3](374,303,ni,1252,e);oi=c[(e+8|0)>>2]|0;pe[oi&3](375,6,1.0,1253,e);pi=c[(e+8|0)>>2]|0;pe[pi&3](375,21,-1.0,1254,e);qi=c[(e+8|0)>>2]|0;ri=c[(d+4|0)>>2]|0;si=c[ri>>2]|0;ti=si;ui=ti+8|0;vi=ui;wi=c[vi>>2]|0;xi=wi;yi=xi+16208|0;zi=yi;Ai=+h[zi>>3];Bi=c[(d+416|0)>>2]|0;Ci=Bi;Di=Ci+1416|0;Ei=Di;Fi=+h[Ei>>3];Gi=Ai*Fi;Hi=wi;Ii=Hi+16232|0;Ji=Ii;Ki=+h[Ji>>3];Li=Bi;Mi=Li+1408|0;Ni=Mi;Oi=+h[Ni>>3];Pi=Ki*Oi;Qi=Gi-Pi;pe[qi&3](375,303,Qi,1255,e);Ri=c[(e+8|0)>>2]|0;pe[Ri&3](376,5,1.0,1256,e);Si=c[(e+8|0)>>2]|0;pe[Si&3](376,6,-1.0,1257,e);Ti=c[(e+8|0)>>2]|0;Ui=c[(d+4|0)>>2]|0;Vi=c[Ui>>2]|0;Wi=Vi;Xi=Wi+8|0;Yi=Xi;Zi=c[Yi>>2]|0;_i=Zi;$i=_i+14816|0;aj=$i;bj=+h[aj>>3];cj=c[(d+416|0)>>2]|0;dj=cj;ej=dj+936|0;fj=ej;gj=+h[fj>>3];hj=bj*gj;ij=Zi;jj=ij+14800|0;kj=jj;lj=+h[kj>>3];mj=cj;nj=mj+928|0;oj=nj;pj=+h[oj>>3];qj=lj*pj;rj=hj-qj;pe[Ti&3](376,303,rj,1258,e);sj=c[(e+8|0)>>2]|0;pe[sj&3](377,4,1.0,1259,e);tj=c[(e+8|0)>>2]|0;uj=c[(d+416|0)>>2]|0;vj=uj;wj=vj+400|0;xj=wj;yj=+h[xj>>3];zj=uj;Aj=zj+19200|0;Bj=Aj;Cj=+h[Bj>>3];Dj=yj*Cj;pe[tj&3](377,303,Dj,1260,e);Ej=c[(e+8|0)>>2]|0;Fj=c[(d+416|0)>>2]|0;Gj=Fj;Hj=Gj+392|0;Ij=Hj;Jj=+h[Ij>>3];Kj=-Jj;pe[Ej&3](378,1,Kj,1261,e);Lj=c[(e+8|0)>>2]|0;pe[Lj&3](378,3,1.0,1262,e);Mj=c[(e+8|0)>>2]|0;Nj=c[(d+416|0)>>2]|0;Oj=Nj;Pj=Oj+400|0;Qj=Pj;Rj=+h[Qj>>3];pe[Mj&3](378,4,Rj,1263,e);Sj=c[(e+8|0)>>2]|0;pe[Sj&3](378,303,-.1,1264,e);Tj=c[(e+8|0)>>2]|0;pe[Tj&3](379,0,1.0,1265,e);Uj=c[(e+8|0)>>2]|0;pe[Uj&3](379,2,1.0,1266,e);Vj=c[(e+8|0)>>2]|0;pe[Vj&3](379,3,1.0,1267,e);Wj=c[(e+8|0)>>2]|0;pe[Wj&3](380,1,1.0,1268,e);Xj=c[(e+8|0)>>2]|0;Yj=c[(d+416|0)>>2]|0;Zj=Yj;_j=Zj+392|0;$j=_j;ak=+h[$j>>3];bk=Yj;ck=bk+19200|0;dk=ck;ek=+h[dk>>3];fk=ak*ek;gk=-fk;pe[Xj&3](380,303,gk,1269,e);hk=c[(e+8|0)>>2]|0;pe[hk&3](381,0,-1.0,1270,e);ik=c[(e+8|0)>>2]|0;jk=c[(d+416|0)>>2]|0;kk=jk;lk=kk+25488|0;mk=lk;nk=+h[mk>>3];pe[ik&3](381,303,nk,1271,e);i=b;c[b+11032>>2]=5;break a}G=+$Lb(c[d+536>>2]|0,m,10712,8456,+h[j>>3],(a[d+319|0]|0)!=0|0);H=-.5/G;pe[g&3](357,25,H,1202,e);I=c[(e+8|0)>>2]|0;J=c[(d+4|0)>>2]|0;K=c[J>>2]|0;L=K;M=L+8|0;N=M;O=c[N>>2]|0;P=O;Q=P+9696|0;R=Q;S=+h[R>>3];T=S*-2.0;pe[I&3](358,22,T,1203,e);W=c[(e+8|0)>>2]|0;pe[W&3](358,23,1.0,1204,e);X=c[(e+8|0)>>2]|0;Y=c[(d+4|0)>>2]|0;Z=c[Y>>2]|0;_=Z;$=_+8|0;aa=$;ba=c[aa>>2]|0;ca=ba;da=ca+9688|0;ea=da;fa=+h[ea>>3];ga=fa*-2.0;pe[X&3](358,76,ga,1205,e);ha=c[(e+8|0)>>2]|0;pe[ha&3](359,5,-.8660254037844387,1206,e);ia=c[(e+8|0)>>2]|0;pe[ia&3](359,22,-1.0,1207,e);ja=c[(e+8|0)>>2]|0;pe[ja&3](359,77,-.4999999999999999,1208,e);ka=c[(e+8|0)>>2]|0;pe[ka&3](360,21,1.0,1209,e);la=c[(e+8|0)>>2]|0;ma=c[(d+4|0)>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+16208|0;ua=ta;va=+h[ua>>3];wa=c[(d+416|0)>>2]|0;xa=wa;ya=xa+280|0;za=ya;Aa=+h[za>>3];Ba=va*Aa;Ca=ra;Da=Ca+16232|0;Ea=Da;Fa=+h[Ea>>3];Ga=wa;Ha=Ga+272|0;Ia=Ha;Ja=+h[Ia>>3];Ka=Fa*Ja;La=Ba-Ka;pe[la&3](360,303,La,1210,e);Ma=c[(e+8|0)>>2]|0;pe[Ma&3](361,20,1.0,1211,e);Na=c[(e+8|0)>>2]|0;pe[Na&3](361,21,-1.0,1212,e);Oa=c[(e+8|0)>>2]|0;Pa=c[(d+4|0)>>2]|0;Qa=c[Pa>>2]|0;Ra=Qa;Sa=Ra+8|0;Ta=Sa;Ua=c[Ta>>2]|0;Va=Ua;Wa=Va+16208|0;Xa=Wa;Ya=+h[Xa>>3];Za=c[(d+416|0)>>2]|0;_a=Za;$a=_a+840|0;ab=$a;bb=+h[ab>>3];cb=Ya*bb;db=Ua;eb=db+16232|0;fb=eb;gb=+h[fb>>3];hb=Za;ib=hb+832|0;jb=ib;kb=+h[jb>>3];lb=gb*kb;mb=cb-lb;pe[Oa&3](361,303,mb,1213,e);nb=c[(e+8|0)>>2]|0;pe[nb&3](362,19,1.0,1214,e);ob=c[(e+8|0)>>2]|0;pe[ob&3](362,20,-1.0,1215,e);pb=c[(e+8|0)>>2]|0;qb=c[(d+4|0)>>2]|0;rb=c[qb>>2]|0;sb=rb;tb=sb+8|0;ub=tb;vb=c[ub>>2]|0;wb=vb;xb=wb+16208|0;yb=xb;zb=+h[yb>>3];Ab=c[(d+416|0)>>2]|0;Bb=Ab;Cb=Bb+3856|0;Db=Cb;Eb=+h[Db>>3];Fb=zb*Eb;Gb=vb;Hb=Gb+16232|0;Ib=Hb;Jb=+h[Ib>>3];Kb=Ab;Lb=Kb+3848|0;Mb=Lb;Nb=+h[Mb>>3];Ob=Jb*Nb;Pb=Fb-Ob;pe[pb&3](362,303,Pb,1216,e);Qb=c[(e+8|0)>>2]|0;pe[Qb&3](363,18,1.0,1217,e);Rb=c[(e+8|0)>>2]|0;pe[Rb&3](363,19,-1.0,1218,e);Sb=c[(e+8|0)>>2]|0;Tb=c[(d+4|0)>>2]|0;Ub=c[Tb>>2]|0;Vb=Ub;Wb=Vb+8|0;Xb=Wb;Yb=c[Xb>>2]|0;Zb=Yb;_b=Zb+16208|0;$b=_b;ac=+h[$b>>3];bc=c[(d+416|0)>>2]|0;cc=bc;dc=cc+6872|0;ec=dc;fc=+h[ec>>3];gc=ac*fc;hc=Yb;ic=hc+16232|0;jc=ic;kc=+h[jc>>3];lc=bc;mc=lc+6864|0;nc=mc;oc=+h[nc>>3];pc=kc*oc;qc=gc-pc;pe[Sb&3](363,303,qc,1219,e);rc=c[(e+8|0)>>2]|0;pe[rc&3](364,17,1.0,1220,e);sc=c[(e+8|0)>>2]|0;pe[sc&3](364,18,-1.0,1221,e);tc=c[(e+8|0)>>2]|0;uc=c[(d+4|0)>>2]|0;vc=c[uc>>2]|0;wc=vc;xc=wc+8|0;yc=xc;zc=c[yc>>2]|0;Ac=zc;Bc=Ac+16208|0;Cc=Bc;Dc=+h[Cc>>3];Ec=c[(d+416|0)>>2]|0;Fc=Ec;Gc=Fc+9888|0;Hc=Gc;Ic=+h[Hc>>3];Jc=Dc*Ic;Kc=zc;Lc=Kc+16232|0;Mc=Lc;Nc=+h[Mc>>3];Oc=Ec;Pc=Oc+9880|0;Qc=Pc;Rc=+h[Qc>>3];Sc=Nc*Rc;Tc=Jc-Sc;pe[tc&3](364,303,Tc,1222,e);Uc=c[(e+8|0)>>2]|0;pe[Uc&3](365,16,1.0,1223,e);Vc=c[(e+8|0)>>2]|0;pe[Vc&3](365,17,-1.0,1224,e);Wc=c[(e+8|0)>>2]|0;Xc=c[(d+4|0)>>2]|0;Yc=c[Xc>>2]|0;Zc=Yc;_c=Zc+8|0;$c=_c;ad=c[$c>>2]|0;bd=ad;cd=bd+16208|0;dd=cd;ed=+h[dd>>3];fd=c[(d+416|0)>>2]|0;gd=fd;hd=gd+12904|0;id=hd;jd=+h[id>>3];kd=ed*jd;ld=ad;md=ld+16232|0;nd=md;od=+h[nd>>3];pd=fd;qd=pd+12896|0;rd=qd;sd=+h[rd>>3];td=od*sd;ud=kd-td;pe[Wc&3](365,303,ud,1225,e);vd=c[(e+8|0)>>2]|0;pe[vd&3](366,15,1.0,1226,e);wd=c[(e+8|0)>>2]|0;pe[wd&3](366,16,-1.0,1227,e);xd=c[(e+8|0)>>2]|0;yd=c[(d+4|0)>>2]|0;zd=c[yd>>2]|0;Ad=zd;Bd=Ad+8|0;Cd=Bd;Dd=c[Cd>>2]|0;Ed=Dd;Fd=Ed+16208|0;Gd=Fd;Hd=+h[Gd>>3];Id=c[(d+416|0)>>2]|0;Jd=Id;Kd=Jd+16496|0;Ld=Kd;Md=+h[Ld>>3];Nd=Hd*Md;Od=Dd;Pd=Od+16232|0;Qd=Pd;Rd=+h[Qd>>3];Sd=Id;Td=Sd+16488|0;Ud=Td;Vd=+h[Ud>>3];Wd=Rd*Vd;Xd=Nd-Wd;pe[xd&3](366,303,Xd,1228,e);Yd=c[(e+8|0)>>2]|0;pe[Yd&3](367,14,1.0,1229,e);Zd=c[(e+8|0)>>2]|0;pe[Zd&3](367,15,-1.0,1230,e);_d=c[(e+8|0)>>2]|0;$d=c[(d+4|0)>>2]|0;ae=c[$d>>2]|0;be=ae;ce=be+8|0;de=ce;ee=c[de>>2]|0;fe=ee;ge=fe+15056|0;he=ge;ie=+h[he>>3];je=c[(d+416|0)>>2]|0;ke=je;le=ke+16016|0;me=le;ne=+h[me>>3];oe=ie*ne;qe=ee;re=qe+15040|0;se=re;te=+h[se>>3];ue=je;ve=ue+16008|0;we=ve;xe=+h[we>>3];ye=te*xe;ze=oe-ye;pe[_d&3](367,303,ze,1231,e);Ae=c[(e+8|0)>>2]|0;pe[Ae&3](368,13,1.0,1232,e);Be=c[(e+8|0)>>2]|0;pe[Be&3](368,17,-1.0,1233,e);Ce=c[(e+8|0)>>2]|0;De=c[(d+4|0)>>2]|0;Ee=c[De>>2]|0;Fe=Ee;Ge=Fe+8|0;He=Ge;Ie=c[He>>2]|0;Je=Ie;Ke=Je+16208|0;Le=Ke;Me=+h[Le>>3];Ne=c[(d+416|0)>>2]|0;Oe=Ne;Pe=Oe+13480|0;Qe=Pe;Re=+h[Qe>>3];Se=Me*Re;Te=Ie;Ue=Te+16232|0;Ve=Ue;We=+h[Ve>>3];Xe=Ne;Ye=Xe+13472|0;Ze=Ye;_e=+h[Ze>>3];$e=We*_e;af=Se-$e;pe[Ce&3](368,303,af,1234,e);bf=c[(e+8|0)>>2]|0;pe[bf&3](369,12,1.0,1235,e);cf=c[(e+8|0)>>2]|0;pe[cf&3](369,13,-1.0,1236,e);df=c[(e+8|0)>>2]|0;ef=c[(d+4|0)>>2]|0;ff=c[ef>>2]|0;gf=ff;hf=gf+8|0;jf=hf;kf=c[jf>>2]|0;lf=kf;mf=lf+15008|0;nf=mf;of=+h[nf>>3];pf=c[(d+416|0)>>2]|0;qf=pf;rf=qf+13e3|0;sf=rf;tf=+h[sf>>3];uf=of*tf;vf=kf;wf=vf+14992|0;xf=wf;yf=+h[xf>>3];zf=pf;Af=zf+12992|0;Bf=Af;Cf=+h[Bf>>3];Df=yf*Cf;Ef=uf-Df;pe[df&3](369,303,Ef,1237,e);Ff=c[(e+8|0)>>2]|0;pe[Ff&3](370,11,1.0,1238,e);Gf=c[(e+8|0)>>2]|0;pe[Gf&3](370,18,-1.0,1239,e);Hf=c[(e+8|0)>>2]|0;If=c[(d+4|0)>>2]|0;Jf=c[If>>2]|0;Kf=Jf;Lf=Kf+8|0;Mf=Lf;Nf=c[Mf>>2]|0;Of=Nf;Pf=Of+16208|0;Qf=Pf;Rf=+h[Qf>>3];Sf=c[(d+416|0)>>2]|0;Tf=Sf;Uf=Tf+10464|0;Vf=Uf;Wf=+h[Vf>>3];Xf=Rf*Wf;Yf=Nf;Zf=Yf+16232|0;_f=Zf;$f=+h[_f>>3];ag=Sf;bg=ag+10456|0;cg=bg;dg=+h[cg>>3];eg=$f*dg;fg=Xf-eg;pe[Hf&3](370,303,fg,1240,e);gg=c[(e+8|0)>>2]|0;pe[gg&3](371,10,1.0,1241,e);hg=c[(e+8|0)>>2]|0;pe[hg&3](371,11,-1.0,1242,e);ig=c[(e+8|0)>>2]|0;jg=c[(d+4|0)>>2]|0;kg=c[jg>>2]|0;lg=kg;mg=lg+8|0;ng=mg;og=c[ng>>2]|0;pg=og;qg=pg+14960|0;rg=qg;sg=+h[rg>>3];tg=c[(d+416|0)>>2]|0;ug=tg;vg=ug+9984|0;wg=vg;xg=+h[wg>>3];yg=sg*xg;zg=og;Ag=zg+14944|0;Bg=Ag;Cg=+h[Bg>>3];Dg=tg;Eg=Dg+9976|0;Fg=Eg;Gg=+h[Fg>>3];Hg=Cg*Gg;Ig=yg-Hg;pe[ig&3](371,303,Ig,1243,e);Jg=c[(e+8|0)>>2]|0;pe[Jg&3](372,9,1.0,1244,e);Kg=c[(e+8|0)>>2]|0;pe[Kg&3](372,19,-1.0,1245,e);Lg=c[(e+8|0)>>2]|0;Mg=c[(d+4|0)>>2]|0;Ng=c[Mg>>2]|0;Og=Ng;Pg=Og+8|0;Qg=Pg;Rg=c[Qg>>2]|0;Sg=Rg;Tg=Sg+16208|0;Ug=Tg;Vg=+h[Ug>>3];Wg=c[(d+416|0)>>2]|0;Xg=Wg;Yg=Xg+7448|0;Zg=Yg;_g=+h[Zg>>3];$g=Vg*_g;ah=Rg;bh=ah+16232|0;ch=bh;dh=+h[ch>>3];eh=Wg;fh=eh+7440|0;gh=fh;hh=+h[gh>>3];ih=dh*hh;jh=$g-ih;pe[Lg&3](372,303,jh,1246,e);kh=c[(e+8|0)>>2]|0;pe[kh&3](373,8,1.0,1247,e);lh=c[(e+8|0)>>2]|0;pe[lh&3](373,20,-1.0,1248,e);mh=c[(e+8|0)>>2]|0;nh=c[(d+4|0)>>2]|0;oh=c[nh>>2]|0;ph=oh;qh=ph+8|0;rh=qh;sh=c[rh>>2]|0;th=sh;uh=th+16208|0;vh=uh;wh=+h[vh>>3];xh=c[(d+416|0)>>2]|0;yh=xh;zh=yh+4432|0;Ah=zh;Bh=+h[Ah>>3];Ch=wh*Bh;Dh=sh;Eh=Dh+16232|0;Fh=Eh;Gh=+h[Fh>>3];Hh=xh;Ih=Hh+4424|0;Jh=Ih;Kh=+h[Jh>>3];Lh=Gh*Kh;Mh=Ch-Lh;pe[mh&3](373,303,Mh,1249,e);Nh=c[(e+8|0)>>2]|0;pe[Nh&3](374,7,1.0,1250,e);Oh=c[(e+8|0)>>2]|0;pe[Oh&3](374,8,-1.0,1251,e);Ph=c[(e+8|0)>>2]|0;Qh=c[(d+4|0)>>2]|0;Rh=c[Qh>>2]|0;Sh=Rh;Th=Sh+8|0;Uh=Th;Vh=c[Uh>>2]|0;Wh=Vh;Xh=Wh+14864|0;Yh=Xh;Zh=+h[Yh>>3];_h=c[(d+416|0)>>2]|0;$h=_h;ai=$h+3952|0;bi=ai;ci=+h[bi>>3];di=Zh*ci;ei=Vh;fi=ei+14848|0;gi=fi;hi=+h[gi>>3];ii=_h;ji=ii+3944|0;ki=ji;li=+h[ki>>3];mi=hi*li;ni=di-mi;pe[Ph&3](374,303,ni,1252,e);oi=c[(e+8|0)>>2]|0;pe[oi&3](375,6,1.0,1253,e);pi=c[(e+8|0)>>2]|0;pe[pi&3](375,21,-1.0,1254,e);qi=c[(e+8|0)>>2]|0;ri=c[(d+4|0)>>2]|0;si=c[ri>>2]|0;ti=si;ui=ti+8|0;vi=ui;wi=c[vi>>2]|0;xi=wi;yi=xi+16208|0;zi=yi;Ai=+h[zi>>3];Bi=c[(d+416|0)>>2]|0;Ci=Bi;Di=Ci+1416|0;Ei=Di;Fi=+h[Ei>>3];Gi=Ai*Fi;Hi=wi;Ii=Hi+16232|0;Ji=Ii;Ki=+h[Ji>>3];Li=Bi;Mi=Li+1408|0;Ni=Mi;Oi=+h[Ni>>3];Pi=Ki*Oi;Qi=Gi-Pi;pe[qi&3](375,303,Qi,1255,e);Ri=c[(e+8|0)>>2]|0;pe[Ri&3](376,5,1.0,1256,e);Si=c[(e+8|0)>>2]|0;pe[Si&3](376,6,-1.0,1257,e);Ti=c[(e+8|0)>>2]|0;Ui=c[(d+4|0)>>2]|0;Vi=c[Ui>>2]|0;Wi=Vi;Xi=Wi+8|0;Yi=Xi;Zi=c[Yi>>2]|0;_i=Zi;$i=_i+14816|0;aj=$i;bj=+h[aj>>3];cj=c[(d+416|0)>>2]|0;dj=cj;ej=dj+936|0;fj=ej;gj=+h[fj>>3];hj=bj*gj;ij=Zi;jj=ij+14800|0;kj=jj;lj=+h[kj>>3];mj=cj;nj=mj+928|0;oj=nj;pj=+h[oj>>3];qj=lj*pj;rj=hj-qj;pe[Ti&3](376,303,rj,1258,e);sj=c[(e+8|0)>>2]|0;pe[sj&3](377,4,1.0,1259,e);tj=c[(e+8|0)>>2]|0;uj=c[(d+416|0)>>2]|0;vj=uj;wj=vj+400|0;xj=wj;yj=+h[xj>>3];zj=uj;Aj=zj+19200|0;Bj=Aj;Cj=+h[Bj>>3];Dj=yj*Cj;pe[tj&3](377,303,Dj,1260,e);Ej=c[(e+8|0)>>2]|0;Fj=c[(d+416|0)>>2]|0;Gj=Fj;Hj=Gj+392|0;Ij=Hj;Jj=+h[Ij>>3];Kj=-Jj;pe[Ej&3](378,1,Kj,1261,e);Lj=c[(e+8|0)>>2]|0;pe[Lj&3](378,3,1.0,1262,e);Mj=c[(e+8|0)>>2]|0;Nj=c[(d+416|0)>>2]|0;Oj=Nj;Pj=Oj+400|0;Qj=Pj;Rj=+h[Qj>>3];pe[Mj&3](378,4,Rj,1263,e);Sj=c[(e+8|0)>>2]|0;pe[Sj&3](378,303,-.1,1264,e);Tj=c[(e+8|0)>>2]|0;pe[Tj&3](379,0,1.0,1265,e);Uj=c[(e+8|0)>>2]|0;pe[Uj&3](379,2,1.0,1266,e);Vj=c[(e+8|0)>>2]|0;pe[Vj&3](379,3,1.0,1267,e);Wj=c[(e+8|0)>>2]|0;pe[Wj&3](380,1,1.0,1268,e);Xj=c[(e+8|0)>>2]|0;Yj=c[(d+416|0)>>2]|0;Zj=Yj;_j=Zj+392|0;$j=_j;ak=+h[$j>>3];bk=Yj;ck=bk+19200|0;dk=ck;ek=+h[dk>>3];fk=ak*ek;gk=-fk;pe[Xj&3](380,303,gk,1269,e);hk=c[(e+8|0)>>2]|0;pe[hk&3](381,0,-1.0,1270,e);ik=c[(e+8|0)>>2]|0;jk=c[(d+416|0)>>2]|0;kk=jk;lk=kk+25488|0;mk=lk;nk=+h[mk>>3];pe[ik&3](381,303,nk,1271,e);i=b;c[b+11032>>2]=5;break a}while(0)}function _setLinearMatrixA1039$1(b){b=b|0;var d=0,e=0,f=0,g=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0;d=c[b+8>>2]|0;e=c[b+16>>2]|0;pe[c[(e+8|0)>>2]&3](247,134,1.0,826,e);pe[c[(e+8|0)>>2]&3](247,135,-1.0,827,e);b=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](247,303,+h[b+14872>>3]*+h[f+3952>>3]- +h[b+14856>>3]*+h[f+3944>>3],828,e);pe[c[(e+8|0)>>2]&3](248,7,-.4999999999999999,829,e);pe[c[(e+8|0)>>2]&3](248,133,-1.0,830,e);pe[c[(e+8|0)>>2]&3](248,134,-.8660254037844387,831,e);pe[c[(e+8|0)>>2]&3](249,132,1.0,832,e);pe[c[(e+8|0)>>2]&3](249,133,2.0,833,e);pe[c[(e+8|0)>>2]&3](250,131,1.0,834,e);pe[c[(e+8|0)>>2]&3](250,132,-.5,835,e);pe[c[(e+8|0)>>2]&3](251,81,-((a[(c[(d+424|0)>>2]|0)+83|0]|0)!=0?1.0:-1.0),836,e);pe[c[(e+8|0)>>2]&3](251,130,-1.0,837,e);pe[c[(e+8|0)>>2]&3](251,131,1.0,838,e);pe[c[(e+8|0)>>2]&3](252,129,1.0,839,e);pe[c[(e+8|0)>>2]&3](252,130,-.8660254037844387,840,e);pe[c[(e+8|0)>>2]&3](253,128,1.0,841,e);pe[c[(e+8|0)>>2]&3](253,129,-1.0,842,e);pe[c[(e+8|0)>>2]&3](253,134,1.0,843,e);f=c[(e+8|0)>>2]|0;g=+h[(c[(d+416|0)>>2]|0)+20848>>3];b=c[c[(d+4|0)>>2]>>2]|0;i=+h[(c[b+8>>2]|0)+14864>>3];do{if(g!=0.0){j=-i/g}else{if(i==-0.0){j=-i;break}j=-i/+$Lb(c[d+536>>2]|0,g,1e4,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](254,84,j,844,e);pe[c[(e+8|0)>>2]&3](254,127,1.0,845,e);f=c[(e+8|0)>>2]|0;j=+h[(c[(d+416|0)>>2]|0)+20848>>3];b=c[c[(d+4|0)>>2]>>2]|0;g=+h[(c[b+8>>2]|0)+14872>>3];do{if(j!=0.0){k=-g/j}else{if(g==-0.0){k=-g;break}k=-g/+$Lb(c[d+536>>2]|0,j,1e4,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](254,128,k,846,e);f=c[(e+8|0)>>2]|0;k=+h[(c[(d+416|0)>>2]|0)+20848>>3];b=c[c[(d+4|0)>>2]>>2]|0;j=+h[(c[b+8>>2]|0)+2840>>3];do{if(k!=0.0){l=-j/k}else{if(j==-0.0){l=-j;break}l=-j/+$Lb(c[d+536>>2]|0,k,1e4,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](254,303,l,847,e);f=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;m=c[b+8>>2]|0;l=+h[m+20240>>3];k=+h[m+2880>>3];do{if(l!=0.0){n=k/l}else{if(k==0.0){n=k;break}n=k/+$Lb(c[d+536>>2]|0,l,10056,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](255,87,n,848,e);pe[c[(e+8|0)>>2]&3](255,126,1.0,849,e);f=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;m=c[b+8>>2]|0;n=+h[m+20240>>3];l=+h[m+2872>>3];do{if(n!=0.0){o=-l/n}else{if(l==-0.0){o=-l;break}o=-l/+$Lb(c[d+536>>2]|0,n,10056,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](255,127,o,850,e);pe[c[(e+8|0)>>2]&3](256,125,1.0,851,e);pe[c[(e+8|0)>>2]&3](256,126,-1.0,852,e);pe[c[(e+8|0)>>2]&3](256,303,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7160>>3],853,e);pe[c[(e+8|0)>>2]&3](257,7,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7152>>3]*+h[(c[(d+416|0)>>2]|0)+21064>>3]),854,e);f=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](257,91,+h[f+5792>>3]*+h[f+21064>>3],855,e);pe[c[(e+8|0)>>2]&3](257,124,-1.0,856,e);f=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](257,125,-(+h[f+5800>>3]*+h[f+21064>>3]),857,e);pe[c[(e+8|0)>>2]&3](257,134,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7144>>3]*+h[(c[(d+416|0)>>2]|0)+21064>>3]),858,e);pe[c[(e+8|0)>>2]&3](258,90,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7160>>3],859,e);pe[c[(e+8|0)>>2]&3](258,123,1.0,860,e);pe[c[(e+8|0)>>2]&3](258,124,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7136>>3],861,e);pe[c[(e+8|0)>>2]&3](259,113,-1.0,862,e);pe[c[(e+8|0)>>2]&3](259,122,-1.0,863,e);pe[c[(e+8|0)>>2]&3](259,123,-1.0,864,e);pe[c[(e+8|0)>>2]&3](260,101,-+h[(c[(d+416|0)>>2]|0)+3936>>3],865,e);pe[c[(e+8|0)>>2]&3](260,112,1.0,866,e);pe[c[(e+8|0)>>2]&3](260,121,-1.0,867,e);pe[c[(e+8|0)>>2]&3](260,122,+h[(c[(d+416|0)>>2]|0)+3952>>3],868,e);pe[c[(e+8|0)>>2]&3](261,105,1.0,869,e);pe[c[(e+8|0)>>2]&3](261,106,-+h[(c[(d+416|0)>>2]|0)+4432>>3],870,e);pe[c[(e+8|0)>>2]&3](261,107,+h[(c[(d+416|0)>>2]|0)+4424>>3],871,e);pe[c[(e+8|0)>>2]&3](261,118,-1.0,872,e);pe[c[(e+8|0)>>2]&3](262,107,-+h[(c[(d+416|0)>>2]|0)+4416>>3],873,e);pe[c[(e+8|0)>>2]&3](262,117,-1.0,874,e);pe[c[(e+8|0)>>2]&3](262,119,-1.0,875,e);pe[c[(e+8|0)>>2]&3](262,121,6.123233995736766e-17,876,e);pe[c[(e+8|0)>>2]&3](262,122,+h[(c[(d+416|0)>>2]|0)+4432>>3],877,e);pe[c[(e+8|0)>>2]&3](263,106,+h[(c[(d+416|0)>>2]|0)+4416>>3],878,e);pe[c[(e+8|0)>>2]&3](263,117,6.123233995736766e-17,879,e);pe[c[(e+8|0)>>2]&3](263,120,-1.0,880,e);pe[c[(e+8|0)>>2]&3](263,121,1.0,881,e);pe[c[(e+8|0)>>2]&3](263,122,-+h[(c[(d+416|0)>>2]|0)+4424>>3],882,e);pe[c[(e+8|0)>>2]&3](264,108,+h[(c[(d+416|0)>>2]|0)+3936>>3],883,e);pe[c[(e+8|0)>>2]&3](264,111,1.0,884,e);pe[c[(e+8|0)>>2]&3](264,117,-1.0,885,e);pe[c[(e+8|0)>>2]&3](264,122,-+h[(c[(d+416|0)>>2]|0)+3944>>3],886,e);pe[c[(e+8|0)>>2]&3](265,90,+h[(c[(d+416|0)>>2]|0)+5784>>3],887,e);pe[c[(e+8|0)>>2]&3](265,91,-.006,888,e);pe[c[(e+8|0)>>2]&3](265,116,-1.0,889,e);pe[c[(e+8|0)>>2]&3](265,124,-+h[(c[(d+416|0)>>2]|0)+5792>>3],890,e);pe[c[(e+8|0)>>2]&3](266,93,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2880>>3],891,e);pe[c[(e+8|0)>>2]&3](266,96,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2960>>3],892,e);pe[c[(e+8|0)>>2]&3](266,115,1.0,893,e);pe[c[(e+8|0)>>2]&3](266,116,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15936>>3],894,e);f=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;m=c[b+8>>2]|0;o=+h[m+7136>>3];n=+h[(c[(d+416|0)>>2]|0)+20848>>3];l=+h[m+15944>>3];do{if(n!=0.0){p=l/n}else{if(l==0.0){p=l;break}p=l/+$Lb(c[d+536>>2]|0,n,1e4,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](267,99,-(o*p),895,e);pe[c[(e+8|0)>>2]&3](267,114,1.0,896,e);f=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;m=c[b+8>>2]|0;p=+h[m+7136>>3];o=+h[(c[(d+416|0)>>2]|0)+20848>>3];n=+h[m+15936>>3];do{if(o!=0.0){q=n/o}else{if(n==0.0){q=n;break}q=n/+$Lb(c[d+536>>2]|0,o,1e4,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](267,115,-(p*q),897,e);pe[c[(e+8|0)>>2]&3](268,103,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7160>>3],898,e);pe[c[(e+8|0)>>2]&3](268,113,1.0,899,e);pe[c[(e+8|0)>>2]&3](268,114,-1.0,900,e);pe[c[(e+8|0)>>2]&3](269,102,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9776>>3],901,e);pe[c[(e+8|0)>>2]&3](269,112,-1.0,902,e);pe[c[(e+8|0)>>2]&3](269,113,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2840>>3],903,e);pe[c[(e+8|0)>>2]&3](269,115,-1.0,904,e);pe[c[(e+8|0)>>2]&3](270,99,-1.0,905,e);pe[c[(e+8|0)>>2]&3](270,109,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9776>>3],906,e);pe[c[(e+8|0)>>2]&3](270,111,-1.0,907,e);pe[c[(e+8|0)>>2]&3](270,113,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2848>>3],908,e);f=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;m=c[b+8>>2]|0;q=+h[(c[(d+416|0)>>2]|0)+20848>>3]*+h[m+7136>>3];p=+h[m+15936>>3];do{if(q!=0.0){r=p/q}else{if(p==0.0){r=p;break}r=p/+$Lb(c[d+536>>2]|0,q,10112,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](271,95,r,909,e);f=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;m=c[b+8>>2]|0;r=+h[m+2880>>3];q=+h[(c[(d+416|0)>>2]|0)+20848>>3];p=+h[m+15944>>3];do{if(q!=0.0){s=p/q}else{if(p==0.0){s=p;break}s=p/+$Lb(c[d+536>>2]|0,q,1e4,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](271,99,-(r*s),910,e);pe[c[(e+8|0)>>2]&3](271,110,1.0,911,e);f=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;m=c[b+8>>2]|0;s=+h[m+2880>>3];r=+h[(c[(d+416|0)>>2]|0)+20848>>3];q=+h[m+15936>>3];do{if(r!=0.0){t=q/r}else{if(q==0.0){t=q;break}t=q/+$Lb(c[d+536>>2]|0,r,1e4,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](271,115,-(s*t),912,e);pe[c[(e+8|0)>>2]&3](272,103,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2960>>3],913,e);pe[c[(e+8|0)>>2]&3](272,109,1.0,914,e);pe[c[(e+8|0)>>2]&3](272,110,-1.0,915,e);pe[c[(e+8|0)>>2]&3](273,98,-1.0,916,e);pe[c[(e+8|0)>>2]&3](273,108,-1.0,917,e);pe[c[(e+8|0)>>2]&3](273,109,-1.0,918,e);pe[c[(e+8|0)>>2]&3](274,101,-6.123233995736766e-17,919,e);pe[c[(e+8|0)>>2]&3](274,107,1.0,920,e);pe[c[(e+8|0)>>2]&3](274,108,-1.0,921,e);pe[c[(e+8|0)>>2]&3](275,101,1.0,922,e);pe[c[(e+8|0)>>2]&3](275,106,1.0,923,e);pe[c[(e+8|0)>>2]&3](275,108,-6.123233995736766e-17,924,e);pe[c[(e+8|0)>>2]&3](276,101,+h[(c[(d+416|0)>>2]|0)+3944>>3],925,e);pe[c[(e+8|0)>>2]&3](276,104,1.0,926,e);pe[c[(e+8|0)>>2]&3](276,105,-1.0,927,e);pe[c[(e+8|0)>>2]&3](276,108,-+h[(c[(d+416|0)>>2]|0)+3952>>3],928,e);pe[c[(e+8|0)>>2]&3](277,95,-1.0,929,e);pe[c[(e+8|0)>>2]&3](277,102,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2848>>3],930,e);pe[c[(e+8|0)>>2]&3](277,104,-1.0,931,e);pe[c[(e+8|0)>>2]&3](277,109,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2840>>3],932,e);f=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20304>>3])),1.0e-10)|0;b=c[(e+8|0)>>2]|0;do{if(f<<24>>24==0){m=c[c[(d+4|0)>>2]>>2]|0;t=+h[(c[m+8>>2]|0)+20304>>3];if(t!=0.0){u=t;break}u=+$Lb(c[d+536>>2]|0,t,10208,8456,+h[m>>3],(a[d+319|0]|0)!=0|0)}else{u=1.0e-10}}while(0);pe[b&3](278,86,1.0/u,933,e);b=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20304>>3])),1.0e-10)|0;f=c[(e+8|0)>>2]|0;m=c[c[(d+4|0)>>2]>>2]|0;v=c[m+8>>2]|0;if(b<<24>>24!=0){w=1}else{w=+h[v+20304>>3]!=0.0}u=+h[v+14856>>3]*.8660254037844387+ +h[v+14848>>3]*.4999999999999999;do{if(w){if(b<<24>>24!=0){x=1.0e-10}else{x=+h[v+20304>>3]}y=u/x}else{if(u==0.0){y=u;break}if(b<<24>>24!=0){z=1.0e-10}else{z=+h[v+20304>>3]}y=u/+$Lb(c[d+536>>2]|0,z,10208,8456,+h[m>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](278,100,y,934,e);pe[c[(e+8|0)>>2]&3](278,103,1.0,935,e);f=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20304>>3])),1.0e-10)|0;m=c[(e+8|0)>>2]|0;v=c[c[(d+4|0)>>2]>>2]|0;b=c[v+8>>2]|0;if(f<<24>>24!=0){A=1}else{A=+h[b+20304>>3]!=0.0}y=+h[b+14872>>3]*.8660254037844387+ +h[b+14864>>3]*.4999999999999999;do{if(A){if(f<<24>>24!=0){B=1.0e-10}else{B=+h[b+20304>>3]}C=y/B}else{if(y==0.0){C=y;break}if(f<<24>>24!=0){D=1.0e-10}else{D=+h[b+20304>>3]}C=y/+$Lb(c[d+536>>2]|0,D,10208,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](278,110,C,936,e);pe[c[(e+8|0)>>2]&3](279,100,-1.0,937,e);pe[c[(e+8|0)>>2]&3](279,102,1.0,938,e);pe[c[(e+8|0)>>2]&3](279,103,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2952>>3],939,e);pe[c[(e+8|0)>>2]&3](280,97,-1.0,940,e);pe[c[(e+8|0)>>2]&3](280,101,-1.0,941,e);pe[c[(e+8|0)>>2]&3](280,102,-1.0,942,e);m=c[(e+8|0)>>2]|0;v=c[c[(d+4|0)>>2]>>2]|0;b=c[v+8>>2]|0;C=+h[(c[(d+416|0)>>2]|0)+20848>>3]*+h[b+7136>>3];D=+h[b+15944>>3];do{if(C!=0.0){E=D/C}else{if(D==0.0){E=D;break}E=D/+$Lb(c[d+536>>2]|0,C,10112,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](281,95,E,943,e);m=c[(e+8|0)>>2]|0;v=c[c[(d+4|0)>>2]>>2]|0;b=c[v+8>>2]|0;E=+h[b+2872>>3];C=+h[(c[(d+416|0)>>2]|0)+20848>>3];D=+h[b+15944>>3];do{if(C!=0.0){F=D/C}else{if(D==0.0){F=D;break}F=D/+$Lb(c[d+536>>2]|0,C,1e4,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](281,99,-(E*F),944,e);pe[c[(e+8|0)>>2]&3](281,100,1.0,945,e);m=c[(e+8|0)>>2]|0;v=c[c[(d+4|0)>>2]>>2]|0;b=c[v+8>>2]|0;F=+h[b+2872>>3];E=+h[(c[(d+416|0)>>2]|0)+20848>>3];C=+h[b+15936>>3];do{if(E!=0.0){G=C/E}else{if(C==0.0){G=C;break}G=C/+$Lb(c[d+536>>2]|0,E,1e4,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](281,115,-(F*G),946,e);pe[c[(e+8|0)>>2]&3](282,93,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2872>>3],947,e);pe[c[(e+8|0)>>2]&3](282,96,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2952>>3],948,e);pe[c[(e+8|0)>>2]&3](282,99,1.0,949,e);pe[c[(e+8|0)>>2]&3](282,116,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15944>>3],950,e);pe[c[(e+8|0)>>2]&3](283,90,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2960>>3],951,e);pe[c[(e+8|0)>>2]&3](283,94,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15936>>3],952,e);pe[c[(e+8|0)>>2]&3](283,98,1.0,953,e);pe[c[(e+8|0)>>2]&3](283,124,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2880>>3],954,e);pe[c[(e+8|0)>>2]&3](284,90,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2952>>3],955,e);pe[c[(e+8|0)>>2]&3](284,94,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15944>>3],956,e);pe[c[(e+8|0)>>2]&3](284,97,1.0,957,e);pe[c[(e+8|0)>>2]&3](284,124,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2872>>3],958,e);pe[c[(e+8|0)>>2]&3](285,94,-+h[(c[(d+416|0)>>2]|0)+5784>>3],959,e);pe[c[(e+8|0)>>2]&3](285,96,-1.0,960,e);pe[c[(e+8|0)>>2]&3](285,124,+h[(c[(d+416|0)>>2]|0)+5800>>3],961,e);pe[c[(e+8|0)>>2]&3](285,125,-5.0e-4,962,e);pe[c[(e+8|0)>>2]&3](286,93,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7136>>3],963,e);pe[c[(e+8|0)>>2]&3](286,95,1.0,964,e);pe[c[(e+8|0)>>2]&3](286,96,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7160>>3],965,e);pe[c[(e+8|0)>>2]&3](287,7,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7200>>3]*+h[(c[(d+416|0)>>2]|0)+21064>>3]),966,e);m=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](287,88,-(+h[m+5792>>3]*+h[m+21064>>3]),967,e);pe[c[(e+8|0)>>2]&3](287,94,-1.0,968,e);m=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](287,125,+h[m+5784>>3]*+h[m+21064>>3],969,e);pe[c[(e+8|0)>>2]&3](287,134,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7192>>3]*+h[(c[(d+416|0)>>2]|0)+21064>>3]),970,e);pe[c[(e+8|0)>>2]&3](288,88,-.006,971,e);pe[c[(e+8|0)>>2]&3](288,90,-+h[(c[(d+416|0)>>2]|0)+5800>>3],972,e);pe[c[(e+8|0)>>2]&3](288,93,-1.0,973,e);pe[c[(e+8|0)>>2]&3](288,94,+h[(c[(d+416|0)>>2]|0)+5792>>3],974,e);pe[c[(e+8|0)>>2]&3](289,87,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2872>>3],975,e);pe[c[(e+8|0)>>2]&3](289,92,1.0,976,e);pe[c[(e+8|0)>>2]&3](289,127,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2880>>3],977,e);pe[c[(e+8|0)>>2]&3](290,91,1.0,978,e);pe[c[(e+8|0)>>2]&3](290,92,-1.0,979,e);pe[c[(e+8|0)>>2]&3](291,7,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7176>>3]*+h[(c[(d+416|0)>>2]|0)+21064>>3]),980,e);m=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](291,88,+h[m+5800>>3]*+h[m+21064>>3],981,e);pe[c[(e+8|0)>>2]&3](291,90,-1.0,982,e);m=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](291,91,-(+h[m+5784>>3]*+h[m+21064>>3]),983,e);pe[c[(e+8|0)>>2]&3](291,134,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7168>>3]*+h[(c[(d+416|0)>>2]|0)+21064>>3]),984,e);pe[c[(e+8|0)>>2]&3](292,87,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15944>>3],985,e);pe[c[(e+8|0)>>2]&3](292,89,1.0,986,e);pe[c[(e+8|0)>>2]&3](292,127,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15936>>3],987,e);pe[c[(e+8|0)>>2]&3](293,88,1.0,988,e);pe[c[(e+8|0)>>2]&3](293,89,-1.0,989,e);pe[c[(e+8|0)>>2]&3](293,303,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7136>>3],990,e);m=c[(e+8|0)>>2]|0;G=+h[(c[(d+416|0)>>2]|0)+20848>>3];v=c[c[(d+4|0)>>2]>>2]|0;F=+h[(c[v+8>>2]|0)+14848>>3];do{if(G!=0.0){H=-F/G}else{if(F==-0.0){H=-F;break}H=-F/+$Lb(c[d+536>>2]|0,G,1e4,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](294,84,H,991,e);pe[c[(e+8|0)>>2]&3](294,87,1.0,992,e);m=c[(e+8|0)>>2]|0;H=+h[(c[(d+416|0)>>2]|0)+20848>>3];v=c[c[(d+4|0)>>2]>>2]|0;G=+h[(c[v+8>>2]|0)+14856>>3];do{if(H!=0.0){I=-G/H}else{if(G==-0.0){I=-G;break}I=-G/+$Lb(c[d+536>>2]|0,H,1e4,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](294,128,I,993,e);m=c[(e+8|0)>>2]|0;I=+h[(c[(d+416|0)>>2]|0)+20848>>3];v=c[c[(d+4|0)>>2]>>2]|0;H=+h[(c[v+8>>2]|0)+2848>>3];do{if(I!=0.0){J=H/I}else{if(H==0.0){J=H;break}J=H/+$Lb(c[d+536>>2]|0,I,1e4,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](294,303,J,994,e);pe[c[(e+8|0)>>2]&3](295,85,+h[(c[(d+416|0)>>2]|0)+21264>>3]*-.4999999999999999,995,e);pe[c[(e+8|0)>>2]&3](295,86,1.0,996,e);pe[c[(e+8|0)>>2]&3](295,129,+h[(c[(d+416|0)>>2]|0)+21264>>3]*-.8660254037844387,997,e);pe[c[(e+8|0)>>2]&3](296,85,1.0,998,e);pe[c[(e+8|0)>>2]&3](296,130,-.4999999999999999,999,e);pe[c[(e+8|0)>>2]&3](297,7,1.0,1e3,e);pe[c[(e+8|0)>>2]&3](297,84,1.0,1001,e);pe[c[(e+8|0)>>2]&3](297,85,-1.0,1002,e);pe[c[(e+8|0)>>2]&3](298,80,1.0,1003,e);pe[c[(e+8|0)>>2]&3](298,83,1.0,1004,e);pe[c[(e+8|0)>>2]&3](298,131,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20280>>3]*-2.0,1005,e);pe[c[(e+8|0)>>2]&3](299,82,1.0,1006,e);m=$Ob(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20264>>3],1.0e-12)|0;pe[c[(e+8|0)>>2]&3](299,83,-(m<<24>>24!=0?1.0:0.0),1007,e);pe[c[(e+8|0)>>2]&3](300,81,1.0,1008,e);m=c[(e+8|0)>>2]|0;v=c[c[(d+4|0)>>2]>>2]|0;J=+V(+(+h[(c[v+8>>2]|0)+20256>>3]));if(J!=0.0){K=J}else{K=+$Lb(c[d+536>>2]|0,J,10328,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}pe[m&3](300,82,-.5/K,1009,e);pe[c[(e+8|0)>>2]&3](301,79,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9816>>3]*-2.0,1010,e);pe[c[(e+8|0)>>2]&3](301,80,1.0,1011,e);pe[c[(e+8|0)>>2]&3](301,133,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9808>>3]*-2.0,1012,e);pe[c[(e+8|0)>>2]&3](302,7,-.8660254037844387,1013,e);pe[c[(e+8|0)>>2]&3](302,79,-1.0,1014,e);pe[c[(e+8|0)>>2]&3](302,134,.4999999999999999,1015,e);pe[c[(e+8|0)>>2]&3](303,78,1.0,1016,e);pe[c[(e+8|0)>>2]&3](303,302,-1.0,1017,e);m=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;v=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](303,303,+h[m+16200>>3]*+h[v+1416>>3]- +h[m+16224>>3]*+h[v+1408>>3],1018,e);pe[c[(e+8|0)>>2]&3](304,77,1.0,1019,e);pe[c[(e+8|0)>>2]&3](304,78,-1.0,1020,e);v=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;m=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](304,303,+h[v+14824>>3]*+h[m+936>>3]- +h[v+14808>>3]*+h[m+928>>3],1021,e);pe[c[(e+8|0)>>2]&3](305,5,.4999999999999999,1022,e);pe[c[(e+8|0)>>2]&3](305,76,-1.0,1023,e);pe[c[(e+8|0)>>2]&3](305,77,-.8660254037844387,1024,e);pe[c[(e+8|0)>>2]&3](306,75,1.0,1025,e);pe[c[(e+8|0)>>2]&3](306,76,2.0,1026,e);pe[c[(e+8|0)>>2]&3](307,74,1.0,1027,e);pe[c[(e+8|0)>>2]&3](307,75,-.5,1028,e);pe[c[(e+8|0)>>2]&3](308,24,-((a[(c[(d+424|0)>>2]|0)+35|0]|0)!=0?1.0:-1.0),1029,e);pe[c[(e+8|0)>>2]&3](308,73,-1.0,1030,e);pe[c[(e+8|0)>>2]&3](308,74,1.0,1031,e);pe[c[(e+8|0)>>2]&3](309,72,1.0,1032,e);pe[c[(e+8|0)>>2]&3](309,73,-.8660254037844387,1033,e);pe[c[(e+8|0)>>2]&3](310,71,1.0,1034,e);pe[c[(e+8|0)>>2]&3](310,72,-1.0,1035,e);pe[c[(e+8|0)>>2]&3](310,77,1.0,1036,e);m=c[(e+8|0)>>2]|0;K=+h[(c[(d+416|0)>>2]|0)+19816>>3];v=c[c[(d+4|0)>>2]>>2]|0;J=+h[(c[v+8>>2]|0)+14816>>3];do{if(K!=0.0){L=-J/K}else{if(J==-0.0){L=-J;break}L=-J/+$Lb(c[d+536>>2]|0,K,10384,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](311,27,L,1037,e);pe[c[(e+8|0)>>2]&3](311,70,1.0,1038,e);m=c[(e+8|0)>>2]|0;L=+h[(c[(d+416|0)>>2]|0)+19816>>3];v=c[c[(d+4|0)>>2]>>2]|0;K=+h[(c[v+8>>2]|0)+14824>>3];do{if(L!=0.0){M=-K/L}else{if(K==-0.0){M=-K;break}M=-K/+$Lb(c[d+536>>2]|0,L,10384,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](311,71,M,1039,e);m=c[(e+8|0)>>2]|0;M=+h[(c[(d+416|0)>>2]|0)+19816>>3];v=c[c[(d+4|0)>>2]>>2]|0;L=+h[(c[v+8>>2]|0)+3560>>3];do{if(M!=0.0){N=-L/M}else{if(L==-0.0){N=-L;break}N=-L/+$Lb(c[d+536>>2]|0,M,10384,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](311,303,N,1040,e);m=c[(e+8|0)>>2]|0;v=c[c[(d+4|0)>>2]>>2]|0;b=c[v+8>>2]|0;N=+h[b+20400>>3];M=+h[b+3600>>3];do{if(N!=0.0){O=M/N}else{if(M==0.0){O=M;break}O=M/+$Lb(c[d+536>>2]|0,N,10440,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](312,30,O,1041,e);pe[c[(e+8|0)>>2]&3](312,69,1.0,1042,e);m=c[(e+8|0)>>2]|0;v=c[c[(d+4|0)>>2]>>2]|0;b=c[v+8>>2]|0;O=+h[b+20400>>3];N=+h[b+3592>>3];do{if(O!=0.0){P=-N/O}else{if(N==-0.0){P=-N;break}P=-N/+$Lb(c[d+536>>2]|0,O,10440,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](312,70,P,1043,e);pe[c[(e+8|0)>>2]&3](313,68,1.0,1044,e);pe[c[(e+8|0)>>2]&3](313,69,-1.0,1045,e);pe[c[(e+8|0)>>2]&3](313,303,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6976>>3],1046,e);pe[c[(e+8|0)>>2]&3](314,5,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6968>>3]*+h[(c[(d+416|0)>>2]|0)+20032>>3]),1047,e);m=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](314,34,+h[m+2776>>3]*+h[m+20032>>3],1048,e);pe[c[(e+8|0)>>2]&3](314,67,-1.0,1049,e);m=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](314,68,-(+h[m+2784>>3]*+h[m+20032>>3]),1050,e);pe[c[(e+8|0)>>2]&3](314,77,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6960>>3]*+h[(c[(d+416|0)>>2]|0)+20032>>3]),1051,e);pe[c[(e+8|0)>>2]&3](315,33,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6976>>3],1052,e);pe[c[(e+8|0)>>2]&3](315,66,1.0,1053,e);pe[c[(e+8|0)>>2]&3](315,67,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6952>>3],1054,e);pe[c[(e+8|0)>>2]&3](316,56,-1.0,1055,e);pe[c[(e+8|0)>>2]&3](316,65,-1.0,1056,e);pe[c[(e+8|0)>>2]&3](316,66,-1.0,1057,e);pe[c[(e+8|0)>>2]&3](317,44,-+h[(c[(d+416|0)>>2]|0)+920>>3],1058,e);pe[c[(e+8|0)>>2]&3](317,55,1.0,1059,e);pe[c[(e+8|0)>>2]&3](317,64,-1.0,1060,e);pe[c[(e+8|0)>>2]&3](317,65,+h[(c[(d+416|0)>>2]|0)+936>>3],1061,e);pe[c[(e+8|0)>>2]&3](318,48,1.0,1062,e);pe[c[(e+8|0)>>2]&3](318,49,-+h[(c[(d+416|0)>>2]|0)+1416>>3],1063,e);pe[c[(e+8|0)>>2]&3](318,50,+h[(c[(d+416|0)>>2]|0)+1408>>3],1064,e);pe[c[(e+8|0)>>2]&3](318,62,-1.0,1065,e);pe[c[(e+8|0)>>2]&3](319,50,-+h[(c[(d+416|0)>>2]|0)+1400>>3],1066,e);pe[c[(e+8|0)>>2]&3](319,60,.4999999999999999,1067,e);pe[c[(e+8|0)>>2]&3](319,63,-1.0,1068,e);pe[c[(e+8|0)>>2]&3](319,64,.8660254037844387,1069,e);pe[c[(e+8|0)>>2]&3](319,65,+h[(c[(d+416|0)>>2]|0)+1416>>3],1070,e);pe[c[(e+8|0)>>2]&3](320,49,+h[(c[(d+416|0)>>2]|0)+1400>>3],1071,e);pe[c[(e+8|0)>>2]&3](320,60,.8660254037844387,1072,e);pe[c[(e+8|0)>>2]&3](320,61,-1.0,1073,e);pe[c[(e+8|0)>>2]&3](320,64,-.4999999999999999,1074,e);pe[c[(e+8|0)>>2]&3](320,65,-+h[(c[(d+416|0)>>2]|0)+1408>>3],1075,e);pe[c[(e+8|0)>>2]&3](321,51,+h[(c[(d+416|0)>>2]|0)+920>>3],1076,e);pe[c[(e+8|0)>>2]&3](321,54,1.0,1077,e);pe[c[(e+8|0)>>2]&3](321,60,-1.0,1078,e);pe[c[(e+8|0)>>2]&3](321,65,-+h[(c[(d+416|0)>>2]|0)+928>>3],1079,e);pe[c[(e+8|0)>>2]&3](322,33,+h[(c[(d+416|0)>>2]|0)+2768>>3],1080,e);pe[c[(e+8|0)>>2]&3](322,34,-.006,1081,e);pe[c[(e+8|0)>>2]&3](322,59,-1.0,1082,e);pe[c[(e+8|0)>>2]&3](322,67,-+h[(c[(d+416|0)>>2]|0)+2776>>3],1083,e);pe[c[(e+8|0)>>2]&3](323,36,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3600>>3],1084,e);pe[c[(e+8|0)>>2]&3](323,39,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3680>>3],1085,e);pe[c[(e+8|0)>>2]&3](323,58,1.0,1086,e);pe[c[(e+8|0)>>2]&3](323,59,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+16032>>3],1087,e);m=c[(e+8|0)>>2]|0;v=c[c[(d+4|0)>>2]>>2]|0;b=c[v+8>>2]|0;P=+h[b+6952>>3];O=+h[(c[(d+416|0)>>2]|0)+19816>>3];N=+h[b+16040>>3];do{if(O!=0.0){Q=N/O}else{if(N==0.0){Q=N;break}Q=N/+$Lb(c[d+536>>2]|0,O,10384,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](324,42,-(P*Q),1088,e);pe[c[(e+8|0)>>2]&3](324,57,1.0,1089,e);m=c[(e+8|0)>>2]|0;v=c[c[(d+4|0)>>2]>>2]|0;b=c[v+8>>2]|0;Q=+h[b+6952>>3];P=+h[(c[(d+416|0)>>2]|0)+19816>>3];O=+h[b+16032>>3];do{if(P!=0.0){R=O/P}else{if(O==0.0){R=O;break}R=O/+$Lb(c[d+536>>2]|0,P,10384,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](324,58,-(Q*R),1090,e);pe[c[(e+8|0)>>2]&3](325,46,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6976>>3],1091,e);pe[c[(e+8|0)>>2]&3](325,56,1.0,1092,e);pe[c[(e+8|0)>>2]&3](325,57,-1.0,1093,e);pe[c[(e+8|0)>>2]&3](326,45,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9656>>3],1094,e);pe[c[(e+8|0)>>2]&3](326,55,-1.0,1095,e);pe[c[(e+8|0)>>2]&3](326,56,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3560>>3],1096,e);pe[c[(e+8|0)>>2]&3](326,58,-1.0,1097,e);pe[c[(e+8|0)>>2]&3](327,42,-1.0,1098,e);pe[c[(e+8|0)>>2]&3](327,52,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9656>>3],1099,e);pe[c[(e+8|0)>>2]&3](327,54,-1.0,1100,e);pe[c[(e+8|0)>>2]&3](327,56,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3568>>3],1101,e);m=c[(e+8|0)>>2]|0;v=c[c[(d+4|0)>>2]>>2]|0;b=c[v+8>>2]|0;R=+h[(c[(d+416|0)>>2]|0)+19816>>3]*+h[b+6952>>3];Q=+h[b+16032>>3];do{if(R!=0.0){S=Q/R}else{if(Q==0.0){S=Q;break}S=Q/+$Lb(c[d+536>>2]|0,R,10496,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](328,38,S,1102,e);m=c[(e+8|0)>>2]|0;v=c[c[(d+4|0)>>2]>>2]|0;b=c[v+8>>2]|0;S=+h[b+3600>>3];R=+h[(c[(d+416|0)>>2]|0)+19816>>3];Q=+h[b+16040>>3];do{if(R!=0.0){T=Q/R}else{if(Q==0.0){T=Q;break}T=Q/+$Lb(c[d+536>>2]|0,R,10384,8456,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](328,42,-(S*T),1103,e);pe[c[(e+8|0)>>2]&3](328,53,1.0,1104,e)}function _setLinearMatrixA1039$2(b){b=b|0;var d=0,e=0,f=0,i=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0;d=c[b+8>>2]|0;e=c[b+16>>2]|0;f=c[b+2304>>2]|0;i=c[b+2312>>2]|0;j=c[b+2320>>2]|0;k=+g[b+2328>>2];l=+h[(c[(d+416|0)>>2]|0)+23944>>3];m=+h[j+15656>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+$Lb(c[d+536>>2]|0,l,9232,8456,+h[i>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](164,216,-(k*n),549,e);pe[c[(e+8|0)>>2]&3](164,217,1.0,550,e);f=c[(e+8|0)>>2]|0;i=c[c[(d+4|0)>>2]>>2]|0;j=c[i+8>>2]|0;n=+h[j+712>>3];k=+h[(c[(d+416|0)>>2]|0)+23944>>3];l=+h[j+15648>>3];do{if(k!=0.0){o=l/k}else{if(l==0.0){o=l;break}o=l/+$Lb(c[d+536>>2]|0,k,9232,8456,+h[i>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](164,232,-(n*o),551,e);pe[c[(e+8|0)>>2]&3](165,210,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+712>>3],552,e);pe[c[(e+8|0)>>2]&3](165,213,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+792>>3],553,e);pe[c[(e+8|0)>>2]&3](165,216,1.0,554,e);pe[c[(e+8|0)>>2]&3](165,233,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15656>>3],555,e);pe[c[(e+8|0)>>2]&3](166,207,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+800>>3],556,e);pe[c[(e+8|0)>>2]&3](166,211,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15648>>3],557,e);pe[c[(e+8|0)>>2]&3](166,215,1.0,558,e);pe[c[(e+8|0)>>2]&3](166,241,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+720>>3],559,e);pe[c[(e+8|0)>>2]&3](167,207,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+792>>3],560,e);pe[c[(e+8|0)>>2]&3](167,211,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15656>>3],561,e);pe[c[(e+8|0)>>2]&3](167,214,1.0,562,e);pe[c[(e+8|0)>>2]&3](167,241,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+712>>3],563,e);pe[c[(e+8|0)>>2]&3](168,211,-+h[(c[(d+416|0)>>2]|0)+14832>>3],564,e);pe[c[(e+8|0)>>2]&3](168,213,-1.0,565,e);pe[c[(e+8|0)>>2]&3](168,241,+h[(c[(d+416|0)>>2]|0)+14848>>3],566,e);pe[c[(e+8|0)>>2]&3](168,242,-5.0e-4,567,e);pe[c[(e+8|0)>>2]&3](169,210,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7688>>3],568,e);pe[c[(e+8|0)>>2]&3](169,212,1.0,569,e);pe[c[(e+8|0)>>2]&3](169,213,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7712>>3],570,e);pe[c[(e+8|0)>>2]&3](170,12,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7752>>3]*+h[(c[(d+416|0)>>2]|0)+24160>>3]),571,e);f=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](170,205,-(+h[f+14840>>3]*+h[f+24160>>3]),572,e);pe[c[(e+8|0)>>2]&3](170,211,-1.0,573,e);f=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](170,242,+h[f+14832>>3]*+h[f+24160>>3],574,e);pe[c[(e+8|0)>>2]&3](170,251,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7744>>3]*+h[(c[(d+416|0)>>2]|0)+24160>>3]),575,e);pe[c[(e+8|0)>>2]&3](171,205,-.006,576,e);pe[c[(e+8|0)>>2]&3](171,207,-+h[(c[(d+416|0)>>2]|0)+14848>>3],577,e);pe[c[(e+8|0)>>2]&3](171,210,-1.0,578,e);pe[c[(e+8|0)>>2]&3](171,211,+h[(c[(d+416|0)>>2]|0)+14840>>3],579,e);pe[c[(e+8|0)>>2]&3](172,204,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+712>>3],580,e);pe[c[(e+8|0)>>2]&3](172,209,1.0,581,e);pe[c[(e+8|0)>>2]&3](172,244,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+720>>3],582,e);pe[c[(e+8|0)>>2]&3](173,208,1.0,583,e);pe[c[(e+8|0)>>2]&3](173,209,-1.0,584,e);pe[c[(e+8|0)>>2]&3](174,12,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7728>>3]*+h[(c[(d+416|0)>>2]|0)+24160>>3]),585,e);f=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](174,205,+h[f+14848>>3]*+h[f+24160>>3],586,e);pe[c[(e+8|0)>>2]&3](174,207,-1.0,587,e);f=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](174,208,-(+h[f+14832>>3]*+h[f+24160>>3]),588,e);pe[c[(e+8|0)>>2]&3](174,251,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7720>>3]*+h[(c[(d+416|0)>>2]|0)+24160>>3]),589,e);pe[c[(e+8|0)>>2]&3](175,204,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15656>>3],590,e);pe[c[(e+8|0)>>2]&3](175,206,1.0,591,e);pe[c[(e+8|0)>>2]&3](175,244,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15648>>3],592,e);pe[c[(e+8|0)>>2]&3](176,205,1.0,593,e);pe[c[(e+8|0)>>2]&3](176,206,-1.0,594,e);pe[c[(e+8|0)>>2]&3](176,303,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7688>>3],595,e);f=c[(e+8|0)>>2]|0;o=+h[(c[(d+416|0)>>2]|0)+23944>>3];i=c[c[(d+4|0)>>2]>>2]|0;n=+h[(c[i+8>>2]|0)+14992>>3];do{if(o!=0.0){p=-n/o}else{if(n==-0.0){p=-n;break}p=-n/+$Lb(c[d+536>>2]|0,o,9232,8456,+h[i>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](177,201,p,596,e);pe[c[(e+8|0)>>2]&3](177,204,1.0,597,e);f=c[(e+8|0)>>2]|0;p=+h[(c[(d+416|0)>>2]|0)+23944>>3];i=c[c[(d+4|0)>>2]>>2]|0;o=+h[(c[i+8>>2]|0)+15e3>>3];do{if(p!=0.0){q=-o/p}else{if(o==-0.0){q=-o;break}q=-o/+$Lb(c[d+536>>2]|0,p,9232,8456,+h[i>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](177,245,q,598,e);f=c[(e+8|0)>>2]|0;q=+h[(c[(d+416|0)>>2]|0)+23944>>3];i=c[c[(d+4|0)>>2]>>2]|0;p=+h[(c[i+8>>2]|0)+688>>3];do{if(q!=0.0){r=p/q}else{if(p==0.0){r=p;break}r=p/+$Lb(c[d+536>>2]|0,q,9232,8456,+h[i>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](177,303,r,599,e);pe[c[(e+8|0)>>2]&3](178,202,+h[(c[(d+416|0)>>2]|0)+24360>>3]*.4999999999999999,600,e);pe[c[(e+8|0)>>2]&3](178,203,1.0,601,e);pe[c[(e+8|0)>>2]&3](178,246,+h[(c[(d+416|0)>>2]|0)+24360>>3]*-.8660254037844387,602,e);pe[c[(e+8|0)>>2]&3](179,202,1.0,603,e);pe[c[(e+8|0)>>2]&3](179,247,.4999999999999999,604,e);pe[c[(e+8|0)>>2]&3](180,12,1.0,605,e);pe[c[(e+8|0)>>2]&3](180,201,1.0,606,e);pe[c[(e+8|0)>>2]&3](180,202,-1.0,607,e);pe[c[(e+8|0)>>2]&3](181,197,1.0,608,e);pe[c[(e+8|0)>>2]&3](181,200,1.0,609,e);pe[c[(e+8|0)>>2]&3](181,248,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19800>>3]*-2.0,610,e);pe[c[(e+8|0)>>2]&3](182,199,1.0,611,e);f=$Ob(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19784>>3],1.0e-12)|0;pe[c[(e+8|0)>>2]&3](182,200,-(f<<24>>24!=0?1.0:0.0),612,e);pe[c[(e+8|0)>>2]&3](183,198,1.0,613,e);f=c[(e+8|0)>>2]|0;i=c[c[(d+4|0)>>2]>>2]|0;r=+V(+(+h[(c[i+8>>2]|0)+19776>>3]));if(r!=0.0){s=r}else{s=+$Lb(c[d+536>>2]|0,r,9560,8456,+h[i>>3],(a[d+319|0]|0)!=0|0)}pe[f&3](183,199,-.5/s,614,e);pe[c[(e+8|0)>>2]&3](184,196,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10176>>3]*-2.0,615,e);pe[c[(e+8|0)>>2]&3](184,197,1.0,616,e);pe[c[(e+8|0)>>2]&3](184,250,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10168>>3]*-2.0,617,e);pe[c[(e+8|0)>>2]&3](185,12,-.8660254037844387,618,e);pe[c[(e+8|0)>>2]&3](185,196,-1.0,619,e);pe[c[(e+8|0)>>2]&3](185,251,-.4999999999999999,620,e);pe[c[(e+8|0)>>2]&3](186,195,1.0,621,e);pe[c[(e+8|0)>>2]&3](186,299,-1.0,622,e);f=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;i=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](186,303,+h[f+16200>>3]*+h[i+10464>>3]- +h[f+16224>>3]*+h[i+10456>>3],623,e);pe[c[(e+8|0)>>2]&3](187,194,1.0,624,e);pe[c[(e+8|0)>>2]&3](187,195,-1.0,625,e);i=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](187,303,+h[i+14968>>3]*+h[f+9984>>3]- +h[i+14952>>3]*+h[f+9976>>3],626,e);pe[c[(e+8|0)>>2]&3](188,144,-1.0,627,e);pe[c[(e+8|0)>>2]&3](188,193,1.0,628,e);pe[c[(e+8|0)>>2]&3](188,194,1.0,629,e);f=c[(e+8|0)>>2]|0;s=+h[(c[(d+416|0)>>2]|0)+22912>>3];i=c[c[(d+4|0)>>2]>>2]|0;r=+h[(c[i+8>>2]|0)+14960>>3];do{if(s!=0.0){t=-r/s}else{if(r==-0.0){t=-r;break}t=-r/+$Lb(c[d+536>>2]|0,s,9616,8456,+h[i>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](189,141,t,630,e);pe[c[(e+8|0)>>2]&3](189,192,1.0,631,e);f=c[(e+8|0)>>2]|0;t=+h[(c[(d+416|0)>>2]|0)+22912>>3];i=c[c[(d+4|0)>>2]>>2]|0;s=+h[(c[i+8>>2]|0)+14968>>3];do{if(t!=0.0){u=-s/t}else{if(s==-0.0){u=-s;break}u=-s/+$Lb(c[d+536>>2]|0,t,9616,8456,+h[i>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](189,193,u,632,e);f=c[(e+8|0)>>2]|0;u=+h[(c[(d+416|0)>>2]|0)+22912>>3];i=c[c[(d+4|0)>>2]>>2]|0;t=+h[(c[i+8>>2]|0)+1400>>3];do{if(u!=0.0){v=-t/u}else{if(t==-0.0){v=-t;break}v=-t/+$Lb(c[d+536>>2]|0,u,9616,8456,+h[i>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](189,303,v,633,e);f=c[(e+8|0)>>2]|0;i=c[c[(d+4|0)>>2]>>2]|0;j=c[i+8>>2]|0;v=+h[j+19920>>3];u=+h[j+1440>>3];do{if(v!=0.0){w=u/v}else{if(u==0.0){w=u;break}w=u/+$Lb(c[d+536>>2]|0,v,9672,8456,+h[i>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](190,151,w,634,e);pe[c[(e+8|0)>>2]&3](190,191,1.0,635,e);f=c[(e+8|0)>>2]|0;i=c[c[(d+4|0)>>2]>>2]|0;j=c[i+8>>2]|0;w=+h[j+19920>>3];v=+h[j+1432>>3];do{if(w!=0.0){x=-v/w}else{if(v==-0.0){x=-v;break}x=-v/+$Lb(c[d+536>>2]|0,w,9672,8456,+h[i>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](190,192,x,636,e);pe[c[(e+8|0)>>2]&3](191,190,1.0,637,e);pe[c[(e+8|0)>>2]&3](191,191,-1.0,638,e);pe[c[(e+8|0)>>2]&3](191,303,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7528>>3],639,e);pe[c[(e+8|0)>>2]&3](192,10,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7520>>3]*+h[(c[(d+416|0)>>2]|0)+23128>>3]),640,e);f=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](192,155,+h[f+11824>>3]*+h[f+23128>>3],641,e);pe[c[(e+8|0)>>2]&3](192,189,-1.0,642,e);f=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](192,190,-(+h[f+11832>>3]*+h[f+23128>>3]),643,e);pe[c[(e+8|0)>>2]&3](192,194,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7512>>3]*+h[(c[(d+416|0)>>2]|0)+23128>>3]),644,e);pe[c[(e+8|0)>>2]&3](193,154,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7528>>3],645,e);pe[c[(e+8|0)>>2]&3](193,188,1.0,646,e);pe[c[(e+8|0)>>2]&3](193,189,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7504>>3],647,e);pe[c[(e+8|0)>>2]&3](194,178,-1.0,648,e);pe[c[(e+8|0)>>2]&3](194,187,-1.0,649,e);pe[c[(e+8|0)>>2]&3](194,188,-1.0,650,e);pe[c[(e+8|0)>>2]&3](195,165,-+h[(c[(d+416|0)>>2]|0)+9968>>3],651,e);pe[c[(e+8|0)>>2]&3](195,177,1.0,652,e);pe[c[(e+8|0)>>2]&3](195,186,-1.0,653,e);pe[c[(e+8|0)>>2]&3](195,187,+h[(c[(d+416|0)>>2]|0)+9984>>3],654,e);pe[c[(e+8|0)>>2]&3](196,169,1.0,655,e);pe[c[(e+8|0)>>2]&3](196,171,-+h[(c[(d+416|0)>>2]|0)+10464>>3],656,e);pe[c[(e+8|0)>>2]&3](196,172,+h[(c[(d+416|0)>>2]|0)+10456>>3],657,e);pe[c[(e+8|0)>>2]&3](196,183,-1.0,658,e);pe[c[(e+8|0)>>2]&3](197,172,-+h[(c[(d+416|0)>>2]|0)+10448>>3],659,e);pe[c[(e+8|0)>>2]&3](197,182,.5000000000000001,660,e);pe[c[(e+8|0)>>2]&3](197,185,-1.0,661,e);pe[c[(e+8|0)>>2]&3](197,186,-.8660254037844386,662,e);pe[c[(e+8|0)>>2]&3](197,187,+h[(c[(d+416|0)>>2]|0)+10464>>3],663,e);pe[c[(e+8|0)>>2]&3](198,171,+h[(c[(d+416|0)>>2]|0)+10448>>3],664,e);pe[c[(e+8|0)>>2]&3](198,182,-.8660254037844386,665,e);pe[c[(e+8|0)>>2]&3](198,184,-1.0,666,e);pe[c[(e+8|0)>>2]&3](198,186,-.5000000000000001,667,e);pe[c[(e+8|0)>>2]&3](198,187,-+h[(c[(d+416|0)>>2]|0)+10456>>3],668,e);pe[c[(e+8|0)>>2]&3](199,173,+h[(c[(d+416|0)>>2]|0)+9968>>3],669,e);pe[c[(e+8|0)>>2]&3](199,176,1.0,670,e);pe[c[(e+8|0)>>2]&3](199,182,-1.0,671,e);pe[c[(e+8|0)>>2]&3](199,187,-+h[(c[(d+416|0)>>2]|0)+9976>>3],672,e);pe[c[(e+8|0)>>2]&3](200,154,+h[(c[(d+416|0)>>2]|0)+11816>>3],673,e);pe[c[(e+8|0)>>2]&3](200,155,-.006,674,e);pe[c[(e+8|0)>>2]&3](200,181,-1.0,675,e);pe[c[(e+8|0)>>2]&3](200,189,-+h[(c[(d+416|0)>>2]|0)+11824>>3],676,e);pe[c[(e+8|0)>>2]&3](201,157,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1440>>3],677,e);pe[c[(e+8|0)>>2]&3](201,160,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1520>>3],678,e);pe[c[(e+8|0)>>2]&3](201,180,1.0,679,e);pe[c[(e+8|0)>>2]&3](201,181,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15744>>3],680,e);f=c[(e+8|0)>>2]|0;i=c[c[(d+4|0)>>2]>>2]|0;j=c[i+8>>2]|0;x=+h[j+7504>>3];w=+h[(c[(d+416|0)>>2]|0)+22912>>3];v=+h[j+15752>>3];do{if(w!=0.0){y=v/w}else{if(v==0.0){y=v;break}y=v/+$Lb(c[d+536>>2]|0,w,9616,8456,+h[i>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](202,163,-(x*y),681,e);pe[c[(e+8|0)>>2]&3](202,179,1.0,682,e);f=c[(e+8|0)>>2]|0;i=c[c[(d+4|0)>>2]>>2]|0;j=c[i+8>>2]|0;y=+h[j+7504>>3];x=+h[(c[(d+416|0)>>2]|0)+22912>>3];w=+h[j+15744>>3];do{if(x!=0.0){z=w/x}else{if(w==0.0){z=w;break}z=w/+$Lb(c[d+536>>2]|0,x,9616,8456,+h[i>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](202,180,-(y*z),683,e);pe[c[(e+8|0)>>2]&3](203,167,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7528>>3],684,e);pe[c[(e+8|0)>>2]&3](203,178,1.0,685,e);pe[c[(e+8|0)>>2]&3](203,179,-1.0,686,e);pe[c[(e+8|0)>>2]&3](204,166,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10016>>3],687,e);pe[c[(e+8|0)>>2]&3](204,177,-1.0,688,e);pe[c[(e+8|0)>>2]&3](204,178,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1400>>3],689,e);pe[c[(e+8|0)>>2]&3](204,180,-1.0,690,e);pe[c[(e+8|0)>>2]&3](205,163,-1.0,691,e);pe[c[(e+8|0)>>2]&3](205,174,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10016>>3],692,e);pe[c[(e+8|0)>>2]&3](205,176,-1.0,693,e);pe[c[(e+8|0)>>2]&3](205,178,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1408>>3],694,e);f=c[(e+8|0)>>2]|0;i=c[c[(d+4|0)>>2]>>2]|0;j=c[i+8>>2]|0;z=+h[(c[(d+416|0)>>2]|0)+22912>>3]*+h[j+7504>>3];y=+h[j+15744>>3];do{if(z!=0.0){A=y/z}else{if(y==0.0){A=y;break}A=y/+$Lb(c[d+536>>2]|0,z,9728,8456,+h[i>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](206,159,A,695,e);f=c[(e+8|0)>>2]|0;i=c[c[(d+4|0)>>2]>>2]|0;j=c[i+8>>2]|0;A=+h[j+1440>>3];z=+h[(c[(d+416|0)>>2]|0)+22912>>3];y=+h[j+15752>>3];do{if(z!=0.0){B=y/z}else{if(y==0.0){B=y;break}B=y/+$Lb(c[d+536>>2]|0,z,9616,8456,+h[i>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](206,163,-(A*B),696,e);pe[c[(e+8|0)>>2]&3](206,175,1.0,697,e);f=c[(e+8|0)>>2]|0;i=c[c[(d+4|0)>>2]>>2]|0;j=c[i+8>>2]|0;B=+h[j+1440>>3];A=+h[(c[(d+416|0)>>2]|0)+22912>>3];z=+h[j+15744>>3];do{if(A!=0.0){C=z/A}else{if(z==0.0){C=z;break}C=z/+$Lb(c[d+536>>2]|0,A,9616,8456,+h[i>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](206,180,-(B*C),698,e);pe[c[(e+8|0)>>2]&3](207,167,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1520>>3],699,e);pe[c[(e+8|0)>>2]&3](207,174,1.0,700,e);pe[c[(e+8|0)>>2]&3](207,175,-1.0,701,e);pe[c[(e+8|0)>>2]&3](208,162,-1.0,702,e);pe[c[(e+8|0)>>2]&3](208,173,-1.0,703,e);pe[c[(e+8|0)>>2]&3](208,174,-1.0,704,e);pe[c[(e+8|0)>>2]&3](209,165,.8660254037844386,705,e);pe[c[(e+8|0)>>2]&3](209,172,1.0,706,e);pe[c[(e+8|0)>>2]&3](209,173,.5000000000000001,707,e);pe[c[(e+8|0)>>2]&3](210,165,-.5000000000000001,708,e);pe[c[(e+8|0)>>2]&3](210,171,1.0,709,e);pe[c[(e+8|0)>>2]&3](210,173,.8660254037844386,710,e);pe[c[(e+8|0)>>2]&3](211,170,1.0,711,e);pe[c[(e+8|0)>>2]&3](211,171,1.0,712,e);pe[c[(e+8|0)>>2]&3](211,374,-1.0,713,e);pe[c[(e+8|0)>>2]&3](212,165,+h[(c[(d+416|0)>>2]|0)+9976>>3],714,e);pe[c[(e+8|0)>>2]&3](212,168,1.0,715,e);pe[c[(e+8|0)>>2]&3](212,169,-1.0,716,e);pe[c[(e+8|0)>>2]&3](212,173,-+h[(c[(d+416|0)>>2]|0)+9984>>3],717,e);pe[c[(e+8|0)>>2]&3](213,159,-1.0,718,e);pe[c[(e+8|0)>>2]&3](213,166,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1408>>3],719,e);pe[c[(e+8|0)>>2]&3](213,168,-1.0,720,e);pe[c[(e+8|0)>>2]&3](213,174,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1400>>3],721,e);f=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19984>>3])),1.0e-10)|0;i=c[(e+8|0)>>2]|0;do{if(f<<24>>24==0){j=c[c[(d+4|0)>>2]>>2]|0;C=+h[(c[j+8>>2]|0)+19984>>3];if(C!=0.0){D=C;break}D=+$Lb(c[d+536>>2]|0,C,9824,8456,+h[j>>3],(a[d+319|0]|0)!=0|0)}else{D=1.0e-10}}while(0);pe[i&3](214,143,1.0/D,722,e);i=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19984>>3])),1.0e-10)|0;f=c[(e+8|0)>>2]|0;j=c[c[(d+4|0)>>2]>>2]|0;b=c[j+8>>2]|0;if(i<<24>>24!=0){E=1}else{E=+h[b+19984>>3]!=0.0}D=+h[b+14952>>3]*.8660254037844387+ +h[b+14944>>3]*.4999999999999999;do{if(E){if(i<<24>>24!=0){F=1.0e-10}else{F=+h[b+19984>>3]}G=D/F}else{if(D==0.0){G=D;break}if(i<<24>>24!=0){H=1.0e-10}else{H=+h[b+19984>>3]}G=D/+$Lb(c[d+536>>2]|0,H,9824,8456,+h[j>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](214,164,G,723,e);pe[c[(e+8|0)>>2]&3](214,167,1.0,724,e);f=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19984>>3])),1.0e-10)|0;j=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;i=c[b+8>>2]|0;if(f<<24>>24!=0){I=1}else{I=+h[i+19984>>3]!=0.0}G=+h[i+14968>>3]*.8660254037844387+ +h[i+14960>>3]*.4999999999999999;do{if(I){if(f<<24>>24!=0){J=1.0e-10}else{J=+h[i+19984>>3]}K=G/J}else{if(G==0.0){K=G;break}if(f<<24>>24!=0){L=1.0e-10}else{L=+h[i+19984>>3]}K=G/+$Lb(c[d+536>>2]|0,L,9824,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[j&3](214,175,K,725,e);pe[c[(e+8|0)>>2]&3](215,164,-1.0,726,e);pe[c[(e+8|0)>>2]&3](215,166,1.0,727,e);pe[c[(e+8|0)>>2]&3](215,167,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1512>>3],728,e);pe[c[(e+8|0)>>2]&3](216,161,-1.0,729,e);pe[c[(e+8|0)>>2]&3](216,165,-1.0,730,e);pe[c[(e+8|0)>>2]&3](216,166,-1.0,731,e);j=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;i=c[b+8>>2]|0;K=+h[(c[(d+416|0)>>2]|0)+22912>>3]*+h[i+7504>>3];L=+h[i+15752>>3];do{if(K!=0.0){M=L/K}else{if(L==0.0){M=L;break}M=L/+$Lb(c[d+536>>2]|0,K,9728,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[j&3](217,159,M,732,e);j=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;i=c[b+8>>2]|0;M=+h[i+1432>>3];K=+h[(c[(d+416|0)>>2]|0)+22912>>3];L=+h[i+15752>>3];do{if(K!=0.0){N=L/K}else{if(L==0.0){N=L;break}N=L/+$Lb(c[d+536>>2]|0,K,9616,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[j&3](217,163,-(M*N),733,e);pe[c[(e+8|0)>>2]&3](217,164,1.0,734,e);j=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;i=c[b+8>>2]|0;N=+h[i+1432>>3];M=+h[(c[(d+416|0)>>2]|0)+22912>>3];K=+h[i+15744>>3];do{if(M!=0.0){O=K/M}else{if(K==0.0){O=K;break}O=K/+$Lb(c[d+536>>2]|0,M,9616,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[j&3](217,180,-(N*O),735,e);pe[c[(e+8|0)>>2]&3](218,157,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1432>>3],736,e);pe[c[(e+8|0)>>2]&3](218,160,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1512>>3],737,e);pe[c[(e+8|0)>>2]&3](218,163,1.0,738,e);pe[c[(e+8|0)>>2]&3](218,181,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15752>>3],739,e);pe[c[(e+8|0)>>2]&3](219,154,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1520>>3],740,e);pe[c[(e+8|0)>>2]&3](219,158,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15744>>3],741,e);pe[c[(e+8|0)>>2]&3](219,162,1.0,742,e);pe[c[(e+8|0)>>2]&3](219,189,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1440>>3],743,e);pe[c[(e+8|0)>>2]&3](220,154,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1512>>3],744,e);pe[c[(e+8|0)>>2]&3](220,158,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15752>>3],745,e);pe[c[(e+8|0)>>2]&3](220,161,1.0,746,e);pe[c[(e+8|0)>>2]&3](220,189,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1432>>3],747,e);pe[c[(e+8|0)>>2]&3](221,158,-+h[(c[(d+416|0)>>2]|0)+11816>>3],748,e);pe[c[(e+8|0)>>2]&3](221,160,-1.0,749,e);pe[c[(e+8|0)>>2]&3](221,189,+h[(c[(d+416|0)>>2]|0)+11832>>3],750,e);pe[c[(e+8|0)>>2]&3](221,190,-5.0e-4,751,e);pe[c[(e+8|0)>>2]&3](222,157,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7504>>3],752,e);pe[c[(e+8|0)>>2]&3](222,159,1.0,753,e);pe[c[(e+8|0)>>2]&3](222,160,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7528>>3],754,e);pe[c[(e+8|0)>>2]&3](223,10,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7568>>3]*+h[(c[(d+416|0)>>2]|0)+23128>>3]),755,e);j=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](223,152,-(+h[j+11824>>3]*+h[j+23128>>3]),756,e);pe[c[(e+8|0)>>2]&3](223,158,-1.0,757,e);j=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](223,190,+h[j+11816>>3]*+h[j+23128>>3],758,e);pe[c[(e+8|0)>>2]&3](223,194,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7560>>3]*+h[(c[(d+416|0)>>2]|0)+23128>>3]),759,e);pe[c[(e+8|0)>>2]&3](224,152,-.006,760,e);pe[c[(e+8|0)>>2]&3](224,154,-+h[(c[(d+416|0)>>2]|0)+11832>>3],761,e);pe[c[(e+8|0)>>2]&3](224,157,-1.0,762,e);pe[c[(e+8|0)>>2]&3](224,158,+h[(c[(d+416|0)>>2]|0)+11824>>3],763,e);pe[c[(e+8|0)>>2]&3](225,151,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1432>>3],764,e);pe[c[(e+8|0)>>2]&3](225,156,1.0,765,e);pe[c[(e+8|0)>>2]&3](225,192,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1440>>3],766,e);pe[c[(e+8|0)>>2]&3](226,155,1.0,767,e);pe[c[(e+8|0)>>2]&3](226,156,-1.0,768,e);pe[c[(e+8|0)>>2]&3](227,10,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7544>>3]*+h[(c[(d+416|0)>>2]|0)+23128>>3]),769,e);j=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](227,152,+h[j+11832>>3]*+h[j+23128>>3],770,e);pe[c[(e+8|0)>>2]&3](227,154,-1.0,771,e);j=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](227,155,-(+h[j+11816>>3]*+h[j+23128>>3]),772,e);pe[c[(e+8|0)>>2]&3](227,194,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7536>>3]*+h[(c[(d+416|0)>>2]|0)+23128>>3]),773,e);pe[c[(e+8|0)>>2]&3](228,151,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15752>>3],774,e);pe[c[(e+8|0)>>2]&3](228,153,1.0,775,e);pe[c[(e+8|0)>>2]&3](228,192,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15744>>3],776,e);pe[c[(e+8|0)>>2]&3](229,152,1.0,777,e);pe[c[(e+8|0)>>2]&3](229,153,-1.0,778,e);pe[c[(e+8|0)>>2]&3](229,303,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7504>>3],779,e);j=c[(e+8|0)>>2]|0;O=+h[(c[(d+416|0)>>2]|0)+22912>>3];b=c[c[(d+4|0)>>2]>>2]|0;N=+h[(c[b+8>>2]|0)+14944>>3];do{if(O!=0.0){P=-N/O}else{if(N==-0.0){P=-N;break}P=-N/+$Lb(c[d+536>>2]|0,O,9616,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[j&3](230,141,P,780,e);pe[c[(e+8|0)>>2]&3](230,151,1.0,781,e);j=c[(e+8|0)>>2]|0;P=+h[(c[(d+416|0)>>2]|0)+22912>>3];b=c[c[(d+4|0)>>2]>>2]|0;O=+h[(c[b+8>>2]|0)+14952>>3];do{if(P!=0.0){Q=-O/P}else{if(O==-0.0){Q=-O;break}Q=-O/+$Lb(c[d+536>>2]|0,P,9616,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[j&3](230,193,Q,782,e);j=c[(e+8|0)>>2]|0;Q=+h[(c[(d+416|0)>>2]|0)+22912>>3];b=c[c[(d+4|0)>>2]>>2]|0;P=+h[(c[b+8>>2]|0)+1408>>3];do{if(Q!=0.0){R=P/Q}else{if(P==0.0){R=P;break}R=P/+$Lb(c[d+536>>2]|0,Q,9616,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[j&3](230,303,R,783,e);pe[c[(e+8|0)>>2]&3](231,10,-.8660254037844387,784,e);pe[c[(e+8|0)>>2]&3](231,150,-1.0,785,e);pe[c[(e+8|0)>>2]&3](231,194,.4999999999999999,786,e);pe[c[(e+8|0)>>2]&3](232,140,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10048>>3]*-2.0,787,e);pe[c[(e+8|0)>>2]&3](232,149,1.0,788,e);pe[c[(e+8|0)>>2]&3](232,150,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10056>>3]*-2.0,789,e);pe[c[(e+8|0)>>2]&3](233,138,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19960>>3]*-2.0,790,e);pe[c[(e+8|0)>>2]&3](233,148,1.0,791,e);pe[c[(e+8|0)>>2]&3](233,149,1.0,792,e);pe[c[(e+8|0)>>2]&3](234,147,1.0,793,e);j=$Ob(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19944>>3],1.0e-12)|0;pe[c[(e+8|0)>>2]&3](234,148,-(j<<24>>24!=0?1.0:0.0),794,e);pe[c[(e+8|0)>>2]&3](235,146,1.0,795,e);j=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;R=+V(+(+h[(c[b+8>>2]|0)+19936>>3]));if(R!=0.0){S=R}else{S=+$Lb(c[d+536>>2]|0,R,9944,8456,+h[b>>3],(a[d+319|0]|0)!=0|0)}pe[j&3](235,147,-.5/S,796,e);pe[c[(e+8|0)>>2]&3](236,138,1.0,797,e);pe[c[(e+8|0)>>2]&3](236,145,-1.0,798,e);pe[c[(e+8|0)>>2]&3](236,146,-((a[(c[(d+424|0)>>2]|0)+179|0]|0)!=0?1.0:-1.0),799,e);pe[c[(e+8|0)>>2]&3](237,144,1.0,800,e);pe[c[(e+8|0)>>2]&3](237,145,-.8660254037844387,801,e);pe[c[(e+8|0)>>2]&3](238,142,+h[(c[(d+416|0)>>2]|0)+23328>>3]*-.4999999999999999,802,e);pe[c[(e+8|0)>>2]&3](238,143,1.0,803,e);pe[c[(e+8|0)>>2]&3](238,144,+h[(c[(d+416|0)>>2]|0)+23328>>3]*-.8660254037844387,804,e);pe[c[(e+8|0)>>2]&3](239,142,1.0,805,e);pe[c[(e+8|0)>>2]&3](239,145,-.4999999999999999,806,e);pe[c[(e+8|0)>>2]&3](240,10,1.0,807,e);pe[c[(e+8|0)>>2]&3](240,141,1.0,808,e);pe[c[(e+8|0)>>2]&3](240,142,-1.0,809,e);pe[c[(e+8|0)>>2]&3](241,10,-.4999999999999999,810,e);pe[c[(e+8|0)>>2]&3](241,140,-1.0,811,e);pe[c[(e+8|0)>>2]&3](241,194,-.8660254037844387,812,e);pe[c[(e+8|0)>>2]&3](242,139,1.0,813,e);pe[c[(e+8|0)>>2]&3](242,140,2.0,814,e);pe[c[(e+8|0)>>2]&3](243,138,1.0,815,e);pe[c[(e+8|0)>>2]&3](243,139,-.5,816,e);pe[c[(e+8|0)>>2]&3](244,137,1.0,817,e);pe[c[(e+8|0)>>2]&3](244,300,-1.0,818,e);j=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;b=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](244,303,+h[j+16200>>3]*+h[b+7448>>3]- +h[j+16224>>3]*+h[b+7440>>3],819,e);pe[c[(e+8|0)>>2]&3](245,136,1.0,820,e);pe[c[(e+8|0)>>2]&3](245,137,-1.0,821,e);b=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;j=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](245,303,+h[b+14920>>3]*+h[j+6968>>3]- +h[b+14904>>3]*+h[j+6960>>3],822,e);pe[c[(e+8|0)>>2]&3](246,135,1.0,823,e);pe[c[(e+8|0)>>2]&3](246,301,-1.0,824,e);j=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;b=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](246,303,+h[j+16200>>3]*+h[b+4432>>3]- +h[j+16224>>3]*+h[b+4424>>3],825,e);}function _setLinearMatrixA1039$3(b){b=b|0;var d=0,e=0,f=0,i=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,fa=0.0;d=c[b+8>>2]|0;e=c[b+16>>2]|0;f=c[b+2304>>2]|0;i=c[b+2312>>2]|0;j=c[b+2320>>2]|0;k=+g[b+2328>>2];l=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;m=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](81,303,+h[l+16200>>3]*+h[m+3856>>3]- +h[l+16224>>3]*+h[m+3848>>3],276,e);pe[c[(e+8|0)>>2]&3](82,299,1.0,277,e);pe[c[(e+8|0)>>2]&3](82,300,-1.0,278,e);m=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;l=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](82,303,+h[m+16200>>3]*+h[l+6872>>3]- +h[m+16224>>3]*+h[l+6864>>3],279,e);pe[c[(e+8|0)>>2]&3](83,298,1.0,280,e);pe[c[(e+8|0)>>2]&3](83,299,-1.0,281,e);l=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;m=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](83,303,+h[l+16200>>3]*+h[m+9888>>3]- +h[l+16224>>3]*+h[m+9880>>3],282,e);pe[c[(e+8|0)>>2]&3](84,297,1.0,283,e);pe[c[(e+8|0)>>2]&3](84,298,-1.0,284,e);m=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;l=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](84,303,+h[m+16200>>3]*+h[l+12904>>3]- +h[m+16224>>3]*+h[l+12896>>3],285,e);pe[c[(e+8|0)>>2]&3](85,296,1.0,286,e);pe[c[(e+8|0)>>2]&3](85,297,-1.0,287,e);l=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;m=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](85,303,+h[l+16200>>3]*+h[m+16496>>3]- +h[l+16224>>3]*+h[m+16488>>3],288,e);pe[c[(e+8|0)>>2]&3](86,295,1.0,289,e);pe[c[(e+8|0)>>2]&3](86,296,-1.0,290,e);m=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;l=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](86,303,+h[m+15064>>3]*+h[l+16016>>3]- +h[m+15048>>3]*+h[l+16008>>3],291,e);pe[c[(e+8|0)>>2]&3](87,14,-.4999999999999999,292,e);pe[c[(e+8|0)>>2]&3](87,294,-1.0,293,e);pe[c[(e+8|0)>>2]&3](87,295,-.8660254037844387,294,e);pe[c[(e+8|0)>>2]&3](88,293,1.0,295,e);pe[c[(e+8|0)>>2]&3](88,294,2.0,296,e);pe[c[(e+8|0)>>2]&3](89,292,1.0,297,e);pe[c[(e+8|0)>>2]&3](89,293,-.5,298,e);pe[c[(e+8|0)>>2]&3](90,255,-((a[(c[(d+424|0)>>2]|0)+275|0]|0)!=0?1.0:-1.0),299,e);pe[c[(e+8|0)>>2]&3](90,291,-1.0,300,e);pe[c[(e+8|0)>>2]&3](90,292,1.0,301,e);pe[c[(e+8|0)>>2]&3](91,290,1.0,302,e);pe[c[(e+8|0)>>2]&3](91,291,-.8660254037844387,303,e);pe[c[(e+8|0)>>2]&3](92,289,1.0,304,e);pe[c[(e+8|0)>>2]&3](92,290,-1.0,305,e);pe[c[(e+8|0)>>2]&3](92,295,1.0,306,e);l=c[(e+8|0)>>2]|0;n=+h[(c[(d+416|0)>>2]|0)+24976>>3];m=c[c[(d+4|0)>>2]>>2]|0;o=+h[(c[m+8>>2]|0)+15056>>3];do{if(n!=0.0){p=-o/n}else{if(o==-0.0){p=-o;break}p=-o/+$Lb(c[d+536>>2]|0,n,8464,8456,+h[m>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](93,258,p,307,e);pe[c[(e+8|0)>>2]&3](93,288,1.0,308,e);l=c[(e+8|0)>>2]|0;p=+h[(c[(d+416|0)>>2]|0)+24976>>3];m=c[c[(d+4|0)>>2]>>2]|0;n=+h[(c[m+8>>2]|0)+15064>>3];do{if(p!=0.0){q=-n/p}else{if(n==-0.0){q=-n;break}q=-n/+$Lb(c[d+536>>2]|0,p,8464,8456,+h[m>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](93,289,q,309,e);l=c[(e+8|0)>>2]|0;q=+h[(c[(d+416|0)>>2]|0)+24976>>3];m=c[c[(d+4|0)>>2]>>2]|0;p=+h[(c[m+8>>2]|0)+200>>3];do{if(q!=0.0){r=-p/q}else{if(p==-0.0){r=-p;break}r=-p/+$Lb(c[d+536>>2]|0,q,8464,8456,+h[m>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](93,303,r,310,e);l=c[(e+8|0)>>2]|0;m=c[c[(d+4|0)>>2]>>2]|0;s=c[m+8>>2]|0;r=+h[s+19600>>3];q=+h[s+240>>3];do{if(r!=0.0){t=q/r}else{if(q==0.0){t=q;break}t=q/+$Lb(c[d+536>>2]|0,r,9e3,8456,+h[m>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](94,261,t,311,e);pe[c[(e+8|0)>>2]&3](94,287,1.0,312,e);l=c[(e+8|0)>>2]|0;m=c[c[(d+4|0)>>2]>>2]|0;s=c[m+8>>2]|0;t=+h[s+19600>>3];r=+h[s+232>>3];do{if(t!=0.0){u=-r/t}else{if(r==-0.0){u=-r;break}u=-r/+$Lb(c[d+536>>2]|0,t,9e3,8456,+h[m>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](94,288,u,313,e);pe[c[(e+8|0)>>2]&3](95,286,1.0,314,e);pe[c[(e+8|0)>>2]&3](95,287,-1.0,315,e);pe[c[(e+8|0)>>2]&3](95,303,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7944>>3],316,e);pe[c[(e+8|0)>>2]&3](96,14,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7936>>3]*+h[(c[(d+416|0)>>2]|0)+25192>>3]),317,e);l=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](96,264,+h[l+17856>>3]*+h[l+25192>>3],318,e);pe[c[(e+8|0)>>2]&3](96,285,-1.0,319,e);l=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](96,286,-(+h[l+17864>>3]*+h[l+25192>>3]),320,e);pe[c[(e+8|0)>>2]&3](96,295,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7928>>3]*+h[(c[(d+416|0)>>2]|0)+25192>>3]),321,e);pe[c[(e+8|0)>>2]&3](97,267,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15504>>3],322,e);pe[c[(e+8|0)>>2]&3](97,284,1.0,323,e);pe[c[(e+8|0)>>2]&3](97,285,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+240>>3],324,e);pe[c[(e+8|0)>>2]&3](97,381,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+320>>3],325,e);pe[c[(e+8|0)>>2]&3](98,267,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15512>>3],326,e);pe[c[(e+8|0)>>2]&3](98,283,1.0,327,e);pe[c[(e+8|0)>>2]&3](98,285,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3],328,e);pe[c[(e+8|0)>>2]&3](98,381,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+312>>3],329,e);pe[c[(e+8|0)>>2]&3](99,270,-1.0,330,e);pe[c[(e+8|0)>>2]&3](99,282,-1.0,331,e);pe[c[(e+8|0)>>2]&3](99,283,-1.0,332,e);pe[c[(e+8|0)>>2]&3](100,281,1.0,333,e);pe[c[(e+8|0)>>2]&3](100,282,.8660254037844387,334,e);pe[c[(e+8|0)>>2]&3](100,376,-.4999999999999999,335,e);pe[c[(e+8|0)>>2]&3](101,224,1.0,336,e);pe[c[(e+8|0)>>2]&3](101,280,1.0,337,e);pe[c[(e+8|0)>>2]&3](101,281,-1.0,338,e);pe[c[(e+8|0)>>2]&3](102,172,1.0,339,e);pe[c[(e+8|0)>>2]&3](102,279,1.0,340,e);pe[c[(e+8|0)>>2]&3](102,280,-1.0,341,e);pe[c[(e+8|0)>>2]&3](103,276,-1.0,342,e);pe[c[(e+8|0)>>2]&3](103,278,-1.0,343,e);pe[c[(e+8|0)>>2]&3](103,281,-+h[(c[(d+416|0)>>2]|0)+12896>>3],344,e);pe[c[(e+8|0)>>2]&3](103,375,+h[(c[(d+416|0)>>2]|0)+12904>>3],345,e);pe[c[(e+8|0)>>2]&3](104,237,1.0,346,e);pe[c[(e+8|0)>>2]&3](104,277,1.0,347,e);pe[c[(e+8|0)>>2]&3](104,278,1.0,348,e);pe[c[(e+8|0)>>2]&3](105,275,1.0,349,e);pe[c[(e+8|0)>>2]&3](105,276,1.0,350,e);pe[c[(e+8|0)>>2]&3](105,281,-+h[(c[(d+416|0)>>2]|0)+16488>>3],351,e);pe[c[(e+8|0)>>2]&3](105,375,+h[(c[(d+416|0)>>2]|0)+16496>>3],352,e);pe[c[(e+8|0)>>2]&3](106,272,1.0,353,e);pe[c[(e+8|0)>>2]&3](106,275,-1.0,354,e);pe[c[(e+8|0)>>2]&3](106,282,+h[(c[(d+416|0)>>2]|0)+16008>>3],355,e);pe[c[(e+8|0)>>2]&3](106,376,-+h[(c[(d+416|0)>>2]|0)+16016>>3],356,e);pe[c[(e+8|0)>>2]&3](107,267,-+h[(c[(d+416|0)>>2]|0)+17848>>3],357,e);pe[c[(e+8|0)>>2]&3](107,274,-1.0,358,e);pe[c[(e+8|0)>>2]&3](107,285,+h[(c[(d+416|0)>>2]|0)+17864>>3],359,e);pe[c[(e+8|0)>>2]&3](107,286,-5.0e-4,360,e);pe[c[(e+8|0)>>2]&3](108,266,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7920>>3],361,e);pe[c[(e+8|0)>>2]&3](108,273,1.0,362,e);pe[c[(e+8|0)>>2]&3](108,274,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7944>>3],363,e);pe[c[(e+8|0)>>2]&3](109,270,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+208>>3],364,e);pe[c[(e+8|0)>>2]&3](109,272,-1.0,365,e);pe[c[(e+8|0)>>2]&3](109,273,-1.0,366,e);pe[c[(e+8|0)>>2]&3](109,377,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+200>>3],367,e);l=c[(e+8|0)>>2]|0;m=c[c[(d+4|0)>>2]>>2]|0;s=c[m+8>>2]|0;u=+h[s+232>>3];t=+h[(c[(d+416|0)>>2]|0)+24976>>3];r=+h[s+15512>>3];do{if(t!=0.0){v=r/t}else{if(r==0.0){v=r;break}v=r/+$Lb(c[d+536>>2]|0,t,8464,8456,+h[m>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](110,268,-(u*v),368,e);pe[c[(e+8|0)>>2]&3](110,271,1.0,369,e);l=c[(e+8|0)>>2]|0;m=c[c[(d+4|0)>>2]>>2]|0;s=c[m+8>>2]|0;v=+h[(c[(d+416|0)>>2]|0)+24976>>3]*+h[s+7920>>3];u=+h[s+15512>>3];do{if(v!=0.0){w=u/v}else{if(u==0.0){w=u;break}w=u/+$Lb(c[d+536>>2]|0,v,8520,8456,+h[m>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](110,273,w,370,e);l=c[(e+8|0)>>2]|0;m=c[c[(d+4|0)>>2]>>2]|0;s=c[m+8>>2]|0;w=+h[s+232>>3];v=+h[(c[(d+416|0)>>2]|0)+24976>>3];u=+h[s+15504>>3];do{if(v!=0.0){x=u/v}else{if(u==0.0){x=u;break}x=u/+$Lb(c[d+536>>2]|0,v,8464,8456,+h[m>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](110,379,-(w*x),371,e);pe[c[(e+8|0)>>2]&3](111,269,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+312>>3],372,e);pe[c[(e+8|0)>>2]&3](111,270,1.0,373,e);pe[c[(e+8|0)>>2]&3](111,271,-1.0,374,e);l=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19664>>3])),1.0e-10)|0;m=c[(e+8|0)>>2]|0;do{if(l<<24>>24==0){s=c[c[(d+4|0)>>2]>>2]|0;x=+h[(c[s+8>>2]|0)+19664>>3];if(x!=0.0){y=x;break}y=+$Lb(c[d+536>>2]|0,x,9056,8456,+h[s>>3],(a[d+319|0]|0)!=0|0)}else{y=1.0e-10}}while(0);pe[m&3](112,260,1.0/y,375,e);pe[c[(e+8|0)>>2]&3](112,269,1.0,376,e);m=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19664>>3])),1.0e-10)|0;l=c[(e+8|0)>>2]|0;s=c[c[(d+4|0)>>2]>>2]|0;z=c[s+8>>2]|0;if(m<<24>>24!=0){A=1}else{A=+h[z+19664>>3]!=0.0}y=+h[z+15048>>3]*.8660254037844387+ +h[z+15040>>3]*.4999999999999999;do{if(A){if(m<<24>>24!=0){B=1.0e-10}else{B=+h[z+19664>>3]}C=y/B}else{if(y==0.0){C=y;break}if(m<<24>>24!=0){D=1.0e-10}else{D=+h[z+19664>>3]}C=y/+$Lb(c[d+536>>2]|0,D,9056,8456,+h[s>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](112,271,C,377,e);l=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19664>>3])),1.0e-10)|0;s=c[(e+8|0)>>2]|0;z=c[c[(d+4|0)>>2]>>2]|0;m=c[z+8>>2]|0;if(l<<24>>24!=0){E=1}else{E=+h[m+19664>>3]!=0.0}C=+h[m+15064>>3]*.8660254037844387+ +h[m+15056>>3]*.4999999999999999;do{if(E){if(l<<24>>24!=0){F=1.0e-10}else{F=+h[m+19664>>3]}G=C/F}else{if(C==0.0){G=C;break}if(l<<24>>24!=0){H=1.0e-10}else{H=+h[m+19664>>3]}G=C/+$Lb(c[d+536>>2]|0,H,9056,8456,+h[z>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](112,378,G,378,e);pe[c[(e+8|0)>>2]&3](113,266,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3],379,e);pe[c[(e+8|0)>>2]&3](113,268,1.0,380,e);pe[c[(e+8|0)>>2]&3](113,274,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+312>>3],381,e);pe[c[(e+8|0)>>2]&3](113,380,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15512>>3],382,e);pe[c[(e+8|0)>>2]&3](114,14,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7984>>3]*+h[(c[(d+416|0)>>2]|0)+25192>>3]),383,e);s=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](114,262,-(+h[s+17856>>3]*+h[s+25192>>3]),384,e);pe[c[(e+8|0)>>2]&3](114,267,-1.0,385,e);s=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](114,286,+h[s+17848>>3]*+h[s+25192>>3],386,e);pe[c[(e+8|0)>>2]&3](114,295,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7976>>3]*+h[(c[(d+416|0)>>2]|0)+25192>>3]),387,e);pe[c[(e+8|0)>>2]&3](115,262,-.006,388,e);pe[c[(e+8|0)>>2]&3](115,266,-1.0,389,e);pe[c[(e+8|0)>>2]&3](115,267,+h[(c[(d+416|0)>>2]|0)+17856>>3],390,e);pe[c[(e+8|0)>>2]&3](115,381,-+h[(c[(d+416|0)>>2]|0)+17864>>3],391,e);pe[c[(e+8|0)>>2]&3](116,261,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3],392,e);pe[c[(e+8|0)>>2]&3](116,265,1.0,393,e);pe[c[(e+8|0)>>2]&3](116,288,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+240>>3],394,e);pe[c[(e+8|0)>>2]&3](117,264,1.0,395,e);pe[c[(e+8|0)>>2]&3](117,265,-1.0,396,e);pe[c[(e+8|0)>>2]&3](118,261,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15512>>3],397,e);pe[c[(e+8|0)>>2]&3](118,263,1.0,398,e);pe[c[(e+8|0)>>2]&3](118,288,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15504>>3],399,e);pe[c[(e+8|0)>>2]&3](119,262,1.0,400,e);pe[c[(e+8|0)>>2]&3](119,263,-1.0,401,e);pe[c[(e+8|0)>>2]&3](119,303,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7920>>3],402,e);s=c[(e+8|0)>>2]|0;G=+h[(c[(d+416|0)>>2]|0)+24976>>3];z=c[c[(d+4|0)>>2]>>2]|0;H=+h[(c[z+8>>2]|0)+15040>>3];do{if(G!=0.0){I=-H/G}else{if(H==-0.0){I=-H;break}I=-H/+$Lb(c[d+536>>2]|0,G,8464,8456,+h[z>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](120,258,I,403,e);pe[c[(e+8|0)>>2]&3](120,261,1.0,404,e);s=c[(e+8|0)>>2]|0;I=+h[(c[(d+416|0)>>2]|0)+24976>>3];z=c[c[(d+4|0)>>2]>>2]|0;G=+h[(c[z+8>>2]|0)+15048>>3];do{if(I!=0.0){J=-G/I}else{if(G==-0.0){J=-G;break}J=-G/+$Lb(c[d+536>>2]|0,I,8464,8456,+h[z>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](120,289,J,405,e);s=c[(e+8|0)>>2]|0;J=+h[(c[(d+416|0)>>2]|0)+24976>>3];z=c[c[(d+4|0)>>2]>>2]|0;I=+h[(c[z+8>>2]|0)+208>>3];do{if(J!=0.0){K=I/J}else{if(I==0.0){K=I;break}K=I/+$Lb(c[d+536>>2]|0,J,8464,8456,+h[z>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](120,303,K,406,e);pe[c[(e+8|0)>>2]&3](121,259,+h[(c[(d+416|0)>>2]|0)+25392>>3]*-.4999999999999999,407,e);pe[c[(e+8|0)>>2]&3](121,260,1.0,408,e);pe[c[(e+8|0)>>2]&3](121,290,+h[(c[(d+416|0)>>2]|0)+25392>>3]*-.8660254037844387,409,e);pe[c[(e+8|0)>>2]&3](122,259,1.0,410,e);pe[c[(e+8|0)>>2]&3](122,291,-.4999999999999999,411,e);pe[c[(e+8|0)>>2]&3](123,14,1.0,412,e);pe[c[(e+8|0)>>2]&3](123,258,1.0,413,e);pe[c[(e+8|0)>>2]&3](123,259,-1.0,414,e);pe[c[(e+8|0)>>2]&3](124,254,1.0,415,e);pe[c[(e+8|0)>>2]&3](124,257,1.0,416,e);pe[c[(e+8|0)>>2]&3](124,292,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19640>>3]*-2.0,417,e);pe[c[(e+8|0)>>2]&3](125,256,1.0,418,e);s=$Ob(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19624>>3],1.0e-12)|0;pe[c[(e+8|0)>>2]&3](125,257,-(s<<24>>24!=0?1.0:0.0),419,e);pe[c[(e+8|0)>>2]&3](126,255,1.0,420,e);s=c[(e+8|0)>>2]|0;z=c[c[(d+4|0)>>2]>>2]|0;K=+V(+(+h[(c[z+8>>2]|0)+19616>>3]));if(K!=0.0){L=K}else{L=+$Lb(c[d+536>>2]|0,K,9176,8456,+h[z>>3],(a[d+319|0]|0)!=0|0)}pe[s&3](126,256,-.5/L,421,e);pe[c[(e+8|0)>>2]&3](127,253,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10296>>3]*-2.0,422,e);pe[c[(e+8|0)>>2]&3](127,254,1.0,423,e);pe[c[(e+8|0)>>2]&3](127,294,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10288>>3]*-2.0,424,e);pe[c[(e+8|0)>>2]&3](128,14,-.8660254037844387,425,e);pe[c[(e+8|0)>>2]&3](128,253,-1.0,426,e);pe[c[(e+8|0)>>2]&3](128,295,.4999999999999999,427,e);pe[c[(e+8|0)>>2]&3](129,252,1.0,428,e);pe[c[(e+8|0)>>2]&3](129,298,-1.0,429,e);s=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;z=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](129,303,+h[s+16200>>3]*+h[z+13480>>3]- +h[s+16224>>3]*+h[z+13472>>3],430,e);pe[c[(e+8|0)>>2]&3](130,251,1.0,431,e);pe[c[(e+8|0)>>2]&3](130,252,-1.0,432,e);z=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;s=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](130,303,+h[z+15016>>3]*+h[s+13e3>>3]- +h[z+15e3>>3]*+h[s+12992>>3],433,e);pe[c[(e+8|0)>>2]&3](131,12,.4999999999999999,434,e);pe[c[(e+8|0)>>2]&3](131,250,-1.0,435,e);pe[c[(e+8|0)>>2]&3](131,251,-.8660254037844387,436,e);pe[c[(e+8|0)>>2]&3](132,249,1.0,437,e);pe[c[(e+8|0)>>2]&3](132,250,2.0,438,e);pe[c[(e+8|0)>>2]&3](133,248,1.0,439,e);pe[c[(e+8|0)>>2]&3](133,249,-.5,440,e);pe[c[(e+8|0)>>2]&3](134,198,-((a[(c[(d+424|0)>>2]|0)+227|0]|0)!=0?1.0:-1.0),441,e);pe[c[(e+8|0)>>2]&3](134,247,-1.0,442,e);pe[c[(e+8|0)>>2]&3](134,248,1.0,443,e);pe[c[(e+8|0)>>2]&3](135,246,1.0,444,e);pe[c[(e+8|0)>>2]&3](135,247,-.8660254037844387,445,e);pe[c[(e+8|0)>>2]&3](136,245,1.0,446,e);pe[c[(e+8|0)>>2]&3](136,246,-1.0,447,e);pe[c[(e+8|0)>>2]&3](136,251,1.0,448,e);s=c[(e+8|0)>>2]|0;L=+h[(c[(d+416|0)>>2]|0)+23944>>3];z=c[c[(d+4|0)>>2]>>2]|0;K=+h[(c[z+8>>2]|0)+15008>>3];do{if(L!=0.0){M=-K/L}else{if(K==-0.0){M=-K;break}M=-K/+$Lb(c[d+536>>2]|0,L,9232,8456,+h[z>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](137,201,M,449,e);pe[c[(e+8|0)>>2]&3](137,244,1.0,450,e);s=c[(e+8|0)>>2]|0;M=+h[(c[(d+416|0)>>2]|0)+23944>>3];z=c[c[(d+4|0)>>2]>>2]|0;L=+h[(c[z+8>>2]|0)+15016>>3];do{if(M!=0.0){N=-L/M}else{if(L==-0.0){N=-L;break}N=-L/+$Lb(c[d+536>>2]|0,M,9232,8456,+h[z>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](137,245,N,451,e);s=c[(e+8|0)>>2]|0;N=+h[(c[(d+416|0)>>2]|0)+23944>>3];z=c[c[(d+4|0)>>2]>>2]|0;M=+h[(c[z+8>>2]|0)+680>>3];do{if(N!=0.0){O=-M/N}else{if(M==-0.0){O=-M;break}O=-M/+$Lb(c[d+536>>2]|0,N,9232,8456,+h[z>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](137,303,O,452,e);s=c[(e+8|0)>>2]|0;z=c[c[(d+4|0)>>2]>>2]|0;m=c[z+8>>2]|0;O=+h[m+19760>>3];N=+h[m+720>>3];do{if(O!=0.0){P=N/O}else{if(N==0.0){P=N;break}P=N/+$Lb(c[d+536>>2]|0,O,9288,8456,+h[z>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](138,204,P,453,e);pe[c[(e+8|0)>>2]&3](138,243,1.0,454,e);s=c[(e+8|0)>>2]|0;z=c[c[(d+4|0)>>2]>>2]|0;m=c[z+8>>2]|0;P=+h[m+19760>>3];O=+h[m+712>>3];do{if(P!=0.0){Q=-O/P}else{if(O==-0.0){Q=-O;break}Q=-O/+$Lb(c[d+536>>2]|0,P,9288,8456,+h[z>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](138,244,Q,455,e);pe[c[(e+8|0)>>2]&3](139,242,1.0,456,e);pe[c[(e+8|0)>>2]&3](139,243,-1.0,457,e);pe[c[(e+8|0)>>2]&3](139,303,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7712>>3],458,e);pe[c[(e+8|0)>>2]&3](140,12,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7704>>3]*+h[(c[(d+416|0)>>2]|0)+24160>>3]),459,e);s=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](140,208,+h[s+14840>>3]*+h[s+24160>>3],460,e);pe[c[(e+8|0)>>2]&3](140,241,-1.0,461,e);s=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](140,242,-(+h[s+14848>>3]*+h[s+24160>>3]),462,e);pe[c[(e+8|0)>>2]&3](140,251,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7696>>3]*+h[(c[(d+416|0)>>2]|0)+24160>>3]),463,e);pe[c[(e+8|0)>>2]&3](141,207,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7712>>3],464,e);pe[c[(e+8|0)>>2]&3](141,240,1.0,465,e);pe[c[(e+8|0)>>2]&3](141,241,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7688>>3],466,e);pe[c[(e+8|0)>>2]&3](142,230,-1.0,467,e);pe[c[(e+8|0)>>2]&3](142,239,-1.0,468,e);pe[c[(e+8|0)>>2]&3](142,240,-1.0,469,e);pe[c[(e+8|0)>>2]&3](143,218,-+h[(c[(d+416|0)>>2]|0)+12984>>3],470,e);pe[c[(e+8|0)>>2]&3](143,229,1.0,471,e);pe[c[(e+8|0)>>2]&3](143,238,-1.0,472,e);pe[c[(e+8|0)>>2]&3](143,239,+h[(c[(d+416|0)>>2]|0)+13e3>>3],473,e);pe[c[(e+8|0)>>2]&3](144,222,1.0,474,e);pe[c[(e+8|0)>>2]&3](144,223,-+h[(c[(d+416|0)>>2]|0)+13480>>3],475,e);pe[c[(e+8|0)>>2]&3](144,224,+h[(c[(d+416|0)>>2]|0)+13472>>3],476,e);pe[c[(e+8|0)>>2]&3](144,237,-1.0,477,e);pe[c[(e+8|0)>>2]&3](145,224,-+h[(c[(d+416|0)>>2]|0)+13464>>3],478,e);pe[c[(e+8|0)>>2]&3](145,234,-1.0,479,e);pe[c[(e+8|0)>>2]&3](145,236,-1.0,480,e);pe[c[(e+8|0)>>2]&3](145,238,6.123233995736766e-17,481,e);pe[c[(e+8|0)>>2]&3](145,239,+h[(c[(d+416|0)>>2]|0)+13480>>3],482,e);pe[c[(e+8|0)>>2]&3](146,223,+h[(c[(d+416|0)>>2]|0)+13464>>3],483,e);pe[c[(e+8|0)>>2]&3](146,234,6.123233995736766e-17,484,e);pe[c[(e+8|0)>>2]&3](146,235,-1.0,485,e);pe[c[(e+8|0)>>2]&3](146,238,1.0,486,e);pe[c[(e+8|0)>>2]&3](146,239,-+h[(c[(d+416|0)>>2]|0)+13472>>3],487,e);pe[c[(e+8|0)>>2]&3](147,225,+h[(c[(d+416|0)>>2]|0)+12984>>3],488,e);pe[c[(e+8|0)>>2]&3](147,228,1.0,489,e);pe[c[(e+8|0)>>2]&3](147,234,-1.0,490,e);pe[c[(e+8|0)>>2]&3](147,239,-+h[(c[(d+416|0)>>2]|0)+12992>>3],491,e);pe[c[(e+8|0)>>2]&3](148,207,+h[(c[(d+416|0)>>2]|0)+14832>>3],492,e);pe[c[(e+8|0)>>2]&3](148,208,-.006,493,e);pe[c[(e+8|0)>>2]&3](148,233,-1.0,494,e);pe[c[(e+8|0)>>2]&3](148,241,-+h[(c[(d+416|0)>>2]|0)+14840>>3],495,e);pe[c[(e+8|0)>>2]&3](149,210,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+720>>3],496,e);pe[c[(e+8|0)>>2]&3](149,213,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+800>>3],497,e);pe[c[(e+8|0)>>2]&3](149,232,1.0,498,e);pe[c[(e+8|0)>>2]&3](149,233,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15648>>3],499,e);s=c[(e+8|0)>>2]|0;z=c[c[(d+4|0)>>2]>>2]|0;m=c[z+8>>2]|0;Q=+h[m+7688>>3];P=+h[(c[(d+416|0)>>2]|0)+23944>>3];O=+h[m+15656>>3];do{if(P!=0.0){R=O/P}else{if(O==0.0){R=O;break}R=O/+$Lb(c[d+536>>2]|0,P,9232,8456,+h[z>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](150,216,-(Q*R),500,e);pe[c[(e+8|0)>>2]&3](150,231,1.0,501,e);s=c[(e+8|0)>>2]|0;z=c[c[(d+4|0)>>2]>>2]|0;m=c[z+8>>2]|0;R=+h[m+7688>>3];Q=+h[(c[(d+416|0)>>2]|0)+23944>>3];P=+h[m+15648>>3];do{if(Q!=0.0){S=P/Q}else{if(P==0.0){S=P;break}S=P/+$Lb(c[d+536>>2]|0,Q,9232,8456,+h[z>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](150,232,-(R*S),502,e);pe[c[(e+8|0)>>2]&3](151,220,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7712>>3],503,e);pe[c[(e+8|0)>>2]&3](151,230,1.0,504,e);pe[c[(e+8|0)>>2]&3](151,231,-1.0,505,e);pe[c[(e+8|0)>>2]&3](152,219,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10136>>3],506,e);pe[c[(e+8|0)>>2]&3](152,229,-1.0,507,e);pe[c[(e+8|0)>>2]&3](152,230,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+680>>3],508,e);pe[c[(e+8|0)>>2]&3](152,232,-1.0,509,e);pe[c[(e+8|0)>>2]&3](153,216,-1.0,510,e);pe[c[(e+8|0)>>2]&3](153,226,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10136>>3],511,e);pe[c[(e+8|0)>>2]&3](153,228,-1.0,512,e);pe[c[(e+8|0)>>2]&3](153,230,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+688>>3],513,e);s=c[(e+8|0)>>2]|0;z=c[c[(d+4|0)>>2]>>2]|0;m=c[z+8>>2]|0;S=+h[(c[(d+416|0)>>2]|0)+23944>>3]*+h[m+7688>>3];R=+h[m+15648>>3];do{if(S!=0.0){T=R/S}else{if(R==0.0){T=R;break}T=R/+$Lb(c[d+536>>2]|0,S,9344,8456,+h[z>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](154,212,T,514,e);s=c[(e+8|0)>>2]|0;z=c[c[(d+4|0)>>2]>>2]|0;m=c[z+8>>2]|0;T=+h[m+720>>3];S=+h[(c[(d+416|0)>>2]|0)+23944>>3];R=+h[m+15656>>3];do{if(S!=0.0){W=R/S}else{if(R==0.0){W=R;break}W=R/+$Lb(c[d+536>>2]|0,S,9232,8456,+h[z>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](154,216,-(T*W),515,e);pe[c[(e+8|0)>>2]&3](154,227,1.0,516,e);s=c[(e+8|0)>>2]|0;z=c[c[(d+4|0)>>2]>>2]|0;m=c[z+8>>2]|0;W=+h[m+720>>3];T=+h[(c[(d+416|0)>>2]|0)+23944>>3];S=+h[m+15648>>3];do{if(T!=0.0){X=S/T}else{if(S==0.0){X=S;break}X=S/+$Lb(c[d+536>>2]|0,T,9232,8456,+h[z>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](154,232,-(W*X),517,e);pe[c[(e+8|0)>>2]&3](155,220,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+800>>3],518,e);pe[c[(e+8|0)>>2]&3](155,226,1.0,519,e);pe[c[(e+8|0)>>2]&3](155,227,-1.0,520,e);pe[c[(e+8|0)>>2]&3](156,215,-1.0,521,e);pe[c[(e+8|0)>>2]&3](156,225,-1.0,522,e);pe[c[(e+8|0)>>2]&3](156,226,-1.0,523,e);pe[c[(e+8|0)>>2]&3](157,218,-6.123233995736766e-17,524,e);pe[c[(e+8|0)>>2]&3](157,224,1.0,525,e);pe[c[(e+8|0)>>2]&3](157,225,-1.0,526,e);pe[c[(e+8|0)>>2]&3](158,218,1.0,527,e);pe[c[(e+8|0)>>2]&3](158,223,1.0,528,e);pe[c[(e+8|0)>>2]&3](158,225,-6.123233995736766e-17,529,e);pe[c[(e+8|0)>>2]&3](159,218,+h[(c[(d+416|0)>>2]|0)+12992>>3],530,e);pe[c[(e+8|0)>>2]&3](159,221,1.0,531,e);pe[c[(e+8|0)>>2]&3](159,222,-1.0,532,e);pe[c[(e+8|0)>>2]&3](159,225,-+h[(c[(d+416|0)>>2]|0)+13e3>>3],533,e);pe[c[(e+8|0)>>2]&3](160,212,-1.0,534,e);pe[c[(e+8|0)>>2]&3](160,219,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+688>>3],535,e);pe[c[(e+8|0)>>2]&3](160,221,-1.0,536,e);pe[c[(e+8|0)>>2]&3](160,226,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+680>>3],537,e);s=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19824>>3])),1.0e-10)|0;z=c[(e+8|0)>>2]|0;do{if(s<<24>>24==0){m=c[c[(d+4|0)>>2]>>2]|0;X=+h[(c[m+8>>2]|0)+19824>>3];if(X!=0.0){Y=X;break}Y=+$Lb(c[d+536>>2]|0,X,9440,8456,+h[m>>3],(a[d+319|0]|0)!=0|0)}else{Y=1.0e-10}}while(0);pe[z&3](161,203,1.0/Y,538,e);z=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19824>>3])),1.0e-10)|0;s=c[(e+8|0)>>2]|0;m=c[c[(d+4|0)>>2]>>2]|0;l=c[m+8>>2]|0;if(z<<24>>24!=0){Z=1}else{Z=+h[l+19824>>3]!=0.0}Y=+h[l+15e3>>3]*.8660254037844387+ +h[l+14992>>3]*-.4999999999999999;do{if(Z){if(z<<24>>24!=0){_=1.0e-10}else{_=+h[l+19824>>3]}$=Y/_}else{if(Y==0.0){$=Y;break}if(z<<24>>24!=0){aa=1.0e-10}else{aa=+h[l+19824>>3]}$=Y/+$Lb(c[d+536>>2]|0,aa,9440,8456,+h[m>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](161,217,$,539,e);pe[c[(e+8|0)>>2]&3](161,220,1.0,540,e);s=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19824>>3])),1.0e-10)|0;m=c[(e+8|0)>>2]|0;l=c[c[(d+4|0)>>2]>>2]|0;z=c[l+8>>2]|0;if(s<<24>>24!=0){ba=1}else{ba=+h[z+19824>>3]!=0.0}$=+h[z+15016>>3]*.8660254037844387+ +h[z+15008>>3]*-.4999999999999999;do{if(ba){if(s<<24>>24!=0){ca=1.0e-10}else{ca=+h[z+19824>>3]}da=$/ca}else{if($==0.0){da=$;break}if(s<<24>>24!=0){ea=1.0e-10}else{ea=+h[z+19824>>3]}da=$/+$Lb(c[d+536>>2]|0,ea,9440,8456,+h[l>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](161,227,da,541,e);pe[c[(e+8|0)>>2]&3](162,217,-1.0,542,e);pe[c[(e+8|0)>>2]&3](162,219,1.0,543,e);pe[c[(e+8|0)>>2]&3](162,220,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+792>>3],544,e);pe[c[(e+8|0)>>2]&3](163,214,-1.0,545,e);pe[c[(e+8|0)>>2]&3](163,218,-1.0,546,e);pe[c[(e+8|0)>>2]&3](163,219,-1.0,547,e);m=c[(e+8|0)>>2]|0;l=c[c[(d+4|0)>>2]>>2]|0;z=c[l+8>>2]|0;da=+h[(c[(d+416|0)>>2]|0)+23944>>3]*+h[z+7688>>3];ea=+h[z+15656>>3];do{if(da!=0.0){fa=ea/da}else{if(ea==0.0){fa=ea;break}fa=ea/+$Lb(c[d+536>>2]|0,da,9344,8456,+h[l>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[m&3](164,212,fa,548,e);f=c[(e+8|0)>>2]|0;i=c[c[(d+4|0)>>2]>>2]|0;j=c[i+8>>2]|0;k=+h[j+712>>3];c[b+2304>>2]=f;c[b+2312>>2]=i;c[b+2320>>2]=j;g[b+2328>>2]=k}



function jv(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0.0;e=i;pe[c[(d+8|0)>>2]&3](0,195,-1.0,0,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;j=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](0,298,+h[f+16200>>3]*+h[j+16496>>3]- +h[f+16224>>3]*+h[j+16488>>3],1,d);pe[c[(d+8|0)>>2]&3](0,381,1.0,2,d);j=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](1,298,+h[j+15064>>3]*+h[f+16016>>3]- +h[j+15048>>3]*+h[f+16008>>3],3,d);pe[c[(d+8|0)>>2]&3](1,380,1.0,4,d);pe[c[(d+8|0)>>2]&3](1,381,-1.0,5,d);pe[c[(d+8|0)>>2]&3](2,271,-(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7984>>3]*+h[(c[(b+416|0)>>2]|0)+25192>>3]),6,d);f=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](2,281,-(+h[f+17856>>3]*+h[f+25192>>3]),7,d);f=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](2,295,+h[f+17848>>3]*+h[f+25192>>3],8,d);pe[c[(d+8|0)>>2]&3](2,379,-1.0,9,d);pe[c[(d+8|0)>>2]&3](2,380,-(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7976>>3]*+h[(c[(b+416|0)>>2]|0)+25192>>3]),10,d);pe[c[(d+8|0)>>2]&3](3,294,+h[(c[(b+416|0)>>2]|0)+17864>>3],11,d);pe[c[(d+8|0)>>2]&3](3,295,-5.0e-4,12,d);pe[c[(d+8|0)>>2]&3](3,378,-1.0,13,d);pe[c[(d+8|0)>>2]&3](3,379,-+h[(c[(b+416|0)>>2]|0)+17848>>3],14,d);pe[c[(d+8|0)>>2]&3](4,280,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3],15,d);pe[c[(d+8|0)>>2]&3](4,285,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+15512>>3],16,d);pe[c[(d+8|0)>>2]&3](4,377,1.0,17,d);pe[c[(d+8|0)>>2]&3](4,378,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+312>>3],18,d);f=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+7920>>3]*+h[(c[(b+416|0)>>2]|0)+24976>>3];m=+h[k+15512>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+$Lb(c[b+536>>2]|0,l,11504,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](5,279,n,19,d);f=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;k=c[j+8>>2]|0;n=+h[k+232>>3];l=+h[(c[(b+416|0)>>2]|0)+24976>>3];m=+h[k+15504>>3];do{if(l!=0.0){o=m/l}else{if(m==0.0){o=m;break}o=m/+$Lb(c[b+536>>2]|0,l,8464,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](5,284,-(n*o),20,d);pe[c[(d+8|0)>>2]&3](5,376,1.0,21,d);f=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;k=c[j+8>>2]|0;o=+h[k+232>>3];n=+h[(c[(b+416|0)>>2]|0)+24976>>3];l=+h[k+15512>>3];do{if(n!=0.0){p=l/n}else{if(l==0.0){p=l;break}p=l/+$Lb(c[b+536>>2]|0,n,8464,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](5,377,-(o*p),22,d);f=ZOb(+U(+(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+19664>>3])),1.0e-10)|0;j=c[(d+8|0)>>2]|0;do{if(f<<24>>24==0){k=c[c[(b+4|0)>>2]>>2]|0;p=+h[(c[k+8>>2]|0)+19664>>3];if(p!=0.0){q=p;break}q=+$Lb(c[b+536>>2]|0,p,9056,11496,+h[k>>3],(a[b+319|0]|0)!=0|0)}else{q=1.0e-10}}while(0);pe[j&3](6,262,1.0/q,23,d);j=ZOb(+U(+(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+19664>>3])),1.0e-10)|0;f=c[(d+8|0)>>2]|0;k=c[c[(b+4|0)>>2]>>2]|0;r=c[k+8>>2]|0;if(j<<24>>24!=0){s=1}else{s=+h[r+19664>>3]!=0.0}q=+h[r+15064>>3]*.8660254037844387+ +h[r+15056>>3]*.4999999999999999;do{if(s){if(j<<24>>24!=0){t=1.0e-10}else{t=+h[r+19664>>3]}u=q/t}else{if(q==0.0){u=q;break}if(j<<24>>24!=0){v=1.0e-10}else{v=+h[r+19664>>3]}u=q/+$Lb(c[b+536>>2]|0,v,9056,11496,+h[k>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](6,283,u,24,d);pe[c[(d+8|0)>>2]&3](6,375,1.0,25,d);f=ZOb(+U(+(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+19664>>3])),1.0e-10)|0;k=c[(d+8|0)>>2]|0;r=c[c[(b+4|0)>>2]>>2]|0;j=c[r+8>>2]|0;if(f<<24>>24!=0){w=1}else{w=+h[j+19664>>3]!=0.0}u=+h[j+15048>>3]*.8660254037844387+ +h[j+15040>>3]*.4999999999999999;do{if(w){if(f<<24>>24!=0){x=1.0e-10}else{x=+h[j+19664>>3]}y=u/x}else{if(u==0.0){y=u;break}if(f<<24>>24!=0){z=1.0e-10}else{z=+h[j+19664>>3]}y=u/+$Lb(c[b+536>>2]|0,z,9056,11496,+h[r>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[k&3](6,376,y,26,d);pe[c[(d+8|0)>>2]&3](7,374,1.0,27,d);pe[c[(d+8|0)>>2]&3](7,375,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+312>>3],28,d);pe[c[(d+8|0)>>2]&3](7,376,-1.0,29,d);pe[c[(d+8|0)>>2]&3](8,279,-1.0,30,d);pe[c[(d+8|0)>>2]&3](8,282,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+200>>3],31,d);pe[c[(d+8|0)>>2]&3](8,373,-1.0,32,d);pe[c[(d+8|0)>>2]&3](8,374,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+208>>3],33,d);pe[c[(d+8|0)>>2]&3](9,286,-+h[(c[(b+416|0)>>2]|0)+16016>>3],34,d);pe[c[(d+8|0)>>2]&3](9,292,+h[(c[(b+416|0)>>2]|0)+16008>>3],35,d);pe[c[(d+8|0)>>2]&3](9,372,-1.0,36,d);pe[c[(d+8|0)>>2]&3](9,373,1.0,37,d);pe[c[(d+8|0)>>2]&3](10,289,+h[(c[(b+416|0)>>2]|0)+16496>>3],38,d);pe[c[(d+8|0)>>2]&3](10,291,-+h[(c[(b+416|0)>>2]|0)+16488>>3],39,d);pe[c[(d+8|0)>>2]&3](10,371,1.0,40,d);pe[c[(d+8|0)>>2]&3](10,372,1.0,41,d);pe[c[(d+8|0)>>2]&3](11,289,+h[(c[(b+416|0)>>2]|0)+12904>>3],42,d);pe[c[(d+8|0)>>2]&3](11,291,-+h[(c[(b+416|0)>>2]|0)+12896>>3],43,d);pe[c[(d+8|0)>>2]&3](11,370,-1.0,44,d);pe[c[(d+8|0)>>2]&3](11,371,-1.0,45,d);pe[c[(d+8|0)>>2]&3](12,250,1.0,46,d);pe[c[(d+8|0)>>2]&3](12,369,1.0,47,d);pe[c[(d+8|0)>>2]&3](12,370,1.0,48,d);pe[c[(d+8|0)>>2]&3](13,288,+h[(c[(b+416|0)>>2]|0)+9888>>3],49,d);pe[c[(d+8|0)>>2]&3](13,290,-+h[(c[(b+416|0)>>2]|0)+9880>>3],50,d);pe[c[(d+8|0)>>2]&3](13,368,-1.0,51,d);pe[c[(d+8|0)>>2]&3](13,369,-1.0,52,d);pe[c[(d+8|0)>>2]&3](14,341,1.0,53,d);pe[c[(d+8|0)>>2]&3](14,367,1.0,54,d);pe[c[(d+8|0)>>2]&3](14,368,1.0,55,d);pe[c[(d+8|0)>>2]&3](15,331,+h[(c[(b+416|0)>>2]|0)+10456>>3],56,d);pe[c[(d+8|0)>>2]&3](15,343,-+h[(c[(b+416|0)>>2]|0)+10464>>3],57,d);pe[c[(d+8|0)>>2]&3](15,360,1.0,58,d);pe[c[(d+8|0)>>2]&3](15,367,-1.0,59,d);pe[c[(d+8|0)>>2]&3](16,331,-+h[(c[(b+416|0)>>2]|0)+10448>>3],60,d);pe[c[(d+8|0)>>2]&3](16,356,-.8660254037844386,61,d);pe[c[(d+8|0)>>2]&3](16,357,+h[(c[(b+416|0)>>2]|0)+10464>>3],62,d);pe[c[(d+8|0)>>2]&3](16,364,-1.0,63,d);pe[c[(d+8|0)>>2]&3](16,366,.5000000000000001,64,d);pe[c[(d+8|0)>>2]&3](17,343,+h[(c[(b+416|0)>>2]|0)+10448>>3],65,d);pe[c[(d+8|0)>>2]&3](17,356,-.5000000000000001,66,d);pe[c[(d+8|0)>>2]&3](17,357,-+h[(c[(b+416|0)>>2]|0)+10456>>3],67,d);pe[c[(d+8|0)>>2]&3](17,365,-1.0,68,d);pe[c[(d+8|0)>>2]&3](17,366,-.8660254037844386,69,d);pe[c[(d+8|0)>>2]&3](18,318,+h[(c[(b+416|0)>>2]|0)+9968>>3],70,d);pe[c[(d+8|0)>>2]&3](18,357,-+h[(c[(b+416|0)>>2]|0)+9976>>3],71,d);pe[c[(d+8|0)>>2]&3](18,363,1.0,72,d);pe[c[(d+8|0)>>2]&3](18,366,-1.0,73,d);pe[c[(d+8|0)>>2]&3](19,347,-1.0,74,d);pe[c[(d+8|0)>>2]&3](19,358,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1408>>3],75,d);pe[c[(d+8|0)>>2]&3](19,362,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10016>>3],76,d);pe[c[(d+8|0)>>2]&3](19,363,-1.0,77,d);pe[c[(d+8|0)>>2]&3](20,323,-1.0,78,d);pe[c[(d+8|0)>>2]&3](20,345,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1408>>3],79,d);pe[c[(d+8|0)>>2]&3](20,361,-1.0,80,d);pe[c[(d+8|0)>>2]&3](20,362,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1400>>3],81,d);pe[c[(d+8|0)>>2]&3](21,318,-+h[(c[(b+416|0)>>2]|0)+9984>>3],82,d);pe[c[(d+8|0)>>2]&3](21,344,+h[(c[(b+416|0)>>2]|0)+9976>>3],83,d);pe[c[(d+8|0)>>2]&3](21,360,-1.0,84,d);pe[c[(d+8|0)>>2]&3](21,361,1.0,85,d);pe[c[(d+8|0)>>2]&3](22,326,-1.0,86,d);pe[c[(d+8|0)>>2]&3](22,359,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1520>>3],87,d);pe[c[(d+8|0)>>2]&3](22,362,1.0,88,d);pe[c[(d+8|0)>>2]&3](23,325,-1.0,89,d);pe[c[(d+8|0)>>2]&3](23,358,1.0,90,d);pe[c[(d+8|0)>>2]&3](23,359,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7528>>3],91,d);pe[c[(d+8|0)>>2]&3](24,315,-1.0,92,d);pe[c[(d+8|0)>>2]&3](24,357,-1.0,93,d);pe[c[(d+8|0)>>2]&3](24,358,-1.0,94,d);pe[c[(d+8|0)>>2]&3](25,344,-+h[(c[(b+416|0)>>2]|0)+9968>>3],95,d);pe[c[(d+8|0)>>2]&3](25,355,1.0,96,d);pe[c[(d+8|0)>>2]&3](25,356,-1.0,97,d);pe[c[(d+8|0)>>2]&3](25,357,+h[(c[(b+416|0)>>2]|0)+9984>>3],98,d);pe[c[(d+8|0)>>2]&3](26,324,-1.0,99,d);pe[c[(d+8|0)>>2]&3](26,345,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10016>>3],100,d);pe[c[(d+8|0)>>2]&3](26,355,-1.0,101,d);pe[c[(d+8|0)>>2]&3](26,358,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1400>>3],102,d);k=ZOb(+U(+(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+19984>>3])),1.0e-10)|0;r=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;f=c[j+8>>2]|0;if(k<<24>>24!=0){B=1}else{B=+h[f+19984>>3]!=0.0}y=+h[f+14968>>3]*.8660254037844387+ +h[f+14960>>3]*.4999999999999999;do{if(B){if(k<<24>>24!=0){C=1.0e-10}else{C=+h[f+19984>>3]}D=y/C}else{if(y==0.0){D=y;break}if(k<<24>>24!=0){E=1.0e-10}else{E=+h[f+19984>>3]}D=y/+$Lb(c[b+536>>2]|0,E,9824,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[r&3](27,326,D,103,d);r=ZOb(+U(+(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+19984>>3])),1.0e-10)|0;j=c[(d+8|0)>>2]|0;f=c[c[(b+4|0)>>2]>>2]|0;k=c[f+8>>2]|0;if(r<<24>>24!=0){F=1}else{F=+h[k+19984>>3]!=0.0}D=+h[k+14952>>3]*.8660254037844387+ +h[k+14944>>3]*.4999999999999999;do{if(F){if(r<<24>>24!=0){G=1.0e-10}else{G=+h[k+19984>>3]}J=D/G}else{if(D==0.0){J=D;break}if(r<<24>>24!=0){K=1.0e-10}else{K=+h[k+19984>>3]}J=D/+$Lb(c[b+536>>2]|0,K,9824,11496,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[j&3](27,346,J,104,d);j=ZOb(+U(+(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+19984>>3])),1.0e-10)|0;f=c[(d+8|0)>>2]|0;do{if(j<<24>>24==0){k=c[c[(b+4|0)>>2]>>2]|0;J=+h[(c[k+8>>2]|0)+19984>>3];if(J!=0.0){L=J;break}L=+$Lb(c[b+536>>2]|0,J,9824,11496,+h[k>>3],(a[b+319|0]|0)!=0|0)}else{L=1.0e-10}}while(0);pe[f&3](27,354,1.0/L,105,d);pe[c[(d+8|0)>>2]&3](27,359,1.0,106,d);pe[c[(d+8|0)>>2]&3](28,0,+h[(c[(b+416|0)>>2]|0)+23328>>3]*-.8660254037844387,107,d);pe[c[(d+8|0)>>2]&3](28,353,+h[(c[(b+416|0)>>2]|0)+23328>>3]*-.4999999999999999,108,d);pe[c[(d+8|0)>>2]&3](28,354,1.0,109,d);pe[c[(d+8|0)>>2]&3](29,300,1.0,110,d);pe[c[(d+8|0)>>2]&3](29,352,1.0,111,d);pe[c[(d+8|0)>>2]&3](29,353,-1.0,112,d);f=c[(d+8|0)>>2]|0;L=+h[(c[(b+416|0)>>2]|0)+22912>>3];j=c[c[(b+4|0)>>2]>>2]|0;J=+h[(c[j+8>>2]|0)+14952>>3];do{if(L!=0.0){M=-J/L}else{if(J==-0.0){M=-J;break}M=-J/+$Lb(c[b+536>>2]|0,L,9616,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](30,191,M,113,d);f=c[(d+8|0)>>2]|0;M=+h[(c[(b+416|0)>>2]|0)+22912>>3];j=c[c[(b+4|0)>>2]>>2]|0;L=+h[(c[j+8>>2]|0)+1408>>3];do{if(M!=0.0){N=L/M}else{if(L==0.0){N=L;break}N=L/+$Lb(c[b+536>>2]|0,M,9616,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](30,298,N,114,d);pe[c[(d+8|0)>>2]&3](30,351,1.0,115,d);f=c[(d+8|0)>>2]|0;N=+h[(c[(b+416|0)>>2]|0)+22912>>3];j=c[c[(b+4|0)>>2]>>2]|0;M=+h[(c[j+8>>2]|0)+14944>>3];do{if(N!=0.0){O=-M/N}else{if(M==-0.0){O=-M;break}O=-M/+$Lb(c[b+536>>2]|0,N,9616,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](30,352,O,116,d);pe[c[(d+8|0)>>2]&3](31,309,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+15744>>3],117,d);pe[c[(d+8|0)>>2]&3](31,350,1.0,118,d);pe[c[(d+8|0)>>2]&3](31,351,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+15752>>3],119,d);pe[c[(d+8|0)>>2]&3](32,298,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7504>>3],120,d);pe[c[(d+8|0)>>2]&3](32,349,1.0,121,d);pe[c[(d+8|0)>>2]&3](32,350,-1.0,122,d);pe[c[(d+8|0)>>2]&3](33,317,-+h[(c[(b+416|0)>>2]|0)+11832>>3],123,d);pe[c[(d+8|0)>>2]&3](33,322,+h[(c[(b+416|0)>>2]|0)+11824>>3],124,d);pe[c[(d+8|0)>>2]&3](33,348,-1.0,125,d);pe[c[(d+8|0)>>2]&3](33,349,-.006,126,d);pe[c[(d+8|0)>>2]&3](34,316,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+15752>>3],127,d);pe[c[(d+8|0)>>2]&3](34,321,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1512>>3],128,d);pe[c[(d+8|0)>>2]&3](34,347,1.0,129,d);pe[c[(d+8|0)>>2]&3](34,348,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1432>>3],130,d);f=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;k=c[j+8>>2]|0;O=+h[k+7504>>3]*+h[(c[(b+416|0)>>2]|0)+22912>>3];N=+h[k+15752>>3];do{if(O!=0.0){P=N/O}else{if(N==0.0){P=N;break}P=N/+$Lb(c[b+536>>2]|0,O,11600,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](35,323,P,131,d);f=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;k=c[j+8>>2]|0;P=+h[k+1432>>3];O=+h[(c[(b+416|0)>>2]|0)+22912>>3];N=+h[k+15744>>3];do{if(O!=0.0){Q=N/O}else{if(N==0.0){Q=N;break}Q=N/+$Lb(c[b+536>>2]|0,O,9616,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](35,324,-(P*Q),132,d);pe[c[(d+8|0)>>2]&3](35,346,1.0,133,d);f=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;k=c[j+8>>2]|0;Q=+h[k+1432>>3];P=+h[(c[(b+416|0)>>2]|0)+22912>>3];O=+h[k+15752>>3];do{if(P!=0.0){R=O/P}else{if(O==0.0){R=O;break}R=O/+$Lb(c[b+536>>2]|0,P,9616,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](35,347,-(Q*R),134,d);pe[c[(d+8|0)>>2]&3](36,345,1.0,135,d);pe[c[(d+8|0)>>2]&3](36,346,-1.0,136,d);pe[c[(d+8|0)>>2]&3](36,359,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1512>>3],137,d);pe[c[(d+8|0)>>2]&3](37,320,-1.0,138,d);pe[c[(d+8|0)>>2]&3](37,344,-1.0,139,d);pe[c[(d+8|0)>>2]&3](37,345,-1.0,140,d);pe[c[(d+8|0)>>2]&3](38,318,.8660254037844386,141,d);pe[c[(d+8|0)>>2]&3](38,343,1.0,142,d);pe[c[(d+8|0)>>2]&3](38,344,-.5000000000000001,143,d);pe[c[(d+8|0)>>2]&3](39,288,-1.0,144,d);pe[c[(d+8|0)>>2]&3](39,342,1.0,145,d);pe[c[(d+8|0)>>2]&3](39,343,1.0,146,d);pe[c[(d+8|0)>>2]&3](40,330,-+h[(c[(b+416|0)>>2]|0)+6864>>3],147,d);pe[c[(d+8|0)>>2]&3](40,338,-1.0,148,d);pe[c[(d+8|0)>>2]&3](40,341,-1.0,149,d);pe[c[(d+8|0)>>2]&3](40,342,+h[(c[(b+416|0)>>2]|0)+6872>>3],150,d);pe[c[(d+8|0)>>2]&3](41,172,1.0,151,d);pe[c[(d+8|0)>>2]&3](41,340,1.0,152,d);pe[c[(d+8|0)>>2]&3](41,342,-1.0,153,d);pe[c[(d+8|0)>>2]&3](42,329,-+h[(c[(b+416|0)>>2]|0)+3848>>3],154,d);pe[c[(d+8|0)>>2]&3](42,335,-1.0,155,d);pe[c[(d+8|0)>>2]&3](42,339,-1.0,156,d);pe[c[(d+8|0)>>2]&3](42,340,+h[(c[(b+416|0)>>2]|0)+3856>>3],157,d);pe[c[(d+8|0)>>2]&3](43,181,1.0,158,d);pe[c[(d+8|0)>>2]&3](43,338,1.0,159,d);pe[c[(d+8|0)>>2]&3](43,339,1.0,160,d);pe[c[(d+8|0)>>2]&3](44,111,1.0,161,d);pe[c[(d+8|0)>>2]&3](44,337,1.0,162,d);pe[c[(d+8|0)>>2]&3](44,340,-1.0,163,d);pe[c[(d+8|0)>>2]&3](45,328,-+h[(c[(b+416|0)>>2]|0)+832>>3],164,d);pe[c[(d+8|0)>>2]&3](45,332,-1.0,165,d);pe[c[(d+8|0)>>2]&3](45,336,-1.0,166,d);pe[c[(d+8|0)>>2]&3](45,337,+h[(c[(b+416|0)>>2]|0)+840>>3],167,d);pe[c[(d+8|0)>>2]&3](46,122,1.0,168,d);pe[c[(d+8|0)>>2]&3](46,335,1.0,169,d);pe[c[(d+8|0)>>2]&3](46,336,1.0,170,d);pe[c[(d+8|0)>>2]&3](47,50,1.0,171,d);pe[c[(d+8|0)>>2]&3](47,334,1.0,172,d);pe[c[(d+8|0)>>2]&3](47,337,-1.0,173,d);pe[c[(d+8|0)>>2]&3](48,296,-1.0,174,d);pe[c[(d+8|0)>>2]&3](48,327,-+h[(c[(b+416|0)>>2]|0)+272>>3],175,d);pe[c[(d+8|0)>>2]&3](48,333,-1.0,176,d);pe[c[(d+8|0)>>2]&3](48,334,+h[(c[(b+416|0)>>2]|0)+280>>3],177,d);pe[c[(d+8|0)>>2]&3](49,59,1.0,178,d);pe[c[(d+8|0)>>2]&3](49,332,1.0,179,d);pe[c[(d+8|0)>>2]&3](49,333,1.0,180,d);pe[c[(d+8|0)>>2]&3](50,318,.5000000000000001,181,d);pe[c[(d+8|0)>>2]&3](50,331,1.0,182,d);pe[c[(d+8|0)>>2]&3](50,344,.8660254037844386,183,d);pe[c[(d+8|0)>>2]&3](51,290,-1.0,184,d);pe[c[(d+8|0)>>2]&3](51,330,1.0,185,d);pe[c[(d+8|0)>>2]&3](51,331,1.0,186,d);pe[c[(d+8|0)>>2]&3](52,171,1.0,187,d);pe[c[(d+8|0)>>2]&3](52,329,1.0,188,d);pe[c[(d+8|0)>>2]&3](52,330,-1.0,189,d);pe[c[(d+8|0)>>2]&3](53,110,1.0,190,d);pe[c[(d+8|0)>>2]&3](53,328,1.0,191,d);pe[c[(d+8|0)>>2]&3](53,329,-1.0,192,d);pe[c[(d+8|0)>>2]&3](54,49,1.0,193,d);pe[c[(d+8|0)>>2]&3](54,327,1.0,194,d);pe[c[(d+8|0)>>2]&3](54,328,-1.0,195,d);f=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;k=c[j+8>>2]|0;R=+h[k+7504>>3]*+h[(c[(b+416|0)>>2]|0)+22912>>3];Q=+h[k+15744>>3];do{if(R!=0.0){S=Q/R}else{if(Q==0.0){S=Q;break}S=Q/+$Lb(c[b+536>>2]|0,R,11600,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](55,323,S,196,d);f=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;k=c[j+8>>2]|0;S=+h[k+1440>>3];R=+h[(c[(b+416|0)>>2]|0)+22912>>3];Q=+h[k+15744>>3];do{if(R!=0.0){T=Q/R}else{if(Q==0.0){T=Q;break}T=Q/+$Lb(c[b+536>>2]|0,R,9616,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](55,324,-(S*T),197,d);pe[c[(d+8|0)>>2]&3](55,326,1.0,198,d);f=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;k=c[j+8>>2]|0;T=+h[k+1440>>3];S=+h[(c[(b+416|0)>>2]|0)+22912>>3];R=+h[k+15752>>3];do{if(S!=0.0){V=R/S}else{if(R==0.0){V=R;break}V=R/+$Lb(c[b+536>>2]|0,S,9616,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](55,347,-(T*V),199,d);f=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;k=c[j+8>>2]|0;V=+h[k+7504>>3];T=+h[(c[(b+416|0)>>2]|0)+22912>>3];S=+h[k+15744>>3];do{if(T!=0.0){W=S/T}else{if(S==0.0){W=S;break}W=S/+$Lb(c[b+536>>2]|0,T,9616,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](56,324,-(V*W),200,d);pe[c[(d+8|0)>>2]&3](56,325,1.0,201,d);f=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;k=c[j+8>>2]|0;W=+h[k+7504>>3];V=+h[(c[(b+416|0)>>2]|0)+22912>>3];T=+h[k+15752>>3];do{if(V!=0.0){X=T/V}else{if(T==0.0){X=T;break}X=T/+$Lb(c[b+536>>2]|0,V,9616,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](56,347,-(W*X),202,d);pe[c[(d+8|0)>>2]&3](57,316,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+15744>>3],203,d);pe[c[(d+8|0)>>2]&3](57,321,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1520>>3],204,d);pe[c[(d+8|0)>>2]&3](57,324,1.0,205,d);pe[c[(d+8|0)>>2]&3](57,348,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1440>>3],206,d);pe[c[(d+8|0)>>2]&3](58,321,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7528>>3],207,d);pe[c[(d+8|0)>>2]&3](58,323,1.0,208,d);pe[c[(d+8|0)>>2]&3](58,348,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7504>>3],209,d);pe[c[(d+8|0)>>2]&3](59,192,-(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7560>>3]*+h[(c[(b+416|0)>>2]|0)+23128>>3]),210,d);pe[c[(d+8|0)>>2]&3](59,300,-(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7568>>3]*+h[(c[(b+416|0)>>2]|0)+23128>>3]),211,d);f=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](59,310,+h[f+11816>>3]*+h[f+23128>>3],212,d);pe[c[(d+8|0)>>2]&3](59,322,-1.0,213,d);f=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](59,349,-(+h[f+11824>>3]*+h[f+23128>>3]),214,d);pe[c[(d+8|0)>>2]&3](60,310,-5.0e-4,215,d);pe[c[(d+8|0)>>2]&3](60,312,+h[(c[(b+416|0)>>2]|0)+11832>>3],216,d);pe[c[(d+8|0)>>2]&3](60,321,-1.0,217,d);pe[c[(d+8|0)>>2]&3](60,322,-+h[(c[(b+416|0)>>2]|0)+11816>>3],218,d);pe[c[(d+8|0)>>2]&3](61,312,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1432>>3],219,d);pe[c[(d+8|0)>>2]&3](61,317,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1512>>3],220,d);pe[c[(d+8|0)>>2]&3](61,320,1.0,221,d);pe[c[(d+8|0)>>2]&3](61,322,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+15752>>3],222,d);pe[c[(d+8|0)>>2]&3](62,312,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1440>>3],223,d);pe[c[(d+8|0)>>2]&3](62,317,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1520>>3],224,d);pe[c[(d+8|0)>>2]&3](62,319,1.0,225,d);pe[c[(d+8|0)>>2]&3](62,322,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+15744>>3],226,d);pe[c[(d+8|0)>>2]&3](63,318,-1.0,227,d);pe[c[(d+8|0)>>2]&3](63,319,-1.0,228,d);pe[c[(d+8|0)>>2]&3](63,362,-1.0,229,d);pe[c[(d+8|0)>>2]&3](64,192,-(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7536>>3]*+h[(c[(b+416|0)>>2]|0)+23128>>3]),230,d);pe[c[(d+8|0)>>2]&3](64,300,-(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7544>>3]*+h[(c[(b+416|0)>>2]|0)+23128>>3]),231,d);f=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](64,313,-(+h[f+11816>>3]*+h[f+23128>>3]),232,d);pe[c[(d+8|0)>>2]&3](64,317,-1.0,233,d);f=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](64,349,+h[f+11832>>3]*+h[f+23128>>3],234,d);pe[c[(d+8|0)>>2]&3](65,312,-+h[(c[(b+416|0)>>2]|0)+11824>>3],235,d);pe[c[(d+8|0)>>2]&3](65,313,-.006,236,d);pe[c[(d+8|0)>>2]&3](65,316,-1.0,237,d);pe[c[(d+8|0)>>2]&3](65,317,+h[(c[(b+416|0)>>2]|0)+11816>>3],238,d);pe[c[(d+8|0)>>2]&3](66,312,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7504>>3],239,d);pe[c[(d+8|0)>>2]&3](66,315,1.0,240,d);pe[c[(d+8|0)>>2]&3](66,317,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7528>>3],241,d);pe[c[(d+8|0)>>2]&3](67,309,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1440>>3],242,d);pe[c[(d+8|0)>>2]&3](67,314,1.0,243,d);pe[c[(d+8|0)>>2]&3](67,351,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1432>>3],244,d);pe[c[(d+8|0)>>2]&3](68,313,1.0,245,d);pe[c[(d+8|0)>>2]&3](68,314,-1.0,246,d);pe[c[(d+8|0)>>2]&3](69,192,-(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7512>>3]*+h[(c[(b+416|0)>>2]|0)+23128>>3]),247,d);pe[c[(d+8|0)>>2]&3](69,300,-(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7520>>3]*+h[(c[(b+416|0)>>2]|0)+23128>>3]),248,d);f=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](69,310,-(+h[f+11832>>3]*+h[f+23128>>3]),249,d);pe[c[(d+8|0)>>2]&3](69,312,-1.0,250,d);f=c[(b+416|0)>>2]|0;pe[c[(d+8|0)>>2]&3](69,313,+h[f+11824>>3]*+h[f+23128>>3],251,d);f=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;k=c[j+8>>2]|0;X=+h[k+19920>>3];W=+h[k+1432>>3];do{if(X!=0.0){Y=-W/X}else{if(W==-0.0){Y=-W;break}Y=-W/+$Lb(c[b+536>>2]|0,X,9672,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](70,309,Y,252,d);pe[c[(d+8|0)>>2]&3](70,311,1.0,253,d);f=c[(d+8|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;k=c[j+8>>2]|0;Y=+h[k+19920>>3];X=+h[k+1440>>3];do{if(Y!=0.0){Z=X/Y}else{if(X==0.0){Z=X;break}Z=X/+$Lb(c[b+536>>2]|0,Y,9672,11496,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);pe[f&3](70,351,Z,254,d);c[e+8>>2]=b;c[e+16>>2]=d;c[e+8920>>2]=0;c[e+8924>>2]=0;_setLinearMatrixA4256$3(e);c[e+8>>2]=b;c[e+16>>2]=d;c[e+3792>>2]=_;g[e+3800>>2]=$;c[e+3808>>2]=aa;g[e+3816>>2]=ba;c[e+8912>>2]=0;c[e+8916>>2]=0;_setLinearMatrixA4256$2(e);_=c[e+3792>>2]|0;$=+g[e+3800>>2];aa=c[e+3808>>2]|0;ba=+g[e+3816>>2];c[e+8>>2]=b;c[e+16>>2]=d;c[e+3792>>2]=_;g[e+3800>>2]=$;c[e+3808>>2]=aa;g[e+3816>>2]=ba;c[e+8904>>2]=0;c[e+8908>>2]=0;_setLinearMatrixA4256$1(e);c[e+8>>2]=b;c[e+16>>2]=d;c[e+8896>>2]=0;c[e+8900>>2]=0;_setLinearMatrixA4256$0(e);H=c[e+8896>>2]|0;A=c[e+8900>>2]|0;I=+g[e+8900>>2];c[e+8896>>2]=0;c[e+8900>>2]=0;if((H|0)==5){return}}function _setLinearMatrixA4256$0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0.0,Xa=0.0,Ya=0,Za=0,_a=0,$a=0.0,ab=0,bb=0,cb=0,db=0.0,eb=0.0,fb=0.0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0.0,tb=0,ub=0,vb=0,wb=0,xb=0.0,yb=0.0,zb=0,Ab=0,Bb=0,Cb=0.0,Db=0,Eb=0,Fb=0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0.0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0,bc=0,cc=0,dc=0.0,ec=0,fc=0,gc=0,hc=0.0,ic=0.0,jc=0.0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0.0,xc=0,yc=0,zc=0,Ac=0,Bc=0.0,Cc=0.0,Dc=0,Ec=0,Fc=0,Gc=0.0,Hc=0,Ic=0,Jc=0,Kc=0.0,Lc=0.0,Mc=0.0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0.0,_c=0,$c=0,ad=0,bd=0,cd=0.0,dd=0.0,ed=0,fd=0,gd=0,hd=0.0,id=0,jd=0,kd=0,ld=0.0,md=0.0,nd=0.0,od=0,pd=0,qd=0,rd=0,sd=0,td=0.0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0.0,Ad=0.0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0.0,Kd=0,Ld=0,Md=0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0.0,Xd=0,Yd=0,Zd=0,_d=0.0,$d=0.0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0.0,me=0,ne=0,oe=0,qe=0,re=0.0,se=0.0,te=0,ue=0,ve=0,we=0.0,xe=0,ye=0,ze=0,Ae=0.0,Be=0.0,Ce=0.0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0.0,Pe=0,Qe=0,Re=0,Se=0,Te=0.0,Ue=0.0,Ve=0,We=0,Xe=0,Ye=0.0,Ze=0,_e=0,$e=0,af=0.0,bf=0.0,cf=0.0,df=0,ef=0;d=c[b+8>>2]|0;e=c[b+16>>2]|0;a:do{pe[c[(e+8|0)>>2]&3](319,45,-+h[(c[(d+416|0)>>2]|0)+928>>3],1068,e);pe[c[(e+8|0)>>2]&3](319,47,+h[(c[(d+416|0)>>2]|0)+920>>3],1069,e);pe[c[(e+8|0)>>2]&3](319,62,-1.0,1070,e);pe[c[(e+8|0)>>2]&3](319,63,1.0,1071,e);pe[c[(e+8|0)>>2]&3](320,49,+h[(c[(d+416|0)>>2]|0)+1408>>3],1072,e);pe[c[(e+8|0)>>2]&3](320,50,-+h[(c[(d+416|0)>>2]|0)+1416>>3],1073,e);pe[c[(e+8|0)>>2]&3](320,52,1.0,1074,e);pe[c[(e+8|0)>>2]&3](320,59,-1.0,1075,e);pe[c[(e+8|0)>>2]&3](321,45,+h[(c[(d+416|0)>>2]|0)+1416>>3],1076,e);pe[c[(e+8|0)>>2]&3](321,49,-+h[(c[(d+416|0)>>2]|0)+1400>>3],1077,e);pe[c[(e+8|0)>>2]&3](321,54,.8660254037844387,1078,e);pe[c[(e+8|0)>>2]&3](321,60,-1.0,1079,e);pe[c[(e+8|0)>>2]&3](321,62,.4999999999999999,1080,e);pe[c[(e+8|0)>>2]&3](322,45,-+h[(c[(d+416|0)>>2]|0)+1408>>3],1081,e);pe[c[(e+8|0)>>2]&3](322,50,+h[(c[(d+416|0)>>2]|0)+1400>>3],1082,e);pe[c[(e+8|0)>>2]&3](322,54,-.4999999999999999,1083,e);pe[c[(e+8|0)>>2]&3](322,61,-1.0,1084,e);pe[c[(e+8|0)>>2]&3](322,62,.8660254037844387,1085,e);f=c[(e+8|0)>>2]|0;g=c[c[(d+4|0)>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6952>>3]*+h[(c[(d+416|0)>>2]|0)+19816>>3];l=+h[j+16040>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+$Lb(c[d+536>>2]|0,k,11984,11496,+h[g>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](323,41,m,1086,e);g=c[(e+8|0)>>2]|0;j=c[c[(d+4|0)>>2]>>2]|0;n=c[j+8>>2]|0;k=+h[n+3592>>3];l=+h[(c[(d+416|0)>>2]|0)+19816>>3];o=+h[n+16032>>3];do{if(l!=0.0){p=o/l}else{if(o==0.0){p=o;break}p=o/+$Lb(c[d+536>>2]|0,l,10384,11496,+h[j>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](323,42,-(k*p),1087,e);pe[c[(e+8|0)>>2]&3](323,58,1.0,1088,e);j=c[(e+8|0)>>2]|0;f=c[c[(d+4|0)>>2]>>2]|0;n=c[f+8>>2]|0;l=+h[n+3592>>3];o=+h[(c[(d+416|0)>>2]|0)+19816>>3];q=+h[n+16040>>3];do{if(o!=0.0){r=q/o}else{if(q==0.0){r=q;break}r=q/+$Lb(c[d+536>>2]|0,o,10384,11496,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[j&3](323,64,-(l*r),1089,e);f=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20464>>3])),1.0e-10)|0;g=c[(e+8|0)>>2]|0;do{if(f<<24>>24==0){n=c[c[(d+4|0)>>2]>>2]|0;o=+h[(c[n+8>>2]|0)+20464>>3];if(o!=0.0){s=o;break}s=+$Lb(c[d+536>>2]|0,o,10592,11496,+h[n>>3],(a[d+319|0]|0)!=0|0)}else{s=1.0e-10}}while(0);pe[g&3](324,16,1.0/s,1090,e);f=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20464>>3])),1.0e-10)|0;j=c[(e+8|0)>>2]|0;n=c[c[(d+4|0)>>2]>>2]|0;t=c[n+8>>2]|0;if(f<<24>>24!=0){u=1}else{u=+h[t+20464>>3]!=0.0}l=+h[t+14824>>3]*.8660254037844387+ +h[t+14816>>3]*-.4999999999999999;do{if(u){if(f<<24>>24!=0){v=1.0e-10}else{v=+h[t+20464>>3]}w=l/v}else{if(l==0.0){w=l;break}if(f<<24>>24!=0){x=1.0e-10}else{x=+h[t+20464>>3]}w=l/+$Lb(c[d+536>>2]|0,x,10592,11496,+h[n>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[j&3](324,44,w,1091,e);pe[c[(e+8|0)>>2]&3](324,57,1.0,1092,e);n=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20464>>3])),1.0e-10)|0;t=c[(e+8|0)>>2]|0;f=c[c[(d+4|0)>>2]>>2]|0;g=c[f+8>>2]|0;if(n<<24>>24!=0){y=1}else{y=+h[g+20464>>3]!=0.0}l=+h[g+14808>>3]*.8660254037844387+ +h[g+14800>>3]*-.4999999999999999;do{if(y){if(n<<24>>24!=0){z=1.0e-10}else{z=+h[g+20464>>3]}A=l/z}else{if(l==0.0){A=l;break}if(n<<24>>24!=0){B=1.0e-10}else{B=+h[g+20464>>3]}A=l/+$Lb(c[d+536>>2]|0,B,10592,11496,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[t&3](324,58,A,1093,e);pe[c[(e+8|0)>>2]&3](325,56,1.0,1094,e);pe[c[(e+8|0)>>2]&3](325,57,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3672>>3],1095,e);pe[c[(e+8|0)>>2]&3](325,58,-1.0,1096,e);pe[c[(e+8|0)>>2]&3](326,42,-1.0,1097,e);pe[c[(e+8|0)>>2]&3](326,46,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3560>>3],1098,e);pe[c[(e+8|0)>>2]&3](326,55,-1.0,1099,e);pe[c[(e+8|0)>>2]&3](326,56,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9656>>3],1100,e);pe[c[(e+8|0)>>2]&3](327,45,+h[(c[(d+416|0)>>2]|0)+936>>3],1101,e);pe[c[(e+8|0)>>2]&3](327,51,-+h[(c[(d+416|0)>>2]|0)+920>>3],1102,e);pe[c[(e+8|0)>>2]&3](327,54,-1.0,1103,e);pe[c[(e+8|0)>>2]&3](327,55,1.0,1104,e);pe[c[(e+8|0)>>2]&3](328,41,-1.0,1105,e);pe[c[(e+8|0)>>2]&3](328,48,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3560>>3],1106,e);pe[c[(e+8|0)>>2]&3](328,53,-1.0,1107,e);pe[c[(e+8|0)>>2]&3](328,56,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3568>>3],1108,e);pe[c[(e+8|0)>>2]&3](329,47,-+h[(c[(d+416|0)>>2]|0)+936>>3],1109,e);pe[c[(e+8|0)>>2]&3](329,51,+h[(c[(d+416|0)>>2]|0)+928>>3],1110,e);pe[c[(e+8|0)>>2]&3](329,52,-1.0,1111,e);pe[c[(e+8|0)>>2]&3](329,53,1.0,1112,e);pe[c[(e+8|0)>>2]&3](330,38,-1.0,1113,e);pe[c[(e+8|0)>>2]&3](330,51,-1.0,1114,e);pe[c[(e+8|0)>>2]&3](330,56,-1.0,1115,e);pe[c[(e+8|0)>>2]&3](331,47,-.8660254037844387,1116,e);pe[c[(e+8|0)>>2]&3](331,50,1.0,1117,e);pe[c[(e+8|0)>>2]&3](331,51,-.4999999999999999,1118,e);pe[c[(e+8|0)>>2]&3](332,47,.4999999999999999,1119,e);pe[c[(e+8|0)>>2]&3](332,49,1.0,1120,e);pe[c[(e+8|0)>>2]&3](332,51,-.8660254037844387,1121,e);pe[c[(e+8|0)>>2]&3](333,44,-1.0,1122,e);pe[c[(e+8|0)>>2]&3](333,48,1.0,1123,e);pe[c[(e+8|0)>>2]&3](333,57,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3680>>3],1124,e);pe[c[(e+8|0)>>2]&3](334,37,-1.0,1125,e);pe[c[(e+8|0)>>2]&3](334,47,-1.0,1126,e);pe[c[(e+8|0)>>2]&3](334,48,-1.0,1127,e);pe[c[(e+8|0)>>2]&3](335,43,-1.0,1128,e);pe[c[(e+8|0)>>2]&3](335,46,1.0,1129,e);pe[c[(e+8|0)>>2]&3](335,57,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6976>>3],1130,e);pe[c[(e+8|0)>>2]&3](336,34,-1.0,1131,e);pe[c[(e+8|0)>>2]&3](336,45,-1.0,1132,e);pe[c[(e+8|0)>>2]&3](336,46,-1.0,1133,e);f=c[(e+8|0)>>2]|0;g=c[c[(d+4|0)>>2]>>2]|0;n=c[g+8>>2]|0;l=+h[n+6952>>3]*+h[(c[(d+416|0)>>2]|0)+19816>>3];o=+h[n+16032>>3];do{if(l!=0.0){C=o/l}else{if(o==0.0){C=o;break}C=o/+$Lb(c[d+536>>2]|0,l,11984,11496,+h[g>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](337,41,C,1134,e);g=c[(e+8|0)>>2]|0;t=c[c[(d+4|0)>>2]>>2]|0;n=c[t+8>>2]|0;l=+h[n+3600>>3];o=+h[(c[(d+416|0)>>2]|0)+19816>>3];q=+h[n+16032>>3];do{if(o!=0.0){D=q/o}else{if(q==0.0){D=q;break}D=q/+$Lb(c[d+536>>2]|0,o,10384,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](337,42,-(l*D),1135,e);pe[c[(e+8|0)>>2]&3](337,44,1.0,1136,e);t=c[(e+8|0)>>2]|0;f=c[c[(d+4|0)>>2]>>2]|0;n=c[f+8>>2]|0;o=+h[n+3600>>3];q=+h[(c[(d+416|0)>>2]|0)+19816>>3];k=+h[n+16040>>3];do{if(q!=0.0){E=k/q}else{if(k==0.0){E=k;break}E=k/+$Lb(c[d+536>>2]|0,q,10384,11496,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[t&3](337,64,-(o*E),1137,e);f=c[(e+8|0)>>2]|0;g=c[c[(d+4|0)>>2]>>2]|0;n=c[g+8>>2]|0;q=+h[n+6952>>3];k=+h[(c[(d+416|0)>>2]|0)+19816>>3];l=+h[n+16032>>3];do{if(k!=0.0){F=l/k}else{if(l==0.0){F=l;break}F=l/+$Lb(c[d+536>>2]|0,k,10384,11496,+h[g>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](338,42,-(q*F),1138,e);pe[c[(e+8|0)>>2]&3](338,43,1.0,1139,e);g=c[(e+8|0)>>2]|0;t=c[c[(d+4|0)>>2]>>2]|0;n=c[t+8>>2]|0;k=+h[n+6952>>3];l=+h[(c[(d+416|0)>>2]|0)+19816>>3];o=+h[n+16040>>3];do{if(l!=0.0){G=o/l}else{if(o==0.0){G=o;break}G=o/+$Lb(c[d+536>>2]|0,l,10384,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](338,64,-(k*G),1140,e);pe[c[(e+8|0)>>2]&3](339,35,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+16032>>3],1141,e);pe[c[(e+8|0)>>2]&3](339,39,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3600>>3],1142,e);pe[c[(e+8|0)>>2]&3](339,42,1.0,1143,e);pe[c[(e+8|0)>>2]&3](339,65,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3680>>3],1144,e);pe[c[(e+8|0)>>2]&3](340,39,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6952>>3],1145,e);pe[c[(e+8|0)>>2]&3](340,41,1.0,1146,e);pe[c[(e+8|0)>>2]&3](340,65,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6976>>3],1147,e);pe[c[(e+8|0)>>2]&3](341,10,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7008>>3]*+h[(c[(d+416|0)>>2]|0)+20032>>3]),1148,e);pe[c[(e+8|0)>>2]&3](341,25,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7016>>3]*+h[(c[(d+416|0)>>2]|0)+20032>>3]),1149,e);t=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](341,33,-(+h[t+2776>>3]*+h[t+20032>>3]),1150,e);pe[c[(e+8|0)>>2]&3](341,40,-1.0,1151,e);t=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](341,66,+h[t+2768>>3]*+h[t+20032>>3],1152,e);pe[c[(e+8|0)>>2]&3](342,32,-+h[(c[(d+416|0)>>2]|0)+2784>>3],1153,e);pe[c[(e+8|0)>>2]&3](342,33,-.006,1154,e);pe[c[(e+8|0)>>2]&3](342,39,-1.0,1155,e);pe[c[(e+8|0)>>2]&3](342,40,+h[(c[(d+416|0)>>2]|0)+2776>>3],1156,e);pe[c[(e+8|0)>>2]&3](343,32,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3672>>3],1157,e);pe[c[(e+8|0)>>2]&3](343,36,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3592>>3],1158,e);pe[c[(e+8|0)>>2]&3](343,38,1.0,1159,e);pe[c[(e+8|0)>>2]&3](343,40,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+16040>>3],1160,e);pe[c[(e+8|0)>>2]&3](344,32,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3680>>3],1161,e);pe[c[(e+8|0)>>2]&3](344,36,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3600>>3],1162,e);pe[c[(e+8|0)>>2]&3](344,37,1.0,1163,e);pe[c[(e+8|0)>>2]&3](344,40,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+16032>>3],1164,e);pe[c[(e+8|0)>>2]&3](345,10,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6960>>3]*+h[(c[(d+416|0)>>2]|0)+20032>>3]),1165,e);pe[c[(e+8|0)>>2]&3](345,25,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6968>>3]*+h[(c[(d+416|0)>>2]|0)+20032>>3]),1166,e);t=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](345,28,+h[t+2776>>3]*+h[t+20032>>3],1167,e);pe[c[(e+8|0)>>2]&3](345,36,-1.0,1168,e);t=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](345,66,-(+h[t+2784>>3]*+h[t+20032>>3]),1169,e);pe[c[(e+8|0)>>2]&3](346,28,-.006,1170,e);pe[c[(e+8|0)>>2]&3](346,32,+h[(c[(d+416|0)>>2]|0)+2768>>3],1171,e);pe[c[(e+8|0)>>2]&3](346,35,-1.0,1172,e);pe[c[(e+8|0)>>2]&3](346,36,-+h[(c[(d+416|0)>>2]|0)+2776>>3],1173,e);pe[c[(e+8|0)>>2]&3](347,32,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6976>>3],1174,e);pe[c[(e+8|0)>>2]&3](347,34,1.0,1175,e);pe[c[(e+8|0)>>2]&3](347,36,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6952>>3],1176,e);pe[c[(e+8|0)>>2]&3](348,30,-1.0,1177,e);pe[c[(e+8|0)>>2]&3](348,33,1.0,1178,e);pe[c[(e+8|0)>>2]&3](348,298,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6952>>3],1179,e);pe[c[(e+8|0)>>2]&3](349,10,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6984>>3]*+h[(c[(d+416|0)>>2]|0)+20032>>3]),1180,e);pe[c[(e+8|0)>>2]&3](349,25,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6992>>3]*+h[(c[(d+416|0)>>2]|0)+20032>>3]),1181,e);t=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](349,28,-(+h[t+2768>>3]*+h[t+20032>>3]),1182,e);pe[c[(e+8|0)>>2]&3](349,32,-1.0,1183,e);t=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](349,33,+h[t+2784>>3]*+h[t+20032>>3],1184,e);t=c[(e+8|0)>>2]|0;l=+h[(c[(d+416|0)>>2]|0)+19816>>3];f=c[c[(d+4|0)>>2]>>2]|0;o=+h[(c[f+8>>2]|0)+14808>>3];do{if(l!=0.0){H=-o/l}else{if(o==-0.0){H=-o;break}H=-o/+$Lb(c[d+536>>2]|0,l,10384,11496,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[t&3](350,14,H,1185,e);f=c[(e+8|0)>>2]|0;l=+h[(c[(d+416|0)>>2]|0)+19816>>3];g=c[c[(d+4|0)>>2]>>2]|0;o=+h[(c[g+8>>2]|0)+14800>>3];do{if(l!=0.0){I=-o/l}else{if(o==-0.0){I=-o;break}I=-o/+$Lb(c[d+536>>2]|0,l,10384,11496,+h[g>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](350,24,I,1186,e);pe[c[(e+8|0)>>2]&3](350,31,1.0,1187,e);g=c[(e+8|0)>>2]|0;l=+h[(c[(d+416|0)>>2]|0)+19816>>3];t=c[c[(d+4|0)>>2]>>2]|0;o=+h[(c[t+8>>2]|0)+3568>>3];do{if(l!=0.0){J=o/l}else{if(o==0.0){J=o;break}J=o/+$Lb(c[d+536>>2]|0,l,10384,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](350,298,J,1188,e);pe[c[(e+8|0)>>2]&3](351,26,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+16032>>3],1189,e);pe[c[(e+8|0)>>2]&3](351,30,1.0,1190,e);pe[c[(e+8|0)>>2]&3](351,31,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+16040>>3],1191,e);pe[c[(e+8|0)>>2]&3](352,26,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3600>>3],1192,e);pe[c[(e+8|0)>>2]&3](352,29,1.0,1193,e);pe[c[(e+8|0)>>2]&3](352,31,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3592>>3],1194,e);pe[c[(e+8|0)>>2]&3](353,28,1.0,1195,e);pe[c[(e+8|0)>>2]&3](353,29,-1.0,1196,e);t=c[(e+8|0)>>2]|0;f=c[c[(d+4|0)>>2]>>2]|0;n=c[f+8>>2]|0;l=+h[n+20400>>3];o=+h[n+3592>>3];do{if(l!=0.0){K=-o/l}else{if(o==-0.0){K=-o;break}K=-o/+$Lb(c[d+536>>2]|0,l,10440,11496,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[t&3](354,26,K,1197,e);pe[c[(e+8|0)>>2]&3](354,27,1.0,1198,e);f=c[(e+8|0)>>2]|0;g=c[c[(d+4|0)>>2]>>2]|0;n=c[g+8>>2]|0;l=+h[n+20400>>3];o=+h[n+3600>>3];do{if(l!=0.0){L=o/l}else{if(o==0.0){L=o;break}L=o/+$Lb(c[d+536>>2]|0,l,10440,11496,+h[g>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](354,31,L,1199,e);g=c[(e+8|0)>>2]|0;l=+h[(c[(d+416|0)>>2]|0)+19816>>3];t=c[c[(d+4|0)>>2]>>2]|0;o=+h[(c[t+8>>2]|0)+14824>>3];do{if(l!=0.0){M=-o/l}else{if(o==-0.0){M=-o;break}M=-o/+$Lb(c[d+536>>2]|0,l,10384,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](355,14,M,1200,e);t=c[(e+8|0)>>2]|0;l=+h[(c[(d+416|0)>>2]|0)+19816>>3];f=c[c[(d+4|0)>>2]>>2]|0;o=+h[(c[f+8>>2]|0)+14816>>3];do{if(l!=0.0){N=-o/l}else{if(o==-0.0){N=-o;break}N=-o/+$Lb(c[d+536>>2]|0,l,10384,11496,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[t&3](355,24,N,1201,e);pe[c[(e+8|0)>>2]&3](355,26,1.0,1202,e);f=c[(e+8|0)>>2]|0;l=+h[(c[(d+416|0)>>2]|0)+19816>>3];g=c[c[(d+4|0)>>2]>>2]|0;o=+h[(c[g+8>>2]|0)+3560>>3];do{if(l!=0.0){O=-o/l}else{if(o==-0.0){O=-o;break}O=-o/+$Lb(c[d+536>>2]|0,l,10384,11496,+h[g>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](355,298,O,1203,e);pe[c[(e+8|0)>>2]&3](356,9,-1.0,1204,e);pe[c[(e+8|0)>>2]&3](356,25,1.0,1205,e);g=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;t=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](356,298,+h[g+14816>>3]*+h[t+936>>3]- +h[g+14800>>3]*+h[t+928>>3],1206,e);pe[c[(e+8|0)>>2]&3](357,17,-1.0,1207,e);pe[c[(e+8|0)>>2]&3](357,24,1.0,1208,e);pe[c[(e+8|0)>>2]&3](357,25,1.0,1209,e);pe[c[(e+8|0)>>2]&3](358,10,-.4999999999999999,1210,e);pe[c[(e+8|0)>>2]&3](358,23,-1.0,1211,e);pe[c[(e+8|0)>>2]&3](358,25,-.8660254037844387,1212,e);pe[c[(e+8|0)>>2]&3](359,13,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9688>>3]*-2.0,1213,e);pe[c[(e+8|0)>>2]&3](359,22,1.0,1214,e);pe[c[(e+8|0)>>2]&3](359,23,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9696>>3]*-2.0,1215,e);pe[c[(e+8|0)>>2]&3](360,11,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20440>>3]*-2.0,1216,e);pe[c[(e+8|0)>>2]&3](360,21,1.0,1217,e);pe[c[(e+8|0)>>2]&3](360,22,1.0,1218,e);pe[c[(e+8|0)>>2]&3](361,20,1.0,1219,e);t=$Ob(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20424>>3],1.0e-12)|0;pe[c[(e+8|0)>>2]&3](361,21,-(t<<24>>24!=0?1.0:0.0),1220,e);pe[c[(e+8|0)>>2]&3](362,19,1.0,1221,e);t=c[(e+8|0)>>2]|0;g=c[c[(d+4|0)>>2]>>2]|0;l=+V(+(+h[(c[g+8>>2]|0)+20416>>3]));if(l!=0.0){P=l;Q=-.5/P;pe[t&3](362,20,Q,1222,e);R=c[(e+8|0)>>2]|0;pe[R&3](363,11,1.0,1223,e);S=c[(e+8|0)>>2]|0;pe[S&3](363,18,-1.0,1224,e);T=c[(e+8|0)>>2]|0;W=c[(d+424|0)>>2]|0;X=W;Y=X+35|0;Z=Y;_=a[Z]|0;$=_<<24>>24!=0;aa=$?1.0:-1.0;ba=-aa;pe[T&3](363,19,ba,1225,e);ca=c[(e+8|0)>>2]|0;pe[ca&3](364,17,1.0,1226,e);da=c[(e+8|0)>>2]|0;pe[da&3](364,18,.4999999999999999,1227,e);ea=c[(e+8|0)>>2]|0;fa=c[(d+416|0)>>2]|0;ga=fa;ha=ga+20232|0;ia=ha;ja=+h[ia>>3];ka=ja*-.8660254037844387;pe[ea&3](365,15,ka,1228,e);la=c[(e+8|0)>>2]|0;pe[la&3](365,16,1.0,1229,e);ma=c[(e+8|0)>>2]|0;na=c[(d+416|0)>>2]|0;oa=na;pa=oa+20232|0;qa=pa;ra=+h[qa>>3];sa=ra*.4999999999999999;pe[ma&3](365,17,sa,1230,e);ta=c[(e+8|0)>>2]|0;pe[ta&3](366,15,1.0,1231,e);ua=c[(e+8|0)>>2]|0;pe[ua&3](366,18,-.8660254037844387,1232,e);va=c[(e+8|0)>>2]|0;pe[va&3](367,10,1.0,1233,e);wa=c[(e+8|0)>>2]|0;pe[wa&3](367,14,1.0,1234,e);xa=c[(e+8|0)>>2]|0;pe[xa&3](367,15,-1.0,1235,e);ya=c[(e+8|0)>>2]|0;pe[ya&3](368,10,-.8660254037844387,1236,e);za=c[(e+8|0)>>2]|0;pe[za&3](368,13,-1.0,1237,e);Aa=c[(e+8|0)>>2]|0;pe[Aa&3](368,25,.4999999999999999,1238,e);Ba=c[(e+8|0)>>2]|0;pe[Ba&3](369,12,1.0,1239,e);Ca=c[(e+8|0)>>2]|0;pe[Ca&3](369,13,2.0,1240,e);Da=c[(e+8|0)>>2]|0;pe[Da&3](370,11,1.0,1241,e);Ea=c[(e+8|0)>>2]|0;pe[Ea&3](370,12,-.5,1242,e);Fa=c[(e+8|0)>>2]|0;pe[Fa&3](371,8,-1.0,1243,e);Ga=c[(e+8|0)>>2]|0;pe[Ga&3](371,10,1.0,1244,e);Ha=c[(e+8|0)>>2]|0;Ia=c[(d+4|0)>>2]|0;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+8|0;Ma=La;Na=c[Ma>>2]|0;Oa=Na;Pa=Oa+14824|0;Qa=Pa;Ra=+h[Qa>>3];Sa=c[(d+416|0)>>2]|0;Ta=Sa;Ua=Ta+936|0;Va=Ua;Wa=+h[Va>>3];Xa=Ra*Wa;Ya=Na;Za=Ya+14808|0;_a=Za;$a=+h[_a>>3];ab=Sa;bb=ab+928|0;cb=bb;db=+h[cb>>3];eb=$a*db;fb=Xa-eb;pe[Ha&3](371,298,fb,1245,e);gb=c[(e+8|0)>>2]|0;pe[gb&3](372,2,-1.0,1246,e);hb=c[(e+8|0)>>2]|0;pe[hb&3](372,9,1.0,1247,e);ib=c[(e+8|0)>>2]|0;jb=c[(d+4|0)>>2]|0;kb=c[jb>>2]|0;lb=kb;mb=lb+8|0;nb=mb;ob=c[nb>>2]|0;pb=ob;qb=pb+16208|0;rb=qb;sb=+h[rb>>3];tb=c[(d+416|0)>>2]|0;ub=tb;vb=ub+1416|0;wb=vb;xb=+h[wb>>3];yb=sb*xb;zb=ob;Ab=zb+16232|0;Bb=Ab;Cb=+h[Bb>>3];Db=tb;Eb=Db+1408|0;Fb=Eb;Gb=+h[Fb>>3];Hb=Cb*Gb;Ib=yb-Hb;pe[ib&3](372,298,Ib,1248,e);Jb=c[(e+8|0)>>2]|0;pe[Jb&3](373,1,-1.0,1249,e);Kb=c[(e+8|0)>>2]|0;pe[Kb&3](373,8,1.0,1250,e);Lb=c[(e+8|0)>>2]|0;Mb=c[(d+4|0)>>2]|0;Nb=c[Mb>>2]|0;Ob=Nb;Pb=Ob+8|0;Qb=Pb;Rb=c[Qb>>2]|0;Sb=Rb;Tb=Sb+16200|0;Ub=Tb;Vb=+h[Ub>>3];Wb=c[(d+416|0)>>2]|0;Xb=Wb;Yb=Xb+1416|0;Zb=Yb;_b=+h[Zb>>3];$b=Vb*_b;ac=Rb;bc=ac+16224|0;cc=bc;dc=+h[cc>>3];ec=Wb;fc=ec+1408|0;gc=fc;hc=+h[gc>>3];ic=dc*hc;jc=$b-ic;pe[Lb&3](373,298,jc,1251,e);kc=c[(e+8|0)>>2]|0;pe[kc&3](374,2,-1.0,1252,e);lc=c[(e+8|0)>>2]|0;pe[lc&3](374,7,1.0,1253,e);mc=c[(e+8|0)>>2]|0;nc=c[(d+4|0)>>2]|0;oc=c[nc>>2]|0;pc=oc;qc=pc+8|0;rc=qc;sc=c[rc>>2]|0;tc=sc;uc=tc+16208|0;vc=uc;wc=+h[vc>>3];xc=c[(d+416|0)>>2]|0;yc=xc;zc=yc+840|0;Ac=zc;Bc=+h[Ac>>3];Cc=wc*Bc;Dc=sc;Ec=Dc+16232|0;Fc=Ec;Gc=+h[Fc>>3];Hc=xc;Ic=Hc+832|0;Jc=Ic;Kc=+h[Jc>>3];Lc=Gc*Kc;Mc=Cc-Lc;pe[mc&3](374,298,Mc,1254,e);Nc=c[(e+8|0)>>2]|0;pe[Nc&3](375,1,-1.0,1255,e);Oc=c[(e+8|0)>>2]|0;pe[Oc&3](375,6,1.0,1256,e);Pc=c[(e+8|0)>>2]|0;Qc=c[(d+4|0)>>2]|0;Rc=c[Qc>>2]|0;Sc=Rc;Tc=Sc+8|0;Uc=Tc;Vc=c[Uc>>2]|0;Wc=Vc;Xc=Wc+16200|0;Yc=Xc;Zc=+h[Yc>>3];_c=c[(d+416|0)>>2]|0;$c=_c;ad=$c+840|0;bd=ad;cd=+h[bd>>3];dd=Zc*cd;ed=Vc;fd=ed+16224|0;gd=fd;hd=+h[gd>>3];id=_c;jd=id+832|0;kd=jd;ld=+h[kd>>3];md=hd*ld;nd=dd-md;pe[Pc&3](375,298,nd,1257,e);od=c[(e+8|0)>>2]|0;pd=c[(d+416|0)>>2]|0;qd=pd;rd=qd+400|0;sd=rd;td=+h[sd>>3];pe[od&3](376,3,td,1258,e);ud=c[(e+8|0)>>2]|0;vd=c[(d+416|0)>>2]|0;wd=vd;xd=wd+392|0;yd=xd;zd=+h[yd>>3];Ad=-zd;pe[ud&3](376,4,Ad,1259,e);Bd=c[(e+8|0)>>2]|0;pe[Bd&3](376,5,1.0,1260,e);Cd=c[(e+8|0)>>2]|0;pe[Cd&3](376,298,-.1,1261,e);Dd=c[(e+8|0)>>2]|0;pe[Dd&3](377,4,1.0,1262,e);Ed=c[(e+8|0)>>2]|0;Fd=c[(d+416|0)>>2]|0;Gd=Fd;Hd=Gd+392|0;Id=Hd;Jd=+h[Id>>3];Kd=Fd;Ld=Kd+19200|0;Md=Ld;Nd=+h[Md>>3];Od=Jd*Nd;Pd=-Od;pe[Ed&3](377,298,Pd,1263,e);Qd=c[(e+8|0)>>2]|0;pe[Qd&3](378,3,1.0,1264,e);Rd=c[(e+8|0)>>2]|0;Sd=c[(d+416|0)>>2]|0;Td=Sd;Ud=Td+400|0;Vd=Ud;Wd=+h[Vd>>3];Xd=Sd;Yd=Xd+19200|0;Zd=Yd;_d=+h[Zd>>3];$d=Wd*_d;pe[Rd&3](378,298,$d,1265,e);ae=c[(e+8|0)>>2]|0;pe[ae&3](379,2,1.0,1266,e);be=c[(e+8|0)>>2]|0;ce=c[(d+4|0)>>2]|0;de=c[ce>>2]|0;ee=de;fe=ee+8|0;ge=fe;he=c[ge>>2]|0;ie=he;je=ie+16208|0;ke=je;le=+h[ke>>3];me=c[(d+416|0)>>2]|0;ne=me;oe=ne+280|0;qe=oe;re=+h[qe>>3];se=le*re;te=he;ue=te+16232|0;ve=ue;we=+h[ve>>3];xe=me;ye=xe+272|0;ze=ye;Ae=+h[ze>>3];Be=we*Ae;Ce=se-Be;pe[be&3](379,298,Ce,1267,e);De=c[(e+8|0)>>2]|0;pe[De&3](380,1,1.0,1268,e);Ee=c[(e+8|0)>>2]|0;Fe=c[(d+4|0)>>2]|0;Ge=c[Fe>>2]|0;He=Ge;Ie=He+8|0;Je=Ie;Ke=c[Je>>2]|0;Le=Ke;Me=Le+16200|0;Ne=Me;Oe=+h[Ne>>3];Pe=c[(d+416|0)>>2]|0;Qe=Pe;Re=Qe+280|0;Se=Re;Te=+h[Se>>3];Ue=Oe*Te;Ve=Ke;We=Ve+16224|0;Xe=We;Ye=+h[Xe>>3];Ze=Pe;_e=Ze+272|0;$e=_e;af=+h[$e>>3];bf=Ye*af;cf=Ue-bf;pe[Ee&3](380,298,cf,1269,e);df=c[(e+8|0)>>2]|0;pe[df&3](381,0,1.0,1270,e);ef=c[(e+8|0)>>2]|0;pe[ef&3](381,308,-.8660254037844387,1271,e);i=b;c[b+8896>>2]=5;break a}P=+$Lb(c[d+536>>2]|0,l,10712,11496,+h[g>>3],(a[d+319|0]|0)!=0|0);Q=-.5/P;pe[t&3](362,20,Q,1222,e);R=c[(e+8|0)>>2]|0;pe[R&3](363,11,1.0,1223,e);S=c[(e+8|0)>>2]|0;pe[S&3](363,18,-1.0,1224,e);T=c[(e+8|0)>>2]|0;W=c[(d+424|0)>>2]|0;X=W;Y=X+35|0;Z=Y;_=a[Z]|0;$=_<<24>>24!=0;aa=$?1.0:-1.0;ba=-aa;pe[T&3](363,19,ba,1225,e);ca=c[(e+8|0)>>2]|0;pe[ca&3](364,17,1.0,1226,e);da=c[(e+8|0)>>2]|0;pe[da&3](364,18,.4999999999999999,1227,e);ea=c[(e+8|0)>>2]|0;fa=c[(d+416|0)>>2]|0;ga=fa;ha=ga+20232|0;ia=ha;ja=+h[ia>>3];ka=ja*-.8660254037844387;pe[ea&3](365,15,ka,1228,e);la=c[(e+8|0)>>2]|0;pe[la&3](365,16,1.0,1229,e);ma=c[(e+8|0)>>2]|0;na=c[(d+416|0)>>2]|0;oa=na;pa=oa+20232|0;qa=pa;ra=+h[qa>>3];sa=ra*.4999999999999999;pe[ma&3](365,17,sa,1230,e);ta=c[(e+8|0)>>2]|0;pe[ta&3](366,15,1.0,1231,e);ua=c[(e+8|0)>>2]|0;pe[ua&3](366,18,-.8660254037844387,1232,e);va=c[(e+8|0)>>2]|0;pe[va&3](367,10,1.0,1233,e);wa=c[(e+8|0)>>2]|0;pe[wa&3](367,14,1.0,1234,e);xa=c[(e+8|0)>>2]|0;pe[xa&3](367,15,-1.0,1235,e);ya=c[(e+8|0)>>2]|0;pe[ya&3](368,10,-.8660254037844387,1236,e);za=c[(e+8|0)>>2]|0;pe[za&3](368,13,-1.0,1237,e);Aa=c[(e+8|0)>>2]|0;pe[Aa&3](368,25,.4999999999999999,1238,e);Ba=c[(e+8|0)>>2]|0;pe[Ba&3](369,12,1.0,1239,e);Ca=c[(e+8|0)>>2]|0;pe[Ca&3](369,13,2.0,1240,e);Da=c[(e+8|0)>>2]|0;pe[Da&3](370,11,1.0,1241,e);Ea=c[(e+8|0)>>2]|0;pe[Ea&3](370,12,-.5,1242,e);Fa=c[(e+8|0)>>2]|0;pe[Fa&3](371,8,-1.0,1243,e);Ga=c[(e+8|0)>>2]|0;pe[Ga&3](371,10,1.0,1244,e);Ha=c[(e+8|0)>>2]|0;Ia=c[(d+4|0)>>2]|0;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+8|0;Ma=La;Na=c[Ma>>2]|0;Oa=Na;Pa=Oa+14824|0;Qa=Pa;Ra=+h[Qa>>3];Sa=c[(d+416|0)>>2]|0;Ta=Sa;Ua=Ta+936|0;Va=Ua;Wa=+h[Va>>3];Xa=Ra*Wa;Ya=Na;Za=Ya+14808|0;_a=Za;$a=+h[_a>>3];ab=Sa;bb=ab+928|0;cb=bb;db=+h[cb>>3];eb=$a*db;fb=Xa-eb;pe[Ha&3](371,298,fb,1245,e);gb=c[(e+8|0)>>2]|0;pe[gb&3](372,2,-1.0,1246,e);hb=c[(e+8|0)>>2]|0;pe[hb&3](372,9,1.0,1247,e);ib=c[(e+8|0)>>2]|0;jb=c[(d+4|0)>>2]|0;kb=c[jb>>2]|0;lb=kb;mb=lb+8|0;nb=mb;ob=c[nb>>2]|0;pb=ob;qb=pb+16208|0;rb=qb;sb=+h[rb>>3];tb=c[(d+416|0)>>2]|0;ub=tb;vb=ub+1416|0;wb=vb;xb=+h[wb>>3];yb=sb*xb;zb=ob;Ab=zb+16232|0;Bb=Ab;Cb=+h[Bb>>3];Db=tb;Eb=Db+1408|0;Fb=Eb;Gb=+h[Fb>>3];Hb=Cb*Gb;Ib=yb-Hb;pe[ib&3](372,298,Ib,1248,e);Jb=c[(e+8|0)>>2]|0;pe[Jb&3](373,1,-1.0,1249,e);Kb=c[(e+8|0)>>2]|0;pe[Kb&3](373,8,1.0,1250,e);Lb=c[(e+8|0)>>2]|0;Mb=c[(d+4|0)>>2]|0;Nb=c[Mb>>2]|0;Ob=Nb;Pb=Ob+8|0;Qb=Pb;Rb=c[Qb>>2]|0;Sb=Rb;Tb=Sb+16200|0;Ub=Tb;Vb=+h[Ub>>3];Wb=c[(d+416|0)>>2]|0;Xb=Wb;Yb=Xb+1416|0;Zb=Yb;_b=+h[Zb>>3];$b=Vb*_b;ac=Rb;bc=ac+16224|0;cc=bc;dc=+h[cc>>3];ec=Wb;fc=ec+1408|0;gc=fc;hc=+h[gc>>3];ic=dc*hc;jc=$b-ic;pe[Lb&3](373,298,jc,1251,e);kc=c[(e+8|0)>>2]|0;pe[kc&3](374,2,-1.0,1252,e);lc=c[(e+8|0)>>2]|0;pe[lc&3](374,7,1.0,1253,e);mc=c[(e+8|0)>>2]|0;nc=c[(d+4|0)>>2]|0;oc=c[nc>>2]|0;pc=oc;qc=pc+8|0;rc=qc;sc=c[rc>>2]|0;tc=sc;uc=tc+16208|0;vc=uc;wc=+h[vc>>3];xc=c[(d+416|0)>>2]|0;yc=xc;zc=yc+840|0;Ac=zc;Bc=+h[Ac>>3];Cc=wc*Bc;Dc=sc;Ec=Dc+16232|0;Fc=Ec;Gc=+h[Fc>>3];Hc=xc;Ic=Hc+832|0;Jc=Ic;Kc=+h[Jc>>3];Lc=Gc*Kc;Mc=Cc-Lc;pe[mc&3](374,298,Mc,1254,e);Nc=c[(e+8|0)>>2]|0;pe[Nc&3](375,1,-1.0,1255,e);Oc=c[(e+8|0)>>2]|0;pe[Oc&3](375,6,1.0,1256,e);Pc=c[(e+8|0)>>2]|0;Qc=c[(d+4|0)>>2]|0;Rc=c[Qc>>2]|0;Sc=Rc;Tc=Sc+8|0;Uc=Tc;Vc=c[Uc>>2]|0;Wc=Vc;Xc=Wc+16200|0;Yc=Xc;Zc=+h[Yc>>3];_c=c[(d+416|0)>>2]|0;$c=_c;ad=$c+840|0;bd=ad;cd=+h[bd>>3];dd=Zc*cd;ed=Vc;fd=ed+16224|0;gd=fd;hd=+h[gd>>3];id=_c;jd=id+832|0;kd=jd;ld=+h[kd>>3];md=hd*ld;nd=dd-md;pe[Pc&3](375,298,nd,1257,e);od=c[(e+8|0)>>2]|0;pd=c[(d+416|0)>>2]|0;qd=pd;rd=qd+400|0;sd=rd;td=+h[sd>>3];pe[od&3](376,3,td,1258,e);ud=c[(e+8|0)>>2]|0;vd=c[(d+416|0)>>2]|0;wd=vd;xd=wd+392|0;yd=xd;zd=+h[yd>>3];Ad=-zd;pe[ud&3](376,4,Ad,1259,e);Bd=c[(e+8|0)>>2]|0;pe[Bd&3](376,5,1.0,1260,e);Cd=c[(e+8|0)>>2]|0;pe[Cd&3](376,298,-.1,1261,e);Dd=c[(e+8|0)>>2]|0;pe[Dd&3](377,4,1.0,1262,e);Ed=c[(e+8|0)>>2]|0;Fd=c[(d+416|0)>>2]|0;Gd=Fd;Hd=Gd+392|0;Id=Hd;Jd=+h[Id>>3];Kd=Fd;Ld=Kd+19200|0;Md=Ld;Nd=+h[Md>>3];Od=Jd*Nd;Pd=-Od;pe[Ed&3](377,298,Pd,1263,e);Qd=c[(e+8|0)>>2]|0;pe[Qd&3](378,3,1.0,1264,e);Rd=c[(e+8|0)>>2]|0;Sd=c[(d+416|0)>>2]|0;Td=Sd;Ud=Td+400|0;Vd=Ud;Wd=+h[Vd>>3];Xd=Sd;Yd=Xd+19200|0;Zd=Yd;_d=+h[Zd>>3];$d=Wd*_d;pe[Rd&3](378,298,$d,1265,e);ae=c[(e+8|0)>>2]|0;pe[ae&3](379,2,1.0,1266,e);be=c[(e+8|0)>>2]|0;ce=c[(d+4|0)>>2]|0;de=c[ce>>2]|0;ee=de;fe=ee+8|0;ge=fe;he=c[ge>>2]|0;ie=he;je=ie+16208|0;ke=je;le=+h[ke>>3];me=c[(d+416|0)>>2]|0;ne=me;oe=ne+280|0;qe=oe;re=+h[qe>>3];se=le*re;te=he;ue=te+16232|0;ve=ue;we=+h[ve>>3];xe=me;ye=xe+272|0;ze=ye;Ae=+h[ze>>3];Be=we*Ae;Ce=se-Be;pe[be&3](379,298,Ce,1267,e);De=c[(e+8|0)>>2]|0;pe[De&3](380,1,1.0,1268,e);Ee=c[(e+8|0)>>2]|0;Fe=c[(d+4|0)>>2]|0;Ge=c[Fe>>2]|0;He=Ge;Ie=He+8|0;Je=Ie;Ke=c[Je>>2]|0;Le=Ke;Me=Le+16200|0;Ne=Me;Oe=+h[Ne>>3];Pe=c[(d+416|0)>>2]|0;Qe=Pe;Re=Qe+280|0;Se=Re;Te=+h[Se>>3];Ue=Oe*Te;Ve=Ke;We=Ve+16224|0;Xe=We;Ye=+h[Xe>>3];Ze=Pe;_e=Ze+272|0;$e=_e;af=+h[$e>>3];bf=Ye*af;cf=Ue-bf;pe[Ee&3](380,298,cf,1269,e);df=c[(e+8|0)>>2]|0;pe[df&3](381,0,1.0,1270,e);ef=c[(e+8|0)>>2]|0;pe[ef&3](381,308,-.8660254037844387,1271,e);i=b;c[b+8896>>2]=5;break a}while(0)}function _setLinearMatrixA4256$1(b){b=b|0;var d=0,e=0,f=0,i=0.0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=c[b+8>>2]|0;e=c[b+16>>2]|0;f=c[b+3792>>2]|0;i=+g[b+3800>>2];j=c[b+3808>>2]|0;k=+g[b+3816>>2];do{if(i!=0.0){l=-k/i}else{if(k==-0.0){l=-k;break}l=-k/+$Lb(c[d+536>>2]|0,i,8736,11496,+h[j>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](233,136,l,790,e);f=c[(e+8|0)>>2]|0;l=+h[(c[(d+416|0)>>2]|0)+21880>>3];j=c[c[(d+4|0)>>2]>>2]|0;i=+h[(c[j+8>>2]|0)+14912>>3];do{if(l!=0.0){m=-i/l}else{if(i==-0.0){m=-i;break}m=-i/+$Lb(c[d+536>>2]|0,l,8736,11496,+h[j>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](233,146,m,791,e);pe[c[(e+8|0)>>2]&3](233,148,1.0,792,e);f=c[(e+8|0)>>2]|0;m=+h[(c[(d+416|0)>>2]|0)+21880>>3];j=c[c[(d+4|0)>>2]>>2]|0;l=+h[(c[j+8>>2]|0)+2120>>3];do{if(m!=0.0){n=-l/m}else{if(l==-0.0){n=-l;break}n=-l/+$Lb(c[d+536>>2]|0,m,8736,11496,+h[j>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](233,298,n,793,e);pe[c[(e+8|0)>>2]&3](234,131,-1.0,794,e);pe[c[(e+8|0)>>2]&3](234,147,1.0,795,e);f=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;j=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](234,298,+h[f+14912>>3]*+h[j+6968>>3]- +h[f+14896>>3]*+h[j+6960>>3],796,e);pe[c[(e+8|0)>>2]&3](235,139,-1.0,797,e);pe[c[(e+8|0)>>2]&3](235,146,1.0,798,e);pe[c[(e+8|0)>>2]&3](235,147,1.0,799,e);pe[c[(e+8|0)>>2]&3](236,132,-.4999999999999999,800,e);pe[c[(e+8|0)>>2]&3](236,145,-1.0,801,e);pe[c[(e+8|0)>>2]&3](236,147,-.8660254037844387,802,e);pe[c[(e+8|0)>>2]&3](237,135,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9928>>3]*-2.0,803,e);pe[c[(e+8|0)>>2]&3](237,144,1.0,804,e);pe[c[(e+8|0)>>2]&3](237,145,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9936>>3]*-2.0,805,e);pe[c[(e+8|0)>>2]&3](238,133,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20120>>3]*-2.0,806,e);pe[c[(e+8|0)>>2]&3](238,143,1.0,807,e);pe[c[(e+8|0)>>2]&3](238,144,1.0,808,e);pe[c[(e+8|0)>>2]&3](239,142,1.0,809,e);j=$Ob(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20104>>3],1.0e-12)|0;pe[c[(e+8|0)>>2]&3](239,143,-(j<<24>>24!=0?1.0:0.0),810,e);pe[c[(e+8|0)>>2]&3](240,141,1.0,811,e);j=c[(e+8|0)>>2]|0;f=c[c[(d+4|0)>>2]>>2]|0;n=+V(+(+h[(c[f+8>>2]|0)+20096>>3]));if(n!=0.0){o=n}else{o=+$Lb(c[d+536>>2]|0,n,8944,11496,+h[f>>3],(a[d+319|0]|0)!=0|0)}pe[j&3](240,142,-.5/o,812,e);pe[c[(e+8|0)>>2]&3](241,133,1.0,813,e);pe[c[(e+8|0)>>2]&3](241,140,-1.0,814,e);pe[c[(e+8|0)>>2]&3](241,141,-((a[(c[(d+424|0)>>2]|0)+131|0]|0)!=0?1.0:-1.0),815,e);pe[c[(e+8|0)>>2]&3](242,139,1.0,816,e);pe[c[(e+8|0)>>2]&3](242,140,.4999999999999999,817,e);pe[c[(e+8|0)>>2]&3](243,137,+h[(c[(d+416|0)>>2]|0)+22296>>3]*-.8660254037844387,818,e);pe[c[(e+8|0)>>2]&3](243,138,1.0,819,e);pe[c[(e+8|0)>>2]&3](243,139,+h[(c[(d+416|0)>>2]|0)+22296>>3]*.4999999999999999,820,e);pe[c[(e+8|0)>>2]&3](244,137,1.0,821,e);pe[c[(e+8|0)>>2]&3](244,140,-.8660254037844387,822,e);pe[c[(e+8|0)>>2]&3](245,132,1.0,823,e);pe[c[(e+8|0)>>2]&3](245,136,1.0,824,e);pe[c[(e+8|0)>>2]&3](245,137,-1.0,825,e);pe[c[(e+8|0)>>2]&3](246,132,-.8660254037844387,826,e);pe[c[(e+8|0)>>2]&3](246,135,-1.0,827,e);pe[c[(e+8|0)>>2]&3](246,147,.4999999999999999,828,e);pe[c[(e+8|0)>>2]&3](247,134,1.0,829,e);pe[c[(e+8|0)>>2]&3](247,135,2.0,830,e);pe[c[(e+8|0)>>2]&3](248,133,1.0,831,e);pe[c[(e+8|0)>>2]&3](248,134,-.5,832,e);pe[c[(e+8|0)>>2]&3](249,130,-1.0,833,e);pe[c[(e+8|0)>>2]&3](249,132,1.0,834,e);j=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](249,298,+h[j+14920>>3]*+h[f+6968>>3]- +h[j+14904>>3]*+h[f+6960>>3],835,e);pe[c[(e+8|0)>>2]&3](250,68,-1.0,836,e);pe[c[(e+8|0)>>2]&3](250,131,1.0,837,e);f=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;j=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](250,298,+h[f+16208>>3]*+h[j+7448>>3]- +h[f+16232>>3]*+h[j+7440>>3],838,e);pe[c[(e+8|0)>>2]&3](251,67,-1.0,839,e);pe[c[(e+8|0)>>2]&3](251,130,1.0,840,e);j=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](251,298,+h[j+16200>>3]*+h[f+7448>>3]- +h[j+16224>>3]*+h[f+7440>>3],841,e);pe[c[(e+8|0)>>2]&3](252,68,-1.0,842,e);pe[c[(e+8|0)>>2]&3](252,129,1.0,843,e);f=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;j=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](252,298,+h[f+16208>>3]*+h[j+6872>>3]- +h[f+16232>>3]*+h[j+6864>>3],844,e);pe[c[(e+8|0)>>2]&3](253,67,-1.0,845,e);pe[c[(e+8|0)>>2]&3](253,128,1.0,846,e);j=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](253,298,+h[j+16200>>3]*+h[f+6872>>3]- +h[j+16224>>3]*+h[f+6864>>3],847,e);pe[c[(e+8|0)>>2]&3](254,88,-1.0,848,e);pe[c[(e+8|0)>>2]&3](254,127,1.0,849,e);pe[c[(e+8|0)>>2]&3](254,298,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7160>>3],850,e);pe[c[(e+8|0)>>2]&3](255,97,+h[(c[(d+416|0)>>2]|0)+5800>>3],851,e);pe[c[(e+8|0)>>2]&3](255,101,-+h[(c[(d+416|0)>>2]|0)+5784>>3],852,e);pe[c[(e+8|0)>>2]&3](255,126,-1.0,853,e);pe[c[(e+8|0)>>2]&3](255,127,-5.0e-4,854,e);pe[c[(e+8|0)>>2]&3](256,96,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15944>>3],855,e);pe[c[(e+8|0)>>2]&3](256,100,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2872>>3],856,e);pe[c[(e+8|0)>>2]&3](256,125,1.0,857,e);pe[c[(e+8|0)>>2]&3](256,126,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2952>>3],858,e);pe[c[(e+8|0)>>2]&3](257,107,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2848>>3],859,e);pe[c[(e+8|0)>>2]&3](257,109,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9776>>3],860,e);pe[c[(e+8|0)>>2]&3](257,124,-1.0,861,e);pe[c[(e+8|0)>>2]&3](257,125,-1.0,862,e);pe[c[(e+8|0)>>2]&3](258,106,-+h[(c[(d+416|0)>>2]|0)+3944>>3],863,e);pe[c[(e+8|0)>>2]&3](258,108,+h[(c[(d+416|0)>>2]|0)+3936>>3],864,e);pe[c[(e+8|0)>>2]&3](258,123,-1.0,865,e);pe[c[(e+8|0)>>2]&3](258,124,1.0,866,e);pe[c[(e+8|0)>>2]&3](259,110,+h[(c[(d+416|0)>>2]|0)+4424>>3],867,e);pe[c[(e+8|0)>>2]&3](259,111,-+h[(c[(d+416|0)>>2]|0)+4432>>3],868,e);pe[c[(e+8|0)>>2]&3](259,113,1.0,869,e);pe[c[(e+8|0)>>2]&3](259,122,-1.0,870,e);pe[c[(e+8|0)>>2]&3](260,106,+h[(c[(d+416|0)>>2]|0)+4432>>3],871,e);pe[c[(e+8|0)>>2]&3](260,110,-+h[(c[(d+416|0)>>2]|0)+4416>>3],872,e);pe[c[(e+8|0)>>2]&3](260,115,6.123233995736766e-17,873,e);pe[c[(e+8|0)>>2]&3](260,120,-1.0,874,e);pe[c[(e+8|0)>>2]&3](260,123,-1.0,875,e);pe[c[(e+8|0)>>2]&3](261,106,-+h[(c[(d+416|0)>>2]|0)+4424>>3],876,e);pe[c[(e+8|0)>>2]&3](261,111,+h[(c[(d+416|0)>>2]|0)+4416>>3],877,e);pe[c[(e+8|0)>>2]&3](261,115,1.0,878,e);pe[c[(e+8|0)>>2]&3](261,121,-1.0,879,e);pe[c[(e+8|0)>>2]&3](261,123,6.123233995736766e-17,880,e);f=c[(e+8|0)>>2]|0;j=c[c[(d+4|0)>>2]>>2]|0;b=c[j+8>>2]|0;o=+h[b+7136>>3]*+h[(c[(d+416|0)>>2]|0)+20848>>3];n=+h[b+15944>>3];do{if(o!=0.0){p=n/o}else{if(n==0.0){p=n;break}p=n/+$Lb(c[d+536>>2]|0,o,11888,11496,+h[j>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](262,102,p,881,e);f=c[(e+8|0)>>2]|0;j=c[c[(d+4|0)>>2]>>2]|0;b=c[j+8>>2]|0;p=+h[b+2872>>3];o=+h[(c[(d+416|0)>>2]|0)+20848>>3];n=+h[b+15936>>3];do{if(o!=0.0){q=n/o}else{if(n==0.0){q=n;break}q=n/+$Lb(c[d+536>>2]|0,o,1e4,11496,+h[j>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](262,103,-(p*q),882,e);pe[c[(e+8|0)>>2]&3](262,119,1.0,883,e);f=c[(e+8|0)>>2]|0;j=c[c[(d+4|0)>>2]>>2]|0;b=c[j+8>>2]|0;q=+h[b+2872>>3];p=+h[(c[(d+416|0)>>2]|0)+20848>>3];o=+h[b+15944>>3];do{if(p!=0.0){r=o/p}else{if(o==0.0){r=o;break}r=o/+$Lb(c[d+536>>2]|0,p,1e4,11496,+h[j>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](262,125,-(q*r),884,e);f=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20304>>3])),1.0e-10)|0;j=c[(e+8|0)>>2]|0;do{if(f<<24>>24==0){b=c[c[(d+4|0)>>2]>>2]|0;r=+h[(c[b+8>>2]|0)+20304>>3];if(r!=0.0){s=r;break}s=+$Lb(c[d+536>>2]|0,r,10208,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}else{s=1.0e-10}}while(0);pe[j&3](263,77,1.0/s,885,e);j=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20304>>3])),1.0e-10)|0;f=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;t=c[b+8>>2]|0;if(j<<24>>24!=0){u=1}else{u=+h[t+20304>>3]!=0.0}s=+h[t+14872>>3]*.8660254037844387+ +h[t+14864>>3]*.4999999999999999;do{if(u){if(j<<24>>24!=0){v=1.0e-10}else{v=+h[t+20304>>3]}w=s/v}else{if(s==0.0){w=s;break}if(j<<24>>24!=0){x=1.0e-10}else{x=+h[t+20304>>3]}w=s/+$Lb(c[d+536>>2]|0,x,10208,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[f&3](263,105,w,886,e);pe[c[(e+8|0)>>2]&3](263,118,1.0,887,e);f=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20304>>3])),1.0e-10)|0;b=c[(e+8|0)>>2]|0;t=c[c[(d+4|0)>>2]>>2]|0;j=c[t+8>>2]|0;if(f<<24>>24!=0){y=1}else{y=+h[j+20304>>3]!=0.0}w=+h[j+14856>>3]*.8660254037844387+ +h[j+14848>>3]*.4999999999999999;do{if(y){if(f<<24>>24!=0){z=1.0e-10}else{z=+h[j+20304>>3]}A=w/z}else{if(w==0.0){A=w;break}if(f<<24>>24!=0){B=1.0e-10}else{B=+h[j+20304>>3]}A=w/+$Lb(c[d+536>>2]|0,B,10208,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](263,119,A,888,e);pe[c[(e+8|0)>>2]&3](264,117,1.0,889,e);pe[c[(e+8|0)>>2]&3](264,118,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2952>>3],890,e);pe[c[(e+8|0)>>2]&3](264,119,-1.0,891,e);pe[c[(e+8|0)>>2]&3](265,103,-1.0,892,e);pe[c[(e+8|0)>>2]&3](265,107,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2840>>3],893,e);pe[c[(e+8|0)>>2]&3](265,116,-1.0,894,e);pe[c[(e+8|0)>>2]&3](265,117,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9776>>3],895,e);pe[c[(e+8|0)>>2]&3](266,106,+h[(c[(d+416|0)>>2]|0)+3952>>3],896,e);pe[c[(e+8|0)>>2]&3](266,112,-+h[(c[(d+416|0)>>2]|0)+3936>>3],897,e);pe[c[(e+8|0)>>2]&3](266,115,-1.0,898,e);pe[c[(e+8|0)>>2]&3](266,116,1.0,899,e);pe[c[(e+8|0)>>2]&3](267,102,-1.0,900,e);pe[c[(e+8|0)>>2]&3](267,109,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2840>>3],901,e);pe[c[(e+8|0)>>2]&3](267,114,-1.0,902,e);pe[c[(e+8|0)>>2]&3](267,117,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2848>>3],903,e);pe[c[(e+8|0)>>2]&3](268,108,-+h[(c[(d+416|0)>>2]|0)+3952>>3],904,e);pe[c[(e+8|0)>>2]&3](268,112,+h[(c[(d+416|0)>>2]|0)+3944>>3],905,e);pe[c[(e+8|0)>>2]&3](268,113,-1.0,906,e);pe[c[(e+8|0)>>2]&3](268,114,1.0,907,e);pe[c[(e+8|0)>>2]&3](269,99,-1.0,908,e);pe[c[(e+8|0)>>2]&3](269,112,-1.0,909,e);pe[c[(e+8|0)>>2]&3](269,117,-1.0,910,e);pe[c[(e+8|0)>>2]&3](270,108,-6.123233995736766e-17,911,e);pe[c[(e+8|0)>>2]&3](270,111,1.0,912,e);pe[c[(e+8|0)>>2]&3](270,112,1.0,913,e);pe[c[(e+8|0)>>2]&3](271,108,-1.0,914,e);pe[c[(e+8|0)>>2]&3](271,110,1.0,915,e);pe[c[(e+8|0)>>2]&3](271,112,-6.123233995736766e-17,916,e);pe[c[(e+8|0)>>2]&3](272,105,-1.0,917,e);pe[c[(e+8|0)>>2]&3](272,109,1.0,918,e);pe[c[(e+8|0)>>2]&3](272,118,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2960>>3],919,e);pe[c[(e+8|0)>>2]&3](273,98,-1.0,920,e);pe[c[(e+8|0)>>2]&3](273,108,-1.0,921,e);pe[c[(e+8|0)>>2]&3](273,109,-1.0,922,e);pe[c[(e+8|0)>>2]&3](274,104,-1.0,923,e);pe[c[(e+8|0)>>2]&3](274,107,1.0,924,e);pe[c[(e+8|0)>>2]&3](274,118,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7160>>3],925,e);pe[c[(e+8|0)>>2]&3](275,95,-1.0,926,e);pe[c[(e+8|0)>>2]&3](275,106,-1.0,927,e);pe[c[(e+8|0)>>2]&3](275,107,-1.0,928,e);b=c[(e+8|0)>>2]|0;t=c[c[(d+4|0)>>2]>>2]|0;j=c[t+8>>2]|0;A=+h[j+7136>>3]*+h[(c[(d+416|0)>>2]|0)+20848>>3];B=+h[j+15936>>3];do{if(A!=0.0){C=B/A}else{if(B==0.0){C=B;break}C=B/+$Lb(c[d+536>>2]|0,A,11888,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](276,102,C,929,e);b=c[(e+8|0)>>2]|0;t=c[c[(d+4|0)>>2]>>2]|0;j=c[t+8>>2]|0;C=+h[j+2880>>3];A=+h[(c[(d+416|0)>>2]|0)+20848>>3];B=+h[j+15936>>3];do{if(A!=0.0){D=B/A}else{if(B==0.0){D=B;break}D=B/+$Lb(c[d+536>>2]|0,A,1e4,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](276,103,-(C*D),930,e);pe[c[(e+8|0)>>2]&3](276,105,1.0,931,e);b=c[(e+8|0)>>2]|0;t=c[c[(d+4|0)>>2]>>2]|0;j=c[t+8>>2]|0;D=+h[j+2880>>3];C=+h[(c[(d+416|0)>>2]|0)+20848>>3];A=+h[j+15944>>3];do{if(C!=0.0){E=A/C}else{if(A==0.0){E=A;break}E=A/+$Lb(c[d+536>>2]|0,C,1e4,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](276,125,-(D*E),932,e);b=c[(e+8|0)>>2]|0;t=c[c[(d+4|0)>>2]>>2]|0;j=c[t+8>>2]|0;E=+h[j+7136>>3];D=+h[(c[(d+416|0)>>2]|0)+20848>>3];C=+h[j+15936>>3];do{if(D!=0.0){F=C/D}else{if(C==0.0){F=C;break}F=C/+$Lb(c[d+536>>2]|0,D,1e4,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](277,103,-(E*F),933,e);pe[c[(e+8|0)>>2]&3](277,104,1.0,934,e);b=c[(e+8|0)>>2]|0;t=c[c[(d+4|0)>>2]>>2]|0;j=c[t+8>>2]|0;F=+h[j+7136>>3];E=+h[(c[(d+416|0)>>2]|0)+20848>>3];D=+h[j+15944>>3];do{if(E!=0.0){G=D/E}else{if(D==0.0){G=D;break}G=D/+$Lb(c[d+536>>2]|0,E,1e4,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](277,125,-(F*G),935,e);pe[c[(e+8|0)>>2]&3](278,96,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15936>>3],936,e);pe[c[(e+8|0)>>2]&3](278,100,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2880>>3],937,e);pe[c[(e+8|0)>>2]&3](278,103,1.0,938,e);pe[c[(e+8|0)>>2]&3](278,126,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2960>>3],939,e);pe[c[(e+8|0)>>2]&3](279,100,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7136>>3],940,e);pe[c[(e+8|0)>>2]&3](279,102,1.0,941,e);pe[c[(e+8|0)>>2]&3](279,126,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7160>>3],942,e);pe[c[(e+8|0)>>2]&3](280,71,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7192>>3]*+h[(c[(d+416|0)>>2]|0)+21064>>3]),943,e);pe[c[(e+8|0)>>2]&3](280,86,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7200>>3]*+h[(c[(d+416|0)>>2]|0)+21064>>3]),944,e);b=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](280,94,-(+h[b+5792>>3]*+h[b+21064>>3]),945,e);pe[c[(e+8|0)>>2]&3](280,101,-1.0,946,e);b=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](280,127,+h[b+5784>>3]*+h[b+21064>>3],947,e);pe[c[(e+8|0)>>2]&3](281,93,-+h[(c[(d+416|0)>>2]|0)+5800>>3],948,e);pe[c[(e+8|0)>>2]&3](281,94,-.006,949,e);pe[c[(e+8|0)>>2]&3](281,100,-1.0,950,e);pe[c[(e+8|0)>>2]&3](281,101,+h[(c[(d+416|0)>>2]|0)+5792>>3],951,e);pe[c[(e+8|0)>>2]&3](282,93,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2952>>3],952,e);pe[c[(e+8|0)>>2]&3](282,97,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2872>>3],953,e);pe[c[(e+8|0)>>2]&3](282,99,1.0,954,e);pe[c[(e+8|0)>>2]&3](282,101,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15944>>3],955,e);pe[c[(e+8|0)>>2]&3](283,93,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2960>>3],956,e);pe[c[(e+8|0)>>2]&3](283,97,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2880>>3],957,e);pe[c[(e+8|0)>>2]&3](283,98,1.0,958,e);pe[c[(e+8|0)>>2]&3](283,101,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15936>>3],959,e);pe[c[(e+8|0)>>2]&3](284,71,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7144>>3]*+h[(c[(d+416|0)>>2]|0)+21064>>3]),960,e);pe[c[(e+8|0)>>2]&3](284,86,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7152>>3]*+h[(c[(d+416|0)>>2]|0)+21064>>3]),961,e);b=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](284,89,+h[b+5792>>3]*+h[b+21064>>3],962,e);pe[c[(e+8|0)>>2]&3](284,97,-1.0,963,e);b=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](284,127,-(+h[b+5800>>3]*+h[b+21064>>3]),964,e);pe[c[(e+8|0)>>2]&3](285,89,-.006,965,e);pe[c[(e+8|0)>>2]&3](285,93,+h[(c[(d+416|0)>>2]|0)+5784>>3],966,e);pe[c[(e+8|0)>>2]&3](285,96,-1.0,967,e);pe[c[(e+8|0)>>2]&3](285,97,-+h[(c[(d+416|0)>>2]|0)+5792>>3],968,e);pe[c[(e+8|0)>>2]&3](286,93,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7160>>3],969,e);pe[c[(e+8|0)>>2]&3](286,95,1.0,970,e);pe[c[(e+8|0)>>2]&3](286,97,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7136>>3],971,e);pe[c[(e+8|0)>>2]&3](287,91,-1.0,972,e);pe[c[(e+8|0)>>2]&3](287,94,1.0,973,e);pe[c[(e+8|0)>>2]&3](287,298,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7136>>3],974,e);pe[c[(e+8|0)>>2]&3](288,71,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7168>>3]*+h[(c[(d+416|0)>>2]|0)+21064>>3]),975,e);pe[c[(e+8|0)>>2]&3](288,86,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7176>>3]*+h[(c[(d+416|0)>>2]|0)+21064>>3]),976,e);b=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](288,89,-(+h[b+5784>>3]*+h[b+21064>>3]),977,e);pe[c[(e+8|0)>>2]&3](288,93,-1.0,978,e);b=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](288,94,+h[b+5800>>3]*+h[b+21064>>3],979,e);b=c[(e+8|0)>>2]|0;G=+h[(c[(d+416|0)>>2]|0)+20848>>3];t=c[c[(d+4|0)>>2]>>2]|0;F=+h[(c[t+8>>2]|0)+14856>>3];do{if(G!=0.0){H=-F/G}else{if(F==-0.0){H=-F;break}H=-F/+$Lb(c[d+536>>2]|0,G,1e4,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](289,75,H,980,e);b=c[(e+8|0)>>2]|0;H=+h[(c[(d+416|0)>>2]|0)+20848>>3];t=c[c[(d+4|0)>>2]>>2]|0;G=+h[(c[t+8>>2]|0)+14848>>3];do{if(H!=0.0){I=-G/H}else{if(G==-0.0){I=-G;break}I=-G/+$Lb(c[d+536>>2]|0,H,1e4,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](289,85,I,981,e);pe[c[(e+8|0)>>2]&3](289,92,1.0,982,e);b=c[(e+8|0)>>2]|0;I=+h[(c[(d+416|0)>>2]|0)+20848>>3];t=c[c[(d+4|0)>>2]>>2]|0;H=+h[(c[t+8>>2]|0)+2848>>3];do{if(I!=0.0){J=H/I}else{if(H==0.0){J=H;break}J=H/+$Lb(c[d+536>>2]|0,I,1e4,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](289,298,J,983,e);pe[c[(e+8|0)>>2]&3](290,87,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15936>>3],984,e);pe[c[(e+8|0)>>2]&3](290,91,1.0,985,e);pe[c[(e+8|0)>>2]&3](290,92,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15944>>3],986,e);pe[c[(e+8|0)>>2]&3](291,87,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2880>>3],987,e);pe[c[(e+8|0)>>2]&3](291,90,1.0,988,e);pe[c[(e+8|0)>>2]&3](291,92,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2872>>3],989,e);pe[c[(e+8|0)>>2]&3](292,89,1.0,990,e);pe[c[(e+8|0)>>2]&3](292,90,-1.0,991,e);b=c[(e+8|0)>>2]|0;t=c[c[(d+4|0)>>2]>>2]|0;j=c[t+8>>2]|0;J=+h[j+20240>>3];I=+h[j+2872>>3];do{if(J!=0.0){K=-I/J}else{if(I==-0.0){K=-I;break}K=-I/+$Lb(c[d+536>>2]|0,J,10056,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](293,87,K,992,e);pe[c[(e+8|0)>>2]&3](293,88,1.0,993,e);b=c[(e+8|0)>>2]|0;t=c[c[(d+4|0)>>2]>>2]|0;j=c[t+8>>2]|0;K=+h[j+20240>>3];J=+h[j+2880>>3];do{if(K!=0.0){L=J/K}else{if(J==0.0){L=J;break}L=J/+$Lb(c[d+536>>2]|0,K,10056,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](293,92,L,994,e);b=c[(e+8|0)>>2]|0;L=+h[(c[(d+416|0)>>2]|0)+20848>>3];t=c[c[(d+4|0)>>2]>>2]|0;K=+h[(c[t+8>>2]|0)+14872>>3];do{if(L!=0.0){M=-K/L}else{if(K==-0.0){M=-K;break}M=-K/+$Lb(c[d+536>>2]|0,L,1e4,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](294,75,M,995,e);b=c[(e+8|0)>>2]|0;M=+h[(c[(d+416|0)>>2]|0)+20848>>3];t=c[c[(d+4|0)>>2]>>2]|0;L=+h[(c[t+8>>2]|0)+14864>>3];do{if(M!=0.0){N=-L/M}else{if(L==-0.0){N=-L;break}N=-L/+$Lb(c[d+536>>2]|0,M,1e4,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](294,85,N,996,e);pe[c[(e+8|0)>>2]&3](294,87,1.0,997,e);b=c[(e+8|0)>>2]|0;N=+h[(c[(d+416|0)>>2]|0)+20848>>3];t=c[c[(d+4|0)>>2]>>2]|0;M=+h[(c[t+8>>2]|0)+2840>>3];do{if(N!=0.0){O=-M/N}else{if(M==-0.0){O=-M;break}O=-M/+$Lb(c[d+536>>2]|0,N,1e4,11496,+h[t>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](294,298,O,998,e);pe[c[(e+8|0)>>2]&3](295,70,-1.0,999,e);pe[c[(e+8|0)>>2]&3](295,86,1.0,1e3,e);b=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;t=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](295,298,+h[b+14864>>3]*+h[t+3952>>3]- +h[b+14848>>3]*+h[t+3944>>3],1001,e);pe[c[(e+8|0)>>2]&3](296,78,-1.0,1002,e);pe[c[(e+8|0)>>2]&3](296,85,1.0,1003,e);pe[c[(e+8|0)>>2]&3](296,86,1.0,1004,e);pe[c[(e+8|0)>>2]&3](297,71,.4999999999999999,1005,e);pe[c[(e+8|0)>>2]&3](297,84,-1.0,1006,e);pe[c[(e+8|0)>>2]&3](297,86,-.8660254037844387,1007,e);pe[c[(e+8|0)>>2]&3](298,74,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9808>>3]*-2.0,1008,e);pe[c[(e+8|0)>>2]&3](298,83,1.0,1009,e);pe[c[(e+8|0)>>2]&3](298,84,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9816>>3]*-2.0,1010,e);pe[c[(e+8|0)>>2]&3](299,72,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20280>>3]*-2.0,1011,e);pe[c[(e+8|0)>>2]&3](299,82,1.0,1012,e);pe[c[(e+8|0)>>2]&3](299,83,1.0,1013,e);pe[c[(e+8|0)>>2]&3](300,81,1.0,1014,e);t=$Ob(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20264>>3],1.0e-12)|0;pe[c[(e+8|0)>>2]&3](300,82,-(t<<24>>24!=0?1.0:0.0),1015,e);pe[c[(e+8|0)>>2]&3](301,80,1.0,1016,e);t=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;O=+V(+(+h[(c[b+8>>2]|0)+20256>>3]));if(O!=0.0){P=O}else{P=+$Lb(c[d+536>>2]|0,O,10328,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}pe[t&3](301,81,-.5/P,1017,e);pe[c[(e+8|0)>>2]&3](302,72,1.0,1018,e);pe[c[(e+8|0)>>2]&3](302,79,-1.0,1019,e);pe[c[(e+8|0)>>2]&3](302,80,-((a[(c[(d+424|0)>>2]|0)+83|0]|0)!=0?1.0:-1.0),1020,e);pe[c[(e+8|0)>>2]&3](303,78,1.0,1021,e);pe[c[(e+8|0)>>2]&3](303,79,-.4999999999999999,1022,e);pe[c[(e+8|0)>>2]&3](304,76,+h[(c[(d+416|0)>>2]|0)+21264>>3]*-.8660254037844387,1023,e);pe[c[(e+8|0)>>2]&3](304,77,1.0,1024,e);pe[c[(e+8|0)>>2]&3](304,78,+h[(c[(d+416|0)>>2]|0)+21264>>3]*-.4999999999999999,1025,e);pe[c[(e+8|0)>>2]&3](305,76,1.0,1026,e);pe[c[(e+8|0)>>2]&3](305,79,-.8660254037844387,1027,e);pe[c[(e+8|0)>>2]&3](306,71,1.0,1028,e);pe[c[(e+8|0)>>2]&3](306,75,1.0,1029,e);pe[c[(e+8|0)>>2]&3](306,76,-1.0,1030,e);pe[c[(e+8|0)>>2]&3](307,71,-.8660254037844387,1031,e);pe[c[(e+8|0)>>2]&3](307,74,-1.0,1032,e);pe[c[(e+8|0)>>2]&3](307,86,-.4999999999999999,1033,e);pe[c[(e+8|0)>>2]&3](308,73,1.0,1034,e);pe[c[(e+8|0)>>2]&3](308,74,2.0,1035,e);pe[c[(e+8|0)>>2]&3](309,72,1.0,1036,e);pe[c[(e+8|0)>>2]&3](309,73,-.5,1037,e);pe[c[(e+8|0)>>2]&3](310,69,-1.0,1038,e);pe[c[(e+8|0)>>2]&3](310,71,1.0,1039,e);t=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;b=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](310,298,+h[t+14872>>3]*+h[b+3952>>3]- +h[t+14856>>3]*+h[b+3944>>3],1040,e);pe[c[(e+8|0)>>2]&3](311,7,-1.0,1041,e);pe[c[(e+8|0)>>2]&3](311,70,1.0,1042,e);b=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;t=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](311,298,+h[b+16208>>3]*+h[t+4432>>3]- +h[b+16232>>3]*+h[t+4424>>3],1043,e);pe[c[(e+8|0)>>2]&3](312,6,-1.0,1044,e);pe[c[(e+8|0)>>2]&3](312,69,1.0,1045,e);t=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;b=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](312,298,+h[t+16200>>3]*+h[b+4432>>3]- +h[t+16224>>3]*+h[b+4424>>3],1046,e);pe[c[(e+8|0)>>2]&3](313,7,-1.0,1047,e);pe[c[(e+8|0)>>2]&3](313,68,1.0,1048,e);b=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;t=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](313,298,+h[b+16208>>3]*+h[t+3856>>3]- +h[b+16232>>3]*+h[t+3848>>3],1049,e);pe[c[(e+8|0)>>2]&3](314,6,-1.0,1050,e);pe[c[(e+8|0)>>2]&3](314,67,1.0,1051,e);t=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;b=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](314,298,+h[t+16200>>3]*+h[b+3856>>3]- +h[t+16224>>3]*+h[b+3848>>3],1052,e);pe[c[(e+8|0)>>2]&3](315,27,-1.0,1053,e);pe[c[(e+8|0)>>2]&3](315,66,1.0,1054,e);pe[c[(e+8|0)>>2]&3](315,298,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6976>>3],1055,e);pe[c[(e+8|0)>>2]&3](316,36,+h[(c[(d+416|0)>>2]|0)+2784>>3],1056,e);pe[c[(e+8|0)>>2]&3](316,40,-+h[(c[(d+416|0)>>2]|0)+2768>>3],1057,e);pe[c[(e+8|0)>>2]&3](316,65,-1.0,1058,e);pe[c[(e+8|0)>>2]&3](316,66,-5.0e-4,1059,e);pe[c[(e+8|0)>>2]&3](317,35,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+16040>>3],1060,e);pe[c[(e+8|0)>>2]&3](317,39,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3592>>3],1061,e);pe[c[(e+8|0)>>2]&3](317,64,1.0,1062,e);pe[c[(e+8|0)>>2]&3](317,65,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3672>>3],1063,e);pe[c[(e+8|0)>>2]&3](318,46,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+3568>>3],1064,e);pe[c[(e+8|0)>>2]&3](318,48,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9656>>3],1065,e);pe[c[(e+8|0)>>2]&3](318,63,-1.0,1066,e);pe[c[(e+8|0)>>2]&3](318,64,-1.0,1067,e);}function _setLinearMatrixA4256$2(b){b=b|0;var d=0,e=0,f=0,i=0.0,j=0,k=0.0,l=0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,W=0.0,X=0.0;d=c[b+8>>2]|0;e=c[b+16>>2]|0;f=c[b+3792>>2]|0;i=+g[b+3800>>2];j=c[b+3808>>2]|0;k=+g[b+3816>>2];pe[c[(e+8|0)>>2]&3](156,214,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7704>>3]*+h[(c[(d+416|0)>>2]|0)+24160>>3]),533,e);l=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](156,217,+h[l+14840>>3]*+h[l+24160>>3],534,e);pe[c[(e+8|0)>>2]&3](156,225,-1.0,535,e);l=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](156,255,-(+h[l+14848>>3]*+h[l+24160>>3]),536,e);pe[c[(e+8|0)>>2]&3](157,217,-.006,537,e);pe[c[(e+8|0)>>2]&3](157,221,+h[(c[(d+416|0)>>2]|0)+14832>>3],538,e);pe[c[(e+8|0)>>2]&3](157,224,-1.0,539,e);pe[c[(e+8|0)>>2]&3](157,225,-+h[(c[(d+416|0)>>2]|0)+14840>>3],540,e);pe[c[(e+8|0)>>2]&3](158,221,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7712>>3],541,e);pe[c[(e+8|0)>>2]&3](158,223,1.0,542,e);pe[c[(e+8|0)>>2]&3](158,225,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7688>>3],543,e);pe[c[(e+8|0)>>2]&3](159,219,-1.0,544,e);pe[c[(e+8|0)>>2]&3](159,222,1.0,545,e);pe[c[(e+8|0)>>2]&3](159,298,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7688>>3],546,e);pe[c[(e+8|0)>>2]&3](160,199,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7720>>3]*+h[(c[(d+416|0)>>2]|0)+24160>>3]),547,e);pe[c[(e+8|0)>>2]&3](160,214,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7728>>3]*+h[(c[(d+416|0)>>2]|0)+24160>>3]),548,e);l=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](160,217,-(+h[l+14832>>3]*+h[l+24160>>3]),549,e);pe[c[(e+8|0)>>2]&3](160,221,-1.0,550,e);l=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](160,222,+h[l+14848>>3]*+h[l+24160>>3],551,e);l=c[(e+8|0)>>2]|0;m=+h[(c[(d+416|0)>>2]|0)+23944>>3];n=c[c[(d+4|0)>>2]>>2]|0;o=+h[(c[n+8>>2]|0)+15e3>>3];do{if(m!=0.0){p=-o/m}else{if(o==-0.0){p=-o;break}p=-o/+$Lb(c[d+536>>2]|0,m,9232,11496,+h[n>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](161,203,p,552,e);l=c[(e+8|0)>>2]|0;p=+h[(c[(d+416|0)>>2]|0)+23944>>3];n=c[c[(d+4|0)>>2]>>2]|0;m=+h[(c[n+8>>2]|0)+14992>>3];do{if(p!=0.0){q=-m/p}else{if(m==-0.0){q=-m;break}q=-m/+$Lb(c[d+536>>2]|0,p,9232,11496,+h[n>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](161,213,q,553,e);pe[c[(e+8|0)>>2]&3](161,220,1.0,554,e);l=c[(e+8|0)>>2]|0;q=+h[(c[(d+416|0)>>2]|0)+23944>>3];n=c[c[(d+4|0)>>2]>>2]|0;p=+h[(c[n+8>>2]|0)+688>>3];do{if(q!=0.0){r=p/q}else{if(p==0.0){r=p;break}r=p/+$Lb(c[d+536>>2]|0,q,9232,11496,+h[n>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](161,298,r,555,e);pe[c[(e+8|0)>>2]&3](162,215,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15648>>3],556,e);pe[c[(e+8|0)>>2]&3](162,219,1.0,557,e);pe[c[(e+8|0)>>2]&3](162,220,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15656>>3],558,e);pe[c[(e+8|0)>>2]&3](163,215,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+720>>3],559,e);pe[c[(e+8|0)>>2]&3](163,218,1.0,560,e);pe[c[(e+8|0)>>2]&3](163,220,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+712>>3],561,e);pe[c[(e+8|0)>>2]&3](164,217,1.0,562,e);pe[c[(e+8|0)>>2]&3](164,218,-1.0,563,e);l=c[(e+8|0)>>2]|0;n=c[c[(d+4|0)>>2]>>2]|0;s=c[n+8>>2]|0;r=+h[s+19760>>3];q=+h[s+712>>3];do{if(r!=0.0){t=-q/r}else{if(q==-0.0){t=-q;break}t=-q/+$Lb(c[d+536>>2]|0,r,9288,11496,+h[n>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](165,215,t,564,e);pe[c[(e+8|0)>>2]&3](165,216,1.0,565,e);l=c[(e+8|0)>>2]|0;n=c[c[(d+4|0)>>2]>>2]|0;s=c[n+8>>2]|0;t=+h[s+19760>>3];r=+h[s+720>>3];do{if(t!=0.0){u=r/t}else{if(r==0.0){u=r;break}u=r/+$Lb(c[d+536>>2]|0,t,9288,11496,+h[n>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](165,220,u,566,e);l=c[(e+8|0)>>2]|0;u=+h[(c[(d+416|0)>>2]|0)+23944>>3];n=c[c[(d+4|0)>>2]>>2]|0;t=+h[(c[n+8>>2]|0)+15016>>3];do{if(u!=0.0){v=-t/u}else{if(t==-0.0){v=-t;break}v=-t/+$Lb(c[d+536>>2]|0,u,9232,11496,+h[n>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](166,203,v,567,e);l=c[(e+8|0)>>2]|0;v=+h[(c[(d+416|0)>>2]|0)+23944>>3];n=c[c[(d+4|0)>>2]>>2]|0;u=+h[(c[n+8>>2]|0)+15008>>3];do{if(v!=0.0){w=-u/v}else{if(u==-0.0){w=-u;break}w=-u/+$Lb(c[d+536>>2]|0,v,9232,11496,+h[n>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](166,213,w,568,e);pe[c[(e+8|0)>>2]&3](166,215,1.0,569,e);l=c[(e+8|0)>>2]|0;w=+h[(c[(d+416|0)>>2]|0)+23944>>3];n=c[c[(d+4|0)>>2]>>2]|0;v=+h[(c[n+8>>2]|0)+680>>3];do{if(w!=0.0){x=-v/w}else{if(v==-0.0){x=-v;break}x=-v/+$Lb(c[d+536>>2]|0,w,9232,11496,+h[n>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[l&3](166,298,x,570,e);pe[c[(e+8|0)>>2]&3](167,198,-1.0,571,e);pe[c[(e+8|0)>>2]&3](167,214,1.0,572,e);l=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;n=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](167,298,+h[l+15008>>3]*+h[n+13e3>>3]- +h[l+14992>>3]*+h[n+12992>>3],573,e);pe[c[(e+8|0)>>2]&3](168,206,-1.0,574,e);pe[c[(e+8|0)>>2]&3](168,213,1.0,575,e);pe[c[(e+8|0)>>2]&3](168,214,1.0,576,e);pe[c[(e+8|0)>>2]&3](169,199,-.4999999999999999,577,e);pe[c[(e+8|0)>>2]&3](169,212,-1.0,578,e);pe[c[(e+8|0)>>2]&3](169,214,-.8660254037844387,579,e);pe[c[(e+8|0)>>2]&3](170,202,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10168>>3]*-2.0,580,e);pe[c[(e+8|0)>>2]&3](170,211,1.0,581,e);pe[c[(e+8|0)>>2]&3](170,212,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10176>>3]*-2.0,582,e);pe[c[(e+8|0)>>2]&3](171,200,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19800>>3]*-2.0,583,e);pe[c[(e+8|0)>>2]&3](171,210,1.0,584,e);pe[c[(e+8|0)>>2]&3](171,211,1.0,585,e);pe[c[(e+8|0)>>2]&3](172,209,1.0,586,e);n=$Ob(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19784>>3],1.0e-12)|0;pe[c[(e+8|0)>>2]&3](172,210,-(n<<24>>24!=0?1.0:0.0),587,e);pe[c[(e+8|0)>>2]&3](173,208,1.0,588,e);n=c[(e+8|0)>>2]|0;l=c[c[(d+4|0)>>2]>>2]|0;x=+V(+(+h[(c[l+8>>2]|0)+19776>>3]));if(x!=0.0){y=x}else{y=+$Lb(c[d+536>>2]|0,x,9560,11496,+h[l>>3],(a[d+319|0]|0)!=0|0)}pe[n&3](173,209,-.5/y,589,e);pe[c[(e+8|0)>>2]&3](174,200,1.0,590,e);pe[c[(e+8|0)>>2]&3](174,207,-1.0,591,e);pe[c[(e+8|0)>>2]&3](174,208,-((a[(c[(d+424|0)>>2]|0)+227|0]|0)!=0?1.0:-1.0),592,e);pe[c[(e+8|0)>>2]&3](175,206,1.0,593,e);pe[c[(e+8|0)>>2]&3](175,207,.4999999999999999,594,e);pe[c[(e+8|0)>>2]&3](176,204,+h[(c[(d+416|0)>>2]|0)+24360>>3]*-.8660254037844387,595,e);pe[c[(e+8|0)>>2]&3](176,205,1.0,596,e);pe[c[(e+8|0)>>2]&3](176,206,+h[(c[(d+416|0)>>2]|0)+24360>>3]*.4999999999999999,597,e);pe[c[(e+8|0)>>2]&3](177,204,1.0,598,e);pe[c[(e+8|0)>>2]&3](177,207,-.8660254037844387,599,e);pe[c[(e+8|0)>>2]&3](178,199,1.0,600,e);pe[c[(e+8|0)>>2]&3](178,203,1.0,601,e);pe[c[(e+8|0)>>2]&3](178,204,-1.0,602,e);pe[c[(e+8|0)>>2]&3](179,199,-.8660254037844387,603,e);pe[c[(e+8|0)>>2]&3](179,202,-1.0,604,e);pe[c[(e+8|0)>>2]&3](179,214,.4999999999999999,605,e);pe[c[(e+8|0)>>2]&3](180,201,1.0,606,e);pe[c[(e+8|0)>>2]&3](180,202,2.0,607,e);pe[c[(e+8|0)>>2]&3](181,200,1.0,608,e);pe[c[(e+8|0)>>2]&3](181,201,-.5,609,e);pe[c[(e+8|0)>>2]&3](182,197,-1.0,610,e);pe[c[(e+8|0)>>2]&3](182,199,1.0,611,e);n=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;l=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](182,298,+h[n+15016>>3]*+h[l+13e3>>3]- +h[n+15e3>>3]*+h[l+12992>>3],612,e);pe[c[(e+8|0)>>2]&3](183,190,-1.0,613,e);pe[c[(e+8|0)>>2]&3](183,198,1.0,614,e);l=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;n=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](183,298,+h[l+16208>>3]*+h[n+13480>>3]- +h[l+16232>>3]*+h[n+13472>>3],615,e);pe[c[(e+8|0)>>2]&3](184,189,-1.0,616,e);pe[c[(e+8|0)>>2]&3](184,197,1.0,617,e);n=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;l=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](184,298,+h[n+16200>>3]*+h[l+13480>>3]- +h[n+16224>>3]*+h[l+13472>>3],618,e);pe[c[(e+8|0)>>2]&3](185,190,-1.0,619,e);pe[c[(e+8|0)>>2]&3](185,196,1.0,620,e);l=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;n=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](185,298,+h[l+16208>>3]*+h[n+12904>>3]- +h[l+16232>>3]*+h[n+12896>>3],621,e);pe[c[(e+8|0)>>2]&3](186,189,-1.0,622,e);pe[c[(e+8|0)>>2]&3](186,195,1.0,623,e);n=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;l=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](186,298,+h[n+16200>>3]*+h[l+12904>>3]- +h[n+16224>>3]*+h[l+12896>>3],624,e);pe[c[(e+8|0)>>2]&3](187,129,-1.0,625,e);pe[c[(e+8|0)>>2]&3](187,194,1.0,626,e);l=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;n=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](187,298,+h[l+16208>>3]*+h[n+10464>>3]- +h[l+16232>>3]*+h[n+10456>>3],627,e);pe[c[(e+8|0)>>2]&3](188,128,-1.0,628,e);pe[c[(e+8|0)>>2]&3](188,193,1.0,629,e);n=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;l=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](188,298,+h[n+16200>>3]*+h[l+10464>>3]- +h[n+16224>>3]*+h[l+10456>>3],630,e);pe[c[(e+8|0)>>2]&3](189,192,1.0,631,e);pe[c[(e+8|0)>>2]&3](189,193,-1.0,632,e);l=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;n=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](189,298,+h[l+14968>>3]*+h[n+9984>>3]- +h[l+14952>>3]*+h[n+9976>>3],633,e);pe[c[(e+8|0)>>2]&3](190,0,-1.0,634,e);pe[c[(e+8|0)>>2]&3](190,191,1.0,635,e);pe[c[(e+8|0)>>2]&3](190,192,1.0,636,e);pe[c[(e+8|0)>>2]&3](191,129,-1.0,637,e);pe[c[(e+8|0)>>2]&3](191,190,1.0,638,e);n=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;l=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](191,298,+h[n+16208>>3]*+h[l+9888>>3]- +h[n+16232>>3]*+h[l+9880>>3],639,e);pe[c[(e+8|0)>>2]&3](192,128,-1.0,640,e);pe[c[(e+8|0)>>2]&3](192,189,1.0,641,e);l=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;n=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](192,298,+h[l+16200>>3]*+h[n+9888>>3]- +h[l+16224>>3]*+h[n+9880>>3],642,e);pe[c[(e+8|0)>>2]&3](193,149,-1.0,643,e);pe[c[(e+8|0)>>2]&3](193,188,1.0,644,e);pe[c[(e+8|0)>>2]&3](193,298,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7344>>3],645,e);pe[c[(e+8|0)>>2]&3](194,158,+h[(c[(d+416|0)>>2]|0)+8816>>3],646,e);pe[c[(e+8|0)>>2]&3](194,162,-+h[(c[(d+416|0)>>2]|0)+8800>>3],647,e);pe[c[(e+8|0)>>2]&3](194,187,-1.0,648,e);pe[c[(e+8|0)>>2]&3](194,188,-5.0e-4,649,e);pe[c[(e+8|0)>>2]&3](195,157,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15848>>3],650,e);pe[c[(e+8|0)>>2]&3](195,161,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2152>>3],651,e);pe[c[(e+8|0)>>2]&3](195,186,1.0,652,e);pe[c[(e+8|0)>>2]&3](195,187,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2232>>3],653,e);pe[c[(e+8|0)>>2]&3](196,168,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2128>>3],654,e);pe[c[(e+8|0)>>2]&3](196,170,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9896>>3],655,e);pe[c[(e+8|0)>>2]&3](196,185,-1.0,656,e);pe[c[(e+8|0)>>2]&3](196,186,-1.0,657,e);pe[c[(e+8|0)>>2]&3](197,167,-+h[(c[(d+416|0)>>2]|0)+6960>>3],658,e);pe[c[(e+8|0)>>2]&3](197,169,+h[(c[(d+416|0)>>2]|0)+6952>>3],659,e);pe[c[(e+8|0)>>2]&3](197,184,-1.0,660,e);pe[c[(e+8|0)>>2]&3](197,185,1.0,661,e);pe[c[(e+8|0)>>2]&3](198,171,+h[(c[(d+416|0)>>2]|0)+7440>>3],662,e);pe[c[(e+8|0)>>2]&3](198,172,-+h[(c[(d+416|0)>>2]|0)+7448>>3],663,e);pe[c[(e+8|0)>>2]&3](198,174,1.0,664,e);pe[c[(e+8|0)>>2]&3](198,181,-1.0,665,e);pe[c[(e+8|0)>>2]&3](199,167,+h[(c[(d+416|0)>>2]|0)+7448>>3],666,e);pe[c[(e+8|0)>>2]&3](199,171,-+h[(c[(d+416|0)>>2]|0)+7432>>3],667,e);pe[c[(e+8|0)>>2]&3](199,176,-.8660254037844386,668,e);pe[c[(e+8|0)>>2]&3](199,182,-1.0,669,e);pe[c[(e+8|0)>>2]&3](199,184,.5000000000000001,670,e);pe[c[(e+8|0)>>2]&3](200,167,-+h[(c[(d+416|0)>>2]|0)+7440>>3],671,e);pe[c[(e+8|0)>>2]&3](200,172,+h[(c[(d+416|0)>>2]|0)+7432>>3],672,e);pe[c[(e+8|0)>>2]&3](200,176,-.5000000000000001,673,e);pe[c[(e+8|0)>>2]&3](200,183,-1.0,674,e);pe[c[(e+8|0)>>2]&3](200,184,-.8660254037844386,675,e);n=c[(e+8|0)>>2]|0;l=c[c[(d+4|0)>>2]>>2]|0;s=c[l+8>>2]|0;y=+h[s+7320>>3]*+h[(c[(d+416|0)>>2]|0)+21880>>3];x=+h[s+15848>>3];do{if(y!=0.0){z=x/y}else{if(x==0.0){z=x;break}z=x/+$Lb(c[d+536>>2]|0,y,11792,11496,+h[l>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[n&3](201,163,z,676,e);n=c[(e+8|0)>>2]|0;l=c[c[(d+4|0)>>2]>>2]|0;s=c[l+8>>2]|0;z=+h[s+2152>>3];y=+h[(c[(d+416|0)>>2]|0)+21880>>3];x=+h[s+15840>>3];do{if(y!=0.0){A=x/y}else{if(x==0.0){A=x;break}A=x/+$Lb(c[d+536>>2]|0,y,8736,11496,+h[l>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[n&3](201,164,-(z*A),677,e);pe[c[(e+8|0)>>2]&3](201,180,1.0,678,e);n=c[(e+8|0)>>2]|0;l=c[c[(d+4|0)>>2]>>2]|0;s=c[l+8>>2]|0;A=+h[s+2152>>3];z=+h[(c[(d+416|0)>>2]|0)+21880>>3];y=+h[s+15848>>3];do{if(z!=0.0){B=y/z}else{if(y==0.0){B=y;break}B=y/+$Lb(c[d+536>>2]|0,z,8736,11496,+h[l>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[n&3](201,186,-(A*B),679,e);n=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20144>>3])),1.0e-10)|0;l=c[(e+8|0)>>2]|0;do{if(n<<24>>24==0){s=c[c[(d+4|0)>>2]>>2]|0;B=+h[(c[s+8>>2]|0)+20144>>3];if(B!=0.0){C=B;break}C=+$Lb(c[d+536>>2]|0,B,8616,11496,+h[s>>3],(a[d+319|0]|0)!=0|0)}else{C=1.0e-10}}while(0);pe[l&3](202,138,1.0/C,680,e);l=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20144>>3])),1.0e-10)|0;n=c[(e+8|0)>>2]|0;s=c[c[(d+4|0)>>2]>>2]|0;D=c[s+8>>2]|0;if(l<<24>>24!=0){E=1}else{E=+h[D+20144>>3]!=0.0}C=+h[D+14920>>3]*.8660254037844387+ +h[D+14912>>3]*-.4999999999999999;do{if(E){if(l<<24>>24!=0){F=1.0e-10}else{F=+h[D+20144>>3]}G=C/F}else{if(C==0.0){G=C;break}if(l<<24>>24!=0){H=1.0e-10}else{H=+h[D+20144>>3]}G=C/+$Lb(c[d+536>>2]|0,H,8616,11496,+h[s>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[n&3](202,166,G,681,e);pe[c[(e+8|0)>>2]&3](202,179,1.0,682,e);n=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+20144>>3])),1.0e-10)|0;s=c[(e+8|0)>>2]|0;D=c[c[(d+4|0)>>2]>>2]|0;l=c[D+8>>2]|0;if(n<<24>>24!=0){I=1}else{I=+h[l+20144>>3]!=0.0}G=+h[l+14904>>3]*.8660254037844387+ +h[l+14896>>3]*-.4999999999999999;do{if(I){if(n<<24>>24!=0){J=1.0e-10}else{J=+h[l+20144>>3]}K=G/J}else{if(G==0.0){K=G;break}if(n<<24>>24!=0){L=1.0e-10}else{L=+h[l+20144>>3]}K=G/+$Lb(c[d+536>>2]|0,L,8616,11496,+h[D>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](202,180,K,683,e);pe[c[(e+8|0)>>2]&3](203,178,1.0,684,e);pe[c[(e+8|0)>>2]&3](203,179,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2232>>3],685,e);pe[c[(e+8|0)>>2]&3](203,180,-1.0,686,e);pe[c[(e+8|0)>>2]&3](204,164,-1.0,687,e);pe[c[(e+8|0)>>2]&3](204,168,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2120>>3],688,e);pe[c[(e+8|0)>>2]&3](204,177,-1.0,689,e);pe[c[(e+8|0)>>2]&3](204,178,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+9896>>3],690,e);pe[c[(e+8|0)>>2]&3](205,167,+h[(c[(d+416|0)>>2]|0)+6968>>3],691,e);pe[c[(e+8|0)>>2]&3](205,173,-+h[(c[(d+416|0)>>2]|0)+6952>>3],692,e);pe[c[(e+8|0)>>2]&3](205,176,-1.0,693,e);pe[c[(e+8|0)>>2]&3](205,177,1.0,694,e);pe[c[(e+8|0)>>2]&3](206,163,-1.0,695,e);pe[c[(e+8|0)>>2]&3](206,170,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2120>>3],696,e);pe[c[(e+8|0)>>2]&3](206,175,-1.0,697,e);pe[c[(e+8|0)>>2]&3](206,178,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2128>>3],698,e);pe[c[(e+8|0)>>2]&3](207,169,-+h[(c[(d+416|0)>>2]|0)+6968>>3],699,e);pe[c[(e+8|0)>>2]&3](207,173,+h[(c[(d+416|0)>>2]|0)+6960>>3],700,e);pe[c[(e+8|0)>>2]&3](207,174,-1.0,701,e);pe[c[(e+8|0)>>2]&3](207,175,1.0,702,e);pe[c[(e+8|0)>>2]&3](208,160,-1.0,703,e);pe[c[(e+8|0)>>2]&3](208,173,-1.0,704,e);pe[c[(e+8|0)>>2]&3](208,178,-1.0,705,e);pe[c[(e+8|0)>>2]&3](209,169,.8660254037844386,706,e);pe[c[(e+8|0)>>2]&3](209,172,1.0,707,e);pe[c[(e+8|0)>>2]&3](209,173,-.5000000000000001,708,e);pe[c[(e+8|0)>>2]&3](210,169,.5000000000000001,709,e);pe[c[(e+8|0)>>2]&3](210,171,1.0,710,e);pe[c[(e+8|0)>>2]&3](210,173,.8660254037844386,711,e);pe[c[(e+8|0)>>2]&3](211,166,-1.0,712,e);pe[c[(e+8|0)>>2]&3](211,170,1.0,713,e);pe[c[(e+8|0)>>2]&3](211,179,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2240>>3],714,e);pe[c[(e+8|0)>>2]&3](212,159,-1.0,715,e);pe[c[(e+8|0)>>2]&3](212,169,-1.0,716,e);pe[c[(e+8|0)>>2]&3](212,170,-1.0,717,e);pe[c[(e+8|0)>>2]&3](213,165,-1.0,718,e);pe[c[(e+8|0)>>2]&3](213,168,1.0,719,e);pe[c[(e+8|0)>>2]&3](213,179,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7344>>3],720,e);pe[c[(e+8|0)>>2]&3](214,156,-1.0,721,e);pe[c[(e+8|0)>>2]&3](214,167,-1.0,722,e);pe[c[(e+8|0)>>2]&3](214,168,-1.0,723,e);s=c[(e+8|0)>>2]|0;D=c[c[(d+4|0)>>2]>>2]|0;l=c[D+8>>2]|0;K=+h[l+7320>>3]*+h[(c[(d+416|0)>>2]|0)+21880>>3];L=+h[l+15840>>3];do{if(K!=0.0){M=L/K}else{if(L==0.0){M=L;break}M=L/+$Lb(c[d+536>>2]|0,K,11792,11496,+h[D>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](215,163,M,724,e);s=c[(e+8|0)>>2]|0;D=c[c[(d+4|0)>>2]>>2]|0;l=c[D+8>>2]|0;M=+h[l+2160>>3];K=+h[(c[(d+416|0)>>2]|0)+21880>>3];L=+h[l+15840>>3];do{if(K!=0.0){N=L/K}else{if(L==0.0){N=L;break}N=L/+$Lb(c[d+536>>2]|0,K,8736,11496,+h[D>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](215,164,-(M*N),725,e);pe[c[(e+8|0)>>2]&3](215,166,1.0,726,e);s=c[(e+8|0)>>2]|0;D=c[c[(d+4|0)>>2]>>2]|0;l=c[D+8>>2]|0;N=+h[l+2160>>3];M=+h[(c[(d+416|0)>>2]|0)+21880>>3];K=+h[l+15848>>3];do{if(M!=0.0){O=K/M}else{if(K==0.0){O=K;break}O=K/+$Lb(c[d+536>>2]|0,M,8736,11496,+h[D>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](215,186,-(N*O),727,e);s=c[(e+8|0)>>2]|0;D=c[c[(d+4|0)>>2]>>2]|0;l=c[D+8>>2]|0;O=+h[l+7320>>3];N=+h[(c[(d+416|0)>>2]|0)+21880>>3];M=+h[l+15840>>3];do{if(N!=0.0){P=M/N}else{if(M==0.0){P=M;break}P=M/+$Lb(c[d+536>>2]|0,N,8736,11496,+h[D>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](216,164,-(O*P),728,e);pe[c[(e+8|0)>>2]&3](216,165,1.0,729,e);s=c[(e+8|0)>>2]|0;D=c[c[(d+4|0)>>2]>>2]|0;l=c[D+8>>2]|0;P=+h[l+7320>>3];O=+h[(c[(d+416|0)>>2]|0)+21880>>3];N=+h[l+15848>>3];do{if(O!=0.0){Q=N/O}else{if(N==0.0){Q=N;break}Q=N/+$Lb(c[d+536>>2]|0,O,8736,11496,+h[D>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](216,186,-(P*Q),730,e);pe[c[(e+8|0)>>2]&3](217,157,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15840>>3],731,e);pe[c[(e+8|0)>>2]&3](217,161,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2160>>3],732,e);pe[c[(e+8|0)>>2]&3](217,164,1.0,733,e);pe[c[(e+8|0)>>2]&3](217,187,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2240>>3],734,e);pe[c[(e+8|0)>>2]&3](218,161,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7320>>3],735,e);pe[c[(e+8|0)>>2]&3](218,163,1.0,736,e);pe[c[(e+8|0)>>2]&3](218,187,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7344>>3],737,e);pe[c[(e+8|0)>>2]&3](219,132,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7376>>3]*+h[(c[(d+416|0)>>2]|0)+22096>>3]),738,e);pe[c[(e+8|0)>>2]&3](219,147,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7384>>3]*+h[(c[(d+416|0)>>2]|0)+22096>>3]),739,e);s=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](219,155,-(+h[s+8808>>3]*+h[s+22096>>3]),740,e);pe[c[(e+8|0)>>2]&3](219,162,-1.0,741,e);s=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](219,188,+h[s+8800>>3]*+h[s+22096>>3],742,e);pe[c[(e+8|0)>>2]&3](220,154,-+h[(c[(d+416|0)>>2]|0)+8816>>3],743,e);pe[c[(e+8|0)>>2]&3](220,155,-.006,744,e);pe[c[(e+8|0)>>2]&3](220,161,-1.0,745,e);pe[c[(e+8|0)>>2]&3](220,162,+h[(c[(d+416|0)>>2]|0)+8808>>3],746,e);pe[c[(e+8|0)>>2]&3](221,154,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2232>>3],747,e);pe[c[(e+8|0)>>2]&3](221,158,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2152>>3],748,e);pe[c[(e+8|0)>>2]&3](221,160,1.0,749,e);pe[c[(e+8|0)>>2]&3](221,162,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15848>>3],750,e);pe[c[(e+8|0)>>2]&3](222,154,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2240>>3],751,e);pe[c[(e+8|0)>>2]&3](222,158,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2160>>3],752,e);pe[c[(e+8|0)>>2]&3](222,159,1.0,753,e);pe[c[(e+8|0)>>2]&3](222,162,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15840>>3],754,e);pe[c[(e+8|0)>>2]&3](223,132,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7328>>3]*+h[(c[(d+416|0)>>2]|0)+22096>>3]),755,e);pe[c[(e+8|0)>>2]&3](223,147,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7336>>3]*+h[(c[(d+416|0)>>2]|0)+22096>>3]),756,e);s=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](223,150,+h[s+8808>>3]*+h[s+22096>>3],757,e);pe[c[(e+8|0)>>2]&3](223,158,-1.0,758,e);s=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](223,188,-(+h[s+8816>>3]*+h[s+22096>>3]),759,e);pe[c[(e+8|0)>>2]&3](224,150,-.006,760,e);pe[c[(e+8|0)>>2]&3](224,154,+h[(c[(d+416|0)>>2]|0)+8800>>3],761,e);pe[c[(e+8|0)>>2]&3](224,157,-1.0,762,e);pe[c[(e+8|0)>>2]&3](224,158,-+h[(c[(d+416|0)>>2]|0)+8808>>3],763,e);pe[c[(e+8|0)>>2]&3](225,154,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7344>>3],764,e);pe[c[(e+8|0)>>2]&3](225,156,1.0,765,e);pe[c[(e+8|0)>>2]&3](225,158,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7320>>3],766,e);pe[c[(e+8|0)>>2]&3](226,152,-1.0,767,e);pe[c[(e+8|0)>>2]&3](226,155,1.0,768,e);pe[c[(e+8|0)>>2]&3](226,298,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7320>>3],769,e);pe[c[(e+8|0)>>2]&3](227,132,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7352>>3]*+h[(c[(d+416|0)>>2]|0)+22096>>3]),770,e);pe[c[(e+8|0)>>2]&3](227,147,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7360>>3]*+h[(c[(d+416|0)>>2]|0)+22096>>3]),771,e);s=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](227,150,-(+h[s+8800>>3]*+h[s+22096>>3]),772,e);pe[c[(e+8|0)>>2]&3](227,154,-1.0,773,e);s=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](227,155,+h[s+8816>>3]*+h[s+22096>>3],774,e);s=c[(e+8|0)>>2]|0;Q=+h[(c[(d+416|0)>>2]|0)+21880>>3];D=c[c[(d+4|0)>>2]>>2]|0;P=+h[(c[D+8>>2]|0)+14904>>3];do{if(Q!=0.0){R=-P/Q}else{if(P==-0.0){R=-P;break}R=-P/+$Lb(c[d+536>>2]|0,Q,8736,11496,+h[D>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](228,136,R,775,e);s=c[(e+8|0)>>2]|0;R=+h[(c[(d+416|0)>>2]|0)+21880>>3];D=c[c[(d+4|0)>>2]>>2]|0;Q=+h[(c[D+8>>2]|0)+14896>>3];do{if(R!=0.0){S=-Q/R}else{if(Q==-0.0){S=-Q;break}S=-Q/+$Lb(c[d+536>>2]|0,R,8736,11496,+h[D>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](228,146,S,776,e);pe[c[(e+8|0)>>2]&3](228,153,1.0,777,e);s=c[(e+8|0)>>2]|0;S=+h[(c[(d+416|0)>>2]|0)+21880>>3];D=c[c[(d+4|0)>>2]>>2]|0;R=+h[(c[D+8>>2]|0)+2128>>3];do{if(S!=0.0){T=R/S}else{if(R==0.0){T=R;break}T=R/+$Lb(c[d+536>>2]|0,S,8736,11496,+h[D>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](228,298,T,778,e);pe[c[(e+8|0)>>2]&3](229,148,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15840>>3],779,e);pe[c[(e+8|0)>>2]&3](229,152,1.0,780,e);pe[c[(e+8|0)>>2]&3](229,153,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15848>>3],781,e);pe[c[(e+8|0)>>2]&3](230,148,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2160>>3],782,e);pe[c[(e+8|0)>>2]&3](230,151,1.0,783,e);pe[c[(e+8|0)>>2]&3](230,153,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2152>>3],784,e);pe[c[(e+8|0)>>2]&3](231,150,1.0,785,e);pe[c[(e+8|0)>>2]&3](231,151,-1.0,786,e);s=c[(e+8|0)>>2]|0;D=c[c[(d+4|0)>>2]>>2]|0;l=c[D+8>>2]|0;T=+h[l+20080>>3];S=+h[l+2152>>3];do{if(T!=0.0){W=-S/T}else{if(S==-0.0){W=-S;break}W=-S/+$Lb(c[d+536>>2]|0,T,8888,11496,+h[D>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](232,148,W,787,e);pe[c[(e+8|0)>>2]&3](232,149,1.0,788,e);s=c[(e+8|0)>>2]|0;D=c[c[(d+4|0)>>2]>>2]|0;l=c[D+8>>2]|0;W=+h[l+20080>>3];T=+h[l+2160>>3];do{if(W!=0.0){X=T/W}else{if(T==0.0){X=T;break}X=T/+$Lb(c[d+536>>2]|0,W,8888,11496,+h[D>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[s&3](232,153,X,789,e);f=c[(e+8|0)>>2]|0;i=+h[(c[(d+416|0)>>2]|0)+21880>>3];j=c[c[(d+4|0)>>2]>>2]|0;k=+h[(c[j+8>>2]|0)+14920>>3];c[b+3792>>2]=f;g[b+3800>>2]=i;c[b+3808>>2]=j;g[b+3816>>2]=k}function _setLinearMatrixA4256$3(b){b=b|0;var d=0,e=0,f=0.0,g=0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0;d=c[b+8>>2]|0;e=c[b+16>>2]|0;pe[c[(e+8|0)>>2]&3](71,298,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7528>>3],255,e);pe[c[(e+8|0)>>2]&3](71,310,1.0,256,e);pe[c[(e+8|0)>>2]&3](71,311,-1.0,257,e);b=c[(e+8|0)>>2]|0;f=+h[(c[(d+416|0)>>2]|0)+22912>>3];g=c[c[(d+4|0)>>2]>>2]|0;i=+h[(c[g+8>>2]|0)+14968>>3];do{if(f!=0.0){j=-i/f}else{if(i==-0.0){j=-i;break}j=-i/+$Lb(c[d+536>>2]|0,f,9616,11496,+h[g>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](72,191,j,258,e);b=c[(e+8|0)>>2]|0;j=+h[(c[(d+416|0)>>2]|0)+22912>>3];g=c[c[(d+4|0)>>2]>>2]|0;f=+h[(c[g+8>>2]|0)+1400>>3];do{if(j!=0.0){k=-f/j}else{if(f==-0.0){k=-f;break}k=-f/+$Lb(c[d+536>>2]|0,j,9616,11496,+h[g>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](72,298,k,259,e);pe[c[(e+8|0)>>2]&3](72,309,1.0,260,e);b=c[(e+8|0)>>2]|0;k=+h[(c[(d+416|0)>>2]|0)+22912>>3];g=c[c[(d+4|0)>>2]>>2]|0;j=+h[(c[g+8>>2]|0)+14960>>3];do{if(k!=0.0){l=-j/k}else{if(j==-0.0){l=-j;break}l=-j/+$Lb(c[d+536>>2]|0,k,9616,11496,+h[g>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[b&3](72,352,l,261,e);pe[c[(e+8|0)>>2]&3](73,308,-.4999999999999999,262,e);pe[c[(e+8|0)>>2]&3](73,353,1.0,263,e);pe[c[(e+8|0)>>2]&3](74,304,-((a[(c[(d+424|0)>>2]|0)+179|0]|0)!=0?1.0:-1.0),264,e);pe[c[(e+8|0)>>2]&3](74,307,1.0,265,e);pe[c[(e+8|0)>>2]&3](74,308,-1.0,266,e);pe[c[(e+8|0)>>2]&3](75,301,1.0,267,e);pe[c[(e+8|0)>>2]&3](75,306,1.0,268,e);pe[c[(e+8|0)>>2]&3](75,307,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19960>>3]*-2.0,269,e);pe[c[(e+8|0)>>2]&3](76,305,1.0,270,e);b=$Ob(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19944>>3],1.0e-12)|0;pe[c[(e+8|0)>>2]&3](76,306,-(b<<24>>24!=0?1.0:0.0),271,e);pe[c[(e+8|0)>>2]&3](77,304,1.0,272,e);b=c[(e+8|0)>>2]|0;g=c[c[(d+4|0)>>2]>>2]|0;l=+V(+(+h[(c[g+8>>2]|0)+19936>>3]));if(l!=0.0){m=l}else{m=+$Lb(c[d+536>>2]|0,l,9944,11496,+h[g>>3],(a[d+319|0]|0)!=0|0)}pe[b&3](77,305,-.5/m,273,e);pe[c[(e+8|0)>>2]&3](78,303,-.5,274,e);pe[c[(e+8|0)>>2]&3](78,307,1.0,275,e);pe[c[(e+8|0)>>2]&3](79,302,2.0,276,e);pe[c[(e+8|0)>>2]&3](79,303,1.0,277,e);pe[c[(e+8|0)>>2]&3](80,299,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10056>>3]*-2.0,278,e);pe[c[(e+8|0)>>2]&3](80,301,1.0,279,e);pe[c[(e+8|0)>>2]&3](80,302,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10048>>3]*-2.0,280,e);pe[c[(e+8|0)>>2]&3](81,192,-.8660254037844387,281,e);pe[c[(e+8|0)>>2]&3](81,300,-.4999999999999999,282,e);pe[c[(e+8|0)>>2]&3](81,302,-1.0,283,e);pe[c[(e+8|0)>>2]&3](82,192,.4999999999999999,284,e);pe[c[(e+8|0)>>2]&3](82,299,-1.0,285,e);pe[c[(e+8|0)>>2]&3](82,300,-.8660254037844387,286,e);pe[c[(e+8|0)>>2]&3](83,194,-1.0,287,e);b=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;g=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](83,298,+h[b+14960>>3]*+h[g+9984>>3]- +h[b+14944>>3]*+h[g+9976>>3],288,e);pe[c[(e+8|0)>>2]&3](83,300,1.0,289,e);pe[c[(e+8|0)>>2]&3](84,297,-1.0,290,e);pe[c[(e+8|0)>>2]&3](84,298,+h[(c[(d+416|0)>>2]|0)+25488>>3],291,e);pe[c[(e+8|0)>>2]&3](85,5,1.0,292,e);pe[c[(e+8|0)>>2]&3](85,296,1.0,293,e);pe[c[(e+8|0)>>2]&3](85,297,1.0,294,e);pe[c[(e+8|0)>>2]&3](86,273,-1.0,295,e);pe[c[(e+8|0)>>2]&3](86,295,1.0,296,e);pe[c[(e+8|0)>>2]&3](86,298,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7944>>3],297,e);pe[c[(e+8|0)>>2]&3](87,271,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7936>>3]*+h[(c[(d+416|0)>>2]|0)+25192>>3]),298,e);g=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](87,274,+h[g+17856>>3]*+h[g+25192>>3],299,e);pe[c[(e+8|0)>>2]&3](87,294,-1.0,300,e);g=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](87,295,-(+h[g+17864>>3]*+h[g+25192>>3]),301,e);pe[c[(e+8|0)>>2]&3](87,380,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7928>>3]*+h[(c[(d+416|0)>>2]|0)+25192>>3]),302,e);pe[c[(e+8|0)>>2]&3](88,278,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+312>>3],303,e);pe[c[(e+8|0)>>2]&3](88,293,1.0,304,e);pe[c[(e+8|0)>>2]&3](88,294,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3],305,e);pe[c[(e+8|0)>>2]&3](88,379,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15512>>3],306,e);pe[c[(e+8|0)>>2]&3](89,292,-1.0,307,e);pe[c[(e+8|0)>>2]&3](89,293,-1.0,308,e);pe[c[(e+8|0)>>2]&3](89,374,-1.0,309,e);pe[c[(e+8|0)>>2]&3](90,286,-.4999999999999999,310,e);pe[c[(e+8|0)>>2]&3](90,291,1.0,311,e);pe[c[(e+8|0)>>2]&3](90,292,.8660254037844387,312,e);pe[c[(e+8|0)>>2]&3](91,238,1.0,313,e);pe[c[(e+8|0)>>2]&3](91,290,1.0,314,e);pe[c[(e+8|0)>>2]&3](91,291,-1.0,315,e);pe[c[(e+8|0)>>2]&3](92,286,.8660254037844387,316,e);pe[c[(e+8|0)>>2]&3](92,289,1.0,317,e);pe[c[(e+8|0)>>2]&3](92,292,.4999999999999999,318,e);pe[c[(e+8|0)>>2]&3](93,239,1.0,319,e);pe[c[(e+8|0)>>2]&3](93,288,1.0,320,e);pe[c[(e+8|0)>>2]&3](93,289,-1.0,321,e);pe[c[(e+8|0)>>2]&3](94,278,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+320>>3],322,e);pe[c[(e+8|0)>>2]&3](94,287,1.0,323,e);pe[c[(e+8|0)>>2]&3](94,294,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+240>>3],324,e);pe[c[(e+8|0)>>2]&3](94,379,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15504>>3],325,e);pe[c[(e+8|0)>>2]&3](95,282,-1.0,326,e);pe[c[(e+8|0)>>2]&3](95,286,-1.0,327,e);pe[c[(e+8|0)>>2]&3](95,287,-1.0,328,e);pe[c[(e+8|0)>>2]&3](96,274,-.006,329,e);pe[c[(e+8|0)>>2]&3](96,278,+h[(c[(d+416|0)>>2]|0)+17848>>3],330,e);pe[c[(e+8|0)>>2]&3](96,285,-1.0,331,e);pe[c[(e+8|0)>>2]&3](96,294,-+h[(c[(d+416|0)>>2]|0)+17856>>3],332,e);pe[c[(e+8|0)>>2]&3](97,280,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+240>>3],333,e);pe[c[(e+8|0)>>2]&3](97,284,1.0,334,e);pe[c[(e+8|0)>>2]&3](97,285,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15504>>3],335,e);pe[c[(e+8|0)>>2]&3](97,378,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+320>>3],336,e);g=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;n=c[b+8>>2]|0;m=+h[n+7920>>3]*+h[(c[(d+416|0)>>2]|0)+24976>>3];l=+h[n+15504>>3];do{if(m!=0.0){o=l/m}else{if(l==0.0){o=l;break}o=l/+$Lb(c[d+536>>2]|0,m,11504,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](98,279,o,337,e);pe[c[(e+8|0)>>2]&3](98,283,1.0,338,e);g=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;n=c[b+8>>2]|0;o=+h[n+240>>3];m=+h[(c[(d+416|0)>>2]|0)+24976>>3];l=+h[n+15504>>3];do{if(m!=0.0){p=l/m}else{if(l==0.0){p=l;break}p=l/+$Lb(c[d+536>>2]|0,m,8464,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](98,284,-(o*p),339,e);g=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;n=c[b+8>>2]|0;p=+h[n+240>>3];o=+h[(c[(d+416|0)>>2]|0)+24976>>3];m=+h[n+15512>>3];do{if(o!=0.0){q=m/o}else{if(m==0.0){q=m;break}q=m/+$Lb(c[d+536>>2]|0,o,8464,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](98,377,-(p*q),340,e);pe[c[(e+8|0)>>2]&3](99,282,1.0,341,e);pe[c[(e+8|0)>>2]&3](99,283,-1.0,342,e);pe[c[(e+8|0)>>2]&3](99,375,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+320>>3],343,e);pe[c[(e+8|0)>>2]&3](100,276,-1.0,344,e);pe[c[(e+8|0)>>2]&3](100,281,1.0,345,e);pe[c[(e+8|0)>>2]&3](100,298,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7920>>3],346,e);pe[c[(e+8|0)>>2]&3](101,278,-+h[(c[(d+416|0)>>2]|0)+17864>>3],347,e);pe[c[(e+8|0)>>2]&3](101,280,-1.0,348,e);pe[c[(e+8|0)>>2]&3](101,281,-.006,349,e);pe[c[(e+8|0)>>2]&3](101,379,+h[(c[(d+416|0)>>2]|0)+17856>>3],350,e);pe[c[(e+8|0)>>2]&3](102,279,1.0,351,e);pe[c[(e+8|0)>>2]&3](102,280,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7920>>3],352,e);pe[c[(e+8|0)>>2]&3](102,378,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7944>>3],353,e);pe[c[(e+8|0)>>2]&3](103,271,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7960>>3]*+h[(c[(d+416|0)>>2]|0)+25192>>3]),354,e);g=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](103,274,-(+h[g+17848>>3]*+h[g+25192>>3]),355,e);pe[c[(e+8|0)>>2]&3](103,278,-1.0,356,e);g=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](103,281,+h[g+17864>>3]*+h[g+25192>>3],357,e);pe[c[(e+8|0)>>2]&3](103,380,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7952>>3]*+h[(c[(d+416|0)>>2]|0)+25192>>3]),358,e);g=c[(e+8|0)>>2]|0;q=+h[(c[(d+416|0)>>2]|0)+24976>>3];b=c[c[(d+4|0)>>2]>>2]|0;p=+h[(c[b+8>>2]|0)+15048>>3];do{if(q!=0.0){r=-p/q}else{if(p==-0.0){r=-p;break}r=-p/+$Lb(c[d+536>>2]|0,q,8464,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](104,260,r,359,e);g=c[(e+8|0)>>2]|0;r=+h[(c[(d+416|0)>>2]|0)+24976>>3];b=c[c[(d+4|0)>>2]>>2]|0;q=+h[(c[b+8>>2]|0)+15040>>3];do{if(r!=0.0){s=-q/r}else{if(q==-0.0){s=-q;break}s=-q/+$Lb(c[d+536>>2]|0,r,8464,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](104,270,s,360,e);pe[c[(e+8|0)>>2]&3](104,277,1.0,361,e);g=c[(e+8|0)>>2]|0;s=+h[(c[(d+416|0)>>2]|0)+24976>>3];b=c[c[(d+4|0)>>2]>>2]|0;r=+h[(c[b+8>>2]|0)+208>>3];do{if(s!=0.0){t=r/s}else{if(r==0.0){t=r;break}t=r/+$Lb(c[d+536>>2]|0,s,8464,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](104,298,t,362,e);pe[c[(e+8|0)>>2]&3](105,272,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15504>>3],363,e);pe[c[(e+8|0)>>2]&3](105,276,1.0,364,e);pe[c[(e+8|0)>>2]&3](105,277,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15512>>3],365,e);pe[c[(e+8|0)>>2]&3](106,272,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+240>>3],366,e);pe[c[(e+8|0)>>2]&3](106,275,1.0,367,e);pe[c[(e+8|0)>>2]&3](106,277,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3],368,e);pe[c[(e+8|0)>>2]&3](107,274,1.0,369,e);pe[c[(e+8|0)>>2]&3](107,275,-1.0,370,e);g=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;n=c[b+8>>2]|0;t=+h[n+19600>>3];s=+h[n+232>>3];do{if(t!=0.0){u=-s/t}else{if(s==-0.0){u=-s;break}u=-s/+$Lb(c[d+536>>2]|0,t,9e3,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](108,272,u,371,e);pe[c[(e+8|0)>>2]&3](108,273,1.0,372,e);g=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;n=c[b+8>>2]|0;u=+h[n+19600>>3];t=+h[n+240>>3];do{if(u!=0.0){v=t/u}else{if(t==0.0){v=t;break}v=t/+$Lb(c[d+536>>2]|0,u,9e3,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](108,277,v,373,e);g=c[(e+8|0)>>2]|0;v=+h[(c[(d+416|0)>>2]|0)+24976>>3];b=c[c[(d+4|0)>>2]>>2]|0;u=+h[(c[b+8>>2]|0)+15064>>3];do{if(v!=0.0){w=-u/v}else{if(u==-0.0){w=-u;break}w=-u/+$Lb(c[d+536>>2]|0,v,8464,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](109,260,w,374,e);g=c[(e+8|0)>>2]|0;w=+h[(c[(d+416|0)>>2]|0)+24976>>3];b=c[c[(d+4|0)>>2]>>2]|0;v=+h[(c[b+8>>2]|0)+15056>>3];do{if(w!=0.0){x=-v/w}else{if(v==-0.0){x=-v;break}x=-v/+$Lb(c[d+536>>2]|0,w,8464,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](109,270,x,375,e);pe[c[(e+8|0)>>2]&3](109,272,1.0,376,e);g=c[(e+8|0)>>2]|0;x=+h[(c[(d+416|0)>>2]|0)+24976>>3];b=c[c[(d+4|0)>>2]>>2]|0;w=+h[(c[b+8>>2]|0)+200>>3];do{if(x!=0.0){y=-w/x}else{if(w==-0.0){y=-w;break}y=-w/+$Lb(c[d+536>>2]|0,x,8464,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](109,298,y,377,e);pe[c[(e+8|0)>>2]&3](110,256,-1.0,378,e);pe[c[(e+8|0)>>2]&3](110,271,1.0,379,e);g=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;b=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](110,298,+h[g+15056>>3]*+h[b+16016>>3]- +h[g+15040>>3]*+h[b+16008>>3],380,e);pe[c[(e+8|0)>>2]&3](111,263,-1.0,381,e);pe[c[(e+8|0)>>2]&3](111,270,1.0,382,e);pe[c[(e+8|0)>>2]&3](111,271,1.0,383,e);pe[c[(e+8|0)>>2]&3](112,269,-1.0,384,e);pe[c[(e+8|0)>>2]&3](112,271,-.8660254037844387,385,e);pe[c[(e+8|0)>>2]&3](112,380,.4999999999999999,386,e);pe[c[(e+8|0)>>2]&3](113,259,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10288>>3]*-2.0,387,e);pe[c[(e+8|0)>>2]&3](113,268,1.0,388,e);pe[c[(e+8|0)>>2]&3](113,269,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10296>>3]*-2.0,389,e);pe[c[(e+8|0)>>2]&3](114,257,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19640>>3]*-2.0,390,e);pe[c[(e+8|0)>>2]&3](114,267,1.0,391,e);pe[c[(e+8|0)>>2]&3](114,268,1.0,392,e);pe[c[(e+8|0)>>2]&3](115,266,1.0,393,e);b=$Ob(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19624>>3],1.0e-12)|0;pe[c[(e+8|0)>>2]&3](115,267,-(b<<24>>24!=0?1.0:0.0),394,e);pe[c[(e+8|0)>>2]&3](116,265,1.0,395,e);b=c[(e+8|0)>>2]|0;g=c[c[(d+4|0)>>2]>>2]|0;y=+V(+(+h[(c[g+8>>2]|0)+19616>>3]));if(y!=0.0){z=y}else{z=+$Lb(c[d+536>>2]|0,y,9176,11496,+h[g>>3],(a[d+319|0]|0)!=0|0)}pe[b&3](116,266,-.5/z,396,e);pe[c[(e+8|0)>>2]&3](117,257,1.0,397,e);pe[c[(e+8|0)>>2]&3](117,264,-1.0,398,e);pe[c[(e+8|0)>>2]&3](117,265,-((a[(c[(d+424|0)>>2]|0)+275|0]|0)!=0?1.0:-1.0),399,e);pe[c[(e+8|0)>>2]&3](118,263,1.0,400,e);pe[c[(e+8|0)>>2]&3](118,264,-.4999999999999999,401,e);pe[c[(e+8|0)>>2]&3](119,261,+h[(c[(d+416|0)>>2]|0)+25392>>3]*-.8660254037844387,402,e);pe[c[(e+8|0)>>2]&3](119,262,1.0,403,e);pe[c[(e+8|0)>>2]&3](119,263,+h[(c[(d+416|0)>>2]|0)+25392>>3]*-.4999999999999999,404,e);pe[c[(e+8|0)>>2]&3](120,261,1.0,405,e);pe[c[(e+8|0)>>2]&3](120,264,-.8660254037844387,406,e);pe[c[(e+8|0)>>2]&3](121,260,1.0,407,e);pe[c[(e+8|0)>>2]&3](121,261,-1.0,408,e);pe[c[(e+8|0)>>2]&3](121,380,1.0,409,e);pe[c[(e+8|0)>>2]&3](122,259,-1.0,410,e);pe[c[(e+8|0)>>2]&3](122,271,-.4999999999999999,411,e);pe[c[(e+8|0)>>2]&3](122,380,-.8660254037844387,412,e);pe[c[(e+8|0)>>2]&3](123,258,1.0,413,e);pe[c[(e+8|0)>>2]&3](123,259,2.0,414,e);pe[c[(e+8|0)>>2]&3](124,257,1.0,415,e);pe[c[(e+8|0)>>2]&3](124,258,-.5,416,e);pe[c[(e+8|0)>>2]&3](125,196,-1.0,417,e);pe[c[(e+8|0)>>2]&3](125,256,1.0,418,e);b=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;g=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](125,298,+h[b+16208>>3]*+h[g+16496>>3]- +h[b+16232>>3]*+h[g+16488>>3],419,e);pe[c[(e+8|0)>>2]&3](126,216,-1.0,420,e);pe[c[(e+8|0)>>2]&3](126,255,1.0,421,e);pe[c[(e+8|0)>>2]&3](126,298,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7712>>3],422,e);pe[c[(e+8|0)>>2]&3](127,225,+h[(c[(d+416|0)>>2]|0)+14848>>3],423,e);pe[c[(e+8|0)>>2]&3](127,229,-+h[(c[(d+416|0)>>2]|0)+14832>>3],424,e);pe[c[(e+8|0)>>2]&3](127,254,-1.0,425,e);pe[c[(e+8|0)>>2]&3](127,255,-5.0e-4,426,e);pe[c[(e+8|0)>>2]&3](128,224,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15656>>3],427,e);pe[c[(e+8|0)>>2]&3](128,228,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+712>>3],428,e);pe[c[(e+8|0)>>2]&3](128,253,1.0,429,e);pe[c[(e+8|0)>>2]&3](128,254,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+792>>3],430,e);pe[c[(e+8|0)>>2]&3](129,235,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+688>>3],431,e);pe[c[(e+8|0)>>2]&3](129,237,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10136>>3],432,e);pe[c[(e+8|0)>>2]&3](129,252,-1.0,433,e);pe[c[(e+8|0)>>2]&3](129,253,-1.0,434,e);pe[c[(e+8|0)>>2]&3](130,234,-+h[(c[(d+416|0)>>2]|0)+12992>>3],435,e);pe[c[(e+8|0)>>2]&3](130,236,+h[(c[(d+416|0)>>2]|0)+12984>>3],436,e);pe[c[(e+8|0)>>2]&3](130,251,-1.0,437,e);pe[c[(e+8|0)>>2]&3](130,252,1.0,438,e);pe[c[(e+8|0)>>2]&3](131,238,+h[(c[(d+416|0)>>2]|0)+13472>>3],439,e);pe[c[(e+8|0)>>2]&3](131,239,-+h[(c[(d+416|0)>>2]|0)+13480>>3],440,e);pe[c[(e+8|0)>>2]&3](131,241,1.0,441,e);pe[c[(e+8|0)>>2]&3](131,250,-1.0,442,e);pe[c[(e+8|0)>>2]&3](132,234,+h[(c[(d+416|0)>>2]|0)+13480>>3],443,e);pe[c[(e+8|0)>>2]&3](132,238,-+h[(c[(d+416|0)>>2]|0)+13464>>3],444,e);pe[c[(e+8|0)>>2]&3](132,243,6.123233995736766e-17,445,e);pe[c[(e+8|0)>>2]&3](132,248,-1.0,446,e);pe[c[(e+8|0)>>2]&3](132,251,-1.0,447,e);pe[c[(e+8|0)>>2]&3](133,234,-+h[(c[(d+416|0)>>2]|0)+13472>>3],448,e);pe[c[(e+8|0)>>2]&3](133,239,+h[(c[(d+416|0)>>2]|0)+13464>>3],449,e);pe[c[(e+8|0)>>2]&3](133,243,1.0,450,e);pe[c[(e+8|0)>>2]&3](133,249,-1.0,451,e);pe[c[(e+8|0)>>2]&3](133,251,6.123233995736766e-17,452,e);g=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;n=c[b+8>>2]|0;z=+h[n+7688>>3]*+h[(c[(d+416|0)>>2]|0)+23944>>3];y=+h[n+15656>>3];do{if(z!=0.0){A=y/z}else{if(y==0.0){A=y;break}A=y/+$Lb(c[d+536>>2]|0,z,11696,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](134,230,A,453,e);g=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;n=c[b+8>>2]|0;A=+h[n+712>>3];z=+h[(c[(d+416|0)>>2]|0)+23944>>3];y=+h[n+15648>>3];do{if(z!=0.0){B=y/z}else{if(y==0.0){B=y;break}B=y/+$Lb(c[d+536>>2]|0,z,9232,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](134,231,-(A*B),454,e);pe[c[(e+8|0)>>2]&3](134,247,1.0,455,e);g=c[(e+8|0)>>2]|0;b=c[c[(d+4|0)>>2]>>2]|0;n=c[b+8>>2]|0;B=+h[n+712>>3];A=+h[(c[(d+416|0)>>2]|0)+23944>>3];z=+h[n+15656>>3];do{if(A!=0.0){C=z/A}else{if(z==0.0){C=z;break}C=z/+$Lb(c[d+536>>2]|0,A,9232,11496,+h[b>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](134,253,-(B*C),456,e);g=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19824>>3])),1.0e-10)|0;b=c[(e+8|0)>>2]|0;do{if(g<<24>>24==0){n=c[c[(d+4|0)>>2]>>2]|0;C=+h[(c[n+8>>2]|0)+19824>>3];if(C!=0.0){D=C;break}D=+$Lb(c[d+536>>2]|0,C,9440,11496,+h[n>>3],(a[d+319|0]|0)!=0|0)}else{D=1.0e-10}}while(0);pe[b&3](135,205,1.0/D,457,e);b=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19824>>3])),1.0e-10)|0;g=c[(e+8|0)>>2]|0;n=c[c[(d+4|0)>>2]>>2]|0;E=c[n+8>>2]|0;if(b<<24>>24!=0){F=1}else{F=+h[E+19824>>3]!=0.0}D=+h[E+15016>>3]*.8660254037844387+ +h[E+15008>>3]*-.4999999999999999;do{if(F){if(b<<24>>24!=0){G=1.0e-10}else{G=+h[E+19824>>3]}H=D/G}else{if(D==0.0){H=D;break}if(b<<24>>24!=0){I=1.0e-10}else{I=+h[E+19824>>3]}H=D/+$Lb(c[d+536>>2]|0,I,9440,11496,+h[n>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[g&3](135,233,H,458,e);pe[c[(e+8|0)>>2]&3](135,246,1.0,459,e);g=ZOb(+U(+(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+19824>>3])),1.0e-10)|0;n=c[(e+8|0)>>2]|0;E=c[c[(d+4|0)>>2]>>2]|0;b=c[E+8>>2]|0;if(g<<24>>24!=0){J=1}else{J=+h[b+19824>>3]!=0.0}H=+h[b+15e3>>3]*.8660254037844387+ +h[b+14992>>3]*-.4999999999999999;do{if(J){if(g<<24>>24!=0){K=1.0e-10}else{K=+h[b+19824>>3]}L=H/K}else{if(H==0.0){L=H;break}if(g<<24>>24!=0){M=1.0e-10}else{M=+h[b+19824>>3]}L=H/+$Lb(c[d+536>>2]|0,M,9440,11496,+h[E>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[n&3](135,247,L,460,e);pe[c[(e+8|0)>>2]&3](136,245,1.0,461,e);pe[c[(e+8|0)>>2]&3](136,246,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+792>>3],462,e);pe[c[(e+8|0)>>2]&3](136,247,-1.0,463,e);pe[c[(e+8|0)>>2]&3](137,231,-1.0,464,e);pe[c[(e+8|0)>>2]&3](137,235,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+680>>3],465,e);pe[c[(e+8|0)>>2]&3](137,244,-1.0,466,e);pe[c[(e+8|0)>>2]&3](137,245,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+10136>>3],467,e);pe[c[(e+8|0)>>2]&3](138,234,+h[(c[(d+416|0)>>2]|0)+13e3>>3],468,e);pe[c[(e+8|0)>>2]&3](138,240,-+h[(c[(d+416|0)>>2]|0)+12984>>3],469,e);pe[c[(e+8|0)>>2]&3](138,243,-1.0,470,e);pe[c[(e+8|0)>>2]&3](138,244,1.0,471,e);pe[c[(e+8|0)>>2]&3](139,230,-1.0,472,e);pe[c[(e+8|0)>>2]&3](139,237,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+680>>3],473,e);pe[c[(e+8|0)>>2]&3](139,242,-1.0,474,e);pe[c[(e+8|0)>>2]&3](139,245,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+688>>3],475,e);pe[c[(e+8|0)>>2]&3](140,236,-+h[(c[(d+416|0)>>2]|0)+13e3>>3],476,e);pe[c[(e+8|0)>>2]&3](140,240,+h[(c[(d+416|0)>>2]|0)+12992>>3],477,e);pe[c[(e+8|0)>>2]&3](140,241,-1.0,478,e);pe[c[(e+8|0)>>2]&3](140,242,1.0,479,e);pe[c[(e+8|0)>>2]&3](141,227,-1.0,480,e);pe[c[(e+8|0)>>2]&3](141,240,-1.0,481,e);pe[c[(e+8|0)>>2]&3](141,245,-1.0,482,e);pe[c[(e+8|0)>>2]&3](142,236,-6.123233995736766e-17,483,e);pe[c[(e+8|0)>>2]&3](142,239,1.0,484,e);pe[c[(e+8|0)>>2]&3](142,240,1.0,485,e);pe[c[(e+8|0)>>2]&3](143,236,-1.0,486,e);pe[c[(e+8|0)>>2]&3](143,238,1.0,487,e);pe[c[(e+8|0)>>2]&3](143,240,-6.123233995736766e-17,488,e);pe[c[(e+8|0)>>2]&3](144,233,-1.0,489,e);pe[c[(e+8|0)>>2]&3](144,237,1.0,490,e);pe[c[(e+8|0)>>2]&3](144,246,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+800>>3],491,e);pe[c[(e+8|0)>>2]&3](145,226,-1.0,492,e);pe[c[(e+8|0)>>2]&3](145,236,-1.0,493,e);pe[c[(e+8|0)>>2]&3](145,237,-1.0,494,e);pe[c[(e+8|0)>>2]&3](146,232,-1.0,495,e);pe[c[(e+8|0)>>2]&3](146,235,1.0,496,e);pe[c[(e+8|0)>>2]&3](146,246,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7712>>3],497,e);pe[c[(e+8|0)>>2]&3](147,223,-1.0,498,e);pe[c[(e+8|0)>>2]&3](147,234,-1.0,499,e);pe[c[(e+8|0)>>2]&3](147,235,-1.0,500,e);n=c[(e+8|0)>>2]|0;E=c[c[(d+4|0)>>2]>>2]|0;b=c[E+8>>2]|0;L=+h[b+7688>>3]*+h[(c[(d+416|0)>>2]|0)+23944>>3];M=+h[b+15648>>3];do{if(L!=0.0){N=M/L}else{if(M==0.0){N=M;break}N=M/+$Lb(c[d+536>>2]|0,L,11696,11496,+h[E>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[n&3](148,230,N,501,e);n=c[(e+8|0)>>2]|0;E=c[c[(d+4|0)>>2]>>2]|0;b=c[E+8>>2]|0;N=+h[b+720>>3];L=+h[(c[(d+416|0)>>2]|0)+23944>>3];M=+h[b+15648>>3];do{if(L!=0.0){O=M/L}else{if(M==0.0){O=M;break}O=M/+$Lb(c[d+536>>2]|0,L,9232,11496,+h[E>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[n&3](148,231,-(N*O),502,e);pe[c[(e+8|0)>>2]&3](148,233,1.0,503,e);n=c[(e+8|0)>>2]|0;E=c[c[(d+4|0)>>2]>>2]|0;b=c[E+8>>2]|0;O=+h[b+720>>3];N=+h[(c[(d+416|0)>>2]|0)+23944>>3];L=+h[b+15656>>3];do{if(N!=0.0){P=L/N}else{if(L==0.0){P=L;break}P=L/+$Lb(c[d+536>>2]|0,N,9232,11496,+h[E>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[n&3](148,253,-(O*P),504,e);n=c[(e+8|0)>>2]|0;E=c[c[(d+4|0)>>2]>>2]|0;b=c[E+8>>2]|0;P=+h[b+7688>>3];O=+h[(c[(d+416|0)>>2]|0)+23944>>3];N=+h[b+15648>>3];do{if(O!=0.0){Q=N/O}else{if(N==0.0){Q=N;break}Q=N/+$Lb(c[d+536>>2]|0,O,9232,11496,+h[E>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[n&3](149,231,-(P*Q),505,e);pe[c[(e+8|0)>>2]&3](149,232,1.0,506,e);n=c[(e+8|0)>>2]|0;E=c[c[(d+4|0)>>2]>>2]|0;b=c[E+8>>2]|0;Q=+h[b+7688>>3];P=+h[(c[(d+416|0)>>2]|0)+23944>>3];O=+h[b+15656>>3];do{if(P!=0.0){R=O/P}else{if(O==0.0){R=O;break}R=O/+$Lb(c[d+536>>2]|0,P,9232,11496,+h[E>>3],(a[d+319|0]|0)!=0|0)}}while(0);pe[n&3](149,253,-(Q*R),507,e);pe[c[(e+8|0)>>2]&3](150,224,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15648>>3],508,e);pe[c[(e+8|0)>>2]&3](150,228,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+720>>3],509,e);pe[c[(e+8|0)>>2]&3](150,231,1.0,510,e);pe[c[(e+8|0)>>2]&3](150,254,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+800>>3],511,e);pe[c[(e+8|0)>>2]&3](151,228,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7688>>3],512,e);pe[c[(e+8|0)>>2]&3](151,230,1.0,513,e);pe[c[(e+8|0)>>2]&3](151,254,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7712>>3],514,e);pe[c[(e+8|0)>>2]&3](152,199,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7744>>3]*+h[(c[(d+416|0)>>2]|0)+24160>>3]),515,e);pe[c[(e+8|0)>>2]&3](152,214,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7752>>3]*+h[(c[(d+416|0)>>2]|0)+24160>>3]),516,e);n=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](152,222,-(+h[n+14840>>3]*+h[n+24160>>3]),517,e);pe[c[(e+8|0)>>2]&3](152,229,-1.0,518,e);n=c[(d+416|0)>>2]|0;pe[c[(e+8|0)>>2]&3](152,255,+h[n+14832>>3]*+h[n+24160>>3],519,e);pe[c[(e+8|0)>>2]&3](153,221,-+h[(c[(d+416|0)>>2]|0)+14848>>3],520,e);pe[c[(e+8|0)>>2]&3](153,222,-.006,521,e);pe[c[(e+8|0)>>2]&3](153,228,-1.0,522,e);pe[c[(e+8|0)>>2]&3](153,229,+h[(c[(d+416|0)>>2]|0)+14840>>3],523,e);pe[c[(e+8|0)>>2]&3](154,221,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+792>>3],524,e);pe[c[(e+8|0)>>2]&3](154,225,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+712>>3],525,e);pe[c[(e+8|0)>>2]&3](154,227,1.0,526,e);pe[c[(e+8|0)>>2]&3](154,229,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15656>>3],527,e);pe[c[(e+8|0)>>2]&3](155,221,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+800>>3],528,e);pe[c[(e+8|0)>>2]&3](155,225,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+720>>3],529,e);pe[c[(e+8|0)>>2]&3](155,226,1.0,530,e);pe[c[(e+8|0)>>2]&3](155,229,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+15648>>3],531,e);pe[c[(e+8|0)>>2]&3](156,199,-(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+7696>>3]*+h[(c[(d+416|0)>>2]|0)+24160>>3]),532,e)}



function qJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=TIb(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=TIb(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function rJb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=fIb(c)|0;k=j;i=b;return k|0}function sJb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){if((a[e]|0)==0){h=a[e+1|0]|0}else{h=-1}if((h|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((h|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==103){f=62;g=f;i=b;return g|0}else if((j|0)==108){f=60;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function tJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=TIb(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 5:{b=b+2|0;break};case 7:{b=b+4|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=TIb(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 6:{b=b+3|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function uJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=TIb(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function vJb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g+1|0]|0;o=((l&3)<<4|(a[g]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function wJb(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function xJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=TIb(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[224936+((d[224680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 19:{k=zJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=TIb(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 6:{n=32;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 18:{n=38;break b;break};case 29:{if((c[224936+((d[226216+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 5:{n=29;break b;break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function yJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=TIb(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[224936+((d[224680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=TIb(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=35;break b;break};case 29:{if((c[224936+((d[226216+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 18:{n=38;break b;break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function zJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=AJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=TIb(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=TIb(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function AJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=TIb(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=TIb(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function BJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=TIb(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 29:{if((c[224936+((d[224680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 15:{k=EJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=TIb(a[g]|0,a[b+1|0]|0)|0}if((n|0)==20){k=DJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=CJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=FJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=TIb(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 6:{o=42;break b;break};case 11:{o=90;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=TIb(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 29:{if((c[224936+((d[224680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};case 7:{o=65;break b;break};case 24:case 22:{break};case 6:{o=62;break b;break};case 5:{o=59;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 29:{if((c[224936+((d[226216+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 17:{break b;break};case 5:{o=39;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{o=45;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=TIb(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 10:case 9:case 21:{break};case 11:{o=90;break c;break};case 5:{o=78;break d;break};case 17:{break c;break};case 6:{o=81;break d;break};case 29:{o=75;break d;break};case 24:case 22:{break d;break};case 7:{o=84;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[224936+((d[224680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=GJb(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function CJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=TIb(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 8:case 1:case 0:{l=20;break b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function DJb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[227256+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function EJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=TIb(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[224936+((d[224680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=TIb(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 29:{if((c[224936+((d[226216+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{p=28;break b;break};case 7:{p=34;break b;break};case 6:{p=31;break b;break};case 15:{p=62;break b;break};case 10:case 9:case 21:{p=37;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((HJb(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=TIb(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 8:case 1:case 0:{p=54;break c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((HJb(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function FJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=TIb(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[224936+((d[224680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=TIb(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 6:{n=31;break b;break};case 29:{if((c[224936+((d[226216+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 11:{n=48;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{n=37;break b;break};case 5:{n=28;break b;break};case 23:{b=b+2|0;continue b;break};case 7:{n=34;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=TIb(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function GJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=TIb(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 14:{break};case 6:{l=13;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=TIb(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 29:{if((c[224936+((d[226216+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 7:{l=16;break a;break};case 5:{l=10;break a;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){p=d[k+76+(d[o+1|0]|0)|0]|0}else{p=TIb(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(p|0){case 5:{l=30;break a;break};case 7:{l=36;break a;break};case 24:case 22:{break};case 29:{if((c[224936+((d[224680+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 6:{l=33;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=TIb(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[o+1|0]|0)|0]|0}else{s=TIb(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 2:{l=79;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 3:{t=xJb(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 8:case 1:case 0:{l=74;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[o+1|0]|0)|0]|0}else{u=TIb(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 11:{l=106;break a;break};case 17:{l=107;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[o+1|0]|0)|0]|0}else{v=TIb(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 7:{l=103;break a;break};case 10:case 9:case 21:{break};case 24:case 22:{break d;break};case 11:{l=106;break a;break};case 6:{l=100;break a;break};case 29:{l=94;break d;break};case 17:{l=107;break a;break};case 5:{l=97;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[224936+((d[224680+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function HJb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function IJb(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=TIb(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=TIb(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function JJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=TIb(a[g]|0,a[b+1|0]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=TIb(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 30:{n=16;break a;break};case 10:case 9:case 21:{break a;break};case 24:case 22:{break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=TIb(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=CJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function KJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=TIb(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[224936+((d[224680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=TIb(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 5:{n=28;break b;break};case 29:{if((c[224936+((d[226216+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=34;break b;break};case 6:{n=31;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function LJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 23:case 27:case 26:case 25:{m=19;b=b+1|0;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((ue[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;m=18;break a}g=b;if((ue[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 12:{k=tKb(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 30:{k=jKb(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 19:{k=vKb(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 10:case 21:{n=15;break};case 9:{if((b+1|0)!=(e|0)){n=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((ue[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;m=18;break a}g=b;if((ue[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 16:{k=uKb(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};case 15:{k=pKb(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 13:{k=tKb(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 24:case 22:{m=18;b=b+1|0;break};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((ue[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;m=18;break a}g=b;if((ue[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((n|0)==15){while(1){n=0;b=b+1|0;o=b;if((b|0)==(e|0)){n=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){n=15;continue}else if((g|0)!=9){n=18;break}if((b+1|0)!=(e|0)){n=15}else{n=18;break}}if((n|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){n=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=86;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 34:{n=110;break b;break};case 15:{n=116;break b;break};case 7:{if((e-b|0)<4){n=82;break b}p=b;if((ue[c[j+340>>2]&63](j,b)|0)==0){n=84;break b}b=p+4|0;continue b;break};case 23:{b=b+1|0;o=m;if((o|0)==41){m=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){n=89;break b}m=41;switch(d[j+76+(d[b]|0)|0]|0){case 29:{n=91;break b;break};case 5:{if((e-b|0)<2){n=94;break b}q=b;if((ue[c[j+332>>2]&63](j,b)|0)==0){n=96;break b}b=q+2|0;continue b;break};case 7:{if((e-b|0)<4){n=104;break b}r=b;if((ue[c[j+340>>2]&63](j,b)|0)==0){n=106;break b}b=r+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){n=99;break b}s=b;if((ue[c[j+336>>2]&63](j,b)|0)==0){n=101;break b}b=s+3|0;continue b;break};default:{m=19;continue b}}break};case 5:{if((e-b|0)<2){n=72;break b}t=b;if((ue[c[j+332>>2]&63](j,b)|0)==0){n=74;break b}b=t+2|0;continue b;break};case 29:{n=69;break b;break};case 6:{if((e-b|0)<3){n=77;break b}u=b;if((ue[c[j+336>>2]&63](j,b)|0)==0){n=79;break b}b=u+3|0;continue b;break};case 33:{n=113;break b;break};default:{n=119;break b}}}if((n|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==72){k=-2;l=k;i=h;return l|0}else if((n|0)==74){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((n|0)==77){k=-2;l=k;i=h;return l|0}else if((n|0)==79){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((n|0)==82){k=-2;l=k;i=h;return l|0}else if((n|0)==84){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((n|0)==86){c[f>>2]=b;k=m;l=k;i=h;return l|0}else if((n|0)==89){k=-1;l=k;i=h;return l|0}else if((n|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==94){k=-2;l=k;i=h;return l|0}else if((n|0)==96){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((n|0)==99){k=-2;l=k;i=h;return l|0}else if((n|0)==101){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((n|0)==104){k=-2;l=k;i=h;return l|0}else if((n|0)==106){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((n|0)==110){r=b;if((m|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=32;l=k;i=h;return l|0}}else if((n|0)==113){r=b;if((m|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=31;l=k;i=h;return l|0}}else if((n|0)==116){r=b;if((m|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=30;l=k;i=h;return l|0}}else if((n|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==120){k=0-m|0;l=k;i=h;return l|0}return 0}function MJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 2:{k=mKb(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 3:{k=iKb(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((ue[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((ue[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((ue[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 5:{if((e-b|0)<2){n=41;break b}if((ue[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((ue[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){n=49;break b}if((ue[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function NJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((ue[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((ue[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((ue[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=39;break b}if((ue[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 6:{if((e-b|0)<3){n=43;break b}if((ue[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){n=47;break b}if((ue[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function OJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){k=5;break a}l=b;if((ue[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 4:{m=b+1|0;b=m;if((m|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}m=b+1|0;b=m;if((m|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}n=b;if((ue[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=n+4|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}o=b;if((ue[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=o+3|0;continue a;break};case 2:{m=b+1|0;b=m;if((m|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}m=b+1|0;b=m;if((m|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=l;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function PJb(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 10:{m=13;break a;break};case 2:{m=12;break a;break};case 3:{m=9;break a;break};case 5:{a=a+2|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 9:{m=16;break a;break};case 7:{a=a+4|0;continue a;break};case 21:{m=23;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=iKb(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function QJb(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 5:{a=a+2|0;continue a;break};case 10:{m=15;break a;break};case 6:{a=a+3|0;continue a;break};case 30:{m=12;break a;break};case 7:{a=a+4|0;continue a;break};case 3:{m=9;break a;break};case 9:{m=18;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=iKb(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=jKb(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function RJb(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 5:{break};case 6:{h=5;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){h=12;break a}else{continue a}break};case 7:{j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){h=4;break a}else{h=5}break};default:{h=13;break a}}if((h|0)==5){h=0;e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=6;break}}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){h=8;break}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=10;break}}if((h|0)==4){k=0;l=k;i=f;return l|0}else if((h|0)==6){k=0;l=k;i=f;return l|0}else if((h|0)==8){k=0;l=k;i=f;return l|0}else if((h|0)==10){k=0;l=k;i=f;return l|0}else if((h|0)==12){k=0;l=k;i=f;return l|0}else if((h|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function SJb(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function TJb(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 5:{a=a+2|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};default:{break a}}}i=c;return a-b|0}function UJb(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function VJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function WJb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=fIb(c)|0;g=f;i=b;return g|0}function XJb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==103){f=62;g=f;i=b;return g|0}else if((d|0)==108){f=60;g=f;i=b;return g|0}else{break}}else if((c|0)==4){d=a[e]|0;if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function YJb(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 7:{a=a+4|0;break};case 5:{a=a+2|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};case 6:{a=a+3|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function ZJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 21:{if((a[b]|0)==9){k=5;break a}break};case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function _Jb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function $Jb(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==6){p=j;j=p+2|0;b[p>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else if((o|0)==5){p=j;j=p+2|0;b[p>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}o=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;o=o-65536|0;b[j>>1]=o>>>10|55296;b[j+2>>1]=o&1023|56320;j=j+4|0;m=m+4|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function aKb(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[224936+(((d[226216+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function bKb(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[224936+(((d[226216+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function cKb(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function dKb(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[224936+(((d[224680+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function eKb(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[224936+(((d[224680+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function fKb(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function gKb(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function hKb(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function iKb(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((ue[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((ue[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 19:{j=kKb(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((ue[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}m=a;if((ue[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((ue[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 18:{l=42;break b;break};case 29:{l=25;break b;break};case 6:{if((b-a|0)<3){l=33;break b}o=a;if((ue[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=o+3|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function jKb(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((ue[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((ue[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((ue[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=33;break b}m=a;if((ue[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=m+3|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((ue[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 29:{l=25;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 18:{l=42;break b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((ue[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function kKb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=lKb(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function lKb(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function mKb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 17:{k=qKb(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((ue[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 15:{k=pKb(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((ue[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==20){k=oKb(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==27){k=nKb(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{b=b+1|0;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((ue[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){m=68;break b}n=b;if((ue[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=n+4|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){m=63;break b}o=b;if((ue[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=o+3|0;continue b;break};case 29:{m=55;break b;break};case 5:{if((e-b|0)<2){m=58;break b}p=b;if((ue[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=p+2|0;continue b;break};default:{m=72;break b}}break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 5:{if((e-b|0)<2){m=36;break b}q=b;if((ue[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=q+2|0;continue b;break};case 29:{m=33;break b;break};case 7:{if((e-b|0)<4){m=46;break b}r=b;if((ue[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=r+4|0;continue b;break};case 11:{m=97;break b;break};case 17:{break b;break};case 6:{if((e-b|0)<3){m=41;break b}s=b;if((ue[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=s+3|0;continue b;break};case 10:case 9:case 21:{m=73;break b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 5:{m=78;break d;break};case 11:{m=97;break c;break};case 29:{m=76;break d;break};case 10:case 9:case 21:{break};case 6:{m=83;break d;break};case 17:{break c;break};case 24:case 22:{m=77;break d;break};case 7:{m=88;break d;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((ue[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((ue[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((ue[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=rKb(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function nKb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){m=8;break b}n=b;if((ue[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=n+2|0;continue b;break};case 7:{if((e-b|0)<4){m=18;break b}o=b;if((ue[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=o+4|0;continue b;break};case 6:{if((e-b|0)<3){m=13;break b}p=b;if((ue[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=p+3|0;continue b;break};case 8:case 1:case 0:{m=22;break b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function oKb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[227632+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function pKb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((ue[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((ue[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((ue[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 15:{o=68;break b;break};case 10:case 9:case 21:{o=41;break b;break};case 7:{if((e-b|0)<4){o=37;break b}p=b;if((ue[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=p+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 5:{if((e-b|0)<2){o=27;break b}q=b;if((ue[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=q+2|0;continue b;break};case 6:{if((e-b|0)<3){o=32;break b}r=b;if((ue[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=r+3|0;continue b;break};case 29:{o=24;break b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((sKb(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 5:{if((e-b|0)<2){o=47;break c}s=b;if((ue[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=s+2|0;continue c;break};case 7:{if((e-b|0)<4){o=57;break c}t=b;if((ue[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=t+4|0;continue c;break};case 8:case 1:case 0:{o=61;break c;break};case 6:{if((e-b|0)<3){o=52;break c}u=b;if((ue[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=u+3|0;continue c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((sKb(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function qKb(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((ue[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((ue[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((ue[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 23:{a=a+1|0;continue b;break};case 10:case 9:case 21:{l=41;break b;break};case 7:{if((b-a|0)<4){l=37;break b}m=a;if((ue[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=m+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 5:{if((b-a|0)<2){l=27;break b}n=a;if((ue[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=n+2|0;continue b;break};case 11:{l=49;break b;break};case 6:{if((b-a|0)<3){l=32;break b}o=a;if((ue[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=o+3|0;continue b;break};case 29:{l=24;break b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}m=d[h+76+(d[a]|0)|0]|0;if((m|0)==11){l=44;break}else if(!((m|0)==10|(m|0)==9|(m|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function rKb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}b=(ue[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=36;break a}c[j>>2]=m+3;continue a;break};case 29:{l=26;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}b=(ue[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!b){l=31;break a}c[j>>2]=n+2;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}b=(ue[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!b){l=41;break a}c[j>>2]=o+4;continue a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};default:{l=43;break a}}break};case 14:{break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}b=(ue[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!b){l=19;break a}c[j>>2]=p+4;continue a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}q=b;if(!((q|0)==9|(q|0)==10|(q|0)==21)){l=48;break a}}break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}q=(ue[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!q){l=9;break a}c[j>>2]=r+2;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}q=(ue[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!q){l=14;break a}c[j>>2]=s+3;continue a;break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 29:{l=4;break a;break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}q=t;if(!((q|0)==9|(q|0)==10|(q|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}q=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((q|0)==(t|0)){break}switch(q|0){case 2:{l=80;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}q=(ue[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(q){l=73;break a}c[j>>2]=u+4;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}q=(ue[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(q){l=63;break a}c[j>>2]=v+2;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}q=(ue[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(q){l=68;break a}c[j>>2]=w+3;continue c;break};case 3:{x=iKb(k,(c[j>>2]|0)+1|0,e,j)|0;if((x|0)<=0){l=77;break a}else{continue c}break};case 8:case 1:case 0:{l=75;break a;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 11:{l=106;break a;break};case 6:{l=96;break d;break};case 7:{l=101;break d;break};case 5:{l=91;break d;break};case 29:{l=89;break a;break};case 10:case 9:case 21:{break};case 24:case 22:{l=90;break d;break};case 17:{l=107;break a;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}q=(ue[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!q){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}q=(ue[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!q){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}q=(ue[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!q){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((x|0)==0){c[f>>2]=c[j>>2]}B=x;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function sKb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function tKb(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 6:{if((e-b|0)<3){k=10;break a}l=b;if((ue[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=l+3|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 7:{if((e-b|0)<4){k=15;break a}m=b;if((ue[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=m+4|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}n=b;if((ue[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=n+2|0;continue a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function uKb(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{break};case 30:{l=10;break a;break};case 10:case 9:case 21:{break a;break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==27){j=nKb(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function vKb(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((ue[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((ue[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((ue[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=32;break b}m=a;if((ue[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=m+3|0;continue b;break};case 29:{l=24;break b;break};case 7:{if((b-a|0)<4){l=37;break b}n=a;if((ue[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=n+4|0;continue b;break};case 5:{if((b-a|0)<2){l=27;break b}o=a;if((ue[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=o+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function wKb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function xKb(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function yKb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function zKb(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 60:case 0:{break};case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==15360){if((a[b+73|0]|0)==4){p=16}else{if((a[b+73|0]|0)==3){p=16}}if((p|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=De[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==61371){if((e|0)==1){o=a[b+73|0]|0;if((o|0)==0|(o|0)==4|(o|0)==5|(o|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=De[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=De[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=De[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function AKb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((CKb(BKb(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((CKb(BKb(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=BKb(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((CKb(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=BKb(k,a,b)|0;n=h;}while((CKb(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=BKb(k,a,b)|0;while(1){if((CKb(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=BKb(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=BKb(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function BKb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;ae[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function CKb(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function DKb(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function EKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 12:{c[h>>2]=14;j=1;break};case 14:{j=0;break};case 16:{if((De[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,231376)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};case 13:{c[h>>2]=14;j=56;break};case 11:{c[h>>2]=14;j=55;break};case 29:{c[h>>2]=16;j=2;break};case 15:{c[h>>2]=14;j=0;break};default:{k=10}}}while(0);if((k|0)==10){j=IKb(h,a)|0}i=g;return j|0}function FKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 34:{if((c[h+12>>2]|0)==0){j=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;k=0;break};case 26:{j=9;break};case-4:{if((c[h+12>>2]|0)!=0){j=9;break a}k=0;break};case 15:{k=0;break};case 33:{c[h>>2]=17;k=0;break};default:{k=HKb(h,a,d,e,f)|0}}}while(0);if((j|0)==9){k=IKb(h,a)|0}i=g;return k|0}function GKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=0;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((De[c[e+28>>2]&63](e,b,d,231360)|0)!=0){c[h>>2]=18;j=0;k=j;i=g;return k|0}if((De[c[e+28>>2]&63](e,b,d,231368)|0)==0){break}c[h>>2]=19;j=0;k=j;i=g;return k|0}}while(0);j=IKb(h,a)|0;k=j;i=g;return k|0}function HKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 11:{j=55;k=j;i=g;return k|0};case 16:{if((De[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,231136)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((De[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,231144)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((De[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,231152)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((De[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,231160)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};case 13:{j=56;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};default:{}}}while(0);j=IKb(h,a)|0;k=j;i=g;return k|0}function IKb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function JKb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function KKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==22){c[e>>2]=25;g=11}else if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=26;g=9}else{g=IKb(e,a)|0}i=f;return g|0}function LKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else{g=IKb(e,a)|0}i=f;return g|0}function MKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else if((b|0)==15){g=39}else{g=IKb(e,a)|0}i=f;return g|0}function NKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==18){c[e>>2]=29;g=18}else{g=IKb(e,a)|0}i=f;return g|0}function OKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else{g=IKb(e,a)|0}i=f;return g|0}function PKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==29){c[e>>2]=16;g=2}else if((b|0)==11){g=55}else if((b|0)==13){g=56}else{g=IKb(e,a)|0}i=f;return g|0}function QKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=17;l=k;i=g;return l|0}do{if((j|0)==3){if((De[c[e+28>>2]&63](e,b,d,231176)|0)!=0){c[h>>2]=31;k=17;l=k;i=g;return l|0}if((De[c[e+28>>2]&63](e,b,d,231184)|0)==0){break}c[h>>2]=32;k=17;l=k;i=g;return l|0}}while(0);k=IKb(h,a)|0;l=k;i=g;return l|0}function RKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=IKb(e,a)|0}i=f;return g|0}function SKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=34;g=21}else{g=IKb(e,a)|0}i=f;return g|0}function TKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==15){g=17}else{g=IKb(e,a)|0}i=f;return g|0}function UKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=IKb(e,a)|0;h=g;i=f;return h|0}return 0}function VKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((De[c[e+28>>2]&63](e,b,d,231192)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((De[c[e+28>>2]&63](e,b,d,231200)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}else if((f|0)==15){j=39;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}}while(0);j=IKb(h,a)|0;k=j;i=g;return k|0}function WKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 32:{c[h>>2]=40;j=54;break};case 15:{j=39;break};case 30:{c[h>>2]=40;j=53;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};case 41:case 18:{c[h>>2]=40;j=51;break};case 20:{if((De[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,231208)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};case 31:{c[h>>2]=40;j=52;break};default:{k=10}}}while(0);if((k|0)==10){j=IKb(h,a)|0}i=g;return j|0}function XKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==15){g=39}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else{g=IKb(e,a)|0}i=f;return g|0}function YKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 41:case 18:{c[e>>2]=40;g=51;break};case 32:{c[e>>2]=40;g=54;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 31:{c[e>>2]=40;g=52;break};case 15:{g=39;break};case 30:{c[e>>2]=40;g=53;break};default:{g=IKb(e,a)|0}}i=f;return g|0}function ZKb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 15:{g=39;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};default:{g=IKb(e,a)|0;h=g;i=f;return h|0}}return 0}function _Kb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else if((b|0)==15){g=39}else{g=IKb(e,a)|0}i=f;return g|0}function $Kb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==15){g=39}else{g=IKb(e,a)|0}i=f;return g|0}function aLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else if((b|0)==15){g=33}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else{g=IKb(e,a)|0}i=f;return g|0}function bLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){j=0;while(1){k=c[e+28>>2]|0;l=e;m=b;n=d;if((j|0)>=8){break}if((De[k&63](l,m,n,c[231216+(j<<2)>>2]|0)|0)!=0){o=6;break}j=j+1|0}if((o|0)==6){c[h>>2]=44;p=23+j|0;q=p;i=g;return q|0}if((De[k&63](l,m,n,231160)|0)==0){break}c[h>>2]=45;p=33;q=p;i=g;return q|0}else if((f|0)==23){c[h>>2]=46;p=33;q=p;i=g;return q|0}else if((f|0)==15){p=33;q=p;i=g;return q|0}}while(0);p=IKb(h,a)|0;q=p;i=g;return q|0}function cLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==20){if((De[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,231320)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((De[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,231328)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((De[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,231344)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}}while(0);j=IKb(h,a)|0;k=j;i=g;return k|0}function dLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==23){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=IKb(e,a)|0}i=f;return g|0}function eLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else{g=IKb(e,a)|0}i=f;return g|0}function fLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==21){c[e>>2]=46;g=33}else{g=IKb(e,a)|0}i=f;return g|0}function gLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=50;g=32}else if((b|0)==15){g=33}else{g=IKb(e,a)|0}i=f;return g|0}function hLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=IKb(e,a)|0}i=f;return g|0}function iLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=27;g=38}else if((b|0)==15){g=33}else{g=IKb(e,a)|0}i=f;return g|0}function jLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=51;g=10}else{g=IKb(e,a)|0}i=f;return g|0}function kLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((De[c[e+28>>2]&63](e,b,d,231176)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((De[c[e+28>>2]&63](e,b,d,231184)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=IKb(h,a)|0;k=j;i=g;return k|0}function lLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=54;g=13}else if((b|0)==15){g=11}else{g=IKb(e,a)|0}i=f;return g|0}function mLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=52;g=14}else{g=IKb(e,a)|0}i=f;return g|0}function nLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((De[c[e+28>>2]&63](e,b,d,231352)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}}while(0);j=IKb(h,a)|0;k=j;i=g;return k|0}function oLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else if((b|0)==15){g=11}else{g=IKb(e,a)|0}i=f;return g|0}function pLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((De[c[e+28>>2]&63](e,b,d,231176)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((De[c[e+28>>2]&63](e,b,d,231184)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=IKb(h,a)|0;k=j;i=g;return k|0}function qLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=58;g=13}else{g=IKb(e,a)|0}i=f;return g|0}function rLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=56;g=14}else{g=IKb(e,a)|0}i=f;return g|0}function sLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else if((b|0)==15){g=11;h=g;i=f;return h|0}else{g=IKb(e,a)|0;h=g;i=f;return h|0}return 0}function tLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0;h=g;i=f;return h|0}else if((b|0)==25){c[e>>2]=36;b=e+12|0;c[b>>2]=(c[b>>2]|0)+1;g=0;h=g;i=f;return h|0}else{g=IKb(e,a)|0;h=g;i=f;return h|0}return 0}function uLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==25){c[e>>2]=36;g=58}else{g=IKb(e,a)|0}i=f;return g|0}function vLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 14:{j=0;break};case 11:{j=55;break};case 15:{j=0;break};case 29:{c[h>>2]=16;j=2;break};case 16:{if((De[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,231376)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};case 13:{j=56;break};default:{k=9}}}while(0);if((k|0)==9){j=IKb(h,a)|0}i=g;return j|0}function wLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else if((b|0)==15){g=3}else{g=IKb(e,a)|0}i=f;return g|0}function xLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==18){if((De[c[e+28>>2]&63](e,b,d,231176)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((De[c[e+28>>2]&63](e,b,d,231184)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}}while(0);j=IKb(h,a)|0;k=j;i=g;return k|0}function yLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=62;g=5}else{g=IKb(e,a)|0}i=f;return g|0}function zLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=60;g=6}else if((b|0)==15){g=3}else{g=IKb(e,a)|0}i=f;return g|0}function ALb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==17){c[e>>2]=30;g=8}else{g=IKb(e,a)|0}i=f;return g|0}function BLb(){i=i;return}function CLb(){i=i;return}function DLb(){var a=0;a=i;Ua(231384,0)|0;i=a;return}function ELb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;c[a+8>>2]=b;c[a>>2]=d;b=a+4|0;c[b>>2]=oMb(d)|0;if((d|0)>0){g=0}else{i=f;return}do{a=c[e>>2]|0;h=c[a>>2]|0;c[e>>2]=a+4;c[(c[b>>2]|0)+(g<<2)>>2]=h;g=g+1|0;}while((g|0)<(d|0));i=f;return}function FLb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;pc(231392,29,1,e|0)|0;sd(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;pc(231424,54,1,g|0)|0;sd(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;pc(231480,47,1,a|0)|0;sd(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;ud(k|0,231528,d|0)|0;sd(k|0)|0;f=0;i=b;return f|0}function GLb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=c[a>>2]|0;h=c[b>>2]|0;if((g|0)!=(h|0)){j=c[r>>2]|0;c[f>>2]=g;c[f+4>>2]=h;ud(j|0,231616,f|0)|0;k=0;i=d;return k|0}if((g|0)<=0){k=1;i=d;return k|0}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;while(1){l=c[f+(b<<2)>>2]|0;m=c[a+(b<<2)>>2]|0;j=b+1|0;if((l|0)!=(m|0)){break}if((j|0)<(g|0)){b=j}else{k=1;n=8;break}}if((n|0)==8){i=d;return k|0}n=c[r>>2]|0;c[e>>2]=b;c[e+4>>2]=b;c[e+8>>2]=l;c[e+12>>2]=m;ud(n|0,231648,e|0)|0;k=0;i=d;return k|0}function HLb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function ILb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=oMb(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function JLb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=oMb(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function KLb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((FLb(a)|0)==0){ab(231696,231592,262,231720)}e=c[a>>2]|0;f=b;c[f>>2]=e;g=oMb(e)|0;c[b+4>>2]=g;if((g|0)==0){ab(231744,231592,266,231720)}b=c[f>>2]|0;if((b|0)<=0){i=d;return}f=c[a+4>>2]|0;a=0;do{c[g+(a<<2)>>2]=c[f+(a<<2)>>2];a=a+1|0;}while((a|0)<(b|0));i=d;return}function LLb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[69976]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=231768;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](0,f,231792,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function MLb(){var a=0,b=0,d=0;a=i;b=233560|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=233672|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=233784|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[233564>>2]=1;c[233568>>2]=1;i=a;return}function NLb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?233920:233936;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;ud(a|0,233896,e|0)|0;i=d;return}function OLb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=233784+(d<<2)|0;o=233672+(d<<2)|0;p=233984+(b<<2)|0;q=232264+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=233968;ec(233952,l|0)|0;s=233968}else{if((c[58386]|0)==(d|0)){if((c[o>>2]|0)>0){t=233968}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;ec(233952,m|0)|0;do{if((c[58386]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=233968;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;ec(233976,k|0)|0;c[n>>2]=b;c[58386]=d;if((c[o>>2]|0)>0){g=0;while(1){ec(234008,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==0){break a}else if(g<<24>>24==10){break}w=w+1|0}a[x]=0;rb(e|0)|0;r=0;e=e+(w+1)|0;f=1}rb(e|0)|0;sd(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function PLb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[233984+(a<<2)>>2]|0;c[j>>2]=c[232264+(b<<2)>>2];c[j+4>>2]=k;ec(234016,j|0)|0;QLb(e);if((g|0)==0){Id(((d|0)!=0?234056:234104)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=sd(m|0)|0;i=f;return}rb(234184)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];ec(234064,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=sd(m|0)|0;i=f;return}pc(234088,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=sd(m|0)|0;i=f;return}function QLb(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==62){pc(234144,4,1,e|0)|0}else if(b<<24>>24==38){pc(234128,5,1,e|0)|0}else if(b<<24>>24==60){pc(234136,4,1,e|0)|0}else if(b<<24>>24==0){break}else{Qd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function RLb(a){a=a|0;var b=0;b=233672+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function SLb(a){a=a|0;var b=0;b=(a|0)==0;c[58530]=b?1:19;c[58528]=b?7:464;i=i;return}function TLb(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;pc(234088,11,1,b|0)|0;sd(b|0)|0;i=a;return}function ULb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[233560+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;Xc(j|0,2048,e|0,h|0)|0;oe[c[58530]&31](1,a,b,j,0,d);i=g;return}function VLb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[233560+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;Xc(h|0,2048,d|0,g|0)|0;oe[c[58530]&31](1,a,b,h,0,0);i=f;return}function WLb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[58388]|0)==0){if((c[233560+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;Xc(k|0,2048,e|0,j|0)|0;oe[c[58530]&31](2,a,b,k,0,d);i=g;return}function XLb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[58388]|0)==0){if((c[233560+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;Xc(j|0,2048,d|0,h|0)|0;oe[c[58530]&31](2,a,b,j,0,0);i=f;return}function YLb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;Xc(b|0,2048,d|0,g|0)|0;oe[c[58530]&31](4,2,0,b,0,0);if((a|0)==0){h=kd(c[57846]|0)|0}else{h=a}cb(c[h+76>>2]|0,1)}function ZLb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;Xc(g|0,2048,b|0,f|0)|0;oe[c[58530]&31](5,2,0,g,0,0);if((a|0)==0){h=kd(c[57846]|0)|0}else{h=a}cb(c[h+76>>2]|0,1)}



function j2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[73490]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){Q1b(101,299288);l=101;i=d;return l|0}else{c[(Lc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[73502]|0)==0){R1b();m=c[f>>2]|0}else{m=k}k=288944+(m*48|0)|0;c[72226]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){o2b(k,c[b+12>>2]|0,j);o=p2b(j,h)|0;if((o|0)==(c[288952+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[288956+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=M1b(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[288976+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=288960+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[288976+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=288968+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[288968+(m*48|0)>>2]=1;r=1;break}else{c[288968+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];fc(j|0,299296,e|0)|0}else{o2b(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){k2b(107,299288,b);l=107;i=d;return l|0}else{c[(Lc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=288988+(m*48|0)|0;c[q>>2]=0;c[288980+(m*48|0)>>2]=0;e=288984+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=288972+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 78:case 110:{if((Ac(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){k2b(128,299288,b);l=128;i=d;return l|0}else{c[(Lc()|0)>>2]=128;l=128;i=d;return l|0}break};case 82:case 114:{break};case 83:case 115:{c[q>>2]=1;o=Kb()|0;c[n>>2]=o;if((o|0)!=0){c[288948+(m*48|0)>>2]=0;c[288956+(m*48|0)>>2]=-1;c[288952+(m*48|0)>>2]=-1;c[288964+(m*48|0)>>2]=1;l=0;i=d;return l|0}o=(c[b>>2]|0)==0;k=Lc()|0;s=c[k>>2]|0;if(o){k2b(s,299288,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 79:case 111:{if((Ac(j|0,0)|0)==0){break b}s=(c[b>>2]|0)==0;k=Lc()|0;o=c[k>>2]|0;if(s){k2b(o,299288,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};default:{break b}}}while(0);o=gc(j|0,c[74814]|0)|0;if((o|0)==0){break}Wc(o|0)|0}}while(0);q=aec((Eec(j|0)|0)+1|0)|0;c[288948+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){k2b(113,299312,b);l=113;i=d;return l|0}else{c[(Lc()|0)>>2]=113;l=113;i=d;return l|0}}Kec(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=gc(j|0,c[299256+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=gc(j|0,c[299216+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=gc(j|0,c[299256+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Lc()|0;o=c[g>>2]|0;if(h){Q1b(o,299288);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=288964+(m*48|0)|0;c[r>>2]=P1b(u)|0;u=p2b(j,288956+(m*48|0)|0)|0;c[288952+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){k2b(108,299288,b);l=108;i=d;return l|0}else{c[(Lc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){nb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Uc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){k2b(129,299288,b);l=129;i=d;return l|0}else{c[(Lc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function k2b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){Q1b(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[74818]|0)){j=d;k=g}else{h2b(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[74820]|0;c[(c[72226]|0)+4>>2]=f;o2b(k,j,f);Q1b(a,b);i=e;return}function l2b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;fc(j|0,299296,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=Eec(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?299328:299336;c[h+24>>2]=(b|0)==5?299344:299352;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=j2b(h)|0;i=e;return a|0}function m2b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=288944+(d*48|0)|0;c[72226]=e;if(d>>>0>99){if((c[a>>2]|0)==0){Q1b(101,299776);f=101;i=b;return f|0}else{c[(Lc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((l2b(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){Q1b(114,299784);f=114;i=b;return f|0}else{c[(Lc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[288968+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){Q1b(102,299784);f=102;i=b;return f|0}else{c[(Lc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function n2b(){var a=0,b=0;a=i;b=Y1b()|0;c[73452]=0;i=a;return b|0}function o2b(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function p2b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((jc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function q2b(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[73532]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[73512]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];fc(p|0,299792,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(Eec(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;de[c[73516]&511](32);}while((A|0)>0)}if((D|0)!=0){de[c[73516]&511]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{de[c[73516]&511](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Dc(A|0)|0)+1|0;c[m>>2]=t-(c[73532]|0);fc(A|0,299800,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;de[c[73516]&511](32);}while((z|0)>0)}if((x|0)!=0){de[c[73516]&511]((w|0)!=0?45:43)}z=c[73532]|0;do{if((z|0)<1){de[c[73516]&511](46);y=c[73516]|0;if((z|0)<0){G=y;J=z;while(1){de[G&511](48);I=J+1|0;K=c[73516]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}de[N&511](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}de[c[73516]&511](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[73516]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){de[P&511](a[J]|0);R=Q+ -1|0;S=c[73516]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}de[T&511](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;de[c[73516]&511](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){de[c[73516]&511](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;de[c[73516]&511](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){de[c[73516]&511](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;de[c[73516]&511](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;de[c[73516]&511](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;de[c[73516]&511](42);}while((_|0)>0);i=l;return 0}function r2b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[73532]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(fc(n|0,299808,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[73512]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;de[c[73516]&511](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;de[c[73516]&511](32);}while((b|0)>0)}do{if(q){if((c[73512]|0)==0){break}de[c[73516]&511](43)}else{de[c[73516]&511](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;de[c[73516]&511](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;de[c[73516]&511](48);}while((z|0)>0);i=j;return 0}function s2b(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==4){h=c[d>>2]|0}else if((f|0)==1){h=a[d]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{de[c[73516]&511](32);e=e+1|0;}while((e|0)<(d|0))}d=c[73516]|0;if((h|0)==0){de[d&511](70);i=g;return 0}else{de[d&511](84);i=g;return 0}return 0}function t2b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[73528]|0)!=0){g=u2b()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 28:case 27:{h=z2b(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 23:{h=r2b(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 7:{v2b(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 35:{A2b(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 34:{w2b(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 29:{s2b(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 25:case 24:case 26:{h=q2b(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 30:{x2b(b,d);h=0;i=e;return h|0};case 36:{A2b(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 10:{w2b(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 32:{v2b(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 31:{y2b(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;ud(h|0,299816,f|0)|0;F1b(c[73452]|0,1)}}return 0}function u2b(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[73528]|0;c[73528]=0;if((c[73490]|0)!=0){if((b|0)>0){d=c[73530]|0;e=c[73526]|0;if((d|0)<=(e|0)){f=b;while(1){de[c[73516]&511](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[73526]=f;h=0;i=a;return h|0}f=b-d+e|0;c[73526]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){de[c[73516]&511](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[73526]|0;f=j+b|0;if((f|0)>=0){if((c[73530]|0)<(j|0)){c[73530]=j}c[73526]=f;h=0;i=a;return h|0}if((c[c[73508]>>2]|0)==0){Q1b(110,299904);h=110;i=a;return h|0}else{c[(Lc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[73526]|0;if((c[73530]|0)<(f|0)){c[73530]=f}j=f+b|0;c[73526]=j;c[73534]=(c[73534]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[73508]>>2]|0)==0){Q1b(110,299904);h=110;i=a;return h|0}else{c[(Lc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[73526]|0;f=j+b|0;if((f|0)>=(c[(c[73510]|0)+16>>2]|0)){if((c[c[73508]>>2]|0)==0){Q1b(110,299920);h=110;i=a;return h|0}else{c[(Lc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[73530]|0;if((d|0)<=(j|0)){e=b;while(1){de[c[73516]&511](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[73534]=(c[73534]|0)+b;c[73526]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[73534]=(c[73534]|0)+f;c[73526]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){de[c[73516]&511](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function v2b(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==4){l=c[d>>2]|0}else if((f|0)==1){l=a[d]|0}else{l=b[d>>1]|0}d=f2b(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[73512]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{de[c[73516]&511](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{de[c[73516]&511](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[73512]|0)==0){break}de[c[73516]&511](43)}else{de[c[73516]&511](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){de[c[73516]&511](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function w2b(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==1){m=a[d]|0}else if((g|0)==4){m=c[d>>2]|0}else{m=b[d>>1]|0}d=f2b(m,k,l,h)|0;h=c[l>>2]|0;g=(c[73512]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{de[c[73516]&511](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{de[c[73516]&511](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[73512]|0)==0){break}de[c[73516]&511](43)}else{de[c[73516]&511](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){de[c[73516]&511](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){de[c[73516]&511](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{de[c[73516]&511](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function x2b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;de[c[73516]&511](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function y2b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;de[c[73516]&511](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;de[c[73516]&511](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function z2b(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=q2b(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=q2b(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[73532]|0;c[73532]=0;p=(e|0)==0?4:e+2|0;e=r2b(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{de[c[73516]&511](32);f=f+1|0;}while((f|0)<(p|0))}c[73532]=o;n=e;i=j;return n|0}function A2b(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{de[c[73516]&511](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;de[c[73516]&511](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;de[c[73516]&511](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){de[c[73516]&511](a[299880+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){de[c[73516]&511](a[299880+((d[p]|0)>>>4)|0]|0);de[c[73516]&511](a[299880+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function B2b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 13:{f=(c[73528]|0)-(c[a+4>>2]|0)|0;g=0-(c[73526]|0)|0;c[73528]=(f|0)<(g|0)?g:f;h=1;i=b;return h|0};case 11:{h=C2b(c[a+8>>2]|0)|0;i=b;return h|0};case 15:{c[73528]=(c[a+4>>2]|0)+ -1-(c[73526]|0);h=1;i=b;return h|0};case 12:{h=D2b(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return h|0};case 4:case 14:{c[73528]=(c[73528]|0)+(c[a+4>>2]|0);h=1;i=b;return h|0};case 5:{h=ye[c[73524]&7]()|0;i=b;return h|0};default:{h=c[r>>2]|0;c[d>>2]=e;ud(h|0,299848,d|0)|0;F1b(c[73452]|0,1)}}return 0}function C2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[73528]|0)!=0){e=u2b()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}de[c[73516]&511](e<<24>>24);n=b}else{de[c[73516]&511](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function D2b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[73528]|0)!=0){f=u2b()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;de[c[73516]&511](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function E2b(){var a=0,b=0;a=i;b=g2b(10)|0;c[73528]=0;c[73526]=0;c[73530]=0;i=a;return(b|0)==0|0}function F2b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[73502]|0)==0){R1b()}c[73466]=0;c[73472]=1;c[73480]=1;c[73490]=1;d=m2b(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[73508]=a;c[73526]=0;c[73528]=0;c[73530]=0;c[74780]=0;c[73532]=0;d=c[a+12>>2]|0;c[73452]=d;c[73504]=c[c[72226]>>2];if((U1b(d)|0)<0){if((c[a>>2]|0)==0){Q1b(100,299928);e=100;i=b;return e|0}else{c[(Lc()|0)>>2]=100;e=100;i=b;return e|0}}c[73516]=484;c[73518]=44;c[73520]=111;c[73506]=4;c[73522]=5;c[73524]=6;Z1b();c[73512]=0;d=c[72226]|0;c[73514]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((S1b(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Lc()|0;f=c[a>>2]|0;if(d){Q1b(f,299936);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function G2b(){var a=0,b=0;a=i;if((c[74780]|0)==0){b=g2b(10)|0}else{g2b(0)|0;sd(c[73504]|0)|0;b=0}c[73528]=0;c[73526]=0;c[73530]=0;i=a;return b|0}function H2b(){var a=0,b=0,d=0;a=i;if((c[74764]|0)==0){b=0}else{d=g2b(10)|0;c[74764]=0;b=d}c[73528]=0;c[73526]=0;c[73530]=0;i=a;return b|0}function I2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;c3b(300664,h,300720);c[74988]=302172;c[299960>>2]=302192;c[299956>>2]=0;V4b(299960|0,300664);c[300032>>2]=0;c[300036>>2]=-1;j=c[t>>2]|0;c[75192]=302040;Dac(300772|0);k=300776|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[75192]=301280;c[300800>>2]=j;Eac(g,300772|0);k=Hac(g,304832)|0;l=k;Fac(g);c[300804>>2]=l;c[300808>>2]=300728;a[300812|0]=(ge[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[75010]=302252;c[300044>>2]=302272;V4b(300044|0,300768);c[300116>>2]=0;c[300120>>2]=-1;l=c[r>>2]|0;c[75204]=302040;Dac(300820|0);k=300824|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[75204]=301280;c[300848>>2]=l;Eac(f,300820|0);k=Hac(f,304832)|0;g=k;Fac(f);c[300852>>2]=g;c[300856>>2]=300736;a[300860|0]=(ge[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[75032]=302252;c[300132>>2]=302272;V4b(300132|0,300816);c[300204>>2]=0;c[300208>>2]=-1;g=c[(c[(c[75032]|0)+ -12>>2]|0)+300152>>2]|0;c[75054]=302252;c[300220>>2]=302272;V4b(300220|0,g);c[300292>>2]=0;c[300296>>2]=-1;c[(c[(c[74988]|0)+ -12>>2]|0)+300024>>2]=300040;g=(c[(c[75032]|0)+ -12>>2]|0)+300132|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[75032]|0)+ -12>>2]|0)+300200>>2]=300040;Q2b(300864,h,300744|0);c[75076]=302212;c[300312>>2]=302232;c[300308>>2]=0;V4b(300312|0,300864);c[300384>>2]=0;c[300388>>2]=-1;c[75230]=302104;Dac(300924|0);h=300928|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[75230]=301024;c[300952>>2]=j;Eac(e,300924|0);j=Hac(e,304840)|0;h=j;Fac(e);c[300956>>2]=h;c[300960>>2]=300752;a[300964|0]=(ge[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[75098]=302292;c[300396>>2]=302312;V4b(300396|0,300920);c[300468>>2]=0;c[300472>>2]=-1;c[75242]=302104;Dac(300972|0);h=300976|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[75242]=301024;c[301e3>>2]=l;Eac(d,300972|0);l=Hac(d,304840)|0;h=l;Fac(d);c[301004>>2]=h;c[301008>>2]=300760;a[301012|0]=(ge[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[75120]=302292;c[300484>>2]=302312;V4b(300484|0,300968);c[300556>>2]=0;c[300560>>2]=-1;h=c[(c[(c[75120]|0)+ -12>>2]|0)+300504>>2]|0;c[75142]=302292;c[300572>>2]=302312;V4b(300572|0,h);c[300644>>2]=0;c[300648>>2]=-1;c[(c[(c[75076]|0)+ -12>>2]|0)+300376>>2]=300392;h=(c[(c[75120]|0)+ -12>>2]|0)+300484|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[75120]|0)+ -12>>2]|0)+300552>>2]=300392;i=b;return}function J2b(a){a=a|0;a=i;T5b(300040)|0;T5b(300216)|0;_5b(300392)|0;_5b(300568)|0;i=a;return}function K2b(a){a=a|0;var b=0;b=i;c[a>>2]=302104;Fac(a+4|0);i=b;return}function L2b(a){a=a|0;var b=0;b=i;c[a>>2]=302104;Fac(a+4|0);iec(a);i=b;return}function M2b(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;ge[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=Hac(d,304840)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(ge[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function N2b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=ve[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((pc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((sd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function O2b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=pc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((ue[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function P2b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((pc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Ce[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((pc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((pc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function Q2b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=302104;j=b+4|0;Dac(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=301136;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;Eac(g,j);j=Hac(g,304840)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=ge[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(ge[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){P9b(301232)}else{Fac(g);i=f;return}}function R2b(a){a=a|0;var b=0;b=i;c[a>>2]=302104;Fac(a+4|0);i=b;return}function S2b(a){a=a|0;var b=0;b=i;c[a>>2]=302104;Fac(a+4|0);iec(a);i=b;return}function T2b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=Hac(d,304840)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=ge[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(ge[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){P9b(301232)}else{i=e;return}}function U2b(a){a=a|0;var b=0,c=0;b=i;c=X2b(a,0)|0;i=b;return c|0}function V2b(a){a=a|0;var b=0,c=0;b=i;c=X2b(a,1)|0;i=b;return c|0}function W2b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Ce[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((od(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function X2b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=bd(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=Ce[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==3){y=14;break}else if((x|0)==2){n=-1;y=22;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=bd(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((od(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function Y2b(a){a=a|0;var b=0;b=i;c[a>>2]=302040;Fac(a+4|0);i=b;return}function Z2b(a){a=a|0;var b=0;b=i;c[a>>2]=302040;Fac(a+4|0);iec(a);i=b;return}function _2b(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;ge[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=Hac(d,304832)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(ge[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function $2b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=ve[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((pc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((sd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function a3b(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=pc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((ue[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function b3b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((pc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Ce[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((pc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((pc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function c3b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=302040;j=b+4|0;Dac(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=301392;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;Eac(g,j);j=Hac(g,304832)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=ge[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(ge[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){P9b(301232)}else{Fac(g);i=f;return}}function d3b(a){a=a|0;var b=0;b=i;c[a>>2]=302040;Fac(a+4|0);i=b;return}function e3b(a){a=a|0;var b=0;b=i;c[a>>2]=302040;Fac(a+4|0);iec(a);i=b;return}function f3b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=Hac(d,304832)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=ge[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(ge[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){P9b(301232)}else{i=e;return}}function g3b(a){a=a|0;var b=0,c=0;b=i;c=j3b(a,0)|0;i=b;return c|0}function h3b(a){a=a|0;var b=0,c=0;b=i;c=j3b(a,1)|0;i=b;return c|0}function i3b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Ce[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((od(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function j3b(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=bd(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=Ce[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==3){z=14;break}else if((y|0)==2){o=-1;z=23;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=bd(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((od(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function k3b(){var a=0;a=i;I2b(0);Xd(485,300656,q|0)|0;i=a;return}function l3b(a){a=a|0;i=i;return}function m3b(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function n3b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}de[c[(c[a>>2]|0)+8>>2]&511](a);f=1;i=b;return f|0}function o3b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=301536;e=Eec(b|0)|0;f=hec(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;Gec(g|0,b|0,e+1|0)|0;i=d;return}function p3b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=301536;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;xb(h|0);j=a;iec(j);i=b;return}jec((c[d>>2]|0)+ -12|0);g=a;h=g;xb(h|0);j=a;iec(j);i=b;return}function q3b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=301536;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;xb(h|0);i=b;return}jec((c[d>>2]|0)+ -12|0);g=a;h=g;xb(h|0);i=b;return}function r3b(a){a=a|0;i=i;return c[a+4>>2]|0}function s3b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=301560;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=Eec(f|0)|0;g=hec(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;Gec(h|0,f|0,d+1|0)|0;i=e;return}function t3b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=301560;e=Eec(b|0)|0;f=hec(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;Gec(g|0,b|0,e+1|0)|0;i=d;return}function u3b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=301560;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;xb(h|0);j=a;iec(j);i=b;return}jec((c[d>>2]|0)+ -12|0);g=a;h=g;xb(h|0);j=a;iec(j);i=b;return}function v3b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=301560;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;xb(h|0);i=b;return}jec((c[d>>2]|0)+ -12|0);g=a;h=g;xb(h|0);i=b;return}function w3b(a){a=a|0;i=i;return c[a+4>>2]|0}function x3b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=301536;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;xb(h|0);j=a;iec(j);i=b;return}jec((c[d>>2]|0)+ -12|0);g=a;h=g;xb(h|0);j=a;iec(j);i=b;return}function y3b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=301536;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;xb(h|0);j=a;iec(j);i=b;return}jec((c[d>>2]|0)+ -12|0);g=a;h=g;xb(h|0);j=a;iec(j);i=b;return}function z3b(a){a=a|0;i=i;return}function A3b(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function B3b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;Ae[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function C3b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function D3b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Ud(e|0)|0;e=Eec(f|0)|0;if(e>>>0>4294967279){J3b(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;Gec(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=gec(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;Gec(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function E3b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{o4b(e,301776,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;Ae[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}o4b(e,o,p)|0;if((a[g]&1)==0){break}iec(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function F3b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=Eec(e|0)|0;if(j>>>0>4294967279){J3b(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=gec(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}Gec(k|0,e|0,j|0)|0;a[k+j|0]=0;E3b(g,d,h);s3b(b,g);if(!((a[g]&1)==0)){iec(c[g+8>>2]|0)}if(!((a[h]&1)==0)){iec(c[h+8>>2]|0)}c[b>>2]=301792;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function G3b(a){a=a|0;var b=0;b=i;v3b(a);iec(a);i=b;return}function H3b(a){a=a|0;var b=0;b=i;v3b(a);i=b;return}function I3b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;rc(301928)|0;if((c[a>>2]|0)==1){do{ld(301952,301928)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;dc(301928)|0;de[d&511](b);rc(301928)|0;c[a>>2]=-1;dc(301928)|0;_c(301952)|0;i=e;return}else{dc(301928)|0;i=e;return}}function J3b(a){a=a|0;a=Cc(8)|0;o3b(a,302e3);c[a>>2]=301616;Rd(a|0,301656,40)}function K3b(a){a=a|0;a=Cc(8)|0;o3b(a,302e3);c[a>>2]=301680;Rd(a|0,301720,40)}function L3b(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function M3b(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function N3b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){J3b(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=gec(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}Gec(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function O3b(b){b=b|0;i=i;return(a[b]&1)!=0|0}function P3b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){J3b(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=gec(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}Gec(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function Q3b(a){a=a|0;i=i;return a|0}function R3b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=Eec(d|0)|0;if(f>>>0>4294967279){J3b(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;Gec(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=gec(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;Gec(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function S3b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){J3b(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=gec(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}Iec(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function T3b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){J3b(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;Iec(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=gec(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;Iec(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function U3b(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){K3b(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){J3b(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;Gec(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=gec(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;Gec(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function V3b(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function W3b(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function X3b(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}iec(c[b+8>>2]|0);i=d;return}function Y3b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}p4b(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}Hec(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function Z3b(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=_3b(a,b)|0;i=c;return d|0}function _3b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=Eec(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}p4b(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}Hec(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function $3b(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function a4b(a){a=a|0;i=i;return a+1|0}function b4b(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function c4b(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function d4b(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function e4b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){f4b(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function f4b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){q4b(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}Iec(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function g4b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){f4b(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function h4b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){J3b(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=gec(f)|0}else{p=gec(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}Gec(l|0,n|0,q+1|0)|0;if(o){iec(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function i4b(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function j4b(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function k4b(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function l4b(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function m4b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=o4b(b,g,h)|0;i=e;return d|0}function n4b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){q4b(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function o4b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){p4b(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}Gec(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function p4b(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){J3b(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=gec(q)|0;if((g|0)!=0){Gec(e|0,m|0,g|0)|0}if((j|0)!=0){Gec(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){Gec(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){iec(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function q4b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){J3b(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=gec(p)|0;if((g|0)!=0){Gec(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){Gec(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}iec(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function r4b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;U3b(a,b,c,d,0);i=e;return}function s4b(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function t4b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=Eec(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function u4b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=zec(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function v4b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=Eec(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){K3b(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=zec(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function w4b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){J3b(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;Gec(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=gec(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;Gec(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function x4b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){J3b(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=gec(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}Ddc(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function y4b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){J3b(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=gec(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}Fdc(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function z4b(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}iec(c[b+8>>2]|0);i=d;return}function A4b(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=B4b(a,b,Cdc(b)|0)|0;i=c;return d|0}function B4b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}E4b(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}Edc(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function C4b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){J3b(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=gec(f)|0}else{p=gec(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}Ddc(l,n,q+1|0)|0;if(o){iec(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function D4b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){F4b(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function E4b(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){J3b(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=gec(q<<2)|0;p=e;if((g|0)!=0){Ddc(p,m,g)|0}if((j|0)!=0){Ddc(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){Ddc(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){iec(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function F4b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){J3b(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=gec(p<<2)|0;o=e;if((g|0)!=0){Ddc(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){Ddc(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}iec(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function G4b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=Eec(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){J3b(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=gec(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}Gec(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=o4b(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=o4b(b,m,j)|0;i=f;return}}function H4b(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function I4b(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function J4b(a,b){a=a|0;b=b|0;var c=0;c=i;K4b(a,b);i=c;return}function K4b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Cc(16)|0;do{if((a[302384]|0)==0){if((Xa(302384)|0)==0){break}c[75594]=303080;Xd(66,302376,q|0)|0;Rb(302384)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=302376;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];F3b(b,f,302432);c[e>>2]=302400;Rd(e|0,302480,62)}function L4b(a,b){a=a|0;b=b|0;var d=0;d=i;K4b(a,c[a+16>>2]|b);i=d;return}function M4b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=302424;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;Ae[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}Fac(a+28|0);bec(c[e>>2]|0);bec(c[f>>2]|0);bec(c[a+48>>2]|0);bec(c[a+60>>2]|0);i=b;return}function N4b(a){a=a|0;var b=0;b=i;M4b(a);iec(a);i=b;return}function O4b(a){a=a|0;var b=0;b=i;M4b(a);i=b;return}function P4b(a){a=a|0;var b=0;b=i;M4b(a);i=b;return}function Q4b(a){a=a|0;i=i;return c[a+24>>2]|0}function R4b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}Eac(d,a+28|0);a=Hac(d,304768)|0;f=ue[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;Fac(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function S4b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;Eac(e,a+28|0);a=Hac(e,304768)|0;f=ue[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;Fac(e);i=d;return f|0}function T4b(a,b){a=a|0;b=b|0;var c=0;c=i;Eac(a,b+28|0);i=c;return}function U4b(a){a=a|0;c[a>>2]=302024;i=i;return}function V4b(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));Dac(b);i=d;return}function W4b(a){a=a|0;var b=0;b=i;c[a>>2]=302040;Fac(a+4|0);iec(a);i=b;return}function X4b(a){a=a|0;var b=0;b=i;c[a>>2]=302040;Fac(a+4|0);i=b;return}function Y4b(a){a=a|0;var b=0;b=i;c[a>>2]=302040;Fac(a+4|0);i=b;return}function Z4b(a,b){a=a|0;b=b|0;var c=0;c=i;Eac(a,b+4|0);i=c;return}function _4b(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=ge[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function $4b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=ue[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function a5b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=le[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function b5b(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=302040;Dac(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function c5b(a){a=a|0;i=i;return c[a+8>>2]|0}function d5b(a){a=a|0;i=i;return c[a+12>>2]|0}function e5b(a){a=a|0;i=i;return c[a+16>>2]|0}function f5b(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function g5b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function h5b(a){a=a|0;i=i;return c[a+20>>2]|0}function i5b(a){a=a|0;i=i;return c[a+24>>2]|0}function j5b(a){a=a|0;i=i;return c[a+28>>2]|0}function k5b(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function l5b(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function m5b(a,b){a=a|0;b=b|0;i=i;return}function n5b(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function o5b(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function p5b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function q5b(a){a=a|0;i=i;return 0}function r5b(a){a=a|0;i=i;return 0}function s5b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=ge[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function t5b(a){a=a|0;i=i;return-1}function u5b(a){a=a|0;var b=0,e=0,f=0;b=i;if((ge[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function v5b(a,b){a=a|0;b=b|0;i=i;return-1}function w5b(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((ue[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function x5b(a,b){a=a|0;b=b|0;i=i;return-1}function y5b(a){a=a|0;var b=0;b=i;c[a>>2]=302104;Fac(a+4|0);iec(a);i=b;return}function z5b(a){a=a|0;var b=0;b=i;c[a>>2]=302104;Fac(a+4|0);i=b;return}function A5b(a,b){a=a|0;b=b|0;i=i;return}function B5b(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function C5b(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function D5b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function E5b(a){a=a|0;i=i;return 0}function F5b(a){a=a|0;i=i;return 0}function G5b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=ge[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function H5b(a){a=a|0;i=i;return-1}function I5b(a){a=a|0;var b=0,d=0,e=0;b=i;if((ge[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function J5b(a,b){a=a|0;b=b|0;i=i;return-1}function K5b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((ue[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function L5b(a,b){a=a|0;b=b|0;i=i;return-1}function M5b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));Dac(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function N5b(a){a=a|0;var b=0;b=i;M4b(a+8|0);iec(a);i=b;return}function O5b(a){a=a|0;var b=0;b=i;M4b(a+8|0);i=b;return}function P5b(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;M4b(a+(d+8)|0);iec(a+d|0);i=b;return}function Q5b(a){a=a|0;var b=0;b=i;M4b(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function R5b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;S5b(a,b,c);i=d;return}function S5b(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){K4b(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){T5b(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}Eac(h,e+(k+28)|0);k=Hac(h,304768)|0;Fac(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(ge[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(ge[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){ge[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((ge[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;K4b(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function T5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{T5b(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((ge[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;K4b(b+h|0,c[b+(h+16)>>2]|1)}}while(0);g6b(e);i=d;return b|0}function U5b(b){b=b|0;i=i;return(a[b]|0)!=0|0}function V5b(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Db()}}function W5b(a){a=a|0;var b=0;b=i;M4b(a+8|0);iec(a);i=b;return}function X5b(a){a=a|0;var b=0;b=i;M4b(a+8|0);i=b;return}function Y5b(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;M4b(a+(d+8)|0);iec(a+d|0);i=b;return}function Z5b(a){a=a|0;var b=0;b=i;M4b(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function _5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{_5b(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((ge[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;K4b(b+h|0,c[b+(h+16)>>2]|1)}}while(0);s6b(e);i=d;return b|0}function $5b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));Dac(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function a6b(a){a=a|0;var b=0;b=i;M4b(a+4|0);iec(a);i=b;return}function b6b(a){a=a|0;var b=0;b=i;M4b(a+4|0);i=b;return}function c6b(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;M4b(a+(d+4)|0);iec(a+d|0);i=b;return}function d6b(a){a=a|0;var b=0;b=i;M4b(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function e6b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){T5b(g)|0}a[f]=1;i=e;return}function f6b(a){a=a|0;var b=0;b=i;g6b(a);i=b;return}function g6b(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(bb()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((ge[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;K4b(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function h6b(b){b=b|0;i=i;return(a[b]|0)!=0|0}function i6b(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ge[b&127](a)|0;i=c;return d|0}function j6b(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){g6b(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{T5b(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;Eac(k,b+(p+28)|0);p=Hac(k,303488)|0;m=p;Fac(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){Eac(h,b+(k+28)|0);r=Hac(h,304768)|0;s=ue[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;Fac(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];me[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){g6b(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;K4b(b+l|0,c[b+(l+16)>>2]|5);g6b(j);i=e;return b|0}function k6b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){g6b(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{T5b(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;g6b(f);i=e;return b|0}if((ue[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{g6b(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;K4b(b+d|0,c[b+(d+16)>>2]|1);g6b(f);i=e;return b|0}function l6b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){g6b(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){T5b(k)|0}a[h]=1;if((e|0)==0){g6b(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((le[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){g6b(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;K4b(b+e|0,c[b+(e+16)>>2]|1);g6b(g);i=f;return b|0}function m6b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;oe[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function n6b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){g6b(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{T5b(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];Ee[l&31](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){g6b(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;K4b(b+f|0,c[b+(f+16)>>2]|4);g6b(h);i=e;return b|0}function o6b(a){a=a|0;var b=0;b=i;M4b(a+4|0);iec(a);i=b;return}function p6b(a){a=a|0;var b=0;b=i;M4b(a+4|0);i=b;return}function q6b(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;M4b(a+(d+4)|0);iec(a+d|0);i=b;return}function r6b(a){a=a|0;var b=0;b=i;M4b(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function s6b(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(bb()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((ge[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;K4b(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function t6b(a){a=a|0;i=i;return 302320}function u6b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){P3b(a,302336,35);i=d;return}else{D3b(a,b,c);i=d;return}}function v6b(a){a=a|0;i=i;return}function w6b(a){a=a|0;var b=0;b=i;H3b(a);iec(a);i=b;return}function x6b(a){a=a|0;var b=0;b=i;H3b(a);i=b;return}function y6b(a){a=a|0;var b=0;b=i;M4b(a);iec(a);i=b;return}function z6b(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function A6b(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function B6b(a){a=a|0;i=i;return}function C6b(a){a=a|0;i=i;return}function D6b(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function E6b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){J3b(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=gec(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function F6b(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function G6b(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function H6b(a){a=a|0;i=i;return}function I6b(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function J6b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){J3b(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=gec(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function K6b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function L6b(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function M6b(a){a=a|0;i=i;return}function N6b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];re[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}T4b(u,g);m=u;u=c[m>>2]|0;if(!((c[76192]|0)==-1)){c[p>>2]=304768;c[p+4>>2]=486;c[p+8>>2]=0;I3b(304768,p,487)}p=(c[304772>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Cc(4)|0;D=C;Hdc(D);E=320328;F=127;Rd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Cc(4)|0;D=C;Hdc(D);E=320328;F=127;Rd(C|0,E|0,F|0)}F=u;n3b(c[m>>2]|0)|0;T4b(v,g);g=v;v=c[g>>2]|0;if(!((c[76228]|0)==-1)){c[o>>2]=304912;c[o+4>>2]=486;c[o+8>>2]=0;I3b(304912,o,487)}o=(c[304916>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Cc(4)|0;H=G;Hdc(H);I=320328;J=127;Rd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Cc(4)|0;H=G;Hdc(H);I=320328;J=127;Rd(G|0,I|0,J|0)}J=v;n3b(c[g>>2]|0)|0;g=w;ee[c[(c[v>>2]|0)+24>>2]&63](g,J);ee[c[(c[v>>2]|0)+28>>2]&63](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=O6b(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];X3b(w+12|0);X3b(w);i=k;return}function O6b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=aec(l)|0;if((n|0)!=0){o=n;p=n;break}nec()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((ge[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((ge[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(ge[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=ue[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(ue[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){ge[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((ge[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((ge[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}bec(o);i=k;return _|0}function P6b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Q6b(a,0,k,j,f,g,h);i=b;return}function Q6b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;G7b(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e4b(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ge[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ge[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}e4b(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}e4b(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ge[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((g7b(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ge[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=Ccc(F,c[o>>2]|0,h,t)|0;T9b(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ge[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;X3b(n);X3b(m);i=d;return}if((ge[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;X3b(n);X3b(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;X3b(n);X3b(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;X3b(n);X3b(m);i=d;return}function R6b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];S6b(a,0,k,j,f,g,h);i=b;return}function S6b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;G7b(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e4b(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ge[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ge[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}e4b(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}e4b(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(ge[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((g7b(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){ge[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=Bcc(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;T9b(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((ge[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;X3b(n);X3b(m);i=d;return}if((ge[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;X3b(n);X3b(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;X3b(n);X3b(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;X3b(n);X3b(m);i=d;return}function T6b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];U6b(a,0,k,j,f,g,h);i=b;return}function U6b(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==0){u=0}else if((t|0)==8){u=16}else if((t|0)==64){u=8}else{u=10}t=l;G7b(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;e4b(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((ge[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((ge[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}e4b(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}e4b(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(ge[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((g7b(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){ge[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=Acc(G,c[p>>2]|0,j,u)|0;T9b(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((ge[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;X3b(o);X3b(n);i=e;return}if((ge[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;X3b(o);X3b(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;X3b(o);X3b(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;X3b(o);X3b(n);i=e;return}function V6b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];W6b(a,0,k,j,f,g,h);i=b;return}function W6b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;G7b(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e4b(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ge[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ge[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}e4b(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}e4b(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ge[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((g7b(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ge[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=zcc(F,c[o>>2]|0,h,t)|0;T9b(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ge[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;X3b(n);X3b(m);i=d;return}if((ge[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;X3b(n);X3b(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;X3b(n);X3b(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;X3b(n);X3b(m);i=d;return}function X6b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Y6b(a,0,k,j,f,g,h);i=b;return}function Y6b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;G7b(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e4b(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ge[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ge[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}e4b(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}e4b(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ge[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((g7b(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ge[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=ycc(F,c[o>>2]|0,h,t)|0;T9b(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ge[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;X3b(n);X3b(m);i=d;return}if((ge[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;X3b(n);X3b(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;X3b(n);X3b(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;X3b(n);X3b(m);i=d;return}function Z6b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];_6b(a,0,k,j,f,g,h);i=b;return}function _6b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;G7b(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e4b(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ge[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ge[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}e4b(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}e4b(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(ge[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((g7b(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){ge[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=xcc(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;T9b(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((ge[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;X3b(n);X3b(m);i=d;return}if((ge[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;X3b(n);X3b(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;X3b(n);X3b(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;X3b(n);X3b(m);i=d;return}function $6b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];a7b(a,0,k,j,f,g,h);i=b;return}function a7b(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;H7b(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;e4b(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ge[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ge[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}e4b(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}e4b(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ge[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((I7b(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ge[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+wcc(I,c[p>>2]|0,j);T9b(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ge[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;X3b(o);X3b(n);i=d;return}if((ge[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;X3b(o);X3b(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;X3b(o);X3b(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;X3b(o);X3b(n);i=d;return}function b7b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];c7b(a,0,k,j,f,g,h);i=b;return}function c7b(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;H7b(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e4b(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ge[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ge[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}e4b(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}e4b(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ge[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((I7b(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ge[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+vcc(I,c[p>>2]|0,j);T9b(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ge[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;X3b(o);X3b(n);i=d;return}if((ge[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;X3b(o);X3b(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;X3b(o);X3b(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;X3b(o);X3b(n);i=d;return}function d7b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];e7b(a,0,k,j,f,g,h);i=b;return}function e7b(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;H7b(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e4b(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ge[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ge[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}e4b(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}e4b(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ge[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((I7b(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ge[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+ucc(I,c[p>>2]|0,j);T9b(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ge[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;X3b(o);X3b(n);i=d;return}if((ge[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;X3b(o);X3b(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;X3b(o);X3b(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;X3b(o);X3b(n);i=d;return}function f7b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;T4b(o,g);g=o;o=c[g>>2]|0;if(!((c[76192]|0)==-1)){c[l>>2]=304768;c[l+4>>2]=486;c[l+8>>2]=0;I3b(304768,l,487)}l=(c[304772>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Cc(4)|0;w=v;Hdc(w);x=320328;y=127;Rd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Cc(4)|0;w=v;Hdc(w);x=320328;y=127;Rd(v|0,x|0,y|0)}y=m;De[c[(c[o>>2]|0)+32>>2]&63](o,303312,303338|0,y)|0;n3b(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e4b(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((ge[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((ge[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}e4b(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}e4b(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(ge[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((g7b(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){ge[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);K=c[76164]|0;c[k>>2]=j;if((h7b(E,K,303352,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((ge[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;X3b(p);X3b(n);i=d;return}if((ge[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;X3b(p);X3b(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;X3b(p);X3b(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;X3b(p);X3b(n);i=d;return}function g7b(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[303312+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[303312+h|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function h7b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Jc(b|0)|0;b=Va(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Jc(e|0)|0;i=f;return b|0}function i7b(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function j7b(a){a=a|0;i=i;return}function k7b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];re[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}T4b(u,g);m=u;u=c[m>>2]|0;if(!((c[76190]|0)==-1)){c[p>>2]=304760;c[p+4>>2]=486;c[p+8>>2]=0;I3b(304760,p,487)}p=(c[304764>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Cc(4)|0;D=C;Hdc(D);E=320328;F=127;Rd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Cc(4)|0;D=C;Hdc(D);E=320328;F=127;Rd(C|0,E|0,F|0)}F=u;n3b(c[m>>2]|0)|0;T4b(v,g);g=v;v=c[g>>2]|0;if(!((c[76230]|0)==-1)){c[o>>2]=304920;c[o+4>>2]=486;c[o+8>>2]=0;I3b(304920,o,487)}o=(c[304924>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Cc(4)|0;H=G;Hdc(H);I=320328;J=127;Rd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Cc(4)|0;H=G;Hdc(H);I=320328;J=127;Rd(G|0,I|0,J|0)}J=v;n3b(c[g>>2]|0)|0;g=w;ee[c[(c[v>>2]|0)+24>>2]&63](g,J);ee[c[(c[v>>2]|0)+28>>2]&63](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=l7b(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];z4b(w+12|0);z4b(w);i=k;return}function l7b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=aec(l)|0;if((n|0)!=0){o=n;p=n;break}nec()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=ge[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=ge[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=ge[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=ue[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(ue[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){ge[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=ge[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=ge[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}bec(o);i=k;return ba|0}function m7b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];n7b(a,0,k,j,f,g,h);i=b;return}



function n7b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;J7b(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e4b(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ge[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ge[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}e4b(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}e4b(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ge[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((F7b(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ge[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=Ccc(I,c[o>>2]|0,h,t)|0;T9b(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ge[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ge[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;X3b(n);X3b(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;X3b(n);X3b(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;X3b(n);X3b(m);i=d;return}function o7b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];p7b(a,0,k,j,f,g,h);i=b;return}function p7b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;J7b(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e4b(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ge[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ge[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}e4b(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}e4b(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=ge[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((F7b(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){ge[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=Bcc(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;T9b(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=ge[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=ge[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;X3b(n);X3b(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;X3b(n);X3b(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;X3b(n);X3b(m);i=d;return}function q7b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];r7b(a,0,k,j,f,g,h);i=b;return}function r7b(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==8){u=16}else if((t|0)==64){u=8}else if((t|0)==0){u=0}else{u=10}t=l;J7b(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;e4b(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=ge[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=ge[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}e4b(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}e4b(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=ge[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((F7b(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){ge[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=Acc(J,c[p>>2]|0,j,u)|0;T9b(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=ge[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=ge[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;X3b(o);X3b(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;X3b(o);X3b(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;X3b(o);X3b(n);i=e;return}function s7b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];t7b(a,0,k,j,f,g,h);i=b;return}function t7b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;J7b(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e4b(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ge[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ge[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}e4b(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}e4b(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ge[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((F7b(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ge[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=zcc(I,c[o>>2]|0,h,t)|0;T9b(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ge[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ge[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;X3b(n);X3b(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;X3b(n);X3b(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;X3b(n);X3b(m);i=d;return}function u7b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];v7b(a,0,k,j,f,g,h);i=b;return}function v7b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;J7b(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e4b(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ge[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ge[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}e4b(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}e4b(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ge[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((F7b(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ge[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=ycc(I,c[o>>2]|0,h,t)|0;T9b(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ge[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ge[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;X3b(n);X3b(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;X3b(n);X3b(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;X3b(n);X3b(m);i=d;return}function w7b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];x7b(a,0,k,j,f,g,h);i=b;return}function x7b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;J7b(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e4b(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ge[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ge[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}e4b(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}e4b(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=ge[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((F7b(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){ge[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=xcc(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;T9b(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=ge[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=ge[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;X3b(n);X3b(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;X3b(n);X3b(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;X3b(n);X3b(m);i=d;return}function y7b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];z7b(a,0,k,j,f,g,h);i=b;return}function z7b(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;K7b(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;e4b(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ge[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ge[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}e4b(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}e4b(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ge[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((L7b(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ge[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+wcc(L,c[p>>2]|0,j);T9b(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ge[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ge[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;X3b(o);X3b(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;X3b(o);X3b(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;X3b(o);X3b(n);i=d;return}function A7b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];B7b(a,0,k,j,f,g,h);i=b;return}function B7b(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;K7b(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e4b(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ge[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ge[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}e4b(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}e4b(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ge[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((L7b(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ge[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+vcc(L,c[p>>2]|0,j);T9b(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ge[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ge[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;X3b(o);X3b(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;X3b(o);X3b(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;X3b(o);X3b(n);i=d;return}function C7b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];D7b(a,0,k,j,f,g,h);i=b;return}function D7b(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;K7b(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e4b(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ge[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ge[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}e4b(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}e4b(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ge[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((L7b(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ge[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+ucc(L,c[p>>2]|0,j);T9b(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ge[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ge[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;X3b(o);X3b(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;X3b(o);X3b(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;X3b(o);X3b(n);i=d;return}function E7b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;T4b(o,g);g=o;o=c[g>>2]|0;if(!((c[76190]|0)==-1)){c[l>>2]=304760;c[l+4>>2]=486;c[l+8>>2]=0;I3b(304760,l,487)}l=(c[304764>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Cc(4)|0;w=v;Hdc(w);x=320328;y=127;Rd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Cc(4)|0;w=v;Hdc(w);x=320328;y=127;Rd(v|0,x|0,y|0)}y=m;De[c[(c[o>>2]|0)+48>>2]&63](o,303312,303338|0,y)|0;n3b(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e4b(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=ge[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=ge[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}e4b(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}e4b(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=ge[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((F7b(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){ge[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);N=c[76164]|0;c[k>>2]=j;if((h7b(H,N,303352,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=ge[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=ge[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;X3b(p);X3b(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;X3b(p);X3b(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;X3b(p);X3b(n);i=d;return}function F7b(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[303312+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}}while(0);e=a[303312+m|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function G7b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;T4b(k,d);d=k;k=c[d>>2]|0;if(!((c[76192]|0)==-1)){c[j>>2]=304768;c[j+4>>2]=486;c[j+8>>2]=0;I3b(304768,j,487)}j=(c[304772>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Cc(4)|0;n=m;Hdc(n);o=320328;p=127;Rd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Cc(4)|0;n=m;Hdc(n);o=320328;p=127;Rd(m|0,o|0,p|0)}De[c[(c[k>>2]|0)+32>>2]&63](k,303312,303338|0,e)|0;e=c[d>>2]|0;if(!((c[76228]|0)==-1)){c[h>>2]=304912;c[h+4>>2]=486;c[h+8>>2]=0;I3b(304912,h,487)}h=(c[304916>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Cc(4)|0;r=q;Hdc(r);s=320328;t=127;Rd(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Cc(4)|0;r=q;Hdc(r);s=320328;t=127;Rd(q|0,s|0,t|0)}else{t=e;a[f]=ge[c[(c[e>>2]|0)+16>>2]&127](t)|0;ee[c[(c[e>>2]|0)+20>>2]&63](b,t);n3b(c[d>>2]|0)|0;i=g;return}}function H7b(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;T4b(l,d);d=l;l=c[d>>2]|0;if(!((c[76192]|0)==-1)){c[k>>2]=304768;c[k+4>>2]=486;c[k+8>>2]=0;I3b(304768,k,487)}k=(c[304772>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Cc(4)|0;o=n;Hdc(o);p=320328;q=127;Rd(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Cc(4)|0;o=n;Hdc(o);p=320328;q=127;Rd(n|0,p|0,q|0)}De[c[(c[l>>2]|0)+32>>2]&63](l,303312,303344|0,e)|0;e=c[d>>2]|0;if(!((c[76228]|0)==-1)){c[j>>2]=304912;c[j+4>>2]=486;c[j+8>>2]=0;I3b(304912,j,487)}j=(c[304916>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Cc(4)|0;s=r;Hdc(s);t=320328;u=127;Rd(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Cc(4)|0;s=r;Hdc(s);t=320328;u=127;Rd(r|0,t|0,u|0)}else{u=e;a[f]=ge[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=ge[c[(c[e>>2]|0)+16>>2]&127](u)|0;ee[c[(c[e>>2]|0)+20>>2]&63](b,u);n3b(c[d>>2]|0)|0;i=h;return}}function I7b(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[303312+j|0]|0;if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function J7b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;T4b(j,b);b=j;j=c[b>>2]|0;if(!((c[76190]|0)==-1)){c[h>>2]=304760;c[h+4>>2]=486;c[h+8>>2]=0;I3b(304760,h,487)}h=(c[304764>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Cc(4)|0;m=l;Hdc(m);n=320328;o=127;Rd(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Cc(4)|0;m=l;Hdc(m);n=320328;o=127;Rd(l|0,n|0,o|0)}De[c[(c[j>>2]|0)+48>>2]&63](j,303312,303338|0,d)|0;d=c[b>>2]|0;if(!((c[76230]|0)==-1)){c[g>>2]=304920;c[g+4>>2]=486;c[g+8>>2]=0;I3b(304920,g,487)}g=(c[304924>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Cc(4)|0;q=p;Hdc(q);r=320328;s=127;Rd(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Cc(4)|0;q=p;Hdc(q);r=320328;s=127;Rd(p|0,r|0,s|0)}else{s=d;c[e>>2]=ge[c[(c[d>>2]|0)+16>>2]&127](s)|0;ee[c[(c[d>>2]|0)+20>>2]&63](a,s);n3b(c[b>>2]|0)|0;i=f;return}}function K7b(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;T4b(k,b);b=k;k=c[b>>2]|0;if(!((c[76190]|0)==-1)){c[j>>2]=304760;c[j+4>>2]=486;c[j+8>>2]=0;I3b(304760,j,487)}j=(c[304764>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Cc(4)|0;n=m;Hdc(n);o=320328;p=127;Rd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Cc(4)|0;n=m;Hdc(n);o=320328;p=127;Rd(m|0,o|0,p|0)}De[c[(c[k>>2]|0)+48>>2]&63](k,303312,303344|0,d)|0;d=c[b>>2]|0;if(!((c[76230]|0)==-1)){c[h>>2]=304920;c[h+4>>2]=486;c[h+8>>2]=0;I3b(304920,h,487)}h=(c[304924>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Cc(4)|0;r=q;Hdc(r);s=320328;t=127;Rd(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Cc(4)|0;r=q;Hdc(r);s=320328;t=127;Rd(q|0,s|0,t|0)}else{t=d;c[e>>2]=ge[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=ge[c[(c[d>>2]|0)+16>>2]&127](t)|0;ee[c[(c[d>>2]|0)+20>>2]&63](a,t);n3b(c[b>>2]|0)|0;i=g;return}}function L7b(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[303312+o|0]|0;do{if((o|0)==23|(o|0)==22){a[e]=80}else if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function M7b(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function N7b(a){a=a|0;i=i;return}function O7b(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];oe[p&31](b,d,k,f,g,q);i=j;return}T4b(n,f);f=n;n=c[f>>2]|0;if(!((c[76228]|0)==-1)){c[l>>2]=304912;c[l+4>>2]=486;c[l+8>>2]=0;I3b(304912,l,487)}l=(c[304916>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Cc(4)|0;u=t;Hdc(u);v=320328;w=127;Rd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Cc(4)|0;u=t;Hdc(u);v=320328;w=127;Rd(t|0,v|0,w|0)}w=n;n3b(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ee[c[f+24>>2]&63](o,w)}else{ee[c[f+28>>2]&63](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((ue[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];X3b(o);i=j;return}function P7b(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=303560;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);v=c[76164]|0;c[k>>2]=h;h=Q7b(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;T4b(q,f);R7b(w,y,k,z,o,p,q);n3b(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];u0b(b,j,z,e,o,f,g);i=d;return}function Q7b(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Jc(d|0)|0;d=Xc(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Jc(f|0)|0;i=g;return d|0}function R7b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[76192]|0)==-1)){c[m>>2]=304768;c[m+4>>2]=486;c[m+8>>2]=0;I3b(304768,m,487)}m=(c[304772>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Cc(4)|0;r=q;Hdc(r);s=320328;t=127;Rd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Cc(4)|0;r=q;Hdc(r);s=320328;t=127;Rd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[76228]|0)==-1)){c[l>>2]=304912;c[l+4>>2]=486;c[l+8>>2]=0;I3b(304912,l,487)}l=(c[304916>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Cc(4)|0;v=u;Hdc(v);w=320328;x=127;Rd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Cc(4)|0;v=u;Hdc(v);w=320328;x=127;Rd(u|0,w|0,x|0)}x=s;ee[c[(c[s>>2]|0)+20>>2]&63](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){De[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=ue[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=ue[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=ue[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=ge[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=ue[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;X3b(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;X3b(n);i=k;return}}function S7b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);y=c[76164]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=Q7b(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;T4b(r,f);R7b(x,z,l,A,p,q,r);n3b(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];u0b(b,k,A,e,p,f,g);i=d;return}function T7b(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=303560;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);x=c[76164]|0;c[k>>2]=h;h=Q7b(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;T4b(q,f);R7b(w,y,k,z,o,p,q);n3b(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];u0b(b,j,z,e,o,f,g);i=d;return}function U7b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);w=c[76164]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=Q7b(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;T4b(r,f);R7b(x,z,l,A,p,q,r);n3b(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];u0b(b,k,A,e,p,f,g);i=d;return}function V7b(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);r=c[76164]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Q7b(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Q7b(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[304664]|0)==0;if(F){do{if(o){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);r=c[76164]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=W7b(s,r,z,n)|0}else{do{if(o){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);o=c[76164]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=W7b(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}nec()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=aec(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}nec()}}while(0);T4b(w,f);X7b(N,L,G,P,u,v,w);n3b(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];u0b(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){bec(O)}if((J|0)==0){i=d;return}bec(J);i=d;return}function W7b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Jc(b|0)|0;b=hc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Jc(e|0)|0;i=f;return b|0}function X7b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[76192]|0)==-1)){c[m>>2]=304768;c[m+4>>2]=486;c[m+8>>2]=0;I3b(304768,m,487)}m=(c[304772>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Cc(4)|0;r=q;Hdc(r);s=320328;t=127;Rd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Cc(4)|0;r=q;Hdc(r);s=320328;t=127;Rd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[76228]|0)==-1)){c[l>>2]=304912;c[l+4>>2]=486;c[l+8>>2]=0;I3b(304912,l,487)}l=(c[304916>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Cc(4)|0;v=u;Hdc(v);w=320328;x=127;Rd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Cc(4)|0;v=u;Hdc(v);w=320328;x=127;Rd(u|0,w|0,x|0)}x=s;ee[c[(c[s>>2]|0)+20>>2]&63](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=ue[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=ue[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=ue[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);w=A+1|0;if((Vc(l<<24>>24|0,c[76164]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);l=D+1|0;if((Td(A<<24>>24|0,c[76164]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){De[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=ge[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=ue[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=ue[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=ge[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);De[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;X3b(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;X3b(n);i=k;return}function Y7b(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);r=c[76164]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Q7b(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Q7b(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[304664]|0)==0;if(F){do{if(o){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);r=c[76164]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=W7b(s,r,z,n)|0}else{do{if(o){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);o=c[76164]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=W7b(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}nec()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=aec(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}nec()}}while(0);T4b(w,f);X7b(N,L,G,P,u,v,w);n3b(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];u0b(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){bec(O)}if((J|0)==0){i=d;return}bec(J);i=d;return}function Z7b(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=303568;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);s=c[76164]|0;c[k>>2]=h;h=Q7b(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}u=o;T4b(p,f);r=p;p=c[r>>2]|0;if(!((c[76192]|0)==-1)){c[l>>2]=304768;c[l+4>>2]=486;c[l+8>>2]=0;I3b(304768,l,487)}l=(c[304772>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Cc(4)|0;w=v;Hdc(w);x=320328;y=127;Rd(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Cc(4)|0;w=v;Hdc(w);x=320328;y=127;Rd(v|0,x|0,y|0)}n3b(c[r>>2]|0)|0;De[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];u0b(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];u0b(b,j,u,z,m,f,g);I=j;i=d;return}function _7b(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function $7b(a){a=a|0;i=i;return}function a8b(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];oe[p&31](b,d,k,f,g,q);i=j;return}T4b(n,f);f=n;n=c[f>>2]|0;if(!((c[76230]|0)==-1)){c[l>>2]=304920;c[l+4>>2]=486;c[l+8>>2]=0;I3b(304920,l,487)}l=(c[304924>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Cc(4)|0;u=t;Hdc(u);v=320328;w=127;Rd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Cc(4)|0;u=t;Hdc(u);v=320328;w=127;Rd(t|0,v|0,w|0)}w=n;n3b(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ee[c[f+24>>2]&63](o,w)}else{ee[c[f+28>>2]&63](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=ue[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];z4b(o);i=j;return}function b8b(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=303560;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);x=c[76164]|0;c[k>>2]=h;h=Q7b(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;T4b(q,f);c8b(w,y,k,z,o,p,q);n3b(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];d8b(b,j,z,e,o,f,g);i=d;return}function c8b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[76190]|0)==-1)){c[m>>2]=304760;c[m+4>>2]=486;c[m+8>>2]=0;I3b(304760,m,487)}m=(c[304764>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Cc(4)|0;r=q;Hdc(r);s=320328;t=127;Rd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Cc(4)|0;r=q;Hdc(r);s=320328;t=127;Rd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[76230]|0)==-1)){c[l>>2]=304920;c[l+4>>2]=486;c[l+8>>2]=0;I3b(304920,l,487)}l=(c[304924>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Cc(4)|0;v=u;Hdc(v);w=320328;x=127;Rd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Cc(4)|0;v=u;Hdc(v);w=320328;x=127;Rd(u|0,w|0,x|0)}x=s;ee[c[(c[s>>2]|0)+20>>2]&63](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){De[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=ue[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=ue[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=ue[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=ge[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=ue[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;X3b(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;X3b(n);i=k;return}function d8b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((le[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){y4b(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((le[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){z4b(l);break}c[m>>2]=0;c[b>>2]=0;z4b(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((le[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function e8b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);y=c[76164]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=Q7b(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;T4b(r,f);c8b(x,z,l,A,p,q,r);n3b(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];d8b(b,k,A,e,p,f,g);i=d;return}function f8b(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=303560;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);x=c[76164]|0;c[k>>2]=h;h=Q7b(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;T4b(q,f);c8b(w,y,k,z,o,p,q);n3b(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];d8b(b,j,z,e,o,f,g);i=d;return}function g8b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);y=c[76164]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=Q7b(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;T4b(r,f);c8b(x,z,l,A,p,q,r);n3b(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];d8b(b,k,A,e,p,f,g);i=d;return}function h8b(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);r=c[76164]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Q7b(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Q7b(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[304664]|0)==0;if(F){do{if(o){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);r=c[76164]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=W7b(s,r,z,n)|0}else{do{if(o){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);o=c[76164]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=W7b(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}nec()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=aec(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}nec()}}while(0);T4b(w,f);i8b(N,L,G,P,u,v,w);n3b(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];d8b(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){bec(O)}if((J|0)==0){i=d;return}bec(J);i=d;return}function i8b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[76190]|0)==-1)){c[m>>2]=304760;c[m+4>>2]=486;c[m+8>>2]=0;I3b(304760,m,487)}m=(c[304764>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Cc(4)|0;r=q;Hdc(r);s=320328;t=127;Rd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Cc(4)|0;r=q;Hdc(r);s=320328;t=127;Rd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[76230]|0)==-1)){c[l>>2]=304920;c[l+4>>2]=486;c[l+8>>2]=0;I3b(304920,l,487)}l=(c[304924>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Cc(4)|0;v=u;Hdc(v);w=320328;x=127;Rd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Cc(4)|0;v=u;Hdc(v);w=320328;x=127;Rd(u|0,w|0,x|0)}x=s;ee[c[(c[s>>2]|0)+20>>2]&63](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=ue[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=ue[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=ue[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);w=A+1|0;if((Vc(l<<24>>24|0,c[76164]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);l=D+1|0;if((Td(A<<24>>24|0,c[76164]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){De[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=ge[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=ue[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=ue[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=ge[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);De[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;X3b(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;X3b(n);i=k;return}function j8b(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);r=c[76164]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Q7b(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Q7b(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[304664]|0)==0;if(F){do{if(o){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);r=c[76164]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=W7b(s,r,z,n)|0}else{do{if(o){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);o=c[76164]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=W7b(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}nec()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=aec(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}nec()}}while(0);T4b(w,f);i8b(N,L,G,P,u,v,w);n3b(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];d8b(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){bec(O)}if((J|0)==0){i=d;return}bec(J);i=d;return}function k8b(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=303568;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);s=c[76164]|0;c[k>>2]=h;h=Q7b(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}T4b(p,f);u=p;p=c[u>>2]|0;if(!((c[76190]|0)==-1)){c[l>>2]=304760;c[l+4>>2]=486;c[l+8>>2]=0;I3b(304760,l,487)}l=(c[304764>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Cc(4)|0;w=v;Hdc(w);x=320328;y=127;Rd(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Cc(4)|0;w=v;Hdc(w);x=320328;y=127;Rd(v|0,x|0,y|0)}n3b(c[u>>2]|0)|0;u=o;De[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];d8b(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];d8b(b,j,u,z,m,f,g);I=j;i=d;return}function l8b(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;T4b(r,h);v=r;r=c[v>>2]|0;if(!((c[76192]|0)==-1)){c[q>>2]=304768;c[q+4>>2]=486;c[q+8>>2]=0;I3b(304768,q,487)}q=(c[304772>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Cc(4)|0;y=x;Hdc(y);z=320328;A=127;Rd(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Cc(4)|0;y=x;Hdc(y);z=320328;A=127;Rd(x|0,z|0,A|0)}A=r;n3b(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((ge[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((ge[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((le[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(ge[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=ue[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(ue[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=le[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=le[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];te[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((ge[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((ge[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(ge[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){ge[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){ge[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((ge[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((ge[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function m8b(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function n8b(a){a=a|0;i=i;return}function o8b(a){a=a|0;i=i;return 2}function p8b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];l8b(a,b,l,k,f,g,h,303672,303680|0);i=j;return}function q8b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=ge[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];l8b(b,d,m,l,g,h,j,s,q);i=k;return}function r8b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;T4b(n,f);f=n;n=c[f>>2]|0;if(!((c[76192]|0)==-1)){c[m>>2]=304768;c[m+4>>2]=486;c[m+8>>2]=0;I3b(304768,m,487)}m=(c[304772>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Cc(4)|0;q=p;Hdc(q);r=320328;s=127;Rd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Cc(4)|0;q=p;Hdc(q);r=320328;s=127;Rd(p|0,r|0,s|0)}s=n;n3b(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ge[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=O6b(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function s8b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;T4b(n,f);f=n;n=c[f>>2]|0;if(!((c[76192]|0)==-1)){c[m>>2]=304768;c[m+4>>2]=486;c[m+8>>2]=0;I3b(304768,m,487)}m=(c[304772>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Cc(4)|0;q=p;Hdc(q);r=320328;s=127;Rd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Cc(4)|0;q=p;Hdc(q);r=320328;s=127;Rd(p|0,r|0,s|0)}s=n;n3b(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ge[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=O6b(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function t8b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;T4b(m,f);f=m;m=c[f>>2]|0;if(!((c[76192]|0)==-1)){c[l>>2]=304768;c[l+4>>2]=486;c[l+8>>2]=0;I3b(304768,l,487)}l=(c[304772>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Cc(4)|0;p=o;Hdc(p);q=320328;r=127;Rd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Cc(4)|0;p=o;Hdc(p);q=320328;r=127;Rd(o|0,q|0,r|0)}r=m;n3b(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=y8b(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function u8b(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;T4b(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[76192]|0)==-1)){c[ba>>2]=304768;c[ba+4>>2]=486;c[ba+8>>2]=0;I3b(304768,ba,487)}ba=(c[304772>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Cc(4)|0;Ga=Fa;Hdc(Ga);Ha=320328;Ia=127;Rd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Cc(4)|0;Ga=Fa;Hdc(Ga);Ha=320328;Ia=127;Rd(Fa|0,Ha|0,Ia|0)}Ia=ca;n3b(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=y8b(e,F,h,Ia,3)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];ca=y8b(e,w,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<61){c[j>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];v8b(0,e,C,h,Ia);break};case 99:{Da=d+8|0;ca=ge[c[(c[Da>>2]|0)+12>>2]&127](Da)|0;Da=e;c[ea>>2]=c[Da>>2];c[fa>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Ja=ca+1|0;Ka=ca+1|0;La=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Ja=Ha;Ka=Ha;La=c[ca+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];l8b(da,d,O,N,g,h,j,Ka,Ja+La|0);c[Da>>2]=c[da>>2];break};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];l8b(ua,d,v,u,g,h,j,303720,303728|0);c[Da>>2]=c[ua>>2];break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Da=y8b(e,H,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<24){c[j+8>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];ca=y8b(e,D,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<60){c[j+4>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Da=y8b(e,t,h,Ia,1)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<7){c[j+24>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];l8b(ja,d,J,I,g,h,j,303688,303696|0);c[ca>>2]=c[ja>>2];break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];ca=y8b(e,E,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<13){c[j+16>>2]=ca+ -1;break a}else{c[h>>2]=Da|4;break a}break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];x8b(0,e,m,h,Ia);break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];l8b(ra,d,y,x,g,h,j,303712,303717|0);c[Da>>2]=c[ra>>2];break};case 88:{Da=d+8|0;ca=ge[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Ma=ca+1|0;Na=ca+1|0;Oa=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Ma=Ha;Na=Ha;Oa=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];l8b(za,d,q,p,g,h,j,Na,Ma+Oa|0);c[Da>>2]=c[za>>2];break};case 73:{Da=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];ca=y8b(e,G,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((ca+ -1|0)>>>0<12)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Ha|4;break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];ca=y8b(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((ca|0)<69){Pa=ca+2e3|0}else{Pa=(ca+ -69|0)>>>0<31?ca+1900|0:ca}c[j+20>>2]=Pa+ -1900;break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];w8b(d,j+8|0,e,B,h,Ia);break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=y8b(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];l8b(oa,d,A,z,g,h,j,303696,303707|0);c[ca>>2]=c[oa>>2];break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=y8b(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};case 104:case 66:case 98:{Da=c[f>>2]|0;ca=d+8|0;Ha=ge[c[(c[ca>>2]|0)+4>>2]&127](ca)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(O6b(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];l8b(ga,d,L,K,g,h,j,303680,303688|0);c[Da>>2]=c[ga>>2];break};case 65:case 97:{Da=c[f>>2]|0;Ha=d+8|0;ca=ge[c[c[Ha>>2]>>2]&127](Ha)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(O6b(e,Q,ca,ca+168|0,Ia,h,0)|0)-ca|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 120:{Da=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];re[Da&63](b,d,s,r,g,h,j);i=l;return};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function v8b(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((ge[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((ge[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(ge[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){ge[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((ge[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((ge[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function w8b(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=ge[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=O6b(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function x8b(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((ge[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((ge[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(ge[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((le[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){ge[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((ge[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((ge[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function y8b(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((ge[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((ge[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(ge[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(le[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){ge[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((ge[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((ge[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(ge[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((le[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){ge[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((ge[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((ge[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function z8b(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;T4b(p,f);t=p;p=c[t>>2]|0;if(!((c[76190]|0)==-1)){c[o>>2]=304760;c[o+4>>2]=486;c[o+8>>2]=0;I3b(304760,o,487)}o=(c[304764>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Cc(4)|0;w=v;Hdc(w);x=320328;y=127;Rd(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Cc(4)|0;w=v;Hdc(w);x=320328;y=127;Rd(v|0,x|0,y|0)}y=p;n3b(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=ge[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=ge[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((le[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(le[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=ge[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=ue[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(ue[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=le[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=le[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];te[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(le[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=ge[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=ge[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=ge[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(le[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){ge[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){ge[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=ge[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=ge[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function A8b(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function B8b(a){a=a|0;i=i;return}function C8b(a){a=a|0;i=i;return 2}function D8b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];z8b(a,b,l,k,f,g,h,303824,303856|0);i=j;return}function E8b(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=ge[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];z8b(b,d,m,l,g,h,j,s,q);i=k;return}function F8b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;T4b(n,f);f=n;n=c[f>>2]|0;if(!((c[76190]|0)==-1)){c[m>>2]=304760;c[m+4>>2]=486;c[m+8>>2]=0;I3b(304760,m,487)}m=(c[304764>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Cc(4)|0;q=p;Hdc(q);r=320328;s=127;Rd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Cc(4)|0;q=p;Hdc(q);r=320328;s=127;Rd(p|0,r|0,s|0)}s=n;n3b(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ge[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=l7b(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function G8b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;T4b(n,f);f=n;n=c[f>>2]|0;if(!((c[76190]|0)==-1)){c[m>>2]=304760;c[m+4>>2]=486;c[m+8>>2]=0;I3b(304760,m,487)}m=(c[304764>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Cc(4)|0;q=p;Hdc(q);r=320328;s=127;Rd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Cc(4)|0;q=p;Hdc(q);r=320328;s=127;Rd(p|0,r|0,s|0)}s=n;n3b(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ge[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=l7b(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function H8b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;T4b(m,f);f=m;m=c[f>>2]|0;if(!((c[76190]|0)==-1)){c[l>>2]=304760;c[l+4>>2]=486;c[l+8>>2]=0;I3b(304760,l,487)}l=(c[304764>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Cc(4)|0;p=o;Hdc(p);q=320328;r=127;Rd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Cc(4)|0;p=o;Hdc(p);q=320328;r=127;Rd(o|0,q|0,r|0)}r=m;n3b(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=M8b(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function I8b(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;T4b(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[76190]|0)==-1)){c[ba>>2]=304760;c[ba+4>>2]=486;c[ba+8>>2]=0;I3b(304760,ba,487)}ba=(c[304764>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Cc(4)|0;Ga=Fa;Hdc(Ga);Ha=320328;Ia=127;Rd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Cc(4)|0;Ga=Fa;Hdc(Ga);Ha=320328;Ia=127;Rd(Fa|0,Ha|0,Ia|0)}Ia=ca;n3b(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=M8b(e,F,h,Ia,3)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];ca=M8b(e,E,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<13){c[j+16>>2]=ca+ -1;break a}else{c[h>>2]=Da|4;break a}break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];J8b(0,e,C,h,Ia);break};case 99:{Da=d+8|0;ca=ge[c[(c[Da>>2]|0)+12>>2]&127](Da)|0;Da=e;c[ea>>2]=c[Da>>2];c[fa>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Ja=ca+4|0;Ka=ca+4|0;La=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Ja=Ha;Ka=Ha;La=c[ca+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];z8b(da,d,O,N,g,h,j,Ka,Ja+(La<<2)|0);c[Da>>2]=c[da>>2];break};case 104:case 66:case 98:{Da=c[f>>2]|0;ca=d+8|0;Ha=ge[c[(c[ca>>2]|0)+4>>2]&127](ca)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(l7b(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=M8b(e,D,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 120:{Ha=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];re[Ha&63](b,d,s,r,g,h,j);i=l;return};case 101:case 100:{Ha=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=M8b(e,M,h,Ia,2)|0;ca=c[h>>2]|0;do{if((ca&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[Ha>>2]=Da;break a}}while(0);c[h>>2]=ca|4;break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];z8b(ra,d,y,x,g,h,j,303968,303988|0);c[Da>>2]=c[ra>>2];break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=M8b(e,w,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Ha=M8b(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Ha|0)<69){Ma=Ha+2e3|0}else{Ma=(Ha+ -69|0)>>>0<31?Ha+1900|0:Ha}c[j+20>>2]=Ma+ -1900;break};case 73:{Ha=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=M8b(e,G,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[Ha>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};case 65:case 97:{Da=c[f>>2]|0;Ha=d+8|0;ca=ge[c[c[Ha>>2]>>2]&127](Ha)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(l7b(e,Q,ca,ca+168|0,Ia,h,0)|0)-ca|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];z8b(ja,d,J,I,g,h,j,303888,303920|0);c[Da>>2]=c[ja>>2];break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];z8b(ga,d,L,K,g,h,j,303856,303888|0);c[Da>>2]=c[ga>>2];break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];L8b(0,e,m,h,Ia);break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Da=M8b(e,H,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<24){c[j+8>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];K8b(d,j+8|0,e,B,h,Ia);break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=M8b(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];z8b(oa,d,A,z,g,h,j,303920,303964|0);c[ca>>2]=c[oa>>2];break};case 84:{ca=e;c[va>>2]=c[ca>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];z8b(ua,d,v,u,g,h,j,303992,304024|0);c[ca>>2]=c[ua>>2];break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=M8b(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 88:{Da=d+8|0;ca=ge[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Na=ca+4|0;Oa=ca+4|0;Pa=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Na=Ha;Oa=Ha;Pa=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];z8b(za,d,q,p,g,h,j,Oa,Na+(Pa<<2)|0);c[Da>>2]=c[za>>2];break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}



function J8b(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=ge[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=ge[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=ge[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(le[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){ge[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=ge[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=ge[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function K8b(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=ge[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=l7b(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function L8b(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=ge[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=ge[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=ge[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((le[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){ge[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=ge[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=ge[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function M8b(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=ge[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=ge[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=ge[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(le[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(le[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){ge[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=ge[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=ge[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=ge[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(le[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((le[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){ge[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=ge[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=ge[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function N8b(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);if((f|0)==(c[76164]|0)){g=b;iec(g);i=d;return}_b(c[e>>2]|0);g=b;iec(g);i=d;return}function O8b(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);if((b|0)==(c[76164]|0)){i=d;return}_b(c[e>>2]|0);i=d;return}function P8b(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Qc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(ue[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function Q8b(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);if((f|0)==(c[76164]|0)){g=b;iec(g);i=d;return}_b(c[e>>2]|0);g=b;iec(g);i=d;return}function R8b(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);if((b|0)==(c[76164]|0)){i=d;return}_b(c[e>>2]|0);i=d;return}function S8b(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;T8b(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=ue[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function T8b(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Qc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Jc(c[g>>2]|0)|0;g=ddc(d,m,n,l)|0;if((f|0)!=0){Jc(f|0)|0}if((g|0)==-1){P9b(305648)}else{c[e>>2]=d+(g<<2);i=j;return}}function U8b(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function V8b(a){a=a|0;i=i;return}function W8b(a){a=a|0;i=i;return 127}function X8b(a){a=a|0;i=i;return 127}function Y8b(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Z8b(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function _8b(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function $8b(a,b){a=a|0;b=b|0;b=i;T3b(a,1,45);i=b;return}function a9b(a){a=a|0;i=i;return 0}function b9b(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function c9b(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function d9b(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function e9b(a){a=a|0;i=i;return}function f9b(a){a=a|0;i=i;return 127}function g9b(a){a=a|0;i=i;return 127}function h9b(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function i9b(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function j9b(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function k9b(a,b){a=a|0;b=b|0;b=i;T3b(a,1,45);i=b;return}function l9b(a){a=a|0;i=i;return 0}function m9b(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function n9b(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function o9b(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function p9b(a){a=a|0;i=i;return}function q9b(a){a=a|0;i=i;return 2147483647}function r9b(a){a=a|0;i=i;return 2147483647}function s9b(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function t9b(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function u9b(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function v9b(a,b){a=a|0;b=b|0;b=i;y4b(a,1,45);i=b;return}function w9b(a){a=a|0;i=i;return 0}function x9b(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function y9b(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function z9b(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function A9b(a){a=a|0;i=i;return}function B9b(a){a=a|0;i=i;return 2147483647}function C9b(a){a=a|0;i=i;return 2147483647}function D9b(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function E9b(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function F9b(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function G9b(a,b){a=a|0;b=b|0;b=i;y4b(a,1,45);i=b;return}function H9b(a){a=a|0;i=i;return 0}function I9b(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function J9b(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function K9b(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function L9b(a){a=a|0;i=i;return}function M9b(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=488;y=o+100|0;T4b(r,h);o=r;z=c[o>>2]|0;if(!((c[76192]|0)==-1)){c[n>>2]=304768;c[n+4>>2]=486;c[n+8>>2]=0;I3b(304768,n,487)}n=(c[304772>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Cc(4)|0;C=B;Hdc(C);D=320328;E=127;Rd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Cc(4)|0;C=B;Hdc(C);D=320328;E=127;Rd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=O9b(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;De[c[(c[z>>2]|0)+32>>2]&63](E,304384,304394|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=aec(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}nec()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[304384+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((vd(p|0,304400,m|0)|0)!=1){t=Cc(8)|0;t3b(t,304408);Rd(t|0,301760,42)}if((F|0)==0){break}bec(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((ge[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((ge[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;n3b(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}de[c[x>>2]&511](o);i=d;return}function N9b(a){a=a|0;i=i;return}function O9b(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;S9b(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=488;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((ge[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((ge[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}W=c[h>>2]|0;ba=c[W+12>>2]|0;if((ba|0)==(c[W+16>>2]|0)){ca=(ge[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{ca=a[ba]|0}if(!(ca<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(ca<<24>>24<<1)>>1]&8192)==0){X=25;break a}ba=c[h>>2]|0;W=ba+12|0;da=c[W>>2]|0;if((da|0)==(c[ba+16>>2]|0)){ea=(ge[c[(c[ba>>2]|0)+40>>2]&127](ba)|0)&255}else{c[W>>2]=da+1;ea=a[da]|0}n4b(A,ea);X=26;break};case 0:{X=26;break};case 4:{da=D;W=R;ba=r;fa=Q;ga=0;ha=T;c:while(1){ia=c[h>>2]|0;do{if((ia|0)==0){ja=0}else{if((c[ia+12>>2]|0)!=(c[ia+16>>2]|0)){ja=ia;break}if((ge[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)==-1){c[h>>2]=0;ja=0;break}else{ja=c[h>>2]|0;break}}}while(0);ia=(ja|0)==0;ka=c[e>>2]|0;do{if((ka|0)==0){X=173}else{if((c[ka+12>>2]|0)!=(c[ka+16>>2]|0)){if(ia){break}else{break c}}if((ge[c[(c[ka>>2]|0)+36>>2]&127](ka)|0)==-1){c[e>>2]=0;X=173;break}else{if(ia){break}else{break c}}}}while(0);if((X|0)==173){X=0;if(ia){break}}ka=c[h>>2]|0;la=c[ka+12>>2]|0;if((la|0)==(c[ka+16>>2]|0)){ma=(ge[c[(c[ka>>2]|0)+36>>2]&127](ka)|0)&255}else{ma=a[la]|0}do{if(ma<<24>>24>-1){if((b[(c[f>>2]|0)+(ma<<24>>24<<1)>>1]&2048)==0){X=189;break}la=c[o>>2]|0;if((la|0)==(da|0)){ka=(c[P>>2]|0)!=488;na=c[t>>2]|0;oa=da-na|0;pa=oa>>>0<2147483647?oa<<1:-1;qa=dec(ka?na:0,pa)|0;if((qa|0)==0){X=182;break a}do{if(ka){c[t>>2]=qa;ra=qa}else{na=c[t>>2]|0;c[t>>2]=qa;if((na|0)==0){ra=qa;break}de[c[P>>2]&511](na);ra=c[t>>2]|0}}while(0);c[P>>2]=463;qa=ra+oa|0;c[o>>2]=qa;sa=qa;ta=(c[t>>2]|0)+pa|0}else{sa=la;ta=da}c[o>>2]=sa+1;a[sa]=ma;ua=ta;va=W;wa=ba;xa=fa;ya=ga+1|0;za=ha}else{X=189}}while(0);if((X|0)==189){X=0;ia=a[w]|0;if((ia&1)==0){Aa=(ia&255)>>>1}else{Aa=c[n>>2]|0}if((Aa|0)==0|(ga|0)==0){break}if(!(ma<<24>>24==(a[v]|0))){break}if((ba|0)==(fa|0)){ia=ba-W|0;qa=ia>>>0<2147483647?ia<<1:-1;if((ha|0)==488){Ba=0}else{Ba=W}ka=dec(Ba,qa)|0;if((ka|0)==0){X=198;break a}Ca=ka;Da=ka+(ia>>2<<2)|0;Ea=ka+(qa>>>2<<2)|0;Fa=463}else{Ca=W;Da=ba;Ea=fa;Fa=ha}c[Da>>2]=ga;ua=da;va=Ca;wa=Da+4|0;xa=Ea;ya=0;za=Fa}qa=c[h>>2]|0;ka=qa+12|0;ia=c[ka>>2]|0;if((ia|0)==(c[qa+16>>2]|0)){ge[c[(c[qa>>2]|0)+40>>2]&127](qa)|0;da=ua;W=va;ba=wa;fa=xa;ga=ya;ha=za;continue}else{c[ka>>2]=ia+1;da=ua;W=va;ba=wa;fa=xa;ga=ya;ha=za;continue}}if((W|0)==(ba|0)|(ga|0)==0){Ga=W;Ha=ba;Ia=fa;Ja=ha}else{if((ba|0)==(fa|0)){ia=ba-W|0;ka=ia>>>0<2147483647?ia<<1:-1;if((ha|0)==488){Ka=0}else{Ka=W}qa=dec(Ka,ka)|0;if((qa|0)==0){X=209;break a}La=qa;Ma=qa+(ia>>2<<2)|0;Na=qa+(ka>>>2<<2)|0;Oa=463}else{La=W;Ma=ba;Na=fa;Oa=ha}c[Ma>>2]=ga;Ga=La;Ha=Ma+4|0;Ia=Na;Ja=Oa}if((c[B>>2]|0)>0){ka=c[h>>2]|0;do{if((ka|0)==0){Pa=0}else{if((c[ka+12>>2]|0)!=(c[ka+16>>2]|0)){Pa=ka;break}if((ge[c[(c[ka>>2]|0)+36>>2]&127](ka)|0)==-1){c[h>>2]=0;Pa=0;break}else{Pa=c[h>>2]|0;break}}}while(0);ka=(Pa|0)==0;ga=c[e>>2]|0;do{if((ga|0)==0){X=223}else{if((c[ga+12>>2]|0)!=(c[ga+16>>2]|0)){if(ka){Qa=ga;break}else{X=229;break a}}if((ge[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)==-1){c[e>>2]=0;X=223;break}else{if(ka){Qa=ga;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(ka){X=229;break a}else{Qa=0}}ga=c[h>>2]|0;ha=c[ga+12>>2]|0;if((ha|0)==(c[ga+16>>2]|0)){Ra=(ge[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255}else{Ra=a[ha]|0}if(!(Ra<<24>>24==(a[u]|0))){X=229;break a}ha=c[h>>2]|0;ga=ha+12|0;fa=c[ga>>2]|0;if((fa|0)==(c[ha+16>>2]|0)){ge[c[(c[ha>>2]|0)+40>>2]&127](ha)|0;Sa=Qa;Ta=Qa;Ua=da}else{c[ga>>2]=fa+1;Sa=Qa;Ta=Qa;Ua=da}while(1){fa=c[h>>2]|0;do{if((fa|0)==0){Va=0}else{if((c[fa+12>>2]|0)!=(c[fa+16>>2]|0)){Va=fa;break}if((ge[c[(c[fa>>2]|0)+36>>2]&127](fa)|0)==-1){c[h>>2]=0;Va=0;break}else{Va=c[h>>2]|0;break}}}while(0);fa=(Va|0)==0;do{if((Ta|0)==0){Wa=Sa;X=243}else{if((c[Ta+12>>2]|0)!=(c[Ta+16>>2]|0)){if(fa){Xa=Sa;Ya=Ta;break}else{X=250;break a}}if((ge[c[(c[Ta>>2]|0)+36>>2]&127](Ta)|0)==-1){c[e>>2]=0;Wa=0;X=243;break}else{if(fa^(Sa|0)==0){Xa=Sa;Ya=Sa;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(fa){X=250;break a}else{Xa=Wa;Ya=0}}ga=c[h>>2]|0;ha=c[ga+12>>2]|0;if((ha|0)==(c[ga+16>>2]|0)){Za=(ge[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255}else{Za=a[ha]|0}if(!(Za<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(Za<<24>>24<<1)>>1]&2048)==0){X=250;break a}ha=c[o>>2]|0;if((ha|0)==(Ua|0)){ga=(c[P>>2]|0)!=488;ba=c[t>>2]|0;W=Ua-ba|0;qa=W>>>0<2147483647?W<<1:-1;ia=dec(ga?ba:0,qa)|0;if((ia|0)==0){X=253;break a}do{if(ga){c[t>>2]=ia;_a=ia}else{ba=c[t>>2]|0;c[t>>2]=ia;if((ba|0)==0){_a=ia;break}de[c[P>>2]&511](ba);_a=c[t>>2]|0}}while(0);c[P>>2]=463;ia=_a+W|0;c[o>>2]=ia;$a=ia;ab=(c[t>>2]|0)+qa|0}else{$a=ha;ab=Ua}ia=c[h>>2]|0;ga=c[ia+12>>2]|0;if((ga|0)==(c[ia+16>>2]|0)){fa=(ge[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)&255;bb=fa;cb=c[o>>2]|0}else{bb=a[ga]|0;cb=$a}c[o>>2]=cb+1;a[cb]=bb;ga=(c[B>>2]|0)+ -1|0;c[B>>2]=ga;fa=c[h>>2]|0;ia=fa+12|0;ba=c[ia>>2]|0;if((ba|0)==(c[fa+16>>2]|0)){ge[c[(c[fa>>2]|0)+40>>2]&127](fa)|0}else{c[ia>>2]=ba+1}if((ga|0)>0){Sa=Xa;Ta=Ya;Ua=ab}else{db=ab;break}}}else{db=da}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{eb=db;fb=Ga;gb=Ha;hb=Ia;ib=S;jb=Ja}break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){kb=(a[O]|0)!=0}else{kb=0}if(!(I|kb)){eb=D;fb=R;gb=r;hb=Q;ib=0;jb=T;break b}}ka=a[x]|0;ga=(ka&1)==0;ba=ga?j:c[J>>2]|0;d:do{if((p|0)==0){lb=Y;mb=Y;nb=ka;ob=ba}else{if((d[s+(p+ -1)|0]|0)>=2){lb=Y;mb=Y;nb=ka;ob=ba;break}ia=ba+(ga?(ka&255)>>>1:c[K>>2]|0)|0;fa=ba;while(1){if((fa|0)==(ia|0)){pb=ia;break}na=a[fa]|0;if(!(na<<24>>24>-1)){pb=fa;break}if((b[(c[f>>2]|0)+(na<<24>>24<<1)>>1]&8192)==0){pb=fa;break}else{fa=fa+1|0}}fa=pb-ba|0;ia=a[A]|0;ha=(ia&1)==0;if(ha){qb=(ia&255)>>>1}else{qb=c[N>>2]|0}if(fa>>>0>qb>>>0){lb=Y;mb=Y;nb=ka;ob=ba;break}if(ha){ha=(ia&255)>>>1;rb=A+1+(ha-fa)|0;sb=L;tb=ha}else{ha=c[M>>2]|0;ia=c[N>>2]|0;rb=ha+(ia-fa)|0;sb=ha;tb=ia}ia=sb+tb|0;if((rb|0)==(ia|0)){lb=Y;mb=Y;nb=ka;ob=pb;break}else{ub=ba;vb=rb}while(1){if((a[vb]|0)!=(a[ub]|0)){lb=Y;mb=Y;nb=ka;ob=ba;break d}ha=vb+1|0;if((ha|0)==(ia|0)){lb=Y;mb=Y;nb=ka;ob=pb;break}else{ub=ub+1|0;vb=ha}}}}while(0);e:while(1){if((nb&1)==0){wb=j;xb=(nb&255)>>>1}else{wb=c[J>>2]|0;xb=c[K>>2]|0}if((ob|0)==(wb+xb|0)){break}ka=c[h>>2]|0;do{if((ka|0)==0){yb=0}else{if((c[ka+12>>2]|0)!=(c[ka+16>>2]|0)){yb=ka;break}if((ge[c[(c[ka>>2]|0)+36>>2]&127](ka)|0)==-1){c[h>>2]=0;yb=0;break}else{yb=c[h>>2]|0;break}}}while(0);ka=(yb|0)==0;do{if((mb|0)==0){zb=lb;X=147}else{if((c[mb+12>>2]|0)!=(c[mb+16>>2]|0)){if(ka){Ab=lb;Bb=mb;break}else{break e}}if((ge[c[(c[mb>>2]|0)+36>>2]&127](mb)|0)==-1){c[e>>2]=0;zb=0;X=147;break}else{if(ka^(lb|0)==0){Ab=lb;Bb=lb;break}else{break e}}}}while(0);if((X|0)==147){X=0;if(ka){break}else{Ab=zb;Bb=0}}ba=c[h>>2]|0;ga=c[ba+12>>2]|0;if((ga|0)==(c[ba+16>>2]|0)){Cb=(ge[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)&255}else{Cb=a[ga]|0}if(!(Cb<<24>>24==(a[ob]|0))){break}ga=c[h>>2]|0;ba=ga+12|0;da=c[ba>>2]|0;if((da|0)==(c[ga+16>>2]|0)){ge[c[(c[ga>>2]|0)+40>>2]&127](ga)|0}else{c[ba>>2]=da+1}lb=Ab;mb=Bb;nb=a[x]|0;ob=ob+1|0}if(!I){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break b}da=a[x]|0;if((da&1)==0){Db=j;Eb=(da&255)>>>1}else{Db=c[J>>2]|0;Eb=c[K>>2]|0}if((ob|0)==(Db+Eb|0)){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T}else{X=162;break a}break};case 3:{da=a[y]|0;ba=(da&1)==0;if(ba){Fb=(da&255)>>>1}else{Fb=c[G>>2]|0}ga=a[z]|0;ia=(ga&1)==0;if(ia){Gb=(ga&255)>>>1}else{Gb=c[g>>2]|0}if((Fb|0)==(0-Gb|0)){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break b}if(ba){Hb=(da&255)>>>1}else{Hb=c[G>>2]|0}do{if((Hb|0)!=0){if(ia){Ib=(ga&255)>>>1}else{Ib=c[g>>2]|0}if((Ib|0)==0){break}ha=c[h>>2]|0;fa=c[ha+12>>2]|0;qa=c[ha+16>>2]|0;if((fa|0)==(qa|0)){W=(ge[c[(c[ha>>2]|0)+36>>2]&127](ha)|0)&255;na=c[h>>2]|0;Jb=W;Kb=c[na+16>>2]|0;Lb=c[na+12>>2]|0;Mb=na;Nb=a[y]|0}else{Jb=a[fa]|0;Kb=qa;Lb=fa;Mb=ha;Nb=da}ha=Mb+12|0;fa=(Lb|0)==(Kb|0);if(Jb<<24>>24==(a[(Nb&1)==0?F:c[H>>2]|0]|0)){if(fa){ge[c[(c[Mb>>2]|0)+40>>2]&127](Mb)|0}else{c[ha>>2]=Lb+1}ha=a[y]|0;if((ha&1)==0){Ob=(ha&255)>>>1}else{Ob=c[G>>2]|0}eb=D;fb=R;gb=r;hb=Q;ib=Ob>>>0>1?y:S;jb=T;break b}if(fa){Pb=(ge[c[(c[Mb>>2]|0)+36>>2]&127](Mb)|0)&255}else{Pb=a[Lb]|0}if(!(Pb<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}fa=c[h>>2]|0;ha=fa+12|0;qa=c[ha>>2]|0;if((qa|0)==(c[fa+16>>2]|0)){ge[c[(c[fa>>2]|0)+40>>2]&127](fa)|0}else{c[ha>>2]=qa+1}a[l]=1;qa=a[z]|0;if((qa&1)==0){Qb=(qa&255)>>>1}else{Qb=c[g>>2]|0}eb=D;fb=R;gb=r;hb=Q;ib=Qb>>>0>1?z:S;jb=T;break b}}while(0);if(ba){Rb=(da&255)>>>1}else{Rb=c[G>>2]|0}ia=c[h>>2]|0;qa=c[ia+12>>2]|0;ha=(qa|0)==(c[ia+16>>2]|0);if((Rb|0)==0){if(ha){fa=(ge[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)&255;Sb=fa;Tb=a[z]|0}else{Sb=a[qa]|0;Tb=ga}if(!(Sb<<24>>24==(a[(Tb&1)==0?m:c[E>>2]|0]|0))){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break b}fa=c[h>>2]|0;na=fa+12|0;W=c[na>>2]|0;if((W|0)==(c[fa+16>>2]|0)){ge[c[(c[fa>>2]|0)+40>>2]&127](fa)|0}else{c[na>>2]=W+1}a[l]=1;W=a[z]|0;if((W&1)==0){Ub=(W&255)>>>1}else{Ub=c[g>>2]|0}eb=D;fb=R;gb=r;hb=Q;ib=Ub>>>0>1?z:S;jb=T;break b}if(ha){ha=(ge[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)&255;Vb=ha;Wb=a[y]|0}else{Vb=a[qa]|0;Wb=da}if(!(Vb<<24>>24==(a[(Wb&1)==0?F:c[H>>2]|0]|0))){a[l]=1;eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break b}qa=c[h>>2]|0;ha=qa+12|0;ia=c[ha>>2]|0;if((ia|0)==(c[qa+16>>2]|0)){ge[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[ha>>2]=ia+1}ia=a[y]|0;if((ia&1)==0){Xb=(ia&255)>>>1}else{Xb=c[G>>2]|0}eb=D;fb=R;gb=r;hb=Q;ib=Xb>>>0>1?y:S;jb=T;break};default:{eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{Yb=Y;Zb=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){_b=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){_b=U;break}if((ge[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;_b=0;break}else{_b=c[h>>2]|0;break}}}while(0);U=(_b|0)==0;do{if((Zb|0)==0){$b=Yb;X=37}else{if((c[Zb+12>>2]|0)!=(c[Zb+16>>2]|0)){if(U){ac=Yb;bc=Zb;break}else{eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break f}}if((ge[c[(c[Zb>>2]|0)+36>>2]&127](Zb)|0)==-1){c[e>>2]=0;$b=0;X=37;break}else{if(U^(Yb|0)==0){ac=Yb;bc=Yb;break}else{eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break f}else{ac=$b;bc=0}}ka=c[h>>2]|0;ia=c[ka+12>>2]|0;if((ia|0)==(c[ka+16>>2]|0)){cc=(ge[c[(c[ka>>2]|0)+36>>2]&127](ka)|0)&255}else{cc=a[ia]|0}if(!(cc<<24>>24>-1)){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break f}if((b[(c[f>>2]|0)+(cc<<24>>24<<1)>>1]&8192)==0){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break f}ia=c[h>>2]|0;ka=ia+12|0;ha=c[ka>>2]|0;if((ha|0)==(c[ia+16>>2]|0)){dc=(ge[c[(c[ia>>2]|0)+40>>2]&127](ia)|0)&255}else{c[ka>>2]=ha+1;dc=a[ha]|0}n4b(A,dc);Yb=ac;Zb=bc}}}while(0);da=p+1|0;if(da>>>0<4){Q=hb;r=gb;R=fb;D=eb;p=da;S=ib;T=jb}else{Z=fb;_=gb;$=ib;aa=jb;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==182){nec()}else if((X|0)==198){nec()}else if((X|0)==209){nec()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;ec=0;fc=Ga;gc=Ja}else if((X|0)==250){c[k>>2]=c[k>>2]|4;ec=0;fc=Ga;gc=Ja}else if((X|0)==253){nec()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;ec=0;fc=Ga;gc=Ja}else if((X|0)==269){h:do{if(($|0)!=0){jb=$+1|0;ib=$+8|0;gb=$+4|0;fb=1;i:while(1){S=a[$]|0;if((S&1)==0){hc=(S&255)>>>1}else{hc=c[gb>>2]|0}if(!(fb>>>0<hc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){ic=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){ic=S;break}if((ge[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;ic=0;break}else{ic=c[h>>2]|0;break}}}while(0);S=(ic|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((ge[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){jc=(ge[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{jc=a[p]|0}if((a[$]&1)==0){kc=jb}else{kc=c[ib>>2]|0}if(!(jc<<24>>24==(a[kc+fb|0]|0))){break}p=fb+1|0;U=c[h>>2]|0;eb=U+12|0;D=c[eb>>2]|0;if((D|0)==(c[U+16>>2]|0)){ge[c[(c[U>>2]|0)+40>>2]&127](U)|0;fb=p;continue}else{c[eb>>2]=D+1;fb=p;continue}}c[k>>2]=c[k>>2]|4;ec=0;fc=Z;gc=aa;break g}}while(0);if((Z|0)==(_|0)){ec=1;fc=_;gc=aa;break}c[C>>2]=0;T9b(w,Z,_,C);if((c[C>>2]|0)==0){ec=1;fc=Z;gc=aa;break}c[k>>2]=c[k>>2]|4;ec=0;fc=Z;gc=aa}}while(0);X3b(A);X3b(z);X3b(y);X3b(x);X3b(w);if((fc|0)==0){i=q;return ec|0}de[gc&511](fc);i=q;return ec|0}function P9b(a){a=a|0;var b=0;b=Cc(8)|0;t3b(b,a);Rd(b|0,301760,42)}function Q9b(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=488;v=n+100|0;T4b(q,h);n=q;w=c[n>>2]|0;if(!((c[76192]|0)==-1)){c[m>>2]=304768;c[m+4>>2]=486;c[m+8>>2]=0;I3b(304768,m,487)}m=(c[304772>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Cc(4)|0;z=y;Hdc(z);A=320328;B=127;Rd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Cc(4)|0;z=y;Hdc(z);A=320328;B=127;Rd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=O9b(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){n4b(k,ue[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=ue[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);R9b(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((ge[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((ge[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;n3b(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}de[c[u>>2]&511](n);i=d;return}function R9b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){q4b(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function S9b(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[76052]|0)==-1)){c[p>>2]=304208;c[p+4>>2]=486;c[p+8>>2]=0;I3b(304208,p,487)}p=(c[304212>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Cc(4)|0;C=B;Hdc(C);D=320328;E=127;Rd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Cc(4)|0;C=B;Hdc(C);D=320328;E=127;Rd(B|0,D|0,E|0)}E=b;ee[c[(c[b>>2]|0)+44>>2]&63](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ee[c[(c[b>>2]|0)+32>>2]&63](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}h4b(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;X3b(r);ee[c[(c[b>>2]|0)+28>>2]&63](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}h4b(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;X3b(s);a[f]=ge[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=ge[c[(c[b>>2]|0)+16>>2]&127](E)|0;ee[c[(c[b>>2]|0)+20>>2]&63](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}h4b(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;X3b(t);ee[c[(c[b>>2]|0)+24>>2]&63](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}h4b(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;X3b(u);F=ge[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[76036]|0)==-1)){c[o>>2]=304144;c[o+4>>2]=486;c[o+8>>2]=0;I3b(304144,o,487)}o=(c[304148>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Cc(4)|0;H=G;Hdc(H);I=320328;J=127;Rd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Cc(4)|0;H=G;Hdc(H);I=320328;J=127;Rd(G|0,I|0,J|0)}J=E;ee[c[(c[E>>2]|0)+44>>2]&63](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ee[c[(c[E>>2]|0)+32>>2]&63](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}h4b(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;X3b(w);ee[c[(c[E>>2]|0)+28>>2]&63](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}h4b(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;X3b(x);a[f]=ge[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=ge[c[(c[E>>2]|0)+16>>2]&127](J)|0;ee[c[(c[E>>2]|0)+20>>2]&63](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}h4b(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;X3b(y);ee[c[(c[E>>2]|0)+24>>2]&63](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}h4b(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;X3b(z);F=ge[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function T9b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function U9b(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function V9b(a){a=a|0;i=i;return}function W9b(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=488;y=o+400|0;T4b(r,h);o=r;z=c[o>>2]|0;if(!((c[76190]|0)==-1)){c[n>>2]=304760;c[n+4>>2]=486;c[n+8>>2]=0;I3b(304760,n,487)}n=(c[304764>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Cc(4)|0;C=B;Hdc(C);D=320328;E=127;Rd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Cc(4)|0;C=B;Hdc(C);D=320328;E=127;Rd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=X9b(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;De[c[(c[z>>2]|0)+48>>2]&63](E,304464,304474|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=aec((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}nec()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[304464+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((vd(p|0,304400,m|0)|0)!=1){t=Cc(8)|0;t3b(t,304408);Rd(t|0,301760,42)}if((F|0)==0){break}bec(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=ge[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=ge[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];n3b(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}de[c[x>>2]&511](o);i=d;return}function X9b(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;_9b(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=488;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=ge[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=ge[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 3:{P=a[y]|0;R=(P&1)==0;if(R){_=(P&255)>>>1}else{_=c[D>>2]|0}$=a[z]|0;aa=($&1)==0;if(aa){ba=($&255)>>>1}else{ba=c[e>>2]|0}if((_|0)==(0-ba|0)){ca=M;da=r;ea=L;fa=N;ga=O;break b}if(R){ha=(P&255)>>>1}else{ha=c[D>>2]|0}do{if((ha|0)!=0){if(aa){ia=($&255)>>>1}else{ia=c[e>>2]|0}if((ia|0)==0){break}ja=c[g>>2]|0;ka=c[ja+12>>2]|0;if((ka|0)==(c[ja+16>>2]|0)){la=ge[c[(c[ja>>2]|0)+36>>2]&127](ja)|0;ma=la;na=a[y]|0}else{ma=c[ka>>2]|0;na=P}ka=c[g>>2]|0;la=ka+12|0;ja=c[la>>2]|0;oa=(ja|0)==(c[ka+16>>2]|0);if((ma|0)==(c[((na&1)==0?D:c[E>>2]|0)>>2]|0)){if(oa){ge[c[(c[ka>>2]|0)+40>>2]&127](ka)|0}else{c[la>>2]=ja+4}la=a[y]|0;if((la&1)==0){pa=(la&255)>>>1}else{pa=c[D>>2]|0}ca=M;da=r;ea=L;fa=pa>>>0>1?y:N;ga=O;break b}if(oa){qa=ge[c[(c[ka>>2]|0)+36>>2]&127](ka)|0}else{qa=c[ja>>2]|0}if((qa|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}ja=c[g>>2]|0;ka=ja+12|0;oa=c[ka>>2]|0;if((oa|0)==(c[ja+16>>2]|0)){ge[c[(c[ja>>2]|0)+40>>2]&127](ja)|0}else{c[ka>>2]=oa+4}a[k]=1;oa=a[z]|0;if((oa&1)==0){ra=(oa&255)>>>1}else{ra=c[e>>2]|0}ca=M;da=r;ea=L;fa=ra>>>0>1?z:N;ga=O;break b}}while(0);if(R){sa=(P&255)>>>1}else{sa=c[D>>2]|0}aa=c[g>>2]|0;oa=c[aa+12>>2]|0;ka=(oa|0)==(c[aa+16>>2]|0);if((sa|0)==0){if(ka){ja=ge[c[(c[aa>>2]|0)+36>>2]&127](aa)|0;ta=ja;ua=a[z]|0}else{ta=c[oa>>2]|0;ua=$}if((ta|0)!=(c[((ua&1)==0?e:c[f>>2]|0)>>2]|0)){ca=M;da=r;ea=L;fa=N;ga=O;break b}ja=c[g>>2]|0;la=ja+12|0;va=c[la>>2]|0;if((va|0)==(c[ja+16>>2]|0)){ge[c[(c[ja>>2]|0)+40>>2]&127](ja)|0}else{c[la>>2]=va+4}a[k]=1;va=a[z]|0;if((va&1)==0){wa=(va&255)>>>1}else{wa=c[e>>2]|0}ca=M;da=r;ea=L;fa=wa>>>0>1?z:N;ga=O;break b}if(ka){ka=ge[c[(c[aa>>2]|0)+36>>2]&127](aa)|0;xa=ka;ya=a[y]|0}else{xa=c[oa>>2]|0;ya=P}if((xa|0)!=(c[((ya&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;ca=M;da=r;ea=L;fa=N;ga=O;break b}oa=c[g>>2]|0;ka=oa+12|0;aa=c[ka>>2]|0;if((aa|0)==(c[oa+16>>2]|0)){ge[c[(c[oa>>2]|0)+40>>2]&127](oa)|0}else{c[ka>>2]=aa+4}aa=a[y]|0;if((aa&1)==0){za=(aa&255)>>>1}else{za=c[D>>2]|0}ca=M;da=r;ea=L;fa=za>>>0>1?y:N;ga=O;break};case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}aa=c[g>>2]|0;ka=c[aa+12>>2]|0;if((ka|0)==(c[aa+16>>2]|0)){Aa=ge[c[(c[aa>>2]|0)+36>>2]&127](aa)|0}else{Aa=c[ka>>2]|0}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,8192,Aa)|0)){T=27;break a}ka=c[g>>2]|0;aa=ka+12|0;oa=c[aa>>2]|0;if((oa|0)==(c[ka+16>>2]|0)){Ba=ge[c[(c[ka>>2]|0)+40>>2]&127](ka)|0}else{c[aa>>2]=oa+4;Ba=c[oa>>2]|0}D4b(A,Ba);T=28;break};case 0:{T=28;break};case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){Ca=(a[J]|0)!=0}else{Ca=0}if(!(F|Ca)){ca=M;da=r;ea=L;fa=0;ga=O;break b}}oa=a[x]|0;aa=(oa&1)==0?h:c[G>>2]|0;c:do{if((o|0)==0){Da=V;Ea=V;Fa=oa;Ga=aa}else{if((d[s+(o+ -1)|0]|0)<2){Ha=oa;Ia=aa}else{Da=V;Ea=V;Fa=oa;Ga=aa;break}while(1){if((Ha&1)==0){Ja=h;Ka=(Ha&255)>>>1}else{Ja=c[G>>2]|0;Ka=c[h>>2]|0}if((Ia|0)==(Ja+(Ka<<2)|0)){La=Ha;break}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[Ia>>2]|0)|0)){T=129;break}Ha=a[x]|0;Ia=Ia+4|0}if((T|0)==129){T=0;La=a[x]|0}ka=(La&1)==0;va=Ia-(ka?h:c[G>>2]|0)>>2;la=a[A]|0;ja=(la&1)==0;if(ja){Ma=(la&255)>>>1}else{Ma=c[H>>2]|0}d:do{if(!(va>>>0>Ma>>>0)){if(ja){Na=H+(((la&255)>>>1)-va<<2)|0;Oa=H;Pa=(la&255)>>>1}else{Qa=c[I>>2]|0;Ra=c[H>>2]|0;Na=Qa+(Ra-va<<2)|0;Oa=Qa;Pa=Ra}Ra=Oa+(Pa<<2)|0;if((Na|0)==(Ra|0)){Da=V;Ea=V;Fa=La;Ga=Ia;break c}else{Sa=ka?h:c[G>>2]|0;Ta=Na}while(1){if((c[Ta>>2]|0)!=(c[Sa>>2]|0)){break d}Qa=Ta+4|0;if((Qa|0)==(Ra|0)){Da=V;Ea=V;Fa=La;Ga=Ia;break c}Sa=Sa+4|0;Ta=Qa}}}while(0);Da=V;Ea=V;Fa=La;Ga=ka?h:c[G>>2]|0}}while(0);e:while(1){if((Fa&1)==0){Ua=h;Va=(Fa&255)>>>1}else{Ua=c[G>>2]|0;Va=c[h>>2]|0}if((Ga|0)==(Ua+(Va<<2)|0)){break}aa=c[g>>2]|0;do{if((aa|0)==0){Wa=1}else{oa=c[aa+12>>2]|0;if((oa|0)==(c[aa+16>>2]|0)){Xa=ge[c[(c[aa>>2]|0)+36>>2]&127](aa)|0}else{Xa=c[oa>>2]|0}if((Xa|0)==-1){c[g>>2]=0;Wa=1;break}else{Wa=(c[g>>2]|0)==0;break}}}while(0);do{if((Ea|0)==0){Ya=Da;T=159}else{aa=c[Ea+12>>2]|0;if((aa|0)==(c[Ea+16>>2]|0)){Za=ge[c[(c[Ea>>2]|0)+36>>2]&127](Ea)|0}else{Za=c[aa>>2]|0}if((Za|0)==-1){c[b>>2]=0;Ya=0;T=159;break}else{if(Wa^(Da|0)==0){_a=Da;$a=Da;break}else{break e}}}}while(0);if((T|0)==159){T=0;if(Wa){break}else{_a=Ya;$a=0}}aa=c[g>>2]|0;ka=c[aa+12>>2]|0;if((ka|0)==(c[aa+16>>2]|0)){ab=ge[c[(c[aa>>2]|0)+36>>2]&127](aa)|0}else{ab=c[ka>>2]|0}if((ab|0)!=(c[Ga>>2]|0)){break}ka=c[g>>2]|0;aa=ka+12|0;oa=c[aa>>2]|0;if((oa|0)==(c[ka+16>>2]|0)){ge[c[(c[ka>>2]|0)+40>>2]&127](ka)|0}else{c[aa>>2]=oa+4}Da=_a;Ea=$a;Fa=a[x]|0;Ga=Ga+4|0}if(!F){ca=M;da=r;ea=L;fa=N;ga=O;break b}oa=a[x]|0;if((oa&1)==0){bb=h;cb=(oa&255)>>>1}else{bb=c[G>>2]|0;cb=c[h>>2]|0}if((Ga|0)==(bb+(cb<<2)|0)){ca=M;da=r;ea=L;fa=N;ga=O}else{T=174;break a}break};case 4:{oa=M;aa=r;ka=L;P=0;$=O;f:while(1){R=c[g>>2]|0;do{if((R|0)==0){db=1}else{va=c[R+12>>2]|0;if((va|0)==(c[R+16>>2]|0)){eb=ge[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{eb=c[va>>2]|0}if((eb|0)==-1){c[g>>2]=0;db=1;break}else{db=(c[g>>2]|0)==0;break}}}while(0);R=c[b>>2]|0;do{if((R|0)==0){T=188}else{va=c[R+12>>2]|0;if((va|0)==(c[R+16>>2]|0)){fb=ge[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{fb=c[va>>2]|0}if((fb|0)==-1){c[b>>2]=0;T=188;break}else{if(db){break}else{break f}}}}while(0);if((T|0)==188){T=0;if(db){break}}R=c[g>>2]|0;va=c[R+12>>2]|0;if((va|0)==(c[R+16>>2]|0)){gb=ge[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{gb=c[va>>2]|0}if(le[c[(c[l>>2]|0)+12>>2]&63](l,2048,gb)|0){va=c[n>>2]|0;if((va|0)==(c[q>>2]|0)){$9b(m,n,q);hb=c[n>>2]|0}else{hb=va}c[n>>2]=hb+4;c[hb>>2]=gb;ib=oa;jb=aa;kb=ka;lb=P+1|0;mb=$}else{va=a[w]|0;if((va&1)==0){nb=(va&255)>>>1}else{nb=c[K>>2]|0}if((nb|0)==0|(P|0)==0){break}if((gb|0)!=(c[v>>2]|0)){break}if((aa|0)==(ka|0)){va=aa-oa|0;R=va>>>0<2147483647?va<<1:-1;if(($|0)!=488){ob=oa}else{ob=0}la=dec(ob,R)|0;if((la|0)==0){T=206;break a}pb=la;qb=la+(va>>2<<2)|0;rb=la+(R>>>2<<2)|0;sb=463}else{pb=oa;qb=aa;rb=ka;sb=$}c[qb>>2]=P;ib=pb;jb=qb+4|0;kb=rb;lb=0;mb=sb}R=c[g>>2]|0;la=R+12|0;va=c[la>>2]|0;if((va|0)==(c[R+16>>2]|0)){ge[c[(c[R>>2]|0)+40>>2]&127](R)|0;oa=ib;aa=jb;ka=kb;P=lb;$=mb;continue}else{c[la>>2]=va+4;oa=ib;aa=jb;ka=kb;P=lb;$=mb;continue}}if((oa|0)==(aa|0)|(P|0)==0){tb=oa;ub=aa;vb=ka;wb=$}else{if((aa|0)==(ka|0)){va=aa-oa|0;la=va>>>0<2147483647?va<<1:-1;if(($|0)!=488){xb=oa}else{xb=0}R=dec(xb,la)|0;if((R|0)==0){T=217;break a}yb=R;zb=R+(va>>2<<2)|0;Ab=R+(la>>>2<<2)|0;Bb=463}else{yb=oa;zb=aa;Ab=ka;Bb=$}c[zb>>2]=P;tb=yb;ub=zb+4|0;vb=Ab;wb=Bb}la=c[B>>2]|0;if((la|0)>0){R=c[g>>2]|0;do{if((R|0)==0){Cb=1}else{va=c[R+12>>2]|0;if((va|0)==(c[R+16>>2]|0)){Db=ge[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Db=c[va>>2]|0}if((Db|0)==-1){c[g>>2]=0;Cb=1;break}else{Cb=(c[g>>2]|0)==0;break}}}while(0);R=c[b>>2]|0;do{if((R|0)==0){T=234}else{P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){Eb=ge[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Eb=c[P>>2]|0}if((Eb|0)==-1){c[b>>2]=0;T=234;break}else{if(Cb){Fb=R;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(Cb){T=240;break a}else{Fb=0}}R=c[g>>2]|0;P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){Gb=ge[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Gb=c[P>>2]|0}if((Gb|0)!=(c[u>>2]|0)){T=240;break a}P=c[g>>2]|0;R=P+12|0;$=c[R>>2]|0;if(($|0)==(c[P+16>>2]|0)){ge[c[(c[P>>2]|0)+40>>2]&127](P)|0;Hb=Fb;Ib=la;Jb=Fb}else{c[R>>2]=$+4;Hb=Fb;Ib=la;Jb=Fb}while(1){$=c[g>>2]|0;do{if(($|0)==0){Kb=1}else{R=c[$+12>>2]|0;if((R|0)==(c[$+16>>2]|0)){Lb=ge[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{Lb=c[R>>2]|0}if((Lb|0)==-1){c[g>>2]=0;Kb=1;break}else{Kb=(c[g>>2]|0)==0;break}}}while(0);do{if((Jb|0)==0){Mb=Hb;T=257}else{$=c[Jb+12>>2]|0;if(($|0)==(c[Jb+16>>2]|0)){Nb=ge[c[(c[Jb>>2]|0)+36>>2]&127](Jb)|0}else{Nb=c[$>>2]|0}if((Nb|0)==-1){c[b>>2]=0;Mb=0;T=257;break}else{if(Kb^(Hb|0)==0){Ob=Hb;Pb=Hb;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(Kb){T=263;break a}else{Ob=Mb;Pb=0}}$=c[g>>2]|0;R=c[$+12>>2]|0;if((R|0)==(c[$+16>>2]|0)){Qb=ge[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{Qb=c[R>>2]|0}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,2048,Qb)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){$9b(m,n,q)}R=c[g>>2]|0;$=c[R+12>>2]|0;if(($|0)==(c[R+16>>2]|0)){Rb=ge[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Rb=c[$>>2]|0}$=c[n>>2]|0;c[n>>2]=$+4;c[$>>2]=Rb;$=Ib+ -1|0;c[B>>2]=$;R=c[g>>2]|0;P=R+12|0;ka=c[P>>2]|0;if((ka|0)==(c[R+16>>2]|0)){ge[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[P>>2]=ka+4}if(($|0)>0){Hb=Ob;Ib=$;Jb=Pb}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{ca=tb;da=ub;ea=vb;fa=N;ga=wb}break};default:{ca=M;da=r;ea=L;fa=N;ga=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Sb=V;Tb=V}while(1){la=c[g>>2]|0;do{if((la|0)==0){Ub=1}else{$=c[la+12>>2]|0;if(($|0)==(c[la+16>>2]|0)){Vb=ge[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{Vb=c[$>>2]|0}if((Vb|0)==-1){c[g>>2]=0;Ub=1;break}else{Ub=(c[g>>2]|0)==0;break}}}while(0);do{if((Tb|0)==0){Wb=Sb;T=42}else{la=c[Tb+12>>2]|0;if((la|0)==(c[Tb+16>>2]|0)){Xb=ge[c[(c[Tb>>2]|0)+36>>2]&127](Tb)|0}else{Xb=c[la>>2]|0}if((Xb|0)==-1){c[b>>2]=0;Wb=0;T=42;break}else{if(Ub^(Sb|0)==0){Yb=Sb;Zb=Sb;break}else{ca=M;da=r;ea=L;fa=N;ga=O;break g}}}}while(0);if((T|0)==42){T=0;if(Ub){ca=M;da=r;ea=L;fa=N;ga=O;break g}else{Yb=Wb;Zb=0}}la=c[g>>2]|0;$=c[la+12>>2]|0;if(($|0)==(c[la+16>>2]|0)){_b=ge[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{_b=c[$>>2]|0}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,8192,_b)|0)){ca=M;da=r;ea=L;fa=N;ga=O;break g}$=c[g>>2]|0;la=$+12|0;ka=c[la>>2]|0;if((ka|0)==(c[$+16>>2]|0)){$b=ge[c[(c[$>>2]|0)+40>>2]&127]($)|0}else{c[la>>2]=ka+4;$b=c[ka>>2]|0}D4b(A,$b);Sb=Yb;Tb=Zb}}}while(0);ka=o+1|0;if(ka>>>0<4){L=ea;r=da;M=ca;o=ka;N=fa;O=ga}else{W=ca;X=da;Y=fa;Z=ga;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==206){nec()}else if((T|0)==217){nec()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;ac=0;bc=tb;cc=wb}else if((T|0)==263){c[j>>2]=c[j>>2]|4;ac=0;bc=tb;cc=wb}else if((T|0)==274){c[j>>2]=c[j>>2]|4;ac=0;bc=tb;cc=wb}else if((T|0)==276){i:do{if((Y|0)!=0){ga=Y+4|0;fa=Y+8|0;da=1;j:while(1){ca=a[Y]|0;if((ca&1)==0){dc=(ca&255)>>>1}else{dc=c[ga>>2]|0}if(!(da>>>0<dc>>>0)){break i}ca=c[g>>2]|0;do{if((ca|0)==0){ec=1}else{N=c[ca+12>>2]|0;if((N|0)==(c[ca+16>>2]|0)){fc=ge[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{fc=c[N>>2]|0}if((fc|0)==-1){c[g>>2]=0;ec=1;break}else{ec=(c[g>>2]|0)==0;break}}}while(0);ca=c[b>>2]|0;do{if((ca|0)==0){T=295}else{N=c[ca+12>>2]|0;if((N|0)==(c[ca+16>>2]|0)){gc=ge[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{gc=c[N>>2]|0}if((gc|0)==-1){c[b>>2]=0;T=295;break}else{if(ec){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(ec){break}}ca=c[g>>2]|0;N=c[ca+12>>2]|0;if((N|0)==(c[ca+16>>2]|0)){hc=ge[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{hc=c[N>>2]|0}if((a[Y]&1)==0){ic=ga}else{ic=c[fa>>2]|0}if((hc|0)!=(c[ic+(da<<2)>>2]|0)){break}N=da+1|0;ca=c[g>>2]|0;o=ca+12|0;r=c[o>>2]|0;if((r|0)==(c[ca+16>>2]|0)){ge[c[(c[ca>>2]|0)+40>>2]&127](ca)|0;da=N;continue}else{c[o>>2]=r+4;da=N;continue}}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z;break h}}while(0);if((W|0)==(X|0)){ac=1;bc=X;cc=Z;break}c[C>>2]=0;T9b(w,W,X,C);if((c[C>>2]|0)==0){ac=1;bc=W;cc=Z;break}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z}}while(0);z4b(A);z4b(z);z4b(y);z4b(x);X3b(w);if((bc|0)==0){i=p;return ac|0}de[cc&511](bc);i=p;return ac|0}function Y9b(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=488;v=n+400|0;T4b(q,h);n=q;w=c[n>>2]|0;if(!((c[76190]|0)==-1)){c[m>>2]=304760;c[m+4>>2]=486;c[m+8>>2]=0;I3b(304760,m,487)}m=(c[304764>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Cc(4)|0;z=y;Hdc(z);A=320328;B=127;Rd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Cc(4)|0;z=y;Hdc(z);A=320328;B=127;Rd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=X9b(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){D4b(k,ue[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=ue[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);Z9b(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=ge[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=ge[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];n3b(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}de[c[u>>2]&511](n);i=d;return}function Z9b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){F4b(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function _9b(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[76084]|0)==-1)){c[p>>2]=304336;c[p+4>>2]=486;c[p+8>>2]=0;I3b(304336,p,487)}p=(c[304340>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Cc(4)|0;C=B;Hdc(C);D=320328;E=127;Rd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Cc(4)|0;C=B;Hdc(C);D=320328;E=127;Rd(B|0,D|0,E|0)}E=b;ee[c[(c[b>>2]|0)+44>>2]&63](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ee[c[(c[b>>2]|0)+32>>2]&63](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}C4b(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;z4b(r);ee[c[(c[b>>2]|0)+28>>2]&63](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}C4b(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;z4b(s);c[f>>2]=ge[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=ge[c[(c[b>>2]|0)+16>>2]&127](E)|0;ee[c[(c[b>>2]|0)+20>>2]&63](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}h4b(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;X3b(t);ee[c[(c[b>>2]|0)+24>>2]&63](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}C4b(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;z4b(u);F=ge[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[76068]|0)==-1)){c[o>>2]=304272;c[o+4>>2]=486;c[o+8>>2]=0;I3b(304272,o,487)}o=(c[304276>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Cc(4)|0;H=G;Hdc(H);I=320328;J=127;Rd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Cc(4)|0;H=G;Hdc(H);I=320328;J=127;Rd(G|0,I|0,J|0)}J=E;ee[c[(c[E>>2]|0)+44>>2]&63](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ee[c[(c[E>>2]|0)+32>>2]&63](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}C4b(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;z4b(w);ee[c[(c[E>>2]|0)+28>>2]&63](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}C4b(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;z4b(x);c[f>>2]=ge[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=ge[c[(c[E>>2]|0)+16>>2]&127](J)|0;ee[c[(c[E>>2]|0)+20>>2]&63](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}h4b(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;X3b(y);ee[c[(c[E>>2]|0)+24>>2]&63](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}C4b(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;z4b(z);F=ge[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function $9b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=488;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=dec(m,l)|0;m=a;if((a|0)==0){nec()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}de[c[f>>2]&511](a);n=c[h>>2]|0}}while(0);c[f>>2]=463;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function aac(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function bac(a){a=a|0;i=i;return}function cac(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Kc(G|0,100,304520,o|0)|0;do{if(s>>>0>99){do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);o=c[76164]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=W7b(r,o,304520,n)|0;o=c[r>>2]|0;if((o|0)==0){nec()}H=aec(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}nec()}else{I=0;J=0;K=q;L=s}}while(0);T4b(t,g);s=t;q=c[s>>2]|0;if(!((c[76192]|0)==-1)){c[p>>2]=304768;c[p+4>>2]=486;c[p+8>>2]=0;I3b(304768,p,487)}p=(c[304772>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Cc(4)|0;N=M;Hdc(N);O=320328;P=127;Rd(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Cc(4)|0;N=M;Hdc(N);O=320328;P=127;Rd(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;De[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;dac(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=aec(V)|0;if((T|0)!=0){W=T;X=T;break}nec()}else{W=0;X=t}}while(0);eac(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];u0b(b,m,X,e,D,g,j);if((W|0)!=0){bec(W)}X3b(A);X3b(z);X3b(y);n3b(c[s>>2]|0)|0;if((J|0)!=0){bec(J)}if((I|0)==0){i=d;return}bec(I);i=d;return}function dac(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[76052]|0)==-1)){c[p>>2]=304208;c[p+4>>2]=486;c[p+8>>2]=0;I3b(304208,p,487)}p=(c[304212>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Cc(4)|0;I=H;Hdc(I);J=320328;K=127;Rd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Cc(4)|0;I=H;Hdc(I);J=320328;K=127;Rd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ee[c[J+44>>2]&63](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ee[c[(c[e>>2]|0)+32>>2]&63](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}h4b(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;X3b(s)}else{ee[c[J+40>>2]&63](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ee[c[(c[e>>2]|0)+28>>2]&63](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}h4b(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;X3b(v)}a[g]=ge[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=ge[c[(c[e>>2]|0)+16>>2]&127](K)|0;ee[c[(c[e>>2]|0)+20>>2]&63](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}h4b(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;X3b(w);ee[c[(c[e>>2]|0)+24>>2]&63](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}h4b(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;X3b(x);L=ge[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[76036]|0)==-1)){c[o>>2]=304144;c[o+4>>2]=486;c[o+8>>2]=0;I3b(304144,o,487)}o=(c[304148>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Cc(4)|0;N=M;Hdc(N);O=320328;P=127;Rd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Cc(4)|0;N=M;Hdc(N);O=320328;P=127;Rd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ee[c[O+44>>2]&63](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ee[c[(c[G>>2]|0)+32>>2]&63](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}h4b(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;X3b(A)}else{ee[c[O+40>>2]&63](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ee[c[(c[G>>2]|0)+28>>2]&63](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}h4b(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;X3b(D)}a[g]=ge[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=ge[c[(c[G>>2]|0)+16>>2]&127](P)|0;ee[c[(c[G>>2]|0)+20>>2]&63](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}h4b(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;X3b(E);ee[c[(c[G>>2]|0)+24>>2]&63](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}h4b(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;X3b(F);L=ge[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function eac(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 4:{I=c[f>>2]|0;J=l?H+1|0:H;b:do{if(J>>>0<j>>>0){K=J;while(1){L=a[K]|0;if(!(L<<24>>24>-1)){M=K;break b}N=K+1|0;if((b[(c[F>>2]|0)+(L<<24>>24<<1)>>1]&2048)==0){M=K;break b}if(N>>>0<j>>>0){K=N}else{M=N;break}}}else{M=J}}while(0);K=M;if(B){if(M>>>0>J>>>0){N=J+(0-K)|0;K=N>>>0<G>>>0?G:N;N=K+s|0;L=I;O=M;P=s;while(1){Q=O+ -1|0;R=a[Q]|0;c[f>>2]=L+1;a[L]=R;R=P+ -1|0;S=(R|0)>0;if(!(Q>>>0>J>>>0&S)){break}L=c[f>>2]|0;P=R;O=Q}O=M+K|0;if(S){T=O;U=N;V=32}else{W=0;X=O;Y=N}}else{T=M;U=s;V=32}if((V|0)==32){V=0;W=ue[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;X=T;Y=U}O=c[f>>2]|0;c[f>>2]=O+1;if((Y|0)>0){P=O;L=Y;while(1){a[P]=W;Q=L+ -1|0;R=c[f>>2]|0;c[f>>2]=R+1;if((Q|0)>0){L=Q;P=R}else{Z=R;break}}}else{Z=O}a[Z]=n;_=X}else{_=M}if((_|0)==(J|0)){P=ue[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;L=c[f>>2]|0;c[f>>2]=L+1;a[L]=P}else{P=a[p]|0;L=(P&1)==0;if(L){$=(P&255)>>>1}else{$=c[E>>2]|0}if(($|0)==0){aa=_;ba=-1;ca=0;da=0}else{if(L){ea=C}else{ea=c[D>>2]|0}aa=_;ba=a[ea]|0;ca=0;da=0}while(1){do{if((da|0)==(ba|0)){L=c[f>>2]|0;c[f>>2]=L+1;a[L]=o;L=ca+1|0;P=a[p]|0;N=(P&1)==0;if(N){fa=(P&255)>>>1}else{fa=c[E>>2]|0}if(!(L>>>0<fa>>>0)){ga=ba;ha=L;ia=0;break}if(N){ja=C}else{ja=c[D>>2]|0}if((a[ja+L|0]|0)==127){ga=-1;ha=L;ia=0;break}if(N){ka=C}else{ka=c[D>>2]|0}ga=a[ka+L|0]|0;ha=L;ia=0}else{ga=ba;ha=ca;ia=da}}while(0);L=aa+ -1|0;N=a[L]|0;P=c[f>>2]|0;c[f>>2]=P+1;a[P]=N;if((L|0)==(J|0)){break}else{aa=L;ba=ga;ca=ha;da=ia+1|0}}}O=c[f>>2]|0;if((I|0)==(O|0)){la=J;break a}L=O+ -1|0;if(L>>>0>I>>>0){ma=I;na=L}else{la=J;break a}while(1){L=a[ma]|0;a[ma]=a[na]|0;a[na]=L;L=ma+1|0;O=na+ -1|0;if(L>>>0<O>>>0){na=O;ma=L}else{la=J;break}}break};case 1:{c[e>>2]=c[f>>2];J=ue[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;I=c[f>>2]|0;c[f>>2]=I+1;a[I]=J;la=H;break};case 0:{c[e>>2]=c[f>>2];la=H;break};case 2:{J=a[q]|0;I=(J&1)==0;if(I){oa=(J&255)>>>1}else{oa=c[A>>2]|0}if((oa|0)==0|x){la=H;break a}if(I){pa=y;qa=(J&255)>>>1}else{pa=c[z>>2]|0;qa=c[A>>2]|0}J=pa+qa|0;I=c[f>>2]|0;if((pa|0)==(J|0)){ra=I}else{L=I;I=pa;while(1){a[L]=a[I]|0;O=I+1|0;N=L+1|0;if((O|0)==(J|0)){ra=N;break}else{I=O;L=N}}}c[f>>2]=ra;la=H;break};case 3:{L=a[r]|0;I=(L&1)==0;if(I){sa=(L&255)>>>1}else{sa=c[w>>2]|0}if((sa|0)==0){la=H;break a}if(I){ta=u}else{ta=c[v>>2]|0}I=a[ta]|0;L=c[f>>2]|0;c[f>>2]=L+1;a[L]=I;la=H;break};default:{la=H}}}while(0);I=h+1|0;if(I>>>0<4){H=la;h=I}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else if((xa|0)==16){i=t;return}else{c[e>>2]=d;i=t;return}}function fac(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;T4b(m,g);z=m;A=c[z>>2]|0;if(!((c[76192]|0)==-1)){c[l>>2]=304768;c[l+4>>2]=486;c[l+8>>2]=0;I3b(304768,l,487)}l=(c[304772>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Cc(4)|0;D=C;Hdc(D);E=320328;F=127;Rd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Cc(4)|0;D=C;Hdc(D);E=320328;F=127;Rd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(ue[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;dac(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=aec(P)|0;if((N|0)!=0){Q=N;R=N;break}nec()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}eac(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];u0b(b,k,R,e,w,g,h);if((Q|0)==0){X3b(t);X3b(s);X3b(r);U=c[z>>2]|0;V=U;W=V;X=n3b(W)|0;i=d;return}bec(Q);X3b(t);X3b(s);X3b(r);U=c[z>>2]|0;V=U;W=V;X=n3b(W)|0;i=d;return}function gac(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function hac(a){a=a|0;i=i;return}function iac(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Kc(G|0,100,304520,o|0)|0;do{if(s>>>0>99){do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);o=c[76164]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=W7b(r,o,304520,n)|0;o=c[r>>2]|0;if((o|0)==0){nec()}H=aec(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}nec()}else{J=0;K=0;L=q;M=s}}while(0);T4b(t,g);s=t;q=c[s>>2]|0;if(!((c[76190]|0)==-1)){c[p>>2]=304760;c[p+4>>2]=486;c[p+8>>2]=0;I3b(304760,p,487)}p=(c[304764>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Cc(4)|0;O=N;Hdc(O);P=320328;Q=127;Rd(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Cc(4)|0;O=N;Hdc(O);P=320328;Q=127;Rd(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;De[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;jac(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=aec(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}nec()}else{X=0;Y=t}}while(0);kac(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];d8b(b,m,Y,e,D,g,j);if((X|0)!=0){bec(X)}z4b(A);z4b(z);X3b(y);n3b(c[s>>2]|0)|0;if((K|0)!=0){bec(K)}if((J|0)==0){i=d;return}bec(J);i=d;return}function jac(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[76084]|0)==-1)){c[p>>2]=304336;c[p+4>>2]=486;c[p+8>>2]=0;I3b(304336,p,487)}p=(c[304340>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Cc(4)|0;I=H;Hdc(I);J=320328;K=127;Rd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Cc(4)|0;I=H;Hdc(I);J=320328;K=127;Rd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ee[c[J+44>>2]&63](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ee[c[(c[e>>2]|0)+32>>2]&63](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}C4b(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;z4b(s)}else{ee[c[J+40>>2]&63](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ee[c[(c[e>>2]|0)+28>>2]&63](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}C4b(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;z4b(v)}c[g>>2]=ge[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=ge[c[(c[e>>2]|0)+16>>2]&127](K)|0;ee[c[(c[e>>2]|0)+20>>2]&63](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}h4b(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;X3b(w);ee[c[(c[e>>2]|0)+24>>2]&63](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}C4b(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;z4b(x);L=ge[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[76068]|0)==-1)){c[o>>2]=304272;c[o+4>>2]=486;c[o+8>>2]=0;I3b(304272,o,487)}o=(c[304276>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Cc(4)|0;N=M;Hdc(N);O=320328;P=127;Rd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Cc(4)|0;N=M;Hdc(N);O=320328;P=127;Rd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ee[c[O+44>>2]&63](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ee[c[(c[G>>2]|0)+32>>2]&63](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}C4b(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;z4b(A)}else{ee[c[O+40>>2]&63](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ee[c[(c[G>>2]|0)+28>>2]&63](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}C4b(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;z4b(D)}c[g>>2]=ge[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=ge[c[(c[G>>2]|0)+16>>2]&127](P)|0;ee[c[(c[G>>2]|0)+20>>2]&63](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}h4b(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;X3b(E);ee[c[(c[G>>2]|0)+24>>2]&63](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}C4b(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;z4b(F);L=ge[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function kac(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 2:{D=a[p]|0;E=(D&1)==0;if(E){F=(D&255)>>>1}else{F=c[w>>2]|0}if((F|0)==0|v){G=C;break a}if(E){H=w;I=(D&255)>>>1}else{H=c[x>>2]|0;I=c[w>>2]|0}D=H+(I<<2)|0;E=c[e>>2]|0;if((H|0)==(D|0)){J=E}else{K=(H+(I+ -1<<2)+(0-H)|0)>>>2;L=E;M=H;while(1){c[L>>2]=c[M>>2];N=M+4|0;if((N|0)==(D|0)){break}L=L+4|0;M=N}J=E+(K+1<<2)|0}c[e>>2]=J;G=C;break};case 3:{M=a[q]|0;L=(M&1)==0;if(L){O=(M&255)>>>1}else{O=c[t>>2]|0}if((O|0)==0){G=C;break a}if(L){P=t}else{P=c[u>>2]|0}L=c[P>>2]|0;M=c[e>>2]|0;c[e>>2]=M+4;c[M>>2]=L;G=C;break};case 1:{c[d>>2]=c[e>>2];L=ue[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;M=c[e>>2]|0;c[e>>2]=M+4;c[M>>2]=L;G=C;break};case 0:{c[d>>2]=c[e>>2];G=C;break};case 4:{L=c[e>>2]|0;M=k?C+4|0:C;b:do{if(M>>>0<h>>>0){D=M;while(1){N=D+4|0;if(!(le[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[D>>2]|0)|0)){Q=D;break b}if(N>>>0<h>>>0){D=N}else{Q=N;break}}}else{Q=M}}while(0);if(y){do{if(Q>>>0>M>>>0){K=c[e>>2]|0;E=Q;D=r;while(1){R=E+ -4|0;S=K+4|0;c[K>>2]=c[R>>2];T=D+ -1|0;U=(T|0)>0;if(R>>>0>M>>>0&U){D=T;E=R;K=S}else{break}}c[e>>2]=S;if(U){V=R;W=T;X=34;break}K=c[e>>2]|0;c[e>>2]=K+4;Y=K;Z=R}else{V=Q;W=r;X=34}}while(0);do{if((X|0)==34){X=0;K=ue[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;E=c[e>>2]|0;D=E+4|0;c[e>>2]=D;if((W|0)>0){_=D;$=E;aa=W}else{Y=E;Z=V;break}while(1){c[$>>2]=K;D=aa+ -1|0;if((D|0)>0){aa=D;$=_;_=_+4|0}else{break}}c[e>>2]=E+(W+1<<2);Y=E+(W<<2)|0;Z=V}}while(0);c[Y>>2]=m;ba=Z}else{ba=Q}if((ba|0)==(M|0)){K=ue[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;D=c[e>>2]|0;N=D+4|0;c[e>>2]=N;c[D>>2]=K;ca=N}else{N=a[o]|0;K=(N&1)==0;if(K){da=(N&255)>>>1}else{da=c[B>>2]|0}if((da|0)==0){ea=ba;fa=-1;ga=0;ha=0}else{if(K){ia=z}else{ia=c[A>>2]|0}ea=ba;fa=a[ia]|0;ga=0;ha=0}while(1){K=c[e>>2]|0;do{if((ha|0)==(fa|0)){N=K+4|0;c[e>>2]=N;c[K>>2]=n;D=ga+1|0;ja=a[o]|0;ka=(ja&1)==0;if(ka){la=(ja&255)>>>1}else{la=c[B>>2]|0}if(!(D>>>0<la>>>0)){ma=N;na=fa;oa=D;pa=0;break}if(ka){qa=z}else{qa=c[A>>2]|0}if((a[qa+D|0]|0)==127){ma=N;na=-1;oa=D;pa=0;break}if(ka){ra=z}else{ra=c[A>>2]|0}ma=N;na=a[ra+D|0]|0;oa=D;pa=0}else{ma=K;na=fa;oa=ga;pa=ha}}while(0);K=ea+ -4|0;E=c[K>>2]|0;D=ma+4|0;c[e>>2]=D;c[ma>>2]=E;if((K|0)==(M|0)){ca=D;break}else{ea=K;fa=na;ga=oa;ha=pa+1|0}}}if((L|0)==(ca|0)){G=M;break a}K=ca+ -4|0;if(K>>>0>L>>>0){sa=L;ta=K}else{G=M;break a}while(1){K=c[sa>>2]|0;c[sa>>2]=c[ta>>2];c[ta>>2]=K;K=sa+4|0;D=ta+ -4|0;if(K>>>0<D>>>0){ta=D;sa=K}else{G=M;break}}break};default:{G=C}}}while(0);M=g+1|0;if(M>>>0<4){C=G;g=M}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else if((xa|0)==16){i=s;return}else{c[d>>2]=b;i=s;return}}function lac(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;T4b(m,g);z=m;A=c[z>>2]|0;if(!((c[76190]|0)==-1)){c[l>>2]=304760;c[l+4>>2]=486;c[l+8>>2]=0;I3b(304760,l,487)}l=(c[304764>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Cc(4)|0;D=C;Hdc(D);E=320328;F=127;Rd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Cc(4)|0;D=C;Hdc(D);E=320328;F=127;Rd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(ue[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;jac(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=aec(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}nec()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}kac(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];d8b(b,k,R,e,w,g,h);if((Q|0)==0){z4b(t);z4b(s);X3b(r);U=c[z>>2]|0;V=U;W=V;X=n3b(W)|0;i=d;return}bec(Q);z4b(t);z4b(s);X3b(r);U=c[z>>2]|0;V=U;W=V;X=n3b(W)|0;i=d;return}function mac(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function nac(a){a=a|0;i=i;return}function oac(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=sc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function pac(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{n4b(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=wd(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=Eec(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{X3b(j);i=d;return}do{n4b(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);X3b(j);i=d;return}function qac(a,b){a=a|0;b=b|0;a=i;Fb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function rac(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function sac(a){a=a|0;i=i;return}function tac(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=sc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function uac(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=306424;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=306424|0;while(1){c[m>>2]=y;A=(Ce[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{n4b(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}P9b(305648)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=wd(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=306528;D=Eec(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){X3b(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=306528|0;while(1){c[q>>2]=o;h=(Ce[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{D4b(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){P9b(305648)}else if((E|0)==25){X3b(r);i=d;return}}function vac(a,b){a=a|0;b=b|0;a=i;Fb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function wac(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=304856;e=b+8|0;b=c[e>>2]|0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);if((b|0)==(c[76164]|0)){i=d;return}_b(c[e>>2]|0);i=d;return}function xac(a){a=a|0;a=Cc(8)|0;o3b(a,304648);c[a>>2]=301616;Rd(a|0,301656,40)}function yac(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=304688;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);P3b(b+144|0,304672,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[309580>>2]=0;c[77394]=303168;if(!((c[75798]|0)==-1)){c[G>>2]=303192;c[G+4>>2]=486;c[G+8>>2]=0;I3b(303192,G,487)}zac(b,309576,(c[303196>>2]|0)+ -1|0);c[309572>>2]=0;c[77392]=303208;if(!((c[75808]|0)==-1)){c[F>>2]=303232;c[F+4>>2]=486;c[F+8>>2]=0;I3b(303232,F,487)}zac(b,309568,(c[303236>>2]|0)+ -1|0);c[309556>>2]=0;c[77388]=304784;c[309560>>2]=0;a[309564|0]=0;F=c[(wc()|0)>>2]|0;c[309560>>2]=F;if(!((c[76192]|0)==-1)){c[E>>2]=304768;c[E+4>>2]=486;c[E+8>>2]=0;I3b(304768,E,487)}zac(b,309552,(c[304772>>2]|0)+ -1|0);c[309548>>2]=0;c[77386]=305744;if(!((c[76190]|0)==-1)){c[D>>2]=304760;c[D+4>>2]=486;c[D+8>>2]=0;I3b(304760,D,487)}zac(b,309544,(c[304764>>2]|0)+ -1|0);c[309540>>2]=0;c[77384]=305960;if(!((c[76208]|0)==-1)){c[C>>2]=304832;c[C+4>>2]=486;c[C+8>>2]=0;I3b(304832,C,487)}zac(b,309536,(c[304836>>2]|0)+ -1|0);c[309524>>2]=0;c[77380]=304856;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);c[309528>>2]=c[76164];if(!((c[76210]|0)==-1)){c[B>>2]=304840;c[B+4>>2]=486;c[B+8>>2]=0;I3b(304840,B,487)}zac(b,309520,(c[304844>>2]|0)+ -1|0);c[309516>>2]=0;c[77378]=306184;if(!((c[76224]|0)==-1)){c[A>>2]=304896;c[A+4>>2]=486;c[A+8>>2]=0;I3b(304896,A,487)}zac(b,309512,(c[304900>>2]|0)+ -1|0);c[309508>>2]=0;c[77376]=306304;if(!((c[76226]|0)==-1)){c[z>>2]=304904;c[z+4>>2]=486;c[z+8>>2]=0;I3b(304904,z,487)}zac(b,309504,(c[304908>>2]|0)+ -1|0);c[309484>>2]=0;c[77370]=304936;a[309488|0]=46;a[309489|0]=44;z=309492|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[76228]|0)==-1)){c[y>>2]=304912;c[y+4>>2]=486;c[y+8>>2]=0;I3b(304912,y,487)}zac(b,309480,(c[304916>>2]|0)+ -1|0);c[309452>>2]=0;c[77362]=304976;c[309456>>2]=46;c[309460>>2]=44;y=309464|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[76230]|0)==-1)){c[x>>2]=304920;c[x+4>>2]=486;c[x+8>>2]=0;I3b(304920,x,487)}zac(b,309448,(c[304924>>2]|0)+ -1|0);c[309444>>2]=0;c[77360]=303248;if(!((c[75826]|0)==-1)){c[w>>2]=303304;c[w+4>>2]=486;c[w+8>>2]=0;I3b(303304,w,487)}zac(b,309440,(c[303308>>2]|0)+ -1|0);c[309436>>2]=0;c[77358]=303368;if(!((c[75856]|0)==-1)){c[v>>2]=303424;c[v+4>>2]=486;c[v+8>>2]=0;I3b(303424,v,487)}zac(b,309432,(c[303428>>2]|0)+ -1|0);c[309428>>2]=0;c[77356]=303440;if(!((c[75872]|0)==-1)){c[u>>2]=303488;c[u+4>>2]=486;c[u+8>>2]=0;I3b(303488,u,487)}zac(b,309424,(c[303492>>2]|0)+ -1|0);c[309420>>2]=0;c[77354]=303504;if(!((c[75888]|0)==-1)){c[t>>2]=303552;c[t+4>>2]=486;c[t+8>>2]=0;I3b(303552,t,487)}zac(b,309416,(c[303556>>2]|0)+ -1|0);c[309412>>2]=0;c[77352]=304096;if(!((c[76036]|0)==-1)){c[s>>2]=304144;c[s+4>>2]=486;c[s+8>>2]=0;I3b(304144,s,487)}zac(b,309408,(c[304148>>2]|0)+ -1|0);c[309404>>2]=0;c[77350]=304160;if(!((c[76052]|0)==-1)){c[r>>2]=304208;c[r+4>>2]=486;c[r+8>>2]=0;I3b(304208,r,487)}zac(b,309400,(c[304212>>2]|0)+ -1|0);c[309396>>2]=0;c[77348]=304224;if(!((c[76068]|0)==-1)){c[q>>2]=304272;c[q+4>>2]=486;c[q+8>>2]=0;I3b(304272,q,487)}zac(b,309392,(c[304276>>2]|0)+ -1|0);c[309388>>2]=0;c[77346]=304288;if(!((c[76084]|0)==-1)){c[p>>2]=304336;c[p+4>>2]=486;c[p+8>>2]=0;I3b(304336,p,487)}zac(b,309384,(c[304340>>2]|0)+ -1|0);c[309380>>2]=0;c[77344]=304352;if(!((c[76094]|0)==-1)){c[o>>2]=304376;c[o+4>>2]=486;c[o+8>>2]=0;I3b(304376,o,487)}zac(b,309376,(c[304380>>2]|0)+ -1|0);c[309372>>2]=0;c[77342]=304432;if(!((c[76114]|0)==-1)){c[n>>2]=304456;c[n+4>>2]=486;c[n+8>>2]=0;I3b(304456,n,487)}zac(b,309368,(c[304460>>2]|0)+ -1|0);c[309364>>2]=0;c[77340]=304488;if(!((c[76128]|0)==-1)){c[m>>2]=304512;c[m+4>>2]=486;c[m+8>>2]=0;I3b(304512,m,487)}zac(b,309360,(c[304516>>2]|0)+ -1|0);c[309356>>2]=0;c[77338]=304536;if(!((c[76140]|0)==-1)){c[l>>2]=304560;c[l+4>>2]=486;c[l+8>>2]=0;I3b(304560,l,487)}zac(b,309352,(c[304564>>2]|0)+ -1|0);c[309340>>2]=0;c[77334]=303584;c[309344>>2]=303632;if(!((c[75916]|0)==-1)){c[k>>2]=303664;c[k+4>>2]=486;c[k+8>>2]=0;I3b(303664,k,487)}zac(b,309336,(c[303668>>2]|0)+ -1|0);c[309324>>2]=0;c[77330]=303736;c[309328>>2]=303784;if(!((c[75954]|0)==-1)){c[j>>2]=303816;c[j+4>>2]=486;c[j+8>>2]=0;I3b(303816,j,487)}zac(b,309320,(c[303820>>2]|0)+ -1|0);c[309308>>2]=0;c[77326]=305680;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);c[309312>>2]=c[76164];c[77326]=304032;if(!((c[76012]|0)==-1)){c[h>>2]=304048;c[h+4>>2]=486;c[h+8>>2]=0;I3b(304048,h,487)}zac(b,309304,(c[304052>>2]|0)+ -1|0);c[309292>>2]=0;c[77322]=305680;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);c[309296>>2]=c[76164];c[77322]=304064;if(!((c[76020]|0)==-1)){c[g>>2]=304080;c[g+4>>2]=486;c[g+8>>2]=0;I3b(304080,g,487)}zac(b,309288,(c[304084>>2]|0)+ -1|0);c[309284>>2]=0;c[77320]=304576;if(!((c[76150]|0)==-1)){c[f>>2]=304600;c[f+4>>2]=486;c[f+8>>2]=0;I3b(304600,f,487)}zac(b,309280,(c[304604>>2]|0)+ -1|0);c[309276>>2]=0;c[77318]=304616;if((c[76160]|0)==-1){N=304640;O=304640;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=309272;zac(b,T,S);i=e;return}c[H>>2]=304640;c[H+4>>2]=486;c[H+8>>2]=0;I3b(304640,H,487);N=304640;O=304640;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=309272;zac(b,T,S);i=e;return}function zac(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;m3b(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){Ecc(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}n3b(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function Aac(a){a=a|0;var b=0;b=i;Bac(a);iec(a);i=b;return}function Bac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=304688;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{n3b(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}X3b(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{iec(h);i=d;return}}function Cac(){var b=0,d=0,e=0,f=0;b=i;if((a[304744]|0)!=0){d=304736;e=c[76184]|0;i=b;return e|0}if((Xa(304744)|0)==0){d=304736;e=c[76184]|0;i=b;return e|0}do{if((a[304720]|0)==0){if((Xa(304720)|0)==0){break}yac(309112,1);c[76176]=309112;c[76178]=304704;Rb(304720)}}while(0);f=c[c[76178]>>2]|0;c[76182]=f;m3b(f);c[76184]=304728;Rb(304744);d=304736;e=c[76184]|0;i=b;return e|0}function Dac(a){a=a|0;var b=0,d=0;b=i;d=c[(Cac()|0)>>2]|0;c[a>>2]=d;m3b(d);i=b;return}function Eac(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;m3b(e);i=d;return}function Fac(a){a=a|0;var b=0;b=i;n3b(c[a>>2]|0)|0;i=b;return}function Gac(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=486;c[e+8>>2]=0;I3b(a,e,487)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function Hac(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=486;c[e+8>>2]=0;I3b(a,e,487)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Cc(4)|0;h=g;Hdc(h);j=320328;k=127;Rd(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Cc(4)|0;h=g;Hdc(h);j=320328;k=127;Rd(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function Iac(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function Jac(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}de[c[(c[a>>2]|0)+4>>2]&511](a);i=b;return}function Kac(a){a=a|0;var b=0;b=c[76188]|0;c[76188]=1+b;c[a+4>>2]=b+1;i=i;return}function Lac(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function Mac(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(wc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function Nac(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(wc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function Oac(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(wc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function Pac(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(wc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function Qac(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Bd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function Rac(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Bd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function Sac(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Gd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function Tac(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Gd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function Uac(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}function Vac(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function Wac(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function Xac(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function Yac(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=304784;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}jec(e)}}while(0);iec(b);i=d;return}function Zac(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=304784;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}jec(e);i=d;return}function _ac(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Bd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function $ac(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Bd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function abc(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Gd()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function bbc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Gd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function cbc(a,b){a=a|0;b=b|0;i=i;return b|0}function dbc(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function ebc(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function fbc(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function gbc(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function hbc(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function ibc(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function jbc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function kbc(a){a=a|0;i=i;return 1}function lbc(a){a=a|0;i=i;return 1}function mbc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function nbc(a){a=a|0;i=i;return 1}function obc(a){a=a|0;var b=0;b=i;wac(a);iec(a);i=b;return}function pbc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Jc(c[s>>2]|0)|0;A=gdc(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Jc(z|0)|0}if((A|0)==0){B=1;C=33;break}else if((A|0)==-1){C=10;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){C=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Jc(c[s>>2]|0)|0;A=fdc(u,0,d)|0;if((z|0)!=0){Jc(z|0)|0}if((A|0)==-1){B=2;C=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){B=1;C=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((C|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Jc(c[s>>2]|0)|0;G=fdc(u,r,n)|0;if((z|0)!=0){Jc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;B=2;i=l;return B|0}else if((C|0)==31){q=c[g>>2]|0;break}else if((C|0)==33){i=l;return B|0}}}while(0);B=(q|0)!=(f|0)|0;i=l;return B|0}function qbc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Jc(c[r>>2]|0)|0;y=cdc(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Jc(x|0)|0}if((y|0)==-1){A=10;break}else if((y|0)==0){B=2;A=32;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){A=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Jc(c[r>>2]|0)|0;F=bdc(x,y,1,d)|0;if((w|0)!=0){Jc(w|0)|0}if((F|0)!=0){B=2;A=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((A|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Jc(c[r>>2]|0)|0;y=bdc(q,v,z-v|0,n)|0;if((w|0)!=0){Jc(w|0)|0}if((y|0)==0){I=v+1|0}else if((y|0)==-1){A=15;break}else if((y|0)==-2){A=16;break}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((A|0)==15){c[g>>2]=v;B=2;i=l;return B|0}else if((A|0)==16){c[g>>2]=v;B=1;i=l;return B|0}}}while(0);c[g>>2]=H;B=(H|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==30){p=c[g>>2]|0;break}else if((A|0)==32){i=l;return B|0}}}while(0);B=(p|0)!=(f|0)|0;i=l;return B|0}function rbc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Jc(c[b+8>>2]|0)|0;b=fdc(e,0,d)|0;if((j|0)!=0){Jc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function sbc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Jc(c[d>>2]|0)|0;e=edc(0,0,4)|0;if((a|0)!=0){Jc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Jc(a|0)|0;if((g|0)==0){f=0;break}Jc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function tbc(a){a=a|0;i=i;return 0}function ubc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Jc(c[k>>2]|0)|0;n=adc(a,j-a|0,b)|0;if((m|0)!=0){Jc(m|0)|0}if((n|0)==-2|(n|0)==-1){h=d;o=9;break}else if((n|0)==0){p=a+1|0;q=1}else{p=a+n|0;q=n}n=q+d|0;m=l+1|0;if(m>>>0>=f>>>0|(p|0)==(e|0)){h=n;o=9;break}else{a=p;d=n;l=m}}if((o|0)==9){i=g;return h|0}return 0}function vbc(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Jc(d|0)|0;if((a|0)==0){e=4;break}Jc(a|0)|0;e=4}}while(0);i=b;return e|0}function wbc(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function xbc(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=ybc(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function ybc(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function zbc(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=Abc(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function Abc(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function Bbc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function Cbc(a){a=a|0;i=i;return 0}function Dbc(a){a=a|0;i=i;return 0}function Ebc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=Fbc(c,d,e,1114111,0)|0;i=b;return a|0}



function wdc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=aec(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=aec(y)|0;if((z|0)==0){A=12;break}Iec(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=edc(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((Lcc(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((Lcc(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((Lcc(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((Lcc(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(Lcc(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(Lcc(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(Lcc(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(Lcc(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){Iec(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=edc(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((Lcc(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((Lcc(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((Lcc(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((Lcc(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(Lcc(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(Lcc(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(Lcc(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(Lcc(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((Pcc(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=$cc(X)|0;qb=_a+24|0;if((Pcc(fb,c[qb>>2]|0)|0)!=0){break}fb=Zcc(X)|0;if((Pcc(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((Pcc(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=Zcc(X)|0;if((Pcc(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=$cc(X)|0;if((Pcc(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}bec(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=ydc(0,0)|0;if((S|0)==0){A=12;break}R=Adc(S,0,0,0,32)|0;Q=R;if((R|0)==0){zdc(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=aec(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=aec(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=aec(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){Iec(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){Iec(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=edc(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((Lcc(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((Lcc(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((Lcc(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((Lcc(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(Lcc(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(Lcc(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(Lcc(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(Lcc(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=Adc(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=Adc(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;xdc(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((Bec(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=edc(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=edc(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((Lcc(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((Lcc(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((Lcc(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((Lcc(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(Lcc(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(Lcc(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(Lcc(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(Lcc(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((Pcc(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=$cc(tc)|0;aa=Ca+24|0;if((Pcc(qa,c[aa>>2]|0)|0)!=0){break}qa=Zcc(tc)|0;if((Pcc(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((Pcc(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=Zcc(tc)|0;if((Pcc(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=$cc(tc)|0;if((Pcc(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=Adc(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=Adc(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){zdc(S);if((Eb|0)!=0){bec(O)}if((Kb|0)!=0){bec(Kb)}if((Lb|0)==0){A=12;break a}bec(N);A=12;break a}else if((sa|0)==67){zdc(S);if((Eb|0)!=0){bec(O)}if((Kb|0)!=0){bec(Kb)}if((Lb|0)==0){A=12;break a}bec(N);A=12;break a}else if((sa|0)==169){zdc(S);if((Eb|0)!=0){bec(O)}if((Kb|0)!=0){bec(Kb)}if((Lb|0)==0){A=12;break a}bec(N);A=12;break a}else if((sa|0)==176){zdc(S);if((Eb|0)!=0){bec(O)}if((Kb|0)!=0){bec(Kb)}if((Lb|0)==0){A=12;break a}bec(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);zdc(S);if((Jb|0)!=0){bec(Jb)}if((Gb|0)!=0){bec(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}bec(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}xdc(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}bec(m);p=A;i=g;return p|0}function xdc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function ydc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=cec(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function zdc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;bec(e);i=b;return}else{f=d}while(1){bec(c[f>>2]|0);d=c[f+4>>2]|0;bec(f);if((d|0)==0){break}else{f=d}}e=a;bec(e);i=b;return}function Adc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=aec(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=aec(p)|0;c[o>>2]=r;if((r|0)==0){bec(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}Iec(m|0,0,h|0)|0;j=m;i=g;return j|0}function Bdc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((Cdc(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function Cdc(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function Ddc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function Edc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function Fdc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function Gdc(a){a=a|0;i=i;return}function Hdc(a){a=a|0;c[a>>2]=320256;i=i;return}function Idc(a){a=a|0;var b=0;b=i;xb(a|0);iec(a);i=b;return}function Jdc(a){a=a|0;var b=0;b=i;xb(a|0);i=b;return}function Kdc(a){a=a|0;i=i;return 320272}function Ldc(a){a=a|0;i=i;return}function Mdc(a){a=a|0;i=i;return}function Ndc(a){a=a|0;i=i;return}function Odc(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function Pdc(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function Qdc(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function Rdc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=Vdc(b,320384,320440,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;Ee[c[(c[h>>2]|0)+28>>2]&31](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function Sdc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function Tdc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;Ee[c[(c[h>>2]|0)+28>>2]&31](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function Udc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;Ee[c[(c[l>>2]|0)+28>>2]&31](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;Ee[c[(c[m>>2]|0)+28>>2]&31](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function Vdc(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;oe[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}ae[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function Wdc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;oe[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;ae[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;ae[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;ae[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;ae[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function Xdc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;ae[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;oe[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function Ydc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function Zdc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;oe[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;oe[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function _dc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;oe[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function $dc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function aec(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[80172]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=320728+(j<<2)|0;l=320728+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[80172]=f&~(1<<h)}else{if(n>>>0<(c[320704>>2]|0)>>>0){fd()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{fd()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[320696>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=320728+(r<<2)|0;o=320728+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[80172]=f&~(1<<t)}else{if(n>>>0<(c[320704>>2]|0)>>>0){fd()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{fd()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[320696>>2]|0;if((n|0)!=0){f=c[320708>>2]|0;e=n>>>3;n=e<<1;g=320728+(n<<2)|0;m=c[80172]|0;j=1<<e;do{if((m&j|0)==0){c[80172]=m|j;u=320728+(n+2<<2)|0;v=g}else{e=320728+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[320704>>2]|0)>>>0)){u=e;v=h;break}fd()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[320696>>2]=o;c[320708>>2]=s;p=k;i=b;return p|0}n=c[320692>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[320992+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[320704>>2]|0;if(h>>>0<k>>>0){fd()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){fd()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){fd()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){fd()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){fd()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{fd()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=320992+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[320692>>2]=c[320692>>2]&~(1<<h);break a}else{if(s>>>0<(c[320704>>2]|0)>>>0){fd()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[320704>>2]|0)>>>0){fd()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[320696>>2]|0;if((h|0)!=0){s=c[320708>>2]|0;k=h>>>3;h=k<<1;f=320728+(h<<2)|0;m=c[80172]|0;g=1<<k;do{if((m&g|0)==0){c[80172]=m|g;A=320728+(h+2<<2)|0;B=f}else{k=320728+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[320704>>2]|0)>>>0)){A=k;B=e;break}fd()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[320696>>2]=t;c[320708>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[320692>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[320992+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[320992+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[320696>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[320704>>2]|0;if(t>>>0<f>>>0){fd()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){fd()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){fd()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){fd()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){fd()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{fd()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=320992+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[320692>>2]=c[320692>>2]&~(1<<e);break c}else{if(t>>>0<(c[320704>>2]|0)>>>0){fd()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[320704>>2]|0)>>>0){fd()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=320728+(t<<2)|0;s=c[80172]|0;r=1<<e;do{if((s&r|0)==0){c[80172]=s|r;S=320728+(t+2<<2)|0;T=f}else{e=320728+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[320704>>2]|0)>>>0)){S=e;T=k;break}fd()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=320992+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[320692>>2]|0;l=1<<U;if((f&l|0)==0){c[320692>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[320704>>2]|0;if(W>>>0<k>>>0){fd()}if(r>>>0<k>>>0){fd()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[320696>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[320708>>2]|0;if(W>>>0>15){c[320708>>2]=X+q;c[320696>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[320696>>2]=0;c[320708>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[320700>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[320700>>2]=W;X=c[320712>>2]|0;c[320712>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[80290]|0)==0){X=cd(30)|0;if((X+ -1&X|0)==0){c[321168>>2]=X;c[321164>>2]=X;c[321172>>2]=-1;c[321176>>2]=-1;c[321180>>2]=0;c[321132>>2]=0;c[80290]=(qc(0)|0)&-16^1431655768;break}else{fd()}}}while(0);X=q+48|0;W=c[321168>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[321128>>2]|0;do{if((U|0)!=0){T=c[321120>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[321132>>2]&4|0)==0){U=c[320712>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=321136|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[320700>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=ib(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=ib(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[321164>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[321120>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[321128>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=ib(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[321168>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((ib(t|0)|0)==(-1|0)){ib(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[321132>>2]=c[321132>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=ib(W|0)|0;ha=ib(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[321120>>2]|0)+ga|0;c[321120>>2]=ia;if(ia>>>0>(c[321124>>2]|0)>>>0){c[321124>>2]=ia}ia=c[320712>>2]|0;W=321136|0;i:do{if((ia|0)==0){aa=c[320704>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[320704>>2]=fa}c[321136>>2]=fa;c[321140>>2]=ga;c[321148>>2]=0;c[320724>>2]=c[80290];c[320720>>2]=-1;aa=0;do{ha=aa<<1;$=320728+(ha<<2)|0;c[320728+(ha+3<<2)>>2]=$;c[320728+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[320712>>2]=fa+ja;c[320700>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[320716>>2]=c[321176>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[320700>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[320712>>2]=ia+na;c[320700>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[320716>>2]=c[321176>>2];break i}}while(0);if(fa>>>0<(c[320704>>2]|0)>>>0){c[320704>>2]=fa}aa=fa+ga|0;$=321136|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[320712>>2]|0)){ca=(c[320700>>2]|0)+X|0;c[320700>>2]=ca;c[320712>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[320708>>2]|0)){ca=(c[320696>>2]|0)+X|0;c[320696>>2]=ca;c[320708>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=320728+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[320704>>2]|0)>>>0){fd()}if((c[V+12>>2]|0)==(ha|0)){break}fd()}}while(0);if((L|0)==(V|0)){c[80172]=c[80172]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[320704>>2]|0)>>>0){fd()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}fd()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[320704>>2]|0)>>>0){fd()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){fd()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{fd()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=320992+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[320692>>2]=c[320692>>2]&~(1<<t);break k}else{if(T>>>0<(c[320704>>2]|0)>>>0){fd()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[320704>>2]|0)>>>0){fd()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=320728+(Z<<2)|0;t=c[80172]|0;T=1<<ca;do{if((t&T|0)==0){c[80172]=t|T;xa=320728+(Z+2<<2)|0;ya=ea}else{ca=320728+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[320704>>2]|0)>>>0)){xa=ca;ya=V;break}fd()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=320992+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[320692>>2]|0;L=1<<za;if((ea&L|0)==0){c[320692>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[320704>>2]|0;if(Ba>>>0<S>>>0){fd()}if(T>>>0<S>>>0){fd()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=321136|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[320712>>2]=fa+Ha;c[320700>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[320716>>2]=c[321176>>2];c[ba+4>>2]=27;X=321136|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[321136>>2]=fa;c[321140>>2]=ga;c[321148>>2]=0;c[321144>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=320728+(da<<2)|0;aa=c[80172]|0;f=1<<M;do{if((aa&f|0)==0){c[80172]=aa|f;Ia=320728+(da+2<<2)|0;Ja=ha}else{M=320728+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[320704>>2]|0)>>>0)){Ia=M;Ja=T;break}fd()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=320992+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[320692>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[320692>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[320704>>2]|0;if(Ma>>>0<f>>>0){fd()}if(M>>>0<f>>>0){fd()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[320700>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[320700>>2]=W;ia=c[320712>>2]|0;c[320712>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Lc()|0)>>2]=12;p=0;i=b;return p|0}function bec(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[320704>>2]|0;if(d>>>0<f>>>0){fd()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){fd()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){fd()}if((p|0)==(c[320708>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[320696>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=320728+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){fd()}if((c[m+12>>2]|0)==(p|0)){break}fd()}}while(0);if((u|0)==(m|0)){c[80172]=c[80172]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){fd()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}fd()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){fd()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){fd()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){fd()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{fd()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=320992+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[320692>>2]=c[320692>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[320704>>2]|0)>>>0){fd()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[320704>>2]|0)>>>0){fd()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){fd()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){fd()}do{if((C&2|0)==0){if((l|0)==(c[320712>>2]|0)){f=(c[320700>>2]|0)+t|0;c[320700>>2]=f;c[320712>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[320708>>2]|0)){i=b;return}c[320708>>2]=0;c[320696>>2]=0;i=b;return}if((l|0)==(c[320708>>2]|0)){f=(c[320696>>2]|0)+t|0;c[320696>>2]=f;c[320708>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=320728+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[320704>>2]|0)>>>0){fd()}if((c[E+12>>2]|0)==(l|0)){break}fd()}}while(0);if((w|0)==(E|0)){c[80172]=c[80172]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[320704>>2]|0)>>>0){fd()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}fd()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[320704>>2]|0)>>>0){fd()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){fd()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{fd()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=320992+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[320692>>2]=c[320692>>2]&~(1<<g);break b}else{if(d>>>0<(c[320704>>2]|0)>>>0){fd()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[320704>>2]|0)>>>0){fd()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[320708>>2]|0)){J=f;break}c[320696>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=320728+(C<<2)|0;G=c[80172]|0;j=1<<t;do{if((G&j|0)==0){c[80172]=G|j;K=320728+(C+2<<2)|0;L=e}else{t=320728+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[320704>>2]|0)>>>0)){K=t;L=a;break}fd()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=320992+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[320692>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[320692>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[320704>>2]|0;if(O>>>0<K>>>0){fd()}if(f>>>0<K>>>0){fd()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[320720>>2]|0)+ -1|0;c[320720>>2]=s;if((s|0)==0){Q=321144|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[320720>>2]=-1;i=b;return}function cec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=aec(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}Iec(b|0,0,e|0)|0;i=d;return b|0}function dec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=aec(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Lc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=eec(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=aec(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;Gec(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;bec(a);e=g;i=d;return e|0}function eec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[320704>>2]|0;if(h>>>0<l>>>0){fd()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){fd()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){fd()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[321168>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;fec(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[320712>>2]|0)){m=(c[320700>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[320712>>2]=a+b;c[320700>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[320708>>2]|0)){h=(c[320696>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[320696>>2]=r;c[320708>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=320728+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){fd()}if((c[h+12>>2]|0)==(k|0)){break}fd()}}while(0);if((m|0)==(h|0)){c[80172]=c[80172]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){fd()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}fd()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){fd()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){fd()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){fd()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{fd()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=320992+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[320692>>2]=c[320692>>2]&~(1<<u);break a}else{if(t>>>0<(c[320704>>2]|0)>>>0){fd()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[320704>>2]|0)>>>0){fd()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;fec(a+b|0,r);o=a;i=d;return o|0}return 0}function fec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[320704>>2]|0;if(j>>>0<m>>>0){fd()}if((k|0)==(c[320708>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[320696>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=320728+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){fd()}if((c[q+12>>2]|0)==(k|0)){break}fd()}}while(0);if((r|0)==(q|0)){c[80172]=c[80172]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){fd()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}fd()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){fd()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){fd()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){fd()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{fd()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=320992+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[320692>>2]=c[320692>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[320704>>2]|0)>>>0){fd()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[320704>>2]|0)>>>0){fd()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[320704>>2]|0;if(e>>>0<z>>>0){fd()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[320712>>2]|0)){t=(c[320700>>2]|0)+p|0;c[320700>>2]=t;c[320712>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[320708>>2]|0)){i=d;return}c[320708>>2]=0;c[320696>>2]=0;i=d;return}if((f|0)==(c[320708>>2]|0)){t=(c[320696>>2]|0)+p|0;c[320696>>2]=t;c[320708>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=320728+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){fd()}if((c[u+12>>2]|0)==(f|0)){break}fd()}}while(0);if((h|0)==(u|0)){c[80172]=c[80172]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){fd()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}fd()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){fd()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){fd()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){fd()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{fd()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=320992+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[320692>>2]=c[320692>>2]&~(1<<j);break b}else{if(m>>>0<(c[320704>>2]|0)>>>0){fd()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[320704>>2]|0)>>>0){fd()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[320704>>2]|0)>>>0){fd()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[320708>>2]|0)){G=t;break}c[320696>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=320728+(B<<2)|0;D=c[80172]|0;b=1<<p;do{if((D&b|0)==0){c[80172]=D|b;H=320728+(B+2<<2)|0;I=A}else{p=320728+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[320704>>2]|0)>>>0)){H=p;I=a;break}fd()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=320992+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[320692>>2]|0;B=1<<J;if((a&B|0)==0){c[320692>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[320704>>2]|0)>>>0){fd()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[320704>>2]|0;if(L>>>0<B>>>0){fd()}if(G>>>0<B>>>0){fd()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function gec(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=aec(d)|0;if((e|0)!=0){f=6;break}a=c[80296]|0;c[80296]=0+a;if((a|0)==0){f=5;break}Be[a&7]()}if((f|0)==5){d=Cc(4)|0;c[d>>2]=321200;Rd(d|0,321248,135)}else if((f|0)==6){i=b;return e|0}return 0}function hec(a){a=a|0;var b=0,c=0;b=i;c=gec(a)|0;i=b;return c|0}function iec(a){a=a|0;var b=0;b=i;if((a|0)!=0){bec(a)}i=b;return}function jec(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function kec(a){a=a|0;var b=0;b=i;xb(a|0);iec(a);i=b;return}function lec(a){a=a|0;var b=0;b=i;xb(a|0);i=b;return}function mec(a){a=a|0;i=i;return 321216}function nec(){var a=0;a=Cc(4)|0;c[a>>2]=321200;Rd(a|0,321248,135)}function oec(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,uc=0,vc=0.0,wc=0.0,yc=0.0,zc=0.0,Ac=0.0,Bc=0.0,Cc=0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0,Ic=0,Jc=0,Kc=0,Mc=0;g=i;i=i+512|0;h=g;if((e|0)==1){j=53;k=-1074}else if((e|0)==2){j=53;k=-1074}else if((e|0)==0){j=24;k=-149}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=rec(b)|0}}while((hd(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=rec(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[321264+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=rec(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[321280+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=rec(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=rec(b)|0}if((B|32|0)!=120){if((c[m>>2]|0)==0){C=48;break}c[e>>2]=(c[e>>2]|0)+ -1;C=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=0}else{D=rec(b)|0;E=0}while(1){if((D|0)==46){v=70;break}else if((D|0)!=48){F=0;G=0;H=0;I=0;K=D;L=E;M=0;N=0;O=1.0;P=0;Q=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=1;continue}else{D=rec(b)|0;E=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;R=d[o]|0}else{R=rec(b)|0}if((R|0)==48){S=-1;T=-1}else{F=0;G=0;H=0;I=0;K=R;L=E;M=1;N=0;O=1.0;P=0;Q=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;V=d[o]|0}else{V=rec(b)|0}if((V|0)!=48){F=S;G=T;H=0;I=0;K=V;L=1;M=1;N=0;O=1.0;P=0;Q=0.0;break b}o=Oec(S|0,T|0,-1,-1)|0;S=o;T=J}}}while(0);c:while(1){o=K+ -48|0;do{if(o>>>0<10){W=o;v=84}else{q=K|32;n=(K|0)==46;if(!((q+ -97|0)>>>0<6|n)){X=K;break c}if(n){if((M|0)==0){Y=H;Z=I;_=H;$=I;aa=L;ba=1;ca=N;da=O;ea=P;ga=Q;break}else{X=46;break c}}else{W=(K|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((I|0)<0|(I|0)==0&H>>>0<8){ha=N;ia=O;ja=W+(P<<4)|0;ka=Q}else{if((I|0)<0|(I|0)==0&H>>>0<14){la=O*.0625;ha=N;ia=la;ja=P;ka=Q+la*+(W|0);break}if(!((W|0)!=0&(N|0)==0)){ha=N;ia=O;ja=P;ka=Q;break}ha=1;ia=O;ja=P;ka=Q+O*.5}}while(0);o=Oec(H|0,I|0,1,0)|0;Y=F;Z=G;_=o;$=J;aa=1;ba=M;ca=ha;da=ia;ea=ja;ga=ka}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=Y;G=Z;H=_;I=$;K=d[o]|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}else{F=Y;G=Z;H=_;I=$;K=rec(b)|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}}if((L|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){qec(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((M|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(M|0)==0;q=o?H:F;n=o?I:G;if((I|0)<0|(I|0)==0&H>>>0<8){o=H;p=I;ma=P;while(1){na=ma<<4;oa=Oec(o|0,p|0,1,0)|0;pa=J;if((pa|0)<0|(pa|0)==0&oa>>>0<8){ma=na;p=pa;o=oa}else{qa=na;break}}}else{qa=P}do{if((X|32|0)==112){o=pec(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){ra=o;sa=p;break}if(u){qec(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0;break}}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0}}while(0);p=Jec(q|0,n|0,2)|0;o=Oec(p|0,J|0,-32,-1)|0;p=Oec(o|0,J|0,ra|0,sa|0)|0;o=J;if((qa|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Lc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}ma=k+ -106|0;na=((ma|0)<0)<<31>>31;if((o|0)<(na|0)|(o|0)==(na|0)&p>>>0<ma>>>0){c[(Lc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((qa|0)>-1){ma=p;na=o;oa=qa;la=Q;while(1){pa=oa<<1;if(!(la>=.5)){ta=la;ua=pa}else{ta=la+-1.0;ua=pa|1}va=la+ta;pa=Oec(ma|0,na|0,-1,-1)|0;wa=J;if((ua|0)>-1){ma=pa;na=wa;oa=ua;la=va}else{xa=pa;ya=wa;za=ua;Aa=va;break}}}else{xa=p;ya=o;za=qa;Aa=Q}oa=Nec(32,0,k|0,((k|0)<0)<<31>>31|0)|0;na=Oec(xa|0,ya|0,oa|0,J|0)|0;oa=J;if(0>(oa|0)|0==(oa|0)&j>>>0>na>>>0){Ba=(na|0)<0?0:na}else{Ba=j}do{if((Ba|0)<53){la=+(r|0);va=+Pd(+(+sec(1.0,84-Ba|0)),+la);if(!((Ba|0)<32&Aa!=0.0)){Ca=la;Da=va;Ea=za;Fa=Aa;break}na=za&1;Ca=la;Da=va;Ea=(na^1)+za|0;Fa=(na|0)==0?0.0:Aa}else{Ca=+(r|0);Da=0.0;Ea=za;Fa=Aa}}while(0);va=Ca*Fa+(Da+Ca*+(Ea>>>0))-Da;if(!(va!=0.0)){c[(Lc()|0)>>2]=34}l=+tec(va,xa);i=g;return+l}else{C=w}}while(0);o=k+j|0;p=0-o|0;na=C;oa=0;while(1){if((na|0)==46){v=139;break}else if((na|0)!=48){Ga=na;Ha=0;Ia=0;Ja=oa;Ka=0;break}ma=c[e>>2]|0;if(ma>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ma+1;na=d[ma]|0;oa=1;continue}else{na=rec(b)|0;oa=1;continue}}d:do{if((v|0)==139){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;La=d[na]|0}else{La=rec(b)|0}if((La|0)==48){Ma=-1;Na=-1}else{Ga=La;Ha=0;Ia=0;Ja=oa;Ka=1;break}while(1){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;Oa=d[na]|0}else{Oa=rec(b)|0}if((Oa|0)!=48){Ga=Oa;Ha=Ma;Ia=Na;Ja=1;Ka=1;break d}na=Oec(Ma|0,Na|0,-1,-1)|0;Ma=na;Na=J}}}while(0);oa=h;c[oa>>2]=0;na=Ga+ -48|0;ma=(Ga|0)==46;e:do{if(na>>>0<10|ma){n=h+496|0;q=Ga;wa=ma;pa=na;Pa=0;Qa=0;Ra=Ha;Sa=Ia;Ta=Ja;Ua=Ka;Va=0;Wa=0;Xa=0;while(1){do{if(wa){if((Ua|0)==0){Ya=Pa;Za=Qa;_a=Pa;$a=Qa;ab=Ta;bb=1;cb=Va;db=Wa;eb=Xa}else{fb=q;gb=Pa;hb=Qa;ib=Ra;jb=Sa;kb=Ta;lb=Va;mb=Wa;nb=Xa;break e}}else{ob=Oec(Pa|0,Qa|0,1,0)|0;pb=J;qb=(q|0)!=48;if((Wa|0)>=125){if(!qb){Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}c[n>>2]=c[n>>2]|1;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}rb=h+(Wa<<2)|0;if((Va|0)==0){sb=pa}else{sb=q+ -48+((c[rb>>2]|0)*10|0)|0}c[rb>>2]=sb;rb=Va+1|0;tb=(rb|0)==9;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=1;bb=Ua;cb=tb?0:rb;db=(tb&1)+Wa|0;eb=qb?ob:Xa}}while(0);ob=c[e>>2]|0;if(ob>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ob+1;ub=d[ob]|0}else{ub=rec(b)|0}ob=ub+ -48|0;qb=(ub|0)==46;if(ob>>>0<10|qb){q=ub;wa=qb;pa=ob;Pa=_a;Qa=$a;Ra=Ya;Sa=Za;Ta=ab;Ua=bb;Va=cb;Wa=db;Xa=eb}else{vb=ub;wb=_a;xb=$a;yb=Ya;zb=Za;Ab=ab;Bb=bb;Cb=cb;Db=db;Eb=eb;v=162;break}}}else{vb=Ga;wb=0;xb=0;yb=Ha;zb=Ia;Ab=Ja;Bb=Ka;Cb=0;Db=0;Eb=0;v=162}}while(0);if((v|0)==162){na=(Bb|0)==0;fb=vb;gb=wb;hb=xb;ib=na?wb:yb;jb=na?xb:zb;kb=Ab;lb=Cb;mb=Db;nb=Eb}na=(kb|0)!=0;do{if(na){if((fb|32|0)!=101){v=171;break}ma=pec(b,f)|0;Xa=J;do{if((ma|0)==0&(Xa|0)==-2147483648){if(u){qec(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Fb=0;Gb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Fb=0;Gb=0;break}}else{Fb=ma;Gb=Xa}}while(0);Xa=Oec(Fb|0,Gb|0,ib|0,jb|0)|0;Hb=Xa;Ib=J}else{v=171}}while(0);do{if((v|0)==171){if(!((fb|0)>-1)){Hb=ib;Ib=jb;break}if((c[m>>2]|0)==0){Hb=ib;Ib=jb;break}c[e>>2]=(c[e>>2]|0)+ -1;Hb=ib;Ib=jb}}while(0);if(!na){c[(Lc()|0)>>2]=22;qec(b,0);l=0.0;i=g;return+l}Xa=c[oa>>2]|0;if((Xa|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Hb|0)==(gb|0)&(Ib|0)==(hb|0)&((hb|0)<0|(hb|0)==0&gb>>>0<10)){if(!(j>>>0>30)){if((Xa>>>j|0)!=0){break}}l=+(r|0)*+(Xa>>>0);i=g;return+l}}while(0);Xa=(k|0)/-2|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)>(na|0)|(Ib|0)==(na|0)&Hb>>>0>Xa>>>0){c[(Lc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}Xa=k+ -106|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)<(na|0)|(Ib|0)==(na|0)&Hb>>>0<Xa>>>0){c[(Lc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((lb|0)==0){Jb=mb}else{if((lb|0)<9){Xa=h+(mb<<2)|0;na=c[Xa>>2]|0;ma=lb;do{na=na*10|0;ma=ma+1|0;}while((ma|0)<9);c[Xa>>2]=na}Jb=mb+1|0}do{if((nb|0)<9){if(!((nb|0)<=(Hb|0)&(Hb|0)<18)){break}if((Hb|0)==9){l=+(r|0)*+((c[oa>>2]|0)>>>0);i=g;return+l}if((Hb|0)<9){l=+(r|0)*+((c[oa>>2]|0)>>>0)/+(c[321296+(8-Hb<<2)>>2]|0);i=g;return+l}ma=j+27+(fa(Hb,-3)|0)|0;Wa=c[oa>>2]|0;if((ma|0)<=30){if((Wa>>>ma|0)!=0){break}}l=+(r|0)*+(Wa>>>0)*+(c[321296+(Hb+ -10<<2)>>2]|0);i=g;return+l}}while(0);oa=(Hb|0)%9|0;if((oa|0)==0){Kb=0;Lb=0;Mb=Hb;Nb=Jb}else{na=(Hb|0)>-1?oa:oa+9|0;oa=c[321296+(8-na<<2)>>2]|0;do{if((Jb|0)==0){Ob=0;Pb=Hb;Qb=0}else{Xa=1e9/(oa|0)|0;Wa=0;ma=0;Va=0;Ua=Hb;while(1){Ta=h+(Va<<2)|0;Sa=c[Ta>>2]|0;Ra=((Sa>>>0)/(oa>>>0)|0)+ma|0;c[Ta>>2]=Ra;Rb=fa((Sa>>>0)%(oa>>>0)|0,Xa)|0;Sa=Va+1|0;if((Va|0)==(Wa|0)&(Ra|0)==0){Sb=Sa&127;Tb=Ua+ -9|0}else{Sb=Wa;Tb=Ua}if((Sa|0)==(Jb|0)){break}else{Wa=Sb;Ua=Tb;Va=Sa;ma=Rb}}if((Rb|0)==0){Ob=Sb;Pb=Tb;Qb=Jb;break}c[h+(Jb<<2)>>2]=Rb;Ob=Sb;Pb=Tb;Qb=Jb+1|0}}while(0);Kb=Ob;Lb=0;Mb=9-na+Pb|0;Nb=Qb}f:while(1){oa=h+(Kb<<2)|0;if((Mb|0)<18){ma=Lb;Va=Nb;while(1){Ua=0;Wa=Va+127|0;Xa=Va;while(1){Sa=Wa&127;Ra=h+(Sa<<2)|0;Ta=Jec(c[Ra>>2]|0,0,29)|0;Qa=Oec(Ta|0,J|0,Ua|0,0)|0;Ta=J;if(Ta>>>0>0|(Ta|0)==0&Qa>>>0>1e9){Pa=Yec(Qa|0,Ta|0,1e9,0)|0;pa=Zec(Qa|0,Ta|0,1e9,0)|0;Ub=pa;Vb=Pa}else{Ub=Qa;Vb=0}c[Ra>>2]=Ub;Ra=(Sa|0)==(Kb|0);if((Sa|0)!=(Xa+127&127|0)|Ra){Wb=Xa}else{Wb=(Ub|0)==0?Sa:Xa}if(Ra){break}else{Ua=Vb;Wa=Sa+ -1|0;Xa=Wb}}Xa=ma+ -29|0;if((Vb|0)==0){ma=Xa;Va=Wb}else{Xb=Xa;Yb=Vb;Zb=Wb;break}}}else{if((Mb|0)==18){_b=Lb;$b=Nb}else{ac=Kb;bc=Lb;cc=Mb;dc=Nb;break}while(1){if(!((c[oa>>2]|0)>>>0<9007199)){ac=Kb;bc=_b;cc=18;dc=$b;break f}Va=0;ma=$b+127|0;Xa=$b;while(1){Wa=ma&127;Ua=h+(Wa<<2)|0;Sa=Jec(c[Ua>>2]|0,0,29)|0;Ra=Oec(Sa|0,J|0,Va|0,0)|0;Sa=J;if(Sa>>>0>0|(Sa|0)==0&Ra>>>0>1e9){Qa=Yec(Ra|0,Sa|0,1e9,0)|0;Pa=Zec(Ra|0,Sa|0,1e9,0)|0;ec=Pa;fc=Qa}else{ec=Ra;fc=0}c[Ua>>2]=ec;Ua=(Wa|0)==(Kb|0);if((Wa|0)!=(Xa+127&127|0)|Ua){gc=Xa}else{gc=(ec|0)==0?Wa:Xa}if(Ua){break}else{Va=fc;ma=Wa+ -1|0;Xa=gc}}Xa=_b+ -29|0;if((fc|0)==0){_b=Xa;$b=gc}else{Xb=Xa;Yb=fc;Zb=gc;break}}}oa=Kb+127&127;if((oa|0)==(Zb|0)){Xa=Zb+127&127;ma=h+((Zb+126&127)<<2)|0;c[ma>>2]=c[ma>>2]|c[h+(Xa<<2)>>2];hc=Xa}else{hc=Zb}c[h+(oa<<2)>>2]=Yb;Kb=oa;Lb=Xb;Mb=Mb+9|0;Nb=hc}g:while(1){ic=dc+1&127;na=h+((dc+127&127)<<2)|0;oa=ac;Xa=bc;ma=cc;while(1){Va=(ma|0)==18;Wa=(ma|0)>27?9:1;jc=oa;kc=Xa;while(1){Ua=0;while(1){Ra=Ua+jc&127;if((Ra|0)==(dc|0)){lc=2;break}Qa=c[h+(Ra<<2)>>2]|0;Ra=c[321288+(Ua<<2)>>2]|0;if(Qa>>>0<Ra>>>0){lc=2;break}Pa=Ua+1|0;if(Qa>>>0>Ra>>>0){lc=Ua;break}if((Pa|0)<2){Ua=Pa}else{lc=Pa;break}}if((lc|0)==2&Va){break g}mc=Wa+kc|0;if((jc|0)==(dc|0)){jc=dc;kc=mc}else{break}}Va=(1<<Wa)+ -1|0;Ua=1e9>>>Wa;nc=jc;oc=0;Pa=jc;pc=ma;do{Ra=h+(Pa<<2)|0;Qa=c[Ra>>2]|0;Sa=(Qa>>>Wa)+oc|0;c[Ra>>2]=Sa;oc=fa(Qa&Va,Ua)|0;Qa=(Pa|0)==(nc|0)&(Sa|0)==0;Pa=Pa+1&127;pc=Qa?pc+ -9|0:pc;nc=Qa?Pa:nc;}while((Pa|0)!=(dc|0));if((oc|0)==0){oa=nc;Xa=mc;ma=pc;continue}if((ic|0)!=(nc|0)){break}c[na>>2]=c[na>>2]|1;oa=nc;Xa=mc;ma=pc}c[h+(dc<<2)>>2]=oc;ac=nc;bc=mc;cc=pc;dc=ic}ma=jc&127;if((ma|0)==(dc|0)){c[h+(ic+ -1<<2)>>2]=0;qc=ic}else{qc=dc}va=+((c[h+(ma<<2)>>2]|0)>>>0);ma=jc+1&127;if((ma|0)==(qc|0)){Xa=qc+1&127;c[h+(Xa+ -1<<2)>>2]=0;rc=Xa}else{rc=qc}la=+(r|0);sc=la*(va*1.0e9+ +((c[h+(ma<<2)>>2]|0)>>>0));ma=kc+53|0;Xa=ma-k|0;if((Xa|0)<(j|0)){tc=(Xa|0)<0?0:Xa;uc=1}else{tc=j;uc=0}if((tc|0)<53){va=+Pd(+(+sec(1.0,105-tc|0)),+sc);vc=+xc(+sc,+(+sec(1.0,53-tc|0)));wc=va;yc=vc;zc=va+(sc-vc)}else{wc=0.0;yc=0.0;zc=sc}oa=jc+2&127;do{if((oa|0)==(rc|0)){Ac=yc}else{na=c[h+(oa<<2)>>2]|0;do{if(na>>>0<5e8){if((na|0)==0){if((jc+3&127|0)==(rc|0)){Bc=yc;break}}Bc=la*.25+yc}else{if(na>>>0>5e8){Bc=la*.75+yc;break}if((jc+3&127|0)==(rc|0)){Bc=la*.5+yc;break}else{Bc=la*.75+yc;break}}}while(0);if((53-tc|0)<=1){Ac=Bc;break}if(+xc(+Bc,1.0)!=0.0){Ac=Bc;break}Ac=Bc+1.0}}while(0);la=zc+Ac-wc;do{if((ma&2147483647|0)>(-2-o|0)){if(!(+U(+la)>=9007199254740992.0)){Cc=uc;Dc=kc;Ec=la}else{Cc=(uc|0)!=0&(tc|0)==(Xa|0)?0:uc;Dc=kc+1|0;Ec=la*.5}if((Dc+50|0)<=(p|0)){if(!((Cc|0)!=0&Ac!=0.0)){Fc=Dc;Gc=Ec;break}}c[(Lc()|0)>>2]=34;Fc=Dc;Gc=Ec}else{Fc=kc;Gc=la}}while(0);l=+tec(Gc,Fc);i=g;return+l}else if((x|0)==3){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Hc=d[p]|0}else{Hc=rec(b)|0}if((Hc|0)==40){Ic=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Jc=d[p]|0}else{Jc=rec(b)|0}if(!((Jc+ -48|0)>>>0<10|(Jc+ -65|0)>>>0<26)){if(!((Jc+ -97|0)>>>0<26|(Jc|0)==95)){break}}Ic=Ic+1|0}if((Jc|0)==41){l=+y;i=g;return+l}p=(c[m>>2]|0)==0;if(!p){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Lc()|0)>>2]=22;qec(b,0);l=0.0;i=g;return+l}if((Ic|0)==0|p){l=+y;i=g;return+l}else{Kc=Ic}while(1){p=Kc+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((p|0)==0){l=+y;break}else{Kc=p}}i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Lc()|0)>>2]=22;qec(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Mc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Mc=Mc+ -1|0;}while(Mc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function pec(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=rec(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=rec(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=rec(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=Xec(q|0,m|0,10,0)|0;b=J;g=Oec(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=Oec(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=rec(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=rec(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=Nec(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function qec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function rec(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=vec(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function sec(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=Jec(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function tec(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+sec(a,b);i=c;return+d}function uec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){le[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function vec(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((uec(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((le[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function wec(a){a=a|0;var b=0,c=0.0;b=i;c=+xec(a,0);i=b;return+c}function xec(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;qec(e,0);h=+oec(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function yec(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;qec(e,0);h=+oec(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function zec(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function Aec(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function Bec(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function Cec(){c[75400]=p;c[75442]=p;c[80084]=p;c[80314]=p}function Dec(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}bc(116);bc(111);bc(111);bc(32);bc(109);bc(97);bc(110);bc(121);bc(32);bc(115);bc(101);bc(116);bc(106);bc(109);bc(112);bc(115);bc(32);bc(105);bc(110);bc(32);bc(97);bc(32);bc(102);bc(117);bc(110);bc(99);bc(116);bc(105);bc(111);bc(110);bc(32);bc(99);bc(97);bc(108);bc(108);bc(44);bc(32);bc(98);bc(117);bc(105);bc(108);bc(100);bc(32);bc(119);bc(105);bc(116);bc(104);bc(32);bc(97);bc(32);bc(104);bc(105);bc(103);bc(104);bc(101);bc(114);bc(32);bc(118);bc(97);bc(108);bc(117);bc(101);bc(32);bc(102);bc(111);bc(114);bc(32);bc(77);bc(65);bc(88);bc(95);bc(83);bc(69);bc(84);bc(74);bc(77);bc(80);bc(83);bc(10);ga(0);return 0}function Eec(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function Fec(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function Gec(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return kb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function Hec(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{Gec(b,c,d)|0}return b|0}function Iec(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function Jec(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function Kec(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function Lec(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function Mec(){return Lec(o)|0}function Nec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function Oec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function Pec(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function Qec(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function Rec(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function Sec(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function Tec(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function Uec(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function Vec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=Nec(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=Nec((_ec(i,b,Nec(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function Wec(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=Nec(h^a,j^b,h,j)|0;b=J;_ec(m,b,Nec(k^d,l^e,k,l)|0,J,g)|0;l=Nec(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function Xec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=Uec(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function Yec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=_ec(a,b,c,d,0)|0;return(J=J,e)|0}function Zec(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;_ec(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function _ec(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((Tec(l|0)|0)>>>0);return(J=n,o)|0}p=(Sec(l|0)|0)-(Sec(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(Sec(l|0)|0)-(Sec(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(Sec(j|0)|0)+33-(Sec(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=Tec(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=Oec(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;Nec(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=Nec(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function $ec(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return $d[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function afc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ae[a&31](b|0,c|0,d|0,e|0,f|0)}function bfc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return be[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function cfc(a,b){a=a|0;b=+b;ce[a&1](+b)}function dfc(a,b){a=a|0;b=b|0;de[a&511](b|0)}function efc(a,b,c){a=a|0;b=b|0;c=c|0;ee[a&63](b|0,c|0)}function ffc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return fe[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function gfc(a,b){a=a|0;b=b|0;return ge[a&127](b|0)|0}function hfc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;he[a&1](b|0,c|0,+d,e|0)}function ifc(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return ie[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function jfc(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return je[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function kfc(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return ke[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function lfc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return le[a&63](b|0,c|0,d|0)|0}function mfc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;me[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function nfc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ne[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function ofc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;oe[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function pfc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;pe[a&3](b|0,c|0,+d,e|0,f|0)}function qfc(a,b,c){a=a|0;b=b|0;c=+c;return qe[a&1](b|0,+c)|0}function rfc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;re[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function sfc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;se[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function tfc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;te[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function ufc(a,b,c){a=a|0;b=b|0;c=c|0;return ue[a&63](b|0,c|0)|0}function vfc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ve[a&63](b|0,c|0,d|0,e|0,f|0)|0}function wfc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return we[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function xfc(a,b,c){a=a|0;b=b|0;c=c|0;return+xe[a&1](b|0,c|0)}function yfc(a){a=a|0;return ye[a&7]()|0}function zfc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return ze[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function Afc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ae[a&15](b|0,c|0,d|0)}function Bfc(a){a=a|0;Be[a&7]()}function Cfc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Ce[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function Dfc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return De[a&63](b|0,c|0,d|0,e|0)|0}function Efc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ee[a&31](b|0,c|0,d|0,e|0)}function Ffc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function Gfc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function Hfc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function Ifc(a){a=+a;ga(3)}function Jfc(a){a=a|0;ga(4)}function Kfc(a){a=a|0;Ad(a|0)}function Lfc(a,b){a=a|0;b=b|0;ga(5)}function Mfc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function Nfc(a){a=a|0;ga(7);return 0}function Ofc(a){a=a|0;return Mc(a|0)|0}function Pfc(a){a=a|0;return Jd(a|0)|0}function Qfc(a){a=a|0;return uc(a|0)|0}function Rfc(a){a=a|0;return yd(a|0)|0}function Sfc(a){a=a|0;return kd(a|0)|0}function Tfc(a){a=a|0;return sd(a|0)|0}function Ufc(a){a=a|0;return Wc(a|0)|0}function Vfc(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function Wfc(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function Xfc(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(10);return 0}function Yfc(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function Zfc(a,b,c){a=a|0;b=b|0;c=c|0;ga(12);return 0}function _fc(a,b,c){a=a|0;b=b|0;c=c|0;return ud(a|0,b|0,c|0)|0}function $fc(a,b,c){a=a|0;b=b|0;c=c|0;return fc(a|0,b|0,c|0)|0}function agc(a,b,c){a=a|0;b=b|0;c=c|0;return Md(a|0,b|0,c|0)|0}function bgc(a,b,c){a=a|0;b=b|0;c=c|0;return zd(a|0,b|0,c|0)|0}function cgc(a,b,c){a=a|0;b=b|0;c=c|0;return vd(a|0,b|0,c|0)|0}function dgc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function egc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function fgc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(15)}function ggc(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(16)}function hgc(a,b){a=a|0;b=+b;ga(17);return 0}function igc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(18)}function jgc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(19)}function kgc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(20)}function lgc(a,b){a=a|0;b=b|0;ga(21);return 0}function mgc(a,b){a=a|0;b=b|0;return Od(a|0,b|0)|0}function ngc(a,b){a=a|0;b=b|0;return ec(a|0,b|0)|0}function ogc(a,b){a=a|0;b=b|0;return gb(a|0,b|0)|0}function pgc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(22);return 0}function qgc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(23);return 0}function rgc(a,b){a=a|0;b=b|0;ga(24);return 0.0}function sgc(){ga(25);return 0}function tgc(){return hb()|0}function ugc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(26);return 0}function vgc(a,b,c){a=a|0;b=b|0;c=c|0;ga(27)}function wgc(){ga(28)}function xgc(){Sc()}function ygc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(29);return 0}function zgc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(30);return 0}function Agc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return pc(a|0,b|0,c|0,d|0)|0}function Bgc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Kc(a|0,b|0,c|0,d|0)|0}function Cgc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(31)}



function Q8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5880>>3]=+h[b+5808>>3];i=i;return}function R8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5888>>3]=+h[b+5816>>3];i=i;return}function S8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5896>>3]=+h[b+5824>>3];i=i;return}function T8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21120>>3]=+h[b+18960>>3];i=i;return}function U8a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+6096>>3]=l;i=b;return}function V8a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+6104>>3]=l;i=b;return}function W8a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+6112>>3]=l;i=b;return}function X8a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+6120>>3]=l;i=b;return}function Y8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21128>>3]=+h[b+21120>>3]/3.0;i=i;return}function Z8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21136>>3]=+h[b+20416>>3]/1.75;i=i;return}function _8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21144>>3]=+h[b+20416>>3]/1.75;i=i;return}function $8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21152>>3]=+h[b+21136>>3]*2.0;i=i;return}function a9a(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+116>>2]=c[b+108>>2];i=i;return}function b9a(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+104|0]=a[d+71|0]|0;i=i;return}function c9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6136>>3]=+h[b+20376>>3];i=i;return}function d9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6160>>3]=+h[b+20376>>3]*.5;i=i;return}function e9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21160>>3]=+h[b+20384>>3];i=i;return}function f9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21168>>3]=+h[b+20392>>3];i=i;return}function g9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21176>>3]=+h[b+20400>>3];i=i;return}function h9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21184>>3]=+h[b+20408>>3];i=i;return}function i9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6296>>3]=+h[b+6128>>3];i=i;return}function j9a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10496>>3]=+h[b+10616>>3]- +h[(c[a+416>>2]|0)+6296>>3];i=i;return}function k9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6304>>3]=+h[b+6136>>3];i=i;return}function l9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6312>>3]=+h[b+6144>>3];i=i;return}function m9a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+6296>>3]- +h[b+6320>>3];e=+h[b+6304>>3]- +h[b+6328>>3];f=+h[b+6312>>3]- +h[b+6336>>3];h[b+21232>>3]=+V(+(d*d+e*e+f*f));i=i;return}function n9a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+21232>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23584,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+21240>>3]=l;i=d;return}function o9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21248>>3]=+h[b+21240>>3];i=i;return}function p9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6416>>3]=+h[b+6152>>3];i=i;return}function q9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6424>>3]=+h[b+6160>>3];i=i;return}function r9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6432>>3]=+h[b+6168>>3];i=i;return}function s9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21264>>3]=+h[b+21160>>3];i=i;return}function t9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21272>>3]=+h[b+21168>>3];i=i;return}function u9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21280>>3]=+h[b+21176>>3];i=i;return}function v9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21288>>3]=+h[b+21184>>3];i=i;return}function w9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21296>>3]=+h[b+21192>>3];i=i;return}function x9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21304>>3]=+h[b+21200>>3];i=i;return}function y9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21312>>3]=+h[b+21208>>3];i=i;return}function z9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6440>>3]=+h[b+6176>>3];i=i;return}function A9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6448>>3]=+h[b+6184>>3];i=i;return}function B9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6456>>3]=+h[b+6192>>3];i=i;return}function C9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6464>>3]=+h[b+6200>>3];i=i;return}function D9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6472>>3]=+h[b+6208>>3];i=i;return}function E9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6480>>3]=+h[b+6216>>3];i=i;return}function F9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6488>>3]=+h[b+6224>>3];i=i;return}function G9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6496>>3]=+h[b+6232>>3];i=i;return}function H9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6504>>3]=+h[b+6240>>3];i=i;return}function I9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6512>>3]=+h[b+6440>>3];i=i;return}function J9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6520>>3]=+h[b+6448>>3];i=i;return}function K9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6528>>3]=+h[b+6456>>3];i=i;return}function L9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21320>>3]=+h[b+18960>>3];i=i;return}function M9a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+6728>>3]=l;i=b;return}function N9a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+6736>>3]=l;i=b;return}function O9a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+6744>>3]=l;i=b;return}function P9a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+6752>>3]=l;i=b;return}function Q9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21328>>3]=+h[b+21320>>3]/3.0;i=i;return}function R9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21352>>3]=+h[b+21336>>3]*2.0;i=i;return}function S9a(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+128>>2]=c[b+120>>2];i=i;return}function T9a(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+118|0]=a[d+71|0]|0;i=i;return}function U9a(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+136>>2]=c[b+132>>2];i=i;return}function V9a(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+119|0]=a[d+6|0]|0;i=i;return}function W9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6760>>3]=+h[b+21368>>3];i=i;return}function X9a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10784>>3]=+h[b+10808>>3]+ +h[(c[a+416>>2]|0)+6760>>3];i=i;return}function Y9a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+6760>>3]- +h[b+6784>>3];e=+h[b+6768>>3]- +h[b+6792>>3];f=+h[b+6776>>3]- +h[b+6800>>3];h[b+21496>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Z9a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+21496>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23592,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+21504>>3]=l;i=d;return}function _9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21512>>3]=+h[b+21504>>3];i=i;return}function $9a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6856>>3]=+h[b+21368>>3];i=i;return}function aab(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10424>>3]=+h[b+10448>>3]+ +h[(c[a+416>>2]|0)+6856>>3];i=i;return}function bab(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10112>>3]=+h[b+10424>>3]+ +h[(c[a+416>>2]|0)+10448>>3];i=i;return}function cab(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+6856>>3]- +h[b+6880>>3];e=+h[b+6864>>3]- +h[b+6888>>3];f=+h[b+6872>>3]- +h[b+6896>>3];h[b+21528>>3]=+V(+(d*d+e*e+f*f));i=i;return}function dab(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+21528>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23600,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+21536>>3]=l;i=d;return}function eab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21544>>3]=+h[b+21536>>3];i=i;return}function fab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6952>>3]=+h[b+21368>>3]+ +h[b+21384>>3]*-.5;i=i;return}function gab(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9968>>3]=+h[b+9992>>3]+ +h[(c[a+416>>2]|0)+6952>>3];i=i;return}function hab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6960>>3]=+h[b+21376>>3];i=i;return}function iab(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+6952>>3]- +h[b+6976>>3];e=+h[b+6960>>3]- +h[b+6984>>3];f=+h[b+6968>>3]- +h[b+6992>>3];h[b+21560>>3]=+V(+(d*d+e*e+f*f));i=i;return}function jab(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+21560>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23608,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+21568>>3]=l;i=d;return}function kab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21576>>3]=+h[b+21568>>3];i=i;return}function lab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7048>>3]=+h[b+21368>>3]+ +h[b+21384>>3]*-.5;i=i;return}function mab(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10640>>3]=+h[b+10808>>3]+ +h[(c[a+416>>2]|0)+7048>>3];i=i;return}function nab(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9944>>3]=+h[b+9968>>3]- +h[b+10640>>3];i=i;return}function oab(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9920>>3]=+h[b+15136>>3]- +h[b+9944>>3];i=i;return}function pab(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9896>>3]=+h[b+10640>>3]- +h[b+9968>>3];i=i;return}function qab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21584>>3]=+h[b+21392>>3];i=i;return}function rab(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+7048>>3]- +h[b+7168>>3];e=+h[b+7056>>3]- +h[b+7176>>3];f=+h[b+7064>>3]- +h[b+7184>>3];h[b+21600>>3]=+V(+(d*d+e*e+f*f));i=i;return}function sab(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+21600>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23616,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+21608>>3]=l;i=d;return}function tab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21616>>3]=+h[b+21608>>3];i=i;return}function uab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21624>>3]=+h[b+21400>>3];i=i;return}function vab(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+7432>>3]- +h[b+7552>>3];e=+h[b+7440>>3]- +h[b+7560>>3];f=+h[b+7448>>3]- +h[b+7568>>3];h[b+21640>>3]=+V(+(d*d+e*e+f*f));i=i;return}function wab(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+21640>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23624,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+21648>>3]=l;i=d;return}function xab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21656>>3]=+h[b+21648>>3];i=i;return}function yab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21664>>3]=+h[b+21408>>3]*.5;i=i;return}function zab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21672>>3]=+h[b+21448>>3]*.5;i=i;return}function Aab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7896>>3]=-+h[b+21408>>3];i=i;return}function Bab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21688>>3]=-+h[b+21360>>3];i=i;return}function Cab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21704>>3]=+h[b+18928>>3];i=i;return}function Dab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21712>>3]=+h[b+18936>>3];i=i;return}function Eab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21720>>3]=+h[b+18936>>3];i=i;return}function Fab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21728>>3]=+h[b+21688>>3];i=i;return}function Gab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21736>>3]=+h[b+21696>>3];i=i;return}function Hab(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+129|0]=a[d+126|0]|0;i=i;return}function Iab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21744>>3]=+h[b+18928>>3];i=i;return}function Jab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21752>>3]=+h[b+18936>>3];i=i;return}function Kab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21760>>3]=+h[b+18928>>3];i=i;return}function Lab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21768>>3]=+h[b+18936>>3];i=i;return}function Mab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21776>>3]=+h[b+21744>>3]*.5;i=i;return}function Nab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21784>>3]=+h[b+21752>>3];i=i;return}function Oab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21792>>3]=+h[b+21776>>3];i=i;return}function Pab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21800>>3]=+h[b+21880>>3];i=i;return}function Qab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21808>>3]=+h[b+21880>>3];i=i;return}function Rab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21816>>3]=+h[b+21728>>3];i=i;return}function Sab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21824>>3]=+h[b+21736>>3];i=i;return}function Tab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21832>>3]=+h[b+21752>>3];i=i;return}function Uab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21840>>3]=+h[b+21784>>3];i=i;return}function Vab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21856>>3]=+h[b+21744>>3];i=i;return}function Wab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21864>>3]=+h[b+21760>>3];i=i;return}function Xab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21872>>3]=+h[b+21768>>3];i=i;return}function Yab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21888>>3]=+h[b+21776>>3];i=i;return}function Zab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21896>>3]=+h[b+21776>>3];i=i;return}function _ab(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+8392>>3];e=-.1- +h[b+8400>>3];f=+h[b+8408>>3];h[b+21912>>3]=+V(+(f*f+(d*d+e*e)));i=i;return}function $ab(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21920>>3]=+h[b+21792>>3];i=i;return}function abb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21928>>3]=+h[b+21792>>3];i=i;return}function bbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21936>>3]=+h[b+21712>>3]*1.1;i=i;return}function cbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21944>>3]=+h[b+21720>>3];i=i;return}function dbb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+138|0]=a[d+119|0]|0;i=i;return}function ebb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8520>>3]=+h[b+21448>>3];i=i;return}function fbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8544>>3]=+h[b+21448>>3]*.5;i=i;return}function gbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21992>>3]=+h[b+21456>>3];i=i;return}function hbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22e3>>3]=+h[b+21464>>3];i=i;return}function ibb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22008>>3]=+h[b+21472>>3];i=i;return}function jbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22016>>3]=+h[b+21480>>3];i=i;return}function kbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8680>>3]=+h[b+8512>>3];i=i;return}function lbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8688>>3]=+h[b+8520>>3];i=i;return}function mbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8696>>3]=+h[b+8528>>3];i=i;return}function nbb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+8680>>3]- +h[b+8704>>3];e=+h[b+8688>>3]- +h[b+8712>>3];f=+h[b+8696>>3]- +h[b+8720>>3];h[b+22064>>3]=+V(+(d*d+e*e+f*f));i=i;return}function obb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+22064>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23632,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+22072>>3]=l;i=d;return}function pbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22080>>3]=+h[b+22072>>3];i=i;return}function qbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22088>>3]=+h[b+21448>>3]/1.75;i=i;return}function rbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8800>>3]=+h[b+8536>>3];i=i;return}function sbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8808>>3]=+h[b+8544>>3];i=i;return}function tbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8816>>3]=+h[b+8552>>3];i=i;return}function ubb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22096>>3]=+h[b+21992>>3];i=i;return}function vbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22104>>3]=+h[b+22e3>>3];i=i;return}function wbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22112>>3]=+h[b+22008>>3];i=i;return}function xbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22120>>3]=+h[b+22016>>3];i=i;return}function ybb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22128>>3]=+h[b+22024>>3];i=i;return}function zbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22136>>3]=+h[b+22032>>3];i=i;return}function Abb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22144>>3]=+h[b+22040>>3];i=i;return}function Bbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8824>>3]=+h[b+8560>>3];i=i;return}function Cbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8832>>3]=+h[b+8568>>3];i=i;return}function Dbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8840>>3]=+h[b+8576>>3];i=i;return}function Ebb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8848>>3]=+h[b+8584>>3];i=i;return}function Fbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8856>>3]=+h[b+8592>>3];i=i;return}function Gbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8864>>3]=+h[b+8600>>3];i=i;return}function Hbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8872>>3]=+h[b+8608>>3];i=i;return}function Ibb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8880>>3]=+h[b+8616>>3];i=i;return}function Jbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8888>>3]=+h[b+8624>>3];i=i;return}function Kbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8896>>3]=+h[b+8824>>3];i=i;return}function Lbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8904>>3]=+h[b+8832>>3];i=i;return}function Mbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8912>>3]=+h[b+8840>>3];i=i;return}function Nbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22152>>3]=+h[b+18960>>3];i=i;return}function Obb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+9112>>3]=l;i=b;return}function Pbb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+9120>>3]=l;i=b;return}function Qbb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+9128>>3]=l;i=b;return}function Rbb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+9136>>3]=l;i=b;return}function Sbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22160>>3]=+h[b+22152>>3]/3.0;i=i;return}function Tbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22168>>3]=+h[b+21448>>3]/1.75;i=i;return}function Ubb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22176>>3]=+h[b+21448>>3]/1.75;i=i;return}function Vbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22184>>3]=+h[b+22168>>3]*2.0;i=i;return}function Wbb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+176>>2]=c[b+168>>2];i=i;return}function Xbb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+152|0]=a[d+119|0]|0;i=i;return}function Ybb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9152>>3]=+h[b+21408>>3];i=i;return}function Zbb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9176>>3]=+h[b+21408>>3]*.5;i=i;return}function _bb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22192>>3]=+h[b+21416>>3];i=i;return}function $bb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22200>>3]=+h[b+21424>>3];i=i;return}function acb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22208>>3]=+h[b+21432>>3];i=i;return}function bcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22216>>3]=+h[b+21440>>3];i=i;return}function ccb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9312>>3]=+h[b+9144>>3];i=i;return}function dcb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10520>>3]=+h[b+10640>>3]- +h[(c[a+416>>2]|0)+9312>>3];i=i;return}function ecb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9320>>3]=+h[b+9152>>3];i=i;return}function fcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9328>>3]=+h[b+9160>>3];i=i;return}function gcb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+9312>>3]- +h[b+9336>>3];e=+h[b+9320>>3]- +h[b+9344>>3];f=+h[b+9328>>3]- +h[b+9352>>3];h[b+22264>>3]=+V(+(d*d+e*e+f*f));i=i;return}function hcb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+22264>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23640,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+22272>>3]=l;i=d;return}function icb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22280>>3]=+h[b+22272>>3];i=i;return}function jcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9432>>3]=+h[b+9168>>3];i=i;return}function kcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9440>>3]=+h[b+9176>>3];i=i;return}function lcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9448>>3]=+h[b+9184>>3];i=i;return}function mcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22296>>3]=+h[b+22192>>3];i=i;return}function ncb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22304>>3]=+h[b+22200>>3];i=i;return}function ocb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22312>>3]=+h[b+22208>>3];i=i;return}function pcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22320>>3]=+h[b+22216>>3];i=i;return}function qcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22328>>3]=+h[b+22224>>3];i=i;return}function rcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22336>>3]=+h[b+22232>>3];i=i;return}function scb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22344>>3]=+h[b+22240>>3];i=i;return}function tcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9456>>3]=+h[b+9192>>3];i=i;return}function ucb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9464>>3]=+h[b+9200>>3];i=i;return}function vcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9472>>3]=+h[b+9208>>3];i=i;return}function wcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9480>>3]=+h[b+9216>>3];i=i;return}function xcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9488>>3]=+h[b+9224>>3];i=i;return}function ycb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9496>>3]=+h[b+9232>>3];i=i;return}function zcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9504>>3]=+h[b+9240>>3];i=i;return}function Acb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9512>>3]=+h[b+9248>>3];i=i;return}function Bcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9520>>3]=+h[b+9256>>3];i=i;return}function Ccb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9528>>3]=+h[b+9456>>3];i=i;return}function Dcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9536>>3]=+h[b+9464>>3];i=i;return}function Ecb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9544>>3]=+h[b+9472>>3];i=i;return}function Fcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22352>>3]=+h[b+18960>>3];i=i;return}function Gcb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+9744>>3]=l;i=b;return}function Hcb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+9752>>3]=l;i=b;return}function Icb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+9760>>3]=l;i=b;return}function Jcb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+9768>>3]=l;i=b;return}function Kcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22360>>3]=+h[b+22352>>3]/3.0;i=i;return}function Lcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22384>>3]=+h[b+22368>>3]*2.0;i=i;return}function Mcb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+188>>2]=c[b+180>>2];i=i;return}function Ncb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+166|0]=a[d+119|0]|0;i=i;return}function Ocb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+196>>2]=c[b+192>>2];i=i;return}function Pcb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+167|0]=a[d+6|0]|0;i=i;return}function Qcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9776>>3]=+h[b+22400>>3];i=i;return}function Rcb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10760>>3]=+h[b+10784>>3]+ +h[(c[a+416>>2]|0)+9776>>3];i=i;return}function Scb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+9776>>3]- +h[b+9800>>3];e=+h[b+9784>>3]- +h[b+9808>>3];f=+h[b+9792>>3]- +h[b+9816>>3];h[b+22528>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Tcb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+22528>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23648,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+22536>>3]=l;i=d;return}function Ucb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22544>>3]=+h[b+22536>>3];i=i;return}function Vcb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9872>>3]=+h[b+22400>>3];i=i;return}function Wcb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10400>>3]=+h[b+10424>>3]+ +h[(c[a+416>>2]|0)+9872>>3];i=i;return}function Xcb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10232>>3]=+h[b+10400>>3]+ +h[(c[a+416>>2]|0)+13464>>3];i=i;return}function Ycb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+9872>>3]- +h[b+9896>>3];e=+h[b+9880>>3]- +h[b+9904>>3];f=+h[b+9888>>3]- +h[b+9912>>3];h[b+22560>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Zcb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+22560>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23656,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+22568>>3]=l;i=d;return}function _cb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22576>>3]=+h[b+22568>>3];i=i;return}function $cb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9968>>3]=+h[b+22400>>3]+ +h[b+22416>>3]*-.5;i=i;return}function adb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10088>>3]=+h[b+10112>>3]+ +h[(c[a+416>>2]|0)+9968>>3];i=i;return}function bdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9976>>3]=+h[b+22408>>3];i=i;return}function cdb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+9968>>3]- +h[b+9992>>3];e=+h[b+9976>>3]- +h[b+1e4>>3];f=+h[b+9984>>3]- +h[b+10008>>3];h[b+22592>>3]=+V(+(d*d+e*e+f*f));i=i;return}function ddb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+22592>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23664,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+22600>>3]=l;i=d;return}function edb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22608>>3]=+h[b+22600>>3];i=i;return}function fdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10064>>3]=+h[b+22400>>3]+ +h[b+22416>>3]*-.5;i=i;return}function gdb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10664>>3]=+h[b+10784>>3]+ +h[(c[a+416>>2]|0)+10064>>3];i=i;return}function hdb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10064>>3]=+h[b+10088>>3]- +h[b+10664>>3];i=i;return}function idb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10040>>3]=+h[b+15160>>3]- +h[b+10064>>3];i=i;return}function jdb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10016>>3]=+h[b+10664>>3]- +h[b+10088>>3];i=i;return}function kdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22616>>3]=+h[b+22424>>3];i=i;return}function ldb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+10064>>3]- +h[b+10184>>3];e=+h[b+10072>>3]- +h[b+10192>>3];f=+h[b+10080>>3]- +h[b+10200>>3];h[b+22632>>3]=+V(+(d*d+e*e+f*f));i=i;return}function mdb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+22632>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23672,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+22640>>3]=l;i=d;return}function ndb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22648>>3]=+h[b+22640>>3];i=i;return}function odb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22656>>3]=+h[b+22432>>3];i=i;return}function pdb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+10448>>3]- +h[b+10568>>3];e=+h[b+10456>>3]- +h[b+10576>>3];f=+h[b+10464>>3]- +h[b+10584>>3];h[b+22672>>3]=+V(+(d*d+e*e+f*f));i=i;return}function qdb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+22672>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23680,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+22680>>3]=l;i=d;return}function rdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22688>>3]=+h[b+22680>>3];i=i;return}function sdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22696>>3]=+h[b+22440>>3]*.5;i=i;return}function tdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22704>>3]=+h[b+22480>>3]*.5;i=i;return}function udb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10912>>3]=-+h[b+22440>>3];i=i;return}function vdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22720>>3]=-+h[b+22392>>3];i=i;return}function wdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22736>>3]=+h[b+18928>>3];i=i;return}function xdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22744>>3]=+h[b+18936>>3];i=i;return}function ydb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22752>>3]=+h[b+18936>>3];i=i;return}function zdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22760>>3]=+h[b+22720>>3];i=i;return}function Adb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22768>>3]=+h[b+22728>>3];i=i;return}function Bdb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+177|0]=a[d+174|0]|0;i=i;return}function Cdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22776>>3]=+h[b+18928>>3];i=i;return}function Ddb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22784>>3]=+h[b+18936>>3];i=i;return}function Edb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22792>>3]=+h[b+18928>>3];i=i;return}function Fdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22800>>3]=+h[b+18936>>3];i=i;return}function Gdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22808>>3]=+h[b+22776>>3]*.5;i=i;return}function Hdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22816>>3]=+h[b+22784>>3];i=i;return}function Idb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22824>>3]=+h[b+22808>>3];i=i;return}function Jdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22832>>3]=+h[b+22912>>3];i=i;return}function Kdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22840>>3]=+h[b+22912>>3];i=i;return}function Ldb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22848>>3]=+h[b+22760>>3];i=i;return}function Mdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22856>>3]=+h[b+22768>>3];i=i;return}function Ndb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22864>>3]=+h[b+22784>>3];i=i;return}function Odb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22872>>3]=+h[b+22816>>3];i=i;return}function Pdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22888>>3]=+h[b+22776>>3];i=i;return}function Qdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22896>>3]=+h[b+22792>>3];i=i;return}function Rdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22904>>3]=+h[b+22800>>3];i=i;return}function Sdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22920>>3]=+h[b+22808>>3];i=i;return}function Tdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22928>>3]=+h[b+22808>>3];i=i;return}function Udb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+11408>>3];e=-.1- +h[b+11416>>3];f=+h[b+11424>>3];h[b+22944>>3]=+V(+(f*f+(d*d+e*e)));i=i;return}function Vdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22952>>3]=+h[b+22824>>3];i=i;return}function Wdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22960>>3]=+h[b+22824>>3];i=i;return}function Xdb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22968>>3]=+h[b+22744>>3]*1.1;i=i;return}function Ydb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22976>>3]=+h[b+22752>>3];i=i;return}function Zdb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+186|0]=a[d+167|0]|0;i=i;return}function _db(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11536>>3]=+h[b+22480>>3];i=i;return}function $db(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11560>>3]=+h[b+22480>>3]*.5;i=i;return}function aeb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23024>>3]=+h[b+22488>>3];i=i;return}function beb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23032>>3]=+h[b+22496>>3];i=i;return}function ceb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23040>>3]=+h[b+22504>>3];i=i;return}function deb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23048>>3]=+h[b+22512>>3];i=i;return}function eeb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11696>>3]=+h[b+11528>>3];i=i;return}function feb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11704>>3]=+h[b+11536>>3];i=i;return}function geb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11712>>3]=+h[b+11544>>3];i=i;return}function heb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+11696>>3]- +h[b+11720>>3];e=+h[b+11704>>3]- +h[b+11728>>3];f=+h[b+11712>>3]- +h[b+11736>>3];h[b+23096>>3]=+V(+(d*d+e*e+f*f));i=i;return}function ieb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+23096>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23688,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+23104>>3]=l;i=d;return}function jeb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23112>>3]=+h[b+23104>>3];i=i;return}function keb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23120>>3]=+h[b+22480>>3]/1.75;i=i;return}function leb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11816>>3]=+h[b+11552>>3];i=i;return}function meb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11824>>3]=+h[b+11560>>3];i=i;return}function neb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11832>>3]=+h[b+11568>>3];i=i;return}function oeb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23128>>3]=+h[b+23024>>3];i=i;return}function peb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23136>>3]=+h[b+23032>>3];i=i;return}function qeb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23144>>3]=+h[b+23040>>3];i=i;return}function reb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23152>>3]=+h[b+23048>>3];i=i;return}function seb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23160>>3]=+h[b+23056>>3];i=i;return}function teb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23168>>3]=+h[b+23064>>3];i=i;return}function ueb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23176>>3]=+h[b+23072>>3];i=i;return}function veb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11840>>3]=+h[b+11576>>3];i=i;return}function web(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11848>>3]=+h[b+11584>>3];i=i;return}function xeb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11856>>3]=+h[b+11592>>3];i=i;return}function yeb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11864>>3]=+h[b+11600>>3];i=i;return}function zeb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11872>>3]=+h[b+11608>>3];i=i;return}function Aeb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11880>>3]=+h[b+11616>>3];i=i;return}function Beb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11888>>3]=+h[b+11624>>3];i=i;return}function Ceb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11896>>3]=+h[b+11632>>3];i=i;return}function Deb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11904>>3]=+h[b+11640>>3];i=i;return}function Eeb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11912>>3]=+h[b+11840>>3];i=i;return}function Feb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11920>>3]=+h[b+11848>>3];i=i;return}function Geb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11928>>3]=+h[b+11856>>3];i=i;return}function Heb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23184>>3]=+h[b+18960>>3];i=i;return}function Ieb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+12128>>3]=l;i=b;return}function Jeb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+12136>>3]=l;i=b;return}function Keb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+12144>>3]=l;i=b;return}function Leb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+12152>>3]=l;i=b;return}function Meb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23192>>3]=+h[b+23184>>3]/3.0;i=i;return}function Neb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23200>>3]=+h[b+22480>>3]/1.75;i=i;return}function Oeb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23208>>3]=+h[b+22480>>3]/1.75;i=i;return}function Peb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23216>>3]=+h[b+23200>>3]*2.0;i=i;return}function Qeb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+236>>2]=c[b+228>>2];i=i;return}function Reb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+200|0]=a[d+167|0]|0;i=i;return}function Seb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12168>>3]=+h[b+22440>>3];i=i;return}function Teb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12192>>3]=+h[b+22440>>3]*.5;i=i;return}function Ueb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23224>>3]=+h[b+22448>>3];i=i;return}function Veb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23232>>3]=+h[b+22456>>3];i=i;return}function Web(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23240>>3]=+h[b+22464>>3];i=i;return}function Xeb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23248>>3]=+h[b+22472>>3];i=i;return}function Yeb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12328>>3]=+h[b+12160>>3];i=i;return}function Zeb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10544>>3]=+h[b+10664>>3]- +h[(c[a+416>>2]|0)+12328>>3];i=i;return}function _eb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12336>>3]=+h[b+12168>>3];i=i;return}function $eb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12344>>3]=+h[b+12176>>3];i=i;return}function afb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+12328>>3]- +h[b+12352>>3];e=+h[b+12336>>3]- +h[b+12360>>3];f=+h[b+12344>>3]- +h[b+12368>>3];h[b+23296>>3]=+V(+(d*d+e*e+f*f));i=i;return}function bfb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+23296>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23696,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+23304>>3]=l;i=d;return}function cfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23312>>3]=+h[b+23304>>3];i=i;return}function dfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12448>>3]=+h[b+12184>>3];i=i;return}function efb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12456>>3]=+h[b+12192>>3];i=i;return}function ffb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12464>>3]=+h[b+12200>>3];i=i;return}function gfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23328>>3]=+h[b+23224>>3];i=i;return}function hfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23336>>3]=+h[b+23232>>3];i=i;return}function ifb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23344>>3]=+h[b+23240>>3];i=i;return}function jfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23352>>3]=+h[b+23248>>3];i=i;return}function kfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23360>>3]=+h[b+23256>>3];i=i;return}function lfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23368>>3]=+h[b+23264>>3];i=i;return}function mfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23376>>3]=+h[b+23272>>3];i=i;return}function nfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12472>>3]=+h[b+12208>>3];i=i;return}function ofb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12480>>3]=+h[b+12216>>3];i=i;return}function pfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12488>>3]=+h[b+12224>>3];i=i;return}function qfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12496>>3]=+h[b+12232>>3];i=i;return}function rfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12504>>3]=+h[b+12240>>3];i=i;return}function sfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12512>>3]=+h[b+12248>>3];i=i;return}function tfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12520>>3]=+h[b+12256>>3];i=i;return}function ufb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12528>>3]=+h[b+12264>>3];i=i;return}function vfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12536>>3]=+h[b+12272>>3];i=i;return}function wfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12544>>3]=+h[b+12472>>3];i=i;return}function xfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12552>>3]=+h[b+12480>>3];i=i;return}function yfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12560>>3]=+h[b+12488>>3];i=i;return}function zfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23384>>3]=+h[b+18960>>3];i=i;return}function Afb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+12760>>3]=l;i=b;return}function Bfb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+12768>>3]=l;i=b;return}function Cfb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+12776>>3]=l;i=b;return}function Dfb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+12784>>3]=l;i=b;return}function Efb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23392>>3]=+h[b+23384>>3]/3.0;i=i;return}function Ffb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23416>>3]=+h[b+23400>>3]*2.0;i=i;return}function Gfb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+248>>2]=c[b+240>>2];i=i;return}function Hfb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+214|0]=a[d+167|0]|0;i=i;return}function Ifb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+256>>2]=c[b+252>>2];i=i;return}function Jfb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+215|0]=a[d+6|0]|0;i=i;return}function Kfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12792>>3]=+h[b+23432>>3];i=i;return}function Lfb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10736>>3]=+h[b+10760>>3]+ +h[(c[a+416>>2]|0)+12792>>3];i=i;return}function Mfb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+12792>>3]- +h[b+12816>>3];e=+h[b+12800>>3]- +h[b+12824>>3];f=+h[b+12808>>3]- +h[b+12832>>3];h[b+23560>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Nfb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+23560>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23704,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+23568>>3]=l;i=d;return}function Ofb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23576>>3]=+h[b+23568>>3];i=i;return}function Pfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12888>>3]=+h[b+23432>>3];i=i;return}function Qfb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10376>>3]=+h[b+10400>>3]+ +h[(c[a+416>>2]|0)+12888>>3];i=i;return}function Rfb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10352>>3]=+h[b+10376>>3]+ +h[(c[a+416>>2]|0)+16480>>3];i=i;return}function Sfb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+12888>>3]- +h[b+12912>>3];e=+h[b+12896>>3]- +h[b+12920>>3];f=+h[b+12904>>3]- +h[b+12928>>3];h[b+23592>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Tfb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+23592>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23712,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+23600>>3]=l;i=d;return}function Ufb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23608>>3]=+h[b+23600>>3];i=i;return}function Vfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12984>>3]=+h[b+23432>>3]+ +h[b+23448>>3]*-.5;i=i;return}function Wfb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10208>>3]=+h[b+10232>>3]+ +h[(c[a+416>>2]|0)+12984>>3];i=i;return}function Xfb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12992>>3]=+h[b+23440>>3];i=i;return}function Yfb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+12984>>3]- +h[b+13008>>3];e=+h[b+12992>>3]- +h[b+13016>>3];f=+h[b+13e3>>3]- +h[b+13024>>3];h[b+23624>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Zfb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+23624>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23720,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+23632>>3]=l;i=d;return}function _fb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23640>>3]=+h[b+23632>>3];i=i;return}function $fb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13080>>3]=+h[b+23432>>3]+ +h[b+23448>>3]*-.5;i=i;return}function agb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10688>>3]=+h[b+10760>>3]+ +h[(c[a+416>>2]|0)+13080>>3];i=i;return}function bgb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10184>>3]=+h[b+10208>>3]- +h[b+10688>>3];i=i;return}function cgb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10160>>3]=+h[b+15184>>3]- +h[b+10184>>3];i=i;return}function dgb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10136>>3]=+h[b+10688>>3]- +h[b+10208>>3];i=i;return}function egb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23648>>3]=+h[b+23456>>3];i=i;return}function fgb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+13080>>3]- +h[b+13200>>3];e=+h[b+13088>>3]- +h[b+13208>>3];f=+h[b+13096>>3]- +h[b+13216>>3];h[b+23664>>3]=+V(+(d*d+e*e+f*f));i=i;return}function ggb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+23664>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23728,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+23672>>3]=l;i=d;return}function hgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23680>>3]=+h[b+23672>>3];i=i;return}function igb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23688>>3]=+h[b+23464>>3];i=i;return}function jgb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+13464>>3]- +h[b+13584>>3];e=+h[b+13472>>3]- +h[b+13592>>3];f=+h[b+13480>>3]- +h[b+13600>>3];h[b+23704>>3]=+V(+(d*d+e*e+f*f));i=i;return}function kgb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+23704>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23736,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+23712>>3]=l;i=d;return}function lgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23720>>3]=+h[b+23712>>3];i=i;return}function mgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23728>>3]=+h[b+23472>>3]*.5;i=i;return}function ngb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23736>>3]=+h[b+23512>>3]*.5;i=i;return}function ogb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13928>>3]=-+h[b+23472>>3];i=i;return}function pgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23752>>3]=-+h[b+23424>>3];i=i;return}function qgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23768>>3]=+h[b+18928>>3];i=i;return}function rgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23776>>3]=+h[b+18936>>3];i=i;return}function sgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23784>>3]=+h[b+18936>>3];i=i;return}function tgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23792>>3]=+h[b+23752>>3];i=i;return}function ugb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23800>>3]=+h[b+23760>>3];i=i;return}function vgb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+225|0]=a[d+222|0]|0;i=i;return}function wgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23808>>3]=+h[b+18928>>3];i=i;return}function xgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23816>>3]=+h[b+18936>>3];i=i;return}function ygb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23824>>3]=+h[b+18928>>3];i=i;return}function zgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23832>>3]=+h[b+18936>>3];i=i;return}function Agb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23840>>3]=+h[b+23808>>3]*.5;i=i;return}function Bgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23848>>3]=+h[b+23816>>3];i=i;return}function Cgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23856>>3]=+h[b+23840>>3];i=i;return}function Dgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23864>>3]=+h[b+23944>>3];i=i;return}function Egb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23872>>3]=+h[b+23944>>3];i=i;return}function Fgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23880>>3]=+h[b+23792>>3];i=i;return}function Ggb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23888>>3]=+h[b+23800>>3];i=i;return}function Hgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23896>>3]=+h[b+23816>>3];i=i;return}function Igb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23904>>3]=+h[b+23848>>3];i=i;return}function Jgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23920>>3]=+h[b+23808>>3];i=i;return}function Kgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23928>>3]=+h[b+23824>>3];i=i;return}function Lgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23936>>3]=+h[b+23832>>3];i=i;return}function Mgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23952>>3]=+h[b+23840>>3];i=i;return}function Ngb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23960>>3]=+h[b+23840>>3];i=i;return}function Ogb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+14424>>3];e=-.1- +h[b+14432>>3];f=+h[b+14440>>3];h[b+23976>>3]=+V(+(f*f+(d*d+e*e)));i=i;return}function Pgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23984>>3]=+h[b+23856>>3];i=i;return}function Qgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23992>>3]=+h[b+23856>>3];i=i;return}function Rgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24e3>>3]=+h[b+23776>>3]*1.1;i=i;return}function Sgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24008>>3]=+h[b+23784>>3];i=i;return}function Tgb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+234|0]=a[d+215|0]|0;i=i;return}function Ugb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14552>>3]=+h[b+23512>>3];i=i;return}function Vgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14576>>3]=+h[b+23512>>3]*.5;i=i;return}function Wgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24056>>3]=+h[b+23520>>3];i=i;return}function Xgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24064>>3]=+h[b+23528>>3];i=i;return}function Ygb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24072>>3]=+h[b+23536>>3];i=i;return}function Zgb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24080>>3]=+h[b+23544>>3];i=i;return}function _gb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14712>>3]=+h[b+14544>>3];i=i;return}function $gb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14720>>3]=+h[b+14552>>3];i=i;return}function ahb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14728>>3]=+h[b+14560>>3];i=i;return}function bhb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+14712>>3]- +h[b+14736>>3];e=+h[b+14720>>3]- +h[b+14744>>3];f=+h[b+14728>>3]- +h[b+14752>>3];h[b+24128>>3]=+V(+(d*d+e*e+f*f));i=i;return}function chb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+24128>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23744,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+24136>>3]=l;i=d;return}function dhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24144>>3]=+h[b+24136>>3];i=i;return}function ehb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24152>>3]=+h[b+23512>>3]/1.75;i=i;return}function fhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14832>>3]=+h[b+14568>>3];i=i;return}function ghb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14840>>3]=+h[b+14576>>3];i=i;return}function hhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14848>>3]=+h[b+14584>>3];i=i;return}function ihb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24160>>3]=+h[b+24056>>3];i=i;return}function jhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24168>>3]=+h[b+24064>>3];i=i;return}function khb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24176>>3]=+h[b+24072>>3];i=i;return}function lhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24184>>3]=+h[b+24080>>3];i=i;return}function mhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24192>>3]=+h[b+24088>>3];i=i;return}function nhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24200>>3]=+h[b+24096>>3];i=i;return}function ohb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24208>>3]=+h[b+24104>>3];i=i;return}function phb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14856>>3]=+h[b+14592>>3];i=i;return}function qhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14864>>3]=+h[b+14600>>3];i=i;return}function rhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14872>>3]=+h[b+14608>>3];i=i;return}function shb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14880>>3]=+h[b+14616>>3];i=i;return}function thb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14888>>3]=+h[b+14624>>3];i=i;return}function uhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14896>>3]=+h[b+14632>>3];i=i;return}function vhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14904>>3]=+h[b+14640>>3];i=i;return}function whb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14912>>3]=+h[b+14648>>3];i=i;return}function xhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14920>>3]=+h[b+14656>>3];i=i;return}function yhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14928>>3]=+h[b+14856>>3];i=i;return}function zhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14936>>3]=+h[b+14864>>3];i=i;return}function Ahb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14944>>3]=+h[b+14872>>3];i=i;return}function Bhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24216>>3]=+h[b+18960>>3];i=i;return}function Chb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+15144>>3]=l;i=b;return}function Dhb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+15152>>3]=l;i=b;return}function Ehb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+15160>>3]=l;i=b;return}function Fhb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+15168>>3]=l;i=b;return}function Ghb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24224>>3]=+h[b+24216>>3]/3.0;i=i;return}function Hhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24232>>3]=+h[b+23512>>3]/1.75;i=i;return}function Ihb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24240>>3]=+h[b+23512>>3]/1.75;i=i;return}function Jhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24248>>3]=+h[b+24232>>3]*2.0;i=i;return}function Khb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+296>>2]=c[b+288>>2];i=i;return}function Lhb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+248|0]=a[d+215|0]|0;i=i;return}function Mhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15184>>3]=+h[b+23472>>3];i=i;return}function Nhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15208>>3]=+h[b+23472>>3]*.5;i=i;return}function Ohb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24256>>3]=+h[b+23480>>3];i=i;return}function Phb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24264>>3]=+h[b+23488>>3];i=i;return}function Qhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24272>>3]=+h[b+23496>>3];i=i;return}function Rhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24280>>3]=+h[b+23504>>3];i=i;return}function Shb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15344>>3]=+h[b+15176>>3];i=i;return}function Thb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10568>>3]=+h[b+10688>>3]- +h[(c[a+416>>2]|0)+15344>>3];i=i;return}function Uhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15352>>3]=+h[b+15184>>3];i=i;return}function Vhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15360>>3]=+h[b+15192>>3];i=i;return}function Whb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+15344>>3]- +h[b+15368>>3];e=+h[b+15352>>3]- +h[b+15376>>3];f=+h[b+15360>>3]- +h[b+15384>>3];h[b+24328>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Xhb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+24328>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23752,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+24336>>3]=l;i=d;return}function Yhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24344>>3]=+h[b+24336>>3];i=i;return}function Zhb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15464>>3]=+h[b+15200>>3];i=i;return}function _hb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15472>>3]=+h[b+15208>>3];i=i;return}function $hb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15480>>3]=+h[b+15216>>3];i=i;return}function aib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24360>>3]=+h[b+24256>>3];i=i;return}function bib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24368>>3]=+h[b+24264>>3];i=i;return}function cib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24376>>3]=+h[b+24272>>3];i=i;return}function dib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24384>>3]=+h[b+24280>>3];i=i;return}function eib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24392>>3]=+h[b+24288>>3];i=i;return}function fib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24400>>3]=+h[b+24296>>3];i=i;return}function gib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24408>>3]=+h[b+24304>>3];i=i;return}function hib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15488>>3]=+h[b+15224>>3];i=i;return}function iib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15496>>3]=+h[b+15232>>3];i=i;return}function jib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15504>>3]=+h[b+15240>>3];i=i;return}function kib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15512>>3]=+h[b+15248>>3];i=i;return}function lib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15520>>3]=+h[b+15256>>3];i=i;return}function mib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15528>>3]=+h[b+15264>>3];i=i;return}function nib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15536>>3]=+h[b+15272>>3];i=i;return}function oib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15544>>3]=+h[b+15280>>3];i=i;return}function pib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15552>>3]=+h[b+15288>>3];i=i;return}function qib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15560>>3]=+h[b+15488>>3];i=i;return}function rib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15568>>3]=+h[b+15496>>3];i=i;return}function sib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15576>>3]=+h[b+15504>>3];i=i;return}function tib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24416>>3]=+h[b+18960>>3];i=i;return}function uib(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+15776>>3]=l;i=b;return}function vib(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+15784>>3]=l;i=b;return}function wib(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+15792>>3]=l;i=b;return}function xib(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+15800>>3]=l;i=b;return}function yib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24424>>3]=+h[b+24416>>3]/3.0;i=i;return}function zib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24448>>3]=+h[b+24432>>3]*2.0;i=i;return}function Aib(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+308>>2]=c[b+300>>2];i=i;return}function Bib(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+262|0]=a[d+215|0]|0;i=i;return}function Cib(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+316>>2]=c[b+312>>2];i=i;return}function Dib(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+263|0]=a[d+6|0]|0;i=i;return}function Eib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15808>>3]=+h[b+24464>>3];i=i;return}function Fib(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7776>>3]=+h[b+10736>>3]+ +h[(c[a+416>>2]|0)+15808>>3];i=i;return}function Gib(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+15808>>3]- +h[b+15832>>3];e=+h[b+15816>>3]- +h[b+15840>>3];f=+h[b+15824>>3]- +h[b+15848>>3];h[b+24592>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Hib(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+24592>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23760,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+24600>>3]=l;i=d;return}function Iib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24608>>3]=+h[b+24600>>3];i=i;return}function Jib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15904>>3]=+h[b+24464>>3];i=i;return}function Kib(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7800>>3]=+h[b+10376>>3]+ +h[(c[a+416>>2]|0)+15904>>3];i=i;return}function Lib(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+15904>>3]- +h[b+15928>>3];e=+h[b+15912>>3]- +h[b+15936>>3];f=+h[b+15920>>3]- +h[b+15944>>3];h[b+24624>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Mib(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+24624>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23768,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+24632>>3]=l;i=d;return}function Nib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24640>>3]=+h[b+24632>>3];i=i;return}function Oib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16e3>>3]=+h[b+24464>>3]+ +h[b+24480>>3]*-.5;i=i;return}function Pib(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10328>>3]=+h[b+10352>>3]+ +h[(c[a+416>>2]|0)+16e3>>3];i=i;return}function Qib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16008>>3]=+h[b+24472>>3];i=i;return}function Rib(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+16e3>>3]- +h[b+16024>>3];e=+h[b+16008>>3]- +h[b+16032>>3];f=+h[b+16016>>3]- +h[b+16040>>3];h[b+24656>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Sib(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+24656>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23776,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+24664>>3]=l;i=d;return}function Tib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24672>>3]=+h[b+24664>>3];i=i;return}function Uib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16096>>3]=+h[b+24464>>3]+ +h[b+24480>>3]*-.5;i=i;return}function Vib(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10712>>3]=+h[b+10736>>3]+ +h[(c[a+416>>2]|0)+16096>>3];i=i;return}function Wib(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10304>>3]=+h[b+10328>>3]- +h[b+10712>>3];i=i;return}function Xib(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10280>>3]=+h[b+15208>>3]- +h[b+10304>>3];i=i;return}function Yib(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10256>>3]=+h[b+10712>>3]- +h[b+10328>>3];i=i;return}function Zib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24680>>3]=+h[b+24488>>3];i=i;return}function _ib(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+16096>>3]- +h[b+16216>>3];e=+h[b+16104>>3]- +h[b+16224>>3];f=+h[b+16112>>3]- +h[b+16232>>3];h[b+24696>>3]=+V(+(d*d+e*e+f*f));i=i;return}function $ib(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+24696>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23784,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+24704>>3]=l;i=d;return}function ajb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24712>>3]=+h[b+24704>>3];i=i;return}function bjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24720>>3]=+h[b+24496>>3];i=i;return}function cjb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+16480>>3]- +h[b+16600>>3];e=+h[b+16488>>3]- +h[b+16608>>3];f=+h[b+16496>>3]- +h[b+16616>>3];h[b+24736>>3]=+V(+(d*d+e*e+f*f));i=i;return}function djb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+24736>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23792,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+24744>>3]=l;i=d;return}function ejb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24752>>3]=+h[b+24744>>3];i=i;return}function fjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24760>>3]=+h[b+24504>>3]*.5;i=i;return}function gjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24768>>3]=+h[b+24544>>3]*.5;i=i;return}function hjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16944>>3]=-+h[b+24504>>3];i=i;return}function ijb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24784>>3]=-+h[b+24456>>3];i=i;return}function jjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24800>>3]=+h[b+18928>>3];i=i;return}function kjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24808>>3]=+h[b+18936>>3];i=i;return}function ljb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24816>>3]=+h[b+18936>>3];i=i;return}function mjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24824>>3]=+h[b+24784>>3];i=i;return}function njb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24832>>3]=+h[b+24792>>3];i=i;return}function ojb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+273|0]=a[d+270|0]|0;i=i;return}function pjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24840>>3]=+h[b+18928>>3];i=i;return}function qjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24848>>3]=+h[b+18936>>3];i=i;return}function rjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24856>>3]=+h[b+18928>>3];i=i;return}function sjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24864>>3]=+h[b+18936>>3];i=i;return}function tjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24872>>3]=+h[b+24840>>3]*.5;i=i;return}function ujb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24880>>3]=+h[b+24848>>3];i=i;return}function vjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24888>>3]=+h[b+24872>>3];i=i;return}function wjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24896>>3]=+h[b+24976>>3];i=i;return}function xjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24904>>3]=+h[b+24976>>3];i=i;return}function yjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24912>>3]=+h[b+24824>>3];i=i;return}function zjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24920>>3]=+h[b+24832>>3];i=i;return}function Ajb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24928>>3]=+h[b+24848>>3];i=i;return}function Bjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24936>>3]=+h[b+24880>>3];i=i;return}function Cjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24952>>3]=+h[b+24840>>3];i=i;return}function Djb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24960>>3]=+h[b+24856>>3];i=i;return}function Ejb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24968>>3]=+h[b+24864>>3];i=i;return}function Fjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24984>>3]=+h[b+24872>>3];i=i;return}function Gjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24992>>3]=+h[b+24872>>3];i=i;return}function Hjb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+17440>>3];e=-.1- +h[b+17448>>3];f=+h[b+17456>>3];h[b+25008>>3]=+V(+(f*f+(d*d+e*e)));i=i;return}function Ijb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25016>>3]=+h[b+24888>>3];i=i;return}function Jjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25024>>3]=+h[b+24888>>3];i=i;return}function Kjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25032>>3]=+h[b+24808>>3]*1.1;i=i;return}function Ljb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25040>>3]=+h[b+24816>>3];i=i;return}function Mjb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+282|0]=a[d+263|0]|0;i=i;return}function Njb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17568>>3]=+h[b+24544>>3];i=i;return}function Ojb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17592>>3]=+h[b+24544>>3]*.5;i=i;return}function Pjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25088>>3]=+h[b+24552>>3];i=i;return}function Qjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25096>>3]=+h[b+24560>>3];i=i;return}function Rjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25104>>3]=+h[b+24568>>3];i=i;return}function Sjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25112>>3]=+h[b+24576>>3];i=i;return}function Tjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17728>>3]=+h[b+17560>>3];i=i;return}function Ujb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17736>>3]=+h[b+17568>>3];i=i;return}function Vjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17744>>3]=+h[b+17576>>3];i=i;return}function Wjb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+17728>>3]- +h[b+17752>>3];e=+h[b+17736>>3]- +h[b+17760>>3];f=+h[b+17744>>3]- +h[b+17768>>3];h[b+25160>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Xjb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+25160>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23800,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+25168>>3]=l;i=d;return}function Yjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25176>>3]=+h[b+25168>>3];i=i;return}function Zjb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25184>>3]=+h[b+24544>>3]/1.75;i=i;return}function _jb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17848>>3]=+h[b+17584>>3];i=i;return}function $jb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17856>>3]=+h[b+17592>>3];i=i;return}function akb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17864>>3]=+h[b+17600>>3];i=i;return}function bkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25192>>3]=+h[b+25088>>3];i=i;return}function ckb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25200>>3]=+h[b+25096>>3];i=i;return}function dkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25208>>3]=+h[b+25104>>3];i=i;return}function ekb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25216>>3]=+h[b+25112>>3];i=i;return}function fkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25224>>3]=+h[b+25120>>3];i=i;return}function gkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25232>>3]=+h[b+25128>>3];i=i;return}function hkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25240>>3]=+h[b+25136>>3];i=i;return}function ikb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17872>>3]=+h[b+17608>>3];i=i;return}function jkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17880>>3]=+h[b+17616>>3];i=i;return}function kkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17888>>3]=+h[b+17624>>3];i=i;return}function lkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17896>>3]=+h[b+17632>>3];i=i;return}function mkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17904>>3]=+h[b+17640>>3];i=i;return}function nkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17912>>3]=+h[b+17648>>3];i=i;return}function okb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17920>>3]=+h[b+17656>>3];i=i;return}function pkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17928>>3]=+h[b+17664>>3];i=i;return}function qkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17936>>3]=+h[b+17672>>3];i=i;return}function rkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17944>>3]=+h[b+17872>>3];i=i;return}function skb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17952>>3]=+h[b+17880>>3];i=i;return}function tkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17960>>3]=+h[b+17888>>3];i=i;return}function ukb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25248>>3]=+h[b+18960>>3];i=i;return}function vkb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+18160>>3]=l;i=b;return}function wkb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+18168>>3]=l;i=b;return}function xkb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+18176>>3]=l;i=b;return}function ykb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+18184>>3]=l;i=b;return}function zkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25256>>3]=+h[b+25248>>3]/3.0;i=i;return}function Akb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25264>>3]=+h[b+24544>>3]/1.75;i=i;return}function Bkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25272>>3]=+h[b+24544>>3]/1.75;i=i;return}function Ckb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25280>>3]=+h[b+25264>>3]*2.0;i=i;return}function Dkb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+356>>2]=c[b+348>>2];i=i;return}function Ekb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+296|0]=a[d+263|0]|0;i=i;return}function Fkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18200>>3]=+h[b+24504>>3];i=i;return}function Gkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18224>>3]=+h[b+24504>>3]*.5;i=i;return}function Hkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25288>>3]=+h[b+24512>>3];i=i;return}function Ikb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25296>>3]=+h[b+24520>>3];i=i;return}function Jkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25304>>3]=+h[b+24528>>3];i=i;return}function Kkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25312>>3]=+h[b+24536>>3];i=i;return}function Lkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18360>>3]=+h[b+18192>>3];i=i;return}function Mkb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10592>>3]=+h[b+10712>>3]- +h[(c[a+416>>2]|0)+18360>>3];i=i;return}function Nkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18368>>3]=+h[b+18200>>3];i=i;return}function Okb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18376>>3]=+h[b+18208>>3];i=i;return}function Pkb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+18360>>3]- +h[b+18384>>3];e=+h[b+18368>>3]- +h[b+18392>>3];f=+h[b+18376>>3]- +h[b+18400>>3];h[b+25360>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Qkb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+25360>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23808,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+25368>>3]=l;i=d;return}function Rkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25376>>3]=+h[b+25368>>3];i=i;return}function Skb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18480>>3]=+h[b+18216>>3];i=i;return}function Tkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18488>>3]=+h[b+18224>>3];i=i;return}function Ukb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18496>>3]=+h[b+18232>>3];i=i;return}function Vkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25392>>3]=+h[b+25288>>3];i=i;return}function Wkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25400>>3]=+h[b+25296>>3];i=i;return}function Xkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25408>>3]=+h[b+25304>>3];i=i;return}function Ykb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25416>>3]=+h[b+25312>>3];i=i;return}function Zkb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25424>>3]=+h[b+25320>>3];i=i;return}function _kb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25432>>3]=+h[b+25328>>3];i=i;return}function $kb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25440>>3]=+h[b+25336>>3];i=i;return}function alb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18504>>3]=+h[b+18240>>3];i=i;return}function blb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18512>>3]=+h[b+18248>>3];i=i;return}function clb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18520>>3]=+h[b+18256>>3];i=i;return}function dlb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18528>>3]=+h[b+18264>>3];i=i;return}function elb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18536>>3]=+h[b+18272>>3];i=i;return}function flb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18544>>3]=+h[b+18280>>3];i=i;return}function glb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18552>>3]=+h[b+18288>>3];i=i;return}function hlb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18560>>3]=+h[b+18296>>3];i=i;return}function ilb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18568>>3]=+h[b+18304>>3];i=i;return}function jlb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18576>>3]=+h[b+18504>>3];i=i;return}function klb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18584>>3]=+h[b+18512>>3];i=i;return}function llb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18592>>3]=+h[b+18520>>3];i=i;return}function mlb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25448>>3]=+h[b+18960>>3];i=i;return}function nlb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+18792>>3]=l;i=b;return}function olb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+18800>>3]=l;i=b;return}function plb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+18808>>3]=l;i=b;return}function qlb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+18816>>3]=l;i=b;return}function rlb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25456>>3]=+h[b+25448>>3]/3.0;i=i;return}function slb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25480>>3]=+h[b+25464>>3]*2.0;i=i;return}function tlb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+368>>2]=c[b+360>>2];i=i;return}function ulb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+310|0]=a[d+263|0]|0;i=i;return}function vlb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+376>>2]=c[b+372>>2];i=i;return}function wlb(b){b=b|0;h[(c[b+416>>2]|0)+25528>>3]=(a[(c[b+424>>2]|0)+313|0]|0)!=0?.6435942529055827:1.0;i=i;return}function xlb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+25528>>3];j=+h[f+25512>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23824,23816,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+25536>>3]=l*6.283185307179586;i=d;return}function ylb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23840]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+892>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+892>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=xMb(23856,vMb(c[(c[g>>2]|0)+892>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=24120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[23840]=1;i=d;return}function zlb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24144]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25504>>3],1.0e-15)|0)<<24>>24==0)){i=d;return}b=xMb(24160,tMb(+h[(c[g>>2]|0)+25504>>3],24152)|0)|0;g=c[69978]|0;j=e;k=24336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[24144]=1;i=d;return}function Alb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24360]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+884>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+884>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=xMb(24368,vMb(c[(c[g>>2]|0)+884>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=24520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[24360]=1;i=d;return}function Blb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24544]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(24552,tMb(+h[(c[g>>2]|0)+25488>>3],24152)|0)|0;g=c[69978]|0;j=e;k=24624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[24544]=1;i=d;return}function Clb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24648]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(24656,tMb(+h[(c[g>>2]|0)+25480>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[24648]=1;i=d;return}function Dlb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24880]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(24888,tMb(+h[(c[g>>2]|0)+25472>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[24880]=1;i=d;return}function Elb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25008]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(25016,tMb(+h[(c[g>>2]|0)+25464>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[25008]=1;i=d;return}function Flb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25136]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(25144,tMb(+h[(c[g>>2]|0)+25456>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[25136]=1;i=d;return}function Glb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25296]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(25304,tMb(+h[(c[g>>2]|0)+25448>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[25296]=1;i=d;return}function Hlb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25448]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+764>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+764>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(25456,vMb(c[(c[g>>2]|0)+764>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[25448]=1;i=d;return}function Ilb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25680]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+760>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+760>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(25688,vMb(c[(c[g>>2]|0)+760>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[25680]=1;i=d;return}function Jlb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25912]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+756>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+756>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(25920,vMb(c[(c[g>>2]|0)+756>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[25912]=1;i=d;return}function Klb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26144]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+752>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+752>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(26152,vMb(c[(c[g>>2]|0)+752>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[26144]=1;i=d;return}function Llb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26360]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+748>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+748>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(26368,vMb(c[(c[g>>2]|0)+748>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[26360]=1;i=d;return}function Mlb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26576]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+744>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+744>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(26584,vMb(c[(c[g>>2]|0)+744>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[26576]=1;i=d;return}function Nlb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26792]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25440>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(26800,tMb(+h[(c[g>>2]|0)+25440>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[26792]=1;i=d;return}function Olb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26944]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25432>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(26952,tMb(+h[(c[g>>2]|0)+25432>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[26944]=1;i=d;return}function Plb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27096]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25424>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(27104,tMb(+h[(c[g>>2]|0)+25424>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[27096]=1;i=d;return}function Qlb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27248]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(27256,tMb(+h[(c[g>>2]|0)+25416>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[27248]=1;i=d;return}function Rlb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27384]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(27392,tMb(+h[(c[g>>2]|0)+25408>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[27384]=1;i=d;return}function Slb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27520]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(27528,tMb(+h[(c[g>>2]|0)+25400>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[27520]=1;i=d;return}function Tlb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27656]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(27664,tMb(+h[(c[g>>2]|0)+25392>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[27656]=1;i=d;return}function Ulb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27784]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(27792,tMb(+h[(c[g>>2]|0)+25376>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[27784]=1;i=d;return}function Vlb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27944]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(27952,tMb(+h[(c[g>>2]|0)+25368>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[27944]=1;i=d;return}function Wlb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28104]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+740>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+740>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(28112,vMb(c[(c[g>>2]|0)+740>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[28104]=1;i=d;return}



function ZPb(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];VLb(9,0,270432,z);z=CMb(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;ZLb(C,270472,y)}VLb(9,0,270512,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=DMb(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=cQb(c[d+(C*112|0)+4>>2]|0)|0;E=DMb(A,D)|0;bec(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((Bec(E,270552,6)|0)==0){if((c[233596>>2]|0)==0){break}}else{D=Bec(E,270560,6)|0;if((c[233596>>2]|D|0)==0){break}}c[v>>2]=E;XLb(9,0,270568,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;JMb(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];VLb(9,0,270536,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}VLb(9,0,270624,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=DMb(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=cQb(c[G+(w*112|0)+4>>2]|0)|0;v=DMb(A,F)|0;bec(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];XLb(9,0,270648,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;JMb(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];VLb(9,0,270536,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}VLb(9,0,270704,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=DMb(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=cQb(c[t+(x*112|0)+4>>2]|0)|0;K=DMb(A,C)|0;bec(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];XLb(9,0,270648,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;JMb(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];VLb(9,0,270536,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}VLb(9,0,270728,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=DMb(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=cQb(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=DMb(A,u)|0;bec(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];XLb(9,0,270776,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;JMb(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;VLb(9,0,270760,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}VLb(9,0,270832,l);l=b+144|0;if((c[l>>2]|0)<=0){AMb(A);i=f;return}o=b+32|0;b=0;do{x=DMb(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=cQb(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=DMb(A,n)|0;bec(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];XLb(9,0,270880,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;JMb(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?268824:268832;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;VLb(9,0,270864,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));AMb(A);i=f;return}function _Pb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;vOb(a,+h[a+240>>3]);KOb(a);POb(a);FOb(a);ROb(a);LPb(a);GOb(a);KOb(a);e=aQb(a,b,c)|0;POb(a);FOb(a);LOb(a);POb(a);i=d;return e|0}function $Pb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;vOb(b,+h[b+240>>3]);KOb(b);POb(b);NPb(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=cec(c[y>>2]|0,8)|0;A=b+124|0;B=cec(c[A>>2]|0,4)|0;C=b+128|0;D=cec(c[C>>2]|0,1)|0;E=b+132|0;F=cec(c[E>>2]|0,4)|0;G=b+536|0;YLb(c[G>>2]|0,(z|0)!=0|0,269304,t);YLb(c[G>>2]|0,(B|0)!=0|0,269304,s);YLb(c[G>>2]|0,(D|0)!=0|0,269304,r);YLb(c[G>>2]|0,(F|0)!=0|0,269304,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[233596>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];fc(x|0,269320,p|0)|0;p=gc(x|0,269336)|0;c[o>>2]=269352;ud(p|0,269344,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];ud(p|0,269344,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Qd(10,p|0)|0;H=p}VLb(9,1,269360,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;ge[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];VLb(9,0,269384,l);if((c[233596>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];ud(H|0,269408,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];ud(H|0,269408,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Qd(10,H|0)|0}if((wPb(b,0)|0)!=0){break a}if((nPb(b,0)|0)!=0){break a}if((dPb(b,0)|0)!=0){break a}SOb(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);de[c[58528]&511](9);if((c[233596>>2]|0)!=0){Wc(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}bec(z);bec(B);bec(D);bec(F)}else{h[b+304>>3]=1.0;ge[c[w+80>>2]&127](b)|0}HOb(b);if((NPb(b,1,1)|0)!=1){i=e;return}ge[c[(c[v>>2]|0)+80>>2]&127](b)|0;HOb(b);if((NPb(b,1,1)|0)!=1){i=e;return}XLb(1,0,269416,f);i=e;return}function aQb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=dQb(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){VLb(9,0,269520,u);if((c[b+184>>2]|0)==0){ue[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}bec(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){VLb(9,0,269552,t);ue[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;bec(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){VLb(9,1,269624,s);t=aec(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+VPb(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+VPb(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}VLb(9,1,269648,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];VLb(9,0,269672,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];VLb(9,0,269672,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];VLb(9,0,269672,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[233596>>2]|0)!=0){de[c[58528]&511](9);de[c[58528]&511](9)}bec(t);eQb(v);H=dQb(b)|0;if((c[H>>2]|0)!=0){$=H;break}VLb(9,0,269696,n);bec(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}VLb(9,0,269728,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){VLb(9,0,269744,l);bQb($,d,1,e);WPb(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+VPb($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){bec(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){bec(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){bec(v);c[l>>2]=0}bQb($,d,0,e);WPb(b,$);+VPb($,1.0)}else{VLb(9,0,269768,j)}VLb(9,1,269792,g);WPb(b,$);b=UPb($)|0;if((c[233596>>2]|0)!=0){de[c[58528]&511](9)}eQb($);y=b;i=f;return y|0}function bQb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=aec(c[p>>2]<<3)|0;r=q;s=+VPb(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;gQb(a,r);bec(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=269920;F=E;VLb(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;VLb(9,0,269832,m);if(!t){fQb(a)}switch(b|0){case 1:{G=nQb(a)|0;break};case 2:{G=lQb(a)|0;break};case 3:{G=pQb(a,n,e)|0;break};case 6:{H=14;break a;break};case 5:{H=13;break a;break};case 4:{H=12;break a;break};default:{H=15;break a}}POb(o);FOb(o);LOb(o);POb(o);s=+VPb(a,1.0);v=(G|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}VLb(9,0,269880,k);WPb(o,a);K=s}else{VLb(9,0,269896,j);if(v&s==x){y=w;H=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;H=23;break}}if((H|0)==12){kQb(a)|0}else if((H|0)==13){kQb(a)|0}else if((H|0)==14){jQb(o,a,0)|0}else if((H|0)==15){ZLb(c[o+536>>2]|0,269856,l)}else if((H|0)==23){gQb(a,r);bec(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=269920;F=E;VLb(9,0,F,g);i=f;return}}function cQb(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=Eec(b|0)|0;do{if((d|0)==0){e=aec(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==91){l=h+1|0}else if(k<<24>>24==93){l=h+ -1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=aec(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==93){q=p+ -1|0}else if(h<<24>>24==91){q=p+1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((zec(e,270936,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;Gec(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((zec(e,270936,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function dQb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=aec(64)|0;z=y;YLb(0,(y|0)!=0|0,270944,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=cec(Z,8)|0;c[E>>2]=y;YLb(0,(y|0)!=0|0,270944,w);w=cec(Z,8)|0;c[F>>2]=w;YLb(0,(w|0)!=0|0,270944,v);v=cec(Z,8)|0;c[G>>2]=v;YLb(0,(v|0)!=0|0,270944,u);u=cec(Z,8)|0;c[H>>2]=u;YLb(0,(u|0)!=0|0,270944,t);t=cec(Z,8)|0;c[I>>2]=t;YLb(0,(t|0)!=0|0,270944,s);s=cec(Z,4)|0;t=s;c[J>>2]=t;YLb(0,(s|0)!=0|0,270944,r);VLb(9,0,270960,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;VLb(9,0,270984,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];VLb(9,0,271072,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];VLb(9,0,271120,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];VLb(9,0,271176,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;VLb(9,0,271232,l);c[j>>2]=ya;VLb(9,0,271304,j);j=cec(sa,8)|0;c[K>>2]=j;YLb(0,(j|0)!=0|0,270944,g);g=aec(sa<<3)|0;c[L>>2]=g;YLb(0,(g|0)!=0|0,270944,f);f=aec(ya<<3)|0;c[M>>2]=f;YLb(0,(f|0)!=0|0,270944,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function eQb(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){bec(d)}d=c[a+28>>2]|0;if((d|0)!=0){bec(d)}d=c[a+32>>2]|0;if((d|0)!=0){bec(d)}d=c[a+36>>2]|0;if((d|0)!=0){bec(d)}d=c[a+40>>2]|0;if((d|0)!=0){bec(d)}d=c[a+44>>2]|0;if((d|0)!=0){bec(d)}d=c[a+48>>2]|0;if((d|0)!=0){bec(d)}d=c[a+52>>2]|0;if((d|0)!=0){bec(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;bec(e);i=b;return}bec(d);e=a;bec(e);i=b;return}function fQb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=cec(o,8)|0;q=cec(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=cec(s,8)|0;u=cec(s,8)|0;v=cec(o,8)|0;w=cec(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+VPb(b,1.0);s=c[n>>2]|0;if((s|0)>0){Gec(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+VPb(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){Gec(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;VLb(9,0,271344,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}bec(p);bec(q);bec(t);bec(u);bec(v);bec(w);i=d;return}function gQb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function hQb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function iQb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function jQb(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;ZLb(c[a+536>>2]|0,271416,d);return 0}function kQb(a){a=a|0;a=i;i=i+8|0;ZLb(0,271448,a);return 0}function lQb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[233596>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=cec((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;YLb(0,(n|0)!=0|0,271488,b);c[67876]=c[a+60>>2];c[67878]=c[a+48>>2];$Nb(k,j,c[a+24>>2]|0,g,f,d,e,n,6)|0;bec(n);c[67876]=0;c[67878]=0;n=UPb(a)|0;i=b;return n|0}function mQb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[67878];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[67876];h[d>>3]=+VPb(f,1.0);i=e;return}function nQb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=aec(x)|0;z=y;A=aec(x)|0;x=A;YLb(0,(y|0)!=0|0,271520,n);YLb(0,(A|0)!=0|0,271520,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[233596>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+VPb(a,1.0);h[o>>3]=D;if(D!=0.0){c[67884]=c[a+60>>2];c[67886]=c[a+48>>2];YNb(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,7,u)|0;c[67884]=0;c[67886]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];VLb(9,0,271552,l)}D=+VPb(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];VLb(9,0,271656,j);j=c[u>>2]|0;do{if((j|0)==4){XLb(9,0,271888,d);F=-4;i=b;return F|0}else if((j|0)==2){XLb(9,0,271752,f);F=-2;i=b;return F|0}else if((j|0)==3){XLb(9,0,271816,e);F=-3;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];XLb(9,0,271672,g);F=-1;i=b;return F|0}}while(0);F=UPb(a)|0;i=b;return F|0}function oQb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[67886];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[67884];h[d>>3]=+VPb(f,1.0);i=e;return}function pQb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;VLb(9,1,271944,g);if((c[233596>>2]|0)==0){l=0}else{l=(k|0)/10|0}qQb(a,d,k,l,b,j);c[f>>2]=c[j>>2];VLb(9,0,271968,f);de[c[58528]&511](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=UPb(a)|0;if((b|0)==0){m=0;i=e;return m|0}XLb(9,0,271984,e);m=b;i=e;return m|0}function qQb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=aec(fa(N,M)|0)|0;P=aec(M<<3)|0;Q=aec(N)|0;R=Q;S=aec(N)|0;T=S;V=aec(N)|0;W=V;X=aec(N)|0;Y=+h[f>>3];if((c[233596>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];fc(N|0,272032,I|0)|0;I=gc(N|0,272048)|0;c[H>>2]=272064;ud(I|0,272056,H|0)|0;c[G>>2]=272080;ud(I|0,272056,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];ud(I|0,272056,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Qd(10,I|0)|0;c[E>>2]=0;ud(I|0,272088,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];ud(I|0,272096,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];ud(I|0,272096,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Qd(10,I|0)|0;Z=I}else{Z=0}YLb(0,(O|0)!=0|0,272104,B);YLb(0,(P|0)!=0|0,272104,A);YLb(0,(Q|0)!=0|0,272104,z);YLb(0,(S|0)!=0|0,272104,y);YLb(0,(V|0)!=0|0,272104,x);YLb(0,(X|0)!=0|0,272104,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{hQb(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+VPb(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;hQb(a,la);+VPb(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];VLb(9,0,272120,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){Iec(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);hQb(a,R);za=+VPb(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}Gec(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}hQb(a,T);if(+VPb(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}Gec(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}Gec(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}hQb(a,W);Ba=+VPb(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}hQb(a,W);Ba=+VPb(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}Gec(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];VLb(9,0,272160,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;ud(Z|0,272088,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];ud(Z|0,272096,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];ud(Z|0,272096,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Qd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];XLb(9,0,272208,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];XLb(9,0,272224,p);ZLb(0,272240,o)}hQb(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){bec(S);bec(Q);bec(V);bec(X);bec(P);bec(O);i=j;return}c[n>>2]=ia;ud(Z|0,272088,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];ud(Z|0,272096,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];ud(Z|0,272096,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Qd(10,Z|0)|0;Wc(Z|0)|0;bec(S);bec(Q);bec(V);bec(X);bec(P);bec(O);i=j;return}function rQb(a,b){a=a|0;b=b|0;i=i;return}function sQb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;oNb(3);rNb(0);w=+jNb(0);oNb(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];ud(v|0,272320,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];ud(v|0,272320,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];ud(v|0,272320,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];ud(v|0,272328,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;ud(v|0,272328,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];ud(v|0,272336,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==1){break}else if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];ud(v|0,272320,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];ud(v|0,272320,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;ud(v|0,272328,l|0)|0;break}else{c[m>>2]=0-E;ud(v|0,272328,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;ud(v|0,272328,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;ud(v|0,272328,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Qd(10,v|0)|0;rNb(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];ud(v|0,272336,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Qd(10,v|0)|0;rNb(3);i=e;return}function tQb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=gc(c[r>>2]|0,272344)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Ud(c[(Lc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;YLb(t,(s|0)!=0|0,272352,q);c[p>>2]=272408;ud(s|0,272336,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=272416;ud(s|0,272336,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];ud(s|0,272336,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];ud(s|0,272336,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];ud(s|0,272336,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];ud(s|0,272336,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];ud(s|0,272336,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];ud(s|0,272336,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];ud(s|0,272336,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Qd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];ud(s|0,272336,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Qd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function uQb(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;oNb(3);Wc(d|0)|0;rNb(3);i=b;return}function vQb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;m6b(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];n6b(p,f)|0;wQb(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;xQb(a,b,272432,c[j>>2]|0,c[g>>2]|0,o,8);bec(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];n6b(p,e)|0;i=d;return}function wQb(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=cec(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;YLb(c[b+536>>2]|0,(p|0)!=0|0,272712,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function xQb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;IQb(a,b,d,e,f,h);l6b(l,g,fa(fa(f,e)|0,h)|0)|0;if(I4b(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];ZLb(l,272664,k)}else{i=j;return}}function yQb(a){a=a|0;var b=0;b=i;if((ARb(a+4|0)|0)!=0){i=b;return}L4b(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function zQb(a){a=a|0;Pc(a|0)|0;Wa()}function AQb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=gec(320)|0;Iec(q|0,0,320)|0;BQb(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;oNb(3);t=a+8|0;u=CQb(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=DQb(a,b,u+s|0)|0;u=q+184|0;EQb(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;EQb(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;FQb(q,c[x>>2]|0,36);if(I4b(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];ZLb(y,272488,e)}else{xQb(a,b,272520,4,11,272440,1);GQb((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;xQb(a,b,272528,c[g>>2]|0,c[j>>2]|0,e,1);bec(e);c[f>>2]=0;GQb((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;xQb(a,b,272536,c[g>>2]|0,c[j>>2]|0,e,1);bec(e);c[f>>2]=0;HQb(a,b,k,g,j,c[r>>2]|0,s);xQb(a,b,272552,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;m6b(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];wQb(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;xQb(a,b,272432,c[j>>2]|0,c[g>>2]|0,n,8);m6b(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=JQb(q+240|0)|0;w=JQb(q+264|0)|0;p=JQb(q+288|0)|0;IQb(a,b,272568,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);bec(n);bec(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;T5b(s)|0;bec(v);rNb(3);i=d;return}}function BQb(a){a=a|0;var b=0;b=i;KTb(a);i=b;return}function CQb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(OSb(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(OSb(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(OSb(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function DQb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=aec(e<<2)|0;e=l;c[l>>2]=273120;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=273160;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(OSb(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(OSb(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(OSb(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function EQb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;zRb(a,b,c);i=d;return}function FQb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(yRb(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){L4b(d,4);i=e;return}else{J4b(d,0);i=e;return}}function GQb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=Eec(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=cec((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;YLb(0,(o|0)!=0|0,272640,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;Pec(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;NQb(q,Eec(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=cec(1,1)|0;c[d>>2]=q;YLb(0,(q|0)!=0|0,272640,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function HQb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=cec(c[f>>2]<<2,4)|0;c[e>>2]=g;YLb(c[d+536>>2]|0,(g|0)!=0|0,272688,k);g=s+240|0;f=JQb(g)|0;h=s+264|0;t=JQb(h)|0;u=s+288|0;v=JQb(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=JQb(g)|0;D=JQb(h)|0;E=JQb(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==0){OQb(l,g,A+(v*52|0)+4|0);QQb(m,g);if(!(PQb(l,m)|0)){F=w;break}G=(c[(RQb(l)|0)+4>>2]|0)+1|0;H=2}else if(z<<24>>24==2){G=1;H=2}else if(z<<24>>24==1){OQb(l,b,A+(v*52|0)+4|0);QQb(n,b);if(!(PQb(l,n)|0)){F=w;break}G=(c[(RQb(l)|0)+4>>2]|0)+1|0;H=1}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==0){OQb(l,h,G+(t*52|0)+4|0);QQb(o,h);H=PQb(l,o)|0;J=H?2:0}else if(f<<24>>24==1){OQb(l,v,G+(t*52|0)+4|0);QQb(p,v);J=(PQb(l,p)|0)&1}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;n=c[(RQb(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=n+1}else{c[f+(w+1<<2)>>2]=~n}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==0){OQb(l,u,y+(t*52|0)+4|0);QQb(q,u);F=PQb(l,q)|0;M=F?2:0}else if(x<<24>>24==1){OQb(l,d,y+(t*52|0)+4|0);QQb(r,d);M=(PQb(l,r)|0)&1}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(RQb(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function IQb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(Eec(d|0)|0)+1;e=m;l6b(e,l,20)|0;if(I4b(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];ZLb(l,272664,k)}l6b(e,d,c[f>>2]|0)|0;if(I4b(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];ZLb(m,272664,j)}else{i=h;return}}function JQb(a){a=a|0;var b=0,d=0;b=i;d=c[(vRb(a)|0)>>2]|0;i=b;return d|0}function KQb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;oNb(3);do{if(H4b(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];n6b(k,e)|0;k=JQb(h+240|0)|0;m=JQb(h+264|0)|0;l=JQb(h+288|0)|0;IQb(a,b,272568,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);yQb(h)}else{if((h|0)!=0){break}c[g>>2]=0;rNb(3);i=d;return}}while(0);LQb(j);iec(h);c[g>>2]=0;rNb(3);i=d;return}function LQb(a){a=a|0;var b=0;b=i;TRb(a);i=b;return}function MQb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;oNb(3);rNb(0);h[j>>3]=+jNb(0);oNb(0);l=k;m=d+4|0;l6b(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){l6b(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){l6b(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);l6b(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);l6b(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);l6b(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(I4b(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];ZLb(t,272608,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;rNb(3);i=e;return}}function NQb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((Bec(b,272824,4)|0)!=0){i=d;return}c=b;while(1){e=Ta(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((Bec(b,272824,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function OQb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;hRb(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];ZQb(a,f);i=e;return}function PQb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=XQb(a,b)|0;i=c;return d|0}function QQb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;_Qb(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];ZQb(a,e);i=d;return}function RQb(a){a=a|0;var b=0,c=0;b=i;c=SQb(TQb(a)|0)|0;i=b;return c|0}function SQb(a){a=a|0;var b=0,c=0;b=i;c=WQb(a)|0;i=b;return c|0}function TQb(a){a=a|0;var b=0,d=0;b=i;d=UQb((c[a>>2]|0)+16|0)|0;i=b;return d|0}function UQb(a){a=a|0;var b=0,c=0;b=i;c=VQb(a)|0;i=b;return c|0}function VQb(a){a=a|0;i=i;return a|0}function WQb(a){a=a|0;i=i;return a|0}function XQb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(YQb(a,b)|0)^1;i=c;return d|0}function YQb(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function ZQb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];gRb(a,e);i=d;return}function _Qb(a,b){a=a|0;b=b|0;var c=0;c=i;$Qb(a,aRb(b)|0);i=c;return}function $Qb(a,b){a=a|0;b=b|0;var c=0;c=i;fRb(a,b);i=c;return}function aRb(a){a=a|0;var b=0,c=0;b=i;c=bRb(cRb(a+4|0)|0)|0;i=b;return c|0}function bRb(a){a=a|0;var b=0,c=0;b=i;c=eRb(a)|0;i=b;return c|0}function cRb(a){a=a|0;var b=0,c=0;b=i;c=dRb(a)|0;i=b;return c|0}function dRb(a){a=a|0;i=i;return a|0}function eRb(a){a=a|0;i=i;return a|0}function fRb(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function gRb(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function hRb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=jRb(b)|0;iRb(f,b,d,h,aRb(b)|0);_Qb(g,b);do{if(XQb(f,g)|0){h=kRb(b)|0;if(lRb(h,d,mRb(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);_Qb(a,b);i=e;return}function iRb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;qRb(h);a:do{if((e|0)==0){j=f}else{k=kRb(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(rRb(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;qRb(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;qRb(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);$Qb(a,j);i=g;return}function jRb(a){a=a|0;var b=0,d=0;b=i;d=c[(aRb(a)|0)>>2]|0;i=b;return d|0}function kRb(a){a=a|0;var b=0,c=0;b=i;c=oRb(a+8|0)|0;i=b;return c|0}function lRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=nRb(0,b,c)|0;i=a;return d|0}function mRb(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function nRb(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function oRb(a){a=a|0;var b=0,c=0;b=i;c=pRb(a)|0;i=b;return c|0}function pRb(a){a=a|0;i=i;return a|0}function qRb(a){a=a|0;var b=0;b=i;sRb(a,-1);i=b;return}function rRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=nRb(0,b,c)|0;i=a;return d|0}function sRb(a,b){a=a|0;b=b|0;b=i;tRb(a,0);i=b;return}function tRb(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function uRb(a){a=a|0;i=i;return c[a+4>>2]|0}function vRb(a){a=a|0;var b=0,c=0;b=i;c=wRb(a+8|0)|0;i=b;return c|0}function wRb(a){a=a|0;var b=0,c=0;b=i;c=xRb(a)|0;i=b;return c|0}function xRb(a){a=a|0;i=i;return a|0}function yRb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 9:case 25:{h=272768;break};case 8:{h=272744;break};case 24:{h=272752;break};case 60:{h=272808;break};case 5:case 21:{h=272784;break};case 1:case 17:{h=272736;break};case 48:case 16:{h=272728;break};case 12:{h=272792;break};case 28:{h=272800;break};case 52:case 20:{h=272776;break};case 56:{h=272760;break};case 13:case 29:{h=272816;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=gc(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Uc(j|0,0,2)|0)==0){g=a;i=e;return g|0}Wc(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function zRb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function ARb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}BRb(d,f,102);f=ge[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((Wc(CRb(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}DRb(d);g=h;i=b;return g|0}function BRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;KRb(a,b,c);i=d;return}function CRb(a){a=a|0;var b=0,d=0;b=i;d=GRb(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function DRb(a){a=a|0;var b=0;b=i;ERb(a);i=b;return}function ERb(a){a=a|0;var b=0;b=i;FRb(a,0);i=b;return}function FRb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=GRb(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}ge[c[(HRb(e)|0)>>2]&127](f)|0;i=d;return}function GRb(a){a=a|0;var b=0,c=0;b=i;c=JRb(a)|0;i=b;return c|0}function HRb(a){a=a|0;var b=0,c=0;b=i;c=IRb(a)|0;i=b;return c|0}function IRb(a){a=a|0;i=i;return a+4|0}function JRb(a){a=a|0;i=i;return a|0}function KRb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(MRb(f)|0)>>2]|0;LRb(a,d,c[(NRb(g)|0)>>2]|0);i=e;return}function LRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;ORb(a,b,c);i=d;return}function MRb(a){a=a|0;i=i;return a|0}function NRb(a){a=a|0;i=i;return a|0}function ORb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(QRb(f)|0)>>2]|0;PRb(a,d,c[(RRb(g)|0)>>2]|0);i=e;return}function PRb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(QRb(f)|0)>>2];c[a+4>>2]=c[(RRb(g)|0)>>2];i=e;return}function QRb(a){a=a|0;i=i;return a|0}function RRb(a){a=a|0;i=i;return a|0}function SRb(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function TRb(a){a=a|0;var b=0;b=i;URb(a+300|0);URb(a+288|0);URb(a+276|0);URb(a+264|0);URb(a+252|0);URb(a+240|0);VRb(a);i=b;return}function URb(a){a=a|0;var b=0;b=i;FSb(a);i=b;return}function VRb(a){a=a|0;var b=0;b=i;WRb(a,272872);P4b(a+104|0);i=b;return}function WRb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];_Rb(a+4|0);i=d;return}function XRb(a){a=a|0;var b=0;b=i;VRb(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function YRb(a){a=a|0;var b=0;b=i;VRb(a);iec(a);i=b;return}function ZRb(a){a=a|0;var b=0;b=i;YRb(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function _Rb(a){a=a|0;var b=0;b=i;$Rb(a);i=b;return}function $Rb(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=273e3;ARb(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}jec(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}jec(e)}}while(0);Y4b(b);i=d;return}function aSb(a){a=a|0;var b=0;b=i;_Rb(a);iec(a);i=b;return}function bSb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;ge[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=DSb(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=ESb(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;g5b(h,0,0,0);l5b(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}jec(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=hec(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=hec(h)|0;a[b+97|0]=1;i=e;return}function cSb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;g5b(e,0,0,0);l5b(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}jec(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}jec(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=hec(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(ASb(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=hec(o)|0;a[k]=1;i=f;return e|0}return 0}function dSb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Cc(4)|0;Hdc(n);Rd(n|0,320328,127)}n=wSb(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((ge[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){EQb(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=Xec(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Uc(p|0,q|0,f|0)|0)==0){p=wb(c[m>>2]|0)|0;EQb(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];zSb(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{EQb(a,-1,-1);i=g;return}}}while(0);EQb(a,-1,-1);i=g;return}function eSb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((ge[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=SRb(d)|0;if((Uc(j|0,k|0,0)|0)==0){ySb(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{EQb(a,-1,-1);i=e;return}}}while(0);EQb(a,-1,-1);i=e;return}function fSb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Cc(4)|0;Hdc(m);Rd(m|0,320328,127)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=wSb(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=e5b(s)|0;u=(fa(t-(d5b(s)|0)|0,p)|0)+r|0;v=0;break}p=d5b(s)|0;if((p|0)==(e5b(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=xSb(t,g,x,o,p-(c5b(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=e5b(w)|0;u=q-(d5b(w)|0)|0;v=0}}while(0);if((Uc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;g5b(b,0,0,0);c[m>>2]=0}else{q=b;y=i5b(q)|0;do{if((y|0)!=(h5b(q)|0)){if((ue[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=vSb(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((pc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((sd(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function gSb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=qSb(b)|0;o=b;if((d5b(o)|0)==0){p=e+1|0;g5b(o,e,p,p)}if(n){q=0}else{n=e5b(o)|0;c[f>>2]=(n-(c5b(o)|0)|0)/2|0;c[g>>2]=4;q=c[(rSb(f,g)|0)>>2]|0}g=d5b(o)|0;do{if((g|0)==(e5b(o)|0)){Hec(c5b(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=e5b(o)|0;n=c5b(o)|0;p=qb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=c5b(o)|0;g5b(o,n,n+q|0,n+(p+q)|0);r=oSb(a[d5b(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;Hec(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(rSb(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=qb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Cc(4)|0;Hdc(t);Rd(t|0,320328,127)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=c5b(o)|0;if((sSb(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;g5b(o,f,f,c[s>>2]|0);r=oSb(a[d5b(o)|0]|0)|0;break}s=c[k>>2]|0;f=c5b(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}g5b(o,f,p,s);r=oSb(a[d5b(o)|0]|0)|0}else{r=oSb(a[g]|0)|0}}while(0);if((c5b(o)|0)!=(e|0)){m=r;i=d;return m|0}g5b(o,0,0,0);m=r;i=d;return m|0}function hSb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=c5b(g)|0;j=d5b(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(kSb(d,-1)|0){f5b(g,-1);f=nSb(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=lSb(d)|0;do{if(h){if(pSb(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);f5b(g,-1);a[d5b(g)|0]=b;f=d;i=e;return f|0}function iSb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}jSb(b);l=b;m=h5b(l)|0;n=j5b(l)|0;if(!(kSb(d,-1)|0)){if((i5b(l)|0)==0){l5b(l,f,f+1|0)}f=lSb(d)|0;a[i5b(l)|0]=f;k5b(l,1)}f=i5b(l)|0;o=h5b(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Cc(4)|0;u=t;Hdc(u);v=320328;w=127;Rd(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=h5b(l)|0;A=i5b(l)|0;B=mSb(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=h5b(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((pc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;l5b(l,B,i5b(l)|0);B=j5b(l)|0;k5b(l,B-(h5b(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Cc(4)|0;u=t;Hdc(u);v=320328;w=127;Rd(t|0,v|0,w|0)}else if((D|0)==14){q=(i5b(l)|0)-C|0;if((pc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((pc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);l5b(l,m,n)}k=nSb(d)|0;i=e;return k|0}function jSb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;g5b(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;l5b(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;l5b(f,h,h+(g+ -1)|0);break}}else{l5b(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function kSb(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function lSb(a){a=a|0;i=i;return a&255|0}function mSb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Ce[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function nSb(a){a=a|0;var b=0,c=0;b=i;c=kSb(a,-1)|0;i=b;return(c?0:a)|0}function oSb(a){a=a|0;i=i;return a&255|0}function pSb(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function qSb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;l5b(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;g5b(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;g5b(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function rSb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=tSb(b,c,e)|0;i=d;return g|0}function sSb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Ce[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function tSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=uSb(0,b,a)|0;i=c;return(d?b:a)|0}function uSb(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function vSb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=ve[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function wSb(a){a=a|0;var b=0,d=0;b=i;d=ge[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function xSb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=ve[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function ySb(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function zSb(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function ASb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=BSb(b,c,e)|0;i=d;return g|0}function BSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=CSb(0,a,b)|0;i=c;return(d?b:a)|0}function CSb(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function DSb(a){a=a|0;var b=0,c=0;b=i;c=Hac(a,304832)|0;i=b;return c|0}function ESb(a){a=a|0;var b=0,d=0;b=i;d=ge[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function FSb(a){a=a|0;var b=0;b=i;GSb(a);i=b;return}function GSb(a){a=a|0;var b=0;b=i;HSb(a);i=b;return}function HSb(a){a=a|0;var b=0;b=i;ISb(a,jRb(a)|0);i=b;return}function ISb(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;qRb(d);if((b|0)==0){i=d;return}ISb(a,c[b>>2]|0);ISb(a,c[b+4>>2]|0);KSb(JSb(a)|0,b,1);i=d;return}function JSb(a){a=a|0;var b=0,c=0;b=i;c=MSb(a+4|0)|0;i=b;return c|0}function KSb(a,b,c){a=a|0;b=b|0;c=c|0;c=i;LSb(0,b,0);i=c;return}function LSb(a,b,c){a=a|0;b=b|0;c=c|0;c=i;iec(b);i=c;return}function MSb(a){a=a|0;var b=0,c=0;b=i;c=NSb(a)|0;i=b;return c|0}function NSb(a){a=a|0;i=i;return a|0}function OSb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=PSb(a,f,b)|0;l=c[k>>2]|0;qRb(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}RSb(j,a,b);SSb(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];QSb(g,e);TSb(j);j=c[f>>2]|0;USb(a,j,k,VSb(g)|0);k=WSb(g)|0;TSb(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function PSb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=jRb(h)|0;qRb(e);if((a|0)==0){j=aRb(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(nRb(0,d,a)|0){m=l;j=c[m>>2]|0;qRb(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(nRb(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;qRb(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function QSb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];ITb(a,e);i=d;return}function RSb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=JSb(d)|0;d=rTb(n,1)|0;sTb(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];qTb(j,d,h);tTb(0,mTb((uTb(j)|0)+16|0)|0,e);e=vTb(j)|0;a[e+4|0]=1;wTb(0,lTb((uTb(j)|0)+20|0)|0);a[e+5|0]=1;xTb(m,j);SSb(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];QSb(b,g);TSb(m);TSb(j);i=f;return}function SSb(a,b){a=a|0;b=b|0;var c=0;c=i;oTb(a,b);i=c;return}function TSb(a){a=a|0;var b=0;b=i;hTb(a);i=b;return}function USb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;qRb(f);c[e>>2]=0;qRb(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=$Sb(a)|0;b=c[c[e>>2]>>2]|0;qRb(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(aRb(a)|0)>>2]|0;aTb(e,c[d>>2]|0);d=bTb(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function VSb(a){a=a|0;var b=0,d=0;b=i;d=c[(ZSb(a)|0)>>2]|0;i=b;return d|0}function WSb(a){a=a|0;var b=0,d=0;b=i;d=XSb(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function XSb(a){a=a|0;var b=0,c=0;b=i;c=YSb(a)|0;i=b;return c|0}function YSb(a){a=a|0;i=i;return a|0}function ZSb(a){a=a|0;var b=0,c=0;b=i;c=_Sb(a)|0;i=b;return c|0}function _Sb(a){a=a|0;i=i;return a|0}function $Sb(a){a=a|0;i=i;return a|0}function aTb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=eTb(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;qRb(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;qRb(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(eTb(j)|0){p=j}else{o=c[k>>2]|0;fTb(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;gTb(p);i=e;return}else if((l|0)==14){if(eTb(j)|0){p=c[k>>2]|0;gTb(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;fTb(q);i=e;return}else if((l|0)==17){i=e;return}}function bTb(a){a=a|0;var b=0,c=0;b=i;c=cTb(a+8|0)|0;i=b;return c|0}function cTb(a){a=a|0;var b=0,c=0;b=i;c=dTb(a)|0;i=b;return c|0}function dTb(a){a=a|0;i=i;return a|0}function eTb(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function fTb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;qRb(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=eTb(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function gTb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;qRb(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=eTb(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function hTb(a){a=a|0;var b=0;b=i;iTb(a,0);i=b;return}function iTb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=XSb(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}kTb(jTb(e)|0,f);i=d;return}function jTb(a){a=a|0;var b=0,c=0;b=i;c=nTb(a)|0;i=b;return c|0}function kTb(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}KSb(c[a>>2]|0,b,1);i=d;return}function lTb(a){a=a|0;i=i;return a|0}function mTb(a){a=a|0;i=i;return a|0}function nTb(a){a=a|0;i=i;return a+4|0}function oTb(a,b){a=a|0;b=b|0;var c=0;c=i;pTb(a,b);i=c;return}function pTb(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function qTb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];ATb(a,b,f);i=e;return}function rTb(a,b){a=a|0;b=b|0;var c=0;a=i;c=zTb(0,b,0)|0;i=a;return c|0}function sTb(a,b){a=a|0;b=b|0;var c=0;c=i;yTb(a,b);i=c;return}function tTb(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function uTb(a){a=a|0;var b=0,d=0;b=i;d=c[(ZSb(a)|0)>>2]|0;i=b;return d|0}function vTb(a){a=a|0;var b=0,c=0;b=i;c=jTb(a)|0;i=b;return c|0}function wTb(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function xTb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;oTb(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];QSb(h,f);SSb(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];QSb(a,e);TSb(h);i=d;return}function yTb(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function zTb(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=gec(b*24|0)|0;i=c;return a|0}function ATb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(CTb(g)|0)>>2]|0;g=DTb(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];BTb(b,a,f);i=e;return}function BTb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];ETb(a,b,f);i=e;return}function CTb(a){a=a|0;i=i;return a|0}function DTb(a){a=a|0;i=i;return a|0}function ETb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(GTb(g)|0)>>2]|0;g=HTb(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];FTb(b,a,f);i=e;return}function FTb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(GTb(f)|0)>>2];f=HTb(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function GTb(a){a=a|0;i=i;return a|0}function HTb(a){a=a|0;i=i;return a|0}function ITb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=WSb(JTb(b)|0)|0;h=HTb(vTb(JTb(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];BTb(g,a,e);i=d;return}function JTb(a){a=a|0;i=i;return c[a>>2]|0}function KTb(a){a=a|0;var b=0;b=i;i=i+48|0;LTb(a);EQb(a+184|0,0,0);EQb(a+200|0,0,0);MTb(a+240|0,b);MTb(a+252|0,b+8|0);MTb(a+264|0,b+16|0);MTb(a+276|0,b+24|0);MTb(a+288|0,b+32|0);MTb(a+300|0,b+40|0);i=b;return}function LTb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;U4b(d);e=a;c[e>>2]=272844;f=d;c[f>>2]=272864;d=a+4|0;$5b(a,272876|0,d);c[e>>2]=272844;c[f>>2]=272864;ZTb(d);i=b;return}function MTb(a,b){a=a|0;b=b|0;b=i;NTb(a,0);i=b;return}function NTb(a,b){a=a|0;b=b|0;b=i;i=i+8|0;OTb(a,b);i=b;return}function OTb(a,b){a=a|0;b=b|0;b=i;PTb(a,0);i=b;return}function PTb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;QTb(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;RTb(f,0,e);e=aRb(b)|0;c[($Sb(b)|0)>>2]=e;i=d;return}function QTb(a){a=a|0;var b=0;b=i;VTb(a);i=b;return}function RTb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;STb(b,c,f);i=e;return}function STb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(UTb(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;TTb(d,b,f);i=e;return}function TTb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(UTb(e)|0)>>2];i=d;return}function UTb(a){a=a|0;i=i;return a|0}function VTb(a){a=a|0;var b=0;b=i;WTb(a);i=b;return}function WTb(a){a=a|0;var b=0;b=i;XTb(a);i=b;return}function XTb(a){a=a|0;var b=0;b=i;YTb(a);i=b;return}function YTb(a){a=a|0;c[a>>2]=0;i=i;return}function ZTb(a){a=a|0;var b=0;b=i;_Tb(a);i=b;return}function _Tb(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;b5b(j);c[d>>2]=273e3;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;qRb(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;Z4b(g,j);l=$Tb(g)|0;Fac(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=le[r&63](d,0,4096)|0;i=e;return}Z4b(h,j);c[k>>2]=DSb(h)|0;Fac(h);a[f]=(ESb(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=le[r&63](d,0,4096)|0;i=e;return}function $Tb(a){a=a|0;var b=0,c=0;b=i;c=Gac(a,304832)|0;i=b;return c|0}function aUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;oNb(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){bUb(a,b,c[f>>2]|0,h);rNb(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=dec(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;ZLb(k,273272,e)}bUb(a,b,l,h);rNb(3);i=d;return}function bUb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;rNb(0);k=+jNb(0);oNb(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function cUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=aec(24)|0;oNb(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;YLb(c[m>>2]|0,l>>>31^1,273328,f);f=b+8|0;b=c[a+8>>2]|0;l=dUb(b,f)|0;c[g+20>>2]=l;l=dUb(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=aec(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;ZLb(k,273408,e)}else{c[h>>2]=0;c[a+12>>2]=g;rNb(3);i=d;return}}function dUb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function eUb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;oNb(3);u=b;v=gc(c[u>>2]|0,273472)|0;if((v|0)==0){fUb(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Ud(c[(Lc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;ZLb(w,273480,q)}pc(273536,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];ud(v|0,273584,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];ud(v|0,273608,o|0)|0;pc(273632,40,1,v|0)|0;pc(273680,11,1,v|0)|0;pc(273696,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];gUb(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Qd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{pc(273712,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;gUb(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Qd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];ud(v|0,273736,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;gUb(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Qd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];ud(v|0,273736,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;gUb(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Qd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];ud(v|0,273736,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;gUb(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Qd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];ud(v|0,273736,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;gUb(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Qd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];ud(v|0,273736,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;gUb(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Qd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];ud(v|0,273736,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;gUb(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Qd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}fUb(t);if((Wc(v|0)|0)==0){bec(c[r>>2]|0);c[r>>2]=0;rNb(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];ZLb(e,273752,f)}}function fUb(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}bec(a);c[d>>2]=0;i=b;return}function gUb(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];ud(a|0,273800,f|0)|0;i=e;return}function hUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=gec(192)|0;Iec(m|0,0,192)|0;iUb(m);c[a+12>>2]=m;n=m;o=a;FQb(n,c[o>>2]|0,36);if(I4b(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];ZLb(a,273840,g)}else{g=m;l6b(g,273816,14)|0;m6b(h,g);a=SRb(h)|0;h=m+184|0;c[h>>2]=a;l6b(g,273832,4)|0;jUb(n,b+8|0);m6b(j,g);b=SRb(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;EQb(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];n6b(g,f)|0;kUb(n,-4-m+b|0);b=c[j>>2]|0;EQb(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];n6b(g,e)|0;rNb(3);i=d;return}}function iUb(a){a=a|0;var b=0;b=i;DUb(a);i=b;return}function jUb(a,b){a=a|0;b=b|0;var c=0;c=i;mUb(a,3);nUb(a,274016);mUb(a,0);nUb(a,274024);mUb(a,2);yUb(a,b);zUb(a,b);nUb(a,274032);mUb(a,0);i=c;return}function kUb(a,b){a=a|0;b=b|0;var d=0;d=i;c[68502]=Fd(b|0)|0;l6b(a,274008,4)|0;i=d;return}function lUb(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;m6b(l,q);r=SRb(l)|0;kUb(b,0);m6b(m,q);l=SRb(m)|0;mUb(b,1);nUb(b,273904);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;oUb(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);pUb(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{pUb(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{qUb(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{rUb(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{nUb(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}m6b(n,q);u=SRb(n)|0;n=Fec(0,r|0,32)|0;EQb(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];n6b(q,k)|0;kUb(b,u-l|0);EQb(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];n6b(q,j)|0;i=g;return}function mUb(b,d){b=b|0;d=d|0;var e=0;e=i;a[273992]=-33;c[68500]=Fd(d|0)|0;d=b;l6b(d,273992,1)|0;l6b(d,274e3,4)|0;i=e;return}function nUb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=Fd(Eec(d|0)|0)|0;a[273984]=-37;g=b;l6b(g,273984,1)|0;l6b(g,f,4)|0;l6b(g,d,Eec(d|0)|0)|0;i=e;return}function oUb(b,d){b=b|0;d=d|0;var e=0;e=i;a[273968]=-35;c[68494]=Fd(d|0)|0;d=b;l6b(d,273968,1)|0;l6b(d,273976,4)|0;i=e;return}function pUb(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[273952]=-53;xUb(c);e=b;l6b(e,273952,1)|0;l6b(e,273960,8)|0;i=d;return}function qUb(b,d){b=b|0;d=d|0;var e=0;e=i;a[273936]=-46;c[68486]=Fd(d|0)|0;d=b;l6b(d,273936,1)|0;l6b(d,273944,4)|0;i=e;return}function rUb(b,c){b=b|0;c=c|0;var d=0;d=i;a[273928]=c?-61:-62;l6b(b,273928,1)|0;i=d;return}function sUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;lUb(e,+h[f>>3],a,f);lUb(e,+h[b+248>>3],a,f);i=d;return}function tUb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;m6b(j,p);o=SRb(j)|0;kUb(b,0);m6b(k,p);j=SRb(k)|0;mUb(b,1);nUb(b,273912);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;oUb(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;pUb(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{pUb(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{qUb(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{rUb(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{nUb(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}m6b(l,p);s=SRb(l)|0;l=Fec(0,o|0,32)|0;EQb(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];n6b(p,g)|0;kUb(b,s-j|0);EQb(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];n6b(p,f)|0;i=e;return}function uUb(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;yQb(a);oNb(3);if((a|0)!=0){vUb(a);iec(a)}c[d>>2]=0;rNb(3);i=b;return}function vUb(a){a=a|0;var b=0;b=i;wUb(a);i=b;return}function wUb(a){a=a|0;var b=0;b=i;VRb(a);i=b;return}



function QHb(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=lHb(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=TGb(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=lHb(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((WHb(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=De[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=ue[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}De[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=yHb(k,b,v,w+(ue[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=uHb(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=CHb(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=pHb(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=pHb(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=ue[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(lHb(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((iHb(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((iHb(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((iHb(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=ge[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;Gec(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}de[c[k+20>>2]&511](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;Gec(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;Gec(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function RHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=43;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=De[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case-15:{k=3;break a;break};case-4:{k=7;break a;break};case 13:{if((KHb(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case-2:{k=18;break a;break};case-1:{k=15;break a;break};case 11:{if((JHb(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case 15:{if((c[j+80>>2]|0)==0){break b}gHb(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case 0:{k=14;break a;break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==3){k=23;break}else if((f|0)==2){k=24;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){gHb(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function SHb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=De[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case 6:{r=c[o+60>>2]|0;if((r|0)==0){if((c[o+80>>2]|0)==0){break b}gHb(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){Ae[r&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];ae[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];Ae[r&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;Ae[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}gHb(o,b,c[k>>2]|0,c[l>>2]|0);break};case-2:{s=25;break a;break};case 0:{s=24;break a;break};case-4:case-1:{s=28;break a;break};case 40:{s=6;break a;break};default:{s=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==3){s=33;break}else if((h|0)==2){s=34;break}}if((s|0)==6){m=o;do{if((c[o+76>>2]|0)!=0){de[c[m+76>>2]&511](c[o+4>>2]|0)}else{if((c[m+80>>2]|0)==0){break}gHb(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((s|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((s|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((s|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((s|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((s|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((s|0)==34){t=35;u=t;i=j;return u|0}return 0}function THb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=SHb(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=44;k=UHb(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=wHb(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function UHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=NHb(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((VHb(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function VHb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=ue[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}Gec(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function WHb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((iHb(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((iHb(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=lHb(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function XHb(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(De[c[b+16>>2]&63](b,f,g,l)|0){case 7:case 39:{o=31;break};case-1:{o=7;break a;break};case 0:{o=4;break a;break};case-4:{o=3;break a;break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);o=31;break};case 10:{p=ue[c[b+44>>2]&63](b,f)|0;if((p|0)<0){o=11;break a}do{if(!(e<<24>>24!=0)){if((p|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);p=cIb(p,m)|0;if((p|0)==0){o=19;break a}q=0;while(1){if((q|0)>=(p|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((iHb(h)|0)<<24>>24!=0)){o=27;break a}}r=a[m+q|0]|0;s=h+12|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t]=r;q=q+1|0}break};case 6:{if((AHb(h,b,f,c[l>>2]|0)|0)==0){o=29;break a}break};case 9:{q=(le[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(q<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((iHb(h)|0)<<24>>24!=0)){o=42;break a}}p=h+12|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=q;break b}q=uHb(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((q|0)==0){o=44;break a}r=lHb(n,j,q,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){u=(c[n+300>>2]|0)!=0}else{u=(a[j+129|0]|0)!=0}v=((u^1)&1|0)!=0}else{v=0}w=v&1}else{if((a[j+129|0]|0)!=0){x=(d[j+130|0]|0)!=0}else{x=1}w=x&1}q=(r|0)!=0;if(w<<24>>24!=0){if(!q){o=57;break a}if((a[r+34|0]|0)==0){o=59;break a}}else{if(!q){break b}}if((a[r+32|0]|0)!=0){o=62;break a}if((c[r+28>>2]|0)!=0){o=66;break a}if((c[r+4>>2]|0)==0){o=70;break a}q=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;y=XHb(n,c[n+228>>2]|0,e,c[r+4>>2]|0,q,h)|0;a[r+32|0]=0;if((y|0)!=0){o=74;break a}break};default:{o=75;break a}}}while(0);do{if((o|0)==31){o=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((iHb(h)|0)<<24>>24!=0)){o=37;break a}}r=h+12|0;q=c[r>>2]|0;c[r>>2]=q+1;a[q]=32}}while(0);f=c[l>>2]|0}if((o|0)==3){z=0;A=z;i=k;return A|0}else if((o|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((o|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((o|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==27){z=1;A=z;i=k;return A|0}else if((o|0)==29){z=1;A=z;i=k;return A|0}else if((o|0)==37){z=1;A=z;i=k;return A|0}else if((o|0)==42){z=1;A=z;i=k;return A|0}else if((o|0)==44){z=1;A=z;i=k;return A|0}else if((o|0)==57){z=11;A=z;i=k;return A|0}else if((o|0)==59){z=24;A=z;i=k;return A|0}else if((o|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((o|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((o|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((o|0)==74){z=y;A=z;i=k;return A|0}else if((o|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function YHb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((le[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=dIb()|0;c[g+240>>2]=ge[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=De[((a[g+236|0]&255|0)!=0?45:46)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){de[c[f+1032>>2]&511](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}de[c[f+1032>>2]&511](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function ZHb(){var a=0,b=0;a=i;i=i+8|0;$b(((qc(0)|0)>>>0)%4294967295|0|0);b=Mec()|0;i=a;return b|0}function _Hb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=qHb(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=40;h=rHb(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function $Hb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=ge[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{aIb(f+80|0,e);aIb(b+104|0,e);bIb(b,e);bIb(b+20|0,e);bIb(b+40|0,e);bIb(b+60|0,e);a[b+131|0]=0;bIb(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function aIb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function bIb(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function cIb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function dIb(){i=i;return 1912}function eIb(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[230768+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[230844+l|0]|0|0)!=28){if((d[230844+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[230844+q|0]|0|0)!=28){if((d[230844+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[230844+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((fIb(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[224936+(((d[224680+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[224936+(((d[226216+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=cIb(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=49;c[h+336>>2]=49;c[h+340>>2]=49;c[h+344>>2]=50;c[h+348>>2]=50;c[h+352>>2]=50;c[h+356>>2]=51;c[h+360>>2]=51;c[h+364>>2]=51}c[h+60>>2]=13;c[h+64>>2]=14;n=h;o=n;i=j;return o|0}return 0}function fIb(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{e=-1;break};case 0:{if((d[230844+c|0]|0|0)!=0){f=7;break a}e=-1;break};case 255:{if(!((c|0)==65534|(c|0)==65535)){f=7;break a}e=-1;break};default:{f=7}}}while(0);if((f|0)==7){e=c}i=b;return e|0}function gIb(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=ue[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[224936+(((d[226216+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function hIb(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=ue[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[224936+(((d[224680+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function iIb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=ue[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(fIb(a)|0)<0;g=f&1;i=d;return g|0}function jIb(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=cIb(ue[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function kIb(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(ue[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function lIb(){i=i;return 230400}function mIb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=nIb(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=47;c[g+4>>2]=48;c[g+52>>2]=20;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function nIb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((BIb(d,c[230304+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function oIb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=zKb(228744,a,0,b,c,d)|0;i=e;return f|0}function pIb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=zKb(228744,a,1,b,c,d)|0;i=e;return f|0}function qIb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;YJb(229512,b,c,d);i=a;return}function rIb(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=sIb(35,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function sIb(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(AKb(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((De[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,230248)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((AKb(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((De[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,230256)|0)!=0){h=BKb(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=le[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((AKb(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((De[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,230272)|0)!=0){if((a|0)!=0){break}do{if((De[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,230288)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((De[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,230296)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((CKb(BKb(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function tIb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;ae[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((BIb(h,226472)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=nIb(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[228744+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function uIb(){i=i;return 228376}function vIb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=nIb(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=49;c[g+4>>2]=50;c[g+52>>2]=20;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function wIb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=zKb(226480,a,0,b,c,d)|0;i=e;return f|0}function xIb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=zKb(226480,a,1,b,c,d)|0;i=e;return f|0}function yIb(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=sIb(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function zIb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;ae[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((BIb(h,226472)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=nIb(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[226480+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function AIb(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=eIb(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function BIb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function CIb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=TIb(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 24:case 22:{n=18;b=b+2|0;o=77;break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 19:{k=fJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[g]|0)|0]|0}else{p=TIb(a[g+1|0]|0,a[b]|0)|0}switch(p|0){case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 23:case 27:case 26:case 25:{n=19;b=b+2|0;o=77;break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 10:case 21:{o=25;break};case 30:{k=VIb(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 13:{k=dJb(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 12:{k=dJb(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=TIb(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 16:{k=eJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=$Ib(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 29:{g=b;if((c[224936+((d[224680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;n=18;o=77;break a}if((c[224936+((d[226216+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=76;break a}b=b+2|0;n=19;o=77;break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=TIb(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=TIb(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 23:{b=b+2|0;r=n;if((r|0)==41){n=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}n=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=TIb(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 5:{o=105;break b;break};case 6:{o=108;break b;break};case 7:{o=111;break b;break};case 29:{if((c[224936+((d[226216+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=103;break b}break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 15:{o=122;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 29:{if((c[224936+((d[226216+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=83;break b}break};case 34:{o=116;break b;break};case 7:{o=91;break b;break};case 5:{o=85;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{o=88;break b;break};case 33:{o=119;break b;break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-n|0;l=k;i=h;return l|0}}return 0}function DIb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=TIb(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 3:{k=UIb(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 2:{k=YIb(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=TIb(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=TIb(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 6:{r=b;if((e-b|0)<3){p=52;break b}b=r+3|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=49;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function EIb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=TIb(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=TIb(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=TIb(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=47;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function FIb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=TIb(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function GIb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=TIb(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 5:{b=b+2|0;continue a;break};case 2:{n=15;break a;break};case 10:{n=16;break a;break};case 3:{n=12;break a;break};case 6:{b=b+3|0;continue a;break};case 9:{n=19;break a;break};case 7:{b=b+4|0;continue a;break};case 21:{n=29;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=UIb(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=TIb(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function HIb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=TIb(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 30:{n=15;break a;break};case 3:{n=12;break a;break};case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 9:{n=21;break a;break};case 10:{n=18;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=UIb(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=VIb(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=TIb(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function IIb(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=TIb(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=15;break a}e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=17;break a}else{continue a}break};case 5:{break};case 6:{k=8;break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[k]|0)|0]|0}else{n=TIb(a[k+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function JIb(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function KIb(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=TIb(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};default:{break a}}}i=e;return b-c|0}function LIb(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=TIb(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function MIb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=TIb(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=TIb(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function NIb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=fIb(c)|0;k=j;i=b;return k|0}function OIb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){if((a[e+1|0]|0)==0){h=a[e]|0}else{h=-1}if((h|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((h|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==108){f=60;g=f;i=b;return g|0}else if((j|0)==103){f=62;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function PIb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=TIb(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 5:{b=b+2|0;break};case 6:{b=b+3|0;break};case 7:{b=b+4|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=TIb(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function QIb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=TIb(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function RIb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g]|0;o=((l&3)<<4|(a[g+1|0]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function SIb(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function TIb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 219:case 218:case 217:case 216:{d=7;break};case 223:case 222:case 221:case 220:{d=8;break};case 255:{if(!(((b&255)+ -254|0)>>>0<2)){e=6;break a}d=0;break};default:{e=6}}}while(0);if((e|0)==6){d=29}i=c;return d|0}function UIb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=TIb(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[224936+((d[224680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 19:{k=WIb(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=TIb(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 7:{n=35;break b;break};case 6:{n=32;break b;break};case 5:{n=29;break b;break};case 29:{if((c[224936+((d[226216+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 18:{n=38;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function VIb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=TIb(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[224936+((d[224680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=TIb(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=32;break b;break};case 7:{n=35;break b;break};case 5:{n=29;break b;break};case 29:{if((c[224936+((d[226216+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 18:{n=38;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function WIb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=XIb(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=TIb(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=TIb(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function XIb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=TIb(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=TIb(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function YIb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=TIb(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=TIb(a[g+1|0]|0,a[b]|0)|0}if((n|0)==27){k=ZIb(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=_Ib(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[224936+((d[224680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 15:{k=$Ib(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=aJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=TIb(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=TIb(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 29:{if((c[224936+((d[224680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 24:case 22:{break};case 6:{o=62;break b;break};case 5:{o=59;break b;break};case 7:{o=65;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 10:case 9:case 21:{o=69;break b;break};case 11:{o=90;break b;break};case 7:{o=45;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=39;break b;break};case 29:{if((c[224936+((d[226216+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 6:{o=42;break b;break};case 17:{break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=TIb(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 10:case 9:case 21:{break};case 24:case 22:{break d;break};case 7:{o=84;break d;break};case 11:{o=90;break c;break};case 17:{break c;break};case 5:{o=78;break d;break};case 6:{o=81;break d;break};case 29:{o=75;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[224936+((d[224680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=bJb(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function ZIb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=TIb(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function _Ib(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[226880+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function $Ib(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=TIb(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 29:{if((c[224936+((d[224680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=TIb(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{p=28;break b;break};case 29:{if((c[224936+((d[226216+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 7:{p=34;break b;break};case 6:{p=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 15:{p=62;break b;break};case 10:case 9:case 21:{p=37;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((cJb(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=TIb(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((cJb(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function aJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=TIb(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[224936+((d[224680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=TIb(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[224936+((d[226216+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 10:case 9:case 21:{n=37;break b;break};case 23:{b=b+2|0;continue b;break};case 11:{n=48;break b;break};case 7:{n=34;break b;break};case 5:{n=28;break b;break};case 6:{n=31;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=TIb(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function bJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=TIb(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 29:{if((c[224936+((d[226216+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 14:{break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=TIb(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}switch(n|0){case 24:case 22:{break};case 7:{l=36;break a;break};case 6:{l=33;break a;break};case 29:{if((c[224936+((d[224680+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 5:{l=30;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 6:{l=13;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){o=d[k+76+(d[b]|0)|0]|0}else{o=TIb(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 5:{l=10;break a;break};case 7:{l=16;break a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[p]|0)|0]|0}else{q=TIb(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[p]|0)|0]|0}else{s=TIb(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 2:{l=79;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 3:{t=UIb(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 8:case 1:case 0:{l=74;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[p]|0)|0]|0}else{u=TIb(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 11:{l=106;break a;break};case 17:{l=107;break a;break};case 10:case 9:case 21:{break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[p]|0)|0]|0}else{v=TIb(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 6:{l=100;break a;break};case 11:{l=106;break a;break};case 29:{l=94;break d;break};case 7:{l=103;break a;break};case 17:{l=107;break a;break};case 24:case 22:{break d;break};case 10:case 9:case 21:{break};case 5:{l=97;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[224936+((d[224680+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function cJb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function dJb(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=TIb(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=TIb(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function eJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=TIb(a[g+1|0]|0,a[b]|0)|0}if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=TIb(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 10:case 9:case 21:{break a;break};case 24:case 22:{break};case 30:{n=16;break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=TIb(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=ZIb(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function fJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=TIb(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[224936+((d[224680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=TIb(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=28;break b;break};case 6:{n=31;break b;break};case 7:{n=34;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 29:{if((c[224936+((d[226216+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function gJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=TIb(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{g=b;if((c[224936+((d[224680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;n=18;o=77;break a}if((c[224936+((d[226216+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=76;break a}b=b+2|0;n=19;o=77;break};case 23:case 27:case 26:case 25:{n=19;b=b+2|0;o=77;break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 19:{k=KJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){p=d[j+76+(d[g+1|0]|0)|0]|0}else{p=TIb(a[g]|0,a[b+1|0]|0)|0}switch(p|0){case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{n=18;b=b+2|0;o=77;break};case 30:{k=yJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:case 21:{o=25;break};case 13:{k=IJb(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){q=d[j+76+(d[g+1|0]|0)|0]|0}else{q=TIb(a[g]|0,a[b+1|0]|0)|0}switch(q|0){case 16:{k=JJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 15:{k=EJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 12:{k=IJb(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}q=b;if((a[r]|0)==0){s=d[j+76+(d[q+1|0]|0)|0]|0}else{s=TIb(a[q]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=TIb(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 7:{o=91;break b;break};case 15:{o=122;break b;break};case 33:{o=119;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 34:{o=116;break b;break};case 5:{o=85;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 6:{o=88;break b;break};case 23:{b=b+2|0;r=n;if((r|0)==41){n=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}n=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=TIb(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=105;break b;break};case 7:{o=111;break b;break};case 6:{o=108;break b;break};case 29:{if((c[224936+((d[226216+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=103;break b}break};default:{n=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 29:{if((c[224936+((d[226216+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=83;break b}break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-n|0;l=k;i=h;return l|0}}return 0}function hJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=TIb(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 3:{k=xJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=TIb(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 2:{k=BJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=TIb(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=55;break b}b=r+4|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=49;break b}b=s+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function iJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=TIb(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=TIb(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=TIb(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=53;break b}b=r+4|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=47;break b}b=s+2|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=50;break b}b=t+3|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function jJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=TIb(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function kJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=TIb(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 7:{b=b+4|0;continue a;break};case 21:{n=29;break a;break};case 3:{n=12;break a;break};case 2:{n=15;break a;break};case 10:{n=16;break a;break};case 5:{b=b+2|0;continue a;break};case 9:{n=19;break a;break};case 6:{b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=xJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=TIb(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function lJb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=TIb(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 3:{n=12;break a;break};case 10:{n=18;break a;break};case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 30:{n=15;break a;break};case 9:{n=21;break a;break};case 6:{b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=xJb(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=yJb(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=TIb(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function mJb(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=TIb(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 5:{break};case 6:{k=8;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=15;break a}e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=17;break a}else{continue a}break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c]|0)==0){n=d[g+76+(d[k+1|0]|0)|0]|0}else{n=TIb(a[k]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function nJb(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function oJb(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=TIb(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function pJb(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=TIb(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}



function kv(b,d){b=b|0;d=d|0;var e=0,f=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0.0,z=0,B=0,C=0,D=0.0,E=0,F=0,G=0,J=0.0,K=0,L=0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0,T=0.0,V=0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0;e=i;f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;j=+h[(f+16|0)>>3];k=c[(b+416|0)>>2]|0;l=c[(d+36|0)>>2]|0;h[l>>3]=+h[f+16200>>3]*j*+h[k+16488>>3]*-j+ +h[f+16224>>3]*j*+h[k+16496>>3]*-j;j=+h[(f+16|0)>>3];h[l+8>>3]=+h[f+15064>>3]*j*+h[k+16008>>3]*-j+ +h[f+15048>>3]*j*+h[k+16016>>3]*-j;j=+h[(f+152|0)>>3];m=+h[(f+168|0)>>3];n=+h[k+17864>>3];o=+h[f+160>>3];h[l+16>>3]=+h[k+25192>>3]*(+h[f+7976>>3]*+h[k+18840>>3]+(j*(m*+h[k+17848>>3]-j*n)-o*(n*o-m*+h[k+17856>>3])));m=+h[(f+168|0)>>3]*+h[(f+152|0)>>3];h[l+24>>3]=m*.006+m*-.006;c[(l+32|0)+0>>2]=0;c[(l+32|0)+4>>2]=0;c[(l+32|0)+8>>2]=0;c[(l+32|0)+12>>2]=0;l=(ZOb(+U(+(+h[(f+19664|0)>>3])),1.0e-10)|0)<<24>>24==0;f=c[c[(b+4|0)>>2]>>2]|0;k=c[f+8>>2]|0;do{if(l){m=+h[k+19584>>3];if(+h[k+19664>>3]!=0.0){p=-m;q=+h[k+19664>>3];r=5;break}if(m==-0.0){s=k;t=-m;break}o=-m/+$Lb(c[b+536>>2]|0,+h[k+19664>>3],9056,12080,+h[f>>3],(a[b+319|0]|0)!=0|0);s=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;t=o}else{p=-+h[k+19584>>3];q=1.0e-10;r=5}}while(0);if((r|0)==5){s=k;t=p/q}k=c[(d+36|0)>>2]|0;h[k+48>>3]=t;Iec(k+56|0,0,160)|0;k=(ZOb(+U(+(+h[s+19984>>3])),1.0e-10)|0)<<24>>24==0;s=c[c[(b+4|0)>>2]>>2]|0;f=c[s+8>>2]|0;do{if(k){t=+h[f+19904>>3];if(+h[f+19984>>3]!=0.0){u=-t;v=+h[f+19984>>3];r=12;break}if(t==-0.0){w=f;x=s;y=-t;break}q=-t/+$Lb(c[b+536>>2]|0,+h[f+19984>>3],9824,12080,+h[s>>3],(a[b+319|0]|0)!=0|0);l=c[c[(b+4|0)>>2]>>2]|0;w=c[l+8>>2]|0;x=l;y=q}else{u=-+h[f+19904>>3];v=1.0e-10;r=12}}while(0);if((r|0)==12){w=f;x=s;y=u/v}s=c[(d+36|0)>>2]|0;h[s+216>>3]=y;f=c[(b+416|0)>>2]|0;h[s+224>>3]=+h[f+18840>>3]*+h[f+23328>>3]*.8660254037844387;h[s+232>>3]=0.0;y=+h[f+22912>>3];v=+h[w+16>>3];u=-(v*+h[w+7488>>3])-v*(+h[w+14968>>3]*+h[w+8576>>3]+ +h[w+14960>>3]*+h[w+8584>>3]);do{if(y!=0.0){z=f;B=w;C=s;D=u/y}else{if(u==0.0){z=f;B=w;C=s;D=u;break}v=u/+$Lb(c[b+536>>2]|0,y,9616,12080,+h[x>>3],(a[b+319|0]|0)!=0|0);z=c[(b+416|0)>>2]|0;B=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;C=c[(d+36|0)>>2]|0;D=v}}while(0);h[C+240>>3]=D;h[C+248>>3]=+h[B+4712>>3]*+h[B+8552>>3]+ +h[B+4720>>3]*+h[B+8560>>3];x=B+1368|0;h[C+256>>3]=+h[x>>3]*+h[B+7528>>3]*+h[B+16>>3];s=B+1360|0;D=+h[s>>3]*+h[x>>3];h[C+264>>3]=D*.006+D*-5.0e-4;Iec(C+272|0,0,200)|0;D=+h[B+1352>>3];y=+h[x>>3];u=+h[z+11832>>3];v=+h[s>>3];s=c[(d+36|0)>>2]|0;h[s+472>>3]=+h[z+23128>>3]*(+h[B+7560>>3]*+h[z+18840>>3]+(D*(y*+h[z+11816>>3]-D*u)-v*(u*v-y*+h[z+11824>>3])));z=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;y=+h[(z+1368|0)>>3]*+h[(z+1352|0)>>3];h[s+480>>3]=y*.006+y*-.006;c[(s+488|0)+0>>2]=0;c[(s+488|0)+4>>2]=0;c[(s+488|0)+8>>2]=0;c[(s+488|0)+12>>2]=0;c[(s+488|0)+16>>2]=0;c[(s+488|0)+20>>2]=0;B=c[(b+416|0)>>2]|0;y=+h[(z+1368|0)>>3];v=+h[(z+1360|0)>>3];u=+h[(B+11824|0)>>3];D=+h[(z+1352|0)>>3];h[s+512>>3]=+h[(B+23128|0)>>3]*(+h[(z+7536|0)>>3]*+h[(B+18840|0)>>3]+(y*(v*+h[(B+11832|0)>>3]-y*u)-D*(u*D-v*+h[(B+11816|0)>>3])));v=+h[(z+1352|0)>>3]*+h[(z+1360|0)>>3];h[s+520>>3]=v*5.0e-4+v*-.006;h[s+528>>3]=0.0;h[s+536>>3]=-(+h[z+4744>>3]*+h[z+8560>>3])- +h[z+4736>>3]*+h[z+8552>>3];v=+h[z+16>>3];h[s+544>>3]=+h[z+1424>>3]*+h[z+7504>>3]*v- +h[z+1416>>3]*v*+h[z+7528>>3];v=+h[(z+1360|0)>>3];D=+h[(z+1352|0)>>3];u=+h[(B+11816|0)>>3];y=+h[(z+1368|0)>>3];s=c[(d+36|0)>>2]|0;h[s+552>>3]=+h[(B+23128|0)>>3]*(+h[z+7512>>3]*+h[(B+18840|0)>>3]+(v*(D*+h[(B+11824|0)>>3]-v*u)-y*(u*y-D*+h[(B+11832|0)>>3])));B=c[c[(b+4|0)>>2]>>2]|0;z=c[B+8>>2]|0;D=+h[z+19920>>3];y=+h[z+8560>>3];u=+h[z+8552>>3];v=D*(+h[z+4744>>3]*u- +h[z+4736>>3]*y)- +h[z+20816>>3]*(u*+h[z+1432>>3]-y*+h[z+1440>>3]);do{if(D*D!=0.0){E=z;F=B;G=s;J=v/(D*D)}else{if(v==0.0){E=z;F=B;G=s;J=v;break}y=v/+$Lb(c[b+536>>2]|0,D*D,11136,12080,+h[B>>3],(a[b+319|0]|0)!=0|0);x=c[c[(b+4|0)>>2]>>2]|0;E=c[x+8>>2]|0;F=x;G=c[(d+36|0)>>2]|0;J=y}}while(0);h[G+560>>3]=J;B=E+16|0;h[G+568>>3]=-(+h[E+1368>>3]*+h[E+7504>>3]*+h[B>>3]);J=+h[B>>3];D=+h[(c[(b+416|0)>>2]|0)+22912>>3];v=+h[E+14952>>3]*+h[E+8576>>3]+(+h[E+14944>>3]*+h[E+8584>>3]+ +h[E+7496>>3]);do{if(D!=0.0){K=E;L=F;M=G;N=v/D}else{if(v==0.0){K=E;L=F;M=G;N=v;break}y=v/+$Lb(c[b+536>>2]|0,D,9616,12080,+h[F>>3],(a[b+319|0]|0)!=0|0);B=c[c[(b+4|0)>>2]>>2]|0;K=c[B+8>>2]|0;L=B;M=c[(d+36|0)>>2]|0;N=y}}while(0);h[M+576>>3]=J*N;F=K+21048|0;G=M+584|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;N=+h[F>>3];h[M+600>>3]=N*N*2.0;h[M+608>>3]=0.0;N=+h[K+21072>>3];J=+W(+(+h[K+19936>>3]),1.5);do{if(J!=0.0){O=K;P=M;Q=N*N*-.25/J}else{if(N*N*-.25==0.0){O=K;P=M;Q=N*N*-.25;break}D=N*N*-.25/+$Lb(c[b+536>>2]|0,J,11200,12080,+h[L>>3],(a[b+319|0]|0)!=0|0);O=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;P=c[(d+36|0)>>2]|0;Q=D}}while(0);h[P+616>>3]=Q;L=O+8608|0;M=P+624|0;c[M+0>>2]=0;c[M+4>>2]=0;c[M+8>>2]=0;c[M+12>>2]=0;Q=+h[L>>3];J=+h[O+8616>>3];h[P+640>>3]=(Q*Q+J*J)*2.0;L=O+14960|0;M=P+648|0;c[M+0>>2]=0;c[M+4>>2]=0;c[M+8>>2]=0;c[M+12>>2]=0;M=O+16|0;J=+h[M>>3];K=c[(b+416|0)>>2]|0;h[P+664>>3]=+h[L>>3]*J*+h[K+9976>>3]*-J+ +h[O+14944>>3]*J*+h[K+9984>>3]*-J;h[P+672>>3]=+h[O+19504>>3];h[P+680>>3]=0.0;L=O+168|0;h[P+688>>3]=-(+h[L>>3]*+h[O+7920>>3]*+h[M>>3]);J=+h[O+160>>3];Q=+h[O+152>>3];N=+h[K+17848>>3];D=+h[L>>3];h[P+696>>3]=+h[K+25192>>3]*(+h[O+7928>>3]*+h[K+18840>>3]+(J*(Q*+h[K+17856>>3]-J*N)-D*(N*D-Q*+h[K+17864>>3])));K=P+704|0;c[K+0>>2]=0;c[K+4>>2]=0;c[K+8>>2]=0;c[K+12>>2]=0;c[K+16>>2]=0;c[K+20>>2]=0;K=c[(d+36|0)>>2]|0;P=K+728|0;O=P+40|0;do{c[P>>2]=0;P=P+4|0}while((P|0)<(O|0));L=c[c[(b+4|0)>>2]>>2]|0;M=c[L+8>>2]|0;Q=+h[(M+152|0)>>3]*+h[(M+160|0)>>3];h[K+768>>3]=Q*5.0e-4+Q*-.006;c[(K+776|0)+0>>2]=0;c[(K+776|0)+4>>2]=0;c[(K+776|0)+8>>2]=0;c[(K+776|0)+12>>2]=0;c[(K+776|0)+16>>2]=0;c[(K+776|0)+20>>2]=0;h[K+800>>3]=+h[(M+168|0)>>3]*+h[M+7944>>3]*+h[(M+16|0)>>3];Q=+h[(M+160|0)>>3]*+h[(M+168|0)>>3];h[K+808>>3]=Q*.006+Q*-5.0e-4;h[K+816>>3]=0.0;F=c[(b+416|0)>>2]|0;Q=+h[(M+168|0)>>3];D=+h[(M+160|0)>>3];N=+h[F+17856>>3];J=+h[(M+152|0)>>3];h[K+824>>3]=+h[F+25192>>3]*(+h[M+7952>>3]*+h[F+18840>>3]+(Q*(D*+h[F+17864>>3]-Q*N)-J*(N*J-D*+h[F+17848>>3])));D=+h[F+24976>>3];J=+h[(M+16|0)>>3];N=-(J*+h[M+7904>>3])-J*(+h[M+15064>>3]*+h[M+8064>>3]+ +h[M+15056>>3]*+h[M+8072>>3]);do{if(D!=0.0){R=M;S=L;T=N/D}else{if(N==0.0){R=M;S=L;T=N;break}J=N/+$Lb(c[b+536>>2]|0,D,8464,12080,+h[L>>3],(a[b+319|0]|0)!=0|0);F=c[c[(b+4|0)>>2]>>2]|0;R=c[F+8>>2]|0;S=F;T=J}}while(0);L=c[(d+36|0)>>2]|0;h[L+832>>3]=T;M=R+8040|0;F=R+8048|0;h[L+840>>3]=+h[R+4856>>3]*+h[M>>3]+ +h[R+4864>>3]*+h[F>>3];K=R+4880|0;G=R+4888|0;h[L+848>>3]=-(+h[G>>3]*+h[F>>3])- +h[K>>3]*+h[M>>3];T=+h[R+16>>3];h[L+856>>3]=+h[R+224>>3]*+h[R+7920>>3]*T- +h[R+216>>3]*T*+h[R+7944>>3];T=+h[R+19600>>3];D=+h[F>>3];N=+h[M>>3];J=T*(+h[G>>3]*N- +h[K>>3]*D)- +h[R+20832>>3]*(N*+h[R+232>>3]-D*+h[R+240>>3]);do{if(T*T!=0.0){V=R;X=S;Y=L;Z=J/(T*T)}else{if(J==0.0){V=R;X=S;Y=L;Z=J;break}D=J/+$Lb(c[b+536>>2]|0,T*T,10896,12080,+h[S>>3],(a[b+319|0]|0)!=0|0);K=c[c[(b+4|0)>>2]>>2]|0;V=c[K+8>>2]|0;X=K;Y=c[(d+36|0)>>2]|0;Z=D}}while(0);h[Y+864>>3]=Z;Z=+h[V+16>>3];S=c[(b+416|0)>>2]|0;T=+h[S+24976>>3];J=+h[V+15048>>3]*+h[V+8064>>3]+(+h[V+15040>>3]*+h[V+8072>>3]+ +h[V+7912>>3]);do{if(T!=0.0){_=S;$=V;aa=X;ba=Y;ca=J/T}else{if(J==0.0){_=S;$=V;aa=X;ba=Y;ca=J;break}D=J/+$Lb(c[b+536>>2]|0,T,8464,12080,+h[X>>3],(a[b+319|0]|0)!=0|0);L=c[c[(b+4|0)>>2]>>2]|0;_=c[(b+416|0)>>2]|0;$=c[L+8>>2]|0;aa=L;ba=c[(d+36|0)>>2]|0;ca=D}}while(0);h[ba+872>>3]=Z*ca;ca=+h[$+16>>3];h[ba+880>>3]=+h[$+15056>>3]*ca*+h[_+16008>>3]*-ca+ +h[$+15040>>3]*ca*+h[_+16016>>3]*-ca;X=$+8096|0;Y=ba+888|0;c[Y+0>>2]=0;c[Y+4>>2]=0;c[Y+8>>2]=0;c[Y+12>>2]=0;ca=+h[X>>3];Z=+h[$+8104>>3];h[ba+904>>3]=(ca*ca+Z*Z)*2.0;Z=+h[$+21144>>3];h[ba+912>>3]=Z*Z*2.0;h[ba+920>>3]=0.0;Z=+h[$+21168>>3];ca=+W(+(+h[$+19616>>3]),1.5);do{if(ca!=0.0){da=$;ea=_;fa=ba;ga=Z*Z*-.25/ca}else{if(Z*Z*-.25==0.0){da=$;ea=_;fa=ba;ga=Z*Z*-.25;break}T=Z*Z*-.25/+$Lb(c[b+536>>2]|0,ca,10960,12080,+h[aa>>3],(a[b+319|0]|0)!=0|0);da=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;ea=c[(b+416|0)>>2]|0;fa=c[(d+36|0)>>2]|0;ga=T}}while(0);h[fa+928>>3]=ga;aa=ea+18840|0;ba=fa+936|0;c[ba+0>>2]=0;c[ba+4>>2]=0;c[ba+8>>2]=0;c[ba+12>>2]=0;h[fa+952>>3]=+h[aa>>3]*+h[ea+25392>>3]*.8660254037844387;aa=da+16208|0;P=fa+960|0;O=P+40|0;do{c[P>>2]=0;P=P+4|0}while((P|0)<(O|0));ba=da+16|0;ga=+h[ba>>3];h[fa+1e3>>3]=+h[aa>>3]*ga*+h[ea+16488>>3]*-ga+ +h[da+16232>>3]*ga*+h[ea+16496>>3]*-ga;ea=da+648|0;h[fa+1008>>3]=-(+h[ea>>3]*+h[da+7688>>3]*+h[ba>>3]);ga=+h[ea>>3]*+h[da+632>>3];h[fa+1016>>3]=ga*.006+ga*-.006;ea=da+19824|0;P=fa+1024|0;O=P+56|0;do{c[P>>2]=0;P=P+4|0}while((P|0)<(O|0));fa=(ZOb(+U(+(+h[ea>>3])),1.0e-10)|0)<<24>>24==0;ea=c[c[(b+4|0)>>2]>>2]|0;da=c[ea+8>>2]|0;do{if(fa){ga=+h[da+19744>>3];if(+h[da+19824>>3]!=0.0){ha=-ga;ia=+h[da+19824>>3];r=51;break}if(ga==-0.0){ja=da;ka=-ga;break}ca=-ga/+$Lb(c[b+536>>2]|0,+h[da+19824>>3],9440,12080,+h[ea>>3],(a[b+319|0]|0)!=0|0);ja=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;ka=ca}else{ha=-+h[da+19744>>3];ia=1.0e-10;r=51}}while(0);if((r|0)==51){ja=da;ka=ha/ia}da=c[(d+36|0)>>2]|0;h[da+1080>>3]=ka;ea=ja+7744|0;P=da+1088|0;O=P+128|0;do{c[P>>2]=0;P=P+4|0}while((P|0)<(O|0));fa=c[(b+416|0)>>2]|0;ba=ja+632|0;ka=+h[ba>>3];aa=ja+648|0;ia=+h[aa>>3];ha=+h[(fa+14848|0)>>3];_=ja+640|0;ca=+h[_>>3];h[da+1216>>3]=+h[(fa+24160|0)>>3]*(+h[ea>>3]*+h[(fa+18840|0)>>3]+(ka*(ia*+h[(fa+14832|0)>>3]-ka*ha)-ca*(ha*ca-ia*+h[(fa+14840|0)>>3])));ia=+h[_>>3]*+h[aa>>3];h[da+1224>>3]=ia*.006+ia*-5.0e-4;ea=ja+7696|0;c[(da+1232|0)+0>>2]=0;c[(da+1232|0)+4>>2]=0;c[(da+1232|0)+8>>2]=0;c[(da+1232|0)+12>>2]=0;ia=+h[_>>3];ca=+h[ba>>3];ha=+h[(fa+14832|0)>>3];ka=+h[aa>>3];aa=c[(d+36|0)>>2]|0;h[aa+1248>>3]=+h[(fa+24160|0)>>3]*(+h[ea>>3]*+h[(fa+18840|0)>>3]+(ia*(ca*+h[(fa+14840|0)>>3]-ia*ha)-ka*(ha*ka-ca*+h[(fa+14848|0)>>3])));ea=c[c[(b+4|0)>>2]>>2]|0;ba=c[ea+8>>2]|0;ca=+h[(ba+632|0)>>3]*+h[(ba+640|0)>>3];h[aa+1256>>3]=ca*5.0e-4+ca*-.006;h[aa+1264>>3]=0.0;h[aa+1272>>3]=+h[(ba+648|0)>>3]*+h[ba+7712>>3]*+h[(ba+16|0)>>3];ca=+h[(ba+648|0)>>3];ka=+h[(ba+640|0)>>3];ha=+h[(fa+14840|0)>>3];ia=+h[(ba+632|0)>>3];h[aa+1280>>3]=+h[(fa+24160|0)>>3]*(+h[ba+7720>>3]*+h[(fa+18840|0)>>3]+(ca*(ka*+h[(fa+14848|0)>>3]-ca*ha)-ia*(ha*ia-ka*+h[(fa+14832|0)>>3])));ka=+h[(c[(b+416|0)>>2]|0)+23944>>3];ia=+h[(ba+16|0)>>3];ha=-(ia*+h[ba+7672>>3])-ia*(+h[ba+15016>>3]*+h[ba+8296>>3]+ +h[ba+15008>>3]*+h[ba+8304>>3]);do{if(ka!=0.0){la=ba;ma=ea;na=aa;oa=ha/ka}else{if(ha==0.0){la=ba;ma=ea;na=aa;oa=ha;break}ia=ha/+$Lb(c[b+536>>2]|0,ka,9232,12080,+h[ea>>3],(a[b+319|0]|0)!=0|0);fa=c[c[(b+4|0)>>2]>>2]|0;la=c[fa+8>>2]|0;ma=fa;na=c[(d+36|0)>>2]|0;oa=ia}}while(0);h[na+1288>>3]=oa;ea=la+8272|0;aa=la+8280|0;h[na+1296>>3]=+h[la+4784>>3]*+h[ea>>3]+ +h[la+4792>>3]*+h[aa>>3];ba=la+4808|0;fa=la+4816|0;h[na+1304>>3]=-(+h[fa>>3]*+h[aa>>3])- +h[ba>>3]*+h[ea>>3];oa=+h[la+16>>3];h[na+1312>>3]=+h[la+704>>3]*+h[la+7688>>3]*oa- +h[la+696>>3]*oa*+h[la+7712>>3];oa=+h[la+19760>>3];ka=+h[aa>>3];ha=+h[ea>>3];ia=oa*(+h[fa>>3]*ha- +h[ba>>3]*ka)- +h[la+20824>>3]*(ha*+h[la+712>>3]-ka*+h[la+720>>3]);do{if(oa*oa!=0.0){pa=la;qa=ma;ra=na;sa=ia/(oa*oa)}else{if(ia==0.0){pa=la;qa=ma;ra=na;sa=ia;break}ka=ia/+$Lb(c[b+536>>2]|0,oa*oa,11016,12080,+h[ma>>3],(a[b+319|0]|0)!=0|0);ba=c[c[(b+4|0)>>2]>>2]|0;pa=c[ba+8>>2]|0;qa=ba;ra=c[(d+36|0)>>2]|0;sa=ka}}while(0);h[ra+1320>>3]=sa;sa=+h[pa+16>>3];ma=c[(b+416|0)>>2]|0;oa=+h[ma+23944>>3];ia=+h[pa+15e3>>3]*+h[pa+8296>>3]+(+h[pa+14992>>3]*+h[pa+8304>>3]+ +h[pa+7680>>3]);do{if(oa!=0.0){ta=ma;ua=pa;va=qa;wa=ra;xa=ia/oa}else{if(ia==0.0){ta=ma;ua=pa;va=qa;wa=ra;xa=ia;break}ka=ia/+$Lb(c[b+536>>2]|0,oa,9232,12080,+h[qa>>3],(a[b+319|0]|0)!=0|0);na=c[c[(b+4|0)>>2]>>2]|0;ta=c[(b+416|0)>>2]|0;ua=c[na+8>>2]|0;va=na;wa=c[(d+36|0)>>2]|0;xa=ka}}while(0);h[wa+1328>>3]=sa*xa;xa=+h[ua+16>>3];h[wa+1336>>3]=+h[ua+15008>>3]*xa*+h[ta+12992>>3]*-xa+ +h[ua+14992>>3]*xa*+h[ta+13e3>>3]*-xa;qa=ua+8328|0;ra=wa+1344|0;c[ra+0>>2]=0;c[ra+4>>2]=0;c[ra+8>>2]=0;c[ra+12>>2]=0;xa=+h[qa>>3];sa=+h[ua+8336>>3];h[wa+1360>>3]=(xa*xa+sa*sa)*2.0;sa=+h[ua+21096>>3];h[wa+1368>>3]=sa*sa*2.0;h[wa+1376>>3]=0.0;sa=+h[ua+21120>>3];xa=+W(+(+h[ua+19776>>3]),1.5);do{if(xa!=0.0){ya=ua;za=ta;Aa=wa;Ba=sa*sa*-.25/xa}else{if(sa*sa*-.25==0.0){ya=ua;za=ta;Aa=wa;Ba=sa*sa*-.25;break}oa=sa*sa*-.25/+$Lb(c[b+536>>2]|0,xa,11080,12080,+h[va>>3],(a[b+319|0]|0)!=0|0);ya=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;za=c[(b+416|0)>>2]|0;Aa=c[(d+36|0)>>2]|0;Ba=oa}}while(0);h[Aa+1384>>3]=Ba;va=za+18840|0;wa=Aa+1392|0;c[wa+0>>2]=0;c[wa+4>>2]=0;c[wa+8>>2]=0;c[wa+12>>2]=0;h[Aa+1408>>3]=+h[va>>3]*+h[za+24360>>3]*.8660254037844387;va=ya+15016|0;P=Aa+1416|0;O=P+40|0;do{c[P>>2]=0;P=P+4|0}while((P|0)<(O|0));wa=ya+16|0;Ba=+h[wa>>3];h[Aa+1456>>3]=+h[va>>3]*Ba*+h[za+12992>>3]*-Ba+ +h[ya+15e3>>3]*Ba*+h[za+13e3>>3]*-Ba;va=ya+16208|0;Ba=+h[wa>>3];ta=za+13472|0;ua=ya+16232|0;qa=za+13480|0;h[Aa+1464>>3]=+h[va>>3]*Ba*+h[ta>>3]*-Ba+ +h[ua>>3]*Ba*+h[qa>>3]*-Ba;Ba=+h[wa>>3];h[Aa+1472>>3]=+h[ya+16200>>3]*Ba*+h[ta>>3]*-Ba+ +h[ya+16224>>3]*Ba*+h[qa>>3]*-Ba;Ba=+h[wa>>3];wa=c[(d+36|0)>>2]|0;h[wa+1480>>3]=+h[va>>3]*Ba*+h[za+12896>>3]*-Ba+ +h[ua>>3]*Ba*+h[za+12904>>3]*-Ba;za=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;Ba=+h[(za+16|0)>>3];ua=c[(b+416|0)>>2]|0;h[wa+1488>>3]=+h[(za+16200|0)>>3]*Ba*+h[ua+12896>>3]*-Ba+ +h[(za+16224|0)>>3]*Ba*+h[ua+12904>>3]*-Ba;Ba=+h[(za+16|0)>>3];h[wa+1496>>3]=+h[(za+16208|0)>>3]*Ba*+h[(ua+10456|0)>>3]*-Ba+ +h[(za+16232|0)>>3]*Ba*+h[(ua+10464|0)>>3]*-Ba;Ba=+h[(za+16|0)>>3];h[wa+1504>>3]=+h[(za+16200|0)>>3]*Ba*+h[(ua+10456|0)>>3]*-Ba+ +h[(za+16224|0)>>3]*Ba*+h[(ua+10464|0)>>3]*-Ba;Ba=+h[(za+16|0)>>3];h[wa+1512>>3]=+h[za+14968>>3]*Ba*+h[ua+9976>>3]*-Ba+ +h[za+14952>>3]*Ba*+h[ua+9984>>3]*-Ba;h[wa+1520>>3]=0.0;Ba=+h[(za+16|0)>>3];h[wa+1528>>3]=+h[(za+16208|0)>>3]*Ba*+h[(ua+9880|0)>>3]*-Ba+ +h[(za+16232|0)>>3]*Ba*+h[(ua+9888|0)>>3]*-Ba;Ba=+h[(za+16|0)>>3];wa=c[(d+36|0)>>2]|0;h[wa+1536>>3]=+h[(za+16200|0)>>3]*Ba*+h[(ua+9880|0)>>3]*-Ba+ +h[(za+16224|0)>>3]*Ba*+h[(ua+9888|0)>>3]*-Ba;ua=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[wa+1544>>3]=-(+h[(ua+2088|0)>>3]*+h[ua+7320>>3]*+h[ua+16>>3]);Ba=+h[(ua+2088|0)>>3]*+h[ua+2072>>3];h[wa+1552>>3]=Ba*.006+Ba*-.006;P=wa+1560|0;O=P+56|0;do{c[P>>2]=0;P=P+4|0}while((P|0)<(O|0));wa=(ZOb(+U(+(+h[(ua+20144|0)>>3])),1.0e-10)|0)<<24>>24==0;ua=c[c[(b+4|0)>>2]>>2]|0;za=c[ua+8>>2]|0;do{if(wa){Ba=+h[za+20064>>3];if(+h[za+20144>>3]!=0.0){Ca=-Ba;Da=+h[za+20144>>3];r=74;break}if(Ba==-0.0){Ea=za;Fa=-Ba;break}xa=-Ba/+$Lb(c[b+536>>2]|0,+h[za+20144>>3],8616,12080,+h[ua>>3],(a[b+319|0]|0)!=0|0);Ea=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;Fa=xa}else{Ca=-+h[za+20064>>3];Da=1.0e-10;r=74}}while(0);if((r|0)==74){Ea=za;Fa=Ca/Da}za=c[(d+36|0)>>2]|0;h[za+1616>>3]=Fa;ua=Ea+7376|0;P=za+1624|0;O=P+128|0;do{c[P>>2]=0;P=P+4|0}while((P|0)<(O|0));wa=c[(b+416|0)>>2]|0;va=Ea+2072|0;Fa=+h[va>>3];qa=Ea+2088|0;Da=+h[qa>>3];Ca=+h[(wa+8816|0)>>3];ya=Ea+2080|0;xa=+h[ya>>3];h[za+1752>>3]=+h[(wa+22096|0)>>3]*(+h[ua>>3]*+h[(wa+18840|0)>>3]+(Fa*(Da*+h[(wa+8800|0)>>3]-Fa*Ca)-xa*(Ca*xa-Da*+h[(wa+8808|0)>>3])));Da=+h[ya>>3]*+h[qa>>3];h[za+1760>>3]=Da*.006+Da*-5.0e-4;ua=Ea+7328|0;c[(za+1768|0)+0>>2]=0;c[(za+1768|0)+4>>2]=0;c[(za+1768|0)+8>>2]=0;c[(za+1768|0)+12>>2]=0;Da=+h[ya>>3];xa=+h[va>>3];Ca=+h[(wa+8800|0)>>3];Fa=+h[qa>>3];qa=c[(d+36|0)>>2]|0;h[qa+1784>>3]=+h[(wa+22096|0)>>3]*(+h[ua>>3]*+h[(wa+18840|0)>>3]+(Da*(xa*+h[(wa+8808|0)>>3]-Da*Ca)-Fa*(Ca*Fa-xa*+h[(wa+8816|0)>>3])));ua=c[c[(b+4|0)>>2]>>2]|0;va=c[ua+8>>2]|0;xa=+h[(va+2072|0)>>3]*+h[(va+2080|0)>>3];h[qa+1792>>3]=xa*5.0e-4+xa*-.006;h[qa+1800>>3]=0.0;h[qa+1808>>3]=+h[(va+2088|0)>>3]*+h[va+7344>>3]*+h[(va+16|0)>>3];xa=+h[(va+2088|0)>>3];Fa=+h[(va+2080|0)>>3];Ca=+h[(wa+8808|0)>>3];Da=+h[(va+2072|0)>>3];h[qa+1816>>3]=+h[(wa+22096|0)>>3]*(+h[va+7352>>3]*+h[(wa+18840|0)>>3]+(xa*(Fa*+h[(wa+8816|0)>>3]-xa*Ca)-Da*(Ca*Da-Fa*+h[(wa+8800|0)>>3])));Fa=+h[(c[(b+416|0)>>2]|0)+21880>>3];Da=+h[(va+16|0)>>3];Ca=-(Da*+h[va+7304>>3])-Da*(+h[va+14920>>3]*+h[va+8856>>3]+ +h[va+14912>>3]*+h[va+8864>>3]);c[e+8>>2]=b;c[e+16>>2]=d;c[e+1224>>2]=qa;c[e+1232>>2]=ua;c[e+1248>>2]=va;g[e+1312>>2]=Fa;g[e+1328>>2]=Ca;c[e+6512>>2]=P;c[e+6520>>2]=r;c[e+6536>>2]=O;c[e+6544>>2]=0;c[e+6548>>2]=0;_setLinearVectorb4256$0(e);P=c[e+6512>>2]|0;r=c[e+6520>>2]|0;O=c[e+6536>>2]|0;H=c[e+6544>>2]|0;A=c[e+6548>>2]|0;I=+g[e+6548>>2];c[e+6544>>2]=0;c[e+6548>>2]=0;if((H|0)==5){return}}function lv(a){a=a|0;c[a+20>>2]=1039;c[a+16>>2]=382;c[a+12>>2]=1272;c[a>>2]=43;c[a+4>>2]=44;c[a+84>>2]=4256;c[a+80>>2]=382;c[a+76>>2]=1272;c[a+64>>2]=45;c[a+68>>2]=46;i=i;return}function mv(a,b){a=a|0;b=b|0;i=i;return}function nv(a){a=a|0;i=i;return}function ov(a,b){a=a|0;b=b|0;c[b>>2]=c[12952+(a<<2)>>2];i=i;return c[13024+(a<<2)>>2]|0}function pv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=b+4|0;g=b+360|0;b=(XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19528>>3],0.0,a[c[g>>2]|0]|0)|0)<<24>>24!=0;h[d>>3]=b?1.0:-1.0;b=(XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19576>>3],.987,a[(c[g>>2]|0)+1|0]|0)|0)<<24>>24!=0;h[d+8>>3]=b?1.0:-1.0;b=(YOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19576>>3],.93,a[(c[g>>2]|0)+2|0]|0)|0)<<24>>24!=0;h[d+16>>3]=b?1.0:-1.0;b=(XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19688>>3],0.0,a[(c[g>>2]|0)+3|0]|0)|0)<<24>>24!=0;h[d+24>>3]=b?1.0:-1.0;b=(XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19736>>3],.987,a[(c[g>>2]|0)+4|0]|0)|0)<<24>>24!=0;h[d+32>>3]=b?1.0:-1.0;b=(YOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19736>>3],.93,a[(c[g>>2]|0)+5|0]|0)|0)<<24>>24!=0;h[d+40>>3]=b?1.0:-1.0;b=(XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19848>>3],0.0,a[(c[g>>2]|0)+6|0]|0)|0)<<24>>24!=0;h[d+48>>3]=b?1.0:-1.0;b=(XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19896>>3],.987,a[(c[g>>2]|0)+7|0]|0)|0)<<24>>24!=0;h[d+56>>3]=b?1.0:-1.0;b=(YOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19896>>3],.93,a[(c[g>>2]|0)+8|0]|0)|0)<<24>>24!=0;h[d+64>>3]=b?1.0:-1.0;b=(XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20008>>3],0.0,a[(c[g>>2]|0)+9|0]|0)|0)<<24>>24!=0;h[d+72>>3]=b?1.0:-1.0;b=(XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20056>>3],.987,a[(c[g>>2]|0)+10|0]|0)|0)<<24>>24!=0;h[d+80>>3]=b?1.0:-1.0;b=(YOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20056>>3],.93,a[(c[g>>2]|0)+11|0]|0)|0)<<24>>24!=0;h[d+88>>3]=b?1.0:-1.0;b=(XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20168>>3],0.0,a[(c[g>>2]|0)+12|0]|0)|0)<<24>>24!=0;h[d+96>>3]=b?1.0:-1.0;b=(XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20216>>3],.987,a[(c[g>>2]|0)+13|0]|0)|0)<<24>>24!=0;h[d+104>>3]=b?1.0:-1.0;b=(YOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20216>>3],.93,a[(c[g>>2]|0)+14|0]|0)|0)<<24>>24!=0;h[d+112>>3]=b?1.0:-1.0;b=(XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20328>>3],0.0,a[(c[g>>2]|0)+15|0]|0)|0)<<24>>24!=0;h[d+120>>3]=b?1.0:-1.0;b=(XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20376>>3],.987,a[(c[g>>2]|0)+16|0]|0)|0)<<24>>24!=0;h[d+128>>3]=b?1.0:-1.0;b=(YOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20376>>3],.93,a[(c[g>>2]|0)+17|0]|0)|0)<<24>>24!=0;h[d+136>>3]=b?1.0:-1.0;i=e;return 0}function qv(a){a=a|0;i=i;return c[13024+(a<<2)>>2]|0}function rv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0,k=0;e=i;f=b+4|0;g=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19528>>3];if((d|0)==0){d=b+352|0;a[c[d>>2]|0]=g<0.0|0;a[(c[d>>2]|0)+1|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19576>>3]<.987|0;a[(c[d>>2]|0)+2|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19576>>3]>.93|0;a[(c[d>>2]|0)+3|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19688>>3]<0.0|0;a[(c[d>>2]|0)+4|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19736>>3]<.987|0;a[(c[d>>2]|0)+5|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19736>>3]>.93|0;a[(c[d>>2]|0)+6|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19848>>3]<0.0|0;a[(c[d>>2]|0)+7|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19896>>3]<.987|0;a[(c[d>>2]|0)+8|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19896>>3]>.93|0;a[(c[d>>2]|0)+9|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20008>>3]<0.0|0;a[(c[d>>2]|0)+10|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20056>>3]<.987|0;a[(c[d>>2]|0)+11|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20056>>3]>.93|0;a[(c[d>>2]|0)+12|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20168>>3]<0.0|0;a[(c[d>>2]|0)+13|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20216>>3]<.987|0;a[(c[d>>2]|0)+14|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20216>>3]>.93|0;a[(c[d>>2]|0)+15|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20328>>3]<0.0|0;a[(c[d>>2]|0)+16|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20376>>3]<.987|0;a[(c[d>>2]|0)+17|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20376>>3]>.93|0;i=e;return 0}else{d=b+360|0;j=XOb(g,0.0,a[c[d>>2]|0]|0)|0;k=b+352|0;a[c[k>>2]|0]=j;j=XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19576>>3],.987,a[(c[d>>2]|0)+1|0]|0)|0;a[(c[k>>2]|0)+1|0]=j;j=YOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19576>>3],.93,a[(c[d>>2]|0)+2|0]|0)|0;a[(c[k>>2]|0)+2|0]=j;j=XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19688>>3],0.0,a[(c[d>>2]|0)+3|0]|0)|0;a[(c[k>>2]|0)+3|0]=j;j=XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19736>>3],.987,a[(c[d>>2]|0)+4|0]|0)|0;a[(c[k>>2]|0)+4|0]=j;j=YOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19736>>3],.93,a[(c[d>>2]|0)+5|0]|0)|0;a[(c[k>>2]|0)+5|0]=j;j=XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19848>>3],0.0,a[(c[d>>2]|0)+6|0]|0)|0;a[(c[k>>2]|0)+6|0]=j;j=XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19896>>3],.987,a[(c[d>>2]|0)+7|0]|0)|0;a[(c[k>>2]|0)+7|0]=j;j=YOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19896>>3],.93,a[(c[d>>2]|0)+8|0]|0)|0;a[(c[k>>2]|0)+8|0]=j;j=XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20008>>3],0.0,a[(c[d>>2]|0)+9|0]|0)|0;a[(c[k>>2]|0)+9|0]=j;j=XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20056>>3],.987,a[(c[d>>2]|0)+10|0]|0)|0;a[(c[k>>2]|0)+10|0]=j;j=YOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20056>>3],.93,a[(c[d>>2]|0)+11|0]|0)|0;a[(c[k>>2]|0)+11|0]=j;j=XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20168>>3],0.0,a[(c[d>>2]|0)+12|0]|0)|0;a[(c[k>>2]|0)+12|0]=j;j=XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20216>>3],.987,a[(c[d>>2]|0)+13|0]|0)|0;a[(c[k>>2]|0)+13|0]=j;j=YOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20216>>3],.93,a[(c[d>>2]|0)+14|0]|0)|0;a[(c[k>>2]|0)+14|0]=j;j=XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20328>>3],0.0,a[(c[d>>2]|0)+15|0]|0)|0;a[(c[k>>2]|0)+15|0]=j;j=XOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20376>>3],.987,a[(c[d>>2]|0)+16|0]|0)|0;a[(c[k>>2]|0)+16|0]=j;j=YOb(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20376>>3],.93,a[(c[d>>2]|0)+17|0]|0)|0;a[(c[k>>2]|0)+17|0]=j;i=e;return 0}return 0}function sv(a){a=a|0;a=i;i=i+8|0;VLb(8,1,13096,a);if((c[233592>>2]|0)==0){i=a;return 0}de[c[58528]&511](8);i=a;return 0}function tv(a){a=a|0;i=i;return c[17880+(a<<2)>>2]|0}function uv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=i;i=i+16|0;f=i;i=i+16|0;g=(c[a+416>>2]|0)+16984|0;c[d>>2]=3;LMb(e,g,1,d);XMb(e,18008,f);RMb(f,(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21704|0);i=b;return}function vv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=i;i=i+16|0;f=i;i=i+16|0;g=(c[a+416>>2]|0)+13968|0;c[d>>2]=3;LMb(e,g,1,d);XMb(e,18008,f);RMb(f,(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21680|0);i=b;return}function wv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=i;i=i+16|0;f=i;i=i+16|0;g=(c[a+416>>2]|0)+10952|0;c[d>>2]=3;LMb(e,g,1,d);XMb(e,18008,f);RMb(f,(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21656|0);i=b;return}function xv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=i;i=i+16|0;f=i;i=i+16|0;g=(c[a+416>>2]|0)+7936|0;c[d>>2]=3;LMb(e,g,1,d);XMb(e,18008,f);RMb(f,(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21632|0);i=b;return}function yv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=i;i=i+16|0;f=i;i=i+16|0;g=(c[a+416>>2]|0)+4920|0;c[d>>2]=3;LMb(e,g,1,d);XMb(e,18008,f);RMb(f,(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21608|0);i=b;return}function zv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=i;i=i+16|0;f=i;i=i+16|0;g=(c[a+416>>2]|0)+1904|0;c[d>>2]=3;LMb(e,g,1,d);XMb(e,18008,f);RMb(f,(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21584|0);i=b;return}function Av(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0;e=i;i=i+304|0;f=e;g=e+16|0;j=e+32|0;l=e+48|0;m=e+64|0;n=e+80|0;o=e+96|0;p=e+112|0;q=e+128|0;r=e+144|0;s=e+160|0;t=e+176|0;u=e+192|0;v=e+208|0;w=e+224|0;x=e+240|0;y=e+256|0;z=e+272|0;A=e+288|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+16|0;$=i;i=i+16|0;aa=i;i=i+16|0;ba=i;i=i+16|0;ca=i;i=i+16|0;da=i;i=i+16|0;ea=i;i=i+16|0;fa=i;i=i+16|0;ga=i;i=i+16|0;ha=i;i=i+16|0;ia=i;i=i+16|0;ja=i;i=i+16|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+16|0;na=i;i=i+16|0;oa=i;i=i+16|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+16|0;ua=i;i=i+16|0;va=i;i=i+16|0;wa=i;i=i+16|0;xa=i;i=i+16|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+16|0;Ba=i;i=i+16|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;VLb(21,1,18024,qa);qa=b+4|0;Ja=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+40>>3];h[d>>3]=Ja;Ka=tv(0)|0;c[pa>>2]=1;c[pa+4>>2]=Ka;Ka=pa+8|0;h[k>>3]=Ja;c[Ka>>2]=c[k>>2];c[Ka+4>>2]=c[k+4>>2];VLb(21,0,18056,pa);Ja=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+32>>3];h[d+8>>3]=Ja;pa=tv(1)|0;c[oa>>2]=2;c[oa+4>>2]=pa;pa=oa+8|0;h[k>>3]=Ja;c[pa>>2]=c[k>>2];c[pa+4>>2]=c[k+4>>2];VLb(21,0,18056,oa);uv(b);Ja=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21704>>3];h[d+16>>3]=Ja;oa=tv(2)|0;c[na>>2]=3;c[na+4>>2]=oa;oa=na+8|0;h[k>>3]=Ja;c[oa>>2]=c[k>>2];c[oa+4>>2]=c[k+4>>2];VLb(21,0,18056,na);Ja=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21712>>3];h[d+24>>3]=Ja;na=tv(3)|0;c[ma>>2]=4;c[ma+4>>2]=na;na=ma+8|0;h[k>>3]=Ja;c[na>>2]=c[k>>2];c[na+4>>2]=c[k+4>>2];VLb(21,0,18056,ma);Ja=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21720>>3];h[d+32>>3]=Ja;ma=tv(4)|0;c[la>>2]=5;c[la+4>>2]=ma;ma=la+8|0;h[k>>3]=Ja;c[ma>>2]=c[k>>2];c[ma+4>>2]=c[k+4>>2];VLb(21,0,18056,la);la=b+416|0;Ja=+h[(c[la>>2]|0)+24976>>3]+-.175;h[d+40>>3]=Ja;ma=tv(5)|0;c[ka>>2]=6;c[ka+4>>2]=ma;ma=ka+8|0;h[k>>3]=Ja;c[ma>>2]=c[k>>2];c[ma+4>>2]=c[k+4>>2];VLb(21,0,18056,ka);ka=c[(c[c[qa>>2]>>2]|0)+8>>2]|0;Ja=+h[ka+10304>>3];La=+h[ka+10320>>3];ma=ja;h[k>>3]=+h[ka+10312>>3];c[ma>>2]=c[k>>2];c[ma+4>>2]=c[k+4>>2];ma=ja+8|0;h[k>>3]=La;c[ma>>2]=c[k>>2];c[ma+4>>2]=c[k+4>>2];UMb(ra,3,Ja,ja);ja=c[(c[c[qa>>2]>>2]|0)+8>>2]|0;Ja=+h[ja+15208>>3];La=+h[ja+15224>>3];ma=ia;h[k>>3]=+h[ja+15216>>3];c[ma>>2]=c[k>>2];c[ma+4>>2]=c[k+4>>2];ma=ia+8|0;h[k>>3]=La;c[ma>>2]=c[k>>2];c[ma+4>>2]=c[k+4>>2];UMb(sa,3,Ja,ia);ia=b+536|0;ma=c[ia>>2]|0;ja=c[la>>2]|0;Ja=+h[ja+24904>>3];La=+h[ja+24912>>3]+ +h[ja+24920>>3];ja=z;ka=18072;c[ja+0>>2]=c[ka+0>>2];c[ja+4>>2]=c[ka+4>>2];c[ja+8>>2]=c[ka+8>>2];ka=y;ja=ra;c[ka+0>>2]=c[ja+0>>2];c[ka+4>>2]=c[ja+4>>2];c[ka+8>>2]=c[ja+8>>2];ja=x;ka=sa;c[ja+0>>2]=c[ka+0>>2];c[ja+4>>2]=c[ka+4>>2];c[ja+8>>2]=c[ka+8>>2];dv(Da,ma,Ja,z,La,y,x);x=a[Da]|0;Da=b+424|0;y=a[(c[Da>>2]|0)+275|0]|0;z=(y|x)<<24>>24==0;if(z|y<<24>>24==0){Ma=z?0.0:1.0}else{Ma=+(x<<24>>24==0|0)}h[d+48>>3]=Ma;x=tv(6)|0;c[ha>>2]=7;c[ha+4>>2]=x;x=ha+8|0;h[k>>3]=Ma;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];VLb(21,0,18056,ha);vv(b);Ma=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21680>>3];h[d+56>>3]=Ma;ha=tv(7)|0;c[ga>>2]=8;c[ga+4>>2]=ha;ha=ga+8|0;h[k>>3]=Ma;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];VLb(21,0,18056,ga);Ma=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21688>>3];h[d+64>>3]=Ma;ga=tv(8)|0;c[fa>>2]=9;c[fa+4>>2]=ga;ga=fa+8|0;h[k>>3]=Ma;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];VLb(21,0,18056,fa);Ma=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21696>>3];h[d+72>>3]=Ma;fa=tv(9)|0;c[ea>>2]=10;c[ea+4>>2]=fa;fa=ea+8|0;h[k>>3]=Ma;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];VLb(21,0,18056,ea);Ma=+h[(c[la>>2]|0)+23944>>3]+-.175;h[d+80>>3]=Ma;ea=tv(10)|0;c[da>>2]=11;c[da+4>>2]=ea;ea=da+8|0;h[k>>3]=Ma;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];VLb(21,0,18056,da);da=c[(c[c[qa>>2]>>2]|0)+8>>2]|0;Ma=+h[da+10184>>3];La=+h[da+10200>>3];ea=ca;h[k>>3]=+h[da+10192>>3];c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];ea=ca+8|0;h[k>>3]=La;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];UMb(ta,3,Ma,ca);ca=c[(c[c[qa>>2]>>2]|0)+8>>2]|0;Ma=+h[ca+15184>>3];La=+h[ca+15200>>3];ea=ba;h[k>>3]=+h[ca+15192>>3];c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];ea=ba+8|0;h[k>>3]=La;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];UMb(ua,3,Ma,ba);ba=c[ia>>2]|0;ea=c[la>>2]|0;Ma=+h[ea+23872>>3];La=+h[ea+23880>>3]+ +h[ea+23888>>3];ea=w;ca=18072;c[ea+0>>2]=c[ca+0>>2];c[ea+4>>2]=c[ca+4>>2];c[ea+8>>2]=c[ca+8>>2];ca=v;ea=ta;c[ca+0>>2]=c[ea+0>>2];c[ca+4>>2]=c[ea+4>>2];c[ca+8>>2]=c[ea+8>>2];ea=u;ca=ua;c[ea+0>>2]=c[ca+0>>2];c[ea+4>>2]=c[ca+4>>2];c[ea+8>>2]=c[ca+8>>2];dv(Ea,ba,Ma,w,La,v,u);u=a[Ea]|0;Ea=a[(c[Da>>2]|0)+227|0]|0;v=(Ea|u)<<24>>24==0;if(v|Ea<<24>>24==0){Na=v?0.0:1.0}else{Na=+(u<<24>>24==0|0)}h[d+88>>3]=Na;u=tv(11)|0;c[aa>>2]=12;c[aa+4>>2]=u;u=aa+8|0;h[k>>3]=Na;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];VLb(21,0,18056,aa);wv(b);Na=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21656>>3];h[d+96>>3]=Na;aa=tv(12)|0;c[$>>2]=13;c[$+4>>2]=aa;aa=$+8|0;h[k>>3]=Na;c[aa>>2]=c[k>>2];c[aa+4>>2]=c[k+4>>2];VLb(21,0,18056,$);Na=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21664>>3];h[d+104>>3]=Na;$=tv(13)|0;c[_>>2]=14;c[_+4>>2]=$;$=_+8|0;h[k>>3]=Na;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];VLb(21,0,18056,_);Na=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21672>>3];h[d+112>>3]=Na;_=tv(14)|0;c[Z>>2]=15;c[Z+4>>2]=_;_=Z+8|0;h[k>>3]=Na;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];VLb(21,0,18056,Z);Na=+h[(c[la>>2]|0)+22912>>3]+-.175;h[d+120>>3]=Na;Z=tv(15)|0;c[Y>>2]=16;c[Y+4>>2]=Z;Z=Y+8|0;h[k>>3]=Na;c[Z>>2]=c[k>>2];c[Z+4>>2]=c[k+4>>2];VLb(21,0,18056,Y);Y=c[(c[c[qa>>2]>>2]|0)+8>>2]|0;Na=+h[Y+10064>>3];La=+h[Y+10080>>3];Z=X;h[k>>3]=+h[Y+10072>>3];c[Z>>2]=c[k>>2];c[Z+4>>2]=c[k+4>>2];Z=X+8|0;h[k>>3]=La;c[Z>>2]=c[k>>2];c[Z+4>>2]=c[k+4>>2];UMb(va,3,Na,X);X=c[(c[c[qa>>2]>>2]|0)+8>>2]|0;Na=+h[X+15160>>3];La=+h[X+15176>>3];Z=W;h[k>>3]=+h[X+15168>>3];c[Z>>2]=c[k>>2];c[Z+4>>2]=c[k+4>>2];Z=W+8|0;h[k>>3]=La;c[Z>>2]=c[k>>2];c[Z+4>>2]=c[k+4>>2];UMb(wa,3,Na,W);W=c[ia>>2]|0;Z=c[la>>2]|0;Na=+h[Z+22840>>3];La=+h[Z+22848>>3]+ +h[Z+22856>>3];Z=t;X=18072;c[Z+0>>2]=c[X+0>>2];c[Z+4>>2]=c[X+4>>2];c[Z+8>>2]=c[X+8>>2];X=s;Z=va;c[X+0>>2]=c[Z+0>>2];c[X+4>>2]=c[Z+4>>2];c[X+8>>2]=c[Z+8>>2];Z=r;X=wa;c[Z+0>>2]=c[X+0>>2];c[Z+4>>2]=c[X+4>>2];c[Z+8>>2]=c[X+8>>2];dv(Fa,W,Na,t,La,s,r);r=a[Fa]|0;Fa=a[(c[Da>>2]|0)+179|0]|0;s=(Fa|r)<<24>>24==0;if(s|Fa<<24>>24==0){Oa=s?0.0:1.0}else{Oa=+(r<<24>>24==0|0)}h[d+128>>3]=Oa;r=tv(16)|0;c[V>>2]=17;c[V+4>>2]=r;r=V+8|0;h[k>>3]=Oa;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];VLb(21,0,18056,V);xv(b);Oa=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21632>>3];h[d+136>>3]=Oa;V=tv(17)|0;c[U>>2]=18;c[U+4>>2]=V;V=U+8|0;h[k>>3]=Oa;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];VLb(21,0,18056,U);Oa=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21640>>3];h[d+144>>3]=Oa;U=tv(18)|0;c[T>>2]=19;c[T+4>>2]=U;U=T+8|0;h[k>>3]=Oa;c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];VLb(21,0,18056,T);Oa=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21648>>3];h[d+152>>3]=Oa;T=tv(19)|0;c[S>>2]=20;c[S+4>>2]=T;T=S+8|0;h[k>>3]=Oa;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];VLb(21,0,18056,S);Oa=+h[(c[la>>2]|0)+21880>>3]+-.175;h[d+160>>3]=Oa;S=tv(20)|0;c[R>>2]=21;c[R+4>>2]=S;S=R+8|0;h[k>>3]=Oa;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];VLb(21,0,18056,R);R=c[(c[c[qa>>2]>>2]|0)+8>>2]|0;Oa=+h[R+9944>>3];La=+h[R+9960>>3];S=Q;h[k>>3]=+h[R+9952>>3];c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];S=Q+8|0;h[k>>3]=La;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];UMb(xa,3,Oa,Q);Q=c[(c[c[qa>>2]>>2]|0)+8>>2]|0;Oa=+h[Q+15136>>3];La=+h[Q+15152>>3];S=P;h[k>>3]=+h[Q+15144>>3];c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];S=P+8|0;h[k>>3]=La;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];UMb(ya,3,Oa,P);P=c[ia>>2]|0;S=c[la>>2]|0;Oa=+h[S+21808>>3];La=+h[S+21816>>3]+ +h[S+21824>>3];S=q;Q=18072;c[S+0>>2]=c[Q+0>>2];c[S+4>>2]=c[Q+4>>2];c[S+8>>2]=c[Q+8>>2];Q=p;S=xa;c[Q+0>>2]=c[S+0>>2];c[Q+4>>2]=c[S+4>>2];c[Q+8>>2]=c[S+8>>2];S=o;Q=ya;c[S+0>>2]=c[Q+0>>2];c[S+4>>2]=c[Q+4>>2];c[S+8>>2]=c[Q+8>>2];dv(Ga,P,Oa,q,La,p,o);o=a[Ga]|0;Ga=a[(c[Da>>2]|0)+131|0]|0;p=(Ga|o)<<24>>24==0;if(p|Ga<<24>>24==0){Pa=p?0.0:1.0}else{Pa=+(o<<24>>24==0|0)}h[d+168>>3]=Pa;o=tv(21)|0;c[O>>2]=22;c[O+4>>2]=o;o=O+8|0;h[k>>3]=Pa;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];VLb(21,0,18056,O);yv(b);Pa=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21608>>3];h[d+176>>3]=Pa;O=tv(22)|0;c[N>>2]=23;c[N+4>>2]=O;O=N+8|0;h[k>>3]=Pa;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];VLb(21,0,18056,N);Pa=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21616>>3];h[d+184>>3]=Pa;N=tv(23)|0;c[M>>2]=24;c[M+4>>2]=N;N=M+8|0;h[k>>3]=Pa;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];VLb(21,0,18056,M);Pa=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21624>>3];h[d+192>>3]=Pa;M=tv(24)|0;c[L>>2]=25;c[L+4>>2]=M;M=L+8|0;h[k>>3]=Pa;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];VLb(21,0,18056,L);Pa=+h[(c[la>>2]|0)+20848>>3]+-.175;h[d+200>>3]=Pa;L=tv(25)|0;c[K>>2]=26;c[K+4>>2]=L;L=K+8|0;h[k>>3]=Pa;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];VLb(21,0,18056,K);K=c[(c[c[qa>>2]>>2]|0)+8>>2]|0;Pa=+h[K+9824>>3];La=+h[K+9840>>3];L=J;h[k>>3]=+h[K+9832>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=J+8|0;h[k>>3]=La;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];UMb(za,3,Pa,J);J=c[(c[c[qa>>2]>>2]|0)+8>>2]|0;Pa=+h[J+15112>>3];La=+h[J+15128>>3];L=I;h[k>>3]=+h[J+15120>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=I+8|0;h[k>>3]=La;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];UMb(Aa,3,Pa,I);I=c[ia>>2]|0;L=c[la>>2]|0;Pa=+h[L+20776>>3];La=+h[L+20784>>3]+ +h[L+20792>>3];L=n;J=18072;c[L+0>>2]=c[J+0>>2];c[L+4>>2]=c[J+4>>2];c[L+8>>2]=c[J+8>>2];J=m;L=za;c[J+0>>2]=c[L+0>>2];c[J+4>>2]=c[L+4>>2];c[J+8>>2]=c[L+8>>2];L=l;J=Aa;c[L+0>>2]=c[J+0>>2];c[L+4>>2]=c[J+4>>2];c[L+8>>2]=c[J+8>>2];dv(Ha,I,Pa,n,La,m,l);l=a[Ha]|0;Ha=a[(c[Da>>2]|0)+83|0]|0;m=(Ha|l)<<24>>24==0;if(m|Ha<<24>>24==0){Qa=m?0.0:1.0}else{Qa=+(l<<24>>24==0|0)}h[d+208>>3]=Qa;l=tv(26)|0;c[H>>2]=27;c[H+4>>2]=l;l=H+8|0;h[k>>3]=Qa;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];VLb(21,0,18056,H);zv(b);Qa=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21584>>3];h[d+216>>3]=Qa;b=tv(27)|0;c[G>>2]=28;c[G+4>>2]=b;b=G+8|0;h[k>>3]=Qa;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];VLb(21,0,18056,G);Qa=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21592>>3];h[d+224>>3]=Qa;G=tv(28)|0;c[F>>2]=29;c[F+4>>2]=G;G=F+8|0;h[k>>3]=Qa;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];VLb(21,0,18056,F);Qa=+h[(c[(c[c[qa>>2]>>2]|0)+8>>2]|0)+21600>>3];h[d+232>>3]=Qa;F=tv(29)|0;c[E>>2]=30;c[E+4>>2]=F;F=E+8|0;h[k>>3]=Qa;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];VLb(21,0,18056,E);Qa=+h[(c[la>>2]|0)+19816>>3]+-.175;h[d+240>>3]=Qa;E=tv(30)|0;c[D>>2]=31;c[D+4>>2]=E;E=D+8|0;h[k>>3]=Qa;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];VLb(21,0,18056,D);D=c[(c[c[qa>>2]>>2]|0)+8>>2]|0;Qa=+h[D+9704>>3];La=+h[D+9720>>3];E=C;h[k>>3]=+h[D+9712>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=C+8|0;h[k>>3]=La;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];UMb(Ba,3,Qa,C);C=c[(c[c[qa>>2]>>2]|0)+8>>2]|0;Qa=+h[C+15088>>3];La=+h[C+15104>>3];qa=B;h[k>>3]=+h[C+15096>>3];c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=B+8|0;h[k>>3]=La;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];UMb(Ca,3,Qa,B);B=c[ia>>2]|0;ia=c[la>>2]|0;Qa=+h[ia+19744>>3];La=+h[ia+19752>>3]+ +h[ia+19760>>3];ia=j;la=18072;c[ia+0>>2]=c[la+0>>2];c[ia+4>>2]=c[la+4>>2];c[ia+8>>2]=c[la+8>>2];la=g;ia=Ba;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];ia=f;la=Ca;c[ia+0>>2]=c[la+0>>2];c[ia+4>>2]=c[la+4>>2];c[ia+8>>2]=c[la+8>>2];dv(Ia,B,Qa,j,La,g,f);f=a[Ia]|0;Ia=a[(c[Da>>2]|0)+35|0]|0;Da=(Ia|f)<<24>>24==0;if(Da|Ia<<24>>24==0){Ra=Da?0.0:1.0}else{Ra=+(f<<24>>24==0|0)}h[d+248>>3]=Ra;d=tv(31)|0;c[A>>2]=32;c[A+4>>2]=d;d=A+8|0;h[k>>3]=Ra;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];VLb(21,0,18056,A);if((c[233644>>2]|0)==0){i=e;return 0}de[c[58528]&511](21);i=e;return 0}function Bv(b){b=b|0;h[(c[b+416>>2]|0)+25528>>3]=(a[(c[b+424>>2]|0)+313|0]|0)!=0?.6435942529055827:1.0;i=i;return}function Cv(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+25528>>3];j=+h[f+25512>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18096,18088,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+25536>>3]=l*6.283185307179586;i=d;return}function Dv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18496>>3]=+h[b+18232>>3];i=i;return}function Ev(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18480>>3]=+h[b+18216>>3];i=i;return}function Fv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18376>>3]=+h[b+18208>>3];i=i;return}function Gv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18360>>3]=+h[b+18192>>3];i=i;return}function Hv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25288>>3]=+h[b+24512>>3];i=i;return}function Iv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25392>>3]=+h[b+25288>>3];i=i;return}function Jv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18224>>3]=+h[b+24504>>3]*.5;i=i;return}function Kv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18488>>3]=+h[b+18224>>3];i=i;return}function Lv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18200>>3]=+h[b+24504>>3];i=i;return}function Mv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18368>>3]=+h[b+18200>>3];i=i;return}function Nv(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+18360>>3]- +h[b+18384>>3];e=+h[b+18368>>3]- +h[b+18392>>3];f=+h[b+18376>>3]- +h[b+18400>>3];h[b+25360>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Ov(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+25360>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18112,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+25368>>3]=l;i=d;return}function Pv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25376>>3]=+h[b+25368>>3];i=i;return}function Qv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17864>>3]=+h[b+17600>>3];i=i;return}function Rv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17848>>3]=+h[b+17584>>3];i=i;return}function Sv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17744>>3]=+h[b+17576>>3];i=i;return}function Tv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17728>>3]=+h[b+17560>>3];i=i;return}function Uv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25088>>3]=+h[b+24552>>3];i=i;return}function Vv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25192>>3]=+h[b+25088>>3];i=i;return}function Wv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17592>>3]=+h[b+24544>>3]*.5;i=i;return}function Xv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17856>>3]=+h[b+17592>>3];i=i;return}function Yv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17568>>3]=+h[b+24544>>3];i=i;return}function Zv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17736>>3]=+h[b+17568>>3];i=i;return}function _v(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+17728>>3]- +h[b+17752>>3];e=+h[b+17736>>3]- +h[b+17760>>3];f=+h[b+17744>>3]- +h[b+17768>>3];h[b+25160>>3]=+V(+(d*d+e*e+f*f));i=i;return}function $v(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+25160>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18152,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+25168>>3]=l;i=d;return}function aw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25176>>3]=+h[b+25168>>3];i=i;return}function bw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24832>>3]=+h[b+24792>>3];i=i;return}function cw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24920>>3]=+h[b+24832>>3];i=i;return}function dw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24784>>3]=-+h[b+24456>>3];i=i;return}function ew(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24824>>3]=+h[b+24784>>3];i=i;return}function fw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24912>>3]=+h[b+24824>>3];i=i;return}function gw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16096>>3]=+h[b+24464>>3]+ +h[b+24480>>3]*-.5;i=i;return}function hw(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+16096>>3]- +h[b+16216>>3];e=+h[b+16104>>3]- +h[b+16224>>3];f=+h[b+16112>>3]- +h[b+16232>>3];h[b+24696>>3]=+V(+(d*d+e*e+f*f));i=i;return}function iw(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+24696>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18160,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+24704>>3]=l;i=d;return}function jw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24712>>3]=+h[b+24704>>3];i=i;return}function kw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16008>>3]=+h[b+24472>>3];i=i;return}function lw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16e3>>3]=+h[b+24464>>3]+ +h[b+24480>>3]*-.5;i=i;return}function mw(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+16e3>>3]- +h[b+16024>>3];e=+h[b+16008>>3]- +h[b+16032>>3];f=+h[b+16016>>3]- +h[b+16040>>3];h[b+24656>>3]=+V(+(d*d+e*e+f*f));i=i;return}function nw(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+24656>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18168,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+24664>>3]=l;i=d;return}function ow(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24672>>3]=+h[b+24664>>3];i=i;return}function pw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15904>>3]=+h[b+24464>>3];i=i;return}function qw(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+15904>>3]- +h[b+15928>>3];e=+h[b+15912>>3]- +h[b+15936>>3];f=+h[b+15920>>3]- +h[b+15944>>3];h[b+24624>>3]=+V(+(d*d+e*e+f*f));i=i;return}function rw(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+24624>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18176,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+24632>>3]=l;i=d;return}function sw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24640>>3]=+h[b+24632>>3];i=i;return}function tw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15808>>3]=+h[b+24464>>3];i=i;return}function uw(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+15808>>3]- +h[b+15832>>3];e=+h[b+15816>>3]- +h[b+15840>>3];f=+h[b+15824>>3]- +h[b+15848>>3];h[b+24592>>3]=+V(+(d*d+e*e+f*f));i=i;return}function vw(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+24592>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18184,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+24600>>3]=l;i=d;return}function ww(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24608>>3]=+h[b+24600>>3];i=i;return}function xw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15480>>3]=+h[b+15216>>3];i=i;return}function yw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15464>>3]=+h[b+15200>>3];i=i;return}function zw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15360>>3]=+h[b+15192>>3];i=i;return}function Aw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15344>>3]=+h[b+15176>>3];i=i;return}function Bw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24256>>3]=+h[b+23480>>3];i=i;return}function Cw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24360>>3]=+h[b+24256>>3];i=i;return}function Dw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15208>>3]=+h[b+23472>>3]*.5;i=i;return}function Ew(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15472>>3]=+h[b+15208>>3];i=i;return}function Fw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15184>>3]=+h[b+23472>>3];i=i;return}function Gw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15352>>3]=+h[b+15184>>3];i=i;return}function Hw(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+15344>>3]- +h[b+15368>>3];e=+h[b+15352>>3]- +h[b+15376>>3];f=+h[b+15360>>3]- +h[b+15384>>3];h[b+24328>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Iw(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+24328>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18192,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+24336>>3]=l;i=d;return}function Jw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24344>>3]=+h[b+24336>>3];i=i;return}function Kw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14848>>3]=+h[b+14584>>3];i=i;return}function Lw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14832>>3]=+h[b+14568>>3];i=i;return}function Mw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14728>>3]=+h[b+14560>>3];i=i;return}function Nw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14712>>3]=+h[b+14544>>3];i=i;return}function Ow(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24056>>3]=+h[b+23520>>3];i=i;return}function Pw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24160>>3]=+h[b+24056>>3];i=i;return}function Qw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14576>>3]=+h[b+23512>>3]*.5;i=i;return}function Rw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14840>>3]=+h[b+14576>>3];i=i;return}function Sw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14552>>3]=+h[b+23512>>3];i=i;return}function Tw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14720>>3]=+h[b+14552>>3];i=i;return}function Uw(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+14712>>3]- +h[b+14736>>3];e=+h[b+14720>>3]- +h[b+14744>>3];f=+h[b+14728>>3]- +h[b+14752>>3];h[b+24128>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Vw(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+24128>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18200,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+24136>>3]=l;i=d;return}function Ww(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24144>>3]=+h[b+24136>>3];i=i;return}function Xw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23800>>3]=+h[b+23760>>3];i=i;return}function Yw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23888>>3]=+h[b+23800>>3];i=i;return}function Zw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23752>>3]=-+h[b+23424>>3];i=i;return}function _w(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23792>>3]=+h[b+23752>>3];i=i;return}function $w(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23880>>3]=+h[b+23792>>3];i=i;return}function ax(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13080>>3]=+h[b+23432>>3]+ +h[b+23448>>3]*-.5;i=i;return}function bx(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+13080>>3]- +h[b+13200>>3];e=+h[b+13088>>3]- +h[b+13208>>3];f=+h[b+13096>>3]- +h[b+13216>>3];h[b+23664>>3]=+V(+(d*d+e*e+f*f));i=i;return}function cx(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+23664>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18208,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+23672>>3]=l;i=d;return}function dx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23680>>3]=+h[b+23672>>3];i=i;return}function ex(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12992>>3]=+h[b+23440>>3];i=i;return}function fx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12984>>3]=+h[b+23432>>3]+ +h[b+23448>>3]*-.5;i=i;return}function gx(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+12984>>3]- +h[b+13008>>3];e=+h[b+12992>>3]- +h[b+13016>>3];f=+h[b+13e3>>3]- +h[b+13024>>3];h[b+23624>>3]=+V(+(d*d+e*e+f*f));i=i;return}function hx(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+23624>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18216,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+23632>>3]=l;i=d;return}function ix(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23640>>3]=+h[b+23632>>3];i=i;return}function jx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12888>>3]=+h[b+23432>>3];i=i;return}function kx(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+12888>>3]- +h[b+12912>>3];e=+h[b+12896>>3]- +h[b+12920>>3];f=+h[b+12904>>3]- +h[b+12928>>3];h[b+23592>>3]=+V(+(d*d+e*e+f*f));i=i;return}function lx(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+23592>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18224,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+23600>>3]=l;i=d;return}function mx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23608>>3]=+h[b+23600>>3];i=i;return}function nx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12792>>3]=+h[b+23432>>3];i=i;return}function ox(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+12792>>3]- +h[b+12816>>3];e=+h[b+12800>>3]- +h[b+12824>>3];f=+h[b+12808>>3]- +h[b+12832>>3];h[b+23560>>3]=+V(+(d*d+e*e+f*f));i=i;return}function px(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+23560>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18232,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+23568>>3]=l;i=d;return}function qx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23576>>3]=+h[b+23568>>3];i=i;return}function rx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12464>>3]=+h[b+12200>>3];i=i;return}function sx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12448>>3]=+h[b+12184>>3];i=i;return}function tx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12344>>3]=+h[b+12176>>3];i=i;return}function ux(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12328>>3]=+h[b+12160>>3];i=i;return}function vx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23224>>3]=+h[b+22448>>3];i=i;return}function wx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23328>>3]=+h[b+23224>>3];i=i;return}function xx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12192>>3]=+h[b+22440>>3]*.5;i=i;return}function yx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12456>>3]=+h[b+12192>>3];i=i;return}function zx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12168>>3]=+h[b+22440>>3];i=i;return}function Ax(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12336>>3]=+h[b+12168>>3];i=i;return}function Bx(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+12328>>3]- +h[b+12352>>3];e=+h[b+12336>>3]- +h[b+12360>>3];f=+h[b+12344>>3]- +h[b+12368>>3];h[b+23296>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Cx(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+23296>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18240,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+23304>>3]=l;i=d;return}function Dx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23312>>3]=+h[b+23304>>3];i=i;return}function Ex(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11832>>3]=+h[b+11568>>3];i=i;return}function Fx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11816>>3]=+h[b+11552>>3];i=i;return}function Gx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11712>>3]=+h[b+11544>>3];i=i;return}function Hx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11696>>3]=+h[b+11528>>3];i=i;return}function Ix(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23024>>3]=+h[b+22488>>3];i=i;return}function Jx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23128>>3]=+h[b+23024>>3];i=i;return}function Kx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11560>>3]=+h[b+22480>>3]*.5;i=i;return}function Lx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11824>>3]=+h[b+11560>>3];i=i;return}function Mx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11536>>3]=+h[b+22480>>3];i=i;return}function Nx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11704>>3]=+h[b+11536>>3];i=i;return}function Ox(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+11696>>3]- +h[b+11720>>3];e=+h[b+11704>>3]- +h[b+11728>>3];f=+h[b+11712>>3]- +h[b+11736>>3];h[b+23096>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Px(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+23096>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18248,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+23104>>3]=l;i=d;return}function Qx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23112>>3]=+h[b+23104>>3];i=i;return}function Rx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22768>>3]=+h[b+22728>>3];i=i;return}function Sx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22856>>3]=+h[b+22768>>3];i=i;return}function Tx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22720>>3]=-+h[b+22392>>3];i=i;return}function Ux(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22760>>3]=+h[b+22720>>3];i=i;return}function Vx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22848>>3]=+h[b+22760>>3];i=i;return}function Wx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10064>>3]=+h[b+22400>>3]+ +h[b+22416>>3]*-.5;i=i;return}function Xx(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+10064>>3]- +h[b+10184>>3];e=+h[b+10072>>3]- +h[b+10192>>3];f=+h[b+10080>>3]- +h[b+10200>>3];h[b+22632>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Yx(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+22632>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18256,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+22640>>3]=l;i=d;return}function Zx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22648>>3]=+h[b+22640>>3];i=i;return}function _x(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9976>>3]=+h[b+22408>>3];i=i;return}function $x(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9968>>3]=+h[b+22400>>3]+ +h[b+22416>>3]*-.5;i=i;return}function ay(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+9968>>3]- +h[b+9992>>3];e=+h[b+9976>>3]- +h[b+1e4>>3];f=+h[b+9984>>3]- +h[b+10008>>3];h[b+22592>>3]=+V(+(d*d+e*e+f*f));i=i;return}function by(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+22592>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18264,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+22600>>3]=l;i=d;return}function cy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22608>>3]=+h[b+22600>>3];i=i;return}function dy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9872>>3]=+h[b+22400>>3];i=i;return}function ey(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+9872>>3]- +h[b+9896>>3];e=+h[b+9880>>3]- +h[b+9904>>3];f=+h[b+9888>>3]- +h[b+9912>>3];h[b+22560>>3]=+V(+(d*d+e*e+f*f));i=i;return}function fy(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+22560>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18272,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+22568>>3]=l;i=d;return}function gy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22576>>3]=+h[b+22568>>3];i=i;return}function hy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9776>>3]=+h[b+22400>>3];i=i;return}function iy(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+9776>>3]- +h[b+9800>>3];e=+h[b+9784>>3]- +h[b+9808>>3];f=+h[b+9792>>3]- +h[b+9816>>3];h[b+22528>>3]=+V(+(d*d+e*e+f*f));i=i;return}function jy(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+22528>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18280,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+22536>>3]=l;i=d;return}function ky(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22544>>3]=+h[b+22536>>3];i=i;return}function ly(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9448>>3]=+h[b+9184>>3];i=i;return}function my(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9432>>3]=+h[b+9168>>3];i=i;return}function ny(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9328>>3]=+h[b+9160>>3];i=i;return}function oy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9312>>3]=+h[b+9144>>3];i=i;return}function py(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22192>>3]=+h[b+21416>>3];i=i;return}function qy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22296>>3]=+h[b+22192>>3];i=i;return}function ry(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9176>>3]=+h[b+21408>>3]*.5;i=i;return}function sy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9440>>3]=+h[b+9176>>3];i=i;return}function ty(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9152>>3]=+h[b+21408>>3];i=i;return}function uy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9320>>3]=+h[b+9152>>3];i=i;return}function vy(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+9312>>3]- +h[b+9336>>3];e=+h[b+9320>>3]- +h[b+9344>>3];f=+h[b+9328>>3]- +h[b+9352>>3];h[b+22264>>3]=+V(+(d*d+e*e+f*f));i=i;return}function wy(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+22264>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18288,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+22272>>3]=l;i=d;return}function xy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22280>>3]=+h[b+22272>>3];i=i;return}function yy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8816>>3]=+h[b+8552>>3];i=i;return}function zy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8800>>3]=+h[b+8536>>3];i=i;return}function Ay(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8696>>3]=+h[b+8528>>3];i=i;return}function By(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8680>>3]=+h[b+8512>>3];i=i;return}function Cy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21992>>3]=+h[b+21456>>3];i=i;return}function Dy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22096>>3]=+h[b+21992>>3];i=i;return}function Ey(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8544>>3]=+h[b+21448>>3]*.5;i=i;return}function Fy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8808>>3]=+h[b+8544>>3];i=i;return}function Gy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8520>>3]=+h[b+21448>>3];i=i;return}function Hy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8688>>3]=+h[b+8520>>3];i=i;return}function Iy(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+8680>>3]- +h[b+8704>>3];e=+h[b+8688>>3]- +h[b+8712>>3];f=+h[b+8696>>3]- +h[b+8720>>3];h[b+22064>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Jy(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+22064>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18296,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+22072>>3]=l;i=d;return}function Ky(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22080>>3]=+h[b+22072>>3];i=i;return}function Ly(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21736>>3]=+h[b+21696>>3];i=i;return}function My(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21824>>3]=+h[b+21736>>3];i=i;return}function Ny(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21688>>3]=-+h[b+21360>>3];i=i;return}function Oy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21728>>3]=+h[b+21688>>3];i=i;return}function Py(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21816>>3]=+h[b+21728>>3];i=i;return}function Qy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7048>>3]=+h[b+21368>>3]+ +h[b+21384>>3]*-.5;i=i;return}function Ry(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+7048>>3]- +h[b+7168>>3];e=+h[b+7056>>3]- +h[b+7176>>3];f=+h[b+7064>>3]- +h[b+7184>>3];h[b+21600>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Sy(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+21600>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18304,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+21608>>3]=l;i=d;return}function Ty(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21616>>3]=+h[b+21608>>3];i=i;return}function Uy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6960>>3]=+h[b+21376>>3];i=i;return}function Vy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6952>>3]=+h[b+21368>>3]+ +h[b+21384>>3]*-.5;i=i;return}function Wy(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+6952>>3]- +h[b+6976>>3];e=+h[b+6960>>3]- +h[b+6984>>3];f=+h[b+6968>>3]- +h[b+6992>>3];h[b+21560>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Xy(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+21560>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18312,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+21568>>3]=l;i=d;return}function Yy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21576>>3]=+h[b+21568>>3];i=i;return}function Zy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6856>>3]=+h[b+21368>>3];i=i;return}function _y(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+6856>>3]- +h[b+6880>>3];e=+h[b+6864>>3]- +h[b+6888>>3];f=+h[b+6872>>3]- +h[b+6896>>3];h[b+21528>>3]=+V(+(d*d+e*e+f*f));i=i;return}function $y(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+21528>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18320,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+21536>>3]=l;i=d;return}function az(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21544>>3]=+h[b+21536>>3];i=i;return}function bz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6760>>3]=+h[b+21368>>3];i=i;return}function cz(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+6760>>3]- +h[b+6784>>3];e=+h[b+6768>>3]- +h[b+6792>>3];f=+h[b+6776>>3]- +h[b+6800>>3];h[b+21496>>3]=+V(+(d*d+e*e+f*f));i=i;return}function dz(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+21496>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18328,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+21504>>3]=l;i=d;return}function ez(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21512>>3]=+h[b+21504>>3];i=i;return}function fz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6432>>3]=+h[b+6168>>3];i=i;return}function gz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6416>>3]=+h[b+6152>>3];i=i;return}function hz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6312>>3]=+h[b+6144>>3];i=i;return}function iz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6296>>3]=+h[b+6128>>3];i=i;return}function jz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21160>>3]=+h[b+20384>>3];i=i;return}function kz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21264>>3]=+h[b+21160>>3];i=i;return}function lz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6160>>3]=+h[b+20376>>3]*.5;i=i;return}function mz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6424>>3]=+h[b+6160>>3];i=i;return}function nz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6136>>3]=+h[b+20376>>3];i=i;return}function oz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6304>>3]=+h[b+6136>>3];i=i;return}function pz(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+6296>>3]- +h[b+6320>>3];e=+h[b+6304>>3]- +h[b+6328>>3];f=+h[b+6312>>3]- +h[b+6336>>3];h[b+21232>>3]=+V(+(d*d+e*e+f*f));i=i;return}function qz(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+21232>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18336,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+21240>>3]=l;i=d;return}function rz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21248>>3]=+h[b+21240>>3];i=i;return}function sz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5800>>3]=+h[b+5536>>3];i=i;return}function tz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5784>>3]=+h[b+5520>>3];i=i;return}function uz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5680>>3]=+h[b+5512>>3];i=i;return}function vz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5664>>3]=+h[b+5496>>3];i=i;return}function wz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20960>>3]=+h[b+20424>>3];i=i;return}function xz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21064>>3]=+h[b+20960>>3];i=i;return}function yz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5528>>3]=+h[b+20416>>3]*.5;i=i;return}function zz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5792>>3]=+h[b+5528>>3];i=i;return}function Az(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5504>>3]=+h[b+20416>>3];i=i;return}function Bz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5672>>3]=+h[b+5504>>3];i=i;return}function Cz(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+5664>>3]- +h[b+5688>>3];e=+h[b+5672>>3]- +h[b+5696>>3];f=+h[b+5680>>3]- +h[b+5704>>3];h[b+21032>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Dz(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+21032>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18344,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+21040>>3]=l;i=d;return}function Ez(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21048>>3]=+h[b+21040>>3];i=i;return}function Fz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20704>>3]=+h[b+20664>>3];i=i;return}function Gz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20792>>3]=+h[b+20704>>3];i=i;return}function Hz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20656>>3]=-+h[b+20328>>3];i=i;return}function Iz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20696>>3]=+h[b+20656>>3];i=i;return}function Jz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20784>>3]=+h[b+20696>>3];i=i;return}function Kz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4032>>3]=+h[b+20336>>3]+ +h[b+20352>>3]*-.5;i=i;return}function Lz(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+4032>>3]- +h[b+4152>>3];e=+h[b+4040>>3]- +h[b+4160>>3];f=+h[b+4048>>3]- +h[b+4168>>3];h[b+20568>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Mz(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+20568>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18352,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+20576>>3]=l;i=d;return}function Nz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20584>>3]=+h[b+20576>>3];i=i;return}function Oz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3944>>3]=+h[b+20344>>3];i=i;return}function Pz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3936>>3]=+h[b+20336>>3]+ +h[b+20352>>3]*-.5;i=i;return}function Qz(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+3936>>3]- +h[b+3960>>3];e=+h[b+3944>>3]- +h[b+3968>>3];f=+h[b+3952>>3]- +h[b+3976>>3];h[b+20528>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Rz(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+20528>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18360,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+20536>>3]=l;i=d;return}function Sz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20544>>3]=+h[b+20536>>3];i=i;return}function Tz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3840>>3]=+h[b+20336>>3];i=i;return}function Uz(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+3840>>3]- +h[b+3864>>3];e=+h[b+3848>>3]- +h[b+3872>>3];f=+h[b+3856>>3]- +h[b+3880>>3];h[b+20496>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Vz(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+20496>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18368,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+20504>>3]=l;i=d;return}function Wz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20512>>3]=+h[b+20504>>3];i=i;return}function Xz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3744>>3]=+h[b+20336>>3];i=i;return}function Yz(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+3744>>3]- +h[b+3768>>3];e=+h[b+3752>>3]- +h[b+3776>>3];f=+h[b+3760>>3]- +h[b+3784>>3];h[b+20464>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Zz(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+20464>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18376,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+20472>>3]=l;i=d;return}function _z(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20480>>3]=+h[b+20472>>3];i=i;return}function $z(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3416>>3]=+h[b+3152>>3];i=i;return}function aA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3400>>3]=+h[b+3136>>3];i=i;return}function bA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3296>>3]=+h[b+3128>>3];i=i;return}function cA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3280>>3]=+h[b+3112>>3];i=i;return}function dA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20128>>3]=+h[b+19352>>3];i=i;return}function eA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20232>>3]=+h[b+20128>>3];i=i;return}function fA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3144>>3]=+h[b+19344>>3]*.5;i=i;return}function gA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3408>>3]=+h[b+3144>>3];i=i;return}function hA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3120>>3]=+h[b+19344>>3];i=i;return}function iA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3288>>3]=+h[b+3120>>3];i=i;return}function jA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+3280>>3]- +h[b+3304>>3];e=+h[b+3288>>3]- +h[b+3312>>3];f=+h[b+3296>>3]- +h[b+3320>>3];h[b+20200>>3]=+V(+(d*d+e*e+f*f));i=i;return}function kA(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+20200>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18384,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+20208>>3]=l;i=d;return}function lA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20216>>3]=+h[b+20208>>3];i=i;return}function _setLinearVectorb4256$0(b){b=b|0;var d=0,e=0,f=0,j=0,k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0.0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0,qa=0.0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0.0,za=0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0.0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0,Ta=0,Ua=0,Va=0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0,lb=0.0,mb=0.0,nb=0,ob=0,pb=0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0,vb=0,wb=0,xb=0.0,yb=0,zb=0,Ab=0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0,Qb=0,Rb=0,Sb=0.0,Tb=0.0,Ub=0.0,Vb=0.0,Wb=0,Xb=0,Yb=0,Zb=0.0,_b=0,$b=0,ac=0,bc=0.0,cc=0.0,dc=0.0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0.0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0,uc=0,vc=0,wc=0.0,xc=0.0,yc=0.0,zc=0.0,Ac=0.0,Bc=0.0,Cc=0,Dc=0,Ec=0,Fc=0.0,Gc=0.0,Hc=0.0,Ic=0,Jc=0,Kc=0,Lc=0.0,Mc=0.0,Nc=0.0,Oc=0.0,Pc=0.0,Qc=0,Rc=0,Sc=0,Tc=0.0,Uc=0.0,Vc=0.0,Wc=0.0,Xc=0.0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0.0,kd=0,ld=0,md=0,nd=0.0,od=0.0,pd=0,qd=0,rd=0,sd=0,td=0.0,ud=0.0,vd=0.0,wd=0.0,xd=0,yd=0,zd=0,Ad=0.0,Bd=0,Cd=0,Dd=0,Ed=0.0,Fd=0.0,Gd=0.0,Hd=0.0,Id=0.0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0.0,Qd=0.0,Rd=0,Sd=0,Td=0,Ud=0.0,Vd=0.0,Wd=0.0,Xd=0,Yd=0,Zd=0,_d=0.0,$d=0.0,ae=0.0,be=0,ce=0,de=0,ee=0.0,fe=0.0,ge=0,he=0,ie=0,je=0.0,ke=0.0,le=0.0,me=0.0,ne=0.0,oe=0,pe=0,qe=0,re=0.0,se=0.0,te=0.0,ue=0.0,ve=0.0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0.0,De=0.0,Ee=0.0,Fe=0,Ge=0,He=0,Ie=0.0,Je=0.0,Ke=0.0,Le=0.0,Me=0,Ne=0,Oe=0,Pe=0.0,Qe=0,Re=0,Se=0,Te=0.0,Ue=0.0,Ve=0.0,We=0.0,Xe=0.0,Ye=0,Ze=0,_e=0,$e=0.0,af=0.0,bf=0.0,cf=0.0,df=0.0,ef=0.0,ff=0.0,gf=0.0,hf=0.0,jf=0.0,kf=0.0,lf=0.0,mf=0.0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0;d=c[b+8>>2]|0;e=c[b+16>>2]|0;f=c[b+1224>>2]|0;j=c[b+1232>>2]|0;k=c[b+1248>>2]|0;l=+g[b+1312>>2];m=+g[b+1328>>2];n=c[b+6512>>2]|0;o=c[b+6520>>2]|0;p=c[b+6536>>2]|0;a:do{do{if(l!=0.0){q=k;r=j;s=f;t=m/l}else{if(m==0.0){q=k;r=j;s=f;t=m;break}u=m/+$Lb(c[d+536>>2]|0,l,8736,12080,+h[j>>3],(a[d+319|0]|0)!=0|0);v=c[c[(d+4|0)>>2]>>2]|0;q=c[v+8>>2]|0;r=v;s=c[(e+36|0)>>2]|0;t=u}}while(0);h[s+1824>>3]=t;v=q+8832|0;w=q+8840|0;h[s+1832>>3]=+h[q+4640>>3]*+h[v>>3]+ +h[q+4648>>3]*+h[w>>3];x=q+4664|0;y=q+4672|0;h[s+1840>>3]=-(+h[y>>3]*+h[w>>3])- +h[x>>3]*+h[v>>3];u=+h[q+16>>3];h[s+1848>>3]=+h[q+2144>>3]*+h[q+7320>>3]*u- +h[q+2136>>3]*u*+h[q+7344>>3];u=+h[q+20080>>3];z=+h[w>>3];A=+h[v>>3];B=u*(+h[y>>3]*A- +h[x>>3]*z)- +h[q+20808>>3]*(A*+h[q+2152>>3]-z*+h[q+2160>>3]);do{if(u*u!=0.0){C=q;D=r;E=s;F=B/(u*u)}else{if(B==0.0){C=q;D=r;E=s;F=B;break}z=B/+$Lb(c[d+536>>2]|0,u*u,10776,12080,+h[r>>3],(a[d+319|0]|0)!=0|0);x=c[c[(d+4|0)>>2]>>2]|0;C=c[x+8>>2]|0;D=x;E=c[(e+36|0)>>2]|0;F=z}}while(0);h[E+1856>>3]=F;u=+h[C+16>>3];x=c[(d+416|0)>>2]|0;B=+h[x+21880>>3];z=+h[C+14904>>3]*+h[C+8856>>3]+(+h[C+14896>>3]*+h[C+8864>>3]+ +h[C+7312>>3]);do{if(B!=0.0){G=x;H=C;I=D;J=E;K=z/B}else{if(z==0.0){G=x;H=C;I=D;J=E;K=z;break}A=z/+$Lb(c[d+536>>2]|0,B,8736,12080,+h[D>>3],(a[d+319|0]|0)!=0|0);y=c[c[(d+4|0)>>2]>>2]|0;G=c[(d+416|0)>>2]|0;H=c[y+8>>2]|0;I=y;J=c[(e+36|0)>>2]|0;K=A}}while(0);h[J+1864>>3]=u*K;B=+h[H+16>>3];h[J+1872>>3]=+h[H+14912>>3]*B*+h[G+6960>>3]*-B+ +h[H+14896>>3]*B*+h[G+6968>>3]*-B;x=H+8888|0;y=J+1880|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;B=+h[x>>3];z=+h[H+8896>>3];h[J+1896>>3]=(B*B+z*z)*2.0;z=+h[H+21e3>>3];h[J+1904>>3]=z*z*2.0;h[J+1912>>3]=0.0;z=+h[H+21024>>3];B=+W(+(+h[H+20096>>3]),1.5);do{if(B!=0.0){L=H;M=G;N=J;O=z*z*-.25/B}else{if(z*z*-.25==0.0){L=H;M=G;N=J;O=z*z*-.25;break}A=z*z*-.25/+$Lb(c[d+536>>2]|0,B,10840,12080,+h[I>>3],(a[d+319|0]|0)!=0|0);L=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;M=c[(d+416|0)>>2]|0;N=c[(e+36|0)>>2]|0;O=A}}while(0);h[N+1920>>3]=O;x=M+18840|0;y=N+1928|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;h[N+1944>>3]=+h[x>>3]*+h[M+22296>>3]*.8660254037844387;x=L+14920|0;n=N+1952|0;p=n+40|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));y=L+16|0;B=+h[y>>3];h[N+1992>>3]=+h[x>>3]*B*+h[M+6960>>3]*-B+ +h[L+14904>>3]*B*+h[M+6968>>3]*-B;v=L+16208|0;B=+h[y>>3];w=M+7440|0;P=L+16232|0;Q=M+7448|0;h[N+2e3>>3]=+h[v>>3]*B*+h[w>>3]*-B+ +h[P>>3]*B*+h[Q>>3]*-B;B=+h[y>>3];h[N+2008>>3]=+h[L+16200>>3]*B*+h[w>>3]*-B+ +h[L+16224>>3]*B*+h[Q>>3]*-B;B=+h[y>>3];y=c[(e+36|0)>>2]|0;h[y+2016>>3]=+h[v>>3]*B*+h[M+6864>>3]*-B+ +h[P>>3]*B*+h[M+6872>>3]*-B;P=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;B=+h[(P+16|0)>>3];v=c[(d+416|0)>>2]|0;h[y+2024>>3]=+h[P+16200>>3]*B*+h[v+6864>>3]*-B+ +h[P+16224>>3]*B*+h[v+6872>>3]*-B;h[y+2032>>3]=-(+h[(P+2808|0)>>3]*+h[P+7136>>3]*+h[(P+16|0)>>3]);B=+h[(P+2808|0)>>3]*+h[P+2792>>3];h[y+2040>>3]=B*.006+B*-.006;n=y+2048|0;p=n+56|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));x=(ZOb(+U(+(+h[(P+20304|0)>>3])),1.0e-10)|0)<<24>>24==0;y=c[c[(d+4|0)>>2]>>2]|0;v=c[y+8>>2]|0;do{if(x){B=+h[v+20224>>3];if(+h[v+20304>>3]!=0.0){R=-B;S=+h[v+20304>>3];o=97;break}if(B==-0.0){T=v;V=-B;break}z=-B/+$Lb(c[d+536>>2]|0,+h[v+20304>>3],10208,12080,+h[y>>3],(a[d+319|0]|0)!=0|0);T=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;V=z}else{R=-+h[v+20224>>3];S=1.0e-10;o=97}}while(0);if((o|0)==97){T=v;V=R/S}y=c[(e+36|0)>>2]|0;h[y+2104>>3]=V;x=T+7192|0;n=y+2112|0;p=n+128|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));v=c[(d+416|0)>>2]|0;P=T+2792|0;z=+h[P>>3];Q=T+2808|0;B=+h[Q>>3];u=+h[(v+5800|0)>>3];w=T+2800|0;A=+h[w>>3];h[y+2240>>3]=+h[(v+21064|0)>>3]*(+h[x>>3]*+h[(v+18840|0)>>3]+(z*(B*+h[(v+5784|0)>>3]-z*u)-A*(u*A-B*+h[(v+5792|0)>>3])));B=+h[w>>3]*+h[Q>>3];h[y+2248>>3]=B*.006+B*-5.0e-4;X=T+7144|0;c[(y+2256|0)+0>>2]=0;c[(y+2256|0)+4>>2]=0;c[(y+2256|0)+8>>2]=0;c[(y+2256|0)+12>>2]=0;B=+h[w>>3];A=+h[P>>3];u=+h[(v+5784|0)>>3];z=+h[Q>>3];Q=c[(e+36|0)>>2]|0;h[Q+2272>>3]=+h[(v+21064|0)>>3]*(+h[X>>3]*+h[(v+18840|0)>>3]+(B*(A*+h[(v+5792|0)>>3]-B*u)-z*(u*z-A*+h[(v+5800|0)>>3])));X=c[c[(d+4|0)>>2]>>2]|0;P=c[X+8>>2]|0;A=+h[(P+2792|0)>>3]*+h[(P+2800|0)>>3];h[Q+2280>>3]=A*5.0e-4+A*-.006;h[Q+2288>>3]=0.0;h[Q+2296>>3]=+h[(P+2808|0)>>3]*+h[P+7160>>3]*+h[(P+16|0)>>3];A=+h[(P+2808|0)>>3];z=+h[(P+2800|0)>>3];u=+h[(v+5792|0)>>3];B=+h[(P+2792|0)>>3];h[Q+2304>>3]=+h[(v+21064|0)>>3]*(+h[P+7168>>3]*+h[(v+18840|0)>>3]+(A*(z*+h[(v+5800|0)>>3]-A*u)-B*(u*B-z*+h[(v+5784|0)>>3])));z=+h[(c[(d+416|0)>>2]|0)+20848>>3];B=+h[(P+16|0)>>3];u=-(B*+h[P+7120>>3])-B*(+h[P+14872>>3]*+h[P+9136>>3]+ +h[P+14864>>3]*+h[P+9144>>3]);do{if(z!=0.0){Y=P;Z=X;_=Q;$=u/z}else{if(u==0.0){Y=P;Z=X;_=Q;$=u;break}B=u/+$Lb(c[d+536>>2]|0,z,1e4,12080,+h[X>>3],(a[d+319|0]|0)!=0|0);v=c[c[(d+4|0)>>2]>>2]|0;Y=c[v+8>>2]|0;Z=v;_=c[(e+36|0)>>2]|0;$=B}}while(0);h[_+2312>>3]=$;X=Y+9112|0;Q=Y+9120|0;h[_+2320>>3]=+h[Y+4568>>3]*+h[X>>3]+ +h[Y+4576>>3]*+h[Q>>3];P=Y+4592|0;y=Y+4600|0;h[_+2328>>3]=-(+h[y>>3]*+h[Q>>3])- +h[P>>3]*+h[X>>3];z=+h[Y+16>>3];h[_+2336>>3]=+h[Y+2864>>3]*+h[Y+7136>>3]*z- +h[Y+2856>>3]*z*+h[Y+7160>>3];z=+h[Y+20240>>3];u=+h[Q>>3];B=+h[X>>3];A=z*(+h[y>>3]*B- +h[P>>3]*u)- +h[Y+20800>>3]*(B*+h[Y+2872>>3]-u*+h[Y+2880>>3]);do{if(z*z!=0.0){aa=Y;ba=Z;ca=_;da=A/(z*z)}else{if(A==0.0){aa=Y;ba=Z;ca=_;da=A;break}u=A/+$Lb(c[d+536>>2]|0,z*z,11256,12080,+h[Z>>3],(a[d+319|0]|0)!=0|0);P=c[c[(d+4|0)>>2]>>2]|0;aa=c[P+8>>2]|0;ba=P;ca=c[(e+36|0)>>2]|0;da=u}}while(0);h[ca+2344>>3]=da;z=+h[aa+16>>3];P=c[(d+416|0)>>2]|0;A=+h[P+20848>>3];u=+h[aa+14856>>3]*+h[aa+9136>>3]+(+h[aa+14848>>3]*+h[aa+9144>>3]+ +h[aa+7128>>3]);do{if(A!=0.0){ea=P;fa=aa;ga=ba;ha=ca;ia=u/A}else{if(u==0.0){ea=P;fa=aa;ga=ba;ha=ca;ia=u;break}B=u/+$Lb(c[d+536>>2]|0,A,1e4,12080,+h[ba>>3],(a[d+319|0]|0)!=0|0);y=c[c[(d+4|0)>>2]>>2]|0;ea=c[(d+416|0)>>2]|0;fa=c[y+8>>2]|0;ga=y;ha=c[(e+36|0)>>2]|0;ia=B}}while(0);h[ha+2352>>3]=z*ia;A=+h[fa+16>>3];h[ha+2360>>3]=+h[fa+14864>>3]*A*+h[ea+3944>>3]*-A+ +h[fa+14848>>3]*A*+h[ea+3952>>3]*-A;P=fa+9168|0;y=ha+2368|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;A=+h[P>>3];u=+h[fa+9176>>3];h[ha+2384>>3]=(A*A+u*u)*2.0;u=+h[fa+20952>>3];h[ha+2392>>3]=u*u*2.0;h[ha+2400>>3]=0.0;u=+h[fa+20976>>3];A=+W(+(+h[fa+20256>>3]),1.5);do{if(A!=0.0){ja=fa;ka=ea;la=ha;ma=u*u*-.25/A}else{if(u*u*-.25==0.0){ja=fa;ka=ea;la=ha;ma=u*u*-.25;break}B=u*u*-.25/+$Lb(c[d+536>>2]|0,A,11320,12080,+h[ga>>3],(a[d+319|0]|0)!=0|0);ja=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;ka=c[(d+416|0)>>2]|0;la=c[(e+36|0)>>2]|0;ma=B}}while(0);h[la+2408>>3]=ma;P=ka+18840|0;y=la+2416|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;h[la+2432>>3]=+h[P>>3]*+h[ka+21264>>3]*.8660254037844387;P=ja+14872|0;n=la+2440|0;p=n+40|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));y=ja+16|0;A=+h[y>>3];h[la+2480>>3]=+h[P>>3]*A*+h[ka+3944>>3]*-A+ +h[ja+14856>>3]*A*+h[ka+3952>>3]*-A;X=ja+16208|0;A=+h[y>>3];Q=ka+4424|0;x=ja+16232|0;v=ka+4432|0;h[la+2488>>3]=+h[X>>3]*A*+h[Q>>3]*-A+ +h[x>>3]*A*+h[v>>3]*-A;A=+h[y>>3];h[la+2496>>3]=+h[ja+16200>>3]*A*+h[Q>>3]*-A+ +h[ja+16224>>3]*A*+h[v>>3]*-A;A=+h[y>>3];y=c[(e+36|0)>>2]|0;h[y+2504>>3]=+h[X>>3]*A*+h[ka+3848>>3]*-A+ +h[x>>3]*A*+h[ka+3856>>3]*-A;x=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;A=+h[(x+16|0)>>3];X=c[(d+416|0)>>2]|0;h[y+2512>>3]=+h[x+16200>>3]*A*+h[X+3848>>3]*-A+ +h[x+16224>>3]*A*+h[X+3856>>3]*-A;h[y+2520>>3]=-(+h[(x+3528|0)>>3]*+h[x+6952>>3]*+h[(x+16|0)>>3]);A=+h[(x+3528|0)>>3]*+h[x+3512>>3];h[y+2528>>3]=A*.006+A*-.006;n=y+2536|0;p=n+56|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));P=(ZOb(+U(+(+h[(x+20464|0)>>3])),1.0e-10)|0)<<24>>24==0;y=c[c[(d+4|0)>>2]>>2]|0;X=c[y+8>>2]|0;do{if(P){A=+h[X+20384>>3];if(+h[X+20464>>3]!=0.0){na=-A;oa=+h[X+20464>>3];o=120;break}if(A==-0.0){pa=X;qa=-A;break}u=-A/+$Lb(c[d+536>>2]|0,+h[X+20464>>3],10592,12080,+h[y>>3],(a[d+319|0]|0)!=0|0);pa=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;qa=u}else{na=-+h[X+20384>>3];oa=1.0e-10;o=120}}while(0);if((o|0)==120){pa=X;qa=na/oa}y=c[(e+36|0)>>2]|0;h[y+2592>>3]=qa;P=pa+7008|0;n=y+2600|0;p=n+128|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));X=c[(d+416|0)>>2]|0;x=pa+3512|0;u=+h[x>>3];v=pa+3528|0;A=+h[v>>3];z=+h[(X+2784|0)>>3];Q=pa+3520|0;B=+h[Q>>3];h[y+2728>>3]=+h[(X+20032|0)>>3]*(+h[P>>3]*+h[(X+18840|0)>>3]+(u*(A*+h[(X+2768|0)>>3]-u*z)-B*(z*B-A*+h[(X+2776|0)>>3])));A=+h[Q>>3]*+h[v>>3];h[y+2736>>3]=A*.006+A*-5.0e-4;w=pa+6960|0;c[(y+2744|0)+0>>2]=0;c[(y+2744|0)+4>>2]=0;c[(y+2744|0)+8>>2]=0;c[(y+2744|0)+12>>2]=0;A=+h[Q>>3];B=+h[x>>3];z=+h[(X+2768|0)>>3];u=+h[v>>3];v=c[(e+36|0)>>2]|0;h[v+2760>>3]=+h[(X+20032|0)>>3]*(+h[w>>3]*+h[(X+18840|0)>>3]+(A*(B*+h[(X+2776|0)>>3]-A*z)-u*(z*u-B*+h[(X+2784|0)>>3])));w=c[c[(d+4|0)>>2]>>2]|0;x=c[w+8>>2]|0;B=+h[(x+3512|0)>>3]*+h[(x+3520|0)>>3];h[v+2768>>3]=B*5.0e-4+B*-.006;h[v+2776>>3]=0.0;h[v+2784>>3]=+h[(x+3528|0)>>3]*+h[x+6976>>3]*+h[(x+16|0)>>3];B=+h[(x+3528|0)>>3];u=+h[(x+3520|0)>>3];z=+h[(X+2776|0)>>3];A=+h[(x+3512|0)>>3];h[v+2792>>3]=+h[(X+20032|0)>>3]*(+h[x+6984>>3]*+h[(X+18840|0)>>3]+(B*(u*+h[(X+2784|0)>>3]-B*z)-A*(z*A-u*+h[(X+2768|0)>>3])));u=+h[(c[(d+416|0)>>2]|0)+19816>>3];A=+h[(x+16|0)>>3];z=-(A*+h[x+6936>>3])-A*(+h[x+14824>>3]*+h[x+9416>>3]+ +h[x+14816>>3]*+h[x+9424>>3]);do{if(u!=0.0){ra=x;sa=w;ta=v;ua=z/u}else{if(z==0.0){ra=x;sa=w;ta=v;ua=z;break}A=z/+$Lb(c[d+536>>2]|0,u,10384,12080,+h[w>>3],(a[d+319|0]|0)!=0|0);X=c[c[(d+4|0)>>2]>>2]|0;ra=c[X+8>>2]|0;sa=X;ta=c[(e+36|0)>>2]|0;ua=A}}while(0);h[ta+2800>>3]=ua;w=ra+9392|0;v=ra+9400|0;h[ta+2808>>3]=+h[ra+4496>>3]*+h[w>>3]+ +h[ra+4504>>3]*+h[v>>3];x=ra+4520|0;y=ra+4528|0;h[ta+2816>>3]=-(+h[y>>3]*+h[v>>3])- +h[x>>3]*+h[w>>3];u=+h[ra+16>>3];h[ta+2824>>3]=+h[ra+3584>>3]*+h[ra+6952>>3]*u- +h[ra+3576>>3]*u*+h[ra+6976>>3];u=+h[ra+20400>>3];z=+h[v>>3];A=+h[w>>3];B=u*(+h[y>>3]*A- +h[x>>3]*z)- +h[ra+20792>>3]*(A*+h[ra+3592>>3]-z*+h[ra+3600>>3]);do{if(u*u!=0.0){va=ra;wa=sa;xa=ta;ya=B/(u*u)}else{if(B==0.0){va=ra;wa=sa;xa=ta;ya=B;break}z=B/+$Lb(c[d+536>>2]|0,u*u,11376,12080,+h[sa>>3],(a[d+319|0]|0)!=0|0);x=c[c[(d+4|0)>>2]>>2]|0;va=c[x+8>>2]|0;wa=x;xa=c[(e+36|0)>>2]|0;ya=z}}while(0);h[xa+2832>>3]=ya;u=+h[va+16>>3];x=c[(d+416|0)>>2]|0;B=+h[x+19816>>3];z=+h[va+14808>>3]*+h[va+9416>>3]+(+h[va+14800>>3]*+h[va+9424>>3]+ +h[va+6944>>3]);do{if(B!=0.0){za=x;Aa=va;Ba=wa;Ca=xa;Da=z/B}else{if(z==0.0){za=x;Aa=va;Ba=wa;Ca=xa;Da=z;break}A=z/+$Lb(c[d+536>>2]|0,B,10384,12080,+h[wa>>3],(a[d+319|0]|0)!=0|0);y=c[c[(d+4|0)>>2]>>2]|0;za=c[(d+416|0)>>2]|0;Aa=c[y+8>>2]|0;Ba=y;Ca=c[(e+36|0)>>2]|0;Da=A}}while(0);h[Ca+2840>>3]=u*Da;B=+h[Aa+16>>3];h[Ca+2848>>3]=+h[Aa+14816>>3]*B*+h[za+928>>3]*-B+ +h[Aa+14800>>3]*B*+h[za+936>>3]*-B;x=Aa+9448|0;y=Ca+2856|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;B=+h[x>>3];z=+h[Aa+9456>>3];h[Ca+2872>>3]=(B*B+z*z)*2.0;z=+h[Aa+20904>>3];h[Ca+2880>>3]=z*z*2.0;h[Ca+2888>>3]=0.0;z=+h[Aa+20928>>3];B=+W(+(+h[Aa+20416>>3]),1.5);if(B!=0.0){Ea=Aa;Fa=za;Ga=Ca;Ha=z*z*-.25/B;Ia=Ga;Ja=Ia+2896|0;Ka=Ja;h[Ka>>3]=Ha;La=Ga;Ma=La+2904|0;Na=Ma;Oa=Fa;Pa=Oa+18840|0;Qa=Pa;Ra=Na;c[Ra+0>>2]=0;c[Ra+4>>2]=0;c[Ra+8>>2]=0;c[Ra+12>>2]=0;Sa=+h[Qa>>3];Ta=Fa;Ua=Ta+20232|0;Va=Ua;Wa=+h[Va>>3];Xa=Sa*Wa;Ya=Xa*.8660254037844387;Za=Ga;_a=Za+2920|0;$a=_a;h[$a>>3]=Ya;ab=Ga;bb=ab+2928|0;cb=bb;db=Ea;eb=db+14824|0;fb=eb;gb=cb;n=gb+0|0;p=n+40|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));hb=+h[fb>>3];ib=Ea;jb=ib+16|0;kb=jb;lb=+h[kb>>3];mb=-lb;nb=Fa;ob=nb+928|0;pb=ob;qb=+h[pb>>3];rb=lb*qb;sb=rb*mb;tb=hb*sb;ub=Ea;vb=ub+14808|0;wb=vb;xb=+h[wb>>3];yb=Fa;zb=yb+936|0;Ab=zb;Bb=+h[Ab>>3];Cb=lb*Bb;Db=Cb*mb;Eb=xb*Db;Fb=tb+Eb;Gb=Ga;Hb=Gb+2968|0;Ib=Hb;h[Ib>>3]=Fb;Jb=Ea;Kb=Jb+16208|0;Lb=Kb;Mb=+h[Lb>>3];Nb=+h[kb>>3];Ob=-Nb;Pb=Fa;Qb=Pb+1408|0;Rb=Qb;Sb=+h[Rb>>3];Tb=Nb*Sb;Ub=Tb*Ob;Vb=Mb*Ub;Wb=Ea;Xb=Wb+16232|0;Yb=Xb;Zb=+h[Yb>>3];_b=Fa;$b=_b+1416|0;ac=$b;bc=+h[ac>>3];cc=Nb*bc;dc=cc*Ob;ec=Zb*dc;fc=Vb+ec;gc=Ga;hc=gc+2976|0;ic=hc;h[ic>>3]=fc;jc=Ea;kc=jc+16200|0;lc=kc;mc=+h[lc>>3];nc=+h[kb>>3];oc=-nc;pc=+h[Rb>>3];qc=nc*pc;rc=qc*oc;sc=mc*rc;tc=Ea;uc=tc+16224|0;vc=uc;wc=+h[vc>>3];xc=+h[ac>>3];yc=nc*xc;zc=yc*oc;Ac=wc*zc;Bc=sc+Ac;Cc=Ga;Dc=Cc+2984|0;Ec=Dc;h[Ec>>3]=Bc;Fc=+h[Lb>>3];Gc=+h[kb>>3];Hc=-Gc;Ic=Fa;Jc=Ic+832|0;Kc=Jc;Lc=+h[Kc>>3];Mc=Gc*Lc;Nc=Mc*Hc;Oc=Fc*Nc;Pc=+h[Yb>>3];Qc=Fa;Rc=Qc+840|0;Sc=Rc;Tc=+h[Sc>>3];Uc=Gc*Tc;Vc=Uc*Hc;Wc=Pc*Vc;Xc=Oc+Wc;Yc=c[(e+36|0)>>2]|0;Zc=Yc;_c=Zc+2992|0;$c=_c;h[$c>>3]=Xc;ad=c[(d+4|0)>>2]|0;bd=c[ad>>2]|0;cd=bd;dd=cd+8|0;ed=dd;fd=c[ed>>2]|0;gd=fd;hd=gd+16200|0;id=hd;jd=+h[id>>3];kd=fd;ld=kd+16|0;md=ld;nd=+h[md>>3];od=-nd;pd=c[(d+416|0)>>2]|0;qd=pd;rd=qd+832|0;sd=rd;td=+h[sd>>3];ud=nd*td;vd=ud*od;wd=jd*vd;xd=fd;yd=xd+16224|0;zd=yd;Ad=+h[zd>>3];Bd=pd;Cd=Bd+840|0;Dd=Cd;Ed=+h[Dd>>3];Fd=nd*Ed;Gd=Fd*od;Hd=Ad*Gd;Id=wd+Hd;Jd=Yc;Kd=Jd+3e3|0;Ld=Kd;h[Ld>>3]=Id;Md=Yc;Nd=Md+3008|0;Od=Nd;h[Od>>3]=0.0;Pd=+h[md>>3];Qd=+h[zd>>3];Rd=pd;Sd=Rd+18840|0;Td=Sd;Ud=+h[Td>>3];Vd=Qd*Ud;Wd=Pd*Pd;Xd=pd;Yd=Xd+400|0;Zd=Yd;_d=+h[Zd>>3];$d=Wd*_d;ae=Vd-$d;be=pd;ce=be+19200|0;de=ce;ee=+h[de>>3];fe=ee*ae;ge=Yc;he=ge+3016|0;ie=he;h[ie>>3]=fe;je=+h[md>>3];ke=+h[id>>3];le=+h[Td>>3];me=ke*le;ne=je*je;oe=pd;pe=oe+392|0;qe=pe;re=+h[qe>>3];se=ne*re;te=me-se;ue=+h[de>>3];ve=ue*te;we=Yc;xe=we+3024|0;ye=xe;h[ye>>3]=ve;ze=fd;Ae=ze+16208|0;Be=Ae;Ce=+h[Be>>3];De=+h[md>>3];Ee=-De;Fe=pd;Ge=Fe+272|0;He=Ge;Ie=+h[He>>3];Je=De*Ie;Ke=Je*Ee;Le=Ce*Ke;Me=fd;Ne=Me+16232|0;Oe=Ne;Pe=+h[Oe>>3];Qe=pd;Re=Qe+280|0;Se=Re;Te=+h[Se>>3];Ue=De*Te;Ve=Ue*Ee;We=Pe*Ve;Xe=Le+We;Ye=Yc;Ze=Ye+3032|0;_e=Ze;h[_e>>3]=Xe;$e=+h[id>>3];af=+h[md>>3];bf=-af;cf=+h[He>>3];df=af*cf;ef=df*bf;ff=$e*ef;gf=+h[zd>>3];hf=+h[Se>>3];jf=af*hf;kf=jf*bf;lf=gf*kf;mf=ff+lf;nf=Yc;of=nf+3040|0;pf=of;h[pf>>3]=mf;qf=Yc;rf=qf+3048|0;sf=rf;h[sf>>3]=0.0;i=b;c[b+6544>>2]=5;break a}if(z*z*-.25==0.0){Ea=Aa;Fa=za;Ga=Ca;Ha=z*z*-.25;Ia=Ga;Ja=Ia+2896|0;Ka=Ja;h[Ka>>3]=Ha;La=Ga;Ma=La+2904|0;Na=Ma;Oa=Fa;Pa=Oa+18840|0;Qa=Pa;Ra=Na;c[Ra+0>>2]=0;c[Ra+4>>2]=0;c[Ra+8>>2]=0;c[Ra+12>>2]=0;Sa=+h[Qa>>3];Ta=Fa;Ua=Ta+20232|0;Va=Ua;Wa=+h[Va>>3];Xa=Sa*Wa;Ya=Xa*.8660254037844387;Za=Ga;_a=Za+2920|0;$a=_a;h[$a>>3]=Ya;ab=Ga;bb=ab+2928|0;cb=bb;db=Ea;eb=db+14824|0;fb=eb;gb=cb;n=gb+0|0;p=n+40|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));hb=+h[fb>>3];ib=Ea;jb=ib+16|0;kb=jb;lb=+h[kb>>3];mb=-lb;nb=Fa;ob=nb+928|0;pb=ob;qb=+h[pb>>3];rb=lb*qb;sb=rb*mb;tb=hb*sb;ub=Ea;vb=ub+14808|0;wb=vb;xb=+h[wb>>3];yb=Fa;zb=yb+936|0;Ab=zb;Bb=+h[Ab>>3];Cb=lb*Bb;Db=Cb*mb;Eb=xb*Db;Fb=tb+Eb;Gb=Ga;Hb=Gb+2968|0;Ib=Hb;h[Ib>>3]=Fb;Jb=Ea;Kb=Jb+16208|0;Lb=Kb;Mb=+h[Lb>>3];Nb=+h[kb>>3];Ob=-Nb;Pb=Fa;Qb=Pb+1408|0;Rb=Qb;Sb=+h[Rb>>3];Tb=Nb*Sb;Ub=Tb*Ob;Vb=Mb*Ub;Wb=Ea;Xb=Wb+16232|0;Yb=Xb;Zb=+h[Yb>>3];_b=Fa;$b=_b+1416|0;ac=$b;bc=+h[ac>>3];cc=Nb*bc;dc=cc*Ob;ec=Zb*dc;fc=Vb+ec;gc=Ga;hc=gc+2976|0;ic=hc;h[ic>>3]=fc;jc=Ea;kc=jc+16200|0;lc=kc;mc=+h[lc>>3];nc=+h[kb>>3];oc=-nc;pc=+h[Rb>>3];qc=nc*pc;rc=qc*oc;sc=mc*rc;tc=Ea;uc=tc+16224|0;vc=uc;wc=+h[vc>>3];xc=+h[ac>>3];yc=nc*xc;zc=yc*oc;Ac=wc*zc;Bc=sc+Ac;Cc=Ga;Dc=Cc+2984|0;Ec=Dc;h[Ec>>3]=Bc;Fc=+h[Lb>>3];Gc=+h[kb>>3];Hc=-Gc;Ic=Fa;Jc=Ic+832|0;Kc=Jc;Lc=+h[Kc>>3];Mc=Gc*Lc;Nc=Mc*Hc;Oc=Fc*Nc;Pc=+h[Yb>>3];Qc=Fa;Rc=Qc+840|0;Sc=Rc;Tc=+h[Sc>>3];Uc=Gc*Tc;Vc=Uc*Hc;Wc=Pc*Vc;Xc=Oc+Wc;Yc=c[(e+36|0)>>2]|0;Zc=Yc;_c=Zc+2992|0;$c=_c;h[$c>>3]=Xc;ad=c[(d+4|0)>>2]|0;bd=c[ad>>2]|0;cd=bd;dd=cd+8|0;ed=dd;fd=c[ed>>2]|0;gd=fd;hd=gd+16200|0;id=hd;jd=+h[id>>3];kd=fd;ld=kd+16|0;md=ld;nd=+h[md>>3];od=-nd;pd=c[(d+416|0)>>2]|0;qd=pd;rd=qd+832|0;sd=rd;td=+h[sd>>3];ud=nd*td;vd=ud*od;wd=jd*vd;xd=fd;yd=xd+16224|0;zd=yd;Ad=+h[zd>>3];Bd=pd;Cd=Bd+840|0;Dd=Cd;Ed=+h[Dd>>3];Fd=nd*Ed;Gd=Fd*od;Hd=Ad*Gd;Id=wd+Hd;Jd=Yc;Kd=Jd+3e3|0;Ld=Kd;h[Ld>>3]=Id;Md=Yc;Nd=Md+3008|0;Od=Nd;h[Od>>3]=0.0;Pd=+h[md>>3];Qd=+h[zd>>3];Rd=pd;Sd=Rd+18840|0;Td=Sd;Ud=+h[Td>>3];Vd=Qd*Ud;Wd=Pd*Pd;Xd=pd;Yd=Xd+400|0;Zd=Yd;_d=+h[Zd>>3];$d=Wd*_d;ae=Vd-$d;be=pd;ce=be+19200|0;de=ce;ee=+h[de>>3];fe=ee*ae;ge=Yc;he=ge+3016|0;ie=he;h[ie>>3]=fe;je=+h[md>>3];ke=+h[id>>3];le=+h[Td>>3];me=ke*le;ne=je*je;oe=pd;pe=oe+392|0;qe=pe;re=+h[qe>>3];se=ne*re;te=me-se;ue=+h[de>>3];ve=ue*te;we=Yc;xe=we+3024|0;ye=xe;h[ye>>3]=ve;ze=fd;Ae=ze+16208|0;Be=Ae;Ce=+h[Be>>3];De=+h[md>>3];Ee=-De;Fe=pd;Ge=Fe+272|0;He=Ge;Ie=+h[He>>3];Je=De*Ie;Ke=Je*Ee;Le=Ce*Ke;Me=fd;Ne=Me+16232|0;Oe=Ne;Pe=+h[Oe>>3];Qe=pd;Re=Qe+280|0;Se=Re;Te=+h[Se>>3];Ue=De*Te;Ve=Ue*Ee;We=Pe*Ve;Xe=Le+We;Ye=Yc;Ze=Ye+3032|0;_e=Ze;h[_e>>3]=Xe;$e=+h[id>>3];af=+h[md>>3];bf=-af;cf=+h[He>>3];df=af*cf;ef=df*bf;ff=$e*ef;gf=+h[zd>>3];hf=+h[Se>>3];jf=af*hf;kf=jf*bf;lf=gf*kf;mf=ff+lf;nf=Yc;of=nf+3040|0;pf=of;h[pf>>3]=mf;qf=Yc;rf=qf+3048|0;sf=rf;h[sf>>3]=0.0;i=b;c[b+6544>>2]=5;break a}u=z*z*-.25/+$Lb(c[d+536>>2]|0,B,11440,12080,+h[Ba>>3],(a[d+319|0]|0)!=0|0);Ea=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;Fa=c[(d+416|0)>>2]|0;Ga=c[(e+36|0)>>2]|0;Ha=u;Ia=Ga;Ja=Ia+2896|0;Ka=Ja;h[Ka>>3]=Ha;La=Ga;Ma=La+2904|0;Na=Ma;Oa=Fa;Pa=Oa+18840|0;Qa=Pa;Ra=Na;c[Ra+0>>2]=0;c[Ra+4>>2]=0;c[Ra+8>>2]=0;c[Ra+12>>2]=0;Sa=+h[Qa>>3];Ta=Fa;Ua=Ta+20232|0;Va=Ua;Wa=+h[Va>>3];Xa=Sa*Wa;Ya=Xa*.8660254037844387;Za=Ga;_a=Za+2920|0;$a=_a;h[$a>>3]=Ya;ab=Ga;bb=ab+2928|0;cb=bb;db=Ea;eb=db+14824|0;fb=eb;gb=cb;n=gb+0|0;p=n+40|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));hb=+h[fb>>3];ib=Ea;jb=ib+16|0;kb=jb;lb=+h[kb>>3];mb=-lb;nb=Fa;ob=nb+928|0;pb=ob;qb=+h[pb>>3];rb=lb*qb;sb=rb*mb;tb=hb*sb;ub=Ea;vb=ub+14808|0;wb=vb;xb=+h[wb>>3];yb=Fa;zb=yb+936|0;Ab=zb;Bb=+h[Ab>>3];Cb=lb*Bb;Db=Cb*mb;Eb=xb*Db;Fb=tb+Eb;Gb=Ga;Hb=Gb+2968|0;Ib=Hb;h[Ib>>3]=Fb;Jb=Ea;Kb=Jb+16208|0;Lb=Kb;Mb=+h[Lb>>3];Nb=+h[kb>>3];Ob=-Nb;Pb=Fa;Qb=Pb+1408|0;Rb=Qb;Sb=+h[Rb>>3];Tb=Nb*Sb;Ub=Tb*Ob;Vb=Mb*Ub;Wb=Ea;Xb=Wb+16232|0;Yb=Xb;Zb=+h[Yb>>3];_b=Fa;$b=_b+1416|0;ac=$b;bc=+h[ac>>3];cc=Nb*bc;dc=cc*Ob;ec=Zb*dc;fc=Vb+ec;gc=Ga;hc=gc+2976|0;ic=hc;h[ic>>3]=fc;jc=Ea;kc=jc+16200|0;lc=kc;mc=+h[lc>>3];nc=+h[kb>>3];oc=-nc;pc=+h[Rb>>3];qc=nc*pc;rc=qc*oc;sc=mc*rc;tc=Ea;uc=tc+16224|0;vc=uc;wc=+h[vc>>3];xc=+h[ac>>3];yc=nc*xc;zc=yc*oc;Ac=wc*zc;Bc=sc+Ac;Cc=Ga;Dc=Cc+2984|0;Ec=Dc;h[Ec>>3]=Bc;Fc=+h[Lb>>3];Gc=+h[kb>>3];Hc=-Gc;Ic=Fa;Jc=Ic+832|0;Kc=Jc;Lc=+h[Kc>>3];Mc=Gc*Lc;Nc=Mc*Hc;Oc=Fc*Nc;Pc=+h[Yb>>3];Qc=Fa;Rc=Qc+840|0;Sc=Rc;Tc=+h[Sc>>3];Uc=Gc*Tc;Vc=Uc*Hc;Wc=Pc*Vc;Xc=Oc+Wc;Yc=c[(e+36|0)>>2]|0;Zc=Yc;_c=Zc+2992|0;$c=_c;h[$c>>3]=Xc;ad=c[(d+4|0)>>2]|0;bd=c[ad>>2]|0;cd=bd;dd=cd+8|0;ed=dd;fd=c[ed>>2]|0;gd=fd;hd=gd+16200|0;id=hd;jd=+h[id>>3];kd=fd;ld=kd+16|0;md=ld;nd=+h[md>>3];od=-nd;pd=c[(d+416|0)>>2]|0;qd=pd;rd=qd+832|0;sd=rd;td=+h[sd>>3];ud=nd*td;vd=ud*od;wd=jd*vd;xd=fd;yd=xd+16224|0;zd=yd;Ad=+h[zd>>3];Bd=pd;Cd=Bd+840|0;Dd=Cd;Ed=+h[Dd>>3];Fd=nd*Ed;Gd=Fd*od;Hd=Ad*Gd;Id=wd+Hd;Jd=Yc;Kd=Jd+3e3|0;Ld=Kd;h[Ld>>3]=Id;Md=Yc;Nd=Md+3008|0;Od=Nd;h[Od>>3]=0.0;Pd=+h[md>>3];Qd=+h[zd>>3];Rd=pd;Sd=Rd+18840|0;Td=Sd;Ud=+h[Td>>3];Vd=Qd*Ud;Wd=Pd*Pd;Xd=pd;Yd=Xd+400|0;Zd=Yd;_d=+h[Zd>>3];$d=Wd*_d;ae=Vd-$d;be=pd;ce=be+19200|0;de=ce;ee=+h[de>>3];fe=ee*ae;ge=Yc;he=ge+3016|0;ie=he;h[ie>>3]=fe;je=+h[md>>3];ke=+h[id>>3];le=+h[Td>>3];me=ke*le;ne=je*je;oe=pd;pe=oe+392|0;qe=pe;re=+h[qe>>3];se=ne*re;te=me-se;ue=+h[de>>3];ve=ue*te;we=Yc;xe=we+3024|0;ye=xe;h[ye>>3]=ve;ze=fd;Ae=ze+16208|0;Be=Ae;Ce=+h[Be>>3];De=+h[md>>3];Ee=-De;Fe=pd;Ge=Fe+272|0;He=Ge;Ie=+h[He>>3];Je=De*Ie;Ke=Je*Ee;Le=Ce*Ke;Me=fd;Ne=Me+16232|0;Oe=Ne;Pe=+h[Oe>>3];Qe=pd;Re=Qe+280|0;Se=Re;Te=+h[Se>>3];Ue=De*Te;Ve=Ue*Ee;We=Pe*Ve;Xe=Le+We;Ye=Yc;Ze=Ye+3032|0;_e=Ze;h[_e>>3]=Xe;$e=+h[id>>3];af=+h[md>>3];bf=-af;cf=+h[He>>3];df=af*cf;ef=df*bf;ff=$e*ef;gf=+h[zd>>3];hf=+h[Se>>3];jf=af*hf;kf=jf*bf;lf=gf*kf;mf=ff+lf;nf=Yc;of=nf+3040|0;pf=of;h[pf>>3]=mf;qf=Yc;rf=qf+3048|0;sf=rf;h[sf>>3]=0.0;i=b;c[b+6544>>2]=5;break a}while(0);c[b+6512>>2]=n;c[b+6520>>2]=o;c[b+6536>>2]=p}



function E_b(a){a=a|0;i=i;return a|0}function F_b(a,b){a=a|0;b=b|0;var c=0;c=i;x_b(a,b);i=c;return}function G_b(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=P$b(a,b)|0;i=c;return d|0}function H_b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];R_b(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];Q_b(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];fXb(a,g);UZb(l);i=f;return}function I_b(a){a=a|0;var b=0,c=0;b=i;c=N_b(a)|0;i=b;return c|0}function J_b(a){a=a|0;var b=0;b=i;K_b(a)|0;i=b;return a|0}function K_b(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=L_b(c[d>>2]|0)|0;i=b;return a|0}function L_b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;qRb(b);if((e|0)==0){e=a;while(1){a=eTb(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=M_b(c[d>>2]|0)|0;i=b;return g|0}return 0}function M_b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;qRb(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;qRb(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function N_b(a){a=a|0;var b=0,d=0;b=i;d=O_b((c[a>>2]|0)+16|0)|0;i=b;return d|0}function O_b(a){a=a|0;var b=0,c=0;b=i;c=P_b(a)|0;i=b;return c|0}function P_b(a){a=a|0;i=i;return a|0}function Q_b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=V_b(b,h,j,e)|0;h=c[p>>2]|0;qRb(l);if((h|0)!=0){q=h;hXb(a,q);i=f;return}X_b(o,b,e);Y_b(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];W_b(m,g);Z_b(o);o=c[j>>2]|0;UYb(b,o,p,__b(m)|0);p=$_b(m)|0;Z_b(m);q=p;hXb(a,q);i=f;return}function R_b(a,b){a=a|0;b=b|0;var c=0;c=i;S_b(a,b);i=c;return}function S_b(a,b){a=a|0;b=b|0;var c=0;c=i;T_b(a,b);i=c;return}function T_b(a,b){a=a|0;b=b|0;var c=0;c=i;U_b(a,b);i=c;return}function U_b(a,b){a=a|0;b=b|0;var c=0;c=i;N3b(a,b);N3b(a+12|0,b+12|0);i=c;return}function V_b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;gXb(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];D$b(l,k);do{if(!(C$b(b,l)|0)){k=rXb(a)|0;x=F$b(b)|0;if(E$b(k,e,x)|0){break}w=E$b(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];J$b(r,h,1,0);gXb(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];D$b(t,g);do{if(!(C$b(r,t)|0)){if(E$b(k,e,F$b(r)|0)|0){break}y=I$b(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;qRb(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;G$b(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];D$b(o,j);do{if(!(C$b(n,o)|0)){j=rXb(a)|0;if(E$b(j,F$b(H$b(n)|0)|0,e)|0){break}y=I$b(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;qRb(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function W_b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];A$b(a,e);i=d;return}function X_b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=qZb(d)|0;d=sZb(n,1)|0;m$b(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];l$b(j,d,h);n$b(0,SZb((o$b(j)|0)+16|0)|0,e);a[(p$b(j)|0)+4|0]=1;q$b(m,j);Y_b(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];W_b(b,g);Z_b(m);Z_b(j);i=f;return}function Y_b(a,b){a=a|0;b=b|0;var c=0;c=i;j$b(a,b);i=c;return}function Z_b(a){a=a|0;var b=0;b=i;e$b(a);i=b;return}function __b(a){a=a|0;var b=0,d=0;b=i;d=c[(c$b(a)|0)>>2]|0;i=b;return d|0}function $_b(a){a=a|0;var b=0,d=0;b=i;d=a$b(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function a$b(a){a=a|0;var b=0,c=0;b=i;c=b$b(a)|0;i=b;return c|0}function b$b(a){a=a|0;i=i;return a|0}function c$b(a){a=a|0;var b=0,c=0;b=i;c=d$b(a)|0;i=b;return c|0}function d$b(a){a=a|0;i=i;return a|0}function e$b(a){a=a|0;var b=0;b=i;f$b(a,0);i=b;return}function f$b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=a$b(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}h$b(g$b(e)|0,f);i=d;return}function g$b(a){a=a|0;var b=0,c=0;b=i;c=i$b(a)|0;i=b;return c|0}function h$b(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;RZb(f,SZb(d+16|0)|0)}if((d|0)==0){i=e;return}jZb(c[b>>2]|0,d,1);i=e;return}function i$b(a){a=a|0;i=i;return a+4|0}function j$b(a,b){a=a|0;b=b|0;var c=0;c=i;k$b(a,b);i=c;return}function k$b(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function l$b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];u$b(a,b,f);i=e;return}function m$b(a,b){a=a|0;b=b|0;var c=0;c=i;t$b(a,b);i=c;return}function n$b(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}r$b(b,c);i=a;return}function o$b(a){a=a|0;var b=0,d=0;b=i;d=c[(c$b(a)|0)>>2]|0;i=b;return d|0}function p$b(a){a=a|0;var b=0,c=0;b=i;c=g$b(a)|0;i=b;return c|0}function q$b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;j$b(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];W_b(h,f);Y_b(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];W_b(a,e);Z_b(h);i=d;return}function r$b(a,b){a=a|0;b=b|0;var c=0;c=i;s$b(a,b);i=c;return}function s$b(a,b){a=a|0;b=b|0;var c=0;c=i;T_b(a,b);i=c;return}function t$b(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function u$b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(DZb(g)|0)>>2]|0;g=w$b(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];v$b(b,a,f);i=e;return}function v$b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];x$b(a,b,f);i=e;return}function w$b(a){a=a|0;i=i;return a|0}function x$b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(HZb(g)|0)>>2]|0;g=z$b(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];y$b(b,a,f);i=e;return}function y$b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(HZb(f)|0)>>2];f=z$b(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function z$b(a){a=a|0;i=i;return a|0}function A$b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=$_b(B$b(b)|0)|0;h=z$b(p$b(B$b(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];v$b(g,a,e);i=d;return}function B$b(a){a=a|0;i=i;return c[a>>2]|0}function C$b(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function D$b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];O$b(a,e);i=d;return}function E$b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=vVb(0,b,c)|0;i=a;return d|0}function F$b(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function G$b(a,b){a=a|0;b=b|0;var d=0;d=i;hXb(a,c[(KYb(b)|0)>>2]|0);i=d;return}function H$b(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=M$b(c[d>>2]|0)|0;i=b;return a|0}function I$b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=pXb(a)|0;qRb(e);if((h|0)==0){j=iXb(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=rXb(a)|0;a=h;while(1){h=a+16|0;if(E$b(j,d,h)|0){l=a;m=c[l>>2]|0;qRb(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(E$b(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;qRb(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function J$b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;K$b(b,d);c[a>>2]=c[b>>2];i=e;return}function K$b(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;L$b(b,c,e);i=d;return}function L$b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{H$b(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{K_b(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function M$b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;qRb(b);if((e|0)==0){e=a;while(1){a=eTb(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=N$b(c[d>>2]|0)|0;i=b;return g|0}return 0}function N$b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;qRb(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;qRb(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function O$b(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function P$b(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(C$b(a,b)|0)^1;i=c;return d|0}function Q$b(a){a=a|0;var b=0;b=i;i=i+128|0;gVb(a,b);gVb(a+12|0,b+8|0);R$b(a+24|0,b+16|0);R$b(a+36|0,b+24|0);R$b(a+48|0,b+32|0);R$b(a+60|0,b+40|0);R$b(a+72|0,b+48|0);R$b(a+84|0,b+56|0);R$b(a+96|0,b+64|0);R$b(a+108|0,b+72|0);R$b(a+120|0,b+80|0);R$b(a+132|0,b+88|0);R$b(a+144|0,b+96|0);R$b(a+156|0,b+104|0);R$b(a+168|0,b+112|0);R$b(a+180|0,b+120|0);i=b;return}function R$b(a,b){a=a|0;b=b|0;b=i;S$b(a,0);i=b;return}function S$b(a,b){a=a|0;b=b|0;b=i;i=i+8|0;T$b(a,b);i=b;return}function T$b(a,b){a=a|0;b=b|0;b=i;U$b(a,0);i=b;return}function U$b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;V$b(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;W$b(f,0,e);e=RXb(b)|0;c[(QXb(b)|0)>>2]=e;i=d;return}function V$b(a){a=a|0;var b=0;b=i;Z$b(a);i=b;return}function W$b(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;X$b(b,c,f);i=e;return}function X$b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(UTb(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;Y$b(d,b,f);i=e;return}function Y$b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(UTb(e)|0)>>2];i=d;return}function Z$b(a){a=a|0;var b=0;b=i;_$b(a);i=b;return}function _$b(a){a=a|0;var b=0;b=i;XTb(a);i=b;return}function $$b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[287732>>2]|0;if((m|0)==0){n=0}else{o=gec(12)|0;R3b(o,m);n=o}if((c[287648>>2]|0)!=0){c[58388]=1}if((n|0)==0){c[233564>>2]=1;c[233568>>2]=1;i=b;return}do{if((t4b(n,277936,0)|0)==-1){N3b(g,n);L3b(h);o=c[57962]|0;m=(o|0)<28;while(1){p=t4b(g,277944,0)|0;q=(p|0)!=-1;if(q){r4b(j,g,0,p);Y3b(h,j)|0;X3b(j);r4b(k,g,p+1|0,-1);Y3b(g,k)|0;X3b(k)}else{Y3b(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){R3b(l,c[232264+(s<<2)>>2]|0);p=a0b(h,l)|0;X3b(l);if(p){c[233560+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){XLb(1,1,277952,f);if(m){v=o}else{w=234112;x=c[58528]|0;de[x&511](1);y=s4b(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=277992;E=D;ZLb(0,E,a)}do{p=c[233432+(v<<2)>>2]|0;c[e>>2]=c[232264+(v<<2)>>2];c[e+4>>2]=p;XLb(1,0,277976,e);v=v+1|0;}while((v|0)<28);w=234112;x=c[58528]|0;de[x&511](1);y=s4b(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=277992;E=D;ZLb(0,E,a)}else if((t|0)==20){XLb(1,1,277952,d);w=234112;x=c[58528]|0;de[x&511](1);y=s4b(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=277992;E=D;ZLb(0,E,a)}else if((t|0)==23){X3b(h);X3b(g);break}}else{o=1;do{c[233560+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[233564>>2]=1;c[233568>>2]=1;if((c[233596>>2]|0)!=0){c[233656>>2]=1}if((c[233652>>2]|0)==1){c[233660>>2]=1}if((c[233632>>2]|0)!=0){c[233628>>2]=1}if((c[233640>>2]|0)!=0){c[233628>>2]=1}if((c[233592>>2]|0)!=0){c[233588>>2]=1}if((c[233636>>2]|0)!=0){c[233628>>2]=1}if((c[233584>>2]|0)!=0){c[233580>>2]=1}X3b(n);iec(n);i=b;return}function a0b(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=V3b(b)|0;if((e|0)!=(V3b(c)|0)){f=0;i=d;return f|0}g=W3b(b)|0;h=W3b(c)|0;if(O3b(b)|0){f=(xVb(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function b0b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[287740>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=gec(12)|0;l=k;R3b(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(c0b(l,c[265456+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=s4b(l)|0;XLb(1,1,278024,g);g=c[265540>>2]|0;c[f>>2]=c[265460>>2];c[f+4>>2]=g;XLb(1,0,277976,f);f=c[265544>>2]|0;c[e>>2]=c[265464>>2];c[e+4>>2]=f;XLb(1,0,277976,e);e=c[265548>>2]|0;c[d>>2]=c[265468>>2];c[d+4>>2]=e;XLb(1,0,277976,d);de[c[58528]&511](1);ZLb(0,278080,a)}else if((n|0)==6){i=b;return j|0}return 0}function c0b(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(v4b(a,b)|0)==0;i=c;return d|0}function d0b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[287724>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=gec(12)|0;l=k;R3b(l,h);if((k|0)==0){j=1;i=b;return j|0}R3b(f,278104);k=a0b(l,f)|0;X3b(f);if(k){j=1;i=b;return j|0}R3b(g,278112);k=a0b(l,g)|0;X3b(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=s4b(l)|0;XLb(1,1,278120,e);c[d>>2]=278104;c[d+4>>2]=278176;XLb(1,0,277976,d);c[a>>2]=278112;c[a+4>>2]=278192;XLb(1,0,277976,a);de[c[58528]&511](1);ZLb(0,278080,b)}return 0}function e0b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;e6b(f,a);if(!(h6b(f)|0)){f6b(f);i=d;return a|0}j=FVb(b)|0;r0b(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((uRb(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=R4b(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];u0b(h,e,b,m,k,l,n);if(!(s0b(h)|0)){f6b(f);i=d;return a|0}L4b(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);f6b(f);i=d;return a|0}function f0b(a){a=a|0;var b=0;b=i;k6b(a,S4b(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;T5b(a)|0;i=b;return a|0}function g0b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;R3b(h,d);G4b(k,278200,h);SUb(j,k,278208);X3b(k);k=s4b(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((Aec(c[n+4>>2]|0,278216)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((Aec(k,278224)|0)==0){X3b(j);X3b(h);i=f;return}d=idc(g,k,1)|0;if((d|0)!=0){m=l;Iec(m|0,0,2048)|0;vdc(d,g,m,2048)|0;i6b(e0b(e0b(e0b(e0b(e0b(300128,278232)|0,k)|0,278272)|0,m)|0,278288)|0,103)|0;X3b(j);X3b(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(wdc(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==1){r=(wdc(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==0){q=(wdc(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){l=b+4|0;p=o;o=0;while(1){d=c[l>>2]|0;if((a[d+(o*60|0)+56|0]|0)==0){m=(wdc(g,c[d+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(o*60|0)+56|0]=m;s=c[k>>2]|0}else{s=p}m=o+1|0;if((m|0)<(s|0)){p=s;o=m}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;p=b+4|0;k=(e|0)==0;l=b+20|0;m=0;do{d=c[s>>2]|0;do{if((a[d+(m*52|0)+48|0]|0)==0){n=a[d+(m*52|0)+8|0]|0;if(n<<24>>24==0){q=(wdc(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(m*52|0)+48|0]|0)!=0){break}a[(c[p>>2]|0)+((c[q+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==1){n=(wdc(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0|k){break}a[(c[l>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[o>>2]|0))}o=b+120|0;m=c[o>>2]|0;if((m|0)>0){l=b+8|0;k=m;m=0;while(1){s=c[l>>2]|0;if((a[s+(m*48|0)+44|0]|0)==0){p=(wdc(g,c[s+(m*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(m*48|0)+44|0]=p;t=c[o>>2]|0}else{t=k}p=m+1|0;if((p|0)<(t|0)){k=t;m=p}else{break}}}m=b+216|0;if((c[m>>2]|0)>0){t=b+40|0;k=b+8|0;o=(e|0)==0;l=b+24|0;p=0;do{s=c[t>>2]|0;do{if((a[s+(p*52|0)+48|0]|0)==0){d=a[s+(p*52|0)+8|0]|0;if(d<<24>>24==0){n=(wdc(g,c[s+(p*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(p*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(p*52|0)+48|0]|0)!=0){break}a[(c[k>>2]|0)+((c[n+(p*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(d<<24>>24==1){d=(wdc(g,c[s+(p*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(p*52|0)+48|0]=d;d=c[t>>2]|0;if((a[d+(p*52|0)+48|0]|0)!=0|o){break}a[(c[l>>2]|0)+((c[d+(p*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);p=p+1|0;}while((p|0)<(c[m>>2]|0))}m=b+124|0;p=c[m>>2]|0;if((p|0)>0){l=b+12|0;o=p;p=0;while(1){t=c[l>>2]|0;if((a[t+(p*52|0)+48|0]|0)==0){k=(wdc(g,c[t+(p*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(p*52|0)+48|0]=k;u=c[m>>2]|0}else{u=o}k=p+1|0;if((k|0)<(u|0)){o=u;p=k}else{break}}}p=b+220|0;if((c[p>>2]|0)>0){u=b+44|0;o=b+12|0;m=(e|0)==0;e=b+28|0;b=0;do{l=c[u>>2]|0;do{if((a[l+(b*52|0)+48|0]|0)==0){k=a[l+(b*52|0)+8|0]|0;if(k<<24>>24==0){t=(wdc(g,c[l+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=t;t=c[u>>2]|0;if((a[t+(b*52|0)+48|0]|0)!=0){break}a[(c[o>>2]|0)+((c[t+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(k<<24>>24==1){k=(wdc(g,c[l+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=k;k=c[u>>2]|0;if((a[k+(b*52|0)+48|0]|0)!=0|m){break}a[(c[e>>2]|0)+((c[k+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[p>>2]|0))}mdc(g);X3b(j);X3b(h);i=f;return}function h0b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[287588>>2]|0;H=c[287716>>2]|0;I=c[2]|0;if((c[233660>>2]|0)==0){if(!((c[287536>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+zb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;VLb(23,0,278336,l);l=c[287660>>2]|0;do{if((l|0)==0){M=0}else{if((Aec(l,278360)|0)==0){M=1;break}if((Aec(l,278368)|0)==0){M=0;break}if((Aec(l,278376)|0)==0){M=2;break}c[j>>2]=l;XLb(1,0,278384,j);M=0}}while(0);if((nNb(M)|0)!=0){c[g>>2]=l;XLb(1,0,278456,g)}if((c[2]|0)!=0){p1b(d+56|0);sNb((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);oNb(0);oNb(6);pNb(3);pNb(4);pNb(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+wec(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];VLb(1,0,278544,f)}do{if((c[287644>>2]|0)!=0){f=gec(12)|0;J=f;R3b(J,c[287772>>2]|0);if((f|0)==0){break}f=s4b(J)|0;c[d+280>>2]=f;c[e>>2]=f;VLb(23,0,278600,e)}}while(0);e=c[287768>>2]|0;L3b(m);if((e|0)==0){R3b(p,c[d+88>>2]|0);R3b(q,278648);i0b(o,p,q);SUb(n,o,c[d+284>>2]|0);Y3b(m,n)|0;X3b(n);X3b(o);X3b(q);X3b(p)}else{Z3b(m,e)|0}R3b(r,278656);R3b(s,278656);R3b(t,278656);R3b(u,278656);R3b(v,278656);R3b(w,278656);e=c[287536>>2]|0;if((c[287556>>2]|0)!=0){Z3b(r,c[287684>>2]|0)|0}if((c[287572>>2]|0)!=0){Z3b(s,c[287700>>2]|0)|0}if((c[287552>>2]|0)!=0){Z3b(t,c[287680>>2]|0)|0}if((c[287560>>2]|0)==0){O=0.0}else{Z3b(u,c[287688>>2]|0)|0;O=+wec(s4b(u)|0)}if((c[287564>>2]|0)==0){P=1}else{Z3b(v,c[287692>>2]|0)|0;P=Dc(s4b(v)|0)|0}if((c[287624>>2]|0)!=0){Z3b(w,c[287752>>2]|0)|0}N3b(x,m);N3b(y,r);N3b(z,s);N3b(A,t);N3b(B,w);p=j0b(d,x,y,z,A,O,P,B,e)|0;X3b(B);X3b(A);X3b(z);X3b(y);X3b(x);if((p|0)!=0|g^1){Q=p}else{oNb(5);p=G0b(d)|0;rNb(5);VLb(1,0,278664,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;X3b(w);X3b(v);X3b(u);X3b(t);X3b(s);X3b(r);X3b(m);i=b;return R|0}Q=d+88|0;R3b(D,c[Q>>2]|0);SUb(C,D,278696);X3b(D);R3b(F,c[Q>>2]|0);SUb(E,F,278712);X3b(F);rNb(0);F=c[287736>>2]|0;Q=s4b(C)|0;D=s4b(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;d1b(d,Q,D,(F|0)!=0?F:278728,I,p,s4b(m)|0)|0;X3b(E);X3b(C);R=0;X3b(w);X3b(v);X3b(u);X3b(t);X3b(s);X3b(r);X3b(m);i=b;return R|0}function i0b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;M3b(a,d);e=V3b(b)|0;f=V3b(c)|0;w4b(a,W3b(b)|0,e,f+e|0);o4b(a,W3b(c)|0,f)|0;i=d;return}function j0b(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((V3b(j)|0)==0){u=0}else{u=s4b(j)|0}N3b(r,b);b=(k0b(a,r,k)|0)==0;X3b(r);if(!b){v=-1;i=l;return v|0}R3b(s,278656);b=a+280|0;r=c0b(s,c[b>>2]|0)|0;X3b(s);do{if(r){w=3}else{s=1;k=0;do{R3b(t,c[278872+(s<<2)>>2]|0);j=c0b(t,c[b>>2]|0)|0;X3b(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];XLb(1,0,278952,q);XLb(1,0,277952,p);s=1;do{j=c[278984+(s<<2)>>2]|0;c[o>>2]=c[278872+(s<<2)>>2];c[o+4>>2]=j;XLb(1,0,277976,o);s=s+1|0;}while((s|0)<20);ZLb(c[a+536>>2]|0,278080,n)}}while(0);c[m>>2]=c[278872+(w<<2)>>2];VLb(23,0,279064,m);m=s4b(d)|0;d=s4b(e)|0;e=JPb(a,m,d,s4b(f)|0,g,h,w,u)|0;ee[c[272316>>2]&63](272288,a);v=e;i=l;return v|0}function k0b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[68072]=yd(s4b(b)|0)|0;c[272292>>2]=g;c[272296>>2]=d;d=a+284|0;do{if((c[69482]|0)==0){g=c[d>>2]|0;if((Aec(278736,g)|0)==0){h=0;break}if((Aec(278744,g)|0)==0){c[272304>>2]=49;c[272308>>2]=50;c[272316>>2]=51;h=0;break}if((Aec(278752,g)|0)==0){c[272304>>2]=52;c[272308>>2]=53;c[272312>>2]=54;c[272316>>2]=55;h=1;break}if((Aec(278760,g)|0)==0){c[272304>>2]=56;c[272308>>2]=57;c[272312>>2]=58;c[272316>>2]=59;h=1;break}if((Aec(278768,g)|0)==0){c[272304>>2]=60;c[272308>>2]=61;c[272316>>2]=62;h=0;break}g=e0b(300128,278776)|0;i6b(e0b(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);g0b(a+8|0,c[a+288>>2]|0,h);ee[c[272304>>2]&63](272288,a);a=c[68072]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;VLb(23,0,278800,f);j=0;i=e;return j|0}function l0b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;MLb();do{if((x1b(a,b)|0)==0){if((z1b(a,b)|0)!=0){break}do{if((c[287592>>2]|0)!=0){w=c[287720>>2]|0;if((Aec(w,279184)|0)==0){SLb(1);break}if((Aec(w,279192)|0)==0){SLb(0);break}else{c[p>>2]=w;XLb(1,0,279200,p);sd(0)|0;Ad(0)}}}while(0);if((c[287548>>2]|0)==0){$$b(0,0);UOb(d);if((d|0)==0){i6b(e0b(300128,279568)|0,103)|0}c[d+300>>2]=b0b(0,0)|0;c[d+292>>2]=d0b(0,0)|0;PUb(d+8|0,d+240|0);bPb(d)|0;iPb(d)|0;uPb(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}i6b(e0b(300128,279632)|0,103)|0;x=1;i=e;return x|0}}while(0);c[69482]=c[287616>>2];x=0;i=e;return x|0}R3b(u,c[287676>>2]|0);w=1;while(1){y=238072+(w<<2)|0;R3b(v,c[y>>2]|0);z=a0b(u,v)|0;X3b(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=s4b(u)|0;XLb(1,0,279472,g);c[f>>2]=c[b>>2];XLb(1,0,279512,f);sd(0)|0;Ad(0)}A=c[242096+(w<<2)>>2]|0;do{if((A|0)==1){z=c[241968+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;VLb(1,1,279272,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[241968+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;VLb(1,1,279312,n);break}else{c[m>>2]=z;XLb(1,1,279152,m);break}}}while(0);if((w|0)==29){A=1;do{z=c[278984+(A<<2)>>2]|0;c[h>>2]=c[278872+(A<<2)>>2];c[h+4>>2]=z;VLb(1,0,277976,h);A=A+1|0;}while((A|0)<20);D=234112;E=c[58528]|0;de[E&511](1);F=sd(0)|0;Ad(0)}else if((w|0)==19){A=c[57962]|0;if((A|0)<28){G=A}else{D=234112;E=c[58528]|0;de[E&511](1);F=sd(0)|0;Ad(0)}do{A=c[233432+(G<<2)>>2]|0;c[l>>2]=c[232264+(G<<2)>>2];c[l+4>>2]=A;VLb(1,0,277976,l);G=G+1|0;}while((G|0)<28);D=234112;E=c[58528]|0;de[E&511](1);F=sd(0)|0;Ad(0)}else if((w|0)==11){A=1;do{z=c[279440+(A<<2)>>2]|0;c[j>>2]=c[279408+(A<<2)>>2];c[j+4>>2]=z;VLb(1,0,277976,j);A=A+1|0;}while((A|0)<7);D=234112;E=c[58528]|0;de[E&511](1);F=sd(0)|0;Ad(0)}else if((w|0)==7){A=1;do{z=c[279392+(A<<2)>>2]|0;c[k>>2]=c[279376+(A<<2)>>2];c[k+4>>2]=z;VLb(1,0,277976,k);A=A+1|0;}while((A|0)<4);D=234112;E=c[58528]|0;de[E&511](1);F=sd(0)|0;Ad(0)}else{D=234112;E=c[58528]|0;de[E&511](1);F=sd(0)|0;Ad(0)}}}while(0);c[t>>2]=c[b>>2];VLb(1,1,279088,t);t=1;do{b=c[242096+(t<<2)>>2]|0;do{if((b|0)==1){F=c[239976+(t<<2)>>2]|0;c[s>>2]=c[238072+(t<<2)>>2];c[s+4>>2]=F;VLb(1,0,279104,s)}else{F=c[238072+(t<<2)>>2]|0;if((b|0)==2){E=c[239976+(t<<2)>>2]|0;c[r>>2]=F;c[r+4>>2]=F;c[r+8>>2]=E;VLb(1,0,279120,r);break}else{c[q>>2]=F;XLb(1,0,279152,q);break}}}while(0);t=t+1|0;}while((t|0)<31);de[c[58528]&511](1);sd(0)|0;Ad(0);return 0}function m0b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[69916]|0;rb(281248)|0;c[l>>2]=c[m+88>>2];ec(279672,l|0)|0;rb(281264)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];ec(279696,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];ec(279736,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];ec(279768,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];ec(279800,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];ec(279832,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];ec(279864,b|0)|0;rb(281288)|0;i=a;return}function n0b(a,b){a=a|0;b=+b;i=i;return}function o0b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;Dec(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=Rec(c[g>>2]|0,f)|0;if((k|0)==0){cb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=xa(41,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=Rec(c[g>>2]|0,f)|0;if((m|0)==0){cb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[69916]=d;u=0;Ga(57,10,482)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=Rec(c[k>>2]|0,f)|0;if((p|0)==0){cb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=xa(42,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=Rec(c[g>>2]|0,f)|0;if((q|0)==0){cb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=Rec(c[g>>2]|0,f)|0;if((r|0)==0){cb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=Rec(c[g>>2]|0,f)|0;if((s|0)==0){cb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=Rec(c[g>>2]|0,f)|0;if((t|0)==0){cb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=Rec(c[g>>2]|0,f)|0;if((w|0)==0){cb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(483,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=Rec(c[g>>2]|0,f)|0;if((x|0)==0){cb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=Rec(c[g>>2]|0,f)|0;if((y|0)==0){cb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=Rec(c[k>>2]|0,f)|0;if((A|0)==0){cb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function p0b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=kd(c[57846]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 2:{if((c[233572>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;cb(n|0,1)}c[f>>2]=e;a=c[r>>2]|0;pc(279936,7,1,a|0)|0;Bc(a|0,d|0,f|0)|0;Qd(10,a|0)|0;sd(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;cb(n|0,1);break};case 3:{if((c[233628>>2]|0)==0){i=b;return}c[f>>2]=e;n=c[r>>2]|0;pc(279936,7,1,n|0)|0;Bc(n|0,d|0,f|0)|0;Qd(10,n|0)|0;sd(0)|0;i=b;return};case 1:{c[f>>2]=e;e=c[r>>2]|0;pc(279936,7,1,e|0)|0;Bc(e|0,d|0,f|0)|0;Qd(10,e|0)|0;sd(0)|0;cb(c[g+80>>2]|0,1);break};case 5:case 4:{i=b;return};default:{ZLb(g,279944,b)}}}function q0b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;pc(279920,9,1,d|0)|0;Bc(d|0,b|0,e|0)|0;Qd(10,d|0)|0;sd(0)|0;i=a;return}function r0b(a,b){a=a|0;b=b|0;var c=0;c=i;t0b(a,b);i=c;return}function s0b(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function t0b(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=Q4b(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function u0b(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;qRb(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=v0b(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((a5b(b,d,r)|0)==(r|0)){break}qRb(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){S3b(l,s,h);if((a5b(b,W3b(l)|0,s)|0)==(s|0)){X3b(l);break}qRb(m);c[o>>2]=0;c[a>>2]=0;X3b(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((a5b(b,e,l)|0)==(l|0)){break}qRb(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);w0b(g,0)|0;c[a>>2]=b;i=j;return}function v0b(a){a=a|0;i=i;return c[a+12>>2]|0}function w0b(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function x0b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;y0b(g,16);z0b(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){A0b(a,g);B0b(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){e0b(j6b(m,+h[b+(p<<3)>>3])|0,281304)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){j6b(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){e0b(m,281312)|0}}while((e|0)<(d|0));A0b(a,g);B0b(g);i=f;return}function y0b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;U4b(e);f=a;c[f>>2]=281684;g=e;c[g>>2]=281704;e=a+4|0;$5b(a,281716|0,e);c[f>>2]=281684;c[g>>2]=281704;N0b(e,b|16);i=d;return}function z0b(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function A0b(a,b){a=a|0;b=b|0;var c=0;c=i;H0b(a,b+4|0);i=c;return}function B0b(a){a=a|0;var b=0;b=i;R0b(a,281712);P4b(a+56|0);i=b;return}function C0b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[233616>>2]|0)!=0){rb(282008)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];VLb(14,0,281320,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ge[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];VLb(14,0,281392,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[233616>>2]|0)==0){i=d;return 0}VLb(14,0,281440,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];ec(281456,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}bc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function D0b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[233616>>2]|0)!=0){rb(282008)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];VLb(14,0,281320,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ge[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];VLb(14,0,281392,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[233616>>2]|0)==0){i=d;return 0}VLb(14,0,281440,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];ec(281456,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}bc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function E0b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[233616>>2]|0)!=0){rb(282008)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];VLb(14,0,281320,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ge[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];VLb(14,0,281392,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[233616>>2]|0)==0){i=d;return 0}VLb(14,0,281440,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];ec(281456,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}bc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function F0b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[233616>>2]|0)!=0){rb(282008)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];VLb(14,0,281320,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ge[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];VLb(14,0,281392,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[233616>>2]|0)==0){i=d;return 0}VLb(14,0,281440,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];ec(281456,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}bc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function G0b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=cec(fa(F,F)|0,8)|0;J=I;K=cec(fa(G,F)|0,8)|0;L=K;M=cec(fa(H,F)|0,8)|0;N=M;O=cec(fa(H,G)|0,8)|0;P=O;L3b(p);L3b(q);L3b(r);L3b(s);L3b(t);L3b(u);L3b(v);Q=a+536|0;YLb(c[Q>>2]|0,(I|0)!=0|0,281464,o);YLb(c[Q>>2]|0,(K|0)!=0|0,281464,n);YLb(c[Q>>2]|0,(M|0)!=0|0,281464,m);YLb(c[Q>>2]|0,(O|0)!=0|0,281464,l);l=a+540|0;m=a;if((ge[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;C0b(a,J)|0;YLb(n,1,281480,k)}x0b(w,J,F,F);Y3b(p,w)|0;X3b(w);if((ge[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;D0b(a,L)|0;YLb(w,1,281512,j)}x0b(x,L,F,G);Y3b(q,x)|0;X3b(x);if((ge[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;E0b(a,N)|0;YLb(x,1,281544,h)}x0b(y,N,H,F);Y3b(r,y)|0;X3b(y);if((ge[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;F0b(a,P)|0;YLb(m,1,281576,g)}x0b(z,P,H,G);Y3b(s,z)|0;X3b(z);if((F|0)==0){Z3b(t,281608)|0}else{x0b(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);Y3b(t,A)|0;X3b(A)}if((G|0)==0){Z3b(u,281608)|0}else{x0b(B,c[a+432>>2]|0,1,G);Y3b(u,B)|0;X3b(B)}bec(I);bec(K);bec(M);bec(O);R3b(E,c[a+84>>2]|0);G4b(D,281624,E);SUb(C,D,281632);Y3b(v,C)|0;X3b(C);X3b(D);X3b(E);E=gc(s4b(v)|0,281640)|0;D=c[Q>>2]|0;c[f>>2]=s4b(v)|0;YLb(D,(E|0)!=0|0,281648,f);f=ye[c[(c[l>>2]|0)+176>>2]&7]()|0;D=s4b(t)|0;Q=s4b(u)|0;C=s4b(p)|0;a=s4b(q)|0;O=s4b(r)|0;M=s4b(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;ud(E|0,f|0,e|0)|0;if((c[233660>>2]|0)==0){R=sd(E|0)|0;S=Wc(E|0)|0;X3b(v);X3b(u);X3b(t);X3b(s);X3b(r);X3b(q);X3b(p);i=b;return 0}e=ye[c[(c[l>>2]|0)+176>>2]&7]()|0;l=s4b(t)|0;f=s4b(u)|0;M=s4b(p)|0;O=s4b(q)|0;a=s4b(r)|0;C=s4b(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;VLb(25,0,e,d);R=sd(E|0)|0;S=Wc(E|0)|0;X3b(v);X3b(u);X3b(t);X3b(s);X3b(r);X3b(q);X3b(p);i=b;return 0}function H0b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=i5b(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}I0b(a,h5b(l)|0,n,e);i=d;return}if((h&8|0)==0){M3b(a,g);i=d;return}else{g=b;b=c5b(g)|0;I0b(a,b,e5b(g)|0,f);i=d;return}}function I0b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;J0b(a,b,c,0);i=d;return}function J0b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;K0b(a,b,c);i=d;return}function K0b(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=L0b(c,d)|0;if(g>>>0>4294967279){J3b(0)}if(g>>>0<11){b4b(b,g);h=a4b(b)|0}else{j=i4b(g)|0;k=j+1|0;j=CVb(Q3b(b)|0,k)|0;k4b(b,j);j4b(b,k);$3b(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;DVb(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){DVb(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;DVb(l,f);i=e;return}function L0b(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=M0b(b,c,e)|0;i=d;return g|0}function M0b(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function N0b(a,b){a=a|0;b=b|0;var c=0;c=i;b1b(a,b);i=c;return}function O0b(a){a=a|0;var b=0;b=i;B0b(a);iec(a);i=b;return}function P0b(a){a=a|0;var b=0;b=i;B0b(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Q0b(a){a=a|0;var b=0;b=i;O0b(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function R0b(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];S0b(a+4|0);i=d;return}function S0b(a){a=a|0;var b=0;b=i;T0b(a);i=b;return}function T0b(a){a=a|0;var b=0;b=i;c[a>>2]=281864;X3b(a+32|0);Y4b(a);i=b;return}function U0b(a){a=a|0;var b=0;b=i;S0b(a);iec(a);i=b;return}function V0b(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=i5b(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==24){if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}EQb(a,-1,-1);i=h;return}else if((k|0)==0){EQb(a,-1,-1);i=h;return}else{if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}if((g&8|0)==0){m=i5b(l)|0;j=m-(h5b(l)|0)|0;o=j;p=((j|0)<0)<<31>>31;break}else{j=d5b(l)|0;m=j-(c5b(l)|0)|0;o=m;p=((m|0)<0)<<31>>31;break}}}while(0);if((q|0)==11){f=n-(W3b(b+32|0)|0)|0;o=f;p=((f|0)<0)<<31>>31}else if((q|0)==12){EQb(a,-1,-1);i=h;return}q=Oec(o|0,p|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&q>>>0<0)){d=n-(W3b(b+32|0)|0)|0;p=((d|0)<0)<<31>>31;if((p|0)<(e|0)|(p|0)==(e|0)&d>>>0<q>>>0){break}d=g&8;do{if(!((q|0)==0&(e|0)==0)){do{if((d|0)!=0){if((d5b(l)|0)!=0){break}EQb(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((i5b(l)|0)!=0){break}EQb(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){p=c5b(l)|0;g5b(l,p,p+q|0,n)}if((g&16|0)!=0){p=h5b(l)|0;l5b(l,p,j5b(l)|0);k5b(l,q)}EQb(a,q,e);i=h;return}}while(0);EQb(a,-1,-1);i=h;return}function W0b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=SRb(d)|0;oe[g&31](a,b,h,J,0,e);i=f;return}function X0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=i5b(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((e5b(g)|0)>>>0<j>>>0){b=c5b(g)|0;g5b(g,b,d5b(g)|0,j)}j=d5b(g)|0;if(!(j>>>0<(e5b(g)|0)>>>0)){k=-1;i=d;return k|0}k=oSb(a[j]|0)|0;i=d;return k|0}function Y0b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=i5b(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=c5b(h)|0;j=d5b(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(kSb(d,-1)|0){g5b(h,g,j+ -1|0,k);l=nSb(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=lSb(d)|0;do{if(g){if(pSb(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=c5b(h)|0;g5b(h,j,(d5b(h)|0)+ -1|0,k);a[d5b(h)|0]=b;l=d;i=e;return l|0}function Z0b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(kSb(b,-1)|0){f=nSb(b)|0;i=d;return f|0}g=a;h=d5b(g)|0;j=h-(c5b(g)|0)|0;h=i5b(g)|0;do{if((h|0)==(j5b(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=h5b(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;n4b(o,0);g4b(o,d4b(o)|0);p=W3b(o)|0;l5b(g,p,p+(V3b(o)|0)|0);k5b(g,h-l|0);c[m>>2]=(h5b(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(i5b(g)|0)+1;h=c[(_0b(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=W3b(a+32|0)|0;g5b(g,q,q+j|0,h)}f=$4b(g,b&255)|0;i=d;return f|0}function _0b(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=$0b(b,c,e)|0;i=d;return g|0}function $0b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=a1b(0,a,b)|0;i=c;return(d?b:a)|0}function a1b(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function b1b(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;b5b(a);c[a>>2]=281864;L3b(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;L3b(e);c1b(a,e);X3b(e);i=d;return}function c1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;Y3b(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=W3b(e)|0;j=g+(V3b(e)|0)|0;c[b>>2]=j;g=W3b(e)|0;g5b(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=V3b(e)|0;c[b>>2]=(W3b(e)|0)+h;g4b(e,d4b(e)|0);b=a;a=W3b(e)|0;l5b(b,a,a+(V3b(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}k5b(b,h);i=d;return}function d1b(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=gc(d|0,282288)|0;J=$c(282296,282288)|0;K=(J|0)!=0;L=Lc()|0;if(K){M=c[b+536>>2]|0;N=Ud(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;YLb(M,(I|0)!=0|0,282352,E);pc(282376,17,1,J|0)|0;pc(282400,10,1,J|0)|0;pc(282416,18,1,J|0)|0;e1b(J,f,282440,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,282472)}else{c[G>>2]=Ud(c[L>>2]|0)|0;XLb(26,0,282304,G);G=c[b+536>>2]|0;E=Ud(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;YLb(G,(I|0)!=0|0,282352,F)}pc(282480,348,1,I|0)|0;if((qc(H|0)|0)<0){c[D>>2]=Ud(c[L>>2]|0)|0;XLb(26,0,282832,D);Wc(I|0)|0;_a(J|0)|0;O=1;i=j;return O|0}if((Qc(282032,250,282856,id(H|0)|0)|0)==0){XLb(26,0,282880,C);Wc(I|0)|0;O=1;i=j;return O|0}pc(282904,13,1,I|0)|0;pc(282920,12,1,I|0)|0;f1b(I,2);pc(282936,6,1,I|0)|0;g1b(I,c[b+84>>2]|0);pc(282944,8,1,I|0)|0;f1b(I,2);pc(282960,8,1,I|0)|0;C=b+88|0;g1b(I,c[C>>2]|0);pc(282976,10,1,I|0)|0;f1b(I,2);pc(282992,6,1,I|0)|0;g1b(I,282032);pc(283e3,8,1,I|0)|0;f1b(I,2);pc(283016,8,1,I|0)|0;g1b(I,c[b+280>>2]|0);pc(283032,10,1,I|0)|0;f1b(I,2);pc(283048,14,1,I|0)|0;g1b(I,c[b+284>>2]|0);pc(283064,16,1,I|0)|0;f1b(I,2);pc(283088,16,1,I|0)|0;g1b(I,l);pc(283112,18,1,I|0)|0;f1b(I,2);c[B>>2]=h1b(l)|0;ud(I|0,283136,B|0)|0;f1b(I,2);P=+jNb(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];ud(I|0,283176,A|0)|0;f1b(I,2);P=+jNb(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];ud(I|0,283216,z|0)|0;f1b(I,2);P=+jNb(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];ud(I|0,283248,y|0)|0;f1b(I,2);P=+jNb(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];ud(I|0,283280,x|0)|0;f1b(I,2);P=+jNb(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];ud(I|0,283312,w|0)|0;f1b(I,2);P=+jNb(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];ud(I|0,283344,v|0)|0;f1b(I,2);P=+jNb(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];ud(I|0,283384,u|0)|0;f1b(I,2);P=+mNb(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];ud(I|0,283416,t|0)|0;f1b(I,2);c[s>>2]=hNb(2)|0;ud(I|0,283456,s|0)|0;f1b(I,2);P=+lNb(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];ud(I|0,283480,r|0)|0;pc(283512,13,1,I|0)|0;pc(283528,16,1,I|0)|0;f1b(I,2);P=+jNb(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];ud(I|0,283552,q|0)|0;f1b(I,2);c[p>>2]=eNb(8)|0;ud(I|0,283576,p|0)|0;pc(283616,17,1,I|0)|0;pc(283640,22,1,I|0)|0;i1b(I,b);pc(283664,23,1,I|0)|0;pc(283688,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{j1b(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{j1b(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{j1b(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{j1b(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{j1b(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{j1b(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{j1b(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{j1b(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}pc(283704,13,1,I|0)|0;pc(283720,12,1,I|0)|0;k1b(I,J,f,c[C>>2]|0,b);pc(283736,13,1,I|0)|0;pc(283752,12,1,I|0)|0;l1b(I,c[b+68>>2]|0,b+56|0);pc(283768,13,1,I|0)|0;pc(283784,16,1,I|0)|0;m1b(I,J,f,b);pc(283808,17,1,I|0)|0;pc(283832,14,1,I|0)|0;Wc(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((Eec(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(Eec(K|0)|0)<<1}else{Q=0}I=aec(b+Q|0)|0;if((I|0)==0){ab(283848,283856,404,283880)}if((_a(J|0)|0)!=0){XLb(26,0,283896,o)}if(e){e=c[C>>2]|0;c[n>>2]=283928;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;fc(I|0,283944,n|0)|0;if((pd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=284024|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;XLb(1,0,284056,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;VLb(1,0,284120,g);bec(I);O=0;i=j;return O|0}function e1b(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=fNb(F)|0;H=gNb(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+lNb(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}pc(282376,17,1,a|0)|0;pc(285288,12,1,a|0)|0;pc(285304,12,1,a|0)|0;pc(285320,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;ud(a|0,285336,D|0)|0;pc(285376,10,1,a|0)|0;pc(285392,11,1,a|0)|0;pc(285408,11,1,a|0)|0;pc(285424,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];ud(a|0,285440,C|0)|0}else{pc(285464,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;ud(a|0,285064,B|0)|0;pc(285488,13,1,a|0)|0;if(E){pc(285304,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];ud(a|0,285504,A|0)|0}else{pc(285464,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;ud(a|0,285528,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;ud(a|0,285184,y|0)|0;pc(285576,10,1,a|0)|0;pc(285592,10,1,a|0)|0;pc(285576,10,1,a|0)|0;pc(285608,11,1,a|0)|0;c[x>>2]=b;ud(a|0,285624,x|0)|0;c[w>>2]=d;ud(a|0,285648,w|0)|0;pc(285664,33,1,a|0)|0;pc(285704,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;ud(a|0,285744,v|0)|0;pc(285424,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];ud(a|0,285440,u|0)|0}else{pc(285592,10,1,a|0)|0;pc(285576,10,1,a|0)|0;pc(285608,11,1,a|0)|0;c[t>>2]=b;ud(a|0,285624,t|0)|0;c[s>>2]=d;ud(a|0,285648,s|0)|0;pc(285664,33,1,a|0)|0;pc(285704,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;ud(a|0,285744,r|0)|0;pc(285424,10,1,a|0)|0;pc(285464,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;ud(a|0,285064,q|0)|0;pc(285488,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];ud(a|0,285504,p|0)|0}else{pc(285464,17,1,a|0)|0}pc(285776,32,1,a|0)|0;pc(285816,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;ud(a|0,285848,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;ud(a|0,285184,n|0)|0;i=m;return}function f1b(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Qd(32,a|0)|0;}while((d|0)!=0);i=c;return}function g1b(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==62){pc(285040,4,1,b|0)|0}else if((e|0)==39){pc(285048,6,1,b|0)|0}else if((e|0)==60){pc(285032,4,1,b|0)|0}else if((e|0)==34){pc(285056,6,1,b|0)|0}else{Qd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function h1b(a){a=a|0;var b=0,c=0,d=0;b=i;c=gc(a|0,285024)|0;if((c|0)==0){d=-1;i=b;return d|0}Uc(c|0,0,2)|0;a=wb(c|0)|0;Wc(c|0)|0;d=a;i=b;return d|0}function i1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=aec((Eec(l|0)|0)+15|0)|0;c[f>>2]=l;fc(m|0,284752,f|0)|0;f1b(a,2);pc(284768,10,1,a|0)|0;g1b(a,m);pc(284784,12,1,a|0)|0;f1b(a,2);c[e>>2]=h1b(m)|0;ud(a|0,284800,e|0)|0;bec(m);f1b(a,2);pc(284832,9,1,a|0)|0;f1b(a,4);pc(284848,22,1,a|0)|0;f1b(a,4);pc(284872,22,1,a|0)|0;f1b(a,4);pc(284896,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){o1b(g,m,n);o=c[l>>2]|0;f1b(a,4);pc(284928,8,1,a|0)|0;g1b(a,o);pc(284944,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{t1b(h,m,l);g=c[n>>2]|0;f1b(a,4);pc(284928,8,1,a|0)|0;g1b(a,g);pc(284944,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{o1b(j,m,q);b=c[t>>2]|0;f1b(a,4);pc(284968,8,1,a|0)|0;g1b(a,b);pc(284984,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){f1b(a,2);v=285008;w=v;x=pc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{t1b(k,m,s);e=c[u>>2]|0;f1b(a,4);pc(284968,8,1,a|0)|0;g1b(a,e);pc(284984,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));f1b(a,2);v=285008;w=v;x=pc(w|0,10,1,a|0)|0;i=d;return}function j1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;f1b(a,2);c[f>>2]=c[b>>2];ud(a|0,284688,f|0)|0;g1b(a,c[b+4>>2]|0);pc(284720,11,1,a|0)|0;g1b(a,c[b+8>>2]|0);pc(284392,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];n1b(a,4,e);f1b(a,2);pc(284736,12,1,a|0)|0;i=d;return}function k1b(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{o1b(p,r,v);e1b(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,284504);w=v+9|0;pNb(w);f1b(a,2);c[o>>2]=c[f>>2];ud(a|0,284512,o|0)|0;f1b(a,4);pc(282936,6,1,a|0)|0;g1b(a,c[s>>2]|0);pc(282944,8,1,a|0)|0;f1b(a,4);c[n>>2]=hNb(w)|0;ud(a|0,284288,n|0)|0;f1b(a,4);x=+mNb(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];ud(a|0,284312,m|0)|0;f1b(a,4);x=+lNb(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];ud(a|0,283480,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];n1b(a,6,j);f1b(a,2);pc(284536,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function l1b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{f1b(a,2);s1b(l,d,x);c[j>>2]=c[q>>2];ud(a|0,284360,j|0)|0;s1b(m,d,x);g1b(a,c[r>>2]|0);pc(284392,3,1,a|0)|0;f1b(a,4);pc(284400,7,1,a|0)|0;s1b(n,d,x);if((c[s>>2]|0)>0){y=0;do{f1b(a,6);c[g>>2]=0;ud(a|0,284408,g|0)|0;y=y+1|0;s1b(n,d,x);}while((y|0)<(c[s>>2]|0))}f1b(a,4);pc(284432,8,1,a|0)|0;f1b(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;s1b(o,d,x);z=+jNb(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;s1b(p,d,x);A=eNb(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;ud(a|0,284448,f|0)|0;f1b(a,2);pc(284488,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function m1b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{t1b(n,o,v-u|0);e1b(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,284240);q=v+9|0;pNb(q);f1b(a,2);pc(284248,15,1,a|0)|0;f1b(a,4);c[m>>2]=c[e>>2];ud(a|0,284264,m|0)|0;f1b(a,4);c[l>>2]=hNb(q)|0;ud(a|0,284288,l|0)|0;f1b(a,4);w=+mNb(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];ud(a|0,284312,j|0)|0;f1b(a,4);w=+lNb(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];ud(a|0,283480,g|0)|0;f1b(a,2);pc(284336,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function n1b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;f1b(a,b);pc(284552,16,1,a|0)|0;g1b(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?284656:284672;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;ud(a|0,284576,f|0)|0;i=e;return}function o1b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){p1b(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function p1b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=gc(c[o>>2]|0,285888)|0;if((p|0)!=0){q=p;break}p=Ud(c[(Lc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;ZLb(0,285896,g)}else{q=0}}while(0);g=OGb(0)|0;if((g|0)==0){ZLb(0,285928,f)}f=a+8|0;c[a+20>>2]=cec(c[f>>2]|0,32)|0;p=a+12|0;o=cec((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=285960;c[o+12>>2]=0;c[o+16>>2]=0;ZGb(g,h);_Gb(g,9,63);h=c[n>>2]|0;do{if((h|0)==0){o=j;Iec(o|0,0,1024)|0;while(1){r=qb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if(($Gb(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=hHb(eHb(g)|0)|0;s=fHb(g)|0;Wc(q|0)|0;VGb(g);r=c[a>>2]|0;c[e>>2]=286064;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;ZLb(0,286e3,e)}else if((t|0)==11){Wc(q|0)|0;break}}else{if(($Gb(g,h,Eec(h|0)|0,1)|0)!=0){break}s=hHb(eHb(g)|0)|0;o=fHb(g)|0;VGb(g);r=c[n>>2]|0;c[d>>2]=286064;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;ZLb(0,286104,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){ab(286168,286064,295,286208)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{ab(286232,286064,297,286208)}}function q1b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((Aec(286640,b)|0)==0){if((Aec(c[d>>2]|0,286648)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}YLb(0,p,286656,l);l=c[71624]|0;p=c[71678]|0;do{if((l|0)==0|(p|0)==0){c[71678]=32;a=aec(1152)|0;c[71624]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[71678]=p<<1;a=dec(l,p*72|0)|0;c[71624]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(w1b(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((Aec(286720,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((Aec(286728,u)|0)==0){c[71684]=yd(c[t+4>>2]|0)|0}else{if((Aec(286760,u)|0)==0){c[286740>>2]=Tb(c[t+4>>2]|0,0,10)|0;break}if((Aec(286776,u)|0)==0){c[286748>>2]=Tb(c[t+4>>2]|0,0,10)|0;break}if((Aec(286784,u)|0)==0){c[286744>>2]=Tb(c[t+4>>2]|0,0,10)|0;break}if((Aec(286800,u)|0)==0){c[286752>>2]=Tb(c[t+4>>2]|0,0,10)|0;break}if((Aec(286808,u)|0)!=0){v=23;break a}c[286756>>2]=(Aec(c[t+4>>2]|0,286824)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];ZLb(0,286832,k)}else if((v|0)==45){i=e;return}}if((Aec(286480,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=286064;c[j+4>>2]=k;c[j+8>>2]=v;ZLb(0,286864,j)}if((Aec(286928,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=286064;c[h+4>>2]=j;ZLb(0,286936,h)}h=Tb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=286064;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;ZLb(0,286992,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=287056;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((Aec(286424,b)|0)!=0){if((Aec(286616,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=287160;m=yd(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=287168;i=e;return}c[286444>>2]=0;c[286448>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((Aec(m,286648)|0)==0){c[286444>>2]=yd(c[b+4>>2]|0)|0}else{if((Aec(m,287112)|0)!=0){break}c[286448>>2]=yd(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[286444>>2]|0)==0){w=0;break}w=(c[286448>>2]|0)!=0|0}}while(0);YLb(0,w,287120,f);c[71610]=-1;f=286452|0;w=286736;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function r1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((Aec(286424,b)|0)==0){o=e+0|0;p=286440|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));v1b(e);i=d;return}if((Aec(286480,b)|0)==0){e=h+24|0;r=aec((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=aec(36)|0;t=s;o=s+0|0;p=(c[71624]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((Aec(286504,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;zd(e+(k*20|0)+8|0,286512,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((Aec(286552,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;zd(h+(k*20|0)+8|0,286568,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((Aec(286616,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function s1b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){p1b(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function t1b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){p1b(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;ZLb(0,286272,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=5;n=m;o=286352;p=o;ZLb(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=5;n=m;o=286352;p=o;ZLb(0,p,f)}}function u1b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){bec(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){bec(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}bec(k);c[d>>2]=0;i=b;return}function v1b(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=aec(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=Eec(f|0)|0;c[e+64>>2]=k;k=c[71658]|0;do{if((k|0)==0){c[71658]=e;c[e+44>>2]=0;l=aec(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){tc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=aec(384)|0;c[l>>2]=n;if((n|0)==0){tc(-1)}else{Iec(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[71658]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[71658]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=Eec(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(Eec(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 6:{B=o;C=y;D=17;break};case 9:{E=o;D=14;break};case 3:{F=o;G=x;H=y;D=20;break};case 8:{I=o;D=15;break};case 4:{J=o;K=y;D=19;break};case 2:{L=o;M=x;N=y;D=21;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;O=z;D=13;break};case 7:{P=o;Q=y;D=16;break};case 5:{R=o;S=y;D=18;break};case 10:{O=o;D=13;break};case 1:{T=o;U=x;V=y;D=22;break};default:{W=o;X=x;Y=y}}if((D|0)==13){o=((d[A+9|0]|0)<<16)+O|0;c[p>>2]=o;E=o;D=14}if((D|0)==14){o=((d[A+8|0]|0)<<8)+E|0;c[p>>2]=o;I=o;D=15}if((D|0)==15){P=I;Q=((d[A+7|0]|0)<<24)+y|0;D=16}if((D|0)==16){B=P;C=((d[A+6|0]|0)<<16)+Q|0;D=17}if((D|0)==17){R=B;S=((d[A+5|0]|0)<<8)+C|0;D=18}if((D|0)==18){J=R;K=(d[A+4|0]|0)+S|0;D=19}if((D|0)==19){F=J;G=((d[A+3|0]|0)<<24)+x|0;H=K;D=20}if((D|0)==20){L=F;M=((d[A+2|0]|0)<<16)+G|0;N=H;D=21}if((D|0)==21){T=L;U=((d[A+1|0]|0)<<8)+M|0;V=N;D=22}if((D|0)==22){W=T;X=(d[A]|0)+U|0;Y=V}V=X-Y-W^W>>>13;X=Y-W-V^V<<8;Y=W-V-X^X>>>13;W=V-X-Y^Y>>>12;V=X-Y-W^W<<16;X=Y-W-V^V>>>5;Y=W-V-X^X>>>3;W=V-X-Y^Y<<10;V=X-Y-W^W>>>15;c[p>>2]=V;p=(c[71658]|0)+40|0;W=c[p>>2]|0;Y=V&(c[W+4>>2]|0)+ -1;V=c[W>>2]|0;W=V+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[V+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[71658]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[71658]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=aec((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){tc(-1)}Iec(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;V=c[j>>2]|0;c[Y+24>>2]=(((V<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((V|0)==0){_=e}else{V=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=V}else{W=V;X=j;while(1){j=X+16|0;U=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];T=Z+(A*12|0)+4|0;D=(c[T>>2]|0)+1|0;c[T>>2]=D;N=c[W+24>>2]|0;if(D>>>0>N>>>0){D=W+28|0;c[D>>2]=(c[D>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[T>>2]|0)>>>0)/(N>>>0)|0}c[X+12>>2]=0;N=Z+(A*12|0)|0;c[j>>2]=c[N>>2];j=c[N>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[N>>2]=X;N=c[h>>2]|0;if((U|0)==0){$=N;break}else{W=N;X=U}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){V=$;Y=W;e=X}else{_=W;break}}}bec(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function w1b(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[71658]|0)==0){f=24}else{g=Eec(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(Eec(a|0)|0)+s|0;switch(v|0){case 11:{x=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 5:{y=h;z=u;f=11;break};case 1:{A=h;B=t;C=u;f=15;break};case 3:{D=h;E=t;F=u;f=13;break};case 6:{G=h;H=u;f=10;break};case 8:{I=h;f=8;break};case 9:{J=h;f=7;break};case 4:{K=h;L=u;f=12;break};case 7:{M=h;N=u;f=9;break};case 2:{O=h;P=t;Q=u;f=14;break};case 10:{x=h;f=6;break};default:{R=h;S=t;T=u}}if((f|0)==6){J=((d[w+9|0]|0)<<16)+x|0;f=7}if((f|0)==7){I=((d[w+8|0]|0)<<8)+J|0;f=8}if((f|0)==8){M=I;N=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){G=M;H=((d[w+6|0]|0)<<16)+N|0;f=10}if((f|0)==10){y=G;z=((d[w+5|0]|0)<<8)+H|0;f=11}if((f|0)==11){K=y;L=(d[w+4|0]|0)+z|0;f=12}if((f|0)==12){D=K;E=((d[w+3|0]|0)<<24)+t|0;F=L;f=13}if((f|0)==13){O=D;P=((d[w+2|0]|0)<<16)+E|0;Q=F;f=14}if((f|0)==14){A=O;B=((d[w+1|0]|0)<<8)+P|0;C=Q;f=15}if((f|0)==15){R=A;S=(d[w]|0)+B|0;T=C}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[71658]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=Eec(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((zec(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Cb(a|0,287192)|0)==0){V=0;break}else{W=287216}i=b;return W|0}}while(0);c[e>>2]=a;YLb(0,(V|0)!=0|0,287264,e);W=V+4|0;i=b;return W|0}function x1b(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((y1b(287320,a,b)|0)!=0){d=1;i=c;return d|0}d=(y1b(287328,a,b)|0)!=0|0;i=c;return d|0}function y1b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((Aec(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function z1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(Aec(c[238196>>2]|0,287336)|0)==0|0;YLb(0,m,287352,l);l=(Aec(c[240100>>2]|0,287336)|0)==0|0;YLb(0,l,287408,k);k=(Aec(c[242092>>2]|0,287336)|0)==0|0;YLb(0,k,287464,j);j=287528|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=287656|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[242096+(k<<2)>>2]|0;if((l|0)==1){if((y1b(c[238072+(k<<2)>>2]|0,1,p)|0)!=0){q=5;break}}else if((l|0)==2){r=c[238072+(k<<2)>>2]|0;if(!((y1b(r,1,p)|0)==0|(j|0)>=(a|0))){q=9;break}s=c[238072+(k<<2)>>2]|0;if((B1b(s,p)|0)!=0){q=13;break}}l=k+1|0;if((l|0)<31){k=l}else{q=17;break a}}if((q|0)==5){q=0;l=287528+(k<<2)|0;if((c[l>>2]|0)!=0){q=6;break}c[l>>2]=1;t=n}else if((q|0)==9){q=0;l=287528+(k<<2)|0;if((c[l>>2]|0)!=0){q=10;break}c[l>>2]=1;c[287656+(k<<2)>>2]=A1b(r,p)|0;t=j}else if((q|0)==13){q=0;l=287528+(k<<2)|0;if((c[l>>2]|0)!=0){q=14;break}c[l>>2]=1;c[287656+(k<<2)>>2]=C1b(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;q=19;break}}if((q|0)==6){c[h>>2]=c[p>>2];XLb(1,0,287784,h);o=1;i=d;return o|0}else if((q|0)==10){c[g>>2]=c[p>>2];XLb(1,0,287784,g);o=1;i=d;return o|0}else if((q|0)==14){c[f>>2]=c[p>>2];XLb(1,0,287784,f);o=1;i=d;return o|0}else if((q|0)==17){c[e>>2]=c[p>>2];XLb(1,0,287840,e);o=1;i=d;return o|0}else if((q|0)==19){i=d;return o|0}return 0}function A1b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((Aec(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function B1b(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(C1b(a,b)|0)!=0|0;i=c;return d|0}function C1b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=Eec(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((Bec(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function D1b(){i=i;return}function E1b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){tc(0)}e=c[r>>2]|0;pc(287872,5,1,e|0)|0;f=b;b=0;while(1){Qd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}pc(287880,20,1,e|0)|0;tc(0);return 0}function F1b(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;ud(d|0,287904,e|0)|0;if((b|0)==0){tc(1)}else{sd(d|0)|0;N1b();sd(d|0)|0;gb(6,0)|0;fd()}}function G1b(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function H1b(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function I1b(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function J1b(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function K1b(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function L1b(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}Iec(p|0,32,b+(d-p)|0)|0;i=f;return}function M1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=288944+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[288988+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[288984+(e*48|0)>>2]|0)==1){O1b(b)|0}k=288948+(e*48|0)|0;if((c[k>>2]|0)==0){break}Wc(c[f>>2]|0)|0;bec(c[k>>2]|0)}}while(0);do{if((h|0)==10){Wc(g|0)|0;b=288948+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Hd(k|0)|0;bec(c[b>>2]|0)}}while(0);c[f>>2]=0}c[288980+(e*48|0)>>2]=0;c[288948+(e*48|0)>>2]=0;i=d;return 0}function N1b(){var a=0,b=0;a=i;if((c[71978]|0)!=0){i=a;return}c[71978]=1;c[287920>>2]=0;b=0;do{c[287916>>2]=b;M1b(287912)|0;b=b+1|0;}while((b|0)<100);i=a;return}function O1b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[288960+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=288944+(d*48|0)|0;g=c[f>>2]|0;h=wb(g|0)|0;Uc(g|0,0,2)|0;if((h|0)>=(wb(g|0)|0)){e=0;i=b;return e|0}if((c[288964+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[288972+(d*48|0)>>2]&2|0)!=0){sd(c[f>>2]|0)|0}d=Rc(pb(c[f>>2]|0)|0,h|0)|0;Uc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){Q1b(111,287928);e=111;i=b;return e|0}else{c[(Lc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function P1b(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if((Za(pb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else if((f|0)==8192){e=(sb(pb(a|0)|0)|0)==0|0;break}else if((f|0)==24576){e=1;break}else{e=0;break}}}while(0);i=b;return e|0}function Q1b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Oc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;ud(m|0,288840,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;ud(m|0,288872,j|0)|0;l=m;break}else{n=c[288712+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;ud(m|0,288896,h|0)|0;l=m;break}}}while(0);h=c[72226]|0;do{if((h|0)==0){pc(293776,29,1,l|0)|0}else{c[g>>2]=(h-288944|0)/48|0;ud(l|0,288912,g|0)|0;b=c[(c[72226]|0)+4>>2]|0;if((b|0)==0){pc(293760,10,1,l|0)|0;break}else{c[f>>2]=b;ud(l|0,293744,f|0)|0;break}}}while(0);f=c[73452]|0;if((f|0)!=0){c[d>>2]=f;ud(l|0,293816,d|0)|0}d=(c[73472]|0)!=0?293896:293912;f=(c[73480]|0)!=0?293928:293944;g=(c[73490]|0)!=0?293968:293984;c[e>>2]=(c[73466]|0)!=0?293872:293880;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;ud(l|0,293840,e|0)|0;F1b(294e3,1)}function R1b(){var a=0,b=0;a=i;c[73502]=1;b=c[r>>2]|0;c[72236]=b;c[288964>>2]=P1b(b)|0;c[288968>>2]=1;c[288984>>2]=1;b=c[s>>2]|0;c[289184>>2]=b;c[289204>>2]=P1b(b)|0;c[289208>>2]=1;c[289224>>2]=0;b=c[t>>2]|0;c[289232>>2]=b;c[289252>>2]=P1b(b)|0;c[289256>>2]=1;c[289272>>2]=1;i=a;return}function S1b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=vc(g|0,c[299256+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[73504]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=wb(c[k>>2]|0)|0;l=vc(c[f>>2]|0,c[299256+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[73504]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Uc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Lc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Uc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function T1b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){Q1b(b,d)}d=c[73506]|0;if((d|0)!=0){ye[d&7]()|0}c[(Lc()|0)>>2]=b;i=e;return b|0}function U1b(a){a=a|0;var b=0,d=0;b=i;c[73536]=0;c[73538]=0;c[73540]=0;d=((V1b(a,0)|0)==0)<<31>>31;i=b;return d|0}function V1b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==32){f=g}else if(b<<24>>24==40){break}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[73540]|0;c[73540]=j+1;if((j|0)==1){c[73538]=d}if((_1b(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=$1b(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function W1b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[73536]|0;l=294168+(k<<4)|0;m=c[l>>2]|0;switch(X1b(m)|0){case 1:{n=c[294172+(k<<4)>>2]|0;o=(c[74768]|0)+1|0;c[74768]=o;c[299080+(o<<2)>>2]=n;c[73536]=k+1;continue b;break};case 16:{if(b){p=28;break a}c[73536]=k+1;continue b;break};case 8:{n=c[74752]|0;q=299016+(n<<2)|0;s=c[q>>2]|0;if((s|0)>=1){p=10;break b}c[74752]=n+ -1;c[73536]=k+1;continue b;break};case 19:case 17:{c[73512]=0;c[73536]=k+1;continue b;break};case 2:{c[74752]=0;c[74768]=0;c[73536]=c[294172+(k<<4)>>2];if(b){p=24;break a}if((c[74764]|0)==0){j=0;p=37;break a}n=ye[c[73522]&7]()|0;if((n|0)==0){continue b}else{j=n;p=37;break a}break};case 9:{n=(ge[c[73520]&127](l)|0)==0;c[73536]=(c[73536]|0)+1;if(n){break b}else{continue b}break};case 33:{c[74780]=1;c[73536]=k+1;continue b;break};case 6:{n=c[294172+(k<<4)>>2]|0;o=(c[74752]|0)+1|0;c[74752]=o;c[299016+(o<<2)>>2]=n;c[73536]=k+1;continue b;break};case 3:{n=c[74752]|0;o=299016+(n<<2)|0;t=c[o>>2]|0;c[o>>2]=t+ -1;if((t|0)<2){c[74752]=n+ -1;c[74768]=(c[74768]|0)+ -1;c[73536]=k+1;continue b}else{n=c[74768]|0;c[74768]=n+ -1;c[73536]=(c[299080+(n<<2)>>2]|0)+1;continue b}break};case 21:{c[73514]=0;c[73536]=k+1;continue b;break};case 22:{c[73514]=1;c[73536]=k+1;continue b;break};case 18:{c[73512]=1;c[73536]=k+1;continue b;break};case 20:{c[73532]=c[294172+(k<<4)>>2];c[73536]=k+1;continue b;break};default:{p=4;break a}}}if((p|0)==10){p=0;if(b){p=11;break}c[q>>2]=s+ -1;c[74764]=1;k=le[c[73518]&63](l,g,d)|0;if((k|0)>0){p=13;break}if((k|0)<0){p=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;p=37;break}}if((p|0)==4){h=c[r>>2]|0;d=c[73452]|0;c[f>>2]=m;c[f+4>>2]=d;ud(h|0,298968,f|0)|0;if((c[c[73508]>>2]|0)==0){Q1b(100,299e3);j=100;i=e;return j|0}else{c[(Lc()|0)>>2]=100;j=100;i=e;return j|0}}else if((p|0)==11){j=ye[c[73506]&7]()|0;i=e;return j|0}else if((p|0)==13){f=c[c[73508]>>2]|0;j=T1b(f,c[(Lc()|0)>>2]|0,299064)|0;i=e;return j|0}else if((p|0)==15){if((c[(c[73508]|0)+8>>2]|0)==0){Q1b(-1,299064);j=-1;i=e;return j|0}else{c[(Lc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((p|0)==24){j=ye[c[73506]&7]()|0;i=e;return j|0}else if((p|0)==28){j=ye[c[73506]&7]()|0;i=e;return j|0}else if((p|0)==37){i=e;return j|0}return 0}function X1b(a){a=a|0;var b=0;switch(a|0){case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};default:{b=a}}i=i;return b|0}function Y1b(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=W1b(b,0,0)|0;i=a;return d|0}function Z1b(){c[73528]=0;c[73536]=0;c[74768]=0;c[74752]=0;c[74764]=0;c[74770]=0;c[74754]=0;i=i;return}function _1b(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[73536]|0;if((g|0)>299){pc(299144,24,1,c[r>>2]|0)|0;F1b(c[73452]|0,1)}else{c[294168+(g<<4)>>2]=a;c[294172+(g<<4)>>2]=b;c[294176+(g<<4)>>2]=d;c[294180+(g<<4)>>2]=e;c[73536]=g+1;i=f;return g|0}return 0}function $1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=a2b(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==41){j=9;break a}else if(e<<24>>24==44){j=7;break}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[73540]|0)+ -1|0;c[73540]=h;if((h|0)==0){_1b(2,c[73538]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{_1b(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function a2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((b2b(b,e)|0)!=0){g=c[e>>2]|0;break}if((c2b(b,e)|0)!=0){g=c[e>>2]|0;break}h=d2b(b,f,1)|0;j=_1b(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=V1b(h,j)|0}}while(0);i=d;return g|0}function b2b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 47:{_1b(5,0,0,0)|0;g=b;h=30;break};case 43:{j=0;h=13;break};case 120:case 88:{_1b(4,1,0,0)|0;g=b;h=30;break};case 115:case 83:{k=b+1|0;l=a[k]|0;if(l<<24>>24==83|l<<24>>24==115){m=k;n=19}else if(l<<24>>24==80|l<<24>>24==112){m=k;n=18}else{m=b;n=17}_1b(n,0,0,0)|0;g=m;h=30;break};case 112:case 80:{_1b(20,1,0,0)|0;g=b;h=30;break};case 116:case 84:{k=b+1|0;l=a[k]|0;if(l<<24>>24==76|l<<24>>24==108){o=k;p=13}else if(l<<24>>24==82|l<<24>>24==114){o=k;p=14}else{o=b;p=15}k=d2b(o+1|0,f,0)|0;if((k|0)==0){h=15;break a}_1b(p,c[f>>2]|0,0,0)|0;g=k+ -1|0;h=30;break};case 98:case 66:{k=b+1|0;l=a[k]|0;if(l<<24>>24==90|l<<24>>24==122){_1b(22,0,0,0)|0;g=k;h=30;break a}else{_1b(21,0,0,0)|0;g=k;h=30;break a}break};case 45:{j=1;h=13;break};case 39:case 34:case 2:{c[294176+((_1b(11,0,0,0)|0)<<4)>>2]=b;k=e2b(b)|0;c[d>>2]=k;q=(k|0)!=0|0;i=e;return q|0};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{r=b;s=0;h=14;break};case 58:{_1b(16,0,0,0)|0;g=b;h=30;break};case 36:{_1b(33,0,0,0)|0;g=b;h=30;break};default:{q=0;i=e;return q|0}}}while(0);if((h|0)==13){r=b+1|0;s=j;h=14}b:do{if((h|0)==14){j=d2b(r,f,0)|0;if((j|0)==0){h=15;break}switch(a[j]|0){case 112:case 80:{b=c[f>>2]|0;if((s|0)==0){t=b}else{p=0-b|0;c[f>>2]=p;t=p}_1b(20,t,0,0)|0;g=j;h=30;break b;break};case 120:case 88:{_1b(4,c[f>>2]|0,0,0)|0;g=j;h=30;break b;break};case 104:case 72:{p=c[f>>2]|0;c[294176+((_1b(12,p,0,0)|0)<<4)>>2]=j+1;g=j+p|0;h=30;break b;break};default:{q=0;i=e;return q|0}}}}while(0);if((h|0)==15){c[d>>2]=0;q=1;i=e;return q|0}else if((h|0)==30){c[d>>2]=g+1;q=1;i=e;return q|0}return 0}function c2b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=d2b(b,f,1)|0;_1b(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 111:case 79:{l=32;m=34;n=38;break};case 97:case 65:{o=f;while(1){p=a[o]|0;if(p<<24>>24==32){o=o+1|0}else{break}}if(!((p+ -48<<24>>24&255)<10)){_1b(30,0,0,0)|0;q=o;n=45;break a}r=d2b(o,g,1)|0;s=c[g>>2]|0;if((s|0)==0){q=r;n=45;break a}_1b(31,s,0,0)|0;q=r;n=45;break};case 102:case 70:{r=d2b(f,g,0)|0;if((r|0)==0){n=4;break a}s=c[g>>2]|0;if((s|0)==0){q=r;n=45;break a}if((a[r]|0)==46){t=d2b(r+1|0,h,0)|0;if((t|0)==0){n=4;break a}u=t;v=c[h>>2]|0}else{c[h>>2]=0;u=r;v=0}_1b(23,s,v,0)|0;q=u;n=45;break};case 108:case 76:{s=d2b(f,g,0)|0;if((s|0)==0){n=4;break a}r=c[g>>2]|0;if((r|0)==0){q=s;n=45;break a}_1b(29,r,0,0)|0;q=s;n=45;break};case 101:case 69:{w=1;n=3;break};case 105:case 73:{l=7;m=10;n=38;break};case 122:case 90:{l=35;m=36;n=38;break};case 103:case 71:{w=0;n=3;break};case 100:case 68:{s=d2b(f,g,0)|0;if((s|0)==0){n=4;break a}r=c[g>>2]|0;if((r|0)==0){q=s;n=45;break a}if((a[s]|0)==46){t=d2b(s+1|0,h,0)|0;if((t|0)==0){n=4;break a}x=t;y=c[h>>2]|0}else{c[h>>2]=0;x=s;y=0}_1b(26,r,y,0)|0;q=x;n=45;break};default:{c[73536]=(c[73536]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((n|0)==3){b=d2b(f,g,0)|0;if((b|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){q=b;n=45;break}y=a[b]|0;if(y<<24>>24==46){u=d2b(b+1|0,h,0)|0;if((u|0)==0){n=4;break}A=u;B=a[u]|0}else{c[h>>2]=0;A=b;B=y}if(!(B<<24>>24==101|B<<24>>24==69)){_1b((w|0)==1?24:27,x,c[h>>2]|0,0)|0;q=A;n=45;break}y=d2b(A+1|0,j,0)|0;if((y|0)==0){n=4;break}_1b((w|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;q=y;n=45}else if((n|0)==38){y=d2b(f,g,0)|0;if((y|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){q=y;n=45;break}if((a[y]|0)!=46){_1b(l,x,0,0)|0;q=y;n=45;break}b=d2b(y+1|0,h,0)|0;if((b|0)==0){n=4;break}_1b(m,x,c[h>>2]|0,0)|0;q=b;n=45}}while(0);if((n|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((n|0)==45){c[d>>2]=q;z=1;i=e;return z|0}return 0}function d2b(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function e2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[73508]>>2]|0)==0){Q1b(100,299128);n=0;i=d;return n|0}else{c[(Lc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function f2b(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[299198|0]=48;k=299198|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=299176+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function g2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[73530]|0;f=c[73526]|0;if((e|0)>(f|0)){c[73526]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[74818]|0)){h=g}else{h2b(f,g);h=c[73526]|0}g=c[74820]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Id(g|0,c[73504]|0)|0;h=Eec(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Qd(a[k]|0,c[73504]|0)|0;Id(h|0,c[73504]|0)|0;b=Eec(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function h2b(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[74820]|0;if((f|0)==299360){c[74818]=1024;g=1024}else{g=c[74818]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[74818]=j;h=j}j=aec(h)|0;if((j|0)==0){Q1b(113,299760);k=c[74820]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[74820]|0}else{l=k}if((l|0)==299360){m=299280;c[74820]=j;i=e;return}bec(l);m=299280;c[74820]=j;i=e;return}function i2b(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[73526]|0;f=c[74818]|0;if((e|0)<(f|0)){g=e}else{h2b(e,f);g=c[73526]|0}c[73526]=g+1;a[(c[74820]|0)+g|0]=b;i=d;return}



function UX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+15144>>3]=l;i=b;return}function VX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14872>>3]=+h[b+14608>>3];i=i;return}function WX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14944>>3]=+h[b+14872>>3];i=i;return}function XX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14864>>3]=+h[b+14600>>3];i=i;return}function YX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14936>>3]=+h[b+14864>>3];i=i;return}function ZX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14856>>3]=+h[b+14592>>3];i=i;return}function _X(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14928>>3]=+h[b+14856>>3];i=i;return}function $X(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14920>>3]=+h[b+14656>>3];i=i;return}function aY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14912>>3]=+h[b+14648>>3];i=i;return}function bY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14904>>3]=+h[b+14640>>3];i=i;return}function cY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14896>>3]=+h[b+14632>>3];i=i;return}function dY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14888>>3]=+h[b+14624>>3];i=i;return}function eY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14880>>3]=+h[b+14616>>3];i=i;return}function fY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24208>>3]=+h[b+24104>>3];i=i;return}function gY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24200>>3]=+h[b+24096>>3];i=i;return}function hY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24192>>3]=+h[b+24088>>3];i=i;return}function iY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24080>>3]=+h[b+23544>>3];i=i;return}function jY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24184>>3]=+h[b+24080>>3];i=i;return}function kY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24072>>3]=+h[b+23536>>3];i=i;return}function lY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24176>>3]=+h[b+24072>>3];i=i;return}function mY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24064>>3]=+h[b+23528>>3];i=i;return}function nY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24168>>3]=+h[b+24064>>3];i=i;return}function oY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24152>>3]=+h[b+23512>>3]/1.75;i=i;return}function pY(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+14424>>3];e=-.1- +h[b+14432>>3];f=+h[b+14440>>3];h[b+23976>>3]=+V(+(f*f+(d*d+e*e)));i=i;return}function qY(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+225|0]=a[d+222|0]|0;i=i;return}function rY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13928>>3]=-+h[b+23472>>3];i=i;return}function sY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23736>>3]=+h[b+23512>>3]*.5;i=i;return}function tY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23728>>3]=+h[b+23472>>3]*.5;i=i;return}function uY(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+13464>>3]- +h[b+13584>>3];e=+h[b+13472>>3]- +h[b+13592>>3];f=+h[b+13480>>3]- +h[b+13600>>3];h[b+23704>>3]=+V(+(d*d+e*e+f*f));i=i;return}function vY(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+23704>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,22896,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+23712>>3]=l;i=d;return}function wY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23720>>3]=+h[b+23712>>3];i=i;return}function xY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23688>>3]=+h[b+23464>>3];i=i;return}function yY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23648>>3]=+h[b+23456>>3];i=i;return}function zY(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+256>>2]=c[b+252>>2];i=i;return}function AY(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+167|0]=a[d+6|0]|0;i=i;return}function BY(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+186|0]=a[d+167|0]|0;i=i;return}function CY(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+200|0]=a[d+167|0]|0;i=i;return}function DY(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+214|0]=a[d+167|0]|0;i=i;return}function EY(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+248>>2]=c[b+240>>2];i=i;return}function FY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23416>>3]=+h[b+23400>>3]*2.0;i=i;return}function GY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+12784>>3]=l;i=b;return}function HY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+12776>>3]=l;i=b;return}function IY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+12768>>3]=l;i=b;return}function JY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+12760>>3]=l;i=b;return}function KY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12488>>3]=+h[b+12224>>3];i=i;return}function LY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12560>>3]=+h[b+12488>>3];i=i;return}function MY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12480>>3]=+h[b+12216>>3];i=i;return}function NY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12552>>3]=+h[b+12480>>3];i=i;return}function OY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12472>>3]=+h[b+12208>>3];i=i;return}function PY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12544>>3]=+h[b+12472>>3];i=i;return}function QY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12536>>3]=+h[b+12272>>3];i=i;return}function RY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12528>>3]=+h[b+12264>>3];i=i;return}function SY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12520>>3]=+h[b+12256>>3];i=i;return}function TY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12512>>3]=+h[b+12248>>3];i=i;return}function UY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12504>>3]=+h[b+12240>>3];i=i;return}function VY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12496>>3]=+h[b+12232>>3];i=i;return}function WY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23376>>3]=+h[b+23272>>3];i=i;return}function XY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23368>>3]=+h[b+23264>>3];i=i;return}function YY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23360>>3]=+h[b+23256>>3];i=i;return}function ZY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23248>>3]=+h[b+22472>>3];i=i;return}function _Y(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23352>>3]=+h[b+23248>>3];i=i;return}function $Y(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23240>>3]=+h[b+22464>>3];i=i;return}function aZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23344>>3]=+h[b+23240>>3];i=i;return}function bZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23232>>3]=+h[b+22456>>3];i=i;return}function cZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23336>>3]=+h[b+23232>>3];i=i;return}function dZ(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+236>>2]=c[b+228>>2];i=i;return}function eZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23200>>3]=+h[b+22480>>3]/1.75;i=i;return}function fZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23216>>3]=+h[b+23200>>3]*2.0;i=i;return}function gZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23208>>3]=+h[b+22480>>3]/1.75;i=i;return}function hZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+12152>>3]=l;i=b;return}function iZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+12144>>3]=l;i=b;return}function jZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+12136>>3]=l;i=b;return}function kZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+12128>>3]=l;i=b;return}function lZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11856>>3]=+h[b+11592>>3];i=i;return}function mZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11928>>3]=+h[b+11856>>3];i=i;return}function nZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11848>>3]=+h[b+11584>>3];i=i;return}function oZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11920>>3]=+h[b+11848>>3];i=i;return}function pZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11840>>3]=+h[b+11576>>3];i=i;return}function qZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11912>>3]=+h[b+11840>>3];i=i;return}function rZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11904>>3]=+h[b+11640>>3];i=i;return}function sZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11896>>3]=+h[b+11632>>3];i=i;return}function tZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11888>>3]=+h[b+11624>>3];i=i;return}function uZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11880>>3]=+h[b+11616>>3];i=i;return}function vZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11872>>3]=+h[b+11608>>3];i=i;return}function wZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11864>>3]=+h[b+11600>>3];i=i;return}function xZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23176>>3]=+h[b+23072>>3];i=i;return}function yZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23168>>3]=+h[b+23064>>3];i=i;return}function zZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23160>>3]=+h[b+23056>>3];i=i;return}function AZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23048>>3]=+h[b+22512>>3];i=i;return}function BZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23152>>3]=+h[b+23048>>3];i=i;return}function CZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23040>>3]=+h[b+22504>>3];i=i;return}function DZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23144>>3]=+h[b+23040>>3];i=i;return}function EZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23032>>3]=+h[b+22496>>3];i=i;return}function FZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23136>>3]=+h[b+23032>>3];i=i;return}function GZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23120>>3]=+h[b+22480>>3]/1.75;i=i;return}function HZ(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+11408>>3];e=-.1- +h[b+11416>>3];f=+h[b+11424>>3];h[b+22944>>3]=+V(+(f*f+(d*d+e*e)));i=i;return}function IZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+177|0]=a[d+174|0]|0;i=i;return}function JZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10912>>3]=-+h[b+22440>>3];i=i;return}function KZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22704>>3]=+h[b+22480>>3]*.5;i=i;return}function LZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22696>>3]=+h[b+22440>>3]*.5;i=i;return}function MZ(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+10448>>3]- +h[b+10568>>3];e=+h[b+10456>>3]- +h[b+10576>>3];f=+h[b+10464>>3]- +h[b+10584>>3];h[b+22672>>3]=+V(+(d*d+e*e+f*f));i=i;return}function NZ(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+22672>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,22904,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+22680>>3]=l;i=d;return}function OZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22688>>3]=+h[b+22680>>3];i=i;return}function PZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22656>>3]=+h[b+22432>>3];i=i;return}function QZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22616>>3]=+h[b+22424>>3];i=i;return}function RZ(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+196>>2]=c[b+192>>2];i=i;return}function SZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+119|0]=a[d+6|0]|0;i=i;return}function TZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+138|0]=a[d+119|0]|0;i=i;return}function UZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+152|0]=a[d+119|0]|0;i=i;return}function VZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+166|0]=a[d+119|0]|0;i=i;return}function WZ(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+188>>2]=c[b+180>>2];i=i;return}function XZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22384>>3]=+h[b+22368>>3]*2.0;i=i;return}function YZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+9768>>3]=l;i=b;return}function ZZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+9760>>3]=l;i=b;return}function _Z(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+9752>>3]=l;i=b;return}function $Z(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+9744>>3]=l;i=b;return}function a_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9472>>3]=+h[b+9208>>3];i=i;return}function b_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9544>>3]=+h[b+9472>>3];i=i;return}function c_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9464>>3]=+h[b+9200>>3];i=i;return}function d_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9536>>3]=+h[b+9464>>3];i=i;return}function e_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9456>>3]=+h[b+9192>>3];i=i;return}function f_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9528>>3]=+h[b+9456>>3];i=i;return}function g_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9520>>3]=+h[b+9256>>3];i=i;return}function h_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9512>>3]=+h[b+9248>>3];i=i;return}function i_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9504>>3]=+h[b+9240>>3];i=i;return}function j_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9496>>3]=+h[b+9232>>3];i=i;return}function k_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9488>>3]=+h[b+9224>>3];i=i;return}function l_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9480>>3]=+h[b+9216>>3];i=i;return}function m_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22344>>3]=+h[b+22240>>3];i=i;return}function n_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22336>>3]=+h[b+22232>>3];i=i;return}function o_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22328>>3]=+h[b+22224>>3];i=i;return}function p_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22216>>3]=+h[b+21440>>3];i=i;return}function q_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22320>>3]=+h[b+22216>>3];i=i;return}function r_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22208>>3]=+h[b+21432>>3];i=i;return}function s_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22312>>3]=+h[b+22208>>3];i=i;return}function t_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22200>>3]=+h[b+21424>>3];i=i;return}function u_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22304>>3]=+h[b+22200>>3];i=i;return}function v_(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+176>>2]=c[b+168>>2];i=i;return}function w_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22168>>3]=+h[b+21448>>3]/1.75;i=i;return}function x_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22184>>3]=+h[b+22168>>3]*2.0;i=i;return}function y_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22176>>3]=+h[b+21448>>3]/1.75;i=i;return}function z_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+9136>>3]=l;i=b;return}function A_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+9128>>3]=l;i=b;return}function B_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+9120>>3]=l;i=b;return}function C_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+9112>>3]=l;i=b;return}function D_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8840>>3]=+h[b+8576>>3];i=i;return}function E_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8912>>3]=+h[b+8840>>3];i=i;return}function F_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8832>>3]=+h[b+8568>>3];i=i;return}function G_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8904>>3]=+h[b+8832>>3];i=i;return}function H_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8824>>3]=+h[b+8560>>3];i=i;return}function I_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8896>>3]=+h[b+8824>>3];i=i;return}function J_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8888>>3]=+h[b+8624>>3];i=i;return}function K_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8880>>3]=+h[b+8616>>3];i=i;return}function L_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8872>>3]=+h[b+8608>>3];i=i;return}function M_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8864>>3]=+h[b+8600>>3];i=i;return}function N_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8856>>3]=+h[b+8592>>3];i=i;return}function O_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8848>>3]=+h[b+8584>>3];i=i;return}function P_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22144>>3]=+h[b+22040>>3];i=i;return}function Q_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22136>>3]=+h[b+22032>>3];i=i;return}function R_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22128>>3]=+h[b+22024>>3];i=i;return}function S_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22016>>3]=+h[b+21480>>3];i=i;return}function T_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22120>>3]=+h[b+22016>>3];i=i;return}function U_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22008>>3]=+h[b+21472>>3];i=i;return}function V_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22112>>3]=+h[b+22008>>3];i=i;return}function W_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22e3>>3]=+h[b+21464>>3];i=i;return}function X_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22104>>3]=+h[b+22e3>>3];i=i;return}function Y_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22088>>3]=+h[b+21448>>3]/1.75;i=i;return}function Z_(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+8392>>3];e=-.1- +h[b+8400>>3];f=+h[b+8408>>3];h[b+21912>>3]=+V(+(f*f+(d*d+e*e)));i=i;return}function __(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+129|0]=a[d+126|0]|0;i=i;return}function $_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7896>>3]=-+h[b+21408>>3];i=i;return}function a$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21672>>3]=+h[b+21448>>3]*.5;i=i;return}function b$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21664>>3]=+h[b+21408>>3]*.5;i=i;return}function c$(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+7432>>3]- +h[b+7552>>3];e=+h[b+7440>>3]- +h[b+7560>>3];f=+h[b+7448>>3]- +h[b+7568>>3];h[b+21640>>3]=+V(+(d*d+e*e+f*f));i=i;return}function d$(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+21640>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,22912,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+21648>>3]=l;i=d;return}function e$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21656>>3]=+h[b+21648>>3];i=i;return}function f$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21624>>3]=+h[b+21400>>3];i=i;return}function g$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21584>>3]=+h[b+21392>>3];i=i;return}function h$(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+136>>2]=c[b+132>>2];i=i;return}function i$(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+71|0]=a[d+6|0]|0;i=i;return}function j$(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+90|0]=a[d+71|0]|0;i=i;return}function k$(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+104|0]=a[d+71|0]|0;i=i;return}function l$(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+118|0]=a[d+71|0]|0;i=i;return}function m$(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+128>>2]=c[b+120>>2];i=i;return}function n$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21352>>3]=+h[b+21336>>3]*2.0;i=i;return}function o$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+6752>>3]=l;i=b;return}function p$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+6744>>3]=l;i=b;return}function q$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+6736>>3]=l;i=b;return}function r$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+6728>>3]=l;i=b;return}function s$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6456>>3]=+h[b+6192>>3];i=i;return}function t$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6528>>3]=+h[b+6456>>3];i=i;return}function u$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6448>>3]=+h[b+6184>>3];i=i;return}function v$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6520>>3]=+h[b+6448>>3];i=i;return}function w$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6440>>3]=+h[b+6176>>3];i=i;return}function x$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6512>>3]=+h[b+6440>>3];i=i;return}function y$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6504>>3]=+h[b+6240>>3];i=i;return}function z$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6496>>3]=+h[b+6232>>3];i=i;return}function A$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6488>>3]=+h[b+6224>>3];i=i;return}function B$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6480>>3]=+h[b+6216>>3];i=i;return}function C$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6472>>3]=+h[b+6208>>3];i=i;return}function D$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6464>>3]=+h[b+6200>>3];i=i;return}function E$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21312>>3]=+h[b+21208>>3];i=i;return}function F$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21304>>3]=+h[b+21200>>3];i=i;return}function G$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21296>>3]=+h[b+21192>>3];i=i;return}function H$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21184>>3]=+h[b+20408>>3];i=i;return}function I$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21288>>3]=+h[b+21184>>3];i=i;return}function J$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21176>>3]=+h[b+20400>>3];i=i;return}function K$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21280>>3]=+h[b+21176>>3];i=i;return}function L$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21168>>3]=+h[b+20392>>3];i=i;return}function M$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21272>>3]=+h[b+21168>>3];i=i;return}function N$(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+116>>2]=c[b+108>>2];i=i;return}function O$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21136>>3]=+h[b+20416>>3]/1.75;i=i;return}function P$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21152>>3]=+h[b+21136>>3]*2.0;i=i;return}function Q$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21144>>3]=+h[b+20416>>3]/1.75;i=i;return}function R$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+6120>>3]=l;i=b;return}function S$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+6112>>3]=l;i=b;return}function T$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+6104>>3]=l;i=b;return}function U$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+6096>>3]=l;i=b;return}function V$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5824>>3]=+h[b+5560>>3];i=i;return}function W$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5896>>3]=+h[b+5824>>3];i=i;return}function X$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5816>>3]=+h[b+5552>>3];i=i;return}function Y$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5888>>3]=+h[b+5816>>3];i=i;return}function Z$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5808>>3]=+h[b+5544>>3];i=i;return}function _$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5880>>3]=+h[b+5808>>3];i=i;return}function $$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5872>>3]=+h[b+5608>>3];i=i;return}function a0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5864>>3]=+h[b+5600>>3];i=i;return}function b0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5856>>3]=+h[b+5592>>3];i=i;return}function c0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5848>>3]=+h[b+5584>>3];i=i;return}function d0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5840>>3]=+h[b+5576>>3];i=i;return}function e0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5832>>3]=+h[b+5568>>3];i=i;return}function f0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21112>>3]=+h[b+21008>>3];i=i;return}function g0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21104>>3]=+h[b+21e3>>3];i=i;return}function h0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21096>>3]=+h[b+20992>>3];i=i;return}function i0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20984>>3]=+h[b+20448>>3];i=i;return}function j0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21088>>3]=+h[b+20984>>3];i=i;return}function k0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20976>>3]=+h[b+20440>>3];i=i;return}function l0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21080>>3]=+h[b+20976>>3];i=i;return}function m0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20968>>3]=+h[b+20432>>3];i=i;return}function n0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21072>>3]=+h[b+20968>>3];i=i;return}function o0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21056>>3]=+h[b+20416>>3]/1.75;i=i;return}function p0(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+5376>>3];e=-.1- +h[b+5384>>3];f=+h[b+5392>>3];h[b+20880>>3]=+V(+(f*f+(d*d+e*e)));i=i;return}function q0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+81|0]=a[d+78|0]|0;i=i;return}function r0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4880>>3]=-+h[b+20376>>3];i=i;return}function s0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20640>>3]=+h[b+20416>>3]*.5;i=i;return}function t0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20632>>3]=+h[b+20376>>3]*.5;i=i;return}function u0(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+4416>>3]- +h[b+4536>>3];e=+h[b+4424>>3]- +h[b+4544>>3];f=+h[b+4432>>3]- +h[b+4552>>3];h[b+20608>>3]=+V(+(d*d+e*e+f*f));i=i;return}function v0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+20608>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,22920,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+20616>>3]=l;i=d;return}function w0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20624>>3]=+h[b+20616>>3];i=i;return}function x0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20592>>3]=+h[b+20368>>3];i=i;return}function y0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20552>>3]=+h[b+20360>>3];i=i;return}function z0(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+76>>2]=c[b+72>>2];i=i;return}function A0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+23|0]=a[d+6|0]|0;i=i;return}function B0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+42|0]=a[d+23|0]|0;i=i;return}function C0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+56|0]=a[d+23|0]|0;i=i;return}function D0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+70|0]=a[d+23|0]|0;i=i;return}function E0(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+68>>2]=c[b+60>>2];i=i;return}function F0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20320>>3]=+h[b+20304>>3]*2.0;i=i;return}function G0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+3736>>3]=l;i=b;return}function H0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+3728>>3]=l;i=b;return}function I0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+3720>>3]=l;i=b;return}function J0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+3712>>3]=l;i=b;return}function K0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3440>>3]=+h[b+3176>>3];i=i;return}function L0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3512>>3]=+h[b+3440>>3];i=i;return}function M0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3432>>3]=+h[b+3168>>3];i=i;return}function N0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3504>>3]=+h[b+3432>>3];i=i;return}function O0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3424>>3]=+h[b+3160>>3];i=i;return}function P0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3496>>3]=+h[b+3424>>3];i=i;return}function Q0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3488>>3]=+h[b+3224>>3];i=i;return}function R0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3480>>3]=+h[b+3216>>3];i=i;return}function S0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3472>>3]=+h[b+3208>>3];i=i;return}function T0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3464>>3]=+h[b+3200>>3];i=i;return}function U0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3456>>3]=+h[b+3192>>3];i=i;return}function V0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3448>>3]=+h[b+3184>>3];i=i;return}function W0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20280>>3]=+h[b+20176>>3];i=i;return}function X0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20272>>3]=+h[b+20168>>3];i=i;return}function Y0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20264>>3]=+h[b+20160>>3];i=i;return}function Z0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20152>>3]=+h[b+19376>>3];i=i;return}function _0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20256>>3]=+h[b+20152>>3];i=i;return}function $0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20144>>3]=+h[b+19368>>3];i=i;return}function a1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20248>>3]=+h[b+20144>>3];i=i;return}function b1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20136>>3]=+h[b+19360>>3];i=i;return}function c1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20240>>3]=+h[b+20136>>3];i=i;return}function d1(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+56>>2]=c[b+48>>2];i=i;return}function e1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20104>>3]=+h[b+19384>>3]/1.75;i=i;return}function f1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20120>>3]=+h[b+20104>>3]*2.0;i=i;return}function g1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20112>>3]=+h[b+19384>>3]/1.75;i=i;return}function h1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+3104>>3]=l;i=b;return}function i1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+3096>>3]=l;i=b;return}function j1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+3088>>3]=l;i=b;return}function k1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+3080>>3]=l;i=b;return}function l1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2808>>3]=+h[b+2544>>3];i=i;return}function m1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2880>>3]=+h[b+2808>>3];i=i;return}function n1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2800>>3]=+h[b+2536>>3];i=i;return}function o1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2872>>3]=+h[b+2800>>3];i=i;return}function p1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2792>>3]=+h[b+2528>>3];i=i;return}function q1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2864>>3]=+h[b+2792>>3];i=i;return}function r1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2856>>3]=+h[b+2592>>3];i=i;return}function s1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2848>>3]=+h[b+2584>>3];i=i;return}function t1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2840>>3]=+h[b+2576>>3];i=i;return}function u1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2832>>3]=+h[b+2568>>3];i=i;return}function v1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2824>>3]=+h[b+2560>>3];i=i;return}function w1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2816>>3]=+h[b+2552>>3];i=i;return}function x1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20080>>3]=+h[b+19976>>3];i=i;return}function y1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20072>>3]=+h[b+19968>>3];i=i;return}function z1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20064>>3]=+h[b+19960>>3];i=i;return}function A1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19952>>3]=+h[b+19416>>3];i=i;return}function B1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20056>>3]=+h[b+19952>>3];i=i;return}function C1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19944>>3]=+h[b+19408>>3];i=i;return}function D1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20048>>3]=+h[b+19944>>3];i=i;return}function E1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19936>>3]=+h[b+19400>>3];i=i;return}function F1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20040>>3]=+h[b+19936>>3];i=i;return}function G1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20024>>3]=+h[b+19384>>3]/1.75;i=i;return}function H1(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+2360>>3];e=-.1- +h[b+2368>>3];f=+h[b+2376>>3];h[b+19848>>3]=+V(+(f*f+(d*d+e*e)));i=i;return}function I1(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+33|0]=a[d+30|0]|0;i=i;return}function J1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1864>>3]=-+h[b+19344>>3];i=i;return}function K1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19608>>3]=+h[b+19384>>3]*.5;i=i;return}function L1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19600>>3]=+h[b+19344>>3]*.5;i=i;return}function M1(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+1400>>3]- +h[b+1520>>3];e=+h[b+1408>>3]- +h[b+1528>>3];f=+h[b+1416>>3]- +h[b+1536>>3];h[b+19576>>3]=+V(+(d*d+e*e+f*f));i=i;return}function N1(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+19576>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,22928,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+19584>>3]=l;i=d;return}function O1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19592>>3]=+h[b+19584>>3];i=i;return}function P1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19560>>3]=+h[b+19336>>3];i=i;return}function Q1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19520>>3]=+h[b+19328>>3];i=i;return}function R1(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+96>>3]- +h[b+216>>3];e=+h[b+104>>3]- +h[b+224>>3];f=+h[b+112>>3]- +h[b+232>>3];h[b+19192>>3]=+V(+(d*d+e*e+f*f));i=i;return}function S1(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+19192>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,22936,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+19272>>3]=l;i=d;return}function T1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19280>>3]=+h[b+19272>>3];i=i;return}function U1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19288>>3]=+h[b+19272>>3]*2.0;i=i;return}function V1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+720>>3]=l;i=b;return}function W1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+712>>3]=l;i=b;return}function X1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+704>>3]=l;i=b;return}function Y1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+696>>3]=l;i=b;return}function Z1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+424>>3]=+h[b+160>>3];i=i;return}function _1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+496>>3]=+h[b+424>>3];i=i;return}function $1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+416>>3]=+h[b+152>>3];i=i;return}function a2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+488>>3]=+h[b+416>>3];i=i;return}function b2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+408>>3]=+h[b+144>>3];i=i;return}function c2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+480>>3]=+h[b+408>>3];i=i;return}function d2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+472>>3]=+h[b+208>>3];i=i;return}function e2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+464>>3]=+h[b+200>>3];i=i;return}function f2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+456>>3]=+h[b+192>>3];i=i;return}function g2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+448>>3]=+h[b+184>>3];i=i;return}function h2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+440>>3]=+h[b+176>>3];i=i;return}function i2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+432>>3]=+h[b+168>>3];i=i;return}function j2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19248>>3]=+h[b+19144>>3];i=i;return}function k2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19240>>3]=+h[b+19136>>3];i=i;return}function l2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19232>>3]=+h[b+19128>>3];i=i;return}function m2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19224>>3]=+h[b+19120>>3];i=i;return}function n2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19216>>3]=+h[b+19112>>3];i=i;return}function o2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19208>>3]=+h[b+19104>>3];i=i;return}function p2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18912>>3]=+h[b+18864>>3]*.5;i=i;return}function q2(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18880>>3];j=+h[f+18912>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,22952,22944,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+18976>>3]=l;i=d;return}function r2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19008>>3]=+h[b+18976>>3]*3.0;i=i;return}function s2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19016>>3]=+h[b+18976>>3];i=i;return}function t2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19024>>3]=+h[b+18976>>3]*3.0;i=i;return}function u2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18984>>3]=+h[b+18912>>3]*.5;i=i;return}function v2(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+18984>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,22992,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+19032>>3]=l;i=d;return}function w2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19056>>3]=+h[b+19032>>3]*3.0;i=i;return}function x2(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+19048>>3]=+qd(+(+h[d+18984>>3]),+(+h[d+19032>>3]*4.0));i=b;return}function y2(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+19064>>3]=+rd(0.0,+(+h[d+18984>>3]- +h[d+19048>>3]));i=b;return}function z2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18992>>3]=+h[b+18912>>3]*1.05;i=i;return}function A2(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+19e3>>3]=+qd(+(+h[d+18912>>3]),+(+h[d+18976>>3]*5.0));i=b;return}function B2(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+19040>>3]=+rd(0.0,+(+h[d+18912>>3]- +h[d+19e3>>3]));i=b;return}function C2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18968>>3]=+h[b+18864>>3]*.025;i=i;return}function D2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18952>>3]=+h[b+18864>>3]*.05;i=i;return}function E2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18944>>3]=+h[b+18864>>3]*.1;i=i;return}function F2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18920>>3]=+h[b+18864>>3]*.2;i=i;return}function G2(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+424>>2]|0;do{if((a[e+1|0]|0)==0){f=0}else{if((a[e+2|0]|0)==0){f=0;break}f=(a[e+5|0]|0)!=0|0}}while(0);c[(c[b+420>>2]|0)+776>>2]=f;i=d;return}function H2(b){b=b|0;var d=0,e=0;d=c[b+424>>2]|0;if((a[d+1|0]|0)==0){e=0}else{e=(a[d+2|0]|0)!=0|0}c[(c[b+420>>2]|0)+772>>2]=e;i=i;return}function I2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19496>>3]=0.0;i=i;return}function J2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19488>>3]=0.0;i=i;return}function K2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19480>>3]=0.0;i=i;return}function L2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19472>>3]=0.0;i=i;return}function M2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19464>>3]=0.0;i=i;return}function N2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19456>>3]=0.0;i=i;return}function O2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19448>>3]=1.0;i=i;return}function P2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19424>>3]=0.0;i=i;return}function Q2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19400>>3]=0.0;i=i;return}function R2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19440>>3]=0.0;i=i;return}function S2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19416>>3]=1.0;i=i;return}function T2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19392>>3]=0.0;i=i;return}function U2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19432>>3]=0.0;i=i;return}function V2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19408>>3]=0.0;i=i;return}function W2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19384>>3]=1.0;i=i;return}function X2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21576>>3]=0.0;i=i;return}function Y2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19376>>3]=0.0;i=i;return}function Z2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19368>>3]=0.0;i=i;return}function _2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19360>>3]=0.0;i=i;return}function $2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19352>>3]=0.0;i=i;return}function a3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19344>>3]=0.0;i=i;return}function b3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19336>>3]=0.0;i=i;return}function c3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19328>>3]=0.0;i=i;return}function d3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19320>>3]=0.0;i=i;return}function e3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19312>>3]=0.0;i=i;return}function f3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19304>>3]=0.0;i=i;return}function g3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19296>>3]=0.0;i=i;return}function h3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19288>>3]=0.0;i=i;return}function i3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19280>>3]=0.0;i=i;return}function j3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19272>>3]=-.1;i=i;return}function k3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19264>>3]=0.0;i=i;return}function l3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19256>>3]=0.0;i=i;return}function m3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19248>>3]=0.0;i=i;return}function n3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19240>>3]=0.0;i=i;return}function o3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19232>>3]=0.0;i=i;return}function p3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19224>>3]=0.0;i=i;return}function q3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19216>>3]=0.0;i=i;return}function r3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19208>>3]=0.0;i=i;return}function s3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19200>>3]=0.0;i=i;return}function t3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19192>>3]=0.0;i=i;return}function u3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19184>>3]=0.0;i=i;return}function v3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19176>>3]=0.0;i=i;return}function w3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19168>>3]=0.0;i=i;return}function x3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19160>>3]=0.0;i=i;return}function y3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19152>>3]=0.0;i=i;return}function z3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19144>>3]=0.0;i=i;return}function A3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19136>>3]=0.0;i=i;return}function B3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19128>>3]=0.0;i=i;return}function C3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19120>>3]=0.0;i=i;return}function D3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19112>>3]=0.0;i=i;return}function E3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19104>>3]=0.0;i=i;return}function F3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19096>>3]=0.0;i=i;return}function G3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19088>>3]=0.0;i=i;return}function H3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19080>>3]=0.0;i=i;return}function I3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19072>>3]=0.0;i=i;return}function J3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19064>>3]=0.0;i=i;return}function K3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19056>>3]=0.0;i=i;return}function L3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19048>>3]=0.0;i=i;return}function M3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19040>>3]=0.0;i=i;return}function N3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19032>>3]=0.0;i=i;return}function O3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19024>>3]=0.0;i=i;return}function P3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21568>>3]=0.0;i=i;return}function Q3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19016>>3]=0.0;i=i;return}function R3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19008>>3]=0.0;i=i;return}function S3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19e3>>3]=0.0;i=i;return}function T3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18992>>3]=0.0;i=i;return}function U3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18984>>3]=0.0;i=i;return}function V3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18976>>3]=0.0;i=i;return}function W3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18968>>3]=0.0;i=i;return}function X3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18960>>3]=0.0;i=i;return}function Y3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18952>>3]=0.0;i=i;return}function Z3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18944>>3]=0.0;i=i;return}function _3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18936>>3]=0.0;i=i;return}function $3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18928>>3]=0.0;i=i;return}function a4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18920>>3]=0.0;i=i;return}function b4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18912>>3]=-.1;i=i;return}function c4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18904>>3]=0.0;i=i;return}function d4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18896>>3]=0.0;i=i;return}function e4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18888>>3]=0.0;i=i;return}function f4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18880>>3]=0.0;i=i;return}function g4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18872>>3]=0.0;i=i;return}function h4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18864>>3]=0.0;i=i;return}function i4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18856>>3]=0.0;i=i;return}function j4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18848>>3]=0.0;i=i;return}function k4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18840>>3]=0.0;i=i;return}function l4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18832>>3]=0.0;i=i;return}function m4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18824>>3]=0.0;i=i;return}function n4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18816>>3]=0.0;i=i;return}function o4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18808>>3]=0.0;i=i;return}function p4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18800>>3]=0.0;i=i;return}function q4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18792>>3]=0.0;i=i;return}function r4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18784>>3]=0.0;i=i;return}function s4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18776>>3]=0.0;i=i;return}function t4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18768>>3]=0.0;i=i;return}function u4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18760>>3]=0.0;i=i;return}function v4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21560>>3]=0.0;i=i;return}function w4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18752>>3]=0.0;i=i;return}function x4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18744>>3]=0.0;i=i;return}function y4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18736>>3]=0.0;i=i;return}function z4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18728>>3]=0.0;i=i;return}function A4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18720>>3]=0.0;i=i;return}function B4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18712>>3]=0.0;i=i;return}function C4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18704>>3]=0.0;i=i;return}function D4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18696>>3]=0.0;i=i;return}function E4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18688>>3]=0.0;i=i;return}function F4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18680>>3]=0.0;i=i;return}function G4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18672>>3]=0.0;i=i;return}function H4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18664>>3]=0.0;i=i;return}function I4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18656>>3]=0.0;i=i;return}function J4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18648>>3]=-.1;i=i;return}function K4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18640>>3]=0.0;i=i;return}function L4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18632>>3]=0.0;i=i;return}function M4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18624>>3]=0.0;i=i;return}function N4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18616>>3]=0.0;i=i;return}function O4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18608>>3]=0.0;i=i;return}function P4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18600>>3]=0.0;i=i;return}function Q4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18592>>3]=0.0;i=i;return}function R4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18584>>3]=0.0;i=i;return}function S4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18576>>3]=0.0;i=i;return}function T4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18568>>3]=0.0;i=i;return}function U4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18560>>3]=0.0;i=i;return}function V4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18552>>3]=0.0;i=i;return}function W4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18544>>3]=0.0;i=i;return}function X4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18536>>3]=0.0;i=i;return}function Y4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18528>>3]=0.0;i=i;return}function Z4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18520>>3]=0.0;i=i;return}function _4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18512>>3]=0.0;i=i;return}function $4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18504>>3]=0.0;i=i;return}function a5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18496>>3]=0.0;i=i;return}function b5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21552>>3]=0.0;i=i;return}function c5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18488>>3]=0.0;i=i;return}function d5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18480>>3]=0.0;i=i;return}function e5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18472>>3]=0.0;i=i;return}function f5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18464>>3]=0.0;i=i;return}function g5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18456>>3]=0.0;i=i;return}function h5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18448>>3]=0.0;i=i;return}function i5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18440>>3]=0.0;i=i;return}function j5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18432>>3]=0.0;i=i;return}function k5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18424>>3]=0.0;i=i;return}function l5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18416>>3]=0.0;i=i;return}function m5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18408>>3]=0.0;i=i;return}function n5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18400>>3]=0.0;i=i;return}function o5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18392>>3]=0.0;i=i;return}function p5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18384>>3]=-.1;i=i;return}function q5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18376>>3]=0.0;i=i;return}function r5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18368>>3]=0.0;i=i;return}function s5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18360>>3]=0.0;i=i;return}function t5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18352>>3]=0.0;i=i;return}function u5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18344>>3]=0.0;i=i;return}function v5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18336>>3]=0.0;i=i;return}function w5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18328>>3]=0.0;i=i;return}function x5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18320>>3]=0.0;i=i;return}function y5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18312>>3]=0.0;i=i;return}function z5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18304>>3]=0.0;i=i;return}function A5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18296>>3]=0.0;i=i;return}function B5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18288>>3]=0.0;i=i;return}function C5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18280>>3]=0.0;i=i;return}function D5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18272>>3]=0.0;i=i;return}function E5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18264>>3]=0.0;i=i;return}function F5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18256>>3]=0.0;i=i;return}function G5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18248>>3]=0.0;i=i;return}function H5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18240>>3]=0.0;i=i;return}function I5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18232>>3]=0.0;i=i;return}function J5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21544>>3]=0.0;i=i;return}function K5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18224>>3]=0.0;i=i;return}function L5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18216>>3]=0.0;i=i;return}function M5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18208>>3]=0.0;i=i;return}function N5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18200>>3]=0.0;i=i;return}function O5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18192>>3]=0.0;i=i;return}function P5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18184>>3]=0.0;i=i;return}function Q5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18176>>3]=0.0;i=i;return}function R5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18168>>3]=0.0;i=i;return}function S5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18160>>3]=0.0;i=i;return}function T5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18152>>3]=0.0;i=i;return}function U5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18144>>3]=0.0;i=i;return}function V5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18136>>3]=0.0;i=i;return}function W5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18128>>3]=0.0;i=i;return}function X5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18120>>3]=-.1;i=i;return}function Y5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18112>>3]=0.0;i=i;return}function Z5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18104>>3]=0.0;i=i;return}function _5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18096>>3]=0.0;i=i;return}function $5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18088>>3]=0.0;i=i;return}function a6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18080>>3]=0.0;i=i;return}function b6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18072>>3]=0.0;i=i;return}function c6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18064>>3]=0.0;i=i;return}function d6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18056>>3]=0.0;i=i;return}function e6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18048>>3]=0.0;i=i;return}function f6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18040>>3]=0.0;i=i;return}function g6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18032>>3]=0.0;i=i;return}function h6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18024>>3]=0.0;i=i;return}function i6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18016>>3]=0.0;i=i;return}function j6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18008>>3]=0.0;i=i;return}function k6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18e3>>3]=0.0;i=i;return}function l6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17992>>3]=0.0;i=i;return}function m6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17984>>3]=0.0;i=i;return}function n6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17976>>3]=0.0;i=i;return}function o6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17968>>3]=0.0;i=i;return}function p6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21536>>3]=0.0;i=i;return}function q6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17960>>3]=0.0;i=i;return}function r6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17952>>3]=0.0;i=i;return}function s6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17944>>3]=0.0;i=i;return}function t6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17936>>3]=0.0;i=i;return}function u6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17928>>3]=0.0;i=i;return}function v6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17920>>3]=0.0;i=i;return}function w6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17912>>3]=0.0;i=i;return}function x6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17904>>3]=0.0;i=i;return}function y6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17896>>3]=0.0;i=i;return}function z6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17888>>3]=0.0;i=i;return}function A6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17880>>3]=0.0;i=i;return}function B6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17872>>3]=0.0;i=i;return}function C6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17864>>3]=0.0;i=i;return}function D6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17856>>3]=-.1;i=i;return}function E6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17848>>3]=0.0;i=i;return}function F6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17840>>3]=0.0;i=i;return}function G6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17832>>3]=0.0;i=i;return}function H6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17824>>3]=0.0;i=i;return}function I6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17816>>3]=0.0;i=i;return}function J6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17808>>3]=0.0;i=i;return}function K6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17800>>3]=0.0;i=i;return}function L6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17792>>3]=0.0;i=i;return}function M6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17784>>3]=0.0;i=i;return}function N6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17776>>3]=0.0;i=i;return}function O6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17768>>3]=0.0;i=i;return}function P6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17760>>3]=0.0;i=i;return}function Q6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17752>>3]=0.0;i=i;return}function R6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17744>>3]=0.0;i=i;return}function S6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17736>>3]=0.0;i=i;return}function T6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17728>>3]=0.0;i=i;return}function U6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17720>>3]=0.0;i=i;return}function V6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17712>>3]=0.0;i=i;return}function W6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17704>>3]=0.0;i=i;return}function X6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21528>>3]=0.0;i=i;return}function Y6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17696>>3]=0.0;i=i;return}function Z6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17688>>3]=0.0;i=i;return}function _6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17680>>3]=0.0;i=i;return}function $6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17672>>3]=0.0;i=i;return}function a7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17664>>3]=0.0;i=i;return}function b7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17656>>3]=0.0;i=i;return}function c7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17648>>3]=0.0;i=i;return}function d7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17640>>3]=0.0;i=i;return}function e7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17632>>3]=0.0;i=i;return}function f7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17624>>3]=0.0;i=i;return}function g7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17616>>3]=0.0;i=i;return}function h7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17608>>3]=0.0;i=i;return}function i7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17600>>3]=0.0;i=i;return}function j7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17592>>3]=0.0;i=i;return}function k7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17584>>3]=1.0;i=i;return}function l7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17576>>3]=0.0;i=i;return}function m7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17568>>3]=0.0;i=i;return}function n7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17560>>3]=0.0;i=i;return}function o7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17552>>3]=1.0;i=i;return}function p7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17544>>3]=1.0;i=i;return}function q7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17536>>3]=0.0;i=i;return}function r7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17528>>3]=0.0;i=i;return}function s7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17520>>3]=0.0;i=i;return}function t7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17512>>3]=0.0;i=i;return}function u7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17504>>3]=0.0;i=i;return}function v7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17496>>3]=0.0;i=i;return}function w7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21520>>3]=0.0;i=i;return}function x7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17488>>3]=0.0;i=i;return}function y7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17472>>3]=0.0;i=i;return}function z7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17464>>3]=0.0;i=i;return}function A7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17456>>3]=0.0;i=i;return}function B7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17448>>3]=0.0;i=i;return}function C7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17440>>3]=0.0;i=i;return}function D7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17432>>3]=0.0;i=i;return}function E7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17424>>3]=0.0;i=i;return}function F7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17416>>3]=0.0;i=i;return}function G7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17408>>3]=0.0;i=i;return}function H7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17400>>3]=0.0;i=i;return}function I7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17392>>3]=0.0;i=i;return}function J7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17384>>3]=0.0;i=i;return}function K7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17376>>3]=0.0;i=i;return}function L7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17368>>3]=0.0;i=i;return}function M7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17360>>3]=0.0;i=i;return}function N7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17352>>3]=1.0;i=i;return}function O7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17344>>3]=0.0;i=i;return}function P7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17336>>3]=0.0;i=i;return}function Q7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17328>>3]=0.0;i=i;return}function R7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17320>>3]=1.0;i=i;return}function S7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17312>>3]=1.0;i=i;return}function T7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17304>>3]=0.0;i=i;return}function U7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17296>>3]=0.0;i=i;return}function V7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17288>>3]=0.0;i=i;return}function W7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17280>>3]=0.0;i=i;return}function X7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17272>>3]=0.0;i=i;return}function Y7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17264>>3]=0.0;i=i;return}function Z7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21512>>3]=0.0;i=i;return}function _7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17256>>3]=0.0;i=i;return}function $7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17240>>3]=0.0;i=i;return}function a8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17232>>3]=0.0;i=i;return}function b8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17224>>3]=0.0;i=i;return}function c8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17216>>3]=0.0;i=i;return}function d8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17208>>3]=0.0;i=i;return}function e8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17200>>3]=0.0;i=i;return}function f8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17192>>3]=0.0;i=i;return}function g8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17184>>3]=0.0;i=i;return}function h8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17176>>3]=0.0;i=i;return}function i8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17168>>3]=0.0;i=i;return}function j8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17160>>3]=0.0;i=i;return}function k8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17152>>3]=0.0;i=i;return}function l8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17144>>3]=0.0;i=i;return}function m8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17136>>3]=0.0;i=i;return}function n8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17128>>3]=0.0;i=i;return}function o8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17120>>3]=1.0;i=i;return}function p8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17112>>3]=0.0;i=i;return}function q8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17104>>3]=0.0;i=i;return}function r8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17096>>3]=0.0;i=i;return}function s8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17088>>3]=1.0;i=i;return}function t8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17080>>3]=1.0;i=i;return}function u8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17072>>3]=0.0;i=i;return}function v8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17064>>3]=0.0;i=i;return}function w8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17056>>3]=0.0;i=i;return}function x8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17048>>3]=0.0;i=i;return}function y8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17040>>3]=0.0;i=i;return}function z8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17032>>3]=0.0;i=i;return}function A8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21504>>3]=0.0;i=i;return}function B8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17024>>3]=0.0;i=i;return}function C8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17008>>3]=0.0;i=i;return}function D8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17e3>>3]=0.0;i=i;return}function E8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16992>>3]=0.0;i=i;return}function F8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16984>>3]=0.0;i=i;return}function G8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16976>>3]=0.0;i=i;return}function H8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16968>>3]=0.0;i=i;return}function I8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16960>>3]=0.0;i=i;return}function J8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16952>>3]=0.0;i=i;return}function K8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16944>>3]=0.0;i=i;return}function L8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16936>>3]=0.0;i=i;return}function M8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16928>>3]=0.0;i=i;return}function N8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16920>>3]=0.0;i=i;return}function O8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16912>>3]=0.0;i=i;return}function P8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16904>>3]=0.0;i=i;return}function Q8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16896>>3]=0.0;i=i;return}function R8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16888>>3]=1.0;i=i;return}function S8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16880>>3]=0.0;i=i;return}function T8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16872>>3]=0.0;i=i;return}function U8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16864>>3]=0.0;i=i;return}function V8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16856>>3]=1.0;i=i;return}function W8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16848>>3]=1.0;i=i;return}function X8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16840>>3]=0.0;i=i;return}function Y8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16832>>3]=0.0;i=i;return}function Z8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16824>>3]=0.0;i=i;return}function _8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16816>>3]=0.0;i=i;return}function $8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16808>>3]=0.0;i=i;return}function a9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16800>>3]=0.0;i=i;return}function b9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21496>>3]=0.0;i=i;return}function c9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16792>>3]=0.0;i=i;return}function d9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16776>>3]=0.0;i=i;return}function e9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16768>>3]=0.0;i=i;return}function f9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16760>>3]=0.0;i=i;return}function g9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16752>>3]=0.0;i=i;return}function h9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16744>>3]=0.0;i=i;return}function i9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16736>>3]=0.0;i=i;return}function j9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16728>>3]=0.0;i=i;return}function k9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16720>>3]=0.0;i=i;return}function l9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16712>>3]=0.0;i=i;return}function m9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16704>>3]=0.0;i=i;return}function n9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16696>>3]=0.0;i=i;return}function o9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16688>>3]=0.0;i=i;return}function p9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16680>>3]=0.0;i=i;return}function q9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16672>>3]=0.0;i=i;return}function r9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16664>>3]=0.0;i=i;return}function s9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16656>>3]=1.0;i=i;return}function t9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16648>>3]=0.0;i=i;return}function u9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16640>>3]=0.0;i=i;return}function v9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16632>>3]=0.0;i=i;return}function w9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16624>>3]=1.0;i=i;return}function x9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16616>>3]=1.0;i=i;return}function y9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16608>>3]=0.0;i=i;return}function z9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16600>>3]=0.0;i=i;return}function A9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16592>>3]=0.0;i=i;return}function B9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16584>>3]=0.0;i=i;return}function C9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16576>>3]=0.0;i=i;return}function D9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16568>>3]=0.0;i=i;return}function E9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21488>>3]=0.0;i=i;return}function F9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16560>>3]=0.0;i=i;return}function G9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16544>>3]=0.0;i=i;return}function H9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16536>>3]=0.0;i=i;return}function I9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16528>>3]=0.0;i=i;return}function J9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16520>>3]=0.0;i=i;return}function K9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16512>>3]=0.0;i=i;return}function L9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16504>>3]=0.0;i=i;return}function M9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16496>>3]=0.0;i=i;return}function N9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16488>>3]=0.0;i=i;return}function O9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16480>>3]=0.0;i=i;return}function P9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16472>>3]=0.0;i=i;return}function Q9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16464>>3]=0.0;i=i;return}function R9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16456>>3]=0.0;i=i;return}function S9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16448>>3]=0.0;i=i;return}function T9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16440>>3]=0.0;i=i;return}function U9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16432>>3]=0.0;i=i;return}function V9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16424>>3]=1.0;i=i;return}function W9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16416>>3]=0.0;i=i;return}function X9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16408>>3]=0.0;i=i;return}function Y9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16400>>3]=0.0;i=i;return}function Z9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16392>>3]=1.0;i=i;return}function _9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16384>>3]=1.0;i=i;return}function $9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16376>>3]=0.0;i=i;return}function aaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16368>>3]=0.0;i=i;return}function baa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16360>>3]=0.0;i=i;return}function caa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16352>>3]=0.0;i=i;return}function daa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16344>>3]=0.0;i=i;return}function eaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16336>>3]=0.0;i=i;return}function faa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21480>>3]=0.0;i=i;return}function gaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16328>>3]=0.0;i=i;return}function haa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16312>>3]=0.0;i=i;return}function iaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16304>>3]=0.0;i=i;return}function jaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16296>>3]=0.0;i=i;return}function kaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16288>>3]=0.0;i=i;return}function laa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16280>>3]=0.0;i=i;return}function maa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16272>>3]=0.0;i=i;return}function naa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16264>>3]=0.0;i=i;return}function oaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16256>>3]=1.0;i=i;return}function paa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16248>>3]=0.0;i=i;return}function qaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16240>>3]=0.0;i=i;return}function raa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16168>>3]=1.0;i=i;return}function saa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16176>>3]=0.0;i=i;return}function taa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16184>>3]=0.0;i=i;return}function uaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16192>>3]=0.0;i=i;return}function vaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16216>>3]=0.0;i=i;return}function waa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16144>>3]=0.0;i=i;return}function xaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16152>>3]=0.0;i=i;return}function yaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16160>>3]=0.0;i=i;return}function zaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16120>>3]=0.0;i=i;return}function Aaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16128>>3]=0.0;i=i;return}function Baa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16136>>3]=0.0;i=i;return}function Caa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16088>>3]=0.0;i=i;return}function Daa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16080>>3]=.8660254037844387;i=i;return}function Eaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16072>>3]=-.4999999999999999;i=i;return}function Faa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16064>>3]=0.0;i=i;return}function Gaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16056>>3]=.4999999999999999;i=i;return}function Haa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16048>>3]=.8660254037844387;i=i;return}function Iaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16024>>3]=0.0;i=i;return}function Jaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16e3>>3]=0.0;i=i;return}function Kaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16008>>3]=0.0;i=i;return}function Laa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16016>>3]=0.0;i=i;return}function Maa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15992>>3]=0.0;i=i;return}function Naa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15984>>3]=.8660254037844387;i=i;return}function Oaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15976>>3]=.4999999999999999;i=i;return}function Paa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15968>>3]=0.0;i=i;return}function Qaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15960>>3]=-.4999999999999999;i=i;return}function Raa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15952>>3]=.8660254037844387;i=i;return}function Saa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15928>>3]=0.0;i=i;return}function Taa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15904>>3]=0.0;i=i;return}function Uaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15912>>3]=0.0;i=i;return}function Vaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15920>>3]=0.0;i=i;return}function Waa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15896>>3]=0.0;i=i;return}function Xaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15888>>3]=.8660254037844387;i=i;return}function Yaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15880>>3]=-.4999999999999999;i=i;return}function Zaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15872>>3]=0.0;i=i;return}function _aa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15864>>3]=.4999999999999999;i=i;return}function $aa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15856>>3]=.8660254037844387;i=i;return}function aba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15832>>3]=0.0;i=i;return}function bba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15808>>3]=0.0;i=i;return}function cba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15816>>3]=0.0;i=i;return}function dba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15824>>3]=0.0;i=i;return}function eba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15800>>3]=0.0;i=i;return}function fba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15792>>3]=.8660254037844387;i=i;return}function gba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15784>>3]=.4999999999999999;i=i;return}function hba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15776>>3]=0.0;i=i;return}function iba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15768>>3]=-.4999999999999999;i=i;return}function jba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15760>>3]=.8660254037844387;i=i;return}function kba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15736>>3]=0.0;i=i;return}function lba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15712>>3]=0.0;i=i;return}function mba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15720>>3]=0.0;i=i;return}function nba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15728>>3]=0.0;i=i;return}function oba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15704>>3]=0.0;i=i;return}function pba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15696>>3]=.8660254037844387;i=i;return}function qba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15688>>3]=-.4999999999999999;i=i;return}function rba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15680>>3]=0.0;i=i;return}function sba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15672>>3]=.4999999999999999;i=i;return}function tba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15664>>3]=.8660254037844387;i=i;return}function uba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15640>>3]=0.0;i=i;return}function vba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15616>>3]=0.0;i=i;return}function wba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15624>>3]=0.0;i=i;return}function xba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15632>>3]=0.0;i=i;return}function yba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15592>>3]=0.0;i=i;return}function zba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15600>>3]=0.0;i=i;return}function Aba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15608>>3]=0.0;i=i;return}function Bba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15568>>3]=0.0;i=i;return}function Cba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15576>>3]=0.0;i=i;return}function Dba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15584>>3]=0.0;i=i;return}function Eba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15560>>3]=0.0;i=i;return}function Fba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15552>>3]=.8660254037844387;i=i;return}function Gba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15544>>3]=.4999999999999999;i=i;return}function Hba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15536>>3]=0.0;i=i;return}function Iba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15528>>3]=-.4999999999999999;i=i;return}function Jba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15520>>3]=.8660254037844387;i=i;return}function Kba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15496>>3]=0.0;i=i;return}function Lba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15472>>3]=0.0;i=i;return}function Mba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15480>>3]=0.0;i=i;return}function Nba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15488>>3]=0.0;i=i;return}function Oba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15464>>3]=0.0;i=i;return}function Pba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15440>>3]=0.0;i=i;return}function Qba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15456>>3]=0.0;i=i;return}function Rba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15424>>3]=0.0;i=i;return}function Sba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15400>>3]=0.0;i=i;return}function Tba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15416>>3]=0.0;i=i;return}function Uba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15384>>3]=0.0;i=i;return}function Vba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15360>>3]=0.0;i=i;return}function Wba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15376>>3]=0.0;i=i;return}function Xba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15344>>3]=0.0;i=i;return}function Yba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15320>>3]=0.0;i=i;return}function Zba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15336>>3]=0.0;i=i;return}function _ba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15304>>3]=0.0;i=i;return}function $ba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15280>>3]=0.0;i=i;return}function aca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15296>>3]=0.0;i=i;return}function bca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15264>>3]=0.0;i=i;return}function cca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15240>>3]=0.0;i=i;return}function dca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15256>>3]=0.0;i=i;return}function eca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15080>>3]=0.0;i=i;return}function fca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15072>>3]=0.0;i=i;return}function gca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15032>>3]=0.0;i=i;return}function hca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15024>>3]=0.0;i=i;return}function ica(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14984>>3]=0.0;i=i;return}function jca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14976>>3]=0.0;i=i;return}function kca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14936>>3]=0.0;i=i;return}function lca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14928>>3]=0.0;i=i;return}function mca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14888>>3]=0.0;i=i;return}function nca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14880>>3]=0.0;i=i;return}function oca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14840>>3]=0.0;i=i;return}function pca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14832>>3]=0.0;i=i;return}function qca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14792>>3]=0.0;i=i;return}function rca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14784>>3]=0.0;i=i;return}function sca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14776>>3]=0.0;i=i;return}function tca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14768>>3]=0.0;i=i;return}function uca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14760>>3]=0.0;i=i;return}function vca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14752>>3]=0.0;i=i;return}function wca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14744>>3]=0.0;i=i;return}function xca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14736>>3]=0.0;i=i;return}function yca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14728>>3]=0.0;i=i;return}function zca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14720>>3]=0.0;i=i;return}function Aca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14712>>3]=0.0;i=i;return}function Bca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14704>>3]=0.0;i=i;return}function Cca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14696>>3]=1.0;i=i;return}function Dca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14672>>3]=0.0;i=i;return}function Eca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14648>>3]=0.0;i=i;return}function Fca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14688>>3]=0.0;i=i;return}function Gca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14664>>3]=1.0;i=i;return}function Hca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14640>>3]=0.0;i=i;return}function Ica(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14680>>3]=0.0;i=i;return}function Jca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14656>>3]=0.0;i=i;return}function Kca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14632>>3]=1.0;i=i;return}function Lca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14624>>3]=0.0;i=i;return}function Mca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14616>>3]=0.0;i=i;return}function Nca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14608>>3]=0.0;i=i;return}function Oca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14600>>3]=0.0;i=i;return}function Pca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14592>>3]=0.0;i=i;return}function Qca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14584>>3]=0.0;i=i;return}function Rca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14576>>3]=0.0;i=i;return}function Sca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14568>>3]=0.0;i=i;return}function Tca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14560>>3]=0.0;i=i;return}function Uca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14552>>3]=0.0;i=i;return}function Vca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14544>>3]=0.0;i=i;return}function Wca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14536>>3]=0.0;i=i;return}function Xca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14528>>3]=1.0;i=i;return}function Yca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14504>>3]=0.0;i=i;return}



function Fbc(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function Gbc(a){a=a|0;i=i;return 4}function Hbc(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function Ibc(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=Jbc(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function Jbc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function Kbc(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=Lbc(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function Lbc(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function Mbc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function Nbc(a){a=a|0;i=i;return 0}function Obc(a){a=a|0;i=i;return 0}function Pbc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=Qbc(c,d,e,1114111,0)|0;i=b;return a|0}function Qbc(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function Rbc(a){a=a|0;i=i;return 4}function Sbc(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function Tbc(a){a=a|0;var b=0;b=i;iec(a);i=b;return}function Ubc(a){a=a|0;var b=0;b=i;c[a>>2]=304936;X3b(a+12|0);iec(a);i=b;return}function Vbc(a){a=a|0;var b=0;b=i;c[a>>2]=304936;X3b(a+12|0);i=b;return}function Wbc(a){a=a|0;var b=0;b=i;c[a>>2]=304976;X3b(a+16|0);iec(a);i=b;return}function Xbc(a){a=a|0;var b=0;b=i;c[a>>2]=304976;X3b(a+16|0);i=b;return}function Ybc(b){b=b|0;i=i;return a[b+8|0]|0}function Zbc(a){a=a|0;i=i;return c[a+8>>2]|0}function _bc(b){b=b|0;i=i;return a[b+9|0]|0}function $bc(a){a=a|0;i=i;return c[a+12>>2]|0}function acc(a,b){a=a|0;b=b|0;var c=0;c=i;N3b(a,b+12|0);i=c;return}function bcc(a,b){a=a|0;b=b|0;var c=0;c=i;N3b(a,b+16|0);i=c;return}function ccc(a,b){a=a|0;b=b|0;b=i;P3b(a,305008,4);i=b;return}function dcc(a,b){a=a|0;b=b|0;b=i;x4b(a,305016,Cdc(305016)|0);i=b;return}function ecc(a,b){a=a|0;b=b|0;b=i;P3b(a,305040,5);i=b;return}function fcc(a,b){a=a|0;b=b|0;b=i;x4b(a,305048,Cdc(305048)|0);i=b;return}function gcc(b){b=b|0;var d=0,e=0;b=i;if((a[305080]|0)!=0){d=305072;e=c[76268]|0;i=b;return e|0}if((Xa(305080)|0)==0){d=305072;e=c[76268]|0;i=b;return e|0}do{if((a[312280]|0)==0){if((Xa(312280)|0)==0){break}Iec(312112,0,168)|0;Xd(489,0,q|0)|0;Rb(312280)}}while(0);_3b(312112,312288)|0;_3b(312124|0,312296)|0;_3b(312136|0,312304)|0;_3b(312148|0,312312)|0;_3b(312160|0,312328)|0;_3b(312172|0,312344)|0;_3b(312184|0,312352)|0;_3b(312196|0,312368)|0;_3b(312208|0,312376)|0;_3b(312220|0,312384)|0;_3b(312232|0,312392)|0;_3b(312244|0,312400)|0;_3b(312256|0,312408)|0;_3b(312268|0,312416)|0;c[76268]=312112;Rb(305080);d=305072;e=c[76268]|0;i=b;return e|0}function hcc(b){b=b|0;var d=0,e=0;b=i;if((a[305096]|0)!=0){d=305088;e=c[76272]|0;i=b;return e|0}if((Xa(305096)|0)==0){d=305088;e=c[76272]|0;i=b;return e|0}do{if((a[311744]|0)==0){if((Xa(311744)|0)==0){break}Iec(311576,0,168)|0;Xd(490,0,q|0)|0;Rb(311744)}}while(0);A4b(311576,311752)|0;A4b(311588|0,311784)|0;A4b(311600|0,311816)|0;A4b(311612|0,311848)|0;A4b(311624|0,311888)|0;A4b(311636|0,311928)|0;A4b(311648|0,311960)|0;A4b(311660|0,312e3)|0;A4b(311672|0,312016)|0;A4b(311684|0,312032)|0;A4b(311696|0,312048)|0;A4b(311708|0,312064)|0;A4b(311720|0,312080)|0;A4b(311732|0,312096)|0;c[76272]=311576;Rb(305096);d=305088;e=c[76272]|0;i=b;return e|0}function icc(b){b=b|0;var d=0,e=0;b=i;if((a[305112]|0)!=0){d=305104;e=c[76276]|0;i=b;return e|0}if((Xa(305112)|0)==0){d=305104;e=c[76276]|0;i=b;return e|0}do{if((a[311352]|0)==0){if((Xa(311352)|0)==0){break}Iec(311064,0,288)|0;Xd(491,0,q|0)|0;Rb(311352)}}while(0);_3b(311064,311360)|0;_3b(311076|0,311368)|0;_3b(311088|0,311384)|0;_3b(311100|0,311392)|0;_3b(311112|0,311400)|0;_3b(311124|0,311408)|0;_3b(311136|0,311416)|0;_3b(311148|0,311424)|0;_3b(311160|0,311432)|0;_3b(311172|0,311448)|0;_3b(311184|0,311456)|0;_3b(311196|0,311472)|0;_3b(311208|0,311488)|0;_3b(311220|0,311496)|0;_3b(311232|0,311504)|0;_3b(311244|0,311512)|0;_3b(311256|0,311400)|0;_3b(311268|0,311520)|0;_3b(311280|0,311528)|0;_3b(311292|0,311536)|0;_3b(311304|0,311544)|0;_3b(311316|0,311552)|0;_3b(311328|0,311560)|0;_3b(311340|0,311568)|0;c[76276]=311064;Rb(305112);d=305104;e=c[76276]|0;i=b;return e|0}function jcc(b){b=b|0;var d=0,e=0;b=i;if((a[305128]|0)!=0){d=305120;e=c[76280]|0;i=b;return e|0}if((Xa(305128)|0)==0){d=305120;e=c[76280]|0;i=b;return e|0}do{if((a[310512]|0)==0){if((Xa(310512)|0)==0){break}Iec(310224,0,288)|0;Xd(492,0,q|0)|0;Rb(310512)}}while(0);A4b(310224,310520)|0;A4b(310236|0,310552)|0;A4b(310248|0,310592)|0;A4b(310260|0,310616)|0;A4b(310272|0,310936)|0;A4b(310284|0,310640)|0;A4b(310296|0,310664)|0;A4b(310308|0,310688)|0;A4b(310320|0,310720)|0;A4b(310332|0,310760)|0;A4b(310344|0,310792)|0;A4b(310356|0,310832)|0;A4b(310368|0,310872)|0;A4b(310380|0,310888)|0;A4b(310392|0,310904)|0;A4b(310404|0,310920)|0;A4b(310416|0,310936)|0;A4b(310428|0,310952)|0;A4b(310440|0,310968)|0;A4b(310452|0,310984)|0;A4b(310464|0,311e3)|0;A4b(310476|0,311016)|0;A4b(310488|0,311032)|0;A4b(310500|0,311048)|0;c[76280]=310224;Rb(305128);d=305120;e=c[76280]|0;i=b;return e|0}function kcc(b){b=b|0;var d=0,e=0;b=i;if((a[305144]|0)!=0){d=305136;e=c[76284]|0;i=b;return e|0}if((Xa(305144)|0)==0){d=305136;e=c[76284]|0;i=b;return e|0}do{if((a[310200]|0)==0){if((Xa(310200)|0)==0){break}Iec(309912,0,288)|0;Xd(493,0,q|0)|0;Rb(310200)}}while(0);_3b(309912,310208)|0;_3b(309924|0,310216)|0;c[76284]=309912;Rb(305144);d=305136;e=c[76284]|0;i=b;return e|0}function lcc(b){b=b|0;var d=0,e=0;b=i;if((a[305160]|0)!=0){d=305152;e=c[76288]|0;i=b;return e|0}if((Xa(305160)|0)==0){d=305152;e=c[76288]|0;i=b;return e|0}do{if((a[309872]|0)==0){if((Xa(309872)|0)==0){break}Iec(309584,0,288)|0;Xd(494,0,q|0)|0;Rb(309872)}}while(0);A4b(309584,309880)|0;A4b(309596|0,309896)|0;c[76288]=309584;Rb(305160);d=305152;e=c[76288]|0;i=b;return e|0}function mcc(b){b=b|0;var c=0;b=i;if((a[305184]|0)!=0){c=305168;i=b;return c|0}if((Xa(305184)|0)==0){c=305168;i=b;return c|0}P3b(305168,305192,8);Xd(495,305168,q|0)|0;Rb(305184);c=305168;i=b;return c|0}function ncc(b){b=b|0;var c=0;b=i;if((a[305224]|0)!=0){c=305208;i=b;return c|0}if((Xa(305224)|0)==0){c=305208;i=b;return c|0}x4b(305208,305232,Cdc(305232)|0);Xd(496,305208,q|0)|0;Rb(305224);c=305208;i=b;return c|0}function occ(b){b=b|0;var c=0;b=i;if((a[305288]|0)!=0){c=305272;i=b;return c|0}if((Xa(305288)|0)==0){c=305272;i=b;return c|0}P3b(305272,305296,8);Xd(495,305272,q|0)|0;Rb(305288);c=305272;i=b;return c|0}function pcc(b){b=b|0;var c=0;b=i;if((a[305328]|0)!=0){c=305312;i=b;return c|0}if((Xa(305328)|0)==0){c=305312;i=b;return c|0}x4b(305312,305336,Cdc(305336)|0);Xd(496,305312,q|0)|0;Rb(305328);c=305312;i=b;return c|0}function qcc(b){b=b|0;var c=0;b=i;if((a[305392]|0)!=0){c=305376;i=b;return c|0}if((Xa(305392)|0)==0){c=305376;i=b;return c|0}P3b(305376,305400,20);Xd(495,305376,q|0)|0;Rb(305392);c=305376;i=b;return c|0}function rcc(b){b=b|0;var c=0;b=i;if((a[305440]|0)!=0){c=305424;i=b;return c|0}if((Xa(305440)|0)==0){c=305424;i=b;return c|0}x4b(305424,305448,Cdc(305448)|0);Xd(496,305424,q|0)|0;Rb(305440);c=305424;i=b;return c|0}function scc(b){b=b|0;var c=0;b=i;if((a[305552]|0)!=0){c=305536;i=b;return c|0}if((Xa(305552)|0)==0){c=305536;i=b;return c|0}P3b(305536,305560,11);Xd(495,305536,q|0)|0;Rb(305552);c=305536;i=b;return c|0}function tcc(b){b=b|0;var c=0;b=i;if((a[305592]|0)!=0){c=305576;i=b;return c|0}if((Xa(305592)|0)==0){c=305576;i=b;return c|0}x4b(305576,305600,Cdc(305600)|0);Xd(496,305576,q|0)|0;Rb(305592);c=305576;i=b;return c|0}function ucc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Lc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);l=+yec(b,g,c[76164]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function vcc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Lc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);l=+yec(b,g,c[76164]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function wcc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Lc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);l=+yec(b,g,c[76164]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function xcc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Lc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);n=jb(b|0,h|0,f|0,c[76164]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function ycc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Lc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);m=jb(b|0,h|0,f|0,c[76164]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function zcc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Lc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);m=jb(b|0,h|0,f|0,c[76164]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function Acc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Lc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);m=jb(b|0,h|0,f|0,c[76164]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function Bcc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Lc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);n=Ec(b|0,h|0,f|0,c[76164]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function Ccc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Lc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[304664]|0)==0){if((Xa(304664)|0)==0){break}c[76164]=Xb(2147483647,304672,0)|0;Rb(304664)}}while(0);m=Ec(b|0,h|0,f|0,c[76164]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function Dcc(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;de[h&511](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;de[h&511](a);i=b;return}}function Ecc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){xac(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=gec(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;Gec(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{iec(h);i=e;return}}function Fcc(a){a=a|0;a=i;z4b(309860|0);z4b(309848|0);z4b(309836|0);z4b(309824|0);z4b(309812|0);z4b(309800|0);z4b(309788|0);z4b(309776|0);z4b(309764|0);z4b(309752|0);z4b(309740|0);z4b(309728|0);z4b(309716|0);z4b(309704|0);z4b(309692|0);z4b(309680|0);z4b(309668|0);z4b(309656|0);z4b(309644|0);z4b(309632|0);z4b(309620|0);z4b(309608|0);z4b(309596|0);z4b(309584);i=a;return}function Gcc(a){a=a|0;a=i;X3b(310188|0);X3b(310176|0);X3b(310164|0);X3b(310152|0);X3b(310140|0);X3b(310128|0);X3b(310116|0);X3b(310104|0);X3b(310092|0);X3b(310080|0);X3b(310068|0);X3b(310056|0);X3b(310044|0);X3b(310032|0);X3b(310020|0);X3b(310008|0);X3b(309996|0);X3b(309984|0);X3b(309972|0);X3b(309960|0);X3b(309948|0);X3b(309936|0);X3b(309924|0);X3b(309912);i=a;return}function Hcc(a){a=a|0;a=i;z4b(310500|0);z4b(310488|0);z4b(310476|0);z4b(310464|0);z4b(310452|0);z4b(310440|0);z4b(310428|0);z4b(310416|0);z4b(310404|0);z4b(310392|0);z4b(310380|0);z4b(310368|0);z4b(310356|0);z4b(310344|0);z4b(310332|0);z4b(310320|0);z4b(310308|0);z4b(310296|0);z4b(310284|0);z4b(310272|0);z4b(310260|0);z4b(310248|0);z4b(310236|0);z4b(310224);i=a;return}function Icc(a){a=a|0;a=i;X3b(311340|0);X3b(311328|0);X3b(311316|0);X3b(311304|0);X3b(311292|0);X3b(311280|0);X3b(311268|0);X3b(311256|0);X3b(311244|0);X3b(311232|0);X3b(311220|0);X3b(311208|0);X3b(311196|0);X3b(311184|0);X3b(311172|0);X3b(311160|0);X3b(311148|0);X3b(311136|0);X3b(311124|0);X3b(311112|0);X3b(311100|0);X3b(311088|0);X3b(311076|0);X3b(311064);i=a;return}function Jcc(a){a=a|0;a=i;z4b(311732|0);z4b(311720|0);z4b(311708|0);z4b(311696|0);z4b(311684|0);z4b(311672|0);z4b(311660|0);z4b(311648|0);z4b(311636|0);z4b(311624|0);z4b(311612|0);z4b(311600|0);z4b(311588|0);z4b(311576);i=a;return}function Kcc(a){a=a|0;a=i;X3b(312268|0);X3b(312256|0);X3b(312244|0);X3b(312232|0);X3b(312220|0);X3b(312208|0);X3b(312196|0);X3b(312184|0);X3b(312172|0);X3b(312160|0);X3b(312148|0);X3b(312136|0);X3b(312124|0);X3b(312112);i=a;return}function Lcc(a){a=a|0;var b=0,c=0;b=i;if((Rcc(a)|0)==0){c=(Mcc(a)|0)!=0|0}else{c=1}i=b;return c|0}function Mcc(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[312424+((d[312424+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function Ncc(a){a=a|0;var b=0,c=0;b=i;c=vb(a|0)|0;i=b;return c|0}function Occ(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function Pcc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 9:{d=Vcc(a)|0;break};case 5:{d=Rcc(a)|0;break};case 11:{d=Xcc(a)|0;break};case 10:{d=Wcc(a)|0;break};case 3:{d=Ncc(a)|0;break};case 7:{d=Tcc(a)|0;break};case 6:{d=Scc(a)|0;break};case 12:{d=Ycc(a)|0;break};case 2:{d=Mcc(a)|0;break};case 1:{d=Lcc(a)|0;break};case 8:{d=Ucc(a)|0;break};case 4:{d=Occ(a)|0;break};default:{d=0}}i=c;return d|0}function Qcc(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=315400;while(1){if(d<<24>>24==e<<24>>24){if((Aec(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function Rcc(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function Scc(a){a=a|0;var b=0,c=0;b=i;if((Wcc(a)|0)==0){c=(Ucc(a)|0)!=0|0}else{c=0}i=b;return c|0}function Tcc(a){a=a|0;var b=0,c=0;b=i;if((Zcc(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function Ucc(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function Vcc(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[315480+((d[315480+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function Wcc(a){a=a|0;var b=0,c=0;b=i;c=(Bdc(318648,a)|0)!=0|0;i=b;return c|0}function Xcc(a){a=a|0;var b=0,c=0;b=i;c=($cc(a)|0)!=(a|0)|0;i=b;return c|0}function Ycc(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function Zcc(a){a=a|0;var b=0,c=0;b=i;c=_cc(a,0)|0;i=b;return c|0}function _cc(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((Mcc(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[318738+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[318736+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[318739+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[318984+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[318984+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[318984+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function $cc(a){a=a|0;var b=0,c=0;b=i;c=_cc(a,1)|0;i=b;return c|0}function adc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=bdc(0,a,b,(c|0)!=0?c:319688)|0;i=d;return e|0}function bdc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?319696:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[319480+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Lc()|0)>>2]=84;k=-1;i=g;return k|0}function cdc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=ddc(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=bdc(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==-1){C=-1;break}else if((I|0)==0){c[h>>2]=0;C=G;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function ddc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[319480+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[319480+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Lc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function edc(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[319480+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Lc()|0)>>2]=84;j=-1;i=g;return j|0}function fdc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Lc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function gdc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=hdc(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=fdc(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function hdc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=fdc(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=fdc(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=fdc(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}fdc(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function idc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=aec(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=aec(2048)|0;c[p+16>>2]=s;if((s|0)==0){bec(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=ydc(0,0)|0;if((s|0)==0){bec(c[p+16>>2]|0);bec(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=jdc(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=cec(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=kdc(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=aec(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;Iec(y|0,-1,v|0)|0;I=H}else{I=0}H=cec(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=cec(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=kdc(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=qdc(q,x)|0;b:do{if((v|0)==0){y=qdc(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;V=c[Q+(U<<2)>>2]|0;c[j>>2]=V;U=T+4|0;W=c[U>>2]|0;do{if((W|0)>1){c[l>>2]=0;X=T;F=51}else{if((c[T+8>>2]|0)<=1){Y=V;break}c[l>>2]=0;Z=T;if((W|0)>0){X=Z;F=51}else{_=W;$=Z;aa=V;ba=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;Z=V;ca=W;da=1;ea=0;while(1){fa=rdc(s,q,c[X>>2]|0,(da|0)<(ca|0)?1:2,j,G,m,k)|0;if((fa|0)!=0){J=fa;break b}fa=c[m>>2]|0;if((ea|0)==0){ga=fa}else{ha=Adc(s,0,0,1,32)|0;if((ha|0)==0){J=12;break b}ia=Adc(s,0,0,1,8)|0;ja=ha+4|0;c[ja>>2]=ia;if((ia|0)==0){J=12;break b}c[ha>>2]=1;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[ia>>2]=ea;c[(c[ja>>2]|0)+4>>2]=fa;c[ha+16>>2]=(c[fa+16>>2]|0)+(c[ea+16>>2]|0);ga=ha}if((ga|0)==0){J=12;break b}ha=c[U>>2]|0;if((da|0)>=(ha|0)){_=ha;$=X;aa=Z;ba=ga;F=60;break e}Z=c[j>>2]|0;ca=ha;da=da+1|0;ea=ga}}}while(0);if((F|0)==60){F=0;U=T+8|0;W=c[U>>2]|0;do{if((W|0)==-1){ea=c[j>>2]|0;da=rdc(s,q,c[$>>2]|0,0,j,0,l,k)|0;if((da|0)!=0){J=da;break b}da=c[l>>2]|0;ca=Adc(s,0,0,1,32)|0;Z=ca;if((ca|0)==0){F=65;break d}ha=Adc(s,0,0,1,16)|0;c[ca+4>>2]=ha;if((ha|0)==0){F=65;break d}c[ca>>2]=2;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[ha>>2]=da;c[ha+4>>2]=0;c[ha+8>>2]=-1;fa=ha+12|0;a[fa]=a[fa]&-2;c[ca+16>>2]=c[da+16>>2];c[l>>2]=Z;ka=Z;la=ea}else{if((_|0)<(W|0)){ma=0;na=_}else{ka=0;la=aa;break}while(1){ea=c[j>>2]|0;Z=rdc(s,q,c[$>>2]|0,0,j,0,n,k)|0;if((Z|0)!=0){J=Z;break b}Z=c[n>>2]|0;if((ma|0)==0){oa=Z}else{da=Adc(s,0,0,1,32)|0;if((da|0)==0){F=73;break d}ca=Adc(s,0,0,1,8)|0;fa=da+4|0;c[fa>>2]=ca;if((ca|0)==0){F=73;break d}c[da>>2]=1;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ca>>2]=Z;c[(c[fa>>2]|0)+4>>2]=ma;c[da+16>>2]=(c[ma+16>>2]|0)+(c[Z+16>>2]|0);oa=da}c[l>>2]=oa;if((oa|0)==0){J=12;break b}da=Adc(s,0,0,1,32)|0;if((da|0)==0){J=12;break b}Z=Adc(s,0,0,1,20)|0;c[da+4>>2]=Z;if((Z|0)==0){J=12;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Z>>2]=-1;c[Z+4>>2]=-1;c[Z+8>>2]=-1;Z=Adc(s,0,0,1,32)|0;fa=Z;if((Z|0)==0){F=79;break d}ca=Adc(s,0,0,1,8)|0;ha=Z+4|0;c[ha>>2]=ca;if((ca|0)==0){F=79;break d}c[Z>>2]=3;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[ca>>2]=da;c[(c[ha>>2]|0)+4>>2]=oa;c[Z+16>>2]=(c[oa+16>>2]|0)+(c[da+16>>2]|0);c[l>>2]=fa;da=na+1|0;if((da|0)<(c[U>>2]|0)){ma=fa;na=da}else{ka=fa;la=ea;break}}}}while(0);c[j>>2]=la;do{if((ba|0)==0){pa=ka;F=85}else{if((ka|0)==0){qa=ba;break}U=Adc(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}W=Adc(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=W;if((W|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[W>>2]=ba;c[(c[T>>2]|0)+4>>2]=ka;c[U+16>>2]=(c[ka+16>>2]|0)+(c[ba+16>>2]|0);pa=U;F=85}}while(0);if((F|0)==85){F=0;if((pa|0)==0){J=12;break b}else{qa=pa}}c[P>>2]=c[qa+4>>2];c[S>>2]=c[qa>>2];Y=la}U=M+ -1|0;T=Y-V+N|0;if((U|0)!=0){ra=Y;sa=U;ta=T;break}c[j>>2]=T;ra=T;sa=0;ta=T}else if((R|0)==0){T=c[S>>2]|0;if((T|0)==2){U=c[S+4>>2]|0;W=qdc(q,L)|0;if((W|0)!=0){ua=N;va=W;break c}W=qdc(q,S)|0;if((W|0)!=0){ua=N;va=W;break c}W=qdc(q,1)|0;if((W|0)!=0){ua=N;va=W;break c}W=qdc(q,c[U>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=qdc(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}if((c[U+4>>2]|0)>1){F=45}else{if((c[U+8>>2]|0)>1){F=45}else{wa=L}}if((F|0)==45){F=0;c[j>>2]=0;wa=0}ra=wa;sa=M+1|0;ta=N;break}else if((T|0)==1){U=c[S+4>>2]|0;W=qdc(q,c[U+4>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=qdc(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}W=qdc(q,c[U>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}xa=qdc(q,0)|0}else if((T|0)==0){W=c[S+4>>2]|0;U=c[W>>2]|0;if(!((U|0)>-1|(U|0)==-4)){ra=L;sa=M;ta=N;break}U=W+8|0;W=(c[U>>2]|0)+L|0;c[U>>2]=W;if((W|0)<=(c[k>>2]|0)){ra=L;sa=M;ta=N;break}c[k>>2]=W;ra=L;sa=M;ta=N;break}else if((T|0)==3){T=c[S+4>>2]|0;W=qdc(q,c[T+4>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=qdc(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}W=qdc(q,c[T>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}xa=qdc(q,0)|0}else{ra=L;sa=M;ta=N;break}if((xa|0)==0){ra=L;sa=M;ta=N}else{ua=N;va=xa;break c}}else{ra=L;sa=M;ta=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=ra;M=sa;N=ta;O=S}else{ua=ta;va=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{ua=0;va=0}}while(0);y=(c[H>>2]|0)+ua|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=va}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=Adc(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=Adc(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=Adc(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=Adc(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=qdc(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=qdc(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==3){M=c[ya+4>>2]|0;L=c[M>>2]|0;do{if((c[M+4>>2]|0)==0){F=141}else{if((c[L+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[L+24>>2];c[ya+28>>2]=c[(c[M>>2]|0)+28>>2]}else if((S|0)==1){R=c[ya+4>>2]|0;Q=c[R>>2]|0;W=R+4|0;T=c[W>>2]|0;if((c[Q+8>>2]|0)==0){za=(c[T+8>>2]|0)!=0|0}else{za=1}c[ya+8>>2]=za;U=odc(s,c[Q+24>>2]|0,c[T+24>>2]|0,0,0)|0;c[ya+24>>2]=U;if((U|0)==0){z=0;A=12;B=0;C=D;break a}U=odc(s,c[(c[R>>2]|0)+28>>2]|0,c[(c[W>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=U;if((U|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==0){U=c[ya>>2]|0;if((U|0)==1){W=qdc(q,ya)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=qdc(q,2)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=ya+4|0;R=qdc(q,c[(c[W>>2]|0)+4>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=qdc(q,0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=qdc(q,c[c[W>>2]>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=qdc(q,0)|0;if((R|0)==0){break}else{z=0;A=R;B=0;C=D;break a}}else if((U|0)==3){R=qdc(q,ya)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=qdc(q,1)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=ya+4|0;W=qdc(q,c[(c[R>>2]|0)+4>>2]|0)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=qdc(q,0)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=qdc(q,c[c[R>>2]>>2]|0)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=qdc(q,0)|0;if((W|0)==0){break}else{z=0;A=W;B=0;C=D;break a}}else if((U|0)==2){W=qdc(q,ya)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=qdc(q,3)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=qdc(q,c[c[ya+4>>2]>>2]|0)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=qdc(q,0)|0;if((W|0)==0){break}else{z=0;A=W;B=0;C=D;break a}}else if((U|0)==0){U=c[ya+4>>2]|0;W=c[U>>2]|0;if((W|0)==-4){c[ya+8>>2]=0;R=U+8|0;T=c[R>>2]|0;Q=Adc(s,0,0,1,64)|0;if((Q|0)==0){F=104;break g}ea=Q;c[Q>>2]=T;c[Q+4>>2]=0;c[Q+8>>2]=1114111;c[Q+20>>2]=0;c[Q+24>>2]=0;T=Q+28|0;Q=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[Q>>2]=ea;ea=c[R>>2]|0;R=c[U+4>>2]|0;Q=Adc(s,0,0,1,64)|0;if((Q|0)==0){F=106;break g}c[Q>>2]=ea;c[Q+4>>2]=0;c[Q+8>>2]=1114111;c[Q+20>>2]=0;c[Q+24>>2]=0;c[Q+28>>2]=R;c[Q+32>>2]=-1;c[Q+36>>2]=-1;c[Q+40>>2]=-1;c[ya+28>>2]=Q;break}Q=ya+8|0;if((W|0)<0){c[Q>>2]=1;R=Adc(s,0,0,1,32)|0;if((R|0)==0){F=110;break g}c[R>>2]=-1;c[R+4>>2]=-1;c[R+8>>2]=-1;c[ya+24>>2]=R;R=Adc(s,0,0,1,32)|0;if((R|0)==0){F=112;break g}c[R>>2]=-1;c[R+4>>2]=-1;c[R+8>>2]=-1;c[ya+28>>2]=R;break}else{c[Q>>2]=0;Q=U+8|0;R=c[Q>>2]|0;ea=U+4|0;T=c[ea>>2]|0;fa=Adc(s,0,0,1,64)|0;if((fa|0)==0){F=115;break g}da=fa;c[fa>>2]=R;c[fa+4>>2]=W;c[fa+8>>2]=T;c[fa+20>>2]=0;c[fa+24>>2]=0;T=fa+28|0;fa=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[fa>>2]=da;da=c[Q>>2]|0;Q=c[U>>2]|0;fa=c[ea>>2]|0;ea=c[U+12>>2]|0;T=c[U+16>>2]|0;U=Adc(s,0,0,1,64)|0;if((U|0)==0){F=117;break g}W=U;c[U>>2]=da;c[U+4>>2]=Q;c[U+8>>2]=fa;c[U+20>>2]=ea;c[U+24>>2]=T;T=U+28|0;U=ya+28|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[U>>2]=W;break}}else{break}}else if((S|0)==2){W=c[ya+4>>2]|0;U=c[W>>2]|0;T=U+8|0;if((c[T>>2]|0)==0){Aa=0}else{Aa=(c[(c[W+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=Aa;if((c[T>>2]|0)==0){c[ya+24>>2]=c[U+24>>2];Ba=W+4|0}else{T=pdc(q,U,0,0,g)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}Ca=aec((c[g>>2]<<2)+4|0)|0;T=Ca;if((Ca|0)==0){z=0;A=12;B=0;C=D;break a}c[Ca>>2]=-1;c[h>>2]=0;Da=pdc(q,c[W>>2]|0,T,h,0)|0;if((Da|0)!=0){F=150;break g}U=W+4|0;ea=odc(s,c[(c[U>>2]|0)+24>>2]|0,c[(c[W>>2]|0)+24>>2]|0,T,c[h>>2]|0)|0;T=ya+24|0;c[T>>2]=ea;bec(Ca);if((c[T>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Ba=U}}U=c[Ba>>2]|0;if((c[U+8>>2]|0)==0){c[ya+28>>2]=c[U+28>>2];break}T=pdc(q,U,0,0,g)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}Ea=aec((c[g>>2]<<2)+4|0)|0;T=Ea;if((Ea|0)==0){z=0;A=12;B=0;C=D;break a}c[Ea>>2]=-1;c[h>>2]=0;Fa=pdc(q,c[Ba>>2]|0,T,h,0)|0;if((Fa|0)!=0){F=157;break g}U=odc(s,c[(c[W>>2]|0)+28>>2]|0,c[(c[Ba>>2]|0)+28>>2]|0,T,c[h>>2]|0)|0;T=ya+28|0;c[T>>2]=U;bec(Ea);if((c[T>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){bec(Ca);z=0;A=Da;B=0;C=D;break a}else if((F|0)==157){bec(Ea);z=0;A=Fa;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=aec(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=aec(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){Iec(O|0,0,((E|0)>1?E<<2:4)|0)|0}ldc(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;T=O+(S<<2)|0;U=K+1+(c[T>>2]|0)|0;c[T>>2]=0;T=S+1|0;if((T|0)<(E|0)){S=T;K=U}else{Ga=U;break}}}else{Ga=0}K=cec(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;U=ldc(y,S,x,u)|0;if((U|0)!=0){z=x;A=U;B=u;C=D;break}c[w+20>>2]=0;U=v+24|0;S=c[U>>2]|0;if((c[S>>2]|0)>-1){T=1;W=S;while(1){S=W+32|0;ea=T+1|0;if((c[S>>2]|0)>-1){W=S;T=ea}else{Ha=ea;break}}}else{Ha=1}T=cec(Ha,32)|0;if((T|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=T;W=c[U>>2]|0;y=c[W>>2]|0;if((y|0)>-1){ea=y;y=W;W=0;while(1){c[T+(W<<5)+8>>2]=K+(c[N+(ea<<2)>>2]<<5);c[T+(W<<5)+12>>2]=ea;S=T+(W<<5)+16|0;c[S>>2]=0;fa=y+12|0;Q=c[fa>>2]|0;if((Q|0)!=0){da=0;while(1){Ia=da+1|0;if((c[Q+(da<<2)>>2]|0)>-1){da=Ia}else{break}}da=Ia<<2;Q=aec(da)|0;c[S>>2]=Q;if((Q|0)==0){z=x;A=12;B=u;C=D;break a}Gec(Q|0,c[fa>>2]|0,da|0)|0}c[T+(W<<5)+20>>2]=c[y+16>>2];da=W+1|0;Q=y+32|0;R=c[Q>>2]|0;if((R|0)>-1){ea=R;y=Q;W=da}else{Ja=da;break}}}else{Ja=0}c[T+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;zdc(s);bec(c[p+16>>2]|0);bec(p);bec(O);bec(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);zdc(s);bec(c[p+16>>2]|0);bec(p);if((z|0)!=0){bec(z)}if((B|0)!=0){bec(B)}c[b+4>>2]=C;mdc(b);r=A;i=f;return r|0}function jdc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;qdc(m,c[p>>2]|0)|0;qdc(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=qdc(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 4:{Q=qdc(m,9)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}U=M;V=N;W=qdc(m,1)|0;break};case 3:{Q=qdc(m,5)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}U=M;V=N;W=qdc(m,4)|0;break};case 2:{Q=L+ -2|0;c[n>>2]=Q;X=c[P+(Q<<2)>>2]|0;if((c[N+12>>2]|0)>-1){Q=c[w>>2]|0;Y=Adc(Q,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}_=Adc(Q,0,0,1,20)|0;c[Y+4>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[_>>2]=-1;c[_+4>>2]=-1;c[_+8>>2]=-1;_=c[w>>2]|0;Q=Adc(_,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}$=Adc(_,0,0,1,8)|0;_=Q+4|0;c[_>>2]=$;if(($|0)==0){Z=12;T=294;break b}c[Q>>2]=1;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[$>>2]=Y;c[(c[_>>2]|0)+4>>2]=N;_=N+16|0;$=Q+16|0;c[$>>2]=(c[_>>2]|0)+(c[Y+16>>2]|0);c[$>>2]=c[_>>2];aa=Q}else{aa=N}c[aa+12>>2]=X;X=aa+16|0;c[X>>2]=(c[X>>2]|0)+1;U=M;V=aa;W=0;break};case 1:{X=c[q>>2]|0;d:do{switch(a[X]|0){case 91:{Q=X+1|0;c[q>>2]=Q;_=aec(128)|0;if((_|0)==0){Z=12;T=294;break b}if((a[Q]|0)==94){$=X+2|0;c[q>>2]=$;ba=$;ca=1}else{ba=Q;ca=0}Q=(ca|0)==0;$=_;_=0;Y=0;da=32;ea=ba;e:while(1){fa=a[ea]|0;if(fa<<24>>24==0){ga=$;ha=ea;ia=7;T=140;break}else if(fa<<24>>24==93){if(ea>>>0>(c[q>>2]|0)>>>0){T=85;break}}fa=edc(e,ea,-1)|0;if((fa|0)<0){c[e>>2]=-1;ja=1}else{ja=fa}fa=ea+ja|0;do{if((a[fa]|0)==45){ka=ja+1|0;la=ea+ka|0;if((a[la]|0)==93){T=94;break}ma=c[e>>2]|0;na=edc(e,la,-1)|0;if((na|0)<0){c[e>>2]=-1;oa=-1;pa=1}else{oa=c[e>>2]|0;pa=na}qa=0;ra=oa;sa=ma;ta=ea+(pa+ka)|0;ua=ma>>>0>oa>>>0?11:0}else{T=94}}while(0);f:do{if((T|0)==94){T=0;ma=a[ea]|0;do{if(ma<<24>>24==91){ka=a[ea+1|0]|0;if(ka<<24>>24==61|ka<<24>>24==46){ga=$;ha=ea;ia=3;T=140;break e}else if(!(ka<<24>>24==58)){va=0;break}ka=ea+2|0;na=ka;while(1){la=a[na]|0;wa=la<<24>>24==0;if(la<<24>>24!=58&(wa^1)){na=na+1|0}else{break}}if(wa){ga=$;ha=ea;ia=4;T=140;break e}la=na-ea+ -2|0;xa=(la|0)>63?63:la;Pec(A|0,ka|0,xa|0)|0;a[f+xa|0]=0;xa=Qcc(A)|0;qa=xa;ra=1114111;sa=0;ta=na+2|0;ua=(xa|0)==0?4:0;break f}else if(ma<<24>>24==45){if((a[ea+1|0]|0)==93){va=0;break}va=(c[q>>2]|0)==(ea|0)?0:11}else{va=0}}while(0);ma=c[e>>2]|0;qa=0;ra=ma;sa=ma;ta=fa;ua=va}}while(0);if((ua|0)!=0){ga=$;ha=ta;ia=ua;T=140;break}fa=(qa|0)!=0;do{if(Q|fa^1){ma=c[w>>2]|0;if((Y|0)<(da|0)){ya=$;za=da}else{if((da|0)>1024){ga=$;ha=ta;ia=12;T=140;break e}xa=dec($,da<<3)|0;if((xa|0)==0){ga=$;ha=ta;ia=12;T=140;break e}else{ya=xa;za=da<<1}}xa=Adc(ma,0,0,1,32)|0;if((xa|0)==0){T=112;break e}la=Adc(ma,0,0,1,20)|0;ma=xa+4|0;c[ma>>2]=la;if((la|0)==0){T=112;break e}c[xa>>2]=0;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[la>>2]=sa;c[la+4>>2]=ra;c[la+8>>2]=-1;c[ya+(Y<<2)>>2]=xa;c[(c[ma>>2]|0)+12>>2]=qa;Aa=ya;Ba=_;Ca=Y+1|0;Da=za;Ea=0}else{if((_|0)>63){Aa=$;Ba=_;Ca=Y;Da=da;Ea=12;break}c[g+(_<<2)>>2]=qa;Aa=$;Ba=_+1|0;Ca=Y;Da=da;Ea=0}}while(0);ma=(Ea|0)==0;if(ma&(((c[v>>2]&2|0)==0|fa)^1)){Fa=Aa;Ga=Ca;Ha=Da;Ia=sa}else{if(ma){$=Aa;_=Ba;Y=Ca;da=Da;ea=ta;continue}else{ga=Aa;ha=ta;ia=Ea;T=140;break}}while(1){ma=Ia;while(1){if(ma>>>0>ra>>>0){$=Fa;_=Ba;Y=Ga;da=Ha;ea=ta;continue e}if((Tcc(ma)|0)!=0){T=118;break}Ja=ma+1|0;if((Xcc(ma)|0)==0){ma=Ja}else{T=129;break}}if((T|0)==118){T=0;xa=Zcc(ma)|0;la=ma+1|0;g:do{if((Tcc(la)|0)==0){Ka=xa;La=la}else{Ma=xa;Na=la;while(1){if((Zcc(Na)|0)!=(Ma+1|0)|Na>>>0>ra>>>0){Ka=Ma;La=Na;break g}Oa=Zcc(Na)|0;Pa=Na+1|0;if((Tcc(Pa)|0)==0){Ka=Oa;La=Pa;break}else{Ma=Oa;Na=Pa}}}}while(0);la=c[w>>2]|0;if((Ga|0)<(Ha|0)){Qa=Fa;Ra=Ha}else{if((Ha|0)>1024){ga=Fa;ha=ta;ia=12;T=140;break e}Na=dec(Fa,Ha<<3)|0;if((Na|0)==0){ga=Fa;ha=ta;ia=12;T=140;break e}else{Qa=Na;Ra=Ha<<1}}Na=Adc(la,0,0,1,32)|0;Ma=Na;do{if((Na|0)==0){Sa=0}else{na=Adc(la,0,0,1,20)|0;c[Na+4>>2]=na;if((na|0)==0){Sa=0;break}c[Na>>2]=0;c[Na+8>>2]=-1;c[Na+12>>2]=-1;c[na>>2]=xa;c[na+4>>2]=Ka;c[na+8>>2]=-1;Sa=Ma}}while(0);c[Qa+(Ga<<2)>>2]=Sa;Ta=Sa;Ua=Qa;Va=Ra;Wa=La}else if((T|0)==129){T=0;Ma=$cc(ma)|0;h:do{if((Xcc(Ja)|0)==0){Xa=Ma;Ya=Ja}else{xa=Ma;Na=Ja;while(1){if(($cc(Na)|0)!=(xa+1|0)|Na>>>0>ra>>>0){Xa=xa;Ya=Na;break h}la=Na+1|0;na=$cc(Na)|0;if((Xcc(la)|0)==0){Xa=na;Ya=la;break}else{xa=na;Na=la}}}}while(0);ma=c[w>>2]|0;if((Ga|0)<(Ha|0)){Za=Fa;_a=Ha}else{if((Ha|0)>1024){ga=Fa;ha=ta;ia=12;T=140;break e}Na=dec(Fa,Ha<<3)|0;if((Na|0)==0){ga=Fa;ha=ta;ia=12;T=140;break e}else{Za=Na;_a=Ha<<1}}Na=Adc(ma,0,0,1,32)|0;xa=Na;do{if((Na|0)==0){$a=0}else{la=Adc(ma,0,0,1,20)|0;c[Na+4>>2]=la;if((la|0)==0){$a=0;break}c[Na>>2]=0;c[Na+8>>2]=-1;c[Na+12>>2]=-1;c[la>>2]=Ma;c[la+4>>2]=Xa;c[la+8>>2]=-1;$a=xa}}while(0);c[Za+(Ga<<2)>>2]=$a;Ta=$a;Ua=Za;Va=_a;Wa=Ya}if((Ta|0)==0){T=141;break e}else{Fa=Ua;Ga=Ga+1|0;Ha=Va;Ia=Wa}}}i:do{if((T|0)==85){T=0;c[q>>2]=ea+1;da=(ca|0)!=0;if(da){ac($|0,Y|0,4,58)}j:do{if((Y|0)>0){Q=(_|0)>0;fa=_<<2;xa=fa+4|0;if(da){ab=0;bb=0;cb=0;db=0}else{Ma=0;Na=0;while(1){ma=$+(Ma<<2)|0;la=c[(c[ma>>2]|0)+4>>2]|0;do{if((la|0)==0){eb=Na;fb=0}else{c[la+8>>2]=c[x>>2];if(Q){na=Adc(c[w>>2]|0,0,0,0,xa)|0;ka=la+16|0;c[ka>>2]=na;if((na|0)==0){gb=$;hb=Na;ib=12;break i}Gec(na|0,z|0,fa|0)|0;c[(c[ka>>2]|0)+(_<<2)>>2]=0}else{c[la+16>>2]=0}if((Na|0)==0){eb=c[ma>>2]|0;fb=0;break}ka=c[w>>2]|0;na=c[ma>>2]|0;Pa=Adc(ka,0,0,1,32)|0;Oa=Pa;do{if((Pa|0)==0){jb=0}else{kb=Adc(ka,0,0,1,8)|0;lb=Pa+4|0;c[lb>>2]=kb;if((kb|0)==0){jb=0;break}c[Pa>>2]=3;c[Pa+8>>2]=-1;c[Pa+12>>2]=-1;c[kb>>2]=Na;c[(c[lb>>2]|0)+4>>2]=na;c[Pa+16>>2]=(c[na+16>>2]|0)+(c[Na+16>>2]|0);jb=Oa}}while(0);eb=jb;fb=(jb|0)==0?12:0}}while(0);ma=Ma+1|0;if((ma|0)<(Y|0)&(fb|0)==0){Ma=ma;Na=eb}else{mb=0;nb=eb;ob=fb;break j}}}while(1){Na=$+(cb<<2)|0;Ma=c[(c[Na>>2]|0)+4>>2]|0;ma=c[Ma>>2]|0;la=Ma+4|0;Oa=c[la>>2]|0;do{if((ma|0)<(ab|0)){na=Oa+1|0;pb=(na|0)<(ab|0)?ab:na;qb=bb;rb=db;sb=0}else{if((ma|0)<=(bb|0)){na=Oa+1|0;pb=na;qb=na;rb=db;sb=0;break}c[Ma>>2]=bb;c[la>>2]=ma+ -1;na=Oa+1|0;if((Ma|0)==0){pb=na;qb=na;rb=db;sb=0;break}c[Ma+8>>2]=c[x>>2];if(Q){Pa=Adc(c[w>>2]|0,0,0,0,xa)|0;ka=Ma+16|0;c[ka>>2]=Pa;if((Pa|0)==0){gb=$;hb=db;ib=12;break i}Gec(Pa|0,z|0,fa|0)|0;c[(c[ka>>2]|0)+(_<<2)>>2]=0}else{c[Ma+16>>2]=0}if((db|0)==0){pb=na;qb=na;rb=c[Na>>2]|0;sb=0;break}ka=c[w>>2]|0;Pa=c[Na>>2]|0;lb=Adc(ka,0,0,1,32)|0;kb=lb;do{if((lb|0)==0){tb=0}else{ub=Adc(ka,0,0,1,8)|0;vb=lb+4|0;c[vb>>2]=ub;if((ub|0)==0){tb=0;break}c[lb>>2]=3;c[lb+8>>2]=-1;c[lb+12>>2]=-1;c[ub>>2]=db;c[(c[vb>>2]|0)+4>>2]=Pa;c[lb+16>>2]=(c[Pa+16>>2]|0)+(c[db+16>>2]|0);tb=kb}}while(0);pb=na;qb=na;rb=tb;sb=(tb|0)==0?12:0}}while(0);Na=cb+1|0;if((Na|0)<(Y|0)&(sb|0)==0){ab=pb;bb=qb;cb=Na;db=rb}else{mb=qb;nb=rb;ob=sb;break}}}else{mb=0;nb=0;ob=0}}while(0);if((ob|0)!=0|da^1){gb=$;hb=nb;ib=ob;break}fa=c[w>>2]|0;xa=c[x>>2]|0;Q=Adc(fa,0,0,1,32)|0;Na=Q;if((Q|0)==0){gb=$;hb=nb;ib=12;break}Ma=Adc(fa,0,0,1,20)|0;c[Q+4>>2]=Ma;if((Ma|0)==0){gb=$;hb=nb;ib=12;break}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Ma>>2]=mb;c[Ma+4>>2]=1114111;c[Ma+8>>2]=xa;if((_|0)>0){xa=_<<2;fa=Adc(c[w>>2]|0,0,0,0,xa+4|0)|0;Oa=Ma+16|0;c[Oa>>2]=fa;if((fa|0)==0){gb=$;hb=nb;ib=12;break}Gec(fa|0,z|0,xa|0)|0;c[(c[Oa>>2]|0)+(_<<2)>>2]=0}else{c[Ma+16>>2]=0}if((nb|0)==0){gb=$;hb=Na;ib=0;break}Ma=c[w>>2]|0;Oa=Adc(Ma,0,0,1,32)|0;xa=Oa;do{if((Oa|0)==0){wb=0}else{fa=Adc(Ma,0,0,1,8)|0;ma=Oa+4|0;c[ma>>2]=fa;if((fa|0)==0){wb=0;break}c[Oa>>2]=3;c[Oa+8>>2]=-1;c[Oa+12>>2]=-1;c[fa>>2]=nb;c[(c[ma>>2]|0)+4>>2]=Na;c[Oa+16>>2]=(c[Q+16>>2]|0)+(c[nb+16>>2]|0);wb=xa}}while(0);gb=$;hb=wb;ib=(wb|0)==0?12:0}else if((T|0)==112){T=0;c[ya+(Y<<2)>>2]=0;ga=ya;ha=ta;ia=12;T=140}else if((T|0)==141){T=0;c[q>>2]=ta;gb=Ua;hb=0;ib=12}}while(0);if((T|0)==140){T=0;c[q>>2]=ha;gb=ga;hb=0;ib=ia}bec(gb);c[x>>2]=(c[x>>2]|0)+1;if((ib|0)==0){U=M;V=hb;W=0;break c}else{Z=ib;T=294;break b}break};case 46:{Y=(c[v>>2]&4|0)==0;$=c[w>>2]|0;_=c[x>>2]|0;ea=Adc($,0,0,1,32)|0;xa=ea;Q=(ea|0)==0;if(Y){if(Q){Z=12;T=294;break b}Y=Adc($,0,0,1,20)|0;c[ea+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[Y>>2]=0;c[Y+4>>2]=1114111;c[Y+8>>2]=_;xb=xa;yb=(c[x>>2]|0)+1|0}else{if(Q){Z=12;T=294;break b}Q=Adc($,0,0,1,20)|0;c[ea+4>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[Q>>2]=0;c[Q+4>>2]=9;c[Q+8>>2]=_;_=c[w>>2]|0;Q=(c[x>>2]|0)+1|0;$=Adc(_,0,0,1,32)|0;if(($|0)==0){Z=12;T=294;break b}Y=Adc(_,0,0,1,20)|0;c[$+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[$>>2]=0;c[$+8>>2]=-1;c[$+12>>2]=-1;c[Y>>2]=11;c[Y+4>>2]=1114111;c[Y+8>>2]=Q;Q=c[w>>2]|0;Y=Adc(Q,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}_=Adc(Q,0,0,1,8)|0;Q=Y+4|0;c[Q>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Y>>2]=3;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[_>>2]=xa;c[(c[Q>>2]|0)+4>>2]=$;c[Y+16>>2]=(c[$+16>>2]|0)+(c[ea+16>>2]|0);xb=Y;yb=(c[x>>2]|0)+2|0}c[x>>2]=yb;c[q>>2]=(c[q>>2]|0)+1;U=M;V=xb;W=0;break c;break};case 36:{if((c[v>>2]&1|0)==0){if((a[X+1|0]|0)!=0){break d}}Y=c[w>>2]|0;ea=Adc(Y,0,0,1,32)|0;if((ea|0)==0){Z=12;T=294;break b}$=Adc(Y,0,0,1,20)|0;c[ea+4>>2]=$;if(($|0)==0){Z=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[$>>2]=-2;c[$+4>>2]=2;c[$+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=ea;W=0;break c;break};case 94:{if((c[v>>2]&1|0)==0){if((X|0)!=(c[r>>2]|0)){break d}ea=qdc(m,5)|0;if((ea|0)!=0){R=M;S=ea;T=6;break b}}ea=c[w>>2]|0;$=Adc(ea,0,0,1,32)|0;if(($|0)==0){Z=12;T=294;break b}Y=Adc(ea,0,0,1,20)|0;c[$+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[$>>2]=0;c[$+8>>2]=-1;c[$+12>>2]=-1;c[Y>>2]=-2;c[Y+4>>2]=1;c[Y+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=$;W=0;break c;break};case 40:{if((c[v>>2]&1|0)!=0){zb=X;T=74}break};case 63:case 43:case 123:case 124:case 42:{T=264;break};case 0:{T=265;break};case 41:{if((M|0)!=0){T=264}break};case 92:{$=X+1|0;Y=a[$]|0;do{if((c[v>>2]&1|0)==0){if(Y<<24>>24==40){c[q>>2]=$;zb=$;T=74;break d}else{ea=a[X+1|0]|0;if(ea<<24>>24==41){T=265;break d}else{Ab=ea;break}}}else{Ab=Y}}while(0);Y=X+1|0;$=Ab<<24>>24==0;if($){Z=5;T=294;break b}else{Bb=319708|0;Cb=0}while(1){ea=Cb+1|0;if((a[319704+(Cb<<3)|0]|0)==Ab<<24>>24){Db=Bb;break}Q=319708+(ea<<3)|0;if((ea|0)==12){Db=Q;break}else{Bb=Q;Cb=ea}}ea=c[Db>>2]|0;if((ea|0)!=0){Q=F+0|0;xa=G+0|0;_=Q+40|0;do{c[Q>>2]=c[xa>>2];Q=Q+4|0;xa=xa+4|0}while((Q|0)<(_|0));c[H>>2]=ea;c[I>>2]=1;xa=jdc(j)|0;if((xa|0)!=0){Z=xa;T=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];U=M;V=c[K>>2]|0;W=0;break c}if($){Z=5;T=294;break b}c[q>>2]=Y;xa=a[Y]|0;k:do{switch(xa|0){case 120:{Q=X+2|0;c[q>>2]=Q;_=a[Q]|0;if(_<<24>>24==123){Q=X+3|0;c[q>>2]=Q;Oa=Q;Q=0;while(1){Na=a[Oa]|0;if(Na<<24>>24==0|Na<<24>>24==125){Eb=Q;Fb=Oa;break}if((Ycc(Na<<24>>24)|0)==0){Z=9;T=294;break b}Na=c[q>>2]|0;a[l+Q|0]=a[Na]|0;Ma=Q+1|0;da=Na+1|0;c[q>>2]=da;if(Ma>>>0>31){Eb=Ma;Fb=da;break}else{Oa=da;Q=Ma}}c[q>>2]=Fb+1;a[l+Eb|0]=0;Q=Tb(C|0,0,16)|0;Oa=c[w>>2]|0;Ma=c[x>>2]|0;da=Adc(Oa,0,0,1,32)|0;Na=da;do{if((da|0)==0){Gb=0}else{ma=Adc(Oa,0,0,1,20)|0;c[da+4>>2]=ma;if((ma|0)==0){Gb=0;break}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ma>>2]=Q;c[ma+4>>2]=Q;c[ma+8>>2]=Ma;Gb=Na}}while(0);c[x>>2]=(c[x>>2]|0)+1;Hb=Gb;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;Na=(Ycc(_<<24>>24)|0)==0;Ma=c[q>>2]|0;if(Na){Ib=Ma}else{a[D]=a[Ma]|0;Na=Ma+1|0;c[q>>2]=Na;Ib=Na}if((Ycc(a[Ib]|0)|0)!=0){Na=c[q>>2]|0;a[E]=a[Na]|0;c[q>>2]=Na+1}Na=Tb(D|0,0,16)|0;Ma=c[w>>2]|0;Q=c[x>>2]|0;da=Adc(Ma,0,0,1,32)|0;Oa=da;do{if((da|0)==0){Jb=0}else{ma=Adc(Ma,0,0,1,20)|0;c[da+4>>2]=ma;if((ma|0)==0){Jb=0;break}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ma>>2]=Na;c[ma+4>>2]=Na;c[ma+8>>2]=Q;Jb=Oa}}while(0);c[x>>2]=(c[x>>2]|0)+1;Hb=Jb;break k}break};case 60:{Oa=c[w>>2]|0;Q=Adc(Oa,0,0,1,32)|0;Na=Q;do{if((Q|0)==0){Kb=0}else{da=Adc(Oa,0,0,1,20)|0;c[Q+4>>2]=da;if((da|0)==0){Kb=0;break}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[da>>2]=-2;c[da+4>>2]=16;c[da+8>>2]=-1;Kb=Na}}while(0);c[q>>2]=(c[q>>2]|0)+1;Hb=Kb;break};case 66:{Na=c[w>>2]|0;Q=Adc(Na,0,0,1,32)|0;Oa=Q;do{if((Q|0)==0){Lb=0}else{da=Adc(Na,0,0,1,20)|0;c[Q+4>>2]=da;if((da|0)==0){Lb=0;break}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[da>>2]=-2;c[da+4>>2]=128;c[da+8>>2]=-1;Lb=Oa}}while(0);c[q>>2]=(c[q>>2]|0)+1;Hb=Lb;break};case 62:{Oa=c[w>>2]|0;Q=Adc(Oa,0,0,1,32)|0;Na=Q;do{if((Q|0)==0){Mb=0}else{da=Adc(Oa,0,0,1,20)|0;c[Q+4>>2]=da;if((da|0)==0){Mb=0;break}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[da>>2]=-2;c[da+4>>2]=32;c[da+8>>2]=-1;Mb=Na}}while(0);c[q>>2]=(c[q>>2]|0)+1;Hb=Mb;break};case 98:{Na=c[w>>2]|0;Q=Adc(Na,0,0,1,32)|0;Oa=Q;do{if((Q|0)==0){Nb=0}else{da=Adc(Na,0,0,1,20)|0;c[Q+4>>2]=da;if((da|0)==0){Nb=0;break}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[da>>2]=-2;c[da+4>>2]=64;c[da+8>>2]=-1;Nb=Oa}}while(0);c[q>>2]=(c[q>>2]|0)+1;Hb=Nb;break};default:{if((Rcc(xa)|0)!=0){Oa=(a[c[q>>2]|0]|0)+ -48|0;Q=c[w>>2]|0;Na=c[x>>2]|0;da=Adc(Q,0,0,1,32)|0;if((da|0)==0){Z=12;T=294;break b}Ma=Adc(Q,0,0,1,20)|0;c[da+4>>2]=Ma;if((Ma|0)==0){Z=12;T=294;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Ma>>2]=-4;c[Ma+4>>2]=Oa;c[Ma+8>>2]=Na;c[x>>2]=(c[x>>2]|0)+1;Na=c[B>>2]|0;c[B>>2]=(Oa|0)<(Na|0)?Na:Oa;c[q>>2]=(c[q>>2]|0)+1;U=M;V=da;W=0;break c}da=c[w>>2]|0;Oa=a[c[q>>2]|0]|0;Na=c[x>>2]|0;Ma=Adc(da,0,0,1,32)|0;Q=Ma;do{if((Ma|0)==0){Ob=0}else{_=Adc(da,0,0,1,20)|0;c[Ma+4>>2]=_;if((_|0)==0){Ob=0;break}c[Ma>>2]=0;c[Ma+8>>2]=-1;c[Ma+12>>2]=-1;c[_>>2]=Oa;c[_+4>>2]=Oa;c[_+8>>2]=Na;Ob=Q}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;Hb=Ob}}}while(0);if((Hb|0)==0){Z=12;T=294;break b}else{U=M;V=Hb;W=0;break c}break};default:{}}}while(0);if((T|0)==74){T=0;xa=M+1|0;c[q>>2]=zb+1;Y=qdc(m,c[y>>2]|0)|0;if((Y|0)!=0){R=xa;S=Y;T=6;break b}Y=qdc(m,2)|0;if((Y|0)!=0){R=xa;S=Y;T=6;break b}Y=qdc(m,0)|0;if((Y|0)!=0){R=xa;S=Y;T=6;break b}c[y>>2]=(c[y>>2]|0)+1;U=xa;V=N;W=0;break c}else if((T|0)==264){T=0;if((c[v>>2]&1|0)!=0){T=265}}if((T|0)==265){T=0;xa=c[w>>2]|0;Y=Adc(xa,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}$=Adc(xa,0,0,1,20)|0;c[Y+4>>2]=$;if(($|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[$>>2]=-1;c[$+4>>2]=-1;c[$+8>>2]=-1;U=M;V=Y;W=0;break c}Y=edc(h,X,-1)|0;if((Y|0)<0){c[h>>2]=-1;Pb=1}else{Pb=Y}do{if((c[v>>2]&2|0)==0){T=280}else{if((Xcc(c[h>>2]|0)|0)==0){if((Tcc(c[h>>2]|0)|0)==0){T=280;break}}Y=c[w>>2]|0;$=Zcc(c[h>>2]|0)|0;xa=Zcc(c[h>>2]|0)|0;ea=c[x>>2]|0;Q=Adc(Y,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}Na=Adc(Y,0,0,1,20)|0;c[Q+4>>2]=Na;if((Na|0)==0){Z=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Na>>2]=$;c[Na+4>>2]=xa;c[Na+8>>2]=ea;ea=c[w>>2]|0;Na=$cc(c[h>>2]|0)|0;xa=$cc(c[h>>2]|0)|0;$=c[x>>2]|0;Y=Adc(ea,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}Oa=Adc(ea,0,0,1,20)|0;c[Y+4>>2]=Oa;if((Oa|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Oa>>2]=Na;c[Oa+4>>2]=xa;c[Oa+8>>2]=$;$=c[w>>2]|0;Oa=Adc($,0,0,1,32)|0;if((Oa|0)==0){Z=12;T=294;break b}xa=Adc($,0,0,1,8)|0;$=Oa+4|0;c[$>>2]=xa;if((xa|0)==0){Z=12;T=294;break b}c[Oa>>2]=3;c[Oa+8>>2]=-1;c[Oa+12>>2]=-1;c[xa>>2]=Q;c[(c[$>>2]|0)+4>>2]=Y;c[Oa+16>>2]=(c[Y+16>>2]|0)+(c[Q+16>>2]|0);Qb=Oa}}while(0);if((T|0)==280){T=0;X=c[w>>2]|0;Oa=c[h>>2]|0;Q=c[x>>2]|0;Y=Adc(X,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}$=Adc(X,0,0,1,20)|0;c[Y+4>>2]=$;if(($|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[$>>2]=Oa;c[$+4>>2]=Oa;c[$+8>>2]=Q;Qb=Y}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+Pb;U=M;V=Qb;W=0;break};case 8:{Y=L+ -2|0;c[n>>2]=Y;Q=c[P+(Y<<2)>>2]|0;Y=c[w>>2]|0;$=Adc(Y,0,0,1,32)|0;if(($|0)==0){Z=12;T=294;break b}Oa=Adc(Y,0,0,1,8)|0;Y=$+4|0;c[Y>>2]=Oa;if((Oa|0)==0){Z=12;T=294;break b}c[$>>2]=3;c[$+8>>2]=-1;c[$+12>>2]=-1;c[Oa>>2]=Q;c[(c[Y>>2]|0)+4>>2]=N;c[$+16>>2]=(c[N+16>>2]|0)+(c[Q+16>>2]|0);U=M;V=$;W=0;break};case 10:{$=L+ -2|0;c[n>>2]=$;c[v>>2]=c[P+($<<2)>>2];U=M;V=N;W=0;break};case 5:{$=c[q>>2]|0;Q=a[$]|0;if(Q<<24>>24==0){U=M;V=N;W=0;break c}Y=c[v>>2]&1;Oa=(Y|0)!=0;if(Oa&Q<<24>>24==124){U=M;V=N;W=0;break c}do{if(!(Oa&Q<<24>>24==41&(M|0)>0)){if((Y|0)==0&Q<<24>>24==92){if((a[$+1|0]|0)==41){break}}X=qdc(m,5)|0;if((X|0)!=0){R=M;S=X;T=6;break b}X=qdc(m,N)|0;if((X|0)!=0){R=M;S=X;T=6;break b}X=qdc(m,6)|0;if((X|0)!=0){R=M;S=X;T=6;break b}U=M;V=N;W=qdc(m,4)|0;break c}}while(0);Q=(Y|M|0)==0?8:0;Oa=M+ -1|0;if((Y|0)!=0){U=Oa;V=N;W=Q;break c}c[q>>2]=$+2;U=Oa;V=N;W=Q;break};case 6:{Q=L+ -2|0;c[n>>2]=Q;Oa=c[P+(Q<<2)>>2]|0;Q=c[w>>2]|0;X=Adc(Q,0,0,1,32)|0;if((X|0)==0){Z=12;T=294;break b}xa=Adc(Q,0,0,1,8)|0;Q=X+4|0;c[Q>>2]=xa;if((xa|0)==0){Z=12;T=294;break b}c[X>>2]=1;c[X+8>>2]=-1;c[X+12>>2]=-1;c[xa>>2]=Oa;c[(c[Q>>2]|0)+4>>2]=N;c[X+16>>2]=(c[N+16>>2]|0)+(c[Oa+16>>2]|0);U=M;V=X;W=0;break};case 9:{X=c[q>>2]|0;Oa=a[X]|0;switch(Oa<<24>>24|0){case 123:{Q=c[v>>2]|0;if((Q&1|0)==0){U=M;V=N;W=0;break c}else{Rb=Q;Sb=X}break};case 42:{T=41;break};case 92:{Q=c[v>>2]|0;if((Q&1|0)!=0){U=M;V=N;W=0;break c}xa=X+1|0;if((a[xa]|0)!=123){U=M;V=N;W=0;break c}c[q>>2]=xa;Rb=Q;Sb=xa;break};case 63:case 43:{if((c[v>>2]&1|0)==0){U=M;V=N;W=0;break c}else{T=41}break};default:{U=M;V=N;W=0;break c}}if((T|0)==41){T=0;c[q>>2]=X+1;X=c[w>>2]|0;xa=Adc(X,0,0,1,32)|0;if((xa|0)==0){Z=12;T=294;break b}Q=Adc(X,0,0,1,16)|0;c[xa+4>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[xa>>2]=2;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[Q>>2]=N;c[Q+4>>2]=Oa<<24>>24==43;c[Q+8>>2]=Oa<<24>>24==63?1:-1;Oa=Q+12|0;a[Oa]=a[Oa]&-2;c[xa+16>>2]=c[N+16>>2];U=M;V=xa;W=qdc(m,9)|0;break c}xa=Sb+1|0;c[q>>2]=xa;Oa=a[xa]|0;if((Oa+ -48<<24>>24&255)<10){Q=Oa<<24>>24;if((Q+ -48|0)>>>0<10){Ub=Q;Vb=-1;Wb=xa}else{Z=10;T=294;break b}while(1){Q=((Vb|0)<0?-48:(Vb*10|0)+ -48|0)+Ub|0;X=Wb+1|0;Na=a[X]|0;ea=Na<<24>>24;if((ea+ -48|0)>>>0<10){Wb=X;Vb=Q;Ub=ea}else{Xb=Na;Yb=Q;Zb=X;break}}}else{Xb=Oa;Yb=-1;Zb=xa}do{if(Xb<<24>>24==44){$=Zb+1|0;Y=a[$]|0;X=Y<<24>>24;if((X+ -48|0)>>>0<10){_b=X;$b=-1;bc=$}else{cc=Y;dc=-1;ec=$;break}while(1){$=(($b|0)<0?-48:($b*10|0)+ -48|0)+_b|0;Y=bc+1|0;X=a[Y]|0;Q=X<<24>>24;if((Q+ -48|0)>>>0<10){bc=Y;$b=$;_b=Q}else{fc=X;gc=$;hc=Y;T=54;break}}}else{fc=Xb;gc=Yb;hc=Zb;T=54}}while(0);do{if((T|0)==54){T=0;if(!((gc|0)>-1)){cc=fc;dc=gc;ec=hc;break}if((Yb|0)>(gc|0)|(gc|0)>255){Z=10;T=294;break b}else{cc=fc;dc=gc;ec=hc}}}while(0);if(cc<<24>>24==0){Z=9;T=294;break b}if((ec|0)==(xa|0)){Z=10;T=294;break b}if((Rb&1|0)==0){if(!(cc<<24>>24==92)){Z=10;T=294;break b}if((a[ec+1|0]|0)!=125){Z=10;T=294;break b}ic=ec+2|0}else{if(!(cc<<24>>24==125)){Z=10;T=294;break b}ic=ec+1|0}if((dc|Yb|0)==0){Oa=c[w>>2]|0;Y=Adc(Oa,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}$=Adc(Oa,0,0,1,20)|0;c[Y+4>>2]=$;if(($|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[$>>2]=-1;c[$+4>>2]=-1;c[$+8>>2]=-1;jc=Y}else{Y=(dc&Yb|0)<0;$=c[w>>2]|0;Oa=Adc($,0,0,1,32)|0;if((Oa|0)==0){Z=12;T=294;break b}X=Adc($,0,0,1,16)|0;c[Oa+4>>2]=X;if((X|0)==0){Z=12;T=294;break b}c[Oa>>2]=2;c[Oa+8>>2]=-1;c[Oa+12>>2]=-1;c[X>>2]=N;c[X+4>>2]=Y?1:Yb;c[X+8>>2]=Y?1:dc;Y=X+12|0;a[Y]=a[Y]&-2;c[Oa+16>>2]=c[N+16>>2];jc=Oa}c[q>>2]=ic;U=M;V=jc;W=qdc(m,9)|0;break};case 0:{if((c[v>>2]&1|0)!=0){Oa=qdc(m,7)|0;if((Oa|0)!=0){R=M;S=Oa;T=6;break b}}U=M;V=N;W=qdc(m,3)|0;break};case 7:{Oa=c[q>>2]|0;Y=a[Oa]|0;if((Y|0)==41){c[q>>2]=Oa+1;U=M;V=N;W=0;break c}else if((Y|0)!=124){U=M;V=N;W=0;break c}Y=qdc(m,7)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}Y=qdc(m,N)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}Y=qdc(m,8)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}Y=qdc(m,3)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}c[q>>2]=(c[q>>2]|0)+1;U=M;V=N;W=0;break};default:{U=M;V=N;W=0}}}while(0);P=c[n>>2]|0;O=(W|0)==0;if((P|0)>(o|0)&O){L=P;M=U;N=V}else{kc=O;lc=U;mc=V;nc=W;break a}}if((T|0)==6){kc=(S|0)==0;lc=R;mc=N;nc=S;break}else if((T|0)==294){i=d;return Z|0}}else{kc=t;lc=0;mc=0;nc=p}}while(0);p=(lc|0)>0;if(p|kc^1){Z=p?8:nc;i=d;return Z|0}c[b+8>>2]=mc;Z=0;i=d;return Z|0}function kdc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=aec((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=aec((l<<2)+4|0)|0;if((p|0)==0){bec(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}qdc(d,e)|0;e=qdc(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 2:{E=A;while(1){if((c[E>>2]|0)>-1){E=E+4|0}else{F=v;G=w;H=x;I=y;J=z;K=E;L=0;M=B;break}}break};case 3:{E=c[D+(u+ -2<<2)>>2]|0;N=c[D+(u+ -3<<2)>>2]|0;O=c[D+(u+ -4<<2)>>2]|0;P=u+ -5|0;c[h>>2]=P;if(k){Q=c[O+4>>2]|0;R=O+16|0;c[O+20>>2]=(c[(c[Q>>2]|0)+20>>2]|0)+(c[D+(P<<2)>>2]|0)+(c[(c[Q+4>>2]|0)+20>>2]|0)+((c[R>>2]|0)>0?2:0);S=R;T=c[h>>2]|0}else{S=O+16|0;T=P}P=c[D+(T+ -1<<2)>>2]|0;O=T+ -2|0;c[h>>2]=O;R=c[D+(O<<2)>>2]|0;O=T+ -3|0;c[h>>2]=O;Q=c[D+(O<<2)>>2]|0;if((c[S>>2]|0)<=0){F=1;G=w;H=x;I=y;J=z;K=P;L=0;M=B;break b}if(k){U=0}else{tdc(b,E,R)|0;c[(c[r>>2]|0)+(R<<2)>>2]=1;R=tdc(b,N,Q)|0;c[(c[r>>2]|0)+(Q<<2)>>2]=1;U=R}F=1;G=w;H=x;I=y;J=z+2|0;K=P;L=U;M=B;break};case 6:{P=u+ -2|0;c[h>>2]=P;R=c[D+(P<<2)>>2]|0;P=0;do{V=A+(P<<2)|0;P=P+1|0}while((c[V>>2]|0)>-1);c[V>>2]=R<<1|1;c[A+(P<<2)>>2]=-1;Q=0;while(1){if((c[p+(Q<<2)>>2]|0)>-1){Q=Q+1|0}else{break}}c[p+(Q+ -1<<2)>>2]=-1;F=v;G=w;H=x;I=y;J=z;K=A;L=0;M=B;break};case 0:{P=u+ -2|0;c[h>>2]=P;R=c[D+(P<<2)>>2]|0;P=R;N=R+12|0;E=c[N>>2]|0;if((E|0)>-1){O=0;do{W=A+(O<<2)|0;O=O+1|0}while((c[W>>2]|0)>-1);c[W>>2]=E<<1;c[A+(O<<2)>>2]=-1;do{if(!k){Q=0;while(1){if((c[p+(Q<<2)>>2]|0)>-1){Q=Q+1|0}else{break}}c[(c[s>>2]|0)+(E*12|0)+8>>2]=0;if((Q|0)<=0){break}X=aec((Q<<2)+4|0)|0;Y=X;if((X|0)==0){Z=w;_=y;$=z;aa=A;ba=12;ca=B;break a}c[(c[s>>2]|0)+(E*12|0)+8>>2]=Y;da=c[p>>2]|0;if((da|0)>-1){ea=Y;fa=da;da=0;while(1){c[ea>>2]=fa;ga=da+1|0;ha=c[p+(ga<<2)>>2]|0;ia=X+(ga<<2)|0;if((ha|0)>-1){da=ga;fa=ha;ea=ia}else{ja=ia;break}}}else{ja=Y}c[ja>>2]=-1}}while(0);E=qdc(d,c[N>>2]|0)|0;if((E|0)!=0){Z=w;_=y;$=z;aa=A;ba=E;ca=B;break a}E=qdc(d,6)|0;if((E|0)!=0){Z=w;_=y;$=z;aa=A;ba=E;ca=B;break a}}E=c[R>>2]|0;do{if((E|0)==3){O=c[R+4>>2]|0;ea=c[O>>2]|0;fa=c[O+4>>2]|0;O=(c[A>>2]|0)>-1;da=x+1|0;X=qdc(d,O?da:x)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=qdc(d,O?x:B)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=qdc(d,A)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=qdc(d,(c[A>>2]|0)>>>31^1)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=qdc(d,R)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=fa;fa=qdc(d,X)|0;if((fa|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=fa;qa=B;break}fa=ea;ea=qdc(d,fa)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=qdc(d,3)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=qdc(d,X)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=qdc(d,0)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=qdc(d,2)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=qdc(d,fa)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=qdc(d,0)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}if((c[A>>2]|0)>-1){if(k){ra=w;sa=y;ta=0}else{ea=sdc(b,P,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){fa=c[t>>2]|0;X=0;while(1){ua=fa+(X<<2)|0;va=X+1|0;if((c[ua>>2]|0)>-1){X=va}else{break}}c[ua>>2]=B;c[fa+(va<<2)>>2]=w;c[fa+(X+2<<2)>>2]=-1;wa=-1;xa=y+1|0}else{wa=w;xa=y}Y=c[A>>2]|0;if((Y|0)>-1){O=c[s>>2]|0;Q=Y;Y=0;do{ia=(Q|0)/2|0;if((Q&1|0)==0){c[O+(ia*12|0)>>2]=B}else{c[O+(ia*12|0)+4>>2]=B}Y=Y+1|0;Q=c[A+(Y<<2)>>2]|0;}while((Q|0)>-1)}c[A>>2]=-1;ra=wa;sa=xa;ta=ea}c[A>>2]=-1;ya=ra;za=da;Aa=sa;Ba=z+1|0;Ca=ta;Da=x}else{ya=w;za=x;Aa=y;Ba=z;Ca=0;Da=B}if((c[R+16>>2]|0)<=0){ka=v;la=ya;ma=za;na=Aa;oa=Ba;pa=Ca;qa=Da;break}ka=v;la=ya;ma=za+2|0;na=Aa;oa=Ba;pa=Ca;qa=za+1|0}else if((E|0)==2){Q=c[R+4>>2]|0;if(k){if((c[A>>2]|0)>-1){Ea=1}else{Ea=a[Q+12|0]&1}Y=qdc(d,Ea)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}}else{Y=qdc(d,B)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=qdc(d,a[Q+12|0]&1)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}}Y=qdc(d,R)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=qdc(d,1)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=qdc(d,c[Q>>2]|0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=qdc(d,0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}if(!((c[A>>2]|0)>-1)){if((a[Q+12|0]&1)==0){ka=0;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}}if(k){Fa=w;Ga=y;Ha=0}else{Y=sdc(b,P,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[Q+12|0]&1)==0?v:1;if((w|0)>-1){Q=c[t>>2]|0;O=0;while(1){Ia=Q+(O<<2)|0;Ja=O+1|0;if((c[Ia>>2]|0)>-1){O=Ja}else{break}}c[Ia>>2]=B;c[Q+(Ja<<2)>>2]=w;c[Q+(O+2<<2)>>2]=-1;Ka=-1;La=y+1|0}else{Ka=w;La=y}da=c[A>>2]|0;if((da|0)>-1){ea=c[s>>2]|0;X=da;da=0;do{fa=(X|0)/2|0;if((X&1|0)==0){c[ea+(fa*12|0)>>2]=B}else{c[ea+(fa*12|0)+4>>2]=B}da=da+1|0;X=c[A+(da<<2)>>2]|0;}while((X|0)>-1)}c[A>>2]=-1;Fa=Ka;Ga=La;Ha=Y}c[A>>2]=-1;ka=0;la=Fa;ma=x+1|0;na=Ga;oa=z+1|0;pa=Ha;qa=x}else if((E|0)==1){X=c[R+4>>2]|0;da=c[X>>2]|0;ea=c[X+4>>2]|0;X=qdc(d,R)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=qdc(d,5)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=qdc(d,ea)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=qdc(d,0)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=da+20|0;O=qdc(d,(c[X>>2]|0)+x|0)|0;if((O|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=O;qa=B;break}if((c[X>>2]|0)>0){X=(c[ea+20>>2]|0)>0;Ma=(X&1)+x|0;Na=X?x:-1}else{Ma=x;Na=-1}X=qdc(d,Na)|0;if((X|0)!=0){ka=v;la=w;ma=Ma;na=y;oa=z;pa=X;qa=B;break}X=qdc(d,4)|0;if((X|0)!=0){ka=v;la=w;ma=Ma;na=y;oa=z;pa=X;qa=B;break}X=qdc(d,da)|0;if((X|0)!=0){ka=v;la=w;ma=Ma;na=y;oa=z;pa=X;qa=B;break}ka=v;la=w;ma=Ma;na=y;oa=z;pa=qdc(d,0)|0;qa=B}else if((E|0)==0){X=c[c[R+4>>2]>>2]|0;if(!((X|0)>-1|(X|0)==-4)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(!((c[A>>2]|0)>-1)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(k){c[R+20>>2]=1;Oa=w;Pa=y;Qa=0}else{X=sdc(b,P,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){da=c[t>>2]|0;ea=0;while(1){Ra=da+(ea<<2)|0;Sa=ea+1|0;if((c[Ra>>2]|0)>-1){ea=Sa}else{break}}c[Ra>>2]=B;c[da+(Sa<<2)>>2]=w;c[da+(ea+2<<2)>>2]=-1;Ta=-1;Ua=y+1|0}else{Ta=w;Ua=y}Y=c[A>>2]|0;if((Y|0)>-1){O=c[s>>2]|0;Q=Y;Y=0;do{fa=(Q|0)/2|0;if((Q&1|0)==0){c[O+(fa*12|0)>>2]=B}else{c[O+(fa*12|0)+4>>2]=B}Y=Y+1|0;Q=c[A+(Y<<2)>>2]|0;}while((Q|0)>-1)}c[A>>2]=-1;Oa=Ta;Pa=Ua;Qa=X}c[A>>2]=-1;ka=v;la=Oa;ma=x+1|0;na=Pa;oa=z+1|0;pa=Qa;qa=x}else{ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B}}while(0);P=c[N>>2]|0;if((P|0)>-1){Va=0}else{F=ka;G=la;H=ma;I=na;J=oa;K=A;L=pa;M=qa;break b}do{Wa=p+(Va<<2)|0;Va=Va+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=P;c[p+(Va<<2)>>2]=-1;F=ka;G=la;H=ma;I=na;J=oa;K=A;L=pa;M=qa;break};case 5:{N=u+ -2|0;c[h>>2]=N;R=c[D+(N<<2)>>2]|0;if(!k){F=v;G=w;H=x;I=y;J=z;K=A;L=0;M=B;break b}N=c[R+4>>2]|0;c[R+20>>2]=(c[(c[N+4>>2]|0)+20>>2]|0)+(c[(c[N>>2]|0)+20>>2]|0);F=v;G=w;H=x;I=y;J=z;K=A;L=0;M=B;break};case 4:{N=u+ -2|0;c[h>>2]=N;R=c[D+(N<<2)>>2]|0;N=u+ -3|0;c[h>>2]=N;F=v;G=w;H=c[D+(N<<2)>>2]|0;I=y;J=z;K=A;L=0;M=(R|0)>-1?R:B;break};case 1:{R=u+ -2|0;c[h>>2]=R;N=c[D+(R<<2)>>2]|0;if(k){R=c[(c[c[N+4>>2]>>2]|0)+20>>2]|0;E=u+ -3|0;c[h>>2]=E;c[N+20>>2]=(c[D+(E<<2)>>2]|0)+R;F=v;G=-1;H=x;I=y;J=z;K=A;L=0;M=B;break b}else{R=u+ -3|0;c[h>>2]=R;E=c[D+(R<<2)>>2]|0;R=u+ -4|0;c[h>>2]=R;N=(E|0)==0;F=N&1;G=N?w:c[D+(R<<2)>>2]|0;H=x;I=y;J=z;K=A;L=0;M=B;break b}break};default:{F=v;G=w;H=x;I=y;J=z;K=A;L=0;M=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(L|0)==0){u=D;v=F;w=G;x=H;y=I;z=J;A=K;B=M}else{Z=G;_=I;$=J;aa=K;ba=L;ca=M;break a}}}else{Z=-1;_=0;$=0;aa=n;ba=e;ca=0}}while(0);do{if(k){Xa=_}else{e=c[aa>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;M=e;e=0;do{L=(M|0)/2|0;if((M&1|0)==0){c[n+(L*12|0)>>2]=ca}else{c[n+(L*12|0)+4>>2]=ca}e=e+1|0;M=c[aa+(e<<2)>>2]|0;}while((M|0)>-1)}c[aa>>2]=-1;if(!((Z|0)>-1)){Xa=_;break}M=c[f+36>>2]|0;e=0;while(1){Ya=M+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=ca;c[M+(Za<<2)>>2]=Z;c[M+(e+2<<2)>>2]=-1;Xa=_+1|0}}while(0);c[f+48>>2]=$;c[f+40>>2]=$;c[f+44>>2]=Xa;bec(m);bec(p);o=ba;i=g;return o|0}function ldc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==3){h=c[g+4>>2]|0;j=ldc(c[h>>2]|0,b,d,e)|0;if((j|0)!=0){k=j;l=10;break a}m=h+4|0}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;n=ndc(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((n|0)!=0){k=n;l=10;break a}n=ldc(c[h>>2]|0,b,d,e)|0;if((n|0)==0){m=j}else{k=n;l=10;break a}}else if((a|0)==2){n=c[g+4>>2]|0;j=n;if(!((c[n+8>>2]|0)==-1)){m=j;break}h=c[n>>2]|0;n=ndc(c[h+28>>2]|0,c[h+24>>2]|0,b,d,e)|0;if((n|0)==0){m=j}else{k=n;l=10;break a}}else{k=0;l=10;break a}}while(0);g=c[m>>2]|0}if((l|0)==10){i=f;return k|0}return 0}function mdc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{bec(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}bec(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){bec(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){bec(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}bec(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{bec(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}bec(m)}m=c[d+32>>2]|0;if((m|0)!=0){bec(m)}m=c[d+20>>2]|0;if((m|0)!=0){bec(m)}m=c[d+36>>2]|0;if((m|0)!=0){bec(m)}bec(d);i=b;return}function ndc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=aec(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){bec(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=aec((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function odc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=Adc(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=Adc(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=Adc(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function pdc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=qdc(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==3){r=c[o+4>>2]|0;s=c[r>>2]|0;if((c[s+8>>2]|0)!=0){t=qdc(a,s)|0;break}s=c[r+4>>2]|0;if((c[s+8>>2]|0)==0){continue a}t=qdc(a,s)|0}else if((q|0)==2){s=c[c[o+4>>2]>>2]|0;if((c[s+8>>2]|0)==0){continue a}t=qdc(a,s)|0}else if((q|0)==1){s=c[o+4>>2]|0;r=qdc(a,c[s>>2]|0)|0;if((r|0)!=0){m=r;p=28;break a}t=qdc(a,c[s+4>>2]|0)|0}else if((q|0)==0){s=c[o+4>>2]|0;r=c[s>>2]|0;if((r|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[s+4>>2];continue a}else if(!((r|0)==-3)){continue a}r=c[s+4>>2]|0;if(!((r|0)>-1)){continue a}b:do{if(!b){s=c[d>>2]|0;c:do{if((s|0)>-1){u=s;v=d;w=0;while(1){x=w+1|0;if((u|0)==(r|0)){break}y=d+(x<<2)|0;z=c[y>>2]|0;if((z|0)>-1){u=z;v=y;w=x}else{A=y;B=x;break c}}if((r|0)<0){A=v;B=w}else{break b}}else{A=d;B=0}}while(0);c[A>>2]=r;c[d+(B+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else{continue a}}while(0);if((t|0)!=0){m=t;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function qdc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=dec(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;qdc(a,b)|0;i=d;return 0}return 0}function rdc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;qdc(d,e)|0;e=qdc(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==0){y=c[u+4>>2]|0;x=c[y+8>>2]|0;D=c[y>>2]|0;E=c[y+4>>2]|0;do{if((D|0)>-1|(D|0)==-4){F=r;G=E;H=D;I=s+1|0;J=(c[g>>2]|0)+x|0}else{if(!((D|0)==-3)){F=r;G=E;H=D;I=s;J=x;break}if(!p){F=r;G=-1;H=-1;I=s;J=-1;break}if(q|(r|0)==0){F=r;G=E;H=-3;I=s;J=x;break}c[h+(E<<2)>>2]=1;F=0;G=E;H=-3;I=s;J=x}}while(0);x=Adc(b,0,0,1,32)|0;E=x;do{if((x|0)==0){K=0}else{D=Adc(b,0,0,1,20)|0;c[x+4>>2]=D;if((D|0)==0){K=0;break}c[x>>2]=0;c[x+8>>2]=-1;c[x+12>>2]=-1;c[D>>2]=H;c[D+4>>2]=G;c[D+8>>2]=J;K=E}}while(0);c[t>>2]=K;E=(K|0)==0?12:0;if((J|0)<=(c[k>>2]|0)){L=F;M=I;N=t;O=E;break}c[k>>2]=J;L=F;M=I;N=t;O=E}else if((z|0)==2){E=c[u+4>>2]|0;x=qdc(d,c[E>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=qdc(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=c[E>>2]|0;D=c[E+4>>2]|0;y=c[E+8>>2]|0;P=a[E+12|0]|0;E=Adc(b,0,0,1,32)|0;if((E|0)==0){Q=40;break b}R=Adc(b,0,0,1,16)|0;S=E+4|0;c[S>>2]=R;if((R|0)==0){Q=40;break b}c[E>>2]=2;c[E+8>>2]=-1;c[E+12>>2]=-1;c[R>>2]=x;c[R+4>>2]=D;c[R+8>>2]=y;y=R+12|0;a[y]=a[y]&-2|P&1;c[E+16>>2]=c[x+16>>2];c[t>>2]=E;A=s;B=r;t=c[S>>2]|0;s=A;r=B;continue b}else if((z|0)==3){S=c[u+4>>2]|0;E=c[S>>2]|0;x=S+4|0;P=c[x>>2]|0;y=Adc(b,0,0,1,32)|0;if((y|0)==0){Q=20;break b}R=Adc(b,0,0,1,8)|0;D=y+4|0;c[D>>2]=R;if((R|0)==0){Q=20;break b}c[y>>2]=3;c[y+8>>2]=-1;c[y+12>>2]=-1;c[R>>2]=E;c[(c[D>>2]|0)+4>>2]=P;c[y+16>>2]=(c[P+16>>2]|0)+(c[E+16>>2]|0);c[t>>2]=y;y=c[D>>2]|0;D=qdc(d,c[x>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}D=qdc(d,0)|0;if((D|0)!=0){v=s;w=D;break a}D=qdc(d,y+4|0)|0;if((D|0)!=0){v=s;w=D;break a}D=qdc(d,1)|0;if((D|0)!=0){v=s;w=D;break a}D=qdc(d,c[S>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}L=r;M=s;N=y;O=qdc(d,0)|0}else if((z|0)==1){y=c[u+4>>2]|0;D=c[y>>2]|0;S=y+4|0;x=c[S>>2]|0;E=Adc(b,0,0,1,32)|0;if((E|0)==0){Q=29;break b}P=Adc(b,0,0,1,8)|0;R=E+4|0;c[R>>2]=P;if((P|0)==0){Q=29;break b}c[E>>2]=1;c[E+8>>2]=-1;c[E+12>>2]=-1;c[P>>2]=D;c[(c[R>>2]|0)+4>>2]=x;c[E+16>>2]=(c[x+16>>2]|0)+(c[D+16>>2]|0);c[t>>2]=E;E=c[R>>2]|0;c[E>>2]=0;R=E+4|0;c[R>>2]=0;D=qdc(d,c[S>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}D=qdc(d,0)|0;if((D|0)!=0){v=s;w=D;break a}D=qdc(d,R)|0;if((D|0)!=0){v=s;w=D;break a}D=qdc(d,1)|0;if((D|0)!=0){v=s;w=D;break a}D=qdc(d,c[y>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}L=r;M=s;N=E;O=qdc(d,0)|0}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((O|0)==0){r=L;s=M;t=N}else{v=M;w=O;break a}}if((Q|0)==20){c[t>>2]=0;v=s;w=12;break}else if((Q|0)==29){c[t>>2]=0;v=s;w=12;break}else if((Q|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function sdc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=Adc(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=Adc(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=Adc(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=Adc(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function tdc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=Adc(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=Adc(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=Adc(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=Adc(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function udc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function vdc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=319952}else{j=b;k=319952;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((Eec(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Kc(e|0,f|0,320240,g|0)|0)+1|0;i=d;return h|0}



function LI(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+20848>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+14856>>3]*+h[j+9136>>3]+(+h[j+14848>>3]*+h[j+9144>>3]- +h[j+16>>3]*+h[j+2848>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+9120|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+9120|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,19200,19528,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9120|0;p=o;h[p>>3]=m;i=d;return}function MI(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+20848>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2848>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+2960|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+2960|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,19200,19536,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2960|0;p=o;h[p>>3]=m;i=d;return}function NI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2840>>3]=+h[b+14856>>3]*+h[b+9784>>3]+ +h[b+14848>>3]*+h[b+9792>>3];i=i;return}function OI(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+20848>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+14872>>3]*+h[j+9136>>3]+(+h[j+14864>>3]*+h[j+9144>>3]+ +h[j+16>>3]*+h[j+2840>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+9112|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+9112|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,19200,19544,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9112|0;p=o;h[p>>3]=m;i=d;return}function PI(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+20848>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2840>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+2952|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+2952|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,19200,19552,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2952|0;p=o;h[p>>3]=m;i=d;return}function QI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20848>>3]=(+h[b+2952>>3]*+h[b+7104>>3]+ +h[b+2960>>3]*+h[b+7096>>3])*2.0;i=i;return}function RI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7168>>3]=+h[b+2960>>3]*+h[b+14872>>3]+ +h[b+2952>>3]*+h[b+14856>>3];i=i;return}function SI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7176>>3]=+h[b+2960>>3]*+h[b+14864>>3]+ +h[b+2952>>3]*+h[b+14848>>3];i=i;return}function TI(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2960>>3];e=+h[b+2952>>3];h[b+20304>>3]=(+h[b+14872>>3]*d+ +h[b+14856>>3]*e)*-.8660254037844387+(d*+h[b+14864>>3]+e*+h[b+14848>>3])*-.4999999999999999;i=i;return}function UI(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2952>>3];e=+h[b+2960>>3];h[b+20248>>3]=d*d+e*e;i=i;return}function VI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+20248>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=22632;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,19568,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+20848>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+20800|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+20800|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,19680,19560,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+20800|0;y=x;h[y>>3]=v;i=d;return}function WI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+20248>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+20240|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=22632;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,19568,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+20240|0;p=o;h[p>>3]=m;i=b;return}function XI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20240>>3];k=j*j;l=j*+h[g+7096>>3]- +h[g+2960>>3]*+h[g+20800>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4576|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4576|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,19760,19752,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4576|0;q=p;h[q>>3]=n;i=d;return}function YI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4592>>3]=-(+h[b+7160>>3]*+h[b+4576>>3]);i=i;return}function ZI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20240>>3];k=j*j;l=+h[g+2952>>3]*+h[g+20800>>3]-j*+h[g+7104>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4568|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4568|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,19760,19824,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4568|0;q=p;h[q>>3]=n;i=d;return}function _I(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4600>>3]=+h[b+7160>>3]*+h[b+4568>>3];i=i;return}function $I(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20240>>3];k=+h[g+2960>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+15944|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+15944|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,19840,19832,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+15944|0;p=o;h[p>>3]=m;i=d;return}function aJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2880>>3]=-(+h[b+7160>>3]*+h[b+15944>>3]);i=i;return}function bJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20240>>3];k=+h[g+2952>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+15936|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+15936|0;q=p;h[q>>3]=n;i=d;return}k=l/+$Lb(c[b+536>>2]|0,j,19840,19896,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+15936|0;q=p;h[q>>3]=n;i=d;return}function cJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4584>>3]=+h[b+2960>>3]*+h[b+4576>>3]+(+h[b+7096>>3]*+h[b+15944>>3]+(-(+h[b+2952>>3]*+h[b+4568>>3])- +h[b+7104>>3]*+h[b+15936>>3]));i=i;return}function dJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7192>>3]=+h[b+15936>>3]*+h[b+14872>>3]+ +h[b+15944>>3]*+h[b+14856>>3];i=i;return}function eJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7200>>3]=+h[b+15936>>3]*+h[b+14864>>3]+ +h[b+15944>>3]*+h[b+14848>>3];i=i;return}function fJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2856>>3]=+h[b+15936>>3]*+h[b+9112>>3]+ +h[b+15944>>3]*+h[b+9120>>3];i=i;return}function gJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2872>>3]=+h[b+7160>>3]*+h[b+15936>>3];i=i;return}function hJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7144>>3]=+h[b+2880>>3]*+h[b+14872>>3]+ +h[b+2872>>3]*+h[b+14856>>3];i=i;return}function iJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2824>>3]=+h[b+9856>>3]+(+h[b+7144>>3]*+h[d+5664>>3]+(+h[b+7168>>3]*+h[d+5672>>3]+ +h[b+7192>>3]*+h[d+5680>>3]));i=i;return}function jJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7152>>3]=+h[b+2880>>3]*+h[b+14864>>3]+ +h[b+2872>>3]*+h[b+14848>>3];i=i;return}function kJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2832>>3]=+h[b+9864>>3]+(+h[b+7152>>3]*+h[d+5664>>3]+(+h[b+7176>>3]*+h[d+5672>>3]+ +h[b+7200>>3]*+h[d+5680>>3]));i=i;return}function lJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2808>>3]=-(+h[b+2872>>3]*+h[b+9120>>3])- +h[b+2880>>3]*+h[b+9112>>3];i=i;return}function mJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20240>>3];k=+h[g+2872>>3]*+h[g+9112>>3]- +h[g+2880>>3]*+h[g+9120>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2864|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2864|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,19840,19904,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2864|0;p=o;h[p>>3]=m;i=d;return}function nJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2800>>3]=+h[b+7160>>3]*+h[b+16>>3]+ +h[b+2864>>3];i=i;return}function oJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7136>>3]=+h[b+2960>>3]*+h[b+15944>>3]- +h[b+2952>>3]*+h[b+15936>>3];i=i;return}function pJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2816>>3]=+h[b+9848>>3]+(+h[b+7136>>3]*+h[d+5664>>3]+ +h[b+7160>>3]*+h[d+5672>>3]);i=i;return}function qJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2792>>3]=+h[b+7136>>3]*+h[b+16>>3]+ +h[b+2856>>3];i=i;return}function rJ(a){a=a|0;h[(c[a+416>>2]|0)+21880>>3]=.175;i=i;return}function sJ(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+21880>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+9896>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7344|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7344|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,19920,19912,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7344|0;p=o;h[p>>3]=m;i=d;return}function tJ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21800>>3]=+h[b+21880>>3];i=i;return}function uJ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21808>>3]=+h[b+21880>>3];i=i;return}function vJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0;d=i;i=i+64|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+8|0;p=b+4|0;q=c[(c[c[p>>2]>>2]|0)+8>>2]|0;r=+h[q+9944>>3];s=+h[q+9960>>3];t=l;h[k>>3]=+h[q+9952>>3];c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=l+8|0;h[k>>3]=s;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];UMb(m,3,r,l);l=c[(c[c[p>>2]>>2]|0)+8>>2]|0;r=+h[l+15136>>3];s=+h[l+15152>>3];p=j;h[k>>3]=+h[l+15144>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j+8|0;h[k>>3]=s;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];UMb(n,3,r,j);j=c[b+536>>2]|0;p=c[b+416>>2]|0;r=+h[p+21808>>3];s=+h[p+21816>>3]+ +h[p+21824>>3];p=g;l=18072;c[p+0>>2]=c[l+0>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];l=f;p=m;c[l+0>>2]=c[p+0>>2];c[l+4>>2]=c[p+4>>2];c[l+8>>2]=c[p+8>>2];p=e;l=n;c[p+0>>2]=c[l+0>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];dv(o,j,r,g,s,f,e);a[(c[b+424>>2]|0)+131|0]=a[o]|0;i=d;return}function wJ(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+9920>>3];e=+h[b+9928>>3];f=+h[b+9936>>3];g=+h[(c[a+416>>2]|0)+21808>>3];h[b+20128>>3]=d*d+(e*e+(f*f-g*g));i=i;return}function xJ(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+20120>>3];h[b+20104>>3]=d*d- +h[b+20128>>3];i=i;return}function yJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;av(d,c[a+536>>2]|0,+h[f+20104>>3],1.0e-12,+h[f+21016>>3],0.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+21024>>3]=+h[d>>3];i=b;return}function zJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;bv(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20104>>3],1.0e-12);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20096>>3]=+h[d>>3];i=b;return}function AJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+20096>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=22632;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,19984,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+21024>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+21008|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+21008|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,20088,19976,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+21008|0;y=x;h[y>>3]=v;i=d;return}function BJ(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+21e3>>3];g=+h[e+21008>>3];if((a[(c[b+424>>2]|0)+131|0]|0)!=0){j=g;k=f-j;l=e;m=l+20008|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+20008|0;n=m;h[n>>3]=k;i=d;return}function CJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8816>>3]=+h[b+20008>>3]*-.4999999999999999;i=i;return}function DJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8864>>3]=+h[b+8816>>3]- +h[b+8936>>3];i=i;return}function EJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8808>>3]=+h[b+20008>>3]*.8660254037844387;i=i;return}function FJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8856>>3]=+h[b+8808>>3]- +h[b+8928>>3];i=i;return}function GJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+20096>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+20112|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=22632;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,19984,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+20112|0;p=o;h[p>>3]=m;i=b;return}function HJ(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+20120>>3];g=+h[e+20112>>3];if((a[(c[b+424>>2]|0)+131|0]|0)!=0){j=g;k=f-j;l=e;m=l+16784|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+16784|0;n=m;h[n>>3]=k;i=d;return}function IJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20072>>3]=+h[(c[a+416>>2]|0)+21816>>3]+ +h[b+16784>>3];i=i;return}function JJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20048>>3]=-+h[b+20072>>3]/.195;i=i;return}function KJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20056>>3]=+h[b+20072>>3]/.195+1.0;i=i;return}function LJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+9|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+9|0]|0;k=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20008>>3],0.0,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=k;f=j;break}else{j=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20008>>3],0.0,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+9|0]|0;j=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20008>>3],0.0)|0;a[(c[b+352>>2]|0)+9|0]=j;f=g;break}else{g=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20008>>3],0.0)|0;a[(c[b+352>>2]|0)+9|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+11|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+11|0]|0;j=b+4|0;k=YOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20056>>3],.93,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=k;l=j;m=e;break}else{e=b+4|0;j=YOb(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20056>>3],.93,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+11|0]|0;j=b+4|0;e=$Ob(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20056>>3],.93)|0;a[(c[b+352>>2]|0)+11|0]=e;l=j;m=f;break}else{f=b+4|0;j=$Ob(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20056>>3],.93)|0;a[(c[b+352>>2]|0)+11|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+20056>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+2e4|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+2e4|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+10|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+10|0]|0;l=b+4|0;f=XOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+20056>>3],.987,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=f;w=l;x=m;break}else{m=b+4|0;l=XOb(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+20056>>3],.987,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+10|0]|0;l=b+4|0;m=ZOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+20056>>3],.987)|0;a[(c[b+352>>2]|0)+10|0]=m;w=l;x=j;break}else{j=b+4|0;l=ZOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20056>>3],.987)|0;a[(c[b+352>>2]|0)+10|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+20056>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+2e4|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+2e4|0;v=u;h[v>>3]=s;i=d;return}}}function MJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20032>>3]=+h[b+2e4>>3]*1.0e-5;i=i;return}function NJ(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+21960>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+20064>>3]=b*b*+h[d+20032>>3]*-78539.81633974482;i=i;return}function OJ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+20024>>3]=+h[b+21968>>3]+ +h[b+21976>>3]*(1.0- +h[d+20056>>3]);i=i;return}function PJ(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+21984>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2e4>>3]*+h[j+20024>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+20016|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+20016|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,20160,20152,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+20016|0;p=o;h[p>>3]=m;i=d;return}function QJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20024>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+20040|0;p=o;h[p>>3]=m;i=d;return}q=+$Lb(c[b+536>>2]|0,j,20200,20192,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+20040|0;p=o;h[p>>3]=m;i=d;return}function RJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2032>>3]=+h[b+10656>>3]+ +h[b+16784>>3]*-.4999999999999999;i=i;return}function SJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10536>>3]=+h[b+2032>>3]+(+h[d+9320>>3]*.4999999999999999+ +h[d+9328>>3]*-.8660254037844387);i=i;return}function TJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2304>>3]=+h[b+2032>>3]+.05;i=i;return}function UJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9912>>3]=+h[b+2304>>3]- +h[b+9984>>3];i=i;return}function VJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2040>>3]=+h[b+10648>>3]+ +h[b+16784>>3]*.8660254037844387;i=i;return}function WJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10528>>3]=+h[b+2040>>3]+(+h[d+9320>>3]*-.8660254037844387+ +h[d+9328>>3]*-.4999999999999999);i=i;return}function XJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2312>>3]=+h[b+2040>>3]+-.08660254037844388;i=i;return}function YJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9904>>3]=+h[b+2312>>3]- +h[b+9976>>3];i=i;return}function ZJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7304>>3]=+h[b+14920>>3]*+h[b+8856>>3]+(+h[b+14912>>3]*+h[b+8864>>3]+ +h[b+16>>3]*(+h[b+14904>>3]*+h[b+9904>>3]+ +h[b+14896>>3]*+h[b+9912>>3]));i=i;return}function _J(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+21880>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7304>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7280|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7280|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,19920,20232,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7280|0;p=o;h[p>>3]=m;i=d;return}function $J(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7312>>3]=+h[b+14904>>3]*+h[b+8856>>3]+(+h[b+14896>>3]*+h[b+8864>>3]- +h[b+16>>3]*(+h[b+14920>>3]*+h[b+9904>>3]+ +h[b+14912>>3]*+h[b+9912>>3]));i=i;return}function aK(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+21880>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7312>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7288|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7288|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,19920,20240,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7288|0;p=o;h[p>>3]=m;i=d;return}function bK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2128>>3]=+h[b+14920>>3]*+h[b+9904>>3]+ +h[b+14912>>3]*+h[b+9912>>3];i=i;return}function cK(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+21880>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+14904>>3]*+h[j+8856>>3]+(+h[j+14896>>3]*+h[j+8864>>3]- +h[j+16>>3]*+h[j+2128>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+8840|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8840|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,19920,20248,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8840|0;p=o;h[p>>3]=m;i=d;return}function dK(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+21880>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2128>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+2240|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+2240|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,19920,20256,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2240|0;p=o;h[p>>3]=m;i=d;return}function eK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2120>>3]=+h[b+14904>>3]*+h[b+9904>>3]+ +h[b+14896>>3]*+h[b+9912>>3];i=i;return}function fK(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+21880>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+14920>>3]*+h[j+8856>>3]+(+h[j+14912>>3]*+h[j+8864>>3]+ +h[j+16>>3]*+h[j+2120>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+8832|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8832|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,19920,20264,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8832|0;p=o;h[p>>3]=m;i=d;return}function gK(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+21880>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2120>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+2232|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+2232|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,19920,20272,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2232|0;p=o;h[p>>3]=m;i=d;return}function hK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20856>>3]=(+h[b+2232>>3]*+h[b+7288>>3]+ +h[b+2240>>3]*+h[b+7280>>3])*2.0;i=i;return}function iK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7352>>3]=+h[b+2240>>3]*+h[b+14920>>3]+ +h[b+2232>>3]*+h[b+14904>>3];i=i;return}function jK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7360>>3]=+h[b+2240>>3]*+h[b+14912>>3]+ +h[b+2232>>3]*+h[b+14896>>3];i=i;return}function kK(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2240>>3];e=+h[b+2232>>3];h[b+20144>>3]=(+h[b+14920>>3]*d+ +h[b+14904>>3]*e)*-.8660254037844387+(d*+h[b+14912>>3]+e*+h[b+14896>>3])*.4999999999999999;i=i;return}function lK(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2232>>3];e=+h[b+2240>>3];h[b+20088>>3]=d*d+e*e;i=i;return}function mK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+20088>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=22632;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,20288,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+20856>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+20808|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+20808|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,20400,20280,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+20808|0;y=x;h[y>>3]=v;i=d;return}function nK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+20088>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+20080|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=22632;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,20288,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+20080|0;p=o;h[p>>3]=m;i=b;return}function oK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20080>>3];k=j*j;l=j*+h[g+7280>>3]- +h[g+2240>>3]*+h[g+20808>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4648|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4648|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,20480,20472,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4648|0;q=p;h[q>>3]=n;i=d;return}function pK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4664>>3]=-(+h[b+7344>>3]*+h[b+4648>>3]);i=i;return}function qK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20080>>3];k=j*j;l=+h[g+2232>>3]*+h[g+20808>>3]-j*+h[g+7288>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4640|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4640|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,20480,20544,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4640|0;q=p;h[q>>3]=n;i=d;return}function rK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4672>>3]=+h[b+7344>>3]*+h[b+4640>>3];i=i;return}function sK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20080>>3];k=+h[g+2240>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+15848|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+15848|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,20560,20552,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+15848|0;p=o;h[p>>3]=m;i=d;return}function tK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2160>>3]=-(+h[b+7344>>3]*+h[b+15848>>3]);i=i;return}function uK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20080>>3];k=+h[g+2232>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+15840|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+15840|0;q=p;h[q>>3]=n;i=d;return}k=l/+$Lb(c[b+536>>2]|0,j,20560,20616,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+15840|0;q=p;h[q>>3]=n;i=d;return}function vK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4656>>3]=+h[b+2240>>3]*+h[b+4648>>3]+(+h[b+7280>>3]*+h[b+15848>>3]+(-(+h[b+2232>>3]*+h[b+4640>>3])- +h[b+7288>>3]*+h[b+15840>>3]));i=i;return}function wK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7376>>3]=+h[b+15840>>3]*+h[b+14920>>3]+ +h[b+15848>>3]*+h[b+14904>>3];i=i;return}function xK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7384>>3]=+h[b+15840>>3]*+h[b+14912>>3]+ +h[b+15848>>3]*+h[b+14896>>3];i=i;return}function yK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2136>>3]=+h[b+15840>>3]*+h[b+8832>>3]+ +h[b+15848>>3]*+h[b+8840>>3];i=i;return}function zK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2152>>3]=+h[b+7344>>3]*+h[b+15840>>3];i=i;return}function AK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7328>>3]=+h[b+2160>>3]*+h[b+14920>>3]+ +h[b+2152>>3]*+h[b+14904>>3];i=i;return}function BK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2104>>3]=+h[b+9976>>3]+(+h[b+7328>>3]*+h[d+8680>>3]+(+h[b+7352>>3]*+h[d+8688>>3]+ +h[b+7376>>3]*+h[d+8696>>3]));i=i;return}function CK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7336>>3]=+h[b+2160>>3]*+h[b+14912>>3]+ +h[b+2152>>3]*+h[b+14896>>3];i=i;return}function DK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2112>>3]=+h[b+9984>>3]+(+h[b+7336>>3]*+h[d+8680>>3]+(+h[b+7360>>3]*+h[d+8688>>3]+ +h[b+7384>>3]*+h[d+8696>>3]));i=i;return}function EK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2088>>3]=-(+h[b+2152>>3]*+h[b+8840>>3])- +h[b+2160>>3]*+h[b+8832>>3];i=i;return}function FK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20080>>3];k=+h[g+2152>>3]*+h[g+8832>>3]- +h[g+2160>>3]*+h[g+8840>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2144|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2144|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,20560,20624,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2144|0;p=o;h[p>>3]=m;i=d;return}function GK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2080>>3]=+h[b+7344>>3]*+h[b+16>>3]+ +h[b+2144>>3];i=i;return}function HK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7320>>3]=+h[b+2240>>3]*+h[b+15848>>3]- +h[b+2232>>3]*+h[b+15840>>3];i=i;return}function IK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2096>>3]=+h[b+9968>>3]+(+h[b+7320>>3]*+h[d+8680>>3]+ +h[b+7344>>3]*+h[d+8688>>3]);i=i;return}function JK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2072>>3]=+h[b+7320>>3]*+h[b+16>>3]+ +h[b+2136>>3];i=i;return}function KK(a){a=a|0;h[(c[a+416>>2]|0)+22912>>3]=.175;i=i;return}function LK(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+22912>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+10016>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7528|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7528|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,20640,20632,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7528|0;p=o;h[p>>3]=m;i=d;return}function MK(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22832>>3]=+h[b+22912>>3];i=i;return}function NK(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22840>>3]=+h[b+22912>>3];i=i;return}function OK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0;d=i;i=i+64|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+8|0;p=b+4|0;q=c[(c[c[p>>2]>>2]|0)+8>>2]|0;r=+h[q+10064>>3];s=+h[q+10080>>3];t=l;h[k>>3]=+h[q+10072>>3];c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=l+8|0;h[k>>3]=s;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];UMb(m,3,r,l);l=c[(c[c[p>>2]>>2]|0)+8>>2]|0;r=+h[l+15160>>3];s=+h[l+15176>>3];p=j;h[k>>3]=+h[l+15168>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j+8|0;h[k>>3]=s;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];UMb(n,3,r,j);j=c[b+536>>2]|0;p=c[b+416>>2]|0;r=+h[p+22840>>3];s=+h[p+22848>>3]+ +h[p+22856>>3];p=g;l=18072;c[p+0>>2]=c[l+0>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];l=f;p=m;c[l+0>>2]=c[p+0>>2];c[l+4>>2]=c[p+4>>2];c[l+8>>2]=c[p+8>>2];p=e;l=n;c[p+0>>2]=c[l+0>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];dv(o,j,r,g,s,f,e);a[(c[b+424>>2]|0)+179|0]=a[o]|0;i=d;return}function PK(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+10040>>3];e=+h[b+10048>>3];f=+h[b+10056>>3];g=+h[(c[a+416>>2]|0)+22840>>3];h[b+19968>>3]=d*d+(e*e+(f*f-g*g));i=i;return}function QK(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+19960>>3];h[b+19944>>3]=d*d- +h[b+19968>>3];i=i;return}function RK(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;av(d,c[a+536>>2]|0,+h[f+19944>>3],1.0e-12,+h[f+21064>>3],0.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+21072>>3]=+h[d>>3];i=b;return}function SK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;bv(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19944>>3],1.0e-12);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19936>>3]=+h[d>>3];i=b;return}function TK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+19936>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=22632;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,20704,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+21072>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+21056|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+21056|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,20808,20696,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+21056|0;y=x;h[y>>3]=v;i=d;return}function UK(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+21048>>3];g=+h[e+21056>>3];if((a[(c[b+424>>2]|0)+179|0]|0)!=0){j=g;k=f-j;l=e;m=l+19848|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+19848|0;n=m;h[n>>3]=k;i=d;return}function VK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8536>>3]=+h[b+19848>>3]*.4999999999999999;i=i;return}function WK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8584>>3]=+h[b+8536>>3]- +h[b+8656>>3];i=i;return}function XK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8528>>3]=+h[b+19848>>3]*.8660254037844387;i=i;return}function YK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8576>>3]=+h[b+8528>>3]- +h[b+8648>>3];i=i;return}function ZK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+19936>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+19952|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=22632;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,20704,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+19952|0;p=o;h[p>>3]=m;i=b;return}function _K(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+19960>>3];g=+h[e+19952>>3];if((a[(c[b+424>>2]|0)+179|0]|0)!=0){j=g;k=f-j;l=e;m=l+17016|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+17016|0;n=m;h[n>>3]=k;i=d;return}function $K(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19912>>3]=+h[(c[a+416>>2]|0)+22848>>3]+ +h[b+17016>>3];i=i;return}function aL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19888>>3]=-+h[b+19912>>3]/.195;i=i;return}function bL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19896>>3]=+h[b+19912>>3]/.195+1.0;i=i;return}function cL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+6|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+6|0]|0;k=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19848>>3],0.0,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;f=j;break}else{j=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19848>>3],0.0,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+6|0]|0;j=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19848>>3],0.0)|0;a[(c[b+352>>2]|0)+6|0]=j;f=g;break}else{g=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19848>>3],0.0)|0;a[(c[b+352>>2]|0)+6|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+8|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+8|0]|0;j=b+4|0;k=YOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19896>>3],.93,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=k;l=j;m=e;break}else{e=b+4|0;j=YOb(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19896>>3],.93,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+8|0]|0;j=b+4|0;e=$Ob(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19896>>3],.93)|0;a[(c[b+352>>2]|0)+8|0]=e;l=j;m=f;break}else{f=b+4|0;j=$Ob(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19896>>3],.93)|0;a[(c[b+352>>2]|0)+8|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+19896>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+19840|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+19840|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+7|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+7|0]|0;l=b+4|0;f=XOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+19896>>3],.987,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=f;w=l;x=m;break}else{m=b+4|0;l=XOb(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+19896>>3],.987,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+7|0]|0;l=b+4|0;m=ZOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+19896>>3],.987)|0;a[(c[b+352>>2]|0)+7|0]=m;w=l;x=j;break}else{j=b+4|0;l=ZOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19896>>3],.987)|0;a[(c[b+352>>2]|0)+7|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+19896>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+19840|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+19840|0;v=u;h[v>>3]=s;i=d;return}}}function dL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19872>>3]=+h[b+19840>>3]*1.0e-5;i=i;return}function eL(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+22992>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+19904>>3]=b*b*+h[d+19872>>3]*-78539.81633974482;i=i;return}function fL(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+19864>>3]=+h[b+23e3>>3]+ +h[b+23008>>3]*(1.0- +h[d+19896>>3]);i=i;return}function gL(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+23016>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+19840>>3]*+h[j+19864>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+19856|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+19856|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,20880,20872,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+19856|0;p=o;h[p>>3]=m;i=d;return}function hL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19864>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+19880|0;p=o;h[p>>3]=m;i=d;return}q=+$Lb(c[b+536>>2]|0,j,20920,20912,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+19880|0;p=o;h[p>>3]=m;i=d;return}function iL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1312>>3]=+h[b+10680>>3]+ +h[b+17016>>3]*.4999999999999999;i=i;return}function jL(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10560>>3]=+h[b+1312>>3]+(+h[d+12336>>3]*-.4999999999999999+ +h[d+12344>>3]*-.8660254037844387);i=i;return}function kL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1584>>3]=+h[b+1312>>3]+-.05;i=i;return}function lL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10032>>3]=+h[b+1584>>3]- +h[b+10104>>3];i=i;return}function mL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1320>>3]=+h[b+10672>>3]+ +h[b+17016>>3]*.8660254037844387;i=i;return}function nL(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10552>>3]=+h[b+1320>>3]+(+h[d+12336>>3]*-.8660254037844387+ +h[d+12344>>3]*.4999999999999999);i=i;return}function oL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1592>>3]=+h[b+1320>>3]+-.08660254037844388;i=i;return}function pL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10024>>3]=+h[b+1592>>3]- +h[b+10096>>3];i=i;return}function qL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7488>>3]=+h[b+14968>>3]*+h[b+8576>>3]+(+h[b+14960>>3]*+h[b+8584>>3]+ +h[b+16>>3]*(+h[b+14952>>3]*+h[b+10024>>3]+ +h[b+14944>>3]*+h[b+10032>>3]));i=i;return}function rL(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+22912>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7488>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7464|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7464|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,20640,20952,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7464|0;p=o;h[p>>3]=m;i=d;return}function sL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7496>>3]=+h[b+14952>>3]*+h[b+8576>>3]+(+h[b+14944>>3]*+h[b+8584>>3]- +h[b+16>>3]*(+h[b+14968>>3]*+h[b+10024>>3]+ +h[b+14960>>3]*+h[b+10032>>3]));i=i;return}function tL(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+22912>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7496>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7472|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7472|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,20640,20960,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7472|0;p=o;h[p>>3]=m;i=d;return}function uL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1408>>3]=+h[b+14968>>3]*+h[b+10024>>3]+ +h[b+14960>>3]*+h[b+10032>>3];i=i;return}function vL(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+22912>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+14952>>3]*+h[j+8576>>3]+(+h[j+14944>>3]*+h[j+8584>>3]- +h[j+16>>3]*+h[j+1408>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+8560|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8560|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,20640,20968,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8560|0;p=o;h[p>>3]=m;i=d;return}function wL(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+22912>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1408>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+1520|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1520|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,20640,20976,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1520|0;p=o;h[p>>3]=m;i=d;return}function xL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1400>>3]=+h[b+14952>>3]*+h[b+10024>>3]+ +h[b+14944>>3]*+h[b+10032>>3];i=i;return}function yL(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+22912>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+14968>>3]*+h[j+8576>>3]+(+h[j+14960>>3]*+h[j+8584>>3]+ +h[j+16>>3]*+h[j+1400>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+8552|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8552|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,20640,20984,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8552|0;p=o;h[p>>3]=m;i=d;return}function zL(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+22912>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1400>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+1512|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1512|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,20640,20992,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1512|0;p=o;h[p>>3]=m;i=d;return}function AL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20864>>3]=(+h[b+1512>>3]*+h[b+7472>>3]+ +h[b+1520>>3]*+h[b+7464>>3])*2.0;i=i;return}function BL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7536>>3]=+h[b+1520>>3]*+h[b+14968>>3]+ +h[b+1512>>3]*+h[b+14952>>3];i=i;return}function CL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7544>>3]=+h[b+1520>>3]*+h[b+14960>>3]+ +h[b+1512>>3]*+h[b+14944>>3];i=i;return}function DL(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1520>>3];e=+h[b+1512>>3];h[b+19984>>3]=(+h[b+14968>>3]*d+ +h[b+14952>>3]*e)*-.8660254037844387+(d*+h[b+14960>>3]+e*+h[b+14944>>3])*-.4999999999999999;i=i;return}function EL(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1512>>3];e=+h[b+1520>>3];h[b+19928>>3]=d*d+e*e;i=i;return}function FL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+19928>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=22632;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,21008,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+20864>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+20816|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+20816|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,21120,21e3,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+20816|0;y=x;h[y>>3]=v;i=d;return}function GL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+19928>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+19920|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=22632;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,21008,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+19920|0;p=o;h[p>>3]=m;i=b;return}function HL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19920>>3];k=j*j;l=j*+h[g+7464>>3]- +h[g+1520>>3]*+h[g+20816>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4720|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4720|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,21200,21192,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4720|0;q=p;h[q>>3]=n;i=d;return}function IL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4736>>3]=-(+h[b+7528>>3]*+h[b+4720>>3]);i=i;return}function JL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19920>>3];k=j*j;l=+h[g+1512>>3]*+h[g+20816>>3]-j*+h[g+7472>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4712|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4712|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,21200,21264,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4712|0;q=p;h[q>>3]=n;i=d;return}function KL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4744>>3]=+h[b+7528>>3]*+h[b+4712>>3];i=i;return}function LL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19920>>3];k=+h[g+1520>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+15752|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+15752|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,21280,21272,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+15752|0;p=o;h[p>>3]=m;i=d;return}function ML(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1440>>3]=-(+h[b+7528>>3]*+h[b+15752>>3]);i=i;return}function NL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19920>>3];k=+h[g+1512>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+15744|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+15744|0;q=p;h[q>>3]=n;i=d;return}k=l/+$Lb(c[b+536>>2]|0,j,21280,21336,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+15744|0;q=p;h[q>>3]=n;i=d;return}function OL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4728>>3]=+h[b+1520>>3]*+h[b+4720>>3]+(+h[b+7464>>3]*+h[b+15752>>3]+(-(+h[b+1512>>3]*+h[b+4712>>3])- +h[b+7472>>3]*+h[b+15744>>3]));i=i;return}function PL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7560>>3]=+h[b+15744>>3]*+h[b+14968>>3]+ +h[b+15752>>3]*+h[b+14952>>3];i=i;return}function QL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7568>>3]=+h[b+15744>>3]*+h[b+14960>>3]+ +h[b+15752>>3]*+h[b+14944>>3];i=i;return}function RL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1416>>3]=+h[b+15744>>3]*+h[b+8552>>3]+ +h[b+15752>>3]*+h[b+8560>>3];i=i;return}function SL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1432>>3]=+h[b+7528>>3]*+h[b+15744>>3];i=i;return}function TL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7512>>3]=+h[b+1440>>3]*+h[b+14968>>3]+ +h[b+1432>>3]*+h[b+14952>>3];i=i;return}function UL(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1384>>3]=+h[b+10096>>3]+(+h[b+7512>>3]*+h[d+11696>>3]+(+h[b+7536>>3]*+h[d+11704>>3]+ +h[b+7560>>3]*+h[d+11712>>3]));i=i;return}function VL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7520>>3]=+h[b+1440>>3]*+h[b+14960>>3]+ +h[b+1432>>3]*+h[b+14944>>3];i=i;return}function WL(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1392>>3]=+h[b+10104>>3]+(+h[b+7520>>3]*+h[d+11696>>3]+(+h[b+7544>>3]*+h[d+11704>>3]+ +h[b+7568>>3]*+h[d+11712>>3]));i=i;return}function XL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1368>>3]=-(+h[b+1432>>3]*+h[b+8560>>3])- +h[b+1440>>3]*+h[b+8552>>3];i=i;return}function YL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19920>>3];k=+h[g+1432>>3]*+h[g+8552>>3]- +h[g+1440>>3]*+h[g+8560>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1424|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1424|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,21280,21344,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1424|0;p=o;h[p>>3]=m;i=d;return}function ZL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1360>>3]=+h[b+7528>>3]*+h[b+16>>3]+ +h[b+1424>>3];i=i;return}function _L(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7504>>3]=+h[b+1520>>3]*+h[b+15752>>3]- +h[b+1512>>3]*+h[b+15744>>3];i=i;return}function $L(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1376>>3]=+h[b+10088>>3]+(+h[b+7504>>3]*+h[d+11696>>3]+ +h[b+7528>>3]*+h[d+11704>>3]);i=i;return}function aM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1352>>3]=+h[b+7504>>3]*+h[b+16>>3]+ +h[b+1416>>3];i=i;return}function bM(a){a=a|0;h[(c[a+416>>2]|0)+23944>>3]=.175;i=i;return}function cM(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+23944>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+10136>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7712|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7712|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,21360,21352,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7712|0;p=o;h[p>>3]=m;i=d;return}function dM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23864>>3]=+h[b+23944>>3];i=i;return}function eM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23872>>3]=+h[b+23944>>3];i=i;return}function fM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0;d=i;i=i+64|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+8|0;p=b+4|0;q=c[(c[c[p>>2]>>2]|0)+8>>2]|0;r=+h[q+10184>>3];s=+h[q+10200>>3];t=l;h[k>>3]=+h[q+10192>>3];c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=l+8|0;h[k>>3]=s;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];UMb(m,3,r,l);l=c[(c[c[p>>2]>>2]|0)+8>>2]|0;r=+h[l+15184>>3];s=+h[l+15200>>3];p=j;h[k>>3]=+h[l+15192>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j+8|0;h[k>>3]=s;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];UMb(n,3,r,j);j=c[b+536>>2]|0;p=c[b+416>>2]|0;r=+h[p+23872>>3];s=+h[p+23880>>3]+ +h[p+23888>>3];p=g;l=18072;c[p+0>>2]=c[l+0>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];l=f;p=m;c[l+0>>2]=c[p+0>>2];c[l+4>>2]=c[p+4>>2];c[l+8>>2]=c[p+8>>2];p=e;l=n;c[p+0>>2]=c[l+0>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];dv(o,j,r,g,s,f,e);a[(c[b+424>>2]|0)+227|0]=a[o]|0;i=d;return}function gM(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+10160>>3];e=+h[b+10168>>3];f=+h[b+10176>>3];g=+h[(c[a+416>>2]|0)+23872>>3];h[b+19808>>3]=d*d+(e*e+(f*f-g*g));i=i;return}function hM(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+19800>>3];h[b+19784>>3]=d*d- +h[b+19808>>3];i=i;return}function iM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;av(d,c[a+536>>2]|0,+h[f+19784>>3],1.0e-12,+h[f+21112>>3],0.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+21120>>3]=+h[d>>3];i=b;return}function jM(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;bv(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19784>>3],1.0e-12);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19776>>3]=+h[d>>3];i=b;return}function kM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+19776>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=22632;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,21424,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+21120>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+21104|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+21104|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,21528,21416,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+21104|0;y=x;h[y>>3]=v;i=d;return}function lM(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+21096>>3];g=+h[e+21104>>3];if((a[(c[b+424>>2]|0)+227|0]|0)!=0){j=g;k=f-j;l=e;m=l+19688|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+19688|0;n=m;h[n>>3]=k;i=d;return}function mM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8256>>3]=+h[b+19688>>3]*-.4999999999999999;i=i;return}function nM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8304>>3]=+h[b+8256>>3]- +h[b+8376>>3];i=i;return}function oM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8248>>3]=+h[b+19688>>3]*.8660254037844387;i=i;return}function pM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8296>>3]=+h[b+8248>>3]- +h[b+8368>>3];i=i;return}function qM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+19776>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+19792|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=22632;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,21424,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+19792|0;p=o;h[p>>3]=m;i=b;return}function rM(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+19800>>3];g=+h[e+19792>>3];if((a[(c[b+424>>2]|0)+227|0]|0)!=0){j=g;k=f-j;l=e;m=l+17248|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+17248|0;n=m;h[n>>3]=k;i=d;return}function sM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19752>>3]=+h[(c[a+416>>2]|0)+23880>>3]+ +h[b+17248>>3];i=i;return}function tM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19728>>3]=-+h[b+19752>>3]/.195;i=i;return}function uM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19736>>3]=+h[b+19752>>3]/.195+1.0;i=i;return}function vM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+3|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+3|0]|0;k=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19688>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;f=j;break}else{j=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19688>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+3|0]|0;j=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19688>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=j;f=g;break}else{g=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19688>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+5|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+5|0]|0;j=b+4|0;k=YOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19736>>3],.93,a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=k;l=j;m=e;break}else{e=b+4|0;j=YOb(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19736>>3],.93,a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+5|0]|0;j=b+4|0;e=$Ob(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19736>>3],.93)|0;a[(c[b+352>>2]|0)+5|0]=e;l=j;m=f;break}else{f=b+4|0;j=$Ob(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19736>>3],.93)|0;a[(c[b+352>>2]|0)+5|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+19736>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+19680|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+19680|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+4|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+4|0]|0;l=b+4|0;f=XOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+19736>>3],.987,a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=f;w=l;x=m;break}else{m=b+4|0;l=XOb(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+19736>>3],.987,a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+4|0]|0;l=b+4|0;m=ZOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+19736>>3],.987)|0;a[(c[b+352>>2]|0)+4|0]=m;w=l;x=j;break}else{j=b+4|0;l=ZOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19736>>3],.987)|0;a[(c[b+352>>2]|0)+4|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+19736>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+19680|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+19680|0;v=u;h[v>>3]=s;i=d;return}}}function wM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19712>>3]=+h[b+19680>>3]*1.0e-5;i=i;return}function xM(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+24024>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+19744>>3]=b*b*+h[d+19712>>3]*-78539.81633974482;i=i;return}function yM(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+19704>>3]=+h[b+24032>>3]+ +h[b+24040>>3]*(1.0- +h[d+19736>>3]);i=i;return}function zM(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+24048>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+19680>>3]*+h[j+19704>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+19696|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+19696|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,21600,21592,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+19696|0;p=o;h[p>>3]=m;i=d;return}function AM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19704>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+19720|0;p=o;h[p>>3]=m;i=d;return}q=+$Lb(c[b+536>>2]|0,j,21640,21632,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+19720|0;p=o;h[p>>3]=m;i=d;return}function BM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+592>>3]=+h[b+10704>>3]+ +h[b+17248>>3]*-.4999999999999999;i=i;return}function CM(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10584>>3]=+h[b+592>>3]+(+h[d+15352>>3]*.4999999999999999+ +h[d+15360>>3]*-.8660254037844387);i=i;return}function DM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+864>>3]=+h[b+592>>3]+.05;i=i;return}function EM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10152>>3]=+h[b+864>>3]- +h[b+10224>>3];i=i;return}function FM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+600>>3]=+h[b+10696>>3]+ +h[b+17248>>3]*.8660254037844387;i=i;return}function GM(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10576>>3]=+h[b+600>>3]+(+h[d+15352>>3]*-.8660254037844387+ +h[d+15360>>3]*-.4999999999999999);i=i;return}function HM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+872>>3]=+h[b+600>>3]+-.08660254037844388;i=i;return}function IM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10144>>3]=+h[b+872>>3]- +h[b+10216>>3];i=i;return}function JM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7672>>3]=+h[b+15016>>3]*+h[b+8296>>3]+(+h[b+15008>>3]*+h[b+8304>>3]+ +h[b+16>>3]*(+h[b+15e3>>3]*+h[b+10144>>3]+ +h[b+14992>>3]*+h[b+10152>>3]));i=i;return}function KM(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+23944>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7672>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7648|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7648|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,21360,21672,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7648|0;p=o;h[p>>3]=m;i=d;return}function LM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7680>>3]=+h[b+15e3>>3]*+h[b+8296>>3]+(+h[b+14992>>3]*+h[b+8304>>3]- +h[b+16>>3]*(+h[b+15016>>3]*+h[b+10144>>3]+ +h[b+15008>>3]*+h[b+10152>>3]));i=i;return}function MM(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+23944>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7680>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7656|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7656|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,21360,21680,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7656|0;p=o;h[p>>3]=m;i=d;return}function NM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+688>>3]=+h[b+15016>>3]*+h[b+10144>>3]+ +h[b+15008>>3]*+h[b+10152>>3];i=i;return}function OM(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+23944>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+15e3>>3]*+h[j+8296>>3]+(+h[j+14992>>3]*+h[j+8304>>3]- +h[j+16>>3]*+h[j+688>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+8280|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8280|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,21360,21688,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8280|0;p=o;h[p>>3]=m;i=d;return}function PM(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+23944>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+688>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+800|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+800|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,21360,21696,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+800|0;p=o;h[p>>3]=m;i=d;return}function QM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+680>>3]=+h[b+15e3>>3]*+h[b+10144>>3]+ +h[b+14992>>3]*+h[b+10152>>3];i=i;return}function RM(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+23944>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+15016>>3]*+h[j+8296>>3]+(+h[j+15008>>3]*+h[j+8304>>3]+ +h[j+16>>3]*+h[j+680>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+8272|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8272|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,21360,21704,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8272|0;p=o;h[p>>3]=m;i=d;return}function SM(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+23944>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+680>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+792|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+792|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,21360,21712,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+792|0;p=o;h[p>>3]=m;i=d;return}function TM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20872>>3]=(+h[b+792>>3]*+h[b+7656>>3]+ +h[b+800>>3]*+h[b+7648>>3])*2.0;i=i;return}function UM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7720>>3]=+h[b+800>>3]*+h[b+15016>>3]+ +h[b+792>>3]*+h[b+15e3>>3];i=i;return}function VM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7728>>3]=+h[b+800>>3]*+h[b+15008>>3]+ +h[b+792>>3]*+h[b+14992>>3];i=i;return}function WM(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+800>>3];e=+h[b+792>>3];h[b+19824>>3]=(+h[b+15016>>3]*d+ +h[b+15e3>>3]*e)*-.8660254037844387+(d*+h[b+15008>>3]+e*+h[b+14992>>3])*.4999999999999999;i=i;return}function XM(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+792>>3];e=+h[b+800>>3];h[b+19768>>3]=d*d+e*e;i=i;return}function YM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+19768>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=22632;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,21728,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+20872>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+20824|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+20824|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,21840,21720,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+20824|0;y=x;h[y>>3]=v;i=d;return}function ZM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+19768>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+19760|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=22632;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,21728,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+19760|0;p=o;h[p>>3]=m;i=b;return}function _M(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19760>>3];k=j*j;l=j*+h[g+7648>>3]- +h[g+800>>3]*+h[g+20824>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4792|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4792|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,21920,21912,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4792|0;q=p;h[q>>3]=n;i=d;return}function $M(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4808>>3]=-(+h[b+7712>>3]*+h[b+4792>>3]);i=i;return}function aN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19760>>3];k=j*j;l=+h[g+792>>3]*+h[g+20824>>3]-j*+h[g+7656>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4784|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4784|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,21920,21984,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4784|0;q=p;h[q>>3]=n;i=d;return}function bN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4816>>3]=+h[b+7712>>3]*+h[b+4784>>3];i=i;return}function cN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19760>>3];k=+h[g+800>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+15656|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+15656|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,22e3,21992,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+15656|0;p=o;h[p>>3]=m;i=d;return}function dN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+720>>3]=-(+h[b+7712>>3]*+h[b+15656>>3]);i=i;return}function eN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19760>>3];k=+h[g+792>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+15648|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+15648|0;q=p;h[q>>3]=n;i=d;return}k=l/+$Lb(c[b+536>>2]|0,j,22e3,22056,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+15648|0;q=p;h[q>>3]=n;i=d;return}function fN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4800>>3]=+h[b+800>>3]*+h[b+4792>>3]+(+h[b+7648>>3]*+h[b+15656>>3]+(-(+h[b+792>>3]*+h[b+4784>>3])- +h[b+7656>>3]*+h[b+15648>>3]));i=i;return}function gN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7744>>3]=+h[b+15648>>3]*+h[b+15016>>3]+ +h[b+15656>>3]*+h[b+15e3>>3];i=i;return}function hN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7752>>3]=+h[b+15648>>3]*+h[b+15008>>3]+ +h[b+15656>>3]*+h[b+14992>>3];i=i;return}function iN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+696>>3]=+h[b+15648>>3]*+h[b+8272>>3]+ +h[b+15656>>3]*+h[b+8280>>3];i=i;return}function jN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+712>>3]=+h[b+7712>>3]*+h[b+15648>>3];i=i;return}function kN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7696>>3]=+h[b+720>>3]*+h[b+15016>>3]+ +h[b+712>>3]*+h[b+15e3>>3];i=i;return}function lN(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+664>>3]=+h[b+10216>>3]+(+h[b+7696>>3]*+h[d+14712>>3]+(+h[b+7720>>3]*+h[d+14720>>3]+ +h[b+7744>>3]*+h[d+14728>>3]));i=i;return}function mN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7704>>3]=+h[b+720>>3]*+h[b+15008>>3]+ +h[b+712>>3]*+h[b+14992>>3];i=i;return}function nN(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+672>>3]=+h[b+10224>>3]+(+h[b+7704>>3]*+h[d+14712>>3]+(+h[b+7728>>3]*+h[d+14720>>3]+ +h[b+7752>>3]*+h[d+14728>>3]));i=i;return}function oN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+648>>3]=-(+h[b+712>>3]*+h[b+8280>>3])- +h[b+720>>3]*+h[b+8272>>3];i=i;return}function pN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19760>>3];k=+h[g+712>>3]*+h[g+8272>>3]- +h[g+720>>3]*+h[g+8280>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+704|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+704|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,22e3,22064,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+704|0;p=o;h[p>>3]=m;i=d;return}function qN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+640>>3]=+h[b+7712>>3]*+h[b+16>>3]+ +h[b+704>>3];i=i;return}function rN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7688>>3]=+h[b+800>>3]*+h[b+15656>>3]- +h[b+792>>3]*+h[b+15648>>3];i=i;return}function sN(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+656>>3]=+h[b+10208>>3]+(+h[b+7688>>3]*+h[d+14712>>3]+ +h[b+7712>>3]*+h[d+14720>>3]);i=i;return}function tN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+632>>3]=+h[b+7688>>3]*+h[b+16>>3]+ +h[b+696>>3];i=i;return}function uN(a){a=a|0;h[(c[a+416>>2]|0)+24976>>3]=.175;i=i;return}function vN(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+24976>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+10256>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7944|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7944|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,22080,22072,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7944|0;p=o;h[p>>3]=m;i=d;return}function wN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24896>>3]=+h[b+24976>>3];i=i;return}function xN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24904>>3]=+h[b+24976>>3];i=i;return}function yN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0;d=i;i=i+64|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+8|0;p=b+4|0;q=c[(c[c[p>>2]>>2]|0)+8>>2]|0;r=+h[q+10304>>3];s=+h[q+10320>>3];t=l;h[k>>3]=+h[q+10312>>3];c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=l+8|0;h[k>>3]=s;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];UMb(m,3,r,l);l=c[(c[c[p>>2]>>2]|0)+8>>2]|0;r=+h[l+15208>>3];s=+h[l+15224>>3];p=j;h[k>>3]=+h[l+15216>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j+8|0;h[k>>3]=s;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];UMb(n,3,r,j);j=c[b+536>>2]|0;p=c[b+416>>2]|0;r=+h[p+24904>>3];s=+h[p+24912>>3]+ +h[p+24920>>3];p=g;l=18072;c[p+0>>2]=c[l+0>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];l=f;p=m;c[l+0>>2]=c[p+0>>2];c[l+4>>2]=c[p+4>>2];c[l+8>>2]=c[p+8>>2];p=e;l=n;c[p+0>>2]=c[l+0>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];dv(o,j,r,g,s,f,e);a[(c[b+424>>2]|0)+275|0]=a[o]|0;i=d;return}function zN(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+10280>>3];e=+h[b+10288>>3];f=+h[b+10296>>3];g=+h[(c[a+416>>2]|0)+24904>>3];h[b+19648>>3]=d*d+(e*e+(f*f-g*g));i=i;return}function AN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+19640>>3];h[b+19624>>3]=d*d- +h[b+19648>>3];i=i;return}function BN(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;av(d,c[a+536>>2]|0,+h[f+19624>>3],1.0e-12,+h[f+21160>>3],0.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+21168>>3]=+h[d>>3];i=b;return}function CN(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;bv(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19624>>3],1.0e-12);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19616>>3]=+h[d>>3];i=b;return}function DN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+19616>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=22632;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,22144,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+21168>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+21152|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+21152|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,22248,22136,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+21152|0;y=x;h[y>>3]=v;i=d;return}function EN(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+21144>>3];g=+h[e+21152>>3];if((a[(c[b+424>>2]|0)+275|0]|0)!=0){j=g;k=f-j;l=e;m=l+19528|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+19528|0;n=m;h[n>>3]=k;i=d;return}function FN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8024>>3]=+h[b+19528>>3]*.4999999999999999;i=i;return}function GN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8072>>3]=+h[b+8024>>3]- +h[b+8144>>3];i=i;return}function HN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8016>>3]=+h[b+19528>>3]*.8660254037844387;i=i;return}function IN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8064>>3]=+h[b+8016>>3]- +h[b+8136>>3];i=i;return}function JN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+19616>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+19632|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=22632;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,22144,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+19632|0;p=o;h[p>>3]=m;i=b;return}function KN(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+19640>>3];g=+h[e+19632>>3];if((a[(c[b+424>>2]|0)+275|0]|0)!=0){j=g;k=f-j;l=e;m=l+17480|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+17480|0;n=m;h[n>>3]=k;i=d;return}function LN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19592>>3]=+h[(c[a+416>>2]|0)+24912>>3]+ +h[b+17480>>3];i=i;return}function MN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19568>>3]=-+h[b+19592>>3]/.195;i=i;return}function NN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19576>>3]=+h[b+19592>>3]/.195+1.0;i=i;return}function ON(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19528>>3],0.0,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;f=j;break}else{j=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19528>>3],0.0,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;f=j;break}}else{if(g){g=a[c[b+356>>2]|0]|0;j=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19528>>3],0.0)|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19528>>3],0.0)|0;a[c[b+352>>2]|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+2|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+2|0]|0;j=b+4|0;k=YOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19576>>3],.93,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=k;l=j;m=e;break}else{e=b+4|0;j=YOb(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19576>>3],.93,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+2|0]|0;j=b+4|0;e=$Ob(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19576>>3],.93)|0;a[(c[b+352>>2]|0)+2|0]=e;l=j;m=f;break}else{f=b+4|0;j=$Ob(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19576>>3],.93)|0;a[(c[b+352>>2]|0)+2|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+19576>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+19520|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+19520|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+1|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+1|0]|0;l=b+4|0;f=XOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+19576>>3],.987,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=f;w=l;x=m;break}else{m=b+4|0;l=XOb(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+19576>>3],.987,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+1|0]|0;l=b+4|0;m=ZOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+19576>>3],.987)|0;a[(c[b+352>>2]|0)+1|0]=m;w=l;x=j;break}else{j=b+4|0;l=ZOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19576>>3],.987)|0;a[(c[b+352>>2]|0)+1|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+19576>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+19520|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+19520|0;v=u;h[v>>3]=s;i=d;return}}}function PN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19552>>3]=+h[b+19520>>3]*1.0e-5;i=i;return}function QN(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+25056>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+19584>>3]=b*b*+h[d+19552>>3]*-78539.81633974482;i=i;return}function RN(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+19544>>3]=+h[b+25064>>3]+ +h[b+25072>>3]*(1.0- +h[d+19576>>3]);i=i;return}function SN(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+25080>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+19520>>3]*+h[j+19544>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+19536|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+19536|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,22320,22312,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+19536|0;p=o;h[p>>3]=m;i=d;return}function TN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19544>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+19560|0;p=o;h[p>>3]=m;i=d;return}q=+$Lb(c[b+536>>2]|0,j,22360,22352,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+19560|0;p=o;h[p>>3]=m;i=d;return}function UN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=+h[b+10728>>3]+ +h[b+17480>>3]*.4999999999999999;i=i;return}function VN(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10608>>3]=+h[b+112>>3]+(+h[d+18368>>3]*-.4999999999999999+ +h[d+18376>>3]*-.8660254037844387);i=i;return}function WN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+384>>3]=+h[b+112>>3]+-.05;i=i;return}function XN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10272>>3]=+h[b+384>>3]- +h[b+10344>>3];i=i;return}function YN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+120>>3]=+h[b+10720>>3]+ +h[b+17480>>3]*.8660254037844387;i=i;return}function ZN(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10600>>3]=+h[b+120>>3]+(+h[d+18368>>3]*-.8660254037844387+ +h[d+18376>>3]*.4999999999999999);i=i;return}function _N(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+392>>3]=+h[b+120>>3]+-.08660254037844388;i=i;return}function $N(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10264>>3]=+h[b+392>>3]- +h[b+10336>>3];i=i;return}function aO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7904>>3]=+h[b+15064>>3]*+h[b+8064>>3]+(+h[b+15056>>3]*+h[b+8072>>3]+ +h[b+16>>3]*(+h[b+15048>>3]*+h[b+10264>>3]+ +h[b+15040>>3]*+h[b+10272>>3]));i=i;return}function bO(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+24976>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7904>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7880|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7880|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,22080,22392,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7880|0;p=o;h[p>>3]=m;i=d;return}function cO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7912>>3]=+h[b+15048>>3]*+h[b+8064>>3]+(+h[b+15040>>3]*+h[b+8072>>3]- +h[b+16>>3]*(+h[b+15064>>3]*+h[b+10264>>3]+ +h[b+15056>>3]*+h[b+10272>>3]));i=i;return}function dO(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+24976>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7912>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7888|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7888|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,22080,22400,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7888|0;p=o;h[p>>3]=m;i=d;return}function eO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+208>>3]=+h[b+15064>>3]*+h[b+10264>>3]+ +h[b+15056>>3]*+h[b+10272>>3];i=i;return}function fO(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+24976>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+15048>>3]*+h[j+8064>>3]+(+h[j+15040>>3]*+h[j+8072>>3]- +h[j+16>>3]*+h[j+208>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+8048|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8048|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,22080,22408,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8048|0;p=o;h[p>>3]=m;i=d;return}function gO(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+24976>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+208>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,22080,22416,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}function hO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+200>>3]=+h[b+15048>>3]*+h[b+10264>>3]+ +h[b+15040>>3]*+h[b+10272>>3];i=i;return}function iO(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+24976>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+15064>>3]*+h[j+8064>>3]+(+h[j+15056>>3]*+h[j+8072>>3]+ +h[j+16>>3]*+h[j+200>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+8040|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8040|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,22080,22424,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8040|0;p=o;h[p>>3]=m;i=d;return}function jO(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+24976>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+200>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+312|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+312|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,22080,22432,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+312|0;p=o;h[p>>3]=m;i=d;return}function kO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20880>>3]=(+h[b+312>>3]*+h[b+7888>>3]+ +h[b+320>>3]*+h[b+7880>>3])*2.0;i=i;return}function lO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7952>>3]=+h[b+320>>3]*+h[b+15064>>3]+ +h[b+312>>3]*+h[b+15048>>3];i=i;return}function mO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7960>>3]=+h[b+320>>3]*+h[b+15056>>3]+ +h[b+312>>3]*+h[b+15040>>3];i=i;return}function nO(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+320>>3];e=+h[b+312>>3];h[b+19664>>3]=(+h[b+15064>>3]*d+ +h[b+15048>>3]*e)*-.8660254037844387+(d*+h[b+15056>>3]+e*+h[b+15040>>3])*-.4999999999999999;i=i;return}function oO(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+312>>3];e=+h[b+320>>3];h[b+19608>>3]=d*d+e*e;i=i;return}function pO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+19608>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=22632;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,22448,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+20880>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+20832|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+20832|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,22560,22440,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+20832|0;y=x;h[y>>3]=v;i=d;return}function qO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+19608>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+19600|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=22632;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,22448,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+19600|0;p=o;h[p>>3]=m;i=b;return}function rO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19600>>3];k=j*j;l=j*+h[g+7880>>3]- +h[g+320>>3]*+h[g+20832>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4864|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4864|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,22664,22656,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4864|0;q=p;h[q>>3]=n;i=d;return}function sO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4880>>3]=-(+h[b+7944>>3]*+h[b+4864>>3]);i=i;return}



function hOb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;YLb(c[N>>2]|0,(c[M>>2]|0)!=0|0,261568,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){VLb(3,0,261600,B);VLb(3,0,261640,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];ge[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];VLb(3,0,261664,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];VLb(23,0,261704,y);if((c[z>>2]|0)==1){dNb(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){TPb(a)|0;ge[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 5:{yNb(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};case 7:{yNb(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 4:{yNb(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};case 3:{yNb(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 6:{yNb(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){yNb(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{yNb(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){sd(_|0)|0;sd($|0)|0;XLb(3,0,261736,x);VLb(3,0,261824,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){sd(_|0)|0;sd($|0)|0;$=qOb(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){TPb(a)|0;ge[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ge[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];XLb(1,0,261848,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[233572>>2]|0)!=0){VLb(3,1,261880,u);c[s>>2]=c[z>>2];VLb(3,0,261904,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];VLb(3,0,261928,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];VLb(3,0,261960,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];VLb(3,0,262e3,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];VLb(3,0,262048,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];VLb(3,0,262096,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];VLb(3,0,262136,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];VLb(3,0,262176,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];VLb(3,0,262216,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];VLb(3,0,262264,f);de[c[58528]&511](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){ab(262304,262336,410,262368)}VLb(3,0,262384,e);S=0;i=d;return S|0}function iOb(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;TPb(g)|0;a=f+540|0;ge[c[(c[a>>2]|0)+40>>2]&127](g)|0;ge[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function jOb(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;TPb(l)|0;b=k+540|0;ge[c[(c[b>>2]|0)+40>>2]&127](l)|0;ge[c[(c[b>>2]|0)+28>>2]&127](l)|0;sOb(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function kOb(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];TPb(g)|0;l=e+540|0;ge[c[(c[l>>2]|0)+40>>2]&127](g)|0;ge[c[(c[l>>2]|0)+28>>2]&127](g)|0;ge[c[(c[l>>2]|0)+32>>2]&127](g)|0;le[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function lOb(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;tOb(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function mOb(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;TPb(l)|0;b=k+540|0;ge[c[(c[b>>2]|0)+40>>2]&127](l)|0;ge[c[(c[b>>2]|0)+28>>2]&127](l)|0;rOb(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function nOb(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function oOb(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;uOb(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function pOb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function qOb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-11:{XLb(1,0,262792,d);m=-11;i=b;return m|0};case-2:{XLb(1,0,262408,k);m=-2;i=b;return m|0};case-1:{XLb(3,0,261736,l);m=1;i=b;return m|0};case-9:{XLb(1,0,262608,f);m=-9;i=b;return m|0};case-6:{XLb(1,0,262448,j);m=-6;i=b;return m|0};case-8:{XLb(1,0,262560,g);m=-8;i=b;return m|0};case-10:{XLb(1,0,262696,e);m=-10;i=b;return m|0};case-33:{XLb(1,0,262928,b);m=-33;i=b;return m|0};case-12:{XLb(1,0,262880,c);m=-12;i=b;return m|0};case-7:{XLb(1,0,262520,h);m=-7;i=b;return m|0};case-3:{m=-3;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function rOb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}ge[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function sOb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;ge[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function tOb(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+rd(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+rd(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;iOb(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}function uOb(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+rd(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+rd(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}iOb(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function vOb(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function wOb(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;de[c[(c[a+540>>2]|0)+112>>2]&511](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function xOb(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function yOb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=eMb(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{ue[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;cMb(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=eMb(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function zOb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((yOb(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}AOb(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(eMb(d)|0)>0;h=b?2:0;i=e;return h|0}function AOb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=aec(q)|0;s=r;t=aec(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[65922]=aMb(4)|0;if((r|0)==0){ab(263696,263712,308,263744)}if((t|0)==0){ab(263760,263712,309,263744)}v=hMb(b)|0;if((v|0)!=0){w=v;do{v=jMb(w)|0;c[l>>2]=c[v>>2];VLb(27,0,263776,l);w=iMb(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;Gec(t|0,c[a+384>>2]|0,v|0)|0;Gec(r|0,l|0,v|0)|0}h[d>>3]=+DOb(a,n,o,q,s,c[65922]|0,b);do{if((eMb(c[65922]|0)|0)==0){s=fMb(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=hMb(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=jMb(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=iMb(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];VLb(27,0,263824,j);v=hMb(b)|0;if((v|0)==0){break}else{B=v}do{v=jMb(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[65922]|0;dMb(v,jMb(B)|0);v=jMb(B)|0;c[g>>2]=c[v>>2];VLb(27,0,263848,g)}B=iMb(B)|0;}while((B|0)!=0)}}while(0);bMb(b);if((c[233588>>2]|0)!=0){eMb(c[65922]|0)|0}if((eMb(c[65922]|0)|0)>0){B=m;do{g=fMb(c[65922]|0)|0;c[m>>2]=c[g>>2];gMb(c[65922]|0);c[f>>2]=c[m>>2];VLb(7,0,263872,f);cMb(b,B);}while((eMb(c[65922]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){Gec(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}Ve(a);GOb(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){bec(t);bec(r);i=e;return}Gec(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;bec(t);bec(r);i=e;return}function BOb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){KOb(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];VLb(7,0,263416,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((eMb(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[233588>>2]|0)!=0){e=hMb(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=jMb(s)|0;x=c[e>>2]|0;e=ue[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;ULb(7,0,w,263440,l);s=iMb(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=jMb(hMb(d)|0)|0;x=ue[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;ULb(1,0,e,263456,j);c[s>>2]=1}}while(0);bMb(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;FOb(b);COb(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function COb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;VLb(27,0,264064,b);d=a+344|0;le[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function DOb(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=aec(p<<3)|0;if((q|0)==0){ab(263880,263712,409,263896)}if((p|0)>0){Gec(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];VLb(27,0,263912,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];VLb(27,0,263960,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){bec(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}TPb(a)|0;ge[c[(c[p>>2]|0)+40>>2]&127](a)|0;ge[c[(c[p>>2]|0)+28>>2]&127](a)|0;ge[c[(c[p>>2]|0)+32>>2]&127](a)|0;le[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(EOb(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}Gec(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}bec(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function EOb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;bMb(b);VLb(27,0,263984,g);g=hMb(d)|0;if((g|0)==0){j=eMb(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=jMb(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=jMb(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=jMb(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=jMb(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=jMb(a)|0;o=c[g>>2]|0;g=jMb(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?263400:263408;g=jMb(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?263400:263408;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;VLb(27,0,264024,f);cMb(b,jMb(a)|0)}a=iMb(a)|0;}while((a|0)!=0);j=eMb(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function FOb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;ue[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;GOb(b);HOb(b);ge[c[(c[g>>2]|0)+36>>2]&127](b)|0;IOb(b,8);h=JOb(b)|0;j=ge[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{HOb(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}KOb(b);GOb(b);IOb(b,8);ge[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=JOb(b)|0;j=ge[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){ZLb(c[b+536>>2]|0,264104,e)}else if((o|0)==7){HOb(b);i=d;return}}function GOb(a){a=a|0;var b=0;b=i;Gec(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function HOb(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function IOb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[233560+(d<<2)>>2]|0)==0){i=e;return}VLb(d,1,264528,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=ge[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=ge[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;VLb(d,0,264552,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}de[c[58528]&511](d);i=e;return}function JOb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function KOb(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;Gec(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;Gec(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;Gec(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;Gec(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function LOb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}le[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function MOb(a){a=a|0;var b=0;b=i;NOb(a);OOb(a);KOb(a);POb(a);i=b;return}function NOb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function OOb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function POb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((cNb(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];Gec(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;Gec(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;Gec(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;Gec(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(cNb(c[d>>2]|0)|0));i=b;return}function QOb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[233560+(d<<2)>>2]|0)==0){i=e;return}VLb(d,1,264200,q);q=b+136|0;if((c[q>>2]|0)>0){VLb(d,1,264224,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?264184:264192;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];VLb(d,0,264240,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}de[c[58528]&511](d)}s=b+140|0;if((c[s>>2]|0)>0){VLb(d,1,264296,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?264184:264192;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;VLb(d,0,264320,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}de[c[58528]&511](d)}o=b+144|0;if((c[o>>2]|0)>0){VLb(d,1,264376,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?264184:264192;v=(a[n+(m*48|0)+40|0]|0)!=0?264184:264192;n=(a[(c[s>>2]|0)+m|0]|0)!=0?264184:264192;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;VLb(d,0,264400,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}de[c[58528]&511](d)}m=b+148|0;if((c[m>>2]|0)>0){VLb(d,1,264456,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;VLb(d,0,264480,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}de[c[58528]&511](d)}de[c[58528]&511](d);i=e;return}function ROb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((cNb(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];Gec(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;Gec(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;Gec(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;Gec(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(cNb(c[d>>2]|0)|0));i=b;return}function SOb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function TOb(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];Gec(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;Gec(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;Gec(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;Gec(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function UOb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=ZMb(3,32)|0;c[o>>2]=p;if((p|0)==0){ZLb(c[b+536>>2]|0,264584,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=cec(c[p>>2]|0,8)|0;c[q>>2]=z;YLb(c[r>>2]|0,(z|0)!=0|0,264640,l);z=cec(c[s>>2]|0,4)|0;c[t>>2]=z;YLb(c[r>>2]|0,(z|0)!=0|0,264640,k);z=cec(c[u>>2]|0,1)|0;c[v>>2]=z;YLb(c[r>>2]|0,(z|0)!=0|0,264640,j);z=cec(c[w>>2]|0,4)|0;c[x>>2]=z;YLb(c[r>>2]|0,(z|0)!=0|0,264640,g);bNb(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=cec(3,4)|0;c[b+4>>2]=n;dNb(c[o>>2]|0,0,n);c[b+8>>2]=cec(c[p>>2]|0,112)|0;c[b+12>>2]=cec(c[s>>2]|0,60)|0;c[b+16>>2]=cec(c[u>>2]|0,48)|0;c[b+20>>2]=cec(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=cec(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=cec(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=cec(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=cec(g,52)|0;c[b+40>>2]=cec(c[b+216>>2]|0,52)|0;c[b+44>>2]=cec(c[b+220>>2]|0,52)|0;c[b+48>>2]=cec(c[b+224>>2]|0,52)|0;c[b+52>>2]=cec(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=cec(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=cec(x,8)|0;c[b+340>>2]=cec(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=cec(x,8)|0;c[b+348>>2]=cec(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=cec(j,1)|0;c[b+356>>2]=cec(j,1)|0;c[b+360>>2]=cec(j,1)|0;j=aec(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=aec(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=cec(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=cec(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=cec(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=cec(u,4)|0;c[b+400>>2]=cec(x,8)|0;c[b+404>>2]=cec(p,4)|0;c[b+408>>2]=cec(s,1)|0;c[b+412>>2]=cec(u,4)|0;c[b+416>>2]=cec(c[n>>2]|0,8)|0;c[b+420>>2]=cec(o,4)|0;c[b+424>>2]=cec(y,1)|0;c[b+428>>2]=cec(g,4)|0;c[b+432>>2]=cec(c[b+152>>2]|0,8)|0;c[b+436>>2]=cec(c[b+156>>2]|0,8)|0;g=aec((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;de[c[(c[y>>2]|0)+20>>2]&511](g);g=aec((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;de[c[(c[y>>2]|0)+16>>2]&511](g);g=aec((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;de[c[(c[y>>2]|0)+12>>2]&511](g);g=aec((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;ee[c[(c[y>>2]|0)+24>>2]&63](g,b);c[b+464>>2]=aec((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=cec(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;YLb(c[r>>2]|0,(g|0)!=0|0,264656,f);c[b+512>>2]=100;c[b+516>>2]=cec(100,4)|0;c[b+520>>2]=cec(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=aec(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;YLb(c[r>>2]|0,(g|0)!=0|0,264640,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=ZMb(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function VOb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;bec(c[g+8>>2]|0);bec(c[g+12>>2]|0);bec(c[g+16>>2]|0);bec(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);bec(e);_Mb(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){uNb(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}bec(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){uNb(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}bec(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){uNb(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}bec(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){uNb(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}bec(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){uNb(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}bec(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){uNb(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}bec(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){uNb(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}bec(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){uNb(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}bec(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){uNb(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}bec(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){uNb(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}bec(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){uNb(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}bec(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){uNb(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}bec(v);bec(c[a+108>>2]|0);bec(c[a+336>>2]|0);bec(c[a+340>>2]|0);bec(c[a+344>>2]|0);bec(c[a+348>>2]|0);bec(c[a+352>>2]|0);bec(c[a+356>>2]|0);bec(c[a+360>>2]|0);bec(c[a+368>>2]|0);bec(c[a+384>>2]|0);bec(c[a+388>>2]|0);bec(c[a+392>>2]|0);bec(c[a+396>>2]|0);bec(c[a+400>>2]|0);bec(c[a+404>>2]|0);bec(c[a+408>>2]|0);bec(c[a+412>>2]|0);bec(c[a+416>>2]|0);bec(c[a+420>>2]|0);bec(c[a+424>>2]|0);bec(c[a+428>>2]|0);bec(c[a+488>>2]|0);bec(c[a+484>>2]|0);bec(c[a+476>>2]|0);bec(c[a+468>>2]|0);bec(c[a+464>>2]|0);bec(c[a+432>>2]|0);bec(c[a+436>>2]|0);bec(c[a+320>>2]|0);bec(c[a+516>>2]|0);bec(c[a+520>>2]|0);u1b(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;bec(x);i=b;return}else{y=a;z=0}while(1){_Mb(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;bec(x);i=b;return}function WOb(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[33087]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];VLb(8,0,264704,d);i=b;return}function XOb(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[33087];f=e+e*+U(+(d?b:a));if(d){g=f}else{g=-f}i=i;return a-b<=g|0}function YOb(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[33087];f=e+e*+U(+(d?a:b));if(d){g=-f}else{g=f}i=i;return a-b>=g|0}function ZOb(a,b){a=+a;b=+b;i=i;return a<b|0}function _Ob(a,b){a=+a;b=+b;i=i;return a<=b|0}function $Ob(a,b){a=+a;b=+b;i=i;return a>b|0}function aPb(a,b){a=+a;b=+b;i=i;return a>=b|0}function bPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=aec(k)|0;c[e+(h*40|0)+24>>2]=aec(k)|0;if((c[g>>2]|0)!=1){l=5;break}ePb(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){ZLb(c[a+536>>2]|0,264760,d)}else if((l|0)==6){i=b;return 0}return 0}function cPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){bec(c[e+(h*40|0)+20>>2]|0);bec(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;fPb(k)|0;bec(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){ZLb(c[a+536>>2]|0,264760,d)}else if((j|0)==6){i=b;return 0}return 0}function dPb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[233628>>2]|c[58388]|0)==0){z=w;A=1;break}s1b(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];XLb(17,1,264792,g);s1b(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;s1b(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;XLb(17,0,264824,f);s1b(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}de[c[58528]&511](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function ePb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=aec(20)|0;c[b>>2]=f;YLb(0,(f|0)!=0|0,264832,e);e=aec(a)|0;c[f>>2]=e;e=aec(a)|0;c[f+4>>2]=e;e=aec(a)|0;c[f+8>>2]=e;e=aec(a)|0;c[f+16>>2]=e;YLb(0,(c[b>>2]|0)!=0|0,264864,d);i=d;return 0}function fPb(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;bec(c[d>>2]|0);bec(c[d+4>>2]|0);bec(c[d+8>>2]|0);bec(c[d+16>>2]|0);i=b;return 0}function gPb(a,b){a=a|0;b=b|0;b=i;i=i+8|0;ZLb(c[a+536>>2]|0,264912,b);return 0}function hPb(a){a=a|0;a=i;i=i+8|0;ZLb(0,264912,a);return 0}function iPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=aec(l)|0;c[e+(h<<6)+36>>2]=aec(l)|0;m=c[g>>2]|0;if((m|0)==2){c[e+(h<<6)+8>>2]=2;rPb(j,j,k,e+(h<<6)+24|0)|0}else if((m|0)==1){c[e+(h<<6)+32>>2]=aec(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;oPb(j,e+(h<<6)+24|0)|0}else{n=6;break}j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{n=8;break}}if((n|0)==6){ZLb(c[a+536>>2]|0,264952,d)}else if((n|0)==8){i=b;return 0}return 0}function jPb(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function kPb(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;tb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function lPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){bec(c[e+(h<<6)+28>>2]|0);bec(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==2){sPb(e+(h<<6)+24|0)|0}else if((j|0)==1){pPb(e+(h<<6)+24|0)|0;bec(c[e+(h<<6)+32>>2]|0)}else{k=6;break}bec(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){ZLb(c[a+536>>2]|0,264952,d)}else if((k|0)==8){i=b;return 0}return 0}function mPb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[b+476>>2]|0;h=c[b+292>>2]|0;if((h|0)==1){j=qPb(b,d)|0}else if((h|0)==2){j=tPb(b,d)|0}else{ZLb(c[b+536>>2]|0,264952,f)}a[g+(d<<6)+56|0]=j;i=e;return 0}function nPb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[233620>>2]|c[58388]|0)==0){z=w;A=1;break}s1b(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];XLb(15,1,264984,g);s1b(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;s1b(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;XLb(15,0,265016,f);s1b(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}de[c[58528]&511](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function oPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=aec(12)|0;f=aec(a<<2)|0;c[e>>2]=f;YLb(0,(f|0)!=0|0,265024,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function pPb(a){a=a|0;var b=0;b=i;bec(c[c[a>>2]>>2]|0);i=b;return 0}function qPb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16384|0;v=i;i=i+4096|0;w=c[b+476>>2]|0;x=w+(d<<6)|0;y=c[w+(d<<6)+24>>2]|0;z=w+(d<<6)+16|0;A=c[z>>2]|0;B=w+(d<<6)+32|0;Iec(c[B>>2]|0,0,fa(A<<3,A)|0)|0;C=b;D=x;ee[c[x>>2]&63](C,D);ee[c[w+(d<<6)+4>>2]&63](C,D);if((c[233624>>2]|0)!=0){D=u;c[t>>2]=A;c[t+4>>2]=A;VLb(16,1,265080,t);t=(A|0)>0;do{if(t){u=0;do{a[D]=0;C=0;do{x=(fa(C,A)|0)+u|0;E=+h[(c[B>>2]|0)+(x<<3)>>3];c[r>>2]=D;x=r+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];fc(D|0,265104,r|0)|0;C=C+1|0;}while((C|0)<(A|0));c[q>>2]=D;VLb(16,0,265120,q);u=u+1|0;}while((u|0)<(A|0));c[p>>2]=A;VLb(16,1,265128,p);if(!t){break}u=w+(d<<6)+36|0;C=0;do{a[D]=0;E=+h[(c[u>>2]|0)+(C<<3)>>3];c[o>>2]=D;x=o+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];fc(D|0,265104,o|0)|0;c[n>>2]=D;VLb(16,0,265120,n);C=C+1|0;}while((C|0)<(A|0))}else{c[s>>2]=A;VLb(16,1,265128,s)}}while(0);de[c[58528]&511](16)}s=w+(d<<6)+36|0;A=y+8|0;GGb(z,y+4|0,c[B>>2]|0,z,c[y>>2]|0,c[s>>2]|0,z,A)|0;y=c[A>>2]|0;if((y|0)<0){E=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[w+(d<<6)+20>>2];A=m+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];c[m+12>>2]=y;XLb(1,0,265144,m);F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;Gec(M|0,O|0,Q|0)|0;i=e;return F|0}if((y|0)<=0){F=1;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;Gec(M|0,O|0,Q|0)|0;i=e;return F|0}E=+h[c[c[b+4>>2]>>2]>>3];b=y+1|0;c[l>>2]=c[w+(d<<6)+20>>2];y=l+4|0;h[k>>3]=E;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[l+12>>2]=b;c[l+16>>2]=b;XLb(1,0,265232,l);if((c[233620>>2]|0)==0){F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;Gec(M|0,O|0,Q|0)|0;i=e;return F|0}l=v;v=(c[z>>2]|0)>0;a[l]=0;if(v){v=0;do{b=c[z>>2]|0;if((b|0)>0){y=b;m=0;while(1){A=(fa(y,m)|0)+v|0;E=+h[(c[B>>2]|0)+(A<<3)>>3];c[j>>2]=l;A=j+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];fc(l|0,265336,j|0)|0;A=m+1|0;n=c[z>>2]|0;if((A|0)<(n|0)){m=A;y=n}else{R=n;break}}}else{R=b}v=v+1|0;a[l]=0}while((v|0)<(R|0))}if((c[z>>2]|0)>0){R=0;do{E=+h[(c[s>>2]|0)+(R<<3)>>3];c[g>>2]=l;v=g+4|0;h[k>>3]=E;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];fc(l|0,265336,g|0)|0;R=R+1|0;}while((R|0)<(c[z>>2]|0))}a[l]=0;if((c[z>>2]|0)>0){S=0}else{F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;Gec(M|0,O|0,Q|0)|0;i=e;return F|0}while(1){E=+h[(c[s>>2]|0)+(S<<3)>>3];c[f>>2]=l;R=f+4|0;h[k>>3]=E;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];fc(l|0,265336,f|0)|0;R=S+1|0;if((R|0)<(c[z>>2]|0)){S=R}else{F=0;break}}G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;Gec(M|0,O|0,Q|0)|0;i=e;return F|0}function rPb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=aec(32)|0;YLb(0,(g|0)!=0|0,265344,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Wd(0,d|0)|0;Ld(c[d>>2]|0,c[b>>2]|0,0)|0;Wd(0,g+4|0)|0;Ld(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;$a(b|0)|0;Jb(265392,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function sPb(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;xd(c[d+12>>2]|0)|0;Ib(c[d+8>>2]|0)|0;Ib(c[d+4>>2]|0)|0;i=b;return 0}function tPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[a+476>>2]|0;f=e+(b<<6)|0;g=c[e+(b<<6)+24>>2]|0;jd(c[g>>2]|0)|0;Sd(0,g|0)|0;j=g+24|0;Nb(c[g>>2]|0,c[j>>2]|0,0)|0;k=a;a=f;ee[c[f>>2]&63](k,a);Tc(c[g>>2]|0,1)|0;Sa(c[g>>2]|0)|0;ee[c[e+(b<<6)+4>>2]&63](k,a);if((c[j>>2]|0)>0){a=e+(b<<6)+36|0;k=g+8|0;f=k;l=0;while(1){ed(0,l|0,+(+h[(c[a>>2]|0)+(l<<3)>>3]),c[k>>2]|0)|0;m=l+1|0;if((m|0)<(c[j>>2]|0)){l=m}else{n=f;break}}}else{n=g+8|0}f=g+4|0;l=(kc(c[g>>2]|0,c[n>>2]|0,c[f>>2]|0,c[g+12>>2]|0)|0)==0|0;Hb(c[f>>2]|0,0,c[g+20>>2]|0,c[e+(b<<6)+28>>2]|0)|0;jd(c[g>>2]|0)|0;i=d;return l|0}function uPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;YLb(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,265560,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){YLb(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,265600,e);if((ge[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=aec(p)|0;c[g+(m*80|0)+52>>2]=aec(p)|0;c[g+(m*80|0)+48>>2]=aec(p)|0;c[g+(m*80|0)+16>>2]=aec(p)|0;c[g+(m*80|0)+8>>2]=aec(p)|0;c[g+(m*80|0)+12>>2]=aec(p)|0;ee[c[g+(m*80|0)+36>>2]&63](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){zPb(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==3){zPb(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==2){gPb(a,n)|0;break}else if((p|0)==1){xPb(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){ZLb(c[j>>2]|0,265640,d)}else if((q|0)==14){i=b;return 0}return 0}function vPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;bec(c[e+(h*80|0)+44>>2]|0);bec(c[e+(h*80|0)+52>>2]|0);bec(c[e+(h*80|0)+48>>2]|0);bec(c[e+(h*80|0)+16>>2]|0);bec(c[e+(h*80|0)+8>>2]|0);bec(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;APb(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==1){m=e+(h*80|0)+40|0;yPb(m)|0;l=m;break}else if((k|0)==2){n=7;break a}else if((k|0)==3){k=e+(h*80|0)+40|0;APb(k)|0;l=k;break}else{n=9;break a}}}while(0);bec(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=11;break}}if((n|0)==7){hPb(j)|0}else if((n|0)==9){ZLb(c[a+536>>2]|0,265640,d)}else if((n|0)==11){i=b;return 0}return 0}function wPb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;s1b(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];WLb(17,1,u,265672,m);do{if((a[b+312|0]|0)==0){s1b(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;s1b(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;XLb(17,0,265872,f);s1b(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{XLb(17,1,265712,l);s1b(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;s1b(q,d,c[v>>2]|0);if((Aec(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];XLb(17,0,265792,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;s1b(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;XLb(17,0,265832,g);G=E}s1b(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[233628>>2]|c[58388]|0)==0){break}de[c[58528]&511](17)}}while(0);if((c[233628>>2]|c[58388]|0)==0){x=1;i=e;return x|0}de[c[58528]&511](17);x=1;i=e;return x|0}function xPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=aec(144)|0;c[b>>2]=f;YLb(0,(f|0)!=0|0,265888,e);c[f>>2]=0;e=a<<3;g=aec(e)|0;c[f+4>>2]=g;g=aec(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=aec(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=aec(e)|0;c[f+24>>2]=g;g=cec(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=aec(e)|0;c[f+64>>2]=g;g=aec(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=cec(g,8)|0;c[f+104>>2]=j;j=cec(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=aec(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=aec(e)|0;c[f+124>>2]=j;j=aec(e)|0;c[f+128>>2]=j;j=aec(e)|0;c[f+132>>2]=j;j=aec(e)|0;c[f+136>>2]=j;j=aec(e)|0;c[f+140>>2]=j;YLb(0,(c[b>>2]|0)!=0|0,265920,d);i=d;return 0}function yPb(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;bec(c[d+4>>2]|0);bec(c[d+16>>2]|0);bec(c[d+12>>2]|0);bec(c[d+24>>2]|0);bec(c[d+28>>2]|0);bec(c[d+64>>2]|0);bec(c[d+68>>2]|0);bec(c[d+104>>2]|0);bec(c[d+108>>2]|0);bec(c[d+116>>2]|0);bec(c[d+124>>2]|0);bec(c[d+128>>2]|0);bec(c[d+132>>2]|0);bec(c[d+136>>2]|0);bec(c[d+140>>2]|0);i=b;return 0}function zPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=aec(80)|0;c[b>>2]=f;YLb(0,(f|0)!=0|0,265960,e);c[f>>2]=0;e=a<<3;g=aec(e)|0;c[f+4>>2]=g;g=aec(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=aec(e)|0;c[f+16>>2]=g;g=cec(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=aec(fa(e,a)|0)|0;c[f+64>>2]=g;g=aec(e)|0;c[f+68>>2]=g;g=aec(a<<2)|0;c[f+72>>2]=g;YLb(0,(c[b>>2]|0)!=0|0,265992,d);i=d;return 0}function APb(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;bec(c[d+4>>2]|0);bec(c[d+8>>2]|0);bec(c[d+16>>2]|0);bec(c[d+20>>2]|0);bec(c[d+64>>2]|0);bec(c[d+68>>2]|0);bec(c[d+72>>2]|0);i=b;return 0}function BPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==1){f=c[a+4>>2]|0;g=c[f+4>>2]|0;DPb(c[f>>2]|0,+h[g>>3],c[g+8>>2]|0,c[a+112>>2]|0,b);j=0;i=d;return j|0}else if((e|0)==2){CPb(a,b);j=0;i=d;return j|0}else if((e|0)==3){j=hOb(a,b)|0;i=d;return j|0}else if((e|0)==4){qe[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];j=0;i=d;return j|0}else{j=1;i=d;return j|0}return 0}function CPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[266032+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[266032+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];ge[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function DPb(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function EPb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=aMb(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;f=c[d+24>>2]|0;a:do{if((f|0)==3){g=aec(88)|0;VLb(23,0,266064,e);j=fOb(b,d,g)|0;c[d+48>>2]=g;k=j}else if((f|0)==4){j=c[1658]|0;g=aec(j<<2)|0;c[66522]=g;if((j|0)<=0){k=0;break}l=c[b+116>>2]|0;m=g;g=0;while(1){c[m+(g<<2)>>2]=cec(l,8)|0;n=g+1|0;if((n|0)>=(j|0)){k=0;break a}m=c[66522]|0;g=n}}else if((f|0)==2){g=aec(8)|0;c[g+4>>2]=4;m=aec(20)|0;c[g>>2]=m;j=c[b+112>>2]|0;l=m;m=0;while(1){c[l+(m<<2)>>2]=cec(j,8)|0;if((m|0)>=4){break}l=c[g>>2]|0;m=m+1|0}c[d+48>>2]=g;k=0}else{k=0}}while(0);RPb(b)|0;if((c[2]|0)==0){i=e;return k|0}rNb(6);oNb(1);i=e;return k|0}function FPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+24>>2]|0;if((e|0)==4){f=c[1658]|0;g=c[66522]|0;if((f|0)>0){h=g;j=0;while(1){bec(c[h+(j<<2)>>2]|0);k=j+1|0;l=c[66522]|0;if((k|0)<(f|0)){j=k;h=l}else{m=l;break}}}else{m=g}bec(m)}else if((e|0)==3){gOb(c[b+48>>2]|0)|0}else if((e|0)==2){e=b+48|0;b=c[e>>2]|0;m=c[b>>2]|0;if((c[b+4>>2]|0)>-1){b=m;g=0;while(1){bec(c[b+(g<<2)>>2]|0);h=c[e>>2]|0;j=c[h>>2]|0;if((g|0)<(c[h+4>>2]|0)){g=g+1|0;b=j}else{n=j;break}}}else{n=m}bec(n);bec(c[e>>2]|0)}SPb(a)|0;MPb(a);i=d;return 0}function GPb(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(470,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=Rec(c[s>>2]|0,o)|0;if((t|0)==0){cb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=Rec(c[s>>2]|0,o)|0;if((B|0)==0){cb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=Rec(c[C>>2]|0,o)|0;if((D|0)==0){cb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=Rec(c[C>>2]|0,o)|0;if((E|0)==0){cb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=Rec(c[s>>2]|0,o)|0;if((F|0)==0){cb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(471,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=Rec(c[s>>2]|0,o)|0;if((G|0)==0){cb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=Rec(c[s>>2]|0,o)|0;if((H|0)==0){cb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;Dec(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=Rec(c[L>>2]|0,o)|0;if((M|0)==0){cb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ia(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=Rec(c[p>>2]|0,o)|0;if((N|0)==0){cb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Qa(14,1,0,266096,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=Rec(c[M>>2]|0,o)|0;if((U|0)==0){cb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=Rec(c[M>>2]|0,o)|0;if((V|0)==0){cb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Qa(15,2,0,266192,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=Rec(c[M>>2]|0,o)|0;if((X|0)==0){cb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[272312>>2]|0,272288,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=Rec(c[M>>2]|0,o)|0;if((Y|0)==0){cb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Qa(15,23,0,266248,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=Rec(c[M>>2]|0,o)|0;if((Z|0)==0){cb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(472,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=Rec(c[M>>2]|0,o)|0;if(($|0)==0){cb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function HPb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];VLb(8,0,266344,G);I=b+313|0;a[I]=1;FOb(b);if((c[287620>>2]|0)==0){ee[c[272308>>2]&63](272288,b)}a[I]=0}}while(0);if((e|0)!=0){IPb(yd(e|0)|0,b)}if((c[233660>>2]|0)==0){i=f;return 0}rNb(0);VLb(25,0,266392,F);VLb(25,1,266416,E);H=+jNb(6);J=+jNb(6);K=J/+jNb(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];VLb(25,0,266424,D);K=+jNb(1);H=+jNb(1);J=H/+jNb(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];VLb(25,0,266464,C);J=+jNb(2);K=+jNb(2);H=K/+jNb(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];VLb(25,0,266496,B);H=+jNb(3);J=+jNb(3);K=J/+jNb(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];VLb(25,0,266520,A);K=+jNb(4);H=+jNb(4);J=H/+jNb(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];VLb(25,0,266560,z);J=+jNb(7);K=+jNb(7);H=K/+jNb(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];VLb(25,0,266592,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+jNb(0);J=H- +jNb(7);H=J- +jNb(4);J=H- +jNb(3);H=J- +jNb(2);J=H- +jNb(1);H=J- +jNb(6);J=+jNb(0);K=J- +jNb(7);J=K- +jNb(4);K=J- +jNb(3);J=K- +jNb(2);K=J- +jNb(1);J=K- +jNb(6);K=J/+jNb(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];VLb(25,0,266656,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];VLb(25,0,266624,x)}K=+jNb(0);H=+jNb(0);J=H/+jNb(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];VLb(25,0,266688,v);de[c[58528]&511](25);VLb(25,1,266712,u);c[t>>2]=c[d+40>>2];VLb(25,0,266720,t);c[s>>2]=c[d+44>>2];VLb(25,0,266744,s);de[c[58528]&511](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);VLb(25,1,266768,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];VLb(25,0,266784,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];VLb(25,0,266800,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];VLb(25,0,266832,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];VLb(25,0,266864,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];VLb(25,0,266888,m);de[c[58528]&511](25)}else if((s|0)!=5){VLb(25,1,266920,l);VLb(25,0,266928,j);de[c[58528]&511](25)}VLb(25,0,266992,g);oNb(0);i=f;return 0}function IPb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Vb(b|0,267464)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];ud(b|0,267472,y|0)|0;if((z|0)==0){C=Qd(10,b|0)|0;D=sd(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Aec(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];ud(b|0,267488,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Aec(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;ud(b|0,267504,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Aec(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;ud(b|0,267512,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Aec(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;ud(b|0,267520,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((Aec(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];ud(b|0,267488,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];ud(b|0,267488,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((Aec(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;ud(b|0,267504,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;ud(b|0,267504,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((Aec(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;ud(b|0,267512,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;ud(b|0,267512,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((Aec(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;ud(b|0,267520,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Aec(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ud(b|0,267488,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Aec(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;ud(b|0,267504,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Aec(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;ud(b|0,267512,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Aec(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;ud(b|0,267520,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Vb(0,267464)|0;}while((d|0)!=0);C=Qd(10,b|0)|0;D=sd(b|0)|0;i=e;return}function JPb(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 11:case 10:case 9:case 6:case 7:case 8:{XLb(1,0,267016,r);v=1;i=m;return v|0};case 18:{w=c[1656]|0;do{if((w|0)!=0){if((Aec(w,267272)|0)!=0){break}c[u>>2]=4;break a}}while(0);VLb(23,0,267296,o);v=1;i=m;return v|0};case 5:{XLb(1,0,267088,q);v=1;i=m;return v|0};case 4:{w=c[1656]|0;if((w|0)!=0){if((Aec(w,267128)|0)==0){break a}}VLb(23,0,267144,p);v=1;i=m;return v|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};default:{}}}while(0);p=EPb(a,s)|0;ye[c[234460>>2]&7]()|0;do{if((p|0)==0){q=GPb(a,b,d,e,f,g)|0;ye[c[234460>>2]&7]()|0;if((q|0)!=0){x=q;break}if((c[u>>2]|0)!=5){ee[c[272308>>2]&63](272288,a);POb(a)}y=+h[a+248>>3];q=n;h[k>>3]=+h[a+240>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=n+8|0;h[k>>3]=y;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];VLb(23,0,267424,n);q=ue[c[c[a+540>>2]>>2]&63](a,t)|0;ye[c[234460>>2]&7]()|0;HPb(a,s,l)|0;ye[c[234460>>2]&7]()|0;x=q}else{ye[c[234460>>2]&7]()|0;x=p}}while(0);FPb(a,s)|0;v=x;i=m;return v|0}function KPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){LPb(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((ge[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){ZLb(c[a+536>>2]|0,267536,d)}else if((k|0)==6){LPb(a);i=b;return}}function LPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;Iec(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function MPb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;bec(c[f+(a*48|0)+28>>2]|0);bec(c[f+(a*48|0)+32>>2]|0);bec(c[f+(a*48|0)+16>>2]|0);bec(c[f+(a*48|0)+20>>2]|0);bec(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function NPb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=aec(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=aec(c[y>>2]<<2)|0;OPb(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;Gec(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;Gec(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((eOb(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=PPb(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){Gec(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;Gec(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;bec(x);bec(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;XLb(5,1,267592,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];fc(q|0,267624,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;XLb(5,0,267632,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=234112;K=c[58528]|0;de[K&511](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=267640;aa=$;ZLb(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];XLb(5,0,267632,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=234112;K=c[58528]|0;de[K&511](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=267640;aa=$;ZLb(O,aa,g);return 0}function OPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;Iec(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}ge[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function PPb(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=cec(d,4)|0;r=cec(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;bec(q);bec(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;bec(q);bec(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){bec(q);bec(r);i=o;return v|0}if((n|0)==0){v=-1;bec(q);bec(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];VLb(5,1,267744,p);QPb(s,d,f,c[g>>2]|0,j,l,m);if((c[233580>>2]|0)==0){v=-1;bec(q);bec(r);i=o;return v|0}de[c[58528]&511](5);v=-1;bec(q);bec(r);i=o;return v|0}function QPb(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;Iec(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];VLb(5,0,267776,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function RPb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=gc(267792,267816)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=bd(n|0)|0;if((o|0)==-1){break a}else if((o|0)==10){break}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;nb(n|0);do{}while((bd(n|0)|0)!=10);q=c[b+152>>2]|0;r=cec(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=cec(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=cec(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=Md(n|0,267824,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=Md(n|0,267824,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=cec(s,8)|0;x=v}}while(0);ec(267832,j|0)|0;ec(267888,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];ec(267848,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];ec(267872,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}rb(267888)|0;Wc(n|0)|0;c[b+460>>2]=0;i=d;return 0}function SPb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}bec(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){bec(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}bec(l);i=d;return 0}function TPb(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function UPb(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+VPb(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[233596>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];VLb(9,1,267952,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];VLb(9,0,268064,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}de[c[58528]&511](9);g=1;i=b;return g|0}function VPb(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;iQb(b);g=f+540|0;ge[c[(c[g>>2]|0)+84>>2]&127](f)|0;ge[c[(c[g>>2]|0)+36>>2]&127](f)|0;ge[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;ue[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function WPb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+VPb(b,1.0);if((c[233596>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}VLb(9,1,268088,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];VLb(9,0,268152,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];VLb(9,0,268112,s)}VLb(9,1,268176,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;VLb(9,0,268248,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];VLb(9,0,268200,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;VLb(9,0,268336,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];VLb(9,0,268272,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;VLb(9,0,268424,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];VLb(9,0,268368,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}de[c[58528]&511](9);VLb(9,1,268456,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=ge[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;VLb(9,0,268248,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];VLb(9,0,268200,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}de[c[58528]&511](9);de[c[58528]&511](9);i=d;return}function XPb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[233596>>2]|0)!=0){QOb(b,9)}if((c[233656>>2]|0)==0){i=d;return}VLb(24,1,268480,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){VLb(24,1,268520,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];VLb(24,0,268544,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}de[c[58528]&511](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}VLb(24,1,268600,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];VLb(24,0,268624,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}de[c[58528]&511](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){VLb(24,1,268656,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];VLb(24,0,268544,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}de[c[58528]&511](24)}p=b+124|0;if((c[p>>2]|0)>0){VLb(24,1,268680,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;VLb(24,0,268704,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}de[c[58528]&511](24)}H=b+128|0;if((c[H>>2]|0)>0){VLb(24,1,268752,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?268824:268832;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?268824:268832;t=(a[(c[l>>2]|0)+n|0]|0)!=0?268824:268832;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;VLb(24,0,268776,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}de[c[58528]&511](24)}n=b+132|0;if((c[n>>2]|0)>0){VLb(24,1,268840,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;VLb(24,0,268864,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}de[c[58528]&511](24)}de[c[58528]&511](24);i=d;return}function YPb(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;VLb(9,0,268912,z);if((f|0)==0){NOb(b);OOb(b);C=6}else{if((a[f]|0)!=0){ZPb(b,f,g)}NOb(b);OOb(b);if((a[f]|0)==0){C=6}}if((C|0)==6){ge[c[(c[A>>2]|0)+84>>2]&127](b)|0;ge[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(Aec(d,270400)|0)==0|0;f=(Aec(d,270408)|0)==0;z=(Aec(d,270416)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;XLb(1,0,268960,y);XLb(1,0,268992,x);c[w>>2]=270400;c[w+4>>2]=270208;XLb(1,0,269016,w);c[v>>2]=270408;c[v+4>>2]=270288;XLb(1,0,269016,v);c[u>>2]=270416;c[u+4>>2]=270336;XLb(1,0,269016,u);ZLb(c[b+536>>2]|0,269048,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(Aec(e,c[269072+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;XLb(1,0,269104,s);XLb(1,0,268992,r);t=1;do{u=c[269136+(t<<2)>>2]|0;c[q>>2]=c[269072+(t<<2)>>2];c[q+4>>2]=u;XLb(1,0,269016,q);t=t+1|0;}while((t|0)<7);ZLb(c[b+536>>2]|0,269048,p)}}while(0);p=c[269032+(D<<2)>>2]|0;c[o>>2]=c[268944+(D<<2)>>2];c[o+4>>2]=p;VLb(9,0,269168,o);o=(D|0)==2;if(o){p=c[269136+(F<<2)>>2]|0;c[n>>2]=c[269072+(F<<2)>>2];c[n+4>>2]=p;VLb(9,0,269208,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=_Pb(b,F,j)|0;break}if((D|0)==3){$Pb(b,j);I=0;break}else{ZLb(c[b+536>>2]|0,269248,m)}}}while(0);if((wPb(b,1)|0)!=0){J=-2;XPb(b);K=15;L=K;M=269272;N=M;VLb(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];wOb(b,R,V);W=467;KOb(b);X=473;POb(b);Y=468;FOb(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ge[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=ue[ha&63](b,1)|0;ja=476;LOb(b);i=k;return J|0}if((nPb(b,1)|0)!=0){J=-3;XPb(b);K=15;L=K;M=269272;N=M;VLb(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];wOb(b,R,V);W=467;KOb(b);X=473;POb(b);Y=468;FOb(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ge[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=ue[ha&63](b,1)|0;ja=476;LOb(b);i=k;return J|0}m=(dPb(b,1)|0)==0;J=m?I:-4;XPb(b);K=15;L=K;M=269272;N=M;VLb(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];wOb(b,R,V);W=467;KOb(b);X=473;POb(b);Y=468;FOb(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ge[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=ue[ha&63](b,1)|0;ja=476;LOb(b);i=k;return J|0}



function UTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14328>>3]=1.0;i=i;return}function VTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14352>>3]=0.0;i=i;return}function WTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14312>>3]=0.0;i=i;return}function XTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14336>>3]=0.0;i=i;return}function YTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14360>>3]=1.0;i=i;return}function ZTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14368>>3]=0.0;i=i;return}function _Ta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14376>>3]=0.0;i=i;return}function $Ta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14384>>3]=0.0;i=i;return}function aUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14392>>3]=0.0;i=i;return}function bUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14400>>3]=0.0;i=i;return}function cUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14408>>3]=0.0;i=i;return}function dUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14416>>3]=0.0;i=i;return}function eUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14424>>3]=0.0;i=i;return}function fUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14432>>3]=0.0;i=i;return}function gUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14440>>3]=0.0;i=i;return}function hUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14448>>3]=0.0;i=i;return}function iUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14456>>3]=0.0;i=i;return}function jUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14464>>3]=1.0;i=i;return}function kUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14488>>3]=0.0;i=i;return}function lUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14512>>3]=0.0;i=i;return}function mUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14472>>3]=0.0;i=i;return}function nUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14496>>3]=1.0;i=i;return}function oUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14520>>3]=0.0;i=i;return}function pUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14480>>3]=0.0;i=i;return}function qUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14504>>3]=0.0;i=i;return}function rUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14528>>3]=1.0;i=i;return}function sUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14536>>3]=0.0;i=i;return}function tUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14544>>3]=0.0;i=i;return}function uUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14552>>3]=0.0;i=i;return}function vUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14560>>3]=0.0;i=i;return}function wUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14568>>3]=0.0;i=i;return}function xUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14576>>3]=0.0;i=i;return}function yUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14584>>3]=0.0;i=i;return}function zUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14592>>3]=0.0;i=i;return}function AUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14600>>3]=0.0;i=i;return}function BUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14608>>3]=0.0;i=i;return}function CUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14616>>3]=0.0;i=i;return}function DUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14624>>3]=0.0;i=i;return}function EUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14632>>3]=1.0;i=i;return}function FUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14656>>3]=0.0;i=i;return}function GUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14680>>3]=0.0;i=i;return}function HUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14640>>3]=0.0;i=i;return}function IUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14664>>3]=1.0;i=i;return}function JUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14688>>3]=0.0;i=i;return}function KUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14648>>3]=0.0;i=i;return}function LUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14672>>3]=0.0;i=i;return}function MUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14696>>3]=1.0;i=i;return}function NUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14704>>3]=0.0;i=i;return}function OUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14712>>3]=0.0;i=i;return}function PUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14720>>3]=0.0;i=i;return}function QUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14728>>3]=0.0;i=i;return}function RUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14736>>3]=0.0;i=i;return}function SUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14744>>3]=0.0;i=i;return}function TUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14752>>3]=0.0;i=i;return}function UUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14760>>3]=0.0;i=i;return}function VUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14768>>3]=0.0;i=i;return}function WUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14776>>3]=0.0;i=i;return}function XUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14784>>3]=0.0;i=i;return}function YUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14792>>3]=0.0;i=i;return}function ZUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14832>>3]=0.0;i=i;return}function _Ua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14840>>3]=0.0;i=i;return}function $Ua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14880>>3]=0.0;i=i;return}function aVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14888>>3]=0.0;i=i;return}function bVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14928>>3]=0.0;i=i;return}function cVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14936>>3]=0.0;i=i;return}function dVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14976>>3]=0.0;i=i;return}function eVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14984>>3]=0.0;i=i;return}function fVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15024>>3]=0.0;i=i;return}function gVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15032>>3]=0.0;i=i;return}function hVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15072>>3]=0.0;i=i;return}function iVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15080>>3]=0.0;i=i;return}function jVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15088>>3]=0.0;i=i;return}function kVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15096>>3]=-.1;i=i;return}function lVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15104>>3]=0.0;i=i;return}function mVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15112>>3]=0.0;i=i;return}function nVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15120>>3]=-.1;i=i;return}function oVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15128>>3]=0.0;i=i;return}function pVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15136>>3]=0.0;i=i;return}function qVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15144>>3]=-.1;i=i;return}function rVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15152>>3]=0.0;i=i;return}function sVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15160>>3]=0.0;i=i;return}function tVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15168>>3]=-.1;i=i;return}function uVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15176>>3]=0.0;i=i;return}function vVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15184>>3]=0.0;i=i;return}function wVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15192>>3]=-.1;i=i;return}function xVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15200>>3]=0.0;i=i;return}function yVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15208>>3]=0.0;i=i;return}function zVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15216>>3]=-.1;i=i;return}function AVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15224>>3]=0.0;i=i;return}function BVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15256>>3]=0.0;i=i;return}function CVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15240>>3]=0.0;i=i;return}function DVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15264>>3]=0.0;i=i;return}function EVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15296>>3]=0.0;i=i;return}function FVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15280>>3]=0.0;i=i;return}function GVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15304>>3]=0.0;i=i;return}function HVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15336>>3]=0.0;i=i;return}function IVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15320>>3]=0.0;i=i;return}function JVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15344>>3]=0.0;i=i;return}function KVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15376>>3]=0.0;i=i;return}function LVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15360>>3]=0.0;i=i;return}function MVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15384>>3]=0.0;i=i;return}function NVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15416>>3]=0.0;i=i;return}function OVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15400>>3]=0.0;i=i;return}function PVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15424>>3]=0.0;i=i;return}function QVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15456>>3]=0.0;i=i;return}function RVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15440>>3]=0.0;i=i;return}function SVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15464>>3]=0.0;i=i;return}function TVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15488>>3]=0.0;i=i;return}function UVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15480>>3]=0.0;i=i;return}function VVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15472>>3]=0.0;i=i;return}function WVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15496>>3]=0.0;i=i;return}function XVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15520>>3]=.8660254037844387;i=i;return}function YVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15528>>3]=-.4999999999999999;i=i;return}function ZVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15536>>3]=0.0;i=i;return}function _Va(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15544>>3]=.4999999999999999;i=i;return}function $Va(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15552>>3]=.8660254037844387;i=i;return}function aWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15560>>3]=0.0;i=i;return}function bWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15584>>3]=0.0;i=i;return}function cWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15576>>3]=0.0;i=i;return}function dWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15568>>3]=0.0;i=i;return}function eWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15608>>3]=0.0;i=i;return}function fWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15600>>3]=0.0;i=i;return}function gWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15592>>3]=0.0;i=i;return}function hWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15632>>3]=0.0;i=i;return}function iWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15624>>3]=0.0;i=i;return}function jWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15616>>3]=0.0;i=i;return}function kWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15640>>3]=0.0;i=i;return}function lWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15664>>3]=.8660254037844387;i=i;return}function mWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15672>>3]=.4999999999999999;i=i;return}function nWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15680>>3]=0.0;i=i;return}function oWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15688>>3]=-.4999999999999999;i=i;return}function pWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15696>>3]=.8660254037844387;i=i;return}function qWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15704>>3]=0.0;i=i;return}function rWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15728>>3]=0.0;i=i;return}function sWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15720>>3]=0.0;i=i;return}function tWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15712>>3]=0.0;i=i;return}function uWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15736>>3]=0.0;i=i;return}function vWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15760>>3]=.8660254037844387;i=i;return}function wWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15768>>3]=-.4999999999999999;i=i;return}function xWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15776>>3]=0.0;i=i;return}function yWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15784>>3]=.4999999999999999;i=i;return}function zWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15792>>3]=.8660254037844387;i=i;return}function AWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15800>>3]=0.0;i=i;return}function BWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15824>>3]=0.0;i=i;return}function CWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15816>>3]=0.0;i=i;return}function DWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15808>>3]=0.0;i=i;return}function EWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15832>>3]=0.0;i=i;return}function FWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15856>>3]=.8660254037844387;i=i;return}function GWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15864>>3]=.4999999999999999;i=i;return}function HWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15872>>3]=0.0;i=i;return}function IWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15880>>3]=-.4999999999999999;i=i;return}function JWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15888>>3]=.8660254037844387;i=i;return}function KWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15896>>3]=0.0;i=i;return}function LWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15920>>3]=0.0;i=i;return}function MWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15912>>3]=0.0;i=i;return}function NWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15904>>3]=0.0;i=i;return}function OWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15928>>3]=0.0;i=i;return}function PWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15952>>3]=.8660254037844387;i=i;return}function QWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15960>>3]=-.4999999999999999;i=i;return}function RWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15968>>3]=0.0;i=i;return}function SWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15976>>3]=.4999999999999999;i=i;return}function TWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15984>>3]=.8660254037844387;i=i;return}function UWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15992>>3]=0.0;i=i;return}function VWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16016>>3]=0.0;i=i;return}function WWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16008>>3]=0.0;i=i;return}function XWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16e3>>3]=0.0;i=i;return}function YWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16024>>3]=0.0;i=i;return}function ZWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16048>>3]=.8660254037844387;i=i;return}function _Wa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16056>>3]=.4999999999999999;i=i;return}function $Wa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16064>>3]=0.0;i=i;return}function aXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16072>>3]=-.4999999999999999;i=i;return}function bXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16080>>3]=.8660254037844387;i=i;return}function cXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16088>>3]=0.0;i=i;return}function dXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16104>>3]=+h[(c[a+416>>2]|0)+1024>>3];i=i;return}function eXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16112>>3]=+h[(c[a+416>>2]|0)+1032>>3];i=i;return}function fXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16136>>3]=0.0;i=i;return}function gXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16128>>3]=0.0;i=i;return}function hXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16120>>3]=0.0;i=i;return}function iXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16160>>3]=0.0;i=i;return}function jXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16152>>3]=0.0;i=i;return}function kXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16144>>3]=0.0;i=i;return}function lXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16216>>3]=0.0;i=i;return}function mXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16192>>3]=0.0;i=i;return}function nXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16184>>3]=0.0;i=i;return}function oXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16176>>3]=0.0;i=i;return}function pXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16168>>3]=1.0;i=i;return}function qXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16240>>3]=0.0;i=i;return}function rXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16248>>3]=0.0;i=i;return}function sXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16256>>3]=1.0;i=i;return}function tXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16264>>3]=0.0;i=i;return}function uXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16272>>3]=0.0;i=i;return}function vXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16280>>3]=0.0;i=i;return}function wXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16288>>3]=0.0;i=i;return}function xXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16296>>3]=0.0;i=i;return}function yXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16304>>3]=0.0;i=i;return}function zXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16312>>3]=0.0;i=i;return}function AXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16328>>3]=0.0;i=i;return}function BXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21480>>3]=0.0;i=i;return}function CXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16336>>3]=0.0;i=i;return}function DXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16344>>3]=0.0;i=i;return}function EXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16352>>3]=0.0;i=i;return}function FXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16360>>3]=0.0;i=i;return}function GXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16368>>3]=0.0;i=i;return}function HXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16376>>3]=0.0;i=i;return}function IXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16384>>3]=1.0;i=i;return}function JXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16392>>3]=1.0;i=i;return}function KXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16400>>3]=0.0;i=i;return}function LXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16408>>3]=0.0;i=i;return}function MXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16416>>3]=0.0;i=i;return}function NXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16424>>3]=1.0;i=i;return}function OXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16432>>3]=0.0;i=i;return}function PXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16440>>3]=0.0;i=i;return}function QXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16448>>3]=0.0;i=i;return}function RXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16456>>3]=0.0;i=i;return}function SXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16464>>3]=0.0;i=i;return}function TXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16472>>3]=0.0;i=i;return}function UXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16480>>3]=0.0;i=i;return}function VXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16488>>3]=0.0;i=i;return}function WXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16496>>3]=0.0;i=i;return}function XXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16504>>3]=0.0;i=i;return}function YXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16512>>3]=0.0;i=i;return}function ZXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16520>>3]=0.0;i=i;return}function _Xa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16528>>3]=0.0;i=i;return}function $Xa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16536>>3]=0.0;i=i;return}function aYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16544>>3]=0.0;i=i;return}function bYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16560>>3]=0.0;i=i;return}function cYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21488>>3]=0.0;i=i;return}function dYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16568>>3]=0.0;i=i;return}function eYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16576>>3]=0.0;i=i;return}function fYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16584>>3]=0.0;i=i;return}function gYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16592>>3]=0.0;i=i;return}function hYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16600>>3]=0.0;i=i;return}function iYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16608>>3]=0.0;i=i;return}function jYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16616>>3]=1.0;i=i;return}function kYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16624>>3]=1.0;i=i;return}function lYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16632>>3]=0.0;i=i;return}function mYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16640>>3]=0.0;i=i;return}function nYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16648>>3]=0.0;i=i;return}function oYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16656>>3]=1.0;i=i;return}function pYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16664>>3]=0.0;i=i;return}function qYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16672>>3]=0.0;i=i;return}function rYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16680>>3]=0.0;i=i;return}function sYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16688>>3]=0.0;i=i;return}function tYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16696>>3]=0.0;i=i;return}function uYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16704>>3]=0.0;i=i;return}function vYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16712>>3]=0.0;i=i;return}function wYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16720>>3]=0.0;i=i;return}function xYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16728>>3]=0.0;i=i;return}function yYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16736>>3]=0.0;i=i;return}function zYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16744>>3]=0.0;i=i;return}function AYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16752>>3]=0.0;i=i;return}function BYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16760>>3]=0.0;i=i;return}function CYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16768>>3]=0.0;i=i;return}function DYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16776>>3]=0.0;i=i;return}function EYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16792>>3]=0.0;i=i;return}function FYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21496>>3]=0.0;i=i;return}function GYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16800>>3]=0.0;i=i;return}function HYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16808>>3]=0.0;i=i;return}function IYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16816>>3]=0.0;i=i;return}function JYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16824>>3]=0.0;i=i;return}function KYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16832>>3]=0.0;i=i;return}function LYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16840>>3]=0.0;i=i;return}function MYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16848>>3]=1.0;i=i;return}function NYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16856>>3]=1.0;i=i;return}function OYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16864>>3]=0.0;i=i;return}function PYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16872>>3]=0.0;i=i;return}function QYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16880>>3]=0.0;i=i;return}function RYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16888>>3]=1.0;i=i;return}function SYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16896>>3]=0.0;i=i;return}function TYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16904>>3]=0.0;i=i;return}function UYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16912>>3]=0.0;i=i;return}function VYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16920>>3]=0.0;i=i;return}function WYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16928>>3]=0.0;i=i;return}function XYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16936>>3]=0.0;i=i;return}function YYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16944>>3]=0.0;i=i;return}function ZYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16952>>3]=0.0;i=i;return}function _Ya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16960>>3]=0.0;i=i;return}function $Ya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16968>>3]=0.0;i=i;return}function aZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16976>>3]=0.0;i=i;return}function bZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16984>>3]=0.0;i=i;return}function cZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16992>>3]=0.0;i=i;return}function dZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17e3>>3]=0.0;i=i;return}function eZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17008>>3]=0.0;i=i;return}function fZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17024>>3]=0.0;i=i;return}function gZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21504>>3]=0.0;i=i;return}function hZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17032>>3]=0.0;i=i;return}function iZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17040>>3]=0.0;i=i;return}function jZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17048>>3]=0.0;i=i;return}function kZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17056>>3]=0.0;i=i;return}function lZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17064>>3]=0.0;i=i;return}function mZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17072>>3]=0.0;i=i;return}function nZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17080>>3]=1.0;i=i;return}function oZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17088>>3]=1.0;i=i;return}function pZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17096>>3]=0.0;i=i;return}function qZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17104>>3]=0.0;i=i;return}function rZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17112>>3]=0.0;i=i;return}function sZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17120>>3]=1.0;i=i;return}function tZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17128>>3]=0.0;i=i;return}function uZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17136>>3]=0.0;i=i;return}function vZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17144>>3]=0.0;i=i;return}function wZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17152>>3]=0.0;i=i;return}function xZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17160>>3]=0.0;i=i;return}function yZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17168>>3]=0.0;i=i;return}function zZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17176>>3]=0.0;i=i;return}function AZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17184>>3]=0.0;i=i;return}function BZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17192>>3]=0.0;i=i;return}function CZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17200>>3]=0.0;i=i;return}function DZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17208>>3]=0.0;i=i;return}function EZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17216>>3]=0.0;i=i;return}function FZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17224>>3]=0.0;i=i;return}function GZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17232>>3]=0.0;i=i;return}function HZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17240>>3]=0.0;i=i;return}function IZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17256>>3]=0.0;i=i;return}function JZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21512>>3]=0.0;i=i;return}function KZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17264>>3]=0.0;i=i;return}function LZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17272>>3]=0.0;i=i;return}function MZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17280>>3]=0.0;i=i;return}function NZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17288>>3]=0.0;i=i;return}function OZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17296>>3]=0.0;i=i;return}function PZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17304>>3]=0.0;i=i;return}function QZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17312>>3]=1.0;i=i;return}function RZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17320>>3]=1.0;i=i;return}function SZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17328>>3]=0.0;i=i;return}function TZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17336>>3]=0.0;i=i;return}function UZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17344>>3]=0.0;i=i;return}function VZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17352>>3]=1.0;i=i;return}function WZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17360>>3]=0.0;i=i;return}function XZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17368>>3]=0.0;i=i;return}function YZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17376>>3]=0.0;i=i;return}function ZZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17384>>3]=0.0;i=i;return}function _Za(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17392>>3]=0.0;i=i;return}function $Za(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17400>>3]=0.0;i=i;return}function a_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17408>>3]=0.0;i=i;return}function b_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17416>>3]=0.0;i=i;return}function c_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17424>>3]=0.0;i=i;return}function d_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17432>>3]=0.0;i=i;return}function e_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17440>>3]=0.0;i=i;return}function f_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17448>>3]=0.0;i=i;return}function g_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17456>>3]=0.0;i=i;return}function h_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17464>>3]=0.0;i=i;return}function i_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17472>>3]=0.0;i=i;return}function j_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17488>>3]=0.0;i=i;return}function k_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21520>>3]=0.0;i=i;return}function l_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17496>>3]=0.0;i=i;return}function m_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17504>>3]=0.0;i=i;return}function n_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17512>>3]=0.0;i=i;return}function o_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17520>>3]=0.0;i=i;return}function p_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17528>>3]=0.0;i=i;return}function q_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17536>>3]=0.0;i=i;return}function r_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17544>>3]=1.0;i=i;return}function s_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17552>>3]=1.0;i=i;return}function t_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17560>>3]=0.0;i=i;return}function u_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17568>>3]=0.0;i=i;return}function v_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17576>>3]=0.0;i=i;return}function w_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17584>>3]=1.0;i=i;return}function x_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17592>>3]=0.0;i=i;return}function y_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17600>>3]=0.0;i=i;return}function z_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17608>>3]=0.0;i=i;return}function A_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17616>>3]=0.0;i=i;return}function B_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17624>>3]=0.0;i=i;return}function C_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17632>>3]=0.0;i=i;return}function D_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17640>>3]=0.0;i=i;return}function E_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17648>>3]=0.0;i=i;return}function F_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17656>>3]=0.0;i=i;return}function G_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17664>>3]=0.0;i=i;return}function H_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17672>>3]=0.0;i=i;return}function I_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17680>>3]=0.0;i=i;return}function J_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17688>>3]=0.0;i=i;return}function K_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17696>>3]=0.0;i=i;return}function L_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21528>>3]=0.0;i=i;return}function M_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17704>>3]=0.0;i=i;return}function N_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17712>>3]=0.0;i=i;return}function O_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17720>>3]=0.0;i=i;return}function P_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17728>>3]=0.0;i=i;return}function Q_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17736>>3]=0.0;i=i;return}function R_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17744>>3]=0.0;i=i;return}function S_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17752>>3]=0.0;i=i;return}function T_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17760>>3]=0.0;i=i;return}function U_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17768>>3]=0.0;i=i;return}function V_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17776>>3]=0.0;i=i;return}function W_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17784>>3]=0.0;i=i;return}function X_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17792>>3]=0.0;i=i;return}function Y_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17800>>3]=0.0;i=i;return}function Z_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17808>>3]=0.0;i=i;return}function __a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17816>>3]=0.0;i=i;return}function $_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17824>>3]=0.0;i=i;return}function a$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17832>>3]=0.0;i=i;return}function b$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17840>>3]=0.0;i=i;return}function c$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17848>>3]=0.0;i=i;return}function d$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17856>>3]=-.1;i=i;return}function e$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17864>>3]=0.0;i=i;return}function f$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17872>>3]=0.0;i=i;return}function g$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17880>>3]=0.0;i=i;return}function h$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17888>>3]=0.0;i=i;return}function i$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17896>>3]=0.0;i=i;return}function j$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17904>>3]=0.0;i=i;return}function k$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17912>>3]=0.0;i=i;return}function l$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17920>>3]=0.0;i=i;return}function m$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17928>>3]=0.0;i=i;return}function n$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17936>>3]=0.0;i=i;return}function o$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17944>>3]=0.0;i=i;return}function p$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17952>>3]=0.0;i=i;return}function q$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17960>>3]=0.0;i=i;return}function r$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21536>>3]=0.0;i=i;return}function s$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17968>>3]=0.0;i=i;return}function t$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17976>>3]=0.0;i=i;return}function u$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17984>>3]=0.0;i=i;return}function v$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17992>>3]=0.0;i=i;return}function w$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18e3>>3]=0.0;i=i;return}function x$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18008>>3]=0.0;i=i;return}function y$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18016>>3]=0.0;i=i;return}function z$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18024>>3]=0.0;i=i;return}function A$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18032>>3]=0.0;i=i;return}function B$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18040>>3]=0.0;i=i;return}function C$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18048>>3]=0.0;i=i;return}function D$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18056>>3]=0.0;i=i;return}function E$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18064>>3]=0.0;i=i;return}function F$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18072>>3]=0.0;i=i;return}function G$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18080>>3]=0.0;i=i;return}function H$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18088>>3]=0.0;i=i;return}function I$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18096>>3]=0.0;i=i;return}function J$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18104>>3]=0.0;i=i;return}function K$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18112>>3]=0.0;i=i;return}function L$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18120>>3]=-.1;i=i;return}function M$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18128>>3]=0.0;i=i;return}function N$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18136>>3]=0.0;i=i;return}function O$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18144>>3]=0.0;i=i;return}function P$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18152>>3]=0.0;i=i;return}function Q$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18160>>3]=0.0;i=i;return}function R$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18168>>3]=0.0;i=i;return}function S$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18176>>3]=0.0;i=i;return}function T$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18184>>3]=0.0;i=i;return}function U$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18192>>3]=0.0;i=i;return}function V$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18200>>3]=0.0;i=i;return}function W$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18208>>3]=0.0;i=i;return}function X$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18216>>3]=0.0;i=i;return}function Y$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18224>>3]=0.0;i=i;return}function Z$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21544>>3]=0.0;i=i;return}function _$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18232>>3]=0.0;i=i;return}function $$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18240>>3]=0.0;i=i;return}function a0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18248>>3]=0.0;i=i;return}function b0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18256>>3]=0.0;i=i;return}function c0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18264>>3]=0.0;i=i;return}function d0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18272>>3]=0.0;i=i;return}function e0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18280>>3]=0.0;i=i;return}function f0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18288>>3]=0.0;i=i;return}function g0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18296>>3]=0.0;i=i;return}function h0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18304>>3]=0.0;i=i;return}function i0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18312>>3]=0.0;i=i;return}function j0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18320>>3]=0.0;i=i;return}function k0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18328>>3]=0.0;i=i;return}function l0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18336>>3]=0.0;i=i;return}function m0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18344>>3]=0.0;i=i;return}function n0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18352>>3]=0.0;i=i;return}function o0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18360>>3]=0.0;i=i;return}function p0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18368>>3]=0.0;i=i;return}function q0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18376>>3]=0.0;i=i;return}function r0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18384>>3]=-.1;i=i;return}function s0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18392>>3]=0.0;i=i;return}function t0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18400>>3]=0.0;i=i;return}function u0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18408>>3]=0.0;i=i;return}function v0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18416>>3]=0.0;i=i;return}function w0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18424>>3]=0.0;i=i;return}function x0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18432>>3]=0.0;i=i;return}function y0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18440>>3]=0.0;i=i;return}function z0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18448>>3]=0.0;i=i;return}function A0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18456>>3]=0.0;i=i;return}function B0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18464>>3]=0.0;i=i;return}function C0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18472>>3]=0.0;i=i;return}function D0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18480>>3]=0.0;i=i;return}function E0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18488>>3]=0.0;i=i;return}function F0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21552>>3]=0.0;i=i;return}function G0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18496>>3]=0.0;i=i;return}function H0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18504>>3]=0.0;i=i;return}function I0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18512>>3]=0.0;i=i;return}function J0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18520>>3]=0.0;i=i;return}function K0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18528>>3]=0.0;i=i;return}function L0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18536>>3]=0.0;i=i;return}function M0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18544>>3]=0.0;i=i;return}function N0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18552>>3]=0.0;i=i;return}function O0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18560>>3]=0.0;i=i;return}function P0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18568>>3]=0.0;i=i;return}function Q0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18576>>3]=0.0;i=i;return}function R0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18584>>3]=0.0;i=i;return}function S0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18592>>3]=0.0;i=i;return}function T0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18600>>3]=0.0;i=i;return}function U0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18608>>3]=0.0;i=i;return}function V0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18616>>3]=0.0;i=i;return}function W0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18624>>3]=0.0;i=i;return}function X0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18632>>3]=0.0;i=i;return}function Y0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18640>>3]=0.0;i=i;return}function Z0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18648>>3]=-.1;i=i;return}function _0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18656>>3]=0.0;i=i;return}function $0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18664>>3]=0.0;i=i;return}function a1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18672>>3]=0.0;i=i;return}function b1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18680>>3]=0.0;i=i;return}function c1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18688>>3]=0.0;i=i;return}function d1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18696>>3]=0.0;i=i;return}function e1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18704>>3]=0.0;i=i;return}function f1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18712>>3]=0.0;i=i;return}function g1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18720>>3]=0.0;i=i;return}function h1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18728>>3]=0.0;i=i;return}function i1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18736>>3]=0.0;i=i;return}function j1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18744>>3]=0.0;i=i;return}function k1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18752>>3]=0.0;i=i;return}function l1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21560>>3]=0.0;i=i;return}function m1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18760>>3]=0.0;i=i;return}function n1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18768>>3]=0.0;i=i;return}function o1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18776>>3]=0.0;i=i;return}function p1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18784>>3]=0.0;i=i;return}function q1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18792>>3]=0.0;i=i;return}function r1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18800>>3]=0.0;i=i;return}function s1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18808>>3]=0.0;i=i;return}function t1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18816>>3]=0.0;i=i;return}function u1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18824>>3]=0.0;i=i;return}function v1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18832>>3]=0.0;i=i;return}function w1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18840>>3]=0.0;i=i;return}function x1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18848>>3]=0.0;i=i;return}function y1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18856>>3]=0.0;i=i;return}function z1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18864>>3]=0.0;i=i;return}function A1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18872>>3]=0.0;i=i;return}function B1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18880>>3]=0.0;i=i;return}function C1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18888>>3]=0.0;i=i;return}function D1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18896>>3]=0.0;i=i;return}function E1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18904>>3]=0.0;i=i;return}function F1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18912>>3]=-.1;i=i;return}function G1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18920>>3]=0.0;i=i;return}function H1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18928>>3]=0.0;i=i;return}function I1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18936>>3]=0.0;i=i;return}function J1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18944>>3]=0.0;i=i;return}function K1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18952>>3]=0.0;i=i;return}function L1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18960>>3]=0.0;i=i;return}function M1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18968>>3]=0.0;i=i;return}function N1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18976>>3]=0.0;i=i;return}function O1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18984>>3]=0.0;i=i;return}function P1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18992>>3]=0.0;i=i;return}function Q1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19e3>>3]=0.0;i=i;return}function R1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19008>>3]=0.0;i=i;return}function S1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19016>>3]=0.0;i=i;return}function T1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21568>>3]=0.0;i=i;return}function U1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19024>>3]=0.0;i=i;return}function V1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19032>>3]=0.0;i=i;return}function W1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19040>>3]=0.0;i=i;return}function X1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19048>>3]=0.0;i=i;return}function Y1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19056>>3]=0.0;i=i;return}function Z1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19064>>3]=0.0;i=i;return}function _1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19072>>3]=0.0;i=i;return}function $1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19080>>3]=0.0;i=i;return}function a2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19088>>3]=0.0;i=i;return}function b2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19096>>3]=0.0;i=i;return}function c2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19104>>3]=0.0;i=i;return}function d2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19112>>3]=0.0;i=i;return}function e2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19120>>3]=0.0;i=i;return}function f2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19128>>3]=0.0;i=i;return}function g2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19136>>3]=0.0;i=i;return}function h2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19144>>3]=0.0;i=i;return}function i2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19152>>3]=0.0;i=i;return}function j2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19160>>3]=0.0;i=i;return}function k2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19168>>3]=0.0;i=i;return}function l2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19176>>3]=0.0;i=i;return}function m2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19184>>3]=0.0;i=i;return}function n2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19192>>3]=0.0;i=i;return}function o2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19200>>3]=0.0;i=i;return}function p2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19208>>3]=0.0;i=i;return}function q2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19216>>3]=0.0;i=i;return}function r2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19224>>3]=0.0;i=i;return}function s2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19232>>3]=0.0;i=i;return}function t2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19240>>3]=0.0;i=i;return}function u2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19248>>3]=0.0;i=i;return}function v2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19256>>3]=0.0;i=i;return}function w2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19264>>3]=0.0;i=i;return}function x2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19272>>3]=-.1;i=i;return}function y2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19280>>3]=0.0;i=i;return}function z2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19288>>3]=0.0;i=i;return}function A2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19296>>3]=0.0;i=i;return}function B2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19304>>3]=0.0;i=i;return}function C2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19312>>3]=0.0;i=i;return}function D2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19320>>3]=0.0;i=i;return}function E2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19328>>3]=0.0;i=i;return}function F2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19336>>3]=0.0;i=i;return}function G2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19344>>3]=0.0;i=i;return}function H2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19352>>3]=0.0;i=i;return}function I2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19360>>3]=0.0;i=i;return}function J2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19368>>3]=0.0;i=i;return}function K2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19376>>3]=0.0;i=i;return}function L2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21576>>3]=0.0;i=i;return}function M2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19384>>3]=1.0;i=i;return}function N2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19408>>3]=0.0;i=i;return}function O2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19432>>3]=0.0;i=i;return}function P2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19392>>3]=0.0;i=i;return}function Q2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19416>>3]=1.0;i=i;return}function R2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19440>>3]=0.0;i=i;return}function S2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19400>>3]=0.0;i=i;return}function T2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19424>>3]=0.0;i=i;return}function U2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19448>>3]=1.0;i=i;return}function V2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19456>>3]=0.0;i=i;return}function W2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19464>>3]=0.0;i=i;return}function X2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19472>>3]=0.0;i=i;return}function Y2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19480>>3]=0.0;i=i;return}function Z2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19488>>3]=0.0;i=i;return}function _2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19496>>3]=0.0;i=i;return}function $2a(b){b=b|0;var d=0,e=0;d=c[b+424>>2]|0;if((a[d+1|0]|0)==0){e=0}else{e=(a[d+2|0]|0)!=0|0}c[(c[b+420>>2]|0)+772>>2]=e;i=i;return}function a3a(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+424>>2]|0;do{if((a[e+1|0]|0)==0){f=0}else{if((a[e+2|0]|0)==0){f=0;break}f=(a[e+5|0]|0)!=0|0}}while(0);c[(c[b+420>>2]|0)+776>>2]=f;i=d;return}function b3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18912>>3]=+h[b+18864>>3]*.5;i=i;return}function c3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18920>>3]=+h[b+18864>>3]*.2;i=i;return}function d3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18928>>3]=+h[b+18864>>3]*.1;i=i;return}function e3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18936>>3]=+h[b+18864>>3]*.05;i=i;return}function f3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18944>>3]=+h[b+18864>>3]*.1;i=i;return}function g3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18952>>3]=+h[b+18864>>3]*.05;i=i;return}function h3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18960>>3]=+h[b+18864>>3]/9.0;i=i;return}function i3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18968>>3]=+h[b+18864>>3]*.025;i=i;return}function j3a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18880>>3];j=+h[f+18912>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23352,23344,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+18976>>3]=l;i=d;return}function k3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18984>>3]=+h[b+18912>>3]*.5;i=i;return}function l3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18992>>3]=+h[b+18912>>3]*1.05;i=i;return}function m3a(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+19e3>>3]=+qd(+(+h[d+18912>>3]),+(+h[d+18976>>3]*5.0));i=b;return}function n3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19008>>3]=+h[b+18976>>3]*3.0;i=i;return}function o3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19016>>3]=+h[b+18976>>3];i=i;return}function p3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19024>>3]=+h[b+18976>>3]*3.0;i=i;return}function q3a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+18984>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23392,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+19032>>3]=l;i=d;return}function r3a(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+19040>>3]=+rd(0.0,+(+h[d+18912>>3]- +h[d+19e3>>3]));i=b;return}function s3a(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+19048>>3]=+qd(+(+h[d+18984>>3]),+(+h[d+19032>>3]*4.0));i=b;return}function t3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19056>>3]=+h[b+19032>>3]*3.0;i=i;return}function u3a(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+19064>>3]=+rd(0.0,+(+h[d+18984>>3]- +h[d+19048>>3]));i=b;return}function v3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+264>>3]=+h[b+96>>3];i=i;return}function w3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9752>>3]=+h[b+264>>3]+ +h[b+1400>>3];i=i;return}function x3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+272>>3]=+h[b+104>>3];i=i;return}function y3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+280>>3]=+h[b+112>>3];i=i;return}function z3a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+264>>3]- +h[b+288>>3];e=+h[b+272>>3]- +h[b+296>>3];f=+h[b+280>>3]- +h[b+304>>3];h[b+19168>>3]=+V(+(d*d+e*e+f*f));i=i;return}function A3a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+19168>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23432,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+19176>>3]=l;i=d;return}function B3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19184>>3]=+h[b+19176>>3];i=i;return}function C3a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+96>>3]- +h[b+216>>3];e=+h[b+104>>3]- +h[b+224>>3];f=+h[b+112>>3]- +h[b+232>>3];h[b+19192>>3]=+V(+(d*d+e*e+f*f));i=i;return}function D3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+384>>3]=+h[b+120>>3];i=i;return}function E3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+392>>3]=+h[b+128>>3];i=i;return}function F3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+400>>3]=+h[b+136>>3];i=i;return}function G3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19200>>3]=+h[b+19096>>3];i=i;return}function H3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19208>>3]=+h[b+19104>>3];i=i;return}function I3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19216>>3]=+h[b+19112>>3];i=i;return}function J3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19224>>3]=+h[b+19120>>3];i=i;return}function K3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19232>>3]=+h[b+19128>>3];i=i;return}function L3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19240>>3]=+h[b+19136>>3];i=i;return}function M3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19248>>3]=+h[b+19144>>3];i=i;return}function N3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+408>>3]=+h[b+144>>3];i=i;return}function O3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+416>>3]=+h[b+152>>3];i=i;return}function P3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+424>>3]=+h[b+160>>3];i=i;return}function Q3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+432>>3]=+h[b+168>>3];i=i;return}function R3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+440>>3]=+h[b+176>>3];i=i;return}function S3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+448>>3]=+h[b+184>>3];i=i;return}function T3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+456>>3]=+h[b+192>>3];i=i;return}function U3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+464>>3]=+h[b+200>>3];i=i;return}function V3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+472>>3]=+h[b+208>>3];i=i;return}function W3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+480>>3]=+h[b+408>>3];i=i;return}function X3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+488>>3]=+h[b+416>>3];i=i;return}function Y3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+496>>3]=+h[b+424>>3];i=i;return}function Z3a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19256>>3]=+h[b+18960>>3];i=i;return}function _3a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+696>>3]=l;i=b;return}function $3a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+704>>3]=l;i=b;return}function a4a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+712>>3]=l;i=b;return}function b4a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+720>>3]=l;i=b;return}function c4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19264>>3]=+h[b+19256>>3]/3.0;i=i;return}function d4a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+19192>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23472,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+19272>>3]=l;i=d;return}function e4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19280>>3]=+h[b+19272>>3];i=i;return}function f4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19288>>3]=+h[b+19272>>3]*2.0;i=i;return}function g4a(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+23|0]=a[d+6|0]|0;i=i;return}function h4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+728>>3]=+h[b+19304>>3];i=i;return}function i4a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+728>>3]- +h[b+752>>3];e=+h[b+736>>3]- +h[b+760>>3];f=+h[b+744>>3]- +h[b+768>>3];h[b+19432>>3]=+V(+(d*d+e*e+f*f));i=i;return}function j4a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+19432>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23480,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+19440>>3]=l;i=d;return}function k4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19448>>3]=+h[b+19440>>3];i=i;return}function l4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+824>>3]=+h[b+19304>>3];i=i;return}function m4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10472>>3]=+h[b+264>>3]+ +h[b+824>>3];i=i;return}function n4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9872>>3]=+h[b+10472>>3]+ +h[(c[a+416>>2]|0)+4416>>3];i=i;return}function o4a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+824>>3]- +h[b+848>>3];e=+h[b+832>>3]- +h[b+856>>3];f=+h[b+840>>3]- +h[b+864>>3];h[b+19464>>3]=+V(+(d*d+e*e+f*f));i=i;return}function p4a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+19464>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23488,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+19472>>3]=l;i=d;return}function q4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19480>>3]=+h[b+19472>>3];i=i;return}function r4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+920>>3]=+h[b+19304>>3]+ +h[b+19320>>3]*-.5;i=i;return}function s4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9728>>3]=+h[b+9752>>3]+ +h[(c[a+416>>2]|0)+920>>3];i=i;return}function t4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+928>>3]=+h[b+19312>>3];i=i;return}function u4a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+920>>3]- +h[b+944>>3];e=+h[b+928>>3]- +h[b+952>>3];f=+h[b+936>>3]- +h[b+960>>3];h[b+19496>>3]=+V(+(d*d+e*e+f*f));i=i;return}function v4a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+19496>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23496,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+19504>>3]=l;i=d;return}function w4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19512>>3]=+h[b+19504>>3];i=i;return}function x4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1016>>3]=+h[b+19304>>3]+ +h[b+19320>>3]*-.5;i=i;return}function y4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16096>>3]=+h[(c[a+416>>2]|0)+1016>>3];i=i;return}function z4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9704>>3]=+h[b+9728>>3]- +h[b+16096>>3];i=i;return}function A4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9680>>3]=+h[b+15088>>3]- +h[b+9704>>3];i=i;return}function B4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9656>>3]=+h[b+16096>>3]- +h[b+9728>>3];i=i;return}function C4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19520>>3]=+h[b+19328>>3];i=i;return}function D4a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+1016>>3]- +h[b+1136>>3];e=+h[b+1024>>3]- +h[b+1144>>3];f=+h[b+1032>>3]- +h[b+1152>>3];h[b+19536>>3]=+V(+(d*d+e*e+f*f));i=i;return}function E4a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+19536>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23504,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+19544>>3]=l;i=d;return}function F4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19552>>3]=+h[b+19544>>3];i=i;return}function G4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19560>>3]=+h[b+19336>>3];i=i;return}function H4a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+1400>>3]- +h[b+1520>>3];e=+h[b+1408>>3]- +h[b+1528>>3];f=+h[b+1416>>3]- +h[b+1536>>3];h[b+19576>>3]=+V(+(d*d+e*e+f*f));i=i;return}function I4a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+19576>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23512,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+19584>>3]=l;i=d;return}function J4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19592>>3]=+h[b+19584>>3];i=i;return}function K4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19600>>3]=+h[b+19344>>3]*.5;i=i;return}function L4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19608>>3]=+h[b+19384>>3]*.5;i=i;return}function M4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1864>>3]=-+h[b+19344>>3];i=i;return}function N4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19624>>3]=-+h[b+19296>>3];i=i;return}function O4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19640>>3]=+h[b+18928>>3];i=i;return}function P4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19648>>3]=+h[b+18936>>3];i=i;return}function Q4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19656>>3]=+h[b+18936>>3];i=i;return}function R4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19664>>3]=+h[b+19624>>3];i=i;return}function S4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19672>>3]=+h[b+19632>>3];i=i;return}function T4a(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+33|0]=a[d+30|0]|0;i=i;return}function U4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19680>>3]=+h[b+18928>>3];i=i;return}function V4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19688>>3]=+h[b+18936>>3];i=i;return}function W4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19696>>3]=+h[b+18928>>3];i=i;return}function X4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19704>>3]=+h[b+18936>>3];i=i;return}function Y4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19712>>3]=+h[b+19680>>3]*.5;i=i;return}function Z4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19720>>3]=+h[b+19688>>3];i=i;return}function _4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19728>>3]=+h[b+19712>>3];i=i;return}function $4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19736>>3]=+h[b+19816>>3];i=i;return}function a5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19744>>3]=+h[b+19816>>3];i=i;return}function b5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19752>>3]=+h[b+19664>>3];i=i;return}function c5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19760>>3]=+h[b+19672>>3];i=i;return}function d5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19768>>3]=+h[b+19688>>3];i=i;return}function e5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19776>>3]=+h[b+19720>>3];i=i;return}function f5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19792>>3]=+h[b+19680>>3];i=i;return}function g5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19800>>3]=+h[b+19696>>3];i=i;return}function h5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19808>>3]=+h[b+19704>>3];i=i;return}function i5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19824>>3]=+h[b+19712>>3];i=i;return}function j5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19832>>3]=+h[b+19712>>3];i=i;return}function k5a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+2360>>3];e=-.1- +h[b+2368>>3];f=+h[b+2376>>3];h[b+19848>>3]=+V(+(f*f+(d*d+e*e)));i=i;return}function l5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19856>>3]=+h[b+19728>>3];i=i;return}function m5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19864>>3]=+h[b+19728>>3];i=i;return}function n5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19872>>3]=+h[b+19648>>3]*1.1;i=i;return}function o5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19880>>3]=+h[b+19656>>3];i=i;return}function p5a(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+42|0]=a[d+23|0]|0;i=i;return}function q5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2488>>3]=+h[b+19384>>3];i=i;return}function r5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2512>>3]=+h[b+19384>>3]*.5;i=i;return}function s5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19928>>3]=+h[b+19392>>3];i=i;return}function t5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19936>>3]=+h[b+19400>>3];i=i;return}function u5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19944>>3]=+h[b+19408>>3];i=i;return}function v5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19952>>3]=+h[b+19416>>3];i=i;return}function w5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2648>>3]=+h[b+2480>>3];i=i;return}function x5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2656>>3]=+h[b+2488>>3];i=i;return}function y5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2664>>3]=+h[b+2496>>3];i=i;return}function z5a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+2648>>3]- +h[b+2672>>3];e=+h[b+2656>>3]- +h[b+2680>>3];f=+h[b+2664>>3]- +h[b+2688>>3];h[b+2e4>>3]=+V(+(d*d+e*e+f*f));i=i;return}function A5a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+2e4>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23520,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+20008>>3]=l;i=d;return}function B5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20016>>3]=+h[b+20008>>3];i=i;return}function C5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20024>>3]=+h[b+19384>>3]/1.75;i=i;return}function D5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2768>>3]=+h[b+2504>>3];i=i;return}function E5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2776>>3]=+h[b+2512>>3];i=i;return}function F5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2784>>3]=+h[b+2520>>3];i=i;return}function G5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20032>>3]=+h[b+19928>>3];i=i;return}function H5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20040>>3]=+h[b+19936>>3];i=i;return}function I5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20048>>3]=+h[b+19944>>3];i=i;return}function J5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20056>>3]=+h[b+19952>>3];i=i;return}function K5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20064>>3]=+h[b+19960>>3];i=i;return}function L5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20072>>3]=+h[b+19968>>3];i=i;return}function M5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20080>>3]=+h[b+19976>>3];i=i;return}function N5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2792>>3]=+h[b+2528>>3];i=i;return}function O5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2800>>3]=+h[b+2536>>3];i=i;return}function P5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2808>>3]=+h[b+2544>>3];i=i;return}function Q5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2816>>3]=+h[b+2552>>3];i=i;return}function R5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2824>>3]=+h[b+2560>>3];i=i;return}function S5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2832>>3]=+h[b+2568>>3];i=i;return}function T5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2840>>3]=+h[b+2576>>3];i=i;return}function U5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2848>>3]=+h[b+2584>>3];i=i;return}function V5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2856>>3]=+h[b+2592>>3];i=i;return}function W5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2864>>3]=+h[b+2792>>3];i=i;return}function X5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2872>>3]=+h[b+2800>>3];i=i;return}function Y5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2880>>3]=+h[b+2808>>3];i=i;return}function Z5a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20088>>3]=+h[b+18960>>3];i=i;return}function _5a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+3080>>3]=l;i=b;return}function $5a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+3088>>3]=l;i=b;return}function a6a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+3096>>3]=l;i=b;return}function b6a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+3104>>3]=l;i=b;return}function c6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20096>>3]=+h[b+20088>>3]/3.0;i=i;return}function d6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20104>>3]=+h[b+19384>>3]/1.75;i=i;return}function e6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20112>>3]=+h[b+19384>>3]/1.75;i=i;return}function f6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20120>>3]=+h[b+20104>>3]*2.0;i=i;return}function g6a(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+56>>2]=c[b+48>>2];i=i;return}function h6a(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+56|0]=a[d+23|0]|0;i=i;return}function i6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3120>>3]=+h[b+19344>>3];i=i;return}function j6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3144>>3]=+h[b+19344>>3]*.5;i=i;return}function k6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20128>>3]=+h[b+19352>>3];i=i;return}function l6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20136>>3]=+h[b+19360>>3];i=i;return}function m6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20144>>3]=+h[b+19368>>3];i=i;return}function n6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20152>>3]=+h[b+19376>>3];i=i;return}function o6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3280>>3]=+h[b+3112>>3];i=i;return}function p6a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10832>>3]=+h[b+16096>>3]- +h[(c[a+416>>2]|0)+3280>>3];i=i;return}function q6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3288>>3]=+h[b+3120>>3];i=i;return}function r6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3296>>3]=+h[b+3128>>3];i=i;return}function s6a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+3280>>3]- +h[b+3304>>3];e=+h[b+3288>>3]- +h[b+3312>>3];f=+h[b+3296>>3]- +h[b+3320>>3];h[b+20200>>3]=+V(+(d*d+e*e+f*f));i=i;return}function t6a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+20200>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23528,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+20208>>3]=l;i=d;return}function u6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20216>>3]=+h[b+20208>>3];i=i;return}function v6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3400>>3]=+h[b+3136>>3];i=i;return}function w6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3408>>3]=+h[b+3144>>3];i=i;return}function x6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3416>>3]=+h[b+3152>>3];i=i;return}function y6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20232>>3]=+h[b+20128>>3];i=i;return}function z6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20240>>3]=+h[b+20136>>3];i=i;return}function A6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20248>>3]=+h[b+20144>>3];i=i;return}function B6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20256>>3]=+h[b+20152>>3];i=i;return}function C6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20264>>3]=+h[b+20160>>3];i=i;return}function D6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20272>>3]=+h[b+20168>>3];i=i;return}function E6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20280>>3]=+h[b+20176>>3];i=i;return}function F6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3424>>3]=+h[b+3160>>3];i=i;return}function G6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3432>>3]=+h[b+3168>>3];i=i;return}function H6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3440>>3]=+h[b+3176>>3];i=i;return}function I6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3448>>3]=+h[b+3184>>3];i=i;return}function J6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3456>>3]=+h[b+3192>>3];i=i;return}function K6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3464>>3]=+h[b+3200>>3];i=i;return}function L6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3472>>3]=+h[b+3208>>3];i=i;return}function M6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3480>>3]=+h[b+3216>>3];i=i;return}function N6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3488>>3]=+h[b+3224>>3];i=i;return}function O6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3496>>3]=+h[b+3424>>3];i=i;return}function P6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3504>>3]=+h[b+3432>>3];i=i;return}function Q6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3512>>3]=+h[b+3440>>3];i=i;return}function R6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20288>>3]=+h[b+18960>>3];i=i;return}function S6a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+3712>>3]=l;i=b;return}function T6a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+3720>>3]=l;i=b;return}function U6a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+3728>>3]=l;i=b;return}function V6a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=23440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=23456;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+3736>>3]=l;i=b;return}function W6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20296>>3]=+h[b+20288>>3]/3.0;i=i;return}function X6a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20320>>3]=+h[b+20304>>3]*2.0;i=i;return}function Y6a(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+68>>2]=c[b+60>>2];i=i;return}function Z6a(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+70|0]=a[d+23|0]|0;i=i;return}function _6a(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+76>>2]=c[b+72>>2];i=i;return}function $6a(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+71|0]=a[d+6|0]|0;i=i;return}function a7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3744>>3]=+h[b+20336>>3];i=i;return}function b7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10808>>3]=+h[b+728>>3]+ +h[b+3744>>3];i=i;return}function c7a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+3744>>3]- +h[b+3768>>3];e=+h[b+3752>>3]- +h[b+3776>>3];f=+h[b+3760>>3]- +h[b+3784>>3];h[b+20464>>3]=+V(+(d*d+e*e+f*f));i=i;return}function d7a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+20464>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23536,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+20472>>3]=l;i=d;return}function e7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20480>>3]=+h[b+20472>>3];i=i;return}function f7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3840>>3]=+h[b+20336>>3];i=i;return}function g7a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10448>>3]=+h[b+10472>>3]+ +h[(c[a+416>>2]|0)+3840>>3];i=i;return}function h7a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9992>>3]=+h[b+10448>>3]+ +h[(c[a+416>>2]|0)+7432>>3];i=i;return}function i7a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+3840>>3]- +h[b+3864>>3];e=+h[b+3848>>3]- +h[b+3872>>3];f=+h[b+3856>>3]- +h[b+3880>>3];h[b+20496>>3]=+V(+(d*d+e*e+f*f));i=i;return}function j7a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+20496>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23544,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+20504>>3]=l;i=d;return}function k7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20512>>3]=+h[b+20504>>3];i=i;return}function l7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3936>>3]=+h[b+20336>>3]+ +h[b+20352>>3]*-.5;i=i;return}function m7a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9848>>3]=+h[b+9872>>3]+ +h[(c[a+416>>2]|0)+3936>>3];i=i;return}function n7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3944>>3]=+h[b+20344>>3];i=i;return}function o7a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+3936>>3]- +h[b+3960>>3];e=+h[b+3944>>3]- +h[b+3968>>3];f=+h[b+3952>>3]- +h[b+3976>>3];h[b+20528>>3]=+V(+(d*d+e*e+f*f));i=i;return}function p7a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+20528>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23552,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+20536>>3]=l;i=d;return}function q7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20544>>3]=+h[b+20536>>3];i=i;return}function r7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4032>>3]=+h[b+20336>>3]+ +h[b+20352>>3]*-.5;i=i;return}function s7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10616>>3]=+h[b+728>>3]+ +h[b+4032>>3];i=i;return}function t7a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9824>>3]=+h[b+9848>>3]- +h[b+10616>>3];i=i;return}function u7a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9800>>3]=+h[b+15112>>3]- +h[b+9824>>3];i=i;return}function v7a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9776>>3]=+h[b+10616>>3]- +h[b+9848>>3];i=i;return}function w7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20552>>3]=+h[b+20360>>3];i=i;return}function x7a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+4032>>3]- +h[b+4152>>3];e=+h[b+4040>>3]- +h[b+4160>>3];f=+h[b+4048>>3]- +h[b+4168>>3];h[b+20568>>3]=+V(+(d*d+e*e+f*f));i=i;return}function y7a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+20568>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23560,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+20576>>3]=l;i=d;return}function z7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20584>>3]=+h[b+20576>>3];i=i;return}function A7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20592>>3]=+h[b+20368>>3];i=i;return}function B7a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+4416>>3]- +h[b+4536>>3];e=+h[b+4424>>3]- +h[b+4544>>3];f=+h[b+4432>>3]- +h[b+4552>>3];h[b+20608>>3]=+V(+(d*d+e*e+f*f));i=i;return}function C7a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+20608>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23568,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+20616>>3]=l;i=d;return}function D7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20624>>3]=+h[b+20616>>3];i=i;return}function E7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20632>>3]=+h[b+20376>>3]*.5;i=i;return}function F7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20640>>3]=+h[b+20416>>3]*.5;i=i;return}function G7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4880>>3]=-+h[b+20376>>3];i=i;return}function H7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20656>>3]=-+h[b+20328>>3];i=i;return}function I7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20672>>3]=+h[b+18928>>3];i=i;return}function J7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20680>>3]=+h[b+18936>>3];i=i;return}function K7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20688>>3]=+h[b+18936>>3];i=i;return}function L7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20696>>3]=+h[b+20656>>3];i=i;return}function M7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20704>>3]=+h[b+20664>>3];i=i;return}function N7a(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+81|0]=a[d+78|0]|0;i=i;return}function O7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20712>>3]=+h[b+18928>>3];i=i;return}function P7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20720>>3]=+h[b+18936>>3];i=i;return}function Q7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20728>>3]=+h[b+18928>>3];i=i;return}function R7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20736>>3]=+h[b+18936>>3];i=i;return}function S7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20744>>3]=+h[b+20712>>3]*.5;i=i;return}function T7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20752>>3]=+h[b+20720>>3];i=i;return}function U7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20760>>3]=+h[b+20744>>3];i=i;return}function V7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20768>>3]=+h[b+20848>>3];i=i;return}function W7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20776>>3]=+h[b+20848>>3];i=i;return}function X7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20784>>3]=+h[b+20696>>3];i=i;return}function Y7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20792>>3]=+h[b+20704>>3];i=i;return}function Z7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20800>>3]=+h[b+20720>>3];i=i;return}function _7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20808>>3]=+h[b+20752>>3];i=i;return}function $7a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20824>>3]=+h[b+20712>>3];i=i;return}function a8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20832>>3]=+h[b+20728>>3];i=i;return}function b8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20840>>3]=+h[b+20736>>3];i=i;return}function c8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20856>>3]=+h[b+20744>>3];i=i;return}function d8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20864>>3]=+h[b+20744>>3];i=i;return}function e8a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+5376>>3];e=-.1- +h[b+5384>>3];f=+h[b+5392>>3];h[b+20880>>3]=+V(+(f*f+(d*d+e*e)));i=i;return}function f8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20888>>3]=+h[b+20760>>3];i=i;return}function g8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20896>>3]=+h[b+20760>>3];i=i;return}function h8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20904>>3]=+h[b+20680>>3]*1.1;i=i;return}function i8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20912>>3]=+h[b+20688>>3];i=i;return}function j8a(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+90|0]=a[d+71|0]|0;i=i;return}function k8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5504>>3]=+h[b+20416>>3];i=i;return}function l8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5528>>3]=+h[b+20416>>3]*.5;i=i;return}function m8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20960>>3]=+h[b+20424>>3];i=i;return}function n8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20968>>3]=+h[b+20432>>3];i=i;return}function o8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20976>>3]=+h[b+20440>>3];i=i;return}function p8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20984>>3]=+h[b+20448>>3];i=i;return}function q8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5664>>3]=+h[b+5496>>3];i=i;return}function r8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5672>>3]=+h[b+5504>>3];i=i;return}function s8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5680>>3]=+h[b+5512>>3];i=i;return}function t8a(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+5664>>3]- +h[b+5688>>3];e=+h[b+5672>>3]- +h[b+5696>>3];f=+h[b+5680>>3]- +h[b+5704>>3];h[b+21032>>3]=+V(+(d*d+e*e+f*f));i=i;return}function u8a(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+21032>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,23400,23576,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+21040>>3]=l;i=d;return}function v8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21048>>3]=+h[b+21040>>3];i=i;return}function w8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21056>>3]=+h[b+20416>>3]/1.75;i=i;return}function x8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5784>>3]=+h[b+5520>>3];i=i;return}function y8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5792>>3]=+h[b+5528>>3];i=i;return}function z8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5800>>3]=+h[b+5536>>3];i=i;return}function A8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21064>>3]=+h[b+20960>>3];i=i;return}function B8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21072>>3]=+h[b+20968>>3];i=i;return}function C8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21080>>3]=+h[b+20976>>3];i=i;return}function D8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21088>>3]=+h[b+20984>>3];i=i;return}function E8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21096>>3]=+h[b+20992>>3];i=i;return}function F8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21104>>3]=+h[b+21e3>>3];i=i;return}function G8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21112>>3]=+h[b+21008>>3];i=i;return}function H8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5808>>3]=+h[b+5544>>3];i=i;return}function I8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5816>>3]=+h[b+5552>>3];i=i;return}function J8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5824>>3]=+h[b+5560>>3];i=i;return}function K8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5832>>3]=+h[b+5568>>3];i=i;return}function L8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5840>>3]=+h[b+5576>>3];i=i;return}function M8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5848>>3]=+h[b+5584>>3];i=i;return}function N8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5856>>3]=+h[b+5592>>3];i=i;return}function O8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5864>>3]=+h[b+5600>>3];i=i;return}function P8a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5872>>3]=+h[b+5608>>3];i=i;return}



function GNb(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==5){P=q+4|0;Q=(c[P>>2]|0)+(c[q>>2]|0)|0;R=Q+1|0;c[61790]=R;S=c[b>>2]|0;c[61780]=(Q|0)<(S|0)?R:S;S=c[q>>2]|0;c[61798]=R+S;c[61784]=S+Q;Q=(c[b>>2]|0)/(R|0)|0;c[61794]=Q+1;R=c[x>>2]|0;c[61792]=R+ -1;c[61802]=R+Q;c[s>>2]=0;h[30894]=+V(+(+h[t>>3]));Q=c[61780]|0;c[61766]=1;if((Q|0)<1){T=75;break}R=r;S=1;while(1){U=c[b>>2]|0;W=c[61790]|0;c[61772]=S;X=(W|0)<0;b:do{if(X?(S|0)>=(U|0):(S|0)<=(U|0)){Y=W;Z=S;_=S;while(1){$=(_-Z|0)/(Y|0)|0;c[61768]=$+1;aa=_+ -1|0;ba=e+(aa<<3)|0;h[p+((c[61792]|0)+$<<3)>>3]=+h[ba>>3];ca=f+(aa<<3)|0;h[p+((c[61802]|0)+$<<3)>>3]=+h[ca>>3];da=+h[ba>>3];h[N>>3]=da;if(!(da>=0.0)){ea=-da}else{ea=da}da=+h[l>>3]*+h[ca>>3];if(!(da>=0.0)){ga=-da}else{ga=da}da=ea>=ga?ea:ga;ha=+h[n+(aa<<3)>>3];if(!(ha>=0.0)){ia=-ha}else{ia=ha}h[30891]=+h[30894]*(da>=ia?da:ia);h[N>>3]=+h[l>>3]*+h[ca>>3];da=+I1b(247128,N);h[30891]=da;ca=c[61772]|0;aa=ca+ -1|0;ba=e+(aa<<3)|0;ha=+h[ba>>3];ja=da+ha-ha;h[30891]=ja;h[ba>>3]=+h[ba>>3]+ja;ba=f+(aa<<3)|0;h[ba>>3]=+h[j>>3]*+h[30891]+ +h[ba>>3];ba=ca+W|0;c[61772]=ba;if(!(X?(ba|0)>=(U|0):(ba|0)<=(U|0))){break b}Y=c[61790]|0;Z=c[61766]|0;_=ba}}}while(0);$d[R&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}U=c[b>>2]|0;X=c[61790]|0;W=c[61766]|0;c[61772]=W;_=(X|0)<0;c:do{if(_?(W|0)>=(U|0):(W|0)<=(U|0)){Z=X;Y=W;ba=W;while(1){ca=(ba-Y|0)/(Z|0)|0;c[61768]=ca+1;aa=ba+ -1|0;$=e+(aa<<3)|0;h[$>>3]=+h[p+((c[61792]|0)+ca<<3)>>3];ja=+h[p+((c[61802]|0)+ca<<3)>>3];ca=f+(aa<<3)|0;h[ca>>3]=ja;ha=+h[$>>3];h[N>>3]=ha;if(!(ha>=0.0)){ka=-ha}else{ka=ha}ha=+h[l>>3]*ja;if(!(ha>=0.0)){la=-ha}else{la=ha}ha=ka>=la?ka:la;ja=+h[n+(aa<<3)>>3];if(!(ja>=0.0)){ma=-ja}else{ma=ja}h[30891]=+h[30894]*(ha>=ma?ha:ma);h[N>>3]=+h[l>>3]*+h[ca>>3];ha=+I1b(247128,N);h[30891]=ha;ca=c[61772]|0;ja=+h[e+(ca+ -1<<3)>>3];da=ha+ja-ja;h[30891]=da;ja=1.0/da;h[30900]=ja;aa=ca-(c[P>>2]|0)|0;$=(aa|0)>1?aa:1;c[61774]=$;aa=c[b>>2]|0;na=(c[q>>2]|0)+ca|0;oa=(aa|0)<=(na|0)?aa:na;c[61776]=oa;pa=fa(c[61784]|0,ca)|0;qa=pa-(c[q>>2]|0)|0;c[61778]=qa;c[61764]=$;if(($|0)<=(oa|0)){pa=~aa;aa=~na;na=~((pa|0)>(aa|0)?pa:aa);aa=($|0)>(na|0)?$:na;da=ja;na=$;while(1){$=na+ -1|0;h[p+($+qa<<3)>>3]=(+h[o+($<<3)>>3]- +h[g+($<<3)>>3])*da;if((na|0)>=(oa|0)){break}da=+h[30900];na=na+1|0}c[61764]=aa+1}na=ca+X|0;c[61772]=na;oa=c[61766]|0;if(!(_?(na|0)>=(U|0):(na|0)<=(U|0))){ra=oa;break c}Z=c[61790]|0;Y=oa;ba=na}}else{ra=W}}while(0);W=ra+1|0;c[61766]=W;if((ra|0)<(Q|0)){S=W}else{T=75;break a}}i=y;return 0}else if((O|0)==3){i=y;return 0}else if((O|0)==4){S=c[q>>2]|0;Q=q+4|0;P=c[Q>>2]|0;R=c[b>>2]|0;W=fa(P+1+(S<<1)|0,R)|0;c[61764]=1;if((W|0)>=1){U=fa(R,P+(S<<1)+1|0)|0;S=(U|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(W|0)){P=P+1|0}else{break}}c[61764]=S?2:U+1|0}fe[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[61798]=(c[Q>>2]|0)+1+(c[q>>2]<<1);T=75}else if((O|0)==2){c[s>>2]=0;c[61786]=0;h[30894]=+V(+(+h[t>>3]));P=c[b>>2]|0;c[61764]=1;d:do{if((P|0)>=1){W=r;R=1;while(1){_=R+ -1|0;da=+h[e+(_<<3)>>3];h[N>>3]=da;if(!(da>=0.0)){sa=-da}else{sa=da}X=f+(_<<3)|0;da=+h[l>>3]*+h[X>>3];if(!(da>=0.0)){ta=-da}else{ta=da}da=sa>=ta?sa:ta;ja=+h[n+(_<<3)>>3];if(!(ja>=0.0)){ua=-ja}else{ua=ja}h[30891]=+h[30894]*(da>=ua?da:ua);h[N>>3]=+h[l>>3]*+h[X>>3];da=+I1b(247128,N);h[30891]=da;X=(c[61764]|0)+ -1|0;_=e+(X<<3)|0;ja=+h[_>>3];ha=da+ja-ja;h[30891]=ha;h[30898]=+h[_>>3];ba=f+(X<<3)|0;h[30902]=+h[ba>>3];h[_>>3]=ha+ +h[_>>3];h[ba>>3]=+h[j>>3]*+h[30891]+ +h[ba>>3];$d[W&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ha=1.0/+h[30891];h[30900]=ha;ba=c[b>>2]|0;c[61770]=1;_=c[61786]|0;if((ba|0)>=1){ja=ha;X=1;Y=0;while(1){h[p+(Y+_<<3)>>3]=(+h[o+(Y<<3)>>3]- +h[g+(Y<<3)>>3])*ja;if((X|0)>=(ba|0)){break}Z=X;ja=+h[30900];X=X+1|0;Y=Z}c[61770]=ba+1}c[61786]=_+(c[b>>2]|0);Y=c[61764]|0;X=Y+ -1|0;h[e+(X<<3)>>3]=+h[30898];h[f+(X<<3)>>3]=+h[30902];R=Y+1|0;c[61764]=R;if((Y|0)>=(P|0)){break d}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){T=42;break}c[61786]=0;P=c[b>>2]|0;if((c[233616>>2]|0)==0){T=42;break}Q=aec(P*20|0)|0;U=F;h[k>>3]=+h[d>>3];c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];VLb(14,1,247224,F);U=E;h[k>>3]=+h[j>>3];c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];VLb(14,0,247248,E);VLb(14,1,247256,D);c[61768]=0;if((c[b>>2]|0)>0){U=0;do{ja=+h[e+(U<<3)>>3];c[C>>2]=U+1;S=C+4|0;h[k>>3]=ja;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];VLb(14,0,247264,C);U=(c[61768]|0)+1|0;c[61768]=U;}while((U|0)<(c[b>>2]|0))}de[c[58528]&511](14);VLb(14,1,247320,B);c[61764]=1;if((P|0)>=1){U=Q+1|0;S=c[61786]|0;R=1;do{W=p+(R+ -1+S<<3)|0;h[W>>3]=+h[j>>3]+ +h[W>>3];a[Q]=0;a[U]=0;c[61770]=1;W=S;Y=0;while(1){ja=+h[p+(Y+W<<3)>>3];c[A>>2]=Q;X=A+4|0;h[k>>3]=ja;c[X>>2]=c[k>>2];c[X+4>>2]=c[k+4>>2];fc(Q|0,247304,A|0)|0;X=c[61770]|0;c[61770]=X+1;if((X|0)>=(P|0)){break}W=c[61786]|0;Y=X}c[z>>2]=Q;VLb(14,0,247312,z);Y=c[61786]|0;W=c[61764]|0;X=p+(Y+ -1+W<<3)|0;h[X>>3]=+h[X>>3]- +h[j>>3];S=Y+(c[b>>2]|0)|0;c[61786]=S;R=W+1|0;c[61764]=R;}while((W|0)<(P|0))}de[c[58528]&511](14);de[c[58528]&511](14);bec(Q);T=42}else{P=c[b>>2]|0;R=fa(P,P)|0;c[61764]=1;if((R|0)!=0){P=(R|0)<1;S=1;while(1){h[p+(S+ -1<<3)>>3]=0.0;if((S|0)<(R|0)){S=S+1|0}else{break}}c[61764]=P?2:R+1|0}fe[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){T=42;break}c[61786]=0;S=c[b>>2]|0;if((c[233616>>2]|0)==0){T=42;break}Q=aec(S*20|0)|0;U=M;h[k>>3]=+h[d>>3];c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];VLb(14,1,247224,M);U=L;h[k>>3]=+h[j>>3];c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];VLb(14,0,247248,L);VLb(14,1,247256,K);c[61768]=0;if((c[b>>2]|0)>0){U=0;do{ja=+h[e+(U<<3)>>3];c[J>>2]=U+1;W=J+4|0;h[k>>3]=ja;c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];VLb(14,0,247264,J);U=(c[61768]|0)+1|0;c[61768]=U;}while((U|0)<(c[b>>2]|0))}de[c[58528]&511](14);VLb(14,1,247280,I);c[61764]=1;if((S|0)>=1){U=Q+1|0;R=c[61786]|0;P=1;do{W=p+(P+ -1+R<<3)|0;h[W>>3]=+h[j>>3]+ +h[W>>3];a[Q]=0;a[U]=0;c[61770]=1;W=R;Y=0;while(1){ja=+h[p+(Y+W<<3)>>3];c[H>>2]=Q;X=H+4|0;h[k>>3]=ja;c[X>>2]=c[k>>2];c[X+4>>2]=c[k+4>>2];fc(Q|0,247304,H|0)|0;X=c[61770]|0;c[61770]=X+1;if((X|0)>=(S|0)){break}W=c[61786]|0;Y=X}c[G>>2]=Q;VLb(14,0,247312,G);Y=c[61786]|0;W=c[61764]|0;X=p+(Y+ -1+W<<3)|0;h[X>>3]=+h[X>>3]- +h[j>>3];R=Y+(c[b>>2]|0)|0;c[61786]=R;P=W+1|0;c[61764]=P;}while((W|0)<(S|0))}de[c[58528]&511](14);de[c[58528]&511](14);bec(Q);T=42}}while(0);if((T|0)==42){ONb(p,b,b,q+80|0,m)|0;i=y;return 0}else if((T|0)==75){UNb(p,247192,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function HNb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[e+12>>2]|0;if((g|0)==3){i=f;return 0}else if((g|0)==4|(g|0)==5){g=e+4|0;c[61836]=(c[g>>2]|0)+1+(c[e>>2]<<1);VNb(d,247344,a,e,g,e+80|0,b,247352)|0;i=f;return 0}else{SNb(d,a,a,e+80|0,b,247352)|0;i=f;return 0}return 0}function INb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[247360]&1)){a[247360]=1;JNb(247408,247376,247456,247392,247440,247464,247448,247472)|0;h[30925]=+(c[61852]|0);f=c[61844]|0;h[30921]=+(f|0);if((c[61864]|0)==0){h[30923]=0.0;c[e>>2]=1-f;g=+H1b(247400,e)}else{h[30923]=1.0;c[e>>2]=1-f;g=+H1b(247400,e)*.5}h[30924]=g;h[30928]=g*+h[30925];h[30927]=+(c[61860]|0);h[30929]=+(c[61862]|0);j=+h[30933];h[30936]=j;k=1.0/+h[30934];if(!(k>=j)){break}h[30936]=k*(g+1.0)}}while(0);if((XNb(b,247496,1,1)|0)!=0){g=+h[30924];h[30935]=g;l=g;i=d;return+l}if((XNb(b,247504,1,1)|0)!=0){g=+h[30936];h[30935]=g;l=g;i=d;return+l}if((XNb(b,247512,1,1)|0)!=0){g=+h[30925];h[30935]=g;l=g;i=d;return+l}if((XNb(b,247520,1,1)|0)!=0){g=+h[30928];h[30935]=g;l=g;i=d;return+l}if((XNb(b,247528,1,1)|0)!=0){g=+h[30921];h[30935]=g;l=g;i=d;return+l}if((XNb(b,247536,1,1)|0)!=0){g=+h[30923];h[30935]=g;l=g;i=d;return+l}if((XNb(b,247544,1,1)|0)!=0){g=+h[30927];h[30935]=g;l=g;i=d;return+l}if((XNb(b,247552,1,1)|0)!=0){g=+h[30933];h[30935]=g;l=g;i=d;return+l}if((XNb(b,247560,1,1)|0)!=0){g=+h[30929];h[30935]=g;l=g;i=d;return+l}if((XNb(b,247568,1,1)|0)==0){l=+h[30935];i=d;return+l}else{g=+h[30934];h[30935]=g;l=g;i=d;return+l}return 0.0}function JNb(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[247680]&1){q=248048;r=c[62012]|0;c[b>>2]=r;s=247984;t=c[61996]|0;c[d>>2]=t;u=248024;v=c[62006]|0;c[e>>2]=v;w=248032;x=+h[31004];h[f>>3]=x;y=248064;z=c[62016]|0;c[g>>2]=z;A=248112;B=+h[31014];h[j>>3]=B;C=248072;D=c[62018]|0;c[k>>2]=D;E=248120;F=+h[31015];h[l>>3]=F;i=m;return 0}a[247680]=1;h[31005]=0.0;h[30999]=1.0;h[31e3]=2.0;KNb(248048,247984,248024,248136)|0;h[30995]=+(c[62012]|0);c[n>>2]=0-(c[61996]|0);G=+H1b(247960,n);h[30994]=G;h[31004]=G;H=+h[31e3];h[30995]=H/3.0;I=+h[30999];J=I*.5;h[31002]=J;K=-J;h[o>>3]=K;h[31016]=+LNb(247960,o);L=248128;h[31013]=+LNb(L,L);h[o>>3]=K;h[30995]=+LNb(248104,o);K=+LNb(247960,248128);h[30995]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[30995]=K;h[31004]=1.0;M=+h[31005];if(K<1.0&K>M){N=K;while(1){h[31004]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+LNb(o,p);h[30996]=K;h[o>>3]=-K;h[30996]=+LNb(248016,o);K=+LNb(248016,247968);h[30995]=K;h[o>>3]=-K;h[30996]=+LNb(248016,o);K=+LNb(248016,247968);h[30995]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[31004]=G}G=I/+(c[62012]|0);h[31007]=G;h[31011]=I;c[61994]=1;p=1;O=I;do{h[o>>3]=O*G;O=+LNb(o,248040);h[31011]=O;p=p+1|0;c[61994]=p;}while((p|0)<4);h[30994]=+LNb(247992,248088);MNb(248152,247992,248048)|0;h[o>>3]=-+h[30999];MNb(248144,o,248048)|0;MNb(248096,247952,248048)|0;h[o>>3]=-+h[30994];MNb(248080,o,248048)|0;c[62002]=0;p=c[62038]|0;L=c[62036]|0;P=c[62024]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[62020]|0)){if(Q){c[62016]=p;R=0;S=25;break}if((P-p|0)==3){c[62016]=p+ -1+(c[61996]|0);c[62002]=1;R=1;S=25;break}else{c[62016]=(p|0)<=(P|0)?p:P;a[247688]=1;S=26;break}}else{T=Q&(L|0)==(c[62020]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[62016]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[62016]=(p|0)<=(L|0)?p:L;a[247688]=1;S=26;break}}T=c[62020]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[62016]=(V|0)<=(T|0)?V:T;a[247688]=1;S=26;break}if((P-U|0)==3){c[62016]=((p|0)>=(L|0)?p:L)+ -1+(c[61996]|0);R=0;S=25;break}else{c[62016]=U;a[247688]=1;S=26;break}}}while(0);if((S|0)==25){if(a[247688]&1){S=26}else{W=R}}if((S|0)==26){a[247680]=0;F2b(248160)|0;W1b(248184,248064,4)|0;n2b()|0;W=c[62002]|0}if((W|0)==0){X=(c[62034]|0)!=0|0}else{X=1}c[62002]=X;h[31014]=1.0;X=c[62016]|0;W=1-X|0;c[n>>2]=W;c[61994]=1;if((X|0)<=0){O=+h[31007];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+LNb(o,248040);h[31014]=I;n=X+1|0;c[61994]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}NNb(248048,247984,248064,248008,248072,248120)|0;q=248048;r=c[62012]|0;c[b>>2]=r;s=247984;t=c[61996]|0;c[d>>2]=t;u=248024;v=c[62006]|0;c[e>>2]=v;w=248032;x=+h[31004];h[f>>3]=x;y=248064;z=c[62016]|0;c[g>>2]=z;A=248112;B=+h[31014];h[j>>3]=B;C=248072;D=c[62018]|0;c[k>>2]=D;E=248120;F=+h[31015];h[l>>3]=F;i=m;return 0}function KNb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[247576]&1){l=a[247648]&1;m=c[61914]|0;c[b>>2]=m;n=247624;o=c[61906]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=247672;r=c[61918]|0;c[f>>2]=r;i=g;return 0}a[247576]=1;h[30954]=1.0;h[30948]=1.0;h[30950]=1.0;s=1.0;do{s=s*2.0;h[30948]=s;h[30950]=+LNb(247584,247632);h[j>>3]=-s;t=+LNb(247600,j);h[30950]=t;}while(t==1.0);h[30949]=1.0;t=+LNb(247584,247592);h[30950]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[30949]=v;w=+LNb(247584,247592);h[30950]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[30955]=.25;h[30958]=x;h[j>>3]=-s;t=+LNb(247600,j);h[30950]=t;y=~~(t+.25);c[61914]=y;t=+(y|0);h[30949]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[30951]=+LNb(j,k);w=+LNb(247608,247584);h[30950]=w;z=w==s;a[247648]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[30951]=+LNb(j,k);w=+LNb(247608,247584);h[30950]=w;if(z&w==s){a[247648]=0;A=0}else{A=z}h[j>>3]=u;w=+LNb(j,247584);h[30952]=w;h[j>>3]=u;z=w==s&+LNb(j,247664)>x;c[61918]=z?A&1:0;c[61906]=0;h[30948]=1.0;h[30950]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[61906]=k;s=x*t;h[30948]=s;h[30950]=+LNb(247584,247632);h[j>>3]=-s;w=+LNb(247600,j);h[30950]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=247624;o=c[61906]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=247672;r=c[61918]|0;c[f>>2]=r;i=g;return 0}function LNb(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function MNb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[31024]=g;j=1.0/+(c[d>>2]|0);h[31033]=j;h[31032]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+LNb(f,248256);h[31026]=k;h[31028]=g;h[31029]=g;h[31030]=g;h[31031]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[31024]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+LNb(f,248256);h[31026]=g;h[f>>3]=g*k;k=+LNb(f,248256);h[31028]=k;h[31030]=0.0;c[62050]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[31030]=q;c[62050]=b+1;n=q}h[f>>3]=m*j;p=+LNb(f,248256);h[31027]=p;h[f>>3]=p/j;r=+LNb(f,248256);h[31029]=r;h[31031]=0.0;o=c[d>>2]|0;c[62050]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[31031]=v;c[62050]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function NNb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[62074]=1;c[62082]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[62074]=q;r=l+1|0;c[62082]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[62078]=n;u=n}else{c[62078]=m;c[62082]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[62084]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[62082]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[31040]=x;y=w+-1.0;h[31036]=y;h[31035]=0.0;v=c[b>>2]|0;c[62068]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[31036]=B;if(w<1.0){h[31038]=w}C=+LNb(248280,248288);h[31035]=C;e=b+1|0;c[62068]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[31038];h[31035]=A;z=A}}while(0);v=c[f>>2]|0;c[62068]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+LNb(k,248344);h[31035]=z;f=E+1|0;c[62068]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function ONb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[62090]=1;m=1;do{c[62096]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=PNb(j,a+(m+b+(fa(m,l)|0)<<3)|0,248392)|0;q=c[62090]|0;r=p+ -1+q|0;c[62092]=r;c[e+(q+ -1<<2)>>2]=r;r=c[62092]|0;q=c[62090]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[31047]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[31047];t=q}u=fa(t,l)|0;h[31047]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;QNb(j,248376,a+(t-l+u<<3)|0,248392)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[62096]|0;c[62088]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[62092]|0;x=fa(w,l)|0;h[31047]=+h[a+(x+b+v<<3)>>3];y=c[62090]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[31047];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=248392;RNb(k,248376,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[62088]|0;w=A+1|0;c[62088]=w;}while((A|0)<(u|0))}}while(0);q=c[62090]|0;m=q+1|0;c[62090]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function PNb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[62188]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[31095]=k;l=(c[d>>2]|0)+1|0;c[62188]=l;m=c[a>>2]|0;c[62186]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[31095]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[62188]=l;a=n+1|0;c[62186]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[31095]=v;c[62186]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[31095]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[62186]=f+1;g=C;i=e;return g|0}function QNb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[62172]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[62172]=l;i=f;return 0}l=(g|0)%5|0;c[62174]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[62172]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[62172]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[62172]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[62172]=o;i=f;return 0}function RNb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[62158]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[62156]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[62156]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[62156]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[62156]=s;i=j;return 0}}while(0);c[62160]=1;c[62162]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[62160]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[62162]=s;u=s}else{u=1}s=c[a>>2]|0;c[62156]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[62160]=t;u=x+(c[g>>2]|0)|0;c[62162]=u;a=w+1|0;c[62156]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function SNb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[62108]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[62100]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[62102]=o;p=f+(o+ -1<<3)|0;h[31052]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[31052]}c[k>>2]=(c[d>>2]|0)-m;o=248392;RNb(k,248416,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[62100]|0;m=o+1|0;c[62100]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[62106]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[62100]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[31052]=-s;c[k>>2]=g;g=248392;RNb(k,248416,a+(p-l<<3)|0,g,f,g)|0;g=c[62106]|0;q=g+1|0;c[62106]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[62100]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=248392;s=+TNb(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[31052]=s;q=c[62100]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[62100]=n;}while((q|0)<(m|0));t=c[62108]|0}if((t|0)<1){i=j;return 0}c[62106]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[62100]=n;c[k>>2]=(c[d>>2]|0)-n;b=248392;s=+TNb(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[62100]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[62102]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[31052]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[31052]}q=c[62106]|0;m=q+1|0;c[62106]=m;}while((q|0)<(t|0));i=j;return 0}function TNb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[31092]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[62178]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[62176]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[31092]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[62176]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[62176]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[31092]=t;u=u+5|0;}while((u|0)<=(m|0));c[62176]=u;k=t;i=g;return+k}}while(0);c[62180]=1;c[62182]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[62180]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[62182]=u;y=u}else{y=1}u=c[a>>2]|0;c[62176]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[31092]=t;x=C+(c[d>>2]|0)|0;c[62180]=x;y=B+(c[f>>2]|0)|0;c[62182]=y;a=z+1|0;c[62176]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function UNb(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[62118]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[62124]=n;o=c[d>>2]|0;p=c[62118]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[62126]=o;do{if((q|0)>(n|0)){c[62134]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[62122]=s;t=c[e>>2]|0;c[62110]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[62110]=t+1}u=r+1|0;c[62134]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[62134]=o;c[62132]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[62114]=1;t=o;o=1;while(1){c[62136]=o+1;p=t+1|0;c[62134]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[62110]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[62110]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[62128]=s;c[l>>2]=s+1;s=PNb(l,a+((c[62118]|0)+b+(fa(o,m)|0)<<3)|0,248392)|0;p=s+ -1|0;c[62116]=p+(c[62118]|0);s=c[62114]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[62116]|0;p=c[62114]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[62118]|0;if((s|0)==(u|0)){y=s}else{h[31060]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[31060];y=u}h[31060]=-1.0/+h[a+(y+b+n<<3)>>3];QNb(248512,248480,a+(y-m+n<<3)|0,248392)|0;u=c[62132]|0;z=(c[g+((c[62114]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[62132]=u;A=c[62118]|0;c[62130]=A;z=c[62136]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[62112]=z;B=z;z=A;while(1){A=(c[62116]|0)+ -1|0;c[62116]=A;C=z+ -1|0;c[62130]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[31060]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[31060];F=C}C=248392;RNb(248512,248480,a+((c[62118]|0)-m+(fa(c[62114]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[62112]|0;D=C+1|0;c[62112]=D;if((C|0)>=(u|0)){break a}B=D;z=c[62130]|0}}}while(0);n=c[62114]|0;s=n+1|0;c[62114]=s;if((n|0)>=(r|0)){break}t=c[62134]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[62118]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function VNb(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[62142]=n;f=c[d>>2]|0;o=f+ -1|0;c[62154]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[62138]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[62152]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[62140]=k;q=j+(k+ -1<<3)|0;h[31072]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[31072]}k=248392;RNb(248608,248576,a+((c[62142]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[62138]|0;f=k+1|0;c[62138]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[62146]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[62138]=k;q=c[62142]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[62152]=s;u=q-s|0;c[62148]=u;q=k-s|0;c[62150]=q;h[31072]=-t;s=248392;RNb(248608,248576,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[62146]|0;r=s+1|0;c[62146]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[62138]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[62152]=r;s=o-r|0;c[62148]=s;q=n-r|0;c[62150]=q;r=248392;t=+TNb(248608,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[31072]=t;r=c[62138]|0;q=j+(r+ -1<<3)|0;o=c[62142]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[62138]=n;}while((r|0)<(f|0));v=o;w=c[62154]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[62146]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[62138]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[62152]=(n|0)<=(b|0)?n:b;b=248392;t=+TNb(248608,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[62138]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[62140]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[31072]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[31072]}n=c[62146]|0;b=n+1|0;c[62146]=b;if((n|0)>=(w|0)){break}o=c[62142]|0;v=b}i=l;return 0}function WNb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[62166]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[62164]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[62164]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[62164]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[62164]=o;i=g;return 0}}while(0);c[62168]=1;c[62170]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[62168]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[62170]=o;q=o}else{q=1}o=c[a>>2]|0;c[62164]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[62168]=p;q=s+(c[f>>2]|0)|0;c[62170]=q;a=r+1|0;c[62164]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function XNb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[248784]=1;f=d[b]|0;c[62192]=f;b=d[e]|0;c[62194]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[62192]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[62194]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}function YNb(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[258316>>2]=6;F2b(258312)|0;W1b(259056,j,4)|0;n2b()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[63880]=0;c[64486]=0;c[64474]=0;a[257920]=0;t=c[e>>2]|0;c[63434]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[63880]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[63434]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[63434]=1;if((v|0)>=1){x=1;while(1){h[250208+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[63434]=v+1}c[64478]=2;x=c[e>>2]|0;c[63434]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[63436]=1;if((E|0)<1){F=C}else{G=1;while(1){h[250208+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[63436]=E+1;F=+h[B>>3]}h[250208+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[64478]=G;D=G}G=z+1|0;c[63434]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[63880]|0;y=z+1|0;c[63876]=y;c[63434]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[63436]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[250208+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[63436]=x+1}le[u&63](e,b,253568+(z+ -1<<3)|0)|0;c[64486]=(c[64486]|0)+1;if((c[j>>2]|0)>=1){c[258340>>2]=6;F2b(258336)|0;W1b(259056,257944,4)|0;W1b(259056,253568+((c[63434]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[63436]=1;if((v|0)>=1){A=1;do{W1b(259056,b+(A+ -1<<3)|0,8)|0;B=c[63436]|0;A=B+1|0;c[63436]=A;}while((B|0)<(v|0))}n2b()|0}v=c[63434]|0;z=v+1|0;c[63434]=z;}while((v|0)<(y|0))}y=c[64474]|0;b:while(1){c[64474]=y+1;c[64386]=1;c[64382]=1;C=+h[31696];h[32192]=C;h[32194]=C;z=c[63876]|0;c[63434]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[253568+(A+ -1<<3)>>3];do{if(!(C<=K)){c[64386]=A;L=+h[253568+(A+ -1<<3)>>3];h[32192]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[64382]=A;L=+h[253568+(A+ -1<<3)>>3];h[32194]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[63434]=z+1;H=O}A=c[e>>2]|0;c[63434]=1;if((A|0)>=1){v=1;while(1){h[255688+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[63434]=A+1}c[63434]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[63436]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=255688+(Q+ -1<<3)|0;h[B>>3]=+h[250208+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[63436]=x+1;P=v}}while(0);v=P+1|0;c[63434]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[63436]=1;if((z|0)>=1){K=+(c[63880]|0);v=1;while(1){A=255688+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[63436]=z+1}v=c[e>>2]|0;c[63434]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[255688+(B<<3)>>3];h[257968+(B<<3)>>3]=K+(K- +h[250208+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[63434]=v+1}le[u&63](e,257968,257960)|0;A=(c[64486]|0)+1|0;c[64486]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[258364>>2]=6;F2b(258360)|0;W1b(259056,257944,4)|0;W1b(259056,257960,8)|0;B=c[e>>2]|0;c[63436]=1;if((B|0)>=1){E=1;do{W1b(259056,257968+(E+ -1<<3)|0,8)|0;G=c[63436]|0;E=G+1|0;c[63436]=E;}while((G|0)<(B|0))}n2b()|0}}while(0);K=+h[32245];c:do{if(!(K>=+h[32194])){z=c[e>>2]|0;c[63434]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[255688+(v<<3)>>3];h[258136+(v<<3)>>3]=I+(+h[257968+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[63434]=z+1}le[u&63](e,258136,258128)|0;A=(c[64486]|0)+1|0;c[64486]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[258388>>2]=6;F2b(258384)|0;W1b(259056,257944,4)|0;W1b(259056,258128,8)|0;B=c[e>>2]|0;c[63436]=1;if((B|0)>=1){E=1;do{W1b(259056,258136+(E+ -1<<3)|0,8)|0;G=c[63436]|0;E=G+1|0;c[63436]=E;}while((G|0)<(B|0))}n2b()|0}}while(0);I=+h[32266];if(I>=+h[32194]){R=118;break}v=c[e>>2]|0;c[63434]=1;A=c[64386]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[250208+((z*21|0)+ -22+A<<3)>>3]=+h[258136+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[63434]=v+1}h[253568+(A+ -1<<3)>>3]=I}else{z=c[63876]|0;c[63434]=1;if((z|0)>=1){B=c[64386]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[253568+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[63434]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[32192])){E=c[e>>2]|0;c[63434]=1;z=c[64386]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[250208+((B*21|0)+ -22+z<<3)>>3]=+h[257968+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[63434]=E+1}h[32192]=K;h[253568+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[63434]=1;if((B|0)>=1){A=c[64386]|0;v=1;while(1){x=v+ -1|0;h[258136+(x<<3)>>3]=+h[250208+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[255688+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[63434]=B+1}le[u&63](e,258136,258128)|0;v=(c[64486]|0)+1|0;c[64486]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[258412>>2]=6;F2b(258408)|0;W1b(259056,257944,4)|0;W1b(259056,258128,8)|0;z=c[e>>2]|0;c[63436]=1;if((z|0)>=1){E=1;do{W1b(259056,258136+(E+ -1<<3)|0,8)|0;x=c[63436]|0;E=x+1|0;c[63436]=E;}while((x|0)<(z|0))}n2b()|0}}while(0);I=+h[32266];if(!(I>+h[32192])){A=c[e>>2]|0;c[63434]=1;v=c[64386]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[250208+((B*21|0)+ -22+v<<3)>>3]=+h[258136+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[63434]=A+1}h[253568+(v+ -1<<3)>>3]=I;break}B=c[63876]|0;c[63434]=1;if((B|0)<1){break}else{S=1}do{z=c[64382]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[63436]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=250208+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[250208+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[250208+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[63436]=E+1}le[u&63](e,b,253568+(S+ -1<<3)|0)|0;G=(c[64486]|0)+1|0;c[64486]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[258436>>2]=6;F2b(258432)|0;W1b(259056,257944,4)|0;W1b(259056,253568+((c[63434]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[63436]=1;if((x|0)>=1){G=1;do{W1b(259056,b+(G+ -1<<3)|0,8)|0;T=c[63436]|0;G=T+1|0;c[63436]=G;}while((T|0)<(x|0))}n2b()|0}}while(0);z=c[63434]|0;S=z+1|0;c[63434]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[63434]=1;v=c[64386]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[250208+((A*21|0)+ -22+v<<3)>>3]=+h[257968+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[63434]=B+1}h[253568+(v+ -1<<3)>>3]=+h[32245]}A=c[64474]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[32195]=0.0;h[32241]=0.0;A=c[63876]|0;c[63434]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[32241]=0.0/K;c[63434]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[253568+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[32241]=I;c[63434]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[253568+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[32195]=$;c[63434]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[32195]=I;do{if(!(I<=+h[k>>3])){if((c[64486]|0)>(c[g>>2]|0)){break}a[257920]=0;c[64474]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[63434]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[63436]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[250208+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[63436]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[63434]=v+1}le[u&63](e,b,f)|0;B=(c[64486]|0)+1|0;c[64486]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[258460>>2]=6;F2b(258456)|0;W1b(259056,257944,4)|0;W1b(259056,s,8)|0;z=c[e>>2]|0;c[63436]=1;if((z|0)>=1){E=1;do{W1b(259056,b+(E+ -1<<3)|0,8)|0;x=c[63436]|0;E=x+1|0;c[63436]=E;}while((x|0)<(z|0))}n2b()|0;ba=c[64486]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[258580>>2]=6;F2b(258576)|0;n2b()|0;c[258604>>2]=6;F2b(258600)|0;B=c[e>>2]|0;c[63434]=1;if((B|0)>=1){A=1;do{W1b(259056,b+(A+ -1<<3)|0,8)|0;v=c[63434]|0;A=v+1|0;c[63434]=A;}while((v|0)<(B|0))}n2b()|0;c[258628>>2]=6;F2b(258624)|0;W1b(259056,s,8)|0;n2b()|0}if(a[257920]&1){I=+h[32241];K=+h[32287]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[257920]=1;da=+h[32241]}h[32287]=da;c[64474]=0;y=0}if((c[j>>2]|0)>=0){c[258652>>2]=6;F2b(258648)|0;W1b(259056,257944,4)|0;n2b()|0;c[258676>>2]=6;F2b(258672)|0;y=c[e>>2]|0;c[63434]=1;if((y|0)>=1){B=1;do{W1b(259056,b+(B+ -1<<3)|0,8)|0;A=c[63434]|0;B=A+1|0;c[63434]=B;}while((A|0)<(y|0))}n2b()|0;c[258700>>2]=6;F2b(258696)|0;W1b(259056,s,8)|0;n2b()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[258724>>2]=6;F2b(258720)|0;n2b()|0}h[32194]=+h[f>>3];c[64488]=0;y=c[63876]|0;c[63434]=1;if((y|0)>=1){B=1;while(1){A=253568+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[63434]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[63436]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=250208+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[258136+(E+ -1<<3)>>3]=+h[250208+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[63436]=v+1}le[u&63](e,258136,A)|0;c[64488]=(c[64488]|0)+1;c[64486]=(c[64486]|0)+1;E=c[63434]|0;I=+h[253568+(E+ -1<<3)>>3];if(I>=+h[32194]){B=E;continue}h[32194]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[258748>>2]=6;F2b(258744)|0;W1b(259056,257944,4)|0;W1b(259056,257552,8)|0;E=c[e>>2]|0;c[63436]=1;if((E|0)>=1){z=1;do{W1b(259056,258136+(z+ -1<<3)|0,8)|0;G=c[63436]|0;z=G+1|0;c[63436]=z;}while((G|0)<(E|0))}n2b()|0;B=c[63434]|0}}B=c[63880]|0;c[63434]=1;do{if((B|0)<1){h[31721]=+h[31696];c[63434]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[63444]=E;z=c[e>>2]|0;c[63436]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[257968+(A+ -1<<3)>>3]=(+h[250208+(v+ -21<<3)>>3]+ +h[250208+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[63436]=z+1}le[u&63](e,257968,255528+(y+ -1<<3)|0)|0;c[64488]=(c[64488]|0)+1;c[64486]=(c[64486]|0)+1;A=c[63434]|0;y=A+1|0;c[63434]=y;}while((A|0)<(B|0));y=c[63880]|0;I=+h[31696];h[31721]=I;c[63434]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[63444]=A;c[63446]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[63436]=1;E=1;while(1){v=E+1|0;c[63448]=v;G=c[e>>2]|0;c[63438]=1;if((G|0)>=1){x=c[63446]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[258136+(T+ -1<<3)>>3]=(+h[250208+(U+x<<3)>>3]+ +h[250208+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[63438]=G+1}le[u&63](e,258136,258128)|0;c[64488]=(c[64488]|0)+1;c[64486]=(c[64486]|0)+1;T=c[63434]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[63436]|0;la=U+x|0;c[63440]=la;I=+h[31721];h[255848+(la+ -1<<3)>>3]=(+h[32266]+I- +h[255528+(v<<3)>>3]- +h[255528+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[63436]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[63434]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[63880]|0;c[63440]=0;c[63434]=1;E=(y|0)<1;if(E){c[63434]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=Xec(A|0,0,y+ -2|0,0)|0;A=Qec(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[255848+(U+ -1<<3)>>3]=(+h[253568+(v<<3)>>3]+ka- +h[255528+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[63444]=v+1;c[63440]=(z|1)+A;c[63434]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=255528+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[253568+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[63444]=T+1;c[63434]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[63440]=0;c[63434]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[63434]=1;if((B|0)>=1){A=1;while(1){h[257568+(A+ -1<<3)>>3]=+h[250208+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[63434]=B+1}c[63434]=1;do{if(ma){c[63434]=1}else{A=1;while(1){z=A+1|0;c[63444]=z;v=c[e>>2]|0;c[63436]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=250208+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[250208+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[63436]=v+1}c[63434]=z;if((A|0)<(na|0)){A=z}else{break}}c[63434]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[63444]=A;y=c[e>>2]|0;c[63436]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[250208+(T+oa<<3)>>3]=+h[250208+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[63436]=y+1}c[63434]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=255848;ZNb(B,255520,B,257728,258304,q,257888)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[258772>>2]=6;F2b(258768)|0;n2b()|0}c[q>>2]=2;if((c[64486]|0)>(c[g>>2]|0)){R=312;break}c[258796>>2]=6;F2b(258792)|0;n2b()|0;B=c[e>>2]|0;c[63434]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[63434]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[258484>>2]=6;F2b(258480)|0;W1b(259056,g,4)|0;n2b()|0;c[258508>>2]=6;F2b(258504)|0;W1b(259056,257560,8)|0;n2b()|0;c[258532>>2]=6;F2b(258528)|0;u=c[e>>2]|0;c[63434]=1;if((u|0)>=1){E=1;do{W1b(259056,b+(E+ -1<<3)|0,8)|0;z=c[63434]|0;E=z+1|0;c[63434]=E;}while((z|0)<(u|0))}n2b()|0;c[258556>>2]=6;F2b(258552)|0;W1b(259056,s,8)|0;n2b()|0;i=r;return 0}else if((R|0)==226){u=c[63880]|0;c[64484]=u-(c[64576]|0);c[63434]=1;E=(u|0)<1;do{if(E){h[32238]=0.0;c[63434]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[253568+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=253568+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[255848+(sa+ -1<<3)>>3]*+h[255528+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[63440]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[63436]=z;h[32238]=0.0;c[63434]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[253568+(v<<3)>>3]*+h[255528+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[32238]=wa;c[63434]=u+1;qa=wa}}while(0);h[32238]=+h[31721]-qa;s=c[e>>2]|0;c[63434]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[258136+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=258136+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[253568+(T+ -1<<3)>>3]*+h[250208+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[63434]=s+1;c[63436]=xa}v=c[e>>2]|0;c[63434]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=257568+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[258136+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[63434]=v+1}if((c[j>>2]|0)>=0){c[258820>>2]=6;F2b(258816)|0;W1b(259056,257904,8)|0;z=c[e>>2]|0;c[63434]=1;if((z|0)>=1){s=1;do{W1b(259056,257568+(s+ -1<<3)|0,8)|0;u=c[63434]|0;s=u+1|0;c[63434]=s;}while((u|0)<(z|0))}n2b()|0;c[258844>>2]=6;F2b(258840)|0;n2b()|0}z=c[e>>2]|0;c[63434]=1;if((z|0)>=1){s=c[63880]|0;v=1;while(1){c[63436]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[253568+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=253568+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[255848+(Aa+ -1<<3)>>3]*+h[250208+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[63440]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[63438]=E;c[63436]=s+1}T=c[e>>2]|0;c[63436]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=253824+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[253568+(Ea+ -1<<3)>>3]*+h[250208+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[63436]=T+1;c[63440]=Ca;c[63438]=Da}za=v+1|0;c[63434]=za;if((v|0)<(z|0)){v=za}else{break}}}c[63436]=0;v=c[e>>2]|0;c[63434]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[253824+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[63436]=Ga;c[63434]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[258868>>2]=6;F2b(258864)|0;W1b(259056,257936,4)|0;n2b()|0;c[63878]=1;z=1;d:while(1){c[63440]=z;do{if((z|0)>(c[e>>2]|0)){s=c[63878]|0;if((s|0)==1){c[258892>>2]=6;F2b(258888)|0;n2b()|0;ZNb(253824,255520,255848,257728,258304,q,257888)|0;c[258916>>2]=6;F2b(258912)|0;n2b()|0;c[63878]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[63878]=2;c[63450]=0;c[63452]=0;s=c[e>>2]|0;c[63434]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=Xec(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=Qec(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=253824+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=253824+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[253824+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[63454]=Na;c[63452]=Ta;c[63450]=Ia;c[63436]=Ma;c[63434]=s+1}c[258940>>2]=6;F2b(258936)|0;n2b()|0;c[63450]=0;u=c[e>>2]|0;c[63434]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=253824+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[63450]=Wa;c[63434]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[63450]=T;s=c[e>>2]|0;c[63434]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[63444]=B;Qa=za+la|0;c[63450]=Qa;Pa=B+5|0;c[63446]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[63878]|0)==3){c[259012>>2]=6;F2b(259008)|0;Pa=c[63446]|0;Qa=c[63444]|0;c[63436]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{W1b(259056,255848+(B+ -1<<3)|0,8)|0;Qa=c[63436]|0;B=Qa+1|0;c[63436]=B;}while((Qa|0)<(Pa|0))}n2b()|0}else{c[258988>>2]=6;F2b(258984)|0;Pa=c[63446]|0;B=c[63444]|0;c[63436]=B;if((B|0)<=(Pa|0)){x=B;do{W1b(259056,253824+(x+ -1<<3)|0,8)|0;B=c[63436]|0;x=B+1|0;c[63436]=x;}while((B|0)<(Pa|0))}n2b()|0}Pa=c[63434]|0;x=Pa+1|0;c[63434]=x;if((Pa|0)>=(s|0)){break e}E=c[63440]|0;la=c[63450]|0;za=x}}}while(0);c[259036>>2]=6;F2b(259032)|0;n2b()|0;z=(c[63440]|0)+6|0}c[258964>>2]=6;F2b(258960)|0;W1b(259056,257952,4)|0;n2b()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);le[p&63](e,b,f)|0;i=r;return 0}function ZNb(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[64784]=c[b>>2];c[g>>2]=1;if((c[64784]|0)<1){i=k;return 0}c[g>>2]=0;_Nb(a,259136,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[64784]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[64776]=f;c[64782]=g;c[64788]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=Xec(a|0,0,g+ -2|0,0)|0;m=Qec(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[64768]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=Xec(p|0,0,a-n|0,0)|0;p=Qec(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[64768]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[64766]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[64766]=j}c[64778]=g;c[64780]=f;c[64786]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[32387]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[32387]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[32387]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[64786]=D;E=v+ -1|0;c[64778]=E;F=w+ -1|0;c[64780]=F;q=D;v=E;w=F}c[64770]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[64772]=t;c[64782]=0;c[64788]=l-g;i=k;return 0}function _Nb(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[32401]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[32401]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[32401];c[64792]=1;c[64794]=0;n=c[b>>2]|0;c[64806]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[64796]=0;c[64808]=1;do{if((o|0)>=1){p=1;q=c[64794]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[32400]=m;u=(p|0)==(o|0);if(u){l=m*+h[32401];h[32402]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[32400]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[32402]=+h[32402]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[64796]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[64796]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[32400];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[64808]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[64790]=y;c[64798]=x;c[64794]=s;break}else if((D|0)==26){D=0;c[64790]=y;c[64798]=x;c[64794]=s;break}}}while(0);m=+V(+(+h[32402]));h[32402]=m;H=+h[32400];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[64794]|0)+ -1<<3)>>3]=G;G=+h[32402]/+h[32400];h[j+((c[64790]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[64794]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[64792]|0;O=c[64806]|0}}while(0);b=N+O|0;c[64792]=b;o=O+1|0;c[64806]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[64790]=y;c[64798]=x;c[64794]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function $Nb(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[64832]=n;o=(c[d>>2]|0)-n|0;c[64854]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[64852]=s;a[259352]=1;t=c[b>>2]|0;u=t+1|0;c[64848]=u;v=c[b>>2]|0;w=u+v|0;c[64846]=w;u=w+(c[b>>2]|0)|0;c[64850]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[64840]=w;x=w+(c[d>>2]|0)|0;c[64834]=x;y=x+(c[b>>2]|0)|0;c[64836]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[64842]=z;A=z+(c[d>>2]|0)|0;c[64856]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[64858]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[64830]=C;D=C+(c[b>>2]|0)|0;c[64844]=D;aOb(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,259408,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);F2b(259440)|0;n2b()|0;i=m;return 0}function aOb(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[32515]=.5;h[32506]=1.0;h[32546]=.1;F=(c[a>>2]|0)+1|0;c[65008]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[65e3]=H;I=(c[b>>2]|0)-F|0;c[65054]=I;F=c[j>>2]|0;c[65108]=(F|0)<1?1:F;F=c[a>>2]|0;c[64992]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[64994]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[64994]=J+1}L=c[u>>2]|0;c[64990]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[64990]=L+1}K=j+1|0;c[64992]=K;if((j|0)<(F|0)){j=K}else{break}}}c[64996]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[64996]=H+1}H=c[b>>2]|0;c[64994]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[64992]=M;c[64994]=H+1}N=+h[e>>3];O=N*N;h[32551]=O;h[32537]=+h[32506]/O;h[32538]=+V(+(+h[32515]))/O;c[64998]=0;H=y;y=A;M=0;a:while(1){c[65010]=M;F=M-(c[a>>2]|0)|0;c[65034]=F;j=M+1|0;c[64998]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[65084]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[65022]=L;K=L+G|0;c[65020]=K;if((K|0)>(c[a>>2]|0)){c[65084]=L;G=K-(c[a>>2]|0)|0;c[65022]=G;c[65020]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[32528]=O;L=c[65008]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[32528]=N;R=N}else{R=O}O=+h[e>>3];h[32529]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[32529]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[32529];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[64992]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[64992]=S+1}if((M|0)>=(c[65108]|0)){T=j;U=159;break}while(1){le[H&63](a,d,259952)|0;if((c[g>>2]|0)==3){F2b(260480)|0;W1b(260648,259992,4)|0;W1b(260648,259952,8)|0;I=c[a>>2]|0;c[64990]=1;if((I|0)>=1){F=1;do{W1b(260648,d+(F+ -1<<3)|0,8)|0;L=c[64990]|0;F=L+1|0;c[64990]=F;}while((L|0)<(I|0))}n2b()|0}I=c[64998]|0;do{if((I|0)>(c[b>>2]|0)){F=c[65038]|0;if((F|0)==-1){break a}h[32547]=0.0;c[64996]=0;L=c[a>>2]|0;c[64992]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[32547]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[32520]=N;if((X|0)==(G|0)){ea=N*+h[32515];h[32520]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[32547]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[64996]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[64990]=Y;c[64992]=L+1;W=Z}J=c[b>>2]|0;c[64994]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[32547]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[64994]=J+1;ia=ja}O=+h[32494];ba=+h[32523];N=O-ba-ia;h[32514]=N;h[32533]=+h[32532];h[32532]=+h[32531];if(!(N>=0.0)){ka=-N}else{ka=N}h[32531]=ka;if(+h[32543]>+h[32509]){c[65082]=I}h[32539]=ba;do{if(O<ba){h[32523]=O;h[32556]=0.0;G=c[a>>2]|0;c[64990]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[32556]=+h[32556]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[64990]=G+1;h[A>>3]=ma}}while(0);c[65080]=F;if((F|0)<=0){O=+h[32547];if(O>=0.0){U=190;break a}ba=+h[32494];N=+h[32539];ea=(ba-N)/O;h[32544]=ea;O=+h[32546];do{if(!(ea<=O)){na=+h[32515]*+h[32536];h[A>>3]=na;oa=+h[32543];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[32536]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[32536]=qa;ra=qa;break}}else{qa=+h[32515]*+h[32543];h[32536]=qa;ra=qa}}while(0);ea=+h[32509];if(!(ra<=ea*1.5)){sa=ra}else{h[32536]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[32551]=ea;c[65096]=0;h[32552]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[65052]|0;c[65096]=J;oa=+h[32506];h[32552]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[64994]=1;if((J|0)<1){va=F}else{L=c[65054]|0;oa=ua;K=1;ca=F;while(1){h[32534]=0.0;c[64992]=1;if((L|0)<1){wa=0.0}else{X=c[65014]|0;aa=K+C|0;qa=+h[32506];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[32520]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[32534]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[64992]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[32516]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[32520]=za;h[32555]=0.0;$=c[a>>2]|0;c[64992]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[32555]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[64992]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[32520]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[32552]=Fa;c[65038]=K;Ga=Fa;Ha=K}aa=K+1|0;c[64994]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}cOb(a,b,s,t,260056,u,w,260128,260152,x)|0;ca=c[65038]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[32494];c[64996]=0;J=c[a>>2]|0;c[64990]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[32520]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[32520];G=G+1|0;da=da+1|0}da=X+aa|0;c[64996]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[64992]=La;c[64990]=J+1}h[L>>3]=0.0;X=c[65054]|0;c[64992]=1;aa=(X|0)<1;if(!aa){F=c[65014]|0;K=1;while(1){da=fa(K,B)|0;O=+h[32514]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[32520]=Oa;G=c[b>>2]|0;c[64994]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[32520];$=$+1|0}c[64994]=G+1}$=K+1|0;c[64992]=$;if((K|0)<(X|0)){K=$}else{break}}}h[32525]=0.0;K=c[a>>2]|0;c[64990]=1;if((K|0)>=1){F=1;while(1){O=+h[32514]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[32525]=+h[32525]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[64990]=K+1;h[A>>3]=Pa}F=c[65080]|0;do{if((F|0)==0){if(!(+h[32536]==+h[32509])){break}O=+h[32544];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[65100]=0;break}L=c[b>>2]|0;c[64994]=1;if((L|0)>=1){J=o+((c[65052]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[64994]=L+1}h[32518]=0.0;$=c[a>>2]|0;c[64990]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[32512]=0.0;G=c[b>>2]|0;c[64994]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[32512]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[64994]=G+1;Sa=Ta}h[32518]=+h[32518]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[64990]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[32518]*100.0}J=c[65100]|0;c[65100]=J+1;if(+h[32525]<Ra){c[65100]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[64990]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[64990]=J+1}$=c[65e3]|0;c[64996]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[64996]=$+1}c[64992]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[64994]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[64994]=Na+1;Ua=Wa}if((L|0)<(c[65014]|0)){h[J>>3]=-Ua}Va=L+1|0;c[64992]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[64994]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[64992]=Xa;c[64994]=L+1}c[65100]=0}}while(0);O=+h[32494];ea=+h[32539];if(O<ea){c[65052]=ca}oa=+h[32546];if(O<=ea+oa*+h[32547]|(F|0)>0){U=54;break}c[65038]=0;Ia=0;Ja=+h[32536];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[32494];oa=+h[32494];do{if((I|0)==1){h[32513]=oa;h[32523]=oa;c[65052]=1;Ya=1}else{if(!(oa<+h[32523])){Ya=I;break}h[32523]=oa;c[65052]=I;Ya=I}}while(0);F=c[65010]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[65020]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[65022]|0;Va=K+aa|0;c[64996]=Va;if(+h[32528]<0.0){aa=X+(c[a>>2]|0)|0;c[65020]=aa;Za=aa}else{Za=X}if(+h[32529]<0.0){X=K+(c[a>>2]|0)|0;c[65022]=X;_a=X}else{_a=K}K=fa(c[65034]|0,B)|0;h[t+(K-B<<3)>>3]=+h[32537];h[t+(Ya+C+K<<3)>>3]=+h[32537];h[t+(Za-B+K<<3)>>3]=-+h[32537];h[t+(_a-B+K<<3)>>3]=-+h[32537];h[q+(Va+ -1<<3)>>3]=(+h[32513]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[32494])/(+h[32528]*+h[32529])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[65034]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[32515]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[32515]/+h[e>>3];ea=+h[32538];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[32538];h[t+(X+K<<3)>>3]=+h[32538];K=(fa(Va+1|0,Va)|0)/2|0;c[64996]=K;ea=(+h[32513]- +h[32494])/+h[e>>3];h[32520]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[32515]*(+h[X>>3]+ +h[32520]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[32513])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[32506]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[32506]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[32515]*+h[32551]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[32509]=oa;h[32536]=oa;c[65014]=1;h[32531]=0.0;h[32532]=0.0;c[65100]=0;h[32556]=0.0;F=c[a>>2]|0;c[64990]=1;if((F|0)<1){U=53;break}ca=c[65052]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[32556]=+h[32556]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[64990]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[65082]=c[64998];U=54;continue}else if((U|0)==54){U=0;c[65038]=0;I=(c[65008]|0)+ -1|0;K=c[a>>2]|0;bOb(a,b,l,n,p,q,r,260288,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,260424)|0;h[32508]=0.0;K=c[a>>2]|0;c[64990]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[32508]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[64990]=K+1;ab=cb}oa=+h[32536];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[32543]=O;ea=+h[32509];if(!(O<+h[32515]*ea)){db=ab;U=62;break}c[65038]=-1;O=+h[32546];N=O*oa;h[32536]=N;h[32544]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[32536]=ea;eb=ea}if((c[64998]|0)<=((c[65082]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[32553]*.125*ea;h[32520]=N;oa=+h[32531];ba=+h[32532];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[32533];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[32555]=O;I=c[b>>2]|0;c[64994]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[32512]=0.0;X=c[a>>2]|0;c[64992]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[32512]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[64992]=X+1;jb=lb}if(jb>ea){c[65038]=F;h[32555]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[64994]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[32544]>0.0){U=54;continue}ea=+h[32543];O=+h[32509];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[32515];h[32536]=O;ea=hb/+h[f>>3];h[32544]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[32509]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[32509]=na;ob=na;break}}else{na=+h[f>>3];h[32509]=na;ob=na}}while(0);h[32536]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){F2b(260528)|0;n2b()|0}F2b(260552)|0;W1b(260648,260072,8)|0;W1b(260648,259992,4)|0;n2b()|0;F2b(260576)|0;W1b(260648,260184,8)|0;ca=c[a>>2]|0;c[64990]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];W1b(260648,y,8)|0;I=c[64990]|0;F=I+1|0;c[64990]=F;}while((I|0)<(ca|0))}n2b()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[32515]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[32509];O=na>=ea?na:ea;h[32545]=O;ea=O*O;h[32508]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[32556];if(db<=ea*.001){h[32549]=ea*.25;ca=c[b>>2]|0;c[64994]=1;if((ca|0)>=1){F=1;while(1){h[32512]=0.0;I=c[a>>2]|0;c[64990]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[32512]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[64990]=I+1;pb=qb}h[32520]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[32515]*+h[32556];h[32512]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[64990]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[32520]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[32515]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[32512]*+h[n+(F+C+Va<<3)>>3]+ +h[32549]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[65002]=aa;c[64992]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[64992]=Va;rb=Va}c[64990]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[64994]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[65054]|0;c[64994]=1;if((F|0)>=1){ca=1;while(1){h[32530]=0.0;X=c[b>>2]|0;c[64990]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[32530]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[64990]=I;if((K|0)>=(X|0)){break b}O=+h[32530];K=I}}}while(0);X=c[a>>2]|0;c[64992]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[32549]*+h[32530]*+h[l+(I<<3)>>3];h[32512]=O;Va=c[b>>2]|0;c[64990]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[32512]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[64990]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[65014]|0)){h[32512]=-+h[32512]}L=c[b>>2]|0;c[64990]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[32512]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[64990]=L+1}J=K+1|0;c[64992]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[64990]=1;if((K|0)>=1){X=c[65014]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[65002]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[32520]=ub;c[64992]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[32520];aa=aa+1|0}aa=J+1|0;c[64992]=aa;vb=aa}c[64990]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[64994]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[64996]=0;ca=c[a>>2]|0;c[64992]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[64994]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[32515]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[64994]=aa+1}c[64990]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[64996]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[64990]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[64992]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[64992]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[64992]=J+1}h[32556]=0.0}if((c[65038]|0)>0){F=(c[65008]|0)+ -1|0;wNb(a,b,l,n,s,t,260056,u,260152,260360,v,260280,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[64994]=1;if((F|0)>=1){L=1;while(1){h[32521]=0.0;h[32522]=0.0;h[32512]=0.0;ca=c[a>>2]|0;c[64992]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[32521]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[32522]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[32512]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[64992]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[32515]+Ab);h[w+(K<<3)>>3]=+h[32512];K=L+1|0;c[64994]=K;if((L|0)<(F|0)){L=K}else{break}}}h[32516]=0.0;L=c[65054]|0;c[64994]=1;if((L|0)>=1){F=1;while(1){h[32512]=0.0;J=c[b>>2]|0;c[64990]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[32512]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[64990]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[32516];if((F|0)<(c[65014]|0)){h[32516]=O+ea;na=-Eb;h[32512]=na;Gb=na}else{h[32516]=O-ea;Gb=Eb}K=c[b>>2]|0;c[64990]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[32512];X=X+1|0}c[64990]=K+1}X=F+1|0;c[64994]=X;if((F|0)<(L|0)){F=X}else{break}}}h[32524]=0.0;h[32503]=0.0;F=c[a>>2]|0;c[64992]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[32512]=0.0;X=c[b>>2]|0;c[64990]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[32512]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[64990]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[32524]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[65004]=K;Va=c[a>>2]|0;c[64994]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[32512]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[64994]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[32524]+ +h[32512]*+h[ca>>3];h[32524]=O;na=+h[32503]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[32503]=na;aa=L+1|0;c[64992]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[32508];h[32516]=+h[32516]+(Ib*Ib+ea*(Ib+(Ib+ +h[32556])+ea*+h[32515]))-Hb;L=w+((c[65052]|0)+ -1<<3)|0;h[L>>3]=+h[32506]+ +h[L>>3];L=c[65038]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[32506]+ +h[32535]*+h[32516]/(ea*ea);h[32520]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;vNb(a,b,l,n,s,t,260056,u,260208,260152,v,x,w,260128,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[64990]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[64990]=L+1}F=c[64998]|0;aa=F+1|0;c[64998]=aa;if((F|0)>=(c[65108]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[64998]=T+ -1;if((c[g>>2]|0)<=0){break}F2b(260456)|0;n2b()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}F2b(260504)|0;n2b()|0}}while(0);Nb=+h[32523];if(Nb<=+h[32494]){U=c[a>>2]|0;c[64990]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[64990]=U+1;Ob=+h[32523]}h[32494]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}F2b(260600)|0;W1b(260648,259992,4)|0;n2b()|0;F2b(260624)|0;W1b(260648,259952,8)|0;g=c[a>>2]|0;c[64990]=1;if((g|0)>=1){a=1;do{W1b(260648,d+(a+ -1<<3)|0,8)|0;U=c[64990]|0;a=U+1|0;c[64990]=a;}while((U|0)<(g|0))}n2b()|0;i=z;return 0}function bOb(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[32601]=.5;h[32619]=6.283185307179586;v=+h[l>>3];h[32614]=v*v;c[65224]=0;l=c[b>>2]|0;c[65242]=l;c[65240]=l;w=c[b>>2]|0;c[65164]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[65164]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[65164]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[65164]=w+1}z=c[d>>2]|0;c[65168]=1;if((z|0)>=1){e=1;while(1){h[32605]=0.0;A=c[b>>2]|0;c[65166]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[32605]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[65166]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[32605]=v;C=c[b>>2]|0;c[65164]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[32605];F=F+1|0}c[65164]=C+1}F=e+1|0;c[65168]=F;if((e|0)<(z|0)){e=F}else{break}}}c[65178]=0;e=c[b>>2]|0;c[65166]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[65178]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[65164]=H;c[65166]=e+1}do{if((y|0)==0){h[32603]=0.0;h[32585]=0.0;w=c[b>>2]|0;c[65164]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[32585]=+h[32585]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[65164]=w+1}h[r>>3]=0.0;D=+h[32585];if(D==0.0){O=55;break a}h[32590]=0.0;h[32593]=0.0;h[32588]=D;h[32608]=D;P=D;Q=0.0;R=0.0;S=+h[32614];T=0}else{if((y|0)>(x|0)){h[32587]=0.0;h[32594]=0.0;h[32595]=0.0;z=c[b>>2]|0;c[65164]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[32587]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[32594]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[32595]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[65164]=z+1;U=ba;W=$;Z=aa}D=+h[32601];v=D*(+h[32598]-Z);h[32586]=v;_=+h[32591];ca=_+v;h[32602]=ca;h[32606]=ca;h[32604]=ca;c[65234]=0;a[260736]=1;da=+h[32619]/50.0;h[32605]=da;c[65164]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[32604]=ka;c[65234]=w;h[32615]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[32616]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[32610]=ha;h[32596]=ia;h[32599]=ja;h[32607]=ka;c[65164]=50;h[32606]=ka;if((la|0)==0){h[32615]=ka;O=46}else if((la|0)==49){h[32616]=ca;na=ca}else{O=46}if((O|0)==46){O=0;na=+h[32616]}h[32610]=0.0;ga=+h[32615];if(ga!=na){ea=ga-ma;h[32615]=ea;ga=na-ma;h[32616]=ga;oa=D*(ea-ga)/(ea+ga);h[32610]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[32610]=oa;ga=+X(+oa);h[32596]=ga;ea=+Y(+oa);h[32599]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[32611]=oa;h[32588]=0.0;w=c[b>>2]|0;c[65164]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[32596]*+h[J>>3]+ +h[32599]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[32588]+sa*sa;h[32588]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[32599];ea=+h[32596];F=F+1|0;z=K}c[65164]=w+1;qa=ta;ra=+h[32611]}ea=ra+ +h[32603];h[32603]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[32594]=0.0;z=c[b>>2]|0;c[65166]=1;do{if((z|0)<1){ea=+h[32618];h[32609]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[32594]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[65166]=z+1;ea=+h[32618];h[32609]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[32585];h[32605]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[32605]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[32609];oa=+h[32588];v=+h[32594];_=oa/v;ca=ea<=_?ea:_;h[32609]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[32588];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[32601]*Ca);h[32600]=ca;h[32603]=+h[32603]+ca;h[32613]=Ba;h[32588]=0.0;z=c[b>>2]|0;c[65164]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[32609]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[32588]+oa*oa;h[32588]=Ga;Ha=+h[32609];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[65164]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[32618]){if(+h[32600]<=+h[32603]*.01){O=55;break a}if(Fa<=+h[32608]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[32613];h[32605]=ca;h[32585]=0.0;h[32590]=0.0;h[32593]=0.0;w=c[b>>2]|0;c[65164]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[32585]+ca*ca;h[32585]=La;J=m+(F<<3)|0;Ma=+h[32590]+ +h[K>>3]*+h[J>>3];h[32590]=Ma;ca=+h[J>>3];Na=+h[32593]+ca*ca;h[32593]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[32605];Ja=Ja+1|0;Ka=J}c[65164]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[32614];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[65240]=y;ua=+h[32588];va=y}if(ua<=+h[32608]*1.0e-4){O=55;break a}h[32591]=0.0;h[32598]=0.0;z=c[b>>2]|0;c[65164]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[32591]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[32598]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[65164]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[32597]=ca;oa=+h[32614];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[65224]=J;_=+V(+(v-ca*ca));h[32605]=_;v=oa/_;h[32615]=v;oa=ca/_;h[32616]=oa;w=c[b>>2]|0;c[65164]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[32616];Ta=+h[32615];Ua=Ua+1|0;Va=K}c[65164]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[65224]=e;v=S-R;h[32605]=v;h[32618]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function cOb(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[32628]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[65262]=t;c[65252]=1;c[65246]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[65252]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[32630]=D;C=+h[x>>3]/D;h[32637]=C;z=+h[f+(B+y<<3)>>3]/D;h[32638]=z;B=c[d>>2]|0;c[65244]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[32630]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[32630];if((x|0)>=(B|0)){break}D=+h[32638];z=+h[32637];x=x+1|0}c[65244]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[65246]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[32637]=z;if((c[g>>2]|0)>1){D=-z;h[32637]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[32638]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[65244]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[32638]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[32637];t=t+1|0;x=A}c[65244]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[32635]=z;x=k+(w<<3)|0;H=+h[x>>3];h[32629]=H;D=H*H;h[32639]=D;h[32636]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[32628];a[261056]=0;do{if((u|0)==1){z=+h[32636];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[32630]=z;D=+h[32637]/z;h[32638]=D;H=+h[32629]/z;h[32637]=H;x=c[d>>2]|0;c[65244]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[32638];D=+h[32637];w=w+1|0;t=s}c[65244]=x+1;J=+h[32630]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[65248]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[65248]=u;M=u}t=u+1-M|0;c[65250]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[32636];z=+h[f+(t+w<<3)>>3]/D;h[32630]=z;h[32637]=z*+h[l>>3];H=+h[32629];h[32638]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[32630]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[32628]/+V(+(+h[32639]+z*N*z));h[32633]=C;if(!(D>=0.0)){O=-D}else{O=D}h[32634]=C*+V(+O);t=c[d>>2]|0;c[65244]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[32634]*(+h[A>>3]- +h[32637]*+h[n+(G<<3)>>3]- +h[32638]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[32630];z=+h[32629];H=+h[32633];v=v+1|0}c[65244]=t+1;P=+h[32636]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[261056]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[65244]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[32630]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[32630];K=Q+1|0;c[65244]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[65246]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[65254]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[32629];N=+h[32636];J=(+h[32635]*+h[f>>3]-O*P)/N;h[32637]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[32638]=P;c[65244]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[65244]=q;if((f|0)>=(b|0)){break a}N=+h[32638];O=+h[32637];f=q}}}while(0);b=R+1|0;c[65246]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function dOb(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function eOb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((dOb(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){ab(261120,261136,116,261160)}else if((s|0)==14){i=g;return o|0}return 0}function fOb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((Aec(w,c[261168+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[261272+(x<<2)>>2]|0;c[q>>2]=c[261168+(x<<2)>>2];c[q+4>>2]=y;VLb(23,0,261344,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=cec(D,8)|0;c[e+40>>2]=B;D=b+536|0;YLb(c[D>>2]|0,(B|0)!=0|0,261384,p);B=cec(c[A>>2]|0,4)|0;c[e+36>>2]=B;YLb(c[D>>2]|0,(B|0)!=0|0,261384,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=cec(c[C>>2]|0,4)|0;c[e+24>>2]=aec(8)|0;C=aec(4)|0;c[e+20>>2]=C;c[C>>2]=c[233616>>2];YLb(c[D>>2]|0,(C|0)!=0|0,261384,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=aec(C)|0;A=e+44|0;c[A>>2]=aec(C)|0;C=cec(15,4)|0;E=e+12|0;c[E>>2]=C;YLb(c[D>>2]|0,(C|0)!=0|0,261384,m);C=cec(5,4)|0;c[e+4>>2]=C;YLb(c[D>>2]|0,(C|0)!=0|0,261384,l);C=cec(5,4)|0;c[e+8>>2]=C;YLb(c[D>>2]|0,(C|0)!=0|0,261384,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=aec(C)|0;c[e+76>>2]=aec(C)|0;c[e+80>>2]=aec(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((ge[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){VLb(23,0,261400,j)}else{VLb(1,0,261472,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[233652>>2]|c[58388]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=261304;W=V;ZLb(Q,W,r)}c[t>>2]=w;XLb(23,1,261200,t);t=1;do{w=c[261272+(t<<2)>>2]|0;c[s>>2]=c[261168+(t<<2)>>2];c[s+4>>2]=w;XLb(23,0,261256,s);t=t+1|0;}while((t|0)<8);de[c[58528]&511](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=261304;W=V;ZLb(Q,W,r);return 0}function gOb(a){a=a|0;var b=0;b=i;bec(c[a+40>>2]|0);bec(c[a+36>>2]|0);bec(c[a+20>>2]|0);bec(c[a+12>>2]|0);bec(c[a+4>>2]|0);bec(c[a+8>>2]|0);bec(a);i=b;return 0}



function btb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93096]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(93104,tMb(+h[(c[g>>2]|0)+22080>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[93096]=1;i=d;return}function ctb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93256]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(93264,tMb(+h[(c[g>>2]|0)+22072>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[93256]=1;i=d;return}function dtb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93408]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+332>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+332>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(93416,vMb(c[(c[g>>2]|0)+332>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[93408]=1;i=d;return}function etb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93616]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+328>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+328>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(93624,vMb(c[(c[g>>2]|0)+328>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[93616]=1;i=d;return}function ftb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93824]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+324>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+324>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(93832,vMb(c[(c[g>>2]|0)+324>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[93824]=1;i=d;return}function gtb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94032]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+320>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+320>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(94040,vMb(c[(c[g>>2]|0)+320>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[94032]=1;i=d;return}function htb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94224]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+316>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+316>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(94232,vMb(c[(c[g>>2]|0)+316>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[94224]=1;i=d;return}function itb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94416]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+312>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+312>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(94424,vMb(c[(c[g>>2]|0)+312>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[94416]=1;i=d;return}function jtb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94608]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22040>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(94616,tMb(+h[(c[g>>2]|0)+22040>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[94608]=1;i=d;return}function ktb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94744]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22032>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(94752,tMb(+h[(c[g>>2]|0)+22032>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[94744]=1;i=d;return}function ltb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94880]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22024>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(94888,tMb(+h[(c[g>>2]|0)+22024>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[94880]=1;i=d;return}function mtb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95016]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(95024,tMb(+h[(c[g>>2]|0)+22016>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[95016]=1;i=d;return}function ntb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95136]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(95144,tMb(+h[(c[g>>2]|0)+22008>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[95136]=1;i=d;return}function otb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95256]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(95264,tMb(+h[(c[g>>2]|0)+22e3>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[95256]=1;i=d;return}function ptb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95376]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(95384,tMb(+h[(c[g>>2]|0)+21992>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[95376]=1;i=d;return}function qtb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95488]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(95496,tMb(+h[(c[g>>2]|0)+21960>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[95488]=1;i=d;return}function rtb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95608]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(95616,tMb(+h[(c[g>>2]|0)+21944>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[95608]=1;i=d;return}function stb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95744]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(95752,tMb(+h[(c[g>>2]|0)+21936>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[95744]=1;i=d;return}function ttb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95888]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(95896,tMb(+h[(c[g>>2]|0)+21928>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[95888]=1;i=d;return}function utb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96048]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(96056,tMb(+h[(c[g>>2]|0)+21920>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[96048]=1;i=d;return}function vtb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96208]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(96216,tMb(+h[(c[g>>2]|0)+21896>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[96208]=1;i=d;return}function wtb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96376]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(96384,tMb(+h[(c[g>>2]|0)+21888>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[96376]=1;i=d;return}function xtb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96544]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(96552,tMb(+h[(c[g>>2]|0)+21880>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[96544]=1;i=d;return}function ytb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96712]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(96720,tMb(+h[(c[g>>2]|0)+21872>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[96712]=1;i=d;return}function ztb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96896]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(96904,tMb(+h[(c[g>>2]|0)+21864>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[96896]=1;i=d;return}function Atb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97072]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(97080,tMb(+h[(c[g>>2]|0)+21856>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[97072]=1;i=d;return}function Btb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97248]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(97256,tMb(+h[(c[g>>2]|0)+21840>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[97248]=1;i=d;return}function Ctb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97424]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(97432,tMb(+h[(c[g>>2]|0)+21832>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[97424]=1;i=d;return}function Dtb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97600]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(97608,tMb(+h[(c[g>>2]|0)+21800>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[97600]=1;i=d;return}function Etb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97760]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21792>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(97768,tMb(+h[(c[g>>2]|0)+21792>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[97760]=1;i=d;return}function Ftb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97920]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(97928,tMb(+h[(c[g>>2]|0)+21784>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[97920]=1;i=d;return}function Gtb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98080]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21776>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(98088,tMb(+h[(c[g>>2]|0)+21776>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[98080]=1;i=d;return}function Htb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98240]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(98248,tMb(+h[(c[g>>2]|0)+21768>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[98240]=1;i=d;return}function Itb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98408]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21760>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(98416,tMb(+h[(c[g>>2]|0)+21760>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[98408]=1;i=d;return}function Jtb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98576]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21752>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(98584,tMb(+h[(c[g>>2]|0)+21752>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[98576]=1;i=d;return}function Ktb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98728]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21744>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(98736,tMb(+h[(c[g>>2]|0)+21744>>3],24152)|0)|0;g=c[69978]|0;j=e;k=139056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[98728]=1;i=d;return}function Ltb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98896]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+832>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+832>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=xMb(98904,vMb(c[(c[g>>2]|0)+832>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=139528;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[98896]=1;i=d;return}function Mtb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99344]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+828>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+828>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=xMb(99352,vMb(c[(c[g>>2]|0)+828>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=139944;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[99344]=1;i=d;return}function Ntb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99736]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(99744,tMb(+h[(c[g>>2]|0)+21720>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[99736]=1;i=d;return}function Otb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99872]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21712>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(99880,tMb(+h[(c[g>>2]|0)+21712>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[99872]=1;i=d;return}function Ptb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100024]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(100032,tMb(+h[(c[g>>2]|0)+21704>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[100024]=1;i=d;return}function Qtb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100176]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21656>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(100184,tMb(+h[(c[g>>2]|0)+21656>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[100176]=1;i=d;return}function Rtb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100312]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(100320,tMb(+h[(c[g>>2]|0)+21648>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[100312]=1;i=d;return}function Stb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100448]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+308>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+308>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(100456,vMb(c[(c[g>>2]|0)+308>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[100448]=1;i=d;return}function Ttb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100640]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+304>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+304>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(100648,vMb(c[(c[g>>2]|0)+304>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[100640]=1;i=d;return}function Utb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100832]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+300>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+300>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(100840,vMb(c[(c[g>>2]|0)+300>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[100832]=1;i=d;return}function Vtb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101024]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+824>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+824>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(101032,vMb(c[(c[g>>2]|0)+824>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=143056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[101024]=1;i=d;return}function Wtb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101352]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(101360,tMb(+h[(c[g>>2]|0)+21616>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[101352]=1;i=d;return}function Xtb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101504]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(101512,tMb(+h[(c[g>>2]|0)+21608>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[101504]=1;i=d;return}function Ytb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101656]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+296>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+296>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(101664,vMb(c[(c[g>>2]|0)+296>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[101656]=1;i=d;return}function Ztb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101880]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+292>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+292>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(101888,vMb(c[(c[g>>2]|0)+292>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[101880]=1;i=d;return}function _tb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102104]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+288>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+288>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(102112,vMb(c[(c[g>>2]|0)+288>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[102104]=1;i=d;return}function $tb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102328]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+820>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+820>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(102336,vMb(c[(c[g>>2]|0)+820>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=143056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[102328]=1;i=d;return}function aub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102680]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(102688,tMb(+h[(c[g>>2]|0)+21576>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[102680]=1;i=d;return}function bub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102800]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(102808,tMb(+h[(c[g>>2]|0)+21568>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[102800]=1;i=d;return}function cub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102920]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(102928,tMb(+h[(c[g>>2]|0)+21544>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[102920]=1;i=d;return}function dub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103048]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(103056,tMb(+h[(c[g>>2]|0)+21536>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[103048]=1;i=d;return}function eub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103176]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(103184,tMb(+h[(c[g>>2]|0)+21512>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[103176]=1;i=d;return}function fub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103312]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(103320,tMb(+h[(c[g>>2]|0)+21504>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[103312]=1;i=d;return}function gub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103440]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(103448,tMb(+h[(c[g>>2]|0)+21480>>3],24152)|0)|0;g=c[69978]|0;j=e;k=143968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[103440]=1;i=d;return}function hub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103568]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(103576,tMb(+h[(c[g>>2]|0)+21472>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[103568]=1;i=d;return}function iub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103696]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(103704,tMb(+h[(c[g>>2]|0)+21464>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[103696]=1;i=d;return}function jub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103824]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(103832,tMb(+h[(c[g>>2]|0)+21456>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144416;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[103824]=1;i=d;return}function kub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103944]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(103952,tMb(+h[(c[g>>2]|0)+21440>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[103944]=1;i=d;return}function lub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104080]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(104088,tMb(+h[(c[g>>2]|0)+21432>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[104080]=1;i=d;return}function mub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104216]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(104224,tMb(+h[(c[g>>2]|0)+21424>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[104216]=1;i=d;return}function nub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104352]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(104360,tMb(+h[(c[g>>2]|0)+21416>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[104352]=1;i=d;return}function oub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104472]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(104480,tMb(+h[(c[g>>2]|0)+21352>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[104472]=1;i=d;return}function pub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104616]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(104624,tMb(+h[(c[g>>2]|0)+21344>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[104616]=1;i=d;return}function qub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104744]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(104752,tMb(+h[(c[g>>2]|0)+21336>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[104744]=1;i=d;return}function rub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104872]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(104880,tMb(+h[(c[g>>2]|0)+21328>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[104872]=1;i=d;return}function sub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105032]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(105040,tMb(+h[(c[g>>2]|0)+21320>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[105032]=1;i=d;return}function tub(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105184]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+284>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+284>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(105192,vMb(c[(c[g>>2]|0)+284>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[105184]=1;i=d;return}function uub(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105416]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+280>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+280>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(105424,vMb(c[(c[g>>2]|0)+280>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[105416]=1;i=d;return}function vub(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105648]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+276>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+276>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(105656,vMb(c[(c[g>>2]|0)+276>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[105648]=1;i=d;return}function wub(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105880]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+272>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+272>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(105888,vMb(c[(c[g>>2]|0)+272>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[105880]=1;i=d;return}function xub(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106096]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+268>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+268>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(106104,vMb(c[(c[g>>2]|0)+268>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[106096]=1;i=d;return}function yub(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106312]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+264>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+264>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(106320,vMb(c[(c[g>>2]|0)+264>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[106312]=1;i=d;return}function zub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106528]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21312>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(106536,tMb(+h[(c[g>>2]|0)+21312>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[106528]=1;i=d;return}function Aub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106680]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21304>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(106688,tMb(+h[(c[g>>2]|0)+21304>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[106680]=1;i=d;return}function Bub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106832]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21296>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(106840,tMb(+h[(c[g>>2]|0)+21296>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[106832]=1;i=d;return}function Cub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106984]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(106992,tMb(+h[(c[g>>2]|0)+21288>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[106984]=1;i=d;return}function Dub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107120]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(107128,tMb(+h[(c[g>>2]|0)+21280>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[107120]=1;i=d;return}function Eub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107256]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(107264,tMb(+h[(c[g>>2]|0)+21272>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[107256]=1;i=d;return}function Fub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107392]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(107400,tMb(+h[(c[g>>2]|0)+21264>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[107392]=1;i=d;return}function Gub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107520]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(107528,tMb(+h[(c[g>>2]|0)+21248>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[107520]=1;i=d;return}function Hub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107680]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(107688,tMb(+h[(c[g>>2]|0)+21240>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[107680]=1;i=d;return}function Iub(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107840]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+260>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+260>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(107848,vMb(c[(c[g>>2]|0)+260>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[107840]=1;i=d;return}function Jub(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108056]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+256>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+256>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(108064,vMb(c[(c[g>>2]|0)+256>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[108056]=1;i=d;return}function Kub(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108272]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+252>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+252>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(108280,vMb(c[(c[g>>2]|0)+252>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[108272]=1;i=d;return}function Lub(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108488]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+248>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+248>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(108496,vMb(c[(c[g>>2]|0)+248>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[108488]=1;i=d;return}function Mub(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108688]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+244>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+244>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(108696,vMb(c[(c[g>>2]|0)+244>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[108688]=1;i=d;return}function Nub(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108888]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+240>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+240>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(108896,vMb(c[(c[g>>2]|0)+240>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[108888]=1;i=d;return}function Oub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109088]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21208>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(109096,tMb(+h[(c[g>>2]|0)+21208>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[109088]=1;i=d;return}function Pub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109232]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21200>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(109240,tMb(+h[(c[g>>2]|0)+21200>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[109232]=1;i=d;return}function Qub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109376]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21192>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(109384,tMb(+h[(c[g>>2]|0)+21192>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[109376]=1;i=d;return}function Rub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109520]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(109528,tMb(+h[(c[g>>2]|0)+21184>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[109520]=1;i=d;return}function Sub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109648]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(109656,tMb(+h[(c[g>>2]|0)+21176>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[109648]=1;i=d;return}function Tub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109776]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(109784,tMb(+h[(c[g>>2]|0)+21168>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[109776]=1;i=d;return}function Uub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109904]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(109912,tMb(+h[(c[g>>2]|0)+21160>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[109904]=1;i=d;return}function Vub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110024]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21152>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(110032,tMb(+h[(c[g>>2]|0)+21152>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[110024]=1;i=d;return}function Wub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110160]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21144>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(110168,tMb(+h[(c[g>>2]|0)+21144>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[110160]=1;i=d;return}function Xub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110280]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(110288,tMb(+h[(c[g>>2]|0)+21136>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[110280]=1;i=d;return}function Yub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110400]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(110408,tMb(+h[(c[g>>2]|0)+21128>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[110400]=1;i=d;return}function Zub(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110552]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(110560,tMb(+h[(c[g>>2]|0)+21120>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[110552]=1;i=d;return}function _ub(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110704]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+236>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+236>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(110712,vMb(c[(c[g>>2]|0)+236>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[110704]=1;i=d;return}function $ub(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110928]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+232>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+232>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(110936,vMb(c[(c[g>>2]|0)+232>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[110928]=1;i=d;return}function avb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111152]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+228>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+228>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(111160,vMb(c[(c[g>>2]|0)+228>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[111152]=1;i=d;return}function bvb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111376]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+224>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+224>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(111384,vMb(c[(c[g>>2]|0)+224>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[111376]=1;i=d;return}function cvb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111584]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+220>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+220>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(111592,vMb(c[(c[g>>2]|0)+220>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[111584]=1;i=d;return}function dvb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111792]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+216>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+216>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(111800,vMb(c[(c[g>>2]|0)+216>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[111792]=1;i=d;return}function evb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112e3]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21112>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(112008,tMb(+h[(c[g>>2]|0)+21112>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[112e3]=1;i=d;return}function fvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112152]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21104>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(112160,tMb(+h[(c[g>>2]|0)+21104>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[112152]=1;i=d;return}function gvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112304]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21096>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(112312,tMb(+h[(c[g>>2]|0)+21096>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[112304]=1;i=d;return}function hvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112456]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(112464,tMb(+h[(c[g>>2]|0)+21088>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[112456]=1;i=d;return}function ivb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112584]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(112592,tMb(+h[(c[g>>2]|0)+21080>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[112584]=1;i=d;return}function jvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112712]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(112720,tMb(+h[(c[g>>2]|0)+21072>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[112712]=1;i=d;return}function kvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112840]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(112848,tMb(+h[(c[g>>2]|0)+21064>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[112840]=1;i=d;return}function lvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112960]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(112968,tMb(+h[(c[g>>2]|0)+21048>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[112960]=1;i=d;return}function mvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113120]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(113128,tMb(+h[(c[g>>2]|0)+21040>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[113120]=1;i=d;return}function nvb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113272]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+212>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+212>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(113280,vMb(c[(c[g>>2]|0)+212>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[113272]=1;i=d;return}function ovb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113480]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+208>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+208>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(113488,vMb(c[(c[g>>2]|0)+208>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[113480]=1;i=d;return}function pvb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113688]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+204>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+204>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(113696,vMb(c[(c[g>>2]|0)+204>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[113688]=1;i=d;return}function qvb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113896]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+200>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+200>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(113904,vMb(c[(c[g>>2]|0)+200>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[113896]=1;i=d;return}function rvb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114088]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+196>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+196>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(114096,vMb(c[(c[g>>2]|0)+196>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[114088]=1;i=d;return}function svb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114280]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+192>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+192>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(114288,vMb(c[(c[g>>2]|0)+192>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[114280]=1;i=d;return}function tvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114472]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21008>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(114480,tMb(+h[(c[g>>2]|0)+21008>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[114472]=1;i=d;return}function uvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114608]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+21e3>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(114616,tMb(+h[(c[g>>2]|0)+21e3>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[114608]=1;i=d;return}function vvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114744]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20992>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(114752,tMb(+h[(c[g>>2]|0)+20992>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[114744]=1;i=d;return}function wvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114880]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(114888,tMb(+h[(c[g>>2]|0)+20984>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[114880]=1;i=d;return}function xvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115e3]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(115008,tMb(+h[(c[g>>2]|0)+20976>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[115e3]=1;i=d;return}function yvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115120]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(115128,tMb(+h[(c[g>>2]|0)+20968>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[115120]=1;i=d;return}function zvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115240]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(115248,tMb(+h[(c[g>>2]|0)+20960>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[115240]=1;i=d;return}function Avb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115352]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(115360,tMb(+h[(c[g>>2]|0)+20928>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[115352]=1;i=d;return}function Bvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115472]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(115480,tMb(+h[(c[g>>2]|0)+20912>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[115472]=1;i=d;return}function Cvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115608]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(115616,tMb(+h[(c[g>>2]|0)+20904>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[115608]=1;i=d;return}function Dvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115752]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(115760,tMb(+h[(c[g>>2]|0)+20896>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[115752]=1;i=d;return}function Evb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115912]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(115920,tMb(+h[(c[g>>2]|0)+20888>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[115912]=1;i=d;return}function Fvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116072]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(116080,tMb(+h[(c[g>>2]|0)+20864>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[116072]=1;i=d;return}function Gvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116240]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(116248,tMb(+h[(c[g>>2]|0)+20856>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[116240]=1;i=d;return}function Hvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116408]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(116416,tMb(+h[(c[g>>2]|0)+20848>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[116408]=1;i=d;return}function Ivb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116576]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(116584,tMb(+h[(c[g>>2]|0)+20840>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[116576]=1;i=d;return}function Jvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116760]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(116768,tMb(+h[(c[g>>2]|0)+20832>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[116760]=1;i=d;return}function Kvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116936]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(116944,tMb(+h[(c[g>>2]|0)+20824>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[116936]=1;i=d;return}function Lvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117112]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(117120,tMb(+h[(c[g>>2]|0)+20808>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[117112]=1;i=d;return}function Mvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117288]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(117296,tMb(+h[(c[g>>2]|0)+20800>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[117288]=1;i=d;return}function Nvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117464]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(117472,tMb(+h[(c[g>>2]|0)+20768>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[117464]=1;i=d;return}function Ovb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117624]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20760>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(117632,tMb(+h[(c[g>>2]|0)+20760>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[117624]=1;i=d;return}function Pvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117784]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20752>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(117792,tMb(+h[(c[g>>2]|0)+20752>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[117784]=1;i=d;return}function Qvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117944]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20744>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(117952,tMb(+h[(c[g>>2]|0)+20744>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[117944]=1;i=d;return}function Rvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118104]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(118112,tMb(+h[(c[g>>2]|0)+20736>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[118104]=1;i=d;return}function Svb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118272]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(118280,tMb(+h[(c[g>>2]|0)+20728>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[118272]=1;i=d;return}function Tvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118440]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(118448,tMb(+h[(c[g>>2]|0)+20720>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[118440]=1;i=d;return}function Uvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118592]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20712>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(118600,tMb(+h[(c[g>>2]|0)+20712>>3],24152)|0)|0;g=c[69978]|0;j=e;k=139056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[118592]=1;i=d;return}function Vvb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118760]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+816>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+816>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=xMb(118768,vMb(c[(c[g>>2]|0)+816>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=139528;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[118760]=1;i=d;return}function Wvb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119208]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+812>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+812>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=xMb(119216,vMb(c[(c[g>>2]|0)+812>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=139944;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[119208]=1;i=d;return}function Xvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119600]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(119608,tMb(+h[(c[g>>2]|0)+20688>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[119600]=1;i=d;return}function Yvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119736]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(119744,tMb(+h[(c[g>>2]|0)+20680>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[119736]=1;i=d;return}function Zvb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119888]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(119896,tMb(+h[(c[g>>2]|0)+20672>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[119888]=1;i=d;return}function _vb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120040]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20624>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(120048,tMb(+h[(c[g>>2]|0)+20624>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[120040]=1;i=d;return}function $vb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120176]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(120184,tMb(+h[(c[g>>2]|0)+20616>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[120176]=1;i=d;return}function awb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120312]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+188>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+188>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(120320,vMb(c[(c[g>>2]|0)+188>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[120312]=1;i=d;return}function bwb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120504]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+184>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+184>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(120512,vMb(c[(c[g>>2]|0)+184>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[120504]=1;i=d;return}function cwb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120696]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+180>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+180>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(120704,vMb(c[(c[g>>2]|0)+180>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[120696]=1;i=d;return}function dwb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120888]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+808>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+808>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(120896,vMb(c[(c[g>>2]|0)+808>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=143056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[120888]=1;i=d;return}function ewb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121216]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20584>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(121224,tMb(+h[(c[g>>2]|0)+20584>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[121216]=1;i=d;return}function fwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121368]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(121376,tMb(+h[(c[g>>2]|0)+20576>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[121368]=1;i=d;return}function gwb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121520]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+176>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+176>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(121528,vMb(c[(c[g>>2]|0)+176>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[121520]=1;i=d;return}function hwb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121744]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+172>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+172>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(121752,vMb(c[(c[g>>2]|0)+172>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[121744]=1;i=d;return}function iwb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121968]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+168>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+168>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(121976,vMb(c[(c[g>>2]|0)+168>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[121968]=1;i=d;return}function jwb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122192]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+804>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+804>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(122200,vMb(c[(c[g>>2]|0)+804>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=143056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[122192]=1;i=d;return}function kwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122544]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(122552,tMb(+h[(c[g>>2]|0)+20544>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[122544]=1;i=d;return}function lwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122664]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(122672,tMb(+h[(c[g>>2]|0)+20536>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[122664]=1;i=d;return}function mwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122784]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(122792,tMb(+h[(c[g>>2]|0)+20512>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[122784]=1;i=d;return}function nwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122912]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(122920,tMb(+h[(c[g>>2]|0)+20504>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[122912]=1;i=d;return}function owb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123040]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(123048,tMb(+h[(c[g>>2]|0)+20480>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[123040]=1;i=d;return}function pwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123176]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(123184,tMb(+h[(c[g>>2]|0)+20472>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[123176]=1;i=d;return}function qwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123304]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(123312,tMb(+h[(c[g>>2]|0)+20448>>3],24152)|0)|0;g=c[69978]|0;j=e;k=143968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[123304]=1;i=d;return}function rwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123432]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(123440,tMb(+h[(c[g>>2]|0)+20440>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[123432]=1;i=d;return}function swb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123560]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(123568,tMb(+h[(c[g>>2]|0)+20432>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[123560]=1;i=d;return}function twb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123688]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(123696,tMb(+h[(c[g>>2]|0)+20424>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144416;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[123688]=1;i=d;return}function uwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123808]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(123816,tMb(+h[(c[g>>2]|0)+20408>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[123808]=1;i=d;return}function vwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123944]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(123952,tMb(+h[(c[g>>2]|0)+20400>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[123944]=1;i=d;return}function wwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124080]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(124088,tMb(+h[(c[g>>2]|0)+20392>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[124080]=1;i=d;return}function xwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124216]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(124224,tMb(+h[(c[g>>2]|0)+20384>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[124216]=1;i=d;return}function ywb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124336]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(124344,tMb(+h[(c[g>>2]|0)+20320>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[124336]=1;i=d;return}function zwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124480]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(124488,tMb(+h[(c[g>>2]|0)+20312>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[124480]=1;i=d;return}function Awb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124608]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(124616,tMb(+h[(c[g>>2]|0)+20304>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[124608]=1;i=d;return}function Bwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124736]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(124744,tMb(+h[(c[g>>2]|0)+20296>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[124736]=1;i=d;return}function Cwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124896]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(124904,tMb(+h[(c[g>>2]|0)+20288>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[124896]=1;i=d;return}function Dwb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125048]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+164>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+164>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(125056,vMb(c[(c[g>>2]|0)+164>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[125048]=1;i=d;return}function Ewb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125280]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+160>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+160>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(125288,vMb(c[(c[g>>2]|0)+160>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[125280]=1;i=d;return}



function zpb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60912]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+544>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+544>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(60920,vMb(c[(c[g>>2]|0)+544>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[60912]=1;i=d;return}function Apb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61104]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+540>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+540>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(61112,vMb(c[(c[g>>2]|0)+540>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[61104]=1;i=d;return}function Bpb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61296]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+856>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+856>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(61304,vMb(c[(c[g>>2]|0)+856>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=143056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[61296]=1;i=d;return}function Cpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61624]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(61632,tMb(+h[(c[g>>2]|0)+23680>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[61624]=1;i=d;return}function Dpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61776]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(61784,tMb(+h[(c[g>>2]|0)+23672>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[61776]=1;i=d;return}function Epb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61928]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+536>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+536>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(61936,vMb(c[(c[g>>2]|0)+536>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[61928]=1;i=d;return}function Fpb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62152]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+532>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+532>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(62160,vMb(c[(c[g>>2]|0)+532>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[62152]=1;i=d;return}function Gpb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62376]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+528>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+528>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(62384,vMb(c[(c[g>>2]|0)+528>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[62376]=1;i=d;return}function Hpb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62600]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+852>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+852>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(62608,vMb(c[(c[g>>2]|0)+852>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=143056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[62600]=1;i=d;return}function Ipb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62952]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(62960,tMb(+h[(c[g>>2]|0)+23640>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[62952]=1;i=d;return}function Jpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63072]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(63080,tMb(+h[(c[g>>2]|0)+23632>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[63072]=1;i=d;return}function Kpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63192]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(63200,tMb(+h[(c[g>>2]|0)+23608>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[63192]=1;i=d;return}function Lpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63320]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(63328,tMb(+h[(c[g>>2]|0)+23600>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[63320]=1;i=d;return}function Mpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63448]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(63456,tMb(+h[(c[g>>2]|0)+23576>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[63448]=1;i=d;return}function Npb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63584]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(63592,tMb(+h[(c[g>>2]|0)+23568>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[63584]=1;i=d;return}function Opb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63712]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(63720,tMb(+h[(c[g>>2]|0)+23544>>3],24152)|0)|0;g=c[69978]|0;j=e;k=143968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[63712]=1;i=d;return}function Ppb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63840]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(63848,tMb(+h[(c[g>>2]|0)+23536>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[63840]=1;i=d;return}function Qpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63968]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(63976,tMb(+h[(c[g>>2]|0)+23528>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[63968]=1;i=d;return}function Rpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64096]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(64104,tMb(+h[(c[g>>2]|0)+23520>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144416;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[64096]=1;i=d;return}function Spb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64216]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(64224,tMb(+h[(c[g>>2]|0)+23504>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[64216]=1;i=d;return}function Tpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64352]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(64360,tMb(+h[(c[g>>2]|0)+23496>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[64352]=1;i=d;return}function Upb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64488]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(64496,tMb(+h[(c[g>>2]|0)+23488>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[64488]=1;i=d;return}function Vpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64624]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(64632,tMb(+h[(c[g>>2]|0)+23480>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[64624]=1;i=d;return}function Wpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64744]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(64752,tMb(+h[(c[g>>2]|0)+23416>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[64744]=1;i=d;return}function Xpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64888]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(64896,tMb(+h[(c[g>>2]|0)+23408>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[64888]=1;i=d;return}function Ypb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65016]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(65024,tMb(+h[(c[g>>2]|0)+23400>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[65016]=1;i=d;return}function Zpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65144]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(65152,tMb(+h[(c[g>>2]|0)+23392>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[65144]=1;i=d;return}function _pb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65304]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(65312,tMb(+h[(c[g>>2]|0)+23384>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[65304]=1;i=d;return}function $pb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65456]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+524>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+524>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(65464,vMb(c[(c[g>>2]|0)+524>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[65456]=1;i=d;return}function aqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65688]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+520>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+520>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(65696,vMb(c[(c[g>>2]|0)+520>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[65688]=1;i=d;return}function bqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65920]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+516>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+516>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(65928,vMb(c[(c[g>>2]|0)+516>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[65920]=1;i=d;return}function cqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66152]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+512>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+512>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(66160,vMb(c[(c[g>>2]|0)+512>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[66152]=1;i=d;return}function dqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66368]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+508>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+508>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(66376,vMb(c[(c[g>>2]|0)+508>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[66368]=1;i=d;return}function eqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66584]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+504>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+504>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(66592,vMb(c[(c[g>>2]|0)+504>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[66584]=1;i=d;return}function fqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66800]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23376>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(66808,tMb(+h[(c[g>>2]|0)+23376>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[66800]=1;i=d;return}function gqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66952]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23368>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(66960,tMb(+h[(c[g>>2]|0)+23368>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[66952]=1;i=d;return}function hqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67104]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23360>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(67112,tMb(+h[(c[g>>2]|0)+23360>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[67104]=1;i=d;return}function iqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67256]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(67264,tMb(+h[(c[g>>2]|0)+23352>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[67256]=1;i=d;return}function jqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67392]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(67400,tMb(+h[(c[g>>2]|0)+23344>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[67392]=1;i=d;return}function kqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67528]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(67536,tMb(+h[(c[g>>2]|0)+23336>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[67528]=1;i=d;return}function lqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67664]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(67672,tMb(+h[(c[g>>2]|0)+23328>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[67664]=1;i=d;return}function mqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67792]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(67800,tMb(+h[(c[g>>2]|0)+23312>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[67792]=1;i=d;return}function nqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67952]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(67960,tMb(+h[(c[g>>2]|0)+23304>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[67952]=1;i=d;return}function oqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68112]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+500>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+500>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(68120,vMb(c[(c[g>>2]|0)+500>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[68112]=1;i=d;return}function pqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68328]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+496>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+496>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(68336,vMb(c[(c[g>>2]|0)+496>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[68328]=1;i=d;return}function qqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68544]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+492>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+492>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(68552,vMb(c[(c[g>>2]|0)+492>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[68544]=1;i=d;return}function rqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68760]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+488>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+488>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(68768,vMb(c[(c[g>>2]|0)+488>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[68760]=1;i=d;return}function sqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68960]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+484>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+484>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(68968,vMb(c[(c[g>>2]|0)+484>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[68960]=1;i=d;return}function tqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69160]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+480>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+480>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(69168,vMb(c[(c[g>>2]|0)+480>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[69160]=1;i=d;return}function uqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69360]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23272>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(69368,tMb(+h[(c[g>>2]|0)+23272>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[69360]=1;i=d;return}function vqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69504]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23264>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(69512,tMb(+h[(c[g>>2]|0)+23264>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[69504]=1;i=d;return}function wqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69648]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23256>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(69656,tMb(+h[(c[g>>2]|0)+23256>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[69648]=1;i=d;return}function xqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69792]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(69800,tMb(+h[(c[g>>2]|0)+23248>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[69792]=1;i=d;return}function yqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69920]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(69928,tMb(+h[(c[g>>2]|0)+23240>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[69920]=1;i=d;return}function zqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70048]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(70056,tMb(+h[(c[g>>2]|0)+23232>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[70048]=1;i=d;return}function Aqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70176]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(70184,tMb(+h[(c[g>>2]|0)+23224>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[70176]=1;i=d;return}function Bqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70296]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(70304,tMb(+h[(c[g>>2]|0)+23216>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[70296]=1;i=d;return}function Cqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70432]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(70440,tMb(+h[(c[g>>2]|0)+23208>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[70432]=1;i=d;return}function Dqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70552]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(70560,tMb(+h[(c[g>>2]|0)+23200>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[70552]=1;i=d;return}function Eqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70672]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(70680,tMb(+h[(c[g>>2]|0)+23192>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[70672]=1;i=d;return}function Fqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70824]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(70832,tMb(+h[(c[g>>2]|0)+23184>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[70824]=1;i=d;return}function Gqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70976]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+476>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+476>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(70984,vMb(c[(c[g>>2]|0)+476>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[70976]=1;i=d;return}function Hqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71200]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+472>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+472>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(71208,vMb(c[(c[g>>2]|0)+472>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[71200]=1;i=d;return}function Iqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71424]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+468>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+468>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(71432,vMb(c[(c[g>>2]|0)+468>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[71424]=1;i=d;return}function Jqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71648]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+464>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+464>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(71656,vMb(c[(c[g>>2]|0)+464>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[71648]=1;i=d;return}function Kqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71856]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+460>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+460>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(71864,vMb(c[(c[g>>2]|0)+460>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[71856]=1;i=d;return}function Lqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72064]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+456>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+456>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(72072,vMb(c[(c[g>>2]|0)+456>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[72064]=1;i=d;return}function Mqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72272]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23176>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(72280,tMb(+h[(c[g>>2]|0)+23176>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[72272]=1;i=d;return}function Nqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72424]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23168>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(72432,tMb(+h[(c[g>>2]|0)+23168>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[72424]=1;i=d;return}function Oqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72576]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23160>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(72584,tMb(+h[(c[g>>2]|0)+23160>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[72576]=1;i=d;return}function Pqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72728]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23152>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(72736,tMb(+h[(c[g>>2]|0)+23152>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[72728]=1;i=d;return}function Qqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72856]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23144>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(72864,tMb(+h[(c[g>>2]|0)+23144>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[72856]=1;i=d;return}function Rqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72984]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(72992,tMb(+h[(c[g>>2]|0)+23136>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[72984]=1;i=d;return}function Sqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73112]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(73120,tMb(+h[(c[g>>2]|0)+23128>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[73112]=1;i=d;return}function Tqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73232]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(73240,tMb(+h[(c[g>>2]|0)+23112>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[73232]=1;i=d;return}function Uqb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73392]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(73400,tMb(+h[(c[g>>2]|0)+23104>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[73392]=1;i=d;return}function Vqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73544]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+452>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+452>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(73552,vMb(c[(c[g>>2]|0)+452>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[73544]=1;i=d;return}function Wqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73752]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+448>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+448>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(73760,vMb(c[(c[g>>2]|0)+448>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[73752]=1;i=d;return}function Xqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73960]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+444>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+444>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(73968,vMb(c[(c[g>>2]|0)+444>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[73960]=1;i=d;return}function Yqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74168]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+440>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+440>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(74176,vMb(c[(c[g>>2]|0)+440>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[74168]=1;i=d;return}function Zqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74360]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+436>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+436>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(74368,vMb(c[(c[g>>2]|0)+436>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[74360]=1;i=d;return}function _qb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74552]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+432>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+432>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(74560,vMb(c[(c[g>>2]|0)+432>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[74552]=1;i=d;return}function $qb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74744]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23072>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(74752,tMb(+h[(c[g>>2]|0)+23072>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[74744]=1;i=d;return}function arb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74880]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23064>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(74888,tMb(+h[(c[g>>2]|0)+23064>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[74880]=1;i=d;return}function brb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75016]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23056>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(75024,tMb(+h[(c[g>>2]|0)+23056>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[75016]=1;i=d;return}function crb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75152]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(75160,tMb(+h[(c[g>>2]|0)+23048>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[75152]=1;i=d;return}function drb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75272]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(75280,tMb(+h[(c[g>>2]|0)+23040>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[75272]=1;i=d;return}function erb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75392]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(75400,tMb(+h[(c[g>>2]|0)+23032>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[75392]=1;i=d;return}function frb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75512]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(75520,tMb(+h[(c[g>>2]|0)+23024>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[75512]=1;i=d;return}function grb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75624]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(75632,tMb(+h[(c[g>>2]|0)+22992>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[75624]=1;i=d;return}function hrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75744]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(75752,tMb(+h[(c[g>>2]|0)+22976>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[75744]=1;i=d;return}function irb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75880]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(75888,tMb(+h[(c[g>>2]|0)+22968>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[75880]=1;i=d;return}function jrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76024]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(76032,tMb(+h[(c[g>>2]|0)+22960>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[76024]=1;i=d;return}function krb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76184]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(76192,tMb(+h[(c[g>>2]|0)+22952>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[76184]=1;i=d;return}function lrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76344]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(76352,tMb(+h[(c[g>>2]|0)+22928>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[76344]=1;i=d;return}function mrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76512]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(76520,tMb(+h[(c[g>>2]|0)+22920>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[76512]=1;i=d;return}function nrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76680]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(76688,tMb(+h[(c[g>>2]|0)+22912>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[76680]=1;i=d;return}function orb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76848]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(76856,tMb(+h[(c[g>>2]|0)+22904>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[76848]=1;i=d;return}function prb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77032]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(77040,tMb(+h[(c[g>>2]|0)+22896>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[77032]=1;i=d;return}function qrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77208]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(77216,tMb(+h[(c[g>>2]|0)+22888>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[77208]=1;i=d;return}function rrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77384]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(77392,tMb(+h[(c[g>>2]|0)+22872>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[77384]=1;i=d;return}function srb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77560]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(77568,tMb(+h[(c[g>>2]|0)+22864>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[77560]=1;i=d;return}function trb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77736]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(77744,tMb(+h[(c[g>>2]|0)+22832>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[77736]=1;i=d;return}function urb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77896]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(77904,tMb(+h[(c[g>>2]|0)+22824>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[77896]=1;i=d;return}function vrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78056]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(78064,tMb(+h[(c[g>>2]|0)+22816>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[78056]=1;i=d;return}function wrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78216]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(78224,tMb(+h[(c[g>>2]|0)+22808>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[78216]=1;i=d;return}function xrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78376]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(78384,tMb(+h[(c[g>>2]|0)+22800>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[78376]=1;i=d;return}function yrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78544]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22792>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(78552,tMb(+h[(c[g>>2]|0)+22792>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[78544]=1;i=d;return}function zrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78712]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(78720,tMb(+h[(c[g>>2]|0)+22784>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[78712]=1;i=d;return}function Arb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78864]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22776>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(78872,tMb(+h[(c[g>>2]|0)+22776>>3],24152)|0)|0;g=c[69978]|0;j=e;k=139056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[78864]=1;i=d;return}function Brb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79032]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+848>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+848>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=xMb(79040,vMb(c[(c[g>>2]|0)+848>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=139528;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[79032]=1;i=d;return}function Crb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79480]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+844>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+844>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=xMb(79488,vMb(c[(c[g>>2]|0)+844>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=139944;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[79480]=1;i=d;return}function Drb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79872]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22752>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(79880,tMb(+h[(c[g>>2]|0)+22752>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[79872]=1;i=d;return}function Erb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80008]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22744>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(80016,tMb(+h[(c[g>>2]|0)+22744>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[80008]=1;i=d;return}function Frb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80160]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(80168,tMb(+h[(c[g>>2]|0)+22736>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[80160]=1;i=d;return}function Grb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80312]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(80320,tMb(+h[(c[g>>2]|0)+22688>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[80312]=1;i=d;return}function Hrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80448]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(80456,tMb(+h[(c[g>>2]|0)+22680>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[80448]=1;i=d;return}function Irb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80584]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+428>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+428>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(80592,vMb(c[(c[g>>2]|0)+428>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[80584]=1;i=d;return}function Jrb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80776]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+424>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+424>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(80784,vMb(c[(c[g>>2]|0)+424>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[80776]=1;i=d;return}function Krb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80968]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+420>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+420>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(80976,vMb(c[(c[g>>2]|0)+420>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[80968]=1;i=d;return}function Lrb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81160]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+840>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+840>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(81168,vMb(c[(c[g>>2]|0)+840>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=143056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[81160]=1;i=d;return}function Mrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81488]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(81496,tMb(+h[(c[g>>2]|0)+22648>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[81488]=1;i=d;return}function Nrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81640]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(81648,tMb(+h[(c[g>>2]|0)+22640>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[81640]=1;i=d;return}function Orb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81792]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+416>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+416>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(81800,vMb(c[(c[g>>2]|0)+416>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[81792]=1;i=d;return}function Prb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82016]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+412>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+412>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(82024,vMb(c[(c[g>>2]|0)+412>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[82016]=1;i=d;return}function Qrb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82240]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+408>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+408>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(82248,vMb(c[(c[g>>2]|0)+408>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[82240]=1;i=d;return}function Rrb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82464]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+836>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+836>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(82472,vMb(c[(c[g>>2]|0)+836>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=143056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[82464]=1;i=d;return}function Srb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82816]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(82824,tMb(+h[(c[g>>2]|0)+22608>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[82816]=1;i=d;return}function Trb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82936]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(82944,tMb(+h[(c[g>>2]|0)+22600>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[82936]=1;i=d;return}function Urb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83056]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(83064,tMb(+h[(c[g>>2]|0)+22576>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[83056]=1;i=d;return}function Vrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83184]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(83192,tMb(+h[(c[g>>2]|0)+22568>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[83184]=1;i=d;return}function Wrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83312]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(83320,tMb(+h[(c[g>>2]|0)+22544>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[83312]=1;i=d;return}function Xrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83448]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(83456,tMb(+h[(c[g>>2]|0)+22536>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[83448]=1;i=d;return}function Yrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83576]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(83584,tMb(+h[(c[g>>2]|0)+22512>>3],24152)|0)|0;g=c[69978]|0;j=e;k=143968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[83576]=1;i=d;return}function Zrb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83704]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(83712,tMb(+h[(c[g>>2]|0)+22504>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[83704]=1;i=d;return}function _rb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83832]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(83840,tMb(+h[(c[g>>2]|0)+22496>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[83832]=1;i=d;return}function $rb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83960]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(83968,tMb(+h[(c[g>>2]|0)+22488>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144416;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[83960]=1;i=d;return}function asb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84080]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(84088,tMb(+h[(c[g>>2]|0)+22472>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[84080]=1;i=d;return}function bsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84216]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(84224,tMb(+h[(c[g>>2]|0)+22464>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[84216]=1;i=d;return}function csb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84352]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(84360,tMb(+h[(c[g>>2]|0)+22456>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[84352]=1;i=d;return}function dsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84488]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(84496,tMb(+h[(c[g>>2]|0)+22448>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[84488]=1;i=d;return}function esb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84608]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(84616,tMb(+h[(c[g>>2]|0)+22384>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[84608]=1;i=d;return}function fsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84752]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(84760,tMb(+h[(c[g>>2]|0)+22376>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[84752]=1;i=d;return}function gsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84880]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(84888,tMb(+h[(c[g>>2]|0)+22368>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[84880]=1;i=d;return}function hsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85008]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(85016,tMb(+h[(c[g>>2]|0)+22360>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[85008]=1;i=d;return}function isb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85168]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(85176,tMb(+h[(c[g>>2]|0)+22352>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[85168]=1;i=d;return}function jsb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85320]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+404>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+404>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(85328,vMb(c[(c[g>>2]|0)+404>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[85320]=1;i=d;return}function ksb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85552]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+400>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+400>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(85560,vMb(c[(c[g>>2]|0)+400>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[85552]=1;i=d;return}function lsb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85784]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+396>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+396>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(85792,vMb(c[(c[g>>2]|0)+396>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[85784]=1;i=d;return}function msb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86016]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+392>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+392>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(86024,vMb(c[(c[g>>2]|0)+392>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[86016]=1;i=d;return}function nsb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86232]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+388>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+388>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(86240,vMb(c[(c[g>>2]|0)+388>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[86232]=1;i=d;return}function osb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86448]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+384>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+384>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(86456,vMb(c[(c[g>>2]|0)+384>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[86448]=1;i=d;return}function psb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86664]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22344>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(86672,tMb(+h[(c[g>>2]|0)+22344>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[86664]=1;i=d;return}function qsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86816]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22336>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(86824,tMb(+h[(c[g>>2]|0)+22336>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[86816]=1;i=d;return}function rsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86968]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22328>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(86976,tMb(+h[(c[g>>2]|0)+22328>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[86968]=1;i=d;return}function ssb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87120]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(87128,tMb(+h[(c[g>>2]|0)+22320>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[87120]=1;i=d;return}function tsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87256]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(87264,tMb(+h[(c[g>>2]|0)+22312>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[87256]=1;i=d;return}function usb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87392]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(87400,tMb(+h[(c[g>>2]|0)+22304>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[87392]=1;i=d;return}function vsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87528]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(87536,tMb(+h[(c[g>>2]|0)+22296>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[87528]=1;i=d;return}function wsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87656]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(87664,tMb(+h[(c[g>>2]|0)+22280>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[87656]=1;i=d;return}function xsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87816]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(87824,tMb(+h[(c[g>>2]|0)+22272>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[87816]=1;i=d;return}function ysb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87976]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+380>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+380>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(87984,vMb(c[(c[g>>2]|0)+380>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[87976]=1;i=d;return}function zsb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88192]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+376>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+376>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(88200,vMb(c[(c[g>>2]|0)+376>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[88192]=1;i=d;return}function Asb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88408]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+372>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+372>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(88416,vMb(c[(c[g>>2]|0)+372>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[88408]=1;i=d;return}function Bsb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88624]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+368>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+368>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(88632,vMb(c[(c[g>>2]|0)+368>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[88624]=1;i=d;return}function Csb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88824]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+364>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+364>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(88832,vMb(c[(c[g>>2]|0)+364>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[88824]=1;i=d;return}function Dsb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89024]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+360>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+360>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(89032,vMb(c[(c[g>>2]|0)+360>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[89024]=1;i=d;return}function Esb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89224]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22240>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(89232,tMb(+h[(c[g>>2]|0)+22240>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[89224]=1;i=d;return}function Fsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89368]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22232>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(89376,tMb(+h[(c[g>>2]|0)+22232>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[89368]=1;i=d;return}function Gsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89512]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22224>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(89520,tMb(+h[(c[g>>2]|0)+22224>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[89512]=1;i=d;return}function Hsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89656]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(89664,tMb(+h[(c[g>>2]|0)+22216>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[89656]=1;i=d;return}function Isb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89784]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(89792,tMb(+h[(c[g>>2]|0)+22208>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[89784]=1;i=d;return}function Jsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89912]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(89920,tMb(+h[(c[g>>2]|0)+22200>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[89912]=1;i=d;return}function Ksb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90040]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(90048,tMb(+h[(c[g>>2]|0)+22192>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[90040]=1;i=d;return}function Lsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90160]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(90168,tMb(+h[(c[g>>2]|0)+22184>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[90160]=1;i=d;return}function Msb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90296]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(90304,tMb(+h[(c[g>>2]|0)+22176>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[90296]=1;i=d;return}function Nsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90416]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(90424,tMb(+h[(c[g>>2]|0)+22168>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[90416]=1;i=d;return}function Osb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90536]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(90544,tMb(+h[(c[g>>2]|0)+22160>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[90536]=1;i=d;return}function Psb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90688]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22152>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(90696,tMb(+h[(c[g>>2]|0)+22152>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[90688]=1;i=d;return}function Qsb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90840]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+356>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+356>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(90848,vMb(c[(c[g>>2]|0)+356>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[90840]=1;i=d;return}function Rsb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91064]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+352>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+352>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(91072,vMb(c[(c[g>>2]|0)+352>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[91064]=1;i=d;return}function Ssb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91288]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+348>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+348>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(91296,vMb(c[(c[g>>2]|0)+348>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[91288]=1;i=d;return}function Tsb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91512]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+344>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+344>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(91520,vMb(c[(c[g>>2]|0)+344>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[91512]=1;i=d;return}function Usb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91720]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+340>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+340>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(91728,vMb(c[(c[g>>2]|0)+340>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[91720]=1;i=d;return}function Vsb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91928]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+336>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+336>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(91936,vMb(c[(c[g>>2]|0)+336>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[91928]=1;i=d;return}function Wsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92136]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22144>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(92144,tMb(+h[(c[g>>2]|0)+22144>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[92136]=1;i=d;return}function Xsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92288]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22136>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(92296,tMb(+h[(c[g>>2]|0)+22136>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[92288]=1;i=d;return}function Ysb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92440]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22128>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(92448,tMb(+h[(c[g>>2]|0)+22128>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[92440]=1;i=d;return}function Zsb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92592]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(92600,tMb(+h[(c[g>>2]|0)+22120>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[92592]=1;i=d;return}function _sb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92720]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(92728,tMb(+h[(c[g>>2]|0)+22112>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[92720]=1;i=d;return}function $sb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92848]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(92856,tMb(+h[(c[g>>2]|0)+22104>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[92848]=1;i=d;return}function atb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92976]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+22096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(92984,tMb(+h[(c[g>>2]|0)+22096>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[92976]=1;i=d;return}



function Fe(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Ge(){return i|0}function He(a){a=a|0;i=a}function Ie(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Je(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Ke(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Le(a){a=a|0;J=a}function Me(a){a=a|0;K=a}function Ne(a){a=a|0;L=a}function Oe(a){a=a|0;M=a}function Pe(a){a=a|0;N=a}function Qe(a){a=a|0;O=a}function Re(a){a=a|0;P=a}function Se(a){a=a|0;Q=a}function Te(a){a=a|0;R=a}function Ue(a){a=a|0;S=a}function Ve(a){a=a|0;var b=0,d=0;b=i;TPb(a)|0;d=a+540|0;ge[c[(c[d>>2]|0)+40>>2]&127](a)|0;ge[c[(c[d>>2]|0)+28>>2]&127](a)|0;ge[c[(c[d>>2]|0)+32>>2]&127](a)|0;ge[c[(c[d>>2]|0)+48>>2]&127](a)|0;ge[c[(c[d>>2]|0)+52>>2]&127](a)|0;KOb(a);i=b;return}function We(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=Eec(B|0)|0;D=aec(C+11|0)|0;Pec(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=gc(D|0,32)|0;if((C|0)==0){B=Ud(c[(Lc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;XLb(23,0,40,u);Wc(0)|0;F=0}else{F=C}bec(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}ye[c[234460>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{pNb(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}pNb(2);oNb(2)}dNb(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];VLb(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];xOb(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];VLb(23,1,144,r);Z=BPb(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}Ve(b);LOb(b);if((c[233652>>2]|0)!=0){de[c[58528]&511](23)}if((c[2]|0)!=0){oNb(4)}A=zOb(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];VLb(7,1,200,q);if((c[287620>>2]|0)==0){ee[c[272308>>2]&63](272288,b)}BOb(b,c[J>>2]|0,z,d);if((c[233588>>2]|0)!=0){de[c[58528]&511](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;POb(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){rNb(4)}if((NPb(b,1,1)|0)!=0){c[B>>2]=1;POb(b)}ge[c[(c[K>>2]|0)+88>>2]&127](b)|0;KOb(b);TOb(b);LOb(b);do{if((T|0)==0){_=0}else{oNb(7);rNb(2);A=(pc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(pc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+jNb(2);if(!$){aa=0;break}aa=(pc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+jNb(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=eNb(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(pc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+jNb(ba+9|0);if((ca|0)==0){ka=0}else{ka=(pc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}rNb(7);if((la|0)!=0){_=T;break}c[p>>2]=Ud(c[(Lc()|0)>>2]|0)|0;XLb(23,0,240,p);Wc(T|0)|0;_=0}}while(0);if((c[287620>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;ee[c[272308>>2]&63](272288,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[69472]|0)!=0){ca=f;ba=277896;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];NLb(M,f);Qd(10,M|0)|0;ba=c[69480]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;VLb(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((wPb(b,0)|0)!=0){ma=58;break}if((nPb(b,0)|0)!=0){ma=58;break}if((dPb(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];VLb(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((wPb(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];VLb(1,0,448,m);U=_;V=-2;break}if((nPb(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];VLb(1,0,536,l);U=_;V=-3;break}T=(dPb(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];VLb(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];VLb(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}Wc(U|0)|0;i=e;return V|0}function Xe(a){a=a|0;i=i;return 0}function Ye(a){a=a|0;i=i;return 0}function Ze(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+436>>2]|0;h[d>>3]=+h[b+20480>>3];h[d+8>>3]=+h[b+20488>>3];h[d+16>>3]=+h[b+20496>>3];i=i;return 0}function _e(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20496>>3]=+h[b+16>>3]*9.549296585513721;i=i;return}function $e(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+24>>3]));h[b+5040>>3]=-(d*+h[b+16>>3]);i=i;return}function af(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+24>>3]));h[b+5048>>3]=d*+h[b+16>>3];i=i;return}function bf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+24>>3]));h[b+5056>>3]=-(d*+h[b+16>>3]);i=i;return}function cf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4464>>3]=+h[b+5040>>3]*.8660254037844387+ +h[b+5056>>3]*-.4999999999999999;i=i;return}function df(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4480>>3]=+h[b+5040>>3]*.4999999999999999+ +h[b+5056>>3]*.8660254037844387;i=i;return}function ef(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4536>>3]=+h[b+5040>>3]*6.123233995736766e-17+ +h[b+5056>>3];i=i;return}function ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4552>>3]=+h[b+5056>>3]*6.123233995736766e-17- +h[b+5040>>3];i=i;return}function gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4608>>3]=+h[b+5040>>3]*-.8660254037844386+ +h[b+5056>>3]*-.5000000000000001;i=i;return}function hf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4624>>3]=+h[b+5040>>3]*.5000000000000001+ +h[b+5056>>3]*-.8660254037844386;i=i;return}function jf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4680>>3]=+h[b+5040>>3]*-.8660254037844386+ +h[b+5056>>3]*-.5000000000000001;i=i;return}function kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4696>>3]=+h[b+5040>>3]*.5000000000000001+ +h[b+5056>>3]*-.8660254037844386;i=i;return}function lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4752>>3]=+h[b+5040>>3]*6.123233995736766e-17+ +h[b+5056>>3];i=i;return}function mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4768>>3]=+h[b+5056>>3]*6.123233995736766e-17- +h[b+5040>>3];i=i;return}function nf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4824>>3]=+h[b+5040>>3]*.8660254037844387+ +h[b+5056>>3]*-.4999999999999999;i=i;return}function of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4840>>3]=+h[b+5040>>3]*.4999999999999999+ +h[b+5056>>3]*.8660254037844387;i=i;return}function pf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+24>>3]));h[b+5064>>3]=-(d*+h[b+16>>3]);i=i;return}function qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4472>>3]=+h[b+5048>>3]*.8660254037844387+ +h[b+5064>>3]*-.4999999999999999;i=i;return}function rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4488>>3]=+h[b+5048>>3]*.4999999999999999+ +h[b+5064>>3]*.8660254037844387;i=i;return}function sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4544>>3]=+h[b+5048>>3]*6.123233995736766e-17+ +h[b+5064>>3];i=i;return}function tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4560>>3]=+h[b+5064>>3]*6.123233995736766e-17- +h[b+5048>>3];i=i;return}function uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4616>>3]=+h[b+5048>>3]*-.8660254037844386+ +h[b+5064>>3]*-.5000000000000001;i=i;return}function vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4632>>3]=+h[b+5048>>3]*.5000000000000001+ +h[b+5064>>3]*-.8660254037844386;i=i;return}function wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4688>>3]=+h[b+5048>>3]*-.8660254037844386+ +h[b+5064>>3]*-.5000000000000001;i=i;return}function xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4704>>3]=+h[b+5048>>3]*.5000000000000001+ +h[b+5064>>3]*-.8660254037844386;i=i;return}function yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4760>>3]=+h[b+5048>>3]*6.123233995736766e-17+ +h[b+5064>>3];i=i;return}function zf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4776>>3]=+h[b+5064>>3]*6.123233995736766e-17- +h[b+5048>>3];i=i;return}function Af(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4832>>3]=+h[b+5048>>3]*.8660254037844387+ +h[b+5064>>3]*-.4999999999999999;i=i;return}function Bf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4848>>3]=+h[b+5048>>3]*.4999999999999999+ +h[b+5064>>3]*.8660254037844387;i=i;return}function Cf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+56>>3]=+h[b+16>>3];i=i;return}function Df(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0.0,q=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+25504>>3];j=b+4|0;k=c[c[j>>2]>>2]|0;l=c[k+8>>2]|0;m=+h[l+16>>3];do{if(g!=0.0){n=l;o=f;p=m/g}else{if(m==0.0){n=l;o=f;p=m;break}q=m/+$Lb(c[b+536>>2]|0,g,880,872,+h[k>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[j>>2]>>2]|0)+8>>2]|0;o=c[e>>2]|0;p=q}}while(0);h[n+19504>>3]=p*p*+h[o+25496>>3];i=d;return}function Ef(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+40>>3]=(+h[b>>3]- +h[b+8>>3])*+h[(c[a+416>>2]|0)+25536>>3];i=i;return}function Ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20480>>3]=+h[b+8>>3];i=i;return}function Gf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+24976>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+10256>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7944|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7944|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,904,896,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7944|0;p=o;h[p>>3]=m;i=d;return}function Hf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+23944>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+10136>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7712|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7712|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,968,960,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7712|0;p=o;h[p>>3]=m;i=d;return}function If(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+22912>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+10016>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7528|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7528|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1032,1024,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7528|0;p=o;h[p>>3]=m;i=d;return}function Jf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+21880>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+9896>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7344|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7344|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1096,1088,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7344|0;p=o;h[p>>3]=m;i=d;return}function Kf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+20848>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+9776>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7160|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7160|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1160,1152,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7160|0;p=o;h[p>>3]=m;i=d;return}function Lf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19816>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+9656>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+6976|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+6976|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1224,1216,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6976|0;p=o;h[p>>3]=m;i=d;return}function Mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+16232>>3]=+X(+(+h[b+24>>3]));i=i;return}function Nf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+16224>>3]=-+Y(+(+h[b+24>>3]));i=i;return}function Of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+16208>>3]=+Y(+(+h[b+24>>3]));i=i;return}function Pf(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+4280>>3]=+h[b+16208>>3]*+h[d+272>>3]+ +h[b+16232>>3]*+h[d+280>>3];i=i;return}function Qf(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10488>>3]=+h[b+4280>>3]+(+h[b+16208>>3]*+h[d+832>>3]+ +h[b+16232>>3]*+h[d+840>>3]);i=i;return}function Rf(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9768>>3]=+h[b+4280>>3]+(+h[b+16208>>3]*+h[d+1408>>3]+ +h[b+16232>>3]*+h[d+1416>>3]);i=i;return}function Sf(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10464>>3]=+h[b+10488>>3]+(+h[b+16208>>3]*+h[d+3848>>3]+ +h[b+16232>>3]*+h[d+3856>>3]);i=i;return}function Tf(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9888>>3]=+h[b+10488>>3]+(+h[b+16208>>3]*+h[d+4424>>3]+ +h[b+16232>>3]*+h[d+4432>>3]);i=i;return}function Uf(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10440>>3]=+h[b+10464>>3]+(+h[b+16208>>3]*+h[d+6864>>3]+ +h[b+16232>>3]*+h[d+6872>>3]);i=i;return}function Vf(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10008>>3]=+h[b+10464>>3]+(+h[b+16208>>3]*+h[d+7440>>3]+ +h[b+16232>>3]*+h[d+7448>>3]);i=i;return}function Wf(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10416>>3]=+h[b+10440>>3]+(+h[b+16208>>3]*+h[d+9880>>3]+ +h[b+16232>>3]*+h[d+9888>>3]);i=i;return}function Xf(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10128>>3]=+h[b+10440>>3]+(+h[b+16208>>3]*+h[d+10456>>3]+ +h[b+16232>>3]*+h[d+10464>>3]);i=i;return}function Yf(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10392>>3]=+h[b+10416>>3]+(+h[b+16208>>3]*+h[d+12896>>3]+ +h[b+16232>>3]*+h[d+12904>>3]);i=i;return}function Zf(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10248>>3]=+h[b+10416>>3]+(+h[b+16208>>3]*+h[d+13472>>3]+ +h[b+16232>>3]*+h[d+13480>>3]);i=i;return}function _f(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10368>>3]=+h[b+10392>>3]+(+h[b+16208>>3]*+h[d+16488>>3]+ +h[b+16232>>3]*+h[d+16496>>3]);i=i;return}function $f(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9632>>3]=+h[b+16232>>3]*d*+h[e+272>>3]- +h[b+16208>>3]*d*+h[e+280>>3];i=i;return}function ag(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9584>>3]=+h[b+9632>>3]+(+h[b+16232>>3]*d*+h[e+832>>3]- +h[b+16208>>3]*d*+h[e+840>>3]);i=i;return}function bg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9536>>3]=+h[b+9632>>3]+(+h[b+16232>>3]*d*+h[e+1408>>3]- +h[b+16208>>3]*d*+h[e+1416>>3]);i=i;return}function cg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14816>>3]=+h[b+16208>>3]*.8660254037844387+ +h[b+16232>>3]*-.4999999999999999;i=i;return}function dg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14800>>3]=+h[b+16208>>3]*.4999999999999999+ +h[b+16232>>3]*.8660254037844387;i=i;return}function eg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9496>>3]=+h[b+9536>>3]+(+h[b+14800>>3]*d*+h[e+928>>3]- +h[b+14816>>3]*d*+h[e+936>>3]);i=i;return}function fg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9744>>3]=+h[b+9768>>3]+(+h[b+14816>>3]*+h[d+928>>3]+ +h[b+14800>>3]*+h[d+936>>3]);i=i;return}function gg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9328>>3]=+h[b+9584>>3]+(+h[b+16232>>3]*d*+h[e+3848>>3]- +h[b+16208>>3]*d*+h[e+3856>>3]);i=i;return}function hg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9256>>3]=+h[b+9584>>3]+(+h[b+16232>>3]*d*+h[e+4424>>3]- +h[b+16208>>3]*d*+h[e+4432>>3]);i=i;return}function ig(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14864>>3]=+h[b+16208>>3]*6.123233995736766e-17+ +h[b+16232>>3];i=i;return}function jg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14848>>3]=+h[b+16232>>3]*6.123233995736766e-17- +h[b+16208>>3];i=i;return}function kg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9216>>3]=+h[b+9256>>3]+(+h[b+14848>>3]*d*+h[e+3944>>3]- +h[b+14864>>3]*d*+h[e+3952>>3]);i=i;return}function lg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9864>>3]=+h[b+9888>>3]+(+h[b+14864>>3]*+h[d+3944>>3]+ +h[b+14848>>3]*+h[d+3952>>3]);i=i;return}function mg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9048>>3]=+h[b+9328>>3]+(+h[b+16232>>3]*d*+h[e+6864>>3]- +h[b+16208>>3]*d*+h[e+6872>>3]);i=i;return}function ng(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8976>>3]=+h[b+9328>>3]+(+h[b+16232>>3]*d*+h[e+7440>>3]- +h[b+16208>>3]*d*+h[e+7448>>3]);i=i;return}function og(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14912>>3]=+h[b+16208>>3]*-.8660254037844386+ +h[b+16232>>3]*-.5000000000000001;i=i;return}function pg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14896>>3]=+h[b+16208>>3]*.5000000000000001+ +h[b+16232>>3]*-.8660254037844386;i=i;return}function qg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8936>>3]=+h[b+8976>>3]+(+h[b+14896>>3]*d*+h[e+6960>>3]- +h[b+14912>>3]*d*+h[e+6968>>3]);i=i;return}function rg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9984>>3]=+h[b+10008>>3]+(+h[b+14912>>3]*+h[d+6960>>3]+ +h[b+14896>>3]*+h[d+6968>>3]);i=i;return}function sg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8768>>3]=+h[b+9048>>3]+(+h[b+16232>>3]*d*+h[e+9880>>3]- +h[b+16208>>3]*d*+h[e+9888>>3]);i=i;return}function tg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8696>>3]=+h[b+9048>>3]+(+h[b+16232>>3]*d*+h[e+10456>>3]- +h[b+16208>>3]*d*+h[e+10464>>3]);i=i;return}function ug(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14960>>3]=+h[b+16208>>3]*-.8660254037844386+ +h[b+16232>>3]*-.5000000000000001;i=i;return}function vg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14944>>3]=+h[b+16208>>3]*.5000000000000001+ +h[b+16232>>3]*-.8660254037844386;i=i;return}function wg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8656>>3]=+h[b+8696>>3]+(+h[b+14944>>3]*d*+h[e+9976>>3]- +h[b+14960>>3]*d*+h[e+9984>>3]);i=i;return}function xg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10104>>3]=+h[b+10128>>3]+(+h[b+14960>>3]*+h[d+9976>>3]+ +h[b+14944>>3]*+h[d+9984>>3]);i=i;return}function yg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8488>>3]=+h[b+8768>>3]+(+h[b+16232>>3]*d*+h[e+12896>>3]- +h[b+16208>>3]*d*+h[e+12904>>3]);i=i;return}function zg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8416>>3]=+h[b+8768>>3]+(+h[b+16232>>3]*d*+h[e+13472>>3]- +h[b+16208>>3]*d*+h[e+13480>>3]);i=i;return}function Ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15008>>3]=+h[b+16208>>3]*6.123233995736766e-17+ +h[b+16232>>3];i=i;return}function Bg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14992>>3]=+h[b+16232>>3]*6.123233995736766e-17- +h[b+16208>>3];i=i;return}function Cg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8376>>3]=+h[b+8416>>3]+(+h[b+14992>>3]*d*+h[e+12992>>3]- +h[b+15008>>3]*d*+h[e+13e3>>3]);i=i;return}function Dg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10224>>3]=+h[b+10248>>3]+(+h[b+15008>>3]*+h[d+12992>>3]+ +h[b+14992>>3]*+h[d+13e3>>3]);i=i;return}function Eg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8184>>3]=+h[b+8488>>3]+(+h[b+16232>>3]*d*+h[e+16488>>3]- +h[b+16208>>3]*d*+h[e+16496>>3]);i=i;return}function Fg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15056>>3]=+h[b+16208>>3]*.8660254037844387+ +h[b+16232>>3]*-.4999999999999999;i=i;return}function Gg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15040>>3]=+h[b+16208>>3]*.4999999999999999+ +h[b+16232>>3]*.8660254037844387;i=i;return}function Hg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8144>>3]=+h[b+8184>>3]+(+h[b+15040>>3]*d*+h[e+16008>>3]- +h[b+15056>>3]*d*+h[e+16016>>3]);i=i;return}function Ig(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10344>>3]=+h[b+10368>>3]+(+h[b+15056>>3]*+h[d+16008>>3]+ +h[b+15040>>3]*+h[d+16016>>3]);i=i;return}function Jg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+7816>>3]=+h[b+10392>>3]+(+h[b+16208>>3]*+h[d+15912>>3]+ +h[b+16232>>3]*+h[d+15920>>3]);i=i;return}function Kg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+16200>>3]=+X(+(+h[b+24>>3]));i=i;return}function Lg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+4288>>3]=+h[b+16200>>3]*+h[d+272>>3]+ +h[b+16224>>3]*+h[d+280>>3];i=i;return}function Mg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10480>>3]=+h[b+4288>>3]+(+h[b+16200>>3]*+h[d+832>>3]+ +h[b+16224>>3]*+h[d+840>>3]);i=i;return}function Ng(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9760>>3]=+h[b+4288>>3]+(+h[b+16200>>3]*+h[d+1408>>3]+ +h[b+16224>>3]*+h[d+1416>>3]);i=i;return}function Og(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10456>>3]=+h[b+10480>>3]+(+h[b+16200>>3]*+h[d+3848>>3]+ +h[b+16224>>3]*+h[d+3856>>3]);i=i;return}function Pg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9880>>3]=+h[b+10480>>3]+(+h[b+16200>>3]*+h[d+4424>>3]+ +h[b+16224>>3]*+h[d+4432>>3]);i=i;return}function Qg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10432>>3]=+h[b+10456>>3]+(+h[b+16200>>3]*+h[d+6864>>3]+ +h[b+16224>>3]*+h[d+6872>>3]);i=i;return}function Rg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1e4>>3]=+h[b+10456>>3]+(+h[b+16200>>3]*+h[d+7440>>3]+ +h[b+16224>>3]*+h[d+7448>>3]);i=i;return}function Sg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10408>>3]=+h[b+10432>>3]+(+h[b+16200>>3]*+h[d+9880>>3]+ +h[b+16224>>3]*+h[d+9888>>3]);i=i;return}function Tg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10120>>3]=+h[b+10432>>3]+(+h[b+16200>>3]*+h[d+10456>>3]+ +h[b+16224>>3]*+h[d+10464>>3]);i=i;return}function Ug(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10384>>3]=+h[b+10408>>3]+(+h[b+16200>>3]*+h[d+12896>>3]+ +h[b+16224>>3]*+h[d+12904>>3]);i=i;return}function Vg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10240>>3]=+h[b+10408>>3]+(+h[b+16200>>3]*+h[d+13472>>3]+ +h[b+16224>>3]*+h[d+13480>>3]);i=i;return}function Wg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10360>>3]=+h[b+10384>>3]+(+h[b+16200>>3]*+h[d+16488>>3]+ +h[b+16224>>3]*+h[d+16496>>3]);i=i;return}function Xg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9624>>3]=+h[b+16224>>3]*d*+h[e+272>>3]- +h[b+16200>>3]*d*+h[e+280>>3];i=i;return}function Yg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9576>>3]=+h[b+9624>>3]+(+h[b+16224>>3]*d*+h[e+832>>3]- +h[b+16200>>3]*d*+h[e+840>>3]);i=i;return}function Zg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9528>>3]=+h[b+9624>>3]+(+h[b+16224>>3]*d*+h[e+1408>>3]- +h[b+16200>>3]*d*+h[e+1416>>3]);i=i;return}function _g(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14824>>3]=+h[b+16200>>3]*.8660254037844387+ +h[b+16224>>3]*-.4999999999999999;i=i;return}function $g(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14808>>3]=+h[b+16200>>3]*.4999999999999999+ +h[b+16224>>3]*.8660254037844387;i=i;return}function ah(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9488>>3]=+h[b+9528>>3]+(+h[b+14808>>3]*d*+h[e+928>>3]- +h[b+14824>>3]*d*+h[e+936>>3]);i=i;return}function bh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9456>>3]=+h[b+9488>>3]*-.4999999999999999+ +h[b+9496>>3]*-.8660254037844387;i=i;return}function ch(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9448>>3]=+h[b+9488>>3]*-.8660254037844387+ +h[b+9496>>3]*.4999999999999999;i=i;return}function dh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20888>>3]=+h[b+9448>>3]*-2.0;i=i;return}function eh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20904>>3]=+h[b+20888>>3]*.5;i=i;return}function fh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9736>>3]=+h[b+9760>>3]+(+h[b+14824>>3]*+h[d+928>>3]+ +h[b+14808>>3]*+h[d+936>>3]);i=i;return}function gh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9712>>3]=(+h[b+9736>>3]- +h[b+16104>>3])*.8660254037844387+(+h[b+9744>>3]- +h[b+16112>>3])*-.4999999999999999;i=i;return}function hh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9688>>3]=+h[b+15096>>3]- +h[b+9712>>3];i=i;return}function ih(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20456>>3]=+h[b+9688>>3]*-2.0;i=i;return}function jh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20440>>3]=+h[b+20456>>3]*.5;i=i;return}function kh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9720>>3]=(+h[b+9736>>3]- +h[b+16104>>3])*.4999999999999999+(+h[b+9744>>3]- +h[b+16112>>3])*.8660254037844387;i=i;return}function lh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9696>>3]=+h[b+15104>>3]- +h[b+9720>>3];i=i;return}function mh(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+9680>>3];e=+h[b+9688>>3];f=+h[b+9696>>3];g=+h[(c[a+416>>2]|0)+19744>>3];h[b+20448>>3]=d*d+(e*e+(f*f-g*g));i=i;return}function nh(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+20440>>3];h[b+20424>>3]=d*d- +h[b+20448>>3];i=i;return}function oh(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;bv(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20424>>3],1.0e-12);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20416>>3]=+h[d>>3];i=b;return}function ph(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+20416>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+20432|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=5064;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,1280,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+20432|0;p=o;h[p>>3]=m;i=b;return}function qh(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+20440>>3];g=+h[e+20432>>3];if((a[(c[b+424>>2]|0)+35|0]|0)!=0){j=g;k=f-j;l=e;m=l+16320|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+16320|0;n=m;h[n>>3]=k;i=d;return}function rh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3480>>3]=+h[b+16104>>3]+ +h[b+16320>>3]*.8660254037844387;i=i;return}function sh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3752>>3]=+h[b+3480>>3]+-.08660254037844388;i=i;return}function th(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10840>>3]=+h[b+3480>>3]+(+h[d+3288>>3]*-.8660254037844387+ +h[d+3296>>3]*-.4999999999999999);i=i;return}function uh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3472>>3]=+h[b+16112>>3]+ +h[b+16320>>3]*-.4999999999999999;i=i;return}function vh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3744>>3]=+h[b+3472>>3]+.05;i=i;return}function wh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9672>>3]=+h[b+3744>>3]- +h[b+9744>>3];i=i;return}function xh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10848>>3]=+h[b+3472>>3]+(+h[d+3288>>3]*.4999999999999999+ +h[d+3296>>3]*-.8660254037844387);i=i;return}function yh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20392>>3]=+h[(c[a+416>>2]|0)+19752>>3]+ +h[b+16320>>3];i=i;return}function zh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20376>>3]=+h[b+20392>>3]/.195+1.0;i=i;return}function Ah(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+20344>>3]=+h[b+19904>>3]+ +h[b+19912>>3]*(1.0- +h[d+20376>>3]);i=i;return}function Bh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20344>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+20360|0;p=o;h[p>>3]=m;i=d;return}q=+$Lb(c[b+536>>2]|0,j,1392,1384,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+20360|0;p=o;h[p>>3]=m;i=d;return}function Ch(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20368>>3]=-+h[b+20392>>3]/.195;i=i;return}function Dh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20896>>3]=(+h[b+9688>>3]*+h[b+9448>>3]+ +h[b+9696>>3]*+h[b+9456>>3])*2.0;i=i;return}function Eh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20920>>3]=+h[b+20440>>3]*+h[b+20904>>3]*2.0- +h[b+20896>>3];i=i;return}function Fh(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;av(d,c[a+536>>2]|0,+h[f+20424>>3],1.0e-12,+h[f+20920>>3],0.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20928>>3]=+h[d>>3];i=b;return}function Gh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+20416>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=5064;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,1280,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+20928>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+20912|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+20912|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,1432,1424,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+20912|0;y=x;h[y>>3]=v;i=d;return}function Hh(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+20904>>3];g=+h[e+20912>>3];if((a[(c[b+424>>2]|0)+35|0]|0)!=0){j=g;k=f-j;l=e;m=l+20328|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+20328|0;n=m;h[n>>3]=k;i=d;return}function Ih(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9368>>3]=+h[b+20328>>3]*.8660254037844387;i=i;return}function Jh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9416>>3]=+h[b+9368>>3]- +h[b+9488>>3];i=i;return}function Kh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9376>>3]=+h[b+20328>>3]*-.4999999999999999;i=i;return}function Lh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9424>>3]=+h[b+9376>>3]- +h[b+9496>>3];i=i;return}function Mh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+15|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+15|0]|0;k=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20328>>3],0.0,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=k;f=j;break}else{j=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20328>>3],0.0,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+15|0]|0;j=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20328>>3],0.0)|0;a[(c[b+352>>2]|0)+15|0]=j;f=g;break}else{g=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20328>>3],0.0)|0;a[(c[b+352>>2]|0)+15|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+17|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+17|0]|0;j=b+4|0;k=YOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20376>>3],.93,a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=k;l=j;m=e;break}else{e=b+4|0;j=YOb(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20376>>3],.93,a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+17|0]|0;j=b+4|0;e=$Ob(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20376>>3],.93)|0;a[(c[b+352>>2]|0)+17|0]=e;l=j;m=f;break}else{f=b+4|0;j=$Ob(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20376>>3],.93)|0;a[(c[b+352>>2]|0)+17|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+20376>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+20320|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+20320|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+16|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+16|0]|0;l=b+4|0;f=XOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+20376>>3],.987,a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=f;w=l;x=m;break}else{m=b+4|0;l=XOb(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+20376>>3],.987,a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+16|0]|0;l=b+4|0;m=ZOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+20376>>3],.987)|0;a[(c[b+352>>2]|0)+16|0]=m;w=l;x=j;break}else{j=b+4|0;l=ZOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20376>>3],.987)|0;a[(c[b+352>>2]|0)+16|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+20376>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+20320|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+20320|0;v=u;h[v>>3]=s;i=d;return}}}function Nh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20352>>3]=+h[b+20320>>3]*1.0e-5;i=i;return}function Oh(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+19896>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+20384>>3]=b*b*+h[d+20352>>3]*-78539.81633974482;i=i;return}function Ph(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19920>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+20320>>3]*+h[j+20344>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+20336|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+20336|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1504,1496,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+20336|0;p=o;h[p>>3]=m;i=d;return}function Qh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9664>>3]=+h[b+3752>>3]- +h[b+9736>>3];i=i;return}function Rh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3568>>3]=+h[b+14824>>3]*+h[b+9664>>3]+ +h[b+14816>>3]*+h[b+9672>>3];i=i;return}function Sh(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19816>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3568>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+3680|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+3680|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1224,1536,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3680|0;p=o;h[p>>3]=m;i=d;return}function Th(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3560>>3]=+h[b+14808>>3]*+h[b+9664>>3]+ +h[b+14800>>3]*+h[b+9672>>3];i=i;return}function Uh(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19816>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3560>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+3672|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+3672|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1224,1544,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3672|0;p=o;h[p>>3]=m;i=d;return}function Vh(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3672>>3];e=+h[b+3680>>3];h[b+20408>>3]=d*d+e*e;i=i;return}function Wh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+20408>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+20400|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=5064;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,1552,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+20400|0;p=o;h[p>>3]=m;i=b;return}function Xh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20400>>3];k=+h[g+3680>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+16040|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+16040|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,1672,1664,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+16040|0;p=o;h[p>>3]=m;i=d;return}function Yh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3600>>3]=-(+h[b+6976>>3]*+h[b+16040>>3]);i=i;return}function Zh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20400>>3];k=+h[g+3672>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+16032|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+16032|0;q=p;h[q>>3]=n;i=d;return}k=l/+$Lb(c[b+536>>2]|0,j,1672,1728,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+16032|0;q=p;h[q>>3]=n;i=d;return}function _h(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3592>>3]=+h[b+6976>>3]*+h[b+16032>>3];i=i;return}function $h(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6968>>3]=+h[b+3600>>3]*+h[b+14816>>3]+ +h[b+3592>>3]*+h[b+14800>>3];i=i;return}function ai(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7016>>3]=+h[b+16032>>3]*+h[b+14816>>3]+ +h[b+16040>>3]*+h[b+14800>>3];i=i;return}function bi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6952>>3]=+h[b+3680>>3]*+h[b+16040>>3]- +h[b+3672>>3]*+h[b+16032>>3];i=i;return}function ci(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3536>>3]=+h[b+9728>>3]+(+h[b+6952>>3]*+h[d+2648>>3]+ +h[b+6976>>3]*+h[d+2656>>3]);i=i;return}function di(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6992>>3]=+h[b+3680>>3]*+h[b+14816>>3]+ +h[b+3672>>3]*+h[b+14800>>3];i=i;return}function ei(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3552>>3]=+h[b+9744>>3]+(+h[b+6968>>3]*+h[d+2648>>3]+(+h[b+6992>>3]*+h[d+2656>>3]+ +h[b+7016>>3]*+h[d+2664>>3]));i=i;return}function fi(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19816>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+14824>>3]*+h[j+9416>>3]+(+h[j+14816>>3]*+h[j+9424>>3]+ +h[j+16>>3]*+h[j+3560>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+9392|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+9392|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1224,1736,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9392|0;p=o;h[p>>3]=m;i=d;return}function gi(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19816>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+14808>>3]*+h[j+9416>>3]+(+h[j+14800>>3]*+h[j+9424>>3]- +h[j+16>>3]*+h[j+3568>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+9400|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+9400|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1224,1744,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9400|0;p=o;h[p>>3]=m;i=d;return}function hi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3576>>3]=+h[b+16032>>3]*+h[b+9392>>3]+ +h[b+16040>>3]*+h[b+9400>>3];i=i;return}function ii(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3512>>3]=+h[b+6952>>3]*+h[b+16>>3]+ +h[b+3576>>3];i=i;return}function ji(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20400>>3];k=+h[g+3592>>3]*+h[g+9392>>3]- +h[g+3600>>3]*+h[g+9400>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3584|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3584|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,1672,1752,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3584|0;p=o;h[p>>3]=m;i=d;return}function ki(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3520>>3]=+h[b+6976>>3]*+h[b+16>>3]+ +h[b+3584>>3];i=i;return}function li(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3528>>3]=-(+h[b+3592>>3]*+h[b+9400>>3])- +h[b+3600>>3]*+h[b+9392>>3];i=i;return}function mi(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3680>>3];e=+h[b+3672>>3];h[b+20464>>3]=(+h[b+14824>>3]*d+ +h[b+14808>>3]*e)*-.8660254037844387+(d*+h[b+14816>>3]+e*+h[b+14800>>3])*.4999999999999999;i=i;return}function ni(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7008>>3]=+h[b+16032>>3]*+h[b+14824>>3]+ +h[b+16040>>3]*+h[b+14808>>3];i=i;return}function oi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6984>>3]=+h[b+3680>>3]*+h[b+14824>>3]+ +h[b+3672>>3]*+h[b+14808>>3];i=i;return}function pi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6960>>3]=+h[b+3600>>3]*+h[b+14824>>3]+ +h[b+3592>>3]*+h[b+14808>>3];i=i;return}function qi(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3544>>3]=+h[b+9736>>3]+(+h[b+6960>>3]*+h[d+2648>>3]+(+h[b+6984>>3]*+h[d+2656>>3]+ +h[b+7008>>3]*+h[d+2664>>3]));i=i;return}function ri(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6944>>3]=+h[b+14808>>3]*+h[b+9416>>3]+(+h[b+14800>>3]*+h[b+9424>>3]- +h[b+16>>3]*(+h[b+14824>>3]*+h[b+9664>>3]+ +h[b+14816>>3]*+h[b+9672>>3]));i=i;return}function si(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19816>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6944>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+6920|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+6920|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1224,1760,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6920|0;p=o;h[p>>3]=m;i=d;return}function ti(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6936>>3]=+h[b+14824>>3]*+h[b+9416>>3]+(+h[b+14816>>3]*+h[b+9424>>3]+ +h[b+16>>3]*(+h[b+14808>>3]*+h[b+9664>>3]+ +h[b+14800>>3]*+h[b+9672>>3]));i=i;return}function ui(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19816>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6936>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+6912|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+6912|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1224,1768,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6912|0;p=o;h[p>>3]=m;i=d;return}function vi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20840>>3]=(+h[b+3672>>3]*+h[b+6920>>3]+ +h[b+3680>>3]*+h[b+6912>>3])*2.0;i=i;return}function wi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+20408>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=5064;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,1552,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+20840>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+20792|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+20792|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,1784,1776,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+20792|0;y=x;h[y>>3]=v;i=d;return}function xi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20400>>3];k=j*j;l=+h[g+3672>>3]*+h[g+20792>>3]-j*+h[g+6920>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4496|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4496|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,1864,1856,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4496|0;q=p;h[q>>3]=n;i=d;return}function yi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4528>>3]=+h[b+6976>>3]*+h[b+4496>>3];i=i;return}function zi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20400>>3];k=j*j;l=j*+h[g+6912>>3]- +h[g+3680>>3]*+h[g+20792>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4504|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4504|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,1864,1928,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4504|0;q=p;h[q>>3]=n;i=d;return}function Ai(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4520>>3]=-(+h[b+6976>>3]*+h[b+4504>>3]);i=i;return}function Bi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4512>>3]=+h[b+3680>>3]*+h[b+4504>>3]+(+h[b+6912>>3]*+h[b+16040>>3]+(-(+h[b+3672>>3]*+h[b+4496>>3])- +h[b+6920>>3]*+h[b+16032>>3]));i=i;return}function Ci(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9320>>3]=+h[b+9576>>3]+(+h[b+16224>>3]*d*+h[e+3848>>3]- +h[b+16200>>3]*d*+h[e+3856>>3]);i=i;return}function Di(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9248>>3]=+h[b+9576>>3]+(+h[b+16224>>3]*d*+h[e+4424>>3]- +h[b+16200>>3]*d*+h[e+4432>>3]);i=i;return}function Ei(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14872>>3]=+h[b+16200>>3]*6.123233995736766e-17+ +h[b+16224>>3];i=i;return}function Fi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14856>>3]=+h[b+16224>>3]*6.123233995736766e-17- +h[b+16200>>3];i=i;return}function Gi(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9208>>3]=+h[b+9248>>3]+(+h[b+14856>>3]*d*+h[e+3944>>3]- +h[b+14872>>3]*d*+h[e+3952>>3]);i=i;return}function Hi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9176>>3]=+h[b+9208>>3]*.4999999999999999+ +h[b+9216>>3]*-.8660254037844387;i=i;return}function Ii(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9168>>3]=+h[b+9208>>3]*-.8660254037844387+ +h[b+9216>>3]*-.4999999999999999;i=i;return}function Ji(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20936>>3]=+h[b+9168>>3]*-2.0;i=i;return}function Ki(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20952>>3]=+h[b+20936>>3]*.5;i=i;return}function Li(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9856>>3]=+h[b+9880>>3]+(+h[b+14872>>3]*+h[d+3944>>3]+ +h[b+14856>>3]*+h[d+3952>>3]);i=i;return}function Mi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9832>>3]=(+h[b+9856>>3]- +h[b+10624>>3])*.8660254037844387+(+h[b+9864>>3]- +h[b+10632>>3])*.4999999999999999;i=i;return}function Ni(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9808>>3]=+h[b+15120>>3]- +h[b+9832>>3];i=i;return}function Oi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20296>>3]=+h[b+9808>>3]*-2.0;i=i;return}function Pi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20280>>3]=+h[b+20296>>3]*.5;i=i;return}function Qi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9840>>3]=(+h[b+9856>>3]- +h[b+10624>>3])*-.4999999999999999+(+h[b+9864>>3]- +h[b+10632>>3])*.8660254037844387;i=i;return}function Ri(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9816>>3]=+h[b+15128>>3]- +h[b+9840>>3];i=i;return}function Si(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+9800>>3];e=+h[b+9808>>3];f=+h[b+9816>>3];g=+h[(c[a+416>>2]|0)+20776>>3];h[b+20288>>3]=d*d+(e*e+(f*f-g*g));i=i;return}function Ti(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+20280>>3];h[b+20264>>3]=d*d- +h[b+20288>>3];i=i;return}function Ui(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;bv(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20264>>3],1.0e-12);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20256>>3]=+h[d>>3];i=b;return}function Vi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+20256>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+20272|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=5064;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,1936,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+20272|0;p=o;h[p>>3]=m;i=b;return}function Wi(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+20280>>3];g=+h[e+20272>>3];if((a[(c[b+424>>2]|0)+83|0]|0)!=0){j=g;k=f-j;l=e;m=l+16552|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+16552|0;n=m;h[n>>3]=k;i=d;return}function Xi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2760>>3]=+h[b+10624>>3]+ +h[b+16552>>3]*.8660254037844387;i=i;return}function Yi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3032>>3]=+h[b+2760>>3]+-.08660254037844388;i=i;return}function Zi(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10504>>3]=+h[b+2760>>3]+(+h[d+6304>>3]*-.8660254037844387+ +h[d+6312>>3]*.4999999999999999);i=i;return}function _i(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2752>>3]=+h[b+10632>>3]+ +h[b+16552>>3]*.4999999999999999;i=i;return}function $i(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3024>>3]=+h[b+2752>>3]+-.05;i=i;return}function aj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9792>>3]=+h[b+3024>>3]- +h[b+9864>>3];i=i;return}function bj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10512>>3]=+h[b+2752>>3]+(+h[d+6304>>3]*-.4999999999999999+ +h[d+6312>>3]*-.8660254037844387);i=i;return}function cj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20232>>3]=+h[(c[a+416>>2]|0)+20784>>3]+ +h[b+16552>>3];i=i;return}function dj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20216>>3]=+h[b+20232>>3]/.195+1.0;i=i;return}function ej(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+20184>>3]=+h[b+20936>>3]+ +h[b+20944>>3]*(1.0- +h[d+20216>>3]);i=i;return}function fj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20184>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+20200|0;p=o;h[p>>3]=m;i=d;return}q=+$Lb(c[b+536>>2]|0,j,2048,2040,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+20200|0;p=o;h[p>>3]=m;i=d;return}function gj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20208>>3]=-+h[b+20232>>3]/.195;i=i;return}function hj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20944>>3]=(+h[b+9808>>3]*+h[b+9168>>3]+ +h[b+9816>>3]*+h[b+9176>>3])*2.0;i=i;return}function ij(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20968>>3]=+h[b+20280>>3]*+h[b+20952>>3]*2.0- +h[b+20944>>3];i=i;return}function jj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;av(d,c[a+536>>2]|0,+h[f+20264>>3],1.0e-12,+h[f+20968>>3],0.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20976>>3]=+h[d>>3];i=b;return}function kj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+20256>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=5064;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,1936,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+20976>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+20960|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+20960|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,2088,2080,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+20960|0;y=x;h[y>>3]=v;i=d;return}function lj(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+20952>>3];g=+h[e+20960>>3];if((a[(c[b+424>>2]|0)+83|0]|0)!=0){j=g;k=f-j;l=e;m=l+20168|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+20168|0;n=m;h[n>>3]=k;i=d;return}function mj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9088>>3]=+h[b+20168>>3]*.8660254037844387;i=i;return}function nj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9136>>3]=+h[b+9088>>3]- +h[b+9208>>3];i=i;return}function oj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9096>>3]=+h[b+20168>>3]*.4999999999999999;i=i;return}function pj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9144>>3]=+h[b+9096>>3]- +h[b+9216>>3];i=i;return}function qj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+12|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+12|0]|0;k=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20168>>3],0.0,a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=k;f=j;break}else{j=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20168>>3],0.0,a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+12|0]|0;j=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20168>>3],0.0)|0;a[(c[b+352>>2]|0)+12|0]=j;f=g;break}else{g=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20168>>3],0.0)|0;a[(c[b+352>>2]|0)+12|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+14|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+14|0]|0;j=b+4|0;k=YOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20216>>3],.93,a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=k;l=j;m=e;break}else{e=b+4|0;j=YOb(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20216>>3],.93,a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+14|0]|0;j=b+4|0;e=$Ob(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20216>>3],.93)|0;a[(c[b+352>>2]|0)+14|0]=e;l=j;m=f;break}else{f=b+4|0;j=$Ob(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20216>>3],.93)|0;a[(c[b+352>>2]|0)+14|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+20216>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+20160|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+20160|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+13|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+13|0]|0;l=b+4|0;f=XOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+20216>>3],.987,a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=f;w=l;x=m;break}else{m=b+4|0;l=XOb(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+20216>>3],.987,a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+13|0]|0;l=b+4|0;m=ZOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+20216>>3],.987)|0;a[(c[b+352>>2]|0)+13|0]=m;w=l;x=j;break}else{j=b+4|0;l=ZOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20216>>3],.987)|0;a[(c[b+352>>2]|0)+13|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+20216>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+20160|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+20160|0;v=u;h[v>>3]=s;i=d;return}}}function rj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20192>>3]=+h[b+20160>>3]*1.0e-5;i=i;return}function sj(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+20928>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+20224>>3]=b*b*+h[d+20192>>3]*-78539.81633974482;i=i;return}function tj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+20952>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+20160>>3]*+h[j+20184>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+20176|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+20176|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,2160,2152,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+20176|0;p=o;h[p>>3]=m;i=d;return}function uj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9784>>3]=+h[b+3032>>3]- +h[b+9856>>3];i=i;return}function vj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2848>>3]=+h[b+14872>>3]*+h[b+9784>>3]+ +h[b+14864>>3]*+h[b+9792>>3];i=i;return}function wj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+20848>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2848>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+2960|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+2960|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1160,2192,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2960|0;p=o;h[p>>3]=m;i=d;return}function xj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2840>>3]=+h[b+14856>>3]*+h[b+9784>>3]+ +h[b+14848>>3]*+h[b+9792>>3];i=i;return}function yj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+20848>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2840>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+2952|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+2952|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1160,2200,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2952|0;p=o;h[p>>3]=m;i=d;return}function zj(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2952>>3];e=+h[b+2960>>3];h[b+20248>>3]=d*d+e*e;i=i;return}function Aj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+20248>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+20240|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=5064;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,2208,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+20240|0;p=o;h[p>>3]=m;i=b;return}function Bj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20240>>3];k=+h[g+2960>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+15944|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+15944|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,2328,2320,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+15944|0;p=o;h[p>>3]=m;i=d;return}function Cj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2880>>3]=-(+h[b+7160>>3]*+h[b+15944>>3]);i=i;return}function Dj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20240>>3];k=+h[g+2952>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+15936|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+15936|0;q=p;h[q>>3]=n;i=d;return}k=l/+$Lb(c[b+536>>2]|0,j,2328,2384,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+15936|0;q=p;h[q>>3]=n;i=d;return}function Ej(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2872>>3]=+h[b+7160>>3]*+h[b+15936>>3];i=i;return}function Fj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7152>>3]=+h[b+2880>>3]*+h[b+14864>>3]+ +h[b+2872>>3]*+h[b+14848>>3];i=i;return}function Gj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7200>>3]=+h[b+15936>>3]*+h[b+14864>>3]+ +h[b+15944>>3]*+h[b+14848>>3];i=i;return}function Hj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7136>>3]=+h[b+2960>>3]*+h[b+15944>>3]- +h[b+2952>>3]*+h[b+15936>>3];i=i;return}function Ij(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2816>>3]=+h[b+9848>>3]+(+h[b+7136>>3]*+h[d+5664>>3]+ +h[b+7160>>3]*+h[d+5672>>3]);i=i;return}function Jj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7176>>3]=+h[b+2960>>3]*+h[b+14864>>3]+ +h[b+2952>>3]*+h[b+14848>>3];i=i;return}function Kj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2832>>3]=+h[b+9864>>3]+(+h[b+7152>>3]*+h[d+5664>>3]+(+h[b+7176>>3]*+h[d+5672>>3]+ +h[b+7200>>3]*+h[d+5680>>3]));i=i;return}function Lj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+20848>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+14872>>3]*+h[j+9136>>3]+(+h[j+14864>>3]*+h[j+9144>>3]+ +h[j+16>>3]*+h[j+2840>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+9112|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+9112|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1160,2392,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9112|0;p=o;h[p>>3]=m;i=d;return}function Mj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+20848>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+14856>>3]*+h[j+9136>>3]+(+h[j+14848>>3]*+h[j+9144>>3]- +h[j+16>>3]*+h[j+2848>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+9120|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+9120|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1160,2400,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9120|0;p=o;h[p>>3]=m;i=d;return}function Nj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2856>>3]=+h[b+15936>>3]*+h[b+9112>>3]+ +h[b+15944>>3]*+h[b+9120>>3];i=i;return}function Oj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2792>>3]=+h[b+7136>>3]*+h[b+16>>3]+ +h[b+2856>>3];i=i;return}function Pj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20240>>3];k=+h[g+2872>>3]*+h[g+9112>>3]- +h[g+2880>>3]*+h[g+9120>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2864|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2864|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,2328,2408,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2864|0;p=o;h[p>>3]=m;i=d;return}function Qj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2800>>3]=+h[b+7160>>3]*+h[b+16>>3]+ +h[b+2864>>3];i=i;return}function Rj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2808>>3]=-(+h[b+2872>>3]*+h[b+9120>>3])- +h[b+2880>>3]*+h[b+9112>>3];i=i;return}function Sj(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2960>>3];e=+h[b+2952>>3];h[b+20304>>3]=(+h[b+14872>>3]*d+ +h[b+14856>>3]*e)*-.8660254037844387+(d*+h[b+14864>>3]+e*+h[b+14848>>3])*-.4999999999999999;i=i;return}function Tj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7192>>3]=+h[b+15936>>3]*+h[b+14872>>3]+ +h[b+15944>>3]*+h[b+14856>>3];i=i;return}function Uj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7168>>3]=+h[b+2960>>3]*+h[b+14872>>3]+ +h[b+2952>>3]*+h[b+14856>>3];i=i;return}function Vj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7144>>3]=+h[b+2880>>3]*+h[b+14872>>3]+ +h[b+2872>>3]*+h[b+14856>>3];i=i;return}function Wj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2824>>3]=+h[b+9856>>3]+(+h[b+7144>>3]*+h[d+5664>>3]+(+h[b+7168>>3]*+h[d+5672>>3]+ +h[b+7192>>3]*+h[d+5680>>3]));i=i;return}function Xj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7128>>3]=+h[b+14856>>3]*+h[b+9136>>3]+(+h[b+14848>>3]*+h[b+9144>>3]- +h[b+16>>3]*(+h[b+14872>>3]*+h[b+9784>>3]+ +h[b+14864>>3]*+h[b+9792>>3]));i=i;return}function Yj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+20848>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7128>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7104|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7104|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1160,2416,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7104|0;p=o;h[p>>3]=m;i=d;return}function Zj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7120>>3]=+h[b+14872>>3]*+h[b+9136>>3]+(+h[b+14864>>3]*+h[b+9144>>3]+ +h[b+16>>3]*(+h[b+14856>>3]*+h[b+9784>>3]+ +h[b+14848>>3]*+h[b+9792>>3]));i=i;return}function _j(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+20848>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7120>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7096|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7096|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1160,2424,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7096|0;p=o;h[p>>3]=m;i=d;return}function $j(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20848>>3]=(+h[b+2952>>3]*+h[b+7104>>3]+ +h[b+2960>>3]*+h[b+7096>>3])*2.0;i=i;return}function ak(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+20248>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=5064;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,2208,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+20848>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+20800|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+20800|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,2440,2432,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+20800|0;y=x;h[y>>3]=v;i=d;return}function bk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20240>>3];k=j*j;l=+h[g+2952>>3]*+h[g+20800>>3]-j*+h[g+7104>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4568|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4568|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,2520,2512,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4568|0;q=p;h[q>>3]=n;i=d;return}function ck(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4600>>3]=+h[b+7160>>3]*+h[b+4568>>3];i=i;return}function dk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20240>>3];k=j*j;l=j*+h[g+7096>>3]- +h[g+2960>>3]*+h[g+20800>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4576|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4576|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,2520,2584,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4576|0;q=p;h[q>>3]=n;i=d;return}function ek(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4592>>3]=-(+h[b+7160>>3]*+h[b+4576>>3]);i=i;return}function fk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4584>>3]=+h[b+2960>>3]*+h[b+4576>>3]+(+h[b+7096>>3]*+h[b+15944>>3]+(-(+h[b+2952>>3]*+h[b+4568>>3])- +h[b+7104>>3]*+h[b+15936>>3]));i=i;return}function gk(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9040>>3]=+h[b+9320>>3]+(+h[b+16224>>3]*d*+h[e+6864>>3]- +h[b+16200>>3]*d*+h[e+6872>>3]);i=i;return}function hk(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8968>>3]=+h[b+9320>>3]+(+h[b+16224>>3]*d*+h[e+7440>>3]- +h[b+16200>>3]*d*+h[e+7448>>3]);i=i;return}function ik(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14920>>3]=+h[b+16200>>3]*-.8660254037844386+ +h[b+16224>>3]*-.5000000000000001;i=i;return}function jk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14904>>3]=+h[b+16200>>3]*.5000000000000001+ +h[b+16224>>3]*-.8660254037844386;i=i;return}function kk(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8928>>3]=+h[b+8968>>3]+(+h[b+14904>>3]*d*+h[e+6960>>3]- +h[b+14920>>3]*d*+h[e+6968>>3]);i=i;return}function lk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8896>>3]=+h[b+8928>>3]*-.4999999999999999+ +h[b+8936>>3]*-.8660254037844387;i=i;return}function mk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8888>>3]=+h[b+8928>>3]*-.8660254037844387+ +h[b+8936>>3]*.4999999999999999;i=i;return}function nk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20984>>3]=+h[b+8888>>3]*-2.0;i=i;return}function ok(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21e3>>3]=+h[b+20984>>3]*.5;i=i;return}function pk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9976>>3]=+h[b+1e4>>3]+(+h[b+14920>>3]*+h[d+6960>>3]+ +h[b+14904>>3]*+h[d+6968>>3]);i=i;return}function qk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9952>>3]=(+h[b+9976>>3]- +h[b+10648>>3])*.8660254037844387+(+h[b+9984>>3]- +h[b+10656>>3])*-.4999999999999999;i=i;return}function rk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9928>>3]=+h[b+15144>>3]- +h[b+9952>>3];i=i;return}function sk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20136>>3]=+h[b+9928>>3]*-2.0;i=i;return}function tk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20120>>3]=+h[b+20136>>3]*.5;i=i;return}function uk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9960>>3]=(+h[b+9976>>3]- +h[b+10648>>3])*.4999999999999999+(+h[b+9984>>3]- +h[b+10656>>3])*.8660254037844387;i=i;return}function vk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9936>>3]=+h[b+15152>>3]- +h[b+9960>>3];i=i;return}function wk(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+9920>>3];e=+h[b+9928>>3];f=+h[b+9936>>3];g=+h[(c[a+416>>2]|0)+21808>>3];h[b+20128>>3]=d*d+(e*e+(f*f-g*g));i=i;return}function xk(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+20120>>3];h[b+20104>>3]=d*d- +h[b+20128>>3];i=i;return}function yk(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;bv(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20104>>3],1.0e-12);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20096>>3]=+h[d>>3];i=b;return}function zk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+20096>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+20112|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=5064;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,2592,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+20112|0;p=o;h[p>>3]=m;i=b;return}function Ak(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+20120>>3];g=+h[e+20112>>3];if((a[(c[b+424>>2]|0)+131|0]|0)!=0){j=g;k=f-j;l=e;m=l+16784|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+16784|0;n=m;h[n>>3]=k;i=d;return}function Bk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2040>>3]=+h[b+10648>>3]+ +h[b+16784>>3]*.8660254037844387;i=i;return}function Ck(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2312>>3]=+h[b+2040>>3]+-.08660254037844388;i=i;return}function Dk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10528>>3]=+h[b+2040>>3]+(+h[d+9320>>3]*-.8660254037844387+ +h[d+9328>>3]*-.4999999999999999);i=i;return}function Ek(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2032>>3]=+h[b+10656>>3]+ +h[b+16784>>3]*-.4999999999999999;i=i;return}function Fk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2304>>3]=+h[b+2032>>3]+.05;i=i;return}function Gk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9912>>3]=+h[b+2304>>3]- +h[b+9984>>3];i=i;return}function Hk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10536>>3]=+h[b+2032>>3]+(+h[d+9320>>3]*.4999999999999999+ +h[d+9328>>3]*-.8660254037844387);i=i;return}function Ik(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20072>>3]=+h[(c[a+416>>2]|0)+21816>>3]+ +h[b+16784>>3];i=i;return}function Jk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20056>>3]=+h[b+20072>>3]/.195+1.0;i=i;return}function Kk(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+20024>>3]=+h[b+21968>>3]+ +h[b+21976>>3]*(1.0- +h[d+20056>>3]);i=i;return}function Lk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20024>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+20040|0;p=o;h[p>>3]=m;i=d;return}q=+$Lb(c[b+536>>2]|0,j,2704,2696,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+20040|0;p=o;h[p>>3]=m;i=d;return}function Mk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20048>>3]=-+h[b+20072>>3]/.195;i=i;return}function Nk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20992>>3]=(+h[b+9928>>3]*+h[b+8888>>3]+ +h[b+9936>>3]*+h[b+8896>>3])*2.0;i=i;return}function Ok(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21016>>3]=+h[b+20120>>3]*+h[b+21e3>>3]*2.0- +h[b+20992>>3];i=i;return}function Pk(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;av(d,c[a+536>>2]|0,+h[f+20104>>3],1.0e-12,+h[f+21016>>3],0.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+21024>>3]=+h[d>>3];i=b;return}function Qk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+20096>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=5064;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,2592,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+21024>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+21008|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+21008|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,2744,2736,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+21008|0;y=x;h[y>>3]=v;i=d;return}function Rk(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+21e3>>3];g=+h[e+21008>>3];if((a[(c[b+424>>2]|0)+131|0]|0)!=0){j=g;k=f-j;l=e;m=l+20008|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+20008|0;n=m;h[n>>3]=k;i=d;return}function Sk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8808>>3]=+h[b+20008>>3]*.8660254037844387;i=i;return}function Tk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8856>>3]=+h[b+8808>>3]- +h[b+8928>>3];i=i;return}function Uk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8816>>3]=+h[b+20008>>3]*-.4999999999999999;i=i;return}function Vk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8864>>3]=+h[b+8816>>3]- +h[b+8936>>3];i=i;return}function Wk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+9|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+9|0]|0;k=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20008>>3],0.0,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=k;f=j;break}else{j=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20008>>3],0.0,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+9|0]|0;j=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20008>>3],0.0)|0;a[(c[b+352>>2]|0)+9|0]=j;f=g;break}else{g=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20008>>3],0.0)|0;a[(c[b+352>>2]|0)+9|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+11|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+11|0]|0;j=b+4|0;k=YOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20056>>3],.93,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=k;l=j;m=e;break}else{e=b+4|0;j=YOb(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20056>>3],.93,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+11|0]|0;j=b+4|0;e=$Ob(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20056>>3],.93)|0;a[(c[b+352>>2]|0)+11|0]=e;l=j;m=f;break}else{f=b+4|0;j=$Ob(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20056>>3],.93)|0;a[(c[b+352>>2]|0)+11|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+20056>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+2e4|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+2e4|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+10|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+10|0]|0;l=b+4|0;f=XOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+20056>>3],.987,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=f;w=l;x=m;break}else{m=b+4|0;l=XOb(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+20056>>3],.987,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+10|0]|0;l=b+4|0;m=ZOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+20056>>3],.987)|0;a[(c[b+352>>2]|0)+10|0]=m;w=l;x=j;break}else{j=b+4|0;l=ZOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20056>>3],.987)|0;a[(c[b+352>>2]|0)+10|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+20056>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+2e4|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+2e4|0;v=u;h[v>>3]=s;i=d;return}}}function Xk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20032>>3]=+h[b+2e4>>3]*1.0e-5;i=i;return}function Yk(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+21960>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+20064>>3]=b*b*+h[d+20032>>3]*-78539.81633974482;i=i;return}function Zk(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+21984>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2e4>>3]*+h[j+20024>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+20016|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+20016|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,2816,2808,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+20016|0;p=o;h[p>>3]=m;i=d;return}function _k(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9904>>3]=+h[b+2312>>3]- +h[b+9976>>3];i=i;return}function $k(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2128>>3]=+h[b+14920>>3]*+h[b+9904>>3]+ +h[b+14912>>3]*+h[b+9912>>3];i=i;return}function al(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+21880>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2128>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+2240|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+2240|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1096,2848,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2240|0;p=o;h[p>>3]=m;i=d;return}function bl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2120>>3]=+h[b+14904>>3]*+h[b+9904>>3]+ +h[b+14896>>3]*+h[b+9912>>3];i=i;return}function cl(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+21880>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2120>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+2232|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+2232|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1096,2856,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2232|0;p=o;h[p>>3]=m;i=d;return}function dl(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2232>>3];e=+h[b+2240>>3];h[b+20088>>3]=d*d+e*e;i=i;return}function el(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+20088>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+20080|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=5064;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,2864,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+20080|0;p=o;h[p>>3]=m;i=b;return}function fl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20080>>3];k=+h[g+2240>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+15848|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+15848|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,2984,2976,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+15848|0;p=o;h[p>>3]=m;i=d;return}function gl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2160>>3]=-(+h[b+7344>>3]*+h[b+15848>>3]);i=i;return}function hl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20080>>3];k=+h[g+2232>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+15840|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+15840|0;q=p;h[q>>3]=n;i=d;return}k=l/+$Lb(c[b+536>>2]|0,j,2984,3040,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+15840|0;q=p;h[q>>3]=n;i=d;return}function il(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2152>>3]=+h[b+7344>>3]*+h[b+15840>>3];i=i;return}function jl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7336>>3]=+h[b+2160>>3]*+h[b+14912>>3]+ +h[b+2152>>3]*+h[b+14896>>3];i=i;return}function kl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7384>>3]=+h[b+15840>>3]*+h[b+14912>>3]+ +h[b+15848>>3]*+h[b+14896>>3];i=i;return}function ll(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7320>>3]=+h[b+2240>>3]*+h[b+15848>>3]- +h[b+2232>>3]*+h[b+15840>>3];i=i;return}function ml(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2096>>3]=+h[b+9968>>3]+(+h[b+7320>>3]*+h[d+8680>>3]+ +h[b+7344>>3]*+h[d+8688>>3]);i=i;return}function nl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7360>>3]=+h[b+2240>>3]*+h[b+14912>>3]+ +h[b+2232>>3]*+h[b+14896>>3];i=i;return}function ol(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2112>>3]=+h[b+9984>>3]+(+h[b+7336>>3]*+h[d+8680>>3]+(+h[b+7360>>3]*+h[d+8688>>3]+ +h[b+7384>>3]*+h[d+8696>>3]));i=i;return}function pl(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+21880>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+14920>>3]*+h[j+8856>>3]+(+h[j+14912>>3]*+h[j+8864>>3]+ +h[j+16>>3]*+h[j+2120>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+8832|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8832|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1096,3048,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8832|0;p=o;h[p>>3]=m;i=d;return}function ql(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+21880>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+14904>>3]*+h[j+8856>>3]+(+h[j+14896>>3]*+h[j+8864>>3]- +h[j+16>>3]*+h[j+2128>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+8840|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8840|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1096,3056,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8840|0;p=o;h[p>>3]=m;i=d;return}function rl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2136>>3]=+h[b+15840>>3]*+h[b+8832>>3]+ +h[b+15848>>3]*+h[b+8840>>3];i=i;return}function sl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2072>>3]=+h[b+7320>>3]*+h[b+16>>3]+ +h[b+2136>>3];i=i;return}



function Xlb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28320]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+736>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+736>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(28328,vMb(c[(c[g>>2]|0)+736>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[28320]=1;i=d;return}function Ylb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28536]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+732>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+732>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(28544,vMb(c[(c[g>>2]|0)+732>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[28536]=1;i=d;return}function Zlb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28752]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+728>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+728>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(28760,vMb(c[(c[g>>2]|0)+728>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[28752]=1;i=d;return}function _lb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28952]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+724>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+724>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(28960,vMb(c[(c[g>>2]|0)+724>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[28952]=1;i=d;return}function $lb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29152]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+720>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+720>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(29160,vMb(c[(c[g>>2]|0)+720>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[29152]=1;i=d;return}function amb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29352]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25336>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(29360,tMb(+h[(c[g>>2]|0)+25336>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[29352]=1;i=d;return}function bmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29496]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25328>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(29504,tMb(+h[(c[g>>2]|0)+25328>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[29496]=1;i=d;return}function cmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29640]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25320>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(29648,tMb(+h[(c[g>>2]|0)+25320>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[29640]=1;i=d;return}function dmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29784]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(29792,tMb(+h[(c[g>>2]|0)+25312>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[29784]=1;i=d;return}function emb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29912]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(29920,tMb(+h[(c[g>>2]|0)+25304>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[29912]=1;i=d;return}function fmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30040]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(30048,tMb(+h[(c[g>>2]|0)+25296>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[30040]=1;i=d;return}function gmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30168]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(30176,tMb(+h[(c[g>>2]|0)+25288>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[30168]=1;i=d;return}function hmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30288]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(30296,tMb(+h[(c[g>>2]|0)+25280>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[30288]=1;i=d;return}function imb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30424]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(30432,tMb(+h[(c[g>>2]|0)+25272>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[30424]=1;i=d;return}function jmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30544]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(30552,tMb(+h[(c[g>>2]|0)+25264>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[30544]=1;i=d;return}function kmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30664]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(30672,tMb(+h[(c[g>>2]|0)+25256>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[30664]=1;i=d;return}function lmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30816]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(30824,tMb(+h[(c[g>>2]|0)+25248>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[30816]=1;i=d;return}function mmb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30968]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+716>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+716>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(30976,vMb(c[(c[g>>2]|0)+716>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[30968]=1;i=d;return}function nmb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31192]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+712>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+712>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(31200,vMb(c[(c[g>>2]|0)+712>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[31192]=1;i=d;return}function omb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31416]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+708>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+708>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(31424,vMb(c[(c[g>>2]|0)+708>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[31416]=1;i=d;return}function pmb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31640]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+704>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+704>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(31648,vMb(c[(c[g>>2]|0)+704>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[31640]=1;i=d;return}function qmb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31848]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+700>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+700>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(31856,vMb(c[(c[g>>2]|0)+700>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[31848]=1;i=d;return}function rmb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32056]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+696>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+696>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(32064,vMb(c[(c[g>>2]|0)+696>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[32056]=1;i=d;return}function smb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32264]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25240>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(32272,tMb(+h[(c[g>>2]|0)+25240>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[32264]=1;i=d;return}function tmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32416]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25232>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(32424,tMb(+h[(c[g>>2]|0)+25232>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[32416]=1;i=d;return}function umb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32568]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25224>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(32576,tMb(+h[(c[g>>2]|0)+25224>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[32568]=1;i=d;return}function vmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32720]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(32728,tMb(+h[(c[g>>2]|0)+25216>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[32720]=1;i=d;return}function wmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32848]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(32856,tMb(+h[(c[g>>2]|0)+25208>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[32848]=1;i=d;return}function xmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32976]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(32984,tMb(+h[(c[g>>2]|0)+25200>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[32976]=1;i=d;return}function ymb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33104]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(33112,tMb(+h[(c[g>>2]|0)+25192>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[33104]=1;i=d;return}function zmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33224]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(33232,tMb(+h[(c[g>>2]|0)+25176>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[33224]=1;i=d;return}function Amb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33384]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(33392,tMb(+h[(c[g>>2]|0)+25168>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[33384]=1;i=d;return}function Bmb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33536]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+692>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+692>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(33544,vMb(c[(c[g>>2]|0)+692>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[33536]=1;i=d;return}function Cmb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33744]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+688>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+688>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(33752,vMb(c[(c[g>>2]|0)+688>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[33744]=1;i=d;return}function Dmb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33952]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+684>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+684>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(33960,vMb(c[(c[g>>2]|0)+684>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[33952]=1;i=d;return}function Emb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34160]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+680>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+680>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(34168,vMb(c[(c[g>>2]|0)+680>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[34160]=1;i=d;return}function Fmb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34352]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+676>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+676>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(34360,vMb(c[(c[g>>2]|0)+676>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[34352]=1;i=d;return}function Gmb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34544]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+672>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+672>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(34552,vMb(c[(c[g>>2]|0)+672>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[34544]=1;i=d;return}function Hmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34736]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25136>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(34744,tMb(+h[(c[g>>2]|0)+25136>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[34736]=1;i=d;return}function Imb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34872]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25128>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(34880,tMb(+h[(c[g>>2]|0)+25128>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[34872]=1;i=d;return}function Jmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35008]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25120>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(35016,tMb(+h[(c[g>>2]|0)+25120>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[35008]=1;i=d;return}function Kmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35144]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(35152,tMb(+h[(c[g>>2]|0)+25112>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[35144]=1;i=d;return}function Lmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35264]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(35272,tMb(+h[(c[g>>2]|0)+25104>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[35264]=1;i=d;return}function Mmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35384]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(35392,tMb(+h[(c[g>>2]|0)+25096>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[35384]=1;i=d;return}function Nmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35504]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(35512,tMb(+h[(c[g>>2]|0)+25088>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[35504]=1;i=d;return}function Omb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35616]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(35624,tMb(+h[(c[g>>2]|0)+25056>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[35616]=1;i=d;return}function Pmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35840]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(35848,tMb(+h[(c[g>>2]|0)+25040>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[35840]=1;i=d;return}function Qmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36064]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(36072,tMb(+h[(c[g>>2]|0)+25032>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[36064]=1;i=d;return}function Rmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36208]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(36216,tMb(+h[(c[g>>2]|0)+25024>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[36208]=1;i=d;return}function Smb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36368]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+25016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(36376,tMb(+h[(c[g>>2]|0)+25016>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[36368]=1;i=d;return}function Tmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36528]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(36536,tMb(+h[(c[g>>2]|0)+24992>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[36528]=1;i=d;return}function Umb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36696]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(36704,tMb(+h[(c[g>>2]|0)+24984>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[36696]=1;i=d;return}function Vmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36864]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(36872,tMb(+h[(c[g>>2]|0)+24976>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[36864]=1;i=d;return}function Wmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37032]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(37040,tMb(+h[(c[g>>2]|0)+24968>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[37032]=1;i=d;return}function Xmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37216]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(37224,tMb(+h[(c[g>>2]|0)+24960>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[37216]=1;i=d;return}function Ymb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37392]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(37400,tMb(+h[(c[g>>2]|0)+24952>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[37392]=1;i=d;return}function Zmb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37568]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(37576,tMb(+h[(c[g>>2]|0)+24936>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[37568]=1;i=d;return}function _mb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37744]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(37752,tMb(+h[(c[g>>2]|0)+24928>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[37744]=1;i=d;return}function $mb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37920]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(37928,tMb(+h[(c[g>>2]|0)+24896>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[37920]=1;i=d;return}function anb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38080]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(38088,tMb(+h[(c[g>>2]|0)+24888>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[38080]=1;i=d;return}function bnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38240]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(38248,tMb(+h[(c[g>>2]|0)+24880>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[38240]=1;i=d;return}function cnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38400]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(38408,tMb(+h[(c[g>>2]|0)+24872>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[38400]=1;i=d;return}function dnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38560]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(38568,tMb(+h[(c[g>>2]|0)+24864>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[38560]=1;i=d;return}function enb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38728]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(38736,tMb(+h[(c[g>>2]|0)+24856>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[38728]=1;i=d;return}function fnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38896]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(38904,tMb(+h[(c[g>>2]|0)+24848>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[38896]=1;i=d;return}function gnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39048]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(39056,tMb(+h[(c[g>>2]|0)+24840>>3],24152)|0)|0;g=c[69978]|0;j=e;k=139056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[39048]=1;i=d;return}function hnb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39216]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+880>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+880>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=xMb(39224,vMb(c[(c[g>>2]|0)+880>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=139528;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[39216]=1;i=d;return}function inb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39752]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+876>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+876>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=xMb(39760,vMb(c[(c[g>>2]|0)+876>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=139944;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[39752]=1;i=d;return}function jnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40144]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(40152,tMb(+h[(c[g>>2]|0)+24816>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[40144]=1;i=d;return}function knb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40280]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(40288,tMb(+h[(c[g>>2]|0)+24808>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[40280]=1;i=d;return}function lnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40432]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(40440,tMb(+h[(c[g>>2]|0)+24800>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[40432]=1;i=d;return}function mnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40584]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24752>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(40592,tMb(+h[(c[g>>2]|0)+24752>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[40584]=1;i=d;return}function nnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40720]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24744>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(40728,tMb(+h[(c[g>>2]|0)+24744>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[40720]=1;i=d;return}function onb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40856]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+668>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+668>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(40864,vMb(c[(c[g>>2]|0)+668>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[40856]=1;i=d;return}function pnb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41048]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+664>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+664>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(41056,vMb(c[(c[g>>2]|0)+664>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[41048]=1;i=d;return}function qnb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41240]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+660>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+660>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(41248,vMb(c[(c[g>>2]|0)+660>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[41240]=1;i=d;return}function rnb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41432]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+872>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+872>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(41440,vMb(c[(c[g>>2]|0)+872>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=143056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[41432]=1;i=d;return}function snb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41760]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24712>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(41768,tMb(+h[(c[g>>2]|0)+24712>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[41760]=1;i=d;return}function tnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41912]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(41920,tMb(+h[(c[g>>2]|0)+24704>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[41912]=1;i=d;return}function unb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42064]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+656>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+656>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(42072,vMb(c[(c[g>>2]|0)+656>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[42064]=1;i=d;return}function vnb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42288]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+652>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+652>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(42296,vMb(c[(c[g>>2]|0)+652>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[42288]=1;i=d;return}function wnb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42512]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+648>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+648>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(42520,vMb(c[(c[g>>2]|0)+648>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[42512]=1;i=d;return}function xnb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42736]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+868>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+868>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(42744,vMb(c[(c[g>>2]|0)+868>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=143056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[42736]=1;i=d;return}function ynb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43088]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(43096,tMb(+h[(c[g>>2]|0)+24672>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[43088]=1;i=d;return}function znb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43208]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24664>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(43216,tMb(+h[(c[g>>2]|0)+24664>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[43208]=1;i=d;return}function Anb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43328]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(43336,tMb(+h[(c[g>>2]|0)+24640>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[43328]=1;i=d;return}function Bnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43456]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(43464,tMb(+h[(c[g>>2]|0)+24632>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[43456]=1;i=d;return}function Cnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43584]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(43592,tMb(+h[(c[g>>2]|0)+24608>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[43584]=1;i=d;return}function Dnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43720]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(43728,tMb(+h[(c[g>>2]|0)+24600>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[43720]=1;i=d;return}function Enb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43848]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(43856,tMb(+h[(c[g>>2]|0)+24576>>3],24152)|0)|0;g=c[69978]|0;j=e;k=143968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[43848]=1;i=d;return}function Fnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43976]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(43984,tMb(+h[(c[g>>2]|0)+24568>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[43976]=1;i=d;return}function Gnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44104]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(44112,tMb(+h[(c[g>>2]|0)+24560>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[44104]=1;i=d;return}function Hnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44232]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24552>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(44240,tMb(+h[(c[g>>2]|0)+24552>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144416;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[44232]=1;i=d;return}function Inb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44352]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(44360,tMb(+h[(c[g>>2]|0)+24536>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[44352]=1;i=d;return}function Jnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44488]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(44496,tMb(+h[(c[g>>2]|0)+24528>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[44488]=1;i=d;return}function Knb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44624]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(44632,tMb(+h[(c[g>>2]|0)+24520>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[44624]=1;i=d;return}function Lnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44760]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(44768,tMb(+h[(c[g>>2]|0)+24512>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[44760]=1;i=d;return}function Mnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44880]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(44888,tMb(+h[(c[g>>2]|0)+24448>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[44880]=1;i=d;return}function Nnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45024]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(45032,tMb(+h[(c[g>>2]|0)+24440>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[45024]=1;i=d;return}function Onb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45152]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(45160,tMb(+h[(c[g>>2]|0)+24432>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[45152]=1;i=d;return}function Pnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45280]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(45288,tMb(+h[(c[g>>2]|0)+24424>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[45280]=1;i=d;return}function Qnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45440]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(45448,tMb(+h[(c[g>>2]|0)+24416>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[45440]=1;i=d;return}function Rnb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45592]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+644>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+644>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(45600,vMb(c[(c[g>>2]|0)+644>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[45592]=1;i=d;return}function Snb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45824]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+640>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+640>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(45832,vMb(c[(c[g>>2]|0)+640>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[45824]=1;i=d;return}function Tnb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46056]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+636>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+636>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(46064,vMb(c[(c[g>>2]|0)+636>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[46056]=1;i=d;return}function Unb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46288]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+632>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+632>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(46296,vMb(c[(c[g>>2]|0)+632>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[46288]=1;i=d;return}function Vnb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46504]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+628>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+628>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(46512,vMb(c[(c[g>>2]|0)+628>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[46504]=1;i=d;return}function Wnb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46720]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+624>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+624>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(46728,vMb(c[(c[g>>2]|0)+624>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[46720]=1;i=d;return}function Xnb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46936]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24408>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(46944,tMb(+h[(c[g>>2]|0)+24408>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[46936]=1;i=d;return}function Ynb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47088]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24400>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(47096,tMb(+h[(c[g>>2]|0)+24400>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[47088]=1;i=d;return}function Znb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47240]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24392>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(47248,tMb(+h[(c[g>>2]|0)+24392>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[47240]=1;i=d;return}function _nb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47392]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(47400,tMb(+h[(c[g>>2]|0)+24384>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[47392]=1;i=d;return}function $nb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47528]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(47536,tMb(+h[(c[g>>2]|0)+24376>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[47528]=1;i=d;return}function aob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47664]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(47672,tMb(+h[(c[g>>2]|0)+24368>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[47664]=1;i=d;return}function bob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47800]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(47808,tMb(+h[(c[g>>2]|0)+24360>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[47800]=1;i=d;return}function cob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47928]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(47936,tMb(+h[(c[g>>2]|0)+24344>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[47928]=1;i=d;return}function dob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48088]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(48096,tMb(+h[(c[g>>2]|0)+24336>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[48088]=1;i=d;return}function eob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48248]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+620>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+620>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(48256,vMb(c[(c[g>>2]|0)+620>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[48248]=1;i=d;return}function fob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48464]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+616>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+616>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(48472,vMb(c[(c[g>>2]|0)+616>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[48464]=1;i=d;return}function gob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48680]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+612>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+612>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(48688,vMb(c[(c[g>>2]|0)+612>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[48680]=1;i=d;return}function hob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48896]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+608>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+608>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(48904,vMb(c[(c[g>>2]|0)+608>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[48896]=1;i=d;return}function iob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49096]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+604>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+604>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(49104,vMb(c[(c[g>>2]|0)+604>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[49096]=1;i=d;return}function job(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49296]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+600>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+600>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(49304,vMb(c[(c[g>>2]|0)+600>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[49296]=1;i=d;return}function kob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49496]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24304>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(49504,tMb(+h[(c[g>>2]|0)+24304>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[49496]=1;i=d;return}function lob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49640]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24296>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(49648,tMb(+h[(c[g>>2]|0)+24296>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[49640]=1;i=d;return}function mob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49784]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24288>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(49792,tMb(+h[(c[g>>2]|0)+24288>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[49784]=1;i=d;return}function nob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49928]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(49936,tMb(+h[(c[g>>2]|0)+24280>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[49928]=1;i=d;return}function oob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50056]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(50064,tMb(+h[(c[g>>2]|0)+24272>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[50056]=1;i=d;return}function pob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50184]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(50192,tMb(+h[(c[g>>2]|0)+24264>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[50184]=1;i=d;return}function qob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50312]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(50320,tMb(+h[(c[g>>2]|0)+24256>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[50312]=1;i=d;return}function rob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50432]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(50440,tMb(+h[(c[g>>2]|0)+24248>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[50432]=1;i=d;return}function sob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50568]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(50576,tMb(+h[(c[g>>2]|0)+24240>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[50568]=1;i=d;return}function tob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50688]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(50696,tMb(+h[(c[g>>2]|0)+24232>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[50688]=1;i=d;return}function uob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50808]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(50816,tMb(+h[(c[g>>2]|0)+24224>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[50808]=1;i=d;return}function vob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50960]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(50968,tMb(+h[(c[g>>2]|0)+24216>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[50960]=1;i=d;return}function wob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51112]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+596>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+596>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(51120,vMb(c[(c[g>>2]|0)+596>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[51112]=1;i=d;return}function xob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51336]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+592>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+592>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(51344,vMb(c[(c[g>>2]|0)+592>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[51336]=1;i=d;return}function yob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51560]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+588>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+588>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(51568,vMb(c[(c[g>>2]|0)+588>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[51560]=1;i=d;return}function zob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51784]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+584>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+584>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(51792,vMb(c[(c[g>>2]|0)+584>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[51784]=1;i=d;return}function Aob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51992]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+580>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+580>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(52e3,vMb(c[(c[g>>2]|0)+580>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[51992]=1;i=d;return}function Bob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52200]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+576>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+576>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(52208,vMb(c[(c[g>>2]|0)+576>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[52200]=1;i=d;return}function Cob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52408]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24208>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(52416,tMb(+h[(c[g>>2]|0)+24208>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[52408]=1;i=d;return}function Dob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52560]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24200>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(52568,tMb(+h[(c[g>>2]|0)+24200>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[52560]=1;i=d;return}function Eob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52712]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24192>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(52720,tMb(+h[(c[g>>2]|0)+24192>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[52712]=1;i=d;return}function Fob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52864]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(52872,tMb(+h[(c[g>>2]|0)+24184>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[52864]=1;i=d;return}function Gob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52992]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(53e3,tMb(+h[(c[g>>2]|0)+24176>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[52992]=1;i=d;return}function Hob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53120]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(53128,tMb(+h[(c[g>>2]|0)+24168>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[53120]=1;i=d;return}function Iob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53248]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(53256,tMb(+h[(c[g>>2]|0)+24160>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[53248]=1;i=d;return}function Job(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53368]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24144>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(53376,tMb(+h[(c[g>>2]|0)+24144>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[53368]=1;i=d;return}function Kob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53528]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(53536,tMb(+h[(c[g>>2]|0)+24136>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[53528]=1;i=d;return}function Lob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53680]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+572>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+572>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(53688,vMb(c[(c[g>>2]|0)+572>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[53680]=1;i=d;return}function Mob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53888]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+568>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+568>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(53896,vMb(c[(c[g>>2]|0)+568>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[53888]=1;i=d;return}function Nob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54096]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+564>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+564>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(54104,vMb(c[(c[g>>2]|0)+564>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[54096]=1;i=d;return}function Oob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54304]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+560>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+560>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(54312,vMb(c[(c[g>>2]|0)+560>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[54304]=1;i=d;return}function Pob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54496]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+556>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+556>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(54504,vMb(c[(c[g>>2]|0)+556>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[54496]=1;i=d;return}function Qob(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54688]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+552>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+552>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(54696,vMb(c[(c[g>>2]|0)+552>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[54688]=1;i=d;return}function Rob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54880]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24104>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(54888,tMb(+h[(c[g>>2]|0)+24104>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[54880]=1;i=d;return}function Sob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55016]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24096>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(55024,tMb(+h[(c[g>>2]|0)+24096>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[55016]=1;i=d;return}function Tob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55152]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24088>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(55160,tMb(+h[(c[g>>2]|0)+24088>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[55152]=1;i=d;return}function Uob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55288]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(55296,tMb(+h[(c[g>>2]|0)+24080>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[55288]=1;i=d;return}function Vob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55408]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(55416,tMb(+h[(c[g>>2]|0)+24072>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[55408]=1;i=d;return}function Wob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55528]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(55536,tMb(+h[(c[g>>2]|0)+24064>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[55528]=1;i=d;return}function Xob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55648]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(55656,tMb(+h[(c[g>>2]|0)+24056>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[55648]=1;i=d;return}function Yob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55760]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(55768,tMb(+h[(c[g>>2]|0)+24024>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[55760]=1;i=d;return}function Zob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55880]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(55888,tMb(+h[(c[g>>2]|0)+24008>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[55880]=1;i=d;return}function _ob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56016]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+24e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(56024,tMb(+h[(c[g>>2]|0)+24e3>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[56016]=1;i=d;return}function $ob(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56160]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(56168,tMb(+h[(c[g>>2]|0)+23992>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[56160]=1;i=d;return}function apb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56320]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(56328,tMb(+h[(c[g>>2]|0)+23984>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[56320]=1;i=d;return}function bpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56480]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(56488,tMb(+h[(c[g>>2]|0)+23960>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[56480]=1;i=d;return}function cpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56648]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(56656,tMb(+h[(c[g>>2]|0)+23952>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[56648]=1;i=d;return}function dpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56816]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(56824,tMb(+h[(c[g>>2]|0)+23944>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[56816]=1;i=d;return}function epb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56984]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(56992,tMb(+h[(c[g>>2]|0)+23936>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[56984]=1;i=d;return}function fpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57168]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(57176,tMb(+h[(c[g>>2]|0)+23928>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[57168]=1;i=d;return}function gpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57344]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(57352,tMb(+h[(c[g>>2]|0)+23920>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[57344]=1;i=d;return}function hpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57520]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(57528,tMb(+h[(c[g>>2]|0)+23904>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[57520]=1;i=d;return}function ipb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57696]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(57704,tMb(+h[(c[g>>2]|0)+23896>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[57696]=1;i=d;return}function jpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57872]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(57880,tMb(+h[(c[g>>2]|0)+23864>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[57872]=1;i=d;return}function kpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58032]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(58040,tMb(+h[(c[g>>2]|0)+23856>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[58032]=1;i=d;return}function lpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58192]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(58200,tMb(+h[(c[g>>2]|0)+23848>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[58192]=1;i=d;return}function mpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58352]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(58360,tMb(+h[(c[g>>2]|0)+23840>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[58352]=1;i=d;return}function npb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58512]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(58520,tMb(+h[(c[g>>2]|0)+23832>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[58512]=1;i=d;return}function opb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58680]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(58688,tMb(+h[(c[g>>2]|0)+23824>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[58680]=1;i=d;return}function ppb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58848]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(58856,tMb(+h[(c[g>>2]|0)+23816>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[58848]=1;i=d;return}function qpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59e3]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(59008,tMb(+h[(c[g>>2]|0)+23808>>3],24152)|0)|0;g=c[69978]|0;j=e;k=139056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[59e3]=1;i=d;return}function rpb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59168]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+864>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+864>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=xMb(59176,vMb(c[(c[g>>2]|0)+864>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=139528;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[59168]=1;i=d;return}function spb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59616]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+860>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+860>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=xMb(59624,vMb(c[(c[g>>2]|0)+860>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=139944;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[59616]=1;i=d;return}function tpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60008]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(60016,tMb(+h[(c[g>>2]|0)+23784>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[60008]=1;i=d;return}function upb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60144]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23776>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(60152,tMb(+h[(c[g>>2]|0)+23776>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[60144]=1;i=d;return}function vpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60296]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(60304,tMb(+h[(c[g>>2]|0)+23768>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[60296]=1;i=d;return}function wpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60448]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(60456,tMb(+h[(c[g>>2]|0)+23720>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[60448]=1;i=d;return}function xpb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60584]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+23712>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(60592,tMb(+h[(c[g>>2]|0)+23712>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[60584]=1;i=d;return}function ypb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60720]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+548>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+548>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(60728,vMb(c[(c[g>>2]|0)+548>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[60720]=1;i=d;return}



function Fwb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125512]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+156>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+156>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(125520,vMb(c[(c[g>>2]|0)+156>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[125512]=1;i=d;return}function Gwb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125744]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+152>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+152>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(125752,vMb(c[(c[g>>2]|0)+152>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[125744]=1;i=d;return}function Hwb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125960]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+148>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+148>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(125968,vMb(c[(c[g>>2]|0)+148>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[125960]=1;i=d;return}function Iwb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126176]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+144>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+144>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(126184,vMb(c[(c[g>>2]|0)+144>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[126176]=1;i=d;return}function Jwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126392]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20280>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(126400,tMb(+h[(c[g>>2]|0)+20280>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[126392]=1;i=d;return}function Kwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126544]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20272>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(126552,tMb(+h[(c[g>>2]|0)+20272>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[126544]=1;i=d;return}function Lwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126696]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20264>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(126704,tMb(+h[(c[g>>2]|0)+20264>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[126696]=1;i=d;return}function Mwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126848]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(126856,tMb(+h[(c[g>>2]|0)+20256>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[126848]=1;i=d;return}function Nwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126984]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(126992,tMb(+h[(c[g>>2]|0)+20248>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[126984]=1;i=d;return}function Owb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127120]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(127128,tMb(+h[(c[g>>2]|0)+20240>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[127120]=1;i=d;return}function Pwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127256]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(127264,tMb(+h[(c[g>>2]|0)+20232>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[127256]=1;i=d;return}function Qwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127384]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(127392,tMb(+h[(c[g>>2]|0)+20216>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[127384]=1;i=d;return}function Rwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127544]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(127552,tMb(+h[(c[g>>2]|0)+20208>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[127544]=1;i=d;return}function Swb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127704]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+140>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+140>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(127712,vMb(c[(c[g>>2]|0)+140>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[127704]=1;i=d;return}function Twb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127920]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+136>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+136>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(127928,vMb(c[(c[g>>2]|0)+136>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[127920]=1;i=d;return}function Uwb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128136]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+132>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+132>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(128144,vMb(c[(c[g>>2]|0)+132>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[128136]=1;i=d;return}function Vwb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128352]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+128>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+128>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(128360,vMb(c[(c[g>>2]|0)+128>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[128352]=1;i=d;return}function Wwb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128552]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+124>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+124>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(128560,vMb(c[(c[g>>2]|0)+124>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[128552]=1;i=d;return}function Xwb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128752]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+120>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+120>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(128760,vMb(c[(c[g>>2]|0)+120>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[128752]=1;i=d;return}function Ywb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128952]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20176>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(128960,tMb(+h[(c[g>>2]|0)+20176>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[128952]=1;i=d;return}function Zwb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129096]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20168>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(129104,tMb(+h[(c[g>>2]|0)+20168>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[129096]=1;i=d;return}function _wb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129240]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20160>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(129248,tMb(+h[(c[g>>2]|0)+20160>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[129240]=1;i=d;return}function $wb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129384]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20152>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(129392,tMb(+h[(c[g>>2]|0)+20152>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[129384]=1;i=d;return}function axb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129512]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20144>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(129520,tMb(+h[(c[g>>2]|0)+20144>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[129512]=1;i=d;return}function bxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129640]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(129648,tMb(+h[(c[g>>2]|0)+20136>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[129640]=1;i=d;return}function cxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129768]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(129776,tMb(+h[(c[g>>2]|0)+20128>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[129768]=1;i=d;return}function dxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129888]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(129896,tMb(+h[(c[g>>2]|0)+20120>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[129888]=1;i=d;return}function exb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130024]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(130032,tMb(+h[(c[g>>2]|0)+20112>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[130024]=1;i=d;return}function fxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130144]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(130152,tMb(+h[(c[g>>2]|0)+20104>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[130144]=1;i=d;return}function gxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130264]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(130272,tMb(+h[(c[g>>2]|0)+20096>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[130264]=1;i=d;return}function hxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130416]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(130424,tMb(+h[(c[g>>2]|0)+20088>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[130416]=1;i=d;return}function ixb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130568]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+116>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+116>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(130576,vMb(c[(c[g>>2]|0)+116>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[130568]=1;i=d;return}function jxb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130792]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+112>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+112>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(130800,vMb(c[(c[g>>2]|0)+112>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[130792]=1;i=d;return}function kxb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131016]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+108>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+108>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(131024,vMb(c[(c[g>>2]|0)+108>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[131016]=1;i=d;return}function lxb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131240]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+104>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+104>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(131248,vMb(c[(c[g>>2]|0)+104>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[131240]=1;i=d;return}function mxb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131448]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+100>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+100>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(131456,vMb(c[(c[g>>2]|0)+100>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[131448]=1;i=d;return}function nxb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131656]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+96>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+96>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(131664,vMb(c[(c[g>>2]|0)+96>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[131656]=1;i=d;return}function oxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131864]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20080>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(131872,tMb(+h[(c[g>>2]|0)+20080>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[131864]=1;i=d;return}function pxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132016]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20072>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(132024,tMb(+h[(c[g>>2]|0)+20072>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[132016]=1;i=d;return}function qxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132168]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20064>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(132176,tMb(+h[(c[g>>2]|0)+20064>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[132168]=1;i=d;return}function rxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132320]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(132328,tMb(+h[(c[g>>2]|0)+20056>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[132320]=1;i=d;return}function sxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132448]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(132456,tMb(+h[(c[g>>2]|0)+20048>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[132448]=1;i=d;return}function txb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132576]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(132584,tMb(+h[(c[g>>2]|0)+20040>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[132576]=1;i=d;return}function uxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132704]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(132712,tMb(+h[(c[g>>2]|0)+20032>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[132704]=1;i=d;return}function vxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132824]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(132832,tMb(+h[(c[g>>2]|0)+20016>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[132824]=1;i=d;return}function wxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132984]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+20008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(132992,tMb(+h[(c[g>>2]|0)+20008>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[132984]=1;i=d;return}function xxb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133136]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+92>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+92>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(133144,vMb(c[(c[g>>2]|0)+92>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[133136]=1;i=d;return}function yxb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133344]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+88>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+88>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(133352,vMb(c[(c[g>>2]|0)+88>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[133344]=1;i=d;return}function zxb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133552]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+84>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+84>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(133560,vMb(c[(c[g>>2]|0)+84>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[133552]=1;i=d;return}function Axb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133760]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+80>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+80>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(133768,vMb(c[(c[g>>2]|0)+80>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[133760]=1;i=d;return}function Bxb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133952]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+76>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+76>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(133960,vMb(c[(c[g>>2]|0)+76>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[133952]=1;i=d;return}function Cxb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134144]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+72>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+72>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(134152,vMb(c[(c[g>>2]|0)+72>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[134144]=1;i=d;return}function Dxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134336]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19976>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(134344,tMb(+h[(c[g>>2]|0)+19976>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[134336]=1;i=d;return}function Exb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134472]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19968>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(134480,tMb(+h[(c[g>>2]|0)+19968>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[134472]=1;i=d;return}function Fxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134608]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19960>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(134616,tMb(+h[(c[g>>2]|0)+19960>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[134608]=1;i=d;return}function Gxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134744]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(134752,tMb(+h[(c[g>>2]|0)+19952>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[134744]=1;i=d;return}function Hxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134864]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(134872,tMb(+h[(c[g>>2]|0)+19944>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[134864]=1;i=d;return}function Ixb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134984]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(134992,tMb(+h[(c[g>>2]|0)+19936>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[134984]=1;i=d;return}function Jxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135104]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(135112,tMb(+h[(c[g>>2]|0)+19928>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[135104]=1;i=d;return}function Kxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135216]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(135224,tMb(+h[(c[g>>2]|0)+19896>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[135216]=1;i=d;return}function Lxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135360]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(135368,tMb(+h[(c[g>>2]|0)+19880>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[135360]=1;i=d;return}function Mxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135520]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(135528,tMb(+h[(c[g>>2]|0)+19872>>3],24152)|0)|0;g=c[69978]|0;j=e;k=135664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[135520]=1;i=d;return}function Nxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135688]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(135696,tMb(+h[(c[g>>2]|0)+19864>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[135688]=1;i=d;return}function Oxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135848]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(135856,tMb(+h[(c[g>>2]|0)+19856>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[135848]=1;i=d;return}function Pxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136008]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(136016,tMb(+h[(c[g>>2]|0)+19832>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[136008]=1;i=d;return}function Qxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136200]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(136208,tMb(+h[(c[g>>2]|0)+19824>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[136200]=1;i=d;return}function Rxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136392]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(136400,tMb(+h[(c[g>>2]|0)+19816>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[136392]=1;i=d;return}function Sxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136584]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(136592,tMb(+h[(c[g>>2]|0)+19808>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[136584]=1;i=d;return}function Txb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136792]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(136800,tMb(+h[(c[g>>2]|0)+19800>>3],24152)|0)|0;g=c[69978]|0;j=e;k=136968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[136792]=1;i=d;return}function Uxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136992]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19792>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(137e3,tMb(+h[(c[g>>2]|0)+19792>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[136992]=1;i=d;return}function Vxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137192]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19776>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(137200,tMb(+h[(c[g>>2]|0)+19776>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[137192]=1;i=d;return}function Wxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137392]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(137400,tMb(+h[(c[g>>2]|0)+19768>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[137392]=1;i=d;return}function Xxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137592]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(137600,tMb(+h[(c[g>>2]|0)+19736>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[137592]=1;i=d;return}function Yxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137776]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(137784,tMb(+h[(c[g>>2]|0)+19728>>3],24152)|0)|0;g=c[69978]|0;j=e;k=137936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[137776]=1;i=d;return}function Zxb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137960]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(137968,tMb(+h[(c[g>>2]|0)+19720>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[137960]=1;i=d;return}function _xb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138144]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19712>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(138152,tMb(+h[(c[g>>2]|0)+19712>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[138144]=1;i=d;return}function $xb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138328]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(138336,tMb(+h[(c[g>>2]|0)+19704>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[138328]=1;i=d;return}function ayb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138520]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19696>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(138528,tMb(+h[(c[g>>2]|0)+19696>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[138520]=1;i=d;return}function byb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138712]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(138720,tMb(+h[(c[g>>2]|0)+19688>>3],24152)|0)|0;g=c[69978]|0;j=e;k=138864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[138712]=1;i=d;return}function cyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138888]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(138896,tMb(+h[(c[g>>2]|0)+19680>>3],24152)|0)|0;g=c[69978]|0;j=e;k=139056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[138888]=1;i=d;return}function dyb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139080]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+800>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+800>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=xMb(139088,vMb(c[(c[g>>2]|0)+800>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=139528;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[139080]=1;i=d;return}function eyb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139552]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+796>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+796>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=xMb(139560,vMb(c[(c[g>>2]|0)+796>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=139944;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[139552]=1;i=d;return}function fyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139968]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19656>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(139976,tMb(+h[(c[g>>2]|0)+19656>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[139968]=1;i=d;return}function gyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140128]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(140136,tMb(+h[(c[g>>2]|0)+19648>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[140128]=1;i=d;return}function hyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140304]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(140312,tMb(+h[(c[g>>2]|0)+19640>>3],24152)|0)|0;g=c[69978]|0;j=e;k=140456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[140304]=1;i=d;return}function iyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140480]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(140488,tMb(+h[(c[g>>2]|0)+19592>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[140480]=1;i=d;return}function jyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140616]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19584>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(140624,tMb(+h[(c[g>>2]|0)+19584>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[140616]=1;i=d;return}function kyb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140752]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+68>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+68>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(140760,vMb(c[(c[g>>2]|0)+68>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[140752]=1;i=d;return}function lyb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140944]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+64>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+64>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(140952,vMb(c[(c[g>>2]|0)+64>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[140944]=1;i=d;return}function myb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141136]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+60>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+60>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(141144,vMb(c[(c[g>>2]|0)+60>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[141136]=1;i=d;return}function nyb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141328]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+792>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+792>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(141336,vMb(c[(c[g>>2]|0)+792>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=143056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[141328]=1;i=d;return}function oyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141656]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19552>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(141664,tMb(+h[(c[g>>2]|0)+19552>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[141656]=1;i=d;return}function pyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141832]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(141840,tMb(+h[(c[g>>2]|0)+19544>>3],24152)|0)|0;g=c[69978]|0;j=e;k=141984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[141832]=1;i=d;return}function qyb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142008]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+56>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+56>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(142016,vMb(c[(c[g>>2]|0)+56>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[142008]=1;i=d;return}function ryb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142232]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+52>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+52>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(142240,vMb(c[(c[g>>2]|0)+52>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[142232]=1;i=d;return}function syb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142456]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+48>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+48>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(142464,vMb(c[(c[g>>2]|0)+48>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=142680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[142456]=1;i=d;return}function tyb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142704]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+788>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+788>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(142712,vMb(c[(c[g>>2]|0)+788>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=143056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[142704]=1;i=d;return}function uyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143080]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(143088,tMb(+h[(c[g>>2]|0)+19512>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[143080]=1;i=d;return}function vyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143200]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(143208,tMb(+h[(c[g>>2]|0)+19504>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[143200]=1;i=d;return}function wyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143320]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(143328,tMb(+h[(c[g>>2]|0)+19480>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[143320]=1;i=d;return}function xyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143448]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(143456,tMb(+h[(c[g>>2]|0)+19472>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[143448]=1;i=d;return}function yyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143576]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(143584,tMb(+h[(c[g>>2]|0)+19448>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[143576]=1;i=d;return}function zyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143712]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(143720,tMb(+h[(c[g>>2]|0)+19440>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[143712]=1;i=d;return}function Ayb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143840]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(143848,tMb(+h[(c[g>>2]|0)+19416>>3],24152)|0)|0;g=c[69978]|0;j=e;k=143968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[143840]=1;i=d;return}function Byb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143992]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(144e3,tMb(+h[(c[g>>2]|0)+19408>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[143992]=1;i=d;return}function Cyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144144]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(144152,tMb(+h[(c[g>>2]|0)+19400>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[144144]=1;i=d;return}function Dyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144296]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(144304,tMb(+h[(c[g>>2]|0)+19392>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144416;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[144296]=1;i=d;return}function Eyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144440]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(144448,tMb(+h[(c[g>>2]|0)+19376>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[144440]=1;i=d;return}function Fyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144600]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(144608,tMb(+h[(c[g>>2]|0)+19368>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[144600]=1;i=d;return}function Gyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144760]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(144768,tMb(+h[(c[g>>2]|0)+19360>>3],24152)|0)|0;g=c[69978]|0;j=e;k=144896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[144760]=1;i=d;return}function Hyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144920]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(144928,tMb(+h[(c[g>>2]|0)+19352>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[144920]=1;i=d;return}function Iyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145064]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(145072,tMb(+h[(c[g>>2]|0)+19288>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[145064]=1;i=d;return}function Jyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145208]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(145216,tMb(+h[(c[g>>2]|0)+19280>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[145208]=1;i=d;return}function Kyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145336]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(145344,tMb(+h[(c[g>>2]|0)+19272>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[145336]=1;i=d;return}function Lyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145464]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(145472,tMb(+h[(c[g>>2]|0)+19264>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[145464]=1;i=d;return}function Myb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145624]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(145632,tMb(+h[(c[g>>2]|0)+19256>>3],24152)|0)|0;g=c[69978]|0;j=e;k=145760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[145624]=1;i=d;return}function Nyb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145784]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+44>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+44>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(145792,vMb(c[(c[g>>2]|0)+44>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[145784]=1;i=d;return}function Oyb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145984]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+40>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+40>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(145992,vMb(c[(c[g>>2]|0)+40>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[145984]=1;i=d;return}function Pyb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146184]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+36>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+36>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(146192,vMb(c[(c[g>>2]|0)+36>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[146184]=1;i=d;return}function Qyb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146408]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+32>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+32>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(146416,vMb(c[(c[g>>2]|0)+32>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[146408]=1;i=d;return}function Ryb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146592]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+28>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+28>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(146600,vMb(c[(c[g>>2]|0)+28>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[146592]=1;i=d;return}function Syb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146776]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+24>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+24>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(146784,vMb(c[(c[g>>2]|0)+24>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=146960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[146776]=1;i=d;return}function Tyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146984]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19248>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(146992,tMb(+h[(c[g>>2]|0)+19248>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[146984]=1;i=d;return}function Uyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147144]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19240>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(147152,tMb(+h[(c[g>>2]|0)+19240>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[147144]=1;i=d;return}function Vyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147304]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19232>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(147312,tMb(+h[(c[g>>2]|0)+19232>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[147304]=1;i=d;return}function Wyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147464]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(147472,tMb(+h[(c[g>>2]|0)+19224>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[147464]=1;i=d;return}function Xyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147600]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(147608,tMb(+h[(c[g>>2]|0)+19216>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[147600]=1;i=d;return}function Yyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147736]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(147744,tMb(+h[(c[g>>2]|0)+19208>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[147736]=1;i=d;return}function Zyb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147872]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(147880,tMb(+h[(c[g>>2]|0)+19200>>3],24152)|0)|0;g=c[69978]|0;j=e;k=147976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[147872]=1;i=d;return}function _yb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148e3]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(148008,tMb(+h[(c[g>>2]|0)+19184>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[148e3]=1;i=d;return}function $yb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148168]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(148176,tMb(+h[(c[g>>2]|0)+19176>>3],24152)|0)|0;g=c[69978]|0;j=e;k=148304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[148168]=1;i=d;return}function azb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148328]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+20>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+20>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(148336,vMb(c[(c[g>>2]|0)+20>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[148328]=1;i=d;return}function bzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148512]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+16>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+16>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(148520,vMb(c[(c[g>>2]|0)+16>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[148512]=1;i=d;return}function czb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148696]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+12>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+12>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(148704,vMb(c[(c[g>>2]|0)+12>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=148880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[148696]=1;i=d;return}function dzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148904]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+8>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+8>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(148912,vMb(c[(c[g>>2]|0)+8>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[148904]=1;i=d;return}function ezb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149072]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+4>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+4>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(149080,vMb(c[(c[g>>2]|0)+4>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[149072]=1;i=d;return}function fzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149240]&1){i=d;return}g=b+420|0;b=aPb(+(c[c[g>>2]>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[c[g>>2]>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(149248,vMb(c[c[g>>2]>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=149408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[149240]=1;i=d;return}function gzb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149432]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19144>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(149440,tMb(+h[(c[g>>2]|0)+19144>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[149432]=1;i=d;return}function hzb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149576]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19136>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(149584,tMb(+h[(c[g>>2]|0)+19136>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[149576]=1;i=d;return}function izb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149720]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19128>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=xMb(149728,tMb(+h[(c[g>>2]|0)+19128>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[149720]=1;i=d;return}function jzb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149864]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(149872,tMb(+h[(c[g>>2]|0)+19120>>3],24152)|0)|0;g=c[69978]|0;j=e;k=149968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[149864]=1;i=d;return}function kzb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149992]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(15e4,tMb(+h[(c[g>>2]|0)+19112>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[149992]=1;i=d;return}function lzb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150120]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(150128,tMb(+h[(c[g>>2]|0)+19104>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[150120]=1;i=d;return}function mzb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150248]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(150256,tMb(+h[(c[g>>2]|0)+19096>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[150248]=1;i=d;return}function nzb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150368]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(150376,tMb(+h[(c[g>>2]|0)+19088>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[150368]=1;i=d;return}function ozb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150520]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(150528,tMb(+h[(c[g>>2]|0)+19080>>3],24152)|0)|0;g=c[69978]|0;j=e;k=150648;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[150520]=1;i=d;return}function pzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150672]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+784>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+784>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=xMb(150680,vMb(c[(c[g>>2]|0)+784>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=150864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[150672]=1;i=d;return}function qzb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150888]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+19032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(150896,tMb(+h[(c[g>>2]|0)+19032>>3],24152)|0)|0;g=c[69978]|0;j=e;k=151096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[150888]=1;i=d;return}function rzb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151120]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+18976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(151128,tMb(+h[(c[g>>2]|0)+18976>>3],24152)|0)|0;g=c[69978]|0;j=e;k=151224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[151120]=1;i=d;return}function szb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151248]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+18912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(151256,tMb(+h[(c[g>>2]|0)+18912>>3],24152)|0)|0;g=c[69978]|0;j=e;k=151352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[151248]=1;i=d;return}function tzb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151376]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+18904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(151384,tMb(+h[(c[g>>2]|0)+18904>>3],24152)|0)|0;g=c[69978]|0;j=e;k=151488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[151376]=1;i=d;return}function uzb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151512]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+18896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(151520,tMb(+h[(c[g>>2]|0)+18896>>3],24152)|0)|0;g=c[69978]|0;j=e;k=151616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[151512]=1;i=d;return}function vzb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151640]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+18888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(151648,tMb(+h[(c[g>>2]|0)+18888>>3],24152)|0)|0;g=c[69978]|0;j=e;k=151776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[151640]=1;i=d;return}function wzb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151800]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+18856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(151808,tMb(+h[(c[g>>2]|0)+18856>>3],24152)|0)|0;g=c[69978]|0;j=e;k=151920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[151800]=1;i=d;return}function xzb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151944]&1){i=d;return}g=b+416|0;if(!((aPb(+h[(c[g>>2]|0)+18848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(151952,tMb(+h[(c[g>>2]|0)+18848>>3],24152)|0)|0;g=c[69978]|0;j=e;k=152032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[151944]=1;i=d;return}function yzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152056]&1){i=d;return}g=b+420|0;b=aPb(+(c[(c[g>>2]|0)+768>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[g>>2]|0)+768>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=xMb(152064,vMb(c[(c[g>>2]|0)+768>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=152296;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[152056]=1;i=d;return}function zzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152320]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1304>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1304>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(152328,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1304>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[152320]=1;i=d;return}function Azb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152592]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1300>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1300>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(152600,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1300>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[152592]=1;i=d;return}function Bzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152776]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1296>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1296>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(152784,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1296>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[152776]=1;i=d;return}function Czb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152960]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1292>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1292>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(152968,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1292>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[152960]=1;i=d;return}function Dzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153136]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1288>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1288>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(153144,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1288>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[153136]=1;i=d;return}function Ezb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153312]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1284>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1284>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(153320,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1284>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[153312]=1;i=d;return}function Fzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153488]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1280>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1280>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(153496,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1280>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[153488]=1;i=d;return}function Gzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153696]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1276>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1276>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(153704,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1276>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[153696]=1;i=d;return}function Hzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153904]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1272>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1272>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(153912,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1272>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[153904]=1;i=d;return}function Izb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154112]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1268>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1268>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(154120,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1268>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[154112]=1;i=d;return}function Jzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154336]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1264>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1264>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(154344,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1264>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[154336]=1;i=d;return}function Kzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154560]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1260>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1260>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(154568,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1260>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[154560]=1;i=d;return}function Lzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154784]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1256>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1256>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(154792,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1256>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[154784]=1;i=d;return}function Mzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154952]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1252>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1252>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(154960,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1252>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[154952]=1;i=d;return}function Nzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155120]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1248>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1248>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(155128,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1248>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[155120]=1;i=d;return}function Ozb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155288]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1244>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1244>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(155296,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1244>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[155288]=1;i=d;return}function Pzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155488]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1240>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1240>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(155496,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1240>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[155488]=1;i=d;return}function Qzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155688]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1236>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1236>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(155696,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1236>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[155688]=1;i=d;return}function Rzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155888]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1232>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1232>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(155896,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1232>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[155888]=1;i=d;return}function Szb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156104]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1228>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1228>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(156112,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1228>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[156104]=1;i=d;return}function Tzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156320]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1224>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1224>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(156328,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1224>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[156320]=1;i=d;return}function Uzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156536]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1220>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1220>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(156544,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1220>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[156536]=1;i=d;return}function Vzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156760]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1216>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1216>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(156768,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1216>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[156760]=1;i=d;return}function Wzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156984]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1212>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1212>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(156992,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1212>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[156984]=1;i=d;return}function Xzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157208]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1208>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1208>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(157216,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1208>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[157208]=1;i=d;return}function Yzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157440]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1204>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1204>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(157448,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1204>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[157440]=1;i=d;return}function Zzb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157672]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1200>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1200>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(157680,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1200>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[157672]=1;i=d;return}function _zb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157904]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1196>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1196>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(157912,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1196>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[157904]=1;i=d;return}



function _Lb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;Xc(h|0,2048,d|0,g|0)|0;oe[c[58530]&31](5,2,0,h,0,b);if((a|0)==0){j=kd(c[57846]|0)|0}else{j=a}cb(c[j+76>>2]|0,1)}function $Lb(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;_Lb(a,e,234256,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;WLb(26,0,e,234192,m);i=j;return+b}return 0.0}function aMb(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=aec(16)|0;YLb(0,(d|0)!=0|0,234304,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function bMb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;bec(c[f>>2]|0);bec(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function cMb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;YLb(0,(a|0)!=0|0,234320,f);f=aec(8)|0;g=f;YLb(0,(f|0)!=0|0,234304,e);e=a+8|0;h=aec(c[e>>2]|0)|0;c[f>>2]=h;YLb(0,(h|0)!=0|0,234304,d);Gec(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function dMb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;YLb(0,(a|0)!=0|0,234320,f);f=aec(8)|0;g=f;YLb(0,(f|0)!=0|0,234304,e);e=a+8|0;h=aec(c[e>>2]|0)|0;c[f>>2]=h;YLb(0,(h|0)!=0|0,234304,d);Gec(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function eMb(a){a=a|0;var b=0;b=i;i=i+8|0;YLb(0,(a|0)!=0|0,234320,b);i=b;return c[a+12>>2]|0}function fMb(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;YLb(0,(a|0)!=0|0,234320,d);d=a;YLb(0,(c[d>>2]|0)!=0|0,234344,b);i=b;return c[c[d>>2]>>2]|0}function gMb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;bec(c[e>>2]|0);bec(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function hMb(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;YLb(0,(a|0)!=0|0,234320,d);d=a;YLb(0,(c[d>>2]|0)!=0|0,234360,b);i=b;return c[d>>2]|0}function iMb(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;YLb(0,d&1,234392,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function jMb(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;YLb(0,(a|0)!=0|0,234392,d);d=a;YLb(0,(c[d>>2]|0)!=0|0,234416,b);i=b;return c[d>>2]|0}function kMb(){var a=0,b=0,d=0;a=i;b=aec(16)|0;c[58622]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=aec(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function lMb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=pMb(a)|0;rc(234496)|0;qMb(d);a=c[58622]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;dc(234496)|0;Iec(g|0,0,d|0)|0;i=b;return g|0}function mMb(){var a=0,b=0,d=0,e=0;a=i;b=c[58622]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;bec(c[b>>2]|0);bec(b);if((d|0)==0){break}else{b=d}}e=c[58622]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function nMb(a){a=a|0;var b=0,d=0;b=i;d=ge[c[234448>>2]&127](a<<3)|0;i=b;return d|0}function oMb(a){a=a|0;var b=0,d=0;b=i;d=ge[c[234448>>2]&127](a<<2)|0;i=b;return d|0}function pMb(a){a=a|0;i=i;return a+7&-8|0}function qMb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[58622]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=aec(16)|0;c[f+12>>2]=d;c[58622]=f;c[f+4>>2]=0;d=rMb((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=aec(d)|0;c[f>>2]=a;i=b;return}function rMb(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function sMb(a){a=a|0;var b=0,c=0;b=i;c=Eec(a|0)|0;i=b;return c|0}function tMb(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;Kec(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];fc(m|0,l|0,f|0)|0;f=uMb(m)|0;i=e;return f|0}function uMb(a){a=a|0;var b=0,c=0,d=0;b=i;c=Eec(a|0)|0;d=wMb(c)|0;Gec(d|0,a|0,c|0)|0;i=b;return d|0}function vMb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;h=i;i=i+400|0;j=g;k=h;a[j]=37;Kec(g+1|0,d|0)|0;c[f>>2]=b;fc(k|0,j|0,f|0)|0;f=uMb(k)|0;i=e;return f|0}function wMb(b){b=b|0;var d=0,e=0;d=i;e=ge[c[234452>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function xMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=sMb(a)|0;e=sMb(b)|0;f=wMb(e+d|0)|0;Gec(f|0,a|0,d|0)|0;Gec(f+d|0,b|0,e|0)|0;i=c;return f|0}function yMb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Aec(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function zMb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 3:{f=2;break a;break};case 2:{f=4;break a;break};case 0:{f=8;break a;break};case 1:{f=4;break a;break};case 5:{f=1;break a;break};case 4:{f=2;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function AMb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){Wc(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){bec(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{bec(c[(c[f>>2]|0)+(g<<4)>>2]|0);bec(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;bec(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){bec(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{bec(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}bec(d);c[g>>2]=0;i=b;return}function BMb(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(Eec(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function CMb(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=gc(b|0,234680)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Ud(c[(Lc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=yd(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=qb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=234688;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[234656+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=234712;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=234736;E=131;break}G=zMb(D)|0;if((G|0)==-1){n=234768;E=131;break}D=c[q>>2]|0;H=aec(D)|0;if((qb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=234816;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=234840;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((Aec(H,c[234632+(C<<2)>>2]|0)|0)!=0){n=234864;E=131;break}bec(H);H=235440;b:do{switch(C|0){case 4:{if(d<<24>>24==1){if((D|0)==0){n=235128;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=235184;E=131;break a}c[w>>2]=D;F=fa(I,D)|0;if((a[l]|0)==1){G=aec(F<<3)|0;c[x>>2]=G;if((qb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=235224;E=131;break a}}else{G=aec(F<<2)|0;c[x>>2]=aec(fa(D<<3,I)|0)|0;if((qb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=235224;E=131;break a}if((F|0)!=0){K=c[x>>2]|0;L=0;do{h[K+(L<<3)>>3]=+g[G+(L<<2)>>2];L=L+1|0;}while(L>>>0<F>>>0)}bec(G)}F=c[w>>2]|0;if(!(F>>>0>1)){M=1;E=130;break b}L=(I|0)==2;K=1;while(1){if(L){N=c[x>>2]|0;if(+h[N+(K<<3)>>3]!=+h[N+(F+K<<3)>>3]){n=235256;E=131;break a}}N=K+1|0;if(N>>>0<F>>>0){K=N}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){O=d;E=129;break b}if((I|0)==0){n=235128;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=235336;E=131;break a}c[w>>2]=I;K=fa(I,D)|0;if((a[l]|0)==1){F=aec(K<<3)|0;c[x>>2]=aec(fa(D<<3,I)|0)|0;if((qb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=235224;E=131;break a}if((D|0)!=0){L=0;do{G=c[x>>2]|0;N=0;do{h[G+((fa(I,L)|0)+N<<3)>>3]=+h[F+((fa(D,N)|0)+L<<3)>>3];N=N+1|0;}while(N>>>0<I>>>0);L=L+1|0;}while(L>>>0<D>>>0)}bec(F)}else{L=aec(K<<2)|0;c[x>>2]=aec(fa(D<<3,I)|0)|0;if((qb(L|0,J|0,1,c[m>>2]|0)|0)!=1){n=235224;E=131;break a}if((D|0)!=0){N=0;do{G=c[x>>2]|0;P=0;do{h[G+((fa(I,N)|0)+P<<3)>>3]=+g[L+((fa(D,P)|0)+N<<2)>>2];P=P+1|0;}while(P>>>0<I>>>0);N=N+1|0;}while(N>>>0<D>>>0)}bec(L)}N=c[w>>2]|0;if(!(N>>>0>1)){M=d;E=130;break b}K=(D|0)==2;F=1;while(1){if(K){P=c[x>>2]|0;if(+h[P+(F<<3)>>3]!=+h[P+(N+F<<3)>>3]){n=235256;E=131;break a}}P=F+1|0;if(P>>>0<N>>>0){F=P}else{M=d;E=130;break}}break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=235376;E=131;break a}c[z>>2]=D;c[A>>2]=wb(c[m>>2]|0)|0;c[B>>2]=cec(c[z>>2]<<1,4)|0;if((Uc(c[m>>2]|0,J|0,1)|0)==-1){n=235408;E=131;break a}else{M=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=235376;E=131;break a}c[z>>2]=I;c[A>>2]=wb(c[m>>2]|0)|0;c[B>>2]=cec(c[z>>2]<<1,4)|0;F=fa(I,D)|0;if((a[l]|0)==1){N=aec(F<<3)|0;if((qb(N|0,J|0,1,c[m>>2]|0)|0)!=1){n=235408;E=131;break a}if((I|0)!=0){K=D<<3;L=(D|0)==0;P=D<<3;G=0;do{Q=aec(K)|0;c[(c[B>>2]|0)+(G<<2)>>2]=Q;if(!L){Q=N+(fa(P,G)|0)|0;Gec(c[(c[B>>2]|0)+(G<<2)>>2]|0,Q|0,P|0)|0}G=G+1|0;}while(G>>>0<I>>>0)}G=c[z>>2]|0;P=G<<1;if(G>>>0<P>>>0){L=D<<3;K=(D|0)==0;Q=G;do{R=aec(L)|0;c[(c[B>>2]|0)+(Q<<2)>>2]=R;if(!K){R=c[B>>2]|0;S=c[R+(Q-G<<2)>>2]|0;T=c[R+(Q<<2)>>2]|0;R=0;do{h[T+(R<<3)>>3]=-+h[S+(R<<3)>>3];R=R+1|0;}while(R>>>0<D>>>0)}Q=Q+1|0;}while(Q>>>0<P>>>0)}bec(N)}else{P=aec(F<<2)|0;if((qb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=235408;E=131;break a}if((I|0)!=0){Q=D<<3;G=(D|0)==0;K=0;do{L=aec(Q)|0;c[(c[B>>2]|0)+(K<<2)>>2]=L;if(!G){L=c[(c[B>>2]|0)+(K<<2)>>2]|0;R=0;do{h[L+(R<<3)>>3]=+g[P+((fa(D,K)|0)+R<<2)>>2];R=R+1|0;}while(R>>>0<D>>>0)}K=K+1|0;}while(K>>>0<I>>>0)}K=c[z>>2]|0;G=K<<1;if(K>>>0<G>>>0){Q=D<<3;F=(D|0)==0;N=K;do{R=aec(Q)|0;c[(c[B>>2]|0)+(N<<2)>>2]=R;if(!F){R=c[B>>2]|0;L=c[R+(N-K<<2)>>2]|0;S=c[R+(N<<2)>>2]|0;R=0;do{h[S+(R<<3)>>3]=-+h[L+(R<<3)>>3];R=R+1|0;}while(R>>>0<D>>>0)}N=N+1|0;}while(N>>>0<G>>>0)}bec(P)}if((Uc(c[m>>2]|0,J|0,1)|0)==-1){n=235408;E=131;break a}else{M=d;E=130}break};case 1:{G=d<<24>>24==0;c[u>>2]=G?D:I;N=aec((G?D:I)<<4)|0;c[v>>2]=N;c:do{if(d<<24>>24==1){if((I|0)==0){U=0;break}K=D+1|0;F=N;Q=0;while(1){c[F+(Q<<4)>>2]=aec(K)|0;if((qb(c[(c[v>>2]|0)+(Q<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=235064;E=131;break a}a[(c[(c[v>>2]|0)+(Q<<4)>>2]|0)+D|0]=0;R=c[v>>2]|0;c[R+(Q<<4)+8>>2]=-1;c[R+(Q<<4)+12>>2]=-1;BMb(c[R+(Q<<4)>>2]|0);R=Q+1|0;if(!(R>>>0<I>>>0)){U=I;break c}F=c[v>>2]|0;Q=R}}else{U=I}}while(0);if(!G){M=d;E=130;break b}N=fa(D,U)|0;V=aec(N+1|0)|0;if((qb(V|0,N|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){N=U+1|0;P=(U|0)==0;Q=0;do{F=aec(N)|0;c[(c[v>>2]|0)+(Q<<4)>>2]=F;if(!P){F=0;do{K=a[V+((fa(D,F)|0)+Q)|0]|0;a[(c[(c[v>>2]|0)+(Q<<4)>>2]|0)+F|0]=K;F=F+1|0;}while(F>>>0<U>>>0)}a[(c[(c[v>>2]|0)+(Q<<4)>>2]|0)+U|0]=0;F=c[v>>2]|0;c[F+(Q<<4)+8>>2]=-1;c[F+(Q<<4)+12>>2]=-1;BMb(c[F+(Q<<4)>>2]|0);Q=Q+1|0;}while(Q>>>0<D>>>0)}bec(V);M=0;E=130;break};case 2:{if(d<<24>>24==1){if((I|0)==0){O=1;E=129;break b}Q=D+1|0;P=0;while(1){N=aec(Q)|0;c[(c[v>>2]|0)+(P<<4)+4>>2]=N;if((qb(c[(c[v>>2]|0)+(P<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=235064;E=131;break a}a[(c[(c[v>>2]|0)+(P<<4)+4>>2]|0)+D|0]=0;N=P+1|0;if(N>>>0<I>>>0){P=N}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){O=d;E=129;break b}P=fa(D,I)|0;W=aec(P+1|0)|0;if((qb(W|0,P|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){P=I+1|0;Q=(I|0)==0;N=0;do{G=aec(P)|0;c[(c[v>>2]|0)+(N<<4)+4>>2]=G;if(!Q){G=0;do{F=a[W+((fa(D,G)|0)+N)|0]|0;a[(c[(c[v>>2]|0)+(N<<4)+4>>2]|0)+G|0]=F;G=G+1|0;}while(G>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(N<<4)+4>>2]|0)+I|0]=0;N=N+1|0;}while(N>>>0<D>>>0)}bec(W);M=0;E=130;break};case 0:{if((D|0)!=4){n=234888;E=131;break a}if((I|0)!=11){n=234928;E=131;break a}if((qb(f|0,44,1,c[m>>2]|0)|0)==1){X=0}else{n=234968;E=131;break a}while(1){N=0;do{a[k+N|0]=a[j+((N<<2)+X)|0]|0;N=N+1|0;}while(N>>>0<11);a[k+11|0]=0;if((X|0)==3){break}N=X+1|0;if(N>>>0<4){X=N}else{M=d;E=130;break b}}if((Bec(t,c[58634]|0,8)|0)==0){M=1;E=130;break b}if((Bec(t,c[58640]|0,9)|0)==0){M=0;E=130}else{n=235e3;E=131;break a}break};case 3:{N=fa(I<<2,D)|0;Y=aec(N)|0;if((qb(Y|0,N|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==0){if((D|0)==0){break}N=c[v>>2]|0;Q=0;do{c[N+(Q<<4)+8>>2]=(c[Y+(Q<<2)>>2]|0)==1;c[N+(Q<<4)+12>>2]=c[Y+(D+Q<<2)>>2];Q=Q+1|0;}while(Q>>>0<D>>>0)}else if(d<<24>>24==1){if((I|0)==0){break}Q=c[v>>2]|0;N=0;do{P=fa(D,N)|0;c[Q+(N<<4)+8>>2]=(c[Y+(P<<2)>>2]|0)==1;c[Q+(N<<4)+12>>2]=c[Y+(P+1<<2)>>2];N=N+1|0;}while(N>>>0<I>>>0)}}while(0);bec(Y);ac(c[v>>2]|0,c[u>>2]|0,16,53);M=d;E=130;break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=O;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=M;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){bec(V);n=235064;i=e;return n|0}else if((E|0)==46){bec(W);n=235064;i=e;return n|0}else if((E|0)==52){bec(Y);n=235096;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function DMb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=Cd(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,53)|0;i=d;return b|0}function EMb(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=235480;o=n;p=235528;q=p;r=235552;s=r;ab(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=235480;o=n;p=235528;q=p;r=235552;s=r;ab(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=aec(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Uc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((qb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}bec(r);t=0;i=e;return t|0}else{k=aec(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Uc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((qb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}bec(k);bec(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);bec(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function FMb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=235480;r=q;s=235528;t=s;u=235576;v=u;ab(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=235480;r=q;s=235528;t=s;u=235576;v=u;ab(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Uc(o|0,t+(r<<3)|0,0)|0;f=(qb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Uc(o|0,t+(r<<2)|0,0)|0;if((qb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function GMb(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function HMb(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function IMb(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function JMb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+IMb(b)<e){q=1;i=f;return q|0}if(+HMb(b)>e){q=1;i=f;return q|0}if((EMb(b,1)|0)==0){q=1;i=f;return q|0}GMb(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+FMb(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+FMb(a,b,d,o);i=f;return q|0}if(+FMb(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+FMb(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function KMb(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function LMb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;ELb(a,b,d,g);i=f;return}function MMb(a,b){a=a|0;b=b|0;var c=0;c=i;ILb(a,b,nMb(b)|0);i=c;return}function NMb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=nMb(JLb(a,b,f)|0)|0;i=e;return}function OMb(a){a=a|0;var b=0;b=i;c[a+8>>2]=nMb(HLb(a)|0)|0;i=b;return}function PMb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;if((FLb(a)|0)==0){ab(235608,235632,127,235656)}if((FLb(b)|0)==0){ab(235680,235632,128,235656)}if((GLb(a,b)|0)==0){ab(235704,235632,129,235656)}e=HLb(a)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=+KMb(a,b);QMb(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function QMb(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function RMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if((FLb(a)|0)==0){ab(235608,235632,142,235744)}d=HLb(a)|0;if((d|0)==0){i=c;return}else{e=0}do{h[b+(e<<3)>>3]=+KMb(a,e);e=e+1|0;}while(e>>>0<d>>>0);i=c;return}function SMb(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function TMb(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;QMb(c[d+8>>2]|0,b,a);i=e;return}function UMb(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;MMb(a,b);j=g;c[g>>2]=e;TMb(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;TMb(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function VMb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=LLb(a,b,f)|0;f=SMb(c[a+8>>2]|0,d)|0;i=e;return f|0}function WMb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0.0;e=i;f=HLb(a)|0;if((f|0)==0){i=e;return}g=d+8|0;d=0;do{h=+KMb(a,d);j=h+ +KMb(b,d);QMb(c[g>>2]|0,d,j);d=d+1|0;}while(d>>>0<f>>>0);i=e;return}function XMb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;YMb(a,c);OMb(c);WMb(a,b,c);i=d;return}function YMb(a,b){a=a|0;b=b|0;var c=0;c=i;KLb(a,b);i=c;return}function ZMb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=aec(20)|0;YLb(0,(f|0)!=0|0,235776,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=cec(e,b)|0;c[f>>2]=a;YLb(0,(a|0)!=0|0,235776,d);i=d;return f|0}function _Mb(a){a=a|0;var b=0;b=i;bec(c[a>>2]|0);bec(a);i=b;return}function $Mb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;YLb(0,(c[h>>2]|0)>0|0,235792,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;YLb(0,(g|0)>(b|0)|0,235816,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;YLb(0,(0-f|0)<(b|0)|0,235816,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function aNb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=cec(c[d>>2]<<1,c[e>>2]|0)|0;YLb(0,(f|0)!=0|0,235776,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=$Mb(a,j)|0;h=c[e>>2]|0;Gec(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;bec(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function bNb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){aNb(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;Gec((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function cNb(a){a=a|0;i=i;return c[a+12>>2]|0}function dNb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;YLb(0,(c[j>>2]|0)>0|0,235792,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;YLb(0,(h|0)>(b|0)|0,235816,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;YLb(0,b>>>31^1,235816,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=$Mb(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function eNb(a){a=a|0;i=i;return c[(c[58962]|0)+(a<<2)>>2]|0}function fNb(a){a=a|0;i=i;return c[(c[58964]|0)+(a<<2)>>2]|0}function gNb(a){a=a|0;i=i;return c[(c[58966]|0)+(a<<2)>>2]|0}function hNb(a){a=a|0;i=i;return c[(c[58968]|0)+(a<<2)>>2]|0}function iNb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[58964]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[58966]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[58962]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function jNb(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[58970]|0;e=+kNb(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function kNb(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function lNb(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[58972]|0;e=+kNb(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function mNb(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[58974]|0;e=+kNb(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function nNb(a){a=a|0;i=i;return 0}function oNb(a){a=a|0;var b=0,d=0;b=i;eb(4,(c[58976]|0)+(a<<3)|0)|0;d=(c[58962]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function pNb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[58970]|0;f=e+(a<<3)|0;g=c[58974]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[58968]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[58962]|0)+(a<<2)>>2]|0);e=c[58972]|0;g=e+(a<<3)|0;qNb(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;iNb(a);d=c[58970]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[58962]|0)+(a<<2)>>2]=0;i=b;return}function qNb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(tNb(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function rNb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;eb(4,d|0)|0;e=c[58976]|0;f=c[58970]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function sNb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=cec(a,8)|0;c[58970]=d;e=cec(a,8)|0;c[58972]=e;f=cec(a,8)|0;c[58974]=f;g=cec(a,8)|0;c[58976]=g;h=cec(a,4)|0;c[58962]=h;j=cec(a,4)|0;c[58968]=j;k=a<<2;l=aec(k)|0;c[58964]=l;m=cec(a,4)|0;c[58966]=m;Iec(l|0,-1,k|0)|0;if((d|0)==0){ab(235912,235928,393,235944)}if((e|0)==0){ab(235952,235928,394,235944)}if((f|0)==0){ab(235968,235928,395,235944)}if((g|0)==0){ab(235984,235928,396,235944)}if((h|0)==0){ab(236e3,235928,397,235944)}if((l|0)==0){ab(236024,235928,398,235944)}if((m|0)==0){ab(236048,235928,399,235944)}if((j|0)==0){ab(236072,235928,400,235944)}else{i=b;return}}function tNb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function uNb(a){a=a|0;var b=0;b=i;bec(c[a+12>>2]|0);bec(c[a+4>>2]|0);bec(c[a+8>>2]|0);i=b;return}function vNb(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[30311]=.5;h[30297]=1.0;h[30334]=.25;h[30309]=2.0;h[30336]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[60630]=A;B=c[d>>2]|0;c[60560]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[60560]=D;if((C|0)<(B|0)){C=D}else{break}}}c[60558]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[30312]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[30312]=F;G=F}else{G=E}D=c[d>>2]|0;c[60560]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[60560]=I;if((H|0)>=(D|0)){break a}E=+h[30312];H=I}}}while(0);D=C+1|0;c[60558]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[30316]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[30281]=0.0;h[30283]=0.0;h[30287]=0.0;h[30344]=0.0;c[60556]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[30281]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[30283]+ +h[B>>3]*F;h[30283]=E;F=+h[I>>3];M=+h[30287]+F*F;h[30287]=M;F=+h[H>>3];h[30344]=+h[30344]+F*F;H=A+1|0;c[60556]=H;F=+h[30281];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[60626]=A;E=G/J;h[30333]=E;C=c[d>>2]|0;c[60560]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[30341]=0.0;h[30343]=0.0;I=c[b>>2]|0;c[60556]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[30310]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[30341]=ba;ca=E+aa*aa;h[30343]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[60556]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[60626]=A;h[30333]=E;h[30283]=Z;h[30287]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[60560]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[60556]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[60556]=A+1;da=+h[30283];ea=+h[30287];ga=+h[30281]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[30332]=K;c[60654]=0;h[30340]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[60654]=C;K=+h[30297]/+V(+ga);h[30312]=K;h[30335]=0.0;h[30337]=0.0;B=c[b>>2]|0;c[60556]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[30335]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[30335]=oa;pa=+h[30337]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[30337]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[30283];L=+h[30281];N=+h[30312];D=D+1|0;la=ma}c[60556]=B+1;ia=+h[30281];ja=pa;ka=oa}N=+h[30311];L=ka*N*ka;h[30328]=L;J=ja*N*ja;h[30329]=J;h[30288]=J+(L+ia*(+h[30344]+ia*N));N=+h[30309];h[242312>>3]=N*ka*ia;h[242320>>3]=N*ja*ia;h[242328>>3]=L-J;h[242336>>3]=ka*ja;la=242344|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[60556]=10;la=c[d>>2]|0;c[60560]=1;if((la|0)>=1){D=1;while(1){h[30328]=0.0;h[30329]=0.0;h[30330]=0.0;A=c[b>>2]|0;c[60556]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[30328]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[30329]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[30330]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[60556]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[30334]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[30328]*+h[30330];h[t+(U+D<<3)>>3]=+h[30329]*+h[30330];J=+h[30328];L=+h[30329];h[t+(P+D<<3)>>3]=+h[30334]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[30311]*+h[30328]*+h[30329];na=D+1|0;c[60560]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[60556]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[60568]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[60556]=B;if((la|0)<(D|0)){la=B}else{break}}}c[60564]=1;la=1;do{D=c[d>>2]|0;c[60572]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[60572]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[60560]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[60560]=D+1}na=c[60630]|0;c[60558]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[30308]=0.0;ma=c[d>>2]|0;c[60560]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[30308]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[60560]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[30308]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[60560]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[30308];Ca=Ca+1|0}c[60560]=ta+1}Ca=B+1|0;c[60558]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[60560]=1;if((A|0)<1){break}else{Ea=1}while(1){h[30308]=0.0;B=c[b>>2]|0;c[60558]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[30308]=N;Ca=na+1|0;c[60558]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[60560]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[60558]=1;if((A|0)>=1){ta=1;while(1){h[30308]=0.0;c[60556]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[30308]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[60556]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[60558]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[60564]=la;}while((la|0)<6);la=c[l>>2]|0;c[60560]=1;h[30308]=0.0;c[60556]=1;L=+h[30311];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[242384+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[242384+(A+ -1<<3)>>3]+L;h[30308]=L;A=A+1|0;}while((A|0)<6);h[30288]=+h[30288]- +h[30298]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[30328]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[30329]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[30330]=O;h[242312>>3]=+h[242312>>3]-J-N*(O+K);h[242344>>3]=+h[242344>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[30328]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[30329]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[30330]=J;h[242320>>3]=+h[242320>>3]-O-N*(K-J);h[242352>>3]=+h[242352>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[30328]=J;h[242328>>3]=+h[242400>>3]+(+h[242328>>3]-J- +h[242392>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[30328]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[30329]=K;Oa=+h[30311];h[242336>>3]=+h[242336>>3]-J-K*Oa;h[242360>>3]=+h[242360>>3]- +h[242408>>3]+ +h[242416>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[30328]=K;h[242368>>3]=+h[242368>>3]-Oa*K;h[30308]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[60560]=la+1;c[60556]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[242384+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[242384+(ta+ -1<<3)>>3]+N;h[30308]=N;ta=ta+1|0;c[60556]=ta;}while((ta|0)<6);K=+h[30316];h[30318]=K*+h[30288]+ +h[30298]+N;J=+h[30309];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[30328]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[30329]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[30330]=R;T=R+(K*+h[242312>>3]+O+S);h[242552>>3]=T;O=K*+h[242344>>3]+S-R;h[242584>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[30328]=R;S=+h[I>>3]*+h[ma>>3];h[30329]=S;Z=+h[Ma>>3]*+h[Na>>3];h[30330]=Z;h[242560>>3]=K*+h[242320>>3]+R+S-Z;h[242592>>3]=K*+h[242352>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[30328]=Z;R=+h[242392>>3]+(Z+K*+h[242328>>3])- +h[242400>>3];h[242568>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[30328]=Z;h[242576>>3]=Z+K*+h[242336>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[242360>>3]+ +h[242408>>3]- +h[242416>>3];h[242600>>3]=J;h[242608>>3]=+h[30316]*+h[242368>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[30318]+T+R+O+J;h[30308]=K;h[30338]=K;h[30339]=K;c[60662]=0;J=+h[30336]/50.0;h[30312]=J;h[30298]=+h[30297];c[60556]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[242392>>3]=Z;W=+Y(+Pa);h[242400>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[242384+(Ma+ -1<<3)>>3]=Z;Q=+h[242392>>3]*G+ +h[242400>>3]*W;h[242384+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[242400>>3];ca=+h[242392>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[242544+(Ma<<3)>>3]*+h[242384+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[30339]=Ra;c[60662]=Na;h[30328]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[30329]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[60558]=10;h[30308]=Ra;h[30317]=Pa;h[30342]=O;c[60556]=50;if((Xa|0)==0){h[30328]=Ra;Ya=Ra;Za=Va}else if((Xa|0)==49){h[30329]=K;Ya=Wa;Za=K}else{Ya=Wa;Za=Va}h[30314]=0.0;if(Ya!=Za){S=Ya-Ua;h[30328]=S;T=Za-Ua;h[30329]=T;R=+h[30311]*(S-T)/(S+T);h[30314]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[30317]=R;T=+X(+R);h[242392>>3]=T;S=+Y(+R);h[242400>>3]=S;c[60558]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[242384+(Na+ -1<<3)>>3]=T;W=+h[242392>>3]*G+ +h[242400>>3]*S;h[242384+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[242400>>3];N=+h[242392>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[30339]=0.0;c[60558]=1;Na=1;do{ma=Na+ -1|0;Ma=242384+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[242304+(ma<<3)>>3]*+h[Ma>>3];h[30339]=+h[30339]+ +h[242544+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[60558]=10;Na=c[l>>2]|0;c[60560]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[242384+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[60558]=6;c[60560]=Na+1}h[30307]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[30281]=0.0;h[30328]=0.0;h[30329]=0.0;Ma=c[b>>2]|0;c[60556]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[242392>>3]*+h[la>>3]+ +h[242400>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[30281]=+h[30281]+G*G;bb=+h[30328]+ +h[la>>3]*+h[ta>>3];h[30328]=bb;G=+h[ta>>3];cb=+h[30329]+G*G;h[30329]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[60556]=Ma+1;$a=cb;ab=bb}ma=c[60654]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[30340];S=+h[30338];h[30340]=G>=S?G:S}S=+h[30339];if(!(S>=0.0)){db=-S}else{db=S}G=+h[30340];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[30340]=S;c[60556]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[30312]=N;R=+h[30307]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[30316];la=ta+1|0;c[60556]=la;if((ta|0)>=(Na|0)){break b}S=+h[30329];G=+h[30328];ta=la}}}while(0);Na=c[d>>2]|0;c[60560]=1;if((Na|0)>=1){Ma=1;while(1){h[30308]=0.0;ta=c[b>>2]|0;c[60558]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[30308]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[60558]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[30307]*+h[p+(la+ -1+Ma<<3)>>3]- +h[30316]*+h[q+(Ma+ -1<<3)>>3]);h[30312]=G;c[60556]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[30312];I=I+1|0}c[60556]=la+1}I=Ma+1|0;c[60560]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[30287]=0.0;h[30283]=0.0;Ma=c[b>>2]|0;c[60556]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[30287]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[30283]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[60556]=Ma+1;hb=kb;ib=jb}S=+h[30281];G=S*ib-hb*hb;h[30332]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[242280]=1;C=c[l>>2]|0;c[60560]=1;if((C|0)<1){lb=242376;mb=+h[30297];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[242384+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[60558]=6;c[60560]=C+1;lb=242376;mb=+h[30297];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function wNb(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[30364]=.5;h[30360]=1.0;h[30376]=6.283185307179586;z=+h[n>>3];h[30373]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[60734]=A;c[60742]=0;B=c[d>>2]|0;c[60694]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[60694]=B+1}c[60692]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[30365]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[30365]=F;G=F}else{G=z}H=c[d>>2]|0;c[60694]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[30365];I=I+1|0}c[60694]=H+1}I=B+1|0;c[60692]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[30348]=0.0;D=c[b>>2]|0;c[60690]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[30348]=+h[30348]+G*G;A=p+1|0;c[60690]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[60694]=1;if((p|0)>=1){D=1;while(1){h[30365]=0.0;h[30363]=0.0;y=c[b>>2]|0;c[60692]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[30365]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[30363]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[60692]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[30365]=G;h[30363]=+h[g>>3]*L;g=c[b>>2]|0;c[60690]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[30363]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[30365];H=H+1|0}c[60690]=g+1}H=D+1|0;c[60694]=H;if((D|0)<(p|0)){D=H}else{break}}}h[30349]=0.0;h[30351]=0.0;h[30358]=0.0;D=c[b>>2]|0;c[60690]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[30349]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[30351]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[30358]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[60690]=D+1;O=R;P=T;Q=S}S=+h[30348];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[30369]=U;h[30365]=0.0;if(Q*Q>S*.99*O){h[30365]=+h[30360]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[30364]*U*Z);h[30361]=P;if(O*+h[30373]<P*P*.01){h[30365]=+h[30360]}n=c[b>>2]|0;c[60690]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[30369]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[30365]*U;if((D|0)>=(n|0)){break}e=D;P=+h[30369];D=D+1|0;p=e}c[60690]=n+1;_=0}while(1){n=_+1|0;c[60742]=n;h[30348]=0.0;h[30351]=0.0;h[30352]=0.0;p=c[b>>2]|0;c[60690]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[30348]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[30351]=da;Z=+h[H>>3];ea=P+Z*Z;h[30352]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[60690]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[30365]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[30370]=U;D=c[b>>2]|0;c[60690]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[30370];U=+h[30351];O=+h[30348];g=g+1|0;H=e}c[60690]=D+1}H=c[d>>2]|0;c[60694]=1;if((H|0)>=1){g=1;while(1){h[30363]=0.0;p=c[b>>2]|0;c[60692]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[30363]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[60692]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[30363]=O;e=c[b>>2]|0;c[60690]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[30363];l=l+1|0}c[60690]=e+1}l=g+1|0;c[60694]=l;if((g|0)<(H|0)){g=l}else{break}}}h[30353]=0.0;h[30354]=0.0;h[30355]=0.0;h[30356]=0.0;h[30357]=0.0;g=c[b>>2]|0;c[60690]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[30353]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[30354]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[30355]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[30356]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[30357]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[60690]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[30364];O=U*na;h[30353]=O;P=U*ma-O;h[30356]=P;Z=O+la+P;h[30377]=Z;h[30379]=Z;h[30378]=Z;c[60744]=0;a[242800]=1;W=+h[30376]/50.0;h[30365]=W;c[60690]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[30379]=wa;c[60744]=p;h[30374]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[30375]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[30368]=ta;h[30359]=ua;h[30362]=va;h[30361]=wa;c[60690]=50;h[30378]=wa;if((za|0)==0){h[30374]=wa;ga=74}else if((za|0)==49){h[30375]=Z;Ba=Z}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[30375]}h[30366]=0.0;S=+h[30374];if(S!=Ba){Q=S-Aa;h[30374]=Q;S=Ba-Aa;h[30375]=S;T=U*(Q-S)/(Q+S);h[30366]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[30368]=T;S=+X(+T);h[30359]=S;Q=+Y(+T);h[30362]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[30361]=T;p=c[b>>2]|0;c[60690]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[30359]*+h[y>>3]+ +h[30362]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[30362];Q=+h[30359];H=H+1|0;g=e}c[60690]=p+1;Da=+h[30361]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[30377];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function xNb(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[243256]=1;a[243248]=1;c[243268>>2]=6;F2b(243264)|0;e=c[d>>2]|0;c[60810]=1;if((e|0)>=1){d=1;do{W1b(243384,b+(d+ -1)|0,1)|0;o=c[60810]|0;d=o+1|0;c[60810]=d;}while((o|0)<(e|0))}n2b()|0;e=c[g>>2]|0;if((e|0)==1){c[243292>>2]=a[243248]&1?6:0;F2b(243288)|0;W1b(243384,h,4)|0;n2b()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[243316>>2]=a[243248]&1?6:0;F2b(243312)|0;W1b(243384,h,4)|0;W1b(243384,j,4)|0;n2b()|0}j=c[k>>2]|0;if((j|0)==1){c[243340>>2]=a[243248]&1?6:0;F2b(243336)|0;W1b(243384,l,8)|0;n2b()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[243364>>2]=a[243248]&1?6:0;F2b(243360)|0;W1b(243384,l,8)|0;W1b(243384,m,8)|0;n2b()|0}if((c[f>>2]|0)==2){E1b(243392,0)|0}else{i=n;return 0}return 0}function yNb(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==0){c[60852]=2;B=2;while(1){C=B+1|0;if(!((c[k+(B+ -1<<2)>>2]|0)>>>0<2)){D=210;break a}c[60852]=C;if((C|0)<12){B=C}else{break}}if((c[d>>2]|0)<1){L1b(243464,245160,80,25);B=243768;C=243776;xNb(243464,245192,243944,B,243848,d,B,B,C,C,80)|0;break}c[60916]=5;C=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{B=c[C>>2]|0;c[60916]=B;if(!((B+ -1|0)>>>0>4)){E=B;break}L1b(243464,245200,80,34);B=243768;F=243776;xNb(243464,245240,243936,B,243848,243664,B,B,F,F,80)|0;break a}}while(0);c[C>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;B=fa(F,F)|0;c[60902]=B;c[60914]=B+50+(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0);B=q+12|0;if((c[k+16>>2]|0)==0){c[B>>2]=2;break}else{c[B>>2]=1;break}}else{B=c[q>>2]|0;do{if((B|0)>=0){F=c[d>>2]|0;if((B|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){L1b(243464,246024,80,52);I=243768;J=243776;xNb(243464,246008,246080,I,243848,G,I,I,J,J,80)|0;break a}c[60902]=fa((B<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[C>>2]|0)+4|0,H)|0;c[60914]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[60902]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[60914]=F+(c[60902]|0);break b}}}while(0);L1b(243464,245952,80,52);B=243768;F=243776;xNb(243464,246008,246016,B,243848,q,B,B,F,F,80)|0;break a}}while(0);c[60906]=(c[d>>2]|0)+20;c[q+64>>2]=c[60902];if((c[p>>2]|0)<(c[60914]|0)){L1b(243464,245248,80,60);C=243768;F=243776;xNb(243464,245312,245320,C,243944,243656,p,C,F,F,80)|0;break}if((c[r>>2]|0)<(c[60906]|0)){L1b(243464,245328,80,60);F=243768;C=243776;xNb(243464,245312,245392,F,243944,243624,r,F,C,C,80)|0;break}if(+h[j>>3]==+h[e>>3]){D=227;break}if((c[w>>2]|0)<0){L1b(243464,246136,80,24);C=243848;F=243768;B=243776;xNb(243464,246168,246176,C,C,w,F,F,B,B,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[30448]=K;if(!(K<=0.0)){break}L1b(243464,245632,80,28);B=243768;xNb(243464,244344,245664,B,B,B,B,243848,243584,243776,80)|0;break a}}while(0);c[q+60>>2]=0;B=q+36|0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;c[n>>2]=1;D=27}else if((A|0)==1){c[q+36>>2]=c[q+40>>2];D=27}else if((A|0)==-1){L1b(243464,243696,80,49);B=243768;F=243776;xNb(243464,243752,243760,B,B,B,B,B,F,F,80)|0;L1b(243464,243784,80,47);F=243768;B=243776;xNb(243464,243832,243840,F,243848,n,F,F,B,B,80)|0;L1b(243464,243856,80,41);B=243768;F=243776;xNb(243464,243904,243912,243848,B,B,B,B,F,F,80)|0;i=y;return 0}else{D=210}}while(0);c:do{if((D|0)==27){a[243640]=0;K=+h[l>>3];h[30459]=K;L=+h[m>>3];h[30452]=L;A=c[d>>2]|0;c[60852]=1;do{if((A|0)>=1){r=k+4|0;p=0;E=1;M=L;N=K;while(1){if((c[r>>2]|0)==1){F=E+ -1|0;O=+h[l+(F<<3)>>3];h[30459]=O;P=+h[m+(F<<3)>>3];h[30452]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[243640]=1;S=1}else{S=p}if(Q<0.0){D=215;break}if(R<0.0){D=216;break}F=E+1|0;c[60852]=F;if((E|0)<(A|0)){p=S;E=F;M=R;N=Q}else{D=36;break}}if((D|0)==36){if(!S){break}E=c[d>>2]|0;p=E+51|0;c[60862]=p;r=p+(c[w>>2]|0)|0;c[60864]=r;p=r+(c[w>>2]|0)|0;c[60886]=p;F=p+(c[w>>2]|0)|0;c[60856]=F;B=F+(c[d>>2]|0)|0;c[60892]=B;C=B+(c[d>>2]|0)|0;c[60898]=C;c[60888]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+C;c[60912]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){B=o+64|0;h[30461]=+h[B>>3];a[243576]=0;h[30430]=+h[o+24>>3];J=o+16|0;h[30425]=+h[J>>3];do{if((c[w>>2]|0)!=0){zNb(243944,v,w,d,243440,j,f,o+(F+ -1<<3)|0,o+(C+ -1<<3)|0,o+224|0,q+28|0,o+(E+50<<3)|0,o+(r+ -1<<3)|0,o+(p+ -1<<3)|0,x,243560,B,0,o,q,s,t)|0;if((c[60982]|0)>0){i=y;return 0}if((c[60890]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=243848;WNb(d,o+((c[60856]|0)+ -1<<3)|0,G,g,G)|0;a[243576]=1;D=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[30425];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[30425]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){D=227;break c}P=+h[30425];if((M-N)*P>0.0){D=220;break}B=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[30460]=O;U=+h[30430];V=U-O;G=V*P>0.0;do{if(B){if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[60898]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){ENb(243440,j,f,g,d,H,I,X)|0;if((c[60982]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[243576]=1;D=197;break d}}else{Y=243440;ENb(Y,Y,f,g,d,H,I,X)|0;if((c[60982]|0)>0){i=y;return 0}else{h[e>>3]=+h[30430];c[n>>2]=1;a[243576]=1;D=197;break d}}}else{if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U-W)<0.0){break}ENb(243440,j,f,g,d,q+28|0,o+((c[60898]|0)+ -1<<3)|0,o+224|0)|0;if((c[60982]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[243576]=1;D=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[30461]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[30425]=W;h[J>>3]=W;break}ENb(243440,243680,f,g,d,q+28|0,o+((c[60898]|0)+ -1<<3)|0,o+224|0)|0;if((c[60982]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[30460];a[243576]=1;D=197;break d}}else{W=+h[30430];if(!B){if(P*(W-N)<0.0){break}ENb(243440,j,f,g,d,q+28|0,o+((c[60898]|0)+ -1<<3)|0,o+224|0)|0;if((c[60982]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[243576]=1;D=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[60898]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){ENb(243440,j,f,g,d,G,X,I)|0;if((c[60982]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[243576]=1;D=197;break d}}else{H=243440;ENb(H,H,f,g,d,G,X,I)|0;if((c[60982]|0)>0){i=y;return 0}else{h[e>>3]=+h[30430];c[n>>2]=1;a[243576]=1;D=197;break d}}}}while(0);if(a[243576]&1){D=197}else{D=128}}else{h[30430]=+h[e>>3];c[n>>2]=1;BNb(d,k+4|0,l,m,f,o+((c[60892]|0)+ -1<<3)|0,s,t)|0;B=c[d>>2]|0;c[60852]=1;e:do{if((B|0)>=1){J=c[60892]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[60852]=X;if((I|0)<(B|0)){I=X}else{break e}}L1b(243464,245768,80,39);I=243768;J=243776;xNb(243464,245440,245808,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+INb(243920,1);h[30461]=U;B=o+64|0;h[B>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[30461]*4.0*(aa>=ba?aa:ba);h[30450]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){L1b(243464,245816,80,60);J=243768;xNb(243464,245312,245880,J,J,J,J,243944,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[30429]=ca*.001;U=+CNb(d,g,o+((c[60892]|0)+ -1<<3)|0,s,t);if(U>.5/+h[30429]){h[30429]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+I1b(243432,z);h[30429]=U;da=U}else{U=+h[o+16>>3];h[30429]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){D=220;break d}if(!(U==0.0)){da=U;break}L1b(243464,245720,80,29);J=243768;I=243776;xNb(243464,245752,245760,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[30429]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[30460]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){D=224;break}if(ea*(U+ea-O)>0.0){h[30429]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){D=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{DNb(243440,f,g,d,b,u,243432,o+((c[60892]|0)+ -1<<3)|0,n,s,t,o+((c[60898]|0)+ -1<<3)|0,o+400|0,o+((c[60856]|0)+ -1<<3)|0,o+((c[60888]|0)+ -1<<3)|0,q,243600,B,k+36|0,243648)|0;if((c[60982]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;D=129;break}ja=+h[30429]}h[30425]=ja;h[o+16>>3]=ja;J=c[60898]|0;X=(c[d>>2]|0)+J|0;c[60908]=X;G=c[d>>2]|0;c[60852]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[30425]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[60852]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[30425];h[o+232>>3]=+h[30425]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){D=128;break}zNb(243848,v,w,d,e,j,f,o+((c[60856]|0)+ -1<<3)|0,o+((c[60898]|0)+ -1<<3)|0,J,Y,o+((c[60862]|0)+ -1<<3)|0,o+((c[60864]|0)+ -1<<3)|0,o+((c[60886]|0)+ -1<<3)|0,x,243560,B,0,o,q,s,t)|0;if((c[60982]|0)>0){i=y;return 0}if((c[60890]|0)!=0){L1b(243464,246184,80,47);la=243768;ma=243776;xNb(243464,243832,246232,243848,la,la,la,la,ma,ma,80)|0;L1b(243464,246240,80,38);ma=243768;la=243776;xNb(243464,243992,246232,243848,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){D=128;break}if((c[I>>2]|0)==0){D=128;break}zNb(243936,v,w,d,243440,j,f,o+((c[60856]|0)+ -1<<3)|0,o+((c[60898]|0)+ -1<<3)|0,J,Y,o+((c[60862]|0)+ -1<<3)|0,o+((c[60864]|0)+ -1<<3)|0,o+((c[60886]|0)+ -1<<3)|0,x,243560,B,0,o,q,s,t)|0;if((c[60982]|0)>0){i=y;return 0}if((c[60890]|0)!=1){D=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=243848;WNb(d,o+((c[60856]|0)+ -1<<3)|0,H,g,H)|0;D=197}}while(0);if((D|0)==218){L1b(243464,245560,80,54);p=243768;xNb(243464,245616,245624,p,p,p,p,243944,243680,j,80)|0;break c}else if((D|0)==220){L1b(243464,245672,80,34);p=243768;xNb(243464,245240,245712,p,p,p,p,243944,j,e,80)|0;break c}else if((D|0)==224){L1b(243464,245888,80,49);p=243768;xNb(243464,243752,245944,p,p,p,p,243944,243680,e,80)|0;break c}f:while(1){if((D|0)==128){D=0;ka=c[n>>2]|0;D=129;continue}else if((D|0)==129){D=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){D=131;break}oa=k+4|0;BNb(d,oa,l,m,o+((c[60898]|0)+ -1<<3)|0,o+((c[60892]|0)+ -1<<3)|0,s,t)|0;if((c[60982]|0)>0){D=233;break}p=c[d>>2]|0;c[60852]=1;r=c[60892]|0;if((p|0)>=1){E=1;while(1){C=E+1|0;if(!(+h[o+(E+ -2+r<<3)>>3]>0.0)){D=136;break f}c[60852]=C;if((E|0)<(p|0)){E=C}else{break}}}O=+CNb(d,o+((c[60898]|0)+ -1<<3)|0,o+(r+ -1<<3)|0,s,t)*100.0;V=+h[30461];pa=O*V;h[30427]=pa;if(!(pa<=1.0)){D=138;break}O=+h[30430];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[30450]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[30425];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[30425]=V/O}}while(0);FNb(243440,f,g,d,b,u,243400,o+((c[60892]|0)+ -1<<3)|0,k,n,s,t,o+((c[60898]|0)+ -1<<3)|0,o+400|0,o+((c[60856]|0)+ -1<<3)|0,o+((c[60888]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,243600,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,243648)|0;if((c[60982]|0)>0){D=233;break}r=c[n>>2]|0;if((r|0)<0){na=r;break}do{if((c[w>>2]|0)!=0){zNb(243936,v,w,d,243440,j,f,o+((c[60856]|0)+ -1<<3)|0,o+((c[60898]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[60862]|0)+ -1<<3)|0,o+((c[60864]|0)+ -1<<3)|0,o+((c[60886]|0)+ -1<<3)|0,x,243560,o+64|0,0,o,q,s,t)|0;if((c[60982]|0)>0){D=233;break f}if((c[60890]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];r=243848;WNb(d,o+((c[60856]|0)+ -1<<3)|0,r,g,r)|0;D=197;continue f}}while(0);r=(c[k+8>>2]|0)!=0;O=+h[30430];V=+h[30425];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!r){if(U<0.0){D=128;continue}ENb(243440,j,f,g,d,q+28|0,o+((c[60898]|0)+ -1<<3)|0,o+224|0)|0;if((c[60982]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;D=197;continue}ENb(243440,j,f,g,d,q+28|0,o+((c[60898]|0)+ -1<<3)|0,o+224|0)|0;if((c[60982]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(r){if(U>=0.0){ENb(243440,j,f,g,d,q+28|0,o+((c[60898]|0)+ -1<<3)|0,o+224|0)|0;if((c[60982]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}N=O- +h[30460];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[30461]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;D=197;continue}ENb(243440,243680,f,g,d,q+28|0,o+((c[60898]|0)+ -1<<3)|0,o+224|0)|0;if((c[60982]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[30460];D=197;continue}if(!(U<0.0)){ENb(243440,j,f,g,d,q+28|0,o+((c[60898]|0)+ -1<<3)|0,o+224|0)|0;if((c[60982]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}U=+h[30460];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[30461]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){D=128;continue}h[30425]=U-O;D=128;continue}else{ENb(243440,243680,f,g,d,q+28|0,o+((c[60898]|0)+ -1<<3)|0,o+224|0)|0;if((c[60982]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[30460];D=197;continue}}else if((D|0)==197){D=0;h[o+24>>3]=+h[30430];h[o+16>>3]=+h[30425];h[o+328>>3]=+h[e>>3];D=233;break}}do{if((D|0)==131){c[n>>2]=-1;na=-1}else if((D|0)==136){c[n>>2]=-3;na=-3}else if((D|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[30427]*+h[m>>3];c[n>>2]=-2;na=-2;break}r=c[d>>2]|0;c[60852]=1;if((r|0)>=1){O=pa;E=1;p=0;while(1){B=l+(p<<3)|0;h[B>>3]=O*+h[B>>3];B=m+(E+ -1<<3)|0;h[B>>3]=+h[30427]*+h[B>>3];if((E|0)>=(r|0)){break}B=E;O=+h[30427];E=E+1|0;p=B}c[60852]=r+1}c[n>>2]=-2;na=-2}else if((D|0)==233){i=y;return 0}}while(0);p=0-na|0;c[60908]=p;switch(p|0){case 6:{L1b(243464,244360,80,44);p=243768;xNb(243464,244408,244416,p,p,p,p,243944,243440,243400,80)|0;L1b(243464,244424,80,57);p=243768;E=243776;xNb(243464,244488,244496,p,p,p,p,p,E,E,80)|0;break};case 7:{L1b(243464,244360,80,44);E=243768;xNb(243464,244408,244504,E,E,E,E,243944,243440,243400,80)|0;L1b(243464,244512,80,48);E=243768;p=243776;xNb(243464,244064,244568,E,E,E,E,E,p,p,80)|0;L1b(243464,244576,80,28);p=243768;E=243776;xNb(243464,244344,244608,p,p,p,p,p,E,E,80)|0;break};case 8:{L1b(243464,244360,80,44);E=243768;xNb(243464,244408,244616,E,E,E,E,243944,243440,243400,80)|0;L1b(243464,244624,80,37);E=243768;p=243776;xNb(243464,244664,244672,E,E,E,E,E,p,p,80)|0;break};case 9:{L1b(243464,244360,80,44);p=243768;xNb(243464,244408,244680,p,p,p,p,243944,243440,243400,80)|0;L1b(243464,244688,80,49);p=243768;E=243776;xNb(243464,243752,244744,p,p,p,p,p,E,E,80)|0;L1b(243464,244752,80,38);E=243768;p=243776;xNb(243464,243992,244792,E,E,E,E,E,p,p,80)|0;break};case 10:{L1b(243464,244360,80,44);p=243768;xNb(243464,244408,244800,p,p,p,p,243944,243440,243400,80)|0;L1b(243464,244808,80,45);p=243768;E=243776;xNb(243464,244248,244856,p,p,p,p,p,E,E,80)|0;L1b(243464,244864,80,36);E=243768;p=243776;xNb(243464,244904,244912,E,E,E,E,E,p,p,80)|0;break};case 11:{L1b(243464,244920,80,40);p=243768;xNb(243464,244968,244976,p,p,p,p,243944,243440,243400,80)|0;L1b(243464,244984,80,36);p=243768;E=243776;xNb(243464,244904,245024,p,p,p,p,p,E,E,80)|0;break};case 12:{L1b(243464,244360,80,44);E=243768;xNb(243464,244408,245032,E,E,E,E,243944,243440,243432,80)|0;L1b(243464,245040,80,45);E=243768;p=243776;xNb(243464,244248,245088,E,E,E,E,E,p,p,80)|0;break};case 5:case 4:{break};case 2:{L1b(243464,244080,80,47);p=243768;xNb(243464,243832,244128,p,p,p,p,243848,243440,243776,80)|0;L1b(243464,244136,80,48);p=243768;E=243776;xNb(243464,244064,244192,p,p,p,p,p,E,E,80)|0;L1b(243464,244200,80,45);E=243768;p=243776;xNb(243464,244248,244256,E,E,E,E,E,p,p,80)|0;break};case 3:{L1b(243464,244264,80,38);p=243768;xNb(243464,243992,244304,p,p,p,p,243848,243440,243776,80)|0;L1b(243464,244312,80,28);p=243768;E=243776;xNb(243464,244344,244352,p,p,p,p,p,E,E,80)|0;break};default:{L1b(243464,243952,80,38);E=243768;xNb(243464,243992,244e3,E,E,E,E,243848,243440,243776,80)|0;L1b(243464,244008,80,48);E=243768;p=243776;xNb(243464,244064,244072,E,E,E,E,E,p,p,80)|0}}c[k>>2]=-1;h[e>>3]=+h[30430];h[o+24>>3]=+h[30430];h[o+16>>3]=+h[30425];i=y;return 0}else if((D|0)==215){L1b(243464,245400,80,39);p=243768;E=243776;xNb(243464,245440,245448,p,p,p,p,p,E,E,80)|0;break c}else if((D|0)==216){L1b(243464,245456,80,39);E=243768;p=243776;xNb(243464,245440,245496,E,E,E,E,E,p,p,80)|0;break c}}}while(0);L1b(243464,245504,80,47);A=243768;p=243776;xNb(243464,243832,245552,A,A,A,A,A,p,p,80)|0}else if((D|0)==210){L1b(243464,245096,80,55);p=243768;A=243776;xNb(243464,245152,243848,p,p,p,p,p,A,A,80)|0}}while(0);if((D|0)==227){L1b(243464,246088,80,39);D=243768;xNb(243464,245440,246128,D,D,D,D,243944,j,e,80)|0}if((c[k>>2]|0)==-1){L1b(243464,246280,80,46);e=243768;j=243776;xNb(243464,246328,246336,e,e,e,e,e,j,j,80)|0;L1b(243464,246344,80,47);j=243768;e=243776;xNb(243464,243832,246392,243848,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function zNb(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[30800]=C;c[t>>2]=0;D=c[e>>2]|0;c[61602]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[61602]|0;E=F+1|0;c[61602]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[30807]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==3){J=C;K=+h[g>>3]}else if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;ENb(g,b,k,l,f,o,m,n)|0;if((c[60982]|0)>0){i=v;return 0}D=d;$d[D&7](f,b,k,e,p,y,z)|0;if((c[60982]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[246464]=0;F=c[e>>2]|0;c[61602]=1;if((F|0)<1){break}else{L=0;M=1}while(1){I=+h[p+(M+ -1<<3)>>3];if(!(I>=0.0)){N=-I}else{N=I}if(!(N<=0.0)){O=L}else{a[246464]=1;O=1}if((M|0)<(F|0)){L=O;M=M+1|0}else{break}}c[61602]=F+1;if(!O){break}I=+I1b(246456,246400);h[30804]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[30800];do{if((H- +h[g>>3])*I<0.0){ENb(g,b,k,l,f,o,m,n)|0;if((c[60982]|0)<=0){break}i=v;return 0}else{G=+h[30804]/I;h[30805]=G;P=c[f>>2]|0;c[61602]=1;if((P|0)<1){break}Q=(A<<1)+B|0;R=G;S=1;while(1){T=k+(S+ -1<<3)|0;h[T>>3]=+h[T>>3]+R*+h[m+(Q+S<<3)>>3];if((S|0)>=(P|0)){break}R=+h[30805];S=S+1|0}c[61602]=P+1}}while(0);$d[D&7](f,b,k,e,p,y,z)|0;if((c[60982]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[246464]=0;F=c[e>>2]|0;c[61602]=1;if((F|0)<1){break}else{U=0;V=1}while(1){S=V+ -1|0;I=+h[p+(S<<3)>>3];if(!(I>=0.0)){W=-I}else{W=I}if(W>0.0){X=U;Y=V}else{c[s+(S<<2)>>2]=1;a[246464]=1;X=1;Y=c[61602]|0}S=Y+1|0;c[61602]=S;if((Y|0)<(F|0)){U=X;V=S}else{break}}if(!X){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{J=+h[30800];K=I;break}}else{F=w+320|0;ENb(g,F,k,l,f,o,m,n)|0;if((c[60982]|0)>0){i=v;return 0}E=d;$d[E&7](f,F,k,e,p,y,z)|0;if((c[60982]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[246464]=0;D=c[e>>2]|0;c[61602]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[246464]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[61602]=D+1;if(!aa){i=v;return 0}I=+I1b(246456,246400);h[30804]=I;h[F>>3]=I+ +h[F>>3];I=+h[30804]/+h[30800];h[30805]=I;S=c[f>>2]|0;c[61602]=1;if((S|0)>=1){Q=(A<<1)+B|0;H=I;T=1;while(1){ba=k+(T+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(Q+T<<3)>>3];if((T|0)>=(S|0)){break}H=+h[30805];T=T+1|0}c[61602]=S+1}$d[E&7](f,F,k,e,p,y,z)|0;if((c[60982]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[246464]=0;T=c[e>>2]|0;c[61602]=1;if((T|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[246464]=1;fa=1}if((da|0)<(T|0)){ca=fa;da=da+1|0}else{break}}c[61602]=T+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-K)*J>=0.0)){h[30803]=ea;if((ea- +h[w+320>>3])*J<=0.0){i=v;return 0}ENb(g,246424,k,l,f,o,m,n)|0;if((c[60982]|0)<=0){break}i=v;return 0}else{h[30803]=K;j=c[f>>2]|0;c[61602]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[61602]=j+1}}while(0);ga=d;$d[ga&7](f,246424,k,e,q,y,z)|0;if((c[60982]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[61612]=0;T=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){ANb(e,246456,246448,T,246424,p,q,r,246416,s,fa,da,x,ca)|0;if((c[60982]|0)>0){ha=76;break}if((c[61612]|0)>1){ha=73;break}ENb(g,246416,k,l,f,o,m,n)|0;if((c[60982]|0)>0){ha=76;break}$d[ga&7](f,246416,k,e,r,y,z)|0;if((c[60982]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[T>>3]=+h[30802];T=243848;WNb(e,r,T,p,T)|0;if((c[61612]|0)==4){i=v;return 0}ENb(g,246416,k,l,f,o,m,n)|0;if((c[60982]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function ANb(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[61628]=c[o>>2];c[o>>2]=0;h[30810]=0.0;a[246496]=0;t=c[b>>2]|0;c[61618]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+I1b(246528,j+(v<<3)|0);if(w==+I1b(246528,l+((c[61618]|0)+ -1<<3)|0)){break}y=c[61618]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[30810]){break}h[30810]=B;c[o>>2]=y}else{a[246496]=1}}while(0);v=c[61618]|0;u=v+1|0;c[61618]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[246504]=1;c[61630]=c[p>>2];h[g>>3]=+h[r>>3];t=243848;WNb(b,l,t,k,t)|0;c[p>>2]=1;a[246488]=0;C=0}else{a[246504]=0;c[o>>2]=c[61628];c[61630]=c[p>>2];if(a[246496]&1){h[g>>3]=+h[r>>3];t=243848;WNb(b,l,t,k,t)|0;a[246488]=1;C=1;break}else{t=243848;WNb(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[246488]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[246488]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=243848;WNb(b,k,t,l,t)|0;t=c[b>>2]|0;c[61618]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[61618]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+I1b(246528,j+(u<<3)|0);if(!(A!=+I1b(246528,k+((c[61618]|0)+ -1<<3)|0))){break}c[n+((c[61618]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[61618]|0;F=u+1|0;c[61618]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[30810]=0.0;a[246496]=0;t=c[b>>2]|0;c[61618]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+I1b(246528,j+(v<<3)|0);if(A==+I1b(246528,k+((c[61618]|0)+ -1<<3)|0)){break}y=c[61618]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[30810]){break}h[30810]=I;c[o>>2]=y}else{a[246496]=1}}while(0);v=c[61618]|0;u=v+1|0;c[61618]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[246504]=t&1;if(t){a[246488]=0;c[61630]=0;c[p>>2]=1;break}if(!(a[246496]&1)){t=243848;WNb(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=243848;WNb(b,k,t,l,t)|0;t=c[b>>2]|0;c[61618]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[61618]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[61618]|0}u=K+1|0;c[61618]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[61630]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function BNb(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[30819]=+h[d>>3];h[30818]=+h[e>>3];j=c[a>>2]|0;c[61634]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[30819]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[30819]=o;h[30818]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[30818];a=l+1|0;c[61634]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function CNb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[30822]=0.0;e=c[a>>2]|0;c[61640]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[30822]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[61640]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[30821]=0.0;e=c[a>>2]|0;c[61640]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[30821]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[61640]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function DNb(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[61658]=0;c[61656]=0;c[61662]=0;h[30834]=+h[b>>3];h[30836]=+CNb(f,d,l,0,0);C=c[f>>2]|0;c[61646]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[61646]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[30827]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[61646]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[61646]=G+1}a[246680]=1;c[61648]=0;a[246696]=1;c[C>>2]=(c[C>>2]|0)+1;c[61666]=0;$d[B&7](b,d,e,q,246664,n,o)|0;b:do{if((c[61666]|0)<0){K=35}else{while(1){if(a[246680]&1){c[E>>2]=(c[E>>2]|0)+1;a[246680]=0;GNb(f,b,d,e,q,246616,k,246640,l,r,s,t,g,246664,v,j,n,o,x)|0;h[30826]=1.0e6;if((c[61666]|0)<0|(c[61660]|0)!=0){K=35;break b}c[61662]=0}H=c[f>>2]|0;c[61646]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[61646]=H+1}HNb(f,q,s,t)|0;I=c[f>>2]|0;c[61646]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[30827]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[61646]=I+1}N=+CNb(f,q,l,0,0);h[30838]=N;if(N<=+h[v>>3]*100.0*+h[30836]){break}J=c[61648]|0;if((J|0)>0){h[z>>3]=N/+h[30839];h[A>>3]=1.0/+(J|0);O=+G1b(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[30826]=P;Q=+h[30838];R=P}else{h[30839]=N;Q=N;R=+h[30826]}if(R*Q<=.33){break}J=c[61648]|0;H=J+1|0;c[61648]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[246680]=1}c[C>>2]=(c[C>>2]|0)+1;c[61666]=0;$d[B&7](b,d,e,q,246664,n,o)|0;if((c[61666]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[61646]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[61646]=H+1}N=+CNb(f,q,l,0,0);h[30838]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[61646]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[30827]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[61646]=J+1}}while(0);if(!(a[246696]&1)){break}H=c[f>>2]|0;c[61646]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[61646]=H+1}N=+CNb(f,r,l,0,0);h[30832]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[246696]=0}h[b>>3]=+h[30834];G=c[f>>2]|0;c[61646]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[61646]=G+1}if(a[246696]&1){I=(c[61658]|0)+1|0;c[61658]=I;N=.9/(+h[30832]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[30825]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[61660]|0)!=0){I=(c[61662]|0)+1|0;c[61662]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[61666]|0)>-2)){K=53;break}I=(c[61656]|0)+1|0;c[61656]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function ENb(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[61692]=o;p=+h[b>>3]- +h[a>>3];h[30844]=p;a=c[f>>2]|0;c[61684]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[61684]=a+1;q=+h[30844]}h[30840]=1.0;h[30841]=0.0;p=q/+h[k>>3];h[30845]=p;c[61686]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[30841]=u*t+s/+h[a>>3];p=t*s;h[30840]=p;h[30845]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[61684]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[30841]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[30840];g=g+1|0}c[61684]=a+1}g=v+1|0;c[61686]=g;if((v|0)>=(o|0)){break}r=+h[30844];s=+h[30840];t=+h[30845];u=+h[30841];v=g}i=l;return 0}function FNb(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[30867]=+h[b>>3];c[61712]=0;c[61720]=0;c[61714]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[30879]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[61708]=(c[I>>2]|0)+1;c[61710]=(c[I>>2]|0)+2;c[61706]=(c[I>>2]|0)+ -1;h[30867]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[61724]=$+1;$=c[61708]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[30870]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[61694]=2;if(($|0)>=2){Y=2;while(1){h[30871]=+h[y+(Y+ -2<<3)>>3];U=+h[30870];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[30871];U=+h[30871]+ +h[k>>3];h[30870]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[61694]=$+1}h[y+($+ -1<<3)>>3]=+h[30870]}h[30877]=0.0;h[30875]=0.0;Y=c[I>>2]|0;c[61694]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[30877]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[30875]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[61694]=Y+1;da=ea}h[30878]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[30877]- +h[30875];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[30852]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[30852]=ha>=ca?ha:ca;h[30870]=.6;h[30871]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[30878]){h[D>>3]=100.0}aa=c[61708]|0;ba=c[61724]|0;if((aa|0)>=(ba|0)){c[61696]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[61694]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[61694]=ba+1}ja=ia+1|0;c[61696]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[61694]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[61694]=ia+1}aa=c[61708]|0;c[61696]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[61694]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[61694]=$+1}la=ba+1|0;c[61696]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[30874]=+CNb(f,d,l,0,0);a[247040]=1;c[61698]=0;c[T>>2]=(c[T>>2]|0)+1;c[61728]=0;$d[m&7](b,d,e,r,246912,o,p)|0;if((c[61728]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;GNb(f,b,d,e,r,A,k,246864,l,s,t,u,g,246912,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[61728]|0)<0|(c[61716]|0)!=0){X=70;break}c[61720]=0}ba=c[f>>2]|0;c[61694]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[61694]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[30870]=ca;aa=c[f>>2]|0;c[61694]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[30870];ia=ia+1|0;la=ka}c[61694]=aa+1}HNb(f,r,t,u)|0;la=c[f>>2]|0;c[61694]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[61694]=la+1}U=+CNb(f,r,l,0,0);h[30879]=U;if(U<=+h[F>>3]*100.0*+h[30874]){X=63;break a}ia=c[61698]|0;if((ia|0)>0){h[O>>3]=U/+h[30881];h[P>>3]=1.0/+(ia|0);ca=+G1b(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[30879];oa=ga}else{h[30881]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[61698]|0;c[61698]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[61728]=0;$d[m&7](b,d,e,r,246912,o,p)|0;if((c[61728]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[61694]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[61694]=ba+1}U=+CNb(f,r,l,0,0);h[30879]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[61694]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[61694]=ia+1}}while(0);if((X|0)==70){X=0;a[247040]=0}c[H>>2]=1;if(a[247040]&1){U=+CNb(f,s,l,0,0);h[30873]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[30859]=ga;h[30866]=ga*+(ba+1|0);h[30861]=ga;c[61730]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[61694]=1;if((ba|0)>=1){aa=fa(c[61708]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[61694]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+CNb(f,r,l,0,0);h[30868]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[30876]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[61694]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[61694]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+CNb(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[30876];if((sa>=ca?sa:ca)>+h[30866]){break}ta=+h[30868];ua=Y}else{if(!(ga<=+h[30866]*.5)){break}else{ta=U;ua=ka}}c[61730]=ua+ -1;h[30861]=ta}}while(0);if(!(+h[30852]*+h[30873]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[30867];Y=c[61708]|0;ia=c[61724]|0;if((Y|0)>=(ia|0)){c[61696]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[30870]=ca;ia=c[f>>2]|0;c[61694]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[30870];ja=ja+1|0}c[61694]=ia+1}ja=aa+1|0;c[61696]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[61694]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[61694]=Y+1}if(!(a[247040]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[61716]|0)!=0){aa=(c[61720]|0)+1|0;c[61720]=aa;h[30850]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[61728]|0)>-2)){X=146;break}aa=(c[61712]|0)+1|0;c[61712]=aa;h[30850]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[61714]=(c[61714]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[61714]|0;if((aa|0)<=1){ja=c[61730]|0;c[I>>2]=ja;sa=+(ja+1|0);h[30871]=sa;h[O>>3]=+h[30861]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+G1b(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[30850]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[61730];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[61744]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[61730]|0;E=c[61706]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[61708];za=+h[k>>3]*2.0;h[30863]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[61706]|0;Ba=c[61730]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[61708]|0)>=(c[K>>2]|0)|(c[61744]|0)==1){Fa=G;break}G=c[f>>2]|0;c[61694]=1;if((G|0)>=1){E=fa(c[61710]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[61694]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+CNb(f,r,l,0,0);h[30869]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[30866];E=xa<=za;if(+h[30876]<=(E?xa:za)){Ea=c[61706]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[30866]*.5){Fa=S;break}}S=c[61708]|0;c[I>>2]=S;h[30861]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[30861]=+h[30868];Fa=Ea}h[30863]=+h[k>>3];ya=+(Fa+1|0);h[30871]=ya;h[O>>3]=+h[30861]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+G1b(O,P);h[30850]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[30863];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[30850]=xa;za=+h[k>>3]*xa;h[30863]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[30863]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[61694]=1;if((k|0)<1){break}u=fa(c[61710]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[61694]=k+1}}while(0);Ca=c[f>>2]|0;c[61694]=1;if((Ca|0)>=1){J=fa(c[61708]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[61694]=Ca+1}Ca=c[61708]|0;c[61702]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[61696]=P;s=c[f>>2]|0;c[61694]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[61694]=s+1}P=Ha+1|0;c[61702]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[61728]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[61714]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}ENb(b,b,d,e,f,I,q,y)|0;i=N;return 0}



function SCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188584]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+580>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+580>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(188592,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+580>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[188584]=1;i=d;return}function TCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188808]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+576>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+576>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(188816,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+576>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[188808]=1;i=d;return}function UCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189032]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+572>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+572>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(189040,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+572>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[189032]=1;i=d;return}function VCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189240]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+568>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+568>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(189248,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+568>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[189240]=1;i=d;return}function WCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189448]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+564>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+564>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(189456,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+564>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[189448]=1;i=d;return}function XCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189656]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+560>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+560>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(189664,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+560>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[189656]=1;i=d;return}function YCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189848]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+556>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+556>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(189856,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+556>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[189848]=1;i=d;return}function ZCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190040]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+552>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+552>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(190048,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+552>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[190040]=1;i=d;return}function _Cb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190232]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+548>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+548>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(190240,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+548>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[190232]=1;i=d;return}function $Cb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190416]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+544>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+544>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(190424,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+544>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[190416]=1;i=d;return}function aDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190600]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+540>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+540>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(190608,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+540>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[190600]=1;i=d;return}function bDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190784]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+536>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+536>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(190792,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+536>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[190784]=1;i=d;return}function cDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191e3]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+532>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+532>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(191008,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+532>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[191e3]=1;i=d;return}function dDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191216]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+528>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+528>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(191224,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+528>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[191216]=1;i=d;return}function eDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191432]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+524>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+524>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(191440,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+524>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[191432]=1;i=d;return}function fDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191600]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+520>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+520>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(191608,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+520>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[191600]=1;i=d;return}function gDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191768]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+516>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+516>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(191776,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+516>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[191768]=1;i=d;return}function hDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191936]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+512>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+512>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(191944,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+512>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[191936]=1;i=d;return}function iDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192112]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+508>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+508>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(192120,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+508>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[192112]=1;i=d;return}function jDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192288]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+504>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+504>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(192296,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+504>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[192288]=1;i=d;return}function kDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192464]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+500>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+500>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(192472,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+500>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[192464]=1;i=d;return}function lDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192648]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+496>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+496>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(192656,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+496>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[192648]=1;i=d;return}function mDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192832]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+492>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+492>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(192840,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+492>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[192832]=1;i=d;return}function nDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193016]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+488>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+488>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(193024,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+488>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[193016]=1;i=d;return}function oDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193200]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+484>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+484>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(193208,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+484>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[193200]=1;i=d;return}function pDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193384]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+480>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+480>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(193392,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+480>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[193384]=1;i=d;return}function qDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193568]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+476>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+476>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(193576,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+476>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[193568]=1;i=d;return}function rDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193744]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+472>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+472>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(193752,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+472>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[193744]=1;i=d;return}function sDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193920]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+468>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+468>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(193928,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+468>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[193920]=1;i=d;return}function tDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194096]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+464>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+464>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(194104,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+464>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[194096]=1;i=d;return}function uDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194304]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+460>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+460>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(194312,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+460>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[194304]=1;i=d;return}function vDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194512]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+456>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+456>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(194520,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+456>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[194512]=1;i=d;return}function wDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194720]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+452>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+452>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(194728,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+452>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[194720]=1;i=d;return}function xDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194944]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+448>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+448>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(194952,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+448>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[194944]=1;i=d;return}function yDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195168]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+444>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+444>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(195176,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+444>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[195168]=1;i=d;return}function zDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195392]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+440>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+440>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(195400,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+440>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[195392]=1;i=d;return}function ADb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195560]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+436>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+436>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(195568,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+436>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[195560]=1;i=d;return}function BDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195728]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+432>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+432>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(195736,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+432>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[195728]=1;i=d;return}function CDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195896]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+428>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+428>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(195904,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+428>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[195896]=1;i=d;return}function DDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196096]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+424>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+424>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(196104,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+424>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[196096]=1;i=d;return}function EDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196296]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+420>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+420>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(196304,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+420>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[196296]=1;i=d;return}function FDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196496]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+416>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+416>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(196504,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+416>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[196496]=1;i=d;return}function GDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196712]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+412>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+412>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(196720,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+412>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[196712]=1;i=d;return}function HDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196928]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+408>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+408>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(196936,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+408>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[196928]=1;i=d;return}function IDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197144]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+404>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+404>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(197152,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+404>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[197144]=1;i=d;return}function JDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197368]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+400>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+400>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(197376,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+400>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[197368]=1;i=d;return}function KDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197592]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+396>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+396>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(197600,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+396>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[197592]=1;i=d;return}function LDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197816]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+392>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+392>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(197824,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+392>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[197816]=1;i=d;return}function MDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198048]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+388>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+388>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(198056,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+388>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[198048]=1;i=d;return}function NDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198280]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+384>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+384>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(198288,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+384>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[198280]=1;i=d;return}function ODb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198512]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+380>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+380>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(198520,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+380>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[198512]=1;i=d;return}function PDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198736]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+376>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+376>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(198744,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+376>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[198736]=1;i=d;return}function QDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198960]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+372>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+372>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(198968,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+372>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[198960]=1;i=d;return}function RDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199184]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+368>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+368>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(199192,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+368>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[199184]=1;i=d;return}function SDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199392]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+364>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+364>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(199400,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+364>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[199392]=1;i=d;return}function TDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199600]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+360>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+360>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(199608,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+360>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[199600]=1;i=d;return}function UDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199808]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+356>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+356>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(199816,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+356>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[199808]=1;i=d;return}function VDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[2e5]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+352>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+352>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(200008,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+352>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[2e5]=1;i=d;return}function WDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200192]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+348>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+348>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(200200,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+348>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[200192]=1;i=d;return}function XDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200384]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+344>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+344>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(200392,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+344>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[200384]=1;i=d;return}function YDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200568]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+340>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+340>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(200576,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+340>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[200568]=1;i=d;return}function ZDb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200752]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+336>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+336>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(200760,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+336>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[200752]=1;i=d;return}function _Db(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200936]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+332>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+332>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(200944,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+332>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[200936]=1;i=d;return}function $Db(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201152]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+328>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+328>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(201160,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+328>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[201152]=1;i=d;return}function aEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201368]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+324>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+324>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(201376,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+324>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[201368]=1;i=d;return}function bEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201584]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+320>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+320>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(201592,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+320>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[201584]=1;i=d;return}function cEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201752]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+316>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+316>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(201760,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+316>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[201752]=1;i=d;return}function dEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201920]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+312>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+312>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(201928,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+312>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[201920]=1;i=d;return}function eEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202088]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+308>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+308>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(202096,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+308>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[202088]=1;i=d;return}function fEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202264]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+304>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+304>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(202272,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+304>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[202264]=1;i=d;return}function gEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202440]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+300>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+300>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(202448,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+300>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[202440]=1;i=d;return}function hEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202616]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+296>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+296>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(202624,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+296>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[202616]=1;i=d;return}function iEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202800]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+292>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+292>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(202808,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+292>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[202800]=1;i=d;return}function jEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202984]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+288>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+288>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(202992,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+288>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[202984]=1;i=d;return}function kEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203168]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+284>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+284>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(203176,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+284>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[203168]=1;i=d;return}function lEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203352]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+280>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+280>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(203360,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+280>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[203352]=1;i=d;return}function mEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203536]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+276>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+276>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(203544,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+276>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[203536]=1;i=d;return}function nEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203744]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+272>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+272>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(203752,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+272>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[203744]=1;i=d;return}function oEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203920]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+268>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+268>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(203928,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+268>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[203920]=1;i=d;return}function pEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204096]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+264>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+264>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(204104,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+264>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[204096]=1;i=d;return}function qEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204272]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+260>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+260>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(204280,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+260>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[204272]=1;i=d;return}function rEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204480]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+256>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+256>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(204488,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+256>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[204480]=1;i=d;return}function sEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204688]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+252>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+252>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(204696,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+252>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[204688]=1;i=d;return}function tEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204896]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(204904,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[204896]=1;i=d;return}function uEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205120]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(205128,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[205120]=1;i=d;return}function vEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205344]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(205352,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[205344]=1;i=d;return}function wEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205568]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(205576,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[205568]=1;i=d;return}function xEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205736]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(205744,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[205736]=1;i=d;return}function yEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205904]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(205912,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[205904]=1;i=d;return}function zEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206072]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(206080,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[206072]=1;i=d;return}function AEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206272]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(206280,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[206272]=1;i=d;return}function BEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206472]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(206480,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[206472]=1;i=d;return}function CEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206672]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(206680,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[206672]=1;i=d;return}function DEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206888]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(206896,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[206888]=1;i=d;return}function EEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207104]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(207112,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[207104]=1;i=d;return}function FEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207320]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(207328,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[207320]=1;i=d;return}function GEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207544]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(207552,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[207544]=1;i=d;return}function HEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207768]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(207776,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[207768]=1;i=d;return}function IEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208016]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(208024,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[208016]=1;i=d;return}function JEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208248]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(208256,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[208248]=1;i=d;return}function KEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208480]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(208488,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[208480]=1;i=d;return}function LEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208736]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(208744,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[208736]=1;i=d;return}function MEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208960]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(208968,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[208960]=1;i=d;return}function NEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209184]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(209192,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[209184]=1;i=d;return}function OEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209432]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(209440,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[209432]=1;i=d;return}function PEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209640]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(209648,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[209640]=1;i=d;return}function QEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209848]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(209856,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[209848]=1;i=d;return}function REb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210080]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(210088,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[210080]=1;i=d;return}function SEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210272]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(210280,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[210272]=1;i=d;return}function TEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210464]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(210472,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[210464]=1;i=d;return}function UEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210680]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(210688,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[210680]=1;i=d;return}function VEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210864]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(210872,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[210864]=1;i=d;return}function WEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211048]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(211056,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[211048]=1;i=d;return}function XEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211232]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(211240,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[211232]=1;i=d;return}function YEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211448]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(211456,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[211448]=1;i=d;return}function ZEb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211664]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(211672,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[211664]=1;i=d;return}function _Eb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211904]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(211912,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[211904]=1;i=d;return}function $Eb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212072]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(212080,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[212072]=1;i=d;return}function aFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212240]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(212248,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[212240]=1;i=d;return}function bFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212408]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(212416,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[212408]=1;i=d;return}function cFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212584]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(212592,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[212584]=1;i=d;return}function dFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212760]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(212768,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[212760]=1;i=d;return}function eFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212936]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(212944,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[212936]=1;i=d;return}function fFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213120]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(213128,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[213120]=1;i=d;return}function gFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213304]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(213312,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[213304]=1;i=d;return}function hFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213488]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(213496,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[213488]=1;i=d;return}function iFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213664]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(213672,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[213664]=1;i=d;return}function jFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213840]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(213848,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[213840]=1;i=d;return}function kFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214040]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(214048,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[214040]=1;i=d;return}function lFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214184]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(214192,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[214184]=1;i=d;return}function mFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214328]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(214336,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[214328]=1;i=d;return}function nFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214496]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(214504,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[214496]=1;i=d;return}function oFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214688]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(214696,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[214688]=1;i=d;return}function pFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214880]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(214888,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[214880]=1;i=d;return}function qFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215096]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(215104,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215624;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[215096]=1;i=d;return}function rFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215272]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(215280,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215624;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[215272]=1;i=d;return}function sFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215448]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(215456,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215624;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[215448]=1;i=d;return}function tFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215648]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(215656,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=216056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[215648]=1;i=d;return}function uFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215784]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(215792,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=216056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[215784]=1;i=d;return}function vFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215920]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(215928,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=216056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[215920]=1;i=d;return}function wFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216080]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(216088,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=216560;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[216080]=1;i=d;return}function xFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216240]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(216248,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=216560;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[216240]=1;i=d;return}function yFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216400]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(216408,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=216560;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[216400]=1;i=d;return}function zFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216584]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(216592,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=217064;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[216584]=1;i=d;return}function AFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216744]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(216752,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=217064;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[216744]=1;i=d;return}function BFb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216904]&1){i=d;return}g=b+4|0;b=aPb(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(216912,vMb(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=217064;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[216904]=1;i=d;return}function CFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217088]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(217096,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21360>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[217088]=1;i=d;return}function DFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217224]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(217232,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21352>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[217224]=1;i=d;return}function EFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217360]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(217368,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21344>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[217360]=1;i=d;return}function FFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217496]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(217504,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21328>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[217496]=1;i=d;return}function GFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217632]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(217640,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21320>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[217632]=1;i=d;return}function HFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217768]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(217776,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21312>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[217768]=1;i=d;return}function IFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217904]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(217912,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21296>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[217904]=1;i=d;return}function JFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218040]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(218048,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21288>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[218040]=1;i=d;return}function KFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218176]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(218184,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21280>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[218176]=1;i=d;return}



function $zb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158128]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1192>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1192>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(158136,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1192>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[158128]=1;i=d;return}function aAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158352]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1188>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1188>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(158360,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1188>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[158352]=1;i=d;return}function bAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158576]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1184>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1184>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(158584,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1184>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[158576]=1;i=d;return}function cAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158784]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1180>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1180>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(158792,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1180>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[158784]=1;i=d;return}function dAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158992]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1176>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1176>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(159e3,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1176>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[158992]=1;i=d;return}function eAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159200]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1172>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1172>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(159208,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1172>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[159200]=1;i=d;return}function fAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159392]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1168>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1168>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(159400,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1168>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[159392]=1;i=d;return}function gAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159584]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1164>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1164>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(159592,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1164>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[159584]=1;i=d;return}function hAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159776]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1160>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1160>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(159784,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1160>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[159776]=1;i=d;return}function iAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159960]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1156>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1156>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(159968,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1156>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[159960]=1;i=d;return}function jAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160144]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1152>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1152>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(160152,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1152>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[160144]=1;i=d;return}function kAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160328]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1148>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1148>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(160336,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1148>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[160328]=1;i=d;return}function lAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160544]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1144>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1144>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(160552,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1144>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[160544]=1;i=d;return}function mAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160760]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1140>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1140>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(160768,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1140>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[160760]=1;i=d;return}function nAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160976]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1136>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1136>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(160984,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1136>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[160976]=1;i=d;return}function oAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161144]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1132>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1132>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(161152,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1132>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[161144]=1;i=d;return}function pAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161312]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1128>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1128>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(161320,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1128>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[161312]=1;i=d;return}function qAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161480]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1124>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1124>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(161488,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1124>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[161480]=1;i=d;return}function rAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161656]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1120>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1120>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(161664,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1120>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[161656]=1;i=d;return}function sAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161832]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1116>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1116>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(161840,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1116>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[161832]=1;i=d;return}function tAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162008]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1112>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1112>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(162016,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1112>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[162008]=1;i=d;return}function uAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162192]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1108>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1108>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(162200,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1108>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[162192]=1;i=d;return}function vAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162376]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1104>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1104>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(162384,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1104>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[162376]=1;i=d;return}function wAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162560]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1100>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1100>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(162568,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1100>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[162560]=1;i=d;return}function xAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162744]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1096>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1096>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(162752,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1096>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[162744]=1;i=d;return}function yAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162928]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1092>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1092>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(162936,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1092>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[162928]=1;i=d;return}function zAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163112]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1088>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1088>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(163120,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1088>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[163112]=1;i=d;return}function AAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163288]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1084>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1084>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(163296,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1084>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[163288]=1;i=d;return}function BAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163464]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1080>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1080>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(163472,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1080>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[163464]=1;i=d;return}function CAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163640]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1076>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1076>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(163648,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1076>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[163640]=1;i=d;return}function DAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163848]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1072>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1072>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(163856,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1072>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[163848]=1;i=d;return}function EAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164056]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1068>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1068>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(164064,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1068>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[164056]=1;i=d;return}function FAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164264]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1064>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1064>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(164272,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1064>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[164264]=1;i=d;return}function GAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164488]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1060>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1060>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(164496,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1060>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[164488]=1;i=d;return}function HAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164712]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1056>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1056>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(164720,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1056>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[164712]=1;i=d;return}function IAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164936]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1052>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1052>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(164944,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1052>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[164936]=1;i=d;return}function JAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165104]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1048>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1048>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(165112,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1048>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[165104]=1;i=d;return}function KAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165272]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1044>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1044>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(165280,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1044>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[165272]=1;i=d;return}function LAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165440]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1040>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1040>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(165448,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1040>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[165440]=1;i=d;return}function MAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165640]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1036>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1036>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(165648,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1036>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[165640]=1;i=d;return}function NAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165840]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1032>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1032>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(165848,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1032>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[165840]=1;i=d;return}function OAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166040]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1028>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1028>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(166048,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1028>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[166040]=1;i=d;return}function PAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166256]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1024>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1024>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(166264,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1024>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[166256]=1;i=d;return}function QAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166472]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1020>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1020>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(166480,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1020>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[166472]=1;i=d;return}function RAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166688]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1016>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1016>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(166696,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1016>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[166688]=1;i=d;return}function SAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166912]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1012>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1012>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(166920,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1012>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[166912]=1;i=d;return}function TAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167136]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1008>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1008>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(167144,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1008>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[167136]=1;i=d;return}function UAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167360]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1004>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1004>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(167368,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1004>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[167360]=1;i=d;return}function VAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167592]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1e3>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1e3>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(167600,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1e3>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[167592]=1;i=d;return}function WAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167824]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+996>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+996>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(167832,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+996>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[167824]=1;i=d;return}function XAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168056]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+992>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+992>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(168064,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+992>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[168056]=1;i=d;return}function YAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168280]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+988>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+988>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(168288,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+988>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[168280]=1;i=d;return}function ZAb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168504]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+984>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+984>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(168512,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+984>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[168504]=1;i=d;return}function _Ab(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168728]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+980>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+980>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(168736,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+980>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[168728]=1;i=d;return}function $Ab(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168936]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+976>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+976>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(168944,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+976>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[168936]=1;i=d;return}function aBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169144]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+972>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+972>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(169152,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+972>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[169144]=1;i=d;return}function bBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169352]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+968>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+968>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(169360,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+968>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[169352]=1;i=d;return}function cBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169544]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+964>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+964>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(169552,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+964>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[169544]=1;i=d;return}function dBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169736]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+960>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+960>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(169744,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+960>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[169736]=1;i=d;return}function eBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169928]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+956>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+956>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(169936,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+956>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[169928]=1;i=d;return}function fBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170112]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+952>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+952>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(170120,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+952>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[170112]=1;i=d;return}function gBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170296]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+948>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+948>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(170304,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+948>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[170296]=1;i=d;return}function hBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170480]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+944>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+944>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(170488,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+944>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[170480]=1;i=d;return}function iBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170696]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+940>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+940>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(170704,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+940>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[170696]=1;i=d;return}function jBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170912]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+936>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+936>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(170920,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+936>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[170912]=1;i=d;return}function kBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171128]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+932>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+932>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(171136,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+932>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[171128]=1;i=d;return}function lBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171296]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+928>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+928>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(171304,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+928>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[171296]=1;i=d;return}function mBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171464]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+924>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+924>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(171472,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+924>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[171464]=1;i=d;return}function nBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171632]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+920>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+920>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(171640,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+920>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[171632]=1;i=d;return}function oBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171808]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+916>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+916>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(171816,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+916>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[171808]=1;i=d;return}function pBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171984]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+912>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+912>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(171992,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+912>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[171984]=1;i=d;return}function qBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172160]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+908>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+908>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(172168,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+908>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[172160]=1;i=d;return}function rBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172344]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+904>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+904>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(172352,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+904>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[172344]=1;i=d;return}function sBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172528]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+900>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+900>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(172536,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+900>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[172528]=1;i=d;return}function tBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172712]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+896>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+896>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(172720,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+896>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[172712]=1;i=d;return}function uBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172896]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+892>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+892>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(172904,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+892>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[172896]=1;i=d;return}function vBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173080]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+888>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+888>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(173088,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+888>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[173080]=1;i=d;return}function wBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173264]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+884>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+884>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(173272,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+884>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[173264]=1;i=d;return}function xBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173440]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+880>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+880>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(173448,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+880>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[173440]=1;i=d;return}function yBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173616]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+876>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+876>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(173624,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+876>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[173616]=1;i=d;return}function zBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173792]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+872>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+872>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(173800,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+872>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[173792]=1;i=d;return}function ABb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174e3]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+868>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+868>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(174008,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+868>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[174e3]=1;i=d;return}function BBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174208]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+864>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+864>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(174216,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+864>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[174208]=1;i=d;return}function CBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174416]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+860>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+860>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(174424,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+860>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[174416]=1;i=d;return}function DBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174640]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+856>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+856>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(174648,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+856>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[174640]=1;i=d;return}function EBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174864]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+852>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+852>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(174872,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+852>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[174864]=1;i=d;return}function FBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175088]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+848>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+848>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(175096,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+848>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[175088]=1;i=d;return}function GBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175256]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+844>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+844>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(175264,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+844>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[175256]=1;i=d;return}function HBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175424]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+840>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+840>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(175432,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+840>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[175424]=1;i=d;return}function IBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175592]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+836>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+836>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(175600,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+836>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[175592]=1;i=d;return}function JBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175792]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+832>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+832>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(175800,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+832>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[175792]=1;i=d;return}function KBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175992]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+828>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+828>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(176e3,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+828>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[175992]=1;i=d;return}function LBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176192]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+824>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+824>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(176200,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+824>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[176192]=1;i=d;return}function MBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176408]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+820>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+820>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(176416,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+820>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[176408]=1;i=d;return}function NBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176624]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+816>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+816>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(176632,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+816>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[176624]=1;i=d;return}function OBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176840]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+812>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+812>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(176848,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+812>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[176840]=1;i=d;return}function PBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177064]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+808>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+808>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(177072,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+808>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[177064]=1;i=d;return}function QBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177288]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+804>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+804>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(177296,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+804>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[177288]=1;i=d;return}function RBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177512]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+800>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+800>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(177520,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+800>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[177512]=1;i=d;return}function SBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177744]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+796>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+796>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(177752,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+796>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[177744]=1;i=d;return}function TBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177976]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+792>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+792>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(177984,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+792>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[177976]=1;i=d;return}function UBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178208]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+788>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+788>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(178216,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+788>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[178208]=1;i=d;return}function VBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178432]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+784>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+784>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(178440,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+784>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[178432]=1;i=d;return}function WBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178656]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+780>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+780>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(178664,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+780>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[178656]=1;i=d;return}function XBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178880]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+776>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+776>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(178888,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+776>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[178880]=1;i=d;return}function YBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179088]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+772>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+772>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(179096,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+772>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[179088]=1;i=d;return}function ZBb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179296]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+768>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+768>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(179304,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+768>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[179296]=1;i=d;return}function _Bb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179504]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+764>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+764>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(179512,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+764>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[179504]=1;i=d;return}function $Bb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179696]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+760>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+760>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(179704,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+760>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[179696]=1;i=d;return}function aCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179888]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+756>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+756>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(179896,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+756>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=210656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[179888]=1;i=d;return}function bCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180080]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+752>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+752>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(180088,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+752>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[180080]=1;i=d;return}function cCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180264]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+748>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+748>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(180272,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+748>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[180264]=1;i=d;return}function dCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180448]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+744>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+744>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(180456,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+744>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[180448]=1;i=d;return}function eCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180632]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+740>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+740>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(180640,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+740>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[180632]=1;i=d;return}function fCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180848]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+736>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+736>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(180856,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+736>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[180848]=1;i=d;return}function gCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181064]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+732>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+732>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(181072,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+732>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=211880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[181064]=1;i=d;return}function hCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181280]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+728>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+728>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(181288,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+728>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[181280]=1;i=d;return}function iCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181448]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+724>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+724>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(181456,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+724>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[181448]=1;i=d;return}function jCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181616]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+720>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+720>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(181624,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+720>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[181616]=1;i=d;return}function kCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181784]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+716>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+716>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(181792,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+716>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[181784]=1;i=d;return}function lCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181960]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+712>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+712>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(181968,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+712>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[181960]=1;i=d;return}function mCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182136]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+708>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+708>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(182144,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+708>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[182136]=1;i=d;return}function nCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182312]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+704>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+704>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(182320,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+704>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[182312]=1;i=d;return}function oCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182496]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+700>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+700>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(182504,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+700>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[182496]=1;i=d;return}function pCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182680]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+696>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+696>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(182688,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+696>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[182680]=1;i=d;return}function qCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182864]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+692>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+692>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(182872,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+692>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[182864]=1;i=d;return}function rCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183048]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+688>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+688>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(183056,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+688>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[183048]=1;i=d;return}function sCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183232]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+684>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+684>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(183240,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+684>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=203720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[183232]=1;i=d;return}function tCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183416]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+680>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+680>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(183424,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+680>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[183416]=1;i=d;return}function uCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183592]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+676>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+676>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(183600,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+676>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[183592]=1;i=d;return}function vCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183768]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+672>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+672>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(183776,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+672>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[183768]=1;i=d;return}function wCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183944]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+668>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+668>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(183952,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+668>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[183944]=1;i=d;return}function xCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184152]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+664>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+664>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(184160,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+664>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[184152]=1;i=d;return}function yCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184360]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+660>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+660>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(184368,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+660>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[184360]=1;i=d;return}function zCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184568]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+656>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+656>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(184576,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+656>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[184568]=1;i=d;return}function ACb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184792]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+652>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+652>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(184800,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+652>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[184792]=1;i=d;return}function BCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185016]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+648>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+648>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(185024,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+648>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[185016]=1;i=d;return}function CCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185240]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+644>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+644>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(185248,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+644>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[185240]=1;i=d;return}function DCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185408]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+640>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+640>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(185416,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+640>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[185408]=1;i=d;return}function ECb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185576]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+636>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+636>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(185584,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+636>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[185576]=1;i=d;return}function FCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185744]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+632>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+632>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(185752,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+632>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[185744]=1;i=d;return}function GCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185944]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+628>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+628>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(185952,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+628>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[185944]=1;i=d;return}function HCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186144]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+624>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+624>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(186152,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+624>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=214016;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[186144]=1;i=d;return}function ICb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186344]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+620>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+620>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(186352,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+620>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[186344]=1;i=d;return}function JCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186560]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+616>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+616>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(186568,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+616>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[186560]=1;i=d;return}function KCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186776]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+612>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+612>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(186784,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+612>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=215072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[186776]=1;i=d;return}function LCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186992]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+608>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+608>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(187e3,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+608>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[186992]=1;i=d;return}function MCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187216]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+604>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+604>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(187224,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+604>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[187216]=1;i=d;return}function NCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187440]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+600>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+600>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(187448,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+600>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=207992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[187440]=1;i=d;return}function OCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187664]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+596>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+596>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(187672,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+596>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[187664]=1;i=d;return}function PCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187896]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+592>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+592>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(187904,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+592>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[187896]=1;i=d;return}function QCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188128]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+588>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+588>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(188136,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+588>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=208712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[188128]=1;i=d;return}function RCb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188360]&1){i=d;return}g=b+4|0;b=aPb(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+584>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_Ob(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+584>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=xMb(188368,vMb(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+584>>2]|0,23848)|0)|0;g=c[69978]|0;h=e;j=209408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ae[g&15](e,b,f);a[188360]=1;i=d;return}



function mA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2784>>3]=+h[b+2520>>3];i=i;return}function nA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2768>>3]=+h[b+2504>>3];i=i;return}function oA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2664>>3]=+h[b+2496>>3];i=i;return}function pA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2648>>3]=+h[b+2480>>3];i=i;return}function qA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19928>>3]=+h[b+19392>>3];i=i;return}function rA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20032>>3]=+h[b+19928>>3];i=i;return}function sA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2512>>3]=+h[b+19384>>3]*.5;i=i;return}function tA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2776>>3]=+h[b+2512>>3];i=i;return}function uA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2488>>3]=+h[b+19384>>3];i=i;return}function vA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2656>>3]=+h[b+2488>>3];i=i;return}function wA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+2648>>3]- +h[b+2672>>3];e=+h[b+2656>>3]- +h[b+2680>>3];f=+h[b+2664>>3]- +h[b+2688>>3];h[b+2e4>>3]=+V(+(d*d+e*e+f*f));i=i;return}function xA(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+2e4>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18392,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+20008>>3]=l;i=d;return}function yA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20016>>3]=+h[b+20008>>3];i=i;return}function zA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19672>>3]=+h[b+19632>>3];i=i;return}function AA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19760>>3]=+h[b+19672>>3];i=i;return}function BA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19624>>3]=-+h[b+19296>>3];i=i;return}function CA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19664>>3]=+h[b+19624>>3];i=i;return}function DA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19752>>3]=+h[b+19664>>3];i=i;return}function EA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1016>>3]=+h[b+19304>>3]+ +h[b+19320>>3]*-.5;i=i;return}function FA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+1016>>3]- +h[b+1136>>3];e=+h[b+1024>>3]- +h[b+1144>>3];f=+h[b+1032>>3]- +h[b+1152>>3];h[b+19536>>3]=+V(+(d*d+e*e+f*f));i=i;return}function GA(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+19536>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18400,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+19544>>3]=l;i=d;return}function HA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19552>>3]=+h[b+19544>>3];i=i;return}function IA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+928>>3]=+h[b+19312>>3];i=i;return}function JA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+920>>3]=+h[b+19304>>3]+ +h[b+19320>>3]*-.5;i=i;return}function KA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+920>>3]- +h[b+944>>3];e=+h[b+928>>3]- +h[b+952>>3];f=+h[b+936>>3]- +h[b+960>>3];h[b+19496>>3]=+V(+(d*d+e*e+f*f));i=i;return}function LA(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+19496>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18408,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+19504>>3]=l;i=d;return}function MA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19512>>3]=+h[b+19504>>3];i=i;return}function NA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+824>>3]=+h[b+19304>>3];i=i;return}function OA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+824>>3]- +h[b+848>>3];e=+h[b+832>>3]- +h[b+856>>3];f=+h[b+840>>3]- +h[b+864>>3];h[b+19464>>3]=+V(+(d*d+e*e+f*f));i=i;return}function PA(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+19464>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18416,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+19472>>3]=l;i=d;return}function QA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19480>>3]=+h[b+19472>>3];i=i;return}function RA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+728>>3]=+h[b+19304>>3];i=i;return}function SA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+728>>3]- +h[b+752>>3];e=+h[b+736>>3]- +h[b+760>>3];f=+h[b+744>>3]- +h[b+768>>3];h[b+19432>>3]=+V(+(d*d+e*e+f*f));i=i;return}function TA(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+19432>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18424,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+19440>>3]=l;i=d;return}function UA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19448>>3]=+h[b+19440>>3];i=i;return}function VA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19200>>3]=+h[b+19096>>3];i=i;return}function WA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+400>>3]=+h[b+136>>3];i=i;return}function XA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+392>>3]=+h[b+128>>3];i=i;return}function YA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+384>>3]=+h[b+120>>3];i=i;return}function ZA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+280>>3]=+h[b+112>>3];i=i;return}function _A(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+272>>3]=+h[b+104>>3];i=i;return}function $A(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+264>>3]=+h[b+96>>3];i=i;return}function aB(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+264>>3]- +h[b+288>>3];e=+h[b+272>>3]- +h[b+296>>3];f=+h[b+280>>3]- +h[b+304>>3];h[b+19168>>3]=+V(+(d*d+e*e+f*f));i=i;return}function bB(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+19168>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,18432,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+19176>>3]=l;i=d;return}function cB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19184>>3]=+h[b+19176>>3];i=i;return}function dB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16112>>3]=+h[(c[a+416>>2]|0)+1032>>3];i=i;return}function eB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16104>>3]=+h[(c[a+416>>2]|0)+1024>>3];i=i;return}function fB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16096>>3]=+h[(c[a+416>>2]|0)+1016>>3];i=i;return}function gB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15224>>3]=0.0;i=i;return}function hB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15216>>3]=-.1;i=i;return}function iB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15208>>3]=0.0;i=i;return}function jB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15200>>3]=0.0;i=i;return}function kB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15192>>3]=-.1;i=i;return}function lB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15184>>3]=0.0;i=i;return}function mB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15176>>3]=0.0;i=i;return}function nB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15168>>3]=-.1;i=i;return}function oB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15160>>3]=0.0;i=i;return}function pB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15152>>3]=0.0;i=i;return}function qB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15144>>3]=-.1;i=i;return}function rB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15136>>3]=0.0;i=i;return}function sB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15128>>3]=0.0;i=i;return}function tB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15120>>3]=-.1;i=i;return}function uB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15112>>3]=0.0;i=i;return}function vB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15104>>3]=0.0;i=i;return}function wB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15096>>3]=-.1;i=i;return}function xB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15088>>3]=0.0;i=i;return}function yB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10832>>3]=+h[b+16096>>3]- +h[(c[a+416>>2]|0)+3280>>3];i=i;return}function zB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10824>>3]=+h[b+744>>3]+ +h[b+3760>>3];i=i;return}function AB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10800>>3]=+h[b+10824>>3]+ +h[(c[a+416>>2]|0)+6776>>3];i=i;return}function BB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10776>>3]=+h[b+10800>>3]+ +h[(c[a+416>>2]|0)+9792>>3];i=i;return}function CB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10752>>3]=+h[b+10776>>3]+ +h[(c[a+416>>2]|0)+12808>>3];i=i;return}function DB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10728>>3]=+h[b+10752>>3]+ +h[(c[a+416>>2]|0)+16112>>3];i=i;return}function EB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10704>>3]=+h[b+10776>>3]+ +h[(c[a+416>>2]|0)+13096>>3];i=i;return}function FB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10680>>3]=+h[b+10800>>3]+ +h[(c[a+416>>2]|0)+10080>>3];i=i;return}function GB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10656>>3]=+h[b+10824>>3]+ +h[(c[a+416>>2]|0)+7064>>3];i=i;return}function HB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10632>>3]=+h[b+744>>3]+ +h[b+4048>>3];i=i;return}function IB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10816>>3]=+h[b+736>>3]+ +h[b+3752>>3];i=i;return}function JB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10792>>3]=+h[b+10816>>3]+ +h[(c[a+416>>2]|0)+6768>>3];i=i;return}function KB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10768>>3]=+h[b+10792>>3]+ +h[(c[a+416>>2]|0)+9784>>3];i=i;return}function LB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10744>>3]=+h[b+10768>>3]+ +h[(c[a+416>>2]|0)+12800>>3];i=i;return}function MB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10720>>3]=+h[b+10744>>3]+ +h[(c[a+416>>2]|0)+16104>>3];i=i;return}function NB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10696>>3]=+h[b+10768>>3]+ +h[(c[a+416>>2]|0)+13088>>3];i=i;return}function OB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10672>>3]=+h[b+10792>>3]+ +h[(c[a+416>>2]|0)+10072>>3];i=i;return}function PB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10648>>3]=+h[b+10816>>3]+ +h[(c[a+416>>2]|0)+7056>>3];i=i;return}function QB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10624>>3]=+h[b+736>>3]+ +h[b+4040>>3];i=i;return}function RB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10808>>3]=+h[b+728>>3]+ +h[b+3744>>3];i=i;return}function SB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10784>>3]=+h[b+10808>>3]+ +h[(c[a+416>>2]|0)+6760>>3];i=i;return}function TB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10760>>3]=+h[b+10784>>3]+ +h[(c[a+416>>2]|0)+9776>>3];i=i;return}function UB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10736>>3]=+h[b+10760>>3]+ +h[(c[a+416>>2]|0)+12792>>3];i=i;return}function VB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10712>>3]=+h[b+10736>>3]+ +h[(c[a+416>>2]|0)+16096>>3];i=i;return}function WB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10592>>3]=+h[b+10712>>3]- +h[(c[a+416>>2]|0)+18360>>3];i=i;return}function XB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10688>>3]=+h[b+10760>>3]+ +h[(c[a+416>>2]|0)+13080>>3];i=i;return}function YB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10568>>3]=+h[b+10688>>3]- +h[(c[a+416>>2]|0)+15344>>3];i=i;return}function ZB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10664>>3]=+h[b+10784>>3]+ +h[(c[a+416>>2]|0)+10064>>3];i=i;return}function _B(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10544>>3]=+h[b+10664>>3]- +h[(c[a+416>>2]|0)+12328>>3];i=i;return}function $B(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10640>>3]=+h[b+10808>>3]+ +h[(c[a+416>>2]|0)+7048>>3];i=i;return}function aC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10520>>3]=+h[b+10640>>3]- +h[(c[a+416>>2]|0)+9312>>3];i=i;return}function bC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10616>>3]=+h[b+728>>3]+ +h[b+4032>>3];i=i;return}function cC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10496>>3]=+h[b+10616>>3]- +h[(c[a+416>>2]|0)+6296>>3];i=i;return}function dC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10472>>3]=+h[b+264>>3]+ +h[b+824>>3];i=i;return}function eC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10448>>3]=+h[b+10472>>3]+ +h[(c[a+416>>2]|0)+3840>>3];i=i;return}function fC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10424>>3]=+h[b+10448>>3]+ +h[(c[a+416>>2]|0)+6856>>3];i=i;return}function gC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10400>>3]=+h[b+10424>>3]+ +h[(c[a+416>>2]|0)+9872>>3];i=i;return}function hC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10376>>3]=+h[b+10400>>3]+ +h[(c[a+416>>2]|0)+12888>>3];i=i;return}function iC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10352>>3]=+h[b+10376>>3]+ +h[(c[a+416>>2]|0)+16480>>3];i=i;return}function jC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10328>>3]=+h[b+10352>>3]+ +h[(c[a+416>>2]|0)+16e3>>3];i=i;return}function kC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10304>>3]=+h[b+10328>>3]- +h[b+10712>>3];i=i;return}function lC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10280>>3]=+h[b+15208>>3]- +h[b+10304>>3];i=i;return}function mC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10256>>3]=+h[b+10712>>3]- +h[b+10328>>3];i=i;return}function nC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10232>>3]=+h[b+10400>>3]+ +h[(c[a+416>>2]|0)+13464>>3];i=i;return}function oC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10208>>3]=+h[b+10232>>3]+ +h[(c[a+416>>2]|0)+12984>>3];i=i;return}function pC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10184>>3]=+h[b+10208>>3]- +h[b+10688>>3];i=i;return}function qC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10160>>3]=+h[b+15184>>3]- +h[b+10184>>3];i=i;return}function rC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10136>>3]=+h[b+10688>>3]- +h[b+10208>>3];i=i;return}function sC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10112>>3]=+h[b+10424>>3]+ +h[(c[a+416>>2]|0)+10448>>3];i=i;return}function tC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10088>>3]=+h[b+10112>>3]+ +h[(c[a+416>>2]|0)+9968>>3];i=i;return}function uC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10064>>3]=+h[b+10088>>3]- +h[b+10664>>3];i=i;return}function vC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10040>>3]=+h[b+15160>>3]- +h[b+10064>>3];i=i;return}function wC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10016>>3]=+h[b+10664>>3]- +h[b+10088>>3];i=i;return}function xC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9992>>3]=+h[b+10448>>3]+ +h[(c[a+416>>2]|0)+7432>>3];i=i;return}function yC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9968>>3]=+h[b+9992>>3]+ +h[(c[a+416>>2]|0)+6952>>3];i=i;return}function zC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9944>>3]=+h[b+9968>>3]- +h[b+10640>>3];i=i;return}function AC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9920>>3]=+h[b+15136>>3]- +h[b+9944>>3];i=i;return}function BC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9896>>3]=+h[b+10640>>3]- +h[b+9968>>3];i=i;return}function CC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9872>>3]=+h[b+10472>>3]+ +h[(c[a+416>>2]|0)+4416>>3];i=i;return}function DC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9848>>3]=+h[b+9872>>3]+ +h[(c[a+416>>2]|0)+3936>>3];i=i;return}function EC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9824>>3]=+h[b+9848>>3]- +h[b+10616>>3];i=i;return}function FC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9800>>3]=+h[b+15112>>3]- +h[b+9824>>3];i=i;return}function GC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9776>>3]=+h[b+10616>>3]- +h[b+9848>>3];i=i;return}function HC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9752>>3]=+h[b+264>>3]+ +h[b+1400>>3];i=i;return}function IC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9728>>3]=+h[b+9752>>3]+ +h[(c[a+416>>2]|0)+920>>3];i=i;return}function JC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9704>>3]=+h[b+9728>>3]- +h[b+16096>>3];i=i;return}function KC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9680>>3]=+h[b+15088>>3]- +h[b+9704>>3];i=i;return}function LC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9656>>3]=+h[b+16096>>3]- +h[b+9728>>3];i=i;return}function MC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7800>>3]=+h[b+10376>>3]+ +h[(c[a+416>>2]|0)+15904>>3];i=i;return}function NC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7792>>3]=+h[b+10752>>3]+ +h[(c[a+416>>2]|0)+15824>>3];i=i;return}function OC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7784>>3]=+h[b+10744>>3]+ +h[(c[a+416>>2]|0)+15816>>3];i=i;return}function PC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7776>>3]=+h[b+10736>>3]+ +h[(c[a+416>>2]|0)+15808>>3];i=i;return}function QC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24>>3]=0.0;i=i;return}function RC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+16232>>3]=+X(+(+h[b+24>>3]));i=i;return}function SC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+16224>>3]=-+Y(+(+h[b+24>>3]));i=i;return}function TC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+16208>>3]=+Y(+(+h[b+24>>3]));i=i;return}function UC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15040>>3]=+h[b+16208>>3]*.4999999999999999+ +h[b+16232>>3]*.8660254037844387;i=i;return}function VC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15056>>3]=+h[b+16208>>3]*.8660254037844387+ +h[b+16232>>3]*-.4999999999999999;i=i;return}function WC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14992>>3]=+h[b+16232>>3]*6.123233995736766e-17- +h[b+16208>>3];i=i;return}function XC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15008>>3]=+h[b+16208>>3]*6.123233995736766e-17+ +h[b+16232>>3];i=i;return}function YC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14944>>3]=+h[b+16208>>3]*.5000000000000001+ +h[b+16232>>3]*-.8660254037844386;i=i;return}function ZC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14960>>3]=+h[b+16208>>3]*-.8660254037844386+ +h[b+16232>>3]*-.5000000000000001;i=i;return}function _C(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14896>>3]=+h[b+16208>>3]*.5000000000000001+ +h[b+16232>>3]*-.8660254037844386;i=i;return}function $C(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14912>>3]=+h[b+16208>>3]*-.8660254037844386+ +h[b+16232>>3]*-.5000000000000001;i=i;return}function aD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14848>>3]=+h[b+16232>>3]*6.123233995736766e-17- +h[b+16208>>3];i=i;return}function bD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14864>>3]=+h[b+16208>>3]*6.123233995736766e-17+ +h[b+16232>>3];i=i;return}function cD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14800>>3]=+h[b+16208>>3]*.4999999999999999+ +h[b+16232>>3]*.8660254037844387;i=i;return}function dD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14816>>3]=+h[b+16208>>3]*.8660254037844387+ +h[b+16232>>3]*-.4999999999999999;i=i;return}function eD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+4280>>3]=+h[b+16208>>3]*+h[d+272>>3]+ +h[b+16232>>3]*+h[d+280>>3];i=i;return}function fD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9768>>3]=+h[b+4280>>3]+(+h[b+16208>>3]*+h[d+1408>>3]+ +h[b+16232>>3]*+h[d+1416>>3]);i=i;return}function gD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9744>>3]=+h[b+9768>>3]+(+h[b+14816>>3]*+h[d+928>>3]+ +h[b+14800>>3]*+h[d+936>>3]);i=i;return}function hD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10488>>3]=+h[b+4280>>3]+(+h[b+16208>>3]*+h[d+832>>3]+ +h[b+16232>>3]*+h[d+840>>3]);i=i;return}function iD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9888>>3]=+h[b+10488>>3]+(+h[b+16208>>3]*+h[d+4424>>3]+ +h[b+16232>>3]*+h[d+4432>>3]);i=i;return}function jD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9864>>3]=+h[b+9888>>3]+(+h[b+14864>>3]*+h[d+3944>>3]+ +h[b+14848>>3]*+h[d+3952>>3]);i=i;return}function kD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10464>>3]=+h[b+10488>>3]+(+h[b+16208>>3]*+h[d+3848>>3]+ +h[b+16232>>3]*+h[d+3856>>3]);i=i;return}function lD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10008>>3]=+h[b+10464>>3]+(+h[b+16208>>3]*+h[d+7440>>3]+ +h[b+16232>>3]*+h[d+7448>>3]);i=i;return}function mD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9984>>3]=+h[b+10008>>3]+(+h[b+14912>>3]*+h[d+6960>>3]+ +h[b+14896>>3]*+h[d+6968>>3]);i=i;return}function nD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10440>>3]=+h[b+10464>>3]+(+h[b+16208>>3]*+h[d+6864>>3]+ +h[b+16232>>3]*+h[d+6872>>3]);i=i;return}function oD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10128>>3]=+h[b+10440>>3]+(+h[b+16208>>3]*+h[d+10456>>3]+ +h[b+16232>>3]*+h[d+10464>>3]);i=i;return}function pD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10104>>3]=+h[b+10128>>3]+(+h[b+14960>>3]*+h[d+9976>>3]+ +h[b+14944>>3]*+h[d+9984>>3]);i=i;return}function qD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10416>>3]=+h[b+10440>>3]+(+h[b+16208>>3]*+h[d+9880>>3]+ +h[b+16232>>3]*+h[d+9888>>3]);i=i;return}function rD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10248>>3]=+h[b+10416>>3]+(+h[b+16208>>3]*+h[d+13472>>3]+ +h[b+16232>>3]*+h[d+13480>>3]);i=i;return}function sD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10224>>3]=+h[b+10248>>3]+(+h[b+15008>>3]*+h[d+12992>>3]+ +h[b+14992>>3]*+h[d+13e3>>3]);i=i;return}function tD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10392>>3]=+h[b+10416>>3]+(+h[b+16208>>3]*+h[d+12896>>3]+ +h[b+16232>>3]*+h[d+12904>>3]);i=i;return}function uD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+7816>>3]=+h[b+10392>>3]+(+h[b+16208>>3]*+h[d+15912>>3]+ +h[b+16232>>3]*+h[d+15920>>3]);i=i;return}function vD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10368>>3]=+h[b+10392>>3]+(+h[b+16208>>3]*+h[d+16488>>3]+ +h[b+16232>>3]*+h[d+16496>>3]);i=i;return}function wD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10344>>3]=+h[b+10368>>3]+(+h[b+15056>>3]*+h[d+16008>>3]+ +h[b+15040>>3]*+h[d+16016>>3]);i=i;return}function xD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+16200>>3]=+X(+(+h[b+24>>3]));i=i;return}function yD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15048>>3]=+h[b+16200>>3]*.4999999999999999+ +h[b+16224>>3]*.8660254037844387;i=i;return}function zD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15064>>3]=+h[b+16200>>3]*.8660254037844387+ +h[b+16224>>3]*-.4999999999999999;i=i;return}function AD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15e3>>3]=+h[b+16224>>3]*6.123233995736766e-17- +h[b+16200>>3];i=i;return}function BD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15016>>3]=+h[b+16200>>3]*6.123233995736766e-17+ +h[b+16224>>3];i=i;return}function CD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14952>>3]=+h[b+16200>>3]*.5000000000000001+ +h[b+16224>>3]*-.8660254037844386;i=i;return}function DD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14968>>3]=+h[b+16200>>3]*-.8660254037844386+ +h[b+16224>>3]*-.5000000000000001;i=i;return}function ED(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14904>>3]=+h[b+16200>>3]*.5000000000000001+ +h[b+16224>>3]*-.8660254037844386;i=i;return}function FD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14920>>3]=+h[b+16200>>3]*-.8660254037844386+ +h[b+16224>>3]*-.5000000000000001;i=i;return}function GD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14856>>3]=+h[b+16224>>3]*6.123233995736766e-17- +h[b+16200>>3];i=i;return}function HD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14872>>3]=+h[b+16200>>3]*6.123233995736766e-17+ +h[b+16224>>3];i=i;return}function ID(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14808>>3]=+h[b+16200>>3]*.4999999999999999+ +h[b+16224>>3]*.8660254037844387;i=i;return}function JD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14824>>3]=+h[b+16200>>3]*.8660254037844387+ +h[b+16224>>3]*-.4999999999999999;i=i;return}function KD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+4288>>3]=+h[b+16200>>3]*+h[d+272>>3]+ +h[b+16224>>3]*+h[d+280>>3];i=i;return}function LD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9760>>3]=+h[b+4288>>3]+(+h[b+16200>>3]*+h[d+1408>>3]+ +h[b+16224>>3]*+h[d+1416>>3]);i=i;return}function MD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9736>>3]=+h[b+9760>>3]+(+h[b+14824>>3]*+h[d+928>>3]+ +h[b+14808>>3]*+h[d+936>>3]);i=i;return}function ND(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9720>>3]=(+h[b+9736>>3]- +h[b+16104>>3])*.4999999999999999+(+h[b+9744>>3]- +h[b+16112>>3])*.8660254037844387;i=i;return}function OD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9696>>3]=+h[b+15104>>3]- +h[b+9720>>3];i=i;return}function PD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9712>>3]=(+h[b+9736>>3]- +h[b+16104>>3])*.8660254037844387+(+h[b+9744>>3]- +h[b+16112>>3])*-.4999999999999999;i=i;return}function QD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9688>>3]=+h[b+15096>>3]- +h[b+9712>>3];i=i;return}function RD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20456>>3]=+h[b+9688>>3]*-2.0;i=i;return}function SD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20440>>3]=+h[b+20456>>3]*.5;i=i;return}function TD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10480>>3]=+h[b+4288>>3]+(+h[b+16200>>3]*+h[d+832>>3]+ +h[b+16224>>3]*+h[d+840>>3]);i=i;return}function UD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9880>>3]=+h[b+10480>>3]+(+h[b+16200>>3]*+h[d+4424>>3]+ +h[b+16224>>3]*+h[d+4432>>3]);i=i;return}function VD(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9856>>3]=+h[b+9880>>3]+(+h[b+14872>>3]*+h[d+3944>>3]+ +h[b+14856>>3]*+h[d+3952>>3]);i=i;return}function WD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9840>>3]=(+h[b+9856>>3]- +h[b+10624>>3])*-.4999999999999999+(+h[b+9864>>3]- +h[b+10632>>3])*.8660254037844387;i=i;return}function XD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9816>>3]=+h[b+15128>>3]- +h[b+9840>>3];i=i;return}function YD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9832>>3]=(+h[b+9856>>3]- +h[b+10624>>3])*.8660254037844387+(+h[b+9864>>3]- +h[b+10632>>3])*.4999999999999999;i=i;return}function ZD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9808>>3]=+h[b+15120>>3]- +h[b+9832>>3];i=i;return}function _D(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20296>>3]=+h[b+9808>>3]*-2.0;i=i;return}function $D(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20280>>3]=+h[b+20296>>3]*.5;i=i;return}function aE(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10456>>3]=+h[b+10480>>3]+(+h[b+16200>>3]*+h[d+3848>>3]+ +h[b+16224>>3]*+h[d+3856>>3]);i=i;return}function bE(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1e4>>3]=+h[b+10456>>3]+(+h[b+16200>>3]*+h[d+7440>>3]+ +h[b+16224>>3]*+h[d+7448>>3]);i=i;return}function cE(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+9976>>3]=+h[b+1e4>>3]+(+h[b+14920>>3]*+h[d+6960>>3]+ +h[b+14904>>3]*+h[d+6968>>3]);i=i;return}function dE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9960>>3]=(+h[b+9976>>3]- +h[b+10648>>3])*.4999999999999999+(+h[b+9984>>3]- +h[b+10656>>3])*.8660254037844387;i=i;return}function eE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9936>>3]=+h[b+15152>>3]- +h[b+9960>>3];i=i;return}function fE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9952>>3]=(+h[b+9976>>3]- +h[b+10648>>3])*.8660254037844387+(+h[b+9984>>3]- +h[b+10656>>3])*-.4999999999999999;i=i;return}function gE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9928>>3]=+h[b+15144>>3]- +h[b+9952>>3];i=i;return}function hE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20136>>3]=+h[b+9928>>3]*-2.0;i=i;return}function iE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20120>>3]=+h[b+20136>>3]*.5;i=i;return}function jE(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10432>>3]=+h[b+10456>>3]+(+h[b+16200>>3]*+h[d+6864>>3]+ +h[b+16224>>3]*+h[d+6872>>3]);i=i;return}function kE(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10120>>3]=+h[b+10432>>3]+(+h[b+16200>>3]*+h[d+10456>>3]+ +h[b+16224>>3]*+h[d+10464>>3]);i=i;return}function lE(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10096>>3]=+h[b+10120>>3]+(+h[b+14968>>3]*+h[d+9976>>3]+ +h[b+14952>>3]*+h[d+9984>>3]);i=i;return}function mE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10080>>3]=(+h[b+10096>>3]- +h[b+10672>>3])*-.4999999999999999+(+h[b+10104>>3]- +h[b+10680>>3])*.8660254037844387;i=i;return}function nE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10056>>3]=+h[b+15176>>3]- +h[b+10080>>3];i=i;return}function oE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10072>>3]=(+h[b+10096>>3]- +h[b+10672>>3])*.8660254037844387+(+h[b+10104>>3]- +h[b+10680>>3])*.4999999999999999;i=i;return}function pE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10048>>3]=+h[b+15168>>3]- +h[b+10072>>3];i=i;return}function qE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19976>>3]=+h[b+10048>>3]*-2.0;i=i;return}function rE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19960>>3]=+h[b+19976>>3]*.5;i=i;return}function sE(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10408>>3]=+h[b+10432>>3]+(+h[b+16200>>3]*+h[d+9880>>3]+ +h[b+16224>>3]*+h[d+9888>>3]);i=i;return}function tE(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10240>>3]=+h[b+10408>>3]+(+h[b+16200>>3]*+h[d+13472>>3]+ +h[b+16224>>3]*+h[d+13480>>3]);i=i;return}function uE(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10216>>3]=+h[b+10240>>3]+(+h[b+15016>>3]*+h[d+12992>>3]+ +h[b+15e3>>3]*+h[d+13e3>>3]);i=i;return}function vE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10200>>3]=(+h[b+10216>>3]- +h[b+10696>>3])*.4999999999999999+(+h[b+10224>>3]- +h[b+10704>>3])*.8660254037844387;i=i;return}function wE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10176>>3]=+h[b+15200>>3]- +h[b+10200>>3];i=i;return}function xE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10192>>3]=(+h[b+10216>>3]- +h[b+10696>>3])*.8660254037844387+(+h[b+10224>>3]- +h[b+10704>>3])*-.4999999999999999;i=i;return}function yE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10168>>3]=+h[b+15192>>3]- +h[b+10192>>3];i=i;return}function zE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19816>>3]=+h[b+10168>>3]*-2.0;i=i;return}function AE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19800>>3]=+h[b+19816>>3]*.5;i=i;return}function BE(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10384>>3]=+h[b+10408>>3]+(+h[b+16200>>3]*+h[d+12896>>3]+ +h[b+16224>>3]*+h[d+12904>>3]);i=i;return}function CE(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+7808>>3]=+h[b+10384>>3]+(+h[b+16200>>3]*+h[d+15912>>3]+ +h[b+16224>>3]*+h[d+15920>>3]);i=i;return}function DE(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10360>>3]=+h[b+10384>>3]+(+h[b+16200>>3]*+h[d+16488>>3]+ +h[b+16224>>3]*+h[d+16496>>3]);i=i;return}function EE(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10336>>3]=+h[b+10360>>3]+(+h[b+15064>>3]*+h[d+16008>>3]+ +h[b+15048>>3]*+h[d+16016>>3]);i=i;return}function FE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10320>>3]=(+h[b+10336>>3]- +h[b+10720>>3])*-.4999999999999999+(+h[b+10344>>3]- +h[b+10728>>3])*.8660254037844387;i=i;return}function GE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10296>>3]=+h[b+15224>>3]- +h[b+10320>>3];i=i;return}function HE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10312>>3]=(+h[b+10336>>3]- +h[b+10720>>3])*.8660254037844387+(+h[b+10344>>3]- +h[b+10728>>3])*.4999999999999999;i=i;return}function IE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10288>>3]=+h[b+15216>>3]- +h[b+10312>>3];i=i;return}function JE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19656>>3]=+h[b+10288>>3]*-2.0;i=i;return}function KE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19640>>3]=+h[b+19656>>3]*.5;i=i;return}function LE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=10.0;i=i;return}function ME(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20496>>3]=+h[b+16>>3]*9.549296585513721;i=i;return}function NE(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+24>>3]));h[b+5040>>3]=-(d*+h[b+16>>3]);i=i;return}function OE(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+24>>3]));h[b+5048>>3]=d*+h[b+16>>3];i=i;return}function PE(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+24>>3]));h[b+5056>>3]=-(d*+h[b+16>>3]);i=i;return}function QE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4840>>3]=+h[b+5040>>3]*.4999999999999999+ +h[b+5056>>3]*.8660254037844387;i=i;return}function RE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4824>>3]=+h[b+5040>>3]*.8660254037844387+ +h[b+5056>>3]*-.4999999999999999;i=i;return}function SE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4768>>3]=+h[b+5056>>3]*6.123233995736766e-17- +h[b+5040>>3];i=i;return}function TE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4752>>3]=+h[b+5040>>3]*6.123233995736766e-17+ +h[b+5056>>3];i=i;return}function UE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4696>>3]=+h[b+5040>>3]*.5000000000000001+ +h[b+5056>>3]*-.8660254037844386;i=i;return}function VE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4680>>3]=+h[b+5040>>3]*-.8660254037844386+ +h[b+5056>>3]*-.5000000000000001;i=i;return}function WE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4624>>3]=+h[b+5040>>3]*.5000000000000001+ +h[b+5056>>3]*-.8660254037844386;i=i;return}function XE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4608>>3]=+h[b+5040>>3]*-.8660254037844386+ +h[b+5056>>3]*-.5000000000000001;i=i;return}function YE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4552>>3]=+h[b+5056>>3]*6.123233995736766e-17- +h[b+5040>>3];i=i;return}function ZE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4536>>3]=+h[b+5040>>3]*6.123233995736766e-17+ +h[b+5056>>3];i=i;return}function _E(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4480>>3]=+h[b+5040>>3]*.4999999999999999+ +h[b+5056>>3]*.8660254037844387;i=i;return}function $E(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4464>>3]=+h[b+5040>>3]*.8660254037844387+ +h[b+5056>>3]*-.4999999999999999;i=i;return}function aF(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+24>>3]));h[b+5064>>3]=-(d*+h[b+16>>3]);i=i;return}function bF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4848>>3]=+h[b+5048>>3]*.4999999999999999+ +h[b+5064>>3]*.8660254037844387;i=i;return}function cF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4832>>3]=+h[b+5048>>3]*.8660254037844387+ +h[b+5064>>3]*-.4999999999999999;i=i;return}function dF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4776>>3]=+h[b+5064>>3]*6.123233995736766e-17- +h[b+5048>>3];i=i;return}function eF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4760>>3]=+h[b+5048>>3]*6.123233995736766e-17+ +h[b+5064>>3];i=i;return}function fF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4704>>3]=+h[b+5048>>3]*.5000000000000001+ +h[b+5064>>3]*-.8660254037844386;i=i;return}function gF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4688>>3]=+h[b+5048>>3]*-.8660254037844386+ +h[b+5064>>3]*-.5000000000000001;i=i;return}function hF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4632>>3]=+h[b+5048>>3]*.5000000000000001+ +h[b+5064>>3]*-.8660254037844386;i=i;return}function iF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4616>>3]=+h[b+5048>>3]*-.8660254037844386+ +h[b+5064>>3]*-.5000000000000001;i=i;return}function jF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4560>>3]=+h[b+5064>>3]*6.123233995736766e-17- +h[b+5048>>3];i=i;return}function kF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4544>>3]=+h[b+5048>>3]*6.123233995736766e-17+ +h[b+5064>>3];i=i;return}function lF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4488>>3]=+h[b+5048>>3]*.4999999999999999+ +h[b+5064>>3]*.8660254037844387;i=i;return}function mF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4472>>3]=+h[b+5048>>3]*.8660254037844387+ +h[b+5064>>3]*-.4999999999999999;i=i;return}function nF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+56>>3]=+h[b+16>>3];i=i;return}function oF(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0.0,q=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+25504>>3];j=b+4|0;k=c[c[j>>2]>>2]|0;l=c[k+8>>2]|0;m=+h[l+16>>3];do{if(g!=0.0){n=l;o=f;p=m/g}else{if(m==0.0){n=l;o=f;p=m;break}q=m/+$Lb(c[b+536>>2]|0,g,18448,18440,+h[k>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[j>>2]>>2]|0)+8>>2]|0;o=c[e>>2]|0;p=q}}while(0);h[n+19504>>3]=p*p*+h[o+25496>>3];i=d;return}function pF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9624>>3]=+h[b+16224>>3]*d*+h[e+272>>3]- +h[b+16200>>3]*d*+h[e+280>>3];i=i;return}function qF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9528>>3]=+h[b+9624>>3]+(+h[b+16224>>3]*d*+h[e+1408>>3]- +h[b+16200>>3]*d*+h[e+1416>>3]);i=i;return}function rF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9488>>3]=+h[b+9528>>3]+(+h[b+14808>>3]*d*+h[e+928>>3]- +h[b+14824>>3]*d*+h[e+936>>3]);i=i;return}function sF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9576>>3]=+h[b+9624>>3]+(+h[b+16224>>3]*d*+h[e+832>>3]- +h[b+16200>>3]*d*+h[e+840>>3]);i=i;return}function tF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9248>>3]=+h[b+9576>>3]+(+h[b+16224>>3]*d*+h[e+4424>>3]- +h[b+16200>>3]*d*+h[e+4432>>3]);i=i;return}function uF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9208>>3]=+h[b+9248>>3]+(+h[b+14856>>3]*d*+h[e+3944>>3]- +h[b+14872>>3]*d*+h[e+3952>>3]);i=i;return}function vF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9320>>3]=+h[b+9576>>3]+(+h[b+16224>>3]*d*+h[e+3848>>3]- +h[b+16200>>3]*d*+h[e+3856>>3]);i=i;return}function wF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8968>>3]=+h[b+9320>>3]+(+h[b+16224>>3]*d*+h[e+7440>>3]- +h[b+16200>>3]*d*+h[e+7448>>3]);i=i;return}function xF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8928>>3]=+h[b+8968>>3]+(+h[b+14904>>3]*d*+h[e+6960>>3]- +h[b+14920>>3]*d*+h[e+6968>>3]);i=i;return}function yF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9040>>3]=+h[b+9320>>3]+(+h[b+16224>>3]*d*+h[e+6864>>3]- +h[b+16200>>3]*d*+h[e+6872>>3]);i=i;return}function zF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8688>>3]=+h[b+9040>>3]+(+h[b+16224>>3]*d*+h[e+10456>>3]- +h[b+16200>>3]*d*+h[e+10464>>3]);i=i;return}function AF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8648>>3]=+h[b+8688>>3]+(+h[b+14952>>3]*d*+h[e+9976>>3]- +h[b+14968>>3]*d*+h[e+9984>>3]);i=i;return}function BF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8760>>3]=+h[b+9040>>3]+(+h[b+16224>>3]*d*+h[e+9880>>3]- +h[b+16200>>3]*d*+h[e+9888>>3]);i=i;return}function CF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8408>>3]=+h[b+8760>>3]+(+h[b+16224>>3]*d*+h[e+13472>>3]- +h[b+16200>>3]*d*+h[e+13480>>3]);i=i;return}function DF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8368>>3]=+h[b+8408>>3]+(+h[b+15e3>>3]*d*+h[e+12992>>3]- +h[b+15016>>3]*d*+h[e+13e3>>3]);i=i;return}function EF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8480>>3]=+h[b+8760>>3]+(+h[b+16224>>3]*d*+h[e+12896>>3]- +h[b+16200>>3]*d*+h[e+12904>>3]);i=i;return}function FF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8176>>3]=+h[b+8480>>3]+(+h[b+16224>>3]*d*+h[e+16488>>3]- +h[b+16200>>3]*d*+h[e+16496>>3]);i=i;return}function GF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8136>>3]=+h[b+8176>>3]+(+h[b+15048>>3]*d*+h[e+16008>>3]- +h[b+15064>>3]*d*+h[e+16016>>3]);i=i;return}function HF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9632>>3]=+h[b+16232>>3]*d*+h[e+272>>3]- +h[b+16208>>3]*d*+h[e+280>>3];i=i;return}function IF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9536>>3]=+h[b+9632>>3]+(+h[b+16232>>3]*d*+h[e+1408>>3]- +h[b+16208>>3]*d*+h[e+1416>>3]);i=i;return}function JF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9496>>3]=+h[b+9536>>3]+(+h[b+14800>>3]*d*+h[e+928>>3]- +h[b+14816>>3]*d*+h[e+936>>3]);i=i;return}function KF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9448>>3]=+h[b+9488>>3]*-.8660254037844387+ +h[b+9496>>3]*.4999999999999999;i=i;return}function LF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20888>>3]=+h[b+9448>>3]*-2.0;i=i;return}function MF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20904>>3]=+h[b+20888>>3]*.5;i=i;return}function NF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9456>>3]=+h[b+9488>>3]*-.4999999999999999+ +h[b+9496>>3]*-.8660254037844387;i=i;return}function OF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20896>>3]=(+h[b+9688>>3]*+h[b+9448>>3]+ +h[b+9696>>3]*+h[b+9456>>3])*2.0;i=i;return}function PF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20920>>3]=+h[b+20440>>3]*+h[b+20904>>3]*2.0- +h[b+20896>>3];i=i;return}function QF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9584>>3]=+h[b+9632>>3]+(+h[b+16232>>3]*d*+h[e+832>>3]- +h[b+16208>>3]*d*+h[e+840>>3]);i=i;return}function RF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9256>>3]=+h[b+9584>>3]+(+h[b+16232>>3]*d*+h[e+4424>>3]- +h[b+16208>>3]*d*+h[e+4432>>3]);i=i;return}function SF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9216>>3]=+h[b+9256>>3]+(+h[b+14848>>3]*d*+h[e+3944>>3]- +h[b+14864>>3]*d*+h[e+3952>>3]);i=i;return}function TF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9168>>3]=+h[b+9208>>3]*-.8660254037844387+ +h[b+9216>>3]*-.4999999999999999;i=i;return}function UF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20936>>3]=+h[b+9168>>3]*-2.0;i=i;return}function VF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20952>>3]=+h[b+20936>>3]*.5;i=i;return}function WF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9176>>3]=+h[b+9208>>3]*.4999999999999999+ +h[b+9216>>3]*-.8660254037844387;i=i;return}function XF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20944>>3]=(+h[b+9808>>3]*+h[b+9168>>3]+ +h[b+9816>>3]*+h[b+9176>>3])*2.0;i=i;return}function YF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20968>>3]=+h[b+20280>>3]*+h[b+20952>>3]*2.0- +h[b+20944>>3];i=i;return}function ZF(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9328>>3]=+h[b+9584>>3]+(+h[b+16232>>3]*d*+h[e+3848>>3]- +h[b+16208>>3]*d*+h[e+3856>>3]);i=i;return}function _F(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8976>>3]=+h[b+9328>>3]+(+h[b+16232>>3]*d*+h[e+7440>>3]- +h[b+16208>>3]*d*+h[e+7448>>3]);i=i;return}function $F(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8936>>3]=+h[b+8976>>3]+(+h[b+14896>>3]*d*+h[e+6960>>3]- +h[b+14912>>3]*d*+h[e+6968>>3]);i=i;return}function aG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8888>>3]=+h[b+8928>>3]*-.8660254037844387+ +h[b+8936>>3]*.4999999999999999;i=i;return}function bG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20984>>3]=+h[b+8888>>3]*-2.0;i=i;return}function cG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21e3>>3]=+h[b+20984>>3]*.5;i=i;return}function dG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8896>>3]=+h[b+8928>>3]*-.4999999999999999+ +h[b+8936>>3]*-.8660254037844387;i=i;return}function eG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20992>>3]=(+h[b+9928>>3]*+h[b+8888>>3]+ +h[b+9936>>3]*+h[b+8896>>3])*2.0;i=i;return}function fG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21016>>3]=+h[b+20120>>3]*+h[b+21e3>>3]*2.0- +h[b+20992>>3];i=i;return}function gG(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+9048>>3]=+h[b+9328>>3]+(+h[b+16232>>3]*d*+h[e+6864>>3]- +h[b+16208>>3]*d*+h[e+6872>>3]);i=i;return}function hG(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8696>>3]=+h[b+9048>>3]+(+h[b+16232>>3]*d*+h[e+10456>>3]- +h[b+16208>>3]*d*+h[e+10464>>3]);i=i;return}function iG(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8656>>3]=+h[b+8696>>3]+(+h[b+14944>>3]*d*+h[e+9976>>3]- +h[b+14960>>3]*d*+h[e+9984>>3]);i=i;return}function jG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8608>>3]=+h[b+8648>>3]*-.8660254037844387+ +h[b+8656>>3]*-.4999999999999999;i=i;return}function kG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21032>>3]=+h[b+8608>>3]*-2.0;i=i;return}function lG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21048>>3]=+h[b+21032>>3]*.5;i=i;return}function mG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8616>>3]=+h[b+8648>>3]*.4999999999999999+ +h[b+8656>>3]*-.8660254037844387;i=i;return}function nG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21040>>3]=(+h[b+10048>>3]*+h[b+8608>>3]+ +h[b+10056>>3]*+h[b+8616>>3])*2.0;i=i;return}function oG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21064>>3]=+h[b+19960>>3]*+h[b+21048>>3]*2.0- +h[b+21040>>3];i=i;return}function pG(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8768>>3]=+h[b+9048>>3]+(+h[b+16232>>3]*d*+h[e+9880>>3]- +h[b+16208>>3]*d*+h[e+9888>>3]);i=i;return}function qG(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8416>>3]=+h[b+8768>>3]+(+h[b+16232>>3]*d*+h[e+13472>>3]- +h[b+16208>>3]*d*+h[e+13480>>3]);i=i;return}function rG(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8376>>3]=+h[b+8416>>3]+(+h[b+14992>>3]*d*+h[e+12992>>3]- +h[b+15008>>3]*d*+h[e+13e3>>3]);i=i;return}function sG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8328>>3]=+h[b+8368>>3]*-.8660254037844387+ +h[b+8376>>3]*.4999999999999999;i=i;return}function tG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21080>>3]=+h[b+8328>>3]*-2.0;i=i;return}function uG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21096>>3]=+h[b+21080>>3]*.5;i=i;return}function vG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8336>>3]=+h[b+8368>>3]*-.4999999999999999+ +h[b+8376>>3]*-.8660254037844387;i=i;return}function wG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21088>>3]=(+h[b+10168>>3]*+h[b+8328>>3]+ +h[b+10176>>3]*+h[b+8336>>3])*2.0;i=i;return}function xG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21112>>3]=+h[b+19800>>3]*+h[b+21096>>3]*2.0- +h[b+21088>>3];i=i;return}function yG(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8488>>3]=+h[b+8768>>3]+(+h[b+16232>>3]*d*+h[e+12896>>3]- +h[b+16208>>3]*d*+h[e+12904>>3]);i=i;return}function zG(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8184>>3]=+h[b+8488>>3]+(+h[b+16232>>3]*d*+h[e+16488>>3]- +h[b+16208>>3]*d*+h[e+16496>>3]);i=i;return}function AG(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8144>>3]=+h[b+8184>>3]+(+h[b+15040>>3]*d*+h[e+16008>>3]- +h[b+15056>>3]*d*+h[e+16016>>3]);i=i;return}function BG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8096>>3]=+h[b+8136>>3]*-.8660254037844387+ +h[b+8144>>3]*-.4999999999999999;i=i;return}function CG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21128>>3]=+h[b+8096>>3]*-2.0;i=i;return}function DG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21144>>3]=+h[b+21128>>3]*.5;i=i;return}function EG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8104>>3]=+h[b+8136>>3]*.4999999999999999+ +h[b+8144>>3]*-.8660254037844387;i=i;return}function FG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21136>>3]=(+h[b+10288>>3]*+h[b+8096>>3]+ +h[b+10296>>3]*+h[b+8104>>3])*2.0;i=i;return}function GG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21160>>3]=+h[b+19640>>3]*+h[b+21144>>3]*2.0- +h[b+21136>>3];i=i;return}function HG(a){a=a|0;h[(c[a+416>>2]|0)+19816>>3]=.175;i=i;return}function IG(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19816>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+9656>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+6976|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+6976|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,18472,18464,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6976|0;p=o;h[p>>3]=m;i=d;return}function JG(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19736>>3]=+h[b+19816>>3];i=i;return}function KG(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19744>>3]=+h[b+19816>>3];i=i;return}function LG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0;d=i;i=i+64|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+8|0;p=b+4|0;q=c[(c[c[p>>2]>>2]|0)+8>>2]|0;r=+h[q+9704>>3];s=+h[q+9720>>3];t=l;h[k>>3]=+h[q+9712>>3];c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=l+8|0;h[k>>3]=s;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];UMb(m,3,r,l);l=c[(c[c[p>>2]>>2]|0)+8>>2]|0;r=+h[l+15088>>3];s=+h[l+15104>>3];p=j;h[k>>3]=+h[l+15096>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j+8|0;h[k>>3]=s;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];UMb(n,3,r,j);j=c[b+536>>2]|0;p=c[b+416>>2]|0;r=+h[p+19744>>3];s=+h[p+19752>>3]+ +h[p+19760>>3];p=g;l=18072;c[p+0>>2]=c[l+0>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];l=f;p=m;c[l+0>>2]=c[p+0>>2];c[l+4>>2]=c[p+4>>2];c[l+8>>2]=c[p+8>>2];p=e;l=n;c[p+0>>2]=c[l+0>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];dv(o,j,r,g,s,f,e);a[(c[b+424>>2]|0)+35|0]=a[o]|0;i=d;return}function MG(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+9680>>3];e=+h[b+9688>>3];f=+h[b+9696>>3];g=+h[(c[a+416>>2]|0)+19744>>3];h[b+20448>>3]=d*d+(e*e+(f*f-g*g));i=i;return}function NG(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+20440>>3];h[b+20424>>3]=d*d- +h[b+20448>>3];i=i;return}function OG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;av(d,c[a+536>>2]|0,+h[f+20424>>3],1.0e-12,+h[f+20920>>3],0.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20928>>3]=+h[d>>3];i=b;return}function PG(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;bv(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20424>>3],1.0e-12);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20416>>3]=+h[d>>3];i=b;return}function QG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+20416>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=22632;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,18544,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+20928>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+20912|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+20912|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,18648,18528,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+20912|0;y=x;h[y>>3]=v;i=d;return}function RG(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+20904>>3];g=+h[e+20912>>3];if((a[(c[b+424>>2]|0)+35|0]|0)!=0){j=g;k=f-j;l=e;m=l+20328|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+20328|0;n=m;h[n>>3]=k;i=d;return}function SG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9376>>3]=+h[b+20328>>3]*-.4999999999999999;i=i;return}function TG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9424>>3]=+h[b+9376>>3]- +h[b+9496>>3];i=i;return}function UG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9368>>3]=+h[b+20328>>3]*.8660254037844387;i=i;return}function VG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9416>>3]=+h[b+9368>>3]- +h[b+9488>>3];i=i;return}function WG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+20416>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+20432|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=22632;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,18544,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+20432|0;p=o;h[p>>3]=m;i=b;return}function XG(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+20440>>3];g=+h[e+20432>>3];if((a[(c[b+424>>2]|0)+35|0]|0)!=0){j=g;k=f-j;l=e;m=l+16320|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+16320|0;n=m;h[n>>3]=k;i=d;return}function YG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20392>>3]=+h[(c[a+416>>2]|0)+19752>>3]+ +h[b+16320>>3];i=i;return}function ZG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20368>>3]=-+h[b+20392>>3]/.195;i=i;return}function _G(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20376>>3]=+h[b+20392>>3]/.195+1.0;i=i;return}function $G(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+15|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+15|0]|0;k=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20328>>3],0.0,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=k;f=j;break}else{j=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20328>>3],0.0,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+15|0]|0;j=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20328>>3],0.0)|0;a[(c[b+352>>2]|0)+15|0]=j;f=g;break}else{g=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20328>>3],0.0)|0;a[(c[b+352>>2]|0)+15|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+17|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+17|0]|0;j=b+4|0;k=YOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20376>>3],.93,a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=k;l=j;m=e;break}else{e=b+4|0;j=YOb(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20376>>3],.93,a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+17|0]|0;j=b+4|0;e=$Ob(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20376>>3],.93)|0;a[(c[b+352>>2]|0)+17|0]=e;l=j;m=f;break}else{f=b+4|0;j=$Ob(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20376>>3],.93)|0;a[(c[b+352>>2]|0)+17|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+20376>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+20320|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+20320|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+16|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+16|0]|0;l=b+4|0;f=XOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+20376>>3],.987,a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=f;w=l;x=m;break}else{m=b+4|0;l=XOb(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+20376>>3],.987,a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+16|0]|0;l=b+4|0;m=ZOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+20376>>3],.987)|0;a[(c[b+352>>2]|0)+16|0]=m;w=l;x=j;break}else{j=b+4|0;l=ZOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20376>>3],.987)|0;a[(c[b+352>>2]|0)+16|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+20376>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+20320|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+20320|0;v=u;h[v>>3]=s;i=d;return}}}function aH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20352>>3]=+h[b+20320>>3]*1.0e-5;i=i;return}function bH(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+19896>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+20384>>3]=b*b*+h[d+20352>>3]*-78539.81633974482;i=i;return}function cH(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+20344>>3]=+h[b+19904>>3]+ +h[b+19912>>3]*(1.0- +h[d+20376>>3]);i=i;return}function dH(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19920>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+20320>>3]*+h[j+20344>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+20336|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+20336|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,18720,18712,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+20336|0;p=o;h[p>>3]=m;i=d;return}function eH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20344>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+20360|0;p=o;h[p>>3]=m;i=d;return}q=+$Lb(c[b+536>>2]|0,j,18760,18752,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+20360|0;p=o;h[p>>3]=m;i=d;return}function fH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3472>>3]=+h[b+16112>>3]+ +h[b+16320>>3]*-.4999999999999999;i=i;return}function gH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10848>>3]=+h[b+3472>>3]+(+h[d+3288>>3]*.4999999999999999+ +h[d+3296>>3]*-.8660254037844387);i=i;return}function hH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3744>>3]=+h[b+3472>>3]+.05;i=i;return}function iH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9672>>3]=+h[b+3744>>3]- +h[b+9744>>3];i=i;return}function jH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3480>>3]=+h[b+16104>>3]+ +h[b+16320>>3]*.8660254037844387;i=i;return}function kH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10840>>3]=+h[b+3480>>3]+(+h[d+3288>>3]*-.8660254037844387+ +h[d+3296>>3]*-.4999999999999999);i=i;return}function lH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3752>>3]=+h[b+3480>>3]+-.08660254037844388;i=i;return}function mH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9664>>3]=+h[b+3752>>3]- +h[b+9736>>3];i=i;return}function nH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6936>>3]=+h[b+14824>>3]*+h[b+9416>>3]+(+h[b+14816>>3]*+h[b+9424>>3]+ +h[b+16>>3]*(+h[b+14808>>3]*+h[b+9664>>3]+ +h[b+14800>>3]*+h[b+9672>>3]));i=i;return}function oH(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19816>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6936>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+6912|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+6912|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,18472,18792,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6912|0;p=o;h[p>>3]=m;i=d;return}function pH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6944>>3]=+h[b+14808>>3]*+h[b+9416>>3]+(+h[b+14800>>3]*+h[b+9424>>3]- +h[b+16>>3]*(+h[b+14824>>3]*+h[b+9664>>3]+ +h[b+14816>>3]*+h[b+9672>>3]));i=i;return}function qH(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19816>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6944>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+6920|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+6920|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,18472,18800,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6920|0;p=o;h[p>>3]=m;i=d;return}function rH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3568>>3]=+h[b+14824>>3]*+h[b+9664>>3]+ +h[b+14816>>3]*+h[b+9672>>3];i=i;return}function sH(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19816>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+14808>>3]*+h[j+9416>>3]+(+h[j+14800>>3]*+h[j+9424>>3]- +h[j+16>>3]*+h[j+3568>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+9400|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+9400|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,18472,18808,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9400|0;p=o;h[p>>3]=m;i=d;return}function tH(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19816>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3568>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+3680|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+3680|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,18472,18816,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3680|0;p=o;h[p>>3]=m;i=d;return}function uH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3560>>3]=+h[b+14808>>3]*+h[b+9664>>3]+ +h[b+14800>>3]*+h[b+9672>>3];i=i;return}function vH(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19816>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+14824>>3]*+h[j+9416>>3]+(+h[j+14816>>3]*+h[j+9424>>3]+ +h[j+16>>3]*+h[j+3560>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+9392|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+9392|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,18472,18824,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9392|0;p=o;h[p>>3]=m;i=d;return}function wH(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19816>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3560>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+3672|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+3672|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,18472,18832,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3672|0;p=o;h[p>>3]=m;i=d;return}function xH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20840>>3]=(+h[b+3672>>3]*+h[b+6920>>3]+ +h[b+3680>>3]*+h[b+6912>>3])*2.0;i=i;return}function yH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6984>>3]=+h[b+3680>>3]*+h[b+14824>>3]+ +h[b+3672>>3]*+h[b+14808>>3];i=i;return}function zH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6992>>3]=+h[b+3680>>3]*+h[b+14816>>3]+ +h[b+3672>>3]*+h[b+14800>>3];i=i;return}function AH(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3680>>3];e=+h[b+3672>>3];h[b+20464>>3]=(+h[b+14824>>3]*d+ +h[b+14808>>3]*e)*-.8660254037844387+(d*+h[b+14816>>3]+e*+h[b+14800>>3])*.4999999999999999;i=i;return}function BH(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3672>>3];e=+h[b+3680>>3];h[b+20408>>3]=d*d+e*e;i=i;return}function CH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+20408>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=22632;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,18848,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+20840>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+20792|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+20792|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,18960,18840,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+20792|0;y=x;h[y>>3]=v;i=d;return}function DH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+20408>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+20400|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=22632;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,18848,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+20400|0;p=o;h[p>>3]=m;i=b;return}function EH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20400>>3];k=j*j;l=j*+h[g+6912>>3]- +h[g+3680>>3]*+h[g+20792>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4504|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4504|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,19040,19032,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4504|0;q=p;h[q>>3]=n;i=d;return}function FH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4520>>3]=-(+h[b+6976>>3]*+h[b+4504>>3]);i=i;return}function GH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20400>>3];k=j*j;l=+h[g+3672>>3]*+h[g+20792>>3]-j*+h[g+6920>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4496|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4496|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,19040,19104,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4496|0;q=p;h[q>>3]=n;i=d;return}function HH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4528>>3]=+h[b+6976>>3]*+h[b+4496>>3];i=i;return}function IH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20400>>3];k=+h[g+3680>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+16040|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+16040|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,19120,19112,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+16040|0;p=o;h[p>>3]=m;i=d;return}function JH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3600>>3]=-(+h[b+6976>>3]*+h[b+16040>>3]);i=i;return}function KH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20400>>3];k=+h[g+3672>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+16032|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+16032|0;q=p;h[q>>3]=n;i=d;return}k=l/+$Lb(c[b+536>>2]|0,j,19120,19176,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+16032|0;q=p;h[q>>3]=n;i=d;return}function LH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4512>>3]=+h[b+3680>>3]*+h[b+4504>>3]+(+h[b+6912>>3]*+h[b+16040>>3]+(-(+h[b+3672>>3]*+h[b+4496>>3])- +h[b+6920>>3]*+h[b+16032>>3]));i=i;return}function MH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7008>>3]=+h[b+16032>>3]*+h[b+14824>>3]+ +h[b+16040>>3]*+h[b+14808>>3];i=i;return}function NH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7016>>3]=+h[b+16032>>3]*+h[b+14816>>3]+ +h[b+16040>>3]*+h[b+14800>>3];i=i;return}function OH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3576>>3]=+h[b+16032>>3]*+h[b+9392>>3]+ +h[b+16040>>3]*+h[b+9400>>3];i=i;return}function PH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3592>>3]=+h[b+6976>>3]*+h[b+16032>>3];i=i;return}function QH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6960>>3]=+h[b+3600>>3]*+h[b+14824>>3]+ +h[b+3592>>3]*+h[b+14808>>3];i=i;return}function RH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3544>>3]=+h[b+9736>>3]+(+h[b+6960>>3]*+h[d+2648>>3]+(+h[b+6984>>3]*+h[d+2656>>3]+ +h[b+7008>>3]*+h[d+2664>>3]));i=i;return}function SH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6968>>3]=+h[b+3600>>3]*+h[b+14816>>3]+ +h[b+3592>>3]*+h[b+14800>>3];i=i;return}function TH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3552>>3]=+h[b+9744>>3]+(+h[b+6968>>3]*+h[d+2648>>3]+(+h[b+6992>>3]*+h[d+2656>>3]+ +h[b+7016>>3]*+h[d+2664>>3]));i=i;return}function UH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3528>>3]=-(+h[b+3592>>3]*+h[b+9400>>3])- +h[b+3600>>3]*+h[b+9392>>3];i=i;return}function VH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20400>>3];k=+h[g+3592>>3]*+h[g+9392>>3]- +h[g+3600>>3]*+h[g+9400>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3584|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3584|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,19120,19184,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3584|0;p=o;h[p>>3]=m;i=d;return}function WH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3520>>3]=+h[b+6976>>3]*+h[b+16>>3]+ +h[b+3584>>3];i=i;return}function XH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6952>>3]=+h[b+3680>>3]*+h[b+16040>>3]- +h[b+3672>>3]*+h[b+16032>>3];i=i;return}function YH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3536>>3]=+h[b+9728>>3]+(+h[b+6952>>3]*+h[d+2648>>3]+ +h[b+6976>>3]*+h[d+2656>>3]);i=i;return}function ZH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3512>>3]=+h[b+6952>>3]*+h[b+16>>3]+ +h[b+3576>>3];i=i;return}function _H(a){a=a|0;h[(c[a+416>>2]|0)+20848>>3]=.175;i=i;return}function $H(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+20848>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+9776>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7160|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7160|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,19200,19192,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7160|0;p=o;h[p>>3]=m;i=d;return}function aI(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20768>>3]=+h[b+20848>>3];i=i;return}function bI(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20776>>3]=+h[b+20848>>3];i=i;return}function cI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0;d=i;i=i+64|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+8|0;p=b+4|0;q=c[(c[c[p>>2]>>2]|0)+8>>2]|0;r=+h[q+9824>>3];s=+h[q+9840>>3];t=l;h[k>>3]=+h[q+9832>>3];c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=l+8|0;h[k>>3]=s;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];UMb(m,3,r,l);l=c[(c[c[p>>2]>>2]|0)+8>>2]|0;r=+h[l+15112>>3];s=+h[l+15128>>3];p=j;h[k>>3]=+h[l+15120>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j+8|0;h[k>>3]=s;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];UMb(n,3,r,j);j=c[b+536>>2]|0;p=c[b+416>>2]|0;r=+h[p+20776>>3];s=+h[p+20784>>3]+ +h[p+20792>>3];p=g;l=18072;c[p+0>>2]=c[l+0>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];l=f;p=m;c[l+0>>2]=c[p+0>>2];c[l+4>>2]=c[p+4>>2];c[l+8>>2]=c[p+8>>2];p=e;l=n;c[p+0>>2]=c[l+0>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];dv(o,j,r,g,s,f,e);a[(c[b+424>>2]|0)+83|0]=a[o]|0;i=d;return}function dI(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+9800>>3];e=+h[b+9808>>3];f=+h[b+9816>>3];g=+h[(c[a+416>>2]|0)+20776>>3];h[b+20288>>3]=d*d+(e*e+(f*f-g*g));i=i;return}function eI(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+20280>>3];h[b+20264>>3]=d*d- +h[b+20288>>3];i=i;return}function fI(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;av(d,c[a+536>>2]|0,+h[f+20264>>3],1.0e-12,+h[f+20968>>3],0.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20976>>3]=+h[d>>3];i=b;return}function gI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;bv(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20264>>3],1.0e-12);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20256>>3]=+h[d>>3];i=b;return}function hI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+20256>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=22632;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,19264,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+20976>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+20960|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+20960|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,19368,19256,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+20960|0;y=x;h[y>>3]=v;i=d;return}function iI(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+20952>>3];g=+h[e+20960>>3];if((a[(c[b+424>>2]|0)+83|0]|0)!=0){j=g;k=f-j;l=e;m=l+20168|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+20168|0;n=m;h[n>>3]=k;i=d;return}function jI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9096>>3]=+h[b+20168>>3]*.4999999999999999;i=i;return}function kI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9144>>3]=+h[b+9096>>3]- +h[b+9216>>3];i=i;return}function lI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9088>>3]=+h[b+20168>>3]*.8660254037844387;i=i;return}function mI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9136>>3]=+h[b+9088>>3]- +h[b+9208>>3];i=i;return}function nI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+20256>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+20272|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=22632;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,19264,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+20272|0;p=o;h[p>>3]=m;i=b;return}function oI(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+20280>>3];g=+h[e+20272>>3];if((a[(c[b+424>>2]|0)+83|0]|0)!=0){j=g;k=f-j;l=e;m=l+16552|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+16552|0;n=m;h[n>>3]=k;i=d;return}function pI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20232>>3]=+h[(c[a+416>>2]|0)+20784>>3]+ +h[b+16552>>3];i=i;return}function qI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20208>>3]=-+h[b+20232>>3]/.195;i=i;return}function rI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20216>>3]=+h[b+20232>>3]/.195+1.0;i=i;return}function sI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+12|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+12|0]|0;k=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20168>>3],0.0,a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=k;f=j;break}else{j=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20168>>3],0.0,a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+12|0]|0;j=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20168>>3],0.0)|0;a[(c[b+352>>2]|0)+12|0]=j;f=g;break}else{g=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+20168>>3],0.0)|0;a[(c[b+352>>2]|0)+12|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+14|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+14|0]|0;j=b+4|0;k=YOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20216>>3],.93,a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=k;l=j;m=e;break}else{e=b+4|0;j=YOb(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+20216>>3],.93,a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+14|0]|0;j=b+4|0;e=$Ob(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20216>>3],.93)|0;a[(c[b+352>>2]|0)+14|0]=e;l=j;m=f;break}else{f=b+4|0;j=$Ob(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+20216>>3],.93)|0;a[(c[b+352>>2]|0)+14|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+20216>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+20160|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+20160|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+13|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+13|0]|0;l=b+4|0;f=XOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+20216>>3],.987,a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=f;w=l;x=m;break}else{m=b+4|0;l=XOb(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+20216>>3],.987,a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+13|0]|0;l=b+4|0;m=ZOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+20216>>3],.987)|0;a[(c[b+352>>2]|0)+13|0]=m;w=l;x=j;break}else{j=b+4|0;l=ZOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+20216>>3],.987)|0;a[(c[b+352>>2]|0)+13|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+20216>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+20160|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+20160|0;v=u;h[v>>3]=s;i=d;return}}}function tI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20192>>3]=+h[b+20160>>3]*1.0e-5;i=i;return}function uI(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+20928>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+20224>>3]=b*b*+h[d+20192>>3]*-78539.81633974482;i=i;return}function vI(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+20184>>3]=+h[b+20936>>3]+ +h[b+20944>>3]*(1.0- +h[d+20216>>3]);i=i;return}function wI(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+20952>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+20160>>3]*+h[j+20184>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+20176|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+20176|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,19440,19432,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+20176|0;p=o;h[p>>3]=m;i=d;return}function xI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20184>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+20200|0;p=o;h[p>>3]=m;i=d;return}q=+$Lb(c[b+536>>2]|0,j,19480,19472,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+20200|0;p=o;h[p>>3]=m;i=d;return}function yI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2752>>3]=+h[b+10632>>3]+ +h[b+16552>>3]*.4999999999999999;i=i;return}function zI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10512>>3]=+h[b+2752>>3]+(+h[d+6304>>3]*-.4999999999999999+ +h[d+6312>>3]*-.8660254037844387);i=i;return}function AI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3024>>3]=+h[b+2752>>3]+-.05;i=i;return}function BI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9792>>3]=+h[b+3024>>3]- +h[b+9864>>3];i=i;return}function CI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2760>>3]=+h[b+10624>>3]+ +h[b+16552>>3]*.8660254037844387;i=i;return}function DI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10504>>3]=+h[b+2760>>3]+(+h[d+6304>>3]*-.8660254037844387+ +h[d+6312>>3]*.4999999999999999);i=i;return}function EI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3032>>3]=+h[b+2760>>3]+-.08660254037844388;i=i;return}function FI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9784>>3]=+h[b+3032>>3]- +h[b+9856>>3];i=i;return}function GI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7120>>3]=+h[b+14872>>3]*+h[b+9136>>3]+(+h[b+14864>>3]*+h[b+9144>>3]+ +h[b+16>>3]*(+h[b+14856>>3]*+h[b+9784>>3]+ +h[b+14848>>3]*+h[b+9792>>3]));i=i;return}function HI(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+20848>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7120>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7096|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7096|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,19200,19512,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7096|0;p=o;h[p>>3]=m;i=d;return}function II(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7128>>3]=+h[b+14856>>3]*+h[b+9136>>3]+(+h[b+14848>>3]*+h[b+9144>>3]- +h[b+16>>3]*(+h[b+14872>>3]*+h[b+9784>>3]+ +h[b+14864>>3]*+h[b+9792>>3]));i=i;return}function JI(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+20848>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7128>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7104|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7104|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,19200,19520,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7104|0;p=o;h[p>>3]=m;i=d;return}function KI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2848>>3]=+h[b+14872>>3]*+h[b+9784>>3]+ +h[b+14864>>3]*+h[b+9792>>3];i=i;return}



function Zca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14480>>3]=0.0;i=i;return}function _ca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14520>>3]=0.0;i=i;return}function $ca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14496>>3]=1.0;i=i;return}function ada(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14472>>3]=0.0;i=i;return}function bda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14512>>3]=0.0;i=i;return}function cda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14488>>3]=0.0;i=i;return}function dda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14464>>3]=1.0;i=i;return}function eda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14456>>3]=0.0;i=i;return}function fda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14448>>3]=0.0;i=i;return}function gda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14440>>3]=0.0;i=i;return}function hda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14432>>3]=0.0;i=i;return}function ida(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14424>>3]=0.0;i=i;return}function jda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14416>>3]=0.0;i=i;return}function kda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14408>>3]=0.0;i=i;return}function lda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14400>>3]=0.0;i=i;return}function mda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14392>>3]=0.0;i=i;return}function nda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14384>>3]=0.0;i=i;return}function oda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14376>>3]=0.0;i=i;return}function pda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14368>>3]=0.0;i=i;return}function qda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14360>>3]=1.0;i=i;return}function rda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14336>>3]=0.0;i=i;return}function sda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14312>>3]=0.0;i=i;return}function tda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14352>>3]=0.0;i=i;return}function uda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14328>>3]=1.0;i=i;return}function vda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14304>>3]=0.0;i=i;return}function wda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14344>>3]=0.0;i=i;return}function xda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14320>>3]=0.0;i=i;return}function yda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14296>>3]=1.0;i=i;return}function zda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14288>>3]=0.0;i=i;return}function Ada(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14280>>3]=0.0;i=i;return}function Bda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14272>>3]=0.0;i=i;return}function Cda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14264>>3]=0.0;i=i;return}function Dda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14256>>3]=0.0;i=i;return}function Eda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14248>>3]=0.0;i=i;return}function Fda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14240>>3]=0.0;i=i;return}function Gda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14232>>3]=0.0;i=i;return}function Hda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14224>>3]=0.0;i=i;return}function Ida(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14216>>3]=0.0;i=i;return}function Jda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14208>>3]=0.0;i=i;return}function Kda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14200>>3]=0.0;i=i;return}function Lda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14192>>3]=1.0;i=i;return}function Mda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14168>>3]=0.0;i=i;return}function Nda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14144>>3]=0.0;i=i;return}function Oda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14184>>3]=0.0;i=i;return}function Pda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14160>>3]=1.0;i=i;return}function Qda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14136>>3]=0.0;i=i;return}function Rda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14176>>3]=0.0;i=i;return}function Sda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14152>>3]=0.0;i=i;return}function Tda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14128>>3]=1.0;i=i;return}function Uda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14120>>3]=0.0;i=i;return}function Vda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14112>>3]=0.0;i=i;return}function Wda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14104>>3]=0.0;i=i;return}function Xda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14096>>3]=0.0;i=i;return}function Yda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14088>>3]=0.0;i=i;return}function Zda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14080>>3]=0.0;i=i;return}function _da(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14072>>3]=0.0;i=i;return}function $da(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14064>>3]=0.0;i=i;return}function aea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14056>>3]=0.0;i=i;return}function bea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14048>>3]=0.0;i=i;return}function cea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14040>>3]=0.0;i=i;return}function dea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14032>>3]=0.0;i=i;return}function eea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14024>>3]=1.0;i=i;return}function fea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14e3>>3]=0.0;i=i;return}function gea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13976>>3]=0.0;i=i;return}function hea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14016>>3]=0.0;i=i;return}function iea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13992>>3]=1.0;i=i;return}function jea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13968>>3]=0.0;i=i;return}function kea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14008>>3]=0.0;i=i;return}function lea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13984>>3]=0.0;i=i;return}function mea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13960>>3]=1.0;i=i;return}function nea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13952>>3]=0.0;i=i;return}function oea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13944>>3]=0.0;i=i;return}function pea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13936>>3]=0.0;i=i;return}function qea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13928>>3]=0.0;i=i;return}function rea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13920>>3]=0.0;i=i;return}function sea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13912>>3]=0.0;i=i;return}function tea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13904>>3]=0.0;i=i;return}function uea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13896>>3]=0.0;i=i;return}function vea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13888>>3]=0.0;i=i;return}function wea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13880>>3]=0.0;i=i;return}function xea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13872>>3]=0.0;i=i;return}function yea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13864>>3]=0.0;i=i;return}function zea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13856>>3]=1.0;i=i;return}function Aea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13832>>3]=0.0;i=i;return}function Bea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13808>>3]=0.0;i=i;return}function Cea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13848>>3]=0.0;i=i;return}function Dea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13824>>3]=1.0;i=i;return}function Eea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13800>>3]=0.0;i=i;return}function Fea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13840>>3]=0.0;i=i;return}function Gea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13816>>3]=0.0;i=i;return}function Hea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13792>>3]=1.0;i=i;return}function Iea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13784>>3]=0.0;i=i;return}function Jea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13776>>3]=0.0;i=i;return}function Kea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13768>>3]=0.0;i=i;return}function Lea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13760>>3]=0.0;i=i;return}function Mea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13752>>3]=0.0;i=i;return}function Nea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13744>>3]=0.0;i=i;return}function Oea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21472>>3]=0.0;i=i;return}function Pea(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1304>>2]=255;i=i;return}function Qea(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1300>>2]=128;i=i;return}function Rea(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1296>>2]=0;i=i;return}function Sea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13720>>3]=0.0;i=i;return}function Tea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13728>>3]=128.0;i=i;return}function Uea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13736>>3]=255.0;i=i;return}function Vea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13712>>3]=0.0;i=i;return}function Wea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13704>>3]=1.0;i=i;return}function Xea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13696>>3]=0.0;i=i;return}function Yea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13688>>3]=0.0;i=i;return}function Zea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13680>>3]=0.0;i=i;return}function _ea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13672>>3]=1.0;i=i;return}function $ea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13664>>3]=0.0;i=i;return}function afa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13656>>3]=0.0;i=i;return}function bfa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13648>>3]=+h[b+24464>>3]+ +h[b+24480>>3]*-.5+-.002;i=i;return}function cfa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1292>>2]=180;i=i;return}function dfa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1288>>2]=180;i=i;return}function efa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1284>>2]=180;i=i;return}function ffa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13624>>3]=180.0;i=i;return}function gfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13632>>3]=180.0;i=i;return}function hfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13640>>3]=180.0;i=i;return}function ifa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13616>>3]=-1.0;i=i;return}function jfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13608>>3]=0.0;i=i;return}function kfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13600>>3]=0.0;i=i;return}function lfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13592>>3]=0.0;i=i;return}function mfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13584>>3]=0.0;i=i;return}function nfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13576>>3]=1.0;i=i;return}function ofa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13568>>3]=0.0;i=i;return}function pfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13560>>3]=0.0;i=i;return}function qfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13552>>3]=0.0;i=i;return}function rfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13544>>3]=0.0;i=i;return}function sfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13536>>3]=0.0;i=i;return}function tfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13528>>3]=0.0;i=i;return}function ufa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13520>>3]=0.0;i=i;return}function vfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13512>>3]=0.0;i=i;return}function wfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13504>>3]=0.0;i=i;return}function xfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13496>>3]=1.0;i=i;return}function yfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13488>>3]=0.0;i=i;return}function zfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13480>>3]=0.0;i=i;return}function Afa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13472>>3]=0.0;i=i;return}function Bfa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1280>>2]=255;i=i;return}function Cfa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1276>>2]=128;i=i;return}function Dfa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1272>>2]=0;i=i;return}function Efa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1268>>2]=155;i=i;return}function Ffa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1264>>2]=155;i=i;return}function Gfa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1260>>2]=155;i=i;return}function Hfa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1256>>2]=155;i=i;return}function Ifa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1252>>2]=155;i=i;return}function Jfa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1248>>2]=155;i=i;return}function Kfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13448>>3]=155.0;i=i;return}function Lfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13456>>3]=155.0;i=i;return}function Mfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13464>>3]=155.0;i=i;return}function Nfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13440>>3]=-1.0;i=i;return}function Ofa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13432>>3]=0.0;i=i;return}function Pfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13424>>3]=0.0;i=i;return}function Qfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13416>>3]=0.0;i=i;return}function Rfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13408>>3]=0.0;i=i;return}function Sfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13400>>3]=1.0;i=i;return}function Tfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13392>>3]=0.0;i=i;return}function Ufa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13384>>3]=0.0;i=i;return}function Vfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13376>>3]=0.0;i=i;return}function Wfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13368>>3]=0.0;i=i;return}function Xfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13360>>3]=0.0;i=i;return}function Yfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13352>>3]=0.0;i=i;return}function Zfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13344>>3]=0.0;i=i;return}function _fa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13336>>3]=0.0;i=i;return}function $fa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13328>>3]=0.0;i=i;return}function aga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13320>>3]=1.0;i=i;return}function bga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13312>>3]=0.0;i=i;return}function cga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13304>>3]=0.0;i=i;return}function dga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13296>>3]=0.0;i=i;return}function ega(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1244>>2]=255;i=i;return}function fga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1240>>2]=128;i=i;return}function gga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1236>>2]=0;i=i;return}function hga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1232>>2]=155;i=i;return}function iga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1228>>2]=155;i=i;return}function jga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1224>>2]=155;i=i;return}function kga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21464>>3]=0.0;i=i;return}function lga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1220>>2]=155;i=i;return}function mga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1216>>2]=155;i=i;return}function nga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1212>>2]=155;i=i;return}function oga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21456>>3]=0.0;i=i;return}function pga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1208>>2]=0;i=i;return}function qga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1204>>2]=0;i=i;return}function rga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1200>>2]=255;i=i;return}function sga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1196>>2]=0;i=i;return}function tga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1192>>2]=0;i=i;return}function uga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1188>>2]=255;i=i;return}function vga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1184>>2]=0;i=i;return}function wga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1180>>2]=0;i=i;return}function xga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1176>>2]=255;i=i;return}function yga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1172>>2]=155;i=i;return}function zga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1168>>2]=155;i=i;return}function Aga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1164>>2]=155;i=i;return}function Bga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1160>>2]=155;i=i;return}function Cga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1156>>2]=155;i=i;return}function Dga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1152>>2]=155;i=i;return}function Ega(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1148>>2]=155;i=i;return}function Fga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1144>>2]=155;i=i;return}function Gga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1140>>2]=155;i=i;return}function Hga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1136>>2]=155;i=i;return}function Iga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1132>>2]=155;i=i;return}function Jga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1128>>2]=155;i=i;return}function Kga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1124>>2]=155;i=i;return}function Lga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1120>>2]=155;i=i;return}function Mga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1116>>2]=155;i=i;return}function Nga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1112>>2]=155;i=i;return}function Oga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1108>>2]=155;i=i;return}function Pga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1104>>2]=155;i=i;return}function Qga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1100>>2]=255;i=i;return}function Rga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1096>>2]=128;i=i;return}function Sga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1092>>2]=0;i=i;return}function Tga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13272>>3]=0.0;i=i;return}function Uga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13280>>3]=128.0;i=i;return}function Vga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13288>>3]=255.0;i=i;return}function Wga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13264>>3]=0.0;i=i;return}function Xga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13256>>3]=1.0;i=i;return}function Yga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13248>>3]=0.0;i=i;return}function Zga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13240>>3]=0.0;i=i;return}function _ga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13232>>3]=0.0;i=i;return}function $ga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13224>>3]=1.0;i=i;return}function aha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13216>>3]=0.0;i=i;return}function bha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13208>>3]=0.0;i=i;return}function cha(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13200>>3]=+h[b+23432>>3]+ +h[b+23448>>3]*-.5+-.002;i=i;return}function dha(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1088>>2]=180;i=i;return}function eha(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1084>>2]=180;i=i;return}function fha(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1080>>2]=180;i=i;return}function gha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13176>>3]=180.0;i=i;return}function hha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13184>>3]=180.0;i=i;return}function iha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13192>>3]=180.0;i=i;return}function jha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13168>>3]=-1.0;i=i;return}function kha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13160>>3]=0.0;i=i;return}function lha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13152>>3]=0.0;i=i;return}function mha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13144>>3]=0.0;i=i;return}function nha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13136>>3]=0.0;i=i;return}function oha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13128>>3]=1.0;i=i;return}function pha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13120>>3]=0.0;i=i;return}function qha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13112>>3]=0.0;i=i;return}function rha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13104>>3]=0.0;i=i;return}function sha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13096>>3]=0.0;i=i;return}function tha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13088>>3]=0.0;i=i;return}function uha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13080>>3]=0.0;i=i;return}function vha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13072>>3]=0.0;i=i;return}function wha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13064>>3]=0.0;i=i;return}function xha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13056>>3]=0.0;i=i;return}function yha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13048>>3]=1.0;i=i;return}function zha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13040>>3]=0.0;i=i;return}function Aha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13032>>3]=0.0;i=i;return}function Bha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13024>>3]=0.0;i=i;return}function Cha(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1076>>2]=255;i=i;return}function Dha(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1072>>2]=128;i=i;return}function Eha(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1068>>2]=0;i=i;return}function Fha(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1064>>2]=155;i=i;return}function Gha(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1060>>2]=155;i=i;return}function Hha(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1056>>2]=155;i=i;return}function Iha(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1052>>2]=155;i=i;return}function Jha(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1048>>2]=155;i=i;return}function Kha(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1044>>2]=155;i=i;return}function Lha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13e3>>3]=155.0;i=i;return}function Mha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13008>>3]=155.0;i=i;return}function Nha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13016>>3]=155.0;i=i;return}function Oha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12992>>3]=-1.0;i=i;return}function Pha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12984>>3]=0.0;i=i;return}function Qha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12976>>3]=0.0;i=i;return}function Rha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12968>>3]=0.0;i=i;return}function Sha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12960>>3]=0.0;i=i;return}function Tha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12952>>3]=1.0;i=i;return}function Uha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12944>>3]=0.0;i=i;return}function Vha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12936>>3]=0.0;i=i;return}function Wha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12928>>3]=0.0;i=i;return}function Xha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12920>>3]=0.0;i=i;return}function Yha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12912>>3]=0.0;i=i;return}function Zha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12904>>3]=0.0;i=i;return}function _ha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12896>>3]=0.0;i=i;return}function $ha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12888>>3]=0.0;i=i;return}function aia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12880>>3]=0.0;i=i;return}function bia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12872>>3]=1.0;i=i;return}function cia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12864>>3]=0.0;i=i;return}function dia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12856>>3]=0.0;i=i;return}function eia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12848>>3]=0.0;i=i;return}function fia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1040>>2]=255;i=i;return}function gia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1036>>2]=128;i=i;return}function hia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1032>>2]=0;i=i;return}function iia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1028>>2]=155;i=i;return}function jia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1024>>2]=155;i=i;return}function kia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1020>>2]=155;i=i;return}function lia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21448>>3]=0.0;i=i;return}function mia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1016>>2]=155;i=i;return}function nia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1012>>2]=155;i=i;return}function oia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1008>>2]=155;i=i;return}function pia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21440>>3]=0.0;i=i;return}function qia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1004>>2]=0;i=i;return}function ria(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1e3>>2]=0;i=i;return}function sia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+996>>2]=255;i=i;return}function tia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+992>>2]=0;i=i;return}function uia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+988>>2]=0;i=i;return}function via(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+984>>2]=255;i=i;return}function wia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+980>>2]=0;i=i;return}function xia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+976>>2]=0;i=i;return}function yia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+972>>2]=255;i=i;return}function zia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+968>>2]=155;i=i;return}function Aia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+964>>2]=155;i=i;return}function Bia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+960>>2]=155;i=i;return}function Cia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+956>>2]=155;i=i;return}function Dia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+952>>2]=155;i=i;return}function Eia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+948>>2]=155;i=i;return}function Fia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+944>>2]=155;i=i;return}function Gia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+940>>2]=155;i=i;return}function Hia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+936>>2]=155;i=i;return}function Iia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+932>>2]=155;i=i;return}function Jia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+928>>2]=155;i=i;return}function Kia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+924>>2]=155;i=i;return}function Lia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+920>>2]=155;i=i;return}function Mia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+916>>2]=155;i=i;return}function Nia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+912>>2]=155;i=i;return}function Oia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+908>>2]=155;i=i;return}function Pia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+904>>2]=155;i=i;return}function Qia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+900>>2]=155;i=i;return}function Ria(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+896>>2]=255;i=i;return}function Sia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+892>>2]=128;i=i;return}function Tia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+888>>2]=0;i=i;return}function Uia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12824>>3]=0.0;i=i;return}function Via(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12832>>3]=128.0;i=i;return}function Wia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12840>>3]=255.0;i=i;return}function Xia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12816>>3]=0.0;i=i;return}function Yia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12808>>3]=1.0;i=i;return}function Zia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12800>>3]=0.0;i=i;return}function _ia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12792>>3]=0.0;i=i;return}function $ia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12784>>3]=0.0;i=i;return}function aja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12776>>3]=1.0;i=i;return}function bja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12768>>3]=0.0;i=i;return}function cja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12760>>3]=0.0;i=i;return}function dja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12752>>3]=+h[b+22400>>3]+ +h[b+22416>>3]*-.5+-.002;i=i;return}function eja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+884>>2]=180;i=i;return}function fja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+880>>2]=180;i=i;return}function gja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+876>>2]=180;i=i;return}function hja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12728>>3]=180.0;i=i;return}function ija(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12736>>3]=180.0;i=i;return}function jja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12744>>3]=180.0;i=i;return}function kja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12720>>3]=-1.0;i=i;return}function lja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12712>>3]=0.0;i=i;return}function mja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12704>>3]=0.0;i=i;return}function nja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12696>>3]=0.0;i=i;return}function oja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12688>>3]=0.0;i=i;return}function pja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12680>>3]=1.0;i=i;return}function qja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12672>>3]=0.0;i=i;return}function rja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12664>>3]=0.0;i=i;return}function sja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12656>>3]=0.0;i=i;return}function tja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12648>>3]=0.0;i=i;return}function uja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12640>>3]=0.0;i=i;return}function vja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12632>>3]=0.0;i=i;return}function wja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12624>>3]=0.0;i=i;return}function xja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12616>>3]=0.0;i=i;return}function yja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12608>>3]=0.0;i=i;return}function zja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12600>>3]=1.0;i=i;return}function Aja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12592>>3]=0.0;i=i;return}function Bja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12584>>3]=0.0;i=i;return}function Cja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12576>>3]=0.0;i=i;return}function Dja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+872>>2]=255;i=i;return}function Eja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+868>>2]=128;i=i;return}function Fja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+864>>2]=0;i=i;return}function Gja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+860>>2]=155;i=i;return}function Hja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+856>>2]=155;i=i;return}function Ija(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+852>>2]=155;i=i;return}function Jja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+848>>2]=155;i=i;return}function Kja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+844>>2]=155;i=i;return}function Lja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+840>>2]=155;i=i;return}function Mja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12552>>3]=155.0;i=i;return}function Nja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12560>>3]=155.0;i=i;return}function Oja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12568>>3]=155.0;i=i;return}function Pja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12544>>3]=-1.0;i=i;return}function Qja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12536>>3]=0.0;i=i;return}function Rja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12528>>3]=0.0;i=i;return}function Sja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12520>>3]=0.0;i=i;return}function Tja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12512>>3]=0.0;i=i;return}function Uja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12504>>3]=1.0;i=i;return}function Vja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12496>>3]=0.0;i=i;return}function Wja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12488>>3]=0.0;i=i;return}function Xja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12480>>3]=0.0;i=i;return}function Yja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12472>>3]=0.0;i=i;return}function Zja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12464>>3]=0.0;i=i;return}function _ja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12456>>3]=0.0;i=i;return}function $ja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12448>>3]=0.0;i=i;return}function aka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12440>>3]=0.0;i=i;return}function bka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12432>>3]=0.0;i=i;return}function cka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12424>>3]=1.0;i=i;return}function dka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12416>>3]=0.0;i=i;return}function eka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12408>>3]=0.0;i=i;return}function fka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12400>>3]=0.0;i=i;return}function gka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+836>>2]=255;i=i;return}function hka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+832>>2]=128;i=i;return}function ika(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+828>>2]=0;i=i;return}function jka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+824>>2]=155;i=i;return}function kka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+820>>2]=155;i=i;return}function lka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+816>>2]=155;i=i;return}function mka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21432>>3]=0.0;i=i;return}function nka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+812>>2]=155;i=i;return}function oka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+808>>2]=155;i=i;return}function pka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+804>>2]=155;i=i;return}function qka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21424>>3]=0.0;i=i;return}function rka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+800>>2]=0;i=i;return}function ska(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+796>>2]=0;i=i;return}function tka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+792>>2]=255;i=i;return}function uka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+788>>2]=0;i=i;return}function vka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+784>>2]=0;i=i;return}function wka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+780>>2]=255;i=i;return}function xka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+776>>2]=0;i=i;return}function yka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+772>>2]=0;i=i;return}function zka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+768>>2]=255;i=i;return}function Aka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+764>>2]=155;i=i;return}function Bka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+760>>2]=155;i=i;return}function Cka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+756>>2]=155;i=i;return}function Dka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+752>>2]=155;i=i;return}function Eka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+748>>2]=155;i=i;return}function Fka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+744>>2]=155;i=i;return}function Gka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+740>>2]=155;i=i;return}function Hka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+736>>2]=155;i=i;return}function Ika(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+732>>2]=155;i=i;return}function Jka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+728>>2]=155;i=i;return}function Kka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+724>>2]=155;i=i;return}function Lka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+720>>2]=155;i=i;return}function Mka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+716>>2]=155;i=i;return}function Nka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+712>>2]=155;i=i;return}function Oka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+708>>2]=155;i=i;return}function Pka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+704>>2]=155;i=i;return}function Qka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+700>>2]=155;i=i;return}function Rka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+696>>2]=155;i=i;return}function Ska(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+692>>2]=255;i=i;return}function Tka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+688>>2]=128;i=i;return}function Uka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+684>>2]=0;i=i;return}function Vka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12376>>3]=0.0;i=i;return}function Wka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12384>>3]=128.0;i=i;return}function Xka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12392>>3]=255.0;i=i;return}function Yka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12368>>3]=0.0;i=i;return}function Zka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12360>>3]=1.0;i=i;return}function _ka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12352>>3]=0.0;i=i;return}function $ka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12344>>3]=0.0;i=i;return}function ala(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12336>>3]=0.0;i=i;return}function bla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12328>>3]=1.0;i=i;return}function cla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12320>>3]=0.0;i=i;return}function dla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12312>>3]=0.0;i=i;return}function ela(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12304>>3]=+h[b+21368>>3]+ +h[b+21384>>3]*-.5+-.002;i=i;return}function fla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+680>>2]=180;i=i;return}function gla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+676>>2]=180;i=i;return}function hla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+672>>2]=180;i=i;return}function ila(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12280>>3]=180.0;i=i;return}function jla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12288>>3]=180.0;i=i;return}function kla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12296>>3]=180.0;i=i;return}function lla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12272>>3]=-1.0;i=i;return}function mla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12264>>3]=0.0;i=i;return}function nla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12256>>3]=0.0;i=i;return}function ola(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12248>>3]=0.0;i=i;return}function pla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12240>>3]=0.0;i=i;return}function qla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12232>>3]=1.0;i=i;return}function rla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12224>>3]=0.0;i=i;return}function sla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12216>>3]=0.0;i=i;return}function tla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12208>>3]=0.0;i=i;return}function ula(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12200>>3]=0.0;i=i;return}function vla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12192>>3]=0.0;i=i;return}function wla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12184>>3]=0.0;i=i;return}function xla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12176>>3]=0.0;i=i;return}function yla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12168>>3]=0.0;i=i;return}function zla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12160>>3]=0.0;i=i;return}function Ala(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12152>>3]=1.0;i=i;return}function Bla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12144>>3]=0.0;i=i;return}function Cla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12136>>3]=0.0;i=i;return}function Dla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12128>>3]=0.0;i=i;return}function Ela(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+668>>2]=255;i=i;return}function Fla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+664>>2]=128;i=i;return}function Gla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+660>>2]=0;i=i;return}function Hla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+656>>2]=155;i=i;return}function Ila(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+652>>2]=155;i=i;return}function Jla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+648>>2]=155;i=i;return}function Kla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+644>>2]=155;i=i;return}function Lla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+640>>2]=155;i=i;return}function Mla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+636>>2]=155;i=i;return}function Nla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12104>>3]=155.0;i=i;return}function Ola(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12112>>3]=155.0;i=i;return}function Pla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12120>>3]=155.0;i=i;return}function Qla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12096>>3]=-1.0;i=i;return}function Rla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12088>>3]=0.0;i=i;return}function Sla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12080>>3]=0.0;i=i;return}function Tla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12072>>3]=0.0;i=i;return}function Ula(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12064>>3]=0.0;i=i;return}function Vla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12056>>3]=1.0;i=i;return}function Wla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12048>>3]=0.0;i=i;return}function Xla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12040>>3]=0.0;i=i;return}function Yla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12032>>3]=0.0;i=i;return}function Zla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12024>>3]=0.0;i=i;return}function _la(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12016>>3]=0.0;i=i;return}function $la(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12008>>3]=0.0;i=i;return}function ama(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12e3>>3]=0.0;i=i;return}function bma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11992>>3]=0.0;i=i;return}function cma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11984>>3]=0.0;i=i;return}function dma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11976>>3]=1.0;i=i;return}function ema(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11968>>3]=0.0;i=i;return}function fma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11960>>3]=0.0;i=i;return}function gma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11952>>3]=0.0;i=i;return}function hma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+632>>2]=255;i=i;return}function ima(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+628>>2]=128;i=i;return}function jma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+624>>2]=0;i=i;return}function kma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+620>>2]=155;i=i;return}function lma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+616>>2]=155;i=i;return}function mma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+612>>2]=155;i=i;return}function nma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21416>>3]=0.0;i=i;return}function oma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+608>>2]=155;i=i;return}function pma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+604>>2]=155;i=i;return}function qma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+600>>2]=155;i=i;return}function rma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21408>>3]=0.0;i=i;return}function sma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+596>>2]=0;i=i;return}function tma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+592>>2]=0;i=i;return}function uma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+588>>2]=255;i=i;return}function vma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+584>>2]=0;i=i;return}function wma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+580>>2]=0;i=i;return}function xma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+576>>2]=255;i=i;return}function yma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+572>>2]=0;i=i;return}function zma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+568>>2]=0;i=i;return}function Ama(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+564>>2]=255;i=i;return}function Bma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+560>>2]=155;i=i;return}function Cma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+556>>2]=155;i=i;return}function Dma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+552>>2]=155;i=i;return}function Ema(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+548>>2]=155;i=i;return}function Fma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+544>>2]=155;i=i;return}function Gma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+540>>2]=155;i=i;return}function Hma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+536>>2]=155;i=i;return}function Ima(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+532>>2]=155;i=i;return}function Jma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+528>>2]=155;i=i;return}function Kma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+524>>2]=155;i=i;return}function Lma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+520>>2]=155;i=i;return}function Mma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+516>>2]=155;i=i;return}function Nma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+512>>2]=155;i=i;return}function Oma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+508>>2]=155;i=i;return}function Pma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+504>>2]=155;i=i;return}function Qma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+500>>2]=155;i=i;return}function Rma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+496>>2]=155;i=i;return}function Sma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+492>>2]=155;i=i;return}function Tma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+488>>2]=255;i=i;return}function Uma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+484>>2]=128;i=i;return}function Vma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+480>>2]=0;i=i;return}function Wma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11928>>3]=0.0;i=i;return}function Xma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11936>>3]=128.0;i=i;return}function Yma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11944>>3]=255.0;i=i;return}function Zma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11920>>3]=0.0;i=i;return}function _ma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11912>>3]=1.0;i=i;return}function $ma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11904>>3]=0.0;i=i;return}function ana(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11896>>3]=0.0;i=i;return}function bna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11888>>3]=0.0;i=i;return}function cna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11880>>3]=1.0;i=i;return}function dna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11872>>3]=0.0;i=i;return}function ena(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11864>>3]=0.0;i=i;return}function fna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11856>>3]=+h[b+20336>>3]+ +h[b+20352>>3]*-.5+-.002;i=i;return}function gna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+476>>2]=180;i=i;return}function hna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+472>>2]=180;i=i;return}function ina(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+468>>2]=180;i=i;return}function jna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11832>>3]=180.0;i=i;return}function kna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11840>>3]=180.0;i=i;return}function lna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11848>>3]=180.0;i=i;return}function mna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11824>>3]=-1.0;i=i;return}function nna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11816>>3]=0.0;i=i;return}function ona(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11808>>3]=0.0;i=i;return}function pna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11800>>3]=0.0;i=i;return}function qna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11792>>3]=0.0;i=i;return}function rna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11784>>3]=1.0;i=i;return}function sna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11776>>3]=0.0;i=i;return}function tna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11768>>3]=0.0;i=i;return}function una(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11760>>3]=0.0;i=i;return}function vna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11752>>3]=0.0;i=i;return}function wna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11744>>3]=0.0;i=i;return}function xna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11736>>3]=0.0;i=i;return}function yna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11728>>3]=0.0;i=i;return}function zna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11720>>3]=0.0;i=i;return}function Ana(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11712>>3]=0.0;i=i;return}function Bna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11704>>3]=1.0;i=i;return}function Cna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11696>>3]=0.0;i=i;return}function Dna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11688>>3]=0.0;i=i;return}function Ena(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11680>>3]=0.0;i=i;return}function Fna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+464>>2]=255;i=i;return}function Gna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+460>>2]=128;i=i;return}function Hna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+456>>2]=0;i=i;return}function Ina(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+452>>2]=155;i=i;return}function Jna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+448>>2]=155;i=i;return}function Kna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+444>>2]=155;i=i;return}function Lna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+440>>2]=155;i=i;return}function Mna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+436>>2]=155;i=i;return}function Nna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+432>>2]=155;i=i;return}function Ona(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11656>>3]=155.0;i=i;return}function Pna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11664>>3]=155.0;i=i;return}function Qna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11672>>3]=155.0;i=i;return}function Rna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11648>>3]=-1.0;i=i;return}function Sna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11640>>3]=0.0;i=i;return}function Tna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11632>>3]=0.0;i=i;return}function Una(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11624>>3]=0.0;i=i;return}function Vna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11616>>3]=0.0;i=i;return}function Wna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11608>>3]=1.0;i=i;return}function Xna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11600>>3]=0.0;i=i;return}function Yna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11592>>3]=0.0;i=i;return}function Zna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11584>>3]=0.0;i=i;return}function _na(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11576>>3]=0.0;i=i;return}function $na(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11568>>3]=0.0;i=i;return}function aoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11560>>3]=0.0;i=i;return}function boa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11552>>3]=0.0;i=i;return}function coa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11544>>3]=0.0;i=i;return}function doa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11536>>3]=0.0;i=i;return}function eoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11528>>3]=1.0;i=i;return}function foa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11520>>3]=0.0;i=i;return}function goa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11512>>3]=0.0;i=i;return}function hoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11504>>3]=0.0;i=i;return}function ioa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+428>>2]=255;i=i;return}function joa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+424>>2]=128;i=i;return}function koa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+420>>2]=0;i=i;return}function loa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+416>>2]=155;i=i;return}function moa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+412>>2]=155;i=i;return}function noa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+408>>2]=155;i=i;return}function ooa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21400>>3]=0.0;i=i;return}function poa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+404>>2]=155;i=i;return}function qoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+400>>2]=155;i=i;return}function roa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+396>>2]=155;i=i;return}function soa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21392>>3]=0.0;i=i;return}function toa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+392>>2]=0;i=i;return}function uoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+388>>2]=0;i=i;return}function voa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+384>>2]=255;i=i;return}function woa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+380>>2]=0;i=i;return}function xoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+376>>2]=0;i=i;return}function yoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+372>>2]=255;i=i;return}function zoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+368>>2]=0;i=i;return}function Aoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+364>>2]=0;i=i;return}function Boa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+360>>2]=255;i=i;return}function Coa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+356>>2]=155;i=i;return}function Doa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+352>>2]=155;i=i;return}function Eoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+348>>2]=155;i=i;return}function Foa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+344>>2]=155;i=i;return}function Goa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+340>>2]=155;i=i;return}function Hoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+336>>2]=155;i=i;return}function Ioa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+332>>2]=155;i=i;return}function Joa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+328>>2]=155;i=i;return}function Koa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+324>>2]=155;i=i;return}function Loa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+320>>2]=155;i=i;return}function Moa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+316>>2]=155;i=i;return}function Noa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+312>>2]=155;i=i;return}function Ooa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+308>>2]=155;i=i;return}function Poa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+304>>2]=155;i=i;return}function Qoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+300>>2]=155;i=i;return}function Roa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+296>>2]=155;i=i;return}function Soa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+292>>2]=155;i=i;return}function Toa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+288>>2]=155;i=i;return}function Uoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+284>>2]=255;i=i;return}function Voa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+280>>2]=128;i=i;return}function Woa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+276>>2]=0;i=i;return}function Xoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11480>>3]=0.0;i=i;return}function Yoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11488>>3]=128.0;i=i;return}function Zoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11496>>3]=255.0;i=i;return}function _oa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11472>>3]=0.0;i=i;return}function $oa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11464>>3]=1.0;i=i;return}function apa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11456>>3]=0.0;i=i;return}function bpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11448>>3]=0.0;i=i;return}function cpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11440>>3]=0.0;i=i;return}function dpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11432>>3]=1.0;i=i;return}function epa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11424>>3]=0.0;i=i;return}function fpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11416>>3]=0.0;i=i;return}function gpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11408>>3]=+h[b+19304>>3]+ +h[b+19320>>3]*-.5+-.002;i=i;return}function hpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+272>>2]=180;i=i;return}function ipa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+268>>2]=180;i=i;return}function jpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+264>>2]=180;i=i;return}function kpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11384>>3]=180.0;i=i;return}function lpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11392>>3]=180.0;i=i;return}function mpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11400>>3]=180.0;i=i;return}function npa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11376>>3]=-1.0;i=i;return}function opa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11368>>3]=0.0;i=i;return}function ppa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11360>>3]=0.0;i=i;return}function qpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11352>>3]=0.0;i=i;return}function rpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11344>>3]=0.0;i=i;return}function spa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11336>>3]=1.0;i=i;return}function tpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11328>>3]=0.0;i=i;return}function upa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11320>>3]=0.0;i=i;return}function vpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11312>>3]=0.0;i=i;return}function wpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11304>>3]=0.0;i=i;return}function xpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11296>>3]=0.0;i=i;return}function ypa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11288>>3]=0.0;i=i;return}function zpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11280>>3]=0.0;i=i;return}function Apa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11272>>3]=0.0;i=i;return}function Bpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11264>>3]=0.0;i=i;return}function Cpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11256>>3]=1.0;i=i;return}function Dpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11248>>3]=0.0;i=i;return}function Epa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11240>>3]=0.0;i=i;return}function Fpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11232>>3]=0.0;i=i;return}function Gpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+260>>2]=255;i=i;return}function Hpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+256>>2]=128;i=i;return}function Ipa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+252>>2]=0;i=i;return}function Jpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+248>>2]=155;i=i;return}function Kpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+244>>2]=155;i=i;return}function Lpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+240>>2]=155;i=i;return}function Mpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+236>>2]=155;i=i;return}function Npa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+232>>2]=155;i=i;return}function Opa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+228>>2]=155;i=i;return}function Ppa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11208>>3]=155.0;i=i;return}function Qpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11216>>3]=155.0;i=i;return}function Rpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11224>>3]=155.0;i=i;return}function Spa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11200>>3]=-1.0;i=i;return}function Tpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11192>>3]=0.0;i=i;return}function Upa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11184>>3]=0.0;i=i;return}function Vpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11176>>3]=0.0;i=i;return}function Wpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11168>>3]=0.0;i=i;return}function Xpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11160>>3]=1.0;i=i;return}function Ypa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11152>>3]=0.0;i=i;return}function Zpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11144>>3]=0.0;i=i;return}function _pa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11136>>3]=0.0;i=i;return}function $pa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11128>>3]=0.0;i=i;return}function aqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11120>>3]=0.0;i=i;return}function bqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11112>>3]=0.0;i=i;return}function cqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11104>>3]=0.0;i=i;return}function dqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11096>>3]=0.0;i=i;return}function eqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11088>>3]=0.0;i=i;return}function fqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11080>>3]=1.0;i=i;return}function gqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11072>>3]=0.0;i=i;return}function hqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11064>>3]=0.0;i=i;return}function iqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11056>>3]=0.0;i=i;return}function jqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+224>>2]=255;i=i;return}function kqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+220>>2]=128;i=i;return}function lqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+216>>2]=0;i=i;return}function mqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+212>>2]=155;i=i;return}function nqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+208>>2]=155;i=i;return}function oqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+204>>2]=155;i=i;return}function pqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21384>>3]=0.0;i=i;return}function qqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+200>>2]=155;i=i;return}function rqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+196>>2]=155;i=i;return}function sqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+192>>2]=155;i=i;return}function tqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21376>>3]=0.0;i=i;return}function uqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+188>>2]=0;i=i;return}function vqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+184>>2]=0;i=i;return}function wqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+180>>2]=255;i=i;return}function xqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+176>>2]=0;i=i;return}function yqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+172>>2]=0;i=i;return}function zqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+168>>2]=255;i=i;return}function Aqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+164>>2]=0;i=i;return}function Bqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+160>>2]=0;i=i;return}function Cqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+156>>2]=255;i=i;return}function Dqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+152>>2]=155;i=i;return}function Eqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+148>>2]=155;i=i;return}function Fqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+144>>2]=155;i=i;return}function Gqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+140>>2]=155;i=i;return}function Hqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+136>>2]=155;i=i;return}function Iqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+132>>2]=155;i=i;return}function Jqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+128>>2]=155;i=i;return}function Kqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+124>>2]=155;i=i;return}function Lqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+120>>2]=155;i=i;return}function Mqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+116>>2]=155;i=i;return}function Nqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+112>>2]=155;i=i;return}function Oqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+108>>2]=155;i=i;return}function Pqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+104>>2]=155;i=i;return}function Qqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+100>>2]=155;i=i;return}function Rqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+96>>2]=155;i=i;return}function Sqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+92>>2]=155;i=i;return}function Tqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+88>>2]=155;i=i;return}function Uqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+84>>2]=155;i=i;return}function Vqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11048>>3]=0.0;i=i;return}function Wqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11040>>3]=0.0;i=i;return}function Xqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11032>>3]=0.0;i=i;return}function Yqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11024>>3]=0.0;i=i;return}function Zqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11016>>3]=0.0;i=i;return}function _qa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11008>>3]=0.0;i=i;return}function $qa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11e3>>3]=0.0;i=i;return}function ara(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10992>>3]=0.0;i=i;return}function bra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10984>>3]=0.0;i=i;return}function cra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10976>>3]=1.0;i=i;return}function dra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10968>>3]=0.0;i=i;return}function era(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10960>>3]=0.0;i=i;return}function fra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10952>>3]=0.0;i=i;return}function gra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+80>>2]=255;i=i;return}function hra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+76>>2]=128;i=i;return}function ira(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+72>>2]=0;i=i;return}function jra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+68>>2]=255;i=i;return}function kra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+64>>2]=128;i=i;return}function lra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+60>>2]=0;i=i;return}function mra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+56>>2]=155;i=i;return}function nra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+52>>2]=155;i=i;return}function ora(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+48>>2]=155;i=i;return}function pra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+44>>2]=0;i=i;return}function qra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+40>>2]=0;i=i;return}function rra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+36>>2]=255;i=i;return}function sra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10928>>3]=255.0;i=i;return}function tra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10936>>3]=0.0;i=i;return}function ura(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10944>>3]=0.0;i=i;return}function vra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10920>>3]=0.0;i=i;return}function wra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10912>>3]=1.0;i=i;return}function xra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10904>>3]=0.0;i=i;return}function yra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10896>>3]=0.0;i=i;return}function zra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10888>>3]=0.0;i=i;return}function Ara(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10880>>3]=1.0;i=i;return}function Bra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10872>>3]=0.0;i=i;return}function Cra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10864>>3]=0.0;i=i;return}function Dra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10856>>3]=+h[(c[a+416>>2]|0)+19080>>3]*-.5;i=i;return}function Era(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+32>>2]=0;i=i;return}function Fra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+28>>2]=0;i=i;return}function Gra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+24>>2]=0;i=i;return}function Hra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+20>>2]=0;i=i;return}function Ira(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+16>>2]=230;i=i;return}function Jra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+12>>2]=0;i=i;return}function Kra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+8>>2]=0;i=i;return}function Lra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+4>>2]=230;i=i;return}function Mra(a){a=a|0;c[c[(c[c[a+4>>2]>>2]|0)+12>>2]>>2]=0;i=i;return}function Nra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21368>>3]=1.0;i=i;return}function Ora(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21360>>3]=+h[(c[a+416>>2]|0)+24472>>3]*2.0;i=i;return}function Pra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21352>>3]=+h[(c[a+416>>2]|0)+24472>>3]*2.0;i=i;return}function Qra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21344>>3]=+h[(c[a+416>>2]|0)+24472>>3]*2.0;i=i;return}function Rra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21336>>3]=1.0;i=i;return}function Sra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21328>>3]=+h[(c[a+416>>2]|0)+23440>>3]*2.0;i=i;return}function Tra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21320>>3]=+h[(c[a+416>>2]|0)+23440>>3]*2.0;i=i;return}function Ura(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21312>>3]=+h[(c[a+416>>2]|0)+23440>>3]*2.0;i=i;return}function Vra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21304>>3]=1.0;i=i;return}function Wra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21296>>3]=+h[(c[a+416>>2]|0)+22408>>3]*2.0;i=i;return}function Xra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21288>>3]=+h[(c[a+416>>2]|0)+22408>>3]*2.0;i=i;return}function Yra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21280>>3]=+h[(c[a+416>>2]|0)+22408>>3]*2.0;i=i;return}function Zra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21272>>3]=1.0;i=i;return}function _ra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21264>>3]=+h[(c[a+416>>2]|0)+21376>>3]*2.0;i=i;return}function $ra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21256>>3]=+h[(c[a+416>>2]|0)+21376>>3]*2.0;i=i;return}function asa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21248>>3]=+h[(c[a+416>>2]|0)+21376>>3]*2.0;i=i;return}function bsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21240>>3]=1.0;i=i;return}function csa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21232>>3]=+h[(c[a+416>>2]|0)+20344>>3]*2.0;i=i;return}function dsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21224>>3]=+h[(c[a+416>>2]|0)+20344>>3]*2.0;i=i;return}function esa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21216>>3]=+h[(c[a+416>>2]|0)+20344>>3]*2.0;i=i;return}function fsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21208>>3]=1.0;i=i;return}function gsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21200>>3]=+h[(c[a+416>>2]|0)+19312>>3]*2.0;i=i;return}function hsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21192>>3]=+h[(c[a+416>>2]|0)+19312>>3]*2.0;i=i;return}function isa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21184>>3]=+h[(c[a+416>>2]|0)+19312>>3]*2.0;i=i;return}function jsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21176>>3]=0.0;i=i;return}function ksa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9648>>3]=0.0;i=i;return}function lsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9640>>3]=0.0;i=i;return}function msa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9616>>3]=0.0;i=i;return}function nsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9608>>3]=0.0;i=i;return}function osa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9600>>3]=0.0;i=i;return}function psa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9592>>3]=0.0;i=i;return}function qsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9568>>3]=0.0;i=i;return}function rsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9560>>3]=0.0;i=i;return}function ssa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9552>>3]=0.0;i=i;return}function tsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9544>>3]=0.0;i=i;return}function usa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9520>>3]=0.0;i=i;return}function vsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9512>>3]=0.0;i=i;return}function wsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9504>>3]=0.0;i=i;return}function xsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9480>>3]=0.0;i=i;return}function ysa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9472>>3]=0.0;i=i;return}function zsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9464>>3]=0.0;i=i;return}function Asa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9440>>3]=0.0;i=i;return}function Bsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9432>>3]=0.0;i=i;return}function Csa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9408>>3]=0.0;i=i;return}function Dsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9384>>3]=0.0;i=i;return}function Esa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9360>>3]=0.0;i=i;return}function Fsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9352>>3]=0.0;i=i;return}function Gsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9344>>3]=0.0;i=i;return}function Hsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9336>>3]=0.0;i=i;return}function Isa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9312>>3]=0.0;i=i;return}function Jsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9304>>3]=0.0;i=i;return}function Ksa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9296>>3]=0.0;i=i;return}function Lsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9288>>3]=0.0;i=i;return}function Msa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9280>>3]=0.0;i=i;return}function Nsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9272>>3]=0.0;i=i;return}function Osa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9264>>3]=0.0;i=i;return}function Psa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9240>>3]=0.0;i=i;return}function Qsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9232>>3]=0.0;i=i;return}function Rsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9224>>3]=0.0;i=i;return}function Ssa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9200>>3]=0.0;i=i;return}function Tsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9192>>3]=0.0;i=i;return}function Usa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9184>>3]=0.0;i=i;return}function Vsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9160>>3]=0.0;i=i;return}function Wsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9152>>3]=0.0;i=i;return}function Xsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9128>>3]=0.0;i=i;return}function Ysa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9104>>3]=0.0;i=i;return}function Zsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9080>>3]=0.0;i=i;return}function _sa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9072>>3]=0.0;i=i;return}function $sa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9064>>3]=0.0;i=i;return}function ata(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9056>>3]=0.0;i=i;return}function bta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9032>>3]=0.0;i=i;return}function cta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9024>>3]=0.0;i=i;return}function dta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9016>>3]=0.0;i=i;return}function eta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9008>>3]=0.0;i=i;return}function fta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9e3>>3]=0.0;i=i;return}function gta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8992>>3]=0.0;i=i;return}function hta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8984>>3]=0.0;i=i;return}function ita(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8960>>3]=0.0;i=i;return}function jta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8952>>3]=0.0;i=i;return}function kta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8944>>3]=0.0;i=i;return}function lta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8920>>3]=0.0;i=i;return}function mta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8912>>3]=0.0;i=i;return}function nta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8904>>3]=0.0;i=i;return}function ota(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8880>>3]=0.0;i=i;return}function pta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8872>>3]=0.0;i=i;return}function qta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8848>>3]=0.0;i=i;return}function rta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8824>>3]=0.0;i=i;return}function sta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8800>>3]=0.0;i=i;return}function tta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8792>>3]=0.0;i=i;return}function uta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8784>>3]=0.0;i=i;return}function vta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8776>>3]=0.0;i=i;return}function wta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8752>>3]=0.0;i=i;return}function xta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8744>>3]=0.0;i=i;return}function yta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8736>>3]=0.0;i=i;return}function zta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8728>>3]=0.0;i=i;return}function Ata(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8720>>3]=0.0;i=i;return}function Bta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8712>>3]=0.0;i=i;return}function Cta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8704>>3]=0.0;i=i;return}function Dta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8680>>3]=0.0;i=i;return}function Eta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8672>>3]=0.0;i=i;return}function Fta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8664>>3]=0.0;i=i;return}function Gta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8640>>3]=0.0;i=i;return}function Hta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8632>>3]=0.0;i=i;return}function Ita(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8624>>3]=0.0;i=i;return}function Jta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8600>>3]=0.0;i=i;return}function Kta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8592>>3]=0.0;i=i;return}function Lta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8568>>3]=0.0;i=i;return}function Mta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8544>>3]=0.0;i=i;return}function Nta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8520>>3]=0.0;i=i;return}function Ota(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8512>>3]=0.0;i=i;return}function Pta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8504>>3]=0.0;i=i;return}function Qta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8496>>3]=0.0;i=i;return}function Rta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8472>>3]=0.0;i=i;return}function Sta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8464>>3]=0.0;i=i;return}function Tta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8456>>3]=0.0;i=i;return}function Uta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8448>>3]=0.0;i=i;return}function Vta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8440>>3]=0.0;i=i;return}function Wta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8432>>3]=0.0;i=i;return}function Xta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8424>>3]=0.0;i=i;return}function Yta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8400>>3]=0.0;i=i;return}function Zta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8392>>3]=0.0;i=i;return}function _ta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8384>>3]=0.0;i=i;return}function $ta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8360>>3]=0.0;i=i;return}function aua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8352>>3]=0.0;i=i;return}function bua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8344>>3]=0.0;i=i;return}function cua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8320>>3]=0.0;i=i;return}function dua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8312>>3]=0.0;i=i;return}function eua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8288>>3]=0.0;i=i;return}function fua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8264>>3]=0.0;i=i;return}function gua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8240>>3]=0.0;i=i;return}function hua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8232>>3]=0.0;i=i;return}function iua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8224>>3]=0.0;i=i;return}function jua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8216>>3]=0.0;i=i;return}function kua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8208>>3]=0.0;i=i;return}function lua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8200>>3]=0.0;i=i;return}function mua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8192>>3]=0.0;i=i;return}function nua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8168>>3]=0.0;i=i;return}function oua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8160>>3]=0.0;i=i;return}function pua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8152>>3]=0.0;i=i;return}function qua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8128>>3]=0.0;i=i;return}function rua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8120>>3]=0.0;i=i;return}function sua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8112>>3]=0.0;i=i;return}function tua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8088>>3]=0.0;i=i;return}function uua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8080>>3]=0.0;i=i;return}function vua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8056>>3]=0.0;i=i;return}function wua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8032>>3]=0.0;i=i;return}function xua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8008>>3]=0.0;i=i;return}function yua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8e3>>3]=0.0;i=i;return}function zua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7992>>3]=0.0;i=i;return}function Aua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7968>>3]=0.0;i=i;return}function Bua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7896>>3]=0.0;i=i;return}function Cua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7872>>3]=0.0;i=i;return}function Dua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7864>>3]=0.0;i=i;return}function Eua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7840>>3]=0.0;i=i;return}function Fua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7856>>3]=0.0;i=i;return}function Gua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7832>>3]=0.0;i=i;return}function Hua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7848>>3]=0.0;i=i;return}function Iua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7824>>3]=0.0;i=i;return}function Jua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7768>>3]=0.0;i=i;return}function Kua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7760>>3]=0.0;i=i;return}function Lua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7736>>3]=0.0;i=i;return}function Mua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7664>>3]=0.0;i=i;return}function Nua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7640>>3]=0.0;i=i;return}function Oua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7632>>3]=0.0;i=i;return}function Pua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7608>>3]=0.0;i=i;return}function Qua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7624>>3]=0.0;i=i;return}function Rua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7600>>3]=0.0;i=i;return}function Sua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7616>>3]=0.0;i=i;return}function Tua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7592>>3]=0.0;i=i;return}function Uua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7584>>3]=0.0;i=i;return}function Vua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7576>>3]=0.0;i=i;return}function Wua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7552>>3]=0.0;i=i;return}function Xua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7480>>3]=0.0;i=i;return}function Yua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7456>>3]=0.0;i=i;return}function Zua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7448>>3]=0.0;i=i;return}function _ua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7424>>3]=0.0;i=i;return}function $ua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7440>>3]=0.0;i=i;return}function ava(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7416>>3]=0.0;i=i;return}function bva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7432>>3]=0.0;i=i;return}function cva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7408>>3]=0.0;i=i;return}function dva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7400>>3]=0.0;i=i;return}function eva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7392>>3]=0.0;i=i;return}function fva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7368>>3]=0.0;i=i;return}function gva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7296>>3]=0.0;i=i;return}function hva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7272>>3]=0.0;i=i;return}function iva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7264>>3]=0.0;i=i;return}function jva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7240>>3]=0.0;i=i;return}function kva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7256>>3]=0.0;i=i;return}function lva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7232>>3]=0.0;i=i;return}function mva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7248>>3]=0.0;i=i;return}function nva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7224>>3]=0.0;i=i;return}function ova(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7216>>3]=0.0;i=i;return}function pva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7208>>3]=0.0;i=i;return}function qva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7184>>3]=0.0;i=i;return}function rva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7112>>3]=0.0;i=i;return}function sva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7088>>3]=0.0;i=i;return}function tva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7080>>3]=0.0;i=i;return}



function MBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7264>>3]=0.0;i=i;return}function NBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7272>>3]=0.0;i=i;return}function OBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7296>>3]=0.0;i=i;return}function PBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7368>>3]=0.0;i=i;return}function QBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7392>>3]=0.0;i=i;return}function RBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7400>>3]=0.0;i=i;return}function SBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7408>>3]=0.0;i=i;return}function TBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7432>>3]=0.0;i=i;return}function UBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7416>>3]=0.0;i=i;return}function VBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7440>>3]=0.0;i=i;return}function WBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7424>>3]=0.0;i=i;return}function XBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7448>>3]=0.0;i=i;return}function YBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7456>>3]=0.0;i=i;return}function ZBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7480>>3]=0.0;i=i;return}function _Ba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7552>>3]=0.0;i=i;return}function $Ba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7576>>3]=0.0;i=i;return}function aCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7584>>3]=0.0;i=i;return}function bCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7592>>3]=0.0;i=i;return}function cCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7616>>3]=0.0;i=i;return}function dCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7600>>3]=0.0;i=i;return}function eCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7624>>3]=0.0;i=i;return}function fCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7608>>3]=0.0;i=i;return}function gCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7632>>3]=0.0;i=i;return}function hCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7640>>3]=0.0;i=i;return}function iCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7664>>3]=0.0;i=i;return}function jCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7736>>3]=0.0;i=i;return}function kCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7760>>3]=0.0;i=i;return}function lCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7768>>3]=0.0;i=i;return}function mCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7824>>3]=0.0;i=i;return}function nCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7848>>3]=0.0;i=i;return}function oCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7832>>3]=0.0;i=i;return}function pCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7856>>3]=0.0;i=i;return}function qCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7840>>3]=0.0;i=i;return}function rCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7864>>3]=0.0;i=i;return}function sCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7872>>3]=0.0;i=i;return}function tCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7896>>3]=0.0;i=i;return}function uCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7968>>3]=0.0;i=i;return}function vCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7992>>3]=0.0;i=i;return}function wCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8e3>>3]=0.0;i=i;return}function xCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8008>>3]=0.0;i=i;return}function yCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8032>>3]=0.0;i=i;return}function zCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8056>>3]=0.0;i=i;return}function ACa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8080>>3]=0.0;i=i;return}function BCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8088>>3]=0.0;i=i;return}function CCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8112>>3]=0.0;i=i;return}function DCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8120>>3]=0.0;i=i;return}function ECa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8128>>3]=0.0;i=i;return}function FCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8152>>3]=0.0;i=i;return}function GCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8160>>3]=0.0;i=i;return}function HCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8168>>3]=0.0;i=i;return}function ICa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8192>>3]=0.0;i=i;return}function JCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8200>>3]=0.0;i=i;return}function KCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8208>>3]=0.0;i=i;return}function LCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8216>>3]=0.0;i=i;return}function MCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8224>>3]=0.0;i=i;return}function NCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8232>>3]=0.0;i=i;return}function OCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8240>>3]=0.0;i=i;return}function PCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8264>>3]=0.0;i=i;return}function QCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8288>>3]=0.0;i=i;return}function RCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8312>>3]=0.0;i=i;return}function SCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8320>>3]=0.0;i=i;return}function TCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8344>>3]=0.0;i=i;return}function UCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8352>>3]=0.0;i=i;return}function VCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8360>>3]=0.0;i=i;return}function WCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8384>>3]=0.0;i=i;return}function XCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8392>>3]=0.0;i=i;return}function YCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8400>>3]=0.0;i=i;return}function ZCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8424>>3]=0.0;i=i;return}function _Ca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8432>>3]=0.0;i=i;return}function $Ca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8440>>3]=0.0;i=i;return}function aDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8448>>3]=0.0;i=i;return}function bDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8456>>3]=0.0;i=i;return}function cDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8464>>3]=0.0;i=i;return}function dDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8472>>3]=0.0;i=i;return}function eDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8496>>3]=0.0;i=i;return}function fDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8504>>3]=0.0;i=i;return}function gDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8512>>3]=0.0;i=i;return}function hDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8520>>3]=0.0;i=i;return}function iDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8544>>3]=0.0;i=i;return}function jDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8568>>3]=0.0;i=i;return}function kDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8592>>3]=0.0;i=i;return}function lDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8600>>3]=0.0;i=i;return}function mDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8624>>3]=0.0;i=i;return}function nDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8632>>3]=0.0;i=i;return}function oDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8640>>3]=0.0;i=i;return}function pDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8664>>3]=0.0;i=i;return}function qDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8672>>3]=0.0;i=i;return}function rDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8680>>3]=0.0;i=i;return}function sDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8704>>3]=0.0;i=i;return}function tDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8712>>3]=0.0;i=i;return}function uDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8720>>3]=0.0;i=i;return}function vDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8728>>3]=0.0;i=i;return}function wDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8736>>3]=0.0;i=i;return}function xDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8744>>3]=0.0;i=i;return}function yDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8752>>3]=0.0;i=i;return}function zDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8776>>3]=0.0;i=i;return}function ADa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8784>>3]=0.0;i=i;return}function BDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8792>>3]=0.0;i=i;return}function CDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8800>>3]=0.0;i=i;return}function DDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8824>>3]=0.0;i=i;return}function EDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8848>>3]=0.0;i=i;return}function FDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8872>>3]=0.0;i=i;return}function GDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8880>>3]=0.0;i=i;return}function HDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8904>>3]=0.0;i=i;return}function IDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8912>>3]=0.0;i=i;return}function JDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8920>>3]=0.0;i=i;return}function KDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8944>>3]=0.0;i=i;return}function LDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8952>>3]=0.0;i=i;return}function MDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8960>>3]=0.0;i=i;return}function NDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8984>>3]=0.0;i=i;return}function ODa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8992>>3]=0.0;i=i;return}function PDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9e3>>3]=0.0;i=i;return}function QDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9008>>3]=0.0;i=i;return}function RDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9016>>3]=0.0;i=i;return}function SDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9024>>3]=0.0;i=i;return}function TDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9032>>3]=0.0;i=i;return}function UDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9056>>3]=0.0;i=i;return}function VDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9064>>3]=0.0;i=i;return}function WDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9072>>3]=0.0;i=i;return}function XDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9080>>3]=0.0;i=i;return}function YDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9104>>3]=0.0;i=i;return}function ZDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9128>>3]=0.0;i=i;return}function _Da(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9152>>3]=0.0;i=i;return}function $Da(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9160>>3]=0.0;i=i;return}function aEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9184>>3]=0.0;i=i;return}function bEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9192>>3]=0.0;i=i;return}function cEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9200>>3]=0.0;i=i;return}function dEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9224>>3]=0.0;i=i;return}function eEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9232>>3]=0.0;i=i;return}function fEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9240>>3]=0.0;i=i;return}function gEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9264>>3]=0.0;i=i;return}function hEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9272>>3]=0.0;i=i;return}function iEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9280>>3]=0.0;i=i;return}function jEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9288>>3]=0.0;i=i;return}function kEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9296>>3]=0.0;i=i;return}function lEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9304>>3]=0.0;i=i;return}function mEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9312>>3]=0.0;i=i;return}function nEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9336>>3]=0.0;i=i;return}function oEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9344>>3]=0.0;i=i;return}function pEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9352>>3]=0.0;i=i;return}function qEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9360>>3]=0.0;i=i;return}function rEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9384>>3]=0.0;i=i;return}function sEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9408>>3]=0.0;i=i;return}function tEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9432>>3]=0.0;i=i;return}function uEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9440>>3]=0.0;i=i;return}function vEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9464>>3]=0.0;i=i;return}function wEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9472>>3]=0.0;i=i;return}function xEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9480>>3]=0.0;i=i;return}function yEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9504>>3]=0.0;i=i;return}function zEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9512>>3]=0.0;i=i;return}function AEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9520>>3]=0.0;i=i;return}function BEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9544>>3]=0.0;i=i;return}function CEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9552>>3]=0.0;i=i;return}function DEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9560>>3]=0.0;i=i;return}function EEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9568>>3]=0.0;i=i;return}function FEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9592>>3]=0.0;i=i;return}function GEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9600>>3]=0.0;i=i;return}function HEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9608>>3]=0.0;i=i;return}function IEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9616>>3]=0.0;i=i;return}function JEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9640>>3]=0.0;i=i;return}function KEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9648>>3]=0.0;i=i;return}function LEa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10624>>3]=+h[b+736>>3]+ +h[b+4040>>3];i=i;return}function MEa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10816>>3]=+h[b+736>>3]+ +h[b+3752>>3];i=i;return}function NEa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10792>>3]=+h[b+10816>>3]+ +h[(c[a+416>>2]|0)+6768>>3];i=i;return}function OEa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10768>>3]=+h[b+10792>>3]+ +h[(c[a+416>>2]|0)+9784>>3];i=i;return}function PEa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10744>>3]=+h[b+10768>>3]+ +h[(c[a+416>>2]|0)+12800>>3];i=i;return}function QEa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10720>>3]=+h[b+10744>>3]+ +h[(c[a+416>>2]|0)+16104>>3];i=i;return}function REa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7784>>3]=+h[b+10744>>3]+ +h[(c[a+416>>2]|0)+15816>>3];i=i;return}function SEa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10696>>3]=+h[b+10768>>3]+ +h[(c[a+416>>2]|0)+13088>>3];i=i;return}function TEa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10672>>3]=+h[b+10792>>3]+ +h[(c[a+416>>2]|0)+10072>>3];i=i;return}function UEa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10648>>3]=+h[b+10816>>3]+ +h[(c[a+416>>2]|0)+7056>>3];i=i;return}function VEa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10632>>3]=+h[b+744>>3]+ +h[b+4048>>3];i=i;return}function WEa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10824>>3]=+h[b+744>>3]+ +h[b+3760>>3];i=i;return}function XEa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10800>>3]=+h[b+10824>>3]+ +h[(c[a+416>>2]|0)+6776>>3];i=i;return}function YEa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10776>>3]=+h[b+10800>>3]+ +h[(c[a+416>>2]|0)+9792>>3];i=i;return}function ZEa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10752>>3]=+h[b+10776>>3]+ +h[(c[a+416>>2]|0)+12808>>3];i=i;return}function _Ea(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10728>>3]=+h[b+10752>>3]+ +h[(c[a+416>>2]|0)+16112>>3];i=i;return}function $Ea(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7792>>3]=+h[b+10752>>3]+ +h[(c[a+416>>2]|0)+15824>>3];i=i;return}function aFa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10704>>3]=+h[b+10776>>3]+ +h[(c[a+416>>2]|0)+13096>>3];i=i;return}function bFa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10680>>3]=+h[b+10800>>3]+ +h[(c[a+416>>2]|0)+10080>>3];i=i;return}function cFa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10656>>3]=+h[b+10824>>3]+ +h[(c[a+416>>2]|0)+7064>>3];i=i;return}function dFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21176>>3]=0.0;i=i;return}function eFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21184>>3]=+h[(c[a+416>>2]|0)+19312>>3]*2.0;i=i;return}function fFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21192>>3]=+h[(c[a+416>>2]|0)+19312>>3]*2.0;i=i;return}function gFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21200>>3]=+h[(c[a+416>>2]|0)+19312>>3]*2.0;i=i;return}function hFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21208>>3]=1.0;i=i;return}function iFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21216>>3]=+h[(c[a+416>>2]|0)+20344>>3]*2.0;i=i;return}function jFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21224>>3]=+h[(c[a+416>>2]|0)+20344>>3]*2.0;i=i;return}function kFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21232>>3]=+h[(c[a+416>>2]|0)+20344>>3]*2.0;i=i;return}function lFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21240>>3]=1.0;i=i;return}function mFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21248>>3]=+h[(c[a+416>>2]|0)+21376>>3]*2.0;i=i;return}function nFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21256>>3]=+h[(c[a+416>>2]|0)+21376>>3]*2.0;i=i;return}function oFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21264>>3]=+h[(c[a+416>>2]|0)+21376>>3]*2.0;i=i;return}function pFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21272>>3]=1.0;i=i;return}function qFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21280>>3]=+h[(c[a+416>>2]|0)+22408>>3]*2.0;i=i;return}function rFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21288>>3]=+h[(c[a+416>>2]|0)+22408>>3]*2.0;i=i;return}function sFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21296>>3]=+h[(c[a+416>>2]|0)+22408>>3]*2.0;i=i;return}function tFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21304>>3]=1.0;i=i;return}function uFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21312>>3]=+h[(c[a+416>>2]|0)+23440>>3]*2.0;i=i;return}function vFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21320>>3]=+h[(c[a+416>>2]|0)+23440>>3]*2.0;i=i;return}function wFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21328>>3]=+h[(c[a+416>>2]|0)+23440>>3]*2.0;i=i;return}function xFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21336>>3]=1.0;i=i;return}function yFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21344>>3]=+h[(c[a+416>>2]|0)+24472>>3]*2.0;i=i;return}function zFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21352>>3]=+h[(c[a+416>>2]|0)+24472>>3]*2.0;i=i;return}function AFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21360>>3]=+h[(c[a+416>>2]|0)+24472>>3]*2.0;i=i;return}function BFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21368>>3]=1.0;i=i;return}function CFa(a){a=a|0;c[c[(c[c[a+4>>2]>>2]|0)+12>>2]>>2]=0;i=i;return}function DFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+4>>2]=230;i=i;return}function EFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+8>>2]=0;i=i;return}function FFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+12>>2]=0;i=i;return}function GFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+16>>2]=230;i=i;return}function HFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+20>>2]=0;i=i;return}function IFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+24>>2]=0;i=i;return}function JFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+28>>2]=0;i=i;return}function KFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+32>>2]=0;i=i;return}function LFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10856>>3]=+h[(c[a+416>>2]|0)+19080>>3]*-.5;i=i;return}function MFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10864>>3]=0.0;i=i;return}function NFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10872>>3]=0.0;i=i;return}function OFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10880>>3]=1.0;i=i;return}function PFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10888>>3]=0.0;i=i;return}function QFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10896>>3]=0.0;i=i;return}function RFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10904>>3]=0.0;i=i;return}function SFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10912>>3]=1.0;i=i;return}function TFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10920>>3]=0.0;i=i;return}function UFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10944>>3]=0.0;i=i;return}function VFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10936>>3]=0.0;i=i;return}function WFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10928>>3]=255.0;i=i;return}function XFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+36>>2]=255;i=i;return}function YFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+40>>2]=0;i=i;return}function ZFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+44>>2]=0;i=i;return}function _Fa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+48>>2]=155;i=i;return}function $Fa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+52>>2]=155;i=i;return}function aGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+56>>2]=155;i=i;return}function bGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+60>>2]=0;i=i;return}function cGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+64>>2]=128;i=i;return}function dGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+68>>2]=255;i=i;return}function eGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+72>>2]=0;i=i;return}function fGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+76>>2]=128;i=i;return}function gGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+80>>2]=255;i=i;return}function hGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10952>>3]=0.0;i=i;return}function iGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10960>>3]=0.0;i=i;return}function jGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10968>>3]=0.0;i=i;return}function kGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10976>>3]=1.0;i=i;return}function lGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10984>>3]=0.0;i=i;return}function mGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10992>>3]=0.0;i=i;return}function nGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11e3>>3]=0.0;i=i;return}function oGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11008>>3]=0.0;i=i;return}function pGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11016>>3]=0.0;i=i;return}function qGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11024>>3]=0.0;i=i;return}function rGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11032>>3]=0.0;i=i;return}function sGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11040>>3]=0.0;i=i;return}function tGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11048>>3]=0.0;i=i;return}function uGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+84>>2]=155;i=i;return}function vGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+88>>2]=155;i=i;return}function wGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+92>>2]=155;i=i;return}function xGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+96>>2]=155;i=i;return}function yGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+100>>2]=155;i=i;return}function zGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+104>>2]=155;i=i;return}function AGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+108>>2]=155;i=i;return}function BGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+112>>2]=155;i=i;return}function CGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+116>>2]=155;i=i;return}function DGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+120>>2]=155;i=i;return}function EGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+124>>2]=155;i=i;return}function FGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+128>>2]=155;i=i;return}function GGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+132>>2]=155;i=i;return}function HGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+136>>2]=155;i=i;return}function IGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+140>>2]=155;i=i;return}function JGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+144>>2]=155;i=i;return}function KGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+148>>2]=155;i=i;return}function LGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+152>>2]=155;i=i;return}function MGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+156>>2]=255;i=i;return}function NGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+160>>2]=0;i=i;return}function OGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+164>>2]=0;i=i;return}function PGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+168>>2]=255;i=i;return}function QGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+172>>2]=0;i=i;return}function RGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+176>>2]=0;i=i;return}function SGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+180>>2]=255;i=i;return}function TGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+184>>2]=0;i=i;return}function UGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+188>>2]=0;i=i;return}function VGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21376>>3]=0.0;i=i;return}function WGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+192>>2]=155;i=i;return}function XGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+196>>2]=155;i=i;return}function YGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+200>>2]=155;i=i;return}function ZGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21384>>3]=0.0;i=i;return}function _Ga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+204>>2]=155;i=i;return}function $Ga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+208>>2]=155;i=i;return}function aHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+212>>2]=155;i=i;return}function bHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+216>>2]=0;i=i;return}function cHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+220>>2]=128;i=i;return}function dHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+224>>2]=255;i=i;return}function eHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11056>>3]=0.0;i=i;return}function fHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11064>>3]=0.0;i=i;return}function gHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11072>>3]=0.0;i=i;return}function hHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11080>>3]=1.0;i=i;return}function iHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11088>>3]=0.0;i=i;return}function jHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11096>>3]=0.0;i=i;return}function kHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11104>>3]=0.0;i=i;return}function lHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11112>>3]=0.0;i=i;return}function mHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11120>>3]=0.0;i=i;return}function nHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11128>>3]=0.0;i=i;return}function oHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11136>>3]=0.0;i=i;return}function pHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11144>>3]=0.0;i=i;return}function qHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11152>>3]=0.0;i=i;return}function rHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11160>>3]=1.0;i=i;return}function sHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11168>>3]=0.0;i=i;return}function tHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11176>>3]=0.0;i=i;return}function uHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11184>>3]=0.0;i=i;return}function vHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11192>>3]=0.0;i=i;return}function wHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11200>>3]=-1.0;i=i;return}function xHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11224>>3]=155.0;i=i;return}function yHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11216>>3]=155.0;i=i;return}function zHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11208>>3]=155.0;i=i;return}function AHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+228>>2]=155;i=i;return}function BHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+232>>2]=155;i=i;return}function CHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+236>>2]=155;i=i;return}function DHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+240>>2]=155;i=i;return}function EHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+244>>2]=155;i=i;return}function FHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+248>>2]=155;i=i;return}function GHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+252>>2]=0;i=i;return}function HHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+256>>2]=128;i=i;return}function IHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+260>>2]=255;i=i;return}function JHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11232>>3]=0.0;i=i;return}function KHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11240>>3]=0.0;i=i;return}function LHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11248>>3]=0.0;i=i;return}function MHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11256>>3]=1.0;i=i;return}function NHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11264>>3]=0.0;i=i;return}function OHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11272>>3]=0.0;i=i;return}function PHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11280>>3]=0.0;i=i;return}function QHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11288>>3]=0.0;i=i;return}function RHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11296>>3]=0.0;i=i;return}function SHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11304>>3]=0.0;i=i;return}function THa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11312>>3]=0.0;i=i;return}function UHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11320>>3]=0.0;i=i;return}function VHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11328>>3]=0.0;i=i;return}function WHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11336>>3]=1.0;i=i;return}function XHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11344>>3]=0.0;i=i;return}function YHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11352>>3]=0.0;i=i;return}function ZHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11360>>3]=0.0;i=i;return}function _Ha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11368>>3]=0.0;i=i;return}function $Ha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11376>>3]=-1.0;i=i;return}function aIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11400>>3]=180.0;i=i;return}function bIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11392>>3]=180.0;i=i;return}function cIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11384>>3]=180.0;i=i;return}function dIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+264>>2]=180;i=i;return}function eIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+268>>2]=180;i=i;return}function fIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+272>>2]=180;i=i;return}function gIa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11408>>3]=+h[b+19304>>3]+ +h[b+19320>>3]*-.5+-.002;i=i;return}function hIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11416>>3]=0.0;i=i;return}function iIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11424>>3]=0.0;i=i;return}function jIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11432>>3]=1.0;i=i;return}function kIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11440>>3]=0.0;i=i;return}function lIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11448>>3]=0.0;i=i;return}function mIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11456>>3]=0.0;i=i;return}function nIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11464>>3]=1.0;i=i;return}function oIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11472>>3]=0.0;i=i;return}function pIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11496>>3]=255.0;i=i;return}function qIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11488>>3]=128.0;i=i;return}function rIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11480>>3]=0.0;i=i;return}function sIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+276>>2]=0;i=i;return}function tIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+280>>2]=128;i=i;return}function uIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+284>>2]=255;i=i;return}function vIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+288>>2]=155;i=i;return}function wIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+292>>2]=155;i=i;return}function xIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+296>>2]=155;i=i;return}function yIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+300>>2]=155;i=i;return}function zIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+304>>2]=155;i=i;return}function AIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+308>>2]=155;i=i;return}function BIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+312>>2]=155;i=i;return}function CIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+316>>2]=155;i=i;return}function DIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+320>>2]=155;i=i;return}function EIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+324>>2]=155;i=i;return}function FIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+328>>2]=155;i=i;return}function GIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+332>>2]=155;i=i;return}function HIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+336>>2]=155;i=i;return}function IIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+340>>2]=155;i=i;return}function JIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+344>>2]=155;i=i;return}function KIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+348>>2]=155;i=i;return}function LIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+352>>2]=155;i=i;return}function MIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+356>>2]=155;i=i;return}function NIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+360>>2]=255;i=i;return}function OIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+364>>2]=0;i=i;return}function PIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+368>>2]=0;i=i;return}function QIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+372>>2]=255;i=i;return}function RIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+376>>2]=0;i=i;return}function SIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+380>>2]=0;i=i;return}function TIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+384>>2]=255;i=i;return}function UIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+388>>2]=0;i=i;return}function VIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+392>>2]=0;i=i;return}function WIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21392>>3]=0.0;i=i;return}function XIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+396>>2]=155;i=i;return}function YIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+400>>2]=155;i=i;return}function ZIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+404>>2]=155;i=i;return}function _Ia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21400>>3]=0.0;i=i;return}function $Ia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+408>>2]=155;i=i;return}function aJa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+412>>2]=155;i=i;return}function bJa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+416>>2]=155;i=i;return}function cJa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+420>>2]=0;i=i;return}function dJa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+424>>2]=128;i=i;return}function eJa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+428>>2]=255;i=i;return}function fJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11504>>3]=0.0;i=i;return}function gJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11512>>3]=0.0;i=i;return}function hJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11520>>3]=0.0;i=i;return}function iJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11528>>3]=1.0;i=i;return}function jJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11536>>3]=0.0;i=i;return}function kJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11544>>3]=0.0;i=i;return}function lJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11552>>3]=0.0;i=i;return}function mJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11560>>3]=0.0;i=i;return}function nJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11568>>3]=0.0;i=i;return}function oJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11576>>3]=0.0;i=i;return}function pJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11584>>3]=0.0;i=i;return}function qJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11592>>3]=0.0;i=i;return}function rJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11600>>3]=0.0;i=i;return}function sJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11608>>3]=1.0;i=i;return}function tJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11616>>3]=0.0;i=i;return}function uJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11624>>3]=0.0;i=i;return}function vJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11632>>3]=0.0;i=i;return}function wJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11640>>3]=0.0;i=i;return}function xJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11648>>3]=-1.0;i=i;return}function yJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11672>>3]=155.0;i=i;return}function zJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11664>>3]=155.0;i=i;return}function AJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11656>>3]=155.0;i=i;return}function BJa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+432>>2]=155;i=i;return}function CJa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+436>>2]=155;i=i;return}function DJa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+440>>2]=155;i=i;return}function EJa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+444>>2]=155;i=i;return}function FJa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+448>>2]=155;i=i;return}function GJa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+452>>2]=155;i=i;return}function HJa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+456>>2]=0;i=i;return}function IJa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+460>>2]=128;i=i;return}function JJa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+464>>2]=255;i=i;return}function KJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11680>>3]=0.0;i=i;return}function LJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11688>>3]=0.0;i=i;return}function MJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11696>>3]=0.0;i=i;return}function NJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11704>>3]=1.0;i=i;return}function OJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11712>>3]=0.0;i=i;return}function PJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11720>>3]=0.0;i=i;return}function QJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11728>>3]=0.0;i=i;return}function RJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11736>>3]=0.0;i=i;return}function SJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11744>>3]=0.0;i=i;return}function TJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11752>>3]=0.0;i=i;return}function UJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11760>>3]=0.0;i=i;return}function VJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11768>>3]=0.0;i=i;return}function WJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11776>>3]=0.0;i=i;return}function XJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11784>>3]=1.0;i=i;return}function YJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11792>>3]=0.0;i=i;return}function ZJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11800>>3]=0.0;i=i;return}function _Ja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11808>>3]=0.0;i=i;return}function $Ja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11816>>3]=0.0;i=i;return}function aKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11824>>3]=-1.0;i=i;return}function bKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11848>>3]=180.0;i=i;return}function cKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11840>>3]=180.0;i=i;return}function dKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11832>>3]=180.0;i=i;return}function eKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+468>>2]=180;i=i;return}function fKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+472>>2]=180;i=i;return}function gKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+476>>2]=180;i=i;return}function hKa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11856>>3]=+h[b+20336>>3]+ +h[b+20352>>3]*-.5+-.002;i=i;return}function iKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11864>>3]=0.0;i=i;return}function jKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11872>>3]=0.0;i=i;return}function kKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11880>>3]=1.0;i=i;return}function lKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11888>>3]=0.0;i=i;return}function mKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11896>>3]=0.0;i=i;return}function nKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11904>>3]=0.0;i=i;return}function oKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11912>>3]=1.0;i=i;return}function pKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11920>>3]=0.0;i=i;return}function qKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11944>>3]=255.0;i=i;return}function rKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11936>>3]=128.0;i=i;return}function sKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11928>>3]=0.0;i=i;return}function tKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+480>>2]=0;i=i;return}function uKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+484>>2]=128;i=i;return}function vKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+488>>2]=255;i=i;return}function wKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+492>>2]=155;i=i;return}function xKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+496>>2]=155;i=i;return}function yKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+500>>2]=155;i=i;return}function zKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+504>>2]=155;i=i;return}function AKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+508>>2]=155;i=i;return}function BKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+512>>2]=155;i=i;return}function CKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+516>>2]=155;i=i;return}function DKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+520>>2]=155;i=i;return}function EKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+524>>2]=155;i=i;return}function FKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+528>>2]=155;i=i;return}function GKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+532>>2]=155;i=i;return}function HKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+536>>2]=155;i=i;return}function IKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+540>>2]=155;i=i;return}function JKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+544>>2]=155;i=i;return}function KKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+548>>2]=155;i=i;return}function LKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+552>>2]=155;i=i;return}function MKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+556>>2]=155;i=i;return}function NKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+560>>2]=155;i=i;return}function OKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+564>>2]=255;i=i;return}function PKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+568>>2]=0;i=i;return}function QKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+572>>2]=0;i=i;return}function RKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+576>>2]=255;i=i;return}function SKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+580>>2]=0;i=i;return}function TKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+584>>2]=0;i=i;return}function UKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+588>>2]=255;i=i;return}function VKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+592>>2]=0;i=i;return}function WKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+596>>2]=0;i=i;return}function XKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21408>>3]=0.0;i=i;return}function YKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+600>>2]=155;i=i;return}function ZKa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+604>>2]=155;i=i;return}function _Ka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+608>>2]=155;i=i;return}function $Ka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21416>>3]=0.0;i=i;return}function aLa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+612>>2]=155;i=i;return}function bLa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+616>>2]=155;i=i;return}function cLa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+620>>2]=155;i=i;return}function dLa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+624>>2]=0;i=i;return}function eLa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+628>>2]=128;i=i;return}function fLa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+632>>2]=255;i=i;return}function gLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11952>>3]=0.0;i=i;return}function hLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11960>>3]=0.0;i=i;return}function iLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11968>>3]=0.0;i=i;return}function jLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11976>>3]=1.0;i=i;return}function kLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11984>>3]=0.0;i=i;return}function lLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11992>>3]=0.0;i=i;return}function mLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12e3>>3]=0.0;i=i;return}function nLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12008>>3]=0.0;i=i;return}function oLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12016>>3]=0.0;i=i;return}function pLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12024>>3]=0.0;i=i;return}function qLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12032>>3]=0.0;i=i;return}function rLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12040>>3]=0.0;i=i;return}function sLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12048>>3]=0.0;i=i;return}function tLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12056>>3]=1.0;i=i;return}function uLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12064>>3]=0.0;i=i;return}function vLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12072>>3]=0.0;i=i;return}function wLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12080>>3]=0.0;i=i;return}function xLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12088>>3]=0.0;i=i;return}function yLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12096>>3]=-1.0;i=i;return}function zLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12120>>3]=155.0;i=i;return}function ALa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12112>>3]=155.0;i=i;return}function BLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12104>>3]=155.0;i=i;return}function CLa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+636>>2]=155;i=i;return}function DLa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+640>>2]=155;i=i;return}function ELa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+644>>2]=155;i=i;return}function FLa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+648>>2]=155;i=i;return}function GLa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+652>>2]=155;i=i;return}function HLa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+656>>2]=155;i=i;return}function ILa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+660>>2]=0;i=i;return}function JLa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+664>>2]=128;i=i;return}function KLa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+668>>2]=255;i=i;return}function LLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12128>>3]=0.0;i=i;return}function MLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12136>>3]=0.0;i=i;return}function NLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12144>>3]=0.0;i=i;return}function OLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12152>>3]=1.0;i=i;return}function PLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12160>>3]=0.0;i=i;return}function QLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12168>>3]=0.0;i=i;return}function RLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12176>>3]=0.0;i=i;return}function SLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12184>>3]=0.0;i=i;return}function TLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12192>>3]=0.0;i=i;return}function ULa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12200>>3]=0.0;i=i;return}function VLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12208>>3]=0.0;i=i;return}function WLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12216>>3]=0.0;i=i;return}function XLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12224>>3]=0.0;i=i;return}function YLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12232>>3]=1.0;i=i;return}function ZLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12240>>3]=0.0;i=i;return}function _La(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12248>>3]=0.0;i=i;return}function $La(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12256>>3]=0.0;i=i;return}function aMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12264>>3]=0.0;i=i;return}function bMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12272>>3]=-1.0;i=i;return}function cMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12296>>3]=180.0;i=i;return}function dMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12288>>3]=180.0;i=i;return}function eMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12280>>3]=180.0;i=i;return}function fMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+672>>2]=180;i=i;return}function gMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+676>>2]=180;i=i;return}function hMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+680>>2]=180;i=i;return}function iMa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12304>>3]=+h[b+21368>>3]+ +h[b+21384>>3]*-.5+-.002;i=i;return}function jMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12312>>3]=0.0;i=i;return}function kMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12320>>3]=0.0;i=i;return}function lMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12328>>3]=1.0;i=i;return}function mMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12336>>3]=0.0;i=i;return}function nMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12344>>3]=0.0;i=i;return}function oMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12352>>3]=0.0;i=i;return}function pMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12360>>3]=1.0;i=i;return}function qMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12368>>3]=0.0;i=i;return}function rMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12392>>3]=255.0;i=i;return}function sMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12384>>3]=128.0;i=i;return}function tMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12376>>3]=0.0;i=i;return}function uMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+684>>2]=0;i=i;return}function vMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+688>>2]=128;i=i;return}function wMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+692>>2]=255;i=i;return}function xMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+696>>2]=155;i=i;return}function yMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+700>>2]=155;i=i;return}function zMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+704>>2]=155;i=i;return}function AMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+708>>2]=155;i=i;return}function BMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+712>>2]=155;i=i;return}function CMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+716>>2]=155;i=i;return}function DMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+720>>2]=155;i=i;return}function EMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+724>>2]=155;i=i;return}function FMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+728>>2]=155;i=i;return}function GMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+732>>2]=155;i=i;return}function HMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+736>>2]=155;i=i;return}function IMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+740>>2]=155;i=i;return}function JMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+744>>2]=155;i=i;return}function KMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+748>>2]=155;i=i;return}function LMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+752>>2]=155;i=i;return}function MMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+756>>2]=155;i=i;return}function NMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+760>>2]=155;i=i;return}function OMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+764>>2]=155;i=i;return}function PMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+768>>2]=255;i=i;return}function QMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+772>>2]=0;i=i;return}function RMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+776>>2]=0;i=i;return}function SMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+780>>2]=255;i=i;return}function TMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+784>>2]=0;i=i;return}function UMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+788>>2]=0;i=i;return}function VMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+792>>2]=255;i=i;return}function WMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+796>>2]=0;i=i;return}function XMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+800>>2]=0;i=i;return}function YMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21424>>3]=0.0;i=i;return}function ZMa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+804>>2]=155;i=i;return}function _Ma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+808>>2]=155;i=i;return}function $Ma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+812>>2]=155;i=i;return}function aNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21432>>3]=0.0;i=i;return}function bNa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+816>>2]=155;i=i;return}function cNa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+820>>2]=155;i=i;return}function dNa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+824>>2]=155;i=i;return}function eNa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+828>>2]=0;i=i;return}function fNa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+832>>2]=128;i=i;return}function gNa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+836>>2]=255;i=i;return}function hNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12400>>3]=0.0;i=i;return}function iNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12408>>3]=0.0;i=i;return}function jNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12416>>3]=0.0;i=i;return}function kNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12424>>3]=1.0;i=i;return}function lNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12432>>3]=0.0;i=i;return}function mNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12440>>3]=0.0;i=i;return}function nNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12448>>3]=0.0;i=i;return}function oNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12456>>3]=0.0;i=i;return}function pNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12464>>3]=0.0;i=i;return}function qNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12472>>3]=0.0;i=i;return}function rNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12480>>3]=0.0;i=i;return}function sNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12488>>3]=0.0;i=i;return}function tNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12496>>3]=0.0;i=i;return}function uNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12504>>3]=1.0;i=i;return}function vNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12512>>3]=0.0;i=i;return}function wNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12520>>3]=0.0;i=i;return}function xNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12528>>3]=0.0;i=i;return}function yNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12536>>3]=0.0;i=i;return}function zNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12544>>3]=-1.0;i=i;return}function ANa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12568>>3]=155.0;i=i;return}function BNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12560>>3]=155.0;i=i;return}function CNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12552>>3]=155.0;i=i;return}function DNa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+840>>2]=155;i=i;return}function ENa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+844>>2]=155;i=i;return}function FNa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+848>>2]=155;i=i;return}function GNa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+852>>2]=155;i=i;return}function HNa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+856>>2]=155;i=i;return}function INa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+860>>2]=155;i=i;return}function JNa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+864>>2]=0;i=i;return}function KNa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+868>>2]=128;i=i;return}function LNa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+872>>2]=255;i=i;return}function MNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12576>>3]=0.0;i=i;return}function NNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12584>>3]=0.0;i=i;return}function ONa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12592>>3]=0.0;i=i;return}function PNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12600>>3]=1.0;i=i;return}function QNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12608>>3]=0.0;i=i;return}function RNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12616>>3]=0.0;i=i;return}function SNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12624>>3]=0.0;i=i;return}function TNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12632>>3]=0.0;i=i;return}function UNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12640>>3]=0.0;i=i;return}function VNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12648>>3]=0.0;i=i;return}function WNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12656>>3]=0.0;i=i;return}function XNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12664>>3]=0.0;i=i;return}function YNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12672>>3]=0.0;i=i;return}function ZNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12680>>3]=1.0;i=i;return}function _Na(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12688>>3]=0.0;i=i;return}function $Na(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12696>>3]=0.0;i=i;return}function aOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12704>>3]=0.0;i=i;return}function bOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12712>>3]=0.0;i=i;return}function cOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12720>>3]=-1.0;i=i;return}function dOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12744>>3]=180.0;i=i;return}function eOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12736>>3]=180.0;i=i;return}function fOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12728>>3]=180.0;i=i;return}function gOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+876>>2]=180;i=i;return}function hOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+880>>2]=180;i=i;return}function iOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+884>>2]=180;i=i;return}function jOa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12752>>3]=+h[b+22400>>3]+ +h[b+22416>>3]*-.5+-.002;i=i;return}function kOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12760>>3]=0.0;i=i;return}function lOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12768>>3]=0.0;i=i;return}function mOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12776>>3]=1.0;i=i;return}function nOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12784>>3]=0.0;i=i;return}function oOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12792>>3]=0.0;i=i;return}function pOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12800>>3]=0.0;i=i;return}function qOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12808>>3]=1.0;i=i;return}function rOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12816>>3]=0.0;i=i;return}function sOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12840>>3]=255.0;i=i;return}function tOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12832>>3]=128.0;i=i;return}function uOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12824>>3]=0.0;i=i;return}function vOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+888>>2]=0;i=i;return}function wOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+892>>2]=128;i=i;return}function xOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+896>>2]=255;i=i;return}function yOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+900>>2]=155;i=i;return}function zOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+904>>2]=155;i=i;return}function AOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+908>>2]=155;i=i;return}function BOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+912>>2]=155;i=i;return}function COa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+916>>2]=155;i=i;return}function DOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+920>>2]=155;i=i;return}function EOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+924>>2]=155;i=i;return}function FOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+928>>2]=155;i=i;return}function GOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+932>>2]=155;i=i;return}function HOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+936>>2]=155;i=i;return}function IOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+940>>2]=155;i=i;return}function JOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+944>>2]=155;i=i;return}function KOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+948>>2]=155;i=i;return}function LOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+952>>2]=155;i=i;return}function MOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+956>>2]=155;i=i;return}function NOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+960>>2]=155;i=i;return}function OOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+964>>2]=155;i=i;return}function POa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+968>>2]=155;i=i;return}function QOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+972>>2]=255;i=i;return}function ROa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+976>>2]=0;i=i;return}function SOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+980>>2]=0;i=i;return}function TOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+984>>2]=255;i=i;return}function UOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+988>>2]=0;i=i;return}function VOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+992>>2]=0;i=i;return}function WOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+996>>2]=255;i=i;return}function XOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1e3>>2]=0;i=i;return}function YOa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1004>>2]=0;i=i;return}function ZOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21440>>3]=0.0;i=i;return}function _Oa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1008>>2]=155;i=i;return}function $Oa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1012>>2]=155;i=i;return}function aPa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1016>>2]=155;i=i;return}function bPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21448>>3]=0.0;i=i;return}function cPa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1020>>2]=155;i=i;return}function dPa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1024>>2]=155;i=i;return}function ePa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1028>>2]=155;i=i;return}function fPa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1032>>2]=0;i=i;return}function gPa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1036>>2]=128;i=i;return}function hPa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1040>>2]=255;i=i;return}function iPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12848>>3]=0.0;i=i;return}function jPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12856>>3]=0.0;i=i;return}function kPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12864>>3]=0.0;i=i;return}function lPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12872>>3]=1.0;i=i;return}function mPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12880>>3]=0.0;i=i;return}function nPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12888>>3]=0.0;i=i;return}function oPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12896>>3]=0.0;i=i;return}function pPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12904>>3]=0.0;i=i;return}function qPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12912>>3]=0.0;i=i;return}function rPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12920>>3]=0.0;i=i;return}function sPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12928>>3]=0.0;i=i;return}function tPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12936>>3]=0.0;i=i;return}function uPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12944>>3]=0.0;i=i;return}function vPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12952>>3]=1.0;i=i;return}function wPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12960>>3]=0.0;i=i;return}function xPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12968>>3]=0.0;i=i;return}function yPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12976>>3]=0.0;i=i;return}function zPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12984>>3]=0.0;i=i;return}function APa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12992>>3]=-1.0;i=i;return}function BPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13016>>3]=155.0;i=i;return}function CPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13008>>3]=155.0;i=i;return}function DPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13e3>>3]=155.0;i=i;return}function EPa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1044>>2]=155;i=i;return}function FPa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1048>>2]=155;i=i;return}function GPa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1052>>2]=155;i=i;return}function HPa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1056>>2]=155;i=i;return}function IPa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1060>>2]=155;i=i;return}function JPa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1064>>2]=155;i=i;return}function KPa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1068>>2]=0;i=i;return}function LPa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1072>>2]=128;i=i;return}function MPa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1076>>2]=255;i=i;return}function NPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13024>>3]=0.0;i=i;return}function OPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13032>>3]=0.0;i=i;return}function PPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13040>>3]=0.0;i=i;return}function QPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13048>>3]=1.0;i=i;return}function RPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13056>>3]=0.0;i=i;return}function SPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13064>>3]=0.0;i=i;return}function TPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13072>>3]=0.0;i=i;return}function UPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13080>>3]=0.0;i=i;return}function VPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13088>>3]=0.0;i=i;return}function WPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13096>>3]=0.0;i=i;return}function XPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13104>>3]=0.0;i=i;return}function YPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13112>>3]=0.0;i=i;return}function ZPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13120>>3]=0.0;i=i;return}function _Pa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13128>>3]=1.0;i=i;return}function $Pa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13136>>3]=0.0;i=i;return}function aQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13144>>3]=0.0;i=i;return}function bQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13152>>3]=0.0;i=i;return}function cQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13160>>3]=0.0;i=i;return}function dQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13168>>3]=-1.0;i=i;return}function eQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13192>>3]=180.0;i=i;return}function fQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13184>>3]=180.0;i=i;return}function gQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13176>>3]=180.0;i=i;return}function hQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1080>>2]=180;i=i;return}function iQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1084>>2]=180;i=i;return}function jQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1088>>2]=180;i=i;return}function kQa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13200>>3]=+h[b+23432>>3]+ +h[b+23448>>3]*-.5+-.002;i=i;return}function lQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13208>>3]=0.0;i=i;return}function mQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13216>>3]=0.0;i=i;return}function nQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13224>>3]=1.0;i=i;return}function oQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13232>>3]=0.0;i=i;return}function pQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13240>>3]=0.0;i=i;return}function qQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13248>>3]=0.0;i=i;return}function rQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13256>>3]=1.0;i=i;return}function sQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13264>>3]=0.0;i=i;return}function tQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13288>>3]=255.0;i=i;return}function uQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13280>>3]=128.0;i=i;return}function vQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13272>>3]=0.0;i=i;return}function wQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1092>>2]=0;i=i;return}function xQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1096>>2]=128;i=i;return}function yQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1100>>2]=255;i=i;return}function zQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1104>>2]=155;i=i;return}function AQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1108>>2]=155;i=i;return}function BQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1112>>2]=155;i=i;return}function CQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1116>>2]=155;i=i;return}function DQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1120>>2]=155;i=i;return}function EQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1124>>2]=155;i=i;return}function FQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1128>>2]=155;i=i;return}function GQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1132>>2]=155;i=i;return}function HQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1136>>2]=155;i=i;return}function IQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1140>>2]=155;i=i;return}function JQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1144>>2]=155;i=i;return}function KQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1148>>2]=155;i=i;return}function LQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1152>>2]=155;i=i;return}function MQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1156>>2]=155;i=i;return}function NQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1160>>2]=155;i=i;return}function OQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1164>>2]=155;i=i;return}function PQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1168>>2]=155;i=i;return}function QQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1172>>2]=155;i=i;return}function RQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1176>>2]=255;i=i;return}function SQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1180>>2]=0;i=i;return}function TQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1184>>2]=0;i=i;return}function UQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1188>>2]=255;i=i;return}function VQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1192>>2]=0;i=i;return}function WQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1196>>2]=0;i=i;return}function XQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1200>>2]=255;i=i;return}function YQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1204>>2]=0;i=i;return}function ZQa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1208>>2]=0;i=i;return}function _Qa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21456>>3]=0.0;i=i;return}function $Qa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1212>>2]=155;i=i;return}function aRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1216>>2]=155;i=i;return}function bRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1220>>2]=155;i=i;return}function cRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21464>>3]=0.0;i=i;return}function dRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1224>>2]=155;i=i;return}function eRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1228>>2]=155;i=i;return}function fRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1232>>2]=155;i=i;return}function gRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1236>>2]=0;i=i;return}function hRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1240>>2]=128;i=i;return}function iRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1244>>2]=255;i=i;return}function jRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13296>>3]=0.0;i=i;return}function kRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13304>>3]=0.0;i=i;return}function lRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13312>>3]=0.0;i=i;return}function mRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13320>>3]=1.0;i=i;return}function nRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13328>>3]=0.0;i=i;return}function oRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13336>>3]=0.0;i=i;return}function pRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13344>>3]=0.0;i=i;return}function qRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13352>>3]=0.0;i=i;return}function rRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13360>>3]=0.0;i=i;return}function sRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13368>>3]=0.0;i=i;return}function tRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13376>>3]=0.0;i=i;return}function uRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13384>>3]=0.0;i=i;return}function vRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13392>>3]=0.0;i=i;return}function wRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13400>>3]=1.0;i=i;return}function xRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13408>>3]=0.0;i=i;return}function yRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13416>>3]=0.0;i=i;return}function zRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13424>>3]=0.0;i=i;return}function ARa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13432>>3]=0.0;i=i;return}function BRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13440>>3]=-1.0;i=i;return}function CRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13464>>3]=155.0;i=i;return}function DRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13456>>3]=155.0;i=i;return}function ERa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13448>>3]=155.0;i=i;return}function FRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1248>>2]=155;i=i;return}function GRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1252>>2]=155;i=i;return}function HRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1256>>2]=155;i=i;return}function IRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1260>>2]=155;i=i;return}function JRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1264>>2]=155;i=i;return}function KRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1268>>2]=155;i=i;return}function LRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1272>>2]=0;i=i;return}function MRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1276>>2]=128;i=i;return}function NRa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1280>>2]=255;i=i;return}function ORa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13472>>3]=0.0;i=i;return}function PRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13480>>3]=0.0;i=i;return}function QRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13488>>3]=0.0;i=i;return}function RRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13496>>3]=1.0;i=i;return}function SRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13504>>3]=0.0;i=i;return}function TRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13512>>3]=0.0;i=i;return}function URa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13520>>3]=0.0;i=i;return}function VRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13528>>3]=0.0;i=i;return}function WRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13536>>3]=0.0;i=i;return}function XRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13544>>3]=0.0;i=i;return}function YRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13552>>3]=0.0;i=i;return}function ZRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13560>>3]=0.0;i=i;return}function _Ra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13568>>3]=0.0;i=i;return}function $Ra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13576>>3]=1.0;i=i;return}function aSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13584>>3]=0.0;i=i;return}function bSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13592>>3]=0.0;i=i;return}function cSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13600>>3]=0.0;i=i;return}function dSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13608>>3]=0.0;i=i;return}function eSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13616>>3]=-1.0;i=i;return}function fSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13640>>3]=180.0;i=i;return}function gSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13632>>3]=180.0;i=i;return}function hSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13624>>3]=180.0;i=i;return}function iSa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1284>>2]=180;i=i;return}function jSa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1288>>2]=180;i=i;return}function kSa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1292>>2]=180;i=i;return}function lSa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13648>>3]=+h[b+24464>>3]+ +h[b+24480>>3]*-.5+-.002;i=i;return}function mSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13656>>3]=0.0;i=i;return}function nSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13664>>3]=0.0;i=i;return}function oSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13672>>3]=1.0;i=i;return}function pSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13680>>3]=0.0;i=i;return}function qSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13688>>3]=0.0;i=i;return}function rSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13696>>3]=0.0;i=i;return}function sSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13704>>3]=1.0;i=i;return}function tSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13712>>3]=0.0;i=i;return}function uSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13736>>3]=255.0;i=i;return}function vSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13728>>3]=128.0;i=i;return}function wSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13720>>3]=0.0;i=i;return}function xSa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1296>>2]=0;i=i;return}function ySa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1300>>2]=128;i=i;return}function zSa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1304>>2]=255;i=i;return}function ASa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21472>>3]=0.0;i=i;return}function BSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13744>>3]=0.0;i=i;return}function CSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13752>>3]=0.0;i=i;return}function DSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13760>>3]=0.0;i=i;return}function ESa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13768>>3]=0.0;i=i;return}function FSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13776>>3]=0.0;i=i;return}function GSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13784>>3]=0.0;i=i;return}function HSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13792>>3]=1.0;i=i;return}function ISa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13816>>3]=0.0;i=i;return}function JSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13840>>3]=0.0;i=i;return}function KSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13800>>3]=0.0;i=i;return}function LSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13824>>3]=1.0;i=i;return}function MSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13848>>3]=0.0;i=i;return}function NSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13808>>3]=0.0;i=i;return}function OSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13832>>3]=0.0;i=i;return}function PSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13856>>3]=1.0;i=i;return}function QSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13864>>3]=0.0;i=i;return}function RSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13872>>3]=0.0;i=i;return}function SSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13880>>3]=0.0;i=i;return}function TSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13888>>3]=0.0;i=i;return}function USa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13896>>3]=0.0;i=i;return}function VSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13904>>3]=0.0;i=i;return}function WSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13912>>3]=0.0;i=i;return}function XSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13920>>3]=0.0;i=i;return}function YSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13928>>3]=0.0;i=i;return}function ZSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13936>>3]=0.0;i=i;return}function _Sa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13944>>3]=0.0;i=i;return}function $Sa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13952>>3]=0.0;i=i;return}function aTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13960>>3]=1.0;i=i;return}function bTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13984>>3]=0.0;i=i;return}function cTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14008>>3]=0.0;i=i;return}function dTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13968>>3]=0.0;i=i;return}function eTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13992>>3]=1.0;i=i;return}function fTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14016>>3]=0.0;i=i;return}function gTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13976>>3]=0.0;i=i;return}function hTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14e3>>3]=0.0;i=i;return}function iTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14024>>3]=1.0;i=i;return}function jTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14032>>3]=0.0;i=i;return}function kTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14040>>3]=0.0;i=i;return}function lTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14048>>3]=0.0;i=i;return}function mTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14056>>3]=0.0;i=i;return}function nTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14064>>3]=0.0;i=i;return}function oTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14072>>3]=0.0;i=i;return}function pTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14080>>3]=0.0;i=i;return}function qTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14088>>3]=0.0;i=i;return}function rTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14096>>3]=0.0;i=i;return}function sTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14104>>3]=0.0;i=i;return}function tTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14112>>3]=0.0;i=i;return}function uTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14120>>3]=0.0;i=i;return}function vTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14128>>3]=1.0;i=i;return}function wTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14152>>3]=0.0;i=i;return}function xTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14176>>3]=0.0;i=i;return}function yTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14136>>3]=0.0;i=i;return}function zTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14160>>3]=1.0;i=i;return}function ATa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14184>>3]=0.0;i=i;return}function BTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14144>>3]=0.0;i=i;return}function CTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14168>>3]=0.0;i=i;return}function DTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14192>>3]=1.0;i=i;return}function ETa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14200>>3]=0.0;i=i;return}function FTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14208>>3]=0.0;i=i;return}function GTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14216>>3]=0.0;i=i;return}function HTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14224>>3]=0.0;i=i;return}function ITa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14232>>3]=0.0;i=i;return}function JTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14240>>3]=0.0;i=i;return}function KTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14248>>3]=0.0;i=i;return}function LTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14256>>3]=0.0;i=i;return}function MTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14264>>3]=0.0;i=i;return}function NTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14272>>3]=0.0;i=i;return}function OTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14280>>3]=0.0;i=i;return}function PTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14288>>3]=0.0;i=i;return}function QTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14296>>3]=1.0;i=i;return}function RTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14320>>3]=0.0;i=i;return}function STa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14344>>3]=0.0;i=i;return}function TTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14304>>3]=0.0;i=i;return}



function tO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19600>>3];k=j*j;l=+h[g+312>>3]*+h[g+20832>>3]-j*+h[g+7888>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4856|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4856|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,22664,22728,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4856|0;q=p;h[q>>3]=n;i=d;return}function uO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4888>>3]=+h[b+7944>>3]*+h[b+4856>>3];i=i;return}function vO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19600>>3];k=+h[g+320>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+15512|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+15512|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,22744,22736,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+15512|0;p=o;h[p>>3]=m;i=d;return}function wO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+240>>3]=-(+h[b+7944>>3]*+h[b+15512>>3]);i=i;return}function xO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19600>>3];k=+h[g+312>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+15504|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+15504|0;q=p;h[q>>3]=n;i=d;return}k=l/+$Lb(c[b+536>>2]|0,j,22744,22800,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+15504|0;q=p;h[q>>3]=n;i=d;return}function yO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4872>>3]=+h[b+320>>3]*+h[b+4864>>3]+(+h[b+7880>>3]*+h[b+15512>>3]+(-(+h[b+312>>3]*+h[b+4856>>3])- +h[b+7888>>3]*+h[b+15504>>3]));i=i;return}function zO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7976>>3]=+h[b+15504>>3]*+h[b+15064>>3]+ +h[b+15512>>3]*+h[b+15048>>3];i=i;return}function AO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7984>>3]=+h[b+15504>>3]*+h[b+15056>>3]+ +h[b+15512>>3]*+h[b+15040>>3];i=i;return}function BO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=+h[b+15504>>3]*+h[b+8040>>3]+ +h[b+15512>>3]*+h[b+8048>>3];i=i;return}function CO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+232>>3]=+h[b+7944>>3]*+h[b+15504>>3];i=i;return}function DO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7928>>3]=+h[b+240>>3]*+h[b+15064>>3]+ +h[b+232>>3]*+h[b+15048>>3];i=i;return}function EO(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+184>>3]=+h[b+10336>>3]+(+h[b+7928>>3]*+h[d+17728>>3]+(+h[b+7952>>3]*+h[d+17736>>3]+ +h[b+7976>>3]*+h[d+17744>>3]));i=i;return}function FO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7936>>3]=+h[b+240>>3]*+h[b+15056>>3]+ +h[b+232>>3]*+h[b+15040>>3];i=i;return}function GO(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+192>>3]=+h[b+10344>>3]+(+h[b+7936>>3]*+h[d+17728>>3]+(+h[b+7960>>3]*+h[d+17736>>3]+ +h[b+7984>>3]*+h[d+17744>>3]));i=i;return}function HO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+168>>3]=-(+h[b+232>>3]*+h[b+8048>>3])- +h[b+240>>3]*+h[b+8040>>3];i=i;return}function IO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19600>>3];k=+h[g+232>>3]*+h[g+8040>>3]- +h[g+240>>3]*+h[g+8048>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+224|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+224|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,22744,22808,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+224|0;p=o;h[p>>3]=m;i=d;return}function JO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+160>>3]=+h[b+7944>>3]*+h[b+16>>3]+ +h[b+224>>3];i=i;return}function KO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7920>>3]=+h[b+320>>3]*+h[b+15512>>3]- +h[b+312>>3]*+h[b+15504>>3];i=i;return}function LO(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+176>>3]=+h[b+10328>>3]+(+h[b+7920>>3]*+h[d+17728>>3]+ +h[b+7944>>3]*+h[d+17736>>3]);i=i;return}function MO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+152>>3]=+h[b+7920>>3]*+h[b+16>>3]+ +h[b+216>>3];i=i;return}function NO(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;mPb(a,0)|0;d=a+476|0;e=c[(c[d>>2]|0)+28>>2]|0;f=a+4|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+20488>>3]=+h[e>>3];h[a+6120>>3]=+h[e+8>>3];h[a+4216>>3]=+h[e+16>>3];h[a+4192>>3]=+h[e+24>>3];h[a+6112>>3]=+h[e+32>>3];h[a+6032>>3]=+h[e+40>>3];h[a+6072>>3]=+h[e+48>>3];h[a+5856>>3]=+h[e+56>>3];h[a+5896>>3]=+h[e+64>>3];h[a+5720>>3]=+h[e+72>>3];h[a+5504>>3]=+h[e+80>>3];h[a+5544>>3]=+h[e+88>>3];h[a+5328>>3]=+h[e+96>>3];h[a+5368>>3]=+h[e+104>>3];h[a+5176>>3]=+h[e+112>>3];h[a+5216>>3]=+h[e+120>>3];h[a+5392>>3]=+h[e+128>>3];h[a+5568>>3]=+h[e+136>>3];h[a+5744>>3]=+h[e+144>>3];h[a+5920>>3]=+h[e+152>>3];h[a+6096>>3]=+h[e+160>>3];h[a+6144>>3]=+h[e+168>>3];h[a+6e3>>3]=+h[e+176>>3];h[a+20776>>3]=+h[e+184>>3];e=c[(c[d>>2]|0)+28>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+20760>>3]=+h[e+192>>3];h[a+20744>>3]=+h[e+200>>3];h[a+20752>>3]=+h[e+208>>3];h[a+5976>>3]=+h[e+216>>3];h[a+6832>>3]=+h[e+224>>3];h[a+6792>>3]=+h[e+232>>3];h[a+5944>>3]=+h[e+240>>3];h[a+3488>>3]=+h[e+248>>3];h[a+4912>>3]=+h[e+256>>3];h[a+3792>>3]=+h[e+264>>3];h[a+3504>>3]=+h[e+272>>3];h[a+4904>>3]=+h[e+280>>3];h[a+3760>>3]=+h[e+288>>3];h[a+3800>>3]=+h[e+296>>3];h[a+3608>>3]=+h[e+304>>3];h[a+3768>>3]=+h[e+312>>3];h[a+3648>>3]=+h[e+320>>3];h[a+3640>>3]=+h[e+328>>3];h[a+3624>>3]=+h[e+336>>3];h[a+3704>>3]=+h[e+344>>3];h[a+3864>>3]=+h[e+352>>3];h[a+3656>>3]=+h[e+360>>3];h[a+20472>>3]=+h[e+368>>3];h[a+3840>>3]=+h[e+376>>3];e=c[(c[d>>2]|0)+28>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+3976>>3]=+h[e+384>>3];h[a+3912>>3]=+h[e+392>>3];h[a+3920>>3]=+h[e+400>>3];h[a+3872>>3]=+h[e+408>>3];h[a+3664>>3]=+h[e+416>>3];h[a+3696>>3]=+h[e+424>>3];h[a+3856>>3]=+h[e+432>>3];h[a+3848>>3]=+h[e+440>>3];h[a+3952>>3]=+h[e+448>>3];h[a+3688>>3]=+h[e+456>>3];h[a+3616>>3]=+h[e+464>>3];h[a+3776>>3]=+h[e+472>>3];h[a+3992>>3]=+h[e+480>>3];h[a+3896>>3]=+h[e+488>>3];h[a+3880>>3]=+h[e+496>>3];h[a+3888>>3]=+h[e+504>>3];h[a+3984>>3]=+h[e+512>>3];h[a+3904>>3]=+h[e+520>>3];h[a+3632>>3]=+h[e+528>>3];h[a+3784>>3]=+h[e+536>>3];h[a+3496>>3]=+h[e+544>>3];h[a+4896>>3]=+h[e+552>>3];h[a+5936>>3]=+h[e+560>>3];h[a+5968>>3]=+h[e+568>>3];e=c[(c[d>>2]|0)+28>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+6824>>3]=+h[e+576>>3];h[a+4456>>3]=+h[e+584>>3];h[a+20768>>3]=+h[e+592>>3];h[a+20784>>3]=+h[e+600>>3];h[a+5992>>3]=+h[e+608>>3];h[a+6024>>3]=+h[e+616>>3];h[a+6064>>3]=+h[e+624>>3];h[a+5824>>3]=+h[e+632>>3];h[a+20728>>3]=+h[e+640>>3];h[a+20712>>3]=+h[e+648>>3];h[a+20696>>3]=+h[e+656>>3];h[a+20704>>3]=+h[e+664>>3];h[a+5800>>3]=+h[e+672>>3];h[a+6232>>3]=+h[e+680>>3];h[a+6200>>3]=+h[e+688>>3];h[a+5768>>3]=+h[e+696>>3];h[a+2768>>3]=+h[e+704>>3];h[a+4936>>3]=+h[e+712>>3];h[a+3072>>3]=+h[e+720>>3];h[a+2784>>3]=+h[e+728>>3];h[a+4928>>3]=+h[e+736>>3];h[a+3040>>3]=+h[e+744>>3];h[a+3080>>3]=+h[e+752>>3];h[a+2888>>3]=+h[e+760>>3];e=c[(c[d>>2]|0)+28>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+3048>>3]=+h[e+768>>3];h[a+2928>>3]=+h[e+776>>3];h[a+2920>>3]=+h[e+784>>3];h[a+2904>>3]=+h[e+792>>3];h[a+2984>>3]=+h[e+800>>3];h[a+3144>>3]=+h[e+808>>3];h[a+2936>>3]=+h[e+816>>3];h[a+20312>>3]=+h[e+824>>3];h[a+3120>>3]=+h[e+832>>3];h[a+3256>>3]=+h[e+840>>3];h[a+3192>>3]=+h[e+848>>3];h[a+3200>>3]=+h[e+856>>3];h[a+3152>>3]=+h[e+864>>3];h[a+2944>>3]=+h[e+872>>3];h[a+2976>>3]=+h[e+880>>3];h[a+3136>>3]=+h[e+888>>3];h[a+3128>>3]=+h[e+896>>3];h[a+3232>>3]=+h[e+904>>3];h[a+2968>>3]=+h[e+912>>3];h[a+2896>>3]=+h[e+920>>3];h[a+3056>>3]=+h[e+928>>3];h[a+3272>>3]=+h[e+936>>3];h[a+3160>>3]=+h[e+944>>3];h[a+3168>>3]=+h[e+952>>3];e=c[(c[d>>2]|0)+28>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+3176>>3]=+h[e+960>>3];h[a+3264>>3]=+h[e+968>>3];h[a+3184>>3]=+h[e+976>>3];h[a+2912>>3]=+h[e+984>>3];h[a+3064>>3]=+h[e+992>>3];h[a+2776>>3]=+h[e+1e3>>3];h[a+4920>>3]=+h[e+1008>>3];h[a+5760>>3]=+h[e+1016>>3];h[a+5792>>3]=+h[e+1024>>3];h[a+6224>>3]=+h[e+1032>>3];h[a+4448>>3]=+h[e+1040>>3];h[a+20720>>3]=+h[e+1048>>3];h[a+20736>>3]=+h[e+1056>>3];h[a+5816>>3]=+h[e+1064>>3];h[a+5848>>3]=+h[e+1072>>3];h[a+5888>>3]=+h[e+1080>>3];h[a+5672>>3]=+h[e+1088>>3];h[a+5712>>3]=+h[e+1096>>3];h[a+20624>>3]=+h[e+1104>>3];h[a+20640>>3]=+h[e+1112>>3];h[a+5464>>3]=+h[e+1120>>3];h[a+5448>>3]=+h[e+1128>>3];h[a+6376>>3]=+h[e+1136>>3];h[a+6344>>3]=+h[e+1144>>3];e=c[(c[d>>2]|0)+28>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+6368>>3]=+h[e+1152>>3];h[a+4432>>3]=+h[e+1160>>3];h[a+20616>>3]=+h[e+1168>>3];h[a+20600>>3]=+h[e+1176>>3];h[a+20608>>3]=+h[e+1184>>3];h[a+20632>>3]=+h[e+1192>>3];h[a+5472>>3]=+h[e+1200>>3];h[a+5416>>3]=+h[e+1208>>3];h[a+1328>>3]=+h[e+1216>>3];h[a+4984>>3]=+h[e+1224>>3];h[a+1632>>3]=+h[e+1232>>3];h[a+1344>>3]=+h[e+1240>>3];h[a+4976>>3]=+h[e+1248>>3];h[a+1600>>3]=+h[e+1256>>3];h[a+1640>>3]=+h[e+1264>>3];h[a+1448>>3]=+h[e+1272>>3];h[a+1608>>3]=+h[e+1280>>3];h[a+1488>>3]=+h[e+1288>>3];h[a+1480>>3]=+h[e+1296>>3];h[a+1464>>3]=+h[e+1304>>3];h[a+1544>>3]=+h[e+1312>>3];h[a+1704>>3]=+h[e+1320>>3];h[a+1496>>3]=+h[e+1328>>3];h[a+19992>>3]=+h[e+1336>>3];e=c[(c[d>>2]|0)+28>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+1680>>3]=+h[e+1344>>3];h[a+1816>>3]=+h[e+1352>>3];h[a+2640>>3]=+h[e+1360>>3];h[a+1752>>3]=+h[e+1368>>3];h[a+1760>>3]=+h[e+1376>>3];h[a+1712>>3]=+h[e+1384>>3];h[a+1504>>3]=+h[e+1392>>3];h[a+1536>>3]=+h[e+1400>>3];h[a+1696>>3]=+h[e+1408>>3];h[a+1688>>3]=+h[e+1416>>3];h[a+1792>>3]=+h[e+1424>>3];h[a+1528>>3]=+h[e+1432>>3];h[a+1456>>3]=+h[e+1440>>3];h[a+1616>>3]=+h[e+1448>>3];h[a+1832>>3]=+h[e+1456>>3];h[a+1720>>3]=+h[e+1464>>3];h[a+1736>>3]=+h[e+1472>>3];h[a+1728>>3]=+h[e+1480>>3];h[a+1824>>3]=+h[e+1488>>3];h[a+1744>>3]=+h[e+1496>>3];h[a+1472>>3]=+h[e+1504>>3];h[a+1624>>3]=+h[e+1512>>3];h[a+1336>>3]=+h[e+1520>>3];h[a+4968>>3]=+h[e+1528>>3];e=c[(c[d>>2]|0)+28>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+5408>>3]=+h[e+1536>>3];h[a+5440>>3]=+h[e+1544>>3];h[a+5496>>3]=+h[e+1552>>3];h[a+5536>>3]=+h[e+1560>>3];h[a+5296>>3]=+h[e+1568>>3];h[a+20584>>3]=+h[e+1576>>3];h[a+20568>>3]=+h[e+1584>>3];h[a+20552>>3]=+h[e+1592>>3];h[a+20560>>3]=+h[e+1600>>3];h[a+5272>>3]=+h[e+1608>>3];h[a+6448>>3]=+h[e+1616>>3];h[a+6416>>3]=+h[e+1624>>3];h[a+5240>>3]=+h[e+1632>>3];h[a+608>>3]=+h[e+1640>>3];h[a+5008>>3]=+h[e+1648>>3];h[a+912>>3]=+h[e+1656>>3];h[a+624>>3]=+h[e+1664>>3];h[a+5e3>>3]=+h[e+1672>>3];h[a+880>>3]=+h[e+1680>>3];h[a+920>>3]=+h[e+1688>>3];h[a+728>>3]=+h[e+1696>>3];h[a+888>>3]=+h[e+1704>>3];h[a+768>>3]=+h[e+1712>>3];h[a+760>>3]=+h[e+1720>>3];e=c[(c[d>>2]|0)+28>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+744>>3]=+h[e+1728>>3];h[a+824>>3]=+h[e+1736>>3];h[a+984>>3]=+h[e+1744>>3];h[a+776>>3]=+h[e+1752>>3];h[a+19832>>3]=+h[e+1760>>3];h[a+960>>3]=+h[e+1768>>3];h[a+1096>>3]=+h[e+1776>>3];h[a+1032>>3]=+h[e+1784>>3];h[a+1040>>3]=+h[e+1792>>3];h[a+992>>3]=+h[e+1800>>3];h[a+784>>3]=+h[e+1808>>3];h[a+816>>3]=+h[e+1816>>3];h[a+976>>3]=+h[e+1824>>3];h[a+968>>3]=+h[e+1832>>3];h[a+1072>>3]=+h[e+1840>>3];h[a+808>>3]=+h[e+1848>>3];h[a+736>>3]=+h[e+1856>>3];h[a+896>>3]=+h[e+1864>>3];h[a+1112>>3]=+h[e+1872>>3];h[a+1016>>3]=+h[e+1880>>3];h[a+1008>>3]=+h[e+1888>>3];h[a+1e3>>3]=+h[e+1896>>3];h[a+1104>>3]=+h[e+1904>>3];h[a+1024>>3]=+h[e+1912>>3];e=c[(c[d>>2]|0)+28>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+752>>3]=+h[e+1920>>3];h[a+904>>3]=+h[e+1928>>3];h[a+616>>3]=+h[e+1936>>3];h[a+4992>>3]=+h[e+1944>>3];h[a+5232>>3]=+h[e+1952>>3];h[a+5264>>3]=+h[e+1960>>3];h[a+6440>>3]=+h[e+1968>>3];h[a+4424>>3]=+h[e+1976>>3];h[a+20576>>3]=+h[e+1984>>3];h[a+20592>>3]=+h[e+1992>>3];h[a+5288>>3]=+h[e+2e3>>3];h[a+5320>>3]=+h[e+2008>>3];h[a+5360>>3]=+h[e+2016>>3];h[a+5144>>3]=+h[e+2024>>3];h[a+20536>>3]=+h[e+2032>>3];h[a+20520>>3]=+h[e+2040>>3];h[a+20504>>3]=+h[e+2048>>3];h[a+20512>>3]=+h[e+2056>>3];h[a+5120>>3]=+h[e+2064>>3];h[a+6520>>3]=+h[e+2072>>3];h[a+6488>>3]=+h[e+2080>>3];h[a+5088>>3]=+h[e+2088>>3];h[a+128>>3]=+h[e+2096>>3];h[a+5032>>3]=+h[e+2104>>3];e=c[(c[d>>2]|0)+28>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+144>>3]=+h[e+2112>>3];h[a+5024>>3]=+h[e+2120>>3];h[a+400>>3]=+h[e+2128>>3];h[a+440>>3]=+h[e+2136>>3];h[a+264>>3]=+h[e+2144>>3];h[a+19672>>3]=+h[e+2152>>3];h[a+296>>3]=+h[e+2160>>3];h[a+344>>3]=+h[e+2168>>3];h[a+480>>3]=+h[e+2176>>3];h[a+248>>3]=+h[e+2184>>3];h[a+408>>3]=+h[e+2192>>3];h[a+520>>3]=+h[e+2200>>3];h[a+1168>>3]=+h[e+2208>>3];h[a+1888>>3]=+h[e+2216>>3];h[a+1120>>3]=+h[e+2224>>3];h[a+2648>>3]=+h[e+2232>>3];h[a+1928>>3]=+h[e+2240>>3];h[a+1208>>3]=+h[e+2248>>3];h[a+504>>3]=+h[e+2256>>3];h[a+288>>3]=+h[e+2264>>3];h[a+280>>3]=+h[e+2272>>3];h[a+424>>3]=+h[e+2280>>3];h[a+136>>3]=+h[e+2288>>3];h[a+5016>>3]=+h[e+2296>>3];e=c[(c[d>>2]|0)+28>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+5080>>3]=+h[e+2304>>3];h[a+5112>>3]=+h[e+2312>>3];h[a+6512>>3]=+h[e+2320>>3];h[a+4416>>3]=+h[e+2328>>3];h[a+20528>>3]=+h[e+2336>>3];h[a+20544>>3]=+h[e+2344>>3];h[a+5136>>3]=+h[e+2352>>3];h[a+5168>>3]=+h[e+2360>>3];h[a+5208>>3]=+h[e+2368>>3];h[a+5384>>3]=+h[e+2376>>3];h[a+5560>>3]=+h[e+2384>>3];h[a+5736>>3]=+h[e+2392>>3];h[a+5912>>3]=+h[e+2400>>3];h[a+6088>>3]=+h[e+2408>>3];h[a+6136>>3]=+h[e+2416>>3];h[a+19512>>3]=+h[e+2424>>3];h[a+20664>>3]=+h[e+2432>>3];h[a+20648>>3]=+h[e+2440>>3];h[a+20656>>3]=+h[e+2448>>3];h[a+20680>>3]=+h[e+2456>>3];h[a+5648>>3]=+h[e+2464>>3];h[a+5680>>3]=+h[e+2472>>3];h[a+5640>>3]=+h[e+2480>>3];h[a+20688>>3]=+h[e+2488>>3];e=c[(c[d>>2]|0)+28>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+20672>>3]=+h[e+2496>>3];h[a+5584>>3]=+h[e+2504>>3];h[a+5616>>3]=+h[e+2512>>3];h[a+6296>>3]=+h[e+2520>>3];h[a+4440>>3]=+h[e+2528>>3];h[a+6272>>3]=+h[e+2536>>3];h[a+6304>>3]=+h[e+2544>>3];h[a+5624>>3]=+h[e+2552>>3];h[a+2352>>3]=+h[e+2560>>3];h[a+2048>>3]=+h[e+2568>>3];h[a+4960>>3]=+h[e+2576>>3];h[a+2328>>3]=+h[e+2584>>3];h[a+2176>>3]=+h[e+2592>>3];h[a+2168>>3]=+h[e+2600>>3];h[a+2320>>3]=+h[e+2608>>3];h[a+2208>>3]=+h[e+2616>>3];h[a+2200>>3]=+h[e+2624>>3];h[a+2360>>3]=+h[e+2632>>3];h[a+2056>>3]=+h[e+2640>>3];h[a+4944>>3]=+h[e+2648>>3];h[a+5592>>3]=+h[e+2656>>3];h[a+4952>>3]=+h[e+2664>>3];h[a+2064>>3]=+h[e+2672>>3];h[a+2192>>3]=+h[e+2680>>3];e=c[(c[d>>2]|0)+28>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+2344>>3]=+h[e+2688>>3];h[a+2336>>3]=+h[e+2696>>3];h[a+2256>>3]=+h[e+2704>>3];h[a+2248>>3]=+h[e+2712>>3];h[a+2184>>3]=+h[e+2720>>3];h[a+2264>>3]=+h[e+2728>>3];h[a+2400>>3]=+h[e+2736>>3];h[a+2536>>3]=+h[e+2744>>3];h[a+4264>>3]=+h[e+2752>>3];h[a+4088>>3]=+h[e+2760>>3];h[a+3368>>3]=+h[e+2768>>3];h[a+2480>>3]=+h[e+2776>>3];h[a+2424>>3]=+h[e+2784>>3];h[a+2216>>3]=+h[e+2792>>3];h[a+2416>>3]=+h[e+2800>>3];h[a+2408>>3]=+h[e+2808>>3];h[a+2552>>3]=+h[e+2816>>3];h[a+2448>>3]=+h[e+2824>>3];h[a+2440>>3]=+h[e+2832>>3];h[a+2456>>3]=+h[e+2840>>3];h[a+2544>>3]=+h[e+2848>>3];h[a+2464>>3]=+h[e+2856>>3];h[a+2512>>3]=+h[e+2864>>3];h[a+20152>>3]=+h[e+2872>>3];e=c[(c[d>>2]|0)+28>>2]|0;d=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[d+2224>>3]=+h[e+2880>>3];h[d+2432>>3]=+h[e+2888>>3];h[d+2472>>3]=+h[e+2896>>3];h[d+3360>>3]=+h[e+2904>>3];h[d+4080>>3]=+h[e+2912>>3];h[d+4272>>3]=+h[e+2920>>3];h[d+4240>>3]=+h[e+2928>>3];h[d+4e3>>3]=+h[e+2936>>3];h[d+4048>>3]=+h[e+2944>>3];h[d+3280>>3]=+h[e+2952>>3];h[d+3328>>3]=+h[e+2960>>3];h[d+2560>>3]=+h[e+2968>>3];h[d+2608>>3]=+h[e+2976>>3];h[d+1840>>3]=+h[e+2984>>3];h[d+1920>>3]=+h[e+2992>>3];h[d+1200>>3]=+h[e+3e3>>3];h[d+512>>3]=+h[e+3008>>3];h[d+304>>3]=+h[e+3016>>3];h[d+336>>3]=+h[e+3024>>3];h[d+256>>3]=+h[e+3032>>3];h[d+416>>3]=+h[e+3040>>3];h[d+432>>3]=+h[e+3048>>3];i=b;return}function OO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+48>>3]=+h[b+19512>>3];i=i;return}function PO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4200>>3]=-(+h[(c[a+416>>2]|0)+384>>3]*+h[b+6120>>3]);i=i;return}function QO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4320>>3]=+h[b+4272>>3]- +h[b+6112>>3];i=i;return}function RO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4208>>3]=+h[(c[a+416>>2]|0)+384>>3]*+h[b+6112>>3];i=i;return}function SO(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+6800>>3]=+h[d+20232>>3]*((+h[b+6824>>3]+ +h[d+18840>>3])*.4999999999999999+ +h[b+6832>>3]*.8660254037844387);i=i;return}function TO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3432>>3]=+h[(c[a+416>>2]|0)+3400>>3]*+h[b+6800>>3];i=i;return}function UO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3456>>3]=+h[(c[a+416>>2]|0)+3280>>3]*+h[b+6800>>3]- +h[b+3432>>3];i=i;return}function VO(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3424>>3]=+h[b+3416>>3]*+h[d+6792>>3]- +h[b+3408>>3]*+h[d+6800>>3];i=i;return}function WO(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3448>>3]=+h[b+3296>>3]*+h[d+6792>>3]+(-(+h[b+3288>>3]*+h[d+6800>>3])- +h[d+3424>>3]);i=i;return}function XO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3440>>3]=-(+h[(c[a+416>>2]|0)+3400>>3]*+h[b+6792>>3]);i=i;return}function YO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3464>>3]=-+h[b+3440>>3]- +h[(c[a+416>>2]|0)+3280>>3]*+h[b+6792>>3];i=i;return}function ZO(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3664>>3];e=+h[b+3656>>3];h[b+3712>>3]=(+h[b+14824>>3]*d+ +h[b+14808>>3]*e)*.4999999999999999+(d*+h[b+14816>>3]+e*+h[b+14800>>3])*.8660254037844387;i=i;return}function _O(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3824>>3]=+h[b+3712>>3]+ +h[b+6800>>3];i=i;return}function $O(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15432>>3]=+h[b+3712>>3]*-.1;i=i;return}function aP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3736>>3]=-+h[b+15432>>3]- +h[b+3448>>3];i=i;return}function bP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3816>>3]=+h[b+16320>>3]*+h[b+3824>>3]- +h[b+3736>>3];i=i;return}function cP(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3664>>3];e=+h[b+3656>>3];h[b+3720>>3]=(+h[b+14824>>3]*d+ +h[b+14808>>3]*e)*.8660254037844387+(d*+h[b+14816>>3]+e*+h[b+14800>>3])*-.4999999999999999;i=i;return}function dP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3832>>3]=+h[b+3720>>3]+ +h[b+6792>>3];i=i;return}function eP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3968>>3]=+h[b+3832>>3]*-.4999999999999999+ +h[b+3824>>3]*.8660254037844387;i=i;return}function fP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3960>>3]=+h[b+3832>>3]*.8660254037844387+ +h[b+3824>>3]*.4999999999999999;i=i;return}function gP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15448>>3]=+h[b+3952>>3]*.1;i=i;return}function hP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3728>>3]=-+h[b+15448>>3]- +h[b+3464>>3];i=i;return}function iP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3808>>3]=-+h[b+3728>>3]- +h[b+16320>>3]*+h[b+3952>>3];i=i;return}function jP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=+h[f+1024>>3];j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[a+3968>>3];m=+h[f+1032>>3];n=+h[a+3960>>3];o=+h[a+3816>>3]+(g*l-m*n);p=+h[a+3952>>3];q=+h[f+1016>>3];r=+h[a+3456>>3];s=+h[a+3808>>3];a=d;h[k>>3]=m*p-l*q-(r*-.8660254037844387+s*-.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=n*q-g*p-(r*.4999999999999999+s*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];UMb(e,3,o,d);RMb(e,(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3928|0);i=b;return}function kP(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+6208>>3]=+h[d+21264>>3]*((+h[b+6224>>3]+ +h[d+18840>>3])*-.4999999999999999+ +h[b+6232>>3]*.8660254037844387);i=i;return}function lP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2712>>3]=+h[(c[a+416>>2]|0)+6416>>3]*+h[b+6208>>3];i=i;return}function mP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2736>>3]=+h[(c[a+416>>2]|0)+6296>>3]*+h[b+6208>>3]- +h[b+2712>>3];i=i;return}function nP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2704>>3]=+h[b+6432>>3]*+h[d+6200>>3]- +h[b+6424>>3]*+h[d+6208>>3];i=i;return}function oP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2728>>3]=+h[b+6312>>3]*+h[d+6200>>3]+(-(+h[b+6304>>3]*+h[d+6208>>3])- +h[d+2704>>3]);i=i;return}function pP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2720>>3]=-(+h[(c[a+416>>2]|0)+6416>>3]*+h[b+6200>>3]);i=i;return}function qP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2744>>3]=-+h[b+2720>>3]- +h[(c[a+416>>2]|0)+6296>>3]*+h[b+6200>>3];i=i;return}function rP(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2944>>3];e=+h[b+2936>>3];h[b+2992>>3]=(+h[b+14872>>3]*d+ +h[b+14856>>3]*e)*-.4999999999999999+(d*+h[b+14864>>3]+e*+h[b+14848>>3])*.8660254037844387;i=i;return}function sP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3104>>3]=+h[b+2992>>3]+ +h[b+6208>>3];i=i;return}function tP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15392>>3]=+h[b+2992>>3]*-.1;i=i;return}function uP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3016>>3]=-+h[b+15392>>3]- +h[b+2728>>3];i=i;return}function vP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3096>>3]=+h[b+16552>>3]*+h[b+3104>>3]- +h[b+3016>>3];i=i;return}function wP(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2944>>3];e=+h[b+2936>>3];h[b+3e3>>3]=(+h[b+14872>>3]*d+ +h[b+14856>>3]*e)*.8660254037844387+(d*+h[b+14864>>3]+e*+h[b+14848>>3])*.4999999999999999;i=i;return}function xP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3112>>3]=+h[b+3e3>>3]+ +h[b+6200>>3];i=i;return}function yP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3248>>3]=+h[b+3112>>3]*.4999999999999999+ +h[b+3104>>3]*.8660254037844387;i=i;return}function zP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3240>>3]=+h[b+3112>>3]*.8660254037844387+ +h[b+3104>>3]*-.4999999999999999;i=i;return}function AP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15408>>3]=+h[b+3232>>3]*.1;i=i;return}function BP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3008>>3]=-+h[b+15408>>3]- +h[b+2744>>3];i=i;return}function CP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3088>>3]=-+h[b+3008>>3]- +h[b+16552>>3]*+h[b+3232>>3];i=i;return}function DP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=+h[f+4040>>3];j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[a+3248>>3];m=+h[f+4048>>3];n=+h[a+3240>>3];o=+h[a+3096>>3]+(g*l-m*n);p=+h[a+3232>>3];q=+h[f+4032>>3];r=+h[a+2736>>3];s=+h[a+3088>>3];a=d;h[k>>3]=m*p-l*q-(r*-.8660254037844387+s*.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=n*q-g*p-(r*-.4999999999999999+s*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];UMb(e,3,o,d);RMb(e,(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3208|0);i=b;return}function EP(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+6352>>3]=+h[d+23328>>3]*((+h[b+6368>>3]+ +h[d+18840>>3])*-.4999999999999999+ +h[b+6376>>3]*.8660254037844387);i=i;return}function FP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1272>>3]=+h[(c[a+416>>2]|0)+12448>>3]*+h[b+6352>>3];i=i;return}function GP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1296>>3]=+h[(c[a+416>>2]|0)+12328>>3]*+h[b+6352>>3]- +h[b+1272>>3];i=i;return}function HP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1280>>3]=-(+h[(c[a+416>>2]|0)+12448>>3]*+h[b+6344>>3]);i=i;return}function IP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1304>>3]=-+h[b+1280>>3]- +h[(c[a+416>>2]|0)+12328>>3]*+h[b+6344>>3];i=i;return}function JP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1264>>3]=+h[b+12464>>3]*+h[d+6344>>3]- +h[b+12456>>3]*+h[d+6352>>3];i=i;return}function KP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1288>>3]=+h[b+12344>>3]*+h[d+6344>>3]+(-(+h[b+12336>>3]*+h[d+6352>>3])- +h[d+1264>>3]);i=i;return}function LP(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1504>>3];e=+h[b+1496>>3];h[b+1552>>3]=(+h[b+14968>>3]*d+ +h[b+14952>>3]*e)*-.4999999999999999+(d*+h[b+14960>>3]+e*+h[b+14944>>3])*.8660254037844387;i=i;return}function MP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1664>>3]=+h[b+1552>>3]+ +h[b+6352>>3];i=i;return}function NP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15312>>3]=+h[b+1552>>3]*-.1;i=i;return}function OP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1576>>3]=-+h[b+15312>>3]- +h[b+1288>>3];i=i;return}function PP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1656>>3]=+h[b+17016>>3]*+h[b+1664>>3]- +h[b+1576>>3];i=i;return}function QP(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1504>>3];e=+h[b+1496>>3];h[b+1560>>3]=(+h[b+14968>>3]*d+ +h[b+14952>>3]*e)*.8660254037844387+(d*+h[b+14960>>3]+e*+h[b+14944>>3])*.4999999999999999;i=i;return}function RP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1672>>3]=+h[b+1560>>3]+ +h[b+6344>>3];i=i;return}function SP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1808>>3]=+h[b+1672>>3]*.4999999999999999+ +h[b+1664>>3]*.8660254037844387;i=i;return}function TP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1800>>3]=+h[b+1672>>3]*.8660254037844387+ +h[b+1664>>3]*-.4999999999999999;i=i;return}function UP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15328>>3]=+h[b+1792>>3]*.1;i=i;return}function VP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1568>>3]=-+h[b+15328>>3]- +h[b+1304>>3];i=i;return}function WP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1648>>3]=-+h[b+1568>>3]- +h[b+17016>>3]*+h[b+1792>>3];i=i;return}function XP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=+h[f+10072>>3];j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[a+1808>>3];m=+h[f+10080>>3];n=+h[a+1800>>3];o=+h[a+1656>>3]+(g*l-m*n);p=+h[a+1792>>3];q=+h[f+10064>>3];r=+h[a+1296>>3];s=+h[a+1648>>3];a=d;h[k>>3]=m*p-l*q-(r*-.8660254037844387+s*.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=n*q-g*p-(r*-.4999999999999999+s*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];UMb(e,3,o,d);RMb(e,(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1768|0);i=b;return}function YP(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+6424>>3]=+h[d+24360>>3]*((+h[b+6440>>3]+ +h[d+18840>>3])*.4999999999999999+ +h[b+6448>>3]*.8660254037844387);i=i;return}function ZP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=+h[(c[a+416>>2]|0)+15464>>3]*+h[b+6424>>3];i=i;return}function _P(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+576>>3]=+h[(c[a+416>>2]|0)+15344>>3]*+h[b+6424>>3]- +h[b+552>>3];i=i;return}function $P(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+544>>3]=+h[b+15480>>3]*+h[d+6416>>3]- +h[b+15472>>3]*+h[d+6424>>3];i=i;return}function aQ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+568>>3]=+h[b+15360>>3]*+h[d+6416>>3]+(-(+h[b+15352>>3]*+h[d+6424>>3])- +h[d+544>>3]);i=i;return}function bQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+560>>3]=-(+h[(c[a+416>>2]|0)+15464>>3]*+h[b+6416>>3]);i=i;return}function cQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+584>>3]=-+h[b+560>>3]- +h[(c[a+416>>2]|0)+15344>>3]*+h[b+6416>>3];i=i;return}function dQ(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+784>>3];e=+h[b+776>>3];h[b+832>>3]=(+h[b+15016>>3]*d+ +h[b+15e3>>3]*e)*.4999999999999999+(d*+h[b+15008>>3]+e*+h[b+14992>>3])*.8660254037844387;i=i;return}function eQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+944>>3]=+h[b+832>>3]+ +h[b+6424>>3];i=i;return}function fQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15272>>3]=+h[b+832>>3]*-.1;i=i;return}function gQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+856>>3]=-+h[b+15272>>3]- +h[b+568>>3];i=i;return}function hQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+936>>3]=+h[b+17248>>3]*+h[b+944>>3]- +h[b+856>>3];i=i;return}function iQ(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+784>>3];e=+h[b+776>>3];h[b+840>>3]=(+h[b+15016>>3]*d+ +h[b+15e3>>3]*e)*.8660254037844387+(d*+h[b+15008>>3]+e*+h[b+14992>>3])*-.4999999999999999;i=i;return}function jQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+952>>3]=+h[b+840>>3]+ +h[b+6416>>3];i=i;return}function kQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1088>>3]=+h[b+952>>3]*-.4999999999999999+ +h[b+944>>3]*.8660254037844387;i=i;return}function lQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1080>>3]=+h[b+952>>3]*.8660254037844387+ +h[b+944>>3]*.4999999999999999;i=i;return}function mQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15288>>3]=+h[b+1072>>3]*.1;i=i;return}function nQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+848>>3]=-+h[b+15288>>3]- +h[b+584>>3];i=i;return}function oQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+928>>3]=-+h[b+848>>3]- +h[b+17248>>3]*+h[b+1072>>3];i=i;return}function pQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=+h[f+13088>>3];j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[a+1088>>3];m=+h[f+13096>>3];n=+h[a+1080>>3];o=+h[a+936>>3]+(g*l-m*n);p=+h[a+1072>>3];q=+h[f+13080>>3];r=+h[a+576>>3];s=+h[a+928>>3];a=d;h[k>>3]=m*p-l*q-(r*-.8660254037844387+s*-.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=n*q-g*p-(r*.4999999999999999+s*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];UMb(e,3,o,d);RMb(e,(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1048|0);i=b;return}function qQ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+6496>>3]=+h[d+25392>>3]*((+h[b+6512>>3]+ +h[d+18840>>3])*-.4999999999999999+ +h[b+6520>>3]*.8660254037844387);i=i;return}function rQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+72>>3]=+h[(c[a+416>>2]|0)+18480>>3]*+h[b+6496>>3];i=i;return}function sQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+96>>3]=+h[(c[a+416>>2]|0)+18360>>3]*+h[b+6496>>3]- +h[b+72>>3];i=i;return}function tQ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+64>>3]=+h[b+18496>>3]*+h[d+6488>>3]- +h[b+18488>>3]*+h[d+6496>>3];i=i;return}function uQ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+88>>3]=+h[b+18376>>3]*+h[d+6488>>3]+(-(+h[b+18368>>3]*+h[d+6496>>3])- +h[d+64>>3]);i=i;return}function vQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+80>>3]=-(+h[(c[a+416>>2]|0)+18480>>3]*+h[b+6488>>3]);i=i;return}function wQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+104>>3]=-+h[b+80>>3]- +h[(c[a+416>>2]|0)+18360>>3]*+h[b+6488>>3];i=i;return}function xQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+272>>3]=+h[b+7920>>3]*+h[b+424>>3]+ +h[b+7944>>3]*+h[b+432>>3];i=i;return}function yQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+7920>>3];k=+h[(c[b+416>>2]|0)+24976>>3];l=+h[g+15504>>3]*+h[g+256>>3]+ +h[g+15512>>3]*+h[g+264>>3];if(k!=0.0){m=g;n=l/k;o=j*n;p=m;q=p+328|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j*n;p=m;q=p+328|0;r=q;h[r>>3]=o;i=d;return}s=l/+$Lb(c[b+536>>2]|0,k,22080,22816,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+328|0;r=q;h[r>>3]=o;i=d;return}function zQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1240>>3]=+h[b+7944>>3]*+h[b+19672>>3]- +h[b+328>>3];i=i;return}function AQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+496>>3]=-(+h[b+10256>>3]*+h[b+304>>3])- +h[b+264>>3]- +h[b+208>>3]*+h[b+1240>>3];i=i;return}function BQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1192>>3]=+h[b+272>>3]- +h[b+1240>>3];i=i;return}function CQ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+536>>3]=+h[b+16e3>>3]*+h[d+512>>3]+(+h[b+16008>>3]*+h[d+1192>>3]+ +h[d+496>>3]);i=i;return}function DQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1912>>3]=+h[b+1192>>3]- +h[b+1024>>3];i=i;return}function EQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2632>>3]=+h[b+1912>>3]- +h[b+1744>>3];i=i;return}function FQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1960>>3]=+h[b+1240>>3]- +h[b+1072>>3];i=i;return}function GQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2680>>3]=+h[b+1960>>3]- +h[b+1792>>3];i=i;return}function HQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15248>>3]=+h[b+1240>>3]*-.1;i=i;return}function IQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+368>>3]=-+h[b+15248>>3]- +h[b+104>>3];i=i;return}function JQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+448>>3]=+h[b+17480>>3]*+h[b+1240>>3]- +h[b+368>>3];i=i;return}function KQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+488>>3]=+h[b+10256>>3]*+h[b+296>>3]+(+h[b+200>>3]*+h[b+1240>>3]- +h[b+256>>3]);i=i;return}function LQ(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+304>>3];e=+h[b+296>>3];h[b+352>>3]=(+h[b+15064>>3]*d+ +h[b+15048>>3]*e)*-.4999999999999999+(d*+h[b+15056>>3]+e*+h[b+15040>>3])*.8660254037844387;i=i;return}function MQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+464>>3]=+h[b+352>>3]+ +h[b+6496>>3];i=i;return}function NQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15232>>3]=+h[b+352>>3]*-.1;i=i;return}function OQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+376>>3]=-+h[b+15232>>3]- +h[b+88>>3];i=i;return}function PQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+456>>3]=+h[b+17480>>3]*+h[b+464>>3]- +h[b+376>>3];i=i;return}function QQ(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+304>>3];e=+h[b+296>>3];h[b+360>>3]=(+h[b+15064>>3]*d+ +h[b+15048>>3]*e)*.8660254037844387+(d*+h[b+15056>>3]+e*+h[b+15040>>3])*.4999999999999999;i=i;return}function RQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+472>>3]=+h[b+360>>3]+ +h[b+6488>>3];i=i;return}function SQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1256>>3]=+h[b+472>>3]*-.4999999999999999+ +h[b+464>>3]*-.8660254037844387;i=i;return}function TQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1976>>3]=+h[b+1256>>3]- +h[b+1088>>3];i=i;return}function UQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2696>>3]=+h[b+1976>>3]- +h[b+1808>>3];i=i;return}function VQ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1224>>3]=+h[b+96>>3]*-.8660254037844387+(+h[b+448>>3]*.4999999999999999+(+h[d+16112>>3]*+h[b+1240>>3]- +h[d+16096>>3]*+h[b+1256>>3]));i=i;return}function WQ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1152>>3]=+h[b+12792>>3]*+h[d+1256>>3]+(-(+h[b+12808>>3]*+h[d+1240>>3])- +h[d+1224>>3]);i=i;return}function XQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1944>>3]=-+h[b+1152>>3]- +h[b+1056>>3];i=i;return}function YQ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1872>>3]=+h[b+9776>>3]*+h[d+1976>>3]+(-(+h[b+9792>>3]*+h[d+1960>>3])- +h[d+1944>>3]);i=i;return}function ZQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2664>>3]=-+h[b+1872>>3]- +h[b+1776>>3];i=i;return}function _Q(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2592>>3]=+h[b+6760>>3]*+h[d+2696>>3]+(-(+h[b+6776>>3]*+h[d+2680>>3])- +h[d+2664>>3]);i=i;return}function $Q(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1248>>3]=+h[b+472>>3]*-.8660254037844387+ +h[b+464>>3]*.4999999999999999;i=i;return}function aR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1216>>3]=+h[b+16104>>3]*+h[d+1256>>3]- +h[b+16112>>3]*+h[d+1248>>3]- +h[d+456>>3];i=i;return}function bR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1144>>3]=+h[b+12808>>3]*+h[d+1248>>3]+(-(+h[b+12800>>3]*+h[d+1256>>3])- +h[d+1216>>3]);i=i;return}function cR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1936>>3]=-+h[b+1144>>3]- +h[b+1048>>3];i=i;return}function dR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1968>>3]=+h[b+1248>>3]- +h[b+1080>>3];i=i;return}function eR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2688>>3]=+h[b+1968>>3]- +h[b+1800>>3];i=i;return}function fR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1864>>3]=+h[b+9792>>3]*+h[d+1968>>3]+(-(+h[b+9784>>3]*+h[d+1976>>3])- +h[d+1936>>3]);i=i;return}function gR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2656>>3]=-+h[b+1864>>3]- +h[b+1768>>3];i=i;return}function hR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2584>>3]=+h[b+6776>>3]*+h[d+2688>>3]+(-(+h[b+6768>>3]*+h[d+2696>>3])- +h[d+2656>>3]);i=i;return}function iR(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1232>>3]=+h[b+96>>3]*-.4999999999999999+(+h[b+448>>3]*-.8660254037844387+(+h[d+16096>>3]*+h[b+1248>>3]- +h[d+16104>>3]*+h[b+1240>>3]));i=i;return}function jR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1160>>3]=+h[b+12800>>3]*+h[d+1240>>3]+(-(+h[b+12792>>3]*+h[d+1248>>3])- +h[d+1232>>3]);i=i;return}function kR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1952>>3]=-+h[b+1160>>3]- +h[b+1064>>3];i=i;return}function lR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1880>>3]=+h[b+9784>>3]*+h[d+1960>>3]+(-(+h[b+9776>>3]*+h[d+1968>>3])- +h[d+1952>>3]);i=i;return}function mR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2672>>3]=-+h[b+1880>>3]- +h[b+1784>>3];i=i;return}function nR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2600>>3]=+h[b+6768>>3]*+h[d+2680>>3]+(-(+h[b+6760>>3]*+h[d+2688>>3])- +h[d+2672>>3]);i=i;return}function oR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+528>>3]=+h[d+488>>3]- +h[b+16e3>>3]*+h[d+504>>3]- +h[b+16016>>3]*+h[d+1192>>3];i=i;return}function pR(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1184>>3]=+h[b+528>>3]*.4999999999999999+(+h[b+536>>3]*-.8660254037844387+(+h[d+16480>>3]*+h[b+1200>>3]- +h[d+16488>>3]*+h[b+1192>>3]));i=i;return}function qR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1136>>3]=+h[b+12896>>3]*+h[d+1192>>3]+(-(+h[b+12888>>3]*+h[d+1200>>3])- +h[d+1184>>3]);i=i;return}function rR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1904>>3]=-+h[b+1136>>3]- +h[b+1016>>3];i=i;return}function sR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1856>>3]=+h[b+9880>>3]*+h[d+1912>>3]+(-(+h[b+9872>>3]*+h[d+1920>>3])- +h[d+1904>>3]);i=i;return}function tR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2624>>3]=-+h[b+1856>>3]- +h[b+1736>>3];i=i;return}function uR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2576>>3]=+h[b+6864>>3]*+h[d+2632>>3]+(-(+h[b+6856>>3]*+h[d+2640>>3])- +h[d+2624>>3]);i=i;return}function vR(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1176>>3]=+h[b+528>>3]*-.8660254037844387+(+h[b+536>>3]*-.4999999999999999+(+h[d+16496>>3]*+h[b+1192>>3]- +h[d+16480>>3]*+h[b+1208>>3]));i=i;return}function wR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1128>>3]=+h[b+12888>>3]*+h[d+1208>>3]+(-(+h[b+12904>>3]*+h[d+1192>>3])- +h[d+1176>>3]);i=i;return}function xR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1896>>3]=-+h[b+1128>>3]- +h[b+1008>>3];i=i;return}function yR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1848>>3]=+h[b+9872>>3]*+h[d+1928>>3]+(-(+h[b+9888>>3]*+h[d+1912>>3])- +h[d+1896>>3]);i=i;return}function zR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2616>>3]=-+h[b+1848>>3]- +h[b+1728>>3];i=i;return}function AR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2568>>3]=+h[b+6856>>3]*+h[d+2648>>3]+(-(+h[b+6872>>3]*+h[d+2632>>3])- +h[d+2616>>3]);i=i;return}function BR(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+6280>>3]=+h[d+22296>>3]*((+h[b+6296>>3]+ +h[d+18840>>3])*.4999999999999999+ +h[b+6304>>3]*.8660254037844387);i=i;return}function CR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1992>>3]=+h[(c[a+416>>2]|0)+9432>>3]*+h[b+6280>>3];i=i;return}function DR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2016>>3]=+h[(c[a+416>>2]|0)+9312>>3]*+h[b+6280>>3]- +h[b+1992>>3];i=i;return}function ER(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1984>>3]=+h[b+9448>>3]*+h[d+6272>>3]- +h[b+9440>>3]*+h[d+6280>>3];i=i;return}function FR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2008>>3]=+h[b+9328>>3]*+h[d+6272>>3]+(-(+h[b+9320>>3]*+h[d+6280>>3])- +h[d+1984>>3]);i=i;return}function GR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2e3>>3]=-(+h[(c[a+416>>2]|0)+9432>>3]*+h[b+6272>>3]);i=i;return}function HR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2024>>3]=-+h[b+2e3>>3]- +h[(c[a+416>>2]|0)+9312>>3]*+h[b+6272>>3];i=i;return}function IR(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2224>>3];e=+h[b+2216>>3];h[b+2272>>3]=(+h[b+14920>>3]*d+ +h[b+14904>>3]*e)*.4999999999999999+(d*+h[b+14912>>3]+e*+h[b+14896>>3])*.8660254037844387;i=i;return}function JR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2384>>3]=+h[b+2272>>3]+ +h[b+6280>>3];i=i;return}function KR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15352>>3]=+h[b+2272>>3]*-.1;i=i;return}function LR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2296>>3]=-+h[b+15352>>3]- +h[b+2008>>3];i=i;return}function MR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2376>>3]=+h[b+16784>>3]*+h[b+2384>>3]- +h[b+2296>>3];i=i;return}function NR(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2224>>3];e=+h[b+2216>>3];h[b+2280>>3]=(+h[b+14920>>3]*d+ +h[b+14904>>3]*e)*.8660254037844387+(d*+h[b+14912>>3]+e*+h[b+14896>>3])*-.4999999999999999;i=i;return}function OR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2392>>3]=+h[b+2280>>3]+ +h[b+6272>>3];i=i;return}function PR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2528>>3]=+h[b+2392>>3]*-.4999999999999999+ +h[b+2384>>3]*.8660254037844387;i=i;return}function QR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3416>>3]=+h[b+2696>>3]- +h[b+2528>>3];i=i;return}function RR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4136>>3]=+h[b+3416>>3]- +h[b+3248>>3];i=i;return}function SR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4184>>3]=+h[b+3968>>3]- +h[b+4136>>3];i=i;return}function TR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2520>>3]=+h[b+2392>>3]*.8660254037844387+ +h[b+2384>>3]*.4999999999999999;i=i;return}function UR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3408>>3]=+h[b+2688>>3]- +h[b+2520>>3];i=i;return}function VR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4128>>3]=+h[b+3408>>3]- +h[b+3240>>3];i=i;return}function WR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4176>>3]=+h[b+3960>>3]- +h[b+4128>>3];i=i;return}function XR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4312>>3]=+h[b+4264>>3]- +h[b+6120>>3];i=i;return}function YR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4360>>3]=-(+h[b+16232>>3]*+h[b+4312>>3])- +h[b+16208>>3]*+h[b+4320>>3];i=i;return}function ZR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4408>>3]=-+h[b+4360>>3]- +h[b+4184>>3];i=i;return}function _R(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4352>>3]=-(+h[b+16224>>3]*+h[b+4312>>3])- +h[b+16200>>3]*+h[b+4320>>3];i=i;return}function $R(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4400>>3]=-+h[b+4352>>3]- +h[b+4176>>3];i=i;return}function aS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3400>>3]=+h[b+2680>>3]- +h[b+2512>>3];i=i;return}function bS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4120>>3]=+h[b+3400>>3]- +h[b+3232>>3];i=i;return}function cS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4168>>3]=+h[b+3952>>3]- +h[b+4120>>3];i=i;return}function dS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15368>>3]=+h[b+2512>>3]*.1;i=i;return}function eS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2288>>3]=-+h[b+15368>>3]- +h[b+2024>>3];i=i;return}function fS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2368>>3]=-+h[b+2288>>3]- +h[b+16784>>3]*+h[b+2512>>3];i=i;return}function gS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=+h[f+7056>>3];j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[a+2528>>3];m=+h[f+7064>>3];n=+h[a+2520>>3];o=+h[a+2376>>3]+(g*l-m*n);p=+h[a+2512>>3];q=+h[f+7048>>3];r=+h[a+2016>>3];s=+h[a+2368>>3];a=d;h[k>>3]=m*p-l*q-(r*-.8660254037844387+s*-.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=n*q-g*p-(r*.4999999999999999+s*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];UMb(e,3,o,d);RMb(e,(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2488|0);i=b;return}function hS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3392>>3]=-+h[b+2600>>3]- +h[b+2504>>3];i=i;return}function iS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3320>>3]=+h[b+3752>>3]*+h[d+3400>>3]+(-(+h[b+3744>>3]*+h[d+3408>>3])- +h[d+3392>>3]);i=i;return}function jS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4112>>3]=-+h[b+3320>>3]- +h[b+3224>>3];i=i;return}function kS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4040>>3]=+h[b+736>>3]*+h[d+4120>>3]+(-(+h[b+728>>3]*+h[d+4128>>3])- +h[d+4112>>3]);i=i;return}function lS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4160>>3]=+h[b+4040>>3]+ +h[b+3944>>3];i=i;return}function mS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3376>>3]=-+h[b+2584>>3]- +h[b+2488>>3];i=i;return}function nS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3304>>3]=+h[b+3760>>3]*+h[d+3408>>3]+(-(+h[b+3752>>3]*+h[d+3416>>3])- +h[d+3376>>3]);i=i;return}function oS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4096>>3]=-+h[b+3304>>3]- +h[b+3208>>3];i=i;return}function pS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4024>>3]=+h[b+744>>3]*+h[d+4128>>3]+(-(+h[b+736>>3]*+h[d+4136>>3])- +h[d+4096>>3]);i=i;return}function qS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4144>>3]=+h[b+4024>>3]+ +h[b+3928>>3];i=i;return}function rS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4368>>3]=+h[b+20488>>3]- +h[b+4144>>3];i=i;return}function sS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3384>>3]=-+h[b+2592>>3]- +h[b+2496>>3];i=i;return}function tS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3312>>3]=+h[b+3744>>3]*+h[d+3416>>3]+(-(+h[b+3760>>3]*+h[d+3400>>3])- +h[d+3384>>3]);i=i;return}function uS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4104>>3]=-+h[b+3312>>3]- +h[b+3216>>3];i=i;return}function vS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4032>>3]=+h[b+728>>3]*+h[d+4136>>3]+(-(+h[b+744>>3]*+h[d+4120>>3])- +h[d+4104>>3]);i=i;return}function wS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4152>>3]=+h[b+4032>>3]+ +h[b+3936>>3];i=i;return}function xS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3352>>3]=+h[b+2632>>3]- +h[b+2464>>3];i=i;return}function yS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4072>>3]=+h[b+3352>>3]- +h[b+3184>>3];i=i;return}function zS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4344>>3]=+h[b+3904>>3]- +h[b+4072>>3];i=i;return}function AS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4392>>3]=-+h[b+4344>>3]- +h[b+4168>>3];i=i;return}function BS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3344>>3]=-+h[b+2576>>3]- +h[b+2456>>3];i=i;return}function CS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3296>>3]=+h[b+3848>>3]*+h[d+3352>>3]+(-(+h[b+3840>>3]*+h[d+3360>>3])- +h[d+3344>>3]);i=i;return}function DS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4064>>3]=-+h[b+3296>>3]- +h[b+3176>>3];i=i;return}function ES(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4016>>3]=+h[b+832>>3]*+h[d+4072>>3]+(-(+h[b+824>>3]*+h[d+4080>>3])- +h[d+4064>>3]);i=i;return}function FS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4256>>3]=-+h[b+4016>>3]- +h[b+3896>>3];i=i;return}function GS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4232>>3]=-(+h[b+264>>3]*+h[d+4272>>3])- +h[d+4256>>3]- +h[b+272>>3]*+h[d+4344>>3];i=i;return}function HS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4296>>3]=-+h[b+4232>>3]- +h[b+4208>>3];i=i;return}function IS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3336>>3]=-+h[b+2568>>3]- +h[b+2448>>3];i=i;return}function JS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3288>>3]=+h[b+3840>>3]*+h[d+3368>>3]+(-(+h[b+3856>>3]*+h[d+3352>>3])- +h[d+3336>>3]);i=i;return}function KS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4056>>3]=-+h[b+3288>>3]- +h[b+3168>>3];i=i;return}function LS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4008>>3]=+h[b+824>>3]*+h[d+4088>>3]+(-(+h[b+840>>3]*+h[d+4072>>3])- +h[d+4056>>3]);i=i;return}function MS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4248>>3]=-+h[b+4008>>3]- +h[b+3888>>3];i=i;return}function NS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4224>>3]=+h[b+264>>3]*+h[d+4264>>3]+(+h[b+280>>3]*+h[d+4344>>3]- +h[d+4248>>3]);i=i;return}function OS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4304>>3]=-+h[b+4224>>3]- +h[b+4200>>3];i=i;return}function PS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4328>>3]=-(+h[b+16232>>3]*+h[b+4296>>3])- +h[b+16208>>3]*+h[b+4304>>3];i=i;return}function QS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4384>>3]=-+h[b+4328>>3]- +h[b+4160>>3];i=i;return}function RS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4336>>3]=-(+h[b+16224>>3]*+h[b+4296>>3])- +h[b+16200>>3]*+h[b+4304>>3];i=i;return}function SS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4376>>3]=-+h[b+4336>>3]- +h[b+4152>>3];i=i;return}function TS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+32>>3]=0.0;i=i;return}function US(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20488>>3];k=+h[(c[b+416>>2]|0)+25536>>3];l=+h[g+32>>3];if(k!=0.0){m=g;n=l/k;o=j-n;h[m>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;h[m>>3]=o;i=d;return}p=l/+$Lb(c[b+536>>2]|0,k,22832,22824,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=p;o=j-n;h[m>>3]=o;i=d;return}function VS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+40>>3]=0.0;i=i;return}function WS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g>>3];k=+h[(c[b+416>>2]|0)+25536>>3];l=+h[g+40>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+8|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+8|0;r=q;h[r>>3]=o;i=d;return}s=l/+$Lb(c[b+536>>2]|0,k,22832,22848,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+8|0;r=q;h[r>>3]=o;i=d;return}function XS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20480>>3]=+h[b+8>>3];i=i;return}function YS(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+376>>2]=c[b+372>>2];i=i;return}function ZS(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+263|0]=a[d+6|0]|0;i=i;return}function _S(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+282|0]=a[d+263|0]|0;i=i;return}function $S(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+296|0]=a[d+263|0]|0;i=i;return}function aT(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+310|0]=a[d+263|0]|0;i=i;return}function bT(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+368>>2]=c[b+360>>2];i=i;return}function cT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25480>>3]=+h[b+25464>>3]*2.0;i=i;return}function dT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18960>>3]=+h[b+18864>>3]/9.0;i=i;return}function eT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19256>>3]=+h[b+18960>>3];i=i;return}function fT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19264>>3]=+h[b+19256>>3]/3.0;i=i;return}function gT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20088>>3]=+h[b+18960>>3];i=i;return}function hT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20096>>3]=+h[b+20088>>3]/3.0;i=i;return}function iT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20288>>3]=+h[b+18960>>3];i=i;return}function jT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20296>>3]=+h[b+20288>>3]/3.0;i=i;return}function kT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21120>>3]=+h[b+18960>>3];i=i;return}function lT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21128>>3]=+h[b+21120>>3]/3.0;i=i;return}function mT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21320>>3]=+h[b+18960>>3];i=i;return}function nT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21328>>3]=+h[b+21320>>3]/3.0;i=i;return}function oT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22152>>3]=+h[b+18960>>3];i=i;return}function pT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22160>>3]=+h[b+22152>>3]/3.0;i=i;return}function qT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22352>>3]=+h[b+18960>>3];i=i;return}function rT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22360>>3]=+h[b+22352>>3]/3.0;i=i;return}function sT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23184>>3]=+h[b+18960>>3];i=i;return}function tT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23192>>3]=+h[b+23184>>3]/3.0;i=i;return}function uT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23384>>3]=+h[b+18960>>3];i=i;return}function vT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23392>>3]=+h[b+23384>>3]/3.0;i=i;return}function wT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24216>>3]=+h[b+18960>>3];i=i;return}function xT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24224>>3]=+h[b+24216>>3]/3.0;i=i;return}function yT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24416>>3]=+h[b+18960>>3];i=i;return}function zT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24424>>3]=+h[b+24416>>3]/3.0;i=i;return}function AT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25248>>3]=+h[b+18960>>3];i=i;return}function BT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25256>>3]=+h[b+25248>>3]/3.0;i=i;return}function CT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25448>>3]=+h[b+18960>>3];i=i;return}function DT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25456>>3]=+h[b+25448>>3]/3.0;i=i;return}function ET(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+18816>>3]=l;i=b;return}function FT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+18808>>3]=l;i=b;return}function GT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+18800>>3]=l;i=b;return}function HT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+18792>>3]=l;i=b;return}function IT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18520>>3]=+h[b+18256>>3];i=i;return}function JT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18592>>3]=+h[b+18520>>3];i=i;return}function KT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18512>>3]=+h[b+18248>>3];i=i;return}function LT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18584>>3]=+h[b+18512>>3];i=i;return}function MT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18504>>3]=+h[b+18240>>3];i=i;return}function NT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18576>>3]=+h[b+18504>>3];i=i;return}function OT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18568>>3]=+h[b+18304>>3];i=i;return}function PT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18560>>3]=+h[b+18296>>3];i=i;return}function QT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18552>>3]=+h[b+18288>>3];i=i;return}function RT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18544>>3]=+h[b+18280>>3];i=i;return}function ST(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18536>>3]=+h[b+18272>>3];i=i;return}function TT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18528>>3]=+h[b+18264>>3];i=i;return}function UT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25440>>3]=+h[b+25336>>3];i=i;return}function VT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25432>>3]=+h[b+25328>>3];i=i;return}function WT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25424>>3]=+h[b+25320>>3];i=i;return}function XT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25312>>3]=+h[b+24536>>3];i=i;return}function YT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25416>>3]=+h[b+25312>>3];i=i;return}function ZT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25304>>3]=+h[b+24528>>3];i=i;return}function _T(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25408>>3]=+h[b+25304>>3];i=i;return}function $T(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25296>>3]=+h[b+24520>>3];i=i;return}function aU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25400>>3]=+h[b+25296>>3];i=i;return}function bU(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+356>>2]=c[b+348>>2];i=i;return}function cU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25264>>3]=+h[b+24544>>3]/1.75;i=i;return}function dU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25280>>3]=+h[b+25264>>3]*2.0;i=i;return}function eU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25272>>3]=+h[b+24544>>3]/1.75;i=i;return}function fU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+18184>>3]=l;i=b;return}function gU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+18176>>3]=l;i=b;return}function hU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+18168>>3]=l;i=b;return}function iU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+18160>>3]=l;i=b;return}function jU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17888>>3]=+h[b+17624>>3];i=i;return}function kU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17960>>3]=+h[b+17888>>3];i=i;return}function lU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17880>>3]=+h[b+17616>>3];i=i;return}function mU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17952>>3]=+h[b+17880>>3];i=i;return}function nU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17872>>3]=+h[b+17608>>3];i=i;return}function oU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17944>>3]=+h[b+17872>>3];i=i;return}function pU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17936>>3]=+h[b+17672>>3];i=i;return}function qU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17928>>3]=+h[b+17664>>3];i=i;return}function rU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17920>>3]=+h[b+17656>>3];i=i;return}function sU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17912>>3]=+h[b+17648>>3];i=i;return}function tU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17904>>3]=+h[b+17640>>3];i=i;return}function uU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17896>>3]=+h[b+17632>>3];i=i;return}function vU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25240>>3]=+h[b+25136>>3];i=i;return}function wU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25232>>3]=+h[b+25128>>3];i=i;return}function xU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25224>>3]=+h[b+25120>>3];i=i;return}function yU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25112>>3]=+h[b+24576>>3];i=i;return}function zU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25216>>3]=+h[b+25112>>3];i=i;return}function AU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25104>>3]=+h[b+24568>>3];i=i;return}function BU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25208>>3]=+h[b+25104>>3];i=i;return}function CU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25096>>3]=+h[b+24560>>3];i=i;return}function DU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25200>>3]=+h[b+25096>>3];i=i;return}function EU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25184>>3]=+h[b+24544>>3]/1.75;i=i;return}function FU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18936>>3]=+h[b+18864>>3]*.05;i=i;return}function GU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19648>>3]=+h[b+18936>>3];i=i;return}function HU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19872>>3]=+h[b+19648>>3]*1.1;i=i;return}function IU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19656>>3]=+h[b+18936>>3];i=i;return}function JU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19880>>3]=+h[b+19656>>3];i=i;return}function KU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19688>>3]=+h[b+18936>>3];i=i;return}function LU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19720>>3]=+h[b+19688>>3];i=i;return}function MU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19776>>3]=+h[b+19720>>3];i=i;return}function NU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19768>>3]=+h[b+19688>>3];i=i;return}function OU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19704>>3]=+h[b+18936>>3];i=i;return}function PU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19808>>3]=+h[b+19704>>3];i=i;return}function QU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20680>>3]=+h[b+18936>>3];i=i;return}function RU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20904>>3]=+h[b+20680>>3]*1.1;i=i;return}function SU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20688>>3]=+h[b+18936>>3];i=i;return}function TU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20912>>3]=+h[b+20688>>3];i=i;return}function UU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20720>>3]=+h[b+18936>>3];i=i;return}function VU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20752>>3]=+h[b+20720>>3];i=i;return}function WU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20808>>3]=+h[b+20752>>3];i=i;return}function XU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20800>>3]=+h[b+20720>>3];i=i;return}function YU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20736>>3]=+h[b+18936>>3];i=i;return}function ZU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20840>>3]=+h[b+20736>>3];i=i;return}function _U(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21712>>3]=+h[b+18936>>3];i=i;return}function $U(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21936>>3]=+h[b+21712>>3]*1.1;i=i;return}function aV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21720>>3]=+h[b+18936>>3];i=i;return}function bV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21944>>3]=+h[b+21720>>3];i=i;return}function cV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21752>>3]=+h[b+18936>>3];i=i;return}function dV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21784>>3]=+h[b+21752>>3];i=i;return}function eV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21840>>3]=+h[b+21784>>3];i=i;return}function fV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21832>>3]=+h[b+21752>>3];i=i;return}function gV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21768>>3]=+h[b+18936>>3];i=i;return}function hV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21872>>3]=+h[b+21768>>3];i=i;return}function iV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22744>>3]=+h[b+18936>>3];i=i;return}function jV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22968>>3]=+h[b+22744>>3]*1.1;i=i;return}function kV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22752>>3]=+h[b+18936>>3];i=i;return}function lV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22976>>3]=+h[b+22752>>3];i=i;return}function mV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22784>>3]=+h[b+18936>>3];i=i;return}function nV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22816>>3]=+h[b+22784>>3];i=i;return}function oV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22872>>3]=+h[b+22816>>3];i=i;return}function pV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22864>>3]=+h[b+22784>>3];i=i;return}function qV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22800>>3]=+h[b+18936>>3];i=i;return}function rV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22904>>3]=+h[b+22800>>3];i=i;return}function sV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23776>>3]=+h[b+18936>>3];i=i;return}function tV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24e3>>3]=+h[b+23776>>3]*1.1;i=i;return}function uV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23784>>3]=+h[b+18936>>3];i=i;return}function vV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24008>>3]=+h[b+23784>>3];i=i;return}function wV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23816>>3]=+h[b+18936>>3];i=i;return}function xV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23848>>3]=+h[b+23816>>3];i=i;return}function yV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23904>>3]=+h[b+23848>>3];i=i;return}function zV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23896>>3]=+h[b+23816>>3];i=i;return}function AV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23832>>3]=+h[b+18936>>3];i=i;return}function BV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23936>>3]=+h[b+23832>>3];i=i;return}function CV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24808>>3]=+h[b+18936>>3];i=i;return}function DV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25032>>3]=+h[b+24808>>3]*1.1;i=i;return}function EV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24816>>3]=+h[b+18936>>3];i=i;return}function FV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25040>>3]=+h[b+24816>>3];i=i;return}function GV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24848>>3]=+h[b+18936>>3];i=i;return}function HV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24880>>3]=+h[b+24848>>3];i=i;return}function IV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24936>>3]=+h[b+24880>>3];i=i;return}function JV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24928>>3]=+h[b+24848>>3];i=i;return}function KV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24864>>3]=+h[b+18936>>3];i=i;return}function LV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24968>>3]=+h[b+24864>>3];i=i;return}function MV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18928>>3]=+h[b+18864>>3]*.1;i=i;return}function NV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19640>>3]=+h[b+18928>>3];i=i;return}function OV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19680>>3]=+h[b+18928>>3];i=i;return}function PV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19712>>3]=+h[b+19680>>3]*.5;i=i;return}function QV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19728>>3]=+h[b+19712>>3];i=i;return}function RV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19856>>3]=+h[b+19728>>3];i=i;return}function SV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19864>>3]=+h[b+19728>>3];i=i;return}function TV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19824>>3]=+h[b+19712>>3];i=i;return}function UV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19832>>3]=+h[b+19712>>3];i=i;return}function VV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19792>>3]=+h[b+19680>>3];i=i;return}function WV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19696>>3]=+h[b+18928>>3];i=i;return}function XV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19800>>3]=+h[b+19696>>3];i=i;return}function YV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20672>>3]=+h[b+18928>>3];i=i;return}function ZV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20712>>3]=+h[b+18928>>3];i=i;return}function _V(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20744>>3]=+h[b+20712>>3]*.5;i=i;return}function $V(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20760>>3]=+h[b+20744>>3];i=i;return}function aW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20888>>3]=+h[b+20760>>3];i=i;return}function bW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20896>>3]=+h[b+20760>>3];i=i;return}function cW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20856>>3]=+h[b+20744>>3];i=i;return}function dW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20864>>3]=+h[b+20744>>3];i=i;return}function eW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20824>>3]=+h[b+20712>>3];i=i;return}function fW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20728>>3]=+h[b+18928>>3];i=i;return}function gW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20832>>3]=+h[b+20728>>3];i=i;return}function hW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21704>>3]=+h[b+18928>>3];i=i;return}function iW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21744>>3]=+h[b+18928>>3];i=i;return}function jW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21776>>3]=+h[b+21744>>3]*.5;i=i;return}function kW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21792>>3]=+h[b+21776>>3];i=i;return}function lW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21920>>3]=+h[b+21792>>3];i=i;return}function mW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21928>>3]=+h[b+21792>>3];i=i;return}function nW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21888>>3]=+h[b+21776>>3];i=i;return}function oW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21896>>3]=+h[b+21776>>3];i=i;return}function pW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21856>>3]=+h[b+21744>>3];i=i;return}function qW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21760>>3]=+h[b+18928>>3];i=i;return}function rW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21864>>3]=+h[b+21760>>3];i=i;return}function sW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22736>>3]=+h[b+18928>>3];i=i;return}function tW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22776>>3]=+h[b+18928>>3];i=i;return}function uW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22808>>3]=+h[b+22776>>3]*.5;i=i;return}function vW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22824>>3]=+h[b+22808>>3];i=i;return}function wW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22952>>3]=+h[b+22824>>3];i=i;return}function xW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22960>>3]=+h[b+22824>>3];i=i;return}function yW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22920>>3]=+h[b+22808>>3];i=i;return}function zW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22928>>3]=+h[b+22808>>3];i=i;return}function AW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22888>>3]=+h[b+22776>>3];i=i;return}function BW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22792>>3]=+h[b+18928>>3];i=i;return}function CW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22896>>3]=+h[b+22792>>3];i=i;return}function DW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23768>>3]=+h[b+18928>>3];i=i;return}function EW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23808>>3]=+h[b+18928>>3];i=i;return}function FW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23840>>3]=+h[b+23808>>3]*.5;i=i;return}function GW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23856>>3]=+h[b+23840>>3];i=i;return}function HW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23984>>3]=+h[b+23856>>3];i=i;return}function IW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23992>>3]=+h[b+23856>>3];i=i;return}function JW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23952>>3]=+h[b+23840>>3];i=i;return}function KW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23960>>3]=+h[b+23840>>3];i=i;return}function LW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23920>>3]=+h[b+23808>>3];i=i;return}function MW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23824>>3]=+h[b+18928>>3];i=i;return}function NW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23928>>3]=+h[b+23824>>3];i=i;return}function OW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24800>>3]=+h[b+18928>>3];i=i;return}function PW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24840>>3]=+h[b+18928>>3];i=i;return}function QW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24872>>3]=+h[b+24840>>3]*.5;i=i;return}function RW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24888>>3]=+h[b+24872>>3];i=i;return}function SW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25016>>3]=+h[b+24888>>3];i=i;return}function TW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25024>>3]=+h[b+24888>>3];i=i;return}function UW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24984>>3]=+h[b+24872>>3];i=i;return}function VW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24992>>3]=+h[b+24872>>3];i=i;return}function WW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24952>>3]=+h[b+24840>>3];i=i;return}function XW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24856>>3]=+h[b+18928>>3];i=i;return}function YW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24960>>3]=+h[b+24856>>3];i=i;return}function ZW(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+17440>>3];e=-.1- +h[b+17448>>3];f=+h[b+17456>>3];h[b+25008>>3]=+V(+(f*f+(d*d+e*e)));i=i;return}function _W(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+273|0]=a[d+270|0]|0;i=i;return}function $W(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16944>>3]=-+h[b+24504>>3];i=i;return}function aX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24768>>3]=+h[b+24544>>3]*.5;i=i;return}function bX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24760>>3]=+h[b+24504>>3]*.5;i=i;return}function cX(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+16480>>3]- +h[b+16600>>3];e=+h[b+16488>>3]- +h[b+16608>>3];f=+h[b+16496>>3]- +h[b+16616>>3];h[b+24736>>3]=+V(+(d*d+e*e+f*f));i=i;return}function dX(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+18872>>3];j=+h[f+24736>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$Lb(c[b+536>>2]|0,g,18120,22888,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+24744>>3]=l;i=d;return}function eX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24752>>3]=+h[b+24744>>3];i=i;return}function fX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24720>>3]=+h[b+24496>>3];i=i;return}function gX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24680>>3]=+h[b+24488>>3];i=i;return}function hX(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+316>>2]=c[b+312>>2];i=i;return}function iX(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+215|0]=a[d+6|0]|0;i=i;return}function jX(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+234|0]=a[d+215|0]|0;i=i;return}function kX(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+248|0]=a[d+215|0]|0;i=i;return}function lX(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+262|0]=a[d+215|0]|0;i=i;return}function mX(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+308>>2]=c[b+300>>2];i=i;return}function nX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24448>>3]=+h[b+24432>>3]*2.0;i=i;return}function oX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+15800>>3]=l;i=b;return}function pX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+15792>>3]=l;i=b;return}function qX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+15784>>3]=l;i=b;return}function rX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,0);h[(c[a+416>>2]|0)+15776>>3]=l;i=b;return}function sX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15504>>3]=+h[b+15240>>3];i=i;return}function tX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15576>>3]=+h[b+15504>>3];i=i;return}function uX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15496>>3]=+h[b+15232>>3];i=i;return}function vX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15568>>3]=+h[b+15496>>3];i=i;return}function wX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15488>>3]=+h[b+15224>>3];i=i;return}function xX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15560>>3]=+h[b+15488>>3];i=i;return}function yX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15552>>3]=+h[b+15288>>3];i=i;return}function zX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15544>>3]=+h[b+15280>>3];i=i;return}function AX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15536>>3]=+h[b+15272>>3];i=i;return}function BX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15528>>3]=+h[b+15264>>3];i=i;return}function CX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15520>>3]=+h[b+15256>>3];i=i;return}function DX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15512>>3]=+h[b+15248>>3];i=i;return}function EX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24408>>3]=+h[b+24304>>3];i=i;return}function FX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24400>>3]=+h[b+24296>>3];i=i;return}function GX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24392>>3]=+h[b+24288>>3];i=i;return}function HX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24280>>3]=+h[b+23504>>3];i=i;return}function IX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24384>>3]=+h[b+24280>>3];i=i;return}function JX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24272>>3]=+h[b+23496>>3];i=i;return}function KX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24376>>3]=+h[b+24272>>3];i=i;return}function LX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24264>>3]=+h[b+23488>>3];i=i;return}function MX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24368>>3]=+h[b+24264>>3];i=i;return}function NX(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+296>>2]=c[b+288>>2];i=i;return}function OX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24232>>3]=+h[b+23512>>3]/1.75;i=i;return}function PX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24248>>3]=+h[b+24232>>3]*2.0;i=i;return}function QX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24240>>3]=+h[b+23512>>3]/1.75;i=i;return}function RX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,3);h[(c[a+416>>2]|0)+15168>>3]=l;i=b;return}function SX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,2);h[(c[a+416>>2]|0)+15160>>3]=l;i=b;return}function TX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=22856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=22872;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];cv(f,g,e,d);l=+KMb(f,1);h[(c[a+416>>2]|0)+15152>>3]=l;i=b;return}



function xUb(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((Fd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=273960;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[273960+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function yUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;nUb(a,273904);mUb(a,4);nUb(a,274040);mUb(a,0);nUb(a,274048);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;oUb(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);nUb(a,274056);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{nUb(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{nUb(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{nUb(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{nUb(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=274144;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];AUb(a,b,e);nUb(a,274080);mUb(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);BUb(a,274056,274088);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;BUb(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;BUb(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;BUb(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;BUb(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function zUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;nUb(a,273912);mUb(a,4);nUb(a,274040);mUb(a,0);nUb(a,274048);o=g+1+j+l+n|0;oUb(a,o);nUb(a,274056);if((c[f>>2]|0)>0){n=b;l=0;do{nUb(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{nUb(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{nUb(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{nUb(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=274064;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];AUb(a,b,e);nUb(a,274080);mUb(a,o);BUb(a,274056,274088);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;BUb(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;BUb(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;BUb(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;BUb(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function AUb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;nUb(b,274112);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}mUb(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?274056:h;if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}CUb(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;j=a[g+(u*52|0)+8|0]|0;if((c[e+(j<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{m=j<<24>>24==2?274056:w;if(j<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(j<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=m}CUb(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{s=k<<24>>24==2?274056:l;if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=s}CUb(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?274056:C;if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}CUb(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function BUb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;nUb(a,b);mUb(a,1);nUb(a,274096);nUb(a,c);i=d;return}function CUb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;nUb(a,b);mUb(a,d?2:1);nUb(a,274120);nUb(a,c);if(!d){i=e;return}nUb(a,274128);nUb(a,274136);i=e;return}function DUb(a){a=a|0;var b=0;b=i;LTb(a);i=b;return}function EUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;R3b(e,274160);N3b(d,GUb(a,e)|0);FUb(d,b+4|0);X3b(d);X3b(e);R3b(g,274168);N3b(f,GUb(a,g)|0);HUb(f,b);X3b(f);X3b(g);R3b(j,274184);N3b(h,GUb(a,j)|0);FUb(h,b+8|0);X3b(h);X3b(j);R3b(l,274200);N3b(k,GUb(a,l)|0);FUb(k,b+12|0);X3b(k);X3b(l);R3b(n,274216);N3b(m,GUb(a,n)|0);IUb(m,b+16|0,0);X3b(m);X3b(n);R3b(p,274232);N3b(o,GUb(a,p)|0);IUb(o,b+20|0,0);X3b(o);X3b(p);R3b(r,274248);N3b(q,GUb(a,r)|0);IUb(q,b+24|0,0);X3b(q);X3b(r);R3b(t,274256);N3b(s,GUb(a,t)|0);IUb(s,b+28|0,0);X3b(s);X3b(t);R3b(v,274272);N3b(u,GUb(a,v)|0);IUb(u,b+32|0,0);X3b(u);X3b(v);i=c;return}function FUb(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){XLb(22,0,277480,d);i=d;return}else{c[b>>2]=yd(s4b(a)|0)|0;i=d;return}}function GUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=PYb(a,f,b)|0;l=c[k>>2]|0;qRb(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}RYb(j,a,b);SYb(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];QYb(g,e);TYb(j);j=c[f>>2]|0;UYb(a,j,k,VYb(g)|0);k=WYb(g)|0;TYb(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function HUb(a,b){a=a|0;b=b|0;var d=0;d=i;if((v4b(a,274448)|0)==0){c[b>>2]=1;i=d;return}if((v4b(a,274456)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Dc(s4b(a)|0)|0;i=d;return}}function IUb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((v4b(a,274424)|0)==0){c[b>>2]=d}if((v4b(a,274448)|0)==0){c[b>>2]=1;i=e;return}if((v4b(a,274456)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Dc(s4b(a)|0)|0;i=e;return}}function JUb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;R3b(j,274288);N3b(g,GUb(b,j)|0);y=d+48|0;KUb(g,y);X3b(g);X3b(j);R3b(m,274304);N3b(l,GUb(b,m)|0);j=d+56|0;LUb(l,j,0.0);X3b(l);X3b(m);R3b(o,274312);N3b(n,GUb(b,o)|0);m=d+32|0;KUb(n,m);X3b(n);X3b(o);R3b(q,274320);N3b(p,GUb(b,q)|0);o=d+33|0;KUb(p,o);X3b(p);X3b(q);R3b(s,274336);N3b(r,GUb(b,s)|0);q=d+40|0;LUb(r,q,1.0);X3b(r);X3b(s);R3b(u,274344);N3b(t,GUb(b,u)|0);s=d+16|0;LUb(t,s,-1.7976931348623157e+308);X3b(t);X3b(u);R3b(w,274352);N3b(v,GUb(b,w)|0);u=d+24|0;LUb(v,u,1.7976931348623157e+308);X3b(v);X3b(w);R3b(x,274160);w=s4b(GUb(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?274448:274456;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?274424:274432;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?274424:274440;c[f+20>>2]=j;c[f+24>>2]=m?274424:274432;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?274424:274440;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];VLb(4,0,274360,f);X3b(x);i=e;return}function KUb(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(v4b(b,274448)|0)==0|0;i=d;return}function LUb(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((v4b(a,274424)|0)==0){h[b>>3]=c;i=d;return}if((v4b(a,274448)|0)==0){h[b>>3]=1.0;i=d;return}if((v4b(a,274456)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+wec(s4b(a)|0);i=d;return}}function MUb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;R3b(h,274288);N3b(g,GUb(b,h)|0);s=d+13|0;KUb(g,s);X3b(g);X3b(h);R3b(k,274304);N3b(j,GUb(b,k)|0);h=d+16|0;IUb(j,h,0);X3b(j);X3b(k);R3b(m,274312);N3b(l,GUb(b,m)|0);k=d+12|0;KUb(l,k);X3b(l);X3b(m);R3b(o,274344);N3b(n,GUb(b,o)|0);m=d+4|0;IUb(n,m,-2147483648);X3b(n);X3b(o);R3b(q,274352);N3b(p,GUb(b,q)|0);o=d+8|0;IUb(p,o,2147483647);X3b(p);X3b(q);R3b(r,274160);q=s4b(GUb(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?274448:274456;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?274424:274432;c[f+8>>2]=s;c[f+12>>2]=b?274424:274440;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;VLb(4,0,274464,f);X3b(r);i=e;return}function NUb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;R3b(h,274288);N3b(g,GUb(b,h)|0);o=d+5|0;KUb(g,o);X3b(g);X3b(h);R3b(k,274304);N3b(j,GUb(b,k)|0);h=d+6|0;KUb(j,h);X3b(j);X3b(k);R3b(m,274312);N3b(l,GUb(b,m)|0);k=d+4|0;KUb(l,k);X3b(l);X3b(m);R3b(n,274160);m=s4b(GUb(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?274448:274456;h=(a[k]|0)!=0?274448:274456;c[f>>2]=m;c[f+4>>2]=b?274424:274432;c[f+8>>2]=o;c[f+12>>2]=b?274424:274440;c[f+16>>2]=h;VLb(4,0,274520,f);X3b(n);i=e;return}function OUb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;R3b(h,274288);N3b(g,GUb(b,h)|0);m=d+4|0;KUb(g,m);X3b(g);X3b(h);R3b(k,274304);N3b(j,GUb(b,k)|0);h=d+8|0;FUb(j,h);X3b(j);X3b(k);R3b(l,274160);k=s4b(GUb(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?274424:274432;c[f+8>>2]=m;c[f+12>>2]=b?274424:274440;VLb(4,0,274560,f);X3b(l);i=e;return}function PUb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Xc=0,Yc=0,Zc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=qa;QUb(qa);L3b(ra);RUb(sa,ta);RUb(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[287544>>2]|0)==0){R3b(za,c[b+80>>2]|0);SUb(ya,za,274584);Y3b(ra,ya)|0;X3b(ya);X3b(za)}else{Z3b(ra,c[287672>>2]|0)|0}ta=gc(s4b(ra)|0,274600)|0;if((ta|0)!=0){Xc=ta;break}c[pa>>2]=s4b(ra)|0;ZLb(0,274608,pa)}else{Xc=0}}while(0);pa=OGb(0)|0;if((pa|0)==0){Wc(Xc|0)|0;ZLb(0,274712,oa)}ZGb(pa,Vc);_Gb(pa,8,48);Vc=c[va>>2]|0;do{if((Vc|0)==0){oa=Aa;Iec(oa|0,0,1024)|0;while(1){za=qb(oa|0,1,1024,Xc|0)|0;ya=za>>>0<1024;if(($Gb(pa,oa,za,ya&1)|0)==0){Yc=12;break}if(ya){Yc=14;break}}if((Yc|0)==12){Wc(Xc|0)|0;oa=s4b(ra)|0;ya=hHb(eHb(pa)|0)|0;za=fHb(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;XLb(1,0,274792,na);VGb(pa);ZLb(0,274880,ma)}else if((Yc|0)==14){Wc(Xc|0)|0;break}}else{if(($Gb(pa,Vc,Eec(Vc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=hHb(eHb(pa)|0)|0;ta=fHb(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;ud(za|0,274904,la|0)|0;za=c[va>>2]|0;ta=hHb(eHb(pa)|0)|0;oa=fHb(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;XLb(1,0,274920,ka);VGb(pa);ZLb(0,274880,ja)}}while(0);ja=qa;R3b(Ca,275008);WUb(Ba,ja,Ca);XUb(Da,ja);ka=VUb(Ba,Da)|0;X3b(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=s4b(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;XLb(1,0,275016,ia)}else{R3b(Ea,275008);Ba=Aec(Da,s4b(GUb(ja,Ea)|0)|0)|0;X3b(Ea);if((Ba|0)==0){break}VGb(pa);R3b(Fa,275008);Ba=s4b(GUb(ja,Fa)|0)|0;va=s4b(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;XLb(1,0,275064,ha);X3b(Fa);ZLb(0,274880,ga)}}while(0);YUb(qa,b,c[287756>>2]|0,c[287760>>2]|0);VLb(23,1,275160,fa);fa=qa+12|0;R3b(Ha,275200);N3b(Ga,GUb(fa,Ha)|0);ga=d;LUb(Ga,ga,0.0);X3b(Ga);X3b(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];VLb(23,0,275216,ea);R3b(Ja,275232);N3b(Ia,GUb(fa,Ja)|0);ea=d+8|0;LUb(Ia,ea,1.0);X3b(Ia);X3b(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];VLb(23,0,275248,da);R3b(La,275264);N3b(Ka,GUb(fa,La)|0);da=d+24|0;LUb(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);X3b(Ka);X3b(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];VLb(23,0,275280,ca);R3b(Na,275296);N3b(Ma,GUb(fa,Na)|0);ca=d+32|0;LUb(Ma,ca,1.0e-5);X3b(Ma);X3b(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];VLb(23,0,275312,ba);R3b(Pa,275328);N3b(Oa,GUb(fa,Pa)|0);ba=d+40|0;FUb(Oa,ba);X3b(Oa);X3b(Pa);c[aa>>2]=c[ba>>2];VLb(23,0,275336,aa);R3b(Ra,275360);N3b(Qa,GUb(fa,Ra)|0);aa=d+44|0;FUb(Qa,aa);X3b(Qa);X3b(Ra);c[$>>2]=c[aa>>2];VLb(23,0,275376,$);R3b(Ta,275400);N3b(Sa,GUb(fa,Ta)|0);fa=d+48|0;FUb(Sa,fa);X3b(Sa);X3b(Ta);c[_>>2]=c[fa>>2];VLb(23,0,275416,_);R3b(Va,275440);N3b(Ua,GUb(ja,Va)|0);_=d+268|0;FUb(Ua,_);X3b(Ua);X3b(Va);c[Z>>2]=c[_>>2];VLb(23,0,275464,Z);if((c[233652>>2]|0)!=0){de[c[58528]&511](23)}R3b(eb,275488);N3b(db,GUb(ja,eb)|0);IUb(db,Wa,0);X3b(db);X3b(eb);R3b(gb,275520);N3b(fb,GUb(ja,gb)|0);IUb(fb,Xa,0);X3b(fb);X3b(gb);R3b(ib,275552);N3b(hb,GUb(ja,ib)|0);IUb(hb,Ya,0);X3b(hb);X3b(ib);R3b(kb,275576);N3b(jb,GUb(ja,kb)|0);IUb(jb,_a,0);X3b(jb);X3b(kb);R3b(mb,275608);N3b(lb,GUb(ja,mb)|0);IUb(lb,Za,0);X3b(lb);X3b(mb);R3b(ob,275648);N3b(nb,GUb(ja,ob)|0);IUb(nb,ab,0);X3b(nb);X3b(ob);R3b(rb,275680);N3b(pb,GUb(ja,rb)|0);IUb(pb,$a,0);X3b(pb);X3b(rb);R3b(tb,275720);N3b(sb,GUb(ja,tb)|0);IUb(sb,cb,0);X3b(sb);X3b(tb);R3b(vb,275752);N3b(ub,GUb(ja,vb)|0);IUb(ub,bb,0);X3b(ub);X3b(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}sb=b+116|0;if((c[Za>>2]|0)!=(c[sb>>2]|0)){break}rb=b+136|0;if((c[ab>>2]|0)!=(c[rb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=276296;VLb(4,1,276272,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=ZUb(lb,wb)|0;EUb(ib,jb+(kb*112|0)|0);JUb(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[287540>>2]|0)!=0){break}R3b(xb,276312);jb=(v4b(GUb(ib,xb)|0,274448)|0)==0;X3b(xb);if(!jb){break}c[N>>2]=c[hb>>2];VLb(4,0,276328,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);R3b(yb,c[hb>>2]|0);c[(_Ub(sa,yb)|0)>>2]=kb;X3b(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[233576>>2]|0)!=0){de[c[58528]&511](4)}c[M>>2]=276360;VLb(4,1,276272,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=ZUb(lb,zb)|0;EUb(fb,gb+(jb*112|0)|0);JUb(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[287540>>2]|0)!=0){break}R3b(Ab,276312);gb=(v4b(GUb(fb,Ab)|0,274448)|0)==0;X3b(Ab);if(!gb){break}c[L>>2]=c[eb>>2];VLb(4,0,276328,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);R3b(Bb,c[eb>>2]|0);c[(_Ub(sa,Bb)|0)>>2]=jb;X3b(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[233576>>2]|0)!=0){de[c[58528]&511](4)}c[K>>2]=276384;VLb(4,1,276272,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=ZUb(mb,Cb)|0;EUb(gb,hb+(fb*112|0)|0);JUb(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[287540>>2]|0)!=0){break}R3b(Db,276312);hb=(v4b(GUb(gb,Db)|0,274448)|0)==0;X3b(Db);if(!hb){break}c[J>>2]=c[db>>2];VLb(4,0,276328,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);R3b(Eb,c[db>>2]|0);c[(_Ub(sa,Eb)|0)>>2]=fb;X3b(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[233576>>2]|0)!=0){de[c[58528]&511](4)}c[I>>2]=276400;VLb(4,1,276272,I);if((c[sb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=ZUb(ub,Fb)|0;EUb(mb,kb+(ib*60|0)|0);MUb(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[287540>>2]|0)!=0){break}R3b(Gb,276312);kb=(v4b(GUb(mb,Gb)|0,274448)|0)==0;X3b(Gb);if(!kb){break}c[H>>2]=c[gb>>2];VLb(4,0,276328,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);R3b(Hb,c[gb>>2]|0);c[(_Ub(sa,Hb)|0)>>2]=ib;X3b(Hb);ib=ib+1|0;}while((ib|0)<(c[sb>>2]|0))}if((c[233576>>2]|0)!=0){de[c[58528]&511](4)}c[G>>2]=276424;VLb(4,1,276272,G);if((c[pb>>2]|0)>0){sb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[sb>>2]|0;c[Ib>>2]=lb;mb=ZUb(ib,Ib)|0;EUb(mb,ub+(lb*48|0)|0);NUb(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[sb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[287540>>2]|0)!=0){break}R3b(Jb,276312);ub=(v4b(GUb(mb,Jb)|0,274448)|0)==0;X3b(Jb);if(!ub){break}c[F>>2]=c[fb>>2];VLb(4,0,276328,F);a[(c[sb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);R3b(Kb,c[fb>>2]|0);c[(_Ub(sa,Kb)|0)>>2]=lb;X3b(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[233576>>2]|0)!=0){de[c[58528]&511](4)}c[E>>2]=276448;VLb(4,1,276272,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;sb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=sb;mb=ZUb(lb,Lb)|0;EUb(mb,ib+(sb*52|0)|0);OUb(mb,ib+(sb*52|0)+36|0);gb=ib+(sb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(sb*52|0)+48|0]=1}else{if((c[287540>>2]|0)!=0){break}R3b(Mb,276312);ib=(v4b(GUb(mb,Mb)|0,274448)|0)==0;X3b(Mb);if(!ib){break}c[D>>2]=c[gb>>2];VLb(4,0,276328,D);a[(c[pb>>2]|0)+(sb*52|0)+48|0]=1}}while(0);R3b(Nb,c[gb>>2]|0);c[(_Ub(sa,Nb)|0)>>2]=sb;X3b(Nb);sb=sb+1|0;}while((sb|0)<(c[nb>>2]|0))}if((c[233576>>2]|0)!=0){de[c[58528]&511](4)}c[C>>2]=276472;VLb(4,1,276272,C);if((c[ja>>2]|0)>0){nb=b+16|0;sb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=ZUb(sb,Ob)|0;EUb(mb,lb+(pb*112|0)|0);JUb(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[287540>>2]|0)!=0){break}R3b(Pb,276312);lb=(v4b(GUb(mb,Pb)|0,274448)|0)==0;X3b(Pb);if(!lb){break}c[B>>2]=c[fb>>2];VLb(4,0,276328,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);R3b(Qb,c[fb>>2]|0);c[(_Ub(ua,Qb)|0)>>2]=pb;X3b(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[233576>>2]|0)!=0){de[c[58528]&511](4)}c[A>>2]=276488;VLb(4,1,276272,A);if((c[tb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{sb=c[ja>>2]|0;c[Rb>>2]=nb;mb=ZUb(pb,Rb)|0;EUb(mb,sb+(nb*60|0)|0);MUb(mb,sb+(nb*60|0)+36|0);gb=sb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[287540>>2]|0)!=0){break}R3b(Sb,276312);sb=(v4b(GUb(mb,Sb)|0,274448)|0)==0;X3b(Sb);if(!sb){break}c[z>>2]=c[gb>>2];VLb(4,0,276328,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);R3b(Tb,c[gb>>2]|0);c[(_Ub(ua,Tb)|0)>>2]=nb;X3b(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[233576>>2]|0)!=0){de[c[58528]&511](4)}c[y>>2]=276512;VLb(4,1,276272,y);if((c[rb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[tb>>2]|0;c[Ub>>2]=ja;mb=ZUb(nb,Ub)|0;EUb(mb,pb+(ja*48|0)|0);NUb(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[287540>>2]|0)!=0){break}R3b(Vb,276312);pb=(v4b(GUb(mb,Vb)|0,274448)|0)==0;X3b(Vb);if(!pb){break}c[x>>2]=c[fb>>2];VLb(4,0,276328,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);R3b(Wb,c[fb>>2]|0);c[(_Ub(ua,Wb)|0)>>2]=ja;X3b(Wb);ja=ja+1|0;}while((ja|0)<(c[rb>>2]|0))}if((c[233576>>2]|0)!=0){de[c[58528]&511](4)}c[w>>2]=276536;VLb(4,1,276272,w);if((c[ob>>2]|0)>0){rb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[rb>>2]|0;c[Xb>>2]=tb;mb=ZUb(ja,Xb)|0;EUb(mb,nb+(tb*52|0)|0);OUb(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[287540>>2]|0)!=0){break}R3b(Yb,276312);nb=(v4b(GUb(mb,Yb)|0,274448)|0)==0;X3b(Yb);if(!nb){break}c[v>>2]=c[gb>>2];VLb(4,0,276328,v);a[(c[rb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);R3b(Zb,c[gb>>2]|0);c[(_Ub(ua,Zb)|0)>>2]=tb;X3b(Zb);tb=tb+1|0;}while((tb|0)<(c[ob>>2]|0))}if((c[233576>>2]|0)!=0){de[c[58528]&511](4)}VLb(4,1,276560,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){tb=qa+72|0;rb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=ZUb(tb,_b)|0;EUb(mb,(c[rb>>2]|0)+(ja*52|0)+12|0);L3b($b);c[bc>>2]=ja;mb=ZUb(tb,bc)|0;R3b(cc,276600);N3b(ac,GUb(mb,cc)|0);$Ub(ac,$b);X3b(ac);X3b(cc);mb=(v4b($b,276608)|0)==0;fb=c[rb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;VLb(4,0,276624,t);nb=c[rb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=ZUb(tb,ec)|0;R3b(fc,276664);N3b(dc,GUb(nb,fc)|0);$Ub(dc,$b);X3b(dc);X3b(fc);aVb(wa,sa,$b);aVb(xa,ua,$b);cVb(hc,sa);do{if(bVb(wa,hc)|0){nb=c[(dVb(wa)|0)+12>>2]|0;fb=c[rb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{cVb(ic,ua);if(bVb(xa,ic)|0){fb=c[(dVb(xa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((v4b($b,276680)|0)!=0){break b}a[(c[rb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);X3b($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}G4b(kc,276688,$b);SUb(jc,kc,276712);X3b(kc);c[s>>2]=s4b(jc)|0;ZLb(0,276728,s)}}while(0);if((c[233576>>2]|0)!=0){de[c[58528]&511](4)}VLb(4,1,276736,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;rb=b+36|0;tb=0;while(1){c[lc>>2]=tb;gb=ZUb(ja,lc)|0;EUb(gb,(c[rb>>2]|0)+(tb*52|0)+12|0);L3b(mc);c[oc>>2]=tb;gb=ZUb(ja,oc)|0;R3b(pc,276600);N3b(nc,GUb(gb,pc)|0);$Ub(nc,mc);X3b(nc);X3b(pc);gb=(v4b(mc,276608)|0)==0;nb=c[rb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;VLb(4,0,276624,p);fb=c[rb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=ZUb(ja,rc)|0;R3b(sc,276664);N3b(qc,GUb(fb,sc)|0);$Ub(qc,mc);X3b(qc);X3b(sc);aVb(wa,sa,mc);aVb(xa,ua,mc);cVb(tc,sa);if(bVb(wa,tc)|0){fb=c[(dVb(wa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{cVb(uc,ua);if(!(bVb(xa,uc)|0)){break}nb=c[(dVb(xa)|0)+12>>2]|0;fb=c[rb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}X3b(mc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break c}}G4b(wc,276776,mc);SUb(vc,wc,276712);X3b(wc);c[o>>2]=s4b(vc)|0;ZLb(0,276728,o)}}while(0);if((c[233576>>2]|0)!=0){de[c[58528]&511](4)}VLb(4,1,276800,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){tb=qa+144|0;rb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=ZUb(tb,xc)|0;EUb(fb,(c[rb>>2]|0)+(ja*52|0)+12|0);L3b(yc);c[Ac>>2]=ja;fb=ZUb(tb,Ac)|0;R3b(Bc,276600);N3b(zc,GUb(fb,Bc)|0);$Ub(zc,yc);X3b(zc);X3b(Bc);fb=(v4b(yc,276608)|0)==0;nb=c[rb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;VLb(4,0,276624,m);gb=c[rb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=ZUb(tb,Dc)|0;R3b(Ec,276664);N3b(Cc,GUb(gb,Ec)|0);$Ub(Cc,yc);X3b(Cc);X3b(Ec);aVb(wa,sa,yc);aVb(xa,ua,yc);cVb(Fc,sa);if(bVb(wa,Fc)|0){gb=c[(dVb(wa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{cVb(Gc,ua);if(!(bVb(xa,Gc)|0)){break}nb=c[(dVb(xa)|0)+12>>2]|0;gb=c[rb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}X3b(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}G4b(Ic,276840,yc);SUb(Hc,Ic,276712);X3b(Ic);c[l>>2]=s4b(Hc)|0;ZLb(0,276728,l)}}while(0);if((c[233576>>2]|0)!=0){de[c[58528]&511](4)}VLb(4,1,276864,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;rb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=ZUb(ja,Jc)|0;EUb(gb,(c[rb>>2]|0)+(tb*52|0)+12|0);L3b(Kc);c[Mc>>2]=tb;gb=ZUb(ja,Mc)|0;R3b(Nc,276600);N3b(Lc,GUb(gb,Nc)|0);$Ub(Lc,Kc);X3b(Lc);X3b(Nc);gb=(v4b(Kc,276608)|0)==0;nb=c[rb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;VLb(4,0,276624,g);fb=c[rb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=ZUb(ja,Pc)|0;R3b(Qc,276664);N3b(Oc,GUb(fb,Qc)|0);$Ub(Oc,Kc);X3b(Oc);X3b(Qc);aVb(wa,sa,Kc);aVb(xa,ua,Kc);cVb(Rc,sa);if(bVb(wa,Rc)|0){fb=c[(dVb(wa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{cVb(Sc,ua);if(!(bVb(xa,Sc)|0)){break}nb=c[(dVb(xa)|0)+12>>2]|0;fb=c[rb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}X3b(Kc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break e}}G4b(Uc,276904,Kc);SUb(Tc,Uc,276712);X3b(Uc);c[f>>2]=s4b(Tc)|0;ZLb(0,276728,f)}}while(0);if((c[233576>>2]|0)==0){VGb(pa);eVb(ua);eVb(sa);X3b(ra);fVb(qa);i=e;return}de[c[58528]&511](4);VGb(pa);eVb(ua);eVb(sa);X3b(ra);fVb(qa);i=e;return}}while(0);if((c[233648>>2]|c[58388]|0)==0){VGb(pa);Zc=sd(0)|0;Ad(-1)}XLb(22,1,275792,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;XLb(22,0,275840,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;XLb(22,0,275888,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;XLb(22,0,275936,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;XLb(22,0,275984,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;XLb(22,0,276032,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;XLb(22,0,276080,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;XLb(22,0,276128,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;XLb(22,0,276176,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;XLb(22,0,276224,P);de[c[58528]&511](22);VGb(pa);Zc=sd(0)|0;Ad(-1)}function QUb(a){a=a|0;var b=0;b=i;Q$b(a);i=b;return}function RUb(a,b){a=a|0;b=b|0;b=i;vXb(a,0);i=b;return}function SUb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;M3b(a,d);e=V3b(b)|0;f=FVb(c)|0;w4b(a,W3b(b)|0,e,f+e|0);o4b(a,c,f)|0;i=d;return}function TUb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((Aec(b,277536)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{R3b(g,v);w=GUb(u,g)|0;Z3b(w,c[d+((t|1)<<2)>>2]|0)|0;X3b(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((Aec(b,277560)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{R3b(h,g);u=GUb(t,h)|0;Z3b(u,c[d+((v|1)<<2)>>2]|0)|0;X3b(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((Aec(b,277584)|0)!=0){do{if((Aec(b,277840)|0)!=0){if((Aec(b,277848)|0)==0){break}if((Aec(b,277856)|0)==0){break}if((Aec(b,277864)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=ZUb(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){R3b(r,c[t>>2]|0);w=GUb(g,r)|0;Z3b(w,c[d+((u|1)<<2)>>2]|0)|0;X3b(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=ZUb(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}R3b(s,277872);Z3b(GUb(x,s)|0,b)|0;X3b(s);i=e;return}gVb(j,k);L3b(l);L3b(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{R3b(n,g);t=GUb(j,n)|0;Z3b(t,c[d+((x|1)<<2)>>2]|0)|0;X3b(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}R3b(o,277600);Y3b(l,GUb(j,o)|0)|0;X3b(o);R3b(p,277616);Y3b(m,GUb(j,p)|0)|0;X3b(p);c[k>>2]=Dc(s4b(l)|0)|0;if((v4b(m,277632)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((v4b(m,277640)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((v4b(m,277648)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((v4b(m,277656)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((v4b(m,277664)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((v4b(m,277672)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((v4b(m,277680)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((v4b(m,277688)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((v4b(m,277696)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((v4b(m,277704)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((v4b(m,277712)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((v4b(m,277720)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((v4b(m,277728)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((v4b(m,277736)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=s4b(m)|0;R3b(q,274160);N=s4b(GUb(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;YLb(0,(O|0)!=0|0,277744,f);X3b(q);t_b(ZUb(c[b>>2]|0,s)|0,j)|0;X3b(m);X3b(l);oVb(j);i=e;return}function UUb(a,b){a=a|0;b=b|0;i=i;return}function VUb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=eXb(a,b)|0;i=c;return d|0}function WUb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;nXb(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];fXb(a,f);i=e;return}function XUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;gXb(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];fXb(a,e);i=d;return}function YUb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;gVb(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){ZLb(0,276928,n)}if(p){ec=yd(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;VLb(23,0,277072,m);hVb(q);iVb(q,e,8);if(!(jVb(q)|0)){c[l>>2]=e;ZLb(0,277112,l)}L3b(r);l=q;kVb(l,r)|0;N3b(s,r);while(1){e=kVb(l,r)|0;if(!(H4b(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}G4b(t,277192,r);m4b(s,t)|0;X3b(t)}t=yd(s4b(s)|0)|0;lVb(q);X3b(s);X3b(r);mVb(q);fc=t}if((fc|0)==0){VLb(23,0,277280,g);oVb(o);i=f;return}L3b(u);L3b(v);c[k>>2]=fc;VLb(23,0,277200,k);k=Vb(fc|0,277192)|0;if((k|0)!=0){g=k;do{k=gec(12)|0;R3b(k,g);t=t4b(k,277232,0)|0;r4b(w,k,0,t);Y3b(u,w)|0;X3b(w);r4b(x,k,t+1|0,(c4b(k)|0)+~t|0);Y3b(v,x)|0;X3b(x);Y3b(GUb(o,u)|0,v)|0;t=s4b(u)|0;k=s4b(v)|0;c[j>>2]=t;c[j+4>>2]=k;VLb(23,0,277240,j);g=Vb(0,277192)|0;}while((g|0)!=0)}bec(fc);fc=a+12|0;R3b(y,275328);g=GUb(fc,y)|0;R3b(z,275328);if((nVb(o,z)|0)==0){R3b(B,275328);gc=1;hc=0;ic=GUb(fc,B)|0}else{R3b(A,275328);gc=0;hc=1;ic=GUb(o,A)|0}Y3b(g,ic)|0;if(gc){X3b(B)}if(hc){X3b(A)}X3b(z);X3b(y);R3b(C,275200);y=GUb(fc,C)|0;R3b(D,275200);if((nVb(o,D)|0)==0){R3b(F,275200);jc=1;kc=0;lc=GUb(fc,F)|0}else{R3b(E,275200);jc=0;kc=1;lc=GUb(o,E)|0}Y3b(y,lc)|0;if(jc){X3b(F)}if(kc){X3b(E)}X3b(D);X3b(C);R3b(G,275232);C=GUb(fc,G)|0;R3b(H,275232);if((nVb(o,H)|0)==0){R3b(J,275232);mc=1;nc=0;oc=GUb(fc,J)|0}else{R3b(I,275232);mc=0;nc=1;oc=GUb(o,I)|0}Y3b(C,oc)|0;if(mc){X3b(J)}if(nc){X3b(I)}X3b(H);X3b(G);R3b(K,275264);G=GUb(fc,K)|0;R3b(L,275264);if((nVb(o,L)|0)==0){R3b(N,275264);pc=0;qc=1;rc=GUb(fc,N)|0}else{R3b(M,275264);pc=1;qc=0;rc=GUb(o,M)|0}Y3b(G,rc)|0;if(qc){X3b(N)}if(pc){X3b(M)}X3b(L);X3b(K);R3b(O,275296);K=GUb(fc,O)|0;R3b(P,275296);if((nVb(o,P)|0)==0){R3b(R,275296);sc=1;tc=0;uc=GUb(fc,R)|0}else{R3b(Q,275296);sc=0;tc=1;uc=GUb(o,Q)|0}Y3b(K,uc)|0;if(sc){X3b(R)}if(tc){X3b(Q)}X3b(P);X3b(O);R3b(S,275360);O=GUb(fc,S)|0;R3b(T,275360);if((nVb(o,T)|0)==0){R3b(V,275360);vc=1;wc=0;xc=GUb(fc,V)|0}else{R3b(U,275360);vc=0;wc=1;xc=GUb(o,U)|0}Y3b(O,xc)|0;if(vc){X3b(V)}if(wc){X3b(U)}X3b(T);X3b(S);R3b(W,275400);S=GUb(fc,W)|0;R3b(X,275400);if((nVb(o,X)|0)==0){R3b(Z,275400);yc=1;zc=0;Ac=GUb(fc,Z)|0}else{R3b(Y,275400);yc=0;zc=1;Ac=GUb(o,Y)|0}Y3b(S,Ac)|0;if(yc){X3b(Z)}if(zc){X3b(Y)}X3b(X);X3b(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=ZUb(Y,_)|0;R3b($,274304);Ac=GUb(yc,$)|0;c[aa>>2]=Z;yc=ZUb(Y,aa)|0;R3b(ba,274160);if((nVb(o,GUb(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=ZUb(Y,ea)|0;R3b(fa,274304);Bc=1;Cc=0;Dc=GUb(yc,fa)|0}else{c[ca>>2]=Z;yc=ZUb(Y,ca)|0;R3b(da,274160);Bc=0;Cc=1;Dc=GUb(o,GUb(yc,da)|0)|0}Y3b(Ac,Dc)|0;if(Bc){X3b(fa)}if(Cc){X3b(da)}X3b(ba);X3b($);c[ga>>2]=Z;Ac=ZUb(zc,ga)|0;R3b(ha,274304);yc=GUb(Ac,ha)|0;c[ia>>2]=Z;Ac=ZUb(zc,ia)|0;R3b(ja,274160);if((nVb(o,GUb(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=ZUb(zc,ma)|0;R3b(na,274304);Ec=1;Fc=0;Gc=GUb(Ac,na)|0}else{c[ka>>2]=Z;Ac=ZUb(zc,ka)|0;R3b(la,274160);Ec=0;Fc=1;Gc=GUb(o,GUb(Ac,la)|0)|0}Y3b(yc,Gc)|0;if(Ec){X3b(na)}if(Fc){X3b(la)}X3b(ja);X3b(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=ZUb(Hc,oa)|0;R3b(pa,274304);ja=GUb(ha,pa)|0;c[qa>>2]=Z;ha=ZUb(Hc,qa)|0;R3b(ra,274160);if((nVb(o,GUb(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=ZUb(Hc,ua)|0;R3b(va,274304);Ic=1;Jc=0;Kc=GUb(ha,va)|0}else{c[sa>>2]=Z;ha=ZUb(Hc,sa)|0;R3b(ta,274160);Ic=0;Jc=1;Kc=GUb(o,GUb(ha,ta)|0)|0}Y3b(ja,Kc)|0;if(Ic){X3b(va)}if(Jc){X3b(ta)}X3b(ra);X3b(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=ZUb(X,wa)|0;R3b(xa,274304);ra=GUb(pa,xa)|0;c[ya>>2]=Z;pa=ZUb(X,ya)|0;R3b(za,274160);if((nVb(o,GUb(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=ZUb(X,Ca)|0;R3b(Da,274304);Lc=1;Mc=0;Nc=GUb(pa,Da)|0}else{c[Aa>>2]=Z;pa=ZUb(X,Aa)|0;R3b(Ba,274160);Lc=0;Mc=1;Nc=GUb(o,GUb(pa,Ba)|0)|0}Y3b(ra,Nc)|0;if(Lc){X3b(Da)}if(Mc){X3b(Ba)}X3b(za);X3b(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=ZUb(Z,Ea)|0;R3b(Fa,274304);Ba=GUb(za,Fa)|0;c[Ga>>2]=xa;za=ZUb(Z,Ga)|0;R3b(Ha,274160);if((nVb(o,GUb(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=ZUb(Z,Ka)|0;R3b(La,274304);Oc=1;Pc=0;Qc=GUb(za,La)|0}else{c[Ia>>2]=xa;za=ZUb(Z,Ia)|0;R3b(Ja,274160);Oc=0;Pc=1;Qc=GUb(o,GUb(za,Ja)|0)|0}Y3b(Ba,Qc)|0;if(Oc){X3b(La)}if(Pc){X3b(Ja)}X3b(Ha);X3b(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=ZUb(xa,Ma)|0;R3b(Na,274304);Ja=GUb(Ha,Na)|0;c[Oa>>2]=Fa;Ha=ZUb(xa,Oa)|0;R3b(Pa,274160);if((nVb(o,GUb(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=ZUb(xa,Sa)|0;R3b(Ta,274304);Rc=1;Sc=0;Tc=GUb(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=ZUb(xa,Qa)|0;R3b(Ra,274160);Rc=0;Sc=1;Tc=GUb(o,GUb(Ha,Ra)|0)|0}Y3b(Ja,Tc)|0;if(Rc){X3b(Ta)}if(Sc){X3b(Ra)}X3b(Pa);X3b(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=ZUb(Fa,Ua)|0;R3b(Va,274304);Ra=GUb(Pa,Va)|0;c[Wa>>2]=Na;Pa=ZUb(Fa,Wa)|0;R3b(Xa,274160);if((nVb(o,GUb(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=ZUb(Fa,_a)|0;R3b($a,274304);Uc=1;Vc=0;Wc=GUb(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=ZUb(Fa,Ya)|0;R3b(Za,274160);Uc=0;Vc=1;Wc=GUb(o,GUb(Pa,Za)|0)|0}Y3b(Ra,Wc)|0;if(Uc){X3b($a)}if(Vc){X3b(Za)}X3b(Xa);X3b(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=ZUb(Na,ab)|0;R3b(bb,274304);Za=GUb(Xa,bb)|0;c[cb>>2]=Va;Xa=ZUb(Na,cb)|0;R3b(db,274160);if((nVb(o,GUb(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=ZUb(Na,gb)|0;R3b(hb,274304);Xc=1;Yc=0;Zc=GUb(Xa,hb)|0}else{c[eb>>2]=Va;Xa=ZUb(Na,eb)|0;R3b(fb,274160);Xc=0;Yc=1;Zc=GUb(o,GUb(Xa,fb)|0)|0}Y3b(Za,Zc)|0;if(Xc){X3b(hb)}if(Yc){X3b(fb)}X3b(db);X3b(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=ZUb(Va,ib)|0;R3b(jb,274304);fb=GUb(db,jb)|0;c[kb>>2]=bb;db=ZUb(Va,kb)|0;R3b(lb,274160);if((nVb(o,GUb(db,lb)|0)|0)==0){c[ob>>2]=bb;db=ZUb(Va,ob)|0;R3b(pb,274304);_c=1;$c=0;ad=GUb(db,pb)|0}else{c[mb>>2]=bb;db=ZUb(Va,mb)|0;R3b(nb,274160);_c=0;$c=1;ad=GUb(o,GUb(db,nb)|0)|0}Y3b(fb,ad)|0;if(_c){X3b(pb)}if($c){X3b(nb)}X3b(lb);X3b(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=ZUb(bb,qb)|0;R3b(rb,274304);nb=GUb(lb,rb)|0;c[sb>>2]=jb;lb=ZUb(bb,sb)|0;R3b(tb,274160);if((nVb(o,GUb(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=ZUb(bb,wb)|0;R3b(xb,274304);bd=1;cd=0;dd=GUb(lb,xb)|0}else{c[ub>>2]=jb;lb=ZUb(bb,ub)|0;R3b(vb,274160);bd=0;cd=1;dd=GUb(o,GUb(lb,vb)|0)|0}Y3b(nb,dd)|0;if(bd){X3b(xb)}if(cd){X3b(vb)}X3b(tb);X3b(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=ZUb(jb,yb)|0;R3b(zb,274304);vb=GUb(tb,zb)|0;c[Ab>>2]=rb;tb=ZUb(jb,Ab)|0;R3b(Bb,274160);if((nVb(o,GUb(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=ZUb(jb,Eb)|0;R3b(Fb,274304);ed=1;fd=0;gd=GUb(tb,Fb)|0}else{c[Cb>>2]=rb;tb=ZUb(jb,Cb)|0;R3b(Db,274160);ed=0;fd=1;gd=GUb(o,GUb(tb,Db)|0)|0}Y3b(vb,gd)|0;if(ed){X3b(Fb)}if(fd){X3b(Db)}X3b(Bb);X3b(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=ZUb(rb,Gb)|0;R3b(Hb,274304);Db=GUb(Bb,Hb)|0;c[Ib>>2]=zb;Bb=ZUb(rb,Ib)|0;R3b(Jb,274160);if((nVb(o,GUb(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=ZUb(rb,Mb)|0;R3b(Nb,274304);hd=0;id=1;jd=GUb(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=ZUb(rb,Kb)|0;R3b(Lb,274160);hd=1;id=0;jd=GUb(o,GUb(Bb,Lb)|0)|0}Y3b(Db,jd)|0;if(id){X3b(Nb)}if(hd){X3b(Lb)}X3b(Jb);X3b(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=ZUb(zb,Ob)|0;R3b(Pb,274304);Lb=GUb(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=ZUb(zb,Qb)|0;R3b(Rb,274160);if((nVb(o,GUb(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=ZUb(zb,Ub)|0;R3b(Wb,274304);kd=1;ld=0;md=GUb(Jb,Wb)|0}else{c[Sb>>2]=Hb;Jb=ZUb(zb,Sb)|0;R3b(Tb,274160);kd=0;ld=1;md=GUb(o,GUb(Jb,Tb)|0)|0}Y3b(Lb,md)|0;if(kd){X3b(Wb)}if(ld){X3b(Tb)}X3b(Rb);X3b(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Xb>>2]=a;Hb=ZUb(b,Xb)|0;R3b(Yb,274304);Pb=GUb(Hb,Yb)|0;c[Zb>>2]=a;Hb=ZUb(b,Zb)|0;R3b(_b,274160);if((nVb(o,GUb(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=ZUb(b,bc)|0;R3b(cc,274304);nd=1;od=0;pd=GUb(Hb,cc)|0}else{c[$b>>2]=a;Hb=ZUb(b,$b)|0;R3b(ac,274160);nd=0;od=1;pd=GUb(o,GUb(Hb,ac)|0)|0}Y3b(Pb,pd)|0;if(nd){X3b(cc)}if(od){X3b(ac)}X3b(_b);X3b(Yb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}VLb(23,0,277264,h);X3b(v);X3b(u);oVb(o);i=f;return}function ZUb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=EXb(a,f,b)|0;l=c[k>>2]|0;qRb(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}GXb(j,a,b);HXb(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];FXb(g,e);IXb(j);j=c[f>>2]|0;JXb(a,j,k,KXb(g)|0);k=LXb(g)|0;IXb(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function _Ub(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=gWb(a,f,b)|0;l=c[k>>2]|0;qRb(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}iWb(j,a,b);jWb(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];hWb(g,e);kWb(j);j=c[f>>2]|0;lWb(a,j,k,mWb(g)|0);k=nWb(g)|0;kWb(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function $Ub(a,b){a=a|0;b=b|0;var c=0;c=i;Y3b(b,a)|0;i=c;return}function aVb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;ZVb(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];RVb(a,f);i=e;return}function bVb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=PVb(a,b)|0;i=c;return d|0}function cVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;SVb(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];RVb(a,e);i=d;return}function dVb(a){a=a|0;var b=0,c=0;b=i;c=MVb(a)|0;i=b;return c|0}function eVb(a){a=a|0;var b=0;b=i;j_b(a);i=b;return}function fVb(a){a=a|0;var b=0;b=i;YZb(a);i=b;return}function gVb(a,b){a=a|0;b=b|0;b=i;FYb(a,0);i=b;return}function hVb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;U4b(d);e=a;c[e>>2]=277332;f=d;c[f>>2]=277352;d=a+8|0;M5b(a,277364|0,d);c[e>>2]=277332;c[f>>2]=277352;ZTb(d);i=b;return}function iVb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(yRb(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){L4b(d,4);i=e;return}else{J4b(d,0);i=e;return}}function jVb(a){a=a|0;var b=0,c=0;b=i;c=HVb(a+8|0)|0;i=b;return c|0}function kVb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=GVb(a,b,S4b(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function lVb(a){a=a|0;var b=0;b=i;if((ARb(a+8|0)|0)!=0){i=b;return}L4b(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function mVb(a){a=a|0;var b=0;b=i;LVb(a,277360);P4b(a+108|0);i=b;return}function nVb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=pVb(a,b)|0;i=c;return d|0}function oVb(a){a=a|0;var b=0;b=i;NZb(a);i=b;return}function pVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=rVb(a)|0;qRb(e);if((f|0)==0){g=0;i=d;return g|0}h=sVb(a)|0;a=f;while(1){f=a+16|0;if(tVb(h,b,f)|0){j=a}else{if(!(uVb(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;qRb(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function qVb(a){a=a|0;var b=0,c=0;b=i;c=bRb(AVb(a+4|0)|0)|0;i=b;return c|0}function rVb(a){a=a|0;var b=0,d=0;b=i;d=c[(qVb(a)|0)>>2]|0;i=b;return d|0}function sVb(a){a=a|0;var b=0,c=0;b=i;c=yVb(a+8|0)|0;i=b;return c|0}function tVb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=vVb(0,b,c)|0;i=a;return d|0}function uVb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=vVb(0,b,c)|0;i=a;return d|0}function vVb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=wVb(b,c)|0;i=a;return d|0}function wVb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(u4b(a,b)|0)<0;i=c;return d|0}function xVb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=zec(a,b,c)|0;i=d;return e|0}function yVb(a){a=a|0;var b=0,c=0;b=i;c=zVb(a)|0;i=b;return c|0}function zVb(a){a=a|0;i=i;return a|0}function AVb(a){a=a|0;var b=0,c=0;b=i;c=BVb(a)|0;i=b;return c|0}function BVb(a){a=a|0;i=i;return a|0}function CVb(a,b){a=a|0;b=b|0;var c=0;a=i;c=EVb(0,b,0)|0;i=a;return c|0}function DVb(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function EVb(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=gec(b)|0;i=c;return a|0}function FVb(a){a=a|0;var b=0,c=0;b=i;c=Eec(a|0)|0;i=b;return c|0}function GVb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;R5b(f,a,1);if(!(U5b(f)|0)){i=e;return a|0}l4b(b);f=0;while(1){g=_4b(Q4b(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(kSb(g,-1)|0){h=2;j=f;break}k=f+1|0;l=lSb(g)|0;if(pSb(l,d)|0){h=0;j=k;break}n4b(b,l);if((V3b(b)|0)==-17){h=4;j=k;break}else{f=k}}L4b(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function HVb(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function IVb(a){a=a|0;var b=0;b=i;mVb(a);iec(a);i=b;return}function JVb(a){a=a|0;var b=0;b=i;mVb(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function KVb(a){a=a|0;var b=0;b=i;IVb(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function LVb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];_Rb(a+8|0);i=d;return}function MVb(a){a=a|0;var b=0,d=0;b=i;d=NVb((c[a>>2]|0)+16|0)|0;i=b;return d|0}function NVb(a){a=a|0;var b=0,c=0;b=i;c=OVb(a)|0;i=b;return c|0}function OVb(a){a=a|0;i=i;return a|0}function PVb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(QVb(a,b)|0)^1;i=c;return d|0}function QVb(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function RVb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];YVb(a,e);i=d;return}function SVb(a,b){a=a|0;b=b|0;var c=0;c=i;TVb(a,UVb(b)|0);i=c;return}function TVb(a,b){a=a|0;b=b|0;var c=0;c=i;XVb(a,b);i=c;return}function UVb(a){a=a|0;var b=0,c=0;b=i;c=bRb(VVb(a+4|0)|0)|0;i=b;return c|0}function VVb(a){a=a|0;var b=0,c=0;b=i;c=WVb(a)|0;i=b;return c|0}function WVb(a){a=a|0;i=i;return a|0}function XVb(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function YVb(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function ZVb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=$Vb(b)|0;_Vb(f,b,d,h,UVb(b)|0);SVb(g,b);do{if(PVb(f,g)|0){h=aWb(b)|0;if(bWb(h,d,cWb(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);SVb(a,b);i=e;return}function _Vb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;qRb(h);a:do{if((e|0)==0){j=f}else{k=aWb(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(fWb(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;qRb(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;qRb(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);TVb(a,j);i=g;return}function $Vb(a){a=a|0;var b=0,d=0;b=i;d=c[(UVb(a)|0)>>2]|0;i=b;return d|0}function aWb(a){a=a|0;var b=0,c=0;b=i;c=dWb(a+8|0)|0;i=b;return c|0}function bWb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=vVb(0,b,c)|0;i=a;return d|0}function cWb(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function dWb(a){a=a|0;var b=0,c=0;b=i;c=eWb(a)|0;i=b;return c|0}function eWb(a){a=a|0;i=i;return a|0}function fWb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=vVb(0,b,c)|0;i=a;return d|0}function gWb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=$Vb(h)|0;qRb(e);if((a|0)==0){j=UVb(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(vVb(0,d,a)|0){m=l;j=c[m>>2]|0;qRb(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(vVb(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;qRb(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function hWb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];cXb(a,e);i=d;return}function iWb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=JWb(d)|0;d=LWb(n,1)|0;MWb(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];KWb(j,d,h);NWb(0,CWb((OWb(j)|0)+16|0)|0,e);e=PWb(j)|0;a[e+4|0]=1;QWb(0,AWb((OWb(j)|0)+28|0)|0);a[e+5|0]=1;RWb(m,j);jWb(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];hWb(b,g);kWb(m);kWb(j);i=f;return}function jWb(a,b){a=a|0;b=b|0;var c=0;c=i;HWb(a,b);i=c;return}function kWb(a){a=a|0;var b=0;b=i;wWb(a);i=b;return}function lWb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;qRb(f);c[e>>2]=0;qRb(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=sWb(a)|0;b=c[c[e>>2]>>2]|0;qRb(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(UVb(a)|0)>>2]|0;aTb(e,c[d>>2]|0);d=tWb(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function mWb(a){a=a|0;var b=0,d=0;b=i;d=c[(qWb(a)|0)>>2]|0;i=b;return d|0}function nWb(a){a=a|0;var b=0,d=0;b=i;d=oWb(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function oWb(a){a=a|0;var b=0,c=0;b=i;c=pWb(a)|0;i=b;return c|0}function pWb(a){a=a|0;i=i;return a|0}function qWb(a){a=a|0;var b=0,c=0;b=i;c=rWb(a)|0;i=b;return c|0}function rWb(a){a=a|0;i=i;return a|0}function sWb(a){a=a|0;i=i;return a|0}function tWb(a){a=a|0;var b=0,c=0;b=i;c=uWb(a+8|0)|0;i=b;return c|0}function uWb(a){a=a|0;var b=0,c=0;b=i;c=vWb(a)|0;i=b;return c|0}function vWb(a){a=a|0;i=i;return a|0}function wWb(a){a=a|0;var b=0;b=i;xWb(a,0);i=b;return}function xWb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=oWb(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}zWb(yWb(e)|0,f);i=d;return}function yWb(a){a=a|0;var b=0,c=0;b=i;c=GWb(a)|0;i=b;return c|0}function zWb(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;BWb(f,CWb(d+16|0)|0)}if((d|0)==0){i=e;return}DWb(c[b>>2]|0,d,1);i=e;return}function AWb(a){a=a|0;i=i;return a|0}function BWb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;FWb(d,0,c);i=b;return}function CWb(a){a=a|0;i=i;return a|0}function DWb(a,b,c){a=a|0;b=b|0;c=c|0;c=i;EWb(0,b,0);i=c;return}function EWb(a,b,c){a=a|0;b=b|0;c=c|0;c=i;iec(b);i=c;return}function FWb(a,b,c){a=a|0;b=b|0;c=c|0;b=i;X3b(c);i=b;return}function GWb(a){a=a|0;i=i;return a+4|0}function HWb(a,b){a=a|0;b=b|0;var c=0;c=i;IWb(a,b);i=c;return}function IWb(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function JWb(a){a=a|0;var b=0,c=0;b=i;c=aXb(a+4|0)|0;i=b;return c|0}function KWb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];UWb(a,b,f);i=e;return}function LWb(a,b){a=a|0;b=b|0;var c=0;a=i;c=TWb(0,b,0)|0;i=a;return c|0}function MWb(a,b){a=a|0;b=b|0;var c=0;c=i;SWb(a,b);i=c;return}function NWb(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}N3b(b,c);i=a;return}function OWb(a){a=a|0;var b=0,d=0;b=i;d=c[(qWb(a)|0)>>2]|0;i=b;return d|0}function PWb(a){a=a|0;var b=0,c=0;b=i;c=yWb(a)|0;i=b;return c|0}function QWb(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function RWb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;HWb(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];hWb(h,f);jWb(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];hWb(a,e);kWb(h);i=d;return}function SWb(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function TWb(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=gec(b<<5)|0;i=c;return a|0}function UWb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(WWb(g)|0)>>2]|0;g=XWb(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];VWb(b,a,f);i=e;return}function VWb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];YWb(a,b,f);i=e;return}function WWb(a){a=a|0;i=i;return a|0}function XWb(a){a=a|0;i=i;return a|0}function YWb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(_Wb(g)|0)>>2]|0;g=$Wb(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];ZWb(b,a,f);i=e;return}function ZWb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(_Wb(f)|0)>>2];f=$Wb(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function _Wb(a){a=a|0;i=i;return a|0}function $Wb(a){a=a|0;i=i;return a|0}function aXb(a){a=a|0;var b=0,c=0;b=i;c=bXb(a)|0;i=b;return c|0}function bXb(a){a=a|0;i=i;return a|0}function cXb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=nWb(dXb(b)|0)|0;h=$Wb(PWb(dXb(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];VWb(g,a,e);i=d;return}function dXb(a){a=a|0;i=i;return c[a>>2]|0}function eXb(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function fXb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];mXb(a,e);i=d;return}function gXb(a,b){a=a|0;b=b|0;var c=0;c=i;hXb(a,iXb(b)|0);i=c;return}function hXb(a,b){a=a|0;b=b|0;var c=0;c=i;lXb(a,b);i=c;return}function iXb(a){a=a|0;var b=0,c=0;b=i;c=bRb(jXb(a+4|0)|0)|0;i=b;return c|0}function jXb(a){a=a|0;var b=0,c=0;b=i;c=kXb(a)|0;i=b;return c|0}function kXb(a){a=a|0;i=i;return a|0}function lXb(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function mXb(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function nXb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=pXb(b)|0;oXb(f,b,d,h,iXb(b)|0);gXb(g,b);do{if(qXb(f,g)|0){h=rXb(b)|0;if(tVb(h,d,sXb(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);gXb(a,b);i=e;return}function oXb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;qRb(h);a:do{if((e|0)==0){j=f}else{k=rXb(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(uVb(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;qRb(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;qRb(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);hXb(a,j);i=g;return}function pXb(a){a=a|0;var b=0,d=0;b=i;d=c[(iXb(a)|0)>>2]|0;i=b;return d|0}function qXb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(eXb(a,b)|0)^1;i=c;return d|0}function rXb(a){a=a|0;var b=0,c=0;b=i;c=tXb(a+8|0)|0;i=b;return c|0}function sXb(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function tXb(a){a=a|0;var b=0,c=0;b=i;c=uXb(a)|0;i=b;return c|0}function uXb(a){a=a|0;i=i;return a|0}function vXb(a,b){a=a|0;b=b|0;b=i;i=i+8|0;wXb(a,b);i=b;return}function wXb(a,b){a=a|0;b=b|0;b=i;xXb(a,0);i=b;return}function xXb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;yXb(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;zXb(f,0,e);e=UVb(b)|0;c[(sWb(b)|0)>>2]=e;i=d;return}function yXb(a){a=a|0;var b=0;b=i;CXb(a);i=b;return}function zXb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;AXb(b,c,f);i=e;return}function AXb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(UTb(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;BXb(d,b,f);i=e;return}function BXb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(UTb(e)|0)>>2];i=d;return}function CXb(a){a=a|0;var b=0;b=i;DXb(a);i=b;return}function DXb(a){a=a|0;var b=0;b=i;XTb(a);i=b;return}function EXb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=EYb(h)|0;qRb(e);if((a|0)==0){j=RXb(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(nRb(0,d,a)|0){m=l;j=c[m>>2]|0;qRb(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(nRb(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;qRb(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function FXb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];CYb(a,e);i=d;return}function GXb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=hYb(d)|0;d=jYb(n,1)|0;kYb(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];iYb(j,d,h);lYb(0,mTb((mYb(j)|0)+16|0)|0,e);e=nYb(j)|0;a[e+4|0]=1;oYb(0,aYb((mYb(j)|0)+20|0)|0);a[e+5|0]=1;pYb(m,j);HXb(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];FXb(b,g);IXb(m);IXb(j);i=f;return}function HXb(a,b){a=a|0;b=b|0;var c=0;c=i;fYb(a,b);i=c;return}function IXb(a){a=a|0;var b=0;b=i;XXb(a);i=b;return}function JXb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;qRb(f);c[e>>2]=0;qRb(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=QXb(a)|0;b=c[c[e>>2]>>2]|0;qRb(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(RXb(a)|0)>>2]|0;aTb(e,c[d>>2]|0);d=SXb(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function KXb(a){a=a|0;var b=0,d=0;b=i;d=c[(OXb(a)|0)>>2]|0;i=b;return d|0}function LXb(a){a=a|0;var b=0,d=0;b=i;d=MXb(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function MXb(a){a=a|0;var b=0,c=0;b=i;c=NXb(a)|0;i=b;return c|0}function NXb(a){a=a|0;i=i;return a|0}function OXb(a){a=a|0;var b=0,c=0;b=i;c=PXb(a)|0;i=b;return c|0}function PXb(a){a=a|0;i=i;return a|0}function QXb(a){a=a|0;i=i;return a|0}function RXb(a){a=a|0;var b=0,c=0;b=i;c=bRb(VXb(a+4|0)|0)|0;i=b;return c|0}function SXb(a){a=a|0;var b=0,c=0;b=i;c=TXb(a+8|0)|0;i=b;return c|0}function TXb(a){a=a|0;var b=0,c=0;b=i;c=UXb(a)|0;i=b;return c|0}function UXb(a){a=a|0;i=i;return a|0}function VXb(a){a=a|0;var b=0,c=0;b=i;c=WXb(a)|0;i=b;return c|0}function WXb(a){a=a|0;i=i;return a|0}function XXb(a){a=a|0;var b=0;b=i;YXb(a,0);i=b;return}function YXb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=MXb(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}_Xb(ZXb(e)|0,f);i=d;return}function ZXb(a){a=a|0;var b=0,c=0;b=i;c=eYb(a)|0;i=b;return c|0}function _Xb(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;$Xb(f,aYb(d+20|0)|0)}if((d|0)==0){i=e;return}bYb(c[b>>2]|0,d,1);i=e;return}function $Xb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;dYb(d,0,c);i=b;return}function aYb(a){a=a|0;i=i;return a|0}function bYb(a,b,c){a=a|0;b=b|0;c=c|0;c=i;cYb(0,b,0);i=c;return}function cYb(a,b,c){a=a|0;b=b|0;c=c|0;c=i;iec(b);i=c;return}function dYb(a,b,c){a=a|0;b=b|0;c=c|0;b=i;oVb(c);i=b;return}function eYb(a){a=a|0;i=i;return a+4|0}function fYb(a,b){a=a|0;b=b|0;var c=0;c=i;gYb(a,b);i=c;return}function gYb(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function hYb(a){a=a|0;var b=0,c=0;b=i;c=AYb(a+4|0)|0;i=b;return c|0}function iYb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];sYb(a,b,f);i=e;return}function jYb(a,b){a=a|0;b=b|0;var c=0;a=i;c=rYb(0,b,0)|0;i=a;return c|0}function kYb(a,b){a=a|0;b=b|0;var c=0;c=i;qYb(a,b);i=c;return}function lYb(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function mYb(a){a=a|0;var b=0,d=0;b=i;d=c[(OXb(a)|0)>>2]|0;i=b;return d|0}function nYb(a){a=a|0;var b=0,c=0;b=i;c=ZXb(a)|0;i=b;return c|0}function oYb(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}gVb(b,a);i=a;return}function pYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;fYb(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];FXb(h,f);HXb(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];FXb(a,e);IXb(h);i=d;return}function qYb(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function rYb(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=gec(b<<5)|0;i=c;return a|0}function sYb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(uYb(g)|0)>>2]|0;g=vYb(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];tYb(b,a,f);i=e;return}function tYb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];wYb(a,b,f);i=e;return}function uYb(a){a=a|0;i=i;return a|0}function vYb(a){a=a|0;i=i;return a|0}function wYb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(yYb(g)|0)>>2]|0;g=zYb(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];xYb(b,a,f);i=e;return}function xYb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(yYb(f)|0)>>2];f=zYb(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function yYb(a){a=a|0;i=i;return a|0}function zYb(a){a=a|0;i=i;return a|0}function AYb(a){a=a|0;var b=0,c=0;b=i;c=BYb(a)|0;i=b;return c|0}function BYb(a){a=a|0;i=i;return a|0}function CYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=LXb(DYb(b)|0)|0;h=zYb(nYb(DYb(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];tYb(g,a,e);i=d;return}function DYb(a){a=a|0;i=i;return c[a>>2]|0}function EYb(a){a=a|0;var b=0,d=0;b=i;d=c[(RXb(a)|0)>>2]|0;i=b;return d|0}function FYb(a,b){a=a|0;b=b|0;b=i;i=i+8|0;GYb(a,b);i=b;return}function GYb(a,b){a=a|0;b=b|0;b=i;HYb(a,0);i=b;return}function HYb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;IYb(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;JYb(f,0,e);e=iXb(b)|0;c[(KYb(b)|0)>>2]=e;i=d;return}function IYb(a){a=a|0;var b=0;b=i;NYb(a);i=b;return}function JYb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;LYb(b,c,f);i=e;return}function KYb(a){a=a|0;i=i;return a|0}function LYb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(UTb(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;MYb(d,b,f);i=e;return}function MYb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(UTb(e)|0)>>2];i=d;return}function NYb(a){a=a|0;var b=0;b=i;OYb(a);i=b;return}function OYb(a){a=a|0;var b=0;b=i;XTb(a);i=b;return}function PYb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=pXb(h)|0;qRb(e);if((a|0)==0){j=iXb(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(vVb(0,d,a)|0){m=l;j=c[m>>2]|0;qRb(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(vVb(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;qRb(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function QYb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];LZb(a,e);i=d;return}function RYb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=qZb(d)|0;d=sZb(n,1)|0;tZb(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];rZb(j,d,h);uZb(0,CWb((vZb(j)|0)+16|0)|0,e);e=wZb(j)|0;a[e+4|0]=1;xZb(0,hZb((vZb(j)|0)+28|0)|0);a[e+5|0]=1;yZb(m,j);SYb(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];QYb(b,g);TYb(m);TYb(j);i=f;return}function SYb(a,b){a=a|0;b=b|0;var c=0;c=i;oZb(a,b);i=c;return}function TYb(a){a=a|0;var b=0;b=i;cZb(a);i=b;return}function UYb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;qRb(f);c[e>>2]=0;qRb(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=KYb(a)|0;b=c[c[e>>2]>>2]|0;qRb(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(iXb(a)|0)>>2]|0;aTb(e,c[d>>2]|0);d=$Yb(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function VYb(a){a=a|0;var b=0,d=0;b=i;d=c[(ZYb(a)|0)>>2]|0;i=b;return d|0}function WYb(a){a=a|0;var b=0,d=0;b=i;d=XYb(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function XYb(a){a=a|0;var b=0,c=0;b=i;c=YYb(a)|0;i=b;return c|0}function YYb(a){a=a|0;i=i;return a|0}function ZYb(a){a=a|0;var b=0,c=0;b=i;c=_Yb(a)|0;i=b;return c|0}function _Yb(a){a=a|0;i=i;return a|0}function $Yb(a){a=a|0;var b=0,c=0;b=i;c=aZb(a+8|0)|0;i=b;return c|0}function aZb(a){a=a|0;var b=0,c=0;b=i;c=bZb(a)|0;i=b;return c|0}function bZb(a){a=a|0;i=i;return a|0}function cZb(a){a=a|0;var b=0;b=i;dZb(a,0);i=b;return}function dZb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=XYb(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}fZb(eZb(e)|0,f);i=d;return}function eZb(a){a=a|0;var b=0,c=0;b=i;c=nZb(a)|0;i=b;return c|0}function fZb(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;gZb(f,hZb(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;iZb(f,CWb(d+16|0)|0)}if((d|0)==0){i=e;return}jZb(c[b>>2]|0,d,1);i=e;return}function gZb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;mZb(d,0,c);i=b;return}function hZb(a){a=a|0;i=i;return a|0}function iZb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;lZb(d,0,c);i=b;return}function jZb(a,b,c){a=a|0;b=b|0;c=c|0;c=i;kZb(0,b,0);i=c;return}function kZb(a,b,c){a=a|0;b=b|0;c=c|0;c=i;iec(b);i=c;return}function lZb(a,b,c){a=a|0;b=b|0;c=c|0;b=i;X3b(c);i=b;return}function mZb(a,b,c){a=a|0;b=b|0;c=c|0;b=i;X3b(c);i=b;return}function nZb(a){a=a|0;i=i;return a+4|0}function oZb(a,b){a=a|0;b=b|0;var c=0;c=i;pZb(a,b);i=c;return}function pZb(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function qZb(a){a=a|0;var b=0,c=0;b=i;c=JZb(a+4|0)|0;i=b;return c|0}function rZb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];BZb(a,b,f);i=e;return}function sZb(a,b){a=a|0;b=b|0;var c=0;a=i;c=AZb(0,b,0)|0;i=a;return c|0}function tZb(a,b){a=a|0;b=b|0;var c=0;c=i;zZb(a,b);i=c;return}function uZb(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}N3b(b,c);i=a;return}function vZb(a){a=a|0;var b=0,d=0;b=i;d=c[(ZYb(a)|0)>>2]|0;i=b;return d|0}function wZb(a){a=a|0;var b=0,c=0;b=i;c=eZb(a)|0;i=b;return c|0}function xZb(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}L3b(b);i=a;return}function yZb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;oZb(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];QYb(h,f);SYb(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];QYb(a,e);TYb(h);i=d;return}function zZb(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function AZb(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=gec(b*40|0)|0;i=c;return a|0}function BZb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(DZb(g)|0)>>2]|0;g=EZb(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];CZb(b,a,f);i=e;return}function CZb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];FZb(a,b,f);i=e;return}function DZb(a){a=a|0;i=i;return a|0}function EZb(a){a=a|0;i=i;return a|0}function FZb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(HZb(g)|0)>>2]|0;g=IZb(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];GZb(b,a,f);i=e;return}function GZb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(HZb(f)|0)>>2];f=IZb(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function HZb(a){a=a|0;i=i;return a|0}function IZb(a){a=a|0;i=i;return a|0}function JZb(a){a=a|0;var b=0,c=0;b=i;c=KZb(a)|0;i=b;return c|0}function KZb(a){a=a|0;i=i;return a|0}function LZb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=WYb(MZb(b)|0)|0;h=IZb(wZb(MZb(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];CZb(g,a,e);i=d;return}function MZb(a){a=a|0;i=i;return c[a>>2]|0}function NZb(a){a=a|0;var b=0;b=i;OZb(a);i=b;return}function OZb(a){a=a|0;var b=0;b=i;PZb(a);i=b;return}function PZb(a){a=a|0;var b=0;b=i;QZb(a,pXb(a)|0);i=b;return}function QZb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;qRb(d);if((b|0)==0){i=d;return}QZb(a,c[b>>2]|0);QZb(a,c[b+4>>2]|0);e=qZb(a)|0;RZb(e,SZb(b+16|0)|0);jZb(e,b,1);i=d;return}function RZb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;TZb(d,0,c);i=b;return}function SZb(a){a=a|0;i=i;return a|0}function TZb(a,b,c){a=a|0;b=b|0;c=c|0;b=i;UZb(c);i=b;return}function UZb(a){a=a|0;var b=0;b=i;VZb(a);i=b;return}function VZb(a){a=a|0;var b=0;b=i;WZb(a);i=b;return}function WZb(a){a=a|0;var b=0;b=i;XZb(a);i=b;return}function XZb(a){a=a|0;var b=0;b=i;X3b(a+12|0);X3b(a);i=b;return}function YZb(a){a=a|0;var b=0;b=i;ZZb(a+180|0);ZZb(a+168|0);ZZb(a+156|0);ZZb(a+144|0);ZZb(a+132|0);ZZb(a+120|0);ZZb(a+108|0);ZZb(a+96|0);ZZb(a+84|0);ZZb(a+72|0);ZZb(a+60|0);ZZb(a+48|0);ZZb(a+36|0);ZZb(a+24|0);oVb(a+12|0);oVb(a);i=b;return}function ZZb(a){a=a|0;var b=0;b=i;_Zb(a);i=b;return}function _Zb(a){a=a|0;var b=0;b=i;$Zb(a);i=b;return}function $Zb(a){a=a|0;var b=0;b=i;a_b(a);i=b;return}function a_b(a){a=a|0;var b=0;b=i;b_b(a,EYb(a)|0);i=b;return}function b_b(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;qRb(d);if((b|0)==0){i=d;return}b_b(a,c[b>>2]|0);b_b(a,c[b+4>>2]|0);e=hYb(a)|0;c_b(e,d_b(b+16|0)|0);bYb(e,b,1);i=d;return}function c_b(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;e_b(d,0,c);i=b;return}function d_b(a){a=a|0;i=i;return a|0}function e_b(a,b,c){a=a|0;b=b|0;c=c|0;b=i;f_b(c);i=b;return}function f_b(a){a=a|0;var b=0;b=i;g_b(a);i=b;return}function g_b(a){a=a|0;var b=0;b=i;h_b(a);i=b;return}function h_b(a){a=a|0;var b=0;b=i;i_b(a);i=b;return}function i_b(a){a=a|0;var b=0;b=i;oVb(a+4|0);i=b;return}function j_b(a){a=a|0;var b=0;b=i;k_b(a);i=b;return}function k_b(a){a=a|0;var b=0;b=i;l_b(a);i=b;return}function l_b(a){a=a|0;var b=0;b=i;m_b(a,$Vb(a)|0);i=b;return}function m_b(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;qRb(d);if((b|0)==0){i=d;return}m_b(a,c[b>>2]|0);m_b(a,c[b+4>>2]|0);e=JWb(a)|0;n_b(e,OVb(b+16|0)|0);DWb(e,b,1);i=d;return}function n_b(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;o_b(d,0,c);i=b;return}function o_b(a,b,c){a=a|0;b=b|0;c=c|0;b=i;p_b(c);i=b;return}function p_b(a){a=a|0;var b=0;b=i;q_b(a);i=b;return}function q_b(a){a=a|0;var b=0;b=i;r_b(a);i=b;return}function r_b(a){a=a|0;var b=0;b=i;s_b(a);i=b;return}function s_b(a){a=a|0;var b=0;b=i;X3b(a);i=b;return}function t_b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;u_b(a);w_b(g,b);x_b(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];v_b(a,f,e);i=d;return a|0}function u_b(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;QZb(a,pXb(a)|0);c[($Yb(a)|0)>>2]=0;d=iXb(a)|0;c[(KYb(a)|0)>>2]=d;qRb(b);c[d>>2]=0;i=b;return}function v_b(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;F_b(h,a);if(!(G_b(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];y_b(j,g);o=I_b(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];H_b(l,a,f,o);J_b(b)|0;}while(G_b(b,d)|0);i=e;return}function w_b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;D_b(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];y_b(a,e);i=d;return}function x_b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;z_b(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];y_b(a,e);i=d;return}function y_b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];C_b(a,e);i=d;return}function z_b(a,b){a=a|0;b=b|0;var c=0;c=i;A_b(a,qVb(b)|0);i=c;return}function A_b(a,b){a=a|0;b=b|0;var c=0;c=i;B_b(a,b);i=c;return}function B_b(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function C_b(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function D_b(a,b){a=a|0;b=b|0;var d=0;d=i;A_b(a,c[(E_b(b)|0)>>2]|0);i=d;return}



function LGb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=Eec(d|0)|0;switch(c[b>>2]|0){case 3:case 2:case 1:{q=o;L1b(q,d,1,p);p=a[q]|0;do{if((p+ -97<<24>>24&255)<26){r=p+ -32<<24>>24;a[q]=r;s=o+1|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+2|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+3|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+4|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+5|0;t=a[s]|0;if(!((t+ -97<<24>>24&255)<26)){u=r;break}a[s]=t+ -32<<24>>24;u=r}else{u=p}}while(0);p=u<<24>>24==83;q=u<<24>>24==68;r=p|q;if(!(u<<24>>24==67|u<<24>>24==68|u<<24>>24==83|u<<24>>24==90)){v=1;i=k;return v|0}t=l;L1b(t,o+1|0,1,2);l=m;L1b(l,o+3|0,1,3);o=n;L1b(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==3){if((K1b(t,222592,1,2)|0)==0){if((K1b(l,222608,1,3)|0)==0){v=128;i=k;return v|0}if((K1b(l,222616,1,3)|0)==0){v=128;i=k;return v|0}if((K1b(l,222624,1,3)|0)==0){v=128;i=k;return v|0}if((K1b(l,222632,1,3)|0)==0){v=128;i=k;return v|0}if((K1b(l,222640,1,3)|0)==0){v=128;i=k;return v|0}n=(K1b(l,222648,1,3)|0)==0;v=n?128:0;i=k;return v|0}if((K1b(t,222672,1,2)|0)==0){if(!(u<<24>>24==68|u<<24>>24==83)){v=0;i=k;return v|0}n=(K1b(l,222680,1,3)|0)==0;v=n?32:0;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=138}else if(u<<24>>24==68|u<<24>>24==83){w=141}else{v=0;i=k;return v|0}do{if((w|0)==138){if((K1b(t,222696,1,2)|0)==0){n=(K1b(l,222680,1,3)|0)==0;v=n?32:0;i=k;return v|0}else{if(u<<24>>24==68|u<<24>>24==83){w=141;break}else if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}}}while(0);do{if((w|0)==141){if((K1b(t,222704,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((K1b(o,222712,1,2)|0)!=0){if((K1b(o,222720,1,2)|0)==0){break}if((K1b(o,222728,1,2)|0)==0){break}if((K1b(o,222736,1,2)|0)==0){break}if((K1b(o,222744,1,2)|0)==0){break}if((K1b(o,222752,1,2)|0)==0){break}if((K1b(o,222760,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}}while(0);if((K1b(t,222768,1,2)|0)!=0){v=0;i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((K1b(o,222712,1,2)|0)!=0){if((K1b(o,222720,1,2)|0)==0){break}if((K1b(o,222728,1,2)|0)==0){break}if((K1b(o,222736,1,2)|0)==0){break}if((K1b(o,222744,1,2)|0)==0){break}if((K1b(o,222752,1,2)|0)==0){break}if((K1b(o,222760,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}else if((m|0)==2){if((K1b(t,222592,1,2)|0)==0){if((K1b(l,222608,1,3)|0)==0){v=2;i=k;return v|0}if((K1b(l,222616,1,3)|0)==0){v=2;i=k;return v|0}if((K1b(l,222624,1,3)|0)==0){v=2;i=k;return v|0}if((K1b(l,222632,1,3)|0)==0){v=2;i=k;return v|0}if((K1b(l,222640,1,3)|0)==0){v=2;i=k;return v|0}if((K1b(l,222648,1,3)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}if((K1b(t,222672,1,2)|0)==0){m=(K1b(l,222600,1,3)|0)==0;if(m|(p|q)^1){v=m?8:2;i=k;return v|0}v=2;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=91}else if(u<<24>>24==68|u<<24>>24==83){w=94}else{v=2;i=k;return v|0}do{if((w|0)==91){if((K1b(t,222696,1,2)|0)==0){v=2;i=k;return v|0}else{if(u<<24>>24==68|u<<24>>24==83){w=94;break}else if(u<<24>>24==67|u<<24>>24==90){break}else{v=2}i=k;return v|0}}}while(0);do{if((w|0)==94){if((K1b(t,222704,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=2}i=k;return v|0}m=a[l]|0;if(m<<24>>24==71){if((K1b(o,222712,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222720,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222728,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222736,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222744,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222752,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(m<<24>>24==77){if((K1b(o,222712,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222720,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222728,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222736,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222744,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222752,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}}while(0);if((K1b(t,222768,1,2)|0)!=0){v=2;i=k;return v|0}m=a[l]|0;if(m<<24>>24==77){if((K1b(o,222712,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222720,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222728,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222736,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222744,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222752,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(m<<24>>24==71){if((K1b(o,222712,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222720,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222728,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222736,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222744,1,2)|0)==0){v=2;i=k;return v|0}if((K1b(o,222752,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}else{if((K1b(t,222592,1,2)|0)==0){if((K1b(l,222600,1,3)|0)==0){v=64;i=k;return v|0}if((K1b(l,222608,1,3)|0)==0){v=32;i=k;return v|0}if((K1b(l,222616,1,3)|0)==0){v=32;i=k;return v|0}if((K1b(l,222624,1,3)|0)==0){v=32;i=k;return v|0}if((K1b(l,222632,1,3)|0)==0){v=32;i=k;return v|0}if((K1b(l,222640,1,3)|0)==0){v=32;i=k;return v|0}if((K1b(l,222648,1,3)|0)==0){v=32;i=k;return v|0}m=(K1b(l,222656,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((K1b(t,222664,1,2)|0)==0){m=(K1b(l,222600,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((K1b(t,222672,1,2)|0)==0){m=(K1b(l,222600,1,3)|0)==0;if(m|r^1){v=m?64:1;i=k;return v|0}m=(K1b(l,222680,1,3)|0)==0;if(m){v=m?32:1;i=k;return v|0}m=(K1b(l,222688,1,3)|0)==0;v=m?64:1;i=k;return v|0}do{if(u<<24>>24==68|u<<24>>24==83){w=29}else if(u<<24>>24==67|u<<24>>24==90){if((K1b(t,222696,1,2)|0)!=0){if(u<<24>>24==68|u<<24>>24==83){w=29;break}else if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}if((K1b(l,222600,1,3)|0)==0){v=64;i=k;return v|0}if((K1b(l,222680,1,3)|0)==0){v=32;i=k;return v|0}m=(K1b(l,222688,1,3)|0)==0;v=m?64:1;i=k;return v|0}}while(0);do{if((w|0)==29){if((K1b(t,222704,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}m=a[l]|0;if(m<<24>>24==71){do{if((K1b(o,222712,1,2)|0)!=0){if((K1b(o,222720,1,2)|0)==0){break}if((K1b(o,222728,1,2)|0)==0){break}if((K1b(o,222736,1,2)|0)==0){break}if((K1b(o,222744,1,2)|0)==0){break}if((K1b(o,222752,1,2)|0)==0){break}if((K1b(o,222760,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==77){do{if((K1b(o,222712,1,2)|0)!=0){if((K1b(o,222720,1,2)|0)==0){break}if((K1b(o,222728,1,2)|0)==0){break}if((K1b(o,222736,1,2)|0)==0){break}if((K1b(o,222744,1,2)|0)==0){break}if((K1b(o,222752,1,2)|0)==0){break}if((K1b(o,222760,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);do{if((w|0)==48){if((K1b(t,222768,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==77){do{if((K1b(o,222712,1,2)|0)!=0){if((K1b(o,222720,1,2)|0)==0){break}if((K1b(o,222728,1,2)|0)==0){break}if((K1b(o,222736,1,2)|0)==0){break}if((K1b(o,222744,1,2)|0)==0){break}if((K1b(o,222752,1,2)|0)==0){break}if((K1b(o,222760,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==71){do{if((K1b(o,222712,1,2)|0)!=0){if((K1b(o,222720,1,2)|0)==0){break}if((K1b(o,222728,1,2)|0)==0){break}if((K1b(o,222736,1,2)|0)==0){break}if((K1b(o,222744,1,2)|0)==0){break}if((K1b(o,222752,1,2)|0)==0){break}if((K1b(o,222760,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);if((K1b(t,222776,1,2)|0)==0){if((K1b(l,222600,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[j>>2]|0)<65?1:32;i=k;return v|0}if((K1b(t,222784,1,2)|0)==0){if((K1b(l,222600,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[g>>2]|0)<65?1:32;i=k;return v|0}if((K1b(t,222752,1,2)|0)==0){o=(K1b(l,222656,1,3)|0)==0;v=o?64:1;i=k;return v|0}if((K1b(t,222792,1,2)|0)==0){o=(K1b(l,222800,1,3)|0)==0;v=o?64:1;i=k;return v|0}if(!(u<<24>>24==68|u<<24>>24==83)){v=1;i=k;return v|0}if((K1b(t,222808,1,2)|0)==0){i=k;return 1}else{v=1;i=k;return v|0}}break};case 10:{v=MGb(222824,222832,222840)|0;i=k;return v|0};case 11:{v=MGb(222848,222832,222840)|0;i=k;return v|0};case 16:case 15:case 14:case 13:case 12:{v=NGb(b,d,e,f,g,h,j)|0;i=k;return v|0};case 4:{v=6;i=k;return v|0};case 5:{v=2;i=k;return v|0};case 6:{j=c[f>>2]|0;f=c[g>>2]|0;v=~~(+(((j|0)>(f|0)?f:j)|0)*1.600000023841858);i=k;return v|0};case 7:{v=1;i=k;return v|0};case 8:{v=50;i=k;return v|0};case 9:{v=25;i=k;return v|0};default:{v=-1;i=k;return v|0}}return 0}function MGb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function NGb(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(J1b(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 15:{p=o;i=j;return p|0};case 12:{p=75;i=j;return p|0};case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 14:{p=14;i=j;return p|0};case 16:{n=(o|0)>13;i=j;return(n?2:n&1)|0};default:{p=-1;i=j;return p|0}}return 0}function OGb(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=PGb(a,0,0)|0;i=b;return c|0}function PGb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=QGb(a,b,c,0)|0;i=d;return e|0}function QGb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=ge[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=aec(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=48;c[f+8>>2]=463}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=ge[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){de[c[b+8>>2]&511](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=ge[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){de[c[b+20>>2]&511](c[j+392>>2]|0);de[c[j+20>>2]&511](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=$Hb(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}de[c[j+20>>2]&511](c[j+44>>2]|0);de[c[j+20>>2]&511](c[j+392>>2]|0);de[c[j+20>>2]&511](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;aIb(j+416|0,j+12|0);aIb(j+440|0,j+12|0);SGb(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}VGb(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=uIb()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=lIb()|0}k=j;l=k;i=g;return l|0}function RGb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function SGb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=36;DKb(f+256|0);if((b|0)!=0){g=TGb(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;mIb(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function TGb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((iHb(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function UGb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((iHb(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((iHb(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=lHb(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=TGb(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((iHb(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((iHb(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((pHb(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((iHb(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=lHb(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function VGb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;de[c[e+20>>2]&511](c[g+36>>2]|0);WGb(c[g+44>>2]|0,e);de[c[e+20>>2]&511](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;de[c[e+20>>2]&511](f)}WGb(c[h+376>>2]|0,e);WGb(c[e+372>>2]|0,e);XGb(e+416|0);XGb(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}YGb(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);de[c[e+20>>2]&511](c[e+392>>2]|0);de[c[e+20>>2]&511](c[e+464>>2]|0);de[c[e+20>>2]&511](c[e+8>>2]|0);de[c[e+20>>2]&511](c[e+44>>2]|0);de[c[e+20>>2]&511](c[e+396>>2]|0);de[c[e+20>>2]&511](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){de[c[e+252>>2]&511](c[e+244>>2]|0)}de[c[e+20>>2]&511](e);i=d;return}function WGb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;de[c[a+20>>2]&511](c[b+16>>2]|0);de[c[a+20>>2]&511](b)}i=d;return}function XGb(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;de[c[(c[d+20>>2]|0)+8>>2]&511](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;de[c[(c[d+20>>2]|0)+8>>2]&511](a);a=e}i=b;return}function YGb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;jHb(f,g+20|0);while(1){d=kHb(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}de[c[b+8>>2]&511](c[d+20>>2]|0)}oHb(g);oHb(g+132|0);oHb(g+20|0);oHb(g+40|0);oHb(g+60|0);XGb(g+80|0);XGb(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;de[m&511](o);i=e;return}de[c[b+8>>2]&511](c[g+184>>2]|0);de[c[b+8>>2]&511](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;de[m&511](o);i=e;return}function ZGb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function _Gb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function $Gb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}else if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((aHb(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=cHb(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{Gec(f|0,b|0,d|0)|0;j=dHb(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=De[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=37;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==3){Ee[c[(c[h+144>>2]|0)+52>>2]&31](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}else if((d|0)==1|(d|0)==0){c[h+480>>2]=2}j=1;k=j;i=g;return k|0}function aHb(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=ZHb()|0}if((a[e+236|0]|0)!=0){f=UGb(e,224632)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function bHb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function cHb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;Hec(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=ge[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;Gec(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;de[c[e+20>>2]&511](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function dHb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}else if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((aHb(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}else if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=De[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=37;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}else if((b|0)==3){e=2}}while(0);Ee[c[(c[g+144>>2]|0)+52>>2]&31](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function eHb(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function fHb(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}Ee[c[(c[d+144>>2]|0)+52>>2]&31](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function gHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){Ae[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];ae[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];Ae[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function hHb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[222856+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function iHb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;Gec((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=ue[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=ge[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){Gec(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function jHb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function kHb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function lHb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=ge[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){Iec(c[m>>2]|0,0,g|0)|0;g=mHb(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=mHb(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((nHb(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=ge[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}Iec(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=mHb(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}de[c[(c[b+16>>2]|0)+8>>2]&511](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=ge[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){Iec(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function mHb(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function nHb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function oHb(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}de[e&511](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}de[e&511](c[d>>2]|0);i=b;return}function pHb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[224440+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[224480+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=ue[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=ge[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=ge[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}de[c[j+20>>2]&511](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;Gec(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}Ae[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function qHb(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((le[((a[e+236|0]&255|0)!=0?33:34)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=YHb(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function rHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=De[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=sHb(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function sHb(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=ve[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;t=l;do{if((c[o+492>>2]|0)!=0){u=uHb(t+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=273;break a}v=lHb(o,l+132|0,u,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((v|0)==0){r=279;break a}if((a[v+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((v|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}Ae[c[o+120>>2]&15](c[o+4>>2]|0,u,1);h=0;break c}}while(0);if((a[v+32|0]|0)!=0){r=287;break a}if((c[v+4>>2]|0)!=0){w=HHb(o,v,((s|0)==60?1:0)&255)|0;if((w|0)!=0){r=290;break a}h=0;break c}u=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[u+130|0]|0;break c}a[u+131|0]=0;a[v+32|0]=1;u=(ve[c[o+112>>2]&63](c[o+116>>2]|0,0,c[v+20>>2]|0,c[v+16>>2]|0,c[v+24>>2]|0)|0)!=0;a[v+32|0]=0;if(!u){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[t+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((ge[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{x=1;r=319;break};case 52:{x=2;r=319;break};case 54:{x=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=xHb(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){t=ge[c[o+12>>2]&127](20)|0;if((t|0)==0){r=309;break a}c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[t+16>>2]=0;c[t>>2]=(s|0)==41?2:1;c[q>>2]=e;Ae[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,t);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{x=0;r=319;break};case 47:{x=1;r=334;break};case 46:{x=2;r=334;break};case 48:{x=3;r=334;break};case 45:{x=0;r=334;break};case 56:{if((KHb(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((JHb(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=xHb(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){y=224616}else{y=(s|0)==32?224600:224624}if((zHb(o+416|0,y)|0)==0){r=111;break a}if((AHb(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=224520;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=224528;r=102;break};case 25:{c[o+332>>2]=224536;r=102;break};case 26:{c[o+332>>2]=224544;r=102;break};case 27:{c[o+332>>2]=224552;r=102;break};case 28:{c[o+332>>2]=224560;r=102;break};case 29:{c[o+332>>2]=224576;r=102;break};case 30:{c[o+332>>2]=224584;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((BHb(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((iHb(o+416|0)|0)<<24>>24!=0)){r=128;break a}}t=o+428|0;u=c[t>>2]|0;c[t>>2]=u+1;a[u]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((iHb(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;t=c[u>>2]|0;c[u>>2]=t+1;a[t]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;oe[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);RGb(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;t=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=uHb(t+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[t+324>>2]=224512}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ge[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=lHb(o,l+132|0,224512,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}z=CHb(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((z|0)!=0){r=132;break a}t=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((BHb(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,t,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((iHb(o+416|0)|0)<<24>>24!=0)){r=145;break a}}u=o+428|0;A=c[u>>2]|0;c[u>>2]=A+1;a[A]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((iHb(o+416|0)|0)<<24>>24!=0)){r=145;break a}}A=o+428|0;u=c[A>>2]|0;c[A>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;oe[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,t,(s|0)==38|0);RGb(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}B=DHb(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;u=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=u;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;te[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=u}}while(0);if((B|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;te[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}u=uHb(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=u;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;oe[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;te[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((le[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}u=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[u+16>>2];c[o+316>>2]=0;break c}t=uHb(u,b,e,c[n>>2]|0)|0;if((t|0)==0){r=190;break a}c[o+316>>2]=lHb(o,l,t,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}u=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(t|0)){c[l+92>>2]=c[u+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[u+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{u=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[u+16>>2];c[o+316>>2]=0;break c}t=uHb(u,b,e,c[n>>2]|0)|0;if((t|0)==0){r=202;break a}c[o+316>>2]=lHb(o,l+132|0,t,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}u=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(t|0)){c[l+92>>2]=c[u+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[u+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){D=1}else{D=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(D^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 58:{if((c[o+80>>2]|0)!=0){gHb(o,b,e,c[n>>2]|0)}h=0;E=EHb(o,b,n,f,j,k)|0;if((E|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=uHb(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 21:{if((De[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}u=uHb(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=220;break a}vHb(u);c[o+340>>2]=u;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}u=uHb(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=225;break a}c[q>>2]=e;ae[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,u,c[o+340>>2]|0);h=0}}while(0);RGb(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;ae[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);RGb(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){u=o+12|0;if((c[o+468>>2]|0)==0){t=c[u>>2]|0;c[o+468>>2]=32;c[o+464>>2]=ge[t&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}t=c[u+4>>2]|0;u=c[o+464>>2]|0;A=o+468|0;F=c[A>>2]<<1;c[A>>2]=F;A=ue[t&63](u,F)|0;if((A|0)==0){r=245;break a}c[o+464>>2]=A;if((c[l+184>>2]|0)==0){break}A=ue[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((A|0)==0){r=248;break a}c[l+184>>2]=A}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}A=GHb(o)|0;if((A|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=A;F=l+180|0;c[F>>2]=(c[F>>2]|0)+1;c[(c[l+164>>2]|0)+(A*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 1:{G=tHb(o,0,e,c[n>>2]|0)|0;if((G|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=lHb(o,l+132|0,224512,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((De[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}A=uHb(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((A|0)==0){r=43;break a}vHb(A);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=A;h=0;r=47;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=uHb(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 7:{if((c[o+84>>2]|0)==0){break c}ae[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;RGb(o+416|0);h=0;break};case 57:{H=tHb(o,1,e,c[n>>2]|0)|0;if((H|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=yHb(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){ae[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);RGb(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;A=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}F=lHb(o,l+132|0,224512,36)|0;if((F|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[F+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((ve[c[o+112>>2]&63](c[o+116>>2]|0,0,c[F+20>>2]|0,c[F+16>>2]|0,c[F+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=A;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ge[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}de[c[o+88>>2]&511](c[o+4>>2]|0);h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((De[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=uHb(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((x|0)==0){I=s}else{I=s+(0-(c[b+68>>2]|0))|0}s=GHb(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=x;A=xHb(o,b,e,I)|0;if((A|0)==0){r=325;break a}F=c[A>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=F;s=0;do{A=s;s=A+1|0;}while((a[F+A|0]|0)!=0);F=l+168|0;c[F>>2]=(c[F>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}F=l+180|0;c[F>>2]=(c[F>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=x;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){F=IHb(o)|0;if((F|0)==0){r=340;break a}c[q>>2]=e;Ae[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,F)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}F=uHb(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((F|0)==0){r=50;break a}vHb(F);c[(c[o+316>>2]|0)+24>>2]=F;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}gHb(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=De[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;J=0;K=J;i=m;return K|0}else if((r|0)==9){c[p>>2]=c[n>>2];J=4;K=J;i=m;return K|0}else if((r|0)==10){J=5;K=J;i=m;return K|0}else if((r|0)==11){J=6;K=J;i=m;return K|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;J=0;K=J;i=m;return K|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}J=3;K=J;i=m;return K|0}}while(0);if((ve[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){J=29;K=J;i=m;return K|0}else{c[j>>2]=e;J=0;K=J;i=m;return K|0}}else if((r|0)==25){J=G;K=J;i=m;return K|0}else if((r|0)==29){J=1;K=J;i=m;return K|0}else if((r|0)==35){J=H;K=J;i=m;return K|0}else if((r|0)==38){J=1;K=J;i=m;return K|0}else if((r|0)==41){J=32;K=J;i=m;return K|0}else if((r|0)==43){J=1;K=J;i=m;return K|0}else if((r|0)==46){J=32;K=J;i=m;return K|0}else if((r|0)==50){J=1;K=J;i=m;return K|0}else if((r|0)==60){J=1;K=J;i=m;return K|0}else if((r|0)==64){J=21;K=J;i=m;return K|0}else if((r|0)==69){J=22;K=J;i=m;return K|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){H=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}G=lHb(o,l+132|0,224512,36)|0;if((G|0)==0){J=1;K=J;i=m;return K|0}c[G+20>>2]=c[o+360>>2];a[l+131|0]=0;if((ve[c[o+112>>2]&63](c[o+116>>2]|0,0,c[G+20>>2]|0,c[G+16>>2]|0,c[G+24>>2]|0)|0)==0){J=21;K=J;i=m;return K|0}if((a[l+131|0]|0)==0){a[l+129|0]=H;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ge[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}J=22;K=J;i=m;return K|0}}while(0);c[o+280>>2]=38;J=wHb(o,e,f,j)|0;K=J;i=m;return K|0}else if((r|0)==90){J=1;K=J;i=m;return K|0}else if((r|0)==92){J=1;K=J;i=m;return K|0}else if((r|0)==111){J=1;K=J;i=m;return K|0}else if((r|0)==113){J=1;K=J;i=m;return K|0}else if((r|0)==117){J=1;K=J;i=m;return K|0}else if((r|0)==128){J=1;K=J;i=m;return K|0}else if((r|0)==132){J=z;K=J;i=m;return K|0}else if((r|0)==134){J=1;K=J;i=m;return K|0}else if((r|0)==145){J=1;K=J;i=m;return K|0}else if((r|0)==153){J=B;K=J;i=m;return K|0}else if((r|0)==156){J=1;K=J;i=m;return K|0}else if((r|0)==163){J=22;K=J;i=m;return K|0}else if((r|0)==166){J=1;K=J;i=m;return K|0}else if((r|0)==171){J=1;K=J;i=m;return K|0}else if((r|0)==181){J=1;K=J;i=m;return K|0}else if((r|0)==190){J=1;K=J;i=m;return K|0}else if((r|0)==192){J=1;K=J;i=m;return K|0}else if((r|0)==202){J=1;K=J;i=m;return K|0}else if((r|0)==204){J=1;K=J;i=m;return K|0}else if((r|0)==214){J=1;K=J;i=m;return K|0}else if((r|0)==217){J=32;K=J;i=m;return K|0}else if((r|0)==220){J=1;K=J;i=m;return K|0}else if((r|0)==225){J=1;K=J;i=m;return K|0}else if((r|0)==232){B=g;if((B|0)==28){J=10;K=J;i=m;return K|0}else if((B|0)==12){J=17;K=J;i=m;return K|0}else{J=2;K=J;i=m;return K|0}}else if((r|0)==239){J=E;K=J;i=m;return K|0}else if((r|0)==241){c[o+280>>2]=39;J=E;K=J;i=m;return K|0}else if((r|0)==245){J=1;K=J;i=m;return K|0}else if((r|0)==248){J=1;K=J;i=m;return K|0}else if((r|0)==251){J=1;K=J;i=m;return K|0}else if((r|0)==254){J=1;K=J;i=m;return K|0}else if((r|0)==258){J=2;K=J;i=m;return K|0}else if((r|0)==263){J=2;K=J;i=m;return K|0}else if((r|0)==273){J=1;K=J;i=m;return K|0}else if((r|0)==279){J=11;K=J;i=m;return K|0}else if((r|0)==281){J=24;K=J;i=m;return K|0}else if((r|0)==287){J=12;K=J;i=m;return K|0}else if((r|0)==290){J=w;K=J;i=m;return K|0}else if((r|0)==294){J=21;K=J;i=m;return K|0}else if((r|0)==301){J=22;K=J;i=m;return K|0}else if((r|0)==304){J=1;K=J;i=m;return K|0}else if((r|0)==309){J=1;K=J;i=m;return K|0}else if((r|0)==323){J=1;K=J;i=m;return K|0}else if((r|0)==325){J=1;K=J;i=m;return K|0}else if((r|0)==340){J=1;K=J;i=m;return K|0}else if((r|0)==344){J=1;K=J;i=m;return K|0}else if((r|0)==347){J=1;K=J;i=m;return K|0}else if((r|0)==367){c[j>>2]=c[n>>2];J=0;K=J;i=m;return K|0}else if((r|0)==368){J=35;K=J;i=m;return K|0}return 0}function tHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((fe[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=uHb(n+440|0,p,b,s+(ue[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=uHb(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);Ee[c[n+140>>2]&31](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}gHb(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=uHb(n+440|0,e,d,m+(ue[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=YHb(n,f)|0;RGb(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){RGb(n+440|0)}q=0;r=q;i=g;return r|0}function uHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((AHb(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((iHb(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function vHb(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function wHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=NHb(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((VHb(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function xHb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=uHb(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=lHb(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((WHb(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function yHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((iHb(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=uHb(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=lHb(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=lHb(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((iHb(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((iHb(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=lHb(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function zHb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((iHb(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function AHb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((iHb(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){ae[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((iHb(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function BHb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=ge[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=ue[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function CHb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=XHb(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((iHb(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function DHb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((iHb(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(De[c[b+20>>2]&63](b,e,f,j)|0){case 7:{r=28;break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}s=uHb(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((s|0)==0){r=8;break a}t=lHb(l,g+132|0,s,0)|0;c[l+428>>2]=c[l+432>>2];if((t|0)==0){r=10;break a}if((a[t+32|0]|0)!=0){r=12;break a}if((c[t+16>>2]|0)==0){a[t+32|0]=1;n=DHb(l,c[l+228>>2]|0,c[t+4>>2]|0,(c[t+4>>2]|0)+(c[t+8>>2]|0)|0)|0;a[t+32|0]=0;if((n|0)!=0){break a}else{break b}}s=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[s+130|0]|0;break b}a[s+131|0]=0;a[t+32|0]=1;s=(ve[c[l+112>>2]&63](c[l+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)!=0;a[t+32|0]=0;if(!s){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case-1:{r=46;break a;break};case 6:case 9:{if((AHb(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case 0:{r=49;break a;break};case-4:{r=24;break a;break};case 10:{s=ue[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=cIb(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((iHb(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((iHb(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function EHb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=De[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case 42:{if((c[k+80>>2]|0)!=0){gHb(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function FHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=EHb(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=40;k=rHb(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function GHb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=ge[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=ue[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=ge[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function HHb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=ge[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=De[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=sHb(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=NHb(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=41;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function IHb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=ge[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;MHb(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function JHb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){gHb(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(ue[c[a+32>>2]&63](a,b)|0)|0;k=uHb(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=ue[c[a+36>>2]&63](a,e)|0;e=uHb(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){LHb(e);Ae[c[g+64>>2]&15](c[g+4>>2]|0,k,e);RGb(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function KHb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){gHb(g,a,b,d)}h=1;j=h;i=f;return j|0}k=uHb(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){LHb(k);ee[c[g+68>>2]&63](c[g+4>>2]|0,k);RGb(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function LHb(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function MHb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}MHb(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}function NHb(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=De[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case 0:{B=24;break a;break};case-3:{B=6;break a;break};case-1:{B=25;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;Ae[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}gHb(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{C=y;do{if((c[y+72>>2]|0)!=0){de[c[C+72>>2]&511](c[y+4>>2]|0)}else{if((c[C+80>>2]|0)==0){break}gHb(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);D=SHb(y,e,n,g,h,j)|0;if((D|0)!=0){B=150;break a}if((c[n>>2]|0)==0){B=152;break a}break};case 10:{C=ue[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((C|0)<0){B=135;break a}E=y;if((c[y+60>>2]|0)!=0){F=c[E+60>>2]|0;G=c[y+4>>2]|0;H=cIb(C,u)|0;Ae[F&15](G,u,H);break b}if((c[E+80>>2]|0)==0){break b}gHb(y,e,c[m>>2]|0,c[n>>2]|0);break};case 3:case 4:{E=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;H=1;c[t>>2]=uHb(y+416|0,e,E,E+(ue[c[e+32>>2]&63](e,E)|0)|0)|0;if((c[t>>2]|0)==0){B=89;break a}c[y+432>>2]=c[y+428>>2];I=QHb(y,e,c[m>>2]|0,t,s)|0;if((I|0)!=0){B=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){Ae[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);H=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}ee[c[y+56>>2]&63](c[y+4>>2]|0,c[t>>2]|0);H=0}do{if((H&255|0)!=0){if((c[y+80>>2]|0)==0){break}gHb(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);RGb(y+416|0);while(1){if((c[s>>2]|0)==0){break}H=c[s>>2]|0;if((c[y+104>>2]|0)!=0){ee[c[y+104>>2]&63](c[y+4>>2]|0,c[c[H>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[H+4>>2]=c[y+376>>2];c[y+376>>2]=H;c[(c[H>>2]|0)+4>>2]=c[H+8>>2]}if((c[y+312>>2]|0)==0){B=107;break a}break};case 1:case 2:{H=y;if((c[y+368>>2]|0)!=0){J=c[H+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{J=ge[c[H+12>>2]&127](48)|0;if((J|0)==0){B=72;break a}c[J+36>>2]=ge[c[y+12>>2]&127](32)|0;if((c[J+36>>2]|0)==0){B=74;break a}c[J+40>>2]=(c[J+36>>2]|0)+32}c[J+44>>2]=0;c[J>>2]=c[y+364>>2];c[y+364>>2]=J;c[J+16>>2]=0;c[J+20>>2]=0;c[J+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[J+8>>2]=ue[c[e+32>>2]&63](e,c[J+4>>2]|0)|0;H=y+312|0;c[H>>2]=(c[H>>2]|0)+1;H=(c[J+4>>2]|0)+(c[J+8>>2]|0)|0;c[r>>2]=c[J+4>>2];c[q>>2]=c[J+36>>2];while(1){ae[c[e+60>>2]&31](e,r,H,q,(c[J+40>>2]|0)+ -1|0);K=(c[q>>2]|0)-(c[J+36>>2]|0)|0;if((c[r>>2]|0)==(H|0)){break}E=(c[J+40>>2]|0)-(c[J+36>>2]|0)<<1;G=ue[c[y+16>>2]&63](c[J+36>>2]|0,E)|0;if((G|0)==0){B=80;break a}c[J+36>>2]=G;c[J+40>>2]=G+E;c[q>>2]=G+K}c[J+24>>2]=K;c[J+12>>2]=c[J+36>>2];a[c[q>>2]|0]=0;L=QHb(y,e,c[m>>2]|0,J+12|0,J+44|0)|0;if((L|0)!=0){B=82;break a}H=y;do{if((c[y+52>>2]|0)!=0){Ae[c[H+52>>2]&15](c[y+4>>2]|0,c[J+12>>2]|0,c[y+392>>2]|0)}else{if((c[H+80>>2]|0)==0){break}gHb(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);RGb(y+416|0);break};case-2:{B=28;break a;break};case 5:{if((c[y+312>>2]|0)==(b|0)){B=109;break a}H=c[y+364>>2]|0;c[y+364>>2]=c[H>>2];c[H>>2]=c[y+368>>2];c[y+368>>2]=H;M=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;G=ue[c[e+32>>2]&63](e,M)|0;if((G|0)!=(c[H+8>>2]|0)){B=112;break a}if((zec(c[H+4>>2]|0,M,G)|0)!=0){B=112;break a}G=y+312|0;c[G>>2]=(c[G>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){G=c[H+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((G|0)==0){break}E=(c[H+12>>2]|0)+(c[H+28>>2]|0)|0;while(1){if((a[G]|0)==0){break}F=G;G=F+1|0;C=E;E=C+1|0;a[C]=a[F]|0}F=c[H+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((F|0)==0){break}C=E;E=C+1|0;a[C]=a[y+472|0]|0;while(1){if((a[F]|0)==0){break c}C=F;F=C+1|0;N=E;E=N+1|0;a[N]=a[C]|0}}}while(0);a[E]=0}}while(0);ee[c[y+56>>2]&63](c[y+4>>2]|0,c[H+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}gHb(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[H+44>>2]|0)==0){break}G=c[H+44>>2]|0;if((c[y+104>>2]|0)!=0){ee[c[y+104>>2]&63](c[y+4>>2]|0,c[c[G>>2]>>2]|0)}c[H+44>>2]=c[(c[H+44>>2]|0)+4>>2];c[G+4>>2]=c[y+376>>2];c[y+376>>2]=G;c[(c[G>>2]|0)+4>>2]=c[G+8>>2]}if((c[y+312>>2]|0)==0){B=133;break a}break};case 9:{a[p]=le[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){H=y;if((c[y+60>>2]|0)!=0){Ae[c[H+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[H+80>>2]|0)==0){break b}gHb(y,e,c[m>>2]|0,c[n>>2]|0);break b}H=uHb(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((H|0)==0){B=37;break a}G=lHb(y,k,H,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){B=40;break}if((G|0)!=0){break}F=y;if((c[y+120>>2]|0)!=0){Ae[c[F+120>>2]&15](c[y+4>>2]|0,H,0);break b}if((c[F+80>>2]|0)==0){break b}gHb(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{B=40}}while(0);if((B|0)==40){B=0;if((G|0)==0){B=41;break a}if((a[G+34|0]|0)==0){B=43;break a}}if((a[G+32|0]|0)!=0){B=50;break a}if((c[G+28>>2]|0)!=0){B=52;break a}H=y;if((c[G+4>>2]|0)!=0){F=y;if((a[H+308|0]|0)!=0){O=HHb(F,G,0)|0;if((O|0)!=0){B=60;break a}else{break b}}C=y;if((c[F+120>>2]|0)!=0){Ae[c[C+120>>2]&15](c[y+4>>2]|0,c[G>>2]|0,0);break b}if((c[C+80>>2]|0)==0){break b}gHb(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[H+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}gHb(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[G+32|0]=1;H=PHb(y)|0;a[G+32|0]=0;if((H|0)==0){B=63;break a}if((ve[c[y+112>>2]&63](c[y+116>>2]|0,H,c[G+20>>2]|0,c[G+16>>2]|0,c[G+24>>2]|0)|0)==0){B=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case-4:{B=17;break a;break};case 12:{B=140;break a;break};case-5:{B=153;break a;break};case 6:{H=c[y+60>>2]|0;if((H|0)==0){if((c[y+80>>2]|0)==0){break b}gHb(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){Ae[H&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];ae[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];Ae[H&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 11:{if((JHb(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=174;break a}break};case 13:{if((KHb(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=176;break a}break};default:{if((c[y+80>>2]|0)==0){break b}gHb(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==3){B=180;break}else if((f|0)==2){B=181;break}}if((B|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;Ae[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}gHb(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((B|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((B|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((B|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((B|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((B|0)==37){P=1;Q=P;i=l;return Q|0}else if((B|0)==41){P=11;Q=P;i=l;return Q|0}else if((B|0)==43){P=24;Q=P;i=l;return Q|0}else if((B|0)==50){P=12;Q=P;i=l;return Q|0}else if((B|0)==52){P=15;Q=P;i=l;return Q|0}else if((B|0)==60){P=O;Q=P;i=l;return Q|0}else if((B|0)==63){P=1;Q=P;i=l;return Q|0}else if((B|0)==65){P=21;Q=P;i=l;return Q|0}else if((B|0)==72){P=1;Q=P;i=l;return Q|0}else if((B|0)==74){de[c[y+20>>2]&511](J);P=1;Q=P;i=l;return Q|0}else if((B|0)==80){P=1;Q=P;i=l;return Q|0}else if((B|0)==82){P=L;Q=P;i=l;return Q|0}else if((B|0)==89){P=1;Q=P;i=l;return Q|0}else if((B|0)==91){P=I;Q=P;i=l;return Q|0}else if((B|0)==107){P=RHb(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==109){P=13;Q=P;i=l;return Q|0}else if((B|0)==112){c[z>>2]=M;P=7;Q=P;i=l;return Q|0}else if((B|0)==133){P=RHb(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==135){P=14;Q=P;i=l;return Q|0}else if((B|0)==140){P=17;Q=P;i=l;return Q|0}else if((B|0)==150){P=D;Q=P;i=l;return Q|0}else if((B|0)==152){c[y+280>>2]=42;P=D;Q=P;i=l;return Q|0}else if((B|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){Ae[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];ae[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);Ae[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}gHb(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((B|0)==174){P=1;Q=P;i=l;return Q|0}else if((B|0)==176){P=1;Q=P;i=l;return Q|0}else if((B|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((B|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function OHb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=De[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=sHb(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=NHb(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=40;m=De[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=sHb(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=NHb(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function PHb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((iHb(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((iHb(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);jHb(e,b+60|0);a:while(1){k=kHb(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((iHb(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((iHb(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((iHb(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((iHb(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){jHb(e,b);b:while(1){b=kHb(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((iHb(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((iHb(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((iHb(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}



function tl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20080>>3];k=+h[g+2152>>3]*+h[g+8832>>3]- +h[g+2160>>3]*+h[g+8840>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2144|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2144|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,2984,3064,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2144|0;p=o;h[p>>3]=m;i=d;return}function ul(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2080>>3]=+h[b+7344>>3]*+h[b+16>>3]+ +h[b+2144>>3];i=i;return}function vl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2088>>3]=-(+h[b+2152>>3]*+h[b+8840>>3])- +h[b+2160>>3]*+h[b+8832>>3];i=i;return}function wl(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2240>>3];e=+h[b+2232>>3];h[b+20144>>3]=(+h[b+14920>>3]*d+ +h[b+14904>>3]*e)*-.8660254037844387+(d*+h[b+14912>>3]+e*+h[b+14896>>3])*.4999999999999999;i=i;return}function xl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7376>>3]=+h[b+15840>>3]*+h[b+14920>>3]+ +h[b+15848>>3]*+h[b+14904>>3];i=i;return}function yl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7352>>3]=+h[b+2240>>3]*+h[b+14920>>3]+ +h[b+2232>>3]*+h[b+14904>>3];i=i;return}function zl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7328>>3]=+h[b+2160>>3]*+h[b+14920>>3]+ +h[b+2152>>3]*+h[b+14904>>3];i=i;return}function Al(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2104>>3]=+h[b+9976>>3]+(+h[b+7328>>3]*+h[d+8680>>3]+(+h[b+7352>>3]*+h[d+8688>>3]+ +h[b+7376>>3]*+h[d+8696>>3]));i=i;return}function Bl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7312>>3]=+h[b+14904>>3]*+h[b+8856>>3]+(+h[b+14896>>3]*+h[b+8864>>3]- +h[b+16>>3]*(+h[b+14920>>3]*+h[b+9904>>3]+ +h[b+14912>>3]*+h[b+9912>>3]));i=i;return}function Cl(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+21880>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7312>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7288|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7288|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1096,3072,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7288|0;p=o;h[p>>3]=m;i=d;return}function Dl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7304>>3]=+h[b+14920>>3]*+h[b+8856>>3]+(+h[b+14912>>3]*+h[b+8864>>3]+ +h[b+16>>3]*(+h[b+14904>>3]*+h[b+9904>>3]+ +h[b+14896>>3]*+h[b+9912>>3]));i=i;return}function El(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+21880>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7304>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7280|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7280|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1096,3080,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7280|0;p=o;h[p>>3]=m;i=d;return}function Fl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20856>>3]=(+h[b+2232>>3]*+h[b+7288>>3]+ +h[b+2240>>3]*+h[b+7280>>3])*2.0;i=i;return}function Gl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+20088>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=5064;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,2864,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+20856>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+20808|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+20808|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,3096,3088,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+20808|0;y=x;h[y>>3]=v;i=d;return}function Hl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20080>>3];k=j*j;l=+h[g+2232>>3]*+h[g+20808>>3]-j*+h[g+7288>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4640|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4640|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,3176,3168,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4640|0;q=p;h[q>>3]=n;i=d;return}function Il(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4672>>3]=+h[b+7344>>3]*+h[b+4640>>3];i=i;return}function Jl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+20080>>3];k=j*j;l=j*+h[g+7280>>3]- +h[g+2240>>3]*+h[g+20808>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4648|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4648|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,3176,3240,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4648|0;q=p;h[q>>3]=n;i=d;return}function Kl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4664>>3]=-(+h[b+7344>>3]*+h[b+4648>>3]);i=i;return}function Ll(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4656>>3]=+h[b+2240>>3]*+h[b+4648>>3]+(+h[b+7280>>3]*+h[b+15848>>3]+(-(+h[b+2232>>3]*+h[b+4640>>3])- +h[b+7288>>3]*+h[b+15840>>3]));i=i;return}function Ml(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8760>>3]=+h[b+9040>>3]+(+h[b+16224>>3]*d*+h[e+9880>>3]- +h[b+16200>>3]*d*+h[e+9888>>3]);i=i;return}function Nl(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8688>>3]=+h[b+9040>>3]+(+h[b+16224>>3]*d*+h[e+10456>>3]- +h[b+16200>>3]*d*+h[e+10464>>3]);i=i;return}function Ol(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14968>>3]=+h[b+16200>>3]*-.8660254037844386+ +h[b+16224>>3]*-.5000000000000001;i=i;return}function Pl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14952>>3]=+h[b+16200>>3]*.5000000000000001+ +h[b+16224>>3]*-.8660254037844386;i=i;return}function Ql(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8648>>3]=+h[b+8688>>3]+(+h[b+14952>>3]*d*+h[e+9976>>3]- +h[b+14968>>3]*d*+h[e+9984>>3]);i=i;return}function Rl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8616>>3]=+h[b+8648>>3]*.4999999999999999+ +h[b+8656>>3]*-.8660254037844387;i=i;return}function Sl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8608>>3]=+h[b+8648>>3]*-.8660254037844387+ +h[b+8656>>3]*-.4999999999999999;i=i;return}function Tl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21032>>3]=+h[b+8608>>3]*-2.0;i=i;return}function Ul(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21048>>3]=+h[b+21032>>3]*.5;i=i;return}function Vl(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10096>>3]=+h[b+10120>>3]+(+h[b+14968>>3]*+h[d+9976>>3]+ +h[b+14952>>3]*+h[d+9984>>3]);i=i;return}function Wl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10072>>3]=(+h[b+10096>>3]- +h[b+10672>>3])*.8660254037844387+(+h[b+10104>>3]- +h[b+10680>>3])*.4999999999999999;i=i;return}function Xl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10048>>3]=+h[b+15168>>3]- +h[b+10072>>3];i=i;return}function Yl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19976>>3]=+h[b+10048>>3]*-2.0;i=i;return}function Zl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19960>>3]=+h[b+19976>>3]*.5;i=i;return}function _l(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10080>>3]=(+h[b+10096>>3]- +h[b+10672>>3])*-.4999999999999999+(+h[b+10104>>3]- +h[b+10680>>3])*.8660254037844387;i=i;return}function $l(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10056>>3]=+h[b+15176>>3]- +h[b+10080>>3];i=i;return}function am(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+10040>>3];e=+h[b+10048>>3];f=+h[b+10056>>3];g=+h[(c[a+416>>2]|0)+22840>>3];h[b+19968>>3]=d*d+(e*e+(f*f-g*g));i=i;return}function bm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+19960>>3];h[b+19944>>3]=d*d- +h[b+19968>>3];i=i;return}function cm(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;bv(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19944>>3],1.0e-12);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19936>>3]=+h[d>>3];i=b;return}function dm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+19936>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+19952|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=5064;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,3248,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+19952|0;p=o;h[p>>3]=m;i=b;return}function em(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+19960>>3];g=+h[e+19952>>3];if((a[(c[b+424>>2]|0)+179|0]|0)!=0){j=g;k=f-j;l=e;m=l+17016|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+17016|0;n=m;h[n>>3]=k;i=d;return}function fm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1320>>3]=+h[b+10672>>3]+ +h[b+17016>>3]*.8660254037844387;i=i;return}function gm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1592>>3]=+h[b+1320>>3]+-.08660254037844388;i=i;return}function hm(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10552>>3]=+h[b+1320>>3]+(+h[d+12336>>3]*-.8660254037844387+ +h[d+12344>>3]*.4999999999999999);i=i;return}function im(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1312>>3]=+h[b+10680>>3]+ +h[b+17016>>3]*.4999999999999999;i=i;return}function jm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1584>>3]=+h[b+1312>>3]+-.05;i=i;return}function km(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10032>>3]=+h[b+1584>>3]- +h[b+10104>>3];i=i;return}function lm(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10560>>3]=+h[b+1312>>3]+(+h[d+12336>>3]*-.4999999999999999+ +h[d+12344>>3]*-.8660254037844387);i=i;return}function mm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19912>>3]=+h[(c[a+416>>2]|0)+22848>>3]+ +h[b+17016>>3];i=i;return}function nm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19896>>3]=+h[b+19912>>3]/.195+1.0;i=i;return}function om(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+19864>>3]=+h[b+23e3>>3]+ +h[b+23008>>3]*(1.0- +h[d+19896>>3]);i=i;return}function pm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19864>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+19880|0;p=o;h[p>>3]=m;i=d;return}q=+$Lb(c[b+536>>2]|0,j,3360,3352,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+19880|0;p=o;h[p>>3]=m;i=d;return}function qm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19888>>3]=-+h[b+19912>>3]/.195;i=i;return}function rm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21040>>3]=(+h[b+10048>>3]*+h[b+8608>>3]+ +h[b+10056>>3]*+h[b+8616>>3])*2.0;i=i;return}function sm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21064>>3]=+h[b+19960>>3]*+h[b+21048>>3]*2.0- +h[b+21040>>3];i=i;return}function tm(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;av(d,c[a+536>>2]|0,+h[f+19944>>3],1.0e-12,+h[f+21064>>3],0.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+21072>>3]=+h[d>>3];i=b;return}function um(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+19936>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=5064;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,3248,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+21072>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+21056|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+21056|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,3400,3392,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+21056|0;y=x;h[y>>3]=v;i=d;return}function vm(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+21048>>3];g=+h[e+21056>>3];if((a[(c[b+424>>2]|0)+179|0]|0)!=0){j=g;k=f-j;l=e;m=l+19848|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+19848|0;n=m;h[n>>3]=k;i=d;return}function wm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8528>>3]=+h[b+19848>>3]*.8660254037844387;i=i;return}function xm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8576>>3]=+h[b+8528>>3]- +h[b+8648>>3];i=i;return}function ym(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8536>>3]=+h[b+19848>>3]*.4999999999999999;i=i;return}function zm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8584>>3]=+h[b+8536>>3]- +h[b+8656>>3];i=i;return}function Am(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+6|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+6|0]|0;k=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19848>>3],0.0,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;f=j;break}else{j=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19848>>3],0.0,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+6|0]|0;j=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19848>>3],0.0)|0;a[(c[b+352>>2]|0)+6|0]=j;f=g;break}else{g=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19848>>3],0.0)|0;a[(c[b+352>>2]|0)+6|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+8|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+8|0]|0;j=b+4|0;k=YOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19896>>3],.93,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=k;l=j;m=e;break}else{e=b+4|0;j=YOb(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19896>>3],.93,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+8|0]|0;j=b+4|0;e=$Ob(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19896>>3],.93)|0;a[(c[b+352>>2]|0)+8|0]=e;l=j;m=f;break}else{f=b+4|0;j=$Ob(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19896>>3],.93)|0;a[(c[b+352>>2]|0)+8|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+19896>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+19840|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+19840|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+7|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+7|0]|0;l=b+4|0;f=XOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+19896>>3],.987,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=f;w=l;x=m;break}else{m=b+4|0;l=XOb(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+19896>>3],.987,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+7|0]|0;l=b+4|0;m=ZOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+19896>>3],.987)|0;a[(c[b+352>>2]|0)+7|0]=m;w=l;x=j;break}else{j=b+4|0;l=ZOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19896>>3],.987)|0;a[(c[b+352>>2]|0)+7|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+19896>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+19840|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+19840|0;v=u;h[v>>3]=s;i=d;return}}}function Bm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19872>>3]=+h[b+19840>>3]*1.0e-5;i=i;return}function Cm(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+22992>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+19904>>3]=b*b*+h[d+19872>>3]*-78539.81633974482;i=i;return}function Dm(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+23016>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+19840>>3]*+h[j+19864>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+19856|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+19856|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,3472,3464,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+19856|0;p=o;h[p>>3]=m;i=d;return}function Em(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10024>>3]=+h[b+1592>>3]- +h[b+10096>>3];i=i;return}function Fm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1408>>3]=+h[b+14968>>3]*+h[b+10024>>3]+ +h[b+14960>>3]*+h[b+10032>>3];i=i;return}function Gm(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+22912>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1408>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+1520|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1520|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1032,3504,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1520|0;p=o;h[p>>3]=m;i=d;return}function Hm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1400>>3]=+h[b+14952>>3]*+h[b+10024>>3]+ +h[b+14944>>3]*+h[b+10032>>3];i=i;return}function Im(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+22912>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1400>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+1512|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1512|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1032,3512,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1512|0;p=o;h[p>>3]=m;i=d;return}function Jm(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1512>>3];e=+h[b+1520>>3];h[b+19928>>3]=d*d+e*e;i=i;return}function Km(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+19928>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+19920|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=5064;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,3520,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+19920|0;p=o;h[p>>3]=m;i=b;return}function Lm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19920>>3];k=+h[g+1520>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+15752|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+15752|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,3640,3632,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+15752|0;p=o;h[p>>3]=m;i=d;return}function Mm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1440>>3]=-(+h[b+7528>>3]*+h[b+15752>>3]);i=i;return}function Nm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19920>>3];k=+h[g+1512>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+15744|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+15744|0;q=p;h[q>>3]=n;i=d;return}k=l/+$Lb(c[b+536>>2]|0,j,3640,3696,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+15744|0;q=p;h[q>>3]=n;i=d;return}function Om(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1432>>3]=+h[b+7528>>3]*+h[b+15744>>3];i=i;return}function Pm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7520>>3]=+h[b+1440>>3]*+h[b+14960>>3]+ +h[b+1432>>3]*+h[b+14944>>3];i=i;return}function Qm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7568>>3]=+h[b+15744>>3]*+h[b+14960>>3]+ +h[b+15752>>3]*+h[b+14944>>3];i=i;return}function Rm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7504>>3]=+h[b+1520>>3]*+h[b+15752>>3]- +h[b+1512>>3]*+h[b+15744>>3];i=i;return}function Sm(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1376>>3]=+h[b+10088>>3]+(+h[b+7504>>3]*+h[d+11696>>3]+ +h[b+7528>>3]*+h[d+11704>>3]);i=i;return}function Tm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7544>>3]=+h[b+1520>>3]*+h[b+14960>>3]+ +h[b+1512>>3]*+h[b+14944>>3];i=i;return}function Um(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1392>>3]=+h[b+10104>>3]+(+h[b+7520>>3]*+h[d+11696>>3]+(+h[b+7544>>3]*+h[d+11704>>3]+ +h[b+7568>>3]*+h[d+11712>>3]));i=i;return}function Vm(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+22912>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+14968>>3]*+h[j+8576>>3]+(+h[j+14960>>3]*+h[j+8584>>3]+ +h[j+16>>3]*+h[j+1400>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+8552|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8552|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1032,3704,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8552|0;p=o;h[p>>3]=m;i=d;return}function Wm(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+22912>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+14952>>3]*+h[j+8576>>3]+(+h[j+14944>>3]*+h[j+8584>>3]- +h[j+16>>3]*+h[j+1408>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+8560|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8560|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1032,3712,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8560|0;p=o;h[p>>3]=m;i=d;return}function Xm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1416>>3]=+h[b+15744>>3]*+h[b+8552>>3]+ +h[b+15752>>3]*+h[b+8560>>3];i=i;return}function Ym(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1352>>3]=+h[b+7504>>3]*+h[b+16>>3]+ +h[b+1416>>3];i=i;return}function Zm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19920>>3];k=+h[g+1432>>3]*+h[g+8552>>3]- +h[g+1440>>3]*+h[g+8560>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1424|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1424|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,3640,3720,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1424|0;p=o;h[p>>3]=m;i=d;return}function _m(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1360>>3]=+h[b+7528>>3]*+h[b+16>>3]+ +h[b+1424>>3];i=i;return}function $m(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1368>>3]=-(+h[b+1432>>3]*+h[b+8560>>3])- +h[b+1440>>3]*+h[b+8552>>3];i=i;return}function an(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1520>>3];e=+h[b+1512>>3];h[b+19984>>3]=(+h[b+14968>>3]*d+ +h[b+14952>>3]*e)*-.8660254037844387+(d*+h[b+14960>>3]+e*+h[b+14944>>3])*-.4999999999999999;i=i;return}function bn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7560>>3]=+h[b+15744>>3]*+h[b+14968>>3]+ +h[b+15752>>3]*+h[b+14952>>3];i=i;return}function cn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7536>>3]=+h[b+1520>>3]*+h[b+14968>>3]+ +h[b+1512>>3]*+h[b+14952>>3];i=i;return}function dn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7512>>3]=+h[b+1440>>3]*+h[b+14968>>3]+ +h[b+1432>>3]*+h[b+14952>>3];i=i;return}function en(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1384>>3]=+h[b+10096>>3]+(+h[b+7512>>3]*+h[d+11696>>3]+(+h[b+7536>>3]*+h[d+11704>>3]+ +h[b+7560>>3]*+h[d+11712>>3]));i=i;return}function fn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7496>>3]=+h[b+14952>>3]*+h[b+8576>>3]+(+h[b+14944>>3]*+h[b+8584>>3]- +h[b+16>>3]*(+h[b+14968>>3]*+h[b+10024>>3]+ +h[b+14960>>3]*+h[b+10032>>3]));i=i;return}function gn(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+22912>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7496>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7472|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7472|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1032,3728,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7472|0;p=o;h[p>>3]=m;i=d;return}function hn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7488>>3]=+h[b+14968>>3]*+h[b+8576>>3]+(+h[b+14960>>3]*+h[b+8584>>3]+ +h[b+16>>3]*(+h[b+14952>>3]*+h[b+10024>>3]+ +h[b+14944>>3]*+h[b+10032>>3]));i=i;return}function jn(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+22912>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7488>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7464|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7464|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,1032,3736,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7464|0;p=o;h[p>>3]=m;i=d;return}function kn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20864>>3]=(+h[b+1512>>3]*+h[b+7472>>3]+ +h[b+1520>>3]*+h[b+7464>>3])*2.0;i=i;return}function ln(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+19928>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=5064;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,3520,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+20864>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+20816|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+20816|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,3752,3744,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+20816|0;y=x;h[y>>3]=v;i=d;return}function mn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19920>>3];k=j*j;l=+h[g+1512>>3]*+h[g+20816>>3]-j*+h[g+7472>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4712|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4712|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,3832,3824,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4712|0;q=p;h[q>>3]=n;i=d;return}function nn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4744>>3]=+h[b+7528>>3]*+h[b+4712>>3];i=i;return}function on(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19920>>3];k=j*j;l=j*+h[g+7464>>3]- +h[g+1520>>3]*+h[g+20816>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4720|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4720|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,3832,3896,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4720|0;q=p;h[q>>3]=n;i=d;return}function pn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4736>>3]=-(+h[b+7528>>3]*+h[b+4720>>3]);i=i;return}function qn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4728>>3]=+h[b+1520>>3]*+h[b+4720>>3]+(+h[b+7464>>3]*+h[b+15752>>3]+(-(+h[b+1512>>3]*+h[b+4712>>3])- +h[b+7472>>3]*+h[b+15744>>3]));i=i;return}function rn(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8480>>3]=+h[b+8760>>3]+(+h[b+16224>>3]*d*+h[e+12896>>3]- +h[b+16200>>3]*d*+h[e+12904>>3]);i=i;return}function sn(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8408>>3]=+h[b+8760>>3]+(+h[b+16224>>3]*d*+h[e+13472>>3]- +h[b+16200>>3]*d*+h[e+13480>>3]);i=i;return}function tn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15016>>3]=+h[b+16200>>3]*6.123233995736766e-17+ +h[b+16224>>3];i=i;return}function un(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15e3>>3]=+h[b+16224>>3]*6.123233995736766e-17- +h[b+16200>>3];i=i;return}function vn(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8368>>3]=+h[b+8408>>3]+(+h[b+15e3>>3]*d*+h[e+12992>>3]- +h[b+15016>>3]*d*+h[e+13e3>>3]);i=i;return}function wn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8336>>3]=+h[b+8368>>3]*-.4999999999999999+ +h[b+8376>>3]*-.8660254037844387;i=i;return}function xn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8328>>3]=+h[b+8368>>3]*-.8660254037844387+ +h[b+8376>>3]*.4999999999999999;i=i;return}function yn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21080>>3]=+h[b+8328>>3]*-2.0;i=i;return}function zn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21096>>3]=+h[b+21080>>3]*.5;i=i;return}function An(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10216>>3]=+h[b+10240>>3]+(+h[b+15016>>3]*+h[d+12992>>3]+ +h[b+15e3>>3]*+h[d+13e3>>3]);i=i;return}function Bn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10192>>3]=(+h[b+10216>>3]- +h[b+10696>>3])*.8660254037844387+(+h[b+10224>>3]- +h[b+10704>>3])*-.4999999999999999;i=i;return}function Cn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10168>>3]=+h[b+15192>>3]- +h[b+10192>>3];i=i;return}function Dn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19816>>3]=+h[b+10168>>3]*-2.0;i=i;return}function En(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19800>>3]=+h[b+19816>>3]*.5;i=i;return}function Fn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10200>>3]=(+h[b+10216>>3]- +h[b+10696>>3])*.4999999999999999+(+h[b+10224>>3]- +h[b+10704>>3])*.8660254037844387;i=i;return}function Gn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10176>>3]=+h[b+15200>>3]- +h[b+10200>>3];i=i;return}function Hn(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+10160>>3];e=+h[b+10168>>3];f=+h[b+10176>>3];g=+h[(c[a+416>>2]|0)+23872>>3];h[b+19808>>3]=d*d+(e*e+(f*f-g*g));i=i;return}function In(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+19800>>3];h[b+19784>>3]=d*d- +h[b+19808>>3];i=i;return}function Jn(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;bv(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19784>>3],1.0e-12);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19776>>3]=+h[d>>3];i=b;return}function Kn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+19776>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+19792|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=5064;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,3904,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+19792|0;p=o;h[p>>3]=m;i=b;return}function Ln(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+19800>>3];g=+h[e+19792>>3];if((a[(c[b+424>>2]|0)+227|0]|0)!=0){j=g;k=f-j;l=e;m=l+17248|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+17248|0;n=m;h[n>>3]=k;i=d;return}function Mn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+600>>3]=+h[b+10696>>3]+ +h[b+17248>>3]*.8660254037844387;i=i;return}function Nn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+872>>3]=+h[b+600>>3]+-.08660254037844388;i=i;return}function On(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10576>>3]=+h[b+600>>3]+(+h[d+15352>>3]*-.8660254037844387+ +h[d+15360>>3]*-.4999999999999999);i=i;return}function Pn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+592>>3]=+h[b+10704>>3]+ +h[b+17248>>3]*-.4999999999999999;i=i;return}function Qn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+864>>3]=+h[b+592>>3]+.05;i=i;return}function Rn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10152>>3]=+h[b+864>>3]- +h[b+10224>>3];i=i;return}function Sn(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10584>>3]=+h[b+592>>3]+(+h[d+15352>>3]*.4999999999999999+ +h[d+15360>>3]*-.8660254037844387);i=i;return}function Tn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19752>>3]=+h[(c[a+416>>2]|0)+23880>>3]+ +h[b+17248>>3];i=i;return}function Un(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19736>>3]=+h[b+19752>>3]/.195+1.0;i=i;return}function Vn(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+19704>>3]=+h[b+24032>>3]+ +h[b+24040>>3]*(1.0- +h[d+19736>>3]);i=i;return}function Wn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19704>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+19720|0;p=o;h[p>>3]=m;i=d;return}q=+$Lb(c[b+536>>2]|0,j,4016,4008,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+19720|0;p=o;h[p>>3]=m;i=d;return}function Xn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19728>>3]=-+h[b+19752>>3]/.195;i=i;return}function Yn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21088>>3]=(+h[b+10168>>3]*+h[b+8328>>3]+ +h[b+10176>>3]*+h[b+8336>>3])*2.0;i=i;return}function Zn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21112>>3]=+h[b+19800>>3]*+h[b+21096>>3]*2.0- +h[b+21088>>3];i=i;return}function _n(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;av(d,c[a+536>>2]|0,+h[f+19784>>3],1.0e-12,+h[f+21112>>3],0.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+21120>>3]=+h[d>>3];i=b;return}function $n(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+19776>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=5064;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,3904,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+21120>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+21104|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+21104|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,4056,4048,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+21104|0;y=x;h[y>>3]=v;i=d;return}function ao(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+21096>>3];g=+h[e+21104>>3];if((a[(c[b+424>>2]|0)+227|0]|0)!=0){j=g;k=f-j;l=e;m=l+19688|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+19688|0;n=m;h[n>>3]=k;i=d;return}function bo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8248>>3]=+h[b+19688>>3]*.8660254037844387;i=i;return}function co(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8296>>3]=+h[b+8248>>3]- +h[b+8368>>3];i=i;return}function eo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8256>>3]=+h[b+19688>>3]*-.4999999999999999;i=i;return}function fo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8304>>3]=+h[b+8256>>3]- +h[b+8376>>3];i=i;return}function go(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+3|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+3|0]|0;k=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19688>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;f=j;break}else{j=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19688>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+3|0]|0;j=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19688>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=j;f=g;break}else{g=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19688>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+5|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+5|0]|0;j=b+4|0;k=YOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19736>>3],.93,a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=k;l=j;m=e;break}else{e=b+4|0;j=YOb(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19736>>3],.93,a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+5|0]|0;j=b+4|0;e=$Ob(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19736>>3],.93)|0;a[(c[b+352>>2]|0)+5|0]=e;l=j;m=f;break}else{f=b+4|0;j=$Ob(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19736>>3],.93)|0;a[(c[b+352>>2]|0)+5|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+19736>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+19680|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+19680|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+4|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+4|0]|0;l=b+4|0;f=XOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+19736>>3],.987,a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=f;w=l;x=m;break}else{m=b+4|0;l=XOb(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+19736>>3],.987,a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+4|0]|0;l=b+4|0;m=ZOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+19736>>3],.987)|0;a[(c[b+352>>2]|0)+4|0]=m;w=l;x=j;break}else{j=b+4|0;l=ZOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19736>>3],.987)|0;a[(c[b+352>>2]|0)+4|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+19736>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+19680|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+19680|0;v=u;h[v>>3]=s;i=d;return}}}function ho(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19712>>3]=+h[b+19680>>3]*1.0e-5;i=i;return}function io(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+24024>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+19744>>3]=b*b*+h[d+19712>>3]*-78539.81633974482;i=i;return}function jo(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+24048>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+19680>>3]*+h[j+19704>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+19696|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+19696|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,4128,4120,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+19696|0;p=o;h[p>>3]=m;i=d;return}function ko(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10144>>3]=+h[b+872>>3]- +h[b+10216>>3];i=i;return}function lo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+688>>3]=+h[b+15016>>3]*+h[b+10144>>3]+ +h[b+15008>>3]*+h[b+10152>>3];i=i;return}function mo(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+23944>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+688>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+800|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+800|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,968,4160,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+800|0;p=o;h[p>>3]=m;i=d;return}function no(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+680>>3]=+h[b+15e3>>3]*+h[b+10144>>3]+ +h[b+14992>>3]*+h[b+10152>>3];i=i;return}function oo(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+23944>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+680>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+792|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+792|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,968,4168,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+792|0;p=o;h[p>>3]=m;i=d;return}function po(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+792>>3];e=+h[b+800>>3];h[b+19768>>3]=d*d+e*e;i=i;return}function qo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+19768>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+19760|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=5064;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,4176,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+19760|0;p=o;h[p>>3]=m;i=b;return}function ro(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19760>>3];k=+h[g+800>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+15656|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+15656|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,4296,4288,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+15656|0;p=o;h[p>>3]=m;i=d;return}function so(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+720>>3]=-(+h[b+7712>>3]*+h[b+15656>>3]);i=i;return}function to(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19760>>3];k=+h[g+792>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+15648|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+15648|0;q=p;h[q>>3]=n;i=d;return}k=l/+$Lb(c[b+536>>2]|0,j,4296,4352,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+15648|0;q=p;h[q>>3]=n;i=d;return}function uo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+712>>3]=+h[b+7712>>3]*+h[b+15648>>3];i=i;return}function vo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7704>>3]=+h[b+720>>3]*+h[b+15008>>3]+ +h[b+712>>3]*+h[b+14992>>3];i=i;return}function wo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7752>>3]=+h[b+15648>>3]*+h[b+15008>>3]+ +h[b+15656>>3]*+h[b+14992>>3];i=i;return}function xo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7688>>3]=+h[b+800>>3]*+h[b+15656>>3]- +h[b+792>>3]*+h[b+15648>>3];i=i;return}function yo(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+656>>3]=+h[b+10208>>3]+(+h[b+7688>>3]*+h[d+14712>>3]+ +h[b+7712>>3]*+h[d+14720>>3]);i=i;return}function zo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7728>>3]=+h[b+800>>3]*+h[b+15008>>3]+ +h[b+792>>3]*+h[b+14992>>3];i=i;return}function Ao(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+672>>3]=+h[b+10224>>3]+(+h[b+7704>>3]*+h[d+14712>>3]+(+h[b+7728>>3]*+h[d+14720>>3]+ +h[b+7752>>3]*+h[d+14728>>3]));i=i;return}function Bo(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+23944>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+15016>>3]*+h[j+8296>>3]+(+h[j+15008>>3]*+h[j+8304>>3]+ +h[j+16>>3]*+h[j+680>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+8272|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8272|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,968,4360,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8272|0;p=o;h[p>>3]=m;i=d;return}function Co(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+23944>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+15e3>>3]*+h[j+8296>>3]+(+h[j+14992>>3]*+h[j+8304>>3]- +h[j+16>>3]*+h[j+688>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+8280|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8280|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,968,4368,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8280|0;p=o;h[p>>3]=m;i=d;return}function Do(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+696>>3]=+h[b+15648>>3]*+h[b+8272>>3]+ +h[b+15656>>3]*+h[b+8280>>3];i=i;return}function Eo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+632>>3]=+h[b+7688>>3]*+h[b+16>>3]+ +h[b+696>>3];i=i;return}function Fo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19760>>3];k=+h[g+712>>3]*+h[g+8272>>3]- +h[g+720>>3]*+h[g+8280>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+704|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+704|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,4296,4376,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+704|0;p=o;h[p>>3]=m;i=d;return}function Go(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+640>>3]=+h[b+7712>>3]*+h[b+16>>3]+ +h[b+704>>3];i=i;return}function Ho(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+648>>3]=-(+h[b+712>>3]*+h[b+8280>>3])- +h[b+720>>3]*+h[b+8272>>3];i=i;return}function Io(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+800>>3];e=+h[b+792>>3];h[b+19824>>3]=(+h[b+15016>>3]*d+ +h[b+15e3>>3]*e)*-.8660254037844387+(d*+h[b+15008>>3]+e*+h[b+14992>>3])*.4999999999999999;i=i;return}function Jo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7744>>3]=+h[b+15648>>3]*+h[b+15016>>3]+ +h[b+15656>>3]*+h[b+15e3>>3];i=i;return}function Ko(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7720>>3]=+h[b+800>>3]*+h[b+15016>>3]+ +h[b+792>>3]*+h[b+15e3>>3];i=i;return}function Lo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7696>>3]=+h[b+720>>3]*+h[b+15016>>3]+ +h[b+712>>3]*+h[b+15e3>>3];i=i;return}function Mo(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+664>>3]=+h[b+10216>>3]+(+h[b+7696>>3]*+h[d+14712>>3]+(+h[b+7720>>3]*+h[d+14720>>3]+ +h[b+7744>>3]*+h[d+14728>>3]));i=i;return}function No(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7680>>3]=+h[b+15e3>>3]*+h[b+8296>>3]+(+h[b+14992>>3]*+h[b+8304>>3]- +h[b+16>>3]*(+h[b+15016>>3]*+h[b+10144>>3]+ +h[b+15008>>3]*+h[b+10152>>3]));i=i;return}function Oo(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+23944>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7680>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7656|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7656|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,968,4384,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7656|0;p=o;h[p>>3]=m;i=d;return}function Po(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7672>>3]=+h[b+15016>>3]*+h[b+8296>>3]+(+h[b+15008>>3]*+h[b+8304>>3]+ +h[b+16>>3]*(+h[b+15e3>>3]*+h[b+10144>>3]+ +h[b+14992>>3]*+h[b+10152>>3]));i=i;return}function Qo(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+23944>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7672>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7648|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7648|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,968,4392,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7648|0;p=o;h[p>>3]=m;i=d;return}function Ro(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20872>>3]=(+h[b+792>>3]*+h[b+7656>>3]+ +h[b+800>>3]*+h[b+7648>>3])*2.0;i=i;return}function So(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+19768>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=5064;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,4176,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+20872>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+20824|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+20824|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,4408,4400,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+20824|0;y=x;h[y>>3]=v;i=d;return}function To(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19760>>3];k=j*j;l=+h[g+792>>3]*+h[g+20824>>3]-j*+h[g+7656>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4784|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4784|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,4488,4480,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4784|0;q=p;h[q>>3]=n;i=d;return}function Uo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4816>>3]=+h[b+7712>>3]*+h[b+4784>>3];i=i;return}function Vo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19760>>3];k=j*j;l=j*+h[g+7648>>3]- +h[g+800>>3]*+h[g+20824>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4792|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4792|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,4488,4552,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4792|0;q=p;h[q>>3]=n;i=d;return}function Wo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4808>>3]=-(+h[b+7712>>3]*+h[b+4792>>3]);i=i;return}function Xo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4800>>3]=+h[b+800>>3]*+h[b+4792>>3]+(+h[b+7648>>3]*+h[b+15656>>3]+(-(+h[b+792>>3]*+h[b+4784>>3])- +h[b+7656>>3]*+h[b+15648>>3]));i=i;return}function Yo(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8176>>3]=+h[b+8480>>3]+(+h[b+16224>>3]*d*+h[e+16488>>3]- +h[b+16200>>3]*d*+h[e+16496>>3]);i=i;return}function Zo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15064>>3]=+h[b+16200>>3]*.8660254037844387+ +h[b+16224>>3]*-.4999999999999999;i=i;return}function _o(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15048>>3]=+h[b+16200>>3]*.4999999999999999+ +h[b+16224>>3]*.8660254037844387;i=i;return}function $o(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+8136>>3]=+h[b+8176>>3]+(+h[b+15048>>3]*d*+h[e+16008>>3]- +h[b+15064>>3]*d*+h[e+16016>>3]);i=i;return}function ap(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8104>>3]=+h[b+8136>>3]*.4999999999999999+ +h[b+8144>>3]*-.8660254037844387;i=i;return}function bp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8096>>3]=+h[b+8136>>3]*-.8660254037844387+ +h[b+8144>>3]*-.4999999999999999;i=i;return}function cp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21128>>3]=+h[b+8096>>3]*-2.0;i=i;return}function dp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21144>>3]=+h[b+21128>>3]*.5;i=i;return}function ep(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10336>>3]=+h[b+10360>>3]+(+h[b+15064>>3]*+h[d+16008>>3]+ +h[b+15048>>3]*+h[d+16016>>3]);i=i;return}function fp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10312>>3]=(+h[b+10336>>3]- +h[b+10720>>3])*.8660254037844387+(+h[b+10344>>3]- +h[b+10728>>3])*.4999999999999999;i=i;return}function gp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10288>>3]=+h[b+15216>>3]- +h[b+10312>>3];i=i;return}function hp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19656>>3]=+h[b+10288>>3]*-2.0;i=i;return}function ip(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19640>>3]=+h[b+19656>>3]*.5;i=i;return}function jp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10320>>3]=(+h[b+10336>>3]- +h[b+10720>>3])*-.4999999999999999+(+h[b+10344>>3]- +h[b+10728>>3])*.8660254037844387;i=i;return}function kp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10296>>3]=+h[b+15224>>3]- +h[b+10320>>3];i=i;return}function lp(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+10280>>3];e=+h[b+10288>>3];f=+h[b+10296>>3];g=+h[(c[a+416>>2]|0)+24904>>3];h[b+19648>>3]=d*d+(e*e+(f*f-g*g));i=i;return}function mp(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+19640>>3];h[b+19624>>3]=d*d- +h[b+19648>>3];i=i;return}function np(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;bv(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19624>>3],1.0e-12);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19616>>3]=+h[d>>3];i=b;return}function op(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+19616>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+19632|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=5064;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,4560,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+19632|0;p=o;h[p>>3]=m;i=b;return}function pp(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+19640>>3];g=+h[e+19632>>3];if((a[(c[b+424>>2]|0)+275|0]|0)!=0){j=g;k=f-j;l=e;m=l+17480|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+17480|0;n=m;h[n>>3]=k;i=d;return}function qp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+120>>3]=+h[b+10720>>3]+ +h[b+17480>>3]*.8660254037844387;i=i;return}function rp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+392>>3]=+h[b+120>>3]+-.08660254037844388;i=i;return}function sp(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10600>>3]=+h[b+120>>3]+(+h[d+18368>>3]*-.8660254037844387+ +h[d+18376>>3]*.4999999999999999);i=i;return}function tp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=+h[b+10728>>3]+ +h[b+17480>>3]*.4999999999999999;i=i;return}function up(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+384>>3]=+h[b+112>>3]+-.05;i=i;return}function vp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10272>>3]=+h[b+384>>3]- +h[b+10344>>3];i=i;return}function wp(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10608>>3]=+h[b+112>>3]+(+h[d+18368>>3]*-.4999999999999999+ +h[d+18376>>3]*-.8660254037844387);i=i;return}function xp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19592>>3]=+h[(c[a+416>>2]|0)+24912>>3]+ +h[b+17480>>3];i=i;return}function yp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19576>>3]=+h[b+19592>>3]/.195+1.0;i=i;return}function zp(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+19544>>3]=+h[b+25064>>3]+ +h[b+25072>>3]*(1.0- +h[d+19576>>3]);i=i;return}function Ap(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19544>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+19560|0;p=o;h[p>>3]=m;i=d;return}q=+$Lb(c[b+536>>2]|0,j,4672,4664,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+19560|0;p=o;h[p>>3]=m;i=d;return}function Bp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19568>>3]=-+h[b+19592>>3]/.195;i=i;return}function Cp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21136>>3]=(+h[b+10288>>3]*+h[b+8096>>3]+ +h[b+10296>>3]*+h[b+8104>>3])*2.0;i=i;return}function Dp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+21160>>3]=+h[b+19640>>3]*+h[b+21144>>3]*2.0- +h[b+21136>>3];i=i;return}function Ep(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;av(d,c[a+536>>2]|0,+h[f+19624>>3],1.0e-12,+h[f+21160>>3],0.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+21168>>3]=+h[d>>3];i=b;return}function Fp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+19616>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=5064;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,4560,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+21168>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+21152|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+21152|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,4712,4704,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+21152|0;y=x;h[y>>3]=v;i=d;return}function Gp(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;f=+h[e+21144>>3];g=+h[e+21152>>3];if((a[(c[b+424>>2]|0)+275|0]|0)!=0){j=g;k=f-j;l=e;m=l+19528|0;n=m;h[n>>3]=k;i=d;return}j=-g;k=f-j;l=e;m=l+19528|0;n=m;h[n>>3]=k;i=d;return}function Hp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8016>>3]=+h[b+19528>>3]*.8660254037844387;i=i;return}function Ip(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8064>>3]=+h[b+8016>>3]- +h[b+8136>>3];i=i;return}function Jp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8024>>3]=+h[b+19528>>3]*.4999999999999999;i=i;return}function Kp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8072>>3]=+h[b+8024>>3]- +h[b+8144>>3];i=i;return}function Lp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19528>>3],0.0,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;f=j;break}else{j=XOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19528>>3],0.0,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;f=j;break}}else{if(g){g=a[c[b+356>>2]|0]|0;j=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19528>>3],0.0)|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=ZOb(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+19528>>3],0.0)|0;a[c[b+352>>2]|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+2|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+2|0]|0;j=b+4|0;k=YOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19576>>3],.93,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=k;l=j;m=e;break}else{e=b+4|0;j=YOb(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+19576>>3],.93,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+2|0]|0;j=b+4|0;e=$Ob(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19576>>3],.93)|0;a[(c[b+352>>2]|0)+2|0]=e;l=j;m=f;break}else{f=b+4|0;j=$Ob(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+19576>>3],.93)|0;a[(c[b+352>>2]|0)+2|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+19576>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+19520|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+19520|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+1|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+1|0]|0;l=b+4|0;f=XOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+19576>>3],.987,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=f;w=l;x=m;break}else{m=b+4|0;l=XOb(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+19576>>3],.987,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+1|0]|0;l=b+4|0;m=ZOb(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+19576>>3],.987)|0;a[(c[b+352>>2]|0)+1|0]=m;w=l;x=j;break}else{j=b+4|0;l=ZOb(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+19576>>3],.987)|0;a[(c[b+352>>2]|0)+1|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+19576>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+19520|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+19520|0;v=u;h[v>>3]=s;i=d;return}}}function Mp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+19552>>3]=+h[b+19520>>3]*1.0e-5;i=i;return}function Np(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+25056>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+19584>>3]=b*b*+h[d+19552>>3]*-78539.81633974482;i=i;return}function Op(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+25080>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+19520>>3]*+h[j+19544>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+19536|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+19536|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,4784,4776,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+19536|0;p=o;h[p>>3]=m;i=d;return}function Pp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10264>>3]=+h[b+392>>3]- +h[b+10336>>3];i=i;return}function Qp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+208>>3]=+h[b+15064>>3]*+h[b+10264>>3]+ +h[b+15056>>3]*+h[b+10272>>3];i=i;return}function Rp(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+24976>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+208>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,904,4816,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}function Sp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+200>>3]=+h[b+15048>>3]*+h[b+10264>>3]+ +h[b+15040>>3]*+h[b+10272>>3];i=i;return}function Tp(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+24976>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+200>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+312|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+312|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,904,4824,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+312|0;p=o;h[p>>3]=m;i=d;return}function Up(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+312>>3];e=+h[b+320>>3];h[b+19608>>3]=d*d+e*e;i=i;return}function Vp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+19608>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+19600|0;p=o;h[p>>3]=m;i=b;return}g=c[69976]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=5064;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ee[a&31](q,d,4832,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+19600|0;p=o;h[p>>3]=m;i=b;return}function Wp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19600>>3];k=+h[g+320>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+15512|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+15512|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,4952,4944,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+15512|0;p=o;h[p>>3]=m;i=d;return}function Xp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+240>>3]=-(+h[b+7944>>3]*+h[b+15512>>3]);i=i;return}function Yp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19600>>3];k=+h[g+312>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+15504|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+15504|0;q=p;h[q>>3]=n;i=d;return}k=l/+$Lb(c[b+536>>2]|0,j,4952,5008,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+15504|0;q=p;h[q>>3]=n;i=d;return}function Zp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+232>>3]=+h[b+7944>>3]*+h[b+15504>>3];i=i;return}function _p(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7936>>3]=+h[b+240>>3]*+h[b+15056>>3]+ +h[b+232>>3]*+h[b+15040>>3];i=i;return}function $p(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7984>>3]=+h[b+15504>>3]*+h[b+15056>>3]+ +h[b+15512>>3]*+h[b+15040>>3];i=i;return}function aq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7920>>3]=+h[b+320>>3]*+h[b+15512>>3]- +h[b+312>>3]*+h[b+15504>>3];i=i;return}function bq(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+176>>3]=+h[b+10328>>3]+(+h[b+7920>>3]*+h[d+17728>>3]+ +h[b+7944>>3]*+h[d+17736>>3]);i=i;return}function cq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7960>>3]=+h[b+320>>3]*+h[b+15056>>3]+ +h[b+312>>3]*+h[b+15040>>3];i=i;return}function dq(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+192>>3]=+h[b+10344>>3]+(+h[b+7936>>3]*+h[d+17728>>3]+(+h[b+7960>>3]*+h[d+17736>>3]+ +h[b+7984>>3]*+h[d+17744>>3]));i=i;return}function eq(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+24976>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+15064>>3]*+h[j+8064>>3]+(+h[j+15056>>3]*+h[j+8072>>3]+ +h[j+16>>3]*+h[j+200>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+8040|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8040|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,904,5016,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8040|0;p=o;h[p>>3]=m;i=d;return}function fq(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+24976>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+15048>>3]*+h[j+8064>>3]+(+h[j+15040>>3]*+h[j+8072>>3]- +h[j+16>>3]*+h[j+208>>3]);if(e!=0.0){l=j;m=k/e;n=l;o=n+8048|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8048|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,904,5024,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8048|0;p=o;h[p>>3]=m;i=d;return}function gq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=+h[b+15504>>3]*+h[b+8040>>3]+ +h[b+15512>>3]*+h[b+8048>>3];i=i;return}function hq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+152>>3]=+h[b+7920>>3]*+h[b+16>>3]+ +h[b+216>>3];i=i;return}function iq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19600>>3];k=+h[g+232>>3]*+h[g+8040>>3]- +h[g+240>>3]*+h[g+8048>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+224|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+224|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,j,4952,5032,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+224|0;p=o;h[p>>3]=m;i=d;return}function jq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+160>>3]=+h[b+7944>>3]*+h[b+16>>3]+ +h[b+224>>3];i=i;return}function kq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+168>>3]=-(+h[b+232>>3]*+h[b+8048>>3])- +h[b+240>>3]*+h[b+8040>>3];i=i;return}function lq(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+320>>3];e=+h[b+312>>3];h[b+19664>>3]=(+h[b+15064>>3]*d+ +h[b+15048>>3]*e)*-.8660254037844387+(d*+h[b+15056>>3]+e*+h[b+15040>>3])*-.4999999999999999;i=i;return}function mq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7976>>3]=+h[b+15504>>3]*+h[b+15064>>3]+ +h[b+15512>>3]*+h[b+15048>>3];i=i;return}function nq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7952>>3]=+h[b+320>>3]*+h[b+15064>>3]+ +h[b+312>>3]*+h[b+15048>>3];i=i;return}function oq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7928>>3]=+h[b+240>>3]*+h[b+15064>>3]+ +h[b+232>>3]*+h[b+15048>>3];i=i;return}function pq(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+184>>3]=+h[b+10336>>3]+(+h[b+7928>>3]*+h[d+17728>>3]+(+h[b+7952>>3]*+h[d+17736>>3]+ +h[b+7976>>3]*+h[d+17744>>3]));i=i;return}function qq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7912>>3]=+h[b+15048>>3]*+h[b+8064>>3]+(+h[b+15040>>3]*+h[b+8072>>3]- +h[b+16>>3]*(+h[b+15064>>3]*+h[b+10264>>3]+ +h[b+15056>>3]*+h[b+10272>>3]));i=i;return}function rq(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+24976>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7912>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7888|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7888|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,904,5040,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7888|0;p=o;h[p>>3]=m;i=d;return}function sq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7904>>3]=+h[b+15064>>3]*+h[b+8064>>3]+(+h[b+15056>>3]*+h[b+8072>>3]+ +h[b+16>>3]*(+h[b+15048>>3]*+h[b+10264>>3]+ +h[b+15040>>3]*+h[b+10272>>3]));i=i;return}function tq(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+24976>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7904>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7880|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7880|0;p=o;h[p>>3]=m;i=d;return}q=k/+$Lb(c[b+536>>2]|0,e,904,5048,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7880|0;p=o;h[p>>3]=m;i=d;return}function uq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+20880>>3]=(+h[b+312>>3]*+h[b+7888>>3]+ +h[b+320>>3]*+h[b+7880>>3])*2.0;i=i;return}function vq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+19608>>3];if(!(m>=0.0)){n=c[69976]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=5064;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ee[p&31](o,e,4832,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+20880>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+20832|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+20832|0;y=x;h[y>>3]=v;i=d;return}z=m/+$Lb(c[b+536>>2]|0,t,5088,5056,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+20832|0;y=x;h[y>>3]=v;i=d;return}function wq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19600>>3];k=j*j;l=+h[g+312>>3]*+h[g+20832>>3]-j*+h[g+7888>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4856|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4856|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,5168,5160,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4856|0;q=p;h[q>>3]=n;i=d;return}function xq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4888>>3]=+h[b+7944>>3]*+h[b+4856>>3];i=i;return}function yq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+19600>>3];k=j*j;l=j*+h[g+7880>>3]- +h[g+320>>3]*+h[g+20832>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+4864|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+4864|0;q=p;h[q>>3]=n;i=d;return}j=l/+$Lb(c[b+536>>2]|0,k,5168,5232,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+4864|0;q=p;h[q>>3]=n;i=d;return}function zq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4880>>3]=-(+h[b+7944>>3]*+h[b+4864>>3]);i=i;return}function Aq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4872>>3]=+h[b+320>>3]*+h[b+4864>>3]+(+h[b+7880>>3]*+h[b+15512>>3]+(-(+h[b+312>>3]*+h[b+4856>>3])- +h[b+7888>>3]*+h[b+15504>>3]));i=i;return}function Bq(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+7808>>3]=+h[b+10384>>3]+(+h[b+16200>>3]*+h[d+15912>>3]+ +h[b+16224>>3]*+h[d+15920>>3]);i=i;return}



function Cq(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;mPb(a,1)|0;d=a+476|0;e=c[(c[d>>2]|0)+92>>2]|0;f=a+4|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+6368>>3]=+h[e>>3];h[a+6136>>3]=+h[e+8>>3];h[a+6144>>3]=+h[e+16>>3];h[a+6112>>3]=+h[e+24>>3];h[a+6120>>3]=+h[e+32>>3];h[a+4192>>3]=+h[e+40>>3];h[a+6088>>3]=+h[e+48>>3];h[a+6096>>3]=+h[e+56>>3];h[a+6064>>3]=+h[e+64>>3];h[a+6072>>3]=+h[e+72>>3];h[a+6024>>3]=+h[e+80>>3];h[a+20768>>3]=+h[e+88>>3];h[a+20784>>3]=+h[e+96>>3];h[a+5992>>3]=+h[e+104>>3];h[a+5968>>3]=+h[e+112>>3];h[a+6824>>3]=+h[e+120>>3];h[a+6792>>3]=+h[e+128>>3];h[a+6832>>3]=+h[e+136>>3];h[a+4456>>3]=+h[e+144>>3];h[a+20760>>3]=+h[e+152>>3];h[a+20744>>3]=+h[e+160>>3];h[a+20752>>3]=+h[e+168>>3];h[a+20776>>3]=+h[e+176>>3];h[a+6e3>>3]=+h[e+184>>3];e=c[(c[d>>2]|0)+92>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+5976>>3]=+h[e+192>>3];h[a+6032>>3]=+h[e+200>>3];h[a+5936>>3]=+h[e+208>>3];h[a+4896>>3]=+h[e+216>>3];h[a+3504>>3]=+h[e+224>>3];h[a+4904>>3]=+h[e+232>>3];h[a+4912>>3]=+h[e+240>>3];h[a+5944>>3]=+h[e+248>>3];h[a+3792>>3]=+h[e+256>>3];h[a+3488>>3]=+h[e+264>>3];h[a+3632>>3]=+h[e+272>>3];h[a+3776>>3]=+h[e+280>>3];h[a+3784>>3]=+h[e+288>>3];h[a+3640>>3]=+h[e+296>>3];h[a+3648>>3]=+h[e+304>>3];h[a+3760>>3]=+h[e+312>>3];h[a+3800>>3]=+h[e+320>>3];h[a+3608>>3]=+h[e+328>>3];h[a+3616>>3]=+h[e+336>>3];h[a+3688>>3]=+h[e+344>>3];h[a+3696>>3]=+h[e+352>>3];h[a+3904>>3]=+h[e+360>>3];h[a+3952>>3]=+h[e+368>>3];h[a+3872>>3]=+h[e+376>>3];e=c[(c[d>>2]|0)+92>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+3664>>3]=+h[e+384>>3];h[a+3920>>3]=+h[e+392>>3];h[a+3912>>3]=+h[e+400>>3];h[a+3864>>3]=+h[e+408>>3];h[a+3976>>3]=+h[e+416>>3];h[a+3840>>3]=+h[e+424>>3];h[a+3984>>3]=+h[e+432>>3];h[a+3848>>3]=+h[e+440>>3];h[a+3656>>3]=+h[e+448>>3];h[a+20472>>3]=+h[e+456>>3];h[a+3704>>3]=+h[e+464>>3];h[a+3880>>3]=+h[e+472>>3];h[a+3888>>3]=+h[e+480>>3];h[a+3896>>3]=+h[e+488>>3];h[a+3992>>3]=+h[e+496>>3];h[a+3856>>3]=+h[e+504>>3];h[a+3624>>3]=+h[e+512>>3];h[a+3768>>3]=+h[e+520>>3];h[a+3496>>3]=+h[e+528>>3];h[a+5912>>3]=+h[e+536>>3];h[a+5920>>3]=+h[e+544>>3];h[a+5888>>3]=+h[e+552>>3];h[a+5896>>3]=+h[e+560>>3];h[a+5848>>3]=+h[e+568>>3];e=c[(c[d>>2]|0)+92>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+20720>>3]=+h[e+576>>3];h[a+20736>>3]=+h[e+584>>3];h[a+5816>>3]=+h[e+592>>3];h[a+5792>>3]=+h[e+600>>3];h[a+6224>>3]=+h[e+608>>3];h[a+6200>>3]=+h[e+616>>3];h[a+6232>>3]=+h[e+624>>3];h[a+4448>>3]=+h[e+632>>3];h[a+20712>>3]=+h[e+640>>3];h[a+20696>>3]=+h[e+648>>3];h[a+20704>>3]=+h[e+656>>3];h[a+20728>>3]=+h[e+664>>3];h[a+5824>>3]=+h[e+672>>3];h[a+5800>>3]=+h[e+680>>3];h[a+5856>>3]=+h[e+688>>3];h[a+5760>>3]=+h[e+696>>3];h[a+4920>>3]=+h[e+704>>3];h[a+2784>>3]=+h[e+712>>3];h[a+4928>>3]=+h[e+720>>3];h[a+4936>>3]=+h[e+728>>3];h[a+5768>>3]=+h[e+736>>3];h[a+3072>>3]=+h[e+744>>3];h[a+2768>>3]=+h[e+752>>3];h[a+2912>>3]=+h[e+760>>3];e=c[(c[d>>2]|0)+92>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+3056>>3]=+h[e+768>>3];h[a+3064>>3]=+h[e+776>>3];h[a+2920>>3]=+h[e+784>>3];h[a+2928>>3]=+h[e+792>>3];h[a+3040>>3]=+h[e+800>>3];h[a+3080>>3]=+h[e+808>>3];h[a+2888>>3]=+h[e+816>>3];h[a+2896>>3]=+h[e+824>>3];h[a+2968>>3]=+h[e+832>>3];h[a+2976>>3]=+h[e+840>>3];h[a+3184>>3]=+h[e+848>>3];h[a+3232>>3]=+h[e+856>>3];h[a+3152>>3]=+h[e+864>>3];h[a+2944>>3]=+h[e+872>>3];h[a+3200>>3]=+h[e+880>>3];h[a+3192>>3]=+h[e+888>>3];h[a+3144>>3]=+h[e+896>>3];h[a+3256>>3]=+h[e+904>>3];h[a+3120>>3]=+h[e+912>>3];h[a+3264>>3]=+h[e+920>>3];h[a+3128>>3]=+h[e+928>>3];h[a+2936>>3]=+h[e+936>>3];h[a+20312>>3]=+h[e+944>>3];h[a+2984>>3]=+h[e+952>>3];e=c[(c[d>>2]|0)+92>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+3168>>3]=+h[e+960>>3];h[a+3176>>3]=+h[e+968>>3];h[a+3160>>3]=+h[e+976>>3];h[a+3272>>3]=+h[e+984>>3];h[a+3136>>3]=+h[e+992>>3];h[a+2904>>3]=+h[e+1e3>>3];h[a+3048>>3]=+h[e+1008>>3];h[a+2776>>3]=+h[e+1016>>3];h[a+5736>>3]=+h[e+1024>>3];h[a+5744>>3]=+h[e+1032>>3];h[a+5712>>3]=+h[e+1040>>3];h[a+5720>>3]=+h[e+1048>>3];h[a+5672>>3]=+h[e+1056>>3];h[a+20672>>3]=+h[e+1064>>3];h[a+20688>>3]=+h[e+1072>>3];h[a+5640>>3]=+h[e+1080>>3];h[a+5616>>3]=+h[e+1088>>3];h[a+6296>>3]=+h[e+1096>>3];h[a+6272>>3]=+h[e+1104>>3];h[a+6304>>3]=+h[e+1112>>3];h[a+4440>>3]=+h[e+1120>>3];h[a+20664>>3]=+h[e+1128>>3];h[a+20648>>3]=+h[e+1136>>3];h[a+20656>>3]=+h[e+1144>>3];e=c[(c[d>>2]|0)+92>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+20680>>3]=+h[e+1152>>3];h[a+5648>>3]=+h[e+1160>>3];h[a+5624>>3]=+h[e+1168>>3];h[a+5680>>3]=+h[e+1176>>3];h[a+5584>>3]=+h[e+1184>>3];h[a+4944>>3]=+h[e+1192>>3];h[a+2064>>3]=+h[e+1200>>3];h[a+4952>>3]=+h[e+1208>>3];h[a+4960>>3]=+h[e+1216>>3];h[a+5592>>3]=+h[e+1224>>3];h[a+2352>>3]=+h[e+1232>>3];h[a+2048>>3]=+h[e+1240>>3];h[a+2192>>3]=+h[e+1248>>3];h[a+2336>>3]=+h[e+1256>>3];h[a+2344>>3]=+h[e+1264>>3];h[a+2200>>3]=+h[e+1272>>3];h[a+2208>>3]=+h[e+1280>>3];h[a+2320>>3]=+h[e+1288>>3];h[a+2360>>3]=+h[e+1296>>3];h[a+2168>>3]=+h[e+1304>>3];h[a+2176>>3]=+h[e+1312>>3];h[a+2248>>3]=+h[e+1320>>3];h[a+2256>>3]=+h[e+1328>>3];h[a+2464>>3]=+h[e+1336>>3];e=c[(c[d>>2]|0)+92>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+2512>>3]=+h[e+1344>>3];h[a+2432>>3]=+h[e+1352>>3];h[a+2224>>3]=+h[e+1360>>3];h[a+2480>>3]=+h[e+1368>>3];h[a+2472>>3]=+h[e+1376>>3];h[a+2424>>3]=+h[e+1384>>3];h[a+2536>>3]=+h[e+1392>>3];h[a+2400>>3]=+h[e+1400>>3];h[a+2544>>3]=+h[e+1408>>3];h[a+2408>>3]=+h[e+1416>>3];h[a+2216>>3]=+h[e+1424>>3];h[a+20152>>3]=+h[e+1432>>3];h[a+2264>>3]=+h[e+1440>>3];h[a+2440>>3]=+h[e+1448>>3];h[a+2448>>3]=+h[e+1456>>3];h[a+2456>>3]=+h[e+1464>>3];h[a+2552>>3]=+h[e+1472>>3];h[a+2416>>3]=+h[e+1480>>3];h[a+2184>>3]=+h[e+1488>>3];h[a+2328>>3]=+h[e+1496>>3];h[a+2056>>3]=+h[e+1504>>3];h[a+5560>>3]=+h[e+1512>>3];h[a+5568>>3]=+h[e+1520>>3];h[a+5440>>3]=+h[e+1528>>3];e=c[(c[d>>2]|0)+92>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+5496>>3]=+h[e+1536>>3];h[a+5536>>3]=+h[e+1544>>3];h[a+5544>>3]=+h[e+1552>>3];h[a+5384>>3]=+h[e+1560>>3];h[a+5392>>3]=+h[e+1568>>3];h[a+5360>>3]=+h[e+1576>>3];h[a+5368>>3]=+h[e+1584>>3];h[a+5320>>3]=+h[e+1592>>3];h[a+20576>>3]=+h[e+1600>>3];h[a+20592>>3]=+h[e+1608>>3];h[a+5288>>3]=+h[e+1616>>3];h[a+5264>>3]=+h[e+1624>>3];h[a+6440>>3]=+h[e+1632>>3];h[a+6416>>3]=+h[e+1640>>3];h[a+6448>>3]=+h[e+1648>>3];h[a+4424>>3]=+h[e+1656>>3];h[a+20568>>3]=+h[e+1664>>3];h[a+20552>>3]=+h[e+1672>>3];h[a+20560>>3]=+h[e+1680>>3];h[a+20584>>3]=+h[e+1688>>3];h[a+5296>>3]=+h[e+1696>>3];h[a+5272>>3]=+h[e+1704>>3];h[a+5328>>3]=+h[e+1712>>3];h[a+5232>>3]=+h[e+1720>>3];e=c[(c[d>>2]|0)+92>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+4992>>3]=+h[e+1728>>3];h[a+624>>3]=+h[e+1736>>3];h[a+5e3>>3]=+h[e+1744>>3];h[a+5008>>3]=+h[e+1752>>3];h[a+5240>>3]=+h[e+1760>>3];h[a+912>>3]=+h[e+1768>>3];h[a+608>>3]=+h[e+1776>>3];h[a+752>>3]=+h[e+1784>>3];h[a+896>>3]=+h[e+1792>>3];h[a+904>>3]=+h[e+1800>>3];h[a+760>>3]=+h[e+1808>>3];h[a+768>>3]=+h[e+1816>>3];h[a+880>>3]=+h[e+1824>>3];h[a+920>>3]=+h[e+1832>>3];h[a+728>>3]=+h[e+1840>>3];h[a+736>>3]=+h[e+1848>>3];h[a+808>>3]=+h[e+1856>>3];h[a+816>>3]=+h[e+1864>>3];h[a+1024>>3]=+h[e+1872>>3];h[a+1072>>3]=+h[e+1880>>3];h[a+992>>3]=+h[e+1888>>3];h[a+784>>3]=+h[e+1896>>3];h[a+1040>>3]=+h[e+1904>>3];h[a+1032>>3]=+h[e+1912>>3];e=c[(c[d>>2]|0)+92>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+984>>3]=+h[e+1920>>3];h[a+1096>>3]=+h[e+1928>>3];h[a+960>>3]=+h[e+1936>>3];h[a+1104>>3]=+h[e+1944>>3];h[a+968>>3]=+h[e+1952>>3];h[a+776>>3]=+h[e+1960>>3];h[a+19832>>3]=+h[e+1968>>3];h[a+824>>3]=+h[e+1976>>3];h[a+1008>>3]=+h[e+1984>>3];h[a+1016>>3]=+h[e+1992>>3];h[a+1e3>>3]=+h[e+2e3>>3];h[a+1112>>3]=+h[e+2008>>3];h[a+976>>3]=+h[e+2016>>3];h[a+744>>3]=+h[e+2024>>3];h[a+888>>3]=+h[e+2032>>3];h[a+616>>3]=+h[e+2040>>3];h[a+5216>>3]=+h[e+2048>>3];h[a+20528>>3]=+h[e+2056>>3];h[a+20544>>3]=+h[e+2064>>3];h[a+5136>>3]=+h[e+2072>>3];h[a+5112>>3]=+h[e+2080>>3];h[a+6512>>3]=+h[e+2088>>3];h[a+6488>>3]=+h[e+2096>>3];h[a+6520>>3]=+h[e+2104>>3];e=c[(c[d>>2]|0)+92>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+4416>>3]=+h[e+2112>>3];h[a+20520>>3]=+h[e+2120>>3];h[a+20504>>3]=+h[e+2128>>3];h[a+20512>>3]=+h[e+2136>>3];h[a+20536>>3]=+h[e+2144>>3];h[a+5144>>3]=+h[e+2152>>3];h[a+5120>>3]=+h[e+2160>>3];h[a+5176>>3]=+h[e+2168>>3];h[a+5080>>3]=+h[e+2176>>3];h[a+5016>>3]=+h[e+2184>>3];h[a+144>>3]=+h[e+2192>>3];h[a+5024>>3]=+h[e+2200>>3];h[a+5032>>3]=+h[e+2208>>3];h[a+5088>>3]=+h[e+2216>>3];h[a+432>>3]=+h[e+2224>>3];h[a+248>>3]=+h[e+2232>>3];h[a+400>>3]=+h[e+2240>>3];h[a+128>>3]=+h[e+2248>>3];h[a+304>>3]=+h[e+2256>>3];h[a+336>>3]=+h[e+2264>>3];h[a+256>>3]=+h[e+2272>>3];h[a+416>>3]=+h[e+2280>>3];h[a+512>>3]=+h[e+2288>>3];h[a+280>>3]=+h[e+2296>>3];e=c[(c[d>>2]|0)+92>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+1920>>3]=+h[e+2304>>3];h[a+1200>>3]=+h[e+2312>>3];h[a+1928>>3]=+h[e+2320>>3];h[a+1208>>3]=+h[e+2328>>3];h[a+504>>3]=+h[e+2336>>3];h[a+288>>3]=+h[e+2344>>3];h[a+424>>3]=+h[e+2352>>3];h[a+136>>3]=+h[e+2360>>3];h[a+4216>>3]=+h[e+2368>>3];h[a+20488>>3]=+h[e+2376>>3];h[a+19512>>3]=+h[e+2384>>3];h[a+5472>>3]=+h[e+2392>>3];h[a+5504>>3]=+h[e+2400>>3];h[a+20632>>3]=+h[e+2408>>3];h[a+5464>>3]=+h[e+2416>>3];h[a+20640>>3]=+h[e+2424>>3];h[a+20616>>3]=+h[e+2432>>3];h[a+20600>>3]=+h[e+2440>>3];h[a+20608>>3]=+h[e+2448>>3];h[a+20624>>3]=+h[e+2456>>3];h[a+4432>>3]=+h[e+2464>>3];h[a+5408>>3]=+h[e+2472>>3];h[a+1336>>3]=+h[e+2480>>3];h[a+4968>>3]=+h[e+2488>>3];e=c[(c[d>>2]|0)+92>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+1624>>3]=+h[e+2496>>3];h[a+1344>>3]=+h[e+2504>>3];h[a+4976>>3]=+h[e+2512>>3];h[a+1472>>3]=+h[e+2520>>3];h[a+1616>>3]=+h[e+2528>>3];h[a+1632>>3]=+h[e+2536>>3];h[a+1712>>3]=+h[e+2544>>3];h[a+1480>>3]=+h[e+2552>>3];h[a+1488>>3]=+h[e+2560>>3];h[a+1608>>3]=+h[e+2568>>3];h[a+1640>>3]=+h[e+2576>>3];h[a+1448>>3]=+h[e+2584>>3];h[a+1456>>3]=+h[e+2592>>3];h[a+1528>>3]=+h[e+2600>>3];h[a+1536>>3]=+h[e+2608>>3];h[a+4264>>3]=+h[e+2616>>3];h[a+4088>>3]=+h[e+2624>>3];h[a+3368>>3]=+h[e+2632>>3];h[a+2648>>3]=+h[e+2640>>3];h[a+1760>>3]=+h[e+2648>>3];h[a+4e3>>3]=+h[e+2656>>3];h[a+4240>>3]=+h[e+2664>>3];h[a+4272>>3]=+h[e+2672>>3];h[a+3280>>3]=+h[e+2680>>3];e=c[(c[d>>2]|0)+92>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+4048>>3]=+h[e+2688>>3];h[a+4080>>3]=+h[e+2696>>3];h[a+2560>>3]=+h[e+2704>>3];h[a+3328>>3]=+h[e+2712>>3];h[a+3360>>3]=+h[e+2720>>3];h[a+2608>>3]=+h[e+2728>>3];h[a+2640>>3]=+h[e+2736>>3];h[a+1752>>3]=+h[e+2744>>3];h[a+1704>>3]=+h[e+2752>>3];h[a+1496>>3]=+h[e+2760>>3];h[a+1544>>3]=+h[e+2768>>3];h[a+1464>>3]=+h[e+2776>>3];h[a+1600>>3]=+h[e+2784>>3];h[a+1328>>3]=+h[e+2792>>3];h[a+4984>>3]=+h[e+2800>>3];h[a+5416>>3]=+h[e+2808>>3];h[a+5448>>3]=+h[e+2816>>3];h[a+6376>>3]=+h[e+2824>>3];h[a+6344>>3]=+h[e+2832>>3];h[a+1688>>3]=+h[e+2840>>3];h[a+1824>>3]=+h[e+2848>>3];h[a+1744>>3]=+h[e+2856>>3];h[a+1792>>3]=+h[e+2864>>3];h[a+19992>>3]=+h[e+2872>>3];e=c[(c[d>>2]|0)+92>>2]|0;d=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[d+1816>>3]=+h[e+2880>>3];h[d+1680>>3]=+h[e+2888>>3];h[d+1504>>3]=+h[e+2896>>3];h[d+1696>>3]=+h[e+2904>>3];h[d+1728>>3]=+h[e+2912>>3];h[d+1736>>3]=+h[e+2920>>3];h[d+1832>>3]=+h[e+2928>>3];h[d+1720>>3]=+h[e+2936>>3];h[d+1840>>3]=+h[e+2944>>3];h[d+1888>>3]=+h[e+2952>>3];h[d+1120>>3]=+h[e+2960>>3];h[d+1168>>3]=+h[e+2968>>3];h[d+520>>3]=+h[e+2976>>3];h[d+480>>3]=+h[e+2984>>3];h[d+296>>3]=+h[e+2992>>3];h[d+19672>>3]=+h[e+3e3>>3];h[d+344>>3]=+h[e+3008>>3];h[d+264>>3]=+h[e+3016>>3];h[d+408>>3]=+h[e+3024>>3];h[d+440>>3]=+h[e+3032>>3];h[d+5168>>3]=+h[e+3040>>3];h[d+5208>>3]=+h[e+3048>>3];i=b;return}function Dq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4208>>3]=+h[(c[a+416>>2]|0)+384>>3]*+h[b+6112>>3];i=i;return}function Eq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4200>>3]=-(+h[(c[a+416>>2]|0)+384>>3]*+h[b+6120>>3]);i=i;return}function Fq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3440>>3]=-(+h[(c[a+416>>2]|0)+3400>>3]*+h[b+6792>>3]);i=i;return}function Gq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3464>>3]=-+h[b+3440>>3]- +h[(c[a+416>>2]|0)+3280>>3]*+h[b+6792>>3];i=i;return}function Hq(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+6800>>3]=+h[d+20232>>3]*((+h[b+6824>>3]+ +h[d+18840>>3])*.4999999999999999+ +h[b+6832>>3]*.8660254037844387);i=i;return}function Iq(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3424>>3]=+h[b+3416>>3]*+h[d+6792>>3]- +h[b+3408>>3]*+h[d+6800>>3];i=i;return}function Jq(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3448>>3]=+h[b+3296>>3]*+h[d+6792>>3]+(-(+h[b+3288>>3]*+h[d+6800>>3])- +h[d+3424>>3]);i=i;return}function Kq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3432>>3]=+h[(c[a+416>>2]|0)+3400>>3]*+h[b+6800>>3];i=i;return}function Lq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3456>>3]=+h[(c[a+416>>2]|0)+3280>>3]*+h[b+6800>>3]- +h[b+3432>>3];i=i;return}function Mq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15448>>3]=+h[b+3952>>3]*.1;i=i;return}function Nq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3728>>3]=-+h[b+15448>>3]- +h[b+3464>>3];i=i;return}function Oq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3808>>3]=-+h[b+3728>>3]- +h[b+16320>>3]*+h[b+3952>>3];i=i;return}function Pq(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3664>>3];e=+h[b+3656>>3];h[b+3720>>3]=(+h[b+14824>>3]*d+ +h[b+14808>>3]*e)*.8660254037844387+(d*+h[b+14816>>3]+e*+h[b+14800>>3])*-.4999999999999999;i=i;return}function Qq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3832>>3]=+h[b+3720>>3]+ +h[b+6792>>3];i=i;return}function Rq(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3664>>3];e=+h[b+3656>>3];h[b+3712>>3]=(+h[b+14824>>3]*d+ +h[b+14808>>3]*e)*.4999999999999999+(d*+h[b+14816>>3]+e*+h[b+14800>>3])*.8660254037844387;i=i;return}function Sq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15432>>3]=+h[b+3712>>3]*-.1;i=i;return}function Tq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3736>>3]=-+h[b+15432>>3]- +h[b+3448>>3];i=i;return}function Uq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3824>>3]=+h[b+3712>>3]+ +h[b+6800>>3];i=i;return}function Vq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3960>>3]=+h[b+3832>>3]*.8660254037844387+ +h[b+3824>>3]*.4999999999999999;i=i;return}function Wq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3968>>3]=+h[b+3832>>3]*-.4999999999999999+ +h[b+3824>>3]*.8660254037844387;i=i;return}function Xq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3816>>3]=+h[b+16320>>3]*+h[b+3824>>3]- +h[b+3736>>3];i=i;return}function Yq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=+h[f+1024>>3];j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[a+3968>>3];m=+h[f+1032>>3];n=+h[a+3960>>3];o=+h[a+3816>>3]+(g*l-m*n);p=+h[a+3952>>3];q=+h[f+1016>>3];r=+h[a+3456>>3];s=+h[a+3808>>3];a=d;h[k>>3]=m*p-l*q-(r*-.8660254037844387+s*-.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=n*q-g*p-(r*.4999999999999999+s*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];UMb(e,3,o,d);RMb(e,(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3928|0);i=b;return}function Zq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2720>>3]=-(+h[(c[a+416>>2]|0)+6416>>3]*+h[b+6200>>3]);i=i;return}function _q(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2744>>3]=-+h[b+2720>>3]- +h[(c[a+416>>2]|0)+6296>>3]*+h[b+6200>>3];i=i;return}function $q(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+6208>>3]=+h[d+21264>>3]*((+h[b+6224>>3]+ +h[d+18840>>3])*-.4999999999999999+ +h[b+6232>>3]*.8660254037844387);i=i;return}function ar(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2704>>3]=+h[b+6432>>3]*+h[d+6200>>3]- +h[b+6424>>3]*+h[d+6208>>3];i=i;return}function br(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2728>>3]=+h[b+6312>>3]*+h[d+6200>>3]+(-(+h[b+6304>>3]*+h[d+6208>>3])- +h[d+2704>>3]);i=i;return}function cr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2712>>3]=+h[(c[a+416>>2]|0)+6416>>3]*+h[b+6208>>3];i=i;return}function dr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2736>>3]=+h[(c[a+416>>2]|0)+6296>>3]*+h[b+6208>>3]- +h[b+2712>>3];i=i;return}function er(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15408>>3]=+h[b+3232>>3]*.1;i=i;return}function fr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3008>>3]=-+h[b+15408>>3]- +h[b+2744>>3];i=i;return}function gr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3088>>3]=-+h[b+3008>>3]- +h[b+16552>>3]*+h[b+3232>>3];i=i;return}function hr(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2944>>3];e=+h[b+2936>>3];h[b+3e3>>3]=(+h[b+14872>>3]*d+ +h[b+14856>>3]*e)*.8660254037844387+(d*+h[b+14864>>3]+e*+h[b+14848>>3])*.4999999999999999;i=i;return}function ir(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3112>>3]=+h[b+3e3>>3]+ +h[b+6200>>3];i=i;return}function jr(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2944>>3];e=+h[b+2936>>3];h[b+2992>>3]=(+h[b+14872>>3]*d+ +h[b+14856>>3]*e)*-.4999999999999999+(d*+h[b+14864>>3]+e*+h[b+14848>>3])*.8660254037844387;i=i;return}function kr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15392>>3]=+h[b+2992>>3]*-.1;i=i;return}function lr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3016>>3]=-+h[b+15392>>3]- +h[b+2728>>3];i=i;return}function mr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3104>>3]=+h[b+2992>>3]+ +h[b+6208>>3];i=i;return}function nr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3240>>3]=+h[b+3112>>3]*.8660254037844387+ +h[b+3104>>3]*-.4999999999999999;i=i;return}function or(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3248>>3]=+h[b+3112>>3]*.4999999999999999+ +h[b+3104>>3]*.8660254037844387;i=i;return}function pr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3096>>3]=+h[b+16552>>3]*+h[b+3104>>3]- +h[b+3016>>3];i=i;return}function qr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=+h[f+4040>>3];j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[a+3248>>3];m=+h[f+4048>>3];n=+h[a+3240>>3];o=+h[a+3096>>3]+(g*l-m*n);p=+h[a+3232>>3];q=+h[f+4032>>3];r=+h[a+2736>>3];s=+h[a+3088>>3];a=d;h[k>>3]=m*p-l*q-(r*-.8660254037844387+s*.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=n*q-g*p-(r*-.4999999999999999+s*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];UMb(e,3,o,d);RMb(e,(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3208|0);i=b;return}function rr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2e3>>3]=-(+h[(c[a+416>>2]|0)+9432>>3]*+h[b+6272>>3]);i=i;return}function sr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2024>>3]=-+h[b+2e3>>3]- +h[(c[a+416>>2]|0)+9312>>3]*+h[b+6272>>3];i=i;return}function tr(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+6280>>3]=+h[d+22296>>3]*((+h[b+6296>>3]+ +h[d+18840>>3])*.4999999999999999+ +h[b+6304>>3]*.8660254037844387);i=i;return}function ur(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1984>>3]=+h[b+9448>>3]*+h[d+6272>>3]- +h[b+9440>>3]*+h[d+6280>>3];i=i;return}function vr(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2008>>3]=+h[b+9328>>3]*+h[d+6272>>3]+(-(+h[b+9320>>3]*+h[d+6280>>3])- +h[d+1984>>3]);i=i;return}function wr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1992>>3]=+h[(c[a+416>>2]|0)+9432>>3]*+h[b+6280>>3];i=i;return}function xr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2016>>3]=+h[(c[a+416>>2]|0)+9312>>3]*+h[b+6280>>3]- +h[b+1992>>3];i=i;return}function yr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15368>>3]=+h[b+2512>>3]*.1;i=i;return}function zr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2288>>3]=-+h[b+15368>>3]- +h[b+2024>>3];i=i;return}function Ar(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2368>>3]=-+h[b+2288>>3]- +h[b+16784>>3]*+h[b+2512>>3];i=i;return}function Br(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2224>>3];e=+h[b+2216>>3];h[b+2280>>3]=(+h[b+14920>>3]*d+ +h[b+14904>>3]*e)*.8660254037844387+(d*+h[b+14912>>3]+e*+h[b+14896>>3])*-.4999999999999999;i=i;return}function Cr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2392>>3]=+h[b+2280>>3]+ +h[b+6272>>3];i=i;return}function Dr(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2224>>3];e=+h[b+2216>>3];h[b+2272>>3]=(+h[b+14920>>3]*d+ +h[b+14904>>3]*e)*.4999999999999999+(d*+h[b+14912>>3]+e*+h[b+14896>>3])*.8660254037844387;i=i;return}function Er(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15352>>3]=+h[b+2272>>3]*-.1;i=i;return}function Fr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2296>>3]=-+h[b+15352>>3]- +h[b+2008>>3];i=i;return}function Gr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2384>>3]=+h[b+2272>>3]+ +h[b+6280>>3];i=i;return}function Hr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2520>>3]=+h[b+2392>>3]*.8660254037844387+ +h[b+2384>>3]*.4999999999999999;i=i;return}function Ir(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2528>>3]=+h[b+2392>>3]*-.4999999999999999+ +h[b+2384>>3]*.8660254037844387;i=i;return}function Jr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2376>>3]=+h[b+16784>>3]*+h[b+2384>>3]- +h[b+2296>>3];i=i;return}function Kr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=+h[f+7056>>3];j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[a+2528>>3];m=+h[f+7064>>3];n=+h[a+2520>>3];o=+h[a+2376>>3]+(g*l-m*n);p=+h[a+2512>>3];q=+h[f+7048>>3];r=+h[a+2016>>3];s=+h[a+2368>>3];a=d;h[k>>3]=m*p-l*q-(r*-.8660254037844387+s*-.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=n*q-g*p-(r*.4999999999999999+s*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];UMb(e,3,o,d);RMb(e,(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2488|0);i=b;return}function Lr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+560>>3]=-(+h[(c[a+416>>2]|0)+15464>>3]*+h[b+6416>>3]);i=i;return}function Mr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+584>>3]=-+h[b+560>>3]- +h[(c[a+416>>2]|0)+15344>>3]*+h[b+6416>>3];i=i;return}function Nr(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+6424>>3]=+h[d+24360>>3]*((+h[b+6440>>3]+ +h[d+18840>>3])*.4999999999999999+ +h[b+6448>>3]*.8660254037844387);i=i;return}function Or(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+544>>3]=+h[b+15480>>3]*+h[d+6416>>3]- +h[b+15472>>3]*+h[d+6424>>3];i=i;return}function Pr(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+568>>3]=+h[b+15360>>3]*+h[d+6416>>3]+(-(+h[b+15352>>3]*+h[d+6424>>3])- +h[d+544>>3]);i=i;return}function Qr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=+h[(c[a+416>>2]|0)+15464>>3]*+h[b+6424>>3];i=i;return}function Rr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+576>>3]=+h[(c[a+416>>2]|0)+15344>>3]*+h[b+6424>>3]- +h[b+552>>3];i=i;return}function Sr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15288>>3]=+h[b+1072>>3]*.1;i=i;return}function Tr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+848>>3]=-+h[b+15288>>3]- +h[b+584>>3];i=i;return}function Ur(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+928>>3]=-+h[b+848>>3]- +h[b+17248>>3]*+h[b+1072>>3];i=i;return}function Vr(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+784>>3];e=+h[b+776>>3];h[b+840>>3]=(+h[b+15016>>3]*d+ +h[b+15e3>>3]*e)*.8660254037844387+(d*+h[b+15008>>3]+e*+h[b+14992>>3])*-.4999999999999999;i=i;return}function Wr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+952>>3]=+h[b+840>>3]+ +h[b+6416>>3];i=i;return}function Xr(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+784>>3];e=+h[b+776>>3];h[b+832>>3]=(+h[b+15016>>3]*d+ +h[b+15e3>>3]*e)*.4999999999999999+(d*+h[b+15008>>3]+e*+h[b+14992>>3])*.8660254037844387;i=i;return}function Yr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15272>>3]=+h[b+832>>3]*-.1;i=i;return}function Zr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+856>>3]=-+h[b+15272>>3]- +h[b+568>>3];i=i;return}function _r(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+944>>3]=+h[b+832>>3]+ +h[b+6424>>3];i=i;return}function $r(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1080>>3]=+h[b+952>>3]*.8660254037844387+ +h[b+944>>3]*.4999999999999999;i=i;return}function as(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1088>>3]=+h[b+952>>3]*-.4999999999999999+ +h[b+944>>3]*.8660254037844387;i=i;return}function bs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+936>>3]=+h[b+17248>>3]*+h[b+944>>3]- +h[b+856>>3];i=i;return}function cs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=+h[f+13088>>3];j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[a+1088>>3];m=+h[f+13096>>3];n=+h[a+1080>>3];o=+h[a+936>>3]+(g*l-m*n);p=+h[a+1072>>3];q=+h[f+13080>>3];r=+h[a+576>>3];s=+h[a+928>>3];a=d;h[k>>3]=m*p-l*q-(r*-.8660254037844387+s*-.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=n*q-g*p-(r*.4999999999999999+s*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];UMb(e,3,o,d);RMb(e,(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1048|0);i=b;return}function ds(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+80>>3]=-(+h[(c[a+416>>2]|0)+18480>>3]*+h[b+6488>>3]);i=i;return}function es(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+104>>3]=-+h[b+80>>3]- +h[(c[a+416>>2]|0)+18360>>3]*+h[b+6488>>3];i=i;return}function fs(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+6496>>3]=+h[d+25392>>3]*((+h[b+6512>>3]+ +h[d+18840>>3])*-.4999999999999999+ +h[b+6520>>3]*.8660254037844387);i=i;return}function gs(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+64>>3]=+h[b+18496>>3]*+h[d+6488>>3]- +h[b+18488>>3]*+h[d+6496>>3];i=i;return}function hs(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+88>>3]=+h[b+18376>>3]*+h[d+6488>>3]+(-(+h[b+18368>>3]*+h[d+6496>>3])- +h[d+64>>3]);i=i;return}function is(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+72>>3]=+h[(c[a+416>>2]|0)+18480>>3]*+h[b+6496>>3];i=i;return}function js(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+96>>3]=+h[(c[a+416>>2]|0)+18360>>3]*+h[b+6496>>3]- +h[b+72>>3];i=i;return}function ks(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+272>>3]=+h[b+7920>>3]*+h[b+424>>3]+ +h[b+7944>>3]*+h[b+432>>3];i=i;return}function ls(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+32>>3]=(+h[b+20488>>3]- +h[b>>3])*+h[(c[a+416>>2]|0)+25536>>3];i=i;return}function ms(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+48>>3]=+h[b+19512>>3];i=i;return}function ns(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4312>>3]=+h[b+4264>>3]- +h[b+6120>>3];i=i;return}function os(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4320>>3]=+h[b+4272>>3]- +h[b+6112>>3];i=i;return}function ps(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4360>>3]=-(+h[b+16232>>3]*+h[b+4312>>3])- +h[b+16208>>3]*+h[b+4320>>3];i=i;return}function qs(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+6352>>3]=+h[d+23328>>3]*((+h[b+6368>>3]+ +h[d+18840>>3])*-.4999999999999999+ +h[b+6376>>3]*.8660254037844387);i=i;return}function rs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1272>>3]=+h[(c[a+416>>2]|0)+12448>>3]*+h[b+6352>>3];i=i;return}function ss(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1296>>3]=+h[(c[a+416>>2]|0)+12328>>3]*+h[b+6352>>3]- +h[b+1272>>3];i=i;return}function ts(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1264>>3]=+h[b+12464>>3]*+h[d+6344>>3]- +h[b+12456>>3]*+h[d+6352>>3];i=i;return}function us(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1288>>3]=+h[b+12344>>3]*+h[d+6344>>3]+(-(+h[b+12336>>3]*+h[d+6352>>3])- +h[d+1264>>3]);i=i;return}function vs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1280>>3]=-(+h[(c[a+416>>2]|0)+12448>>3]*+h[b+6344>>3]);i=i;return}function ws(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1304>>3]=-+h[b+1280>>3]- +h[(c[a+416>>2]|0)+12328>>3]*+h[b+6344>>3];i=i;return}function xs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15328>>3]=+h[b+1792>>3]*.1;i=i;return}function ys(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1568>>3]=-+h[b+15328>>3]- +h[b+1304>>3];i=i;return}function zs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1648>>3]=-+h[b+1568>>3]- +h[b+17016>>3]*+h[b+1792>>3];i=i;return}function As(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1504>>3];e=+h[b+1496>>3];h[b+1560>>3]=(+h[b+14968>>3]*d+ +h[b+14952>>3]*e)*.8660254037844387+(d*+h[b+14960>>3]+e*+h[b+14944>>3])*.4999999999999999;i=i;return}function Bs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1672>>3]=+h[b+1560>>3]+ +h[b+6344>>3];i=i;return}function Cs(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1504>>3];e=+h[b+1496>>3];h[b+1552>>3]=(+h[b+14968>>3]*d+ +h[b+14952>>3]*e)*-.4999999999999999+(d*+h[b+14960>>3]+e*+h[b+14944>>3])*.8660254037844387;i=i;return}function Ds(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15312>>3]=+h[b+1552>>3]*-.1;i=i;return}function Es(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1576>>3]=-+h[b+15312>>3]- +h[b+1288>>3];i=i;return}function Fs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1664>>3]=+h[b+1552>>3]+ +h[b+6352>>3];i=i;return}function Gs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1656>>3]=+h[b+17016>>3]*+h[b+1664>>3]- +h[b+1576>>3];i=i;return}function Hs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1800>>3]=+h[b+1672>>3]*.8660254037844387+ +h[b+1664>>3]*-.4999999999999999;i=i;return}function Is(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1808>>3]=+h[b+1672>>3]*.4999999999999999+ +h[b+1664>>3]*.8660254037844387;i=i;return}function Js(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=+h[f+10072>>3];j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[a+1808>>3];m=+h[f+10080>>3];n=+h[a+1800>>3];o=+h[a+1656>>3]+(g*l-m*n);p=+h[a+1792>>3];q=+h[f+10064>>3];r=+h[a+1296>>3];s=+h[a+1648>>3];a=d;h[k>>3]=m*p-l*q-(r*-.8660254037844387+s*.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=n*q-g*p-(r*-.4999999999999999+s*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];UMb(e,3,o,d);RMb(e,(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1768|0);i=b;return}function Ks(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+304>>3];e=+h[b+296>>3];h[b+360>>3]=(+h[b+15064>>3]*d+ +h[b+15048>>3]*e)*.8660254037844387+(d*+h[b+15056>>3]+e*+h[b+15040>>3])*.4999999999999999;i=i;return}function Ls(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+472>>3]=+h[b+360>>3]+ +h[b+6488>>3];i=i;return}function Ms(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+304>>3];e=+h[b+296>>3];h[b+352>>3]=(+h[b+15064>>3]*d+ +h[b+15048>>3]*e)*-.4999999999999999+(d*+h[b+15056>>3]+e*+h[b+15040>>3])*.8660254037844387;i=i;return}function Ns(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15232>>3]=+h[b+352>>3]*-.1;i=i;return}function Os(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+376>>3]=-+h[b+15232>>3]- +h[b+88>>3];i=i;return}function Ps(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+464>>3]=+h[b+352>>3]+ +h[b+6496>>3];i=i;return}function Qs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1248>>3]=+h[b+472>>3]*-.8660254037844387+ +h[b+464>>3]*.4999999999999999;i=i;return}function Rs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1968>>3]=+h[b+1248>>3]- +h[b+1080>>3];i=i;return}function Ss(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2688>>3]=+h[b+1968>>3]- +h[b+1800>>3];i=i;return}function Ts(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3408>>3]=+h[b+2688>>3]- +h[b+2520>>3];i=i;return}function Us(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4128>>3]=+h[b+3408>>3]- +h[b+3240>>3];i=i;return}function Vs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4176>>3]=+h[b+3960>>3]- +h[b+4128>>3];i=i;return}function Ws(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1256>>3]=+h[b+472>>3]*-.4999999999999999+ +h[b+464>>3]*-.8660254037844387;i=i;return}function Xs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1976>>3]=+h[b+1256>>3]- +h[b+1088>>3];i=i;return}function Ys(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2696>>3]=+h[b+1976>>3]- +h[b+1808>>3];i=i;return}function Zs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3416>>3]=+h[b+2696>>3]- +h[b+2528>>3];i=i;return}function _s(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4136>>3]=+h[b+3416>>3]- +h[b+3248>>3];i=i;return}function $s(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4184>>3]=+h[b+3968>>3]- +h[b+4136>>3];i=i;return}function at(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4408>>3]=-+h[b+4360>>3]- +h[b+4184>>3];i=i;return}function bt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+456>>3]=+h[b+17480>>3]*+h[b+464>>3]- +h[b+376>>3];i=i;return}function ct(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1216>>3]=+h[b+16104>>3]*+h[d+1256>>3]- +h[b+16112>>3]*+h[d+1248>>3]- +h[d+456>>3];i=i;return}function dt(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1144>>3]=+h[b+12808>>3]*+h[d+1248>>3]+(-(+h[b+12800>>3]*+h[d+1256>>3])- +h[d+1216>>3]);i=i;return}function et(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1936>>3]=-+h[b+1144>>3]- +h[b+1048>>3];i=i;return}function ft(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1864>>3]=+h[b+9792>>3]*+h[d+1968>>3]+(-(+h[b+9784>>3]*+h[d+1976>>3])- +h[d+1936>>3]);i=i;return}function gt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2656>>3]=-+h[b+1864>>3]- +h[b+1768>>3];i=i;return}function ht(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2584>>3]=+h[b+6776>>3]*+h[d+2688>>3]+(-(+h[b+6768>>3]*+h[d+2696>>3])- +h[d+2656>>3]);i=i;return}function it(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3376>>3]=-+h[b+2584>>3]- +h[b+2488>>3];i=i;return}function jt(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3304>>3]=+h[b+3760>>3]*+h[d+3408>>3]+(-(+h[b+3752>>3]*+h[d+3416>>3])- +h[d+3376>>3]);i=i;return}function kt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4096>>3]=-+h[b+3304>>3]- +h[b+3208>>3];i=i;return}function lt(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4024>>3]=+h[b+744>>3]*+h[d+4128>>3]+(-(+h[b+736>>3]*+h[d+4136>>3])- +h[d+4096>>3]);i=i;return}function mt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4144>>3]=+h[b+4024>>3]+ +h[b+3928>>3];i=i;return}function nt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4368>>3]=+h[b+20488>>3]- +h[b+4144>>3];i=i;return}function ot(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+7920>>3];k=+h[(c[b+416>>2]|0)+24976>>3];l=+h[g+15504>>3]*+h[g+256>>3]+ +h[g+15512>>3]*+h[g+264>>3];if(k!=0.0){m=g;n=l/k;o=j*n;p=m;q=p+328|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j*n;p=m;q=p+328|0;r=q;h[r>>3]=o;i=d;return}s=l/+$Lb(c[b+536>>2]|0,k,904,5240,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+328|0;r=q;h[r>>3]=o;i=d;return}function pt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1240>>3]=+h[b+7944>>3]*+h[b+19672>>3]- +h[b+328>>3];i=i;return}function qt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+15248>>3]=+h[b+1240>>3]*-.1;i=i;return}function rt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+368>>3]=-+h[b+15248>>3]- +h[b+104>>3];i=i;return}function st(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1960>>3]=+h[b+1240>>3]- +h[b+1072>>3];i=i;return}function tt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2680>>3]=+h[b+1960>>3]- +h[b+1792>>3];i=i;return}function ut(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3400>>3]=+h[b+2680>>3]- +h[b+2512>>3];i=i;return}function vt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4120>>3]=+h[b+3400>>3]- +h[b+3232>>3];i=i;return}function wt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4168>>3]=+h[b+3952>>3]- +h[b+4120>>3];i=i;return}function xt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+448>>3]=+h[b+17480>>3]*+h[b+1240>>3]- +h[b+368>>3];i=i;return}function yt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1192>>3]=+h[b+272>>3]- +h[b+1240>>3];i=i;return}function zt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1912>>3]=+h[b+1192>>3]- +h[b+1024>>3];i=i;return}function At(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2632>>3]=+h[b+1912>>3]- +h[b+1744>>3];i=i;return}function Bt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3352>>3]=+h[b+2632>>3]- +h[b+2464>>3];i=i;return}function Ct(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4072>>3]=+h[b+3352>>3]- +h[b+3184>>3];i=i;return}function Dt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4344>>3]=+h[b+3904>>3]- +h[b+4072>>3];i=i;return}function Et(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4392>>3]=-+h[b+4344>>3]- +h[b+4168>>3];i=i;return}function Ft(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1232>>3]=+h[b+96>>3]*-.4999999999999999+(+h[b+448>>3]*-.8660254037844387+(+h[d+16096>>3]*+h[b+1248>>3]- +h[d+16104>>3]*+h[b+1240>>3]));i=i;return}function Gt(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1160>>3]=+h[b+12800>>3]*+h[d+1240>>3]+(-(+h[b+12792>>3]*+h[d+1248>>3])- +h[d+1232>>3]);i=i;return}function Ht(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1952>>3]=-+h[b+1160>>3]- +h[b+1064>>3];i=i;return}function It(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1880>>3]=+h[b+9784>>3]*+h[d+1960>>3]+(-(+h[b+9776>>3]*+h[d+1968>>3])- +h[d+1952>>3]);i=i;return}function Jt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2672>>3]=-+h[b+1880>>3]- +h[b+1784>>3];i=i;return}function Kt(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2600>>3]=+h[b+6768>>3]*+h[d+2680>>3]+(-(+h[b+6760>>3]*+h[d+2688>>3])- +h[d+2672>>3]);i=i;return}function Lt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3392>>3]=-+h[b+2600>>3]- +h[b+2504>>3];i=i;return}function Mt(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3320>>3]=+h[b+3752>>3]*+h[d+3400>>3]+(-(+h[b+3744>>3]*+h[d+3408>>3])- +h[d+3392>>3]);i=i;return}function Nt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4112>>3]=-+h[b+3320>>3]- +h[b+3224>>3];i=i;return}function Ot(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4040>>3]=+h[b+736>>3]*+h[d+4120>>3]+(-(+h[b+728>>3]*+h[d+4128>>3])- +h[d+4112>>3]);i=i;return}function Pt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4160>>3]=+h[b+4040>>3]+ +h[b+3944>>3];i=i;return}function Qt(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1224>>3]=+h[b+96>>3]*-.8660254037844387+(+h[b+448>>3]*.4999999999999999+(+h[d+16112>>3]*+h[b+1240>>3]- +h[d+16096>>3]*+h[b+1256>>3]));i=i;return}function Rt(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1152>>3]=+h[b+12792>>3]*+h[d+1256>>3]+(-(+h[b+12808>>3]*+h[d+1240>>3])- +h[d+1224>>3]);i=i;return}function St(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1944>>3]=-+h[b+1152>>3]- +h[b+1056>>3];i=i;return}function Tt(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1872>>3]=+h[b+9776>>3]*+h[d+1976>>3]+(-(+h[b+9792>>3]*+h[d+1960>>3])- +h[d+1944>>3]);i=i;return}function Ut(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2664>>3]=-+h[b+1872>>3]- +h[b+1776>>3];i=i;return}function Vt(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2592>>3]=+h[b+6760>>3]*+h[d+2696>>3]+(-(+h[b+6776>>3]*+h[d+2680>>3])- +h[d+2664>>3]);i=i;return}function Wt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3384>>3]=-+h[b+2592>>3]- +h[b+2496>>3];i=i;return}function Xt(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3312>>3]=+h[b+3744>>3]*+h[d+3416>>3]+(-(+h[b+3760>>3]*+h[d+3400>>3])- +h[d+3384>>3]);i=i;return}function Yt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4104>>3]=-+h[b+3312>>3]- +h[b+3216>>3];i=i;return}function Zt(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4032>>3]=+h[b+728>>3]*+h[d+4136>>3]+(-(+h[b+744>>3]*+h[d+4120>>3])- +h[d+4104>>3]);i=i;return}function _t(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4152>>3]=+h[b+4032>>3]+ +h[b+3936>>3];i=i;return}function $t(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+488>>3]=+h[b+10256>>3]*+h[b+296>>3]+(+h[b+200>>3]*+h[b+1240>>3]- +h[b+256>>3]);i=i;return}function au(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+528>>3]=+h[d+488>>3]- +h[b+16e3>>3]*+h[d+504>>3]- +h[b+16016>>3]*+h[d+1192>>3];i=i;return}function bu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+496>>3]=-(+h[b+10256>>3]*+h[b+304>>3])- +h[b+264>>3]- +h[b+208>>3]*+h[b+1240>>3];i=i;return}function cu(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+536>>3]=+h[b+16e3>>3]*+h[d+512>>3]+(+h[b+16008>>3]*+h[d+1192>>3]+ +h[d+496>>3]);i=i;return}function du(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1176>>3]=+h[b+528>>3]*-.8660254037844387+(+h[b+536>>3]*-.4999999999999999+(+h[d+16496>>3]*+h[b+1192>>3]- +h[d+16480>>3]*+h[b+1208>>3]));i=i;return}function eu(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1128>>3]=+h[b+12888>>3]*+h[d+1208>>3]+(-(+h[b+12904>>3]*+h[d+1192>>3])- +h[d+1176>>3]);i=i;return}function fu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1896>>3]=-+h[b+1128>>3]- +h[b+1008>>3];i=i;return}function gu(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1848>>3]=+h[b+9872>>3]*+h[d+1928>>3]+(-(+h[b+9888>>3]*+h[d+1912>>3])- +h[d+1896>>3]);i=i;return}function hu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2616>>3]=-+h[b+1848>>3]- +h[b+1728>>3];i=i;return}function iu(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2568>>3]=+h[b+6856>>3]*+h[d+2648>>3]+(-(+h[b+6872>>3]*+h[d+2632>>3])- +h[d+2616>>3]);i=i;return}function ju(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3336>>3]=-+h[b+2568>>3]- +h[b+2448>>3];i=i;return}function ku(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3288>>3]=+h[b+3840>>3]*+h[d+3368>>3]+(-(+h[b+3856>>3]*+h[d+3352>>3])- +h[d+3336>>3]);i=i;return}function lu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4056>>3]=-+h[b+3288>>3]- +h[b+3168>>3];i=i;return}function mu(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4008>>3]=+h[b+824>>3]*+h[d+4088>>3]+(-(+h[b+840>>3]*+h[d+4072>>3])- +h[d+4056>>3]);i=i;return}function nu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4248>>3]=-+h[b+4008>>3]- +h[b+3888>>3];i=i;return}function ou(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4224>>3]=+h[b+264>>3]*+h[d+4264>>3]+(+h[b+280>>3]*+h[d+4344>>3]- +h[d+4248>>3]);i=i;return}function pu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4304>>3]=-+h[b+4224>>3]- +h[b+4200>>3];i=i;return}function qu(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1184>>3]=+h[b+528>>3]*.4999999999999999+(+h[b+536>>3]*-.8660254037844387+(+h[d+16480>>3]*+h[b+1200>>3]- +h[d+16488>>3]*+h[b+1192>>3]));i=i;return}function ru(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1136>>3]=+h[b+12896>>3]*+h[d+1192>>3]+(-(+h[b+12888>>3]*+h[d+1200>>3])- +h[d+1184>>3]);i=i;return}function su(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1904>>3]=-+h[b+1136>>3]- +h[b+1016>>3];i=i;return}function tu(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1856>>3]=+h[b+9880>>3]*+h[d+1912>>3]+(-(+h[b+9872>>3]*+h[d+1920>>3])- +h[d+1904>>3]);i=i;return}function uu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2624>>3]=-+h[b+1856>>3]- +h[b+1736>>3];i=i;return}function vu(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2576>>3]=+h[b+6864>>3]*+h[d+2632>>3]+(-(+h[b+6856>>3]*+h[d+2640>>3])- +h[d+2624>>3]);i=i;return}function wu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3344>>3]=-+h[b+2576>>3]- +h[b+2456>>3];i=i;return}function xu(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3296>>3]=+h[b+3848>>3]*+h[d+3352>>3]+(-(+h[b+3840>>3]*+h[d+3360>>3])- +h[d+3344>>3]);i=i;return}function yu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4064>>3]=-+h[b+3296>>3]- +h[b+3176>>3];i=i;return}function zu(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4016>>3]=+h[b+832>>3]*+h[d+4072>>3]+(-(+h[b+824>>3]*+h[d+4080>>3])- +h[d+4064>>3]);i=i;return}function Au(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4256>>3]=-+h[b+4016>>3]- +h[b+3896>>3];i=i;return}function Bu(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4232>>3]=-(+h[b+264>>3]*+h[d+4272>>3])- +h[d+4256>>3]- +h[b+272>>3]*+h[d+4344>>3];i=i;return}function Cu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4296>>3]=-+h[b+4232>>3]- +h[b+4208>>3];i=i;return}function Du(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4328>>3]=-(+h[b+16232>>3]*+h[b+4296>>3])- +h[b+16208>>3]*+h[b+4304>>3];i=i;return}function Eu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4384>>3]=-+h[b+4328>>3]- +h[b+4160>>3];i=i;return}function Fu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4352>>3]=-(+h[b+16224>>3]*+h[b+4312>>3])- +h[b+16200>>3]*+h[b+4320>>3];i=i;return}function Gu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4400>>3]=-+h[b+4352>>3]- +h[b+4176>>3];i=i;return}function Hu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4336>>3]=-(+h[b+16224>>3]*+h[b+4296>>3])- +h[b+16200>>3]*+h[b+4304>>3];i=i;return}function Iu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4376>>3]=-+h[b+4336>>3]- +h[b+4152>>3];i=i;return}function Ju(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!(($Ob(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19608>>3],1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[69976]|0;g=d;j=6576;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ee[a&31](f,d,5336,e);i=b;return}function Ku(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!(($Ob(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19624>>3],1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[69976]|0;g=d;j=6600;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ee[a&31](f,d,5952,e);i=b;return}function Lu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!(($Ob(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19768>>3],1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[69976]|0;g=d;j=6576;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ee[a&31](f,d,5336,e);i=b;return}function Mu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!(($Ob(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19784>>3],1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[69976]|0;g=d;j=6600;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ee[a&31](f,d,5952,e);i=b;return}function Nu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!(($Ob(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19928>>3],1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[69976]|0;g=d;j=6576;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ee[a&31](f,d,5336,e);i=b;return}function Ou(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!(($Ob(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19944>>3],1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[69976]|0;g=d;j=6600;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ee[a&31](f,d,5952,e);i=b;return}function Pu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!(($Ob(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20088>>3],1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[69976]|0;g=d;j=6576;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ee[a&31](f,d,5336,e);i=b;return}function Qu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!(($Ob(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20104>>3],1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[69976]|0;g=d;j=6600;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ee[a&31](f,d,5952,e);i=b;return}function Ru(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!(($Ob(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20248>>3],1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[69976]|0;g=d;j=6576;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ee[a&31](f,d,5336,e);i=b;return}function Su(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!(($Ob(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20264>>3],1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[69976]|0;g=d;j=6600;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ee[a&31](f,d,5952,e);i=b;return}function Tu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!(($Ob(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20408>>3],1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[69976]|0;g=d;j=6576;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ee[a&31](f,d,5336,e);i=b;return}function Uu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!(($Ob(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20424>>3],1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[69976]|0;g=d;j=6600;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ee[a&31](f,d,5952,e);i=b;return}function Vu(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;_e(b);$e(b);af(b);bf(b);cf(b);df(b);ef(b);ff(b);gf(b);hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);Jg(b);Kg(b);Lg(b);Mg(b);Ng(b);Og(b);Pg(b);Qg(b);Rg(b);Sg(b);Tg(b);Ug(b);Vg(b);Wg(b);Xg(b);Yg(b);Zg(b);_g(b);$g(b);ah(b);bh(b);ch(b);dh(b);eh(b);fh(b);gh(b);hh(b);ih(b);jh(b);kh(b);lh(b);mh(b);nh(b);oh(b);ph(b);qh(b);rh(b);sh(b);th(b);uh(b);vh(b);wh(b);xh(b);yh(b);zh(b);Ah(b);Bh(b);Ch(b);Dh(b);Eh(b);Fh(b);Gh(b);Hh(b);Ih(b);Jh(b);Kh(b);Lh(b);Mh(b);Nh(b);Oh(b);Ph(b);Qh(b);Rh(b);Sh(b);Th(b);Uh(b);Vh(b);Wh(b);Xh(b);Yh(b);Zh(b);_h(b);$h(b);ai(b);bi(b);ci(b);di(b);ei(b);fi(b);gi(b);hi(b);ii(b);ji(b);ki(b);li(b);mi(b);ni(b);oi(b);pi(b);qi(b);ri(b);si(b);ti(b);ui(b);vi(b);wi(b);xi(b);yi(b);zi(b);Ai(b);Bi(b);Ci(b);Di(b);Ei(b);Fi(b);Gi(b);Hi(b);Ii(b);Ji(b);Ki(b);Li(b);Mi(b);Ni(b);Oi(b);Pi(b);Qi(b);Ri(b);Si(b);Ti(b);Ui(b);Vi(b);Wi(b);Xi(b);Yi(b);Zi(b);_i(b);$i(b);aj(b);bj(b);cj(b);dj(b);ej(b);fj(b);gj(b);hj(b);ij(b);jj(b);kj(b);lj(b);mj(b);nj(b);oj(b);pj(b);qj(b);rj(b);sj(b);tj(b);uj(b);vj(b);wj(b);xj(b);yj(b);zj(b);Aj(b);Bj(b);Cj(b);Dj(b);Ej(b);Fj(b);Gj(b);Hj(b);Ij(b);Jj(b);Kj(b);Lj(b);Mj(b);Nj(b);Oj(b);Pj(b);Qj(b);Rj(b);Sj(b);Tj(b);Uj(b);Vj(b);Wj(b);Xj(b);Yj(b);Zj(b);_j(b);$j(b);ak(b);bk(b);ck(b);dk(b);ek(b);fk(b);gk(b);hk(b);ik(b);jk(b);kk(b);lk(b);mk(b);nk(b);ok(b);pk(b);qk(b);rk(b);sk(b);tk(b);uk(b);vk(b);wk(b);xk(b);yk(b);zk(b);Ak(b);Bk(b);Ck(b);Dk(b);Ek(b);Fk(b);Gk(b);Hk(b);Ik(b);Jk(b);Kk(b);Lk(b);Mk(b);Nk(b);Ok(b);Pk(b);Qk(b);Rk(b);Sk(b);Tk(b);Uk(b);Vk(b);Wk(b);Xk(b);Yk(b);Zk(b);_k(b);$k(b);al(b);bl(b);cl(b);dl(b);el(b);fl(b);gl(b);hl(b);il(b);jl(b);kl(b);ll(b);ml(b);nl(b);ol(b);pl(b);ql(b);rl(b);sl(b);tl(b);ul(b);vl(b);wl(b);xl(b);yl(b);zl(b);Al(b);Bl(b);Cl(b);Dl(b);El(b);Fl(b);Gl(b);Hl(b);Il(b);Jl(b);Kl(b);Ll(b);Ml(b);Nl(b);Ol(b);Pl(b);Ql(b);Rl(b);Sl(b);Tl(b);Ul(b);Vl(b);Wl(b);Xl(b);Yl(b);Zl(b);_l(b);$l(b);am(b);bm(b);cm(b);dm(b);em(b);fm(b);gm(b);hm(b);im(b);jm(b);km(b);lm(b);mm(b);nm(b);om(b);pm(b);qm(b);rm(b);sm(b);tm(b);um(b);vm(b);wm(b);xm(b);ym(b);zm(b);Am(b);Bm(b);Cm(b);Dm(b);Em(b);Fm(b);Gm(b);Hm(b);Im(b);Jm(b);Km(b);Lm(b);Mm(b);Nm(b);Om(b);Pm(b);Qm(b);Rm(b);Sm(b);Tm(b);Um(b);Vm(b);Wm(b);Xm(b);Ym(b);Zm(b);_m(b);$m(b);an(b);bn(b);cn(b);dn(b);en(b);fn(b);gn(b);hn(b);jn(b);kn(b);ln(b);mn(b);nn(b);on(b);pn(b);qn(b);rn(b);sn(b);tn(b);un(b);vn(b);wn(b);xn(b);yn(b);zn(b);An(b);Bn(b);Cn(b);Dn(b);En(b);Fn(b);Gn(b);Hn(b);In(b);Jn(b);Kn(b);Ln(b);Mn(b);Nn(b);On(b);Pn(b);Qn(b);Rn(b);Sn(b);Tn(b);Un(b);Vn(b);Wn(b);Xn(b);Yn(b);Zn(b);_n(b);$n(b);ao(b);bo(b);co(b);eo(b);fo(b);go(b);ho(b);io(b);jo(b);ko(b);lo(b);mo(b);no(b);oo(b);po(b);qo(b);ro(b);so(b);to(b);uo(b);vo(b);wo(b);xo(b);yo(b);zo(b);Ao(b);Bo(b);Co(b);Do(b);Eo(b);Fo(b);Go(b);Ho(b);Io(b);Jo(b);Ko(b);Lo(b);Mo(b);No(b);Oo(b);Po(b);Qo(b);Ro(b);So(b);To(b);Uo(b);Vo(b);Wo(b);Xo(b);Yo(b);Zo(b);_o(b);$o(b);ap(b);bp(b);cp(b);dp(b);ep(b);fp(b);gp(b);hp(b);ip(b);jp(b);kp(b);lp(b);mp(b);np(b);op(b);pp(b);qp(b);rp(b);sp(b);tp(b);up(b);vp(b);wp(b);xp(b);yp(b);zp(b);Ap(b);Bp(b);Cp(b);Dp(b);Ep(b);Fp(b);Gp(b);Hp(b);Ip(b);Jp(b);Kp(b);Lp(b);Mp(b);Np(b);Op(b);Pp(b);Qp(b);Rp(b);Sp(b);Tp(b);Up(b);Vp(b);Wp(b);Xp(b);Yp(b);Zp(b);_p(b);$p(b);aq(b);bq(b);cq(b);dq(b);eq(b);fq(b);gq(b);hq(b);iq(b);jq(b);kq(b);lq(b);mq(b);nq(b);oq(b);pq(b);qq(b);rq(b);sq(b);tq(b);uq(b);vq(b);wq(b);xq(b);yq(b);zq(b);Aq(b);Bq(b);Cq(b);Dq(b);Eq(b);Fq(b);Gq(b);Hq(b);Iq(b);Jq(b);Kq(b);Lq(b);Mq(b);Nq(b);Oq(b);Pq(b);Qq(b);Rq(b);Sq(b);Tq(b);Uq(b);Vq(b);Wq(b);Xq(b);Yq(b);Zq(b);_q(b);$q(b);ar(b);br(b);cr(b);dr(b);er(b);fr(b);gr(b);hr(b);ir(b);jr(b);kr(b);lr(b);mr(b);nr(b);or(b);pr(b);qr(b);rr(b);sr(b);tr(b);ur(b);vr(b);wr(b);xr(b);yr(b);zr(b);Ar(b);Br(b);Cr(b);Dr(b);Er(b);Fr(b);Gr(b);Hr(b);Ir(b);Jr(b);Kr(b);Lr(b);Mr(b);Nr(b);Or(b);Pr(b);Qr(b);Rr(b);Sr(b);Tr(b);Ur(b);Vr(b);Wr(b);Xr(b);Yr(b);Zr(b);_r(b);$r(b);as(b);bs(b);cs(b);ds(b);es(b);fs(b);gs(b);hs(b);is(b);js(b);ks(b);ls(b);ms(b);ns(b);os(b);ps(b);qs(b);rs(b);ss(b);ts(b);us(b);vs(b);ws(b);xs(b);ys(b);zs(b);As(b);Bs(b);Cs(b);Ds(b);Es(b);Fs(b);Gs(b);Hs(b);Is(b);Js(b);Ks(b);Ls(b);Ms(b);Ns(b);Os(b);Ps(b);Qs(b);Rs(b);Ss(b);Ts(b);Us(b);Vs(b);Ws(b);Xs(b);Ys(b);Zs(b);_s(b);$s(b);at(b);bt(b);ct(b);dt(b);et(b);ft(b);gt(b);ht(b);it(b);jt(b);kt(b);lt(b);mt(b);nt(b);ot(b);pt(b);qt(b);rt(b);st(b);tt(b);ut(b);vt(b);wt(b);xt(b);yt(b);zt(b);At(b);Bt(b);Ct(b);Dt(b);Et(b);Ft(b);Gt(b);Ht(b);It(b);Jt(b);Kt(b);Lt(b);Mt(b);Nt(b);Ot(b);Pt(b);Qt(b);Rt(b);St(b);Tt(b);Ut(b);Vt(b);Wt(b);Xt(b);Yt(b);Zt(b);_t(b);$t(b);au(b);bu(b);cu(b);du(b);eu(b);fu(b);gu(b);hu(b);iu(b);ju(b);ku(b);lu(b);mu(b);nu(b);ou(b);pu(b);qu(b);ru(b);su(b);tu(b);uu(b);vu(b);wu(b);xu(b);yu(b);zu(b);Au(b);Bu(b);Cu(b);Du(b);Eu(b);Fu(b);Gu(b);Hu(b);Iu(b);Ju(b);Ku(b);Lu(b);Mu(b);Nu(b);Ou(b);Pu(b);Qu(b);Ru(b);Su(b);Tu(b);Uu(b);i=c;return 0}function Wu(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Xu(b);i=c;return 0}function Xu(a){a=a|0;var b=0;b=i;Cf(a);Df(a);Ef(a);Gf(a);Hf(a);If(a);Jf(a);Kf(a);Lf(a);Mf(a);Nf(a);Of(a);Pf(a);Qf(a);Rf(a);Sf(a);Tf(a);Uf(a);Vf(a);Wf(a);Xf(a);Yf(a);Zf(a);_f(a);$f(a);ag(a);bg(a);cg(a);dg(a);eg(a);fg(a);gg(a);hg(a);ig(a);jg(a);kg(a);lg(a);mg(a);ng(a);og(a);pg(a);qg(a);rg(a);sg(a);tg(a);ug(a);vg(a);wg(a);xg(a);yg(a);zg(a);Ag(a);Bg(a);Cg(a);Dg(a);Eg(a);Fg(a);Gg(a);Hg(a);Ig(a);Kg(a);Lg(a);Mg(a);Ng(a);Og(a);Pg(a);Qg(a);Rg(a);Sg(a);Tg(a);Ug(a);Vg(a);Wg(a);Xg(a);Yg(a);Zg(a);_g(a);$g(a);ah(a);bh(a);ch(a);dh(a);eh(a);fh(a);gh(a);hh(a);ih(a);jh(a);kh(a);lh(a);mh(a);nh(a);oh(a);ph(a);qh(a);rh(a);sh(a);uh(a);vh(a);wh(a);yh(a);zh(a);Dh(a);Eh(a);Fh(a);Gh(a);Hh(a);Ih(a);Jh(a);Kh(a);Lh(a);Mh(a);Nh(a);Oh(a);Qh(a);Rh(a);Sh(a);Th(a);Uh(a);Vh(a);Wh(a);Xh(a);Yh(a);Zh(a);_h(a);$h(a);ai(a);bi(a);di(a);fi(a);gi(a);hi(a);ii(a);ji(a);ki(a);li(a);mi(a);ni(a);oi(a);pi(a);ri(a);si(a);ti(a);ui(a);vi(a);wi(a);xi(a);yi(a);zi(a);Ai(a);Ci(a);Di(a);Ei(a);Fi(a);Gi(a);Hi(a);Ii(a);Ji(a);Ki(a);Li(a);Mi(a);Ni(a);Oi(a);Pi(a);Qi(a);Ri(a);Si(a);Ti(a);Ui(a);Vi(a);Wi(a);Xi(a);Yi(a);_i(a);$i(a);aj(a);cj(a);dj(a);hj(a);ij(a);jj(a);kj(a);lj(a);mj(a);nj(a);oj(a);pj(a);qj(a);rj(a);sj(a);uj(a);vj(a);wj(a);xj(a);yj(a);zj(a);Aj(a);Bj(a);Cj(a);Dj(a);Ej(a);Fj(a);Gj(a);Hj(a);Jj(a);Lj(a);Mj(a);Nj(a);Oj(a);Pj(a);Qj(a);Rj(a);Sj(a);Tj(a);Uj(a);Vj(a);Xj(a);Yj(a);Zj(a);_j(a);$j(a);ak(a);bk(a);ck(a);dk(a);ek(a);gk(a);hk(a);ik(a);jk(a);kk(a);lk(a);mk(a);nk(a);ok(a);pk(a);qk(a);rk(a);sk(a);tk(a);uk(a);vk(a);wk(a);xk(a);yk(a);zk(a);Ak(a);Bk(a);Ck(a);Ek(a);Fk(a);Gk(a);Ik(a);Jk(a);Nk(a);Ok(a);Pk(a);Qk(a);Rk(a);Sk(a);Tk(a);Uk(a);Vk(a);Wk(a);Xk(a);Yk(a);_k(a);$k(a);al(a);bl(a);cl(a);dl(a);el(a);fl(a);gl(a);hl(a);il(a);jl(a);kl(a);ll(a);nl(a);pl(a);ql(a);rl(a);sl(a);tl(a);ul(a);vl(a);wl(a);xl(a);yl(a);zl(a);Bl(a);Cl(a);Dl(a);El(a);Fl(a);Gl(a);Hl(a);Il(a);Jl(a);Kl(a);Ml(a);Nl(a);Ol(a);Pl(a);Ql(a);Rl(a);Sl(a);Tl(a);Ul(a);Vl(a);Wl(a);Xl(a);Yl(a);Zl(a);_l(a);$l(a);am(a);bm(a);cm(a);dm(a);em(a);fm(a);gm(a);im(a);jm(a);km(a);mm(a);nm(a);rm(a);sm(a);tm(a);um(a);vm(a);wm(a);xm(a);ym(a);zm(a);Am(a);Bm(a);Cm(a);Em(a);Fm(a);Gm(a);Hm(a);Im(a);Jm(a);Km(a);Lm(a);Mm(a);Nm(a);Om(a);Pm(a);Qm(a);Rm(a);Tm(a);Vm(a);Wm(a);Xm(a);Ym(a);Zm(a);_m(a);$m(a);an(a);bn(a);cn(a);dn(a);fn(a);gn(a);hn(a);jn(a);kn(a);ln(a);mn(a);nn(a);on(a);pn(a);rn(a);sn(a);tn(a);un(a);vn(a);wn(a);xn(a);yn(a);zn(a);An(a);Bn(a);Cn(a);Dn(a);En(a);Fn(a);Gn(a);Hn(a);In(a);Jn(a);Kn(a);Ln(a);Mn(a);Nn(a);Pn(a);Qn(a);Rn(a);Tn(a);Un(a);Yn(a);Zn(a);_n(a);$n(a);ao(a);bo(a);co(a);eo(a);fo(a);go(a);ho(a);io(a);ko(a);lo(a);mo(a);no(a);oo(a);po(a);qo(a);ro(a);so(a);to(a);uo(a);vo(a);wo(a);xo(a);zo(a);Bo(a);Co(a);Do(a);Eo(a);Fo(a);Go(a);Ho(a);Io(a);Jo(a);Ko(a);Lo(a);No(a);Oo(a);Po(a);Qo(a);Ro(a);So(a);To(a);Uo(a);Vo(a);Wo(a);Yo(a);Zo(a);_o(a);$o(a);ap(a);bp(a);cp(a);dp(a);ep(a);fp(a);gp(a);hp(a);ip(a);jp(a);kp(a);lp(a);mp(a);np(a);op(a);pp(a);qp(a);rp(a);tp(a);up(a);vp(a);xp(a);yp(a);Cp(a);Dp(a);Ep(a);Fp(a);Gp(a);Hp(a);Ip(a);Jp(a);Kp(a);Lp(a);Mp(a);Np(a);Pp(a);Qp(a);Rp(a);Sp(a);Tp(a);Up(a);Vp(a);Wp(a);Xp(a);Yp(a);Zp(a);_p(a);$p(a);aq(a);cq(a);eq(a);fq(a);gq(a);hq(a);iq(a);jq(a);kq(a);lq(a);mq(a);nq(a);oq(a);qq(a);rq(a);sq(a);tq(a);uq(a);vq(a);wq(a);xq(a);yq(a);zq(a);Cq(a);ls(a);ms(a);i=b;return}function Yu(a,b){a=a|0;b=+b;i=i;return 0}function Zu(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;YLb(c[a+536>>2]|0,(a|0)!=0|0,6832,b);c[a+540>>2]=6640;c[a+84>>2]=6864;c[a+88>>2]=6864;c[a+92>>2]=6928;c[a+96>>2]=7016;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=4;c[a+116>>2]=2716;c[a+120>>2]=0;c[a+124>>2]=327;c[a+128>>2]=0;c[a+132>>2]=0;c[a+136>>2]=3193;c[a+140>>2]=224;c[a+144>>2]=314;c[a+148>>2]=95;c[a+152>>2]=0;c[a+156>>2]=3;c[a+232>>2]=5;c[a+216>>2]=6458;c[a+220>>2]=228;c[a+224>>2]=0;c[a+228>>2]=0;c[a+160>>2]=18;c[a+104>>2]=0;c[a+164>>2]=18;c[a+168>>2]=0;c[a+176>>2]=32;c[a+180>>2]=0;c[a+184>>2]=32;c[a+188>>2]=0;c[a+56>>2]=7056;c[a+64>>2]=5;c[a+72>>2]=0;c[a+68>>2]=8374;c[a+192>>2]=0;c[a+196>>2]=2;c[a+172>>2]=0;d=a+200|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;i=b;return}function _u(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Na(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=Rec(c[k>>2]|0,e)|0;if((l|0)==0){cb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=k;w=7}else if((l|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=k}else{E=234440;F=234464;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Na(c[58610]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=Rec(c[F>>2]|0,e)|0;if((G|0)==0){cb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=F;w=7;break}else if((G|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=F;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[57846]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=Rec(c[H>>2]|0,e)|0;if((I|0)==0){cb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((I|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}u=0;Ga(47,c[57846]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=Rec(c[H>>2]|0,e)|0;if((K|0)==0){cb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((K|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}H=h;c[g>>2]=h;Dec(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=Rec(c[L>>2]|0,e)|0;if((M|0)==0){cb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==2){m=0;n=0;o=0;p=H;q=E;s=F;t=L;w=7;break}else if((M|0)==1){x=0;y=0;z=0;A=H;B=E;C=F;D=L;break}m=0;n=0;o=0;p=H;q=E;s=F;t=0;w=7}}while(0);while(1){if((w|0)==7){w=0;if((t|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;Dec(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=Rec(c[I>>2]|0,e)|0;if((N|0)==0){cb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==2){O=s;P=q;Q=p;m=K;n=h;o=M;t=I;s=O;q=P;p=Q;w=7;continue}else if((N|0)==1){x=K;y=h;z=M;A=p;B=q;C=s;D=I;continue}x=K;y=h;z=M;A=p;B=q;C=s;D=0;continue}else{u=0;Ga(47,c[57846]|0,q|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=Rec(c[M>>2]|0,e)|0;if((R|0)==0){cb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((R|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}u=0;Na(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=Rec(c[M>>2]|0,e)|0;if((V|0)==0){cb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((V|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}else{w=18;break}}}if((D|0)!=0){u=0;Na(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=Rec(c[M>>2]|0,e)|0;if((W|0)==0){cb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((W|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}M=c[r>>2]|0;u=0;Pa(34,7128,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=Rec(c[M>>2]|0,e)|0;if((ba|0)==0){cb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ba|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=Rec(c[M>>2]|0,e)|0;if((ca|0)==0){cb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ca|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=Rec(c[M>>2]|0,e)|0;if((da|0)==0){cb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((da|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}else{w=15;break}}u=0;pa(137,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=Rec(c[M>>2]|0,e)|0;if((ea|0)==0){cb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ea|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[f+536>>2]=g;u=0;M=xa(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=Rec(c[h>>2]|0,e)|0;if((fa|0)==0){cb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((fa|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[y>>2]=x;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=Rec(c[h>>2]|0,e)|0;if((ga|0)==0){cb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ga|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;Ga(47,c[57846]|0,B|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=Rec(c[h>>2]|0,e)|0;if((ha|0)==0){cb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ha|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=Rec(c[h>>2]|0,e)|0;if((ia|0)==0){cb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ia|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=Rec(c[h>>2]|0,e)|0;if((ja|0)==0){cb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ja|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;pa(138,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=Rec(c[M>>2]|0,e)|0;if((ka|0)==0){cb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7}else if((ka|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa}else{w=26;break}}if((w|0)==15){la=A;ma=C;i=d;return 1}else if((w|0)==18){la=p;ma=s;i=d;return 1}return 0}function $u(){var a=0;a=i;sd(0)|0;pc(7288,18,1,c[r>>2]|0)|0;sd(0)|0;i=a;return}function av(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;h[a>>3]=c>d?e:f;i=i;return}function bv(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=c>d?c:d;i=i;return}



function LFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218312]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(218320,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21264>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[218312]=1;i=d;return}function MFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218448]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(218456,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21256>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[218448]=1;i=d;return}function NFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218584]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(218592,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21248>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[218584]=1;i=d;return}function OFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218720]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(218728,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21232>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[218720]=1;i=d;return}function PFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218856]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(218864,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21224>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[218856]=1;i=d;return}function QFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218992]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(219e3,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21216>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[218992]=1;i=d;return}function RFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219128]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(219136,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21200>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[219128]=1;i=d;return}function SFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219288]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(219296,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21192>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[219288]=1;i=d;return}function TFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219448]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(219456,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+21184>>3],24152)|0)|0;g=c[69978]|0;j=e;k=219584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[219448]=1;i=d;return}function UFb(a){a=a|0;var b=0;b=i;Wya(a);Xya(a);Yya(a);Zya(a);_ya(a);$ya(a);aza(a);bza(a);cza(a);dza(a);eza(a);fza(a);gza(a);hza(a);iza(a);jza(a);kza(a);lza(a);mza(a);nza(a);oza(a);pza(a);qza(a);rza(a);sza(a);tza(a);uza(a);vza(a);wza(a);xza(a);yza(a);zza(a);Aza(a);Bza(a);Cza(a);Dza(a);Eza(a);Fza(a);Gza(a);Hza(a);Iza(a);Jza(a);Kza(a);Lza(a);Mza(a);Nza(a);Oza(a);Pza(a);Qza(a);Rza(a);Sza(a);Tza(a);Uza(a);Vza(a);Wza(a);Xza(a);Yza(a);Zza(a);_za(a);$za(a);aAa(a);bAa(a);cAa(a);dAa(a);eAa(a);fAa(a);gAa(a);hAa(a);iAa(a);jAa(a);kAa(a);lAa(a);mAa(a);nAa(a);oAa(a);pAa(a);qAa(a);rAa(a);sAa(a);tAa(a);uAa(a);vAa(a);wAa(a);xAa(a);yAa(a);zAa(a);AAa(a);BAa(a);CAa(a);DAa(a);EAa(a);FAa(a);GAa(a);HAa(a);IAa(a);JAa(a);KAa(a);LAa(a);MAa(a);NAa(a);OAa(a);PAa(a);QAa(a);RAa(a);SAa(a);TAa(a);UAa(a);VAa(a);WAa(a);XAa(a);YAa(a);ZAa(a);_Aa(a);$Aa(a);aBa(a);bBa(a);cBa(a);dBa(a);eBa(a);fBa(a);gBa(a);hBa(a);iBa(a);jBa(a);kBa(a);lBa(a);mBa(a);nBa(a);oBa(a);pBa(a);qBa(a);rBa(a);sBa(a);tBa(a);uBa(a);vBa(a);wBa(a);xBa(a);yBa(a);zBa(a);ABa(a);BBa(a);CBa(a);DBa(a);EBa(a);FBa(a);GBa(a);HBa(a);IBa(a);JBa(a);KBa(a);LBa(a);MBa(a);NBa(a);OBa(a);PBa(a);QBa(a);RBa(a);SBa(a);TBa(a);UBa(a);VBa(a);WBa(a);XBa(a);YBa(a);ZBa(a);_Ba(a);$Ba(a);aCa(a);bCa(a);cCa(a);dCa(a);eCa(a);fCa(a);gCa(a);hCa(a);iCa(a);jCa(a);kCa(a);lCa(a);mCa(a);nCa(a);oCa(a);pCa(a);qCa(a);rCa(a);sCa(a);tCa(a);uCa(a);vCa(a);wCa(a);xCa(a);yCa(a);zCa(a);ACa(a);BCa(a);CCa(a);DCa(a);ECa(a);FCa(a);GCa(a);HCa(a);ICa(a);JCa(a);KCa(a);LCa(a);MCa(a);NCa(a);OCa(a);PCa(a);QCa(a);RCa(a);SCa(a);TCa(a);UCa(a);VCa(a);WCa(a);XCa(a);YCa(a);ZCa(a);_Ca(a);$Ca(a);aDa(a);bDa(a);cDa(a);dDa(a);eDa(a);fDa(a);gDa(a);hDa(a);iDa(a);jDa(a);kDa(a);lDa(a);mDa(a);nDa(a);oDa(a);pDa(a);qDa(a);rDa(a);sDa(a);tDa(a);uDa(a);vDa(a);wDa(a);xDa(a);yDa(a);zDa(a);ADa(a);BDa(a);CDa(a);DDa(a);EDa(a);FDa(a);GDa(a);HDa(a);IDa(a);JDa(a);KDa(a);LDa(a);MDa(a);NDa(a);ODa(a);PDa(a);QDa(a);RDa(a);SDa(a);TDa(a);UDa(a);VDa(a);WDa(a);XDa(a);YDa(a);ZDa(a);_Da(a);$Da(a);aEa(a);bEa(a);cEa(a);dEa(a);eEa(a);fEa(a);gEa(a);hEa(a);iEa(a);jEa(a);kEa(a);lEa(a);mEa(a);nEa(a);oEa(a);pEa(a);qEa(a);rEa(a);sEa(a);tEa(a);uEa(a);vEa(a);wEa(a);xEa(a);yEa(a);zEa(a);AEa(a);BEa(a);CEa(a);DEa(a);EEa(a);FEa(a);GEa(a);HEa(a);IEa(a);JEa(a);KEa(a);LEa(a);MEa(a);NEa(a);OEa(a);PEa(a);QEa(a);REa(a);SEa(a);TEa(a);UEa(a);VEa(a);WEa(a);XEa(a);YEa(a);ZEa(a);_Ea(a);$Ea(a);aFa(a);bFa(a);cFa(a);dFa(a);eFa(a);fFa(a);gFa(a);hFa(a);iFa(a);jFa(a);kFa(a);lFa(a);mFa(a);nFa(a);oFa(a);pFa(a);qFa(a);rFa(a);sFa(a);tFa(a);uFa(a);vFa(a);wFa(a);xFa(a);yFa(a);zFa(a);AFa(a);BFa(a);CFa(a);DFa(a);EFa(a);FFa(a);GFa(a);HFa(a);IFa(a);JFa(a);KFa(a);LFa(a);MFa(a);NFa(a);OFa(a);PFa(a);QFa(a);RFa(a);SFa(a);TFa(a);UFa(a);VFa(a);WFa(a);XFa(a);YFa(a);ZFa(a);_Fa(a);$Fa(a);aGa(a);bGa(a);cGa(a);dGa(a);eGa(a);fGa(a);gGa(a);hGa(a);iGa(a);jGa(a);kGa(a);lGa(a);mGa(a);nGa(a);oGa(a);pGa(a);qGa(a);rGa(a);sGa(a);tGa(a);uGa(a);vGa(a);wGa(a);xGa(a);yGa(a);zGa(a);AGa(a);BGa(a);CGa(a);DGa(a);EGa(a);FGa(a);GGa(a);HGa(a);IGa(a);JGa(a);KGa(a);LGa(a);MGa(a);NGa(a);OGa(a);PGa(a);QGa(a);RGa(a);SGa(a);TGa(a);UGa(a);VGa(a);WGa(a);XGa(a);YGa(a);ZGa(a);_Ga(a);$Ga(a);aHa(a);bHa(a);cHa(a);dHa(a);eHa(a);fHa(a);gHa(a);hHa(a);iHa(a);jHa(a);kHa(a);lHa(a);mHa(a);nHa(a);oHa(a);pHa(a);qHa(a);rHa(a);sHa(a);tHa(a);uHa(a);vHa(a);wHa(a);xHa(a);yHa(a);zHa(a);AHa(a);BHa(a);CHa(a);DHa(a);EHa(a);FHa(a);GHa(a);HHa(a);IHa(a);JHa(a);KHa(a);LHa(a);MHa(a);NHa(a);OHa(a);PHa(a);QHa(a);RHa(a);SHa(a);THa(a);UHa(a);VHa(a);WHa(a);XHa(a);YHa(a);ZHa(a);_Ha(a);$Ha(a);aIa(a);bIa(a);cIa(a);dIa(a);eIa(a);fIa(a);gIa(a);hIa(a);iIa(a);jIa(a);kIa(a);lIa(a);mIa(a);nIa(a);oIa(a);pIa(a);qIa(a);rIa(a);sIa(a);tIa(a);uIa(a);vIa(a);wIa(a);xIa(a);yIa(a);zIa(a);AIa(a);BIa(a);CIa(a);DIa(a);EIa(a);FIa(a);GIa(a);HIa(a);IIa(a);JIa(a);KIa(a);LIa(a);MIa(a);NIa(a);OIa(a);PIa(a);QIa(a);RIa(a);SIa(a);TIa(a);UIa(a);VIa(a);WIa(a);XIa(a);YIa(a);ZIa(a);_Ia(a);$Ia(a);aJa(a);bJa(a);cJa(a);dJa(a);eJa(a);fJa(a);gJa(a);hJa(a);iJa(a);jJa(a);kJa(a);lJa(a);mJa(a);nJa(a);oJa(a);pJa(a);qJa(a);rJa(a);sJa(a);tJa(a);uJa(a);vJa(a);wJa(a);xJa(a);yJa(a);zJa(a);AJa(a);BJa(a);CJa(a);DJa(a);EJa(a);FJa(a);GJa(a);HJa(a);IJa(a);JJa(a);KJa(a);LJa(a);MJa(a);NJa(a);OJa(a);PJa(a);QJa(a);RJa(a);SJa(a);TJa(a);UJa(a);VJa(a);WJa(a);XJa(a);YJa(a);ZJa(a);_Ja(a);$Ja(a);aKa(a);bKa(a);cKa(a);dKa(a);eKa(a);fKa(a);gKa(a);hKa(a);iKa(a);jKa(a);kKa(a);lKa(a);mKa(a);nKa(a);oKa(a);pKa(a);qKa(a);rKa(a);sKa(a);tKa(a);uKa(a);vKa(a);wKa(a);xKa(a);yKa(a);zKa(a);AKa(a);BKa(a);CKa(a);DKa(a);EKa(a);FKa(a);GKa(a);HKa(a);IKa(a);JKa(a);KKa(a);LKa(a);MKa(a);NKa(a);OKa(a);PKa(a);QKa(a);RKa(a);SKa(a);TKa(a);UKa(a);VKa(a);WKa(a);XKa(a);YKa(a);ZKa(a);_Ka(a);$Ka(a);aLa(a);bLa(a);cLa(a);dLa(a);eLa(a);fLa(a);gLa(a);hLa(a);iLa(a);jLa(a);kLa(a);lLa(a);mLa(a);nLa(a);oLa(a);pLa(a);qLa(a);rLa(a);sLa(a);tLa(a);uLa(a);vLa(a);wLa(a);xLa(a);yLa(a);zLa(a);ALa(a);BLa(a);CLa(a);DLa(a);ELa(a);FLa(a);GLa(a);HLa(a);ILa(a);JLa(a);KLa(a);LLa(a);MLa(a);NLa(a);OLa(a);PLa(a);QLa(a);RLa(a);SLa(a);TLa(a);ULa(a);VLa(a);WLa(a);XLa(a);YLa(a);ZLa(a);_La(a);$La(a);aMa(a);bMa(a);cMa(a);dMa(a);eMa(a);fMa(a);gMa(a);hMa(a);iMa(a);jMa(a);kMa(a);lMa(a);mMa(a);nMa(a);oMa(a);pMa(a);qMa(a);rMa(a);sMa(a);tMa(a);uMa(a);vMa(a);wMa(a);xMa(a);yMa(a);zMa(a);AMa(a);BMa(a);CMa(a);DMa(a);EMa(a);FMa(a);GMa(a);HMa(a);IMa(a);JMa(a);KMa(a);LMa(a);MMa(a);NMa(a);OMa(a);PMa(a);QMa(a);RMa(a);SMa(a);TMa(a);UMa(a);VMa(a);WMa(a);XMa(a);YMa(a);ZMa(a);_Ma(a);$Ma(a);aNa(a);bNa(a);cNa(a);dNa(a);eNa(a);fNa(a);gNa(a);hNa(a);iNa(a);jNa(a);kNa(a);lNa(a);mNa(a);nNa(a);oNa(a);pNa(a);qNa(a);rNa(a);sNa(a);tNa(a);uNa(a);vNa(a);wNa(a);xNa(a);yNa(a);zNa(a);ANa(a);BNa(a);CNa(a);DNa(a);ENa(a);FNa(a);GNa(a);HNa(a);INa(a);JNa(a);KNa(a);LNa(a);MNa(a);NNa(a);ONa(a);PNa(a);QNa(a);RNa(a);SNa(a);TNa(a);UNa(a);VNa(a);WNa(a);XNa(a);YNa(a);ZNa(a);_Na(a);$Na(a);aOa(a);bOa(a);cOa(a);dOa(a);eOa(a);fOa(a);gOa(a);hOa(a);iOa(a);jOa(a);kOa(a);lOa(a);mOa(a);nOa(a);oOa(a);pOa(a);qOa(a);rOa(a);sOa(a);tOa(a);uOa(a);vOa(a);wOa(a);xOa(a);yOa(a);zOa(a);AOa(a);BOa(a);COa(a);DOa(a);EOa(a);FOa(a);GOa(a);HOa(a);IOa(a);JOa(a);KOa(a);LOa(a);MOa(a);NOa(a);OOa(a);POa(a);QOa(a);ROa(a);SOa(a);TOa(a);UOa(a);VOa(a);WOa(a);XOa(a);YOa(a);ZOa(a);_Oa(a);$Oa(a);aPa(a);bPa(a);cPa(a);dPa(a);ePa(a);fPa(a);gPa(a);hPa(a);iPa(a);jPa(a);kPa(a);lPa(a);mPa(a);nPa(a);oPa(a);pPa(a);qPa(a);rPa(a);sPa(a);tPa(a);uPa(a);vPa(a);wPa(a);xPa(a);yPa(a);zPa(a);APa(a);BPa(a);CPa(a);DPa(a);EPa(a);FPa(a);GPa(a);HPa(a);IPa(a);JPa(a);KPa(a);LPa(a);MPa(a);NPa(a);OPa(a);PPa(a);QPa(a);RPa(a);SPa(a);TPa(a);UPa(a);VPa(a);WPa(a);XPa(a);YPa(a);ZPa(a);_Pa(a);$Pa(a);aQa(a);bQa(a);cQa(a);dQa(a);eQa(a);fQa(a);gQa(a);hQa(a);iQa(a);jQa(a);kQa(a);lQa(a);mQa(a);nQa(a);oQa(a);pQa(a);qQa(a);rQa(a);sQa(a);tQa(a);uQa(a);vQa(a);wQa(a);xQa(a);yQa(a);zQa(a);AQa(a);BQa(a);CQa(a);DQa(a);EQa(a);FQa(a);GQa(a);HQa(a);IQa(a);JQa(a);KQa(a);LQa(a);MQa(a);NQa(a);OQa(a);PQa(a);QQa(a);RQa(a);SQa(a);TQa(a);UQa(a);VQa(a);WQa(a);XQa(a);YQa(a);ZQa(a);_Qa(a);$Qa(a);aRa(a);bRa(a);cRa(a);dRa(a);eRa(a);fRa(a);gRa(a);hRa(a);iRa(a);jRa(a);kRa(a);lRa(a);mRa(a);nRa(a);oRa(a);pRa(a);qRa(a);rRa(a);sRa(a);tRa(a);uRa(a);vRa(a);wRa(a);xRa(a);yRa(a);zRa(a);ARa(a);BRa(a);CRa(a);DRa(a);ERa(a);FRa(a);GRa(a);HRa(a);IRa(a);JRa(a);KRa(a);LRa(a);MRa(a);NRa(a);ORa(a);PRa(a);QRa(a);RRa(a);SRa(a);TRa(a);URa(a);VRa(a);WRa(a);XRa(a);YRa(a);ZRa(a);_Ra(a);$Ra(a);aSa(a);bSa(a);cSa(a);dSa(a);eSa(a);fSa(a);gSa(a);hSa(a);iSa(a);jSa(a);kSa(a);lSa(a);mSa(a);nSa(a);oSa(a);pSa(a);qSa(a);rSa(a);sSa(a);tSa(a);uSa(a);vSa(a);wSa(a);xSa(a);ySa(a);zSa(a);ASa(a);BSa(a);CSa(a);DSa(a);ESa(a);FSa(a);GSa(a);HSa(a);ISa(a);JSa(a);KSa(a);LSa(a);MSa(a);NSa(a);OSa(a);PSa(a);QSa(a);RSa(a);SSa(a);TSa(a);USa(a);VSa(a);WSa(a);XSa(a);YSa(a);ZSa(a);_Sa(a);$Sa(a);aTa(a);bTa(a);cTa(a);dTa(a);eTa(a);fTa(a);gTa(a);hTa(a);iTa(a);jTa(a);kTa(a);lTa(a);mTa(a);nTa(a);oTa(a);pTa(a);qTa(a);rTa(a);sTa(a);tTa(a);uTa(a);vTa(a);wTa(a);xTa(a);yTa(a);zTa(a);ATa(a);BTa(a);CTa(a);DTa(a);ETa(a);FTa(a);GTa(a);HTa(a);ITa(a);JTa(a);KTa(a);LTa(a);MTa(a);NTa(a);OTa(a);PTa(a);QTa(a);RTa(a);STa(a);TTa(a);UTa(a);VTa(a);WTa(a);XTa(a);YTa(a);ZTa(a);_Ta(a);$Ta(a);aUa(a);bUa(a);cUa(a);dUa(a);eUa(a);fUa(a);gUa(a);hUa(a);iUa(a);jUa(a);kUa(a);lUa(a);mUa(a);nUa(a);oUa(a);pUa(a);qUa(a);rUa(a);sUa(a);tUa(a);uUa(a);vUa(a);wUa(a);xUa(a);yUa(a);zUa(a);AUa(a);BUa(a);CUa(a);DUa(a);EUa(a);FUa(a);GUa(a);HUa(a);IUa(a);JUa(a);KUa(a);LUa(a);MUa(a);NUa(a);OUa(a);PUa(a);QUa(a);RUa(a);SUa(a);TUa(a);UUa(a);VUa(a);WUa(a);XUa(a);YUa(a);ZUa(a);_Ua(a);$Ua(a);aVa(a);bVa(a);cVa(a);dVa(a);eVa(a);fVa(a);gVa(a);hVa(a);iVa(a);jVa(a);kVa(a);lVa(a);mVa(a);nVa(a);oVa(a);pVa(a);qVa(a);rVa(a);sVa(a);tVa(a);uVa(a);vVa(a);wVa(a);xVa(a);yVa(a);zVa(a);AVa(a);BVa(a);CVa(a);DVa(a);EVa(a);FVa(a);GVa(a);HVa(a);IVa(a);JVa(a);KVa(a);LVa(a);MVa(a);NVa(a);OVa(a);PVa(a);QVa(a);RVa(a);SVa(a);TVa(a);UVa(a);VVa(a);WVa(a);XVa(a);YVa(a);ZVa(a);_Va(a);$Va(a);aWa(a);bWa(a);cWa(a);dWa(a);eWa(a);fWa(a);gWa(a);hWa(a);iWa(a);jWa(a);kWa(a);lWa(a);mWa(a);nWa(a);oWa(a);pWa(a);qWa(a);rWa(a);sWa(a);tWa(a);uWa(a);vWa(a);wWa(a);xWa(a);yWa(a);zWa(a);AWa(a);BWa(a);CWa(a);DWa(a);EWa(a);FWa(a);GWa(a);HWa(a);IWa(a);JWa(a);KWa(a);LWa(a);MWa(a);NWa(a);OWa(a);PWa(a);QWa(a);RWa(a);SWa(a);TWa(a);UWa(a);VWa(a);WWa(a);XWa(a);YWa(a);ZWa(a);_Wa(a);$Wa(a);aXa(a);bXa(a);cXa(a);dXa(a);eXa(a);fXa(a);gXa(a);hXa(a);iXa(a);jXa(a);kXa(a);lXa(a);mXa(a);nXa(a);oXa(a);pXa(a);qXa(a);rXa(a);sXa(a);tXa(a);uXa(a);vXa(a);wXa(a);xXa(a);yXa(a);zXa(a);AXa(a);BXa(a);CXa(a);DXa(a);EXa(a);FXa(a);GXa(a);HXa(a);IXa(a);JXa(a);KXa(a);LXa(a);MXa(a);NXa(a);OXa(a);PXa(a);QXa(a);RXa(a);SXa(a);TXa(a);UXa(a);VXa(a);WXa(a);XXa(a);YXa(a);ZXa(a);_Xa(a);$Xa(a);aYa(a);bYa(a);cYa(a);dYa(a);eYa(a);fYa(a);gYa(a);hYa(a);iYa(a);jYa(a);kYa(a);lYa(a);mYa(a);nYa(a);oYa(a);pYa(a);qYa(a);rYa(a);sYa(a);tYa(a);uYa(a);vYa(a);wYa(a);xYa(a);yYa(a);zYa(a);AYa(a);BYa(a);CYa(a);DYa(a);EYa(a);FYa(a);GYa(a);HYa(a);IYa(a);JYa(a);KYa(a);LYa(a);MYa(a);NYa(a);OYa(a);PYa(a);QYa(a);RYa(a);SYa(a);TYa(a);UYa(a);VYa(a);WYa(a);XYa(a);YYa(a);ZYa(a);_Ya(a);$Ya(a);aZa(a);bZa(a);cZa(a);dZa(a);eZa(a);fZa(a);gZa(a);hZa(a);iZa(a);jZa(a);kZa(a);lZa(a);mZa(a);nZa(a);oZa(a);pZa(a);qZa(a);rZa(a);sZa(a);tZa(a);uZa(a);vZa(a);wZa(a);xZa(a);yZa(a);zZa(a);AZa(a);BZa(a);CZa(a);DZa(a);EZa(a);FZa(a);GZa(a);HZa(a);IZa(a);JZa(a);KZa(a);LZa(a);MZa(a);NZa(a);OZa(a);PZa(a);QZa(a);RZa(a);SZa(a);TZa(a);UZa(a);VZa(a);WZa(a);XZa(a);YZa(a);ZZa(a);_Za(a);$Za(a);a_a(a);b_a(a);c_a(a);d_a(a);e_a(a);f_a(a);g_a(a);h_a(a);i_a(a);j_a(a);k_a(a);l_a(a);m_a(a);n_a(a);o_a(a);p_a(a);q_a(a);r_a(a);s_a(a);t_a(a);u_a(a);v_a(a);w_a(a);x_a(a);y_a(a);z_a(a);A_a(a);B_a(a);C_a(a);D_a(a);E_a(a);F_a(a);G_a(a);H_a(a);I_a(a);J_a(a);K_a(a);L_a(a);M_a(a);N_a(a);O_a(a);P_a(a);Q_a(a);R_a(a);S_a(a);T_a(a);U_a(a);V_a(a);W_a(a);X_a(a);Y_a(a);Z_a(a);__a(a);$_a(a);a$a(a);b$a(a);c$a(a);d$a(a);e$a(a);f$a(a);g$a(a);h$a(a);i$a(a);j$a(a);k$a(a);l$a(a);m$a(a);n$a(a);o$a(a);p$a(a);q$a(a);r$a(a);s$a(a);t$a(a);u$a(a);v$a(a);w$a(a);x$a(a);y$a(a);z$a(a);A$a(a);B$a(a);C$a(a);D$a(a);E$a(a);F$a(a);G$a(a);H$a(a);I$a(a);J$a(a);K$a(a);L$a(a);M$a(a);N$a(a);O$a(a);P$a(a);Q$a(a);R$a(a);S$a(a);T$a(a);U$a(a);V$a(a);W$a(a);X$a(a);Y$a(a);Z$a(a);_$a(a);$$a(a);a0a(a);b0a(a);c0a(a);d0a(a);e0a(a);f0a(a);g0a(a);h0a(a);i0a(a);j0a(a);k0a(a);l0a(a);m0a(a);n0a(a);o0a(a);p0a(a);q0a(a);r0a(a);s0a(a);t0a(a);u0a(a);v0a(a);w0a(a);x0a(a);y0a(a);z0a(a);A0a(a);B0a(a);C0a(a);D0a(a);E0a(a);F0a(a);G0a(a);H0a(a);I0a(a);J0a(a);K0a(a);L0a(a);M0a(a);N0a(a);O0a(a);P0a(a);Q0a(a);R0a(a);S0a(a);T0a(a);U0a(a);V0a(a);W0a(a);X0a(a);Y0a(a);Z0a(a);_0a(a);$0a(a);a1a(a);b1a(a);c1a(a);d1a(a);e1a(a);f1a(a);g1a(a);h1a(a);i1a(a);j1a(a);k1a(a);l1a(a);m1a(a);n1a(a);o1a(a);p1a(a);q1a(a);r1a(a);s1a(a);t1a(a);u1a(a);v1a(a);w1a(a);x1a(a);y1a(a);z1a(a);A1a(a);B1a(a);C1a(a);D1a(a);E1a(a);F1a(a);G1a(a);H1a(a);I1a(a);J1a(a);K1a(a);L1a(a);M1a(a);N1a(a);O1a(a);P1a(a);Q1a(a);R1a(a);S1a(a);T1a(a);U1a(a);V1a(a);W1a(a);X1a(a);Y1a(a);Z1a(a);_1a(a);$1a(a);a2a(a);b2a(a);c2a(a);d2a(a);e2a(a);f2a(a);g2a(a);h2a(a);i2a(a);j2a(a);k2a(a);l2a(a);m2a(a);n2a(a);o2a(a);p2a(a);q2a(a);r2a(a);s2a(a);t2a(a);u2a(a);v2a(a);w2a(a);x2a(a);y2a(a);z2a(a);A2a(a);B2a(a);C2a(a);D2a(a);E2a(a);F2a(a);G2a(a);H2a(a);I2a(a);J2a(a);K2a(a);L2a(a);M2a(a);N2a(a);O2a(a);P2a(a);Q2a(a);R2a(a);S2a(a);T2a(a);U2a(a);V2a(a);W2a(a);X2a(a);Y2a(a);Z2a(a);_2a(a);$2a(a);a3a(a);b3a(a);c3a(a);d3a(a);e3a(a);f3a(a);g3a(a);h3a(a);i3a(a);j3a(a);k3a(a);l3a(a);m3a(a);n3a(a);o3a(a);p3a(a);q3a(a);r3a(a);s3a(a);t3a(a);u3a(a);v3a(a);w3a(a);x3a(a);y3a(a);z3a(a);A3a(a);B3a(a);C3a(a);D3a(a);E3a(a);F3a(a);G3a(a);H3a(a);I3a(a);J3a(a);K3a(a);L3a(a);M3a(a);N3a(a);O3a(a);P3a(a);Q3a(a);R3a(a);S3a(a);T3a(a);U3a(a);V3a(a);W3a(a);X3a(a);Y3a(a);Z3a(a);_3a(a);$3a(a);a4a(a);b4a(a);c4a(a);d4a(a);e4a(a);f4a(a);g4a(a);h4a(a);i4a(a);j4a(a);k4a(a);l4a(a);m4a(a);n4a(a);o4a(a);p4a(a);q4a(a);r4a(a);s4a(a);t4a(a);u4a(a);v4a(a);w4a(a);x4a(a);y4a(a);z4a(a);A4a(a);B4a(a);C4a(a);D4a(a);E4a(a);F4a(a);G4a(a);H4a(a);I4a(a);J4a(a);K4a(a);L4a(a);M4a(a);N4a(a);O4a(a);P4a(a);Q4a(a);R4a(a);S4a(a);T4a(a);U4a(a);V4a(a);W4a(a);X4a(a);Y4a(a);Z4a(a);_4a(a);$4a(a);a5a(a);b5a(a);c5a(a);d5a(a);e5a(a);f5a(a);g5a(a);h5a(a);i5a(a);j5a(a);k5a(a);l5a(a);m5a(a);n5a(a);o5a(a);p5a(a);q5a(a);r5a(a);s5a(a);t5a(a);u5a(a);v5a(a);w5a(a);x5a(a);y5a(a);z5a(a);A5a(a);B5a(a);C5a(a);D5a(a);E5a(a);F5a(a);G5a(a);H5a(a);I5a(a);J5a(a);K5a(a);L5a(a);M5a(a);N5a(a);O5a(a);P5a(a);Q5a(a);R5a(a);S5a(a);T5a(a);U5a(a);V5a(a);W5a(a);X5a(a);Y5a(a);Z5a(a);_5a(a);$5a(a);a6a(a);b6a(a);c6a(a);d6a(a);e6a(a);f6a(a);g6a(a);h6a(a);i6a(a);j6a(a);k6a(a);l6a(a);m6a(a);n6a(a);o6a(a);p6a(a);q6a(a);r6a(a);s6a(a);t6a(a);u6a(a);v6a(a);w6a(a);x6a(a);y6a(a);z6a(a);A6a(a);B6a(a);C6a(a);D6a(a);E6a(a);F6a(a);G6a(a);H6a(a);I6a(a);J6a(a);K6a(a);L6a(a);M6a(a);N6a(a);O6a(a);P6a(a);Q6a(a);R6a(a);S6a(a);T6a(a);U6a(a);V6a(a);W6a(a);X6a(a);Y6a(a);Z6a(a);_6a(a);$6a(a);a7a(a);b7a(a);c7a(a);d7a(a);e7a(a);f7a(a);g7a(a);h7a(a);i7a(a);j7a(a);k7a(a);l7a(a);m7a(a);n7a(a);o7a(a);p7a(a);q7a(a);r7a(a);s7a(a);t7a(a);u7a(a);v7a(a);w7a(a);x7a(a);y7a(a);z7a(a);A7a(a);B7a(a);C7a(a);D7a(a);E7a(a);F7a(a);G7a(a);H7a(a);I7a(a);J7a(a);K7a(a);L7a(a);M7a(a);N7a(a);O7a(a);P7a(a);Q7a(a);R7a(a);S7a(a);T7a(a);U7a(a);V7a(a);W7a(a);X7a(a);Y7a(a);Z7a(a);_7a(a);$7a(a);a8a(a);b8a(a);c8a(a);d8a(a);e8a(a);f8a(a);g8a(a);h8a(a);i8a(a);j8a(a);k8a(a);l8a(a);m8a(a);n8a(a);o8a(a);p8a(a);q8a(a);r8a(a);s8a(a);t8a(a);u8a(a);v8a(a);w8a(a);x8a(a);y8a(a);z8a(a);A8a(a);B8a(a);C8a(a);D8a(a);E8a(a);F8a(a);G8a(a);H8a(a);I8a(a);J8a(a);K8a(a);L8a(a);M8a(a);N8a(a);O8a(a);P8a(a);Q8a(a);R8a(a);S8a(a);T8a(a);U8a(a);V8a(a);W8a(a);X8a(a);Y8a(a);Z8a(a);_8a(a);$8a(a);a9a(a);b9a(a);c9a(a);d9a(a);e9a(a);f9a(a);g9a(a);h9a(a);i9a(a);j9a(a);k9a(a);l9a(a);m9a(a);n9a(a);o9a(a);p9a(a);q9a(a);r9a(a);s9a(a);t9a(a);u9a(a);v9a(a);w9a(a);x9a(a);y9a(a);z9a(a);A9a(a);B9a(a);C9a(a);D9a(a);E9a(a);F9a(a);G9a(a);H9a(a);I9a(a);J9a(a);K9a(a);L9a(a);M9a(a);N9a(a);O9a(a);P9a(a);Q9a(a);R9a(a);S9a(a);T9a(a);U9a(a);V9a(a);W9a(a);X9a(a);Y9a(a);Z9a(a);_9a(a);$9a(a);aab(a);bab(a);cab(a);dab(a);eab(a);fab(a);gab(a);hab(a);iab(a);jab(a);kab(a);lab(a);mab(a);nab(a);oab(a);pab(a);qab(a);rab(a);sab(a);tab(a);uab(a);vab(a);wab(a);xab(a);yab(a);zab(a);Aab(a);Bab(a);Cab(a);Dab(a);Eab(a);Fab(a);Gab(a);Hab(a);Iab(a);Jab(a);Kab(a);Lab(a);Mab(a);Nab(a);Oab(a);Pab(a);Qab(a);Rab(a);Sab(a);Tab(a);Uab(a);Vab(a);Wab(a);Xab(a);Yab(a);Zab(a);_ab(a);$ab(a);abb(a);bbb(a);cbb(a);dbb(a);ebb(a);fbb(a);gbb(a);hbb(a);ibb(a);jbb(a);kbb(a);lbb(a);mbb(a);nbb(a);obb(a);pbb(a);qbb(a);rbb(a);sbb(a);tbb(a);ubb(a);vbb(a);wbb(a);xbb(a);ybb(a);zbb(a);Abb(a);Bbb(a);Cbb(a);Dbb(a);Ebb(a);Fbb(a);Gbb(a);Hbb(a);Ibb(a);Jbb(a);Kbb(a);Lbb(a);Mbb(a);Nbb(a);Obb(a);Pbb(a);Qbb(a);Rbb(a);Sbb(a);Tbb(a);Ubb(a);Vbb(a);Wbb(a);Xbb(a);Ybb(a);Zbb(a);_bb(a);$bb(a);acb(a);bcb(a);ccb(a);dcb(a);ecb(a);fcb(a);gcb(a);hcb(a);icb(a);jcb(a);kcb(a);lcb(a);mcb(a);ncb(a);ocb(a);pcb(a);qcb(a);rcb(a);scb(a);tcb(a);ucb(a);vcb(a);wcb(a);xcb(a);ycb(a);zcb(a);Acb(a);Bcb(a);Ccb(a);Dcb(a);Ecb(a);Fcb(a);Gcb(a);Hcb(a);Icb(a);Jcb(a);Kcb(a);Lcb(a);Mcb(a);Ncb(a);Ocb(a);Pcb(a);Qcb(a);Rcb(a);Scb(a);Tcb(a);Ucb(a);Vcb(a);Wcb(a);Xcb(a);Ycb(a);Zcb(a);_cb(a);$cb(a);adb(a);bdb(a);cdb(a);ddb(a);edb(a);fdb(a);gdb(a);hdb(a);idb(a);jdb(a);kdb(a);ldb(a);mdb(a);ndb(a);odb(a);pdb(a);qdb(a);rdb(a);sdb(a);tdb(a);udb(a);vdb(a);wdb(a);xdb(a);ydb(a);zdb(a);Adb(a);Bdb(a);Cdb(a);Ddb(a);Edb(a);Fdb(a);Gdb(a);Hdb(a);Idb(a);Jdb(a);Kdb(a);Ldb(a);Mdb(a);Ndb(a);Odb(a);Pdb(a);Qdb(a);Rdb(a);Sdb(a);Tdb(a);Udb(a);Vdb(a);Wdb(a);Xdb(a);Ydb(a);Zdb(a);_db(a);$db(a);aeb(a);beb(a);ceb(a);deb(a);eeb(a);feb(a);geb(a);heb(a);ieb(a);jeb(a);keb(a);leb(a);meb(a);neb(a);oeb(a);peb(a);qeb(a);reb(a);seb(a);teb(a);ueb(a);veb(a);web(a);xeb(a);yeb(a);zeb(a);Aeb(a);Beb(a);Ceb(a);Deb(a);Eeb(a);Feb(a);Geb(a);Heb(a);Ieb(a);Jeb(a);Keb(a);Leb(a);Meb(a);Neb(a);Oeb(a);Peb(a);Qeb(a);Reb(a);Seb(a);Teb(a);Ueb(a);Veb(a);Web(a);Xeb(a);Yeb(a);Zeb(a);_eb(a);$eb(a);afb(a);bfb(a);cfb(a);dfb(a);efb(a);ffb(a);gfb(a);hfb(a);ifb(a);jfb(a);kfb(a);lfb(a);mfb(a);nfb(a);ofb(a);pfb(a);qfb(a);rfb(a);sfb(a);tfb(a);ufb(a);vfb(a);wfb(a);xfb(a);yfb(a);zfb(a);Afb(a);Bfb(a);Cfb(a);Dfb(a);Efb(a);Ffb(a);Gfb(a);Hfb(a);Ifb(a);Jfb(a);Kfb(a);Lfb(a);Mfb(a);Nfb(a);Ofb(a);Pfb(a);Qfb(a);Rfb(a);Sfb(a);Tfb(a);Ufb(a);Vfb(a);Wfb(a);Xfb(a);Yfb(a);Zfb(a);_fb(a);$fb(a);agb(a);bgb(a);cgb(a);dgb(a);egb(a);fgb(a);ggb(a);hgb(a);igb(a);jgb(a);kgb(a);lgb(a);mgb(a);ngb(a);ogb(a);pgb(a);qgb(a);rgb(a);sgb(a);tgb(a);ugb(a);vgb(a);wgb(a);xgb(a);ygb(a);zgb(a);Agb(a);Bgb(a);Cgb(a);Dgb(a);Egb(a);Fgb(a);Ggb(a);Hgb(a);Igb(a);Jgb(a);Kgb(a);Lgb(a);Mgb(a);Ngb(a);Ogb(a);Pgb(a);Qgb(a);Rgb(a);Sgb(a);Tgb(a);Ugb(a);Vgb(a);Wgb(a);Xgb(a);Ygb(a);Zgb(a);_gb(a);$gb(a);ahb(a);bhb(a);chb(a);dhb(a);ehb(a);fhb(a);ghb(a);hhb(a);ihb(a);jhb(a);khb(a);lhb(a);mhb(a);nhb(a);ohb(a);phb(a);qhb(a);rhb(a);shb(a);thb(a);uhb(a);vhb(a);whb(a);xhb(a);yhb(a);zhb(a);Ahb(a);Bhb(a);Chb(a);Dhb(a);Ehb(a);Fhb(a);Ghb(a);Hhb(a);Ihb(a);Jhb(a);Khb(a);Lhb(a);Mhb(a);Nhb(a);Ohb(a);Phb(a);Qhb(a);Rhb(a);Shb(a);Thb(a);Uhb(a);Vhb(a);Whb(a);Xhb(a);Yhb(a);Zhb(a);_hb(a);$hb(a);aib(a);bib(a);cib(a);dib(a);eib(a);fib(a);gib(a);hib(a);iib(a);jib(a);kib(a);lib(a);mib(a);nib(a);oib(a);pib(a);qib(a);rib(a);sib(a);tib(a);uib(a);vib(a);wib(a);xib(a);yib(a);zib(a);Aib(a);Bib(a);Cib(a);Dib(a);Eib(a);Fib(a);Gib(a);Hib(a);Iib(a);Jib(a);Kib(a);Lib(a);Mib(a);Nib(a);Oib(a);Pib(a);Qib(a);Rib(a);Sib(a);Tib(a);Uib(a);Vib(a);Wib(a);Xib(a);Yib(a);Zib(a);_ib(a);$ib(a);ajb(a);bjb(a);cjb(a);djb(a);ejb(a);fjb(a);gjb(a);hjb(a);ijb(a);jjb(a);kjb(a);ljb(a);mjb(a);njb(a);ojb(a);pjb(a);qjb(a);rjb(a);sjb(a);tjb(a);ujb(a);vjb(a);wjb(a);xjb(a);yjb(a);zjb(a);Ajb(a);Bjb(a);Cjb(a);Djb(a);Ejb(a);Fjb(a);Gjb(a);Hjb(a);Ijb(a);Jjb(a);Kjb(a);Ljb(a);Mjb(a);Njb(a);Ojb(a);Pjb(a);Qjb(a);Rjb(a);Sjb(a);Tjb(a);Ujb(a);Vjb(a);Wjb(a);Xjb(a);Yjb(a);Zjb(a);_jb(a);$jb(a);akb(a);bkb(a);ckb(a);dkb(a);ekb(a);fkb(a);gkb(a);hkb(a);ikb(a);jkb(a);kkb(a);lkb(a);mkb(a);nkb(a);okb(a);pkb(a);qkb(a);rkb(a);skb(a);tkb(a);ukb(a);vkb(a);wkb(a);xkb(a);ykb(a);zkb(a);Akb(a);Bkb(a);Ckb(a);Dkb(a);Ekb(a);Fkb(a);Gkb(a);Hkb(a);Ikb(a);Jkb(a);Kkb(a);Lkb(a);Mkb(a);Nkb(a);Okb(a);Pkb(a);Qkb(a);Rkb(a);Skb(a);Tkb(a);Ukb(a);Vkb(a);Wkb(a);Xkb(a);Ykb(a);Zkb(a);_kb(a);$kb(a);alb(a);blb(a);clb(a);dlb(a);elb(a);flb(a);glb(a);hlb(a);ilb(a);jlb(a);klb(a);llb(a);mlb(a);nlb(a);olb(a);plb(a);qlb(a);rlb(a);slb(a);tlb(a);ulb(a);vlb(a);wlb(a);xlb(a);ylb(a);zlb(a);Alb(a);Blb(a);Clb(a);Dlb(a);Elb(a);Flb(a);Glb(a);Hlb(a);Ilb(a);Jlb(a);Klb(a);Llb(a);Mlb(a);Nlb(a);Olb(a);Plb(a);Qlb(a);Rlb(a);Slb(a);Tlb(a);Ulb(a);Vlb(a);Wlb(a);Xlb(a);Ylb(a);Zlb(a);_lb(a);$lb(a);amb(a);bmb(a);cmb(a);dmb(a);emb(a);fmb(a);gmb(a);hmb(a);imb(a);jmb(a);kmb(a);lmb(a);mmb(a);nmb(a);omb(a);pmb(a);qmb(a);rmb(a);smb(a);tmb(a);umb(a);vmb(a);wmb(a);xmb(a);ymb(a);zmb(a);Amb(a);Bmb(a);Cmb(a);Dmb(a);Emb(a);Fmb(a);Gmb(a);Hmb(a);Imb(a);Jmb(a);Kmb(a);Lmb(a);Mmb(a);Nmb(a);Omb(a);Pmb(a);Qmb(a);Rmb(a);Smb(a);Tmb(a);Umb(a);Vmb(a);Wmb(a);Xmb(a);Ymb(a);Zmb(a);_mb(a);$mb(a);anb(a);bnb(a);cnb(a);dnb(a);enb(a);fnb(a);gnb(a);hnb(a);inb(a);jnb(a);knb(a);lnb(a);mnb(a);nnb(a);onb(a);pnb(a);qnb(a);rnb(a);snb(a);tnb(a);unb(a);vnb(a);wnb(a);xnb(a);ynb(a);znb(a);Anb(a);Bnb(a);Cnb(a);Dnb(a);Enb(a);Fnb(a);Gnb(a);Hnb(a);Inb(a);Jnb(a);Knb(a);Lnb(a);Mnb(a);Nnb(a);Onb(a);Pnb(a);Qnb(a);Rnb(a);Snb(a);Tnb(a);Unb(a);Vnb(a);Wnb(a);Xnb(a);Ynb(a);Znb(a);_nb(a);$nb(a);aob(a);bob(a);cob(a);dob(a);eob(a);fob(a);gob(a);hob(a);iob(a);job(a);kob(a);lob(a);mob(a);nob(a);oob(a);pob(a);qob(a);rob(a);sob(a);tob(a);uob(a);vob(a);wob(a);xob(a);yob(a);zob(a);Aob(a);Bob(a);Cob(a);Dob(a);Eob(a);Fob(a);Gob(a);Hob(a);Iob(a);Job(a);Kob(a);Lob(a);Mob(a);Nob(a);Oob(a);Pob(a);Qob(a);Rob(a);Sob(a);Tob(a);Uob(a);Vob(a);Wob(a);Xob(a);Yob(a);Zob(a);_ob(a);$ob(a);apb(a);bpb(a);cpb(a);dpb(a);epb(a);fpb(a);gpb(a);hpb(a);ipb(a);jpb(a);kpb(a);lpb(a);mpb(a);npb(a);opb(a);ppb(a);qpb(a);rpb(a);spb(a);tpb(a);upb(a);vpb(a);wpb(a);xpb(a);ypb(a);zpb(a);Apb(a);Bpb(a);Cpb(a);Dpb(a);Epb(a);Fpb(a);Gpb(a);Hpb(a);Ipb(a);Jpb(a);Kpb(a);Lpb(a);Mpb(a);Npb(a);Opb(a);Ppb(a);Qpb(a);Rpb(a);Spb(a);Tpb(a);Upb(a);Vpb(a);Wpb(a);Xpb(a);Ypb(a);Zpb(a);_pb(a);$pb(a);aqb(a);bqb(a);cqb(a);dqb(a);eqb(a);fqb(a);gqb(a);hqb(a);iqb(a);jqb(a);kqb(a);lqb(a);mqb(a);nqb(a);oqb(a);pqb(a);qqb(a);rqb(a);sqb(a);tqb(a);uqb(a);vqb(a);wqb(a);xqb(a);yqb(a);zqb(a);Aqb(a);Bqb(a);Cqb(a);Dqb(a);Eqb(a);Fqb(a);Gqb(a);Hqb(a);Iqb(a);Jqb(a);Kqb(a);Lqb(a);Mqb(a);Nqb(a);Oqb(a);Pqb(a);Qqb(a);Rqb(a);Sqb(a);Tqb(a);Uqb(a);Vqb(a);Wqb(a);Xqb(a);Yqb(a);Zqb(a);_qb(a);$qb(a);arb(a);brb(a);crb(a);drb(a);erb(a);frb(a);grb(a);hrb(a);irb(a);jrb(a);krb(a);lrb(a);mrb(a);nrb(a);orb(a);prb(a);qrb(a);rrb(a);srb(a);trb(a);urb(a);vrb(a);wrb(a);xrb(a);yrb(a);zrb(a);Arb(a);Brb(a);Crb(a);Drb(a);Erb(a);Frb(a);Grb(a);Hrb(a);Irb(a);Jrb(a);Krb(a);Lrb(a);Mrb(a);Nrb(a);Orb(a);Prb(a);Qrb(a);Rrb(a);Srb(a);Trb(a);Urb(a);Vrb(a);Wrb(a);Xrb(a);Yrb(a);Zrb(a);_rb(a);$rb(a);asb(a);bsb(a);csb(a);dsb(a);esb(a);fsb(a);gsb(a);hsb(a);isb(a);jsb(a);ksb(a);lsb(a);msb(a);nsb(a);osb(a);psb(a);qsb(a);rsb(a);ssb(a);tsb(a);usb(a);vsb(a);wsb(a);xsb(a);ysb(a);zsb(a);Asb(a);Bsb(a);Csb(a);Dsb(a);Esb(a);Fsb(a);Gsb(a);Hsb(a);Isb(a);Jsb(a);Ksb(a);Lsb(a);Msb(a);Nsb(a);Osb(a);Psb(a);Qsb(a);Rsb(a);Ssb(a);Tsb(a);Usb(a);Vsb(a);Wsb(a);Xsb(a);Ysb(a);Zsb(a);_sb(a);$sb(a);atb(a);btb(a);ctb(a);dtb(a);etb(a);ftb(a);gtb(a);htb(a);itb(a);jtb(a);ktb(a);ltb(a);mtb(a);ntb(a);otb(a);ptb(a);qtb(a);rtb(a);stb(a);ttb(a);utb(a);vtb(a);wtb(a);xtb(a);ytb(a);ztb(a);Atb(a);Btb(a);Ctb(a);Dtb(a);Etb(a);Ftb(a);Gtb(a);Htb(a);Itb(a);Jtb(a);Ktb(a);Ltb(a);Mtb(a);Ntb(a);Otb(a);Ptb(a);Qtb(a);Rtb(a);Stb(a);Ttb(a);Utb(a);Vtb(a);Wtb(a);Xtb(a);Ytb(a);Ztb(a);_tb(a);$tb(a);aub(a);bub(a);cub(a);dub(a);eub(a);fub(a);gub(a);hub(a);iub(a);jub(a);kub(a);lub(a);mub(a);nub(a);oub(a);pub(a);qub(a);rub(a);sub(a);tub(a);uub(a);vub(a);wub(a);xub(a);yub(a);zub(a);Aub(a);Bub(a);Cub(a);Dub(a);Eub(a);Fub(a);Gub(a);Hub(a);Iub(a);Jub(a);Kub(a);Lub(a);Mub(a);Nub(a);Oub(a);Pub(a);Qub(a);Rub(a);Sub(a);Tub(a);Uub(a);Vub(a);Wub(a);Xub(a);Yub(a);Zub(a);_ub(a);$ub(a);avb(a);bvb(a);cvb(a);dvb(a);evb(a);fvb(a);gvb(a);hvb(a);ivb(a);jvb(a);kvb(a);lvb(a);mvb(a);nvb(a);ovb(a);pvb(a);qvb(a);rvb(a);svb(a);tvb(a);uvb(a);vvb(a);wvb(a);xvb(a);yvb(a);zvb(a);Avb(a);Bvb(a);Cvb(a);Dvb(a);Evb(a);Fvb(a);Gvb(a);Hvb(a);Ivb(a);Jvb(a);Kvb(a);Lvb(a);Mvb(a);Nvb(a);Ovb(a);Pvb(a);Qvb(a);Rvb(a);Svb(a);Tvb(a);Uvb(a);Vvb(a);Wvb(a);Xvb(a);Yvb(a);Zvb(a);_vb(a);$vb(a);awb(a);bwb(a);cwb(a);dwb(a);ewb(a);fwb(a);gwb(a);hwb(a);iwb(a);jwb(a);kwb(a);lwb(a);mwb(a);nwb(a);owb(a);pwb(a);qwb(a);rwb(a);swb(a);twb(a);uwb(a);vwb(a);wwb(a);xwb(a);ywb(a);zwb(a);Awb(a);Bwb(a);Cwb(a);Dwb(a);Ewb(a);Fwb(a);Gwb(a);Hwb(a);Iwb(a);Jwb(a);Kwb(a);Lwb(a);Mwb(a);Nwb(a);Owb(a);Pwb(a);Qwb(a);Rwb(a);Swb(a);Twb(a);Uwb(a);Vwb(a);Wwb(a);Xwb(a);Ywb(a);Zwb(a);_wb(a);$wb(a);axb(a);bxb(a);cxb(a);dxb(a);exb(a);fxb(a);gxb(a);hxb(a);ixb(a);jxb(a);kxb(a);lxb(a);mxb(a);nxb(a);oxb(a);pxb(a);qxb(a);rxb(a);sxb(a);txb(a);uxb(a);vxb(a);wxb(a);xxb(a);yxb(a);zxb(a);Axb(a);Bxb(a);Cxb(a);Dxb(a);Exb(a);Fxb(a);Gxb(a);Hxb(a);Ixb(a);Jxb(a);Kxb(a);Lxb(a);Mxb(a);Nxb(a);Oxb(a);Pxb(a);Qxb(a);Rxb(a);Sxb(a);Txb(a);Uxb(a);Vxb(a);Wxb(a);Xxb(a);Yxb(a);Zxb(a);_xb(a);$xb(a);ayb(a);byb(a);cyb(a);dyb(a);eyb(a);fyb(a);gyb(a);hyb(a);iyb(a);jyb(a);kyb(a);lyb(a);myb(a);nyb(a);oyb(a);pyb(a);qyb(a);ryb(a);syb(a);tyb(a);uyb(a);vyb(a);wyb(a);xyb(a);yyb(a);zyb(a);Ayb(a);Byb(a);Cyb(a);Dyb(a);Eyb(a);Fyb(a);Gyb(a);Hyb(a);Iyb(a);Jyb(a);Kyb(a);Lyb(a);Myb(a);Nyb(a);Oyb(a);Pyb(a);Qyb(a);Ryb(a);Syb(a);Tyb(a);Uyb(a);Vyb(a);Wyb(a);Xyb(a);Yyb(a);Zyb(a);_yb(a);$yb(a);azb(a);bzb(a);czb(a);dzb(a);ezb(a);fzb(a);gzb(a);hzb(a);izb(a);jzb(a);kzb(a);lzb(a);mzb(a);nzb(a);ozb(a);pzb(a);qzb(a);rzb(a);szb(a);tzb(a);uzb(a);vzb(a);wzb(a);xzb(a);yzb(a);zzb(a);Azb(a);Bzb(a);Czb(a);Dzb(a);Ezb(a);Fzb(a);Gzb(a);Hzb(a);Izb(a);Jzb(a);Kzb(a);Lzb(a);Mzb(a);Nzb(a);Ozb(a);Pzb(a);Qzb(a);Rzb(a);Szb(a);Tzb(a);Uzb(a);Vzb(a);Wzb(a);Xzb(a);Yzb(a);Zzb(a);_zb(a);$zb(a);aAb(a);bAb(a);cAb(a);dAb(a);eAb(a);fAb(a);gAb(a);hAb(a);iAb(a);jAb(a);kAb(a);lAb(a);mAb(a);nAb(a);oAb(a);pAb(a);qAb(a);rAb(a);sAb(a);tAb(a);uAb(a);vAb(a);wAb(a);xAb(a);yAb(a);zAb(a);AAb(a);BAb(a);CAb(a);DAb(a);EAb(a);FAb(a);GAb(a);HAb(a);IAb(a);JAb(a);KAb(a);LAb(a);MAb(a);NAb(a);OAb(a);PAb(a);QAb(a);RAb(a);SAb(a);TAb(a);UAb(a);VAb(a);WAb(a);XAb(a);YAb(a);ZAb(a);_Ab(a);$Ab(a);aBb(a);bBb(a);cBb(a);dBb(a);eBb(a);fBb(a);gBb(a);hBb(a);iBb(a);jBb(a);kBb(a);lBb(a);mBb(a);nBb(a);oBb(a);pBb(a);qBb(a);rBb(a);sBb(a);tBb(a);uBb(a);vBb(a);wBb(a);xBb(a);yBb(a);zBb(a);ABb(a);BBb(a);CBb(a);DBb(a);EBb(a);FBb(a);GBb(a);HBb(a);IBb(a);JBb(a);KBb(a);LBb(a);MBb(a);NBb(a);OBb(a);PBb(a);QBb(a);RBb(a);SBb(a);TBb(a);UBb(a);VBb(a);WBb(a);XBb(a);YBb(a);ZBb(a);_Bb(a);$Bb(a);aCb(a);bCb(a);cCb(a);dCb(a);eCb(a);fCb(a);gCb(a);hCb(a);iCb(a);jCb(a);kCb(a);lCb(a);mCb(a);nCb(a);oCb(a);pCb(a);qCb(a);rCb(a);sCb(a);tCb(a);uCb(a);vCb(a);wCb(a);xCb(a);yCb(a);zCb(a);ACb(a);BCb(a);CCb(a);DCb(a);ECb(a);FCb(a);GCb(a);HCb(a);ICb(a);JCb(a);KCb(a);LCb(a);MCb(a);NCb(a);OCb(a);PCb(a);QCb(a);RCb(a);SCb(a);TCb(a);UCb(a);VCb(a);WCb(a);XCb(a);YCb(a);ZCb(a);_Cb(a);$Cb(a);aDb(a);bDb(a);cDb(a);dDb(a);eDb(a);fDb(a);gDb(a);hDb(a);iDb(a);jDb(a);kDb(a);lDb(a);mDb(a);nDb(a);oDb(a);pDb(a);qDb(a);rDb(a);sDb(a);tDb(a);uDb(a);vDb(a);wDb(a);xDb(a);yDb(a);zDb(a);ADb(a);BDb(a);CDb(a);DDb(a);EDb(a);FDb(a);GDb(a);HDb(a);IDb(a);JDb(a);KDb(a);LDb(a);MDb(a);NDb(a);ODb(a);PDb(a);QDb(a);RDb(a);SDb(a);TDb(a);UDb(a);VDb(a);WDb(a);XDb(a);YDb(a);ZDb(a);_Db(a);$Db(a);aEb(a);bEb(a);cEb(a);dEb(a);eEb(a);fEb(a);gEb(a);hEb(a);iEb(a);jEb(a);kEb(a);lEb(a);mEb(a);nEb(a);oEb(a);pEb(a);qEb(a);rEb(a);sEb(a);tEb(a);uEb(a);vEb(a);wEb(a);xEb(a);yEb(a);zEb(a);AEb(a);BEb(a);CEb(a);DEb(a);EEb(a);FEb(a);GEb(a);HEb(a);IEb(a);JEb(a);KEb(a);LEb(a);MEb(a);NEb(a);OEb(a);PEb(a);QEb(a);REb(a);SEb(a);TEb(a);UEb(a);VEb(a);WEb(a);XEb(a);YEb(a);ZEb(a);_Eb(a);$Eb(a);aFb(a);bFb(a);cFb(a);dFb(a);eFb(a);fFb(a);gFb(a);hFb(a);iFb(a);jFb(a);kFb(a);lFb(a);mFb(a);nFb(a);oFb(a);pFb(a);qFb(a);rFb(a);sFb(a);tFb(a);uFb(a);vFb(a);wFb(a);xFb(a);yFb(a);zFb(a);AFb(a);BFb(a);CFb(a);DFb(a);EFb(a);FFb(a);GFb(a);HFb(a);IFb(a);JFb(a);KFb(a);LFb(a);MFb(a);NFb(a);OFb(a);PFb(a);QFb(a);RFb(a);SFb(a);TFb(a);i=b;return 0}function VFb(b){b=b|0;var c=0;c=i;a[b+314|0]=0;WFb(b);i=c;return 0}function WFb(a){a=a|0;var b=0;b=i;_e(a);$e(a);af(a);bf(a);cf(a);df(a);ef(a);ff(a);gf(a);hf(a);jf(a);kf(a);lf(a);mf(a);nf(a);of(a);pf(a);qf(a);rf(a);sf(a);tf(a);uf(a);vf(a);wf(a);xf(a);yf(a);zf(a);Af(a);Bf(a);Ff(a);Jg(a);th(a);xh(a);Ah(a);Bh(a);Ch(a);Ph(a);ci(a);ei(a);qi(a);Bi(a);Zi(a);bj(a);ej(a);fj(a);gj(a);tj(a);Ij(a);Kj(a);Wj(a);fk(a);Dk(a);Hk(a);Kk(a);Lk(a);Mk(a);Zk(a);ml(a);ol(a);Al(a);Ll(a);hm(a);lm(a);om(a);pm(a);qm(a);Dm(a);Sm(a);Um(a);en(a);qn(a);On(a);Sn(a);Vn(a);Wn(a);Xn(a);jo(a);yo(a);Ao(a);Mo(a);Xo(a);sp(a);wp(a);zp(a);Ap(a);Bp(a);Op(a);bq(a);dq(a);pq(a);Aq(a);Bq(a);Dq(a);Eq(a);Fq(a);Gq(a);Hq(a);Iq(a);Jq(a);Kq(a);Lq(a);Mq(a);Nq(a);Oq(a);Pq(a);Qq(a);Rq(a);Sq(a);Tq(a);Uq(a);Vq(a);Wq(a);Xq(a);Yq(a);Zq(a);_q(a);$q(a);ar(a);br(a);cr(a);dr(a);er(a);fr(a);gr(a);hr(a);ir(a);jr(a);kr(a);lr(a);mr(a);nr(a);or(a);pr(a);qr(a);rr(a);sr(a);tr(a);ur(a);vr(a);wr(a);xr(a);yr(a);zr(a);Ar(a);Br(a);Cr(a);Dr(a);Er(a);Fr(a);Gr(a);Hr(a);Ir(a);Jr(a);Kr(a);Lr(a);Mr(a);Nr(a);Or(a);Pr(a);Qr(a);Rr(a);Sr(a);Tr(a);Ur(a);Vr(a);Wr(a);Xr(a);Yr(a);Zr(a);_r(a);$r(a);as(a);bs(a);cs(a);ds(a);es(a);fs(a);gs(a);hs(a);is(a);js(a);ks(a);ns(a);os(a);ps(a);qs(a);rs(a);ss(a);ts(a);us(a);vs(a);ws(a);xs(a);ys(a);zs(a);As(a);Bs(a);Cs(a);Ds(a);Es(a);Fs(a);Gs(a);Hs(a);Is(a);Js(a);Ks(a);Ls(a);Ms(a);Ns(a);Os(a);Ps(a);Qs(a);Rs(a);Ss(a);Ts(a);Us(a);Vs(a);Ws(a);Xs(a);Ys(a);Zs(a);_s(a);$s(a);at(a);bt(a);ct(a);dt(a);et(a);ft(a);gt(a);ht(a);it(a);jt(a);kt(a);lt(a);mt(a);nt(a);ot(a);pt(a);qt(a);rt(a);st(a);tt(a);ut(a);vt(a);wt(a);xt(a);yt(a);zt(a);At(a);Bt(a);Ct(a);Dt(a);Et(a);Ft(a);Gt(a);Ht(a);It(a);Jt(a);Kt(a);Lt(a);Mt(a);Nt(a);Ot(a);Pt(a);Qt(a);Rt(a);St(a);Tt(a);Ut(a);Vt(a);Wt(a);Xt(a);Yt(a);Zt(a);_t(a);$t(a);au(a);bu(a);cu(a);du(a);eu(a);fu(a);gu(a);hu(a);iu(a);ju(a);ku(a);lu(a);mu(a);nu(a);ou(a);pu(a);qu(a);ru(a);su(a);tu(a);uu(a);vu(a);wu(a);xu(a);yu(a);zu(a);Au(a);Bu(a);Cu(a);Du(a);Eu(a);Fu(a);Gu(a);Hu(a);Iu(a);Ju(a);Ku(a);Lu(a);Mu(a);Nu(a);Ou(a);Pu(a);Qu(a);Ru(a);Su(a);Tu(a);Uu(a);i=b;return}function XFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219728]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+20360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(219744,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+20360>>3],219736)|0)|0;g=c[69978]|0;j=e;k=221208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[219728]=1;i=d;return}function YFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219968]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+20336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(219976,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+20336>>3],219736)|0)|0;g=c[69978]|0;j=e;k=221352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[219968]=1;i=d;return}function ZFb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220088]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+20200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(220096,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+20200>>3],219736)|0)|0;g=c[69978]|0;j=e;k=221208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[220088]=1;i=d;return}function _Fb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220216]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+20176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(220224,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+20176>>3],219736)|0)|0;g=c[69978]|0;j=e;k=221352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[220216]=1;i=d;return}function $Fb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220336]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+20040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(220344,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+20040>>3],219736)|0)|0;g=c[69978]|0;j=e;k=221208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[220336]=1;i=d;return}function aGb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220464]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+20016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(220472,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+20016>>3],219736)|0)|0;g=c[69978]|0;j=e;k=221352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[220464]=1;i=d;return}function bGb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220584]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+19880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(220592,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+19880>>3],219736)|0)|0;g=c[69978]|0;j=e;k=221208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[220584]=1;i=d;return}function cGb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220712]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+19856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(220720,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+19856>>3],219736)|0)|0;g=c[69978]|0;j=e;k=221352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[220712]=1;i=d;return}function dGb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220832]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+19720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(220840,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+19720>>3],219736)|0)|0;g=c[69978]|0;j=e;k=221208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[220832]=1;i=d;return}function eGb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220960]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+19696>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(220968,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+19696>>3],219736)|0)|0;g=c[69978]|0;j=e;k=221352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[220960]=1;i=d;return}function fGb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221080]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+19560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(221088,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+19560>>3],219736)|0)|0;g=c[69978]|0;j=e;k=221208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[221080]=1;i=d;return}function gGb(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221232]&1){i=d;return}g=b+4|0;if(!((aPb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+19536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=xMb(221240,tMb(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+19536>>3],219736)|0)|0;g=c[69978]|0;j=e;k=221352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ae[g&15](e,b,f);a[221232]=1;i=d;return}function hGb(a){a=a|0;var b=0;b=i;XFb(a);YFb(a);ZFb(a);_Fb(a);$Fb(a);aGb(a);bGb(a);cGb(a);dGb(a);eGb(a);fGb(a);gGb(a);i=b;return 0}function iGb(a){a=a|0;i=i;return 1}function jGb(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=4;c[a+48>>2]=4;c[a+72>>2]=cec(4,8)|0;a=cec(4,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=cec(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=aec(16)|0;c[(c[d>>2]|0)+52>>2]=a;a=aec(32)|0;c[(c[d>>2]|0)+56>>2]=a;a=aec(16)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=3;c[a+84>>2]=0;a=c[d>>2]|0;e=c[a+52>>2]|0;c[e>>2]=2;c[e+4>>2]=3;c[e+8>>2]=6;c[e+12>>2]=8;kGb(e,c[a+56>>2]|0);a=c[d>>2]|0;lGb(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;mGb(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;nGb(c[(c[a+52>>2]|0)+4>>2]|0,c[a+56>>2]|0);a=c[(c[d>>2]|0)+64>>2]|0;c[a+12>>2]=1;c[a+4>>2]=1;c[a+8>>2]=2;c[a>>2]=3;i=b;return 0}function kGb(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[b+((c[d>>2]|0)+ -2<<2)>>2]=0;c[b+((c[d>>2]|0)+ -1<<2)>>2]=2;i=i;return}function lGb(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=0;c[b+((c[d>>2]|0)+ -2<<2)>>2]=2;c[b+((c[d>>2]|0)+ -1<<2)>>2]=3;i=i;return}function mGb(a,b){a=a|0;b=b|0;c[b+((c[a>>2]|0)+ -2<<2)>>2]=1;c[b+((c[a>>2]|0)+ -1<<2)>>2]=0;i=i;return}function nGb(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=1;i=i;return}function oGb(a){a=a|0;i=i;return 1}function pGb(a){a=a|0;i=i;return 1}function qGb(a){a=a|0;i=i;return 1}function rGb(a){a=a|0;i=i;return 0}function sGb(a){a=a|0;i=i;return 0}function tGb(a){a=a|0;i=i;return 0}function uGb(a){a=a|0;i=i;return 0}function vGb(a){a=a|0;i=i;return 0}function wGb(a,b){a=a|0;b=b|0;i=i;return-1}function xGb(a,b){a=a|0;b=b|0;i=i;return-1}function yGb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function zGb(){i=i;return 221376}function AGb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function BGb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function CGb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function DGb(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);yb(222216,n|0)|0;i=m;return 0}function EGb(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=XNb(a,222224)|0;z=XNb(b,222224)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((XNb(a,222232)|0)!=0){C=5;break}if((XNb(a,222240)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((XNb(b,222232)|0)!=0){break}if((XNb(b,222240)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){Iec(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}Iec(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}Iec(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);yb(222248,r|0)|0;i=q;return 0}function FGb(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(XNb(a,222256)|0)!=0;v=c[(u?f:g)>>2]|0;w=XNb(e,222264)|0;x=XNb(b,222272)|0;c[p>>2]=0;do{if(u){y=4}else{if((XNb(a,222280)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((XNb(b,222256)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((XNb(d,222264)|0)==0){if((XNb(d,222288)|0)!=0){break}if((XNb(d,222296)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((XNb(e,222272)|0)==0){if((XNb(e,222264)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){Iec(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(XNb(d,222264)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);yb(222304,p|0)|0;i=o;return 0}function GGb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}IGb(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}JGb(222320,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;yb(222312,l|0)|0;i=k;return 0}function HGb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+INb(222344);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(AGb(l,z,222352)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){CGb(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;BGb(l,n,d+(x-o+v<<3)|0,222352)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;DGb(l,m,222360,d+(B+y<<3)|0,222352,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;yb(222336,k|0)|0;i=j;return 0}function IGb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=222392;u=LGb(222376,222368,222384,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;HGb(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;KGb(k,d,e,m,l,f,222376)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;KGb(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,222376)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;FGb(222400,222408,222416,222432,n,k,222440,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=222416;EGb(H,H,k,l,n,222448,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,222440,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);HGb(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;yb(222368,j|0)|0;i=h;return 0}function JGb(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(XNb(a,222456)|0)!=0;do{if(n){o=5}else{if((XNb(a,222464)|0)!=0){o=5;break}if((XNb(a,222472)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=222488;KGb(d,h,j,q,b,g,q)|0;FGb(222496,222504,222512,222528,b,d,222536,e,f,h,j)|0;FGb(222496,222544,222512,222552,b,d,222536,e,f,h,j)|0;i=l;return 0}else{FGb(222496,222544,222568,222552,b,d,222536,e,f,h,j)|0;FGb(222496,222504,222568,222528,b,d,222536,e,f,h,j)|0;KGb(d,h,j,222488,b,g,222584)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;yb(222480,m|0)|0;i=l;return 0}function KGb(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}



function uva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7056>>3]=0.0;i=i;return}function vva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7072>>3]=0.0;i=i;return}function wva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7048>>3]=0.0;i=i;return}function xva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7064>>3]=0.0;i=i;return}function yva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7040>>3]=0.0;i=i;return}function zva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7032>>3]=0.0;i=i;return}function Ava(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7024>>3]=0.0;i=i;return}function Bva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7e3>>3]=0.0;i=i;return}function Cva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6928>>3]=0.0;i=i;return}function Dva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6904>>3]=0.0;i=i;return}function Eva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6896>>3]=0.0;i=i;return}function Fva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6872>>3]=0.0;i=i;return}function Gva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6864>>3]=0.0;i=i;return}function Hva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6856>>3]=0.0;i=i;return}function Iva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6888>>3]=0.0;i=i;return}function Jva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6816>>3]=0.0;i=i;return}function Kva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6808>>3]=0.0;i=i;return}function Lva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6848>>3]=0.0;i=i;return}function Mva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6784>>3]=0.0;i=i;return}function Nva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6880>>3]=0.0;i=i;return}function Ova(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6840>>3]=0.0;i=i;return}function Pva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6776>>3]=0.0;i=i;return}function Qva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6752>>3]=0.0;i=i;return}function Rva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6728>>3]=0.0;i=i;return}function Sva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6704>>3]=0.0;i=i;return}function Tva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6680>>3]=0.0;i=i;return}function Uva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6656>>3]=0.0;i=i;return}function Vva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6632>>3]=0.0;i=i;return}function Wva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6608>>3]=0.0;i=i;return}function Xva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6584>>3]=0.0;i=i;return}function Yva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6560>>3]=0.0;i=i;return}function Zva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6768>>3]=0.0;i=i;return}function _va(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6744>>3]=0.0;i=i;return}function $va(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6720>>3]=0.0;i=i;return}function awa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6696>>3]=0.0;i=i;return}function bwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6672>>3]=0.0;i=i;return}function cwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6648>>3]=0.0;i=i;return}function dwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6624>>3]=0.0;i=i;return}function ewa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6600>>3]=0.0;i=i;return}function fwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6576>>3]=0.0;i=i;return}function gwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6552>>3]=0.0;i=i;return}function hwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6760>>3]=0.0;i=i;return}function iwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6736>>3]=0.0;i=i;return}function jwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6712>>3]=0.0;i=i;return}function kwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6688>>3]=0.0;i=i;return}function lwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6664>>3]=0.0;i=i;return}function mwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6640>>3]=0.0;i=i;return}function nwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6536>>3]=0.0;i=i;return}function owa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6528>>3]=0.0;i=i;return}function pwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6504>>3]=0.0;i=i;return}function qwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6480>>3]=0.0;i=i;return}function rwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6472>>3]=0.0;i=i;return}function swa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6616>>3]=0.0;i=i;return}function twa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6464>>3]=0.0;i=i;return}function uwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6456>>3]=0.0;i=i;return}function vwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6432>>3]=0.0;i=i;return}function wwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6408>>3]=0.0;i=i;return}function xwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6400>>3]=0.0;i=i;return}function ywa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6592>>3]=0.0;i=i;return}function zwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6392>>3]=0.0;i=i;return}function Awa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6384>>3]=0.0;i=i;return}function Bwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6360>>3]=0.0;i=i;return}function Cwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6336>>3]=0.0;i=i;return}function Dwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6328>>3]=0.0;i=i;return}function Ewa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6568>>3]=0.0;i=i;return}function Fwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6320>>3]=0.0;i=i;return}function Gwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6312>>3]=0.0;i=i;return}function Hwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6288>>3]=0.0;i=i;return}function Iwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6264>>3]=0.0;i=i;return}function Jwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6256>>3]=0.0;i=i;return}function Kwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6544>>3]=0.0;i=i;return}function Lwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6248>>3]=0.0;i=i;return}function Mwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6240>>3]=0.0;i=i;return}function Nwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6216>>3]=0.0;i=i;return}function Owa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6192>>3]=0.0;i=i;return}function Pwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6184>>3]=0.0;i=i;return}function Qwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6176>>3]=0.0;i=i;return}function Rwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6160>>3]=0.0;i=i;return}function Swa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6168>>3]=0.0;i=i;return}function Twa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6128>>3]=0.0;i=i;return}function Uwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6152>>3]=0.0;i=i;return}function Vwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6104>>3]=0.0;i=i;return}function Wwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6080>>3]=0.0;i=i;return}function Xwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6056>>3]=0.0;i=i;return}function Ywa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6048>>3]=0.0;i=i;return}function Zwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6040>>3]=0.0;i=i;return}function _wa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6016>>3]=0.0;i=i;return}function $wa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6008>>3]=0.0;i=i;return}function axa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5984>>3]=0.0;i=i;return}function bxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5960>>3]=0.0;i=i;return}function cxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5952>>3]=0.0;i=i;return}function dxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5928>>3]=0.0;i=i;return}function exa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5904>>3]=0.0;i=i;return}function fxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5880>>3]=0.0;i=i;return}function gxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5872>>3]=0.0;i=i;return}function hxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5864>>3]=0.0;i=i;return}function ixa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5840>>3]=0.0;i=i;return}function jxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5832>>3]=0.0;i=i;return}function kxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5808>>3]=0.0;i=i;return}function lxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5784>>3]=0.0;i=i;return}function mxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5776>>3]=0.0;i=i;return}function nxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5752>>3]=0.0;i=i;return}function oxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5728>>3]=0.0;i=i;return}function pxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5704>>3]=0.0;i=i;return}function qxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5696>>3]=0.0;i=i;return}function rxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5688>>3]=0.0;i=i;return}function sxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5664>>3]=0.0;i=i;return}function txa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5656>>3]=0.0;i=i;return}function uxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5632>>3]=0.0;i=i;return}function vxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5608>>3]=0.0;i=i;return}function wxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5600>>3]=0.0;i=i;return}function xxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5576>>3]=0.0;i=i;return}function yxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5552>>3]=0.0;i=i;return}function zxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5528>>3]=0.0;i=i;return}function Axa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5520>>3]=0.0;i=i;return}function Bxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5512>>3]=0.0;i=i;return}function Cxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5488>>3]=0.0;i=i;return}function Dxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5480>>3]=0.0;i=i;return}function Exa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5456>>3]=0.0;i=i;return}function Fxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5432>>3]=0.0;i=i;return}function Gxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5424>>3]=0.0;i=i;return}function Hxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5400>>3]=0.0;i=i;return}function Ixa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5376>>3]=0.0;i=i;return}function Jxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5352>>3]=0.0;i=i;return}function Kxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5344>>3]=0.0;i=i;return}function Lxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5336>>3]=0.0;i=i;return}function Mxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5312>>3]=0.0;i=i;return}function Nxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5304>>3]=0.0;i=i;return}function Oxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5280>>3]=0.0;i=i;return}function Pxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5256>>3]=0.0;i=i;return}function Qxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5248>>3]=0.0;i=i;return}function Rxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5224>>3]=0.0;i=i;return}function Sxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5200>>3]=0.0;i=i;return}function Txa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5192>>3]=0.0;i=i;return}function Uxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5184>>3]=0.0;i=i;return}function Vxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5160>>3]=0.0;i=i;return}function Wxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5152>>3]=0.0;i=i;return}function Xxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5128>>3]=0.0;i=i;return}function Yxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5104>>3]=0.0;i=i;return}function Zxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5096>>3]=0.0;i=i;return}function _xa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5072>>3]=0.0;i=i;return}function $xa(a){a=a|0;var b=0;b=i;RMb(23e3,(c[a+416>>2]|0)+1904|0);i=b;return}function aya(a){a=a|0;var b=0;b=i;RMb(23e3,(c[a+416>>2]|0)+4920|0);i=b;return}function bya(a){a=a|0;var b=0;b=i;RMb(23e3,(c[a+416>>2]|0)+7936|0);i=b;return}function cya(a){a=a|0;var b=0;b=i;RMb(23e3,(c[a+416>>2]|0)+10952|0);i=b;return}function dya(a){a=a|0;var b=0;b=i;RMb(23e3,(c[a+416>>2]|0)+13968|0);i=b;return}function eya(a){a=a|0;var b=0;b=i;RMb(23e3,(c[a+416>>2]|0)+16984|0);i=b;return}function fya(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;Bv(b);Cv(b);Dv(b);Ev(b);Fv(b);Gv(b);Hv(b);Iv(b);Jv(b);Kv(b);Lv(b);Mv(b);Nv(b);Ov(b);Pv(b);Qv(b);Rv(b);Sv(b);Tv(b);Uv(b);Vv(b);Wv(b);Xv(b);Yv(b);Zv(b);_v(b);$v(b);aw(b);bw(b);cw(b);dw(b);ew(b);fw(b);gw(b);hw(b);iw(b);jw(b);kw(b);lw(b);mw(b);nw(b);ow(b);pw(b);qw(b);rw(b);sw(b);tw(b);uw(b);vw(b);ww(b);xw(b);yw(b);zw(b);Aw(b);Bw(b);Cw(b);Dw(b);Ew(b);Fw(b);Gw(b);Hw(b);Iw(b);Jw(b);Kw(b);Lw(b);Mw(b);Nw(b);Ow(b);Pw(b);Qw(b);Rw(b);Sw(b);Tw(b);Uw(b);Vw(b);Ww(b);Xw(b);Yw(b);Zw(b);_w(b);$w(b);ax(b);bx(b);cx(b);dx(b);ex(b);fx(b);gx(b);hx(b);ix(b);jx(b);kx(b);lx(b);mx(b);nx(b);ox(b);px(b);qx(b);rx(b);sx(b);tx(b);ux(b);vx(b);wx(b);xx(b);yx(b);zx(b);Ax(b);Bx(b);Cx(b);Dx(b);Ex(b);Fx(b);Gx(b);Hx(b);Ix(b);Jx(b);Kx(b);Lx(b);Mx(b);Nx(b);Ox(b);Px(b);Qx(b);Rx(b);Sx(b);Tx(b);Ux(b);Vx(b);Wx(b);Xx(b);Yx(b);Zx(b);_x(b);$x(b);ay(b);by(b);cy(b);dy(b);ey(b);fy(b);gy(b);hy(b);iy(b);jy(b);ky(b);ly(b);my(b);ny(b);oy(b);py(b);qy(b);ry(b);sy(b);ty(b);uy(b);vy(b);wy(b);xy(b);yy(b);zy(b);Ay(b);By(b);Cy(b);Dy(b);Ey(b);Fy(b);Gy(b);Hy(b);Iy(b);Jy(b);Ky(b);Ly(b);My(b);Ny(b);Oy(b);Py(b);Qy(b);Ry(b);Sy(b);Ty(b);Uy(b);Vy(b);Wy(b);Xy(b);Yy(b);Zy(b);_y(b);$y(b);az(b);bz(b);cz(b);dz(b);ez(b);fz(b);gz(b);hz(b);iz(b);jz(b);kz(b);lz(b);mz(b);nz(b);oz(b);pz(b);qz(b);rz(b);sz(b);tz(b);uz(b);vz(b);wz(b);xz(b);yz(b);zz(b);Az(b);Bz(b);Cz(b);Dz(b);Ez(b);Fz(b);Gz(b);Hz(b);Iz(b);Jz(b);Kz(b);Lz(b);Mz(b);Nz(b);Oz(b);Pz(b);Qz(b);Rz(b);Sz(b);Tz(b);Uz(b);Vz(b);Wz(b);Xz(b);Yz(b);Zz(b);_z(b);$z(b);aA(b);bA(b);cA(b);dA(b);eA(b);fA(b);gA(b);hA(b);iA(b);jA(b);kA(b);lA(b);mA(b);nA(b);oA(b);pA(b);qA(b);rA(b);sA(b);tA(b);uA(b);vA(b);wA(b);xA(b);yA(b);zA(b);AA(b);BA(b);CA(b);DA(b);EA(b);FA(b);GA(b);HA(b);IA(b);JA(b);KA(b);LA(b);MA(b);NA(b);OA(b);PA(b);QA(b);RA(b);SA(b);TA(b);UA(b);VA(b);WA(b);XA(b);YA(b);ZA(b);_A(b);$A(b);aB(b);bB(b);cB(b);dB(b);eB(b);fB(b);gB(b);hB(b);iB(b);jB(b);kB(b);lB(b);mB(b);nB(b);oB(b);pB(b);qB(b);rB(b);sB(b);tB(b);uB(b);vB(b);wB(b);xB(b);yB(b);zB(b);AB(b);BB(b);CB(b);DB(b);EB(b);FB(b);GB(b);HB(b);IB(b);JB(b);KB(b);LB(b);MB(b);NB(b);OB(b);PB(b);QB(b);RB(b);SB(b);TB(b);UB(b);VB(b);WB(b);XB(b);YB(b);ZB(b);_B(b);$B(b);aC(b);bC(b);cC(b);dC(b);eC(b);fC(b);gC(b);hC(b);iC(b);jC(b);kC(b);lC(b);mC(b);nC(b);oC(b);pC(b);qC(b);rC(b);sC(b);tC(b);uC(b);vC(b);wC(b);xC(b);yC(b);zC(b);AC(b);BC(b);CC(b);DC(b);EC(b);FC(b);GC(b);HC(b);IC(b);JC(b);KC(b);LC(b);MC(b);NC(b);OC(b);PC(b);QC(b);RC(b);SC(b);TC(b);UC(b);VC(b);WC(b);XC(b);YC(b);ZC(b);_C(b);$C(b);aD(b);bD(b);cD(b);dD(b);eD(b);fD(b);gD(b);hD(b);iD(b);jD(b);kD(b);lD(b);mD(b);nD(b);oD(b);pD(b);qD(b);rD(b);sD(b);tD(b);uD(b);vD(b);wD(b);xD(b);yD(b);zD(b);AD(b);BD(b);CD(b);DD(b);ED(b);FD(b);GD(b);HD(b);ID(b);JD(b);KD(b);LD(b);MD(b);ND(b);OD(b);PD(b);QD(b);RD(b);SD(b);TD(b);UD(b);VD(b);WD(b);XD(b);YD(b);ZD(b);_D(b);$D(b);aE(b);bE(b);cE(b);dE(b);eE(b);fE(b);gE(b);hE(b);iE(b);jE(b);kE(b);lE(b);mE(b);nE(b);oE(b);pE(b);qE(b);rE(b);sE(b);tE(b);uE(b);vE(b);wE(b);xE(b);yE(b);zE(b);AE(b);BE(b);CE(b);DE(b);EE(b);FE(b);GE(b);HE(b);IE(b);JE(b);KE(b);LE(b);ME(b);NE(b);OE(b);PE(b);QE(b);RE(b);SE(b);TE(b);UE(b);VE(b);WE(b);XE(b);YE(b);ZE(b);_E(b);$E(b);aF(b);bF(b);cF(b);dF(b);eF(b);fF(b);gF(b);hF(b);iF(b);jF(b);kF(b);lF(b);mF(b);nF(b);oF(b);pF(b);qF(b);rF(b);sF(b);tF(b);uF(b);vF(b);wF(b);xF(b);yF(b);zF(b);AF(b);BF(b);CF(b);DF(b);EF(b);FF(b);GF(b);HF(b);IF(b);JF(b);KF(b);LF(b);MF(b);NF(b);OF(b);PF(b);QF(b);RF(b);SF(b);TF(b);UF(b);VF(b);WF(b);XF(b);YF(b);ZF(b);_F(b);$F(b);aG(b);bG(b);cG(b);dG(b);eG(b);fG(b);gG(b);hG(b);iG(b);jG(b);kG(b);lG(b);mG(b);nG(b);oG(b);pG(b);qG(b);rG(b);sG(b);tG(b);uG(b);vG(b);wG(b);xG(b);yG(b);zG(b);AG(b);BG(b);CG(b);DG(b);EG(b);FG(b);GG(b);HG(b);IG(b);JG(b);KG(b);LG(b);MG(b);NG(b);OG(b);PG(b);QG(b);RG(b);SG(b);TG(b);UG(b);VG(b);WG(b);XG(b);YG(b);ZG(b);_G(b);$G(b);aH(b);bH(b);cH(b);dH(b);eH(b);fH(b);gH(b);hH(b);iH(b);jH(b);kH(b);lH(b);mH(b);nH(b);oH(b);pH(b);qH(b);rH(b);sH(b);tH(b);uH(b);vH(b);wH(b);xH(b);yH(b);zH(b);AH(b);BH(b);CH(b);DH(b);EH(b);FH(b);GH(b);HH(b);IH(b);JH(b);KH(b);LH(b);MH(b);NH(b);OH(b);PH(b);QH(b);RH(b);SH(b);TH(b);UH(b);VH(b);WH(b);XH(b);YH(b);ZH(b);_H(b);$H(b);aI(b);bI(b);cI(b);dI(b);eI(b);fI(b);gI(b);hI(b);iI(b);jI(b);kI(b);lI(b);mI(b);nI(b);oI(b);pI(b);qI(b);rI(b);sI(b);tI(b);uI(b);vI(b);wI(b);xI(b);yI(b);zI(b);AI(b);BI(b);CI(b);DI(b);EI(b);FI(b);GI(b);HI(b);II(b);JI(b);KI(b);LI(b);MI(b);NI(b);OI(b);PI(b);QI(b);RI(b);SI(b);TI(b);UI(b);VI(b);WI(b);XI(b);YI(b);ZI(b);_I(b);$I(b);aJ(b);bJ(b);cJ(b);dJ(b);eJ(b);fJ(b);gJ(b);hJ(b);iJ(b);jJ(b);kJ(b);lJ(b);mJ(b);nJ(b);oJ(b);pJ(b);qJ(b);rJ(b);sJ(b);tJ(b);uJ(b);vJ(b);wJ(b);xJ(b);yJ(b);zJ(b);AJ(b);BJ(b);CJ(b);DJ(b);EJ(b);FJ(b);GJ(b);HJ(b);IJ(b);JJ(b);KJ(b);LJ(b);MJ(b);NJ(b);OJ(b);PJ(b);QJ(b);RJ(b);SJ(b);TJ(b);UJ(b);VJ(b);WJ(b);XJ(b);YJ(b);ZJ(b);_J(b);$J(b);aK(b);bK(b);cK(b);dK(b);eK(b);fK(b);gK(b);hK(b);iK(b);jK(b);kK(b);lK(b);mK(b);nK(b);oK(b);pK(b);qK(b);rK(b);sK(b);tK(b);uK(b);vK(b);wK(b);xK(b);yK(b);zK(b);AK(b);BK(b);CK(b);DK(b);EK(b);FK(b);GK(b);HK(b);IK(b);JK(b);KK(b);LK(b);MK(b);NK(b);OK(b);PK(b);QK(b);RK(b);SK(b);TK(b);UK(b);VK(b);WK(b);XK(b);YK(b);ZK(b);_K(b);$K(b);aL(b);bL(b);cL(b);dL(b);eL(b);fL(b);gL(b);hL(b);iL(b);jL(b);kL(b);lL(b);mL(b);nL(b);oL(b);pL(b);qL(b);rL(b);sL(b);tL(b);uL(b);vL(b);wL(b);xL(b);yL(b);zL(b);AL(b);BL(b);CL(b);DL(b);EL(b);FL(b);GL(b);HL(b);IL(b);JL(b);KL(b);LL(b);ML(b);NL(b);OL(b);PL(b);QL(b);RL(b);SL(b);TL(b);UL(b);VL(b);WL(b);XL(b);YL(b);ZL(b);_L(b);$L(b);aM(b);bM(b);cM(b);dM(b);eM(b);fM(b);gM(b);hM(b);iM(b);jM(b);kM(b);lM(b);mM(b);nM(b);oM(b);pM(b);qM(b);rM(b);sM(b);tM(b);uM(b);vM(b);wM(b);xM(b);yM(b);zM(b);AM(b);BM(b);CM(b);DM(b);EM(b);FM(b);GM(b);HM(b);IM(b);JM(b);KM(b);LM(b);MM(b);NM(b);OM(b);PM(b);QM(b);RM(b);SM(b);TM(b);UM(b);VM(b);WM(b);XM(b);YM(b);ZM(b);_M(b);$M(b);aN(b);bN(b);cN(b);dN(b);eN(b);fN(b);gN(b);hN(b);iN(b);jN(b);kN(b);lN(b);mN(b);nN(b);oN(b);pN(b);qN(b);rN(b);sN(b);tN(b);uN(b);vN(b);wN(b);xN(b);yN(b);zN(b);AN(b);BN(b);CN(b);DN(b);EN(b);FN(b);GN(b);HN(b);IN(b);JN(b);KN(b);LN(b);MN(b);NN(b);ON(b);PN(b);QN(b);RN(b);SN(b);TN(b);UN(b);VN(b);WN(b);XN(b);YN(b);ZN(b);_N(b);$N(b);aO(b);bO(b);cO(b);dO(b);eO(b);fO(b);gO(b);hO(b);iO(b);jO(b);kO(b);lO(b);mO(b);nO(b);oO(b);pO(b);qO(b);rO(b);sO(b);tO(b);uO(b);vO(b);wO(b);xO(b);yO(b);zO(b);AO(b);BO(b);CO(b);DO(b);EO(b);FO(b);GO(b);HO(b);IO(b);JO(b);KO(b);LO(b);MO(b);NO(b);OO(b);PO(b);QO(b);RO(b);SO(b);TO(b);UO(b);VO(b);WO(b);XO(b);YO(b);ZO(b);_O(b);$O(b);aP(b);bP(b);cP(b);dP(b);eP(b);fP(b);gP(b);hP(b);iP(b);jP(b);kP(b);lP(b);mP(b);nP(b);oP(b);pP(b);qP(b);rP(b);sP(b);tP(b);uP(b);vP(b);wP(b);xP(b);yP(b);zP(b);AP(b);BP(b);CP(b);DP(b);EP(b);FP(b);GP(b);HP(b);IP(b);JP(b);KP(b);LP(b);MP(b);NP(b);OP(b);PP(b);QP(b);RP(b);SP(b);TP(b);UP(b);VP(b);WP(b);XP(b);YP(b);ZP(b);_P(b);$P(b);aQ(b);bQ(b);cQ(b);dQ(b);eQ(b);fQ(b);gQ(b);hQ(b);iQ(b);jQ(b);kQ(b);lQ(b);mQ(b);nQ(b);oQ(b);pQ(b);qQ(b);rQ(b);sQ(b);tQ(b);uQ(b);vQ(b);wQ(b);xQ(b);yQ(b);zQ(b);AQ(b);BQ(b);CQ(b);DQ(b);EQ(b);FQ(b);GQ(b);HQ(b);IQ(b);JQ(b);KQ(b);LQ(b);MQ(b);NQ(b);OQ(b);PQ(b);QQ(b);RQ(b);SQ(b);TQ(b);UQ(b);VQ(b);WQ(b);XQ(b);YQ(b);ZQ(b);_Q(b);$Q(b);aR(b);bR(b);cR(b);dR(b);eR(b);fR(b);gR(b);hR(b);iR(b);jR(b);kR(b);lR(b);mR(b);nR(b);oR(b);pR(b);qR(b);rR(b);sR(b);tR(b);uR(b);vR(b);wR(b);xR(b);yR(b);zR(b);AR(b);BR(b);CR(b);DR(b);ER(b);FR(b);GR(b);HR(b);IR(b);JR(b);KR(b);LR(b);MR(b);NR(b);OR(b);PR(b);QR(b);RR(b);SR(b);TR(b);UR(b);VR(b);WR(b);XR(b);YR(b);ZR(b);_R(b);$R(b);aS(b);bS(b);cS(b);dS(b);eS(b);fS(b);gS(b);hS(b);iS(b);jS(b);kS(b);lS(b);mS(b);nS(b);oS(b);pS(b);qS(b);rS(b);sS(b);tS(b);uS(b);vS(b);wS(b);xS(b);yS(b);zS(b);AS(b);BS(b);CS(b);DS(b);ES(b);FS(b);GS(b);HS(b);IS(b);JS(b);KS(b);LS(b);MS(b);NS(b);OS(b);PS(b);QS(b);RS(b);SS(b);TS(b);US(b);VS(b);WS(b);XS(b);YS(b);ZS(b);_S(b);$S(b);aT(b);bT(b);cT(b);dT(b);eT(b);fT(b);gT(b);hT(b);iT(b);jT(b);kT(b);lT(b);mT(b);nT(b);oT(b);pT(b);qT(b);rT(b);sT(b);tT(b);uT(b);vT(b);wT(b);xT(b);yT(b);zT(b);AT(b);BT(b);CT(b);DT(b);ET(b);FT(b);GT(b);HT(b);IT(b);JT(b);KT(b);LT(b);MT(b);NT(b);OT(b);PT(b);QT(b);RT(b);ST(b);TT(b);UT(b);VT(b);WT(b);XT(b);YT(b);ZT(b);_T(b);$T(b);aU(b);bU(b);cU(b);dU(b);eU(b);fU(b);gU(b);hU(b);iU(b);jU(b);kU(b);lU(b);mU(b);nU(b);oU(b);pU(b);qU(b);rU(b);sU(b);tU(b);uU(b);vU(b);wU(b);xU(b);yU(b);zU(b);AU(b);BU(b);CU(b);DU(b);EU(b);FU(b);GU(b);HU(b);IU(b);JU(b);KU(b);LU(b);MU(b);NU(b);OU(b);PU(b);QU(b);RU(b);SU(b);TU(b);UU(b);VU(b);WU(b);XU(b);YU(b);ZU(b);_U(b);$U(b);aV(b);bV(b);cV(b);dV(b);eV(b);fV(b);gV(b);hV(b);iV(b);jV(b);kV(b);lV(b);mV(b);nV(b);oV(b);pV(b);qV(b);rV(b);sV(b);tV(b);uV(b);vV(b);wV(b);xV(b);yV(b);zV(b);AV(b);BV(b);CV(b);DV(b);EV(b);FV(b);GV(b);HV(b);IV(b);JV(b);KV(b);LV(b);MV(b);NV(b);OV(b);PV(b);QV(b);RV(b);SV(b);TV(b);UV(b);VV(b);WV(b);XV(b);YV(b);ZV(b);_V(b);$V(b);aW(b);bW(b);cW(b);dW(b);eW(b);fW(b);gW(b);hW(b);iW(b);jW(b);kW(b);lW(b);mW(b);nW(b);oW(b);pW(b);qW(b);rW(b);sW(b);tW(b);uW(b);vW(b);wW(b);xW(b);yW(b);zW(b);AW(b);BW(b);CW(b);DW(b);EW(b);FW(b);GW(b);HW(b);IW(b);JW(b);KW(b);LW(b);MW(b);NW(b);OW(b);PW(b);QW(b);RW(b);SW(b);TW(b);UW(b);VW(b);WW(b);XW(b);YW(b);ZW(b);_W(b);$W(b);aX(b);bX(b);cX(b);dX(b);eX(b);fX(b);gX(b);hX(b);iX(b);jX(b);kX(b);lX(b);mX(b);nX(b);oX(b);pX(b);qX(b);rX(b);sX(b);tX(b);uX(b);vX(b);wX(b);xX(b);yX(b);zX(b);AX(b);BX(b);CX(b);DX(b);EX(b);FX(b);GX(b);HX(b);IX(b);JX(b);KX(b);LX(b);MX(b);NX(b);OX(b);PX(b);QX(b);RX(b);SX(b);TX(b);UX(b);VX(b);WX(b);XX(b);YX(b);ZX(b);_X(b);$X(b);aY(b);bY(b);cY(b);dY(b);eY(b);fY(b);gY(b);hY(b);iY(b);jY(b);kY(b);lY(b);mY(b);nY(b);oY(b);pY(b);qY(b);rY(b);sY(b);tY(b);uY(b);vY(b);wY(b);xY(b);yY(b);zY(b);AY(b);BY(b);CY(b);DY(b);EY(b);FY(b);GY(b);HY(b);IY(b);JY(b);KY(b);LY(b);MY(b);NY(b);OY(b);PY(b);QY(b);RY(b);SY(b);TY(b);UY(b);VY(b);WY(b);XY(b);YY(b);ZY(b);_Y(b);$Y(b);aZ(b);bZ(b);cZ(b);dZ(b);eZ(b);fZ(b);gZ(b);hZ(b);iZ(b);jZ(b);kZ(b);lZ(b);mZ(b);nZ(b);oZ(b);pZ(b);qZ(b);rZ(b);sZ(b);tZ(b);uZ(b);vZ(b);wZ(b);xZ(b);yZ(b);zZ(b);AZ(b);BZ(b);CZ(b);DZ(b);EZ(b);FZ(b);GZ(b);HZ(b);IZ(b);JZ(b);KZ(b);LZ(b);MZ(b);NZ(b);OZ(b);PZ(b);QZ(b);RZ(b);SZ(b);TZ(b);UZ(b);VZ(b);WZ(b);XZ(b);YZ(b);ZZ(b);_Z(b);$Z(b);a_(b);b_(b);c_(b);d_(b);e_(b);f_(b);g_(b);h_(b);i_(b);j_(b);k_(b);l_(b);m_(b);n_(b);o_(b);p_(b);q_(b);r_(b);s_(b);t_(b);u_(b);v_(b);w_(b);x_(b);y_(b);z_(b);A_(b);B_(b);C_(b);D_(b);E_(b);F_(b);G_(b);H_(b);I_(b);J_(b);K_(b);L_(b);M_(b);N_(b);O_(b);P_(b);Q_(b);R_(b);S_(b);T_(b);U_(b);V_(b);W_(b);X_(b);Y_(b);Z_(b);__(b);$_(b);a$(b);b$(b);c$(b);d$(b);e$(b);f$(b);g$(b);h$(b);i$(b);j$(b);k$(b);l$(b);m$(b);n$(b);o$(b);p$(b);q$(b);r$(b);s$(b);t$(b);u$(b);v$(b);w$(b);x$(b);y$(b);z$(b);A$(b);B$(b);C$(b);D$(b);E$(b);F$(b);G$(b);H$(b);I$(b);J$(b);K$(b);L$(b);M$(b);N$(b);O$(b);P$(b);Q$(b);R$(b);S$(b);T$(b);U$(b);V$(b);W$(b);X$(b);Y$(b);Z$(b);_$(b);$$(b);a0(b);b0(b);c0(b);d0(b);e0(b);f0(b);g0(b);h0(b);i0(b);j0(b);k0(b);l0(b);m0(b);n0(b);o0(b);p0(b);q0(b);r0(b);s0(b);t0(b);u0(b);v0(b);w0(b);x0(b);y0(b);z0(b);A0(b);B0(b);C0(b);D0(b);E0(b);F0(b);G0(b);H0(b);I0(b);J0(b);K0(b);L0(b);M0(b);N0(b);O0(b);P0(b);Q0(b);R0(b);S0(b);T0(b);U0(b);V0(b);W0(b);X0(b);Y0(b);Z0(b);_0(b);$0(b);a1(b);b1(b);c1(b);d1(b);e1(b);f1(b);g1(b);h1(b);i1(b);j1(b);k1(b);l1(b);m1(b);n1(b);o1(b);p1(b);q1(b);r1(b);s1(b);t1(b);u1(b);v1(b);w1(b);x1(b);y1(b);z1(b);A1(b);B1(b);C1(b);D1(b);E1(b);F1(b);G1(b);H1(b);I1(b);J1(b);K1(b);L1(b);M1(b);N1(b);O1(b);P1(b);Q1(b);R1(b);S1(b);T1(b);U1(b);V1(b);W1(b);X1(b);Y1(b);Z1(b);_1(b);$1(b);a2(b);b2(b);c2(b);d2(b);e2(b);f2(b);g2(b);h2(b);i2(b);j2(b);k2(b);l2(b);m2(b);n2(b);o2(b);p2(b);q2(b);r2(b);s2(b);t2(b);u2(b);v2(b);w2(b);x2(b);y2(b);z2(b);A2(b);B2(b);C2(b);D2(b);E2(b);F2(b);G2(b);H2(b);I2(b);J2(b);K2(b);L2(b);M2(b);N2(b);O2(b);P2(b);Q2(b);R2(b);S2(b);T2(b);U2(b);V2(b);W2(b);X2(b);Y2(b);Z2(b);_2(b);$2(b);a3(b);b3(b);c3(b);d3(b);e3(b);f3(b);g3(b);h3(b);i3(b);j3(b);k3(b);l3(b);m3(b);n3(b);o3(b);p3(b);q3(b);r3(b);s3(b);t3(b);u3(b);v3(b);w3(b);x3(b);y3(b);z3(b);A3(b);B3(b);C3(b);D3(b);E3(b);F3(b);G3(b);H3(b);I3(b);J3(b);K3(b);L3(b);M3(b);N3(b);O3(b);P3(b);Q3(b);R3(b);S3(b);T3(b);U3(b);V3(b);W3(b);X3(b);Y3(b);Z3(b);_3(b);$3(b);a4(b);b4(b);c4(b);d4(b);e4(b);f4(b);g4(b);h4(b);i4(b);j4(b);k4(b);l4(b);m4(b);n4(b);o4(b);p4(b);q4(b);r4(b);s4(b);t4(b);u4(b);v4(b);w4(b);x4(b);y4(b);z4(b);A4(b);B4(b);C4(b);D4(b);E4(b);F4(b);G4(b);H4(b);I4(b);J4(b);K4(b);L4(b);M4(b);N4(b);O4(b);P4(b);Q4(b);R4(b);S4(b);T4(b);U4(b);V4(b);W4(b);X4(b);Y4(b);Z4(b);_4(b);$4(b);a5(b);b5(b);c5(b);d5(b);e5(b);f5(b);g5(b);h5(b);i5(b);j5(b);k5(b);l5(b);m5(b);n5(b);o5(b);p5(b);q5(b);r5(b);s5(b);t5(b);u5(b);v5(b);w5(b);x5(b);y5(b);z5(b);A5(b);B5(b);C5(b);D5(b);E5(b);F5(b);G5(b);H5(b);I5(b);J5(b);K5(b);L5(b);M5(b);N5(b);O5(b);P5(b);Q5(b);R5(b);S5(b);T5(b);U5(b);V5(b);W5(b);X5(b);Y5(b);Z5(b);_5(b);$5(b);a6(b);b6(b);c6(b);d6(b);e6(b);f6(b);g6(b);h6(b);i6(b);j6(b);k6(b);l6(b);m6(b);n6(b);o6(b);p6(b);q6(b);r6(b);s6(b);t6(b);u6(b);v6(b);w6(b);x6(b);y6(b);z6(b);A6(b);B6(b);C6(b);D6(b);E6(b);F6(b);G6(b);H6(b);I6(b);J6(b);K6(b);L6(b);M6(b);N6(b);O6(b);P6(b);Q6(b);R6(b);S6(b);T6(b);U6(b);V6(b);W6(b);X6(b);Y6(b);Z6(b);_6(b);$6(b);a7(b);b7(b);c7(b);d7(b);e7(b);f7(b);g7(b);h7(b);i7(b);j7(b);k7(b);l7(b);m7(b);n7(b);o7(b);p7(b);q7(b);r7(b);s7(b);t7(b);u7(b);v7(b);w7(b);x7(b);y7(b);z7(b);A7(b);B7(b);C7(b);D7(b);E7(b);F7(b);G7(b);H7(b);I7(b);J7(b);K7(b);L7(b);M7(b);N7(b);O7(b);P7(b);Q7(b);R7(b);S7(b);T7(b);U7(b);V7(b);W7(b);X7(b);Y7(b);Z7(b);_7(b);$7(b);a8(b);b8(b);c8(b);d8(b);e8(b);f8(b);g8(b);h8(b);i8(b);j8(b);k8(b);l8(b);m8(b);n8(b);o8(b);p8(b);q8(b);r8(b);s8(b);t8(b);u8(b);v8(b);w8(b);x8(b);y8(b);z8(b);A8(b);B8(b);C8(b);D8(b);E8(b);F8(b);G8(b);H8(b);I8(b);J8(b);K8(b);L8(b);M8(b);N8(b);O8(b);P8(b);Q8(b);R8(b);S8(b);T8(b);U8(b);V8(b);W8(b);X8(b);Y8(b);Z8(b);_8(b);$8(b);a9(b);b9(b);c9(b);d9(b);e9(b);f9(b);g9(b);h9(b);i9(b);j9(b);k9(b);l9(b);m9(b);n9(b);o9(b);p9(b);q9(b);r9(b);s9(b);t9(b);u9(b);v9(b);w9(b);x9(b);y9(b);z9(b);A9(b);B9(b);C9(b);D9(b);E9(b);F9(b);G9(b);H9(b);I9(b);J9(b);K9(b);L9(b);M9(b);N9(b);O9(b);P9(b);Q9(b);R9(b);S9(b);T9(b);U9(b);V9(b);W9(b);X9(b);Y9(b);Z9(b);_9(b);$9(b);aaa(b);baa(b);caa(b);daa(b);eaa(b);faa(b);gaa(b);haa(b);iaa(b);jaa(b);kaa(b);laa(b);maa(b);naa(b);oaa(b);paa(b);qaa(b);raa(b);saa(b);taa(b);uaa(b);vaa(b);waa(b);xaa(b);yaa(b);zaa(b);Aaa(b);Baa(b);Caa(b);Daa(b);Eaa(b);Faa(b);Gaa(b);Haa(b);Iaa(b);Jaa(b);Kaa(b);Laa(b);Maa(b);Naa(b);Oaa(b);Paa(b);Qaa(b);Raa(b);Saa(b);Taa(b);Uaa(b);Vaa(b);Waa(b);Xaa(b);Yaa(b);Zaa(b);_aa(b);$aa(b);aba(b);bba(b);cba(b);dba(b);eba(b);fba(b);gba(b);hba(b);iba(b);jba(b);kba(b);lba(b);mba(b);nba(b);oba(b);pba(b);qba(b);rba(b);sba(b);tba(b);uba(b);vba(b);wba(b);xba(b);yba(b);zba(b);Aba(b);Bba(b);Cba(b);Dba(b);Eba(b);Fba(b);Gba(b);Hba(b);Iba(b);Jba(b);Kba(b);Lba(b);Mba(b);Nba(b);Oba(b);Pba(b);Qba(b);Rba(b);Sba(b);Tba(b);Uba(b);Vba(b);Wba(b);Xba(b);Yba(b);Zba(b);_ba(b);$ba(b);aca(b);bca(b);cca(b);dca(b);eca(b);fca(b);gca(b);hca(b);ica(b);jca(b);kca(b);lca(b);mca(b);nca(b);oca(b);pca(b);qca(b);rca(b);sca(b);tca(b);uca(b);vca(b);wca(b);xca(b);yca(b);zca(b);Aca(b);Bca(b);Cca(b);Dca(b);Eca(b);Fca(b);Gca(b);Hca(b);Ica(b);Jca(b);Kca(b);Lca(b);Mca(b);Nca(b);Oca(b);Pca(b);Qca(b);Rca(b);Sca(b);Tca(b);Uca(b);Vca(b);Wca(b);Xca(b);Yca(b);Zca(b);_ca(b);$ca(b);ada(b);bda(b);cda(b);dda(b);eda(b);fda(b);gda(b);hda(b);ida(b);jda(b);kda(b);lda(b);mda(b);nda(b);oda(b);pda(b);qda(b);rda(b);sda(b);tda(b);uda(b);vda(b);wda(b);xda(b);yda(b);zda(b);Ada(b);Bda(b);Cda(b);Dda(b);Eda(b);Fda(b);Gda(b);Hda(b);Ida(b);Jda(b);Kda(b);Lda(b);Mda(b);Nda(b);Oda(b);Pda(b);Qda(b);Rda(b);Sda(b);Tda(b);Uda(b);Vda(b);Wda(b);Xda(b);Yda(b);Zda(b);_da(b);$da(b);aea(b);bea(b);cea(b);dea(b);eea(b);fea(b);gea(b);hea(b);iea(b);jea(b);kea(b);lea(b);mea(b);nea(b);oea(b);pea(b);qea(b);rea(b);sea(b);tea(b);uea(b);vea(b);wea(b);xea(b);yea(b);zea(b);Aea(b);Bea(b);Cea(b);Dea(b);Eea(b);Fea(b);Gea(b);Hea(b);Iea(b);Jea(b);Kea(b);Lea(b);Mea(b);Nea(b);Oea(b);Pea(b);Qea(b);Rea(b);Sea(b);Tea(b);Uea(b);Vea(b);Wea(b);Xea(b);Yea(b);Zea(b);_ea(b);$ea(b);afa(b);bfa(b);cfa(b);dfa(b);efa(b);ffa(b);gfa(b);hfa(b);ifa(b);jfa(b);kfa(b);lfa(b);mfa(b);nfa(b);ofa(b);pfa(b);qfa(b);rfa(b);sfa(b);tfa(b);ufa(b);vfa(b);wfa(b);xfa(b);yfa(b);zfa(b);Afa(b);Bfa(b);Cfa(b);Dfa(b);Efa(b);Ffa(b);Gfa(b);Hfa(b);Ifa(b);Jfa(b);Kfa(b);Lfa(b);Mfa(b);Nfa(b);Ofa(b);Pfa(b);Qfa(b);Rfa(b);Sfa(b);Tfa(b);Ufa(b);Vfa(b);Wfa(b);Xfa(b);Yfa(b);Zfa(b);_fa(b);$fa(b);aga(b);bga(b);cga(b);dga(b);ega(b);fga(b);gga(b);hga(b);iga(b);jga(b);kga(b);lga(b);mga(b);nga(b);oga(b);pga(b);qga(b);rga(b);sga(b);tga(b);uga(b);vga(b);wga(b);xga(b);yga(b);zga(b);Aga(b);Bga(b);Cga(b);Dga(b);Ega(b);Fga(b);Gga(b);Hga(b);Iga(b);Jga(b);Kga(b);Lga(b);Mga(b);Nga(b);Oga(b);Pga(b);Qga(b);Rga(b);Sga(b);Tga(b);Uga(b);Vga(b);Wga(b);Xga(b);Yga(b);Zga(b);_ga(b);$ga(b);aha(b);bha(b);cha(b);dha(b);eha(b);fha(b);gha(b);hha(b);iha(b);jha(b);kha(b);lha(b);mha(b);nha(b);oha(b);pha(b);qha(b);rha(b);sha(b);tha(b);uha(b);vha(b);wha(b);xha(b);yha(b);zha(b);Aha(b);Bha(b);Cha(b);Dha(b);Eha(b);Fha(b);Gha(b);Hha(b);Iha(b);Jha(b);Kha(b);Lha(b);Mha(b);Nha(b);Oha(b);Pha(b);Qha(b);Rha(b);Sha(b);Tha(b);Uha(b);Vha(b);Wha(b);Xha(b);Yha(b);Zha(b);_ha(b);$ha(b);aia(b);bia(b);cia(b);dia(b);eia(b);fia(b);gia(b);hia(b);iia(b);jia(b);kia(b);lia(b);mia(b);nia(b);oia(b);pia(b);qia(b);ria(b);sia(b);tia(b);uia(b);via(b);wia(b);xia(b);yia(b);zia(b);Aia(b);Bia(b);Cia(b);Dia(b);Eia(b);Fia(b);Gia(b);Hia(b);Iia(b);Jia(b);Kia(b);Lia(b);Mia(b);Nia(b);Oia(b);Pia(b);Qia(b);Ria(b);Sia(b);Tia(b);Uia(b);Via(b);Wia(b);Xia(b);Yia(b);Zia(b);_ia(b);$ia(b);aja(b);bja(b);cja(b);dja(b);eja(b);fja(b);gja(b);hja(b);ija(b);jja(b);kja(b);lja(b);mja(b);nja(b);oja(b);pja(b);qja(b);rja(b);sja(b);tja(b);uja(b);vja(b);wja(b);xja(b);yja(b);zja(b);Aja(b);Bja(b);Cja(b);Dja(b);Eja(b);Fja(b);Gja(b);Hja(b);Ija(b);Jja(b);Kja(b);Lja(b);Mja(b);Nja(b);Oja(b);Pja(b);Qja(b);Rja(b);Sja(b);Tja(b);Uja(b);Vja(b);Wja(b);Xja(b);Yja(b);Zja(b);_ja(b);$ja(b);aka(b);bka(b);cka(b);dka(b);eka(b);fka(b);gka(b);hka(b);ika(b);jka(b);kka(b);lka(b);mka(b);nka(b);oka(b);pka(b);qka(b);rka(b);ska(b);tka(b);uka(b);vka(b);wka(b);xka(b);yka(b);zka(b);Aka(b);Bka(b);Cka(b);Dka(b);Eka(b);Fka(b);Gka(b);Hka(b);Ika(b);Jka(b);Kka(b);Lka(b);Mka(b);Nka(b);Oka(b);Pka(b);Qka(b);Rka(b);Ska(b);Tka(b);Uka(b);Vka(b);Wka(b);Xka(b);Yka(b);Zka(b);_ka(b);$ka(b);ala(b);bla(b);cla(b);dla(b);ela(b);fla(b);gla(b);hla(b);ila(b);jla(b);kla(b);lla(b);mla(b);nla(b);ola(b);pla(b);qla(b);rla(b);sla(b);tla(b);ula(b);vla(b);wla(b);xla(b);yla(b);zla(b);Ala(b);Bla(b);Cla(b);Dla(b);Ela(b);Fla(b);Gla(b);Hla(b);Ila(b);Jla(b);Kla(b);Lla(b);Mla(b);Nla(b);Ola(b);Pla(b);Qla(b);Rla(b);Sla(b);Tla(b);Ula(b);Vla(b);Wla(b);Xla(b);Yla(b);Zla(b);_la(b);$la(b);ama(b);bma(b);cma(b);dma(b);ema(b);fma(b);gma(b);hma(b);ima(b);jma(b);kma(b);lma(b);mma(b);nma(b);oma(b);pma(b);qma(b);rma(b);sma(b);tma(b);uma(b);vma(b);wma(b);xma(b);yma(b);zma(b);Ama(b);Bma(b);Cma(b);Dma(b);Ema(b);Fma(b);Gma(b);Hma(b);Ima(b);Jma(b);Kma(b);Lma(b);Mma(b);Nma(b);Oma(b);Pma(b);Qma(b);Rma(b);Sma(b);Tma(b);Uma(b);Vma(b);Wma(b);Xma(b);Yma(b);Zma(b);_ma(b);$ma(b);ana(b);bna(b);cna(b);dna(b);ena(b);fna(b);gna(b);hna(b);ina(b);jna(b);kna(b);lna(b);mna(b);nna(b);ona(b);pna(b);qna(b);rna(b);sna(b);tna(b);una(b);vna(b);wna(b);xna(b);yna(b);zna(b);Ana(b);Bna(b);Cna(b);Dna(b);Ena(b);Fna(b);Gna(b);Hna(b);Ina(b);Jna(b);Kna(b);Lna(b);Mna(b);Nna(b);Ona(b);Pna(b);Qna(b);Rna(b);Sna(b);Tna(b);Una(b);Vna(b);Wna(b);Xna(b);Yna(b);Zna(b);_na(b);$na(b);aoa(b);boa(b);coa(b);doa(b);eoa(b);foa(b);goa(b);hoa(b);ioa(b);joa(b);koa(b);loa(b);moa(b);noa(b);ooa(b);poa(b);qoa(b);roa(b);soa(b);toa(b);uoa(b);voa(b);woa(b);xoa(b);yoa(b);zoa(b);Aoa(b);Boa(b);Coa(b);Doa(b);Eoa(b);Foa(b);Goa(b);Hoa(b);Ioa(b);Joa(b);Koa(b);Loa(b);Moa(b);Noa(b);Ooa(b);Poa(b);Qoa(b);Roa(b);Soa(b);Toa(b);Uoa(b);Voa(b);Woa(b);Xoa(b);Yoa(b);Zoa(b);_oa(b);$oa(b);apa(b);bpa(b);cpa(b);dpa(b);epa(b);fpa(b);gpa(b);hpa(b);ipa(b);jpa(b);kpa(b);lpa(b);mpa(b);npa(b);opa(b);ppa(b);qpa(b);rpa(b);spa(b);tpa(b);upa(b);vpa(b);wpa(b);xpa(b);ypa(b);zpa(b);Apa(b);Bpa(b);Cpa(b);Dpa(b);Epa(b);Fpa(b);Gpa(b);Hpa(b);Ipa(b);Jpa(b);Kpa(b);Lpa(b);Mpa(b);Npa(b);Opa(b);Ppa(b);Qpa(b);Rpa(b);Spa(b);Tpa(b);Upa(b);Vpa(b);Wpa(b);Xpa(b);Ypa(b);Zpa(b);_pa(b);$pa(b);aqa(b);bqa(b);cqa(b);dqa(b);eqa(b);fqa(b);gqa(b);hqa(b);iqa(b);jqa(b);kqa(b);lqa(b);mqa(b);nqa(b);oqa(b);pqa(b);qqa(b);rqa(b);sqa(b);tqa(b);uqa(b);vqa(b);wqa(b);xqa(b);yqa(b);zqa(b);Aqa(b);Bqa(b);Cqa(b);Dqa(b);Eqa(b);Fqa(b);Gqa(b);Hqa(b);Iqa(b);Jqa(b);Kqa(b);Lqa(b);Mqa(b);Nqa(b);Oqa(b);Pqa(b);Qqa(b);Rqa(b);Sqa(b);Tqa(b);Uqa(b);Vqa(b);Wqa(b);Xqa(b);Yqa(b);Zqa(b);_qa(b);$qa(b);ara(b);bra(b);cra(b);dra(b);era(b);fra(b);gra(b);hra(b);ira(b);jra(b);kra(b);lra(b);mra(b);nra(b);ora(b);pra(b);qra(b);rra(b);sra(b);tra(b);ura(b);vra(b);wra(b);xra(b);yra(b);zra(b);Ara(b);Bra(b);Cra(b);Dra(b);Era(b);Fra(b);Gra(b);Hra(b);Ira(b);Jra(b);Kra(b);Lra(b);Mra(b);Nra(b);Ora(b);Pra(b);Qra(b);Rra(b);Sra(b);Tra(b);Ura(b);Vra(b);Wra(b);Xra(b);Yra(b);Zra(b);_ra(b);$ra(b);asa(b);bsa(b);csa(b);dsa(b);esa(b);fsa(b);gsa(b);hsa(b);isa(b);jsa(b);ksa(b);lsa(b);msa(b);nsa(b);osa(b);psa(b);qsa(b);rsa(b);ssa(b);tsa(b);usa(b);vsa(b);wsa(b);xsa(b);ysa(b);zsa(b);Asa(b);Bsa(b);Csa(b);Dsa(b);Esa(b);Fsa(b);Gsa(b);Hsa(b);Isa(b);Jsa(b);Ksa(b);Lsa(b);Msa(b);Nsa(b);Osa(b);Psa(b);Qsa(b);Rsa(b);Ssa(b);Tsa(b);Usa(b);Vsa(b);Wsa(b);Xsa(b);Ysa(b);Zsa(b);_sa(b);$sa(b);ata(b);bta(b);cta(b);dta(b);eta(b);fta(b);gta(b);hta(b);ita(b);jta(b);kta(b);lta(b);mta(b);nta(b);ota(b);pta(b);qta(b);rta(b);sta(b);tta(b);uta(b);vta(b);wta(b);xta(b);yta(b);zta(b);Ata(b);Bta(b);Cta(b);Dta(b);Eta(b);Fta(b);Gta(b);Hta(b);Ita(b);Jta(b);Kta(b);Lta(b);Mta(b);Nta(b);Ota(b);Pta(b);Qta(b);Rta(b);Sta(b);Tta(b);Uta(b);Vta(b);Wta(b);Xta(b);Yta(b);Zta(b);_ta(b);$ta(b);aua(b);bua(b);cua(b);dua(b);eua(b);fua(b);gua(b);hua(b);iua(b);jua(b);kua(b);lua(b);mua(b);nua(b);oua(b);pua(b);qua(b);rua(b);sua(b);tua(b);uua(b);vua(b);wua(b);xua(b);yua(b);zua(b);Aua(b);Bua(b);Cua(b);Dua(b);Eua(b);Fua(b);Gua(b);Hua(b);Iua(b);Jua(b);Kua(b);Lua(b);Mua(b);Nua(b);Oua(b);Pua(b);Qua(b);Rua(b);Sua(b);Tua(b);Uua(b);Vua(b);Wua(b);Xua(b);Yua(b);Zua(b);_ua(b);$ua(b);ava(b);bva(b);cva(b);dva(b);eva(b);fva(b);gva(b);hva(b);iva(b);jva(b);kva(b);lva(b);mva(b);nva(b);ova(b);pva(b);qva(b);rva(b);sva(b);tva(b);uva(b);vva(b);wva(b);xva(b);yva(b);zva(b);Ava(b);Bva(b);Cva(b);Dva(b);Eva(b);Fva(b);Gva(b);Hva(b);Iva(b);Jva(b);Kva(b);Lva(b);Mva(b);Nva(b);Ova(b);Pva(b);Qva(b);Rva(b);Sva(b);Tva(b);Uva(b);Vva(b);Wva(b);Xva(b);Yva(b);Zva(b);_va(b);$va(b);awa(b);bwa(b);cwa(b);dwa(b);ewa(b);fwa(b);gwa(b);hwa(b);iwa(b);jwa(b);kwa(b);lwa(b);mwa(b);nwa(b);owa(b);pwa(b);qwa(b);rwa(b);swa(b);twa(b);uwa(b);vwa(b);wwa(b);xwa(b);ywa(b);zwa(b);Awa(b);Bwa(b);Cwa(b);Dwa(b);Ewa(b);Fwa(b);Gwa(b);Hwa(b);Iwa(b);Jwa(b);Kwa(b);Lwa(b);Mwa(b);Nwa(b);Owa(b);Pwa(b);Qwa(b);Rwa(b);Swa(b);Twa(b);Uwa(b);Vwa(b);Wwa(b);Xwa(b);Ywa(b);Zwa(b);_wa(b);$wa(b);axa(b);bxa(b);cxa(b);dxa(b);exa(b);fxa(b);gxa(b);hxa(b);ixa(b);jxa(b);kxa(b);lxa(b);mxa(b);nxa(b);oxa(b);pxa(b);qxa(b);rxa(b);sxa(b);txa(b);uxa(b);vxa(b);wxa(b);xxa(b);yxa(b);zxa(b);Axa(b);Bxa(b);Cxa(b);Dxa(b);Exa(b);Fxa(b);Gxa(b);Hxa(b);Ixa(b);Jxa(b);Kxa(b);Lxa(b);Mxa(b);Nxa(b);Oxa(b);Pxa(b);Qxa(b);Rxa(b);Sxa(b);Txa(b);Uxa(b);Vxa(b);Wxa(b);Xxa(b);Yxa(b);Zxa(b);_xa(b);$xa(b);aya(b);bya(b);cya(b);dya(b);eya(b);a[d]=0;i=c;return 0}function gya(a){a=a|0;i=i;return}function hya(a){a=a|0;i=i;return 0}function iya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=+h[(c[a+416>>2]|0)+18832>>3];i=i;return}function jya(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=+h[(c[a+416>>2]|0)+18824>>3];i=i;return}function kya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19512>>3]=+h[(c[a+416>>2]|0)+456>>3];i=i;return}function lya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+144>>3]=+h[(c[a+416>>2]|0)+17936>>3];i=i;return}function mya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+136>>3]=+h[(c[a+416>>2]|0)+17928>>3];i=i;return}function nya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+128>>3]=+h[(c[a+416>>2]|0)+17920>>3];i=i;return}function oya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+168>>3]=+h[(c[a+416>>2]|0)+17912>>3];i=i;return}function pya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+160>>3]=+h[(c[a+416>>2]|0)+17904>>3];i=i;return}function qya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+152>>3]=+h[(c[a+416>>2]|0)+17896>>3];i=i;return}function rya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+624>>3]=+h[(c[a+416>>2]|0)+14920>>3];i=i;return}function sya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+616>>3]=+h[(c[a+416>>2]|0)+14912>>3];i=i;return}function tya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+608>>3]=+h[(c[a+416>>2]|0)+14904>>3];i=i;return}function uya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+648>>3]=+h[(c[a+416>>2]|0)+14896>>3];i=i;return}function vya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+640>>3]=+h[(c[a+416>>2]|0)+14888>>3];i=i;return}function wya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+632>>3]=+h[(c[a+416>>2]|0)+14880>>3];i=i;return}function xya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1344>>3]=+h[(c[a+416>>2]|0)+11904>>3];i=i;return}function yya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1336>>3]=+h[(c[a+416>>2]|0)+11896>>3];i=i;return}function zya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1328>>3]=+h[(c[a+416>>2]|0)+11888>>3];i=i;return}function Aya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1368>>3]=+h[(c[a+416>>2]|0)+11880>>3];i=i;return}function Bya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1360>>3]=+h[(c[a+416>>2]|0)+11872>>3];i=i;return}function Cya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1352>>3]=+h[(c[a+416>>2]|0)+11864>>3];i=i;return}function Dya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2064>>3]=+h[(c[a+416>>2]|0)+8888>>3];i=i;return}function Eya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2056>>3]=+h[(c[a+416>>2]|0)+8880>>3];i=i;return}function Fya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2048>>3]=+h[(c[a+416>>2]|0)+8872>>3];i=i;return}function Gya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2088>>3]=+h[(c[a+416>>2]|0)+8864>>3];i=i;return}function Hya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2080>>3]=+h[(c[a+416>>2]|0)+8856>>3];i=i;return}function Iya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2072>>3]=+h[(c[a+416>>2]|0)+8848>>3];i=i;return}function Jya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2784>>3]=+h[(c[a+416>>2]|0)+5872>>3];i=i;return}function Kya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2776>>3]=+h[(c[a+416>>2]|0)+5864>>3];i=i;return}function Lya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2768>>3]=+h[(c[a+416>>2]|0)+5856>>3];i=i;return}function Mya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2808>>3]=+h[(c[a+416>>2]|0)+5848>>3];i=i;return}function Nya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2800>>3]=+h[(c[a+416>>2]|0)+5840>>3];i=i;return}function Oya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2792>>3]=+h[(c[a+416>>2]|0)+5832>>3];i=i;return}function Pya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3504>>3]=+h[(c[a+416>>2]|0)+2856>>3];i=i;return}function Qya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3496>>3]=+h[(c[a+416>>2]|0)+2848>>3];i=i;return}function Rya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3488>>3]=+h[(c[a+416>>2]|0)+2840>>3];i=i;return}function Sya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3528>>3]=+h[(c[a+416>>2]|0)+2832>>3];i=i;return}function Tya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3520>>3]=+h[(c[a+416>>2]|0)+2824>>3];i=i;return}function Uya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3512>>3]=+h[(c[a+416>>2]|0)+2816>>3];i=i;return}function Vya(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;VLb(9,1,23232,W);if((c[233596>>2]|0)!=0){de[c[58528]&511](9)}VLb(9,1,23256,V);if((c[233596>>2]|0)!=0){de[c[58528]&511](9)}VLb(9,1,23280,U);if((c[233596>>2]|0)!=0){de[c[58528]&511](9)}iya(a);jya(a);kya(a);lya(a);mya(a);nya(a);oya(a);pya(a);qya(a);rya(a);sya(a);tya(a);uya(a);vya(a);wya(a);xya(a);yya(a);zya(a);Aya(a);Bya(a);Cya(a);Dya(a);Eya(a);Fya(a);Gya(a);Hya(a);Iya(a);Jya(a);Kya(a);Lya(a);Mya(a);Nya(a);Oya(a);Pya(a);Qya(a);Rya(a);Sya(a);Tya(a);Uya(a);VLb(9,1,23304,T);T=a+4|0;X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+8>>3];U=a+8|0;a=c[U>>2]|0;h[a+208>>3]=X;c[S>>2]=c[a+116>>2];a=S+4|0;h[k>>3]=X;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];VLb(9,0,23328,S);X=+h[c[(c[c[T>>2]>>2]|0)+8>>2]>>3];S=c[U>>2]|0;h[S+96>>3]=X;c[R>>2]=c[S+4>>2];S=R+4|0;h[k>>3]=X;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];VLb(9,0,23328,R);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+19512>>3];R=c[U>>2]|0;h[R+273264>>3]=X;c[Q>>2]=c[R+273172>>2];R=Q+4|0;h[k>>3]=X;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];VLb(9,0,23328,Q);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+144>>3];Q=c[U>>2]|0;h[Q+2112>>3]=X;c[P>>2]=c[Q+2020>>2];Q=P+4|0;h[k>>3]=X;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];VLb(9,0,23328,P);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+136>>3];P=c[U>>2]|0;h[P+2e3>>3]=X;c[O>>2]=c[P+1908>>2];P=O+4|0;h[k>>3]=X;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];VLb(9,0,23328,O);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+128>>3];O=c[U>>2]|0;h[O+1888>>3]=X;c[N>>2]=c[O+1796>>2];O=N+4|0;h[k>>3]=X;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];VLb(9,0,23328,N);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+168>>3];N=c[U>>2]|0;h[N+2448>>3]=X;c[M>>2]=c[N+2356>>2];N=M+4|0;h[k>>3]=X;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];VLb(9,0,23328,M);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+160>>3];M=c[U>>2]|0;h[M+2336>>3]=X;c[L>>2]=c[M+2244>>2];M=L+4|0;h[k>>3]=X;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];VLb(9,0,23328,L);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+152>>3];L=c[U>>2]|0;h[L+2224>>3]=X;c[K>>2]=c[L+2132>>2];L=K+4|0;h[k>>3]=X;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];VLb(9,0,23328,K);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+624>>3];K=c[U>>2]|0;h[K+8832>>3]=X;c[J>>2]=c[K+8740>>2];K=J+4|0;h[k>>3]=X;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];VLb(9,0,23328,J);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+616>>3];J=c[U>>2]|0;h[J+8720>>3]=X;c[I>>2]=c[J+8628>>2];J=I+4|0;h[k>>3]=X;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];VLb(9,0,23328,I);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+608>>3];I=c[U>>2]|0;h[I+8608>>3]=X;c[H>>2]=c[I+8516>>2];I=H+4|0;h[k>>3]=X;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];VLb(9,0,23328,H);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+648>>3];H=c[U>>2]|0;h[H+9168>>3]=X;c[G>>2]=c[H+9076>>2];H=G+4|0;h[k>>3]=X;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];VLb(9,0,23328,G);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+640>>3];G=c[U>>2]|0;h[G+9056>>3]=X;c[F>>2]=c[G+8964>>2];G=F+4|0;h[k>>3]=X;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];VLb(9,0,23328,F);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+632>>3];F=c[U>>2]|0;h[F+8944>>3]=X;c[E>>2]=c[F+8852>>2];F=E+4|0;h[k>>3]=X;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];VLb(9,0,23328,E);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+1344>>3];E=c[U>>2]|0;h[E+18912>>3]=X;c[D>>2]=c[E+18820>>2];E=D+4|0;h[k>>3]=X;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];VLb(9,0,23328,D);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+1336>>3];D=c[U>>2]|0;h[D+18800>>3]=X;c[C>>2]=c[D+18708>>2];D=C+4|0;h[k>>3]=X;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];VLb(9,0,23328,C);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+1328>>3];C=c[U>>2]|0;h[C+18688>>3]=X;c[B>>2]=c[C+18596>>2];C=B+4|0;h[k>>3]=X;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];VLb(9,0,23328,B);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+1368>>3];B=c[U>>2]|0;h[B+19248>>3]=X;c[A>>2]=c[B+19156>>2];B=A+4|0;h[k>>3]=X;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];VLb(9,0,23328,A);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+1360>>3];A=c[U>>2]|0;h[A+19136>>3]=X;c[z>>2]=c[A+19044>>2];A=z+4|0;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];VLb(9,0,23328,z);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+1352>>3];z=c[U>>2]|0;h[z+19024>>3]=X;c[y>>2]=c[z+18932>>2];z=y+4|0;h[k>>3]=X;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];VLb(9,0,23328,y);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+2064>>3];y=c[U>>2]|0;h[y+28992>>3]=X;c[x>>2]=c[y+28900>>2];y=x+4|0;h[k>>3]=X;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];VLb(9,0,23328,x);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+2056>>3];x=c[U>>2]|0;h[x+28880>>3]=X;c[w>>2]=c[x+28788>>2];x=w+4|0;h[k>>3]=X;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];VLb(9,0,23328,w);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+2048>>3];w=c[U>>2]|0;h[w+28768>>3]=X;c[v>>2]=c[w+28676>>2];w=v+4|0;h[k>>3]=X;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];VLb(9,0,23328,v);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+2088>>3];v=c[U>>2]|0;h[v+29328>>3]=X;c[u>>2]=c[v+29236>>2];v=u+4|0;h[k>>3]=X;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];VLb(9,0,23328,u);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+2080>>3];u=c[U>>2]|0;h[u+29216>>3]=X;c[t>>2]=c[u+29124>>2];u=t+4|0;h[k>>3]=X;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];VLb(9,0,23328,t);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+2072>>3];t=c[U>>2]|0;h[t+29104>>3]=X;c[s>>2]=c[t+29012>>2];t=s+4|0;h[k>>3]=X;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];VLb(9,0,23328,s);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+2784>>3];s=c[U>>2]|0;h[s+39072>>3]=X;c[r>>2]=c[s+38980>>2];s=r+4|0;h[k>>3]=X;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];VLb(9,0,23328,r);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+2776>>3];r=c[U>>2]|0;h[r+38960>>3]=X;c[q>>2]=c[r+38868>>2];r=q+4|0;h[k>>3]=X;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];VLb(9,0,23328,q);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+2768>>3];q=c[U>>2]|0;h[q+38848>>3]=X;c[p>>2]=c[q+38756>>2];q=p+4|0;h[k>>3]=X;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];VLb(9,0,23328,p);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+2808>>3];p=c[U>>2]|0;h[p+39408>>3]=X;c[o>>2]=c[p+39316>>2];p=o+4|0;h[k>>3]=X;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];VLb(9,0,23328,o);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+2800>>3];o=c[U>>2]|0;h[o+39296>>3]=X;c[n>>2]=c[o+39204>>2];o=n+4|0;h[k>>3]=X;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];VLb(9,0,23328,n);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+2792>>3];n=c[U>>2]|0;h[n+39184>>3]=X;c[m>>2]=c[n+39092>>2];n=m+4|0;h[k>>3]=X;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];VLb(9,0,23328,m);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+3504>>3];m=c[U>>2]|0;h[m+49152>>3]=X;c[l>>2]=c[m+49060>>2];m=l+4|0;h[k>>3]=X;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];VLb(9,0,23328,l);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+3496>>3];l=c[U>>2]|0;h[l+49040>>3]=X;c[j>>2]=c[l+48948>>2];l=j+4|0;h[k>>3]=X;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];VLb(9,0,23328,j);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+3488>>3];j=c[U>>2]|0;h[j+48928>>3]=X;c[g>>2]=c[j+48836>>2];j=g+4|0;h[k>>3]=X;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];VLb(9,0,23328,g);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+3528>>3];g=c[U>>2]|0;h[g+49488>>3]=X;c[f>>2]=c[g+49396>>2];g=f+4|0;h[k>>3]=X;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];VLb(9,0,23328,f);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+3520>>3];f=c[U>>2]|0;h[f+49376>>3]=X;c[e>>2]=c[f+49284>>2];f=e+4|0;h[k>>3]=X;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];VLb(9,0,23328,e);X=+h[(c[(c[c[T>>2]>>2]|0)+8>>2]|0)+3512>>3];T=c[U>>2]|0;h[T+49264>>3]=X;c[d>>2]=c[T+49172>>2];T=d+4|0;h[k>>3]=X;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];VLb(9,0,23328,d);if((c[233596>>2]|0)==0){i=b;return 0}de[c[58528]&511](9);i=b;return 0}function Wya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5072>>3]=0.0;i=i;return}function Xya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5096>>3]=0.0;i=i;return}function Yya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5104>>3]=0.0;i=i;return}function Zya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5128>>3]=0.0;i=i;return}function _ya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5152>>3]=0.0;i=i;return}function $ya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5160>>3]=0.0;i=i;return}function aza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5184>>3]=0.0;i=i;return}function bza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5192>>3]=0.0;i=i;return}function cza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5200>>3]=0.0;i=i;return}function dza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5224>>3]=0.0;i=i;return}function eza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5248>>3]=0.0;i=i;return}function fza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5256>>3]=0.0;i=i;return}function gza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5280>>3]=0.0;i=i;return}function hza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5304>>3]=0.0;i=i;return}function iza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5312>>3]=0.0;i=i;return}function jza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5336>>3]=0.0;i=i;return}function kza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5344>>3]=0.0;i=i;return}function lza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5352>>3]=0.0;i=i;return}function mza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5376>>3]=0.0;i=i;return}function nza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5400>>3]=0.0;i=i;return}function oza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5424>>3]=0.0;i=i;return}function pza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5432>>3]=0.0;i=i;return}function qza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5456>>3]=0.0;i=i;return}function rza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5480>>3]=0.0;i=i;return}function sza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5488>>3]=0.0;i=i;return}function tza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5512>>3]=0.0;i=i;return}function uza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5520>>3]=0.0;i=i;return}function vza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5528>>3]=0.0;i=i;return}function wza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5552>>3]=0.0;i=i;return}function xza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5576>>3]=0.0;i=i;return}function yza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5600>>3]=0.0;i=i;return}function zza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5608>>3]=0.0;i=i;return}function Aza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5632>>3]=0.0;i=i;return}function Bza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5656>>3]=0.0;i=i;return}function Cza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5664>>3]=0.0;i=i;return}function Dza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5688>>3]=0.0;i=i;return}function Eza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5696>>3]=0.0;i=i;return}function Fza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5704>>3]=0.0;i=i;return}function Gza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5728>>3]=0.0;i=i;return}function Hza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5752>>3]=0.0;i=i;return}function Iza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5776>>3]=0.0;i=i;return}function Jza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5784>>3]=0.0;i=i;return}function Kza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5808>>3]=0.0;i=i;return}function Lza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5832>>3]=0.0;i=i;return}function Mza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5840>>3]=0.0;i=i;return}function Nza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5864>>3]=0.0;i=i;return}function Oza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5872>>3]=0.0;i=i;return}function Pza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5880>>3]=0.0;i=i;return}function Qza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5904>>3]=0.0;i=i;return}function Rza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5928>>3]=0.0;i=i;return}function Sza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5952>>3]=0.0;i=i;return}function Tza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5960>>3]=0.0;i=i;return}function Uza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5984>>3]=0.0;i=i;return}function Vza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6008>>3]=0.0;i=i;return}function Wza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6016>>3]=0.0;i=i;return}function Xza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6040>>3]=0.0;i=i;return}function Yza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6048>>3]=0.0;i=i;return}function Zza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6056>>3]=0.0;i=i;return}function _za(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6080>>3]=0.0;i=i;return}function $za(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6104>>3]=0.0;i=i;return}function aAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6152>>3]=0.0;i=i;return}function bAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6128>>3]=0.0;i=i;return}function cAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6168>>3]=0.0;i=i;return}function dAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6160>>3]=0.0;i=i;return}function eAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6176>>3]=0.0;i=i;return}function fAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6184>>3]=0.0;i=i;return}function gAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6192>>3]=0.0;i=i;return}function hAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6216>>3]=0.0;i=i;return}function iAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6240>>3]=0.0;i=i;return}function jAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6248>>3]=0.0;i=i;return}function kAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6544>>3]=0.0;i=i;return}function lAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6256>>3]=0.0;i=i;return}function mAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6264>>3]=0.0;i=i;return}function nAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6288>>3]=0.0;i=i;return}function oAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6312>>3]=0.0;i=i;return}function pAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6320>>3]=0.0;i=i;return}function qAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6568>>3]=0.0;i=i;return}function rAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6328>>3]=0.0;i=i;return}function sAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6336>>3]=0.0;i=i;return}function tAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6360>>3]=0.0;i=i;return}function uAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6384>>3]=0.0;i=i;return}function vAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6392>>3]=0.0;i=i;return}function wAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6592>>3]=0.0;i=i;return}function xAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6400>>3]=0.0;i=i;return}function yAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6408>>3]=0.0;i=i;return}function zAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6432>>3]=0.0;i=i;return}function AAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6456>>3]=0.0;i=i;return}function BAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6464>>3]=0.0;i=i;return}function CAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6616>>3]=0.0;i=i;return}function DAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6472>>3]=0.0;i=i;return}function EAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6480>>3]=0.0;i=i;return}function FAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6504>>3]=0.0;i=i;return}function GAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6528>>3]=0.0;i=i;return}function HAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6536>>3]=0.0;i=i;return}function IAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6640>>3]=0.0;i=i;return}function JAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6664>>3]=0.0;i=i;return}function KAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6688>>3]=0.0;i=i;return}function LAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6712>>3]=0.0;i=i;return}function MAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6736>>3]=0.0;i=i;return}function NAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6760>>3]=0.0;i=i;return}function OAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6552>>3]=0.0;i=i;return}function PAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6576>>3]=0.0;i=i;return}function QAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6600>>3]=0.0;i=i;return}function RAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6624>>3]=0.0;i=i;return}function SAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6648>>3]=0.0;i=i;return}function TAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6672>>3]=0.0;i=i;return}function UAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6696>>3]=0.0;i=i;return}function VAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6720>>3]=0.0;i=i;return}function WAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6744>>3]=0.0;i=i;return}function XAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6768>>3]=0.0;i=i;return}function YAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6560>>3]=0.0;i=i;return}function ZAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6584>>3]=0.0;i=i;return}function _Aa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6608>>3]=0.0;i=i;return}function $Aa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6632>>3]=0.0;i=i;return}function aBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6656>>3]=0.0;i=i;return}function bBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6680>>3]=0.0;i=i;return}function cBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6704>>3]=0.0;i=i;return}function dBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6728>>3]=0.0;i=i;return}function eBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6752>>3]=0.0;i=i;return}function fBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6776>>3]=0.0;i=i;return}function gBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6840>>3]=0.0;i=i;return}function hBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6880>>3]=0.0;i=i;return}function iBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6784>>3]=0.0;i=i;return}function jBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6848>>3]=0.0;i=i;return}function kBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6808>>3]=0.0;i=i;return}function lBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6816>>3]=0.0;i=i;return}function mBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6888>>3]=0.0;i=i;return}function nBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6856>>3]=0.0;i=i;return}function oBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6864>>3]=0.0;i=i;return}function pBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6872>>3]=0.0;i=i;return}function qBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6896>>3]=0.0;i=i;return}function rBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6904>>3]=0.0;i=i;return}function sBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6928>>3]=0.0;i=i;return}function tBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7e3>>3]=0.0;i=i;return}function uBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7024>>3]=0.0;i=i;return}function vBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7032>>3]=0.0;i=i;return}function wBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7040>>3]=0.0;i=i;return}function xBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7064>>3]=0.0;i=i;return}function yBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7048>>3]=0.0;i=i;return}function zBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7072>>3]=0.0;i=i;return}function ABa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7056>>3]=0.0;i=i;return}function BBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7080>>3]=0.0;i=i;return}function CBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7088>>3]=0.0;i=i;return}function DBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7112>>3]=0.0;i=i;return}function EBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7184>>3]=0.0;i=i;return}function FBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7208>>3]=0.0;i=i;return}function GBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7216>>3]=0.0;i=i;return}function HBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7224>>3]=0.0;i=i;return}function IBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7248>>3]=0.0;i=i;return}function JBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7232>>3]=0.0;i=i;return}function KBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7256>>3]=0.0;i=i;return}function LBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7240>>3]=0.0;i=i;return}



function iv(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0,J=0,K=0,L=0.0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0.0,T=0,V=0,X=0.0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0,ca=0.0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0,za=0,Aa=0,Ba=0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0.0;e=i;f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;j=c[(b+416|0)>>2]|0;k=+h[f+168>>3];l=+h[(f+160|0)>>3];m=+h[j+17856>>3];n=+h[(f+152|0)>>3];o=c[(d+36|0)>>2]|0;h[o>>3]=+h[j+25192>>3]*(+h[f+7952>>3]*+h[j+18840>>3]+(k*(l*+h[j+17864>>3]-k*m)-n*(m*n-l*+h[j+17848>>3])));l=+h[(f+152|0)>>3]*+h[(f+160|0)>>3];h[o+8>>3]=l*5.0e-4+l*-.006;Iec(o+16|0,0,304)|0;o=(ZOb(+U(+(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+20144>>3])),1.0e-10)|0)<<24>>24==0;f=c[c[(b+4|0)>>2]>>2]|0;j=c[f+8>>2]|0;do{if(o){l=+h[j+20064>>3];if(+h[j+20144>>3]!=0.0){p=-l;q=+h[j+20144>>3];r=5;break}if(l==-0.0){s=j;t=f;u=-l;break}n=-l/+$Lb(c[b+536>>2]|0,+h[j+20144>>3],8616,10768,+h[f>>3],(a[b+319|0]|0)!=0|0);v=c[c[(b+4|0)>>2]>>2]|0;s=c[v+8>>2]|0;t=v;u=n}else{p=-+h[j+20064>>3];q=1.0e-10;r=5}}while(0);if((r|0)==5){s=j;t=f;u=p/q}f=c[(d+36|0)>>2]|0;h[f+320>>3]=u;j=s+2072|0;c[(f+328|0)+0>>2]=0;c[(f+328|0)+4>>2]=0;c[(f+328|0)+8>>2]=0;c[(f+328|0)+12>>2]=0;c[(f+328|0)+16>>2]=0;c[(f+328|0)+20>>2]=0;c[(f+328|0)+24>>2]=0;c[(f+328|0)+28>>2]=0;o=s+2080|0;u=+h[j>>3]*+h[o>>3];h[f+360>>3]=u*5.0e-4+u*-.006;h[f+368>>3]=0.0;v=c[(b+416|0)>>2]|0;u=+h[o>>3];q=+h[j>>3];p=+h[v+8800>>3];n=+h[s+2088>>3];h[f+376>>3]=+h[v+22096>>3]*(+h[s+7328>>3]*+h[v+18840>>3]+(u*(q*+h[v+8808>>3]-u*p)-n*(p*n-q*+h[v+8816>>3])));q=+h[s+16>>3];h[f+384>>3]=+h[s+2144>>3]*+h[s+7320>>3]*q- +h[s+2136>>3]*q*+h[s+7344>>3];j=s+4664|0;o=s+8832|0;w=s+4672|0;x=s+8840|0;h[f+392>>3]=-(+h[w>>3]*+h[x>>3])- +h[j>>3]*+h[o>>3];q=+h[s+20080>>3];n=+h[x>>3];p=+h[o>>3];u=q*(+h[w>>3]*p- +h[j>>3]*n)- +h[s+20808>>3]*(p*+h[s+2152>>3]-n*+h[s+2160>>3]);do{if(q*q!=0.0){y=v;z=u/(q*q)}else{if(u==0.0){y=v;z=u;break}n=u/+$Lb(c[b+536>>2]|0,q*q,10776,10768,+h[t>>3],(a[b+319|0]|0)!=0|0);y=c[(b+416|0)>>2]|0;z=n}}while(0);t=c[(d+36|0)>>2]|0;h[t+400>>3]=z;v=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[t+408>>3]=-(+h[(v+2088|0)>>3]*+h[v+7320>>3]*+h[(v+16|0)>>3]);s=y+18840|0;z=+h[(v+2072|0)>>3];q=+h[(v+2088|0)>>3];j=y+8800|0;w=y+8816|0;u=+h[w>>3];n=+h[(v+2080|0)>>3];o=y+8808|0;x=y+22096|0;h[t+416>>3]=+h[x>>3]*(+h[v+7376>>3]*+h[s>>3]+(z*(q*+h[j>>3]-z*u)-n*(u*n-q*+h[o>>3])));c[(t+424|0)+0>>2]=0;c[(t+424|0)+4>>2]=0;c[(t+424|0)+8>>2]=0;c[(t+424|0)+12>>2]=0;q=+h[(v+2080|0)>>3]*+h[(v+2088|0)>>3];h[t+440>>3]=q*.006+q*-5.0e-4;c[(t+448|0)+0>>2]=0;c[(t+448|0)+4>>2]=0;c[(t+448|0)+8>>2]=0;c[(t+448|0)+12>>2]=0;q=+h[(v+2088|0)>>3]*+h[(v+2072|0)>>3];h[t+464>>3]=q*.006+q*-.006;h[t+472>>3]=+h[v+4640>>3]*+h[v+8832>>3]+ +h[v+4648>>3]*+h[v+8840>>3];h[t+480>>3]=+h[(v+2088|0)>>3]*+h[v+7344>>3]*+h[(v+16|0)>>3];q=+h[(v+2088|0)>>3];n=+h[(v+2080|0)>>3];u=+h[o>>3];z=+h[(v+2072|0)>>3];o=c[(d+36|0)>>2]|0;h[o+488>>3]=+h[x>>3]*(+h[v+7352>>3]*+h[s>>3]+(q*(n*+h[w>>3]-q*u)-z*(u*z-n*+h[j>>3])));j=c[(b+416|0)>>2]|0;n=+h[j+21880>>3];w=c[c[(b+4|0)>>2]>>2]|0;s=c[w+8>>2]|0;z=+h[s+16>>3];u=-(z*+h[s+7304>>3])-z*(+h[s+14920>>3]*+h[s+8856>>3]+ +h[s+14912>>3]*+h[s+8864>>3]);do{if(n!=0.0){B=s;C=w;D=j;E=o;F=u/n}else{if(u==0.0){B=s;C=w;D=j;E=o;F=u;break}z=u/+$Lb(c[b+536>>2]|0,n,8736,10768,+h[w>>3],(a[b+319|0]|0)!=0|0);v=c[c[(b+4|0)>>2]>>2]|0;B=c[v+8>>2]|0;C=v;D=c[(b+416|0)>>2]|0;E=c[(d+36|0)>>2]|0;F=z}}while(0);h[E+496>>3]=F;h[E+504>>3]=0.0;h[E+512>>3]=+h[D+18840>>3]*+h[D+22296>>3]*.8660254037844387;w=B+16|0;o=E+520|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;F=+h[w>>3];n=+h[D+21880>>3];u=+h[B+14904>>3]*+h[B+8856>>3]+(+h[B+14896>>3]*+h[B+8864>>3]+ +h[B+7312>>3]);do{if(n!=0.0){G=B;J=C;K=E;L=u/n}else{if(u==0.0){G=B;J=C;K=E;L=u;break}z=u/+$Lb(c[b+536>>2]|0,n,8736,10768,+h[C>>3],(a[b+319|0]|0)!=0|0);D=c[c[(b+4|0)>>2]>>2]|0;G=c[D+8>>2]|0;J=D;K=c[(d+36|0)>>2]|0;L=z}}while(0);h[K+544>>3]=F*L;C=G+8888|0;E=K+552|0;B=E+40|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(B|0));L=+h[C>>3];F=+h[G+8896>>3];h[K+592>>3]=(L*L+F*F)*2.0;F=+h[G+21e3>>3];h[K+600>>3]=F*F*2.0;h[K+608>>3]=0.0;F=+h[G+21024>>3];L=+W(+(+h[G+20096>>3]),1.5);do{if(L!=0.0){M=G;N=K;O=F*F*-.25/L}else{if(F*F*-.25==0.0){M=G;N=K;O=F*F*-.25;break}n=F*F*-.25/+$Lb(c[b+536>>2]|0,L,10840,10768,+h[J>>3],(a[b+319|0]|0)!=0|0);M=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;N=c[(d+36|0)>>2]|0;O=n}}while(0);h[N+616>>3]=O;J=M+16|0;O=+h[J>>3];K=c[(b+416|0)>>2]|0;h[N+624>>3]=+h[M+14912>>3]*O*+h[K+6960>>3]*-O+ +h[M+14896>>3]*O*+h[K+6968>>3]*-O;G=M+16200|0;O=+h[J>>3];C=M+16224|0;h[N+632>>3]=+h[G>>3]*O*+h[K+272>>3]*-O+ +h[C>>3]*O*+h[K+280>>3]*-O;O=+h[J>>3];h[N+640>>3]=+h[G>>3]*O*+h[K+832>>3]*-O+ +h[C>>3]*O*+h[K+840>>3]*-O;O=+h[J>>3];h[N+648>>3]=+h[G>>3]*O*+h[K+3848>>3]*-O+ +h[C>>3]*O*+h[K+3856>>3]*-O;O=+h[J>>3];h[N+656>>3]=+h[G>>3]*O*+h[K+6864>>3]*-O+ +h[C>>3]*O*+h[K+6872>>3]*-O;O=+h[J>>3];J=c[(d+36|0)>>2]|0;h[J+664>>3]=+h[G>>3]*O*+h[K+9880>>3]*-O+ +h[C>>3]*O*+h[K+9888>>3]*-O;K=c[c[(b+4|0)>>2]>>2]|0;C=c[K+8>>2]|0;O=+h[(C+16|0)>>3];G=c[(b+416|0)>>2]|0;h[J+672>>3]=+h[(C+16200|0)>>3]*O*+h[G+12896>>3]*-O+ +h[(C+16224|0)>>3]*O*+h[G+12904>>3]*-O;O=+h[(C+16|0)>>3];h[J+680>>3]=+h[(C+16200|0)>>3]*O*+h[G+16488>>3]*-O+ +h[(C+16224|0)>>3]*O*+h[G+16496>>3]*-O;O=+h[(C+16|0)>>3];h[J+688>>3]=+h[C+15064>>3]*O*+h[G+16008>>3]*-O+ +h[(C+15048|0)>>3]*O*+h[G+16016>>3]*-O;E=J+696|0;B=E+48|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(B|0));O=+h[(C+16|0)>>3];L=+h[G+24976>>3];F=+h[(C+15048|0)>>3]*+h[C+8064>>3]+(+h[C+15040>>3]*+h[C+8072>>3]+ +h[C+7912>>3]);do{if(L!=0.0){P=C;Q=K;R=J;S=F/L}else{if(F==0.0){P=C;Q=K;R=J;S=F;break}n=F/+$Lb(c[b+536>>2]|0,L,8464,10768,+h[K>>3],(a[b+319|0]|0)!=0|0);G=c[c[(b+4|0)>>2]>>2]|0;P=c[G+8>>2]|0;Q=G;R=c[(d+36|0)>>2]|0;S=n}}while(0);h[R+744>>3]=O*S;S=+h[P+19600>>3];O=+h[P+8048>>3];L=+h[P+8040>>3];F=S*(+h[P+4888>>3]*L- +h[P+4880>>3]*O)- +h[P+20832>>3]*(L*+h[P+232>>3]-O*+h[P+240>>3]);do{if(S*S!=0.0){T=P;V=R;X=F/(S*S)}else{if(F==0.0){T=P;V=R;X=F;break}O=F/+$Lb(c[b+536>>2]|0,S*S,10896,10768,+h[Q>>3],(a[b+319|0]|0)!=0|0);T=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;V=c[(d+36|0)>>2]|0;X=O}}while(0);h[V+752>>3]=X;Q=T+168|0;h[V+760>>3]=-(+h[Q>>3]*+h[T+7920>>3]*+h[T+16>>3]);R=c[(b+416|0)>>2]|0;X=+h[T+160>>3];P=T+152|0;S=+h[P>>3];F=+h[R+17848>>3];O=+h[Q>>3];h[V+768>>3]=+h[R+25192>>3]*(+h[T+7928>>3]*+h[R+18840>>3]+(X*(S*+h[R+17856>>3]-X*F)-O*(F*O-S*+h[R+17864>>3])));E=V+776|0;B=E+80|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(B|0));S=+h[Q>>3]*+h[P>>3];h[V+856>>3]=S*.006+S*-.006;P=T+19664|0;T=V+864|0;c[T+0>>2]=0;c[T+4>>2]=0;c[T+8>>2]=0;c[T+12>>2]=0;c[T+16>>2]=0;c[T+20>>2]=0;c[T+24>>2]=0;c[T+28>>2]=0;T=(ZOb(+U(+(+h[P>>3])),1.0e-10)|0)<<24>>24==0;P=c[c[(b+4|0)>>2]>>2]|0;V=c[P+8>>2]|0;do{if(T){S=+h[V+19584>>3];if(+h[V+19664>>3]!=0.0){Y=-S;Z=+h[V+19664>>3];r=36;break}if(S==-0.0){_=V;$=-S;break}O=-S/+$Lb(c[b+536>>2]|0,+h[V+19664>>3],9056,10768,+h[P>>3],(a[b+319|0]|0)!=0|0);_=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;$=O}else{Y=-+h[V+19584>>3];Z=1.0e-10;r=36}}while(0);if((r|0)==36){_=V;$=Y/Z}V=c[(d+36|0)>>2]|0;h[V+896>>3]=$;h[V+904>>3]=0.0;P=c[(b+416|0)>>2]|0;$=+h[_+152>>3];T=_+168|0;Z=+h[T>>3];Y=+h[P+17864>>3];Q=_+160|0;O=+h[Q>>3];h[V+912>>3]=+h[P+25192>>3]*(+h[_+7976>>3]*+h[P+18840>>3]+($*(Z*+h[P+17848>>3]-$*Y)-O*(Y*O-Z*+h[P+17856>>3])));Z=+h[Q>>3]*+h[T>>3];h[V+920>>3]=Z*.006+Z*-5.0e-4;Q=_+8040|0;R=_+8048|0;h[V+928>>3]=-(+h[_+4888>>3]*+h[R>>3])- +h[_+4880>>3]*+h[Q>>3];K=_+16|0;Z=+h[K>>3];J=_+7944|0;h[V+936>>3]=+h[_+224>>3]*+h[_+7920>>3]*Z- +h[_+216>>3]*Z*+h[J>>3];h[V+944>>3]=+h[_+4856>>3]*+h[Q>>3]+ +h[_+4864>>3]*+h[R>>3];h[V+952>>3]=+h[T>>3]*+h[J>>3]*+h[K>>3];Z=+h[P+24976>>3];P=c[c[(b+4|0)>>2]>>2]|0;K=c[P+8>>2]|0;O=+h[K+16>>3];Y=-(O*+h[K+7904>>3])-O*(+h[K+15064>>3]*+h[K+8064>>3]+ +h[K+15056>>3]*+h[K+8072>>3]);do{if(Z!=0.0){aa=K;ba=P;ca=Y/Z}else{if(Y==0.0){aa=K;ba=P;ca=Y;break}O=Y/+$Lb(c[b+536>>2]|0,Z,8464,10768,+h[P>>3],(a[b+319|0]|0)!=0|0);J=c[c[(b+4|0)>>2]>>2]|0;aa=c[J+8>>2]|0;ba=J;ca=O}}while(0);P=c[(d+36|0)>>2]|0;h[P+960>>3]=ca;K=c[(b+416|0)>>2]|0;h[P+968>>3]=+h[K+18840>>3]*+h[K+25392>>3]*.8660254037844387;J=aa+21144|0;c[(P+976|0)+0>>2]=0;c[(P+976|0)+4>>2]=0;c[(P+976|0)+8>>2]=0;c[(P+976|0)+12>>2]=0;ca=+h[J>>3];h[P+992>>3]=ca*ca*2.0;h[P+1e3>>3]=0.0;ca=+h[aa+21168>>3];Z=+W(+(+h[aa+19616>>3]),1.5);do{if(Z!=0.0){da=K;ea=aa;fa=ba;ga=P;ha=ca*ca*-.25/Z}else{if(ca*ca*-.25==0.0){da=K;ea=aa;fa=ba;ga=P;ha=ca*ca*-.25;break}Y=ca*ca*-.25/+$Lb(c[b+536>>2]|0,Z,10960,10768,+h[ba>>3],(a[b+319|0]|0)!=0|0);J=c[c[(b+4|0)>>2]>>2]|0;da=c[(b+416|0)>>2]|0;ea=c[J+8>>2]|0;fa=J;ga=c[(d+36|0)>>2]|0;ha=Y}}while(0);h[ga+1008>>3]=ha;ha=+h[ea+8096>>3];Z=+h[ea+8104>>3];h[ga+1016>>3]=(ha*ha+Z*Z)*2.0;h[ga+1024>>3]=0.0;ba=ea+16|0;Z=+h[ba>>3];h[ga+1032>>3]=+h[ea+16200>>3]*Z*+h[da+13472>>3]*-Z+ +h[ea+16224>>3]*Z*+h[da+13480>>3]*-Z;Z=+h[ba>>3];P=ea+15e3|0;h[ga+1040>>3]=+h[ea+15016>>3]*Z*+h[da+12992>>3]*-Z+ +h[P>>3]*Z*+h[da+13e3>>3]*-Z;E=ga+1048|0;B=E+48|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(B|0));Z=+h[ba>>3];ha=+h[da+23944>>3];ca=+h[P>>3]*+h[ea+8296>>3]+(+h[ea+14992>>3]*+h[ea+8304>>3]+ +h[ea+7680>>3]);do{if(ha!=0.0){ia=ea;ja=fa;ka=ga;la=ca/ha}else{if(ca==0.0){ia=ea;ja=fa;ka=ga;la=ca;break}Y=ca/+$Lb(c[b+536>>2]|0,ha,9232,10768,+h[fa>>3],(a[b+319|0]|0)!=0|0);P=c[c[(b+4|0)>>2]>>2]|0;ia=c[P+8>>2]|0;ja=P;ka=c[(d+36|0)>>2]|0;la=Y}}while(0);h[ka+1096>>3]=Z*la;la=+h[ia+19760>>3];Z=+h[ia+8280>>3];ha=+h[ia+8272>>3];ca=la*(+h[ia+4816>>3]*ha- +h[ia+4808>>3]*Z)- +h[ia+20824>>3]*(ha*+h[ia+712>>3]-Z*+h[ia+720>>3]);do{if(la*la!=0.0){ma=ia;na=ka;oa=ca/(la*la)}else{if(ca==0.0){ma=ia;na=ka;oa=ca;break}Z=ca/+$Lb(c[b+536>>2]|0,la*la,11016,10768,+h[ja>>3],(a[b+319|0]|0)!=0|0);ma=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;na=c[(d+36|0)>>2]|0;oa=Z}}while(0);h[na+1104>>3]=oa;ja=ma+648|0;h[na+1112>>3]=-(+h[ja>>3]*+h[ma+7688>>3]*+h[ma+16>>3]);ka=c[(b+416|0)>>2]|0;ia=ma+640|0;oa=+h[ia>>3];fa=ma+632|0;la=+h[fa>>3];ca=+h[ka+14832>>3];Z=+h[ja>>3];h[na+1120>>3]=+h[ka+24160>>3]*(+h[ma+7696>>3]*+h[ka+18840>>3]+(oa*(la*+h[ka+14840>>3]-oa*ca)-Z*(ca*Z-la*+h[ka+14848>>3])));E=na+1128|0;B=E+56|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(B|0));la=+h[fa>>3]*+h[ia>>3];h[na+1184>>3]=la*5.0e-4+la*-.006;ia=ma+19824|0;E=na+1192|0;B=E+96|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(B|0));na=(ZOb(+U(+(+h[ia>>3])),1.0e-10)|0)<<24>>24==0;ia=c[c[(b+4|0)>>2]>>2]|0;ma=c[ia+8>>2]|0;do{if(na){la=+h[ma+19744>>3];if(+h[ma+19824>>3]!=0.0){pa=-la;qa=+h[ma+19824>>3];r=59;break}if(la==-0.0){ra=ma;sa=-la;break}Z=-la/+$Lb(c[b+536>>2]|0,+h[ma+19824>>3],9440,10768,+h[ia>>3],(a[b+319|0]|0)!=0|0);ra=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;sa=Z}else{pa=-+h[ma+19744>>3];qa=1.0e-10;r=59}}while(0);if((r|0)==59){ra=ma;sa=pa/qa}ma=c[(d+36|0)>>2]|0;h[ma+1288>>3]=sa;ia=ra+648|0;E=ma+1296|0;B=E+48|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(B|0));na=ra+632|0;sa=+h[ia>>3]*+h[na>>3];h[ma+1344>>3]=sa*.006+sa*-.006;h[ma+1352>>3]=0.0;fa=c[(b+416|0)>>2]|0;sa=+h[na>>3];qa=+h[ia>>3];pa=+h[(fa+14848|0)>>3];na=ra+640|0;Z=+h[na>>3];h[ma+1360>>3]=+h[(fa+24160|0)>>3]*(+h[ra+7744>>3]*+h[(fa+18840|0)>>3]+(sa*(qa*+h[(fa+14832|0)>>3]-sa*pa)-Z*(pa*Z-qa*+h[(fa+14840|0)>>3])));qa=+h[na>>3]*+h[ia>>3];h[ma+1368>>3]=qa*.006+qa*-5.0e-4;h[ma+1376>>3]=-(+h[ra+4816>>3]*+h[ra+8280>>3])- +h[ra+4808>>3]*+h[ra+8272>>3];qa=+h[ra+16>>3];h[ma+1384>>3]=+h[ra+704>>3]*+h[ra+7688>>3]*qa- +h[ra+696>>3]*qa*+h[ra+7712>>3];ra=c[c[(b+4|0)>>2]>>2]|0;ma=c[ra+8>>2]|0;qa=+h[(ma+648|0)>>3];Z=+h[ma+640>>3];pa=+h[(fa+14840|0)>>3];sa=+h[ma+632>>3];ia=c[(d+36|0)>>2]|0;h[ia+1392>>3]=+h[(fa+24160|0)>>3]*(+h[ma+7720>>3]*+h[(fa+18840|0)>>3]+(qa*(Z*+h[(fa+14848|0)>>3]-qa*pa)-sa*(pa*sa-Z*+h[(fa+14832|0)>>3])));h[ia+1400>>3]=+h[ma+4784>>3]*+h[ma+8272>>3]+ +h[ma+4792>>3]*+h[ma+8280>>3];h[ia+1408>>3]=+h[(ma+648|0)>>3]*+h[ma+7712>>3]*+h[(ma+16|0)>>3];fa=c[(b+416|0)>>2]|0;Z=+h[fa+23944>>3];sa=+h[(ma+16|0)>>3];pa=-(sa*+h[ma+7672>>3])-sa*(+h[ma+15016>>3]*+h[ma+8296>>3]+ +h[ma+15008>>3]*+h[ma+8304>>3]);do{if(Z!=0.0){ta=ma;ua=ra;va=fa;wa=ia;xa=pa/Z}else{if(pa==0.0){ta=ma;ua=ra;va=fa;wa=ia;xa=pa;break}sa=pa/+$Lb(c[b+536>>2]|0,Z,9232,10768,+h[ra>>3],(a[b+319|0]|0)!=0|0);na=c[c[(b+4|0)>>2]>>2]|0;ta=c[na+8>>2]|0;ua=na;va=c[(b+416|0)>>2]|0;wa=c[(d+36|0)>>2]|0;xa=sa}}while(0);h[wa+1416>>3]=xa;h[wa+1424>>3]=+h[va+18840>>3]*+h[va+24360>>3]*.8660254037844387;ra=ta+21096|0;ia=wa+1432|0;c[ia+0>>2]=0;c[ia+4>>2]=0;c[ia+8>>2]=0;c[ia+12>>2]=0;xa=+h[ra>>3];h[wa+1448>>3]=xa*xa*2.0;h[wa+1456>>3]=0.0;xa=+h[ta+21120>>3];Z=+W(+(+h[ta+19776>>3]),1.5);do{if(Z!=0.0){ya=va;za=ta;Aa=ua;Ba=wa;Ca=xa*xa*-.25/Z}else{if(xa*xa*-.25==0.0){ya=va;za=ta;Aa=ua;Ba=wa;Ca=xa*xa*-.25;break}pa=xa*xa*-.25/+$Lb(c[b+536>>2]|0,Z,11080,10768,+h[ua>>3],(a[b+319|0]|0)!=0|0);ra=c[c[(b+4|0)>>2]>>2]|0;ya=c[(b+416|0)>>2]|0;za=c[ra+8>>2]|0;Aa=ra;Ba=c[(d+36|0)>>2]|0;Ca=pa}}while(0);h[Ba+1464>>3]=Ca;Ca=+h[za+8328>>3];Z=+h[za+8336>>3];h[Ba+1472>>3]=(Ca*Ca+Z*Z)*2.0;h[Ba+1480>>3]=0.0;ua=za+16|0;Z=+h[ua>>3];h[Ba+1488>>3]=+h[za+16200>>3]*Z*+h[ya+10456>>3]*-Z+ +h[za+16224>>3]*Z*+h[ya+10464>>3]*-Z;Z=+h[ua>>3];wa=za+14952|0;h[Ba+1496>>3]=+h[za+14968>>3]*Z*+h[ya+9976>>3]*-Z+ +h[wa>>3]*Z*+h[ya+9984>>3]*-Z;h[Ba+1504>>3]=0.0;Z=+h[ua>>3];Ca=+h[ya+22912>>3];xa=+h[wa>>3]*+h[za+8576>>3]+(+h[za+14944>>3]*+h[za+8584>>3]+ +h[za+7496>>3]);do{if(Ca!=0.0){Da=za;Ea=Aa;Fa=Ba;Ga=xa/Ca}else{if(xa==0.0){Da=za;Ea=Aa;Fa=Ba;Ga=xa;break}pa=xa/+$Lb(c[b+536>>2]|0,Ca,9616,10768,+h[Aa>>3],(a[b+319|0]|0)!=0|0);wa=c[c[(b+4|0)>>2]>>2]|0;Da=c[wa+8>>2]|0;Ea=wa;Fa=c[(d+36|0)>>2]|0;Ga=pa}}while(0);h[Fa+1512>>3]=Z*Ga;Ga=+h[Da+19920>>3];Z=+h[Da+8560>>3];c[e+8>>2]=b;c[e+16>>2]=d;c[e+952>>2]=Da;c[e+960>>2]=Ea;c[e+968>>2]=Fa;g[e+984>>2]=Ga;g[e+992>>2]=Z;c[e+4424>>2]=E;c[e+4432>>2]=r;c[e+4448>>2]=B;c[e+4456>>2]=0;c[e+4460>>2]=0;_setLinearVectorb1039$0(e);E=c[e+4424>>2]|0;r=c[e+4432>>2]|0;B=c[e+4448>>2]|0;H=c[e+4456>>2]|0;A=c[e+4460>>2]|0;I=+g[e+4460>>2];c[e+4456>>2]=0;c[e+4460>>2]=0;if((H|0)==5){return}}function _setLinearVectorb1039$0(b){b=b|0;var d=0,e=0,f=0,j=0,k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0.0,r=0.0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,X=0.0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0,Da=0,Ea=0.0;d=c[b+8>>2]|0;e=c[b+16>>2]|0;f=c[b+952>>2]|0;j=c[b+960>>2]|0;k=c[b+968>>2]|0;l=+g[b+984>>2];m=+g[b+992>>2];n=c[b+4424>>2]|0;o=c[b+4432>>2]|0;p=c[b+4448>>2]|0;a:do{q=+h[f+8552>>3];r=l*(+h[f+4744>>3]*q- +h[f+4736>>3]*m)- +h[f+20816>>3]*(q*+h[f+1432>>3]-m*+h[f+1440>>3]);do{if(l*l!=0.0){s=f;t=k;u=r/(l*l)}else{if(r==0.0){s=f;t=k;u=r;break}q=r/+$Lb(c[d+536>>2]|0,l*l,11136,10768,+h[j>>3],(a[d+319|0]|0)!=0|0);s=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;t=c[(e+36|0)>>2]|0;u=q}}while(0);h[t+1520>>3]=u;v=s+1368|0;h[t+1528>>3]=-(+h[v>>3]*+h[s+7504>>3]*+h[s+16>>3]);w=c[(d+416|0)>>2]|0;x=s+1360|0;r=+h[x>>3];y=s+1352|0;q=+h[y>>3];z=+h[w+11816>>3];A=+h[v>>3];h[t+1536>>3]=+h[w+23128>>3]*(+h[s+7512>>3]*+h[w+18840>>3]+(r*(q*+h[w+11824>>3]-r*z)-A*(z*A-q*+h[w+11832>>3])));n=t+1544|0;p=n+56|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));q=+h[y>>3]*+h[x>>3];h[t+1600>>3]=q*5.0e-4+q*-.006;w=s+19984|0;n=t+1608|0;p=n+104|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));x=(ZOb(+U(+(+h[w>>3])),1.0e-10)|0)<<24>>24==0;y=c[c[(d+4|0)>>2]>>2]|0;v=c[y+8>>2]|0;do{if(x){q=+h[v+19904>>3];if(+h[v+19984>>3]!=0.0){B=-q;C=+h[v+19984>>3];o=82;break}if(q==-0.0){D=v;E=-q;break}A=-q/+$Lb(c[d+536>>2]|0,+h[v+19984>>3],9824,10768,+h[y>>3],(a[d+319|0]|0)!=0|0);D=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;E=A}else{B=-+h[v+19904>>3];C=1.0e-10;o=82}}while(0);if((o|0)==82){D=v;E=B/C}y=c[(e+36|0)>>2]|0;h[y+1712>>3]=E;x=D+1368|0;n=y+1720|0;p=n+48|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));v=D+1352|0;A=+h[x>>3]*+h[v>>3];h[y+1768>>3]=A*.006+A*-.006;h[y+1776>>3]=0.0;w=c[(d+416|0)>>2]|0;A=+h[v>>3];q=+h[x>>3];z=+h[(w+11832|0)>>3];v=D+1360|0;r=+h[v>>3];h[y+1784>>3]=+h[(w+23128|0)>>3]*(+h[D+7560>>3]*+h[(w+18840|0)>>3]+(A*(q*+h[(w+11816|0)>>3]-A*z)-r*(z*r-q*+h[(w+11824|0)>>3])));q=+h[v>>3]*+h[x>>3];h[y+1792>>3]=q*.006+q*-5.0e-4;h[y+1800>>3]=-(+h[D+4744>>3]*+h[D+8560>>3])- +h[D+4736>>3]*+h[D+8552>>3];q=+h[D+16>>3];h[y+1808>>3]=+h[D+1424>>3]*+h[D+7504>>3]*q- +h[D+1416>>3]*q*+h[D+7528>>3];v=c[c[(d+4|0)>>2]>>2]|0;F=c[v+8>>2]|0;q=+h[(F+1368|0)>>3];r=+h[F+1360>>3];z=+h[(w+11824|0)>>3];A=+h[F+1352>>3];G=c[(e+36|0)>>2]|0;h[G+1816>>3]=+h[(w+23128|0)>>3]*(+h[F+7536>>3]*+h[(w+18840|0)>>3]+(q*(r*+h[(w+11832|0)>>3]-q*z)-A*(z*A-r*+h[(w+11816|0)>>3])));h[G+1824>>3]=+h[F+4712>>3]*+h[F+8552>>3]+ +h[F+4720>>3]*+h[F+8560>>3];h[G+1832>>3]=+h[(F+1368|0)>>3]*+h[F+7528>>3]*+h[(F+16|0)>>3];r=+h[(c[(d+416|0)>>2]|0)+22912>>3];A=+h[(F+16|0)>>3];z=-(A*+h[F+7488>>3])-A*(+h[F+14968>>3]*+h[F+8576>>3]+ +h[F+14960>>3]*+h[F+8584>>3]);do{if(r!=0.0){H=F;I=v;J=G;K=z/r}else{if(z==0.0){H=F;I=v;J=G;K=z;break}A=z/+$Lb(c[d+536>>2]|0,r,9616,10768,+h[v>>3],(a[d+319|0]|0)!=0|0);w=c[c[(d+4|0)>>2]>>2]|0;H=c[w+8>>2]|0;I=w;J=c[(e+36|0)>>2]|0;K=A}}while(0);h[J+1840>>3]=K;h[J+1848>>3]=0.0;r=+h[H+8608>>3];z=+h[H+8616>>3];h[J+1856>>3]=(r*r+z*z)*2.0;z=+h[H+21048>>3];h[J+1864>>3]=z*z*2.0;h[J+1872>>3]=0.0;z=+h[H+21072>>3];r=+W(+(+h[H+19936>>3]),1.5);do{if(r!=0.0){L=H;M=J;N=z*z*-.25/r}else{if(z*z*-.25==0.0){L=H;M=J;N=z*z*-.25;break}A=z*z*-.25/+$Lb(c[d+536>>2]|0,r,11200,10768,+h[I>>3],(a[d+319|0]|0)!=0|0);L=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;M=c[(e+36|0)>>2]|0;N=A}}while(0);h[M+1880>>3]=N;v=M+1888|0;c[v+0>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;v=c[(d+416|0)>>2]|0;h[M+1904>>3]=+h[v+18840>>3]*+h[v+23328>>3]*.8660254037844387;G=L+16200|0;n=M+1912|0;p=n+40|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));F=L+16|0;r=+h[F>>3];y=L+16224|0;h[M+1952>>3]=+h[G>>3]*r*+h[v+7440>>3]*-r+ +h[y>>3]*r*+h[v+7448>>3]*-r;r=+h[F>>3];h[M+1960>>3]=+h[L+14920>>3]*r*+h[v+6960>>3]*-r+ +h[L+14904>>3]*r*+h[v+6968>>3]*-r;r=+h[F>>3];h[M+1968>>3]=+h[G>>3]*r*+h[v+4424>>3]*-r+ +h[y>>3]*r*+h[v+4432>>3]*-r;r=+h[F>>3];F=c[(e+36|0)>>2]|0;h[F+1976>>3]=+h[L+14872>>3]*r*+h[v+3944>>3]*-r+ +h[L+14856>>3]*r*+h[v+3952>>3]*-r;n=F+1984|0;p=n+48|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));v=c[c[(d+4|0)>>2]>>2]|0;G=c[v+8>>2]|0;r=+h[G+16>>3];z=+h[(c[(d+416|0)>>2]|0)+20848>>3];A=+h[G+14856>>3]*+h[G+9136>>3]+(+h[G+14848>>3]*+h[G+9144>>3]+ +h[G+7128>>3]);do{if(z!=0.0){O=G;P=v;Q=F;R=A/z}else{if(A==0.0){O=G;P=v;Q=F;R=A;break}q=A/+$Lb(c[d+536>>2]|0,z,1e4,10768,+h[v>>3],(a[d+319|0]|0)!=0|0);y=c[c[(d+4|0)>>2]>>2]|0;O=c[y+8>>2]|0;P=y;Q=c[(e+36|0)>>2]|0;R=q}}while(0);h[Q+2032>>3]=r*R;z=+h[O+20240>>3];A=+h[O+9120>>3];q=+h[O+9112>>3];S=z*(+h[O+4600>>3]*q- +h[O+4592>>3]*A)- +h[O+20800>>3]*(q*+h[O+2872>>3]-A*+h[O+2880>>3]);do{if(z*z!=0.0){T=O;V=Q;X=S/(z*z)}else{if(S==0.0){T=O;V=Q;X=S;break}A=S/+$Lb(c[d+536>>2]|0,z*z,11256,10768,+h[P>>3],(a[d+319|0]|0)!=0|0);T=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;V=c[(e+36|0)>>2]|0;X=A}}while(0);h[V+2040>>3]=X;v=T+2808|0;h[V+2048>>3]=-(+h[v>>3]*+h[T+7136>>3]*+h[T+16>>3]);F=c[(d+416|0)>>2]|0;G=T+2800|0;z=+h[G>>3];y=T+2792|0;S=+h[y>>3];r=+h[F+5784>>3];A=+h[v>>3];h[V+2056>>3]=+h[F+21064>>3]*(+h[T+7144>>3]*+h[F+18840>>3]+(z*(S*+h[F+5792>>3]-z*r)-A*(r*A-S*+h[F+5800>>3])));n=V+2064|0;p=n+56|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));S=+h[y>>3]*+h[G>>3];h[V+2120>>3]=S*5.0e-4+S*-.006;F=T+20304|0;n=V+2128|0;p=n+96|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));G=(ZOb(+U(+(+h[F>>3])),1.0e-10)|0)<<24>>24==0;y=c[c[(d+4|0)>>2]>>2]|0;v=c[y+8>>2]|0;do{if(G){S=+h[v+20224>>3];if(+h[v+20304>>3]!=0.0){Y=-S;Z=+h[v+20304>>3];o=105;break}if(S==-0.0){_=v;$=-S;break}A=-S/+$Lb(c[d+536>>2]|0,+h[v+20304>>3],10208,10768,+h[y>>3],(a[d+319|0]|0)!=0|0);_=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;$=A}else{Y=-+h[v+20224>>3];Z=1.0e-10;o=105}}while(0);if((o|0)==105){_=v;$=Y/Z}y=c[(e+36|0)>>2]|0;h[y+2224>>3]=$;G=_+2808|0;n=y+2232|0;p=n+48|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));v=_+2792|0;A=+h[G>>3]*+h[v>>3];h[y+2280>>3]=A*.006+A*-.006;h[y+2288>>3]=0.0;F=c[(d+416|0)>>2]|0;A=+h[v>>3];S=+h[G>>3];r=+h[(F+5800|0)>>3];v=_+2800|0;z=+h[v>>3];h[y+2296>>3]=+h[(F+21064|0)>>3]*(+h[_+7192>>3]*+h[(F+18840|0)>>3]+(A*(S*+h[(F+5784|0)>>3]-A*r)-z*(r*z-S*+h[(F+5792|0)>>3])));S=+h[v>>3]*+h[G>>3];h[y+2304>>3]=S*.006+S*-5.0e-4;h[y+2312>>3]=-(+h[_+4600>>3]*+h[_+9120>>3])- +h[_+4592>>3]*+h[_+9112>>3];S=+h[_+16>>3];h[y+2320>>3]=+h[_+2864>>3]*+h[_+7136>>3]*S- +h[_+2856>>3]*S*+h[_+7160>>3];v=c[c[(d+4|0)>>2]>>2]|0;x=c[v+8>>2]|0;S=+h[(x+2808|0)>>3];z=+h[x+2800>>3];r=+h[(F+5792|0)>>3];A=+h[x+2792>>3];w=c[(e+36|0)>>2]|0;h[w+2328>>3]=+h[(F+21064|0)>>3]*(+h[x+7168>>3]*+h[(F+18840|0)>>3]+(S*(z*+h[(F+5800|0)>>3]-S*r)-A*(r*A-z*+h[(F+5784|0)>>3])));h[w+2336>>3]=+h[x+4568>>3]*+h[x+9112>>3]+ +h[x+4576>>3]*+h[x+9120>>3];h[w+2344>>3]=+h[(x+2808|0)>>3]*+h[x+7160>>3]*+h[(x+16|0)>>3];F=c[(d+416|0)>>2]|0;z=+h[F+20848>>3];A=+h[(x+16|0)>>3];r=-(A*+h[x+7120>>3])-A*(+h[x+14872>>3]*+h[x+9136>>3]+ +h[x+14864>>3]*+h[x+9144>>3]);do{if(z!=0.0){aa=x;ba=v;ca=F;da=w;ea=r/z}else{if(r==0.0){aa=x;ba=v;ca=F;da=w;ea=r;break}A=r/+$Lb(c[d+536>>2]|0,z,1e4,10768,+h[v>>3],(a[d+319|0]|0)!=0|0);fa=c[c[(d+4|0)>>2]>>2]|0;aa=c[fa+8>>2]|0;ba=fa;ca=c[(d+416|0)>>2]|0;da=c[(e+36|0)>>2]|0;ea=A}}while(0);h[da+2352>>3]=ea;h[da+2360>>3]=+h[ca+18840>>3]*+h[ca+21264>>3]*.8660254037844387;v=aa+20952|0;w=da+2368|0;c[w+0>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;z=+h[v>>3];h[da+2384>>3]=z*z*2.0;h[da+2392>>3]=0.0;z=+h[aa+20976>>3];r=+W(+(+h[aa+20256>>3]),1.5);do{if(r!=0.0){ga=ca;ha=aa;ia=ba;ja=da;ka=z*z*-.25/r}else{if(z*z*-.25==0.0){ga=ca;ha=aa;ia=ba;ja=da;ka=z*z*-.25;break}A=z*z*-.25/+$Lb(c[d+536>>2]|0,r,11320,10768,+h[ba>>3],(a[d+319|0]|0)!=0|0);v=c[c[(d+4|0)>>2]>>2]|0;ga=c[(d+416|0)>>2]|0;ha=c[v+8>>2]|0;ia=v;ja=c[(e+36|0)>>2]|0;ka=A}}while(0);h[ja+2400>>3]=ka;r=+h[ha+9168>>3];z=+h[ha+9176>>3];h[ja+2408>>3]=(r*r+z*z)*2.0;h[ja+2416>>3]=0.0;v=ha+16|0;z=+h[v>>3];h[ja+2424>>3]=+h[ha+16200>>3]*z*+h[ga+1408>>3]*-z+ +h[ha+16224>>3]*z*+h[ga+1416>>3]*-z;z=+h[v>>3];w=ha+14808|0;h[ja+2432>>3]=+h[ha+14824>>3]*z*+h[ga+928>>3]*-z+ +h[w>>3]*z*+h[ga+936>>3]*-z;n=ja+2440|0;p=n+48|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));z=+h[v>>3];r=+h[ga+19816>>3];A=+h[w>>3]*+h[ha+9416>>3]+(+h[ha+14800>>3]*+h[ha+9424>>3]+ +h[ha+6944>>3]);do{if(r!=0.0){la=ha;ma=ia;na=ja;oa=A/r}else{if(A==0.0){la=ha;ma=ia;na=ja;oa=A;break}S=A/+$Lb(c[d+536>>2]|0,r,10384,10768,+h[ia>>3],(a[d+319|0]|0)!=0|0);F=c[c[(d+4|0)>>2]>>2]|0;la=c[F+8>>2]|0;ma=F;na=c[(e+36|0)>>2]|0;oa=S}}while(0);h[na+2488>>3]=z*oa;r=+h[la+20400>>3];A=+h[la+9400>>3];S=+h[la+9392>>3];q=r*(+h[la+4528>>3]*S- +h[la+4520>>3]*A)- +h[la+20792>>3]*(S*+h[la+3592>>3]-A*+h[la+3600>>3]);do{if(r*r!=0.0){pa=la;qa=na;ra=q/(r*r)}else{if(q==0.0){pa=la;qa=na;ra=q;break}A=q/+$Lb(c[d+536>>2]|0,r*r,11376,10768,+h[ma>>3],(a[d+319|0]|0)!=0|0);pa=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;qa=c[(e+36|0)>>2]|0;ra=A}}while(0);h[qa+2496>>3]=ra;w=pa+3528|0;h[qa+2504>>3]=-(+h[w>>3]*+h[pa+6952>>3]*+h[pa+16>>3]);v=c[(d+416|0)>>2]|0;F=pa+3520|0;r=+h[F>>3];x=pa+3512|0;q=+h[x>>3];z=+h[v+2768>>3];A=+h[w>>3];h[qa+2512>>3]=+h[v+20032>>3]*(+h[pa+6960>>3]*+h[v+18840>>3]+(r*(q*+h[v+2776>>3]-r*z)-A*(z*A-q*+h[v+2784>>3])));n=qa+2520|0;p=n+56|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));q=+h[x>>3]*+h[F>>3];h[qa+2576>>3]=q*5.0e-4+q*-.006;v=pa+20464|0;n=qa+2584|0;p=n+96|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));F=(ZOb(+U(+(+h[v>>3])),1.0e-10)|0)<<24>>24==0;x=c[c[(d+4|0)>>2]>>2]|0;w=c[x+8>>2]|0;do{if(F){q=+h[w+20384>>3];if(+h[w+20464>>3]!=0.0){sa=-q;ta=+h[w+20464>>3];o=128;break}if(q==-0.0){ua=w;va=-q;break}A=-q/+$Lb(c[d+536>>2]|0,+h[w+20464>>3],10592,10768,+h[x>>3],(a[d+319|0]|0)!=0|0);ua=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;va=A}else{sa=-+h[w+20384>>3];ta=1.0e-10;o=128}}while(0);if((o|0)==128){ua=w;va=sa/ta}x=c[(e+36|0)>>2]|0;h[x+2680>>3]=va;F=ua+3528|0;n=x+2688|0;p=n+48|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(p|0));w=ua+3512|0;A=+h[F>>3]*+h[w>>3];h[x+2736>>3]=A*.006+A*-.006;h[x+2744>>3]=0.0;v=c[(d+416|0)>>2]|0;A=+h[w>>3];q=+h[F>>3];z=+h[(v+2784|0)>>3];w=ua+3520|0;r=+h[w>>3];h[x+2752>>3]=+h[(v+20032|0)>>3]*(+h[ua+7008>>3]*+h[(v+18840|0)>>3]+(A*(q*+h[(v+2768|0)>>3]-A*z)-r*(z*r-q*+h[(v+2776|0)>>3])));q=+h[w>>3]*+h[F>>3];h[x+2760>>3]=q*.006+q*-5.0e-4;h[x+2768>>3]=-(+h[ua+4528>>3]*+h[ua+9400>>3])- +h[ua+4520>>3]*+h[ua+9392>>3];q=+h[ua+16>>3];h[x+2776>>3]=+h[ua+3584>>3]*+h[ua+6952>>3]*q- +h[ua+3576>>3]*q*+h[ua+6976>>3];w=c[c[(d+4|0)>>2]>>2]|0;y=c[w+8>>2]|0;q=+h[(y+3528|0)>>3];r=+h[y+3520>>3];z=+h[(v+2776|0)>>3];A=+h[y+3512>>3];G=c[(e+36|0)>>2]|0;h[G+2784>>3]=+h[(v+20032|0)>>3]*(+h[y+6984>>3]*+h[(v+18840|0)>>3]+(q*(r*+h[(v+2784|0)>>3]-q*z)-A*(z*A-r*+h[(v+2768|0)>>3])));h[G+2792>>3]=+h[y+4496>>3]*+h[y+9392>>3]+ +h[y+4504>>3]*+h[y+9400>>3];h[G+2800>>3]=+h[(y+3528|0)>>3]*+h[y+6976>>3]*+h[(y+16|0)>>3];v=c[(d+416|0)>>2]|0;r=+h[v+19816>>3];A=+h[(y+16|0)>>3];z=-(A*+h[y+6936>>3])-A*(+h[y+14824>>3]*+h[y+9416>>3]+ +h[y+14816>>3]*+h[y+9424>>3]);do{if(r!=0.0){wa=y;xa=w;ya=v;za=G;Aa=z/r}else{if(z==0.0){wa=y;xa=w;ya=v;za=G;Aa=z;break}A=z/+$Lb(c[d+536>>2]|0,r,10384,10768,+h[w>>3],(a[d+319|0]|0)!=0|0);fa=c[c[(d+4|0)>>2]>>2]|0;wa=c[fa+8>>2]|0;xa=fa;ya=c[(d+416|0)>>2]|0;za=c[(e+36|0)>>2]|0;Aa=A}}while(0);h[za+2808>>3]=Aa;h[za+2816>>3]=+h[ya+18840>>3]*+h[ya+20232>>3]*.8660254037844387;w=wa+20904|0;G=za+2824|0;c[G+0>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;c[G+12>>2]=0;r=+h[w>>3];h[za+2840>>3]=r*r*2.0;h[za+2848>>3]=0.0;r=+h[wa+20928>>3];z=+W(+(+h[wa+20416>>3]),1.5);do{if(z!=0.0){Ba=ya;Ca=wa;Da=za;Ea=r*r*-.25/z}else{if(r*r*-.25==0.0){Ba=ya;Ca=wa;Da=za;Ea=r*r*-.25;break}A=r*r*-.25/+$Lb(c[d+536>>2]|0,z,11440,10768,+h[xa>>3],(a[d+319|0]|0)!=0|0);Ba=c[(d+416|0)>>2]|0;Ca=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;Da=c[(e+36|0)>>2]|0;Ea=A}}while(0);h[Da+2856>>3]=Ea;z=+h[Ca+9448>>3];r=+h[Ca+9456>>3];h[Da+2864>>3]=(z*z+r*r)*2.0;h[Da+2872>>3]=0.0;w=Ca+16208|0;G=Ca+16|0;r=+h[G>>3];v=Ca+16232|0;h[Da+2880>>3]=+h[w>>3]*r*+h[Ba+272>>3]*-r+ +h[v>>3]*r*+h[Ba+280>>3]*-r;r=+h[G>>3];h[Da+2888>>3]=+h[w>>3]*r*+h[Ba+832>>3]*-r+ +h[v>>3]*r*+h[Ba+840>>3]*-r;r=+h[G>>3];h[Da+2896>>3]=+h[w>>3]*r*+h[Ba+3848>>3]*-r+ +h[v>>3]*r*+h[Ba+3856>>3]*-r;r=+h[G>>3];h[Da+2904>>3]=+h[w>>3]*r*+h[Ba+6864>>3]*-r+ +h[v>>3]*r*+h[Ba+6872>>3]*-r;r=+h[G>>3];G=c[(e+36|0)>>2]|0;h[G+2912>>3]=+h[w>>3]*r*+h[Ba+9880>>3]*-r+ +h[v>>3]*r*+h[Ba+9888>>3]*-r;v=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;r=+h[(v+16|0)>>3];w=c[(d+416|0)>>2]|0;h[G+2920>>3]=+h[(v+16208|0)>>3]*r*+h[w+12896>>3]*-r+ +h[(v+16232|0)>>3]*r*+h[w+12904>>3]*-r;r=+h[(v+16|0)>>3];h[G+2928>>3]=+h[(v+16208|0)>>3]*r*+h[w+16488>>3]*-r+ +h[(v+16232|0)>>3]*r*+h[w+16496>>3]*-r;r=+h[(v+16|0)>>3];h[G+2936>>3]=+h[v+15056>>3]*r*+h[w+16008>>3]*-r+ +h[v+15040>>3]*r*+h[w+16016>>3]*-r;r=+h[(v+16|0)>>3];h[G+2944>>3]=+h[(v+16208|0)>>3]*r*+h[w+13472>>3]*-r+ +h[(v+16232|0)>>3]*r*+h[w+13480>>3]*-r;r=+h[(v+16|0)>>3];h[G+2952>>3]=+h[v+15008>>3]*r*+h[w+12992>>3]*-r+ +h[v+14992>>3]*r*+h[w+13e3>>3]*-r;r=+h[(v+16|0)>>3];G=c[(e+36|0)>>2]|0;h[G+2960>>3]=+h[(v+16208|0)>>3]*r*+h[w+10456>>3]*-r+ +h[(v+16232|0)>>3]*r*+h[w+10464>>3]*-r;w=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;r=+h[(w+16|0)>>3];v=c[(d+416|0)>>2]|0;h[G+2968>>3]=+h[w+14960>>3]*r*+h[v+9976>>3]*-r+ +h[w+14944>>3]*r*+h[v+9984>>3]*-r;r=+h[(w+16|0)>>3];h[G+2976>>3]=+h[(w+16208|0)>>3]*r*+h[v+7440>>3]*-r+ +h[(w+16232|0)>>3]*r*+h[v+7448>>3]*-r;r=+h[(w+16|0)>>3];h[G+2984>>3]=+h[(w+16208|0)>>3]*r*+h[v+4424>>3]*-r+ +h[(w+16232|0)>>3]*r*+h[v+4432>>3]*-r;r=+h[(w+16|0)>>3];h[G+2992>>3]=+h[w+14864>>3]*r*+h[v+3944>>3]*-r+ +h[w+14848>>3]*r*+h[v+3952>>3]*-r;r=+h[(w+16|0)>>3];h[G+3e3>>3]=+h[(w+16208|0)>>3]*r*+h[v+1408>>3]*-r+ +h[(w+16232|0)>>3]*r*+h[v+1416>>3]*-r;r=+h[(w+16|0)>>3];G=c[(e+36|0)>>2]|0;h[G+3008>>3]=+h[w+14816>>3]*r*+h[v+928>>3]*-r+ +h[w+14800>>3]*r*+h[v+936>>3]*-r;v=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;r=+h[(v+16|0)>>3];w=c[(d+416|0)>>2]|0;h[G+3016>>3]=+h[(w+19200|0)>>3]*(+h[v+16200>>3]*+h[(w+18840|0)>>3]-r*r*+h[w+392>>3]);c[(G+3024|0)+0>>2]=0;c[(G+3024|0)+4>>2]=0;c[(G+3024|0)+8>>2]=0;c[(G+3024|0)+12>>2]=0;r=+h[(v+16|0)>>3];h[G+3040>>3]=+h[(w+19200|0)>>3]*(+h[v+16224>>3]*+h[(w+18840|0)>>3]-r*r*+h[w+400>>3]);h[G+3048>>3]=+h[v+19504>>3];i=b;c[b+4456>>2]=5;break a}while(0);c[b+4424>>2]=n;c[b+4432>>2]=o;c[b+4448>>2]=p}



function cv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0,Na=0;f=i;i=i+120|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+24|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+24|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+24|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+24|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+16|0;va=i;i=i+16|0;wa=i;i=i+16|0;xa=i;i=i+16|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=ta;c[sa>>2]=4;NMb(Aa,1,sa);c[ra>>2]=4;NMb(ua,1,ra);c[qa>>2]=1;c[qa+4>>2]=1;Ba=+h[(VMb(d,2,qa)|0)>>3];c[pa>>2]=2;c[pa+4>>2]=2;Ca=-+h[(VMb(d,2,pa)|0)>>3];c[oa>>2]=3;c[oa+4>>2]=3;Da=Ba+(Ca- +h[(VMb(d,2,oa)|0)>>3])+1.0;c[na>>2]=2;c[na+4>>2]=2;Ca=+h[(VMb(d,2,na)|0)>>3];c[ma>>2]=1;c[ma+4>>2]=1;Ba=-+h[(VMb(d,2,ma)|0)>>3];c[la>>2]=3;c[la+4>>2]=3;Ea=Ca+(Ba- +h[(VMb(d,2,la)|0)>>3])+1.0;c[ka>>2]=3;c[ka+4>>2]=3;Ba=+h[(VMb(d,2,ka)|0)>>3];c[ja>>2]=1;c[ja+4>>2]=1;Ca=-+h[(VMb(d,2,ja)|0)>>3];c[ia>>2]=2;c[ia+4>>2]=2;Fa=Ba+(Ca- +h[(VMb(d,2,ia)|0)>>3])+1.0;c[ha>>2]=1;c[ha+4>>2]=1;Ca=+h[(VMb(d,2,ha)|0)>>3];c[ga>>2]=2;c[ga+4>>2]=2;Ba=+h[(VMb(d,2,ga)|0)>>3];c[fa>>2]=3;c[fa+4>>2]=3;Ga=Ca+(Ba+ +h[(VMb(d,2,fa)|0)>>3])+1.0;do{if(Ga>.04000000000000001){Ha=3}else{if(Ga>Da&Ga>Ea&Ga>Fa){Ha=3;break}if(Da>Ea&Da>Fa&Da>Ga){if(!(Da>=0.0)){fa=c[69976]|0;ga=Y;h[k>>3]=Da;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa;fa=l;ha=8280;c[fa+0>>2]=c[ha+0>>2];c[fa+4>>2]=c[ha+4>>2];c[fa+8>>2]=c[ha+8>>2];c[fa+12>>2]=c[ha+12>>2];c[fa+16>>2]=c[ha+16>>2];c[fa+20>>2]=c[ha+20>>2];Ee[ga&31](b,l,7376,Y);}Ba=+V(+Da)*.5;Ca=Ba*4.0;c[X>>2]=1;c[X+4>>2]=2;Ia=+h[(VMb(d,2,X)|0)>>3];c[W>>2]=2;c[W+4>>2]=1;Ja=(Ia+ +h[(VMb(d,2,W)|0)>>3])/Ca;c[U>>2]=1;c[U+4>>2]=3;Ia=+h[(VMb(d,2,U)|0)>>3];c[T>>2]=3;c[T+4>>2]=1;Ka=(Ia+ +h[(VMb(d,2,T)|0)>>3])/Ca;c[S>>2]=2;c[S+4>>2]=3;Ia=+h[(VMb(d,2,S)|0)>>3];c[R>>2]=3;c[R+4>>2]=2;La=(Ia- +h[(VMb(d,2,R)|0)>>3])/Ca;ga=Q;h[k>>3]=Ja;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=Q+8|0;h[k>>3]=Ka;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=Q+16|0;h[k>>3]=La;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];UMb(wa,4,Ba,Q);PMb(wa,ua);break}if(Ea>Da&Ea>Fa&Ea>Ga){if(!(Ea>=0.0)){ga=c[69976]|0;ha=P;h[k>>3]=Ea;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];ha=ga;ga=j;fa=8280;c[ga+0>>2]=c[fa+0>>2];c[ga+4>>2]=c[fa+4>>2];c[ga+8>>2]=c[fa+8>>2];c[ga+12>>2]=c[fa+12>>2];c[ga+16>>2]=c[fa+16>>2];c[ga+20>>2]=c[fa+20>>2];Ee[ha&31](b,j,7432,P);}Ba=+V(+Ea)*.5;La=Ba*4.0;c[O>>2]=1;c[O+4>>2]=2;Ka=+h[(VMb(d,2,O)|0)>>3];c[N>>2]=2;c[N+4>>2]=1;Ja=(Ka+ +h[(VMb(d,2,N)|0)>>3])/La;c[M>>2]=2;c[M+4>>2]=3;Ka=+h[(VMb(d,2,M)|0)>>3];c[L>>2]=3;c[L+4>>2]=2;Ca=(Ka+ +h[(VMb(d,2,L)|0)>>3])/La;c[K>>2]=3;c[K+4>>2]=1;Ka=+h[(VMb(d,2,K)|0)>>3];c[J>>2]=1;c[J+4>>2]=3;Ia=(Ka- +h[(VMb(d,2,J)|0)>>3])/La;ha=I;h[k>>3]=Ba;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];ha=I+8|0;h[k>>3]=Ca;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];ha=I+16|0;h[k>>3]=Ia;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];UMb(xa,4,Ja,I);PMb(xa,ua);break}else{if(!(Fa>=0.0)){ha=c[69976]|0;fa=H;h[k>>3]=Fa;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=ha;ha=g;ga=8280;c[ha+0>>2]=c[ga+0>>2];c[ha+4>>2]=c[ga+4>>2];c[ha+8>>2]=c[ga+8>>2];c[ha+12>>2]=c[ga+12>>2];c[ha+16>>2]=c[ga+16>>2];c[ha+20>>2]=c[ga+20>>2];Ee[fa&31](b,g,7488,H);}Ja=+V(+Fa)*.5;Ia=Ja*4.0;c[G>>2]=1;c[G+4>>2]=3;Ca=+h[(VMb(d,2,G)|0)>>3];c[F>>2]=3;c[F+4>>2]=1;Ba=(Ca+ +h[(VMb(d,2,F)|0)>>3])/Ia;c[E>>2]=2;c[E+4>>2]=3;Ca=+h[(VMb(d,2,E)|0)>>3];c[D>>2]=3;c[D+4>>2]=2;La=(Ca+ +h[(VMb(d,2,D)|0)>>3])/Ia;c[C>>2]=1;c[C+4>>2]=2;Ca=+h[(VMb(d,2,C)|0)>>3];c[B>>2]=2;c[B+4>>2]=1;Ka=(Ca- +h[(VMb(d,2,B)|0)>>3])/Ia;fa=A;h[k>>3]=La;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=A+8|0;h[k>>3]=Ja;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=A+16|0;h[k>>3]=Ka;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];UMb(ya,4,Ba,A);PMb(ya,ua);break}}}while(0);if((Ha|0)==3){if(!(Ga>=0.0)){Ha=c[69976]|0;ya=ea;h[k>>3]=Ga;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=Ha;Ha=m;A=8280;c[Ha+0>>2]=c[A+0>>2];c[Ha+4>>2]=c[A+4>>2];c[Ha+8>>2]=c[A+8>>2];c[Ha+12>>2]=c[A+12>>2];c[Ha+16>>2]=c[A+16>>2];c[Ha+20>>2]=c[A+20>>2];Ee[ya&31](b,m,7320,ea);}Fa=+V(+Ga)*.5;Ga=Fa*4.0;c[da>>2]=2;c[da+4>>2]=3;Ea=+h[(VMb(d,2,da)|0)>>3];c[ca>>2]=3;c[ca+4>>2]=2;Da=(Ea- +h[(VMb(d,2,ca)|0)>>3])/Ga;c[ba>>2]=3;c[ba+4>>2]=1;Ea=+h[(VMb(d,2,ba)|0)>>3];c[aa>>2]=1;c[aa+4>>2]=3;Ba=(Ea- +h[(VMb(d,2,aa)|0)>>3])/Ga;c[$>>2]=1;c[$+4>>2]=2;Ea=+h[(VMb(d,2,$)|0)>>3];c[_>>2]=2;c[_+4>>2]=1;Ka=(Ea- +h[(VMb(d,2,_)|0)>>3])/Ga;_=Z;h[k>>3]=Ba;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];_=Z+8|0;h[k>>3]=Ka;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];_=Z+16|0;h[k>>3]=Fa;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];UMb(va,4,Da,Z);PMb(va,ua)}c[z>>2]=1;Da=+h[(VMb(ua,1,z)|0)>>3];c[y>>2]=1;Fa=Da*+h[(VMb(e,1,y)|0)>>3];c[x>>2]=2;Da=+h[(VMb(ua,1,x)|0)>>3];c[w>>2]=2;Ka=Da*+h[(VMb(e,1,w)|0)>>3];c[v>>2]=3;Da=+h[(VMb(ua,1,v)|0)>>3];c[u>>2]=3;Ba=Da*+h[(VMb(e,1,u)|0)>>3];c[t>>2]=4;Da=+h[(VMb(ua,1,t)|0)>>3];c[s>>2]=4;if(!(Fa+(Ka+(Ba+Da*+h[(VMb(e,1,s)|0)>>3]))<0.0)){PMb(ua,Aa);Ma=a;Na=ta;c[Ma+0>>2]=c[Na+0>>2];c[Ma+4>>2]=c[Na+4>>2];c[Ma+8>>2]=c[Na+8>>2];i=f;return}c[r>>2]=1;Da=-+h[(VMb(ua,1,r)|0)>>3];c[q>>2]=2;Ba=-+h[(VMb(ua,1,q)|0)>>3];c[p>>2]=3;Ka=-+h[(VMb(ua,1,p)|0)>>3];c[o>>2]=4;Fa=-+h[(VMb(ua,1,o)|0)>>3];o=n;h[k>>3]=Ba;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=Ka;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+16|0;h[k>>3]=Fa;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];UMb(za,4,Da,n);PMb(za,ua);PMb(ua,Aa);Ma=a;Na=ta;c[Ma+0>>2]=c[Na+0>>2];c[Ma+4>>2]=c[Na+4>>2];c[Ma+8>>2]=c[Na+8>>2];i=f;return}function dv(b,d,e,f,g,j,l){b=b|0;d=d|0;e=+e;f=f|0;g=+g;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,W=0.0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0;m=i;i=i+56|0;n=m;o=m+24|0;p=m+48|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+16|0;J=i;i=i+16|0;c[H>>2]=3;NMb(I,1,H);c[G>>2]=1;K=+h[(VMb(l,1,G)|0)>>3];c[F>>2]=1;L=K- +h[(VMb(j,1,F)|0)>>3];c[E>>2]=2;K=+h[(VMb(l,1,E)|0)>>3];c[D>>2]=2;M=K- +h[(VMb(j,1,D)|0)>>3];c[C>>2]=3;K=+h[(VMb(l,1,C)|0)>>3];c[B>>2]=3;N=K- +h[(VMb(j,1,B)|0)>>3];B=A;h[k>>3]=M;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];UMb(J,3,L,A);PMb(J,I);c[z>>2]=1;L=+h[(VMb(f,1,z)|0)>>3];c[y>>2]=1;N=L*+h[(VMb(I,1,y)|0)>>3];c[x>>2]=2;L=+h[(VMb(f,1,x)|0)>>3];c[w>>2]=2;M=L*+h[(VMb(I,1,w)|0)>>3];c[v>>2]=3;L=+h[(VMb(f,1,v)|0)>>3];c[u>>2]=3;K=(N+(M+L*+h[(VMb(I,1,u)|0)>>3]))*2.0;c[t>>2]=1;L=+h[(VMb(I,1,t)|0)>>3];c[s>>2]=2;M=+h[(VMb(I,1,s)|0)>>3];c[r>>2]=3;N=+h[(VMb(I,1,r)|0)>>3];O=K*.5;K=O*O-(L*L+(M*M+(N*N-e*e)));if(!(K>1.0e-10)){r=c[69976]|0;I=o;s=7632;c[I+0>>2]=c[s+0>>2];c[I+4>>2]=c[s+4>>2];c[I+8>>2]=c[s+8>>2];c[I+12>>2]=c[s+12>>2];c[I+16>>2]=c[s+16>>2];c[I+20>>2]=c[s+20>>2];Ee[r&31](d,o,7656,q);}e=+rd(+K,1.0e-12);if(e>=0.0){P=+V(+e);Q=P-O;R=-O;S=R-P;T=Q-g;W=+U(+T);X=S-g;Y=+U(+X);Z=W<=Y;_=Z&1;$=b;aa=$;a[aa]=_;i=m;return}q=c[69976]|0;o=p;h[k>>3]=e;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=q;q=n;r=8280;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];c[q+16>>2]=c[r+16>>2];c[q+20>>2]=c[r+20>>2];Ee[o&31](d,n,8304,p);P=+V(+e);Q=P-O;R=-O;S=R-P;T=Q-g;W=+U(+T);X=S-g;Y=+U(+X);Z=W<=Y;_=Z&1;$=b;aa=$;a[aa]=_;i=m;return}function ev(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;VLb(4,0,8368,b);VLb(4,0,8408,a);i=a;return}function fv(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}bec(a);c[d>>2]=0;i=b;return}function gv(a){a=a|0;i=i;return}




// EMSCRIPTEN_END_FUNCS
var $d=[Ffc,iOb,kOb,pOb,d1b,Ffc,Ffc,Ffc];var ae=[Gfc,RIb,SIb,vJb,wJb,_Jb,$Jb,wKb,xKb,yKb,Ydc,Xdc,Wdc,jIb,kIb,WLb,ULb,Gfc,Gfc,Gfc,Gfc,Gfc,Gfc,Gfc,Gfc,Gfc,Gfc,Gfc,Gfc,Gfc,Gfc,Gfc];var be=[Hfc,JPb];var ce=[Ifc,WOb];var de=[Jfc,ev,fv,gv,lv,gya,nv,RLb,VRb,YRb,XRb,ZRb,b6b,a6b,d6b,c6b,_Rb,aSb,mVb,IVb,JVb,KVb,O5b,N5b,Q5b,P5b,B0b,O0b,P0b,Q0b,S0b,U0b,K2b,L2b,R2b,S2b,Y2b,Z2b,d3b,e3b,q3b,p3b,v3b,u3b,x3b,y3b,H3b,G3b,O4b,N4b,X4b,W4b,z5b,y5b,X5b,W5b,Z5b,Y5b,p6b,o6b,r6b,q6b,x6b,w6b,M4b,y6b,v6b,z6b,B6b,A6b,Jac,H6b,G6b,M6b,L6b,j7b,i7b,N7b,M7b,$7b,_7b,n8b,m8b,B8b,A8b,O8b,N8b,R8b,Q8b,V8b,U8b,e9b,d9b,p9b,o9b,A9b,z9b,L9b,K9b,V9b,U9b,bac,aac,hac,gac,nac,mac,sac,rac,Bac,Aac,Zac,Yac,wac,obc,Vbc,Ubc,Xbc,Wbc,C6b,Iac,Lac,gbc,wbc,Hbc,Sbc,Tbc,Jdc,Idc,Ldc,Odc,Mdc,Ndc,Pdc,Qdc,lec,kec,Zu,Kfc,_e,$e,af,bf,cf,df,ef,ff,gf,hf,jf,kf,lf,mf,nf,of,pf,qf,rf,sf,tf,uf,vf,wf,xf,yf,zf,Af,Bf,Ff,Jg,th,xh,Ah,Bh,Ch,Ph,ci,ei,qi,Bi,Zi,bj,ej,fj,gj,tj,Ij,Kj,Wj,fk,Dk,Hk,Kk,Lk,Mk,Zk,ml,ol,Al,Ll,hm,lm,om,pm,qm,Dm,Sm,Um,en,qn,On,Sn,Vn,Wn,Xn,jo,yo,Ao,Mo,Xo,sp,wp,zp,Ap,Bp,Op,bq,dq,pq,Aq,Bq,Dq,Eq,Fq,Gq,Hq,Iq,Jq,Kq,Lq,Mq,Nq,Oq,Pq,Qq,Rq,Sq,Tq,Uq,Vq,Wq,Xq,Yq,Zq,_q,$q,ar,br,cr,dr,er,fr,gr,hr,ir,jr,kr,lr,mr,nr,or,pr,qr,rr,sr,tr,ur,vr,wr,xr,yr,zr,Ar,Br,Cr,Dr,Er,Fr,Gr,Hr,Ir,Jr,Kr,Lr,Mr,Nr,Or,Pr,Qr,Rr,Sr,Tr,Ur,Vr,Wr,Xr,Yr,Zr,_r,$r,as,bs,cs,ds,es,fs,gs,hs,is,js,ks,ns,os,ps,qs,rs,ss,ts,us,vs,ws,xs,ys,zs,As,Bs,Cs,Ds,Es,Fs,Gs,Hs,Is,Js,Ks,Ls,Ms,Ns,Os,Ps,Qs,Rs,Ss,Ts,Us,Vs,Ws,Xs,Ys,Zs,_s,$s,at,bt,ct,dt,et,ft,gt,ht,it,jt,kt,lt,mt,nt,ot,pt,qt,rt,st,tt,ut,vt,wt,xt,yt,zt,At,Bt,Ct,Dt,Et,Ft,Gt,Ht,It,Jt,Kt,Lt,Mt,Nt,Ot,Pt,Qt,Rt,St,Tt,Ut,Vt,Wt,Xt,Yt,Zt,_t,$t,au,bu,cu,du,eu,fu,gu,hu,iu,ju,ku,lu,mu,nu,ou,pu,qu,ru,su,tu,uu,vu,wu,xu,yu,zu,Au,Bu,Cu,Du,Eu,Fu,Gu,Hu,Iu,Ju,Ku,Lu,Mu,Nu,Ou,Pu,Qu,Ru,Su,Tu,Uu,bec,TLb,Ve,GOb,KOb,FOb,MPb,MOb,KPb,rNb,POb,NOb,OOb,LOb,ROb,LPb,SOb,HOb,UOb,m0b,VOb,i2b,J2b,Kac,Dcc,N9b,Kcc,Jcc,Icc,Hcc,Gcc,Fcc,X3b,z4b,Jfc,Jfc,Jfc,Jfc,Jfc,Jfc,Jfc,Jfc,Jfc,Jfc,Jfc,Jfc,Jfc,Jfc,Jfc];var ee=[Lfc,mv,rQb,bSb,m5b,M2b,T2b,_2b,f3b,A5b,Y8b,Z8b,_8b,$8b,b9b,c9b,h9b,i9b,j9b,k9b,m9b,n9b,s9b,t9b,u9b,v9b,x9b,y9b,D9b,E9b,F9b,G9b,I9b,J9b,qac,vac,acc,ccc,ecc,bcc,dcc,fcc,xOb,hv,iv,jv,kv,QOb,UUb,tQb,sQb,uQb,AQb,MQb,vQb,KQb,hUb,tUb,sUb,uUb,cUb,aUb,eUb,r1b];var fe=[Mfc,yIb,rIb,jOb,lOb,mOb,nOb,oOb];var ge=[Nfc,Wu,VFb,Vu,Xe,Ye,Ze,hya,Vya,tv,fya,UFb,hGb,sv,qv,iGb,jGb,oGb,pGb,qGb,rGb,sGb,tGb,uGb,vGb,Ofc,Pfc,Qfc,lMb,aec,Rfc,fSb,r5b,gSb,u5b,q5b,X0b,N2b,F5b,H5b,I5b,E5b,U2b,V2b,$2b,t5b,g3b,h3b,r3b,w3b,t6b,o8b,gcc,icc,kcc,qcc,scc,mcc,occ,C8b,hcc,jcc,lcc,rcc,tcc,ncc,pcc,W8b,X8b,a9b,f9b,g9b,l9b,q9b,r9b,w9b,B9b,C9b,H9b,sbc,tbc,vbc,Ybc,_bc,Zbc,$bc,kbc,lbc,nbc,Cbc,Dbc,Gbc,Nbc,Obc,Rbc,Kdc,mec,TPb,Sfc,Tfc,RPb,SPb,Ufc,f0b,G0b,bPb,iPb,uPb,cPb,lPb,vPb,B2b,vec,Nfc,Nfc,Nfc,Nfc,Nfc,Nfc,Nfc,Nfc,Nfc,Nfc,Nfc,Nfc,Nfc,Nfc,Nfc];var he=[Vfc,UMb];var ie=[Wfc,YNb];var je=[Xfc,yNb];var ke=[Yfc,aOb];var le=[Zfc,pv,IIb,OIb,mJb,sJb,RJb,XJb,cSb,s5b,w5b,n5b,B5b,G5b,O2b,K5b,a3b,B3b,C3b,F6b,K6b,oac,tac,$ac,bbc,ebc,Mac,Rac,Tac,Wac,Rdc,o0b,VMb,vIb,mIb,tIb,zIb,_fc,$fc,agc,NPb,l0b,h0b,bgc,t2b,cgc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc];var me=[dgc,V7b,Y7b,h8b,j8b,dgc,dgc,dgc];var ne=[egc,P8b,S8b,M9b,Q9b,W9b,Y9b,egc];var oe=[fgc,OLb,dSb,V0b,C5b,o5b,O7b,P7b,T7b,Z7b,a8b,b8b,f8b,k8b,pac,uac,$dc,_dc,Zdc,PLb,fgc,fgc,fgc,fgc,fgc,fgc,fgc,fgc,fgc,fgc,fgc,fgc];var pe=[ggc,jPb,kPb,ggc];var qe=[hgc,Yu];var re=[igc,N6b,P6b,R6b,T6b,V6b,X6b,Z6b,$6b,b7b,d7b,f7b,k7b,m7b,o7b,q7b,s7b,u7b,w7b,y7b,A7b,C7b,E7b,S7b,U7b,e8b,g8b,p8b,q8b,r8b,s8b,t8b,D8b,E8b,F8b,G8b,H8b,fac,lac,igc,igc,igc,igc,igc,igc,igc,igc,igc,igc,igc,igc,igc,igc,igc,igc,igc,igc,igc,igc,igc,igc,igc,igc,igc];var se=[jgc,cac,iac,jgc];var te=[kgc,u8b,I8b,kgc];var ue=[lgc,We,Av,rv,ov,wGb,xGb,KIb,LIb,NIb,oJb,pJb,rJb,TJb,UJb,WJb,aKb,bKb,cKb,dKb,eKb,fKb,gKb,hKb,hSb,iSb,Y0b,Z0b,J5b,P2b,W2b,L5b,v5b,b3b,i3b,x5b,_ac,abc,cbc,Qac,Sac,Uac,BPb,wPb,nPb,dPb,mPb,mgc,dec,gIb,hIb,iIb,ngc,yMb,qPb,tPb,gPb,ogc,udc,lgc,lgc,lgc,lgc,lgc];var ve=[pgc,D6b,I6b,fbc,rbc,ubc,Xac,jbc,mbc,Bbc,Ebc,Mbc,Pbc,EKb,vLb,wLb,JKb,GKb,tLb,uLb,KKb,LKb,MKb,NKb,OKb,jLb,kLb,aLb,VKb,QKb,PKb,RKb,SKb,UKb,TKb,HKb,FKb,WKb,XKb,YKb,ZKb,_Kb,$Kb,bLb,cLb,dLb,eLb,iLb,gLb,fLb,hLb,pLb,lLb,mLb,nLb,oLb,qLb,rLb,sLb,xLb,yLb,zLb,ALb,Q7b];var we=[qgc,YPb];var xe=[rgc,INb];var ye=[sgc,zGb,tgc,mMb,G2b,H2b,E2b,sgc];var ze=[ugc,$Nb];var Ae=[vgc,q0b,A3b,u6b,NMb,ZLb,mQb,oQb,TUb,q1b,vgc,vgc,vgc,vgc,vgc,vgc];var Be=[wgc,xgc,kMb,DLb,$u,wgc,wgc,wgc];var Ce=[ygc,yGb,pbc,qbc,hbc,ibc,xbc,zbc,Ibc,Kbc,ygc,ygc,ygc,ygc,ygc,ygc];var De=[zgc,CIb,DIb,EIb,FIb,GIb,HIb,JIb,MIb,QIb,gJb,hJb,iJb,jJb,kJb,lJb,nJb,qJb,uJb,LJb,MJb,NJb,OJb,PJb,QJb,SJb,VJb,ZJb,dbc,Nac,Oac,Pac,Vac,zOb,Agc,XNb,_Hb,bHb,wHb,FHb,rHb,OHb,THb,RHb,UHb,AIb,eIb,oIb,pIb,wIb,xIb,h7b,W7b,Bgc,zgc,zgc,zgc,zgc,zgc,zgc,zgc,zgc,zgc,zgc];var Ee=[Cgc,PIb,tJb,YJb,eSb,p0b,W0b,D5b,p5b,E6b,J6b,Sdc,Tdc,Udc,XLb,VLb,BOb,YLb,LMb,L1b,qIb,_Lb,Cgc,Cgc,Cgc,Cgc,Cgc,Cgc,Cgc,Cgc,Cgc,Cgc];return{_testSetjmp:Rec,_saveSetjmp:Dec,_free:bec,_main:_u,_rand_r:Lec,_realloc:dec,_i64Add:Oec,_memmove:Hec,_bitshift64Ashr:Fec,_memset:Iec,_malloc:aec,_strncpy:Pec,_memcpy:Gec,_strlen:Eec,_bitshift64Lshr:Qec,_bitshift64Shl:Jec,_i64Subtract:Nec,_strcpy:Kec,_calloc:cec,_rand:Mec,__GLOBAL__I_a:k3b,runPostSets:Cec,stackAlloc:Fe,stackSave:Ge,stackRestore:He,setThrew:Ie,setTempRet0:Le,setTempRet1:Me,setTempRet2:Ne,setTempRet3:Oe,setTempRet4:Pe,setTempRet5:Qe,setTempRet6:Re,setTempRet7:Se,setTempRet8:Te,setTempRet9:Ue,dynCall_iiiiiiii:$ec,dynCall_viiiii:afc,dynCall_iiiiidiii:bfc,dynCall_vd:cfc,dynCall_vi:dfc,dynCall_vii:efc,dynCall_iiiiiiiiiii:ffc,dynCall_ii:gfc,dynCall_viidi:hfc,dynCall_iiiiiiiiiiiiii:ifc,dynCall_iiiiiiiiiiiiiiiiiiiii:jfc,dynCall_iiiiiiiiiiiiiiiiiiiiiii:kfc,dynCall_iiii:lfc,dynCall_viiiiid:mfc,dynCall_viiiiiiii:nfc,dynCall_viiiiii:ofc,dynCall_viidii:pfc,dynCall_iid:qfc,dynCall_viiiiiii:rfc,dynCall_viiiiiid:sfc,dynCall_viiiiiiiii:tfc,dynCall_iii:ufc,dynCall_iiiiii:vfc,dynCall_iiiiidi:wfc,dynCall_dii:xfc,dynCall_i:yfc,dynCall_iiiiiiiiii:zfc,dynCall_viii:Afc,dynCall_v:Bfc,dynCall_iiiiiiiii:Cfc,dynCall_iiiii:Dfc,dynCall_viiii:Efc}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_lis_matrix_assemble": _lis_matrix_assemble, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "__reallyNegative": __reallyNegative, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_get_values": _lis_vector_get_values, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_lis_matrix_set_size": _lis_matrix_set_size, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_lis_solve": _lis_solve, "_strtoull_l": _strtoull_l, "_mkport": _mkport, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_lis_matrix_set_type": _lis_matrix_set_type, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "_vsnprintf": _vsnprintf, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_lis_vector_set_value": _lis_vector_set_value, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_lis_matrix_destroy": _lis_matrix_destroy, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "___cxa_is_number_type": ___cxa_is_number_type, "_ungetc": _ungetc, "_system": _system, "_fmin": _fmin, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_lis_solver_destroy": _lis_solver_destroy, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_fscanf": _fscanf, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_matrix_create": _lis_matrix_create, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






