var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 208104;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 208144;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(208971);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,1,0,0,0,148,8,0,0,97,120,105,115,49,46,109,111,116,111,114,46,82,112,50,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,168,8,0,0,97,120,105,115,50,46,109,111,116,111,114,46,82,112,50,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,188,8,0,0,97,120,105,115,51,46,109,111,116,111,114,46,82,112,50,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,208,8,0,0,97,120,105,115,52,46,109,111,116,111,114,46,82,112,50,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,222,8,0,0,97,120,105,115,53,46,109,111,116,111,114,46,82,112,50,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,236,8,0,0,97,120,105,115,54,46,109,111,116,111,114,46,82,112,50,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,12,9,0,0,97,120,105,115,54,46,109,111,116,111,114,46,76,97,46,76,0,0,0,0,0,0,0,0,1,0,0,0,22,9,0,0,97,120,105,115,53,46,109,111,116,111,114,46,76,97,46,76,0,0,0,0,0,0,0,0,1,0,0,0,32,9,0,0,97,120,105,115,52,46,109,111,116,111,114,46,76,97,46,76,0,0,0,0,0,0,0,0,1,0,0,0,44,9,0,0,97,120,105,115,51,46,109,111,116,111,114,46,76,97,46,76,0,0,0,0,0,0,0,0,1,0,0,0,61,9,0,0,97,120,105,115,50,46,109,111,116,111,114,46,76,97,46,76,0,0,0,0,0,0,0,0,1,0,0,0,78,9,0,0,97,120,105,115,49,46,109,111,116,111,114,46,76,97,46,76,0,0,0,0,0,0,0,0,1,0,0,0,89,9,0,0,97,120,105,115,49,46,103,101,97,114,46,103,101,97,114,46,114,97,116,105,111,0,0,0,1,0,0,0,107,9,0,0,97,120,105,115,49,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,0,0,0,1,0,0,0,111,9,0,0,97,120,105,115,49,46,109,111,116,111,114,46,82,100,50,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,114,9,0,0,97,120,105,115,49,46,109,111,116,111,114,46,82,105,46,82,95,97,99,116,117,97,108,0,1,0,0,0,115,9,0,0,97,120,105,115,49,46,109,111,116,111,114,46,67,46,67,0,1,0,0,0,121,9,0,0,97,120,105,115,50,46,103,101,97,114,46,103,101,97,114,46,114,97,116,105,111,0,0,0,1,0,0,0,151,9,0,0,97,120,105,115,50,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,0,0,0,1,0,0,0,155,9,0,0,97,120,105,115,50,46,109,111,116,111,114,46,82,100,50,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,158,9,0,0,97,120,105,115,50,46,109,111,116,111,114,46,82,105,46,82,95,97,99,116,117,97,108,0,1,0,0,0,159,9,0,0,97,120,105,115,50,46,109,111,116,111,114,46,67,46,67,0,1,0,0,0,165,9,0,0,97,120,105,115,51,46,103,101,97,114,46,103,101,97,114,46,114,97,116,105,111,0,0,0,1,0,0,0,214,10,0,0,97,120,105,115,51,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,0,0,0,1,0,0,0,218,10,0,0,97,120,105,115,51,46,109,111,116,111,114,46,82,100,50,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,221,10,0,0,97,120,105,115,51,46,109,111,116,111,114,46,82,105,46,82,95,97,99,116,117,97,108,0,1,0,0,0,222,10,0,0,97,120,105,115,51,46,109,111,116,111,114,46,67,46,67,0,1,0,0,0,233,10,0,0,97,120,105,115,52,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,0,0,0,1,0,0,0,237,10,0,0,97,120,105,115,52,46,109,111,116,111,114,46,82,100,50,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,240,10,0,0,97,120,105,115,52,46,109,111,116,111,114,46,82,105,46,82,95,97,99,116,117,97,108,0,1,0,0,0,241,10,0,0,97,120,105,115,52,46,109,111,116,111,114,46,67,46,67,0,1,0,0,0,252,10,0,0,97,120,105,115,53,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,0,0,0,1,0,0,0,0,11,0,0,97,120,105,115,53,46,109,111,116,111,114,46,82,100,50,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,3,11,0,0,97,120,105,115,53,46,109,111,116,111,114,46,82,105,46,82,95,97,99,116,117,97,108,0,1,0,0,0,4,11,0,0,97,120,105,115,53,46,109,111,116,111,114,46,67,46,67,0,1,0,0,0,15,11,0,0,97,120,105,115,54,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,0,0,0,1,0,0,0,19,11,0,0,97,120,105,115,54,46,109,111,116,111,114,46,82,100,50,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,22,11,0,0,97,120,105,115,54,46,109,111,116,111,114,46,82,105,46,82,95,97,99,116,117,97,108,0,1,0,0,0,23,11,0,0,97,120,105,115,54,46,109,111,116,111,114,46,67,46,67,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,66,97,115,105,99,46,109,111,0,84,101,109,112,101,114,97,116,117,114,101,32,111,117,116,115,105,100,101,32,115,99,111,112,101,32,111,102,32,109,111,100,101,108,33,0,0,0,0,0,112,8,0,0,74,0,0,0,3,0,0,0,74,0,0,0,108,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,76,111,103,105,99,97,108,46,109,111,0,0,0,9,0,0,33,4,0,0,7,0,0,0,33,4,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,69,120,97,109,112,108,101,115,46,83,121,115,116,101,109,115,46,82,111,98,111,116,82,51,46,102,117,108,108,82,111,98,111,116,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,69,120,97,109,112,108,101,115,47,83,121,115,116,101,109,115,0,0,0,0,0,0,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,69,120,97,109,112,108,101,115,46,83,121,115,116,101,109,115,46,82,111,98,111,116,82,51,46,102,117,108,108,82,111,98,111,116,95,105,110,102,111,46,120,109,108,0,0,0,0,0,0,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,97,116,104,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,32,12,0,0,172,49,0,0,5,0,0,0,172,49,0,0,54,0,0,0,0,0,0,0,84,97,98,108,101,32,105,110,100,101,120,32,109,117,115,116,32,98,101,32,105,110,99,114,101,97,115,105,110,103,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,52,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,160,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,51,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,120,14,0,0,0,16,0,0,128,17,0,0,152,17,0,0,176,17,0,0,56,19,0,0,184,20,0,0,208,20,0,0,232,20,0,0,112,22,0,0,240,23,0,0,8,24,0,0,32,24,0,0,72,24,0,0,112,24,0,0,144,24,0,0,184,24,0,0,216,24,0,0,248,24,0,0,152,26,0,0,56,28,0,0,200,29,0,0,104,31,0,0,248,32,0,0,136,34,0,0,176,34,0,0,216,34,0,0,0,35,0,0,40,35,0,0,80,35,0,0,120,35,0,0,0,0,0,0,112,114,101,40,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,48,32,97,110,100,32,40,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,41,32,111,114,32,112,114,101,40,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,116,97,114,116,66,97,99,107,119,97,114,100,41,32,97,110,100,32,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,41,32,111,114,32,112,114,101,40,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,49,32,97,110,100,32,97,120,105,115,51,46,109,111,116,111,114,46,101,109,102,46,119,32,60,32,40,45,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,41,32,111,114,32,105,110,105,116,105,97,108,40,41,32,97,110,100,32,97,120,105,115,51,46,109,111,116,111,114,46,101,109,102,46,119,32,60,32,48,46,48,0,0,0,0,0,0,112,114,101,40,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,48,32,97,110,100,32,40,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,32,111,114,32,112,114,101,40,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,116,97,114,116,70,111,114,119,97,114,100,41,32,97,110,100,32,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,32,111,114,32,112,114,101,40,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,45,49,32,97,110,100,32,97,120,105,115,51,46,109,111,116,111,114,46,101,109,102,46,119,32,62,32,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,32,111,114,32,105,110,105,116,105,97,108,40,41,32,97,110,100,32,97,120,105,115,51,46,109,111,116,111,114,46,101,109,102,46,119,32,62,32,48,46,48,0,0,0,0,0,0,0,97,120,105,115,51,46,109,111,116,111,114,46,101,109,102,46,119,32,62,32,48,46,48,0,97,120,105,115,51,46,109,111,116,111,114,46,101,109,102,46,119,32,60,32,48,46,48,0,112,114,101,40,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,48,32,97,110,100,32,40,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,41,32,111,114,32,112,114,101,40,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,116,97,114,116,66,97,99,107,119,97,114,100,41,32,97,110,100,32,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,41,32,111,114,32,112,114,101,40,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,49,32,97,110,100,32,97,120,105,115,50,46,109,111,116,111,114,46,101,109,102,46,119,32,60,32,40,45,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,41,32,111,114,32,105,110,105,116,105,97,108,40,41,32,97,110,100,32,97,120,105,115,50,46,109,111,116,111,114,46,101,109,102,46,119,32,60,32,48,46,48,0,0,0,0,0,0,112,114,101,40,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,48,32,97,110,100,32,40,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,32,111,114,32,112,114,101,40,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,116,97,114,116,70,111,114,119,97,114,100,41,32,97,110,100,32,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,32,111,114,32,112,114,101,40,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,45,49,32,97,110,100,32,97,120,105,115,50,46,109,111,116,111,114,46,101,109,102,46,119,32,62,32,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,32,111,114,32,105,110,105,116,105,97,108,40,41,32,97,110,100,32,97,120,105,115,50,46,109,111,116,111,114,46,101,109,102,46,119,32,62,32,48,46,48,0,0,0,0,0,0,0,97,120,105,115,50,46,109,111,116,111,114,46,101,109,102,46,119,32,62,32,48,46,48,0,97,120,105,115,50,46,109,111,116,111,114,46,101,109,102,46,119,32,60,32,48,46,48,0,112,114,101,40,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,48,32,97,110,100,32,40,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,41,32,111,114,32,112,114,101,40,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,116,97,114,116,66,97,99,107,119,97,114,100,41,32,97,110,100,32,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,41,32,111,114,32,112,114,101,40,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,49,32,97,110,100,32,97,120,105,115,49,46,109,111,116,111,114,46,101,109,102,46,119,32,60,32,40,45,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,41,32,111,114,32,105,110,105,116,105,97,108,40,41,32,97,110,100,32,97,120,105,115,49,46,109,111,116,111,114,46,101,109,102,46,119,32,60,32,48,46,48,0,0,0,0,0,0,112,114,101,40,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,48,32,97,110,100,32,40,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,32,111,114,32,112,114,101,40,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,116,97,114,116,70,111,114,119,97,114,100,41,32,97,110,100,32,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,32,111,114,32,112,114,101,40,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,45,49,32,97,110,100,32,97,120,105,115,49,46,109,111,116,111,114,46,101,109,102,46,119,32,62,32,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,32,111,114,32,105,110,105,116,105,97,108,40,41,32,97,110,100,32,97,120,105,115,49,46,109,111,116,111,114,46,101,109,102,46,119,32,62,32,48,46,48,0,0,0,0,0,0,0,97,120,105,115,49,46,109,111,116,111,114,46,101,109,102,46,119,32,62,32,48,46,48,0,97,120,105,115,49,46,109,111,116,111,114,46,101,109,102,46,119,32,60,32,48,46,48,0,116,105,109,101,32,60,61,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,101,110,100,84,105,109,101,0,0,0,0,0,0,0,116,105,109,101,32,60,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,116,105,109,101,32,60,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,84,97,49,115,0,0,0,116,105,109,101,32,60,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,101,110,100,84,105,109,101,0,0,0,0,0,0,0,0,116,105,109,101,32,60,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,84,97,50,115,0,0,0,116,105,109,101,32,60,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,84,118,115,0,0,0,0,112,114,101,40,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,48,32,97,110,100,32,40,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,41,32,111,114,32,112,114,101,40,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,116,97,114,116,66,97,99,107,119,97,114,100,41,32,97,110,100,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,41,32,111,114,32,112,114,101,40,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,49,32,97,110,100,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,60,32,40,45,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,41,32,111,114,32,105,110,105,116,105,97,108,40,41,32,97,110,100,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,60,32,48,46,48,0,0,0,0,0,0,0,0,112,114,101,40,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,48,32,97,110,100,32,40,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,41,32,111,114,32,112,114,101,40,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,116,97,114,116,66,97,99,107,119,97,114,100,41,32,97,110,100,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,41,32,111,114,32,112,114,101,40,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,49,32,97,110,100,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,60,32,40,45,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,41,32,111,114,32,105,110,105,116,105,97,108,40,41,32,97,110,100,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,60,32,48,46,48,0,0,0,0,0,0,0,0,112,114,101,40,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,48,32,97,110,100,32,40,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,32,111,114,32,112,114,101,40,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,116,97,114,116,70,111,114,119,97,114,100,41,32,97,110,100,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,32,111,114,32,112,114,101,40,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,45,49,32,97,110,100,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,62,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,32,111,114,32,105,110,105,116,105,97,108,40,41,32,97,110,100,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,62,32,48,46,48,0,112,114,101,40,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,48,32,97,110,100,32,40,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,41,32,111,114,32,112,114,101,40,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,116,97,114,116,66,97,99,107,119,97,114,100,41,32,97,110,100,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,41,32,111,114,32,112,114,101,40,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,49,32,97,110,100,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,60,32,40,45,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,41,32,111,114,32,105,110,105,116,105,97,108,40,41,32,97,110,100,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,60,32,48,46,48,0,0,0,0,0,0,0,0,112,114,101,40,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,48,32,97,110,100,32,40,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,32,111,114,32,112,114,101,40,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,116,97,114,116,70,111,114,119,97,114,100,41,32,97,110,100,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,32,111,114,32,112,114,101,40,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,45,49,32,97,110,100,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,62,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,32,111,114,32,105,110,105,116,105,97,108,40,41,32,97,110,100,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,62,32,48,46,48,0,112,114,101,40,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,48,32,97,110,100,32,40,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,32,111,114,32,112,114,101,40,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,116,97,114,116,70,111,114,119,97,114,100,41,32,97,110,100,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,32,111,114,32,112,114,101,40,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,41,32,61,61,32,45,49,32,97,110,100,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,62,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,32,111,114,32,105,110,105,116,105,97,108,40,41,32,97,110,100,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,62,32,48,46,48,0,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,62,32,48,46,48,0,0,0,0,0,0,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,60,32,48,46,48,0,0,0,0,0,0,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,62,32,48,46,48,0,0,0,0,0,0,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,60,32,48,46,48,0,0,0,0,0,0,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,62,32,48,46,48,0,0,0,0,0,0,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,60,32,48,46,48,0,0,0,0,0,0,116,105,109,101,32,62,61,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,101,110,100,84,105,109,101,32,43,32,112,97,116,104,80,108,97,110,110,105,110,103,46,115,119,105,110,103,84,105,109,101,0,0,0,0,0,0,1,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,1,0,0,0,53,9,0,0,1,0,0,0,53,9,0,0,1,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,1,0,0,0,70,9,0,0,1,0,0,0,70,9,0,0,1,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,1,0,0,0,88,9,0,0,1,0,0,0,88,9,0,0,1,0,0,0,145,8,0,0,1,0,0,0,132,8,0,0,1,0,0,0,132,8,0,0,1,0,0,0,132,8,0,0,1,0,0,0,132,8,0,0,1,0,0,0,132,8,0,0,1,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,1,0,0,0,139,10,0,0,1,0,0,0,139,10,0,0,1,0,0,0,145,10,0,0,1,0,0,0,145,10,0,0,1,0,0,0,142,10,0,0,1,0,0,0,142,10,0,0,1,0,0,0,112,8,0,0,184,35,0,0,192,35,0,0,200,35,0,0,208,35,0,0,216,35,0,0,224,35,0,0,232,35,0,0,240,35,0,0,248,35,0,0,0,36,0,0,8,36,0,0,16,36,0,0,24,36,0,0,32,36,0,0,40,36,0,0,48,36,0,0,56,36,0,0,64,36,0,0,72,36,0,0,80,36,0,0,88,36,0,0,96,36,0,0,104,36,0,0,112,36,0,0,120,36,0,0,128,36,0,0,136,36,0,0,144,36,0,0,152,36,0,0,160,36,0,0,168,36,0,0,0,0,0,0,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,41,0,0,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,0,0,0,0,0,0,97,120,105,115,51,46,109,111,116,111,114,46,101,109,102,46,119,32,60,32,40,45,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,0,0,0,0,0,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,0,97,120,105,115,51,46,109,111,116,111,114,46,101,109,102,46,119,32,62,32,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,0,0,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,41,0,0,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,0,0,0,0,0,0,97,120,105,115,50,46,109,111,116,111,114,46,101,109,102,46,119,32,60,32,40,45,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,0,0,0,0,0,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,0,97,120,105,115,50,46,109,111,116,111,114,46,101,109,102,46,119,32,62,32,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,0,0,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,41,0,0,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,0,0,0,0,0,0,97,120,105,115,49,46,109,111,116,111,114,46,101,109,102,46,119,32,60,32,40,45,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,0,0,0,0,0,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,0,97,120,105,115,49,46,109,111,116,111,114,46,101,109,102,46,119,32,62,32,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,0,0,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,41,0,0,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,0,0,0,0,0,0,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,60,32,40,45,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,41,0,0,0,0,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,41,0,0,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,0,0,0,0,0,0,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,60,32,40,45,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,41,0,0,0,0,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,0,0,0,0,0,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,0,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,62,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,0,0,0,0,0,0,0,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,41,0,0,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,60,32,40,45,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,41,0,0,0,0,0,0,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,60,32,40,45,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,41,0,0,0,0,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,0,0,0,0,0,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,0,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,62,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,0,0,0,0,0,0,0,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,95,109,97,120,0,0,0,0,0,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,115,97,32,62,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,116,97,117,48,0,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,32,62,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,119,95,115,109,97,108,108,0,0,0,0,0,0,0,48,37,0,0,120,37,0,0,192,37,0,0,152,17,0,0,0,38,0,0,72,38,0,0,136,38,0,0,128,17,0,0,192,38,0,0,8,39,0,0,80,39,0,0,208,20,0,0,144,39,0,0,216,39,0,0,24,40,0,0,184,20,0,0,80,40,0,0,152,40,0,0,224,40,0,0,8,24,0,0,32,41,0,0,104,41,0,0,168,41,0,0,240,23,0,0,32,24,0,0,72,24,0,0,112,24,0,0,144,24,0,0,184,24,0,0,216,24,0,0,224,41,0,0,40,42,0,0,112,42,0,0,80,35,0,0,184,42,0,0,0,43,0,0,72,43,0,0,0,35,0,0,144,43,0,0,216,43,0,0,24,44,0,0,216,34,0,0,96,44,0,0,168,44,0,0,240,44,0,0,176,34,0,0,56,45,0,0,128,45,0,0,192,45,0,0,136,34,0,0,8,46,0,0,80,46,0,0,144,46,0,0,40,35,0,0,120,35,0,0,0,0,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,49,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,112,97,116,104,80,108,97,110,110,105,110,103,46,95,112,97,116,104,84,111,65,120,105,115,54,46,95,109,111,118,105,110,103,91,54,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,112,97,116,104,80,108,97,110,110,105,110,103,46,95,116,101,114,109,105,110,97,116,101,83,105,109,117,108,97,116,105,111,110,46,95,99,111,110,100,105,116,105,111,110,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,49,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,115,116,97,114,116,70,111,114,119,97,114,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,49,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,115,116,97,114,116,66,97,99,107,119,97,114,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,49,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,108,111,99,107,101,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,49,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,109,111,100,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,50,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,115,116,97,114,116,70,111,114,119,97,114,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,50,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,115,116,97,114,116,66,97,99,107,119,97,114,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,50,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,108,111,99,107,101,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,50,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,109,111,100,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,51,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,115,116,97,114,116,70,111,114,119,97,114,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,51,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,115,116,97,114,116,66,97,99,107,119,97,114,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,51,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,108,111,99,107,101,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,51,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,109,111,100,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,52,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,115,116,97,114,116,70,111,114,119,97,114,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,52,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,115,116,97,114,116,66,97,99,107,119,97,114,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,52,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,108,111,99,107,101,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,52,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,109,111,100,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,53,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,115,116,97,114,116,70,111,114,119,97,114,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,53,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,115,116,97,114,116,66,97,99,107,119,97,114,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,53,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,108,111,99,107,101,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,53,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,109,111,100,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,54,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,115,116,97,114,116,70,111,114,119,97,114,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,54,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,115,116,97,114,116,66,97,99,107,119,97,114,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,54,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,108,111,99,107,101,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,120,105,115,54,46,95,103,101,97,114,46,95,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,95,109,111,100,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,97,120,105,115,49,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,112,104,105,95,115,116,97,114,116,46,102,108,97,110,103,101,46,112,104,105,32,45,32,97,120,105,115,49,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,112,104,105,95,115,116,97,114,116,46,112,104,105,95,115,116,97,114,116,0,0,0,0,0,0,0,0,36,68,69,82,46,97,120,105,115,49,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,119,95,115,116,97,114,116,46,102,108,97,110,103,101,46,112,104,105,32,45,32,97,120,105,115,49,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,119,95,115,116,97,114,116,46,119,95,115,116,97,114,116,0,36,68,69,82,46,97,120,105,115,49,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,97,95,115,116,97,114,116,46,119,32,45,32,97,120,105,115,49,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,97,95,115,116,97,114,116,46,97,95,115,116,97,114,116,0,0,36,68,69,82,46,97,120,105,115,49,46,109,111,116,111,114,46,67,46,118,0,0,0,0,36,68,69,82,46,97,120,105,115,49,46,109,111,116,111,114,46,76,97,46,105,0,0,0,97,120,105,115,49,46,103,101,97,114,46,115,112,114,105,110,103,46,119,95,114,101,108,0,97,120,105,115,49,46,103,101,97,114,46,97,95,114,101,108,0,0,0,0,0,0,0,0,97,120,105,115,50,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,112,104,105,95,115,116,97,114,116,46,102,108,97,110,103,101,46,112,104,105,32,45,32,97,120,105,115,50,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,112,104,105,95,115,116,97,114,116,46,112,104,105,95,115,116,97,114,116,0,0,0,0,0,0,0,0,36,68,69,82,46,97,120,105,115,50,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,119,95,115,116,97,114,116,46,102,108,97,110,103,101,46,112,104,105,32,45,32,97,120,105,115,50,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,119,95,115,116,97,114,116,46,119,95,115,116,97,114,116,0,36,68,69,82,46,97,120,105,115,50,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,97,95,115,116,97,114,116,46,119,32,45,32,97,120,105,115,50,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,97,95,115,116,97,114,116,46,97,95,115,116,97,114,116,0,0,36,68,69,82,46,97,120,105,115,50,46,109,111,116,111,114,46,67,46,118,0,0,0,0,36,68,69,82,46,97,120,105,115,50,46,109,111,116,111,114,46,76,97,46,105,0,0,0,97,120,105,115,50,46,103,101,97,114,46,115,112,114,105,110,103,46,119,95,114,101,108,0,97,120,105,115,50,46,103,101,97,114,46,97,95,114,101,108,0,0,0,0,0,0,0,0,97,120,105,115,51,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,112,104,105,95,115,116,97,114,116,46,102,108,97,110,103,101,46,112,104,105,32,45,32,97,120,105,115,51,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,112,104,105,95,115,116,97,114,116,46,112,104,105,95,115,116,97,114,116,0,0,0,0,0,0,0,0,36,68,69,82,46,97,120,105,115,51,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,119,95,115,116,97,114,116,46,102,108,97,110,103,101,46,112,104,105,32,45,32,97,120,105,115,51,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,119,95,115,116,97,114,116,46,119,95,115,116,97,114,116,0,36,68,69,82,46,97,120,105,115,51,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,97,95,115,116,97,114,116,46,119,32,45,32,97,120,105,115,51,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,97,95,115,116,97,114,116,46,97,95,115,116,97,114,116,0,0,36,68,69,82,46,97,120,105,115,51,46,109,111,116,111,114,46,67,46,118,0,0,0,0,36,68,69,82,46,97,120,105,115,51,46,109,111,116,111,114,46,76,97,46,105,0,0,0,97,120,105,115,51,46,103,101,97,114,46,115,112,114,105,110,103,46,119,95,114,101,108,0,97,120,105,115,51,46,103,101,97,114,46,97,95,114,101,108,0,0,0,0,0,0,0,0,97,120,105,115,52,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,112,104,105,95,115,116,97,114,116,46,102,108,97,110,103,101,46,112,104,105,32,45,32,97,120,105,115,52,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,112,104,105,95,115,116,97,114,116,46,112,104,105,95,115,116,97,114,116,0,0,0,0,0,0,0,0,36,68,69,82,46,97,120,105,115,52,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,119,95,115,116,97,114,116,46,102,108,97,110,103,101,46,112,104,105,32,45,32,97,120,105,115,52,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,119,95,115,116,97,114,116,46,119,95,115,116,97,114,116,0,36,68,69,82,46,97,120,105,115,52,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,97,95,115,116,97,114,116,46,119,32,45,32,97,120,105,115,52,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,97,95,115,116,97,114,116,46,97,95,115,116,97,114,116,0,0,36,68,69,82,46,97,120,105,115,52,46,109,111,116,111,114,46,67,46,118,0,0,0,0,36,68,69,82,46,97,120,105,115,52,46,109,111,116,111,114,46,76,97,46,105,0,0,0,97,120,105,115,53,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,112,104,105,95,115,116,97,114,116,46,102,108,97,110,103,101,46,112,104,105,32,45,32,97,120,105,115,53,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,112,104,105,95,115,116,97,114,116,46,112,104,105,95,115,116,97,114,116,0,0,0,0,0,0,0,0,36,68,69,82,46,97,120,105,115,53,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,119,95,115,116,97,114,116,46,102,108,97,110,103,101,46,112,104,105,32,45,32,97,120,105,115,53,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,119,95,115,116,97,114,116,46,119,95,115,116,97,114,116,0,36,68,69,82,46,97,120,105,115,53,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,97,95,115,116,97,114,116,46,119,32,45,32,97,120,105,115,53,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,97,95,115,116,97,114,116,46,97,95,115,116,97,114,116,0,0,36,68,69,82,46,97,120,105,115,53,46,109,111,116,111,114,46,67,46,118,0,0,0,0,36,68,69,82,46,97,120,105,115,53,46,109,111,116,111,114,46,76,97,46,105,0,0,0,97,120,105,115,54,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,112,104,105,95,115,116,97,114,116,46,102,108,97,110,103,101,46,112,104,105,32,45,32,97,120,105,115,54,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,112,104,105,95,115,116,97,114,116,46,112,104,105,95,115,116,97,114,116,0,0,0,0,0,0,0,0,36,68,69,82,46,97,120,105,115,54,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,119,95,115,116,97,114,116,46,102,108,97,110,103,101,46,112,104,105,32,45,32,97,120,105,115,54,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,119,95,115,116,97,114,116,46,119,95,115,116,97,114,116,0,36,68,69,82,46,97,120,105,115,54,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,97,95,115,116,97,114,116,46,119,32,45,32,97,120,105,115,54,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,101,116,95,97,95,115,116,97,114,116,46,97,95,115,116,97,114,116,0,0,36,68,69,82,46,97,120,105,115,54,46,109,111,116,111,114,46,67,46,118,0,0,0,0,36,68,69,82,46,97,120,105,115,54,46,109,111,116,111,114,46,76,97,46,105,0,0,0,56,56,0,0,160,56,0,0,0,57,0,0,88,57,0,0,112,57,0,0,136,57,0,0,160,57,0,0,184,57,0,0,32,58,0,0,128,58,0,0,216,58,0,0,240,58,0,0,8,59,0,0,32,59,0,0,56,59,0,0,160,59,0,0,0,60,0,0,88,60,0,0,112,60,0,0,136,60,0,0,160,60,0,0,184,60,0,0,32,61,0,0,128,61,0,0,216,61,0,0,240,61,0,0,8,62,0,0,112,62,0,0,208,62,0,0,40,63,0,0,64,63,0,0,88,63,0,0,192,63,0,0,32,64,0,0,120,64,0,0,144,64,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,1,0,0,0,22,0,0,0,97,120,105,115,54,46,109,111,116,111,114,46,119,32,42,32,97,120,105,115,54,46,109,111,116,111,114,46,68,32,42,32,50,46,48,0,0,0,0,0,1,0,0,0,23,0,0,0,97,120,105,115,54,46,109,111,116,111,114,46,119,0,0,0,1,0,0,0,58,0,0,0,97,120,105,115,53,46,109,111,116,111,114,46,119,32,42,32,97,120,105,115,53,46,109,111,116,111,114,46,68,32,42,32,50,46,48,0,0,0,0,0,1,0,0,0,59,0,0,0,97,120,105,115,53,46,109,111,116,111,114,46,119,0,0,0,1,0,0,0,94,0,0,0,97,120,105,115,52,46,109,111,116,111,114,46,119,32,42,32,97,120,105,115,52,46,109,111,116,111,114,46,68,32,42,32,50,46,48,0,0,0,0,0,1,0,0,0,95,0,0,0,97,120,105,115,52,46,109,111,116,111,114,46,119,0,0,0,1,0,0,0,132,0,0,0,97,120,105,115,51,46,109,111,116,111,114,46,119,32,42,32,97,120,105,115,51,46,109,111,116,111,114,46,68,32,42,32,50,46,48,0,0,0,0,0,1,0,0,0,133,0,0,0,97,120,105,115,51,46,109,111,116,111,114,46,119,0,0,0,1,0,0,0,170,0,0,0,97,120,105,115,50,46,109,111,116,111,114,46,119,32,42,32,97,120,105,115,50,46,109,111,116,111,114,46,68,32,42,32,50,46,48,0,0,0,0,0,1,0,0,0,171,0,0,0,97,120,105,115,50,46,109,111,116,111,114,46,119,0,0,0,1,0,0,0,208,0,0,0,97,120,105,115,49,46,109,111,116,111,114,46,119,32,42,32,97,120,105,115,49,46,109,111,116,111,114,46,68,32,42,32,50,46,48,0,0,0,0,0,1,0,0,0,209,0,0,0,97,120,105,115,49,46,109,111,116,111,114,46,119,0,0,0,1,0,0,0,11,1,0,0,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,100,101,102,97,117,108,116,87,105,100,116,104,70,114,97,99,116,105,111,110,0,0,0,0,1,0,0,0,21,1,0,0,1,0,0,0,31,1,0,0,1,0,0,0,41,1,0,0,1,0,0,0,51,1,0,0,1,0,0,0,61,1,0,0,1,0,0,0,71,1,0,0,1,0,0,0,80,1,0,0,1,0,0,0,103,1,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,100,95,109,97,120,91,54,93,0,0,1,0,0,0,104,1,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,95,109,97,120,91,54,93,0,0,0,1,0,0,0,105,1,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,100,95,109,97,120,91,53,93,0,0,1,0,0,0,106,1,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,95,109,97,120,91,53,93,0,0,0,1,0,0,0,107,1,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,100,95,109,97,120,91,52,93,0,0,1,0,0,0,108,1,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,95,109,97,120,91,52,93,0,0,0,1,0,0,0,109,1,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,100,95,109,97,120,91,51,93,0,0,1,0,0,0,110,1,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,95,109,97,120,91,51,93,0,0,0,1,0,0,0,111,1,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,100,95,109,97,120,91,50,93,0,0,1,0,0,0,112,1,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,95,109,97,120,91,50,93,0,0,0,1,0,0,0,113,1,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,100,95,109,97,120,91,49,93,0,0,1,0,0,0,114,1,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,95,109,97,120,91,49,93,0,0,0,1,0,0,0,171,1,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,115,100,100,95,109,97,120,95,105,110,118,0,0,0,1,0,0,0,172,1,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,115,100,95,109,97,120,95,105,110,118,0,0,0,0,1,0,0,0,174,1,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,115,100,100,95,109,97,120,0,0,0,0,0,0,0,1,0,0,0,176,1,0,0,0,0,0,0,0,0,0,0,224,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,68,73,86,73,83,73,79,78,40,49,46,48,44,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,115,100,100,95,109,97,120,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,181,1,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,115,100,95,109,97,120,0,0,0,0,0,0,0,0,1,0,0,0,32,2,0,0,97,120,105,115,54,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,0,0,0,1,0,0,0,71,2,0,0,97,120,105,115,53,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,0,0,0,1,0,0,0,110,2,0,0,97,120,105,115,52,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,0,0,0,1,0,0,0,147,3,0,0,97,120,105,115,54,46,103,101,97,114,46,103,101,97,114,46,114,97,116,105,111,0,0,0,1,0,0,0,149,3,0,0,97,120,105,115,54,46,109,111,116,111,114,46,101,109,102,46,107,0,0,0,0,0,0,0,1,0,0,0,161,3,0,0,97,120,105,115,54,46,109,111,116,111,114,46,82,100,49,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,168,3,0,0,97,120,105,115,54,46,109,111,116,111,114,46,99,111,110,118,101,114,116,50,46,107,0,0,1,0,0,0,169,3,0,0,97,120,105,115,54,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,107,0,0,0,1,0,0,0,196,3,0,0,97,120,105,115,53,46,103,101,97,114,46,103,101,97,114,46,114,97,116,105,111,0,0,0,1,0,0,0,198,3,0,0,97,120,105,115,53,46,109,111,116,111,114,46,101,109,102,46,107,0,0,0,0,0,0,0,1,0,0,0,209,3,0,0,97,120,105,115,53,46,109,111,116,111,114,46,82,100,49,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,215,3,0,0,97,120,105,115,53,46,109,111,116,111,114,46,99,111,110,118,101,114,116,50,46,107,0,0,1,0,0,0,216,3,0,0,97,120,105,115,53,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,107,0,0,0,1,0,0,0,225,3,0,0,97,120,105,115,52,46,103,101,97,114,46,103,101,97,114,46,114,97,116,105,111,0,0,0,1,0,0,0,227,3,0,0,97,120,105,115,52,46,109,111,116,111,114,46,101,109,102,46,107,0,0,0,0,0,0,0,1,0,0,0,239,3,0,0,97,120,105,115,52,46,109,111,116,111,114,46,82,100,49,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,246,3,0,0,97,120,105,115,52,46,109,111,116,111,114,46,99,111,110,118,101,114,116,50,46,107,0,0,1,0,0,0,247,3,0,0,97,120,105,115,52,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,107,0,0,0,1,0,0,0,37,4,0,0,97,120,105,115,49,46,103,101,97,114,46,103,101,97,114,46,114,97,116,105,111,0,0,0,1,0,0,0,40,4,0,0,97,120,105,115,49,46,109,111,116,111,114,46,101,109,102,46,107,0,0,0,0,0,0,0,1,0,0,0,51,4,0,0,97,120,105,115,49,46,109,111,116,111,114,46,82,100,49,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,57,4,0,0,97,120,105,115,49,46,109,111,116,111,114,46,99,111,110,118,101,114,116,50,46,107,0,0,1,0,0,0,62,4,0,0,97,120,105,115,49,46,103,101,97,114,46,115,112,114,105,110,103,46,99,0,0,0,0,0,1,0,0,0,75,4,0,0,97,120,105,115,50,46,103,101,97,114,46,103,101,97,114,46,114,97,116,105,111,0,0,0,1,0,0,0,78,4,0,0,97,120,105,115,50,46,109,111,116,111,114,46,101,109,102,46,107,0,0,0,0,0,0,0,1,0,0,0,89,4,0,0,97,120,105,115,50,46,109,111,116,111,114,46,82,100,49,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,95,4,0,0,97,120,105,115,50,46,109,111,116,111,114,46,99,111,110,118,101,114,116,50,46,107,0,0,1,0,0,0,100,4,0,0,97,120,105,115,50,46,103,101,97,114,46,115,112,114,105,110,103,46,99,0,0,0,0,0,1,0,0,0,105,4,0,0,97,120,105,115,50,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,107,0,0,0,1,0,0,0,106,4,0,0,97,120,105,115,50,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,0,0,0,1,0,0,0,108,4,0,0,97,120,105,115,51,46,103,101,97,114,46,103,101,97,114,46,114,97,116,105,111,0,0,0,1,0,0,0,111,4,0,0,97,120,105,115,51,46,109,111,116,111,114,46,101,109,102,46,107,0,0,0,0,0,0,0,1,0,0,0,123,4,0,0,97,120,105,115,51,46,109,111,116,111,114,46,82,100,49,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,0,1,0,0,0,130,4,0,0,97,120,105,115,51,46,109,111,116,111,114,46,99,111,110,118,101,114,116,50,46,107,0,0,1,0,0,0,133,4,0,0,97,120,105,115,51,46,103,101,97,114,46,115,112,114,105,110,103,46,99,0,0,0,0,0,1,0,0,0,138,4,0,0,97,120,105,115,51,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,107,0,0,0,1,0,0,0,139,4,0,0,97,120,105,115,51,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,0,0,0,1,0,0,0,154,4,0,0,97,120,105,115,49,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,107,0,0,0,1,0,0,0,155,4,0,0,97,120,105,115,49,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,0,0,0,2,0,0,0,40,76,0,0,48,76,0,0,0,0,0,0,1,0,0,0,0,76,0,0,8,76,0,0,0,0,0,0,1,0,0,0,215,4,0,0,1,0,0,0,163,5,0,0,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,100,101,102,97,117,108,116,70,114,97,109,101,68,105,97,109,101,116,101,114,70,114,97,99,116,105,111,110,0,0,0,0,1,0,0,0,168,5,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,3,0,0,0,3,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,37,115,40,110,111,109,105,110,97,108,61,37,103,41,0,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,37,115,40,115,116,97,114,116,61,37,103,41,0,0,0,0,1,0,0,0,30,14,0,0,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,100,101,102,97,117,108,116,70,114,97,109,101,68,105,97,109,101,116,101,114,70,114,97,99,116,105,111,110,0,0,0,0,1,0,0,0,37,14,0,0,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,100,101,102,97,117,108,116,87,105,100,116,104,70,114,97,99,116,105,111,110,0,0,0,0,1,0,0,0,77,14,0,0,2,0,0,0,112,148,1,0,120,148,1,0,0,0,0,0,1,0,0,0,72,148,1,0,80,148,1,0,0,0,0,0,1,0,0,0,118,14,0,0,1,0,0,0,156,14,0,0,1,0,0,0,193,14,0,0,1,0,0,0,230,14,0,0,1,0,0,0,11,15,0,0,1,0,0,0,48,15,0,0,1,0,0,0,79,15,0,0,1,0,0,0,92,15,0,0,1,0,0,0,166,15,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,95,109,97,120,91,49,93,0,0,0,1,0,0,0,168,15,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,95,109,97,120,91,50,93,0,0,0,1,0,0,0,170,15,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,95,109,97,120,91,51,93,0,0,0,1,0,0,0,172,15,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,95,109,97,120,91,52,93,0,0,0,1,0,0,0,174,15,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,95,109,97,120,91,53,93,0,0,0,1,0,0,0,176,15,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,95,109,97,120,91,54,93,0,0,0,1,0,0,0,179,15,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,100,95,109,97,120,91,49,93,0,0,1,0,0,0,181,15,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,100,95,109,97,120,91,50,93,0,0,1,0,0,0,183,15,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,100,95,109,97,120,91,51,93,0,0,1,0,0,0,185,15,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,100,95,109,97,120,91,52,93,0,0,1,0,0,0,187,15,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,100,95,109,97,120,91,53,93,0,0,1,0,0,0,189,15,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,112,95,113,100,100,95,109,97,120,91,54,93,0,0,1,0,0,0,191,15,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,115,100,100,95,109,97,120,95,105,110,118,0,0,0,1,0,0,0,192,15,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,115,100,95,109,97,120,95,105,110,118,0,0,0,0,1,0,0,0,193,15,0,0,112,97,116,104,80,108,97,110], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([110,105,110,103,46,112,97,116,104,46,115,100,100,95,109,97,120,0,0,0,0,0,0,0,1,0,0,0,195,15,0,0,0,0,0,0,0,0,0,0,40,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,68,73,86,73,83,73,79,78,40,49,46,48,44,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,115,100,100,95,109,97,120,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,199,15,0,0,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,115,100,95,109,97,120,0,0,0,0,0,0,0,0,1,0,0,0,231,15,0,0,97,120,105,115,49,46,109,111,116,111,114,46,119,32,42,32,97,120,105,115,49,46,109,111,116,111,114,46,68,32,42,32,50,46,48,0,0,0,0,0,1,0,0,0,232,15,0,0,97,120,105,115,49,46,109,111,116,111,114,46,119,0,0,0,1,0,0,0,24,16,0,0,97,120,105,115,50,46,109,111,116,111,114,46,119,32,42,32,97,120,105,115,50,46,109,111,116,111,114,46,68,32,42,32,50,46,48,0,0,0,0,0,1,0,0,0,25,16,0,0,97,120,105,115,50,46,109,111,116,111,114,46,119,0,0,0,1,0,0,0,73,16,0,0,97,120,105,115,51,46,109,111,116,111,114,46,119,32,42,32,97,120,105,115,51,46,109,111,116,111,114,46,68,32,42,32,50,46,48,0,0,0,0,0,1,0,0,0,74,16,0,0,97,120,105,115,51,46,109,111,116,111,114,46,119,0,0,0,1,0,0,0,122,16,0,0,97,120,105,115,52,46,109,111,116,111,114,46,119,32,42,32,97,120,105,115,52,46,109,111,116,111,114,46,68,32,42,32,50,46,48,0,0,0,0,0,1,0,0,0,123,16,0,0,97,120,105,115,52,46,109,111,116,111,114,46,119,0,0,0,1,0,0,0,168,16,0,0,97,120,105,115,53,46,109,111,116,111,114,46,119,32,42,32,97,120,105,115,53,46,109,111,116,111,114,46,68,32,42,32,50,46,48,0,0,0,0,0,1,0,0,0,169,16,0,0,97,120,105,115,53,46,109,111,116,111,114,46,119,0,0,0,1,0,0,0,214,16,0,0,97,120,105,115,54,46,109,111,116,111,114,46,119,32,42,32,97,120,105,115,54,46,109,111,116,111,114,46,68,32,42,32,50,46,48,0,0,0,0,0,1,0,0,0,215,16,0,0,97,120,105,115,54,46,109,111,116,111,114,46,119,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,112,101,97,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,112,101,97,107,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,82,111,116,97,116,105,111,110,97,108,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,78,111,73,110,105,116,32,97,110,100,32,97,120,105,115,54,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,73,110,105,116,105,97,108,79,117,116,112,117,116,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,67,111,110,116,105,110,117,111,117,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,67,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,67,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,66,97,115,105,99,46,109,111,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,120,105,115,54,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,74,109,111,116,111,114,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,74,109,111,116,111,114,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,82,100,51,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,82,100,51,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,82,100,51,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,82,100,51,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,82,100,52,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,82,100,52,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,82,100,52,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,82,100,52,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,82,112,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,82,112,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,82,112,50,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,82,112,50,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,82,112,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,82,112,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,82,112,49,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,82,112,49,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,82,105,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,82,105,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,82,105,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,82,105,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,82,100,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,82,100,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,82,100,49,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,82,100,49,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,82,100,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,82,100,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,82,100,50,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,82,100,50,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,82,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,82,97,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,82,97,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,82,97,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,109,111,116,111,114,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,109,111,116,111,114,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,69,120,97,109,112,108,101,115,47,83,121,115,116,101,109,115,47,82,111,98,111,116,82,51,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,120,105,115,54,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,112,101,97,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,112,101,97,107,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,78,111,73,110,105,116,32,97,110,100,32,97,120,105,115,53,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,73,110,105,116,105,97,108,79,117,116,112,117,116,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,67,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,67,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,120,105,115,53,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,74,109,111,116,111,114,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,74,109,111,116,111,114,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,82,100,51,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,82,100,51,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,82,100,51,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,82,100,51,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,82,100,52,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,82,100,52,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,82,100,52,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,82,100,52,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,82,112,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,82,112,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,82,112,50,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,82,112,50,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,82,112,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,82,112,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,82,112,49,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,82,112,49,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,82,105,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,82,105,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,82,105,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,82,105,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,82,100,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,82,100,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,82,100,49,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,82,100,49,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,82,100,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,82,100,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,82,100,50,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,82,100,50,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,82,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,82,97,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,82,97,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,82,97,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,109,111,116,111,114,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,109,111,116,111,114,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,120,105,115,53,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,112,101,97,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,112,101,97,107,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,78,111,73,110,105,116,32,97,110,100,32,97,120,105,115,52,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,73,110,105,116,105,97,108,79,117,116,112,117,116,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,67,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,67,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,120,105,115,52,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,74,109,111,116,111,114,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,74,109,111,116,111,114,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,82,100,51,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,82,100,51,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,82,100,51,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,82,100,51,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,82,100,52,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,82,100,52,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,82,100,52,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,82,100,52,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,82,112,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,82,112,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,82,112,50,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,82,112,50,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,82,112,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,82,112,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,82,112,49,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,82,112,49,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,82,105,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,82,105,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,82,105,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,82,105,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,82,100,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,82,100,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,82,100,49,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,82,100,49,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,82,100,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,82,100,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,82,100,50,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,82,100,50,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,82,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,82,97,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,82,97,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,82,97,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,109,111,116,111,114,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,109,111,116,111,114,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,120,105,115,52,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,112,101,97,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,112,101,97,107,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,103,101,97,114,46,115,112,114,105], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([110,103,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,103,101,97,114,46,115,112,114,105,110,103,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,103,101,97,114,46,115,112,114,105,110,103,46,99,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,103,101,97,114,46,115,112,114,105,110,103,46,99,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,103,101,97,114,46,115,112,114,105,110,103,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,103,101,97,114,46,115,112,114,105,110,103,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,120,105,115,51,46,103,101,97,114,46,115,112,114,105,110,103,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,103,101,97,114,46,115,112,114,105,110,103,46,112,104,105,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,103,101,97,114,46,115,112,114,105,110,103,46,112,104,105,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,78,111,73,110,105,116,32,97,110,100,32,97,120,105,115,51,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,73,110,105,116,105,97,108,79,117,116,112,117,116,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,67,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,67,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,120,105,115,51,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,74,109,111,116,111,114,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,74,109,111,116,111,114,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,82,100,51,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,82,100,51,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,82,100,51,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,82,100,51,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,82,100,52,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,82,100,52,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,82,100,52,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,82,100,52,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,82,112,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,82,112,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,82,112,50,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,82,112,50,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,82,112,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,82,112,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,82,112,49,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,82,112,49,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,82,105,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,82,105,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,82,105,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,82,105,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,82,100,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,82,100,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,82,100,49,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,82,100,49,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,82,100,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,82,100,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,82,100,50,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,82,100,50,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,82,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,82,97,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,82,97,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,82,97,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,109,111,116,111,114,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,109,111,116,111,114,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,120,105,115,51,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,112,101,97,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,112,101,97,107,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,103,101,97,114,46,115,112,114,105,110,103,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,103,101,97,114,46,115,112,114,105,110,103,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,103,101,97,114,46,115,112,114,105,110,103,46,99,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,103,101,97,114,46,115,112,114,105,110,103,46,99,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,103,101,97,114,46,115,112,114,105,110,103,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,103,101,97,114,46,115,112,114,105,110,103,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,120,105,115,50,46,103,101,97,114,46,115,112,114,105,110,103,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,103,101,97,114,46,115,112,114,105,110,103,46,112,104,105,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,103,101,97,114,46,115,112,114,105,110,103,46,112,104,105,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,78,111,73,110,105,116,32,97,110,100,32,97,120,105,115,50,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,73,110,105,116,105,97,108,79,117,116,112,117,116,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,67,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,67,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,120,105,115,50,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,74,109,111,116,111,114,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,74,109,111,116,111,114,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,82,100,51,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,82,100,51,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,82,100,51,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,82,100,51,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,82,100,52,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,82,100,52,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,82,100,52,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,82,100,52,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,82,112,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,82,112,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,82,112,50,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,82,112,50,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,82,112,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,82,112,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,82,112,49,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,82,112,49,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,82,105,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,82,105,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,82,105,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,82,105,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,82,100,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,82,100,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,82,100,49,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,82,100,49,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,82,100,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,82,100,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,82,100,50,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,82,100,50,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,82,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,82,97,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,82,97,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,82,97,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,109,111,116,111,114,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,109,111,116,111,114,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,120,105,115,50,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,112,101,97,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,112,101,97,107,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,8,83,0,0,193,11,0,0,7,0,0,0,194,11,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,103,101,97,114,46,115,112,114,105,110,103,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,103,101,97,114,46,115,112,114,105,110,103,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,8,83,0,0,238,9,0,0,7,0,0,0,239,9,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,103,101,97,114,46,115,112,114,105,110,103,46,99,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,103,101,97,114,46,115,112,114,105,110,103,46,99,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,8,83,0,0,236,9,0,0,7,0,0,0,237,9,0,0,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,103,101,97,114,46,115,112,114,105,110,103,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,103,101,97,114,46,115,112,114,105,110,103,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,120,105,115,49,46,103,101,97,114,46,115,112,114,105,110,103,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,8,83,0,0,225,26,0,0,7,0,0,0,227,26,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,103,101,97,114,46,115,112,114,105,110,103,46,112,104,105,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,103,101,97,114,46,115,112,114,105,110,103,46,112,104,105,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,8,83,0,0,221,26,0,0,7,0,0,0,224,26,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,78,111,73,110,105,116,32,97,110,100,32,97,120,105,115,49,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,105,110,105,116,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,73,110,105,116,105,97,108,79,117,116,112,117,116,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,72,84,0,0,56,2,0,0,5,0,0,0,59,2,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,99,111,110,116,114,111,108,108,101,114,46,80,73,46,84,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,72,84,0,0,54,2,0,0,5,0,0,0,55,2,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,67,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,67,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,104,85,0,0,27,1,0,0,5,0,0,0,27,1,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,120,105,115,49,46,109,111,116,111,114,46,74,109,111,116,111,114,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,8,83,0,0,253,8,0,0,7,0,0,0,255,8,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,74,109,111,116,111,114,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,74,109,111,116,111,114,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,8,83,0,0,252,8,0,0,7,0,0,0,252,8,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,82,100,51,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,82,100,51,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,82,100,51,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,82,100,51,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,82,100,52,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,82,100,52,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,82,100,52,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,82,100,52,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,82,112,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,82,112,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,82,112,50,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,82,112,50,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,82,112,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,82,112,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,82,112,49,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,82,112,49,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,82,105,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,82,105,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,82,105,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,82,105,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,82,100,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,82,100,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,82,100,49,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,82,100,49,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,82,100,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,82,100,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,82,100,50,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,82,100,50,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,82,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,82,97,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,88,87,0,0,50,1,0,0,5,0,0,0,51,1,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,82,97,46], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,82,97,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,104,85,0,0,64,0,0,0,3,0,0,0,64,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,109,111,116,111,114,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,109,111,116,111,114,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,104,94,0,0,40,4,0,0,7,0,0,0,40,4,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,120,105,115,49,46,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,8,83,0,0,134,18,0,0,7,0,0,0,135,18,0,0,59,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,104,94,0,0,117,5,0,0,7,0,0,0,118,5,0,0,43,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,100,95,109,97,120,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,100,95,109,97,120,91,54,93,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,83,111,117,114,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,100,95,109,97,120,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,100,95,109,97,120,91,53,93,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,100,95,109,97,120,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,100,95,109,97,120,91,52,93,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,100,95,109,97,120,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,100,95,109,97,120,91,51,93,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,100,95,109,97,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,100,95,109,97,120,91,50,93,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,100,95,109,97,120,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,100,95,109,97,120,91,49,93,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,192,162,0,0,199,6,0,0,5,0,0,0,200,6,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,95,109,97,120,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,95,109,97,120,91,54,93,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,95,109,97,120,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,95,109,97,120,91,53,93,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,95,109,97,120,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,95,109,97,120,91,52,93,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,95,109,97,120,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,95,109,97,120,91,51,93,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,95,109,97,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,95,109,97,120,91,50,93,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,95,109,97,120,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,97,116,104,80,108,97,110,110,105,110,103,46,112,97,116,104,46,113,100,95,109,97,120,91,49,93,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,192,162,0,0,197,6,0,0,5,0,0,0,198,6,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,80,97,114,116,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+40960);
/* memory initializer */ allocate([117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+51200);
/* memory initializer */ allocate([46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,109,32,62,61,32,48,46], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+61440);
/* memory initializer */ allocate([48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,56,169,0,0,139,4,0,0,5,0,0,0,143,4,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,56,169,0,0,123,4,0,0,5,0,0,0,126,4,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,56,169,0,0,118,4,0,0,5,0,0,0,122,4,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,56,169,0,0,225,2,0,0,5,0,0,0,229,2,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,56,169,0,0,214,2,0,0,5,0,0,0,218,2,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,56,169,0,0,248,2,0,0,5,0,0,0,251,2,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,56,169,0,0,190,2,0,0,5,0,0,0,192,2,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,56,169,0,0,165,2,0,0,5,0,0,0,167,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,56,169,0,0,162,2,0,0,5,0,0,0,164,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,56,169,0,0,159,2,0,0,5,0,0,0,161,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,56,169,0,0,156,2,0,0,5,0,0,0,158,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,56,169,0,0,153,2,0,0,5,0,0,0,155,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,56,169,0,0,150,2,0,0,5,0,0,0,152,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,56,169,0,0,149,2,0,0,5,0,0,0,149,2,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,56,169,0,0,195,0,0,0,5,0,0,0,198,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,56,169,0,0,190,0,0,0,5,0,0,0,194,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,56,169,0,0,162,4,0,0,5,0,0,0,165,4,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,56,169,0,0,66,4,0,0,5,0,0,0,68,4,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,56,169,0,0,41,4,0,0,5,0,0,0,43,4,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,56,169,0,0,38,4,0,0,5,0,0,0,40,4,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,56,169,0,0,35,4,0,0,5,0,0,0,37,4,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,56,169,0,0,32,4,0,0,5,0,0,0,34,4,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,56,169,0,0,29,4,0,0,5,0,0,0,31,4,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,56,169,0,0,26,4,0,0,5,0,0,0,28,4,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,56,169,0,0,25,4,0,0,5,0,0,0,25,4,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,54,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,54,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,74,111,105,110,116,115,46,109,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+71680);
/* memory initializer */ allocate([86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,54,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,54,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,54,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,54,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,54,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,53,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,53,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,53,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,53,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,53,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,53,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,53,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,52,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,52,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,52,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,52,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,52,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,52,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,52,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,51,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,51,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,51,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,51,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,51,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,51,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,51,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,50,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,50,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,50,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,50,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,50,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,176,63,1,0,247,0,0,0,5,0,0,0,249,0,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,176,63,1,0,244,0,0,0,5,0,0,0,246,0,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,49,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,49,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,49,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,176,63,1,0,1,1,0,0,5,0,0,0,2,1,0,0,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,109,76,111,97,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,109,76,111,97,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,104,94,0,0,5,6,0,0,7,0,0,0,5,6,0,0,55,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,248,74,1,0,189,4,0,0,3,0,0,0,193,4,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,97,120,105,115,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,97,120,105,115,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,248,74,1,0,167,4,0,0,3,0,0,0,169,4,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,97,120,105,115,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,97,120,105,115,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,248,74,1,0,164,4,0,0,3,0,0,0,166,4,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,100,101,102,97,117,108,116,78,109,95,116,111,95,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,100,101,102,97,117,108,116,78,109,95,116,111,95,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,248,74,1,0,243,4,0,0,3,0,0,0,245,4,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,100,101,102,97,117,108,116,78,95,116,111,95,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,100,101,102,97,117,108,116,78,95,116,111,95,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,248,74,1,0,240,4,0,0,3,0,0,0,242,4,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,100,101,102,97,117,108,116,83,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,100,101,102,97,117,108,116,83,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,248,74,1,0,237,4,0,0,3,0,0,0,239,4,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,248,74,1,0,198,4,0,0,3,0,0,0,202,4,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,109,117,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,109,117,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,248,74,1,0,156,4,0,0,3,0,0,0,160,4,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,71,114,97,118,105,116,121,84,121,112,101,115,46,78,111,71,114,97,118,105,116,121,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,71,114,97,118,105,116,121,84,121,112,101,115,46,80,111,105,110,116,71,114,97,118,105,116,121,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,248,74,1,0,148,4,0,0,3,0,0,0,149,4,0,0,155,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,76,111,97,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,76,111,97,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,104,94,0,0,81,0,0,0,5,0,0,0,81,0,0,0,55,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,108,111,97,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,54,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,54,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,54,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,53,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,53,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,53,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,102,114], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+81928);
/* memory initializer */ allocate([97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,56,169,0,0,133,4,0,0,5,0,0,0,138,4,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,56,169,0,0,219,2,0,0,5,0,0,0,224,2,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,98,48,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,98,48,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,98,48,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,56,169,0,0,205,0,0,0,5,0,0,0,210,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,54,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,54,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,54,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,54,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,54,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,54,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,54,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,54,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,54,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,53,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,53,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,53,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,53,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,53,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,53,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,53,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,53,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,53,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,52,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,52,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,52,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,52,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,52,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,52,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,52,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,52,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,52,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,51,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,51,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,51,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,51,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,51,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,51,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,51,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,51,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,51,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,114,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,114,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,114,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,176,63,1,0,250,0,0,0,5,0,0,0,252,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,248,74,1,0,172,4,0,0,3,0,0,0,174,4,0,0,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+92168);
/* memory initializer */ allocate([108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,248,74,1,0,203,4,0,0,3,0,0,0,206,4,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,109,101,99,104,97,110,105,99,115,46,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,248,74,1,0,194,4,0,0,3,0,0,0,197,4,0,0,101,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,3,0,0,0,3,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,62,61,32,45,49,32,97,110,100,32,97,120,105,115,49,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,82,111,116,97,116,105,111,110,97,108,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,62,61,32,45,49,32,97,110,100,32,97,120,105,115,50,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,62,61,32,45,49,32,97,110,100,32,97,120,105,115,51,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,62,61,32,45,49,32,97,110,100,32,97,120,105,115,52,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,62,61,32,45,49,32,97,110,100,32,97,120,105,115,53,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,62,61,32,45,49,32,97,110,100,32,97,120,105,115,54,46,103,101,97,114,46,98,101,97,114,105,110,103,70,114,105,99,116,105,111,110,46,109,111,100,101,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,112,149,1,0,37,29,0,0,7,0,0,0,41,29,0,0,20,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,99,104,97,110,105,99,115,95,77,117,108,116,105,66,111,100,121,95,69,120,97,109,112,108,101,115,95,83,121,115,116,101,109,115,95,82,111,98,111,116,82,51,95,102,117,108,108,82,111,98,111,116,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,51,54,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,51,54,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,51,54,44,51,54,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,51,54,44,48,93,32,61,32,122,101,114,111,115,40,51,54,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,51,54,93,32,61,32,122,101,114,111,115,40,48,44,51,54,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,51,54,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,54,80,99,111,110,116,114,111,108,108,101,114,80,80,73,80,120,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,54,80,109,111,116,111,114,80,67,80,118,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,54,80,109,111,116,111,114,80,76,97,80,105,32,61,32,120,91,51,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,54,80,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,80,115,101,116,95,119,95,115,116,97,114,116,80,102,108,97,110,103,101,80,112,104,105,32,61,32,120,91,52,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,53,80,99,111,110,116,114,111,108,108,101,114,80,80,73,80,120,32,61,32,120,91,53,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,53,80,109,111,116,111,114,80,67,80,118,32,61,32,120,91,54,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,53,80,109,111,116,111,114,80,76,97,80,105,32,61,32,120,91,55,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,53,80,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,80,115,101,116,95,119,95,115,116,97,114,116,80,102,108,97,110,103,101,80,112,104,105,32,61,32,120,91,56,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,52,80,99,111,110,116,114,111,108,108,101,114,80,80,73,80,120,32,61,32,120,91,57,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,52,80,109,111,116,111,114,80,67,80,118,32,61,32,120,91,49,48,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,52,80,109,111,116,111,114,80,76,97,80,105,32,61,32,120,91,49,49,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,52,80,105,110,105,116,105,97,108,105,122,101,70,108,97,110,103,101,80,115,101,116,95,119,95,115,116,97,114,116,80,102,108,97,110,103,101,80,112,104,105,32,61,32,120,91,49,50,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,51,80,103,101,97,114,80,115,112,114,105,110,103,80,119,95,114,101,108,32,61,32,120,91,49,51,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,51,80,103,101,97,114,80,115,112,114,105,110,103,80,112,104,105,95,114,101,108,32,61,32,120,91,49,52,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,51,80,103,101,97,114,80,103,101,97,114,80,112,104,105,95,97,32,61,32,120,91,49,53,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,51,80,99,111,110,116,114,111,108,108,101,114,80,80,73,80,120,32,61,32,120,91,49,54,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,51,80,109,111,116,111,114,80,67,80,118,32,61,32,120,91,49,55,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,51,80,109,111,116,111,114,80,76,97,80,105,32,61,32,120,91,49,56,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,50,80,103,101,97,114,80,115,112,114,105,110,103,80,119,95,114,101,108,32,61,32,120,91,49,57,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,50,80,103,101,97,114,80,115,112,114,105,110,103,80,112,104,105,95,114,101,108,32,61,32,120,91,50,48,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,50,80,103,101,97,114,80,103,101,97,114,80,112,104,105,95,97,32,61,32,120,91,50,49,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,50,80,99,111,110,116,114,111,108,108,101,114,80,80,73,80,120,32,61,32,120,91,50,50,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,50,80,109,111,116,111,114,80,67,80,118,32,61,32,120,91,50,51,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,50,80,109,111,116,111,114,80,76,97,80,105,32,61,32,120,91,50,52,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,49,80,103,101,97,114,80,115,112,114,105,110,103,80,119,95,114,101,108,32,61,32,120,91,50,53,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,49,80,103,101,97,114,80,115,112,114,105,110,103,80,112,104,105,95,114,101,108,32,61,32,120,91,50,54,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,49,80,103,101,97,114,80,103,101,97,114,80,112,104,105,95,97,32,61,32,120,91,50,55,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,49,80,99,111,110,116,114,111,108,108,101,114,80,80,73,80,120,32,61,32,120,91,50,56,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,49,80,109,111,116,111,114,80,67,80,118,32,61,32,120,91,50,57,93,59,10,32,32,82,101,97,108,32,120,95,80,97,120,105,115,49,80,109,111,116,111,114,80,76,97,80,105,32,61,32,120,91,51,48,93,59,10,32,32,82,101,97,108,32,120,95,80,109,101,99,104,97,110,105,99,115,80,114,54,80,119,32,61,32,120,91,51,49,93,59,10,32,32,82,101,97,108,32,120,95,80,109,101,99,104,97,110,105,99,115,80,114,53,80,119,32,61,32,120,91,51,50,93,59,10,32,32,82,101,97,108,32,120,95,80,109,101,99,104,97,110,105,99,115,80,114,52,80,119,32,61,32,120,91,51,51,93,59,10,32,32,82,101,97,108,32,120,95,80,109,101,99,104,97,110,105,99,115,80,114,51,80,119,32,61,32,120,91,51,52,93,59,10,32,32,82,101,97,108,32,120,95,80,109,101,99,104,97,110,105,99,115,80,114,50,80,119,32,61,32,120,91,51,53,93,59,10,32,32,82,101,97,108,32,120,95,80,109,101,99,104,97,110,105,99,115,80,114,49,80,119,32,61,32,120,91,51,54,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,99,104,97,110,105,99,115,95,77,117,108,116,105,66,111,100,121,95,69,120,97,109,112,108,101,115,95,83,121,115,116,101,109,115,95,82,111,98,111,116,82,51,95,102,117,108,108,82,111,98,111,116,59,10,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,164,1,0,128,164,1,0,144,164,1,0,168,164,1,0,200,164,1,0,216,164,1,0,240,164,1,0,0,165,1,0,24,165,1,0,56,165,1,0,96,165,1,0,120,165,1,0,152,165,1,0,176,165,1,0,216,165,1,0,248,165,1,0,40,166,1,0,88,166,1,0,112,166,1,0,168,166,1,0,192,166,1,0,240,166,1,0,16,167,1,0,72,167,1,0,112,167,1,0,168,167,1,0,216,167,1,0,232,167,1,0,8,168,1,0,48,168,1,0,80,168,1,0,120,168,1,0,160,168,1,0,184,168,1,0,208,168,1,0,224,168,1,0,248,168,1,0,40,169,1,0,120,169,1,0,184,169,1,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,232,183,1,0,120,182,1,0,0,181,1,0,136,179,1,0,136,179,1,0,16,178,1,0,0,181,1,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+102408);
/* memory initializer */ allocate([26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,176,194,1,0,56,191,1,0,200,189,1,0,88,188,1,0,88,188,1,0,232,186,1,0,200,189,1,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,248,192,1,0,8,193,1,0,24,193,1,0,232,177,1,0,32,193,1,0,48,193,1,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,144,196,1,0,152,196,1,0,160,196,1,0,168,196,1,0,32,196,1,0,176,196,1,0,192,196,1,0,200,196,1,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,117,116,105,108,47,98,97,115,101,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,97,45,62,110,100,105,109,115,32,33,61,32,98,45,62,110,100,105,109,115,44,32,37,100,32,33,61,32,37,100,10,0,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,33,61,32,98,45,62,100,105,109,95,115,105,122,101,91,37,100,93,44,32,37,100,32,33,61,32,37,100,10,0,0,0,0,0,0,0,0,0,0,0,80,198,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,105,122,101,95,111,102,95,100,105,109,101,110,115,105,111,110,95,98,97,115,101,95,97,114,114,97,121,0,0,0,0,40,105,32,62,32,48,41,32,38,38,32,40,105,32,60,61,32,97,45,62,110,100,105,109,115,41,0,0,0,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,8,199,1,0,24,199,1,0,32,199,1,0,40,199,1,0,56,199,1,0,72,199,1,0,80,199,1,0,96,199,1,0,112,199,1,0,128,199,1,0,144,199,1,0,160,199,1,0,176,199,1,0,192,199,1,0,208,199,1,0,216,199,1,0,224,199,1,0,240,199,1,0,248,199,1,0,8,200,1,0,24,200,1,0,40,200,1,0,56,200,1,0,72,200,1,0,88,200,1,0,104,200,1,0,120,200,1,0,136,200,1,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,16,201,1,0,24,201,1,0,24,201,1,0,56,201,1,0,104,201,1,0,136,201,1,0,192,201,1,0,240,201,1,0,32,202,1,0,64,202,1,0,112,202,1,0,136,202,1,0,168,202,1,0,208,202,1,0,240,202,1,0,32,203,1,0,64,203,1,0,104,203,1,0,136,203,1,0,176,203,1,0,224,203,1,0,24,204,1,0,64,204,1,0,112,204,1,0,160,204,1,0,200,204,1,0,248,204,1,0,0,205,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,16,201,1,0,0,208,1,0,8,208,1,0,16,208,1,0,32,199,1,0,24,208,1,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,112,209,1,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,136,209,1,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,160,209,1,0,168,209,1,0,176,209,1,0,192,209,1,0,208,209,1,0,216,209,1,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,100,101,115,116,41,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,115,104,97,112,101,95,101,113,40,115,111,117,114,99,101,44,32,100,101,115,116,41,0,0,0,0,0,0,0,101,108,116,115,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,62,61,32,107,0,0,0,0,0,99,97,116,95,97,108,108,111,99,95,114,101,97,108,95,97,114,114,97,121,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,61,61,32,101,108,116,115,91,105,93,45,62,110,100,105,109,115,0,0,0,0,0,0,0,0,101,108,116,115,91,48,93,45,62,100,105,109,95,115,105,122,101,91,106,93,32,61,61,32,101,108,116,115,91,105,93,45,62,100,105,109,95,115,105,122,101,91,106,93,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,109,97,120,95,114,101,97,108,95,97,114,114,97,121,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,240,221,1,0,0,0,0,0,104,221,1,0,0,0,0,0,224,220,1,0,0,0,0,0,88,220,1,0,0,0,0,0,80,219,1,0,0,0,0,0,72,218,1,0,0,0,0,0,64,217,1,0,0,0,0,0,56,216,1,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+112648);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,216,223,1,0,232,223,1,0,240,223,1,0,248,223,1,0,8,224,1,0,16,224,1,0,24,224,1,0,32,224,1,0,40,224,1,0,48,224,1,0,56,224,1,0,72,224,1,0,80,224,1,0,96,224,1,0,112,224,1,0,128,224,1,0,136,224,1,0,152,224,1,0,160,224,1,0,176,224,1,0,184,224,1,0,208,224,1,0,216,224,1,0,224,224,1,0,240,224,1,0,248,224,1,0,8,225,1,0,24,225,1,0,32,225,1,0,40,225,1,0,48,225,1,0,56,225,1,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,200,225,1,0,208,225,1,0,24,226,1,0,72,226,1,0,120,226,1,0,192,226,1,0,0,227,1,0,72,227,1,0,120,227,1,0,192,227,1,0,216,227,1,0,248,227,1,0,48,228,1,0,88,228,1,0,128,228,1,0,184,228,1,0,8,229,1,0,104,229,1,0,152,229,1,0,208,229,1,0,0,230,1,0,72,230,1,0,112,230,1,0,160,230,1,0,208,230,1,0,40,231,1,0,112,231,1,0,224,231,1,0,16,232,1,0,88,232,1,0,120,232,1,0,56,225,1,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,200,225,1,0,56,233,1,0,224,233,1,0,72,226,1,0,120,226,1,0,72,234,1,0,0,227,1,0,72,227,1,0,208,234,1,0,16,235,1,0,216,227,1,0,248,227,1,0,176,235,1,0,240,235,1,0,48,236,1,0,184,228,1,0,8,229,1,0,112,236,1,0,168,236,1,0,48,237,1,0,88,237,1,0,72,230,1,0,112,230,1,0,160,230,1,0,192,237,1,0,72,238,1,0,72,239,1,0,224,231,1,0,16,232,1,0,88,232,1,0,120,232,1,0,56,225,1,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,244,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,244,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,244,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,245,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,245,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+122480);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,224,6,2,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+132824);
/* memory initializer */ allocate([96,11,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,11,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,11,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,11,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,11,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,11,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,11,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,11,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,12,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,12,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,12,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,12,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,12,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,12,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,12,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,13,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,13,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,13,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,11,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,13,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,13,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,14,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,14,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,14,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,15,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,16,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,16,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,16,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,16,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,16,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,16,2,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,48,52,2,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,53,2,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,96,53,2,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,184,53,2,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,54,2,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,24,54,2,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,96,54,2,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,176,54,2,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,96,54,2,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,232,66,2,0,8,68,2,0,16,68,2,0,32,68,2,0,48,68,2,0,64,68,2,0,88,68,2,0,112,68,2,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,232,66,2,0,240,66,2,0,56,67,2,0,96,67,2,0,128,67,2,0,160,67,2,0,200,67,2,0,240,67,2,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,65,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,0,0,0,0,0,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,37,115,0,0,0,0,0,0,98,32,118,101,99,116,111,114,32,91,37,100,93,0,0,0,69,114,114,111,114,32,115,111,108,118,105,110,103,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,46,32,65,114,103,117,109,101,110,116,32,37,100,32,105,108,108,101,103,97,108,46,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,115,111,108,118,101,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,44,32,115,121,115,116,101,109,32,105,115,32,115,105,110,103,117,108,97,114,32,102,111,114,32,85,91,37,100,44,32,37,100,93,46,0,0,0,0,0,0,0,37,115,37,49,48,103,32,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,88,76,2,0,104,76,2,0,112,76,2,0,120,76,2,0,128,76,2,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,160,76,2,0,168,76,2,0,184,76,2,0,200,76,2,0,128,76,2,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+143508);
/* memory initializer */ allocate([114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,136,103,2,0,80,105,2,0,88,105,2,0,96,105,2,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,136,103,2,0,144,104,2,0,224,104,2,0,16,105,2,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,136,103,2,0,80,104,2,0,88,104,2,0,96,104,2,0,112,104,2,0,120,104,2,0,136,104,2,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,136,103,2,0,144,103,2,0,168,103,2,0,184,103,2,0,0,104,2,0,16,104,2,0,48,104,2,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,56,115,2,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,56,115,2,0,10,0,0,0,11,0,0,0,220,114,2,0,84,115,2,0,104,115,2,0,240,114,2,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,24,45,3,0,8,115,2,0,160,232,2,0,0,0,0,0,104,0,0,0,0,0,0,0,160,232,2,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,160,232,2,0,14,0,0,0,15,0,0,0,0,0,0,0,224,115,2,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,24,45,3,0,176,115,2,0,152,231,2,0,0,0,0,0,0,0,0,0,104,116,2,0,112,116,2,0,96,116,2,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,64,116,2,0,80,116,2,0,96,116,2,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+153748);
/* memory initializer */ allocate([32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114,32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,192,132,2,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,192,132,2,0,20,0,0,0,21,0,0,0,100,132,2,0,220,132,2,0,240,132,2,0,120,132,2,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,24,45,3,0,144,132,2,0,16,232,2,0,0,0,0,0,108,0,0,0,0,0,0,0,16,232,2,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,16,232,2,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,200,142,2,0,176,144,2,0,184,144,2,0,0,147,2,0,24,145,2,0,40,145,2,0,8,147,2,0,16,147,2,0,24,147,2,0,32,147,2,0,48,147,2,0,64,147,2,0,80,147,2,0,96,147,2,0,112,147,2,0,128,147,2,0,144,147,2,0,168,147,2,0,224,146,2,0,248,146,2,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,200,142,2,0,176,144,2,0,184,144,2,0,200,144,2,0,24,145,2,0,40,145,2,0,56,145,2,0,88,145,2,0,120,145,2,0,152,145,2,0,192,145,2,0,232,145,2,0,16,146,2,0,56,146,2,0,80,146,2,0,112,146,2,0,144,146,2,0,184,146,2,0,224,146,2,0,248,146,2,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,200,142,2,0,144,144,2,0,152,144,2,0,160,144,2,0,200,142,2,0,208,143,2,0,32,144,2,0,80,144,2,0,200,142,2,0,144,143,2,0,152,143,2,0,160,143,2,0,176,143,2,0,184,143,2,0,200,143,2,0,0,0,0,0,200,142,2,0,208,142,2,0,232,142,2,0,248,142,2,0,64,143,2,0,80,143,2,0,112,143,2,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,232,149,2,0,26,0,0,0,27,0,0,0,200,255,255,255,200,255,255,255,232,149,2,0,28,0,0,0,29,0,0,0,116,149,2,0,4,150,2,0,24,150,2,0,136,149,2,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,24,45,3,0,160,149,2,0,160,232,2,0,0,0,0,0,56,0,0,0,0,0,0,0,160,232,2,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,160,232,2,0,14,0,0,0,15,0,0,0,0,0,0,0,168,150,2,0,30,0,0,0,31,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,24,45,3,0,96,150,2,0,152,231,2,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+163988);
/* memory initializer */ allocate([114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,56,171,2,0,56,171,2,0,56,171,2,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,224,173,2,0,240,173,2,0,8,174,2,0,40,174,2,0,72,174,2,0,96,174,2,0,128,174,2,0,152,174,2,0,168,174,2,0,184,174,2,0,208,174,2,0,232,174,2,0,8,175,2,0,40,175,2,0,184,174,2,0,64,175,2,0,96,175,2,0,120,175,2,0,144,175,2,0,168,175,2,0,200,175,2,0,216,175,2,0,248,175,2,0,24,176,2,0,48,176,2,0,72,176,2,0,96,176,2,0,112,176,2,0,136,176,2,0,160,176,2,0,184,176,2,0,216,176,2,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+174228);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+181384);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,224,217,2,0,232,217,2,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,248,217,2,0,0,218,2,0,8,218,2,0,16,218,2,0,144,1,0,0,0,0,0,0,128,218,2,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+186608);
/* memory initializer */ allocate([88,225,2,0,32,0,0,0,33,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,24,45,3,0,56,225,2,0,216,231,2,0,0,0,0,0,0,0,0,0,192,225,2,0,34,0,0,0,35,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,24,45,3,0,168,225,2,0,216,231,2,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,88,226,2,0,36,0,0,0,37,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,24,45,3,0,56,226,2,0,152,231,2,0,0,0,0,0,0,0,0,0,192,226,2,0,38,0,0,0,39,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,24,45,3,0,168,226,2,0,152,231,2,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,240,44,3,0,208,226,2,0,0,0,0,0,56,227,2,0,40,0,0,0,41,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,224,227,2,0,42,0,0,0,43,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,24,45,3,0,40,227,2,0,0,0,0,0,0,0,0,0,0,0,0,0,120,227,2,0,40,0,0,0,44,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,24,45,3,0,96,227,2,0,56,227,2,0,0,0,0,0,0,0,0,0,184,227,2,0,40,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,24,45,3,0,160,227,2,0,56,227,2,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,24,45,3,0,200,227,2,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,40,228,2,0,46,0,0,0,47,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,24,45,3,0,16,228,2,0,224,227,2,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,240,44,3,0,56,228,2,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,24,45,3,0,96,228,2,0,88,228,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,16,231,2,0,48,0,0,0,49,0,0,0,0,0,0,0,152,231,2,0,50,0,0,0,51,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,216,231,2,0,52,0,0,0,53,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,16,232,2,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,16,232,2,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,88,232,2,0,54,0,0,0,55,0,0,0,248,255,255,255,248,255,255,255,88,232,2,0,56,0,0,0,57,0,0,0,4,0,0,0,0,0,0,0,160,232,2,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,160,232,2,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,232,232,2,0,58,0,0,0,59,0,0,0,252,255,255,255,252,255,255,255,232,232,2,0,60,0,0,0,61,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,230,2,0,62,0,0,0,63,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,216,230,2,0,64,0,0,0,65,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,24,45,3,0,144,230,2,0,40,228,2,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,240,44,3,0,192,230,2,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,24,45,3,0,224,230,2,0,216,230,2,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,24,45,3,0,32,231,2,0,216,230,2,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,240,44,3,0,96,231,2,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,240,44,3,0,160,231,2,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,120,45,3,0,224,231,2,0,0,0,0,0,1,0,0,0,16,231,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,120,45,3,0,40,232,2,0,0,0,0,0,1,0,0,0,80,231,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,120,45,3,0,112,232,2,0,0,0,0,0,1,0,0,0,16,231,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,120,45,3,0,184,232,2,0,0,0,0,0,1,0,0,0,80,231,2,0,3,244,255,255,0,0,0,0,72,233,2,0,66,0,0,0,67,0,0,0,50,0,0,0,3,0,0,0,17,0,0,0,18,0,0,0,4,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,24,45,3,0,40,233,2,0,120,228,2,0,0,0,0,0,0,0,0,0,112,247,2,0,68,0,0,0,69,0,0,0,70,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,247,2,0,71,0,0,0,72,0,0,0,70,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,252,2,0,73,0,0,0,74,0,0,0,70,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,224,252,2,0,75,0,0,0,76,0,0,0,70,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,253,2,0,77,0,0,0,78,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,254,2,0,79,0,0,0,80,0,0,0,70,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,96,249,2,0,81,0,0,0,82,0,0,0,70,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,96,249,2,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,250,2,0,83,0,0,0,84,0,0,0,70,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,0,250,2,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,144,250,2,0,85,0,0,0,86,0,0,0,70,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,250,2,0,87,0,0,0,88,0,0,0,70,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,247,2,0,89,0,0,0,90,0,0,0,70,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,248,2,0,91,0,0,0,92,0,0,0,70,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,248,2,0,93,0,0,0,94,0,0,0,70,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,248,2,0,95,0,0,0,96,0,0,0,70,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,254,2,0,97,0,0,0,98,0,0,0,70,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,88,255,2,0,99,0,0,0,100,0,0,0,70,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,232,255,2,0,101,0,0,0,102,0,0,0,70,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,120,0,3,0,103,0,0,0,104,0,0,0,70,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,251,2,0,105,0,0,0,106,0,0,0,70,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,251,2,0,107,0,0,0,108,0,0,0,70,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,72,247,2,0,109,0,0,0,110,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,244,2,0,111,0,0,0,112,0,0,0,70,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,245,2,0,113,0,0,0,114,0,0,0,70,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,246,2,0,115,0,0,0,116,0,0,0,70,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,32,247,2,0,117,0,0,0,118,0,0,0,70,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,88,243,2,0,119,0,0,0,120,0,0,0,70,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,24,45,3,0,64,243,2,0,240,226,2,0,0,0,0,0,0,0,0,0,232,243,2,0,119,0,0,0,121,0,0,0,70,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,240,44,3,0,200,243,2,0,120,45,3,0,176,243,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,224,243,2,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,120,45,3,0,8,244,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,224,243,2,0,2,0,0,0,0,0,0,0,184,244,2,0,119,0,0,0,122,0,0,0,70,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,240,44,3,0,152,244,2,0,120,45,3,0,112,244,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,176,244,2,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,120,45,3,0,216,244,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,176,244,2,0,2,0,0,0,0,0,0,0,120,245,2,0,119,0,0,0,123,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,120,45,3,0,80,245,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,176,244,2,0,2,0,0,0,0,0,0,0,240,245,2,0,119,0,0,0,124,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,120,45,3,0,200,245,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,176,244,2,0,2,0,0,0,0,0,0,0,104,246,2,0,119,0,0,0,125,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,24,45,3,0,64,246,2,0,240,245,2,0,0,0,0,0,0,0,0,0,208,246,2,0,119,0,0,0,126,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,24,45,3,0,168,246,2,0,240,245,2,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,24,45,3,0,224,246,2,0,88,243,2,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,24,45,3,0,8,247,2,0,88,243,2,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,24,45,3,0,48,247,2,0,88,243,2,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,24,45,3,0,88,247,2,0,88,243,2,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,24,45,3,0,128,247,2,0,88,243,2,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,240,44,3,0,200,247,2,0,120,45,3,0,168,247,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,224,247,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,120,45,3,0,8,248,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,224,247,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,120,45,3,0,72,248,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,224,247,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,120,45,3,0,136,248,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,224,247,2,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,240,44,3,0,16,249,2,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,240,44,3,0,48,249,2,0,120,45,3,0,200,248,2,0,0,0,0,0,3,0,0,0,88,243,2,0,2,0,0,0,40,249,2,0,2,0,0,0,88,249,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,240,44,3,0,208,249,2,0,120,45,3,0,136,249,2,0,0,0,0,0,3,0,0,0,88,243,2,0,2,0,0,0,40,249,2,0,2,0,0,0,248,249,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,240,44,3,0,112,250,2,0,120,45,3,0,40,250,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,136,250,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,120,45,3,0,176,250,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,136,250,2,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,240,44,3,0,48,251,2,0,120,45,3,0,24,251,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,72,251,2,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,120,45,3,0,112,251,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,72,251,2,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,240,44,3,0,8,252,2,0,120,45,3,0,240,251,2,0,0,0,0,0,1,0,0,0,40,252,2,0,0,0,0,0,120,45,3,0,168,251,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,48,252,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,120,45,3,0,176,252,2,0,0,0,0,0,1,0,0,0,40,252,2,0,0,0,0,0,120,45,3,0,104,252,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,200,252,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,240,44,3,0,96,253,2,0,120,45,3,0,72,253,2,0,0,0,0,0,1,0,0,0,128,253,2,0,0,0,0,0,120,45,3,0,0,253,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,136,253,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,120,45,3,0,8,254,2,0,0,0,0,0,1,0,0,0,128,253,2,0,0,0,0,0,120,45,3,0,192,253,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,32,254,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,240,44,3,0,160,254,2,0,120,45,3,0,88,254,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,192,254,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,240,44,3,0,48,255,2,0,120,45,3,0,232,254,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,80,255,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,240,44,3,0,192,255,2,0,120,45,3,0,120,255,2,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,224,255,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,240,44,3,0,80,0,3,0,120,45,3,0,8,0,3,0,0,0,0,0,2,0,0,0,88,243,2,0,2,0,0,0,112,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+188660);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,96,42,3,0,110,0,0,0,104,42,3,0,114,0,0,0,112,42,3,0,102,0,0,0,120,42,3,0,97,0,0,0,128,42,3,0,101,0,0,0,136,42,3,0,119,0,0,0,144,42,3,0,87,0,0,0,160,42,3,0,115,0,0,0,176,42,3,0,83,0,0,0,192,42,3,0,100,0,0,0,208,42,3,0,68,0,0,0,224,42,3,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,104,44,3,0,127,0,0,0,128,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,240,44,3,0,64,44,3,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,24,45,3,0,88,44,3,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,24,45,3,0,120,44,3,0,80,44,3,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,24,45,3,0,176,44,3,0,160,44,3,0,0,0,0,0,0,0,0,0,216,44,3,0,129,0,0,0,130,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,96,45,3,0,129,0,0,0,133,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,24,45,3,0,56,45,3,0,216,44,3,0,0,0,0,0,0,0,0,0,192,45,3,0,129,0,0,0,134,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,24,45,3,0,152,45,3,0,216,44,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,3,0,135,0,0,0,136,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,24,45,3,0,240,47,3,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+199000);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  function _lis_matrix_assemble() {
  Module['printErr']('missing function: lis_matrix_assemble'); abort(-1);
  }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }

  function _lis_matrix_set_type() {
  Module['printErr']('missing function: lis_matrix_set_type'); abort(-1);
  }


  var _cos=Math_cos;

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  function _fmin(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.min(x, y);
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }

  function _lis_vector_get_values() {
  Module['printErr']('missing function: lis_vector_get_values'); abort(-1);
  }


  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  function _lis_vector_set_value() {
  Module['printErr']('missing function: lis_vector_set_value'); abort(-1);
  }


  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


  function _lis_solve() {
  Module['printErr']('missing function: lis_solve'); abort(-1);
  }

   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  function _lis_matrix_create() {
  Module['printErr']('missing function: lis_matrix_create'); abort(-1);
  }

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _putc=_fputc;

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  var _fseeko=_fseek;

  function _lis_matrix_set_size() {
  Module['printErr']('missing function: lis_matrix_set_size'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_matrix_destroy() {
  Module['printErr']('missing function: lis_matrix_destroy'); abort(-1);
  }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  var _emscripten_setjmp=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Ba=env.invoke_viiiiii;var Ca=env.invoke_viidii;var Da=env.invoke_iid;var Ea=env.invoke_viiiiiii;var Fa=env.invoke_viiiiiid;var Ga=env.invoke_viiiiiiiii;var Ha=env.invoke_iii;var Ia=env.invoke_iiiiii;var Ja=env.invoke_iiiiidi;var Ka=env.invoke_didd;var La=env.invoke_dii;var Ma=env.invoke_i;var Na=env.invoke_iiiiiiiiii;var Oa=env.invoke_viii;var Pa=env.invoke_v;var Qa=env.invoke_iiiiiiiii;var Ra=env.invoke_iiiii;var Sa=env.invoke_viiii;var Ta=env._fabs;var Ua=env._lis_matrix_assemble;var Va=env._strrchr;var Wa=env._pthread_key_create;var Xa=env._vsscanf;var Ya=env.__ZSt9terminatev;var Za=env.___cxa_guard_acquire;var _a=env.__reallyNegative;var $a=env._fstat;var ab=env._pclose;var bb=env._lis_solver_create;var cb=env.___assert_fail;var db=env.__ZSt18uncaught_exceptionv;var eb=env._longjmp;var fb=env.__isLeapYear;var gb=env._clock_gettime;var hb=env._fsync;var ib=env._signal;var jb=env._GC_collect_a_little;var kb=env._sbrk;var lb=env._strtoull;var mb=env._emscripten_memcpy_big;var nb=env.__parseInt64;var ob=env._close;var pb=env._rewind;var qb=env._cos;var rb=env._fileno;var sb=env._fread;var tb=env._puts;var ub=env._isatty;var vb=env._lis_matrix_set_value;var wb=env._write;var xb=env._isblank;var yb=env._ftell;var zb=env.__ZNSt9exceptionD2Ev;var Ab=env._xerbla_;var Bb=env._round;var Cb=env.___cxa_does_inherit;var Db=env._strtoll_l;var Eb=env._strstr;var Fb=env.___cxa_rethrow;var Gb=env._llvm_lifetime_end;var Hb=env._catclose;var Ib=env._tmpnam;var Jb=env._lis_vector_get_values;var Kb=env._lis_vector_destroy;var Lb=env._lis_solver_set_option;var Mb=env._tmpfile;var Nb=env._send;var Ob=env._pow;var Pb=env._lis_matrix_set_size;var Qb=env.___cxa_free_exception;var Rb=env.___cxa_find_matching_catch;var Sb=env._isxdigit_l;var Tb=env.___cxa_guard_release;var Ub=env._truncate;var Vb=env._strtol;var Wb=env._sin;var Xb=env._strtok;var Yb=env.___setErrNo;var Zb=env._newlocale;var _b=env._isdigit_l;var $b=env.___resumeException;var ac=env._freelocale;var bc=env._srand;var cc=env._qsort;var dc=env._putchar;var ec=env._floor;var fc=env._pthread_mutex_unlock;var gc=env._printf;var hc=env._sprintf;var ic=env._fopen;var jc=env._vasprintf;var kc=env._emscripten_get_now;var lc=env._stat;var mc=env._lis_solve;var nc=env._strtoull_l;var oc=env._mkport;var pc=env._read;var qc=env.__addDays;var rc=env._fwrite;var sc=env._time;var tc=env._pthread_mutex_lock;var uc=env._catopen;var vc=env._exit;var wc=env._GC_strdup;var xc=env._freopen;var yc=env.___ctype_b_loc;var zc=env._fmod;var Ac=env._strtok_r;var Bc=env._lseek;var Cc=env._access;var Dc=env._vfprintf;var Ec=env.___cxa_allocate_exception;var Fc=env._atoi;var Gc=env._strtoll;var Hc=env._pwrite;var Ic=env._localtime_r;var Jc=env._tzset;var Kc=env._open;var Lc=env._uselocale;var Mc=env._snprintf;var Nc=env.___errno_location;var Oc=env._GC_malloc;var Pc=env.___cxa_end_catch;var Qc=env._perror;var Rc=env.___cxa_begin_catch;var Sc=env._strftime;var Tc=env._ftruncate;var Uc=env._GC_init;var Vc=env._lis_matrix_set_type;var Wc=env._fseek;var Xc=env._isxdigit;var Yc=env._fclose;var Zc=env._vsnprintf;var _c=env.__parseInt;var $c=env._log;var ad=env._pthread_cond_broadcast;var bd=env._popen;var cd=env._recv;var dd=env._fgetc;var ed=env._sysconf;var fd=env.__getFloat;var gd=env._lis_vector_set_value;var hd=env._abort;var id=env._ceil;var jd=env._isspace;var kd=env._localtime;var ld=env._lis_matrix_destroy;var md=env._pthread_getspecific;var nd=env._pthread_cond_wait;var od=env._llvm_lifetime_start;var pd=env.___cxa_is_number_type;var qd=env._ungetc;var rd=env._system;var sd=env._fmin;var td=env._fmax;var ud=env._fflush;var vd=env._strftime_l;var wd=env._fprintf;var xd=env._sscanf;var yd=env._catgets;var zd=env._lis_solver_destroy;var Ad=env._strdup;var Bd=env._asprintf;var Cd=env.__exit;var Dd=env.___ctype_toupper_loc;var Ed=env._bsearch;var Fd=env.__arraySum;var Gd=env.__formatString;var Hd=env._htonl;var Id=env.___ctype_tolower_loc;var Jd=env._unlink;var Kd=env._fputs;var Ld=env._GC_malloc_atomic;var Md=env._pread;var Nd=env._lis_vector_set_size;var Od=env._fscanf;var Pd=env.__scanString;var Qd=env._pthread_setspecific;var Rd=env._copysign;var Sd=env._fputc;var Td=env.___cxa_throw;var Ud=env._lis_matrix_create;var Vd=env._isdigit;var Wd=env._strerror;var Xd=env._emscripten_longjmp;var Yd=env._lis_vector_create;var Zd=env._atexit;var _d=env._sqrt;var $d=env._strerror_r;var ae=0.0;
// EMSCRIPTEN_START_FUNCS
function l3a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Qc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;wd(m|0,176488,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;wd(m|0,176520,j|0)|0;l=m;break}else{n=c[176360+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;wd(m|0,176544,h|0)|0;l=m;break}}}while(0);h=c[44138]|0;do{if((h|0)==0){rc(181424,29,1,l|0)|0}else{c[g>>2]=(h-176592|0)/48|0;wd(l|0,176560,g|0)|0;b=c[(c[44138]|0)+4>>2]|0;if((b|0)==0){rc(181408,10,1,l|0)|0;break}else{c[f>>2]=b;wd(l|0,181392,f|0)|0;break}}}while(0);f=c[45364]|0;if((f|0)!=0){c[d>>2]=f;wd(l|0,181464,d|0)|0}d=(c[45384]|0)!=0?181544:181560;f=(c[45392]|0)!=0?181576:181592;g=(c[45402]|0)!=0?181616:181632;c[e>>2]=(c[45378]|0)!=0?181520:181528;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;wd(l|0,181488,e|0)|0;a3a(181648,1)}function m3a(){var a=0,b=0;a=i;c[45414]=1;b=c[r>>2]|0;c[44148]=b;c[176612>>2]=k3a(b)|0;c[176616>>2]=1;c[176632>>2]=1;b=c[s>>2]|0;c[176832>>2]=b;c[176852>>2]=k3a(b)|0;c[176856>>2]=1;c[176872>>2]=0;b=c[t>>2]|0;c[176880>>2]=b;c[176900>>2]=k3a(b)|0;c[176904>>2]=1;c[176920>>2]=1;i=a;return}function n3a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=xc(g|0,c[186904+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[45416]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=yb(c[k>>2]|0)|0;l=xc(c[f>>2]|0,c[186904+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[45416]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Wc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Nc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Wc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function o3a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){l3a(b,d)}d=c[45418]|0;if((d|0)!=0){Ce[d&7]()|0}c[(Nc()|0)>>2]=b;i=e;return b|0}function p3a(a){a=a|0;var b=0,d=0;b=i;c[45448]=0;c[45450]=0;c[45452]=0;d=((q3a(a,0)|0)==0)<<31>>31;i=b;return d|0}function q3a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==40){break}else if(b<<24>>24==32){f=g}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[45452]|0;c[45452]=j+1;if((j|0)==1){c[45450]=d}if((v3a(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=w3a(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function r3a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[45448]|0;l=181816+(k<<4)|0;m=c[l>>2]|0;switch(s3a(m)|0){case 16:{if(b){n=28;break a}c[45448]=k+1;continue b;break};case 2:{c[46664]=0;c[46680]=0;c[45448]=c[181820+(k<<4)>>2];if(b){n=24;break a}if((c[46676]|0)==0){j=0;n=37;break a}o=Ce[c[45434]&7]()|0;if((o|0)==0){continue b}else{j=o;n=37;break a}break};case 1:{o=c[181820+(k<<4)>>2]|0;p=(c[46680]|0)+1|0;c[46680]=p;c[186728+(p<<2)>>2]=o;c[45448]=k+1;continue b;break};case 19:case 17:{c[45424]=0;c[45448]=k+1;continue b;break};case 18:{c[45424]=1;c[45448]=k+1;continue b;break};case 20:{c[45444]=c[181820+(k<<4)>>2];c[45448]=k+1;continue b;break};case 3:{o=c[46664]|0;p=186664+(o<<2)|0;q=c[p>>2]|0;c[p>>2]=q+ -1;if((q|0)<2){c[46664]=o+ -1;c[46680]=(c[46680]|0)+ -1;c[45448]=k+1;continue b}else{o=c[46680]|0;c[46680]=o+ -1;c[45448]=(c[186728+(o<<2)>>2]|0)+1;continue b}break};case 6:{o=c[181820+(k<<4)>>2]|0;q=(c[46664]|0)+1|0;c[46664]=q;c[186664+(q<<2)>>2]=o;c[45448]=k+1;continue b;break};case 21:{c[45426]=0;c[45448]=k+1;continue b;break};case 22:{c[45426]=1;c[45448]=k+1;continue b;break};case 8:{o=c[46664]|0;s=186664+(o<<2)|0;t=c[s>>2]|0;if((t|0)>=1){n=10;break b}c[46664]=o+ -1;c[45448]=k+1;continue b;break};case 9:{o=(ie[c[45432]&127](l)|0)==0;c[45448]=(c[45448]|0)+1;if(o){break b}else{continue b}break};case 33:{c[46692]=1;c[45448]=k+1;continue b;break};default:{n=4;break a}}}if((n|0)==10){n=0;if(b){n=11;break}c[s>>2]=t+ -1;c[46676]=1;k=le[c[45430]&63](l,g,d)|0;if((k|0)>0){n=13;break}if((k|0)<0){n=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;n=37;break}}if((n|0)==4){h=c[r>>2]|0;d=c[45364]|0;c[f>>2]=m;c[f+4>>2]=d;wd(h|0,186616,f|0)|0;if((c[c[45420]>>2]|0)==0){l3a(100,186648);j=100;i=e;return j|0}else{c[(Nc()|0)>>2]=100;j=100;i=e;return j|0}}else if((n|0)==11){j=Ce[c[45418]&7]()|0;i=e;return j|0}else if((n|0)==13){f=c[c[45420]>>2]|0;j=o3a(f,c[(Nc()|0)>>2]|0,186712)|0;i=e;return j|0}else if((n|0)==15){if((c[(c[45420]|0)+8>>2]|0)==0){l3a(-1,186712);j=-1;i=e;return j|0}else{c[(Nc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((n|0)==24){j=Ce[c[45418]&7]()|0;i=e;return j|0}else if((n|0)==28){j=Ce[c[45418]&7]()|0;i=e;return j|0}else if((n|0)==37){i=e;return j|0}return 0}function s3a(a){a=a|0;var b=0;switch(a|0){case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};default:{b=a}}i=i;return b|0}function t3a(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=r3a(b,0,0)|0;i=a;return d|0}function u3a(){c[45440]=0;c[45448]=0;c[46680]=0;c[46664]=0;c[46676]=0;c[46682]=0;c[46666]=0;i=i;return}function v3a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[45448]|0;if((g|0)>299){rc(186792,24,1,c[r>>2]|0)|0;a3a(c[45364]|0,1)}else{c[181816+(g<<4)>>2]=a;c[181820+(g<<4)>>2]=b;c[181824+(g<<4)>>2]=d;c[181828+(g<<4)>>2]=e;c[45448]=g+1;i=f;return g|0}return 0}function w3a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=x3a(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==41){j=9;break a}else if(e<<24>>24==44){j=7;break}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[45452]|0)+ -1|0;c[45452]=h;if((h|0)==0){v3a(2,c[45450]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{v3a(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function x3a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((y3a(b,e)|0)!=0){g=c[e>>2]|0;break}if((z3a(b,e)|0)!=0){g=c[e>>2]|0;break}h=A3a(b,f,1)|0;j=v3a(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=q3a(h,j)|0}}while(0);i=d;return g|0}function y3a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 98:case 66:{g=b+1|0;h=a[g]|0;if(h<<24>>24==90|h<<24>>24==122){v3a(22,0,0,0)|0;j=g;k=30;break a}else{v3a(21,0,0,0)|0;j=g;k=30;break a}break};case 120:case 88:{v3a(4,1,0,0)|0;j=b;k=30;break};case 39:case 34:case 2:{c[181824+((v3a(11,0,0,0)|0)<<4)>>2]=b;g=B3a(b)|0;c[d>>2]=g;l=(g|0)!=0|0;i=e;return l|0};case 43:{m=0;k=13;break};case 47:{v3a(5,0,0,0)|0;j=b;k=30;break};case 36:{v3a(33,0,0,0)|0;j=b;k=30;break};case 58:{v3a(16,0,0,0)|0;j=b;k=30;break};case 116:case 84:{g=b+1|0;h=a[g]|0;if(h<<24>>24==76|h<<24>>24==108){n=g;o=13}else if(h<<24>>24==82|h<<24>>24==114){n=g;o=14}else{n=b;o=15}g=A3a(n+1|0,f,0)|0;if((g|0)==0){k=15;break a}v3a(o,c[f>>2]|0,0,0)|0;j=g+ -1|0;k=30;break};case 45:{m=1;k=13;break};case 112:case 80:{v3a(20,1,0,0)|0;j=b;k=30;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{p=b;q=0;k=14;break};case 115:case 83:{g=b+1|0;h=a[g]|0;if(h<<24>>24==80|h<<24>>24==112){r=g;s=18}else if(h<<24>>24==83|h<<24>>24==115){r=g;s=19}else{r=b;s=17}v3a(s,0,0,0)|0;j=r;k=30;break};default:{l=0;i=e;return l|0}}}while(0);if((k|0)==13){p=b+1|0;q=m;k=14}b:do{if((k|0)==14){m=A3a(p,f,0)|0;if((m|0)==0){k=15;break}switch(a[m]|0){case 104:case 72:{b=c[f>>2]|0;c[181824+((v3a(12,b,0,0)|0)<<4)>>2]=m+1;j=m+b|0;k=30;break b;break};case 120:case 88:{v3a(4,c[f>>2]|0,0,0)|0;j=m;k=30;break b;break};case 112:case 80:{b=c[f>>2]|0;if((q|0)==0){t=b}else{r=0-b|0;c[f>>2]=r;t=r}v3a(20,t,0,0)|0;j=m;k=30;break b;break};default:{l=0;i=e;return l|0}}}}while(0);if((k|0)==15){c[d>>2]=0;l=1;i=e;return l|0}else if((k|0)==30){c[d>>2]=j+1;l=1;i=e;return l|0}return 0}function z3a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=A3a(b,f,1)|0;v3a(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 102:case 70:{l=A3a(f,g,0)|0;if((l|0)==0){m=4;break a}n=c[g>>2]|0;if((n|0)==0){o=l;m=45;break a}if((a[l]|0)==46){p=A3a(l+1|0,h,0)|0;if((p|0)==0){m=4;break a}q=p;r=c[h>>2]|0}else{c[h>>2]=0;q=l;r=0}v3a(23,n,r,0)|0;o=q;m=45;break};case 122:case 90:{s=35;t=36;m=38;break};case 103:case 71:{u=0;m=3;break};case 101:case 69:{u=1;m=3;break};case 111:case 79:{s=32;t=34;m=38;break};case 100:case 68:{n=A3a(f,g,0)|0;if((n|0)==0){m=4;break a}l=c[g>>2]|0;if((l|0)==0){o=n;m=45;break a}if((a[n]|0)==46){p=A3a(n+1|0,h,0)|0;if((p|0)==0){m=4;break a}v=p;w=c[h>>2]|0}else{c[h>>2]=0;v=n;w=0}v3a(26,l,w,0)|0;o=v;m=45;break};case 108:case 76:{l=A3a(f,g,0)|0;if((l|0)==0){m=4;break a}n=c[g>>2]|0;if((n|0)==0){o=l;m=45;break a}v3a(29,n,0,0)|0;o=l;m=45;break};case 105:case 73:{s=7;t=10;m=38;break};case 97:case 65:{l=f;while(1){x=a[l]|0;if(x<<24>>24==32){l=l+1|0}else{break}}if(!((x+ -48<<24>>24&255)<10)){v3a(30,0,0,0)|0;o=l;m=45;break a}n=A3a(l,g,1)|0;p=c[g>>2]|0;if((p|0)==0){o=n;m=45;break a}v3a(31,p,0,0)|0;o=n;m=45;break};default:{c[45448]=(c[45448]|0)+ -1;c[d>>2]=b;y=0;i=e;return y|0}}}while(0);do{if((m|0)==3){b=A3a(f,g,0)|0;if((b|0)==0){m=4;break}x=c[g>>2]|0;if((x|0)==0){o=b;m=45;break}v=a[b]|0;if(v<<24>>24==46){w=A3a(b+1|0,h,0)|0;if((w|0)==0){m=4;break}z=w;A=a[w]|0}else{c[h>>2]=0;z=b;A=v}if(!(A<<24>>24==101|A<<24>>24==69)){v3a((u|0)==1?24:27,x,c[h>>2]|0,0)|0;o=z;m=45;break}v=A3a(z+1|0,j,0)|0;if((v|0)==0){m=4;break}v3a((u|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;o=v;m=45}else if((m|0)==38){v=A3a(f,g,0)|0;if((v|0)==0){m=4;break}x=c[g>>2]|0;if((x|0)==0){o=v;m=45;break}if((a[v]|0)!=46){v3a(s,x,0,0)|0;o=v;m=45;break}b=A3a(v+1|0,h,0)|0;if((b|0)==0){m=4;break}v3a(t,x,c[h>>2]|0,0)|0;o=b;m=45}}while(0);if((m|0)==4){c[d>>2]=0;y=1;i=e;return y|0}else if((m|0)==45){c[d>>2]=o;y=1;i=e;return y|0}return 0}function A3a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function B3a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[45420]>>2]|0)==0){l3a(100,186776);n=0;i=d;return n|0}else{c[(Nc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function C3a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[186846|0]=48;k=186846|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=186824+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function D3a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[45442]|0;f=c[45438]|0;if((e|0)>(f|0)){c[45438]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[46730]|0)){h=g}else{E3a(f,g);h=c[45438]|0}g=c[46732]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Kd(g|0,c[45416]|0)|0;h=$fb(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Sd(a[k]|0,c[45416]|0)|0;Kd(h|0,c[45416]|0)|0;b=$fb(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function E3a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[46732]|0;if((f|0)==187008){c[46730]=1024;g=1024}else{g=c[46730]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[46730]=j;h=j}j=xfb(h)|0;if((j|0)==0){l3a(113,187408);k=c[46732]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[46732]|0}else{l=k}if((l|0)==187008){m=186928;c[46732]=j;i=e;return}yfb(l);m=186928;c[46732]=j;i=e;return}function F3a(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[45438]|0;f=c[46730]|0;if((e|0)<(f|0)){g=e}else{E3a(e,f);g=c[45438]|0}c[45438]=g+1;a[(c[46732]|0)+g|0]=b;i=d;return}function G3a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[45402]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){l3a(101,186936);l=101;i=d;return l|0}else{c[(Nc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[45414]|0)==0){m3a();m=c[f>>2]|0}else{m=k}k=176592+(m*48|0)|0;c[44138]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){L3a(k,c[b+12>>2]|0,j);o=M3a(j,h)|0;if((o|0)==(c[176600+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[176604+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=h3a(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[176624+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=176608+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[176624+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=176616+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[176616+(m*48|0)>>2]=1;r=1;break}else{c[176616+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];hc(j|0,186944,e|0)|0}else{L3a(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){H3a(107,186936,b);l=107;i=d;return l|0}else{c[(Nc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=176636+(m*48|0)|0;c[q>>2]=0;c[176628+(m*48|0)>>2]=0;e=176632+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=176620+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 82:case 114:{break};case 83:case 115:{c[q>>2]=1;o=Mb()|0;c[n>>2]=o;if((o|0)!=0){c[176596+(m*48|0)>>2]=0;c[176604+(m*48|0)>>2]=-1;c[176600+(m*48|0)>>2]=-1;c[176612+(m*48|0)>>2]=1;l=0;i=d;return l|0}o=(c[b>>2]|0)==0;k=Nc()|0;s=c[k>>2]|0;if(o){H3a(s,186936,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 79:case 111:{if((Cc(j|0,0)|0)==0){break b}s=(c[b>>2]|0)==0;k=Nc()|0;o=c[k>>2]|0;if(s){H3a(o,186936,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};case 78:case 110:{if((Cc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){H3a(128,186936,b);l=128;i=d;return l|0}else{c[(Nc()|0)>>2]=128;l=128;i=d;return l|0}break};default:{break b}}}while(0);o=ic(j|0,c[46726]|0)|0;if((o|0)==0){break}Yc(o|0)|0}}while(0);q=xfb(($fb(j|0)|0)+1|0)|0;c[176596+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){H3a(113,186960,b);l=113;i=d;return l|0}else{c[(Nc()|0)>>2]=113;l=113;i=d;return l|0}}fgb(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=ic(j|0,c[186904+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=ic(j|0,c[186864+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=ic(j|0,c[186904+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Nc()|0;o=c[g>>2]|0;if(h){l3a(o,186936);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=176612+(m*48|0)|0;c[r>>2]=k3a(u)|0;u=M3a(j,176604+(m*48|0)|0)|0;c[176600+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){H3a(108,186936,b);l=108;i=d;return l|0}else{c[(Nc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){pb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Wc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){H3a(129,186936,b);l=129;i=d;return l|0}else{c[(Nc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function H3a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){l3a(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[46730]|0)){j=d;k=g}else{E3a(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[46732]|0;c[(c[44138]|0)+4>>2]=f;L3a(k,j,f);l3a(a,b);i=e;return}function I3a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;hc(j|0,186944,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=$fb(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?186976:186984;c[h+24>>2]=(b|0)==5?186992:187e3;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=G3a(h)|0;i=e;return a|0}function J3a(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=176592+(d*48|0)|0;c[44138]=e;if(d>>>0>99){if((c[a>>2]|0)==0){l3a(101,187424);f=101;i=b;return f|0}else{c[(Nc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((I3a(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){l3a(114,187432);f=114;i=b;return f|0}else{c[(Nc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[176616+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){l3a(102,187432);f=102;i=b;return f|0}else{c[(Nc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function K3a(){var a=0,b=0;a=i;b=t3a()|0;c[45364]=0;i=a;return b|0}function L3a(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function M3a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((lc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function N3a(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[45444]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[45424]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];hc(p|0,187440,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-($fb(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;fe[c[45428]&511](32);}while((A|0)>0)}if((D|0)!=0){fe[c[45428]&511]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{fe[c[45428]&511](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Fc(A|0)|0)+1|0;c[m>>2]=t-(c[45444]|0);hc(A|0,187448,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;fe[c[45428]&511](32);}while((z|0)>0)}if((x|0)!=0){fe[c[45428]&511]((w|0)!=0?45:43)}z=c[45444]|0;do{if((z|0)<1){fe[c[45428]&511](46);y=c[45428]|0;if((z|0)<0){G=y;J=z;while(1){fe[G&511](48);I=J+1|0;K=c[45428]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}fe[N&511](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}fe[c[45428]&511](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[45428]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){fe[P&511](a[J]|0);R=Q+ -1|0;S=c[45428]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}fe[T&511](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;fe[c[45428]&511](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){fe[c[45428]&511](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;fe[c[45428]&511](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){fe[c[45428]&511](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;fe[c[45428]&511](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;fe[c[45428]&511](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;fe[c[45428]&511](42);}while((_|0)>0);i=l;return 0}function O3a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[45444]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(hc(n|0,187456,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[45424]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;fe[c[45428]&511](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;fe[c[45428]&511](32);}while((b|0)>0)}do{if(q){if((c[45424]|0)==0){break}fe[c[45428]&511](43)}else{fe[c[45428]&511](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;fe[c[45428]&511](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;fe[c[45428]&511](48);}while((z|0)>0);i=j;return 0}function P3a(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==1){h=a[d]|0}else if((f|0)==4){h=c[d>>2]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{fe[c[45428]&511](32);e=e+1|0;}while((e|0)<(d|0))}d=c[45428]|0;if((h|0)==0){fe[d&511](70);i=g;return 0}else{fe[d&511](84);i=g;return 0}return 0}function Q3a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[45440]|0)!=0){g=R3a()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 31:{V3a(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 10:{T3a(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 35:{X3a(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 23:{h=O3a(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 28:case 27:{h=W3a(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 34:{T3a(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 32:{S3a(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 36:{X3a(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 25:case 24:case 26:{h=N3a(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 30:{U3a(b,d);h=0;i=e;return h|0};case 29:{P3a(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 7:{S3a(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;wd(h|0,187464,f|0)|0;a3a(c[45364]|0,1)}}return 0}function R3a(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[45440]|0;c[45440]=0;if((c[45402]|0)!=0){if((b|0)>0){d=c[45442]|0;e=c[45438]|0;if((d|0)<=(e|0)){f=b;while(1){fe[c[45428]&511](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[45438]=f;h=0;i=a;return h|0}f=b-d+e|0;c[45438]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){fe[c[45428]&511](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[45438]|0;f=j+b|0;if((f|0)>=0){if((c[45442]|0)<(j|0)){c[45442]=j}c[45438]=f;h=0;i=a;return h|0}if((c[c[45420]>>2]|0)==0){l3a(110,187552);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[45438]|0;if((c[45442]|0)<(f|0)){c[45442]=f}j=f+b|0;c[45438]=j;c[45446]=(c[45446]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[45420]>>2]|0)==0){l3a(110,187552);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[45438]|0;f=j+b|0;if((f|0)>=(c[(c[45422]|0)+16>>2]|0)){if((c[c[45420]>>2]|0)==0){l3a(110,187568);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[45442]|0;if((d|0)<=(j|0)){e=b;while(1){fe[c[45428]&511](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[45446]=(c[45446]|0)+b;c[45438]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[45446]=(c[45446]|0)+f;c[45438]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){fe[c[45428]&511](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function S3a(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==4){l=c[d>>2]|0}else if((f|0)==1){l=a[d]|0}else{l=b[d>>1]|0}d=C3a(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[45424]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{fe[c[45428]&511](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{fe[c[45428]&511](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[45424]|0)==0){break}fe[c[45428]&511](43)}else{fe[c[45428]&511](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){fe[c[45428]&511](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function T3a(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==1){m=a[d]|0}else if((g|0)==4){m=c[d>>2]|0}else{m=b[d>>1]|0}d=C3a(m,k,l,h)|0;h=c[l>>2]|0;g=(c[45424]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{fe[c[45428]&511](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{fe[c[45428]&511](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[45424]|0)==0){break}fe[c[45428]&511](43)}else{fe[c[45428]&511](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){fe[c[45428]&511](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){fe[c[45428]&511](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{fe[c[45428]&511](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function U3a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;fe[c[45428]&511](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function V3a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;fe[c[45428]&511](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;fe[c[45428]&511](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function W3a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=N3a(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=N3a(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[45444]|0;c[45444]=0;p=(e|0)==0?4:e+2|0;e=O3a(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{fe[c[45428]&511](32);f=f+1|0;}while((f|0)<(p|0))}c[45444]=o;n=e;i=j;return n|0}function X3a(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{fe[c[45428]&511](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;fe[c[45428]&511](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;fe[c[45428]&511](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){fe[c[45428]&511](a[187528+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){fe[c[45428]&511](a[187528+((d[p]|0)>>>4)|0]|0);fe[c[45428]&511](a[187528+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function Y3a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 11:{f=Z3a(c[a+8>>2]|0)|0;i=b;return f|0};case 5:{f=Ce[c[45436]&7]()|0;i=b;return f|0};case 15:{c[45440]=(c[a+4>>2]|0)+ -1-(c[45438]|0);f=1;i=b;return f|0};case 12:{f=_3a(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};case 4:case 14:{c[45440]=(c[45440]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};case 13:{g=(c[45440]|0)-(c[a+4>>2]|0)|0;a=0-(c[45438]|0)|0;c[45440]=(g|0)<(a|0)?a:g;f=1;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;wd(f|0,187496,d|0)|0;a3a(c[45364]|0,1)}}return 0}function Z3a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[45440]|0)!=0){e=R3a()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}fe[c[45428]&511](e<<24>>24);n=b}else{fe[c[45428]&511](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function _3a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[45440]|0)!=0){f=R3a()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;fe[c[45428]&511](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function $3a(){var a=0,b=0;a=i;b=D3a(10)|0;c[45440]=0;c[45438]=0;c[45442]=0;i=a;return(b|0)==0|0}function a4a(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[45414]|0)==0){m3a()}c[45378]=0;c[45384]=1;c[45392]=1;c[45402]=1;d=J3a(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[45420]=a;c[45438]=0;c[45440]=0;c[45442]=0;c[46692]=0;c[45444]=0;d=c[a+12>>2]|0;c[45364]=d;c[45416]=c[c[44138]>>2];if((p3a(d)|0)<0){if((c[a>>2]|0)==0){l3a(100,187576);e=100;i=b;return e|0}else{c[(Nc()|0)>>2]=100;e=100;i=b;return e|0}}c[45428]=443;c[45430]=44;c[45432]=111;c[45418]=4;c[45434]=5;c[45436]=6;u3a();c[45424]=0;d=c[44138]|0;c[45426]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((n3a(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Nc()|0;f=c[a>>2]|0;if(d){l3a(f,187584);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function b4a(){var a=0,b=0;a=i;if((c[46692]|0)==0){b=D3a(10)|0}else{D3a(0)|0;ud(c[45416]|0)|0;b=0}c[45440]=0;c[45438]=0;c[45442]=0;i=a;return b|0}function c4a(){var a=0,b=0,d=0;a=i;if((c[46676]|0)==0){b=0}else{d=D3a(10)|0;c[46676]=0;b=d}c[45440]=0;c[45438]=0;c[45442]=0;i=a;return b|0}function d4a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;z4a(188312,h,188368);c[46900]=189820;c[187608>>2]=189840;c[187604>>2]=0;q6a(187608|0,188312);c[187680>>2]=0;c[187684>>2]=-1;j=c[t>>2]|0;c[47104]=189688;_bb(188420|0);k=188424|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[47104]=188928;c[188448>>2]=j;$bb(g,188420|0);k=ccb(g,192480)|0;l=k;acb(g);c[188452>>2]=l;c[188456>>2]=188376;a[188460|0]=(ie[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[46922]=189900;c[187692>>2]=189920;q6a(187692|0,188416);c[187764>>2]=0;c[187768>>2]=-1;l=c[r>>2]|0;c[47116]=189688;_bb(188468|0);k=188472|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[47116]=188928;c[188496>>2]=l;$bb(f,188468|0);k=ccb(f,192480)|0;g=k;acb(f);c[188500>>2]=g;c[188504>>2]=188384;a[188508|0]=(ie[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[46944]=189900;c[187780>>2]=189920;q6a(187780|0,188464);c[187852>>2]=0;c[187856>>2]=-1;g=c[(c[(c[46944]|0)+ -12>>2]|0)+187800>>2]|0;c[46966]=189900;c[187868>>2]=189920;q6a(187868|0,g);c[187940>>2]=0;c[187944>>2]=-1;c[(c[(c[46900]|0)+ -12>>2]|0)+187672>>2]=187688;g=(c[(c[46944]|0)+ -12>>2]|0)+187780|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[46944]|0)+ -12>>2]|0)+187848>>2]=187688;l4a(188512,h,188392|0);c[46988]=189860;c[187960>>2]=189880;c[187956>>2]=0;q6a(187960|0,188512);c[188032>>2]=0;c[188036>>2]=-1;c[47142]=189752;_bb(188572|0);h=188576|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[47142]=188672;c[188600>>2]=j;$bb(e,188572|0);j=ccb(e,192488)|0;h=j;acb(e);c[188604>>2]=h;c[188608>>2]=188400;a[188612|0]=(ie[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[47010]=189940;c[188044>>2]=189960;q6a(188044|0,188568);c[188116>>2]=0;c[188120>>2]=-1;c[47154]=189752;_bb(188620|0);h=188624|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[47154]=188672;c[188648>>2]=l;$bb(d,188620|0);l=ccb(d,192488)|0;h=l;acb(d);c[188652>>2]=h;c[188656>>2]=188408;a[188660|0]=(ie[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[47032]=189940;c[188132>>2]=189960;q6a(188132|0,188616);c[188204>>2]=0;c[188208>>2]=-1;h=c[(c[(c[47032]|0)+ -12>>2]|0)+188152>>2]|0;c[47054]=189940;c[188220>>2]=189960;q6a(188220|0,h);c[188292>>2]=0;c[188296>>2]=-1;c[(c[(c[46988]|0)+ -12>>2]|0)+188024>>2]=188040;h=(c[(c[47032]|0)+ -12>>2]|0)+188132|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[47032]|0)+ -12>>2]|0)+188200>>2]=188040;i=b;return}function e4a(a){a=a|0;a=i;o7a(187688)|0;o7a(187864)|0;v7a(188040)|0;v7a(188216)|0;i=a;return}function f4a(a){a=a|0;var b=0;b=i;c[a>>2]=189752;acb(a+4|0);i=b;return}function g4a(a){a=a|0;var b=0;b=i;c[a>>2]=189752;acb(a+4|0);Ffb(a);i=b;return}function h4a(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;ie[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=ccb(d,192488)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(ie[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function i4a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=ye[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((rc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((ud(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function j4a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=rc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((xe[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function k4a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((rc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Ge[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((rc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((rc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function l4a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=189752;j=b+4|0;_bb(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=188784;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;$bb(g,j);j=ccb(g,192488)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=ie[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(ie[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){kbb(188880)}else{acb(g);i=f;return}}function m4a(a){a=a|0;var b=0;b=i;c[a>>2]=189752;acb(a+4|0);i=b;return}function n4a(a){a=a|0;var b=0;b=i;c[a>>2]=189752;acb(a+4|0);Ffb(a);i=b;return}function o4a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=ccb(d,192488)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=ie[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(ie[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){kbb(188880)}else{i=e;return}}function p4a(a){a=a|0;var b=0,c=0;b=i;c=s4a(a,0)|0;i=b;return c|0}function q4a(a){a=a|0;var b=0,c=0;b=i;c=s4a(a,1)|0;i=b;return c|0}function r4a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Ge[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((qd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function s4a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=dd(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=Ge[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==3){y=14;break}else if((x|0)==2){n=-1;y=22;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=dd(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((qd(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function t4a(a){a=a|0;var b=0;b=i;c[a>>2]=189688;acb(a+4|0);i=b;return}function u4a(a){a=a|0;var b=0;b=i;c[a>>2]=189688;acb(a+4|0);Ffb(a);i=b;return}function v4a(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;ie[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=ccb(d,192480)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(ie[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function w4a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=ye[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((rc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((ud(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function x4a(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=rc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((xe[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function y4a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((rc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Ge[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((rc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((rc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function z4a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=189688;j=b+4|0;_bb(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=189040;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;$bb(g,j);j=ccb(g,192480)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=ie[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(ie[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){kbb(188880)}else{acb(g);i=f;return}}function A4a(a){a=a|0;var b=0;b=i;c[a>>2]=189688;acb(a+4|0);i=b;return}function B4a(a){a=a|0;var b=0;b=i;c[a>>2]=189688;acb(a+4|0);Ffb(a);i=b;return}function C4a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=ccb(d,192480)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=ie[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(ie[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){kbb(188880)}else{i=e;return}}function D4a(a){a=a|0;var b=0,c=0;b=i;c=G4a(a,0)|0;i=b;return c|0}function E4a(a){a=a|0;var b=0,c=0;b=i;c=G4a(a,1)|0;i=b;return c|0}function F4a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Ge[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((qd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function G4a(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=dd(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=Ge[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==2){o=-1;z=23;break}else if((y|0)==3){z=14;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=dd(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((qd(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function H4a(){var a=0;a=i;d4a(0);Zd(444,188304,q|0)|0;i=a;return}function I4a(a){a=a|0;i=i;return}function J4a(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function K4a(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}fe[c[(c[a>>2]|0)+8>>2]&511](a);f=1;i=b;return f|0}function L4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=189184;e=$fb(b|0)|0;f=Efb(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;bgb(g|0,b|0,e+1|0)|0;i=d;return}function M4a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=189184;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;Ffb(j);i=b;return}Gfb((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;Ffb(j);i=b;return}function N4a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=189184;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}Gfb((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function O4a(a){a=a|0;i=i;return c[a+4>>2]|0}function P4a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=189208;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=$fb(f|0)|0;g=Efb(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;bgb(h|0,f|0,d+1|0)|0;i=e;return}function Q4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=189208;e=$fb(b|0)|0;f=Efb(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;bgb(g|0,b|0,e+1|0)|0;i=d;return}function R4a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=189208;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;Ffb(j);i=b;return}Gfb((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;Ffb(j);i=b;return}function S4a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=189208;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}Gfb((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function T4a(a){a=a|0;i=i;return c[a+4>>2]|0}function U4a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=189184;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;Ffb(j);i=b;return}Gfb((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;Ffb(j);i=b;return}function V4a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=189184;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;Ffb(j);i=b;return}Gfb((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;Ffb(j);i=b;return}function W4a(a){a=a|0;i=i;return}function X4a(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function Y4a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;Ee[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function Z4a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function _4a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Wd(e|0)|0;e=$fb(f|0)|0;if(e>>>0>4294967279){e5a(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;bgb(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=Dfb(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;bgb(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function $4a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{L5a(e,189424,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;Ee[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}L5a(e,o,p)|0;if((a[g]&1)==0){break}Ffb(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function a5a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=$fb(e|0)|0;if(j>>>0>4294967279){e5a(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=Dfb(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}bgb(k|0,e|0,j|0)|0;a[k+j|0]=0;$4a(g,d,h);P4a(b,g);if(!((a[g]&1)==0)){Ffb(c[g+8>>2]|0)}if(!((a[h]&1)==0)){Ffb(c[h+8>>2]|0)}c[b>>2]=189440;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function b5a(a){a=a|0;var b=0;b=i;S4a(a);Ffb(a);i=b;return}function c5a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function d5a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;tc(189576)|0;if((c[a>>2]|0)==1){do{nd(189600,189576)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;fc(189576)|0;fe[d&511](b);tc(189576)|0;c[a>>2]=-1;fc(189576)|0;ad(189600)|0;i=e;return}else{fc(189576)|0;i=e;return}}function e5a(a){a=a|0;a=Ec(8)|0;L4a(a,189648);c[a>>2]=189264;Td(a|0,189304,40)}function f5a(a){a=a|0;a=Ec(8)|0;L4a(a,189648);c[a>>2]=189328;Td(a|0,189368,40)}function g5a(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function h5a(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function i5a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){e5a(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=Dfb(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}bgb(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function j5a(b){b=b|0;i=i;return(a[b]&1)!=0|0}function k5a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){e5a(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=Dfb(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}bgb(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function l5a(a){a=a|0;i=i;return a|0}function m5a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=$fb(d|0)|0;if(f>>>0>4294967279){e5a(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;bgb(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=Dfb(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;bgb(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function n5a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){e5a(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=Dfb(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}dgb(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function o5a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){e5a(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;dgb(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=Dfb(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;dgb(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function p5a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){f5a(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){e5a(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;bgb(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=Dfb(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;bgb(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function q5a(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function r5a(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function s5a(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}Ffb(c[b+8>>2]|0);i=d;return}function t5a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}M5a(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}cgb(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function u5a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=v5a(a,b)|0;i=c;return d|0}function v5a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=$fb(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}M5a(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}cgb(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function w5a(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function x5a(a){a=a|0;i=i;return a+1|0}function y5a(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function z5a(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function A5a(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function B5a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){C5a(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function C5a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){N5a(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}dgb(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function D5a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){C5a(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function E5a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){e5a(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=Dfb(f)|0}else{p=Dfb(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}bgb(l|0,n|0,q+1|0)|0;if(o){Ffb(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function F5a(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function G5a(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function H5a(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function I5a(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function J5a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=L5a(b,g,h)|0;i=e;return d|0}function K5a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){N5a(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function L5a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){M5a(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}bgb(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function M5a(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){e5a(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=Dfb(q)|0;if((g|0)!=0){bgb(e|0,m|0,g|0)|0}if((j|0)!=0){bgb(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){bgb(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){Ffb(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function N5a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){e5a(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=Dfb(p)|0;if((g|0)!=0){bgb(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){bgb(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}Ffb(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function O5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;p5a(a,b,c,d,0);i=e;return}function P5a(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function Q5a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=$fb(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function R5a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=Wfb(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function S5a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=$fb(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){f5a(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=Wfb(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function T5a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){e5a(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;bgb(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=Dfb(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;bgb(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function U5a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){e5a(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=Dfb(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}_eb(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function V5a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){e5a(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=Dfb(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}afb(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function W5a(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}Ffb(c[b+8>>2]|0);i=d;return}function X5a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Y5a(a,b,Zeb(b)|0)|0;i=c;return d|0}function Y5a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}$5a(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}$eb(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function Z5a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){e5a(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=Dfb(f)|0}else{p=Dfb(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}_eb(l,n,q+1|0)|0;if(o){Ffb(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function _5a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){a6a(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function $5a(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){e5a(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=Dfb(q<<2)|0;p=e;if((g|0)!=0){_eb(p,m,g)|0}if((j|0)!=0){_eb(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){_eb(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){Ffb(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function a6a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){e5a(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=Dfb(p<<2)|0;o=e;if((g|0)!=0){_eb(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){_eb(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}Ffb(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function b6a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=$fb(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){e5a(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=Dfb(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}bgb(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=L5a(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=L5a(b,m,j)|0;i=f;return}}function c6a(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function d6a(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function e6a(a,b){a=a|0;b=b|0;var c=0;c=i;f6a(a,b);i=c;return}function f6a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Ec(16)|0;do{if((a[190032]|0)==0){if((Za(190032)|0)==0){break}c[47506]=190728;Zd(66,190024,q|0)|0;Tb(190032)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=190024;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];a5a(b,f,190080);c[e>>2]=190048;Td(e|0,190128,62)}function g6a(a,b){a=a|0;b=b|0;var d=0;d=i;f6a(a,c[a+16>>2]|b);i=d;return}function h6a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=190072;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;Ee[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}acb(a+28|0);yfb(c[e>>2]|0);yfb(c[f>>2]|0);yfb(c[a+48>>2]|0);yfb(c[a+60>>2]|0);i=b;return}function i6a(a){a=a|0;var b=0;b=i;h6a(a);Ffb(a);i=b;return}function j6a(a){a=a|0;var b=0;b=i;h6a(a);i=b;return}function k6a(a){a=a|0;var b=0;b=i;h6a(a);i=b;return}function l6a(a){a=a|0;i=i;return c[a+24>>2]|0}function m6a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}$bb(d,a+28|0);a=ccb(d,192416)|0;f=xe[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;acb(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function n6a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;$bb(e,a+28|0);a=ccb(e,192416)|0;f=xe[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;acb(e);i=d;return f|0}function o6a(a,b){a=a|0;b=b|0;var c=0;c=i;$bb(a,b+28|0);i=c;return}function p6a(a){a=a|0;c[a>>2]=189672;i=i;return}function q6a(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));_bb(b);i=d;return}function r6a(a){a=a|0;var b=0;b=i;c[a>>2]=189688;acb(a+4|0);Ffb(a);i=b;return}function s6a(a){a=a|0;var b=0;b=i;c[a>>2]=189688;acb(a+4|0);i=b;return}function t6a(a){a=a|0;var b=0;b=i;c[a>>2]=189688;acb(a+4|0);i=b;return}function u6a(a,b){a=a|0;b=b|0;var c=0;c=i;$bb(a,b+4|0);i=c;return}function v6a(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=ie[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function w6a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=xe[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function x6a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=le[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function y6a(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=189688;_bb(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function z6a(a){a=a|0;i=i;return c[a+8>>2]|0}function A6a(a){a=a|0;i=i;return c[a+12>>2]|0}function B6a(a){a=a|0;i=i;return c[a+16>>2]|0}function C6a(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function D6a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function E6a(a){a=a|0;i=i;return c[a+20>>2]|0}function F6a(a){a=a|0;i=i;return c[a+24>>2]|0}function G6a(a){a=a|0;i=i;return c[a+28>>2]|0}function H6a(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function I6a(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function J6a(a,b){a=a|0;b=b|0;i=i;return}function K6a(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function L6a(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function M6a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function N6a(a){a=a|0;i=i;return 0}function O6a(a){a=a|0;i=i;return 0}function P6a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=ie[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function Q6a(a){a=a|0;i=i;return-1}function R6a(a){a=a|0;var b=0,e=0,f=0;b=i;if((ie[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function S6a(a,b){a=a|0;b=b|0;i=i;return-1}function T6a(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((xe[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function U6a(a,b){a=a|0;b=b|0;i=i;return-1}function V6a(a){a=a|0;var b=0;b=i;c[a>>2]=189752;acb(a+4|0);Ffb(a);i=b;return}function W6a(a){a=a|0;var b=0;b=i;c[a>>2]=189752;acb(a+4|0);i=b;return}function X6a(a,b){a=a|0;b=b|0;i=i;return}function Y6a(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function Z6a(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function _6a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function $6a(a){a=a|0;i=i;return 0}function a7a(a){a=a|0;i=i;return 0}function b7a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=ie[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function c7a(a){a=a|0;i=i;return-1}function d7a(a){a=a|0;var b=0,d=0,e=0;b=i;if((ie[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function e7a(a,b){a=a|0;b=b|0;i=i;return-1}function f7a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((xe[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function g7a(a,b){a=a|0;b=b|0;i=i;return-1}function h7a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));_bb(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function i7a(a){a=a|0;var b=0;b=i;h6a(a+8|0);Ffb(a);i=b;return}function j7a(a){a=a|0;var b=0;b=i;h6a(a+8|0);i=b;return}function k7a(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;h6a(a+(d+8)|0);Ffb(a+d|0);i=b;return}function l7a(a){a=a|0;var b=0;b=i;h6a(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function m7a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;n7a(a,b,c);i=d;return}function n7a(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){f6a(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){o7a(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}$bb(h,e+(k+28)|0);k=ccb(h,192416)|0;acb(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(ie[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(ie[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){ie[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((ie[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;f6a(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function o7a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{o7a(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((ie[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;f6a(b+h|0,c[b+(h+16)>>2]|1)}}while(0);D7a(e);i=d;return b|0}function p7a(b){b=b|0;i=i;return(a[b]|0)!=0|0}function q7a(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Fb()}}function r7a(a){a=a|0;var b=0;b=i;h6a(a+8|0);Ffb(a);i=b;return}function s7a(a){a=a|0;var b=0;b=i;h6a(a+8|0);i=b;return}function t7a(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;h6a(a+(d+8)|0);Ffb(a+d|0);i=b;return}function u7a(a){a=a|0;var b=0;b=i;h6a(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function v7a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{v7a(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((ie[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;f6a(b+h|0,c[b+(h+16)>>2]|1)}}while(0);P7a(e);i=d;return b|0}function w7a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));_bb(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function x7a(a){a=a|0;var b=0;b=i;h6a(a+4|0);Ffb(a);i=b;return}function y7a(a){a=a|0;var b=0;b=i;h6a(a+4|0);i=b;return}function z7a(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;h6a(a+(d+4)|0);Ffb(a+d|0);i=b;return}function A7a(a){a=a|0;var b=0;b=i;h6a(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function B7a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){o7a(g)|0}a[f]=1;i=e;return}function C7a(a){a=a|0;var b=0;b=i;D7a(a);i=b;return}function D7a(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((ie[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;f6a(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function E7a(b){b=b|0;i=i;return(a[b]|0)!=0|0}function F7a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ie[b&127](a)|0;i=c;return d|0}function G7a(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){D7a(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{o7a(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;$bb(k,b+(p+28)|0);p=ccb(k,191136)|0;m=p;acb(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){$bb(h,b+(k+28)|0);r=ccb(h,192416)|0;s=xe[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;acb(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];oe[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){D7a(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;f6a(b+l|0,c[b+(l+16)>>2]|5);D7a(j);i=e;return b|0}function H7a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){D7a(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{o7a(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;D7a(f);i=e;return b|0}if((xe[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{D7a(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;f6a(b+d|0,c[b+(d+16)>>2]|1);D7a(f);i=e;return b|0}function I7a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){D7a(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){o7a(k)|0}a[h]=1;if((e|0)==0){D7a(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((le[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){D7a(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;f6a(b+e|0,c[b+(e+16)>>2]|1);D7a(g);i=f;return b|0}function J7a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;re[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function K7a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){D7a(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{o7a(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];Ie[l&63](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){D7a(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;f6a(b+f|0,c[b+(f+16)>>2]|4);D7a(h);i=e;return b|0}function L7a(a){a=a|0;var b=0;b=i;h6a(a+4|0);Ffb(a);i=b;return}function M7a(a){a=a|0;var b=0;b=i;h6a(a+4|0);i=b;return}function N7a(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;h6a(a+(d+4)|0);Ffb(a+d|0);i=b;return}function O7a(a){a=a|0;var b=0;b=i;h6a(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function P7a(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((ie[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;f6a(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function Q7a(a){a=a|0;i=i;return 189968}function R7a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){k5a(a,189984,35);i=d;return}else{_4a(a,b,c);i=d;return}}function S7a(a){a=a|0;i=i;return}function T7a(a){a=a|0;var b=0;b=i;c5a(a);Ffb(a);i=b;return}function U7a(a){a=a|0;var b=0;b=i;c5a(a);i=b;return}function V7a(a){a=a|0;var b=0;b=i;h6a(a);Ffb(a);i=b;return}function W7a(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function X7a(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function Y7a(a){a=a|0;i=i;return}function Z7a(a){a=a|0;i=i;return}function _7a(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function $7a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){e5a(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=Dfb(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function a8a(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function b8a(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function c8a(a){a=a|0;i=i;return}function d8a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function e8a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){e5a(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=Dfb(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function f8a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function g8a(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function h8a(a){a=a|0;i=i;return}function i8a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];ue[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}o6a(u,g);m=u;u=c[m>>2]|0;if(!((c[48104]|0)==-1)){c[p>>2]=192416;c[p+4>>2]=445;c[p+8>>2]=0;d5a(192416,p,446)}p=(c[192420>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ec(4)|0;D=C;cfb(D);E=207976;F=127;Td(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ec(4)|0;D=C;cfb(D);E=207976;F=127;Td(C|0,E|0,F|0)}F=u;K4a(c[m>>2]|0)|0;o6a(v,g);g=v;v=c[g>>2]|0;if(!((c[48140]|0)==-1)){c[o>>2]=192560;c[o+4>>2]=445;c[o+8>>2]=0;d5a(192560,o,446)}o=(c[192564>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;cfb(H);I=207976;J=127;Td(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ec(4)|0;H=G;cfb(H);I=207976;J=127;Td(G|0,I|0,J|0)}J=v;K4a(c[g>>2]|0)|0;g=w;ge[c[(c[v>>2]|0)+24>>2]&127](g,J);ge[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=j8a(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];s5a(w+12|0);s5a(w);i=k;return}function j8a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=xfb(l)|0;if((n|0)!=0){o=n;p=n;break}Kfb()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((ie[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((ie[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=xe[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(xe[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){ie[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((ie[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}yfb(o);i=k;return _|0}function k8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];l8a(a,0,k,j,f,g,h);i=b;return}function l8a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;b9a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;B5a(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}B5a(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}B5a(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((D8a(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=Zdb(F,c[o>>2]|0,h,t)|0;obb(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;s5a(n);s5a(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;s5a(n);s5a(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;s5a(n);s5a(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;s5a(n);s5a(m);i=d;return}function m8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];n8a(a,0,k,j,f,g,h);i=b;return}function n8a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;b9a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;B5a(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}B5a(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}B5a(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((D8a(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=Ydb(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;obb(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;s5a(n);s5a(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;s5a(n);s5a(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;s5a(n);s5a(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;s5a(n);s5a(m);i=d;return}function o8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];p8a(a,0,k,j,f,g,h);i=b;return}function p8a(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==64){u=8}else if((t|0)==0){u=0}else if((t|0)==8){u=16}else{u=10}t=l;b9a(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;B5a(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((ie[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}B5a(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}B5a(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((D8a(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){ie[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=Xdb(G,c[p>>2]|0,j,u)|0;obb(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;s5a(o);s5a(n);i=e;return}if((ie[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;s5a(o);s5a(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;s5a(o);s5a(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;s5a(o);s5a(n);i=e;return}function q8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];r8a(a,0,k,j,f,g,h);i=b;return}function r8a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;b9a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;B5a(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}B5a(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}B5a(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((D8a(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=Wdb(F,c[o>>2]|0,h,t)|0;obb(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;s5a(n);s5a(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;s5a(n);s5a(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;s5a(n);s5a(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;s5a(n);s5a(m);i=d;return}function s8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];t8a(a,0,k,j,f,g,h);i=b;return}



function t8a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;b9a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;B5a(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}B5a(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}B5a(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((D8a(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=Vdb(F,c[o>>2]|0,h,t)|0;obb(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;s5a(n);s5a(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;s5a(n);s5a(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;s5a(n);s5a(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;s5a(n);s5a(m);i=d;return}function u8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];v8a(a,0,k,j,f,g,h);i=b;return}function v8a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;b9a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;B5a(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}B5a(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}B5a(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((D8a(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=Udb(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;obb(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;s5a(n);s5a(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;s5a(n);s5a(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;s5a(n);s5a(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;s5a(n);s5a(m);i=d;return}function w8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];x8a(a,0,k,j,f,g,h);i=b;return}function x8a(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;c9a(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;B5a(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}B5a(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}B5a(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((d9a(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+Tdb(I,c[p>>2]|0,j);obb(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;s5a(o);s5a(n);i=d;return}if((ie[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;s5a(o);s5a(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;s5a(o);s5a(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;s5a(o);s5a(n);i=d;return}function y8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];z8a(a,0,k,j,f,g,h);i=b;return}function z8a(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;c9a(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;B5a(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}B5a(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}B5a(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((d9a(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+Sdb(I,c[p>>2]|0,j);obb(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;s5a(o);s5a(n);i=d;return}if((ie[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;s5a(o);s5a(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;s5a(o);s5a(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;s5a(o);s5a(n);i=d;return}function A8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];B8a(a,0,k,j,f,g,h);i=b;return}function B8a(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;c9a(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;B5a(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}B5a(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}B5a(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((d9a(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+Rdb(I,c[p>>2]|0,j);obb(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;s5a(o);s5a(n);i=d;return}if((ie[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;s5a(o);s5a(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;s5a(o);s5a(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;s5a(o);s5a(n);i=d;return}function C8a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;o6a(o,g);g=o;o=c[g>>2]|0;if(!((c[48104]|0)==-1)){c[l>>2]=192416;c[l+4>>2]=445;c[l+8>>2]=0;d5a(192416,l,446)}l=(c[192420>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;cfb(w);x=207976;y=127;Td(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ec(4)|0;w=v;cfb(w);x=207976;y=127;Td(v|0,x|0,y|0)}y=m;He[c[(c[o>>2]|0)+32>>2]&63](o,190960,190986|0,y)|0;K4a(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;B5a(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((ie[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}B5a(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}B5a(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(ie[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((D8a(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){ie[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);K=c[48076]|0;c[k>>2]=j;if((E8a(E,K,191e3,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((ie[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;s5a(p);s5a(n);i=d;return}if((ie[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;s5a(p);s5a(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;s5a(p);s5a(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;s5a(p);s5a(n);i=d;return}function D8a(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[190960+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}}while(0);e=a[190960+h|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function E8a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Lc(b|0)|0;b=Xa(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Lc(e|0)|0;i=f;return b|0}function F8a(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function G8a(a){a=a|0;i=i;return}function H8a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];ue[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}o6a(u,g);m=u;u=c[m>>2]|0;if(!((c[48102]|0)==-1)){c[p>>2]=192408;c[p+4>>2]=445;c[p+8>>2]=0;d5a(192408,p,446)}p=(c[192412>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ec(4)|0;D=C;cfb(D);E=207976;F=127;Td(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ec(4)|0;D=C;cfb(D);E=207976;F=127;Td(C|0,E|0,F|0)}F=u;K4a(c[m>>2]|0)|0;o6a(v,g);g=v;v=c[g>>2]|0;if(!((c[48142]|0)==-1)){c[o>>2]=192568;c[o+4>>2]=445;c[o+8>>2]=0;d5a(192568,o,446)}o=(c[192572>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;cfb(H);I=207976;J=127;Td(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ec(4)|0;H=G;cfb(H);I=207976;J=127;Td(G|0,I|0,J|0)}J=v;K4a(c[g>>2]|0)|0;g=w;ge[c[(c[v>>2]|0)+24>>2]&127](g,J);ge[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=I8a(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];W5a(w+12|0);W5a(w);i=k;return}function I8a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=xfb(l)|0;if((n|0)!=0){o=n;p=n;break}Kfb()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=ie[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=ie[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=xe[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(xe[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){ie[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}yfb(o);i=k;return ba|0}function J8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];K8a(a,0,k,j,f,g,h);i=b;return}function K8a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;e9a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;B5a(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}B5a(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}B5a(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((a9a(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=Zdb(I,c[o>>2]|0,h,t)|0;obb(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;s5a(n);s5a(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;s5a(n);s5a(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;s5a(n);s5a(m);i=d;return}function L8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];M8a(a,0,k,j,f,g,h);i=b;return}function M8a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;e9a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;B5a(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}B5a(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}B5a(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((a9a(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=Ydb(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;obb(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;s5a(n);s5a(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;s5a(n);s5a(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;s5a(n);s5a(m);i=d;return}function N8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];O8a(a,0,k,j,f,g,h);i=b;return}function O8a(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==0){u=0}else if((t|0)==64){u=8}else if((t|0)==8){u=16}else{u=10}t=l;e9a(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;B5a(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=ie[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}B5a(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}B5a(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=ie[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((a9a(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){ie[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=Xdb(J,c[p>>2]|0,j,u)|0;obb(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=ie[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=ie[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;s5a(o);s5a(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;s5a(o);s5a(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;s5a(o);s5a(n);i=e;return}function P8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Q8a(a,0,k,j,f,g,h);i=b;return}function Q8a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;e9a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;B5a(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}B5a(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}B5a(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((a9a(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=Wdb(I,c[o>>2]|0,h,t)|0;obb(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;s5a(n);s5a(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;s5a(n);s5a(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;s5a(n);s5a(m);i=d;return}function R8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];S8a(a,0,k,j,f,g,h);i=b;return}function S8a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;e9a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;B5a(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}B5a(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}B5a(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((a9a(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=Vdb(I,c[o>>2]|0,h,t)|0;obb(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;s5a(n);s5a(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;s5a(n);s5a(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;s5a(n);s5a(m);i=d;return}function T8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];U8a(a,0,k,j,f,g,h);i=b;return}function U8a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;e9a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;B5a(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}B5a(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}B5a(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((a9a(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=Udb(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;obb(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;s5a(n);s5a(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;s5a(n);s5a(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;s5a(n);s5a(m);i=d;return}function V8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];W8a(a,0,k,j,f,g,h);i=b;return}function W8a(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;f9a(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;B5a(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ie[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}B5a(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}B5a(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((g9a(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+Tdb(L,c[p>>2]|0,j);obb(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ie[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;s5a(o);s5a(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;s5a(o);s5a(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;s5a(o);s5a(n);i=d;return}function X8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Y8a(a,0,k,j,f,g,h);i=b;return}function Y8a(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;f9a(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;B5a(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ie[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}B5a(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}B5a(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((g9a(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+Sdb(L,c[p>>2]|0,j);obb(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ie[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;s5a(o);s5a(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;s5a(o);s5a(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;s5a(o);s5a(n);i=d;return}function Z8a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];_8a(a,0,k,j,f,g,h);i=b;return}function _8a(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;f9a(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;B5a(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ie[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}B5a(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}B5a(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((g9a(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+Rdb(L,c[p>>2]|0,j);obb(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ie[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;s5a(o);s5a(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;s5a(o);s5a(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;s5a(o);s5a(n);i=d;return}function $8a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;o6a(o,g);g=o;o=c[g>>2]|0;if(!((c[48102]|0)==-1)){c[l>>2]=192408;c[l+4>>2]=445;c[l+8>>2]=0;d5a(192408,l,446)}l=(c[192412>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;cfb(w);x=207976;y=127;Td(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ec(4)|0;w=v;cfb(w);x=207976;y=127;Td(v|0,x|0,y|0)}y=m;He[c[(c[o>>2]|0)+48>>2]&63](o,190960,190986|0,y)|0;K4a(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;B5a(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=ie[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}B5a(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}B5a(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((a9a(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){ie[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);N=c[48076]|0;c[k>>2]=j;if((E8a(H,N,191e3,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=ie[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=ie[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;s5a(p);s5a(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;s5a(p);s5a(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;s5a(p);s5a(n);i=d;return}function a9a(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[190960+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}}while(0);e=a[190960+m|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function b9a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;o6a(k,d);d=k;k=c[d>>2]|0;if(!((c[48104]|0)==-1)){c[j>>2]=192416;c[j+4>>2]=445;c[j+8>>2]=0;d5a(192416,j,446)}j=(c[192420>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ec(4)|0;n=m;cfb(n);o=207976;p=127;Td(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ec(4)|0;n=m;cfb(n);o=207976;p=127;Td(m|0,o|0,p|0)}He[c[(c[k>>2]|0)+32>>2]&63](k,190960,190986|0,e)|0;e=c[d>>2]|0;if(!((c[48140]|0)==-1)){c[h>>2]=192560;c[h+4>>2]=445;c[h+8>>2]=0;d5a(192560,h,446)}h=(c[192564>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ec(4)|0;r=q;cfb(r);s=207976;t=127;Td(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Ec(4)|0;r=q;cfb(r);s=207976;t=127;Td(q|0,s|0,t|0)}else{t=e;a[f]=ie[c[(c[e>>2]|0)+16>>2]&127](t)|0;ge[c[(c[e>>2]|0)+20>>2]&127](b,t);K4a(c[d>>2]|0)|0;i=g;return}}function c9a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;o6a(l,d);d=l;l=c[d>>2]|0;if(!((c[48104]|0)==-1)){c[k>>2]=192416;c[k+4>>2]=445;c[k+8>>2]=0;d5a(192416,k,446)}k=(c[192420>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Ec(4)|0;o=n;cfb(o);p=207976;q=127;Td(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Ec(4)|0;o=n;cfb(o);p=207976;q=127;Td(n|0,p|0,q|0)}He[c[(c[l>>2]|0)+32>>2]&63](l,190960,190992|0,e)|0;e=c[d>>2]|0;if(!((c[48140]|0)==-1)){c[j>>2]=192560;c[j+4>>2]=445;c[j+8>>2]=0;d5a(192560,j,446)}j=(c[192564>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Ec(4)|0;s=r;cfb(s);t=207976;u=127;Td(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Ec(4)|0;s=r;cfb(s);t=207976;u=127;Td(r|0,t|0,u|0)}else{u=e;a[f]=ie[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=ie[c[(c[e>>2]|0)+16>>2]&127](u)|0;ge[c[(c[e>>2]|0)+20>>2]&127](b,u);K4a(c[d>>2]|0)|0;i=h;return}}function d9a(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[190960+j|0]|0;if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function e9a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;o6a(j,b);b=j;j=c[b>>2]|0;if(!((c[48102]|0)==-1)){c[h>>2]=192408;c[h+4>>2]=445;c[h+8>>2]=0;d5a(192408,h,446)}h=(c[192412>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Ec(4)|0;m=l;cfb(m);n=207976;o=127;Td(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Ec(4)|0;m=l;cfb(m);n=207976;o=127;Td(l|0,n|0,o|0)}He[c[(c[j>>2]|0)+48>>2]&63](j,190960,190986|0,d)|0;d=c[b>>2]|0;if(!((c[48142]|0)==-1)){c[g>>2]=192568;c[g+4>>2]=445;c[g+8>>2]=0;d5a(192568,g,446)}g=(c[192572>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Ec(4)|0;q=p;cfb(q);r=207976;s=127;Td(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Ec(4)|0;q=p;cfb(q);r=207976;s=127;Td(p|0,r|0,s|0)}else{s=d;c[e>>2]=ie[c[(c[d>>2]|0)+16>>2]&127](s)|0;ge[c[(c[d>>2]|0)+20>>2]&127](a,s);K4a(c[b>>2]|0)|0;i=f;return}}function f9a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;o6a(k,b);b=k;k=c[b>>2]|0;if(!((c[48102]|0)==-1)){c[j>>2]=192408;c[j+4>>2]=445;c[j+8>>2]=0;d5a(192408,j,446)}j=(c[192412>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ec(4)|0;n=m;cfb(n);o=207976;p=127;Td(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ec(4)|0;n=m;cfb(n);o=207976;p=127;Td(m|0,o|0,p|0)}He[c[(c[k>>2]|0)+48>>2]&63](k,190960,190992|0,d)|0;d=c[b>>2]|0;if(!((c[48142]|0)==-1)){c[h>>2]=192568;c[h+4>>2]=445;c[h+8>>2]=0;d5a(192568,h,446)}h=(c[192572>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ec(4)|0;r=q;cfb(r);s=207976;t=127;Td(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Ec(4)|0;r=q;cfb(r);s=207976;t=127;Td(q|0,s|0,t|0)}else{t=d;c[e>>2]=ie[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=ie[c[(c[d>>2]|0)+16>>2]&127](t)|0;ge[c[(c[d>>2]|0)+20>>2]&127](a,t);K4a(c[b>>2]|0)|0;i=g;return}}function g9a(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[190960+o|0]|0;do{if((o|0)==23|(o|0)==22){a[e]=80}else if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function h9a(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function i9a(a){a=a|0;i=i;return}function j9a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];re[p&31](b,d,k,f,g,q);i=j;return}o6a(n,f);f=n;n=c[f>>2]|0;if(!((c[48140]|0)==-1)){c[l>>2]=192560;c[l+4>>2]=445;c[l+8>>2]=0;d5a(192560,l,446)}l=(c[192564>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ec(4)|0;u=t;cfb(u);v=207976;w=127;Td(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ec(4)|0;u=t;cfb(u);v=207976;w=127;Td(t|0,v|0,w|0)}w=n;K4a(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ge[c[f+24>>2]&127](o,w)}else{ge[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((xe[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];s5a(o);i=j;return}function k9a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=191208;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);v=c[48076]|0;c[k>>2]=h;h=l9a(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;o6a(q,f);m9a(w,y,k,z,o,p,q);K4a(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];Q1a(b,j,z,e,o,f,g);i=d;return}function l9a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Lc(d|0)|0;d=Zc(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Lc(f|0)|0;i=g;return d|0}function m9a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[48104]|0)==-1)){c[m>>2]=192416;c[m+4>>2]=445;c[m+8>>2]=0;d5a(192416,m,446)}m=(c[192420>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;cfb(r);s=207976;t=127;Td(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;cfb(r);s=207976;t=127;Td(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[48140]|0)==-1)){c[l>>2]=192560;c[l+4>>2]=445;c[l+8>>2]=0;d5a(192560,l,446)}l=(c[192564>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;cfb(v);w=207976;x=127;Td(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;cfb(v);w=207976;x=127;Td(u|0,w|0,x|0)}x=s;ge[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){He[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=xe[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=xe[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=xe[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=ie[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=xe[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;s5a(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;s5a(n);i=k;return}}function n9a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);w=c[48076]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=l9a(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;o6a(r,f);m9a(x,z,l,A,p,q,r);K4a(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];Q1a(b,k,A,e,p,f,g);i=d;return}function o9a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=191208;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);v=c[48076]|0;c[k>>2]=h;h=l9a(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;o6a(q,f);m9a(w,y,k,z,o,p,q);K4a(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];Q1a(b,j,z,e,o,f,g);i=d;return}function p9a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);y=c[48076]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=l9a(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;o6a(r,f);m9a(x,z,l,A,p,q,r);K4a(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];Q1a(b,k,A,e,p,f,g);i=d;return}function q9a(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);r=c[48076]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=l9a(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=l9a(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[192312]|0)==0;if(F){do{if(o){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);r=c[48076]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=r9a(s,r,z,n)|0}else{do{if(o){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);o=c[48076]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=r9a(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}Kfb()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=xfb(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}Kfb()}}while(0);o6a(w,f);s9a(N,L,G,P,u,v,w);K4a(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];Q1a(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){yfb(O)}if((J|0)==0){i=d;return}yfb(J);i=d;return}function r9a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Lc(b|0)|0;b=jc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Lc(e|0)|0;i=f;return b|0}function s9a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[48104]|0)==-1)){c[m>>2]=192416;c[m+4>>2]=445;c[m+8>>2]=0;d5a(192416,m,446)}m=(c[192420>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;cfb(r);s=207976;t=127;Td(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;cfb(r);s=207976;t=127;Td(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[48140]|0)==-1)){c[l>>2]=192560;c[l+4>>2]=445;c[l+8>>2]=0;d5a(192560,l,446)}l=(c[192564>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;cfb(v);w=207976;x=127;Td(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;cfb(v);w=207976;x=127;Td(u|0,w|0,x|0)}x=s;ge[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=xe[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=xe[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=xe[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);w=A+1|0;if((Xc(l<<24>>24|0,c[48076]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);l=D+1|0;if((Vd(A<<24>>24|0,c[48076]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){He[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=ie[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=xe[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=xe[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=ie[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);He[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;s5a(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;s5a(n);i=k;return}function t9a(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);r=c[48076]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=l9a(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=l9a(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[192312]|0)==0;if(F){do{if(o){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);r=c[48076]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=r9a(s,r,z,n)|0}else{do{if(o){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);o=c[48076]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=r9a(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}Kfb()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=xfb(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}Kfb()}}while(0);o6a(w,f);s9a(N,L,G,P,u,v,w);K4a(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];Q1a(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){yfb(O)}if((J|0)==0){i=d;return}yfb(J);i=d;return}function u9a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=191216;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);s=c[48076]|0;c[k>>2]=h;h=l9a(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}u=o;o6a(p,f);r=p;p=c[r>>2]|0;if(!((c[48104]|0)==-1)){c[l>>2]=192416;c[l+4>>2]=445;c[l+8>>2]=0;d5a(192416,l,446)}l=(c[192420>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;cfb(w);x=207976;y=127;Td(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;cfb(w);x=207976;y=127;Td(v|0,x|0,y|0)}K4a(c[r>>2]|0)|0;He[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];Q1a(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];Q1a(b,j,u,z,m,f,g);I=j;i=d;return}function v9a(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function w9a(a){a=a|0;i=i;return}function x9a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];re[p&31](b,d,k,f,g,q);i=j;return}o6a(n,f);f=n;n=c[f>>2]|0;if(!((c[48142]|0)==-1)){c[l>>2]=192568;c[l+4>>2]=445;c[l+8>>2]=0;d5a(192568,l,446)}l=(c[192572>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ec(4)|0;u=t;cfb(u);v=207976;w=127;Td(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ec(4)|0;u=t;cfb(u);v=207976;w=127;Td(t|0,v|0,w|0)}w=n;K4a(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ge[c[f+24>>2]&127](o,w)}else{ge[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=xe[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];W5a(o);i=j;return}function y9a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=191208;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);x=c[48076]|0;c[k>>2]=h;h=l9a(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;o6a(q,f);z9a(w,y,k,z,o,p,q);K4a(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];A9a(b,j,z,e,o,f,g);i=d;return}function z9a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[48102]|0)==-1)){c[m>>2]=192408;c[m+4>>2]=445;c[m+8>>2]=0;d5a(192408,m,446)}m=(c[192412>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;cfb(r);s=207976;t=127;Td(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;cfb(r);s=207976;t=127;Td(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[48142]|0)==-1)){c[l>>2]=192568;c[l+4>>2]=445;c[l+8>>2]=0;d5a(192568,l,446)}l=(c[192572>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;cfb(v);w=207976;x=127;Td(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;cfb(v);w=207976;x=127;Td(u|0,w|0,x|0)}x=s;ge[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){He[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=xe[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=xe[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=xe[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=ie[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=xe[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;s5a(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;s5a(n);i=k;return}function A9a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((le[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){V5a(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((le[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){W5a(l);break}c[m>>2]=0;c[b>>2]=0;W5a(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((le[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function B9a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);y=c[48076]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=l9a(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;o6a(r,f);z9a(x,z,l,A,p,q,r);K4a(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];A9a(b,k,A,e,p,f,g);i=d;return}function C9a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=191208;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);v=c[48076]|0;c[k>>2]=h;h=l9a(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;o6a(q,f);z9a(w,y,k,z,o,p,q);K4a(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];A9a(b,j,z,e,o,f,g);i=d;return}function D9a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);w=c[48076]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=l9a(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;o6a(r,f);z9a(x,z,l,A,p,q,r);K4a(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];A9a(b,k,A,e,p,f,g);i=d;return}function E9a(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);r=c[48076]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=l9a(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=l9a(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[192312]|0)==0;if(F){do{if(o){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);r=c[48076]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=r9a(s,r,z,n)|0}else{do{if(o){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);o=c[48076]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=r9a(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}Kfb()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=xfb(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}Kfb()}}while(0);o6a(w,f);F9a(N,L,G,P,u,v,w);K4a(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];A9a(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){yfb(O)}if((J|0)==0){i=d;return}yfb(J);i=d;return}function F9a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[48102]|0)==-1)){c[m>>2]=192408;c[m+4>>2]=445;c[m+8>>2]=0;d5a(192408,m,446)}m=(c[192412>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;cfb(r);s=207976;t=127;Td(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;cfb(r);s=207976;t=127;Td(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[48142]|0)==-1)){c[l>>2]=192568;c[l+4>>2]=445;c[l+8>>2]=0;d5a(192568,l,446)}l=(c[192572>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;cfb(v);w=207976;x=127;Td(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;cfb(v);w=207976;x=127;Td(u|0,w|0,x|0)}x=s;ge[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=xe[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=xe[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=xe[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);w=A+1|0;if((Xc(l<<24>>24|0,c[48076]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);l=D+1|0;if((Vd(A<<24>>24|0,c[48076]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){He[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=ie[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=xe[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=xe[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=ie[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);He[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;s5a(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;s5a(n);i=k;return}function G9a(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);r=c[48076]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=l9a(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=l9a(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[192312]|0)==0;if(F){do{if(o){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);r=c[48076]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=r9a(s,r,z,n)|0}else{do{if(o){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);o=c[48076]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=r9a(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}Kfb()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=xfb(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}Kfb()}}while(0);o6a(w,f);F9a(N,L,G,P,u,v,w);K4a(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];A9a(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){yfb(O)}if((J|0)==0){i=d;return}yfb(J);i=d;return}



function ZJa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=RJa(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[109544+((d[109288+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=RJa(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 15:{p=62;break b;break};case 6:{p=31;break b;break};case 5:{p=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{p=37;break b;break};case 7:{p=34;break b;break};case 29:{if((c[109544+((d[110824+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((aKa(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=RJa(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((aKa(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function _Ja(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=RJa(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[109544+((d[109288+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=RJa(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 5:{n=28;break b;break};case 7:{n=34;break b;break};case 23:{b=b+2|0;continue b;break};case 11:{n=48;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=31;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 29:{if((c[109544+((d[110824+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=RJa(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function $Ja(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=RJa(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 29:{if((c[109544+((d[110824+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 6:{l=13;break a;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=RJa(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}switch(n|0){case 24:case 22:{break};case 5:{l=30;break a;break};case 7:{l=36;break a;break};case 29:{if((c[109544+((d[109288+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 6:{l=33;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 7:{l=16;break a;break};case 14:{break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){o=d[k+76+(d[b]|0)|0]|0}else{o=RJa(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 5:{l=10;break a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[p]|0)|0]|0}else{q=RJa(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[p]|0)|0]|0}else{s=RJa(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 2:{l=79;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 3:{t=SJa(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 8:case 1:case 0:{l=74;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[p]|0)|0]|0}else{u=RJa(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[p]|0)|0]|0}else{v=RJa(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 11:{l=106;break a;break};case 5:{l=97;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 6:{l=100;break a;break};case 29:{l=94;break d;break};case 24:case 22:{break d;break};case 7:{l=103;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[109544+((d[109288+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function aKa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function bKa(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=RJa(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 8:case 1:case 0:{l=16;break a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=RJa(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function cKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=RJa(a[g+1|0]|0,a[b]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=RJa(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 24:case 22:{break};case 30:{n=16;break a;break};case 10:case 9:case 21:{break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=RJa(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=XJa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function dKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=RJa(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[109544+((d[109288+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=RJa(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 7:{n=34;break b;break};case 6:{n=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=28;break b;break};case 29:{if((c[109544+((d[110824+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function eKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=RJa(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=RJa(a[g]|0,a[b+1|0]|0)|0}switch(n|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 15:{k=CKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{k=HKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 30:{k=wKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{o=19;b=b+2|0;p=77;break};case 19:{k=IKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{g=b;if((c[109544+((d[109288+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;o=18;p=77;break a}if((c[109544+((d[110824+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=76;break a}b=b+2|0;o=19;p=77;break};case 13:{k=GKa(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{o=18;b=b+2|0;p=77;break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){q=d[j+76+(d[g+1|0]|0)|0]|0}else{q=RJa(a[g]|0,a[b+1|0]|0)|0}switch(q|0){case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 9:{if((b+2|0)!=(e|0)){p=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 12:{k=GKa(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:case 21:{p=25;break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};default:{p=76}}}while(0);if((p|0)==25){while(1){p=0;b=b+2|0;r=b;if((b|0)==(e|0)){p=32;break}q=b;if((a[r]|0)==0){s=d[j+76+(d[q+1|0]|0)|0]|0}else{s=RJa(a[q]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){p=25;continue}else if((s|0)!=9){p=31;break}if((b+2|0)!=(e|0)){p=25}else{p=31;break}}if((p|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((p|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((p|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==77){b:while(1){p=0;if((b|0)==(e|0)){p=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=RJa(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 23:{b=b+2|0;r=o;if((r|0)==41){o=19;p=77;continue b}else if((r|0)!=18){p=77;continue b}if((b|0)==(e|0)){p=97;break b}o=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=RJa(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 6:{p=108;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[109544+((d[110824+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=103;break b}break};case 5:{p=105;break b;break};case 7:{p=111;break b;break};default:{o=19;p=77;continue b}}b=b+2|0;p=77;continue b;break};case 33:{p=119;break b;break};case 34:{p=116;break b;break};case 15:{p=122;break b;break};case 29:{if((c[109544+((d[110824+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=83;break b}break};case 6:{p=88;break b;break};case 7:{p=91;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{p=94;break b;break};case 5:{p=85;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{p=125;break b}}b=b+2|0;p=77}if((p|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==94){c[f>>2]=b;k=o;l=k;i=h;return l|0}else if((p|0)==97){k=-1;l=k;i=h;return l|0}else if((p|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==116){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((p|0)==119){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((p|0)==122){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((p|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==126){k=0-o|0;l=k;i=h;return l|0}}return 0}function fKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=RJa(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=RJa(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 3:{k=vKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 2:{k=zKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=RJa(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 6:{r=b;if((e-b|0)<3){p=52;break b}b=r+3|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=49;break b}b=t+2|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function gKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=RJa(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=RJa(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=RJa(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 5:{t=b;if((e-b|0)<2){p=47;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function hKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=RJa(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function iKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=RJa(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 10:{n=16;break a;break};case 3:{n=12;break a;break};case 6:{b=b+3|0;continue a;break};case 2:{n=15;break a;break};case 21:{n=29;break a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 9:{n=19;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=vKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=RJa(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function jKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=RJa(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 9:{n=21;break a;break};case 3:{n=12;break a;break};case 10:{n=18;break a;break};case 6:{b=b+3|0;continue a;break};case 30:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=vKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=wKa(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=RJa(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function kKa(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=RJa(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 5:{break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=15;break a}e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=17;break a}else{continue a}break};case 6:{k=8;break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c]|0)==0){n=d[g+76+(d[k+1|0]|0)|0]|0}else{n=RJa(a[k]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function lKa(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function mKa(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=RJa(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function nKa(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=RJa(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function oKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=RJa(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=RJa(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function pKa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=dJa(c)|0;k=j;i=b;return k|0}function qKa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==4){if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((f|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==108){g=60;h=g;i=b;return h|0}else if((j|0)==103){g=62;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function rKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=RJa(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 7:{b=b+4|0;break};case 5:{b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=RJa(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 6:{b=b+3|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function sKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=RJa(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function tKa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g+1|0]|0;n=((l&3)<<4|(a[g]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function uKa(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function vKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=RJa(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 29:{if((c[109544+((d[109288+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 19:{k=xKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=RJa(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 18:{n=38;break b;break};case 7:{n=35;break b;break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};case 29:{if((c[109544+((d[110824+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function wKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=RJa(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 29:{if((c[109544+((d[109288+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=RJa(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 18:{n=38;break b;break};case 7:{n=35;break b;break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[109544+((d[110824+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function xKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=yKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=RJa(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=RJa(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function yKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=RJa(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=RJa(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function zKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=RJa(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 17:{k=DKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 29:{if((c[109544+((d[109288+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=CKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=RJa(a[g]|0,a[b+1|0]|0)|0}if((n|0)==20){k=BKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=AKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=RJa(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 6:{o=42;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=RJa(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 29:{if((c[109544+((d[109288+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};case 24:case 22:{break};case 7:{o=65;break b;break};case 5:{o=59;break b;break};case 6:{o=62;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 7:{o=45;break b;break};case 29:{if((c[109544+((d[110824+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 5:{o=39;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 11:{o=90;break b;break};case 17:{break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=RJa(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 5:{o=78;break d;break};case 29:{o=75;break d;break};case 6:{o=81;break d;break};case 10:case 9:case 21:{break};case 7:{o=84;break d;break};case 11:{o=90;break c;break};case 17:{break c;break};case 24:case 22:{break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[109544+((d[109288+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=EKa(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function AKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=RJa(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function BKa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[111864+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function CKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=RJa(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[109544+((d[109288+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=RJa(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 15:{p=62;break b;break};case 7:{p=34;break b;break};case 6:{p=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{p=37;break b;break};case 29:{if((c[109544+((d[110824+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 5:{p=28;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((FKa(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=RJa(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 8:case 1:case 0:{p=54;break c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((FKa(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function DKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=RJa(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[109544+((d[109288+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=RJa(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 23:{b=b+2|0;continue b;break};case 29:{if((c[109544+((d[110824+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 11:{n=48;break b;break};case 5:{n=28;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 7:{n=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=RJa(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function EKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=RJa(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 7:{l=16;break a;break};case 6:{l=13;break a;break};case 29:{if((c[109544+((d[110824+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=RJa(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(n|0){case 24:case 22:{break};case 5:{l=30;break a;break};case 29:{if((c[109544+((d[109288+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 7:{l=36;break a;break};case 6:{l=33;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 14:{break};case 5:{l=10;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){o=d[k+76+(d[b+1|0]|0)|0]|0}else{o=RJa(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 27:case 26:case 25:case 24:case 22:{l=9;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[p+1|0]|0)|0]|0}else{q=RJa(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[p+1|0]|0)|0]|0}else{s=RJa(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 3:{t=vKa(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 2:{l=79;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[p+1|0]|0)|0]|0}else{u=RJa(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[p+1|0]|0)|0]|0}else{v=RJa(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 7:{l=103;break a;break};case 6:{l=100;break a;break};case 24:case 22:{break d;break};case 10:case 9:case 21:{break};case 29:{l=94;break d;break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 5:{l=97;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[109544+((d[109288+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function FKa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function GKa(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=RJa(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=RJa(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function HKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=RJa(a[g]|0,a[b+1|0]|0)|0}if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==27){k=AKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=RJa(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 10:case 9:case 21:{break a;break};case 24:case 22:{break};case 30:{n=16;break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=RJa(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function IKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=RJa(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 29:{if((c[109544+((d[109288+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=RJa(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 6:{n=31;break b;break};case 5:{n=28;break b;break};case 29:{if((c[109544+((d[110824+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function JKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((xe[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;m=18;break a}g=b;if((xe[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:case 21:{n=15;break};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 16:{k=sLa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};case 15:{k=nLa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 23:case 27:case 26:case 25:{m=19;b=b+1|0;break};case 19:{k=tLa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 12:{k=rLa(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 30:{k=hLa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 13:{k=rLa(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((xe[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;m=18;break a}g=b;if((xe[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 9:{if((b+1|0)!=(e|0)){n=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((xe[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;m=18;break a}g=b;if((xe[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 24:case 22:{m=18;b=b+1|0;break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((n|0)==15){while(1){n=0;b=b+1|0;o=b;if((b|0)==(e|0)){n=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){n=15;continue}else if((g|0)!=9){n=18;break}if((b+1|0)!=(e|0)){n=15}else{n=18;break}}if((n|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){n=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){n=77;break b}p=b;if((xe[c[j+336>>2]&63](j,b)|0)==0){n=79;break b}b=p+3|0;continue b;break};case 29:{n=69;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 15:{n=116;break b;break};case 23:{b=b+1|0;o=m;if((o|0)==41){m=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){n=89;break b}m=41;switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){n=94;break b}q=b;if((xe[c[j+332>>2]&63](j,b)|0)==0){n=96;break b}b=q+2|0;continue b;break};case 6:{if((e-b|0)<3){n=99;break b}r=b;if((xe[c[j+336>>2]&63](j,b)|0)==0){n=101;break b}b=r+3|0;continue b;break};case 29:{n=91;break b;break};case 7:{if((e-b|0)<4){n=104;break b}s=b;if((xe[c[j+340>>2]&63](j,b)|0)==0){n=106;break b}b=s+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};default:{m=19;continue b}}break};case 33:{n=113;break b;break};case 34:{n=110;break b;break};case 5:{if((e-b|0)<2){n=72;break b}t=b;if((xe[c[j+332>>2]&63](j,b)|0)==0){n=74;break b}b=t+2|0;continue b;break};case 7:{if((e-b|0)<4){n=82;break b}u=b;if((xe[c[j+340>>2]&63](j,b)|0)==0){n=84;break b}b=u+4|0;continue b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=86;break b;break};default:{n=119;break b}}}if((n|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==72){k=-2;l=k;i=h;return l|0}else if((n|0)==74){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((n|0)==77){k=-2;l=k;i=h;return l|0}else if((n|0)==79){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((n|0)==82){k=-2;l=k;i=h;return l|0}else if((n|0)==84){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((n|0)==86){c[f>>2]=b;k=m;l=k;i=h;return l|0}else if((n|0)==89){k=-1;l=k;i=h;return l|0}else if((n|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==94){k=-2;l=k;i=h;return l|0}else if((n|0)==96){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((n|0)==99){k=-2;l=k;i=h;return l|0}else if((n|0)==101){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((n|0)==104){k=-2;l=k;i=h;return l|0}else if((n|0)==106){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((n|0)==110){s=b;if((m|0)==19){c[f>>2]=s;k=0;l=k;i=h;return l|0}else{c[f>>2]=s+1;k=32;l=k;i=h;return l|0}}else if((n|0)==113){s=b;if((m|0)==19){c[f>>2]=s;k=0;l=k;i=h;return l|0}else{c[f>>2]=s+1;k=31;l=k;i=h;return l|0}}else if((n|0)==116){s=b;if((m|0)==19){c[f>>2]=s;k=0;l=k;i=h;return l|0}else{c[f>>2]=s+1;k=30;l=k;i=h;return l|0}}else if((n|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==120){k=0-m|0;l=k;i=h;return l|0}return 0}function KKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 2:{k=kLa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 3:{k=gLa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=41;break b}if((xe[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((xe[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){n=49;break b}if((xe[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function LKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 7:{if((e-b|0)<4){n=47;break b}if((xe[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){n=43;break b}if((xe[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){n=39;break b}if((xe[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function MKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{k=19;break a;break};case 2:{l=b+1|0;b=l;if((l|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}l=b+1|0;b=l;if((l|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}m=b;if((xe[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=m+2|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((xe[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}o=b;if((xe[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=o+4|0;continue a;break};case 4:{l=b+1|0;b=l;if((l|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}l=b+1|0;b=l;if((l|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=m;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function NKa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 7:{a=a+4|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 21:{m=23;break a;break};case 5:{a=a+2|0;continue a;break};case 3:{m=9;break a;break};case 10:{m=13;break a;break};case 2:{m=12;break a;break};case 9:{m=16;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=gLa(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function OKa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 7:{a=a+4|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 9:{m=18;break a;break};case 5:{a=a+2|0;continue a;break};case 3:{m=9;break a;break};case 10:{m=15;break a;break};case 30:{m=12;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=gLa(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=hLa(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function PKa(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;h=b;b=h+1|0;if((a[e]|0)!=(a[h]|0)){j=12;break a}else{continue a}break};case 5:{break};case 7:{h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=4;break a}else{j=5}break};case 6:{j=5;break};default:{j=13;break a}}if((j|0)==5){j=0;e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=6;break}}h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=8;break}e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=10;break}}if((j|0)==4){k=0;l=k;i=f;return l|0}else if((j|0)==6){k=0;l=k;i=f;return l|0}else if((j|0)==8){k=0;l=k;i=f;return l|0}else if((j|0)==10){k=0;l=k;i=f;return l|0}else if((j|0)==12){k=0;l=k;i=f;return l|0}else if((j|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function QKa(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function RKa(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 5:{a=a+2|0;continue a;break};default:{break a}}}i=c;return a-b|0}function SKa(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function TKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function UKa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=dJa(c)|0;g=f;i=b;return g|0}function VKa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){d=a[e]|0;if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==103){f=62;g=f;i=b;return g|0}else if((d|0)==108){f=60;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function WKa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{a=a+3|0;break};case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};case 5:{a=a+2|0;break};case 7:{a=a+4|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function XKa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 21:{if((a[b]|0)==9){k=5;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function YKa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function ZKa(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==5){p=j;j=p+2|0;b[p>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==6){o=j;j=o+2|0;b[o>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function _Ka(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[109544+(((d[110824+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function $Ka(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[109544+(((d[110824+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function aLa(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function bLa(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[109544+(((d[109288+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function cLa(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[109544+(((d[109288+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function dLa(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function eLa(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function fLa(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function gLa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 19:{j=iLa(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{l=25;break b;break};case 5:{if((b-a|0)<2){l=28;break b}m=a;if((xe[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((xe[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}o=a;if((xe[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=o+3|0;continue b;break};case 18:{l=42;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function hLa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{l=25;break b;break};case 7:{if((b-a|0)<4){l=38;break b}m=a;if((xe[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=m+4|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}n=a;if((xe[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=n+2|0;continue b;break};case 18:{l=42;break b;break};case 6:{if((b-a|0)<3){l=33;break b}o=a;if((xe[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=o+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function iLa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=jLa(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}



function H9a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=191216;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);s=c[48076]|0;c[k>>2]=h;h=l9a(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}o6a(p,f);u=p;p=c[u>>2]|0;if(!((c[48102]|0)==-1)){c[l>>2]=192408;c[l+4>>2]=445;c[l+8>>2]=0;d5a(192408,l,446)}l=(c[192412>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;cfb(w);x=207976;y=127;Td(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;cfb(w);x=207976;y=127;Td(v|0,x|0,y|0)}K4a(c[u>>2]|0)|0;u=o;He[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];A9a(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];A9a(b,j,u,z,m,f,g);I=j;i=d;return}function I9a(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;o6a(r,h);v=r;r=c[v>>2]|0;if(!((c[48104]|0)==-1)){c[q>>2]=192416;c[q+4>>2]=445;c[q+8>>2]=0;d5a(192416,q,446)}q=(c[192420>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Ec(4)|0;y=x;cfb(y);z=207976;A=127;Td(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Ec(4)|0;y=x;cfb(y);z=207976;A=127;Td(x|0,z|0,A|0)}A=r;K4a(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((ie[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((ie[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((le[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(ie[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=xe[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(xe[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=le[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=le[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];we[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((ie[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){ie[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){ie[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((ie[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((ie[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function J9a(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function K9a(a){a=a|0;i=i;return}function L9a(a){a=a|0;i=i;return 2}function M9a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];I9a(a,b,l,k,f,g,h,191320,191328|0);i=j;return}function N9a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=ie[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];I9a(b,d,m,l,g,h,j,s,q);i=k;return}function O9a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;o6a(n,f);f=n;n=c[f>>2]|0;if(!((c[48104]|0)==-1)){c[m>>2]=192416;c[m+4>>2]=445;c[m+8>>2]=0;d5a(192416,m,446)}m=(c[192420>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;cfb(q);r=207976;s=127;Td(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;cfb(q);r=207976;s=127;Td(p|0,r|0,s|0)}s=n;K4a(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ie[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=j8a(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function P9a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;o6a(n,f);f=n;n=c[f>>2]|0;if(!((c[48104]|0)==-1)){c[m>>2]=192416;c[m+4>>2]=445;c[m+8>>2]=0;d5a(192416,m,446)}m=(c[192420>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;cfb(q);r=207976;s=127;Td(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;cfb(q);r=207976;s=127;Td(p|0,r|0,s|0)}s=n;K4a(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ie[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=j8a(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function Q9a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;o6a(m,f);f=m;m=c[f>>2]|0;if(!((c[48104]|0)==-1)){c[l>>2]=192416;c[l+4>>2]=445;c[l+8>>2]=0;d5a(192416,l,446)}l=(c[192420>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ec(4)|0;p=o;cfb(p);q=207976;r=127;Td(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ec(4)|0;p=o;cfb(p);q=207976;r=127;Td(o|0,q|0,r|0)}r=m;K4a(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=V9a(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function R9a(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;o6a(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[48104]|0)==-1)){c[ba>>2]=192416;c[ba+4>>2]=445;c[ba+8>>2]=0;d5a(192416,ba,446)}ba=(c[192420>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ec(4)|0;Ga=Fa;cfb(Ga);Ha=207976;Ia=127;Td(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ec(4)|0;Ga=Fa;cfb(Ga);Ha=207976;Ia=127;Td(Fa|0,Ha|0,Ia|0)}Ia=ca;K4a(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Da=V9a(e,t,h,Ia,1)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<7){c[j+24>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];ca=V9a(e,D,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<60){c[j+4>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];I9a(ga,d,L,K,g,h,j,191328,191336|0);c[Da>>2]=c[ga>>2];break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];I9a(oa,d,A,z,g,h,j,191344,191355|0);c[Da>>2]=c[oa>>2];break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];T9a(d,j+8|0,e,B,h,Ia);break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];I9a(ra,d,y,x,g,h,j,191360,191365|0);c[Da>>2]=c[ra>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=V9a(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];I9a(ua,d,v,u,g,h,j,191368,191376|0);c[Da>>2]=c[ua>>2];break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=V9a(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];I9a(ja,d,J,I,g,h,j,191336,191344|0);c[ca>>2]=c[ja>>2];break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];U9a(0,e,m,h,Ia);break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];ue[ca&63](b,d,s,r,g,h,j);i=l;return};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];ca=V9a(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((ca|0)<69){Ja=ca+2e3|0}else{Ja=(ca+ -69|0)>>>0<31?ca+1900|0:ca}c[j+20>>2]=Ja+ -1900;break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=V9a(e,G,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Ha|4;break};case 65:case 97:{Da=c[f>>2]|0;ca=d+8|0;Fa=ie[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(j8a(e,Q,Fa,Fa+168|0,Ia,h,0)|0)-Fa|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Fa=V9a(e,M,h,Ia,2)|0;ca=c[h>>2]|0;do{if((ca&4|0)==0){if(!((Fa+ -1|0)>>>0<31)){break}c[Da>>2]=Fa;break a}}while(0);c[h>>2]=ca|4;break};case 99:{Fa=d+8|0;Da=ie[c[(c[Fa>>2]|0)+12>>2]&127](Fa)|0;Fa=e;c[ea>>2]=c[Fa>>2];c[fa>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Ka=Da+1|0;La=Da+1|0;Ma=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Ka=Ha;La=Ha;Ma=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];I9a(da,d,O,N,g,h,j,La,Ka+Ma|0);c[Fa>>2]=c[da>>2];break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];S9a(0,e,C,h,Ia);break};case 88:{Fa=d+8|0;Da=ie[c[(c[Fa>>2]|0)+24>>2]&127](Fa)|0;Fa=e;c[Aa>>2]=c[Fa>>2];c[Ba>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Na=Da+1|0;Oa=Da+1|0;Pa=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Na=Ha;Oa=Ha;Pa=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];I9a(za,d,q,p,g,h,j,Oa,Na+Pa|0);c[Fa>>2]=c[za>>2];break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Fa=V9a(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Fa|0)<366){c[j+28>>2]=Fa;break a}else{c[h>>2]=Da|4;break a}break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=V9a(e,E,h,Ia,2)|0;Fa=c[h>>2]|0;if((Fa&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=Fa|4;break a}break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Fa=V9a(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Fa|0)<24){c[j+8>>2]=Fa;break a}else{c[h>>2]=Da|4;break a}break};case 104:case 66:case 98:{Da=c[f>>2]|0;Fa=d+8|0;Ha=ie[c[(c[Fa>>2]|0)+4>>2]&127](Fa)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(j8a(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function S9a(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((ie[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){ie[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((ie[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((ie[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function T9a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=ie[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=j8a(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function U9a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((ie[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(ie[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((le[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){ie[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function V9a(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((ie[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(ie[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(le[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){ie[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((ie[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((ie[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((le[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){ie[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((ie[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function W9a(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;o6a(p,f);t=p;p=c[t>>2]|0;if(!((c[48102]|0)==-1)){c[o>>2]=192408;c[o+4>>2]=445;c[o+8>>2]=0;d5a(192408,o,446)}o=(c[192412>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Ec(4)|0;w=v;cfb(w);x=207976;y=127;Td(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;cfb(w);x=207976;y=127;Td(v|0,x|0,y|0)}y=p;K4a(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((le[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(le[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=xe[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(xe[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=le[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=le[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];we[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(le[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=ie[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=ie[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(le[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){ie[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=ie[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=ie[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function X9a(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function Y9a(a){a=a|0;i=i;return}function Z9a(a){a=a|0;i=i;return 2}function _9a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];W9a(a,b,l,k,f,g,h,191472,191504|0);i=j;return}function $9a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=ie[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];W9a(b,d,m,l,g,h,j,s,q);i=k;return}function aab(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;o6a(n,f);f=n;n=c[f>>2]|0;if(!((c[48102]|0)==-1)){c[m>>2]=192408;c[m+4>>2]=445;c[m+8>>2]=0;d5a(192408,m,446)}m=(c[192412>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;cfb(q);r=207976;s=127;Td(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;cfb(q);r=207976;s=127;Td(p|0,r|0,s|0)}s=n;K4a(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ie[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=I8a(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function bab(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;o6a(n,f);f=n;n=c[f>>2]|0;if(!((c[48102]|0)==-1)){c[m>>2]=192408;c[m+4>>2]=445;c[m+8>>2]=0;d5a(192408,m,446)}m=(c[192412>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;cfb(q);r=207976;s=127;Td(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;cfb(q);r=207976;s=127;Td(p|0,r|0,s|0)}s=n;K4a(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ie[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=I8a(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function cab(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;o6a(m,f);f=m;m=c[f>>2]|0;if(!((c[48102]|0)==-1)){c[l>>2]=192408;c[l+4>>2]=445;c[l+8>>2]=0;d5a(192408,l,446)}l=(c[192412>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ec(4)|0;p=o;cfb(p);q=207976;r=127;Td(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ec(4)|0;p=o;cfb(p);q=207976;r=127;Td(o|0,q|0,r|0)}r=m;K4a(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=hab(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function dab(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;o6a(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[48102]|0)==-1)){c[ba>>2]=192408;c[ba+4>>2]=445;c[ba+8>>2]=0;d5a(192408,ba,446)}ba=(c[192412>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ec(4)|0;Ga=Fa;cfb(Ga);Ha=207976;Ia=127;Td(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ec(4)|0;Ga=Fa;cfb(Ga);Ha=207976;Ia=127;Td(Fa|0,Ha|0,Ia|0)}Ia=ca;K4a(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 120:{Da=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];ue[Da&63](b,d,s,r,g,h,j);i=l;return};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=hab(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=hab(e,M,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Ha|4;break};case 65:case 97:{Da=c[f>>2]|0;ca=d+8|0;Fa=ie[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(I8a(e,Q,Fa,Fa+168|0,Ia,h,0)|0)-Fa|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];W9a(oa,d,A,z,g,h,j,191568,191612|0);c[Da>>2]=c[oa>>2];break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=hab(e,w,h,Ia,2)|0;Fa=c[h>>2]|0;if((Fa&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=Fa|4;break a}break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];fab(d,j+8|0,e,B,h,Ia);break};case 82:{Fa=e;c[sa>>2]=c[Fa>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];W9a(ra,d,y,x,g,h,j,191616,191636|0);c[Fa>>2]=c[ra>>2];break};case 68:{Fa=e;c[ha>>2]=c[Fa>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];W9a(ga,d,L,K,g,h,j,191504,191536|0);c[Fa>>2]=c[ga>>2];break};case 104:case 66:case 98:{Fa=c[f>>2]|0;Da=d+8|0;ca=ie[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=Fa;c[P+0>>2]=c[$+0>>2];Fa=(I8a(e,P,ca,ca+288|0,Ia,h,0)|0)-ca|0;if((Fa|0)>=288){break a}c[j+16>>2]=((Fa|0)/12|0|0)%12|0;break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Fa=hab(e,H,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Fa|0)<24){c[j+8>>2]=Fa;break a}else{c[h>>2]=ca|4;break a}break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=hab(e,t,h,Ia,1)|0;Fa=c[h>>2]|0;if((Fa&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Fa|4;break a}break};case 84:{Fa=e;c[va>>2]=c[Fa>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];W9a(ua,d,v,u,g,h,j,191640,191672|0);c[Fa>>2]=c[ua>>2];break};case 70:{Fa=e;c[ka>>2]=c[Fa>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];W9a(ja,d,J,I,g,h,j,191536,191568|0);c[Fa>>2]=c[ja>>2];break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Fa=hab(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Fa|0)<69){Ja=Fa+2e3|0}else{Ja=(Fa+ -69|0)>>>0<31?Fa+1900|0:Fa}c[j+20>>2]=Ja+ -1900;break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];eab(0,e,C,h,Ia);break};case 88:{Fa=d+8|0;ca=ie[c[(c[Fa>>2]|0)+24>>2]&127](Fa)|0;Fa=e;c[Aa>>2]=c[Fa>>2];c[Ba>>2]=c[f>>2];Da=a[ca]|0;if((Da&1)==0){Ka=ca+4|0;La=ca+4|0;Ma=(Da&255)>>>1}else{Da=c[ca+8>>2]|0;Ka=Da;La=Da;Ma=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];W9a(za,d,q,p,g,h,j,La,Ka+(Ma<<2)|0);c[Fa>>2]=c[za>>2];break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];gab(0,e,m,h,Ia);break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Fa=hab(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Fa|0)<13){c[j+16>>2]=Fa+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Fa=hab(e,G,h,Ia,2)|0;Da=c[h>>2]|0;do{if((Da&4|0)==0){if(!((Fa+ -1|0)>>>0<12)){break}c[ca>>2]=Fa;break a}}while(0);c[h>>2]=Da|4;break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Fa=hab(e,F,h,Ia,3)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Fa|0)<366){c[j+28>>2]=Fa;break a}else{c[h>>2]=ca|4;break a}break};case 99:{ca=d+8|0;Fa=ie[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Ha=a[Fa]|0;if((Ha&1)==0){Na=Fa+4|0;Oa=Fa+4|0;Pa=(Ha&255)>>>1}else{Ha=c[Fa+8>>2]|0;Na=Ha;Oa=Ha;Pa=c[Fa+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];W9a(da,d,O,N,g,h,j,Oa,Na+(Pa<<2)|0);c[ca>>2]=c[da>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=hab(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function eab(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(le[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){ie[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=ie[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=ie[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function fab(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=ie[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=I8a(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function gab(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=ie[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=ie[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((le[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){ie[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=ie[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function hab(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=ie[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=ie[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=ie[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(le[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(le[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){ie[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=ie[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=ie[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(le[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((le[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){ie[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=ie[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function iab(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);if((f|0)==(c[48076]|0)){g=b;Ffb(g);i=d;return}ac(c[e>>2]|0);g=b;Ffb(g);i=d;return}function jab(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);if((b|0)==(c[48076]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function kab(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Sc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(xe[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function lab(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);if((f|0)==(c[48076]|0)){g=b;Ffb(g);i=d;return}ac(c[e>>2]|0);g=b;Ffb(g);i=d;return}function mab(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);if((b|0)==(c[48076]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function nab(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;oab(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=xe[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function oab(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Sc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Lc(c[g>>2]|0)|0;g=Aeb(d,m,n,l)|0;if((f|0)!=0){Lc(f|0)|0}if((g|0)==-1){kbb(193296)}else{c[e>>2]=d+(g<<2);i=j;return}}function pab(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function qab(a){a=a|0;i=i;return}function rab(a){a=a|0;i=i;return 127}function sab(a){a=a|0;i=i;return 127}function tab(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function uab(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function vab(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function wab(a,b){a=a|0;b=b|0;b=i;o5a(a,1,45);i=b;return}function xab(a){a=a|0;i=i;return 0}function yab(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function zab(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Aab(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function Bab(a){a=a|0;i=i;return}function Cab(a){a=a|0;i=i;return 127}function Dab(a){a=a|0;i=i;return 127}function Eab(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Fab(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Gab(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Hab(a,b){a=a|0;b=b|0;b=i;o5a(a,1,45);i=b;return}function Iab(a){a=a|0;i=i;return 0}function Jab(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Kab(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Lab(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function Mab(a){a=a|0;i=i;return}function Nab(a){a=a|0;i=i;return 2147483647}function Oab(a){a=a|0;i=i;return 2147483647}function Pab(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Qab(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Rab(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Sab(a,b){a=a|0;b=b|0;b=i;V5a(a,1,45);i=b;return}function Tab(a){a=a|0;i=i;return 0}function Uab(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Vab(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Wab(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function Xab(a){a=a|0;i=i;return}function Yab(a){a=a|0;i=i;return 2147483647}function Zab(a){a=a|0;i=i;return 2147483647}function _ab(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function $ab(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function abb(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function bbb(a,b){a=a|0;b=b|0;b=i;V5a(a,1,45);i=b;return}function cbb(a){a=a|0;i=i;return 0}function dbb(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function ebb(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function fbb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function gbb(a){a=a|0;i=i;return}function hbb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=447;y=o+100|0;o6a(r,h);o=r;z=c[o>>2]|0;if(!((c[48104]|0)==-1)){c[n>>2]=192416;c[n+4>>2]=445;c[n+8>>2]=0;d5a(192416,n,446)}n=(c[192420>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ec(4)|0;C=B;cfb(C);D=207976;E=127;Td(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ec(4)|0;C=B;cfb(C);D=207976;E=127;Td(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=jbb(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;He[c[(c[z>>2]|0)+32>>2]&63](E,192032,192042|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=xfb(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}Kfb()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[192032+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((xd(p|0,192048,m|0)|0)!=1){t=Ec(8)|0;Q4a(t,192056);Td(t|0,189408,42)}if((F|0)==0){break}yfb(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;K4a(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}fe[c[x>>2]&511](o);i=d;return}function ibb(a){a=a|0;i=i;return}function jbb(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;nbb(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=447;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((ie[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){ba=(a[O]|0)!=0}else{ba=0}if(!(I|ba)){ca=D;da=R;ea=r;fa=Q;ga=0;ha=T;break b}}W=a[x]|0;ia=(W&1)==0;ja=ia?j:c[J>>2]|0;c:do{if((p|0)==0){ka=Y;la=Y;ma=W;na=ja}else{if((d[s+(p+ -1)|0]|0)>=2){ka=Y;la=Y;ma=W;na=ja;break}oa=ja+(ia?(W&255)>>>1:c[K>>2]|0)|0;pa=ja;while(1){if((pa|0)==(oa|0)){qa=oa;break}ra=a[pa]|0;if(!(ra<<24>>24>-1)){qa=pa;break}if((b[(c[f>>2]|0)+(ra<<24>>24<<1)>>1]&8192)==0){qa=pa;break}else{pa=pa+1|0}}pa=qa-ja|0;oa=a[A]|0;ra=(oa&1)==0;if(ra){sa=(oa&255)>>>1}else{sa=c[N>>2]|0}if(pa>>>0>sa>>>0){ka=Y;la=Y;ma=W;na=ja;break}if(ra){ra=(oa&255)>>>1;ta=A+1+(ra-pa)|0;ua=L;va=ra}else{ra=c[M>>2]|0;oa=c[N>>2]|0;ta=ra+(oa-pa)|0;ua=ra;va=oa}oa=ua+va|0;if((ta|0)==(oa|0)){ka=Y;la=Y;ma=W;na=qa;break}else{wa=ja;xa=ta}while(1){if((a[xa]|0)!=(a[wa]|0)){ka=Y;la=Y;ma=W;na=ja;break c}ra=xa+1|0;if((ra|0)==(oa|0)){ka=Y;la=Y;ma=W;na=qa;break}else{wa=wa+1|0;xa=ra}}}}while(0);d:while(1){if((ma&1)==0){ya=j;za=(ma&255)>>>1}else{ya=c[J>>2]|0;za=c[K>>2]|0}if((na|0)==(ya+za|0)){break}W=c[h>>2]|0;do{if((W|0)==0){Aa=0}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){Aa=W;break}if((ie[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[h>>2]=0;Aa=0;break}else{Aa=c[h>>2]|0;break}}}while(0);W=(Aa|0)==0;do{if((la|0)==0){Ba=ka;X=147}else{if((c[la+12>>2]|0)!=(c[la+16>>2]|0)){if(W){Ca=ka;Da=la;break}else{break d}}if((ie[c[(c[la>>2]|0)+36>>2]&127](la)|0)==-1){c[e>>2]=0;Ba=0;X=147;break}else{if(W^(ka|0)==0){Ca=ka;Da=ka;break}else{break d}}}}while(0);if((X|0)==147){X=0;if(W){break}else{Ca=Ba;Da=0}}ja=c[h>>2]|0;ia=c[ja+12>>2]|0;if((ia|0)==(c[ja+16>>2]|0)){Ea=(ie[c[(c[ja>>2]|0)+36>>2]&127](ja)|0)&255}else{Ea=a[ia]|0}if(!(Ea<<24>>24==(a[na]|0))){break}ia=c[h>>2]|0;ja=ia+12|0;oa=c[ja>>2]|0;if((oa|0)==(c[ia+16>>2]|0)){ie[c[(c[ia>>2]|0)+40>>2]&127](ia)|0}else{c[ja>>2]=oa+1}ka=Ca;la=Da;ma=a[x]|0;na=na+1|0}if(!I){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break b}oa=a[x]|0;if((oa&1)==0){Fa=j;Ga=(oa&255)>>>1}else{Fa=c[J>>2]|0;Ga=c[K>>2]|0}if((na|0)==(Fa+Ga|0)){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T}else{X=162;break a}break};case 4:{oa=D;ja=R;ia=r;ra=Q;pa=0;Ha=T;e:while(1){Ia=c[h>>2]|0;do{if((Ia|0)==0){Ja=0}else{if((c[Ia+12>>2]|0)!=(c[Ia+16>>2]|0)){Ja=Ia;break}if((ie[c[(c[Ia>>2]|0)+36>>2]&127](Ia)|0)==-1){c[h>>2]=0;Ja=0;break}else{Ja=c[h>>2]|0;break}}}while(0);Ia=(Ja|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=173}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(Ia){break}else{break e}}if((ie[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=173;break}else{if(Ia){break}else{break e}}}}while(0);if((X|0)==173){X=0;if(Ia){break}}W=c[h>>2]|0;Ka=c[W+12>>2]|0;if((Ka|0)==(c[W+16>>2]|0)){La=(ie[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{La=a[Ka]|0}do{if(La<<24>>24>-1){if((b[(c[f>>2]|0)+(La<<24>>24<<1)>>1]&2048)==0){X=189;break}Ka=c[o>>2]|0;if((Ka|0)==(oa|0)){W=(c[P>>2]|0)!=447;Ma=c[t>>2]|0;Na=oa-Ma|0;Oa=Na>>>0<2147483647?Na<<1:-1;Pa=Afb(W?Ma:0,Oa)|0;if((Pa|0)==0){X=182;break a}do{if(W){c[t>>2]=Pa;Qa=Pa}else{Ma=c[t>>2]|0;c[t>>2]=Pa;if((Ma|0)==0){Qa=Pa;break}fe[c[P>>2]&511](Ma);Qa=c[t>>2]|0}}while(0);c[P>>2]=422;Pa=Qa+Na|0;c[o>>2]=Pa;Ra=Pa;Sa=(c[t>>2]|0)+Oa|0}else{Ra=Ka;Sa=oa}c[o>>2]=Ra+1;a[Ra]=La;Ta=Sa;Ua=ja;Va=ia;Wa=ra;Xa=pa+1|0;Ya=Ha}else{X=189}}while(0);if((X|0)==189){X=0;Ia=a[w]|0;if((Ia&1)==0){Za=(Ia&255)>>>1}else{Za=c[n>>2]|0}if((Za|0)==0|(pa|0)==0){break}if(!(La<<24>>24==(a[v]|0))){break}if((ia|0)==(ra|0)){Ia=ia-ja|0;Pa=Ia>>>0<2147483647?Ia<<1:-1;if((Ha|0)==447){_a=0}else{_a=ja}W=Afb(_a,Pa)|0;if((W|0)==0){X=198;break a}$a=W;ab=W+(Ia>>2<<2)|0;bb=W+(Pa>>>2<<2)|0;cb=422}else{$a=ja;ab=ia;bb=ra;cb=Ha}c[ab>>2]=pa;Ta=oa;Ua=$a;Va=ab+4|0;Wa=bb;Xa=0;Ya=cb}Pa=c[h>>2]|0;W=Pa+12|0;Ia=c[W>>2]|0;if((Ia|0)==(c[Pa+16>>2]|0)){ie[c[(c[Pa>>2]|0)+40>>2]&127](Pa)|0;oa=Ta;ja=Ua;ia=Va;ra=Wa;pa=Xa;Ha=Ya;continue}else{c[W>>2]=Ia+1;oa=Ta;ja=Ua;ia=Va;ra=Wa;pa=Xa;Ha=Ya;continue}}if((ja|0)==(ia|0)|(pa|0)==0){db=ja;eb=ia;fb=ra;gb=Ha}else{if((ia|0)==(ra|0)){Ia=ia-ja|0;W=Ia>>>0<2147483647?Ia<<1:-1;if((Ha|0)==447){hb=0}else{hb=ja}Pa=Afb(hb,W)|0;if((Pa|0)==0){X=209;break a}ib=Pa;jb=Pa+(Ia>>2<<2)|0;kb=Pa+(W>>>2<<2)|0;lb=422}else{ib=ja;jb=ia;kb=ra;lb=Ha}c[jb>>2]=pa;db=ib;eb=jb+4|0;fb=kb;gb=lb}if((c[B>>2]|0)>0){W=c[h>>2]|0;do{if((W|0)==0){mb=0}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){mb=W;break}if((ie[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[h>>2]=0;mb=0;break}else{mb=c[h>>2]|0;break}}}while(0);W=(mb|0)==0;pa=c[e>>2]|0;do{if((pa|0)==0){X=223}else{if((c[pa+12>>2]|0)!=(c[pa+16>>2]|0)){if(W){nb=pa;break}else{X=229;break a}}if((ie[c[(c[pa>>2]|0)+36>>2]&127](pa)|0)==-1){c[e>>2]=0;X=223;break}else{if(W){nb=pa;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(W){X=229;break a}else{nb=0}}pa=c[h>>2]|0;Ha=c[pa+12>>2]|0;if((Ha|0)==(c[pa+16>>2]|0)){ob=(ie[c[(c[pa>>2]|0)+36>>2]&127](pa)|0)&255}else{ob=a[Ha]|0}if(!(ob<<24>>24==(a[u]|0))){X=229;break a}Ha=c[h>>2]|0;pa=Ha+12|0;ra=c[pa>>2]|0;if((ra|0)==(c[Ha+16>>2]|0)){ie[c[(c[Ha>>2]|0)+40>>2]&127](Ha)|0;pb=nb;qb=nb;rb=oa}else{c[pa>>2]=ra+1;pb=nb;qb=nb;rb=oa}while(1){ra=c[h>>2]|0;do{if((ra|0)==0){sb=0}else{if((c[ra+12>>2]|0)!=(c[ra+16>>2]|0)){sb=ra;break}if((ie[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)==-1){c[h>>2]=0;sb=0;break}else{sb=c[h>>2]|0;break}}}while(0);ra=(sb|0)==0;do{if((qb|0)==0){tb=pb;X=243}else{if((c[qb+12>>2]|0)!=(c[qb+16>>2]|0)){if(ra){ub=pb;vb=qb;break}else{X=250;break a}}if((ie[c[(c[qb>>2]|0)+36>>2]&127](qb)|0)==-1){c[e>>2]=0;tb=0;X=243;break}else{if(ra^(pb|0)==0){ub=pb;vb=pb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(ra){X=250;break a}else{ub=tb;vb=0}}pa=c[h>>2]|0;Ha=c[pa+12>>2]|0;if((Ha|0)==(c[pa+16>>2]|0)){wb=(ie[c[(c[pa>>2]|0)+36>>2]&127](pa)|0)&255}else{wb=a[Ha]|0}if(!(wb<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(wb<<24>>24<<1)>>1]&2048)==0){X=250;break a}Ha=c[o>>2]|0;if((Ha|0)==(rb|0)){pa=(c[P>>2]|0)!=447;ia=c[t>>2]|0;ja=rb-ia|0;Pa=ja>>>0<2147483647?ja<<1:-1;Ia=Afb(pa?ia:0,Pa)|0;if((Ia|0)==0){X=253;break a}do{if(pa){c[t>>2]=Ia;xb=Ia}else{ia=c[t>>2]|0;c[t>>2]=Ia;if((ia|0)==0){xb=Ia;break}fe[c[P>>2]&511](ia);xb=c[t>>2]|0}}while(0);c[P>>2]=422;Ia=xb+ja|0;c[o>>2]=Ia;yb=Ia;zb=(c[t>>2]|0)+Pa|0}else{yb=Ha;zb=rb}Ia=c[h>>2]|0;pa=c[Ia+12>>2]|0;if((pa|0)==(c[Ia+16>>2]|0)){ra=(ie[c[(c[Ia>>2]|0)+36>>2]&127](Ia)|0)&255;Ab=ra;Bb=c[o>>2]|0}else{Ab=a[pa]|0;Bb=yb}c[o>>2]=Bb+1;a[Bb]=Ab;pa=(c[B>>2]|0)+ -1|0;c[B>>2]=pa;ra=c[h>>2]|0;Ia=ra+12|0;ia=c[Ia>>2]|0;if((ia|0)==(c[ra+16>>2]|0)){ie[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[Ia>>2]=ia+1}if((pa|0)>0){pb=ub;qb=vb;rb=zb}else{Cb=zb;break}}}else{Cb=oa}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ca=Cb;da=db;ea=eb;fa=fb;ga=S;ha=gb}break};case 3:{W=a[y]|0;pa=(W&1)==0;if(pa){Db=(W&255)>>>1}else{Db=c[G>>2]|0}ia=a[z]|0;Ia=(ia&1)==0;if(Ia){Eb=(ia&255)>>>1}else{Eb=c[g>>2]|0}if((Db|0)==(0-Eb|0)){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break b}if(pa){Fb=(W&255)>>>1}else{Fb=c[G>>2]|0}do{if((Fb|0)!=0){if(Ia){Gb=(ia&255)>>>1}else{Gb=c[g>>2]|0}if((Gb|0)==0){break}ra=c[h>>2]|0;Ma=c[ra+12>>2]|0;Hb=c[ra+16>>2]|0;if((Ma|0)==(Hb|0)){Ib=(ie[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)&255;Jb=c[h>>2]|0;Kb=Ib;Lb=c[Jb+16>>2]|0;Mb=c[Jb+12>>2]|0;Nb=Jb;Ob=a[y]|0}else{Kb=a[Ma]|0;Lb=Hb;Mb=Ma;Nb=ra;Ob=W}ra=Nb+12|0;Ma=(Mb|0)==(Lb|0);if(Kb<<24>>24==(a[(Ob&1)==0?F:c[H>>2]|0]|0)){if(Ma){ie[c[(c[Nb>>2]|0)+40>>2]&127](Nb)|0}else{c[ra>>2]=Mb+1}ra=a[y]|0;if((ra&1)==0){Pb=(ra&255)>>>1}else{Pb=c[G>>2]|0}ca=D;da=R;ea=r;fa=Q;ga=Pb>>>0>1?y:S;ha=T;break b}if(Ma){Qb=(ie[c[(c[Nb>>2]|0)+36>>2]&127](Nb)|0)&255}else{Qb=a[Mb]|0}if(!(Qb<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}Ma=c[h>>2]|0;ra=Ma+12|0;Hb=c[ra>>2]|0;if((Hb|0)==(c[Ma+16>>2]|0)){ie[c[(c[Ma>>2]|0)+40>>2]&127](Ma)|0}else{c[ra>>2]=Hb+1}a[l]=1;Hb=a[z]|0;if((Hb&1)==0){Rb=(Hb&255)>>>1}else{Rb=c[g>>2]|0}ca=D;da=R;ea=r;fa=Q;ga=Rb>>>0>1?z:S;ha=T;break b}}while(0);if(pa){Sb=(W&255)>>>1}else{Sb=c[G>>2]|0}Ia=c[h>>2]|0;oa=c[Ia+12>>2]|0;Hb=(oa|0)==(c[Ia+16>>2]|0);if((Sb|0)==0){if(Hb){ra=(ie[c[(c[Ia>>2]|0)+36>>2]&127](Ia)|0)&255;Tb=ra;Ub=a[z]|0}else{Tb=a[oa]|0;Ub=ia}if(!(Tb<<24>>24==(a[(Ub&1)==0?m:c[E>>2]|0]|0))){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break b}ra=c[h>>2]|0;Ma=ra+12|0;Jb=c[Ma>>2]|0;if((Jb|0)==(c[ra+16>>2]|0)){ie[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[Ma>>2]=Jb+1}a[l]=1;Jb=a[z]|0;if((Jb&1)==0){Vb=(Jb&255)>>>1}else{Vb=c[g>>2]|0}ca=D;da=R;ea=r;fa=Q;ga=Vb>>>0>1?z:S;ha=T;break b}if(Hb){Hb=(ie[c[(c[Ia>>2]|0)+36>>2]&127](Ia)|0)&255;Wb=Hb;Xb=a[y]|0}else{Wb=a[oa]|0;Xb=W}if(!(Wb<<24>>24==(a[(Xb&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break b}oa=c[h>>2]|0;Hb=oa+12|0;Ia=c[Hb>>2]|0;if((Ia|0)==(c[oa+16>>2]|0)){ie[c[(c[oa>>2]|0)+40>>2]&127](oa)|0}else{c[Hb>>2]=Ia+1}Ia=a[y]|0;if((Ia&1)==0){Yb=(Ia&255)>>>1}else{Yb=c[G>>2]|0}ca=D;da=R;ea=r;fa=Q;ga=Yb>>>0>1?y:S;ha=T;break};case 0:{X=26;break};case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}Ia=c[h>>2]|0;Hb=c[Ia+12>>2]|0;if((Hb|0)==(c[Ia+16>>2]|0)){Zb=(ie[c[(c[Ia>>2]|0)+36>>2]&127](Ia)|0)&255}else{Zb=a[Hb]|0}if(!(Zb<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(Zb<<24>>24<<1)>>1]&8192)==0){X=25;break a}Hb=c[h>>2]|0;Ia=Hb+12|0;oa=c[Ia>>2]|0;if((oa|0)==(c[Hb+16>>2]|0)){_b=(ie[c[(c[Hb>>2]|0)+40>>2]&127](Hb)|0)&255}else{c[Ia>>2]=oa+1;_b=a[oa]|0}K5a(A,_b);X=26;break};default:{ca=D;da=R;ea=r;fa=Q;ga=S;ha=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{$b=Y;ac=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){bc=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){bc=U;break}if((ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;bc=0;break}else{bc=c[h>>2]|0;break}}}while(0);U=(bc|0)==0;do{if((ac|0)==0){cc=$b;X=37}else{if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){if(U){dc=$b;ec=ac;break}else{ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}}if((ie[c[(c[ac>>2]|0)+36>>2]&127](ac)|0)==-1){c[e>>2]=0;cc=0;X=37;break}else{if(U^($b|0)==0){dc=$b;ec=$b;break}else{ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}else{dc=cc;ec=0}}Ha=c[h>>2]|0;Pa=c[Ha+12>>2]|0;if((Pa|0)==(c[Ha+16>>2]|0)){fc=(ie[c[(c[Ha>>2]|0)+36>>2]&127](Ha)|0)&255}else{fc=a[Pa]|0}if(!(fc<<24>>24>-1)){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}if((b[(c[f>>2]|0)+(fc<<24>>24<<1)>>1]&8192)==0){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}Pa=c[h>>2]|0;Ha=Pa+12|0;ja=c[Ha>>2]|0;if((ja|0)==(c[Pa+16>>2]|0)){gc=(ie[c[(c[Pa>>2]|0)+40>>2]&127](Pa)|0)&255}else{c[Ha>>2]=ja+1;gc=a[ja]|0}K5a(A,gc);$b=dc;ac=ec}}}while(0);W=p+1|0;if(W>>>0<4){Q=fa;r=ea;R=da;D=ca;p=W;S=ga;T=ha}else{Z=da;_=ea;$=ga;aa=ha;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==182){Kfb()}else if((X|0)==198){Kfb()}else if((X|0)==209){Kfb()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;hc=0;ic=db;jc=gb}else if((X|0)==250){c[k>>2]=c[k>>2]|4;hc=0;ic=db;jc=gb}else if((X|0)==253){Kfb()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;hc=0;ic=db;jc=gb}else if((X|0)==269){h:do{if(($|0)!=0){ha=$+1|0;ga=$+8|0;ea=$+4|0;da=1;i:while(1){S=a[$]|0;if((S&1)==0){kc=(S&255)>>>1}else{kc=c[ea>>2]|0}if(!(da>>>0<kc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){lc=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){lc=S;break}if((ie[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;lc=0;break}else{lc=c[h>>2]|0;break}}}while(0);S=(lc|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){mc=(ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{mc=a[p]|0}if((a[$]&1)==0){nc=ha}else{nc=c[ga>>2]|0}if(!(mc<<24>>24==(a[nc+da|0]|0))){break}p=da+1|0;U=c[h>>2]|0;ca=U+12|0;D=c[ca>>2]|0;if((D|0)==(c[U+16>>2]|0)){ie[c[(c[U>>2]|0)+40>>2]&127](U)|0;da=p;continue}else{c[ca>>2]=D+1;da=p;continue}}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa;break g}}while(0);if((Z|0)==(_|0)){hc=1;ic=_;jc=aa;break}c[C>>2]=0;obb(w,Z,_,C);if((c[C>>2]|0)==0){hc=1;ic=Z;jc=aa;break}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa}}while(0);s5a(A);s5a(z);s5a(y);s5a(x);s5a(w);if((ic|0)==0){i=q;return hc|0}fe[jc&511](ic);i=q;return hc|0}function kbb(a){a=a|0;var b=0;b=Ec(8)|0;Q4a(b,a);Td(b|0,189408,42)}function lbb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=447;v=n+100|0;o6a(q,h);n=q;w=c[n>>2]|0;if(!((c[48104]|0)==-1)){c[m>>2]=192416;c[m+4>>2]=445;c[m+8>>2]=0;d5a(192416,m,446)}m=(c[192420>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ec(4)|0;z=y;cfb(z);A=207976;B=127;Td(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ec(4)|0;z=y;cfb(z);A=207976;B=127;Td(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=jbb(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){K5a(k,xe[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=xe[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);mbb(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((ie[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;K4a(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}fe[c[u>>2]&511](n);i=d;return}function mbb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){N5a(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function nbb(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[47964]|0)==-1)){c[p>>2]=191856;c[p+4>>2]=445;c[p+8>>2]=0;d5a(191856,p,446)}p=(c[191860>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ec(4)|0;C=B;cfb(C);D=207976;E=127;Td(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ec(4)|0;C=B;cfb(C);D=207976;E=127;Td(B|0,D|0,E|0)}E=b;ge[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ge[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}E5a(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;s5a(r);ge[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}E5a(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;s5a(s);a[f]=ie[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=ie[c[(c[b>>2]|0)+16>>2]&127](E)|0;ge[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}E5a(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;s5a(t);ge[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}E5a(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;s5a(u);F=ie[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[47948]|0)==-1)){c[o>>2]=191792;c[o+4>>2]=445;c[o+8>>2]=0;d5a(191792,o,446)}o=(c[191796>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;cfb(H);I=207976;J=127;Td(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ec(4)|0;H=G;cfb(H);I=207976;J=127;Td(G|0,I|0,J|0)}J=E;ge[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ge[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}E5a(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;s5a(w);ge[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}E5a(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;s5a(x);a[f]=ie[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=ie[c[(c[E>>2]|0)+16>>2]&127](J)|0;ge[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}E5a(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;s5a(y);ge[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}E5a(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;s5a(z);F=ie[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function obb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function pbb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function qbb(a){a=a|0;i=i;return}function rbb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=447;y=o+400|0;o6a(r,h);o=r;z=c[o>>2]|0;if(!((c[48102]|0)==-1)){c[n>>2]=192408;c[n+4>>2]=445;c[n+8>>2]=0;d5a(192408,n,446)}n=(c[192412>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ec(4)|0;C=B;cfb(C);D=207976;E=127;Td(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ec(4)|0;C=B;cfb(C);D=207976;E=127;Td(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=sbb(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;He[c[(c[z>>2]|0)+48>>2]&63](E,192112,192122|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=xfb((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}Kfb()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[192112+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((xd(p|0,192048,m|0)|0)!=1){t=Ec(8)|0;Q4a(t,192056);Td(t|0,189408,42)}if((F|0)==0){break}yfb(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=ie[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=ie[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];K4a(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}fe[c[x>>2]&511](o);i=d;return}function sbb(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;vbb(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=447;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=ie[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=ie[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}P=c[g>>2]|0;R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){_=ie[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{_=c[R>>2]|0}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,8192,_)|0)){T=27;break a}R=c[g>>2]|0;P=R+12|0;$=c[P>>2]|0;if(($|0)==(c[R+16>>2]|0)){aa=ie[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[P>>2]=$+4;aa=c[$>>2]|0}_5a(A,aa);T=28;break};case 0:{T=28;break};case 4:{$=M;P=r;R=L;ba=0;ca=O;c:while(1){da=c[g>>2]|0;do{if((da|0)==0){ea=1}else{fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ga=ie[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{ga=c[fa>>2]|0}if((ga|0)==-1){c[g>>2]=0;ea=1;break}else{ea=(c[g>>2]|0)==0;break}}}while(0);da=c[b>>2]|0;do{if((da|0)==0){T=188}else{fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ha=ie[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{ha=c[fa>>2]|0}if((ha|0)==-1){c[b>>2]=0;T=188;break}else{if(ea){break}else{break c}}}}while(0);if((T|0)==188){T=0;if(ea){break}}da=c[g>>2]|0;fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ia=ie[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{ia=c[fa>>2]|0}if(le[c[(c[l>>2]|0)+12>>2]&63](l,2048,ia)|0){fa=c[n>>2]|0;if((fa|0)==(c[q>>2]|0)){wbb(m,n,q);ja=c[n>>2]|0}else{ja=fa}c[n>>2]=ja+4;c[ja>>2]=ia;ka=$;la=P;ma=R;na=ba+1|0;oa=ca}else{fa=a[w]|0;if((fa&1)==0){pa=(fa&255)>>>1}else{pa=c[K>>2]|0}if((pa|0)==0|(ba|0)==0){break}if((ia|0)!=(c[v>>2]|0)){break}if((P|0)==(R|0)){fa=P-$|0;da=fa>>>0<2147483647?fa<<1:-1;if((ca|0)!=447){qa=$}else{qa=0}ra=Afb(qa,da)|0;if((ra|0)==0){T=206;break a}sa=ra;ta=ra+(fa>>2<<2)|0;ua=ra+(da>>>2<<2)|0;va=422}else{sa=$;ta=P;ua=R;va=ca}c[ta>>2]=ba;ka=sa;la=ta+4|0;ma=ua;na=0;oa=va}da=c[g>>2]|0;ra=da+12|0;fa=c[ra>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ie[c[(c[da>>2]|0)+40>>2]&127](da)|0;$=ka;P=la;R=ma;ba=na;ca=oa;continue}else{c[ra>>2]=fa+4;$=ka;P=la;R=ma;ba=na;ca=oa;continue}}if(($|0)==(P|0)|(ba|0)==0){wa=$;xa=P;ya=R;za=ca}else{if((P|0)==(R|0)){fa=P-$|0;ra=fa>>>0<2147483647?fa<<1:-1;if((ca|0)!=447){Aa=$}else{Aa=0}da=Afb(Aa,ra)|0;if((da|0)==0){T=217;break a}Ba=da;Ca=da+(fa>>2<<2)|0;Da=da+(ra>>>2<<2)|0;Ea=422}else{Ba=$;Ca=P;Da=R;Ea=ca}c[Ca>>2]=ba;wa=Ba;xa=Ca+4|0;ya=Da;za=Ea}ra=c[B>>2]|0;if((ra|0)>0){da=c[g>>2]|0;do{if((da|0)==0){Fa=1}else{fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){Ga=ie[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ga=c[fa>>2]|0}if((Ga|0)==-1){c[g>>2]=0;Fa=1;break}else{Fa=(c[g>>2]|0)==0;break}}}while(0);da=c[b>>2]|0;do{if((da|0)==0){T=234}else{ba=c[da+12>>2]|0;if((ba|0)==(c[da+16>>2]|0)){Ha=ie[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ha=c[ba>>2]|0}if((Ha|0)==-1){c[b>>2]=0;T=234;break}else{if(Fa){Ia=da;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(Fa){T=240;break a}else{Ia=0}}da=c[g>>2]|0;ba=c[da+12>>2]|0;if((ba|0)==(c[da+16>>2]|0)){Ja=ie[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ja=c[ba>>2]|0}if((Ja|0)!=(c[u>>2]|0)){T=240;break a}ba=c[g>>2]|0;da=ba+12|0;ca=c[da>>2]|0;if((ca|0)==(c[ba+16>>2]|0)){ie[c[(c[ba>>2]|0)+40>>2]&127](ba)|0;Ka=Ia;La=ra;Ma=Ia}else{c[da>>2]=ca+4;Ka=Ia;La=ra;Ma=Ia}while(1){ca=c[g>>2]|0;do{if((ca|0)==0){Na=1}else{da=c[ca+12>>2]|0;if((da|0)==(c[ca+16>>2]|0)){Oa=ie[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{Oa=c[da>>2]|0}if((Oa|0)==-1){c[g>>2]=0;Na=1;break}else{Na=(c[g>>2]|0)==0;break}}}while(0);do{if((Ma|0)==0){Pa=Ka;T=257}else{ca=c[Ma+12>>2]|0;if((ca|0)==(c[Ma+16>>2]|0)){Qa=ie[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0}else{Qa=c[ca>>2]|0}if((Qa|0)==-1){c[b>>2]=0;Pa=0;T=257;break}else{if(Na^(Ka|0)==0){Ra=Ka;Sa=Ka;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(Na){T=263;break a}else{Ra=Pa;Sa=0}}ca=c[g>>2]|0;da=c[ca+12>>2]|0;if((da|0)==(c[ca+16>>2]|0)){Ta=ie[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{Ta=c[da>>2]|0}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,2048,Ta)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){wbb(m,n,q)}da=c[g>>2]|0;ca=c[da+12>>2]|0;if((ca|0)==(c[da+16>>2]|0)){Ua=ie[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ua=c[ca>>2]|0}ca=c[n>>2]|0;c[n>>2]=ca+4;c[ca>>2]=Ua;ca=La+ -1|0;c[B>>2]=ca;da=c[g>>2]|0;ba=da+12|0;R=c[ba>>2]|0;if((R|0)==(c[da+16>>2]|0)){ie[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[ba>>2]=R+4}if((ca|0)>0){Ka=Ra;La=ca;Ma=Sa}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{Va=wa;Wa=xa;Xa=ya;Ya=N;Za=za}break};case 3:{ra=a[y]|0;ca=(ra&1)==0;if(ca){_a=(ra&255)>>>1}else{_a=c[D>>2]|0}R=a[z]|0;ba=(R&1)==0;if(ba){$a=(R&255)>>>1}else{$a=c[e>>2]|0}if((_a|0)==(0-$a|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}if(ca){ab=(ra&255)>>>1}else{ab=c[D>>2]|0}do{if((ab|0)!=0){if(ba){bb=(R&255)>>>1}else{bb=c[e>>2]|0}if((bb|0)==0){break}da=c[g>>2]|0;P=c[da+12>>2]|0;if((P|0)==(c[da+16>>2]|0)){$=ie[c[(c[da>>2]|0)+36>>2]&127](da)|0;cb=$;db=a[y]|0}else{cb=c[P>>2]|0;db=ra}P=c[g>>2]|0;$=P+12|0;da=c[$>>2]|0;fa=(da|0)==(c[P+16>>2]|0);if((cb|0)==(c[((db&1)==0?D:c[E>>2]|0)>>2]|0)){if(fa){ie[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[$>>2]=da+4}$=a[y]|0;if(($&1)==0){eb=($&255)>>>1}else{eb=c[D>>2]|0}Va=M;Wa=r;Xa=L;Ya=eb>>>0>1?y:N;Za=O;break b}if(fa){fb=ie[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{fb=c[da>>2]|0}if((fb|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}da=c[g>>2]|0;P=da+12|0;fa=c[P>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ie[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[P>>2]=fa+4}a[k]=1;fa=a[z]|0;if((fa&1)==0){gb=(fa&255)>>>1}else{gb=c[e>>2]|0}Va=M;Wa=r;Xa=L;Ya=gb>>>0>1?z:N;Za=O;break b}}while(0);if(ca){hb=(ra&255)>>>1}else{hb=c[D>>2]|0}ba=c[g>>2]|0;fa=c[ba+12>>2]|0;P=(fa|0)==(c[ba+16>>2]|0);if((hb|0)==0){if(P){da=ie[c[(c[ba>>2]|0)+36>>2]&127](ba)|0;ib=da;jb=a[z]|0}else{ib=c[fa>>2]|0;jb=R}if((ib|0)!=(c[((jb&1)==0?e:c[f>>2]|0)>>2]|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}da=c[g>>2]|0;$=da+12|0;kb=c[$>>2]|0;if((kb|0)==(c[da+16>>2]|0)){ie[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[$>>2]=kb+4}a[k]=1;kb=a[z]|0;if((kb&1)==0){lb=(kb&255)>>>1}else{lb=c[e>>2]|0}Va=M;Wa=r;Xa=L;Ya=lb>>>0>1?z:N;Za=O;break b}if(P){P=ie[c[(c[ba>>2]|0)+36>>2]&127](ba)|0;mb=P;nb=a[y]|0}else{mb=c[fa>>2]|0;nb=ra}if((mb|0)!=(c[((nb&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}fa=c[g>>2]|0;P=fa+12|0;ba=c[P>>2]|0;if((ba|0)==(c[fa+16>>2]|0)){ie[c[(c[fa>>2]|0)+40>>2]&127](fa)|0}else{c[P>>2]=ba+4}ba=a[y]|0;if((ba&1)==0){ob=(ba&255)>>>1}else{ob=c[D>>2]|0}Va=M;Wa=r;Xa=L;Ya=ob>>>0>1?y:N;Za=O;break};case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){pb=(a[J]|0)!=0}else{pb=0}if(!(F|pb)){Va=M;Wa=r;Xa=L;Ya=0;Za=O;break b}}ba=a[x]|0;P=(ba&1)==0?h:c[G>>2]|0;d:do{if((o|0)==0){qb=V;rb=V;sb=ba;tb=P}else{if((d[s+(o+ -1)|0]|0)<2){ub=ba;vb=P}else{qb=V;rb=V;sb=ba;tb=P;break}while(1){if((ub&1)==0){wb=h;xb=(ub&255)>>>1}else{wb=c[G>>2]|0;xb=c[h>>2]|0}if((vb|0)==(wb+(xb<<2)|0)){yb=ub;break}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[vb>>2]|0)|0)){T=129;break}ub=a[x]|0;vb=vb+4|0}if((T|0)==129){T=0;yb=a[x]|0}fa=(yb&1)==0;kb=vb-(fa?h:c[G>>2]|0)>>2;$=a[A]|0;da=($&1)==0;if(da){zb=($&255)>>>1}else{zb=c[H>>2]|0}e:do{if(!(kb>>>0>zb>>>0)){if(da){Ab=H+((($&255)>>>1)-kb<<2)|0;Bb=H;Cb=($&255)>>>1}else{Db=c[I>>2]|0;Eb=c[H>>2]|0;Ab=Db+(Eb-kb<<2)|0;Bb=Db;Cb=Eb}Eb=Bb+(Cb<<2)|0;if((Ab|0)==(Eb|0)){qb=V;rb=V;sb=yb;tb=vb;break d}else{Fb=fa?h:c[G>>2]|0;Gb=Ab}while(1){if((c[Gb>>2]|0)!=(c[Fb>>2]|0)){break e}Db=Gb+4|0;if((Db|0)==(Eb|0)){qb=V;rb=V;sb=yb;tb=vb;break d}Fb=Fb+4|0;Gb=Db}}}while(0);qb=V;rb=V;sb=yb;tb=fa?h:c[G>>2]|0}}while(0);f:while(1){if((sb&1)==0){Hb=h;Ib=(sb&255)>>>1}else{Hb=c[G>>2]|0;Ib=c[h>>2]|0}if((tb|0)==(Hb+(Ib<<2)|0)){break}P=c[g>>2]|0;do{if((P|0)==0){Jb=1}else{ba=c[P+12>>2]|0;if((ba|0)==(c[P+16>>2]|0)){Kb=ie[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{Kb=c[ba>>2]|0}if((Kb|0)==-1){c[g>>2]=0;Jb=1;break}else{Jb=(c[g>>2]|0)==0;break}}}while(0);do{if((rb|0)==0){Lb=qb;T=159}else{P=c[rb+12>>2]|0;if((P|0)==(c[rb+16>>2]|0)){Mb=ie[c[(c[rb>>2]|0)+36>>2]&127](rb)|0}else{Mb=c[P>>2]|0}if((Mb|0)==-1){c[b>>2]=0;Lb=0;T=159;break}else{if(Jb^(qb|0)==0){Nb=qb;Ob=qb;break}else{break f}}}}while(0);if((T|0)==159){T=0;if(Jb){break}else{Nb=Lb;Ob=0}}P=c[g>>2]|0;fa=c[P+12>>2]|0;if((fa|0)==(c[P+16>>2]|0)){Pb=ie[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{Pb=c[fa>>2]|0}if((Pb|0)!=(c[tb>>2]|0)){break}fa=c[g>>2]|0;P=fa+12|0;ba=c[P>>2]|0;if((ba|0)==(c[fa+16>>2]|0)){ie[c[(c[fa>>2]|0)+40>>2]&127](fa)|0}else{c[P>>2]=ba+4}qb=Nb;rb=Ob;sb=a[x]|0;tb=tb+4|0}if(!F){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}ba=a[x]|0;if((ba&1)==0){Qb=h;Rb=(ba&255)>>>1}else{Qb=c[G>>2]|0;Rb=c[h>>2]|0}if((tb|0)==(Qb+(Rb<<2)|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O}else{T=174;break a}break};default:{Va=M;Wa=r;Xa=L;Ya=N;Za=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Sb=V;Tb=V}while(1){ba=c[g>>2]|0;do{if((ba|0)==0){Ub=1}else{P=c[ba+12>>2]|0;if((P|0)==(c[ba+16>>2]|0)){Vb=ie[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{Vb=c[P>>2]|0}if((Vb|0)==-1){c[g>>2]=0;Ub=1;break}else{Ub=(c[g>>2]|0)==0;break}}}while(0);do{if((Tb|0)==0){Wb=Sb;T=42}else{ba=c[Tb+12>>2]|0;if((ba|0)==(c[Tb+16>>2]|0)){Xb=ie[c[(c[Tb>>2]|0)+36>>2]&127](Tb)|0}else{Xb=c[ba>>2]|0}if((Xb|0)==-1){c[b>>2]=0;Wb=0;T=42;break}else{if(Ub^(Sb|0)==0){Yb=Sb;Zb=Sb;break}else{Va=M;Wa=r;Xa=L;Ya=N;Za=O;break g}}}}while(0);if((T|0)==42){T=0;if(Ub){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break g}else{Yb=Wb;Zb=0}}ba=c[g>>2]|0;P=c[ba+12>>2]|0;if((P|0)==(c[ba+16>>2]|0)){_b=ie[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{_b=c[P>>2]|0}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,8192,_b)|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break g}P=c[g>>2]|0;ba=P+12|0;fa=c[ba>>2]|0;if((fa|0)==(c[P+16>>2]|0)){$b=ie[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[ba>>2]=fa+4;$b=c[fa>>2]|0}_5a(A,$b);Sb=Yb;Tb=Zb}}}while(0);fa=o+1|0;if(fa>>>0<4){L=Xa;r=Wa;M=Va;o=fa;N=Ya;O=Za}else{W=Va;X=Wa;Y=Ya;Z=Za;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==206){Kfb()}else if((T|0)==217){Kfb()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;ac=0;bc=wa;cc=za}else if((T|0)==263){c[j>>2]=c[j>>2]|4;ac=0;bc=wa;cc=za}else if((T|0)==274){c[j>>2]=c[j>>2]|4;ac=0;bc=wa;cc=za}else if((T|0)==276){i:do{if((Y|0)!=0){Za=Y+4|0;Ya=Y+8|0;Wa=1;j:while(1){Va=a[Y]|0;if((Va&1)==0){dc=(Va&255)>>>1}else{dc=c[Za>>2]|0}if(!(Wa>>>0<dc>>>0)){break i}Va=c[g>>2]|0;do{if((Va|0)==0){ec=1}else{N=c[Va+12>>2]|0;if((N|0)==(c[Va+16>>2]|0)){fc=ie[c[(c[Va>>2]|0)+36>>2]&127](Va)|0}else{fc=c[N>>2]|0}if((fc|0)==-1){c[g>>2]=0;ec=1;break}else{ec=(c[g>>2]|0)==0;break}}}while(0);Va=c[b>>2]|0;do{if((Va|0)==0){T=295}else{N=c[Va+12>>2]|0;if((N|0)==(c[Va+16>>2]|0)){gc=ie[c[(c[Va>>2]|0)+36>>2]&127](Va)|0}else{gc=c[N>>2]|0}if((gc|0)==-1){c[b>>2]=0;T=295;break}else{if(ec){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(ec){break}}Va=c[g>>2]|0;N=c[Va+12>>2]|0;if((N|0)==(c[Va+16>>2]|0)){hc=ie[c[(c[Va>>2]|0)+36>>2]&127](Va)|0}else{hc=c[N>>2]|0}if((a[Y]&1)==0){ic=Za}else{ic=c[Ya>>2]|0}if((hc|0)!=(c[ic+(Wa<<2)>>2]|0)){break}N=Wa+1|0;Va=c[g>>2]|0;o=Va+12|0;r=c[o>>2]|0;if((r|0)==(c[Va+16>>2]|0)){ie[c[(c[Va>>2]|0)+40>>2]&127](Va)|0;Wa=N;continue}else{c[o>>2]=r+4;Wa=N;continue}}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z;break h}}while(0);if((W|0)==(X|0)){ac=1;bc=X;cc=Z;break}c[C>>2]=0;obb(w,W,X,C);if((c[C>>2]|0)==0){ac=1;bc=W;cc=Z;break}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z}}while(0);W5a(A);W5a(z);W5a(y);W5a(x);s5a(w);if((bc|0)==0){i=p;return ac|0}fe[cc&511](bc);i=p;return ac|0}function tbb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=447;v=n+400|0;o6a(q,h);n=q;w=c[n>>2]|0;if(!((c[48102]|0)==-1)){c[m>>2]=192408;c[m+4>>2]=445;c[m+8>>2]=0;d5a(192408,m,446)}m=(c[192412>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ec(4)|0;z=y;cfb(z);A=207976;B=127;Td(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ec(4)|0;z=y;cfb(z);A=207976;B=127;Td(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=sbb(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){_5a(k,xe[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=xe[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);ubb(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=ie[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=ie[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];K4a(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}fe[c[u>>2]&511](n);i=d;return}function ubb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){a6a(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function vbb(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[47996]|0)==-1)){c[p>>2]=191984;c[p+4>>2]=445;c[p+8>>2]=0;d5a(191984,p,446)}p=(c[191988>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ec(4)|0;C=B;cfb(C);D=207976;E=127;Td(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ec(4)|0;C=B;cfb(C);D=207976;E=127;Td(B|0,D|0,E|0)}E=b;ge[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ge[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}Z5a(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;W5a(r);ge[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}Z5a(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;W5a(s);c[f>>2]=ie[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=ie[c[(c[b>>2]|0)+16>>2]&127](E)|0;ge[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}E5a(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;s5a(t);ge[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}Z5a(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;W5a(u);F=ie[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[47980]|0)==-1)){c[o>>2]=191920;c[o+4>>2]=445;c[o+8>>2]=0;d5a(191920,o,446)}o=(c[191924>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;cfb(H);I=207976;J=127;Td(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ec(4)|0;H=G;cfb(H);I=207976;J=127;Td(G|0,I|0,J|0)}J=E;ge[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ge[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}Z5a(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;W5a(w);ge[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}Z5a(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;W5a(x);c[f>>2]=ie[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=ie[c[(c[E>>2]|0)+16>>2]&127](J)|0;ge[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}E5a(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;s5a(y);ge[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}Z5a(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;W5a(z);F=ie[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function wbb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=447;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=Afb(m,l)|0;m=a;if((a|0)==0){Kfb()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}fe[c[f>>2]&511](a);n=c[h>>2]|0}}while(0);c[f>>2]=422;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function xbb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function ybb(a){a=a|0;i=i;return}function zbb(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Mc(G|0,100,192168,o|0)|0;do{if(s>>>0>99){do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);o=c[48076]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=r9a(r,o,192168,n)|0;o=c[r>>2]|0;if((o|0)==0){Kfb()}H=xfb(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}Kfb()}else{I=0;J=0;K=q;L=s}}while(0);o6a(t,g);s=t;q=c[s>>2]|0;if(!((c[48104]|0)==-1)){c[p>>2]=192416;c[p+4>>2]=445;c[p+8>>2]=0;d5a(192416,p,446)}p=(c[192420>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Ec(4)|0;N=M;cfb(N);O=207976;P=127;Td(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Ec(4)|0;N=M;cfb(N);O=207976;P=127;Td(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;He[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Abb(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=xfb(V)|0;if((T|0)!=0){W=T;X=T;break}Kfb()}else{W=0;X=t}}while(0);Bbb(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];Q1a(b,m,X,e,D,g,j);if((W|0)!=0){yfb(W)}s5a(A);s5a(z);s5a(y);K4a(c[s>>2]|0)|0;if((J|0)!=0){yfb(J)}if((I|0)==0){i=d;return}yfb(I);i=d;return}



function jLa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function kLa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 15:{k=nLa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 24:case 22:{b=b+1|0;break};case 17:{k=oLa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==20){k=mLa(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==27){k=lLa(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){m=41;break b}n=b;if((xe[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=n+3|0;continue b;break};case 10:case 9:case 21:{m=73;break b;break};case 7:{if((e-b|0)<4){m=46;break b}o=b;if((xe[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=o+4|0;continue b;break};case 29:{m=33;break b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){m=68;break b}p=b;if((xe[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=p+4|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 5:{if((e-b|0)<2){m=58;break b}q=b;if((xe[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=q+2|0;continue b;break};case 6:{if((e-b|0)<3){m=63;break b}r=b;if((xe[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=r+3|0;continue b;break};case 29:{m=55;break b;break};default:{m=72;break b}}break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 11:{m=97;break b;break};case 5:{if((e-b|0)<2){m=36;break b}s=b;if((xe[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=s+2|0;continue b;break};case 17:{break b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 29:{m=76;break d;break};case 10:case 9:case 21:{break};case 6:{m=83;break d;break};case 7:{m=88;break d;break};case 11:{m=97;break c;break};case 24:case 22:{m=77;break d;break};case 5:{m=78;break d;break};case 17:{break c;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=pLa(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function lLa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){m=8;break b}n=b;if((xe[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=n+2|0;continue b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 6:{if((e-b|0)<3){m=13;break b}o=b;if((xe[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=o+3|0;continue b;break};case 7:{if((e-b|0)<4){m=18;break b}p=b;if((xe[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=p+4|0;continue b;break};case 8:case 1:case 0:{m=22;break b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function mLa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[112240+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function nLa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((xe[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((xe[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((xe[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 10:case 9:case 21:{o=41;break b;break};case 29:{o=24;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){o=32;break b}p=b;if((xe[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=p+3|0;continue b;break};case 7:{if((e-b|0)<4){o=37;break b}q=b;if((xe[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=q+4|0;continue b;break};case 5:{if((e-b|0)<2){o=27;break b}r=b;if((xe[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=r+2|0;continue b;break};case 15:{o=68;break b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((qLa(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){o=47;break c}s=b;if((xe[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=s+2|0;continue c;break};case 7:{if((e-b|0)<4){o=57;break c}t=b;if((xe[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=t+4|0;continue c;break};case 6:{if((e-b|0)<3){o=52;break c}u=b;if((xe[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=u+3|0;continue c;break};case 8:case 1:case 0:{o=61;break c;break};case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((qLa(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function oLa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 23:{a=a+1|0;continue b;break};case 10:case 9:case 21:{l=41;break b;break};case 29:{l=24;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}m=a;if((xe[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=m+3|0;continue b;break};case 11:{l=49;break b;break};case 7:{if((b-a|0)<4){l=37;break b}n=a;if((xe[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=n+4|0;continue b;break};case 5:{if((b-a|0)<2){l=27;break b}o=a;if((xe[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=o+2|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}n=d[h+76+(d[a]|0)|0]|0;if((n|0)==11){l=44;break}else if(!((n|0)==10|(n|0)==9|(n|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function pLa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 29:{l=4;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}b=(xe[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=19;break a}c[j>>2]=m+4;continue a;break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}b=(xe[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!b){l=41;break a}c[j>>2]=n+4;continue a;break};case 29:{l=26;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}b=(xe[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!b){l=36;break a}c[j>>2]=o+3;continue a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}b=(xe[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!b){l=31;break a}c[j>>2]=p+2;continue a;break};default:{l=43;break a}}break};case 14:{break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}b=(xe[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!b){l=9;break a}c[j>>2]=q+2;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}b=(xe[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!b){l=14;break a}c[j>>2]=r+3;continue a;break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}s=b;if(!((s|0)==9|(s|0)==10|(s|0)==21)){l=48;break a}}break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}s=t;if(!((s|0)==9|(s|0)==10|(s|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}s=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((s|0)==(t|0)){break}switch(s|0){case 8:case 1:case 0:{l=75;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}s=(xe[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(s){l=73;break a}c[j>>2]=u+4;continue c;break};case 2:{l=80;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}s=(xe[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(s){l=68;break a}c[j>>2]=v+3;continue c;break};case 3:{w=gLa(k,(c[j>>2]|0)+1|0,e,j)|0;if((w|0)<=0){l=77;break a}else{continue c}break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}s=(xe[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;x=c[j>>2]|0;if(s){l=63;break a}c[j>>2]=x+2;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 24:case 22:{l=90;break d;break};case 11:{l=106;break a;break};case 6:{l=96;break d;break};case 10:case 9:case 21:{break};case 7:{l=101;break d;break};case 17:{l=107;break a;break};case 5:{l=91;break d;break};case 29:{l=89;break a;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}s=(xe[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!s){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}s=(xe[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!s){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}s=(xe[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!s){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=x;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((w|0)==0){c[f>>2]=c[j>>2]}B=w;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function qLa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function rLa(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};case 5:{if((e-b|0)<2){k=5;break a}l=b;if((xe[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}m=b;if((xe[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=m+3|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 7:{if((e-b|0)<4){k=15;break a}n=b;if((xe[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=n+4|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function sLa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 30:{l=10;break a;break};case 24:case 22:{break};case 10:case 9:case 21:{break a;break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==27){j=lLa(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function tLa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=32;break b}m=a;if((xe[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=m+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}n=a;if((xe[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=n+4|0;continue b;break};case 5:{if((b-a|0)<2){l=27;break b}o=a;if((xe[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=o+2|0;continue b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 29:{l=24;break b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function uLa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function vLa(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function wLa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function xLa(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};case 60:case 0:{break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==15360){if((a[b+73|0]|0)==4){p=16}else{if((a[b+73|0]|0)==3){p=16}}if((p|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=He[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==61371){if((e|0)==1){o=a[b+73|0]|0;if((o|0)==0|(o|0)==4|(o|0)==5|(o|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=He[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=He[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=He[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function yLa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((ALa(zLa(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((ALa(zLa(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=zLa(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((ALa(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=zLa(k,a,b)|0;n=h;}while((ALa(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=zLa(k,a,b)|0;while(1){if((ALa(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=zLa(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=zLa(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function zLa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;ce[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function ALa(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function BLa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function CLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 11:{c[h>>2]=14;j=55;break};case 13:{c[h>>2]=14;j=56;break};case 15:{c[h>>2]=14;j=0;break};case 12:{c[h>>2]=14;j=1;break};case 16:{if((He[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,115984)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};case 14:{j=0;break};case 29:{c[h>>2]=16;j=2;break};default:{k=10}}}while(0);if((k|0)==10){j=GLa(h,a)|0}i=g;return j|0}function DLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 26:{j=9;break};case 15:{k=0;break};case-4:{if((c[h+12>>2]|0)!=0){j=9;break a}k=0;break};case 33:{c[h>>2]=17;k=0;break};case 34:{if((c[h+12>>2]|0)==0){j=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;k=0;break};default:{k=FLa(h,a,d,e,f)|0}}}while(0);if((j|0)==9){k=GLa(h,a)|0}i=g;return k|0}function ELa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=0;l=k;i=g;return l|0}do{if((j|0)==3){if((He[c[e+28>>2]&63](e,b,d,115968)|0)!=0){c[h>>2]=18;k=0;l=k;i=g;return l|0}if((He[c[e+28>>2]&63](e,b,d,115976)|0)==0){break}c[h>>2]=19;k=0;l=k;i=g;return l|0}}while(0);k=GLa(h,a)|0;l=k;i=g;return l|0}function FLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 16:{if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,115744)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,115752)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,115760)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,115768)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};case 13:{j=56;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};default:{}}}while(0);j=GLa(h,a)|0;k=j;i=g;return k|0}function GLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function HLa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function ILa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==22){c[e>>2]=25;g=11}else if((b|0)==18){c[e>>2]=26;g=9}else if((b|0)==15){g=11}else{g=GLa(e,a)|0}i=f;return g|0}function JLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else{g=GLa(e,a)|0}i=f;return g|0}function KLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=GLa(e,a)|0}i=f;return g|0}function LLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==18){c[e>>2]=29;g=18}else{g=GLa(e,a)|0}i=f;return g|0}function MLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else{g=GLa(e,a)|0}i=f;return g|0}function NLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==11){g=55}else if((b|0)==29){c[e>>2]=16;g=2}else if((b|0)==13){g=56}else if((b|0)==15){g=0}else{g=GLa(e,a)|0}i=f;return g|0}function OLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=17;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((He[c[e+28>>2]&63](e,b,d,115784)|0)!=0){c[h>>2]=31;j=17;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,115792)|0)==0){break}c[h>>2]=32;j=17;k=j;i=g;return k|0}}while(0);j=GLa(h,a)|0;k=j;i=g;return k|0}function PLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else{g=GLa(e,a)|0}i=f;return g|0}function QLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=34;g=21}else{g=GLa(e,a)|0}i=f;return g|0}function RLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==15){g=17}else{g=GLa(e,a)|0}i=f;return g|0}function SLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=GLa(e,a)|0;h=g;i=f;return h|0}return 0}function TLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,115800)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,115808)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}else if((f|0)==15){j=39;k=j;i=g;return k|0}}while(0);j=GLa(h,a)|0;k=j;i=g;return k|0}function ULa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 30:{c[h>>2]=40;j=53;break};case 32:{c[h>>2]=40;j=54;break};case 41:case 18:{c[h>>2]=40;j=51;break};case 15:{j=39;break};case 31:{c[h>>2]=40;j=52;break};case 20:{if((He[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,115816)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};default:{k=10}}}while(0);if((k|0)==10){j=GLa(h,a)|0}i=g;return j|0}function VLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==15){g=39}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else{g=GLa(e,a)|0}i=f;return g|0}function WLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 15:{g=39;break};case 31:{c[e>>2]=40;g=52;break};case 30:{c[e>>2]=40;g=53;break};case 41:case 18:{c[e>>2]=40;g=51;break};case 32:{c[e>>2]=40;g=54;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};default:{g=GLa(e,a)|0}}i=f;return g|0}function XLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 15:{g=39;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};default:{g=GLa(e,a)|0;h=g;i=f;return h|0}}return 0}function YLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else{g=GLa(e,a)|0}i=f;return g|0}function ZLa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else{g=GLa(e,a)|0}i=f;return g|0}function _La(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else if((b|0)==15){g=33}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else{g=GLa(e,a)|0}i=f;return g|0}function $La(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==18){l=0;while(1){m=c[e+28>>2]|0;n=e;o=b;p=d;if((l|0)>=8){break}if((He[m&63](n,o,p,c[115824+(l<<2)>>2]|0)|0)!=0){q=6;break}l=l+1|0}if((q|0)==6){c[h>>2]=44;j=23+l|0;k=j;i=g;return k|0}if((He[m&63](n,o,p,115768)|0)==0){break}c[h>>2]=45;j=33;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=46;j=33;k=j;i=g;return k|0}}while(0);j=GLa(h,a)|0;k=j;i=g;return k|0}function aMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==20){if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,115928)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,115936)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,115952)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}}while(0);j=GLa(h,a)|0;k=j;i=g;return k|0}function bMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==23){c[e>>2]=48;g=33}else{g=GLa(e,a)|0}i=f;return g|0}function cMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else if((b|0)==15){g=33}else{g=GLa(e,a)|0}i=f;return g|0}function dMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=GLa(e,a)|0}i=f;return g|0}function eMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=50;g=32}else if((b|0)==15){g=33}else{g=GLa(e,a)|0}i=f;return g|0}function fMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=GLa(e,a)|0}i=f;return g|0}function gMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=27;g=38}else if((b|0)==15){g=33}else{g=GLa(e,a)|0}i=f;return g|0}function hMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=51;g=10}else{g=GLa(e,a)|0}i=f;return g|0}function iMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,115784)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,115792)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=GLa(h,a)|0;k=j;i=g;return k|0}function jMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=54;g=13}else if((b|0)==15){g=11}else{g=GLa(e,a)|0}i=f;return g|0}function kMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=52;g=14}else{g=GLa(e,a)|0}i=f;return g|0}function lMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;f=a;do{if((f|0)==18){if((He[c[b+28>>2]&63](b,d,e,115960)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=GLa(h,a)|0;k=j;i=g;return k|0}function mMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else{g=GLa(e,a)|0}i=f;return g|0}function nMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,115784)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,115792)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=GLa(h,a)|0;k=j;i=g;return k|0}function oMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=58;g=13}else if((b|0)==15){g=11}else{g=GLa(e,a)|0}i=f;return g|0}function pMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=56;g=14}else{g=GLa(e,a)|0}i=f;return g|0}function qMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else if((b|0)==15){g=11;h=g;i=f;return h|0}else{g=GLa(e,a)|0;h=g;i=f;return h|0}return 0}function rMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0;h=g;i=f;return h|0}else if((b|0)==25){c[e>>2]=36;b=e+12|0;c[b>>2]=(c[b>>2]|0)+1;g=0;h=g;i=f;return h|0}else{g=GLa(e,a)|0;h=g;i=f;return h|0}return 0}function sMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;g=58}else if((b|0)==15){g=0}else{g=GLa(e,a)|0}i=f;return g|0}function tMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 16:{if((He[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,115984)|0)==0){j=9;break a}c[h>>2]=15;k=3;break};case 11:{k=55;break};case 14:{k=0;break};case 29:{c[h>>2]=16;k=2;break};case 13:{k=56;break};case 15:{k=0;break};default:{j=9}}}while(0);if((j|0)==9){k=GLa(h,a)|0}i=g;return k|0}function uMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else{g=GLa(e,a)|0}i=f;return g|0}function vMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,115784)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,115792)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}}while(0);j=GLa(h,a)|0;k=j;i=g;return k|0}function wMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=62;g=5}else{g=GLa(e,a)|0}i=f;return g|0}function xMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=60;g=6}else if((b|0)==15){g=3}else{g=GLa(e,a)|0}i=f;return g|0}function yMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else{g=GLa(e,a)|0}i=f;return g|0}function zMa(){i=i;return}function AMa(){i=i;return}function BMa(){var a=0;a=i;Wa(115992,0)|0;i=a;return}function CMa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;rc(116e3,29,1,e|0)|0;ud(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;rc(116032,54,1,g|0)|0;ud(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;rc(116088,47,1,a|0)|0;ud(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;wd(k|0,116136,d|0)|0;ud(k|0)|0;f=0;i=b;return f|0}function DMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=c[a>>2]|0;h=c[b>>2]|0;if((g|0)!=(h|0)){j=c[r>>2]|0;c[f>>2]=g;c[f+4>>2]=h;wd(j|0,116224,f|0)|0;k=0;i=d;return k|0}if((g|0)<=0){k=1;i=d;return k|0}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;while(1){l=c[f+(b<<2)>>2]|0;m=c[a+(b<<2)>>2]|0;j=b+1|0;if((l|0)!=(m|0)){break}if((j|0)<(g|0)){b=j}else{k=1;n=8;break}}if((n|0)==8){i=d;return k|0}n=c[r>>2]|0;c[e>>2]=b;c[e+4>>2]=b;c[e+8>>2]=l;c[e+12>>2]=m;wd(n|0,116256,e|0)|0;k=0;i=d;return k|0}function EMa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function FMa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=lNa(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function GMa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=lNa(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function HMa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[41884]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=116312;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ie[p&63](0,f,116336,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function IMa(a,b){a=a|0;b=b|0;var d=0;d=i;if((CMa(a)|0)==0){cb(116392,116200,347,116416)}do{if((b|0)>0){if((c[a>>2]|0)<(b|0)){break}i=d;return c[(c[a+4>>2]|0)+(b+ -1<<2)>>2]|0}}while(0);cb(116448,116200,348,116416);return 0}function JMa(){var a=0,b=0,d=0;a=i;b=118192|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=118304|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=118416|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[118196>>2]=1;c[118200>>2]=1;i=a;return}function KMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?118552:118568;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;wd(a|0,118528,e|0)|0;i=d;return}function LMa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=118416+(d<<2)|0;o=118304+(d<<2)|0;p=118616+(b<<2)|0;q=116896+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=118600;gc(118584,l|0)|0;s=118600}else{if((c[29544]|0)==(d|0)){if((c[o>>2]|0)>0){t=118600}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;gc(118584,m|0)|0;do{if((c[29544]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=118600;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;gc(118608,k|0)|0;c[n>>2]=b;c[29544]=d;if((c[o>>2]|0)>0){g=0;while(1){gc(118640,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==0){break a}else if(g<<24>>24==10){break}w=w+1|0}a[x]=0;tb(e|0)|0;r=0;e=e+(w+1)|0;f=1}tb(e|0)|0;ud(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function MMa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[118616+(a<<2)>>2]|0;c[j>>2]=c[116896+(b<<2)>>2];c[j+4>>2]=k;gc(118648,j|0)|0;NMa(e);if((g|0)==0){Kd(((d|0)!=0?118688:118736)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=ud(m|0)|0;i=f;return}tb(118816)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];gc(118696,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=ud(m|0)|0;i=f;return}rc(118720,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=ud(m|0)|0;i=f;return}function NMa(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==62){rc(118776,4,1,e|0)|0}else if(b<<24>>24==60){rc(118768,4,1,e|0)|0}else if(b<<24>>24==0){break}else if(b<<24>>24==38){rc(118760,5,1,e|0)|0}else{Sd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function OMa(a){a=a|0;var b=0;b=118304+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function PMa(a){a=a|0;var b=0;b=(a|0)==0;c[29688]=b?1:19;c[29686]=b?7:423;i=i;return}function QMa(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;rc(118720,11,1,b|0)|0;ud(b|0)|0;i=a;return}function RMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[118192+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;Zc(j|0,2048,e|0,h|0)|0;re[c[29688]&31](1,a,b,j,0,d);i=g;return}function SMa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[118192+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;Zc(h|0,2048,d|0,g|0)|0;re[c[29688]&31](1,a,b,h,0,0);i=f;return}function TMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[29546]|0)==0){if((c[118192+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;Zc(k|0,2048,e|0,j|0)|0;re[c[29688]&31](2,a,b,k,0,d);i=g;return}function UMa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[29546]|0)==0){if((c[118192+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;Zc(j|0,2048,d|0,h|0)|0;re[c[29688]&31](2,a,b,j,0,0);i=f;return}function VMa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;Zc(b|0,2048,d|0,g|0)|0;re[c[29688]&31](4,2,0,b,0,0);if((a|0)==0){h=md(c[28998]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function WMa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;Zc(g|0,2048,b|0,f|0)|0;re[c[29688]&31](5,2,0,g,0,0);if((a|0)==0){h=md(c[28998]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function XMa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;Zc(h|0,2048,d|0,g|0)|0;re[c[29688]&31](5,2,0,h,0,b);if((a|0)==0){j=md(c[28998]|0)|0}else{j=a}eb(c[j+76>>2]|0,1)}function YMa(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;XMa(a,e,118888,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;TMa(26,0,e,118824,m);i=j;return+b}return 0.0}function ZMa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=xfb(16)|0;VMa(0,(d|0)!=0|0,118936,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function _Ma(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;yfb(c[f>>2]|0);yfb(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function $Ma(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;VMa(0,(a|0)!=0|0,118952,f);f=xfb(8)|0;g=f;VMa(0,(f|0)!=0|0,118936,e);e=a+8|0;h=xfb(c[e>>2]|0)|0;c[f>>2]=h;VMa(0,(h|0)!=0|0,118936,d);bgb(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function aNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;VMa(0,(a|0)!=0|0,118952,f);f=xfb(8)|0;g=f;VMa(0,(f|0)!=0|0,118936,e);e=a+8|0;h=xfb(c[e>>2]|0)|0;c[f>>2]=h;VMa(0,(h|0)!=0|0,118936,d);bgb(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function bNa(a){a=a|0;var b=0;b=i;i=i+8|0;VMa(0,(a|0)!=0|0,118952,b);i=b;return c[a+12>>2]|0}function cNa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;VMa(0,(a|0)!=0|0,118952,d);d=a;VMa(0,(c[d>>2]|0)!=0|0,118976,b);i=b;return c[c[d>>2]>>2]|0}function dNa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;yfb(c[e>>2]|0);yfb(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function eNa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;VMa(0,(a|0)!=0|0,118952,d);d=a;VMa(0,(c[d>>2]|0)!=0|0,118992,b);i=b;return c[d>>2]|0}function fNa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;VMa(0,d&1,119024,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function gNa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;VMa(0,(a|0)!=0|0,119024,d);d=a;VMa(0,(c[d>>2]|0)!=0|0,119048,b);i=b;return c[d>>2]|0}function hNa(){var a=0,b=0,d=0;a=i;b=xfb(16)|0;c[29780]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=xfb(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function iNa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=mNa(a)|0;tc(119128)|0;nNa(d);a=c[29780]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;fc(119128)|0;dgb(g|0,0,d|0)|0;i=b;return g|0}function jNa(){var a=0,b=0,d=0,e=0;a=i;b=c[29780]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;yfb(c[b>>2]|0);yfb(b);if((d|0)==0){break}else{b=d}}e=c[29780]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function kNa(a){a=a|0;var b=0,d=0;b=i;d=ie[c[119080>>2]&127](a<<3)|0;i=b;return d|0}function lNa(a){a=a|0;var b=0,d=0;b=i;d=ie[c[119080>>2]&127](a<<2)|0;i=b;return d|0}function mNa(a){a=a|0;i=i;return a+7&-8|0}function nNa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[29780]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=xfb(16)|0;c[f+12>>2]=d;c[29780]=f;c[f+4>>2]=0;d=oNa((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=xfb(d)|0;c[f>>2]=a;i=b;return}function oNa(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function pNa(a){a=a|0;var b=0,c=0;b=i;c=$fb(a|0)|0;i=b;return c|0}function qNa(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;fgb(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];hc(m|0,l|0,f|0)|0;f=rNa(m)|0;i=e;return f|0}function rNa(a){a=a|0;var b=0,c=0,d=0;b=i;c=$fb(a|0)|0;d=tNa(c)|0;bgb(d|0,a|0,c|0)|0;i=b;return d|0}function sNa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;h=i;i=i+400|0;j=g;k=h;a[j]=37;fgb(g+1|0,d|0)|0;c[f>>2]=b;hc(k|0,j|0,f|0)|0;f=rNa(k)|0;i=e;return f|0}function tNa(b){b=b|0;var d=0,e=0;d=i;e=ie[c[119084>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function uNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=pNa(a)|0;e=pNa(b)|0;f=tNa(e+d|0)|0;bgb(f|0,a|0,d|0)|0;bgb(f+d|0,b|0,e|0)|0;i=c;return f|0}function vNa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Xfb(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function wNa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 5:{f=1;break a;break};case 0:{f=8;break a;break};case 4:{f=2;break a;break};case 2:{f=4;break a;break};case 1:{f=4;break a;break};case 3:{f=2;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function xNa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){Yc(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){yfb(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{yfb(c[(c[f>>2]|0)+(g<<4)>>2]|0);yfb(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;yfb(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){yfb(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{yfb(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}yfb(d);c[g>>2]=0;i=b;return}function yNa(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>($fb(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function zNa(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=ic(b|0,119312)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Wd(c[(Nc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=Ad(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=sb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=119320;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[119288+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=119344;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=119368;E=131;break}G=wNa(D)|0;if((G|0)==-1){n=119400;E=131;break}D=c[q>>2]|0;H=xfb(D)|0;if((sb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=119448;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=119472;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((Xfb(H,c[119264+(C<<2)>>2]|0)|0)!=0){n=119496;E=131;break}yfb(H);H=120072;b:do{switch(C|0){case 0:{if((D|0)!=4){n=119520;E=131;break a}if((I|0)!=11){n=119560;E=131;break a}if((sb(f|0,44,1,c[m>>2]|0)|0)==1){K=0}else{n=119600;E=131;break a}while(1){F=0;do{a[k+F|0]=a[j+((F<<2)+K)|0]|0;F=F+1|0;}while(F>>>0<11);a[k+11|0]=0;if((K|0)==3){break}F=K+1|0;if(F>>>0<4){K=F}else{L=d;E=130;break b}}if((Yfb(t,c[29792]|0,8)|0)==0){L=1;E=130;break b}if((Yfb(t,c[29798]|0,9)|0)==0){L=0;E=130}else{n=119632;E=131;break a}break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=119760;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=119816;E=131;break a}c[w>>2]=D;F=fa(I,D)|0;if((a[l]|0)==1){G=xfb(F<<3)|0;c[x>>2]=G;if((sb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=119856;E=131;break a}}else{G=xfb(F<<2)|0;c[x>>2]=xfb(fa(D<<3,I)|0)|0;if((sb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=119856;E=131;break a}if((F|0)!=0){M=c[x>>2]|0;N=0;do{h[M+(N<<3)>>3]=+g[G+(N<<2)>>2];N=N+1|0;}while(N>>>0<F>>>0)}yfb(G)}F=c[w>>2]|0;if(!(F>>>0>1)){L=1;E=130;break b}N=(I|0)==2;M=1;while(1){if(N){O=c[x>>2]|0;if(+h[O+(M<<3)>>3]!=+h[O+(F+M<<3)>>3]){n=119888;E=131;break a}}O=M+1|0;if(O>>>0<F>>>0){M=O}else{L=1;E=130;break b}}}else if(!(d<<24>>24==0)){P=d;E=129;break b}if((I|0)==0){n=119760;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=119968;E=131;break a}c[w>>2]=I;M=fa(I,D)|0;if((a[l]|0)==1){F=xfb(M<<3)|0;c[x>>2]=xfb(fa(D<<3,I)|0)|0;if((sb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=119856;E=131;break a}if((D|0)!=0){N=0;do{G=c[x>>2]|0;O=0;do{h[G+((fa(I,N)|0)+O<<3)>>3]=+h[F+((fa(D,O)|0)+N<<3)>>3];O=O+1|0;}while(O>>>0<I>>>0);N=N+1|0;}while(N>>>0<D>>>0)}yfb(F)}else{N=xfb(M<<2)|0;c[x>>2]=xfb(fa(D<<3,I)|0)|0;if((sb(N|0,J|0,1,c[m>>2]|0)|0)!=1){n=119856;E=131;break a}if((D|0)!=0){O=0;do{G=c[x>>2]|0;Q=0;do{h[G+((fa(I,O)|0)+Q<<3)>>3]=+g[N+((fa(D,Q)|0)+O<<2)>>2];Q=Q+1|0;}while(Q>>>0<I>>>0);O=O+1|0;}while(O>>>0<D>>>0)}yfb(N)}O=c[w>>2]|0;if(!(O>>>0>1)){L=d;E=130;break b}M=(D|0)==2;F=1;while(1){if(M){Q=c[x>>2]|0;if(+h[Q+(F<<3)>>3]!=+h[Q+(O+F<<3)>>3]){n=119888;E=131;break a}}Q=F+1|0;if(Q>>>0<O>>>0){F=Q}else{L=d;E=130;break}}break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=120008;E=131;break a}c[z>>2]=D;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=zfb(c[z>>2]<<1,4)|0;if((Wc(c[m>>2]|0,J|0,1)|0)==-1){n=120040;E=131;break a}else{L=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=120008;E=131;break a}c[z>>2]=I;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=zfb(c[z>>2]<<1,4)|0;F=fa(I,D)|0;if((a[l]|0)==1){O=xfb(F<<3)|0;if((sb(O|0,J|0,1,c[m>>2]|0)|0)!=1){n=120040;E=131;break a}if((I|0)!=0){M=D<<3;N=(D|0)==0;Q=D<<3;G=0;do{R=xfb(M)|0;c[(c[B>>2]|0)+(G<<2)>>2]=R;if(!N){R=O+(fa(Q,G)|0)|0;bgb(c[(c[B>>2]|0)+(G<<2)>>2]|0,R|0,Q|0)|0}G=G+1|0;}while(G>>>0<I>>>0)}G=c[z>>2]|0;Q=G<<1;if(G>>>0<Q>>>0){N=D<<3;M=(D|0)==0;R=G;do{S=xfb(N)|0;c[(c[B>>2]|0)+(R<<2)>>2]=S;if(!M){S=c[B>>2]|0;T=c[S+(R-G<<2)>>2]|0;U=c[S+(R<<2)>>2]|0;S=0;do{h[U+(S<<3)>>3]=-+h[T+(S<<3)>>3];S=S+1|0;}while(S>>>0<D>>>0)}R=R+1|0;}while(R>>>0<Q>>>0)}yfb(O)}else{Q=xfb(F<<2)|0;if((sb(Q|0,J|0,1,c[m>>2]|0)|0)!=1){n=120040;E=131;break a}if((I|0)!=0){R=D<<3;G=(D|0)==0;M=0;do{N=xfb(R)|0;c[(c[B>>2]|0)+(M<<2)>>2]=N;if(!G){N=c[(c[B>>2]|0)+(M<<2)>>2]|0;S=0;do{h[N+(S<<3)>>3]=+g[Q+((fa(D,M)|0)+S<<2)>>2];S=S+1|0;}while(S>>>0<D>>>0)}M=M+1|0;}while(M>>>0<I>>>0)}M=c[z>>2]|0;G=M<<1;if(M>>>0<G>>>0){R=D<<3;F=(D|0)==0;O=M;do{S=xfb(R)|0;c[(c[B>>2]|0)+(O<<2)>>2]=S;if(!F){S=c[B>>2]|0;N=c[S+(O-M<<2)>>2]|0;T=c[S+(O<<2)>>2]|0;S=0;do{h[T+(S<<3)>>3]=-+h[N+(S<<3)>>3];S=S+1|0;}while(S>>>0<D>>>0)}O=O+1|0;}while(O>>>0<G>>>0)}yfb(Q)}if((Wc(c[m>>2]|0,J|0,1)|0)==-1){n=120040;E=131;break a}else{L=d;E=130}break};case 1:{G=d<<24>>24==0;c[u>>2]=G?D:I;O=xfb((G?D:I)<<4)|0;c[v>>2]=O;c:do{if(d<<24>>24==1){if((I|0)==0){V=0;break}M=D+1|0;F=O;R=0;while(1){c[F+(R<<4)>>2]=xfb(M)|0;if((sb(c[(c[v>>2]|0)+(R<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=119696;E=131;break a}a[(c[(c[v>>2]|0)+(R<<4)>>2]|0)+D|0]=0;S=c[v>>2]|0;c[S+(R<<4)+8>>2]=-1;c[S+(R<<4)+12>>2]=-1;yNa(c[S+(R<<4)>>2]|0);S=R+1|0;if(!(S>>>0<I>>>0)){V=I;break c}F=c[v>>2]|0;R=S}}else{V=I}}while(0);if(!G){L=d;E=130;break b}O=fa(D,V)|0;W=xfb(O+1|0)|0;if((sb(W|0,O|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){O=V+1|0;Q=(V|0)==0;R=0;do{F=xfb(O)|0;c[(c[v>>2]|0)+(R<<4)>>2]=F;if(!Q){F=0;do{M=a[W+((fa(D,F)|0)+R)|0]|0;a[(c[(c[v>>2]|0)+(R<<4)>>2]|0)+F|0]=M;F=F+1|0;}while(F>>>0<V>>>0)}a[(c[(c[v>>2]|0)+(R<<4)>>2]|0)+V|0]=0;F=c[v>>2]|0;c[F+(R<<4)+8>>2]=-1;c[F+(R<<4)+12>>2]=-1;yNa(c[F+(R<<4)>>2]|0);R=R+1|0;}while(R>>>0<D>>>0)}yfb(W);L=0;E=130;break};case 3:{R=fa(I<<2,D)|0;X=xfb(R)|0;if((sb(X|0,R|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==1){if((I|0)==0){break}R=c[v>>2]|0;Q=0;do{O=fa(D,Q)|0;c[R+(Q<<4)+8>>2]=(c[X+(O<<2)>>2]|0)==1;c[R+(Q<<4)+12>>2]=c[X+(O+1<<2)>>2];Q=Q+1|0;}while(Q>>>0<I>>>0)}else if(d<<24>>24==0){if((D|0)==0){break}Q=c[v>>2]|0;R=0;do{c[Q+(R<<4)+8>>2]=(c[X+(R<<2)>>2]|0)==1;c[Q+(R<<4)+12>>2]=c[X+(D+R<<2)>>2];R=R+1|0;}while(R>>>0<D>>>0)}}while(0);yfb(X);cc(c[v>>2]|0,c[u>>2]|0,16,54);L=d;E=130;break};case 2:{if(d<<24>>24==1){if((I|0)==0){P=1;E=129;break b}R=D+1|0;Q=0;while(1){O=xfb(R)|0;c[(c[v>>2]|0)+(Q<<4)+4>>2]=O;if((sb(c[(c[v>>2]|0)+(Q<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=119696;E=131;break a}a[(c[(c[v>>2]|0)+(Q<<4)+4>>2]|0)+D|0]=0;O=Q+1|0;if(O>>>0<I>>>0){Q=O}else{L=1;E=130;break b}}}else if(!(d<<24>>24==0)){P=d;E=129;break b}Q=fa(D,I)|0;Y=xfb(Q+1|0)|0;if((sb(Y|0,Q|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){Q=I+1|0;R=(I|0)==0;O=0;do{G=xfb(Q)|0;c[(c[v>>2]|0)+(O<<4)+4>>2]=G;if(!R){G=0;do{F=a[Y+((fa(D,G)|0)+O)|0]|0;a[(c[(c[v>>2]|0)+(O<<4)+4>>2]|0)+G|0]=F;G=G+1|0;}while(G>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(O<<4)+4>>2]|0)+I|0]=0;O=O+1|0;}while(O>>>0<D>>>0)}yfb(Y);L=0;E=130;break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=P;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=L;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){yfb(W);n=119696;i=e;return n|0}else if((E|0)==46){yfb(Y);n=119696;i=e;return n|0}else if((E|0)==52){yfb(X);n=119728;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function ANa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=Ed(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,54)|0;i=d;return b|0}function BNa(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=120112;o=n;p=120160;q=p;r=120184;s=r;cb(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=120112;o=n;p=120160;q=p;r=120184;s=r;cb(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=xfb(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Wc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((sb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}yfb(r);t=0;i=e;return t|0}else{k=xfb(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Wc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((sb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}yfb(k);yfb(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);yfb(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function CNa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=120112;r=q;s=120160;t=s;u=120208;v=u;cb(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=120112;r=q;s=120160;t=s;u=120208;v=u;cb(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Wc(o|0,t+(r<<3)|0,0)|0;f=(sb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Wc(o|0,t+(r<<2)|0,0)|0;if((sb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function DNa(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function ENa(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function FNa(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function GNa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+FNa(b)<e){q=1;i=f;return q|0}if(+ENa(b)>e){q=1;i=f;return q|0}if((BNa(b,1)|0)==0){q=1;i=f;return q|0}DNa(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+CNa(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+CNa(a,b,d,o);i=f;return q|0}if(+CNa(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+CNa(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function HNa(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function INa(a,b){a=a|0;b=b|0;var c=0;c=i;FMa(a,b,kNa(b)|0);i=c;return}function JNa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=kNa(GMa(a,b,f)|0)|0;i=e;return}function KNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;if((CMa(a)|0)==0){cb(120240,120264,127,120288)}if((CMa(b)|0)==0){cb(120312,120264,128,120288)}if((DMa(a,b)|0)==0){cb(120336,120264,129,120288)}e=EMa(a)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=+HNa(a,b);LNa(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function LNa(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function MNa(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function NNa(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;LNa(c[d+8>>2]|0,b,a);i=e;return}function ONa(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;INa(a,b);j=g;c[g>>2]=e;NNa(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;NNa(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function PNa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=HMa(a,b,f)|0;f=MNa(c[a+8>>2]|0,d)|0;i=e;return f|0}function QNa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0;g=i;i=i+16|0;h=g;j=xfb(d<<2)|0;if((j|0)==0){cb(120376,120264,784,120408)}k=h;c[h>>2]=f;c[j>>2]=e;f=(d|0)>1;if(f){h=1;do{l=c[k>>2]|0;m=c[l>>2]|0;c[k>>2]=l+4;c[j+(h<<2)>>2]=m;h=h+1|0;}while((h|0)<(d|0));n=c[j>>2]|0}else{n=e}e=c[n>>2]|0;if((e|0)<(a|0)){cb(120384,120264,795,120408)}h=a+ -1|0;k=c[n+4>>2]|0;m=c[k+(h<<2)>>2]|0;a:do{if(f){l=(h|0)>0;o=n;p=1;q=m;b:while(1){r=c[j+(p<<2)>>2]|0;if((e|0)!=(c[r>>2]|0)){s=14;break}t=c[r+4>>2]|0;if(l){r=0;while(1){u=r+1|0;if((c[k+(r<<2)>>2]|0)!=(c[t+(r<<2)>>2]|0)){s=17;break b}if((u|0)<(h|0)){r=u}else{v=n;break}}}else{v=o}r=(c[t+(h<<2)>>2]|0)+q|0;u=c[v>>2]|0;if((u|0)>(a|0)){w=c[v+4>>2]|0;x=a;while(1){y=x+1|0;if((c[w+(x<<2)>>2]|0)!=(c[t+(x<<2)>>2]|0)){s=22;break b}if((y|0)<(u|0)){x=y}else{break}}}x=p+1|0;if((x|0)<(d|0)){o=v;p=x;q=r}else{z=u;A=v;B=r;break a}}if((s|0)==14){cb(120432,120264,798,120408)}else if((s|0)==17){cb(120472,120264,800,120408)}else if((s|0)==22){cb(120472,120264,804,120408)}}else{z=e;A=n;B=m}}while(0);if((h|0)>0){m=c[A+4>>2]|0;n=0;e=1;while(1){s=fa(c[m+(n<<2)>>2]|0,e)|0;v=n+1|0;if((v|0)<(h|0)){e=s;n=v}else{C=s;break}}}else{C=1}n=A;if((z|0)>(a|0)){e=c[A+4>>2]|0;m=a;a=1;while(1){s=fa(c[e+(m<<2)>>2]|0,a)|0;v=m+1|0;if((v|0)<(z|0)){a=s;m=v}else{D=s;break}}}else{D=1}m=b+8|0;c[m>>2]=kNa(fa(fa(C,B)|0,D)|0)|0;a=c[n>>2]|0;n=b;c[n>>2]=a;z=lNa(a)|0;c[b+4>>2]=z;b=c[n>>2]|0;if((b|0)>0){n=c[A+4>>2]|0;A=0;do{c[z+(A<<2)>>2]=c[n+(A<<2)>>2];A=A+1|0;}while((A|0)<(b|0))}c[z+(h<<2)>>2]=B;if((C|0)<=0){yfb(j);i=g;return}B=(d|0)>0;z=0;b=0;while(1){if(B){A=0;n=b;while(1){a=c[j+(A<<2)>>2]|0;e=fa(c[(c[a+4>>2]|0)+(h<<2)>>2]|0,D)|0;if((e|0)>0){s=fa(e,z)|0;v=n;k=0;while(1){E=+HNa(a,k+s|0);LNa(c[m>>2]|0,v,E);f=k+1|0;if((f|0)<(e|0)){k=f;v=v+1|0}else{break}}F=n+e|0}else{F=n}v=A+1|0;if((v|0)<(d|0)){A=v;n=F}else{G=F;break}}}else{G=b}n=z+1|0;if((n|0)<(C|0)){z=n;b=G}else{break}}yfb(j);i=g;return}function RNa(a,b,d){a=+a;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=d+4|0;c[f>>2]=lNa(b)|0;g=kNa(1)|0;c[d+8>>2]=g;c[d>>2]=b;LNa(g,0,a);if((b|0)<=0){i=e;return}g=c[f>>2]|0;f=0;do{c[g+(f<<2)>>2]=1;f=f+1|0;}while((f|0)<(b|0));i=e;return}function SNa(a){a=a|0;var b=0,c=0,d=0.0,e=0.0,f=0,g=0.0,h=0.0,j=0;b=i;if((CMa(a)|0)==0){cb(120520,120264,1502,120544)}c=EMa(a)|0;if((c|0)==0){d=0.0;i=b;return+d}e=+HNa(a,0);if(c>>>0>1){f=1;g=e}else{d=e;i=b;return+d}while(1){e=+HNa(a,f);h=g<e?e:g;j=f+1|0;if(j>>>0<c>>>0){g=h;f=j}else{d=h;break}}i=b;return+d}function TNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=xfb(20)|0;VMa(0,(f|0)!=0|0,120560,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=zfb(e,b)|0;c[f>>2]=a;VMa(0,(a|0)!=0|0,120560,d);i=d;return f|0}function UNa(a){a=a|0;var b=0;b=i;yfb(c[a>>2]|0);yfb(a);i=b;return}function VNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;VMa(0,(c[h>>2]|0)>0|0,120576,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;VMa(0,(g|0)>(b|0)|0,120600,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;VMa(0,(0-f|0)<(b|0)|0,120600,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function WNa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=zfb(c[d>>2]<<1,c[e>>2]|0)|0;VMa(0,(f|0)!=0|0,120560,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=VNa(a,j)|0;h=c[e>>2]|0;bgb(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;yfb(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function XNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){WNa(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;bgb((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function YNa(a){a=a|0;i=i;return c[a+12>>2]|0}function ZNa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;VMa(0,(c[j>>2]|0)>0|0,120576,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;VMa(0,(h|0)>(b|0)|0,120600,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;VMa(0,b>>>31^1,120600,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=VNa(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function _Na(a){a=a|0;i=i;return c[(c[30158]|0)+(a<<2)>>2]|0}function $Na(a){a=a|0;i=i;return c[(c[30160]|0)+(a<<2)>>2]|0}function aOa(a){a=a|0;i=i;return c[(c[30162]|0)+(a<<2)>>2]|0}function bOa(a){a=a|0;i=i;return c[(c[30164]|0)+(a<<2)>>2]|0}function cOa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[30160]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[30162]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[30158]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function dOa(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[30166]|0;e=+eOa(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function eOa(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function fOa(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[30168]|0;e=+eOa(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function gOa(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[30170]|0;e=+eOa(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function hOa(a){a=a|0;i=i;return 0}function iOa(a){a=a|0;var b=0,d=0;b=i;gb(4,(c[30172]|0)+(a<<3)|0)|0;d=(c[30158]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function jOa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[30166]|0;f=e+(a<<3)|0;g=c[30170]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[30164]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[30158]|0)+(a<<2)>>2]|0);e=c[30168]|0;g=e+(a<<3)|0;kOa(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;cOa(a);d=c[30166]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[30158]|0)+(a<<2)>>2]=0;i=b;return}function kOa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(nOa(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function lOa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;gb(4,d|0)|0;e=c[30172]|0;f=c[30166]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function mOa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=zfb(a,8)|0;c[30166]=d;e=zfb(a,8)|0;c[30168]=e;f=zfb(a,8)|0;c[30170]=f;g=zfb(a,8)|0;c[30172]=g;h=zfb(a,4)|0;c[30158]=h;j=zfb(a,4)|0;c[30164]=j;k=a<<2;l=xfb(k)|0;c[30160]=l;m=zfb(a,4)|0;c[30162]=m;dgb(l|0,-1,k|0)|0;if((d|0)==0){cb(120696,120712,393,120728)}if((e|0)==0){cb(120736,120712,394,120728)}if((f|0)==0){cb(120752,120712,395,120728)}if((g|0)==0){cb(120768,120712,396,120728)}if((h|0)==0){cb(120784,120712,397,120728)}if((l|0)==0){cb(120808,120712,398,120728)}if((m|0)==0){cb(120832,120712,399,120728)}if((j|0)==0){cb(120856,120712,400,120728)}else{i=b;return}}function nOa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function oOa(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==1){c[l>>2]=c[b+8>>2];n=l+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];TMa(17,0,o,122536,l);i=e;return}else if((a|0)==3){c[g>>2]=c[b+8>>2];l=g+4|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];TMa(17,0,o,122736,g);i=e;return}else if((a|0)==0){c[m>>2]=c[b+8>>2];g=m+4|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];TMa(17,0,o,122488,m);i=e;return}else if((a|0)==2){c[j>>2]=c[b+8>>2];m=j+4|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];TMa(17,0,o,122640,j);i=e;return}else{j=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=j;j=f+8|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];TMa(17,0,o,122800,f);i=e;return}}function pOa(a){a=a|0;var b=0;b=i;yfb(c[a+12>>2]|0);yfb(c[a+4>>2]|0);yfb(c[a+8>>2]|0);i=b;return}function qOa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[15953]=.5;h[15939]=1.0;h[15976]=.25;h[15951]=2.0;h[15978]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[31914]=A;B=c[d>>2]|0;c[31844]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[31844]=D;if((C|0)<(B|0)){C=D}else{break}}}c[31842]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[15954]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[15954]=F;G=F}else{G=E}D=c[d>>2]|0;c[31844]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[31844]=I;if((H|0)>=(D|0)){break a}E=+h[15954];H=I}}}while(0);D=C+1|0;c[31842]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[15958]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[15923]=0.0;h[15925]=0.0;h[15929]=0.0;h[15986]=0.0;c[31840]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[15923]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[15925]+ +h[B>>3]*F;h[15925]=E;F=+h[I>>3];M=+h[15929]+F*F;h[15929]=M;F=+h[H>>3];h[15986]=+h[15986]+F*F;H=A+1|0;c[31840]=H;F=+h[15923];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[31910]=A;E=G/J;h[15975]=E;C=c[d>>2]|0;c[31844]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[15983]=0.0;h[15985]=0.0;I=c[b>>2]|0;c[31840]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[15952]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[15983]=ba;ca=E+aa*aa;h[15985]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[31840]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[31910]=A;h[15975]=E;h[15925]=Z;h[15929]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[31844]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[31840]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[31840]=A+1;da=+h[15925];ea=+h[15929];ga=+h[15923]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[15974]=K;c[31938]=0;h[15982]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[31938]=C;K=+h[15939]/+V(+ga);h[15954]=K;h[15977]=0.0;h[15979]=0.0;B=c[b>>2]|0;c[31840]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[15977]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[15977]=oa;pa=+h[15979]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[15979]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[15925];L=+h[15923];N=+h[15954];D=D+1|0;la=ma}c[31840]=B+1;ia=+h[15923];ja=pa;ka=oa}N=+h[15953];L=ka*N*ka;h[15970]=L;J=ja*N*ja;h[15971]=J;h[15930]=J+(L+ia*(+h[15986]+ia*N));N=+h[15951];h[127448>>3]=N*ka*ia;h[127456>>3]=N*ja*ia;h[127464>>3]=L-J;h[127472>>3]=ka*ja;la=127480|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[31840]=10;la=c[d>>2]|0;c[31844]=1;if((la|0)>=1){D=1;while(1){h[15970]=0.0;h[15971]=0.0;h[15972]=0.0;A=c[b>>2]|0;c[31840]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[15970]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[15971]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[15972]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[31840]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[15976]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[15970]*+h[15972];h[t+(U+D<<3)>>3]=+h[15971]*+h[15972];J=+h[15970];L=+h[15971];h[t+(P+D<<3)>>3]=+h[15976]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[15953]*+h[15970]*+h[15971];na=D+1|0;c[31844]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[31840]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[31852]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[31840]=B;if((la|0)<(D|0)){la=B}else{break}}}c[31848]=1;la=1;do{D=c[d>>2]|0;c[31856]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[31856]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[31844]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[31844]=D+1}na=c[31914]|0;c[31842]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[15950]=0.0;ma=c[d>>2]|0;c[31844]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[15950]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[31844]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[15950]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[31844]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[15950];Ca=Ca+1|0}c[31844]=ta+1}Ca=B+1|0;c[31842]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[31844]=1;if((A|0)<1){break}else{Ea=1}while(1){h[15950]=0.0;B=c[b>>2]|0;c[31842]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[15950]=N;Ca=na+1|0;c[31842]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[31844]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[31842]=1;if((A|0)>=1){ta=1;while(1){h[15950]=0.0;c[31840]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[15950]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[31840]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[31842]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[31848]=la;}while((la|0)<6);la=c[l>>2]|0;c[31844]=1;h[15950]=0.0;c[31840]=1;L=+h[15953];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[127520+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[127520+(A+ -1<<3)>>3]+L;h[15950]=L;A=A+1|0;}while((A|0)<6);h[15930]=+h[15930]- +h[15940]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[15970]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[15971]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[15972]=O;h[127448>>3]=+h[127448>>3]-J-N*(O+K);h[127480>>3]=+h[127480>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[15970]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[15971]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[15972]=J;h[127456>>3]=+h[127456>>3]-O-N*(K-J);h[127488>>3]=+h[127488>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[15970]=J;h[127464>>3]=+h[127536>>3]+(+h[127464>>3]-J- +h[127528>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[15970]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[15971]=K;Oa=+h[15953];h[127472>>3]=+h[127472>>3]-J-K*Oa;h[127496>>3]=+h[127496>>3]- +h[127544>>3]+ +h[127552>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[15970]=K;h[127504>>3]=+h[127504>>3]-Oa*K;h[15950]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[31844]=la+1;c[31840]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[127520+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[127520+(ta+ -1<<3)>>3]+N;h[15950]=N;ta=ta+1|0;c[31840]=ta;}while((ta|0)<6);K=+h[15958];h[15960]=K*+h[15930]+ +h[15940]+N;J=+h[15951];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[15970]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[15971]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[15972]=R;T=R+(K*+h[127448>>3]+O+S);h[127688>>3]=T;O=K*+h[127480>>3]+S-R;h[127720>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[15970]=R;S=+h[I>>3]*+h[ma>>3];h[15971]=S;Z=+h[Ma>>3]*+h[Na>>3];h[15972]=Z;h[127696>>3]=K*+h[127456>>3]+R+S-Z;h[127728>>3]=K*+h[127488>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[15970]=Z;R=+h[127528>>3]+(Z+K*+h[127464>>3])- +h[127536>>3];h[127704>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[15970]=Z;h[127712>>3]=Z+K*+h[127472>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[127496>>3]+ +h[127544>>3]- +h[127552>>3];h[127736>>3]=J;h[127744>>3]=+h[15958]*+h[127504>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[15960]+T+R+O+J;h[15950]=K;h[15980]=K;h[15981]=K;c[31946]=0;J=+h[15978]/50.0;h[15954]=J;h[15940]=+h[15939];c[31840]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[127528>>3]=Z;W=+Y(+Pa);h[127536>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[127520+(Ma+ -1<<3)>>3]=Z;Q=+h[127528>>3]*G+ +h[127536>>3]*W;h[127520+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[127536>>3];ca=+h[127528>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[127680+(Ma<<3)>>3]*+h[127520+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[15981]=Ra;c[31946]=Na;h[15970]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[15971]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[31842]=10;h[15950]=Ra;h[15959]=Pa;h[15984]=O;c[31840]=50;if((Xa|0)==49){h[15971]=K;Ya=Wa;Za=K}else if((Xa|0)==0){h[15970]=Ra;Ya=Ra;Za=Va}else{Ya=Wa;Za=Va}h[15956]=0.0;if(Ya!=Za){S=Ya-Ua;h[15970]=S;T=Za-Ua;h[15971]=T;R=+h[15953]*(S-T)/(S+T);h[15956]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[15959]=R;T=+X(+R);h[127528>>3]=T;S=+Y(+R);h[127536>>3]=S;c[31842]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[127520+(Na+ -1<<3)>>3]=T;W=+h[127528>>3]*G+ +h[127536>>3]*S;h[127520+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[127536>>3];N=+h[127528>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[15981]=0.0;c[31842]=1;Na=1;do{ma=Na+ -1|0;Ma=127520+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[127440+(ma<<3)>>3]*+h[Ma>>3];h[15981]=+h[15981]+ +h[127680+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[31842]=10;Na=c[l>>2]|0;c[31844]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[127520+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[31842]=6;c[31844]=Na+1}h[15949]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[15923]=0.0;h[15970]=0.0;h[15971]=0.0;Ma=c[b>>2]|0;c[31840]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[127528>>3]*+h[la>>3]+ +h[127536>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[15923]=+h[15923]+G*G;bb=+h[15970]+ +h[la>>3]*+h[ta>>3];h[15970]=bb;G=+h[ta>>3];cb=+h[15971]+G*G;h[15971]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[31840]=Ma+1;$a=cb;ab=bb}ma=c[31938]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[15982];S=+h[15980];h[15982]=G>=S?G:S}S=+h[15981];if(!(S>=0.0)){db=-S}else{db=S}G=+h[15982];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[15982]=S;c[31840]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[15954]=N;R=+h[15949]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[15958];la=ta+1|0;c[31840]=la;if((ta|0)>=(Na|0)){break b}S=+h[15971];G=+h[15970];ta=la}}}while(0);Na=c[d>>2]|0;c[31844]=1;if((Na|0)>=1){Ma=1;while(1){h[15950]=0.0;ta=c[b>>2]|0;c[31842]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[15950]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[31842]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[15949]*+h[p+(la+ -1+Ma<<3)>>3]- +h[15958]*+h[q+(Ma+ -1<<3)>>3]);h[15954]=G;c[31840]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[15954];I=I+1|0}c[31840]=la+1}I=Ma+1|0;c[31844]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[15929]=0.0;h[15925]=0.0;Ma=c[b>>2]|0;c[31840]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[15929]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[15925]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[31840]=Ma+1;hb=kb;ib=jb}S=+h[15923];G=S*ib-hb*hb;h[15974]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[127416]=1;C=c[l>>2]|0;c[31844]=1;if((C|0)<1){lb=127512;mb=+h[15939];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[127520+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[31842]=6;c[31844]=C+1;lb=127512;mb=+h[15939];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}



function wda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5176>>3]=0.0;i=i;return}function xda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5200>>3]=0.0;i=i;return}function yda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5192>>3]=0.0;i=i;return}function zda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5184>>3]=255.0;i=i;return}function Ada(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5224>>3]=0.0;i=i;return}function Bda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5216>>3]=0.0;i=i;return}function Cda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5208>>3]=255.0;i=i;return}function Dda(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+384>>2]=255;i=i;return}function Eda(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+388>>2]=0;i=i;return}function Fda(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+392>>2]=0;i=i;return}function Gda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9192>>3]=0.0;i=i;return}function Hda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9200>>3]=0.0;i=i;return}function Ida(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9208>>3]=0.0;i=i;return}function Jda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9216>>3]=0.0;i=i;return}function Kda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9224>>3]=0.0;i=i;return}function Lda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9232>>3]=0.0;i=i;return}function Mda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5232>>3]=0.0;i=i;return}function Nda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5240>>3]=0.0;i=i;return}function Oda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5248>>3]=0.0;i=i;return}function Pda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5256>>3]=0.0;i=i;return}function Qda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5264>>3]=0.0;i=i;return}function Rda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5272>>3]=0.0;i=i;return}function Sda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9256>>3]=0.0;i=i;return}function Tda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9264>>3]=0.0;i=i;return}function Uda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9272>>3]=0.0;i=i;return}function Vda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9280>>3]=0.0;i=i;return}function Wda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9288>>3]=0.0;i=i;return}function Xda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9296>>3]=0.0;i=i;return}function Yda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9360>>3]=0.0;i=i;return}function Zda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9440>>3]=0.0;i=i;return}function _da(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9520>>3]=0.0;i=i;return}function $da(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9600>>3]=0.0;i=i;return}function aea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9680>>3]=0.0;i=i;return}function bea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9760>>3]=0.0;i=i;return}function cea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5296>>3]=0.0;i=i;return}function dea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5288>>3]=0.0;i=i;return}function eea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5280>>3]=0.0;i=i;return}function fea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5320>>3]=0.0;i=i;return}function gea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5312>>3]=0.0;i=i;return}function hea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5304>>3]=0.0;i=i;return}function iea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5344>>3]=0.0;i=i;return}function jea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5336>>3]=0.0;i=i;return}function kea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5328>>3]=0.0;i=i;return}function lea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5368>>3]=0.0;i=i;return}function mea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5360>>3]=0.0;i=i;return}function nea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5352>>3]=0.0;i=i;return}function oea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5432>>3]=0.0;i=i;return}function pea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5416>>3]=0.0;i=i;return}function qea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5408>>3]=1.0;i=i;return}function rea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5400>>3]=0.0;i=i;return}function sea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5384>>3]=0.0;i=i;return}function tea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5448>>3]=0.0;i=i;return}function uea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5456>>3]=0.0;i=i;return}function vea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5464>>3]=0.0;i=i;return}function wea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5472>>3]=0.0;i=i;return}function xea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5480>>3]=1.0;i=i;return}function yea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5488>>3]=0.0;i=i;return}function zea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5496>>3]=0.0;i=i;return}function Aea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5504>>3]=0.0;i=i;return}function Bea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5512>>3]=0.0;i=i;return}function Cea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5536>>3]=1.0;i=i;return}function Dea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5544>>3]=0.0;i=i;return}function Eea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5552>>3]=0.0;i=i;return}function Fea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5560>>3]=0.0;i=i;return}function Gea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5568>>3]=0.0;i=i;return}function Hea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5576>>3]=0.0;i=i;return}function Iea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5584>>3]=0.0;i=i;return}function Jea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5592>>3]=1.0;i=i;return}function Kea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5600>>3]=0.0;i=i;return}function Lea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5608>>3]=0.0;i=i;return}function Mea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5616>>3]=0.0;i=i;return}function Nea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5640>>3]=0.0;i=i;return}function Oea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5664>>3]=0.0;i=i;return}function Pea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5672>>3]=0.0;i=i;return}function Qea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5688>>3]=0.0;i=i;return}function Rea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5704>>3]=0.0;i=i;return}function Sea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5712>>3]=1.0;i=i;return}function Tea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5720>>3]=0.0;i=i;return}function Uea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5736>>3]=0.0;i=i;return}function Vea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5752>>3]=0.0;i=i;return}function Wea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5760>>3]=0.0;i=i;return}function Xea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5768>>3]=1.0;i=i;return}function Yea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5776>>3]=0.0;i=i;return}function Zea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5784>>3]=0.0;i=i;return}function _ea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5792>>3]=0.0;i=i;return}function $ea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5816>>3]=0.0;i=i;return}function afa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5840>>3]=0.0;i=i;return}function bfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5848>>3]=0.0;i=i;return}function cfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5864>>3]=0.0;i=i;return}function dfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5880>>3]=0.0;i=i;return}function efa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5888>>3]=1.0;i=i;return}function ffa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5896>>3]=0.0;i=i;return}function gfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5912>>3]=0.0;i=i;return}function hfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5928>>3]=0.0;i=i;return}function ifa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5936>>3]=0.0;i=i;return}function jfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5944>>3]=0.0;i=i;return}function kfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5952>>3]=0.0;i=i;return}function lfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5960>>3]=0.0;i=i;return}function mfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5968>>3]=0.0;i=i;return}function nfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5976>>3]=0.0;i=i;return}function ofa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5984>>3]=0.0;i=i;return}function pfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5992>>3]=0.0;i=i;return}function qfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6e3>>3]=0.0;i=i;return}function rfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6008>>3]=0.0;i=i;return}function sfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6016>>3]=0.0;i=i;return}function tfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6024>>3]=0.0;i=i;return}function ufa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6032>>3]=0.0;i=i;return}function vfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6040>>3]=0.0;i=i;return}function wfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6048>>3]=0.0;i=i;return}function xfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9800>>3]=0.0;i=i;return}function yfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9808>>3]=0.0;i=i;return}function zfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9816>>3]=0.0;i=i;return}function Afa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9824>>3]=0.0;i=i;return}function Bfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9832>>3]=0.0;i=i;return}function Cfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9840>>3]=0.0;i=i;return}function Dfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9848>>3]=0.0;i=i;return}function Efa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9856>>3]=0.0;i=i;return}function Ffa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9864>>3]=0.0;i=i;return}function Gfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9872>>3]=0.0;i=i;return}function Hfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9880>>3]=0.0;i=i;return}function Ifa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9888>>3]=0.0;i=i;return}function Jfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9896>>3]=0.0;i=i;return}function Kfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9904>>3]=0.0;i=i;return}function Lfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9912>>3]=0.0;i=i;return}function Mfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9920>>3]=0.0;i=i;return}function Nfa(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+22|0]=0;i=i;return}function Ofa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9936>>3]=0.0;i=i;return}function Pfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9944>>3]=0.0;i=i;return}function Qfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9952>>3]=0.0;i=i;return}function Rfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9960>>3]=0.0;i=i;return}function Sfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9968>>3]=0.0;i=i;return}function Tfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9976>>3]=0.0;i=i;return}function Ufa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9984>>3]=0.0;i=i;return}function Vfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9992>>3]=0.0;i=i;return}function Wfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1e4>>3]=0.0;i=i;return}function Xfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10008>>3]=0.0;i=i;return}function Yfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10016>>3]=0.0;i=i;return}function Zfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10024>>3]=0.0;i=i;return}function _fa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10032>>3]=0.0;i=i;return}function $fa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10040>>3]=0.0;i=i;return}function aga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10048>>3]=0.0;i=i;return}function bga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10056>>3]=0.0;i=i;return}function cga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10064>>3]=0.0;i=i;return}function dga(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+23|0]=0;i=i;return}function ega(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10080>>3]=0.0;i=i;return}function fga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10088>>3]=0.0;i=i;return}function gga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10096>>3]=0.0;i=i;return}function hga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10104>>3]=0.0;i=i;return}function iga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10112>>3]=0.0;i=i;return}function jga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10120>>3]=0.0;i=i;return}function kga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10128>>3]=0.0;i=i;return}function lga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10136>>3]=0.0;i=i;return}function mga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10144>>3]=0.0;i=i;return}function nga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10152>>3]=0.0;i=i;return}function oga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10160>>3]=0.0;i=i;return}function pga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10168>>3]=0.0;i=i;return}function qga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10176>>3]=0.0;i=i;return}function rga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10184>>3]=0.0;i=i;return}function sga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10192>>3]=0.0;i=i;return}function tga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10200>>3]=0.0;i=i;return}function uga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10208>>3]=0.0;i=i;return}function vga(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+24|0]=0;i=i;return}function wga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10224>>3]=0.0;i=i;return}function xga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10232>>3]=0.0;i=i;return}function yga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10240>>3]=0.0;i=i;return}function zga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10248>>3]=0.0;i=i;return}function Aga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10256>>3]=0.0;i=i;return}function Bga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10264>>3]=0.0;i=i;return}function Cga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10272>>3]=0.0;i=i;return}function Dga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10280>>3]=0.0;i=i;return}function Ega(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10288>>3]=0.0;i=i;return}function Fga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10296>>3]=0.0;i=i;return}function Gga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10304>>3]=0.0;i=i;return}function Hga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10312>>3]=0.0;i=i;return}function Iga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10320>>3]=0.0;i=i;return}function Jga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10328>>3]=0.0;i=i;return}function Kga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10336>>3]=0.0;i=i;return}function Lga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10344>>3]=0.0;i=i;return}function Mga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10352>>3]=0.0;i=i;return}function Nga(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+25|0]=0;i=i;return}function Oga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10368>>3]=0.0;i=i;return}function Pga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10376>>3]=0.0;i=i;return}function Qga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10384>>3]=0.0;i=i;return}function Rga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10392>>3]=0.0;i=i;return}function Sga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10400>>3]=0.0;i=i;return}function Tga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10408>>3]=0.0;i=i;return}function Uga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10416>>3]=0.0;i=i;return}function Vga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10424>>3]=0.0;i=i;return}function Wga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10432>>3]=0.0;i=i;return}function Xga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10440>>3]=0.0;i=i;return}function Yga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10448>>3]=0.0;i=i;return}function Zga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10456>>3]=0.0;i=i;return}function _ga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10464>>3]=0.0;i=i;return}function $ga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10472>>3]=0.0;i=i;return}function aha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10480>>3]=0.0;i=i;return}function bha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10488>>3]=0.0;i=i;return}function cha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10496>>3]=0.0;i=i;return}function dha(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+26|0]=0;i=i;return}function eha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10512>>3]=0.0;i=i;return}function fha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10520>>3]=0.0;i=i;return}function gha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10528>>3]=0.0;i=i;return}function hha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10536>>3]=0.0;i=i;return}function iha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10544>>3]=0.0;i=i;return}function jha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10552>>3]=0.0;i=i;return}function kha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10560>>3]=0.0;i=i;return}function lha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10568>>3]=0.0;i=i;return}function mha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10576>>3]=0.0;i=i;return}function nha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10584>>3]=0.0;i=i;return}function oha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10592>>3]=0.0;i=i;return}function pha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10600>>3]=0.0;i=i;return}function qha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10608>>3]=0.0;i=i;return}function rha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10616>>3]=0.0;i=i;return}function sha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10624>>3]=0.0;i=i;return}function tha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10632>>3]=0.0;i=i;return}function uha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10640>>3]=0.0;i=i;return}function vha(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+27|0]=0;i=i;return}function wha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10656>>3]=0.0;i=i;return}function xha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6152>>3]=0.0;i=i;return}function yha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6160>>3]=0.0;i=i;return}function zha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6168>>3]=0.0;i=i;return}function Aha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6176>>3]=0.0;i=i;return}function Bha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6184>>3]=0.0;i=i;return}function Cha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6192>>3]=0.0;i=i;return}function Dha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6200>>3]=0.0;i=i;return}function Eha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6208>>3]=0.0;i=i;return}function Fha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6216>>3]=0.0;i=i;return}function Gha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6224>>3]=1.0;i=i;return}function Hha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6248>>3]=0.0;i=i;return}function Iha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6272>>3]=0.0;i=i;return}function Jha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6232>>3]=0.0;i=i;return}function Kha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6256>>3]=1.0;i=i;return}function Lha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6280>>3]=0.0;i=i;return}function Mha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6240>>3]=0.0;i=i;return}function Nha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6264>>3]=0.0;i=i;return}function Oha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6288>>3]=1.0;i=i;return}function Pha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6296>>3]=0.0;i=i;return}function Qha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6304>>3]=0.0;i=i;return}function Rha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6312>>3]=0.0;i=i;return}function Sha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10664>>3]=0.0;i=i;return}function Tha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10672>>3]=0.0;i=i;return}function Uha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10680>>3]=0.0;i=i;return}function Vha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10688>>3]=0.0;i=i;return}function Wha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10696>>3]=0.0;i=i;return}function Xha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10704>>3]=0.0;i=i;return}function Yha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10712>>3]=0.0;i=i;return}function Zha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10720>>3]=0.0;i=i;return}function _ha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10728>>3]=0.0;i=i;return}function $ha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10736>>3]=0.0;i=i;return}function aia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10744>>3]=0.0;i=i;return}function bia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10752>>3]=0.0;i=i;return}function cia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10760>>3]=0.0;i=i;return}function dia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10768>>3]=0.0;i=i;return}function eia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10776>>3]=0.0;i=i;return}function fia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10784>>3]=0.0;i=i;return}function gia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10792>>3]=0.0;i=i;return}function hia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10800>>3]=0.0;i=i;return}function iia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10808>>3]=0.0;i=i;return}function jia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10816>>3]=0.0;i=i;return}function kia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10824>>3]=0.0;i=i;return}function lia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10832>>3]=0.0;i=i;return}function mia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10840>>3]=0.0;i=i;return}function nia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10848>>3]=0.0;i=i;return}function oia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10856>>3]=0.0;i=i;return}function pia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10864>>3]=0.0;i=i;return}function qia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10872>>3]=0.0;i=i;return}function ria(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10880>>3]=0.0;i=i;return}function sia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10888>>3]=0.0;i=i;return}function tia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10896>>3]=0.0;i=i;return}function uia(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d]=a[d+5|0]|0;i=i;return}function via(b){b=b|0;var d=0,e=0;d=c[b+424>>2]|0;if((a[d]|0)==0){e=0}else{e=(a[d+1|0]|0)!=0|0}c[(c[b+420>>2]|0)+388>>2]=e;i=i;return}function wia(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+424>>2]|0;do{if((a[e]|0)==0){f=0}else{if((a[e+1|0]|0)==0){f=0;break}f=(a[e+4|0]|0)!=0|0}}while(0);c[(c[b+420>>2]|0)+392>>2]=f;i=d;return}function xia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6792>>3]=+h[b+6744>>3]*.5;i=i;return}function yia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6800>>3]=+h[b+6744>>3]*.2;i=i;return}function zia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6808>>3]=+h[b+6744>>3]*.1;i=i;return}function Aia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6816>>3]=+h[b+6744>>3]*.05;i=i;return}function Bia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6824>>3]=+h[b+6744>>3]*.1;i=i;return}function Cia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6832>>3]=+h[b+6744>>3]*.05;i=i;return}function Dia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6840>>3]=+h[b+6744>>3]/9.0;i=i;return}function Eia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6848>>3]=+h[b+6744>>3]*.025;i=i;return}function Fia(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6760>>3];j=+h[f+6792>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,19712,19704,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+6856>>3]=l;i=d;return}function Gia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6864>>3]=+h[b+6792>>3]*.5;i=i;return}function Hia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6872>>3]=+h[b+6792>>3]*1.05;i=i;return}function Iia(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+6880>>3]=+sd(+(+h[d+6792>>3]),+(+h[d+6856>>3]*5.0));i=b;return}function Jia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6888>>3]=+h[b+6856>>3]*3.0;i=i;return}function Kia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6896>>3]=+h[b+6856>>3];i=i;return}function Lia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6904>>3]=+h[b+6856>>3]*3.0;i=i;return}function Mia(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+6864>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,19768,19760,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+6912>>3]=l;i=d;return}function Nia(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+6920>>3]=+td(0.0,+(+h[d+6792>>3]- +h[d+6880>>3]));i=b;return}function Oia(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+6928>>3]=+sd(+(+h[d+6864>>3]),+(+h[d+6912>>3]*4.0));i=b;return}function Pia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6936>>3]=+h[b+6912>>3]*3.0;i=i;return}function Qia(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+6944>>3]=+td(0.0,+(+h[d+6864>>3]- +h[d+6928>>3]));i=b;return}function Ria(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6952>>3]=+h[b+6448>>3];i=i;return}function Sia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+168>>3]=+h[b>>3];i=i;return}function Tia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+176>>3]=+h[b+8>>3];i=i;return}function Uia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+184>>3]=+h[b+16>>3];i=i;return}function Via(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6960>>3]=+h[b+6456>>3];i=i;return}function Wia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6720>>3]=+h[b+6960>>3];i=i;return}function Xia(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+7|0]=a[d+5|0]|0;i=i;return}function Yia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6976>>3]=+h[b+6808>>3];i=i;return}function Zia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3176>>3]=+h[(c[a+416>>2]|0)+6976>>3]*-.5;i=i;return}function _ia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6984>>3]=+h[b+6816>>3];i=i;return}function $ia(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+9|0]=a[d+5|0]|0;i=i;return}function aja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7e3>>3]=+h[b+6808>>3];i=i;return}function bja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3264>>3]=+h[(c[a+416>>2]|0)+7e3>>3]*-.5;i=i;return}function cja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7008>>3]=+h[b+6816>>3];i=i;return}function dja(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+11|0]=a[d+5|0]|0;i=i;return}function eja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7024>>3]=+h[b+6808>>3];i=i;return}function fja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3360>>3]=+h[(c[a+416>>2]|0)+7024>>3]*-.5;i=i;return}function gja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7032>>3]=+h[b+6816>>3];i=i;return}function hja(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+13|0]=a[d+5|0]|0;i=i;return}function ija(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7048>>3]=+h[b+6808>>3];i=i;return}function jja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3464>>3]=+h[(c[a+416>>2]|0)+7048>>3]*-.5;i=i;return}function kja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7056>>3]=+h[b+6816>>3];i=i;return}function lja(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+15|0]=a[d+5|0]|0;i=i;return}function mja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7072>>3]=+h[b+6808>>3];i=i;return}function nja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3552>>3]=+h[(c[a+416>>2]|0)+7072>>3]*-.5;i=i;return}function oja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7080>>3]=+h[b+6816>>3];i=i;return}function pja(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+17|0]=a[d+5|0]|0;i=i;return}function qja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7096>>3]=+h[b+6808>>3];i=i;return}function rja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3656>>3]=+h[(c[a+416>>2]|0)+7096>>3]*-.5;i=i;return}function sja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7104>>3]=+h[b+6816>>3];i=i;return}function tja(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+18|0]=a[d+5|0]|0;i=i;return}function uja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+648>>3]=+h[b+480>>3];i=i;return}function vja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+656>>3]=+h[b+488>>3];i=i;return}function wja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+664>>3]=+h[b+496>>3];i=i;return}function xja(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+648>>3]- +h[b+672>>3];e=+h[b+656>>3]- +h[b+680>>3];f=+h[b+664>>3]- +h[b+688>>3];h[b+7184>>3]=+V(+(d*d+e*e+f*f));i=i;return}function yja(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+7184>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,19768,19808,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+7192>>3]=l;i=d;return}function zja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7200>>3]=+h[b+7192>>3];i=i;return}function Aja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+768>>3]=+h[b+504>>3];i=i;return}function Bja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+776>>3]=+h[b+512>>3];i=i;return}function Cja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+784>>3]=+h[b+520>>3];i=i;return}function Dja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7216>>3]=+h[b+7112>>3];i=i;return}function Eja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3032>>3]=+h[b+6720>>3]*+h[b+7216>>3];i=i;return}function Fja(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3e3>>3]=-(+h[(c[a+416>>2]|0)+784>>3]*+h[b+3032>>3]);i=i;return}function Gja(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3016>>3]=+h[(c[a+416>>2]|0)+768>>3]*+h[b+3032>>3];i=i;return}function Hja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7224>>3]=+h[b+7120>>3];i=i;return}function Ija(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7232>>3]=+h[b+7128>>3];i=i;return}function Jja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7240>>3]=+h[b+7136>>3];i=i;return}function Kja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7248>>3]=+h[b+7144>>3];i=i;return}function Lja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7256>>3]=+h[b+7152>>3];i=i;return}function Mja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7264>>3]=+h[b+7160>>3];i=i;return}function Nja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+792>>3]=+h[b+528>>3];i=i;return}function Oja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+800>>3]=+h[b+536>>3];i=i;return}function Pja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+808>>3]=+h[b+544>>3];i=i;return}function Qja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+816>>3]=+h[b+552>>3];i=i;return}function Rja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+824>>3]=+h[b+560>>3];i=i;return}function Sja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+832>>3]=+h[b+568>>3];i=i;return}function Tja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+840>>3]=+h[b+576>>3];i=i;return}function Uja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+848>>3]=+h[b+584>>3];i=i;return}function Vja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+856>>3]=+h[b+592>>3];i=i;return}function Wja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+864>>3]=+h[b+792>>3];i=i;return}function Xja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+872>>3]=+h[b+800>>3];i=i;return}function Yja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+880>>3]=+h[b+808>>3];i=i;return}function Zja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7272>>3]=+h[b+6840>>3];i=i;return}function _ja(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,0);h[(c[a+416>>2]|0)+1080>>3]=l;i=b;return}function $ja(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,1);h[(c[a+416>>2]|0)+1088>>3]=l;i=b;return}function aka(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,2);h[(c[a+416>>2]|0)+1096>>3]=l;i=b;return}function bka(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,3);h[(c[a+416>>2]|0)+1104>>3]=l;i=b;return}function cka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7280>>3]=+h[b+7272>>3]/3.0;i=i;return}function dka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7304>>3]=+h[b+7288>>3]*2.0;i=i;return}function eka(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+40>>2]=c[b+32>>2];i=i;return}function fka(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+32|0]=a[d+5|0]|0;i=i;return}function gka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1280>>3]=+h[b+1112>>3];i=i;return}function hka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1288>>3]=+h[b+1120>>3];i=i;return}function ika(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3152>>3]=+h[b+656>>3]+ +h[b+1288>>3];i=i;return}function jka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1296>>3]=+h[b+1128>>3];i=i;return}function kka(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+1280>>3]- +h[b+1304>>3];e=+h[b+1288>>3]- +h[b+1312>>3];f=+h[b+1296>>3]- +h[b+1320>>3];h[b+7384>>3]=+V(+(d*d+e*e+f*f));i=i;return}function lka(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+7384>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,19768,19848,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+7392>>3]=l;i=d;return}function mka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7400>>3]=+h[b+7392>>3];i=i;return}function nka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1400>>3]=+h[b+1136>>3];i=i;return}function oka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1408>>3]=+h[b+1144>>3];i=i;return}function pka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1416>>3]=+h[b+1152>>3];i=i;return}function qka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7416>>3]=+h[b+7312>>3];i=i;return}function rka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2872>>3]=+h[b+6720>>3]*+h[b+7416>>3];i=i;return}function ska(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7424>>3]=+h[b+7320>>3];i=i;return}function tka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7432>>3]=+h[b+7328>>3];i=i;return}function uka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7440>>3]=+h[b+7336>>3];i=i;return}function vka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7448>>3]=+h[b+7344>>3];i=i;return}function wka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7456>>3]=+h[b+7352>>3];i=i;return}function xka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7464>>3]=+h[b+7360>>3];i=i;return}function yka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1424>>3]=+h[b+1160>>3];i=i;return}function zka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1432>>3]=+h[b+1168>>3];i=i;return}function Aka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1440>>3]=+h[b+1176>>3];i=i;return}function Bka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1448>>3]=+h[b+1184>>3];i=i;return}function Cka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1456>>3]=+h[b+1192>>3];i=i;return}function Dka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1464>>3]=+h[b+1200>>3];i=i;return}function Eka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1472>>3]=+h[b+1208>>3];i=i;return}function Fka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1480>>3]=+h[b+1216>>3];i=i;return}function Gka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1488>>3]=+h[b+1224>>3];i=i;return}function Hka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1496>>3]=+h[b+1424>>3];i=i;return}function Ika(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1504>>3]=+h[b+1432>>3];i=i;return}function Jka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1512>>3]=+h[b+1440>>3];i=i;return}function Kka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7472>>3]=+h[b+6840>>3];i=i;return}function Lka(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,0);h[(c[a+416>>2]|0)+1712>>3]=l;i=b;return}function Mka(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,1);h[(c[a+416>>2]|0)+1720>>3]=l;i=b;return}function Nka(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,2);h[(c[a+416>>2]|0)+1728>>3]=l;i=b;return}function Oka(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,3);h[(c[a+416>>2]|0)+1736>>3]=l;i=b;return}function Pka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7480>>3]=+h[b+7472>>3]/3.0;i=i;return}function Qka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7504>>3]=+h[b+7488>>3]*2.0;i=i;return}function Rka(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+52>>2]=c[b+44>>2];i=i;return}function Ska(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+46|0]=a[d+5|0]|0;i=i;return}function Tka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1912>>3]=+h[b+1744>>3];i=i;return}function Uka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1920>>3]=+h[b+1752>>3];i=i;return}function Vka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1928>>3]=+h[b+1760>>3];i=i;return}function Wka(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+1912>>3]- +h[b+1936>>3];e=+h[b+1920>>3]- +h[b+1944>>3];f=+h[b+1928>>3]- +h[b+1952>>3];h[b+7584>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Xka(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+7584>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,19768,19856,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+7592>>3]=l;i=d;return}function Yka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7600>>3]=+h[b+7592>>3];i=i;return}function Zka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2032>>3]=+h[b+1768>>3];i=i;return}function _ka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2040>>3]=+h[b+1776>>3];i=i;return}function $ka(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2048>>3]=+h[b+1784>>3];i=i;return}function ala(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7616>>3]=+h[b+7512>>3];i=i;return}function bla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7624>>3]=+h[b+7520>>3];i=i;return}function cla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7632>>3]=+h[b+7528>>3];i=i;return}function dla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7640>>3]=+h[b+7536>>3];i=i;return}function ela(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7648>>3]=+h[b+7544>>3];i=i;return}function fla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7656>>3]=+h[b+7552>>3];i=i;return}function gla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7664>>3]=+h[b+7560>>3];i=i;return}function hla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2056>>3]=+h[b+1792>>3];i=i;return}function ila(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2064>>3]=+h[b+1800>>3];i=i;return}function jla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2072>>3]=+h[b+1808>>3];i=i;return}function kla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2080>>3]=+h[b+1816>>3];i=i;return}function lla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2088>>3]=+h[b+1824>>3];i=i;return}function mla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2096>>3]=+h[b+1832>>3];i=i;return}function nla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2104>>3]=+h[b+1840>>3];i=i;return}function ola(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2112>>3]=+h[b+1848>>3];i=i;return}function pla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2120>>3]=+h[b+1856>>3];i=i;return}function qla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2128>>3]=+h[b+2056>>3];i=i;return}function rla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2136>>3]=+h[b+2064>>3];i=i;return}function sla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2144>>3]=+h[b+2072>>3];i=i;return}function tla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7672>>3]=+h[b+6840>>3];i=i;return}function ula(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,0);h[(c[a+416>>2]|0)+2344>>3]=l;i=b;return}function vla(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,1);h[(c[a+416>>2]|0)+2352>>3]=l;i=b;return}function wla(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,2);h[(c[a+416>>2]|0)+2360>>3]=l;i=b;return}function xla(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,3);h[(c[a+416>>2]|0)+2368>>3]=l;i=b;return}function yla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7680>>3]=+h[b+7672>>3]/3.0;i=i;return}function zla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7704>>3]=+h[b+7688>>3]*2.0;i=i;return}function Ala(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+64>>2]=c[b+56>>2];i=i;return}function Bla(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+60|0]=a[d+5|0]|0;i=i;return}function Cla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2544>>3]=+h[b+2376>>3];i=i;return}function Dla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2552>>3]=+h[b+2384>>3];i=i;return}function Ela(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2560>>3]=+h[b+2392>>3];i=i;return}function Fla(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+2544>>3]- +h[b+2568>>3];e=+h[b+2552>>3]- +h[b+2576>>3];f=+h[b+2560>>3]- +h[b+2584>>3];h[b+7784>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Gla(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+7784>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,19768,19864,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+7792>>3]=l;i=d;return}function Hla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7800>>3]=+h[b+7792>>3];i=i;return}function Ila(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2664>>3]=+h[b+2400>>3];i=i;return}function Jla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2672>>3]=+h[b+2408>>3];i=i;return}function Kla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2680>>3]=+h[b+2416>>3];i=i;return}function Lla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7816>>3]=+h[b+7712>>3];i=i;return}function Mla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7824>>3]=+h[b+7720>>3];i=i;return}function Nla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7832>>3]=+h[b+7728>>3];i=i;return}function Ola(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7840>>3]=+h[b+7736>>3];i=i;return}function Pla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7848>>3]=+h[b+7744>>3];i=i;return}function Qla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7856>>3]=+h[b+7752>>3];i=i;return}function Rla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7864>>3]=+h[b+7760>>3];i=i;return}function Sla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2688>>3]=+h[b+2424>>3];i=i;return}function Tla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2696>>3]=+h[b+2432>>3];i=i;return}function Ula(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2704>>3]=+h[b+2440>>3];i=i;return}function Vla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2712>>3]=+h[b+2448>>3];i=i;return}function Wla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2720>>3]=+h[b+2456>>3];i=i;return}function Xla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2728>>3]=+h[b+2464>>3];i=i;return}function Yla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2736>>3]=+h[b+2472>>3];i=i;return}function Zla(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2744>>3]=+h[b+2480>>3];i=i;return}function _la(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2752>>3]=+h[b+2488>>3];i=i;return}function $la(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2760>>3]=+h[b+2688>>3];i=i;return}function ama(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2768>>3]=+h[b+2696>>3];i=i;return}function bma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2776>>3]=+h[b+2704>>3];i=i;return}function cma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7872>>3]=+h[b+6840>>3];i=i;return}function dma(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,0);h[(c[a+416>>2]|0)+2976>>3]=l;i=b;return}function ema(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,1);h[(c[a+416>>2]|0)+2984>>3]=l;i=b;return}function fma(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,2);h[(c[a+416>>2]|0)+2992>>3]=l;i=b;return}function gma(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,3);h[(c[a+416>>2]|0)+3e3>>3]=l;i=b;return}function hma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7880>>3]=+h[b+7872>>3]/3.0;i=i;return}function ima(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7904>>3]=+h[b+7888>>3]*2.0;i=i;return}function jma(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+76>>2]=c[b+68>>2];i=i;return}function kma(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+74|0]=a[d+5|0]|0;i=i;return}function lma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3176>>3]=+h[b+3008>>3];i=i;return}function mma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3184>>3]=+h[b+3016>>3];i=i;return}function nma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3192>>3]=+h[b+3024>>3];i=i;return}function oma(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+3176>>3]- +h[b+3200>>3];e=+h[b+3184>>3]- +h[b+3208>>3];f=+h[b+3192>>3]- +h[b+3216>>3];h[b+7984>>3]=+V(+(d*d+e*e+f*f));i=i;return}function pma(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+7984>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,19768,19872,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+7992>>3]=l;i=d;return}function qma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8e3>>3]=+h[b+7992>>3];i=i;return}function rma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3296>>3]=+h[b+3032>>3];i=i;return}function sma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3304>>3]=+h[b+3040>>3];i=i;return}function tma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3312>>3]=+h[b+3048>>3];i=i;return}function uma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8016>>3]=+h[b+7912>>3];i=i;return}function vma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8024>>3]=+h[b+7920>>3];i=i;return}function wma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8032>>3]=+h[b+7928>>3];i=i;return}function xma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8040>>3]=+h[b+7936>>3];i=i;return}function yma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8048>>3]=+h[b+7944>>3];i=i;return}function zma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8056>>3]=+h[b+7952>>3];i=i;return}function Ama(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8064>>3]=+h[b+7960>>3];i=i;return}function Bma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3320>>3]=+h[b+3056>>3];i=i;return}function Cma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3328>>3]=+h[b+3064>>3];i=i;return}function Dma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3336>>3]=+h[b+3072>>3];i=i;return}function Ema(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3344>>3]=+h[b+3080>>3];i=i;return}function Fma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3352>>3]=+h[b+3088>>3];i=i;return}function Gma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3360>>3]=+h[b+3096>>3];i=i;return}function Hma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3368>>3]=+h[b+3104>>3];i=i;return}function Ima(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3376>>3]=+h[b+3112>>3];i=i;return}function Jma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3384>>3]=+h[b+3120>>3];i=i;return}function Kma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3392>>3]=+h[b+3320>>3];i=i;return}function Lma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3400>>3]=+h[b+3328>>3];i=i;return}function Mma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3408>>3]=+h[b+3336>>3];i=i;return}function Nma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8072>>3]=+h[b+6840>>3];i=i;return}function Oma(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,0);h[(c[a+416>>2]|0)+3608>>3]=l;i=b;return}function Pma(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,1);h[(c[a+416>>2]|0)+3616>>3]=l;i=b;return}function Qma(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,2);h[(c[a+416>>2]|0)+3624>>3]=l;i=b;return}function Rma(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,3);h[(c[a+416>>2]|0)+3632>>3]=l;i=b;return}function Sma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8080>>3]=+h[b+8072>>3]/3.0;i=i;return}function Tma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8104>>3]=+h[b+8088>>3]*2.0;i=i;return}function Uma(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+88>>2]=c[b+80>>2];i=i;return}function Vma(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+88|0]=a[d+5|0]|0;i=i;return}function Wma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3808>>3]=+h[b+3640>>3];i=i;return}function Xma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3816>>3]=+h[b+3648>>3];i=i;return}function Yma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3824>>3]=+h[b+3656>>3];i=i;return}function Zma(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+3808>>3]- +h[b+3832>>3];e=+h[b+3816>>3]- +h[b+3840>>3];f=+h[b+3824>>3]- +h[b+3848>>3];h[b+8184>>3]=+V(+(d*d+e*e+f*f));i=i;return}function _ma(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+8184>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,19768,19880,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+8192>>3]=l;i=d;return}function $ma(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8200>>3]=+h[b+8192>>3];i=i;return}function ana(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3928>>3]=+h[b+3664>>3];i=i;return}function bna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3936>>3]=+h[b+3672>>3];i=i;return}function cna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3944>>3]=+h[b+3680>>3];i=i;return}function dna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8216>>3]=+h[b+8112>>3];i=i;return}function ena(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8224>>3]=+h[b+8120>>3];i=i;return}function fna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8232>>3]=+h[b+8128>>3];i=i;return}function gna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8240>>3]=+h[b+8136>>3];i=i;return}function hna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8248>>3]=+h[b+8144>>3];i=i;return}function ina(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8256>>3]=+h[b+8152>>3];i=i;return}function jna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8264>>3]=+h[b+8160>>3];i=i;return}function kna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3952>>3]=+h[b+3688>>3];i=i;return}function lna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3960>>3]=+h[b+3696>>3];i=i;return}function mna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3968>>3]=+h[b+3704>>3];i=i;return}function nna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3976>>3]=+h[b+3712>>3];i=i;return}function ona(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3984>>3]=+h[b+3720>>3];i=i;return}function pna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3992>>3]=+h[b+3728>>3];i=i;return}function qna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4e3>>3]=+h[b+3736>>3];i=i;return}function rna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4008>>3]=+h[b+3744>>3];i=i;return}function sna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4016>>3]=+h[b+3752>>3];i=i;return}function tna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4024>>3]=+h[b+3952>>3];i=i;return}function una(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4032>>3]=+h[b+3960>>3];i=i;return}function vna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4040>>3]=+h[b+3968>>3];i=i;return}function wna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8272>>3]=+h[b+6840>>3];i=i;return}function xna(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,0);h[(c[a+416>>2]|0)+4240>>3]=l;i=b;return}function yna(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,1);h[(c[a+416>>2]|0)+4248>>3]=l;i=b;return}function zna(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,2);h[(c[a+416>>2]|0)+4256>>3]=l;i=b;return}function Ana(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,3);h[(c[a+416>>2]|0)+4264>>3]=l;i=b;return}function Bna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8280>>3]=+h[b+8272>>3]/3.0;i=i;return}function Cna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8304>>3]=+h[b+8288>>3]*2.0;i=i;return}function Dna(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+100>>2]=c[b+92>>2];i=i;return}function Ena(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+102|0]=a[d+5|0]|0;i=i;return}function Fna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4440>>3]=+h[b+4272>>3];i=i;return}function Gna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4448>>3]=+h[b+4280>>3];i=i;return}function Hna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4456>>3]=+h[b+4288>>3];i=i;return}function Ina(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+4440>>3]- +h[b+4464>>3];e=+h[b+4448>>3]- +h[b+4472>>3];f=+h[b+4456>>3]- +h[b+4480>>3];h[b+8384>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Jna(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+8384>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,19768,19888,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+8392>>3]=l;i=d;return}function Kna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8400>>3]=+h[b+8392>>3];i=i;return}function Lna(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+4272>>3]- +h[b+4392>>3];e=+h[b+4280>>3]- +h[b+4400>>3];f=+h[b+4288>>3]- +h[b+4408>>3];h[b+8408>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Mna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4560>>3]=+h[b+4296>>3];i=i;return}function Nna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4568>>3]=+h[b+4304>>3];i=i;return}function Ona(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4576>>3]=+h[b+4312>>3];i=i;return}function Pna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8416>>3]=+h[b+8312>>3];i=i;return}function Qna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8424>>3]=+h[b+8320>>3];i=i;return}function Rna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8432>>3]=+h[b+8328>>3];i=i;return}function Sna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8440>>3]=+h[b+8336>>3];i=i;return}function Tna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8448>>3]=+h[b+8344>>3];i=i;return}function Una(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8456>>3]=+h[b+8352>>3];i=i;return}function Vna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8464>>3]=+h[b+8360>>3];i=i;return}function Wna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4584>>3]=+h[b+4320>>3];i=i;return}function Xna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4592>>3]=+h[b+4328>>3];i=i;return}function Yna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4600>>3]=+h[b+4336>>3];i=i;return}function Zna(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4608>>3]=+h[b+4344>>3];i=i;return}function _na(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4616>>3]=+h[b+4352>>3];i=i;return}function $na(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4624>>3]=+h[b+4360>>3];i=i;return}function aoa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4632>>3]=+h[b+4368>>3];i=i;return}function boa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4640>>3]=+h[b+4376>>3];i=i;return}function coa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4648>>3]=+h[b+4384>>3];i=i;return}function doa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4656>>3]=+h[b+4584>>3];i=i;return}function eoa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4664>>3]=+h[b+4592>>3];i=i;return}function foa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4672>>3]=+h[b+4600>>3];i=i;return}function goa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8472>>3]=+h[b+6840>>3];i=i;return}function hoa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,0);h[(c[a+416>>2]|0)+4872>>3]=l;i=b;return}function ioa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,1);h[(c[a+416>>2]|0)+4880>>3]=l;i=b;return}function joa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,2);h[(c[a+416>>2]|0)+4888>>3]=l;i=b;return}function koa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,3);h[(c[a+416>>2]|0)+4896>>3]=l;i=b;return}function loa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8480>>3]=+h[b+8472>>3]/3.0;i=i;return}function moa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+8408>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,19768,19896,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+8488>>3]=l;i=d;return}function noa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8496>>3]=+h[b+8488>>3];i=i;return}function ooa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8504>>3]=+h[b+8488>>3]*2.0;i=i;return}function poa(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+112>>2]=c[b+104>>2];i=i;return}function qoa(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+116|0]=a[d+5|0]|0;i=i;return}function roa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4928>>3]=+h[b+168>>3];i=i;return}function soa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4936>>3]=+h[b+176>>3];i=i;return}function toa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4944>>3]=+h[b+184>>3];i=i;return}function uoa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8512>>3]=+h[b+6952>>3];i=i;return}function voa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5072>>3]=+h[b+4904>>3];i=i;return}function woa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5080>>3]=+h[b+4912>>3];i=i;return}function xoa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5088>>3]=+h[b+4920>>3];i=i;return}function yoa(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+5072>>3]- +h[b+5096>>3];e=+h[b+5080>>3]- +h[b+5104>>3];f=+h[b+5088>>3]- +h[b+5112>>3];h[b+8584>>3]=+V(+(d*d+e*e+f*f));i=i;return}function zoa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+8584>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,19768,19904,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+8592>>3]=l;i=d;return}function Aoa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8600>>3]=+h[b+8592>>3];i=i;return}function Boa(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+168>>3];e=+h[b+176>>3];f=+h[b+184>>3];h[b+8608>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Coa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5192>>3]=+h[b+4928>>3];i=i;return}function Doa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5200>>3]=+h[b+4936>>3];i=i;return}function Eoa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5208>>3]=+h[b+4944>>3];i=i;return}function Foa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8616>>3]=+h[b+8512>>3];i=i;return}function Goa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8624>>3]=+h[b+8520>>3];i=i;return}function Hoa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8632>>3]=+h[b+8528>>3];i=i;return}function Ioa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8640>>3]=+h[b+8536>>3];i=i;return}function Joa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8648>>3]=+h[b+8544>>3];i=i;return}function Koa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8656>>3]=+h[b+8552>>3];i=i;return}function Loa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8664>>3]=+h[b+8560>>3];i=i;return}function Moa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5216>>3]=+h[b+4952>>3];i=i;return}function Noa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5224>>3]=+h[b+4960>>3];i=i;return}function Ooa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5232>>3]=+h[b+4968>>3];i=i;return}function Poa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5240>>3]=+h[b+4976>>3];i=i;return}function Qoa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5248>>3]=+h[b+4984>>3];i=i;return}function Roa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5256>>3]=+h[b+4992>>3];i=i;return}function Soa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5264>>3]=+h[b+5e3>>3];i=i;return}function Toa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5272>>3]=+h[b+5008>>3];i=i;return}function Uoa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5280>>3]=+h[b+5016>>3];i=i;return}function Voa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5288>>3]=+h[b+5216>>3];i=i;return}function Woa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5296>>3]=+h[b+5224>>3];i=i;return}function Xoa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5304>>3]=+h[b+5232>>3];i=i;return}function Yoa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8672>>3]=+h[b+6840>>3];i=i;return}function Zoa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,0);h[(c[a+416>>2]|0)+5504>>3]=l;i=b;return}function _oa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,1);h[(c[a+416>>2]|0)+5512>>3]=l;i=b;return}function $oa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,2);h[(c[a+416>>2]|0)+5520>>3]=l;i=b;return}function apa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19832;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,3);h[(c[a+416>>2]|0)+5528>>3]=l;i=b;return}function bpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8680>>3]=+h[b+8672>>3]/3.0;i=i;return}function cpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8704>>3]=+h[b+8688>>3]*2.0;i=i;return}function dpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5128>>3]=+h[b+4928>>3]+ +h[b+8704>>3]*-.5;i=i;return}function epa(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+124>>2]=c[b+116>>2];i=i;return}function fpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8712>>3]=+h[b+6464>>3];i=i;return}function gpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8720>>3]=+h[b+6472>>3];i=i;return}function hpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5536>>3]=+h[b+6480>>3];i=i;return}function ipa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5544>>3]=+h[b+6488>>3];i=i;return}function jpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5552>>3]=+h[b+6496>>3];i=i;return}function kpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5560>>3]=+h[b+6504>>3];i=i;return}function lpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5568>>3]=+h[b+6512>>3];i=i;return}function mpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5576>>3]=+h[b+6520>>3];i=i;return}function npa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5584>>3]=+h[b+6528>>3];i=i;return}function opa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5592>>3]=+h[b+6536>>3];i=i;return}function ppa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5600>>3]=+h[b+6544>>3];i=i;return}function qpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5608>>3]=+h[b+6552>>3];i=i;return}function rpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5616>>3]=+h[b+6560>>3];i=i;return}function spa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5624>>3]=+h[b+6568>>3];i=i;return}function tpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5632>>3]=+h[b+24>>3];i=i;return}function upa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5640>>3]=+h[b+32>>3];i=i;return}function vpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5648>>3]=+h[b+40>>3];i=i;return}function wpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5656>>3]=+h[b+48>>3];i=i;return}function xpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5664>>3]=+h[b+56>>3];i=i;return}function ypa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5672>>3]=+h[b+64>>3];i=i;return}function zpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5680>>3]=+h[b+72>>3];i=i;return}function Apa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5688>>3]=+h[b+80>>3];i=i;return}function Bpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5696>>3]=+h[b+88>>3];i=i;return}function Cpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5704>>3]=+h[b+96>>3];i=i;return}function Dpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5712>>3]=+h[b+104>>3];i=i;return}function Epa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5720>>3]=+h[b+112>>3];i=i;return}function Fpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5920>>3]=+h[b+5632>>3];i=i;return}function Gpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5928>>3]=+h[b+5640>>3];i=i;return}function Hpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5936>>3]=+h[b+5648>>3];i=i;return}function Ipa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5944>>3]=+h[b+5656>>3];i=i;return}function Jpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5952>>3]=+h[b+5664>>3];i=i;return}function Kpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5960>>3]=+h[b+5672>>3];i=i;return}function Lpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5968>>3]=+h[b+5680>>3];i=i;return}function Mpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5976>>3]=+h[b+5688>>3];i=i;return}function Npa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5984>>3]=+h[b+5696>>3];i=i;return}function Opa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5992>>3]=+h[b+5704>>3];i=i;return}function Ppa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6e3>>3]=+h[b+5712>>3];i=i;return}function Qpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6008>>3]=+h[b+5720>>3];i=i;return}function Rpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8728>>3]=+h[b+8712>>3];i=i;return}function Spa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6112>>3]=+h[b+5920>>3];i=i;return}function Tpa(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6112>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,19920,19912,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6056>>3]=2.094395102393195/g;i=d;return}function Upa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6120>>3]=+h[b+5928>>3];i=i;return}function Vpa(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6120>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,19960,19952,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6064>>3]=-1.570796326794897/g;i=d;return}function Wpa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6128>>3]=+h[b+5936>>3];i=i;return}function Xpa(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6128>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,2e4,19992,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6072>>3]=-2.181661564992912/g;i=d;return}function Ypa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6136>>3]=+h[b+5944>>3];i=i;return}function Zpa(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6136>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,20040,20032,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6080>>3]=.7853981633974483/g;i=d;return}function _pa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6144>>3]=+h[b+5952>>3];i=i;return}function $pa(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6144>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,20080,20072,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6088>>3]=3.839724354387525/g;i=d;return}function aqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6152>>3]=+h[b+5960>>3];i=i;return}function bqa(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6152>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,20120,20112,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6096>>3]=.7853981633974483/g;i=d;return}function cqa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0.0;b=i;i=i+40|0;d=b;e=i;i=i+16|0;f=a+4|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;g=+U(+(+h[a+6056>>3]));j=+U(+(+h[a+6064>>3]));l=+U(+(+h[a+6072>>3]));m=+U(+(+h[a+6080>>3]));n=+U(+(+h[a+6088>>3]));o=+U(+(+h[a+6096>>3]));a=d;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=l;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+16|0;h[k>>3]=m;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+24|0;h[k>>3]=n;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+32|0;h[k>>3]=o;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];ONa(e,6,g,d);g=+SNa(e);h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9792>>3]=g;i=b;return}function dqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6160>>3]=+h[b+5968>>3];i=i;return}function eqa(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6160>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,20160,20152,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6104>>3]=2.094395102393195/g;i=d;return}function fqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6168>>3]=+h[b+5976>>3];i=i;return}function gqa(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6168>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,20200,20192,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6112>>3]=-1.570796326794897/g;i=d;return}function hqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6176>>3]=+h[b+5984>>3];i=i;return}function iqa(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6176>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,20240,20232,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6120>>3]=-2.181661564992912/g;i=d;return}function jqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6184>>3]=+h[b+5992>>3];i=i;return}function kqa(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6184>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,20280,20272,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6128>>3]=.7853981633974483/g;i=d;return}function lqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6192>>3]=+h[b+6e3>>3];i=i;return}function mqa(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6192>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,20320,20312,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6136>>3]=3.839724354387525/g;i=d;return}function nqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6200>>3]=+h[b+6008>>3];i=i;return}function oqa(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6200>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,20360,20352,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6144>>3]=.7853981633974483/g;i=d;return}function pqa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0.0;b=i;i=i+40|0;d=b;e=i;i=i+16|0;f=a+4|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;g=+U(+(+h[a+6104>>3]));j=+U(+(+h[a+6112>>3]));l=+U(+(+h[a+6120>>3]));m=+U(+(+h[a+6128>>3]));n=+U(+(+h[a+6136>>3]));o=+U(+(+h[a+6144>>3]));a=d;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=l;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+16|0;h[k>>3]=m;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+24|0;h[k>>3]=n;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+32|0;h[k>>3]=o;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];ONa(e,6,g,d);g=+SNa(e);h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9784>>3]=g;i=b;return}function qqa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0;d=i;e=b+4|0;f=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;if(!((dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|f)<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+9248|0;r=q;h[r>>3]=g;i=d;return}f=c[c[e>>2]>>2]|0;s=+h[(c[f+8>>2]|0)+9784>>3];if(s!=0.0){t=s}else{t=+YMa(c[b+536>>2]|0,s,20400,20392,+h[f>>3],(a[b+319|0]|0)!=0|0)}g=1.0/t;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+9248|0;r=q;h[r>>3]=g;i=d;return}function rqa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0;d=i;e=b+4|0;f=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;if(!((dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|f)<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+9240|0;r=q;h[r>>3]=g;i=d;return}f=c[c[e>>2]>>2]|0;s=+h[(c[f+8>>2]|0)+9792>>3];if(s!=0.0){t=s}else{t=+YMa(c[b+536>>2]|0,s,20440,20432,+h[f>>3],(a[b+319|0]|0)!=0|0)}g=1.0/t;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+9240|0;r=q;h[r>>3]=g;i=d;return}function sqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;d=i;e=b+4|0;f=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;do{if((dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|f)<<24>>24==0){g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+9248>>3];l=+h[j+9240>>3];if(k!=0.0){m=l/k;break}if(l==0.0){m=l;break}m=l/+YMa(c[b+536>>2]|0,k,20480,20472,+h[g>>3],(a[b+319|0]|0)!=0|0)}else{m=0.0}}while(0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9128>>3]=m;i=d;return}function tqa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;e=dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;f=(dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|e)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(!f){g=0.0;j=e;k=j+9120|0;l=k;h[l>>3]=g;i=b;return}g=+h[e+9128>>3]+ +h[(c[a+416>>2]|0)+8728>>3];j=e;k=j+9120|0;l=k;h[l>>3]=g;i=b;return}function uqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0,y=0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=dQa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;if(!((dQa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|j)<<24>>24==0)){l=0.0;m=c[g>>2]|0;n=c[m>>2]|0;o=n;p=o+8|0;q=p;r=c[q>>2]|0;s=r;t=s+9112|0;u=t;h[u>>3]=l;i=d;return}j=c[c[g>>2]>>2]|0;v=+h[(c[j+8>>2]|0)+9248>>3];if(v!=0.0){w=v}else{w=+YMa(c[b+536>>2]|0,v,20480,20512,+h[j>>3],(a[b+319|0]|0)!=0|0)}v=1.0/w;if(!(v>=0.0)){j=c[41884]|0;x=c[b+536>>2]|0;b=f;h[k>>3]=v;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j;j=e;y=20528;c[j+0>>2]=c[y+0>>2];c[j+4>>2]=c[y+4>>2];c[j+8>>2]=c[y+8>>2];c[j+12>>2]=c[y+12>>2];c[j+16>>2]=c[y+16>>2];c[j+20>>2]=c[y+20>>2];Ie[b&63](x,e,20552,f);}l=+V(+v);m=c[g>>2]|0;n=c[m>>2]|0;o=n;p=o+8|0;q=p;r=c[q>>2]|0;s=r;t=s+9112|0;u=t;h[u>>3]=l;i=d;return}function vqa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;e=dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;f=(dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|e)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(!f){g=0.0;j=e;k=j+9104|0;l=k;h[l>>3]=g;i=b;return}g=+h[e+9112>>3]+ +h[(c[a+416>>2]|0)+8728>>3];j=e;k=j+9104|0;l=k;h[l>>3]=g;i=b;return}function wqa(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;e=(dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|a)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(!e){f=0.0;g=a;j=g+9096|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+9248>>3]*+h[a+9112>>3];g=a;j=g+9096|0;k=j;h[k>>3]=f;i=b;return}function xqa(b){b=b|0;var d=0,e=0,f=0;d=i;e=b+4|0;b=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;if((dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|b)<<24>>24==0){b=c[(c[c[e>>2]>>2]|0)+8>>2]|0;f=fQa(+h[b+9128>>3],+h[b+9112>>3])|0}else{f=0}a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+21|0]=f;i=d;return}function yqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;d=i;e=b+4|0;f=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;do{if((dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|f)<<24>>24==0){g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;if((a[(c[g+16>>2]|0)+21|0]|0)!=0){k=+h[j+9112>>3];break}l=+h[j+9240>>3];if(l!=0.0){m=l}else{m=+YMa(c[b+536>>2]|0,l,20656,20648,+h[g>>3],(a[b+319|0]|0)!=0|0)}k=1.0/m}else{k=0.0}}while(0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9016>>3]=k;i=d;return}function zqa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;e=dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;f=(dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|e)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(!f){g=0.0;j=e;k=j+9008|0;l=k;h[l>>3]=g;i=b;return}g=+h[e+9016>>3]+ +h[(c[a+416>>2]|0)+8728>>3];j=e;k=j+9008|0;l=k;h[l>>3]=g;i=b;return}function Aqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0;d=i;e=b+4|0;b=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;f=(dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|b)<<24>>24==0;b=c[c[e>>2]>>2]|0;if(!f){g=c[b+8>>2]|0;j=0.0;k=g;l=k+9e3|0;m=l;h[m>>3]=j;i=d;return}f=c[b+8>>2]|0;if((a[(c[b+16>>2]|0)+21|0]|0)==0){g=f;j=+h[f+9016>>3]+ +h[f+9128>>3];k=g;l=k+9e3|0;m=l;h[m>>3]=j;i=d;return}else{g=f;j=+h[f+9112>>3]*2.0;k=g;l=k+9e3|0;m=l;h[m>>3]=j;i=d;return}}function Bqa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;e=dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;f=(dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|e)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(!f){g=0.0;j=e;k=j+8992|0;l=k;h[l>>3]=g;i=b;return}g=+h[e+9e3>>3]+ +h[(c[a+416>>2]|0)+8728>>3];j=e;k=j+8992|0;l=k;h[l>>3]=g;i=b;return}function Cqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;b=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;f=(dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|b)<<24>>24==0;b=c[c[e>>2]>>2]|0;if(!f){g=c[b+8>>2]|0;j=0.0;k=g;l=k+8968|0;m=l;h[m>>3]=j;i=d;return}f=c[b+8>>2]|0;if((a[(c[b+16>>2]|0)+21|0]|0)==0){n=+h[f+9128>>3];o=n*n}else{n=+h[f+9112>>3];o=n*n}g=f;j=o*+h[f+9248>>3]*.5;k=g;l=k+8968|0;m=l;h[m>>3]=j;i=d;return}function Dqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;b=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;f=(dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|b)<<24>>24==0;b=c[c[e>>2]>>2]|0;if(!f){g=c[b+8>>2]|0;j=0.0;k=g;l=k+8960|0;m=l;h[m>>3]=j;i=d;return}f=c[b+8>>2]|0;if((a[(c[b+16>>2]|0)+21|0]|0)==0){n=+h[f+9240>>3]*(+h[f+9016>>3]- +h[f+9128>>3])}else{o=+h[f+9e3>>3]- +h[f+9112>>3];n=+h[f+9096>>3]*o+ +h[f+9248>>3]*o*o*-.5}g=f;j=n+ +h[f+8968>>3];k=g;l=k+8960|0;m=l;h[m>>3]=j;i=d;return}function Eqa(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0;b=i;d=a+4|0;a=dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;e=(dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|a)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(!e){f=0.0;g=a;j=g+8952|0;k=j;h[k>>3]=f;i=b;return}l=+h[a+9e3>>3]- +h[a+9016>>3];f=+h[a+8960>>3]+(l*+h[a+9240>>3]+l*l*+h[a+9248>>3]*-.5);g=a;j=g+8952|0;k=j;h[k>>3]=f;i=b;return}



function Feb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=xfb(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=xfb(2048)|0;c[p+16>>2]=s;if((s|0)==0){yfb(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=Veb(0,0)|0;if((s|0)==0){yfb(c[p+16>>2]|0);yfb(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=Geb(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=zfb(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=Heb(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=xfb(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;dgb(y|0,-1,v|0)|0;I=H}else{I=0}H=zfb(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=zfb(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=Heb(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=Neb(q,x)|0;b:do{if((v|0)==0){y=Neb(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;V=c[Q+(U<<2)>>2]|0;c[j>>2]=V;U=T+4|0;W=c[U>>2]|0;do{if((W|0)>1){c[l>>2]=0;X=T;F=51}else{if((c[T+8>>2]|0)<=1){Y=V;break}c[l>>2]=0;Z=T;if((W|0)>0){X=Z;F=51}else{_=W;$=Z;aa=V;ba=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;Z=V;ca=W;da=1;ea=0;while(1){fa=Oeb(s,q,c[X>>2]|0,(da|0)<(ca|0)?1:2,j,G,m,k)|0;if((fa|0)!=0){J=fa;break b}fa=c[m>>2]|0;if((ea|0)==0){ga=fa}else{ha=Xeb(s,0,0,1,32)|0;if((ha|0)==0){J=12;break b}ia=Xeb(s,0,0,1,8)|0;ja=ha+4|0;c[ja>>2]=ia;if((ia|0)==0){J=12;break b}c[ha>>2]=1;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[ia>>2]=ea;c[(c[ja>>2]|0)+4>>2]=fa;c[ha+16>>2]=(c[fa+16>>2]|0)+(c[ea+16>>2]|0);ga=ha}if((ga|0)==0){J=12;break b}ha=c[U>>2]|0;if((da|0)>=(ha|0)){_=ha;$=X;aa=Z;ba=ga;F=60;break e}Z=c[j>>2]|0;ca=ha;da=da+1|0;ea=ga}}}while(0);if((F|0)==60){F=0;U=T+8|0;W=c[U>>2]|0;do{if((W|0)==-1){ea=c[j>>2]|0;da=Oeb(s,q,c[$>>2]|0,0,j,0,l,k)|0;if((da|0)!=0){J=da;break b}da=c[l>>2]|0;ca=Xeb(s,0,0,1,32)|0;Z=ca;if((ca|0)==0){F=65;break d}ha=Xeb(s,0,0,1,16)|0;c[ca+4>>2]=ha;if((ha|0)==0){F=65;break d}c[ca>>2]=2;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[ha>>2]=da;c[ha+4>>2]=0;c[ha+8>>2]=-1;fa=ha+12|0;a[fa]=a[fa]&-2;c[ca+16>>2]=c[da+16>>2];c[l>>2]=Z;ka=Z;la=ea}else{if((_|0)<(W|0)){ma=0;na=_}else{ka=0;la=aa;break}while(1){ea=c[j>>2]|0;Z=Oeb(s,q,c[$>>2]|0,0,j,0,n,k)|0;if((Z|0)!=0){J=Z;break b}Z=c[n>>2]|0;if((ma|0)==0){oa=Z}else{da=Xeb(s,0,0,1,32)|0;if((da|0)==0){F=73;break d}ca=Xeb(s,0,0,1,8)|0;fa=da+4|0;c[fa>>2]=ca;if((ca|0)==0){F=73;break d}c[da>>2]=1;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ca>>2]=Z;c[(c[fa>>2]|0)+4>>2]=ma;c[da+16>>2]=(c[ma+16>>2]|0)+(c[Z+16>>2]|0);oa=da}c[l>>2]=oa;if((oa|0)==0){J=12;break b}da=Xeb(s,0,0,1,32)|0;if((da|0)==0){J=12;break b}Z=Xeb(s,0,0,1,20)|0;c[da+4>>2]=Z;if((Z|0)==0){J=12;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Z>>2]=-1;c[Z+4>>2]=-1;c[Z+8>>2]=-1;Z=Xeb(s,0,0,1,32)|0;fa=Z;if((Z|0)==0){F=79;break d}ca=Xeb(s,0,0,1,8)|0;ha=Z+4|0;c[ha>>2]=ca;if((ca|0)==0){F=79;break d}c[Z>>2]=3;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[ca>>2]=da;c[(c[ha>>2]|0)+4>>2]=oa;c[Z+16>>2]=(c[oa+16>>2]|0)+(c[da+16>>2]|0);c[l>>2]=fa;da=na+1|0;if((da|0)<(c[U>>2]|0)){ma=fa;na=da}else{ka=fa;la=ea;break}}}}while(0);c[j>>2]=la;do{if((ba|0)==0){pa=ka;F=85}else{if((ka|0)==0){qa=ba;break}U=Xeb(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}W=Xeb(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=W;if((W|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[W>>2]=ba;c[(c[T>>2]|0)+4>>2]=ka;c[U+16>>2]=(c[ka+16>>2]|0)+(c[ba+16>>2]|0);pa=U;F=85}}while(0);if((F|0)==85){F=0;if((pa|0)==0){J=12;break b}else{qa=pa}}c[P>>2]=c[qa+4>>2];c[S>>2]=c[qa>>2];Y=la}U=M+ -1|0;T=Y-V+N|0;if((U|0)!=0){ra=Y;sa=U;ta=T;break}c[j>>2]=T;ra=T;sa=0;ta=T}else if((R|0)==0){T=c[S>>2]|0;if((T|0)==3){U=c[S+4>>2]|0;W=Neb(q,c[U+4>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=Neb(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}W=Neb(q,c[U>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}wa=Neb(q,0)|0}else if((T|0)==0){W=c[S+4>>2]|0;U=c[W>>2]|0;if(!((U|0)>-1|(U|0)==-4)){ra=L;sa=M;ta=N;break}U=W+8|0;W=(c[U>>2]|0)+L|0;c[U>>2]=W;if((W|0)<=(c[k>>2]|0)){ra=L;sa=M;ta=N;break}c[k>>2]=W;ra=L;sa=M;ta=N;break}else if((T|0)==1){W=c[S+4>>2]|0;U=Neb(q,c[W+4>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}U=Neb(q,0)|0;if((U|0)!=0){ua=N;va=U;break c}U=Neb(q,c[W>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}wa=Neb(q,0)|0}else if((T|0)==2){T=c[S+4>>2]|0;U=Neb(q,L)|0;if((U|0)!=0){ua=N;va=U;break c}U=Neb(q,S)|0;if((U|0)!=0){ua=N;va=U;break c}U=Neb(q,1)|0;if((U|0)!=0){ua=N;va=U;break c}U=Neb(q,c[T>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}U=Neb(q,0)|0;if((U|0)!=0){ua=N;va=U;break c}if((c[T+4>>2]|0)>1){F=45}else{if((c[T+8>>2]|0)>1){F=45}else{xa=L}}if((F|0)==45){F=0;c[j>>2]=0;xa=0}ra=xa;sa=M+1|0;ta=N;break}else{ra=L;sa=M;ta=N;break}if((wa|0)==0){ra=L;sa=M;ta=N}else{ua=N;va=wa;break c}}else{ra=L;sa=M;ta=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=ra;M=sa;N=ta;O=S}else{ua=ta;va=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{ua=0;va=0}}while(0);y=(c[H>>2]|0)+ua|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=va}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=Xeb(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=Xeb(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=Xeb(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=Xeb(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=Neb(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=Neb(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==0){M=c[ya>>2]|0;if((M|0)==0){L=c[ya+4>>2]|0;R=c[L>>2]|0;if((R|0)==-4){c[ya+8>>2]=0;Q=L+8|0;T=c[Q>>2]|0;U=Xeb(s,0,0,1,64)|0;if((U|0)==0){F=104;break g}W=U;c[U>>2]=T;c[U+4>>2]=0;c[U+8>>2]=1114111;c[U+20>>2]=0;c[U+24>>2]=0;T=U+28|0;U=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[U>>2]=W;W=c[Q>>2]|0;Q=c[L+4>>2]|0;U=Xeb(s,0,0,1,64)|0;if((U|0)==0){F=106;break g}c[U>>2]=W;c[U+4>>2]=0;c[U+8>>2]=1114111;c[U+20>>2]=0;c[U+24>>2]=0;c[U+28>>2]=Q;c[U+32>>2]=-1;c[U+36>>2]=-1;c[U+40>>2]=-1;c[ya+28>>2]=U;break}U=ya+8|0;if((R|0)<0){c[U>>2]=1;Q=Xeb(s,0,0,1,32)|0;if((Q|0)==0){F=110;break g}c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;c[ya+24>>2]=Q;Q=Xeb(s,0,0,1,32)|0;if((Q|0)==0){F=112;break g}c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;c[ya+28>>2]=Q;break}else{c[U>>2]=0;U=L+8|0;Q=c[U>>2]|0;W=L+4|0;T=c[W>>2]|0;ea=Xeb(s,0,0,1,64)|0;if((ea|0)==0){F=115;break g}fa=ea;c[ea>>2]=Q;c[ea+4>>2]=R;c[ea+8>>2]=T;c[ea+20>>2]=0;c[ea+24>>2]=0;T=ea+28|0;ea=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[ea>>2]=fa;fa=c[U>>2]|0;U=c[L>>2]|0;ea=c[W>>2]|0;W=c[L+12>>2]|0;T=c[L+16>>2]|0;L=Xeb(s,0,0,1,64)|0;if((L|0)==0){F=117;break g}R=L;c[L>>2]=fa;c[L+4>>2]=U;c[L+8>>2]=ea;c[L+20>>2]=W;c[L+24>>2]=T;T=L+28|0;L=ya+28|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[L>>2]=R;break}}else if((M|0)==1){R=Neb(q,ya)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=Neb(q,2)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=ya+4|0;L=Neb(q,c[(c[R>>2]|0)+4>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=Neb(q,0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=Neb(q,c[c[R>>2]>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=Neb(q,0)|0;if((L|0)==0){break}else{z=0;A=L;B=0;C=D;break a}}else if((M|0)==3){L=Neb(q,ya)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=Neb(q,1)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=ya+4|0;R=Neb(q,c[(c[L>>2]|0)+4>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=Neb(q,0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=Neb(q,c[c[L>>2]>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=Neb(q,0)|0;if((R|0)==0){break}else{z=0;A=R;B=0;C=D;break a}}else if((M|0)==2){M=Neb(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=Neb(q,3)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=Neb(q,c[c[ya+4>>2]>>2]|0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=Neb(q,0)|0;if((M|0)==0){break}else{z=0;A=M;B=0;C=D;break a}}else{break}}else if((S|0)==2){M=c[ya+4>>2]|0;R=c[M>>2]|0;L=R+8|0;if((c[L>>2]|0)==0){za=0}else{za=(c[(c[M+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=za;if((c[L>>2]|0)==0){c[ya+24>>2]=c[R+24>>2];Aa=M+4|0}else{L=Meb(q,R,0,0,g)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}Ba=xfb((c[g>>2]<<2)+4|0)|0;L=Ba;if((Ba|0)==0){z=0;A=12;B=0;C=D;break a}c[Ba>>2]=-1;c[h>>2]=0;Ca=Meb(q,c[M>>2]|0,L,h,0)|0;if((Ca|0)!=0){F=150;break g}R=M+4|0;T=Leb(s,c[(c[R>>2]|0)+24>>2]|0,c[(c[M>>2]|0)+24>>2]|0,L,c[h>>2]|0)|0;L=ya+24|0;c[L>>2]=T;yfb(Ba);if((c[L>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Aa=R}}R=c[Aa>>2]|0;if((c[R+8>>2]|0)==0){c[ya+28>>2]=c[R+28>>2];break}L=Meb(q,R,0,0,g)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}Da=xfb((c[g>>2]<<2)+4|0)|0;L=Da;if((Da|0)==0){z=0;A=12;B=0;C=D;break a}c[Da>>2]=-1;c[h>>2]=0;Ea=Meb(q,c[Aa>>2]|0,L,h,0)|0;if((Ea|0)!=0){F=157;break g}R=Leb(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[Aa>>2]|0)+28>>2]|0,L,c[h>>2]|0)|0;L=ya+28|0;c[L>>2]=R;yfb(Da);if((c[L>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==1){L=c[ya+4>>2]|0;R=c[L>>2]|0;M=L+4|0;T=c[M>>2]|0;if((c[R+8>>2]|0)==0){Fa=(c[T+8>>2]|0)!=0|0}else{Fa=1}c[ya+8>>2]=Fa;W=Leb(s,c[R+24>>2]|0,c[T+24>>2]|0,0,0)|0;c[ya+24>>2]=W;if((W|0)==0){z=0;A=12;B=0;C=D;break a}W=Leb(s,c[(c[L>>2]|0)+28>>2]|0,c[(c[M>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=W;if((W|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==3){W=c[ya+4>>2]|0;M=c[W>>2]|0;do{if((c[W+4>>2]|0)==0){F=141}else{if((c[M+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[M+24>>2];c[ya+28>>2]=c[(c[W>>2]|0)+28>>2]}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){yfb(Ba);z=0;A=Ca;B=0;C=D;break a}else if((F|0)==157){yfb(Da);z=0;A=Ea;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=xfb(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=xfb(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){dgb(O|0,0,((E|0)>1?E<<2:4)|0)|0}Ieb(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;L=O+(S<<2)|0;T=K+1+(c[L>>2]|0)|0;c[L>>2]=0;L=S+1|0;if((L|0)<(E|0)){S=L;K=T}else{Ga=T;break}}}else{Ga=0}K=zfb(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;T=Ieb(y,S,x,u)|0;if((T|0)!=0){z=x;A=T;B=u;C=D;break}c[w+20>>2]=0;T=v+24|0;S=c[T>>2]|0;if((c[S>>2]|0)>-1){L=1;R=S;while(1){S=R+32|0;ea=L+1|0;if((c[S>>2]|0)>-1){R=S;L=ea}else{Ha=ea;break}}}else{Ha=1}L=zfb(Ha,32)|0;if((L|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=L;R=c[T>>2]|0;y=c[R>>2]|0;if((y|0)>-1){ea=y;y=R;R=0;while(1){c[L+(R<<5)+8>>2]=K+(c[N+(ea<<2)>>2]<<5);c[L+(R<<5)+12>>2]=ea;S=L+(R<<5)+16|0;c[S>>2]=0;U=y+12|0;fa=c[U>>2]|0;if((fa|0)!=0){Q=0;while(1){Ia=Q+1|0;if((c[fa+(Q<<2)>>2]|0)>-1){Q=Ia}else{break}}Q=Ia<<2;fa=xfb(Q)|0;c[S>>2]=fa;if((fa|0)==0){z=x;A=12;B=u;C=D;break a}bgb(fa|0,c[U>>2]|0,Q|0)|0}c[L+(R<<5)+20>>2]=c[y+16>>2];Q=R+1|0;fa=y+32|0;da=c[fa>>2]|0;if((da|0)>-1){ea=da;y=fa;R=Q}else{Ja=Q;break}}}else{Ja=0}c[L+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;Web(s);yfb(c[p+16>>2]|0);yfb(p);yfb(O);yfb(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);Web(s);yfb(c[p+16>>2]|0);yfb(p);if((z|0)!=0){yfb(z)}if((B|0)!=0){yfb(B)}c[b+4>>2]=C;Jeb(b);r=A;i=f;return r|0}function Geb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;Neb(m,c[p>>2]|0)|0;Neb(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=Neb(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 3:{Q=Neb(m,5)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}U=M;V=N;W=Neb(m,4)|0;break};case 2:{Q=L+ -2|0;c[n>>2]=Q;X=c[P+(Q<<2)>>2]|0;if((c[N+12>>2]|0)>-1){Q=c[w>>2]|0;Y=Xeb(Q,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}_=Xeb(Q,0,0,1,20)|0;c[Y+4>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[_>>2]=-1;c[_+4>>2]=-1;c[_+8>>2]=-1;_=c[w>>2]|0;Q=Xeb(_,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}$=Xeb(_,0,0,1,8)|0;_=Q+4|0;c[_>>2]=$;if(($|0)==0){Z=12;T=294;break b}c[Q>>2]=1;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[$>>2]=Y;c[(c[_>>2]|0)+4>>2]=N;_=N+16|0;$=Q+16|0;c[$>>2]=(c[_>>2]|0)+(c[Y+16>>2]|0);c[$>>2]=c[_>>2];aa=Q}else{aa=N}c[aa+12>>2]=X;X=aa+16|0;c[X>>2]=(c[X>>2]|0)+1;U=M;V=aa;W=0;break};case 9:{X=c[q>>2]|0;Q=a[X]|0;switch(Q<<24>>24|0){case 92:{_=c[v>>2]|0;if((_&1|0)!=0){U=M;V=N;W=0;break c}$=X+1|0;if((a[$]|0)!=123){U=M;V=N;W=0;break c}c[q>>2]=$;ba=_;ca=$;break};case 42:{T=41;break};case 63:case 43:{if((c[v>>2]&1|0)==0){U=M;V=N;W=0;break c}else{T=41}break};case 123:{$=c[v>>2]|0;if(($&1|0)==0){U=M;V=N;W=0;break c}else{ba=$;ca=X}break};default:{U=M;V=N;W=0;break c}}if((T|0)==41){T=0;c[q>>2]=X+1;X=c[w>>2]|0;$=Xeb(X,0,0,1,32)|0;if(($|0)==0){Z=12;T=294;break b}_=Xeb(X,0,0,1,16)|0;c[$+4>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[$>>2]=2;c[$+8>>2]=-1;c[$+12>>2]=-1;c[_>>2]=N;c[_+4>>2]=Q<<24>>24==43;c[_+8>>2]=Q<<24>>24==63?1:-1;Q=_+12|0;a[Q]=a[Q]&-2;c[$+16>>2]=c[N+16>>2];U=M;V=$;W=Neb(m,9)|0;break c}$=ca+1|0;c[q>>2]=$;Q=a[$]|0;if((Q+ -48<<24>>24&255)<10){_=Q<<24>>24;if((_+ -48|0)>>>0<10){da=_;ea=-1;fa=$}else{Z=10;T=294;break b}while(1){_=((ea|0)<0?-48:(ea*10|0)+ -48|0)+da|0;X=fa+1|0;Y=a[X]|0;ga=Y<<24>>24;if((ga+ -48|0)>>>0<10){fa=X;ea=_;da=ga}else{ha=Y;ia=_;ja=X;break}}}else{ha=Q;ia=-1;ja=$}do{if(ha<<24>>24==44){X=ja+1|0;_=a[X]|0;Y=_<<24>>24;if((Y+ -48|0)>>>0<10){ka=Y;la=-1;ma=X}else{na=_;oa=-1;pa=X;break}while(1){X=((la|0)<0?-48:(la*10|0)+ -48|0)+ka|0;_=ma+1|0;Y=a[_]|0;ga=Y<<24>>24;if((ga+ -48|0)>>>0<10){ma=_;la=X;ka=ga}else{qa=Y;ra=X;sa=_;T=54;break}}}else{qa=ha;ra=ia;sa=ja;T=54}}while(0);do{if((T|0)==54){T=0;if(!((ra|0)>-1)){na=qa;oa=ra;pa=sa;break}if((ia|0)>(ra|0)|(ra|0)>255){Z=10;T=294;break b}else{na=qa;oa=ra;pa=sa}}}while(0);if(na<<24>>24==0){Z=9;T=294;break b}if((pa|0)==($|0)){Z=10;T=294;break b}if((ba&1|0)==0){if(!(na<<24>>24==92)){Z=10;T=294;break b}if((a[pa+1|0]|0)!=125){Z=10;T=294;break b}ta=pa+2|0}else{if(!(na<<24>>24==125)){Z=10;T=294;break b}ta=pa+1|0}if((oa|ia|0)==0){Q=c[w>>2]|0;_=Xeb(Q,0,0,1,32)|0;if((_|0)==0){Z=12;T=294;break b}X=Xeb(Q,0,0,1,20)|0;c[_+4>>2]=X;if((X|0)==0){Z=12;T=294;break b}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[X>>2]=-1;c[X+4>>2]=-1;c[X+8>>2]=-1;ua=_}else{_=(oa&ia|0)<0;X=c[w>>2]|0;Q=Xeb(X,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}Y=Xeb(X,0,0,1,16)|0;c[Q+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[Q>>2]=2;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Y>>2]=N;c[Y+4>>2]=_?1:ia;c[Y+8>>2]=_?1:oa;_=Y+12|0;a[_]=a[_]&-2;c[Q+16>>2]=c[N+16>>2];ua=Q}c[q>>2]=ta;U=M;V=ua;W=Neb(m,9)|0;break};case 7:{Q=c[q>>2]|0;_=a[Q]|0;if((_|0)==41){c[q>>2]=Q+1;U=M;V=N;W=0;break c}else if((_|0)!=124){U=M;V=N;W=0;break c}_=Neb(m,7)|0;if((_|0)!=0){R=M;S=_;T=6;break b}_=Neb(m,N)|0;if((_|0)!=0){R=M;S=_;T=6;break b}_=Neb(m,8)|0;if((_|0)!=0){R=M;S=_;T=6;break b}_=Neb(m,3)|0;if((_|0)!=0){R=M;S=_;T=6;break b}c[q>>2]=(c[q>>2]|0)+1;U=M;V=N;W=0;break};case 6:{_=L+ -2|0;c[n>>2]=_;Q=c[P+(_<<2)>>2]|0;_=c[w>>2]|0;Y=Xeb(_,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}X=Xeb(_,0,0,1,8)|0;_=Y+4|0;c[_>>2]=X;if((X|0)==0){Z=12;T=294;break b}c[Y>>2]=1;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[X>>2]=Q;c[(c[_>>2]|0)+4>>2]=N;c[Y+16>>2]=(c[N+16>>2]|0)+(c[Q+16>>2]|0);U=M;V=Y;W=0;break};case 4:{Y=Neb(m,9)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}U=M;V=N;W=Neb(m,1)|0;break};case 8:{Y=L+ -2|0;c[n>>2]=Y;Q=c[P+(Y<<2)>>2]|0;Y=c[w>>2]|0;_=Xeb(Y,0,0,1,32)|0;if((_|0)==0){Z=12;T=294;break b}X=Xeb(Y,0,0,1,8)|0;Y=_+4|0;c[Y>>2]=X;if((X|0)==0){Z=12;T=294;break b}c[_>>2]=3;c[_+8>>2]=-1;c[_+12>>2]=-1;c[X>>2]=Q;c[(c[Y>>2]|0)+4>>2]=N;c[_+16>>2]=(c[N+16>>2]|0)+(c[Q+16>>2]|0);U=M;V=_;W=0;break};case 0:{if((c[v>>2]&1|0)!=0){_=Neb(m,7)|0;if((_|0)!=0){R=M;S=_;T=6;break b}}U=M;V=N;W=Neb(m,3)|0;break};case 10:{_=L+ -2|0;c[n>>2]=_;c[v>>2]=c[P+(_<<2)>>2];U=M;V=N;W=0;break};case 5:{_=c[q>>2]|0;Q=a[_]|0;if(Q<<24>>24==0){U=M;V=N;W=0;break c}Y=c[v>>2]&1;X=(Y|0)!=0;if(X&Q<<24>>24==124){U=M;V=N;W=0;break c}do{if(!(X&Q<<24>>24==41&(M|0)>0)){if((Y|0)==0&Q<<24>>24==92){if((a[_+1|0]|0)==41){break}}ga=Neb(m,5)|0;if((ga|0)!=0){R=M;S=ga;T=6;break b}ga=Neb(m,N)|0;if((ga|0)!=0){R=M;S=ga;T=6;break b}ga=Neb(m,6)|0;if((ga|0)!=0){R=M;S=ga;T=6;break b}U=M;V=N;W=Neb(m,4)|0;break c}}while(0);Q=(Y|M|0)==0?8:0;X=M+ -1|0;if((Y|0)!=0){U=X;V=N;W=Q;break c}c[q>>2]=_+2;U=X;V=N;W=Q;break};case 1:{Q=c[q>>2]|0;d:do{switch(a[Q]|0){case 36:{if((c[v>>2]&1|0)==0){if((a[Q+1|0]|0)!=0){break d}}X=c[w>>2]|0;$=Xeb(X,0,0,1,32)|0;if(($|0)==0){Z=12;T=294;break b}ga=Xeb(X,0,0,1,20)|0;c[$+4>>2]=ga;if((ga|0)==0){Z=12;T=294;break b}c[$>>2]=0;c[$+8>>2]=-1;c[$+12>>2]=-1;c[ga>>2]=-2;c[ga+4>>2]=2;c[ga+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=$;W=0;break c;break};case 63:case 43:case 123:case 124:case 42:{T=264;break};case 0:{T=265;break};case 41:{if((M|0)!=0){T=264}break};case 91:{$=Q+1|0;c[q>>2]=$;ga=xfb(128)|0;if((ga|0)==0){Z=12;T=294;break b}if((a[$]|0)==94){X=Q+2|0;c[q>>2]=X;va=X;wa=1}else{va=$;wa=0}$=(wa|0)==0;X=ga;ga=0;xa=0;ya=32;za=va;e:while(1){Aa=a[za]|0;if(Aa<<24>>24==93){if(za>>>0>(c[q>>2]|0)>>>0){T=85;break}}else if(Aa<<24>>24==0){Ba=X;Ca=za;Da=7;T=140;break}Aa=Beb(e,za,-1)|0;if((Aa|0)<0){c[e>>2]=-1;Ea=1}else{Ea=Aa}Aa=za+Ea|0;do{if((a[Aa]|0)==45){Fa=Ea+1|0;Ga=za+Fa|0;if((a[Ga]|0)==93){T=94;break}Ha=c[e>>2]|0;Ia=Beb(e,Ga,-1)|0;if((Ia|0)<0){c[e>>2]=-1;Ja=-1;Ka=1}else{Ja=c[e>>2]|0;Ka=Ia}La=0;Ma=Ja;Na=Ha;Oa=za+(Ka+Fa)|0;Pa=Ha>>>0>Ja>>>0?11:0}else{T=94}}while(0);f:do{if((T|0)==94){T=0;Ha=a[za]|0;do{if(Ha<<24>>24==45){if((a[za+1|0]|0)==93){Qa=0;break}Qa=(c[q>>2]|0)==(za|0)?0:11}else if(Ha<<24>>24==91){Fa=a[za+1|0]|0;if(Fa<<24>>24==61|Fa<<24>>24==46){Ba=X;Ca=za;Da=3;T=140;break e}else if(!(Fa<<24>>24==58)){Qa=0;break}Fa=za+2|0;Ia=Fa;while(1){Ga=a[Ia]|0;Ra=Ga<<24>>24==0;if(Ga<<24>>24!=58&(Ra^1)){Ia=Ia+1|0}else{break}}if(Ra){Ba=X;Ca=za;Da=4;T=140;break e}Ga=Ia-za+ -2|0;Sa=(Ga|0)>63?63:Ga;kgb(A|0,Fa|0,Sa|0)|0;a[f+Sa|0]=0;Sa=leb(A)|0;La=Sa;Ma=1114111;Na=0;Oa=Ia+2|0;Pa=(Sa|0)==0?4:0;break f}else{Qa=0}}while(0);Ha=c[e>>2]|0;La=0;Ma=Ha;Na=Ha;Oa=Aa;Pa=Qa}}while(0);if((Pa|0)!=0){Ba=X;Ca=Oa;Da=Pa;T=140;break}Aa=(La|0)!=0;do{if($|Aa^1){Ha=c[w>>2]|0;if((xa|0)<(ya|0)){Ta=X;Ua=ya}else{if((ya|0)>1024){Ba=X;Ca=Oa;Da=12;T=140;break e}Sa=Afb(X,ya<<3)|0;if((Sa|0)==0){Ba=X;Ca=Oa;Da=12;T=140;break e}else{Ta=Sa;Ua=ya<<1}}Sa=Xeb(Ha,0,0,1,32)|0;if((Sa|0)==0){T=112;break e}Ga=Xeb(Ha,0,0,1,20)|0;Ha=Sa+4|0;c[Ha>>2]=Ga;if((Ga|0)==0){T=112;break e}c[Sa>>2]=0;c[Sa+8>>2]=-1;c[Sa+12>>2]=-1;c[Ga>>2]=Na;c[Ga+4>>2]=Ma;c[Ga+8>>2]=-1;c[Ta+(xa<<2)>>2]=Sa;c[(c[Ha>>2]|0)+12>>2]=La;Va=Ta;Wa=ga;Xa=xa+1|0;Ya=Ua;Za=0}else{if((ga|0)>63){Va=X;Wa=ga;Xa=xa;Ya=ya;Za=12;break}c[g+(ga<<2)>>2]=La;Va=X;Wa=ga+1|0;Xa=xa;Ya=ya;Za=0}}while(0);Ha=(Za|0)==0;if(Ha&(((c[v>>2]&2|0)==0|Aa)^1)){_a=Va;$a=Xa;ab=Ya;bb=Na}else{if(Ha){X=Va;ga=Wa;xa=Xa;ya=Ya;za=Oa;continue}else{Ba=Va;Ca=Oa;Da=Za;T=140;break}}while(1){Ha=bb;while(1){if(Ha>>>0>Ma>>>0){X=_a;ga=Wa;xa=$a;ya=ab;za=Oa;continue e}if((oeb(Ha)|0)!=0){T=118;break}cb=Ha+1|0;if((seb(Ha)|0)==0){Ha=cb}else{T=129;break}}if((T|0)==118){T=0;Sa=ueb(Ha)|0;Ga=Ha+1|0;g:do{if((oeb(Ga)|0)==0){db=Sa;eb=Ga}else{fb=Sa;gb=Ga;while(1){if((ueb(gb)|0)!=(fb+1|0)|gb>>>0>Ma>>>0){db=fb;eb=gb;break g}hb=ueb(gb)|0;ib=gb+1|0;if((oeb(ib)|0)==0){db=hb;eb=ib;break}else{fb=hb;gb=ib}}}}while(0);Ga=c[w>>2]|0;if(($a|0)<(ab|0)){jb=_a;kb=ab}else{if((ab|0)>1024){Ba=_a;Ca=Oa;Da=12;T=140;break e}gb=Afb(_a,ab<<3)|0;if((gb|0)==0){Ba=_a;Ca=Oa;Da=12;T=140;break e}else{jb=gb;kb=ab<<1}}gb=Xeb(Ga,0,0,1,32)|0;fb=gb;do{if((gb|0)==0){lb=0}else{Ia=Xeb(Ga,0,0,1,20)|0;c[gb+4>>2]=Ia;if((Ia|0)==0){lb=0;break}c[gb>>2]=0;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[Ia>>2]=Sa;c[Ia+4>>2]=db;c[Ia+8>>2]=-1;lb=fb}}while(0);c[jb+($a<<2)>>2]=lb;mb=lb;nb=jb;ob=kb;pb=eb}else if((T|0)==129){T=0;fb=web(Ha)|0;h:do{if((seb(cb)|0)==0){qb=fb;rb=cb}else{Sa=fb;gb=cb;while(1){if((web(gb)|0)!=(Sa+1|0)|gb>>>0>Ma>>>0){qb=Sa;rb=gb;break h}Ga=gb+1|0;Ia=web(gb)|0;if((seb(Ga)|0)==0){qb=Ia;rb=Ga;break}else{Sa=Ia;gb=Ga}}}}while(0);Ha=c[w>>2]|0;if(($a|0)<(ab|0)){sb=_a;tb=ab}else{if((ab|0)>1024){Ba=_a;Ca=Oa;Da=12;T=140;break e}gb=Afb(_a,ab<<3)|0;if((gb|0)==0){Ba=_a;Ca=Oa;Da=12;T=140;break e}else{sb=gb;tb=ab<<1}}gb=Xeb(Ha,0,0,1,32)|0;Sa=gb;do{if((gb|0)==0){ub=0}else{Ga=Xeb(Ha,0,0,1,20)|0;c[gb+4>>2]=Ga;if((Ga|0)==0){ub=0;break}c[gb>>2]=0;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[Ga>>2]=fb;c[Ga+4>>2]=qb;c[Ga+8>>2]=-1;ub=Sa}}while(0);c[sb+($a<<2)>>2]=ub;mb=ub;nb=sb;ob=tb;pb=rb}if((mb|0)==0){T=141;break e}else{_a=nb;$a=$a+1|0;ab=ob;bb=pb}}}i:do{if((T|0)==85){T=0;c[q>>2]=za+1;ya=(wa|0)!=0;if(ya){cc(X|0,xa|0,4,62)}j:do{if((xa|0)>0){$=(ga|0)>0;Aa=ga<<2;Sa=Aa+4|0;if(ya){vb=0;wb=0;xb=0;yb=0}else{fb=0;gb=0;while(1){Ha=X+(fb<<2)|0;Ga=c[(c[Ha>>2]|0)+4>>2]|0;do{if((Ga|0)==0){zb=gb;Ab=0}else{c[Ga+8>>2]=c[x>>2];if($){Ia=Xeb(c[w>>2]|0,0,0,0,Sa)|0;Fa=Ga+16|0;c[Fa>>2]=Ia;if((Ia|0)==0){Bb=X;Cb=gb;Db=12;break i}bgb(Ia|0,z|0,Aa|0)|0;c[(c[Fa>>2]|0)+(ga<<2)>>2]=0}else{c[Ga+16>>2]=0}if((gb|0)==0){zb=c[Ha>>2]|0;Ab=0;break}Fa=c[w>>2]|0;Ia=c[Ha>>2]|0;ib=Xeb(Fa,0,0,1,32)|0;hb=ib;do{if((ib|0)==0){Eb=0}else{Fb=Xeb(Fa,0,0,1,8)|0;Gb=ib+4|0;c[Gb>>2]=Fb;if((Fb|0)==0){Eb=0;break}c[ib>>2]=3;c[ib+8>>2]=-1;c[ib+12>>2]=-1;c[Fb>>2]=gb;c[(c[Gb>>2]|0)+4>>2]=Ia;c[ib+16>>2]=(c[Ia+16>>2]|0)+(c[gb+16>>2]|0);Eb=hb}}while(0);zb=Eb;Ab=(Eb|0)==0?12:0}}while(0);Ha=fb+1|0;if((Ha|0)<(xa|0)&(Ab|0)==0){fb=Ha;gb=zb}else{Hb=0;Ib=zb;Jb=Ab;break j}}}while(1){gb=X+(xb<<2)|0;fb=c[(c[gb>>2]|0)+4>>2]|0;Ha=c[fb>>2]|0;Ga=fb+4|0;hb=c[Ga>>2]|0;do{if((Ha|0)<(vb|0)){Ia=hb+1|0;Kb=(Ia|0)<(vb|0)?vb:Ia;Lb=wb;Mb=yb;Nb=0}else{if((Ha|0)<=(wb|0)){Ia=hb+1|0;Kb=Ia;Lb=Ia;Mb=yb;Nb=0;break}c[fb>>2]=wb;c[Ga>>2]=Ha+ -1;Ia=hb+1|0;if((fb|0)==0){Kb=Ia;Lb=Ia;Mb=yb;Nb=0;break}c[fb+8>>2]=c[x>>2];if($){ib=Xeb(c[w>>2]|0,0,0,0,Sa)|0;Fa=fb+16|0;c[Fa>>2]=ib;if((ib|0)==0){Bb=X;Cb=yb;Db=12;break i}bgb(ib|0,z|0,Aa|0)|0;c[(c[Fa>>2]|0)+(ga<<2)>>2]=0}else{c[fb+16>>2]=0}if((yb|0)==0){Kb=Ia;Lb=Ia;Mb=c[gb>>2]|0;Nb=0;break}Fa=c[w>>2]|0;ib=c[gb>>2]|0;Gb=Xeb(Fa,0,0,1,32)|0;Fb=Gb;do{if((Gb|0)==0){Ob=0}else{Pb=Xeb(Fa,0,0,1,8)|0;Qb=Gb+4|0;c[Qb>>2]=Pb;if((Pb|0)==0){Ob=0;break}c[Gb>>2]=3;c[Gb+8>>2]=-1;c[Gb+12>>2]=-1;c[Pb>>2]=yb;c[(c[Qb>>2]|0)+4>>2]=ib;c[Gb+16>>2]=(c[ib+16>>2]|0)+(c[yb+16>>2]|0);Ob=Fb}}while(0);Kb=Ia;Lb=Ia;Mb=Ob;Nb=(Ob|0)==0?12:0}}while(0);gb=xb+1|0;if((gb|0)<(xa|0)&(Nb|0)==0){vb=Kb;wb=Lb;xb=gb;yb=Mb}else{Hb=Lb;Ib=Mb;Jb=Nb;break}}}else{Hb=0;Ib=0;Jb=0}}while(0);if((Jb|0)!=0|ya^1){Bb=X;Cb=Ib;Db=Jb;break}Aa=c[w>>2]|0;Sa=c[x>>2]|0;$=Xeb(Aa,0,0,1,32)|0;gb=$;if(($|0)==0){Bb=X;Cb=Ib;Db=12;break}fb=Xeb(Aa,0,0,1,20)|0;c[$+4>>2]=fb;if((fb|0)==0){Bb=X;Cb=Ib;Db=12;break}c[$>>2]=0;c[$+8>>2]=-1;c[$+12>>2]=-1;c[fb>>2]=Hb;c[fb+4>>2]=1114111;c[fb+8>>2]=Sa;if((ga|0)>0){Sa=ga<<2;Aa=Xeb(c[w>>2]|0,0,0,0,Sa+4|0)|0;hb=fb+16|0;c[hb>>2]=Aa;if((Aa|0)==0){Bb=X;Cb=Ib;Db=12;break}bgb(Aa|0,z|0,Sa|0)|0;c[(c[hb>>2]|0)+(ga<<2)>>2]=0}else{c[fb+16>>2]=0}if((Ib|0)==0){Bb=X;Cb=gb;Db=0;break}fb=c[w>>2]|0;hb=Xeb(fb,0,0,1,32)|0;Sa=hb;do{if((hb|0)==0){Rb=0}else{Aa=Xeb(fb,0,0,1,8)|0;Ha=hb+4|0;c[Ha>>2]=Aa;if((Aa|0)==0){Rb=0;break}c[hb>>2]=3;c[hb+8>>2]=-1;c[hb+12>>2]=-1;c[Aa>>2]=Ib;c[(c[Ha>>2]|0)+4>>2]=gb;c[hb+16>>2]=(c[$+16>>2]|0)+(c[Ib+16>>2]|0);Rb=Sa}}while(0);Bb=X;Cb=Rb;Db=(Rb|0)==0?12:0}else if((T|0)==112){T=0;c[Ta+(xa<<2)>>2]=0;Ba=Ta;Ca=Oa;Da=12;T=140}else if((T|0)==141){T=0;c[q>>2]=Oa;Bb=nb;Cb=0;Db=12}}while(0);if((T|0)==140){T=0;c[q>>2]=Ca;Bb=Ba;Cb=0;Db=Da}yfb(Bb);c[x>>2]=(c[x>>2]|0)+1;if((Db|0)==0){U=M;V=Cb;W=0;break c}else{Z=Db;T=294;break b}break};case 46:{xa=(c[v>>2]&4|0)==0;X=c[w>>2]|0;ga=c[x>>2]|0;za=Xeb(X,0,0,1,32)|0;Sa=za;$=(za|0)==0;if(xa){if($){Z=12;T=294;break b}xa=Xeb(X,0,0,1,20)|0;c[za+4>>2]=xa;if((xa|0)==0){Z=12;T=294;break b}c[za>>2]=0;c[za+8>>2]=-1;c[za+12>>2]=-1;c[xa>>2]=0;c[xa+4>>2]=1114111;c[xa+8>>2]=ga;Sb=Sa;Tb=(c[x>>2]|0)+1|0}else{if($){Z=12;T=294;break b}$=Xeb(X,0,0,1,20)|0;c[za+4>>2]=$;if(($|0)==0){Z=12;T=294;break b}c[za>>2]=0;c[za+8>>2]=-1;c[za+12>>2]=-1;c[$>>2]=0;c[$+4>>2]=9;c[$+8>>2]=ga;ga=c[w>>2]|0;$=(c[x>>2]|0)+1|0;X=Xeb(ga,0,0,1,32)|0;if((X|0)==0){Z=12;T=294;break b}xa=Xeb(ga,0,0,1,20)|0;c[X+4>>2]=xa;if((xa|0)==0){Z=12;T=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[xa>>2]=11;c[xa+4>>2]=1114111;c[xa+8>>2]=$;$=c[w>>2]|0;xa=Xeb($,0,0,1,32)|0;if((xa|0)==0){Z=12;T=294;break b}ga=Xeb($,0,0,1,8)|0;$=xa+4|0;c[$>>2]=ga;if((ga|0)==0){Z=12;T=294;break b}c[xa>>2]=3;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[ga>>2]=Sa;c[(c[$>>2]|0)+4>>2]=X;c[xa+16>>2]=(c[X+16>>2]|0)+(c[za+16>>2]|0);Sb=xa;Tb=(c[x>>2]|0)+2|0}c[x>>2]=Tb;c[q>>2]=(c[q>>2]|0)+1;U=M;V=Sb;W=0;break c;break};case 94:{if((c[v>>2]&1|0)==0){if((Q|0)!=(c[r>>2]|0)){break d}xa=Neb(m,5)|0;if((xa|0)!=0){R=M;S=xa;T=6;break b}}xa=c[w>>2]|0;za=Xeb(xa,0,0,1,32)|0;if((za|0)==0){Z=12;T=294;break b}X=Xeb(xa,0,0,1,20)|0;c[za+4>>2]=X;if((X|0)==0){Z=12;T=294;break b}c[za>>2]=0;c[za+8>>2]=-1;c[za+12>>2]=-1;c[X>>2]=-2;c[X+4>>2]=1;c[X+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=za;W=0;break c;break};case 40:{if((c[v>>2]&1|0)!=0){Ub=Q;T=74}break};case 92:{za=Q+1|0;X=a[za]|0;do{if((c[v>>2]&1|0)==0){if(X<<24>>24==40){c[q>>2]=za;Ub=za;T=74;break d}else{xa=a[Q+1|0]|0;if(xa<<24>>24==41){T=265;break d}else{Wb=xa;break}}}else{Wb=X}}while(0);X=Q+1|0;za=Wb<<24>>24==0;if(za){Z=5;T=294;break b}else{Xb=207356|0;Yb=0}while(1){xa=Yb+1|0;if((a[207352+(Yb<<3)|0]|0)==Wb<<24>>24){Zb=Xb;break}$=207356+(xa<<3)|0;if((xa|0)==12){Zb=$;break}else{Xb=$;Yb=xa}}xa=c[Zb>>2]|0;if((xa|0)!=0){$=F+0|0;Sa=G+0|0;ga=$+40|0;do{c[$>>2]=c[Sa>>2];$=$+4|0;Sa=Sa+4|0}while(($|0)<(ga|0));c[H>>2]=xa;c[I>>2]=1;Sa=Geb(j)|0;if((Sa|0)!=0){Z=Sa;T=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];U=M;V=c[K>>2]|0;W=0;break c}if(za){Z=5;T=294;break b}c[q>>2]=X;Sa=a[X]|0;k:do{switch(Sa|0){case 62:{$=c[w>>2]|0;ga=Xeb($,0,0,1,32)|0;hb=ga;do{if((ga|0)==0){_b=0}else{gb=Xeb($,0,0,1,20)|0;c[ga+4>>2]=gb;if((gb|0)==0){_b=0;break}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[gb>>2]=-2;c[gb+4>>2]=32;c[gb+8>>2]=-1;_b=hb}}while(0);c[q>>2]=(c[q>>2]|0)+1;$b=_b;break};case 120:{hb=Q+2|0;c[q>>2]=hb;ga=a[hb]|0;if(ga<<24>>24==123){hb=Q+3|0;c[q>>2]=hb;$=hb;hb=0;while(1){gb=a[$]|0;if(gb<<24>>24==0|gb<<24>>24==125){ac=hb;bc=$;break}if((teb(gb<<24>>24)|0)==0){Z=9;T=294;break b}gb=c[q>>2]|0;a[l+hb|0]=a[gb]|0;fb=hb+1|0;ya=gb+1|0;c[q>>2]=ya;if(fb>>>0>31){ac=fb;bc=ya;break}else{$=ya;hb=fb}}c[q>>2]=bc+1;a[l+ac|0]=0;hb=Vb(C|0,0,16)|0;$=c[w>>2]|0;fb=c[x>>2]|0;ya=Xeb($,0,0,1,32)|0;gb=ya;do{if((ya|0)==0){dc=0}else{Ha=Xeb($,0,0,1,20)|0;c[ya+4>>2]=Ha;if((Ha|0)==0){dc=0;break}c[ya>>2]=0;c[ya+8>>2]=-1;c[ya+12>>2]=-1;c[Ha>>2]=hb;c[Ha+4>>2]=hb;c[Ha+8>>2]=fb;dc=gb}}while(0);c[x>>2]=(c[x>>2]|0)+1;$b=dc;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;gb=(teb(ga<<24>>24)|0)==0;fb=c[q>>2]|0;if(gb){ec=fb}else{a[D]=a[fb]|0;gb=fb+1|0;c[q>>2]=gb;ec=gb}if((teb(a[ec]|0)|0)!=0){gb=c[q>>2]|0;a[E]=a[gb]|0;c[q>>2]=gb+1}gb=Vb(D|0,0,16)|0;fb=c[w>>2]|0;hb=c[x>>2]|0;ya=Xeb(fb,0,0,1,32)|0;$=ya;do{if((ya|0)==0){fc=0}else{Ha=Xeb(fb,0,0,1,20)|0;c[ya+4>>2]=Ha;if((Ha|0)==0){fc=0;break}c[ya>>2]=0;c[ya+8>>2]=-1;c[ya+12>>2]=-1;c[Ha>>2]=gb;c[Ha+4>>2]=gb;c[Ha+8>>2]=hb;fc=$}}while(0);c[x>>2]=(c[x>>2]|0)+1;$b=fc;break k}break};case 98:{$=c[w>>2]|0;hb=Xeb($,0,0,1,32)|0;gb=hb;do{if((hb|0)==0){gc=0}else{ya=Xeb($,0,0,1,20)|0;c[hb+4>>2]=ya;if((ya|0)==0){gc=0;break}c[hb>>2]=0;c[hb+8>>2]=-1;c[hb+12>>2]=-1;c[ya>>2]=-2;c[ya+4>>2]=64;c[ya+8>>2]=-1;gc=gb}}while(0);c[q>>2]=(c[q>>2]|0)+1;$b=gc;break};case 60:{gb=c[w>>2]|0;hb=Xeb(gb,0,0,1,32)|0;$=hb;do{if((hb|0)==0){hc=0}else{ya=Xeb(gb,0,0,1,20)|0;c[hb+4>>2]=ya;if((ya|0)==0){hc=0;break}c[hb>>2]=0;c[hb+8>>2]=-1;c[hb+12>>2]=-1;c[ya>>2]=-2;c[ya+4>>2]=16;c[ya+8>>2]=-1;hc=$}}while(0);c[q>>2]=(c[q>>2]|0)+1;$b=hc;break};case 66:{$=c[w>>2]|0;hb=Xeb($,0,0,1,32)|0;gb=hb;do{if((hb|0)==0){ic=0}else{ya=Xeb($,0,0,1,20)|0;c[hb+4>>2]=ya;if((ya|0)==0){ic=0;break}c[hb>>2]=0;c[hb+8>>2]=-1;c[hb+12>>2]=-1;c[ya>>2]=-2;c[ya+4>>2]=128;c[ya+8>>2]=-1;ic=gb}}while(0);c[q>>2]=(c[q>>2]|0)+1;$b=ic;break};default:{if((meb(Sa)|0)!=0){gb=(a[c[q>>2]|0]|0)+ -48|0;hb=c[w>>2]|0;$=c[x>>2]|0;ya=Xeb(hb,0,0,1,32)|0;if((ya|0)==0){Z=12;T=294;break b}fb=Xeb(hb,0,0,1,20)|0;c[ya+4>>2]=fb;if((fb|0)==0){Z=12;T=294;break b}c[ya>>2]=0;c[ya+8>>2]=-1;c[ya+12>>2]=-1;c[fb>>2]=-4;c[fb+4>>2]=gb;c[fb+8>>2]=$;c[x>>2]=(c[x>>2]|0)+1;$=c[B>>2]|0;c[B>>2]=(gb|0)<($|0)?$:gb;c[q>>2]=(c[q>>2]|0)+1;U=M;V=ya;W=0;break c}ya=c[w>>2]|0;gb=a[c[q>>2]|0]|0;$=c[x>>2]|0;fb=Xeb(ya,0,0,1,32)|0;hb=fb;do{if((fb|0)==0){jc=0}else{ga=Xeb(ya,0,0,1,20)|0;c[fb+4>>2]=ga;if((ga|0)==0){jc=0;break}c[fb>>2]=0;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[ga>>2]=gb;c[ga+4>>2]=gb;c[ga+8>>2]=$;jc=hb}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;$b=jc}}}while(0);if(($b|0)==0){Z=12;T=294;break b}else{U=M;V=$b;W=0;break c}break};default:{}}}while(0);if((T|0)==74){T=0;_=M+1|0;c[q>>2]=Ub+1;Y=Neb(m,c[y>>2]|0)|0;if((Y|0)!=0){R=_;S=Y;T=6;break b}Y=Neb(m,2)|0;if((Y|0)!=0){R=_;S=Y;T=6;break b}Y=Neb(m,0)|0;if((Y|0)!=0){R=_;S=Y;T=6;break b}c[y>>2]=(c[y>>2]|0)+1;U=_;V=N;W=0;break c}else if((T|0)==264){T=0;if((c[v>>2]&1|0)!=0){T=265}}if((T|0)==265){T=0;_=c[w>>2]|0;Y=Xeb(_,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}Sa=Xeb(_,0,0,1,20)|0;c[Y+4>>2]=Sa;if((Sa|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Sa>>2]=-1;c[Sa+4>>2]=-1;c[Sa+8>>2]=-1;U=M;V=Y;W=0;break c}Y=Beb(h,Q,-1)|0;if((Y|0)<0){c[h>>2]=-1;kc=1}else{kc=Y}do{if((c[v>>2]&2|0)==0){T=280}else{if((seb(c[h>>2]|0)|0)==0){if((oeb(c[h>>2]|0)|0)==0){T=280;break}}Y=c[w>>2]|0;Sa=ueb(c[h>>2]|0)|0;_=ueb(c[h>>2]|0)|0;X=c[x>>2]|0;za=Xeb(Y,0,0,1,32)|0;if((za|0)==0){Z=12;T=294;break b}xa=Xeb(Y,0,0,1,20)|0;c[za+4>>2]=xa;if((xa|0)==0){Z=12;T=294;break b}c[za>>2]=0;c[za+8>>2]=-1;c[za+12>>2]=-1;c[xa>>2]=Sa;c[xa+4>>2]=_;c[xa+8>>2]=X;X=c[w>>2]|0;xa=web(c[h>>2]|0)|0;_=web(c[h>>2]|0)|0;Sa=c[x>>2]|0;Y=Xeb(X,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}hb=Xeb(X,0,0,1,20)|0;c[Y+4>>2]=hb;if((hb|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[hb>>2]=xa;c[hb+4>>2]=_;c[hb+8>>2]=Sa;Sa=c[w>>2]|0;hb=Xeb(Sa,0,0,1,32)|0;if((hb|0)==0){Z=12;T=294;break b}_=Xeb(Sa,0,0,1,8)|0;Sa=hb+4|0;c[Sa>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[hb>>2]=3;c[hb+8>>2]=-1;c[hb+12>>2]=-1;c[_>>2]=za;c[(c[Sa>>2]|0)+4>>2]=Y;c[hb+16>>2]=(c[Y+16>>2]|0)+(c[za+16>>2]|0);lc=hb}}while(0);if((T|0)==280){T=0;Q=c[w>>2]|0;hb=c[h>>2]|0;za=c[x>>2]|0;Y=Xeb(Q,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}Sa=Xeb(Q,0,0,1,20)|0;c[Y+4>>2]=Sa;if((Sa|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Sa>>2]=hb;c[Sa+4>>2]=hb;c[Sa+8>>2]=za;lc=Y}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+kc;U=M;V=lc;W=0;break};default:{U=M;V=N;W=0}}}while(0);P=c[n>>2]|0;O=(W|0)==0;if((P|0)>(o|0)&O){L=P;M=U;N=V}else{mc=O;nc=U;oc=V;pc=W;break a}}if((T|0)==6){mc=(S|0)==0;nc=R;oc=N;pc=S;break}else if((T|0)==294){i=d;return Z|0}}else{mc=t;nc=0;oc=0;pc=p}}while(0);p=(nc|0)>0;if(p|mc^1){Z=p?8:pc;i=d;return Z|0}c[b+8>>2]=oc;Z=0;i=d;return Z|0}function Heb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=xfb((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=xfb((l<<2)+4|0)|0;if((p|0)==0){yfb(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}Neb(d,e)|0;e=Neb(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 6:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;E=0;do{G=A+(E<<2)|0;E=E+1|0}while((c[G>>2]|0)>-1);c[G>>2]=F<<1|1;c[A+(E<<2)>>2]=-1;H=0;while(1){if((c[p+(H<<2)>>2]|0)>-1){H=H+1|0}else{break}}c[p+(H+ -1<<2)>>2]=-1;I=v;J=w;K=x;L=y;M=z;N=A;O=0;P=B;break};case 1:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;if(k){E=c[(c[c[F+4>>2]>>2]|0)+20>>2]|0;Q=u+ -3|0;c[h>>2]=Q;c[F+20>>2]=(c[D+(Q<<2)>>2]|0)+E;I=v;J=-1;K=x;L=y;M=z;N=A;O=0;P=B;break b}else{E=u+ -3|0;c[h>>2]=E;Q=c[D+(E<<2)>>2]|0;E=u+ -4|0;c[h>>2]=E;F=(Q|0)==0;I=F&1;J=F?w:c[D+(E<<2)>>2]|0;K=x;L=y;M=z;N=A;O=0;P=B;break b}break};case 3:{E=c[D+(u+ -2<<2)>>2]|0;F=c[D+(u+ -3<<2)>>2]|0;Q=c[D+(u+ -4<<2)>>2]|0;R=u+ -5|0;c[h>>2]=R;if(k){S=c[Q+4>>2]|0;T=Q+16|0;c[Q+20>>2]=(c[(c[S>>2]|0)+20>>2]|0)+(c[D+(R<<2)>>2]|0)+(c[(c[S+4>>2]|0)+20>>2]|0)+((c[T>>2]|0)>0?2:0);U=T;V=c[h>>2]|0}else{U=Q+16|0;V=R}R=c[D+(V+ -1<<2)>>2]|0;Q=V+ -2|0;c[h>>2]=Q;T=c[D+(Q<<2)>>2]|0;Q=V+ -3|0;c[h>>2]=Q;S=c[D+(Q<<2)>>2]|0;if((c[U>>2]|0)<=0){I=1;J=w;K=x;L=y;M=z;N=R;O=0;P=B;break b}if(k){W=0}else{Qeb(b,E,T)|0;c[(c[r>>2]|0)+(T<<2)>>2]=1;T=Qeb(b,F,S)|0;c[(c[r>>2]|0)+(S<<2)>>2]=1;W=T}I=1;J=w;K=x;L=y;M=z+2|0;N=R;O=W;P=B;break};case 0:{R=u+ -2|0;c[h>>2]=R;T=c[D+(R<<2)>>2]|0;R=T;S=T+12|0;F=c[S>>2]|0;if((F|0)>-1){E=0;do{X=A+(E<<2)|0;E=E+1|0}while((c[X>>2]|0)>-1);c[X>>2]=F<<1;c[A+(E<<2)>>2]=-1;do{if(!k){H=0;while(1){if((c[p+(H<<2)>>2]|0)>-1){H=H+1|0}else{break}}c[(c[s>>2]|0)+(F*12|0)+8>>2]=0;if((H|0)<=0){break}Q=xfb((H<<2)+4|0)|0;Y=Q;if((Q|0)==0){Z=w;_=y;$=z;aa=A;ba=12;ca=B;break a}c[(c[s>>2]|0)+(F*12|0)+8>>2]=Y;da=c[p>>2]|0;if((da|0)>-1){ea=Y;fa=da;da=0;while(1){c[ea>>2]=fa;ga=da+1|0;ha=c[p+(ga<<2)>>2]|0;ia=Q+(ga<<2)|0;if((ha|0)>-1){da=ga;fa=ha;ea=ia}else{ja=ia;break}}}else{ja=Y}c[ja>>2]=-1}}while(0);F=Neb(d,c[S>>2]|0)|0;if((F|0)!=0){Z=w;_=y;$=z;aa=A;ba=F;ca=B;break a}F=Neb(d,6)|0;if((F|0)!=0){Z=w;_=y;$=z;aa=A;ba=F;ca=B;break a}}F=c[T>>2]|0;do{if((F|0)==0){E=c[c[T+4>>2]>>2]|0;if(!((E|0)>-1|(E|0)==-4)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(!((c[A>>2]|0)>-1)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(k){c[T+20>>2]=1;ra=w;sa=y;ta=0}else{E=Peb(b,R,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){ea=c[t>>2]|0;fa=0;while(1){ua=ea+(fa<<2)|0;va=fa+1|0;if((c[ua>>2]|0)>-1){fa=va}else{break}}c[ua>>2]=B;c[ea+(va<<2)>>2]=w;c[ea+(fa+2<<2)>>2]=-1;wa=-1;xa=y+1|0}else{wa=w;xa=y}Y=c[A>>2]|0;if((Y|0)>-1){da=c[s>>2]|0;Q=Y;Y=0;do{H=(Q|0)/2|0;if((Q&1|0)==0){c[da+(H*12|0)>>2]=B}else{c[da+(H*12|0)+4>>2]=B}Y=Y+1|0;Q=c[A+(Y<<2)>>2]|0;}while((Q|0)>-1)}c[A>>2]=-1;ra=wa;sa=xa;ta=E}c[A>>2]=-1;ka=v;la=ra;ma=x+1|0;na=sa;oa=z+1|0;pa=ta;qa=x}else if((F|0)==2){Q=c[T+4>>2]|0;if(k){if((c[A>>2]|0)>-1){ya=1}else{ya=a[Q+12|0]&1}Y=Neb(d,ya)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}}else{Y=Neb(d,B)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=Neb(d,a[Q+12|0]&1)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}}Y=Neb(d,T)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=Neb(d,1)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=Neb(d,c[Q>>2]|0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=Neb(d,0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}if(!((c[A>>2]|0)>-1)){if((a[Q+12|0]&1)==0){ka=0;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}}if(k){za=w;Aa=y;Ba=0}else{Y=Peb(b,R,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[Q+12|0]&1)==0?v:1;if((w|0)>-1){Q=c[t>>2]|0;da=0;while(1){Ca=Q+(da<<2)|0;Da=da+1|0;if((c[Ca>>2]|0)>-1){da=Da}else{break}}c[Ca>>2]=B;c[Q+(Da<<2)>>2]=w;c[Q+(da+2<<2)>>2]=-1;Ea=-1;Fa=y+1|0}else{Ea=w;Fa=y}E=c[A>>2]|0;if((E|0)>-1){fa=c[s>>2]|0;ea=E;E=0;do{H=(ea|0)/2|0;if((ea&1|0)==0){c[fa+(H*12|0)>>2]=B}else{c[fa+(H*12|0)+4>>2]=B}E=E+1|0;ea=c[A+(E<<2)>>2]|0;}while((ea|0)>-1)}c[A>>2]=-1;za=Ea;Aa=Fa;Ba=Y}c[A>>2]=-1;ka=0;la=za;ma=x+1|0;na=Aa;oa=z+1|0;pa=Ba;qa=x}else if((F|0)==1){ea=c[T+4>>2]|0;E=c[ea>>2]|0;fa=c[ea+4>>2]|0;ea=Neb(d,T)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=Neb(d,5)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=Neb(d,fa)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=Neb(d,0)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=E+20|0;da=Neb(d,(c[ea>>2]|0)+x|0)|0;if((da|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=da;qa=B;break}if((c[ea>>2]|0)>0){ea=(c[fa+20>>2]|0)>0;Ga=(ea&1)+x|0;Ha=ea?x:-1}else{Ga=x;Ha=-1}ea=Neb(d,Ha)|0;if((ea|0)!=0){ka=v;la=w;ma=Ga;na=y;oa=z;pa=ea;qa=B;break}ea=Neb(d,4)|0;if((ea|0)!=0){ka=v;la=w;ma=Ga;na=y;oa=z;pa=ea;qa=B;break}ea=Neb(d,E)|0;if((ea|0)!=0){ka=v;la=w;ma=Ga;na=y;oa=z;pa=ea;qa=B;break}ka=v;la=w;ma=Ga;na=y;oa=z;pa=Neb(d,0)|0;qa=B}else if((F|0)==3){ea=c[T+4>>2]|0;E=c[ea>>2]|0;fa=c[ea+4>>2]|0;ea=(c[A>>2]|0)>-1;da=x+1|0;Q=Neb(d,ea?da:x)|0;if((Q|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Q;qa=B;break}Q=Neb(d,ea?x:B)|0;if((Q|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Q;qa=B;break}Q=Neb(d,A)|0;if((Q|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Q;qa=B;break}Q=Neb(d,(c[A>>2]|0)>>>31^1)|0;if((Q|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Q;qa=B;break}Q=Neb(d,T)|0;if((Q|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Q;qa=B;break}Q=fa;fa=Neb(d,Q)|0;if((fa|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=fa;qa=B;break}fa=E;E=Neb(d,fa)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=Neb(d,3)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=Neb(d,Q)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=Neb(d,0)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=Neb(d,2)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=Neb(d,fa)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=Neb(d,0)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}if((c[A>>2]|0)>-1){if(k){Ia=w;Ja=y;Ka=0}else{E=Peb(b,R,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){fa=c[t>>2]|0;Q=0;while(1){La=fa+(Q<<2)|0;Ma=Q+1|0;if((c[La>>2]|0)>-1){Q=Ma}else{break}}c[La>>2]=B;c[fa+(Ma<<2)>>2]=w;c[fa+(Q+2<<2)>>2]=-1;Na=-1;Oa=y+1|0}else{Na=w;Oa=y}Y=c[A>>2]|0;if((Y|0)>-1){ea=c[s>>2]|0;H=Y;Y=0;do{ia=(H|0)/2|0;if((H&1|0)==0){c[ea+(ia*12|0)>>2]=B}else{c[ea+(ia*12|0)+4>>2]=B}Y=Y+1|0;H=c[A+(Y<<2)>>2]|0;}while((H|0)>-1)}c[A>>2]=-1;Ia=Na;Ja=Oa;Ka=E}c[A>>2]=-1;Pa=Ia;Qa=da;Ra=Ja;Sa=z+1|0;Ta=Ka;Ua=x}else{Pa=w;Qa=x;Ra=y;Sa=z;Ta=0;Ua=B}if((c[T+16>>2]|0)<=0){ka=v;la=Pa;ma=Qa;na=Ra;oa=Sa;pa=Ta;qa=Ua;break}ka=v;la=Pa;ma=Qa+2|0;na=Ra;oa=Sa;pa=Ta;qa=Qa+1|0}else{ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B}}while(0);T=c[S>>2]|0;if((T|0)>-1){Va=0}else{I=ka;J=la;K=ma;L=na;M=oa;N=A;O=pa;P=qa;break b}do{Wa=p+(Va<<2)|0;Va=Va+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=T;c[p+(Va<<2)>>2]=-1;I=ka;J=la;K=ma;L=na;M=oa;N=A;O=pa;P=qa;break};case 4:{S=u+ -2|0;c[h>>2]=S;R=c[D+(S<<2)>>2]|0;S=u+ -3|0;c[h>>2]=S;I=v;J=w;K=c[D+(S<<2)>>2]|0;L=y;M=z;N=A;O=0;P=(R|0)>-1?R:B;break};case 2:{R=A;while(1){if((c[R>>2]|0)>-1){R=R+4|0}else{I=v;J=w;K=x;L=y;M=z;N=R;O=0;P=B;break}}break};case 5:{R=u+ -2|0;c[h>>2]=R;T=c[D+(R<<2)>>2]|0;if(!k){I=v;J=w;K=x;L=y;M=z;N=A;O=0;P=B;break b}R=c[T+4>>2]|0;c[T+20>>2]=(c[(c[R+4>>2]|0)+20>>2]|0)+(c[(c[R>>2]|0)+20>>2]|0);I=v;J=w;K=x;L=y;M=z;N=A;O=0;P=B;break};default:{I=v;J=w;K=x;L=y;M=z;N=A;O=0;P=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(O|0)==0){u=D;v=I;w=J;x=K;y=L;z=M;A=N;B=P}else{Z=J;_=L;$=M;aa=N;ba=O;ca=P;break a}}}else{Z=-1;_=0;$=0;aa=n;ba=e;ca=0}}while(0);do{if(k){Xa=_}else{e=c[aa>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;P=e;e=0;do{O=(P|0)/2|0;if((P&1|0)==0){c[n+(O*12|0)>>2]=ca}else{c[n+(O*12|0)+4>>2]=ca}e=e+1|0;P=c[aa+(e<<2)>>2]|0;}while((P|0)>-1)}c[aa>>2]=-1;if(!((Z|0)>-1)){Xa=_;break}P=c[f+36>>2]|0;e=0;while(1){Ya=P+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=ca;c[P+(Za<<2)>>2]=Z;c[P+(e+2<<2)>>2]=-1;Xa=_+1|0}}while(0);c[f+48>>2]=$;c[f+40>>2]=$;c[f+44>>2]=Xa;yfb(m);yfb(p);o=ba;i=g;return o|0}function Ieb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==2){h=c[g+4>>2]|0;j=h;if(!((c[h+8>>2]|0)==-1)){k=j;break}l=c[h>>2]|0;h=Keb(c[l+28>>2]|0,c[l+24>>2]|0,b,d,e)|0;if((h|0)==0){k=j}else{m=h;n=10;break a}}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;l=Keb(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((l|0)!=0){m=l;n=10;break a}l=Ieb(c[h>>2]|0,b,d,e)|0;if((l|0)==0){k=j}else{m=l;n=10;break a}}else if((a|0)==3){l=c[g+4>>2]|0;j=Ieb(c[l>>2]|0,b,d,e)|0;if((j|0)!=0){m=j;n=10;break a}k=l+4|0}else{m=0;n=10;break a}}while(0);g=c[k>>2]|0}if((n|0)==10){i=f;return m|0}return 0}function Jeb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{yfb(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}yfb(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){yfb(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){yfb(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}yfb(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{yfb(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}yfb(m)}m=c[d+32>>2]|0;if((m|0)!=0){yfb(m)}m=c[d+20>>2]|0;if((m|0)!=0){yfb(m)}m=c[d+36>>2]|0;if((m|0)!=0){yfb(m)}yfb(d);i=b;return}function Keb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=xfb(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){yfb(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=xfb((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function Leb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=Xeb(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=Xeb(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=Xeb(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function Meb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=Neb(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==2){r=c[c[o+4>>2]>>2]|0;if((c[r+8>>2]|0)==0){continue a}s=Neb(a,r)|0}else if((q|0)==1){r=c[o+4>>2]|0;t=Neb(a,c[r>>2]|0)|0;if((t|0)!=0){m=t;p=28;break a}s=Neb(a,c[r+4>>2]|0)|0}else if((q|0)==3){r=c[o+4>>2]|0;t=c[r>>2]|0;if((c[t+8>>2]|0)!=0){s=Neb(a,t)|0;break}t=c[r+4>>2]|0;if((c[t+8>>2]|0)==0){continue a}s=Neb(a,t)|0}else if((q|0)==0){t=c[o+4>>2]|0;r=c[t>>2]|0;if((r|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[t+4>>2];continue a}else if(!((r|0)==-3)){continue a}r=c[t+4>>2]|0;if(!((r|0)>-1)){continue a}b:do{if(!b){t=c[d>>2]|0;c:do{if((t|0)>-1){u=t;v=d;w=0;while(1){x=w+1|0;if((u|0)==(r|0)){break}y=d+(x<<2)|0;z=c[y>>2]|0;if((z|0)>-1){u=z;v=y;w=x}else{A=y;B=x;break c}}if((r|0)<0){A=v;B=w}else{break b}}else{A=d;B=0}}while(0);c[A>>2]=r;c[d+(B+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else{continue a}}while(0);if((s|0)!=0){m=s;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function Neb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=Afb(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;Neb(a,b)|0;i=d;return 0}return 0}function Oeb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;Neb(d,e)|0;e=Neb(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==3){y=c[u+4>>2]|0;x=c[y>>2]|0;D=y+4|0;E=c[D>>2]|0;F=Xeb(b,0,0,1,32)|0;if((F|0)==0){G=20;break b}H=Xeb(b,0,0,1,8)|0;I=F+4|0;c[I>>2]=H;if((H|0)==0){G=20;break b}c[F>>2]=3;c[F+8>>2]=-1;c[F+12>>2]=-1;c[H>>2]=x;c[(c[I>>2]|0)+4>>2]=E;c[F+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=F;F=c[I>>2]|0;I=Neb(d,c[D>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}I=Neb(d,0)|0;if((I|0)!=0){v=s;w=I;break a}I=Neb(d,F+4|0)|0;if((I|0)!=0){v=s;w=I;break a}I=Neb(d,1)|0;if((I|0)!=0){v=s;w=I;break a}I=Neb(d,c[y>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}J=r;K=s;L=F;M=Neb(d,0)|0}else if((z|0)==0){F=c[u+4>>2]|0;I=c[F+8>>2]|0;y=c[F>>2]|0;D=c[F+4>>2]|0;do{if((y|0)>-1|(y|0)==-4){N=r;O=D;P=y;Q=s+1|0;R=(c[g>>2]|0)+I|0}else{if(!((y|0)==-3)){N=r;O=D;P=y;Q=s;R=I;break}if(!p){N=r;O=-1;P=-1;Q=s;R=-1;break}if(q|(r|0)==0){N=r;O=D;P=-3;Q=s;R=I;break}c[h+(D<<2)>>2]=1;N=0;O=D;P=-3;Q=s;R=I}}while(0);I=Xeb(b,0,0,1,32)|0;D=I;do{if((I|0)==0){S=0}else{y=Xeb(b,0,0,1,20)|0;c[I+4>>2]=y;if((y|0)==0){S=0;break}c[I>>2]=0;c[I+8>>2]=-1;c[I+12>>2]=-1;c[y>>2]=P;c[y+4>>2]=O;c[y+8>>2]=R;S=D}}while(0);c[t>>2]=S;D=(S|0)==0?12:0;if((R|0)<=(c[k>>2]|0)){J=N;K=Q;L=t;M=D;break}c[k>>2]=R;J=N;K=Q;L=t;M=D}else if((z|0)==2){D=c[u+4>>2]|0;I=Neb(d,c[D>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}I=Neb(d,0)|0;if((I|0)!=0){v=s;w=I;break a}I=c[D>>2]|0;y=c[D+4>>2]|0;F=c[D+8>>2]|0;x=a[D+12|0]|0;D=Xeb(b,0,0,1,32)|0;if((D|0)==0){G=40;break b}E=Xeb(b,0,0,1,16)|0;H=D+4|0;c[H>>2]=E;if((E|0)==0){G=40;break b}c[D>>2]=2;c[D+8>>2]=-1;c[D+12>>2]=-1;c[E>>2]=I;c[E+4>>2]=y;c[E+8>>2]=F;F=E+12|0;a[F]=a[F]&-2|x&1;c[D+16>>2]=c[I+16>>2];c[t>>2]=D;A=s;B=r;t=c[H>>2]|0;s=A;r=B;continue b}else if((z|0)==1){H=c[u+4>>2]|0;D=c[H>>2]|0;I=H+4|0;x=c[I>>2]|0;F=Xeb(b,0,0,1,32)|0;if((F|0)==0){G=29;break b}E=Xeb(b,0,0,1,8)|0;y=F+4|0;c[y>>2]=E;if((E|0)==0){G=29;break b}c[F>>2]=1;c[F+8>>2]=-1;c[F+12>>2]=-1;c[E>>2]=D;c[(c[y>>2]|0)+4>>2]=x;c[F+16>>2]=(c[x+16>>2]|0)+(c[D+16>>2]|0);c[t>>2]=F;F=c[y>>2]|0;c[F>>2]=0;y=F+4|0;c[y>>2]=0;D=Neb(d,c[I>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}D=Neb(d,0)|0;if((D|0)!=0){v=s;w=D;break a}D=Neb(d,y)|0;if((D|0)!=0){v=s;w=D;break a}D=Neb(d,1)|0;if((D|0)!=0){v=s;w=D;break a}D=Neb(d,c[H>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}J=r;K=s;L=F;M=Neb(d,0)|0}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((M|0)==0){r=J;s=K;t=L}else{v=K;w=M;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function Peb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=Xeb(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=Xeb(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=Xeb(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=Xeb(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function Qeb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=Xeb(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=Xeb(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=Xeb(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=Xeb(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function Reb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function Seb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=207600}else{j=b;k=207600;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+(($fb(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Mc(e|0,f|0,207888,g|0)|0)+1|0;i=d;return h|0}function Teb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=xfb(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=xfb(y)|0;if((z|0)==0){A=12;break}dgb(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=Beb(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((geb(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((geb(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((geb(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((geb(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(geb(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(geb(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(geb(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(geb(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){dgb(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=Beb(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((geb(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((geb(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((geb(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((geb(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(geb(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(geb(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(geb(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(geb(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((keb(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=web(X)|0;qb=_a+24|0;if((keb(fb,c[qb>>2]|0)|0)!=0){break}fb=ueb(X)|0;if((keb(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((keb(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=ueb(X)|0;if((keb(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=web(X)|0;if((keb(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}yfb(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=Veb(0,0)|0;if((S|0)==0){A=12;break}R=Xeb(S,0,0,0,32)|0;Q=R;if((R|0)==0){Web(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=xfb(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=xfb(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=xfb(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){dgb(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){dgb(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=Beb(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((geb(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((geb(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((geb(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((geb(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(geb(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(geb(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(geb(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(geb(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=Xeb(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=Xeb(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;Ueb(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((Yfb(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=Beb(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=Beb(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((geb(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((geb(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((geb(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((geb(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(geb(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(geb(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(geb(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(geb(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((keb(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=web(tc)|0;aa=Ca+24|0;if((keb(qa,c[aa>>2]|0)|0)!=0){break}qa=ueb(tc)|0;if((keb(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((keb(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=ueb(tc)|0;if((keb(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=web(tc)|0;if((keb(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=Xeb(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=Xeb(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){Web(S);if((Eb|0)!=0){yfb(O)}if((Kb|0)!=0){yfb(Kb)}if((Lb|0)==0){A=12;break a}yfb(N);A=12;break a}else if((sa|0)==67){Web(S);if((Eb|0)!=0){yfb(O)}if((Kb|0)!=0){yfb(Kb)}if((Lb|0)==0){A=12;break a}yfb(N);A=12;break a}else if((sa|0)==169){Web(S);if((Eb|0)!=0){yfb(O)}if((Kb|0)!=0){yfb(Kb)}if((Lb|0)==0){A=12;break a}yfb(N);A=12;break a}else if((sa|0)==176){Web(S);if((Eb|0)!=0){yfb(O)}if((Kb|0)!=0){yfb(Kb)}if((Lb|0)==0){A=12;break a}yfb(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);Web(S);if((Jb|0)!=0){yfb(Jb)}if((Gb|0)!=0){yfb(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}yfb(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}Ueb(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}yfb(m);p=A;i=g;return p|0}function Ueb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function Veb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=zfb(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function Web(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;yfb(e);i=b;return}else{f=d}while(1){yfb(c[f>>2]|0);d=c[f+4>>2]|0;yfb(f);if((d|0)==0){break}else{f=d}}e=a;yfb(e);i=b;return}function Xeb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=xfb(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=xfb(p)|0;c[o>>2]=r;if((r|0)==0){yfb(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}dgb(m|0,0,h|0)|0;j=m;i=g;return j|0}function Yeb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((Zeb(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function Zeb(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function _eb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function $eb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function afb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function bfb(a){a=a|0;i=i;return}function cfb(a){a=a|0;c[a>>2]=207904;i=i;return}function dfb(a){a=a|0;var b=0;b=i;zb(a|0);Ffb(a);i=b;return}function efb(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function ffb(a){a=a|0;i=i;return 207920}function gfb(a){a=a|0;i=i;return}function hfb(a){a=a|0;i=i;return}function ifb(a){a=a|0;i=i;return}function jfb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function kfb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function lfb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function mfb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=qfb(b,208032,208088,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;Ie[c[(c[h>>2]|0)+28>>2]&63](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function nfb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function ofb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;Ie[c[(c[h>>2]|0)+28>>2]&63](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function pfb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;Ie[c[(c[l>>2]|0)+28>>2]&63](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;Ie[c[(c[m>>2]|0)+28>>2]&63](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}



function Abb(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[47964]|0)==-1)){c[p>>2]=191856;c[p+4>>2]=445;c[p+8>>2]=0;d5a(191856,p,446)}p=(c[191860>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ec(4)|0;I=H;cfb(I);J=207976;K=127;Td(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ec(4)|0;I=H;cfb(I);J=207976;K=127;Td(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ge[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ge[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}E5a(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;s5a(s)}else{ge[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ge[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}E5a(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;s5a(v)}a[g]=ie[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=ie[c[(c[e>>2]|0)+16>>2]&127](K)|0;ge[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}E5a(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;s5a(w);ge[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}E5a(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;s5a(x);L=ie[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[47948]|0)==-1)){c[o>>2]=191792;c[o+4>>2]=445;c[o+8>>2]=0;d5a(191792,o,446)}o=(c[191796>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ec(4)|0;N=M;cfb(N);O=207976;P=127;Td(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ec(4)|0;N=M;cfb(N);O=207976;P=127;Td(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ge[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ge[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}E5a(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;s5a(A)}else{ge[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ge[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}E5a(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;s5a(D)}a[g]=ie[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=ie[c[(c[G>>2]|0)+16>>2]&127](P)|0;ge[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}E5a(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;s5a(E);ge[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}E5a(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;s5a(F);L=ie[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function Bbb(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 2:{I=a[q]|0;J=(I&1)==0;if(J){K=(I&255)>>>1}else{K=c[A>>2]|0}if((K|0)==0|x){L=H;break a}if(J){M=y;N=(I&255)>>>1}else{M=c[z>>2]|0;N=c[A>>2]|0}I=M+N|0;J=c[f>>2]|0;if((M|0)==(I|0)){O=J}else{P=J;J=M;while(1){a[P]=a[J]|0;Q=J+1|0;R=P+1|0;if((Q|0)==(I|0)){O=R;break}else{J=Q;P=R}}}c[f>>2]=O;L=H;break};case 4:{P=c[f>>2]|0;J=l?H+1|0:H;b:do{if(J>>>0<j>>>0){I=J;while(1){R=a[I]|0;if(!(R<<24>>24>-1)){S=I;break b}Q=I+1|0;if((b[(c[F>>2]|0)+(R<<24>>24<<1)>>1]&2048)==0){S=I;break b}if(Q>>>0<j>>>0){I=Q}else{S=Q;break}}}else{S=J}}while(0);I=S;if(B){if(S>>>0>J>>>0){Q=J+(0-I)|0;I=Q>>>0<G>>>0?G:Q;Q=I+s|0;R=P;T=S;U=s;while(1){V=T+ -1|0;W=a[V]|0;c[f>>2]=R+1;a[R]=W;W=U+ -1|0;X=(W|0)>0;if(!(V>>>0>J>>>0&X)){break}R=c[f>>2]|0;U=W;T=V}T=S+I|0;if(X){Y=T;Z=Q;_=32}else{$=0;aa=T;ba=Q}}else{Y=S;Z=s;_=32}if((_|0)==32){_=0;$=xe[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;aa=Y;ba=Z}T=c[f>>2]|0;c[f>>2]=T+1;if((ba|0)>0){U=T;R=ba;while(1){a[U]=$;V=R+ -1|0;W=c[f>>2]|0;c[f>>2]=W+1;if((V|0)>0){R=V;U=W}else{ca=W;break}}}else{ca=T}a[ca]=n;da=aa}else{da=S}if((da|0)==(J|0)){U=xe[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;R=c[f>>2]|0;c[f>>2]=R+1;a[R]=U}else{U=a[p]|0;R=(U&1)==0;if(R){ea=(U&255)>>>1}else{ea=c[E>>2]|0}if((ea|0)==0){fa=da;ga=-1;ha=0;ia=0}else{if(R){ja=C}else{ja=c[D>>2]|0}fa=da;ga=a[ja]|0;ha=0;ia=0}while(1){do{if((ia|0)==(ga|0)){R=c[f>>2]|0;c[f>>2]=R+1;a[R]=o;R=ha+1|0;U=a[p]|0;Q=(U&1)==0;if(Q){ka=(U&255)>>>1}else{ka=c[E>>2]|0}if(!(R>>>0<ka>>>0)){la=ga;ma=R;na=0;break}if(Q){oa=C}else{oa=c[D>>2]|0}if((a[oa+R|0]|0)==127){la=-1;ma=R;na=0;break}if(Q){pa=C}else{pa=c[D>>2]|0}la=a[pa+R|0]|0;ma=R;na=0}else{la=ga;ma=ha;na=ia}}while(0);R=fa+ -1|0;Q=a[R]|0;U=c[f>>2]|0;c[f>>2]=U+1;a[U]=Q;if((R|0)==(J|0)){break}else{fa=R;ga=la;ha=ma;ia=na+1|0}}}T=c[f>>2]|0;if((P|0)==(T|0)){L=J;break a}R=T+ -1|0;if(R>>>0>P>>>0){qa=P;ra=R}else{L=J;break a}while(1){R=a[qa]|0;a[qa]=a[ra]|0;a[ra]=R;R=qa+1|0;T=ra+ -1|0;if(R>>>0<T>>>0){ra=T;qa=R}else{L=J;break}}break};case 1:{c[e>>2]=c[f>>2];J=xe[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;P=c[f>>2]|0;c[f>>2]=P+1;a[P]=J;L=H;break};case 3:{J=a[r]|0;P=(J&1)==0;if(P){sa=(J&255)>>>1}else{sa=c[w>>2]|0}if((sa|0)==0){L=H;break a}if(P){ta=u}else{ta=c[v>>2]|0}P=a[ta]|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=P;L=H;break};case 0:{c[e>>2]=c[f>>2];L=H;break};default:{L=H}}}while(0);P=h+1|0;if(P>>>0<4){H=L;h=P}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==16){i=t;return}else if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else{c[e>>2]=d;i=t;return}}function Cbb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;o6a(m,g);z=m;A=c[z>>2]|0;if(!((c[48104]|0)==-1)){c[l>>2]=192416;c[l+4>>2]=445;c[l+8>>2]=0;d5a(192416,l,446)}l=(c[192420>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ec(4)|0;D=C;cfb(D);E=207976;F=127;Td(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ec(4)|0;D=C;cfb(D);E=207976;F=127;Td(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(xe[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Abb(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=xfb(P)|0;if((N|0)!=0){Q=N;R=N;break}Kfb()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}Bbb(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];Q1a(b,k,R,e,w,g,h);if((Q|0)==0){s5a(t);s5a(s);s5a(r);U=c[z>>2]|0;V=U;W=V;X=K4a(W)|0;i=d;return}yfb(Q);s5a(t);s5a(s);s5a(r);U=c[z>>2]|0;V=U;W=V;X=K4a(W)|0;i=d;return}function Dbb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function Ebb(a){a=a|0;i=i;return}function Fbb(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Mc(G|0,100,192168,o|0)|0;do{if(s>>>0>99){do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);o=c[48076]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=r9a(r,o,192168,n)|0;o=c[r>>2]|0;if((o|0)==0){Kfb()}H=xfb(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}Kfb()}else{J=0;K=0;L=q;M=s}}while(0);o6a(t,g);s=t;q=c[s>>2]|0;if(!((c[48102]|0)==-1)){c[p>>2]=192408;c[p+4>>2]=445;c[p+8>>2]=0;d5a(192408,p,446)}p=(c[192412>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Ec(4)|0;O=N;cfb(O);P=207976;Q=127;Td(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Ec(4)|0;O=N;cfb(O);P=207976;Q=127;Td(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;He[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Gbb(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=xfb(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}Kfb()}else{X=0;Y=t}}while(0);Hbb(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];A9a(b,m,Y,e,D,g,j);if((X|0)!=0){yfb(X)}W5a(A);W5a(z);s5a(y);K4a(c[s>>2]|0)|0;if((K|0)!=0){yfb(K)}if((J|0)==0){i=d;return}yfb(J);i=d;return}function Gbb(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[47996]|0)==-1)){c[p>>2]=191984;c[p+4>>2]=445;c[p+8>>2]=0;d5a(191984,p,446)}p=(c[191988>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ec(4)|0;I=H;cfb(I);J=207976;K=127;Td(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ec(4)|0;I=H;cfb(I);J=207976;K=127;Td(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ge[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ge[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}Z5a(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;W5a(s)}else{ge[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ge[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}Z5a(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;W5a(v)}c[g>>2]=ie[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=ie[c[(c[e>>2]|0)+16>>2]&127](K)|0;ge[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}E5a(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;s5a(w);ge[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}Z5a(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;W5a(x);L=ie[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[47980]|0)==-1)){c[o>>2]=191920;c[o+4>>2]=445;c[o+8>>2]=0;d5a(191920,o,446)}o=(c[191924>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ec(4)|0;N=M;cfb(N);O=207976;P=127;Td(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ec(4)|0;N=M;cfb(N);O=207976;P=127;Td(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ge[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ge[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}Z5a(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;W5a(A)}else{ge[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ge[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}Z5a(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;W5a(D)}c[g>>2]=ie[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=ie[c[(c[G>>2]|0)+16>>2]&127](P)|0;ge[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}E5a(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;s5a(E);ge[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}Z5a(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;W5a(F);L=ie[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function Hbb(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 2:{D=a[p]|0;E=(D&1)==0;if(E){F=(D&255)>>>1}else{F=c[w>>2]|0}if((F|0)==0|v){G=C;break a}if(E){H=w;I=(D&255)>>>1}else{H=c[x>>2]|0;I=c[w>>2]|0}D=H+(I<<2)|0;E=c[e>>2]|0;if((H|0)==(D|0)){J=E}else{K=(H+(I+ -1<<2)+(0-H)|0)>>>2;L=E;M=H;while(1){c[L>>2]=c[M>>2];N=M+4|0;if((N|0)==(D|0)){break}L=L+4|0;M=N}J=E+(K+1<<2)|0}c[e>>2]=J;G=C;break};case 4:{M=c[e>>2]|0;L=k?C+4|0:C;b:do{if(L>>>0<h>>>0){D=L;while(1){N=D+4|0;if(!(le[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[D>>2]|0)|0)){O=D;break b}if(N>>>0<h>>>0){D=N}else{O=N;break}}}else{O=L}}while(0);if(y){do{if(O>>>0>L>>>0){K=c[e>>2]|0;E=O;D=r;while(1){P=E+ -4|0;Q=K+4|0;c[K>>2]=c[P>>2];R=D+ -1|0;S=(R|0)>0;if(P>>>0>L>>>0&S){D=R;E=P;K=Q}else{break}}c[e>>2]=Q;if(S){T=P;U=R;V=34;break}K=c[e>>2]|0;c[e>>2]=K+4;W=K;X=P}else{T=O;U=r;V=34}}while(0);do{if((V|0)==34){V=0;K=xe[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;E=c[e>>2]|0;D=E+4|0;c[e>>2]=D;if((U|0)>0){Y=D;Z=E;_=U}else{W=E;X=T;break}while(1){c[Z>>2]=K;D=_+ -1|0;if((D|0)>0){_=D;Z=Y;Y=Y+4|0}else{break}}c[e>>2]=E+(U+1<<2);W=E+(U<<2)|0;X=T}}while(0);c[W>>2]=m;$=X}else{$=O}if(($|0)==(L|0)){K=xe[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;D=c[e>>2]|0;N=D+4|0;c[e>>2]=N;c[D>>2]=K;aa=N}else{N=a[o]|0;K=(N&1)==0;if(K){ba=(N&255)>>>1}else{ba=c[B>>2]|0}if((ba|0)==0){ca=$;da=-1;ea=0;fa=0}else{if(K){ga=z}else{ga=c[A>>2]|0}ca=$;da=a[ga]|0;ea=0;fa=0}while(1){K=c[e>>2]|0;do{if((fa|0)==(da|0)){N=K+4|0;c[e>>2]=N;c[K>>2]=n;D=ea+1|0;ha=a[o]|0;ia=(ha&1)==0;if(ia){ja=(ha&255)>>>1}else{ja=c[B>>2]|0}if(!(D>>>0<ja>>>0)){ka=N;la=da;ma=D;na=0;break}if(ia){oa=z}else{oa=c[A>>2]|0}if((a[oa+D|0]|0)==127){ka=N;la=-1;ma=D;na=0;break}if(ia){pa=z}else{pa=c[A>>2]|0}ka=N;la=a[pa+D|0]|0;ma=D;na=0}else{ka=K;la=da;ma=ea;na=fa}}while(0);K=ca+ -4|0;E=c[K>>2]|0;D=ka+4|0;c[e>>2]=D;c[ka>>2]=E;if((K|0)==(L|0)){aa=D;break}else{ca=K;da=la;ea=ma;fa=na+1|0}}}if((M|0)==(aa|0)){G=L;break a}K=aa+ -4|0;if(K>>>0>M>>>0){qa=M;ra=K}else{G=L;break a}while(1){K=c[qa>>2]|0;c[qa>>2]=c[ra>>2];c[ra>>2]=K;K=qa+4|0;D=ra+ -4|0;if(K>>>0<D>>>0){ra=D;qa=K}else{G=L;break}}break};case 0:{c[d>>2]=c[e>>2];G=C;break};case 1:{c[d>>2]=c[e>>2];L=xe[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;M=c[e>>2]|0;c[e>>2]=M+4;c[M>>2]=L;G=C;break};case 3:{L=a[q]|0;M=(L&1)==0;if(M){sa=(L&255)>>>1}else{sa=c[t>>2]|0}if((sa|0)==0){G=C;break a}if(M){ta=t}else{ta=c[u>>2]|0}M=c[ta>>2]|0;L=c[e>>2]|0;c[e>>2]=L+4;c[L>>2]=M;G=C;break};default:{G=C}}}while(0);M=g+1|0;if(M>>>0<4){C=G;g=M}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==16){i=s;return}else if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else{c[d>>2]=b;i=s;return}}function Ibb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;o6a(m,g);z=m;A=c[z>>2]|0;if(!((c[48102]|0)==-1)){c[l>>2]=192408;c[l+4>>2]=445;c[l+8>>2]=0;d5a(192408,l,446)}l=(c[192412>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ec(4)|0;D=C;cfb(D);E=207976;F=127;Td(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ec(4)|0;D=C;cfb(D);E=207976;F=127;Td(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(xe[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Gbb(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=xfb(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}Kfb()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}Hbb(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];A9a(b,k,R,e,w,g,h);if((Q|0)==0){W5a(t);W5a(s);s5a(r);U=c[z>>2]|0;V=U;W=V;X=K4a(W)|0;i=d;return}yfb(Q);W5a(t);W5a(s);s5a(r);U=c[z>>2]|0;V=U;W=V;X=K4a(W)|0;i=d;return}function Jbb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function Kbb(a){a=a|0;i=i;return}function Lbb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=uc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function Mbb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{K5a(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=yd(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=$fb(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{s5a(j);i=d;return}do{K5a(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);s5a(j);i=d;return}function Nbb(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function Obb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function Pbb(a){a=a|0;i=i;return}function Qbb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=uc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function Rbb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=194072;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=194072|0;while(1){c[m>>2]=y;A=(Ge[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{K5a(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}kbb(193296)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=yd(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=194176;D=$fb(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){s5a(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=194176|0;while(1){c[q>>2]=o;h=(Ge[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{_5a(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){kbb(193296)}else if((E|0)==25){s5a(r);i=d;return}}function Sbb(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function Tbb(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=192504;e=b+8|0;b=c[e>>2]|0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);if((b|0)==(c[48076]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function Ubb(a){a=a|0;a=Ec(8)|0;L4a(a,192296);c[a>>2]=189264;Td(a|0,189304,40)}function Vbb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=192336;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);k5a(b+144|0,192320,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[197228>>2]=0;c[49306]=190816;if(!((c[47710]|0)==-1)){c[G>>2]=190840;c[G+4>>2]=445;c[G+8>>2]=0;d5a(190840,G,446)}Wbb(b,197224,(c[190844>>2]|0)+ -1|0);c[197220>>2]=0;c[49304]=190856;if(!((c[47720]|0)==-1)){c[F>>2]=190880;c[F+4>>2]=445;c[F+8>>2]=0;d5a(190880,F,446)}Wbb(b,197216,(c[190884>>2]|0)+ -1|0);c[197204>>2]=0;c[49300]=192432;c[197208>>2]=0;a[197212|0]=0;F=c[(yc()|0)>>2]|0;c[197208>>2]=F;if(!((c[48104]|0)==-1)){c[E>>2]=192416;c[E+4>>2]=445;c[E+8>>2]=0;d5a(192416,E,446)}Wbb(b,197200,(c[192420>>2]|0)+ -1|0);c[197196>>2]=0;c[49298]=193392;if(!((c[48102]|0)==-1)){c[D>>2]=192408;c[D+4>>2]=445;c[D+8>>2]=0;d5a(192408,D,446)}Wbb(b,197192,(c[192412>>2]|0)+ -1|0);c[197188>>2]=0;c[49296]=193608;if(!((c[48120]|0)==-1)){c[C>>2]=192480;c[C+4>>2]=445;c[C+8>>2]=0;d5a(192480,C,446)}Wbb(b,197184,(c[192484>>2]|0)+ -1|0);c[197172>>2]=0;c[49292]=192504;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);c[197176>>2]=c[48076];if(!((c[48122]|0)==-1)){c[B>>2]=192488;c[B+4>>2]=445;c[B+8>>2]=0;d5a(192488,B,446)}Wbb(b,197168,(c[192492>>2]|0)+ -1|0);c[197164>>2]=0;c[49290]=193832;if(!((c[48136]|0)==-1)){c[A>>2]=192544;c[A+4>>2]=445;c[A+8>>2]=0;d5a(192544,A,446)}Wbb(b,197160,(c[192548>>2]|0)+ -1|0);c[197156>>2]=0;c[49288]=193952;if(!((c[48138]|0)==-1)){c[z>>2]=192552;c[z+4>>2]=445;c[z+8>>2]=0;d5a(192552,z,446)}Wbb(b,197152,(c[192556>>2]|0)+ -1|0);c[197132>>2]=0;c[49282]=192584;a[197136|0]=46;a[197137|0]=44;z=197140|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[48140]|0)==-1)){c[y>>2]=192560;c[y+4>>2]=445;c[y+8>>2]=0;d5a(192560,y,446)}Wbb(b,197128,(c[192564>>2]|0)+ -1|0);c[197100>>2]=0;c[49274]=192624;c[197104>>2]=46;c[197108>>2]=44;y=197112|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[48142]|0)==-1)){c[x>>2]=192568;c[x+4>>2]=445;c[x+8>>2]=0;d5a(192568,x,446)}Wbb(b,197096,(c[192572>>2]|0)+ -1|0);c[197092>>2]=0;c[49272]=190896;if(!((c[47738]|0)==-1)){c[w>>2]=190952;c[w+4>>2]=445;c[w+8>>2]=0;d5a(190952,w,446)}Wbb(b,197088,(c[190956>>2]|0)+ -1|0);c[197084>>2]=0;c[49270]=191016;if(!((c[47768]|0)==-1)){c[v>>2]=191072;c[v+4>>2]=445;c[v+8>>2]=0;d5a(191072,v,446)}Wbb(b,197080,(c[191076>>2]|0)+ -1|0);c[197076>>2]=0;c[49268]=191088;if(!((c[47784]|0)==-1)){c[u>>2]=191136;c[u+4>>2]=445;c[u+8>>2]=0;d5a(191136,u,446)}Wbb(b,197072,(c[191140>>2]|0)+ -1|0);c[197068>>2]=0;c[49266]=191152;if(!((c[47800]|0)==-1)){c[t>>2]=191200;c[t+4>>2]=445;c[t+8>>2]=0;d5a(191200,t,446)}Wbb(b,197064,(c[191204>>2]|0)+ -1|0);c[197060>>2]=0;c[49264]=191744;if(!((c[47948]|0)==-1)){c[s>>2]=191792;c[s+4>>2]=445;c[s+8>>2]=0;d5a(191792,s,446)}Wbb(b,197056,(c[191796>>2]|0)+ -1|0);c[197052>>2]=0;c[49262]=191808;if(!((c[47964]|0)==-1)){c[r>>2]=191856;c[r+4>>2]=445;c[r+8>>2]=0;d5a(191856,r,446)}Wbb(b,197048,(c[191860>>2]|0)+ -1|0);c[197044>>2]=0;c[49260]=191872;if(!((c[47980]|0)==-1)){c[q>>2]=191920;c[q+4>>2]=445;c[q+8>>2]=0;d5a(191920,q,446)}Wbb(b,197040,(c[191924>>2]|0)+ -1|0);c[197036>>2]=0;c[49258]=191936;if(!((c[47996]|0)==-1)){c[p>>2]=191984;c[p+4>>2]=445;c[p+8>>2]=0;d5a(191984,p,446)}Wbb(b,197032,(c[191988>>2]|0)+ -1|0);c[197028>>2]=0;c[49256]=192e3;if(!((c[48006]|0)==-1)){c[o>>2]=192024;c[o+4>>2]=445;c[o+8>>2]=0;d5a(192024,o,446)}Wbb(b,197024,(c[192028>>2]|0)+ -1|0);c[197020>>2]=0;c[49254]=192080;if(!((c[48026]|0)==-1)){c[n>>2]=192104;c[n+4>>2]=445;c[n+8>>2]=0;d5a(192104,n,446)}Wbb(b,197016,(c[192108>>2]|0)+ -1|0);c[197012>>2]=0;c[49252]=192136;if(!((c[48040]|0)==-1)){c[m>>2]=192160;c[m+4>>2]=445;c[m+8>>2]=0;d5a(192160,m,446)}Wbb(b,197008,(c[192164>>2]|0)+ -1|0);c[197004>>2]=0;c[49250]=192184;if(!((c[48052]|0)==-1)){c[l>>2]=192208;c[l+4>>2]=445;c[l+8>>2]=0;d5a(192208,l,446)}Wbb(b,197e3,(c[192212>>2]|0)+ -1|0);c[196988>>2]=0;c[49246]=191232;c[196992>>2]=191280;if(!((c[47828]|0)==-1)){c[k>>2]=191312;c[k+4>>2]=445;c[k+8>>2]=0;d5a(191312,k,446)}Wbb(b,196984,(c[191316>>2]|0)+ -1|0);c[196972>>2]=0;c[49242]=191384;c[196976>>2]=191432;if(!((c[47866]|0)==-1)){c[j>>2]=191464;c[j+4>>2]=445;c[j+8>>2]=0;d5a(191464,j,446)}Wbb(b,196968,(c[191468>>2]|0)+ -1|0);c[196956>>2]=0;c[49238]=193328;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);c[196960>>2]=c[48076];c[49238]=191680;if(!((c[47924]|0)==-1)){c[h>>2]=191696;c[h+4>>2]=445;c[h+8>>2]=0;d5a(191696,h,446)}Wbb(b,196952,(c[191700>>2]|0)+ -1|0);c[196940>>2]=0;c[49234]=193328;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);c[196944>>2]=c[48076];c[49234]=191712;if(!((c[47932]|0)==-1)){c[g>>2]=191728;c[g+4>>2]=445;c[g+8>>2]=0;d5a(191728,g,446)}Wbb(b,196936,(c[191732>>2]|0)+ -1|0);c[196932>>2]=0;c[49232]=192224;if(!((c[48062]|0)==-1)){c[f>>2]=192248;c[f+4>>2]=445;c[f+8>>2]=0;d5a(192248,f,446)}Wbb(b,196928,(c[192252>>2]|0)+ -1|0);c[196924>>2]=0;c[49230]=192264;if((c[48072]|0)==-1){N=192288;O=192288;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=196920;Wbb(b,T,S);i=e;return}c[H>>2]=192288;c[H+4>>2]=445;c[H+8>>2]=0;d5a(192288,H,446);N=192288;O=192288;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=196920;Wbb(b,T,S);i=e;return}function Wbb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;J4a(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){$db(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}K4a(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function Xbb(a){a=a|0;var b=0;b=i;Ybb(a);Ffb(a);i=b;return}function Ybb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=192336;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{K4a(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}s5a(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{Ffb(h);i=d;return}}function Zbb(){var b=0,d=0,e=0,f=0;b=i;if((a[192392]|0)!=0){d=192384;e=c[48096]|0;i=b;return e|0}if((Za(192392)|0)==0){d=192384;e=c[48096]|0;i=b;return e|0}do{if((a[192368]|0)==0){if((Za(192368)|0)==0){break}Vbb(196760,1);c[48088]=196760;c[48090]=192352;Tb(192368)}}while(0);f=c[c[48090]>>2]|0;c[48094]=f;J4a(f);c[48096]=192376;Tb(192392);d=192384;e=c[48096]|0;i=b;return e|0}function _bb(a){a=a|0;var b=0,d=0;b=i;d=c[(Zbb()|0)>>2]|0;c[a>>2]=d;J4a(d);i=b;return}function $bb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;J4a(e);i=d;return}function acb(a){a=a|0;var b=0;b=i;K4a(c[a>>2]|0)|0;i=b;return}function bcb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=445;c[e+8>>2]=0;d5a(a,e,446)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function ccb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=445;c[e+8>>2]=0;d5a(a,e,446)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Ec(4)|0;h=g;cfb(h);j=207976;k=127;Td(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Ec(4)|0;h=g;cfb(h);j=207976;k=127;Td(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function dcb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function ecb(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}fe[c[(c[a>>2]|0)+4>>2]&511](a);i=b;return}function fcb(a){a=a|0;var b=0;b=c[48100]|0;c[48100]=1+b;c[a+4>>2]=b+1;i=i;return}function gcb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function hcb(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(yc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function icb(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(yc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function jcb(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(yc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function kcb(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(yc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function lcb(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Dd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function mcb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Dd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function ncb(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Id()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function ocb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Id()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function pcb(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}function qcb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function rcb(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function scb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function tcb(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=192432;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}Gfb(e)}}while(0);Ffb(b);i=d;return}function ucb(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=192432;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}Gfb(e);i=d;return}function vcb(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Dd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function wcb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Dd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function xcb(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Id()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function ycb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Id()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function zcb(a,b){a=a|0;b=b|0;i=i;return b|0}function Acb(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function Bcb(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function Ccb(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function Dcb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function Ecb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function Fcb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function Gcb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function Hcb(a){a=a|0;i=i;return 1}function Icb(a){a=a|0;i=i;return 1}function Jcb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function Kcb(a){a=a|0;i=i;return 1}function Lcb(a){a=a|0;var b=0;b=i;Tbb(a);Ffb(a);i=b;return}function Mcb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Lc(c[s>>2]|0)|0;A=Deb(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Lc(z|0)|0}if((A|0)==0){B=1;C=33;break}else if((A|0)==-1){C=10;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){C=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Lc(c[s>>2]|0)|0;A=Ceb(u,0,d)|0;if((z|0)!=0){Lc(z|0)|0}if((A|0)==-1){B=2;C=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){B=1;C=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((C|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Lc(c[s>>2]|0)|0;G=Ceb(u,r,n)|0;if((z|0)!=0){Lc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;B=2;i=l;return B|0}else if((C|0)==31){q=c[g>>2]|0;break}else if((C|0)==33){i=l;return B|0}}}while(0);B=(q|0)!=(f|0)|0;i=l;return B|0}function Ncb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Lc(c[r>>2]|0)|0;y=zeb(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Lc(x|0)|0}if((y|0)==0){A=2;B=32;break}else if((y|0)==-1){B=10;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){B=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Lc(c[r>>2]|0)|0;F=yeb(x,y,1,d)|0;if((w|0)!=0){Lc(w|0)|0}if((F|0)!=0){A=2;B=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((B|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Lc(c[r>>2]|0)|0;y=yeb(q,v,z-v|0,n)|0;if((w|0)!=0){Lc(w|0)|0}if((y|0)==0){I=v+1|0}else if((y|0)==-2){B=16;break}else if((y|0)==-1){B=15;break}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((B|0)==15){c[g>>2]=v;A=2;i=l;return A|0}else if((B|0)==16){c[g>>2]=v;A=1;i=l;return A|0}}}while(0);c[g>>2]=H;A=(H|0)!=(f|0)|0;i=l;return A|0}else if((B|0)==30){p=c[g>>2]|0;break}else if((B|0)==32){i=l;return A|0}}}while(0);A=(p|0)!=(f|0)|0;i=l;return A|0}function Ocb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Lc(c[b+8>>2]|0)|0;b=Ceb(e,0,d)|0;if((j|0)!=0){Lc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function Pcb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Lc(c[d>>2]|0)|0;e=Beb(0,0,4)|0;if((a|0)!=0){Lc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Lc(a|0)|0;if((g|0)==0){f=0;break}Lc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function Qcb(a){a=a|0;i=i;return 0}function Rcb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Lc(c[k>>2]|0)|0;n=xeb(a,j-a|0,b)|0;if((m|0)!=0){Lc(m|0)|0}if((n|0)==-2|(n|0)==-1){h=d;o=9;break}else if((n|0)==0){p=a+1|0;q=1}else{p=a+n|0;q=n}n=q+d|0;m=l+1|0;if(m>>>0>=f>>>0|(p|0)==(e|0)){h=n;o=9;break}else{a=p;d=n;l=m}}if((o|0)==9){i=g;return h|0}return 0}function Scb(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Lc(d|0)|0;if((a|0)==0){e=4;break}Lc(a|0)|0;e=4}}while(0);i=b;return e|0}function Tcb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function Ucb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=Vcb(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function Vcb(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function Wcb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=Xcb(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function Xcb(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function Ycb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function Zcb(a){a=a|0;i=i;return 0}function _cb(a){a=a|0;i=i;return 0}function $cb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=adb(c,d,e,1114111,0)|0;i=b;return a|0}function adb(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function bdb(a){a=a|0;i=i;return 4}function cdb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function ddb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=edb(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function edb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function fdb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=gdb(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function gdb(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function hdb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function idb(a){a=a|0;i=i;return 0}function jdb(a){a=a|0;i=i;return 0}function kdb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=ldb(c,d,e,1114111,0)|0;i=b;return a|0}function ldb(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function mdb(a){a=a|0;i=i;return 4}function ndb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function odb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function pdb(a){a=a|0;var b=0;b=i;c[a>>2]=192584;s5a(a+12|0);Ffb(a);i=b;return}function qdb(a){a=a|0;var b=0;b=i;c[a>>2]=192584;s5a(a+12|0);i=b;return}function rdb(a){a=a|0;var b=0;b=i;c[a>>2]=192624;s5a(a+16|0);Ffb(a);i=b;return}function sdb(a){a=a|0;var b=0;b=i;c[a>>2]=192624;s5a(a+16|0);i=b;return}function tdb(b){b=b|0;i=i;return a[b+8|0]|0}function udb(a){a=a|0;i=i;return c[a+8>>2]|0}function vdb(b){b=b|0;i=i;return a[b+9|0]|0}function wdb(a){a=a|0;i=i;return c[a+12>>2]|0}function xdb(a,b){a=a|0;b=b|0;var c=0;c=i;i5a(a,b+12|0);i=c;return}function ydb(a,b){a=a|0;b=b|0;var c=0;c=i;i5a(a,b+16|0);i=c;return}function zdb(a,b){a=a|0;b=b|0;b=i;k5a(a,192656,4);i=b;return}function Adb(a,b){a=a|0;b=b|0;b=i;U5a(a,192664,Zeb(192664)|0);i=b;return}function Bdb(a,b){a=a|0;b=b|0;b=i;k5a(a,192688,5);i=b;return}function Cdb(a,b){a=a|0;b=b|0;b=i;U5a(a,192696,Zeb(192696)|0);i=b;return}function Ddb(b){b=b|0;var d=0,e=0;b=i;if((a[192728]|0)!=0){d=192720;e=c[48180]|0;i=b;return e|0}if((Za(192728)|0)==0){d=192720;e=c[48180]|0;i=b;return e|0}do{if((a[199928]|0)==0){if((Za(199928)|0)==0){break}dgb(199760,0,168)|0;Zd(448,0,q|0)|0;Tb(199928)}}while(0);v5a(199760,199936)|0;v5a(199772|0,199944)|0;v5a(199784|0,199952)|0;v5a(199796|0,199960)|0;v5a(199808|0,199976)|0;v5a(199820|0,199992)|0;v5a(199832|0,2e5)|0;v5a(199844|0,200016)|0;v5a(199856|0,200024)|0;v5a(199868|0,200032)|0;v5a(199880|0,200040)|0;v5a(199892|0,200048)|0;v5a(199904|0,200056)|0;v5a(199916|0,200064)|0;c[48180]=199760;Tb(192728);d=192720;e=c[48180]|0;i=b;return e|0}function Edb(b){b=b|0;var d=0,e=0;b=i;if((a[192744]|0)!=0){d=192736;e=c[48184]|0;i=b;return e|0}if((Za(192744)|0)==0){d=192736;e=c[48184]|0;i=b;return e|0}do{if((a[199392]|0)==0){if((Za(199392)|0)==0){break}dgb(199224,0,168)|0;Zd(449,0,q|0)|0;Tb(199392)}}while(0);X5a(199224,199400)|0;X5a(199236|0,199432)|0;X5a(199248|0,199464)|0;X5a(199260|0,199496)|0;X5a(199272|0,199536)|0;X5a(199284|0,199576)|0;X5a(199296|0,199608)|0;X5a(199308|0,199648)|0;X5a(199320|0,199664)|0;X5a(199332|0,199680)|0;X5a(199344|0,199696)|0;X5a(199356|0,199712)|0;X5a(199368|0,199728)|0;X5a(199380|0,199744)|0;c[48184]=199224;Tb(192744);d=192736;e=c[48184]|0;i=b;return e|0}function Fdb(b){b=b|0;var d=0,e=0;b=i;if((a[192760]|0)!=0){d=192752;e=c[48188]|0;i=b;return e|0}if((Za(192760)|0)==0){d=192752;e=c[48188]|0;i=b;return e|0}do{if((a[199e3]|0)==0){if((Za(199e3)|0)==0){break}dgb(198712,0,288)|0;Zd(450,0,q|0)|0;Tb(199e3)}}while(0);v5a(198712,199008)|0;v5a(198724|0,199016)|0;v5a(198736|0,199032)|0;v5a(198748|0,199040)|0;v5a(198760|0,199048)|0;v5a(198772|0,199056)|0;v5a(198784|0,199064)|0;v5a(198796|0,199072)|0;v5a(198808|0,199080)|0;v5a(198820|0,199096)|0;v5a(198832|0,199104)|0;v5a(198844|0,199120)|0;v5a(198856|0,199136)|0;v5a(198868|0,199144)|0;v5a(198880|0,199152)|0;v5a(198892|0,199160)|0;v5a(198904|0,199048)|0;v5a(198916|0,199168)|0;v5a(198928|0,199176)|0;v5a(198940|0,199184)|0;v5a(198952|0,199192)|0;v5a(198964|0,199200)|0;v5a(198976|0,199208)|0;v5a(198988|0,199216)|0;c[48188]=198712;Tb(192760);d=192752;e=c[48188]|0;i=b;return e|0}function Gdb(b){b=b|0;var d=0,e=0;b=i;if((a[192776]|0)!=0){d=192768;e=c[48192]|0;i=b;return e|0}if((Za(192776)|0)==0){d=192768;e=c[48192]|0;i=b;return e|0}do{if((a[198160]|0)==0){if((Za(198160)|0)==0){break}dgb(197872,0,288)|0;Zd(451,0,q|0)|0;Tb(198160)}}while(0);X5a(197872,198168)|0;X5a(197884|0,198200)|0;X5a(197896|0,198240)|0;X5a(197908|0,198264)|0;X5a(197920|0,198584)|0;X5a(197932|0,198288)|0;X5a(197944|0,198312)|0;X5a(197956|0,198336)|0;X5a(197968|0,198368)|0;X5a(197980|0,198408)|0;X5a(197992|0,198440)|0;X5a(198004|0,198480)|0;X5a(198016|0,198520)|0;X5a(198028|0,198536)|0;X5a(198040|0,198552)|0;X5a(198052|0,198568)|0;X5a(198064|0,198584)|0;X5a(198076|0,198600)|0;X5a(198088|0,198616)|0;X5a(198100|0,198632)|0;X5a(198112|0,198648)|0;X5a(198124|0,198664)|0;X5a(198136|0,198680)|0;X5a(198148|0,198696)|0;c[48192]=197872;Tb(192776);d=192768;e=c[48192]|0;i=b;return e|0}function Hdb(b){b=b|0;var d=0,e=0;b=i;if((a[192792]|0)!=0){d=192784;e=c[48196]|0;i=b;return e|0}if((Za(192792)|0)==0){d=192784;e=c[48196]|0;i=b;return e|0}do{if((a[197848]|0)==0){if((Za(197848)|0)==0){break}dgb(197560,0,288)|0;Zd(452,0,q|0)|0;Tb(197848)}}while(0);v5a(197560,197856)|0;v5a(197572|0,197864)|0;c[48196]=197560;Tb(192792);d=192784;e=c[48196]|0;i=b;return e|0}function Idb(b){b=b|0;var d=0,e=0;b=i;if((a[192808]|0)!=0){d=192800;e=c[48200]|0;i=b;return e|0}if((Za(192808)|0)==0){d=192800;e=c[48200]|0;i=b;return e|0}do{if((a[197520]|0)==0){if((Za(197520)|0)==0){break}dgb(197232,0,288)|0;Zd(453,0,q|0)|0;Tb(197520)}}while(0);X5a(197232,197528)|0;X5a(197244|0,197544)|0;c[48200]=197232;Tb(192808);d=192800;e=c[48200]|0;i=b;return e|0}function Jdb(b){b=b|0;var c=0;b=i;if((a[192832]|0)!=0){c=192816;i=b;return c|0}if((Za(192832)|0)==0){c=192816;i=b;return c|0}k5a(192816,192840,8);Zd(454,192816,q|0)|0;Tb(192832);c=192816;i=b;return c|0}function Kdb(b){b=b|0;var c=0;b=i;if((a[192872]|0)!=0){c=192856;i=b;return c|0}if((Za(192872)|0)==0){c=192856;i=b;return c|0}U5a(192856,192880,Zeb(192880)|0);Zd(455,192856,q|0)|0;Tb(192872);c=192856;i=b;return c|0}function Ldb(b){b=b|0;var c=0;b=i;if((a[192936]|0)!=0){c=192920;i=b;return c|0}if((Za(192936)|0)==0){c=192920;i=b;return c|0}k5a(192920,192944,8);Zd(454,192920,q|0)|0;Tb(192936);c=192920;i=b;return c|0}function Mdb(b){b=b|0;var c=0;b=i;if((a[192976]|0)!=0){c=192960;i=b;return c|0}if((Za(192976)|0)==0){c=192960;i=b;return c|0}U5a(192960,192984,Zeb(192984)|0);Zd(455,192960,q|0)|0;Tb(192976);c=192960;i=b;return c|0}function Ndb(b){b=b|0;var c=0;b=i;if((a[193040]|0)!=0){c=193024;i=b;return c|0}if((Za(193040)|0)==0){c=193024;i=b;return c|0}k5a(193024,193048,20);Zd(454,193024,q|0)|0;Tb(193040);c=193024;i=b;return c|0}function Odb(b){b=b|0;var c=0;b=i;if((a[193088]|0)!=0){c=193072;i=b;return c|0}if((Za(193088)|0)==0){c=193072;i=b;return c|0}U5a(193072,193096,Zeb(193096)|0);Zd(455,193072,q|0)|0;Tb(193088);c=193072;i=b;return c|0}function Pdb(b){b=b|0;var c=0;b=i;if((a[193200]|0)!=0){c=193184;i=b;return c|0}if((Za(193200)|0)==0){c=193184;i=b;return c|0}k5a(193184,193208,11);Zd(454,193184,q|0)|0;Tb(193200);c=193184;i=b;return c|0}function Qdb(b){b=b|0;var c=0;b=i;if((a[193240]|0)!=0){c=193224;i=b;return c|0}if((Za(193240)|0)==0){c=193224;i=b;return c|0}U5a(193224,193248,Zeb(193248)|0);Zd(455,193224,q|0)|0;Tb(193240);c=193224;i=b;return c|0}function Rdb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);l=+Vfb(b,g,c[48076]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function Sdb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);l=+Vfb(b,g,c[48076]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function Tdb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);l=+Vfb(b,g,c[48076]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function Udb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Nc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);n=lb(b|0,h|0,f|0,c[48076]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function Vdb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);m=lb(b|0,h|0,f|0,c[48076]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function Wdb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);m=lb(b|0,h|0,f|0,c[48076]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function Xdb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);m=lb(b|0,h|0,f|0,c[48076]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function Ydb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Nc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);n=Gc(b|0,h|0,f|0,c[48076]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function Zdb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[192312]|0)==0){if((Za(192312)|0)==0){break}c[48076]=Zb(2147483647,192320,0)|0;Tb(192312)}}while(0);m=Gc(b|0,h|0,f|0,c[48076]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function _db(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;fe[h&511](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;fe[h&511](a);i=b;return}}function $db(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){Ubb(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=Dfb(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;bgb(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{Ffb(h);i=e;return}}function aeb(a){a=a|0;a=i;W5a(197508|0);W5a(197496|0);W5a(197484|0);W5a(197472|0);W5a(197460|0);W5a(197448|0);W5a(197436|0);W5a(197424|0);W5a(197412|0);W5a(197400|0);W5a(197388|0);W5a(197376|0);W5a(197364|0);W5a(197352|0);W5a(197340|0);W5a(197328|0);W5a(197316|0);W5a(197304|0);W5a(197292|0);W5a(197280|0);W5a(197268|0);W5a(197256|0);W5a(197244|0);W5a(197232);i=a;return}function beb(a){a=a|0;a=i;s5a(197836|0);s5a(197824|0);s5a(197812|0);s5a(197800|0);s5a(197788|0);s5a(197776|0);s5a(197764|0);s5a(197752|0);s5a(197740|0);s5a(197728|0);s5a(197716|0);s5a(197704|0);s5a(197692|0);s5a(197680|0);s5a(197668|0);s5a(197656|0);s5a(197644|0);s5a(197632|0);s5a(197620|0);s5a(197608|0);s5a(197596|0);s5a(197584|0);s5a(197572|0);s5a(197560);i=a;return}function ceb(a){a=a|0;a=i;W5a(198148|0);W5a(198136|0);W5a(198124|0);W5a(198112|0);W5a(198100|0);W5a(198088|0);W5a(198076|0);W5a(198064|0);W5a(198052|0);W5a(198040|0);W5a(198028|0);W5a(198016|0);W5a(198004|0);W5a(197992|0);W5a(197980|0);W5a(197968|0);W5a(197956|0);W5a(197944|0);W5a(197932|0);W5a(197920|0);W5a(197908|0);W5a(197896|0);W5a(197884|0);W5a(197872);i=a;return}function deb(a){a=a|0;a=i;s5a(198988|0);s5a(198976|0);s5a(198964|0);s5a(198952|0);s5a(198940|0);s5a(198928|0);s5a(198916|0);s5a(198904|0);s5a(198892|0);s5a(198880|0);s5a(198868|0);s5a(198856|0);s5a(198844|0);s5a(198832|0);s5a(198820|0);s5a(198808|0);s5a(198796|0);s5a(198784|0);s5a(198772|0);s5a(198760|0);s5a(198748|0);s5a(198736|0);s5a(198724|0);s5a(198712);i=a;return}function eeb(a){a=a|0;a=i;W5a(199380|0);W5a(199368|0);W5a(199356|0);W5a(199344|0);W5a(199332|0);W5a(199320|0);W5a(199308|0);W5a(199296|0);W5a(199284|0);W5a(199272|0);W5a(199260|0);W5a(199248|0);W5a(199236|0);W5a(199224);i=a;return}function feb(a){a=a|0;a=i;s5a(199916|0);s5a(199904|0);s5a(199892|0);s5a(199880|0);s5a(199868|0);s5a(199856|0);s5a(199844|0);s5a(199832|0);s5a(199820|0);s5a(199808|0);s5a(199796|0);s5a(199784|0);s5a(199772|0);s5a(199760);i=a;return}function geb(a){a=a|0;var b=0,c=0;b=i;if((meb(a)|0)==0){c=(heb(a)|0)!=0|0}else{c=1}i=b;return c|0}function heb(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[200072+((d[200072+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function ieb(a){a=a|0;var b=0,c=0;b=i;c=xb(a|0)|0;i=b;return c|0}function jeb(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function keb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 1:{d=geb(a)|0;break};case 10:{d=reb(a)|0;break};case 11:{d=seb(a)|0;break};case 4:{d=jeb(a)|0;break};case 8:{d=peb(a)|0;break};case 5:{d=meb(a)|0;break};case 3:{d=ieb(a)|0;break};case 2:{d=heb(a)|0;break};case 9:{d=qeb(a)|0;break};case 6:{d=neb(a)|0;break};case 12:{d=teb(a)|0;break};case 7:{d=oeb(a)|0;break};default:{d=0}}i=c;return d|0}function leb(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=203048;while(1){if(d<<24>>24==e<<24>>24){if((Xfb(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function meb(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function neb(a){a=a|0;var b=0,c=0;b=i;if((reb(a)|0)==0){c=(peb(a)|0)!=0|0}else{c=0}i=b;return c|0}function oeb(a){a=a|0;var b=0,c=0;b=i;if((ueb(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function peb(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function qeb(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[203128+((d[203128+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function reb(a){a=a|0;var b=0,c=0;b=i;c=(Yeb(206296,a)|0)!=0|0;i=b;return c|0}function seb(a){a=a|0;var b=0,c=0;b=i;c=(web(a)|0)!=(a|0)|0;i=b;return c|0}function teb(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function ueb(a){a=a|0;var b=0,c=0;b=i;c=veb(a,0)|0;i=b;return c|0}function veb(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((heb(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[206386+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[206384+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[206387+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[206632+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[206632+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[206632+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function web(a){a=a|0;var b=0,c=0;b=i;c=veb(a,1)|0;i=b;return c|0}function xeb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=yeb(0,a,b,(c|0)!=0?c:207336)|0;i=d;return e|0}function yeb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?207344:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[207128+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Nc()|0)>>2]=84;k=-1;i=g;return k|0}function zeb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=Aeb(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=yeb(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==-1){C=-1;break}else if((I|0)==0){c[h>>2]=0;C=G;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function Aeb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[207128+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[207128+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Nc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function Beb(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[207128+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Nc()|0)>>2]=84;j=-1;i=g;return j|0}function Ceb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Nc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function Deb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=Eeb(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=Ceb(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function Eeb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=Ceb(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=Ceb(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=Ceb(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}Ceb(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}



function mPa(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;kRa(l)|0;b=k+540|0;ie[c[(c[b>>2]|0)+40>>2]&127](l)|0;ie[c[(c[b>>2]|0)+28>>2]&127](l)|0;vPa(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function nPa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];kRa(g)|0;l=e+540|0;ie[c[(c[l>>2]|0)+40>>2]&127](g)|0;ie[c[(c[l>>2]|0)+28>>2]&127](g)|0;ie[c[(c[l>>2]|0)+32>>2]&127](g)|0;le[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function oPa(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;wPa(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function pPa(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;kRa(l)|0;b=k+540|0;ie[c[(c[b>>2]|0)+40>>2]&127](l)|0;ie[c[(c[b>>2]|0)+28>>2]&127](l)|0;uPa(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function qPa(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function rPa(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;xPa(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function sPa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function tPa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-12:{UMa(1,0,148088,c);m=-12;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-2:{UMa(1,0,147616,k);m=-2;i=b;return m|0};case-6:{UMa(1,0,147656,j);m=-6;i=b;return m|0};case-9:{UMa(1,0,147816,f);m=-9;i=b;return m|0};case-8:{UMa(1,0,147768,g);m=-8;i=b;return m|0};case-10:{UMa(1,0,147904,e);m=-10;i=b;return m|0};case-7:{UMa(1,0,147728,h);m=-7;i=b;return m|0};case-11:{UMa(1,0,148e3,d);m=-11;i=b;return m|0};case-33:{UMa(1,0,148136,b);m=-33;i=b;return m|0};case-1:{UMa(3,0,146944,l);m=1;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function uPa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}ie[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function vPa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;ie[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function wPa(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+td(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+td(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;lPa(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}function xPa(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+td(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+td(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}lPa(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function yPa(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function zPa(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;fe[c[(c[a+540>>2]|0)+112>>2]&511](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function APa(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function BPa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=bNa(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{xe[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;$Ma(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=bNa(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function CPa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((BPa(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}DPa(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(bNa(d)|0)>0;h=b?2:0;i=e;return h|0}function DPa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=xfb(q)|0;s=r;t=xfb(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[37224]=ZMa(4)|0;if((r|0)==0){cb(148904,148920,308,148952)}if((t|0)==0){cb(148968,148920,309,148952)}v=eNa(b)|0;if((v|0)!=0){w=v;do{v=gNa(w)|0;c[l>>2]=c[v>>2];SMa(27,0,148984,l);w=fNa(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;bgb(t|0,c[a+384>>2]|0,v|0)|0;bgb(r|0,l|0,v|0)|0}h[d>>3]=+GPa(a,n,o,q,s,c[37224]|0,b);do{if((bNa(c[37224]|0)|0)==0){s=cNa(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=eNa(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=gNa(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=fNa(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];SMa(27,0,149032,j);v=eNa(b)|0;if((v|0)==0){break}else{B=v}do{v=gNa(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[37224]|0;aNa(v,gNa(B)|0);v=gNa(B)|0;c[g>>2]=c[v>>2];SMa(27,0,149056,g)}B=fNa(B)|0;}while((B|0)!=0)}}while(0);_Ma(b);if((c[118220>>2]|0)!=0){bNa(c[37224]|0)|0}if((bNa(c[37224]|0)|0)>0){B=m;do{g=cNa(c[37224]|0)|0;c[m>>2]=c[g>>2];dNa(c[37224]|0);c[f>>2]=c[m>>2];SMa(7,0,149080,f);$Ma(b,B);}while((bNa(c[37224]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){bgb(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}Ze(a);JPa(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){yfb(t);yfb(r);i=e;return}bgb(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;yfb(t);yfb(r);i=e;return}function EPa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){NPa(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];SMa(7,0,148624,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((bNa(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[118220>>2]|0)!=0){e=eNa(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=gNa(s)|0;x=c[e>>2]|0;e=xe[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;RMa(7,0,w,148648,l);s=fNa(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=gNa(eNa(d)|0)|0;x=xe[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;RMa(1,0,e,148664,j);c[s>>2]=1}}while(0);_Ma(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;IPa(b);FPa(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function FPa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;SMa(27,0,149272,b);d=a+344|0;le[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function GPa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=xfb(p<<3)|0;if((q|0)==0){cb(149088,148920,409,149104)}if((p|0)>0){bgb(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];SMa(27,0,149120,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];SMa(27,0,149168,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){yfb(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}kRa(a)|0;ie[c[(c[p>>2]|0)+40>>2]&127](a)|0;ie[c[(c[p>>2]|0)+28>>2]&127](a)|0;ie[c[(c[p>>2]|0)+32>>2]&127](a)|0;le[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(HPa(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}bgb(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}yfb(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function HPa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;_Ma(b);SMa(27,0,149192,g);g=eNa(d)|0;if((g|0)==0){j=bNa(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=gNa(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=gNa(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=gNa(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=gNa(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=gNa(a)|0;o=c[g>>2]|0;g=gNa(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?148608:148616;g=gNa(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?148608:148616;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;SMa(27,0,149232,f);$Ma(b,gNa(a)|0)}a=fNa(a)|0;}while((a|0)!=0);j=bNa(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function IPa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;xe[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;JPa(b);KPa(b);ie[c[(c[g>>2]|0)+36>>2]&127](b)|0;LPa(b,8);h=MPa(b)|0;j=ie[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{KPa(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}NPa(b);JPa(b);LPa(b,8);ie[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=MPa(b)|0;j=ie[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){WMa(c[b+536>>2]|0,149312,e)}else if((o|0)==7){KPa(b);i=d;return}}function JPa(a){a=a|0;var b=0;b=i;bgb(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function KPa(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function LPa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[118192+(d<<2)>>2]|0)==0){i=e;return}SMa(d,1,149736,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=ie[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=ie[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;SMa(d,0,149760,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}fe[c[29686]&511](d);i=e;return}function MPa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function NPa(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;bgb(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;bgb(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;bgb(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;bgb(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function OPa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}le[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function PPa(a){a=a|0;var b=0;b=i;QPa(a);RPa(a);NPa(a);SPa(a);i=b;return}function QPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function RPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function SPa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((YNa(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];bgb(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;bgb(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;bgb(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;bgb(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(YNa(c[d>>2]|0)|0));i=b;return}function TPa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[118192+(d<<2)>>2]|0)==0){i=e;return}SMa(d,1,149408,q);q=b+136|0;if((c[q>>2]|0)>0){SMa(d,1,149432,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?149392:149400;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];SMa(d,0,149448,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}fe[c[29686]&511](d)}s=b+140|0;if((c[s>>2]|0)>0){SMa(d,1,149504,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?149392:149400;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;SMa(d,0,149528,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}fe[c[29686]&511](d)}o=b+144|0;if((c[o>>2]|0)>0){SMa(d,1,149584,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?149392:149400;v=(a[n+(m*48|0)+40|0]|0)!=0?149392:149400;n=(a[(c[s>>2]|0)+m|0]|0)!=0?149392:149400;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;SMa(d,0,149608,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}fe[c[29686]&511](d)}m=b+148|0;if((c[m>>2]|0)>0){SMa(d,1,149664,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;SMa(d,0,149688,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}fe[c[29686]&511](d)}fe[c[29686]&511](d);i=e;return}function UPa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((YNa(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];bgb(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;bgb(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;bgb(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;bgb(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(YNa(c[d>>2]|0)|0));i=b;return}function VPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function WPa(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];bgb(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;bgb(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;bgb(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;bgb(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function XPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=TNa(3,32)|0;c[o>>2]=p;if((p|0)==0){WMa(c[b+536>>2]|0,149792,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=zfb(c[p>>2]|0,8)|0;c[q>>2]=z;VMa(c[r>>2]|0,(z|0)!=0|0,149848,l);z=zfb(c[s>>2]|0,4)|0;c[t>>2]=z;VMa(c[r>>2]|0,(z|0)!=0|0,149848,k);z=zfb(c[u>>2]|0,1)|0;c[v>>2]=z;VMa(c[r>>2]|0,(z|0)!=0|0,149848,j);z=zfb(c[w>>2]|0,4)|0;c[x>>2]=z;VMa(c[r>>2]|0,(z|0)!=0|0,149848,g);XNa(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=zfb(3,4)|0;c[b+4>>2]=n;ZNa(c[o>>2]|0,0,n);c[b+8>>2]=zfb(c[p>>2]|0,112)|0;c[b+12>>2]=zfb(c[s>>2]|0,60)|0;c[b+16>>2]=zfb(c[u>>2]|0,48)|0;c[b+20>>2]=zfb(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=zfb(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=zfb(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=zfb(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=zfb(g,52)|0;c[b+40>>2]=zfb(c[b+216>>2]|0,52)|0;c[b+44>>2]=zfb(c[b+220>>2]|0,52)|0;c[b+48>>2]=zfb(c[b+224>>2]|0,52)|0;c[b+52>>2]=zfb(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=zfb(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=zfb(x,8)|0;c[b+340>>2]=zfb(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=zfb(x,8)|0;c[b+348>>2]=zfb(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=zfb(j,1)|0;c[b+356>>2]=zfb(j,1)|0;c[b+360>>2]=zfb(j,1)|0;j=xfb(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=xfb(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=zfb(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=zfb(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=zfb(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=zfb(u,4)|0;c[b+400>>2]=zfb(x,8)|0;c[b+404>>2]=zfb(p,4)|0;c[b+408>>2]=zfb(s,1)|0;c[b+412>>2]=zfb(u,4)|0;c[b+416>>2]=zfb(c[n>>2]|0,8)|0;c[b+420>>2]=zfb(o,4)|0;c[b+424>>2]=zfb(y,1)|0;c[b+428>>2]=zfb(g,4)|0;c[b+432>>2]=zfb(c[b+152>>2]|0,8)|0;c[b+436>>2]=zfb(c[b+156>>2]|0,8)|0;g=xfb((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;fe[c[(c[y>>2]|0)+20>>2]&511](g);g=xfb((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;fe[c[(c[y>>2]|0)+16>>2]&511](g);g=xfb((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;fe[c[(c[y>>2]|0)+12>>2]&511](g);g=xfb((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;ge[c[(c[y>>2]|0)+24>>2]&127](g,b);c[b+464>>2]=xfb((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=zfb(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;VMa(c[r>>2]|0,(g|0)!=0|0,149864,f);c[b+512>>2]=100;c[b+516>>2]=zfb(100,4)|0;c[b+520>>2]=zfb(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=xfb(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;VMa(c[r>>2]|0,(g|0)!=0|0,149848,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=TNa(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function YPa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;yfb(c[g+8>>2]|0);yfb(c[g+12>>2]|0);yfb(c[g+16>>2]|0);yfb(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);yfb(e);UNa(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){pOa(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}yfb(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){pOa(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}yfb(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){pOa(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}yfb(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){pOa(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}yfb(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){pOa(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}yfb(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){pOa(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}yfb(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){pOa(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}yfb(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){pOa(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}yfb(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){pOa(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}yfb(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){pOa(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}yfb(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){pOa(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}yfb(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){pOa(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}yfb(v);yfb(c[a+108>>2]|0);yfb(c[a+336>>2]|0);yfb(c[a+340>>2]|0);yfb(c[a+344>>2]|0);yfb(c[a+348>>2]|0);yfb(c[a+352>>2]|0);yfb(c[a+356>>2]|0);yfb(c[a+360>>2]|0);yfb(c[a+368>>2]|0);yfb(c[a+384>>2]|0);yfb(c[a+388>>2]|0);yfb(c[a+392>>2]|0);yfb(c[a+396>>2]|0);yfb(c[a+400>>2]|0);yfb(c[a+404>>2]|0);yfb(c[a+408>>2]|0);yfb(c[a+412>>2]|0);yfb(c[a+416>>2]|0);yfb(c[a+420>>2]|0);yfb(c[a+424>>2]|0);yfb(c[a+428>>2]|0);yfb(c[a+488>>2]|0);yfb(c[a+484>>2]|0);yfb(c[a+476>>2]|0);yfb(c[a+468>>2]|0);yfb(c[a+464>>2]|0);yfb(c[a+432>>2]|0);yfb(c[a+436>>2]|0);yfb(c[a+320>>2]|0);yfb(c[a+516>>2]|0);yfb(c[a+520>>2]|0);R2a(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;yfb(x);i=b;return}else{y=a;z=0}while(1){UNa(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;yfb(x);i=b;return}function ZPa(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[18738]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];SMa(8,0,149912,d);i=b;return}function _Pa(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[18738];f=e+e*+U(+(d?b:a));if(d){g=f}else{g=-f}i=i;return a-b<=g|0}function $Pa(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0;d=i;e=(aQa(a,b,c<<24>>24==0|0)|0)<<24>>24==0|0;i=d;return e|0}function aQa(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[18738];f=e+e*+U(+(d?a:b));if(d){g=-f}else{g=f}i=i;return a-b>=g|0}function bQa(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0;d=i;e=(_Pa(a,b,c<<24>>24==0|0)|0)<<24>>24==0|0;i=d;return e|0}function cQa(a,b){a=+a;b=+b;i=i;return a<b|0}function dQa(a,b){a=+a;b=+b;i=i;return a<=b|0}function eQa(a,b){a=+a;b=+b;i=i;return a>b|0}function fQa(a,b){a=+a;b=+b;i=i;return a>=b|0}function gQa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=xfb(k)|0;c[e+(h*40|0)+24>>2]=xfb(k)|0;if((c[g>>2]|0)!=1){l=5;break}jQa(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){WMa(c[a+536>>2]|0,149968,d)}else if((l|0)==6){i=b;return 0}return 0}function hQa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){yfb(c[e+(h*40|0)+20>>2]|0);yfb(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;kQa(k)|0;yfb(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){WMa(c[a+536>>2]|0,149968,d)}else if((j|0)==6){i=b;return 0}return 0}function iQa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[118260>>2]|c[29546]|0)==0){z=w;A=1;break}P2a(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];UMa(17,1,15e4,g);P2a(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;P2a(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;UMa(17,0,150032,f);P2a(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}fe[c[29686]&511](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function jQa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=xfb(20)|0;c[b>>2]=f;VMa(0,(f|0)!=0|0,150040,e);e=xfb(a)|0;c[f>>2]=e;e=xfb(a)|0;c[f+4>>2]=e;e=xfb(a)|0;c[f+8>>2]=e;e=xfb(a)|0;c[f+16>>2]=e;VMa(0,(c[b>>2]|0)!=0|0,150072,d);i=d;return 0}function kQa(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;yfb(c[d>>2]|0);yfb(c[d+4>>2]|0);yfb(c[d+8>>2]|0);yfb(c[d+16>>2]|0);i=b;return 0}function lQa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;WMa(c[a+536>>2]|0,150120,b);return 0}function mQa(a){a=a|0;a=i;i=i+8|0;WMa(0,150120,a);return 0}function nQa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;WMa(c[a+536>>2]|0,150120,b);return 0}function oQa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=xfb(l)|0;c[e+(h<<6)+36>>2]=xfb(l)|0;m=c[g>>2]|0;if((m|0)==2){c[e+(h<<6)+8>>2]=2;xQa(j,j,k,e+(h<<6)+24|0)|0}else if((m|0)==1){c[e+(h<<6)+32>>2]=xfb(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;uQa(j,e+(h<<6)+24|0)|0}else{n=6;break}j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{n=8;break}}if((n|0)==6){WMa(c[a+536>>2]|0,150160,d)}else if((n|0)==8){i=b;return 0}return 0}function pQa(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function qQa(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;vb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function rQa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){yfb(c[e+(h<<6)+28>>2]|0);yfb(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==2){yQa(e+(h<<6)+24|0)|0}else if((j|0)==1){vQa(e+(h<<6)+24|0)|0;yfb(c[e+(h<<6)+32>>2]|0)}else{k=6;break}yfb(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){WMa(c[a+536>>2]|0,150160,d)}else if((k|0)==8){i=b;return 0}return 0}function sQa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[b+476>>2]|0;h=c[b+292>>2]|0;if((h|0)==2){j=zQa(b,d)|0}else if((h|0)==1){j=wQa(b,d)|0}else{WMa(c[b+536>>2]|0,150160,f)}a[g+(d<<6)+56|0]=j;i=e;return 0}function tQa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[118252>>2]|c[29546]|0)==0){z=w;A=1;break}P2a(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];UMa(15,1,150192,g);P2a(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;P2a(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;UMa(15,0,150224,f);P2a(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}fe[c[29686]&511](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function uQa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=xfb(12)|0;f=xfb(a<<2)|0;c[e>>2]=f;VMa(0,(f|0)!=0|0,150232,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function vQa(a){a=a|0;var b=0;b=i;yfb(c[c[a>>2]>>2]|0);i=b;return 0}function wQa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16384|0;v=i;i=i+4096|0;w=c[b+476>>2]|0;x=w+(d<<6)|0;y=c[w+(d<<6)+24>>2]|0;z=w+(d<<6)+16|0;A=c[z>>2]|0;B=w+(d<<6)+32|0;dgb(c[B>>2]|0,0,fa(A<<3,A)|0)|0;C=b;D=x;ge[c[x>>2]&127](C,D);ge[c[w+(d<<6)+4>>2]&127](C,D);if((c[118256>>2]|0)!=0){D=u;c[t>>2]=A;c[t+4>>2]=A;SMa(16,1,150288,t);t=(A|0)>0;do{if(t){u=0;do{a[D]=0;C=0;do{x=(fa(C,A)|0)+u|0;E=+h[(c[B>>2]|0)+(x<<3)>>3];c[r>>2]=D;x=r+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];hc(D|0,150312,r|0)|0;C=C+1|0;}while((C|0)<(A|0));c[q>>2]=D;SMa(16,0,150328,q);u=u+1|0;}while((u|0)<(A|0));c[p>>2]=A;SMa(16,1,150336,p);if(!t){break}u=w+(d<<6)+36|0;C=0;do{a[D]=0;E=+h[(c[u>>2]|0)+(C<<3)>>3];c[o>>2]=D;x=o+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];hc(D|0,150312,o|0)|0;c[n>>2]=D;SMa(16,0,150328,n);C=C+1|0;}while((C|0)<(A|0))}else{c[s>>2]=A;SMa(16,1,150336,s)}}while(0);fe[c[29686]&511](16)}s=w+(d<<6)+36|0;A=y+8|0;EHa(z,y+4|0,c[B>>2]|0,z,c[y>>2]|0,c[s>>2]|0,z,A)|0;y=c[A>>2]|0;if((y|0)<0){E=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[w+(d<<6)+20>>2];A=m+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];c[m+12>>2]=y;UMa(1,0,150352,m);F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;bgb(M|0,O|0,Q|0)|0;i=e;return F|0}if((y|0)<=0){F=1;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;bgb(M|0,O|0,Q|0)|0;i=e;return F|0}E=+h[c[c[b+4>>2]>>2]>>3];b=y+1|0;c[l>>2]=c[w+(d<<6)+20>>2];y=l+4|0;h[k>>3]=E;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[l+12>>2]=b;c[l+16>>2]=b;UMa(1,0,150440,l);if((c[118252>>2]|0)==0){F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;bgb(M|0,O|0,Q|0)|0;i=e;return F|0}l=v;v=(c[z>>2]|0)>0;a[l]=0;if(v){v=0;do{b=c[z>>2]|0;if((b|0)>0){y=b;m=0;while(1){A=(fa(y,m)|0)+v|0;E=+h[(c[B>>2]|0)+(A<<3)>>3];c[j>>2]=l;A=j+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];hc(l|0,150544,j|0)|0;A=m+1|0;n=c[z>>2]|0;if((A|0)<(n|0)){m=A;y=n}else{R=n;break}}}else{R=b}v=v+1|0;a[l]=0}while((v|0)<(R|0))}if((c[z>>2]|0)>0){R=0;do{E=+h[(c[s>>2]|0)+(R<<3)>>3];c[g>>2]=l;v=g+4|0;h[k>>3]=E;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];hc(l|0,150544,g|0)|0;R=R+1|0;}while((R|0)<(c[z>>2]|0))}a[l]=0;if((c[z>>2]|0)>0){S=0}else{F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;bgb(M|0,O|0,Q|0)|0;i=e;return F|0}while(1){E=+h[(c[s>>2]|0)+(S<<3)>>3];c[f>>2]=l;R=f+4|0;h[k>>3]=E;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];hc(l|0,150544,f|0)|0;R=S+1|0;if((R|0)<(c[z>>2]|0)){S=R}else{F=0;break}}G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;bgb(M|0,O|0,Q|0)|0;i=e;return F|0}function xQa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=xfb(32)|0;VMa(0,(g|0)!=0|0,150552,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Yd(0,d|0)|0;Nd(c[d>>2]|0,c[b>>2]|0,0)|0;Yd(0,g+4|0)|0;Nd(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;bb(b|0)|0;Lb(150600,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function yQa(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;zd(c[d+12>>2]|0)|0;Kb(c[d+8>>2]|0)|0;Kb(c[d+4>>2]|0)|0;i=b;return 0}function zQa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[a+476>>2]|0;f=e+(b<<6)|0;g=c[e+(b<<6)+24>>2]|0;ld(c[g>>2]|0)|0;Ud(0,g|0)|0;j=g+24|0;Pb(c[g>>2]|0,c[j>>2]|0,0)|0;k=a;a=f;ge[c[f>>2]&127](k,a);Vc(c[g>>2]|0,1)|0;Ua(c[g>>2]|0)|0;ge[c[e+(b<<6)+4>>2]&127](k,a);if((c[j>>2]|0)>0){a=e+(b<<6)+36|0;k=g+8|0;f=k;l=0;while(1){gd(0,l|0,+(+h[(c[a>>2]|0)+(l<<3)>>3]),c[k>>2]|0)|0;m=l+1|0;if((m|0)<(c[j>>2]|0)){l=m}else{n=f;break}}}else{n=g+8|0}f=g+4|0;l=(mc(c[g>>2]|0,c[n>>2]|0,c[f>>2]|0,c[g+12>>2]|0)|0)==0|0;Jb(c[f>>2]|0,0,c[g+20>>2]|0,c[e+(b<<6)+28>>2]|0)|0;ld(c[g>>2]|0)|0;i=d;return l|0}function AQa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;VMa(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,150768,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){VMa(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,150808,e);if((ie[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=xfb(p)|0;c[g+(m*80|0)+52>>2]=xfb(p)|0;c[g+(m*80|0)+48>>2]=xfb(p)|0;c[g+(m*80|0)+16>>2]=xfb(p)|0;c[g+(m*80|0)+8>>2]=xfb(p)|0;c[g+(m*80|0)+12>>2]=xfb(p)|0;ge[c[g+(m*80|0)+36>>2]&127](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){NQa(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==2){lQa(a,n)|0;break}else if((p|0)==3){NQa(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==1){FQa(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){WMa(c[j>>2]|0,150848,d)}else if((q|0)==14){i=b;return 0}return 0}function BQa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;yfb(c[e+(h*80|0)+44>>2]|0);yfb(c[e+(h*80|0)+52>>2]|0);yfb(c[e+(h*80|0)+48>>2]|0);yfb(c[e+(h*80|0)+16>>2]|0);yfb(c[e+(h*80|0)+8>>2]|0);yfb(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;OQa(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==3){m=e+(h*80|0)+40|0;OQa(m)|0;l=m;break}else if((k|0)==2){n=7;break a}else if((k|0)==1){k=e+(h*80|0)+40|0;GQa(k)|0;l=k;break}else{n=9;break a}}}while(0);yfb(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=11;break}}if((n|0)==7){mQa(j)|0}else if((n|0)==9){WMa(c[a+536>>2]|0,150848,d)}else if((n|0)==11){i=b;return 0}return 0}function CQa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(QQa(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==2){j=(nQa(b,d)|0)&255;break}else if((k|0)==1){l=b+536|0;m=(c[l>>2]|0)+84|0;n=c[m>>2]|0;c[m>>2]=3;m=HQa(b,d)|0;c[(c[l>>2]|0)+84>>2]=n;j=m&255;break}else if((k|0)==3){j=(QQa(b,d)|0)&255;break}else{WMa(c[b+536>>2]|0,150848,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function DQa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;P2a(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];TMa(17,1,u,150880,m);do{if((a[b+312|0]|0)==0){P2a(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;P2a(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;UMa(17,0,151080,f);P2a(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{UMa(17,1,150920,l);P2a(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;P2a(q,d,c[v>>2]|0);if((Xfb(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];UMa(17,0,151e3,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;P2a(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;UMa(17,0,151040,g);G=E}P2a(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[118260>>2]|c[29546]|0)==0){break}fe[c[29686]&511](17)}}while(0);if((c[118260>>2]|c[29546]|0)==0){x=1;i=e;return x|0}fe[c[29686]&511](17);x=1;i=e;return x|0}function EQa(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function FQa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=xfb(144)|0;c[b>>2]=f;VMa(0,(f|0)!=0|0,151096,e);c[f>>2]=0;e=a<<3;g=xfb(e)|0;c[f+4>>2]=g;g=xfb(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=xfb(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=xfb(e)|0;c[f+24>>2]=g;g=zfb(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=xfb(e)|0;c[f+64>>2]=g;g=xfb(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=zfb(g,8)|0;c[f+104>>2]=j;j=zfb(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=xfb(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=xfb(e)|0;c[f+124>>2]=j;j=xfb(e)|0;c[f+128>>2]=j;j=xfb(e)|0;c[f+132>>2]=j;j=xfb(e)|0;c[f+136>>2]=j;j=xfb(e)|0;c[f+140>>2]=j;VMa(0,(c[b>>2]|0)!=0|0,151128,d);i=d;return 0}function GQa(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;yfb(c[d+4>>2]|0);yfb(c[d+16>>2]|0);yfb(c[d+12>>2]|0);yfb(c[d+24>>2]|0);yfb(c[d+28>>2]|0);yfb(c[d+64>>2]|0);yfb(c[d+68>>2]|0);yfb(c[d+104>>2]|0);yfb(c[d+108>>2]|0);yfb(c[d+116>>2]|0);yfb(c[d+124>>2]|0);yfb(c[d+128>>2]|0);yfb(c[d+132>>2]|0);yfb(c[d+136>>2]|0);yfb(c[d+140>>2]|0);i=b;return 0}function HQa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=xfb(c[Y>>2]|0)|0;if((c[118260>>2]|0)!=0){P2a(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];SMa(17,1,151168,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];SMa(17,1,151224,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];SMa(17,0,151240,F);fe[c[29686]&511](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}fe[c[29686]&511](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){bgb(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{bgb(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+td(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;IQa($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+td(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[118264>>2]|0)!=0){JQa(c[Q>>2]|0,$,18,151280);JQa(c[ca>>2]|0,$,18,151312)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[118264>>2]|0)!=0){JQa(c[ca>>2]|0,$,18,151344)}a[da]=R;VOa(10,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){P2a(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];oOa(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;IQa($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;IQa($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}JPa(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[118264>>2]|0)!=0){SMa(18,1,151384,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];SMa(18,1,151424,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];SMa(18,0,151456,C);fe[c[29686]&511](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}fe[c[29686]&511](18)}if((c[118268>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;SMa(19,1,151488,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];hc(Ja|0,151512,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;SMa(19,0,151520,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}fe[c[29686]&511](19)}h[K>>3]=+UOa($,c[Ia>>2]|0);h[J>>3]=+UOa($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}bgb(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){bgb(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{bgb(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[118260>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];SMa(17,0,151568,w);KQa(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[118260>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}SMa(17,0,151640,v);KQa(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){bgb(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{bgb(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+td(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[118260>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}SMa(17,0,151704,u);KQa(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){bgb(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{bgb(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+td(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[118260>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}SMa(17,0,151776,t);KQa(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}bgb(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;bgb(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[118260>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}SMa(17,0,151840,s);KQa(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){bgb(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[118260>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}SMa(17,0,151912,r);KQa(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){bgb(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{bgb(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[118260>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}SMa(17,0,151984,q);KQa(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){bgb(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{bgb(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[118260>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}SMa(17,0,152056,p);KQa(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){bgb(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[118260>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}SMa(17,0,152120,o);KQa(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){bgb(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{bgb(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[118260>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}SMa(17,0,152192,n);KQa(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){bgb(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{bgb(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[118260>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];SMa(17,0,152328,l);KQa(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){bgb(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{bgb(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[118260>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}SMa(17,0,152256,m);KQa(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[118260>>2]|0)!=0){SMa(17,1,151528,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;SMa(17,0,151544,x);fe[c[29686]&511](17);KQa(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}bgb(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;IQa($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;yfb(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;yfb(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;yfb(Z);i=e;return kb|0}if((a[Ha]|0)==0){P2a(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];oOa(0,f,hb);}if((c[118260>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;SMa(17,0,152400,j);KQa(S,L,J,K,17)}bgb(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;yfb(Z);i=e;return kb|0}return 0}function IQa(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[118272>>2]|0)!=0){SMa(20,0,152752,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){MQa(w,f,d,e,m)}else{LQa(w,f,m)}do{if((c[118272>>2]|0)!=0){SMa(20,0,152792,r);if((c[118268>>2]|0)==0){break}w=v;s=c[b>>2]|0;c[q>>2]=s;c[q+4>>2]=s;SMa(19,1,151488,q);s=c[b>>2]|0;if((s|0)>0){C=y+20|0;D=s;s=0;do{a[w]=0;if((D|0)>0){E=0;do{F=+h[f+((fa(c[C>>2]|0,s)|0)+E<<3)>>3];c[p>>2]=w;G=p+4|0;h[k>>3]=F;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];hc(w|0,152824,p|0)|0;E=E+1|0;}while((E|0)<(c[b>>2]|0))}c[o>>2]=w;SMa(19,0,151520,o);s=s+1|0;D=c[b>>2]|0;}while((s|0)<(D|0))}fe[c[29686]&511](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else if((A|0)==1){z=y+8|0;do{if((c[z>>2]|0)!=0){B=c[b>>2]|0;if((B|0)<=0){break}o=c[y+12>>2]|0;p=0;do{f=d+(p<<3)|0;h[f>>3]=+h[f>>3]*+h[o+(p<<3)>>3];p=p+1|0;}while((p|0)<(B|0))}}while(0);if((c[118272>>2]|0)!=0){c[u>>2]=c[y+96>>2];SMa(20,0,152648,u);JQa(d,b,20,152680)}Ie[c[x+(m*80|0)+32>>2]&63](l,d,e,j);if((c[118272>>2]|0)!=0){JQa(e,b,20,152696);c[t>>2]=c[y+96>>2];SMa(20,0,152712,t)}if((c[z>>2]|0)==0){i=g;return 0}z=c[b>>2]|0;if((z|0)<=0){i=g;return 0}b=c[y+12>>2]|0;y=0;do{t=d+(y<<3)|0;h[t>>3]=1.0/+h[b+(y<<3)>>3]*+h[t>>3];y=y+1|0;}while((y|0)<(z|0));i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;WMa(g,152840,n)}return 0}function JQa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[118192+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;SMa(d,1,151520,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];SMa(d,0,152632,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}fe[c[29686]&511](d);i=f;return}function KQa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[118192+(f<<2)>>2]|0)==0){i=g;return}SMa(f,1,152440,q);SMa(f,1,152456,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];SMa(f,0,152472,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}fe[c[29686]&511](f);SMa(f,1,152512,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];SMa(f,0,152528,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}fe[c[29686]&511](f);SMa(f,1,152568,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];SMa(f,0,152584,j);fe[c[29686]&511](f);fe[c[29686]&511](f);i=g;return}function LQa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;dgb(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;dgb(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}ie[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function MQa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+td(+(n*+td(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;IQa(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function NQa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=xfb(80)|0;c[b>>2]=f;VMa(0,(f|0)!=0|0,152920,e);c[f>>2]=0;e=a<<3;g=xfb(e)|0;c[f+4>>2]=g;g=xfb(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=xfb(e)|0;c[f+16>>2]=g;g=zfb(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=xfb(fa(e,a)|0)|0;c[f+64>>2]=g;g=xfb(e)|0;c[f+68>>2]=g;g=xfb(a<<2)|0;c[f+72>>2]=g;VMa(0,(c[b>>2]|0)!=0|0,152952,d);i=d;return 0}function OQa(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;yfb(c[d+4>>2]|0);yfb(c[d+8>>2]|0);yfb(c[d+16>>2]|0);yfb(c[d+20>>2]|0);yfb(c[d+64>>2]|0);yfb(c[d+68>>2]|0);yfb(c[d+72>>2]|0);i=b;return 0}function PQa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;dgb(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}ie[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}function QQa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;bgb(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[118260>>2]|0)==0){J=b+4|0}else{P2a(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];SMa(17,1,152992,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];SMa(17,1,153064,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];SMa(17,0,153080,t);fe[c[29686]&511](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}fe[c[29686]&511](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];RQa(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){P2a(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];oOa(3,g,P);}$=+UOa(H,c[b>>2]|0);aa=+UOa(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){bgb(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;SMa(17,0,153256,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;SMa(17,0,153312,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;SMa(17,0,153376,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[118260>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;SMa(17,0,153128,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];SMa(17,0,153168,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];SMa(17,0,153224,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){P2a(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];oOa(0,f,L);if((c[118260>>2]|0)==0){da=0;break}c[m>>2]=V;SMa(17,0,153456,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];SMa(17,0,153168,l);if((c[118260>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];SMa(17,0,153224,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[118260>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;bgb(ma|0,oa|0,qa|0)|0;i=e;return da|0}fe[c[29686]&511](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;bgb(ma|0,oa|0,qa|0)|0;i=e;return da|0}function RQa(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[118264>>2]|0)!=0){c[z>>2]=j;SMa(18,0,153496,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];SMa(18,0,153544,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){SQa(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){TQa(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{PQa(E,m,r)|0}if((c[118268>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;SMa(19,1,153560,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];hc(F|0,153584,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;SMa(19,0,153592,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}fe[c[29686]&511](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+UOa(b,_);if(!(!(J<=H)&!(+UOa(b,e)<=H))){$=31;break}EHa(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;UMa(17,0,153600,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;UMa(17,0,153632,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+UOa(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function SQa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;Ie[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&63](e,a,b,d);i=g;return 0}function TQa(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+td(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;SQa(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function UQa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==2){VQa(a,b);f=0;i=d;return f|0}else if((e|0)==1){g=c[a+4>>2]|0;j=c[g+4>>2]|0;WQa(c[g>>2]|0,+h[j>>3],c[j+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else if((e|0)==4){te[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else if((e|0)==3){f=kPa(a,b)|0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function VQa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[153664+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[153664+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];ie[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function WQa(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function XQa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=ZMa(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;f=c[d+24>>2]|0;a:do{if((f|0)==3){g=xfb(88)|0;SMa(23,0,153696,e);j=iPa(b,d,g)|0;c[d+48>>2]=g;k=j}else if((f|0)==4){j=c[602]|0;g=xfb(j<<2)|0;c[38430]=g;if((j|0)<=0){k=0;break}l=c[b+116>>2]|0;m=g;g=0;while(1){c[m+(g<<2)>>2]=zfb(l,8)|0;n=g+1|0;if((n|0)>=(j|0)){k=0;break a}m=c[38430]|0;g=n}}else if((f|0)==2){g=xfb(8)|0;c[g+4>>2]=4;m=xfb(20)|0;c[g>>2]=m;j=c[b+112>>2]|0;l=m;m=0;while(1){c[l+(m<<2)>>2]=zfb(j,8)|0;if((m|0)>=4){break}l=c[g>>2]|0;m=m+1|0}c[d+48>>2]=g;k=0}else{k=0}}while(0);iRa(b)|0;if((c[2]|0)==0){i=e;return k|0}lOa(6);iOa(1);i=e;return k|0}function YQa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+24>>2]|0;if((e|0)==3){jPa(c[b+48>>2]|0)|0}else if((e|0)==2){f=b+48|0;b=c[f>>2]|0;g=c[b>>2]|0;if((c[b+4>>2]|0)>-1){b=g;h=0;while(1){yfb(c[b+(h<<2)>>2]|0);j=c[f>>2]|0;k=c[j>>2]|0;if((h|0)<(c[j+4>>2]|0)){h=h+1|0;b=k}else{l=k;break}}}else{l=g}yfb(l);yfb(c[f>>2]|0)}else if((e|0)==4){e=c[602]|0;f=c[38430]|0;if((e|0)>0){l=f;g=0;while(1){yfb(c[l+(g<<2)>>2]|0);b=g+1|0;h=c[38430]|0;if((b|0)<(e|0)){g=b;l=h}else{m=h;break}}}else{m=f}yfb(m)}jRa(a)|0;dRa(a);i=d;return 0}function ZQa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(429,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=mgb(c[s>>2]|0,o)|0;if((t|0)==0){eb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=mgb(c[s>>2]|0,o)|0;if((B|0)==0){eb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=mgb(c[C>>2]|0,o)|0;if((D|0)==0){eb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=mgb(c[C>>2]|0,o)|0;if((E|0)==0){eb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=mgb(c[s>>2]|0,o)|0;if((F|0)==0){eb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(430,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=mgb(c[s>>2]|0,o)|0;if((G|0)==0){eb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=mgb(c[s>>2]|0,o)|0;if((H|0)==0){eb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;_fb(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=mgb(c[L>>2]|0,o)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ja(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=mgb(c[p>>2]|0,o)|0;if((N|0)==0){eb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Sa(14,1,0,153728,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=mgb(c[M>>2]|0,o)|0;if((U|0)==0){eb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=mgb(c[M>>2]|0,o)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Sa(15,2,0,153824,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=mgb(c[M>>2]|0,o)|0;if((X|0)==0){eb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[159944>>2]|0,159920,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=mgb(c[M>>2]|0,o)|0;if((Y|0)==0){eb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Sa(15,23,0,153880,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=mgb(c[M>>2]|0,o)|0;if((Z|0)==0){eb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(431,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=mgb(c[M>>2]|0,o)|0;if(($|0)==0){eb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}



function rOa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[16006]=.5;h[16002]=1.0;h[16018]=6.283185307179586;z=+h[n>>3];h[16015]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[32018]=A;c[32026]=0;B=c[d>>2]|0;c[31978]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[31978]=B+1}c[31976]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[16007]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[16007]=F;G=F}else{G=z}H=c[d>>2]|0;c[31978]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[16007];I=I+1|0}c[31978]=H+1}I=B+1|0;c[31976]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[15990]=0.0;D=c[b>>2]|0;c[31974]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[15990]=+h[15990]+G*G;A=p+1|0;c[31974]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[31978]=1;if((p|0)>=1){D=1;while(1){h[16007]=0.0;h[16005]=0.0;y=c[b>>2]|0;c[31976]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[16007]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[16005]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[31976]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[16007]=G;h[16005]=+h[g>>3]*L;g=c[b>>2]|0;c[31974]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[16005]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[16007];H=H+1|0}c[31974]=g+1}H=D+1|0;c[31978]=H;if((D|0)<(p|0)){D=H}else{break}}}h[15991]=0.0;h[15993]=0.0;h[16e3]=0.0;D=c[b>>2]|0;c[31974]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[15991]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[15993]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[16e3]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[31974]=D+1;O=R;P=T;Q=S}S=+h[15990];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[16011]=U;h[16007]=0.0;if(Q*Q>S*.99*O){h[16007]=+h[16002]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[16006]*U*Z);h[16003]=P;if(O*+h[16015]<P*P*.01){h[16007]=+h[16002]}n=c[b>>2]|0;c[31974]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[16011]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[16007]*U;if((D|0)>=(n|0)){break}e=D;P=+h[16011];D=D+1|0;p=e}c[31974]=n+1;_=0}while(1){n=_+1|0;c[32026]=n;h[15990]=0.0;h[15993]=0.0;h[15994]=0.0;p=c[b>>2]|0;c[31974]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[15990]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[15993]=da;Z=+h[H>>3];ea=P+Z*Z;h[15994]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[31974]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[16007]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[16012]=U;D=c[b>>2]|0;c[31974]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[16012];U=+h[15993];O=+h[15990];g=g+1|0;H=e}c[31974]=D+1}H=c[d>>2]|0;c[31978]=1;if((H|0)>=1){g=1;while(1){h[16005]=0.0;p=c[b>>2]|0;c[31976]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[16005]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[31976]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[16005]=O;e=c[b>>2]|0;c[31974]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[16005];l=l+1|0}c[31974]=e+1}l=g+1|0;c[31978]=l;if((g|0)<(H|0)){g=l}else{break}}}h[15995]=0.0;h[15996]=0.0;h[15997]=0.0;h[15998]=0.0;h[15999]=0.0;g=c[b>>2]|0;c[31974]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[15995]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[15996]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[15997]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[15998]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[15999]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[31974]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[16006];O=U*na;h[15995]=O;P=U*ma-O;h[15998]=P;Z=O+la+P;h[16019]=Z;h[16021]=Z;h[16020]=Z;c[32028]=0;a[127936]=1;W=+h[16018]/50.0;h[16007]=W;c[31974]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[16021]=wa;c[32028]=p;h[16016]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[16017]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[16010]=ta;h[16001]=ua;h[16004]=va;h[16003]=wa;c[31974]=50;h[16020]=wa;if((za|0)==49){h[16017]=Z;Ba=Z}else if((za|0)==0){h[16016]=wa;ga=74}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[16017]}h[16008]=0.0;S=+h[16016];if(S!=Ba){Q=S-Aa;h[16016]=Q;S=Ba-Aa;h[16017]=S;T=U*(Q-S)/(Q+S);h[16008]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[16010]=T;S=+X(+T);h[16001]=S;Q=+Y(+T);h[16004]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[16003]=T;p=c[b>>2]|0;c[31974]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[16001]*+h[y>>3]+ +h[16004]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[16004];Q=+h[16001];H=H+1|0;g=e}c[31974]=p+1;Da=+h[16003]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[16019];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function sOa(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[128392]=1;a[128384]=1;c[128404>>2]=6;a4a(128400)|0;e=c[d>>2]|0;c[32094]=1;if((e|0)>=1){d=1;do{r3a(128520,b+(d+ -1)|0,1)|0;o=c[32094]|0;d=o+1|0;c[32094]=d;}while((o|0)<(e|0))}K3a()|0;e=c[g>>2]|0;if((e|0)==1){c[128428>>2]=a[128384]&1?6:0;a4a(128424)|0;r3a(128520,h,4)|0;K3a()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[128452>>2]=a[128384]&1?6:0;a4a(128448)|0;r3a(128520,h,4)|0;r3a(128520,j,4)|0;K3a()|0}j=c[k>>2]|0;if((j|0)==1){c[128476>>2]=a[128384]&1?6:0;a4a(128472)|0;r3a(128520,l,8)|0;K3a()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[128500>>2]=a[128384]&1?6:0;a4a(128496)|0;r3a(128520,l,8)|0;r3a(128520,m,8)|0;K3a()|0}if((c[f>>2]|0)==2){$2a(128528,0)|0}else{i=n;return 0}return 0}function tOa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==0){c[32136]=2;B=2;while(1){C=B+1|0;if(!((c[k+(B+ -1<<2)>>2]|0)>>>0<2)){D=210;break a}c[32136]=C;if((C|0)<12){B=C}else{break}}if((c[d>>2]|0)<1){g3a(128600,130296,80,25);B=128904;C=128912;sOa(128600,130328,129080,B,128984,d,B,B,C,C,80)|0;break}c[32200]=5;C=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{B=c[C>>2]|0;c[32200]=B;if(!((B+ -1|0)>>>0>4)){E=B;break}g3a(128600,130336,80,34);B=128904;F=128912;sOa(128600,130376,129072,B,128984,128800,B,B,F,F,80)|0;break a}}while(0);c[C>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;B=fa(F,F)|0;c[32186]=B;c[32198]=B+50+(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0);B=q+12|0;if((c[k+16>>2]|0)==0){c[B>>2]=2;break}else{c[B>>2]=1;break}}else{B=c[q>>2]|0;do{if((B|0)>=0){F=c[d>>2]|0;if((B|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){g3a(128600,131160,80,52);I=128904;J=128912;sOa(128600,131144,131216,I,128984,G,I,I,J,J,80)|0;break a}c[32186]=fa((B<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[C>>2]|0)+4|0,H)|0;c[32198]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[32186]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[32198]=F+(c[32186]|0);break b}}}while(0);g3a(128600,131088,80,52);B=128904;F=128912;sOa(128600,131144,131152,B,128984,q,B,B,F,F,80)|0;break a}}while(0);c[32190]=(c[d>>2]|0)+20;c[q+64>>2]=c[32186];if((c[p>>2]|0)<(c[32198]|0)){g3a(128600,130384,80,60);C=128904;F=128912;sOa(128600,130448,130456,C,129080,128792,p,C,F,F,80)|0;break}if((c[r>>2]|0)<(c[32190]|0)){g3a(128600,130464,80,60);F=128904;C=128912;sOa(128600,130448,130528,F,129080,128760,r,F,C,C,80)|0;break}if(+h[j>>3]==+h[e>>3]){D=227;break}if((c[w>>2]|0)<0){g3a(128600,131272,80,24);C=128984;F=128904;B=128912;sOa(128600,131304,131312,C,C,w,F,F,B,B,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[16090]=K;if(!(K<=0.0)){break}g3a(128600,130768,80,28);B=128904;sOa(128600,129480,130800,B,B,B,B,128984,128720,128912,80)|0;break a}}while(0);c[q+60>>2]=0;B=q+36|0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;c[n>>2]=1;D=27}else if((A|0)==1){c[q+36>>2]=c[q+40>>2];D=27}else if((A|0)==-1){g3a(128600,128832,80,49);B=128904;F=128912;sOa(128600,128888,128896,B,B,B,B,B,F,F,80)|0;g3a(128600,128920,80,47);F=128904;B=128912;sOa(128600,128968,128976,F,128984,n,F,F,B,B,80)|0;g3a(128600,128992,80,41);B=128904;F=128912;sOa(128600,129040,129048,128984,B,B,B,B,F,F,80)|0;i=y;return 0}else{D=210}}while(0);c:do{if((D|0)==27){a[128776]=0;K=+h[l>>3];h[16101]=K;L=+h[m>>3];h[16094]=L;A=c[d>>2]|0;c[32136]=1;do{if((A|0)>=1){r=k+4|0;p=0;E=1;M=L;N=K;while(1){if((c[r>>2]|0)==1){F=E+ -1|0;O=+h[l+(F<<3)>>3];h[16101]=O;P=+h[m+(F<<3)>>3];h[16094]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[128776]=1;S=1}else{S=p}if(Q<0.0){D=215;break}if(R<0.0){D=216;break}F=E+1|0;c[32136]=F;if((E|0)<(A|0)){p=S;E=F;M=R;N=Q}else{D=36;break}}if((D|0)==36){if(!S){break}E=c[d>>2]|0;p=E+51|0;c[32146]=p;r=p+(c[w>>2]|0)|0;c[32148]=r;p=r+(c[w>>2]|0)|0;c[32170]=p;F=p+(c[w>>2]|0)|0;c[32140]=F;B=F+(c[d>>2]|0)|0;c[32176]=B;C=B+(c[d>>2]|0)|0;c[32182]=C;c[32172]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+C;c[32196]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){B=o+64|0;h[16103]=+h[B>>3];a[128712]=0;h[16072]=+h[o+24>>3];J=o+16|0;h[16067]=+h[J>>3];do{if((c[w>>2]|0)!=0){uOa(129080,v,w,d,128576,j,f,o+(F+ -1<<3)|0,o+(C+ -1<<3)|0,o+224|0,q+28|0,o+(E+50<<3)|0,o+(r+ -1<<3)|0,o+(p+ -1<<3)|0,x,128696,B,0,o,q,s,t)|0;if((c[32266]|0)>0){i=y;return 0}if((c[32174]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=128984;ROa(d,o+((c[32140]|0)+ -1<<3)|0,G,g,G)|0;a[128712]=1;D=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[16067];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[16067]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){D=227;break c}P=+h[16067];if((M-N)*P>0.0){D=220;break}B=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[16102]=O;U=+h[16072];V=U-O;G=V*P>0.0;do{if(B){if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[32182]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){zOa(128576,j,f,g,d,H,I,X)|0;if((c[32266]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[128712]=1;D=197;break d}}else{Y=128576;zOa(Y,Y,f,g,d,H,I,X)|0;if((c[32266]|0)>0){i=y;return 0}else{h[e>>3]=+h[16072];c[n>>2]=1;a[128712]=1;D=197;break d}}}else{if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U-W)<0.0){break}zOa(128576,j,f,g,d,q+28|0,o+((c[32182]|0)+ -1<<3)|0,o+224|0)|0;if((c[32266]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[128712]=1;D=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[16103]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[16067]=W;h[J>>3]=W;break}zOa(128576,128816,f,g,d,q+28|0,o+((c[32182]|0)+ -1<<3)|0,o+224|0)|0;if((c[32266]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[16102];a[128712]=1;D=197;break d}}else{W=+h[16072];if(!B){if(P*(W-N)<0.0){break}zOa(128576,j,f,g,d,q+28|0,o+((c[32182]|0)+ -1<<3)|0,o+224|0)|0;if((c[32266]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[128712]=1;D=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[32182]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){zOa(128576,j,f,g,d,G,X,I)|0;if((c[32266]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[128712]=1;D=197;break d}}else{H=128576;zOa(H,H,f,g,d,G,X,I)|0;if((c[32266]|0)>0){i=y;return 0}else{h[e>>3]=+h[16072];c[n>>2]=1;a[128712]=1;D=197;break d}}}}while(0);if(a[128712]&1){D=197}else{D=128}}else{h[16072]=+h[e>>3];c[n>>2]=1;wOa(d,k+4|0,l,m,f,o+((c[32176]|0)+ -1<<3)|0,s,t)|0;B=c[d>>2]|0;c[32136]=1;e:do{if((B|0)>=1){J=c[32176]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[32136]=X;if((I|0)<(B|0)){I=X}else{break e}}g3a(128600,130904,80,39);I=128904;J=128912;sOa(128600,130576,130944,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+DOa(129056,1);h[16103]=U;B=o+64|0;h[B>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[16103]*4.0*(aa>=ba?aa:ba);h[16092]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){g3a(128600,130952,80,60);J=128904;sOa(128600,130448,131016,J,J,J,J,129080,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[16071]=ca*.001;U=+xOa(d,g,o+((c[32176]|0)+ -1<<3)|0,s,t);if(U>.5/+h[16071]){h[16071]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+d3a(128568,z);h[16071]=U;da=U}else{U=+h[o+16>>3];h[16071]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){D=220;break d}if(!(U==0.0)){da=U;break}g3a(128600,130856,80,29);J=128904;I=128912;sOa(128600,130888,130896,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[16071]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[16102]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){D=224;break}if(ea*(U+ea-O)>0.0){h[16071]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){D=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{yOa(128576,f,g,d,b,u,128568,o+((c[32176]|0)+ -1<<3)|0,n,s,t,o+((c[32182]|0)+ -1<<3)|0,o+400|0,o+((c[32140]|0)+ -1<<3)|0,o+((c[32172]|0)+ -1<<3)|0,q,128736,B,k+36|0,128784)|0;if((c[32266]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;D=129;break}ja=+h[16071]}h[16067]=ja;h[o+16>>3]=ja;J=c[32182]|0;X=(c[d>>2]|0)+J|0;c[32192]=X;G=c[d>>2]|0;c[32136]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[16067]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[32136]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[16067];h[o+232>>3]=+h[16067]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){D=128;break}uOa(128984,v,w,d,e,j,f,o+((c[32140]|0)+ -1<<3)|0,o+((c[32182]|0)+ -1<<3)|0,J,Y,o+((c[32146]|0)+ -1<<3)|0,o+((c[32148]|0)+ -1<<3)|0,o+((c[32170]|0)+ -1<<3)|0,x,128696,B,0,o,q,s,t)|0;if((c[32266]|0)>0){i=y;return 0}if((c[32174]|0)!=0){g3a(128600,131320,80,47);la=128904;ma=128912;sOa(128600,128968,131368,128984,la,la,la,la,ma,ma,80)|0;g3a(128600,131376,80,38);ma=128904;la=128912;sOa(128600,129128,131368,128984,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){D=128;break}if((c[I>>2]|0)==0){D=128;break}uOa(129072,v,w,d,128576,j,f,o+((c[32140]|0)+ -1<<3)|0,o+((c[32182]|0)+ -1<<3)|0,J,Y,o+((c[32146]|0)+ -1<<3)|0,o+((c[32148]|0)+ -1<<3)|0,o+((c[32170]|0)+ -1<<3)|0,x,128696,B,0,o,q,s,t)|0;if((c[32266]|0)>0){i=y;return 0}if((c[32174]|0)!=1){D=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=128984;ROa(d,o+((c[32140]|0)+ -1<<3)|0,H,g,H)|0;D=197}}while(0);if((D|0)==218){g3a(128600,130696,80,54);p=128904;sOa(128600,130752,130760,p,p,p,p,129080,128816,j,80)|0;break c}else if((D|0)==220){g3a(128600,130808,80,34);p=128904;sOa(128600,130376,130848,p,p,p,p,129080,j,e,80)|0;break c}else if((D|0)==224){g3a(128600,131024,80,49);p=128904;sOa(128600,128888,131080,p,p,p,p,129080,128816,e,80)|0;break c}f:while(1){if((D|0)==128){D=0;ka=c[n>>2]|0;D=129;continue}else if((D|0)==129){D=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){D=131;break}oa=k+4|0;wOa(d,oa,l,m,o+((c[32182]|0)+ -1<<3)|0,o+((c[32176]|0)+ -1<<3)|0,s,t)|0;if((c[32266]|0)>0){D=233;break}p=c[d>>2]|0;c[32136]=1;r=c[32176]|0;if((p|0)>=1){E=1;while(1){C=E+1|0;if(!(+h[o+(E+ -2+r<<3)>>3]>0.0)){D=136;break f}c[32136]=C;if((E|0)<(p|0)){E=C}else{break}}}O=+xOa(d,o+((c[32182]|0)+ -1<<3)|0,o+(r+ -1<<3)|0,s,t)*100.0;V=+h[16103];pa=O*V;h[16069]=pa;if(!(pa<=1.0)){D=138;break}O=+h[16072];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[16092]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[16067];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[16067]=V/O}}while(0);AOa(128576,f,g,d,b,u,128536,o+((c[32176]|0)+ -1<<3)|0,k,n,s,t,o+((c[32182]|0)+ -1<<3)|0,o+400|0,o+((c[32140]|0)+ -1<<3)|0,o+((c[32172]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,128736,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,128784)|0;if((c[32266]|0)>0){D=233;break}r=c[n>>2]|0;if((r|0)<0){na=r;break}do{if((c[w>>2]|0)!=0){uOa(129072,v,w,d,128576,j,f,o+((c[32140]|0)+ -1<<3)|0,o+((c[32182]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[32146]|0)+ -1<<3)|0,o+((c[32148]|0)+ -1<<3)|0,o+((c[32170]|0)+ -1<<3)|0,x,128696,o+64|0,0,o,q,s,t)|0;if((c[32266]|0)>0){D=233;break f}if((c[32174]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];r=128984;ROa(d,o+((c[32140]|0)+ -1<<3)|0,r,g,r)|0;D=197;continue f}}while(0);r=(c[k+8>>2]|0)!=0;O=+h[16072];V=+h[16067];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!r){if(U<0.0){D=128;continue}zOa(128576,j,f,g,d,q+28|0,o+((c[32182]|0)+ -1<<3)|0,o+224|0)|0;if((c[32266]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;D=197;continue}zOa(128576,j,f,g,d,q+28|0,o+((c[32182]|0)+ -1<<3)|0,o+224|0)|0;if((c[32266]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(r){if(U>=0.0){zOa(128576,j,f,g,d,q+28|0,o+((c[32182]|0)+ -1<<3)|0,o+224|0)|0;if((c[32266]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}N=O- +h[16102];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[16103]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;D=197;continue}zOa(128576,128816,f,g,d,q+28|0,o+((c[32182]|0)+ -1<<3)|0,o+224|0)|0;if((c[32266]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[16102];D=197;continue}if(!(U<0.0)){zOa(128576,j,f,g,d,q+28|0,o+((c[32182]|0)+ -1<<3)|0,o+224|0)|0;if((c[32266]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}U=+h[16102];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[16103]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){D=128;continue}h[16067]=U-O;D=128;continue}else{zOa(128576,128816,f,g,d,q+28|0,o+((c[32182]|0)+ -1<<3)|0,o+224|0)|0;if((c[32266]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[16102];D=197;continue}}else if((D|0)==197){D=0;h[o+24>>3]=+h[16072];h[o+16>>3]=+h[16067];h[o+328>>3]=+h[e>>3];D=233;break}}do{if((D|0)==131){c[n>>2]=-1;na=-1}else if((D|0)==136){c[n>>2]=-3;na=-3}else if((D|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[16069]*+h[m>>3];c[n>>2]=-2;na=-2;break}r=c[d>>2]|0;c[32136]=1;if((r|0)>=1){O=pa;E=1;p=0;while(1){B=l+(p<<3)|0;h[B>>3]=O*+h[B>>3];B=m+(E+ -1<<3)|0;h[B>>3]=+h[16069]*+h[B>>3];if((E|0)>=(r|0)){break}B=E;O=+h[16069];E=E+1|0;p=B}c[32136]=r+1}c[n>>2]=-2;na=-2}else if((D|0)==233){i=y;return 0}}while(0);p=0-na|0;c[32192]=p;switch(p|0){case 2:{g3a(128600,129216,80,47);p=128904;sOa(128600,128968,129264,p,p,p,p,128984,128576,128912,80)|0;g3a(128600,129272,80,48);p=128904;E=128912;sOa(128600,129200,129328,p,p,p,p,p,E,E,80)|0;g3a(128600,129336,80,45);E=128904;p=128912;sOa(128600,129384,129392,E,E,E,E,E,p,p,80)|0;break};case 3:{g3a(128600,129400,80,38);p=128904;sOa(128600,129128,129440,p,p,p,p,128984,128576,128912,80)|0;g3a(128600,129448,80,28);p=128904;E=128912;sOa(128600,129480,129488,p,p,p,p,p,E,E,80)|0;break};case 6:{g3a(128600,129496,80,44);E=128904;sOa(128600,129544,129552,E,E,E,E,129080,128576,128536,80)|0;g3a(128600,129560,80,57);E=128904;p=128912;sOa(128600,129624,129632,E,E,E,E,E,p,p,80)|0;break};case 7:{g3a(128600,129496,80,44);p=128904;sOa(128600,129544,129640,p,p,p,p,129080,128576,128536,80)|0;g3a(128600,129648,80,48);p=128904;E=128912;sOa(128600,129200,129704,p,p,p,p,p,E,E,80)|0;g3a(128600,129712,80,28);E=128904;p=128912;sOa(128600,129480,129744,E,E,E,E,E,p,p,80)|0;break};case 8:{g3a(128600,129496,80,44);p=128904;sOa(128600,129544,129752,p,p,p,p,129080,128576,128536,80)|0;g3a(128600,129760,80,37);p=128904;E=128912;sOa(128600,129800,129808,p,p,p,p,p,E,E,80)|0;break};case 9:{g3a(128600,129496,80,44);E=128904;sOa(128600,129544,129816,E,E,E,E,129080,128576,128536,80)|0;g3a(128600,129824,80,49);E=128904;p=128912;sOa(128600,128888,129880,E,E,E,E,E,p,p,80)|0;g3a(128600,129888,80,38);p=128904;E=128912;sOa(128600,129128,129928,p,p,p,p,p,E,E,80)|0;break};case 10:{g3a(128600,129496,80,44);E=128904;sOa(128600,129544,129936,E,E,E,E,129080,128576,128536,80)|0;g3a(128600,129944,80,45);E=128904;p=128912;sOa(128600,129384,129992,E,E,E,E,E,p,p,80)|0;g3a(128600,13e4,80,36);p=128904;E=128912;sOa(128600,130040,130048,p,p,p,p,p,E,E,80)|0;break};case 11:{g3a(128600,130056,80,40);E=128904;sOa(128600,130104,130112,E,E,E,E,129080,128576,128536,80)|0;g3a(128600,130120,80,36);E=128904;p=128912;sOa(128600,130040,130160,E,E,E,E,E,p,p,80)|0;break};case 12:{g3a(128600,129496,80,44);p=128904;sOa(128600,129544,130168,p,p,p,p,129080,128576,128568,80)|0;g3a(128600,130176,80,45);p=128904;E=128912;sOa(128600,129384,130224,p,p,p,p,p,E,E,80)|0;break};case 5:case 4:{break};default:{g3a(128600,129088,80,38);E=128904;sOa(128600,129128,129136,E,E,E,E,128984,128576,128912,80)|0;g3a(128600,129144,80,48);E=128904;p=128912;sOa(128600,129200,129208,E,E,E,E,E,p,p,80)|0}}c[k>>2]=-1;h[e>>3]=+h[16072];h[o+24>>3]=+h[16072];h[o+16>>3]=+h[16067];i=y;return 0}else if((D|0)==215){g3a(128600,130536,80,39);p=128904;E=128912;sOa(128600,130576,130584,p,p,p,p,p,E,E,80)|0;break c}else if((D|0)==216){g3a(128600,130592,80,39);E=128904;p=128912;sOa(128600,130576,130632,E,E,E,E,E,p,p,80)|0;break c}}}while(0);g3a(128600,130640,80,47);A=128904;p=128912;sOa(128600,128968,130688,A,A,A,A,A,p,p,80)|0}else if((D|0)==210){g3a(128600,130232,80,55);p=128904;A=128912;sOa(128600,130288,128984,p,p,p,p,p,A,A,80)|0}}while(0);if((D|0)==227){g3a(128600,131224,80,39);D=128904;sOa(128600,130576,131264,D,D,D,D,129080,j,e,80)|0}if((c[k>>2]|0)==-1){g3a(128600,131416,80,46);e=128904;j=128912;sOa(128600,131464,131472,e,e,e,e,e,j,j,80)|0;g3a(128600,131480,80,47);j=128904;e=128912;sOa(128600,128968,131528,128984,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function uOa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[16442]=C;c[t>>2]=0;D=c[e>>2]|0;c[32886]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[32886]|0;E=F+1|0;c[32886]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[16449]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;zOa(g,b,k,l,f,o,m,n)|0;if((c[32266]|0)>0){i=v;return 0}D=d;be[D&7](f,b,k,e,p,y,z)|0;if((c[32266]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[131600]=0;F=c[e>>2]|0;c[32886]=1;if((F|0)<1){break}else{J=0;K=1}while(1){I=+h[p+(K+ -1<<3)>>3];if(!(I>=0.0)){L=-I}else{L=I}if(!(L<=0.0)){M=J}else{a[131600]=1;M=1}if((K|0)<(F|0)){J=M;K=K+1|0}else{break}}c[32886]=F+1;if(!M){break}I=+d3a(131592,131536);h[16446]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[16442];do{if((H- +h[g>>3])*I<0.0){zOa(g,b,k,l,f,o,m,n)|0;if((c[32266]|0)<=0){break}i=v;return 0}else{G=+h[16446]/I;h[16447]=G;N=c[f>>2]|0;c[32886]=1;if((N|0)<1){break}O=(A<<1)+B|0;P=G;Q=1;while(1){R=k+(Q+ -1<<3)|0;h[R>>3]=+h[R>>3]+P*+h[m+(O+Q<<3)>>3];if((Q|0)>=(N|0)){break}P=+h[16447];Q=Q+1|0}c[32886]=N+1}}while(0);be[D&7](f,b,k,e,p,y,z)|0;if((c[32266]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[131600]=0;F=c[e>>2]|0;c[32886]=1;if((F|0)<1){break}else{S=0;T=1}while(1){Q=T+ -1|0;I=+h[p+(Q<<3)>>3];if(!(I>=0.0)){U=-I}else{U=I}if(U>0.0){V=S;W=T}else{c[s+(Q<<2)>>2]=1;a[131600]=1;V=1;W=c[32886]|0}Q=W+1|0;c[32886]=Q;if((W|0)<(F|0)){S=V;T=Q}else{break}}if(!V){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{X=+h[16442];Y=I;break}}else if((u|0)==3){X=C;Y=+h[g>>3]}else{F=w+320|0;zOa(g,F,k,l,f,o,m,n)|0;if((c[32266]|0)>0){i=v;return 0}E=d;be[E&7](f,F,k,e,p,y,z)|0;if((c[32266]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[131600]=0;D=c[e>>2]|0;c[32886]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[131600]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[32886]=D+1;if(!aa){i=v;return 0}I=+d3a(131592,131536);h[16446]=I;h[F>>3]=I+ +h[F>>3];I=+h[16446]/+h[16442];h[16447]=I;Q=c[f>>2]|0;c[32886]=1;if((Q|0)>=1){O=(A<<1)+B|0;H=I;R=1;while(1){ba=k+(R+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(O+R<<3)>>3];if((R|0)>=(Q|0)){break}H=+h[16447];R=R+1|0}c[32886]=Q+1}be[E&7](f,F,k,e,p,y,z)|0;if((c[32266]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[131600]=0;R=c[e>>2]|0;c[32886]=1;if((R|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[131600]=1;fa=1}if((da|0)<(R|0)){ca=fa;da=da+1|0}else{break}}c[32886]=R+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-Y)*X>=0.0)){h[16445]=ea;if((ea- +h[w+320>>3])*X<=0.0){i=v;return 0}zOa(g,131560,k,l,f,o,m,n)|0;if((c[32266]|0)<=0){break}i=v;return 0}else{h[16445]=Y;j=c[f>>2]|0;c[32886]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[32886]=j+1}}while(0);ga=d;be[ga&7](f,131560,k,e,q,y,z)|0;if((c[32266]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[32896]=0;R=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){vOa(e,131592,131584,R,131560,p,q,r,131552,s,fa,da,x,ca)|0;if((c[32266]|0)>0){ha=76;break}if((c[32896]|0)>1){ha=73;break}zOa(g,131552,k,l,f,o,m,n)|0;if((c[32266]|0)>0){ha=76;break}be[ga&7](f,131552,k,e,r,y,z)|0;if((c[32266]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[R>>3]=+h[16444];R=128984;ROa(e,r,R,p,R)|0;if((c[32896]|0)==4){i=v;return 0}zOa(g,131552,k,l,f,o,m,n)|0;if((c[32266]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function vOa(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[32912]=c[o>>2];c[o>>2]=0;h[16452]=0.0;a[131632]=0;t=c[b>>2]|0;c[32902]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+d3a(131664,j+(v<<3)|0);if(w==+d3a(131664,l+((c[32902]|0)+ -1<<3)|0)){break}y=c[32902]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[16452]){break}h[16452]=B;c[o>>2]=y}else{a[131632]=1}}while(0);v=c[32902]|0;u=v+1|0;c[32902]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[131640]=1;c[32914]=c[p>>2];h[g>>3]=+h[r>>3];t=128984;ROa(b,l,t,k,t)|0;c[p>>2]=1;a[131624]=0;C=0}else{a[131640]=0;c[o>>2]=c[32912];c[32914]=c[p>>2];if(a[131632]&1){h[g>>3]=+h[r>>3];t=128984;ROa(b,l,t,k,t)|0;a[131624]=1;C=1;break}else{t=128984;ROa(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[131624]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[131624]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=128984;ROa(b,k,t,l,t)|0;t=c[b>>2]|0;c[32902]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[32902]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+d3a(131664,j+(u<<3)|0);if(!(A!=+d3a(131664,k+((c[32902]|0)+ -1<<3)|0))){break}c[n+((c[32902]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[32902]|0;F=u+1|0;c[32902]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[16452]=0.0;a[131632]=0;t=c[b>>2]|0;c[32902]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+d3a(131664,j+(v<<3)|0);if(A==+d3a(131664,k+((c[32902]|0)+ -1<<3)|0)){break}y=c[32902]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[16452]){break}h[16452]=I;c[o>>2]=y}else{a[131632]=1}}while(0);v=c[32902]|0;u=v+1|0;c[32902]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[131640]=t&1;if(t){a[131624]=0;c[32914]=0;c[p>>2]=1;break}if(!(a[131632]&1)){t=128984;ROa(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=128984;ROa(b,k,t,l,t)|0;t=c[b>>2]|0;c[32902]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[32902]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[32902]|0}u=K+1|0;c[32902]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[32914]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function wOa(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[16461]=+h[d>>3];h[16460]=+h[e>>3];j=c[a>>2]|0;c[32918]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[16461]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[16461]=o;h[16460]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[16460];a=l+1|0;c[32918]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function xOa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[16464]=0.0;e=c[a>>2]|0;c[32924]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[16464]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[32924]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[16463]=0.0;e=c[a>>2]|0;c[32924]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[16463]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[32924]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function yOa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[32942]=0;c[32940]=0;c[32946]=0;h[16476]=+h[b>>3];h[16478]=+xOa(f,d,l,0,0);C=c[f>>2]|0;c[32930]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[32930]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[16469]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[32930]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[32930]=G+1}a[131816]=1;c[32932]=0;a[131832]=1;c[C>>2]=(c[C>>2]|0)+1;c[32950]=0;be[B&7](b,d,e,q,131800,n,o)|0;b:do{if((c[32950]|0)<0){K=35}else{while(1){if(a[131816]&1){c[E>>2]=(c[E>>2]|0)+1;a[131816]=0;BOa(f,b,d,e,q,131752,k,131776,l,r,s,t,g,131800,v,j,n,o,x)|0;h[16468]=1.0e6;if((c[32950]|0)<0|(c[32944]|0)!=0){K=35;break b}c[32946]=0}H=c[f>>2]|0;c[32930]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[32930]=H+1}COa(f,q,s,t)|0;I=c[f>>2]|0;c[32930]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[16469]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[32930]=I+1}N=+xOa(f,q,l,0,0);h[16480]=N;if(N<=+h[v>>3]*100.0*+h[16478]){break}J=c[32932]|0;if((J|0)>0){h[z>>3]=N/+h[16481];h[A>>3]=1.0/+(J|0);O=+b3a(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[16468]=P;Q=+h[16480];R=P}else{h[16481]=N;Q=N;R=+h[16468]}if(R*Q<=.33){break}J=c[32932]|0;H=J+1|0;c[32932]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[131816]=1}c[C>>2]=(c[C>>2]|0)+1;c[32950]=0;be[B&7](b,d,e,q,131800,n,o)|0;if((c[32950]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[32930]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[32930]=H+1}N=+xOa(f,q,l,0,0);h[16480]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[32930]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[16469]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[32930]=J+1}}while(0);if(!(a[131832]&1)){break}H=c[f>>2]|0;c[32930]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[32930]=H+1}N=+xOa(f,r,l,0,0);h[16474]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[131832]=0}h[b>>3]=+h[16476];G=c[f>>2]|0;c[32930]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[32930]=G+1}if(a[131832]&1){I=(c[32942]|0)+1|0;c[32942]=I;N=.9/(+h[16474]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[16467]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[32944]|0)!=0){I=(c[32946]|0)+1|0;c[32946]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[32950]|0)>-2)){K=53;break}I=(c[32940]|0)+1|0;c[32940]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function zOa(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[32976]=o;p=+h[b>>3]- +h[a>>3];h[16486]=p;a=c[f>>2]|0;c[32968]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[32968]=a+1;q=+h[16486]}h[16482]=1.0;h[16483]=0.0;p=q/+h[k>>3];h[16487]=p;c[32970]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[16483]=u*t+s/+h[a>>3];p=t*s;h[16482]=p;h[16487]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[32968]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[16483]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[16482];g=g+1|0}c[32968]=a+1}g=v+1|0;c[32970]=g;if((v|0)>=(o|0)){break}r=+h[16486];s=+h[16482];t=+h[16487];u=+h[16483];v=g}i=l;return 0}function AOa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[16509]=+h[b>>3];c[32996]=0;c[33004]=0;c[32998]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[16521]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[32992]=(c[I>>2]|0)+1;c[32994]=(c[I>>2]|0)+2;c[32990]=(c[I>>2]|0)+ -1;h[16509]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[33008]=$+1;$=c[32992]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[16512]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[32978]=2;if(($|0)>=2){Y=2;while(1){h[16513]=+h[y+(Y+ -2<<3)>>3];U=+h[16512];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[16513];U=+h[16513]+ +h[k>>3];h[16512]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[32978]=$+1}h[y+($+ -1<<3)>>3]=+h[16512]}h[16519]=0.0;h[16517]=0.0;Y=c[I>>2]|0;c[32978]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[16519]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[16517]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[32978]=Y+1;da=ea}h[16520]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[16519]- +h[16517];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[16494]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[16494]=ha>=ca?ha:ca;h[16512]=.6;h[16513]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[16520]){h[D>>3]=100.0}aa=c[32992]|0;ba=c[33008]|0;if((aa|0)>=(ba|0)){c[32980]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[32978]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[32978]=ba+1}ja=ia+1|0;c[32980]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[32978]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[32978]=ia+1}aa=c[32992]|0;c[32980]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[32978]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[32978]=$+1}la=ba+1|0;c[32980]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[16516]=+xOa(f,d,l,0,0);a[132176]=1;c[32982]=0;c[T>>2]=(c[T>>2]|0)+1;c[33012]=0;be[m&7](b,d,e,r,132048,o,p)|0;if((c[33012]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;BOa(f,b,d,e,r,A,k,132e3,l,s,t,u,g,132048,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[33012]|0)<0|(c[33e3]|0)!=0){X=70;break}c[33004]=0}ba=c[f>>2]|0;c[32978]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[32978]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[16512]=ca;aa=c[f>>2]|0;c[32978]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[16512];ia=ia+1|0;la=ka}c[32978]=aa+1}COa(f,r,t,u)|0;la=c[f>>2]|0;c[32978]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[32978]=la+1}U=+xOa(f,r,l,0,0);h[16521]=U;if(U<=+h[F>>3]*100.0*+h[16516]){X=63;break a}ia=c[32982]|0;if((ia|0)>0){h[O>>3]=U/+h[16523];h[P>>3]=1.0/+(ia|0);ca=+b3a(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[16521];oa=ga}else{h[16523]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[32982]|0;c[32982]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[33012]=0;be[m&7](b,d,e,r,132048,o,p)|0;if((c[33012]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[32978]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[32978]=ba+1}U=+xOa(f,r,l,0,0);h[16521]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[32978]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[32978]=ia+1}}while(0);if((X|0)==70){X=0;a[132176]=0}c[H>>2]=1;if(a[132176]&1){U=+xOa(f,s,l,0,0);h[16515]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[16501]=ga;h[16508]=ga*+(ba+1|0);h[16503]=ga;c[33014]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[32978]=1;if((ba|0)>=1){aa=fa(c[32992]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[32978]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+xOa(f,r,l,0,0);h[16510]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[16518]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[32978]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[32978]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+xOa(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[16518];if((sa>=ca?sa:ca)>+h[16508]){break}ta=+h[16510];ua=Y}else{if(!(ga<=+h[16508]*.5)){break}else{ta=U;ua=ka}}c[33014]=ua+ -1;h[16503]=ta}}while(0);if(!(+h[16494]*+h[16515]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[16509];Y=c[32992]|0;ia=c[33008]|0;if((Y|0)>=(ia|0)){c[32980]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[16512]=ca;ia=c[f>>2]|0;c[32978]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[16512];ja=ja+1|0}c[32978]=ia+1}ja=aa+1|0;c[32980]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[32978]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[32978]=Y+1}if(!(a[132176]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[33e3]|0)!=0){aa=(c[33004]|0)+1|0;c[33004]=aa;h[16492]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[33012]|0)>-2)){X=146;break}aa=(c[32996]|0)+1|0;c[32996]=aa;h[16492]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[32998]=(c[32998]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[32998]|0;if((aa|0)<=1){ja=c[33014]|0;c[I>>2]=ja;sa=+(ja+1|0);h[16513]=sa;h[O>>3]=+h[16503]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+b3a(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[16492]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[33014];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[33028]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[33014]|0;E=c[32990]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[32992];za=+h[k>>3]*2.0;h[16505]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[32990]|0;Ba=c[33014]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[32992]|0)>=(c[K>>2]|0)|(c[33028]|0)==1){Fa=G;break}G=c[f>>2]|0;c[32978]=1;if((G|0)>=1){E=fa(c[32994]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[32978]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+xOa(f,r,l,0,0);h[16511]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[16508];E=xa<=za;if(+h[16518]<=(E?xa:za)){Ea=c[32990]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[16508]*.5){Fa=S;break}}S=c[32992]|0;c[I>>2]=S;h[16503]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[16503]=+h[16510];Fa=Ea}h[16505]=+h[k>>3];ya=+(Fa+1|0);h[16513]=ya;h[O>>3]=+h[16503]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+b3a(O,P);h[16492]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[16505];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[16492]=xa;za=+h[k>>3]*xa;h[16505]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[16505]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[32978]=1;if((k|0)<1){break}u=fa(c[32994]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[32978]=k+1}}while(0);Ca=c[f>>2]|0;c[32978]=1;if((Ca|0)>=1){J=fa(c[32992]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[32978]=Ca+1}Ca=c[32992]|0;c[32986]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[32980]=P;s=c[f>>2]|0;c[32978]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[32978]=s+1}P=Ha+1|0;c[32986]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[33012]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[32998]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}zOa(b,b,d,e,f,I,q,y)|0;i=N;return 0}function BOa(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==3){i=y;return 0}else if((O|0)==4){P=c[q>>2]|0;Q=q+4|0;R=c[Q>>2]|0;S=c[b>>2]|0;T=fa(R+1+(P<<1)|0,S)|0;c[33048]=1;if((T|0)>=1){U=fa(S,R+(P<<1)+1|0)|0;P=(U|0)<1;R=1;while(1){h[p+(R+ -1<<3)>>3]=0.0;if((R|0)<(T|0)){R=R+1|0}else{break}}c[33048]=P?2:U+1|0}he[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[33082]=(c[Q>>2]|0)+1+(c[q>>2]<<1);W=75}else if((O|0)==2){c[s>>2]=0;c[33070]=0;h[16536]=+V(+(+h[t>>3]));R=c[b>>2]|0;c[33048]=1;b:do{if((R|0)>=1){T=r;S=1;while(1){X=S+ -1|0;Y=+h[e+(X<<3)>>3];h[N>>3]=Y;if(!(Y>=0.0)){Z=-Y}else{Z=Y}_=f+(X<<3)|0;Y=+h[l>>3]*+h[_>>3];if(!(Y>=0.0)){$=-Y}else{$=Y}Y=Z>=$?Z:$;aa=+h[n+(X<<3)>>3];if(!(aa>=0.0)){ba=-aa}else{ba=aa}h[16533]=+h[16536]*(Y>=ba?Y:ba);h[N>>3]=+h[l>>3]*+h[_>>3];Y=+d3a(132264,N);h[16533]=Y;_=(c[33048]|0)+ -1|0;X=e+(_<<3)|0;aa=+h[X>>3];ca=Y+aa-aa;h[16533]=ca;h[16540]=+h[X>>3];da=f+(_<<3)|0;h[16544]=+h[da>>3];h[X>>3]=ca+ +h[X>>3];h[da>>3]=+h[j>>3]*+h[16533]+ +h[da>>3];be[T&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ca=1.0/+h[16533];h[16542]=ca;da=c[b>>2]|0;c[33054]=1;X=c[33070]|0;if((da|0)>=1){aa=ca;_=1;ea=0;while(1){h[p+(ea+X<<3)>>3]=(+h[o+(ea<<3)>>3]- +h[g+(ea<<3)>>3])*aa;if((_|0)>=(da|0)){break}ga=_;aa=+h[16542];_=_+1|0;ea=ga}c[33054]=da+1}c[33070]=X+(c[b>>2]|0);ea=c[33048]|0;_=ea+ -1|0;h[e+(_<<3)>>3]=+h[16540];h[f+(_<<3)>>3]=+h[16544];S=ea+1|0;c[33048]=S;if((ea|0)>=(R|0)){break b}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){W=42;break}c[33070]=0;R=c[b>>2]|0;if((c[118248>>2]|0)==0){W=42;break}Q=xfb(R*20|0)|0;U=F;h[k>>3]=+h[d>>3];c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];SMa(14,1,132360,F);U=E;h[k>>3]=+h[j>>3];c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];SMa(14,0,132384,E);SMa(14,1,132392,D);c[33052]=0;if((c[b>>2]|0)>0){U=0;do{aa=+h[e+(U<<3)>>3];c[C>>2]=U+1;P=C+4|0;h[k>>3]=aa;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];SMa(14,0,132400,C);U=(c[33052]|0)+1|0;c[33052]=U;}while((U|0)<(c[b>>2]|0))}fe[c[29686]&511](14);SMa(14,1,132456,B);c[33048]=1;if((R|0)>=1){U=Q+1|0;P=c[33070]|0;S=1;do{T=p+(S+ -1+P<<3)|0;h[T>>3]=+h[j>>3]+ +h[T>>3];a[Q]=0;a[U]=0;c[33054]=1;T=P;ea=0;while(1){aa=+h[p+(ea+T<<3)>>3];c[A>>2]=Q;_=A+4|0;h[k>>3]=aa;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];hc(Q|0,132440,A|0)|0;_=c[33054]|0;c[33054]=_+1;if((_|0)>=(R|0)){break}T=c[33070]|0;ea=_}c[z>>2]=Q;SMa(14,0,132448,z);ea=c[33070]|0;T=c[33048]|0;_=p+(ea+ -1+T<<3)|0;h[_>>3]=+h[_>>3]- +h[j>>3];P=ea+(c[b>>2]|0)|0;c[33070]=P;S=T+1|0;c[33048]=S;}while((T|0)<(R|0))}fe[c[29686]&511](14);fe[c[29686]&511](14);yfb(Q);W=42}else if((O|0)==5){R=q+4|0;S=(c[R>>2]|0)+(c[q>>2]|0)|0;P=S+1|0;c[33074]=P;U=c[b>>2]|0;c[33064]=(S|0)<(U|0)?P:U;U=c[q>>2]|0;c[33082]=P+U;c[33068]=U+S;S=(c[b>>2]|0)/(P|0)|0;c[33078]=S+1;P=c[x>>2]|0;c[33076]=P+ -1;c[33086]=P+S;c[s>>2]=0;h[16536]=+V(+(+h[t>>3]));S=c[33064]|0;c[33050]=1;if((S|0)<1){W=75;break}P=r;U=1;while(1){T=c[b>>2]|0;ea=c[33074]|0;c[33056]=U;_=(ea|0)<0;c:do{if(_?(U|0)>=(T|0):(U|0)<=(T|0)){ga=ea;ha=U;ia=U;while(1){ja=(ia-ha|0)/(ga|0)|0;c[33052]=ja+1;ka=ia+ -1|0;la=e+(ka<<3)|0;h[p+((c[33076]|0)+ja<<3)>>3]=+h[la>>3];ma=f+(ka<<3)|0;h[p+((c[33086]|0)+ja<<3)>>3]=+h[ma>>3];aa=+h[la>>3];h[N>>3]=aa;if(!(aa>=0.0)){na=-aa}else{na=aa}aa=+h[l>>3]*+h[ma>>3];if(!(aa>=0.0)){oa=-aa}else{oa=aa}aa=na>=oa?na:oa;ca=+h[n+(ka<<3)>>3];if(!(ca>=0.0)){pa=-ca}else{pa=ca}h[16533]=+h[16536]*(aa>=pa?aa:pa);h[N>>3]=+h[l>>3]*+h[ma>>3];aa=+d3a(132264,N);h[16533]=aa;ma=c[33056]|0;ka=ma+ -1|0;la=e+(ka<<3)|0;ca=+h[la>>3];Y=aa+ca-ca;h[16533]=Y;h[la>>3]=+h[la>>3]+Y;la=f+(ka<<3)|0;h[la>>3]=+h[j>>3]*+h[16533]+ +h[la>>3];la=ma+ea|0;c[33056]=la;if(!(_?(la|0)>=(T|0):(la|0)<=(T|0))){break c}ga=c[33074]|0;ha=c[33050]|0;ia=la}}}while(0);be[P&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}T=c[b>>2]|0;_=c[33074]|0;ea=c[33050]|0;c[33056]=ea;ia=(_|0)<0;d:do{if(ia?(ea|0)>=(T|0):(ea|0)<=(T|0)){ha=_;ga=ea;X=ea;while(1){da=(X-ga|0)/(ha|0)|0;c[33052]=da+1;la=X+ -1|0;ma=e+(la<<3)|0;h[ma>>3]=+h[p+((c[33076]|0)+da<<3)>>3];Y=+h[p+((c[33086]|0)+da<<3)>>3];da=f+(la<<3)|0;h[da>>3]=Y;ca=+h[ma>>3];h[N>>3]=ca;if(!(ca>=0.0)){qa=-ca}else{qa=ca}ca=+h[l>>3]*Y;if(!(ca>=0.0)){ra=-ca}else{ra=ca}ca=qa>=ra?qa:ra;Y=+h[n+(la<<3)>>3];if(!(Y>=0.0)){sa=-Y}else{sa=Y}h[16533]=+h[16536]*(ca>=sa?ca:sa);h[N>>3]=+h[l>>3]*+h[da>>3];ca=+d3a(132264,N);h[16533]=ca;da=c[33056]|0;Y=+h[e+(da+ -1<<3)>>3];aa=ca+Y-Y;h[16533]=aa;Y=1.0/aa;h[16542]=Y;la=da-(c[R>>2]|0)|0;ma=(la|0)>1?la:1;c[33058]=ma;la=c[b>>2]|0;ka=(c[q>>2]|0)+da|0;ja=(la|0)<=(ka|0)?la:ka;c[33060]=ja;ta=fa(c[33068]|0,da)|0;ua=ta-(c[q>>2]|0)|0;c[33062]=ua;c[33048]=ma;if((ma|0)<=(ja|0)){ta=~la;la=~ka;ka=~((ta|0)>(la|0)?ta:la);la=(ma|0)>(ka|0)?ma:ka;aa=Y;ka=ma;while(1){ma=ka+ -1|0;h[p+(ma+ua<<3)>>3]=(+h[o+(ma<<3)>>3]- +h[g+(ma<<3)>>3])*aa;if((ka|0)>=(ja|0)){break}aa=+h[16542];ka=ka+1|0}c[33048]=la+1}ka=da+_|0;c[33056]=ka;ja=c[33050]|0;if(!(ia?(ka|0)>=(T|0):(ka|0)<=(T|0))){va=ja;break d}ha=c[33074]|0;ga=ja;X=ka}}else{va=ea}}while(0);ea=va+1|0;c[33050]=ea;if((va|0)<(S|0)){U=ea}else{W=75;break a}}i=y;return 0}else{U=c[b>>2]|0;S=fa(U,U)|0;c[33048]=1;if((S|0)!=0){U=(S|0)<1;R=1;while(1){h[p+(R+ -1<<3)>>3]=0.0;if((R|0)<(S|0)){R=R+1|0}else{break}}c[33048]=U?2:S+1|0}he[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){W=42;break}c[33070]=0;R=c[b>>2]|0;if((c[118248>>2]|0)==0){W=42;break}P=xfb(R*20|0)|0;Q=M;h[k>>3]=+h[d>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];SMa(14,1,132360,M);Q=L;h[k>>3]=+h[j>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];SMa(14,0,132384,L);SMa(14,1,132392,K);c[33052]=0;if((c[b>>2]|0)>0){Q=0;do{aa=+h[e+(Q<<3)>>3];c[J>>2]=Q+1;ea=J+4|0;h[k>>3]=aa;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];SMa(14,0,132400,J);Q=(c[33052]|0)+1|0;c[33052]=Q;}while((Q|0)<(c[b>>2]|0))}fe[c[29686]&511](14);SMa(14,1,132416,I);c[33048]=1;if((R|0)>=1){Q=P+1|0;S=c[33070]|0;U=1;do{ea=p+(U+ -1+S<<3)|0;h[ea>>3]=+h[j>>3]+ +h[ea>>3];a[P]=0;a[Q]=0;c[33054]=1;ea=S;T=0;while(1){aa=+h[p+(T+ea<<3)>>3];c[H>>2]=P;ia=H+4|0;h[k>>3]=aa;c[ia>>2]=c[k>>2];c[ia+4>>2]=c[k+4>>2];hc(P|0,132440,H|0)|0;ia=c[33054]|0;c[33054]=ia+1;if((ia|0)>=(R|0)){break}ea=c[33070]|0;T=ia}c[G>>2]=P;SMa(14,0,132448,G);T=c[33070]|0;ea=c[33048]|0;ia=p+(T+ -1+ea<<3)|0;h[ia>>3]=+h[ia>>3]- +h[j>>3];S=T+(c[b>>2]|0)|0;c[33070]=S;U=ea+1|0;c[33048]=U;}while((ea|0)<(R|0))}fe[c[29686]&511](14);fe[c[29686]&511](14);yfb(P);W=42}}while(0);if((W|0)==42){JOa(p,b,b,q+80|0,m)|0;i=y;return 0}else if((W|0)==75){POa(p,132328,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function COa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[e+12>>2]|0;if((g|0)==3){i=f;return 0}else if((g|0)==4|(g|0)==5){g=e+4|0;c[33120]=(c[g>>2]|0)+1+(c[e>>2]<<1);QOa(d,132480,a,e,g,e+80|0,b,132488)|0;i=f;return 0}else{NOa(d,a,a,e+80|0,b,132488)|0;i=f;return 0}return 0}function DOa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[132496]&1)){a[132496]=1;EOa(132544,132512,132592,132528,132576,132600,132584,132608)|0;h[16567]=+(c[33136]|0);f=c[33128]|0;h[16563]=+(f|0);if((c[33148]|0)==0){h[16565]=0.0;c[e>>2]=1-f;g=+c3a(132536,e)}else{h[16565]=1.0;c[e>>2]=1-f;g=+c3a(132536,e)*.5}h[16566]=g;h[16570]=g*+h[16567];h[16569]=+(c[33144]|0);h[16571]=+(c[33146]|0);j=+h[16575];h[16578]=j;k=1.0/+h[16576];if(!(k>=j)){break}h[16578]=k*(g+1.0)}}while(0);if((WOa(b,132632,1,1)|0)!=0){g=+h[16566];h[16577]=g;l=g;i=d;return+l}if((WOa(b,132640,1,1)|0)!=0){g=+h[16578];h[16577]=g;l=g;i=d;return+l}if((WOa(b,132648,1,1)|0)!=0){g=+h[16567];h[16577]=g;l=g;i=d;return+l}if((WOa(b,132656,1,1)|0)!=0){g=+h[16570];h[16577]=g;l=g;i=d;return+l}if((WOa(b,132664,1,1)|0)!=0){g=+h[16563];h[16577]=g;l=g;i=d;return+l}if((WOa(b,132672,1,1)|0)!=0){g=+h[16565];h[16577]=g;l=g;i=d;return+l}if((WOa(b,132680,1,1)|0)!=0){g=+h[16569];h[16577]=g;l=g;i=d;return+l}if((WOa(b,132688,1,1)|0)!=0){g=+h[16575];h[16577]=g;l=g;i=d;return+l}if((WOa(b,132696,1,1)|0)!=0){g=+h[16571];h[16577]=g;l=g;i=d;return+l}if((WOa(b,132704,1,1)|0)==0){l=+h[16577];i=d;return+l}else{g=+h[16576];h[16577]=g;l=g;i=d;return+l}return 0.0}function EOa(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[132816]&1){q=133184;r=c[33296]|0;c[b>>2]=r;s=133120;t=c[33280]|0;c[d>>2]=t;u=133160;v=c[33290]|0;c[e>>2]=v;w=133168;x=+h[16646];h[f>>3]=x;y=133200;z=c[33300]|0;c[g>>2]=z;A=133248;B=+h[16656];h[j>>3]=B;C=133208;D=c[33302]|0;c[k>>2]=D;E=133256;F=+h[16657];h[l>>3]=F;i=m;return 0}a[132816]=1;h[16647]=0.0;h[16641]=1.0;h[16642]=2.0;FOa(133184,133120,133160,133272)|0;h[16637]=+(c[33296]|0);c[n>>2]=0-(c[33280]|0);G=+c3a(133096,n);h[16636]=G;h[16646]=G;H=+h[16642];h[16637]=H/3.0;I=+h[16641];J=I*.5;h[16644]=J;K=-J;h[o>>3]=K;h[16658]=+GOa(133096,o);L=133264;h[16655]=+GOa(L,L);h[o>>3]=K;h[16637]=+GOa(133240,o);K=+GOa(133096,133264);h[16637]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[16637]=K;h[16646]=1.0;M=+h[16647];if(K<1.0&K>M){N=K;while(1){h[16646]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+GOa(o,p);h[16638]=K;h[o>>3]=-K;h[16638]=+GOa(133152,o);K=+GOa(133152,133104);h[16637]=K;h[o>>3]=-K;h[16638]=+GOa(133152,o);K=+GOa(133152,133104);h[16637]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[16646]=G}G=I/+(c[33296]|0);h[16649]=G;h[16653]=I;c[33278]=1;p=1;O=I;do{h[o>>3]=O*G;O=+GOa(o,133176);h[16653]=O;p=p+1|0;c[33278]=p;}while((p|0)<4);h[16636]=+GOa(133128,133224);HOa(133288,133128,133184)|0;h[o>>3]=-+h[16641];HOa(133280,o,133184)|0;HOa(133232,133088,133184)|0;h[o>>3]=-+h[16636];HOa(133216,o,133184)|0;c[33286]=0;p=c[33322]|0;L=c[33320]|0;P=c[33308]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[33304]|0)){if(Q){c[33300]=p;R=0;S=25;break}if((P-p|0)==3){c[33300]=p+ -1+(c[33280]|0);c[33286]=1;R=1;S=25;break}else{c[33300]=(p|0)<=(P|0)?p:P;a[132824]=1;S=26;break}}else{T=Q&(L|0)==(c[33304]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[33300]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[33300]=(p|0)<=(L|0)?p:L;a[132824]=1;S=26;break}}T=c[33304]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[33300]=(V|0)<=(T|0)?V:T;a[132824]=1;S=26;break}if((P-U|0)==3){c[33300]=((p|0)>=(L|0)?p:L)+ -1+(c[33280]|0);R=0;S=25;break}else{c[33300]=U;a[132824]=1;S=26;break}}}while(0);if((S|0)==25){if(a[132824]&1){S=26}else{W=R}}if((S|0)==26){a[132816]=0;a4a(133296)|0;r3a(133320,133200,4)|0;K3a()|0;W=c[33286]|0}if((W|0)==0){X=(c[33318]|0)!=0|0}else{X=1}c[33286]=X;h[16656]=1.0;X=c[33300]|0;W=1-X|0;c[n>>2]=W;c[33278]=1;if((X|0)<=0){O=+h[16649];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+GOa(o,133176);h[16656]=I;n=X+1|0;c[33278]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}IOa(133184,133120,133200,133144,133208,133256)|0;q=133184;r=c[33296]|0;c[b>>2]=r;s=133120;t=c[33280]|0;c[d>>2]=t;u=133160;v=c[33290]|0;c[e>>2]=v;w=133168;x=+h[16646];h[f>>3]=x;y=133200;z=c[33300]|0;c[g>>2]=z;A=133248;B=+h[16656];h[j>>3]=B;C=133208;D=c[33302]|0;c[k>>2]=D;E=133256;F=+h[16657];h[l>>3]=F;i=m;return 0}function FOa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[132712]&1){l=a[132784]&1;m=c[33198]|0;c[b>>2]=m;n=132760;o=c[33190]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=132808;r=c[33202]|0;c[f>>2]=r;i=g;return 0}a[132712]=1;h[16596]=1.0;h[16590]=1.0;h[16592]=1.0;s=1.0;do{s=s*2.0;h[16590]=s;h[16592]=+GOa(132720,132768);h[j>>3]=-s;t=+GOa(132736,j);h[16592]=t;}while(t==1.0);h[16591]=1.0;t=+GOa(132720,132728);h[16592]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[16591]=v;w=+GOa(132720,132728);h[16592]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[16597]=.25;h[16600]=x;h[j>>3]=-s;t=+GOa(132736,j);h[16592]=t;y=~~(t+.25);c[33198]=y;t=+(y|0);h[16591]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[16593]=+GOa(j,k);w=+GOa(132744,132720);h[16592]=w;z=w==s;a[132784]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[16593]=+GOa(j,k);w=+GOa(132744,132720);h[16592]=w;if(z&w==s){a[132784]=0;A=0}else{A=z}h[j>>3]=u;w=+GOa(j,132720);h[16594]=w;h[j>>3]=u;z=w==s&+GOa(j,132800)>x;c[33202]=z?A&1:0;c[33190]=0;h[16590]=1.0;h[16592]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[33190]=k;s=x*t;h[16590]=s;h[16592]=+GOa(132720,132768);h[j>>3]=-s;w=+GOa(132736,j);h[16592]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=132760;o=c[33190]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=132808;r=c[33202]|0;c[f>>2]=r;i=g;return 0}function GOa(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function HOa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[16666]=g;j=1.0/+(c[d>>2]|0);h[16675]=j;h[16674]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+GOa(f,133392);h[16668]=k;h[16670]=g;h[16671]=g;h[16672]=g;h[16673]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[16666]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+GOa(f,133392);h[16668]=g;h[f>>3]=g*k;k=+GOa(f,133392);h[16670]=k;h[16672]=0.0;c[33334]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[16672]=q;c[33334]=b+1;n=q}h[f>>3]=m*j;p=+GOa(f,133392);h[16669]=p;h[f>>3]=p/j;r=+GOa(f,133392);h[16671]=r;h[16673]=0.0;o=c[d>>2]|0;c[33334]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[16673]=v;c[33334]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function IOa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[33358]=1;c[33366]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[33358]=q;r=l+1|0;c[33366]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[33362]=n;u=n}else{c[33362]=m;c[33366]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[33368]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[33366]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[16682]=x;y=w+-1.0;h[16678]=y;h[16677]=0.0;v=c[b>>2]|0;c[33352]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[16678]=B;if(w<1.0){h[16680]=w}C=+GOa(133416,133424);h[16677]=C;e=b+1|0;c[33352]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[16680];h[16677]=A;z=A}}while(0);v=c[f>>2]|0;c[33352]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+GOa(k,133480);h[16677]=z;f=E+1|0;c[33352]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function JOa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[33374]=1;m=1;do{c[33380]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=KOa(j,a+(m+b+(fa(m,l)|0)<<3)|0,133528)|0;q=c[33374]|0;r=p+ -1+q|0;c[33376]=r;c[e+(q+ -1<<2)>>2]=r;r=c[33376]|0;q=c[33374]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[16689]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[16689];t=q}u=fa(t,l)|0;h[16689]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;LOa(j,133512,a+(t-l+u<<3)|0,133528)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[33380]|0;c[33372]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[33376]|0;x=fa(w,l)|0;h[16689]=+h[a+(x+b+v<<3)>>3];y=c[33374]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[16689];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=133528;MOa(k,133512,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[33372]|0;w=A+1|0;c[33372]=w;}while((A|0)<(u|0))}}while(0);q=c[33374]|0;m=q+1|0;c[33374]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function KOa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[33472]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[16737]=k;l=(c[d>>2]|0)+1|0;c[33472]=l;m=c[a>>2]|0;c[33470]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[16737]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[33472]=l;a=n+1|0;c[33470]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[16737]=v;c[33470]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[16737]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[33470]=f+1;g=C;i=e;return g|0}function LOa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[33456]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[33456]=l;i=f;return 0}l=(g|0)%5|0;c[33458]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[33456]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[33456]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[33456]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[33456]=o;i=f;return 0}function MOa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[33442]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[33440]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[33440]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[33440]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[33440]=s;i=j;return 0}}while(0);c[33444]=1;c[33446]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[33444]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[33446]=s;u=s}else{u=1}s=c[a>>2]|0;c[33440]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[33444]=t;u=x+(c[g>>2]|0)|0;c[33446]=u;a=w+1|0;c[33440]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function NOa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[33392]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[33384]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[33386]=o;p=f+(o+ -1<<3)|0;h[16694]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[16694]}c[k>>2]=(c[d>>2]|0)-m;o=133528;MOa(k,133552,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[33384]|0;m=o+1|0;c[33384]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[33390]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[33384]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[16694]=-s;c[k>>2]=g;g=133528;MOa(k,133552,a+(p-l<<3)|0,g,f,g)|0;g=c[33390]|0;q=g+1|0;c[33390]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[33384]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=133528;s=+OOa(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[16694]=s;q=c[33384]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[33384]=n;}while((q|0)<(m|0));t=c[33392]|0}if((t|0)<1){i=j;return 0}c[33390]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[33384]=n;c[k>>2]=(c[d>>2]|0)-n;b=133528;s=+OOa(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[33384]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[33386]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[16694]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[16694]}q=c[33390]|0;m=q+1|0;c[33390]=m;}while((q|0)<(t|0));i=j;return 0}function OOa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[16734]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[33462]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[33460]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[16734]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[33460]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[33460]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[16734]=t;u=u+5|0;}while((u|0)<=(m|0));c[33460]=u;k=t;i=g;return+k}}while(0);c[33464]=1;c[33466]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[33464]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[33466]=u;y=u}else{y=1}u=c[a>>2]|0;c[33460]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[16734]=t;x=C+(c[d>>2]|0)|0;c[33464]=x;y=B+(c[f>>2]|0)|0;c[33466]=y;a=z+1|0;c[33460]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function POa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[33402]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[33408]=n;o=c[d>>2]|0;p=c[33402]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[33410]=o;do{if((q|0)>(n|0)){c[33418]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[33406]=s;t=c[e>>2]|0;c[33394]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[33394]=t+1}u=r+1|0;c[33418]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[33418]=o;c[33416]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[33398]=1;t=o;o=1;while(1){c[33420]=o+1;p=t+1|0;c[33418]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[33394]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[33394]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[33412]=s;c[l>>2]=s+1;s=KOa(l,a+((c[33402]|0)+b+(fa(o,m)|0)<<3)|0,133528)|0;p=s+ -1|0;c[33400]=p+(c[33402]|0);s=c[33398]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[33400]|0;p=c[33398]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[33402]|0;if((s|0)==(u|0)){y=s}else{h[16702]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[16702];y=u}h[16702]=-1.0/+h[a+(y+b+n<<3)>>3];LOa(133648,133616,a+(y-m+n<<3)|0,133528)|0;u=c[33416]|0;z=(c[g+((c[33398]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[33416]=u;A=c[33402]|0;c[33414]=A;z=c[33420]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[33396]=z;B=z;z=A;while(1){A=(c[33400]|0)+ -1|0;c[33400]=A;C=z+ -1|0;c[33414]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[16702]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[16702];F=C}C=133528;MOa(133648,133616,a+((c[33402]|0)-m+(fa(c[33398]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[33396]|0;D=C+1|0;c[33396]=D;if((C|0)>=(u|0)){break a}B=D;z=c[33414]|0}}}while(0);n=c[33398]|0;s=n+1|0;c[33398]=s;if((n|0)>=(r|0)){break}t=c[33418]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[33402]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function QOa(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[33426]=n;f=c[d>>2]|0;o=f+ -1|0;c[33438]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[33422]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[33436]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[33424]=k;q=j+(k+ -1<<3)|0;h[16714]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[16714]}k=133528;MOa(133744,133712,a+((c[33426]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[33422]|0;f=k+1|0;c[33422]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[33430]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[33422]=k;q=c[33426]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[33436]=s;u=q-s|0;c[33432]=u;q=k-s|0;c[33434]=q;h[16714]=-t;s=133528;MOa(133744,133712,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[33430]|0;r=s+1|0;c[33430]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[33422]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[33436]=r;s=o-r|0;c[33432]=s;q=n-r|0;c[33434]=q;r=133528;t=+OOa(133744,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[16714]=t;r=c[33422]|0;q=j+(r+ -1<<3)|0;o=c[33426]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[33422]=n;}while((r|0)<(f|0));v=o;w=c[33438]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[33430]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[33422]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[33436]=(n|0)<=(b|0)?n:b;b=133528;t=+OOa(133744,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[33422]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[33424]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[16714]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[16714]}n=c[33430]|0;b=n+1|0;c[33430]=b;if((n|0)>=(w|0)){break}o=c[33426]|0;v=b}i=l;return 0}function ROa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[33450]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[33448]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[33448]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[33448]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[33448]=o;i=g;return 0}}while(0);c[33452]=1;c[33454]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[33452]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[33454]=o;q=o}else{q=1}o=c[a>>2]|0;c[33448]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[33452]=p;q=s+(c[f>>2]|0)|0;c[33454]=q;a=r+1|0;c[33448]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function SOa(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+TOa(133904);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+UOa(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+UOa(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+UOa(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+UOa(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function TOa(a){a=a|0;i=i;return+(+h[133912+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function UOa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}



function VOa(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+TOa(133944);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;Ge[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+UOa(b,e);c[E>>2]=2;Ge[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){bPa(b,b,f,g,133952,N,133944,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+UOa(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=sgb(ga|0,0,Z+ -2|0,0)|0;Z=lgb(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}aPa(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}Ge[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);SOa(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+UOa(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;Ge[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+UOa(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+UOa(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+UOa(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}dPa(b,b,s,t,v,w,x,D)|0;cPa(b,b,f,g,w,x)|0;W=133944;cPa(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;Ge[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}Ge[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}function WOa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[133976]=1;f=d[b]|0;c[33490]=f;b=d[e]|0;c[33492]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[33490]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[33492]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}function XOa(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[143508>>2]=6;a4a(143504)|0;r3a(144248,j,4)|0;K3a()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[35178]=0;c[35784]=0;c[35772]=0;a[143112]=0;t=c[e>>2]|0;c[34732]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[35178]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[34732]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[34732]=1;if((v|0)>=1){x=1;while(1){h[135400+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[34732]=v+1}c[35776]=2;x=c[e>>2]|0;c[34732]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[34734]=1;if((E|0)<1){F=C}else{G=1;while(1){h[135400+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[34734]=E+1;F=+h[B>>3]}h[135400+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[35776]=G;D=G}G=z+1|0;c[34732]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[35178]|0;y=z+1|0;c[35174]=y;c[34732]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[34734]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[135400+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[34734]=x+1}le[u&63](e,b,138760+(z+ -1<<3)|0)|0;c[35784]=(c[35784]|0)+1;if((c[j>>2]|0)>=1){c[143532>>2]=6;a4a(143528)|0;r3a(144248,143136,4)|0;r3a(144248,138760+((c[34732]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[34734]=1;if((v|0)>=1){A=1;do{r3a(144248,b+(A+ -1<<3)|0,8)|0;B=c[34734]|0;A=B+1|0;c[34734]=A;}while((B|0)<(v|0))}K3a()|0}v=c[34732]|0;z=v+1|0;c[34732]=z;}while((v|0)<(y|0))}y=c[35772]|0;b:while(1){c[35772]=y+1;c[35684]=1;c[35680]=1;C=+h[17345];h[17841]=C;h[17843]=C;z=c[35174]|0;c[34732]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[138760+(A+ -1<<3)>>3];do{if(!(C<=K)){c[35684]=A;L=+h[138760+(A+ -1<<3)>>3];h[17841]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[35680]=A;L=+h[138760+(A+ -1<<3)>>3];h[17843]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[34732]=z+1;H=O}A=c[e>>2]|0;c[34732]=1;if((A|0)>=1){v=1;while(1){h[140880+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[34732]=A+1}c[34732]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[34734]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=140880+(Q+ -1<<3)|0;h[B>>3]=+h[135400+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[34734]=x+1;P=v}}while(0);v=P+1|0;c[34732]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[34734]=1;if((z|0)>=1){K=+(c[35178]|0);v=1;while(1){A=140880+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[34734]=z+1}v=c[e>>2]|0;c[34732]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[140880+(B<<3)>>3];h[143160+(B<<3)>>3]=K+(K- +h[135400+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[34732]=v+1}le[u&63](e,143160,143152)|0;A=(c[35784]|0)+1|0;c[35784]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[143556>>2]=6;a4a(143552)|0;r3a(144248,143136,4)|0;r3a(144248,143152,8)|0;B=c[e>>2]|0;c[34734]=1;if((B|0)>=1){E=1;do{r3a(144248,143160+(E+ -1<<3)|0,8)|0;G=c[34734]|0;E=G+1|0;c[34734]=E;}while((G|0)<(B|0))}K3a()|0}}while(0);K=+h[17894];c:do{if(!(K>=+h[17843])){z=c[e>>2]|0;c[34732]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[140880+(v<<3)>>3];h[143328+(v<<3)>>3]=I+(+h[143160+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[34732]=z+1}le[u&63](e,143328,143320)|0;A=(c[35784]|0)+1|0;c[35784]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[143580>>2]=6;a4a(143576)|0;r3a(144248,143136,4)|0;r3a(144248,143320,8)|0;B=c[e>>2]|0;c[34734]=1;if((B|0)>=1){E=1;do{r3a(144248,143328+(E+ -1<<3)|0,8)|0;G=c[34734]|0;E=G+1|0;c[34734]=E;}while((G|0)<(B|0))}K3a()|0}}while(0);I=+h[17915];if(I>=+h[17843]){R=118;break}v=c[e>>2]|0;c[34732]=1;A=c[35684]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[135400+((z*21|0)+ -22+A<<3)>>3]=+h[143328+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[34732]=v+1}h[138760+(A+ -1<<3)>>3]=I}else{z=c[35174]|0;c[34732]=1;if((z|0)>=1){B=c[35684]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[138760+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[34732]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[17841])){E=c[e>>2]|0;c[34732]=1;z=c[35684]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[135400+((B*21|0)+ -22+z<<3)>>3]=+h[143160+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[34732]=E+1}h[17841]=K;h[138760+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[34732]=1;if((B|0)>=1){A=c[35684]|0;v=1;while(1){x=v+ -1|0;h[143328+(x<<3)>>3]=+h[135400+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[140880+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[34732]=B+1}le[u&63](e,143328,143320)|0;v=(c[35784]|0)+1|0;c[35784]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[143604>>2]=6;a4a(143600)|0;r3a(144248,143136,4)|0;r3a(144248,143320,8)|0;z=c[e>>2]|0;c[34734]=1;if((z|0)>=1){E=1;do{r3a(144248,143328+(E+ -1<<3)|0,8)|0;x=c[34734]|0;E=x+1|0;c[34734]=E;}while((x|0)<(z|0))}K3a()|0}}while(0);I=+h[17915];if(!(I>+h[17841])){A=c[e>>2]|0;c[34732]=1;v=c[35684]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[135400+((B*21|0)+ -22+v<<3)>>3]=+h[143328+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[34732]=A+1}h[138760+(v+ -1<<3)>>3]=I;break}B=c[35174]|0;c[34732]=1;if((B|0)<1){break}else{S=1}do{z=c[35680]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[34734]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=135400+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[135400+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[135400+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[34734]=E+1}le[u&63](e,b,138760+(S+ -1<<3)|0)|0;G=(c[35784]|0)+1|0;c[35784]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[143628>>2]=6;a4a(143624)|0;r3a(144248,143136,4)|0;r3a(144248,138760+((c[34732]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[34734]=1;if((x|0)>=1){G=1;do{r3a(144248,b+(G+ -1<<3)|0,8)|0;T=c[34734]|0;G=T+1|0;c[34734]=G;}while((T|0)<(x|0))}K3a()|0}}while(0);z=c[34732]|0;S=z+1|0;c[34732]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[34732]=1;v=c[35684]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[135400+((A*21|0)+ -22+v<<3)>>3]=+h[143160+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[34732]=B+1}h[138760+(v+ -1<<3)>>3]=+h[17894]}A=c[35772]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[17844]=0.0;h[17890]=0.0;A=c[35174]|0;c[34732]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[17890]=0.0/K;c[34732]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[138760+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[17890]=I;c[34732]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[138760+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[17844]=$;c[34732]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[17844]=I;do{if(!(I<=+h[k>>3])){if((c[35784]|0)>(c[g>>2]|0)){break}a[143112]=0;c[35772]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[34732]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[34734]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[135400+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[34734]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[34732]=v+1}le[u&63](e,b,f)|0;B=(c[35784]|0)+1|0;c[35784]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[143652>>2]=6;a4a(143648)|0;r3a(144248,143136,4)|0;r3a(144248,s,8)|0;z=c[e>>2]|0;c[34734]=1;if((z|0)>=1){E=1;do{r3a(144248,b+(E+ -1<<3)|0,8)|0;x=c[34734]|0;E=x+1|0;c[34734]=E;}while((x|0)<(z|0))}K3a()|0;ba=c[35784]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[143772>>2]=6;a4a(143768)|0;K3a()|0;c[143796>>2]=6;a4a(143792)|0;B=c[e>>2]|0;c[34732]=1;if((B|0)>=1){A=1;do{r3a(144248,b+(A+ -1<<3)|0,8)|0;v=c[34732]|0;A=v+1|0;c[34732]=A;}while((v|0)<(B|0))}K3a()|0;c[143820>>2]=6;a4a(143816)|0;r3a(144248,s,8)|0;K3a()|0}if(a[143112]&1){I=+h[17890];K=+h[17936]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[143112]=1;da=+h[17890]}h[17936]=da;c[35772]=0;y=0}if((c[j>>2]|0)>=0){c[143844>>2]=6;a4a(143840)|0;r3a(144248,143136,4)|0;K3a()|0;c[143868>>2]=6;a4a(143864)|0;y=c[e>>2]|0;c[34732]=1;if((y|0)>=1){B=1;do{r3a(144248,b+(B+ -1<<3)|0,8)|0;A=c[34732]|0;B=A+1|0;c[34732]=B;}while((A|0)<(y|0))}K3a()|0;c[143892>>2]=6;a4a(143888)|0;r3a(144248,s,8)|0;K3a()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[143916>>2]=6;a4a(143912)|0;K3a()|0}h[17843]=+h[f>>3];c[35786]=0;y=c[35174]|0;c[34732]=1;if((y|0)>=1){B=1;while(1){A=138760+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[34732]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[34734]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=135400+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[143328+(E+ -1<<3)>>3]=+h[135400+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[34734]=v+1}le[u&63](e,143328,A)|0;c[35786]=(c[35786]|0)+1;c[35784]=(c[35784]|0)+1;E=c[34732]|0;I=+h[138760+(E+ -1<<3)>>3];if(I>=+h[17843]){B=E;continue}h[17843]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[143940>>2]=6;a4a(143936)|0;r3a(144248,143136,4)|0;r3a(144248,142744,8)|0;E=c[e>>2]|0;c[34734]=1;if((E|0)>=1){z=1;do{r3a(144248,143328+(z+ -1<<3)|0,8)|0;G=c[34734]|0;z=G+1|0;c[34734]=z;}while((G|0)<(E|0))}K3a()|0;B=c[34732]|0}}B=c[35178]|0;c[34732]=1;do{if((B|0)<1){h[17370]=+h[17345];c[34732]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[34742]=E;z=c[e>>2]|0;c[34734]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[143160+(A+ -1<<3)>>3]=(+h[135400+(v+ -21<<3)>>3]+ +h[135400+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[34734]=z+1}le[u&63](e,143160,140720+(y+ -1<<3)|0)|0;c[35786]=(c[35786]|0)+1;c[35784]=(c[35784]|0)+1;A=c[34732]|0;y=A+1|0;c[34732]=y;}while((A|0)<(B|0));y=c[35178]|0;I=+h[17345];h[17370]=I;c[34732]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[34742]=A;c[34744]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[34734]=1;E=1;while(1){v=E+1|0;c[34746]=v;G=c[e>>2]|0;c[34736]=1;if((G|0)>=1){x=c[34744]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[143328+(T+ -1<<3)>>3]=(+h[135400+(U+x<<3)>>3]+ +h[135400+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[34736]=G+1}le[u&63](e,143328,143320)|0;c[35786]=(c[35786]|0)+1;c[35784]=(c[35784]|0)+1;T=c[34732]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[34734]|0;la=U+x|0;c[34738]=la;I=+h[17370];h[141040+(la+ -1<<3)>>3]=(+h[17915]+I- +h[140720+(v<<3)>>3]- +h[140720+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[34734]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[34732]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[35178]|0;c[34738]=0;c[34732]=1;E=(y|0)<1;if(E){c[34732]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=sgb(A|0,0,y+ -2|0,0)|0;A=lgb(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[141040+(U+ -1<<3)>>3]=(+h[138760+(v<<3)>>3]+ka- +h[140720+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[34742]=v+1;c[34738]=(z|1)+A;c[34732]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=140720+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[138760+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[34742]=T+1;c[34732]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[34738]=0;c[34732]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[34732]=1;if((B|0)>=1){A=1;while(1){h[142760+(A+ -1<<3)>>3]=+h[135400+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[34732]=B+1}c[34732]=1;do{if(ma){c[34732]=1}else{A=1;while(1){z=A+1|0;c[34742]=z;v=c[e>>2]|0;c[34734]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=135400+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[135400+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[34734]=v+1}c[34732]=z;if((A|0)<(na|0)){A=z}else{break}}c[34732]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[34742]=A;y=c[e>>2]|0;c[34734]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[135400+(T+oa<<3)>>3]=+h[135400+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[34734]=y+1}c[34732]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=141040;YOa(B,140712,B,142920,143496,q,143080)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[143964>>2]=6;a4a(143960)|0;K3a()|0}c[q>>2]=2;if((c[35784]|0)>(c[g>>2]|0)){R=312;break}c[143988>>2]=6;a4a(143984)|0;K3a()|0;B=c[e>>2]|0;c[34732]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[34732]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[143676>>2]=6;a4a(143672)|0;r3a(144248,g,4)|0;K3a()|0;c[143700>>2]=6;a4a(143696)|0;r3a(144248,142752,8)|0;K3a()|0;c[143724>>2]=6;a4a(143720)|0;u=c[e>>2]|0;c[34732]=1;if((u|0)>=1){E=1;do{r3a(144248,b+(E+ -1<<3)|0,8)|0;z=c[34732]|0;E=z+1|0;c[34732]=E;}while((z|0)<(u|0))}K3a()|0;c[143748>>2]=6;a4a(143744)|0;r3a(144248,s,8)|0;K3a()|0;i=r;return 0}else if((R|0)==226){u=c[35178]|0;c[35782]=u-(c[35874]|0);c[34732]=1;E=(u|0)<1;do{if(E){h[17887]=0.0;c[34732]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[138760+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=138760+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[141040+(sa+ -1<<3)>>3]*+h[140720+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[34738]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[34734]=z;h[17887]=0.0;c[34732]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[138760+(v<<3)>>3]*+h[140720+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[17887]=wa;c[34732]=u+1;qa=wa}}while(0);h[17887]=+h[17370]-qa;s=c[e>>2]|0;c[34732]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[143328+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=143328+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[138760+(T+ -1<<3)>>3]*+h[135400+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[34732]=s+1;c[34734]=xa}v=c[e>>2]|0;c[34732]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=142760+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[143328+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[34732]=v+1}if((c[j>>2]|0)>=0){c[144012>>2]=6;a4a(144008)|0;r3a(144248,143096,8)|0;z=c[e>>2]|0;c[34732]=1;if((z|0)>=1){s=1;do{r3a(144248,142760+(s+ -1<<3)|0,8)|0;u=c[34732]|0;s=u+1|0;c[34732]=s;}while((u|0)<(z|0))}K3a()|0;c[144036>>2]=6;a4a(144032)|0;K3a()|0}z=c[e>>2]|0;c[34732]=1;if((z|0)>=1){s=c[35178]|0;v=1;while(1){c[34734]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[138760+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=138760+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[141040+(Aa+ -1<<3)>>3]*+h[135400+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[34738]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[34736]=E;c[34734]=s+1}T=c[e>>2]|0;c[34734]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=139016+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[138760+(Ea+ -1<<3)>>3]*+h[135400+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[34734]=T+1;c[34738]=Ca;c[34736]=Da}za=v+1|0;c[34732]=za;if((v|0)<(z|0)){v=za}else{break}}}c[34734]=0;v=c[e>>2]|0;c[34732]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[139016+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[34734]=Ga;c[34732]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[144060>>2]=6;a4a(144056)|0;r3a(144248,143128,4)|0;K3a()|0;c[35176]=1;z=1;d:while(1){c[34738]=z;do{if((z|0)>(c[e>>2]|0)){s=c[35176]|0;if((s|0)==1){c[144084>>2]=6;a4a(144080)|0;K3a()|0;YOa(139016,140712,141040,142920,143496,q,143080)|0;c[144108>>2]=6;a4a(144104)|0;K3a()|0;c[35176]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[35176]=2;c[34748]=0;c[34750]=0;s=c[e>>2]|0;c[34732]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=sgb(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=lgb(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=139016+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=139016+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[139016+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[34752]=Na;c[34750]=Ta;c[34748]=Ia;c[34734]=Ma;c[34732]=s+1}c[144132>>2]=6;a4a(144128)|0;K3a()|0;c[34748]=0;u=c[e>>2]|0;c[34732]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=139016+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[34748]=Wa;c[34732]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[34748]=T;s=c[e>>2]|0;c[34732]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[34742]=B;Qa=za+la|0;c[34748]=Qa;Pa=B+5|0;c[34744]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[35176]|0)==3){c[144204>>2]=6;a4a(144200)|0;Pa=c[34744]|0;Qa=c[34742]|0;c[34734]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{r3a(144248,141040+(B+ -1<<3)|0,8)|0;Qa=c[34734]|0;B=Qa+1|0;c[34734]=B;}while((Qa|0)<(Pa|0))}K3a()|0}else{c[144180>>2]=6;a4a(144176)|0;Pa=c[34744]|0;B=c[34742]|0;c[34734]=B;if((B|0)<=(Pa|0)){x=B;do{r3a(144248,139016+(x+ -1<<3)|0,8)|0;B=c[34734]|0;x=B+1|0;c[34734]=x;}while((B|0)<(Pa|0))}K3a()|0}Pa=c[34732]|0;x=Pa+1|0;c[34732]=x;if((Pa|0)>=(s|0)){break e}E=c[34738]|0;la=c[34748]|0;za=x}}}while(0);c[144228>>2]=6;a4a(144224)|0;K3a()|0;z=(c[34738]|0)+6|0}c[144156>>2]=6;a4a(144152)|0;r3a(144248,143144,4)|0;K3a()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);le[p&63](e,b,f)|0;i=r;return 0}function YOa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[36082]=c[b>>2];c[g>>2]=1;if((c[36082]|0)<1){i=k;return 0}c[g>>2]=0;ZOa(a,144328,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[36082]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[36074]=f;c[36080]=g;c[36086]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=sgb(a|0,0,g+ -2|0,0)|0;m=lgb(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[36066]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=sgb(p|0,0,a-n|0,0)|0;p=lgb(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[36066]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[36064]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[36064]=j}c[36076]=g;c[36078]=f;c[36084]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[18036]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[18036]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[18036]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[36084]=D;E=v+ -1|0;c[36076]=E;F=w+ -1|0;c[36078]=F;q=D;v=E;w=F}c[36068]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[36070]=t;c[36080]=0;c[36086]=l-g;i=k;return 0}function ZOa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[18050]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[18050]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[18050];c[36090]=1;c[36092]=0;n=c[b>>2]|0;c[36104]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[36094]=0;c[36106]=1;do{if((o|0)>=1){p=1;q=c[36092]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[18049]=m;u=(p|0)==(o|0);if(u){l=m*+h[18050];h[18051]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[18049]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[18051]=+h[18051]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[36094]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[36094]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[18049];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[36106]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[36088]=y;c[36096]=x;c[36092]=s;break}else if((D|0)==26){D=0;c[36088]=y;c[36096]=x;c[36092]=s;break}}}while(0);m=+V(+(+h[18051]));h[18051]=m;H=+h[18049];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[36092]|0)+ -1<<3)>>3]=G;G=+h[18051]/+h[18049];h[j+((c[36088]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[36092]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[36090]|0;O=c[36104]|0}}while(0);b=N+O|0;c[36090]=b;o=O+1|0;c[36104]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[36088]=y;c[36096]=x;c[36092]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function _Oa(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[36130]=n;o=(c[d>>2]|0)-n|0;c[36152]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[36150]=s;a[144544]=1;t=c[b>>2]|0;u=t+1|0;c[36146]=u;v=c[b>>2]|0;w=u+v|0;c[36144]=w;u=w+(c[b>>2]|0)|0;c[36148]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[36138]=w;x=w+(c[d>>2]|0)|0;c[36132]=x;y=x+(c[b>>2]|0)|0;c[36134]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[36140]=z;A=z+(c[d>>2]|0)|0;c[36154]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[36156]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[36128]=C;D=C+(c[b>>2]|0)|0;c[36142]=D;$Oa(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,144600,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);a4a(144632)|0;K3a()|0;i=m;return 0}function $Oa(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[18164]=.5;h[18155]=1.0;h[18195]=.1;F=(c[a>>2]|0)+1|0;c[36306]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[36298]=H;I=(c[b>>2]|0)-F|0;c[36352]=I;F=c[j>>2]|0;c[36406]=(F|0)<1?1:F;F=c[a>>2]|0;c[36290]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[36292]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[36292]=J+1}L=c[u>>2]|0;c[36288]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[36288]=L+1}K=j+1|0;c[36290]=K;if((j|0)<(F|0)){j=K}else{break}}}c[36294]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[36294]=H+1}H=c[b>>2]|0;c[36292]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[36290]=M;c[36292]=H+1}N=+h[e>>3];O=N*N;h[18200]=O;h[18186]=+h[18155]/O;h[18187]=+V(+(+h[18164]))/O;c[36296]=0;H=y;y=A;M=0;a:while(1){c[36308]=M;F=M-(c[a>>2]|0)|0;c[36332]=F;j=M+1|0;c[36296]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[36382]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[36320]=L;K=L+G|0;c[36318]=K;if((K|0)>(c[a>>2]|0)){c[36382]=L;G=K-(c[a>>2]|0)|0;c[36320]=G;c[36318]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[18177]=O;L=c[36306]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[18177]=N;R=N}else{R=O}O=+h[e>>3];h[18178]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[18178]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[18178];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[36290]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[36290]=S+1}if((M|0)>=(c[36406]|0)){T=j;U=159;break}while(1){le[H&63](a,d,145144)|0;if((c[g>>2]|0)==3){a4a(145672)|0;r3a(145840,145184,4)|0;r3a(145840,145144,8)|0;I=c[a>>2]|0;c[36288]=1;if((I|0)>=1){F=1;do{r3a(145840,d+(F+ -1<<3)|0,8)|0;L=c[36288]|0;F=L+1|0;c[36288]=F;}while((L|0)<(I|0))}K3a()|0}I=c[36296]|0;do{if((I|0)>(c[b>>2]|0)){F=c[36336]|0;if((F|0)==-1){break a}h[18196]=0.0;c[36294]=0;L=c[a>>2]|0;c[36290]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[18196]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[18169]=N;if((X|0)==(G|0)){ea=N*+h[18164];h[18169]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[18196]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[36294]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[36288]=Y;c[36290]=L+1;W=Z}J=c[b>>2]|0;c[36292]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[18196]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[36292]=J+1;ia=ja}O=+h[18143];ba=+h[18172];N=O-ba-ia;h[18163]=N;h[18182]=+h[18181];h[18181]=+h[18180];if(!(N>=0.0)){ka=-N}else{ka=N}h[18180]=ka;if(+h[18192]>+h[18158]){c[36380]=I}h[18188]=ba;do{if(O<ba){h[18172]=O;h[18205]=0.0;G=c[a>>2]|0;c[36288]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[18205]=+h[18205]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[36288]=G+1;h[A>>3]=ma}}while(0);c[36378]=F;if((F|0)<=0){O=+h[18196];if(O>=0.0){U=190;break a}ba=+h[18143];N=+h[18188];ea=(ba-N)/O;h[18193]=ea;O=+h[18195];do{if(!(ea<=O)){na=+h[18164]*+h[18185];h[A>>3]=na;oa=+h[18192];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[18185]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[18185]=qa;ra=qa;break}}else{qa=+h[18164]*+h[18192];h[18185]=qa;ra=qa}}while(0);ea=+h[18158];if(!(ra<=ea*1.5)){sa=ra}else{h[18185]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[18200]=ea;c[36394]=0;h[18201]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[36350]|0;c[36394]=J;oa=+h[18155];h[18201]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[36292]=1;if((J|0)<1){va=F}else{L=c[36352]|0;oa=ua;K=1;ca=F;while(1){h[18183]=0.0;c[36290]=1;if((L|0)<1){wa=0.0}else{X=c[36312]|0;aa=K+C|0;qa=+h[18155];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[18169]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[18183]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[36290]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[18165]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[18169]=za;h[18204]=0.0;$=c[a>>2]|0;c[36290]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[18204]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[36290]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[18169]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[18201]=Fa;c[36336]=K;Ga=Fa;Ha=K}aa=K+1|0;c[36292]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}fPa(a,b,s,t,145248,u,w,145320,145344,x)|0;ca=c[36336]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[18143];c[36294]=0;J=c[a>>2]|0;c[36288]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[18169]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[18169];G=G+1|0;da=da+1|0}da=X+aa|0;c[36294]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[36290]=La;c[36288]=J+1}h[L>>3]=0.0;X=c[36352]|0;c[36290]=1;aa=(X|0)<1;if(!aa){F=c[36312]|0;K=1;while(1){da=fa(K,B)|0;O=+h[18163]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[18169]=Oa;G=c[b>>2]|0;c[36292]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[18169];$=$+1|0}c[36292]=G+1}$=K+1|0;c[36290]=$;if((K|0)<(X|0)){K=$}else{break}}}h[18174]=0.0;K=c[a>>2]|0;c[36288]=1;if((K|0)>=1){F=1;while(1){O=+h[18163]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[18174]=+h[18174]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[36288]=K+1;h[A>>3]=Pa}F=c[36378]|0;do{if((F|0)==0){if(!(+h[18185]==+h[18158])){break}O=+h[18193];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[36398]=0;break}L=c[b>>2]|0;c[36292]=1;if((L|0)>=1){J=o+((c[36350]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[36292]=L+1}h[18167]=0.0;$=c[a>>2]|0;c[36288]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[18161]=0.0;G=c[b>>2]|0;c[36292]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[18161]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[36292]=G+1;Sa=Ta}h[18167]=+h[18167]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[36288]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[18167]*100.0}J=c[36398]|0;c[36398]=J+1;if(+h[18174]<Ra){c[36398]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[36288]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[36288]=J+1}$=c[36298]|0;c[36294]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[36294]=$+1}c[36290]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[36292]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[36292]=Na+1;Ua=Wa}if((L|0)<(c[36312]|0)){h[J>>3]=-Ua}Va=L+1|0;c[36290]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[36292]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[36290]=Xa;c[36292]=L+1}c[36398]=0}}while(0);O=+h[18143];ea=+h[18188];if(O<ea){c[36350]=ca}oa=+h[18195];if(O<=ea+oa*+h[18196]|(F|0)>0){U=54;break}c[36336]=0;Ia=0;Ja=+h[18185];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[18143];oa=+h[18143];do{if((I|0)==1){h[18162]=oa;h[18172]=oa;c[36350]=1;Ya=1}else{if(!(oa<+h[18172])){Ya=I;break}h[18172]=oa;c[36350]=I;Ya=I}}while(0);F=c[36308]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[36318]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[36320]|0;Va=K+aa|0;c[36294]=Va;if(+h[18177]<0.0){aa=X+(c[a>>2]|0)|0;c[36318]=aa;Za=aa}else{Za=X}if(+h[18178]<0.0){X=K+(c[a>>2]|0)|0;c[36320]=X;_a=X}else{_a=K}K=fa(c[36332]|0,B)|0;h[t+(K-B<<3)>>3]=+h[18186];h[t+(Ya+C+K<<3)>>3]=+h[18186];h[t+(Za-B+K<<3)>>3]=-+h[18186];h[t+(_a-B+K<<3)>>3]=-+h[18186];h[q+(Va+ -1<<3)>>3]=(+h[18162]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[18143])/(+h[18177]*+h[18178])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[36332]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[18164]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[18164]/+h[e>>3];ea=+h[18187];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[18187];h[t+(X+K<<3)>>3]=+h[18187];K=(fa(Va+1|0,Va)|0)/2|0;c[36294]=K;ea=(+h[18162]- +h[18143])/+h[e>>3];h[18169]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[18164]*(+h[X>>3]+ +h[18169]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[18162])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[18155]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[18155]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[18164]*+h[18200]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[18158]=oa;h[18185]=oa;c[36312]=1;h[18180]=0.0;h[18181]=0.0;c[36398]=0;h[18205]=0.0;F=c[a>>2]|0;c[36288]=1;if((F|0)<1){U=53;break}ca=c[36350]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[18205]=+h[18205]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[36288]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[36380]=c[36296];U=54;continue}else if((U|0)==54){U=0;c[36336]=0;I=(c[36306]|0)+ -1|0;K=c[a>>2]|0;ePa(a,b,l,n,p,q,r,145480,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,145616)|0;h[18157]=0.0;K=c[a>>2]|0;c[36288]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[18157]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[36288]=K+1;ab=cb}oa=+h[18185];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[18192]=O;ea=+h[18158];if(!(O<+h[18164]*ea)){db=ab;U=62;break}c[36336]=-1;O=+h[18195];N=O*oa;h[18185]=N;h[18193]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[18185]=ea;eb=ea}if((c[36296]|0)<=((c[36380]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[18202]*.125*ea;h[18169]=N;oa=+h[18180];ba=+h[18181];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[18182];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[18204]=O;I=c[b>>2]|0;c[36292]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[18161]=0.0;X=c[a>>2]|0;c[36290]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[18161]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[36290]=X+1;jb=lb}if(jb>ea){c[36336]=F;h[18204]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[36292]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[18193]>0.0){U=54;continue}ea=+h[18192];O=+h[18158];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[18164];h[18185]=O;ea=hb/+h[f>>3];h[18193]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[18158]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[18158]=na;ob=na;break}}else{na=+h[f>>3];h[18158]=na;ob=na}}while(0);h[18185]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){a4a(145720)|0;K3a()|0}a4a(145744)|0;r3a(145840,145264,8)|0;r3a(145840,145184,4)|0;K3a()|0;a4a(145768)|0;r3a(145840,145376,8)|0;ca=c[a>>2]|0;c[36288]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];r3a(145840,y,8)|0;I=c[36288]|0;F=I+1|0;c[36288]=F;}while((I|0)<(ca|0))}K3a()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[18164]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[18158];O=na>=ea?na:ea;h[18194]=O;ea=O*O;h[18157]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[18205];if(db<=ea*.001){h[18198]=ea*.25;ca=c[b>>2]|0;c[36292]=1;if((ca|0)>=1){F=1;while(1){h[18161]=0.0;I=c[a>>2]|0;c[36288]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[18161]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[36288]=I+1;pb=qb}h[18169]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[18164]*+h[18205];h[18161]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[36288]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[18169]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[18164]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[18161]*+h[n+(F+C+Va<<3)>>3]+ +h[18198]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[36300]=aa;c[36290]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[36290]=Va;rb=Va}c[36288]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[36292]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[36352]|0;c[36292]=1;if((F|0)>=1){ca=1;while(1){h[18179]=0.0;X=c[b>>2]|0;c[36288]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[18179]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[36288]=I;if((K|0)>=(X|0)){break b}O=+h[18179];K=I}}}while(0);X=c[a>>2]|0;c[36290]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[18198]*+h[18179]*+h[l+(I<<3)>>3];h[18161]=O;Va=c[b>>2]|0;c[36288]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[18161]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[36288]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[36312]|0)){h[18161]=-+h[18161]}L=c[b>>2]|0;c[36288]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[18161]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[36288]=L+1}J=K+1|0;c[36290]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[36288]=1;if((K|0)>=1){X=c[36312]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[36300]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[18169]=ub;c[36290]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[18169];aa=aa+1|0}aa=J+1|0;c[36290]=aa;vb=aa}c[36288]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[36292]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[36294]=0;ca=c[a>>2]|0;c[36290]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[36292]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[18164]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[36292]=aa+1}c[36288]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[36294]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[36288]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[36290]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[36290]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[36290]=J+1}h[18205]=0.0}if((c[36336]|0)>0){F=(c[36306]|0)+ -1|0;rOa(a,b,l,n,s,t,145248,u,145344,145552,v,145472,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[36292]=1;if((F|0)>=1){L=1;while(1){h[18170]=0.0;h[18171]=0.0;h[18161]=0.0;ca=c[a>>2]|0;c[36290]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[18170]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[18171]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[18161]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[36290]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[18164]+Ab);h[w+(K<<3)>>3]=+h[18161];K=L+1|0;c[36292]=K;if((L|0)<(F|0)){L=K}else{break}}}h[18165]=0.0;L=c[36352]|0;c[36292]=1;if((L|0)>=1){F=1;while(1){h[18161]=0.0;J=c[b>>2]|0;c[36288]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[18161]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[36288]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[18165];if((F|0)<(c[36312]|0)){h[18165]=O+ea;na=-Eb;h[18161]=na;Gb=na}else{h[18165]=O-ea;Gb=Eb}K=c[b>>2]|0;c[36288]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[18161];X=X+1|0}c[36288]=K+1}X=F+1|0;c[36292]=X;if((F|0)<(L|0)){F=X}else{break}}}h[18173]=0.0;h[18152]=0.0;F=c[a>>2]|0;c[36290]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[18161]=0.0;X=c[b>>2]|0;c[36288]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[18161]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[36288]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[18173]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[36302]=K;Va=c[a>>2]|0;c[36292]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[18161]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[36292]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[18173]+ +h[18161]*+h[ca>>3];h[18173]=O;na=+h[18152]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[18152]=na;aa=L+1|0;c[36290]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[18157];h[18165]=+h[18165]+(Ib*Ib+ea*(Ib+(Ib+ +h[18205])+ea*+h[18164]))-Hb;L=w+((c[36350]|0)+ -1<<3)|0;h[L>>3]=+h[18155]+ +h[L>>3];L=c[36336]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[18155]+ +h[18184]*+h[18165]/(ea*ea);h[18169]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;qOa(a,b,l,n,s,t,145248,u,145400,145344,v,x,w,145320,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[36288]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[36288]=L+1}F=c[36296]|0;aa=F+1|0;c[36296]=aa;if((F|0)>=(c[36406]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[36296]=T+ -1;if((c[g>>2]|0)<=0){break}a4a(145648)|0;K3a()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}a4a(145696)|0;K3a()|0}}while(0);Nb=+h[18172];if(Nb<=+h[18143]){U=c[a>>2]|0;c[36288]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[36288]=U+1;Ob=+h[18172]}h[18143]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}a4a(145792)|0;r3a(145840,145184,4)|0;K3a()|0;a4a(145816)|0;r3a(145840,145144,8)|0;g=c[a>>2]|0;c[36288]=1;if((g|0)>=1){a=1;do{r3a(145840,d+(a+ -1<<3)|0,8)|0;U=c[36288]|0;a=U+1|0;c[36288]=a;}while((U|0)<(g|0))}K3a()|0;i=z;return 0}function aPa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){dgb(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){dgb(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}function bPa(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+TOa(145848);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+UOa(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+UOa(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+UOa(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function cPa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function dPa(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+TOa(145856);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=sgb(u|0,0,t+ -2|0,0)|0;t=lgb(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function ePa(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[18252]=.5;h[18270]=6.283185307179586;v=+h[l>>3];h[18265]=v*v;c[36526]=0;l=c[b>>2]|0;c[36544]=l;c[36542]=l;w=c[b>>2]|0;c[36466]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[36466]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[36466]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[36466]=w+1}z=c[d>>2]|0;c[36470]=1;if((z|0)>=1){e=1;while(1){h[18256]=0.0;A=c[b>>2]|0;c[36468]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[18256]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[36468]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[18256]=v;C=c[b>>2]|0;c[36466]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[18256];F=F+1|0}c[36466]=C+1}F=e+1|0;c[36470]=F;if((e|0)<(z|0)){e=F}else{break}}}c[36480]=0;e=c[b>>2]|0;c[36468]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[36480]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[36466]=H;c[36468]=e+1}do{if((y|0)==0){h[18254]=0.0;h[18236]=0.0;w=c[b>>2]|0;c[36466]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[18236]=+h[18236]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[36466]=w+1}h[r>>3]=0.0;D=+h[18236];if(D==0.0){O=55;break a}h[18241]=0.0;h[18244]=0.0;h[18239]=D;h[18259]=D;P=D;Q=0.0;R=0.0;S=+h[18265];T=0}else{if((y|0)>(x|0)){h[18238]=0.0;h[18245]=0.0;h[18246]=0.0;z=c[b>>2]|0;c[36466]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[18238]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[18245]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[18246]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[36466]=z+1;U=ba;W=$;Z=aa}D=+h[18252];v=D*(+h[18249]-Z);h[18237]=v;_=+h[18242];ca=_+v;h[18253]=ca;h[18257]=ca;h[18255]=ca;c[36536]=0;a[145944]=1;da=+h[18270]/50.0;h[18256]=da;c[36466]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[18255]=ka;c[36536]=w;h[18266]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[18267]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[18261]=ha;h[18247]=ia;h[18250]=ja;h[18258]=ka;c[36466]=50;h[18257]=ka;if((la|0)==0){h[18266]=ka;O=46}else if((la|0)==49){h[18267]=ca;na=ca}else{O=46}if((O|0)==46){O=0;na=+h[18267]}h[18261]=0.0;ga=+h[18266];if(ga!=na){ea=ga-ma;h[18266]=ea;ga=na-ma;h[18267]=ga;oa=D*(ea-ga)/(ea+ga);h[18261]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[18261]=oa;ga=+X(+oa);h[18247]=ga;ea=+Y(+oa);h[18250]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[18262]=oa;h[18239]=0.0;w=c[b>>2]|0;c[36466]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[18247]*+h[J>>3]+ +h[18250]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[18239]+sa*sa;h[18239]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[18250];ea=+h[18247];F=F+1|0;z=K}c[36466]=w+1;qa=ta;ra=+h[18262]}ea=ra+ +h[18254];h[18254]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[18245]=0.0;z=c[b>>2]|0;c[36468]=1;do{if((z|0)<1){ea=+h[18269];h[18260]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[18245]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[36468]=z+1;ea=+h[18269];h[18260]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[18236];h[18256]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[18256]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[18260];oa=+h[18239];v=+h[18245];_=oa/v;ca=ea<=_?ea:_;h[18260]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[18239];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[18252]*Ca);h[18251]=ca;h[18254]=+h[18254]+ca;h[18264]=Ba;h[18239]=0.0;z=c[b>>2]|0;c[36466]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[18260]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[18239]+oa*oa;h[18239]=Ga;Ha=+h[18260];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[36466]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[18269]){if(+h[18251]<=+h[18254]*.01){O=55;break a}if(Fa<=+h[18259]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[18264];h[18256]=ca;h[18236]=0.0;h[18241]=0.0;h[18244]=0.0;w=c[b>>2]|0;c[36466]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[18236]+ca*ca;h[18236]=La;J=m+(F<<3)|0;Ma=+h[18241]+ +h[K>>3]*+h[J>>3];h[18241]=Ma;ca=+h[J>>3];Na=+h[18244]+ca*ca;h[18244]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[18256];Ja=Ja+1|0;Ka=J}c[36466]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[18265];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[36542]=y;ua=+h[18239];va=y}if(ua<=+h[18259]*1.0e-4){O=55;break a}h[18242]=0.0;h[18249]=0.0;z=c[b>>2]|0;c[36466]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[18242]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[18249]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[36466]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[18248]=ca;oa=+h[18265];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[36526]=J;_=+V(+(v-ca*ca));h[18256]=_;v=oa/_;h[18266]=v;oa=ca/_;h[18267]=oa;w=c[b>>2]|0;c[36466]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[18267];Ta=+h[18266];Ua=Ua+1|0;Va=K}c[36466]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[36526]=e;v=S-R;h[18256]=v;h[18269]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function fPa(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[18279]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[36564]=t;c[36554]=1;c[36548]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[36554]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[18281]=D;C=+h[x>>3]/D;h[18288]=C;z=+h[f+(B+y<<3)>>3]/D;h[18289]=z;B=c[d>>2]|0;c[36546]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[18281]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[18281];if((x|0)>=(B|0)){break}D=+h[18289];z=+h[18288];x=x+1|0}c[36546]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[36548]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[18288]=z;if((c[g>>2]|0)>1){D=-z;h[18288]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[18289]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[36546]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[18289]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[18288];t=t+1|0;x=A}c[36546]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[18286]=z;x=k+(w<<3)|0;H=+h[x>>3];h[18280]=H;D=H*H;h[18290]=D;h[18287]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[18279];a[146264]=0;do{if((u|0)==1){z=+h[18287];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[18281]=z;D=+h[18288]/z;h[18289]=D;H=+h[18280]/z;h[18288]=H;x=c[d>>2]|0;c[36546]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[18289];D=+h[18288];w=w+1|0;t=s}c[36546]=x+1;J=+h[18281]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[36550]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[36550]=u;M=u}t=u+1-M|0;c[36552]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[18287];z=+h[f+(t+w<<3)>>3]/D;h[18281]=z;h[18288]=z*+h[l>>3];H=+h[18280];h[18289]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[18281]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[18279]/+V(+(+h[18290]+z*N*z));h[18284]=C;if(!(D>=0.0)){O=-D}else{O=D}h[18285]=C*+V(+O);t=c[d>>2]|0;c[36546]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[18285]*(+h[A>>3]- +h[18288]*+h[n+(G<<3)>>3]- +h[18289]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[18281];z=+h[18280];H=+h[18284];v=v+1|0}c[36546]=t+1;P=+h[18287]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[146264]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[36546]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[18281]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[18281];K=Q+1|0;c[36546]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[36548]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[36556]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[18280];N=+h[18287];J=(+h[18286]*+h[f>>3]-O*P)/N;h[18288]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[18289]=P;c[36546]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[36546]=q;if((f|0)>=(b|0)){break a}N=+h[18289];O=+h[18288];f=q}}}while(0);b=R+1|0;c[36548]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function gPa(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function hPa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((gPa(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){cb(146328,146344,116,146368)}else if((s|0)==14){i=g;return o|0}return 0}function iPa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((Xfb(w,c[146376+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[146480+(x<<2)>>2]|0;c[q>>2]=c[146376+(x<<2)>>2];c[q+4>>2]=y;SMa(23,0,146552,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=zfb(D,8)|0;c[e+40>>2]=B;D=b+536|0;VMa(c[D>>2]|0,(B|0)!=0|0,146592,p);B=zfb(c[A>>2]|0,4)|0;c[e+36>>2]=B;VMa(c[D>>2]|0,(B|0)!=0|0,146592,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=zfb(c[C>>2]|0,4)|0;c[e+24>>2]=xfb(8)|0;C=xfb(4)|0;c[e+20>>2]=C;c[C>>2]=c[118248>>2];VMa(c[D>>2]|0,(C|0)!=0|0,146592,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=xfb(C)|0;A=e+44|0;c[A>>2]=xfb(C)|0;C=zfb(15,4)|0;E=e+12|0;c[E>>2]=C;VMa(c[D>>2]|0,(C|0)!=0|0,146592,m);C=zfb(5,4)|0;c[e+4>>2]=C;VMa(c[D>>2]|0,(C|0)!=0|0,146592,l);C=zfb(5,4)|0;c[e+8>>2]=C;VMa(c[D>>2]|0,(C|0)!=0|0,146592,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=xfb(C)|0;c[e+76>>2]=xfb(C)|0;c[e+80>>2]=xfb(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((ie[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){SMa(23,0,146608,j)}else{SMa(1,0,146680,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[118284>>2]|c[29546]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=6;U=T;V=146512;W=V;WMa(Q,W,r)}c[t>>2]=w;UMa(23,1,146408,t);t=1;do{w=c[146480+(t<<2)>>2]|0;c[s>>2]=c[146376+(t<<2)>>2];c[s+4>>2]=w;UMa(23,0,146464,s);t=t+1|0;}while((t|0)<8);fe[c[29686]&511](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=6;U=T;V=146512;W=V;WMa(Q,W,r);return 0}function jPa(a){a=a|0;var b=0;b=i;yfb(c[a+40>>2]|0);yfb(c[a+36>>2]|0);yfb(c[a+20>>2]|0);yfb(c[a+12>>2]|0);yfb(c[a+4>>2]|0);yfb(c[a+8>>2]|0);yfb(a);i=b;return 0}function kPa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;VMa(c[N>>2]|0,(c[M>>2]|0)!=0|0,146776,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){SMa(3,0,146808,B);SMa(3,0,146848,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];ie[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];SMa(3,0,146872,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];SMa(23,0,146912,y);if((c[z>>2]|0)==1){ZNa(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){kRa(a)|0;ie[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 7:{tOa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 3:{tOa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 5:{tOa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};case 6:{tOa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 4:{tOa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){tOa(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{tOa(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){ud(_|0)|0;ud($|0)|0;UMa(3,0,146944,x);SMa(3,0,147032,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){ud(_|0)|0;ud($|0)|0;$=tPa(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){kRa(a)|0;ie[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ie[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];UMa(1,0,147056,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[118204>>2]|0)!=0){SMa(3,1,147088,u);c[s>>2]=c[z>>2];SMa(3,0,147112,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];SMa(3,0,147136,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];SMa(3,0,147168,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];SMa(3,0,147208,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];SMa(3,0,147256,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];SMa(3,0,147304,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];SMa(3,0,147344,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];SMa(3,0,147384,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];SMa(3,0,147424,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];SMa(3,0,147472,f);fe[c[29686]&511](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){cb(147512,147544,410,147576)}SMa(3,0,147592,e);S=0;i=d;return S|0}function lPa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;kRa(g)|0;a=f+540|0;ie[c[(c[a>>2]|0)+40>>2]&127](g)|0;ie[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}



function o0a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;BYa(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];Y0a(l,k);do{if(!(X0a(b,l)|0)){k=MYa(a)|0;x=_0a(b)|0;if(Z0a(k,e,x)|0){break}w=Z0a(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];c1a(r,h,1,0);BYa(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];Y0a(t,g);do{if(!(X0a(r,t)|0)){if(Z0a(k,e,_0a(r)|0)|0){break}y=b1a(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;JSa(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;$0a(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];Y0a(o,j);do{if(!(X0a(n,o)|0)){j=MYa(a)|0;if(Z0a(j,_0a(a1a(n)|0)|0,e)|0){break}y=b1a(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;JSa(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function p0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];V0a(a,e);i=d;return}function q0a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=L_a(d)|0;d=N_a(n,1)|0;H0a(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];G0a(j,d,h);I0a(0,l$a((J0a(j)|0)+16|0)|0,e);a[(K0a(j)|0)+4|0]=1;L0a(m,j);r0a(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];p0a(b,g);s0a(m);s0a(j);i=f;return}function r0a(a,b){a=a|0;b=b|0;var c=0;c=i;E0a(a,b);i=c;return}function s0a(a){a=a|0;var b=0;b=i;z0a(a);i=b;return}function t0a(a){a=a|0;var b=0,d=0;b=i;d=c[(x0a(a)|0)>>2]|0;i=b;return d|0}function u0a(a){a=a|0;var b=0,d=0;b=i;d=v0a(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function v0a(a){a=a|0;var b=0,c=0;b=i;c=w0a(a)|0;i=b;return c|0}function w0a(a){a=a|0;i=i;return a|0}function x0a(a){a=a|0;var b=0,c=0;b=i;c=y0a(a)|0;i=b;return c|0}function y0a(a){a=a|0;i=i;return a|0}function z0a(a){a=a|0;var b=0;b=i;A0a(a,0);i=b;return}function A0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=v0a(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}C0a(B0a(e)|0,f);i=d;return}function B0a(a){a=a|0;var b=0,c=0;b=i;c=D0a(a)|0;i=b;return c|0}function C0a(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;k$a(f,l$a(d+16|0)|0)}if((d|0)==0){i=e;return}E_a(c[b>>2]|0,d,1);i=e;return}function D0a(a){a=a|0;i=i;return a+4|0}function E0a(a,b){a=a|0;b=b|0;var c=0;c=i;F0a(a,b);i=c;return}function F0a(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function G0a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];P0a(a,b,f);i=e;return}function H0a(a,b){a=a|0;b=b|0;var c=0;c=i;O0a(a,b);i=c;return}function I0a(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}M0a(b,c);i=a;return}function J0a(a){a=a|0;var b=0,d=0;b=i;d=c[(x0a(a)|0)>>2]|0;i=b;return d|0}function K0a(a){a=a|0;var b=0,c=0;b=i;c=B0a(a)|0;i=b;return c|0}function L0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;E0a(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];p0a(h,f);r0a(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];p0a(a,e);s0a(h);i=d;return}function M0a(a,b){a=a|0;b=b|0;var c=0;c=i;N0a(a,b);i=c;return}function N0a(a,b){a=a|0;b=b|0;var c=0;c=i;m0a(a,b);i=c;return}function O0a(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function P0a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Y_a(g)|0)>>2]|0;g=R0a(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Q0a(b,a,f);i=e;return}function Q0a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];S0a(a,b,f);i=e;return}function R0a(a){a=a|0;i=i;return a|0}function S0a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(a$a(g)|0)>>2]|0;g=U0a(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];T0a(b,a,f);i=e;return}function T0a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(a$a(f)|0)>>2];f=U0a(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function U0a(a){a=a|0;i=i;return a|0}function V0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=u0a(W0a(b)|0)|0;h=U0a(K0a(W0a(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];Q0a(g,a,e);i=d;return}function W0a(a){a=a|0;i=i;return c[a>>2]|0}function X0a(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function Y0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];h1a(a,e);i=d;return}function Z0a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=OWa(0,b,c)|0;i=a;return d|0}function _0a(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function $0a(a,b){a=a|0;b=b|0;var d=0;d=i;CYa(a,c[(d_a(b)|0)>>2]|0);i=d;return}function a1a(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=f1a(c[d>>2]|0)|0;i=b;return a|0}function b1a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=KYa(a)|0;JSa(e);if((h|0)==0){j=DYa(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=MYa(a)|0;a=h;while(1){h=a+16|0;if(Z0a(j,d,h)|0){l=a;m=c[l>>2]|0;JSa(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(Z0a(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;JSa(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function c1a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;d1a(b,d);c[a>>2]=c[b>>2];i=e;return}function d1a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;e1a(b,c,e);i=d;return}function e1a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{a1a(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{d0a(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function f1a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;JSa(b);if((e|0)==0){e=a;while(1){a=xUa(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=g1a(c[d>>2]|0)|0;i=b;return g|0}return 0}function g1a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;JSa(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;JSa(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function h1a(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function i1a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(X0a(a,b)|0)^1;i=c;return d|0}function j1a(a){a=a|0;var b=0;b=i;i=i+128|0;zWa(a,b);zWa(a+12|0,b+8|0);k1a(a+24|0,b+16|0);k1a(a+36|0,b+24|0);k1a(a+48|0,b+32|0);k1a(a+60|0,b+40|0);k1a(a+72|0,b+48|0);k1a(a+84|0,b+56|0);k1a(a+96|0,b+64|0);k1a(a+108|0,b+72|0);k1a(a+120|0,b+80|0);k1a(a+132|0,b+88|0);k1a(a+144|0,b+96|0);k1a(a+156|0,b+104|0);k1a(a+168|0,b+112|0);k1a(a+180|0,b+120|0);i=b;return}function k1a(a,b){a=a|0;b=b|0;b=i;l1a(a,0);i=b;return}function l1a(a,b){a=a|0;b=b|0;b=i;i=i+8|0;m1a(a,b);i=b;return}function m1a(a,b){a=a|0;b=b|0;b=i;n1a(a,0);i=b;return}function n1a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;o1a(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;p1a(f,0,e);e=kZa(b)|0;c[(jZa(b)|0)>>2]=e;i=d;return}function o1a(a){a=a|0;var b=0;b=i;s1a(a);i=b;return}function p1a(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;q1a(b,c,f);i=e;return}function q1a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(lVa(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;r1a(d,b,f);i=e;return}function r1a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(lVa(e)|0)>>2];i=d;return}function s1a(a){a=a|0;var b=0;b=i;t1a(a);i=b;return}function t1a(a){a=a|0;var b=0;b=i;oVa(a);i=b;return}function u1a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[175380>>2]|0;if((m|0)==0){n=0}else{o=Dfb(12)|0;m5a(o,m);n=o}if((c[175296>>2]|0)!=0){c[29546]=1}if((n|0)==0){c[118196>>2]=1;c[118200>>2]=1;i=b;return}do{if((Q5a(n,165568,0)|0)==-1){i5a(g,n);g5a(h);o=c[29120]|0;m=(o|0)<28;while(1){p=Q5a(g,165576,0)|0;q=(p|0)!=-1;if(q){O5a(j,g,0,p);t5a(h,j)|0;s5a(j);O5a(k,g,p+1|0,-1);t5a(g,k)|0;s5a(k)}else{t5a(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){m5a(l,c[116896+(s<<2)>>2]|0);p=v1a(h,l)|0;s5a(l);if(p){c[118192+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){UMa(1,1,165584,f);if(m){v=o}else{w=118744;x=c[29686]|0;fe[x&511](1);y=P5a(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=165624;E=D;WMa(0,E,a)}do{p=c[118064+(v<<2)>>2]|0;c[e>>2]=c[116896+(v<<2)>>2];c[e+4>>2]=p;UMa(1,0,165608,e);v=v+1|0;}while((v|0)<28);w=118744;x=c[29686]|0;fe[x&511](1);y=P5a(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=165624;E=D;WMa(0,E,a)}else if((t|0)==20){UMa(1,1,165584,d);w=118744;x=c[29686]|0;fe[x&511](1);y=P5a(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=165624;E=D;WMa(0,E,a)}else if((t|0)==23){s5a(h);s5a(g);break}}else{o=1;do{c[118192+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[118196>>2]=1;c[118200>>2]=1;if((c[118228>>2]|0)!=0){c[118288>>2]=1}if((c[118284>>2]|0)==1){c[118292>>2]=1}if((c[118264>>2]|0)!=0){c[118260>>2]=1}if((c[118272>>2]|0)!=0){c[118260>>2]=1}if((c[118224>>2]|0)!=0){c[118220>>2]=1}if((c[118268>>2]|0)!=0){c[118260>>2]=1}if((c[118216>>2]|0)!=0){c[118212>>2]=1}s5a(n);Ffb(n);i=b;return}function v1a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=q5a(b)|0;if((e|0)!=(q5a(c)|0)){f=0;i=d;return f|0}g=r5a(b)|0;h=r5a(c)|0;if(j5a(b)|0){f=(QWa(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function w1a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[175388>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=Dfb(12)|0;l=k;m5a(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(x1a(l,c[150664+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=P5a(l)|0;UMa(1,1,165656,g);g=c[150748>>2]|0;c[f>>2]=c[150668>>2];c[f+4>>2]=g;UMa(1,0,165608,f);f=c[150752>>2]|0;c[e>>2]=c[150672>>2];c[e+4>>2]=f;UMa(1,0,165608,e);e=c[150756>>2]|0;c[d>>2]=c[150676>>2];c[d+4>>2]=e;UMa(1,0,165608,d);fe[c[29686]&511](1);WMa(0,165712,a)}else if((n|0)==6){i=b;return j|0}return 0}function x1a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(S5a(a,b)|0)==0;i=c;return d|0}function y1a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[175372>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=Dfb(12)|0;l=k;m5a(l,h);if((k|0)==0){j=1;i=b;return j|0}m5a(f,165736);k=v1a(l,f)|0;s5a(f);if(k){j=1;i=b;return j|0}m5a(g,165744);k=v1a(l,g)|0;s5a(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=P5a(l)|0;UMa(1,1,165752,e);c[d>>2]=165736;c[d+4>>2]=165808;UMa(1,0,165608,d);c[a>>2]=165744;c[a+4>>2]=165824;UMa(1,0,165608,a);fe[c[29686]&511](1);WMa(0,165712,b)}return 0}function z1a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;B7a(f,a);if(!(E7a(f)|0)){C7a(f);i=d;return a|0}j=YWa(b)|0;N1a(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((NSa(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=m6a(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];Q1a(h,e,b,m,k,l,n);if(!(O1a(h)|0)){C7a(f);i=d;return a|0}g6a(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);C7a(f);i=d;return a|0}function A1a(a){a=a|0;var b=0;b=i;H7a(a,n6a(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;o7a(a)|0;i=b;return a|0}function B1a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;m5a(h,d);b6a(k,165832,h);jWa(j,k,165840);s5a(k);k=P5a(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((Xfb(c[n+4>>2]|0,165848)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((Xfb(k,165856)|0)==0){s5a(j);s5a(h);i=f;return}d=Feb(g,k,1)|0;if((d|0)!=0){m=l;dgb(m|0,0,2048)|0;Seb(d,g,m,2048)|0;F7a(z1a(z1a(z1a(z1a(z1a(187776,165864)|0,k)|0,165904)|0,m)|0,165920)|0,103)|0;s5a(j);s5a(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(Teb(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==0){r=(Teb(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==1){q=(Teb(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){d=b+4|0;m=o;o=0;while(1){p=c[d>>2]|0;if((a[p+(o*60|0)+56|0]|0)==0){l=(Teb(g,c[p+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(o*60|0)+56|0]=l;s=c[k>>2]|0}else{s=m}l=o+1|0;if((l|0)<(s|0)){m=s;o=l}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;m=b+4|0;k=(e|0)==0;d=b+20|0;l=0;do{p=c[s>>2]|0;do{if((a[p+(l*52|0)+48|0]|0)==0){n=a[p+(l*52|0)+8|0]|0;if(n<<24>>24==1){q=(Teb(g,c[p+(l*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(l*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(l*52|0)+48|0]|0)!=0|k){break}a[(c[d>>2]|0)+((c[q+(l*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==0){n=(Teb(g,c[p+(l*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(l*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(l*52|0)+48|0]|0)!=0){break}a[(c[m>>2]|0)+((c[n+(l*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);l=l+1|0;}while((l|0)<(c[o>>2]|0))}o=b+120|0;l=c[o>>2]|0;if((l|0)>0){m=b+8|0;s=l;l=0;while(1){d=c[m>>2]|0;if((a[d+(l*48|0)+44|0]|0)==0){k=(Teb(g,c[d+(l*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[m>>2]|0)+(l*48|0)+44|0]=k;t=c[o>>2]|0}else{t=s}k=l+1|0;if((k|0)<(t|0)){s=t;l=k}else{break}}}l=b+216|0;if((c[l>>2]|0)>0){t=b+40|0;s=b+8|0;o=(e|0)==0;m=b+24|0;k=0;do{d=c[t>>2]|0;do{if((a[d+(k*52|0)+48|0]|0)==0){p=a[d+(k*52|0)+8|0]|0;if(p<<24>>24==0){n=(Teb(g,c[d+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(k*52|0)+48|0]|0)!=0){break}a[(c[s>>2]|0)+((c[n+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(p<<24>>24==1){p=(Teb(g,c[d+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=p;p=c[t>>2]|0;if((a[p+(k*52|0)+48|0]|0)!=0|o){break}a[(c[m>>2]|0)+((c[p+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);k=k+1|0;}while((k|0)<(c[l>>2]|0))}l=b+124|0;k=c[l>>2]|0;if((k|0)>0){m=b+12|0;o=k;k=0;while(1){t=c[m>>2]|0;if((a[t+(k*52|0)+48|0]|0)==0){s=(Teb(g,c[t+(k*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[m>>2]|0)+(k*52|0)+48|0]=s;u=c[l>>2]|0}else{u=o}s=k+1|0;if((s|0)<(u|0)){o=u;k=s}else{break}}}k=b+220|0;if((c[k>>2]|0)>0){u=b+44|0;o=b+12|0;l=(e|0)==0;e=b+28|0;b=0;do{m=c[u>>2]|0;do{if((a[m+(b*52|0)+48|0]|0)==0){s=a[m+(b*52|0)+8|0]|0;if(s<<24>>24==1){t=(Teb(g,c[m+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=t;t=c[u>>2]|0;if((a[t+(b*52|0)+48|0]|0)!=0|l){break}a[(c[e>>2]|0)+((c[t+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(s<<24>>24==0){s=(Teb(g,c[m+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=s;s=c[u>>2]|0;if((a[s+(b*52|0)+48|0]|0)!=0){break}a[(c[o>>2]|0)+((c[s+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[k>>2]|0))}Jeb(g);s5a(j);s5a(h);i=f;return}function C1a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[175236>>2]|0;H=c[175364>>2]|0;I=c[2]|0;if((c[118292>>2]|0)==0){if(!((c[175184>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Bb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;SMa(23,0,165968,l);l=c[175308>>2]|0;do{if((l|0)==0){M=0}else{if((Xfb(l,165992)|0)==0){M=1;break}if((Xfb(l,166e3)|0)==0){M=0;break}if((Xfb(l,166008)|0)==0){M=2;break}c[j>>2]=l;UMa(1,0,166016,j);M=0}}while(0);if((hOa(M)|0)!=0){c[g>>2]=l;UMa(1,0,166088,g)}if((c[2]|0)!=0){M2a(d+56|0);mOa((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);iOa(0);iOa(6);jOa(3);jOa(4);jOa(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+Tfb(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];SMa(1,0,166176,f)}do{if((c[175292>>2]|0)!=0){f=Dfb(12)|0;J=f;m5a(J,c[175420>>2]|0);if((f|0)==0){break}f=P5a(J)|0;c[d+280>>2]=f;c[e>>2]=f;SMa(23,0,166232,e)}}while(0);e=c[175416>>2]|0;g5a(m);if((e|0)==0){m5a(p,c[d+88>>2]|0);m5a(q,166280);D1a(o,p,q);jWa(n,o,c[d+284>>2]|0);t5a(m,n)|0;s5a(n);s5a(o);s5a(q);s5a(p)}else{u5a(m,e)|0}m5a(r,166288);m5a(s,166288);m5a(t,166288);m5a(u,166288);m5a(v,166288);m5a(w,166288);e=c[175184>>2]|0;if((c[175204>>2]|0)!=0){u5a(r,c[175332>>2]|0)|0}if((c[175220>>2]|0)!=0){u5a(s,c[175348>>2]|0)|0}if((c[175200>>2]|0)!=0){u5a(t,c[175328>>2]|0)|0}if((c[175208>>2]|0)==0){O=0.0}else{u5a(u,c[175336>>2]|0)|0;O=+Tfb(P5a(u)|0)}if((c[175212>>2]|0)==0){P=1}else{u5a(v,c[175340>>2]|0)|0;P=Fc(P5a(v)|0)|0}if((c[175272>>2]|0)!=0){u5a(w,c[175400>>2]|0)|0}i5a(x,m);i5a(y,r);i5a(z,s);i5a(A,t);i5a(B,w);p=E1a(d,x,y,z,A,O,P,B,e)|0;s5a(B);s5a(A);s5a(z);s5a(y);s5a(x);if((p|0)!=0|g^1){Q=p}else{iOa(5);p=b2a(d)|0;lOa(5);SMa(1,0,166296,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;s5a(w);s5a(v);s5a(u);s5a(t);s5a(s);s5a(r);s5a(m);i=b;return R|0}Q=d+88|0;m5a(D,c[Q>>2]|0);jWa(C,D,166328);s5a(D);m5a(F,c[Q>>2]|0);jWa(E,F,166344);s5a(F);lOa(0);F=c[175384>>2]|0;Q=P5a(C)|0;D=P5a(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;A2a(d,Q,D,(F|0)!=0?F:166360,I,p,P5a(m)|0)|0;s5a(E);s5a(C);R=0;s5a(w);s5a(v);s5a(u);s5a(t);s5a(s);s5a(r);s5a(m);i=b;return R|0}function D1a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;h5a(a,d);e=q5a(b)|0;f=q5a(c)|0;T5a(a,r5a(b)|0,e,f+e|0);L5a(a,r5a(c)|0,f)|0;i=d;return}function E1a(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((q5a(j)|0)==0){u=0}else{u=P5a(j)|0}i5a(r,b);b=(F1a(a,r,k)|0)==0;s5a(r);if(!b){v=-1;i=l;return v|0}m5a(s,166288);b=a+280|0;r=x1a(s,c[b>>2]|0)|0;s5a(s);do{if(r){w=3}else{s=1;k=0;do{m5a(t,c[166504+(s<<2)>>2]|0);j=x1a(t,c[b>>2]|0)|0;s5a(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];UMa(1,0,166584,q);UMa(1,0,165584,p);s=1;do{j=c[166616+(s<<2)>>2]|0;c[o>>2]=c[166504+(s<<2)>>2];c[o+4>>2]=j;UMa(1,0,165608,o);s=s+1|0;}while((s|0)<20);WMa(c[a+536>>2]|0,165712,n)}}while(0);c[m>>2]=c[166504+(w<<2)>>2];SMa(23,0,166696,m);m=P5a(d)|0;d=P5a(e)|0;e=aRa(a,m,d,P5a(f)|0,g,h,w,u)|0;ge[c[159948>>2]&127](159920,a);v=e;i=l;return v|0}function F1a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[39980]=Ad(P5a(b)|0)|0;c[159924>>2]=g;c[159928>>2]=d;d=a+284|0;do{if((c[41390]|0)==0){g=c[d>>2]|0;if((Xfb(166368,g)|0)==0){h=0;break}if((Xfb(166376,g)|0)==0){c[159936>>2]=94;c[159940>>2]=95;c[159948>>2]=96;h=0;break}if((Xfb(166384,g)|0)==0){c[159936>>2]=97;c[159940>>2]=98;c[159944>>2]=99;c[159948>>2]=100;h=1;break}if((Xfb(166392,g)|0)==0){c[159936>>2]=101;c[159940>>2]=102;c[159944>>2]=103;c[159948>>2]=104;h=1;break}if((Xfb(166400,g)|0)==0){c[159936>>2]=105;c[159940>>2]=106;c[159948>>2]=107;h=0;break}g=z1a(187776,166408)|0;F7a(z1a(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);B1a(a+8|0,c[a+288>>2]|0,h);ge[c[159936>>2]&127](159920,a);a=c[39980]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;SMa(23,0,166432,f);j=0;i=e;return j|0}function G1a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;JMa();do{if((U2a(a,b)|0)==0){if((W2a(a,b)|0)!=0){break}do{if((c[175240>>2]|0)!=0){w=c[175368>>2]|0;if((Xfb(w,166816)|0)==0){PMa(1);break}if((Xfb(w,166824)|0)==0){PMa(0);break}else{c[p>>2]=w;UMa(1,0,166832,p);ud(0)|0;Cd(0)}}}while(0);if((c[175196>>2]|0)==0){u1a(0,0);XPa(d);if((d|0)==0){F7a(z1a(187776,167200)|0,103)|0}c[d+300>>2]=w1a(0,0)|0;c[d+292>>2]=y1a(0,0)|0;gWa(d+8|0,d+240|0);gQa(d)|0;oQa(d)|0;AQa(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}F7a(z1a(187776,167264)|0,103)|0;x=1;i=e;return x|0}}while(0);c[41390]=c[175264>>2];x=0;i=e;return x|0}m5a(u,c[175324>>2]|0);w=1;while(1){y=123208+(w<<2)|0;m5a(v,c[y>>2]|0);z=v1a(u,v)|0;s5a(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=P5a(u)|0;UMa(1,0,167104,g);c[f>>2]=c[b>>2];UMa(1,0,167144,f);ud(0)|0;Cd(0)}A=c[127232+(w<<2)>>2]|0;do{if((A|0)==1){z=c[127104+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;SMa(1,1,166904,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[127104+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;SMa(1,1,166944,n);break}else{c[m>>2]=z;UMa(1,1,166784,m);break}}}while(0);if((w|0)==29){A=1;do{z=c[166616+(A<<2)>>2]|0;c[h>>2]=c[166504+(A<<2)>>2];c[h+4>>2]=z;SMa(1,0,165608,h);A=A+1|0;}while((A|0)<20);D=118744;E=c[29686]|0;fe[E&511](1);F=ud(0)|0;Cd(0)}else if((w|0)==11){A=1;do{z=c[167072+(A<<2)>>2]|0;c[j>>2]=c[167040+(A<<2)>>2];c[j+4>>2]=z;SMa(1,0,165608,j);A=A+1|0;}while((A|0)<7);D=118744;E=c[29686]|0;fe[E&511](1);F=ud(0)|0;Cd(0)}else if((w|0)==7){A=1;do{z=c[167024+(A<<2)>>2]|0;c[k>>2]=c[167008+(A<<2)>>2];c[k+4>>2]=z;SMa(1,0,165608,k);A=A+1|0;}while((A|0)<4);D=118744;E=c[29686]|0;fe[E&511](1);F=ud(0)|0;Cd(0)}else if((w|0)==19){A=c[29120]|0;if((A|0)<28){G=A}else{D=118744;E=c[29686]|0;fe[E&511](1);F=ud(0)|0;Cd(0)}do{A=c[118064+(G<<2)>>2]|0;c[l>>2]=c[116896+(G<<2)>>2];c[l+4>>2]=A;SMa(1,0,165608,l);G=G+1|0;}while((G|0)<28);D=118744;E=c[29686]|0;fe[E&511](1);F=ud(0)|0;Cd(0)}else{D=118744;E=c[29686]|0;fe[E&511](1);F=ud(0)|0;Cd(0)}}}while(0);c[t>>2]=c[b>>2];SMa(1,1,166720,t);t=1;do{b=c[127232+(t<<2)>>2]|0;do{if((b|0)==1){F=c[125112+(t<<2)>>2]|0;c[s>>2]=c[123208+(t<<2)>>2];c[s+4>>2]=F;SMa(1,0,166736,s)}else{F=c[123208+(t<<2)>>2]|0;if((b|0)==2){E=c[125112+(t<<2)>>2]|0;c[r>>2]=F;c[r+4>>2]=F;c[r+8>>2]=E;SMa(1,0,166752,r);break}else{c[q>>2]=F;UMa(1,0,166784,q);break}}}while(0);t=t+1|0;}while((t|0)<31);fe[c[29686]&511](1);ud(0)|0;Cd(0);return 0}function H1a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[41824]|0;tb(168896)|0;c[l>>2]=c[m+88>>2];gc(167304,l|0)|0;tb(168912)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];gc(167328,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];gc(167368,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];gc(167400,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];gc(167432,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];gc(167464,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];gc(167496,b|0)|0;tb(168936)|0;i=a;return}function I1a(a,b){a=a|0;b=+b;i=i;return}function J1a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;_fb(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=mgb(c[g>>2]|0,f)|0;if((k|0)==0){eb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(41,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=mgb(c[g>>2]|0,f)|0;if((m|0)==0){eb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[41824]=d;u=0;Ha(61,10,441)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=mgb(c[k>>2]|0,f)|0;if((p|0)==0){eb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(42,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=mgb(c[g>>2]|0,f)|0;if((q|0)==0){eb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=mgb(c[g>>2]|0,f)|0;if((r|0)==0){eb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=mgb(c[g>>2]|0,f)|0;if((s|0)==0){eb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=mgb(c[g>>2]|0,f)|0;if((t|0)==0){eb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=mgb(c[g>>2]|0,f)|0;if((w|0)==0){eb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(442,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=mgb(c[g>>2]|0,f)|0;if((x|0)==0){eb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=mgb(c[g>>2]|0,f)|0;if((y|0)==0){eb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=mgb(c[k>>2]|0,f)|0;if((A|0)==0){eb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function K1a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=md(c[28998]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 2:{if((c[118204>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1)}c[f>>2]=e;a=c[r>>2]|0;rc(167584,7,1,a|0)|0;Dc(a|0,d|0,f|0)|0;Sd(10,a|0)|0;ud(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1);break};case 3:{if((c[118260>>2]|0)==0){i=b;return}c[f>>2]=e;n=c[r>>2]|0;rc(167584,7,1,n|0)|0;Dc(n|0,d|0,f|0)|0;Sd(10,n|0)|0;ud(0)|0;i=b;return};case 1:{c[f>>2]=e;e=c[r>>2]|0;rc(167584,7,1,e|0)|0;Dc(e|0,d|0,f|0)|0;Sd(10,e|0)|0;ud(0)|0;eb(c[g+80>>2]|0,1);break};case 5:case 4:{i=b;return};default:{WMa(g,167592,b)}}}function L1a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;rc(167568,9,1,d|0)|0;Dc(d|0,b|0,e|0)|0;Sd(10,d|0)|0;ud(0)|0;i=a;return}function M1a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[41380]=1;T1a(b,f);f=a;a=165528;c[a+0>>2]=c[f+0>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];c[a+16>>2]=c[f+16>>2];c[a+20>>2]=c[f+20>>2];i=e;return}function N1a(a,b){a=a|0;b=b|0;var c=0;c=i;P1a(a,b);i=c;return}function O1a(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function P1a(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=l6a(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function Q1a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;JSa(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=R1a(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((x6a(b,d,r)|0)==(r|0)){break}JSa(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){n5a(l,s,h);if((x6a(b,r5a(l)|0,s)|0)==(s|0)){s5a(l);break}JSa(m);c[o>>2]=0;c[a>>2]=0;s5a(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((x6a(b,e,l)|0)==(l|0)){break}JSa(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);S1a(g,0)|0;c[a>>2]=b;i=j;return}function R1a(a){a=a|0;i=i;return c[a+12>>2]|0}function S1a(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function T1a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=d+8|0;g=c[41388]|0;if((g|0)==0){c[e>>2]=($fb(a|0)|0)<<1|1;c[f>>2]=2048;h=c[(ZWa(e,f)|0)>>2]|0;c[41890]=h;f=xfb(h)|0;c[41388]=f;j=h;k=f}else{j=c[41890]|0;k=g}g=Zc(k|0,j|0,a|0,b|0)|0;if(g>>>0<(c[41890]|0)>>>0){i=d;return}yfb(c[41388]|0);j=g<<1|1;c[41890]=j;g=xfb(j)|0;c[41388]=g;Zc(g|0,j|0,a|0,b|0)|0;i=d;return}function U1a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;V1a(g,16);W1a(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){X1a(a,g);Y1a(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){z1a(G7a(m,+h[b+(p<<3)>>3])|0,168952)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){G7a(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){z1a(m,168960)|0}}while((e|0)<(d|0));X1a(a,g);Y1a(g);i=f;return}function V1a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;p6a(e);f=a;c[f>>2]=169332;g=e;c[g>>2]=169352;e=a+4|0;w7a(a,169364|0,e);c[f>>2]=169332;c[g>>2]=169352;i2a(e,b|16);i=d;return}function W1a(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function X1a(a,b){a=a|0;b=b|0;var c=0;c=i;c2a(a,b+4|0);i=c;return}function Y1a(a){a=a|0;var b=0;b=i;m2a(a,169360);k6a(a+56|0);i=b;return}function Z1a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[118248>>2]|0)!=0){tb(169656)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];SMa(14,0,168968,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ie[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];SMa(14,0,169040,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[118248>>2]|0)==0){i=d;return 0}SMa(14,0,169088,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(169104,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function _1a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[118248>>2]|0)!=0){tb(169656)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];SMa(14,0,168968,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ie[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];SMa(14,0,169040,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[118248>>2]|0)==0){i=d;return 0}SMa(14,0,169088,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(169104,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function $1a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[118248>>2]|0)!=0){tb(169656)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];SMa(14,0,168968,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ie[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];SMa(14,0,169040,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[118248>>2]|0)==0){i=d;return 0}SMa(14,0,169088,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(169104,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function a2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[118248>>2]|0)!=0){tb(169656)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];SMa(14,0,168968,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ie[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];SMa(14,0,169040,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[118248>>2]|0)==0){i=d;return 0}SMa(14,0,169088,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(169104,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function b2a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=zfb(fa(F,F)|0,8)|0;J=I;K=zfb(fa(G,F)|0,8)|0;L=K;M=zfb(fa(H,F)|0,8)|0;N=M;O=zfb(fa(H,G)|0,8)|0;P=O;g5a(p);g5a(q);g5a(r);g5a(s);g5a(t);g5a(u);g5a(v);Q=a+536|0;VMa(c[Q>>2]|0,(I|0)!=0|0,169112,o);VMa(c[Q>>2]|0,(K|0)!=0|0,169112,n);VMa(c[Q>>2]|0,(M|0)!=0|0,169112,m);VMa(c[Q>>2]|0,(O|0)!=0|0,169112,l);l=a+540|0;m=a;if((ie[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;Z1a(a,J)|0;VMa(n,1,169128,k)}U1a(w,J,F,F);t5a(p,w)|0;s5a(w);if((ie[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;_1a(a,L)|0;VMa(w,1,169160,j)}U1a(x,L,F,G);t5a(q,x)|0;s5a(x);if((ie[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;$1a(a,N)|0;VMa(x,1,169192,h)}U1a(y,N,H,F);t5a(r,y)|0;s5a(y);if((ie[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;a2a(a,P)|0;VMa(m,1,169224,g)}U1a(z,P,H,G);t5a(s,z)|0;s5a(z);if((F|0)==0){u5a(t,169256)|0}else{U1a(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);t5a(t,A)|0;s5a(A)}if((G|0)==0){u5a(u,169256)|0}else{U1a(B,c[a+432>>2]|0,1,G);t5a(u,B)|0;s5a(B)}yfb(I);yfb(K);yfb(M);yfb(O);m5a(E,c[a+84>>2]|0);b6a(D,169272,E);jWa(C,D,169280);t5a(v,C)|0;s5a(C);s5a(D);s5a(E);E=ic(P5a(v)|0,169288)|0;D=c[Q>>2]|0;c[f>>2]=P5a(v)|0;VMa(D,(E|0)!=0|0,169296,f);f=Ce[c[(c[l>>2]|0)+176>>2]&7]()|0;D=P5a(t)|0;Q=P5a(u)|0;C=P5a(p)|0;a=P5a(q)|0;O=P5a(r)|0;M=P5a(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;wd(E|0,f|0,e|0)|0;if((c[118292>>2]|0)==0){R=ud(E|0)|0;S=Yc(E|0)|0;s5a(v);s5a(u);s5a(t);s5a(s);s5a(r);s5a(q);s5a(p);i=b;return 0}e=Ce[c[(c[l>>2]|0)+176>>2]&7]()|0;l=P5a(t)|0;f=P5a(u)|0;M=P5a(p)|0;O=P5a(q)|0;a=P5a(r)|0;C=P5a(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;SMa(25,0,e,d);R=ud(E|0)|0;S=Yc(E|0)|0;s5a(v);s5a(u);s5a(t);s5a(s);s5a(r);s5a(q);s5a(p);i=b;return 0}function c2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=F6a(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}d2a(a,E6a(l)|0,n,e);i=d;return}if((h&8|0)==0){h5a(a,g);i=d;return}else{g=b;b=z6a(g)|0;d2a(a,b,B6a(g)|0,f);i=d;return}}function d2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;e2a(a,b,c,0);i=d;return}function e2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;f2a(a,b,c);i=d;return}function f2a(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=g2a(c,d)|0;if(g>>>0>4294967279){e5a(0)}if(g>>>0<11){y5a(b,g);h=x5a(b)|0}else{j=F5a(g)|0;k=j+1|0;j=VWa(l5a(b)|0,k)|0;H5a(b,j);G5a(b,k);w5a(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;WWa(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){WWa(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;WWa(l,f);i=e;return}function g2a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=h2a(b,c,e)|0;i=d;return g|0}function h2a(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function i2a(a,b){a=a|0;b=b|0;var c=0;c=i;y2a(a,b);i=c;return}function j2a(a){a=a|0;var b=0;b=i;Y1a(a);Ffb(a);i=b;return}function k2a(a){a=a|0;var b=0;b=i;Y1a(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function l2a(a){a=a|0;var b=0;b=i;j2a(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function m2a(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];n2a(a+4|0);i=d;return}function n2a(a){a=a|0;var b=0;b=i;o2a(a);i=b;return}function o2a(a){a=a|0;var b=0;b=i;c[a>>2]=169512;s5a(a+32|0);t6a(a);i=b;return}function p2a(a){a=a|0;var b=0;b=i;n2a(a);Ffb(a);i=b;return}function q2a(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=F6a(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==24){if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}XRa(a,-1,-1);i=h;return}else if((k|0)==0){XRa(a,-1,-1);i=h;return}else{if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}if((g&8|0)==0){m=F6a(l)|0;j=m-(E6a(l)|0)|0;p=j;q=((j|0)<0)<<31>>31;break}else{j=A6a(l)|0;m=j-(z6a(l)|0)|0;p=m;q=((m|0)<0)<<31>>31;break}}}while(0);if((o|0)==11){f=n-(r5a(b+32|0)|0)|0;p=f;q=((f|0)<0)<<31>>31}else if((o|0)==12){XRa(a,-1,-1);i=h;return}o=jgb(p|0,q|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&o>>>0<0)){d=n-(r5a(b+32|0)|0)|0;q=((d|0)<0)<<31>>31;if((q|0)<(e|0)|(q|0)==(e|0)&d>>>0<o>>>0){break}d=g&8;do{if(!((o|0)==0&(e|0)==0)){do{if((d|0)!=0){if((A6a(l)|0)!=0){break}XRa(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((F6a(l)|0)!=0){break}XRa(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){q=z6a(l)|0;D6a(l,q,q+o|0,n)}if((g&16|0)!=0){q=E6a(l)|0;I6a(l,q,G6a(l)|0);H6a(l,o)}XRa(a,o,e);i=h;return}}while(0);XRa(a,-1,-1);i=h;return}function r2a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=jTa(d)|0;re[g&31](a,b,h,J,0,e);i=f;return}function s2a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=F6a(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((B6a(g)|0)>>>0<j>>>0){b=z6a(g)|0;D6a(g,b,A6a(g)|0,j)}j=A6a(g)|0;if(!(j>>>0<(B6a(g)|0)>>>0)){k=-1;i=d;return k|0}k=HTa(a[j]|0)|0;i=d;return k|0}function t2a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=F6a(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=z6a(h)|0;j=A6a(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(DTa(d,-1)|0){D6a(h,g,j+ -1|0,k);l=GTa(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=ETa(d)|0;do{if(g){if(ITa(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=z6a(h)|0;D6a(h,j,(A6a(h)|0)+ -1|0,k);a[A6a(h)|0]=b;l=d;i=e;return l|0}function u2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(DTa(b,-1)|0){f=GTa(b)|0;i=d;return f|0}g=a;h=A6a(g)|0;j=h-(z6a(g)|0)|0;h=F6a(g)|0;do{if((h|0)==(G6a(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=E6a(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;K5a(o,0);D5a(o,A5a(o)|0);p=r5a(o)|0;I6a(g,p,p+(q5a(o)|0)|0);H6a(g,h-l|0);c[m>>2]=(E6a(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(F6a(g)|0)+1;h=c[(v2a(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=r5a(a+32|0)|0;D6a(g,q,q+j|0,h)}f=w6a(g,b&255)|0;i=d;return f|0}function v2a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=w2a(b,c,e)|0;i=d;return g|0}function w2a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=x2a(0,a,b)|0;i=c;return(d?b:a)|0}function x2a(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function y2a(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;y6a(a);c[a>>2]=169512;g5a(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;g5a(e);z2a(a,e);s5a(e);i=d;return}function z2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;t5a(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=r5a(e)|0;j=g+(q5a(e)|0)|0;c[b>>2]=j;g=r5a(e)|0;D6a(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=q5a(e)|0;c[b>>2]=(r5a(e)|0)+h;D5a(e,A5a(e)|0);b=a;a=r5a(e)|0;I6a(b,a,a+(q5a(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}H6a(b,h);i=d;return}function A2a(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=ic(d|0,169936)|0;J=bd(169944,169936)|0;K=(J|0)!=0;L=Nc()|0;if(K){M=c[b+536>>2]|0;N=Wd(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;VMa(M,(I|0)!=0|0,17e4,E);rc(170024,17,1,J|0)|0;rc(170048,10,1,J|0)|0;rc(170064,18,1,J|0)|0;B2a(J,f,170088,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,170120)}else{c[G>>2]=Wd(c[L>>2]|0)|0;UMa(26,0,169952,G);G=c[b+536>>2]|0;E=Wd(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;VMa(G,(I|0)!=0|0,17e4,F)}rc(170128,348,1,I|0)|0;if((sc(H|0)|0)<0){c[D>>2]=Wd(c[L>>2]|0)|0;UMa(26,0,170480,D);Yc(I|0)|0;ab(J|0)|0;O=1;i=j;return O|0}if((Sc(169680,250,170504,kd(H|0)|0)|0)==0){UMa(26,0,170528,C);Yc(I|0)|0;O=1;i=j;return O|0}rc(170552,13,1,I|0)|0;rc(170568,12,1,I|0)|0;C2a(I,2);rc(170584,6,1,I|0)|0;D2a(I,c[b+84>>2]|0);rc(170592,8,1,I|0)|0;C2a(I,2);rc(170608,8,1,I|0)|0;C=b+88|0;D2a(I,c[C>>2]|0);rc(170624,10,1,I|0)|0;C2a(I,2);rc(170640,6,1,I|0)|0;D2a(I,169680);rc(170648,8,1,I|0)|0;C2a(I,2);rc(170664,8,1,I|0)|0;D2a(I,c[b+280>>2]|0);rc(170680,10,1,I|0)|0;C2a(I,2);rc(170696,14,1,I|0)|0;D2a(I,c[b+284>>2]|0);rc(170712,16,1,I|0)|0;C2a(I,2);rc(170736,16,1,I|0)|0;D2a(I,l);rc(170760,18,1,I|0)|0;C2a(I,2);c[B>>2]=E2a(l)|0;wd(I|0,170784,B|0)|0;C2a(I,2);P=+dOa(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];wd(I|0,170824,A|0)|0;C2a(I,2);P=+dOa(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];wd(I|0,170864,z|0)|0;C2a(I,2);P=+dOa(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];wd(I|0,170896,y|0)|0;C2a(I,2);P=+dOa(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];wd(I|0,170928,x|0)|0;C2a(I,2);P=+dOa(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];wd(I|0,170960,w|0)|0;C2a(I,2);P=+dOa(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];wd(I|0,170992,v|0)|0;C2a(I,2);P=+dOa(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];wd(I|0,171032,u|0)|0;C2a(I,2);P=+gOa(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];wd(I|0,171064,t|0)|0;C2a(I,2);c[s>>2]=bOa(2)|0;wd(I|0,171104,s|0)|0;C2a(I,2);P=+fOa(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];wd(I|0,171128,r|0)|0;rc(171160,13,1,I|0)|0;rc(171176,16,1,I|0)|0;C2a(I,2);P=+dOa(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];wd(I|0,171200,q|0)|0;C2a(I,2);c[p>>2]=_Na(8)|0;wd(I|0,171224,p|0)|0;rc(171264,17,1,I|0)|0;rc(171288,22,1,I|0)|0;F2a(I,b);rc(171312,23,1,I|0)|0;rc(171336,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{G2a(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{G2a(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{G2a(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{G2a(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{G2a(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{G2a(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{G2a(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{G2a(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}rc(171352,13,1,I|0)|0;rc(171368,12,1,I|0)|0;H2a(I,J,f,c[C>>2]|0,b);rc(171384,13,1,I|0)|0;rc(171400,12,1,I|0)|0;I2a(I,c[b+68>>2]|0,b+56|0);rc(171416,13,1,I|0)|0;rc(171432,16,1,I|0)|0;J2a(I,J,f,b);rc(171456,17,1,I|0)|0;rc(171480,14,1,I|0)|0;Yc(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=(($fb(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=($fb(K|0)|0)<<1}else{Q=0}I=xfb(b+Q|0)|0;if((I|0)==0){cb(171496,171504,404,171528)}if((ab(J|0)|0)!=0){UMa(26,0,171544,o)}if(e){e=c[C>>2]|0;c[n>>2]=171576;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;hc(I|0,171592,n|0)|0;if((rd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=171672|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;UMa(1,0,171704,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;SMa(1,0,171768,g);yfb(I);O=0;i=j;return O|0}function B2a(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=$Na(F)|0;H=aOa(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+fOa(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}rc(170024,17,1,a|0)|0;rc(172936,12,1,a|0)|0;rc(172952,12,1,a|0)|0;rc(172968,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;wd(a|0,172984,D|0)|0;rc(173024,10,1,a|0)|0;rc(173040,11,1,a|0)|0;rc(173056,11,1,a|0)|0;rc(173072,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];wd(a|0,173088,C|0)|0}else{rc(173112,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;wd(a|0,172712,B|0)|0;rc(173136,13,1,a|0)|0;if(E){rc(172952,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];wd(a|0,173152,A|0)|0}else{rc(173112,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;wd(a|0,173176,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;wd(a|0,172832,y|0)|0;rc(173224,10,1,a|0)|0;rc(173240,10,1,a|0)|0;rc(173224,10,1,a|0)|0;rc(173256,11,1,a|0)|0;c[x>>2]=b;wd(a|0,173272,x|0)|0;c[w>>2]=d;wd(a|0,173296,w|0)|0;rc(173312,33,1,a|0)|0;rc(173352,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;wd(a|0,173392,v|0)|0;rc(173072,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];wd(a|0,173088,u|0)|0}else{rc(173240,10,1,a|0)|0;rc(173224,10,1,a|0)|0;rc(173256,11,1,a|0)|0;c[t>>2]=b;wd(a|0,173272,t|0)|0;c[s>>2]=d;wd(a|0,173296,s|0)|0;rc(173312,33,1,a|0)|0;rc(173352,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;wd(a|0,173392,r|0)|0;rc(173072,10,1,a|0)|0;rc(173112,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;wd(a|0,172712,q|0)|0;rc(173136,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];wd(a|0,173152,p|0)|0}else{rc(173112,17,1,a|0)|0}rc(173424,32,1,a|0)|0;rc(173464,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;wd(a|0,173496,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;wd(a|0,172832,n|0)|0;i=m;return}function C2a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Sd(32,a|0)|0;}while((d|0)!=0);i=c;return}function D2a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==62){rc(172688,4,1,b|0)|0}else if((e|0)==39){rc(172696,6,1,b|0)|0}else if((e|0)==60){rc(172680,4,1,b|0)|0}else if((e|0)==34){rc(172704,6,1,b|0)|0}else{Sd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function E2a(a){a=a|0;var b=0,c=0,d=0;b=i;c=ic(a|0,172672)|0;if((c|0)==0){d=-1;i=b;return d|0}Wc(c|0,0,2)|0;a=yb(c|0)|0;Yc(c|0)|0;d=a;i=b;return d|0}function F2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=xfb(($fb(l|0)|0)+15|0)|0;c[f>>2]=l;hc(m|0,172400,f|0)|0;C2a(a,2);rc(172416,10,1,a|0)|0;D2a(a,m);rc(172432,12,1,a|0)|0;C2a(a,2);c[e>>2]=E2a(m)|0;wd(a|0,172448,e|0)|0;yfb(m);C2a(a,2);rc(172480,9,1,a|0)|0;C2a(a,4);rc(172496,22,1,a|0)|0;C2a(a,4);rc(172520,22,1,a|0)|0;C2a(a,4);rc(172544,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){L2a(g,m,n);o=c[l>>2]|0;C2a(a,4);rc(172576,8,1,a|0)|0;D2a(a,o);rc(172592,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{Q2a(h,m,l);g=c[n>>2]|0;C2a(a,4);rc(172576,8,1,a|0)|0;D2a(a,g);rc(172592,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{L2a(j,m,q);b=c[t>>2]|0;C2a(a,4);rc(172616,8,1,a|0)|0;D2a(a,b);rc(172632,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){C2a(a,2);v=172656;w=v;x=rc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{Q2a(k,m,s);e=c[u>>2]|0;C2a(a,4);rc(172616,8,1,a|0)|0;D2a(a,e);rc(172632,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));C2a(a,2);v=172656;w=v;x=rc(w|0,10,1,a|0)|0;i=d;return}function G2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;C2a(a,2);c[f>>2]=c[b>>2];wd(a|0,172336,f|0)|0;D2a(a,c[b+4>>2]|0);rc(172368,11,1,a|0)|0;D2a(a,c[b+8>>2]|0);rc(172040,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];K2a(a,4,e);C2a(a,2);rc(172384,12,1,a|0)|0;i=d;return}function H2a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{L2a(p,r,v);B2a(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,172152);w=v+9|0;jOa(w);C2a(a,2);c[o>>2]=c[f>>2];wd(a|0,172160,o|0)|0;C2a(a,4);rc(170584,6,1,a|0)|0;D2a(a,c[s>>2]|0);rc(170592,8,1,a|0)|0;C2a(a,4);c[n>>2]=bOa(w)|0;wd(a|0,171936,n|0)|0;C2a(a,4);x=+gOa(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];wd(a|0,171960,m|0)|0;C2a(a,4);x=+fOa(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];wd(a|0,171128,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];K2a(a,6,j);C2a(a,2);rc(172184,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function I2a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{C2a(a,2);P2a(l,d,x);c[j>>2]=c[q>>2];wd(a|0,172008,j|0)|0;P2a(m,d,x);D2a(a,c[r>>2]|0);rc(172040,3,1,a|0)|0;C2a(a,4);rc(172048,7,1,a|0)|0;P2a(n,d,x);if((c[s>>2]|0)>0){y=0;do{C2a(a,6);c[g>>2]=0;wd(a|0,172056,g|0)|0;y=y+1|0;P2a(n,d,x);}while((y|0)<(c[s>>2]|0))}C2a(a,4);rc(172080,8,1,a|0)|0;C2a(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;P2a(o,d,x);z=+dOa(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;P2a(p,d,x);A=_Na(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;wd(a|0,172096,f|0)|0;C2a(a,2);rc(172136,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function J2a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{Q2a(n,o,v-u|0);B2a(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,171888);q=v+9|0;jOa(q);C2a(a,2);rc(171896,15,1,a|0)|0;C2a(a,4);c[m>>2]=c[e>>2];wd(a|0,171912,m|0)|0;C2a(a,4);c[l>>2]=bOa(q)|0;wd(a|0,171936,l|0)|0;C2a(a,4);w=+gOa(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];wd(a|0,171960,j|0)|0;C2a(a,4);w=+fOa(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];wd(a|0,171128,g|0)|0;C2a(a,2);rc(171984,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function K2a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;C2a(a,b);rc(172200,16,1,a|0)|0;D2a(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?172304:172320;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;wd(a|0,172224,f|0)|0;i=e;return}function L2a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){M2a(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function M2a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=ic(c[o>>2]|0,173536)|0;if((p|0)!=0){q=p;break}p=Wd(c[(Nc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;WMa(0,173544,g)}else{q=0}}while(0);g=MHa(0)|0;if((g|0)==0){WMa(0,173576,f)}f=a+8|0;c[a+20>>2]=zfb(c[f>>2]|0,32)|0;p=a+12|0;o=zfb((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=173608;c[o+12>>2]=0;c[o+16>>2]=0;XHa(g,h);YHa(g,10,108);h=c[n>>2]|0;do{if((h|0)==0){o=j;dgb(o|0,0,1024)|0;while(1){r=sb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((ZHa(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=fIa(cIa(g)|0)|0;s=dIa(g)|0;Yc(q|0)|0;THa(g);r=c[a>>2]|0;c[e>>2]=173712;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;WMa(0,173648,e)}else if((t|0)==11){Yc(q|0)|0;break}}else{if((ZHa(g,h,$fb(h|0)|0,1)|0)!=0){break}s=fIa(cIa(g)|0)|0;o=dIa(g)|0;THa(g);r=c[n>>2]|0;c[d>>2]=173712;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;WMa(0,173752,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){cb(173816,173712,295,173856)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{cb(173880,173712,297,173856)}}function N2a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((Xfb(174288,b)|0)==0){if((Xfb(c[d>>2]|0,174296)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}VMa(0,p,174304,l);l=c[43536]|0;p=c[43590]|0;do{if((l|0)==0|(p|0)==0){c[43590]=32;a=xfb(1152)|0;c[43536]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[43590]=p<<1;a=Afb(l,p*72|0)|0;c[43536]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(T2a(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((Xfb(174368,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((Xfb(174376,u)|0)==0){c[43596]=Ad(c[t+4>>2]|0)|0}else{if((Xfb(174408,u)|0)==0){c[174388>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((Xfb(174424,u)|0)==0){c[174396>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((Xfb(174432,u)|0)==0){c[174392>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((Xfb(174448,u)|0)==0){c[174400>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((Xfb(174456,u)|0)!=0){v=23;break a}c[174404>>2]=(Xfb(c[t+4>>2]|0,174472)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];WMa(0,174480,k)}else if((v|0)==45){i=e;return}}if((Xfb(174128,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=173712;c[j+4>>2]=k;c[j+8>>2]=v;WMa(0,174512,j)}if((Xfb(174576,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=173712;c[h+4>>2]=j;WMa(0,174584,h)}h=Vb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=173712;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;WMa(0,174640,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=174704;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((Xfb(174072,b)|0)!=0){if((Xfb(174264,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=174808;m=Ad(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=174816;i=e;return}c[174092>>2]=0;c[174096>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((Xfb(m,174296)|0)==0){c[174092>>2]=Ad(c[b+4>>2]|0)|0}else{if((Xfb(m,174760)|0)!=0){break}c[174096>>2]=Ad(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[174092>>2]|0)==0){w=0;break}w=(c[174096>>2]|0)!=0|0}}while(0);VMa(0,w,174768,f);c[43522]=-1;f=174100|0;w=174384;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function O2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((Xfb(174072,b)|0)==0){o=e+0|0;p=174088|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));S2a(e);i=d;return}if((Xfb(174128,b)|0)==0){e=h+24|0;r=xfb((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=xfb(36)|0;t=s;o=s+0|0;p=(c[43536]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((Xfb(174152,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;Bd(e+(k*20|0)+8|0,174160,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((Xfb(174200,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;Bd(h+(k*20|0)+8|0,174216,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((Xfb(174264,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function P2a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){M2a(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function Q2a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){M2a(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;WMa(0,173920,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=6;n=m;o=174e3;p=o;WMa(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=6;n=m;o=174e3;p=o;WMa(0,p,f)}}function R2a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){yfb(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){yfb(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}yfb(k);c[d>>2]=0;i=b;return}function S2a(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=xfb(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=$fb(f|0)|0;c[e+64>>2]=k;k=c[43570]|0;do{if((k|0)==0){c[43570]=e;c[e+44>>2]=0;l=xfb(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){vc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=xfb(384)|0;c[l>>2]=n;if((n|0)==0){vc(-1)}else{dgb(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[43570]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[43570]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=$fb(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+($fb(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 1:{B=o;C=x;D=y;E=22;break};case 5:{F=o;G=y;E=18;break};case 9:{H=o;E=14;break};case 10:{I=o;E=13;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;I=z;E=13;break};case 6:{J=o;K=y;E=17;break};case 4:{L=o;M=y;E=19;break};case 7:{N=o;O=y;E=16;break};case 2:{P=o;Q=x;R=y;E=21;break};case 3:{S=o;T=x;U=y;E=20;break};case 8:{V=o;E=15;break};default:{W=o;X=x;Y=y}}if((E|0)==13){o=((d[A+9|0]|0)<<16)+I|0;c[p>>2]=o;H=o;E=14}if((E|0)==14){o=((d[A+8|0]|0)<<8)+H|0;c[p>>2]=o;V=o;E=15}if((E|0)==15){N=V;O=((d[A+7|0]|0)<<24)+y|0;E=16}if((E|0)==16){J=N;K=((d[A+6|0]|0)<<16)+O|0;E=17}if((E|0)==17){F=J;G=((d[A+5|0]|0)<<8)+K|0;E=18}if((E|0)==18){L=F;M=(d[A+4|0]|0)+G|0;E=19}if((E|0)==19){S=L;T=((d[A+3|0]|0)<<24)+x|0;U=M;E=20}if((E|0)==20){P=S;Q=((d[A+2|0]|0)<<16)+T|0;R=U;E=21}if((E|0)==21){B=P;C=((d[A+1|0]|0)<<8)+Q|0;D=R;E=22}if((E|0)==22){W=B;X=(d[A]|0)+C|0;Y=D}D=X-Y-W^W>>>13;X=Y-W-D^D<<8;Y=W-D-X^X>>>13;W=D-X-Y^Y>>>12;D=X-Y-W^W<<16;X=Y-W-D^D>>>5;Y=W-D-X^X>>>3;W=D-X-Y^Y<<10;D=X-Y-W^W>>>15;c[p>>2]=D;p=(c[43570]|0)+40|0;W=c[p>>2]|0;Y=D&(c[W+4>>2]|0)+ -1;D=c[W>>2]|0;W=D+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[D+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[43570]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[43570]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=xfb((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){vc(-1)}dgb(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;D=c[j>>2]|0;c[Y+24>>2]=(((D<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((D|0)==0){_=e}else{D=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=D}else{W=D;X=j;while(1){j=X+16|0;C=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];B=Z+(A*12|0)+4|0;E=(c[B>>2]|0)+1|0;c[B>>2]=E;R=c[W+24>>2]|0;if(E>>>0>R>>>0){E=W+28|0;c[E>>2]=(c[E>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[B>>2]|0)>>>0)/(R>>>0)|0}c[X+12>>2]=0;R=Z+(A*12|0)|0;c[j>>2]=c[R>>2];j=c[R>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[R>>2]=X;R=c[h>>2]|0;if((C|0)==0){$=R;break}else{W=R;X=C}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){D=$;Y=W;e=X}else{_=W;break}}}yfb(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function T2a(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[43570]|0)==0){f=24}else{g=$fb(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=($fb(a|0)|0)+s|0;switch(v|0){case 7:{x=h;y=u;f=9;break};case 1:{z=h;A=t;B=u;f=15;break};case 10:{C=h;f=6;break};case 8:{D=h;f=8;break};case 11:{C=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 3:{E=h;F=t;G=u;f=13;break};case 6:{H=h;I=u;f=10;break};case 4:{J=h;K=u;f=12;break};case 9:{L=h;f=7;break};case 2:{M=h;N=t;O=u;f=14;break};case 5:{P=h;Q=u;f=11;break};default:{R=h;S=t;T=u}}if((f|0)==6){L=((d[w+9|0]|0)<<16)+C|0;f=7}if((f|0)==7){D=((d[w+8|0]|0)<<8)+L|0;f=8}if((f|0)==8){x=D;y=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){H=x;I=((d[w+6|0]|0)<<16)+y|0;f=10}if((f|0)==10){P=H;Q=((d[w+5|0]|0)<<8)+I|0;f=11}if((f|0)==11){J=P;K=(d[w+4|0]|0)+Q|0;f=12}if((f|0)==12){E=J;F=((d[w+3|0]|0)<<24)+t|0;G=K;f=13}if((f|0)==13){M=E;N=((d[w+2|0]|0)<<16)+F|0;O=G;f=14}if((f|0)==14){z=M;A=((d[w+1|0]|0)<<8)+N|0;B=O;f=15}if((f|0)==15){R=z;S=(d[w]|0)+A|0;T=B}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[43570]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=$fb(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((Wfb(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Eb(a|0,174840)|0)==0){V=0;break}else{W=174864}i=b;return W|0}}while(0);c[e>>2]=a;VMa(0,(V|0)!=0|0,174912,e);W=V+4|0;i=b;return W|0}function U2a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((V2a(174968,a,b)|0)!=0){d=1;i=c;return d|0}d=(V2a(174976,a,b)|0)!=0|0;i=c;return d|0}function V2a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((Xfb(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function W2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(Xfb(c[123332>>2]|0,174984)|0)==0|0;VMa(0,m,175e3,l);l=(Xfb(c[125236>>2]|0,174984)|0)==0|0;VMa(0,l,175056,k);k=(Xfb(c[127228>>2]|0,174984)|0)==0|0;VMa(0,k,175112,j);j=175176|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=175304|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[127232+(k<<2)>>2]|0;if((l|0)==2){q=c[123208+(k<<2)>>2]|0;if(!((V2a(q,1,p)|0)==0|(j|0)>=(a|0))){r=9;break}s=c[123208+(k<<2)>>2]|0;if((Y2a(s,p)|0)!=0){r=13;break}}else if((l|0)==1){if((V2a(c[123208+(k<<2)>>2]|0,1,p)|0)!=0){r=5;break}}l=k+1|0;if((l|0)<31){k=l}else{r=17;break a}}if((r|0)==5){r=0;l=175176+(k<<2)|0;if((c[l>>2]|0)!=0){r=6;break}c[l>>2]=1;t=n}else if((r|0)==9){r=0;l=175176+(k<<2)|0;if((c[l>>2]|0)!=0){r=10;break}c[l>>2]=1;c[175304+(k<<2)>>2]=X2a(q,p)|0;t=j}else if((r|0)==13){r=0;l=175176+(k<<2)|0;if((c[l>>2]|0)!=0){r=14;break}c[l>>2]=1;c[175304+(k<<2)>>2]=Z2a(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;r=19;break}}if((r|0)==6){c[h>>2]=c[p>>2];UMa(1,0,175432,h);o=1;i=d;return o|0}else if((r|0)==10){c[g>>2]=c[p>>2];UMa(1,0,175432,g);o=1;i=d;return o|0}else if((r|0)==14){c[f>>2]=c[p>>2];UMa(1,0,175432,f);o=1;i=d;return o|0}else if((r|0)==17){c[e>>2]=c[p>>2];UMa(1,0,175488,e);o=1;i=d;return o|0}else if((r|0)==19){i=d;return o|0}return 0}function X2a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((Xfb(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function Y2a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Z2a(a,b)|0)!=0|0;i=c;return d|0}function Z2a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=$fb(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((Yfb(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function _2a(){i=i;return}function $2a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){vc(0)}e=c[r>>2]|0;rc(175520,5,1,e|0)|0;f=b;b=0;while(1){Sd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}rc(175528,20,1,e|0)|0;vc(0);return 0}function a3a(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;wd(d|0,175552,e|0)|0;if((b|0)==0){vc(1)}else{ud(d|0)|0;i3a();ud(d|0)|0;ib(6,0)|0;hd()}}function b3a(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function c3a(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function d3a(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function e3a(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function f3a(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function g3a(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}dgb(p|0,32,b+(d-p)|0)|0;i=f;return}function h3a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=176592+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[176636+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[176632+(e*48|0)>>2]|0)==1){j3a(b)|0}k=176596+(e*48|0)|0;if((c[k>>2]|0)==0){break}Yc(c[f>>2]|0)|0;yfb(c[k>>2]|0)}}while(0);do{if((h|0)==10){Yc(g|0)|0;b=176596+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Jd(k|0)|0;yfb(c[b>>2]|0)}}while(0);c[f>>2]=0}c[176628+(e*48|0)>>2]=0;c[176596+(e*48|0)>>2]=0;i=d;return 0}function i3a(){var a=0,b=0;a=i;if((c[43890]|0)!=0){i=a;return}c[43890]=1;c[175568>>2]=0;b=0;do{c[175564>>2]=b;h3a(175560)|0;b=b+1|0;}while((b|0)<100);i=a;return}function j3a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[176608+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=176592+(d*48|0)|0;g=c[f>>2]|0;h=yb(g|0)|0;Wc(g|0,0,2)|0;if((h|0)>=(yb(g|0)|0)){e=0;i=b;return e|0}if((c[176612+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[176620+(d*48|0)>>2]&2|0)!=0){ud(c[f>>2]|0)|0}d=Tc(rb(c[f>>2]|0)|0,h|0)|0;Wc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){l3a(111,175576);e=111;i=b;return e|0}else{c[(Nc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function k3a(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if(($a(rb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else if((f|0)==8192){e=(ub(rb(a|0)|0)|0)==0|0;break}else if((f|0)==24576){e=1;break}else{e=0;break}}}while(0);i=b;return e|0}



function Fqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8736>>3]=+h[b+6576>>3];i=i;return}function Gqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8744>>3]=+h[b+6584>>3];i=i;return}function Hqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8752>>3]=+h[b+6592>>3];i=i;return}function Iqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8848>>3]=+h[b+8784>>3];i=i;return}function Jqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8856>>3]=+h[b+8760>>3];i=i;return}function Kqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8864>>3]=+h[b+8768>>3];i=i;return}function Lqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8872>>3]=+h[b+8776>>3];i=i;return}function Mqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8920>>3]=+h[b+8904>>3];i=i;return}function Nqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9776>>3]=+h[b+8896>>3]*(+h[b+8912>>3]*(+h[b+8920>>3]- +h[b+8904>>3])+1.0);i=i;return}function Oqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8952>>3]=+h[b+8936>>3];i=i;return}function Pqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9768>>3]=+h[b+8928>>3]*(+h[b+8944>>3]*(+h[b+8952>>3]- +h[b+8936>>3])+1.0);i=i;return}function Qqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8984>>3]=+h[b+8968>>3];i=i;return}function Rqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9752>>3]=+h[b+8960>>3]*(+h[b+8976>>3]*(+h[b+8984>>3]- +h[b+8968>>3])+1.0);i=i;return}function Sqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9016>>3]=+h[b+9e3>>3];i=i;return}function Tqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9744>>3]=+h[b+8992>>3]*(+h[b+9008>>3]*(+h[b+9016>>3]- +h[b+9e3>>3])+1.0);i=i;return}function Uqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9048>>3]=+h[b+9032>>3];i=i;return}function Vqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9736>>3]=+h[b+9024>>3]*(+h[b+9040>>3]*(+h[b+9048>>3]- +h[b+9032>>3])+1.0);i=i;return}function Wqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9080>>3]=+h[b+9064>>3];i=i;return}function Xqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9728>>3]=+h[b+9056>>3]*(+h[b+9072>>3]*(+h[b+9080>>3]- +h[b+9064>>3])+1.0);i=i;return}function Yqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9112>>3]=+h[b+9096>>3];i=i;return}function Zqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9720>>3]=+h[b+9088>>3]*(+h[b+9104>>3]*(+h[b+9112>>3]- +h[b+9096>>3])+1.0);i=i;return}function _qa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9144>>3]=+h[b+9128>>3];i=i;return}function $qa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9712>>3]=+h[b+9120>>3]*(+h[b+9136>>3]*(+h[b+9144>>3]- +h[b+9128>>3])+1.0);i=i;return}function ara(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9168>>3]=+h[b+8848>>3];i=i;return}function bra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9176>>3]=+h[b+8856>>3];i=i;return}function cra(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+8864>>3]*+h[f+8872>>3]*2.0;if(g!=0.0){j=g;k=f;l=250.0/j;m=k;n=m+9192|0;o=n;h[o>>3]=l;i=d;return}p=+YMa(c[b+536>>2]|0,g,20696,20688,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=250.0/j;m=k;n=m+9192|0;o=n;h[o>>3]=l;i=d;return}function dra(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+8864>>3];j=+h[f+8872>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,20744,20736,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+9200>>3]=l*.004;i=d;return}function era(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9208>>3]=+h[b+8736>>3];i=i;return}function fra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9216>>3]=+h[b+8744>>3];i=i;return}function gra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9224>>3]=+h[b+8752>>3];i=i;return}function hra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9232>>3]=+h[b+8792>>3];i=i;return}function ira(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9264>>3]=+h[b+9208>>3];i=i;return}function jra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9272>>3]=+h[b+9216>>3];i=i;return}function kra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9280>>3]=+h[b+9224>>3];i=i;return}function lra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9304>>3]=+h[b+9232>>3];i=i;return}function mra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9312>>3]=+h[b+9232>>3];i=i;return}function nra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9320>>3]=+h[b+8792>>3];i=i;return}function ora(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9328>>3]=+h[b+8832>>3];i=i;return}function pra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9336>>3]=+h[b+8840>>3];i=i;return}function qra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9344>>3]=+h[b+8800>>3];i=i;return}function rra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9352>>3]=+h[b+8808>>3];i=i;return}function sra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9360>>3]=+h[b+8816>>3];i=i;return}function tra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9368>>3]=+h[b+9320>>3];i=i;return}function ura(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9384>>3]=+h[b+9328>>3];i=i;return}function vra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9392>>3]=+h[b+9336>>3];i=i;return}function wra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6264>>3]=+h[b+9344>>3];i=i;return}function xra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6280>>3]=+h[b+9344>>3]+ +h[b+9352>>3];i=i;return}function yra(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+8|0;r=a+416|0;RNa(+h[(c[r>>2]|0)+6256>>3],2,k);RNa(+h[(c[r>>2]|0)+6264>>3],2,l);RNa(+h[(c[r>>2]|0)+6272>>3],2,n);RNa(+h[(c[r>>2]|0)+6280>>3],2,o);c[g>>2]=l;QNa(2,j,2,k,g);c[f>>2]=o;QNa(2,m,2,n,f);c[e>>2]=m;QNa(1,p,2,j,e);e=c[a+536>>2]|0;j=d;m=p;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];Bp(q,e,0.0,d,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9928>>3]=+h[q>>3];i=b;return}function zra(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9704>>3]=+h[(c[a+416>>2]|0)+9416>>3]*+h[b+9928>>3];i=i;return}function Ara(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9424>>3]=+h[b+6600>>3];i=i;return}function Bra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9432>>3]=+h[b+6608>>3];i=i;return}function Cra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9440>>3]=+h[b+6616>>3];i=i;return}function Dra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9536>>3]=+h[b+9472>>3];i=i;return}function Era(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9544>>3]=+h[b+9448>>3];i=i;return}function Fra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9552>>3]=+h[b+9456>>3];i=i;return}function Gra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9560>>3]=+h[b+9464>>3];i=i;return}function Hra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9608>>3]=+h[b+9592>>3];i=i;return}function Ira(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9696>>3]=+h[b+9584>>3]*(+h[b+9600>>3]*(+h[b+9608>>3]- +h[b+9592>>3])+1.0);i=i;return}function Jra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9640>>3]=+h[b+9624>>3];i=i;return}function Kra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9688>>3]=+h[b+9616>>3]*(+h[b+9632>>3]*(+h[b+9640>>3]- +h[b+9624>>3])+1.0);i=i;return}function Lra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9672>>3]=+h[b+9656>>3];i=i;return}function Mra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9672>>3]=+h[b+9648>>3]*(+h[b+9664>>3]*(+h[b+9672>>3]- +h[b+9656>>3])+1.0);i=i;return}function Nra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9704>>3]=+h[b+9688>>3];i=i;return}function Ora(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9664>>3]=+h[b+9680>>3]*(+h[b+9696>>3]*(+h[b+9704>>3]- +h[b+9688>>3])+1.0);i=i;return}function Pra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9736>>3]=+h[b+9720>>3];i=i;return}function Qra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9656>>3]=+h[b+9712>>3]*(+h[b+9728>>3]*(+h[b+9736>>3]- +h[b+9720>>3])+1.0);i=i;return}function Rra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9768>>3]=+h[b+9752>>3];i=i;return}function Sra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9648>>3]=+h[b+9744>>3]*(+h[b+9760>>3]*(+h[b+9768>>3]- +h[b+9752>>3])+1.0);i=i;return}function Tra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9800>>3]=+h[b+9784>>3];i=i;return}function Ura(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9640>>3]=+h[b+9776>>3]*(+h[b+9792>>3]*(+h[b+9800>>3]- +h[b+9784>>3])+1.0);i=i;return}function Vra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9832>>3]=+h[b+9816>>3];i=i;return}function Wra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9632>>3]=+h[b+9808>>3]*(+h[b+9824>>3]*(+h[b+9832>>3]- +h[b+9816>>3])+1.0);i=i;return}function Xra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9856>>3]=+h[b+9536>>3];i=i;return}function Yra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9864>>3]=+h[b+9544>>3];i=i;return}function Zra(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+9552>>3]*+h[f+9560>>3]*2.0;if(g!=0.0){j=g;k=f;l=250.0/j;m=k;n=m+9880|0;o=n;h[o>>3]=l;i=d;return}p=+YMa(c[b+536>>2]|0,g,20768,20760,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=250.0/j;m=k;n=m+9880|0;o=n;h[o>>3]=l;i=d;return}function _ra(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+9552>>3];j=+h[f+9560>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,20816,20808,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+9888>>3]=l*.004;i=d;return}function $ra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9896>>3]=+h[b+9424>>3];i=i;return}function asa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9904>>3]=+h[b+9432>>3];i=i;return}function bsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9912>>3]=+h[b+9440>>3];i=i;return}function csa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9920>>3]=+h[b+9480>>3];i=i;return}function dsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9952>>3]=+h[b+9896>>3];i=i;return}function esa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9960>>3]=+h[b+9904>>3];i=i;return}function fsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9968>>3]=+h[b+9912>>3];i=i;return}function gsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9992>>3]=+h[b+9920>>3];i=i;return}function hsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1e4>>3]=+h[b+9920>>3];i=i;return}function isa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10008>>3]=+h[b+9480>>3];i=i;return}function jsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10016>>3]=+h[b+9520>>3];i=i;return}function ksa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10024>>3]=+h[b+9528>>3];i=i;return}function lsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10032>>3]=+h[b+9488>>3];i=i;return}function msa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10040>>3]=+h[b+9496>>3];i=i;return}function nsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10048>>3]=+h[b+9504>>3];i=i;return}function osa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10056>>3]=+h[b+10008>>3];i=i;return}function psa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10072>>3]=+h[b+10016>>3];i=i;return}function qsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10080>>3]=+h[b+10024>>3];i=i;return}function rsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6296>>3]=+h[b+10032>>3];i=i;return}function ssa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6312>>3]=+h[b+10032>>3]+ +h[b+10040>>3];i=i;return}function tsa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+8|0;r=a+416|0;RNa(+h[(c[r>>2]|0)+6288>>3],2,k);RNa(+h[(c[r>>2]|0)+6296>>3],2,l);RNa(+h[(c[r>>2]|0)+6304>>3],2,n);RNa(+h[(c[r>>2]|0)+6312>>3],2,o);c[g>>2]=l;QNa(2,j,2,k,g);c[f>>2]=o;QNa(2,m,2,n,f);c[e>>2]=m;QNa(1,p,2,j,e);e=c[a+536>>2]|0;j=d;m=p;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];Bp(q,e,0.0,d,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10072>>3]=+h[q>>3];i=b;return}function usa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9624>>3]=+h[(c[a+416>>2]|0)+10104>>3]*+h[b+10072>>3];i=i;return}function vsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10112>>3]=+h[b+6624>>3];i=i;return}function wsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10120>>3]=+h[b+6632>>3];i=i;return}function xsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10128>>3]=+h[b+6640>>3];i=i;return}function ysa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10224>>3]=+h[b+10160>>3];i=i;return}function zsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10232>>3]=+h[b+10136>>3];i=i;return}function Asa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10240>>3]=+h[b+10144>>3];i=i;return}function Bsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10248>>3]=+h[b+10152>>3];i=i;return}function Csa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10296>>3]=+h[b+10280>>3];i=i;return}function Dsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9616>>3]=+h[b+10272>>3]*(+h[b+10288>>3]*(+h[b+10296>>3]- +h[b+10280>>3])+1.0);i=i;return}function Esa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10328>>3]=+h[b+10312>>3];i=i;return}function Fsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9608>>3]=+h[b+10304>>3]*(+h[b+10320>>3]*(+h[b+10328>>3]- +h[b+10312>>3])+1.0);i=i;return}function Gsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10360>>3]=+h[b+10344>>3];i=i;return}function Hsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9592>>3]=+h[b+10336>>3]*(+h[b+10352>>3]*(+h[b+10360>>3]- +h[b+10344>>3])+1.0);i=i;return}function Isa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10392>>3]=+h[b+10376>>3];i=i;return}function Jsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9584>>3]=+h[b+10368>>3]*(+h[b+10384>>3]*(+h[b+10392>>3]- +h[b+10376>>3])+1.0);i=i;return}function Ksa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10424>>3]=+h[b+10408>>3];i=i;return}function Lsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9576>>3]=+h[b+10400>>3]*(+h[b+10416>>3]*(+h[b+10424>>3]- +h[b+10408>>3])+1.0);i=i;return}function Msa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10456>>3]=+h[b+10440>>3];i=i;return}function Nsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9568>>3]=+h[b+10432>>3]*(+h[b+10448>>3]*(+h[b+10456>>3]- +h[b+10440>>3])+1.0);i=i;return}function Osa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10488>>3]=+h[b+10472>>3];i=i;return}function Psa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9560>>3]=+h[b+10464>>3]*(+h[b+10480>>3]*(+h[b+10488>>3]- +h[b+10472>>3])+1.0);i=i;return}function Qsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10520>>3]=+h[b+10504>>3];i=i;return}function Rsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9552>>3]=+h[b+10496>>3]*(+h[b+10512>>3]*(+h[b+10520>>3]- +h[b+10504>>3])+1.0);i=i;return}function Ssa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10544>>3]=+h[b+10224>>3];i=i;return}function Tsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10552>>3]=+h[b+10232>>3];i=i;return}function Usa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+10240>>3]*+h[f+10248>>3]*2.0;if(g!=0.0){j=g;k=f;l=250.0/j;m=k;n=m+10568|0;o=n;h[o>>3]=l;i=d;return}p=+YMa(c[b+536>>2]|0,g,20840,20832,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=250.0/j;m=k;n=m+10568|0;o=n;h[o>>3]=l;i=d;return}function Vsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+10240>>3];j=+h[f+10248>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,20888,20880,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+10576>>3]=l*.004;i=d;return}function Wsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10584>>3]=+h[b+10112>>3];i=i;return}function Xsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10592>>3]=+h[b+10120>>3];i=i;return}function Ysa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10600>>3]=+h[b+10128>>3];i=i;return}function Zsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10608>>3]=+h[b+10168>>3];i=i;return}function _sa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10640>>3]=+h[b+10584>>3];i=i;return}function $sa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10648>>3]=+h[b+10592>>3];i=i;return}function ata(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10656>>3]=+h[b+10600>>3];i=i;return}function bta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10680>>3]=+h[b+10608>>3];i=i;return}function cta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10688>>3]=+h[b+10608>>3];i=i;return}function dta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10696>>3]=+h[b+10168>>3];i=i;return}function eta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10704>>3]=+h[b+10208>>3];i=i;return}function fta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10712>>3]=+h[b+10216>>3];i=i;return}function gta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10720>>3]=+h[b+10176>>3];i=i;return}function hta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10728>>3]=+h[b+10184>>3];i=i;return}function ita(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10736>>3]=+h[b+10192>>3];i=i;return}function jta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10744>>3]=+h[b+10696>>3];i=i;return}function kta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10760>>3]=+h[b+10704>>3];i=i;return}function lta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10768>>3]=+h[b+10712>>3];i=i;return}function mta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6328>>3]=+h[b+10720>>3];i=i;return}function nta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6344>>3]=+h[b+10720>>3]+ +h[b+10728>>3];i=i;return}function ota(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+8|0;r=a+416|0;RNa(+h[(c[r>>2]|0)+6320>>3],2,k);RNa(+h[(c[r>>2]|0)+6328>>3],2,l);RNa(+h[(c[r>>2]|0)+6336>>3],2,n);RNa(+h[(c[r>>2]|0)+6344>>3],2,o);c[g>>2]=l;QNa(2,j,2,k,g);c[f>>2]=o;QNa(2,m,2,n,f);c[e>>2]=m;QNa(1,p,2,j,e);e=c[a+536>>2]|0;j=d;m=p;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];Bp(q,e,0.0,d,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10216>>3]=+h[q>>3];i=b;return}function pta(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9544>>3]=+h[(c[a+416>>2]|0)+10792>>3]*+h[b+10216>>3];i=i;return}function qta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10800>>3]=+h[b+6648>>3];i=i;return}function rta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10808>>3]=+h[b+6656>>3];i=i;return}function sta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10816>>3]=+h[b+6664>>3];i=i;return}function tta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10896>>3]=+h[b+10848>>3];i=i;return}function uta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10904>>3]=+h[b+10824>>3];i=i;return}function vta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10912>>3]=+h[b+10832>>3];i=i;return}function wta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10920>>3]=+h[b+10840>>3];i=i;return}function xta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10968>>3]=+h[b+10952>>3];i=i;return}function yta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9536>>3]=+h[b+10944>>3]*(+h[b+10960>>3]*(+h[b+10968>>3]- +h[b+10952>>3])+1.0);i=i;return}function zta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11e3>>3]=+h[b+10984>>3];i=i;return}function Ata(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9528>>3]=+h[b+10976>>3]*(+h[b+10992>>3]*(+h[b+11e3>>3]- +h[b+10984>>3])+1.0);i=i;return}function Bta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11032>>3]=+h[b+11016>>3];i=i;return}function Cta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9512>>3]=+h[b+11008>>3]*(+h[b+11024>>3]*(+h[b+11032>>3]- +h[b+11016>>3])+1.0);i=i;return}function Dta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11064>>3]=+h[b+11048>>3];i=i;return}function Eta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9504>>3]=+h[b+11040>>3]*(+h[b+11056>>3]*(+h[b+11064>>3]- +h[b+11048>>3])+1.0);i=i;return}function Fta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11096>>3]=+h[b+11080>>3];i=i;return}function Gta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9496>>3]=+h[b+11072>>3]*(+h[b+11088>>3]*(+h[b+11096>>3]- +h[b+11080>>3])+1.0);i=i;return}function Hta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11128>>3]=+h[b+11112>>3];i=i;return}function Ita(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9488>>3]=+h[b+11104>>3]*(+h[b+11120>>3]*(+h[b+11128>>3]- +h[b+11112>>3])+1.0);i=i;return}function Jta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11160>>3]=+h[b+11144>>3];i=i;return}function Kta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9480>>3]=+h[b+11136>>3]*(+h[b+11152>>3]*(+h[b+11160>>3]- +h[b+11144>>3])+1.0);i=i;return}function Lta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11192>>3]=+h[b+11176>>3];i=i;return}function Mta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9472>>3]=+h[b+11168>>3]*(+h[b+11184>>3]*(+h[b+11192>>3]- +h[b+11176>>3])+1.0);i=i;return}function Nta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11216>>3]=+h[b+10896>>3];i=i;return}function Ota(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11224>>3]=+h[b+10904>>3];i=i;return}function Pta(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+10912>>3]*+h[f+10920>>3]*2.0;if(g!=0.0){j=g;k=f;l=250.0/j;m=k;n=m+11240|0;o=n;h[o>>3]=l;i=d;return}p=+YMa(c[b+536>>2]|0,g,20912,20904,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=250.0/j;m=k;n=m+11240|0;o=n;h[o>>3]=l;i=d;return}function Qta(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+10912>>3];j=+h[f+10920>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,20960,20952,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+11248>>3]=l*.004;i=d;return}function Rta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11256>>3]=+h[b+10800>>3];i=i;return}function Sta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11264>>3]=+h[b+10808>>3];i=i;return}function Tta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11272>>3]=+h[b+10816>>3];i=i;return}function Uta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11280>>3]=+h[b+10856>>3];i=i;return}function Vta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11312>>3]=+h[b+11256>>3];i=i;return}function Wta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11320>>3]=+h[b+11264>>3];i=i;return}function Xta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11328>>3]=+h[b+11272>>3];i=i;return}function Yta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11352>>3]=+h[b+11280>>3];i=i;return}function Zta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11360>>3]=+h[b+11280>>3];i=i;return}function _ta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11368>>3]=+h[b+10856>>3];i=i;return}function $ta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11376>>3]=+h[b+10864>>3];i=i;return}function aua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11384>>3]=+h[b+10872>>3];i=i;return}function bua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11392>>3]=+h[b+10880>>3];i=i;return}function cua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11400>>3]=+h[b+11368>>3];i=i;return}function dua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6360>>3]=+h[b+11376>>3];i=i;return}function eua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6376>>3]=+h[b+11376>>3]+ +h[b+11384>>3];i=i;return}function fua(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+8|0;r=a+416|0;RNa(+h[(c[r>>2]|0)+6352>>3],2,k);RNa(+h[(c[r>>2]|0)+6360>>3],2,l);RNa(+h[(c[r>>2]|0)+6368>>3],2,n);RNa(+h[(c[r>>2]|0)+6376>>3],2,o);c[g>>2]=l;QNa(2,j,2,k,g);c[f>>2]=o;QNa(2,m,2,n,f);c[e>>2]=m;QNa(1,p,2,j,e);e=c[a+536>>2]|0;j=d;m=p;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];Bp(q,e,0.0,d,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10360>>3]=+h[q>>3];i=b;return}function gua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11416>>3]=+h[b+11392>>3];i=i;return}function hua(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9464>>3]=+h[(c[a+416>>2]|0)+11416>>3]*+h[b+10360>>3];i=i;return}function iua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11424>>3]=+h[b+6672>>3];i=i;return}function jua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11432>>3]=+h[b+6680>>3];i=i;return}function kua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11440>>3]=+h[b+6688>>3];i=i;return}function lua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11520>>3]=+h[b+11472>>3];i=i;return}function mua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11528>>3]=+h[b+11448>>3];i=i;return}function nua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11536>>3]=+h[b+11456>>3];i=i;return}function oua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11544>>3]=+h[b+11464>>3];i=i;return}function pua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11592>>3]=+h[b+11576>>3];i=i;return}function qua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9456>>3]=+h[b+11568>>3]*(+h[b+11584>>3]*(+h[b+11592>>3]- +h[b+11576>>3])+1.0);i=i;return}function rua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11624>>3]=+h[b+11608>>3];i=i;return}function sua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9448>>3]=+h[b+11600>>3]*(+h[b+11616>>3]*(+h[b+11624>>3]- +h[b+11608>>3])+1.0);i=i;return}function tua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11656>>3]=+h[b+11640>>3];i=i;return}function uua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9432>>3]=+h[b+11632>>3]*(+h[b+11648>>3]*(+h[b+11656>>3]- +h[b+11640>>3])+1.0);i=i;return}function vua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11688>>3]=+h[b+11672>>3];i=i;return}function wua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9424>>3]=+h[b+11664>>3]*(+h[b+11680>>3]*(+h[b+11688>>3]- +h[b+11672>>3])+1.0);i=i;return}function xua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11720>>3]=+h[b+11704>>3];i=i;return}function yua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9416>>3]=+h[b+11696>>3]*(+h[b+11712>>3]*(+h[b+11720>>3]- +h[b+11704>>3])+1.0);i=i;return}function zua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11752>>3]=+h[b+11736>>3];i=i;return}function Aua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9408>>3]=+h[b+11728>>3]*(+h[b+11744>>3]*(+h[b+11752>>3]- +h[b+11736>>3])+1.0);i=i;return}function Bua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11784>>3]=+h[b+11768>>3];i=i;return}function Cua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9400>>3]=+h[b+11760>>3]*(+h[b+11776>>3]*(+h[b+11784>>3]- +h[b+11768>>3])+1.0);i=i;return}function Dua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11816>>3]=+h[b+11800>>3];i=i;return}function Eua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9392>>3]=+h[b+11792>>3]*(+h[b+11808>>3]*(+h[b+11816>>3]- +h[b+11800>>3])+1.0);i=i;return}function Fua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11840>>3]=+h[b+11520>>3];i=i;return}function Gua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11848>>3]=+h[b+11528>>3];i=i;return}function Hua(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+11536>>3]*+h[f+11544>>3]*2.0;if(g!=0.0){j=g;k=f;l=250.0/j;m=k;n=m+11864|0;o=n;h[o>>3]=l;i=d;return}p=+YMa(c[b+536>>2]|0,g,20984,20976,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=250.0/j;m=k;n=m+11864|0;o=n;h[o>>3]=l;i=d;return}function Iua(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+11536>>3];j=+h[f+11544>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,21032,21024,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+11872>>3]=l*.004;i=d;return}function Jua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11880>>3]=+h[b+11424>>3];i=i;return}function Kua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11888>>3]=+h[b+11432>>3];i=i;return}function Lua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11896>>3]=+h[b+11440>>3];i=i;return}function Mua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11904>>3]=+h[b+11480>>3];i=i;return}function Nua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11936>>3]=+h[b+11880>>3];i=i;return}function Oua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11944>>3]=+h[b+11888>>3];i=i;return}function Pua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11952>>3]=+h[b+11896>>3];i=i;return}function Qua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11976>>3]=+h[b+11904>>3];i=i;return}function Rua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11984>>3]=+h[b+11904>>3];i=i;return}function Sua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11992>>3]=+h[b+11480>>3];i=i;return}function Tua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12e3>>3]=+h[b+11488>>3];i=i;return}function Uua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12008>>3]=+h[b+11496>>3];i=i;return}function Vua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12016>>3]=+h[b+11504>>3];i=i;return}function Wua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12024>>3]=+h[b+11992>>3];i=i;return}function Xua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6392>>3]=+h[b+12e3>>3];i=i;return}function Yua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6408>>3]=+h[b+12e3>>3]+ +h[b+12008>>3];i=i;return}function Zua(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+8|0;r=a+416|0;RNa(+h[(c[r>>2]|0)+6384>>3],2,k);RNa(+h[(c[r>>2]|0)+6392>>3],2,l);RNa(+h[(c[r>>2]|0)+6400>>3],2,n);RNa(+h[(c[r>>2]|0)+6408>>3],2,o);c[g>>2]=l;QNa(2,j,2,k,g);c[f>>2]=o;QNa(2,m,2,n,f);c[e>>2]=m;QNa(1,p,2,j,e);e=c[a+536>>2]|0;j=d;m=p;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];Bp(q,e,0.0,d,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10504>>3]=+h[q>>3];i=b;return}function _ua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12040>>3]=+h[b+12016>>3];i=i;return}function $ua(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9384>>3]=+h[(c[a+416>>2]|0)+12040>>3]*+h[b+10504>>3];i=i;return}function ava(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12048>>3]=+h[b+6696>>3];i=i;return}function bva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12056>>3]=+h[b+6704>>3];i=i;return}function cva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12064>>3]=+h[b+6712>>3];i=i;return}function dva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12144>>3]=+h[b+12096>>3];i=i;return}function eva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12152>>3]=+h[b+12072>>3];i=i;return}function fva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12160>>3]=+h[b+12080>>3];i=i;return}function gva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12168>>3]=+h[b+12088>>3];i=i;return}function hva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12216>>3]=+h[b+12200>>3];i=i;return}function iva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9376>>3]=+h[b+12192>>3]*(+h[b+12208>>3]*(+h[b+12216>>3]- +h[b+12200>>3])+1.0);i=i;return}function jva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12248>>3]=+h[b+12232>>3];i=i;return}function kva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9368>>3]=+h[b+12224>>3]*(+h[b+12240>>3]*(+h[b+12248>>3]- +h[b+12232>>3])+1.0);i=i;return}function lva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12280>>3]=+h[b+12264>>3];i=i;return}function mva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9352>>3]=+h[b+12256>>3]*(+h[b+12272>>3]*(+h[b+12280>>3]- +h[b+12264>>3])+1.0);i=i;return}function nva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12312>>3]=+h[b+12296>>3];i=i;return}function ova(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9344>>3]=+h[b+12288>>3]*(+h[b+12304>>3]*(+h[b+12312>>3]- +h[b+12296>>3])+1.0);i=i;return}function pva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12344>>3]=+h[b+12328>>3];i=i;return}function qva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9336>>3]=+h[b+12320>>3]*(+h[b+12336>>3]*(+h[b+12344>>3]- +h[b+12328>>3])+1.0);i=i;return}function rva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12376>>3]=+h[b+12360>>3];i=i;return}function sva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9328>>3]=+h[b+12352>>3]*(+h[b+12368>>3]*(+h[b+12376>>3]- +h[b+12360>>3])+1.0);i=i;return}function tva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12408>>3]=+h[b+12392>>3];i=i;return}function uva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9320>>3]=+h[b+12384>>3]*(+h[b+12400>>3]*(+h[b+12408>>3]- +h[b+12392>>3])+1.0);i=i;return}function vva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12440>>3]=+h[b+12424>>3];i=i;return}function wva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9312>>3]=+h[b+12416>>3]*(+h[b+12432>>3]*(+h[b+12440>>3]- +h[b+12424>>3])+1.0);i=i;return}function xva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12464>>3]=+h[b+12144>>3];i=i;return}function yva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12472>>3]=+h[b+12152>>3];i=i;return}function zva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+12160>>3]*+h[f+12168>>3]*2.0;if(g!=0.0){j=g;k=f;l=250.0/j;m=k;n=m+12488|0;o=n;h[o>>3]=l;i=d;return}p=+YMa(c[b+536>>2]|0,g,21056,21048,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=250.0/j;m=k;n=m+12488|0;o=n;h[o>>3]=l;i=d;return}function Ava(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+12160>>3];j=+h[f+12168>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,21104,21096,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+12496>>3]=l*.004;i=d;return}function Bva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12504>>3]=+h[b+12048>>3];i=i;return}function Cva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12512>>3]=+h[b+12056>>3];i=i;return}function Dva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12520>>3]=+h[b+12064>>3];i=i;return}function Eva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12528>>3]=+h[b+12104>>3];i=i;return}function Fva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12560>>3]=+h[b+12504>>3];i=i;return}function Gva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12568>>3]=+h[b+12512>>3];i=i;return}function Hva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12576>>3]=+h[b+12520>>3];i=i;return}function Iva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12600>>3]=+h[b+12528>>3];i=i;return}function Jva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12608>>3]=+h[b+12528>>3];i=i;return}function Kva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12616>>3]=+h[b+12104>>3];i=i;return}function Lva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12624>>3]=+h[b+12112>>3];i=i;return}function Mva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12632>>3]=+h[b+12120>>3];i=i;return}function Nva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12640>>3]=+h[b+12128>>3];i=i;return}function Ova(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12648>>3]=+h[b+12616>>3];i=i;return}function Pva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6424>>3]=+h[b+12624>>3];i=i;return}function Qva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6440>>3]=+h[b+12624>>3]+ +h[b+12632>>3];i=i;return}function Rva(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+8|0;r=a+416|0;RNa(+h[(c[r>>2]|0)+6416>>3],2,k);RNa(+h[(c[r>>2]|0)+6424>>3],2,l);RNa(+h[(c[r>>2]|0)+6432>>3],2,n);RNa(+h[(c[r>>2]|0)+6440>>3],2,o);c[g>>2]=l;QNa(2,j,2,k,g);c[f>>2]=o;QNa(2,m,2,n,f);c[e>>2]=m;QNa(1,p,2,j,e);e=c[a+536>>2]|0;j=d;m=p;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];Bp(q,e,0.0,d,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10648>>3]=+h[q>>3];i=b;return}function Sva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12664>>3]=+h[b+12640>>3];i=i;return}function Tva(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9304>>3]=+h[(c[a+416>>2]|0)+12664>>3]*+h[b+10648>>3];i=i;return}function Uva(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21120]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12664>>3],1.0)|0)<<24>>24==0)){i=d;return}b=uNa(21136,qNa(+h[(c[g>>2]|0)+12664>>3],21128)|0)|0;g=c[41886]|0;j=e;k=37768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21120]=1;i=d;return}function Vva(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21336]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+560>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+560>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=uNa(21352,sNa(c[(c[g>>2]|0)+560>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=38656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[21336]=1;i=d;return}function Wva(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21656]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12576>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(21664,qNa(+h[(c[g>>2]|0)+12576>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21656]=1;i=d;return}function Xva(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21768]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(21776,qNa(+h[(c[g>>2]|0)+12496>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21768]=1;i=d;return}function Yva(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21944]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+556>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+556>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(21952,sNa(c[(c[g>>2]|0)+556>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=39136;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[21944]=1;i=d;return}function Zva(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22144]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(22152,qNa(+h[(c[g>>2]|0)+12464>>3],21128)|0)|0;g=c[41886]|0;j=e;k=39272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[22144]=1;i=d;return}function _va(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22256]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(22264,qNa(+h[(c[g>>2]|0)+12440>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[22256]=1;i=d;return}function $va(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22448]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(22456,qNa(+h[(c[g>>2]|0)+12424>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[22448]=1;i=d;return}function awa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22560]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(22568,qNa(+h[(c[g>>2]|0)+12408>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[22560]=1;i=d;return}function bwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22664]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(22672,qNa(+h[(c[g>>2]|0)+12392>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[22664]=1;i=d;return}function cwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22776]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(22784,qNa(+h[(c[g>>2]|0)+12376>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[22776]=1;i=d;return}function dwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22880]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(22888,qNa(+h[(c[g>>2]|0)+12360>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[22880]=1;i=d;return}function ewa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22992]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(23e3,qNa(+h[(c[g>>2]|0)+12344>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[22992]=1;i=d;return}function fwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23096]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(23104,qNa(+h[(c[g>>2]|0)+12328>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23096]=1;i=d;return}function gwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23208]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(23216,qNa(+h[(c[g>>2]|0)+12312>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23208]=1;i=d;return}function hwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23312]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(23320,qNa(+h[(c[g>>2]|0)+12296>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23312]=1;i=d;return}function iwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23424]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(23432,qNa(+h[(c[g>>2]|0)+12280>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23424]=1;i=d;return}function jwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23528]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(23536,qNa(+h[(c[g>>2]|0)+12264>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23528]=1;i=d;return}function kwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23640]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(23648,qNa(+h[(c[g>>2]|0)+12248>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23640]=1;i=d;return}function lwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23744]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(23752,qNa(+h[(c[g>>2]|0)+12232>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23744]=1;i=d;return}function mwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23856]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(23864,qNa(+h[(c[g>>2]|0)+12216>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23856]=1;i=d;return}function nwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23960]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(23968,qNa(+h[(c[g>>2]|0)+12200>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23960]=1;i=d;return}function owa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24072]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12144>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(24080,qNa(+h[(c[g>>2]|0)+12144>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24072]=1;i=d;return}function pwa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24272]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+552>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+552>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(24280,sNa(c[(c[g>>2]|0)+552>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=41408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[24272]=1;i=d;return}function qwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24488]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(24496,qNa(+h[(c[g>>2]|0)+12096>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24488]=1;i=d;return}function rwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24568]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+12040>>3],1.0)|0)<<24>>24==0)){i=d;return}b=uNa(24576,qNa(+h[(c[g>>2]|0)+12040>>3],21128)|0)|0;g=c[41886]|0;j=e;k=37768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24568]=1;i=d;return}function swa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24696]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+548>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+548>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=uNa(24704,sNa(c[(c[g>>2]|0)+548>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=38656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[24696]=1;i=d;return}function twa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24928]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11952>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(24936,qNa(+h[(c[g>>2]|0)+11952>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24928]=1;i=d;return}function uwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25040]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(25048,qNa(+h[(c[g>>2]|0)+11872>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[25040]=1;i=d;return}function vwa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25136]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+544>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+544>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(25144,sNa(c[(c[g>>2]|0)+544>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=39136;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[25136]=1;i=d;return}function wwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25336]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(25344,qNa(+h[(c[g>>2]|0)+11840>>3],21128)|0)|0;g=c[41886]|0;j=e;k=39272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[25336]=1;i=d;return}function xwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25448]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(25456,qNa(+h[(c[g>>2]|0)+11816>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[25448]=1;i=d;return}function ywa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25552]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(25560,qNa(+h[(c[g>>2]|0)+11800>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[25552]=1;i=d;return}function zwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25664]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(25672,qNa(+h[(c[g>>2]|0)+11784>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[25664]=1;i=d;return}function Awa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25768]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(25776,qNa(+h[(c[g>>2]|0)+11768>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[25768]=1;i=d;return}function Bwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25880]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11752>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(25888,qNa(+h[(c[g>>2]|0)+11752>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[25880]=1;i=d;return}function Cwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25984]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(25992,qNa(+h[(c[g>>2]|0)+11736>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[25984]=1;i=d;return}function Dwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26096]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(26104,qNa(+h[(c[g>>2]|0)+11720>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[26096]=1;i=d;return}function Ewa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26200]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(26208,qNa(+h[(c[g>>2]|0)+11704>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[26200]=1;i=d;return}function Fwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26312]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(26320,qNa(+h[(c[g>>2]|0)+11688>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[26312]=1;i=d;return}function Gwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26416]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(26424,qNa(+h[(c[g>>2]|0)+11672>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[26416]=1;i=d;return}function Hwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26528]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11656>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(26536,qNa(+h[(c[g>>2]|0)+11656>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[26528]=1;i=d;return}function Iwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26632]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(26640,qNa(+h[(c[g>>2]|0)+11640>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[26632]=1;i=d;return}function Jwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26744]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11624>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(26752,qNa(+h[(c[g>>2]|0)+11624>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[26744]=1;i=d;return}function Kwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26848]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(26856,qNa(+h[(c[g>>2]|0)+11608>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[26848]=1;i=d;return}function Lwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26960]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(26968,qNa(+h[(c[g>>2]|0)+11592>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[26960]=1;i=d;return}function Mwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27064]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(27072,qNa(+h[(c[g>>2]|0)+11576>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[27064]=1;i=d;return}function Nwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27176]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(27184,qNa(+h[(c[g>>2]|0)+11520>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[27176]=1;i=d;return}function Owa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27272]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+540>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+540>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(27280,sNa(c[(c[g>>2]|0)+540>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=41408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[27272]=1;i=d;return}function Pwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27488]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(27496,qNa(+h[(c[g>>2]|0)+11472>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[27488]=1;i=d;return}function Qwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27568]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11416>>3],1.0)|0)<<24>>24==0)){i=d;return}b=uNa(27576,qNa(+h[(c[g>>2]|0)+11416>>3],21128)|0)|0;g=c[41886]|0;j=e;k=37768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[27568]=1;i=d;return}function Rwa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27696]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+536>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+536>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=uNa(27704,sNa(c[(c[g>>2]|0)+536>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=38656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[27696]=1;i=d;return}function Swa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27928]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11328>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(27936,qNa(+h[(c[g>>2]|0)+11328>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[27928]=1;i=d;return}function Twa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28040]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(28048,qNa(+h[(c[g>>2]|0)+11248>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28040]=1;i=d;return}function Uwa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28136]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+532>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+532>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(28144,sNa(c[(c[g>>2]|0)+532>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=39136;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[28136]=1;i=d;return}function Vwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28336]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(28344,qNa(+h[(c[g>>2]|0)+11216>>3],21128)|0)|0;g=c[41886]|0;j=e;k=39272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28336]=1;i=d;return}function Wwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28448]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(28456,qNa(+h[(c[g>>2]|0)+11192>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28448]=1;i=d;return}function Xwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28552]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(28560,qNa(+h[(c[g>>2]|0)+11176>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28552]=1;i=d;return}function Ywa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28664]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(28672,qNa(+h[(c[g>>2]|0)+11160>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28664]=1;i=d;return}function Zwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28768]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11144>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(28776,qNa(+h[(c[g>>2]|0)+11144>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28768]=1;i=d;return}function _wa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28880]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(28888,qNa(+h[(c[g>>2]|0)+11128>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28880]=1;i=d;return}function $wa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28984]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(28992,qNa(+h[(c[g>>2]|0)+11112>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28984]=1;i=d;return}function axa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29096]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(29104,qNa(+h[(c[g>>2]|0)+11096>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[29096]=1;i=d;return}function bxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29200]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(29208,qNa(+h[(c[g>>2]|0)+11080>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[29200]=1;i=d;return}function cxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29312]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(29320,qNa(+h[(c[g>>2]|0)+11064>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[29312]=1;i=d;return}function dxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29416]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(29424,qNa(+h[(c[g>>2]|0)+11048>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[29416]=1;i=d;return}function exa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29528]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(29536,qNa(+h[(c[g>>2]|0)+11032>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[29528]=1;i=d;return}function fxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29632]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(29640,qNa(+h[(c[g>>2]|0)+11016>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[29632]=1;i=d;return}function gxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29744]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+11e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(29752,qNa(+h[(c[g>>2]|0)+11e3>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[29744]=1;i=d;return}function hxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29848]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(29856,qNa(+h[(c[g>>2]|0)+10984>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[29848]=1;i=d;return}function ixa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29960]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(29968,qNa(+h[(c[g>>2]|0)+10968>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[29960]=1;i=d;return}function jxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30064]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(30072,qNa(+h[(c[g>>2]|0)+10952>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[30064]=1;i=d;return}function kxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30176]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(30184,qNa(+h[(c[g>>2]|0)+10896>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[30176]=1;i=d;return}function lxa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30272]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+528>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+528>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(30280,sNa(c[(c[g>>2]|0)+528>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=41408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[30272]=1;i=d;return}function mxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30488]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(30496,qNa(+h[(c[g>>2]|0)+10848>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[30488]=1;i=d;return}function nxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30568]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10792>>3],1.0)|0)<<24>>24==0)){i=d;return}b=uNa(30576,qNa(+h[(c[g>>2]|0)+10792>>3],21128)|0)|0;g=c[41886]|0;j=e;k=37768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[30568]=1;i=d;return}function oxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30696]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(30704,qNa(+h[(c[g>>2]|0)+10768>>3],21128)|0)|0;g=c[41886]|0;j=e;k=37896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[30696]=1;i=d;return}function pxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30800]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10760>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(30808,qNa(+h[(c[g>>2]|0)+10760>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[30800]=1;i=d;return}function qxa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30904]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+524>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+524>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(30912,sNa(c[(c[g>>2]|0)+524>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=38248;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[30904]=1;i=d;return}function rxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31104]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10752>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(31112,qNa(+h[(c[g>>2]|0)+10752>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[31104]=1;i=d;return}function sxa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31232]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+520>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+520>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=uNa(31240,sNa(c[(c[g>>2]|0)+520>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=38656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[31232]=1;i=d;return}function txa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31464]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10656>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(31472,qNa(+h[(c[g>>2]|0)+10656>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[31464]=1;i=d;return}function uxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31576]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(31584,qNa(+h[(c[g>>2]|0)+10576>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[31576]=1;i=d;return}function vxa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31672]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+516>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+516>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(31680,sNa(c[(c[g>>2]|0)+516>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=39136;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[31672]=1;i=d;return}function wxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31872]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(31880,qNa(+h[(c[g>>2]|0)+10544>>3],21128)|0)|0;g=c[41886]|0;j=e;k=39272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[31872]=1;i=d;return}function xxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31984]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(31992,qNa(+h[(c[g>>2]|0)+10520>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[31984]=1;i=d;return}function yxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32088]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(32096,qNa(+h[(c[g>>2]|0)+10504>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[32088]=1;i=d;return}function zxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32200]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(32208,qNa(+h[(c[g>>2]|0)+10488>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[32200]=1;i=d;return}function Axa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32304]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(32312,qNa(+h[(c[g>>2]|0)+10472>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[32304]=1;i=d;return}function Bxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32416]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(32424,qNa(+h[(c[g>>2]|0)+10456>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[32416]=1;i=d;return}function Cxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32520]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(32528,qNa(+h[(c[g>>2]|0)+10440>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[32520]=1;i=d;return}function Dxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32632]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(32640,qNa(+h[(c[g>>2]|0)+10424>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[32632]=1;i=d;return}function Exa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32736]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(32744,qNa(+h[(c[g>>2]|0)+10408>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[32736]=1;i=d;return}



function AK(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1048>>3]*+h[b+1056>>3];e=c[a+416>>2]|0;h[b+1088>>3]=+h[b+1040>>3]*1.53+(d*.81+(+h[e+3928>>3]*+h[b+1104>>3]+(d*-1.25- +h[e+3936>>3]*+h[b+1096>>3])));i=i;return}function BK(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1032>>3];e=c[a+416>>2]|0;f=+h[e+3824>>3];g=+h[b+1056>>3];j=+h[b+1048>>3];k=+h[e+3816>>3];l=+h[e+3808>>3];m=j*k-g*l;n=+h[b+1064>>3];o=l*n-f*j;p=+h[b+1040>>3];q=f*g-k*n;r=+h[b+1024>>3];h[b+856>>3]=+h[b+1168>>3]+(+h[b+1296>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+976>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1272>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function CK(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+4560>>3];f=+h[b+752>>3];g=+h[b+744>>3];j=+h[d+4576>>3];k=+h[d+4568>>3];l=+h[b+736>>3];h[b+792>>3]=+h[d+8416>>3]*(+h[b+976>>3]*+h[b+856>>3]+(+h[b+984>>3]*(+h[b+864>>3]+ +h[d+6720>>3])+(+h[b+992>>3]*+h[b+872>>3]+(+h[b+632>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+616>>3])))));i=i;return}function DK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2696>>3]=+h[b+5904>>3]*+h[b+2600>>3]+(+h[b+2848>>3]*+h[b+1296>>3]+(+h[b+5920>>3]*+h[b+2624>>3]+ +h[b+2856>>3]*+h[b+1272>>3]));i=i;return}function EK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2648>>3]=+h[b+5856>>3]*+h[b+2600>>3]+(+h[b+2832>>3]*+h[b+1296>>3]+(+h[b+5872>>3]*+h[b+2624>>3]+ +h[b+2840>>3]*+h[b+1272>>3]));i=i;return}function FK(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1336>>3];e=c[a+416>>2]|0;f=+h[e+3192>>3];g=+h[b+1344>>3];j=+h[e+3184>>3];k=+h[e+3176>>3];l=+h[b+1328>>3];h[b+1192>>3]=+h[b+1472>>3]+(+h[b+1296>>3]*(d*f-g*j)+(+h[b+1576>>3]*(g*k-f*l)+ +h[b+1552>>3]*(j*l-d*k)));i=i;return}function GK(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1056>>3];e=c[a+416>>2]|0;f=+h[e+3824>>3];g=+h[b+1064>>3];j=+h[e+3816>>3];k=+h[e+3808>>3];l=+h[b+1048>>3];h[b+880>>3]=+h[b+1192>>3]+(+h[b+1296>>3]*(d*f-g*j)+(+h[b+976>>3]*(g*k-f*l)+ +h[b+1272>>3]*(j*l-d*k)));i=i;return}function HK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1e3>>3]=+h[b+5904>>3]*+h[b+1296>>3]+ +h[b+5920>>3]*+h[b+1272>>3];i=i;return}function IK(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+4568>>3];f=+h[b+736>>3];g=+h[b+752>>3];j=+h[d+4560>>3];k=+h[d+4576>>3];l=+h[b+744>>3];h[b+800>>3]=+h[d+8416>>3]*(+h[b+1e3>>3]*+h[b+856>>3]+(+h[b+1008>>3]*(+h[b+864>>3]+ +h[d+6720>>3])+(+h[b+1016>>3]*+h[b+872>>3]+(+h[b+616>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+624>>3])))));i=i;return}function JK(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+744>>3]*+h[b+752>>3];e=c[a+416>>2]|0;h[b+760>>3]=+h[b+616>>3]*.001+(d*.001+(+h[e+4568>>3]*+h[b+800>>3]+(d*-.001- +h[e+4576>>3]*+h[b+792>>3])));i=i;return}function KK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+952>>3]=+h[b+5856>>3]*+h[b+1296>>3]+ +h[b+5872>>3]*+h[b+1272>>3];i=i;return}function LK(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+4576>>3];f=+h[b+744>>3];g=+h[b+736>>3];j=+h[d+4568>>3];k=+h[d+4560>>3];l=+h[b+752>>3];h[b+784>>3]=+h[d+8416>>3]*(+h[b+952>>3]*+h[b+856>>3]+(+h[b+960>>3]*(+h[b+864>>3]+ +h[d+6720>>3])+(+h[b+968>>3]*+h[b+872>>3]+(+h[b+624>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+632>>3])))));i=i;return}function MK(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+752>>3]*+h[b+736>>3];e=c[a+416>>2]|0;h[b+768>>3]=+h[b+624>>3]*.001+(d*.001+(+h[e+4576>>3]*+h[b+784>>3]+(d*-.001- +h[e+4560>>3]*+h[b+800>>3])));i=i;return}function NK(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+736>>3]*+h[b+744>>3];e=c[a+416>>2]|0;h[b+776>>3]=+h[b+632>>3]*.001+(d*.001+(+h[e+4560>>3]*+h[b+792>>3]+(d*-.001- +h[e+4568>>3]*+h[b+784>>3])));i=i;return}function OK(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+624>>3];e=c[a+416>>2]|0;f=+h[e+4456>>3];g=+h[b+744>>3];j=+h[b+736>>3];k=+h[e+4448>>3];l=+h[e+4440>>3];m=j*k-g*l;n=+h[b+752>>3];o=l*n-f*j;p=+h[b+632>>3];q=f*g-k*n;r=+h[b+616>>3];h[b+664>>3]=+h[b+856>>3]+(+h[b+952>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+976>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1e3>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function PK(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+5200>>3];f=+h[d+5192>>3];g=+h[b+736>>3];j=+h[b+752>>3];k=+h[d+5208>>3];l=+h[b+744>>3];h[b+944>>3]=+h[d+8616>>3]*(+h[b+624>>3]*f-(g*(f*j-g*k)-l*(k*l-e*j))- +h[b+616>>3]*e- +h[b+1016>>3]*+h[b+680>>3]- +h[b+1008>>3]*(+h[b+672>>3]+ +h[d+6720>>3])- +h[b+1e3>>3]*+h[b+664>>3]);i=i;return}function QK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2176>>3]=+h[b+944>>3]- +h[b+800>>3];i=i;return}function RK(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+5208>>3];f=+h[d+5200>>3];g=+h[b+744>>3];j=+h[b+736>>3];k=+h[d+5192>>3];l=+h[b+752>>3];h[b+928>>3]=+h[d+8616>>3]*(+h[b+632>>3]*f-(g*(f*j-g*k)-l*(k*l-e*j))- +h[b+624>>3]*e- +h[b+968>>3]*+h[b+680>>3]- +h[b+960>>3]*(+h[b+672>>3]+ +h[d+6720>>3])- +h[b+952>>3]*+h[b+664>>3]);i=i;return}function SK(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+752>>3]*+h[b+736>>3];e=c[a+416>>2]|0;h[b+912>>3]=+h[b+624>>3]*-.001+(d*-.001+(+h[e+5208>>3]*+h[b+928>>3]+(d*.001- +h[e+5192>>3]*+h[b+944>>3])));i=i;return}function TK(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+840>>3]=+h[b+4440>>3]*+h[d+944>>3]+(-(+h[b+4456>>3]*+h[d+928>>3])- +h[d+912>>3]);i=i;return}function UK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2392>>3]=+h[b+840>>3]+ +h[b+768>>3];i=i;return}function VK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6352>>3]=-+h[b+6328>>3]- +h[b+2392>>3];i=i;return}function WK(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+12648>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6352>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+6360|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+6360|0;q=p;h[q>>3]=n;i=d;return}k=l/+YMa(c[b+536>>2]|0,e,18160,18152,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+6360|0;q=p;h[q>>3]=n;i=d;return}function XK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6456>>3]=+h[(c[a+416>>2]|0)+12464>>3]*+h[b+6448>>3]+ +h[b+6360>>3];i=i;return}function YK(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+12472>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6456>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+16|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+16|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,18192,18184,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+16|0;p=o;h[p>>3]=m;i=d;return}function ZK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6632>>3]=+h[b+9376>>3]*+h[b+16>>3];i=i;return}function _K(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6648>>3]=+h[b+6632>>3]+ +h[b+6408>>3];i=i;return}function $K(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,0)|0;d=c[(c[a+476>>2]|0)+28>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6552>>3]=+h[d>>3];h[e+6544>>3]=+h[d+8>>3];h[e+8>>3]=+h[d+16>>3];i=b;return}function aL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6536>>3]=+h[b+6552>>3]*+h[b+6544>>3];i=i;return}function bL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6528>>3]=+h[b+8>>3]*+h[b+6544>>3];i=i;return}function cL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6624>>3]=+h[b+6632>>3]*+h[b+16>>3];i=i;return}function dL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6640>>3]=+h[b+6544>>3]- +h[b+16>>3];i=i;return}function eL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6464>>3]=+h[(c[a+416>>2]|0)+12448>>3]*+h[b+16>>3];i=i;return}function fL(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,1)|0;d=c[(c[a+476>>2]|0)+92>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6520>>3]=+h[d>>3];h[e+6512>>3]=+h[d+8>>3];h[e+6496>>3]=+h[d+16>>3];i=b;return}function gL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6488>>3]=+h[b+6496>>3]*+h[b+6512>>3];i=i;return}function hL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6592>>3]=+h[b+6520>>3]- +h[b+6568>>3];i=i;return}function iL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9352>>3];k=+h[g+6592>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6584|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6584|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,18224,18216,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6584|0;p=o;h[p>>3]=m;i=d;return}function jL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6656>>3]=+h[b+6584>>3]- +h[b+6600>>3];i=i;return}function kL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6480>>3]=+h[b+6600>>3]-(-+h[b+6656>>3]- +h[b+6640>>3]- +h[b+6512>>3]);i=i;return}function lL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6576>>3]=+h[b+6592>>3]*+h[b+6584>>3];i=i;return}function mL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6616>>3]=+h[b+9368>>3]*+h[b+6584>>3];i=i;return}function nL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6608>>3]=+h[b+6616>>3]*+h[b+6584>>3];i=i;return}function oL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6664>>3]=+h[b+6616>>3]+ +h[b+6520>>3];i=i;return}function pL(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+12456>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6664>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+6696|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+6696|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,18264,18256,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6696|0;p=o;h[p>>3]=m;i=d;return}function qL(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=+h[(c[b+416>>2]|0)+12568>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6696>>3]-e*+h[j+6368>>3];if(e!=0.0){l=j;m=k/e;h[l>>3]=m;i=d;return}if(k==0.0){l=j;m=k;h[l>>3]=m;i=d;return}n=k/+YMa(c[b+536>>2]|0,e,18296,18288,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=n;h[l>>3]=m;i=d;return}function rL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6504>>3]=+h[b+6520>>3]*+h[b+6512>>3];i=i;return}function sL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2184>>3]=+h[b+928>>3]- +h[b+784>>3];i=i;return}function tL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1248>>3]=+h[b+5872>>3]*+h[b+2184>>3]+ +h[b+5920>>3]*+h[b+2176>>3];i=i;return}function uL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2208>>3]=+h[b+1248>>3]- +h[b+1112>>3];i=i;return}function vL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1232>>3]=+h[b+5856>>3]*+h[b+2184>>3]+ +h[b+5904>>3]*+h[b+2176>>3];i=i;return}function wL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1512>>3]=+h[b+1232>>3]- +h[b+1096>>3];i=i;return}function xL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2248>>3]=+h[b+1512>>3]- +h[b+1376>>3];i=i;return}function yL(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1152>>3]=+h[b+3808>>3]*+h[d+1248>>3]+ +h[d+2392>>3]- +h[b+3824>>3]*+h[d+1232>>3];i=i;return}function zL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2200>>3]=-+h[b+1152>>3]- +h[b+1080>>3];i=i;return}function AL(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+5192>>3];f=+h[d+5208>>3];g=+h[b+752>>3];j=+h[b+744>>3];k=+h[d+5200>>3];l=+h[b+736>>3];h[b+936>>3]=+h[d+8616>>3]*(+h[b+616>>3]*f-(g*(f*j-g*k)-l*(k*l-e*j))- +h[b+632>>3]*e- +h[b+992>>3]*+h[b+680>>3]- +h[b+984>>3]*(+h[b+672>>3]+ +h[d+6720>>3])- +h[b+976>>3]*+h[b+664>>3]);i=i;return}function BL(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+744>>3]*+h[b+752>>3];e=c[a+416>>2]|0;h[b+904>>3]=+h[b+616>>3]*-.001+(d*-.001+(+h[e+5200>>3]*+h[b+944>>3]+(d*.001- +h[e+5208>>3]*+h[b+936>>3])));i=i;return}function CL(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+832>>3]=+h[b+4456>>3]*+h[d+936>>3]+(-(+h[b+4448>>3]*+h[d+944>>3])- +h[d+904>>3]);i=i;return}function DL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2168>>3]=-+h[b+832>>3]- +h[b+760>>3];i=i;return}function EL(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+736>>3]*+h[b+744>>3];e=c[a+416>>2]|0;h[b+920>>3]=+h[b+632>>3]*-.001+(d*-.001+(+h[e+5192>>3]*+h[b+936>>3]+(d*.001- +h[e+5200>>3]*+h[b+928>>3])));i=i;return}function FL(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+848>>3]=+h[b+4448>>3]*+h[d+928>>3]+(-(+h[b+4440>>3]*+h[d+936>>3])- +h[d+920>>3]);i=i;return}function GL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2160>>3]=-+h[b+848>>3]- +h[b+776>>3];i=i;return}function HL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1216>>3]=+h[b+5872>>3]*+h[b+2168>>3]+ +h[b+5920>>3]*+h[b+2160>>3];i=i;return}function IL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1224>>3]=+h[b+5856>>3]*+h[b+2168>>3]+ +h[b+5904>>3]*+h[b+2160>>3];i=i;return}function JL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1240>>3]=+h[b+936>>3]- +h[b+792>>3];i=i;return}function KL(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1160>>3]=+h[b+3816>>3]*+h[d+1232>>3]+(-(+h[b+3808>>3]*+h[d+1240>>3])- +h[d+1216>>3]);i=i;return}function LL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2192>>3]=-+h[b+1160>>3]- +h[b+1088>>3];i=i;return}function ML(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1504>>3]=+h[b+5800>>3]*+h[b+2200>>3]+ +h[b+5824>>3]*+h[b+2192>>3];i=i;return}function NL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1496>>3]=+h[b+5808>>3]*+h[b+2200>>3]+ +h[b+5832>>3]*+h[b+2192>>3];i=i;return}function OL(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1144>>3]=+h[b+3824>>3]*+h[d+1240>>3]+(-(+h[b+3816>>3]*+h[d+1248>>3])- +h[d+1224>>3]);i=i;return}function PL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2384>>3]=+h[b+1144>>3]+ +h[b+1072>>3];i=i;return}function QL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6736>>3]=-+h[b+6712>>3]- +h[b+2384>>3];i=i;return}function RL(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+12024>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6736>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+6744|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+6744|0;q=p;h[q>>3]=n;i=d;return}k=l/+YMa(c[b+536>>2]|0,e,18328,18320,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+6744|0;q=p;h[q>>3]=n;i=d;return}function SL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6840>>3]=+h[(c[a+416>>2]|0)+11840>>3]*+h[b+6832>>3]+ +h[b+6744>>3];i=i;return}function TL(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+11848>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6840>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+48|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+48|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,18360,18352,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+48|0;p=o;h[p>>3]=m;i=d;return}function UL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7016>>3]=+h[b+9456>>3]*+h[b+48>>3];i=i;return}function VL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7032>>3]=+h[b+7016>>3]+ +h[b+6792>>3];i=i;return}function WL(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,2)|0;d=c[(c[a+476>>2]|0)+156>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6936>>3]=+h[d>>3];h[e+6928>>3]=+h[d+8>>3];h[e+40>>3]=+h[d+16>>3];i=b;return}function XL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6920>>3]=+h[b+6936>>3]*+h[b+6928>>3];i=i;return}function YL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6912>>3]=+h[b+40>>3]*+h[b+6928>>3];i=i;return}function ZL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7008>>3]=+h[b+7016>>3]*+h[b+48>>3];i=i;return}function _L(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7024>>3]=+h[b+6928>>3]- +h[b+48>>3];i=i;return}function $L(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6848>>3]=+h[(c[a+416>>2]|0)+11824>>3]*+h[b+48>>3];i=i;return}function aM(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,3)|0;d=c[(c[a+476>>2]|0)+220>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6880>>3]=+h[d>>3];h[e+6896>>3]=+h[d+8>>3];h[e+6904>>3]=+h[d+16>>3];i=b;return}function bM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6976>>3]=+h[b+6904>>3]- +h[b+6952>>3];i=i;return}function cM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9432>>3];k=+h[g+6976>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6968|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6968|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,18392,18384,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6968|0;p=o;h[p>>3]=m;i=d;return}function dM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7040>>3]=+h[b+6968>>3]- +h[b+6984>>3];i=i;return}function eM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6960>>3]=+h[b+6976>>3]*+h[b+6968>>3];i=i;return}function fM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7e3>>3]=+h[b+9448>>3]*+h[b+6968>>3];i=i;return}function gM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6992>>3]=+h[b+7e3>>3]*+h[b+6968>>3];i=i;return}function hM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7048>>3]=+h[b+7e3>>3]+ +h[b+6904>>3];i=i;return}function iM(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+11832>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7048>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7080|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7080|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,18432,18424,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7080|0;p=o;h[p>>3]=m;i=d;return}function jM(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+11944>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7080>>3]-e*+h[j+6752>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+32|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+32|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,18464,18456,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+32|0;p=o;h[p>>3]=m;i=d;return}function kM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6864>>3]=+h[b+6984>>3]-(-+h[b+7040>>3]- +h[b+7024>>3]- +h[b+6896>>3]);i=i;return}function lM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6888>>3]=+h[b+6904>>3]*+h[b+6896>>3];i=i;return}function mM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6872>>3]=+h[b+6880>>3]*+h[b+6896>>3];i=i;return}function nM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2216>>3]=+h[b+1240>>3]- +h[b+1104>>3];i=i;return}function oM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1528>>3]=+h[b+5808>>3]*+h[b+2216>>3]+ +h[b+5832>>3]*+h[b+2208>>3];i=i;return}function pM(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1432>>3]=+h[b+3176>>3]*+h[d+1528>>3]+(-(+h[b+3192>>3]*+h[d+1512>>3])- +h[d+1504>>3]);i=i;return}function qM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2376>>3]=+h[b+1432>>3]+ +h[b+1360>>3];i=i;return}function rM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7120>>3]=-+h[b+7096>>3]- +h[b+2376>>3];i=i;return}function sM(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+11400>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7120>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+7128|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+7128|0;q=p;h[q>>3]=n;i=d;return}k=l/+YMa(c[b+536>>2]|0,e,18496,18488,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+7128|0;q=p;h[q>>3]=n;i=d;return}function tM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7224>>3]=+h[(c[a+416>>2]|0)+11216>>3]*+h[b+7216>>3]+ +h[b+7128>>3];i=i;return}function uM(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+11224>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7224>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+80|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+80|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,18528,18520,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+80|0;p=o;h[p>>3]=m;i=d;return}function vM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7400>>3]=+h[b+9536>>3]*+h[b+80>>3];i=i;return}function wM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7416>>3]=+h[b+7400>>3]+ +h[b+7176>>3];i=i;return}function xM(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,4)|0;d=c[(c[a+476>>2]|0)+284>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7320>>3]=+h[d>>3];h[e+7312>>3]=+h[d+8>>3];h[e+72>>3]=+h[d+16>>3];i=b;return}function yM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7304>>3]=+h[b+7320>>3]*+h[b+7312>>3];i=i;return}function zM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7296>>3]=+h[b+72>>3]*+h[b+7312>>3];i=i;return}function AM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7392>>3]=+h[b+7400>>3]*+h[b+80>>3];i=i;return}function BM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7408>>3]=+h[b+7312>>3]- +h[b+80>>3];i=i;return}function CM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7232>>3]=+h[(c[a+416>>2]|0)+11200>>3]*+h[b+80>>3];i=i;return}function DM(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,5)|0;d=c[(c[a+476>>2]|0)+348>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7288>>3]=+h[d>>3];h[e+7280>>3]=+h[d+8>>3];h[e+7264>>3]=+h[d+16>>3];i=b;return}function EM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7256>>3]=+h[b+7264>>3]*+h[b+7280>>3];i=i;return}function FM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7360>>3]=+h[b+7288>>3]- +h[b+7336>>3];i=i;return}function GM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9512>>3];k=+h[g+7360>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+7352|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+7352|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,18560,18552,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7352|0;p=o;h[p>>3]=m;i=d;return}function HM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7424>>3]=+h[b+7352>>3]- +h[b+7368>>3];i=i;return}function IM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7248>>3]=+h[b+7368>>3]-(-+h[b+7424>>3]- +h[b+7408>>3]- +h[b+7280>>3]);i=i;return}function JM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7344>>3]=+h[b+7360>>3]*+h[b+7352>>3];i=i;return}function KM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7384>>3]=+h[b+9528>>3]*+h[b+7352>>3];i=i;return}function LM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7376>>3]=+h[b+7384>>3]*+h[b+7352>>3];i=i;return}function MM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7432>>3]=+h[b+7384>>3]+ +h[b+7288>>3];i=i;return}function NM(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+11208>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7432>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7464|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7464|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,18600,18592,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7464|0;p=o;h[p>>3]=m;i=d;return}function OM(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+11320>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7464>>3]-e*+h[j+7136>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+64|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+64|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,18632,18624,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+64|0;p=o;h[p>>3]=m;i=d;return}function PM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7272>>3]=+h[b+7288>>3]*+h[b+7280>>3];i=i;return}function QM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2240>>3]=+h[b+1528>>3]- +h[b+1392>>3];i=i;return}function RM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1808>>3]=+h[b+5696>>3]*+h[b+2248>>3]+ +h[b+5744>>3]*+h[b+2240>>3];i=i;return}function SM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2272>>3]=+h[b+1808>>3]- +h[b+1672>>3];i=i;return}function TM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1792>>3]=+h[b+5680>>3]*+h[b+2248>>3]+ +h[b+5728>>3]*+h[b+2240>>3];i=i;return}function UM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1960>>3]=+h[b+1792>>3]- +h[b+1656>>3];i=i;return}function VM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2096>>3]=+h[b+1960>>3]- +h[b+1896>>3];i=i;return}function WM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2344>>3]=+h[b+2096>>3]- +h[b+2864>>3];i=i;return}function XM(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1712>>3]=+h[b+2544>>3]*+h[d+1808>>3]+ +h[d+2376>>3]- +h[b+2560>>3]*+h[d+1792>>3];i=i;return}function YM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2264>>3]=-+h[b+1712>>3]- +h[b+1640>>3];i=i;return}function ZM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1520>>3]=+h[b+5800>>3]*+h[b+2216>>3]+ +h[b+5824>>3]*+h[b+2208>>3];i=i;return}function _M(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1424>>3]=+h[b+3192>>3]*+h[d+1520>>3]+ +h[d+2384>>3]- +h[b+3184>>3]*+h[d+1528>>3];i=i;return}function $M(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2232>>3]=-+h[b+1424>>3]- +h[b+1352>>3];i=i;return}function aN(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1440>>3]=+h[b+3184>>3]*+h[d+1512>>3]+(-(+h[b+3176>>3]*+h[d+1520>>3])- +h[d+1496>>3]);i=i;return}function bN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2224>>3]=-+h[b+1440>>3]- +h[b+1368>>3];i=i;return}function cN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1776>>3]=+h[b+5696>>3]*+h[b+2232>>3]+ +h[b+5744>>3]*+h[b+2224>>3];i=i;return}function dN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1784>>3]=+h[b+5680>>3]*+h[b+2232>>3]+ +h[b+5728>>3]*+h[b+2224>>3];i=i;return}function eN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1800>>3]=+h[b+1520>>3]- +h[b+1384>>3];i=i;return}function fN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2280>>3]=+h[b+1800>>3]- +h[b+1664>>3];i=i;return}function gN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1976>>3]=+h[b+5632>>3]*+h[b+2280>>3]+ +h[b+5656>>3]*+h[b+2272>>3];i=i;return}function hN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2304>>3]=+h[b+1976>>3]- +h[b+1912>>3];i=i;return}function iN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1968>>3]=+h[b+5624>>3]*+h[b+2280>>3]+ +h[b+5648>>3]*+h[b+2272>>3];i=i;return}function jN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2312>>3]=+h[b+1968>>3]- +h[b+1904>>3];i=i;return}function kN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2104>>3]=+h[b+2016>>3]*+h[b+2312>>3]+ +h[b+1992>>3]*+h[b+2304>>3];i=i;return}function lN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2152>>3]=+h[b+2104>>3]- +h[b+2872>>3];i=i;return}function mN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2432>>3]=+h[b+2152>>3]- +h[b+3032>>3];i=i;return}function nN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2112>>3]=+h[b+5528>>3]*+h[b+2312>>3]+ +h[b+5520>>3]*+h[b+2304>>3];i=i;return}function oN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2336>>3]=+h[b+2112>>3]- +h[b+2880>>3];i=i;return}function pN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2440>>3]=+h[b+5392>>3]*+h[b+2344>>3]+ +h[b+5440>>3]*+h[b+2336>>3];i=i;return}function qN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2424>>3]=+h[b+5376>>3]*+h[b+2344>>3]+ +h[b+5424>>3]*+h[b+2336>>3];i=i;return}function rN(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1720>>3]=+h[b+2552>>3]*+h[d+1792>>3]+(-(+h[b+2544>>3]*+h[d+1800>>3])- +h[d+1776>>3]);i=i;return}function sN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2256>>3]=-+h[b+1720>>3]- +h[b+1648>>3];i=i;return}function tN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1952>>3]=+h[b+5624>>3]*+h[b+2264>>3]+ +h[b+5648>>3]*+h[b+2256>>3];i=i;return}function uN(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1928>>3]=+h[b+1912>>3]*+h[d+1976>>3]+(-(+h[b+1928>>3]*+h[d+1960>>3])- +h[d+1952>>3]);i=i;return}function vN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2296>>3]=-+h[b+1928>>3]- +h[b+1880>>3];i=i;return}function wN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1944>>3]=+h[b+5632>>3]*+h[b+2264>>3]+ +h[b+5656>>3]*+h[b+2256>>3];i=i;return}function xN(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1936>>3]=+h[b+1920>>3]*+h[d+1960>>3]+(-(+h[b+1912>>3]*+h[d+1968>>3])- +h[d+1944>>3]);i=i;return}function yN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2288>>3]=-+h[b+1936>>3]- +h[b+1888>>3];i=i;return}function zN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2080>>3]=+h[b+5528>>3]*+h[b+2296>>3]+ +h[b+5520>>3]*+h[b+2288>>3];i=i;return}function AN(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2072>>3]=+h[b+1288>>3]*+h[d+2096>>3]+(-(+h[b+1280>>3]*+h[d+2104>>3])- +h[d+2080>>3]);i=i;return}function BN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2320>>3]=-+h[b+2072>>3]- +h[b+2048>>3];i=i;return}function CN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2088>>3]=+h[b+2016>>3]*+h[b+2296>>3]+ +h[b+1992>>3]*+h[b+2288>>3];i=i;return}function DN(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2064>>3]=+h[b+1280>>3]*+h[d+2112>>3]+(-(+h[b+1296>>3]*+h[d+2096>>3])- +h[d+2088>>3]);i=i;return}function EN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2352>>3]=+h[b+2064>>3]+ +h[b+2040>>3];i=i;return}function FN(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2408>>3]=+h[b+664>>3]*+h[d+2424>>3]+(-(+h[b+648>>3]*+h[d+2440>>3])- +h[d+2352>>3]);i=i;return}function GN(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+9368>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2352>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+8360|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+8360|0;q=p;h[q>>3]=n;i=d;return}k=l/+YMa(c[b+536>>2]|0,e,18664,18656,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+8360|0;q=p;h[q>>3]=n;i=d;return}function HN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8368>>3]=+h[b+8296>>3]- +h[b+8360>>3];i=i;return}function IN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8456>>3]=+h[(c[a+416>>2]|0)+9168>>3]*+h[b+8328>>3]+ +h[b+8368>>3];i=i;return}function JN(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+9176>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+8456>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+232|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+232|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,18696,18688,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+232|0;p=o;h[p>>3]=m;i=d;return}function KN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8624>>3]=+h[b+9776>>3]*+h[b+232>>3];i=i;return}function LN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8640>>3]=+h[b+8624>>3]+ +h[b+8416>>3];i=i;return}function MN(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,6)|0;d=c[(c[a+476>>2]|0)+412>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8544>>3]=+h[d>>3];h[e+8536>>3]=+h[d+8>>3];h[e+224>>3]=+h[d+16>>3];i=b;return}function NN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8528>>3]=+h[b+8544>>3]*+h[b+8536>>3];i=i;return}function ON(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8520>>3]=+h[b+224>>3]*+h[b+8536>>3];i=i;return}function PN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8616>>3]=+h[b+8624>>3]*+h[b+232>>3];i=i;return}function QN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8632>>3]=+h[b+8536>>3]- +h[b+232>>3];i=i;return}function RN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8464>>3]=+h[(c[a+416>>2]|0)+9152>>3]*+h[b+232>>3];i=i;return}function SN(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,7)|0;d=c[(c[a+476>>2]|0)+476>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8488>>3]=+h[d>>3];h[e+8504>>3]=+h[d+8>>3];h[e+8512>>3]=+h[d+16>>3];i=b;return}function TN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8584>>3]=+h[b+8512>>3]- +h[b+8560>>3];i=i;return}function UN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9752>>3];k=+h[g+8584>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8576|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8576|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,18728,18720,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8576|0;p=o;h[p>>3]=m;i=d;return}function VN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8648>>3]=+h[b+8576>>3]- +h[b+8592>>3];i=i;return}function WN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8568>>3]=+h[b+8584>>3]*+h[b+8576>>3];i=i;return}function XN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8608>>3]=+h[b+9768>>3]*+h[b+8576>>3];i=i;return}function YN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8600>>3]=+h[b+8608>>3]*+h[b+8576>>3];i=i;return}function ZN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8656>>3]=+h[b+8608>>3]+ +h[b+8512>>3];i=i;return}function _N(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+9160>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+8656>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+8688|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8688|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,18768,18760,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8688|0;p=o;h[p>>3]=m;i=d;return}function $N(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8472>>3]=+h[b+8592>>3]-(-+h[b+8648>>3]- +h[b+8632>>3]- +h[b+8504>>3]);i=i;return}function aO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8496>>3]=+h[b+8512>>3]*+h[b+8504>>3];i=i;return}function bO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8480>>3]=+h[b+8488>>3]*+h[b+8504>>3];i=i;return}function cO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8344>>3]=+h[b+8360>>3]- +h[b+8336>>3];i=i;return}function dO(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+9384>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+8344>>3]+f*+h[e+9400>>3];if(f!=0.0){m=k;n=l/f;o=m;p=o+200|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+200|0;q=p;h[q>>3]=n;i=d;return}r=l/+YMa(c[b+536>>2]|0,f,18800,18792,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+200|0;q=p;h[q>>3]=n;i=d;return}function eO(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1704>>3]=+h[b+2560>>3]*+h[d+1800>>3]+(-(+h[b+2552>>3]*+h[d+1808>>3])- +h[d+1784>>3]);i=i;return}function fO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2368>>3]=+h[b+1704>>3]+ +h[b+1632>>3];i=i;return}function gO(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1920>>3]=+h[b+1928>>3]*+h[d+1968>>3]+ +h[d+2368>>3]- +h[b+1920>>3]*+h[d+1976>>3];i=i;return}function hO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2360>>3]=+h[b+1920>>3]+ +h[b+1872>>3];i=i;return}function iO(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2056>>3]=+h[b+1296>>3]*+h[d+2104>>3]+ +h[d+2360>>3]- +h[b+1288>>3]*+h[d+2112>>3];i=i;return}function jO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2328>>3]=-+h[b+2056>>3]- +h[b+2032>>3];i=i;return}function kO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2136>>3]=+h[b+5392>>3]*+h[b+2328>>3]+ +h[b+5440>>3]*+h[b+2320>>3];i=i;return}function lO(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2120>>3]=+h[b+656>>3]*+h[d+2424>>3]+(-(+h[b+648>>3]*+h[d+2152>>3])- +h[d+2136>>3]);i=i;return}function mO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2416>>3]=-+h[b+2120>>3]- +h[b+3016>>3];i=i;return}function nO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2144>>3]=+h[b+5376>>3]*+h[b+2328>>3]+ +h[b+5424>>3]*+h[b+2320>>3];i=i;return}function oO(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2128>>3]=+h[b+664>>3]*+h[d+2152>>3]+(-(+h[b+656>>3]*+h[d+2440>>3])- +h[d+2144>>3]);i=i;return}function pO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2400>>3]=-+h[b+2128>>3]- +h[b+3e3>>3];i=i;return}function qO(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+10056>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2360>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+7952|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+7952|0;q=p;h[q>>3]=n;i=d;return}k=l/+YMa(c[b+536>>2]|0,e,18832,18824,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+7952|0;q=p;h[q>>3]=n;i=d;return}function rO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7960>>3]=+h[b+7888>>3]- +h[b+7952>>3];i=i;return}function sO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8048>>3]=+h[(c[a+416>>2]|0)+9856>>3]*+h[b+7920>>3]+ +h[b+7960>>3];i=i;return}function tO(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+9864>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+8048>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+184|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+184|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,18864,18856,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+184|0;p=o;h[p>>3]=m;i=d;return}function uO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8216>>3]=+h[b+9696>>3]*+h[b+184>>3];i=i;return}function vO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8232>>3]=+h[b+8216>>3]+ +h[b+8008>>3];i=i;return}function wO(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,8)|0;d=c[(c[a+476>>2]|0)+540>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8136>>3]=+h[d>>3];h[e+8128>>3]=+h[d+8>>3];h[e+176>>3]=+h[d+16>>3];i=b;return}function xO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8120>>3]=+h[b+8136>>3]*+h[b+8128>>3];i=i;return}function yO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8112>>3]=+h[b+176>>3]*+h[b+8128>>3];i=i;return}function zO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8208>>3]=+h[b+8216>>3]*+h[b+184>>3];i=i;return}function AO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8224>>3]=+h[b+8128>>3]- +h[b+184>>3];i=i;return}function BO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8056>>3]=+h[(c[a+416>>2]|0)+9840>>3]*+h[b+184>>3];i=i;return}function CO(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,9)|0;d=c[(c[a+476>>2]|0)+604>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8080>>3]=+h[d>>3];h[e+8096>>3]=+h[d+8>>3];h[e+8104>>3]=+h[d+16>>3];i=b;return}function DO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8176>>3]=+h[b+8104>>3]- +h[b+8152>>3];i=i;return}function EO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9672>>3];k=+h[g+8176>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8168|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8168|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,18896,18888,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8168|0;p=o;h[p>>3]=m;i=d;return}function FO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8240>>3]=+h[b+8168>>3]- +h[b+8184>>3];i=i;return}function GO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8160>>3]=+h[b+8176>>3]*+h[b+8168>>3];i=i;return}function HO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8200>>3]=+h[b+9688>>3]*+h[b+8168>>3];i=i;return}function IO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8192>>3]=+h[b+8200>>3]*+h[b+8168>>3];i=i;return}function JO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8248>>3]=+h[b+8200>>3]+ +h[b+8104>>3];i=i;return}function KO(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+9848>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+8248>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+8280|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8280|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,18936,18928,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8280|0;p=o;h[p>>3]=m;i=d;return}function LO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8064>>3]=+h[b+8184>>3]-(-+h[b+8240>>3]- +h[b+8224>>3]- +h[b+8096>>3]);i=i;return}function MO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8088>>3]=+h[b+8104>>3]*+h[b+8096>>3];i=i;return}function NO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8072>>3]=+h[b+8080>>3]*+h[b+8096>>3];i=i;return}function OO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7936>>3]=+h[b+7952>>3]- +h[b+7928>>3];i=i;return}function PO(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+10072>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+7936>>3]+f*+h[e+10088>>3];if(f!=0.0){m=k;n=l/f;o=m;p=o+152|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+152|0;q=p;h[q>>3]=n;i=d;return}r=l/+YMa(c[b+536>>2]|0,f,18968,18960,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+152|0;q=p;h[q>>3]=n;i=d;return}function QO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7896>>3]=+h[b+160>>3]- +h[b+152>>3];i=i;return}function RO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7984>>3]=+h[b+8e3>>3]- +h[b+7896>>3];i=i;return}function SO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7976>>3]=+h[(c[a+416>>2]|0)+9952>>3]*+h[b+7984>>3];i=i;return}function TO(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7968>>3]=+h[b+9928>>3]*+h[d+7992>>3]+(+h[b+9936>>3]*+h[d+7976>>3]+ +h[b+9944>>3]*+h[d+8024>>3]);i=i;return}function UO(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+9960>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+8280>>3]-e*+h[j+7968>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+168|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+168|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,19e3,18992,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+168|0;p=o;h[p>>3]=m;i=d;return}function VO(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+9968>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7968>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+456|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+456|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,19032,19024,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+456|0;p=o;h[p>>3]=m;i=d;return}function WO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8032>>3]=+h[b+7896>>3]- +h[(c[a+416>>2]|0)+9872>>3];i=i;return}function XO(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+10744>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2368>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+7544|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+7544|0;q=p;h[q>>3]=n;i=d;return}k=l/+YMa(c[b+536>>2]|0,e,19064,19056,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+7544|0;q=p;h[q>>3]=n;i=d;return}function YO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7552>>3]=+h[b+7480>>3]- +h[b+7544>>3];i=i;return}function ZO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7640>>3]=+h[(c[a+416>>2]|0)+10544>>3]*+h[b+7512>>3]+ +h[b+7552>>3];i=i;return}function _O(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+10552>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7640>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+136|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+136|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,19096,19088,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+136|0;p=o;h[p>>3]=m;i=d;return}function $O(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7808>>3]=+h[b+9616>>3]*+h[b+136>>3];i=i;return}function aP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7824>>3]=+h[b+7808>>3]+ +h[b+7600>>3];i=i;return}function bP(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,10)|0;d=c[(c[a+476>>2]|0)+668>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7728>>3]=+h[d>>3];h[e+7720>>3]=+h[d+8>>3];h[e+128>>3]=+h[d+16>>3];i=b;return}function cP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7712>>3]=+h[b+7728>>3]*+h[b+7720>>3];i=i;return}function dP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7704>>3]=+h[b+128>>3]*+h[b+7720>>3];i=i;return}function eP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7800>>3]=+h[b+7808>>3]*+h[b+136>>3];i=i;return}function fP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7816>>3]=+h[b+7720>>3]- +h[b+136>>3];i=i;return}function gP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7648>>3]=+h[(c[a+416>>2]|0)+10528>>3]*+h[b+136>>3];i=i;return}function hP(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,11)|0;d=c[(c[a+476>>2]|0)+732>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7696>>3]=+h[d>>3];h[e+7688>>3]=+h[d+8>>3];h[e+7672>>3]=+h[d+16>>3];i=b;return}function iP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7664>>3]=+h[b+7672>>3]*+h[b+7688>>3];i=i;return}function jP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7768>>3]=+h[b+7696>>3]- +h[b+7744>>3];i=i;return}function kP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9592>>3];k=+h[g+7768>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+7760|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+7760|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,19128,19120,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7760|0;p=o;h[p>>3]=m;i=d;return}function lP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7832>>3]=+h[b+7760>>3]- +h[b+7776>>3];i=i;return}function mP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7656>>3]=+h[b+7776>>3]-(-+h[b+7832>>3]- +h[b+7816>>3]- +h[b+7688>>3]);i=i;return}function nP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7752>>3]=+h[b+7768>>3]*+h[b+7760>>3];i=i;return}function oP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7792>>3]=+h[b+9608>>3]*+h[b+7760>>3];i=i;return}function pP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7784>>3]=+h[b+7792>>3]*+h[b+7760>>3];i=i;return}function qP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7840>>3]=+h[b+7792>>3]+ +h[b+7696>>3];i=i;return}function rP(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+10536>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7840>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7872|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7872|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,19168,19160,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7872|0;p=o;h[p>>3]=m;i=d;return}function sP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7680>>3]=+h[b+7696>>3]*+h[b+7688>>3];i=i;return}function tP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7528>>3]=+h[b+7544>>3]- +h[b+7520>>3];i=i;return}function uP(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+10760>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+7528>>3]+f*+h[e+10776>>3];if(f!=0.0){m=k;n=l/f;o=m;p=o+104|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+104|0;q=p;h[q>>3]=n;i=d;return}r=l/+YMa(c[b+536>>2]|0,f,19200,19192,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+104|0;q=p;h[q>>3]=n;i=d;return}function vP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7488>>3]=+h[b+112>>3]- +h[b+104>>3];i=i;return}function wP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7576>>3]=+h[b+7592>>3]- +h[b+7488>>3];i=i;return}function xP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7568>>3]=+h[(c[a+416>>2]|0)+10640>>3]*+h[b+7576>>3];i=i;return}function yP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7560>>3]=+h[b+10616>>3]*+h[d+7584>>3]+(+h[b+10624>>3]*+h[d+7568>>3]+ +h[b+10632>>3]*+h[d+7616>>3]);i=i;return}function zP(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+10648>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7872>>3]-e*+h[j+7560>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+120|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+120|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,19232,19224,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+120|0;p=o;h[p>>3]=m;i=d;return}function AP(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+10656>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7560>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,19264,19256,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}function BP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7624>>3]=+h[b+7488>>3]- +h[(c[a+416>>2]|0)+10560>>3];i=i;return}function CP(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+744>>3];e=c[a+416>>2]|0;f=+h[e+4456>>3];g=+h[b+752>>3];j=+h[e+4448>>3];k=+h[e+4440>>3];l=+h[b+736>>3];h[b+688>>3]=+h[b+880>>3]+(+h[b+952>>3]*(d*f-g*j)+(+h[b+976>>3]*(g*k-f*l)+ +h[b+1e3>>3]*(j*l-d*k)));i=i;return}function DP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3144>>3]=+h[b+648>>3]+(+h[d+5376>>3]*+h[b+1280>>3]+ +h[d+5424>>3]*+h[b+1296>>3]);i=i;return}function EP(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1680>>3]=+h[b+3144>>3]+(+h[b+5376>>3]*+h[d+1912>>3]+(+h[b+2024>>3]*+h[d+1920>>3]+ +h[b+2e3>>3]*+h[d+1928>>3]));i=i;return}function FP(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1400>>3]=+h[b+1680>>3]+(+h[b+5376>>3]*+h[d+2544>>3]+(+h[b+1576>>3]*+h[d+2552>>3]+ +h[b+1832>>3]*+h[d+2560>>3]));i=i;return}function GP(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1120>>3]=+h[b+1400>>3]+(+h[b+1296>>3]*+h[d+3176>>3]+(+h[b+1576>>3]*+h[d+3184>>3]+ +h[b+1552>>3]*+h[d+3192>>3]));i=i;return}function HP(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+808>>3]=+h[b+1120>>3]+(+h[b+1296>>3]*+h[d+3808>>3]+(+h[b+976>>3]*+h[d+3816>>3]+ +h[b+1272>>3]*+h[d+3824>>3]));i=i;return}function IP(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+640>>3]=+h[b+808>>3]+(+h[b+952>>3]*+h[d+4440>>3]+(+h[b+976>>3]*+h[d+4448>>3]+ +h[b+1e3>>3]*+h[d+4456>>3]));i=i;return}function JP(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+712>>3]=+h[b+640>>3]+(+h[b+952>>3]*+h[d+5072>>3]+(+h[b+976>>3]*+h[d+5080>>3]+ +h[b+1e3>>3]*+h[d+5088>>3]));i=i;return}function KP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+208>>3]=+h[(c[a+416>>2]|0)+9368>>3]*+h[b+8672>>3];i=i;return}function LP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8304>>3]=+h[b+208>>3]- +h[b+200>>3];i=i;return}function MP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8392>>3]=+h[b+8408>>3]- +h[b+8304>>3];i=i;return}function NP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8384>>3]=+h[(c[a+416>>2]|0)+9264>>3]*+h[b+8392>>3];i=i;return}function OP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8376>>3]=+h[b+9240>>3]*+h[d+8400>>3]+(+h[b+9248>>3]*+h[d+8384>>3]+ +h[b+9256>>3]*+h[d+8432>>3]);i=i;return}function PP(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+9272>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+8688>>3]-e*+h[j+8376>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+216|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+216|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,19296,19288,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+216|0;p=o;h[p>>3]=m;i=d;return}function QP(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+9280>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+8376>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+504|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+504|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,19328,19320,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+504|0;p=o;h[p>>3]=m;i=d;return}function RP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8440>>3]=+h[b+8304>>3]- +h[(c[a+416>>2]|0)+9184>>3];i=i;return}function SP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10736>>3]=+h[b+10192>>3];i=i;return}function TP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10048>>3]=+h[b+9504>>3];i=i;return}function UP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9360>>3]=+h[b+8816>>3];i=i;return}function VP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5624>>3]=+h[b+6568>>3];i=i;return}function WP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5616>>3]=+h[b+6560>>3];i=i;return}function XP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5608>>3]=+h[b+6552>>3];i=i;return}function YP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5600>>3]=+h[b+6544>>3];i=i;return}function ZP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5592>>3]=+h[b+6536>>3];i=i;return}function _P(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5584>>3]=+h[b+6528>>3];i=i;return}function $P(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5576>>3]=+h[b+6520>>3];i=i;return}function aQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5568>>3]=+h[b+6512>>3];i=i;return}function bQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5560>>3]=+h[b+6504>>3];i=i;return}function cQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5552>>3]=+h[b+6496>>3];i=i;return}function dQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5544>>3]=+h[b+6488>>3];i=i;return}function eQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5536>>3]=+h[b+6480>>3];i=i;return}function fQ(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+124>>2]=c[b+116>>2];i=i;return}function gQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6840>>3]=+h[b+6744>>3]/9.0;i=i;return}function hQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7272>>3]=+h[b+6840>>3];i=i;return}function iQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7280>>3]=+h[b+7272>>3]/3.0;i=i;return}function jQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7472>>3]=+h[b+6840>>3];i=i;return}function kQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7480>>3]=+h[b+7472>>3]/3.0;i=i;return}function lQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7672>>3]=+h[b+6840>>3];i=i;return}function mQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7680>>3]=+h[b+7672>>3]/3.0;i=i;return}function nQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7872>>3]=+h[b+6840>>3];i=i;return}function oQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7880>>3]=+h[b+7872>>3]/3.0;i=i;return}function pQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8072>>3]=+h[b+6840>>3];i=i;return}function qQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8080>>3]=+h[b+8072>>3]/3.0;i=i;return}function rQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8272>>3]=+h[b+6840>>3];i=i;return}function sQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8280>>3]=+h[b+8272>>3]/3.0;i=i;return}function tQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8472>>3]=+h[b+6840>>3];i=i;return}function uQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8480>>3]=+h[b+8472>>3]/3.0;i=i;return}function vQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8672>>3]=+h[b+6840>>3];i=i;return}function wQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8680>>3]=+h[b+8672>>3]/3.0;i=i;return}function xQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,3);h[(c[a+416>>2]|0)+5528>>3]=l;i=b;return}function yQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,2);h[(c[a+416>>2]|0)+5520>>3]=l;i=b;return}function zQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,1);h[(c[a+416>>2]|0)+5512>>3]=l;i=b;return}function AQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,0);h[(c[a+416>>2]|0)+5504>>3]=l;i=b;return}function BQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5232>>3]=+h[b+4968>>3];i=i;return}function CQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5304>>3]=+h[b+5232>>3];i=i;return}function DQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5224>>3]=+h[b+4960>>3];i=i;return}function EQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5296>>3]=+h[b+5224>>3];i=i;return}function FQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5216>>3]=+h[b+4952>>3];i=i;return}function GQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5288>>3]=+h[b+5216>>3];i=i;return}function HQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5280>>3]=+h[b+5016>>3];i=i;return}function IQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5272>>3]=+h[b+5008>>3];i=i;return}function JQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5264>>3]=+h[b+5e3>>3];i=i;return}function KQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5256>>3]=+h[b+4992>>3];i=i;return}function LQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5248>>3]=+h[b+4984>>3];i=i;return}function MQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5240>>3]=+h[b+4976>>3];i=i;return}function NQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8664>>3]=+h[b+8560>>3];i=i;return}function OQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8656>>3]=+h[b+8552>>3];i=i;return}function PQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8648>>3]=+h[b+8544>>3];i=i;return}function QQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8640>>3]=+h[b+8536>>3];i=i;return}function RQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8632>>3]=+h[b+8528>>3];i=i;return}function SQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8624>>3]=+h[b+8520>>3];i=i;return}function TQ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+116|0]=a[d+5|0]|0;i=i;return}function UQ(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+112>>2]=c[b+104>>2];i=i;return}function VQ(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+4272>>3]- +h[b+4392>>3];e=+h[b+4280>>3]- +h[b+4400>>3];f=+h[b+4288>>3]- +h[b+4408>>3];h[b+8408>>3]=+V(+(d*d+e*e+f*f));i=i;return}function WQ(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+8408>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,17184,19384,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+8488>>3]=l;i=d;return}function XQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8496>>3]=+h[b+8488>>3];i=i;return}function YQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8504>>3]=+h[b+8488>>3]*2.0;i=i;return}function ZQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,3);h[(c[a+416>>2]|0)+4896>>3]=l;i=b;return}function _Q(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,2);h[(c[a+416>>2]|0)+4888>>3]=l;i=b;return}function $Q(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,1);h[(c[a+416>>2]|0)+4880>>3]=l;i=b;return}function aR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,0);h[(c[a+416>>2]|0)+4872>>3]=l;i=b;return}function bR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4600>>3]=+h[b+4336>>3];i=i;return}function cR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4672>>3]=+h[b+4600>>3];i=i;return}function dR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4592>>3]=+h[b+4328>>3];i=i;return}function eR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4664>>3]=+h[b+4592>>3];i=i;return}function fR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4584>>3]=+h[b+4320>>3];i=i;return}function gR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4656>>3]=+h[b+4584>>3];i=i;return}function hR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4648>>3]=+h[b+4384>>3];i=i;return}function iR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4640>>3]=+h[b+4376>>3];i=i;return}function jR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4632>>3]=+h[b+4368>>3];i=i;return}function kR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4624>>3]=+h[b+4360>>3];i=i;return}function lR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4616>>3]=+h[b+4352>>3];i=i;return}function mR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4608>>3]=+h[b+4344>>3];i=i;return}function nR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8464>>3]=+h[b+8360>>3];i=i;return}function oR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8456>>3]=+h[b+8352>>3];i=i;return}function pR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8448>>3]=+h[b+8344>>3];i=i;return}function qR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8440>>3]=+h[b+8336>>3];i=i;return}function rR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8432>>3]=+h[b+8328>>3];i=i;return}function sR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8424>>3]=+h[b+8320>>3];i=i;return}function tR(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+102|0]=a[d+5|0]|0;i=i;return}function uR(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+100>>2]=c[b+92>>2];i=i;return}function vR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8304>>3]=+h[b+8288>>3]*2.0;i=i;return}function wR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,3);h[(c[a+416>>2]|0)+4264>>3]=l;i=b;return}function xR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,2);h[(c[a+416>>2]|0)+4256>>3]=l;i=b;return}function yR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,1);h[(c[a+416>>2]|0)+4248>>3]=l;i=b;return}function zR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,0);h[(c[a+416>>2]|0)+4240>>3]=l;i=b;return}function AR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3968>>3]=+h[b+3704>>3];i=i;return}function BR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4040>>3]=+h[b+3968>>3];i=i;return}function CR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3960>>3]=+h[b+3696>>3];i=i;return}function DR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4032>>3]=+h[b+3960>>3];i=i;return}function ER(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3952>>3]=+h[b+3688>>3];i=i;return}function FR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4024>>3]=+h[b+3952>>3];i=i;return}function GR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4016>>3]=+h[b+3752>>3];i=i;return}function HR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4008>>3]=+h[b+3744>>3];i=i;return}function IR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4e3>>3]=+h[b+3736>>3];i=i;return}function JR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3992>>3]=+h[b+3728>>3];i=i;return}function KR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3984>>3]=+h[b+3720>>3];i=i;return}function LR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3976>>3]=+h[b+3712>>3];i=i;return}function MR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8264>>3]=+h[b+8160>>3];i=i;return}function NR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8256>>3]=+h[b+8152>>3];i=i;return}function OR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8248>>3]=+h[b+8144>>3];i=i;return}function PR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8240>>3]=+h[b+8136>>3];i=i;return}function QR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8232>>3]=+h[b+8128>>3];i=i;return}function RR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8224>>3]=+h[b+8120>>3];i=i;return}function SR(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+88|0]=a[d+5|0]|0;i=i;return}function TR(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+88>>2]=c[b+80>>2];i=i;return}function UR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8104>>3]=+h[b+8088>>3]*2.0;i=i;return}function VR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,3);h[(c[a+416>>2]|0)+3632>>3]=l;i=b;return}function WR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,2);h[(c[a+416>>2]|0)+3624>>3]=l;i=b;return}function XR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,1);h[(c[a+416>>2]|0)+3616>>3]=l;i=b;return}function YR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,0);h[(c[a+416>>2]|0)+3608>>3]=l;i=b;return}function ZR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3336>>3]=+h[b+3072>>3];i=i;return}function _R(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3408>>3]=+h[b+3336>>3];i=i;return}function $R(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3328>>3]=+h[b+3064>>3];i=i;return}function aS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3400>>3]=+h[b+3328>>3];i=i;return}function bS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3320>>3]=+h[b+3056>>3];i=i;return}function cS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3392>>3]=+h[b+3320>>3];i=i;return}function dS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3384>>3]=+h[b+3120>>3];i=i;return}function eS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3376>>3]=+h[b+3112>>3];i=i;return}function fS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3368>>3]=+h[b+3104>>3];i=i;return}function gS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3360>>3]=+h[b+3096>>3];i=i;return}function hS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3352>>3]=+h[b+3088>>3];i=i;return}function iS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3344>>3]=+h[b+3080>>3];i=i;return}function jS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8064>>3]=+h[b+7960>>3];i=i;return}function kS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8056>>3]=+h[b+7952>>3];i=i;return}function lS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8048>>3]=+h[b+7944>>3];i=i;return}function mS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8040>>3]=+h[b+7936>>3];i=i;return}function nS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8032>>3]=+h[b+7928>>3];i=i;return}function oS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8024>>3]=+h[b+7920>>3];i=i;return}function pS(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+74|0]=a[d+5|0]|0;i=i;return}function qS(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+76>>2]=c[b+68>>2];i=i;return}function rS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7904>>3]=+h[b+7888>>3]*2.0;i=i;return}function sS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,3);h[(c[a+416>>2]|0)+3e3>>3]=l;i=b;return}function tS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,2);h[(c[a+416>>2]|0)+2992>>3]=l;i=b;return}function uS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,1);h[(c[a+416>>2]|0)+2984>>3]=l;i=b;return}function vS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,0);h[(c[a+416>>2]|0)+2976>>3]=l;i=b;return}function wS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2704>>3]=+h[b+2440>>3];i=i;return}function xS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2776>>3]=+h[b+2704>>3];i=i;return}function yS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2696>>3]=+h[b+2432>>3];i=i;return}function zS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2768>>3]=+h[b+2696>>3];i=i;return}function AS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2688>>3]=+h[b+2424>>3];i=i;return}function BS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2760>>3]=+h[b+2688>>3];i=i;return}function CS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2752>>3]=+h[b+2488>>3];i=i;return}function DS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2744>>3]=+h[b+2480>>3];i=i;return}function ES(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2736>>3]=+h[b+2472>>3];i=i;return}function FS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2728>>3]=+h[b+2464>>3];i=i;return}function GS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2720>>3]=+h[b+2456>>3];i=i;return}function HS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2712>>3]=+h[b+2448>>3];i=i;return}function IS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7864>>3]=+h[b+7760>>3];i=i;return}function JS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7856>>3]=+h[b+7752>>3];i=i;return}function KS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7848>>3]=+h[b+7744>>3];i=i;return}function LS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7840>>3]=+h[b+7736>>3];i=i;return}function MS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7832>>3]=+h[b+7728>>3];i=i;return}function NS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7824>>3]=+h[b+7720>>3];i=i;return}function OS(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+60|0]=a[d+5|0]|0;i=i;return}function PS(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+64>>2]=c[b+56>>2];i=i;return}function QS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7704>>3]=+h[b+7688>>3]*2.0;i=i;return}function RS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,3);h[(c[a+416>>2]|0)+2368>>3]=l;i=b;return}function SS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,2);h[(c[a+416>>2]|0)+2360>>3]=l;i=b;return}function TS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,1);h[(c[a+416>>2]|0)+2352>>3]=l;i=b;return}function US(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,0);h[(c[a+416>>2]|0)+2344>>3]=l;i=b;return}function VS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2072>>3]=+h[b+1808>>3];i=i;return}function WS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2144>>3]=+h[b+2072>>3];i=i;return}function XS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2064>>3]=+h[b+1800>>3];i=i;return}function YS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2136>>3]=+h[b+2064>>3];i=i;return}function ZS(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2056>>3]=+h[b+1792>>3];i=i;return}function _S(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2128>>3]=+h[b+2056>>3];i=i;return}function $S(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2120>>3]=+h[b+1856>>3];i=i;return}function aT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2112>>3]=+h[b+1848>>3];i=i;return}function bT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2104>>3]=+h[b+1840>>3];i=i;return}function cT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2096>>3]=+h[b+1832>>3];i=i;return}function dT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2088>>3]=+h[b+1824>>3];i=i;return}function eT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2080>>3]=+h[b+1816>>3];i=i;return}function fT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7664>>3]=+h[b+7560>>3];i=i;return}function gT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7656>>3]=+h[b+7552>>3];i=i;return}function hT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7648>>3]=+h[b+7544>>3];i=i;return}function iT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7640>>3]=+h[b+7536>>3];i=i;return}function jT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7632>>3]=+h[b+7528>>3];i=i;return}function kT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7624>>3]=+h[b+7520>>3];i=i;return}function lT(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+46|0]=a[d+5|0]|0;i=i;return}function mT(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+52>>2]=c[b+44>>2];i=i;return}function nT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7504>>3]=+h[b+7488>>3]*2.0;i=i;return}function oT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,3);h[(c[a+416>>2]|0)+1736>>3]=l;i=b;return}



function NAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56320]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+248>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+248>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(56328,sNa(c[(c[g>>2]|0)+248>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[56320]=1;i=d;return}function OAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56488]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+244>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+244>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(56496,sNa(c[(c[g>>2]|0)+244>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[56488]=1;i=d;return}function PAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56656]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+240>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+240>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(56664,sNa(c[(c[g>>2]|0)+240>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[56656]=1;i=d;return}function QAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56824]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8160>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(56832,qNa(+h[(c[g>>2]|0)+8160>>3],21128)|0)|0;g=c[41886]|0;j=e;k=80896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[56824]=1;i=d;return}function RAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56944]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8152>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(56952,qNa(+h[(c[g>>2]|0)+8152>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[56944]=1;i=d;return}function SAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57064]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8144>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(57072,qNa(+h[(c[g>>2]|0)+8144>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57064]=1;i=d;return}function TAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57184]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(57192,qNa(+h[(c[g>>2]|0)+8136>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57184]=1;i=d;return}function UAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57288]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(57296,qNa(+h[(c[g>>2]|0)+8128>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57288]=1;i=d;return}function VAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57392]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(57400,qNa(+h[(c[g>>2]|0)+8120>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57392]=1;i=d;return}function WAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57496]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(57504,qNa(+h[(c[g>>2]|0)+8112>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57496]=1;i=d;return}function XAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57592]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(57600,qNa(+h[(c[g>>2]|0)+8104>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57592]=1;i=d;return}function YAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57712]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(57720,qNa(+h[(c[g>>2]|0)+8096>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57712]=1;i=d;return}function ZAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57816]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(57824,qNa(+h[(c[g>>2]|0)+8088>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57816]=1;i=d;return}function _Aa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57920]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(57928,qNa(+h[(c[g>>2]|0)+8080>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57920]=1;i=d;return}function $Aa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58056]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(58064,qNa(+h[(c[g>>2]|0)+8072>>3],21128)|0)|0;g=c[41886]|0;j=e;k=77104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[58056]=1;i=d;return}function aBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58192]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+236>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+236>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(58200,sNa(c[(c[g>>2]|0)+236>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[58192]=1;i=d;return}function bBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58392]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+232>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+232>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(58400,sNa(c[(c[g>>2]|0)+232>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[58392]=1;i=d;return}function cBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58592]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+228>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+228>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(58600,sNa(c[(c[g>>2]|0)+228>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[58592]=1;i=d;return}function dBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58792]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+224>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+224>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(58800,sNa(c[(c[g>>2]|0)+224>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[58792]=1;i=d;return}function eBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58976]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+220>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+220>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(58984,sNa(c[(c[g>>2]|0)+220>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[58976]=1;i=d;return}function fBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59160]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+216>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+216>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(59168,sNa(c[(c[g>>2]|0)+216>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[59160]=1;i=d;return}function gBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59344]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8064>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(59352,qNa(+h[(c[g>>2]|0)+8064>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[59344]=1;i=d;return}function hBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59480]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8056>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(59488,qNa(+h[(c[g>>2]|0)+8056>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[59480]=1;i=d;return}function iBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59616]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8048>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(59624,qNa(+h[(c[g>>2]|0)+8048>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[59616]=1;i=d;return}function jBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59752]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(59760,qNa(+h[(c[g>>2]|0)+8040>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[59752]=1;i=d;return}function kBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59864]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(59872,qNa(+h[(c[g>>2]|0)+8032>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[59864]=1;i=d;return}function lBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59976]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(59984,qNa(+h[(c[g>>2]|0)+8024>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[59976]=1;i=d;return}function mBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60088]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(60096,qNa(+h[(c[g>>2]|0)+8016>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79320;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[60088]=1;i=d;return}function nBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60192]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(60200,qNa(+h[(c[g>>2]|0)+8e3>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[60192]=1;i=d;return}function oBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60336]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(60344,qNa(+h[(c[g>>2]|0)+7992>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79648;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[60336]=1;i=d;return}function pBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60472]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+212>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+212>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(60480,sNa(c[(c[g>>2]|0)+212>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[60472]=1;i=d;return}function qBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60656]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+208>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+208>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(60664,sNa(c[(c[g>>2]|0)+208>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[60656]=1;i=d;return}function rBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60840]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+204>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+204>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(60848,sNa(c[(c[g>>2]|0)+204>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[60840]=1;i=d;return}function sBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61024]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+200>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+200>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(61032,sNa(c[(c[g>>2]|0)+200>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[61024]=1;i=d;return}function tBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61192]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+196>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+196>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(61200,sNa(c[(c[g>>2]|0)+196>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[61192]=1;i=d;return}function uBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61360]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+192>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+192>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(61368,sNa(c[(c[g>>2]|0)+192>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[61360]=1;i=d;return}function vBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61528]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7960>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(61536,qNa(+h[(c[g>>2]|0)+7960>>3],21128)|0)|0;g=c[41886]|0;j=e;k=80896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[61528]=1;i=d;return}function wBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61648]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7952>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(61656,qNa(+h[(c[g>>2]|0)+7952>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[61648]=1;i=d;return}function xBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61768]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7944>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(61776,qNa(+h[(c[g>>2]|0)+7944>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[61768]=1;i=d;return}function yBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61888]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(61896,qNa(+h[(c[g>>2]|0)+7936>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[61888]=1;i=d;return}function zBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61992]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(62e3,qNa(+h[(c[g>>2]|0)+7928>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[61992]=1;i=d;return}function ABa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62096]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(62104,qNa(+h[(c[g>>2]|0)+7920>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[62096]=1;i=d;return}function BBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62200]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(62208,qNa(+h[(c[g>>2]|0)+7912>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[62200]=1;i=d;return}function CBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62296]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(62304,qNa(+h[(c[g>>2]|0)+7904>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[62296]=1;i=d;return}function DBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62416]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(62424,qNa(+h[(c[g>>2]|0)+7896>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[62416]=1;i=d;return}function EBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62520]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(62528,qNa(+h[(c[g>>2]|0)+7888>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[62520]=1;i=d;return}function FBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62624]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(62632,qNa(+h[(c[g>>2]|0)+7880>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[62624]=1;i=d;return}function GBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62760]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(62768,qNa(+h[(c[g>>2]|0)+7872>>3],21128)|0)|0;g=c[41886]|0;j=e;k=77104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[62760]=1;i=d;return}function HBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62896]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+188>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+188>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(62904,sNa(c[(c[g>>2]|0)+188>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[62896]=1;i=d;return}function IBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63096]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+184>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+184>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(63104,sNa(c[(c[g>>2]|0)+184>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[63096]=1;i=d;return}function JBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63296]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+180>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+180>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(63304,sNa(c[(c[g>>2]|0)+180>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[63296]=1;i=d;return}function KBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63496]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+176>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+176>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(63504,sNa(c[(c[g>>2]|0)+176>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[63496]=1;i=d;return}function LBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63680]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+172>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+172>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(63688,sNa(c[(c[g>>2]|0)+172>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[63680]=1;i=d;return}function MBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63864]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+168>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+168>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(63872,sNa(c[(c[g>>2]|0)+168>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[63864]=1;i=d;return}function NBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64048]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7864>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(64056,qNa(+h[(c[g>>2]|0)+7864>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[64048]=1;i=d;return}function OBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64184]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7856>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(64192,qNa(+h[(c[g>>2]|0)+7856>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[64184]=1;i=d;return}function PBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64320]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7848>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(64328,qNa(+h[(c[g>>2]|0)+7848>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[64320]=1;i=d;return}function QBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64456]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(64464,qNa(+h[(c[g>>2]|0)+7840>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[64456]=1;i=d;return}function RBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64568]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(64576,qNa(+h[(c[g>>2]|0)+7832>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[64568]=1;i=d;return}function SBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64680]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(64688,qNa(+h[(c[g>>2]|0)+7824>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[64680]=1;i=d;return}function TBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64792]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(64800,qNa(+h[(c[g>>2]|0)+7816>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79320;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[64792]=1;i=d;return}function UBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64896]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(64904,qNa(+h[(c[g>>2]|0)+7800>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[64896]=1;i=d;return}function VBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65040]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7792>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(65048,qNa(+h[(c[g>>2]|0)+7792>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79648;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[65040]=1;i=d;return}function WBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65176]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+164>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+164>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(65184,sNa(c[(c[g>>2]|0)+164>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[65176]=1;i=d;return}function XBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65360]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+160>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+160>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(65368,sNa(c[(c[g>>2]|0)+160>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[65360]=1;i=d;return}function YBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65544]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+156>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+156>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(65552,sNa(c[(c[g>>2]|0)+156>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[65544]=1;i=d;return}function ZBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65728]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+152>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+152>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(65736,sNa(c[(c[g>>2]|0)+152>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[65728]=1;i=d;return}function _Ba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65896]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+148>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+148>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(65904,sNa(c[(c[g>>2]|0)+148>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[65896]=1;i=d;return}function $Ba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66064]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+144>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+144>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(66072,sNa(c[(c[g>>2]|0)+144>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[66064]=1;i=d;return}function aCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66232]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7760>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(66240,qNa(+h[(c[g>>2]|0)+7760>>3],21128)|0)|0;g=c[41886]|0;j=e;k=80896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[66232]=1;i=d;return}function bCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66352]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7752>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(66360,qNa(+h[(c[g>>2]|0)+7752>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[66352]=1;i=d;return}function cCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66472]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7744>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(66480,qNa(+h[(c[g>>2]|0)+7744>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[66472]=1;i=d;return}function dCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66592]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(66600,qNa(+h[(c[g>>2]|0)+7736>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[66592]=1;i=d;return}function eCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66696]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(66704,qNa(+h[(c[g>>2]|0)+7728>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[66696]=1;i=d;return}function fCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66800]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(66808,qNa(+h[(c[g>>2]|0)+7720>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[66800]=1;i=d;return}function gCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66904]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7712>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(66912,qNa(+h[(c[g>>2]|0)+7712>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[66904]=1;i=d;return}function hCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67e3]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(67008,qNa(+h[(c[g>>2]|0)+7704>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[67e3]=1;i=d;return}function iCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67120]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7696>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(67128,qNa(+h[(c[g>>2]|0)+7696>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[67120]=1;i=d;return}function jCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67224]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(67232,qNa(+h[(c[g>>2]|0)+7688>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[67224]=1;i=d;return}function kCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67328]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(67336,qNa(+h[(c[g>>2]|0)+7680>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[67328]=1;i=d;return}function lCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67464]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(67472,qNa(+h[(c[g>>2]|0)+7672>>3],21128)|0)|0;g=c[41886]|0;j=e;k=77104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[67464]=1;i=d;return}function mCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67600]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+140>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+140>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(67608,sNa(c[(c[g>>2]|0)+140>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[67600]=1;i=d;return}function nCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67800]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+136>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+136>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(67808,sNa(c[(c[g>>2]|0)+136>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[67800]=1;i=d;return}function oCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68e3]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+132>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+132>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(68008,sNa(c[(c[g>>2]|0)+132>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[68e3]=1;i=d;return}function pCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68200]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+128>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+128>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(68208,sNa(c[(c[g>>2]|0)+128>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[68200]=1;i=d;return}function qCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68384]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+124>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+124>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(68392,sNa(c[(c[g>>2]|0)+124>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[68384]=1;i=d;return}function rCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68568]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+120>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+120>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(68576,sNa(c[(c[g>>2]|0)+120>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[68568]=1;i=d;return}function sCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68752]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7664>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(68760,qNa(+h[(c[g>>2]|0)+7664>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[68752]=1;i=d;return}function tCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68888]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7656>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(68896,qNa(+h[(c[g>>2]|0)+7656>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[68888]=1;i=d;return}function uCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69024]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7648>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(69032,qNa(+h[(c[g>>2]|0)+7648>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[69024]=1;i=d;return}function vCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69160]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(69168,qNa(+h[(c[g>>2]|0)+7640>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[69160]=1;i=d;return}function wCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69272]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(69280,qNa(+h[(c[g>>2]|0)+7632>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[69272]=1;i=d;return}function xCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69384]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7624>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(69392,qNa(+h[(c[g>>2]|0)+7624>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[69384]=1;i=d;return}function yCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69496]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(69504,qNa(+h[(c[g>>2]|0)+7616>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79320;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[69496]=1;i=d;return}function zCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69600]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(69608,qNa(+h[(c[g>>2]|0)+7600>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[69600]=1;i=d;return}function ACa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69744]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(69752,qNa(+h[(c[g>>2]|0)+7592>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79648;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[69744]=1;i=d;return}function BCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69880]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+116>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+116>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(69888,sNa(c[(c[g>>2]|0)+116>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[69880]=1;i=d;return}function CCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70064]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+112>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+112>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(70072,sNa(c[(c[g>>2]|0)+112>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[70064]=1;i=d;return}function DCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70248]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+108>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+108>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(70256,sNa(c[(c[g>>2]|0)+108>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[70248]=1;i=d;return}function ECa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70432]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+104>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+104>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(70440,sNa(c[(c[g>>2]|0)+104>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[70432]=1;i=d;return}function FCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70600]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+100>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+100>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(70608,sNa(c[(c[g>>2]|0)+100>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[70600]=1;i=d;return}function GCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70768]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+96>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+96>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(70776,sNa(c[(c[g>>2]|0)+96>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[70768]=1;i=d;return}function HCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70936]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7560>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(70944,qNa(+h[(c[g>>2]|0)+7560>>3],21128)|0)|0;g=c[41886]|0;j=e;k=80896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[70936]=1;i=d;return}function ICa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71056]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7552>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(71064,qNa(+h[(c[g>>2]|0)+7552>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[71056]=1;i=d;return}function JCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71176]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7544>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(71184,qNa(+h[(c[g>>2]|0)+7544>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[71176]=1;i=d;return}function KCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71296]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(71304,qNa(+h[(c[g>>2]|0)+7536>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[71296]=1;i=d;return}function LCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71400]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(71408,qNa(+h[(c[g>>2]|0)+7528>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[71400]=1;i=d;return}function MCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71504]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(71512,qNa(+h[(c[g>>2]|0)+7520>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[71504]=1;i=d;return}function NCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71608]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(71616,qNa(+h[(c[g>>2]|0)+7512>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[71608]=1;i=d;return}function OCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71704]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(71712,qNa(+h[(c[g>>2]|0)+7504>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[71704]=1;i=d;return}function PCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71824]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(71832,qNa(+h[(c[g>>2]|0)+7496>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[71824]=1;i=d;return}function QCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71928]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(71936,qNa(+h[(c[g>>2]|0)+7488>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[71928]=1;i=d;return}function RCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72032]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(72040,qNa(+h[(c[g>>2]|0)+7480>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[72032]=1;i=d;return}function SCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72168]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(72176,qNa(+h[(c[g>>2]|0)+7472>>3],21128)|0)|0;g=c[41886]|0;j=e;k=77104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[72168]=1;i=d;return}function TCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72304]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+92>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+92>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(72312,sNa(c[(c[g>>2]|0)+92>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[72304]=1;i=d;return}function UCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72504]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+88>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+88>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(72512,sNa(c[(c[g>>2]|0)+88>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[72504]=1;i=d;return}function VCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72704]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+84>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+84>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(72712,sNa(c[(c[g>>2]|0)+84>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[72704]=1;i=d;return}function WCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72904]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+80>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+80>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(72912,sNa(c[(c[g>>2]|0)+80>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[72904]=1;i=d;return}function XCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73088]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+76>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+76>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(73096,sNa(c[(c[g>>2]|0)+76>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[73088]=1;i=d;return}function YCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73272]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+72>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+72>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(73280,sNa(c[(c[g>>2]|0)+72>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[73272]=1;i=d;return}function ZCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73456]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7464>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(73464,qNa(+h[(c[g>>2]|0)+7464>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[73456]=1;i=d;return}function _Ca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73592]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7456>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(73600,qNa(+h[(c[g>>2]|0)+7456>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[73592]=1;i=d;return}function $Ca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73728]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7448>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(73736,qNa(+h[(c[g>>2]|0)+7448>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[73728]=1;i=d;return}function aDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73864]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(73872,qNa(+h[(c[g>>2]|0)+7440>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[73864]=1;i=d;return}function bDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73976]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(73984,qNa(+h[(c[g>>2]|0)+7432>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[73976]=1;i=d;return}function cDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74088]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(74096,qNa(+h[(c[g>>2]|0)+7424>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[74088]=1;i=d;return}function dDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74200]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(74208,qNa(+h[(c[g>>2]|0)+7416>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79320;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[74200]=1;i=d;return}function eDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74304]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(74312,qNa(+h[(c[g>>2]|0)+7400>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[74304]=1;i=d;return}function fDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74448]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(74456,qNa(+h[(c[g>>2]|0)+7392>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79648;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[74448]=1;i=d;return}function gDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74584]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+68>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+68>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(74592,sNa(c[(c[g>>2]|0)+68>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[74584]=1;i=d;return}function hDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74768]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+64>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+64>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(74776,sNa(c[(c[g>>2]|0)+64>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[74768]=1;i=d;return}function iDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74952]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+60>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+60>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(74960,sNa(c[(c[g>>2]|0)+60>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[74952]=1;i=d;return}function jDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75136]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+56>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+56>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(75144,sNa(c[(c[g>>2]|0)+56>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[75136]=1;i=d;return}function kDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75304]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+52>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+52>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(75312,sNa(c[(c[g>>2]|0)+52>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[75304]=1;i=d;return}function lDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75472]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+48>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+48>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(75480,sNa(c[(c[g>>2]|0)+48>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[75472]=1;i=d;return}function mDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75640]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7360>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(75648,qNa(+h[(c[g>>2]|0)+7360>>3],21128)|0)|0;g=c[41886]|0;j=e;k=80896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[75640]=1;i=d;return}function nDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75760]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7352>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(75768,qNa(+h[(c[g>>2]|0)+7352>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[75760]=1;i=d;return}function oDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75880]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7344>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(75888,qNa(+h[(c[g>>2]|0)+7344>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[75880]=1;i=d;return}function pDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76e3]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(76008,qNa(+h[(c[g>>2]|0)+7336>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[76e3]=1;i=d;return}function qDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76104]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(76112,qNa(+h[(c[g>>2]|0)+7328>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[76104]=1;i=d;return}function rDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76208]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(76216,qNa(+h[(c[g>>2]|0)+7320>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[76208]=1;i=d;return}function sDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76312]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(76320,qNa(+h[(c[g>>2]|0)+7312>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[76312]=1;i=d;return}function tDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76408]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(76416,qNa(+h[(c[g>>2]|0)+7304>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[76408]=1;i=d;return}function uDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76552]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(76560,qNa(+h[(c[g>>2]|0)+7296>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[76552]=1;i=d;return}function vDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76680]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(76688,qNa(+h[(c[g>>2]|0)+7288>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[76680]=1;i=d;return}function wDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76808]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(76816,qNa(+h[(c[g>>2]|0)+7280>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[76808]=1;i=d;return}function xDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76968]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(76976,qNa(+h[(c[g>>2]|0)+7272>>3],21128)|0)|0;g=c[41886]|0;j=e;k=77104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[76968]=1;i=d;return}function yDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77128]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+44>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+44>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(77136,sNa(c[(c[g>>2]|0)+44>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[77128]=1;i=d;return}function zDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77328]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+40>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+40>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(77336,sNa(c[(c[g>>2]|0)+40>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[77328]=1;i=d;return}function ADa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77528]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+36>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+36>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(77536,sNa(c[(c[g>>2]|0)+36>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[77528]=1;i=d;return}function BDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77752]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+32>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+32>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(77760,sNa(c[(c[g>>2]|0)+32>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[77752]=1;i=d;return}function CDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77936]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+28>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+28>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(77944,sNa(c[(c[g>>2]|0)+28>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[77936]=1;i=d;return}function DDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78120]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+24>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+24>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(78128,sNa(c[(c[g>>2]|0)+24>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[78120]=1;i=d;return}function EDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78328]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7264>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(78336,qNa(+h[(c[g>>2]|0)+7264>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[78328]=1;i=d;return}function FDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78488]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7256>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(78496,qNa(+h[(c[g>>2]|0)+7256>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[78488]=1;i=d;return}function GDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78648]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7248>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(78656,qNa(+h[(c[g>>2]|0)+7248>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[78648]=1;i=d;return}function HDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78808]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(78816,qNa(+h[(c[g>>2]|0)+7240>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[78808]=1;i=d;return}function IDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78944]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(78952,qNa(+h[(c[g>>2]|0)+7232>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[78944]=1;i=d;return}function JDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79080]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(79088,qNa(+h[(c[g>>2]|0)+7224>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[79080]=1;i=d;return}function KDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79216]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(79224,qNa(+h[(c[g>>2]|0)+7216>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79320;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[79216]=1;i=d;return}function LDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79344]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(79352,qNa(+h[(c[g>>2]|0)+7200>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[79344]=1;i=d;return}function MDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79512]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(79520,qNa(+h[(c[g>>2]|0)+7192>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79648;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[79512]=1;i=d;return}function NDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79672]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+20>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+20>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(79680,sNa(c[(c[g>>2]|0)+20>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[79672]=1;i=d;return}function ODa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79856]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+16>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+16>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(79864,sNa(c[(c[g>>2]|0)+16>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[79856]=1;i=d;return}function PDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80040]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+12>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+12>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(80048,sNa(c[(c[g>>2]|0)+12>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[80040]=1;i=d;return}function QDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80248]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+8>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+8>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(80256,sNa(c[(c[g>>2]|0)+8>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[80248]=1;i=d;return}function RDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80416]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+4>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+4>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(80424,sNa(c[(c[g>>2]|0)+4>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[80416]=1;i=d;return}function SDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80584]&1){i=d;return}g=b+420|0;b=fQa(+(c[c[g>>2]>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[c[g>>2]>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(80592,sNa(c[c[g>>2]>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[80584]=1;i=d;return}



function Fxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32848]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(32856,qNa(+h[(c[g>>2]|0)+10392>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[32848]=1;i=d;return}function Gxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32952]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(32960,qNa(+h[(c[g>>2]|0)+10376>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[32952]=1;i=d;return}function Hxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33064]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(33072,qNa(+h[(c[g>>2]|0)+10360>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[33064]=1;i=d;return}function Ixa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33168]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(33176,qNa(+h[(c[g>>2]|0)+10344>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[33168]=1;i=d;return}function Jxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33280]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(33288,qNa(+h[(c[g>>2]|0)+10328>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[33280]=1;i=d;return}function Kxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33384]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(33392,qNa(+h[(c[g>>2]|0)+10312>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[33384]=1;i=d;return}function Lxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33496]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(33504,qNa(+h[(c[g>>2]|0)+10296>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[33496]=1;i=d;return}function Mxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33600]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(33608,qNa(+h[(c[g>>2]|0)+10280>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[33600]=1;i=d;return}function Nxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33712]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(33720,qNa(+h[(c[g>>2]|0)+10224>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[33712]=1;i=d;return}function Oxa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33808]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+512>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+512>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(33816,sNa(c[(c[g>>2]|0)+512>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=41408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[33808]=1;i=d;return}function Pxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34024]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(34032,qNa(+h[(c[g>>2]|0)+10160>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[34024]=1;i=d;return}function Qxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34104]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10104>>3],1.0)|0)<<24>>24==0)){i=d;return}b=uNa(34112,qNa(+h[(c[g>>2]|0)+10104>>3],21128)|0)|0;g=c[41886]|0;j=e;k=37768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[34104]=1;i=d;return}function Rxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34232]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(34240,qNa(+h[(c[g>>2]|0)+10080>>3],21128)|0)|0;g=c[41886]|0;j=e;k=37896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[34232]=1;i=d;return}function Sxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34336]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(34344,qNa(+h[(c[g>>2]|0)+10072>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[34336]=1;i=d;return}function Txa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34440]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+508>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+508>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(34448,sNa(c[(c[g>>2]|0)+508>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=38248;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[34440]=1;i=d;return}function Uxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34640]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+10064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(34648,qNa(+h[(c[g>>2]|0)+10064>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[34640]=1;i=d;return}function Vxa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34768]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+504>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+504>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=uNa(34776,sNa(c[(c[g>>2]|0)+504>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=38656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[34768]=1;i=d;return}function Wxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35e3]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9968>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(35008,qNa(+h[(c[g>>2]|0)+9968>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[35e3]=1;i=d;return}function Xxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35112]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(35120,qNa(+h[(c[g>>2]|0)+9888>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[35112]=1;i=d;return}function Yxa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35208]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+500>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+500>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(35216,sNa(c[(c[g>>2]|0)+500>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=39136;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[35208]=1;i=d;return}function Zxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35408]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(35416,qNa(+h[(c[g>>2]|0)+9856>>3],21128)|0)|0;g=c[41886]|0;j=e;k=39272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[35408]=1;i=d;return}function _xa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35520]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(35528,qNa(+h[(c[g>>2]|0)+9832>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[35520]=1;i=d;return}function $xa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35624]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(35632,qNa(+h[(c[g>>2]|0)+9816>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[35624]=1;i=d;return}function aya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35736]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(35744,qNa(+h[(c[g>>2]|0)+9800>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[35736]=1;i=d;return}function bya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35840]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(35848,qNa(+h[(c[g>>2]|0)+9784>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[35840]=1;i=d;return}function cya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35952]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(35960,qNa(+h[(c[g>>2]|0)+9768>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[35952]=1;i=d;return}function dya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36056]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9752>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(36064,qNa(+h[(c[g>>2]|0)+9752>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36056]=1;i=d;return}function eya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36168]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(36176,qNa(+h[(c[g>>2]|0)+9736>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36168]=1;i=d;return}function fya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36272]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(36280,qNa(+h[(c[g>>2]|0)+9720>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36272]=1;i=d;return}function gya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36384]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(36392,qNa(+h[(c[g>>2]|0)+9704>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36384]=1;i=d;return}function hya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36488]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(36496,qNa(+h[(c[g>>2]|0)+9688>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36488]=1;i=d;return}function iya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36600]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(36608,qNa(+h[(c[g>>2]|0)+9672>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36600]=1;i=d;return}function jya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36704]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9656>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(36712,qNa(+h[(c[g>>2]|0)+9656>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36704]=1;i=d;return}function kya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36816]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(36824,qNa(+h[(c[g>>2]|0)+9640>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36816]=1;i=d;return}function lya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36920]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9624>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(36928,qNa(+h[(c[g>>2]|0)+9624>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36920]=1;i=d;return}function mya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37032]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(37040,qNa(+h[(c[g>>2]|0)+9608>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[37032]=1;i=d;return}function nya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37136]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(37144,qNa(+h[(c[g>>2]|0)+9592>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[37136]=1;i=d;return}function oya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37248]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(37256,qNa(+h[(c[g>>2]|0)+9536>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[37248]=1;i=d;return}function pya(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37344]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+496>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+496>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(37352,sNa(c[(c[g>>2]|0)+496>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=41408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[37344]=1;i=d;return}function qya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37560]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(37568,qNa(+h[(c[g>>2]|0)+9472>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[37560]=1;i=d;return}function rya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37640]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9416>>3],1.0)|0)<<24>>24==0)){i=d;return}b=uNa(37648,qNa(+h[(c[g>>2]|0)+9416>>3],21128)|0)|0;g=c[41886]|0;j=e;k=37768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[37640]=1;i=d;return}function sya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37792]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(37800,qNa(+h[(c[g>>2]|0)+9392>>3],21128)|0)|0;g=c[41886]|0;j=e;k=37896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[37792]=1;i=d;return}function tya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37920]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(37928,qNa(+h[(c[g>>2]|0)+9384>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[37920]=1;i=d;return}function uya(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38048]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+492>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+492>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(38056,sNa(c[(c[g>>2]|0)+492>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=38248;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[38048]=1;i=d;return}function vya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38272]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(38280,qNa(+h[(c[g>>2]|0)+9376>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[38272]=1;i=d;return}function wya(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38424]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+488>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+488>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=uNa(38432,sNa(c[(c[g>>2]|0)+488>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=38656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[38424]=1;i=d;return}function xya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38680]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9280>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(38688,qNa(+h[(c[g>>2]|0)+9280>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[38680]=1;i=d;return}function yya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38816]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(38824,qNa(+h[(c[g>>2]|0)+9200>>3],21128)|0)|0;g=c[41886]|0;j=e;k=38912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[38816]=1;i=d;return}function zya(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38936]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+484>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+484>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(38944,sNa(c[(c[g>>2]|0)+484>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=39136;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[38936]=1;i=d;return}function Aya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39160]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(39168,qNa(+h[(c[g>>2]|0)+9168>>3],21128)|0)|0;g=c[41886]|0;j=e;k=39272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[39160]=1;i=d;return}function Bya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39296]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9144>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(39304,qNa(+h[(c[g>>2]|0)+9144>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[39296]=1;i=d;return}function Cya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39400]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(39408,qNa(+h[(c[g>>2]|0)+9128>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[39400]=1;i=d;return}function Dya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39512]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(39520,qNa(+h[(c[g>>2]|0)+9112>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[39512]=1;i=d;return}function Eya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39616]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(39624,qNa(+h[(c[g>>2]|0)+9096>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[39616]=1;i=d;return}function Fya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39728]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(39736,qNa(+h[(c[g>>2]|0)+9080>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[39728]=1;i=d;return}function Gya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39832]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(39840,qNa(+h[(c[g>>2]|0)+9064>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[39832]=1;i=d;return}function Hya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39944]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(39952,qNa(+h[(c[g>>2]|0)+9048>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[39944]=1;i=d;return}function Iya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40048]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(40056,qNa(+h[(c[g>>2]|0)+9032>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[40048]=1;i=d;return}function Jya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40160]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(40168,qNa(+h[(c[g>>2]|0)+9016>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[40160]=1;i=d;return}function Kya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40264]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+9e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(40272,qNa(+h[(c[g>>2]|0)+9e3>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[40264]=1;i=d;return}function Lya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40376]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(40384,qNa(+h[(c[g>>2]|0)+8984>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[40376]=1;i=d;return}function Mya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40480]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(40488,qNa(+h[(c[g>>2]|0)+8968>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[40480]=1;i=d;return}function Nya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40592]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(40600,qNa(+h[(c[g>>2]|0)+8952>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[40592]=1;i=d;return}function Oya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40696]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(40704,qNa(+h[(c[g>>2]|0)+8936>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[40696]=1;i=d;return}function Pya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40808]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(40816,qNa(+h[(c[g>>2]|0)+8920>>3],21128)|0)|0;g=c[41886]|0;j=e;k=40912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[40808]=1;i=d;return}function Qya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40936]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(40944,qNa(+h[(c[g>>2]|0)+8904>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[40936]=1;i=d;return}function Rya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41072]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(41080,qNa(+h[(c[g>>2]|0)+8848>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[41072]=1;i=d;return}function Sya(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41192]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+480>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+480>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(41200,sNa(c[(c[g>>2]|0)+480>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=41408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[41192]=1;i=d;return}function Tya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41432]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(41440,qNa(+h[(c[g>>2]|0)+8784>>3],21128)|0)|0;g=c[41886]|0;j=e;k=41512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[41432]=1;i=d;return}function Uya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41536]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+6008>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(41544,qNa(+h[(c[g>>2]|0)+6008>>3],21128)|0)|0;g=c[41886]|0;j=e;k=42376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[41536]=1;i=d;return}function Vya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41736]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+6e3>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(41744,qNa(+h[(c[g>>2]|0)+6e3>>3],21128)|0)|0;g=c[41886]|0;j=e;k=42376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[41736]=1;i=d;return}function Wya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41864]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+5992>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(41872,qNa(+h[(c[g>>2]|0)+5992>>3],21128)|0)|0;g=c[41886]|0;j=e;k=42376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[41864]=1;i=d;return}function Xya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41992]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+5984>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(42e3,qNa(+h[(c[g>>2]|0)+5984>>3],21128)|0)|0;g=c[41886]|0;j=e;k=42376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[41992]=1;i=d;return}function Yya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42120]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+5976>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(42128,qNa(+h[(c[g>>2]|0)+5976>>3],21128)|0)|0;g=c[41886]|0;j=e;k=42376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[42120]=1;i=d;return}function Zya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42248]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+5968>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(42256,qNa(+h[(c[g>>2]|0)+5968>>3],21128)|0)|0;g=c[41886]|0;j=e;k=42376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[42248]=1;i=d;return}function _ya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42400]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+5960>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(42408,qNa(+h[(c[g>>2]|0)+5960>>3],21128)|0)|0;g=c[41886]|0;j=e;k=43168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[42400]=1;i=d;return}function $ya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42528]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+5952>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(42536,qNa(+h[(c[g>>2]|0)+5952>>3],21128)|0)|0;g=c[41886]|0;j=e;k=43168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[42528]=1;i=d;return}function aza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42656]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+5944>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(42664,qNa(+h[(c[g>>2]|0)+5944>>3],21128)|0)|0;g=c[41886]|0;j=e;k=43168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[42656]=1;i=d;return}function bza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42784]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+5936>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(42792,qNa(+h[(c[g>>2]|0)+5936>>3],21128)|0)|0;g=c[41886]|0;j=e;k=43168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[42784]=1;i=d;return}function cza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42912]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+5928>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(42920,qNa(+h[(c[g>>2]|0)+5928>>3],21128)|0)|0;g=c[41886]|0;j=e;k=43168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[42912]=1;i=d;return}function dza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43040]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+5920>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=uNa(43048,qNa(+h[(c[g>>2]|0)+5920>>3],21128)|0)|0;g=c[41886]|0;j=e;k=43168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[43040]=1;i=d;return}function eza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43192]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(43200,qNa(+h[(c[g>>2]|0)+8704>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[43192]=1;i=d;return}function fza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43408]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8696>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(43416,qNa(+h[(c[g>>2]|0)+8696>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[43408]=1;i=d;return}function gza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43520]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(43528,qNa(+h[(c[g>>2]|0)+8688>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[43520]=1;i=d;return}function hza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43632]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(43640,qNa(+h[(c[g>>2]|0)+8680>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[43632]=1;i=d;return}function iza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43776]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(43784,qNa(+h[(c[g>>2]|0)+8672>>3],21128)|0)|0;g=c[41886]|0;j=e;k=77104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[43776]=1;i=d;return}function jza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43912]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+380>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+380>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(43920,sNa(c[(c[g>>2]|0)+380>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[43912]=1;i=d;return}function kza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44120]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+376>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+376>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(44128,sNa(c[(c[g>>2]|0)+376>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[44120]=1;i=d;return}function lza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44328]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+372>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+372>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(44336,sNa(c[(c[g>>2]|0)+372>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[44328]=1;i=d;return}function mza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44536]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+368>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+368>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(44544,sNa(c[(c[g>>2]|0)+368>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[44536]=1;i=d;return}function nza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44728]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+364>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+364>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(44736,sNa(c[(c[g>>2]|0)+364>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[44728]=1;i=d;return}function oza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44920]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+360>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+360>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(44928,sNa(c[(c[g>>2]|0)+360>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[44920]=1;i=d;return}function pza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45112]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8664>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(45120,qNa(+h[(c[g>>2]|0)+8664>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[45112]=1;i=d;return}function qza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45248]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8656>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(45256,qNa(+h[(c[g>>2]|0)+8656>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[45248]=1;i=d;return}function rza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45384]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8648>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(45392,qNa(+h[(c[g>>2]|0)+8648>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[45384]=1;i=d;return}function sza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45520]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(45528,qNa(+h[(c[g>>2]|0)+8640>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[45520]=1;i=d;return}function tza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45640]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(45648,qNa(+h[(c[g>>2]|0)+8632>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[45640]=1;i=d;return}function uza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45760]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8624>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(45768,qNa(+h[(c[g>>2]|0)+8624>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[45760]=1;i=d;return}function vza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45880]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(45888,qNa(+h[(c[g>>2]|0)+8616>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79320;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[45880]=1;i=d;return}function wza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45992]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(46e3,qNa(+h[(c[g>>2]|0)+8600>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[45992]=1;i=d;return}function xza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46136]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(46144,qNa(+h[(c[g>>2]|0)+8592>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79648;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[46136]=1;i=d;return}function yza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46280]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+356>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+356>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(46288,sNa(c[(c[g>>2]|0)+356>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[46280]=1;i=d;return}function zza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46472]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+352>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+352>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(46480,sNa(c[(c[g>>2]|0)+352>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[46472]=1;i=d;return}function Aza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46664]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+348>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+348>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(46672,sNa(c[(c[g>>2]|0)+348>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[46664]=1;i=d;return}function Bza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46856]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+344>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+344>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(46864,sNa(c[(c[g>>2]|0)+344>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[46856]=1;i=d;return}function Cza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47032]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+340>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+340>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(47040,sNa(c[(c[g>>2]|0)+340>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[47032]=1;i=d;return}function Dza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47208]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+336>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+336>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(47216,sNa(c[(c[g>>2]|0)+336>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[47208]=1;i=d;return}function Eza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47384]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8560>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(47392,qNa(+h[(c[g>>2]|0)+8560>>3],21128)|0)|0;g=c[41886]|0;j=e;k=80896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[47384]=1;i=d;return}function Fza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47512]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8552>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(47520,qNa(+h[(c[g>>2]|0)+8552>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[47512]=1;i=d;return}function Gza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47640]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8544>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(47648,qNa(+h[(c[g>>2]|0)+8544>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[47640]=1;i=d;return}function Hza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47768]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(47776,qNa(+h[(c[g>>2]|0)+8536>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[47768]=1;i=d;return}function Iza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47872]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(47880,qNa(+h[(c[g>>2]|0)+8528>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[47872]=1;i=d;return}function Jza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47976]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(47984,qNa(+h[(c[g>>2]|0)+8520>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[47976]=1;i=d;return}function Kza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48080]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(48088,qNa(+h[(c[g>>2]|0)+8512>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[48080]=1;i=d;return}function Lza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48184]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(48192,qNa(+h[(c[g>>2]|0)+8504>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[48184]=1;i=d;return}function Mza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48304]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(48312,qNa(+h[(c[g>>2]|0)+8496>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[48304]=1;i=d;return}function Nza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48408]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(48416,qNa(+h[(c[g>>2]|0)+8488>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[48408]=1;i=d;return}function Oza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48512]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(48520,qNa(+h[(c[g>>2]|0)+8480>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[48512]=1;i=d;return}function Pza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48648]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(48656,qNa(+h[(c[g>>2]|0)+8472>>3],21128)|0)|0;g=c[41886]|0;j=e;k=77104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[48648]=1;i=d;return}function Qza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48784]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+332>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+332>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(48792,sNa(c[(c[g>>2]|0)+332>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[48784]=1;i=d;return}function Rza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48984]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+328>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+328>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(48992,sNa(c[(c[g>>2]|0)+328>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[48984]=1;i=d;return}function Sza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49184]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+324>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+324>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(49192,sNa(c[(c[g>>2]|0)+324>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[49184]=1;i=d;return}function Tza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49384]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+320>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+320>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(49392,sNa(c[(c[g>>2]|0)+320>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[49384]=1;i=d;return}function Uza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49568]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+316>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+316>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(49576,sNa(c[(c[g>>2]|0)+316>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[49568]=1;i=d;return}function Vza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49752]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+312>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+312>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(49760,sNa(c[(c[g>>2]|0)+312>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[49752]=1;i=d;return}function Wza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49936]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8464>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(49944,qNa(+h[(c[g>>2]|0)+8464>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[49936]=1;i=d;return}function Xza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50072]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8456>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(50080,qNa(+h[(c[g>>2]|0)+8456>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[50072]=1;i=d;return}function Yza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50208]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8448>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(50216,qNa(+h[(c[g>>2]|0)+8448>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[50208]=1;i=d;return}function Zza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50344]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(50352,qNa(+h[(c[g>>2]|0)+8440>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[50344]=1;i=d;return}function _za(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50456]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(50464,qNa(+h[(c[g>>2]|0)+8432>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[50456]=1;i=d;return}function $za(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50568]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(50576,qNa(+h[(c[g>>2]|0)+8424>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[50568]=1;i=d;return}function aAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50680]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(50688,qNa(+h[(c[g>>2]|0)+8416>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79320;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[50680]=1;i=d;return}function bAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50784]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(50792,qNa(+h[(c[g>>2]|0)+8400>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[50784]=1;i=d;return}function cAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50928]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(50936,qNa(+h[(c[g>>2]|0)+8392>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79648;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[50928]=1;i=d;return}function dAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51064]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+308>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+308>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(51072,sNa(c[(c[g>>2]|0)+308>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[51064]=1;i=d;return}function eAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51248]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+304>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+304>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(51256,sNa(c[(c[g>>2]|0)+304>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[51248]=1;i=d;return}function fAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51432]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+300>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+300>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(51440,sNa(c[(c[g>>2]|0)+300>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[51432]=1;i=d;return}function gAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51616]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+296>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+296>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(51624,sNa(c[(c[g>>2]|0)+296>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[51616]=1;i=d;return}function hAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51784]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+292>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+292>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(51792,sNa(c[(c[g>>2]|0)+292>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[51784]=1;i=d;return}function iAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51952]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+288>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+288>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(51960,sNa(c[(c[g>>2]|0)+288>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[51952]=1;i=d;return}function jAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52120]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8360>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(52128,qNa(+h[(c[g>>2]|0)+8360>>3],21128)|0)|0;g=c[41886]|0;j=e;k=80896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[52120]=1;i=d;return}function kAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52240]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8352>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(52248,qNa(+h[(c[g>>2]|0)+8352>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[52240]=1;i=d;return}function lAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52360]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8344>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(52368,qNa(+h[(c[g>>2]|0)+8344>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[52360]=1;i=d;return}function mAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52480]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(52488,qNa(+h[(c[g>>2]|0)+8336>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[52480]=1;i=d;return}function nAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52584]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(52592,qNa(+h[(c[g>>2]|0)+8328>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[52584]=1;i=d;return}function oAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52688]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(52696,qNa(+h[(c[g>>2]|0)+8320>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[52688]=1;i=d;return}function pAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52792]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(52800,qNa(+h[(c[g>>2]|0)+8312>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[52792]=1;i=d;return}function qAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52888]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(52896,qNa(+h[(c[g>>2]|0)+8304>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[52888]=1;i=d;return}function rAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53008]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(53016,qNa(+h[(c[g>>2]|0)+8296>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[53008]=1;i=d;return}function sAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53112]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(53120,qNa(+h[(c[g>>2]|0)+8288>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[53112]=1;i=d;return}function tAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53216]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(53224,qNa(+h[(c[g>>2]|0)+8280>>3],21128)|0)|0;g=c[41886]|0;j=e;k=76944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[53216]=1;i=d;return}function uAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53352]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(53360,qNa(+h[(c[g>>2]|0)+8272>>3],21128)|0)|0;g=c[41886]|0;j=e;k=77104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[53352]=1;i=d;return}function vAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53488]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+284>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+284>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(53496,sNa(c[(c[g>>2]|0)+284>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[53488]=1;i=d;return}function wAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53688]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+280>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+280>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(53696,sNa(c[(c[g>>2]|0)+280>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[53688]=1;i=d;return}function xAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53888]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+276>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+276>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(53896,sNa(c[(c[g>>2]|0)+276>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=77728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[53888]=1;i=d;return}function yAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54088]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+272>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+272>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(54096,sNa(c[(c[g>>2]|0)+272>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[54088]=1;i=d;return}function zAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54272]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+268>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+268>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(54280,sNa(c[(c[g>>2]|0)+268>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[54272]=1;i=d;return}function AAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54456]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+264>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+264>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(54464,sNa(c[(c[g>>2]|0)+264>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=78304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[54456]=1;i=d;return}function BAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54640]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8264>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(54648,qNa(+h[(c[g>>2]|0)+8264>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[54640]=1;i=d;return}function CAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54776]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8256>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(54784,qNa(+h[(c[g>>2]|0)+8256>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[54776]=1;i=d;return}function DAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54912]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8248>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(54920,qNa(+h[(c[g>>2]|0)+8248>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[54912]=1;i=d;return}function EAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55048]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(55056,qNa(+h[(c[g>>2]|0)+8240>>3],21128)|0)|0;g=c[41886]|0;j=e;k=78920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[55048]=1;i=d;return}function FAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55160]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(55168,qNa(+h[(c[g>>2]|0)+8232>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[55160]=1;i=d;return}function GAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55272]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(55280,qNa(+h[(c[g>>2]|0)+8224>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[55272]=1;i=d;return}function HAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55384]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(55392,qNa(+h[(c[g>>2]|0)+8216>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79320;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[55384]=1;i=d;return}function IAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55488]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(55496,qNa(+h[(c[g>>2]|0)+8200>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[55488]=1;i=d;return}function JAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55632]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+8192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(55640,qNa(+h[(c[g>>2]|0)+8192>>3],21128)|0)|0;g=c[41886]|0;j=e;k=79648;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[55632]=1;i=d;return}function KAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55768]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+260>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+260>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(55776,sNa(c[(c[g>>2]|0)+260>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[55768]=1;i=d;return}function LAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55952]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+256>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+256>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(55960,sNa(c[(c[g>>2]|0)+256>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[55952]=1;i=d;return}function MAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56136]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+252>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+252>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(56144,sNa(c[(c[g>>2]|0)+252>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=80224;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[56136]=1;i=d;return}



function _Qa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];SMa(8,0,153976,G);I=b+313|0;a[I]=1;IPa(b);if((c[175268>>2]|0)==0){ge[c[159940>>2]&127](159920,b)}a[I]=0}}while(0);if((e|0)!=0){$Qa(Ad(e|0)|0,b)}if((c[118292>>2]|0)==0){i=f;return 0}lOa(0);SMa(25,0,154024,F);SMa(25,1,154048,E);H=+dOa(6);J=+dOa(6);K=J/+dOa(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];SMa(25,0,154056,D);K=+dOa(1);H=+dOa(1);J=H/+dOa(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];SMa(25,0,154096,C);J=+dOa(2);K=+dOa(2);H=K/+dOa(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];SMa(25,0,154128,B);H=+dOa(3);J=+dOa(3);K=J/+dOa(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];SMa(25,0,154152,A);K=+dOa(4);H=+dOa(4);J=H/+dOa(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];SMa(25,0,154192,z);J=+dOa(7);K=+dOa(7);H=K/+dOa(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];SMa(25,0,154224,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+dOa(0);J=H- +dOa(7);H=J- +dOa(4);J=H- +dOa(3);H=J- +dOa(2);J=H- +dOa(1);H=J- +dOa(6);J=+dOa(0);K=J- +dOa(7);J=K- +dOa(4);K=J- +dOa(3);J=K- +dOa(2);K=J- +dOa(1);J=K- +dOa(6);K=J/+dOa(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];SMa(25,0,154288,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];SMa(25,0,154256,x)}K=+dOa(0);H=+dOa(0);J=H/+dOa(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];SMa(25,0,154320,v);fe[c[29686]&511](25);SMa(25,1,154344,u);c[t>>2]=c[d+40>>2];SMa(25,0,154352,t);c[s>>2]=c[d+44>>2];SMa(25,0,154376,s);fe[c[29686]&511](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);SMa(25,1,154400,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];SMa(25,0,154416,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];SMa(25,0,154432,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];SMa(25,0,154464,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];SMa(25,0,154496,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];SMa(25,0,154520,m);fe[c[29686]&511](25)}else if((s|0)!=5){SMa(25,1,154552,l);SMa(25,0,154560,j);fe[c[29686]&511](25)}SMa(25,0,154624,g);iOa(0);i=f;return 0}function $Qa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Xb(b|0,155096)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];wd(b|0,155104,y|0)|0;if((z|0)==0){C=Sd(10,b|0)|0;D=ud(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Xfb(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];wd(b|0,155120,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Xfb(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;wd(b|0,155136,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Xfb(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;wd(b|0,155144,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Xfb(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;wd(b|0,155152,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((Xfb(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];wd(b|0,155120,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];wd(b|0,155120,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((Xfb(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;wd(b|0,155136,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;wd(b|0,155136,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((Xfb(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;wd(b|0,155144,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;wd(b|0,155144,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((Xfb(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;wd(b|0,155152,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Xfb(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];wd(b|0,155120,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Xfb(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;wd(b|0,155136,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Xfb(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;wd(b|0,155144,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Xfb(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;wd(b|0,155152,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Xb(0,155096)|0;}while((d|0)!=0);C=Sd(10,b|0)|0;D=ud(b|0)|0;i=e;return}function aRa(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 4:{v=c[600]|0;if((v|0)!=0){if((Xfb(v,154760)|0)==0){break a}}SMa(23,0,154776,p);w=1;i=m;return w|0};case 11:case 10:case 9:case 6:case 7:case 8:{UMa(1,0,154648,r);w=1;i=m;return w|0};case 18:{v=c[600]|0;do{if((v|0)!=0){if((Xfb(v,154904)|0)!=0){break}c[u>>2]=4;break a}}while(0);SMa(23,0,154928,o);w=1;i=m;return w|0};case 5:{UMa(1,0,154720,q);w=1;i=m;return w|0};default:{}}}while(0);q=XQa(a,s)|0;Ce[c[119092>>2]&7]()|0;do{if((q|0)==0){o=ZQa(a,b,d,e,f,g)|0;Ce[c[119092>>2]&7]()|0;if((o|0)!=0){x=o;break}if((c[u>>2]|0)!=5){ge[c[159940>>2]&127](159920,a);SPa(a)}y=+h[a+248>>3];o=n;h[k>>3]=+h[a+240>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=y;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];SMa(23,0,155056,n);o=xe[c[c[a+540>>2]>>2]&63](a,t)|0;Ce[c[119092>>2]&7]()|0;_Qa(a,s,l)|0;Ce[c[119092>>2]&7]()|0;x=o}else{Ce[c[119092>>2]&7]()|0;x=q}}while(0);YQa(a,s)|0;w=x;i=m;return w|0}function bRa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){cRa(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((ie[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){WMa(c[a+536>>2]|0,155168,d)}else if((k|0)==6){cRa(a);i=b;return}}function cRa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;dgb(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function dRa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;yfb(c[f+(a*48|0)+28>>2]|0);yfb(c[f+(a*48|0)+32>>2]|0);yfb(c[f+(a*48|0)+16>>2]|0);yfb(c[f+(a*48|0)+20>>2]|0);yfb(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function eRa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=xfb(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=xfb(c[y>>2]<<2)|0;fRa(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;bgb(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;bgb(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((hPa(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=gRa(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){bgb(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;bgb(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;yfb(x);yfb(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;UMa(5,1,155224,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];hc(q|0,155256,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;UMa(5,0,155264,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=118744;K=c[29686]|0;fe[K&511](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=6;_=Z;$=155272;aa=$;WMa(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];UMa(5,0,155264,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=118744;K=c[29686]|0;fe[K&511](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=6;_=Z;$=155272;aa=$;WMa(O,aa,g);return 0}function fRa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;dgb(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}ie[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function gRa(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=zfb(d,4)|0;r=zfb(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;yfb(q);yfb(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;yfb(q);yfb(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){yfb(q);yfb(r);i=o;return v|0}if((n|0)==0){v=-1;yfb(q);yfb(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];SMa(5,1,155376,p);hRa(s,d,f,c[g>>2]|0,j,l,m);if((c[118212>>2]|0)==0){v=-1;yfb(q);yfb(r);i=o;return v|0}fe[c[29686]&511](5);v=-1;yfb(q);yfb(r);i=o;return v|0}function hRa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;dgb(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];SMa(5,0,155408,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function iRa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=ic(155424,155448)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=dd(n|0)|0;if((o|0)==10){break}else if((o|0)==-1){break a}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;pb(n|0);do{}while((dd(n|0)|0)!=10);q=c[b+152>>2]|0;r=zfb(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=zfb(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=zfb(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=Od(n|0,155456,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=Od(n|0,155456,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=zfb(s,8)|0;x=v}}while(0);gc(155464,j|0)|0;gc(155520,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];gc(155480,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];gc(155504,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}tb(155520)|0;Yc(n|0)|0;c[b+460>>2]=0;i=d;return 0}function jRa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}yfb(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){yfb(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}yfb(l);i=d;return 0}function kRa(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function lRa(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+mRa(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[118228>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];SMa(9,1,155584,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];SMa(9,0,155696,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}fe[c[29686]&511](9);g=1;i=b;return g|0}function mRa(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;BRa(b);g=f+540|0;ie[c[(c[g>>2]|0)+84>>2]&127](f)|0;ie[c[(c[g>>2]|0)+36>>2]&127](f)|0;ie[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;xe[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function nRa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+mRa(b,1.0);if((c[118228>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}SMa(9,1,155720,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];SMa(9,0,155784,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];SMa(9,0,155744,s)}SMa(9,1,155808,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;SMa(9,0,155880,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];SMa(9,0,155832,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;SMa(9,0,155968,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];SMa(9,0,155904,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;SMa(9,0,156056,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];SMa(9,0,156e3,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}fe[c[29686]&511](9);SMa(9,1,156088,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=ie[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;SMa(9,0,155880,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];SMa(9,0,155832,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}fe[c[29686]&511](9);fe[c[29686]&511](9);i=d;return}function oRa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[118228>>2]|0)!=0){TPa(b,9)}if((c[118288>>2]|0)==0){i=d;return}SMa(24,1,156112,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){SMa(24,1,156152,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];SMa(24,0,156176,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}fe[c[29686]&511](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}SMa(24,1,156232,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];SMa(24,0,156256,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}fe[c[29686]&511](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){SMa(24,1,156288,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];SMa(24,0,156176,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}fe[c[29686]&511](24)}p=b+124|0;if((c[p>>2]|0)>0){SMa(24,1,156312,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;SMa(24,0,156336,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}fe[c[29686]&511](24)}H=b+128|0;if((c[H>>2]|0)>0){SMa(24,1,156384,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?156456:156464;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?156456:156464;t=(a[(c[l>>2]|0)+n|0]|0)!=0?156456:156464;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;SMa(24,0,156408,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}fe[c[29686]&511](24)}n=b+132|0;if((c[n>>2]|0)>0){SMa(24,1,156472,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;SMa(24,0,156496,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}fe[c[29686]&511](24)}fe[c[29686]&511](24);i=d;return}function pRa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;SMa(9,0,156544,z);if((f|0)==0){QPa(b);RPa(b);C=6}else{if((a[f]|0)!=0){qRa(b,f,g)}QPa(b);RPa(b);if((a[f]|0)==0){C=6}}if((C|0)==6){ie[c[(c[A>>2]|0)+84>>2]&127](b)|0;ie[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(Xfb(d,158032)|0)==0|0;f=(Xfb(d,158040)|0)==0;z=(Xfb(d,158048)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;UMa(1,0,156592,y);UMa(1,0,156624,x);c[w>>2]=158032;c[w+4>>2]=157840;UMa(1,0,156648,w);c[v>>2]=158040;c[v+4>>2]=157920;UMa(1,0,156648,v);c[u>>2]=158048;c[u+4>>2]=157968;UMa(1,0,156648,u);WMa(c[b+536>>2]|0,156680,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(Xfb(e,c[156704+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;UMa(1,0,156736,s);UMa(1,0,156624,r);t=1;do{u=c[156768+(t<<2)>>2]|0;c[q>>2]=c[156704+(t<<2)>>2];c[q+4>>2]=u;UMa(1,0,156648,q);t=t+1|0;}while((t|0)<7);WMa(c[b+536>>2]|0,156680,p)}}while(0);p=c[156664+(D<<2)>>2]|0;c[o>>2]=c[156576+(D<<2)>>2];c[o+4>>2]=p;SMa(9,0,156800,o);o=(D|0)==2;if(o){p=c[156768+(F<<2)>>2]|0;c[n>>2]=c[156704+(F<<2)>>2];c[n+4>>2]=p;SMa(9,0,156840,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=rRa(b,F,j)|0;break}if((D|0)==3){sRa(b,j);I=0;break}else{WMa(c[b+536>>2]|0,156880,m)}}}while(0);if((DQa(b,1)|0)!=0){J=-2;oRa(b);K=15;L=K;M=156904;N=M;SMa(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];zPa(b,R,V);W=426;NPa(b);X=432;SPa(b);Y=427;IPa(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ie[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=xe[ha&63](b,1)|0;ja=435;OPa(b);i=k;return J|0}if((tQa(b,1)|0)!=0){J=-3;oRa(b);K=15;L=K;M=156904;N=M;SMa(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];zPa(b,R,V);W=426;NPa(b);X=432;SPa(b);Y=427;IPa(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ie[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=xe[ha&63](b,1)|0;ja=435;OPa(b);i=k;return J|0}m=(iQa(b,1)|0)==0;J=m?I:-4;oRa(b);K=15;L=K;M=156904;N=M;SMa(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];zPa(b,R,V);W=426;NPa(b);X=432;SPa(b);Y=427;IPa(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ie[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=xe[ha&63](b,1)|0;ja=435;OPa(b);i=k;return J|0}function qRa(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];SMa(9,0,158064,z);z=zNa(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;WMa(C,158104,y)}SMa(9,0,158144,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=ANa(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=vRa(c[d+(C*112|0)+4>>2]|0)|0;E=ANa(A,D)|0;yfb(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((Yfb(E,158184,6)|0)==0){if((c[118228>>2]|0)==0){break}}else{D=Yfb(E,158192,6)|0;if((c[118228>>2]|D|0)==0){break}}c[v>>2]=E;UMa(9,0,158200,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;GNa(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];SMa(9,0,158168,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}SMa(9,0,158256,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=ANa(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=vRa(c[G+(w*112|0)+4>>2]|0)|0;v=ANa(A,F)|0;yfb(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];UMa(9,0,158280,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;GNa(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];SMa(9,0,158168,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}SMa(9,0,158336,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=ANa(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=vRa(c[t+(x*112|0)+4>>2]|0)|0;K=ANa(A,C)|0;yfb(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];UMa(9,0,158280,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;GNa(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];SMa(9,0,158168,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}SMa(9,0,158360,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=ANa(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=vRa(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=ANa(A,u)|0;yfb(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];UMa(9,0,158408,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;GNa(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;SMa(9,0,158392,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}SMa(9,0,158464,l);l=b+144|0;if((c[l>>2]|0)<=0){xNa(A);i=f;return}o=b+32|0;b=0;do{x=ANa(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=vRa(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=ANa(A,n)|0;yfb(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];UMa(9,0,158512,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;GNa(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?156456:156464;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;SMa(9,0,158496,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));xNa(A);i=f;return}function rRa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;yPa(a,+h[a+240>>3]);NPa(a);SPa(a);IPa(a);UPa(a);cRa(a);JPa(a);NPa(a);e=tRa(a,b,c)|0;SPa(a);IPa(a);OPa(a);SPa(a);i=d;return e|0}function sRa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;yPa(b,+h[b+240>>3]);NPa(b);SPa(b);eRa(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=zfb(c[y>>2]|0,8)|0;A=b+124|0;B=zfb(c[A>>2]|0,4)|0;C=b+128|0;D=zfb(c[C>>2]|0,1)|0;E=b+132|0;F=zfb(c[E>>2]|0,4)|0;G=b+536|0;VMa(c[G>>2]|0,(z|0)!=0|0,156936,t);VMa(c[G>>2]|0,(B|0)!=0|0,156936,s);VMa(c[G>>2]|0,(D|0)!=0|0,156936,r);VMa(c[G>>2]|0,(F|0)!=0|0,156936,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[118228>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];hc(x|0,156952,p|0)|0;p=ic(x|0,156968)|0;c[o>>2]=156984;wd(p|0,156976,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];wd(p|0,156976,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Sd(10,p|0)|0;H=p}SMa(9,1,156992,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;ie[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];SMa(9,0,157016,l);if((c[118228>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];wd(H|0,157040,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];wd(H|0,157040,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Sd(10,H|0)|0}if((DQa(b,0)|0)!=0){break a}if((tQa(b,0)|0)!=0){break a}if((iQa(b,0)|0)!=0){break a}VPa(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);fe[c[29686]&511](9);if((c[118228>>2]|0)!=0){Yc(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}yfb(z);yfb(B);yfb(D);yfb(F)}else{h[b+304>>3]=1.0;ie[c[w+80>>2]&127](b)|0}KPa(b);if((eRa(b,1,1)|0)!=1){i=e;return}ie[c[(c[v>>2]|0)+80>>2]&127](b)|0;KPa(b);if((eRa(b,1,1)|0)!=1){i=e;return}UMa(1,0,157048,f);i=e;return}function tRa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=wRa(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){SMa(9,0,157152,u);if((c[b+184>>2]|0)==0){xe[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}yfb(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){SMa(9,0,157184,t);xe[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;yfb(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){SMa(9,1,157256,s);t=xfb(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+mRa(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+mRa(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}SMa(9,1,157280,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];SMa(9,0,157304,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];SMa(9,0,157304,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];SMa(9,0,157304,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[118228>>2]|0)!=0){fe[c[29686]&511](9);fe[c[29686]&511](9)}yfb(t);xRa(v);H=wRa(b)|0;if((c[H>>2]|0)!=0){$=H;break}SMa(9,0,157328,n);yfb(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}SMa(9,0,157360,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){SMa(9,0,157376,l);uRa($,d,1,e);nRa(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+mRa($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){yfb(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){yfb(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){yfb(v);c[l>>2]=0}uRa($,d,0,e);nRa(b,$);+mRa($,1.0)}else{SMa(9,0,157400,j)}SMa(9,1,157424,g);nRa(b,$);b=lRa($)|0;if((c[118228>>2]|0)!=0){fe[c[29686]&511](9)}xRa($);y=b;i=f;return y|0}function uRa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=xfb(c[p>>2]<<3)|0;r=q;s=+mRa(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;zRa(a,r);yfb(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=157552;F=E;SMa(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;SMa(9,0,157464,m);if(!t){yRa(a)}switch(b|0){case 3:{G=IRa(a,n,e)|0;break};case 4:{H=12;break a;break};case 5:{H=13;break a;break};case 2:{G=ERa(a)|0;break};case 6:{H=14;break a;break};case 1:{G=GRa(a)|0;break};default:{H=15;break a}}SPa(o);IPa(o);OPa(o);SPa(o);s=+mRa(a,1.0);v=(G|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}SMa(9,0,157512,k);nRa(o,a);K=s}else{SMa(9,0,157528,j);if(v&s==x){y=w;H=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;H=23;break}}if((H|0)==12){DRa(a)|0}else if((H|0)==13){DRa(a)|0}else if((H|0)==14){CRa(o,a,0)|0}else if((H|0)==15){WMa(c[o+536>>2]|0,157488,l)}else if((H|0)==23){zRa(a,r);yfb(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=157552;F=E;SMa(9,0,F,g);i=f;return}}function vRa(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=$fb(b|0)|0;do{if((d|0)==0){e=xfb(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==93){l=h+ -1|0}else if(k<<24>>24==91){l=h+1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=xfb(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==91){q=p+1|0}else if(h<<24>>24==93){q=p+ -1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((Wfb(e,158568,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;bgb(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((Wfb(e,158568,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function wRa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=xfb(64)|0;z=y;VMa(0,(y|0)!=0|0,158576,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=zfb(Z,8)|0;c[E>>2]=y;VMa(0,(y|0)!=0|0,158576,w);w=zfb(Z,8)|0;c[F>>2]=w;VMa(0,(w|0)!=0|0,158576,v);v=zfb(Z,8)|0;c[G>>2]=v;VMa(0,(v|0)!=0|0,158576,u);u=zfb(Z,8)|0;c[H>>2]=u;VMa(0,(u|0)!=0|0,158576,t);t=zfb(Z,8)|0;c[I>>2]=t;VMa(0,(t|0)!=0|0,158576,s);s=zfb(Z,4)|0;t=s;c[J>>2]=t;VMa(0,(s|0)!=0|0,158576,r);SMa(9,0,158592,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;SMa(9,0,158616,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];SMa(9,0,158704,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];SMa(9,0,158752,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];SMa(9,0,158808,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;SMa(9,0,158864,l);c[j>>2]=ya;SMa(9,0,158936,j);j=zfb(sa,8)|0;c[K>>2]=j;VMa(0,(j|0)!=0|0,158576,g);g=xfb(sa<<3)|0;c[L>>2]=g;VMa(0,(g|0)!=0|0,158576,f);f=xfb(ya<<3)|0;c[M>>2]=f;VMa(0,(f|0)!=0|0,158576,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function xRa(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){yfb(d)}d=c[a+28>>2]|0;if((d|0)!=0){yfb(d)}d=c[a+32>>2]|0;if((d|0)!=0){yfb(d)}d=c[a+36>>2]|0;if((d|0)!=0){yfb(d)}d=c[a+40>>2]|0;if((d|0)!=0){yfb(d)}d=c[a+44>>2]|0;if((d|0)!=0){yfb(d)}d=c[a+48>>2]|0;if((d|0)!=0){yfb(d)}d=c[a+52>>2]|0;if((d|0)!=0){yfb(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;yfb(e);i=b;return}yfb(d);e=a;yfb(e);i=b;return}function yRa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=zfb(o,8)|0;q=zfb(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=zfb(s,8)|0;u=zfb(s,8)|0;v=zfb(o,8)|0;w=zfb(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+mRa(b,1.0);s=c[n>>2]|0;if((s|0)>0){bgb(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+mRa(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){bgb(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;SMa(9,0,158976,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}yfb(p);yfb(q);yfb(t);yfb(u);yfb(v);yfb(w);i=d;return}function zRa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function ARa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function BRa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function CRa(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;WMa(c[a+536>>2]|0,159048,d);return 0}function DRa(a){a=a|0;a=i;i=i+8|0;WMa(0,159080,a);return 0}function ERa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[118228>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=zfb((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;VMa(0,(n|0)!=0|0,159120,b);c[39784]=c[a+60>>2];c[39786]=c[a+48>>2];_Oa(k,j,c[a+24>>2]|0,g,f,d,e,n,7)|0;yfb(n);c[39784]=0;c[39786]=0;n=lRa(a)|0;i=b;return n|0}function FRa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[39786];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[39784];h[d>>3]=+mRa(f,1.0);i=e;return}function GRa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=xfb(x)|0;z=y;A=xfb(x)|0;x=A;VMa(0,(y|0)!=0|0,159152,n);VMa(0,(A|0)!=0|0,159152,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[118228>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+mRa(a,1.0);h[o>>3]=D;if(D!=0.0){c[39792]=c[a+60>>2];c[39794]=c[a+48>>2];XOa(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,8,u)|0;c[39792]=0;c[39794]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];SMa(9,0,159184,l)}D=+mRa(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];SMa(9,0,159288,j);j=c[u>>2]|0;do{if((j|0)==4){UMa(9,0,159520,d);F=-4;i=b;return F|0}else if((j|0)==3){UMa(9,0,159448,e);F=-3;i=b;return F|0}else if((j|0)==2){UMa(9,0,159384,f);F=-2;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];UMa(9,0,159304,g);F=-1;i=b;return F|0}}while(0);F=lRa(a)|0;i=b;return F|0}function HRa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[39794];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[39792];h[d>>3]=+mRa(f,1.0);i=e;return}function IRa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;SMa(9,1,159576,g);if((c[118228>>2]|0)==0){l=0}else{l=(k|0)/10|0}JRa(a,d,k,l,b,j);c[f>>2]=c[j>>2];SMa(9,0,159600,f);fe[c[29686]&511](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=lRa(a)|0;if((b|0)==0){m=0;i=e;return m|0}UMa(9,0,159616,e);m=b;i=e;return m|0}function JRa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=xfb(fa(N,M)|0)|0;P=xfb(M<<3)|0;Q=xfb(N)|0;R=Q;S=xfb(N)|0;T=S;V=xfb(N)|0;W=V;X=xfb(N)|0;Y=+h[f>>3];if((c[118228>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];hc(N|0,159664,I|0)|0;I=ic(N|0,159680)|0;c[H>>2]=159696;wd(I|0,159688,H|0)|0;c[G>>2]=159712;wd(I|0,159688,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];wd(I|0,159688,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Sd(10,I|0)|0;c[E>>2]=0;wd(I|0,159720,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];wd(I|0,159728,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];wd(I|0,159728,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Sd(10,I|0)|0;Z=I}else{Z=0}VMa(0,(O|0)!=0|0,159736,B);VMa(0,(P|0)!=0|0,159736,A);VMa(0,(Q|0)!=0|0,159736,z);VMa(0,(S|0)!=0|0,159736,y);VMa(0,(V|0)!=0|0,159736,x);VMa(0,(X|0)!=0|0,159736,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{ARa(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+mRa(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;ARa(a,la);+mRa(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];SMa(9,0,159752,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){dgb(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);ARa(a,R);za=+mRa(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}bgb(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}ARa(a,T);if(+mRa(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}bgb(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}bgb(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}ARa(a,W);Ba=+mRa(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}ARa(a,W);Ba=+mRa(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}bgb(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];SMa(9,0,159792,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;wd(Z|0,159720,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];wd(Z|0,159728,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];wd(Z|0,159728,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Sd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];UMa(9,0,159840,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];UMa(9,0,159856,p);WMa(0,159872,o)}ARa(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){yfb(S);yfb(Q);yfb(V);yfb(X);yfb(P);yfb(O);i=j;return}c[n>>2]=ia;wd(Z|0,159720,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];wd(Z|0,159728,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];wd(Z|0,159728,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Sd(10,Z|0)|0;Yc(Z|0)|0;yfb(S);yfb(Q);yfb(V);yfb(X);yfb(P);yfb(O);i=j;return}function KRa(a,b){a=a|0;b=b|0;i=i;return}function LRa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;iOa(3);lOa(0);w=+dOa(0);iOa(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];wd(v|0,159952,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];wd(v|0,159952,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];wd(v|0,159952,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];wd(v|0,159960,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;wd(v|0,159960,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];wd(v|0,159968,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else if(p<<24>>24==1){break}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];wd(v|0,159952,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];wd(v|0,159952,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;wd(v|0,159960,l|0)|0;break}else{c[m>>2]=0-E;wd(v|0,159960,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;wd(v|0,159960,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;wd(v|0,159960,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Sd(10,v|0)|0;lOa(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];wd(v|0,159968,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Sd(10,v|0)|0;lOa(3);i=e;return}function MRa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=ic(c[r>>2]|0,159976)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Wd(c[(Nc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;VMa(t,(s|0)!=0|0,159984,q);c[p>>2]=160040;wd(s|0,159968,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=160048;wd(s|0,159968,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];wd(s|0,159968,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];wd(s|0,159968,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];wd(s|0,159968,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];wd(s|0,159968,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];wd(s|0,159968,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];wd(s|0,159968,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];wd(s|0,159968,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Sd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];wd(s|0,159968,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Sd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function NRa(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;iOa(3);Yc(d|0)|0;lOa(3);i=b;return}function ORa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;J7a(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];K7a(p,f)|0;PRa(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;QRa(a,b,160064,c[j>>2]|0,c[g>>2]|0,o,8);yfb(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];K7a(p,e)|0;i=d;return}function PRa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=zfb(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;VMa(c[b+536>>2]|0,(p|0)!=0|0,160344,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function QRa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;$Ra(a,b,d,e,f,h);I7a(l,g,fa(fa(f,e)|0,h)|0)|0;if(d6a(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];WMa(l,160296,k)}else{i=j;return}}function RRa(a){a=a|0;var b=0;b=i;if((TSa(a+4|0)|0)!=0){i=b;return}g6a(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function SRa(a){a=a|0;Rc(a|0)|0;Ya()}function TRa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=Dfb(320)|0;dgb(q|0,0,320)|0;URa(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;iOa(3);t=a+8|0;u=VRa(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=WRa(a,b,u+s|0)|0;u=q+184|0;XRa(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;XRa(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;YRa(q,c[x>>2]|0,36);if(d6a(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];WMa(y,160120,e)}else{QRa(a,b,160152,4,11,160072,1);ZRa((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;QRa(a,b,160160,c[g>>2]|0,c[j>>2]|0,e,1);yfb(e);c[f>>2]=0;ZRa((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;QRa(a,b,160168,c[g>>2]|0,c[j>>2]|0,e,1);yfb(e);c[f>>2]=0;_Ra(a,b,k,g,j,c[r>>2]|0,s);QRa(a,b,160184,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;J7a(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];PRa(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;QRa(a,b,160064,c[j>>2]|0,c[g>>2]|0,n,8);J7a(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=aSa(q+240|0)|0;w=aSa(q+264|0)|0;p=aSa(q+288|0)|0;$Ra(a,b,160200,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);yfb(n);yfb(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;o7a(s)|0;yfb(v);lOa(3);i=d;return}}function URa(a){a=a|0;var b=0;b=i;bVa(a);i=b;return}function VRa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(fUa(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(fUa(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(fUa(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}



function LIa(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=He[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case-4:{B=17;break a;break};case 3:case 4:{C=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;D=1;c[t>>2]=sIa(y+416|0,e,C,C+(xe[c[e+32>>2]&63](e,C)|0)|0)|0;if((c[t>>2]|0)==0){B=89;break a}c[y+432>>2]=c[y+428>>2];E=OIa(y,e,c[m>>2]|0,t,s)|0;if((E|0)!=0){B=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){Ee[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);D=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}ge[c[y+56>>2]&127](c[y+4>>2]|0,c[t>>2]|0);D=0}do{if((D&255|0)!=0){if((c[y+80>>2]|0)==0){break}eIa(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);PHa(y+416|0);while(1){if((c[s>>2]|0)==0){break}D=c[s>>2]|0;if((c[y+104>>2]|0)!=0){ge[c[y+104>>2]&127](c[y+4>>2]|0,c[c[D>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[D+4>>2]=c[y+376>>2];c[y+376>>2]=D;c[(c[D>>2]|0)+4>>2]=c[D+8>>2]}if((c[y+312>>2]|0)==0){B=107;break a}break};case 5:{if((c[y+312>>2]|0)==(b|0)){B=109;break a}D=c[y+364>>2]|0;c[y+364>>2]=c[D>>2];c[D>>2]=c[y+368>>2];c[y+368>>2]=D;F=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;C=xe[c[e+32>>2]&63](e,F)|0;if((C|0)!=(c[D+8>>2]|0)){B=112;break a}if((Wfb(c[D+4>>2]|0,F,C)|0)!=0){B=112;break a}C=y+312|0;c[C>>2]=(c[C>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){C=c[D+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((C|0)==0){break}G=(c[D+12>>2]|0)+(c[D+28>>2]|0)|0;while(1){if((a[C]|0)==0){break}H=C;C=H+1|0;I=G;G=I+1|0;a[I]=a[H]|0}H=c[D+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((H|0)==0){break}I=G;G=I+1|0;a[I]=a[y+472|0]|0;while(1){if((a[H]|0)==0){break c}I=H;H=I+1|0;J=G;G=J+1|0;a[J]=a[I]|0}}}while(0);a[G]=0}}while(0);ge[c[y+56>>2]&127](c[y+4>>2]|0,c[D+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}eIa(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[D+44>>2]|0)==0){break}C=c[D+44>>2]|0;if((c[y+104>>2]|0)!=0){ge[c[y+104>>2]&127](c[y+4>>2]|0,c[c[C>>2]>>2]|0)}c[D+44>>2]=c[(c[D+44>>2]|0)+4>>2];c[C+4>>2]=c[y+376>>2];c[y+376>>2]=C;c[(c[C>>2]|0)+4>>2]=c[C+8>>2]}if((c[y+312>>2]|0)==0){B=133;break a}break};case 12:{B=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;Ee[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}eIa(y,e,c[m>>2]|0,c[n>>2]|0);break};case 9:{a[p]=le[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){D=y;if((c[y+60>>2]|0)!=0){Ee[c[D+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[D+80>>2]|0)==0){break b}eIa(y,e,c[m>>2]|0,c[n>>2]|0);break b}D=sIa(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((D|0)==0){B=37;break a}C=jIa(y,k,D,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){B=40;break}if((C|0)!=0){break}H=y;if((c[y+120>>2]|0)!=0){Ee[c[H+120>>2]&15](c[y+4>>2]|0,D,0);break b}if((c[H+80>>2]|0)==0){break b}eIa(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{B=40}}while(0);if((B|0)==40){B=0;if((C|0)==0){B=41;break a}if((a[C+34|0]|0)==0){B=43;break a}}if((a[C+32|0]|0)!=0){B=50;break a}if((c[C+28>>2]|0)!=0){B=52;break a}D=y;if((c[C+4>>2]|0)!=0){H=y;if((a[D+308|0]|0)!=0){K=FIa(H,C,0)|0;if((K|0)!=0){B=60;break a}else{break b}}I=y;if((c[H+120>>2]|0)!=0){Ee[c[I+120>>2]&15](c[y+4>>2]|0,c[C>>2]|0,0);break b}if((c[I+80>>2]|0)==0){break b}eIa(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[D+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}eIa(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[C+32|0]=1;D=NIa(y)|0;a[C+32|0]=0;if((D|0)==0){B=63;break a}if((ye[c[y+112>>2]&63](c[y+116>>2]|0,D,c[C+20>>2]|0,c[C+16>>2]|0,c[C+24>>2]|0)|0)==0){B=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 0:{B=24;break a;break};case-2:{B=28;break a;break};case 1:case 2:{D=y;if((c[y+368>>2]|0)!=0){L=c[D+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{L=ie[c[D+12>>2]&127](48)|0;if((L|0)==0){B=72;break a}c[L+36>>2]=ie[c[y+12>>2]&127](32)|0;if((c[L+36>>2]|0)==0){B=74;break a}c[L+40>>2]=(c[L+36>>2]|0)+32}c[L+44>>2]=0;c[L>>2]=c[y+364>>2];c[y+364>>2]=L;c[L+16>>2]=0;c[L+20>>2]=0;c[L+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[L+8>>2]=xe[c[e+32>>2]&63](e,c[L+4>>2]|0)|0;D=y+312|0;c[D>>2]=(c[D>>2]|0)+1;D=(c[L+4>>2]|0)+(c[L+8>>2]|0)|0;c[r>>2]=c[L+4>>2];c[q>>2]=c[L+36>>2];while(1){ce[c[e+60>>2]&31](e,r,D,q,(c[L+40>>2]|0)+ -1|0);M=(c[q>>2]|0)-(c[L+36>>2]|0)|0;if((c[r>>2]|0)==(D|0)){break}I=(c[L+40>>2]|0)-(c[L+36>>2]|0)<<1;H=xe[c[y+16>>2]&63](c[L+36>>2]|0,I)|0;if((H|0)==0){B=80;break a}c[L+36>>2]=H;c[L+40>>2]=H+I;c[q>>2]=H+M}c[L+24>>2]=M;c[L+12>>2]=c[L+36>>2];a[c[q>>2]|0]=0;N=OIa(y,e,c[m>>2]|0,L+12|0,L+44|0)|0;if((N|0)!=0){B=82;break a}D=y;do{if((c[y+52>>2]|0)!=0){Ee[c[D+52>>2]&15](c[y+4>>2]|0,c[L+12>>2]|0,c[y+392>>2]|0)}else{if((c[D+80>>2]|0)==0){break}eIa(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);PHa(y+416|0);break};case-1:{B=25;break a;break};case 10:{D=xe[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((D|0)<0){B=135;break a}C=y;if((c[y+60>>2]|0)!=0){H=c[C+60>>2]|0;I=c[y+4>>2]|0;J=aJa(D,u)|0;Ee[H&15](I,u,J);break b}if((c[C+80>>2]|0)==0){break b}eIa(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{C=y;do{if((c[y+72>>2]|0)!=0){fe[c[C+72>>2]&511](c[y+4>>2]|0)}else{if((c[C+80>>2]|0)==0){break}eIa(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);O=QIa(y,e,n,g,h,j)|0;if((O|0)!=0){B=150;break a}if((c[n>>2]|0)==0){B=152;break a}break};case-5:{B=153;break a;break};case 6:{C=c[y+60>>2]|0;if((C|0)==0){if((c[y+80>>2]|0)==0){break b}eIa(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){Ee[C&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];ce[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];Ee[C&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 11:{if((HIa(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=174;break a}break};case 13:{if((IIa(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=176;break a}break};case-3:{B=6;break a;break};default:{if((c[y+80>>2]|0)==0){break b}eIa(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==3){B=180;break}else if((f|0)==2){B=181;break}}if((B|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;Ee[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}eIa(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((B|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((B|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((B|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((B|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((B|0)==37){P=1;Q=P;i=l;return Q|0}else if((B|0)==41){P=11;Q=P;i=l;return Q|0}else if((B|0)==43){P=24;Q=P;i=l;return Q|0}else if((B|0)==50){P=12;Q=P;i=l;return Q|0}else if((B|0)==52){P=15;Q=P;i=l;return Q|0}else if((B|0)==60){P=K;Q=P;i=l;return Q|0}else if((B|0)==63){P=1;Q=P;i=l;return Q|0}else if((B|0)==65){P=21;Q=P;i=l;return Q|0}else if((B|0)==72){P=1;Q=P;i=l;return Q|0}else if((B|0)==74){fe[c[y+20>>2]&511](L);P=1;Q=P;i=l;return Q|0}else if((B|0)==80){P=1;Q=P;i=l;return Q|0}else if((B|0)==82){P=N;Q=P;i=l;return Q|0}else if((B|0)==89){P=1;Q=P;i=l;return Q|0}else if((B|0)==91){P=E;Q=P;i=l;return Q|0}else if((B|0)==107){P=PIa(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==109){P=13;Q=P;i=l;return Q|0}else if((B|0)==112){c[z>>2]=F;P=7;Q=P;i=l;return Q|0}else if((B|0)==133){P=PIa(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==135){P=14;Q=P;i=l;return Q|0}else if((B|0)==140){P=17;Q=P;i=l;return Q|0}else if((B|0)==150){P=O;Q=P;i=l;return Q|0}else if((B|0)==152){c[y+280>>2]=42;P=O;Q=P;i=l;return Q|0}else if((B|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){Ee[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];ce[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);Ee[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}eIa(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((B|0)==174){P=1;Q=P;i=l;return Q|0}else if((B|0)==176){P=1;Q=P;i=l;return Q|0}else if((B|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((B|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function MIa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=He[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=qIa(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=LIa(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=40;m=He[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=qIa(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=LIa(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function NIa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((gIa(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gIa(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);hIa(e,b+60|0);a:while(1){k=iIa(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gIa(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((gIa(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((gIa(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gIa(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){hIa(e,b);b:while(1){b=iIa(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gIa(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gIa(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((gIa(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}function OIa(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=jIa(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=RHa(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=jIa(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((UIa(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=He[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=xe[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}He[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=wIa(k,b,v,w+(xe[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=sIa(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=AIa(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=nIa(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=nIa(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=xe[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(jIa(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((gIa(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((gIa(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((gIa(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=ie[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;bgb(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}fe[c[k+20>>2]&511](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;bgb(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;bgb(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function PIa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=43;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=He[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case-15:{k=3;break a;break};case 0:{k=14;break a;break};case 15:{if((c[j+80>>2]|0)==0){break b}eIa(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case-2:{k=18;break a;break};case 13:{if((IIa(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case-1:{k=15;break a;break};case-4:{k=7;break a;break};case 11:{if((HIa(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==2){k=24;break}else if((f|0)==3){k=23;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){eIa(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function QIa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=He[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case 0:{r=24;break a;break};case 40:{r=6;break a;break};case-4:case-1:{r=28;break a;break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;Ee[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}eIa(o,b,c[k>>2]|0,c[l>>2]|0);break};case-2:{r=25;break a;break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}eIa(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){Ee[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];ce[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];Ee[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==2){r=34;break}else if((h|0)==3){r=33;break}}if((r|0)==6){n=o;do{if((c[o+76>>2]|0)!=0){fe[c[n+76>>2]&511](c[o+4>>2]|0)}else{if((c[n+80>>2]|0)==0){break}eIa(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function RIa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=QIa(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=44;k=SIa(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=uIa(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function SIa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=LIa(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((TIa(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function TIa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=xe[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}bgb(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function UIa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((gIa(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((gIa(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=jIa(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function VIa(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(He[c[b+16>>2]&63](b,f,g,l)|0){case 9:{o=(le[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(o<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((gIa(h)|0)<<24>>24!=0)){p=42;break a}}q=h+12|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=o;break b}o=sIa(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((o|0)==0){p=44;break a}r=jIa(n,j,o,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){s=(c[n+300>>2]|0)!=0}else{s=(a[j+129|0]|0)!=0}t=((s^1)&1|0)!=0}else{t=0}u=t&1}else{if((a[j+129|0]|0)!=0){v=(d[j+130|0]|0)!=0}else{v=1}u=v&1}o=(r|0)!=0;if(u<<24>>24!=0){if(!o){p=57;break a}if((a[r+34|0]|0)==0){p=59;break a}}else{if(!o){break b}}if((a[r+32|0]|0)!=0){p=62;break a}if((c[r+28>>2]|0)!=0){p=66;break a}if((c[r+4>>2]|0)==0){p=70;break a}o=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;w=VIa(n,c[n+228>>2]|0,e,c[r+4>>2]|0,o,h)|0;a[r+32|0]=0;if((w|0)!=0){p=74;break a}break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);p=31;break};case 10:{r=xe[c[b+44>>2]&63](b,f)|0;if((r|0)<0){p=11;break a}do{if(!(e<<24>>24!=0)){if((r|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);r=aJa(r,m)|0;if((r|0)==0){p=19;break a}o=0;while(1){if((o|0)>=(r|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((gIa(h)|0)<<24>>24!=0)){p=27;break a}}q=a[m+o|0]|0;x=h+12|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=q;o=o+1|0}break};case 7:case 39:{p=31;break};case 6:{if((yIa(h,b,f,c[l>>2]|0)|0)==0){p=29;break a}break};case-4:{p=3;break a;break};case-1:{p=7;break a;break};case 0:{p=4;break a;break};default:{p=75;break a}}}while(0);do{if((p|0)==31){p=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((gIa(h)|0)<<24>>24!=0)){p=37;break a}}o=h+12|0;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=32}}while(0);f=c[l>>2]|0}if((p|0)==3){z=0;A=z;i=k;return A|0}else if((p|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((p|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((p|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((p|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((p|0)==27){z=1;A=z;i=k;return A|0}else if((p|0)==29){z=1;A=z;i=k;return A|0}else if((p|0)==37){z=1;A=z;i=k;return A|0}else if((p|0)==42){z=1;A=z;i=k;return A|0}else if((p|0)==44){z=1;A=z;i=k;return A|0}else if((p|0)==57){z=11;A=z;i=k;return A|0}else if((p|0)==59){z=24;A=z;i=k;return A|0}else if((p|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((p|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((p|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((p|0)==74){z=w;A=z;i=k;return A|0}else if((p|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function WIa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((le[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=bJa()|0;c[g+240>>2]=ie[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=He[((a[g+236|0]&255|0)!=0?45:46)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){fe[c[f+1032>>2]&511](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}fe[c[f+1032>>2]&511](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function XIa(){var a=0,b=0;a=i;i=i+8|0;bc(((sc(0)|0)>>>0)%4294967295|0|0);b=hgb()|0;i=a;return b|0}function YIa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=oIa(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=40;h=pIa(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function ZIa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=ie[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{_Ia(f+80|0,e);_Ia(b+104|0,e);$Ia(b,e);$Ia(b+20|0,e);$Ia(b+40|0,e);$Ia(b+60|0,e);a[b+131|0]=0;$Ia(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function _Ia(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function $Ia(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function aJa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function bJa(){i=i;return 1912}function cJa(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[115376+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[115452+l|0]|0|0)!=28){if((d[115452+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[115452+q|0]|0|0)!=28){if((d[115452+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[115452+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((dJa(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[109544+(((d[109288+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[109544+(((d[110824+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=aJa(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=50;c[h+336>>2]=50;c[h+340>>2]=50;c[h+344>>2]=51;c[h+348>>2]=51;c[h+352>>2]=51;c[h+356>>2]=52;c[h+360>>2]=52;c[h+364>>2]=52}c[h+60>>2]=14;c[h+64>>2]=15;n=h;o=n;i=j;return o|0}return 0}function dJa(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 255:{if(!((c|0)==65534|(c|0)==65535)){e=7;break a}f=-1;break};case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{f=-1;break};case 0:{if((d[115452+c|0]|0|0)!=0){e=7;break a}f=-1;break};default:{e=7}}}while(0);if((e|0)==7){f=c}i=b;return f|0}function eJa(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=xe[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[109544+(((d[110824+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function fJa(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=xe[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[109544+(((d[109288+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function gJa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=xe[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(dJa(a)|0)<0;g=f&1;i=d;return g|0}function hJa(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=aJa(xe[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function iJa(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(xe[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function jJa(){i=i;return 115008}function kJa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=lJa(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=47;c[g+4>>2]=48;c[g+52>>2]=32;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function lJa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((zJa(d,c[114912+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function mJa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=xLa(113352,a,0,b,c,d)|0;i=e;return f|0}function nJa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=xLa(113352,a,1,b,c,d)|0;i=e;return f|0}function oJa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;WKa(114120,b,c,d);i=a;return}function pJa(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=qJa(35,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function qJa(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(yLa(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((He[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,114856)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((yLa(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((He[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,114864)|0)!=0){h=zLa(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=le[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((yLa(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((He[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,114880)|0)!=0){if((a|0)!=0){break}do{if((He[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,114896)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((He[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,114904)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((ALa(zLa(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function rJa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;ce[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((zJa(h,111080)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=lJa(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[113352+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function sJa(){i=i;return 112984}function tJa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=lJa(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=49;c[g+4>>2]=50;c[g+52>>2]=32;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function uJa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=xLa(111088,a,0,b,c,d)|0;i=e;return f|0}function vJa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=xLa(111088,a,1,b,c,d)|0;i=e;return f|0}function wJa(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=qJa(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function xJa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;ce[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((zJa(h,111080)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=lJa(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[111088+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function yJa(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=cJa(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function zJa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function AJa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=RJa(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 30:{k=TJa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){n=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 10:case 21:{n=25;break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 19:{k=dKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 12:{k=bKa(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{o=19;b=b+2|0;n=77;break};case 24:case 22:{o=18;b=b+2|0;n=77;break};case 29:{g=b;if((c[109544+((d[109288+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;o=18;n=77;break a}if((c[109544+((d[110824+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=76;break a}b=b+2|0;o=19;n=77;break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[g]|0)|0]|0}else{p=RJa(a[g+1|0]|0,a[b]|0)|0}switch(p|0){case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=RJa(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 16:{k=cKa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 15:{k=ZJa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 13:{k=bKa(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{n=76}}}while(0);if((n|0)==25){while(1){n=0;b=b+2|0;r=b;if((b|0)==(e|0)){n=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=RJa(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){n=25;continue}else if((s|0)!=9){n=31;break}if((b+2|0)!=(e|0)){n=25}else{n=31;break}}if((n|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((n|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==77){b:while(1){n=0;if((b|0)==(e|0)){n=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=RJa(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 5:{n=85;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 33:{n=119;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=94;break b;break};case 7:{n=91;break b;break};case 23:{b=b+2|0;r=o;if((r|0)==41){o=19;n=77;continue b}else if((r|0)!=18){n=77;continue b}if((b|0)==(e|0)){n=97;break b}o=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=RJa(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 29:{if((c[109544+((d[110824+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=103;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=105;break b;break};case 6:{n=108;break b;break};case 7:{n=111;break b;break};default:{o=19;n=77;continue b}}b=b+2|0;n=77;continue b;break};case 34:{n=116;break b;break};case 15:{n=122;break b;break};case 6:{n=88;break b;break};case 29:{if((c[109544+((d[110824+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=83;break b}break};default:{n=125;break b}}b=b+2|0;n=77}if((n|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==94){c[f>>2]=b;k=o;l=k;i=h;return l|0}else if((n|0)==97){k=-1;l=k;i=h;return l|0}else if((n|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==116){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((n|0)==119){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((n|0)==122){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((n|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==126){k=0-o|0;l=k;i=h;return l|0}}return 0}function BJa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=RJa(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 2:{k=WJa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 3:{k=SJa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=RJa(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=RJa(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 7:{r=b;if((e-b|0)<4){p=55;break b}b=r+4|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=49;break b}b=s+2|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function CJa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=RJa(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=RJa(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=RJa(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=47;break b}b=s+2|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=53;break b}b=t+4|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function DJa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=RJa(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 8:case 1:case 0:{l=17;break a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function EJa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=RJa(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 21:{n=29;break a;break};case 3:{n=12;break a;break};case 9:{n=19;break a;break};case 5:{b=b+2|0;continue a;break};case 10:{n=16;break a;break};case 6:{b=b+3|0;continue a;break};case 2:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=SJa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=RJa(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function FJa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=RJa(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 3:{n=12;break a;break};case 7:{b=b+4|0;continue a;break};case 10:{n=18;break a;break};case 9:{n=21;break a;break};case 30:{n=15;break a;break};case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=SJa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=TJa(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=RJa(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function GJa(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=RJa(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 6:{j=8;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=15;break a}k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=17;break a}else{continue a}break};case 5:{break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[j]|0)|0]|0}else{n=RJa(a[j+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function HJa(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function IJa(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=RJa(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};default:{break a}}}i=e;return b-c|0}function JJa(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=RJa(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function KJa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=RJa(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 17:case 11:{if((g|0)!=2){break a}break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=RJa(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function LJa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=dJa(c)|0;k=j;i=b;return k|0}function MJa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==4){if((a[e+1|0]|0)==0){f=a[e]|0}else{f=-1}if((f|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((f|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}else if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==103){g=62;h=g;i=b;return h|0}else if((j|0)==108){g=60;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}g=38;h=g;i=b;return h|0}}while(0);g=0;h=g;i=b;return h|0}function NJa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=RJa(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=RJa(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 6:{b=b+3|0;break};case 5:{b=b+2|0;break};case 7:{b=b+4|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function OJa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=RJa(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function PJa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g]|0;o=((l&3)<<4|(a[g+1|0]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function QJa(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function RJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 255:{if(!(((b&255)+ -254|0)>>>0<2)){d=6;break a}e=0;break};case 223:case 222:case 221:case 220:{e=8;break};case 219:case 218:case 217:case 216:{e=7;break};default:{d=6}}}while(0);if((d|0)==6){e=29}i=c;return e|0}function SJa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=RJa(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=UJa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[109544+((d[109288+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=RJa(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 6:{n=32;break b;break};case 18:{n=38;break b;break};case 29:{if((c[109544+((d[110824+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 5:{n=29;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function TJa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=RJa(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[109544+((d[109288+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=RJa(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 5:{n=29;break b;break};case 6:{n=32;break b;break};case 18:{n=38;break b;break};case 7:{n=35;break b;break};case 29:{if((c[109544+((d[110824+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function UJa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=VJa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=RJa(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=RJa(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function VJa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=RJa(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=RJa(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function WJa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=RJa(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=ZJa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=RJa(a[g+1|0]|0,a[b]|0)|0}if((n|0)==27){k=XJa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=YJa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=_Ja(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 29:{if((c[109544+((d[109288+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=RJa(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 6:{o=42;break b;break};case 5:{o=39;break b;break};case 29:{if((c[109544+((d[110824+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 7:{o=45;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=RJa(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{o=62;break b;break};case 5:{o=59;break b;break};case 24:case 22:{break};case 7:{o=65;break b;break};case 29:{if((c[109544+((d[109288+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};default:{o=68;break b}}b=b+2|0;continue b;break};case 17:{break b;break};case 10:case 9:case 21:{o=69;break b;break};case 11:{o=90;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=RJa(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 10:case 9:case 21:{break};case 24:case 22:{break d;break};case 7:{o=84;break d;break};case 5:{o=78;break d;break};case 17:{break c;break};case 6:{o=81;break d;break};case 29:{o=75;break d;break};case 11:{o=90;break c;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[109544+((d[109288+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=$Ja(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function XJa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=RJa(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function YJa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[111488+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}



function qu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0;e=i;f=b+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=b+360|0;k=_Pa(+h[g+7504>>3],-+h[g+9544>>3],a[c[j>>2]|0]|0)|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[g+7504>>3],-+h[g+10216>>3],a[(c[j>>2]|0)+1|0]|0)|0;g=b+416|0;m=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7616>>3],-+h[(c[g>>2]|0)+10784>>3],a[(c[j>>2]|0)+2|0]|0)|0;n=b+312|0;o=a[n]|0;p=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[j>>2]|0)+3|0]|0)|0;q=b+404|0;r=c[(c[q>>2]|0)+408>>2]|0;do{if((r|0)==0){if(!(k<<24>>24==0)){s=1.0;break}if((a[(c[b+408>>2]|0)+11|0]|0)==0|l<<24>>24==0){t=4}else{s=1.0}}else{t=4}}while(0);do{if((t|0)==4){if(!((r|0)!=1|m<<24>>24==0)){s=1.0;break}if(o<<24>>24==0){s=-1.0;break}s=p<<24>>24!=0?1.0:-1.0}}while(0);h[d>>3]=s;p=c[(c[c[f>>2]>>2]|0)+8>>2]|0;o=aQa(+h[p+7504>>3],+h[p+9544>>3],a[(c[j>>2]|0)+4|0]|0)|0;p=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=aQa(+h[p+7504>>3],+h[p+10216>>3],a[(c[j>>2]|0)+5|0]|0)|0;p=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7616>>3],+h[(c[g>>2]|0)+10784>>3],a[(c[j>>2]|0)+6|0]|0)|0;r=a[n]|0;l=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[j>>2]|0)+7|0]|0)|0;k=c[(c[q>>2]|0)+408>>2]|0;do{if((k|0)==0){if(!(o<<24>>24==0)){u=1.0;break}if((a[(c[b+408>>2]|0)+12|0]|0)==0|m<<24>>24==0){t=10}else{u=1.0}}else{t=10}}while(0);do{if((t|0)==10){if(!((k|0)!=-1|p<<24>>24==0)){u=1.0;break}if(r<<24>>24==0){u=-1.0;break}u=l<<24>>24!=0?1.0:-1.0}}while(0);h[d+8>>3]=u;l=(aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[j>>2]|0)+7|0]|0)|0)<<24>>24!=0;h[d+16>>3]=l?1.0:-1.0;l=(_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[j>>2]|0)+3|0]|0)|0)<<24>>24!=0;h[d+24>>3]=l?1.0:-1.0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;r=_Pa(+h[l+7912>>3],-+h[l+9624>>3],a[(c[j>>2]|0)+8|0]|0)|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;p=_Pa(+h[l+7912>>3],-+h[l+10072>>3],a[(c[j>>2]|0)+9|0]|0)|0;l=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8024>>3],-+h[(c[g>>2]|0)+10096>>3],a[(c[j>>2]|0)+10|0]|0)|0;k=a[n]|0;m=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[j>>2]|0)+11|0]|0)|0;o=c[(c[q>>2]|0)+412>>2]|0;do{if((o|0)==0){if(!(r<<24>>24==0)){v=1.0;break}if((a[(c[b+408>>2]|0)+14|0]|0)==0|p<<24>>24==0){t=16}else{v=1.0}}else{t=16}}while(0);do{if((t|0)==16){if(!((o|0)!=1|l<<24>>24==0)){v=1.0;break}if(k<<24>>24==0){v=-1.0;break}v=m<<24>>24!=0?1.0:-1.0}}while(0);h[d+32>>3]=v;m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;k=aQa(+h[m+7912>>3],+h[m+9624>>3],a[(c[j>>2]|0)+12|0]|0)|0;m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=aQa(+h[m+7912>>3],+h[m+10072>>3],a[(c[j>>2]|0)+13|0]|0)|0;m=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8024>>3],+h[(c[g>>2]|0)+10096>>3],a[(c[j>>2]|0)+14|0]|0)|0;o=a[n]|0;p=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[j>>2]|0)+15|0]|0)|0;r=c[(c[q>>2]|0)+412>>2]|0;do{if((r|0)==0){if(!(k<<24>>24==0)){w=1.0;break}if((a[(c[b+408>>2]|0)+15|0]|0)==0|l<<24>>24==0){t=22}else{w=1.0}}else{t=22}}while(0);do{if((t|0)==22){if(!((r|0)!=-1|m<<24>>24==0)){w=1.0;break}if(o<<24>>24==0){w=-1.0;break}w=p<<24>>24!=0?1.0:-1.0}}while(0);h[d+40>>3]=w;p=(aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[j>>2]|0)+15|0]|0)|0)<<24>>24!=0;h[d+48>>3]=p?1.0:-1.0;p=(_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[j>>2]|0)+11|0]|0)|0)<<24>>24!=0;h[d+56>>3]=p?1.0:-1.0;p=c[(c[c[f>>2]>>2]|0)+8>>2]|0;o=_Pa(+h[p+8320>>3],-+h[p+9704>>3],a[(c[j>>2]|0)+16|0]|0)|0;p=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=_Pa(+h[p+8320>>3],-+h[p+9928>>3],a[(c[j>>2]|0)+17|0]|0)|0;p=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8432>>3],-+h[(c[g>>2]|0)+9408>>3],a[(c[j>>2]|0)+18|0]|0)|0;r=a[n]|0;l=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[j>>2]|0)+19|0]|0)|0;k=c[(c[q>>2]|0)+416>>2]|0;do{if((k|0)==0){if(!(o<<24>>24==0)){x=1.0;break}if((a[(c[b+408>>2]|0)+17|0]|0)==0|m<<24>>24==0){t=28}else{x=1.0}}else{t=28}}while(0);do{if((t|0)==28){if(!((k|0)!=1|p<<24>>24==0)){x=1.0;break}if(r<<24>>24==0){x=-1.0;break}x=l<<24>>24!=0?1.0:-1.0}}while(0);h[d+64>>3]=x;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;r=aQa(+h[l+8320>>3],+h[l+9704>>3],a[(c[j>>2]|0)+20|0]|0)|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;p=aQa(+h[l+8320>>3],+h[l+9928>>3],a[(c[j>>2]|0)+21|0]|0)|0;l=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8432>>3],+h[(c[g>>2]|0)+9408>>3],a[(c[j>>2]|0)+22|0]|0)|0;k=a[n]|0;m=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[j>>2]|0)+23|0]|0)|0;o=c[(c[q>>2]|0)+416>>2]|0;do{if((o|0)==0){if(!(r<<24>>24==0)){y=1.0;break}if((a[(c[b+408>>2]|0)+18|0]|0)==0|p<<24>>24==0){t=34}else{y=1.0}}else{t=34}}while(0);do{if((t|0)==34){if(!((o|0)!=-1|l<<24>>24==0)){y=1.0;break}if(k<<24>>24==0){y=-1.0;break}y=m<<24>>24!=0?1.0:-1.0}}while(0);h[d+72>>3]=y;m=(aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[j>>2]|0)+23|0]|0)|0)<<24>>24!=0;h[d+80>>3]=m?1.0:-1.0;m=(_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[j>>2]|0)+19|0]|0)|0)<<24>>24!=0;h[d+88>>3]=m?1.0:-1.0;m=c[c[f>>2]>>2]|0;k=($Pa(+h[m>>3],+h[(c[m+8>>2]|0)+8992>>3],a[(c[j>>2]|0)+24|0]|0)|0)<<24>>24!=0;h[d+96>>3]=k?1.0:-1.0;k=(_Pa(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+8728>>3],a[(c[j>>2]|0)+25|0]|0)|0)<<24>>24!=0;h[d+104>>3]=k?1.0:-1.0;k=c[c[f>>2]>>2]|0;m=(_Pa(+h[k>>3],+h[(c[k+8>>2]|0)+9104>>3],a[(c[j>>2]|0)+26|0]|0)|0)<<24>>24!=0;h[d+112>>3]=m?1.0:-1.0;m=c[c[f>>2]>>2]|0;k=(_Pa(+h[m>>3],+h[(c[m+8>>2]|0)+8992>>3],a[(c[j>>2]|0)+27|0]|0)|0)<<24>>24!=0;h[d+120>>3]=k?1.0:-1.0;k=c[c[f>>2]>>2]|0;m=(_Pa(+h[k>>3],+h[(c[k+8>>2]|0)+9120>>3],a[(c[j>>2]|0)+28|0]|0)|0)<<24>>24!=0;h[d+128>>3]=m?1.0:-1.0;m=c[c[f>>2]>>2]|0;k=(_Pa(+h[m>>3],+h[(c[m+8>>2]|0)+9008>>3],a[(c[j>>2]|0)+29|0]|0)|0)<<24>>24!=0;h[d+136>>3]=k?1.0:-1.0;k=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=_Pa(+h[k+7112>>3],-+h[k+9464>>3],a[(c[j>>2]|0)+30|0]|0)|0;k=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[k+7112>>3],-+h[k+10360>>3],a[(c[j>>2]|0)+31|0]|0)|0;k=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7088>>3],-+h[(c[g>>2]|0)+11408>>3],a[(c[j>>2]|0)+32|0]|0)|0;o=a[n]|0;p=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[j>>2]|0)+33|0]|0)|0;r=c[(c[q>>2]|0)+404>>2]|0;do{if((r|0)==0){if(!(m<<24>>24==0)){z=1.0;break}if((a[(c[b+408>>2]|0)+8|0]|0)==0|l<<24>>24==0){t=40}else{z=1.0}}else{t=40}}while(0);do{if((t|0)==40){if(!((r|0)!=1|k<<24>>24==0)){z=1.0;break}if(o<<24>>24==0){z=-1.0;break}z=p<<24>>24!=0?1.0:-1.0}}while(0);h[d+144>>3]=z;p=c[(c[c[f>>2]>>2]|0)+8>>2]|0;o=_Pa(+h[p+6344>>3],-+h[p+9304>>3],a[(c[j>>2]|0)+34|0]|0)|0;p=c[(c[c[f>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[p+6344>>3],-+h[p+10648>>3],a[(c[j>>2]|0)+35|0]|0)|0;p=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3],-+h[(c[g>>2]|0)+12656>>3],a[(c[j>>2]|0)+36|0]|0)|0;r=a[n]|0;l=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[j>>2]|0)+37|0]|0)|0;m=c[(c[q>>2]|0)+396>>2]|0;do{if((m|0)==0){if(!(o<<24>>24==0)){A=1.0;break}if((a[(c[b+408>>2]|0)+2|0]|0)==0|k<<24>>24==0){t=46}else{A=1.0}}else{t=46}}while(0);do{if((t|0)==46){if(!((m|0)!=1|p<<24>>24==0)){A=1.0;break}if(r<<24>>24==0){A=-1.0;break}A=l<<24>>24!=0?1.0:-1.0}}while(0);h[d+152>>3]=A;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;r=aQa(+h[l+6344>>3],+h[l+9304>>3],a[(c[j>>2]|0)+38|0]|0)|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;p=aQa(+h[l+6344>>3],+h[l+10648>>3],a[(c[j>>2]|0)+39|0]|0)|0;l=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3],+h[(c[g>>2]|0)+12656>>3],a[(c[j>>2]|0)+40|0]|0)|0;m=a[n]|0;k=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[j>>2]|0)+41|0]|0)|0;o=c[(c[q>>2]|0)+396>>2]|0;do{if((o|0)==0){if(!(r<<24>>24==0)){B=1.0;break}if((a[(c[b+408>>2]|0)+3|0]|0)==0|p<<24>>24==0){t=52}else{B=1.0}}else{t=52}}while(0);do{if((t|0)==52){if(!((o|0)!=-1|l<<24>>24==0)){B=1.0;break}if(m<<24>>24==0){B=-1.0;break}B=k<<24>>24!=0?1.0:-1.0}}while(0);h[d+160>>3]=B;k=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=_Pa(+h[k+6728>>3],-+h[k+9384>>3],a[(c[j>>2]|0)+42|0]|0)|0;k=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[k+6728>>3],-+h[k+10504>>3],a[(c[j>>2]|0)+43|0]|0)|0;k=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6704>>3],-+h[(c[g>>2]|0)+12032>>3],a[(c[j>>2]|0)+44|0]|0)|0;o=a[n]|0;p=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[j>>2]|0)+45|0]|0)|0;r=c[(c[q>>2]|0)+400>>2]|0;do{if((r|0)==0){if(!(m<<24>>24==0)){C=1.0;break}if((a[(c[b+408>>2]|0)+5|0]|0)==0|l<<24>>24==0){t=58}else{C=1.0}}else{t=58}}while(0);do{if((t|0)==58){if(!((r|0)!=1|k<<24>>24==0)){C=1.0;break}if(o<<24>>24==0){C=-1.0;break}C=p<<24>>24!=0?1.0:-1.0}}while(0);h[d+168>>3]=C;p=c[(c[c[f>>2]>>2]|0)+8>>2]|0;o=aQa(+h[p+6728>>3],+h[p+9384>>3],a[(c[j>>2]|0)+46|0]|0)|0;p=c[(c[c[f>>2]>>2]|0)+8>>2]|0;k=aQa(+h[p+6728>>3],+h[p+10504>>3],a[(c[j>>2]|0)+47|0]|0)|0;p=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6704>>3],+h[(c[g>>2]|0)+12032>>3],a[(c[j>>2]|0)+48|0]|0)|0;r=a[n]|0;l=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[j>>2]|0)+49|0]|0)|0;m=c[(c[q>>2]|0)+400>>2]|0;do{if((m|0)==0){if(!(o<<24>>24==0)){D=1.0;break}if((a[(c[b+408>>2]|0)+6|0]|0)==0|k<<24>>24==0){t=64}else{D=1.0}}else{t=64}}while(0);do{if((t|0)==64){if(!((m|0)!=-1|p<<24>>24==0)){D=1.0;break}if(r<<24>>24==0){D=-1.0;break}D=l<<24>>24!=0?1.0:-1.0}}while(0);h[d+176>>3]=D;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;r=aQa(+h[l+7112>>3],+h[l+9464>>3],a[(c[j>>2]|0)+50|0]|0)|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;p=aQa(+h[l+7112>>3],+h[l+10360>>3],a[(c[j>>2]|0)+51|0]|0)|0;l=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7088>>3],+h[(c[g>>2]|0)+11408>>3],a[(c[j>>2]|0)+52|0]|0)|0;m=a[n]|0;n=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[j>>2]|0)+53|0]|0)|0;k=c[(c[q>>2]|0)+404>>2]|0;do{if((k|0)==0){if(!(r<<24>>24==0)){E=1.0;break}if((a[(c[b+408>>2]|0)+9|0]|0)==0|p<<24>>24==0){t=70}else{E=1.0}}else{t=70}}while(0);do{if((t|0)==70){if(!((k|0)!=-1|l<<24>>24==0)){E=1.0;break}if(m<<24>>24==0){E=-1.0;break}E=n<<24>>24!=0?1.0:-1.0}}while(0);h[d+184>>3]=E;n=(aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[j>>2]|0)+49|0]|0)|0)<<24>>24!=0;h[d+192>>3]=n?1.0:-1.0;n=(_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[j>>2]|0)+45|0]|0)|0)<<24>>24!=0;h[d+200>>3]=n?1.0:-1.0;n=(aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[j>>2]|0)+41|0]|0)|0)<<24>>24!=0;h[d+208>>3]=n?1.0:-1.0;n=(_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[j>>2]|0)+37|0]|0)|0)<<24>>24!=0;h[d+216>>3]=n?1.0:-1.0;n=(aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[j>>2]|0)+53|0]|0)|0)<<24>>24!=0;h[d+224>>3]=n?1.0:-1.0;n=(_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[j>>2]|0)+33|0]|0)|0)<<24>>24!=0;h[d+232>>3]=n?1.0:-1.0;n=c[c[f>>2]>>2]|0;f=(bQa(+h[n>>3],+h[(c[n+8>>2]|0)+8992>>3]+ +h[(c[g>>2]|0)+8720>>3],a[(c[j>>2]|0)+54|0]|0)|0)<<24>>24!=0;h[d+240>>3]=f?1.0:-1.0;i=e;return 0}function ru(a){a=a|0;i=i;return c[11992+(a<<2)>>2]|0}function su(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0;e=i;f=b+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+7504>>3];k=-+h[g+9544>>3];if((d|0)==0){d=b+352|0;a[c[d>>2]|0]=j<k|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+1|0]=+h[g+7504>>3]<-+h[g+10216>>3]|0;g=b+416|0;a[(c[d>>2]|0)+2|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7616>>3]<-+h[(c[g>>2]|0)+10784>>3]|0;a[(c[d>>2]|0)+3|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7616>>3]<0.0|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+4|0]=+h[l+7504>>3]>+h[l+9544>>3]|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+5|0]=+h[l+7504>>3]>+h[l+10216>>3]|0;a[(c[d>>2]|0)+6|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7616>>3]>+h[(c[g>>2]|0)+10784>>3]|0;a[(c[d>>2]|0)+7|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7616>>3]>0.0|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+8|0]=+h[l+7912>>3]<-+h[l+9624>>3]|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+9|0]=+h[l+7912>>3]<-+h[l+10072>>3]|0;a[(c[d>>2]|0)+10|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8024>>3]<-+h[(c[g>>2]|0)+10096>>3]|0;a[(c[d>>2]|0)+11|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8024>>3]<0.0|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+12|0]=+h[l+7912>>3]>+h[l+9624>>3]|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+13|0]=+h[l+7912>>3]>+h[l+10072>>3]|0;a[(c[d>>2]|0)+14|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8024>>3]>+h[(c[g>>2]|0)+10096>>3]|0;a[(c[d>>2]|0)+15|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8024>>3]>0.0|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+16|0]=+h[l+8320>>3]<-+h[l+9704>>3]|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+17|0]=+h[l+8320>>3]<-+h[l+9928>>3]|0;a[(c[d>>2]|0)+18|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8432>>3]<-+h[(c[g>>2]|0)+9408>>3]|0;a[(c[d>>2]|0)+19|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8432>>3]<0.0|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+20|0]=+h[l+8320>>3]>+h[l+9704>>3]|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+21|0]=+h[l+8320>>3]>+h[l+9928>>3]|0;a[(c[d>>2]|0)+22|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8432>>3]>+h[(c[g>>2]|0)+9408>>3]|0;a[(c[d>>2]|0)+23|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8432>>3]>0.0|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+24|0]=+h[l>>3]<=+h[(c[l+8>>2]|0)+8992>>3]|0;a[(c[d>>2]|0)+25|0]=+h[c[c[f>>2]>>2]>>3]<+h[(c[g>>2]|0)+8728>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+26|0]=+h[l>>3]<+h[(c[l+8>>2]|0)+9104>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+27|0]=+h[l>>3]<+h[(c[l+8>>2]|0)+8992>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+28|0]=+h[l>>3]<+h[(c[l+8>>2]|0)+9120>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+29|0]=+h[l>>3]<+h[(c[l+8>>2]|0)+9008>>3]|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+30|0]=+h[l+7112>>3]<-+h[l+9464>>3]|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+31|0]=+h[l+7112>>3]<-+h[l+10360>>3]|0;a[(c[d>>2]|0)+32|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7088>>3]<-+h[(c[g>>2]|0)+11408>>3]|0;a[(c[d>>2]|0)+33|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7088>>3]<0.0|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+34|0]=+h[l+6344>>3]<-+h[l+9304>>3]|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+35|0]=+h[l+6344>>3]<-+h[l+10648>>3]|0;a[(c[d>>2]|0)+36|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3]<-+h[(c[g>>2]|0)+12656>>3]|0;a[(c[d>>2]|0)+37|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3]<0.0|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+38|0]=+h[l+6344>>3]>+h[l+9304>>3]|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+39|0]=+h[l+6344>>3]>+h[l+10648>>3]|0;a[(c[d>>2]|0)+40|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3]>+h[(c[g>>2]|0)+12656>>3]|0;a[(c[d>>2]|0)+41|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3]>0.0|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+42|0]=+h[l+6728>>3]<-+h[l+9384>>3]|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+43|0]=+h[l+6728>>3]<-+h[l+10504>>3]|0;a[(c[d>>2]|0)+44|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6704>>3]<-+h[(c[g>>2]|0)+12032>>3]|0;a[(c[d>>2]|0)+45|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6704>>3]<0.0|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+46|0]=+h[l+6728>>3]>+h[l+9384>>3]|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+47|0]=+h[l+6728>>3]>+h[l+10504>>3]|0;a[(c[d>>2]|0)+48|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6704>>3]>+h[(c[g>>2]|0)+12032>>3]|0;a[(c[d>>2]|0)+49|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6704>>3]>0.0|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+50|0]=+h[l+7112>>3]>+h[l+9464>>3]|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+51|0]=+h[l+7112>>3]>+h[l+10360>>3]|0;a[(c[d>>2]|0)+52|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7088>>3]>+h[(c[g>>2]|0)+11408>>3]|0;a[(c[d>>2]|0)+53|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7088>>3]>0.0|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+54|0]=+h[l>>3]>=+h[(c[l+8>>2]|0)+8992>>3]+ +h[(c[g>>2]|0)+8720>>3]|0;i=e;return 0}else{g=b+360|0;l=_Pa(j,k,a[c[g>>2]|0]|0)|0;d=b+352|0;a[c[d>>2]|0]=l;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=_Pa(+h[l+7504>>3],-+h[l+10216>>3],a[(c[g>>2]|0)+1|0]|0)|0;a[(c[d>>2]|0)+1|0]=m;m=b+416|0;b=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7616>>3],-+h[(c[m>>2]|0)+10784>>3],a[(c[g>>2]|0)+2|0]|0)|0;a[(c[d>>2]|0)+2|0]=b;b=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[g>>2]|0)+3|0]|0)|0;a[(c[d>>2]|0)+3|0]=b;b=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=aQa(+h[b+7504>>3],+h[b+9544>>3],a[(c[g>>2]|0)+4|0]|0)|0;a[(c[d>>2]|0)+4|0]=l;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;b=aQa(+h[l+7504>>3],+h[l+10216>>3],a[(c[g>>2]|0)+5|0]|0)|0;a[(c[d>>2]|0)+5|0]=b;b=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7616>>3],+h[(c[m>>2]|0)+10784>>3],a[(c[g>>2]|0)+6|0]|0)|0;a[(c[d>>2]|0)+6|0]=b;b=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[g>>2]|0)+7|0]|0)|0;a[(c[d>>2]|0)+7|0]=b;b=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[b+7912>>3],-+h[b+9624>>3],a[(c[g>>2]|0)+8|0]|0)|0;a[(c[d>>2]|0)+8|0]=l;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;b=_Pa(+h[l+7912>>3],-+h[l+10072>>3],a[(c[g>>2]|0)+9|0]|0)|0;a[(c[d>>2]|0)+9|0]=b;b=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8024>>3],-+h[(c[m>>2]|0)+10096>>3],a[(c[g>>2]|0)+10|0]|0)|0;a[(c[d>>2]|0)+10|0]=b;b=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[g>>2]|0)+11|0]|0)|0;a[(c[d>>2]|0)+11|0]=b;b=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=aQa(+h[b+7912>>3],+h[b+9624>>3],a[(c[g>>2]|0)+12|0]|0)|0;a[(c[d>>2]|0)+12|0]=l;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;b=aQa(+h[l+7912>>3],+h[l+10072>>3],a[(c[g>>2]|0)+13|0]|0)|0;a[(c[d>>2]|0)+13|0]=b;b=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8024>>3],+h[(c[m>>2]|0)+10096>>3],a[(c[g>>2]|0)+14|0]|0)|0;a[(c[d>>2]|0)+14|0]=b;b=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[g>>2]|0)+15|0]|0)|0;a[(c[d>>2]|0)+15|0]=b;b=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[b+8320>>3],-+h[b+9704>>3],a[(c[g>>2]|0)+16|0]|0)|0;a[(c[d>>2]|0)+16|0]=l;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;b=_Pa(+h[l+8320>>3],-+h[l+9928>>3],a[(c[g>>2]|0)+17|0]|0)|0;a[(c[d>>2]|0)+17|0]=b;b=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8432>>3],-+h[(c[m>>2]|0)+9408>>3],a[(c[g>>2]|0)+18|0]|0)|0;a[(c[d>>2]|0)+18|0]=b;b=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[g>>2]|0)+19|0]|0)|0;a[(c[d>>2]|0)+19|0]=b;b=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=aQa(+h[b+8320>>3],+h[b+9704>>3],a[(c[g>>2]|0)+20|0]|0)|0;a[(c[d>>2]|0)+20|0]=l;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;b=aQa(+h[l+8320>>3],+h[l+9928>>3],a[(c[g>>2]|0)+21|0]|0)|0;a[(c[d>>2]|0)+21|0]=b;b=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8432>>3],+h[(c[m>>2]|0)+9408>>3],a[(c[g>>2]|0)+22|0]|0)|0;a[(c[d>>2]|0)+22|0]=b;b=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[g>>2]|0)+23|0]|0)|0;a[(c[d>>2]|0)+23|0]=b;b=c[c[f>>2]>>2]|0;l=$Pa(+h[b>>3],+h[(c[b+8>>2]|0)+8992>>3],a[(c[g>>2]|0)+24|0]|0)|0;a[(c[d>>2]|0)+24|0]=l;l=_Pa(+h[c[c[f>>2]>>2]>>3],+h[(c[m>>2]|0)+8728>>3],a[(c[g>>2]|0)+25|0]|0)|0;a[(c[d>>2]|0)+25|0]=l;l=c[c[f>>2]>>2]|0;b=_Pa(+h[l>>3],+h[(c[l+8>>2]|0)+9104>>3],a[(c[g>>2]|0)+26|0]|0)|0;a[(c[d>>2]|0)+26|0]=b;b=c[c[f>>2]>>2]|0;l=_Pa(+h[b>>3],+h[(c[b+8>>2]|0)+8992>>3],a[(c[g>>2]|0)+27|0]|0)|0;a[(c[d>>2]|0)+27|0]=l;l=c[c[f>>2]>>2]|0;b=_Pa(+h[l>>3],+h[(c[l+8>>2]|0)+9120>>3],a[(c[g>>2]|0)+28|0]|0)|0;a[(c[d>>2]|0)+28|0]=b;b=c[c[f>>2]>>2]|0;l=_Pa(+h[b>>3],+h[(c[b+8>>2]|0)+9008>>3],a[(c[g>>2]|0)+29|0]|0)|0;a[(c[d>>2]|0)+29|0]=l;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;b=_Pa(+h[l+7112>>3],-+h[l+9464>>3],a[(c[g>>2]|0)+30|0]|0)|0;a[(c[d>>2]|0)+30|0]=b;b=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[b+7112>>3],-+h[b+10360>>3],a[(c[g>>2]|0)+31|0]|0)|0;a[(c[d>>2]|0)+31|0]=l;l=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7088>>3],-+h[(c[m>>2]|0)+11408>>3],a[(c[g>>2]|0)+32|0]|0)|0;a[(c[d>>2]|0)+32|0]=l;l=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[g>>2]|0)+33|0]|0)|0;a[(c[d>>2]|0)+33|0]=l;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;b=_Pa(+h[l+6344>>3],-+h[l+9304>>3],a[(c[g>>2]|0)+34|0]|0)|0;a[(c[d>>2]|0)+34|0]=b;b=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[b+6344>>3],-+h[b+10648>>3],a[(c[g>>2]|0)+35|0]|0)|0;a[(c[d>>2]|0)+35|0]=l;l=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3],-+h[(c[m>>2]|0)+12656>>3],a[(c[g>>2]|0)+36|0]|0)|0;a[(c[d>>2]|0)+36|0]=l;l=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[g>>2]|0)+37|0]|0)|0;a[(c[d>>2]|0)+37|0]=l;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;b=aQa(+h[l+6344>>3],+h[l+9304>>3],a[(c[g>>2]|0)+38|0]|0)|0;a[(c[d>>2]|0)+38|0]=b;b=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=aQa(+h[b+6344>>3],+h[b+10648>>3],a[(c[g>>2]|0)+39|0]|0)|0;a[(c[d>>2]|0)+39|0]=l;l=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3],+h[(c[m>>2]|0)+12656>>3],a[(c[g>>2]|0)+40|0]|0)|0;a[(c[d>>2]|0)+40|0]=l;l=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[g>>2]|0)+41|0]|0)|0;a[(c[d>>2]|0)+41|0]=l;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;b=_Pa(+h[l+6728>>3],-+h[l+9384>>3],a[(c[g>>2]|0)+42|0]|0)|0;a[(c[d>>2]|0)+42|0]=b;b=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[b+6728>>3],-+h[b+10504>>3],a[(c[g>>2]|0)+43|0]|0)|0;a[(c[d>>2]|0)+43|0]=l;l=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6704>>3],-+h[(c[m>>2]|0)+12032>>3],a[(c[g>>2]|0)+44|0]|0)|0;a[(c[d>>2]|0)+44|0]=l;l=_Pa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[g>>2]|0)+45|0]|0)|0;a[(c[d>>2]|0)+45|0]=l;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;b=aQa(+h[l+6728>>3],+h[l+9384>>3],a[(c[g>>2]|0)+46|0]|0)|0;a[(c[d>>2]|0)+46|0]=b;b=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=aQa(+h[b+6728>>3],+h[b+10504>>3],a[(c[g>>2]|0)+47|0]|0)|0;a[(c[d>>2]|0)+47|0]=l;l=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6704>>3],+h[(c[m>>2]|0)+12032>>3],a[(c[g>>2]|0)+48|0]|0)|0;a[(c[d>>2]|0)+48|0]=l;l=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[g>>2]|0)+49|0]|0)|0;a[(c[d>>2]|0)+49|0]=l;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;b=aQa(+h[l+7112>>3],+h[l+9464>>3],a[(c[g>>2]|0)+50|0]|0)|0;a[(c[d>>2]|0)+50|0]=b;b=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=aQa(+h[b+7112>>3],+h[b+10360>>3],a[(c[g>>2]|0)+51|0]|0)|0;a[(c[d>>2]|0)+51|0]=l;l=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7088>>3],+h[(c[m>>2]|0)+11408>>3],a[(c[g>>2]|0)+52|0]|0)|0;a[(c[d>>2]|0)+52|0]=l;l=aQa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[g>>2]|0)+53|0]|0)|0;a[(c[d>>2]|0)+53|0]=l;l=c[c[f>>2]>>2]|0;f=bQa(+h[l>>3],+h[(c[l+8>>2]|0)+8992>>3]+ +h[(c[m>>2]|0)+8720>>3],a[(c[g>>2]|0)+54|0]|0)|0;a[(c[d>>2]|0)+54|0]=f;i=e;return 0}return 0}function tu(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;SMa(8,1,12216,G);G=b+4|0;H=c[c[G>>2]>>2]|0;I=c[H+16>>2]|0;J=a[I+20|0]|0;K=b+408|0;L=c[K>>2]|0;M=a[L+20|0]|0;if(J<<24>>24==M<<24>>24){N=L;O=I;P=H;Q=0}else{c[F>>2]=M<<24>>24;c[F+4>>2]=J<<24>>24;SMa(8,0,12248,F);F=c[c[G>>2]>>2]|0;N=c[K>>2]|0;O=c[F+16>>2]|0;P=F;Q=1}F=a[O]|0;J=a[N]|0;if(F<<24>>24==J<<24>>24){R=N;S=O;T=P;U=Q}else{c[E>>2]=J<<24>>24;c[E+4>>2]=F<<24>>24;SMa(8,0,12304,E);E=c[c[G>>2]>>2]|0;R=c[K>>2]|0;S=c[E+16>>2]|0;T=E;U=1}E=a[S+19|0]|0;F=a[R+19|0]|0;if(E<<24>>24==F<<24>>24){V=R;W=S;X=T;Y=U}else{c[D>>2]=F<<24>>24;c[D+4>>2]=E<<24>>24;SMa(8,0,12384,D);D=c[c[G>>2]>>2]|0;V=c[K>>2]|0;W=c[D+16>>2]|0;X=D;Y=1}D=a[W+18|0]|0;E=a[V+18|0]|0;if(D<<24>>24==E<<24>>24){Z=V;_=W;$=X;aa=Y}else{c[C>>2]=E<<24>>24;c[C+4>>2]=D<<24>>24;SMa(8,0,12472,C);C=c[c[G>>2]>>2]|0;Z=c[K>>2]|0;_=c[C+16>>2]|0;$=C;aa=1}C=a[_+17|0]|0;D=a[Z+17|0]|0;if(C<<24>>24==D<<24>>24){ba=Z;ca=_;da=$;ea=aa}else{c[B>>2]=D<<24>>24;c[B+4>>2]=C<<24>>24;SMa(8,0,12552,B);B=c[c[G>>2]>>2]|0;ba=c[K>>2]|0;ca=c[B+16>>2]|0;da=B;ea=1}B=a[ca+16|0]|0;ca=a[ba+16|0]|0;if(B<<24>>24==ca<<24>>24){fa=da;ga=ea}else{c[A>>2]=ca<<24>>24;c[A+4>>2]=B<<24>>24;SMa(8,0,12632,A);fa=c[c[G>>2]>>2]|0;ga=1}A=c[(c[fa+12>>2]|0)+416>>2]|0;B=b+404|0;b=c[(c[B>>2]|0)+416>>2]|0;if((A|0)==(b|0)){ha=fa;ia=ga}else{c[z>>2]=b;c[z+4>>2]=A;SMa(8,0,12712,z);ha=c[c[G>>2]>>2]|0;ia=1}z=c[ha+16>>2]|0;A=a[z+15|0]|0;b=c[K>>2]|0;ga=a[b+15|0]|0;if(A<<24>>24==ga<<24>>24){ja=b;ka=z;la=ha;ma=ia}else{c[y>>2]=ga<<24>>24;c[y+4>>2]=A<<24>>24;SMa(8,0,12792,y);y=c[c[G>>2]>>2]|0;ja=c[K>>2]|0;ka=c[y+16>>2]|0;la=y;ma=1}y=a[ka+14|0]|0;A=a[ja+14|0]|0;if(y<<24>>24==A<<24>>24){na=ja;oa=ka;pa=la;qa=ma}else{c[x>>2]=A<<24>>24;c[x+4>>2]=y<<24>>24;SMa(8,0,12872,x);x=c[c[G>>2]>>2]|0;na=c[K>>2]|0;oa=c[x+16>>2]|0;pa=x;qa=1}x=a[oa+13|0]|0;oa=a[na+13|0]|0;if(x<<24>>24==oa<<24>>24){ra=pa;sa=qa}else{c[w>>2]=oa<<24>>24;c[w+4>>2]=x<<24>>24;SMa(8,0,12952,w);ra=c[c[G>>2]>>2]|0;sa=1}w=c[(c[ra+12>>2]|0)+412>>2]|0;x=c[(c[B>>2]|0)+412>>2]|0;if((w|0)==(x|0)){ta=ra;ua=sa}else{c[v>>2]=x;c[v+4>>2]=w;SMa(8,0,13032,v);ta=c[c[G>>2]>>2]|0;ua=1}v=c[ta+16>>2]|0;w=a[v+12|0]|0;x=c[K>>2]|0;sa=a[x+12|0]|0;if(w<<24>>24==sa<<24>>24){va=x;wa=v;xa=ta;ya=ua}else{c[u>>2]=sa<<24>>24;c[u+4>>2]=w<<24>>24;SMa(8,0,13112,u);u=c[c[G>>2]>>2]|0;va=c[K>>2]|0;wa=c[u+16>>2]|0;xa=u;ya=1}u=a[wa+11|0]|0;w=a[va+11|0]|0;if(u<<24>>24==w<<24>>24){za=va;Aa=wa;Ba=xa;Ca=ya}else{c[t>>2]=w<<24>>24;c[t+4>>2]=u<<24>>24;SMa(8,0,13192,t);t=c[c[G>>2]>>2]|0;za=c[K>>2]|0;Aa=c[t+16>>2]|0;Ba=t;Ca=1}t=a[Aa+10|0]|0;Aa=a[za+10|0]|0;if(t<<24>>24==Aa<<24>>24){Da=Ba;Ea=Ca}else{c[s>>2]=Aa<<24>>24;c[s+4>>2]=t<<24>>24;SMa(8,0,13272,s);Da=c[c[G>>2]>>2]|0;Ea=1}s=c[(c[Da+12>>2]|0)+408>>2]|0;t=c[(c[B>>2]|0)+408>>2]|0;if((s|0)==(t|0)){Fa=Da;Ga=Ea}else{c[r>>2]=t;c[r+4>>2]=s;SMa(8,0,13352,r);Fa=c[c[G>>2]>>2]|0;Ga=1}r=c[Fa+16>>2]|0;s=a[r+9|0]|0;t=c[K>>2]|0;Ea=a[t+9|0]|0;if(s<<24>>24==Ea<<24>>24){Ha=t;Ia=r;Ja=Fa;Ka=Ga}else{c[q>>2]=Ea<<24>>24;c[q+4>>2]=s<<24>>24;SMa(8,0,13432,q);q=c[c[G>>2]>>2]|0;Ha=c[K>>2]|0;Ia=c[q+16>>2]|0;Ja=q;Ka=1}q=a[Ia+8|0]|0;s=a[Ha+8|0]|0;if(q<<24>>24==s<<24>>24){La=Ha;Ma=Ia;Na=Ja;Oa=Ka}else{c[p>>2]=s<<24>>24;c[p+4>>2]=q<<24>>24;SMa(8,0,13512,p);p=c[c[G>>2]>>2]|0;La=c[K>>2]|0;Ma=c[p+16>>2]|0;Na=p;Oa=1}p=a[Ma+7|0]|0;Ma=a[La+7|0]|0;if(p<<24>>24==Ma<<24>>24){Pa=Na;Qa=Oa}else{c[o>>2]=Ma<<24>>24;c[o+4>>2]=p<<24>>24;SMa(8,0,13592,o);Pa=c[c[G>>2]>>2]|0;Qa=1}o=c[(c[Pa+12>>2]|0)+404>>2]|0;p=c[(c[B>>2]|0)+404>>2]|0;if((o|0)==(p|0)){Ra=Pa;Sa=Qa}else{c[n>>2]=p;c[n+4>>2]=o;SMa(8,0,13672,n);Ra=c[c[G>>2]>>2]|0;Sa=1}n=c[Ra+16>>2]|0;o=a[n+6|0]|0;p=c[K>>2]|0;Qa=a[p+6|0]|0;if(o<<24>>24==Qa<<24>>24){Ta=p;Ua=n;Va=Ra;Wa=Sa}else{c[m>>2]=Qa<<24>>24;c[m+4>>2]=o<<24>>24;SMa(8,0,13752,m);m=c[c[G>>2]>>2]|0;Ta=c[K>>2]|0;Ua=c[m+16>>2]|0;Va=m;Wa=1}m=a[Ua+5|0]|0;o=a[Ta+5|0]|0;if(m<<24>>24==o<<24>>24){Xa=Ta;Ya=Ua;Za=Va;_a=Wa}else{c[l>>2]=o<<24>>24;c[l+4>>2]=m<<24>>24;SMa(8,0,13832,l);l=c[c[G>>2]>>2]|0;Xa=c[K>>2]|0;Ya=c[l+16>>2]|0;Za=l;_a=1}l=a[Ya+4|0]|0;Ya=a[Xa+4|0]|0;if(l<<24>>24==Ya<<24>>24){$a=Za;ab=_a}else{c[k>>2]=Ya<<24>>24;c[k+4>>2]=l<<24>>24;SMa(8,0,13912,k);$a=c[c[G>>2]>>2]|0;ab=1}k=c[(c[$a+12>>2]|0)+400>>2]|0;l=c[(c[B>>2]|0)+400>>2]|0;if((k|0)==(l|0)){bb=$a;cb=ab}else{c[j>>2]=l;c[j+4>>2]=k;SMa(8,0,13992,j);bb=c[c[G>>2]>>2]|0;cb=1}j=c[bb+16>>2]|0;k=a[j+3|0]|0;l=c[K>>2]|0;ab=a[l+3|0]|0;if(k<<24>>24==ab<<24>>24){db=l;eb=j;fb=bb;gb=cb}else{c[h>>2]=ab<<24>>24;c[h+4>>2]=k<<24>>24;SMa(8,0,14072,h);h=c[c[G>>2]>>2]|0;db=c[K>>2]|0;eb=c[h+16>>2]|0;fb=h;gb=1}h=a[eb+2|0]|0;k=a[db+2|0]|0;if(h<<24>>24==k<<24>>24){hb=db;ib=eb;jb=fb;kb=gb}else{c[g>>2]=k<<24>>24;c[g+4>>2]=h<<24>>24;SMa(8,0,14152,g);g=c[c[G>>2]>>2]|0;hb=c[K>>2]|0;ib=c[g+16>>2]|0;jb=g;kb=1}g=a[ib+1|0]|0;ib=a[hb+1|0]|0;if(g<<24>>24==ib<<24>>24){lb=jb;mb=kb}else{c[f>>2]=ib<<24>>24;c[f+4>>2]=g<<24>>24;SMa(8,0,14232,f);lb=c[c[G>>2]>>2]|0;mb=1}G=c[(c[lb+12>>2]|0)+396>>2]|0;lb=c[(c[B>>2]|0)+396>>2]|0;if((G|0)==(lb|0)){nb=mb}else{c[e>>2]=lb;c[e+4>>2]=G;SMa(8,0,14312,e);nb=1}if((c[118224>>2]|0)==0){i=d;return nb|0}fe[c[29686]&511](8);i=d;return nb|0}function uu(a){a=a|0;i=i;return c[16552+(a<<2)>>2]|0}function vu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+8|0;SMa(21,1,16696,R);R=a+4|0;a=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[a+8672>>3]- +h[a+8680>>3];h[b>>3]=S;a=uu(0)|0;c[Q>>2]=1;c[Q+4>>2]=a;a=Q+8|0;h[k>>3]=S;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];SMa(21,0,16728,Q);Q=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[Q+8808>>3]- +h[Q+8664>>3];h[b+8>>3]=S;Q=uu(1)|0;c[P>>2]=2;c[P+4>>2]=Q;Q=P+8|0;h[k>>3]=S;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];SMa(21,0,16728,P);P=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[P+8744>>3]- +h[P+8856>>3];h[b+16>>3]=S;P=uu(2)|0;c[O>>2]=3;c[O+4>>2]=P;P=O+8|0;h[k>>3]=S;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];SMa(21,0,16728,O);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+512>>3];h[b+24>>3]=S;O=uu(3)|0;c[N>>2]=4;c[N+4>>2]=O;O=N+8|0;h[k>>3]=S;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];SMa(21,0,16728,N);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+520>>3];h[b+32>>3]=S;N=uu(4)|0;c[M>>2]=5;c[M+4>>2]=N;N=M+8|0;h[k>>3]=S;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];SMa(21,0,16728,M);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+192>>3];h[b+40>>3]=S;M=uu(5)|0;c[L>>2]=6;c[L+4>>2]=M;M=L+8|0;h[k>>3]=S;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];SMa(21,0,16728,L);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+8288>>3];h[b+48>>3]=S;L=uu(6)|0;c[K>>2]=7;c[K+4>>2]=L;L=K+8|0;h[k>>3]=S;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];SMa(21,0,16728,K);K=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[K+8264>>3]- +h[K+8272>>3];h[b+56>>3]=S;K=uu(7)|0;c[J>>2]=8;c[J+4>>2]=K;K=J+8|0;h[k>>3]=S;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];SMa(21,0,16728,J);J=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[J+8800>>3]- +h[J+8256>>3];h[b+64>>3]=S;J=uu(8)|0;c[I>>2]=9;c[I+4>>2]=J;J=I+8|0;h[k>>3]=S;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];SMa(21,0,16728,I);I=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[I+8752>>3]- +h[I+8848>>3];h[b+72>>3]=S;I=uu(9)|0;c[H>>2]=10;c[H+4>>2]=I;I=H+8|0;h[k>>3]=S;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];SMa(21,0,16728,H);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+464>>3];h[b+80>>3]=S;H=uu(10)|0;c[G>>2]=11;c[G+4>>2]=H;H=G+8|0;h[k>>3]=S;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];SMa(21,0,16728,G);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+472>>3];h[b+88>>3]=S;G=uu(11)|0;c[F>>2]=12;c[F+4>>2]=G;G=F+8|0;h[k>>3]=S;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];SMa(21,0,16728,F);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+144>>3];h[b+96>>3]=S;F=uu(12)|0;c[E>>2]=13;c[E+4>>2]=F;F=E+8|0;h[k>>3]=S;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];SMa(21,0,16728,E);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+7880>>3];h[b+104>>3]=S;E=uu(13)|0;c[D>>2]=14;c[D+4>>2]=E;E=D+8|0;h[k>>3]=S;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];SMa(21,0,16728,D);D=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[D+7856>>3]- +h[D+7864>>3];h[b+112>>3]=S;D=uu(14)|0;c[C>>2]=15;c[C+4>>2]=D;D=C+8|0;h[k>>3]=S;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];SMa(21,0,16728,C);C=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[C+8792>>3]- +h[C+7848>>3];h[b+120>>3]=S;C=uu(15)|0;c[B>>2]=16;c[B+4>>2]=C;C=B+8|0;h[k>>3]=S;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];SMa(21,0,16728,B);B=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[B+8760>>3]- +h[B+8840>>3];h[b+128>>3]=S;B=uu(16)|0;c[A>>2]=17;c[A+4>>2]=B;B=A+8|0;h[k>>3]=S;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];SMa(21,0,16728,A);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+416>>3];h[b+136>>3]=S;A=uu(17)|0;c[z>>2]=18;c[z+4>>2]=A;A=z+8|0;h[k>>3]=S;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];SMa(21,0,16728,z);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+424>>3];h[b+144>>3]=S;z=uu(18)|0;c[y>>2]=19;c[y+4>>2]=z;z=y+8|0;h[k>>3]=S;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];SMa(21,0,16728,y);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+96>>3];h[b+152>>3]=S;y=uu(19)|0;c[x>>2]=20;c[x+4>>2]=y;y=x+8|0;h[k>>3]=S;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];SMa(21,0,16728,x);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+7472>>3];h[b+160>>3]=S;x=uu(20)|0;c[w>>2]=21;c[w+4>>2]=x;x=w+8|0;h[k>>3]=S;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];SMa(21,0,16728,w);w=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[w+7448>>3]- +h[w+7456>>3];h[b+168>>3]=S;w=uu(21)|0;c[v>>2]=22;c[v+4>>2]=w;w=v+8|0;h[k>>3]=S;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];SMa(21,0,16728,v);v=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[v+376>>3]- +h[v+7440>>3];h[b+176>>3]=S;v=uu(22)|0;c[u>>2]=23;c[u+4>>2]=v;v=u+8|0;h[k>>3]=S;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];SMa(21,0,16728,u);u=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[u+8768>>3]- +h[u+8832>>3];h[b+184>>3]=S;u=uu(23)|0;c[t>>2]=24;c[t+4>>2]=u;u=t+8|0;h[k>>3]=S;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];SMa(21,0,16728,t);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+360>>3];h[b+192>>3]=S;t=uu(24)|0;c[s>>2]=25;c[s+4>>2]=t;t=s+8|0;h[k>>3]=S;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];SMa(21,0,16728,s);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+368>>3];h[b+200>>3]=S;s=uu(25)|0;c[r>>2]=26;c[r+4>>2]=s;s=r+8|0;h[k>>3]=S;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];SMa(21,0,16728,r);r=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[r+7064>>3]- +h[r+7072>>3];h[b+208>>3]=S;r=uu(26)|0;c[q>>2]=27;c[q+4>>2]=r;r=q+8|0;h[k>>3]=S;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];SMa(21,0,16728,q);q=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[q+344>>3]- +h[q+7056>>3];h[b+216>>3]=S;q=uu(27)|0;c[p>>2]=28;c[p+4>>2]=q;q=p+8|0;h[k>>3]=S;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];SMa(21,0,16728,p);p=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[p+8776>>3]- +h[p+8824>>3];h[b+224>>3]=S;p=uu(28)|0;c[o>>2]=29;c[o+4>>2]=p;p=o+8|0;h[k>>3]=S;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];SMa(21,0,16728,o);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+328>>3];h[b+232>>3]=S;o=uu(29)|0;c[n>>2]=30;c[n+4>>2]=o;o=n+8|0;h[k>>3]=S;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];SMa(21,0,16728,n);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+336>>3];h[b+240>>3]=S;n=uu(30)|0;c[m>>2]=31;c[m+4>>2]=n;n=m+8|0;h[k>>3]=S;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];SMa(21,0,16728,m);m=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[m+6680>>3]- +h[m+6688>>3];h[b+248>>3]=S;m=uu(31)|0;c[l>>2]=32;c[l+4>>2]=m;m=l+8|0;h[k>>3]=S;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];SMa(21,0,16728,l);l=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[l+312>>3]- +h[l+6672>>3];h[b+256>>3]=S;l=uu(32)|0;c[j>>2]=33;c[j+4>>2]=l;l=j+8|0;h[k>>3]=S;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];SMa(21,0,16728,j);j=c[(c[c[R>>2]>>2]|0)+8>>2]|0;S=+h[j+8784>>3]- +h[j+8816>>3];h[b+264>>3]=S;j=uu(33)|0;c[g>>2]=34;c[g+4>>2]=j;j=g+8|0;h[k>>3]=S;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];SMa(21,0,16728,g);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+296>>3];h[b+272>>3]=S;g=uu(34)|0;c[f>>2]=35;c[f+4>>2]=g;g=f+8|0;h[k>>3]=S;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];SMa(21,0,16728,f);S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+304>>3];h[b+280>>3]=S;b=uu(35)|0;c[e>>2]=36;c[e+4>>2]=b;b=e+8|0;h[k>>3]=S;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];SMa(21,0,16728,e);if((c[118276>>2]|0)==0){i=d;return 0}fe[c[29686]&511](21);i=d;return 0}function wu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12640>>3]=+h[b+12128>>3];i=i;return}function xu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12664>>3]=+h[b+12640>>3];i=i;return}function yu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12632>>3]=+h[b+12120>>3];i=i;return}function zu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12624>>3]=+h[b+12112>>3];i=i;return}function Au(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6424>>3]=+h[b+12624>>3];i=i;return}function Bu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6440>>3]=+h[b+12624>>3]+ +h[b+12632>>3];i=i;return}function Cu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12616>>3]=+h[b+12104>>3];i=i;return}function Du(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12648>>3]=+h[b+12616>>3];i=i;return}function Eu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12528>>3]=+h[b+12104>>3];i=i;return}function Fu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12600>>3]=+h[b+12528>>3];i=i;return}function Gu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12608>>3]=+h[b+12528>>3];i=i;return}function Hu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12440>>3]=+h[b+12424>>3];i=i;return}function Iu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12408>>3]=+h[b+12392>>3];i=i;return}function Ju(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12376>>3]=+h[b+12360>>3];i=i;return}function Ku(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12344>>3]=+h[b+12328>>3];i=i;return}function Lu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12312>>3]=+h[b+12296>>3];i=i;return}function Mu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12280>>3]=+h[b+12264>>3];i=i;return}function Nu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12248>>3]=+h[b+12232>>3];i=i;return}function Ou(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12216>>3]=+h[b+12200>>3];i=i;return}function Pu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12168>>3]=+h[b+12088>>3];i=i;return}function Qu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12160>>3]=+h[b+12080>>3];i=i;return}function Ru(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+12160>>3]*+h[f+12168>>3]*2.0;if(g!=0.0){j=g;k=f;l=250.0/j;m=k;n=m+12488|0;o=n;h[o>>3]=l;i=d;return}p=+YMa(c[b+536>>2]|0,g,16752,16744,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=250.0/j;m=k;n=m+12488|0;o=n;h[o>>3]=l;i=d;return}function Su(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+12160>>3];j=+h[f+12168>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,16800,16792,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+12496>>3]=l*.004;i=d;return}function Tu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12152>>3]=+h[b+12072>>3];i=i;return}function Uu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12472>>3]=+h[b+12152>>3];i=i;return}function Vu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12144>>3]=+h[b+12096>>3];i=i;return}function Wu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12464>>3]=+h[b+12144>>3];i=i;return}function Xu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12064>>3]=+h[b+6712>>3];i=i;return}function Yu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12520>>3]=+h[b+12064>>3];i=i;return}function Zu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12576>>3]=+h[b+12520>>3];i=i;return}function _u(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12056>>3]=+h[b+6704>>3];i=i;return}function $u(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12512>>3]=+h[b+12056>>3];i=i;return}function av(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12568>>3]=+h[b+12512>>3];i=i;return}function bv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12048>>3]=+h[b+6696>>3];i=i;return}function cv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12504>>3]=+h[b+12048>>3];i=i;return}function dv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12560>>3]=+h[b+12504>>3];i=i;return}function ev(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12016>>3]=+h[b+11504>>3];i=i;return}function fv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12040>>3]=+h[b+12016>>3];i=i;return}function gv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12008>>3]=+h[b+11496>>3];i=i;return}function hv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12e3>>3]=+h[b+11488>>3];i=i;return}function iv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6392>>3]=+h[b+12e3>>3];i=i;return}function jv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6408>>3]=+h[b+12e3>>3]+ +h[b+12008>>3];i=i;return}function kv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11992>>3]=+h[b+11480>>3];i=i;return}function lv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+12024>>3]=+h[b+11992>>3];i=i;return}function mv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11904>>3]=+h[b+11480>>3];i=i;return}function nv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11976>>3]=+h[b+11904>>3];i=i;return}function ov(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11984>>3]=+h[b+11904>>3];i=i;return}function pv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11816>>3]=+h[b+11800>>3];i=i;return}function qv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11784>>3]=+h[b+11768>>3];i=i;return}function rv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11752>>3]=+h[b+11736>>3];i=i;return}function sv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11720>>3]=+h[b+11704>>3];i=i;return}function tv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11688>>3]=+h[b+11672>>3];i=i;return}function uv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11656>>3]=+h[b+11640>>3];i=i;return}function vv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11624>>3]=+h[b+11608>>3];i=i;return}function wv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11592>>3]=+h[b+11576>>3];i=i;return}function xv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11544>>3]=+h[b+11464>>3];i=i;return}function yv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11536>>3]=+h[b+11456>>3];i=i;return}function zv(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+11536>>3]*+h[f+11544>>3]*2.0;if(g!=0.0){j=g;k=f;l=250.0/j;m=k;n=m+11864|0;o=n;h[o>>3]=l;i=d;return}p=+YMa(c[b+536>>2]|0,g,16824,16816,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=250.0/j;m=k;n=m+11864|0;o=n;h[o>>3]=l;i=d;return}function Av(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+11536>>3];j=+h[f+11544>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,16872,16864,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+11872>>3]=l*.004;i=d;return}function Bv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11528>>3]=+h[b+11448>>3];i=i;return}function Cv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11848>>3]=+h[b+11528>>3];i=i;return}function Dv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11520>>3]=+h[b+11472>>3];i=i;return}function Ev(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11840>>3]=+h[b+11520>>3];i=i;return}function Fv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11440>>3]=+h[b+6688>>3];i=i;return}function Gv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11896>>3]=+h[b+11440>>3];i=i;return}function Hv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11952>>3]=+h[b+11896>>3];i=i;return}function Iv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11432>>3]=+h[b+6680>>3];i=i;return}function Jv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11888>>3]=+h[b+11432>>3];i=i;return}function Kv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11944>>3]=+h[b+11888>>3];i=i;return}function Lv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11424>>3]=+h[b+6672>>3];i=i;return}function Mv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11880>>3]=+h[b+11424>>3];i=i;return}function Nv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11936>>3]=+h[b+11880>>3];i=i;return}function Ov(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11392>>3]=+h[b+10880>>3];i=i;return}function Pv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11416>>3]=+h[b+11392>>3];i=i;return}function Qv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11384>>3]=+h[b+10872>>3];i=i;return}function Rv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11376>>3]=+h[b+10864>>3];i=i;return}function Sv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6360>>3]=+h[b+11376>>3];i=i;return}function Tv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6376>>3]=+h[b+11376>>3]+ +h[b+11384>>3];i=i;return}function Uv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11368>>3]=+h[b+10856>>3];i=i;return}function Vv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11400>>3]=+h[b+11368>>3];i=i;return}function Wv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11280>>3]=+h[b+10856>>3];i=i;return}function Xv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11352>>3]=+h[b+11280>>3];i=i;return}function Yv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11360>>3]=+h[b+11280>>3];i=i;return}function Zv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11192>>3]=+h[b+11176>>3];i=i;return}function _v(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11160>>3]=+h[b+11144>>3];i=i;return}function $v(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11128>>3]=+h[b+11112>>3];i=i;return}function aw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11096>>3]=+h[b+11080>>3];i=i;return}function bw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11064>>3]=+h[b+11048>>3];i=i;return}function cw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11032>>3]=+h[b+11016>>3];i=i;return}function dw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11e3>>3]=+h[b+10984>>3];i=i;return}function ew(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10968>>3]=+h[b+10952>>3];i=i;return}function fw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10920>>3]=+h[b+10840>>3];i=i;return}function gw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10912>>3]=+h[b+10832>>3];i=i;return}function hw(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+10912>>3]*+h[f+10920>>3]*2.0;if(g!=0.0){j=g;k=f;l=250.0/j;m=k;n=m+11240|0;o=n;h[o>>3]=l;i=d;return}p=+YMa(c[b+536>>2]|0,g,16896,16888,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=250.0/j;m=k;n=m+11240|0;o=n;h[o>>3]=l;i=d;return}function iw(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+10912>>3];j=+h[f+10920>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,16944,16936,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+11248>>3]=l*.004;i=d;return}function jw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10904>>3]=+h[b+10824>>3];i=i;return}function kw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11224>>3]=+h[b+10904>>3];i=i;return}function lw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10896>>3]=+h[b+10848>>3];i=i;return}function mw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11216>>3]=+h[b+10896>>3];i=i;return}function nw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10816>>3]=+h[b+6664>>3];i=i;return}function ow(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11272>>3]=+h[b+10816>>3];i=i;return}function pw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11328>>3]=+h[b+11272>>3];i=i;return}function qw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10808>>3]=+h[b+6656>>3];i=i;return}function rw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11264>>3]=+h[b+10808>>3];i=i;return}function sw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11320>>3]=+h[b+11264>>3];i=i;return}function tw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10800>>3]=+h[b+6648>>3];i=i;return}function uw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11256>>3]=+h[b+10800>>3];i=i;return}function vw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11312>>3]=+h[b+11256>>3];i=i;return}function ww(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10728>>3]=+h[b+10184>>3];i=i;return}function xw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10720>>3]=+h[b+10176>>3];i=i;return}function yw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6328>>3]=+h[b+10720>>3];i=i;return}function zw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6344>>3]=+h[b+10720>>3]+ +h[b+10728>>3];i=i;return}function Aw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10712>>3]=+h[b+10216>>3];i=i;return}function Bw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10768>>3]=+h[b+10712>>3];i=i;return}function Cw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10704>>3]=+h[b+10208>>3];i=i;return}function Dw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10760>>3]=+h[b+10704>>3];i=i;return}function Ew(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10696>>3]=+h[b+10168>>3];i=i;return}function Fw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10744>>3]=+h[b+10696>>3];i=i;return}function Gw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10608>>3]=+h[b+10168>>3];i=i;return}function Hw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10680>>3]=+h[b+10608>>3];i=i;return}function Iw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10688>>3]=+h[b+10608>>3];i=i;return}function Jw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10520>>3]=+h[b+10504>>3];i=i;return}function Kw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10488>>3]=+h[b+10472>>3];i=i;return}function Lw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10456>>3]=+h[b+10440>>3];i=i;return}function Mw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10424>>3]=+h[b+10408>>3];i=i;return}function Nw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10392>>3]=+h[b+10376>>3];i=i;return}function Ow(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10360>>3]=+h[b+10344>>3];i=i;return}function Pw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10328>>3]=+h[b+10312>>3];i=i;return}function Qw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10296>>3]=+h[b+10280>>3];i=i;return}function Rw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10248>>3]=+h[b+10152>>3];i=i;return}function Sw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10240>>3]=+h[b+10144>>3];i=i;return}function Tw(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+10240>>3]*+h[f+10248>>3]*2.0;if(g!=0.0){j=g;k=f;l=250.0/j;m=k;n=m+10568|0;o=n;h[o>>3]=l;i=d;return}p=+YMa(c[b+536>>2]|0,g,16968,16960,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=250.0/j;m=k;n=m+10568|0;o=n;h[o>>3]=l;i=d;return}function Uw(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+10240>>3];j=+h[f+10248>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,17016,17008,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+10576>>3]=l*.004;i=d;return}function Vw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10232>>3]=+h[b+10136>>3];i=i;return}function Ww(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10552>>3]=+h[b+10232>>3];i=i;return}function Xw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10224>>3]=+h[b+10160>>3];i=i;return}function Yw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10544>>3]=+h[b+10224>>3];i=i;return}function Zw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10128>>3]=+h[b+6640>>3];i=i;return}function _w(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10600>>3]=+h[b+10128>>3];i=i;return}function $w(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10656>>3]=+h[b+10600>>3];i=i;return}function ax(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10120>>3]=+h[b+6632>>3];i=i;return}function bx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10592>>3]=+h[b+10120>>3];i=i;return}function cx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10648>>3]=+h[b+10592>>3];i=i;return}function dx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10112>>3]=+h[b+6624>>3];i=i;return}function ex(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10584>>3]=+h[b+10112>>3];i=i;return}function fx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10640>>3]=+h[b+10584>>3];i=i;return}function gx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10040>>3]=+h[b+9496>>3];i=i;return}function hx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10032>>3]=+h[b+9488>>3];i=i;return}function ix(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6296>>3]=+h[b+10032>>3];i=i;return}function jx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6312>>3]=+h[b+10032>>3]+ +h[b+10040>>3];i=i;return}function kx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10024>>3]=+h[b+9528>>3];i=i;return}function lx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10080>>3]=+h[b+10024>>3];i=i;return}function mx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10016>>3]=+h[b+9520>>3];i=i;return}function nx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10072>>3]=+h[b+10016>>3];i=i;return}function ox(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10008>>3]=+h[b+9480>>3];i=i;return}function px(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10056>>3]=+h[b+10008>>3];i=i;return}function qx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9920>>3]=+h[b+9480>>3];i=i;return}function rx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9992>>3]=+h[b+9920>>3];i=i;return}function sx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1e4>>3]=+h[b+9920>>3];i=i;return}function tx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9832>>3]=+h[b+9816>>3];i=i;return}function ux(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9800>>3]=+h[b+9784>>3];i=i;return}function vx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9768>>3]=+h[b+9752>>3];i=i;return}function wx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9736>>3]=+h[b+9720>>3];i=i;return}function xx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9704>>3]=+h[b+9688>>3];i=i;return}function yx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9672>>3]=+h[b+9656>>3];i=i;return}function zx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9640>>3]=+h[b+9624>>3];i=i;return}function Ax(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9608>>3]=+h[b+9592>>3];i=i;return}function Bx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9560>>3]=+h[b+9464>>3];i=i;return}function Cx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9552>>3]=+h[b+9456>>3];i=i;return}function Dx(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+9552>>3]*+h[f+9560>>3]*2.0;if(g!=0.0){j=g;k=f;l=250.0/j;m=k;n=m+9880|0;o=n;h[o>>3]=l;i=d;return}p=+YMa(c[b+536>>2]|0,g,17040,17032,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=250.0/j;m=k;n=m+9880|0;o=n;h[o>>3]=l;i=d;return}function Ex(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+9552>>3];j=+h[f+9560>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,17088,17080,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+9888>>3]=l*.004;i=d;return}function Fx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9544>>3]=+h[b+9448>>3];i=i;return}function Gx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9864>>3]=+h[b+9544>>3];i=i;return}function Hx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9536>>3]=+h[b+9472>>3];i=i;return}function Ix(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9856>>3]=+h[b+9536>>3];i=i;return}function Jx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9440>>3]=+h[b+6616>>3];i=i;return}function Kx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9912>>3]=+h[b+9440>>3];i=i;return}function Lx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9968>>3]=+h[b+9912>>3];i=i;return}function Mx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9432>>3]=+h[b+6608>>3];i=i;return}function Nx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9904>>3]=+h[b+9432>>3];i=i;return}function Ox(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9960>>3]=+h[b+9904>>3];i=i;return}function Px(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9424>>3]=+h[b+6600>>3];i=i;return}function Qx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9896>>3]=+h[b+9424>>3];i=i;return}function Rx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9952>>3]=+h[b+9896>>3];i=i;return}function Sx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9352>>3]=+h[b+8808>>3];i=i;return}function Tx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9344>>3]=+h[b+8800>>3];i=i;return}function Ux(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6264>>3]=+h[b+9344>>3];i=i;return}function Vx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6280>>3]=+h[b+9344>>3]+ +h[b+9352>>3];i=i;return}function Wx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9336>>3]=+h[b+8840>>3];i=i;return}function Xx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9392>>3]=+h[b+9336>>3];i=i;return}function Yx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9328>>3]=+h[b+8832>>3];i=i;return}function Zx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9384>>3]=+h[b+9328>>3];i=i;return}function _x(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9320>>3]=+h[b+8792>>3];i=i;return}function $x(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9368>>3]=+h[b+9320>>3];i=i;return}function ay(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9232>>3]=+h[b+8792>>3];i=i;return}function by(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9304>>3]=+h[b+9232>>3];i=i;return}function cy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9312>>3]=+h[b+9232>>3];i=i;return}function dy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9144>>3]=+h[b+9128>>3];i=i;return}function ey(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9112>>3]=+h[b+9096>>3];i=i;return}function fy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9080>>3]=+h[b+9064>>3];i=i;return}function gy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9048>>3]=+h[b+9032>>3];i=i;return}function hy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9016>>3]=+h[b+9e3>>3];i=i;return}function iy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8984>>3]=+h[b+8968>>3];i=i;return}function jy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8952>>3]=+h[b+8936>>3];i=i;return}function ky(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8920>>3]=+h[b+8904>>3];i=i;return}function ly(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8872>>3]=+h[b+8776>>3];i=i;return}function my(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8864>>3]=+h[b+8768>>3];i=i;return}function ny(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+8864>>3]*+h[f+8872>>3]*2.0;if(g!=0.0){j=g;k=f;l=250.0/j;m=k;n=m+9192|0;o=n;h[o>>3]=l;i=d;return}p=+YMa(c[b+536>>2]|0,g,17112,17104,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=250.0/j;m=k;n=m+9192|0;o=n;h[o>>3]=l;i=d;return}function oy(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+8864>>3];j=+h[f+8872>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,17160,17152,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+9200>>3]=l*.004;i=d;return}function py(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8856>>3]=+h[b+8760>>3];i=i;return}function qy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9176>>3]=+h[b+8856>>3];i=i;return}function ry(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8848>>3]=+h[b+8784>>3];i=i;return}function sy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9168>>3]=+h[b+8848>>3];i=i;return}function ty(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8752>>3]=+h[b+6592>>3];i=i;return}function uy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9224>>3]=+h[b+8752>>3];i=i;return}function vy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9280>>3]=+h[b+9224>>3];i=i;return}function wy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8744>>3]=+h[b+6584>>3];i=i;return}function xy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9216>>3]=+h[b+8744>>3];i=i;return}function yy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9272>>3]=+h[b+9216>>3];i=i;return}function zy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8736>>3]=+h[b+6576>>3];i=i;return}function Ay(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9208>>3]=+h[b+8736>>3];i=i;return}function By(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9264>>3]=+h[b+9208>>3];i=i;return}function Cy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5720>>3]=+h[b+112>>3];i=i;return}function Dy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6008>>3]=+h[b+5720>>3];i=i;return}function Ey(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6200>>3]=+h[b+6008>>3];i=i;return}function Fy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5712>>3]=+h[b+104>>3];i=i;return}function Gy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6e3>>3]=+h[b+5712>>3];i=i;return}function Hy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6192>>3]=+h[b+6e3>>3];i=i;return}function Iy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5704>>3]=+h[b+96>>3];i=i;return}function Jy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5992>>3]=+h[b+5704>>3];i=i;return}function Ky(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6184>>3]=+h[b+5992>>3];i=i;return}function Ly(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5696>>3]=+h[b+88>>3];i=i;return}function My(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5984>>3]=+h[b+5696>>3];i=i;return}function Ny(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6176>>3]=+h[b+5984>>3];i=i;return}function Oy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5688>>3]=+h[b+80>>3];i=i;return}function Py(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5976>>3]=+h[b+5688>>3];i=i;return}function Qy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6168>>3]=+h[b+5976>>3];i=i;return}function Ry(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5680>>3]=+h[b+72>>3];i=i;return}function Sy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5968>>3]=+h[b+5680>>3];i=i;return}function Ty(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6160>>3]=+h[b+5968>>3];i=i;return}function Uy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5672>>3]=+h[b+64>>3];i=i;return}function Vy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5960>>3]=+h[b+5672>>3];i=i;return}function Wy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6152>>3]=+h[b+5960>>3];i=i;return}function Xy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5664>>3]=+h[b+56>>3];i=i;return}function Yy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5952>>3]=+h[b+5664>>3];i=i;return}function Zy(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6144>>3]=+h[b+5952>>3];i=i;return}function _y(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5656>>3]=+h[b+48>>3];i=i;return}function $y(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5944>>3]=+h[b+5656>>3];i=i;return}function az(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6136>>3]=+h[b+5944>>3];i=i;return}function bz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5648>>3]=+h[b+40>>3];i=i;return}function cz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5936>>3]=+h[b+5648>>3];i=i;return}function dz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6128>>3]=+h[b+5936>>3];i=i;return}function ez(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5640>>3]=+h[b+32>>3];i=i;return}function fz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5928>>3]=+h[b+5640>>3];i=i;return}function gz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6120>>3]=+h[b+5928>>3];i=i;return}function hz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5632>>3]=+h[b+24>>3];i=i;return}function iz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5920>>3]=+h[b+5632>>3];i=i;return}function jz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6112>>3]=+h[b+5920>>3];i=i;return}function kz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8720>>3]=+h[b+6472>>3];i=i;return}function lz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8712>>3]=+h[b+6464>>3];i=i;return}function mz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8728>>3]=+h[b+8712>>3];i=i;return}function nz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8704>>3]=+h[b+8688>>3]*2.0;i=i;return}function oz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5088>>3]=+h[b+4920>>3];i=i;return}function pz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5080>>3]=+h[b+4912>>3];i=i;return}function qz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5072>>3]=+h[b+4904>>3];i=i;return}function rz(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+5072>>3]- +h[b+5096>>3];e=+h[b+5080>>3]- +h[b+5104>>3];f=+h[b+5088>>3]- +h[b+5112>>3];h[b+8584>>3]=+V(+(d*d+e*e+f*f));i=i;return}function sz(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+8584>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,17184,17176,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+8592>>3]=l;i=d;return}function tz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8600>>3]=+h[b+8592>>3];i=i;return}function uz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8416>>3]=+h[b+8312>>3];i=i;return}function vz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4576>>3]=+h[b+4312>>3];i=i;return}function wz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4568>>3]=+h[b+4304>>3];i=i;return}function xz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4560>>3]=+h[b+4296>>3];i=i;return}function yz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4456>>3]=+h[b+4288>>3];i=i;return}function zz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4448>>3]=+h[b+4280>>3];i=i;return}function Az(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4440>>3]=+h[b+4272>>3];i=i;return}function Bz(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+4440>>3]- +h[b+4464>>3];e=+h[b+4448>>3]- +h[b+4472>>3];f=+h[b+4456>>3]- +h[b+4480>>3];h[b+8384>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Cz(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+8384>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,17184,17224,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+8392>>3]=l;i=d;return}function Dz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8400>>3]=+h[b+8392>>3];i=i;return}function Ez(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8216>>3]=+h[b+8112>>3];i=i;return}function Fz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3944>>3]=+h[b+3680>>3];i=i;return}function Gz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3936>>3]=+h[b+3672>>3];i=i;return}function Hz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3928>>3]=+h[b+3664>>3];i=i;return}function Iz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3824>>3]=+h[b+3656>>3];i=i;return}function Jz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3816>>3]=+h[b+3648>>3];i=i;return}function Kz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3808>>3]=+h[b+3640>>3];i=i;return}function Lz(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+3808>>3]- +h[b+3832>>3];e=+h[b+3816>>3]- +h[b+3840>>3];f=+h[b+3824>>3]- +h[b+3848>>3];h[b+8184>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Mz(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+8184>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,17184,17232,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+8192>>3]=l;i=d;return}function Nz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8200>>3]=+h[b+8192>>3];i=i;return}function Oz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8016>>3]=+h[b+7912>>3];i=i;return}function Pz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3312>>3]=+h[b+3048>>3];i=i;return}function Qz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3304>>3]=+h[b+3040>>3];i=i;return}function Rz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3296>>3]=+h[b+3032>>3];i=i;return}function Sz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3192>>3]=+h[b+3024>>3];i=i;return}function Tz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3184>>3]=+h[b+3016>>3];i=i;return}function Uz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3176>>3]=+h[b+3008>>3];i=i;return}function Vz(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+3176>>3]- +h[b+3200>>3];e=+h[b+3184>>3]- +h[b+3208>>3];f=+h[b+3192>>3]- +h[b+3216>>3];h[b+7984>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Wz(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+7984>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,17184,17240,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+7992>>3]=l;i=d;return}function Xz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8e3>>3]=+h[b+7992>>3];i=i;return}function Yz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7816>>3]=+h[b+7712>>3];i=i;return}function Zz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2680>>3]=+h[b+2416>>3];i=i;return}function _z(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2672>>3]=+h[b+2408>>3];i=i;return}function $z(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2664>>3]=+h[b+2400>>3];i=i;return}function aA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2560>>3]=+h[b+2392>>3];i=i;return}function bA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2552>>3]=+h[b+2384>>3];i=i;return}function cA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2544>>3]=+h[b+2376>>3];i=i;return}function dA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+2544>>3]- +h[b+2568>>3];e=+h[b+2552>>3]- +h[b+2576>>3];f=+h[b+2560>>3]- +h[b+2584>>3];h[b+7784>>3]=+V(+(d*d+e*e+f*f));i=i;return}function eA(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+7784>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,17184,17248,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+7792>>3]=l;i=d;return}function fA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7800>>3]=+h[b+7792>>3];i=i;return}function gA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7616>>3]=+h[b+7512>>3];i=i;return}function hA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2048>>3]=+h[b+1784>>3];i=i;return}function iA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2040>>3]=+h[b+1776>>3];i=i;return}function jA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2032>>3]=+h[b+1768>>3];i=i;return}function kA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1928>>3]=+h[b+1760>>3];i=i;return}function lA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1920>>3]=+h[b+1752>>3];i=i;return}function mA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1912>>3]=+h[b+1744>>3];i=i;return}function nA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+1912>>3]- +h[b+1936>>3];e=+h[b+1920>>3]- +h[b+1944>>3];f=+h[b+1928>>3]- +h[b+1952>>3];h[b+7584>>3]=+V(+(d*d+e*e+f*f));i=i;return}function oA(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+7584>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,17184,17256,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+7592>>3]=l;i=d;return}function pA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7600>>3]=+h[b+7592>>3];i=i;return}function qA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7416>>3]=+h[b+7312>>3];i=i;return}function rA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1416>>3]=+h[b+1152>>3];i=i;return}function sA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1408>>3]=+h[b+1144>>3];i=i;return}function tA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1400>>3]=+h[b+1136>>3];i=i;return}function uA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1296>>3]=+h[b+1128>>3];i=i;return}function vA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1288>>3]=+h[b+1120>>3];i=i;return}function wA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1280>>3]=+h[b+1112>>3];i=i;return}function xA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+1280>>3]- +h[b+1304>>3];e=+h[b+1288>>3]- +h[b+1312>>3];f=+h[b+1296>>3]- +h[b+1320>>3];h[b+7384>>3]=+V(+(d*d+e*e+f*f));i=i;return}function yA(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+7384>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,17184,17264,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+7392>>3]=l;i=d;return}function zA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7400>>3]=+h[b+7392>>3];i=i;return}function AA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7216>>3]=+h[b+7112>>3];i=i;return}function BA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+784>>3]=+h[b+520>>3];i=i;return}function CA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+768>>3]=+h[b+504>>3];i=i;return}function DA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+664>>3]=+h[b+496>>3];i=i;return}function EA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+656>>3]=+h[b+488>>3];i=i;return}function FA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+648>>3]=+h[b+480>>3];i=i;return}function GA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+648>>3]- +h[b+672>>3];e=+h[b+656>>3]- +h[b+680>>3];f=+h[b+664>>3]- +h[b+688>>3];h[b+7184>>3]=+V(+(d*d+e*e+f*f));i=i;return}function HA(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+7184>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,17184,17272,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+7192>>3]=l;i=d;return}function IA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7200>>3]=+h[b+7192>>3];i=i;return}function JA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6960>>3]=+h[b+6456>>3];i=i;return}function KA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+184>>3]=+h[b+16>>3];i=i;return}function LA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4944>>3]=+h[b+184>>3];i=i;return}function MA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5208>>3]=+h[b+4944>>3];i=i;return}function NA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+176>>3]=+h[b+8>>3];i=i;return}function OA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4936>>3]=+h[b+176>>3];i=i;return}function PA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5200>>3]=+h[b+4936>>3];i=i;return}function QA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+168>>3]=+h[b>>3];i=i;return}function RA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4928>>3]=+h[b+168>>3];i=i;return}function SA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5192>>3]=+h[b+4928>>3];i=i;return}function TA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+168>>3];e=+h[b+176>>3];f=+h[b+184>>3];h[b+8608>>3]=+V(+(d*d+e*e+f*f));i=i;return}function UA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6952>>3]=+h[b+6448>>3];i=i;return}function VA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8512>>3]=+h[b+6952>>3];i=i;return}function WA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8616>>3]=+h[b+8512>>3];i=i;return}function XA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6720>>3]=+h[b+6960>>3];i=i;return}function YA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+8|0;r=a+416|0;RNa(+h[(c[r>>2]|0)+6416>>3],2,k);RNa(+h[(c[r>>2]|0)+6424>>3],2,l);RNa(+h[(c[r>>2]|0)+6432>>3],2,n);RNa(+h[(c[r>>2]|0)+6440>>3],2,o);c[g>>2]=l;QNa(2,j,2,k,g);c[f>>2]=o;QNa(2,m,2,n,f);c[e>>2]=m;QNa(1,p,2,j,e);e=c[a+536>>2]|0;j=d;m=p;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];Bp(q,e,0.0,d,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10648>>3]=+h[q>>3];i=b;return}function ZA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+8|0;r=a+416|0;RNa(+h[(c[r>>2]|0)+6384>>3],2,k);RNa(+h[(c[r>>2]|0)+6392>>3],2,l);RNa(+h[(c[r>>2]|0)+6400>>3],2,n);RNa(+h[(c[r>>2]|0)+6408>>3],2,o);c[g>>2]=l;QNa(2,j,2,k,g);c[f>>2]=o;QNa(2,m,2,n,f);c[e>>2]=m;QNa(1,p,2,j,e);e=c[a+536>>2]|0;j=d;m=p;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];Bp(q,e,0.0,d,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10504>>3]=+h[q>>3];i=b;return}function _A(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+8|0;r=a+416|0;RNa(+h[(c[r>>2]|0)+6352>>3],2,k);RNa(+h[(c[r>>2]|0)+6360>>3],2,l);RNa(+h[(c[r>>2]|0)+6368>>3],2,n);RNa(+h[(c[r>>2]|0)+6376>>3],2,o);c[g>>2]=l;QNa(2,j,2,k,g);c[f>>2]=o;QNa(2,m,2,n,f);c[e>>2]=m;QNa(1,p,2,j,e);e=c[a+536>>2]|0;j=d;m=p;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];Bp(q,e,0.0,d,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10360>>3]=+h[q>>3];i=b;return}function $A(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+8|0;r=a+416|0;RNa(+h[(c[r>>2]|0)+6320>>3],2,k);RNa(+h[(c[r>>2]|0)+6328>>3],2,l);RNa(+h[(c[r>>2]|0)+6336>>3],2,n);RNa(+h[(c[r>>2]|0)+6344>>3],2,o);c[g>>2]=l;QNa(2,j,2,k,g);c[f>>2]=o;QNa(2,m,2,n,f);c[e>>2]=m;QNa(1,p,2,j,e);e=c[a+536>>2]|0;j=d;m=p;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];Bp(q,e,0.0,d,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10216>>3]=+h[q>>3];i=b;return}



function qfb(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;re[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}ce[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function rfb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;re[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;ce[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;ce[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;ce[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;ce[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function sfb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;ce[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;re[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function tfb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function ufb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;re[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;re[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function vfb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;re[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function wfb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function xfb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[52084]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=208376+(j<<2)|0;l=208376+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[52084]=f&~(1<<h)}else{if(n>>>0<(c[208352>>2]|0)>>>0){hd()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{hd()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[208344>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=208376+(r<<2)|0;o=208376+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[52084]=f&~(1<<t)}else{if(n>>>0<(c[208352>>2]|0)>>>0){hd()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{hd()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[208344>>2]|0;if((n|0)!=0){f=c[208356>>2]|0;e=n>>>3;n=e<<1;g=208376+(n<<2)|0;m=c[52084]|0;j=1<<e;do{if((m&j|0)==0){c[52084]=m|j;u=208376+(n+2<<2)|0;v=g}else{e=208376+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[208352>>2]|0)>>>0)){u=e;v=h;break}hd()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[208344>>2]=o;c[208356>>2]=s;p=k;i=b;return p|0}n=c[208340>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[208640+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[208352>>2]|0;if(h>>>0<k>>>0){hd()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){hd()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){hd()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){hd()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){hd()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{hd()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=208640+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[208340>>2]=c[208340>>2]&~(1<<h);break a}else{if(s>>>0<(c[208352>>2]|0)>>>0){hd()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[208352>>2]|0)>>>0){hd()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[208344>>2]|0;if((h|0)!=0){s=c[208356>>2]|0;k=h>>>3;h=k<<1;f=208376+(h<<2)|0;m=c[52084]|0;g=1<<k;do{if((m&g|0)==0){c[52084]=m|g;A=208376+(h+2<<2)|0;B=f}else{k=208376+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[208352>>2]|0)>>>0)){A=k;B=e;break}hd()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[208344>>2]=t;c[208356>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[208340>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[208640+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[208640+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[208344>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[208352>>2]|0;if(t>>>0<f>>>0){hd()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){hd()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){hd()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){hd()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){hd()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{hd()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=208640+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[208340>>2]=c[208340>>2]&~(1<<e);break c}else{if(t>>>0<(c[208352>>2]|0)>>>0){hd()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[208352>>2]|0)>>>0){hd()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=208376+(t<<2)|0;s=c[52084]|0;r=1<<e;do{if((s&r|0)==0){c[52084]=s|r;S=208376+(t+2<<2)|0;T=f}else{e=208376+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[208352>>2]|0)>>>0)){S=e;T=k;break}hd()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=208640+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[208340>>2]|0;l=1<<U;if((f&l|0)==0){c[208340>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[208352>>2]|0;if(W>>>0<k>>>0){hd()}if(r>>>0<k>>>0){hd()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[208344>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[208356>>2]|0;if(W>>>0>15){c[208356>>2]=X+q;c[208344>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[208344>>2]=0;c[208356>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[208348>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[208348>>2]=W;X=c[208360>>2]|0;c[208360>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[52202]|0)==0){X=ed(30)|0;if((X+ -1&X|0)==0){c[208816>>2]=X;c[208812>>2]=X;c[208820>>2]=-1;c[208824>>2]=-1;c[208828>>2]=0;c[208780>>2]=0;c[52202]=(sc(0)|0)&-16^1431655768;break}else{hd()}}}while(0);X=q+48|0;W=c[208816>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[208776>>2]|0;do{if((U|0)!=0){T=c[208768>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[208780>>2]&4|0)==0){U=c[208360>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=208784|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[208348>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=kb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=kb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[208812>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[208768>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[208776>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=kb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[208816>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((kb(t|0)|0)==(-1|0)){kb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[208780>>2]=c[208780>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=kb(W|0)|0;ha=kb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[208768>>2]|0)+ga|0;c[208768>>2]=ia;if(ia>>>0>(c[208772>>2]|0)>>>0){c[208772>>2]=ia}ia=c[208360>>2]|0;W=208784|0;i:do{if((ia|0)==0){aa=c[208352>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[208352>>2]=fa}c[208784>>2]=fa;c[208788>>2]=ga;c[208796>>2]=0;c[208372>>2]=c[52202];c[208368>>2]=-1;aa=0;do{ha=aa<<1;$=208376+(ha<<2)|0;c[208376+(ha+3<<2)>>2]=$;c[208376+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[208360>>2]=fa+ja;c[208348>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[208364>>2]=c[208824>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[208348>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[208360>>2]=ia+na;c[208348>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[208364>>2]=c[208824>>2];break i}}while(0);if(fa>>>0<(c[208352>>2]|0)>>>0){c[208352>>2]=fa}aa=fa+ga|0;$=208784|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[208360>>2]|0)){ca=(c[208348>>2]|0)+X|0;c[208348>>2]=ca;c[208360>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[208356>>2]|0)){ca=(c[208344>>2]|0)+X|0;c[208344>>2]=ca;c[208356>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=208376+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[208352>>2]|0)>>>0){hd()}if((c[V+12>>2]|0)==(ha|0)){break}hd()}}while(0);if((L|0)==(V|0)){c[52084]=c[52084]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[208352>>2]|0)>>>0){hd()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}hd()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[208352>>2]|0)>>>0){hd()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){hd()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{hd()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=208640+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[208340>>2]=c[208340>>2]&~(1<<t);break k}else{if(T>>>0<(c[208352>>2]|0)>>>0){hd()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[208352>>2]|0)>>>0){hd()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=208376+(Z<<2)|0;t=c[52084]|0;T=1<<ca;do{if((t&T|0)==0){c[52084]=t|T;xa=208376+(Z+2<<2)|0;ya=ea}else{ca=208376+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[208352>>2]|0)>>>0)){xa=ca;ya=V;break}hd()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=208640+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[208340>>2]|0;L=1<<za;if((ea&L|0)==0){c[208340>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[208352>>2]|0;if(Ba>>>0<S>>>0){hd()}if(T>>>0<S>>>0){hd()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=208784|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[208360>>2]=fa+Ha;c[208348>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[208364>>2]=c[208824>>2];c[ba+4>>2]=27;X=208784|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[208784>>2]=fa;c[208788>>2]=ga;c[208796>>2]=0;c[208792>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=208376+(da<<2)|0;aa=c[52084]|0;f=1<<M;do{if((aa&f|0)==0){c[52084]=aa|f;Ia=208376+(da+2<<2)|0;Ja=ha}else{M=208376+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[208352>>2]|0)>>>0)){Ia=M;Ja=T;break}hd()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=208640+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[208340>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[208340>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[208352>>2]|0;if(Ma>>>0<f>>>0){hd()}if(M>>>0<f>>>0){hd()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[208348>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[208348>>2]=W;ia=c[208360>>2]|0;c[208360>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Nc()|0)>>2]=12;p=0;i=b;return p|0}function yfb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[208352>>2]|0;if(d>>>0<f>>>0){hd()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){hd()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){hd()}if((p|0)==(c[208356>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[208344>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=208376+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){hd()}if((c[m+12>>2]|0)==(p|0)){break}hd()}}while(0);if((u|0)==(m|0)){c[52084]=c[52084]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){hd()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}hd()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){hd()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){hd()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){hd()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{hd()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=208640+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[208340>>2]=c[208340>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[208352>>2]|0)>>>0){hd()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[208352>>2]|0)>>>0){hd()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){hd()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){hd()}do{if((C&2|0)==0){if((l|0)==(c[208360>>2]|0)){f=(c[208348>>2]|0)+t|0;c[208348>>2]=f;c[208360>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[208356>>2]|0)){i=b;return}c[208356>>2]=0;c[208344>>2]=0;i=b;return}if((l|0)==(c[208356>>2]|0)){f=(c[208344>>2]|0)+t|0;c[208344>>2]=f;c[208356>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=208376+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[208352>>2]|0)>>>0){hd()}if((c[E+12>>2]|0)==(l|0)){break}hd()}}while(0);if((w|0)==(E|0)){c[52084]=c[52084]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[208352>>2]|0)>>>0){hd()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}hd()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[208352>>2]|0)>>>0){hd()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){hd()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{hd()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=208640+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[208340>>2]=c[208340>>2]&~(1<<g);break b}else{if(d>>>0<(c[208352>>2]|0)>>>0){hd()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[208352>>2]|0)>>>0){hd()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[208356>>2]|0)){J=f;break}c[208344>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=208376+(C<<2)|0;G=c[52084]|0;j=1<<t;do{if((G&j|0)==0){c[52084]=G|j;K=208376+(C+2<<2)|0;L=e}else{t=208376+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[208352>>2]|0)>>>0)){K=t;L=a;break}hd()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=208640+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[208340>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[208340>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[208352>>2]|0;if(O>>>0<K>>>0){hd()}if(f>>>0<K>>>0){hd()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[208368>>2]|0)+ -1|0;c[208368>>2]=s;if((s|0)==0){Q=208792|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[208368>>2]=-1;i=b;return}function zfb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=xfb(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}dgb(b|0,0,e|0)|0;i=d;return b|0}function Afb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=xfb(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Nc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=Bfb(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=xfb(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;bgb(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;yfb(a);e=g;i=d;return e|0}function Bfb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[208352>>2]|0;if(h>>>0<l>>>0){hd()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){hd()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){hd()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[208816>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;Cfb(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[208360>>2]|0)){m=(c[208348>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[208360>>2]=a+b;c[208348>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[208356>>2]|0)){h=(c[208344>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[208344>>2]=r;c[208356>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=208376+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){hd()}if((c[h+12>>2]|0)==(k|0)){break}hd()}}while(0);if((m|0)==(h|0)){c[52084]=c[52084]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){hd()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}hd()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){hd()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){hd()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){hd()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{hd()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=208640+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[208340>>2]=c[208340>>2]&~(1<<u);break a}else{if(t>>>0<(c[208352>>2]|0)>>>0){hd()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[208352>>2]|0)>>>0){hd()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;Cfb(a+b|0,r);o=a;i=d;return o|0}return 0}function Cfb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[208352>>2]|0;if(j>>>0<m>>>0){hd()}if((k|0)==(c[208356>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[208344>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=208376+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){hd()}if((c[q+12>>2]|0)==(k|0)){break}hd()}}while(0);if((r|0)==(q|0)){c[52084]=c[52084]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){hd()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}hd()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){hd()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){hd()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){hd()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{hd()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=208640+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[208340>>2]=c[208340>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[208352>>2]|0)>>>0){hd()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[208352>>2]|0)>>>0){hd()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[208352>>2]|0;if(e>>>0<z>>>0){hd()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[208360>>2]|0)){t=(c[208348>>2]|0)+p|0;c[208348>>2]=t;c[208360>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[208356>>2]|0)){i=d;return}c[208356>>2]=0;c[208344>>2]=0;i=d;return}if((f|0)==(c[208356>>2]|0)){t=(c[208344>>2]|0)+p|0;c[208344>>2]=t;c[208356>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=208376+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){hd()}if((c[u+12>>2]|0)==(f|0)){break}hd()}}while(0);if((h|0)==(u|0)){c[52084]=c[52084]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){hd()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}hd()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){hd()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){hd()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){hd()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{hd()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=208640+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[208340>>2]=c[208340>>2]&~(1<<j);break b}else{if(m>>>0<(c[208352>>2]|0)>>>0){hd()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[208352>>2]|0)>>>0){hd()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[208352>>2]|0)>>>0){hd()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[208356>>2]|0)){G=t;break}c[208344>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=208376+(B<<2)|0;D=c[52084]|0;b=1<<p;do{if((D&b|0)==0){c[52084]=D|b;H=208376+(B+2<<2)|0;I=A}else{p=208376+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[208352>>2]|0)>>>0)){H=p;I=a;break}hd()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=208640+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[208340>>2]|0;B=1<<J;if((a&B|0)==0){c[208340>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[208352>>2]|0)>>>0){hd()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[208352>>2]|0;if(L>>>0<B>>>0){hd()}if(G>>>0<B>>>0){hd()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function Dfb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=xfb(d)|0;if((e|0)!=0){f=6;break}a=c[52208]|0;c[52208]=0+a;if((a|0)==0){f=5;break}Fe[a&7]()}if((f|0)==5){d=Ec(4)|0;c[d>>2]=208848;Td(d|0,208896,135)}else if((f|0)==6){i=b;return e|0}return 0}function Efb(a){a=a|0;var b=0,c=0;b=i;c=Dfb(a)|0;i=b;return c|0}function Ffb(a){a=a|0;var b=0;b=i;if((a|0)!=0){yfb(a)}i=b;return}function Gfb(a){a=a|0;var b=0;b=i;Ffb(a);i=b;return}function Hfb(a){a=a|0;var b=0;b=i;zb(a|0);Ffb(a);i=b;return}function Ifb(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function Jfb(a){a=a|0;i=i;return 208864}function Kfb(){var a=0;a=Ec(4)|0;c[a>>2]=208848;Td(a|0,208896,135)}function Lfb(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,uc=0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,Ac=0.0,Bc=0.0,Cc=0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0;g=i;i=i+512|0;h=g;if((e|0)==0){j=24;k=-149}else if((e|0)==2){j=53;k=-1074}else if((e|0)==1){j=53;k=-1074}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=Ofb(b)|0}}while((jd(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=Ofb(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[208912+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=Ofb(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[208928+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=Ofb(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=Ofb(b)|0}if((B|32|0)!=120){if((c[m>>2]|0)==0){C=48;break}c[e>>2]=(c[e>>2]|0)+ -1;C=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=0}else{D=Ofb(b)|0;E=0}while(1){if((D|0)==46){v=70;break}else if((D|0)!=48){F=0;G=0;H=0;I=0;K=D;L=E;M=0;N=0;O=1.0;P=0;Q=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=1;continue}else{D=Ofb(b)|0;E=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;R=d[o]|0}else{R=Ofb(b)|0}if((R|0)==48){S=-1;T=-1}else{F=0;G=0;H=0;I=0;K=R;L=E;M=1;N=0;O=1.0;P=0;Q=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;V=d[o]|0}else{V=Ofb(b)|0}if((V|0)!=48){F=S;G=T;H=0;I=0;K=V;L=1;M=1;N=0;O=1.0;P=0;Q=0.0;break b}o=jgb(S|0,T|0,-1,-1)|0;S=o;T=J}}}while(0);c:while(1){o=K+ -48|0;do{if(o>>>0<10){W=o;v=84}else{q=K|32;n=(K|0)==46;if(!((q+ -97|0)>>>0<6|n)){X=K;break c}if(n){if((M|0)==0){Y=H;Z=I;_=H;$=I;aa=L;ba=1;ca=N;da=O;ea=P;ga=Q;break}else{X=46;break c}}else{W=(K|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((I|0)<0|(I|0)==0&H>>>0<8){ha=N;ia=O;ja=W+(P<<4)|0;ka=Q}else{if((I|0)<0|(I|0)==0&H>>>0<14){la=O*.0625;ha=N;ia=la;ja=P;ka=Q+la*+(W|0);break}if(!((W|0)!=0&(N|0)==0)){ha=N;ia=O;ja=P;ka=Q;break}ha=1;ia=O;ja=P;ka=Q+O*.5}}while(0);o=jgb(H|0,I|0,1,0)|0;Y=F;Z=G;_=o;$=J;aa=1;ba=M;ca=ha;da=ia;ea=ja;ga=ka}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=Y;G=Z;H=_;I=$;K=d[o]|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}else{F=Y;G=Z;H=_;I=$;K=Ofb(b)|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}}if((L|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){Nfb(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((M|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(M|0)==0;q=o?H:F;n=o?I:G;if((I|0)<0|(I|0)==0&H>>>0<8){o=H;p=I;ma=P;while(1){na=ma<<4;oa=jgb(o|0,p|0,1,0)|0;pa=J;if((pa|0)<0|(pa|0)==0&oa>>>0<8){ma=na;p=pa;o=oa}else{qa=na;break}}}else{qa=P}do{if((X|32|0)==112){o=Mfb(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){ra=o;sa=p;break}if(u){Nfb(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0;break}}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0}}while(0);p=egb(q|0,n|0,2)|0;o=jgb(p|0,J|0,-32,-1)|0;p=jgb(o|0,J|0,ra|0,sa|0)|0;o=J;if((qa|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}ma=k+ -106|0;na=((ma|0)<0)<<31>>31;if((o|0)<(na|0)|(o|0)==(na|0)&p>>>0<ma>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((qa|0)>-1){ma=p;na=o;oa=qa;la=Q;while(1){pa=oa<<1;if(!(la>=.5)){ta=la;ua=pa}else{ta=la+-1.0;ua=pa|1}va=la+ta;pa=jgb(ma|0,na|0,-1,-1)|0;wa=J;if((ua|0)>-1){ma=pa;na=wa;oa=ua;la=va}else{xa=pa;ya=wa;za=ua;Aa=va;break}}}else{xa=p;ya=o;za=qa;Aa=Q}oa=igb(32,0,k|0,((k|0)<0)<<31>>31|0)|0;na=jgb(xa|0,ya|0,oa|0,J|0)|0;oa=J;if(0>(oa|0)|0==(oa|0)&j>>>0>na>>>0){Ba=(na|0)<0?0:na}else{Ba=j}do{if((Ba|0)<53){la=+(r|0);va=+Rd(+(+Pfb(1.0,84-Ba|0)),+la);if(!((Ba|0)<32&Aa!=0.0)){Ca=la;Da=va;Ea=za;Fa=Aa;break}na=za&1;Ca=la;Da=va;Ea=(na^1)+za|0;Fa=(na|0)==0?0.0:Aa}else{Ca=+(r|0);Da=0.0;Ea=za;Fa=Aa}}while(0);va=Ca*Fa+(Da+Ca*+(Ea>>>0))-Da;if(!(va!=0.0)){c[(Nc()|0)>>2]=34}l=+Qfb(va,xa);i=g;return+l}else{C=w}}while(0);o=k+j|0;p=0-o|0;na=C;oa=0;while(1){if((na|0)==46){v=139;break}else if((na|0)!=48){Ga=na;Ha=0;Ia=0;Ja=oa;Ka=0;break}ma=c[e>>2]|0;if(ma>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ma+1;na=d[ma]|0;oa=1;continue}else{na=Ofb(b)|0;oa=1;continue}}d:do{if((v|0)==139){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;La=d[na]|0}else{La=Ofb(b)|0}if((La|0)==48){Ma=-1;Na=-1}else{Ga=La;Ha=0;Ia=0;Ja=oa;Ka=1;break}while(1){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;Oa=d[na]|0}else{Oa=Ofb(b)|0}if((Oa|0)!=48){Ga=Oa;Ha=Ma;Ia=Na;Ja=1;Ka=1;break d}na=jgb(Ma|0,Na|0,-1,-1)|0;Ma=na;Na=J}}}while(0);oa=h;c[oa>>2]=0;na=Ga+ -48|0;ma=(Ga|0)==46;e:do{if(na>>>0<10|ma){n=h+496|0;q=Ga;wa=ma;pa=na;Pa=0;Qa=0;Ra=Ha;Sa=Ia;Ta=Ja;Ua=Ka;Va=0;Wa=0;Xa=0;while(1){do{if(wa){if((Ua|0)==0){Ya=Pa;Za=Qa;_a=Pa;$a=Qa;ab=Ta;bb=1;cb=Va;db=Wa;eb=Xa}else{fb=q;gb=Pa;hb=Qa;ib=Ra;jb=Sa;kb=Ta;lb=Va;mb=Wa;nb=Xa;break e}}else{ob=jgb(Pa|0,Qa|0,1,0)|0;pb=J;qb=(q|0)!=48;if((Wa|0)>=125){if(!qb){Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}c[n>>2]=c[n>>2]|1;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}rb=h+(Wa<<2)|0;if((Va|0)==0){sb=pa}else{sb=q+ -48+((c[rb>>2]|0)*10|0)|0}c[rb>>2]=sb;rb=Va+1|0;tb=(rb|0)==9;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=1;bb=Ua;cb=tb?0:rb;db=(tb&1)+Wa|0;eb=qb?ob:Xa}}while(0);ob=c[e>>2]|0;if(ob>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ob+1;ub=d[ob]|0}else{ub=Ofb(b)|0}ob=ub+ -48|0;qb=(ub|0)==46;if(ob>>>0<10|qb){q=ub;wa=qb;pa=ob;Pa=_a;Qa=$a;Ra=Ya;Sa=Za;Ta=ab;Ua=bb;Va=cb;Wa=db;Xa=eb}else{vb=ub;wb=_a;xb=$a;yb=Ya;zb=Za;Ab=ab;Bb=bb;Cb=cb;Db=db;Eb=eb;v=162;break}}}else{vb=Ga;wb=0;xb=0;yb=Ha;zb=Ia;Ab=Ja;Bb=Ka;Cb=0;Db=0;Eb=0;v=162}}while(0);if((v|0)==162){na=(Bb|0)==0;fb=vb;gb=wb;hb=xb;ib=na?wb:yb;jb=na?xb:zb;kb=Ab;lb=Cb;mb=Db;nb=Eb}na=(kb|0)!=0;do{if(na){if((fb|32|0)!=101){v=171;break}ma=Mfb(b,f)|0;Xa=J;do{if((ma|0)==0&(Xa|0)==-2147483648){if(u){Nfb(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Fb=0;Gb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Fb=0;Gb=0;break}}else{Fb=ma;Gb=Xa}}while(0);Xa=jgb(Fb|0,Gb|0,ib|0,jb|0)|0;Hb=Xa;Ib=J}else{v=171}}while(0);do{if((v|0)==171){if(!((fb|0)>-1)){Hb=ib;Ib=jb;break}if((c[m>>2]|0)==0){Hb=ib;Ib=jb;break}c[e>>2]=(c[e>>2]|0)+ -1;Hb=ib;Ib=jb}}while(0);if(!na){c[(Nc()|0)>>2]=22;Nfb(b,0);l=0.0;i=g;return+l}Xa=c[oa>>2]|0;if((Xa|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Hb|0)==(gb|0)&(Ib|0)==(hb|0)&((hb|0)<0|(hb|0)==0&gb>>>0<10)){if(!(j>>>0>30)){if((Xa>>>j|0)!=0){break}}l=+(r|0)*+(Xa>>>0);i=g;return+l}}while(0);Xa=(k|0)/-2|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)>(na|0)|(Ib|0)==(na|0)&Hb>>>0>Xa>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}Xa=k+ -106|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)<(na|0)|(Ib|0)==(na|0)&Hb>>>0<Xa>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((lb|0)==0){Jb=mb}else{if((lb|0)<9){Xa=h+(mb<<2)|0;na=c[Xa>>2]|0;ma=lb;do{na=na*10|0;ma=ma+1|0;}while((ma|0)<9);c[Xa>>2]=na}Jb=mb+1|0}do{if((nb|0)<9){if(!((nb|0)<=(Hb|0)&(Hb|0)<18)){break}if((Hb|0)==9){l=+(r|0)*+((c[oa>>2]|0)>>>0);i=g;return+l}if((Hb|0)<9){l=+(r|0)*+((c[oa>>2]|0)>>>0)/+(c[208944+(8-Hb<<2)>>2]|0);i=g;return+l}ma=j+27+(fa(Hb,-3)|0)|0;Wa=c[oa>>2]|0;if((ma|0)<=30){if((Wa>>>ma|0)!=0){break}}l=+(r|0)*+(Wa>>>0)*+(c[208944+(Hb+ -10<<2)>>2]|0);i=g;return+l}}while(0);oa=(Hb|0)%9|0;if((oa|0)==0){Kb=0;Lb=0;Mb=Hb;Nb=Jb}else{na=(Hb|0)>-1?oa:oa+9|0;oa=c[208944+(8-na<<2)>>2]|0;do{if((Jb|0)==0){Ob=0;Pb=Hb;Qb=0}else{Xa=1e9/(oa|0)|0;Wa=0;ma=0;Va=0;Ua=Hb;while(1){Ta=h+(Va<<2)|0;Sa=c[Ta>>2]|0;Ra=((Sa>>>0)/(oa>>>0)|0)+ma|0;c[Ta>>2]=Ra;Rb=fa((Sa>>>0)%(oa>>>0)|0,Xa)|0;Sa=Va+1|0;if((Va|0)==(Wa|0)&(Ra|0)==0){Sb=Sa&127;Tb=Ua+ -9|0}else{Sb=Wa;Tb=Ua}if((Sa|0)==(Jb|0)){break}else{Wa=Sb;Ua=Tb;Va=Sa;ma=Rb}}if((Rb|0)==0){Ob=Sb;Pb=Tb;Qb=Jb;break}c[h+(Jb<<2)>>2]=Rb;Ob=Sb;Pb=Tb;Qb=Jb+1|0}}while(0);Kb=Ob;Lb=0;Mb=9-na+Pb|0;Nb=Qb}f:while(1){oa=h+(Kb<<2)|0;if((Mb|0)<18){ma=Lb;Va=Nb;while(1){Ua=0;Wa=Va+127|0;Xa=Va;while(1){Sa=Wa&127;Ra=h+(Sa<<2)|0;Ta=egb(c[Ra>>2]|0,0,29)|0;Qa=jgb(Ta|0,J|0,Ua|0,0)|0;Ta=J;if(Ta>>>0>0|(Ta|0)==0&Qa>>>0>1e9){Pa=tgb(Qa|0,Ta|0,1e9,0)|0;pa=ugb(Qa|0,Ta|0,1e9,0)|0;Ub=pa;Vb=Pa}else{Ub=Qa;Vb=0}c[Ra>>2]=Ub;Ra=(Sa|0)==(Kb|0);if((Sa|0)!=(Xa+127&127|0)|Ra){Wb=Xa}else{Wb=(Ub|0)==0?Sa:Xa}if(Ra){break}else{Ua=Vb;Wa=Sa+ -1|0;Xa=Wb}}Xa=ma+ -29|0;if((Vb|0)==0){ma=Xa;Va=Wb}else{Xb=Xa;Yb=Vb;Zb=Wb;break}}}else{if((Mb|0)==18){_b=Lb;$b=Nb}else{ac=Kb;bc=Lb;cc=Mb;dc=Nb;break}while(1){if(!((c[oa>>2]|0)>>>0<9007199)){ac=Kb;bc=_b;cc=18;dc=$b;break f}Va=0;ma=$b+127|0;Xa=$b;while(1){Wa=ma&127;Ua=h+(Wa<<2)|0;Sa=egb(c[Ua>>2]|0,0,29)|0;Ra=jgb(Sa|0,J|0,Va|0,0)|0;Sa=J;if(Sa>>>0>0|(Sa|0)==0&Ra>>>0>1e9){Qa=tgb(Ra|0,Sa|0,1e9,0)|0;Pa=ugb(Ra|0,Sa|0,1e9,0)|0;ec=Pa;fc=Qa}else{ec=Ra;fc=0}c[Ua>>2]=ec;Ua=(Wa|0)==(Kb|0);if((Wa|0)!=(Xa+127&127|0)|Ua){gc=Xa}else{gc=(ec|0)==0?Wa:Xa}if(Ua){break}else{Va=fc;ma=Wa+ -1|0;Xa=gc}}Xa=_b+ -29|0;if((fc|0)==0){_b=Xa;$b=gc}else{Xb=Xa;Yb=fc;Zb=gc;break}}}oa=Kb+127&127;if((oa|0)==(Zb|0)){Xa=Zb+127&127;ma=h+((Zb+126&127)<<2)|0;c[ma>>2]=c[ma>>2]|c[h+(Xa<<2)>>2];hc=Xa}else{hc=Zb}c[h+(oa<<2)>>2]=Yb;Kb=oa;Lb=Xb;Mb=Mb+9|0;Nb=hc}g:while(1){ic=dc+1&127;na=h+((dc+127&127)<<2)|0;oa=ac;Xa=bc;ma=cc;while(1){Va=(ma|0)==18;Wa=(ma|0)>27?9:1;jc=oa;kc=Xa;while(1){Ua=0;while(1){Ra=Ua+jc&127;if((Ra|0)==(dc|0)){lc=2;break}Qa=c[h+(Ra<<2)>>2]|0;Ra=c[208936+(Ua<<2)>>2]|0;if(Qa>>>0<Ra>>>0){lc=2;break}Pa=Ua+1|0;if(Qa>>>0>Ra>>>0){lc=Ua;break}if((Pa|0)<2){Ua=Pa}else{lc=Pa;break}}if((lc|0)==2&Va){break g}mc=Wa+kc|0;if((jc|0)==(dc|0)){jc=dc;kc=mc}else{break}}Va=(1<<Wa)+ -1|0;Ua=1e9>>>Wa;nc=jc;oc=0;Pa=jc;pc=ma;do{Ra=h+(Pa<<2)|0;Qa=c[Ra>>2]|0;Sa=(Qa>>>Wa)+oc|0;c[Ra>>2]=Sa;oc=fa(Qa&Va,Ua)|0;Qa=(Pa|0)==(nc|0)&(Sa|0)==0;Pa=Pa+1&127;pc=Qa?pc+ -9|0:pc;nc=Qa?Pa:nc;}while((Pa|0)!=(dc|0));if((oc|0)==0){oa=nc;Xa=mc;ma=pc;continue}if((ic|0)!=(nc|0)){break}c[na>>2]=c[na>>2]|1;oa=nc;Xa=mc;ma=pc}c[h+(dc<<2)>>2]=oc;ac=nc;bc=mc;cc=pc;dc=ic}ma=jc&127;if((ma|0)==(dc|0)){c[h+(ic+ -1<<2)>>2]=0;qc=ic}else{qc=dc}va=+((c[h+(ma<<2)>>2]|0)>>>0);ma=jc+1&127;if((ma|0)==(qc|0)){Xa=qc+1&127;c[h+(Xa+ -1<<2)>>2]=0;rc=Xa}else{rc=qc}la=+(r|0);sc=la*(va*1.0e9+ +((c[h+(ma<<2)>>2]|0)>>>0));ma=kc+53|0;Xa=ma-k|0;if((Xa|0)<(j|0)){tc=(Xa|0)<0?0:Xa;uc=1}else{tc=j;uc=0}if((tc|0)<53){va=+Rd(+(+Pfb(1.0,105-tc|0)),+sc);vc=+zc(+sc,+(+Pfb(1.0,53-tc|0)));wc=va;xc=vc;yc=va+(sc-vc)}else{wc=0.0;xc=0.0;yc=sc}oa=jc+2&127;do{if((oa|0)==(rc|0)){Ac=xc}else{na=c[h+(oa<<2)>>2]|0;do{if(na>>>0<5e8){if((na|0)==0){if((jc+3&127|0)==(rc|0)){Bc=xc;break}}Bc=la*.25+xc}else{if(na>>>0>5e8){Bc=la*.75+xc;break}if((jc+3&127|0)==(rc|0)){Bc=la*.5+xc;break}else{Bc=la*.75+xc;break}}}while(0);if((53-tc|0)<=1){Ac=Bc;break}if(+zc(+Bc,1.0)!=0.0){Ac=Bc;break}Ac=Bc+1.0}}while(0);la=yc+Ac-wc;do{if((ma&2147483647|0)>(-2-o|0)){if(!(+U(+la)>=9007199254740992.0)){Cc=uc;Dc=kc;Ec=la}else{Cc=(uc|0)!=0&(tc|0)==(Xa|0)?0:uc;Dc=kc+1|0;Ec=la*.5}if((Dc+50|0)<=(p|0)){if(!((Cc|0)!=0&Ac!=0.0)){Fc=Dc;Gc=Ec;break}}c[(Nc()|0)>>2]=34;Fc=Dc;Gc=Ec}else{Fc=kc;Gc=la}}while(0);l=+Qfb(Gc,Fc);i=g;return+l}else if((x|0)==3){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Hc=d[p]|0}else{Hc=Ofb(b)|0}if((Hc|0)==40){Ic=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Jc=d[p]|0}else{Jc=Ofb(b)|0}if(!((Jc+ -48|0)>>>0<10|(Jc+ -65|0)>>>0<26)){if(!((Jc+ -97|0)>>>0<26|(Jc|0)==95)){break}}Ic=Ic+1|0}if((Jc|0)==41){l=+y;i=g;return+l}p=(c[m>>2]|0)==0;if(!p){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Nc()|0)>>2]=22;Nfb(b,0);l=0.0;i=g;return+l}if((Ic|0)==0|p){l=+y;i=g;return+l}else{Kc=Ic}while(1){p=Kc+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((p|0)==0){l=+y;break}else{Kc=p}}i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Nc()|0)>>2]=22;Nfb(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Lc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Lc=Lc+ -1|0;}while(Lc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function Mfb(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=Ofb(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=Ofb(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=Ofb(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=sgb(q|0,m|0,10,0)|0;b=J;g=jgb(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=jgb(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=Ofb(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=Ofb(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=igb(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function Nfb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function Ofb(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=Sfb(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function Pfb(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=egb(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function Qfb(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+Pfb(a,b);i=c;return+d}function Rfb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){le[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function Sfb(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((Rfb(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((le[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function Tfb(a){a=a|0;var b=0,c=0.0;b=i;c=+Ufb(a,0);i=b;return+c}function Ufb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;Nfb(e,0);h=+Lfb(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function Vfb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;Nfb(e,0);h=+Lfb(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function Wfb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function Xfb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function Yfb(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function Zfb(){c[47312]=p;c[47354]=p;c[51996]=p;c[52226]=p}function _fb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}dc(116);dc(111);dc(111);dc(32);dc(109);dc(97);dc(110);dc(121);dc(32);dc(115);dc(101);dc(116);dc(106);dc(109);dc(112);dc(115);dc(32);dc(105);dc(110);dc(32);dc(97);dc(32);dc(102);dc(117);dc(110);dc(99);dc(116);dc(105);dc(111);dc(110);dc(32);dc(99);dc(97);dc(108);dc(108);dc(44);dc(32);dc(98);dc(117);dc(105);dc(108);dc(100);dc(32);dc(119);dc(105);dc(116);dc(104);dc(32);dc(97);dc(32);dc(104);dc(105);dc(103);dc(104);dc(101);dc(114);dc(32);dc(118);dc(97);dc(108);dc(117);dc(101);dc(32);dc(102);dc(111);dc(114);dc(32);dc(77);dc(65);dc(88);dc(95);dc(83);dc(69);dc(84);dc(74);dc(77);dc(80);dc(83);dc(10);ga(0);return 0}function $fb(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function agb(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function bgb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return mb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function cgb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{bgb(b,c,d)|0}return b|0}function dgb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function egb(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function fgb(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function ggb(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function hgb(){return ggb(o)|0}function igb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function jgb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function kgb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function lgb(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function mgb(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function ngb(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function ogb(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function pgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function qgb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=igb(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=igb((vgb(i,b,igb(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function rgb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=igb(h^a,j^b,h,j)|0;b=J;vgb(m,b,igb(k^d,l^e,k,l)|0,J,g)|0;l=igb(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function sgb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=pgb(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function tgb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=vgb(a,b,c,d,0)|0;return(J=J,e)|0}function ugb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;vgb(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function vgb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((ogb(l|0)|0)>>>0);return(J=n,o)|0}p=(ngb(l|0)|0)-(ngb(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(ngb(l|0)|0)-(ngb(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(ngb(j|0)|0)+33-(ngb(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=ogb(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=jgb(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;igb(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=igb(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function wgb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return be[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function xgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ce[a&31](b|0,c|0,d|0,e|0,f|0)}function ygb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return de[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function zgb(a,b){a=a|0;b=+b;ee[a&1](+b)}function Agb(a,b){a=a|0;b=b|0;fe[a&511](b|0)}function Bgb(a,b,c){a=a|0;b=b|0;c=c|0;ge[a&127](b|0,c|0)}function Cgb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return he[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function Dgb(a,b){a=a|0;b=b|0;return ie[a&127](b|0)|0}function Egb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;je[a&1](b|0,c|0,+d,e|0)}function Fgb(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return ke[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function Ggb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return le[a&63](b|0,c|0,d|0)|0}function Hgb(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return me[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function Igb(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return ne[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function Jgb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;oe[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function Kgb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;pe[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function Lgb(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return qe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function Mgb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;re[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function Ngb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;se[a&3](b|0,c|0,+d,e|0,f|0)}function Ogb(a,b,c){a=a|0;b=b|0;c=+c;return te[a&1](b|0,+c)|0}function Pgb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ue[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function Qgb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;ve[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function Rgb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;we[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function Sgb(a,b,c){a=a|0;b=b|0;c=c|0;return xe[a&63](b|0,c|0)|0}function Tgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ye[a&63](b|0,c|0,d|0,e|0,f|0)|0}function Ugb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return ze[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function Vgb(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+Ae[a&1](b|0,+c,+d)}function Wgb(a,b,c){a=a|0;b=b|0;c=c|0;return+Be[a&1](b|0,c|0)}function Xgb(a){a=a|0;return Ce[a&7]()|0}function Ygb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return De[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function Zgb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ee[a&15](b|0,c|0,d|0)}function _gb(a){a=a|0;Fe[a&7]()}function $gb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Ge[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function ahb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return He[a&63](b|0,c|0,d|0,e|0)|0}function bhb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ie[a&63](b|0,c|0,d|0,e|0)}function chb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function dhb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function ehb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function fhb(a){a=+a;ga(3)}function ghb(a){a=a|0;ga(4)}function hhb(a){a=a|0;Cd(a|0)}function ihb(a,b){a=a|0;b=b|0;ga(5)}function jhb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function khb(a){a=a|0;ga(7);return 0}function lhb(a){a=a|0;return Oc(a|0)|0}function mhb(a){a=a|0;return Ld(a|0)|0}function nhb(a){a=a|0;return wc(a|0)|0}function ohb(a){a=a|0;return Ad(a|0)|0}function phb(a){a=a|0;return md(a|0)|0}function qhb(a){a=a|0;return ud(a|0)|0}function rhb(a){a=a|0;return Yc(a|0)|0}function shb(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function thb(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function uhb(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function vhb(a,b,c){a=a|0;b=b|0;c=c|0;return wd(a|0,b|0,c|0)|0}function whb(a,b,c){a=a|0;b=b|0;c=c|0;return hc(a|0,b|0,c|0)|0}function xhb(a,b,c){a=a|0;b=b|0;c=c|0;return Od(a|0,b|0,c|0)|0}function yhb(a,b,c){a=a|0;b=b|0;c=c|0;return Bd(a|0,b|0,c|0)|0}function zhb(a,b,c){a=a|0;b=b|0;c=c|0;return xd(a|0,b|0,c|0)|0}function Ahb(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function Bhb(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function Chb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function Dhb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function Ehb(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(15);return 0}function Fhb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(16)}function Ghb(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(17)}function Hhb(a,b){a=a|0;b=+b;ga(18);return 0}function Ihb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(19)}function Jhb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(20)}function Khb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(21)}function Lhb(a,b){a=a|0;b=b|0;ga(22);return 0}function Mhb(a,b){a=a|0;b=b|0;return Qd(a|0,b|0)|0}function Nhb(a,b){a=a|0;b=b|0;return gc(a|0,b|0)|0}function Ohb(a,b){a=a|0;b=b|0;return ib(a|0,b|0)|0}function Phb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(23);return 0}function Qhb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(24);return 0}function Rhb(a,b,c){a=a|0;b=+b;c=+c;ga(25);return 0.0}function Shb(a,b){a=a|0;b=b|0;ga(26);return 0.0}function Thb(){ga(27);return 0}function Uhb(){return jb()|0}function Vhb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(28);return 0}function Whb(a,b,c){a=a|0;b=b|0;c=c|0;ga(29)}function Xhb(){ga(30)}function Yhb(){Uc()}function Zhb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(31);return 0}function _hb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32);return 0}function $hb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return rc(a|0,b|0,c|0,d|0)|0}function aib(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Mc(a|0,b|0,c|0,d|0)|0}function bib(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(33)}



function Je(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Ke(){return i|0}function Le(a){a=a|0;i=a}function Me(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Ne(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Oe(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Pe(a){a=a|0;J=a}function Qe(a){a=a|0;K=a}function Re(a){a=a|0;L=a}function Se(a){a=a|0;M=a}function Te(a){a=a|0;N=a}function Ue(a){a=a|0;O=a}function Ve(a){a=a|0;P=a}function We(a){a=a|0;Q=a}function Xe(a){a=a|0;R=a}function Ye(a){a=a|0;S=a}function Ze(a){a=a|0;var b=0,d=0;b=i;kRa(a)|0;d=a+540|0;ie[c[(c[d>>2]|0)+40>>2]&127](a)|0;ie[c[(c[d>>2]|0)+28>>2]&127](a)|0;ie[c[(c[d>>2]|0)+32>>2]&127](a)|0;ie[c[(c[d>>2]|0)+48>>2]&127](a)|0;ie[c[(c[d>>2]|0)+52>>2]&127](a)|0;NPa(a);i=b;return}function _e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=$fb(B|0)|0;D=xfb(C+11|0)|0;kgb(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=ic(D|0,32)|0;if((C|0)==0){B=Wd(c[(Nc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;UMa(23,0,40,u);Yc(0)|0;F=0}else{F=C}yfb(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}Ce[c[119092>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{jOa(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}jOa(2);iOa(2)}ZNa(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];SMa(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];APa(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];SMa(23,1,144,r);Z=UQa(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}Ze(b);OPa(b);if((c[118284>>2]|0)!=0){fe[c[29686]&511](23)}if((c[2]|0)!=0){iOa(4)}A=CPa(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];SMa(7,1,200,q);if((c[175268>>2]|0)==0){ge[c[159940>>2]&127](159920,b)}EPa(b,c[J>>2]|0,z,d);if((c[118220>>2]|0)!=0){fe[c[29686]&511](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;SPa(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){lOa(4)}if((eRa(b,1,1)|0)!=0){c[B>>2]=1;SPa(b)}ie[c[(c[K>>2]|0)+88>>2]&127](b)|0;NPa(b);WPa(b);OPa(b);do{if((T|0)==0){_=0}else{iOa(7);lOa(2);A=(rc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(rc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+dOa(2);if(!$){aa=0;break}aa=(rc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+dOa(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=_Na(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(rc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+dOa(ba+9|0);if((ca|0)==0){ka=0}else{ka=(rc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}lOa(7);if((la|0)!=0){_=T;break}c[p>>2]=Wd(c[(Nc()|0)>>2]|0)|0;UMa(23,0,240,p);Yc(T|0)|0;_=0}}while(0);if((c[175268>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;ge[c[159940>>2]&127](159920,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[41380]|0)!=0){ca=f;ba=165528;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];KMa(M,f);Sd(10,M|0)|0;ba=c[41388]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;SMa(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((DQa(b,0)|0)!=0){ma=58;break}if((tQa(b,0)|0)!=0){ma=58;break}if((iQa(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];SMa(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((DQa(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];SMa(1,0,448,m);U=_;V=-2;break}if((tQa(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];SMa(1,0,536,l);U=_;V=-3;break}T=(iQa(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];SMa(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];SMa(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}Yc(U|0)|0;i=e;return V|0}function $e(a){a=a|0;i=i;return 0}function af(a){a=a|0;i=i;return 0}function bf(a){a=a|0;i=i;return 0}function cf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+54|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+54|0]|0;k=b+4|0;l=c[c[k>>2]>>2]|0;m=bQa(+h[l>>3],+h[(c[l+8>>2]|0)+8992>>3]+ +h[(c[b+416>>2]|0)+8720>>3],a[(c[b+360>>2]|0)+54|0]|0)|0;a[(c[b+352>>2]|0)+54|0]=m;e=k;f=j;break}else{j=b+4|0;k=c[c[j>>2]>>2]|0;m=bQa(+h[k>>3],+h[(c[k+8>>2]|0)+8992>>3]+ +h[(c[b+416>>2]|0)+8720>>3],a[(c[b+360>>2]|0)+54|0]|0)|0;a[(c[b+352>>2]|0)+54|0]=m;e=j;f=m;break}}else{if(g){g=a[(c[b+356>>2]|0)+54|0]|0;m=b+4|0;j=c[c[m>>2]>>2]|0;k=fQa(+h[j>>3],+h[(c[j+8>>2]|0)+8992>>3]+ +h[(c[b+416>>2]|0)+8720>>3])|0;a[(c[b+352>>2]|0)+54|0]=k;e=m;f=g;break}else{g=b+4|0;m=c[c[g>>2]>>2]|0;k=fQa(+h[m>>3],+h[(c[m+8>>2]|0)+8992>>3]+ +h[(c[b+416>>2]|0)+8720>>3])|0;a[(c[b+352>>2]|0)+54|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+19|0]=f;i=d;return}function df(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+4|0;f=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;if(!((dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|f)<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}f=b+314|0;do{if((a[f]|0)==0){s=a[(c[b+356>>2]|0)+25|0]|0}else{t=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(t){u=a[(c[b+356>>2]|0)+25|0]|0;v=_Pa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3],a[(c[b+360>>2]|0)+25|0]|0)|0;a[(c[b+352>>2]|0)+25|0]=v;s=u;break}else{u=_Pa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3],a[(c[b+360>>2]|0)+25|0]|0)|0;a[(c[b+352>>2]|0)+25|0]=u;s=u;break}}else{if(t){t=a[(c[b+356>>2]|0)+25|0]|0;u=cQa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3])|0;a[(c[b+352>>2]|0)+25|0]=u;s=t;break}else{t=cQa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3])|0;a[(c[b+352>>2]|0)+25|0]=t;s=t;break}}}}while(0);if(!(s<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}s=c[c[e>>2]>>2]|0;t=(a[f]|0)==0;if((a[(c[s+16>>2]|0)+21|0]|0)!=0){do{if(t){w=a[(c[b+356>>2]|0)+26|0]|0}else{u=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(u){v=a[(c[b+356>>2]|0)+26|0]|0;x=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3],a[(c[b+360>>2]|0)+26|0]|0)|0;a[(c[b+352>>2]|0)+26|0]=x;w=v;break}else{v=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3],a[(c[b+360>>2]|0)+26|0]|0)|0;a[(c[b+352>>2]|0)+26|0]=v;w=v;break}}else{if(u){u=a[(c[b+356>>2]|0)+26|0]|0;v=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3])|0;a[(c[b+352>>2]|0)+26|0]=v;w=u;break}else{u=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3])|0;a[(c[b+352>>2]|0)+26|0]=u;w=u;break}}}}while(0);if(!(w<<24>>24==0)){g=+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9248>>3];j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){y=a[(c[b+356>>2]|0)+27|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){u=a[(c[b+356>>2]|0)+27|0]|0;v=c[c[e>>2]>>2]|0;x=_Pa(+h[v>>3],+h[(c[v+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=x;y=u;break}else{u=c[c[e>>2]>>2]|0;x=_Pa(+h[u>>3],+h[(c[u+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=x;y=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+27|0]|0;x=c[c[e>>2]>>2]|0;u=cQa(+h[x>>3],+h[(c[x+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=u;y=w;break}else{w=c[c[e>>2]>>2]|0;u=cQa(+h[w>>3],+h[(c[w+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=u;y=u;break}}}}while(0);if(y<<24>>24==0){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}g=-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9248>>3];j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}do{if(t){z=a[(c[b+356>>2]|0)+28|0]|0}else{y=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(y){u=a[(c[b+356>>2]|0)+28|0]|0;w=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3],a[(c[b+360>>2]|0)+28|0]|0)|0;a[(c[b+352>>2]|0)+28|0]=w;z=u;break}else{u=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3],a[(c[b+360>>2]|0)+28|0]|0)|0;a[(c[b+352>>2]|0)+28|0]=u;z=u;break}}else{if(y){y=a[(c[b+356>>2]|0)+28|0]|0;u=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3])|0;a[(c[b+352>>2]|0)+28|0]=u;z=y;break}else{y=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3])|0;a[(c[b+352>>2]|0)+28|0]=y;z=y;break}}}}while(0);if(!(z<<24>>24==0)){g=+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9248>>3];j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){A=a[(c[b+356>>2]|0)+29|0]|0}else{z=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(z){s=a[(c[b+356>>2]|0)+29|0]|0;t=c[c[e>>2]>>2]|0;y=_Pa(+h[t>>3],+h[(c[t+8>>2]|0)+9008>>3],a[(c[b+360>>2]|0)+29|0]|0)|0;a[(c[b+352>>2]|0)+29|0]=y;A=s;break}else{s=c[c[e>>2]>>2]|0;y=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9008>>3],a[(c[b+360>>2]|0)+29|0]|0)|0;a[(c[b+352>>2]|0)+29|0]=y;A=y;break}}else{if(z){z=a[(c[b+356>>2]|0)+29|0]|0;y=c[c[e>>2]>>2]|0;s=cQa(+h[y>>3],+h[(c[y+8>>2]|0)+9008>>3])|0;a[(c[b+352>>2]|0)+29|0]=s;A=z;break}else{z=c[c[e>>2]>>2]|0;s=cQa(+h[z>>3],+h[(c[z+8>>2]|0)+9008>>3])|0;a[(c[b+352>>2]|0)+29|0]=s;A=s;break}}}}while(0);if(!(A<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){B=a[(c[b+356>>2]|0)+27|0]|0}else{A=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(A){s=a[(c[b+356>>2]|0)+27|0]|0;z=c[c[e>>2]>>2]|0;y=_Pa(+h[z>>3],+h[(c[z+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=y;B=s;break}else{s=c[c[e>>2]>>2]|0;y=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=y;B=y;break}}else{if(A){A=a[(c[b+356>>2]|0)+27|0]|0;y=c[c[e>>2]>>2]|0;s=cQa(+h[y>>3],+h[(c[y+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=s;B=A;break}else{A=c[c[e>>2]>>2]|0;s=cQa(+h[A>>3],+h[(c[A+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=s;B=s;break}}}}while(0);if(B<<24>>24==0){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}g=-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9248>>3];j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}function ef(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+608>>3]=+h[b+8712>>3]*2.094395102393195;i=i;return}function ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+600>>3]=+h[b+8712>>3]*-1.570796326794897;i=i;return}function gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+592>>3]=+h[b+8712>>3]*-2.181661564992912;i=i;return}function hf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+576>>3]=+h[b+8712>>3]*.7853981633974483;i=i;return}function jf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+584>>3]=+h[b+8712>>3]*3.839724354387525;i=i;return}function kf(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0;d=i;e=b+4|0;f=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;if(!((dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|f)<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}f=b+314|0;do{if((a[f]|0)==0){s=a[(c[b+356>>2]|0)+25|0]|0}else{t=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(t){u=a[(c[b+356>>2]|0)+25|0]|0;v=_Pa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3],a[(c[b+360>>2]|0)+25|0]|0)|0;a[(c[b+352>>2]|0)+25|0]=v;s=u;break}else{u=_Pa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3],a[(c[b+360>>2]|0)+25|0]|0)|0;a[(c[b+352>>2]|0)+25|0]=u;s=u;break}}else{if(t){t=a[(c[b+356>>2]|0)+25|0]|0;u=cQa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3])|0;a[(c[b+352>>2]|0)+25|0]=u;s=t;break}else{t=cQa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3])|0;a[(c[b+352>>2]|0)+25|0]=t;s=t;break}}}}while(0);if(!(s<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}s=c[c[e>>2]>>2]|0;t=(a[f]|0)==0;if((a[(c[s+16>>2]|0)+21|0]|0)!=0){do{if(t){w=a[(c[b+356>>2]|0)+26|0]|0}else{u=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(u){v=a[(c[b+356>>2]|0)+26|0]|0;x=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3],a[(c[b+360>>2]|0)+26|0]|0)|0;a[(c[b+352>>2]|0)+26|0]=x;w=v;break}else{v=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3],a[(c[b+360>>2]|0)+26|0]|0)|0;a[(c[b+352>>2]|0)+26|0]=v;w=v;break}}else{if(u){u=a[(c[b+356>>2]|0)+26|0]|0;v=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3])|0;a[(c[b+352>>2]|0)+26|0]=v;w=u;break}else{u=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3])|0;a[(c[b+352>>2]|0)+26|0]=u;w=u;break}}}}while(0);if(!(w<<24>>24==0)){w=c[c[e>>2]>>2]|0;y=+h[w>>3]- +h[(c[b+416>>2]|0)+8728>>3];g=+h[(c[w+8>>2]|0)+9248>>3]*y*y*.5;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){z=a[(c[b+356>>2]|0)+27|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){u=a[(c[b+356>>2]|0)+27|0]|0;v=c[c[e>>2]>>2]|0;x=_Pa(+h[v>>3],+h[(c[v+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=x;z=u;break}else{u=c[c[e>>2]>>2]|0;x=_Pa(+h[u>>3],+h[(c[u+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=x;z=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+27|0]|0;x=c[c[e>>2]>>2]|0;u=cQa(+h[x>>3],+h[(c[x+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=u;z=w;break}else{w=c[c[e>>2]>>2]|0;u=cQa(+h[w>>3],+h[(c[w+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=u;z=u;break}}}}while(0);u=c[c[e>>2]>>2]|0;if(z<<24>>24==0){g=+h[(c[u+8>>2]|0)+8960>>3];j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}else{z=c[u+8>>2]|0;y=+h[u>>3]- +h[z+9104>>3];g=+h[z+8968>>3]+(y*+h[z+9096>>3]+y*y*+h[z+9248>>3]*-.5);j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}}do{if(t){A=a[(c[b+356>>2]|0)+28|0]|0}else{z=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(z){u=a[(c[b+356>>2]|0)+28|0]|0;w=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3],a[(c[b+360>>2]|0)+28|0]|0)|0;a[(c[b+352>>2]|0)+28|0]=w;A=u;break}else{u=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3],a[(c[b+360>>2]|0)+28|0]|0)|0;a[(c[b+352>>2]|0)+28|0]=u;A=u;break}}else{if(z){z=a[(c[b+356>>2]|0)+28|0]|0;u=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3])|0;a[(c[b+352>>2]|0)+28|0]=u;A=z;break}else{z=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3])|0;a[(c[b+352>>2]|0)+28|0]=z;A=z;break}}}}while(0);if(!(A<<24>>24==0)){A=c[c[e>>2]>>2]|0;y=+h[A>>3]- +h[(c[b+416>>2]|0)+8728>>3];g=+h[(c[A+8>>2]|0)+9248>>3]*y*y*.5;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){B=a[(c[b+356>>2]|0)+29|0]|0}else{A=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(A){s=a[(c[b+356>>2]|0)+29|0]|0;t=c[c[e>>2]>>2]|0;z=_Pa(+h[t>>3],+h[(c[t+8>>2]|0)+9008>>3],a[(c[b+360>>2]|0)+29|0]|0)|0;a[(c[b+352>>2]|0)+29|0]=z;B=s;break}else{s=c[c[e>>2]>>2]|0;z=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9008>>3],a[(c[b+360>>2]|0)+29|0]|0)|0;a[(c[b+352>>2]|0)+29|0]=z;B=z;break}}else{if(A){A=a[(c[b+356>>2]|0)+29|0]|0;z=c[c[e>>2]>>2]|0;s=cQa(+h[z>>3],+h[(c[z+8>>2]|0)+9008>>3])|0;a[(c[b+352>>2]|0)+29|0]=s;B=A;break}else{A=c[c[e>>2]>>2]|0;s=cQa(+h[A>>3],+h[(c[A+8>>2]|0)+9008>>3])|0;a[(c[b+352>>2]|0)+29|0]=s;B=s;break}}}}while(0);if(!(B<<24>>24==0)){B=c[c[e>>2]>>2]|0;s=c[B+8>>2]|0;g=+h[s+8968>>3]+ +h[s+9240>>3]*(+h[B>>3]- +h[s+9120>>3]);j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){C=a[(c[b+356>>2]|0)+27|0]|0}else{s=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(s){B=a[(c[b+356>>2]|0)+27|0]|0;A=c[c[e>>2]>>2]|0;z=_Pa(+h[A>>3],+h[(c[A+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=z;C=B;break}else{B=c[c[e>>2]>>2]|0;z=_Pa(+h[B>>3],+h[(c[B+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=z;C=z;break}}else{if(s){s=a[(c[b+356>>2]|0)+27|0]|0;z=c[c[e>>2]>>2]|0;B=cQa(+h[z>>3],+h[(c[z+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=B;C=s;break}else{s=c[c[e>>2]>>2]|0;B=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=B;C=B;break}}}}while(0);b=c[c[e>>2]>>2]|0;if(C<<24>>24==0){g=+h[(c[b+8>>2]|0)+8952>>3];j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}else{C=c[b+8>>2]|0;y=+h[b>>3]- +h[C+9008>>3];g=+h[C+8960>>3]+(y*+h[C+9240>>3]+y*y*+h[C+9248>>3]*-.5);j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}}function lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8680>>3]=+h[b+8704>>3]*2.094395102393195+-1.047197551196598;i=i;return}function mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8408>>3]=+h[(c[a+416>>2]|0)+9304>>3]*+h[b+8680>>3];i=i;return}function nf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8272>>3]=+h[b+8704>>3]*-1.570796326794897+.3490658503988659;i=i;return}function of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8e3>>3]=+h[(c[a+416>>2]|0)+9992>>3]*+h[b+8272>>3];i=i;return}function pf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7864>>3]=+h[b+8704>>3]*-2.181661564992912+1.570796326794897;i=i;return}function qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7592>>3]=+h[(c[a+416>>2]|0)+10680>>3]*+h[b+7864>>3];i=i;return}function rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6688>>3]=+h[b+8704>>3]*.7853981633974483;i=i;return}function sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7168>>3]=+h[(c[a+416>>2]|0)+11352>>3]*+h[b+6688>>3];i=i;return}function tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6400>>3]=+h[(c[a+416>>2]|0)+12600>>3]*+h[b+6688>>3];i=i;return}function uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7456>>3]=+h[b+6688>>3];i=i;return}function vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7072>>3]=+h[b+8704>>3]*3.839724354387525+-1.919862177193763;i=i;return}function wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6784>>3]=+h[(c[a+416>>2]|0)+11976>>3]*+h[b+7072>>3];i=i;return}function xf(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+4|0;f=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;if(!((dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|f)<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}f=b+314|0;do{if((a[f]|0)==0){s=a[(c[b+356>>2]|0)+25|0]|0}else{t=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(t){u=a[(c[b+356>>2]|0)+25|0]|0;v=_Pa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3],a[(c[b+360>>2]|0)+25|0]|0)|0;a[(c[b+352>>2]|0)+25|0]=v;s=u;break}else{u=_Pa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3],a[(c[b+360>>2]|0)+25|0]|0)|0;a[(c[b+352>>2]|0)+25|0]=u;s=u;break}}else{if(t){t=a[(c[b+356>>2]|0)+25|0]|0;u=cQa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3])|0;a[(c[b+352>>2]|0)+25|0]=u;s=t;break}else{t=cQa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3])|0;a[(c[b+352>>2]|0)+25|0]=t;s=t;break}}}}while(0);if(!(s<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}s=c[c[e>>2]>>2]|0;t=(a[f]|0)==0;if((a[(c[s+16>>2]|0)+21|0]|0)!=0){do{if(t){w=a[(c[b+356>>2]|0)+26|0]|0}else{u=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(u){v=a[(c[b+356>>2]|0)+26|0]|0;x=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3],a[(c[b+360>>2]|0)+26|0]|0)|0;a[(c[b+352>>2]|0)+26|0]=x;w=v;break}else{v=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3],a[(c[b+360>>2]|0)+26|0]|0)|0;a[(c[b+352>>2]|0)+26|0]=v;w=v;break}}else{if(u){u=a[(c[b+356>>2]|0)+26|0]|0;v=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3])|0;a[(c[b+352>>2]|0)+26|0]=v;w=u;break}else{u=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3])|0;a[(c[b+352>>2]|0)+26|0]=u;w=u;break}}}}while(0);if(!(w<<24>>24==0)){w=c[c[e>>2]>>2]|0;g=+h[(c[w+8>>2]|0)+9248>>3]*(+h[w>>3]- +h[(c[b+416>>2]|0)+8728>>3])*2.0*.5;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){y=a[(c[b+356>>2]|0)+27|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){u=a[(c[b+356>>2]|0)+27|0]|0;v=c[c[e>>2]>>2]|0;x=_Pa(+h[v>>3],+h[(c[v+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=x;y=u;break}else{u=c[c[e>>2]>>2]|0;x=_Pa(+h[u>>3],+h[(c[u+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=x;y=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+27|0]|0;x=c[c[e>>2]>>2]|0;u=cQa(+h[x>>3],+h[(c[x+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=u;y=w;break}else{w=c[c[e>>2]>>2]|0;u=cQa(+h[w>>3],+h[(c[w+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=u;y=u;break}}}}while(0);if(y<<24>>24==0){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}y=c[c[e>>2]>>2]|0;u=c[y+8>>2]|0;g=+h[u+9096>>3]+ +h[u+9248>>3]*(+h[y>>3]- +h[u+9104>>3])*2.0*-.5;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}do{if(t){z=a[(c[b+356>>2]|0)+28|0]|0}else{u=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(u){y=a[(c[b+356>>2]|0)+28|0]|0;w=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3],a[(c[b+360>>2]|0)+28|0]|0)|0;a[(c[b+352>>2]|0)+28|0]=w;z=y;break}else{y=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3],a[(c[b+360>>2]|0)+28|0]|0)|0;a[(c[b+352>>2]|0)+28|0]=y;z=y;break}}else{if(u){u=a[(c[b+356>>2]|0)+28|0]|0;y=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3])|0;a[(c[b+352>>2]|0)+28|0]=y;z=u;break}else{u=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3])|0;a[(c[b+352>>2]|0)+28|0]=u;z=u;break}}}}while(0);if(!(z<<24>>24==0)){z=c[c[e>>2]>>2]|0;g=+h[(c[z+8>>2]|0)+9248>>3]*(+h[z>>3]- +h[(c[b+416>>2]|0)+8728>>3])*2.0*.5;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){A=a[(c[b+356>>2]|0)+29|0]|0}else{z=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(z){s=a[(c[b+356>>2]|0)+29|0]|0;t=c[c[e>>2]>>2]|0;u=_Pa(+h[t>>3],+h[(c[t+8>>2]|0)+9008>>3],a[(c[b+360>>2]|0)+29|0]|0)|0;a[(c[b+352>>2]|0)+29|0]=u;A=s;break}else{s=c[c[e>>2]>>2]|0;u=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9008>>3],a[(c[b+360>>2]|0)+29|0]|0)|0;a[(c[b+352>>2]|0)+29|0]=u;A=u;break}}else{if(z){z=a[(c[b+356>>2]|0)+29|0]|0;u=c[c[e>>2]>>2]|0;s=cQa(+h[u>>3],+h[(c[u+8>>2]|0)+9008>>3])|0;a[(c[b+352>>2]|0)+29|0]=s;A=z;break}else{z=c[c[e>>2]>>2]|0;s=cQa(+h[z>>3],+h[(c[z+8>>2]|0)+9008>>3])|0;a[(c[b+352>>2]|0)+29|0]=s;A=s;break}}}}while(0);if(!(A<<24>>24==0)){g=+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9240>>3];j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){B=a[(c[b+356>>2]|0)+27|0]|0}else{A=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(A){s=a[(c[b+356>>2]|0)+27|0]|0;z=c[c[e>>2]>>2]|0;u=_Pa(+h[z>>3],+h[(c[z+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=u;B=s;break}else{s=c[c[e>>2]>>2]|0;u=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=u;B=u;break}}else{if(A){A=a[(c[b+356>>2]|0)+27|0]|0;u=c[c[e>>2]>>2]|0;s=cQa(+h[u>>3],+h[(c[u+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=s;B=A;break}else{A=c[c[e>>2]>>2]|0;s=cQa(+h[A>>3],+h[(c[A+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=s;B=s;break}}}}while(0);if(B<<24>>24==0){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}B=c[c[e>>2]>>2]|0;b=c[B+8>>2]|0;g=+h[b+9240>>3]+ +h[b+9248>>3]*(+h[B>>3]- +h[b+9008>>3])*2.0*-.5;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}function yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8664>>3]=+h[b+8696>>3]*2.094395102393195;i=i;return}function zf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8400>>3]=+h[(c[a+416>>2]|0)+9312>>3]*+h[b+8664>>3];i=i;return}function Af(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8256>>3]=+h[b+8696>>3]*-1.570796326794897;i=i;return}function Bf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7992>>3]=+h[(c[a+416>>2]|0)+1e4>>3]*+h[b+8256>>3];i=i;return}function Cf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7848>>3]=+h[b+8696>>3]*-2.181661564992912;i=i;return}function Df(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7584>>3]=+h[(c[a+416>>2]|0)+10688>>3]*+h[b+7848>>3];i=i;return}function Ef(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6672>>3]=+h[b+8696>>3]*.7853981633974483;i=i;return}function Ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7160>>3]=+h[(c[a+416>>2]|0)+11360>>3]*+h[b+6672>>3];i=i;return}function Gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6392>>3]=+h[(c[a+416>>2]|0)+12608>>3]*+h[b+6672>>3];i=i;return}function Hf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7440>>3]=+h[b+6672>>3];i=i;return}function If(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7056>>3]=+h[b+8696>>3]*3.839724354387525;i=i;return}function Jf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6776>>3]=+h[(c[a+416>>2]|0)+11984>>3]*+h[b+7056>>3];i=i;return}function Kf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+24|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+24|0]|0;k=b+4|0;l=c[c[k>>2]>>2]|0;m=$Pa(+h[l>>3],+h[(c[l+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+24|0]|0)|0;a[(c[b+352>>2]|0)+24|0]=m;e=k;f=j;break}else{j=b+4|0;k=c[c[j>>2]>>2]|0;m=$Pa(+h[k>>3],+h[(c[k+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+24|0]|0)|0;a[(c[b+352>>2]|0)+24|0]=m;e=j;f=m;break}}else{if(g){g=a[(c[b+356>>2]|0)+24|0]|0;m=b+4|0;j=c[c[m>>2]>>2]|0;k=dQa(+h[j>>3],+h[(c[j+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+24|0]=k;e=m;f=g;break}else{g=b+4|0;m=c[c[g>>2]>>2]|0;k=dQa(+h[m>>3],+h[(c[m+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+24|0]=k;e=g;f=k;break}}}}while(0);a[c[(c[c[e>>2]>>2]|0)+16>>2]|0]=f;i=d;return}function Lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8624>>3]=+h[b+9776>>3]*+h[b+232>>3];i=i;return}function Mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8616>>3]=+h[b+8624>>3]*+h[b+232>>3];i=i;return}function Nf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9728>>3];k=+h[g+224>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8536|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8536|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,872,864,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8536|0;p=o;h[p>>3]=m;i=d;return}function Of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8520>>3]=+h[b+224>>3]*+h[b+8536>>3];i=i;return}function Pf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8632>>3]=+h[b+8536>>3]- +h[b+232>>3];i=i;return}function Qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8544>>3]=+h[b+9736>>3]*+h[b+8536>>3];i=i;return}function Rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8640>>3]=-+h[b+8544>>3]- +h[b+224>>3];i=i;return}function Sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8416>>3]=+h[b+8640>>3]- +h[b+8624>>3];i=i;return}function Tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8528>>3]=+h[b+8544>>3]*+h[b+8536>>3];i=i;return}function Uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8464>>3]=+h[(c[a+416>>2]|0)+9152>>3]*+h[b+232>>3];i=i;return}function Vf(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,12)|0;d=c[(c[a+476>>2]|0)+796>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8488>>3]=+h[d>>3];h[e+8504>>3]=+h[d+8>>3];h[e+8512>>3]=+h[d+16>>3];i=b;return}function Wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8480>>3]=+h[b+8488>>3]*+h[b+8504>>3];i=i;return}function Xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8496>>3]=+h[b+8512>>3]*+h[b+8504>>3];i=i;return}function Yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8456>>3]=+h[(c[a+416>>2]|0)+9176>>3]*+h[b+232>>3];i=i;return}function Zf(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8344>>3]=+h[b+9384>>3]*(+h[d+200>>3]- +h[b+9400>>3]);i=i;return}function _f(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8336>>3]=+h[(c[a+416>>2]|0)+9392>>3]*+h[b+192>>3];i=i;return}function $f(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8352>>3]=+h[b+8336>>3]*+h[b+192>>3];i=i;return}function ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8360>>3]=+h[b+8344>>3]+ +h[b+8336>>3];i=i;return}function bg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2352>>3]=-(+h[(c[a+416>>2]|0)+9368>>3]*+h[b+8360>>3]);i=i;return}function cg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+488>>3]=+h[b+192>>3];i=i;return}function dg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8216>>3]=+h[b+9696>>3]*+h[b+184>>3];i=i;return}function eg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8208>>3]=+h[b+8216>>3]*+h[b+184>>3];i=i;return}function fg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9648>>3];k=+h[g+176>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8128|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8128|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,912,904,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8128|0;p=o;h[p>>3]=m;i=d;return}function gg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8112>>3]=+h[b+176>>3]*+h[b+8128>>3];i=i;return}function hg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8224>>3]=+h[b+8128>>3]- +h[b+184>>3];i=i;return}function ig(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8136>>3]=+h[b+9656>>3]*+h[b+8128>>3];i=i;return}function jg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8232>>3]=-+h[b+8136>>3]- +h[b+176>>3];i=i;return}function kg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8008>>3]=+h[b+8232>>3]- +h[b+8216>>3];i=i;return}function lg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8120>>3]=+h[b+8136>>3]*+h[b+8128>>3];i=i;return}function mg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8056>>3]=+h[(c[a+416>>2]|0)+9840>>3]*+h[b+184>>3];i=i;return}function ng(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,13)|0;d=c[(c[a+476>>2]|0)+860>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8080>>3]=+h[d>>3];h[e+8096>>3]=+h[d+8>>3];h[e+8104>>3]=+h[d+16>>3];i=b;return}function og(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8072>>3]=+h[b+8080>>3]*+h[b+8096>>3];i=i;return}function pg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8088>>3]=+h[b+8104>>3]*+h[b+8096>>3];i=i;return}function qg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8048>>3]=+h[(c[a+416>>2]|0)+9864>>3]*+h[b+184>>3];i=i;return}function rg(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7936>>3]=+h[b+10072>>3]*(+h[d+152>>3]- +h[b+10088>>3]);i=i;return}function sg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7928>>3]=+h[(c[a+416>>2]|0)+10080>>3]*+h[b+144>>3];i=i;return}function tg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7944>>3]=+h[b+7928>>3]*+h[b+144>>3];i=i;return}function ug(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7952>>3]=+h[b+7936>>3]+ +h[b+7928>>3];i=i;return}function vg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2360>>3]=-(+h[(c[a+416>>2]|0)+10056>>3]*+h[b+7952>>3]);i=i;return}function wg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=+h[b+144>>3];i=i;return}function xg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7808>>3]=+h[b+9616>>3]*+h[b+136>>3];i=i;return}function yg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7800>>3]=+h[b+7808>>3]*+h[b+136>>3];i=i;return}function zg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9568>>3];k=+h[g+128>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+7720|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+7720|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,952,944,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7720|0;p=o;h[p>>3]=m;i=d;return}function Ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7704>>3]=+h[b+128>>3]*+h[b+7720>>3];i=i;return}function Bg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7816>>3]=+h[b+7720>>3]- +h[b+136>>3];i=i;return}function Cg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7728>>3]=+h[b+9576>>3]*+h[b+7720>>3];i=i;return}function Dg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7824>>3]=-+h[b+7728>>3]- +h[b+128>>3];i=i;return}function Eg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7600>>3]=+h[b+7824>>3]- +h[b+7808>>3];i=i;return}function Fg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7712>>3]=+h[b+7728>>3]*+h[b+7720>>3];i=i;return}function Gg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7648>>3]=+h[(c[a+416>>2]|0)+10528>>3]*+h[b+136>>3];i=i;return}function Hg(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,14)|0;d=c[(c[a+476>>2]|0)+924>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7672>>3]=+h[d>>3];h[e+7688>>3]=+h[d+8>>3];h[e+7696>>3]=+h[d+16>>3];i=b;return}function Ig(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7664>>3]=+h[b+7672>>3]*+h[b+7688>>3];i=i;return}function Jg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7680>>3]=+h[b+7696>>3]*+h[b+7688>>3];i=i;return}function Kg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7640>>3]=+h[(c[a+416>>2]|0)+10552>>3]*+h[b+136>>3];i=i;return}function Lg(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7528>>3]=+h[b+10760>>3]*(+h[d+104>>3]- +h[b+10776>>3]);i=i;return}function Mg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7520>>3]=+h[(c[a+416>>2]|0)+10768>>3]*+h[b+96>>3];i=i;return}function Ng(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7536>>3]=+h[b+7520>>3]*+h[b+96>>3];i=i;return}function Og(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7544>>3]=+h[b+7528>>3]+ +h[b+7520>>3];i=i;return}function Pg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2368>>3]=-(+h[(c[a+416>>2]|0)+10744>>3]*+h[b+7544>>3]);i=i;return}function Qg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+392>>3]=+h[b+96>>3];i=i;return}function Rg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7400>>3]=+h[b+9536>>3]*+h[b+80>>3];i=i;return}function Sg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7392>>3]=+h[b+7400>>3]*+h[b+80>>3];i=i;return}function Tg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9488>>3];k=+h[g+72>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+7312|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+7312|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,992,984,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7312|0;p=o;h[p>>3]=m;i=d;return}function Ug(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7296>>3]=+h[b+72>>3]*+h[b+7312>>3];i=i;return}function Vg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7408>>3]=+h[b+7312>>3]- +h[b+80>>3];i=i;return}function Wg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7320>>3]=+h[b+9496>>3]*+h[b+7312>>3];i=i;return}function Xg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7416>>3]=-+h[b+7320>>3]- +h[b+72>>3];i=i;return}function Yg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7176>>3]=+h[b+7416>>3]- +h[b+7400>>3];i=i;return}function Zg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7304>>3]=+h[b+7320>>3]*+h[b+7312>>3];i=i;return}function _g(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7232>>3]=+h[(c[a+416>>2]|0)+11200>>3]*+h[b+80>>3];i=i;return}function $g(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,15)|0;d=c[(c[a+476>>2]|0)+988>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7264>>3]=+h[d>>3];h[e+7280>>3]=+h[d+8>>3];h[e+7288>>3]=+h[d+16>>3];i=b;return}function ah(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7256>>3]=+h[b+7264>>3]*+h[b+7280>>3];i=i;return}function bh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7272>>3]=+h[b+7288>>3]*+h[b+7280>>3];i=i;return}function ch(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7224>>3]=+h[(c[a+416>>2]|0)+11224>>3]*+h[b+80>>3];i=i;return}function dh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7016>>3]=+h[b+9456>>3]*+h[b+48>>3];i=i;return}function eh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7008>>3]=+h[b+7016>>3]*+h[b+48>>3];i=i;return}function fh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9408>>3];k=+h[g+40>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6928|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6928|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,1032,1024,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6928|0;p=o;h[p>>3]=m;i=d;return}function gh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6912>>3]=+h[b+40>>3]*+h[b+6928>>3];i=i;return}function hh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7024>>3]=+h[b+6928>>3]- +h[b+48>>3];i=i;return}function ih(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6936>>3]=+h[b+9416>>3]*+h[b+6928>>3];i=i;return}function jh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7032>>3]=-+h[b+6936>>3]- +h[b+40>>3];i=i;return}function kh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6792>>3]=+h[b+7032>>3]- +h[b+7016>>3];i=i;return}function lh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6920>>3]=+h[b+6936>>3]*+h[b+6928>>3];i=i;return}function mh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6848>>3]=+h[(c[a+416>>2]|0)+11824>>3]*+h[b+48>>3];i=i;return}function nh(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,16)|0;d=c[(c[a+476>>2]|0)+1052>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6880>>3]=+h[d>>3];h[e+6896>>3]=+h[d+8>>3];h[e+6904>>3]=+h[d+16>>3];i=b;return}function oh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6872>>3]=+h[b+6880>>3]*+h[b+6896>>3];i=i;return}function ph(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6888>>3]=+h[b+6904>>3]*+h[b+6896>>3];i=i;return}function qh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6840>>3]=+h[(c[a+416>>2]|0)+11848>>3]*+h[b+48>>3];i=i;return}function rh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6632>>3]=+h[b+9376>>3]*+h[b+16>>3];i=i;return}function sh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6624>>3]=+h[b+6632>>3]*+h[b+16>>3];i=i;return}function th(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9328>>3];k=+h[g+8>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6544|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6544|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,1072,1064,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6544|0;p=o;h[p>>3]=m;i=d;return}function uh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6528>>3]=+h[b+8>>3]*+h[b+6544>>3];i=i;return}function vh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6640>>3]=+h[b+6544>>3]- +h[b+16>>3];i=i;return}function wh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6552>>3]=+h[b+9336>>3]*+h[b+6544>>3];i=i;return}function xh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6648>>3]=-+h[b+6552>>3]- +h[b+8>>3];i=i;return}function yh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6408>>3]=+h[b+6648>>3]- +h[b+6632>>3];i=i;return}function zh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6536>>3]=+h[b+6552>>3]*+h[b+6544>>3];i=i;return}function Ah(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6464>>3]=+h[(c[a+416>>2]|0)+12448>>3]*+h[b+16>>3];i=i;return}function Bh(a){a=a|0;var b=0,d=0,e=0;b=i;sQa(a,17)|0;d=c[(c[a+476>>2]|0)+1116>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6496>>3]=+h[d>>3];h[e+6512>>3]=+h[d+8>>3];h[e+6520>>3]=+h[d+16>>3];i=b;return}function Ch(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6488>>3]=+h[b+6496>>3]*+h[b+6512>>3];i=i;return}function Dh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6504>>3]=+h[b+6520>>3]*+h[b+6512>>3];i=i;return}function Eh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6456>>3]=+h[(c[a+416>>2]|0)+12472>>3]*+h[b+16>>3];i=i;return}function Fh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7448>>3]=+h[b+88>>3];i=i;return}function Gh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7064>>3]=+h[b+56>>3];i=i;return}function Hh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6680>>3]=+h[b+24>>3];i=i;return}function Ih(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5920>>3]=+X(+(+h[b+24>>3]));i=i;return}function Jh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5904>>3]=+Y(+(+h[b+24>>3]));i=i;return}function Kh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5872>>3]=-+Y(+(+h[b+24>>3]));i=i;return}function Lh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5856>>3]=+X(+(+h[b+24>>3]));i=i;return}function Mh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5832>>3]=+X(+(+h[b+56>>3]));i=i;return}function Nh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5824>>3]=-+Y(+(+h[b+56>>3]));i=i;return}function Oh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5808>>3]=+Y(+(+h[b+56>>3]));i=i;return}function Ph(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5800>>3]=+X(+(+h[b+56>>3]));i=i;return}function Qh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5744>>3]=+X(+(+h[b+88>>3]));i=i;return}function Rh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5728>>3]=+Y(+(+h[b+88>>3]));i=i;return}function Sh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5696>>3]=-+Y(+(+h[b+88>>3]));i=i;return}function Th(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5680>>3]=+X(+(+h[b+88>>3]));i=i;return}function Uh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1608>>3]=+h[b+272>>3]+ +h[b+264>>3];i=i;return}function Vh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+312>>3]=+h[b+240>>3];i=i;return}function Wh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6424>>3]=+h[(c[a+416>>2]|0)+12648>>3]*+h[b+312>>3];i=i;return}function Xh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6440>>3]=+h[(c[a+416>>2]|0)+12472>>3]*+h[b+6424>>3];i=i;return}function Yh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6416>>3]=+h[b+6408>>3]- +h[b+6440>>3];i=i;return}function Zh(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+12488>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6416>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+304|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+304|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1112,1104,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+304|0;p=o;h[p>>3]=m;i=d;return}function _h(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6320>>3]=+h[b+312>>3];i=i;return}function $h(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+24>>3]));h[b+2856>>3]=-(d*+h[b+312>>3]);i=i;return}function ai(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+24>>3]));h[b+2848>>3]=d*+h[b+312>>3];i=i;return}function bi(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+24>>3]));h[b+2840>>3]=-(d*+h[b+312>>3]);i=i;return}function ci(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+24>>3]));h[b+2832>>3]=-(d*+h[b+312>>3]);i=i;return}function di(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+344>>3]=+h[b+248>>3];i=i;return}function ei(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6808>>3]=+h[(c[a+416>>2]|0)+12024>>3]*+h[b+344>>3];i=i;return}function fi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6824>>3]=+h[(c[a+416>>2]|0)+11848>>3]*+h[b+6808>>3];i=i;return}function gi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6800>>3]=+h[b+6792>>3]- +h[b+6824>>3];i=i;return}function hi(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+11864>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6800>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+336|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+336|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1144,1136,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+336|0;p=o;h[p>>3]=m;i=d;return}function ii(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6704>>3]=+h[b+344>>3];i=i;return}function ji(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+56>>3]));h[b+2824>>3]=-(d*+h[b+344>>3]);i=i;return}function ki(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+56>>3]));h[b+2816>>3]=-(d*+h[b+344>>3]);i=i;return}function li(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+56>>3]));h[b+2808>>3]=d*+h[b+344>>3];i=i;return}function mi(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+56>>3]));h[b+2800>>3]=-(d*+h[b+344>>3]);i=i;return}function ni(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+376>>3]=+h[b+256>>3];i=i;return}function oi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7192>>3]=+h[(c[a+416>>2]|0)+11400>>3]*+h[b+376>>3];i=i;return}function pi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7208>>3]=+h[(c[a+416>>2]|0)+11224>>3]*+h[b+7192>>3];i=i;return}function qi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7184>>3]=+h[b+7176>>3]- +h[b+7208>>3];i=i;return}function ri(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+11240>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7184>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+368|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+368|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1176,1168,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+368|0;p=o;h[p>>3]=m;i=d;return}function si(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7088>>3]=+h[b+376>>3];i=i;return}function ti(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+88>>3]));h[b+2792>>3]=-(d*+h[b+376>>3]);i=i;return}function ui(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+88>>3]));h[b+2784>>3]=d*+h[b+376>>3];i=i;return}function vi(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+88>>3]));h[b+2776>>3]=-(d*+h[b+376>>3]);i=i;return}function wi(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+88>>3]));h[b+2768>>3]=-(d*+h[b+376>>3]);i=i;return}function xi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8792>>3]=+h[b+264>>3];i=i;return}function yi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+400>>3]=+h[(c[a+416>>2]|0)+10744>>3]*+h[b+8792>>3];i=i;return}function zi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+524>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7616>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7616|0;h[c[g+528>>2]>>3]=+h[j>>3];k=+EQa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7616>>3]);h[c[(c[f>>2]|0)+532>>2]>>3]=k;CQa(a,6)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+7616>>3]=+h[c[(c[f>>2]|0)+524>>2]>>3];i=b;return}function Ai(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7632>>3]=+h[(c[a+416>>2]|0)+10552>>3]*+h[b+7616>>3];i=i;return}function Bi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7608>>3]=+h[b+7600>>3]- +h[b+7632>>3];i=i;return}function Ci(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+10568>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7608>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+424|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+424|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1208,1200,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+424|0;p=o;h[p>>3]=m;i=d;return}function Di(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+604>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7504>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7504|0;h[c[g+608>>2]>>3]=+h[j>>3];k=+EQa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7504>>3]);h[c[(c[f>>2]|0)+612>>2]>>3]=k;CQa(a,7)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+7504>>3]=+h[c[(c[f>>2]|0)+604>>2]>>3];jq(a);kq(a);lq(a);mq(a);nq(a);oq(a);i=b;return}function Ei(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+7|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+7|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=k;f=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+7|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;a[(c[b+352>>2]|0)+7|0]=j;f=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;a[(c[b+352>>2]|0)+7|0]=g;f=g;break}}}}while(0);g=b+404|0;do{if(((c[(c[g>>2]|0)+408>>2]|0)+ -1|0)>>>0<2){if(f<<24>>24==0){break}else{l=1}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+408|0;x=w;c[x>>2]=l;i=d;return}else{if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+12|0]|0)!=0&f<<24>>24!=0){l=1}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+408|0;x=w;c[x>>2]=l;i=d;return}}while(0);do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+3|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){j=a[(c[b+356>>2]|0)+3|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;y=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=j;y=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+3|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=j;y=f;break}else{f=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=f;y=f;break}}}}while(0);e=c[(c[g>>2]|0)+408>>2]|0;do{if(!((e|0)==2|(e|0)==-1)){if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+11|0]|0)==0){l=0}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+408|0;x=w;c[x>>2]=l;i=d;return}}while(0);l=(y<<24>>24!=0)<<31>>31;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+408|0;x=w;c[x>>2]=l;i=d;return}function Fi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7496>>3]=+h[b+7480>>3]*+h[b+7616>>3];i=i;return}function Gi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8800>>3]=+h[b+272>>3];i=i;return}function Hi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+448>>3]=+h[(c[a+416>>2]|0)+10056>>3]*+h[b+8800>>3];i=i;return}function Ii(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+684>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+8024>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+8024|0;h[c[g+688>>2]>>3]=+h[j>>3];k=+EQa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+8024>>3]);h[c[(c[f>>2]|0)+692>>2]>>3]=k;CQa(a,8)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8024>>3]=+h[c[(c[f>>2]|0)+684>>2]>>3];i=b;return}function Ji(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8040>>3]=+h[(c[a+416>>2]|0)+9864>>3]*+h[b+8024>>3];i=i;return}function Ki(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8016>>3]=+h[b+8008>>3]- +h[b+8040>>3];i=i;return}function Li(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+9880>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+8016>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+472|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+472|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1240,1232,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+472|0;p=o;h[p>>3]=m;i=d;return}function Mi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+764>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7912>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7912|0;h[c[g+768>>2]>>3]=+h[j>>3];k=+EQa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7912>>3]);h[c[(c[f>>2]|0)+772>>2]>>3]=k;CQa(a,9)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+7912>>3]=+h[c[(c[f>>2]|0)+764>>2]>>3];tq(a);uq(a);vq(a);wq(a);xq(a);yq(a);i=b;return}function Ni(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+15|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+15|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=k;f=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+15|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0;a[(c[b+352>>2]|0)+15|0]=j;f=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0;a[(c[b+352>>2]|0)+15|0]=g;f=g;break}}}}while(0);g=b+404|0;do{if(((c[(c[g>>2]|0)+412>>2]|0)+ -1|0)>>>0<2){if(f<<24>>24==0){break}else{l=1}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+412|0;x=w;c[x>>2]=l;i=d;return}else{if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+15|0]|0)!=0&f<<24>>24!=0){l=1}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+412|0;x=w;c[x>>2]=l;i=d;return}}while(0);do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+11|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){j=a[(c[b+356>>2]|0)+11|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=k;y=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=j;y=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+11|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0;a[(c[b+352>>2]|0)+11|0]=j;y=f;break}else{f=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0;a[(c[b+352>>2]|0)+11|0]=f;y=f;break}}}}while(0);e=c[(c[g>>2]|0)+412>>2]|0;do{if(!((e|0)==2|(e|0)==-1)){if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+14|0]|0)==0){l=0}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+412|0;x=w;c[x>>2]=l;i=d;return}}while(0);l=(y<<24>>24!=0)<<31>>31;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+412|0;x=w;c[x>>2]=l;i=d;return}function Oi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7904>>3]=+h[b+7888>>3]*+h[b+8024>>3];i=i;return}function Pi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8808>>3]=+h[b+280>>3];i=i;return}function Qi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+496>>3]=+h[(c[a+416>>2]|0)+9368>>3]*+h[b+8808>>3];i=i;return}function Ri(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+844>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+8432>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+8432|0;h[c[g+848>>2]>>3]=+h[j>>3];k=+EQa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+8432>>3]);h[c[(c[f>>2]|0)+852>>2]>>3]=k;CQa(a,10)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8432>>3]=+h[c[(c[f>>2]|0)+844>>2]>>3];i=b;return}function Si(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8448>>3]=+h[(c[a+416>>2]|0)+9176>>3]*+h[b+8432>>3];i=i;return}function Ti(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8424>>3]=+h[b+8416>>3]- +h[b+8448>>3];i=i;return}function Ui(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+9192>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+8424>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+520|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+520|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1272,1264,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+520|0;p=o;h[p>>3]=m;i=d;return}function Vi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+924>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+8320>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+8320|0;h[c[g+928>>2]>>3]=+h[j>>3];k=+EQa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+8320>>3]);h[c[(c[f>>2]|0)+932>>2]>>3]=k;CQa(a,11)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8320>>3]=+h[c[(c[f>>2]|0)+924>>2]>>3];Dq(a);Eq(a);Fq(a);Gq(a);Hq(a);Iq(a);i=b;return}function Wi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8312>>3]=+h[b+8296>>3]*+h[b+8432>>3];i=i;return}function Xi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+23|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+23|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[b+360>>2]|0)+23|0]|0)|0;a[(c[b+352>>2]|0)+23|0]=k;f=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[b+360>>2]|0)+23|0]|0)|0;a[(c[b+352>>2]|0)+23|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+23|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0)|0;a[(c[b+352>>2]|0)+23|0]=j;f=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0)|0;a[(c[b+352>>2]|0)+23|0]=g;f=g;break}}}}while(0);g=b+404|0;do{if(((c[(c[g>>2]|0)+416>>2]|0)+ -1|0)>>>0<2){if(f<<24>>24==0){break}else{l=1}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+416|0;x=w;c[x>>2]=l;i=d;return}else{if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+18|0]|0)!=0&f<<24>>24!=0){l=1}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+416|0;x=w;c[x>>2]=l;i=d;return}}while(0);do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+19|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){j=a[(c[b+356>>2]|0)+19|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[b+360>>2]|0)+19|0]|0)|0;a[(c[b+352>>2]|0)+19|0]=k;y=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[b+360>>2]|0)+19|0]|0)|0;a[(c[b+352>>2]|0)+19|0]=j;y=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+19|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0)|0;a[(c[b+352>>2]|0)+19|0]=j;y=f;break}else{f=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0)|0;a[(c[b+352>>2]|0)+19|0]=f;y=f;break}}}}while(0);e=c[(c[g>>2]|0)+416>>2]|0;do{if(!((e|0)==2|(e|0)==-1)){if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+17|0]|0)==0){l=0}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+416|0;x=w;c[x>>2]=l;i=d;return}}while(0);l=(y<<24>>24!=0)<<31>>31;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+416|0;x=w;c[x>>2]=l;i=d;return}function Yi(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+9368>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+208>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+8672|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8672|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1304,1296,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8672|0;p=o;h[p>>3]=m;i=d;return}function Zi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5376>>3]=+X(+(+h[b+8672>>3]));i=i;return}function _i(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5392>>3]=-+Y(+(+h[b+8672>>3]));i=i;return}function $i(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5424>>3]=+Y(+(+h[b+8672>>3]));i=i;return}function aj(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3144>>3]=+h[b+648>>3]+(+h[d+5376>>3]*+h[b+1280>>3]+ +h[d+5424>>3]*+h[b+1296>>3]);i=i;return}function bj(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+280>>3];e=c[a+416>>2]|0;h[b+3080>>3]=+h[b+5376>>3]*d*+h[e+1296>>3]- +h[b+5424>>3]*d*+h[e+1280>>3];i=i;return}function cj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5440>>3]=+X(+(+h[b+8672>>3]));i=i;return}function dj(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3160>>3]=+h[b+664>>3]+(+h[d+5392>>3]*+h[b+1280>>3]+ +h[d+5440>>3]*+h[b+1296>>3]);i=i;return}function ej(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+280>>3];e=c[a+416>>2]|0;h[b+3096>>3]=+h[b+5392>>3]*d*+h[e+1296>>3]- +h[b+5440>>3]*d*+h[e+1280>>3];i=i;return}function fj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+8672>>3]));h[b+2472>>3]=-(d*+h[b+8808>>3]);i=i;return}function gj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+8672>>3]));h[b+2464>>3]=d*+h[b+8808>>3];i=i;return}function hj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+8672>>3]));h[b+2456>>3]=-(d*+h[b+8808>>3]);i=i;return}function ij(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+8672>>3]));h[b+2448>>3]=-(d*+h[b+8808>>3]);i=i;return}function jj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8304>>3]=+h[b+208>>3]- +h[b+200>>3];i=i;return}function kj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8440>>3]=+h[b+8304>>3]- +h[(c[a+416>>2]|0)+9184>>3];i=i;return}function lj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8392>>3]=+h[b+8408>>3]- +h[b+8304>>3];i=i;return}function mj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8384>>3]=+h[(c[a+416>>2]|0)+9264>>3]*+h[b+8392>>3];i=i;return}function nj(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8376>>3]=+h[b+9240>>3]*+h[d+8400>>3]+(+h[b+9248>>3]*+h[d+8384>>3]+ +h[b+9256>>3]*+h[d+8432>>3]);i=i;return}function oj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+9280>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+8376>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+504|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+504|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1336,1328,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+504|0;p=o;h[p>>3]=m;i=d;return}function pj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8688>>3]=+h[(c[a+416>>2]|0)+9272>>3]*(+h[b+216>>3]+ +h[b+8376>>3]);i=i;return}function qj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8656>>3]=+h[(c[a+416>>2]|0)+9160>>3]*+h[b+8688>>3];i=i;return}function rj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8608>>3]=+h[b+8656>>3]- +h[b+8512>>3];i=i;return}function sj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9768>>3];k=+h[g+8608>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8576|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8576|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,1368,1360,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8576|0;p=o;h[p>>3]=m;i=d;return}function tj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8584>>3]=+h[b+9752>>3]*+h[b+8576>>3];i=i;return}function uj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8560>>3]=+h[b+8512>>3]- +h[b+8584>>3];i=i;return}function vj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9744>>3];k=+h[g+8560>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8592|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8592|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,1408,1400,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8592|0;p=o;h[p>>3]=m;i=d;return}function wj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+9200>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+8592>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+512|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+512|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1440,1432,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+512|0;p=o;h[p>>3]=m;i=d;return}function xj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8552>>3]=+h[b+8560>>3]*+h[b+8592>>3];i=i;return}function yj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8568>>3]=+h[b+8584>>3]*+h[b+8576>>3];i=i;return}function zj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8648>>3]=+h[b+8576>>3]- +h[b+8592>>3];i=i;return}function Aj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8472>>3]=+h[b+8592>>3]-(-+h[b+8648>>3]- +h[b+8632>>3]- +h[b+8504>>3]);i=i;return}function Bj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8600>>3]=+h[b+8608>>3]*+h[b+8576>>3];i=i;return}function Cj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+10056>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+160>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+8264|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+8264|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1464,1456,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8264|0;p=o;h[p>>3]=m;i=d;return}function Dj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2016>>3]=+X(+(+h[b+8264>>3]));i=i;return}function Ej(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1864>>3]=+h[b+2016>>3]*+h[b+280>>3];i=i;return}function Fj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5528>>3]=+Y(+(+h[b+8264>>3]));i=i;return}function Gj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2024>>3]=+h[b+5528>>3]*+h[b+5424>>3];i=i;return}function Hj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2008>>3]=+h[b+5528>>3]*+h[b+5440>>3];i=i;return}function Ij(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1992>>3]=-+Y(+(+h[b+8264>>3]));i=i;return}function Jj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1688>>3]=+h[b+3152>>3]+(+h[b+2016>>3]*+h[d+1920>>3]+ +h[b+1992>>3]*+h[d+1928>>3]);i=i;return}function Kj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1856>>3]=+h[b+1992>>3]*+h[b+280>>3];i=i;return}function Lj(a){a=a|0;var b=0,d=0,e=0.0,f=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+1912>>3];f=+h[b+272>>3];h[b+1760>>3]=+h[b+2016>>3]*(+h[b+1856>>3]*e-f*+h[d+1928>>3])+ +h[b+1992>>3]*(f*+h[d+1920>>3]-e*+h[b+1864>>3]);i=i;return}function Mj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5520>>3]=+X(+(+h[b+8264>>3]));i=i;return}function Nj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2e3>>3]=+h[b+5520>>3]*+h[b+5424>>3];i=i;return}function Oj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1680>>3]=+h[b+3144>>3]+(+h[b+5376>>3]*+h[d+1912>>3]+(+h[b+2024>>3]*+h[d+1920>>3]+ +h[b+2e3>>3]*+h[d+1928>>3]));i=i;return}function Pj(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1864>>3];e=c[a+416>>2]|0;f=+h[e+1928>>3];g=+h[b+1856>>3];j=+h[e+1920>>3];k=+h[e+1912>>3];l=+h[b+272>>3];h[b+1752>>3]=+h[b+3080>>3]+(+h[b+5376>>3]*(d*f-g*j)+(+h[b+2024>>3]*(g*k-f*l)+ +h[b+2e3>>3]*(j*l-d*k)));i=i;return}function Qj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1984>>3]=+h[b+5520>>3]*+h[b+5440>>3];i=i;return}function Rj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1696>>3]=+h[b+3160>>3]+(+h[b+5392>>3]*+h[d+1912>>3]+(+h[b+2008>>3]*+h[d+1920>>3]+ +h[b+1984>>3]*+h[d+1928>>3]));i=i;return}function Sj(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1864>>3];e=c[a+416>>2]|0;f=+h[e+1928>>3];g=+h[b+1856>>3];j=+h[e+1920>>3];k=+h[e+1912>>3];l=+h[b+272>>3];h[b+1768>>3]=+h[b+3096>>3]+(+h[b+5392>>3]*(d*f-g*j)+(+h[b+2008>>3]*(g*k-f*l)+ +h[b+1984>>3]*(j*l-d*k)));i=i;return}function Tj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+8264>>3]));h[b+2728>>3]=-(d*+h[b+8800>>3]);i=i;return}function Uj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2520>>3]=+h[b+5520>>3]*+h[b+2472>>3]+ +h[b+2728>>3]*+h[b+5440>>3];i=i;return}function Vj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2504>>3]=+h[b+5520>>3]*+h[b+2464>>3]+ +h[b+2728>>3]*+h[b+5424>>3];i=i;return}function Wj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+8264>>3]));h[b+2512>>3]=-(d*+h[b+8800>>3]);i=i;return}function Xj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+8264>>3]));h[b+2720>>3]=d*+h[b+8800>>3];i=i;return}function Yj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2496>>3]=+h[b+5528>>3]*+h[b+2472>>3]+ +h[b+2720>>3]*+h[b+5440>>3];i=i;return}function Zj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2480>>3]=+h[b+5528>>3]*+h[b+2464>>3]+ +h[b+2720>>3]*+h[b+5424>>3];i=i;return}function _j(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+8264>>3]));h[b+2488>>3]=-(d*+h[b+8800>>3]);i=i;return}function $j(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7896>>3]=+h[b+160>>3]- +h[b+152>>3];i=i;return}function ak(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8032>>3]=+h[b+7896>>3]- +h[(c[a+416>>2]|0)+9872>>3];i=i;return}function bk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7984>>3]=+h[b+8e3>>3]- +h[b+7896>>3];i=i;return}function ck(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7976>>3]=+h[(c[a+416>>2]|0)+9952>>3]*+h[b+7984>>3];i=i;return}function dk(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7968>>3]=+h[b+9928>>3]*+h[d+7992>>3]+(+h[b+9936>>3]*+h[d+7976>>3]+ +h[b+9944>>3]*+h[d+8024>>3]);i=i;return}function ek(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+9968>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7968>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+456|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+456|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1496,1488,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+456|0;p=o;h[p>>3]=m;i=d;return}function fk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8280>>3]=+h[(c[a+416>>2]|0)+9960>>3]*(+h[b+168>>3]+ +h[b+7968>>3]);i=i;return}function gk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8248>>3]=+h[(c[a+416>>2]|0)+9848>>3]*+h[b+8280>>3];i=i;return}function hk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8200>>3]=+h[b+8248>>3]- +h[b+8104>>3];i=i;return}



function rF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0;d=i;i=i+72|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;k=d+64|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=b+4|0;ba=c[c[aa>>2]>>2]|0;ca=c[ba+16>>2]|0;if((a[ca+7|0]|0)!=0){da=+h[(c[ba+8>>2]|0)+7112>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7096|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+9|0]|0)!=0){ba=b+416|0;RNa(+h[(c[ba>>2]|0)+6352>>3],2,x);RNa(+h[(c[ba>>2]|0)+6360>>3],2,y);RNa(+h[(c[ba>>2]|0)+6368>>3],2,A);RNa(+h[(c[ba>>2]|0)+6376>>3],2,B);c[v>>2]=y;QNa(2,w,2,x,v);c[u>>2]=B;QNa(2,z,2,A,u);c[t>>2]=z;QNa(1,C,2,w,t);t=c[b+536>>2]|0;na=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+7088>>3];w=j;z=C;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];Bp(Y,t,na,j,2);da=+h[Y>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7096|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+8|0]|0)!=0){ca=b+416|0;RNa(+h[(c[ca>>2]|0)+6352>>3],2,E);RNa(+h[(c[ca>>2]|0)+6360>>3],2,F);RNa(+h[(c[ca>>2]|0)+6368>>3],2,H);RNa(+h[(c[ca>>2]|0)+6376>>3],2,I);c[s>>2]=F;QNa(2,D,2,E,s);c[r>>2]=I;QNa(2,G,2,H,r);c[q>>2]=G;QNa(1,J,2,D,q);q=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+7088>>3];D=g;G=J;c[D+0>>2]=c[G+0>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2];Bp(Z,q,na,g,2);da=-+h[Z>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7096|0;ma=la;h[ma>>3]=da;i=d;return}Z=b+416|0;na=+h[(c[Z>>2]|0)+6352>>3];if((c[(c[b+404>>2]|0)+404>>2]|0)==1){RNa(na,2,L);RNa(+h[(c[Z>>2]|0)+6360>>3],2,M);RNa(+h[(c[Z>>2]|0)+6368>>3],2,O);RNa(+h[(c[Z>>2]|0)+6376>>3],2,P);c[p>>2]=M;QNa(2,K,2,L,p);c[o>>2]=P;QNa(2,N,2,O,o);c[n>>2]=N;QNa(1,Q,2,K,n);n=c[b+536>>2]|0;oa=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+7088>>3];K=f;N=Q;c[K+0>>2]=c[N+0>>2];c[K+4>>2]=c[N+4>>2];c[K+8>>2]=c[N+8>>2];Bp(_,n,oa,f,2);da=+h[_>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7096|0;ma=la;h[ma>>3]=da;i=d;return}else{RNa(na,2,S);RNa(+h[(c[Z>>2]|0)+6360>>3],2,T);RNa(+h[(c[Z>>2]|0)+6368>>3],2,V);RNa(+h[(c[Z>>2]|0)+6376>>3],2,W);c[m>>2]=T;QNa(2,R,2,S,m);c[l>>2]=W;QNa(2,U,2,V,l);c[k>>2]=U;QNa(1,X,2,R,k);k=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+7088>>3];b=e;R=X;c[b+0>>2]=c[R+0>>2];c[b+4>>2]=c[R+4>>2];c[b+8>>2]=c[R+8>>2];Bp($,k,na,e,2);da=-+h[$>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7096|0;ma=la;h[ma>>3]=da;i=d;return}}function sF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7104>>3]=+h[b+7096>>3]*+h[b+7088>>3];i=i;return}function tF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7192>>3]=+h[(c[a+416>>2]|0)+11400>>3]*+h[b+376>>3];i=i;return}function uF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7208>>3]=+h[(c[a+416>>2]|0)+11224>>3]*+h[b+7192>>3];i=i;return}function vF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7176>>3]=+h[b+7184>>3]+ +h[b+7208>>3];i=i;return}function wF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+256>>3]=+h[b+376>>3];i=i;return}function xF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7448>>3]=+h[b+7456>>3];i=i;return}function yF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+88>>3]=+h[b+7448>>3];i=i;return}function zF(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+88>>3]));h[b+2768>>3]=-(d*+h[b+376>>3]);i=i;return}function AF(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+88>>3]));h[b+2776>>3]=-(d*+h[b+376>>3]);i=i;return}function BF(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+88>>3]));h[b+2784>>3]=d*+h[b+376>>3];i=i;return}function CF(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+88>>3]));h[b+2792>>3]=-(d*+h[b+376>>3]);i=i;return}function DF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5744>>3]=+X(+(+h[b+88>>3]));i=i;return}function EF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5728>>3]=+Y(+(+h[b+88>>3]));i=i;return}function FF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5696>>3]=-+Y(+(+h[b+88>>3]));i=i;return}function GF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5680>>3]=+X(+(+h[b+88>>3]));i=i;return}function HF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7240>>3]=+h[(c[a+416>>2]|0)+11400>>3]*+h[b+88>>3];i=i;return}function IF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7152>>3]=+h[b+7168>>3]- +h[b+7240>>3];i=i;return}function JF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7144>>3]=+h[(c[a+416>>2]|0)+11312>>3]*+h[b+7152>>3];i=i;return}function KF(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7136>>3]=+h[b+11288>>3]*+h[d+7160>>3]+(+h[b+11296>>3]*+h[d+7144>>3]+ +h[b+11304>>3]*+h[d+7192>>3]);i=i;return}function LF(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+11328>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7136>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+352|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+352|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,18128,18120,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+352|0;p=o;h[p>>3]=m;i=d;return}function MF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7200>>3]=+h[b+7240>>3]- +h[(c[a+416>>2]|0)+11232>>3];i=i;return}function NF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7472>>3]=0.0;i=i;return}function OF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+384>>3]=+h[b+7472>>3];i=i;return}function PF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+96>>3]=0.0;i=i;return}function QF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7520>>3]=+h[(c[a+416>>2]|0)+10768>>3]*+h[b+96>>3];i=i;return}function RF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7536>>3]=+h[b+7520>>3]*+h[b+96>>3];i=i;return}function SF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+392>>3]=+h[b+96>>3];i=i;return}function TF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+424>>3]=0.0;i=i;return}function UF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7608>>3]=+h[(c[a+416>>2]|0)+10568>>3]*+h[b+424>>3];i=i;return}function VF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+416>>3]=0.0;i=i;return}function WF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7776>>3]=+h[(c[a+416>>2]|0)+10576>>3]*+h[b+416>>3];i=i;return}function XF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7744>>3]=+h[b+9584>>3]*+h[b+7776>>3];i=i;return}function YF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7736>>3]=+h[b+7744>>3]*+h[b+7776>>3];i=i;return}function ZF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8760>>3]=+h[b+8840>>3];i=i;return}function _F(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8720>>3]=+h[(c[a+416>>2]|0)+10744>>3]*+h[b+8760>>3];i=i;return}function $F(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7512>>3]=+h[b+8720>>3]- +h[b+7472>>3];i=i;return}function aG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=+h[b+8760>>3];i=i;return}function bG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8792>>3]=+h[b+7848>>3];i=i;return}function cG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+400>>3]=+h[(c[a+416>>2]|0)+10744>>3]*+h[b+8792>>3];i=i;return}function dG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7616>>3]=+h[b+400>>3]- +h[b+96>>3];i=i;return}function eG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7504>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7504|0;h[c[g+288>>2]>>3]=+h[j>>3];k=+EQa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7504>>3]);h[c[(c[f>>2]|0)+292>>2]>>3]=k;CQa(a,3)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+7504>>3]=+h[c[(c[f>>2]|0)+284>>2]>>3];Up(a);Vp(a);Wp(a);i=b;return}function fG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+7|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+7|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=k;f=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+7|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;a[(c[b+352>>2]|0)+7|0]=j;f=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;a[(c[b+352>>2]|0)+7|0]=g;f=g;break}}}}while(0);g=b+404|0;do{if(((c[(c[g>>2]|0)+408>>2]|0)+ -1|0)>>>0<2){if(f<<24>>24==0){break}else{l=1}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+408|0;x=w;c[x>>2]=l;i=d;return}else{if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+12|0]|0)!=0&f<<24>>24!=0){l=1}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+408|0;x=w;c[x>>2]=l;i=d;return}}while(0);do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+3|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){j=a[(c[b+356>>2]|0)+3|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;y=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=j;y=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+3|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=j;y=f;break}else{f=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=f;y=f;break}}}}while(0);e=c[(c[g>>2]|0)+408>>2]|0;do{if(!((e|0)==2|(e|0)==-1)){if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+11|0]|0)==0){l=0}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+408|0;x=w;c[x>>2]=l;i=d;return}}while(0);l=(y<<24>>24!=0)<<31>>31;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+408|0;x=w;c[x>>2]=l;i=d;return}function gG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0;d=i;i=i+72|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;k=d+64|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=b+4|0;ba=c[c[aa>>2]>>2]|0;ca=c[ba+16>>2]|0;if((a[ca+10|0]|0)!=0){da=+h[(c[ba+8>>2]|0)+7504>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7480|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+12|0]|0)!=0){ba=b+416|0;RNa(+h[(c[ba>>2]|0)+6320>>3],2,x);RNa(+h[(c[ba>>2]|0)+6328>>3],2,y);RNa(+h[(c[ba>>2]|0)+6336>>3],2,A);RNa(+h[(c[ba>>2]|0)+6344>>3],2,B);c[v>>2]=y;QNa(2,w,2,x,v);c[u>>2]=B;QNa(2,z,2,A,u);c[t>>2]=z;QNa(1,C,2,w,t);t=c[b+536>>2]|0;na=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+7616>>3];w=j;z=C;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];Bp(Y,t,na,j,2);da=+h[Y>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7480|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+11|0]|0)!=0){ca=b+416|0;RNa(+h[(c[ca>>2]|0)+6320>>3],2,E);RNa(+h[(c[ca>>2]|0)+6328>>3],2,F);RNa(+h[(c[ca>>2]|0)+6336>>3],2,H);RNa(+h[(c[ca>>2]|0)+6344>>3],2,I);c[s>>2]=F;QNa(2,D,2,E,s);c[r>>2]=I;QNa(2,G,2,H,r);c[q>>2]=G;QNa(1,J,2,D,q);q=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+7616>>3];D=g;G=J;c[D+0>>2]=c[G+0>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2];Bp(Z,q,na,g,2);da=-+h[Z>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7480|0;ma=la;h[ma>>3]=da;i=d;return}Z=b+416|0;na=+h[(c[Z>>2]|0)+6320>>3];if((c[(c[b+404>>2]|0)+408>>2]|0)==1){RNa(na,2,L);RNa(+h[(c[Z>>2]|0)+6328>>3],2,M);RNa(+h[(c[Z>>2]|0)+6336>>3],2,O);RNa(+h[(c[Z>>2]|0)+6344>>3],2,P);c[p>>2]=M;QNa(2,K,2,L,p);c[o>>2]=P;QNa(2,N,2,O,o);c[n>>2]=N;QNa(1,Q,2,K,n);n=c[b+536>>2]|0;oa=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+7616>>3];K=f;N=Q;c[K+0>>2]=c[N+0>>2];c[K+4>>2]=c[N+4>>2];c[K+8>>2]=c[N+8>>2];Bp(_,n,oa,f,2);da=+h[_>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7480|0;ma=la;h[ma>>3]=da;i=d;return}else{RNa(na,2,S);RNa(+h[(c[Z>>2]|0)+6328>>3],2,T);RNa(+h[(c[Z>>2]|0)+6336>>3],2,V);RNa(+h[(c[Z>>2]|0)+6344>>3],2,W);c[m>>2]=T;QNa(2,R,2,S,m);c[l>>2]=W;QNa(2,U,2,V,l);c[k>>2]=U;QNa(1,X,2,R,k);k=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+7616>>3];b=e;R=X;c[b+0>>2]=c[R+0>>2];c[b+4>>2]=c[R+4>>2];c[b+8>>2]=c[R+8>>2];Bp($,k,na,e,2);da=-+h[$>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7480|0;ma=la;h[ma>>3]=da;i=d;return}}function hG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7496>>3]=+h[b+7480>>3]*+h[b+7616>>3];i=i;return}function iG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7632>>3]=+h[(c[a+416>>2]|0)+10552>>3]*+h[b+7616>>3];i=i;return}function jG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7600>>3]=+h[b+7608>>3]+ +h[b+7632>>3];i=i;return}function kG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+264>>3]=+h[b+8792>>3];i=i;return}function lG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7856>>3]=+h[b+7864>>3];i=i;return}function mG(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+7856>>3]));h[b+2736>>3]=-(d*+h[b+8792>>3]);i=i;return}function nG(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+7856>>3]));h[b+2744>>3]=d*+h[b+8792>>3];i=i;return}function oG(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+7856>>3]));h[b+2752>>3]=-(d*+h[b+8792>>3]);i=i;return}function pG(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+7856>>3]));h[b+2760>>3]=-(d*+h[b+8792>>3]);i=i;return}function qG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5656>>3]=+X(+(+h[b+7856>>3]));i=i;return}function rG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5648>>3]=-+Y(+(+h[b+7856>>3]));i=i;return}function sG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5632>>3]=+Y(+(+h[b+7856>>3]));i=i;return}function tG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5624>>3]=+X(+(+h[b+7856>>3]));i=i;return}function uG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=+h[(c[a+416>>2]|0)+10744>>3]*+h[b+7856>>3];i=i;return}function vG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7880>>3]=0.0;i=i;return}function wG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+432>>3]=+h[b+7880>>3];i=i;return}function xG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+144>>3]=0.0;i=i;return}function yG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7928>>3]=+h[(c[a+416>>2]|0)+10080>>3]*+h[b+144>>3];i=i;return}function zG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7944>>3]=+h[b+7928>>3]*+h[b+144>>3];i=i;return}function AG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=+h[b+144>>3];i=i;return}function BG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+472>>3]=0.0;i=i;return}function CG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8016>>3]=+h[(c[a+416>>2]|0)+9880>>3]*+h[b+472>>3];i=i;return}function DG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+464>>3]=0.0;i=i;return}function EG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8184>>3]=+h[(c[a+416>>2]|0)+9888>>3]*+h[b+464>>3];i=i;return}function FG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8152>>3]=+h[b+9664>>3]*+h[b+8184>>3];i=i;return}function GG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8144>>3]=+h[b+8152>>3]*+h[b+8184>>3];i=i;return}function HG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8752>>3]=+h[b+8848>>3];i=i;return}function IG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8728>>3]=+h[(c[a+416>>2]|0)+10056>>3]*+h[b+8752>>3];i=i;return}function JG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7920>>3]=+h[b+8728>>3]- +h[b+7880>>3];i=i;return}function KG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1584>>3]=+h[b+8752>>3]+ +h[b+8760>>3];i=i;return}function LG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+560>>3]=+h[b+8752>>3];i=i;return}function MG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8800>>3]=+h[b+8256>>3];i=i;return}function NG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+448>>3]=+h[(c[a+416>>2]|0)+10056>>3]*+h[b+8800>>3];i=i;return}function OG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8024>>3]=+h[b+448>>3]- +h[b+144>>3];i=i;return}function PG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+364>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7912>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7912|0;h[c[g+368>>2]>>3]=+h[j>>3];k=+EQa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7912>>3]);h[c[(c[f>>2]|0)+372>>2]>>3]=k;CQa(a,4)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+7912>>3]=+h[c[(c[f>>2]|0)+364>>2]>>3];Zp(a);_p(a);$p(a);i=b;return}function QG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+15|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+15|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=k;f=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+15|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0;a[(c[b+352>>2]|0)+15|0]=j;f=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0;a[(c[b+352>>2]|0)+15|0]=g;f=g;break}}}}while(0);g=b+404|0;do{if(((c[(c[g>>2]|0)+412>>2]|0)+ -1|0)>>>0<2){if(f<<24>>24==0){break}else{l=1}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+412|0;x=w;c[x>>2]=l;i=d;return}else{if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+15|0]|0)!=0&f<<24>>24!=0){l=1}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+412|0;x=w;c[x>>2]=l;i=d;return}}while(0);do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+11|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){j=a[(c[b+356>>2]|0)+11|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=k;y=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=j;y=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+11|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0;a[(c[b+352>>2]|0)+11|0]=j;y=f;break}else{f=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0;a[(c[b+352>>2]|0)+11|0]=f;y=f;break}}}}while(0);e=c[(c[g>>2]|0)+412>>2]|0;do{if(!((e|0)==2|(e|0)==-1)){if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+14|0]|0)==0){l=0}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+412|0;x=w;c[x>>2]=l;i=d;return}}while(0);l=(y<<24>>24!=0)<<31>>31;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+412|0;x=w;c[x>>2]=l;i=d;return}function RG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0;d=i;i=i+72|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;k=d+64|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=b+4|0;ba=c[c[aa>>2]>>2]|0;ca=c[ba+16>>2]|0;if((a[ca+13|0]|0)!=0){da=+h[(c[ba+8>>2]|0)+7912>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7888|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+15|0]|0)!=0){ba=b+416|0;RNa(+h[(c[ba>>2]|0)+6288>>3],2,x);RNa(+h[(c[ba>>2]|0)+6296>>3],2,y);RNa(+h[(c[ba>>2]|0)+6304>>3],2,A);RNa(+h[(c[ba>>2]|0)+6312>>3],2,B);c[v>>2]=y;QNa(2,w,2,x,v);c[u>>2]=B;QNa(2,z,2,A,u);c[t>>2]=z;QNa(1,C,2,w,t);t=c[b+536>>2]|0;na=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+8024>>3];w=j;z=C;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];Bp(Y,t,na,j,2);da=+h[Y>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7888|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+14|0]|0)!=0){ca=b+416|0;RNa(+h[(c[ca>>2]|0)+6288>>3],2,E);RNa(+h[(c[ca>>2]|0)+6296>>3],2,F);RNa(+h[(c[ca>>2]|0)+6304>>3],2,H);RNa(+h[(c[ca>>2]|0)+6312>>3],2,I);c[s>>2]=F;QNa(2,D,2,E,s);c[r>>2]=I;QNa(2,G,2,H,r);c[q>>2]=G;QNa(1,J,2,D,q);q=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+8024>>3];D=g;G=J;c[D+0>>2]=c[G+0>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2];Bp(Z,q,na,g,2);da=-+h[Z>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7888|0;ma=la;h[ma>>3]=da;i=d;return}Z=b+416|0;na=+h[(c[Z>>2]|0)+6288>>3];if((c[(c[b+404>>2]|0)+412>>2]|0)==1){RNa(na,2,L);RNa(+h[(c[Z>>2]|0)+6296>>3],2,M);RNa(+h[(c[Z>>2]|0)+6304>>3],2,O);RNa(+h[(c[Z>>2]|0)+6312>>3],2,P);c[p>>2]=M;QNa(2,K,2,L,p);c[o>>2]=P;QNa(2,N,2,O,o);c[n>>2]=N;QNa(1,Q,2,K,n);n=c[b+536>>2]|0;oa=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+8024>>3];K=f;N=Q;c[K+0>>2]=c[N+0>>2];c[K+4>>2]=c[N+4>>2];c[K+8>>2]=c[N+8>>2];Bp(_,n,oa,f,2);da=+h[_>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7888|0;ma=la;h[ma>>3]=da;i=d;return}else{RNa(na,2,S);RNa(+h[(c[Z>>2]|0)+6296>>3],2,T);RNa(+h[(c[Z>>2]|0)+6304>>3],2,V);RNa(+h[(c[Z>>2]|0)+6312>>3],2,W);c[m>>2]=T;QNa(2,R,2,S,m);c[l>>2]=W;QNa(2,U,2,V,l);c[k>>2]=U;QNa(1,X,2,R,k);k=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+8024>>3];b=e;R=X;c[b+0>>2]=c[R+0>>2];c[b+4>>2]=c[R+4>>2];c[b+8>>2]=c[R+8>>2];Bp($,k,na,e,2);da=-+h[$>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7888|0;ma=la;h[ma>>3]=da;i=d;return}}function SG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7904>>3]=+h[b+7888>>3]*+h[b+8024>>3];i=i;return}function TG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8040>>3]=+h[(c[a+416>>2]|0)+9864>>3]*+h[b+8024>>3];i=i;return}function UG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8008>>3]=+h[b+8016>>3]+ +h[b+8040>>3];i=i;return}function VG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+272>>3]=+h[b+8800>>3];i=i;return}function WG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1608>>3]=+h[b+272>>3]+ +h[b+264>>3];i=i;return}function XG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8264>>3]=+h[b+8272>>3];i=i;return}function YG(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+8264>>3]));h[b+2488>>3]=-(d*+h[b+8800>>3]);i=i;return}function ZG(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+8264>>3]));h[b+2720>>3]=d*+h[b+8800>>3];i=i;return}function _G(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+8264>>3]));h[b+2512>>3]=-(d*+h[b+8800>>3]);i=i;return}function $G(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+8264>>3]));h[b+2728>>3]=-(d*+h[b+8800>>3]);i=i;return}function aH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5520>>3]=+X(+(+h[b+8264>>3]));i=i;return}function bH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1992>>3]=-+Y(+(+h[b+8264>>3]));i=i;return}function cH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5528>>3]=+Y(+(+h[b+8264>>3]));i=i;return}function dH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2016>>3]=+X(+(+h[b+8264>>3]));i=i;return}function eH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2536>>3]=+h[b+5648>>3]*+h[b+2488>>3]+(+h[b+2752>>3]*+h[b+2016>>3]+(+h[b+5656>>3]*+h[b+2512>>3]+ +h[b+2760>>3]*+h[b+1992>>3]));i=i;return}function fH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2560>>3]=+h[b+5624>>3]*+h[b+2488>>3]+(+h[b+2736>>3]*+h[b+2016>>3]+(+h[b+5632>>3]*+h[b+2512>>3]+ +h[b+2744>>3]*+h[b+1992>>3]));i=i;return}function gH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1824>>3]=+h[b+5648>>3]*+h[b+2016>>3]+ +h[b+5656>>3]*+h[b+1992>>3];i=i;return}function hH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2584>>3]=+h[b+5744>>3]*+h[b+2536>>3]+ +h[b+2792>>3]*+h[b+1824>>3];i=i;return}function iH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2608>>3]=+h[b+5696>>3]*+h[b+2536>>3]+ +h[b+2776>>3]*+h[b+1824>>3];i=i;return}function jH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1544>>3]=+h[b+5744>>3]*+h[b+1824>>3];i=i;return}function kH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1288>>3]=+h[b+5696>>3]*+h[b+1824>>3];i=i;return}function lH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1568>>3]=+h[b+5624>>3]*+h[b+2016>>3]+ +h[b+5632>>3]*+h[b+1992>>3];i=i;return}function mH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2632>>3]=+h[b+5824>>3]*+h[b+2560>>3]+(+h[b+2816>>3]*+h[b+1568>>3]+(+h[b+5832>>3]*+h[b+2584>>3]+ +h[b+2824>>3]*+h[b+1544>>3]));i=i;return}function nH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2680>>3]=+h[b+5800>>3]*+h[b+2560>>3]+(+h[b+2800>>3]*+h[b+1568>>3]+(+h[b+5808>>3]*+h[b+2584>>3]+ +h[b+2808>>3]*+h[b+1544>>3]));i=i;return}function oH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1264>>3]=+h[b+5824>>3]*+h[b+1568>>3]+ +h[b+5832>>3]*+h[b+1544>>3];i=i;return}function pH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2704>>3]=+h[b+5904>>3]*+h[b+2608>>3]+(+h[b+2848>>3]*+h[b+1288>>3]+(+h[b+5920>>3]*+h[b+2632>>3]+ +h[b+2856>>3]*+h[b+1264>>3]));i=i;return}function qH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2656>>3]=+h[b+5856>>3]*+h[b+2608>>3]+(+h[b+2832>>3]*+h[b+1288>>3]+(+h[b+5872>>3]*+h[b+2632>>3]+ +h[b+2840>>3]*+h[b+1264>>3]));i=i;return}function rH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1008>>3]=+h[b+5904>>3]*+h[b+1288>>3]+ +h[b+5920>>3]*+h[b+1264>>3];i=i;return}function sH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+960>>3]=+h[b+5856>>3]*+h[b+1288>>3]+ +h[b+5872>>3]*+h[b+1264>>3];i=i;return}function tH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+984>>3]=+h[b+5800>>3]*+h[b+1568>>3]+ +h[b+5808>>3]*+h[b+1544>>3];i=i;return}function uH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1688>>3]=+h[b+3152>>3]+(+h[b+2016>>3]*+h[d+1920>>3]+ +h[b+1992>>3]*+h[d+1928>>3]);i=i;return}function vH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1408>>3]=+h[b+1688>>3]+(+h[b+1568>>3]*+h[d+2552>>3]+ +h[b+1824>>3]*+h[d+2560>>3]);i=i;return}function wH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1128>>3]=+h[b+1408>>3]+(+h[b+1288>>3]*+h[d+3176>>3]+(+h[b+1568>>3]*+h[d+3184>>3]+ +h[b+1544>>3]*+h[d+3192>>3]));i=i;return}function xH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+816>>3]=+h[b+1128>>3]+(+h[b+1288>>3]*+h[d+3808>>3]+(+h[b+984>>3]*+h[d+3816>>3]+ +h[b+1264>>3]*+h[d+3824>>3]));i=i;return}function yH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+648>>3]=+h[b+816>>3]+(+h[b+960>>3]*+h[d+4440>>3]+(+h[b+984>>3]*+h[d+4448>>3]+ +h[b+1008>>3]*+h[d+4456>>3]));i=i;return}function zH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+720>>3]=+h[b+648>>3]+(+h[b+960>>3]*+h[d+5072>>3]+(+h[b+984>>3]*+h[d+5080>>3]+ +h[b+1008>>3]*+h[d+5088>>3]));i=i;return}function AH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+160>>3]=+h[(c[a+416>>2]|0)+10056>>3]*+h[b+8264>>3];i=i;return}function BH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8288>>3]=0.0;i=i;return}function CH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+480>>3]=+h[b+8288>>3];i=i;return}function DH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+192>>3]=0.0;i=i;return}function EH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8336>>3]=+h[(c[a+416>>2]|0)+9392>>3]*+h[b+192>>3];i=i;return}function FH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8352>>3]=+h[b+8336>>3]*+h[b+192>>3];i=i;return}function GH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+488>>3]=+h[b+192>>3];i=i;return}function HH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+520>>3]=0.0;i=i;return}function IH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8424>>3]=+h[(c[a+416>>2]|0)+9192>>3]*+h[b+520>>3];i=i;return}function JH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+512>>3]=0.0;i=i;return}function KH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8592>>3]=+h[(c[a+416>>2]|0)+9200>>3]*+h[b+512>>3];i=i;return}function LH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8560>>3]=+h[b+9744>>3]*+h[b+8592>>3];i=i;return}function MH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8552>>3]=+h[b+8560>>3]*+h[b+8592>>3];i=i;return}function NH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8744>>3]=+h[b+8856>>3];i=i;return}function OH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8736>>3]=+h[(c[a+416>>2]|0)+9368>>3]*+h[b+8744>>3];i=i;return}function PH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8328>>3]=+h[b+8736>>3]- +h[b+8288>>3];i=i;return}function QH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+568>>3]=+h[b+8744>>3];i=i;return}function RH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8808>>3]=+h[b+8664>>3];i=i;return}function SH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+496>>3]=+h[(c[a+416>>2]|0)+9368>>3]*+h[b+8808>>3];i=i;return}function TH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8432>>3]=+h[b+496>>3]- +h[b+192>>3];i=i;return}function UH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+444>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+8320>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+8320|0;h[c[g+448>>2]>>3]=+h[j>>3];k=+EQa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+8320>>3]);h[c[(c[f>>2]|0)+452>>2]>>3]=k;CQa(a,5)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8320>>3]=+h[c[(c[f>>2]|0)+444>>2]>>3];cq(a);dq(a);eq(a);i=b;return}function VH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+23|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+23|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[b+360>>2]|0)+23|0]|0)|0;a[(c[b+352>>2]|0)+23|0]=k;f=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[b+360>>2]|0)+23|0]|0)|0;a[(c[b+352>>2]|0)+23|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+23|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0)|0;a[(c[b+352>>2]|0)+23|0]=j;f=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0)|0;a[(c[b+352>>2]|0)+23|0]=g;f=g;break}}}}while(0);g=b+404|0;do{if(((c[(c[g>>2]|0)+416>>2]|0)+ -1|0)>>>0<2){if(f<<24>>24==0){break}else{l=1}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+416|0;x=w;c[x>>2]=l;i=d;return}else{if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+18|0]|0)!=0&f<<24>>24!=0){l=1}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+416|0;x=w;c[x>>2]=l;i=d;return}}while(0);do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+19|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){j=a[(c[b+356>>2]|0)+19|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[b+360>>2]|0)+19|0]|0)|0;a[(c[b+352>>2]|0)+19|0]=k;y=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[b+360>>2]|0)+19|0]|0)|0;a[(c[b+352>>2]|0)+19|0]=j;y=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+19|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0)|0;a[(c[b+352>>2]|0)+19|0]=j;y=f;break}else{f=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0)|0;a[(c[b+352>>2]|0)+19|0]=f;y=f;break}}}}while(0);e=c[(c[g>>2]|0)+416>>2]|0;do{if(!((e|0)==2|(e|0)==-1)){if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+17|0]|0)==0){l=0}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+416|0;x=w;c[x>>2]=l;i=d;return}}while(0);l=(y<<24>>24!=0)<<31>>31;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+416|0;x=w;c[x>>2]=l;i=d;return}function WH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0;d=i;i=i+72|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;k=d+64|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=b+4|0;ba=c[c[aa>>2]>>2]|0;ca=c[ba+16>>2]|0;if((a[ca+16|0]|0)!=0){da=+h[(c[ba+8>>2]|0)+8320>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+8296|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+18|0]|0)!=0){ba=b+416|0;RNa(+h[(c[ba>>2]|0)+6256>>3],2,x);RNa(+h[(c[ba>>2]|0)+6264>>3],2,y);RNa(+h[(c[ba>>2]|0)+6272>>3],2,A);RNa(+h[(c[ba>>2]|0)+6280>>3],2,B);c[v>>2]=y;QNa(2,w,2,x,v);c[u>>2]=B;QNa(2,z,2,A,u);c[t>>2]=z;QNa(1,C,2,w,t);t=c[b+536>>2]|0;na=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+8432>>3];w=j;z=C;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];Bp(Y,t,na,j,2);da=+h[Y>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+8296|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+17|0]|0)!=0){ca=b+416|0;RNa(+h[(c[ca>>2]|0)+6256>>3],2,E);RNa(+h[(c[ca>>2]|0)+6264>>3],2,F);RNa(+h[(c[ca>>2]|0)+6272>>3],2,H);RNa(+h[(c[ca>>2]|0)+6280>>3],2,I);c[s>>2]=F;QNa(2,D,2,E,s);c[r>>2]=I;QNa(2,G,2,H,r);c[q>>2]=G;QNa(1,J,2,D,q);q=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+8432>>3];D=g;G=J;c[D+0>>2]=c[G+0>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2];Bp(Z,q,na,g,2);da=-+h[Z>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+8296|0;ma=la;h[ma>>3]=da;i=d;return}Z=b+416|0;na=+h[(c[Z>>2]|0)+6256>>3];if((c[(c[b+404>>2]|0)+416>>2]|0)==1){RNa(na,2,L);RNa(+h[(c[Z>>2]|0)+6264>>3],2,M);RNa(+h[(c[Z>>2]|0)+6272>>3],2,O);RNa(+h[(c[Z>>2]|0)+6280>>3],2,P);c[p>>2]=M;QNa(2,K,2,L,p);c[o>>2]=P;QNa(2,N,2,O,o);c[n>>2]=N;QNa(1,Q,2,K,n);n=c[b+536>>2]|0;oa=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+8432>>3];K=f;N=Q;c[K+0>>2]=c[N+0>>2];c[K+4>>2]=c[N+4>>2];c[K+8>>2]=c[N+8>>2];Bp(_,n,oa,f,2);da=+h[_>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+8296|0;ma=la;h[ma>>3]=da;i=d;return}else{RNa(na,2,S);RNa(+h[(c[Z>>2]|0)+6264>>3],2,T);RNa(+h[(c[Z>>2]|0)+6272>>3],2,V);RNa(+h[(c[Z>>2]|0)+6280>>3],2,W);c[m>>2]=T;QNa(2,R,2,S,m);c[l>>2]=W;QNa(2,U,2,V,l);c[k>>2]=U;QNa(1,X,2,R,k);k=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+8432>>3];b=e;R=X;c[b+0>>2]=c[R+0>>2];c[b+4>>2]=c[R+4>>2];c[b+8>>2]=c[R+8>>2];Bp($,k,na,e,2);da=-+h[$>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+8296|0;ma=la;h[ma>>3]=da;i=d;return}}function XH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8312>>3]=+h[b+8296>>3]*+h[b+8432>>3];i=i;return}function YH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8448>>3]=+h[(c[a+416>>2]|0)+9176>>3]*+h[b+8432>>3];i=i;return}function ZH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8416>>3]=+h[b+8424>>3]+ +h[b+8448>>3];i=i;return}function _H(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+280>>3]=+h[b+8808>>3];i=i;return}function $H(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+280>>3];e=c[a+416>>2]|0;h[b+2880>>3]=+h[e+7416>>3]*(-(+h[b+8744>>3]*+h[e+1400>>3])-d*d*+h[e+1416>>3]);i=i;return}function aI(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2032>>3]=+h[b+1408>>3]*+h[d+2880>>3]- +h[b+1416>>3]*+h[d+2872>>3];i=i;return}function bI(a){a=a|0;var b=0,d=0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[b+280>>3];h[b+2864>>3]=+h[d+7416>>3]*(+h[b+8744>>3]*+h[d+1416>>3]-e*e*+h[d+1400>>3]);i=i;return}function cI(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2048>>3]=+h[b+1400>>3]*+h[d+2872>>3]- +h[b+1408>>3]*+h[d+2864>>3];i=i;return}function dI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2040>>3]=+h[b+8744>>3]*1.16+(+h[d+1416>>3]*+h[b+2864>>3]- +h[d+1400>>3]*+h[b+2880>>3]);i=i;return}function eI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1840>>3]=+h[b+1992>>3]*+h[b+8744>>3]- +h[b+272>>3]*+h[b+2016>>3]*+h[b+280>>3];i=i;return}function fI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1848>>3]=+h[b+2016>>3]*+h[b+8744>>3]+ +h[b+272>>3]*+h[b+1992>>3]*+h[b+280>>3];i=i;return}function gI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1864>>3]=+h[b+2016>>3]*+h[b+280>>3];i=i;return}function hI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1856>>3]=+h[b+1992>>3]*+h[b+280>>3];i=i;return}function iI(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+1912>>3];f=+h[b+1856>>3];g=+h[b+1864>>3];j=+h[d+1928>>3];k=+h[d+1920>>3];l=g*j-f*k;m=+h[b+272>>3];n=+h[b+8752>>3];h[b+1736>>3]=+h[b+2016>>3]*(+h[b+1840>>3]*e+(f*l+(-(m*(k*m-e*g))-j*n)))+ +h[b+1992>>3]*(k*n+(m*(e*f-j*m)+(-(g*l)-e*+h[b+1848>>3])));i=i;return}function jI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1600>>3]=+h[b+5648>>3]*+h[b+1848>>3]+(+h[b+5656>>3]*+h[b+1840>>3]- +h[b+264>>3]*(+h[b+5624>>3]*+h[b+1864>>3]+ +h[b+5632>>3]*+h[b+1856>>3]));i=i;return}function kI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1592>>3]=+h[b+5624>>3]*+h[b+1848>>3]+(+h[b+5632>>3]*+h[b+1840>>3]+ +h[b+264>>3]*(+h[b+5648>>3]*+h[b+1864>>3]+ +h[b+5656>>3]*+h[b+1856>>3]));i=i;return}function lI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1312>>3]=+h[b+1592>>3]+ +h[b+8768>>3];i=i;return}function mI(a){a=a|0;var b=0,d=0,e=0.0,f=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+1912>>3];f=+h[b+272>>3];h[b+1760>>3]=+h[b+2016>>3]*(+h[b+1856>>3]*e-f*+h[d+1928>>3])+ +h[b+1992>>3]*(f*+h[d+1920>>3]-e*+h[b+1864>>3]);i=i;return}function nI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1616>>3]=+h[b+5624>>3]*+h[b+1864>>3]+ +h[b+5632>>3]*+h[b+1856>>3];i=i;return}function oI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1336>>3]=+h[b+1616>>3]+ +h[b+256>>3];i=i;return}function pI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1624>>3]=+h[b+5648>>3]*+h[b+1864>>3]+ +h[b+5656>>3]*+h[b+1856>>3];i=i;return}function qI(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+2544>>3];f=+h[b+1624>>3];g=+h[b+1616>>3];j=+h[d+2560>>3];k=+h[d+2552>>3];l=g*j-f*k;m=+h[b+1608>>3];n=+h[b+1584>>3];h[b+1456>>3]=+h[b+1736>>3]+(+h[b+1568>>3]*(+h[b+1600>>3]*e+(f*l+(-(m*(k*m-e*g))-j*n)))+ +h[b+1824>>3]*(k*n+(m*(e*f-j*m)+(-(g*l)-e*+h[b+1592>>3]))));i=i;return}function rI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1320>>3]=+h[b+5728>>3]*+h[b+1584>>3]+(+h[b+5744>>3]*+h[b+1600>>3]+ +h[b+256>>3]*(+h[b+5680>>3]*+h[b+1608>>3]+ +h[b+5696>>3]*+h[b+1624>>3]));i=i;return}function sI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1304>>3]=+h[b+5680>>3]*+h[b+1584>>3]+(+h[b+5696>>3]*+h[b+1600>>3]- +h[b+256>>3]*(+h[b+5728>>3]*+h[b+1608>>3]+ +h[b+5744>>3]*+h[b+1624>>3]));i=i;return}function tI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1024>>3]=+h[b+1304>>3]+ +h[b+8776>>3];i=i;return}function uI(a){a=a|0;var b=0,d=0,e=0.0,f=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+2544>>3];f=+h[b+1608>>3];h[b+1480>>3]=+h[b+1760>>3]+(+h[b+1568>>3]*(+h[b+1624>>3]*e-f*+h[d+2560>>3])+ +h[b+1824>>3]*(f*+h[d+2552>>3]-e*+h[b+1616>>3]));i=i;return}function vI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1328>>3]=+h[b+5680>>3]*+h[b+1608>>3]+ +h[b+5696>>3]*+h[b+1624>>3];i=i;return}function wI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1048>>3]=+h[b+1328>>3]+ +h[b+248>>3];i=i;return}function xI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1344>>3]=+h[b+5728>>3]*+h[b+1608>>3]+ +h[b+5744>>3]*+h[b+1624>>3];i=i;return}function yI(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1312>>3];e=c[a+416>>2]|0;f=+h[e+3192>>3];g=+h[b+1336>>3];j=+h[b+1328>>3];k=+h[e+3184>>3];l=+h[e+3176>>3];m=j*k-g*l;n=+h[b+1344>>3];o=l*n-f*j;p=+h[b+1320>>3];q=f*g-k*n;r=+h[b+1304>>3];h[b+1176>>3]=+h[b+1456>>3]+(+h[b+1288>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+1568>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1544>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function zI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1040>>3]=+h[b+5824>>3]*+h[b+1312>>3]+(+h[b+5832>>3]*+h[b+1320>>3]- +h[b+248>>3]*(+h[b+5800>>3]*+h[b+1336>>3]+ +h[b+5808>>3]*+h[b+1344>>3]));i=i;return}function AI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1032>>3]=+h[b+5800>>3]*+h[b+1312>>3]+(+h[b+5808>>3]*+h[b+1320>>3]+ +h[b+248>>3]*(+h[b+5824>>3]*+h[b+1336>>3]+ +h[b+5832>>3]*+h[b+1344>>3]));i=i;return}function BI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+624>>3]=+h[b+1032>>3]+ +h[b+8784>>3];i=i;return}function CI(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1336>>3];e=c[a+416>>2]|0;f=+h[e+3192>>3];g=+h[b+1344>>3];j=+h[e+3184>>3];k=+h[e+3176>>3];l=+h[b+1328>>3];h[b+1200>>3]=+h[b+1480>>3]+(+h[b+1288>>3]*(d*f-g*j)+(+h[b+1568>>3]*(g*k-f*l)+ +h[b+1544>>3]*(j*l-d*k)));i=i;return}function DI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1056>>3]=+h[b+5800>>3]*+h[b+1336>>3]+ +h[b+5808>>3]*+h[b+1344>>3];i=i;return}function EI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+744>>3]=+h[b+1056>>3]+ +h[b+240>>3];i=i;return}function FI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1064>>3]=+h[b+5824>>3]*+h[b+1336>>3]+ +h[b+5832>>3]*+h[b+1344>>3];i=i;return}function GI(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1032>>3];e=c[a+416>>2]|0;f=+h[e+3824>>3];g=+h[b+1056>>3];j=+h[b+1048>>3];k=+h[e+3816>>3];l=+h[e+3808>>3];m=j*k-g*l;n=+h[b+1064>>3];o=l*n-f*j;p=+h[b+1040>>3];q=f*g-k*n;r=+h[b+1024>>3];h[b+864>>3]=+h[b+1176>>3]+(+h[b+1288>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+984>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1264>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function HI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+632>>3]=+h[b+5904>>3]*+h[b+1024>>3]+(+h[b+5920>>3]*+h[b+1040>>3]+ +h[b+240>>3]*(+h[b+5856>>3]*+h[b+1048>>3]+ +h[b+5872>>3]*+h[b+1064>>3]));i=i;return}function II(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+616>>3]=+h[b+5856>>3]*+h[b+1024>>3]+(+h[b+5872>>3]*+h[b+1040>>3]- +h[b+240>>3]*(+h[b+5904>>3]*+h[b+1048>>3]+ +h[b+5920>>3]*+h[b+1064>>3]));i=i;return}function JI(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1056>>3];e=c[a+416>>2]|0;f=+h[e+3824>>3];g=+h[b+1064>>3];j=+h[e+3816>>3];k=+h[e+3808>>3];l=+h[b+1048>>3];h[b+888>>3]=+h[b+1200>>3]+(+h[b+1288>>3]*(d*f-g*j)+(+h[b+984>>3]*(g*k-f*l)+ +h[b+1264>>3]*(j*l-d*k)));i=i;return}function KI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+736>>3]=+h[b+5856>>3]*+h[b+1048>>3]+ +h[b+5872>>3]*+h[b+1064>>3];i=i;return}function LI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+752>>3]=+h[b+5904>>3]*+h[b+1048>>3]+ +h[b+5920>>3]*+h[b+1064>>3];i=i;return}function MI(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+624>>3];e=c[a+416>>2]|0;f=+h[e+4456>>3];g=+h[b+744>>3];j=+h[b+736>>3];k=+h[e+4448>>3];l=+h[e+4440>>3];m=j*k-g*l;n=+h[b+752>>3];o=l*n-f*j;p=+h[b+632>>3];q=f*g-k*n;r=+h[b+616>>3];h[b+672>>3]=+h[b+864>>3]+(+h[b+960>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+984>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1008>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function NI(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+744>>3];e=c[a+416>>2]|0;f=+h[e+4456>>3];g=+h[b+752>>3];j=+h[e+4448>>3];k=+h[e+4440>>3];l=+h[b+736>>3];h[b+696>>3]=+h[b+888>>3]+(+h[b+960>>3]*(d*f-g*j)+(+h[b+984>>3]*(g*k-f*l)+ +h[b+1008>>3]*(j*l-d*k)));i=i;return}function OI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8672>>3]=+h[b+8680>>3];i=i;return}function PI(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+8672>>3]));h[b+2448>>3]=-(d*+h[b+8808>>3]);i=i;return}function QI(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+8672>>3]));h[b+2456>>3]=-(d*+h[b+8808>>3]);i=i;return}function RI(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+8672>>3]));h[b+2464>>3]=d*+h[b+8808>>3];i=i;return}function SI(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+8672>>3]));h[b+2472>>3]=-(d*+h[b+8808>>3]);i=i;return}function TI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5440>>3]=+X(+(+h[b+8672>>3]));i=i;return}function UI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2520>>3]=+h[b+5520>>3]*+h[b+2472>>3]+ +h[b+2728>>3]*+h[b+5440>>3];i=i;return}function VI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2496>>3]=+h[b+5528>>3]*+h[b+2472>>3]+ +h[b+2720>>3]*+h[b+5440>>3];i=i;return}function WI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1984>>3]=+h[b+5520>>3]*+h[b+5440>>3];i=i;return}function XI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2008>>3]=+h[b+5528>>3]*+h[b+5440>>3];i=i;return}function YI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2544>>3]=+h[b+5648>>3]*+h[b+2496>>3]+(+h[b+2752>>3]*+h[b+2008>>3]+(+h[b+5656>>3]*+h[b+2520>>3]+ +h[b+2760>>3]*+h[b+1984>>3]));i=i;return}function ZI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2568>>3]=+h[b+5624>>3]*+h[b+2496>>3]+(+h[b+2736>>3]*+h[b+2008>>3]+(+h[b+5632>>3]*+h[b+2520>>3]+ +h[b+2744>>3]*+h[b+1984>>3]));i=i;return}function _I(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1816>>3]=+h[b+5648>>3]*+h[b+2008>>3]+ +h[b+5656>>3]*+h[b+1984>>3];i=i;return}function $I(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1560>>3]=+h[b+5624>>3]*+h[b+2008>>3]+ +h[b+5632>>3]*+h[b+1984>>3];i=i;return}function aJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5424>>3]=+Y(+(+h[b+8672>>3]));i=i;return}function bJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2504>>3]=+h[b+5520>>3]*+h[b+2464>>3]+ +h[b+2728>>3]*+h[b+5424>>3];i=i;return}function cJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2480>>3]=+h[b+5528>>3]*+h[b+2464>>3]+ +h[b+2720>>3]*+h[b+5424>>3];i=i;return}function dJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2e3>>3]=+h[b+5520>>3]*+h[b+5424>>3];i=i;return}function eJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2024>>3]=+h[b+5528>>3]*+h[b+5424>>3];i=i;return}function fJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2528>>3]=+h[b+5648>>3]*+h[b+2480>>3]+(+h[b+2752>>3]*+h[b+2024>>3]+(+h[b+5656>>3]*+h[b+2504>>3]+ +h[b+2760>>3]*+h[b+2e3>>3]));i=i;return}function gJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2552>>3]=+h[b+5624>>3]*+h[b+2480>>3]+(+h[b+2736>>3]*+h[b+2024>>3]+(+h[b+5632>>3]*+h[b+2504>>3]+ +h[b+2744>>3]*+h[b+2e3>>3]));i=i;return}function hJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1832>>3]=+h[b+5648>>3]*+h[b+2024>>3]+ +h[b+5656>>3]*+h[b+2e3>>3];i=i;return}function iJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1576>>3]=+h[b+5624>>3]*+h[b+2024>>3]+ +h[b+5632>>3]*+h[b+2e3>>3];i=i;return}function jJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5392>>3]=-+Y(+(+h[b+8672>>3]));i=i;return}function kJ(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8744>>3];e=c[a+416>>2]|0;f=+h[e+1296>>3];g=+h[b+280>>3];j=-g;k=+h[e+1280>>3];h[b+2912>>3]=+h[b+5440>>3]*(f*g*j-d*k)+ +h[b+5392>>3]*(d*f+g*k*j);i=i;return}function lJ(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1848>>3];e=c[a+416>>2]|0;f=+h[e+1928>>3];g=+h[b+1864>>3];j=+h[b+272>>3];k=+h[e+1920>>3];l=+h[e+1912>>3];m=j*k-g*l;n=+h[b+1856>>3];o=l*n-f*j;p=+h[b+1840>>3];q=f*g-k*n;r=+h[b+8752>>3];h[b+1744>>3]=+h[b+2912>>3]+(+h[b+5392>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+2008>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1984>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function mJ(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1592>>3];e=c[a+416>>2]|0;f=+h[e+2560>>3];g=+h[b+1616>>3];j=+h[b+1608>>3];k=+h[e+2552>>3];l=+h[e+2544>>3];m=j*k-g*l;n=+h[b+1624>>3];o=l*n-f*j;p=+h[b+1600>>3];q=f*g-k*n;r=+h[b+1584>>3];h[b+1464>>3]=+h[b+1744>>3]+(+h[b+5392>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+1560>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1816>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function nJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2592>>3]=+h[b+5728>>3]*+h[b+2456>>3]+(+h[b+2784>>3]*+h[b+5392>>3]+(+h[b+5744>>3]*+h[b+2544>>3]+ +h[b+2792>>3]*+h[b+1816>>3]));i=i;return}function oJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2616>>3]=+h[b+5680>>3]*+h[b+2456>>3]+(+h[b+2768>>3]*+h[b+5392>>3]+(+h[b+5696>>3]*+h[b+2544>>3]+ +h[b+2776>>3]*+h[b+1816>>3]));i=i;return}function pJ(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+280>>3];e=c[a+416>>2]|0;h[b+3096>>3]=+h[b+5392>>3]*d*+h[e+1296>>3]- +h[b+5440>>3]*d*+h[e+1280>>3];i=i;return}function qJ(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1864>>3];e=c[a+416>>2]|0;f=+h[e+1928>>3];g=+h[b+1856>>3];j=+h[e+1920>>3];k=+h[e+1912>>3];l=+h[b+272>>3];h[b+1768>>3]=+h[b+3096>>3]+(+h[b+5392>>3]*(d*f-g*j)+(+h[b+2008>>3]*(g*k-f*l)+ +h[b+1984>>3]*(j*l-d*k)));i=i;return}function rJ(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1616>>3];e=c[a+416>>2]|0;f=+h[e+2560>>3];g=+h[b+1624>>3];j=+h[e+2552>>3];k=+h[e+2544>>3];l=+h[b+1608>>3];h[b+1488>>3]=+h[b+1768>>3]+(+h[b+5392>>3]*(d*f-g*j)+(+h[b+1560>>3]*(g*k-f*l)+ +h[b+1816>>3]*(j*l-d*k)));i=i;return}function sJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1536>>3]=+h[b+5728>>3]*+h[b+5392>>3]+ +h[b+5744>>3]*+h[b+1816>>3];i=i;return}function tJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2640>>3]=+h[b+5824>>3]*+h[b+2568>>3]+(+h[b+2816>>3]*+h[b+1560>>3]+(+h[b+5832>>3]*+h[b+2592>>3]+ +h[b+2824>>3]*+h[b+1536>>3]));i=i;return}function uJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2688>>3]=+h[b+5800>>3]*+h[b+2568>>3]+(+h[b+2800>>3]*+h[b+1560>>3]+(+h[b+5808>>3]*+h[b+2592>>3]+ +h[b+2808>>3]*+h[b+1536>>3]));i=i;return}function vJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1256>>3]=+h[b+5824>>3]*+h[b+1560>>3]+ +h[b+5832>>3]*+h[b+1536>>3];i=i;return}function wJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+992>>3]=+h[b+5800>>3]*+h[b+1560>>3]+ +h[b+5808>>3]*+h[b+1536>>3];i=i;return}function xJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1280>>3]=+h[b+5680>>3]*+h[b+5392>>3]+ +h[b+5696>>3]*+h[b+1816>>3];i=i;return}function yJ(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1312>>3];e=c[a+416>>2]|0;f=+h[e+3192>>3];g=+h[b+1336>>3];j=+h[b+1328>>3];k=+h[e+3184>>3];l=+h[e+3176>>3];m=j*k-g*l;n=+h[b+1344>>3];o=l*n-f*j;p=+h[b+1320>>3];q=f*g-k*n;r=+h[b+1304>>3];h[b+1184>>3]=+h[b+1464>>3]+(+h[b+1280>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+1560>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1536>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function zJ(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1032>>3];e=c[a+416>>2]|0;f=+h[e+3824>>3];g=+h[b+1056>>3];j=+h[b+1048>>3];k=+h[e+3816>>3];l=+h[e+3808>>3];m=j*k-g*l;n=+h[b+1064>>3];o=l*n-f*j;p=+h[b+1040>>3];q=f*g-k*n;r=+h[b+1024>>3];h[b+872>>3]=+h[b+1184>>3]+(+h[b+1280>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+992>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1256>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function AJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2712>>3]=+h[b+5904>>3]*+h[b+2616>>3]+(+h[b+2848>>3]*+h[b+1280>>3]+(+h[b+5920>>3]*+h[b+2640>>3]+ +h[b+2856>>3]*+h[b+1256>>3]));i=i;return}function BJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2664>>3]=+h[b+5856>>3]*+h[b+2616>>3]+(+h[b+2832>>3]*+h[b+1280>>3]+(+h[b+5872>>3]*+h[b+2640>>3]+ +h[b+2840>>3]*+h[b+1256>>3]));i=i;return}function CJ(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1336>>3];e=c[a+416>>2]|0;f=+h[e+3192>>3];g=+h[b+1344>>3];j=+h[e+3184>>3];k=+h[e+3176>>3];l=+h[b+1328>>3];h[b+1208>>3]=+h[b+1488>>3]+(+h[b+1280>>3]*(d*f-g*j)+(+h[b+1560>>3]*(g*k-f*l)+ +h[b+1536>>3]*(j*l-d*k)));i=i;return}function DJ(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1056>>3];e=c[a+416>>2]|0;f=+h[e+3824>>3];g=+h[b+1064>>3];j=+h[e+3816>>3];k=+h[e+3808>>3];l=+h[b+1048>>3];h[b+896>>3]=+h[b+1208>>3]+(+h[b+1280>>3]*(d*f-g*j)+(+h[b+992>>3]*(g*k-f*l)+ +h[b+1256>>3]*(j*l-d*k)));i=i;return}function EJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1016>>3]=+h[b+5904>>3]*+h[b+1280>>3]+ +h[b+5920>>3]*+h[b+1256>>3];i=i;return}function FJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+968>>3]=+h[b+5856>>3]*+h[b+1280>>3]+ +h[b+5872>>3]*+h[b+1256>>3];i=i;return}function GJ(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+624>>3];e=c[a+416>>2]|0;f=+h[e+4456>>3];g=+h[b+744>>3];j=+h[b+736>>3];k=+h[e+4448>>3];l=+h[e+4440>>3];m=j*k-g*l;n=+h[b+752>>3];o=l*n-f*j;p=+h[b+632>>3];q=f*g-k*n;r=+h[b+616>>3];h[b+680>>3]=+h[b+872>>3]+(+h[b+968>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+992>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1016>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function HJ(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+744>>3];e=c[a+416>>2]|0;f=+h[e+4456>>3];g=+h[b+752>>3];j=+h[e+4448>>3];k=+h[e+4440>>3];l=+h[b+736>>3];h[b+704>>3]=+h[b+896>>3]+(+h[b+968>>3]*(d*f-g*j)+(+h[b+992>>3]*(g*k-f*l)+ +h[b+1016>>3]*(j*l-d*k)));i=i;return}function IJ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3160>>3]=+h[b+664>>3]+(+h[d+5392>>3]*+h[b+1280>>3]+ +h[d+5440>>3]*+h[b+1296>>3]);i=i;return}function JJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1696>>3]=+h[b+3160>>3]+(+h[b+5392>>3]*+h[d+1912>>3]+(+h[b+2008>>3]*+h[d+1920>>3]+ +h[b+1984>>3]*+h[d+1928>>3]));i=i;return}function KJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1416>>3]=+h[b+1696>>3]+(+h[b+5392>>3]*+h[d+2544>>3]+(+h[b+1560>>3]*+h[d+2552>>3]+ +h[b+1816>>3]*+h[d+2560>>3]));i=i;return}function LJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1136>>3]=+h[b+1416>>3]+(+h[b+1280>>3]*+h[d+3176>>3]+(+h[b+1560>>3]*+h[d+3184>>3]+ +h[b+1536>>3]*+h[d+3192>>3]));i=i;return}function MJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+824>>3]=+h[b+1136>>3]+(+h[b+1280>>3]*+h[d+3808>>3]+(+h[b+992>>3]*+h[d+3816>>3]+ +h[b+1256>>3]*+h[d+3824>>3]));i=i;return}function NJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+656>>3]=+h[b+824>>3]+(+h[b+968>>3]*+h[d+4440>>3]+(+h[b+992>>3]*+h[d+4448>>3]+ +h[b+1016>>3]*+h[d+4456>>3]));i=i;return}function OJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+728>>3]=+h[b+656>>3]+(+h[b+968>>3]*+h[d+5072>>3]+(+h[b+992>>3]*+h[d+5080>>3]+ +h[b+1016>>3]*+h[d+5088>>3]));i=i;return}function PJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5376>>3]=+X(+(+h[b+8672>>3]));i=i;return}function QJ(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8744>>3];e=c[a+416>>2]|0;f=+h[e+1296>>3];g=+h[b+280>>3];j=-g;k=+h[e+1280>>3];h[b+2896>>3]=+h[b+5424>>3]*(f*g*j-d*k)+ +h[b+5376>>3]*(d*f+g*k*j);i=i;return}function RJ(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1848>>3];e=c[a+416>>2]|0;f=+h[e+1928>>3];g=+h[b+1864>>3];j=+h[b+272>>3];k=+h[e+1920>>3];l=+h[e+1912>>3];m=j*k-g*l;n=+h[b+1856>>3];o=l*n-f*j;p=+h[b+1840>>3];q=f*g-k*n;r=+h[b+8752>>3];h[b+1728>>3]=+h[b+2896>>3]+(+h[b+5376>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+2024>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+2e3>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function SJ(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1592>>3];e=c[a+416>>2]|0;f=+h[e+2560>>3];g=+h[b+1616>>3];j=+h[b+1608>>3];k=+h[e+2552>>3];l=+h[e+2544>>3];m=j*k-g*l;n=+h[b+1624>>3];o=l*n-f*j;p=+h[b+1600>>3];q=f*g-k*n;r=+h[b+1584>>3];h[b+1448>>3]=+h[b+1728>>3]+(+h[b+5376>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+1576>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1832>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function TJ(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+3296>>3];f=+h[b+1344>>3];g=+h[b+1336>>3];j=+h[d+3312>>3];k=+h[d+3304>>3];l=+h[b+1328>>3];h[b+1384>>3]=+h[d+8016>>3]*(+h[b+1576>>3]*+h[b+1448>>3]+(+h[b+1568>>3]*(+h[b+1456>>3]+ +h[d+6720>>3])+(+h[b+1560>>3]*+h[b+1464>>3]+(+h[b+1320>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1304>>3])))));i=i;return}function UJ(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+2672>>3];f=+h[b+1608>>3];g=+h[b+1624>>3];j=+h[d+2664>>3];k=+h[d+2680>>3];l=+h[b+1616>>3];h[b+1672>>3]=+h[d+7816>>3]*(+h[b+1832>>3]*+h[b+1728>>3]+(+h[b+1824>>3]*(+h[b+1736>>3]+ +h[d+6720>>3])+(+h[b+1816>>3]*+h[b+1744>>3]+(+h[b+1584>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1592>>3])))));i=i;return}function VJ(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+2664>>3];f=+h[b+1624>>3];g=+h[b+1616>>3];j=+h[d+2680>>3];k=+h[d+2672>>3];l=+h[b+1608>>3];h[b+1664>>3]=+h[d+7816>>3]*(+h[b+1576>>3]*+h[b+1728>>3]+(+h[b+1568>>3]*(+h[b+1736>>3]+ +h[d+6720>>3])+(+h[b+1560>>3]*+h[b+1744>>3]+(+h[b+1600>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1584>>3])))));i=i;return}function WJ(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1616>>3];e=+h[b+1624>>3];f=c[a+416>>2]|0;h[b+1632>>3]=+h[b+1584>>3]*.279+(+h[b+1592>>3]*-.07+(d*e*.413+(+h[f+2672>>3]*+h[b+1672>>3]+(-(+h[f+2680>>3]*+h[b+1664>>3])-e*(d*.245+ +h[b+1608>>3]*-.07)))));i=i;return}function XJ(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+2680>>3];f=+h[b+1616>>3];g=+h[b+1608>>3];j=+h[d+2672>>3];k=+h[d+2664>>3];l=+h[b+1624>>3];h[b+1656>>3]=+h[d+7816>>3]*(+h[b+5376>>3]*+h[b+1728>>3]+(+h[b+5392>>3]*+h[b+1744>>3]+(+h[b+1592>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1600>>3]))));i=i;return}function YJ(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1624>>3];e=+h[b+1608>>3];f=c[a+416>>2]|0;h[b+1640>>3]=+h[b+1584>>3]*-.07+(+h[b+1592>>3]*.245+(d*(e*.279+ +h[b+1616>>3]*-.07)+(+h[f+2680>>3]*+h[b+1656>>3]+(d*e*-.413- +h[f+2664>>3]*+h[b+1672>>3]))));i=i;return}function ZJ(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1608>>3];e=+h[b+1616>>3];f=c[a+416>>2]|0;h[b+1648>>3]=+h[b+1600>>3]*.413+(d*(d*-.07+e*.245)+(+h[f+2664>>3]*+h[b+1664>>3]+(-(+h[f+2672>>3]*+h[b+1656>>3])-e*(d*.279+e*-.07))));i=i;return}function _J(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+2040>>3];f=+h[b+272>>3];g=+h[b+1856>>3];j=+h[d+2032>>3];k=+h[d+2048>>3];l=+h[b+1864>>3];h[b+1912>>3]=+h[d+7616>>3]*(+h[b+2e3>>3]*+h[b+2896>>3]+(+h[b+1992>>3]*+h[d+6720>>3]+(+h[b+1984>>3]*+h[b+2912>>3]+(+h[b+8752>>3]*e+(f*(g*j-f*k)+(-(l*(k*l-e*g))-j*+h[b+1848>>3]))))));i=i;return}function $J(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+2032>>3];f=+h[b+1856>>3];g=+h[b+1864>>3];j=+h[d+2048>>3];k=+h[d+2040>>3];l=+h[b+272>>3];h[b+1904>>3]=+h[d+7616>>3]*(+h[b+2024>>3]*+h[b+2896>>3]+(+h[b+2016>>3]*+h[d+6720>>3]+(+h[b+2008>>3]*+h[b+2912>>3]+(+h[b+1840>>3]*e+(f*(g*j-f*k)+(-(l*(k*l-e*g))-j*+h[b+8752>>3]))))));i=i;return}function aK(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1864>>3];e=+h[b+1856>>3];f=c[a+416>>2]|0;h[b+1872>>3]=+h[b+8752>>3]*2.58+(+h[b+1848>>3]*-.46+(d*e*2.73+(+h[f+2040>>3]*+h[b+1912>>3]+(-(+h[f+2048>>3]*+h[b+1904>>3])-e*(d*.64+ +h[b+272>>3]*-.46)))));i=i;return}function bK(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+2048>>3];f=+h[b+1864>>3];g=+h[b+272>>3];j=+h[d+2040>>3];k=+h[d+2032>>3];l=+h[b+1856>>3];h[b+1896>>3]=+h[d+7616>>3]*(+h[b+5376>>3]*+h[b+2896>>3]+(+h[b+5392>>3]*+h[b+2912>>3]+(+h[b+1848>>3]*e+(f*(g*j-f*k)+(-(l*(k*l-e*g))-j*+h[b+1840>>3])))));i=i;return}function cK(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1856>>3];e=+h[b+272>>3];f=c[a+416>>2]|0;h[b+1880>>3]=+h[b+8752>>3]*-.46+(+h[b+1848>>3]*.64+(d*(e*2.58+ +h[b+1864>>3]*-.46)+(+h[f+2048>>3]*+h[b+1896>>3]+(d*e*-2.73- +h[f+2032>>3]*+h[b+1912>>3]))));i=i;return}function dK(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+272>>3];e=+h[b+1864>>3];f=c[a+416>>2]|0;h[b+1888>>3]=+h[b+1840>>3]*2.73+(d*(d*-.46+e*.64)+(+h[f+2032>>3]*+h[b+1904>>3]+(-(+h[f+2040>>3]*+h[b+1896>>3])-e*(d*2.58+e*-.46))));i=i;return}function eK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2576>>3]=+h[b+5728>>3]*+h[b+2448>>3]+(+h[b+2784>>3]*+h[b+5376>>3]+(+h[b+5744>>3]*+h[b+2528>>3]+ +h[b+2792>>3]*+h[b+1832>>3]));i=i;return}function fK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2600>>3]=+h[b+5680>>3]*+h[b+2448>>3]+(+h[b+2768>>3]*+h[b+5376>>3]+(+h[b+5696>>3]*+h[b+2528>>3]+ +h[b+2776>>3]*+h[b+1832>>3]));i=i;return}function gK(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+280>>3];e=c[a+416>>2]|0;h[b+3080>>3]=+h[b+5376>>3]*d*+h[e+1296>>3]- +h[b+5424>>3]*d*+h[e+1280>>3];i=i;return}function hK(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1864>>3];e=c[a+416>>2]|0;f=+h[e+1928>>3];g=+h[b+1856>>3];j=+h[e+1920>>3];k=+h[e+1912>>3];l=+h[b+272>>3];h[b+1752>>3]=+h[b+3080>>3]+(+h[b+5376>>3]*(d*f-g*j)+(+h[b+2024>>3]*(g*k-f*l)+ +h[b+2e3>>3]*(j*l-d*k)));i=i;return}function iK(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1616>>3];e=c[a+416>>2]|0;f=+h[e+2560>>3];g=+h[b+1624>>3];j=+h[e+2552>>3];k=+h[e+2544>>3];l=+h[b+1608>>3];h[b+1472>>3]=+h[b+1752>>3]+(+h[b+5376>>3]*(d*f-g*j)+(+h[b+1576>>3]*(g*k-f*l)+ +h[b+1832>>3]*(j*l-d*k)));i=i;return}function jK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1552>>3]=+h[b+5728>>3]*+h[b+5376>>3]+ +h[b+5744>>3]*+h[b+1832>>3];i=i;return}function kK(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+3304>>3];f=+h[b+1328>>3];g=+h[b+1344>>3];j=+h[d+3296>>3];k=+h[d+3312>>3];l=+h[b+1336>>3];h[b+1392>>3]=+h[d+8016>>3]*(+h[b+1552>>3]*+h[b+1448>>3]+(+h[b+1544>>3]*(+h[b+1456>>3]+ +h[d+6720>>3])+(+h[b+1536>>3]*+h[b+1464>>3]+(+h[b+1304>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1312>>3])))));i=i;return}function lK(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1336>>3]*+h[b+1344>>3];e=c[a+416>>2]|0;h[b+1352>>3]=+h[b+1304>>3]*1.67+(d*1.67+(+h[e+3304>>3]*+h[b+1392>>3]+(d*-.081- +h[e+3312>>3]*+h[b+1384>>3])));i=i;return}function mK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2624>>3]=+h[b+5824>>3]*+h[b+2552>>3]+(+h[b+2816>>3]*+h[b+1576>>3]+(+h[b+5832>>3]*+h[b+2576>>3]+ +h[b+2824>>3]*+h[b+1552>>3]));i=i;return}function nK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2672>>3]=+h[b+5800>>3]*+h[b+2552>>3]+(+h[b+2800>>3]*+h[b+1576>>3]+(+h[b+5808>>3]*+h[b+2576>>3]+ +h[b+2808>>3]*+h[b+1552>>3]));i=i;return}function oK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1272>>3]=+h[b+5824>>3]*+h[b+1576>>3]+ +h[b+5832>>3]*+h[b+1552>>3];i=i;return}function pK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+976>>3]=+h[b+5800>>3]*+h[b+1576>>3]+ +h[b+5808>>3]*+h[b+1552>>3];i=i;return}function qK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1296>>3]=+h[b+5680>>3]*+h[b+5376>>3]+ +h[b+5696>>3]*+h[b+1832>>3];i=i;return}function rK(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+3312>>3];f=+h[b+1336>>3];g=+h[b+1328>>3];j=+h[d+3304>>3];k=+h[d+3296>>3];l=+h[b+1344>>3];h[b+1376>>3]=+h[d+8016>>3]*(+h[b+1296>>3]*+h[b+1448>>3]+(+h[b+1288>>3]*(+h[b+1456>>3]+ +h[d+6720>>3])+(+h[b+1280>>3]*+h[b+1464>>3]+(+h[b+1312>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1320>>3])))));i=i;return}function sK(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1328>>3]*+h[b+1336>>3];e=c[a+416>>2]|0;h[b+1368>>3]=+h[b+1320>>3]*1.67+(d*.081+(+h[e+3296>>3]*+h[b+1384>>3]+(d*-1.67- +h[e+3304>>3]*+h[b+1376>>3])));i=i;return}function tK(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1344>>3]*+h[b+1328>>3];e=c[a+416>>2]|0;h[b+1360>>3]=+h[b+1312>>3]*.081+(d*1.67+(+h[e+3312>>3]*+h[b+1376>>3]+(d*-1.67- +h[e+3296>>3]*+h[b+1392>>3])));i=i;return}function uK(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1312>>3];e=c[a+416>>2]|0;f=+h[e+3192>>3];g=+h[b+1336>>3];j=+h[b+1328>>3];k=+h[e+3184>>3];l=+h[e+3176>>3];m=j*k-g*l;n=+h[b+1344>>3];o=l*n-f*j;p=+h[b+1320>>3];q=f*g-k*n;r=+h[b+1304>>3];h[b+1168>>3]=+h[b+1448>>3]+(+h[b+1296>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+1576>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1552>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function vK(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+3936>>3];f=+h[b+1048>>3];g=+h[b+1064>>3];j=+h[d+3928>>3];k=+h[d+3944>>3];l=+h[b+1056>>3];h[b+1112>>3]=+h[d+8216>>3]*(+h[b+1272>>3]*+h[b+1168>>3]+(+h[b+1264>>3]*(+h[b+1176>>3]+ +h[d+6720>>3])+(+h[b+1256>>3]*+h[b+1184>>3]+(+h[b+1024>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1032>>3])))));i=i;return}function wK(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+3928>>3];f=+h[b+1064>>3];g=+h[b+1056>>3];j=+h[d+3944>>3];k=+h[d+3936>>3];l=+h[b+1048>>3];h[b+1104>>3]=+h[d+8216>>3]*(+h[b+976>>3]*+h[b+1168>>3]+(+h[b+984>>3]*(+h[b+1176>>3]+ +h[d+6720>>3])+(+h[b+992>>3]*+h[b+1184>>3]+(+h[b+1040>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1024>>3])))));i=i;return}function xK(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1056>>3]*+h[b+1064>>3];e=c[a+416>>2]|0;h[b+1072>>3]=+h[b+1024>>3]*1.25+(d*1.53+(+h[e+3936>>3]*+h[b+1112>>3]+(d*-.81- +h[e+3944>>3]*+h[b+1104>>3])));i=i;return}function yK(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+3944>>3];f=+h[b+1056>>3];g=+h[b+1048>>3];j=+h[d+3936>>3];k=+h[d+3928>>3];l=+h[b+1064>>3];h[b+1096>>3]=+h[d+8216>>3]*(+h[b+1296>>3]*+h[b+1168>>3]+(+h[b+1288>>3]*(+h[b+1176>>3]+ +h[d+6720>>3])+(+h[b+1280>>3]*+h[b+1184>>3]+(+h[b+1032>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1040>>3])))));i=i;return}function zK(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1064>>3]*+h[b+1048>>3];e=c[a+416>>2]|0;h[b+1080>>3]=+h[b+1032>>3]*.81+(d*1.25+(+h[e+3944>>3]*+h[b+1096>>3]+(d*-1.53- +h[e+3928>>3]*+h[b+1112>>3])));i=i;return}



function ik(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9688>>3];k=+h[g+8200>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8168|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8168|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,1528,1520,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8168|0;p=o;h[p>>3]=m;i=d;return}function jk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8176>>3]=+h[b+9672>>3]*+h[b+8168>>3];i=i;return}function kk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8152>>3]=+h[b+8104>>3]- +h[b+8176>>3];i=i;return}function lk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9664>>3];k=+h[g+8152>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8184|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8184|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,1568,1560,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8184|0;p=o;h[p>>3]=m;i=d;return}function mk(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+9888>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+8184>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+464|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+464|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1600,1592,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+464|0;p=o;h[p>>3]=m;i=d;return}function nk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8144>>3]=+h[b+8152>>3]*+h[b+8184>>3];i=i;return}function ok(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8160>>3]=+h[b+8176>>3]*+h[b+8168>>3];i=i;return}function pk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8240>>3]=+h[b+8168>>3]- +h[b+8184>>3];i=i;return}function qk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8064>>3]=+h[b+8184>>3]-(-+h[b+8240>>3]- +h[b+8224>>3]- +h[b+8096>>3]);i=i;return}function rk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8192>>3]=+h[b+8200>>3]*+h[b+8168>>3];i=i;return}function sk(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+10744>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+112>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+7856|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7856|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1624,1616,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7856|0;p=o;h[p>>3]=m;i=d;return}function tk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5624>>3]=+X(+(+h[b+7856>>3]));i=i;return}function uk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5632>>3]=+Y(+(+h[b+7856>>3]));i=i;return}function vk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1616>>3]=+h[b+5624>>3]*+h[b+1864>>3]+ +h[b+5632>>3]*+h[b+1856>>3];i=i;return}function wk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1336>>3]=+h[b+1616>>3]+ +h[b+256>>3];i=i;return}function xk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1576>>3]=+h[b+5624>>3]*+h[b+2024>>3]+ +h[b+5632>>3]*+h[b+2e3>>3];i=i;return}function yk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1568>>3]=+h[b+5624>>3]*+h[b+2016>>3]+ +h[b+5632>>3]*+h[b+1992>>3];i=i;return}function zk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1560>>3]=+h[b+5624>>3]*+h[b+2008>>3]+ +h[b+5632>>3]*+h[b+1984>>3];i=i;return}function Ak(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5648>>3]=-+Y(+(+h[b+7856>>3]));i=i;return}function Bk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5656>>3]=+X(+(+h[b+7856>>3]));i=i;return}function Ck(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1624>>3]=+h[b+5648>>3]*+h[b+1864>>3]+ +h[b+5656>>3]*+h[b+1856>>3];i=i;return}function Dk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1344>>3]=+h[b+5728>>3]*+h[b+1608>>3]+ +h[b+5744>>3]*+h[b+1624>>3];i=i;return}function Ek(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1064>>3]=+h[b+5824>>3]*+h[b+1336>>3]+ +h[b+5832>>3]*+h[b+1344>>3];i=i;return}function Fk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1056>>3]=+h[b+5800>>3]*+h[b+1336>>3]+ +h[b+5808>>3]*+h[b+1344>>3];i=i;return}function Gk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+744>>3]=+h[b+1056>>3]+ +h[b+240>>3];i=i;return}function Hk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1328>>3]=+h[b+5680>>3]*+h[b+1608>>3]+ +h[b+5696>>3]*+h[b+1624>>3];i=i;return}function Ik(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1048>>3]=+h[b+1328>>3]+ +h[b+248>>3];i=i;return}function Jk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+752>>3]=+h[b+5904>>3]*+h[b+1048>>3]+ +h[b+5920>>3]*+h[b+1064>>3];i=i;return}function Kk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+736>>3]=+h[b+5856>>3]*+h[b+1048>>3]+ +h[b+5872>>3]*+h[b+1064>>3];i=i;return}function Lk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1832>>3]=+h[b+5648>>3]*+h[b+2024>>3]+ +h[b+5656>>3]*+h[b+2e3>>3];i=i;return}function Mk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1400>>3]=+h[b+1680>>3]+(+h[b+5376>>3]*+h[d+2544>>3]+(+h[b+1576>>3]*+h[d+2552>>3]+ +h[b+1832>>3]*+h[d+2560>>3]));i=i;return}function Nk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1296>>3]=+h[b+5680>>3]*+h[b+5376>>3]+ +h[b+5696>>3]*+h[b+1832>>3];i=i;return}function Ok(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1552>>3]=+h[b+5728>>3]*+h[b+5376>>3]+ +h[b+5744>>3]*+h[b+1832>>3];i=i;return}function Pk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1120>>3]=+h[b+1400>>3]+(+h[b+1296>>3]*+h[d+3176>>3]+(+h[b+1576>>3]*+h[d+3184>>3]+ +h[b+1552>>3]*+h[d+3192>>3]));i=i;return}function Qk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+976>>3]=+h[b+5800>>3]*+h[b+1576>>3]+ +h[b+5808>>3]*+h[b+1552>>3];i=i;return}function Rk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1272>>3]=+h[b+5824>>3]*+h[b+1576>>3]+ +h[b+5832>>3]*+h[b+1552>>3];i=i;return}function Sk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+808>>3]=+h[b+1120>>3]+(+h[b+1296>>3]*+h[d+3808>>3]+(+h[b+976>>3]*+h[d+3816>>3]+ +h[b+1272>>3]*+h[d+3824>>3]));i=i;return}function Tk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+952>>3]=+h[b+5856>>3]*+h[b+1296>>3]+ +h[b+5872>>3]*+h[b+1272>>3];i=i;return}function Uk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1e3>>3]=+h[b+5904>>3]*+h[b+1296>>3]+ +h[b+5920>>3]*+h[b+1272>>3];i=i;return}function Vk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+640>>3]=+h[b+808>>3]+(+h[b+952>>3]*+h[d+4440>>3]+(+h[b+976>>3]*+h[d+4448>>3]+ +h[b+1e3>>3]*+h[d+4456>>3]));i=i;return}function Wk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+712>>3]=+h[b+640>>3]+(+h[b+952>>3]*+h[d+5072>>3]+(+h[b+976>>3]*+h[d+5080>>3]+ +h[b+1e3>>3]*+h[d+5088>>3]));i=i;return}function Xk(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1616>>3];e=c[a+416>>2]|0;f=+h[e+2560>>3];g=+h[b+1624>>3];j=+h[e+2552>>3];k=+h[e+2544>>3];l=+h[b+1608>>3];h[b+1472>>3]=+h[b+1752>>3]+(+h[b+5376>>3]*(d*f-g*j)+(+h[b+1576>>3]*(g*k-f*l)+ +h[b+1832>>3]*(j*l-d*k)));i=i;return}function Yk(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1336>>3];e=c[a+416>>2]|0;f=+h[e+3192>>3];g=+h[b+1344>>3];j=+h[e+3184>>3];k=+h[e+3176>>3];l=+h[b+1328>>3];h[b+1192>>3]=+h[b+1472>>3]+(+h[b+1296>>3]*(d*f-g*j)+(+h[b+1576>>3]*(g*k-f*l)+ +h[b+1552>>3]*(j*l-d*k)));i=i;return}function Zk(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1056>>3];e=c[a+416>>2]|0;f=+h[e+3824>>3];g=+h[b+1064>>3];j=+h[e+3816>>3];k=+h[e+3808>>3];l=+h[b+1048>>3];h[b+880>>3]=+h[b+1192>>3]+(+h[b+1296>>3]*(d*f-g*j)+(+h[b+976>>3]*(g*k-f*l)+ +h[b+1272>>3]*(j*l-d*k)));i=i;return}function _k(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+744>>3];e=c[a+416>>2]|0;f=+h[e+4456>>3];g=+h[b+752>>3];j=+h[e+4448>>3];k=+h[e+4440>>3];l=+h[b+736>>3];h[b+688>>3]=+h[b+880>>3]+(+h[b+952>>3]*(d*f-g*j)+(+h[b+976>>3]*(g*k-f*l)+ +h[b+1e3>>3]*(j*l-d*k)));i=i;return}function $k(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1824>>3]=+h[b+5648>>3]*+h[b+2016>>3]+ +h[b+5656>>3]*+h[b+1992>>3];i=i;return}function al(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1408>>3]=+h[b+1688>>3]+(+h[b+1568>>3]*+h[d+2552>>3]+ +h[b+1824>>3]*+h[d+2560>>3]);i=i;return}function bl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1288>>3]=+h[b+5696>>3]*+h[b+1824>>3];i=i;return}function cl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1544>>3]=+h[b+5744>>3]*+h[b+1824>>3];i=i;return}function dl(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1128>>3]=+h[b+1408>>3]+(+h[b+1288>>3]*+h[d+3176>>3]+(+h[b+1568>>3]*+h[d+3184>>3]+ +h[b+1544>>3]*+h[d+3192>>3]));i=i;return}function el(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+984>>3]=+h[b+5800>>3]*+h[b+1568>>3]+ +h[b+5808>>3]*+h[b+1544>>3];i=i;return}function fl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1264>>3]=+h[b+5824>>3]*+h[b+1568>>3]+ +h[b+5832>>3]*+h[b+1544>>3];i=i;return}function gl(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+816>>3]=+h[b+1128>>3]+(+h[b+1288>>3]*+h[d+3808>>3]+(+h[b+984>>3]*+h[d+3816>>3]+ +h[b+1264>>3]*+h[d+3824>>3]));i=i;return}function hl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+960>>3]=+h[b+5856>>3]*+h[b+1288>>3]+ +h[b+5872>>3]*+h[b+1264>>3];i=i;return}function il(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1008>>3]=+h[b+5904>>3]*+h[b+1288>>3]+ +h[b+5920>>3]*+h[b+1264>>3];i=i;return}function jl(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+648>>3]=+h[b+816>>3]+(+h[b+960>>3]*+h[d+4440>>3]+(+h[b+984>>3]*+h[d+4448>>3]+ +h[b+1008>>3]*+h[d+4456>>3]));i=i;return}function kl(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+720>>3]=+h[b+648>>3]+(+h[b+960>>3]*+h[d+5072>>3]+(+h[b+984>>3]*+h[d+5080>>3]+ +h[b+1008>>3]*+h[d+5088>>3]));i=i;return}function ll(a){a=a|0;var b=0,d=0,e=0.0,f=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+2544>>3];f=+h[b+1608>>3];h[b+1480>>3]=+h[b+1760>>3]+(+h[b+1568>>3]*(+h[b+1624>>3]*e-f*+h[d+2560>>3])+ +h[b+1824>>3]*(f*+h[d+2552>>3]-e*+h[b+1616>>3]));i=i;return}function ml(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1336>>3];e=c[a+416>>2]|0;f=+h[e+3192>>3];g=+h[b+1344>>3];j=+h[e+3184>>3];k=+h[e+3176>>3];l=+h[b+1328>>3];h[b+1200>>3]=+h[b+1480>>3]+(+h[b+1288>>3]*(d*f-g*j)+(+h[b+1568>>3]*(g*k-f*l)+ +h[b+1544>>3]*(j*l-d*k)));i=i;return}function nl(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1056>>3];e=c[a+416>>2]|0;f=+h[e+3824>>3];g=+h[b+1064>>3];j=+h[e+3816>>3];k=+h[e+3808>>3];l=+h[b+1048>>3];h[b+888>>3]=+h[b+1200>>3]+(+h[b+1288>>3]*(d*f-g*j)+(+h[b+984>>3]*(g*k-f*l)+ +h[b+1264>>3]*(j*l-d*k)));i=i;return}function ol(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+744>>3];e=c[a+416>>2]|0;f=+h[e+4456>>3];g=+h[b+752>>3];j=+h[e+4448>>3];k=+h[e+4440>>3];l=+h[b+736>>3];h[b+696>>3]=+h[b+888>>3]+(+h[b+960>>3]*(d*f-g*j)+(+h[b+984>>3]*(g*k-f*l)+ +h[b+1008>>3]*(j*l-d*k)));i=i;return}function pl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1816>>3]=+h[b+5648>>3]*+h[b+2008>>3]+ +h[b+5656>>3]*+h[b+1984>>3];i=i;return}function ql(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1416>>3]=+h[b+1696>>3]+(+h[b+5392>>3]*+h[d+2544>>3]+(+h[b+1560>>3]*+h[d+2552>>3]+ +h[b+1816>>3]*+h[d+2560>>3]));i=i;return}function rl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1280>>3]=+h[b+5680>>3]*+h[b+5392>>3]+ +h[b+5696>>3]*+h[b+1816>>3];i=i;return}function sl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1536>>3]=+h[b+5728>>3]*+h[b+5392>>3]+ +h[b+5744>>3]*+h[b+1816>>3];i=i;return}function tl(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1136>>3]=+h[b+1416>>3]+(+h[b+1280>>3]*+h[d+3176>>3]+(+h[b+1560>>3]*+h[d+3184>>3]+ +h[b+1536>>3]*+h[d+3192>>3]));i=i;return}function ul(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+992>>3]=+h[b+5800>>3]*+h[b+1560>>3]+ +h[b+5808>>3]*+h[b+1536>>3];i=i;return}function vl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1256>>3]=+h[b+5824>>3]*+h[b+1560>>3]+ +h[b+5832>>3]*+h[b+1536>>3];i=i;return}function wl(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+824>>3]=+h[b+1136>>3]+(+h[b+1280>>3]*+h[d+3808>>3]+(+h[b+992>>3]*+h[d+3816>>3]+ +h[b+1256>>3]*+h[d+3824>>3]));i=i;return}function xl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+968>>3]=+h[b+5856>>3]*+h[b+1280>>3]+ +h[b+5872>>3]*+h[b+1256>>3];i=i;return}function yl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1016>>3]=+h[b+5904>>3]*+h[b+1280>>3]+ +h[b+5920>>3]*+h[b+1256>>3];i=i;return}function zl(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+656>>3]=+h[b+824>>3]+(+h[b+968>>3]*+h[d+4440>>3]+(+h[b+992>>3]*+h[d+4448>>3]+ +h[b+1016>>3]*+h[d+4456>>3]));i=i;return}function Al(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+728>>3]=+h[b+656>>3]+(+h[b+968>>3]*+h[d+5072>>3]+(+h[b+992>>3]*+h[d+5080>>3]+ +h[b+1016>>3]*+h[d+5088>>3]));i=i;return}function Bl(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1616>>3];e=c[a+416>>2]|0;f=+h[e+2560>>3];g=+h[b+1624>>3];j=+h[e+2552>>3];k=+h[e+2544>>3];l=+h[b+1608>>3];h[b+1488>>3]=+h[b+1768>>3]+(+h[b+5392>>3]*(d*f-g*j)+(+h[b+1560>>3]*(g*k-f*l)+ +h[b+1816>>3]*(j*l-d*k)));i=i;return}function Cl(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1336>>3];e=c[a+416>>2]|0;f=+h[e+3192>>3];g=+h[b+1344>>3];j=+h[e+3184>>3];k=+h[e+3176>>3];l=+h[b+1328>>3];h[b+1208>>3]=+h[b+1488>>3]+(+h[b+1280>>3]*(d*f-g*j)+(+h[b+1560>>3]*(g*k-f*l)+ +h[b+1536>>3]*(j*l-d*k)));i=i;return}function Dl(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1056>>3];e=c[a+416>>2]|0;f=+h[e+3824>>3];g=+h[b+1064>>3];j=+h[e+3816>>3];k=+h[e+3808>>3];l=+h[b+1048>>3];h[b+896>>3]=+h[b+1208>>3]+(+h[b+1280>>3]*(d*f-g*j)+(+h[b+992>>3]*(g*k-f*l)+ +h[b+1256>>3]*(j*l-d*k)));i=i;return}function El(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+744>>3];e=c[a+416>>2]|0;f=+h[e+4456>>3];g=+h[b+752>>3];j=+h[e+4448>>3];k=+h[e+4440>>3];l=+h[b+736>>3];h[b+704>>3]=+h[b+896>>3]+(+h[b+968>>3]*(d*f-g*j)+(+h[b+992>>3]*(g*k-f*l)+ +h[b+1016>>3]*(j*l-d*k)));i=i;return}function Fl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1004>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+8752>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+8752|0;h[c[g+1008>>2]>>3]=+h[j>>3];k=+EQa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+8752>>3]);e=c[f>>2]|0;h[c[e+1012>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1004>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+8744>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+8744|0;h[(c[e+1008>>2]|0)+8>>3]=+h[g>>3];k=+EQa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+8744>>3]);j=c[f>>2]|0;h[(c[j+1012>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1004>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1840>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1840|0;h[(c[j+1008>>2]|0)+16>>3]=+h[e>>3];k=+EQa(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1840>>3]);g=c[f>>2]|0;h[(c[g+1012>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+1004>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1040>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1040|0;h[(c[g+1008>>2]|0)+24>>3]=+h[j>>3];k=+EQa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1040>>3]);e=c[f>>2]|0;h[(c[e+1012>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+1004>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1600>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1600|0;h[(c[e+1008>>2]|0)+32>>3]=+h[g>>3];k=+EQa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1600>>3]);j=c[f>>2]|0;h[(c[j+1012>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+1004>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1584>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1584|0;h[(c[j+1008>>2]|0)+40>>3]=+h[e>>3];k=+EQa(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1584>>3]);g=c[f>>2]|0;h[(c[g+1012>>2]|0)+40>>3]=k;e=c[d>>2]|0;h[(c[g+1004>>2]|0)+48>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+6728>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+6728|0;h[(c[g+1008>>2]|0)+48>>3]=+h[j>>3];k=+EQa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+6728>>3]);e=c[f>>2]|0;h[(c[e+1012>>2]|0)+48>>3]=k;j=c[d>>2]|0;h[(c[e+1004>>2]|0)+56>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+7112>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+7112|0;h[(c[e+1008>>2]|0)+56>>3]=+h[g>>3];k=+EQa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+7112>>3]);j=c[f>>2]|0;h[(c[j+1012>>2]|0)+56>>3]=k;g=c[d>>2]|0;h[(c[j+1004>>2]|0)+64>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+6344>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+6344|0;h[(c[j+1008>>2]|0)+64>>3]=+h[e>>3];k=+EQa(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+6344>>3]);h[(c[(c[f>>2]|0)+1012>>2]|0)+64>>3]=k;CQa(a,12)|0;g=c[(c[f>>2]|0)+1004>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+8752>>3]=+h[g>>3];h[f+8744>>3]=+h[g+8>>3];h[f+1840>>3]=+h[g+16>>3];h[f+1040>>3]=+h[g+24>>3];h[f+1600>>3]=+h[g+32>>3];h[f+1584>>3]=+h[g+40>>3];h[f+6728>>3]=+h[g+48>>3];h[f+7112>>3]=+h[g+56>>3];h[f+6344>>3]=+h[g+64>>3];Lq(a);Mq(a);Nq(a);Oq(a);Pq(a);Qq(a);Rq(a);Sq(a);Tq(a);Uq(a);Vq(a);Wq(a);Xq(a);Yq(a);Zq(a);_q(a);$q(a);ar(a);br(a);cr(a);dr(a);er(a);fr(a);gr(a);hr(a);ir(a);jr(a);kr(a);lr(a);mr(a);nr(a);or(a);pr(a);qr(a);rr(a);sr(a);tr(a);ur(a);vr(a);wr(a);xr(a);yr(a);zr(a);Ar(a);Br(a);Cr(a);Dr(a);Er(a);Fr(a);Gr(a);Hr(a);Ir(a);Jr(a);Kr(a);Lr(a);Mr(a);Nr(a);Or(a);Pr(a);Qr(a);Rr(a);Sr(a);Tr(a);Ur(a);Vr(a);Wr(a);Xr(a);Yr(a);Zr(a);_r(a);$r(a);as(a);bs(a);cs(a);ds(a);es(a);fs(a);gs(a);hs(a);is(a);js(a);ks(a);ls(a);ms(a);ns(a);os(a);ps(a);qs(a);rs(a);ss(a);ts(a);us(a);vs(a);ws(a);xs(a);ys(a);zs(a);As(a);Bs(a);Cs(a);Ds(a);Es(a);Fs(a);Gs(a);Hs(a);Is(a);Js(a);Ks(a);Ls(a);Ms(a);Ns(a);Os(a);Ps(a);Qs(a);Rs(a);Ss(a);Ts(a);Us(a);Vs(a);Ws(a);Xs(a);Ys(a);Zs(a);_s(a);$s(a);at(a);bt(a);ct(a);dt(a);et(a);ft(a);gt(a);ht(a);it(a);jt(a);kt(a);lt(a);mt(a);nt(a);ot(a);pt(a);qt(a);rt(a);st(a);tt(a);ut(a);vt(a);wt(a);xt(a);yt(a);zt(a);At(a);i=b;return}function Gl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6720>>3]=+h[b+6712>>3]*+h[b+6704>>3];i=i;return}function Hl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+49|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+49|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[b+360>>2]|0)+49|0]|0)|0;a[(c[b+352>>2]|0)+49|0]=k;f=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[b+360>>2]|0)+49|0]|0)|0;a[(c[b+352>>2]|0)+49|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+49|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;a[(c[b+352>>2]|0)+49|0]=j;f=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;a[(c[b+352>>2]|0)+49|0]=g;f=g;break}}}}while(0);g=b+404|0;do{if(((c[(c[g>>2]|0)+400>>2]|0)+ -1|0)>>>0<2){if(f<<24>>24==0){break}else{l=1}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+400|0;x=w;c[x>>2]=l;i=d;return}else{if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+6|0]|0)!=0&f<<24>>24!=0){l=1}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+400|0;x=w;c[x>>2]=l;i=d;return}}while(0);do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+45|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){j=a[(c[b+356>>2]|0)+45|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[b+360>>2]|0)+45|0]|0)|0;a[(c[b+352>>2]|0)+45|0]=k;y=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[b+360>>2]|0)+45|0]|0)|0;a[(c[b+352>>2]|0)+45|0]=j;y=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+45|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;a[(c[b+352>>2]|0)+45|0]=j;y=f;break}else{f=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;a[(c[b+352>>2]|0)+45|0]=f;y=f;break}}}}while(0);e=c[(c[g>>2]|0)+400>>2]|0;do{if(!((e|0)==2|(e|0)==-1)){if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){l=0}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+400|0;x=w;c[x>>2]=l;i=d;return}}while(0);l=(y<<24>>24!=0)<<31>>31;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+400|0;x=w;c[x>>2]=l;i=d;return}function Il(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+536>>3]=+h[b+8776>>3];i=i;return}function Jl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7104>>3]=+h[b+7096>>3]*+h[b+7088>>3];i=i;return}function Kl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+53|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+53|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[b+360>>2]|0)+53|0]|0)|0;a[(c[b+352>>2]|0)+53|0]=k;f=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[b+360>>2]|0)+53|0]|0)|0;a[(c[b+352>>2]|0)+53|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+53|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0)|0;a[(c[b+352>>2]|0)+53|0]=j;f=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0)|0;a[(c[b+352>>2]|0)+53|0]=g;f=g;break}}}}while(0);g=b+404|0;do{if(((c[(c[g>>2]|0)+404>>2]|0)+ -1|0)>>>0<2){if(f<<24>>24==0){break}else{l=1}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+404|0;x=w;c[x>>2]=l;i=d;return}else{if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+9|0]|0)!=0&f<<24>>24!=0){l=1}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+404|0;x=w;c[x>>2]=l;i=d;return}}while(0);do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+33|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){j=a[(c[b+356>>2]|0)+33|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[b+360>>2]|0)+33|0]|0)|0;a[(c[b+352>>2]|0)+33|0]=k;y=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[b+360>>2]|0)+33|0]|0)|0;a[(c[b+352>>2]|0)+33|0]=j;y=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+33|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0)|0;a[(c[b+352>>2]|0)+33|0]=j;y=f;break}else{f=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0)|0;a[(c[b+352>>2]|0)+33|0]=f;y=f;break}}}}while(0);e=c[(c[g>>2]|0)+404>>2]|0;do{if(!((e|0)==2|(e|0)==-1)){if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){l=0}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+404|0;x=w;c[x>>2]=l;i=d;return}}while(0);l=(y<<24>>24!=0)<<31>>31;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+404|0;x=w;c[x>>2]=l;i=d;return}function Ll(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+544>>3]=+h[b+8768>>3];i=i;return}function Ml(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6336>>3]=+h[b+6328>>3]*+h[b+6320>>3];i=i;return}function Nl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+41|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+41|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[b+360>>2]|0)+41|0]|0)|0;a[(c[b+352>>2]|0)+41|0]=k;f=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[b+360>>2]|0)+41|0]|0)|0;a[(c[b+352>>2]|0)+41|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+41|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;a[(c[b+352>>2]|0)+41|0]=j;f=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;a[(c[b+352>>2]|0)+41|0]=g;f=g;break}}}}while(0);g=b+404|0;do{if(((c[(c[g>>2]|0)+396>>2]|0)+ -1|0)>>>0<2){if(f<<24>>24==0){break}else{l=1}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+396|0;x=w;c[x>>2]=l;i=d;return}else{if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+3|0]|0)!=0&f<<24>>24!=0){l=1}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+396|0;x=w;c[x>>2]=l;i=d;return}}while(0);do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+37|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){j=a[(c[b+356>>2]|0)+37|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[b+360>>2]|0)+37|0]|0)|0;a[(c[b+352>>2]|0)+37|0]=k;y=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[b+360>>2]|0)+37|0]|0)|0;a[(c[b+352>>2]|0)+37|0]=j;y=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+37|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;a[(c[b+352>>2]|0)+37|0]=j;y=f;break}else{f=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;a[(c[b+352>>2]|0)+37|0]=f;y=f;break}}}}while(0);e=c[(c[g>>2]|0)+396>>2]|0;do{if(!((e|0)==2|(e|0)==-1)){if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){l=0}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+396|0;x=w;c[x>>2]=l;i=d;return}}while(0);l=(y<<24>>24!=0)<<31>>31;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+396|0;x=w;c[x>>2]=l;i=d;return}function Ol(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+528>>3]=+h[b+8784>>3];i=i;return}function Pl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+560>>3]=+h[b+8752>>3];i=i;return}function Ql(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8728>>3]=+h[(c[a+416>>2]|0)+10056>>3]*+h[b+8752>>3];i=i;return}function Rl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7880>>3]=+h[b+8728>>3]- +h[b+7920>>3];i=i;return}function Sl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+432>>3]=+h[b+7880>>3];i=i;return}function Tl(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2048>>3]=+h[b+1400>>3]*+h[d+2872>>3]- +h[b+1408>>3]*+h[d+2864>>3];i=i;return}function Ul(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2032>>3]=+h[b+1408>>3]*+h[d+2880>>3]- +h[b+1416>>3]*+h[d+2872>>3];i=i;return}function Vl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+568>>3]=+h[b+8744>>3];i=i;return}function Wl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8736>>3]=+h[(c[a+416>>2]|0)+9368>>3]*+h[b+8744>>3];i=i;return}function Xl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8288>>3]=+h[b+8736>>3]- +h[b+8328>>3];i=i;return}function Yl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+480>>3]=+h[b+8288>>3];i=i;return}function Zl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2336>>3]=+h[b+2112>>3]- +h[b+2880>>3];i=i;return}function _l(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2104>>3]=+h[b+2016>>3]*+h[b+2312>>3]+ +h[b+1992>>3]*+h[b+2304>>3];i=i;return}function $l(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2152>>3]=+h[b+2104>>3]- +h[b+2872>>3];i=i;return}function am(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2432>>3]=+h[b+2152>>3]- +h[b+3032>>3];i=i;return}function bm(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2056>>3]=+h[b+1296>>3]*+h[d+2104>>3]+ +h[d+2360>>3]- +h[b+1288>>3]*+h[d+2112>>3];i=i;return}function cm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2328>>3]=-+h[b+2056>>3]- +h[b+2032>>3];i=i;return}function dm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2344>>3]=+h[b+2096>>3]- +h[b+2864>>3];i=i;return}function em(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2424>>3]=+h[b+5376>>3]*+h[b+2344>>3]+ +h[b+5424>>3]*+h[b+2336>>3];i=i;return}function fm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2440>>3]=+h[b+5392>>3]*+h[b+2344>>3]+ +h[b+5440>>3]*+h[b+2336>>3];i=i;return}function gm(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2408>>3]=+h[b+664>>3]*+h[d+2424>>3]+(-(+h[b+648>>3]*+h[d+2440>>3])- +h[d+2352>>3]);i=i;return}function hm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8760>>3]=+h[b+1584>>3]- +h[b+8752>>3];i=i;return}function im(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=+h[b+8760>>3];i=i;return}function jm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8720>>3]=+h[(c[a+416>>2]|0)+10744>>3]*+h[b+8760>>3];i=i;return}function km(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7472>>3]=+h[b+8720>>3]- +h[b+7512>>3];i=i;return}function lm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+384>>3]=+h[b+7472>>3];i=i;return}function mm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2080>>3]=+h[b+5528>>3]*+h[b+2296>>3]+ +h[b+5520>>3]*+h[b+2288>>3];i=i;return}function nm(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2072>>3]=+h[b+1288>>3]*+h[d+2096>>3]+(-(+h[b+1280>>3]*+h[d+2104>>3])- +h[d+2080>>3]);i=i;return}function om(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2320>>3]=-+h[b+2072>>3]- +h[b+2048>>3];i=i;return}function pm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2144>>3]=+h[b+5376>>3]*+h[b+2328>>3]+ +h[b+5424>>3]*+h[b+2320>>3];i=i;return}function qm(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2128>>3]=+h[b+664>>3]*+h[d+2152>>3]+(-(+h[b+656>>3]*+h[d+2440>>3])- +h[d+2144>>3]);i=i;return}function rm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2400>>3]=-+h[b+2128>>3]- +h[b+3e3>>3];i=i;return}function sm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2136>>3]=+h[b+5392>>3]*+h[b+2328>>3]+ +h[b+5440>>3]*+h[b+2320>>3];i=i;return}function tm(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2120>>3]=+h[b+656>>3]*+h[d+2424>>3]+(-(+h[b+648>>3]*+h[d+2152>>3])- +h[d+2136>>3]);i=i;return}function um(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2416>>3]=-+h[b+2120>>3]- +h[b+3016>>3];i=i;return}function vm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+7856>>3]));h[b+2760>>3]=-(d*+h[b+8792>>3]);i=i;return}function wm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+7856>>3]));h[b+2752>>3]=-(d*+h[b+8792>>3]);i=i;return}function xm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2536>>3]=+h[b+5648>>3]*+h[b+2488>>3]+(+h[b+2752>>3]*+h[b+2016>>3]+(+h[b+5656>>3]*+h[b+2512>>3]+ +h[b+2760>>3]*+h[b+1992>>3]));i=i;return}function ym(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2608>>3]=+h[b+5696>>3]*+h[b+2536>>3]+ +h[b+2776>>3]*+h[b+1824>>3];i=i;return}function zm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2584>>3]=+h[b+5744>>3]*+h[b+2536>>3]+ +h[b+2792>>3]*+h[b+1824>>3];i=i;return}function Am(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2544>>3]=+h[b+5648>>3]*+h[b+2496>>3]+(+h[b+2752>>3]*+h[b+2008>>3]+(+h[b+5656>>3]*+h[b+2520>>3]+ +h[b+2760>>3]*+h[b+1984>>3]));i=i;return}function Bm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2616>>3]=+h[b+5680>>3]*+h[b+2456>>3]+(+h[b+2768>>3]*+h[b+5392>>3]+(+h[b+5696>>3]*+h[b+2544>>3]+ +h[b+2776>>3]*+h[b+1816>>3]));i=i;return}function Cm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2592>>3]=+h[b+5728>>3]*+h[b+2456>>3]+(+h[b+2784>>3]*+h[b+5392>>3]+(+h[b+5744>>3]*+h[b+2544>>3]+ +h[b+2792>>3]*+h[b+1816>>3]));i=i;return}function Dm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2528>>3]=+h[b+5648>>3]*+h[b+2480>>3]+(+h[b+2752>>3]*+h[b+2024>>3]+(+h[b+5656>>3]*+h[b+2504>>3]+ +h[b+2760>>3]*+h[b+2e3>>3]));i=i;return}function Em(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2600>>3]=+h[b+5680>>3]*+h[b+2448>>3]+(+h[b+2768>>3]*+h[b+5376>>3]+(+h[b+5696>>3]*+h[b+2528>>3]+ +h[b+2776>>3]*+h[b+1832>>3]));i=i;return}function Fm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2576>>3]=+h[b+5728>>3]*+h[b+2448>>3]+(+h[b+2784>>3]*+h[b+5376>>3]+(+h[b+5744>>3]*+h[b+2528>>3]+ +h[b+2792>>3]*+h[b+1832>>3]));i=i;return}function Gm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+7856>>3]));h[b+2744>>3]=d*+h[b+8792>>3];i=i;return}function Hm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+7856>>3]));h[b+2736>>3]=-(d*+h[b+8792>>3]);i=i;return}function Im(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2560>>3]=+h[b+5624>>3]*+h[b+2488>>3]+(+h[b+2736>>3]*+h[b+2016>>3]+(+h[b+5632>>3]*+h[b+2512>>3]+ +h[b+2744>>3]*+h[b+1992>>3]));i=i;return}function Jm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2680>>3]=+h[b+5800>>3]*+h[b+2560>>3]+(+h[b+2800>>3]*+h[b+1568>>3]+(+h[b+5808>>3]*+h[b+2584>>3]+ +h[b+2808>>3]*+h[b+1544>>3]));i=i;return}function Km(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2632>>3]=+h[b+5824>>3]*+h[b+2560>>3]+(+h[b+2816>>3]*+h[b+1568>>3]+(+h[b+5832>>3]*+h[b+2584>>3]+ +h[b+2824>>3]*+h[b+1544>>3]));i=i;return}function Lm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2656>>3]=+h[b+5856>>3]*+h[b+2608>>3]+(+h[b+2832>>3]*+h[b+1288>>3]+(+h[b+5872>>3]*+h[b+2632>>3]+ +h[b+2840>>3]*+h[b+1264>>3]));i=i;return}function Mm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2704>>3]=+h[b+5904>>3]*+h[b+2608>>3]+(+h[b+2848>>3]*+h[b+1288>>3]+(+h[b+5920>>3]*+h[b+2632>>3]+ +h[b+2856>>3]*+h[b+1264>>3]));i=i;return}function Nm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2568>>3]=+h[b+5624>>3]*+h[b+2496>>3]+(+h[b+2736>>3]*+h[b+2008>>3]+(+h[b+5632>>3]*+h[b+2520>>3]+ +h[b+2744>>3]*+h[b+1984>>3]));i=i;return}function Om(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2688>>3]=+h[b+5800>>3]*+h[b+2568>>3]+(+h[b+2800>>3]*+h[b+1560>>3]+(+h[b+5808>>3]*+h[b+2592>>3]+ +h[b+2808>>3]*+h[b+1536>>3]));i=i;return}function Pm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2640>>3]=+h[b+5824>>3]*+h[b+2568>>3]+(+h[b+2816>>3]*+h[b+1560>>3]+(+h[b+5832>>3]*+h[b+2592>>3]+ +h[b+2824>>3]*+h[b+1536>>3]));i=i;return}function Qm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2664>>3]=+h[b+5856>>3]*+h[b+2616>>3]+(+h[b+2832>>3]*+h[b+1280>>3]+(+h[b+5872>>3]*+h[b+2640>>3]+ +h[b+2840>>3]*+h[b+1256>>3]));i=i;return}function Rm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2712>>3]=+h[b+5904>>3]*+h[b+2616>>3]+(+h[b+2848>>3]*+h[b+1280>>3]+(+h[b+5920>>3]*+h[b+2640>>3]+ +h[b+2856>>3]*+h[b+1256>>3]));i=i;return}function Sm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2552>>3]=+h[b+5624>>3]*+h[b+2480>>3]+(+h[b+2736>>3]*+h[b+2024>>3]+(+h[b+5632>>3]*+h[b+2504>>3]+ +h[b+2744>>3]*+h[b+2e3>>3]));i=i;return}function Tm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2672>>3]=+h[b+5800>>3]*+h[b+2552>>3]+(+h[b+2800>>3]*+h[b+1576>>3]+(+h[b+5808>>3]*+h[b+2576>>3]+ +h[b+2808>>3]*+h[b+1552>>3]));i=i;return}function Um(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2624>>3]=+h[b+5824>>3]*+h[b+2552>>3]+(+h[b+2816>>3]*+h[b+1576>>3]+(+h[b+5832>>3]*+h[b+2576>>3]+ +h[b+2824>>3]*+h[b+1552>>3]));i=i;return}function Vm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2648>>3]=+h[b+5856>>3]*+h[b+2600>>3]+(+h[b+2832>>3]*+h[b+1296>>3]+(+h[b+5872>>3]*+h[b+2624>>3]+ +h[b+2840>>3]*+h[b+1272>>3]));i=i;return}function Wm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2696>>3]=+h[b+5904>>3]*+h[b+2600>>3]+(+h[b+2848>>3]*+h[b+1296>>3]+(+h[b+5920>>3]*+h[b+2624>>3]+ +h[b+2856>>3]*+h[b+1272>>3]));i=i;return}function Xm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7488>>3]=+h[b+112>>3]- +h[b+104>>3];i=i;return}function Ym(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7624>>3]=+h[b+7488>>3]- +h[(c[a+416>>2]|0)+10560>>3];i=i;return}function Zm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7576>>3]=+h[b+7592>>3]- +h[b+7488>>3];i=i;return}function _m(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7568>>3]=+h[(c[a+416>>2]|0)+10640>>3]*+h[b+7576>>3];i=i;return}function $m(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7560>>3]=+h[b+10616>>3]*+h[d+7584>>3]+(+h[b+10624>>3]*+h[d+7568>>3]+ +h[b+10632>>3]*+h[d+7616>>3]);i=i;return}function an(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+10656>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7560>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1656,1648,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}function bn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7872>>3]=+h[(c[a+416>>2]|0)+10648>>3]*(+h[b+120>>3]+ +h[b+7560>>3]);i=i;return}function cn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7840>>3]=+h[(c[a+416>>2]|0)+10536>>3]*+h[b+7872>>3];i=i;return}function dn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7792>>3]=+h[b+7840>>3]- +h[b+7696>>3];i=i;return}function en(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9608>>3];k=+h[g+7792>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+7760|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+7760|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,1688,1680,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7760|0;p=o;h[p>>3]=m;i=d;return}function fn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7768>>3]=+h[b+9592>>3]*+h[b+7760>>3];i=i;return}function gn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7744>>3]=+h[b+7696>>3]- +h[b+7768>>3];i=i;return}function hn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9584>>3];k=+h[g+7744>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+7776|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+7776|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,1728,1720,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7776|0;p=o;h[p>>3]=m;i=d;return}function jn(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+10576>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7776>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+416|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+416|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1760,1752,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+416|0;p=o;h[p>>3]=m;i=d;return}function kn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7736>>3]=+h[b+7744>>3]*+h[b+7776>>3];i=i;return}function ln(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7752>>3]=+h[b+7768>>3]*+h[b+7760>>3];i=i;return}function mn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7832>>3]=+h[b+7760>>3]- +h[b+7776>>3];i=i;return}function nn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7656>>3]=+h[b+7776>>3]-(-+h[b+7832>>3]- +h[b+7816>>3]- +h[b+7688>>3]);i=i;return}function on(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7784>>3]=+h[b+7792>>3]*+h[b+7760>>3];i=i;return}function pn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7240>>3]=+h[(c[a+416>>2]|0)+11400>>3]*+h[b+88>>3];i=i;return}function qn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7200>>3]=+h[b+7240>>3]- +h[(c[a+416>>2]|0)+11232>>3];i=i;return}function rn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7152>>3]=+h[b+7168>>3]- +h[b+7240>>3];i=i;return}function sn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7144>>3]=+h[(c[a+416>>2]|0)+11312>>3]*+h[b+7152>>3];i=i;return}function tn(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7136>>3]=+h[b+11288>>3]*+h[d+7160>>3]+(+h[b+11296>>3]*+h[d+7144>>3]+ +h[b+11304>>3]*+h[d+7192>>3]);i=i;return}function un(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+11328>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7136>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+352|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+352|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1784,1776,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+352|0;p=o;h[p>>3]=m;i=d;return}function vn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7464>>3]=+h[(c[a+416>>2]|0)+11320>>3]*(+h[b+64>>3]+ +h[b+7136>>3]);i=i;return}function wn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7432>>3]=+h[(c[a+416>>2]|0)+11208>>3]*+h[b+7464>>3];i=i;return}function xn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7384>>3]=+h[b+7432>>3]- +h[b+7288>>3];i=i;return}function yn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9528>>3];k=+h[g+7384>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+7352|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+7352|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,1816,1808,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7352|0;p=o;h[p>>3]=m;i=d;return}function zn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7360>>3]=+h[b+9512>>3]*+h[b+7352>>3];i=i;return}function An(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7336>>3]=+h[b+7288>>3]- +h[b+7360>>3];i=i;return}function Bn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9504>>3];k=+h[g+7336>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+7368|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+7368|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,1856,1848,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7368|0;p=o;h[p>>3]=m;i=d;return}function Cn(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+11248>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7368>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+360|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+360|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1888,1880,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+360|0;p=o;h[p>>3]=m;i=d;return}function Dn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7328>>3]=+h[b+7336>>3]*+h[b+7368>>3];i=i;return}function En(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7344>>3]=+h[b+7360>>3]*+h[b+7352>>3];i=i;return}function Fn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7424>>3]=+h[b+7352>>3]- +h[b+7368>>3];i=i;return}function Gn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7248>>3]=+h[b+7368>>3]-(-+h[b+7424>>3]- +h[b+7408>>3]- +h[b+7280>>3]);i=i;return}function Hn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7376>>3]=+h[b+7384>>3]*+h[b+7352>>3];i=i;return}function In(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6856>>3]=+h[(c[a+416>>2]|0)+12024>>3]*+h[b+56>>3];i=i;return}function Jn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6816>>3]=+h[b+6856>>3]- +h[(c[a+416>>2]|0)+11856>>3];i=i;return}function Kn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6768>>3]=+h[b+6784>>3]- +h[b+6856>>3];i=i;return}function Ln(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6760>>3]=+h[(c[a+416>>2]|0)+11936>>3]*+h[b+6768>>3];i=i;return}function Mn(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6752>>3]=+h[b+11912>>3]*+h[d+6776>>3]+(+h[b+11920>>3]*+h[d+6760>>3]+ +h[b+11928>>3]*+h[d+6808>>3]);i=i;return}function Nn(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+11952>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6752>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,1912,1904,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}function On(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7080>>3]=+h[(c[a+416>>2]|0)+11944>>3]*(+h[b+32>>3]+ +h[b+6752>>3]);i=i;return}function Pn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7048>>3]=+h[(c[a+416>>2]|0)+11832>>3]*+h[b+7080>>3];i=i;return}function Qn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7e3>>3]=+h[b+7048>>3]- +h[b+6904>>3];i=i;return}function Rn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9448>>3];k=+h[g+7e3>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6968|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6968|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,1944,1936,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6968|0;p=o;h[p>>3]=m;i=d;return}function Sn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6976>>3]=+h[b+9432>>3]*+h[b+6968>>3];i=i;return}function Tn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6952>>3]=+h[b+6904>>3]- +h[b+6976>>3];i=i;return}function Un(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9424>>3];k=+h[g+6952>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6984|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6984|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,1984,1976,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6984|0;p=o;h[p>>3]=m;i=d;return}function Vn(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+11872>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6984>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+328|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+328|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,2016,2008,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+328|0;p=o;h[p>>3]=m;i=d;return}function Wn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6944>>3]=+h[b+6952>>3]*+h[b+6984>>3];i=i;return}function Xn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6960>>3]=+h[b+6976>>3]*+h[b+6968>>3];i=i;return}function Yn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7040>>3]=+h[b+6968>>3]- +h[b+6984>>3];i=i;return}function Zn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6864>>3]=+h[b+6984>>3]-(-+h[b+7040>>3]- +h[b+7024>>3]- +h[b+6896>>3]);i=i;return}function _n(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6992>>3]=+h[b+7e3>>3]*+h[b+6968>>3];i=i;return}function $n(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6472>>3]=+h[(c[a+416>>2]|0)+12648>>3]*+h[b+24>>3];i=i;return}function ao(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6432>>3]=+h[b+6472>>3]- +h[(c[a+416>>2]|0)+12480>>3];i=i;return}function bo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6384>>3]=+h[b+6400>>3]- +h[b+6472>>3];i=i;return}function co(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6376>>3]=+h[(c[a+416>>2]|0)+12560>>3]*+h[b+6384>>3];i=i;return}function eo(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6368>>3]=+h[b+12536>>3]*+h[d+6392>>3]+(+h[b+12544>>3]*+h[d+6376>>3]+ +h[b+12552>>3]*+h[d+6424>>3]);i=i;return}function fo(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+12576>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6368>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+288|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+288|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,2040,2032,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+288|0;p=o;h[p>>3]=m;i=d;return}function go(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6696>>3]=+h[(c[a+416>>2]|0)+12568>>3]*(+h[b>>3]+ +h[b+6368>>3]);i=i;return}function ho(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6664>>3]=+h[(c[a+416>>2]|0)+12456>>3]*+h[b+6696>>3];i=i;return}function io(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6616>>3]=+h[b+6664>>3]- +h[b+6520>>3];i=i;return}function jo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9368>>3];k=+h[g+6616>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6584|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6584|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,2072,2064,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6584|0;p=o;h[p>>3]=m;i=d;return}function ko(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6592>>3]=+h[b+9352>>3]*+h[b+6584>>3];i=i;return}function lo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6568>>3]=+h[b+6520>>3]- +h[b+6592>>3];i=i;return}function mo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9344>>3];k=+h[g+6568>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6600|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6600|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,j,2112,2104,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6600|0;p=o;h[p>>3]=m;i=d;return}function no(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+12496>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6600>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+296|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+296|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,2144,2136,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+296|0;p=o;h[p>>3]=m;i=d;return}function oo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6560>>3]=+h[b+6568>>3]*+h[b+6600>>3];i=i;return}function po(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6576>>3]=+h[b+6592>>3]*+h[b+6584>>3];i=i;return}function qo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6656>>3]=+h[b+6584>>3]- +h[b+6600>>3];i=i;return}function ro(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6480>>3]=+h[b+6600>>3]-(-+h[b+6656>>3]- +h[b+6640>>3]- +h[b+6512>>3]);i=i;return}function so(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6608>>3]=+h[b+6616>>3]*+h[b+6584>>3];i=i;return}function to(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8816>>3]=+h[(c[a+416>>2]|0)+12136>>3];i=i;return}function uo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8824>>3]=+h[(c[a+416>>2]|0)+11512>>3];i=i;return}function vo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8832>>3]=+h[(c[a+416>>2]|0)+10888>>3];i=i;return}function wo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8840>>3]=+h[(c[a+416>>2]|0)+10200>>3];i=i;return}function xo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8848>>3]=+h[(c[a+416>>2]|0)+9512>>3];i=i;return}function yo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8856>>3]=+h[(c[a+416>>2]|0)+8824>>3];i=i;return}function zo(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+20|0]=a[d+19|0]|0;i=i;return}function Ao(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+8912>>3]*(+h[f+8920>>3]- +h[f+8904>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Bo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+8944>>3]*(+h[f+8952>>3]- +h[f+8936>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Co(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+8976>>3]*(+h[f+8984>>3]- +h[f+8968>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Do(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+9008>>3]*(+h[f+9016>>3]- +h[f+9e3>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Eo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+9040>>3]*(+h[f+9048>>3]- +h[f+9032>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Fo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+9072>>3]*(+h[f+9080>>3]- +h[f+9064>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Go(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+9104>>3]*(+h[f+9112>>3]- +h[f+9096>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Ho(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+9136>>3]*(+h[f+9144>>3]- +h[f+9128>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Io(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+9600>>3]*(+h[f+9608>>3]- +h[f+9592>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Jo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+9632>>3]*(+h[f+9640>>3]- +h[f+9624>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Ko(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+9664>>3]*(+h[f+9672>>3]- +h[f+9656>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Lo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+9696>>3]*(+h[f+9704>>3]- +h[f+9688>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Mo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+9728>>3]*(+h[f+9736>>3]- +h[f+9720>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function No(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+9760>>3]*(+h[f+9768>>3]- +h[f+9752>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Oo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+9792>>3]*(+h[f+9800>>3]- +h[f+9784>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Po(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+9824>>3]*(+h[f+9832>>3]- +h[f+9816>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Qo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+10288>>3]*(+h[f+10296>>3]- +h[f+10280>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Ro(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+10320>>3]*(+h[f+10328>>3]- +h[f+10312>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function So(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+10352>>3]*(+h[f+10360>>3]- +h[f+10344>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function To(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+10384>>3]*(+h[f+10392>>3]- +h[f+10376>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Uo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+10416>>3]*(+h[f+10424>>3]- +h[f+10408>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Vo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+10448>>3]*(+h[f+10456>>3]- +h[f+10440>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Wo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+10480>>3]*(+h[f+10488>>3]- +h[f+10472>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Xo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+10512>>3]*(+h[f+10520>>3]- +h[f+10504>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Yo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+10960>>3]*(+h[f+10968>>3]- +h[f+10952>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function Zo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+10992>>3]*(+h[f+11e3>>3]- +h[f+10984>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function _o(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+11024>>3]*(+h[f+11032>>3]- +h[f+11016>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function $o(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+11056>>3]*(+h[f+11064>>3]- +h[f+11048>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function ap(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+11088>>3]*(+h[f+11096>>3]- +h[f+11080>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function bp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+11120>>3]*(+h[f+11128>>3]- +h[f+11112>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function cp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+11152>>3]*(+h[f+11160>>3]- +h[f+11144>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function dp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+11184>>3]*(+h[f+11192>>3]- +h[f+11176>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function ep(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+11584>>3]*(+h[f+11592>>3]- +h[f+11576>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function fp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+11616>>3]*(+h[f+11624>>3]- +h[f+11608>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function gp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+11648>>3]*(+h[f+11656>>3]- +h[f+11640>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function hp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+11680>>3]*(+h[f+11688>>3]- +h[f+11672>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function ip(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+11712>>3]*(+h[f+11720>>3]- +h[f+11704>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function jp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+11744>>3]*(+h[f+11752>>3]- +h[f+11736>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function kp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+11776>>3]*(+h[f+11784>>3]- +h[f+11768>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function lp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+11808>>3]*(+h[f+11816>>3]- +h[f+11800>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function mp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+12208>>3]*(+h[f+12216>>3]- +h[f+12200>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function np(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+12240>>3]*(+h[f+12248>>3]- +h[f+12232>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function op(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+12272>>3]*(+h[f+12280>>3]- +h[f+12264>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function pp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+12304>>3]*(+h[f+12312>>3]- +h[f+12296>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function qp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+12336>>3]*(+h[f+12344>>3]- +h[f+12328>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function rp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+12368>>3]*(+h[f+12376>>3]- +h[f+12360>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function sp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+12400>>3]*(+h[f+12408>>3]- +h[f+12392>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}function tp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((fQa(+h[f+12432>>3]*(+h[f+12440>>3]- +h[f+12424>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41884]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2240,e);i=b;return}



function aB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+8|0;r=a+416|0;RNa(+h[(c[r>>2]|0)+6288>>3],2,k);RNa(+h[(c[r>>2]|0)+6296>>3],2,l);RNa(+h[(c[r>>2]|0)+6304>>3],2,n);RNa(+h[(c[r>>2]|0)+6312>>3],2,o);c[g>>2]=l;QNa(2,j,2,k,g);c[f>>2]=o;QNa(2,m,2,n,f);c[e>>2]=m;QNa(1,p,2,j,e);e=c[a+536>>2]|0;j=d;m=p;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];Bp(q,e,0.0,d,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10072>>3]=+h[q>>3];i=b;return}function bB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+8|0;r=a+416|0;RNa(+h[(c[r>>2]|0)+6256>>3],2,k);RNa(+h[(c[r>>2]|0)+6264>>3],2,l);RNa(+h[(c[r>>2]|0)+6272>>3],2,n);RNa(+h[(c[r>>2]|0)+6280>>3],2,o);c[g>>2]=l;QNa(2,j,2,k,g);c[f>>2]=o;QNa(2,m,2,n,f);c[e>>2]=m;QNa(1,p,2,j,e);e=c[a+536>>2]|0;j=d;m=p;c[j+0>>2]=c[m+0>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];Bp(q,e,0.0,d,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9928>>3]=+h[q>>3];i=b;return}function cB(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6200>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,17288,17280,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6144>>3]=.7853981633974483/g;i=d;return}function dB(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6152>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,17328,17320,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6096>>3]=.7853981633974483/g;i=d;return}function eB(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6192>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,17368,17360,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6136>>3]=3.839724354387525/g;i=d;return}function fB(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6144>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,17408,17400,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6088>>3]=3.839724354387525/g;i=d;return}function gB(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6184>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,17448,17440,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6128>>3]=.7853981633974483/g;i=d;return}function hB(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6136>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,17488,17480,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6080>>3]=.7853981633974483/g;i=d;return}function iB(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6176>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,17528,17520,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6120>>3]=-2.181661564992912/g;i=d;return}function jB(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6128>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,17568,17560,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6072>>3]=-2.181661564992912/g;i=d;return}function kB(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6168>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,17608,17600,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6112>>3]=-1.570796326794897/g;i=d;return}function lB(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6120>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,17648,17640,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6064>>3]=-1.570796326794897/g;i=d;return}function mB(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6160>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,17688,17680,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6104>>3]=2.094395102393195/g;i=d;return}function nB(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0;d=i;e=+h[(c[b+416>>2]|0)+6112>>3];if(e!=0.0){f=b+4|0;g=e}else{j=b+4|0;f=j;g=+YMa(c[b+536>>2]|0,e,17728,17720,+h[c[c[j>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6056>>3]=2.094395102393195/g;i=d;return}function oB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0.0;b=i;i=i+40|0;d=b;e=i;i=i+16|0;f=a+4|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;g=+U(+(+h[a+6056>>3]));j=+U(+(+h[a+6064>>3]));l=+U(+(+h[a+6072>>3]));m=+U(+(+h[a+6080>>3]));n=+U(+(+h[a+6088>>3]));o=+U(+(+h[a+6096>>3]));a=d;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=l;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+16|0;h[k>>3]=m;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+24|0;h[k>>3]=n;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+32|0;h[k>>3]=o;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];ONa(e,6,g,d);g=+SNa(e);h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9792>>3]=g;i=b;return}function pB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0.0;b=i;i=i+40|0;d=b;e=i;i=i+16|0;f=a+4|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;g=+U(+(+h[a+6104>>3]));j=+U(+(+h[a+6112>>3]));l=+U(+(+h[a+6120>>3]));m=+U(+(+h[a+6128>>3]));n=+U(+(+h[a+6136>>3]));o=+U(+(+h[a+6144>>3]));a=d;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=l;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+16|0;h[k>>3]=m;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+24|0;h[k>>3]=n;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+32|0;h[k>>3]=o;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];ONa(e,6,g,d);g=+SNa(e);h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9784>>3]=g;i=b;return}function qB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9776>>3]=+h[b+8896>>3]*(+h[b+8912>>3]*(+h[b+8920>>3]- +h[b+8904>>3])+1.0);i=i;return}function rB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9768>>3]=+h[b+8928>>3]*(+h[b+8944>>3]*(+h[b+8952>>3]- +h[b+8936>>3])+1.0);i=i;return}function sB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9752>>3]=+h[b+8960>>3]*(+h[b+8976>>3]*(+h[b+8984>>3]- +h[b+8968>>3])+1.0);i=i;return}function tB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9744>>3]=+h[b+8992>>3]*(+h[b+9008>>3]*(+h[b+9016>>3]- +h[b+9e3>>3])+1.0);i=i;return}function uB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9736>>3]=+h[b+9024>>3]*(+h[b+9040>>3]*(+h[b+9048>>3]- +h[b+9032>>3])+1.0);i=i;return}function vB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9728>>3]=+h[b+9056>>3]*(+h[b+9072>>3]*(+h[b+9080>>3]- +h[b+9064>>3])+1.0);i=i;return}function wB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9720>>3]=+h[b+9088>>3]*(+h[b+9104>>3]*(+h[b+9112>>3]- +h[b+9096>>3])+1.0);i=i;return}function xB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9712>>3]=+h[b+9120>>3]*(+h[b+9136>>3]*(+h[b+9144>>3]- +h[b+9128>>3])+1.0);i=i;return}function yB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9704>>3]=+h[(c[a+416>>2]|0)+9416>>3]*+h[b+9928>>3];i=i;return}function zB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9696>>3]=+h[b+9584>>3]*(+h[b+9600>>3]*(+h[b+9608>>3]- +h[b+9592>>3])+1.0);i=i;return}function AB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9688>>3]=+h[b+9616>>3]*(+h[b+9632>>3]*(+h[b+9640>>3]- +h[b+9624>>3])+1.0);i=i;return}function BB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9672>>3]=+h[b+9648>>3]*(+h[b+9664>>3]*(+h[b+9672>>3]- +h[b+9656>>3])+1.0);i=i;return}function CB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9664>>3]=+h[b+9680>>3]*(+h[b+9696>>3]*(+h[b+9704>>3]- +h[b+9688>>3])+1.0);i=i;return}function DB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9656>>3]=+h[b+9712>>3]*(+h[b+9728>>3]*(+h[b+9736>>3]- +h[b+9720>>3])+1.0);i=i;return}function EB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9648>>3]=+h[b+9744>>3]*(+h[b+9760>>3]*(+h[b+9768>>3]- +h[b+9752>>3])+1.0);i=i;return}function FB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9640>>3]=+h[b+9776>>3]*(+h[b+9792>>3]*(+h[b+9800>>3]- +h[b+9784>>3])+1.0);i=i;return}function GB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9632>>3]=+h[b+9808>>3]*(+h[b+9824>>3]*(+h[b+9832>>3]- +h[b+9816>>3])+1.0);i=i;return}function HB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9624>>3]=+h[(c[a+416>>2]|0)+10104>>3]*+h[b+10072>>3];i=i;return}function IB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9616>>3]=+h[b+10272>>3]*(+h[b+10288>>3]*(+h[b+10296>>3]- +h[b+10280>>3])+1.0);i=i;return}function JB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9608>>3]=+h[b+10304>>3]*(+h[b+10320>>3]*(+h[b+10328>>3]- +h[b+10312>>3])+1.0);i=i;return}function KB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9592>>3]=+h[b+10336>>3]*(+h[b+10352>>3]*(+h[b+10360>>3]- +h[b+10344>>3])+1.0);i=i;return}function LB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9584>>3]=+h[b+10368>>3]*(+h[b+10384>>3]*(+h[b+10392>>3]- +h[b+10376>>3])+1.0);i=i;return}function MB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9576>>3]=+h[b+10400>>3]*(+h[b+10416>>3]*(+h[b+10424>>3]- +h[b+10408>>3])+1.0);i=i;return}function NB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9568>>3]=+h[b+10432>>3]*(+h[b+10448>>3]*(+h[b+10456>>3]- +h[b+10440>>3])+1.0);i=i;return}function OB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9560>>3]=+h[b+10464>>3]*(+h[b+10480>>3]*(+h[b+10488>>3]- +h[b+10472>>3])+1.0);i=i;return}function PB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9552>>3]=+h[b+10496>>3]*(+h[b+10512>>3]*(+h[b+10520>>3]- +h[b+10504>>3])+1.0);i=i;return}function QB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9544>>3]=+h[(c[a+416>>2]|0)+10792>>3]*+h[b+10216>>3];i=i;return}function RB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9536>>3]=+h[b+10944>>3]*(+h[b+10960>>3]*(+h[b+10968>>3]- +h[b+10952>>3])+1.0);i=i;return}function SB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9528>>3]=+h[b+10976>>3]*(+h[b+10992>>3]*(+h[b+11e3>>3]- +h[b+10984>>3])+1.0);i=i;return}function TB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9512>>3]=+h[b+11008>>3]*(+h[b+11024>>3]*(+h[b+11032>>3]- +h[b+11016>>3])+1.0);i=i;return}function UB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9504>>3]=+h[b+11040>>3]*(+h[b+11056>>3]*(+h[b+11064>>3]- +h[b+11048>>3])+1.0);i=i;return}function VB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9496>>3]=+h[b+11072>>3]*(+h[b+11088>>3]*(+h[b+11096>>3]- +h[b+11080>>3])+1.0);i=i;return}function WB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9488>>3]=+h[b+11104>>3]*(+h[b+11120>>3]*(+h[b+11128>>3]- +h[b+11112>>3])+1.0);i=i;return}function XB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9480>>3]=+h[b+11136>>3]*(+h[b+11152>>3]*(+h[b+11160>>3]- +h[b+11144>>3])+1.0);i=i;return}function YB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9472>>3]=+h[b+11168>>3]*(+h[b+11184>>3]*(+h[b+11192>>3]- +h[b+11176>>3])+1.0);i=i;return}function ZB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9464>>3]=+h[(c[a+416>>2]|0)+11416>>3]*+h[b+10360>>3];i=i;return}function _B(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9456>>3]=+h[b+11568>>3]*(+h[b+11584>>3]*(+h[b+11592>>3]- +h[b+11576>>3])+1.0);i=i;return}function $B(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9448>>3]=+h[b+11600>>3]*(+h[b+11616>>3]*(+h[b+11624>>3]- +h[b+11608>>3])+1.0);i=i;return}function aC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9432>>3]=+h[b+11632>>3]*(+h[b+11648>>3]*(+h[b+11656>>3]- +h[b+11640>>3])+1.0);i=i;return}function bC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9424>>3]=+h[b+11664>>3]*(+h[b+11680>>3]*(+h[b+11688>>3]- +h[b+11672>>3])+1.0);i=i;return}function cC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9416>>3]=+h[b+11696>>3]*(+h[b+11712>>3]*(+h[b+11720>>3]- +h[b+11704>>3])+1.0);i=i;return}function dC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9408>>3]=+h[b+11728>>3]*(+h[b+11744>>3]*(+h[b+11752>>3]- +h[b+11736>>3])+1.0);i=i;return}function eC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9400>>3]=+h[b+11760>>3]*(+h[b+11776>>3]*(+h[b+11784>>3]- +h[b+11768>>3])+1.0);i=i;return}function fC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9392>>3]=+h[b+11792>>3]*(+h[b+11808>>3]*(+h[b+11816>>3]- +h[b+11800>>3])+1.0);i=i;return}function gC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9384>>3]=+h[(c[a+416>>2]|0)+12040>>3]*+h[b+10504>>3];i=i;return}function hC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9376>>3]=+h[b+12192>>3]*(+h[b+12208>>3]*(+h[b+12216>>3]- +h[b+12200>>3])+1.0);i=i;return}function iC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9368>>3]=+h[b+12224>>3]*(+h[b+12240>>3]*(+h[b+12248>>3]- +h[b+12232>>3])+1.0);i=i;return}function jC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9352>>3]=+h[b+12256>>3]*(+h[b+12272>>3]*(+h[b+12280>>3]- +h[b+12264>>3])+1.0);i=i;return}function kC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9344>>3]=+h[b+12288>>3]*(+h[b+12304>>3]*(+h[b+12312>>3]- +h[b+12296>>3])+1.0);i=i;return}function lC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9336>>3]=+h[b+12320>>3]*(+h[b+12336>>3]*(+h[b+12344>>3]- +h[b+12328>>3])+1.0);i=i;return}function mC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9328>>3]=+h[b+12352>>3]*(+h[b+12368>>3]*(+h[b+12376>>3]- +h[b+12360>>3])+1.0);i=i;return}function nC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9320>>3]=+h[b+12384>>3]*(+h[b+12400>>3]*(+h[b+12408>>3]- +h[b+12392>>3])+1.0);i=i;return}function oC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9312>>3]=+h[b+12416>>3]*(+h[b+12432>>3]*(+h[b+12440>>3]- +h[b+12424>>3])+1.0);i=i;return}function pC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9304>>3]=+h[(c[a+416>>2]|0)+12664>>3]*+h[b+10648>>3];i=i;return}function qC(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0;d=i;e=b+4|0;f=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;if(!((dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|f)<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+9248|0;r=q;h[r>>3]=g;i=d;return}f=c[c[e>>2]>>2]|0;s=+h[(c[f+8>>2]|0)+9784>>3];if(s!=0.0){t=s}else{t=+YMa(c[b+536>>2]|0,s,17768,17760,+h[f>>3],(a[b+319|0]|0)!=0|0)}g=1.0/t;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+9248|0;r=q;h[r>>3]=g;i=d;return}function rC(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0;d=i;e=b+4|0;f=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;if(!((dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|f)<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+9240|0;r=q;h[r>>3]=g;i=d;return}f=c[c[e>>2]>>2]|0;s=+h[(c[f+8>>2]|0)+9792>>3];if(s!=0.0){t=s}else{t=+YMa(c[b+536>>2]|0,s,17808,17800,+h[f>>3],(a[b+319|0]|0)!=0|0)}g=1.0/t;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+9240|0;r=q;h[r>>3]=g;i=d;return}function sC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5128>>3]=+h[b+4928>>3]+ +h[b+8704>>3]*-.5;i=i;return}function tC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;d=i;e=b+4|0;f=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;do{if((dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|f)<<24>>24==0){g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+9248>>3];l=+h[j+9240>>3];if(k!=0.0){m=l/k;break}if(l==0.0){m=l;break}m=l/+YMa(c[b+536>>2]|0,k,17848,17840,+h[g>>3],(a[b+319|0]|0)!=0|0)}else{m=0.0}}while(0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9128>>3]=m;i=d;return}function uC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;e=dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;f=(dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|e)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(!f){g=0.0;j=e;k=j+9120|0;l=k;h[l>>3]=g;i=b;return}g=+h[e+9128>>3]+ +h[(c[a+416>>2]|0)+8728>>3];j=e;k=j+9120|0;l=k;h[l>>3]=g;i=b;return}function vC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0,y=0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=dQa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;if(!((dQa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|j)<<24>>24==0)){l=0.0;m=c[g>>2]|0;n=c[m>>2]|0;o=n;p=o+8|0;q=p;r=c[q>>2]|0;s=r;t=s+9112|0;u=t;h[u>>3]=l;i=d;return}j=c[c[g>>2]>>2]|0;v=+h[(c[j+8>>2]|0)+9248>>3];if(v!=0.0){w=v}else{w=+YMa(c[b+536>>2]|0,v,17848,17880,+h[j>>3],(a[b+319|0]|0)!=0|0)}v=1.0/w;if(!(v>=0.0)){j=c[41884]|0;x=c[b+536>>2]|0;b=f;h[k>>3]=v;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j;j=e;y=17896;c[j+0>>2]=c[y+0>>2];c[j+4>>2]=c[y+4>>2];c[j+8>>2]=c[y+8>>2];c[j+12>>2]=c[y+12>>2];c[j+16>>2]=c[y+16>>2];c[j+20>>2]=c[y+20>>2];Ie[b&63](x,e,17920,f);}l=+V(+v);m=c[g>>2]|0;n=c[m>>2]|0;o=n;p=o+8|0;q=p;r=c[q>>2]|0;s=r;t=s+9112|0;u=t;h[u>>3]=l;i=d;return}function wC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;e=dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;f=(dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|e)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(!f){g=0.0;j=e;k=j+9104|0;l=k;h[l>>3]=g;i=b;return}g=+h[e+9112>>3]+ +h[(c[a+416>>2]|0)+8728>>3];j=e;k=j+9104|0;l=k;h[l>>3]=g;i=b;return}function xC(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;e=(dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|a)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(!e){f=0.0;g=a;j=g+9096|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+9248>>3]*+h[a+9112>>3];g=a;j=g+9096|0;k=j;h[k>>3]=f;i=b;return}function yC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3152>>3]=+h[b+656>>3]+ +h[b+1288>>3];i=i;return}function zC(b){b=b|0;var d=0,e=0,f=0;d=i;e=b+4|0;b=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;if((dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|b)<<24>>24==0){b=c[(c[c[e>>2]>>2]|0)+8>>2]|0;f=fQa(+h[b+9128>>3],+h[b+9112>>3])|0}else{f=0}a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+21|0]=f;i=d;return}function AC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;d=i;e=b+4|0;f=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;do{if((dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|f)<<24>>24==0){g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;if((a[(c[g+16>>2]|0)+21|0]|0)!=0){k=+h[j+9112>>3];break}l=+h[j+9240>>3];if(l!=0.0){m=l}else{m=+YMa(c[b+536>>2]|0,l,18024,18016,+h[g>>3],(a[b+319|0]|0)!=0|0)}k=1.0/m}else{k=0.0}}while(0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9016>>3]=k;i=d;return}function BC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;e=dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;f=(dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|e)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(!f){g=0.0;j=e;k=j+9008|0;l=k;h[l>>3]=g;i=b;return}g=+h[e+9016>>3]+ +h[(c[a+416>>2]|0)+8728>>3];j=e;k=j+9008|0;l=k;h[l>>3]=g;i=b;return}function CC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0;d=i;e=b+4|0;b=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;f=(dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|b)<<24>>24==0;b=c[c[e>>2]>>2]|0;if(!f){g=c[b+8>>2]|0;j=0.0;k=g;l=k+9e3|0;m=l;h[m>>3]=j;i=d;return}f=c[b+8>>2]|0;if((a[(c[b+16>>2]|0)+21|0]|0)==0){g=f;j=+h[f+9016>>3]+ +h[f+9128>>3];k=g;l=k+9e3|0;m=l;h[m>>3]=j;i=d;return}else{g=f;j=+h[f+9112>>3]*2.0;k=g;l=k+9e3|0;m=l;h[m>>3]=j;i=d;return}}function DC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;e=dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;f=(dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|e)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(!f){g=0.0;j=e;k=j+8992|0;l=k;h[l>>3]=g;i=b;return}g=+h[e+9e3>>3]+ +h[(c[a+416>>2]|0)+8728>>3];j=e;k=j+8992|0;l=k;h[l>>3]=g;i=b;return}function EC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;b=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;f=(dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|b)<<24>>24==0;b=c[c[e>>2]>>2]|0;if(!f){g=c[b+8>>2]|0;j=0.0;k=g;l=k+8968|0;m=l;h[m>>3]=j;i=d;return}f=c[b+8>>2]|0;if((a[(c[b+16>>2]|0)+21|0]|0)==0){n=+h[f+9128>>3];o=n*n}else{n=+h[f+9112>>3];o=n*n}g=f;j=o*+h[f+9248>>3]*.5;k=g;l=k+8968|0;m=l;h[m>>3]=j;i=d;return}function FC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;b=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;f=(dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|b)<<24>>24==0;b=c[c[e>>2]>>2]|0;if(!f){g=c[b+8>>2]|0;j=0.0;k=g;l=k+8960|0;m=l;h[m>>3]=j;i=d;return}f=c[b+8>>2]|0;if((a[(c[b+16>>2]|0)+21|0]|0)==0){n=+h[f+9240>>3]*(+h[f+9016>>3]- +h[f+9128>>3])}else{o=+h[f+9e3>>3]- +h[f+9112>>3];n=+h[f+9096>>3]*o+ +h[f+9248>>3]*o*o*-.5}g=f;j=n+ +h[f+8968>>3];k=g;l=k+8960|0;m=l;h[m>>3]=j;i=d;return}function GC(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0;b=i;d=a+4|0;a=dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;e=(dQa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|a)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(!e){f=0.0;g=a;j=g+8952|0;k=j;h[k>>3]=f;i=b;return}l=+h[a+9e3>>3]- +h[a+9016>>3];f=+h[a+8960>>3]+(l*+h[a+9240>>3]+l*l*+h[a+9248>>3]*-.5);g=a;j=g+8952|0;k=j;h[k>>3]=f;i=b;return}function HC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3032>>3]=+h[b+6720>>3]*+h[b+7216>>3];i=i;return}function IC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3e3>>3]=-(+h[(c[a+416>>2]|0)+784>>3]*+h[b+3032>>3]);i=i;return}function JC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3016>>3]=+h[(c[a+416>>2]|0)+768>>3]*+h[b+3032>>3];i=i;return}function KC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2872>>3]=+h[b+6720>>3]*+h[b+7416>>3];i=i;return}function LC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8856>>3]=+h[(c[a+416>>2]|0)+8824>>3];i=i;return}function MC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8848>>3]=+h[(c[a+416>>2]|0)+9512>>3];i=i;return}function NC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8840>>3]=+h[(c[a+416>>2]|0)+10200>>3];i=i;return}function OC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8832>>3]=+h[(c[a+416>>2]|0)+10888>>3];i=i;return}function PC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8824>>3]=+h[(c[a+416>>2]|0)+11512>>3];i=i;return}function QC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8816>>3]=+h[(c[a+416>>2]|0)+12136>>3];i=i;return}function RC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+24|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+24|0]|0;k=b+4|0;l=c[c[k>>2]>>2]|0;m=$Pa(+h[l>>3],+h[(c[l+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+24|0]|0)|0;a[(c[b+352>>2]|0)+24|0]=m;e=k;f=j;break}else{j=b+4|0;k=c[c[j>>2]>>2]|0;m=$Pa(+h[k>>3],+h[(c[k+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+24|0]|0)|0;a[(c[b+352>>2]|0)+24|0]=m;e=j;f=m;break}}else{if(g){g=a[(c[b+356>>2]|0)+24|0]|0;m=b+4|0;j=c[c[m>>2]>>2]|0;k=dQa(+h[j>>3],+h[(c[j+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+24|0]=k;e=m;f=g;break}else{g=b+4|0;m=c[c[g>>2]>>2]|0;k=dQa(+h[m>>3],+h[(c[m+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+24|0]=k;e=g;f=k;break}}}}while(0);a[c[(c[c[e>>2]>>2]|0)+16>>2]|0]=f;i=d;return}function SC(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+4|0;f=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;if(!((dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|f)<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}f=b+314|0;do{if((a[f]|0)==0){s=a[(c[b+356>>2]|0)+25|0]|0}else{t=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(t){u=a[(c[b+356>>2]|0)+25|0]|0;v=_Pa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3],a[(c[b+360>>2]|0)+25|0]|0)|0;a[(c[b+352>>2]|0)+25|0]=v;s=u;break}else{u=_Pa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3],a[(c[b+360>>2]|0)+25|0]|0)|0;a[(c[b+352>>2]|0)+25|0]=u;s=u;break}}else{if(t){t=a[(c[b+356>>2]|0)+25|0]|0;u=cQa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3])|0;a[(c[b+352>>2]|0)+25|0]=u;s=t;break}else{t=cQa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3])|0;a[(c[b+352>>2]|0)+25|0]=t;s=t;break}}}}while(0);if(!(s<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}s=c[c[e>>2]>>2]|0;t=(a[f]|0)==0;if((a[(c[s+16>>2]|0)+21|0]|0)!=0){do{if(t){w=a[(c[b+356>>2]|0)+26|0]|0}else{u=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(u){v=a[(c[b+356>>2]|0)+26|0]|0;x=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3],a[(c[b+360>>2]|0)+26|0]|0)|0;a[(c[b+352>>2]|0)+26|0]=x;w=v;break}else{v=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3],a[(c[b+360>>2]|0)+26|0]|0)|0;a[(c[b+352>>2]|0)+26|0]=v;w=v;break}}else{if(u){u=a[(c[b+356>>2]|0)+26|0]|0;v=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3])|0;a[(c[b+352>>2]|0)+26|0]=v;w=u;break}else{u=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3])|0;a[(c[b+352>>2]|0)+26|0]=u;w=u;break}}}}while(0);if(!(w<<24>>24==0)){w=c[c[e>>2]>>2]|0;g=+h[(c[w+8>>2]|0)+9248>>3]*(+h[w>>3]- +h[(c[b+416>>2]|0)+8728>>3])*2.0*.5;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){y=a[(c[b+356>>2]|0)+27|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){u=a[(c[b+356>>2]|0)+27|0]|0;v=c[c[e>>2]>>2]|0;x=_Pa(+h[v>>3],+h[(c[v+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=x;y=u;break}else{u=c[c[e>>2]>>2]|0;x=_Pa(+h[u>>3],+h[(c[u+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=x;y=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+27|0]|0;x=c[c[e>>2]>>2]|0;u=cQa(+h[x>>3],+h[(c[x+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=u;y=w;break}else{w=c[c[e>>2]>>2]|0;u=cQa(+h[w>>3],+h[(c[w+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=u;y=u;break}}}}while(0);if(y<<24>>24==0){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}y=c[c[e>>2]>>2]|0;u=c[y+8>>2]|0;g=+h[u+9096>>3]+ +h[u+9248>>3]*(+h[y>>3]- +h[u+9104>>3])*2.0*-.5;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}do{if(t){z=a[(c[b+356>>2]|0)+28|0]|0}else{u=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(u){y=a[(c[b+356>>2]|0)+28|0]|0;w=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3],a[(c[b+360>>2]|0)+28|0]|0)|0;a[(c[b+352>>2]|0)+28|0]=w;z=y;break}else{y=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3],a[(c[b+360>>2]|0)+28|0]|0)|0;a[(c[b+352>>2]|0)+28|0]=y;z=y;break}}else{if(u){u=a[(c[b+356>>2]|0)+28|0]|0;y=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3])|0;a[(c[b+352>>2]|0)+28|0]=y;z=u;break}else{u=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3])|0;a[(c[b+352>>2]|0)+28|0]=u;z=u;break}}}}while(0);if(!(z<<24>>24==0)){z=c[c[e>>2]>>2]|0;g=+h[(c[z+8>>2]|0)+9248>>3]*(+h[z>>3]- +h[(c[b+416>>2]|0)+8728>>3])*2.0*.5;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){A=a[(c[b+356>>2]|0)+29|0]|0}else{z=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(z){s=a[(c[b+356>>2]|0)+29|0]|0;t=c[c[e>>2]>>2]|0;u=_Pa(+h[t>>3],+h[(c[t+8>>2]|0)+9008>>3],a[(c[b+360>>2]|0)+29|0]|0)|0;a[(c[b+352>>2]|0)+29|0]=u;A=s;break}else{s=c[c[e>>2]>>2]|0;u=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9008>>3],a[(c[b+360>>2]|0)+29|0]|0)|0;a[(c[b+352>>2]|0)+29|0]=u;A=u;break}}else{if(z){z=a[(c[b+356>>2]|0)+29|0]|0;u=c[c[e>>2]>>2]|0;s=cQa(+h[u>>3],+h[(c[u+8>>2]|0)+9008>>3])|0;a[(c[b+352>>2]|0)+29|0]=s;A=z;break}else{z=c[c[e>>2]>>2]|0;s=cQa(+h[z>>3],+h[(c[z+8>>2]|0)+9008>>3])|0;a[(c[b+352>>2]|0)+29|0]=s;A=s;break}}}}while(0);if(!(A<<24>>24==0)){g=+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9240>>3];j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){B=a[(c[b+356>>2]|0)+27|0]|0}else{A=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(A){s=a[(c[b+356>>2]|0)+27|0]|0;z=c[c[e>>2]>>2]|0;u=_Pa(+h[z>>3],+h[(c[z+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=u;B=s;break}else{s=c[c[e>>2]>>2]|0;u=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=u;B=u;break}}else{if(A){A=a[(c[b+356>>2]|0)+27|0]|0;u=c[c[e>>2]>>2]|0;s=cQa(+h[u>>3],+h[(c[u+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=s;B=A;break}else{A=c[c[e>>2]>>2]|0;s=cQa(+h[A>>3],+h[(c[A+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=s;B=s;break}}}}while(0);if(B<<24>>24==0){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}B=c[c[e>>2]>>2]|0;b=c[B+8>>2]|0;g=+h[b+9240>>3]+ +h[b+9248>>3]*(+h[B>>3]- +h[b+9008>>3])*2.0*-.5;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8696|0;r=q;h[r>>3]=g;i=d;return}function TC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8664>>3]=+h[b+8696>>3]*2.094395102393195;i=i;return}function UC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8400>>3]=+h[(c[a+416>>2]|0)+9312>>3]*+h[b+8664>>3];i=i;return}function VC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8256>>3]=+h[b+8696>>3]*-1.570796326794897;i=i;return}function WC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7992>>3]=+h[(c[a+416>>2]|0)+1e4>>3]*+h[b+8256>>3];i=i;return}function XC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7848>>3]=+h[b+8696>>3]*-2.181661564992912;i=i;return}function YC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7584>>3]=+h[(c[a+416>>2]|0)+10688>>3]*+h[b+7848>>3];i=i;return}function ZC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6672>>3]=+h[b+8696>>3]*.7853981633974483;i=i;return}function _C(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7160>>3]=+h[(c[a+416>>2]|0)+11360>>3]*+h[b+6672>>3];i=i;return}function $C(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6392>>3]=+h[(c[a+416>>2]|0)+12608>>3]*+h[b+6672>>3];i=i;return}function aD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7440>>3]=+h[b+6672>>3];i=i;return}function bD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7056>>3]=+h[b+8696>>3]*3.839724354387525;i=i;return}function cD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6776>>3]=+h[(c[a+416>>2]|0)+11984>>3]*+h[b+7056>>3];i=i;return}function dD(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0;d=i;e=b+4|0;f=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;if(!((dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|f)<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}f=b+314|0;do{if((a[f]|0)==0){s=a[(c[b+356>>2]|0)+25|0]|0}else{t=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(t){u=a[(c[b+356>>2]|0)+25|0]|0;v=_Pa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3],a[(c[b+360>>2]|0)+25|0]|0)|0;a[(c[b+352>>2]|0)+25|0]=v;s=u;break}else{u=_Pa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3],a[(c[b+360>>2]|0)+25|0]|0)|0;a[(c[b+352>>2]|0)+25|0]=u;s=u;break}}else{if(t){t=a[(c[b+356>>2]|0)+25|0]|0;u=cQa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3])|0;a[(c[b+352>>2]|0)+25|0]=u;s=t;break}else{t=cQa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3])|0;a[(c[b+352>>2]|0)+25|0]=t;s=t;break}}}}while(0);if(!(s<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}s=c[c[e>>2]>>2]|0;t=(a[f]|0)==0;if((a[(c[s+16>>2]|0)+21|0]|0)!=0){do{if(t){w=a[(c[b+356>>2]|0)+26|0]|0}else{u=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(u){v=a[(c[b+356>>2]|0)+26|0]|0;x=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3],a[(c[b+360>>2]|0)+26|0]|0)|0;a[(c[b+352>>2]|0)+26|0]=x;w=v;break}else{v=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3],a[(c[b+360>>2]|0)+26|0]|0)|0;a[(c[b+352>>2]|0)+26|0]=v;w=v;break}}else{if(u){u=a[(c[b+356>>2]|0)+26|0]|0;v=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3])|0;a[(c[b+352>>2]|0)+26|0]=v;w=u;break}else{u=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3])|0;a[(c[b+352>>2]|0)+26|0]=u;w=u;break}}}}while(0);if(!(w<<24>>24==0)){w=c[c[e>>2]>>2]|0;y=+h[w>>3]- +h[(c[b+416>>2]|0)+8728>>3];g=+h[(c[w+8>>2]|0)+9248>>3]*y*y*.5;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){z=a[(c[b+356>>2]|0)+27|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){u=a[(c[b+356>>2]|0)+27|0]|0;v=c[c[e>>2]>>2]|0;x=_Pa(+h[v>>3],+h[(c[v+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=x;z=u;break}else{u=c[c[e>>2]>>2]|0;x=_Pa(+h[u>>3],+h[(c[u+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=x;z=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+27|0]|0;x=c[c[e>>2]>>2]|0;u=cQa(+h[x>>3],+h[(c[x+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=u;z=w;break}else{w=c[c[e>>2]>>2]|0;u=cQa(+h[w>>3],+h[(c[w+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=u;z=u;break}}}}while(0);u=c[c[e>>2]>>2]|0;if(z<<24>>24==0){g=+h[(c[u+8>>2]|0)+8960>>3];j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}else{z=c[u+8>>2]|0;y=+h[u>>3]- +h[z+9104>>3];g=+h[z+8968>>3]+(y*+h[z+9096>>3]+y*y*+h[z+9248>>3]*-.5);j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}}do{if(t){A=a[(c[b+356>>2]|0)+28|0]|0}else{z=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(z){u=a[(c[b+356>>2]|0)+28|0]|0;w=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3],a[(c[b+360>>2]|0)+28|0]|0)|0;a[(c[b+352>>2]|0)+28|0]=w;A=u;break}else{u=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3],a[(c[b+360>>2]|0)+28|0]|0)|0;a[(c[b+352>>2]|0)+28|0]=u;A=u;break}}else{if(z){z=a[(c[b+356>>2]|0)+28|0]|0;u=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3])|0;a[(c[b+352>>2]|0)+28|0]=u;A=z;break}else{z=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3])|0;a[(c[b+352>>2]|0)+28|0]=z;A=z;break}}}}while(0);if(!(A<<24>>24==0)){A=c[c[e>>2]>>2]|0;y=+h[A>>3]- +h[(c[b+416>>2]|0)+8728>>3];g=+h[(c[A+8>>2]|0)+9248>>3]*y*y*.5;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){B=a[(c[b+356>>2]|0)+29|0]|0}else{A=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(A){s=a[(c[b+356>>2]|0)+29|0]|0;t=c[c[e>>2]>>2]|0;z=_Pa(+h[t>>3],+h[(c[t+8>>2]|0)+9008>>3],a[(c[b+360>>2]|0)+29|0]|0)|0;a[(c[b+352>>2]|0)+29|0]=z;B=s;break}else{s=c[c[e>>2]>>2]|0;z=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9008>>3],a[(c[b+360>>2]|0)+29|0]|0)|0;a[(c[b+352>>2]|0)+29|0]=z;B=z;break}}else{if(A){A=a[(c[b+356>>2]|0)+29|0]|0;z=c[c[e>>2]>>2]|0;s=cQa(+h[z>>3],+h[(c[z+8>>2]|0)+9008>>3])|0;a[(c[b+352>>2]|0)+29|0]=s;B=A;break}else{A=c[c[e>>2]>>2]|0;s=cQa(+h[A>>3],+h[(c[A+8>>2]|0)+9008>>3])|0;a[(c[b+352>>2]|0)+29|0]=s;B=s;break}}}}while(0);if(!(B<<24>>24==0)){B=c[c[e>>2]>>2]|0;s=c[B+8>>2]|0;g=+h[s+8968>>3]+ +h[s+9240>>3]*(+h[B>>3]- +h[s+9120>>3]);j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){C=a[(c[b+356>>2]|0)+27|0]|0}else{s=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(s){B=a[(c[b+356>>2]|0)+27|0]|0;A=c[c[e>>2]>>2]|0;z=_Pa(+h[A>>3],+h[(c[A+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=z;C=B;break}else{B=c[c[e>>2]>>2]|0;z=_Pa(+h[B>>3],+h[(c[B+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=z;C=z;break}}else{if(s){s=a[(c[b+356>>2]|0)+27|0]|0;z=c[c[e>>2]>>2]|0;B=cQa(+h[z>>3],+h[(c[z+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=B;C=s;break}else{s=c[c[e>>2]>>2]|0;B=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=B;C=B;break}}}}while(0);b=c[c[e>>2]>>2]|0;if(C<<24>>24==0){g=+h[(c[b+8>>2]|0)+8952>>3];j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}else{C=c[b+8>>2]|0;y=+h[b>>3]- +h[C+9008>>3];g=+h[C+8960>>3]+(y*+h[C+9240>>3]+y*y*+h[C+9248>>3]*-.5);j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8704|0;r=q;h[r>>3]=g;i=d;return}}function eD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8680>>3]=+h[b+8704>>3]*2.094395102393195+-1.047197551196598;i=i;return}function fD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8408>>3]=+h[(c[a+416>>2]|0)+9304>>3]*+h[b+8680>>3];i=i;return}function gD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8272>>3]=+h[b+8704>>3]*-1.570796326794897+.3490658503988659;i=i;return}function hD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8e3>>3]=+h[(c[a+416>>2]|0)+9992>>3]*+h[b+8272>>3];i=i;return}function iD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7864>>3]=+h[b+8704>>3]*-2.181661564992912+1.570796326794897;i=i;return}function jD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7592>>3]=+h[(c[a+416>>2]|0)+10680>>3]*+h[b+7864>>3];i=i;return}function kD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6688>>3]=+h[b+8704>>3]*.7853981633974483;i=i;return}function lD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7168>>3]=+h[(c[a+416>>2]|0)+11352>>3]*+h[b+6688>>3];i=i;return}function mD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6400>>3]=+h[(c[a+416>>2]|0)+12600>>3]*+h[b+6688>>3];i=i;return}function nD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7456>>3]=+h[b+6688>>3];i=i;return}function oD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7072>>3]=+h[b+8704>>3]*3.839724354387525+-1.919862177193763;i=i;return}function pD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6784>>3]=+h[(c[a+416>>2]|0)+11976>>3]*+h[b+7072>>3];i=i;return}function qD(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+4|0;f=dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9792>>3],1.0e-14)|0;if(!((dQa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9784>>3],1.0e-14)|0|f)<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}f=b+314|0;do{if((a[f]|0)==0){s=a[(c[b+356>>2]|0)+25|0]|0}else{t=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(t){u=a[(c[b+356>>2]|0)+25|0]|0;v=_Pa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3],a[(c[b+360>>2]|0)+25|0]|0)|0;a[(c[b+352>>2]|0)+25|0]=v;s=u;break}else{u=_Pa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3],a[(c[b+360>>2]|0)+25|0]|0)|0;a[(c[b+352>>2]|0)+25|0]=u;s=u;break}}else{if(t){t=a[(c[b+356>>2]|0)+25|0]|0;u=cQa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3])|0;a[(c[b+352>>2]|0)+25|0]=u;s=t;break}else{t=cQa(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+8728>>3])|0;a[(c[b+352>>2]|0)+25|0]=t;s=t;break}}}}while(0);if(!(s<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}s=c[c[e>>2]>>2]|0;t=(a[f]|0)==0;if((a[(c[s+16>>2]|0)+21|0]|0)!=0){do{if(t){w=a[(c[b+356>>2]|0)+26|0]|0}else{u=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(u){v=a[(c[b+356>>2]|0)+26|0]|0;x=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3],a[(c[b+360>>2]|0)+26|0]|0)|0;a[(c[b+352>>2]|0)+26|0]=x;w=v;break}else{v=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3],a[(c[b+360>>2]|0)+26|0]|0)|0;a[(c[b+352>>2]|0)+26|0]=v;w=v;break}}else{if(u){u=a[(c[b+356>>2]|0)+26|0]|0;v=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3])|0;a[(c[b+352>>2]|0)+26|0]=v;w=u;break}else{u=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9104>>3])|0;a[(c[b+352>>2]|0)+26|0]=u;w=u;break}}}}while(0);if(!(w<<24>>24==0)){g=+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9248>>3];j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){y=a[(c[b+356>>2]|0)+27|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){u=a[(c[b+356>>2]|0)+27|0]|0;v=c[c[e>>2]>>2]|0;x=_Pa(+h[v>>3],+h[(c[v+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=x;y=u;break}else{u=c[c[e>>2]>>2]|0;x=_Pa(+h[u>>3],+h[(c[u+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=x;y=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+27|0]|0;x=c[c[e>>2]>>2]|0;u=cQa(+h[x>>3],+h[(c[x+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=u;y=w;break}else{w=c[c[e>>2]>>2]|0;u=cQa(+h[w>>3],+h[(c[w+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=u;y=u;break}}}}while(0);if(y<<24>>24==0){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}g=-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9248>>3];j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}do{if(t){z=a[(c[b+356>>2]|0)+28|0]|0}else{y=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(y){u=a[(c[b+356>>2]|0)+28|0]|0;w=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3],a[(c[b+360>>2]|0)+28|0]|0)|0;a[(c[b+352>>2]|0)+28|0]=w;z=u;break}else{u=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3],a[(c[b+360>>2]|0)+28|0]|0)|0;a[(c[b+352>>2]|0)+28|0]=u;z=u;break}}else{if(y){y=a[(c[b+356>>2]|0)+28|0]|0;u=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3])|0;a[(c[b+352>>2]|0)+28|0]=u;z=y;break}else{y=cQa(+h[s>>3],+h[(c[s+8>>2]|0)+9120>>3])|0;a[(c[b+352>>2]|0)+28|0]=y;z=y;break}}}}while(0);if(!(z<<24>>24==0)){g=+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9248>>3];j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){A=a[(c[b+356>>2]|0)+29|0]|0}else{z=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(z){s=a[(c[b+356>>2]|0)+29|0]|0;t=c[c[e>>2]>>2]|0;y=_Pa(+h[t>>3],+h[(c[t+8>>2]|0)+9008>>3],a[(c[b+360>>2]|0)+29|0]|0)|0;a[(c[b+352>>2]|0)+29|0]=y;A=s;break}else{s=c[c[e>>2]>>2]|0;y=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+9008>>3],a[(c[b+360>>2]|0)+29|0]|0)|0;a[(c[b+352>>2]|0)+29|0]=y;A=y;break}}else{if(z){z=a[(c[b+356>>2]|0)+29|0]|0;y=c[c[e>>2]>>2]|0;s=cQa(+h[y>>3],+h[(c[y+8>>2]|0)+9008>>3])|0;a[(c[b+352>>2]|0)+29|0]=s;A=z;break}else{z=c[c[e>>2]>>2]|0;s=cQa(+h[z>>3],+h[(c[z+8>>2]|0)+9008>>3])|0;a[(c[b+352>>2]|0)+29|0]=s;A=s;break}}}}while(0);if(!(A<<24>>24==0)){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}do{if((a[f]|0)==0){B=a[(c[b+356>>2]|0)+27|0]|0}else{A=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(A){s=a[(c[b+356>>2]|0)+27|0]|0;z=c[c[e>>2]>>2]|0;y=_Pa(+h[z>>3],+h[(c[z+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=y;B=s;break}else{s=c[c[e>>2]>>2]|0;y=_Pa(+h[s>>3],+h[(c[s+8>>2]|0)+8992>>3],a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=y;B=y;break}}else{if(A){A=a[(c[b+356>>2]|0)+27|0]|0;y=c[c[e>>2]>>2]|0;s=cQa(+h[y>>3],+h[(c[y+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=s;B=A;break}else{A=c[c[e>>2]>>2]|0;s=cQa(+h[A>>3],+h[(c[A+8>>2]|0)+8992>>3])|0;a[(c[b+352>>2]|0)+27|0]=s;B=s;break}}}}while(0);if(B<<24>>24==0){g=0.0;j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}g=-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+9248>>3];j=c[e>>2]|0;k=c[j>>2]|0;l=k;m=l+8|0;n=m;o=c[n>>2]|0;p=o;q=p+8712|0;r=q;h[r>>3]=g;i=d;return}function rD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+608>>3]=+h[b+8712>>3]*2.094395102393195;i=i;return}function sD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+600>>3]=+h[b+8712>>3]*-1.570796326794897;i=i;return}function tD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+592>>3]=+h[b+8712>>3]*-2.181661564992912;i=i;return}function uD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+576>>3]=+h[b+8712>>3]*.7853981633974483;i=i;return}function vD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+584>>3]=+h[b+8712>>3]*3.839724354387525;i=i;return}function wD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+54|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+54|0]|0;k=b+4|0;l=c[c[k>>2]>>2]|0;m=bQa(+h[l>>3],+h[(c[l+8>>2]|0)+8992>>3]+ +h[(c[b+416>>2]|0)+8720>>3],a[(c[b+360>>2]|0)+54|0]|0)|0;a[(c[b+352>>2]|0)+54|0]=m;e=k;f=j;break}else{j=b+4|0;k=c[c[j>>2]>>2]|0;m=bQa(+h[k>>3],+h[(c[k+8>>2]|0)+8992>>3]+ +h[(c[b+416>>2]|0)+8720>>3],a[(c[b+360>>2]|0)+54|0]|0)|0;a[(c[b+352>>2]|0)+54|0]=m;e=j;f=m;break}}else{if(g){g=a[(c[b+356>>2]|0)+54|0]|0;m=b+4|0;j=c[c[m>>2]>>2]|0;k=fQa(+h[j>>3],+h[(c[j+8>>2]|0)+8992>>3]+ +h[(c[b+416>>2]|0)+8720>>3])|0;a[(c[b+352>>2]|0)+54|0]=k;e=m;f=g;break}else{g=b+4|0;m=c[c[g>>2]>>2]|0;k=fQa(+h[m>>3],+h[(c[m+8>>2]|0)+8992>>3]+ +h[(c[b+416>>2]|0)+8720>>3])|0;a[(c[b+352>>2]|0)+54|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+19|0]=f;i=d;return}function xD(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+20|0]=a[d+19|0]|0;i=i;return}function yD(b){b=b|0;a[(c[b+408>>2]|0)+18|0]=0;i=i;return}function zD(b){b=b|0;a[(c[b+408>>2]|0)+17|0]=0;i=i;return}function AD(a){a=a|0;c[(c[a+404>>2]|0)+416>>2]=3;i=i;return}function BD(b){b=b|0;a[(c[b+408>>2]|0)+15|0]=0;i=i;return}function CD(b){b=b|0;a[(c[b+408>>2]|0)+14|0]=0;i=i;return}function DD(a){a=a|0;c[(c[a+404>>2]|0)+412>>2]=3;i=i;return}function ED(b){b=b|0;a[(c[b+408>>2]|0)+12|0]=0;i=i;return}function FD(b){b=b|0;a[(c[b+408>>2]|0)+11|0]=0;i=i;return}function GD(a){a=a|0;c[(c[a+404>>2]|0)+408>>2]=3;i=i;return}function HD(b){b=b|0;a[(c[b+408>>2]|0)+9|0]=0;i=i;return}function ID(b){b=b|0;a[(c[b+408>>2]|0)+8|0]=0;i=i;return}function JD(a){a=a|0;c[(c[a+404>>2]|0)+404>>2]=3;i=i;return}function KD(b){b=b|0;a[(c[b+408>>2]|0)+6|0]=0;i=i;return}function LD(b){b=b|0;a[(c[b+408>>2]|0)+5|0]=0;i=i;return}function MD(a){a=a|0;c[(c[a+404>>2]|0)+400>>2]=3;i=i;return}function ND(b){b=b|0;a[(c[b+408>>2]|0)+3|0]=0;i=i;return}function OD(b){b=b|0;a[(c[b+408>>2]|0)+2|0]=0;i=i;return}function PD(a){a=a|0;c[(c[a+404>>2]|0)+396>>2]=3;i=i;return}function QD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+304>>3]=0.0;i=i;return}function RD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6416>>3]=+h[(c[a+416>>2]|0)+12488>>3]*+h[b+304>>3];i=i;return}function SD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+296>>3]=0.0;i=i;return}function TD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6600>>3]=+h[(c[a+416>>2]|0)+12496>>3]*+h[b+296>>3];i=i;return}function UD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6568>>3]=+h[b+9344>>3]*+h[b+6600>>3];i=i;return}function VD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6560>>3]=+h[b+6568>>3]*+h[b+6600>>3];i=i;return}function WD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8784>>3]=+h[b+8816>>3];i=i;return}function XD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+528>>3]=+h[b+8784>>3];i=i;return}function YD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6448>>3]=+h[(c[a+416>>2]|0)+12648>>3]*+h[b+8784>>3];i=i;return}function ZD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+312>>3]=+h[b+6672>>3];i=i;return}function _D(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6320>>3]=+h[b+312>>3];i=i;return}function $D(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+44>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+6344>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+6344|0;h[c[g+48>>2]>>3]=+h[j>>3];k=+EQa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+6344>>3]);h[c[(c[f>>2]|0)+52>>2]>>3]=k;CQa(a,0)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+6344>>3]=+h[c[(c[f>>2]|0)+44>>2]>>3];Fp(a);Gp(a);Hp(a);i=b;return}function aE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+41|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+41|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[b+360>>2]|0)+41|0]|0)|0;a[(c[b+352>>2]|0)+41|0]=k;f=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[b+360>>2]|0)+41|0]|0)|0;a[(c[b+352>>2]|0)+41|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+41|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;a[(c[b+352>>2]|0)+41|0]=j;f=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;a[(c[b+352>>2]|0)+41|0]=g;f=g;break}}}}while(0);g=b+404|0;do{if(((c[(c[g>>2]|0)+396>>2]|0)+ -1|0)>>>0<2){if(f<<24>>24==0){break}else{l=1}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+396|0;x=w;c[x>>2]=l;i=d;return}else{if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+3|0]|0)!=0&f<<24>>24!=0){l=1}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+396|0;x=w;c[x>>2]=l;i=d;return}}while(0);do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+37|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){j=a[(c[b+356>>2]|0)+37|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[b+360>>2]|0)+37|0]|0)|0;a[(c[b+352>>2]|0)+37|0]=k;y=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[b+360>>2]|0)+37|0]|0)|0;a[(c[b+352>>2]|0)+37|0]=j;y=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+37|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;a[(c[b+352>>2]|0)+37|0]=j;y=f;break}else{f=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;a[(c[b+352>>2]|0)+37|0]=f;y=f;break}}}}while(0);e=c[(c[g>>2]|0)+396>>2]|0;do{if(!((e|0)==2|(e|0)==-1)){if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){l=0}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+396|0;x=w;c[x>>2]=l;i=d;return}}while(0);l=(y<<24>>24!=0)<<31>>31;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+396|0;x=w;c[x>>2]=l;i=d;return}function bE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0;d=i;i=i+72|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;k=d+64|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=b+4|0;ba=c[c[aa>>2]>>2]|0;ca=c[ba+16>>2]|0;if((a[ca+1|0]|0)!=0){da=+h[(c[ba+8>>2]|0)+6344>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6328|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+3|0]|0)!=0){ba=b+416|0;RNa(+h[(c[ba>>2]|0)+6416>>3],2,x);RNa(+h[(c[ba>>2]|0)+6424>>3],2,y);RNa(+h[(c[ba>>2]|0)+6432>>3],2,A);RNa(+h[(c[ba>>2]|0)+6440>>3],2,B);c[v>>2]=y;QNa(2,w,2,x,v);c[u>>2]=B;QNa(2,z,2,A,u);c[t>>2]=z;QNa(1,C,2,w,t);t=c[b+536>>2]|0;na=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+6320>>3];w=j;z=C;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];Bp(Y,t,na,j,2);da=+h[Y>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6328|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+2|0]|0)!=0){ca=b+416|0;RNa(+h[(c[ca>>2]|0)+6416>>3],2,E);RNa(+h[(c[ca>>2]|0)+6424>>3],2,F);RNa(+h[(c[ca>>2]|0)+6432>>3],2,H);RNa(+h[(c[ca>>2]|0)+6440>>3],2,I);c[s>>2]=F;QNa(2,D,2,E,s);c[r>>2]=I;QNa(2,G,2,H,r);c[q>>2]=G;QNa(1,J,2,D,q);q=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+6320>>3];D=g;G=J;c[D+0>>2]=c[G+0>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2];Bp(Z,q,na,g,2);da=-+h[Z>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6328|0;ma=la;h[ma>>3]=da;i=d;return}Z=b+416|0;na=+h[(c[Z>>2]|0)+6416>>3];if((c[(c[b+404>>2]|0)+396>>2]|0)==1){RNa(na,2,L);RNa(+h[(c[Z>>2]|0)+6424>>3],2,M);RNa(+h[(c[Z>>2]|0)+6432>>3],2,O);RNa(+h[(c[Z>>2]|0)+6440>>3],2,P);c[p>>2]=M;QNa(2,K,2,L,p);c[o>>2]=P;QNa(2,N,2,O,o);c[n>>2]=N;QNa(1,Q,2,K,n);n=c[b+536>>2]|0;oa=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+6320>>3];K=f;N=Q;c[K+0>>2]=c[N+0>>2];c[K+4>>2]=c[N+4>>2];c[K+8>>2]=c[N+8>>2];Bp(_,n,oa,f,2);da=+h[_>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6328|0;ma=la;h[ma>>3]=da;i=d;return}else{RNa(na,2,S);RNa(+h[(c[Z>>2]|0)+6424>>3],2,T);RNa(+h[(c[Z>>2]|0)+6432>>3],2,V);RNa(+h[(c[Z>>2]|0)+6440>>3],2,W);c[m>>2]=T;QNa(2,R,2,S,m);c[l>>2]=W;QNa(2,U,2,V,l);c[k>>2]=U;QNa(1,X,2,R,k);k=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+6320>>3];b=e;R=X;c[b+0>>2]=c[R+0>>2];c[b+4>>2]=c[R+4>>2];c[b+8>>2]=c[R+8>>2];Bp($,k,na,e,2);da=-+h[$>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6328|0;ma=la;h[ma>>3]=da;i=d;return}}function cE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6336>>3]=+h[b+6328>>3]*+h[b+6320>>3];i=i;return}function dE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6424>>3]=+h[(c[a+416>>2]|0)+12648>>3]*+h[b+312>>3];i=i;return}function eE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6440>>3]=+h[(c[a+416>>2]|0)+12472>>3]*+h[b+6424>>3];i=i;return}function fE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6408>>3]=+h[b+6416>>3]+ +h[b+6440>>3];i=i;return}function gE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+240>>3]=+h[b+312>>3];i=i;return}function hE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6680>>3]=+h[b+6688>>3];i=i;return}function iE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24>>3]=+h[b+6680>>3];i=i;return}function jE(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+24>>3]));h[b+2832>>3]=-(d*+h[b+312>>3]);i=i;return}function kE(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+24>>3]));h[b+2840>>3]=-(d*+h[b+312>>3]);i=i;return}function lE(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+24>>3]));h[b+2848>>3]=d*+h[b+312>>3];i=i;return}function mE(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+24>>3]));h[b+2856>>3]=-(d*+h[b+312>>3]);i=i;return}function nE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5920>>3]=+X(+(+h[b+24>>3]));i=i;return}function oE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5904>>3]=+Y(+(+h[b+24>>3]));i=i;return}function pE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5872>>3]=-+Y(+(+h[b+24>>3]));i=i;return}function qE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5856>>3]=+X(+(+h[b+24>>3]));i=i;return}function rE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6472>>3]=+h[(c[a+416>>2]|0)+12648>>3]*+h[b+24>>3];i=i;return}function sE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6384>>3]=+h[b+6400>>3]- +h[b+6472>>3];i=i;return}function tE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6376>>3]=+h[(c[a+416>>2]|0)+12560>>3]*+h[b+6384>>3];i=i;return}function uE(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6368>>3]=+h[b+12536>>3]*+h[d+6392>>3]+(+h[b+12544>>3]*+h[d+6376>>3]+ +h[b+12552>>3]*+h[d+6424>>3]);i=i;return}function vE(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+12576>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6368>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+288|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+288|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,18064,18056,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+288|0;p=o;h[p>>3]=m;i=d;return}function wE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6432>>3]=+h[b+6472>>3]- +h[(c[a+416>>2]|0)+12480>>3];i=i;return}function xE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+336>>3]=0.0;i=i;return}function yE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6800>>3]=+h[(c[a+416>>2]|0)+11864>>3]*+h[b+336>>3];i=i;return}function zE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+328>>3]=0.0;i=i;return}function AE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6984>>3]=+h[(c[a+416>>2]|0)+11872>>3]*+h[b+328>>3];i=i;return}function BE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6952>>3]=+h[b+9424>>3]*+h[b+6984>>3];i=i;return}function CE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6944>>3]=+h[b+6952>>3]*+h[b+6984>>3];i=i;return}function DE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8776>>3]=+h[b+8824>>3];i=i;return}function EE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+536>>3]=+h[b+8776>>3];i=i;return}function FE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6832>>3]=+h[(c[a+416>>2]|0)+12024>>3]*+h[b+8776>>3];i=i;return}function GE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+344>>3]=+h[b+7056>>3];i=i;return}function HE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6704>>3]=+h[b+344>>3];i=i;return}function IE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+6728>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+6728|0;h[c[g+128>>2]>>3]=+h[j>>3];k=+EQa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+6728>>3]);h[c[(c[f>>2]|0)+132>>2]>>3]=k;CQa(a,1)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+6728>>3]=+h[c[(c[f>>2]|0)+124>>2]>>3];Kp(a);Lp(a);Mp(a);i=b;return}function JE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+49|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+49|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[b+360>>2]|0)+49|0]|0)|0;a[(c[b+352>>2]|0)+49|0]=k;f=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[b+360>>2]|0)+49|0]|0)|0;a[(c[b+352>>2]|0)+49|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+49|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;a[(c[b+352>>2]|0)+49|0]=j;f=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;a[(c[b+352>>2]|0)+49|0]=g;f=g;break}}}}while(0);g=b+404|0;do{if(((c[(c[g>>2]|0)+400>>2]|0)+ -1|0)>>>0<2){if(f<<24>>24==0){break}else{l=1}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+400|0;x=w;c[x>>2]=l;i=d;return}else{if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+6|0]|0)!=0&f<<24>>24!=0){l=1}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+400|0;x=w;c[x>>2]=l;i=d;return}}while(0);do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+45|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){j=a[(c[b+356>>2]|0)+45|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[b+360>>2]|0)+45|0]|0)|0;a[(c[b+352>>2]|0)+45|0]=k;y=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[b+360>>2]|0)+45|0]|0)|0;a[(c[b+352>>2]|0)+45|0]=j;y=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+45|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;a[(c[b+352>>2]|0)+45|0]=j;y=f;break}else{f=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;a[(c[b+352>>2]|0)+45|0]=f;y=f;break}}}}while(0);e=c[(c[g>>2]|0)+400>>2]|0;do{if(!((e|0)==2|(e|0)==-1)){if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){l=0}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+400|0;x=w;c[x>>2]=l;i=d;return}}while(0);l=(y<<24>>24!=0)<<31>>31;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+400|0;x=w;c[x>>2]=l;i=d;return}function KE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0;d=i;i=i+72|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;k=d+64|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=b+4|0;ba=c[c[aa>>2]>>2]|0;ca=c[ba+16>>2]|0;if((a[ca+4|0]|0)!=0){da=+h[(c[ba+8>>2]|0)+6728>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6712|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+6|0]|0)!=0){ba=b+416|0;RNa(+h[(c[ba>>2]|0)+6384>>3],2,x);RNa(+h[(c[ba>>2]|0)+6392>>3],2,y);RNa(+h[(c[ba>>2]|0)+6400>>3],2,A);RNa(+h[(c[ba>>2]|0)+6408>>3],2,B);c[v>>2]=y;QNa(2,w,2,x,v);c[u>>2]=B;QNa(2,z,2,A,u);c[t>>2]=z;QNa(1,C,2,w,t);t=c[b+536>>2]|0;na=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+6704>>3];w=j;z=C;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];Bp(Y,t,na,j,2);da=+h[Y>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6712|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+5|0]|0)!=0){ca=b+416|0;RNa(+h[(c[ca>>2]|0)+6384>>3],2,E);RNa(+h[(c[ca>>2]|0)+6392>>3],2,F);RNa(+h[(c[ca>>2]|0)+6400>>3],2,H);RNa(+h[(c[ca>>2]|0)+6408>>3],2,I);c[s>>2]=F;QNa(2,D,2,E,s);c[r>>2]=I;QNa(2,G,2,H,r);c[q>>2]=G;QNa(1,J,2,D,q);q=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+6704>>3];D=g;G=J;c[D+0>>2]=c[G+0>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2];Bp(Z,q,na,g,2);da=-+h[Z>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6712|0;ma=la;h[ma>>3]=da;i=d;return}Z=b+416|0;na=+h[(c[Z>>2]|0)+6384>>3];if((c[(c[b+404>>2]|0)+400>>2]|0)==1){RNa(na,2,L);RNa(+h[(c[Z>>2]|0)+6392>>3],2,M);RNa(+h[(c[Z>>2]|0)+6400>>3],2,O);RNa(+h[(c[Z>>2]|0)+6408>>3],2,P);c[p>>2]=M;QNa(2,K,2,L,p);c[o>>2]=P;QNa(2,N,2,O,o);c[n>>2]=N;QNa(1,Q,2,K,n);n=c[b+536>>2]|0;oa=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+6704>>3];K=f;N=Q;c[K+0>>2]=c[N+0>>2];c[K+4>>2]=c[N+4>>2];c[K+8>>2]=c[N+8>>2];Bp(_,n,oa,f,2);da=+h[_>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6712|0;ma=la;h[ma>>3]=da;i=d;return}else{RNa(na,2,S);RNa(+h[(c[Z>>2]|0)+6392>>3],2,T);RNa(+h[(c[Z>>2]|0)+6400>>3],2,V);RNa(+h[(c[Z>>2]|0)+6408>>3],2,W);c[m>>2]=T;QNa(2,R,2,S,m);c[l>>2]=W;QNa(2,U,2,V,l);c[k>>2]=U;QNa(1,X,2,R,k);k=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+6704>>3];b=e;R=X;c[b+0>>2]=c[R+0>>2];c[b+4>>2]=c[R+4>>2];c[b+8>>2]=c[R+8>>2];Bp($,k,na,e,2);da=-+h[$>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6712|0;ma=la;h[ma>>3]=da;i=d;return}}function LE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6720>>3]=+h[b+6712>>3]*+h[b+6704>>3];i=i;return}function ME(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6808>>3]=+h[(c[a+416>>2]|0)+12024>>3]*+h[b+344>>3];i=i;return}function NE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6824>>3]=+h[(c[a+416>>2]|0)+11848>>3]*+h[b+6808>>3];i=i;return}function OE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6792>>3]=+h[b+6800>>3]+ +h[b+6824>>3];i=i;return}function PE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+248>>3]=+h[b+344>>3];i=i;return}function QE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7064>>3]=+h[b+7072>>3];i=i;return}function RE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+56>>3]=+h[b+7064>>3];i=i;return}function SE(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+56>>3]));h[b+2800>>3]=-(d*+h[b+344>>3]);i=i;return}function TE(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+56>>3]));h[b+2808>>3]=d*+h[b+344>>3];i=i;return}function UE(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+56>>3]));h[b+2816>>3]=-(d*+h[b+344>>3]);i=i;return}function VE(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+56>>3]));h[b+2824>>3]=-(d*+h[b+344>>3]);i=i;return}function WE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5832>>3]=+X(+(+h[b+56>>3]));i=i;return}function XE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5824>>3]=-+Y(+(+h[b+56>>3]));i=i;return}function YE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5808>>3]=+Y(+(+h[b+56>>3]));i=i;return}function ZE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5800>>3]=+X(+(+h[b+56>>3]));i=i;return}function _E(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6856>>3]=+h[(c[a+416>>2]|0)+12024>>3]*+h[b+56>>3];i=i;return}function $E(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6768>>3]=+h[b+6784>>3]- +h[b+6856>>3];i=i;return}function aF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6760>>3]=+h[(c[a+416>>2]|0)+11936>>3]*+h[b+6768>>3];i=i;return}function bF(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6752>>3]=+h[b+11912>>3]*+h[d+6776>>3]+(+h[b+11920>>3]*+h[d+6760>>3]+ +h[b+11928>>3]*+h[d+6808>>3]);i=i;return}function cF(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+11952>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6752>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}q=k/+YMa(c[b+536>>2]|0,e,18096,18088,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}function dF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6816>>3]=+h[b+6856>>3]- +h[(c[a+416>>2]|0)+11856>>3];i=i;return}function eF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+368>>3]=0.0;i=i;return}function fF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7184>>3]=+h[(c[a+416>>2]|0)+11240>>3]*+h[b+368>>3];i=i;return}function gF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+360>>3]=0.0;i=i;return}function hF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7368>>3]=+h[(c[a+416>>2]|0)+11248>>3]*+h[b+360>>3];i=i;return}function iF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7336>>3]=+h[b+9504>>3]*+h[b+7368>>3];i=i;return}function jF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7328>>3]=+h[b+7336>>3]*+h[b+7368>>3];i=i;return}function kF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8768>>3]=+h[b+8832>>3];i=i;return}function lF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+544>>3]=+h[b+8768>>3];i=i;return}function mF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7216>>3]=+h[(c[a+416>>2]|0)+11400>>3]*+h[b+8768>>3];i=i;return}function nF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+376>>3]=+h[b+7440>>3];i=i;return}function oF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7088>>3]=+h[b+376>>3];i=i;return}function pF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+204>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7112>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7112|0;h[c[g+208>>2]>>3]=+h[j>>3];k=+EQa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7112>>3]);h[c[(c[f>>2]|0)+212>>2]>>3]=k;CQa(a,2)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+7112>>3]=+h[c[(c[f>>2]|0)+204>>2]>>3];Pp(a);Qp(a);Rp(a);i=b;return}function qF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+53|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+53|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[b+360>>2]|0)+53|0]|0)|0;a[(c[b+352>>2]|0)+53|0]=k;f=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[b+360>>2]|0)+53|0]|0)|0;a[(c[b+352>>2]|0)+53|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+53|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0)|0;a[(c[b+352>>2]|0)+53|0]=j;f=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0)|0;a[(c[b+352>>2]|0)+53|0]=g;f=g;break}}}}while(0);g=b+404|0;do{if(((c[(c[g>>2]|0)+404>>2]|0)+ -1|0)>>>0<2){if(f<<24>>24==0){break}else{l=1}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+404|0;x=w;c[x>>2]=l;i=d;return}else{if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+9|0]|0)!=0&f<<24>>24!=0){l=1}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+404|0;x=w;c[x>>2]=l;i=d;return}}while(0);do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+33|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){j=a[(c[b+356>>2]|0)+33|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[b+360>>2]|0)+33|0]|0)|0;a[(c[b+352>>2]|0)+33|0]=k;y=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[b+360>>2]|0)+33|0]|0)|0;a[(c[b+352>>2]|0)+33|0]=j;y=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+33|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0)|0;a[(c[b+352>>2]|0)+33|0]=j;y=f;break}else{f=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0)|0;a[(c[b+352>>2]|0)+33|0]=f;y=f;break}}}}while(0);e=c[(c[g>>2]|0)+404>>2]|0;do{if(!((e|0)==2|(e|0)==-1)){if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){l=0}else{break}m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+404|0;x=w;c[x>>2]=l;i=d;return}}while(0);l=(y<<24>>24!=0)<<31>>31;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+404|0;x=w;c[x>>2]=l;i=d;return}



function TDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80776]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7160>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(80784,qNa(+h[(c[g>>2]|0)+7160>>3],21128)|0)|0;g=c[41886]|0;j=e;k=80896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[80776]=1;i=d;return}function UDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80920]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7152>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(80928,qNa(+h[(c[g>>2]|0)+7152>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[80920]=1;i=d;return}function VDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81064]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7144>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=uNa(81072,qNa(+h[(c[g>>2]|0)+7144>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[81064]=1;i=d;return}function WDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81208]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(81216,qNa(+h[(c[g>>2]|0)+7136>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[81208]=1;i=d;return}function XDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81336]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(81344,qNa(+h[(c[g>>2]|0)+7128>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[81336]=1;i=d;return}function YDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81464]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(81472,qNa(+h[(c[g>>2]|0)+7120>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[81464]=1;i=d;return}function ZDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81592]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(81600,qNa(+h[(c[g>>2]|0)+7112>>3],21128)|0)|0;g=c[41886]|0;j=e;k=81688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[81592]=1;i=d;return}function _Da(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81712]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(81720,qNa(+h[(c[g>>2]|0)+7104>>3],21128)|0)|0;g=c[41886]|0;j=e;k=84088;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[81712]=1;i=d;return}function $Da(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81928]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(81936,qNa(+h[(c[g>>2]|0)+7096>>3],21128)|0)|0;g=c[41886]|0;j=e;k=84232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[81928]=1;i=d;return}function aEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82048]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+420>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+420>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(82056,sNa(c[(c[g>>2]|0)+420>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=84440;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[82048]=1;i=d;return}function bEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82232]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(82240,qNa(+h[(c[g>>2]|0)+7080>>3],21128)|0)|0;g=c[41886]|0;j=e;k=84088;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[82232]=1;i=d;return}function cEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82360]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(82368,qNa(+h[(c[g>>2]|0)+7072>>3],21128)|0)|0;g=c[41886]|0;j=e;k=84232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[82360]=1;i=d;return}function dEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82480]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+416>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+416>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(82488,sNa(c[(c[g>>2]|0)+416>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=84440;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[82480]=1;i=d;return}function eEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82664]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(82672,qNa(+h[(c[g>>2]|0)+7056>>3],21128)|0)|0;g=c[41886]|0;j=e;k=84088;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[82664]=1;i=d;return}function fEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82792]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(82800,qNa(+h[(c[g>>2]|0)+7048>>3],21128)|0)|0;g=c[41886]|0;j=e;k=84232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[82792]=1;i=d;return}function gEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82912]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+412>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+412>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(82920,sNa(c[(c[g>>2]|0)+412>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=84440;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[82912]=1;i=d;return}function hEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83096]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(83104,qNa(+h[(c[g>>2]|0)+7032>>3],21128)|0)|0;g=c[41886]|0;j=e;k=84088;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[83096]=1;i=d;return}function iEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83224]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(83232,qNa(+h[(c[g>>2]|0)+7024>>3],21128)|0)|0;g=c[41886]|0;j=e;k=84232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[83224]=1;i=d;return}function jEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83344]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+408>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+408>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(83352,sNa(c[(c[g>>2]|0)+408>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=84440;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[83344]=1;i=d;return}function kEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83528]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(83536,qNa(+h[(c[g>>2]|0)+7008>>3],21128)|0)|0;g=c[41886]|0;j=e;k=84088;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[83528]=1;i=d;return}function lEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83656]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+7e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(83664,qNa(+h[(c[g>>2]|0)+7e3>>3],21128)|0)|0;g=c[41886]|0;j=e;k=84232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[83656]=1;i=d;return}function mEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83776]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+404>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+404>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(83784,sNa(c[(c[g>>2]|0)+404>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=84440;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[83776]=1;i=d;return}function nEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83960]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+6984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(83968,qNa(+h[(c[g>>2]|0)+6984>>3],21128)|0)|0;g=c[41886]|0;j=e;k=84088;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[83960]=1;i=d;return}function oEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84112]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+6976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(84120,qNa(+h[(c[g>>2]|0)+6976>>3],21128)|0)|0;g=c[41886]|0;j=e;k=84232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[84112]=1;i=d;return}function pEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84256]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+400>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+400>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=uNa(84264,sNa(c[(c[g>>2]|0)+400>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=84440;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[84256]=1;i=d;return}function qEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84464]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+6952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(84472,qNa(+h[(c[g>>2]|0)+6952>>3],21128)|0)|0;g=c[41886]|0;j=e;k=84560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[84464]=1;i=d;return}function rEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84584]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+6912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(84592,qNa(+h[(c[g>>2]|0)+6912>>3],21128)|0)|0;g=c[41886]|0;j=e;k=84816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[84584]=1;i=d;return}function sEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84840]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+6856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(84848,qNa(+h[(c[g>>2]|0)+6856>>3],21128)|0)|0;g=c[41886]|0;j=e;k=84968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[84840]=1;i=d;return}function tEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84992]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+6792>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(85e3,qNa(+h[(c[g>>2]|0)+6792>>3],21128)|0)|0;g=c[41886]|0;j=e;k=85112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[84992]=1;i=d;return}function uEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85136]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+6784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(85144,qNa(+h[(c[g>>2]|0)+6784>>3],21128)|0)|0;g=c[41886]|0;j=e;k=85264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[85136]=1;i=d;return}function vEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85288]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+6776>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(85296,qNa(+h[(c[g>>2]|0)+6776>>3],21128)|0)|0;g=c[41886]|0;j=e;k=85416;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[85288]=1;i=d;return}function wEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85440]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+6768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(85448,qNa(+h[(c[g>>2]|0)+6768>>3],21128)|0)|0;g=c[41886]|0;j=e;k=85592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[85440]=1;i=d;return}function xEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85616]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+6736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(85624,qNa(+h[(c[g>>2]|0)+6736>>3],21128)|0)|0;g=c[41886]|0;j=e;k=85760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[85616]=1;i=d;return}function yEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85784]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+6728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(85792,qNa(+h[(c[g>>2]|0)+6728>>3],21128)|0)|0;g=c[41886]|0;j=e;k=85888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[85784]=1;i=d;return}function zEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85912]&1){i=d;return}g=b+420|0;b=fQa(+(c[(c[g>>2]|0)+384>>2]|0),1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[g>>2]|0)+384>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(85920,sNa(c[(c[g>>2]|0)+384>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=86184;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[85912]=1;i=d;return}function AEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86208]&1){i=d;return}g=b+416|0;if(!((fQa(+h[(c[g>>2]|0)+6448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=uNa(86216,qNa(+h[(c[g>>2]|0)+6448>>3],21128)|0)|0;g=c[41886]|0;j=e;k=86288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[86208]=1;i=d;return}function BEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86312]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+392>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+392>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(86320,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+392>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[86312]=1;i=d;return}function CEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86464]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+388>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+388>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(86472,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+388>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[86464]=1;i=d;return}function DEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86616]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+384>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+384>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(86624,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+384>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[86616]=1;i=d;return}function EEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86768]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+380>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+380>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(86776,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+380>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[86768]=1;i=d;return}function FEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86952]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+376>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+376>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(86960,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+376>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[86952]=1;i=d;return}function GEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87136]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+372>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+372>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(87144,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+372>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[87136]=1;i=d;return}function HEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87320]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+368>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+368>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(87328,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+368>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[87320]=1;i=d;return}function IEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87520]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+364>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+364>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(87528,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+364>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[87520]=1;i=d;return}function JEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87720]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+360>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+360>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(87728,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+360>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[87720]=1;i=d;return}function KEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87920]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+356>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+356>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(87928,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+356>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[87920]=1;i=d;return}function LEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88064]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+352>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+352>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(88072,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+352>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[88064]=1;i=d;return}function MEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88208]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+348>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+348>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(88216,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+348>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[88208]=1;i=d;return}function NEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88352]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+344>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+344>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(88360,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+344>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[88352]=1;i=d;return}function OEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88528]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+340>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+340>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(88536,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+340>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[88528]=1;i=d;return}function PEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88704]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+336>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+336>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(88712,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+336>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[88704]=1;i=d;return}function QEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88880]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+332>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+332>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(88888,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+332>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[88880]=1;i=d;return}function REa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89072]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+328>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+328>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(89080,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+328>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[89072]=1;i=d;return}function SEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89264]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+324>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+324>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(89272,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+324>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[89264]=1;i=d;return}function TEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89456]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+320>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+320>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(89464,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+320>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[89456]=1;i=d;return}function UEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89600]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+316>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+316>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(89608,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+316>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[89600]=1;i=d;return}function VEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89744]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+312>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+312>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(89752,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+312>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[89744]=1;i=d;return}function WEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89888]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+308>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+308>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(89896,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+308>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[89888]=1;i=d;return}function XEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90064]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+304>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+304>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(90072,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+304>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[90064]=1;i=d;return}function YEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90240]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+300>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+300>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(90248,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+300>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[90240]=1;i=d;return}function ZEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90416]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+296>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+296>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(90424,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+296>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[90416]=1;i=d;return}function _Ea(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90608]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+292>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+292>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(90616,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+292>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[90608]=1;i=d;return}function $Ea(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90800]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+288>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+288>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(90808,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+288>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[90800]=1;i=d;return}function aFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90992]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+284>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+284>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(91e3,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+284>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[90992]=1;i=d;return}function bFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91136]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+280>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+280>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(91144,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+280>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[91136]=1;i=d;return}function cFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91280]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+276>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+276>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(91288,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+276>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[91280]=1;i=d;return}function dFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91424]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+272>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+272>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(91432,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+272>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[91424]=1;i=d;return}function eFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91600]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+268>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+268>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(91608,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+268>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[91600]=1;i=d;return}function fFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91776]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+264>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+264>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(91784,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+264>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[91776]=1;i=d;return}function gFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91952]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+260>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+260>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(91960,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+260>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[91952]=1;i=d;return}function hFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92144]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+256>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+256>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(92152,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+256>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[92144]=1;i=d;return}function iFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92336]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+252>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+252>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(92344,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+252>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[92336]=1;i=d;return}function jFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92528]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(92536,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[92528]=1;i=d;return}function kFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92672]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(92680,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[92672]=1;i=d;return}function lFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92816]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(92824,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[92816]=1;i=d;return}function mFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92960]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(92968,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[92960]=1;i=d;return}function nFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93136]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(93144,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[93136]=1;i=d;return}function oFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93312]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(93320,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[93312]=1;i=d;return}function pFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93488]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(93496,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[93488]=1;i=d;return}function qFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93680]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(93688,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[93680]=1;i=d;return}function rFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93872]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(93880,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[93872]=1;i=d;return}function sFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94064]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(94072,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[94064]=1;i=d;return}function tFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94208]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(94216,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[94208]=1;i=d;return}function uFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94352]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(94360,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[94352]=1;i=d;return}function vFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94496]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(94504,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[94496]=1;i=d;return}function wFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94672]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(94680,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[94672]=1;i=d;return}function xFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94848]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(94856,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[94848]=1;i=d;return}function yFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95024]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(95032,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[95024]=1;i=d;return}function zFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95216]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(95224,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[95216]=1;i=d;return}function AFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95408]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(95416,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[95408]=1;i=d;return}function BFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95600]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(95608,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[95600]=1;i=d;return}function CFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95744]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(95752,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[95744]=1;i=d;return}function DFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95888]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(95896,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[95888]=1;i=d;return}function EFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96032]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(96040,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[96032]=1;i=d;return}function FFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96208]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(96216,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[96208]=1;i=d;return}function GFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96384]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(96392,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[96384]=1;i=d;return}function HFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96560]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(96568,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[96560]=1;i=d;return}function IFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96752]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(96760,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[96752]=1;i=d;return}function JFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96944]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(96952,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[96944]=1;i=d;return}function KFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97136]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(97144,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[97136]=1;i=d;return}function LFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97280]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(97288,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[97280]=1;i=d;return}function MFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97424]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(97432,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=97568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[97424]=1;i=d;return}function NFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97592]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(97600,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[97592]=1;i=d;return}function OFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97768]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(97776,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[97768]=1;i=d;return}function PFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97944]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(97952,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[97944]=1;i=d;return}function QFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98144]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(98152,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[98144]=1;i=d;return}function RFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98336]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(98344,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[98336]=1;i=d;return}function SFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98528]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(98536,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=98720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[98528]=1;i=d;return}function TFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98744]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(98752,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[98744]=1;i=d;return}function UFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98912]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(98920,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[98912]=1;i=d;return}function VFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99080]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(99088,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[99080]=1;i=d;return}function WFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99248]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(99256,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[99248]=1;i=d;return}function XFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99416]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(99424,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[99416]=1;i=d;return}function YFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99584]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(99592,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[99584]=1;i=d;return}function ZFa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99752]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(99760,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[99752]=1;i=d;return}function _Fa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99920]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(99928,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[99920]=1;i=d;return}function $Fa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100088]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(100096,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[100088]=1;i=d;return}function aGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100256]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(100264,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[100256]=1;i=d;return}function bGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100424]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(100432,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[100424]=1;i=d;return}function cGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100592]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(100600,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[100592]=1;i=d;return}function dGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100760]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(100768,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[100760]=1;i=d;return}function eGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100928]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(100936,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[100928]=1;i=d;return}function fGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101096]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(101104,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[101096]=1;i=d;return}function gGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101264]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(101272,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[101264]=1;i=d;return}function hGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101432]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(101440,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[101432]=1;i=d;return}function iGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101600]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(101608,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=101768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[101600]=1;i=d;return}function jGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101792]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(101800,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=102296;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[101792]=1;i=d;return}function kGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101960]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(101968,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=102296;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[101960]=1;i=d;return}function lGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102128]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(102136,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=102296;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[102128]=1;i=d;return}function mGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102320]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(102328,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=102896;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[102320]=1;i=d;return}function nGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102512]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(102520,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=102896;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[102512]=1;i=d;return}function oGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102704]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(102712,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=102896;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[102704]=1;i=d;return}function pGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102920]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(102928,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=103472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[102920]=1;i=d;return}function qGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103104]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(103112,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=103472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[103104]=1;i=d;return}function rGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103288]&1){i=d;return}g=b+4|0;b=fQa(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),0.0)|0;if(!(b<<24>>24==0|(dQa(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=uNa(103296,sNa(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0,21344)|0)|0;g=c[41886]|0;h=e;j=103472;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[103288]=1;i=d;return}



function gWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Zc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;hc=i;i=i+8|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=qa;hWa(qa);g5a(ra);iWa(sa,ta);iWa(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[175192>>2]|0)==0){m5a(za,c[b+80>>2]|0);jWa(ya,za,162216);t5a(ra,ya)|0;s5a(ya);s5a(za)}else{u5a(ra,c[175320>>2]|0)|0}ta=ic(P5a(ra)|0,162232)|0;if((ta|0)!=0){Wc=ta;break}c[pa>>2]=P5a(ra)|0;WMa(0,162240,pa)}else{Wc=0}}while(0);pa=MHa(0)|0;if((pa|0)==0){Yc(Wc|0)|0;WMa(0,162344,oa)}XHa(pa,Vc);YHa(pa,9,93);Vc=c[va>>2]|0;do{if((Vc|0)==0){oa=Aa;dgb(oa|0,0,1024)|0;while(1){za=sb(oa|0,1,1024,Wc|0)|0;ya=za>>>0<1024;if((ZHa(pa,oa,za,ya&1)|0)==0){Xc=12;break}if(ya){Xc=14;break}}if((Xc|0)==12){Yc(Wc|0)|0;oa=P5a(ra)|0;ya=fIa(cIa(pa)|0)|0;za=dIa(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;UMa(1,0,162424,na);THa(pa);WMa(0,162512,ma)}else if((Xc|0)==14){Yc(Wc|0)|0;break}}else{if((ZHa(pa,Vc,$fb(Vc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=fIa(cIa(pa)|0)|0;ta=dIa(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;wd(za|0,162536,la|0)|0;za=c[va>>2]|0;ta=fIa(cIa(pa)|0)|0;oa=dIa(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;UMa(1,0,162552,ka);THa(pa);WMa(0,162512,ja)}}while(0);ja=qa;m5a(Ca,162640);nWa(Ba,ja,Ca);oWa(Da,ja);ka=mWa(Ba,Da)|0;s5a(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=P5a(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;UMa(1,0,162648,ia)}else{m5a(Ea,162640);Ba=Xfb(Da,P5a(ZVa(ja,Ea)|0)|0)|0;s5a(Ea);if((Ba|0)==0){break}THa(pa);m5a(Fa,162640);Ba=P5a(ZVa(ja,Fa)|0)|0;va=P5a(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;UMa(1,0,162696,ha);s5a(Fa);WMa(0,162512,ga)}}while(0);pWa(qa,b,c[175404>>2]|0,c[175408>>2]|0);SMa(23,1,162792,fa);fa=qa+12|0;m5a(Ha,162832);i5a(Ga,ZVa(fa,Ha)|0);ga=d;cWa(Ga,ga,0.0);s5a(Ga);s5a(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];SMa(23,0,162848,ea);m5a(Ja,162864);i5a(Ia,ZVa(fa,Ja)|0);ea=d+8|0;cWa(Ia,ea,1.0);s5a(Ia);s5a(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];SMa(23,0,162880,da);m5a(La,162896);i5a(Ka,ZVa(fa,La)|0);da=d+24|0;cWa(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);s5a(Ka);s5a(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];SMa(23,0,162912,ca);m5a(Na,162928);i5a(Ma,ZVa(fa,Na)|0);ca=d+32|0;cWa(Ma,ca,1.0e-5);s5a(Ma);s5a(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];SMa(23,0,162944,ba);m5a(Pa,162960);i5a(Oa,ZVa(fa,Pa)|0);ba=d+40|0;YVa(Oa,ba);s5a(Oa);s5a(Pa);c[aa>>2]=c[ba>>2];SMa(23,0,162968,aa);m5a(Ra,162992);i5a(Qa,ZVa(fa,Ra)|0);aa=d+44|0;YVa(Qa,aa);s5a(Qa);s5a(Ra);c[$>>2]=c[aa>>2];SMa(23,0,163008,$);m5a(Ta,163032);i5a(Sa,ZVa(fa,Ta)|0);fa=d+48|0;YVa(Sa,fa);s5a(Sa);s5a(Ta);c[_>>2]=c[fa>>2];SMa(23,0,163048,_);m5a(Va,163072);i5a(Ua,ZVa(ja,Va)|0);_=d+268|0;YVa(Ua,_);s5a(Ua);s5a(Va);c[Z>>2]=c[_>>2];SMa(23,0,163096,Z);if((c[118284>>2]|0)!=0){fe[c[29686]&511](23)}m5a(eb,163120);i5a(db,ZVa(ja,eb)|0);$Va(db,Wa,0);s5a(db);s5a(eb);m5a(gb,163152);i5a(fb,ZVa(ja,gb)|0);$Va(fb,Xa,0);s5a(fb);s5a(gb);m5a(ib,163184);i5a(hb,ZVa(ja,ib)|0);$Va(hb,Ya,0);s5a(hb);s5a(ib);m5a(kb,163208);i5a(jb,ZVa(ja,kb)|0);$Va(jb,_a,0);s5a(jb);s5a(kb);m5a(mb,163240);i5a(lb,ZVa(ja,mb)|0);$Va(lb,Za,0);s5a(lb);s5a(mb);m5a(ob,163280);i5a(nb,ZVa(ja,ob)|0);$Va(nb,ab,0);s5a(nb);s5a(ob);m5a(qb,163312);i5a(pb,ZVa(ja,qb)|0);$Va(pb,$a,0);s5a(pb);s5a(qb);m5a(tb,163352);i5a(rb,ZVa(ja,tb)|0);$Va(rb,cb,0);s5a(rb);s5a(tb);m5a(vb,163384);i5a(ub,ZVa(ja,vb)|0);$Va(ub,bb,0);s5a(ub);s5a(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}rb=b+116|0;if((c[Za>>2]|0)!=(c[rb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=163928;SMa(4,1,163904,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=qWa(lb,wb)|0;XVa(ib,jb+(kb*112|0)|0);aWa(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[175188>>2]|0)!=0){break}m5a(xb,163944);jb=(S5a(ZVa(ib,xb)|0,162080)|0)==0;s5a(xb);if(!jb){break}c[N>>2]=c[hb>>2];SMa(4,0,163960,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);m5a(yb,c[hb>>2]|0);c[(rWa(sa,yb)|0)>>2]=kb;s5a(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[118208>>2]|0)!=0){fe[c[29686]&511](4)}c[M>>2]=163992;SMa(4,1,163904,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=qWa(lb,zb)|0;XVa(fb,gb+(jb*112|0)|0);aWa(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[175188>>2]|0)!=0){break}m5a(Ab,163944);gb=(S5a(ZVa(fb,Ab)|0,162080)|0)==0;s5a(Ab);if(!gb){break}c[L>>2]=c[eb>>2];SMa(4,0,163960,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);m5a(Bb,c[eb>>2]|0);c[(rWa(sa,Bb)|0)>>2]=jb;s5a(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[118208>>2]|0)!=0){fe[c[29686]&511](4)}c[K>>2]=164016;SMa(4,1,163904,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=qWa(mb,Cb)|0;XVa(gb,hb+(fb*112|0)|0);aWa(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[175188>>2]|0)!=0){break}m5a(Db,163944);hb=(S5a(ZVa(gb,Db)|0,162080)|0)==0;s5a(Db);if(!hb){break}c[J>>2]=c[db>>2];SMa(4,0,163960,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);m5a(Eb,c[db>>2]|0);c[(rWa(sa,Eb)|0)>>2]=fb;s5a(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[118208>>2]|0)!=0){fe[c[29686]&511](4)}c[I>>2]=164032;SMa(4,1,163904,I);if((c[rb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=qWa(ub,Fb)|0;XVa(mb,kb+(ib*60|0)|0);dWa(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[175188>>2]|0)!=0){break}m5a(Gb,163944);kb=(S5a(ZVa(mb,Gb)|0,162080)|0)==0;s5a(Gb);if(!kb){break}c[H>>2]=c[gb>>2];SMa(4,0,163960,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);m5a(Hb,c[gb>>2]|0);c[(rWa(sa,Hb)|0)>>2]=ib;s5a(Hb);ib=ib+1|0;}while((ib|0)<(c[rb>>2]|0))}if((c[118208>>2]|0)!=0){fe[c[29686]&511](4)}c[G>>2]=164056;SMa(4,1,163904,G);if((c[pb>>2]|0)>0){rb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[rb>>2]|0;c[Ib>>2]=lb;mb=qWa(ib,Ib)|0;XVa(mb,ub+(lb*48|0)|0);eWa(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[175188>>2]|0)!=0){break}m5a(Jb,163944);ub=(S5a(ZVa(mb,Jb)|0,162080)|0)==0;s5a(Jb);if(!ub){break}c[F>>2]=c[fb>>2];SMa(4,0,163960,F);a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);m5a(Kb,c[fb>>2]|0);c[(rWa(sa,Kb)|0)>>2]=lb;s5a(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[118208>>2]|0)!=0){fe[c[29686]&511](4)}c[E>>2]=164080;SMa(4,1,163904,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;rb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=rb;mb=qWa(lb,Lb)|0;XVa(mb,ib+(rb*52|0)|0);fWa(mb,ib+(rb*52|0)+36|0);gb=ib+(rb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}else{if((c[175188>>2]|0)!=0){break}m5a(Mb,163944);ib=(S5a(ZVa(mb,Mb)|0,162080)|0)==0;s5a(Mb);if(!ib){break}c[D>>2]=c[gb>>2];SMa(4,0,163960,D);a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}}while(0);m5a(Nb,c[gb>>2]|0);c[(rWa(sa,Nb)|0)>>2]=rb;s5a(Nb);rb=rb+1|0;}while((rb|0)<(c[nb>>2]|0))}if((c[118208>>2]|0)!=0){fe[c[29686]&511](4)}c[C>>2]=164104;SMa(4,1,163904,C);if((c[ja>>2]|0)>0){nb=b+16|0;rb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=qWa(rb,Ob)|0;XVa(mb,lb+(pb*112|0)|0);aWa(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[175188>>2]|0)!=0){break}m5a(Pb,163944);lb=(S5a(ZVa(mb,Pb)|0,162080)|0)==0;s5a(Pb);if(!lb){break}c[B>>2]=c[fb>>2];SMa(4,0,163960,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);m5a(Qb,c[fb>>2]|0);c[(rWa(ua,Qb)|0)>>2]=pb;s5a(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[118208>>2]|0)!=0){fe[c[29686]&511](4)}c[A>>2]=164120;SMa(4,1,163904,A);if((c[tb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{rb=c[ja>>2]|0;c[Rb>>2]=nb;mb=qWa(pb,Rb)|0;XVa(mb,rb+(nb*60|0)|0);dWa(mb,rb+(nb*60|0)+36|0);gb=rb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[175188>>2]|0)!=0){break}m5a(Sb,163944);rb=(S5a(ZVa(mb,Sb)|0,162080)|0)==0;s5a(Sb);if(!rb){break}c[z>>2]=c[gb>>2];SMa(4,0,163960,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);m5a(Tb,c[gb>>2]|0);c[(rWa(ua,Tb)|0)>>2]=nb;s5a(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[118208>>2]|0)!=0){fe[c[29686]&511](4)}c[y>>2]=164144;SMa(4,1,163904,y);if((c[qb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[tb>>2]|0;c[Ub>>2]=ja;mb=qWa(nb,Ub)|0;XVa(mb,pb+(ja*48|0)|0);eWa(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[175188>>2]|0)!=0){break}m5a(Vb,163944);pb=(S5a(ZVa(mb,Vb)|0,162080)|0)==0;s5a(Vb);if(!pb){break}c[x>>2]=c[fb>>2];SMa(4,0,163960,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);m5a(Wb,c[fb>>2]|0);c[(rWa(ua,Wb)|0)>>2]=ja;s5a(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[118208>>2]|0)!=0){fe[c[29686]&511](4)}c[w>>2]=164168;SMa(4,1,163904,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=tb;mb=qWa(ja,Xb)|0;XVa(mb,nb+(tb*52|0)|0);fWa(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[175188>>2]|0)!=0){break}m5a(Yb,163944);nb=(S5a(ZVa(mb,Yb)|0,162080)|0)==0;s5a(Yb);if(!nb){break}c[v>>2]=c[gb>>2];SMa(4,0,163960,v);a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);m5a(Zb,c[gb>>2]|0);c[(rWa(ua,Zb)|0)>>2]=tb;s5a(Zb);tb=tb+1|0;}while((tb|0)<(c[ob>>2]|0))}if((c[118208>>2]|0)!=0){fe[c[29686]&511](4)}SMa(4,1,164192,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){tb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=qWa(tb,_b)|0;XVa(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);g5a($b);c[bc>>2]=ja;mb=qWa(tb,bc)|0;m5a(cc,164232);i5a(ac,ZVa(mb,cc)|0);sWa(ac,$b);s5a(ac);s5a(cc);mb=(S5a($b,164240)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;SMa(4,0,164256,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=qWa(tb,ec)|0;m5a(fc,164296);i5a(dc,ZVa(nb,fc)|0);sWa(dc,$b);s5a(dc);s5a(fc);tWa(wa,sa,$b);tWa(xa,ua,$b);vWa(gc,sa);do{if(uWa(wa,gc)|0){nb=c[(wWa(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{vWa(hc,ua);if(uWa(xa,hc)|0){fb=c[(wWa(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((S5a($b,164312)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);s5a($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}b6a(kc,164320,$b);jWa(jc,kc,164344);s5a(kc);c[s>>2]=P5a(jc)|0;WMa(0,164360,s)}}while(0);if((c[118208>>2]|0)!=0){fe[c[29686]&511](4)}SMa(4,1,164368,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;tb=0;while(1){c[lc>>2]=tb;gb=qWa(ja,lc)|0;XVa(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);g5a(mc);c[oc>>2]=tb;gb=qWa(ja,oc)|0;m5a(pc,164232);i5a(nc,ZVa(gb,pc)|0);sWa(nc,mc);s5a(nc);s5a(pc);gb=(S5a(mc,164240)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;SMa(4,0,164256,p);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=qWa(ja,rc)|0;m5a(sc,164296);i5a(qc,ZVa(fb,sc)|0);sWa(qc,mc);s5a(qc);s5a(sc);tWa(wa,sa,mc);tWa(xa,ua,mc);vWa(tc,sa);if(uWa(wa,tc)|0){fb=c[(wWa(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{vWa(uc,ua);if(!(uWa(xa,uc)|0)){break}nb=c[(wWa(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}s5a(mc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break c}}b6a(wc,164408,mc);jWa(vc,wc,164344);s5a(wc);c[o>>2]=P5a(vc)|0;WMa(0,164360,o)}}while(0);if((c[118208>>2]|0)!=0){fe[c[29686]&511](4)}SMa(4,1,164432,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){tb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=qWa(tb,xc)|0;XVa(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);g5a(yc);c[Ac>>2]=ja;fb=qWa(tb,Ac)|0;m5a(Bc,164232);i5a(zc,ZVa(fb,Bc)|0);sWa(zc,yc);s5a(zc);s5a(Bc);fb=(S5a(yc,164240)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;SMa(4,0,164256,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=qWa(tb,Dc)|0;m5a(Ec,164296);i5a(Cc,ZVa(gb,Ec)|0);sWa(Cc,yc);s5a(Cc);s5a(Ec);tWa(wa,sa,yc);tWa(xa,ua,yc);vWa(Fc,sa);if(uWa(wa,Fc)|0){gb=c[(wWa(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{vWa(Gc,ua);if(!(uWa(xa,Gc)|0)){break}nb=c[(wWa(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}s5a(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}b6a(Ic,164472,yc);jWa(Hc,Ic,164344);s5a(Ic);c[l>>2]=P5a(Hc)|0;WMa(0,164360,l)}}while(0);if((c[118208>>2]|0)!=0){fe[c[29686]&511](4)}SMa(4,1,164496,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=qWa(ja,Jc)|0;XVa(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);g5a(Kc);c[Mc>>2]=tb;gb=qWa(ja,Mc)|0;m5a(Nc,164232);i5a(Lc,ZVa(gb,Nc)|0);sWa(Lc,Kc);s5a(Lc);s5a(Nc);gb=(S5a(Kc,164240)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;SMa(4,0,164256,g);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=qWa(ja,Pc)|0;m5a(Qc,164296);i5a(Oc,ZVa(fb,Qc)|0);sWa(Oc,Kc);s5a(Oc);s5a(Qc);tWa(wa,sa,Kc);tWa(xa,ua,Kc);vWa(Rc,sa);if(uWa(wa,Rc)|0){fb=c[(wWa(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{vWa(Sc,ua);if(!(uWa(xa,Sc)|0)){break}nb=c[(wWa(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}s5a(Kc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break e}}b6a(Uc,164536,Kc);jWa(Tc,Uc,164344);s5a(Uc);c[f>>2]=P5a(Tc)|0;WMa(0,164360,f)}}while(0);if((c[118208>>2]|0)==0){THa(pa);xWa(ua);xWa(sa);s5a(ra);yWa(qa);i=e;return}fe[c[29686]&511](4);THa(pa);xWa(ua);xWa(sa);s5a(ra);yWa(qa);i=e;return}}while(0);if((c[118280>>2]|c[29546]|0)==0){THa(pa);Zc=ud(0)|0;Cd(-1)}UMa(22,1,163424,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;UMa(22,0,163472,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;UMa(22,0,163520,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;UMa(22,0,163568,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;UMa(22,0,163616,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;UMa(22,0,163664,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;UMa(22,0,163712,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;UMa(22,0,163760,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;UMa(22,0,163808,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;UMa(22,0,163856,P);fe[c[29686]&511](22);THa(pa);Zc=ud(0)|0;Cd(-1)}function hWa(a){a=a|0;var b=0;b=i;j1a(a);i=b;return}function iWa(a,b){a=a|0;b=b|0;b=i;QYa(a,0);i=b;return}function jWa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;h5a(a,d);e=q5a(b)|0;f=YWa(c)|0;T5a(a,r5a(b)|0,e,f+e|0);L5a(a,c,f)|0;i=d;return}function kWa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((Xfb(b,165168)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{m5a(g,v);w=ZVa(u,g)|0;u5a(w,c[d+((t|1)<<2)>>2]|0)|0;s5a(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((Xfb(b,165192)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{m5a(h,g);u=ZVa(t,h)|0;u5a(u,c[d+((v|1)<<2)>>2]|0)|0;s5a(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((Xfb(b,165216)|0)!=0){do{if((Xfb(b,165472)|0)!=0){if((Xfb(b,165480)|0)==0){break}if((Xfb(b,165488)|0)==0){break}if((Xfb(b,165496)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=qWa(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){m5a(r,c[t>>2]|0);w=ZVa(g,r)|0;u5a(w,c[d+((u|1)<<2)>>2]|0)|0;s5a(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=qWa(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}m5a(s,165504);u5a(ZVa(x,s)|0,b)|0;s5a(s);i=e;return}zWa(j,k);g5a(l);g5a(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{m5a(n,g);t=ZVa(j,n)|0;u5a(t,c[d+((x|1)<<2)>>2]|0)|0;s5a(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}m5a(o,165232);t5a(l,ZVa(j,o)|0)|0;s5a(o);m5a(p,165248);t5a(m,ZVa(j,p)|0)|0;s5a(p);c[k>>2]=Fc(P5a(l)|0)|0;if((S5a(m,165264)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((S5a(m,165272)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((S5a(m,165280)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((S5a(m,165288)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((S5a(m,165296)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((S5a(m,165304)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((S5a(m,165312)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((S5a(m,165320)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((S5a(m,165328)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((S5a(m,165336)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((S5a(m,165344)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((S5a(m,165352)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((S5a(m,165360)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((S5a(m,165368)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=P5a(m)|0;m5a(q,161792);N=P5a(ZVa(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;VMa(0,(O|0)!=0|0,165376,f);s5a(q);O$a(qWa(c[b>>2]|0,s)|0,j)|0;s5a(m);s5a(l);HWa(j);i=e;return}function lWa(a,b){a=a|0;b=b|0;i=i;return}function mWa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zYa(a,b)|0;i=c;return d|0}function nWa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;IYa(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];AYa(a,f);i=e;return}function oWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;BYa(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];AYa(a,e);i=d;return}function pWa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;zWa(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){WMa(0,164560,n)}if(p){ec=Ad(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;SMa(23,0,164704,m);AWa(q);BWa(q,e,8);if(!(CWa(q)|0)){c[l>>2]=e;WMa(0,164744,l)}g5a(r);l=q;DWa(l,r)|0;i5a(s,r);while(1){e=DWa(l,r)|0;if(!(c6a(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}b6a(t,164824,r);J5a(s,t)|0;s5a(t)}t=Ad(P5a(s)|0)|0;EWa(q);s5a(s);s5a(r);FWa(q);fc=t}if((fc|0)==0){SMa(23,0,164912,g);HWa(o);i=f;return}g5a(u);g5a(v);c[k>>2]=fc;SMa(23,0,164832,k);k=Xb(fc|0,164824)|0;if((k|0)!=0){g=k;do{k=Dfb(12)|0;m5a(k,g);t=Q5a(k,164864,0)|0;O5a(w,k,0,t);t5a(u,w)|0;s5a(w);O5a(x,k,t+1|0,(z5a(k)|0)+~t|0);t5a(v,x)|0;s5a(x);t5a(ZVa(o,u)|0,v)|0;t=P5a(u)|0;k=P5a(v)|0;c[j>>2]=t;c[j+4>>2]=k;SMa(23,0,164872,j);g=Xb(0,164824)|0;}while((g|0)!=0)}yfb(fc);fc=a+12|0;m5a(y,162960);g=ZVa(fc,y)|0;m5a(z,162960);if((GWa(o,z)|0)==0){m5a(B,162960);gc=1;hc=0;ic=ZVa(fc,B)|0}else{m5a(A,162960);gc=0;hc=1;ic=ZVa(o,A)|0}t5a(g,ic)|0;if(gc){s5a(B)}if(hc){s5a(A)}s5a(z);s5a(y);m5a(C,162832);y=ZVa(fc,C)|0;m5a(D,162832);if((GWa(o,D)|0)==0){m5a(F,162832);jc=1;kc=0;lc=ZVa(fc,F)|0}else{m5a(E,162832);jc=0;kc=1;lc=ZVa(o,E)|0}t5a(y,lc)|0;if(jc){s5a(F)}if(kc){s5a(E)}s5a(D);s5a(C);m5a(G,162864);C=ZVa(fc,G)|0;m5a(H,162864);if((GWa(o,H)|0)==0){m5a(J,162864);mc=1;nc=0;oc=ZVa(fc,J)|0}else{m5a(I,162864);mc=0;nc=1;oc=ZVa(o,I)|0}t5a(C,oc)|0;if(mc){s5a(J)}if(nc){s5a(I)}s5a(H);s5a(G);m5a(K,162896);G=ZVa(fc,K)|0;m5a(L,162896);if((GWa(o,L)|0)==0){m5a(N,162896);pc=0;qc=1;rc=ZVa(fc,N)|0}else{m5a(M,162896);pc=1;qc=0;rc=ZVa(o,M)|0}t5a(G,rc)|0;if(qc){s5a(N)}if(pc){s5a(M)}s5a(L);s5a(K);m5a(O,162928);K=ZVa(fc,O)|0;m5a(P,162928);if((GWa(o,P)|0)==0){m5a(R,162928);sc=1;tc=0;uc=ZVa(fc,R)|0}else{m5a(Q,162928);sc=0;tc=1;uc=ZVa(o,Q)|0}t5a(K,uc)|0;if(sc){s5a(R)}if(tc){s5a(Q)}s5a(P);s5a(O);m5a(S,162992);O=ZVa(fc,S)|0;m5a(T,162992);if((GWa(o,T)|0)==0){m5a(V,162992);vc=1;wc=0;xc=ZVa(fc,V)|0}else{m5a(U,162992);vc=0;wc=1;xc=ZVa(o,U)|0}t5a(O,xc)|0;if(vc){s5a(V)}if(wc){s5a(U)}s5a(T);s5a(S);m5a(W,163032);S=ZVa(fc,W)|0;m5a(X,163032);if((GWa(o,X)|0)==0){m5a(Z,163032);yc=1;zc=0;Ac=ZVa(fc,Z)|0}else{m5a(Y,163032);yc=0;zc=1;Ac=ZVa(o,Y)|0}t5a(S,Ac)|0;if(yc){s5a(Z)}if(zc){s5a(Y)}s5a(X);s5a(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=qWa(Y,_)|0;m5a($,161936);Ac=ZVa(yc,$)|0;c[aa>>2]=Z;yc=qWa(Y,aa)|0;m5a(ba,161792);if((GWa(o,ZVa(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=qWa(Y,ea)|0;m5a(fa,161936);Bc=1;Cc=0;Dc=ZVa(yc,fa)|0}else{c[ca>>2]=Z;yc=qWa(Y,ca)|0;m5a(da,161792);Bc=0;Cc=1;Dc=ZVa(o,ZVa(yc,da)|0)|0}t5a(Ac,Dc)|0;if(Bc){s5a(fa)}if(Cc){s5a(da)}s5a(ba);s5a($);c[ga>>2]=Z;Ac=qWa(zc,ga)|0;m5a(ha,161936);yc=ZVa(Ac,ha)|0;c[ia>>2]=Z;Ac=qWa(zc,ia)|0;m5a(ja,161792);if((GWa(o,ZVa(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=qWa(zc,ma)|0;m5a(na,161936);Ec=1;Fc=0;Gc=ZVa(Ac,na)|0}else{c[ka>>2]=Z;Ac=qWa(zc,ka)|0;m5a(la,161792);Ec=0;Fc=1;Gc=ZVa(o,ZVa(Ac,la)|0)|0}t5a(yc,Gc)|0;if(Ec){s5a(na)}if(Fc){s5a(la)}s5a(ja);s5a(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=qWa(Hc,oa)|0;m5a(pa,161936);ja=ZVa(ha,pa)|0;c[qa>>2]=Z;ha=qWa(Hc,qa)|0;m5a(ra,161792);if((GWa(o,ZVa(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=qWa(Hc,ua)|0;m5a(va,161936);Ic=1;Jc=0;Kc=ZVa(ha,va)|0}else{c[sa>>2]=Z;ha=qWa(Hc,sa)|0;m5a(ta,161792);Ic=0;Jc=1;Kc=ZVa(o,ZVa(ha,ta)|0)|0}t5a(ja,Kc)|0;if(Ic){s5a(va)}if(Jc){s5a(ta)}s5a(ra);s5a(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=qWa(X,wa)|0;m5a(xa,161936);ra=ZVa(pa,xa)|0;c[ya>>2]=Z;pa=qWa(X,ya)|0;m5a(za,161792);if((GWa(o,ZVa(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=qWa(X,Ca)|0;m5a(Da,161936);Lc=1;Mc=0;Nc=ZVa(pa,Da)|0}else{c[Aa>>2]=Z;pa=qWa(X,Aa)|0;m5a(Ba,161792);Lc=0;Mc=1;Nc=ZVa(o,ZVa(pa,Ba)|0)|0}t5a(ra,Nc)|0;if(Lc){s5a(Da)}if(Mc){s5a(Ba)}s5a(za);s5a(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=qWa(Z,Ea)|0;m5a(Fa,161936);Ba=ZVa(za,Fa)|0;c[Ga>>2]=xa;za=qWa(Z,Ga)|0;m5a(Ha,161792);if((GWa(o,ZVa(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=qWa(Z,Ka)|0;m5a(La,161936);Oc=1;Pc=0;Qc=ZVa(za,La)|0}else{c[Ia>>2]=xa;za=qWa(Z,Ia)|0;m5a(Ja,161792);Oc=0;Pc=1;Qc=ZVa(o,ZVa(za,Ja)|0)|0}t5a(Ba,Qc)|0;if(Oc){s5a(La)}if(Pc){s5a(Ja)}s5a(Ha);s5a(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=qWa(xa,Ma)|0;m5a(Na,161936);Ja=ZVa(Ha,Na)|0;c[Oa>>2]=Fa;Ha=qWa(xa,Oa)|0;m5a(Pa,161792);if((GWa(o,ZVa(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=qWa(xa,Sa)|0;m5a(Ta,161936);Rc=1;Sc=0;Tc=ZVa(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=qWa(xa,Qa)|0;m5a(Ra,161792);Rc=0;Sc=1;Tc=ZVa(o,ZVa(Ha,Ra)|0)|0}t5a(Ja,Tc)|0;if(Rc){s5a(Ta)}if(Sc){s5a(Ra)}s5a(Pa);s5a(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=qWa(Fa,Ua)|0;m5a(Va,161936);Ra=ZVa(Pa,Va)|0;c[Wa>>2]=Na;Pa=qWa(Fa,Wa)|0;m5a(Xa,161792);if((GWa(o,ZVa(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=qWa(Fa,_a)|0;m5a($a,161936);Uc=1;Vc=0;Wc=ZVa(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=qWa(Fa,Ya)|0;m5a(Za,161792);Uc=0;Vc=1;Wc=ZVa(o,ZVa(Pa,Za)|0)|0}t5a(Ra,Wc)|0;if(Uc){s5a($a)}if(Vc){s5a(Za)}s5a(Xa);s5a(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=qWa(Na,ab)|0;m5a(bb,161936);Za=ZVa(Xa,bb)|0;c[cb>>2]=Va;Xa=qWa(Na,cb)|0;m5a(db,161792);if((GWa(o,ZVa(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=qWa(Na,gb)|0;m5a(hb,161936);Xc=1;Yc=0;Zc=ZVa(Xa,hb)|0}else{c[eb>>2]=Va;Xa=qWa(Na,eb)|0;m5a(fb,161792);Xc=0;Yc=1;Zc=ZVa(o,ZVa(Xa,fb)|0)|0}t5a(Za,Zc)|0;if(Xc){s5a(hb)}if(Yc){s5a(fb)}s5a(db);s5a(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=qWa(Va,ib)|0;m5a(jb,161936);fb=ZVa(db,jb)|0;c[kb>>2]=bb;db=qWa(Va,kb)|0;m5a(lb,161792);if((GWa(o,ZVa(db,lb)|0)|0)==0){c[ob>>2]=bb;db=qWa(Va,ob)|0;m5a(pb,161936);_c=1;$c=0;ad=ZVa(db,pb)|0}else{c[mb>>2]=bb;db=qWa(Va,mb)|0;m5a(nb,161792);_c=0;$c=1;ad=ZVa(o,ZVa(db,nb)|0)|0}t5a(fb,ad)|0;if(_c){s5a(pb)}if($c){s5a(nb)}s5a(lb);s5a(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=qWa(bb,qb)|0;m5a(rb,161936);nb=ZVa(lb,rb)|0;c[sb>>2]=jb;lb=qWa(bb,sb)|0;m5a(tb,161792);if((GWa(o,ZVa(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=qWa(bb,wb)|0;m5a(xb,161936);bd=1;cd=0;dd=ZVa(lb,xb)|0}else{c[ub>>2]=jb;lb=qWa(bb,ub)|0;m5a(vb,161792);bd=0;cd=1;dd=ZVa(o,ZVa(lb,vb)|0)|0}t5a(nb,dd)|0;if(bd){s5a(xb)}if(cd){s5a(vb)}s5a(tb);s5a(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=qWa(jb,yb)|0;m5a(zb,161936);vb=ZVa(tb,zb)|0;c[Ab>>2]=rb;tb=qWa(jb,Ab)|0;m5a(Bb,161792);if((GWa(o,ZVa(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=qWa(jb,Eb)|0;m5a(Fb,161936);ed=1;fd=0;gd=ZVa(tb,Fb)|0}else{c[Cb>>2]=rb;tb=qWa(jb,Cb)|0;m5a(Db,161792);ed=0;fd=1;gd=ZVa(o,ZVa(tb,Db)|0)|0}t5a(vb,gd)|0;if(ed){s5a(Fb)}if(fd){s5a(Db)}s5a(Bb);s5a(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=qWa(rb,Gb)|0;m5a(Hb,161936);Db=ZVa(Bb,Hb)|0;c[Ib>>2]=zb;Bb=qWa(rb,Ib)|0;m5a(Jb,161792);if((GWa(o,ZVa(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=qWa(rb,Mb)|0;m5a(Nb,161936);hd=0;id=1;jd=ZVa(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=qWa(rb,Kb)|0;m5a(Lb,161792);hd=1;id=0;jd=ZVa(o,ZVa(Bb,Lb)|0)|0}t5a(Db,jd)|0;if(id){s5a(Nb)}if(hd){s5a(Lb)}s5a(Jb);s5a(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=qWa(zb,Ob)|0;m5a(Pb,161936);Lb=ZVa(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=qWa(zb,Qb)|0;m5a(Rb,161792);if((GWa(o,ZVa(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=qWa(zb,Ub)|0;m5a(Vb,161936);kd=1;ld=0;md=ZVa(Jb,Vb)|0}else{c[Sb>>2]=Hb;Jb=qWa(zb,Sb)|0;m5a(Tb,161792);kd=0;ld=1;md=ZVa(o,ZVa(Jb,Tb)|0)|0}t5a(Lb,md)|0;if(kd){s5a(Vb)}if(ld){s5a(Tb)}s5a(Rb);s5a(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Wb>>2]=a;Hb=qWa(b,Wb)|0;m5a(Yb,161936);Pb=ZVa(Hb,Yb)|0;c[Zb>>2]=a;Hb=qWa(b,Zb)|0;m5a(_b,161792);if((GWa(o,ZVa(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=qWa(b,bc)|0;m5a(cc,161936);nd=1;od=0;pd=ZVa(Hb,cc)|0}else{c[$b>>2]=a;Hb=qWa(b,$b)|0;m5a(ac,161792);nd=0;od=1;pd=ZVa(o,ZVa(Hb,ac)|0)|0}t5a(Pb,pd)|0;if(nd){s5a(cc)}if(od){s5a(ac)}s5a(_b);s5a(Yb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}SMa(23,0,164896,h);s5a(v);s5a(u);HWa(o);i=f;return}function qWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=ZYa(a,f,b)|0;l=c[k>>2]|0;JSa(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}$Ya(j,a,b);aZa(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];_Ya(g,e);bZa(j);j=c[f>>2]|0;cZa(a,j,k,dZa(g)|0);k=eZa(g)|0;bZa(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function rWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=BXa(a,f,b)|0;l=c[k>>2]|0;JSa(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}DXa(j,a,b);EXa(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];CXa(g,e);FXa(j);j=c[f>>2]|0;GXa(a,j,k,HXa(g)|0);k=IXa(g)|0;FXa(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function sWa(a,b){a=a|0;b=b|0;var c=0;c=i;t5a(b,a)|0;i=c;return}function tWa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;sXa(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];kXa(a,f);i=e;return}function uWa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=iXa(a,b)|0;i=c;return d|0}function vWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;lXa(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];kXa(a,e);i=d;return}function wWa(a){a=a|0;var b=0,c=0;b=i;c=fXa(a)|0;i=b;return c|0}function xWa(a){a=a|0;var b=0;b=i;E$a(a);i=b;return}function yWa(a){a=a|0;var b=0;b=i;r$a(a);i=b;return}function zWa(a,b){a=a|0;b=b|0;b=i;_Za(a,0);i=b;return}function AWa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;p6a(d);e=a;c[e>>2]=164964;f=d;c[f>>2]=164984;d=a+8|0;h7a(a,164996|0,d);c[e>>2]=164964;c[f>>2]=164984;qVa(d);i=b;return}function BWa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(RSa(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){g6a(d,4);i=e;return}else{e6a(d,0);i=e;return}}function CWa(a){a=a|0;var b=0,c=0;b=i;c=aXa(a+8|0)|0;i=b;return c|0}function DWa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=$Wa(a,b,n6a(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function EWa(a){a=a|0;var b=0;b=i;if((TSa(a+8|0)|0)!=0){i=b;return}g6a(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function FWa(a){a=a|0;var b=0;b=i;eXa(a,164992);k6a(a+108|0);i=b;return}function GWa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=IWa(a,b)|0;i=c;return d|0}function HWa(a){a=a|0;var b=0;b=i;g$a(a);i=b;return}function IWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=KWa(a)|0;JSa(e);if((f|0)==0){g=0;i=d;return g|0}h=LWa(a)|0;a=f;while(1){f=a+16|0;if(MWa(h,b,f)|0){j=a}else{if(!(NWa(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;JSa(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function JWa(a){a=a|0;var b=0,c=0;b=i;c=uSa(TWa(a+4|0)|0)|0;i=b;return c|0}function KWa(a){a=a|0;var b=0,d=0;b=i;d=c[(JWa(a)|0)>>2]|0;i=b;return d|0}function LWa(a){a=a|0;var b=0,c=0;b=i;c=RWa(a+8|0)|0;i=b;return c|0}function MWa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=OWa(0,b,c)|0;i=a;return d|0}function NWa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=OWa(0,b,c)|0;i=a;return d|0}function OWa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=PWa(b,c)|0;i=a;return d|0}function PWa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(R5a(a,b)|0)<0;i=c;return d|0}function QWa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=Wfb(a,b,c)|0;i=d;return e|0}function RWa(a){a=a|0;var b=0,c=0;b=i;c=SWa(a)|0;i=b;return c|0}function SWa(a){a=a|0;i=i;return a|0}function TWa(a){a=a|0;var b=0,c=0;b=i;c=UWa(a)|0;i=b;return c|0}function UWa(a){a=a|0;i=i;return a|0}function VWa(a,b){a=a|0;b=b|0;var c=0;a=i;c=XWa(0,b,0)|0;i=a;return c|0}function WWa(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function XWa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Dfb(b)|0;i=c;return a|0}function YWa(a){a=a|0;var b=0,c=0;b=i;c=$fb(a|0)|0;i=b;return c|0}function ZWa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=_Wa(b,c,e)|0;i=d;return g|0}function _Wa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=NTa(0,a,b)|0;i=c;return(d?b:a)|0}function $Wa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;m7a(f,a,1);if(!(p7a(f)|0)){i=e;return a|0}I5a(b);f=0;while(1){g=v6a(l6a(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(DTa(g,-1)|0){h=2;j=f;break}k=f+1|0;l=ETa(g)|0;if(ITa(l,d)|0){h=0;j=k;break}K5a(b,l);if((q5a(b)|0)==-17){h=4;j=k;break}else{f=k}}g6a(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function aXa(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function bXa(a){a=a|0;var b=0;b=i;FWa(a);Ffb(a);i=b;return}function cXa(a){a=a|0;var b=0;b=i;FWa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function dXa(a){a=a|0;var b=0;b=i;bXa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function eXa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];rTa(a+8|0);i=d;return}function fXa(a){a=a|0;var b=0,d=0;b=i;d=gXa((c[a>>2]|0)+16|0)|0;i=b;return d|0}function gXa(a){a=a|0;var b=0,c=0;b=i;c=hXa(a)|0;i=b;return c|0}function hXa(a){a=a|0;i=i;return a|0}function iXa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(jXa(a,b)|0)^1;i=c;return d|0}function jXa(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function kXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];rXa(a,e);i=d;return}function lXa(a,b){a=a|0;b=b|0;var c=0;c=i;mXa(a,nXa(b)|0);i=c;return}function mXa(a,b){a=a|0;b=b|0;var c=0;c=i;qXa(a,b);i=c;return}function nXa(a){a=a|0;var b=0,c=0;b=i;c=uSa(oXa(a+4|0)|0)|0;i=b;return c|0}function oXa(a){a=a|0;var b=0,c=0;b=i;c=pXa(a)|0;i=b;return c|0}function pXa(a){a=a|0;i=i;return a|0}function qXa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function rXa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function sXa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=uXa(b)|0;tXa(f,b,d,h,nXa(b)|0);lXa(g,b);do{if(iXa(f,g)|0){h=vXa(b)|0;if(wXa(h,d,xXa(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);lXa(a,b);i=e;return}function tXa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;JSa(h);a:do{if((e|0)==0){j=f}else{k=vXa(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(AXa(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;JSa(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;JSa(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);mXa(a,j);i=g;return}function uXa(a){a=a|0;var b=0,d=0;b=i;d=c[(nXa(a)|0)>>2]|0;i=b;return d|0}function vXa(a){a=a|0;var b=0,c=0;b=i;c=yXa(a+8|0)|0;i=b;return c|0}function wXa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=OWa(0,b,c)|0;i=a;return d|0}function xXa(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function yXa(a){a=a|0;var b=0,c=0;b=i;c=zXa(a)|0;i=b;return c|0}function zXa(a){a=a|0;i=i;return a|0}function AXa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=OWa(0,b,c)|0;i=a;return d|0}function BXa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=uXa(h)|0;JSa(e);if((a|0)==0){j=nXa(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(OWa(0,d,a)|0){m=l;j=c[m>>2]|0;JSa(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(OWa(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;JSa(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function CXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];xYa(a,e);i=d;return}function DXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=cYa(d)|0;d=eYa(n,1)|0;fYa(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];dYa(j,d,h);gYa(0,XXa((hYa(j)|0)+16|0)|0,e);e=iYa(j)|0;a[e+4|0]=1;jYa(0,VXa((hYa(j)|0)+28|0)|0);a[e+5|0]=1;kYa(m,j);EXa(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];CXa(b,g);FXa(m);FXa(j);i=f;return}function EXa(a,b){a=a|0;b=b|0;var c=0;c=i;aYa(a,b);i=c;return}function FXa(a){a=a|0;var b=0;b=i;RXa(a);i=b;return}function GXa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;JSa(f);c[e>>2]=0;JSa(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=NXa(a)|0;b=c[c[e>>2]>>2]|0;JSa(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(nXa(a)|0)>>2]|0;tUa(e,c[d>>2]|0);d=OXa(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function HXa(a){a=a|0;var b=0,d=0;b=i;d=c[(LXa(a)|0)>>2]|0;i=b;return d|0}function IXa(a){a=a|0;var b=0,d=0;b=i;d=JXa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function JXa(a){a=a|0;var b=0,c=0;b=i;c=KXa(a)|0;i=b;return c|0}function KXa(a){a=a|0;i=i;return a|0}function LXa(a){a=a|0;var b=0,c=0;b=i;c=MXa(a)|0;i=b;return c|0}function MXa(a){a=a|0;i=i;return a|0}function NXa(a){a=a|0;i=i;return a|0}function OXa(a){a=a|0;var b=0,c=0;b=i;c=PXa(a+8|0)|0;i=b;return c|0}function PXa(a){a=a|0;var b=0,c=0;b=i;c=QXa(a)|0;i=b;return c|0}function QXa(a){a=a|0;i=i;return a|0}function RXa(a){a=a|0;var b=0;b=i;SXa(a,0);i=b;return}function SXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=JXa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}UXa(TXa(e)|0,f);i=d;return}function TXa(a){a=a|0;var b=0,c=0;b=i;c=$Xa(a)|0;i=b;return c|0}function UXa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;WXa(f,XXa(d+16|0)|0)}if((d|0)==0){i=e;return}YXa(c[b>>2]|0,d,1);i=e;return}function VXa(a){a=a|0;i=i;return a|0}function WXa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;_Xa(d,0,c);i=b;return}function XXa(a){a=a|0;i=i;return a|0}function YXa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;ZXa(0,b,0);i=c;return}function ZXa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Ffb(b);i=c;return}function _Xa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;s5a(c);i=b;return}function $Xa(a){a=a|0;i=i;return a+4|0}function aYa(a,b){a=a|0;b=b|0;var c=0;c=i;bYa(a,b);i=c;return}function bYa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function cYa(a){a=a|0;var b=0,c=0;b=i;c=vYa(a+4|0)|0;i=b;return c|0}function dYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];nYa(a,b,f);i=e;return}function eYa(a,b){a=a|0;b=b|0;var c=0;a=i;c=mYa(0,b,0)|0;i=a;return c|0}function fYa(a,b){a=a|0;b=b|0;var c=0;c=i;lYa(a,b);i=c;return}function gYa(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}i5a(b,c);i=a;return}function hYa(a){a=a|0;var b=0,d=0;b=i;d=c[(LXa(a)|0)>>2]|0;i=b;return d|0}function iYa(a){a=a|0;var b=0,c=0;b=i;c=TXa(a)|0;i=b;return c|0}function jYa(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function kYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;aYa(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];CXa(h,f);EXa(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];CXa(a,e);FXa(h);i=d;return}function lYa(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function mYa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Dfb(b<<5)|0;i=c;return a|0}function nYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(pYa(g)|0)>>2]|0;g=qYa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];oYa(b,a,f);i=e;return}function oYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];rYa(a,b,f);i=e;return}function pYa(a){a=a|0;i=i;return a|0}function qYa(a){a=a|0;i=i;return a|0}function rYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(tYa(g)|0)>>2]|0;g=uYa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];sYa(b,a,f);i=e;return}function sYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(tYa(f)|0)>>2];f=uYa(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function tYa(a){a=a|0;i=i;return a|0}function uYa(a){a=a|0;i=i;return a|0}function vYa(a){a=a|0;var b=0,c=0;b=i;c=wYa(a)|0;i=b;return c|0}function wYa(a){a=a|0;i=i;return a|0}function xYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=IXa(yYa(b)|0)|0;h=uYa(iYa(yYa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];oYa(g,a,e);i=d;return}function yYa(a){a=a|0;i=i;return c[a>>2]|0}function zYa(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function AYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];HYa(a,e);i=d;return}function BYa(a,b){a=a|0;b=b|0;var c=0;c=i;CYa(a,DYa(b)|0);i=c;return}function CYa(a,b){a=a|0;b=b|0;var c=0;c=i;GYa(a,b);i=c;return}function DYa(a){a=a|0;var b=0,c=0;b=i;c=uSa(EYa(a+4|0)|0)|0;i=b;return c|0}function EYa(a){a=a|0;var b=0,c=0;b=i;c=FYa(a)|0;i=b;return c|0}function FYa(a){a=a|0;i=i;return a|0}function GYa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function HYa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function IYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=KYa(b)|0;JYa(f,b,d,h,DYa(b)|0);BYa(g,b);do{if(LYa(f,g)|0){h=MYa(b)|0;if(MWa(h,d,NYa(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);BYa(a,b);i=e;return}function JYa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;JSa(h);a:do{if((e|0)==0){j=f}else{k=MYa(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(NWa(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;JSa(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;JSa(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);CYa(a,j);i=g;return}function KYa(a){a=a|0;var b=0,d=0;b=i;d=c[(DYa(a)|0)>>2]|0;i=b;return d|0}function LYa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(zYa(a,b)|0)^1;i=c;return d|0}function MYa(a){a=a|0;var b=0,c=0;b=i;c=OYa(a+8|0)|0;i=b;return c|0}function NYa(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function OYa(a){a=a|0;var b=0,c=0;b=i;c=PYa(a)|0;i=b;return c|0}function PYa(a){a=a|0;i=i;return a|0}function QYa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;RYa(a,b);i=b;return}function RYa(a,b){a=a|0;b=b|0;b=i;SYa(a,0);i=b;return}function SYa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;TYa(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;UYa(f,0,e);e=nXa(b)|0;c[(NXa(b)|0)>>2]=e;i=d;return}function TYa(a){a=a|0;var b=0;b=i;XYa(a);i=b;return}function UYa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;VYa(b,c,f);i=e;return}function VYa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(lVa(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;WYa(d,b,f);i=e;return}function WYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(lVa(e)|0)>>2];i=d;return}function XYa(a){a=a|0;var b=0;b=i;YYa(a);i=b;return}function YYa(a){a=a|0;var b=0;b=i;oVa(a);i=b;return}function ZYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=ZZa(h)|0;JSa(e);if((a|0)==0){j=kZa(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(GSa(0,d,a)|0){m=l;j=c[m>>2]|0;JSa(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(GSa(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;JSa(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function _Ya(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];XZa(a,e);i=d;return}function $Ya(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=CZa(d)|0;d=EZa(n,1)|0;FZa(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];DZa(j,d,h);GZa(0,FUa((HZa(j)|0)+16|0)|0,e);e=IZa(j)|0;a[e+4|0]=1;JZa(0,vZa((HZa(j)|0)+20|0)|0);a[e+5|0]=1;KZa(m,j);aZa(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];_Ya(b,g);bZa(m);bZa(j);i=f;return}function aZa(a,b){a=a|0;b=b|0;var c=0;c=i;AZa(a,b);i=c;return}function bZa(a){a=a|0;var b=0;b=i;qZa(a);i=b;return}function cZa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;JSa(f);c[e>>2]=0;JSa(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=jZa(a)|0;b=c[c[e>>2]>>2]|0;JSa(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(kZa(a)|0)>>2]|0;tUa(e,c[d>>2]|0);d=lZa(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function dZa(a){a=a|0;var b=0,d=0;b=i;d=c[(hZa(a)|0)>>2]|0;i=b;return d|0}function eZa(a){a=a|0;var b=0,d=0;b=i;d=fZa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function fZa(a){a=a|0;var b=0,c=0;b=i;c=gZa(a)|0;i=b;return c|0}function gZa(a){a=a|0;i=i;return a|0}function hZa(a){a=a|0;var b=0,c=0;b=i;c=iZa(a)|0;i=b;return c|0}function iZa(a){a=a|0;i=i;return a|0}function jZa(a){a=a|0;i=i;return a|0}function kZa(a){a=a|0;var b=0,c=0;b=i;c=uSa(oZa(a+4|0)|0)|0;i=b;return c|0}function lZa(a){a=a|0;var b=0,c=0;b=i;c=mZa(a+8|0)|0;i=b;return c|0}function mZa(a){a=a|0;var b=0,c=0;b=i;c=nZa(a)|0;i=b;return c|0}function nZa(a){a=a|0;i=i;return a|0}function oZa(a){a=a|0;var b=0,c=0;b=i;c=pZa(a)|0;i=b;return c|0}function pZa(a){a=a|0;i=i;return a|0}function qZa(a){a=a|0;var b=0;b=i;rZa(a,0);i=b;return}function rZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=fZa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}tZa(sZa(e)|0,f);i=d;return}function sZa(a){a=a|0;var b=0,c=0;b=i;c=zZa(a)|0;i=b;return c|0}function tZa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;uZa(f,vZa(d+20|0)|0)}if((d|0)==0){i=e;return}wZa(c[b>>2]|0,d,1);i=e;return}function uZa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;yZa(d,0,c);i=b;return}function vZa(a){a=a|0;i=i;return a|0}function wZa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;xZa(0,b,0);i=c;return}function xZa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Ffb(b);i=c;return}function yZa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;HWa(c);i=b;return}function zZa(a){a=a|0;i=i;return a+4|0}function AZa(a,b){a=a|0;b=b|0;var c=0;c=i;BZa(a,b);i=c;return}function BZa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function CZa(a){a=a|0;var b=0,c=0;b=i;c=VZa(a+4|0)|0;i=b;return c|0}function DZa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];NZa(a,b,f);i=e;return}function EZa(a,b){a=a|0;b=b|0;var c=0;a=i;c=MZa(0,b,0)|0;i=a;return c|0}function FZa(a,b){a=a|0;b=b|0;var c=0;c=i;LZa(a,b);i=c;return}function GZa(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function HZa(a){a=a|0;var b=0,d=0;b=i;d=c[(hZa(a)|0)>>2]|0;i=b;return d|0}function IZa(a){a=a|0;var b=0,c=0;b=i;c=sZa(a)|0;i=b;return c|0}function JZa(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}zWa(b,a);i=a;return}function KZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;AZa(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];_Ya(h,f);aZa(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];_Ya(a,e);bZa(h);i=d;return}function LZa(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function MZa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Dfb(b<<5)|0;i=c;return a|0}function NZa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(PZa(g)|0)>>2]|0;g=QZa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];OZa(b,a,f);i=e;return}function OZa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];RZa(a,b,f);i=e;return}function PZa(a){a=a|0;i=i;return a|0}function QZa(a){a=a|0;i=i;return a|0}function RZa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(TZa(g)|0)>>2]|0;g=UZa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];SZa(b,a,f);i=e;return}function SZa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(TZa(f)|0)>>2];f=UZa(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function TZa(a){a=a|0;i=i;return a|0}function UZa(a){a=a|0;i=i;return a|0}function VZa(a){a=a|0;var b=0,c=0;b=i;c=WZa(a)|0;i=b;return c|0}function WZa(a){a=a|0;i=i;return a|0}function XZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=eZa(YZa(b)|0)|0;h=UZa(IZa(YZa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];OZa(g,a,e);i=d;return}function YZa(a){a=a|0;i=i;return c[a>>2]|0}function ZZa(a){a=a|0;var b=0,d=0;b=i;d=c[(kZa(a)|0)>>2]|0;i=b;return d|0}function _Za(a,b){a=a|0;b=b|0;b=i;i=i+8|0;$Za(a,b);i=b;return}function $Za(a,b){a=a|0;b=b|0;b=i;a_a(a,0);i=b;return}function a_a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;b_a(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;c_a(f,0,e);e=DYa(b)|0;c[(d_a(b)|0)>>2]=e;i=d;return}function b_a(a){a=a|0;var b=0;b=i;g_a(a);i=b;return}function c_a(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;e_a(b,c,f);i=e;return}function d_a(a){a=a|0;i=i;return a|0}function e_a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(lVa(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;f_a(d,b,f);i=e;return}function f_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(lVa(e)|0)>>2];i=d;return}function g_a(a){a=a|0;var b=0;b=i;h_a(a);i=b;return}function h_a(a){a=a|0;var b=0;b=i;oVa(a);i=b;return}function i_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=KYa(h)|0;JSa(e);if((a|0)==0){j=DYa(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(OWa(0,d,a)|0){m=l;j=c[m>>2]|0;JSa(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(OWa(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;JSa(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function j_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];e$a(a,e);i=d;return}function k_a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=L_a(d)|0;d=N_a(n,1)|0;O_a(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];M_a(j,d,h);P_a(0,XXa((Q_a(j)|0)+16|0)|0,e);e=R_a(j)|0;a[e+4|0]=1;S_a(0,C_a((Q_a(j)|0)+28|0)|0);a[e+5|0]=1;T_a(m,j);l_a(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];j_a(b,g);m_a(m);m_a(j);i=f;return}function l_a(a,b){a=a|0;b=b|0;var c=0;c=i;J_a(a,b);i=c;return}function m_a(a){a=a|0;var b=0;b=i;x_a(a);i=b;return}function n_a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;JSa(f);c[e>>2]=0;JSa(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=d_a(a)|0;b=c[c[e>>2]>>2]|0;JSa(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(DYa(a)|0)>>2]|0;tUa(e,c[d>>2]|0);d=u_a(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function o_a(a){a=a|0;var b=0,d=0;b=i;d=c[(s_a(a)|0)>>2]|0;i=b;return d|0}function p_a(a){a=a|0;var b=0,d=0;b=i;d=q_a(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function q_a(a){a=a|0;var b=0,c=0;b=i;c=r_a(a)|0;i=b;return c|0}function r_a(a){a=a|0;i=i;return a|0}function s_a(a){a=a|0;var b=0,c=0;b=i;c=t_a(a)|0;i=b;return c|0}function t_a(a){a=a|0;i=i;return a|0}function u_a(a){a=a|0;var b=0,c=0;b=i;c=v_a(a+8|0)|0;i=b;return c|0}function v_a(a){a=a|0;var b=0,c=0;b=i;c=w_a(a)|0;i=b;return c|0}function w_a(a){a=a|0;i=i;return a|0}function x_a(a){a=a|0;var b=0;b=i;y_a(a,0);i=b;return}function y_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=q_a(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}A_a(z_a(e)|0,f);i=d;return}function z_a(a){a=a|0;var b=0,c=0;b=i;c=I_a(a)|0;i=b;return c|0}function A_a(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;B_a(f,C_a(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;D_a(f,XXa(d+16|0)|0)}if((d|0)==0){i=e;return}E_a(c[b>>2]|0,d,1);i=e;return}function B_a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;H_a(d,0,c);i=b;return}function C_a(a){a=a|0;i=i;return a|0}function D_a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;G_a(d,0,c);i=b;return}function E_a(a,b,c){a=a|0;b=b|0;c=c|0;c=i;F_a(0,b,0);i=c;return}function F_a(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Ffb(b);i=c;return}function G_a(a,b,c){a=a|0;b=b|0;c=c|0;b=i;s5a(c);i=b;return}function H_a(a,b,c){a=a|0;b=b|0;c=c|0;b=i;s5a(c);i=b;return}function I_a(a){a=a|0;i=i;return a+4|0}function J_a(a,b){a=a|0;b=b|0;var c=0;c=i;K_a(a,b);i=c;return}function K_a(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function L_a(a){a=a|0;var b=0,c=0;b=i;c=c$a(a+4|0)|0;i=b;return c|0}function M_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];W_a(a,b,f);i=e;return}function N_a(a,b){a=a|0;b=b|0;var c=0;a=i;c=V_a(0,b,0)|0;i=a;return c|0}function O_a(a,b){a=a|0;b=b|0;var c=0;c=i;U_a(a,b);i=c;return}function P_a(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}i5a(b,c);i=a;return}function Q_a(a){a=a|0;var b=0,d=0;b=i;d=c[(s_a(a)|0)>>2]|0;i=b;return d|0}function R_a(a){a=a|0;var b=0,c=0;b=i;c=z_a(a)|0;i=b;return c|0}function S_a(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}g5a(b);i=a;return}function T_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;J_a(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];j_a(h,f);l_a(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];j_a(a,e);m_a(h);i=d;return}function U_a(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function V_a(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Dfb(b*40|0)|0;i=c;return a|0}function W_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Y_a(g)|0)>>2]|0;g=Z_a(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];X_a(b,a,f);i=e;return}function X_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];__a(a,b,f);i=e;return}function Y_a(a){a=a|0;i=i;return a|0}function Z_a(a){a=a|0;i=i;return a|0}function __a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(a$a(g)|0)>>2]|0;g=b$a(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];$_a(b,a,f);i=e;return}function $_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(a$a(f)|0)>>2];f=b$a(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function a$a(a){a=a|0;i=i;return a|0}function b$a(a){a=a|0;i=i;return a|0}function c$a(a){a=a|0;var b=0,c=0;b=i;c=d$a(a)|0;i=b;return c|0}function d$a(a){a=a|0;i=i;return a|0}function e$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=p_a(f$a(b)|0)|0;h=b$a(R_a(f$a(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];X_a(g,a,e);i=d;return}function f$a(a){a=a|0;i=i;return c[a>>2]|0}function g$a(a){a=a|0;var b=0;b=i;h$a(a);i=b;return}function h$a(a){a=a|0;var b=0;b=i;i$a(a);i=b;return}function i$a(a){a=a|0;var b=0;b=i;j$a(a,KYa(a)|0);i=b;return}function j$a(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;JSa(d);if((b|0)==0){i=d;return}j$a(a,c[b>>2]|0);j$a(a,c[b+4>>2]|0);e=L_a(a)|0;k$a(e,l$a(b+16|0)|0);E_a(e,b,1);i=d;return}function k$a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;m$a(d,0,c);i=b;return}function l$a(a){a=a|0;i=i;return a|0}function m$a(a,b,c){a=a|0;b=b|0;c=c|0;b=i;n$a(c);i=b;return}function n$a(a){a=a|0;var b=0;b=i;o$a(a);i=b;return}function o$a(a){a=a|0;var b=0;b=i;p$a(a);i=b;return}function p$a(a){a=a|0;var b=0;b=i;q$a(a);i=b;return}function q$a(a){a=a|0;var b=0;b=i;s5a(a+12|0);s5a(a);i=b;return}function r$a(a){a=a|0;var b=0;b=i;s$a(a+180|0);s$a(a+168|0);s$a(a+156|0);s$a(a+144|0);s$a(a+132|0);s$a(a+120|0);s$a(a+108|0);s$a(a+96|0);s$a(a+84|0);s$a(a+72|0);s$a(a+60|0);s$a(a+48|0);s$a(a+36|0);s$a(a+24|0);HWa(a+12|0);HWa(a);i=b;return}function s$a(a){a=a|0;var b=0;b=i;t$a(a);i=b;return}function t$a(a){a=a|0;var b=0;b=i;u$a(a);i=b;return}function u$a(a){a=a|0;var b=0;b=i;v$a(a);i=b;return}function v$a(a){a=a|0;var b=0;b=i;w$a(a,ZZa(a)|0);i=b;return}function w$a(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;JSa(d);if((b|0)==0){i=d;return}w$a(a,c[b>>2]|0);w$a(a,c[b+4>>2]|0);e=CZa(a)|0;x$a(e,y$a(b+16|0)|0);wZa(e,b,1);i=d;return}function x$a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;z$a(d,0,c);i=b;return}function y$a(a){a=a|0;i=i;return a|0}function z$a(a,b,c){a=a|0;b=b|0;c=c|0;b=i;A$a(c);i=b;return}function A$a(a){a=a|0;var b=0;b=i;B$a(a);i=b;return}function B$a(a){a=a|0;var b=0;b=i;C$a(a);i=b;return}function C$a(a){a=a|0;var b=0;b=i;D$a(a);i=b;return}function D$a(a){a=a|0;var b=0;b=i;HWa(a+4|0);i=b;return}function E$a(a){a=a|0;var b=0;b=i;F$a(a);i=b;return}function F$a(a){a=a|0;var b=0;b=i;G$a(a);i=b;return}function G$a(a){a=a|0;var b=0;b=i;H$a(a,uXa(a)|0);i=b;return}function H$a(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;JSa(d);if((b|0)==0){i=d;return}H$a(a,c[b>>2]|0);H$a(a,c[b+4>>2]|0);e=cYa(a)|0;I$a(e,hXa(b+16|0)|0);YXa(e,b,1);i=d;return}function I$a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;J$a(d,0,c);i=b;return}function J$a(a,b,c){a=a|0;b=b|0;c=c|0;b=i;K$a(c);i=b;return}function K$a(a){a=a|0;var b=0;b=i;L$a(a);i=b;return}function L$a(a){a=a|0;var b=0;b=i;M$a(a);i=b;return}function M$a(a){a=a|0;var b=0;b=i;N$a(a);i=b;return}function N$a(a){a=a|0;var b=0;b=i;s5a(a);i=b;return}function O$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;P$a(a);R$a(g,b);S$a(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];Q$a(a,f,e);i=d;return a|0}function P$a(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;j$a(a,KYa(a)|0);c[(u_a(a)|0)>>2]=0;d=DYa(a)|0;c[(d_a(a)|0)>>2]=d;JSa(b);c[d>>2]=0;i=b;return}function Q$a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;_$a(h,a);if(!($$a(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];T$a(j,g);o=b0a(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];a0a(l,a,f,o);c0a(b)|0;}while($$a(b,d)|0);i=e;return}function R$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;Y$a(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];T$a(a,e);i=d;return}function S$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;U$a(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];T$a(a,e);i=d;return}function T$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];X$a(a,e);i=d;return}function U$a(a,b){a=a|0;b=b|0;var c=0;c=i;V$a(a,JWa(b)|0);i=c;return}function V$a(a,b){a=a|0;b=b|0;var c=0;c=i;W$a(a,b);i=c;return}function W$a(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function X$a(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Y$a(a,b){a=a|0;b=b|0;var d=0;d=i;V$a(a,c[(Z$a(b)|0)>>2]|0);i=d;return}function Z$a(a){a=a|0;i=i;return a|0}function _$a(a,b){a=a|0;b=b|0;var c=0;c=i;S$a(a,b);i=c;return}function $$a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=i1a(a,b)|0;i=c;return d|0}function a0a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];k0a(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];j0a(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];AYa(a,g);n$a(l);i=f;return}function b0a(a){a=a|0;var b=0,c=0;b=i;c=g0a(a)|0;i=b;return c|0}function c0a(a){a=a|0;var b=0;b=i;d0a(a)|0;i=b;return a|0}function d0a(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=e0a(c[d>>2]|0)|0;i=b;return a|0}function e0a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;JSa(b);if((e|0)==0){e=a;while(1){a=xUa(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=f0a(c[d>>2]|0)|0;i=b;return g|0}return 0}function f0a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;JSa(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;JSa(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function g0a(a){a=a|0;var b=0,d=0;b=i;d=h0a((c[a>>2]|0)+16|0)|0;i=b;return d|0}function h0a(a){a=a|0;var b=0,c=0;b=i;c=i0a(a)|0;i=b;return c|0}function i0a(a){a=a|0;i=i;return a|0}function j0a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=o0a(b,h,j,e)|0;h=c[p>>2]|0;JSa(l);if((h|0)!=0){q=h;CYa(a,q);i=f;return}q0a(o,b,e);r0a(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];p0a(m,g);s0a(o);o=c[j>>2]|0;n_a(b,o,p,t0a(m)|0);p=u0a(m)|0;s0a(m);q=p;CYa(a,q);i=f;return}function k0a(a,b){a=a|0;b=b|0;var c=0;c=i;l0a(a,b);i=c;return}function l0a(a,b){a=a|0;b=b|0;var c=0;c=i;m0a(a,b);i=c;return}function m0a(a,b){a=a|0;b=b|0;var c=0;c=i;n0a(a,b);i=c;return}function n0a(a,b){a=a|0;b=b|0;var c=0;c=i;i5a(a,b);i5a(a+12|0,b+12|0);i=c;return}



function pT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,2);h[(c[a+416>>2]|0)+1728>>3]=l;i=b;return}function qT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,1);h[(c[a+416>>2]|0)+1720>>3]=l;i=b;return}function rT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,0);h[(c[a+416>>2]|0)+1712>>3]=l;i=b;return}function sT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1440>>3]=+h[b+1176>>3];i=i;return}function tT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1512>>3]=+h[b+1440>>3];i=i;return}function uT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1432>>3]=+h[b+1168>>3];i=i;return}function vT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1504>>3]=+h[b+1432>>3];i=i;return}function wT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1424>>3]=+h[b+1160>>3];i=i;return}function xT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1496>>3]=+h[b+1424>>3];i=i;return}function yT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1488>>3]=+h[b+1224>>3];i=i;return}function zT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1480>>3]=+h[b+1216>>3];i=i;return}function AT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1472>>3]=+h[b+1208>>3];i=i;return}function BT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1464>>3]=+h[b+1200>>3];i=i;return}function CT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1456>>3]=+h[b+1192>>3];i=i;return}function DT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1448>>3]=+h[b+1184>>3];i=i;return}function ET(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7464>>3]=+h[b+7360>>3];i=i;return}function FT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7456>>3]=+h[b+7352>>3];i=i;return}function GT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7448>>3]=+h[b+7344>>3];i=i;return}function HT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7440>>3]=+h[b+7336>>3];i=i;return}function IT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7432>>3]=+h[b+7328>>3];i=i;return}function JT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7424>>3]=+h[b+7320>>3];i=i;return}function KT(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+32|0]=a[d+5|0]|0;i=i;return}function LT(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+40>>2]=c[b+32>>2];i=i;return}function MT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7304>>3]=+h[b+7288>>3]*2.0;i=i;return}function NT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,3);h[(c[a+416>>2]|0)+1104>>3]=l;i=b;return}function OT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,2);h[(c[a+416>>2]|0)+1096>>3]=l;i=b;return}function PT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,1);h[(c[a+416>>2]|0)+1088>>3]=l;i=b;return}function QT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=19352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=19368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Cp(f,g,e,d);l=+HNa(f,0);h[(c[a+416>>2]|0)+1080>>3]=l;i=b;return}function RT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+808>>3]=+h[b+544>>3];i=i;return}function ST(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+880>>3]=+h[b+808>>3];i=i;return}function TT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+800>>3]=+h[b+536>>3];i=i;return}function UT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+872>>3]=+h[b+800>>3];i=i;return}function VT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+792>>3]=+h[b+528>>3];i=i;return}function WT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+864>>3]=+h[b+792>>3];i=i;return}function XT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+856>>3]=+h[b+592>>3];i=i;return}function YT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+848>>3]=+h[b+584>>3];i=i;return}function ZT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+840>>3]=+h[b+576>>3];i=i;return}function _T(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+832>>3]=+h[b+568>>3];i=i;return}function $T(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+824>>3]=+h[b+560>>3];i=i;return}function aU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+816>>3]=+h[b+552>>3];i=i;return}function bU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7264>>3]=+h[b+7160>>3];i=i;return}function cU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7256>>3]=+h[b+7152>>3];i=i;return}function dU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7248>>3]=+h[b+7144>>3];i=i;return}function eU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7240>>3]=+h[b+7136>>3];i=i;return}function fU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7232>>3]=+h[b+7128>>3];i=i;return}function gU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7224>>3]=+h[b+7120>>3];i=i;return}function hU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+776>>3]=+h[b+512>>3];i=i;return}function iU(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+18|0]=a[d+5|0]|0;i=i;return}function jU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6816>>3]=+h[b+6744>>3]*.05;i=i;return}function kU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6984>>3]=+h[b+6816>>3];i=i;return}function lU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7008>>3]=+h[b+6816>>3];i=i;return}function mU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7032>>3]=+h[b+6816>>3];i=i;return}function nU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7056>>3]=+h[b+6816>>3];i=i;return}function oU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7080>>3]=+h[b+6816>>3];i=i;return}function pU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7104>>3]=+h[b+6816>>3];i=i;return}function qU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6808>>3]=+h[b+6744>>3]*.1;i=i;return}function rU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6976>>3]=+h[b+6808>>3];i=i;return}function sU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7e3>>3]=+h[b+6808>>3];i=i;return}function tU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7024>>3]=+h[b+6808>>3];i=i;return}function uU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7048>>3]=+h[b+6808>>3];i=i;return}function vU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7072>>3]=+h[b+6808>>3];i=i;return}function wU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7096>>3]=+h[b+6808>>3];i=i;return}function xU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3656>>3]=+h[(c[a+416>>2]|0)+7096>>3]*-.5;i=i;return}function yU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3552>>3]=+h[(c[a+416>>2]|0)+7072>>3]*-.5;i=i;return}function zU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3464>>3]=+h[(c[a+416>>2]|0)+7048>>3]*-.5;i=i;return}function AU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3360>>3]=+h[(c[a+416>>2]|0)+7024>>3]*-.5;i=i;return}function BU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3264>>3]=+h[(c[a+416>>2]|0)+7e3>>3]*-.5;i=i;return}function CU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3176>>3]=+h[(c[a+416>>2]|0)+6976>>3]*-.5;i=i;return}function DU(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+17|0]=a[d+5|0]|0;i=i;return}function EU(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+15|0]=a[d+5|0]|0;i=i;return}function FU(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+13|0]=a[d+5|0]|0;i=i;return}function GU(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+11|0]=a[d+5|0]|0;i=i;return}function HU(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+9|0]=a[d+5|0]|0;i=i;return}function IU(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+7|0]=a[d+5|0]|0;i=i;return}function JU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6792>>3]=+h[b+6744>>3]*.5;i=i;return}function KU(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6760>>3];j=+h[f+6792>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,19400,19392,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+6856>>3]=l;i=d;return}function LU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6888>>3]=+h[b+6856>>3]*3.0;i=i;return}function MU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6896>>3]=+h[b+6856>>3];i=i;return}function NU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6904>>3]=+h[b+6856>>3]*3.0;i=i;return}function OU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6864>>3]=+h[b+6792>>3]*.5;i=i;return}function PU(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+6752>>3];j=+h[f+6864>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+YMa(c[b+536>>2]|0,g,17184,19448,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+6912>>3]=l;i=d;return}function QU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6936>>3]=+h[b+6912>>3]*3.0;i=i;return}function RU(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+6928>>3]=+sd(+(+h[d+6864>>3]),+(+h[d+6912>>3]*4.0));i=b;return}function SU(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+6944>>3]=+td(0.0,+(+h[d+6864>>3]- +h[d+6928>>3]));i=b;return}function TU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6872>>3]=+h[b+6792>>3]*1.05;i=i;return}function UU(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+6880>>3]=+sd(+(+h[d+6792>>3]),+(+h[d+6856>>3]*5.0));i=b;return}function VU(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+6920>>3]=+td(0.0,+(+h[d+6792>>3]- +h[d+6880>>3]));i=b;return}function WU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6848>>3]=+h[b+6744>>3]*.025;i=i;return}function XU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6832>>3]=+h[b+6744>>3]*.05;i=i;return}function YU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6824>>3]=+h[b+6744>>3]*.1;i=i;return}function ZU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6800>>3]=+h[b+6744>>3]*.2;i=i;return}function _U(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d]=a[d+5|0]|0;i=i;return}function $U(b){b=b|0;var d=0,e=0;d=c[b+424>>2]|0;if((a[d]|0)==0){e=0}else{e=(a[d+1|0]|0)!=0|0}c[(c[b+420>>2]|0)+388>>2]=e;i=i;return}function aV(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+424>>2]|0;do{if((a[e]|0)==0){f=0}else{if((a[e+1|0]|0)==0){f=0;break}f=(a[e+4|0]|0)!=0|0}}while(0);c[(c[b+420>>2]|0)+392>>2]=f;i=d;return}function bV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10896>>3]=0.0;i=i;return}function cV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10888>>3]=0.0;i=i;return}function dV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10880>>3]=0.0;i=i;return}function eV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10872>>3]=0.0;i=i;return}function fV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10864>>3]=0.0;i=i;return}function gV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10856>>3]=0.0;i=i;return}function hV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10848>>3]=0.0;i=i;return}function iV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10840>>3]=0.0;i=i;return}function jV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10832>>3]=0.0;i=i;return}function kV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10824>>3]=0.0;i=i;return}function lV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10816>>3]=0.0;i=i;return}function mV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10808>>3]=0.0;i=i;return}function nV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10800>>3]=0.0;i=i;return}function oV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10792>>3]=0.0;i=i;return}function pV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10784>>3]=0.0;i=i;return}function qV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10776>>3]=0.0;i=i;return}function rV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10768>>3]=0.0;i=i;return}function sV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10760>>3]=0.0;i=i;return}function tV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10752>>3]=0.0;i=i;return}function uV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10744>>3]=0.0;i=i;return}function vV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10736>>3]=0.0;i=i;return}function wV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10728>>3]=0.0;i=i;return}function xV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10720>>3]=0.0;i=i;return}function yV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10712>>3]=0.0;i=i;return}function zV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10704>>3]=0.0;i=i;return}function AV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10696>>3]=0.0;i=i;return}function BV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10688>>3]=0.0;i=i;return}function CV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10680>>3]=0.0;i=i;return}function DV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10672>>3]=0.0;i=i;return}function EV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10664>>3]=0.0;i=i;return}function FV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6312>>3]=0.0;i=i;return}function GV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6304>>3]=0.0;i=i;return}function HV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6296>>3]=0.0;i=i;return}function IV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6288>>3]=1.0;i=i;return}function JV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6264>>3]=0.0;i=i;return}function KV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6240>>3]=0.0;i=i;return}function LV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6280>>3]=0.0;i=i;return}function MV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6256>>3]=1.0;i=i;return}function NV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6232>>3]=0.0;i=i;return}function OV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6272>>3]=0.0;i=i;return}function PV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6248>>3]=0.0;i=i;return}function QV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6224>>3]=1.0;i=i;return}function RV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6216>>3]=0.0;i=i;return}function SV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6208>>3]=0.0;i=i;return}function TV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6200>>3]=0.0;i=i;return}function UV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6192>>3]=0.0;i=i;return}function VV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6184>>3]=0.0;i=i;return}function WV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6176>>3]=0.0;i=i;return}function XV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6168>>3]=0.0;i=i;return}function YV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6160>>3]=0.0;i=i;return}function ZV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6152>>3]=0.0;i=i;return}function _V(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10656>>3]=0.0;i=i;return}function $V(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+27|0]=0;i=i;return}function aW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10640>>3]=0.0;i=i;return}function bW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10632>>3]=0.0;i=i;return}function cW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10624>>3]=0.0;i=i;return}function dW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10616>>3]=0.0;i=i;return}function eW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10608>>3]=0.0;i=i;return}function fW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10600>>3]=0.0;i=i;return}function gW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10592>>3]=0.0;i=i;return}function hW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10584>>3]=0.0;i=i;return}function iW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10576>>3]=0.0;i=i;return}function jW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10568>>3]=0.0;i=i;return}function kW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10560>>3]=0.0;i=i;return}function lW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10552>>3]=0.0;i=i;return}function mW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10544>>3]=0.0;i=i;return}function nW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10536>>3]=0.0;i=i;return}function oW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10528>>3]=0.0;i=i;return}function pW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10520>>3]=0.0;i=i;return}function qW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10512>>3]=0.0;i=i;return}function rW(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+26|0]=0;i=i;return}function sW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10496>>3]=0.0;i=i;return}function tW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10488>>3]=0.0;i=i;return}function uW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10480>>3]=0.0;i=i;return}function vW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10472>>3]=0.0;i=i;return}function wW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10464>>3]=0.0;i=i;return}function xW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10456>>3]=0.0;i=i;return}function yW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10448>>3]=0.0;i=i;return}function zW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10440>>3]=0.0;i=i;return}function AW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10432>>3]=0.0;i=i;return}function BW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10424>>3]=0.0;i=i;return}function CW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10416>>3]=0.0;i=i;return}function DW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10408>>3]=0.0;i=i;return}function EW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10400>>3]=0.0;i=i;return}function FW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10392>>3]=0.0;i=i;return}function GW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10384>>3]=0.0;i=i;return}function HW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10376>>3]=0.0;i=i;return}function IW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10368>>3]=0.0;i=i;return}function JW(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+25|0]=0;i=i;return}function KW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10352>>3]=0.0;i=i;return}function LW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10344>>3]=0.0;i=i;return}function MW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10336>>3]=0.0;i=i;return}function NW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10328>>3]=0.0;i=i;return}function OW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10320>>3]=0.0;i=i;return}function PW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10312>>3]=0.0;i=i;return}function QW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10304>>3]=0.0;i=i;return}function RW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10296>>3]=0.0;i=i;return}function SW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10288>>3]=0.0;i=i;return}function TW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10280>>3]=0.0;i=i;return}function UW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10272>>3]=0.0;i=i;return}function VW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10264>>3]=0.0;i=i;return}function WW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10256>>3]=0.0;i=i;return}function XW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10248>>3]=0.0;i=i;return}function YW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10240>>3]=0.0;i=i;return}function ZW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10232>>3]=0.0;i=i;return}function _W(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10224>>3]=0.0;i=i;return}function $W(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+24|0]=0;i=i;return}function aX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10208>>3]=0.0;i=i;return}function bX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10200>>3]=0.0;i=i;return}function cX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10192>>3]=0.0;i=i;return}function dX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10184>>3]=0.0;i=i;return}function eX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10176>>3]=0.0;i=i;return}function fX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10168>>3]=0.0;i=i;return}function gX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10160>>3]=0.0;i=i;return}function hX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10152>>3]=0.0;i=i;return}function iX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10144>>3]=0.0;i=i;return}function jX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10136>>3]=0.0;i=i;return}function kX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10128>>3]=0.0;i=i;return}function lX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10120>>3]=0.0;i=i;return}function mX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10112>>3]=0.0;i=i;return}function nX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10104>>3]=0.0;i=i;return}function oX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10096>>3]=0.0;i=i;return}function pX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10088>>3]=0.0;i=i;return}function qX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10080>>3]=0.0;i=i;return}function rX(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+23|0]=0;i=i;return}function sX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10064>>3]=0.0;i=i;return}function tX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10056>>3]=0.0;i=i;return}function uX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10048>>3]=0.0;i=i;return}function vX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10040>>3]=0.0;i=i;return}function wX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10032>>3]=0.0;i=i;return}function xX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10024>>3]=0.0;i=i;return}function yX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10016>>3]=0.0;i=i;return}function zX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10008>>3]=0.0;i=i;return}function AX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1e4>>3]=0.0;i=i;return}function BX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9992>>3]=0.0;i=i;return}function CX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9984>>3]=0.0;i=i;return}function DX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9976>>3]=0.0;i=i;return}function EX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9968>>3]=0.0;i=i;return}function FX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9960>>3]=0.0;i=i;return}function GX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9952>>3]=0.0;i=i;return}function HX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9944>>3]=0.0;i=i;return}function IX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9936>>3]=0.0;i=i;return}function JX(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+22|0]=0;i=i;return}function KX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9920>>3]=0.0;i=i;return}function LX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9912>>3]=0.0;i=i;return}function MX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9904>>3]=0.0;i=i;return}function NX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9896>>3]=0.0;i=i;return}function OX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9888>>3]=0.0;i=i;return}function PX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9880>>3]=0.0;i=i;return}function QX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9872>>3]=0.0;i=i;return}function RX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9864>>3]=0.0;i=i;return}function SX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9856>>3]=0.0;i=i;return}function TX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9848>>3]=0.0;i=i;return}function UX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9840>>3]=0.0;i=i;return}function VX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9832>>3]=0.0;i=i;return}function WX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9824>>3]=0.0;i=i;return}function XX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9816>>3]=0.0;i=i;return}function YX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9808>>3]=0.0;i=i;return}function ZX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9800>>3]=0.0;i=i;return}function _X(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6048>>3]=0.0;i=i;return}function $X(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6040>>3]=0.0;i=i;return}function aY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6032>>3]=0.0;i=i;return}function bY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6024>>3]=0.0;i=i;return}function cY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6016>>3]=0.0;i=i;return}function dY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6008>>3]=0.0;i=i;return}function eY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6e3>>3]=0.0;i=i;return}function fY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5992>>3]=0.0;i=i;return}function gY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5984>>3]=0.0;i=i;return}function hY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5976>>3]=0.0;i=i;return}function iY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5968>>3]=0.0;i=i;return}function jY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5960>>3]=0.0;i=i;return}function kY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5952>>3]=0.0;i=i;return}function lY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5944>>3]=0.0;i=i;return}function mY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5936>>3]=0.0;i=i;return}function nY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5928>>3]=0.0;i=i;return}function oY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5912>>3]=0.0;i=i;return}function pY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5896>>3]=0.0;i=i;return}function qY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5888>>3]=1.0;i=i;return}function rY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5880>>3]=0.0;i=i;return}function sY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5864>>3]=0.0;i=i;return}function tY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5848>>3]=0.0;i=i;return}function uY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5840>>3]=0.0;i=i;return}function vY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5816>>3]=0.0;i=i;return}function wY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5792>>3]=0.0;i=i;return}function xY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5784>>3]=0.0;i=i;return}function yY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5776>>3]=0.0;i=i;return}function zY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5768>>3]=1.0;i=i;return}function AY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5760>>3]=0.0;i=i;return}function BY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5752>>3]=0.0;i=i;return}function CY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5736>>3]=0.0;i=i;return}function DY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5720>>3]=0.0;i=i;return}function EY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5712>>3]=1.0;i=i;return}function FY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5704>>3]=0.0;i=i;return}function GY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5688>>3]=0.0;i=i;return}function HY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5672>>3]=0.0;i=i;return}function IY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5664>>3]=0.0;i=i;return}function JY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5640>>3]=0.0;i=i;return}function KY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5616>>3]=0.0;i=i;return}function LY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5608>>3]=0.0;i=i;return}function MY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5600>>3]=0.0;i=i;return}function NY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5592>>3]=1.0;i=i;return}function OY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5584>>3]=0.0;i=i;return}function PY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5576>>3]=0.0;i=i;return}function QY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5568>>3]=0.0;i=i;return}function RY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5560>>3]=0.0;i=i;return}function SY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5552>>3]=0.0;i=i;return}function TY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5544>>3]=0.0;i=i;return}function UY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5536>>3]=1.0;i=i;return}function VY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5512>>3]=0.0;i=i;return}function WY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5504>>3]=0.0;i=i;return}function XY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5496>>3]=0.0;i=i;return}function YY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5488>>3]=0.0;i=i;return}function ZY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5480>>3]=1.0;i=i;return}function _Y(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5472>>3]=0.0;i=i;return}function $Y(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5464>>3]=0.0;i=i;return}function aZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5456>>3]=0.0;i=i;return}function bZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5448>>3]=0.0;i=i;return}function cZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5384>>3]=0.0;i=i;return}function dZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5400>>3]=0.0;i=i;return}function eZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5408>>3]=1.0;i=i;return}function fZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5416>>3]=0.0;i=i;return}function gZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5432>>3]=0.0;i=i;return}function hZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5352>>3]=0.0;i=i;return}function iZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5360>>3]=0.0;i=i;return}function jZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5368>>3]=0.0;i=i;return}function kZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5328>>3]=0.0;i=i;return}function lZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5336>>3]=0.0;i=i;return}function mZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5344>>3]=0.0;i=i;return}function nZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5304>>3]=0.0;i=i;return}function oZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5312>>3]=0.0;i=i;return}function pZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5320>>3]=0.0;i=i;return}function qZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5280>>3]=0.0;i=i;return}function rZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5288>>3]=0.0;i=i;return}function sZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5296>>3]=0.0;i=i;return}function tZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9760>>3]=0.0;i=i;return}function uZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9680>>3]=0.0;i=i;return}function vZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9600>>3]=0.0;i=i;return}function wZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9520>>3]=0.0;i=i;return}function xZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9440>>3]=0.0;i=i;return}function yZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9360>>3]=0.0;i=i;return}function zZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9296>>3]=0.0;i=i;return}function AZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9288>>3]=0.0;i=i;return}function BZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9280>>3]=0.0;i=i;return}function CZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9272>>3]=0.0;i=i;return}function DZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9264>>3]=0.0;i=i;return}function EZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9256>>3]=0.0;i=i;return}function FZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5272>>3]=0.0;i=i;return}function GZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5264>>3]=0.0;i=i;return}function HZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5256>>3]=0.0;i=i;return}function IZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5248>>3]=0.0;i=i;return}function JZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5240>>3]=0.0;i=i;return}function KZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5232>>3]=0.0;i=i;return}function LZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9232>>3]=0.0;i=i;return}function MZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9224>>3]=0.0;i=i;return}function NZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9216>>3]=0.0;i=i;return}function OZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9208>>3]=0.0;i=i;return}function PZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9200>>3]=0.0;i=i;return}function QZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9192>>3]=0.0;i=i;return}function RZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+392>>2]=0;i=i;return}function SZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+388>>2]=0;i=i;return}function TZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+384>>2]=255;i=i;return}function UZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5208>>3]=255.0;i=i;return}function VZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5216>>3]=0.0;i=i;return}function WZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5224>>3]=0.0;i=i;return}function XZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5184>>3]=255.0;i=i;return}function YZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5192>>3]=0.0;i=i;return}function ZZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5200>>3]=0.0;i=i;return}function _Z(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5176>>3]=0.0;i=i;return}function $Z(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5168>>3]=1.0;i=i;return}function a_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5160>>3]=0.0;i=i;return}function b_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5152>>3]=0.0;i=i;return}function c_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5144>>3]=0.0;i=i;return}function d_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5136>>3]=1.0;i=i;return}function e_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5120>>3]=0.0;i=i;return}function f_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5112>>3]=0.0;i=i;return}function g_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5104>>3]=1.0;i=i;return}function h_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5096>>3]=.1;i=i;return}function i_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5088>>3]=.25;i=i;return}function j_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5080>>3]=.1;i=i;return}function k_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5072>>3]=0.0;i=i;return}function l_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5064>>3]=0.0;i=i;return}function m_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5056>>3]=0.0;i=i;return}function n_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5048>>3]=0.0;i=i;return}function o_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5040>>3]=0.0;i=i;return}function p_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5032>>3]=0.0;i=i;return}function q_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5024>>3]=0.0;i=i;return}function r_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5016>>3]=0.0;i=i;return}function s_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5008>>3]=0.0;i=i;return}function t_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5e3>>3]=1.0;i=i;return}function u_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4992>>3]=0.0;i=i;return}function v_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4984>>3]=0.0;i=i;return}function w_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4976>>3]=0.0;i=i;return}function x_(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+380>>2]=255;i=i;return}function y_(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+376>>2]=128;i=i;return}function z_(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+372>>2]=0;i=i;return}function A_(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+368>>2]=155;i=i;return}function B_(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+364>>2]=155;i=i;return}function C_(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+360>>2]=155;i=i;return}function D_(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+356>>2]=255;i=i;return}function E_(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+352>>2]=0;i=i;return}function F_(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+348>>2]=0;i=i;return}function G_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4952>>3]=0.0;i=i;return}function H_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4960>>3]=0.0;i=i;return}function I_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4968>>3]=255.0;i=i;return}function J_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4944>>3]=0.0;i=i;return}function K_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4936>>3]=1.0;i=i;return}function L_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4928>>3]=0.0;i=i;return}function M_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4920>>3]=0.0;i=i;return}function N_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4912>>3]=0.0;i=i;return}function O_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4904>>3]=1.0;i=i;return}function P_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4896>>3]=0.0;i=i;return}function Q_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4888>>3]=0.0;i=i;return}function R_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4880>>3]=0.0;i=i;return}function S_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4872>>3]=0.0;i=i;return}function T_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4864>>3]=0.0;i=i;return}function U_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4856>>3]=0.0;i=i;return}function V_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4848>>3]=0.0;i=i;return}function W_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4840>>3]=0.0;i=i;return}function X_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4832>>3]=0.0;i=i;return}function Y_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4824>>3]=1.0;i=i;return}function Z_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4816>>3]=0.0;i=i;return}function __(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4808>>3]=0.0;i=i;return}function $_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4800>>3]=0.0;i=i;return}function a$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+344>>2]=255;i=i;return}function b$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+340>>2]=128;i=i;return}function c$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+336>>2]=0;i=i;return}function d$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+332>>2]=155;i=i;return}function e$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+328>>2]=155;i=i;return}function f$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+324>>2]=155;i=i;return}function g$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+320>>2]=255;i=i;return}function h$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+316>>2]=0;i=i;return}function i$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+312>>2]=0;i=i;return}function j$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4776>>3]=0.0;i=i;return}function k$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4784>>3]=0.0;i=i;return}function l$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4792>>3]=255.0;i=i;return}function m$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4768>>3]=0.0;i=i;return}function n$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4760>>3]=1.0;i=i;return}function o$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4752>>3]=0.0;i=i;return}function p$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4744>>3]=0.0;i=i;return}function q$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4736>>3]=0.0;i=i;return}function r$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4728>>3]=1.0;i=i;return}function s$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4720>>3]=0.0;i=i;return}function t$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4712>>3]=0.0;i=i;return}function u$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4704>>3]=0.0;i=i;return}function v$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4696>>3]=0.0;i=i;return}function w$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4688>>3]=0.0;i=i;return}function x$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4680>>3]=0.0;i=i;return}function y$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4672>>3]=0.0;i=i;return}function z$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4664>>3]=0.0;i=i;return}function A$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4656>>3]=0.0;i=i;return}function B$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4648>>3]=1.0;i=i;return}function C$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4640>>3]=0.0;i=i;return}function D$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4632>>3]=0.0;i=i;return}function E$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4624>>3]=0.0;i=i;return}function F$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+308>>2]=255;i=i;return}function G$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+304>>2]=128;i=i;return}function H$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+300>>2]=0;i=i;return}function I$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+296>>2]=155;i=i;return}function J$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+292>>2]=155;i=i;return}function K$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+288>>2]=155;i=i;return}function L$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+284>>2]=0;i=i;return}function M$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+280>>2]=178;i=i;return}function N$(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+276>>2]=255;i=i;return}function O$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4600>>3]=255.0;i=i;return}function P$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4608>>3]=178.0;i=i;return}function Q$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4616>>3]=0.0;i=i;return}function R$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4592>>3]=0.0;i=i;return}function S$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4584>>3]=1.0;i=i;return}function T$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4576>>3]=0.0;i=i;return}function U$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4568>>3]=0.0;i=i;return}function V$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4560>>3]=0.0;i=i;return}function W$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4552>>3]=1.0;i=i;return}function X$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4544>>3]=0.0;i=i;return}function Y$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4536>>3]=0.0;i=i;return}function Z$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4528>>3]=0.0;i=i;return}function _$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4520>>3]=0.0;i=i;return}function $$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4512>>3]=0.0;i=i;return}function a0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4504>>3]=0.0;i=i;return}function b0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4496>>3]=0.0;i=i;return}function c0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4488>>3]=0.0;i=i;return}function d0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4480>>3]=0.0;i=i;return}function e0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4472>>3]=1.0;i=i;return}function f0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4464>>3]=0.0;i=i;return}function g0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4456>>3]=0.0;i=i;return}function h0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4448>>3]=0.0;i=i;return}function i0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+272>>2]=255;i=i;return}function j0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+268>>2]=128;i=i;return}function k0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+264>>2]=0;i=i;return}function l0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+260>>2]=155;i=i;return}function m0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+256>>2]=155;i=i;return}function n0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+252>>2]=155;i=i;return}function o0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+248>>2]=0;i=i;return}function p0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+244>>2]=0;i=i;return}function q0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+240>>2]=255;i=i;return}function r0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4424>>3]=255.0;i=i;return}function s0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4432>>3]=0.0;i=i;return}function t0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4440>>3]=0.0;i=i;return}function u0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4416>>3]=0.0;i=i;return}function v0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4408>>3]=1.0;i=i;return}function w0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4400>>3]=0.0;i=i;return}function x0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4392>>3]=0.0;i=i;return}function y0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4384>>3]=0.0;i=i;return}function z0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4376>>3]=1.0;i=i;return}function A0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4368>>3]=0.0;i=i;return}function B0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4360>>3]=0.0;i=i;return}function C0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4352>>3]=0.0;i=i;return}function D0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4344>>3]=0.0;i=i;return}function E0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4336>>3]=0.0;i=i;return}function F0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4328>>3]=0.0;i=i;return}function G0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4320>>3]=0.0;i=i;return}function H0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4312>>3]=0.0;i=i;return}function I0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4304>>3]=0.0;i=i;return}function J0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4296>>3]=1.0;i=i;return}function K0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4288>>3]=0.0;i=i;return}function L0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4280>>3]=0.0;i=i;return}function M0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4272>>3]=0.0;i=i;return}function N0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+236>>2]=255;i=i;return}function O0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+232>>2]=128;i=i;return}function P0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+228>>2]=0;i=i;return}function Q0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+224>>2]=155;i=i;return}function R0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+220>>2]=155;i=i;return}function S0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+216>>2]=155;i=i;return}function T0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+212>>2]=0;i=i;return}function U0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+208>>2]=178;i=i;return}function V0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+204>>2]=255;i=i;return}function W0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4248>>3]=255.0;i=i;return}function X0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4256>>3]=178.0;i=i;return}function Y0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4264>>3]=0.0;i=i;return}function Z0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4240>>3]=0.0;i=i;return}function _0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4232>>3]=1.0;i=i;return}function $0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4224>>3]=0.0;i=i;return}function a1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4216>>3]=0.0;i=i;return}function b1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4208>>3]=0.0;i=i;return}function c1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4200>>3]=1.0;i=i;return}function d1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4192>>3]=0.0;i=i;return}function e1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4184>>3]=0.0;i=i;return}function f1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4176>>3]=0.0;i=i;return}function g1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4168>>3]=0.0;i=i;return}function h1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4160>>3]=0.0;i=i;return}function i1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4152>>3]=0.0;i=i;return}function j1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4144>>3]=0.0;i=i;return}function k1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4136>>3]=0.0;i=i;return}function l1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4128>>3]=0.0;i=i;return}function m1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4120>>3]=1.0;i=i;return}function n1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4112>>3]=0.0;i=i;return}function o1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4104>>3]=0.0;i=i;return}function p1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4096>>3]=0.0;i=i;return}function q1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+200>>2]=255;i=i;return}function r1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+196>>2]=128;i=i;return}function s1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+192>>2]=0;i=i;return}function t1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+188>>2]=155;i=i;return}function u1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+184>>2]=155;i=i;return}function v1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+180>>2]=155;i=i;return}function w1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+176>>2]=0;i=i;return}function x1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+172>>2]=0;i=i;return}function y1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+168>>2]=255;i=i;return}function z1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4072>>3]=255.0;i=i;return}function A1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4080>>3]=0.0;i=i;return}function B1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4088>>3]=0.0;i=i;return}function C1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4064>>3]=0.0;i=i;return}function D1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4056>>3]=1.0;i=i;return}function E1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4048>>3]=0.0;i=i;return}function F1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4040>>3]=0.0;i=i;return}function G1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4032>>3]=0.0;i=i;return}function H1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4024>>3]=1.0;i=i;return}function I1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4016>>3]=0.0;i=i;return}function J1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4008>>3]=0.0;i=i;return}function K1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4e3>>3]=0.0;i=i;return}function L1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3992>>3]=0.0;i=i;return}function M1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3984>>3]=0.0;i=i;return}function N1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3976>>3]=0.0;i=i;return}function O1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3968>>3]=0.0;i=i;return}function P1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3960>>3]=0.0;i=i;return}function Q1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3952>>3]=0.0;i=i;return}function R1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3944>>3]=1.0;i=i;return}function S1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3936>>3]=0.0;i=i;return}function T1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3928>>3]=0.0;i=i;return}function U1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3920>>3]=0.0;i=i;return}function V1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+164>>2]=255;i=i;return}function W1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+160>>2]=128;i=i;return}function X1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+156>>2]=0;i=i;return}function Y1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+152>>2]=155;i=i;return}function Z1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+148>>2]=155;i=i;return}function _1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+144>>2]=155;i=i;return}function $1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+140>>2]=255;i=i;return}function a2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+136>>2]=0;i=i;return}function b2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+132>>2]=0;i=i;return}function c2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3896>>3]=0.0;i=i;return}function d2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3904>>3]=0.0;i=i;return}function e2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3912>>3]=255.0;i=i;return}function f2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3888>>3]=0.0;i=i;return}function g2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3880>>3]=1.0;i=i;return}function h2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3872>>3]=0.0;i=i;return}function i2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3864>>3]=0.0;i=i;return}function j2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3856>>3]=0.0;i=i;return}function k2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3848>>3]=1.0;i=i;return}function l2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3840>>3]=0.0;i=i;return}function m2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3832>>3]=0.0;i=i;return}function n2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3824>>3]=0.0;i=i;return}function o2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3816>>3]=0.0;i=i;return}function p2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3808>>3]=0.0;i=i;return}function q2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3800>>3]=0.0;i=i;return}function r2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3792>>3]=0.0;i=i;return}function s2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3784>>3]=0.0;i=i;return}function t2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3776>>3]=0.0;i=i;return}function u2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3768>>3]=1.0;i=i;return}function v2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3760>>3]=0.0;i=i;return}function w2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3752>>3]=0.0;i=i;return}function x2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3744>>3]=0.0;i=i;return}function y2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+128>>2]=255;i=i;return}function z2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+124>>2]=128;i=i;return}function A2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+120>>2]=0;i=i;return}function B2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+116>>2]=155;i=i;return}function C2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+112>>2]=155;i=i;return}function D2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+108>>2]=155;i=i;return}function E2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+104>>2]=0;i=i;return}function F2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+100>>2]=0;i=i;return}function G2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+96>>2]=255;i=i;return}function H2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3720>>3]=255.0;i=i;return}function I2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3728>>3]=0.0;i=i;return}function J2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3736>>3]=0.0;i=i;return}function K2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3712>>3]=0.0;i=i;return}function L2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3704>>3]=1.0;i=i;return}function M2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3696>>3]=0.0;i=i;return}function N2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3688>>3]=0.0;i=i;return}function O2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3680>>3]=1.0;i=i;return}function P2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3672>>3]=0.0;i=i;return}function Q2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3664>>3]=0.0;i=i;return}function R2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3648>>3]=0.0;i=i;return}function S2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+92>>2]=0;i=i;return}function T2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+88>>2]=0;i=i;return}function U2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+84>>2]=255;i=i;return}function V2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3624>>3]=255.0;i=i;return}function W2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3632>>3]=0.0;i=i;return}function X2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3640>>3]=0.0;i=i;return}function Y2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3616>>3]=0.0;i=i;return}function Z2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3608>>3]=1.0;i=i;return}function _2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3600>>3]=0.0;i=i;return}function $2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3592>>3]=0.0;i=i;return}function a3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3584>>3]=0.0;i=i;return}function b3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3576>>3]=1.0;i=i;return}function c3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3568>>3]=0.0;i=i;return}function d3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3560>>3]=0.0;i=i;return}function e3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+80>>2]=0;i=i;return}function f3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+76>>2]=0;i=i;return}function g3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+72>>2]=255;i=i;return}function h3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3528>>3]=255.0;i=i;return}function i3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3536>>3]=0.0;i=i;return}function j3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3544>>3]=0.0;i=i;return}function k3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3520>>3]=0.0;i=i;return}function l3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3512>>3]=1.0;i=i;return}function m3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3504>>3]=0.0;i=i;return}function n3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3496>>3]=0.0;i=i;return}function o3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3488>>3]=1.0;i=i;return}function p3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3480>>3]=0.0;i=i;return}function q3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3472>>3]=0.0;i=i;return}function r3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3456>>3]=0.0;i=i;return}function s3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+68>>2]=0;i=i;return}function t3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+64>>2]=0;i=i;return}function u3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+60>>2]=255;i=i;return}function v3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3432>>3]=255.0;i=i;return}function w3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3440>>3]=0.0;i=i;return}function x3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3448>>3]=0.0;i=i;return}function y3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3424>>3]=0.0;i=i;return}function z3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3416>>3]=1.0;i=i;return}function A3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3408>>3]=0.0;i=i;return}function B3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3400>>3]=0.0;i=i;return}function C3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3392>>3]=0.0;i=i;return}function D3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3384>>3]=1.0;i=i;return}function E3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3376>>3]=0.0;i=i;return}function F3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3368>>3]=0.0;i=i;return}function G3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+56>>2]=0;i=i;return}function H3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+52>>2]=0;i=i;return}function I3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+48>>2]=255;i=i;return}function J3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3336>>3]=255.0;i=i;return}function K3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3344>>3]=0.0;i=i;return}function L3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3352>>3]=0.0;i=i;return}function M3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3328>>3]=0.0;i=i;return}function N3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3320>>3]=1.0;i=i;return}function O3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3312>>3]=0.0;i=i;return}function P3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3304>>3]=0.0;i=i;return}function Q3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3296>>3]=0.0;i=i;return}function R3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3288>>3]=1.0;i=i;return}function S3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3280>>3]=0.0;i=i;return}function T3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3272>>3]=0.0;i=i;return}function U3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+44>>2]=0;i=i;return}function V3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+40>>2]=0;i=i;return}function W3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+36>>2]=255;i=i;return}function X3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3240>>3]=255.0;i=i;return}function Y3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3248>>3]=0.0;i=i;return}function Z3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3256>>3]=0.0;i=i;return}function _3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3232>>3]=0.0;i=i;return}function $3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3224>>3]=1.0;i=i;return}function a4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3216>>3]=0.0;i=i;return}function b4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3208>>3]=0.0;i=i;return}function c4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3200>>3]=1.0;i=i;return}function d4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3192>>3]=0.0;i=i;return}function e4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3184>>3]=0.0;i=i;return}function f4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3168>>3]=0.0;i=i;return}function g4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+32>>2]=0;i=i;return}function h4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+28>>2]=0;i=i;return}function i4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+24>>2]=0;i=i;return}function j4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+20>>2]=0;i=i;return}function k4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+16>>2]=230;i=i;return}function l4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+12>>2]=0;i=i;return}function m4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+8>>2]=0;i=i;return}function n4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+4>>2]=230;i=i;return}function o4(a){a=a|0;c[c[(c[c[a+4>>2]>>2]|0)+12>>2]>>2]=0;i=i;return}function p4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9184>>3]=0.0;i=i;return}function q4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9176>>3]=0.0;i=i;return}function r4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9168>>3]=0.0;i=i;return}function s4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9160>>3]=0.0;i=i;return}function t4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9152>>3]=0.0;i=i;return}function u4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9144>>3]=0.0;i=i;return}function v4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9136>>3]=0.0;i=i;return}function w4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3136>>3]=0.0;i=i;return}function x4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3128>>3]=0.0;i=i;return}function y4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3120>>3]=0.0;i=i;return}function z4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3112>>3]=0.0;i=i;return}function A4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3104>>3]=0.0;i=i;return}function B4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3088>>3]=0.0;i=i;return}function C4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9088>>3]=0.0;i=i;return}function D4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9080>>3]=0.0;i=i;return}function E4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9072>>3]=0.0;i=i;return}function F4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9064>>3]=0.0;i=i;return}function G4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9056>>3]=0.0;i=i;return}function H4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9048>>3]=0.0;i=i;return}function I4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9040>>3]=0.0;i=i;return}function J4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9032>>3]=0.0;i=i;return}function K4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9024>>3]=0.0;i=i;return}function L4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8984>>3]=0.0;i=i;return}function M4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8976>>3]=0.0;i=i;return}function N4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8944>>3]=0.0;i=i;return}function O4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8936>>3]=0.0;i=i;return}function P4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8928>>3]=0.0;i=i;return}function Q4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8920>>3]=0.0;i=i;return}function R4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8912>>3]=0.0;i=i;return}function S4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8904>>3]=0.0;i=i;return}function T4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8896>>3]=0.0;i=i;return}function U4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8888>>3]=0.0;i=i;return}function V4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8880>>3]=0.0;i=i;return}function W4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8872>>3]=0.0;i=i;return}function X4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8864>>3]=0.0;i=i;return}function Y4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3072>>3]=0.0;i=i;return}function Z4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3064>>3]=0.0;i=i;return}function _4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3056>>3]=0.0;i=i;return}function $4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3048>>3]=0.0;i=i;return}function a5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3040>>3]=0.0;i=i;return}function b5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3024>>3]=0.0;i=i;return}function c5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3008>>3]=0.0;i=i;return}function d5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2992>>3]=0.0;i=i;return}function e5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2968>>3]=0.0;i=i;return}function f5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2984>>3]=0.0;i=i;return}function g5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2960>>3]=0.0;i=i;return}function h5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2976>>3]=0.0;i=i;return}function i5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2952>>3]=0.0;i=i;return}function j5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2944>>3]=0.0;i=i;return}function k5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2928>>3]=0.0;i=i;return}function l5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2936>>3]=0.0;i=i;return}function m5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2904>>3]=0.0;i=i;return}function n5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2888>>3]=0.0;i=i;return}function o5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2920>>3]=0.0;i=i;return}



function cq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+16|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+16|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[k+8320>>3],-+h[k+9704>>3],a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[j+8320>>3],-+h[j+9704>>3],a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+16|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[l+8320>>3],-+h[l+9704>>3])|0;a[(c[b+352>>2]|0)+16|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[g+8320>>3],-+h[g+9704>>3])|0;a[(c[b+352>>2]|0)+16|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+17|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+17|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[l+8320>>3],-+h[l+9928>>3],a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[g+8320>>3],-+h[g+9928>>3],a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+17|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[k+8320>>3],-+h[k+9928>>3])|0;a[(c[b+352>>2]|0)+17|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[j+8320>>3],-+h[j+9928>>3])|0;a[(c[b+352>>2]|0)+17|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=a[(c[b+356>>2]|0)+18|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+18|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],-+h[(c[b+416>>2]|0)+9408>>3],a[(c[b+360>>2]|0)+18|0]|0)|0;a[(c[b+352>>2]|0)+18|0]=k;n=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],-+h[(c[b+416>>2]|0)+9408>>3],a[(c[b+360>>2]|0)+18|0]|0)|0;a[(c[b+352>>2]|0)+18|0]=j;n=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+18|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],-+h[(c[b+416>>2]|0)+9408>>3])|0;a[(c[b+352>>2]|0)+18|0]=j;n=g;break}else{g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],-+h[(c[b+416>>2]|0)+9408>>3])|0;a[(c[b+352>>2]|0)+18|0]=g;n=g;break}}}}while(0);do{if((a[e]|0)==0){o=a[(c[b+356>>2]|0)+19|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+19|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[b+360>>2]|0)+19|0]|0)|0;a[(c[b+352>>2]|0)+19|0]=k;o=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[b+360>>2]|0)+19|0]|0)|0;a[(c[b+352>>2]|0)+19|0]=j;o=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+19|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0)|0;a[(c[b+352>>2]|0)+19|0]=j;o=g;break}else{g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0)|0;a[(c[b+352>>2]|0)+19|0]=g;o=g;break}}}}while(0);e=c[(c[b+404>>2]|0)+416>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+17|0;B=A;a[B]=p;i=d;return}if((a[(c[b+408>>2]|0)+17|0]|0)==0|m<<24>>24==0){break}else{p=1}q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+17|0;B=A;a[B]=p;i=d;return}}while(0);if(!((e|0)!=1|n<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+17|0;B=A;a[B]=p;i=d;return}p=o<<24>>24!=0|0;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+17|0;B=A;a[B]=p;i=d;return}function dq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+20|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+20|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[k+8320>>3],+h[k+9704>>3],a[(c[b+360>>2]|0)+20|0]|0)|0;a[(c[b+352>>2]|0)+20|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[j+8320>>3],+h[j+9704>>3],a[(c[b+360>>2]|0)+20|0]|0)|0;a[(c[b+352>>2]|0)+20|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+20|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[l+8320>>3],+h[l+9704>>3])|0;a[(c[b+352>>2]|0)+20|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[g+8320>>3],+h[g+9704>>3])|0;a[(c[b+352>>2]|0)+20|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+21|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+21|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[l+8320>>3],+h[l+9928>>3],a[(c[b+360>>2]|0)+21|0]|0)|0;a[(c[b+352>>2]|0)+21|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[g+8320>>3],+h[g+9928>>3],a[(c[b+360>>2]|0)+21|0]|0)|0;a[(c[b+352>>2]|0)+21|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+21|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[k+8320>>3],+h[k+9928>>3])|0;a[(c[b+352>>2]|0)+21|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[j+8320>>3],+h[j+9928>>3])|0;a[(c[b+352>>2]|0)+21|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=a[(c[b+356>>2]|0)+22|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+22|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],+h[(c[b+416>>2]|0)+9408>>3],a[(c[b+360>>2]|0)+22|0]|0)|0;a[(c[b+352>>2]|0)+22|0]=k;n=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],+h[(c[b+416>>2]|0)+9408>>3],a[(c[b+360>>2]|0)+22|0]|0)|0;a[(c[b+352>>2]|0)+22|0]=j;n=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+22|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],+h[(c[b+416>>2]|0)+9408>>3])|0;a[(c[b+352>>2]|0)+22|0]=j;n=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],+h[(c[b+416>>2]|0)+9408>>3])|0;a[(c[b+352>>2]|0)+22|0]=g;n=g;break}}}}while(0);do{if((a[e]|0)==0){o=a[(c[b+356>>2]|0)+23|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+23|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[b+360>>2]|0)+23|0]|0)|0;a[(c[b+352>>2]|0)+23|0]=k;o=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[b+360>>2]|0)+23|0]|0)|0;a[(c[b+352>>2]|0)+23|0]=j;o=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+23|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0)|0;a[(c[b+352>>2]|0)+23|0]=j;o=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0)|0;a[(c[b+352>>2]|0)+23|0]=g;o=g;break}}}}while(0);e=c[(c[b+404>>2]|0)+416>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+18|0;B=A;a[B]=p;i=d;return}if((a[(c[b+408>>2]|0)+18|0]|0)==0|m<<24>>24==0){break}else{p=1}q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+18|0;B=A;a[B]=p;i=d;return}}while(0);if(!((e|0)!=-1|n<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+18|0;B=A;a[B]=p;i=d;return}p=o<<24>>24!=0|0;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+18|0;B=A;a[B]=p;i=d;return}function eq(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[b+404>>2]|0)+416>>2]|0;f=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((e|0)==1){g=0}else{if((a[f+18|0]|0)!=0|(e|0)==-1){g=0;break}g=(a[f+17|0]|0)==0|0}}while(0);a[f+16|0]=g;i=d;return}function fq(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+116560>>3];h[c[b+8>>2]>>3]=+h[d+116536>>3];h[c[b+12>>2]>>3]=+h[d+116544>>3];i=i;return}function gq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0;f=i;g=b;j=b+4|0;h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8320>>3]=+h[d>>3];cq(g);dq(g);eq(g);g=c[c[j>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+8328>>3];d=c[g+16>>2]|0;if((a[d+16|0]|0)!=0){l=0.0;m=k-l;h[e>>3]=m;i=f;return}if((a[d+18|0]|0)!=0){l=+h[j+8320>>3]- +h[j+9704>>3];m=k-l;h[e>>3]=m;i=f;return}if((a[d+17|0]|0)!=0){l=+h[j+8320>>3]+ +h[j+9704>>3];m=k-l;h[e>>3]=m;i=f;return}n=+h[j+8320>>3];o=+h[j+9704>>3];if((c[(c[b+404>>2]|0)+416>>2]|0)==1){l=n-o;m=k-l;h[e>>3]=m;i=f;return}else{l=n+o;m=k-l;h[e>>3]=m;i=f;return}}function hq(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+106704>>3];h[c[b+8>>2]>>3]=+h[d+106680>>3];h[c[b+12>>2]>>3]=+h[d+106688>>3];i=i;return}function iq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0.0;f=+h[b>>3];b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7616>>3]=f;h[d>>3]=+h[b+96>>3]+(f- +h[b+400>>3]);i=i;return}function jq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+4|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+4|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[k+7504>>3],+h[k+9544>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[j+7504>>3],+h[j+9544>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+4|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[l+7504>>3],+h[l+9544>>3])|0;a[(c[b+352>>2]|0)+4|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[g+7504>>3],+h[g+9544>>3])|0;a[(c[b+352>>2]|0)+4|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+5|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+5|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[l+7504>>3],+h[l+10216>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[g+7504>>3],+h[g+10216>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+5|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[k+7504>>3],+h[k+10216>>3])|0;a[(c[b+352>>2]|0)+5|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[j+7504>>3],+h[j+10216>>3])|0;a[(c[b+352>>2]|0)+5|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=b+312|0;o=a[(c[b+356>>2]|0)+6|0]|0}else{g=b+312|0;j=(a[b+318|0]|0)!=0;if((a[g]|0)==0){if(j){k=a[(c[b+356>>2]|0)+6|0]|0;l=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],+h[(c[b+416>>2]|0)+10784>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=l;n=g;o=k;break}else{k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],+h[(c[b+416>>2]|0)+10784>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;n=g;o=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+6|0]|0;k=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],+h[(c[b+416>>2]|0)+10784>>3])|0;a[(c[b+352>>2]|0)+6|0]=k;n=g;o=j;break}else{j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],+h[(c[b+416>>2]|0)+10784>>3])|0;a[(c[b+352>>2]|0)+6|0]=j;n=g;o=j;break}}}}while(0);j=a[n]|0;do{if((a[e]|0)==0){p=a[(c[b+356>>2]|0)+7|0]|0}else{n=(a[b+318|0]|0)!=0;if(j<<24>>24==0){if(n){g=a[(c[b+356>>2]|0)+7|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=k;p=g;break}else{g=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=g;p=g;break}}else{if(n){n=a[(c[b+356>>2]|0)+7|0]|0;g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;a[(c[b+352>>2]|0)+7|0]=g;p=n;break}else{n=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;a[(c[b+352>>2]|0)+7|0]=n;p=n;break}}}}while(0);e=c[(c[b+404>>2]|0)+408>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+12|0;C=B;a[C]=q;i=d;return}if((a[(c[b+408>>2]|0)+12|0]|0)==0|m<<24>>24==0){break}else{q=1}r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+12|0;C=B;a[C]=q;i=d;return}}while(0);if(!((e|0)!=-1|o<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+12|0;C=B;a[C]=q;i=d;return}if(j<<24>>24==0){q=0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+12|0;C=B;a[C]=q;i=d;return}q=p<<24>>24!=0|0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+12|0;C=B;a[C]=q;i=d;return}function kq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[k+7504>>3],-+h[k+9544>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[j+7504>>3],-+h[j+9544>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=l;f=l;break}}else{if(g){g=a[c[b+356>>2]|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[l+7504>>3],-+h[l+9544>>3])|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[g+7504>>3],-+h[g+9544>>3])|0;a[c[b+352>>2]|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+1|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+1|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[l+7504>>3],-+h[l+10216>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[g+7504>>3],-+h[g+10216>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+1|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[k+7504>>3],-+h[k+10216>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[j+7504>>3],-+h[j+10216>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=b+312|0;o=a[(c[b+356>>2]|0)+2|0]|0}else{g=b+312|0;j=(a[b+318|0]|0)!=0;if((a[g]|0)==0){if(j){k=a[(c[b+356>>2]|0)+2|0]|0;l=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],-+h[(c[b+416>>2]|0)+10784>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=l;n=g;o=k;break}else{k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],-+h[(c[b+416>>2]|0)+10784>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=k;n=g;o=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+2|0]|0;k=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],-+h[(c[b+416>>2]|0)+10784>>3])|0;a[(c[b+352>>2]|0)+2|0]=k;n=g;o=j;break}else{j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],-+h[(c[b+416>>2]|0)+10784>>3])|0;a[(c[b+352>>2]|0)+2|0]=j;n=g;o=j;break}}}}while(0);j=a[n]|0;do{if((a[e]|0)==0){p=a[(c[b+356>>2]|0)+3|0]|0}else{n=(a[b+318|0]|0)!=0;if(j<<24>>24==0){if(n){g=a[(c[b+356>>2]|0)+3|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;p=g;break}else{g=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=g;p=g;break}}else{if(n){n=a[(c[b+356>>2]|0)+3|0]|0;g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=g;p=n;break}else{n=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=n;p=n;break}}}}while(0);e=c[(c[b+404>>2]|0)+408>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+11|0;C=B;a[C]=q;i=d;return}if((a[(c[b+408>>2]|0)+11|0]|0)==0|m<<24>>24==0){break}else{q=1}r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+11|0;C=B;a[C]=q;i=d;return}}while(0);if(!((e|0)!=1|o<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+11|0;C=B;a[C]=q;i=d;return}if(j<<24>>24==0){q=0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+11|0;C=B;a[C]=q;i=d;return}q=p<<24>>24!=0|0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+11|0;C=B;a[C]=q;i=d;return}function lq(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[b+404>>2]|0)+408>>2]|0;f=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((e|0)==1){g=0}else{if((a[f+12|0]|0)!=0|(e|0)==-1){g=0;break}g=(a[f+11|0]|0)==0|0}}while(0);a[f+10|0]=g;i=d;return}function mq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+16>>2]|0;do{if((a[f+10|0]|0)==0){if((a[f+12|0]|0)!=0){g=c[e+8>>2]|0;j=g;k=+h[g+7504>>3]- +h[g+9544>>3];break}if((a[f+11|0]|0)!=0){g=c[e+8>>2]|0;j=g;k=+h[g+7504>>3]+ +h[g+9544>>3];break}g=c[e+8>>2]|0;l=+h[g+7504>>3];m=+h[g+9544>>3];if((c[(c[b+404>>2]|0)+408>>2]|0)==1){j=g;k=l-m;break}else{j=g;k=l+m;break}}else{j=c[e+8>>2]|0;k=0.0}}while(0);h[j+7512>>3]=k;i=d;return}function nq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7552>>3]=+h[b+7640>>3]- +h[(c[a+416>>2]|0)+10544>>3]*+h[b+7512>>3];i=i;return}function oq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0;d=i;i=i+72|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;k=d+64|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=b+4|0;ba=c[c[aa>>2]>>2]|0;ca=c[ba+16>>2]|0;if((a[ca+10|0]|0)!=0){da=+h[(c[ba+8>>2]|0)+7504>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7480|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+12|0]|0)!=0){ba=b+416|0;RNa(+h[(c[ba>>2]|0)+6320>>3],2,x);RNa(+h[(c[ba>>2]|0)+6328>>3],2,y);RNa(+h[(c[ba>>2]|0)+6336>>3],2,A);RNa(+h[(c[ba>>2]|0)+6344>>3],2,B);c[v>>2]=y;QNa(2,w,2,x,v);c[u>>2]=B;QNa(2,z,2,A,u);c[t>>2]=z;QNa(1,C,2,w,t);t=c[b+536>>2]|0;na=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+7616>>3];w=j;z=C;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];Bp(Y,t,na,j,2);da=+h[Y>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7480|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+11|0]|0)!=0){ca=b+416|0;RNa(+h[(c[ca>>2]|0)+6320>>3],2,E);RNa(+h[(c[ca>>2]|0)+6328>>3],2,F);RNa(+h[(c[ca>>2]|0)+6336>>3],2,H);RNa(+h[(c[ca>>2]|0)+6344>>3],2,I);c[s>>2]=F;QNa(2,D,2,E,s);c[r>>2]=I;QNa(2,G,2,H,r);c[q>>2]=G;QNa(1,J,2,D,q);q=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+7616>>3];D=g;G=J;c[D+0>>2]=c[G+0>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2];Bp(Z,q,na,g,2);da=-+h[Z>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7480|0;ma=la;h[ma>>3]=da;i=d;return}Z=b+416|0;na=+h[(c[Z>>2]|0)+6320>>3];if((c[(c[b+404>>2]|0)+408>>2]|0)==1){RNa(na,2,L);RNa(+h[(c[Z>>2]|0)+6328>>3],2,M);RNa(+h[(c[Z>>2]|0)+6336>>3],2,O);RNa(+h[(c[Z>>2]|0)+6344>>3],2,P);c[p>>2]=M;QNa(2,K,2,L,p);c[o>>2]=P;QNa(2,N,2,O,o);c[n>>2]=N;QNa(1,Q,2,K,n);n=c[b+536>>2]|0;oa=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+7616>>3];K=f;N=Q;c[K+0>>2]=c[N+0>>2];c[K+4>>2]=c[N+4>>2];c[K+8>>2]=c[N+8>>2];Bp(_,n,oa,f,2);da=+h[_>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7480|0;ma=la;h[ma>>3]=da;i=d;return}else{RNa(na,2,S);RNa(+h[(c[Z>>2]|0)+6328>>3],2,T);RNa(+h[(c[Z>>2]|0)+6336>>3],2,V);RNa(+h[(c[Z>>2]|0)+6344>>3],2,W);c[m>>2]=T;QNa(2,R,2,S,m);c[l>>2]=W;QNa(2,U,2,V,l);c[k>>2]=U;QNa(1,X,2,R,k);k=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+7616>>3];b=e;R=X;c[b+0>>2]=c[R+0>>2];c[b+4>>2]=c[R+4>>2];c[b+8>>2]=c[R+8>>2];Bp($,k,na,e,2);da=-+h[$>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7480|0;ma=la;h[ma>>3]=da;i=d;return}}function pq(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+105136>>3];h[c[b+8>>2]>>3]=+h[d+105112>>3];h[c[b+12>>2]>>3]=+h[d+105120>>3];i=i;return}function qq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7504>>3]=+h[b>>3];jq(f);kq(f);lq(f);mq(f);nq(f);oq(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+7552>>3]+(+h[f+7544>>3]- +h[f+7480>>3]);i=e;return}function rq(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+112416>>3];h[c[b+8>>2]>>3]=+h[d+112392>>3];h[c[b+12>>2]>>3]=+h[d+112400>>3];i=i;return}function sq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0.0;f=+h[b>>3];b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8024>>3]=f;h[d>>3]=+h[b+144>>3]+(f- +h[b+448>>3]);i=i;return}function tq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+12|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+12|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[k+7912>>3],+h[k+9624>>3],a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[j+7912>>3],+h[j+9624>>3],a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+12|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[l+7912>>3],+h[l+9624>>3])|0;a[(c[b+352>>2]|0)+12|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[g+7912>>3],+h[g+9624>>3])|0;a[(c[b+352>>2]|0)+12|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+13|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+13|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[l+7912>>3],+h[l+10072>>3],a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[g+7912>>3],+h[g+10072>>3],a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+13|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[k+7912>>3],+h[k+10072>>3])|0;a[(c[b+352>>2]|0)+13|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[j+7912>>3],+h[j+10072>>3])|0;a[(c[b+352>>2]|0)+13|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=b+312|0;o=a[(c[b+356>>2]|0)+14|0]|0}else{g=b+312|0;j=(a[b+318|0]|0)!=0;if((a[g]|0)==0){if(j){k=a[(c[b+356>>2]|0)+14|0]|0;l=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],+h[(c[b+416>>2]|0)+10096>>3],a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=l;n=g;o=k;break}else{k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],+h[(c[b+416>>2]|0)+10096>>3],a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=k;n=g;o=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+14|0]|0;k=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],+h[(c[b+416>>2]|0)+10096>>3])|0;a[(c[b+352>>2]|0)+14|0]=k;n=g;o=j;break}else{j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],+h[(c[b+416>>2]|0)+10096>>3])|0;a[(c[b+352>>2]|0)+14|0]=j;n=g;o=j;break}}}}while(0);j=a[n]|0;do{if((a[e]|0)==0){p=a[(c[b+356>>2]|0)+15|0]|0}else{n=(a[b+318|0]|0)!=0;if(j<<24>>24==0){if(n){g=a[(c[b+356>>2]|0)+15|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=k;p=g;break}else{g=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=g;p=g;break}}else{if(n){n=a[(c[b+356>>2]|0)+15|0]|0;g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0;a[(c[b+352>>2]|0)+15|0]=g;p=n;break}else{n=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0;a[(c[b+352>>2]|0)+15|0]=n;p=n;break}}}}while(0);e=c[(c[b+404>>2]|0)+412>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+15|0;C=B;a[C]=q;i=d;return}if((a[(c[b+408>>2]|0)+15|0]|0)==0|m<<24>>24==0){break}else{q=1}r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+15|0;C=B;a[C]=q;i=d;return}}while(0);if(!((e|0)!=-1|o<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+15|0;C=B;a[C]=q;i=d;return}if(j<<24>>24==0){q=0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+15|0;C=B;a[C]=q;i=d;return}q=p<<24>>24!=0|0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+15|0;C=B;a[C]=q;i=d;return}function uq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+8|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+8|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[k+7912>>3],-+h[k+9624>>3],a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[j+7912>>3],-+h[j+9624>>3],a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+8|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[l+7912>>3],-+h[l+9624>>3])|0;a[(c[b+352>>2]|0)+8|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[g+7912>>3],-+h[g+9624>>3])|0;a[(c[b+352>>2]|0)+8|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+9|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+9|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[l+7912>>3],-+h[l+10072>>3],a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[g+7912>>3],-+h[g+10072>>3],a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+9|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[k+7912>>3],-+h[k+10072>>3])|0;a[(c[b+352>>2]|0)+9|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[j+7912>>3],-+h[j+10072>>3])|0;a[(c[b+352>>2]|0)+9|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=b+312|0;o=a[(c[b+356>>2]|0)+10|0]|0}else{g=b+312|0;j=(a[b+318|0]|0)!=0;if((a[g]|0)==0){if(j){k=a[(c[b+356>>2]|0)+10|0]|0;l=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],-+h[(c[b+416>>2]|0)+10096>>3],a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=l;n=g;o=k;break}else{k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],-+h[(c[b+416>>2]|0)+10096>>3],a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=k;n=g;o=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+10|0]|0;k=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],-+h[(c[b+416>>2]|0)+10096>>3])|0;a[(c[b+352>>2]|0)+10|0]=k;n=g;o=j;break}else{j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],-+h[(c[b+416>>2]|0)+10096>>3])|0;a[(c[b+352>>2]|0)+10|0]=j;n=g;o=j;break}}}}while(0);j=a[n]|0;do{if((a[e]|0)==0){p=a[(c[b+356>>2]|0)+11|0]|0}else{n=(a[b+318|0]|0)!=0;if(j<<24>>24==0){if(n){g=a[(c[b+356>>2]|0)+11|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=k;p=g;break}else{g=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=g;p=g;break}}else{if(n){n=a[(c[b+356>>2]|0)+11|0]|0;g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0;a[(c[b+352>>2]|0)+11|0]=g;p=n;break}else{n=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0;a[(c[b+352>>2]|0)+11|0]=n;p=n;break}}}}while(0);e=c[(c[b+404>>2]|0)+412>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+14|0;C=B;a[C]=q;i=d;return}if((a[(c[b+408>>2]|0)+14|0]|0)==0|m<<24>>24==0){break}else{q=1}r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+14|0;C=B;a[C]=q;i=d;return}}while(0);if(!((e|0)!=1|o<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+14|0;C=B;a[C]=q;i=d;return}if(j<<24>>24==0){q=0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+14|0;C=B;a[C]=q;i=d;return}q=p<<24>>24!=0|0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+14|0;C=B;a[C]=q;i=d;return}function vq(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[b+404>>2]|0)+412>>2]|0;f=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((e|0)==1){g=0}else{if((a[f+15|0]|0)!=0|(e|0)==-1){g=0;break}g=(a[f+14|0]|0)==0|0}}while(0);a[f+13|0]=g;i=d;return}function wq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+16>>2]|0;do{if((a[f+13|0]|0)==0){if((a[f+15|0]|0)!=0){g=c[e+8>>2]|0;j=g;k=+h[g+7912>>3]- +h[g+9624>>3];break}if((a[f+14|0]|0)!=0){g=c[e+8>>2]|0;j=g;k=+h[g+7912>>3]+ +h[g+9624>>3];break}g=c[e+8>>2]|0;l=+h[g+7912>>3];m=+h[g+9624>>3];if((c[(c[b+404>>2]|0)+412>>2]|0)==1){j=g;k=l-m;break}else{j=g;k=l+m;break}}else{j=c[e+8>>2]|0;k=0.0}}while(0);h[j+7920>>3]=k;i=d;return}function xq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7960>>3]=+h[b+8048>>3]- +h[(c[a+416>>2]|0)+9856>>3]*+h[b+7920>>3];i=i;return}function yq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0;d=i;i=i+72|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;k=d+64|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=b+4|0;ba=c[c[aa>>2]>>2]|0;ca=c[ba+16>>2]|0;if((a[ca+13|0]|0)!=0){da=+h[(c[ba+8>>2]|0)+7912>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7888|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+15|0]|0)!=0){ba=b+416|0;RNa(+h[(c[ba>>2]|0)+6288>>3],2,x);RNa(+h[(c[ba>>2]|0)+6296>>3],2,y);RNa(+h[(c[ba>>2]|0)+6304>>3],2,A);RNa(+h[(c[ba>>2]|0)+6312>>3],2,B);c[v>>2]=y;QNa(2,w,2,x,v);c[u>>2]=B;QNa(2,z,2,A,u);c[t>>2]=z;QNa(1,C,2,w,t);t=c[b+536>>2]|0;na=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+8024>>3];w=j;z=C;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];Bp(Y,t,na,j,2);da=+h[Y>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7888|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+14|0]|0)!=0){ca=b+416|0;RNa(+h[(c[ca>>2]|0)+6288>>3],2,E);RNa(+h[(c[ca>>2]|0)+6296>>3],2,F);RNa(+h[(c[ca>>2]|0)+6304>>3],2,H);RNa(+h[(c[ca>>2]|0)+6312>>3],2,I);c[s>>2]=F;QNa(2,D,2,E,s);c[r>>2]=I;QNa(2,G,2,H,r);c[q>>2]=G;QNa(1,J,2,D,q);q=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+8024>>3];D=g;G=J;c[D+0>>2]=c[G+0>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2];Bp(Z,q,na,g,2);da=-+h[Z>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7888|0;ma=la;h[ma>>3]=da;i=d;return}Z=b+416|0;na=+h[(c[Z>>2]|0)+6288>>3];if((c[(c[b+404>>2]|0)+412>>2]|0)==1){RNa(na,2,L);RNa(+h[(c[Z>>2]|0)+6296>>3],2,M);RNa(+h[(c[Z>>2]|0)+6304>>3],2,O);RNa(+h[(c[Z>>2]|0)+6312>>3],2,P);c[p>>2]=M;QNa(2,K,2,L,p);c[o>>2]=P;QNa(2,N,2,O,o);c[n>>2]=N;QNa(1,Q,2,K,n);n=c[b+536>>2]|0;oa=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+8024>>3];K=f;N=Q;c[K+0>>2]=c[N+0>>2];c[K+4>>2]=c[N+4>>2];c[K+8>>2]=c[N+8>>2];Bp(_,n,oa,f,2);da=+h[_>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7888|0;ma=la;h[ma>>3]=da;i=d;return}else{RNa(na,2,S);RNa(+h[(c[Z>>2]|0)+6296>>3],2,T);RNa(+h[(c[Z>>2]|0)+6304>>3],2,V);RNa(+h[(c[Z>>2]|0)+6312>>3],2,W);c[m>>2]=T;QNa(2,R,2,S,m);c[l>>2]=W;QNa(2,U,2,V,l);c[k>>2]=U;QNa(1,X,2,R,k);k=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+8024>>3];b=e;R=X;c[b+0>>2]=c[R+0>>2];c[b+4>>2]=c[R+4>>2];c[b+8>>2]=c[R+8>>2];Bp($,k,na,e,2);da=-+h[$>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7888|0;ma=la;h[ma>>3]=da;i=d;return}}function zq(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+110848>>3];h[c[b+8>>2]>>3]=+h[d+110824>>3];h[c[b+12>>2]>>3]=+h[d+110832>>3];i=i;return}function Aq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7912>>3]=+h[b>>3];tq(f);uq(f);vq(f);wq(f);xq(f);yq(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+7960>>3]+(+h[f+7952>>3]- +h[f+7888>>3]);i=e;return}function Bq(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+118128>>3];h[c[b+8>>2]>>3]=+h[d+118104>>3];h[c[b+12>>2]>>3]=+h[d+118112>>3];i=i;return}function Cq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0.0;f=+h[b>>3];b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8432>>3]=f;h[d>>3]=+h[b+192>>3]+(f- +h[b+496>>3]);i=i;return}function Dq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+20|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+20|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[k+8320>>3],+h[k+9704>>3],a[(c[b+360>>2]|0)+20|0]|0)|0;a[(c[b+352>>2]|0)+20|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[j+8320>>3],+h[j+9704>>3],a[(c[b+360>>2]|0)+20|0]|0)|0;a[(c[b+352>>2]|0)+20|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+20|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[l+8320>>3],+h[l+9704>>3])|0;a[(c[b+352>>2]|0)+20|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[g+8320>>3],+h[g+9704>>3])|0;a[(c[b+352>>2]|0)+20|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+21|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+21|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[l+8320>>3],+h[l+9928>>3],a[(c[b+360>>2]|0)+21|0]|0)|0;a[(c[b+352>>2]|0)+21|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[g+8320>>3],+h[g+9928>>3],a[(c[b+360>>2]|0)+21|0]|0)|0;a[(c[b+352>>2]|0)+21|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+21|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[k+8320>>3],+h[k+9928>>3])|0;a[(c[b+352>>2]|0)+21|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[j+8320>>3],+h[j+9928>>3])|0;a[(c[b+352>>2]|0)+21|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=b+312|0;o=a[(c[b+356>>2]|0)+22|0]|0}else{g=b+312|0;j=(a[b+318|0]|0)!=0;if((a[g]|0)==0){if(j){k=a[(c[b+356>>2]|0)+22|0]|0;l=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],+h[(c[b+416>>2]|0)+9408>>3],a[(c[b+360>>2]|0)+22|0]|0)|0;a[(c[b+352>>2]|0)+22|0]=l;n=g;o=k;break}else{k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],+h[(c[b+416>>2]|0)+9408>>3],a[(c[b+360>>2]|0)+22|0]|0)|0;a[(c[b+352>>2]|0)+22|0]=k;n=g;o=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+22|0]|0;k=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],+h[(c[b+416>>2]|0)+9408>>3])|0;a[(c[b+352>>2]|0)+22|0]=k;n=g;o=j;break}else{j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],+h[(c[b+416>>2]|0)+9408>>3])|0;a[(c[b+352>>2]|0)+22|0]=j;n=g;o=j;break}}}}while(0);j=a[n]|0;do{if((a[e]|0)==0){p=a[(c[b+356>>2]|0)+23|0]|0}else{n=(a[b+318|0]|0)!=0;if(j<<24>>24==0){if(n){g=a[(c[b+356>>2]|0)+23|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[b+360>>2]|0)+23|0]|0)|0;a[(c[b+352>>2]|0)+23|0]=k;p=g;break}else{g=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[b+360>>2]|0)+23|0]|0)|0;a[(c[b+352>>2]|0)+23|0]=g;p=g;break}}else{if(n){n=a[(c[b+356>>2]|0)+23|0]|0;g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0)|0;a[(c[b+352>>2]|0)+23|0]=g;p=n;break}else{n=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0)|0;a[(c[b+352>>2]|0)+23|0]=n;p=n;break}}}}while(0);e=c[(c[b+404>>2]|0)+416>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+18|0;C=B;a[C]=q;i=d;return}if((a[(c[b+408>>2]|0)+18|0]|0)==0|m<<24>>24==0){break}else{q=1}r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+18|0;C=B;a[C]=q;i=d;return}}while(0);if(!((e|0)!=-1|o<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+18|0;C=B;a[C]=q;i=d;return}if(j<<24>>24==0){q=0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+18|0;C=B;a[C]=q;i=d;return}q=p<<24>>24!=0|0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+18|0;C=B;a[C]=q;i=d;return}function Eq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+16|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+16|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[k+8320>>3],-+h[k+9704>>3],a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[j+8320>>3],-+h[j+9704>>3],a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+16|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[l+8320>>3],-+h[l+9704>>3])|0;a[(c[b+352>>2]|0)+16|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[g+8320>>3],-+h[g+9704>>3])|0;a[(c[b+352>>2]|0)+16|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+17|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+17|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[l+8320>>3],-+h[l+9928>>3],a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[g+8320>>3],-+h[g+9928>>3],a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+17|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[k+8320>>3],-+h[k+9928>>3])|0;a[(c[b+352>>2]|0)+17|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[j+8320>>3],-+h[j+9928>>3])|0;a[(c[b+352>>2]|0)+17|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=b+312|0;o=a[(c[b+356>>2]|0)+18|0]|0}else{g=b+312|0;j=(a[b+318|0]|0)!=0;if((a[g]|0)==0){if(j){k=a[(c[b+356>>2]|0)+18|0]|0;l=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],-+h[(c[b+416>>2]|0)+9408>>3],a[(c[b+360>>2]|0)+18|0]|0)|0;a[(c[b+352>>2]|0)+18|0]=l;n=g;o=k;break}else{k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],-+h[(c[b+416>>2]|0)+9408>>3],a[(c[b+360>>2]|0)+18|0]|0)|0;a[(c[b+352>>2]|0)+18|0]=k;n=g;o=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+18|0]|0;k=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],-+h[(c[b+416>>2]|0)+9408>>3])|0;a[(c[b+352>>2]|0)+18|0]=k;n=g;o=j;break}else{j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],-+h[(c[b+416>>2]|0)+9408>>3])|0;a[(c[b+352>>2]|0)+18|0]=j;n=g;o=j;break}}}}while(0);j=a[n]|0;do{if((a[e]|0)==0){p=a[(c[b+356>>2]|0)+19|0]|0}else{n=(a[b+318|0]|0)!=0;if(j<<24>>24==0){if(n){g=a[(c[b+356>>2]|0)+19|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[b+360>>2]|0)+19|0]|0)|0;a[(c[b+352>>2]|0)+19|0]=k;p=g;break}else{g=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0,a[(c[b+360>>2]|0)+19|0]|0)|0;a[(c[b+352>>2]|0)+19|0]=g;p=g;break}}else{if(n){n=a[(c[b+356>>2]|0)+19|0]|0;g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0)|0;a[(c[b+352>>2]|0)+19|0]=g;p=n;break}else{n=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8432>>3],0.0)|0;a[(c[b+352>>2]|0)+19|0]=n;p=n;break}}}}while(0);e=c[(c[b+404>>2]|0)+416>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+17|0;C=B;a[C]=q;i=d;return}if((a[(c[b+408>>2]|0)+17|0]|0)==0|m<<24>>24==0){break}else{q=1}r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+17|0;C=B;a[C]=q;i=d;return}}while(0);if(!((e|0)!=1|o<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+17|0;C=B;a[C]=q;i=d;return}if(j<<24>>24==0){q=0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+17|0;C=B;a[C]=q;i=d;return}q=p<<24>>24!=0|0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+17|0;C=B;a[C]=q;i=d;return}function Fq(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[b+404>>2]|0)+416>>2]|0;f=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((e|0)==1){g=0}else{if((a[f+18|0]|0)!=0|(e|0)==-1){g=0;break}g=(a[f+17|0]|0)==0|0}}while(0);a[f+16|0]=g;i=d;return}function Gq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0;d=i;i=i+72|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;k=d+64|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=b+4|0;ba=c[c[aa>>2]>>2]|0;ca=c[ba+16>>2]|0;if((a[ca+16|0]|0)!=0){da=+h[(c[ba+8>>2]|0)+8320>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+8296|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+18|0]|0)!=0){ba=b+416|0;RNa(+h[(c[ba>>2]|0)+6256>>3],2,x);RNa(+h[(c[ba>>2]|0)+6264>>3],2,y);RNa(+h[(c[ba>>2]|0)+6272>>3],2,A);RNa(+h[(c[ba>>2]|0)+6280>>3],2,B);c[v>>2]=y;QNa(2,w,2,x,v);c[u>>2]=B;QNa(2,z,2,A,u);c[t>>2]=z;QNa(1,C,2,w,t);t=c[b+536>>2]|0;na=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+8432>>3];w=j;z=C;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];Bp(Y,t,na,j,2);da=+h[Y>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+8296|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+17|0]|0)!=0){ca=b+416|0;RNa(+h[(c[ca>>2]|0)+6256>>3],2,E);RNa(+h[(c[ca>>2]|0)+6264>>3],2,F);RNa(+h[(c[ca>>2]|0)+6272>>3],2,H);RNa(+h[(c[ca>>2]|0)+6280>>3],2,I);c[s>>2]=F;QNa(2,D,2,E,s);c[r>>2]=I;QNa(2,G,2,H,r);c[q>>2]=G;QNa(1,J,2,D,q);q=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+8432>>3];D=g;G=J;c[D+0>>2]=c[G+0>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2];Bp(Z,q,na,g,2);da=-+h[Z>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+8296|0;ma=la;h[ma>>3]=da;i=d;return}Z=b+416|0;na=+h[(c[Z>>2]|0)+6256>>3];if((c[(c[b+404>>2]|0)+416>>2]|0)==1){RNa(na,2,L);RNa(+h[(c[Z>>2]|0)+6264>>3],2,M);RNa(+h[(c[Z>>2]|0)+6272>>3],2,O);RNa(+h[(c[Z>>2]|0)+6280>>3],2,P);c[p>>2]=M;QNa(2,K,2,L,p);c[o>>2]=P;QNa(2,N,2,O,o);c[n>>2]=N;QNa(1,Q,2,K,n);n=c[b+536>>2]|0;oa=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+8432>>3];K=f;N=Q;c[K+0>>2]=c[N+0>>2];c[K+4>>2]=c[N+4>>2];c[K+8>>2]=c[N+8>>2];Bp(_,n,oa,f,2);da=+h[_>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+8296|0;ma=la;h[ma>>3]=da;i=d;return}else{RNa(na,2,S);RNa(+h[(c[Z>>2]|0)+6264>>3],2,T);RNa(+h[(c[Z>>2]|0)+6272>>3],2,V);RNa(+h[(c[Z>>2]|0)+6280>>3],2,W);c[m>>2]=T;QNa(2,R,2,S,m);c[l>>2]=W;QNa(2,U,2,V,l);c[k>>2]=U;QNa(1,X,2,R,k);k=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+8432>>3];b=e;R=X;c[b+0>>2]=c[R+0>>2];c[b+4>>2]=c[R+4>>2];c[b+8>>2]=c[R+8>>2];Bp($,k,na,e,2);da=-+h[$>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+8296|0;ma=la;h[ma>>3]=da;i=d;return}}function Hq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8368>>3]=+h[b+8296>>3]- +h[b+8360>>3];i=i;return}function Iq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+16>>2]|0;do{if((a[f+16|0]|0)==0){if((a[f+18|0]|0)!=0){g=c[e+8>>2]|0;j=g;k=+h[g+8320>>3]- +h[g+9704>>3];break}if((a[f+17|0]|0)!=0){g=c[e+8>>2]|0;j=g;k=+h[g+8320>>3]+ +h[g+9704>>3];break}g=c[e+8>>2]|0;l=+h[g+8320>>3];m=+h[g+9704>>3];if((c[(c[b+404>>2]|0)+416>>2]|0)==1){j=g;k=l-m;break}else{j=g;k=l+m;break}}else{j=c[e+8>>2]|0;k=0.0}}while(0);h[j+8328>>3]=k;i=d;return}function Jq(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+116560>>3];h[c[b+8>>2]>>3]=+h[d+116536>>3];h[c[b+12>>2]>>3]=+h[d+116544>>3];i=i;return}function Kq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8320>>3]=+h[b>>3];Dq(f);Eq(f);Fq(f);Gq(f);Hq(f);Iq(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[(c[a+416>>2]|0)+9168>>3]*+h[f+8328>>3]+(+h[f+8368>>3]- +h[f+8456>>3]);i=e;return}function Lq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+38|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+38|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[k+6344>>3],+h[k+9304>>3],a[(c[b+360>>2]|0)+38|0]|0)|0;a[(c[b+352>>2]|0)+38|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[j+6344>>3],+h[j+9304>>3],a[(c[b+360>>2]|0)+38|0]|0)|0;a[(c[b+352>>2]|0)+38|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+38|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[l+6344>>3],+h[l+9304>>3])|0;a[(c[b+352>>2]|0)+38|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[g+6344>>3],+h[g+9304>>3])|0;a[(c[b+352>>2]|0)+38|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+39|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+39|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[l+6344>>3],+h[l+10648>>3],a[(c[b+360>>2]|0)+39|0]|0)|0;a[(c[b+352>>2]|0)+39|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[g+6344>>3],+h[g+10648>>3],a[(c[b+360>>2]|0)+39|0]|0)|0;a[(c[b+352>>2]|0)+39|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+39|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[k+6344>>3],+h[k+10648>>3])|0;a[(c[b+352>>2]|0)+39|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[j+6344>>3],+h[j+10648>>3])|0;a[(c[b+352>>2]|0)+39|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=b+312|0;o=a[(c[b+356>>2]|0)+40|0]|0}else{g=b+312|0;j=(a[b+318|0]|0)!=0;if((a[g]|0)==0){if(j){k=a[(c[b+356>>2]|0)+40|0]|0;l=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],+h[(c[b+416>>2]|0)+12656>>3],a[(c[b+360>>2]|0)+40|0]|0)|0;a[(c[b+352>>2]|0)+40|0]=l;n=g;o=k;break}else{k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],+h[(c[b+416>>2]|0)+12656>>3],a[(c[b+360>>2]|0)+40|0]|0)|0;a[(c[b+352>>2]|0)+40|0]=k;n=g;o=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+40|0]|0;k=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],+h[(c[b+416>>2]|0)+12656>>3])|0;a[(c[b+352>>2]|0)+40|0]=k;n=g;o=j;break}else{j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],+h[(c[b+416>>2]|0)+12656>>3])|0;a[(c[b+352>>2]|0)+40|0]=j;n=g;o=j;break}}}}while(0);j=a[n]|0;do{if((a[e]|0)==0){p=a[(c[b+356>>2]|0)+41|0]|0}else{n=(a[b+318|0]|0)!=0;if(j<<24>>24==0){if(n){g=a[(c[b+356>>2]|0)+41|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[b+360>>2]|0)+41|0]|0)|0;a[(c[b+352>>2]|0)+41|0]=k;p=g;break}else{g=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[b+360>>2]|0)+41|0]|0)|0;a[(c[b+352>>2]|0)+41|0]=g;p=g;break}}else{if(n){n=a[(c[b+356>>2]|0)+41|0]|0;g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;a[(c[b+352>>2]|0)+41|0]=g;p=n;break}else{n=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;a[(c[b+352>>2]|0)+41|0]=n;p=n;break}}}}while(0);e=c[(c[b+404>>2]|0)+396>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+3|0;C=B;a[C]=q;i=d;return}if((a[(c[b+408>>2]|0)+3|0]|0)==0|m<<24>>24==0){break}else{q=1}r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+3|0;C=B;a[C]=q;i=d;return}}while(0);if(!((e|0)!=-1|o<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+3|0;C=B;a[C]=q;i=d;return}if(j<<24>>24==0){q=0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+3|0;C=B;a[C]=q;i=d;return}q=p<<24>>24!=0|0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+3|0;C=B;a[C]=q;i=d;return}function Mq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+34|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+34|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[k+6344>>3],-+h[k+9304>>3],a[(c[b+360>>2]|0)+34|0]|0)|0;a[(c[b+352>>2]|0)+34|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[j+6344>>3],-+h[j+9304>>3],a[(c[b+360>>2]|0)+34|0]|0)|0;a[(c[b+352>>2]|0)+34|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+34|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[l+6344>>3],-+h[l+9304>>3])|0;a[(c[b+352>>2]|0)+34|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[g+6344>>3],-+h[g+9304>>3])|0;a[(c[b+352>>2]|0)+34|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+35|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+35|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[l+6344>>3],-+h[l+10648>>3],a[(c[b+360>>2]|0)+35|0]|0)|0;a[(c[b+352>>2]|0)+35|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[g+6344>>3],-+h[g+10648>>3],a[(c[b+360>>2]|0)+35|0]|0)|0;a[(c[b+352>>2]|0)+35|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+35|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[k+6344>>3],-+h[k+10648>>3])|0;a[(c[b+352>>2]|0)+35|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[j+6344>>3],-+h[j+10648>>3])|0;a[(c[b+352>>2]|0)+35|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=b+312|0;o=a[(c[b+356>>2]|0)+36|0]|0}else{g=b+312|0;j=(a[b+318|0]|0)!=0;if((a[g]|0)==0){if(j){k=a[(c[b+356>>2]|0)+36|0]|0;l=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],-+h[(c[b+416>>2]|0)+12656>>3],a[(c[b+360>>2]|0)+36|0]|0)|0;a[(c[b+352>>2]|0)+36|0]=l;n=g;o=k;break}else{k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],-+h[(c[b+416>>2]|0)+12656>>3],a[(c[b+360>>2]|0)+36|0]|0)|0;a[(c[b+352>>2]|0)+36|0]=k;n=g;o=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+36|0]|0;k=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],-+h[(c[b+416>>2]|0)+12656>>3])|0;a[(c[b+352>>2]|0)+36|0]=k;n=g;o=j;break}else{j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],-+h[(c[b+416>>2]|0)+12656>>3])|0;a[(c[b+352>>2]|0)+36|0]=j;n=g;o=j;break}}}}while(0);j=a[n]|0;do{if((a[e]|0)==0){p=a[(c[b+356>>2]|0)+37|0]|0}else{n=(a[b+318|0]|0)!=0;if(j<<24>>24==0){if(n){g=a[(c[b+356>>2]|0)+37|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[b+360>>2]|0)+37|0]|0)|0;a[(c[b+352>>2]|0)+37|0]=k;p=g;break}else{g=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[b+360>>2]|0)+37|0]|0)|0;a[(c[b+352>>2]|0)+37|0]=g;p=g;break}}else{if(n){n=a[(c[b+356>>2]|0)+37|0]|0;g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;a[(c[b+352>>2]|0)+37|0]=g;p=n;break}else{n=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;a[(c[b+352>>2]|0)+37|0]=n;p=n;break}}}}while(0);e=c[(c[b+404>>2]|0)+396>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+2|0;C=B;a[C]=q;i=d;return}if((a[(c[b+408>>2]|0)+2|0]|0)==0|m<<24>>24==0){break}else{q=1}r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+2|0;C=B;a[C]=q;i=d;return}}while(0);if(!((e|0)!=1|o<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+2|0;C=B;a[C]=q;i=d;return}if(j<<24>>24==0){q=0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+2|0;C=B;a[C]=q;i=d;return}q=p<<24>>24!=0|0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+2|0;C=B;a[C]=q;i=d;return}function Nq(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[b+404>>2]|0)+396>>2]|0;f=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((e|0)==1){g=0}else{if((a[f+3|0]|0)!=0|(e|0)==-1){g=0;break}g=(a[f+2|0]|0)==0|0}}while(0);a[f+1|0]=g;i=d;return}function Oq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+50|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+50|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[k+7112>>3],+h[k+9464>>3],a[(c[b+360>>2]|0)+50|0]|0)|0;a[(c[b+352>>2]|0)+50|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[j+7112>>3],+h[j+9464>>3],a[(c[b+360>>2]|0)+50|0]|0)|0;a[(c[b+352>>2]|0)+50|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+50|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[l+7112>>3],+h[l+9464>>3])|0;a[(c[b+352>>2]|0)+50|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[g+7112>>3],+h[g+9464>>3])|0;a[(c[b+352>>2]|0)+50|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+51|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+51|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[l+7112>>3],+h[l+10360>>3],a[(c[b+360>>2]|0)+51|0]|0)|0;a[(c[b+352>>2]|0)+51|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[g+7112>>3],+h[g+10360>>3],a[(c[b+360>>2]|0)+51|0]|0)|0;a[(c[b+352>>2]|0)+51|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+51|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[k+7112>>3],+h[k+10360>>3])|0;a[(c[b+352>>2]|0)+51|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[j+7112>>3],+h[j+10360>>3])|0;a[(c[b+352>>2]|0)+51|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=b+312|0;o=a[(c[b+356>>2]|0)+52|0]|0}else{g=b+312|0;j=(a[b+318|0]|0)!=0;if((a[g]|0)==0){if(j){k=a[(c[b+356>>2]|0)+52|0]|0;l=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],+h[(c[b+416>>2]|0)+11408>>3],a[(c[b+360>>2]|0)+52|0]|0)|0;a[(c[b+352>>2]|0)+52|0]=l;n=g;o=k;break}else{k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],+h[(c[b+416>>2]|0)+11408>>3],a[(c[b+360>>2]|0)+52|0]|0)|0;a[(c[b+352>>2]|0)+52|0]=k;n=g;o=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+52|0]|0;k=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],+h[(c[b+416>>2]|0)+11408>>3])|0;a[(c[b+352>>2]|0)+52|0]=k;n=g;o=j;break}else{j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],+h[(c[b+416>>2]|0)+11408>>3])|0;a[(c[b+352>>2]|0)+52|0]=j;n=g;o=j;break}}}}while(0);j=a[n]|0;do{if((a[e]|0)==0){p=a[(c[b+356>>2]|0)+53|0]|0}else{n=(a[b+318|0]|0)!=0;if(j<<24>>24==0){if(n){g=a[(c[b+356>>2]|0)+53|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[b+360>>2]|0)+53|0]|0)|0;a[(c[b+352>>2]|0)+53|0]=k;p=g;break}else{g=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[b+360>>2]|0)+53|0]|0)|0;a[(c[b+352>>2]|0)+53|0]=g;p=g;break}}else{if(n){n=a[(c[b+356>>2]|0)+53|0]|0;g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0)|0;a[(c[b+352>>2]|0)+53|0]=g;p=n;break}else{n=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0)|0;a[(c[b+352>>2]|0)+53|0]=n;p=n;break}}}}while(0);e=c[(c[b+404>>2]|0)+404>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+9|0;C=B;a[C]=q;i=d;return}if((a[(c[b+408>>2]|0)+9|0]|0)==0|m<<24>>24==0){break}else{q=1}r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+9|0;C=B;a[C]=q;i=d;return}}while(0);if(!((e|0)!=-1|o<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+9|0;C=B;a[C]=q;i=d;return}if(j<<24>>24==0){q=0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+9|0;C=B;a[C]=q;i=d;return}q=p<<24>>24!=0|0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+9|0;C=B;a[C]=q;i=d;return}function Pq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+30|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+30|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[k+7112>>3],-+h[k+9464>>3],a[(c[b+360>>2]|0)+30|0]|0)|0;a[(c[b+352>>2]|0)+30|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[j+7112>>3],-+h[j+9464>>3],a[(c[b+360>>2]|0)+30|0]|0)|0;a[(c[b+352>>2]|0)+30|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+30|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[l+7112>>3],-+h[l+9464>>3])|0;a[(c[b+352>>2]|0)+30|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[g+7112>>3],-+h[g+9464>>3])|0;a[(c[b+352>>2]|0)+30|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+31|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+31|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[l+7112>>3],-+h[l+10360>>3],a[(c[b+360>>2]|0)+31|0]|0)|0;a[(c[b+352>>2]|0)+31|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[g+7112>>3],-+h[g+10360>>3],a[(c[b+360>>2]|0)+31|0]|0)|0;a[(c[b+352>>2]|0)+31|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+31|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[k+7112>>3],-+h[k+10360>>3])|0;a[(c[b+352>>2]|0)+31|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[j+7112>>3],-+h[j+10360>>3])|0;a[(c[b+352>>2]|0)+31|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=b+312|0;o=a[(c[b+356>>2]|0)+32|0]|0}else{g=b+312|0;j=(a[b+318|0]|0)!=0;if((a[g]|0)==0){if(j){k=a[(c[b+356>>2]|0)+32|0]|0;l=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],-+h[(c[b+416>>2]|0)+11408>>3],a[(c[b+360>>2]|0)+32|0]|0)|0;a[(c[b+352>>2]|0)+32|0]=l;n=g;o=k;break}else{k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],-+h[(c[b+416>>2]|0)+11408>>3],a[(c[b+360>>2]|0)+32|0]|0)|0;a[(c[b+352>>2]|0)+32|0]=k;n=g;o=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+32|0]|0;k=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],-+h[(c[b+416>>2]|0)+11408>>3])|0;a[(c[b+352>>2]|0)+32|0]=k;n=g;o=j;break}else{j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],-+h[(c[b+416>>2]|0)+11408>>3])|0;a[(c[b+352>>2]|0)+32|0]=j;n=g;o=j;break}}}}while(0);j=a[n]|0;do{if((a[e]|0)==0){p=a[(c[b+356>>2]|0)+33|0]|0}else{n=(a[b+318|0]|0)!=0;if(j<<24>>24==0){if(n){g=a[(c[b+356>>2]|0)+33|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[b+360>>2]|0)+33|0]|0)|0;a[(c[b+352>>2]|0)+33|0]=k;p=g;break}else{g=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[b+360>>2]|0)+33|0]|0)|0;a[(c[b+352>>2]|0)+33|0]=g;p=g;break}}else{if(n){n=a[(c[b+356>>2]|0)+33|0]|0;g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0)|0;a[(c[b+352>>2]|0)+33|0]=g;p=n;break}else{n=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0)|0;a[(c[b+352>>2]|0)+33|0]=n;p=n;break}}}}while(0);e=c[(c[b+404>>2]|0)+404>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+8|0;C=B;a[C]=q;i=d;return}if((a[(c[b+408>>2]|0)+8|0]|0)==0|m<<24>>24==0){break}else{q=1}r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+8|0;C=B;a[C]=q;i=d;return}}while(0);if(!((e|0)!=1|o<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+8|0;C=B;a[C]=q;i=d;return}if(j<<24>>24==0){q=0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+8|0;C=B;a[C]=q;i=d;return}q=p<<24>>24!=0|0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+8|0;C=B;a[C]=q;i=d;return}function Qq(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[b+404>>2]|0)+404>>2]|0;f=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((e|0)==1){g=0}else{if((a[f+9|0]|0)!=0|(e|0)==-1){g=0;break}g=(a[f+8|0]|0)==0|0}}while(0);a[f+7|0]=g;i=d;return}function Rq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+46|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+46|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[k+6728>>3],+h[k+9384>>3],a[(c[b+360>>2]|0)+46|0]|0)|0;a[(c[b+352>>2]|0)+46|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[j+6728>>3],+h[j+9384>>3],a[(c[b+360>>2]|0)+46|0]|0)|0;a[(c[b+352>>2]|0)+46|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+46|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[l+6728>>3],+h[l+9384>>3])|0;a[(c[b+352>>2]|0)+46|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[g+6728>>3],+h[g+9384>>3])|0;a[(c[b+352>>2]|0)+46|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+47|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+47|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[l+6728>>3],+h[l+10504>>3],a[(c[b+360>>2]|0)+47|0]|0)|0;a[(c[b+352>>2]|0)+47|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[g+6728>>3],+h[g+10504>>3],a[(c[b+360>>2]|0)+47|0]|0)|0;a[(c[b+352>>2]|0)+47|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+47|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[k+6728>>3],+h[k+10504>>3])|0;a[(c[b+352>>2]|0)+47|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[j+6728>>3],+h[j+10504>>3])|0;a[(c[b+352>>2]|0)+47|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=b+312|0;o=a[(c[b+356>>2]|0)+48|0]|0}else{g=b+312|0;j=(a[b+318|0]|0)!=0;if((a[g]|0)==0){if(j){k=a[(c[b+356>>2]|0)+48|0]|0;l=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],+h[(c[b+416>>2]|0)+12032>>3],a[(c[b+360>>2]|0)+48|0]|0)|0;a[(c[b+352>>2]|0)+48|0]=l;n=g;o=k;break}else{k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],+h[(c[b+416>>2]|0)+12032>>3],a[(c[b+360>>2]|0)+48|0]|0)|0;a[(c[b+352>>2]|0)+48|0]=k;n=g;o=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+48|0]|0;k=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],+h[(c[b+416>>2]|0)+12032>>3])|0;a[(c[b+352>>2]|0)+48|0]=k;n=g;o=j;break}else{j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],+h[(c[b+416>>2]|0)+12032>>3])|0;a[(c[b+352>>2]|0)+48|0]=j;n=g;o=j;break}}}}while(0);j=a[n]|0;do{if((a[e]|0)==0){p=a[(c[b+356>>2]|0)+49|0]|0}else{n=(a[b+318|0]|0)!=0;if(j<<24>>24==0){if(n){g=a[(c[b+356>>2]|0)+49|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[b+360>>2]|0)+49|0]|0)|0;a[(c[b+352>>2]|0)+49|0]=k;p=g;break}else{g=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[b+360>>2]|0)+49|0]|0)|0;a[(c[b+352>>2]|0)+49|0]=g;p=g;break}}else{if(n){n=a[(c[b+356>>2]|0)+49|0]|0;g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;a[(c[b+352>>2]|0)+49|0]=g;p=n;break}else{n=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;a[(c[b+352>>2]|0)+49|0]=n;p=n;break}}}}while(0);e=c[(c[b+404>>2]|0)+400>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+6|0;C=B;a[C]=q;i=d;return}if((a[(c[b+408>>2]|0)+6|0]|0)==0|m<<24>>24==0){break}else{q=1}r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+6|0;C=B;a[C]=q;i=d;return}}while(0);if(!((e|0)!=-1|o<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+6|0;C=B;a[C]=q;i=d;return}if(j<<24>>24==0){q=0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+6|0;C=B;a[C]=q;i=d;return}q=p<<24>>24!=0|0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+6|0;C=B;a[C]=q;i=d;return}



function Sq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+42|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+42|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[k+6728>>3],-+h[k+9384>>3],a[(c[b+360>>2]|0)+42|0]|0)|0;a[(c[b+352>>2]|0)+42|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[j+6728>>3],-+h[j+9384>>3],a[(c[b+360>>2]|0)+42|0]|0)|0;a[(c[b+352>>2]|0)+42|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+42|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[l+6728>>3],-+h[l+9384>>3])|0;a[(c[b+352>>2]|0)+42|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[g+6728>>3],-+h[g+9384>>3])|0;a[(c[b+352>>2]|0)+42|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+43|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+43|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[l+6728>>3],-+h[l+10504>>3],a[(c[b+360>>2]|0)+43|0]|0)|0;a[(c[b+352>>2]|0)+43|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[g+6728>>3],-+h[g+10504>>3],a[(c[b+360>>2]|0)+43|0]|0)|0;a[(c[b+352>>2]|0)+43|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+43|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[k+6728>>3],-+h[k+10504>>3])|0;a[(c[b+352>>2]|0)+43|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[j+6728>>3],-+h[j+10504>>3])|0;a[(c[b+352>>2]|0)+43|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=b+312|0;o=a[(c[b+356>>2]|0)+44|0]|0}else{g=b+312|0;j=(a[b+318|0]|0)!=0;if((a[g]|0)==0){if(j){k=a[(c[b+356>>2]|0)+44|0]|0;l=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],-+h[(c[b+416>>2]|0)+12032>>3],a[(c[b+360>>2]|0)+44|0]|0)|0;a[(c[b+352>>2]|0)+44|0]=l;n=g;o=k;break}else{k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],-+h[(c[b+416>>2]|0)+12032>>3],a[(c[b+360>>2]|0)+44|0]|0)|0;a[(c[b+352>>2]|0)+44|0]=k;n=g;o=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+44|0]|0;k=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],-+h[(c[b+416>>2]|0)+12032>>3])|0;a[(c[b+352>>2]|0)+44|0]=k;n=g;o=j;break}else{j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],-+h[(c[b+416>>2]|0)+12032>>3])|0;a[(c[b+352>>2]|0)+44|0]=j;n=g;o=j;break}}}}while(0);j=a[n]|0;do{if((a[e]|0)==0){p=a[(c[b+356>>2]|0)+45|0]|0}else{n=(a[b+318|0]|0)!=0;if(j<<24>>24==0){if(n){g=a[(c[b+356>>2]|0)+45|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[b+360>>2]|0)+45|0]|0)|0;a[(c[b+352>>2]|0)+45|0]=k;p=g;break}else{g=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[b+360>>2]|0)+45|0]|0)|0;a[(c[b+352>>2]|0)+45|0]=g;p=g;break}}else{if(n){n=a[(c[b+356>>2]|0)+45|0]|0;g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;a[(c[b+352>>2]|0)+45|0]=g;p=n;break}else{n=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;a[(c[b+352>>2]|0)+45|0]=n;p=n;break}}}}while(0);e=c[(c[b+404>>2]|0)+400>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+5|0;C=B;a[C]=q;i=d;return}if((a[(c[b+408>>2]|0)+5|0]|0)==0|m<<24>>24==0){break}else{q=1}r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+5|0;C=B;a[C]=q;i=d;return}}while(0);if(!((e|0)!=1|o<<24>>24==0)){q=1;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+5|0;C=B;a[C]=q;i=d;return}if(j<<24>>24==0){q=0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+5|0;C=B;a[C]=q;i=d;return}q=p<<24>>24!=0|0;r=b;s=r+4|0;t=s;u=c[t>>2]|0;v=c[u>>2]|0;w=v;x=w+16|0;y=x;z=c[y>>2]|0;A=z;B=A+5|0;C=B;a[C]=q;i=d;return}function Tq(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[b+404>>2]|0)+400>>2]|0;f=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((e|0)==1){g=0}else{if((a[f+6|0]|0)!=0|(e|0)==-1){g=0;break}g=(a[f+5|0]|0)==0|0}}while(0);a[f+4|0]=g;i=d;return}function Uq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1848>>3]=+h[b+2016>>3]*+h[b+8744>>3]+ +h[b+272>>3]*+h[b+1992>>3]*+h[b+280>>3];i=i;return}function Vq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1592>>3]=+h[b+5624>>3]*+h[b+1848>>3]+(+h[b+5632>>3]*+h[b+1840>>3]+ +h[b+264>>3]*(+h[b+5648>>3]*+h[b+1864>>3]+ +h[b+5656>>3]*+h[b+1856>>3]));i=i;return}function Wq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1304>>3]=+h[b+5680>>3]*+h[b+1584>>3]+(+h[b+5696>>3]*+h[b+1600>>3]- +h[b+256>>3]*(+h[b+5728>>3]*+h[b+1608>>3]+ +h[b+5744>>3]*+h[b+1624>>3]));i=i;return}function Xq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1320>>3]=+h[b+5728>>3]*+h[b+1584>>3]+(+h[b+5744>>3]*+h[b+1600>>3]+ +h[b+256>>3]*(+h[b+5680>>3]*+h[b+1608>>3]+ +h[b+5696>>3]*+h[b+1624>>3]));i=i;return}function Yq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0;d=i;i=i+72|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;k=d+64|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=b+4|0;ba=c[c[aa>>2]>>2]|0;ca=c[ba+16>>2]|0;if((a[ca+4|0]|0)!=0){da=+h[(c[ba+8>>2]|0)+6728>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6712|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+6|0]|0)!=0){ba=b+416|0;RNa(+h[(c[ba>>2]|0)+6384>>3],2,x);RNa(+h[(c[ba>>2]|0)+6392>>3],2,y);RNa(+h[(c[ba>>2]|0)+6400>>3],2,A);RNa(+h[(c[ba>>2]|0)+6408>>3],2,B);c[v>>2]=y;QNa(2,w,2,x,v);c[u>>2]=B;QNa(2,z,2,A,u);c[t>>2]=z;QNa(1,C,2,w,t);t=c[b+536>>2]|0;na=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+6704>>3];w=j;z=C;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];Bp(Y,t,na,j,2);da=+h[Y>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6712|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+5|0]|0)!=0){ca=b+416|0;RNa(+h[(c[ca>>2]|0)+6384>>3],2,E);RNa(+h[(c[ca>>2]|0)+6392>>3],2,F);RNa(+h[(c[ca>>2]|0)+6400>>3],2,H);RNa(+h[(c[ca>>2]|0)+6408>>3],2,I);c[s>>2]=F;QNa(2,D,2,E,s);c[r>>2]=I;QNa(2,G,2,H,r);c[q>>2]=G;QNa(1,J,2,D,q);q=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+6704>>3];D=g;G=J;c[D+0>>2]=c[G+0>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2];Bp(Z,q,na,g,2);da=-+h[Z>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6712|0;ma=la;h[ma>>3]=da;i=d;return}Z=b+416|0;na=+h[(c[Z>>2]|0)+6384>>3];if((c[(c[b+404>>2]|0)+400>>2]|0)==1){RNa(na,2,L);RNa(+h[(c[Z>>2]|0)+6392>>3],2,M);RNa(+h[(c[Z>>2]|0)+6400>>3],2,O);RNa(+h[(c[Z>>2]|0)+6408>>3],2,P);c[p>>2]=M;QNa(2,K,2,L,p);c[o>>2]=P;QNa(2,N,2,O,o);c[n>>2]=N;QNa(1,Q,2,K,n);n=c[b+536>>2]|0;oa=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+6704>>3];K=f;N=Q;c[K+0>>2]=c[N+0>>2];c[K+4>>2]=c[N+4>>2];c[K+8>>2]=c[N+8>>2];Bp(_,n,oa,f,2);da=+h[_>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6712|0;ma=la;h[ma>>3]=da;i=d;return}else{RNa(na,2,S);RNa(+h[(c[Z>>2]|0)+6392>>3],2,T);RNa(+h[(c[Z>>2]|0)+6400>>3],2,V);RNa(+h[(c[Z>>2]|0)+6408>>3],2,W);c[m>>2]=T;QNa(2,R,2,S,m);c[l>>2]=W;QNa(2,U,2,V,l);c[k>>2]=U;QNa(1,X,2,R,k);k=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+6704>>3];b=e;R=X;c[b+0>>2]=c[R+0>>2];c[b+4>>2]=c[R+4>>2];c[b+8>>2]=c[R+8>>2];Bp($,k,na,e,2);da=-+h[$>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6712|0;ma=la;h[ma>>3]=da;i=d;return}}function Zq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+16>>2]|0;do{if((a[f+4|0]|0)==0){if((a[f+6|0]|0)!=0){g=c[e+8>>2]|0;j=g;k=+h[g+6728>>3]- +h[g+9384>>3];break}if((a[f+5|0]|0)!=0){g=c[e+8>>2]|0;j=g;k=+h[g+6728>>3]+ +h[g+9384>>3];break}g=c[e+8>>2]|0;l=+h[g+6728>>3];m=+h[g+9384>>3];if((c[(c[b+404>>2]|0)+400>>2]|0)==1){j=g;k=l-m;break}else{j=g;k=l+m;break}}else{j=c[e+8>>2]|0;k=0.0}}while(0);h[j+8776>>3]=k;i=d;return}function _q(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6832>>3]=+h[(c[a+416>>2]|0)+12024>>3]*+h[b+8776>>3];i=i;return}function $q(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6744>>3]=+h[b+6840>>3]- +h[(c[a+416>>2]|0)+11840>>3]*+h[b+6832>>3];i=i;return}function ar(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6736>>3]=-(+h[(c[a+416>>2]|0)+12024>>3]*+h[b+6744>>3]);i=i;return}function br(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2384>>3]=-+h[b+6736>>3]- +h[b+6712>>3];i=i;return}function cr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1024>>3]=+h[b+1304>>3]+ +h[b+8776>>3];i=i;return}function dr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+616>>3]=+h[b+5856>>3]*+h[b+1024>>3]+(+h[b+5872>>3]*+h[b+1040>>3]- +h[b+240>>3]*(+h[b+5904>>3]*+h[b+1048>>3]+ +h[b+5920>>3]*+h[b+1064>>3]));i=i;return}function er(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+632>>3]=+h[b+5904>>3]*+h[b+1024>>3]+(+h[b+5920>>3]*+h[b+1040>>3]+ +h[b+240>>3]*(+h[b+5856>>3]*+h[b+1048>>3]+ +h[b+5872>>3]*+h[b+1064>>3]));i=i;return}function fr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0;d=i;i=i+72|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;k=d+64|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=b+4|0;ba=c[c[aa>>2]>>2]|0;ca=c[ba+16>>2]|0;if((a[ca+7|0]|0)!=0){da=+h[(c[ba+8>>2]|0)+7112>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7096|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+9|0]|0)!=0){ba=b+416|0;RNa(+h[(c[ba>>2]|0)+6352>>3],2,x);RNa(+h[(c[ba>>2]|0)+6360>>3],2,y);RNa(+h[(c[ba>>2]|0)+6368>>3],2,A);RNa(+h[(c[ba>>2]|0)+6376>>3],2,B);c[v>>2]=y;QNa(2,w,2,x,v);c[u>>2]=B;QNa(2,z,2,A,u);c[t>>2]=z;QNa(1,C,2,w,t);t=c[b+536>>2]|0;na=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+7088>>3];w=j;z=C;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];Bp(Y,t,na,j,2);da=+h[Y>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7096|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+8|0]|0)!=0){ca=b+416|0;RNa(+h[(c[ca>>2]|0)+6352>>3],2,E);RNa(+h[(c[ca>>2]|0)+6360>>3],2,F);RNa(+h[(c[ca>>2]|0)+6368>>3],2,H);RNa(+h[(c[ca>>2]|0)+6376>>3],2,I);c[s>>2]=F;QNa(2,D,2,E,s);c[r>>2]=I;QNa(2,G,2,H,r);c[q>>2]=G;QNa(1,J,2,D,q);q=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+7088>>3];D=g;G=J;c[D+0>>2]=c[G+0>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2];Bp(Z,q,na,g,2);da=-+h[Z>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7096|0;ma=la;h[ma>>3]=da;i=d;return}Z=b+416|0;na=+h[(c[Z>>2]|0)+6352>>3];if((c[(c[b+404>>2]|0)+404>>2]|0)==1){RNa(na,2,L);RNa(+h[(c[Z>>2]|0)+6360>>3],2,M);RNa(+h[(c[Z>>2]|0)+6368>>3],2,O);RNa(+h[(c[Z>>2]|0)+6376>>3],2,P);c[p>>2]=M;QNa(2,K,2,L,p);c[o>>2]=P;QNa(2,N,2,O,o);c[n>>2]=N;QNa(1,Q,2,K,n);n=c[b+536>>2]|0;oa=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+7088>>3];K=f;N=Q;c[K+0>>2]=c[N+0>>2];c[K+4>>2]=c[N+4>>2];c[K+8>>2]=c[N+8>>2];Bp(_,n,oa,f,2);da=+h[_>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7096|0;ma=la;h[ma>>3]=da;i=d;return}else{RNa(na,2,S);RNa(+h[(c[Z>>2]|0)+6360>>3],2,T);RNa(+h[(c[Z>>2]|0)+6368>>3],2,V);RNa(+h[(c[Z>>2]|0)+6376>>3],2,W);c[m>>2]=T;QNa(2,R,2,S,m);c[l>>2]=W;QNa(2,U,2,V,l);c[k>>2]=U;QNa(1,X,2,R,k);k=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+7088>>3];b=e;R=X;c[b+0>>2]=c[R+0>>2];c[b+4>>2]=c[R+4>>2];c[b+8>>2]=c[R+8>>2];Bp($,k,na,e,2);da=-+h[$>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+7096|0;ma=la;h[ma>>3]=da;i=d;return}}function gr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+16>>2]|0;do{if((a[f+7|0]|0)==0){if((a[f+9|0]|0)!=0){g=c[e+8>>2]|0;j=g;k=+h[g+7112>>3]- +h[g+9464>>3];break}if((a[f+8|0]|0)!=0){g=c[e+8>>2]|0;j=g;k=+h[g+7112>>3]+ +h[g+9464>>3];break}g=c[e+8>>2]|0;l=+h[g+7112>>3];m=+h[g+9464>>3];if((c[(c[b+404>>2]|0)+404>>2]|0)==1){j=g;k=l-m;break}else{j=g;k=l+m;break}}else{j=c[e+8>>2]|0;k=0.0}}while(0);h[j+8768>>3]=k;i=d;return}function hr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7216>>3]=+h[(c[a+416>>2]|0)+11400>>3]*+h[b+8768>>3];i=i;return}function ir(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7128>>3]=+h[b+7224>>3]- +h[(c[a+416>>2]|0)+11216>>3]*+h[b+7216>>3];i=i;return}function jr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7120>>3]=-(+h[(c[a+416>>2]|0)+11400>>3]*+h[b+7128>>3]);i=i;return}function kr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2376>>3]=-+h[b+7120>>3]- +h[b+7096>>3];i=i;return}function lr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1312>>3]=+h[b+1592>>3]+ +h[b+8768>>3];i=i;return}function mr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1032>>3]=+h[b+5800>>3]*+h[b+1312>>3]+(+h[b+5808>>3]*+h[b+1320>>3]+ +h[b+248>>3]*(+h[b+5824>>3]*+h[b+1336>>3]+ +h[b+5832>>3]*+h[b+1344>>3]));i=i;return}function nr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0;d=i;i=i+72|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;k=d+64|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=b+4|0;ba=c[c[aa>>2]>>2]|0;ca=c[ba+16>>2]|0;if((a[ca+1|0]|0)!=0){da=+h[(c[ba+8>>2]|0)+6344>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6328|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+3|0]|0)!=0){ba=b+416|0;RNa(+h[(c[ba>>2]|0)+6416>>3],2,x);RNa(+h[(c[ba>>2]|0)+6424>>3],2,y);RNa(+h[(c[ba>>2]|0)+6432>>3],2,A);RNa(+h[(c[ba>>2]|0)+6440>>3],2,B);c[v>>2]=y;QNa(2,w,2,x,v);c[u>>2]=B;QNa(2,z,2,A,u);c[t>>2]=z;QNa(1,C,2,w,t);t=c[b+536>>2]|0;na=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+6320>>3];w=j;z=C;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];Bp(Y,t,na,j,2);da=+h[Y>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6328|0;ma=la;h[ma>>3]=da;i=d;return}if((a[ca+2|0]|0)!=0){ca=b+416|0;RNa(+h[(c[ca>>2]|0)+6416>>3],2,E);RNa(+h[(c[ca>>2]|0)+6424>>3],2,F);RNa(+h[(c[ca>>2]|0)+6432>>3],2,H);RNa(+h[(c[ca>>2]|0)+6440>>3],2,I);c[s>>2]=F;QNa(2,D,2,E,s);c[r>>2]=I;QNa(2,G,2,H,r);c[q>>2]=G;QNa(1,J,2,D,q);q=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+6320>>3];D=g;G=J;c[D+0>>2]=c[G+0>>2];c[D+4>>2]=c[G+4>>2];c[D+8>>2]=c[G+8>>2];Bp(Z,q,na,g,2);da=-+h[Z>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6328|0;ma=la;h[ma>>3]=da;i=d;return}Z=b+416|0;na=+h[(c[Z>>2]|0)+6416>>3];if((c[(c[b+404>>2]|0)+396>>2]|0)==1){RNa(na,2,L);RNa(+h[(c[Z>>2]|0)+6424>>3],2,M);RNa(+h[(c[Z>>2]|0)+6432>>3],2,O);RNa(+h[(c[Z>>2]|0)+6440>>3],2,P);c[p>>2]=M;QNa(2,K,2,L,p);c[o>>2]=P;QNa(2,N,2,O,o);c[n>>2]=N;QNa(1,Q,2,K,n);n=c[b+536>>2]|0;oa=+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+6320>>3];K=f;N=Q;c[K+0>>2]=c[N+0>>2];c[K+4>>2]=c[N+4>>2];c[K+8>>2]=c[N+8>>2];Bp(_,n,oa,f,2);da=+h[_>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6328|0;ma=la;h[ma>>3]=da;i=d;return}else{RNa(na,2,S);RNa(+h[(c[Z>>2]|0)+6424>>3],2,T);RNa(+h[(c[Z>>2]|0)+6432>>3],2,V);RNa(+h[(c[Z>>2]|0)+6440>>3],2,W);c[m>>2]=T;QNa(2,R,2,S,m);c[l>>2]=W;QNa(2,U,2,V,l);c[k>>2]=U;QNa(1,X,2,R,k);k=c[b+536>>2]|0;na=-+h[(c[(c[c[aa>>2]>>2]|0)+8>>2]|0)+6320>>3];b=e;R=X;c[b+0>>2]=c[R+0>>2];c[b+4>>2]=c[R+4>>2];c[b+8>>2]=c[R+8>>2];Bp($,k,na,e,2);da=-+h[$>>3];ea=c[aa>>2]|0;fa=c[ea>>2]|0;ga=fa;ha=ga+8|0;ia=ha;ja=c[ia>>2]|0;ka=ja;la=ka+6328|0;ma=la;h[ma>>3]=da;i=d;return}}function or(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+16>>2]|0;do{if((a[f+1|0]|0)==0){if((a[f+3|0]|0)!=0){g=c[e+8>>2]|0;j=g;k=+h[g+6344>>3]- +h[g+9304>>3];break}if((a[f+2|0]|0)!=0){g=c[e+8>>2]|0;j=g;k=+h[g+6344>>3]+ +h[g+9304>>3];break}g=c[e+8>>2]|0;l=+h[g+6344>>3];m=+h[g+9304>>3];if((c[(c[b+404>>2]|0)+396>>2]|0)==1){j=g;k=l-m;break}else{j=g;k=l+m;break}}else{j=c[e+8>>2]|0;k=0.0}}while(0);h[j+8784>>3]=k;i=d;return}function pr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6448>>3]=+h[(c[a+416>>2]|0)+12648>>3]*+h[b+8784>>3];i=i;return}function qr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6360>>3]=+h[b+6456>>3]- +h[(c[a+416>>2]|0)+12464>>3]*+h[b+6448>>3];i=i;return}function rr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6352>>3]=-(+h[(c[a+416>>2]|0)+12648>>3]*+h[b+6360>>3]);i=i;return}function sr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2392>>3]=-+h[b+6352>>3]- +h[b+6328>>3];i=i;return}function tr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+624>>3]=+h[b+1032>>3]+ +h[b+8784>>3];i=i;return}function ur(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+1912>>3];f=+h[b+1856>>3];g=+h[b+1864>>3];j=+h[d+1928>>3];k=+h[d+1920>>3];l=g*j-f*k;m=+h[b+272>>3];n=+h[b+8752>>3];h[b+1736>>3]=+h[b+2016>>3]*(+h[b+1840>>3]*e+(f*l+(-(m*(k*m-e*g))-j*n)))+ +h[b+1992>>3]*(k*n+(m*(e*f-j*m)+(-(g*l)-e*+h[b+1848>>3])));i=i;return}function vr(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+2544>>3];f=+h[b+1624>>3];g=+h[b+1616>>3];j=+h[d+2560>>3];k=+h[d+2552>>3];l=g*j-f*k;m=+h[b+1608>>3];n=+h[b+1584>>3];h[b+1456>>3]=+h[b+1736>>3]+(+h[b+1568>>3]*(+h[b+1600>>3]*e+(f*l+(-(m*(k*m-e*g))-j*n)))+ +h[b+1824>>3]*(k*n+(m*(e*f-j*m)+(-(g*l)-e*+h[b+1592>>3]))));i=i;return}function wr(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1312>>3];e=c[a+416>>2]|0;f=+h[e+3192>>3];g=+h[b+1336>>3];j=+h[b+1328>>3];k=+h[e+3184>>3];l=+h[e+3176>>3];m=j*k-g*l;n=+h[b+1344>>3];o=l*n-f*j;p=+h[b+1320>>3];q=f*g-k*n;r=+h[b+1304>>3];h[b+1176>>3]=+h[b+1456>>3]+(+h[b+1288>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+1568>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1544>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function xr(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1032>>3];e=c[a+416>>2]|0;f=+h[e+3824>>3];g=+h[b+1056>>3];j=+h[b+1048>>3];k=+h[e+3816>>3];l=+h[e+3808>>3];m=j*k-g*l;n=+h[b+1064>>3];o=l*n-f*j;p=+h[b+1040>>3];q=f*g-k*n;r=+h[b+1024>>3];h[b+864>>3]=+h[b+1176>>3]+(+h[b+1288>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+984>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1264>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function yr(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+624>>3];e=c[a+416>>2]|0;f=+h[e+4456>>3];g=+h[b+744>>3];j=+h[b+736>>3];k=+h[e+4448>>3];l=+h[e+4440>>3];m=j*k-g*l;n=+h[b+752>>3];o=l*n-f*j;p=+h[b+632>>3];q=f*g-k*n;r=+h[b+616>>3];h[b+672>>3]=+h[b+864>>3]+(+h[b+960>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+984>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1008>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function zr(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8744>>3];e=c[a+416>>2]|0;f=+h[e+1296>>3];g=+h[b+280>>3];j=-g;k=+h[e+1280>>3];h[b+2912>>3]=+h[b+5440>>3]*(f*g*j-d*k)+ +h[b+5392>>3]*(d*f+g*k*j);i=i;return}function Ar(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1848>>3];e=c[a+416>>2]|0;f=+h[e+1928>>3];g=+h[b+1864>>3];j=+h[b+272>>3];k=+h[e+1920>>3];l=+h[e+1912>>3];m=j*k-g*l;n=+h[b+1856>>3];o=l*n-f*j;p=+h[b+1840>>3];q=f*g-k*n;r=+h[b+8752>>3];h[b+1744>>3]=+h[b+2912>>3]+(+h[b+5392>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+2008>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1984>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function Br(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1592>>3];e=c[a+416>>2]|0;f=+h[e+2560>>3];g=+h[b+1616>>3];j=+h[b+1608>>3];k=+h[e+2552>>3];l=+h[e+2544>>3];m=j*k-g*l;n=+h[b+1624>>3];o=l*n-f*j;p=+h[b+1600>>3];q=f*g-k*n;r=+h[b+1584>>3];h[b+1464>>3]=+h[b+1744>>3]+(+h[b+5392>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+1560>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1816>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function Cr(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1312>>3];e=c[a+416>>2]|0;f=+h[e+3192>>3];g=+h[b+1336>>3];j=+h[b+1328>>3];k=+h[e+3184>>3];l=+h[e+3176>>3];m=j*k-g*l;n=+h[b+1344>>3];o=l*n-f*j;p=+h[b+1320>>3];q=f*g-k*n;r=+h[b+1304>>3];h[b+1184>>3]=+h[b+1464>>3]+(+h[b+1280>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+1560>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1536>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function Dr(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1032>>3];e=c[a+416>>2]|0;f=+h[e+3824>>3];g=+h[b+1056>>3];j=+h[b+1048>>3];k=+h[e+3816>>3];l=+h[e+3808>>3];m=j*k-g*l;n=+h[b+1064>>3];o=l*n-f*j;p=+h[b+1040>>3];q=f*g-k*n;r=+h[b+1024>>3];h[b+872>>3]=+h[b+1184>>3]+(+h[b+1280>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+992>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1256>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function Er(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+624>>3];e=c[a+416>>2]|0;f=+h[e+4456>>3];g=+h[b+744>>3];j=+h[b+736>>3];k=+h[e+4448>>3];l=+h[e+4440>>3];m=j*k-g*l;n=+h[b+752>>3];o=l*n-f*j;p=+h[b+632>>3];q=f*g-k*n;r=+h[b+616>>3];h[b+680>>3]=+h[b+872>>3]+(+h[b+968>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+992>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1016>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function Fr(a){a=a|0;var b=0,d=0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[b+280>>3];h[b+2864>>3]=+h[d+7416>>3]*(+h[b+8744>>3]*+h[d+1416>>3]-e*e*+h[d+1400>>3]);i=i;return}function Gr(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+280>>3];e=c[a+416>>2]|0;h[b+2880>>3]=+h[e+7416>>3]*(-(+h[b+8744>>3]*+h[e+1400>>3])-d*d*+h[e+1416>>3]);i=i;return}function Hr(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2040>>3]=+h[b+8744>>3]*1.16+(+h[d+1416>>3]*+h[b+2864>>3]- +h[d+1400>>3]*+h[b+2880>>3]);i=i;return}function Ir(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2064>>3]=+h[b+2352>>3]- +h[b+2040>>3];i=i;return}function Jr(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8744>>3];e=c[a+416>>2]|0;f=+h[e+1296>>3];g=+h[b+280>>3];j=-g;k=+h[e+1280>>3];h[b+2896>>3]=+h[b+5424>>3]*(f*g*j-d*k)+ +h[b+5376>>3]*(d*f+g*k*j);i=i;return}function Kr(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+2048>>3];f=+h[b+1864>>3];g=+h[b+272>>3];j=+h[d+2040>>3];k=+h[d+2032>>3];l=+h[b+1856>>3];h[b+1896>>3]=+h[d+7616>>3]*(+h[b+5376>>3]*+h[b+2896>>3]+(+h[b+5392>>3]*+h[b+2912>>3]+(+h[b+1848>>3]*e+(f*(g*j-f*k)+(-(l*(k*l-e*g))-j*+h[b+1840>>3])))));i=i;return}function Lr(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+2032>>3];f=+h[b+1856>>3];g=+h[b+1864>>3];j=+h[d+2048>>3];k=+h[d+2040>>3];l=+h[b+272>>3];h[b+1904>>3]=+h[d+7616>>3]*(+h[b+2024>>3]*+h[b+2896>>3]+(+h[b+2016>>3]*+h[d+6720>>3]+(+h[b+2008>>3]*+h[b+2912>>3]+(+h[b+1840>>3]*e+(f*(g*j-f*k)+(-(l*(k*l-e*g))-j*+h[b+8752>>3]))))));i=i;return}function Mr(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+272>>3];e=+h[b+1864>>3];f=c[a+416>>2]|0;h[b+1888>>3]=+h[b+1840>>3]*2.73+(d*(d*-.46+e*.64)+(+h[f+2032>>3]*+h[b+1904>>3]+(-(+h[f+2040>>3]*+h[b+1896>>3])-e*(d*2.58+e*-.46))));i=i;return}function Nr(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+2040>>3];f=+h[b+272>>3];g=+h[b+1856>>3];j=+h[d+2032>>3];k=+h[d+2048>>3];l=+h[b+1864>>3];h[b+1912>>3]=+h[d+7616>>3]*(+h[b+2e3>>3]*+h[b+2896>>3]+(+h[b+1992>>3]*+h[d+6720>>3]+(+h[b+1984>>3]*+h[b+2912>>3]+(+h[b+8752>>3]*e+(f*(g*j-f*k)+(-(l*(k*l-e*g))-j*+h[b+1848>>3]))))));i=i;return}function Or(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1856>>3];e=+h[b+272>>3];f=c[a+416>>2]|0;h[b+1880>>3]=+h[b+8752>>3]*-.46+(+h[b+1848>>3]*.64+(d*(e*2.58+ +h[b+1864>>3]*-.46)+(+h[f+2048>>3]*+h[b+1896>>3]+(d*e*-2.73- +h[f+2032>>3]*+h[b+1912>>3]))));i=i;return}function Pr(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1864>>3];e=+h[b+1856>>3];f=c[a+416>>2]|0;h[b+1872>>3]=+h[b+8752>>3]*2.58+(+h[b+1848>>3]*-.46+(d*e*2.73+(+h[f+2040>>3]*+h[b+1912>>3]+(-(+h[f+2048>>3]*+h[b+1904>>3])-e*(d*.64+ +h[b+272>>3]*-.46)))));i=i;return}function Qr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1920>>3]=+h[b+2360>>3]- +h[b+1872>>3];i=i;return}function Rr(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1848>>3];e=c[a+416>>2]|0;f=+h[e+1928>>3];g=+h[b+1864>>3];j=+h[b+272>>3];k=+h[e+1920>>3];l=+h[e+1912>>3];m=j*k-g*l;n=+h[b+1856>>3];o=l*n-f*j;p=+h[b+1840>>3];q=f*g-k*n;r=+h[b+8752>>3];h[b+1728>>3]=+h[b+2896>>3]+(+h[b+5376>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+2024>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+2e3>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function Sr(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+2680>>3];f=+h[b+1616>>3];g=+h[b+1608>>3];j=+h[d+2672>>3];k=+h[d+2664>>3];l=+h[b+1624>>3];h[b+1656>>3]=+h[d+7816>>3]*(+h[b+5376>>3]*+h[b+1728>>3]+(+h[b+5392>>3]*+h[b+1744>>3]+(+h[b+1592>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1600>>3]))));i=i;return}function Tr(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1592>>3];e=c[a+416>>2]|0;f=+h[e+2560>>3];g=+h[b+1616>>3];j=+h[b+1608>>3];k=+h[e+2552>>3];l=+h[e+2544>>3];m=j*k-g*l;n=+h[b+1624>>3];o=l*n-f*j;p=+h[b+1600>>3];q=f*g-k*n;r=+h[b+1584>>3];h[b+1448>>3]=+h[b+1728>>3]+(+h[b+5376>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+1576>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1832>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function Ur(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+3312>>3];f=+h[b+1336>>3];g=+h[b+1328>>3];j=+h[d+3304>>3];k=+h[d+3296>>3];l=+h[b+1344>>3];h[b+1376>>3]=+h[d+8016>>3]*(+h[b+1296>>3]*+h[b+1448>>3]+(+h[b+1288>>3]*(+h[b+1456>>3]+ +h[d+6720>>3])+(+h[b+1280>>3]*+h[b+1464>>3]+(+h[b+1312>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1320>>3])))));i=i;return}function Vr(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+3304>>3];f=+h[b+1328>>3];g=+h[b+1344>>3];j=+h[d+3296>>3];k=+h[d+3312>>3];l=+h[b+1336>>3];h[b+1392>>3]=+h[d+8016>>3]*(+h[b+1552>>3]*+h[b+1448>>3]+(+h[b+1544>>3]*(+h[b+1456>>3]+ +h[d+6720>>3])+(+h[b+1536>>3]*+h[b+1464>>3]+(+h[b+1304>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1312>>3])))));i=i;return}function Wr(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1344>>3]*+h[b+1328>>3];e=c[a+416>>2]|0;h[b+1360>>3]=+h[b+1312>>3]*.081+(d*1.67+(+h[e+3312>>3]*+h[b+1376>>3]+(d*-1.67- +h[e+3296>>3]*+h[b+1392>>3])));i=i;return}function Xr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1432>>3]=+h[b+2376>>3]- +h[b+1360>>3];i=i;return}function Yr(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+3296>>3];f=+h[b+1344>>3];g=+h[b+1336>>3];j=+h[d+3312>>3];k=+h[d+3304>>3];l=+h[b+1328>>3];h[b+1384>>3]=+h[d+8016>>3]*(+h[b+1576>>3]*+h[b+1448>>3]+(+h[b+1568>>3]*(+h[b+1456>>3]+ +h[d+6720>>3])+(+h[b+1560>>3]*+h[b+1464>>3]+(+h[b+1320>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1304>>3])))));i=i;return}function Zr(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1328>>3]*+h[b+1336>>3];e=c[a+416>>2]|0;h[b+1368>>3]=+h[b+1320>>3]*1.67+(d*.081+(+h[e+3296>>3]*+h[b+1384>>3]+(d*-1.67- +h[e+3304>>3]*+h[b+1376>>3])));i=i;return}function _r(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1336>>3]*+h[b+1344>>3];e=c[a+416>>2]|0;h[b+1352>>3]=+h[b+1304>>3]*1.67+(d*1.67+(+h[e+3304>>3]*+h[b+1392>>3]+(d*-.081- +h[e+3312>>3]*+h[b+1384>>3])));i=i;return}function $r(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1312>>3];e=c[a+416>>2]|0;f=+h[e+3192>>3];g=+h[b+1336>>3];j=+h[b+1328>>3];k=+h[e+3184>>3];l=+h[e+3176>>3];m=j*k-g*l;n=+h[b+1344>>3];o=l*n-f*j;p=+h[b+1320>>3];q=f*g-k*n;r=+h[b+1304>>3];h[b+1168>>3]=+h[b+1448>>3]+(+h[b+1296>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+1576>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1552>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function as(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+3936>>3];f=+h[b+1048>>3];g=+h[b+1064>>3];j=+h[d+3928>>3];k=+h[d+3944>>3];l=+h[b+1056>>3];h[b+1112>>3]=+h[d+8216>>3]*(+h[b+1272>>3]*+h[b+1168>>3]+(+h[b+1264>>3]*(+h[b+1176>>3]+ +h[d+6720>>3])+(+h[b+1256>>3]*+h[b+1184>>3]+(+h[b+1024>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1032>>3])))));i=i;return}function bs(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+3928>>3];f=+h[b+1064>>3];g=+h[b+1056>>3];j=+h[d+3944>>3];k=+h[d+3936>>3];l=+h[b+1048>>3];h[b+1104>>3]=+h[d+8216>>3]*(+h[b+976>>3]*+h[b+1168>>3]+(+h[b+984>>3]*(+h[b+1176>>3]+ +h[d+6720>>3])+(+h[b+992>>3]*+h[b+1184>>3]+(+h[b+1040>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1024>>3])))));i=i;return}function cs(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1056>>3]*+h[b+1064>>3];e=c[a+416>>2]|0;h[b+1072>>3]=+h[b+1024>>3]*1.25+(d*1.53+(+h[e+3936>>3]*+h[b+1112>>3]+(d*-.81- +h[e+3944>>3]*+h[b+1104>>3])));i=i;return}function ds(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1144>>3]=+h[b+2384>>3]- +h[b+1072>>3];i=i;return}function es(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+3944>>3];f=+h[b+1056>>3];g=+h[b+1048>>3];j=+h[d+3936>>3];k=+h[d+3928>>3];l=+h[b+1064>>3];h[b+1096>>3]=+h[d+8216>>3]*(+h[b+1296>>3]*+h[b+1168>>3]+(+h[b+1288>>3]*(+h[b+1176>>3]+ +h[d+6720>>3])+(+h[b+1280>>3]*+h[b+1184>>3]+(+h[b+1032>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1040>>3])))));i=i;return}function fs(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1064>>3]*+h[b+1048>>3];e=c[a+416>>2]|0;h[b+1080>>3]=+h[b+1032>>3]*.81+(d*1.25+(+h[e+3944>>3]*+h[b+1096>>3]+(d*-1.53- +h[e+3928>>3]*+h[b+1112>>3])));i=i;return}function gs(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1048>>3]*+h[b+1056>>3];e=c[a+416>>2]|0;h[b+1088>>3]=+h[b+1040>>3]*1.53+(d*.81+(+h[e+3928>>3]*+h[b+1104>>3]+(d*-1.25- +h[e+3936>>3]*+h[b+1096>>3])));i=i;return}function hs(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1032>>3];e=c[a+416>>2]|0;f=+h[e+3824>>3];g=+h[b+1056>>3];j=+h[b+1048>>3];k=+h[e+3816>>3];l=+h[e+3808>>3];m=j*k-g*l;n=+h[b+1064>>3];o=l*n-f*j;p=+h[b+1040>>3];q=f*g-k*n;r=+h[b+1024>>3];h[b+856>>3]=+h[b+1168>>3]+(+h[b+1296>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+976>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1272>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function is(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+4568>>3];f=+h[b+736>>3];g=+h[b+752>>3];j=+h[d+4560>>3];k=+h[d+4576>>3];l=+h[b+744>>3];h[b+800>>3]=+h[d+8416>>3]*(+h[b+1e3>>3]*+h[b+856>>3]+(+h[b+1008>>3]*(+h[b+864>>3]+ +h[d+6720>>3])+(+h[b+1016>>3]*+h[b+872>>3]+(+h[b+616>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+624>>3])))));i=i;return}function js(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+4576>>3];f=+h[b+744>>3];g=+h[b+736>>3];j=+h[d+4568>>3];k=+h[d+4560>>3];l=+h[b+752>>3];h[b+784>>3]=+h[d+8416>>3]*(+h[b+952>>3]*+h[b+856>>3]+(+h[b+960>>3]*(+h[b+864>>3]+ +h[d+6720>>3])+(+h[b+968>>3]*+h[b+872>>3]+(+h[b+624>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+632>>3])))));i=i;return}function ks(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+752>>3]*+h[b+736>>3];e=c[a+416>>2]|0;h[b+768>>3]=+h[b+624>>3]*.001+(d*.001+(+h[e+4576>>3]*+h[b+784>>3]+(d*-.001- +h[e+4560>>3]*+h[b+800>>3])));i=i;return}function ls(a){a=a|0;var b=0,d=0.0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+624>>3];e=c[a+416>>2]|0;f=+h[e+4456>>3];g=+h[b+744>>3];j=+h[b+736>>3];k=+h[e+4448>>3];l=+h[e+4440>>3];m=j*k-g*l;n=+h[b+752>>3];o=l*n-f*j;p=+h[b+632>>3];q=f*g-k*n;r=+h[b+616>>3];h[b+664>>3]=+h[b+856>>3]+(+h[b+952>>3]*(d*f+(g*m+(-(n*o)-k*p)))+(+h[b+976>>3]*(l*p+(n*q+(-(j*m)-f*r)))+ +h[b+1e3>>3]*(k*r+(j*o+(-(g*q)-d*l)))));i=i;return}function ms(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+5208>>3];f=+h[d+5200>>3];g=+h[b+744>>3];j=+h[b+736>>3];k=+h[d+5192>>3];l=+h[b+752>>3];h[b+928>>3]=+h[d+8616>>3]*(+h[b+632>>3]*f-(g*(f*j-g*k)-l*(k*l-e*j))- +h[b+624>>3]*e- +h[b+968>>3]*+h[b+680>>3]- +h[b+960>>3]*(+h[b+672>>3]+ +h[d+6720>>3])- +h[b+952>>3]*+h[b+664>>3]);i=i;return}function ns(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2184>>3]=+h[b+928>>3]- +h[b+784>>3];i=i;return}function os(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+5192>>3];f=+h[d+5208>>3];g=+h[b+752>>3];j=+h[b+744>>3];k=+h[d+5200>>3];l=+h[b+736>>3];h[b+936>>3]=+h[d+8616>>3]*(+h[b+616>>3]*f-(g*(f*j-g*k)-l*(k*l-e*j))- +h[b+632>>3]*e- +h[b+992>>3]*+h[b+680>>3]- +h[b+984>>3]*(+h[b+672>>3]+ +h[d+6720>>3])- +h[b+976>>3]*+h[b+664>>3]);i=i;return}function ps(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+736>>3]*+h[b+744>>3];e=c[a+416>>2]|0;h[b+920>>3]=+h[b+632>>3]*-.001+(d*-.001+(+h[e+5192>>3]*+h[b+936>>3]+(d*.001- +h[e+5200>>3]*+h[b+928>>3])));i=i;return}function qs(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+848>>3]=+h[b+4448>>3]*+h[d+928>>3]+(-(+h[b+4440>>3]*+h[d+936>>3])- +h[d+920>>3]);i=i;return}function rs(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+4560>>3];f=+h[b+752>>3];g=+h[b+744>>3];j=+h[d+4576>>3];k=+h[d+4568>>3];l=+h[b+736>>3];h[b+792>>3]=+h[d+8416>>3]*(+h[b+976>>3]*+h[b+856>>3]+(+h[b+984>>3]*(+h[b+864>>3]+ +h[d+6720>>3])+(+h[b+992>>3]*+h[b+872>>3]+(+h[b+632>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+616>>3])))));i=i;return}function ss(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1240>>3]=+h[b+936>>3]- +h[b+792>>3];i=i;return}function ts(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2216>>3]=+h[b+1240>>3]- +h[b+1104>>3];i=i;return}function us(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+736>>3]*+h[b+744>>3];e=c[a+416>>2]|0;h[b+776>>3]=+h[b+632>>3]*.001+(d*.001+(+h[e+4560>>3]*+h[b+792>>3]+(d*-.001- +h[e+4568>>3]*+h[b+784>>3])));i=i;return}function vs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2160>>3]=-+h[b+848>>3]- +h[b+776>>3];i=i;return}function ws(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+2664>>3];f=+h[b+1624>>3];g=+h[b+1616>>3];j=+h[d+2680>>3];k=+h[d+2672>>3];l=+h[b+1608>>3];h[b+1664>>3]=+h[d+7816>>3]*(+h[b+1576>>3]*+h[b+1728>>3]+(+h[b+1568>>3]*(+h[b+1736>>3]+ +h[d+6720>>3])+(+h[b+1560>>3]*+h[b+1744>>3]+(+h[b+1600>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1584>>3])))));i=i;return}function xs(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1608>>3];e=+h[b+1616>>3];f=c[a+416>>2]|0;h[b+1648>>3]=+h[b+1600>>3]*.413+(d*(d*-.07+e*.245)+(+h[f+2664>>3]*+h[b+1664>>3]+(-(+h[f+2672>>3]*+h[b+1656>>3])-e*(d*.279+e*-.07))));i=i;return}function ys(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+2672>>3];f=+h[b+1608>>3];g=+h[b+1624>>3];j=+h[d+2664>>3];k=+h[d+2680>>3];l=+h[b+1616>>3];h[b+1672>>3]=+h[d+7816>>3]*(+h[b+1832>>3]*+h[b+1728>>3]+(+h[b+1824>>3]*(+h[b+1736>>3]+ +h[d+6720>>3])+(+h[b+1816>>3]*+h[b+1744>>3]+(+h[b+1584>>3]*e+(f*(g*j-f*k)-l*(k*l-e*g)-j*+h[b+1592>>3])))));i=i;return}function zs(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1624>>3];e=+h[b+1608>>3];f=c[a+416>>2]|0;h[b+1640>>3]=+h[b+1584>>3]*-.07+(+h[b+1592>>3]*.245+(d*(e*.279+ +h[b+1616>>3]*-.07)+(+h[f+2680>>3]*+h[b+1656>>3]+(d*e*-.413- +h[f+2664>>3]*+h[b+1672>>3]))));i=i;return}function As(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1616>>3];e=+h[b+1624>>3];f=c[a+416>>2]|0;h[b+1632>>3]=+h[b+1584>>3]*.279+(+h[b+1592>>3]*-.07+(d*e*.413+(+h[f+2672>>3]*+h[b+1672>>3]+(-(+h[f+2680>>3]*+h[b+1664>>3])-e*(d*.245+ +h[b+1608>>3]*-.07)))));i=i;return}function Bs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1704>>3]=+h[b+2368>>3]- +h[b+1632>>3];i=i;return}function Cs(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;e=+h[d+5200>>3];f=+h[d+5192>>3];g=+h[b+736>>3];j=+h[b+752>>3];k=+h[d+5208>>3];l=+h[b+744>>3];h[b+944>>3]=+h[d+8616>>3]*(+h[b+624>>3]*f-(g*(f*j-g*k)-l*(k*l-e*j))- +h[b+616>>3]*e- +h[b+1016>>3]*+h[b+680>>3]- +h[b+1008>>3]*(+h[b+672>>3]+ +h[d+6720>>3])- +h[b+1e3>>3]*+h[b+664>>3]);i=i;return}function Ds(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2176>>3]=+h[b+944>>3]- +h[b+800>>3];i=i;return}function Es(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1248>>3]=+h[b+5872>>3]*+h[b+2184>>3]+ +h[b+5920>>3]*+h[b+2176>>3];i=i;return}function Fs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2208>>3]=+h[b+1248>>3]- +h[b+1112>>3];i=i;return}function Gs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1528>>3]=+h[b+5808>>3]*+h[b+2216>>3]+ +h[b+5832>>3]*+h[b+2208>>3];i=i;return}function Hs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2240>>3]=+h[b+1528>>3]- +h[b+1392>>3];i=i;return}function Is(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1520>>3]=+h[b+5800>>3]*+h[b+2216>>3]+ +h[b+5824>>3]*+h[b+2208>>3];i=i;return}function Js(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1800>>3]=+h[b+1520>>3]- +h[b+1384>>3];i=i;return}function Ks(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2280>>3]=+h[b+1800>>3]- +h[b+1664>>3];i=i;return}function Ls(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1424>>3]=+h[b+3192>>3]*+h[d+1520>>3]+ +h[d+2384>>3]- +h[b+3184>>3]*+h[d+1528>>3];i=i;return}function Ms(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2232>>3]=-+h[b+1424>>3]- +h[b+1352>>3];i=i;return}function Ns(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1224>>3]=+h[b+3824>>3]*+h[d+1240>>3]+(-(+h[b+3816>>3]*+h[d+1248>>3])- +h[d+1144>>3]);i=i;return}function Os(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1232>>3]=+h[b+5856>>3]*+h[b+2184>>3]+ +h[b+5904>>3]*+h[b+2176>>3];i=i;return}function Ps(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1512>>3]=+h[b+1232>>3]- +h[b+1096>>3];i=i;return}function Qs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2248>>3]=+h[b+1512>>3]- +h[b+1376>>3];i=i;return}function Rs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1808>>3]=+h[b+5696>>3]*+h[b+2248>>3]+ +h[b+5744>>3]*+h[b+2240>>3];i=i;return}function Ss(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2272>>3]=+h[b+1808>>3]- +h[b+1672>>3];i=i;return}function Ts(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1968>>3]=+h[b+5624>>3]*+h[b+2280>>3]+ +h[b+5648>>3]*+h[b+2272>>3];i=i;return}function Us(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2312>>3]=+h[b+1968>>3]- +h[b+1904>>3];i=i;return}function Vs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1792>>3]=+h[b+5680>>3]*+h[b+2248>>3]+ +h[b+5728>>3]*+h[b+2240>>3];i=i;return}function Ws(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1960>>3]=+h[b+1792>>3]- +h[b+1656>>3];i=i;return}function Xs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2096>>3]=+h[b+1960>>3]- +h[b+1896>>3];i=i;return}function Ys(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1712>>3]=+h[b+2544>>3]*+h[d+1808>>3]+ +h[d+2376>>3]- +h[b+2560>>3]*+h[d+1792>>3];i=i;return}function Zs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2264>>3]=-+h[b+1712>>3]- +h[b+1640>>3];i=i;return}function _s(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+752>>3]*+h[b+736>>3];e=c[a+416>>2]|0;h[b+912>>3]=+h[b+624>>3]*-.001+(d*-.001+(+h[e+5208>>3]*+h[b+928>>3]+(d*.001- +h[e+5192>>3]*+h[b+944>>3])));i=i;return}function $s(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+840>>3]=+h[b+4440>>3]*+h[d+944>>3]+(-(+h[b+4456>>3]*+h[d+928>>3])- +h[d+912>>3]);i=i;return}function at(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+744>>3]*+h[b+752>>3];e=c[a+416>>2]|0;h[b+760>>3]=+h[b+616>>3]*.001+(d*.001+(+h[e+4568>>3]*+h[b+800>>3]+(d*-.001- +h[e+4576>>3]*+h[b+792>>3])));i=i;return}function bt(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+744>>3]*+h[b+752>>3];e=c[a+416>>2]|0;h[b+904>>3]=+h[b+616>>3]*-.001+(d*-.001+(+h[e+5200>>3]*+h[b+944>>3]+(d*.001- +h[e+5208>>3]*+h[b+936>>3])));i=i;return}function ct(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+832>>3]=+h[b+4456>>3]*+h[d+936>>3]+(-(+h[b+4448>>3]*+h[d+944>>3])- +h[d+904>>3]);i=i;return}function dt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2168>>3]=-+h[b+832>>3]- +h[b+760>>3];i=i;return}function et(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1216>>3]=+h[b+5872>>3]*+h[b+2168>>3]+ +h[b+5920>>3]*+h[b+2160>>3];i=i;return}function ft(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1160>>3]=+h[b+3816>>3]*+h[d+1232>>3]+(-(+h[b+3808>>3]*+h[d+1240>>3])- +h[d+1216>>3]);i=i;return}function gt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2192>>3]=-+h[b+1160>>3]- +h[b+1088>>3];i=i;return}function ht(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1152>>3]=+h[b+3808>>3]*+h[d+1248>>3]+ +h[d+2392>>3]- +h[b+3824>>3]*+h[d+1232>>3];i=i;return}function it(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2200>>3]=-+h[b+1152>>3]- +h[b+1080>>3];i=i;return}function jt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1504>>3]=+h[b+5800>>3]*+h[b+2200>>3]+ +h[b+5824>>3]*+h[b+2192>>3];i=i;return}function kt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1496>>3]=+h[b+5808>>3]*+h[b+2200>>3]+ +h[b+5832>>3]*+h[b+2192>>3];i=i;return}function lt(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1440>>3]=+h[b+3184>>3]*+h[d+1512>>3]+(-(+h[b+3176>>3]*+h[d+1520>>3])- +h[d+1496>>3]);i=i;return}function mt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2224>>3]=-+h[b+1440>>3]- +h[b+1368>>3];i=i;return}function nt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1784>>3]=+h[b+5680>>3]*+h[b+2232>>3]+ +h[b+5728>>3]*+h[b+2224>>3];i=i;return}function ot(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1776>>3]=+h[b+5696>>3]*+h[b+2232>>3]+ +h[b+5744>>3]*+h[b+2224>>3];i=i;return}function pt(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1720>>3]=+h[b+2552>>3]*+h[d+1792>>3]+(-(+h[b+2544>>3]*+h[d+1800>>3])- +h[d+1776>>3]);i=i;return}function qt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2256>>3]=-+h[b+1720>>3]- +h[b+1648>>3];i=i;return}function rt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1952>>3]=+h[b+5624>>3]*+h[b+2264>>3]+ +h[b+5648>>3]*+h[b+2256>>3];i=i;return}function st(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1944>>3]=+h[b+5632>>3]*+h[b+2264>>3]+ +h[b+5656>>3]*+h[b+2256>>3];i=i;return}function tt(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1936>>3]=+h[b+1920>>3]*+h[d+1960>>3]+(-(+h[b+1912>>3]*+h[d+1968>>3])- +h[d+1944>>3]);i=i;return}function ut(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2288>>3]=-+h[b+1936>>3]- +h[b+1888>>3];i=i;return}function vt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1976>>3]=+h[b+5632>>3]*+h[b+2280>>3]+ +h[b+5656>>3]*+h[b+2272>>3];i=i;return}function wt(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1928>>3]=+h[b+1912>>3]*+h[d+1976>>3]+(-(+h[b+1928>>3]*+h[d+1960>>3])- +h[d+1952>>3]);i=i;return}function xt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2296>>3]=-+h[b+1928>>3]- +h[b+1880>>3];i=i;return}function yt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2304>>3]=+h[b+1976>>3]- +h[b+1912>>3];i=i;return}function zt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2112>>3]=+h[b+5528>>3]*+h[b+2312>>3]+ +h[b+5520>>3]*+h[b+2304>>3];i=i;return}function At(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2088>>3]=+h[b+1280>>3]*+h[d+2112>>3]+(-(+h[b+1296>>3]*+h[d+2096>>3])- +h[d+2064>>3]);i=i;return}function Bt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=a+8|0;a=c[d>>2]|0;e=b+16|0;f=c[e>>2]|0;h[f>>3]=+h[a+122608>>3];g=b+8|0;j=c[g>>2]|0;h[j>>3]=+h[a+122584>>3];k=c[b+12>>2]|0;h[k>>3]=+h[a+122592>>3];h[f+8>>3]=+h[a+122496>>3];h[j+8>>3]=+h[a+122472>>3];h[k+8>>3]=+h[a+122480>>3];h[f+16>>3]=+h[a+25840>>3];h[j+16>>3]=+h[a+25816>>3];h[k+16>>3]=+h[a+25824>>3];h[f+24>>3]=+h[a+14640>>3];h[j+24>>3]=+h[a+14616>>3];h[k+24>>3]=+h[a+14624>>3];h[f+32>>3]=+h[a+22480>>3];h[j+32>>3]=+h[a+22456>>3];h[k+32>>3]=+h[a+22464>>3];h[f+40>>3]=+h[a+22256>>3];h[j+40>>3]=+h[a+22232>>3];h[k+40>>3]=+h[a+22240>>3];h[f+48>>3]=+h[a+94272>>3];h[j+48>>3]=+h[a+94248>>3];h[k+48>>3]=+h[a+94256>>3];h[f+56>>3]=+h[a+99648>>3];h[j+56>>3]=+h[a+99624>>3];h[k+56>>3]=+h[a+99632>>3];a=c[d>>2]|0;h[(c[e>>2]|0)+64>>3]=+h[a+88896>>3];h[(c[g>>2]|0)+64>>3]=+h[a+88872>>3];h[k+64>>3]=+h[a+88880>>3];i=i;return}function Ct(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0;e=i;f=a;g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[j+8752>>3]=+h[b>>3];h[j+8744>>3]=+h[b+8>>3];h[j+1840>>3]=+h[b+16>>3];h[j+1040>>3]=+h[b+24>>3];h[j+1600>>3]=+h[b+32>>3];h[j+1584>>3]=+h[b+40>>3];h[j+6728>>3]=+h[b+48>>3];h[j+7112>>3]=+h[b+56>>3];h[j+6344>>3]=+h[b+64>>3];Lq(f);Mq(f);Nq(f);Oq(f);Pq(f);Qq(f);Rq(f);Sq(f);Tq(f);Uq(f);Vq(f);Wq(f);Xq(f);Yq(f);Zq(f);_q(f);$q(f);ar(f);br(f);cr(f);dr(f);er(f);fr(f);gr(f);hr(f);ir(f);jr(f);kr(f);lr(f);mr(f);nr(f);or(f);pr(f);qr(f);rr(f);sr(f);tr(f);ur(f);vr(f);wr(f);xr(f);yr(f);zr(f);Ar(f);Br(f);Cr(f);Dr(f);Er(f);Fr(f);Gr(f);Hr(f);Ir(f);Jr(f);Kr(f);Lr(f);Mr(f);Nr(f);Or(f);Pr(f);Qr(f);Rr(f);Sr(f);Tr(f);Ur(f);Vr(f);Wr(f);Xr(f);Yr(f);Zr(f);_r(f);$r(f);as(f);bs(f);cs(f);ds(f);es(f);fs(f);gs(f);hs(f);is(f);js(f);ks(f);ls(f);ms(f);ns(f);os(f);ps(f);qs(f);rs(f);ss(f);ts(f);us(f);vs(f);ws(f);xs(f);ys(f);zs(f);As(f);Bs(f);Cs(f);Ds(f);Es(f);Fs(f);Gs(f);Hs(f);Is(f);Js(f);Ks(f);Ls(f);Ms(f);Ns(f);Os(f);Ps(f);Qs(f);Rs(f);Ss(f);Ts(f);Us(f);Vs(f);Ws(f);Xs(f);Ys(f);Zs(f);_s(f);$s(f);at(f);bt(f);ct(f);dt(f);et(f);ft(f);gt(f);ht(f);it(f);jt(f);kt(f);lt(f);mt(f);nt(f);ot(f);pt(f);qt(f);rt(f);st(f);tt(f);ut(f);vt(f);wt(f);xt(f);yt(f);zt(f);At(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+5904>>3]*+h[f+2160>>3]+(+h[f+5856>>3]*+h[f+2168>>3]- +h[f+1224>>3]);h[d+8>>3]=+h[f+1040>>3]+(+h[f+248>>3]*(+h[f+5800>>3]*+h[f+1336>>3]+ +h[f+5808>>3]*+h[f+1344>>3])+(-(+h[f+5824>>3]*+h[f+1312>>3])- +h[f+5832>>3]*+h[f+1320>>3]));h[d+16>>3]=+h[f+840>>3]+(+h[f+768>>3]- +h[f+2392>>3]);b=c[a+416>>2]|0;h[d+24>>3]=+h[f+1432>>3]+(+h[f+1504>>3]+(+h[b+3192>>3]*+h[f+1512>>3]- +h[b+3176>>3]*+h[f+1528>>3]));h[d+32>>3]=+h[f+1920>>3]+(+h[b+1920>>3]*+h[f+1976>>3]+(-(+h[b+1928>>3]*+h[f+1968>>3])- +h[f+2368>>3]));f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d+40>>3]=+h[f+1704>>3]+(+h[f+1784>>3]+(+h[b+2552>>3]*+h[f+1808>>3]- +h[b+2560>>3]*+h[f+1800>>3]));b=f+1840|0;h[d+48>>3]=+h[f+1600>>3]+(+h[f+264>>3]*(+h[f+5624>>3]*+h[f+1864>>3]+ +h[f+5632>>3]*+h[f+1856>>3])+(-(+h[f+5648>>3]*+h[f+1848>>3])- +h[f+5656>>3]*+h[b>>3]));g=f+2016|0;a=f+1992|0;h[d+56>>3]=+h[b>>3]+(+h[f+272>>3]*+h[g>>3]*+h[f+280>>3]- +h[a>>3]*+h[f+8744>>3]);h[d+64>>3]=+h[a>>3]*+h[f+2288>>3]+(+h[g>>3]*+h[f+2296>>3]- +h[f+2088>>3]);i=e;return}function Dt(a){a=a|0;c[a+4>>2]=522;c[a>>2]=1;c[a+56>>2]=0;c[a+32>>2]=18;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;c[a+84>>2]=561;c[a+80>>2]=1;c[a+136>>2]=0;c[a+112>>2]=19;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=-1;c[a+116>>2]=44;c[a+164>>2]=600;c[a+160>>2]=1;c[a+216>>2]=0;c[a+192>>2]=20;c[a+180>>2]=0;c[a+184>>2]=0;c[a+188>>2]=-1;c[a+196>>2]=45;c[a+244>>2]=647;c[a+240>>2]=1;c[a+296>>2]=0;c[a+272>>2]=21;c[a+260>>2]=0;c[a+264>>2]=0;c[a+268>>2]=-1;c[a+276>>2]=46;c[a+324>>2]=688;c[a+320>>2]=1;c[a+376>>2]=0;c[a+352>>2]=22;c[a+340>>2]=0;c[a+344>>2]=0;c[a+348>>2]=-1;c[a+356>>2]=47;c[a+404>>2]=751;c[a+400>>2]=1;c[a+456>>2]=0;c[a+432>>2]=23;c[a+420>>2]=0;c[a+424>>2]=0;c[a+428>>2]=-1;c[a+436>>2]=48;c[a+484>>2]=2345;c[a+480>>2]=1;c[a+536>>2]=0;c[a+512>>2]=24;c[a+500>>2]=0;c[a+504>>2]=0;c[a+508>>2]=-1;c[a+516>>2]=49;c[a+564>>2]=2356;c[a+560>>2]=1;c[a+616>>2]=0;c[a+592>>2]=25;c[a+580>>2]=0;c[a+584>>2]=0;c[a+588>>2]=-1;c[a+596>>2]=50;c[a+644>>2]=2362;c[a+640>>2]=1;c[a+696>>2]=0;c[a+672>>2]=26;c[a+660>>2]=0;c[a+664>>2]=0;c[a+668>>2]=-1;c[a+676>>2]=51;c[a+724>>2]=2373;c[a+720>>2]=1;c[a+776>>2]=0;c[a+752>>2]=27;c[a+740>>2]=0;c[a+744>>2]=0;c[a+748>>2]=-1;c[a+756>>2]=52;c[a+804>>2]=2379;c[a+800>>2]=1;c[a+856>>2]=0;c[a+832>>2]=28;c[a+820>>2]=0;c[a+824>>2]=0;c[a+828>>2]=-1;c[a+836>>2]=53;c[a+884>>2]=2390;c[a+880>>2]=1;c[a+936>>2]=0;c[a+912>>2]=29;c[a+900>>2]=0;c[a+904>>2]=0;c[a+908>>2]=-1;c[a+916>>2]=54;c[a+964>>2]=2697;c[a+960>>2]=9;c[a+1016>>2]=0;c[a+992>>2]=30;c[a+980>>2]=0;c[a+984>>2]=0;c[a+988>>2]=-1;c[a+996>>2]=55;i=i;return}function Et(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9328>>3],2,b);se[c[e>>2]&3](1,2,-1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9336>>3],5,b);i=d;return}function Ft(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=-+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6648>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function Gt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9312>>3],2,b);se[c[e>>2]&3](1,2,1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9320>>3],5,b);i=d;return}function Ht(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6464>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function It(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9408>>3],2,b);se[c[e>>2]&3](1,2,-1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9416>>3],5,b);i=d;return}function Jt(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=-+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7032>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function Kt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9400>>3],2,b);se[c[e>>2]&3](1,2,1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9392>>3],5,b);i=d;return}function Lt(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6848>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function Mt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9488>>3],2,b);se[c[e>>2]&3](1,2,-1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9496>>3],5,b);i=d;return}function Nt(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=-+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7416>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function Ot(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9472>>3],2,b);se[c[e>>2]&3](1,2,1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9480>>3],5,b);i=d;return}function Pt(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7232>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function Qt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9728>>3],2,b);se[c[e>>2]&3](1,2,-1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9736>>3],5,b);i=d;return}function Rt(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=-+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8640>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function St(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9720>>3],2,b);se[c[e>>2]&3](1,2,1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9712>>3],5,b);i=d;return}function Tt(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8464>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function Ut(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9648>>3],2,b);se[c[e>>2]&3](1,2,-1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9656>>3],5,b);i=d;return}function Vt(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=-+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8232>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function Wt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9640>>3],2,b);se[c[e>>2]&3](1,2,1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9632>>3],5,b);i=d;return}function Xt(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8056>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function Yt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9568>>3],2,b);se[c[e>>2]&3](1,2,-1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9576>>3],5,b);i=d;return}function Zt(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=-+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7824>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function _t(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9552>>3],2,b);se[c[e>>2]&3](1,2,1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9560>>3],5,b);i=d;return}function $t(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7648>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function au(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9720>>3],2,b);se[c[e>>2]&3](1,2,1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9712>>3],5,b);i=d;return}function bu(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8464>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function cu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9640>>3],2,b);se[c[e>>2]&3](1,2,1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9632>>3],5,b);i=d;return}function du(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8056>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function eu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9560>>3],2,b);se[c[e>>2]&3](1,2,1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9552>>3],5,b);i=d;return}function fu(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7648>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function gu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9480>>3],2,b);se[c[e>>2]&3](1,2,1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9472>>3],5,b);i=d;return}function hu(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7232>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function iu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9400>>3],2,b);se[c[e>>2]&3](1,2,1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9392>>3],5,b);i=d;return}function ju(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6848>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function ku(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);se[c[e>>2]&3](0,2,1.0,1,b);f=a+4|0;se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9320>>3],2,b);se[c[e>>2]&3](1,2,1.0,3,b);se[c[e>>2]&3](2,0,1.0,4,b);se[c[e>>2]&3](2,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+9312>>3],5,b);i=d;return}function lu(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6464>>3];a=e+8|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;i=d;return}function mu(a){a=a|0;c[a+20>>2]=920;c[a+16>>2]=3;c[a+12>>2]=6;c[a>>2]=56;c[a+4>>2]=57;c[a+84>>2]=926;c[a+80>>2]=3;c[a+76>>2]=6;c[a+64>>2]=58;c[a+68>>2]=59;c[a+148>>2]=969;c[a+144>>2]=3;c[a+140>>2]=6;c[a+128>>2]=60;c[a+132>>2]=61;c[a+212>>2]=975;c[a+208>>2]=3;c[a+204>>2]=6;c[a+192>>2]=62;c[a+196>>2]=63;c[a+276>>2]=998;c[a+272>>2]=3;c[a+268>>2]=6;c[a+256>>2]=64;c[a+260>>2]=65;c[a+340>>2]=1004;c[a+336>>2]=3;c[a+332>>2]=6;c[a+320>>2]=66;c[a+324>>2]=67;c[a+404>>2]=1067;c[a+400>>2]=3;c[a+396>>2]=6;c[a+384>>2]=68;c[a+388>>2]=69;c[a+468>>2]=1073;c[a+464>>2]=3;c[a+460>>2]=6;c[a+448>>2]=70;c[a+452>>2]=71;c[a+532>>2]=1105;c[a+528>>2]=3;c[a+524>>2]=6;c[a+512>>2]=72;c[a+516>>2]=73;c[a+596>>2]=1111;c[a+592>>2]=3;c[a+588>>2]=6;c[a+576>>2]=74;c[a+580>>2]=75;c[a+660>>2]=1138;c[a+656>>2]=3;c[a+652>>2]=6;c[a+640>>2]=76;c[a+644>>2]=77;c[a+724>>2]=1144;c[a+720>>2]=3;c[a+716>>2]=6;c[a+704>>2]=78;c[a+708>>2]=79;c[a+788>>2]=2204;c[a+784>>2]=3;c[a+780>>2]=6;c[a+768>>2]=80;c[a+772>>2]=81;c[a+852>>2]=2224;c[a+848>>2]=3;c[a+844>>2]=6;c[a+832>>2]=82;c[a+836>>2]=83;c[a+916>>2]=2244;c[a+912>>2]=3;c[a+908>>2]=6;c[a+896>>2]=84;c[a+900>>2]=85;c[a+980>>2]=2264;c[a+976>>2]=3;c[a+972>>2]=6;c[a+960>>2]=86;c[a+964>>2]=87;c[a+1044>>2]=2278;c[a+1040>>2]=3;c[a+1036>>2]=6;c[a+1024>>2]=88;c[a+1028>>2]=89;c[a+1108>>2]=2292;c[a+1104>>2]=3;c[a+1100>>2]=6;c[a+1088>>2]=90;c[a+1092>>2]=91;i=i;return}function nu(a,b){a=a|0;b=b|0;i=i;return}function ou(a){a=a|0;i=i;return}function pu(a,b){a=a|0;b=b|0;c[b>>2]=c[9392+(a<<2)>>2];i=i;return c[3576+(a<<2)>>2]|0}



function JHa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=$fb(d|0)|0;switch(c[b>>2]|0){case 3:case 2:case 1:{q=o;g3a(q,d,1,p);p=a[q]|0;do{if((p+ -97<<24>>24&255)<26){r=p+ -32<<24>>24;a[q]=r;s=o+1|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+2|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+3|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+4|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+5|0;t=a[s]|0;if(!((t+ -97<<24>>24&255)<26)){u=r;break}a[s]=t+ -32<<24>>24;u=r}else{u=p}}while(0);p=u<<24>>24==83;q=u<<24>>24==68;r=p|q;if(!(u<<24>>24==67|u<<24>>24==68|u<<24>>24==83|u<<24>>24==90)){v=1;i=k;return v|0}t=l;g3a(t,o+1|0,1,2);l=m;g3a(l,o+3|0,1,3);o=n;g3a(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==2){if((f3a(t,107200,1,2)|0)==0){if((f3a(l,107216,1,3)|0)==0){v=2;i=k;return v|0}if((f3a(l,107224,1,3)|0)==0){v=2;i=k;return v|0}if((f3a(l,107232,1,3)|0)==0){v=2;i=k;return v|0}if((f3a(l,107240,1,3)|0)==0){v=2;i=k;return v|0}if((f3a(l,107248,1,3)|0)==0){v=2;i=k;return v|0}if((f3a(l,107256,1,3)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}if((f3a(t,107280,1,2)|0)==0){n=(f3a(l,107208,1,3)|0)==0;if(n|(p|q)^1){v=n?8:2;i=k;return v|0}v=2;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=91}else if(u<<24>>24==68|u<<24>>24==83){w=94}else{v=2;i=k;return v|0}do{if((w|0)==91){if((f3a(t,107304,1,2)|0)==0){v=2;i=k;return v|0}else{if(u<<24>>24==67|u<<24>>24==90){break}else if(u<<24>>24==68|u<<24>>24==83){w=94;break}else{v=2}i=k;return v|0}}}while(0);do{if((w|0)==94){if((f3a(t,107312,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=2}i=k;return v|0}n=a[l]|0;if(n<<24>>24==77){if((f3a(o,107320,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107328,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107336,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107344,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107352,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107360,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(n<<24>>24==71){if((f3a(o,107320,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107328,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107336,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107344,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107352,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107360,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}}while(0);if((f3a(t,107376,1,2)|0)!=0){v=2;i=k;return v|0}n=a[l]|0;if(n<<24>>24==77){if((f3a(o,107320,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107328,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107336,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107344,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107352,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107360,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(n<<24>>24==71){if((f3a(o,107320,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107328,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107336,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107344,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107352,1,2)|0)==0){v=2;i=k;return v|0}if((f3a(o,107360,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}else if((m|0)==3){if((f3a(t,107200,1,2)|0)==0){if((f3a(l,107216,1,3)|0)==0){v=128;i=k;return v|0}if((f3a(l,107224,1,3)|0)==0){v=128;i=k;return v|0}if((f3a(l,107232,1,3)|0)==0){v=128;i=k;return v|0}if((f3a(l,107240,1,3)|0)==0){v=128;i=k;return v|0}if((f3a(l,107248,1,3)|0)==0){v=128;i=k;return v|0}m=(f3a(l,107256,1,3)|0)==0;v=m?128:0;i=k;return v|0}if((f3a(t,107280,1,2)|0)==0){if(!(u<<24>>24==68|u<<24>>24==83)){v=0;i=k;return v|0}m=(f3a(l,107288,1,3)|0)==0;v=m?32:0;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=138}else if(u<<24>>24==68|u<<24>>24==83){w=141}else{v=0;i=k;return v|0}do{if((w|0)==138){if((f3a(t,107304,1,2)|0)==0){m=(f3a(l,107288,1,3)|0)==0;v=m?32:0;i=k;return v|0}else{if(u<<24>>24==67|u<<24>>24==90){break}else if(u<<24>>24==68|u<<24>>24==83){w=141;break}else{v=0}i=k;return v|0}}}while(0);do{if((w|0)==141){if((f3a(t,107312,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((f3a(o,107320,1,2)|0)!=0){if((f3a(o,107328,1,2)|0)==0){break}if((f3a(o,107336,1,2)|0)==0){break}if((f3a(o,107344,1,2)|0)==0){break}if((f3a(o,107352,1,2)|0)==0){break}if((f3a(o,107360,1,2)|0)==0){break}if((f3a(o,107368,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}}while(0);if((f3a(t,107376,1,2)|0)!=0){v=0;i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((f3a(o,107320,1,2)|0)!=0){if((f3a(o,107328,1,2)|0)==0){break}if((f3a(o,107336,1,2)|0)==0){break}if((f3a(o,107344,1,2)|0)==0){break}if((f3a(o,107352,1,2)|0)==0){break}if((f3a(o,107360,1,2)|0)==0){break}if((f3a(o,107368,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}else{if((f3a(t,107200,1,2)|0)==0){if((f3a(l,107208,1,3)|0)==0){v=64;i=k;return v|0}if((f3a(l,107216,1,3)|0)==0){v=32;i=k;return v|0}if((f3a(l,107224,1,3)|0)==0){v=32;i=k;return v|0}if((f3a(l,107232,1,3)|0)==0){v=32;i=k;return v|0}if((f3a(l,107240,1,3)|0)==0){v=32;i=k;return v|0}if((f3a(l,107248,1,3)|0)==0){v=32;i=k;return v|0}if((f3a(l,107256,1,3)|0)==0){v=32;i=k;return v|0}m=(f3a(l,107264,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((f3a(t,107272,1,2)|0)==0){m=(f3a(l,107208,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((f3a(t,107280,1,2)|0)==0){m=(f3a(l,107208,1,3)|0)==0;if(m|r^1){v=m?64:1;i=k;return v|0}m=(f3a(l,107288,1,3)|0)==0;if(m){v=m?32:1;i=k;return v|0}m=(f3a(l,107296,1,3)|0)==0;v=m?64:1;i=k;return v|0}do{if(u<<24>>24==68|u<<24>>24==83){w=29}else if(u<<24>>24==67|u<<24>>24==90){if((f3a(t,107304,1,2)|0)!=0){if(u<<24>>24==68|u<<24>>24==83){w=29;break}else if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}if((f3a(l,107208,1,3)|0)==0){v=64;i=k;return v|0}if((f3a(l,107288,1,3)|0)==0){v=32;i=k;return v|0}m=(f3a(l,107296,1,3)|0)==0;v=m?64:1;i=k;return v|0}}while(0);do{if((w|0)==29){if((f3a(t,107312,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}m=a[l]|0;if(m<<24>>24==71){do{if((f3a(o,107320,1,2)|0)!=0){if((f3a(o,107328,1,2)|0)==0){break}if((f3a(o,107336,1,2)|0)==0){break}if((f3a(o,107344,1,2)|0)==0){break}if((f3a(o,107352,1,2)|0)==0){break}if((f3a(o,107360,1,2)|0)==0){break}if((f3a(o,107368,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==77){do{if((f3a(o,107320,1,2)|0)!=0){if((f3a(o,107328,1,2)|0)==0){break}if((f3a(o,107336,1,2)|0)==0){break}if((f3a(o,107344,1,2)|0)==0){break}if((f3a(o,107352,1,2)|0)==0){break}if((f3a(o,107360,1,2)|0)==0){break}if((f3a(o,107368,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);do{if((w|0)==48){if((f3a(t,107376,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==77){do{if((f3a(o,107320,1,2)|0)!=0){if((f3a(o,107328,1,2)|0)==0){break}if((f3a(o,107336,1,2)|0)==0){break}if((f3a(o,107344,1,2)|0)==0){break}if((f3a(o,107352,1,2)|0)==0){break}if((f3a(o,107360,1,2)|0)==0){break}if((f3a(o,107368,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==71){do{if((f3a(o,107320,1,2)|0)!=0){if((f3a(o,107328,1,2)|0)==0){break}if((f3a(o,107336,1,2)|0)==0){break}if((f3a(o,107344,1,2)|0)==0){break}if((f3a(o,107352,1,2)|0)==0){break}if((f3a(o,107360,1,2)|0)==0){break}if((f3a(o,107368,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);if((f3a(t,107384,1,2)|0)==0){if((f3a(l,107208,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[j>>2]|0)<65?1:32;i=k;return v|0}if((f3a(t,107392,1,2)|0)==0){if((f3a(l,107208,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[g>>2]|0)<65?1:32;i=k;return v|0}if((f3a(t,107360,1,2)|0)==0){o=(f3a(l,107264,1,3)|0)==0;v=o?64:1;i=k;return v|0}if((f3a(t,107400,1,2)|0)==0){o=(f3a(l,107408,1,3)|0)==0;v=o?64:1;i=k;return v|0}if(!(u<<24>>24==68|u<<24>>24==83)){v=1;i=k;return v|0}if((f3a(t,107416,1,2)|0)==0){i=k;return 1}else{v=1;i=k;return v|0}}break};case 4:{v=6;i=k;return v|0};case 5:{v=2;i=k;return v|0};case 6:{t=c[f>>2]|0;u=c[g>>2]|0;v=~~(+(((t|0)>(u|0)?u:t)|0)*1.600000023841858);i=k;return v|0};case 7:{v=1;i=k;return v|0};case 10:{v=KHa(107432,107440,107448)|0;i=k;return v|0};case 11:{v=KHa(107456,107440,107448)|0;i=k;return v|0};case 16:case 15:case 14:case 13:case 12:{v=LHa(b,d,e,f,g,h,j)|0;i=k;return v|0};case 8:{v=50;i=k;return v|0};case 9:{v=25;i=k;return v|0};default:{v=-1;i=k;return v|0}}return 0}function KHa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function LHa(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(e3a(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 15:{p=o;i=j;return p|0};case 16:{m=(o|0)>13;i=j;return(m?2:m&1)|0};case 14:{p=14;i=j;return p|0};case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 12:{p=75;i=j;return p|0};default:{p=-1;i=j;return p|0}}return 0}function MHa(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=NHa(a,0,0)|0;i=b;return c|0}function NHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=OHa(a,b,c,0)|0;i=d;return e|0}function OHa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=ie[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=xfb(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=49;c[f+8>>2]=422}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=ie[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){fe[c[b+8>>2]&511](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=ie[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){fe[c[b+20>>2]&511](c[j+392>>2]|0);fe[c[j+20>>2]&511](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=ZIa(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}fe[c[j+20>>2]&511](c[j+44>>2]|0);fe[c[j+20>>2]&511](c[j+392>>2]|0);fe[c[j+20>>2]&511](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;_Ia(j+416|0,j+12|0);_Ia(j+440|0,j+12|0);QHa(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}THa(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=sJa()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=jJa()|0}k=j;l=k;i=g;return l|0}function PHa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function QHa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=36;BLa(f+256|0);if((b|0)!=0){g=RHa(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;kJa(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function RHa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((gIa(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function SHa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((gIa(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gIa(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=jIa(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=RHa(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((gIa(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((gIa(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((nIa(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gIa(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=jIa(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function THa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;fe[c[e+20>>2]&511](c[g+36>>2]|0);UHa(c[g+44>>2]|0,e);fe[c[e+20>>2]&511](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;fe[c[e+20>>2]&511](f)}UHa(c[h+376>>2]|0,e);UHa(c[e+372>>2]|0,e);VHa(e+416|0);VHa(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}WHa(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);fe[c[e+20>>2]&511](c[e+392>>2]|0);fe[c[e+20>>2]&511](c[e+464>>2]|0);fe[c[e+20>>2]&511](c[e+8>>2]|0);fe[c[e+20>>2]&511](c[e+44>>2]|0);fe[c[e+20>>2]&511](c[e+396>>2]|0);fe[c[e+20>>2]&511](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){fe[c[e+252>>2]&511](c[e+244>>2]|0)}fe[c[e+20>>2]&511](e);i=d;return}function UHa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;fe[c[a+20>>2]&511](c[b+16>>2]|0);fe[c[a+20>>2]&511](b)}i=d;return}function VHa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;fe[c[(c[d+20>>2]|0)+8>>2]&511](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;fe[c[(c[d+20>>2]|0)+8>>2]&511](a);a=e}i=b;return}function WHa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;hIa(f,g+20|0);while(1){d=iIa(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}fe[c[b+8>>2]&511](c[d+20>>2]|0)}mIa(g);mIa(g+132|0);mIa(g+20|0);mIa(g+40|0);mIa(g+60|0);VHa(g+80|0);VHa(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;fe[m&511](o);i=e;return}fe[c[b+8>>2]&511](c[g+184>>2]|0);fe[c[b+8>>2]&511](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;fe[m&511](o);i=e;return}function XHa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function YHa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function ZHa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((_Ha(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}else if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=aIa(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{bgb(f|0,b|0,d|0)|0;j=bIa(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=He[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=37;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==1|(d|0)==0){c[h+480>>2]=2}else if((d|0)==3){Ie[c[(c[h+144>>2]|0)+52>>2]&63](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}j=1;k=j;i=g;return k|0}function _Ha(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=XIa()|0}if((a[e+236|0]|0)!=0){f=SHa(e,109240)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function $Ha(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function aIa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;cgb(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=ie[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;bgb(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;fe[c[e+20>>2]&511](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function bIa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}else if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((_Ha(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}else if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=He[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=37;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==3){e=2}else if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}}while(0);Ie[c[(c[g+144>>2]|0)+52>>2]&63](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function cIa(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function dIa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}Ie[c[(c[d+144>>2]|0)+52>>2]&63](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function eIa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){Ee[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];ce[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];Ee[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function fIa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[107464+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function gIa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;bgb((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=xe[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=ie[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){bgb(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function hIa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function iIa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function jIa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=ie[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){dgb(c[m>>2]|0,0,g|0)|0;g=kIa(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=kIa(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((lIa(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=ie[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}dgb(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=kIa(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}fe[c[(c[b+16>>2]|0)+8>>2]&511](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=ie[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){dgb(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function kIa(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function lIa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function mIa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}fe[e&511](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}fe[e&511](c[d>>2]|0);i=b;return}function nIa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[109048+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[109088+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=xe[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=ie[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=ie[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}fe[c[j+20>>2]&511](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;bgb(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}Ee[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function oIa(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((le[((a[e+236|0]&255|0)!=0?33:34)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=WIa(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function pIa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=He[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=qIa(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function qIa(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=ye[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 1:{t=rIa(o,0,e,c[n>>2]|0)|0;if((t|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=jIa(o,l+132|0,109120,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((He[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}u=sIa(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=43;break a}tIa(u);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=u;h=0;r=47;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=sIa(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 7:{if((c[o+84>>2]|0)==0){break c}ce[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;PHa(o+416|0);h=0;break};case 57:{v=rIa(o,1,e,c[n>>2]|0)|0;if((v|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=wIa(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){ce[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);PHa(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;u=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=jIa(o,l+132|0,109120,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((ye[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=u;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ie[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}fe[c[o+88>>2]&511](c[o+4>>2]|0);h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=vIa(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){x=109224}else{x=(s|0)==32?109208:109232}if((xIa(o+416|0,x)|0)==0){r=111;break a}if((yIa(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=109128;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=109136;r=102;break};case 25:{c[o+332>>2]=109144;r=102;break};case 26:{c[o+332>>2]=109152;r=102;break};case 27:{c[o+332>>2]=109160;r=102;break};case 28:{c[o+332>>2]=109168;r=102;break};case 29:{c[o+332>>2]=109184;r=102;break};case 30:{c[o+332>>2]=109192;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((zIa(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((gIa(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;w=c[u>>2]|0;c[u>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((gIa(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;u=c[w>>2]|0;c[w>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;re[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);PHa(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;u=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=sIa(u+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[u+324>>2]=109120}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ie[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=jIa(o,l+132|0,109120,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=AIa(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}u=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((zIa(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,u,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((gIa(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;z=c[w>>2]|0;c[w>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((gIa(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;w=c[z>>2]|0;c[z>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;re[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,u,(s|0)==38|0);PHa(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}A=BIa(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;we[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;we[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}w=sIa(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=w;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;re[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;we[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((le[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=sIa(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=190;break a}c[o+316>>2]=jIa(o,l,u,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=sIa(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=202;break a}c[o+316>>2]=jIa(o,l+132|0,u,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=sIa(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 58:{if((c[o+80>>2]|0)!=0){eIa(o,b,e,c[n>>2]|0)}h=0;D=CIa(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 21:{if((He[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}w=sIa(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=220;break a}tIa(w);c[o+340>>2]=w;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}w=sIa(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=225;break a}c[q>>2]=e;ce[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,w,c[o+340>>2]|0);h=0}}while(0);PHa(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;ce[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);PHa(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){w=o+12|0;if((c[o+468>>2]|0)==0){u=c[w>>2]|0;c[o+468>>2]=32;c[o+464>>2]=ie[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[w+4>>2]|0;w=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=xe[u&63](w,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=xe[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=EIa(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=sIa(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}w=jIa(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((w|0)==0){r=279;break a}if((a[w+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((w|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}Ee[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[w+32|0]|0)!=0){r=287;break a}if((c[w+4>>2]|0)!=0){F=FIa(o,w,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[w+32|0]=1;E=(ye[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)!=0;a[w+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((ie[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=vIa(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=ie[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;Ee[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((IIa(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((HIa(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((He[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=sIa(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=EIa(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=vIa(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=GIa(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;Ee[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=sIa(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}tIa(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}eIa(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=He[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((ye[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=t;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=v;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){v=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}t=jIa(o,l+132|0,109120,36)|0;if((t|0)==0){I=1;J=I;i=m;return J|0}c[t+20>>2]=c[o+360>>2];a[l+131|0]=0;if((ye[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=v;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ie[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=38;I=uIa(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=39;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function rIa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((he[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=sIa(n+440|0,p,b,s+(xe[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=sIa(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);Ie[c[n+140>>2]&63](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}eIa(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=sIa(n+440|0,e,d,m+(xe[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=WIa(n,f)|0;PHa(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){PHa(n+440|0)}q=0;r=q;i=g;return r|0}function sIa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((yIa(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((gIa(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function tIa(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function uIa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=LIa(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((TIa(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function vIa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=sIa(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=jIa(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((UIa(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function wIa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((gIa(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=sIa(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=jIa(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=jIa(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((gIa(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((gIa(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=jIa(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function xIa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((gIa(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function yIa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((gIa(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){ce[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((gIa(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function zIa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=ie[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=xe[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function AIa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=VIa(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((gIa(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function BIa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((gIa(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(He[c[b+20>>2]&63](b,e,f,j)|0){case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case-4:{r=24;break a;break};case 10:{s=xe[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=aJa(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((gIa(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case 7:{r=28;break};case-1:{r=46;break a;break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}t=sIa(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=8;break a}s=jIa(l,g+132|0,t,0)|0;c[l+428>>2]=c[l+432>>2];if((s|0)==0){r=10;break a}if((a[s+32|0]|0)!=0){r=12;break a}if((c[s+16>>2]|0)==0){a[s+32|0]=1;n=BIa(l,c[l+228>>2]|0,c[s+4>>2]|0,(c[s+4>>2]|0)+(c[s+8>>2]|0)|0)|0;a[s+32|0]=0;if((n|0)!=0){break a}else{break b}}t=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[t+130|0]|0;break b}a[t+131|0]=0;a[s+32|0]=1;t=(ye[c[l+112>>2]&63](c[l+116>>2]|0,0,c[s+20>>2]|0,c[s+16>>2]|0,c[s+24>>2]|0)|0)!=0;a[s+32|0]=0;if(!t){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case 6:case 9:{if((yIa(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case 0:{r=49;break a;break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((gIa(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function CIa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=He[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case 42:{if((c[k+80>>2]|0)!=0){eIa(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function DIa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=CIa(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=40;k=pIa(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function EIa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=ie[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=xe[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=ie[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function FIa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=ie[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=He[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=qIa(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=LIa(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=41;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function GIa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=ie[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;KIa(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function HIa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){eIa(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(xe[c[a+32>>2]&63](a,b)|0)|0;k=sIa(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=xe[c[a+36>>2]&63](a,e)|0;e=sIa(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){JIa(e);Ee[c[g+64>>2]&15](c[g+4>>2]|0,k,e);PHa(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function IIa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){eIa(g,a,b,d)}h=1;j=h;i=f;return j|0}k=sIa(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){JIa(k);ge[c[g+68>>2]&127](c[g+4>>2]|0,k);PHa(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function JIa(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function KIa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}KIa(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}



function WRa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=xfb(e<<2)|0;e=l;c[l>>2]=160752;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=160792;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(fUa(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(fUa(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(fUa(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function XRa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;SSa(a,b,c);i=d;return}function YRa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(RSa(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){g6a(d,4);i=e;return}else{e6a(d,0);i=e;return}}function ZRa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=$fb(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=zfb((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;VMa(0,(o|0)!=0|0,160272,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;kgb(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;eSa(q,$fb(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=zfb(1,1)|0;c[d>>2]=q;VMa(0,(q|0)!=0|0,160272,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function _Ra(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=zfb(c[f>>2]<<2,4)|0;c[e>>2]=g;VMa(c[d+536>>2]|0,(g|0)!=0|0,160320,k);g=s+240|0;f=aSa(g)|0;h=s+264|0;t=aSa(h)|0;u=s+288|0;v=aSa(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=aSa(g)|0;D=aSa(h)|0;E=aSa(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==0){fSa(l,g,A+(v*52|0)+4|0);hSa(m,g);if(!(gSa(l,m)|0)){F=w;break}G=(c[(iSa(l)|0)+4>>2]|0)+1|0;H=2}else if(z<<24>>24==2){G=1;H=2}else if(z<<24>>24==1){fSa(l,b,A+(v*52|0)+4|0);hSa(n,b);if(!(gSa(l,n)|0)){F=w;break}G=(c[(iSa(l)|0)+4>>2]|0)+1|0;H=1}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==0){fSa(l,h,G+(t*52|0)+4|0);hSa(o,h);H=gSa(l,o)|0;J=H?2:0}else if(f<<24>>24==1){fSa(l,v,G+(t*52|0)+4|0);hSa(p,v);J=(gSa(l,p)|0)&1}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;n=c[(iSa(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=n+1}else{c[f+(w+1<<2)>>2]=~n}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==1){fSa(l,d,y+(t*52|0)+4|0);hSa(r,d);M=(gSa(l,r)|0)&1}else if(x<<24>>24==0){fSa(l,u,y+(t*52|0)+4|0);hSa(q,u);x=gSa(l,q)|0;M=x?2:0}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(iSa(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function $Ra(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=($fb(d|0)|0)+1;e=m;I7a(e,l,20)|0;if(d6a(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];WMa(l,160296,k)}I7a(e,d,c[f>>2]|0)|0;if(d6a(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];WMa(m,160296,j)}else{i=h;return}}function aSa(a){a=a|0;var b=0,d=0;b=i;d=c[(OSa(a)|0)>>2]|0;i=b;return d|0}function bSa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;iOa(3);do{if(c6a(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];K7a(k,e)|0;k=aSa(h+240|0)|0;m=aSa(h+264|0)|0;l=aSa(h+288|0)|0;$Ra(a,b,160200,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);RRa(h)}else{if((h|0)!=0){break}c[g>>2]=0;lOa(3);i=d;return}}while(0);cSa(j);Ffb(h);c[g>>2]=0;lOa(3);i=d;return}function cSa(a){a=a|0;var b=0;b=i;kTa(a);i=b;return}function dSa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;iOa(3);lOa(0);h[j>>3]=+dOa(0);iOa(0);l=k;m=d+4|0;I7a(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){I7a(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){I7a(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);I7a(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);I7a(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);I7a(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(d6a(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];WMa(t,160240,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;lOa(3);i=e;return}}function eSa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((Yfb(b,160456,4)|0)!=0){i=d;return}c=b;while(1){e=Va(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((Yfb(b,160456,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function fSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;ASa(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];qSa(a,f);i=e;return}function gSa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=oSa(a,b)|0;i=c;return d|0}function hSa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;rSa(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];qSa(a,e);i=d;return}function iSa(a){a=a|0;var b=0,c=0;b=i;c=jSa(kSa(a)|0)|0;i=b;return c|0}function jSa(a){a=a|0;var b=0,c=0;b=i;c=nSa(a)|0;i=b;return c|0}function kSa(a){a=a|0;var b=0,d=0;b=i;d=lSa((c[a>>2]|0)+16|0)|0;i=b;return d|0}function lSa(a){a=a|0;var b=0,c=0;b=i;c=mSa(a)|0;i=b;return c|0}function mSa(a){a=a|0;i=i;return a|0}function nSa(a){a=a|0;i=i;return a|0}function oSa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(pSa(a,b)|0)^1;i=c;return d|0}function pSa(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function qSa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];zSa(a,e);i=d;return}function rSa(a,b){a=a|0;b=b|0;var c=0;c=i;sSa(a,tSa(b)|0);i=c;return}function sSa(a,b){a=a|0;b=b|0;var c=0;c=i;ySa(a,b);i=c;return}function tSa(a){a=a|0;var b=0,c=0;b=i;c=uSa(vSa(a+4|0)|0)|0;i=b;return c|0}function uSa(a){a=a|0;var b=0,c=0;b=i;c=xSa(a)|0;i=b;return c|0}function vSa(a){a=a|0;var b=0,c=0;b=i;c=wSa(a)|0;i=b;return c|0}function wSa(a){a=a|0;i=i;return a|0}function xSa(a){a=a|0;i=i;return a|0}function ySa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function zSa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function ASa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=CSa(b)|0;BSa(f,b,d,h,tSa(b)|0);rSa(g,b);do{if(oSa(f,g)|0){h=DSa(b)|0;if(ESa(h,d,FSa(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);rSa(a,b);i=e;return}function BSa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;JSa(h);a:do{if((e|0)==0){j=f}else{k=DSa(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(KSa(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;JSa(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;JSa(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);sSa(a,j);i=g;return}function CSa(a){a=a|0;var b=0,d=0;b=i;d=c[(tSa(a)|0)>>2]|0;i=b;return d|0}function DSa(a){a=a|0;var b=0,c=0;b=i;c=HSa(a+8|0)|0;i=b;return c|0}function ESa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=GSa(0,b,c)|0;i=a;return d|0}function FSa(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function GSa(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function HSa(a){a=a|0;var b=0,c=0;b=i;c=ISa(a)|0;i=b;return c|0}function ISa(a){a=a|0;i=i;return a|0}function JSa(a){a=a|0;var b=0;b=i;LSa(a,-1);i=b;return}function KSa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=GSa(0,b,c)|0;i=a;return d|0}function LSa(a,b){a=a|0;b=b|0;b=i;MSa(a,0);i=b;return}function MSa(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function NSa(a){a=a|0;i=i;return c[a+4>>2]|0}function OSa(a){a=a|0;var b=0,c=0;b=i;c=PSa(a+8|0)|0;i=b;return c|0}function PSa(a){a=a|0;var b=0,c=0;b=i;c=QSa(a)|0;i=b;return c|0}function QSa(a){a=a|0;i=i;return a|0}function RSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 48:case 16:{h=160360;break};case 24:{h=160384;break};case 52:case 20:{h=160408;break};case 28:{h=160432;break};case 9:case 25:{h=160400;break};case 13:case 29:{h=160448;break};case 60:{h=160440;break};case 56:{h=160392;break};case 1:case 17:{h=160368;break};case 12:{h=160424;break};case 8:{h=160376;break};case 5:case 21:{h=160416;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=ic(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Wc(j|0,0,2)|0)==0){g=a;i=e;return g|0}Yc(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function SSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function TSa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}USa(d,f,102);f=ie[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((Yc(VSa(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}WSa(d);g=h;i=b;return g|0}function USa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;bTa(a,b,c);i=d;return}function VSa(a){a=a|0;var b=0,d=0;b=i;d=ZSa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function WSa(a){a=a|0;var b=0;b=i;XSa(a);i=b;return}function XSa(a){a=a|0;var b=0;b=i;YSa(a,0);i=b;return}function YSa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=ZSa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}ie[c[(_Sa(e)|0)>>2]&127](f)|0;i=d;return}function ZSa(a){a=a|0;var b=0,c=0;b=i;c=aTa(a)|0;i=b;return c|0}function _Sa(a){a=a|0;var b=0,c=0;b=i;c=$Sa(a)|0;i=b;return c|0}function $Sa(a){a=a|0;i=i;return a+4|0}function aTa(a){a=a|0;i=i;return a|0}function bTa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(dTa(f)|0)>>2]|0;cTa(a,d,c[(eTa(g)|0)>>2]|0);i=e;return}function cTa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;fTa(a,b,c);i=d;return}function dTa(a){a=a|0;i=i;return a|0}function eTa(a){a=a|0;i=i;return a|0}function fTa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(hTa(f)|0)>>2]|0;gTa(a,d,c[(iTa(g)|0)>>2]|0);i=e;return}function gTa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(hTa(f)|0)>>2];c[a+4>>2]=c[(iTa(g)|0)>>2];i=e;return}function hTa(a){a=a|0;i=i;return a|0}function iTa(a){a=a|0;i=i;return a|0}function jTa(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function kTa(a){a=a|0;var b=0;b=i;lTa(a+300|0);lTa(a+288|0);lTa(a+276|0);lTa(a+264|0);lTa(a+252|0);lTa(a+240|0);mTa(a);i=b;return}function lTa(a){a=a|0;var b=0;b=i;YTa(a);i=b;return}function mTa(a){a=a|0;var b=0;b=i;nTa(a,160504);k6a(a+104|0);i=b;return}function nTa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];rTa(a+4|0);i=d;return}function oTa(a){a=a|0;var b=0;b=i;mTa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function pTa(a){a=a|0;var b=0;b=i;mTa(a);Ffb(a);i=b;return}function qTa(a){a=a|0;var b=0;b=i;pTa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function rTa(a){a=a|0;var b=0;b=i;sTa(a);i=b;return}function sTa(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=160632;TSa(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}Gfb(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}Gfb(e)}}while(0);t6a(b);i=d;return}function tTa(a){a=a|0;var b=0;b=i;rTa(a);Ffb(a);i=b;return}function uTa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;ie[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=WTa(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=XTa(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;D6a(h,0,0,0);I6a(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}Gfb(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=Efb(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=Efb(h)|0;a[b+97|0]=1;i=e;return}function vTa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;D6a(e,0,0,0);I6a(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}Gfb(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}Gfb(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=Efb(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(TTa(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=Efb(o)|0;a[k]=1;i=f;return e|0}return 0}function wTa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Ec(4)|0;cfb(n);Td(n|0,207976,127)}n=PTa(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((ie[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){XRa(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=sgb(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Wc(p|0,q|0,f|0)|0)==0){p=yb(c[m>>2]|0)|0;XRa(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];STa(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{XRa(a,-1,-1);i=g;return}}}while(0);XRa(a,-1,-1);i=g;return}function xTa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((ie[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=jTa(d)|0;if((Wc(j|0,k|0,0)|0)==0){RTa(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{XRa(a,-1,-1);i=e;return}}}while(0);XRa(a,-1,-1);i=e;return}function yTa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Ec(4)|0;cfb(m);Td(m|0,207976,127)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=PTa(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=B6a(s)|0;u=(fa(t-(A6a(s)|0)|0,p)|0)+r|0;v=0;break}p=A6a(s)|0;if((p|0)==(B6a(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=QTa(t,g,x,o,p-(z6a(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=B6a(w)|0;u=q-(A6a(w)|0)|0;v=0}}while(0);if((Wc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;D6a(b,0,0,0);c[m>>2]=0}else{q=b;y=F6a(q)|0;do{if((y|0)!=(E6a(q)|0)){if((xe[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=OTa(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((rc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((ud(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function zTa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=JTa(b)|0;o=b;if((A6a(o)|0)==0){p=e+1|0;D6a(o,e,p,p)}if(n){q=0}else{n=B6a(o)|0;c[f>>2]=(n-(z6a(o)|0)|0)/2|0;c[g>>2]=4;q=c[(KTa(f,g)|0)>>2]|0}g=A6a(o)|0;do{if((g|0)==(B6a(o)|0)){cgb(z6a(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=B6a(o)|0;n=z6a(o)|0;p=sb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=z6a(o)|0;D6a(o,n,n+q|0,n+(p+q)|0);r=HTa(a[A6a(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;cgb(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(KTa(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=sb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Ec(4)|0;cfb(t);Td(t|0,207976,127)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=z6a(o)|0;if((LTa(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;D6a(o,f,f,c[s>>2]|0);r=HTa(a[A6a(o)|0]|0)|0;break}s=c[k>>2]|0;f=z6a(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}D6a(o,f,p,s);r=HTa(a[A6a(o)|0]|0)|0}else{r=HTa(a[g]|0)|0}}while(0);if((z6a(o)|0)!=(e|0)){m=r;i=d;return m|0}D6a(o,0,0,0);m=r;i=d;return m|0}function ATa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=z6a(g)|0;j=A6a(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(DTa(d,-1)|0){C6a(g,-1);f=GTa(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=ETa(d)|0;do{if(h){if(ITa(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);C6a(g,-1);a[A6a(g)|0]=b;f=d;i=e;return f|0}function BTa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}CTa(b);l=b;m=E6a(l)|0;n=G6a(l)|0;if(!(DTa(d,-1)|0)){if((F6a(l)|0)==0){I6a(l,f,f+1|0)}f=ETa(d)|0;a[F6a(l)|0]=f;H6a(l,1)}f=F6a(l)|0;o=E6a(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Ec(4)|0;u=t;cfb(u);v=207976;w=127;Td(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=E6a(l)|0;A=F6a(l)|0;B=FTa(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=E6a(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((rc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;I6a(l,B,F6a(l)|0);B=G6a(l)|0;H6a(l,B-(E6a(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Ec(4)|0;u=t;cfb(u);v=207976;w=127;Td(t|0,v|0,w|0)}else if((D|0)==14){q=(F6a(l)|0)-C|0;if((rc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((rc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);I6a(l,m,n)}k=GTa(d)|0;i=e;return k|0}function CTa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;D6a(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;I6a(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;I6a(f,h,h+(g+ -1)|0);break}}else{I6a(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function DTa(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function ETa(a){a=a|0;i=i;return a&255|0}function FTa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Ge[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function GTa(a){a=a|0;var b=0,c=0;b=i;c=DTa(a,-1)|0;i=b;return(c?0:a)|0}function HTa(a){a=a|0;i=i;return a&255|0}function ITa(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function JTa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;I6a(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;D6a(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;D6a(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function KTa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=MTa(b,c,e)|0;i=d;return g|0}function LTa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Ge[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function MTa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=NTa(0,b,a)|0;i=c;return(d?b:a)|0}function NTa(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function OTa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=ye[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function PTa(a){a=a|0;var b=0,d=0;b=i;d=ie[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function QTa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=ye[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function RTa(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function STa(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function TTa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=UTa(b,c,e)|0;i=d;return g|0}function UTa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=VTa(0,a,b)|0;i=c;return(d?b:a)|0}function VTa(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function WTa(a){a=a|0;var b=0,c=0;b=i;c=ccb(a,192480)|0;i=b;return c|0}function XTa(a){a=a|0;var b=0,d=0;b=i;d=ie[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function YTa(a){a=a|0;var b=0;b=i;ZTa(a);i=b;return}function ZTa(a){a=a|0;var b=0;b=i;_Ta(a);i=b;return}function _Ta(a){a=a|0;var b=0;b=i;$Ta(a,CSa(a)|0);i=b;return}function $Ta(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;JSa(d);if((b|0)==0){i=d;return}$Ta(a,c[b>>2]|0);$Ta(a,c[b+4>>2]|0);bUa(aUa(a)|0,b,1);i=d;return}function aUa(a){a=a|0;var b=0,c=0;b=i;c=dUa(a+4|0)|0;i=b;return c|0}function bUa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;cUa(0,b,0);i=c;return}function cUa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Ffb(b);i=c;return}function dUa(a){a=a|0;var b=0,c=0;b=i;c=eUa(a)|0;i=b;return c|0}function eUa(a){a=a|0;i=i;return a|0}function fUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=gUa(a,f,b)|0;l=c[k>>2]|0;JSa(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}iUa(j,a,b);jUa(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];hUa(g,e);kUa(j);j=c[f>>2]|0;lUa(a,j,k,mUa(g)|0);k=nUa(g)|0;kUa(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function gUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=CSa(h)|0;JSa(e);if((a|0)==0){j=tSa(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(GSa(0,d,a)|0){m=l;j=c[m>>2]|0;JSa(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(GSa(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;JSa(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function hUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];$Ua(a,e);i=d;return}function iUa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=aUa(d)|0;d=KUa(n,1)|0;LUa(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];JUa(j,d,h);MUa(0,FUa((NUa(j)|0)+16|0)|0,e);e=OUa(j)|0;a[e+4|0]=1;PUa(0,EUa((NUa(j)|0)+20|0)|0);a[e+5|0]=1;QUa(m,j);jUa(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];hUa(b,g);kUa(m);kUa(j);i=f;return}function jUa(a,b){a=a|0;b=b|0;var c=0;c=i;HUa(a,b);i=c;return}function kUa(a){a=a|0;var b=0;b=i;AUa(a);i=b;return}function lUa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;JSa(f);c[e>>2]=0;JSa(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=sUa(a)|0;b=c[c[e>>2]>>2]|0;JSa(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(tSa(a)|0)>>2]|0;tUa(e,c[d>>2]|0);d=uUa(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function mUa(a){a=a|0;var b=0,d=0;b=i;d=c[(qUa(a)|0)>>2]|0;i=b;return d|0}function nUa(a){a=a|0;var b=0,d=0;b=i;d=oUa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function oUa(a){a=a|0;var b=0,c=0;b=i;c=pUa(a)|0;i=b;return c|0}function pUa(a){a=a|0;i=i;return a|0}function qUa(a){a=a|0;var b=0,c=0;b=i;c=rUa(a)|0;i=b;return c|0}function rUa(a){a=a|0;i=i;return a|0}function sUa(a){a=a|0;i=i;return a|0}function tUa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=xUa(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;JSa(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;JSa(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(xUa(j)|0){p=j}else{o=c[k>>2]|0;yUa(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;zUa(p);i=e;return}else if((l|0)==14){if(xUa(j)|0){p=c[k>>2]|0;zUa(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;yUa(q);i=e;return}else if((l|0)==17){i=e;return}}function uUa(a){a=a|0;var b=0,c=0;b=i;c=vUa(a+8|0)|0;i=b;return c|0}function vUa(a){a=a|0;var b=0,c=0;b=i;c=wUa(a)|0;i=b;return c|0}function wUa(a){a=a|0;i=i;return a|0}function xUa(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function yUa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;JSa(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=xUa(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function zUa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;JSa(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=xUa(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function AUa(a){a=a|0;var b=0;b=i;BUa(a,0);i=b;return}function BUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=oUa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}DUa(CUa(e)|0,f);i=d;return}function CUa(a){a=a|0;var b=0,c=0;b=i;c=GUa(a)|0;i=b;return c|0}function DUa(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}bUa(c[a>>2]|0,b,1);i=d;return}function EUa(a){a=a|0;i=i;return a|0}function FUa(a){a=a|0;i=i;return a|0}function GUa(a){a=a|0;i=i;return a+4|0}function HUa(a,b){a=a|0;b=b|0;var c=0;c=i;IUa(a,b);i=c;return}function IUa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function JUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];TUa(a,b,f);i=e;return}function KUa(a,b){a=a|0;b=b|0;var c=0;a=i;c=SUa(0,b,0)|0;i=a;return c|0}function LUa(a,b){a=a|0;b=b|0;var c=0;c=i;RUa(a,b);i=c;return}function MUa(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function NUa(a){a=a|0;var b=0,d=0;b=i;d=c[(qUa(a)|0)>>2]|0;i=b;return d|0}function OUa(a){a=a|0;var b=0,c=0;b=i;c=CUa(a)|0;i=b;return c|0}function PUa(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function QUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;HUa(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];hUa(h,f);jUa(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];hUa(a,e);kUa(h);i=d;return}function RUa(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function SUa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Dfb(b*24|0)|0;i=c;return a|0}function TUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(VUa(g)|0)>>2]|0;g=WUa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];UUa(b,a,f);i=e;return}function UUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];XUa(a,b,f);i=e;return}function VUa(a){a=a|0;i=i;return a|0}function WUa(a){a=a|0;i=i;return a|0}function XUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(ZUa(g)|0)>>2]|0;g=_Ua(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];YUa(b,a,f);i=e;return}function YUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(ZUa(f)|0)>>2];f=_Ua(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function ZUa(a){a=a|0;i=i;return a|0}function _Ua(a){a=a|0;i=i;return a|0}function $Ua(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=nUa(aVa(b)|0)|0;h=_Ua(OUa(aVa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];UUa(g,a,e);i=d;return}function aVa(a){a=a|0;i=i;return c[a>>2]|0}function bVa(a){a=a|0;var b=0;b=i;i=i+48|0;cVa(a);XRa(a+184|0,0,0);XRa(a+200|0,0,0);dVa(a+240|0,b);dVa(a+252|0,b+8|0);dVa(a+264|0,b+16|0);dVa(a+276|0,b+24|0);dVa(a+288|0,b+32|0);dVa(a+300|0,b+40|0);i=b;return}function cVa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;p6a(d);e=a;c[e>>2]=160476;f=d;c[f>>2]=160496;d=a+4|0;w7a(a,160508|0,d);c[e>>2]=160476;c[f>>2]=160496;qVa(d);i=b;return}function dVa(a,b){a=a|0;b=b|0;b=i;eVa(a,0);i=b;return}function eVa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;fVa(a,b);i=b;return}function fVa(a,b){a=a|0;b=b|0;b=i;gVa(a,0);i=b;return}function gVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;hVa(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;iVa(f,0,e);e=tSa(b)|0;c[(sUa(b)|0)>>2]=e;i=d;return}function hVa(a){a=a|0;var b=0;b=i;mVa(a);i=b;return}function iVa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;jVa(b,c,f);i=e;return}function jVa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(lVa(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;kVa(d,b,f);i=e;return}function kVa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(lVa(e)|0)>>2];i=d;return}function lVa(a){a=a|0;i=i;return a|0}function mVa(a){a=a|0;var b=0;b=i;nVa(a);i=b;return}function nVa(a){a=a|0;var b=0;b=i;oVa(a);i=b;return}function oVa(a){a=a|0;var b=0;b=i;pVa(a);i=b;return}function pVa(a){a=a|0;c[a>>2]=0;i=i;return}function qVa(a){a=a|0;var b=0;b=i;rVa(a);i=b;return}function rVa(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;y6a(j);c[d>>2]=160632;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;JSa(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;u6a(g,j);l=sVa(g)|0;acb(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=le[r&63](d,0,4096)|0;i=e;return}u6a(h,j);c[k>>2]=WTa(h)|0;acb(h);a[f]=(XTa(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=le[r&63](d,0,4096)|0;i=e;return}function sVa(a){a=a|0;var b=0,c=0;b=i;c=bcb(a,192480)|0;i=b;return c|0}function tVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;iOa(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){uVa(a,b,c[f>>2]|0,h);lOa(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=Afb(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;WMa(k,160904,e)}uVa(a,b,l,h);lOa(3);i=d;return}function uVa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;lOa(0);k=+dOa(0);iOa(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function vVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=xfb(24)|0;iOa(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;VMa(c[m>>2]|0,l>>>31^1,160960,f);f=b+8|0;b=c[a+8>>2]|0;l=wVa(b,f)|0;c[g+20>>2]=l;l=wVa(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=xfb(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;WMa(k,161040,e)}else{c[h>>2]=0;c[a+12>>2]=g;lOa(3);i=d;return}}function wVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function xVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;iOa(3);u=b;v=ic(c[u>>2]|0,161104)|0;if((v|0)==0){yVa(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Wd(c[(Nc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;WMa(w,161112,q)}rc(161168,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];wd(v|0,161216,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];wd(v|0,161240,o|0)|0;rc(161264,40,1,v|0)|0;rc(161312,11,1,v|0)|0;rc(161328,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];zVa(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Sd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{rc(161344,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;zVa(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Sd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];wd(v|0,161368,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;zVa(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Sd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];wd(v|0,161368,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;zVa(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Sd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];wd(v|0,161368,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;zVa(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Sd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];wd(v|0,161368,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;zVa(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Sd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];wd(v|0,161368,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;zVa(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Sd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];wd(v|0,161368,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;zVa(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Sd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}yVa(t);if((Yc(v|0)|0)==0){yfb(c[r>>2]|0);c[r>>2]=0;lOa(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];WMa(e,161384,f)}}function yVa(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}yfb(a);c[d>>2]=0;i=b;return}function zVa(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];wd(a|0,161432,f|0)|0;i=e;return}function AVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=Dfb(192)|0;dgb(m|0,0,192)|0;BVa(m);c[a+12>>2]=m;n=m;o=a;YRa(n,c[o>>2]|0,36);if(d6a(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];WMa(a,161472,g)}else{g=m;I7a(g,161448,14)|0;J7a(h,g);a=jTa(h)|0;h=m+184|0;c[h>>2]=a;I7a(g,161464,4)|0;CVa(n,b+8|0);J7a(j,g);b=jTa(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;XRa(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];K7a(g,f)|0;DVa(n,-4-m+b|0);b=c[j>>2]|0;XRa(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];K7a(g,e)|0;lOa(3);i=d;return}}function BVa(a){a=a|0;var b=0;b=i;WVa(a);i=b;return}function CVa(a,b){a=a|0;b=b|0;var c=0;c=i;FVa(a,3);GVa(a,161648);FVa(a,0);GVa(a,161656);FVa(a,2);RVa(a,b);SVa(a,b);GVa(a,161664);FVa(a,0);i=c;return}function DVa(a,b){a=a|0;b=b|0;var d=0;d=i;c[40410]=Hd(b|0)|0;I7a(a,161640,4)|0;i=d;return}function EVa(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;J7a(l,q);r=jTa(l)|0;DVa(b,0);J7a(m,q);l=jTa(m)|0;FVa(b,1);GVa(b,161536);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;HVa(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);IVa(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{IVa(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{JVa(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{KVa(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{GVa(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}J7a(n,q);u=jTa(n)|0;n=agb(0,r|0,32)|0;XRa(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];K7a(q,k)|0;DVa(b,u-l|0);XRa(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];K7a(q,j)|0;i=g;return}function FVa(b,d){b=b|0;d=d|0;var e=0;e=i;a[161624]=-33;c[40408]=Hd(d|0)|0;d=b;I7a(d,161624,1)|0;I7a(d,161632,4)|0;i=e;return}function GVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=Hd($fb(d|0)|0)|0;a[161616]=-37;g=b;I7a(g,161616,1)|0;I7a(g,f,4)|0;I7a(g,d,$fb(d|0)|0)|0;i=e;return}function HVa(b,d){b=b|0;d=d|0;var e=0;e=i;a[161600]=-35;c[40402]=Hd(d|0)|0;d=b;I7a(d,161600,1)|0;I7a(d,161608,4)|0;i=e;return}function IVa(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[161584]=-53;QVa(c);e=b;I7a(e,161584,1)|0;I7a(e,161592,8)|0;i=d;return}function JVa(b,d){b=b|0;d=d|0;var e=0;e=i;a[161568]=-46;c[40394]=Hd(d|0)|0;d=b;I7a(d,161568,1)|0;I7a(d,161576,4)|0;i=e;return}function KVa(b,c){b=b|0;c=c|0;var d=0;d=i;a[161560]=c?-61:-62;I7a(b,161560,1)|0;i=d;return}function LVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;EVa(e,+h[f>>3],a,f);EVa(e,+h[b+248>>3],a,f);i=d;return}function MVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;J7a(j,p);o=jTa(j)|0;DVa(b,0);J7a(k,p);j=jTa(k)|0;FVa(b,1);GVa(b,161544);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;HVa(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;IVa(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{IVa(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{JVa(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{KVa(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{GVa(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}J7a(l,p);s=jTa(l)|0;l=agb(0,o|0,32)|0;XRa(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];K7a(p,g)|0;DVa(b,s-j|0);XRa(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];K7a(p,f)|0;i=e;return}function NVa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;RRa(a);iOa(3);if((a|0)!=0){OVa(a);Ffb(a)}c[d>>2]=0;lOa(3);i=b;return}function OVa(a){a=a|0;var b=0;b=i;PVa(a);i=b;return}function PVa(a){a=a|0;var b=0;b=i;mTa(a);i=b;return}function QVa(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((Hd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=161592;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[161592+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function RVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;GVa(a,161536);FVa(a,4);GVa(a,161672);FVa(a,0);GVa(a,161680);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;HVa(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);GVa(a,161688);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{GVa(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{GVa(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{GVa(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{GVa(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=161776;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];TVa(a,b,e);GVa(a,161712);FVa(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);UVa(a,161688,161720);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;UVa(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;UVa(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;UVa(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;UVa(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function SVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;GVa(a,161544);FVa(a,4);GVa(a,161672);FVa(a,0);GVa(a,161680);o=g+1+j+l+n|0;HVa(a,o);GVa(a,161688);if((c[f>>2]|0)>0){n=b;l=0;do{GVa(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{GVa(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{GVa(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{GVa(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=161696;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];TVa(a,b,e);GVa(a,161712);FVa(a,o);UVa(a,161688,161720);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;UVa(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;UVa(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;UVa(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;UVa(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function TVa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;GVa(b,161744);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}FVa(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?161688:h;if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}VVa(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;m=a[g+(u*52|0)+8|0]|0;if((c[e+(m<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{j=m<<24>>24==2?161688:w;if(m<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(m<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=j}VVa(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{t=k<<24>>24==2?161688:l;if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=t}VVa(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?161688:C;if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}VVa(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function UVa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GVa(a,b);FVa(a,1);GVa(a,161728);GVa(a,c);i=d;return}function VVa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;GVa(a,b);FVa(a,d?2:1);GVa(a,161752);GVa(a,c);if(!d){i=e;return}GVa(a,161760);GVa(a,161768);i=e;return}function WVa(a){a=a|0;var b=0;b=i;cVa(a);i=b;return}function XVa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;m5a(e,161792);i5a(d,ZVa(a,e)|0);YVa(d,b+4|0);s5a(d);s5a(e);m5a(g,161800);i5a(f,ZVa(a,g)|0);_Va(f,b);s5a(f);s5a(g);m5a(j,161816);i5a(h,ZVa(a,j)|0);YVa(h,b+8|0);s5a(h);s5a(j);m5a(l,161832);i5a(k,ZVa(a,l)|0);YVa(k,b+12|0);s5a(k);s5a(l);m5a(n,161848);i5a(m,ZVa(a,n)|0);$Va(m,b+16|0,0);s5a(m);s5a(n);m5a(p,161864);i5a(o,ZVa(a,p)|0);$Va(o,b+20|0,0);s5a(o);s5a(p);m5a(r,161880);i5a(q,ZVa(a,r)|0);$Va(q,b+24|0,0);s5a(q);s5a(r);m5a(t,161888);i5a(s,ZVa(a,t)|0);$Va(s,b+28|0,0);s5a(s);s5a(t);m5a(v,161904);i5a(u,ZVa(a,v)|0);$Va(u,b+32|0,0);s5a(u);s5a(v);i=c;return}function YVa(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){UMa(22,0,165112,d);i=d;return}else{c[b>>2]=Ad(P5a(a)|0)|0;i=d;return}}function ZVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=i_a(a,f,b)|0;l=c[k>>2]|0;JSa(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}k_a(j,a,b);l_a(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];j_a(g,e);m_a(j);j=c[f>>2]|0;n_a(a,j,k,o_a(g)|0);k=p_a(g)|0;m_a(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function _Va(a,b){a=a|0;b=b|0;var d=0;d=i;if((S5a(a,162080)|0)==0){c[b>>2]=1;i=d;return}if((S5a(a,162088)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Fc(P5a(a)|0)|0;i=d;return}}function $Va(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((S5a(a,162056)|0)==0){c[b>>2]=d}if((S5a(a,162080)|0)==0){c[b>>2]=1;i=e;return}if((S5a(a,162088)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Fc(P5a(a)|0)|0;i=e;return}}function aWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;m5a(j,161920);i5a(g,ZVa(b,j)|0);y=d+48|0;bWa(g,y);s5a(g);s5a(j);m5a(m,161936);i5a(l,ZVa(b,m)|0);j=d+56|0;cWa(l,j,0.0);s5a(l);s5a(m);m5a(o,161944);i5a(n,ZVa(b,o)|0);m=d+32|0;bWa(n,m);s5a(n);s5a(o);m5a(q,161952);i5a(p,ZVa(b,q)|0);o=d+33|0;bWa(p,o);s5a(p);s5a(q);m5a(s,161968);i5a(r,ZVa(b,s)|0);q=d+40|0;cWa(r,q,1.0);s5a(r);s5a(s);m5a(u,161976);i5a(t,ZVa(b,u)|0);s=d+16|0;cWa(t,s,-1.7976931348623157e+308);s5a(t);s5a(u);m5a(w,161984);i5a(v,ZVa(b,w)|0);u=d+24|0;cWa(v,u,1.7976931348623157e+308);s5a(v);s5a(w);m5a(x,161792);w=P5a(ZVa(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?162080:162088;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?162056:162064;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?162056:162072;c[f+20>>2]=j;c[f+24>>2]=m?162056:162064;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?162056:162072;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];SMa(4,0,161992,f);s5a(x);i=e;return}function bWa(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(S5a(b,162080)|0)==0|0;i=d;return}function cWa(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((S5a(a,162056)|0)==0){h[b>>3]=c;i=d;return}if((S5a(a,162080)|0)==0){h[b>>3]=1.0;i=d;return}if((S5a(a,162088)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+Tfb(P5a(a)|0);i=d;return}}function dWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;m5a(h,161920);i5a(g,ZVa(b,h)|0);s=d+13|0;bWa(g,s);s5a(g);s5a(h);m5a(k,161936);i5a(j,ZVa(b,k)|0);h=d+16|0;$Va(j,h,0);s5a(j);s5a(k);m5a(m,161944);i5a(l,ZVa(b,m)|0);k=d+12|0;bWa(l,k);s5a(l);s5a(m);m5a(o,161976);i5a(n,ZVa(b,o)|0);m=d+4|0;$Va(n,m,-2147483648);s5a(n);s5a(o);m5a(q,161984);i5a(p,ZVa(b,q)|0);o=d+8|0;$Va(p,o,2147483647);s5a(p);s5a(q);m5a(r,161792);q=P5a(ZVa(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?162080:162088;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?162056:162064;c[f+8>>2]=s;c[f+12>>2]=b?162056:162072;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;SMa(4,0,162096,f);s5a(r);i=e;return}function eWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;m5a(h,161920);i5a(g,ZVa(b,h)|0);o=d+5|0;bWa(g,o);s5a(g);s5a(h);m5a(k,161936);i5a(j,ZVa(b,k)|0);h=d+6|0;bWa(j,h);s5a(j);s5a(k);m5a(m,161944);i5a(l,ZVa(b,m)|0);k=d+4|0;bWa(l,k);s5a(l);s5a(m);m5a(n,161792);m=P5a(ZVa(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?162080:162088;h=(a[k]|0)!=0?162080:162088;c[f>>2]=m;c[f+4>>2]=b?162056:162064;c[f+8>>2]=o;c[f+12>>2]=b?162056:162072;c[f+16>>2]=h;SMa(4,0,162152,f);s5a(n);i=e;return}function fWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m5a(h,161920);i5a(g,ZVa(b,h)|0);m=d+4|0;bWa(g,m);s5a(g);s5a(h);m5a(k,161936);i5a(j,ZVa(b,k)|0);h=d+8|0;YVa(j,h);s5a(j);s5a(k);m5a(l,161792);k=P5a(ZVa(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?162056:162064;c[f+8>>2]=m;c[f+12>>2]=b?162056:162072;SMa(4,0,162192,f);s5a(l);i=e;return}



function up(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;a[b+315|0]=0;a[b+314|0]=1;cf(b);df(b);ef(b);ff(b);gf(b);hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);Jg(b);Kg(b);Lg(b);Mg(b);Ng(b);Og(b);Pg(b);Qg(b);Rg(b);Sg(b);Tg(b);Ug(b);Vg(b);Wg(b);Xg(b);Yg(b);Zg(b);_g(b);$g(b);ah(b);bh(b);ch(b);dh(b);eh(b);fh(b);gh(b);hh(b);ih(b);jh(b);kh(b);lh(b);mh(b);nh(b);oh(b);ph(b);qh(b);rh(b);sh(b);th(b);uh(b);vh(b);wh(b);xh(b);yh(b);zh(b);Ah(b);Bh(b);Ch(b);Dh(b);Eh(b);Fh(b);Gh(b);Hh(b);Ih(b);Jh(b);Kh(b);Lh(b);Mh(b);Nh(b);Oh(b);Ph(b);Qh(b);Rh(b);Sh(b);Th(b);Uh(b);Vh(b);Wh(b);Xh(b);Yh(b);Zh(b);_h(b);$h(b);ai(b);bi(b);ci(b);di(b);ei(b);fi(b);gi(b);hi(b);ii(b);ji(b);ki(b);li(b);mi(b);ni(b);oi(b);pi(b);qi(b);ri(b);si(b);ti(b);ui(b);vi(b);wi(b);xi(b);yi(b);zi(b);Ai(b);Bi(b);Ci(b);Di(b);Ei(b);Fi(b);Gi(b);Hi(b);Ii(b);Ji(b);Ki(b);Li(b);Mi(b);Ni(b);Oi(b);Pi(b);Qi(b);Ri(b);Si(b);Ti(b);Ui(b);Vi(b);Wi(b);Xi(b);Yi(b);Zi(b);_i(b);$i(b);aj(b);bj(b);cj(b);dj(b);ej(b);fj(b);gj(b);hj(b);ij(b);jj(b);kj(b);lj(b);mj(b);nj(b);oj(b);pj(b);qj(b);rj(b);sj(b);tj(b);uj(b);vj(b);wj(b);xj(b);yj(b);zj(b);Aj(b);Bj(b);Cj(b);Dj(b);Ej(b);Fj(b);Gj(b);Hj(b);Ij(b);Jj(b);Kj(b);Lj(b);Mj(b);Nj(b);Oj(b);Pj(b);Qj(b);Rj(b);Sj(b);Tj(b);Uj(b);Vj(b);Wj(b);Xj(b);Yj(b);Zj(b);_j(b);$j(b);ak(b);bk(b);ck(b);dk(b);ek(b);fk(b);gk(b);hk(b);ik(b);jk(b);kk(b);lk(b);mk(b);nk(b);ok(b);pk(b);qk(b);rk(b);sk(b);tk(b);uk(b);vk(b);wk(b);xk(b);yk(b);zk(b);Ak(b);Bk(b);Ck(b);Dk(b);Ek(b);Fk(b);Gk(b);Hk(b);Ik(b);Jk(b);Kk(b);Lk(b);Mk(b);Nk(b);Ok(b);Pk(b);Qk(b);Rk(b);Sk(b);Tk(b);Uk(b);Vk(b);Wk(b);Xk(b);Yk(b);Zk(b);_k(b);$k(b);al(b);bl(b);cl(b);dl(b);el(b);fl(b);gl(b);hl(b);il(b);jl(b);kl(b);ll(b);ml(b);nl(b);ol(b);pl(b);ql(b);rl(b);sl(b);tl(b);ul(b);vl(b);wl(b);xl(b);yl(b);zl(b);Al(b);Bl(b);Cl(b);Dl(b);El(b);Fl(b);Gl(b);Hl(b);Il(b);Jl(b);Kl(b);Ll(b);Ml(b);Nl(b);Ol(b);Pl(b);Ql(b);Rl(b);Sl(b);Tl(b);Ul(b);Vl(b);Wl(b);Xl(b);Yl(b);Zl(b);_l(b);$l(b);am(b);bm(b);cm(b);dm(b);em(b);fm(b);gm(b);hm(b);im(b);jm(b);km(b);lm(b);mm(b);nm(b);om(b);pm(b);qm(b);rm(b);sm(b);tm(b);um(b);vm(b);wm(b);xm(b);ym(b);zm(b);Am(b);Bm(b);Cm(b);Dm(b);Em(b);Fm(b);Gm(b);Hm(b);Im(b);Jm(b);Km(b);Lm(b);Mm(b);Nm(b);Om(b);Pm(b);Qm(b);Rm(b);Sm(b);Tm(b);Um(b);Vm(b);Wm(b);Xm(b);Ym(b);Zm(b);_m(b);$m(b);an(b);bn(b);cn(b);dn(b);en(b);fn(b);gn(b);hn(b);jn(b);kn(b);ln(b);mn(b);nn(b);on(b);pn(b);qn(b);rn(b);sn(b);tn(b);un(b);vn(b);wn(b);xn(b);yn(b);zn(b);An(b);Bn(b);Cn(b);Dn(b);En(b);Fn(b);Gn(b);Hn(b);In(b);Jn(b);Kn(b);Ln(b);Mn(b);Nn(b);On(b);Pn(b);Qn(b);Rn(b);Sn(b);Tn(b);Un(b);Vn(b);Wn(b);Xn(b);Yn(b);Zn(b);_n(b);$n(b);ao(b);bo(b);co(b);eo(b);fo(b);go(b);ho(b);io(b);jo(b);ko(b);lo(b);mo(b);no(b);oo(b);po(b);qo(b);ro(b);so(b);to(b);uo(b);vo(b);wo(b);xo(b);yo(b);zo(b);Ao(b);Bo(b);Co(b);Do(b);Eo(b);Fo(b);Go(b);Ho(b);Io(b);Jo(b);Ko(b);Lo(b);Mo(b);No(b);Oo(b);Po(b);Qo(b);Ro(b);So(b);To(b);Uo(b);Vo(b);Wo(b);Xo(b);Yo(b);Zo(b);_o(b);$o(b);ap(b);bp(b);cp(b);dp(b);ep(b);fp(b);gp(b);hp(b);ip(b);jp(b);kp(b);lp(b);mp(b);np(b);op(b);pp(b);qp(b);rp(b);sp(b);tp(b);if((a[b+312|0]|0)!=0){i=d;return 0}if((a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+20|0]|0)==0){i=d;return 0}if((a[(c[b+408>>2]|0)+20|0]|0)!=0){i=d;return 0}g=c[(c[b+428>>2]|0)+132>>2]|0;b=c[41888]|0;h=e;j=2376;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[b&15](e,g,f);i=d;return 0}function vp(b){b=b|0;var c=0;c=i;a[b+314|0]=0;wp(b);i=c;return 0}function wp(a){a=a|0;var b=0;b=i;kf(a);lf(a);mf(a);nf(a);of(a);pf(a);qf(a);rf(a);sf(a);tf(a);vf(a);wf(a);xf(a);yf(a);zf(a);Af(a);Bf(a);Cf(a);Df(a);Ef(a);Ff(a);Gf(a);If(a);Jf(a);Lf(a);Nf(a);Qf(a);Rf(a);Sf(a);Uf(a);Vf(a);Yf(a);Zf(a);_f(a);ag(a);bg(a);cg(a);dg(a);fg(a);ig(a);jg(a);kg(a);mg(a);ng(a);qg(a);rg(a);sg(a);ug(a);vg(a);wg(a);xg(a);zg(a);Cg(a);Dg(a);Eg(a);Gg(a);Hg(a);Kg(a);Lg(a);Mg(a);Og(a);Pg(a);Qg(a);Rg(a);Tg(a);Wg(a);Xg(a);Yg(a);_g(a);$g(a);ch(a);dh(a);fh(a);ih(a);jh(a);kh(a);mh(a);nh(a);qh(a);rh(a);th(a);wh(a);xh(a);yh(a);Ah(a);Bh(a);Eh(a);Ih(a);Jh(a);Kh(a);Lh(a);Mh(a);Nh(a);Oh(a);Ph(a);Qh(a);Rh(a);Sh(a);Th(a);Uh(a);Vh(a);Wh(a);Xh(a);Yh(a);Zh(a);_h(a);di(a);ei(a);fi(a);gi(a);hi(a);ii(a);ni(a);oi(a);pi(a);qi(a);ri(a);si(a);xi(a);yi(a);zi(a);Ai(a);Bi(a);Ci(a);Di(a);Gi(a);Hi(a);Ii(a);Ji(a);Ki(a);Li(a);Mi(a);Pi(a);Qi(a);Ri(a);Si(a);Ti(a);Ui(a);Vi(a);Yi(a);Zi(a);_i(a);$i(a);cj(a);jj(a);lj(a);mj(a);nj(a);oj(a);pj(a);qj(a);rj(a);sj(a);tj(a);uj(a);vj(a);wj(a);Cj(a);Dj(a);Ej(a);Fj(a);Gj(a);Hj(a);Ij(a);Kj(a);Mj(a);Nj(a);Qj(a);$j(a);bk(a);ck(a);dk(a);ek(a);fk(a);gk(a);hk(a);ik(a);jk(a);kk(a);lk(a);mk(a);sk(a);tk(a);uk(a);vk(a);wk(a);xk(a);yk(a);zk(a);Ak(a);Bk(a);Ck(a);Dk(a);Ek(a);Fk(a);Gk(a);Hk(a);Ik(a);Jk(a);Kk(a);Lk(a);Nk(a);Ok(a);Qk(a);Rk(a);Tk(a);Uk(a);$k(a);bl(a);cl(a);el(a);fl(a);hl(a);il(a);pl(a);rl(a);sl(a);ul(a);vl(a);xl(a);yl(a);Fl(a);Il(a);Ll(a);Ol(a);Pl(a);Ql(a);Rl(a);Sl(a);Vl(a);Wl(a);Xl(a);Yl(a);hm(a);im(a);jm(a);km(a);lm(a);Xm(a);Zm(a);_m(a);$m(a);an(a);bn(a);cn(a);dn(a);en(a);fn(a);gn(a);hn(a);jn(a);pn(a);rn(a);sn(a);tn(a);un(a);vn(a);wn(a);xn(a);yn(a);zn(a);An(a);Bn(a);Cn(a);In(a);Kn(a);Ln(a);Mn(a);Nn(a);On(a);Pn(a);Qn(a);Rn(a);Sn(a);Tn(a);Un(a);Vn(a);$n(a);bo(a);co(a);eo(a);fo(a);go(a);ho(a);io(a);jo(a);ko(a);lo(a);mo(a);no(a);i=b;return}function xp(a,b){a=a|0;b=+b;i=i;return 0}function yp(a){a=a|0;var b=0;b=i;i=i+8|0;VMa(c[a+536>>2]|0,(a|0)!=0|0,2608,b);c[a+540>>2]=2416;c[a+84>>2]=2640;c[a+88>>2]=2640;c[a+92>>2]=2704;c[a+96>>2]=2800;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=36;c[a+116>>2]=1363;c[a+120>>2]=0;c[a+124>>2]=105;c[a+128>>2]=28;c[a+132>>2]=0;c[a+136>>2]=1584;c[a+140>>2]=141;c[a+144>>2]=223;c[a+148>>2]=34;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=3115;c[a+220>>2]=54;c[a+224>>2]=90;c[a+228>>2]=0;c[a+160>>2]=31;c[a+104>>2]=0;c[a+164>>2]=55;c[a+168>>2]=0;c[a+176>>2]=36;c[a+180>>2]=0;c[a+184>>2]=36;c[a+188>>2]=0;c[a+56>>2]=2840;c[a+64>>2]=4;c[a+72>>2]=0;c[a+68>>2]=4903;c[a+192>>2]=0;c[a+196>>2]=18;c[a+200>>2]=13;c[a+204>>2]=0;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function zp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Pa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=mgb(c[k>>2]|0,e)|0;if((l|0)==0){eb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=k;w=7}else if((l|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=k}else{E=119072;F=119096;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Pa(c[29768]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=mgb(c[F>>2]|0,e)|0;if((G|0)==0){eb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=F;w=7;break}else if((G|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=F;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[28998]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=mgb(c[H>>2]|0,e)|0;if((I|0)==0){eb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((I|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}u=0;Ha(48,c[28998]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=mgb(c[H>>2]|0,e)|0;if((K|0)==0){eb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((K|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}H=h;c[g>>2]=h;_fb(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=mgb(c[L>>2]|0,e)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==2){m=0;n=0;o=0;p=H;q=E;s=F;t=L;w=7;break}else if((M|0)==1){x=0;y=0;z=0;A=H;B=E;C=F;D=L;break}m=0;n=0;o=0;p=H;q=E;s=F;t=0;w=7}}while(0);while(1){if((w|0)==7){w=0;if((t|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;_fb(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=mgb(c[I>>2]|0,e)|0;if((N|0)==0){eb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==2){O=s;P=q;Q=p;m=K;n=h;o=M;t=I;s=O;q=P;p=Q;w=7;continue}else if((N|0)==1){x=K;y=h;z=M;A=p;B=q;C=s;D=I;continue}x=K;y=h;z=M;A=p;B=q;C=s;D=0;continue}else{u=0;Ha(48,c[28998]|0,q|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=mgb(c[M>>2]|0,e)|0;if((R|0)==0){eb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((R|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=mgb(c[M>>2]|0,e)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((V|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}else{w=18;break}}}if((D|0)!=0){u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=mgb(c[M>>2]|0,e)|0;if((W|0)==0){eb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((W|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}M=c[r>>2]|0;u=0;Ra(34,2920,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=mgb(c[M>>2]|0,e)|0;if((ba|0)==0){eb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ba|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=mgb(c[M>>2]|0,e)|0;if((ca|0)==0){eb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ca|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=mgb(c[M>>2]|0,e)|0;if((da|0)==0){eb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((da|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}else{w=15;break}}u=0;pa(137,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=mgb(c[M>>2]|0,e)|0;if((ea|0)==0){eb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ea|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=mgb(c[h>>2]|0,e)|0;if((fa|0)==0){eb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((fa|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[y>>2]=x;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=mgb(c[h>>2]|0,e)|0;if((ga|0)==0){eb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ga|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;Ha(48,c[28998]|0,B|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=mgb(c[h>>2]|0,e)|0;if((ha|0)==0){eb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ha|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=mgb(c[h>>2]|0,e)|0;if((ia|0)==0){eb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ia|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=mgb(c[h>>2]|0,e)|0;if((ja|0)==0){eb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ja|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;pa(138,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=mgb(c[M>>2]|0,e)|0;if((ka|0)==0){eb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7}else if((ka|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa}else{w=26;break}}if((w|0)==15){la=A;ma=C;i=d;return 1}else if((w|0)==18){la=p;ma=s;i=d;return 1}return 0}function Ap(){var a=0;a=i;ud(0)|0;rc(3080,18,1,c[r>>2]|0)|0;ud(0)|0;i=a;return}function Bp(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0;g=i;i=i+32|0;j=g;k=g+24|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=IMa(e,1)|0;if((s|0)<2){c[r>>2]=1;c[r+4>>2]=f;t=+h[(PNa(e,2,r)|0)>>3];u=a;v=u;h[v>>3]=t;i=g;return}c[q>>2]=1;c[q+4>>2]=1;if(!(+h[(PNa(e,2,q)|0)>>3]>=d)){a:do{if((s|0)>2){q=2;while(1){c[p>>2]=q;c[p+4>>2]=1;r=q+1|0;if(!(+h[(PNa(e,2,p)|0)>>3]<=d)){w=q;break a}if((r|0)<(s|0)){q=r}else{w=r;break}}}else{w=2}}while(0);x=w+ -1|0}else{x=1}c[o>>2]=x;c[o+4>>2]=1;y=+h[(PNa(e,2,o)|0)>>3];o=x+1|0;c[n>>2]=o;c[n+4>>2]=1;z=+h[(PNa(e,2,n)|0)>>3];c[m>>2]=x;c[m+4>>2]=f;A=+h[(PNa(e,2,m)|0)>>3];c[l>>2]=o;c[l+4>>2]=f;B=+h[(PNa(e,2,l)|0)>>3];if(!(z>y)){l=c[41884]|0;e=j;f=3176;c[e+0>>2]=c[f+0>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];Ie[l&63](b,j,3200,k);}t=A+(B-A)*((d-y)/(z-y));u=a;v=u;h[v>>3]=t;i=g;return}function Cp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0,Na=0;f=i;i=i+120|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+24|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+24|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+24|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+24|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+16|0;va=i;i=i+16|0;wa=i;i=i+16|0;xa=i;i=i+16|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=ta;c[sa>>2]=4;JNa(Aa,1,sa);c[ra>>2]=4;JNa(ua,1,ra);c[qa>>2]=1;c[qa+4>>2]=1;Ba=+h[(PNa(d,2,qa)|0)>>3];c[pa>>2]=2;c[pa+4>>2]=2;Ca=-+h[(PNa(d,2,pa)|0)>>3];c[oa>>2]=3;c[oa+4>>2]=3;Da=Ba+(Ca- +h[(PNa(d,2,oa)|0)>>3])+1.0;c[na>>2]=2;c[na+4>>2]=2;Ca=+h[(PNa(d,2,na)|0)>>3];c[ma>>2]=1;c[ma+4>>2]=1;Ba=-+h[(PNa(d,2,ma)|0)>>3];c[la>>2]=3;c[la+4>>2]=3;Ea=Ca+(Ba- +h[(PNa(d,2,la)|0)>>3])+1.0;c[ka>>2]=3;c[ka+4>>2]=3;Ba=+h[(PNa(d,2,ka)|0)>>3];c[ja>>2]=1;c[ja+4>>2]=1;Ca=-+h[(PNa(d,2,ja)|0)>>3];c[ia>>2]=2;c[ia+4>>2]=2;Fa=Ba+(Ca- +h[(PNa(d,2,ia)|0)>>3])+1.0;c[ha>>2]=1;c[ha+4>>2]=1;Ca=+h[(PNa(d,2,ha)|0)>>3];c[ga>>2]=2;c[ga+4>>2]=2;Ba=+h[(PNa(d,2,ga)|0)>>3];c[fa>>2]=3;c[fa+4>>2]=3;Ga=Ca+(Ba+ +h[(PNa(d,2,fa)|0)>>3])+1.0;do{if(Ga>.04000000000000001){Ha=3}else{if(Ga>Da&Ga>Ea&Ga>Fa){Ha=3;break}if(Da>Ea&Da>Fa&Da>Ga){if(!(Da>=0.0)){fa=c[41884]|0;ga=Y;h[k>>3]=Da;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa;fa=l;ha=3408;c[fa+0>>2]=c[ha+0>>2];c[fa+4>>2]=c[ha+4>>2];c[fa+8>>2]=c[ha+8>>2];c[fa+12>>2]=c[ha+12>>2];c[fa+16>>2]=c[ha+16>>2];c[fa+20>>2]=c[ha+20>>2];Ie[ga&63](b,l,3296,Y);}Ba=+V(+Da)*.5;Ca=Ba*4.0;c[X>>2]=1;c[X+4>>2]=2;Ia=+h[(PNa(d,2,X)|0)>>3];c[W>>2]=2;c[W+4>>2]=1;Ja=(Ia+ +h[(PNa(d,2,W)|0)>>3])/Ca;c[U>>2]=1;c[U+4>>2]=3;Ia=+h[(PNa(d,2,U)|0)>>3];c[T>>2]=3;c[T+4>>2]=1;Ka=(Ia+ +h[(PNa(d,2,T)|0)>>3])/Ca;c[S>>2]=2;c[S+4>>2]=3;Ia=+h[(PNa(d,2,S)|0)>>3];c[R>>2]=3;c[R+4>>2]=2;La=(Ia- +h[(PNa(d,2,R)|0)>>3])/Ca;ga=Q;h[k>>3]=Ja;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=Q+8|0;h[k>>3]=Ka;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=Q+16|0;h[k>>3]=La;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ONa(wa,4,Ba,Q);KNa(wa,ua);break}if(Ea>Da&Ea>Fa&Ea>Ga){if(!(Ea>=0.0)){ga=c[41884]|0;ha=P;h[k>>3]=Ea;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];ha=ga;ga=j;fa=3408;c[ga+0>>2]=c[fa+0>>2];c[ga+4>>2]=c[fa+4>>2];c[ga+8>>2]=c[fa+8>>2];c[ga+12>>2]=c[fa+12>>2];c[ga+16>>2]=c[fa+16>>2];c[ga+20>>2]=c[fa+20>>2];Ie[ha&63](b,j,3352,P);}Ba=+V(+Ea)*.5;La=Ba*4.0;c[O>>2]=1;c[O+4>>2]=2;Ka=+h[(PNa(d,2,O)|0)>>3];c[N>>2]=2;c[N+4>>2]=1;Ja=(Ka+ +h[(PNa(d,2,N)|0)>>3])/La;c[M>>2]=2;c[M+4>>2]=3;Ka=+h[(PNa(d,2,M)|0)>>3];c[L>>2]=3;c[L+4>>2]=2;Ca=(Ka+ +h[(PNa(d,2,L)|0)>>3])/La;c[K>>2]=3;c[K+4>>2]=1;Ka=+h[(PNa(d,2,K)|0)>>3];c[J>>2]=1;c[J+4>>2]=3;Ia=(Ka- +h[(PNa(d,2,J)|0)>>3])/La;ha=I;h[k>>3]=Ba;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];ha=I+8|0;h[k>>3]=Ca;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];ha=I+16|0;h[k>>3]=Ia;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];ONa(xa,4,Ja,I);KNa(xa,ua);break}else{if(!(Fa>=0.0)){ha=c[41884]|0;fa=H;h[k>>3]=Fa;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=ha;ha=g;ga=3408;c[ha+0>>2]=c[ga+0>>2];c[ha+4>>2]=c[ga+4>>2];c[ha+8>>2]=c[ga+8>>2];c[ha+12>>2]=c[ga+12>>2];c[ha+16>>2]=c[ga+16>>2];c[ha+20>>2]=c[ga+20>>2];Ie[fa&63](b,g,3432,H);}Ja=+V(+Fa)*.5;Ia=Ja*4.0;c[G>>2]=1;c[G+4>>2]=3;Ca=+h[(PNa(d,2,G)|0)>>3];c[F>>2]=3;c[F+4>>2]=1;Ba=(Ca+ +h[(PNa(d,2,F)|0)>>3])/Ia;c[E>>2]=2;c[E+4>>2]=3;Ca=+h[(PNa(d,2,E)|0)>>3];c[D>>2]=3;c[D+4>>2]=2;La=(Ca+ +h[(PNa(d,2,D)|0)>>3])/Ia;c[C>>2]=1;c[C+4>>2]=2;Ca=+h[(PNa(d,2,C)|0)>>3];c[B>>2]=2;c[B+4>>2]=1;Ka=(Ca- +h[(PNa(d,2,B)|0)>>3])/Ia;fa=A;h[k>>3]=La;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=A+8|0;h[k>>3]=Ja;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=A+16|0;h[k>>3]=Ka;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];ONa(ya,4,Ba,A);KNa(ya,ua);break}}}while(0);if((Ha|0)==3){if(!(Ga>=0.0)){Ha=c[41884]|0;ya=ea;h[k>>3]=Ga;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=Ha;Ha=m;A=3408;c[Ha+0>>2]=c[A+0>>2];c[Ha+4>>2]=c[A+4>>2];c[Ha+8>>2]=c[A+8>>2];c[Ha+12>>2]=c[A+12>>2];c[Ha+16>>2]=c[A+16>>2];c[Ha+20>>2]=c[A+20>>2];Ie[ya&63](b,m,3240,ea);}Fa=+V(+Ga)*.5;Ga=Fa*4.0;c[da>>2]=2;c[da+4>>2]=3;Ea=+h[(PNa(d,2,da)|0)>>3];c[ca>>2]=3;c[ca+4>>2]=2;Da=(Ea- +h[(PNa(d,2,ca)|0)>>3])/Ga;c[ba>>2]=3;c[ba+4>>2]=1;Ea=+h[(PNa(d,2,ba)|0)>>3];c[aa>>2]=1;c[aa+4>>2]=3;Ba=(Ea- +h[(PNa(d,2,aa)|0)>>3])/Ga;c[$>>2]=1;c[$+4>>2]=2;Ea=+h[(PNa(d,2,$)|0)>>3];c[_>>2]=2;c[_+4>>2]=1;Ka=(Ea- +h[(PNa(d,2,_)|0)>>3])/Ga;_=Z;h[k>>3]=Ba;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];_=Z+8|0;h[k>>3]=Ka;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];_=Z+16|0;h[k>>3]=Fa;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];ONa(va,4,Da,Z);KNa(va,ua)}c[z>>2]=1;Da=+h[(PNa(ua,1,z)|0)>>3];c[y>>2]=1;Fa=Da*+h[(PNa(e,1,y)|0)>>3];c[x>>2]=2;Da=+h[(PNa(ua,1,x)|0)>>3];c[w>>2]=2;Ka=Da*+h[(PNa(e,1,w)|0)>>3];c[v>>2]=3;Da=+h[(PNa(ua,1,v)|0)>>3];c[u>>2]=3;Ba=Da*+h[(PNa(e,1,u)|0)>>3];c[t>>2]=4;Da=+h[(PNa(ua,1,t)|0)>>3];c[s>>2]=4;if(!(Fa+(Ka+(Ba+Da*+h[(PNa(e,1,s)|0)>>3]))<0.0)){KNa(ua,Aa);Ma=a;Na=ta;c[Ma+0>>2]=c[Na+0>>2];c[Ma+4>>2]=c[Na+4>>2];c[Ma+8>>2]=c[Na+8>>2];i=f;return}c[r>>2]=1;Da=-+h[(PNa(ua,1,r)|0)>>3];c[q>>2]=2;Ba=-+h[(PNa(ua,1,q)|0)>>3];c[p>>2]=3;Ka=-+h[(PNa(ua,1,p)|0)>>3];c[o>>2]=4;Fa=-+h[(PNa(ua,1,o)|0)>>3];o=n;h[k>>3]=Ba;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=Ka;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+16|0;h[k>>3]=Fa;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];ONa(za,4,Da,n);KNa(za,ua);KNa(ua,Aa);Ma=a;Na=ta;c[Ma+0>>2]=c[Na+0>>2];c[Ma+4>>2]=c[Na+4>>2];c[Ma+8>>2]=c[Na+8>>2];i=f;return}function Dp(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;SMa(4,0,3488,b);SMa(4,0,3528,a);i=a;return}function Ep(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}yfb(a);c[d>>2]=0;i=b;return}function Fp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+34|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+34|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[k+6344>>3],-+h[k+9304>>3],a[(c[b+360>>2]|0)+34|0]|0)|0;a[(c[b+352>>2]|0)+34|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[j+6344>>3],-+h[j+9304>>3],a[(c[b+360>>2]|0)+34|0]|0)|0;a[(c[b+352>>2]|0)+34|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+34|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[l+6344>>3],-+h[l+9304>>3])|0;a[(c[b+352>>2]|0)+34|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[g+6344>>3],-+h[g+9304>>3])|0;a[(c[b+352>>2]|0)+34|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+35|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+35|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[l+6344>>3],-+h[l+10648>>3],a[(c[b+360>>2]|0)+35|0]|0)|0;a[(c[b+352>>2]|0)+35|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[g+6344>>3],-+h[g+10648>>3],a[(c[b+360>>2]|0)+35|0]|0)|0;a[(c[b+352>>2]|0)+35|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+35|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[k+6344>>3],-+h[k+10648>>3])|0;a[(c[b+352>>2]|0)+35|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[j+6344>>3],-+h[j+10648>>3])|0;a[(c[b+352>>2]|0)+35|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=a[(c[b+356>>2]|0)+36|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+36|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],-+h[(c[b+416>>2]|0)+12656>>3],a[(c[b+360>>2]|0)+36|0]|0)|0;a[(c[b+352>>2]|0)+36|0]=k;n=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],-+h[(c[b+416>>2]|0)+12656>>3],a[(c[b+360>>2]|0)+36|0]|0)|0;a[(c[b+352>>2]|0)+36|0]=j;n=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+36|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],-+h[(c[b+416>>2]|0)+12656>>3])|0;a[(c[b+352>>2]|0)+36|0]=j;n=g;break}else{g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],-+h[(c[b+416>>2]|0)+12656>>3])|0;a[(c[b+352>>2]|0)+36|0]=g;n=g;break}}}}while(0);do{if((a[e]|0)==0){o=a[(c[b+356>>2]|0)+37|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+37|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[b+360>>2]|0)+37|0]|0)|0;a[(c[b+352>>2]|0)+37|0]=k;o=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[b+360>>2]|0)+37|0]|0)|0;a[(c[b+352>>2]|0)+37|0]=j;o=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+37|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;a[(c[b+352>>2]|0)+37|0]=j;o=g;break}else{g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;a[(c[b+352>>2]|0)+37|0]=g;o=g;break}}}}while(0);e=c[(c[b+404>>2]|0)+396>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+2|0;B=A;a[B]=p;i=d;return}if((a[(c[b+408>>2]|0)+2|0]|0)==0|m<<24>>24==0){break}else{p=1}q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+2|0;B=A;a[B]=p;i=d;return}}while(0);if(!((e|0)!=1|n<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+2|0;B=A;a[B]=p;i=d;return}p=o<<24>>24!=0|0;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+2|0;B=A;a[B]=p;i=d;return}function Gp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+38|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+38|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[k+6344>>3],+h[k+9304>>3],a[(c[b+360>>2]|0)+38|0]|0)|0;a[(c[b+352>>2]|0)+38|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[j+6344>>3],+h[j+9304>>3],a[(c[b+360>>2]|0)+38|0]|0)|0;a[(c[b+352>>2]|0)+38|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+38|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[l+6344>>3],+h[l+9304>>3])|0;a[(c[b+352>>2]|0)+38|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[g+6344>>3],+h[g+9304>>3])|0;a[(c[b+352>>2]|0)+38|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+39|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+39|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[l+6344>>3],+h[l+10648>>3],a[(c[b+360>>2]|0)+39|0]|0)|0;a[(c[b+352>>2]|0)+39|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[g+6344>>3],+h[g+10648>>3],a[(c[b+360>>2]|0)+39|0]|0)|0;a[(c[b+352>>2]|0)+39|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+39|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[k+6344>>3],+h[k+10648>>3])|0;a[(c[b+352>>2]|0)+39|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[j+6344>>3],+h[j+10648>>3])|0;a[(c[b+352>>2]|0)+39|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=a[(c[b+356>>2]|0)+40|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+40|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],+h[(c[b+416>>2]|0)+12656>>3],a[(c[b+360>>2]|0)+40|0]|0)|0;a[(c[b+352>>2]|0)+40|0]=k;n=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],+h[(c[b+416>>2]|0)+12656>>3],a[(c[b+360>>2]|0)+40|0]|0)|0;a[(c[b+352>>2]|0)+40|0]=j;n=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+40|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],+h[(c[b+416>>2]|0)+12656>>3])|0;a[(c[b+352>>2]|0)+40|0]=j;n=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],+h[(c[b+416>>2]|0)+12656>>3])|0;a[(c[b+352>>2]|0)+40|0]=g;n=g;break}}}}while(0);do{if((a[e]|0)==0){o=a[(c[b+356>>2]|0)+41|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+41|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[b+360>>2]|0)+41|0]|0)|0;a[(c[b+352>>2]|0)+41|0]=k;o=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0,a[(c[b+360>>2]|0)+41|0]|0)|0;a[(c[b+352>>2]|0)+41|0]=j;o=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+41|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;a[(c[b+352>>2]|0)+41|0]=j;o=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;a[(c[b+352>>2]|0)+41|0]=g;o=g;break}}}}while(0);e=c[(c[b+404>>2]|0)+396>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+3|0;B=A;a[B]=p;i=d;return}if((a[(c[b+408>>2]|0)+3|0]|0)==0|m<<24>>24==0){break}else{p=1}q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+3|0;B=A;a[B]=p;i=d;return}}while(0);if(!((e|0)!=-1|n<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+3|0;B=A;a[B]=p;i=d;return}p=o<<24>>24!=0|0;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+3|0;B=A;a[B]=p;i=d;return}function Hp(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[b+404>>2]|0)+396>>2]|0;f=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((e|0)==1){g=0}else{if((a[f+3|0]|0)!=0|(e|0)==-1){g=0;break}g=(a[f+2|0]|0)==0|0}}while(0);a[f+1|0]=g;i=d;return}function Ip(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+88896>>3];h[c[b+8>>2]>>3]=+h[d+88872>>3];h[c[b+12>>2]>>3]=+h[d+88880>>3];i=i;return}function Jp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0;f=i;g=b;j=b+4|0;h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6344>>3]=+h[d>>3];Fp(g);Gp(g);Hp(g);g=c[c[j>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+8784>>3];d=c[g+16>>2]|0;if((a[d+1|0]|0)!=0){l=0.0;m=k-l;h[e>>3]=m;i=f;return}if((a[d+3|0]|0)!=0){l=+h[j+6344>>3]- +h[j+9304>>3];m=k-l;h[e>>3]=m;i=f;return}if((a[d+2|0]|0)!=0){l=+h[j+6344>>3]+ +h[j+9304>>3];m=k-l;h[e>>3]=m;i=f;return}n=+h[j+6344>>3];o=+h[j+9304>>3];if((c[(c[b+404>>2]|0)+396>>2]|0)==1){l=n-o;m=k-l;h[e>>3]=m;i=f;return}else{l=n+o;m=k-l;h[e>>3]=m;i=f;return}}function Kp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+42|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+42|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[k+6728>>3],-+h[k+9384>>3],a[(c[b+360>>2]|0)+42|0]|0)|0;a[(c[b+352>>2]|0)+42|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[j+6728>>3],-+h[j+9384>>3],a[(c[b+360>>2]|0)+42|0]|0)|0;a[(c[b+352>>2]|0)+42|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+42|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[l+6728>>3],-+h[l+9384>>3])|0;a[(c[b+352>>2]|0)+42|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[g+6728>>3],-+h[g+9384>>3])|0;a[(c[b+352>>2]|0)+42|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+43|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+43|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[l+6728>>3],-+h[l+10504>>3],a[(c[b+360>>2]|0)+43|0]|0)|0;a[(c[b+352>>2]|0)+43|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[g+6728>>3],-+h[g+10504>>3],a[(c[b+360>>2]|0)+43|0]|0)|0;a[(c[b+352>>2]|0)+43|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+43|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[k+6728>>3],-+h[k+10504>>3])|0;a[(c[b+352>>2]|0)+43|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[j+6728>>3],-+h[j+10504>>3])|0;a[(c[b+352>>2]|0)+43|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=a[(c[b+356>>2]|0)+44|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+44|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],-+h[(c[b+416>>2]|0)+12032>>3],a[(c[b+360>>2]|0)+44|0]|0)|0;a[(c[b+352>>2]|0)+44|0]=k;n=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],-+h[(c[b+416>>2]|0)+12032>>3],a[(c[b+360>>2]|0)+44|0]|0)|0;a[(c[b+352>>2]|0)+44|0]=j;n=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+44|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],-+h[(c[b+416>>2]|0)+12032>>3])|0;a[(c[b+352>>2]|0)+44|0]=j;n=g;break}else{g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],-+h[(c[b+416>>2]|0)+12032>>3])|0;a[(c[b+352>>2]|0)+44|0]=g;n=g;break}}}}while(0);do{if((a[e]|0)==0){o=a[(c[b+356>>2]|0)+45|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+45|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[b+360>>2]|0)+45|0]|0)|0;a[(c[b+352>>2]|0)+45|0]=k;o=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[b+360>>2]|0)+45|0]|0)|0;a[(c[b+352>>2]|0)+45|0]=j;o=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+45|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;a[(c[b+352>>2]|0)+45|0]=j;o=g;break}else{g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;a[(c[b+352>>2]|0)+45|0]=g;o=g;break}}}}while(0);e=c[(c[b+404>>2]|0)+400>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+5|0;B=A;a[B]=p;i=d;return}if((a[(c[b+408>>2]|0)+5|0]|0)==0|m<<24>>24==0){break}else{p=1}q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+5|0;B=A;a[B]=p;i=d;return}}while(0);if(!((e|0)!=1|n<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+5|0;B=A;a[B]=p;i=d;return}p=o<<24>>24!=0|0;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+5|0;B=A;a[B]=p;i=d;return}function Lp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+46|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+46|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[k+6728>>3],+h[k+9384>>3],a[(c[b+360>>2]|0)+46|0]|0)|0;a[(c[b+352>>2]|0)+46|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[j+6728>>3],+h[j+9384>>3],a[(c[b+360>>2]|0)+46|0]|0)|0;a[(c[b+352>>2]|0)+46|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+46|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[l+6728>>3],+h[l+9384>>3])|0;a[(c[b+352>>2]|0)+46|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[g+6728>>3],+h[g+9384>>3])|0;a[(c[b+352>>2]|0)+46|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+47|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+47|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[l+6728>>3],+h[l+10504>>3],a[(c[b+360>>2]|0)+47|0]|0)|0;a[(c[b+352>>2]|0)+47|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[g+6728>>3],+h[g+10504>>3],a[(c[b+360>>2]|0)+47|0]|0)|0;a[(c[b+352>>2]|0)+47|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+47|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[k+6728>>3],+h[k+10504>>3])|0;a[(c[b+352>>2]|0)+47|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[j+6728>>3],+h[j+10504>>3])|0;a[(c[b+352>>2]|0)+47|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=a[(c[b+356>>2]|0)+48|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+48|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],+h[(c[b+416>>2]|0)+12032>>3],a[(c[b+360>>2]|0)+48|0]|0)|0;a[(c[b+352>>2]|0)+48|0]=k;n=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],+h[(c[b+416>>2]|0)+12032>>3],a[(c[b+360>>2]|0)+48|0]|0)|0;a[(c[b+352>>2]|0)+48|0]=j;n=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+48|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],+h[(c[b+416>>2]|0)+12032>>3])|0;a[(c[b+352>>2]|0)+48|0]=j;n=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],+h[(c[b+416>>2]|0)+12032>>3])|0;a[(c[b+352>>2]|0)+48|0]=g;n=g;break}}}}while(0);do{if((a[e]|0)==0){o=a[(c[b+356>>2]|0)+49|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+49|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[b+360>>2]|0)+49|0]|0)|0;a[(c[b+352>>2]|0)+49|0]=k;o=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0,a[(c[b+360>>2]|0)+49|0]|0)|0;a[(c[b+352>>2]|0)+49|0]=j;o=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+49|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;a[(c[b+352>>2]|0)+49|0]=j;o=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;a[(c[b+352>>2]|0)+49|0]=g;o=g;break}}}}while(0);e=c[(c[b+404>>2]|0)+400>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+6|0;B=A;a[B]=p;i=d;return}if((a[(c[b+408>>2]|0)+6|0]|0)==0|m<<24>>24==0){break}else{p=1}q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+6|0;B=A;a[B]=p;i=d;return}}while(0);if(!((e|0)!=-1|n<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+6|0;B=A;a[B]=p;i=d;return}p=o<<24>>24!=0|0;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+6|0;B=A;a[B]=p;i=d;return}function Mp(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[b+404>>2]|0)+400>>2]|0;f=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((e|0)==1){g=0}else{if((a[f+6|0]|0)!=0|(e|0)==-1){g=0;break}g=(a[f+5|0]|0)==0|0}}while(0);a[f+4|0]=g;i=d;return}function Np(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+94272>>3];h[c[b+8>>2]>>3]=+h[d+94248>>3];h[c[b+12>>2]>>3]=+h[d+94256>>3];i=i;return}function Op(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0;f=i;g=b;j=b+4|0;h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6728>>3]=+h[d>>3];Kp(g);Lp(g);Mp(g);g=c[c[j>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+8776>>3];d=c[g+16>>2]|0;if((a[d+4|0]|0)!=0){l=0.0;m=k-l;h[e>>3]=m;i=f;return}if((a[d+6|0]|0)!=0){l=+h[j+6728>>3]- +h[j+9384>>3];m=k-l;h[e>>3]=m;i=f;return}if((a[d+5|0]|0)!=0){l=+h[j+6728>>3]+ +h[j+9384>>3];m=k-l;h[e>>3]=m;i=f;return}n=+h[j+6728>>3];o=+h[j+9384>>3];if((c[(c[b+404>>2]|0)+400>>2]|0)==1){l=n-o;m=k-l;h[e>>3]=m;i=f;return}else{l=n+o;m=k-l;h[e>>3]=m;i=f;return}}function Pp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+30|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+30|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[k+7112>>3],-+h[k+9464>>3],a[(c[b+360>>2]|0)+30|0]|0)|0;a[(c[b+352>>2]|0)+30|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[j+7112>>3],-+h[j+9464>>3],a[(c[b+360>>2]|0)+30|0]|0)|0;a[(c[b+352>>2]|0)+30|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+30|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[l+7112>>3],-+h[l+9464>>3])|0;a[(c[b+352>>2]|0)+30|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[g+7112>>3],-+h[g+9464>>3])|0;a[(c[b+352>>2]|0)+30|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+31|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+31|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[l+7112>>3],-+h[l+10360>>3],a[(c[b+360>>2]|0)+31|0]|0)|0;a[(c[b+352>>2]|0)+31|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[g+7112>>3],-+h[g+10360>>3],a[(c[b+360>>2]|0)+31|0]|0)|0;a[(c[b+352>>2]|0)+31|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+31|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[k+7112>>3],-+h[k+10360>>3])|0;a[(c[b+352>>2]|0)+31|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[j+7112>>3],-+h[j+10360>>3])|0;a[(c[b+352>>2]|0)+31|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=a[(c[b+356>>2]|0)+32|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+32|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],-+h[(c[b+416>>2]|0)+11408>>3],a[(c[b+360>>2]|0)+32|0]|0)|0;a[(c[b+352>>2]|0)+32|0]=k;n=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],-+h[(c[b+416>>2]|0)+11408>>3],a[(c[b+360>>2]|0)+32|0]|0)|0;a[(c[b+352>>2]|0)+32|0]=j;n=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+32|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],-+h[(c[b+416>>2]|0)+11408>>3])|0;a[(c[b+352>>2]|0)+32|0]=j;n=g;break}else{g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],-+h[(c[b+416>>2]|0)+11408>>3])|0;a[(c[b+352>>2]|0)+32|0]=g;n=g;break}}}}while(0);do{if((a[e]|0)==0){o=a[(c[b+356>>2]|0)+33|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+33|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[b+360>>2]|0)+33|0]|0)|0;a[(c[b+352>>2]|0)+33|0]=k;o=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[b+360>>2]|0)+33|0]|0)|0;a[(c[b+352>>2]|0)+33|0]=j;o=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+33|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0)|0;a[(c[b+352>>2]|0)+33|0]=j;o=g;break}else{g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0)|0;a[(c[b+352>>2]|0)+33|0]=g;o=g;break}}}}while(0);e=c[(c[b+404>>2]|0)+404>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+8|0;B=A;a[B]=p;i=d;return}if((a[(c[b+408>>2]|0)+8|0]|0)==0|m<<24>>24==0){break}else{p=1}q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+8|0;B=A;a[B]=p;i=d;return}}while(0);if(!((e|0)!=1|n<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+8|0;B=A;a[B]=p;i=d;return}p=o<<24>>24!=0|0;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+8|0;B=A;a[B]=p;i=d;return}function Qp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+50|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+50|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[k+7112>>3],+h[k+9464>>3],a[(c[b+360>>2]|0)+50|0]|0)|0;a[(c[b+352>>2]|0)+50|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[j+7112>>3],+h[j+9464>>3],a[(c[b+360>>2]|0)+50|0]|0)|0;a[(c[b+352>>2]|0)+50|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+50|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[l+7112>>3],+h[l+9464>>3])|0;a[(c[b+352>>2]|0)+50|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[g+7112>>3],+h[g+9464>>3])|0;a[(c[b+352>>2]|0)+50|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+51|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+51|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[l+7112>>3],+h[l+10360>>3],a[(c[b+360>>2]|0)+51|0]|0)|0;a[(c[b+352>>2]|0)+51|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[g+7112>>3],+h[g+10360>>3],a[(c[b+360>>2]|0)+51|0]|0)|0;a[(c[b+352>>2]|0)+51|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+51|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[k+7112>>3],+h[k+10360>>3])|0;a[(c[b+352>>2]|0)+51|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[j+7112>>3],+h[j+10360>>3])|0;a[(c[b+352>>2]|0)+51|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=a[(c[b+356>>2]|0)+52|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+52|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],+h[(c[b+416>>2]|0)+11408>>3],a[(c[b+360>>2]|0)+52|0]|0)|0;a[(c[b+352>>2]|0)+52|0]=k;n=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],+h[(c[b+416>>2]|0)+11408>>3],a[(c[b+360>>2]|0)+52|0]|0)|0;a[(c[b+352>>2]|0)+52|0]=j;n=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+52|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],+h[(c[b+416>>2]|0)+11408>>3])|0;a[(c[b+352>>2]|0)+52|0]=j;n=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],+h[(c[b+416>>2]|0)+11408>>3])|0;a[(c[b+352>>2]|0)+52|0]=g;n=g;break}}}}while(0);do{if((a[e]|0)==0){o=a[(c[b+356>>2]|0)+53|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+53|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[b+360>>2]|0)+53|0]|0)|0;a[(c[b+352>>2]|0)+53|0]=k;o=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0,a[(c[b+360>>2]|0)+53|0]|0)|0;a[(c[b+352>>2]|0)+53|0]=j;o=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+53|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0)|0;a[(c[b+352>>2]|0)+53|0]=j;o=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7088>>3],0.0)|0;a[(c[b+352>>2]|0)+53|0]=g;o=g;break}}}}while(0);e=c[(c[b+404>>2]|0)+404>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+9|0;B=A;a[B]=p;i=d;return}if((a[(c[b+408>>2]|0)+9|0]|0)==0|m<<24>>24==0){break}else{p=1}q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+9|0;B=A;a[B]=p;i=d;return}}while(0);if(!((e|0)!=-1|n<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+9|0;B=A;a[B]=p;i=d;return}p=o<<24>>24!=0|0;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+9|0;B=A;a[B]=p;i=d;return}function Rp(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[b+404>>2]|0)+404>>2]|0;f=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((e|0)==1){g=0}else{if((a[f+9|0]|0)!=0|(e|0)==-1){g=0;break}g=(a[f+8|0]|0)==0|0}}while(0);a[f+7|0]=g;i=d;return}function Sp(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+99648>>3];h[c[b+8>>2]>>3]=+h[d+99624>>3];h[c[b+12>>2]>>3]=+h[d+99632>>3];i=i;return}function Tp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0;f=i;g=b;j=b+4|0;h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+7112>>3]=+h[d>>3];Pp(g);Qp(g);Rp(g);g=c[c[j>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+8768>>3];d=c[g+16>>2]|0;if((a[d+7|0]|0)!=0){l=0.0;m=k-l;h[e>>3]=m;i=f;return}if((a[d+9|0]|0)!=0){l=+h[j+7112>>3]- +h[j+9464>>3];m=k-l;h[e>>3]=m;i=f;return}if((a[d+8|0]|0)!=0){l=+h[j+7112>>3]+ +h[j+9464>>3];m=k-l;h[e>>3]=m;i=f;return}n=+h[j+7112>>3];o=+h[j+9464>>3];if((c[(c[b+404>>2]|0)+404>>2]|0)==1){l=n-o;m=k-l;h[e>>3]=m;i=f;return}else{l=n+o;m=k-l;h[e>>3]=m;i=f;return}}function Up(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[k+7504>>3],-+h[k+9544>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[j+7504>>3],-+h[j+9544>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=l;f=l;break}}else{if(g){g=a[c[b+356>>2]|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[l+7504>>3],-+h[l+9544>>3])|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[g+7504>>3],-+h[g+9544>>3])|0;a[c[b+352>>2]|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+1|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+1|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[l+7504>>3],-+h[l+10216>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[g+7504>>3],-+h[g+10216>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+1|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[k+7504>>3],-+h[k+10216>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[j+7504>>3],-+h[j+10216>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=a[(c[b+356>>2]|0)+2|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+2|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],-+h[(c[b+416>>2]|0)+10784>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=k;n=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],-+h[(c[b+416>>2]|0)+10784>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=j;n=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+2|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],-+h[(c[b+416>>2]|0)+10784>>3])|0;a[(c[b+352>>2]|0)+2|0]=j;n=g;break}else{g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],-+h[(c[b+416>>2]|0)+10784>>3])|0;a[(c[b+352>>2]|0)+2|0]=g;n=g;break}}}}while(0);do{if((a[e]|0)==0){o=a[(c[b+356>>2]|0)+3|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+3|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;o=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=j;o=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+3|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=j;o=g;break}else{g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=g;o=g;break}}}}while(0);e=c[(c[b+404>>2]|0)+408>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+11|0;B=A;a[B]=p;i=d;return}if((a[(c[b+408>>2]|0)+11|0]|0)==0|m<<24>>24==0){break}else{p=1}q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+11|0;B=A;a[B]=p;i=d;return}}while(0);if(!((e|0)!=1|n<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+11|0;B=A;a[B]=p;i=d;return}p=o<<24>>24!=0|0;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+11|0;B=A;a[B]=p;i=d;return}function Vp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+4|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+4|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[k+7504>>3],+h[k+9544>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[j+7504>>3],+h[j+9544>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+4|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[l+7504>>3],+h[l+9544>>3])|0;a[(c[b+352>>2]|0)+4|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[g+7504>>3],+h[g+9544>>3])|0;a[(c[b+352>>2]|0)+4|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+5|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+5|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[l+7504>>3],+h[l+10216>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[g+7504>>3],+h[g+10216>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+5|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[k+7504>>3],+h[k+10216>>3])|0;a[(c[b+352>>2]|0)+5|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[j+7504>>3],+h[j+10216>>3])|0;a[(c[b+352>>2]|0)+5|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=a[(c[b+356>>2]|0)+6|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+6|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],+h[(c[b+416>>2]|0)+10784>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;n=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],+h[(c[b+416>>2]|0)+10784>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=j;n=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+6|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],+h[(c[b+416>>2]|0)+10784>>3])|0;a[(c[b+352>>2]|0)+6|0]=j;n=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],+h[(c[b+416>>2]|0)+10784>>3])|0;a[(c[b+352>>2]|0)+6|0]=g;n=g;break}}}}while(0);do{if((a[e]|0)==0){o=a[(c[b+356>>2]|0)+7|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+7|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=k;o=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=j;o=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+7|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;a[(c[b+352>>2]|0)+7|0]=j;o=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;a[(c[b+352>>2]|0)+7|0]=g;o=g;break}}}}while(0);e=c[(c[b+404>>2]|0)+408>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+12|0;B=A;a[B]=p;i=d;return}if((a[(c[b+408>>2]|0)+12|0]|0)==0|m<<24>>24==0){break}else{p=1}q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+12|0;B=A;a[B]=p;i=d;return}}while(0);if(!((e|0)!=-1|n<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+12|0;B=A;a[B]=p;i=d;return}p=o<<24>>24!=0|0;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+12|0;B=A;a[B]=p;i=d;return}function Wp(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[b+404>>2]|0)+408>>2]|0;f=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((e|0)==1){g=0}else{if((a[f+12|0]|0)!=0|(e|0)==-1){g=0;break}g=(a[f+11|0]|0)==0|0}}while(0);a[f+10|0]=g;i=d;return}function Xp(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+105136>>3];h[c[b+8>>2]>>3]=+h[d+105112>>3];h[c[b+12>>2]>>3]=+h[d+105120>>3];i=i;return}function Yp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0;f=i;g=b;j=b+4|0;h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+7504>>3]=+h[d>>3];Up(g);Vp(g);Wp(g);g=c[c[j>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7512>>3];d=c[g+16>>2]|0;if((a[d+10|0]|0)!=0){l=0.0;m=k-l;h[e>>3]=m;i=f;return}if((a[d+12|0]|0)!=0){l=+h[j+7504>>3]- +h[j+9544>>3];m=k-l;h[e>>3]=m;i=f;return}if((a[d+11|0]|0)!=0){l=+h[j+7504>>3]+ +h[j+9544>>3];m=k-l;h[e>>3]=m;i=f;return}n=+h[j+7504>>3];o=+h[j+9544>>3];if((c[(c[b+404>>2]|0)+408>>2]|0)==1){l=n-o;m=k-l;h[e>>3]=m;i=f;return}else{l=n+o;m=k-l;h[e>>3]=m;i=f;return}}function Zp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+8|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+8|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[k+7912>>3],-+h[k+9624>>3],a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=_Pa(+h[j+7912>>3],-+h[j+9624>>3],a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+8|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[l+7912>>3],-+h[l+9624>>3])|0;a[(c[b+352>>2]|0)+8|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=cQa(+h[g+7912>>3],-+h[g+9624>>3])|0;a[(c[b+352>>2]|0)+8|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+9|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+9|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[l+7912>>3],-+h[l+10072>>3],a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=_Pa(+h[g+7912>>3],-+h[g+10072>>3],a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+9|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[k+7912>>3],-+h[k+10072>>3])|0;a[(c[b+352>>2]|0)+9|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=cQa(+h[j+7912>>3],-+h[j+10072>>3])|0;a[(c[b+352>>2]|0)+9|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=a[(c[b+356>>2]|0)+10|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+10|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],-+h[(c[b+416>>2]|0)+10096>>3],a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=k;n=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],-+h[(c[b+416>>2]|0)+10096>>3],a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=j;n=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+10|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],-+h[(c[b+416>>2]|0)+10096>>3])|0;a[(c[b+352>>2]|0)+10|0]=j;n=g;break}else{g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],-+h[(c[b+416>>2]|0)+10096>>3])|0;a[(c[b+352>>2]|0)+10|0]=g;n=g;break}}}}while(0);do{if((a[e]|0)==0){o=a[(c[b+356>>2]|0)+11|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+11|0]|0;k=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=k;o=j;break}else{j=_Pa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=j;o=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+11|0]|0;j=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0;a[(c[b+352>>2]|0)+11|0]=j;o=g;break}else{g=cQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0;a[(c[b+352>>2]|0)+11|0]=g;o=g;break}}}}while(0);e=c[(c[b+404>>2]|0)+412>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+14|0;B=A;a[B]=p;i=d;return}if((a[(c[b+408>>2]|0)+14|0]|0)==0|m<<24>>24==0){break}else{p=1}q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+14|0;B=A;a[B]=p;i=d;return}}while(0);if(!((e|0)!=1|n<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+14|0;B=A;a[B]=p;i=d;return}p=o<<24>>24!=0|0;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+14|0;B=A;a[B]=p;i=d;return}function _p(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+12|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+12|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[k+7912>>3],+h[k+9624>>3],a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=aQa(+h[j+7912>>3],+h[j+9624>>3],a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+12|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[l+7912>>3],+h[l+9624>>3])|0;a[(c[b+352>>2]|0)+12|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=eQa(+h[g+7912>>3],+h[g+9624>>3])|0;a[(c[b+352>>2]|0)+12|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+13|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+13|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[l+7912>>3],+h[l+10072>>3],a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=aQa(+h[g+7912>>3],+h[g+10072>>3],a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+13|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[k+7912>>3],+h[k+10072>>3])|0;a[(c[b+352>>2]|0)+13|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=eQa(+h[j+7912>>3],+h[j+10072>>3])|0;a[(c[b+352>>2]|0)+13|0]=g;m=g;break}}}}while(0);do{if((a[e]|0)==0){n=a[(c[b+356>>2]|0)+14|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+14|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],+h[(c[b+416>>2]|0)+10096>>3],a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=k;n=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],+h[(c[b+416>>2]|0)+10096>>3],a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=j;n=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+14|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],+h[(c[b+416>>2]|0)+10096>>3])|0;a[(c[b+352>>2]|0)+14|0]=j;n=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],+h[(c[b+416>>2]|0)+10096>>3])|0;a[(c[b+352>>2]|0)+14|0]=g;n=g;break}}}}while(0);do{if((a[e]|0)==0){o=a[(c[b+356>>2]|0)+15|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+15|0]|0;k=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=k;o=j;break}else{j=aQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=j;o=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+15|0]|0;j=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0;a[(c[b+352>>2]|0)+15|0]=j;o=g;break}else{g=eQa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0;a[(c[b+352>>2]|0)+15|0]=g;o=g;break}}}}while(0);e=c[(c[b+404>>2]|0)+412>>2]|0;do{if((e|0)==0){if(!(f<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+15|0;B=A;a[B]=p;i=d;return}if((a[(c[b+408>>2]|0)+15|0]|0)==0|m<<24>>24==0){break}else{p=1}q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+15|0;B=A;a[B]=p;i=d;return}}while(0);if(!((e|0)!=-1|n<<24>>24==0)){p=1;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+15|0;B=A;a[B]=p;i=d;return}p=o<<24>>24!=0|0;q=b;r=q+4|0;s=r;t=c[s>>2]|0;u=c[t>>2]|0;v=u;w=v+16|0;x=w;y=c[x>>2]|0;z=y;A=z+15|0;B=A;a[B]=p;i=d;return}function $p(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[b+404>>2]|0)+412>>2]|0;f=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((e|0)==1){g=0}else{if((a[f+15|0]|0)!=0|(e|0)==-1){g=0;break}g=(a[f+14|0]|0)==0|0}}while(0);a[f+13|0]=g;i=d;return}function aq(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+110848>>3];h[c[b+8>>2]>>3]=+h[d+110824>>3];h[c[b+12>>2]>>3]=+h[d+110832>>3];i=i;return}function bq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0;f=i;g=b;j=b+4|0;h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+7912>>3]=+h[d>>3];Zp(g);_p(g);$p(g);g=c[c[j>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7920>>3];d=c[g+16>>2]|0;if((a[d+13|0]|0)!=0){l=0.0;m=k-l;h[e>>3]=m;i=f;return}if((a[d+15|0]|0)!=0){l=+h[j+7912>>3]- +h[j+9624>>3];m=k-l;h[e>>3]=m;i=f;return}if((a[d+14|0]|0)!=0){l=+h[j+7912>>3]+ +h[j+9624>>3];m=k-l;h[e>>3]=m;i=f;return}n=+h[j+7912>>3];o=+h[j+9624>>3];if((c[(c[b+404>>2]|0)+412>>2]|0)==1){l=n-o;m=k-l;h[e>>3]=m;i=f;return}else{l=n+o;m=k-l;h[e>>3]=m;i=f;return}}



function p5(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;wu(b);xu(b);yu(b);zu(b);Au(b);Bu(b);Cu(b);Du(b);Eu(b);Fu(b);Gu(b);Hu(b);Iu(b);Ju(b);Ku(b);Lu(b);Mu(b);Nu(b);Ou(b);Pu(b);Qu(b);Ru(b);Su(b);Tu(b);Uu(b);Vu(b);Wu(b);Xu(b);Yu(b);Zu(b);_u(b);$u(b);av(b);bv(b);cv(b);dv(b);ev(b);fv(b);gv(b);hv(b);iv(b);jv(b);kv(b);lv(b);mv(b);nv(b);ov(b);pv(b);qv(b);rv(b);sv(b);tv(b);uv(b);vv(b);wv(b);xv(b);yv(b);zv(b);Av(b);Bv(b);Cv(b);Dv(b);Ev(b);Fv(b);Gv(b);Hv(b);Iv(b);Jv(b);Kv(b);Lv(b);Mv(b);Nv(b);Ov(b);Pv(b);Qv(b);Rv(b);Sv(b);Tv(b);Uv(b);Vv(b);Wv(b);Xv(b);Yv(b);Zv(b);_v(b);$v(b);aw(b);bw(b);cw(b);dw(b);ew(b);fw(b);gw(b);hw(b);iw(b);jw(b);kw(b);lw(b);mw(b);nw(b);ow(b);pw(b);qw(b);rw(b);sw(b);tw(b);uw(b);vw(b);ww(b);xw(b);yw(b);zw(b);Aw(b);Bw(b);Cw(b);Dw(b);Ew(b);Fw(b);Gw(b);Hw(b);Iw(b);Jw(b);Kw(b);Lw(b);Mw(b);Nw(b);Ow(b);Pw(b);Qw(b);Rw(b);Sw(b);Tw(b);Uw(b);Vw(b);Ww(b);Xw(b);Yw(b);Zw(b);_w(b);$w(b);ax(b);bx(b);cx(b);dx(b);ex(b);fx(b);gx(b);hx(b);ix(b);jx(b);kx(b);lx(b);mx(b);nx(b);ox(b);px(b);qx(b);rx(b);sx(b);tx(b);ux(b);vx(b);wx(b);xx(b);yx(b);zx(b);Ax(b);Bx(b);Cx(b);Dx(b);Ex(b);Fx(b);Gx(b);Hx(b);Ix(b);Jx(b);Kx(b);Lx(b);Mx(b);Nx(b);Ox(b);Px(b);Qx(b);Rx(b);Sx(b);Tx(b);Ux(b);Vx(b);Wx(b);Xx(b);Yx(b);Zx(b);_x(b);$x(b);ay(b);by(b);cy(b);dy(b);ey(b);fy(b);gy(b);hy(b);iy(b);jy(b);ky(b);ly(b);my(b);ny(b);oy(b);py(b);qy(b);ry(b);sy(b);ty(b);uy(b);vy(b);wy(b);xy(b);yy(b);zy(b);Ay(b);By(b);Cy(b);Dy(b);Ey(b);Fy(b);Gy(b);Hy(b);Iy(b);Jy(b);Ky(b);Ly(b);My(b);Ny(b);Oy(b);Py(b);Qy(b);Ry(b);Sy(b);Ty(b);Uy(b);Vy(b);Wy(b);Xy(b);Yy(b);Zy(b);_y(b);$y(b);az(b);bz(b);cz(b);dz(b);ez(b);fz(b);gz(b);hz(b);iz(b);jz(b);kz(b);lz(b);mz(b);nz(b);oz(b);pz(b);qz(b);rz(b);sz(b);tz(b);uz(b);vz(b);wz(b);xz(b);yz(b);zz(b);Az(b);Bz(b);Cz(b);Dz(b);Ez(b);Fz(b);Gz(b);Hz(b);Iz(b);Jz(b);Kz(b);Lz(b);Mz(b);Nz(b);Oz(b);Pz(b);Qz(b);Rz(b);Sz(b);Tz(b);Uz(b);Vz(b);Wz(b);Xz(b);Yz(b);Zz(b);_z(b);$z(b);aA(b);bA(b);cA(b);dA(b);eA(b);fA(b);gA(b);hA(b);iA(b);jA(b);kA(b);lA(b);mA(b);nA(b);oA(b);pA(b);qA(b);rA(b);sA(b);tA(b);uA(b);vA(b);wA(b);xA(b);yA(b);zA(b);AA(b);BA(b);CA(b);DA(b);EA(b);FA(b);GA(b);HA(b);IA(b);JA(b);KA(b);LA(b);MA(b);NA(b);OA(b);PA(b);QA(b);RA(b);SA(b);TA(b);UA(b);VA(b);WA(b);XA(b);YA(b);ZA(b);_A(b);$A(b);aB(b);bB(b);cB(b);dB(b);eB(b);fB(b);gB(b);hB(b);iB(b);jB(b);kB(b);lB(b);mB(b);nB(b);oB(b);pB(b);qB(b);rB(b);sB(b);tB(b);uB(b);vB(b);wB(b);xB(b);yB(b);zB(b);AB(b);BB(b);CB(b);DB(b);EB(b);FB(b);GB(b);HB(b);IB(b);JB(b);KB(b);LB(b);MB(b);NB(b);OB(b);PB(b);QB(b);RB(b);SB(b);TB(b);UB(b);VB(b);WB(b);XB(b);YB(b);ZB(b);_B(b);$B(b);aC(b);bC(b);cC(b);dC(b);eC(b);fC(b);gC(b);hC(b);iC(b);jC(b);kC(b);lC(b);mC(b);nC(b);oC(b);pC(b);qC(b);rC(b);sC(b);tC(b);uC(b);vC(b);wC(b);xC(b);yC(b);zC(b);AC(b);BC(b);CC(b);DC(b);EC(b);FC(b);GC(b);HC(b);IC(b);JC(b);KC(b);LC(b);MC(b);NC(b);OC(b);PC(b);QC(b);RC(b);SC(b);TC(b);UC(b);VC(b);WC(b);XC(b);YC(b);ZC(b);_C(b);$C(b);aD(b);bD(b);cD(b);dD(b);eD(b);fD(b);gD(b);hD(b);iD(b);jD(b);kD(b);lD(b);mD(b);nD(b);oD(b);pD(b);qD(b);rD(b);sD(b);tD(b);uD(b);vD(b);wD(b);xD(b);yD(b);zD(b);AD(b);BD(b);CD(b);DD(b);ED(b);FD(b);GD(b);HD(b);ID(b);JD(b);KD(b);LD(b);MD(b);ND(b);OD(b);PD(b);QD(b);RD(b);SD(b);TD(b);UD(b);VD(b);WD(b);XD(b);YD(b);ZD(b);_D(b);$D(b);aE(b);bE(b);cE(b);dE(b);eE(b);fE(b);gE(b);hE(b);iE(b);jE(b);kE(b);lE(b);mE(b);nE(b);oE(b);pE(b);qE(b);rE(b);sE(b);tE(b);uE(b);vE(b);wE(b);xE(b);yE(b);zE(b);AE(b);BE(b);CE(b);DE(b);EE(b);FE(b);GE(b);HE(b);IE(b);JE(b);KE(b);LE(b);ME(b);NE(b);OE(b);PE(b);QE(b);RE(b);SE(b);TE(b);UE(b);VE(b);WE(b);XE(b);YE(b);ZE(b);_E(b);$E(b);aF(b);bF(b);cF(b);dF(b);eF(b);fF(b);gF(b);hF(b);iF(b);jF(b);kF(b);lF(b);mF(b);nF(b);oF(b);pF(b);qF(b);rF(b);sF(b);tF(b);uF(b);vF(b);wF(b);xF(b);yF(b);zF(b);AF(b);BF(b);CF(b);DF(b);EF(b);FF(b);GF(b);HF(b);IF(b);JF(b);KF(b);LF(b);MF(b);NF(b);OF(b);PF(b);QF(b);RF(b);SF(b);TF(b);UF(b);VF(b);WF(b);XF(b);YF(b);ZF(b);_F(b);$F(b);aG(b);bG(b);cG(b);dG(b);eG(b);fG(b);gG(b);hG(b);iG(b);jG(b);kG(b);lG(b);mG(b);nG(b);oG(b);pG(b);qG(b);rG(b);sG(b);tG(b);uG(b);vG(b);wG(b);xG(b);yG(b);zG(b);AG(b);BG(b);CG(b);DG(b);EG(b);FG(b);GG(b);HG(b);IG(b);JG(b);KG(b);LG(b);MG(b);NG(b);OG(b);PG(b);QG(b);RG(b);SG(b);TG(b);UG(b);VG(b);WG(b);XG(b);YG(b);ZG(b);_G(b);$G(b);aH(b);bH(b);cH(b);dH(b);eH(b);fH(b);gH(b);hH(b);iH(b);jH(b);kH(b);lH(b);mH(b);nH(b);oH(b);pH(b);qH(b);rH(b);sH(b);tH(b);uH(b);vH(b);wH(b);xH(b);yH(b);zH(b);AH(b);BH(b);CH(b);DH(b);EH(b);FH(b);GH(b);HH(b);IH(b);JH(b);KH(b);LH(b);MH(b);NH(b);OH(b);PH(b);QH(b);RH(b);SH(b);TH(b);UH(b);VH(b);WH(b);XH(b);YH(b);ZH(b);_H(b);$H(b);aI(b);bI(b);cI(b);dI(b);eI(b);fI(b);gI(b);hI(b);iI(b);jI(b);kI(b);lI(b);mI(b);nI(b);oI(b);pI(b);qI(b);rI(b);sI(b);tI(b);uI(b);vI(b);wI(b);xI(b);yI(b);zI(b);AI(b);BI(b);CI(b);DI(b);EI(b);FI(b);GI(b);HI(b);II(b);JI(b);KI(b);LI(b);MI(b);NI(b);OI(b);PI(b);QI(b);RI(b);SI(b);TI(b);UI(b);VI(b);WI(b);XI(b);YI(b);ZI(b);_I(b);$I(b);aJ(b);bJ(b);cJ(b);dJ(b);eJ(b);fJ(b);gJ(b);hJ(b);iJ(b);jJ(b);kJ(b);lJ(b);mJ(b);nJ(b);oJ(b);pJ(b);qJ(b);rJ(b);sJ(b);tJ(b);uJ(b);vJ(b);wJ(b);xJ(b);yJ(b);zJ(b);AJ(b);BJ(b);CJ(b);DJ(b);EJ(b);FJ(b);GJ(b);HJ(b);IJ(b);JJ(b);KJ(b);LJ(b);MJ(b);NJ(b);OJ(b);PJ(b);QJ(b);RJ(b);SJ(b);TJ(b);UJ(b);VJ(b);WJ(b);XJ(b);YJ(b);ZJ(b);_J(b);$J(b);aK(b);bK(b);cK(b);dK(b);eK(b);fK(b);gK(b);hK(b);iK(b);jK(b);kK(b);lK(b);mK(b);nK(b);oK(b);pK(b);qK(b);rK(b);sK(b);tK(b);uK(b);vK(b);wK(b);xK(b);yK(b);zK(b);AK(b);BK(b);CK(b);DK(b);EK(b);FK(b);GK(b);HK(b);IK(b);JK(b);KK(b);LK(b);MK(b);NK(b);OK(b);PK(b);QK(b);RK(b);SK(b);TK(b);UK(b);VK(b);WK(b);XK(b);YK(b);ZK(b);_K(b);$K(b);aL(b);bL(b);cL(b);dL(b);eL(b);fL(b);gL(b);hL(b);iL(b);jL(b);kL(b);lL(b);mL(b);nL(b);oL(b);pL(b);qL(b);rL(b);sL(b);tL(b);uL(b);vL(b);wL(b);xL(b);yL(b);zL(b);AL(b);BL(b);CL(b);DL(b);EL(b);FL(b);GL(b);HL(b);IL(b);JL(b);KL(b);LL(b);ML(b);NL(b);OL(b);PL(b);QL(b);RL(b);SL(b);TL(b);UL(b);VL(b);WL(b);XL(b);YL(b);ZL(b);_L(b);$L(b);aM(b);bM(b);cM(b);dM(b);eM(b);fM(b);gM(b);hM(b);iM(b);jM(b);kM(b);lM(b);mM(b);nM(b);oM(b);pM(b);qM(b);rM(b);sM(b);tM(b);uM(b);vM(b);wM(b);xM(b);yM(b);zM(b);AM(b);BM(b);CM(b);DM(b);EM(b);FM(b);GM(b);HM(b);IM(b);JM(b);KM(b);LM(b);MM(b);NM(b);OM(b);PM(b);QM(b);RM(b);SM(b);TM(b);UM(b);VM(b);WM(b);XM(b);YM(b);ZM(b);_M(b);$M(b);aN(b);bN(b);cN(b);dN(b);eN(b);fN(b);gN(b);hN(b);iN(b);jN(b);kN(b);lN(b);mN(b);nN(b);oN(b);pN(b);qN(b);rN(b);sN(b);tN(b);uN(b);vN(b);wN(b);xN(b);yN(b);zN(b);AN(b);BN(b);CN(b);DN(b);EN(b);FN(b);GN(b);HN(b);IN(b);JN(b);KN(b);LN(b);MN(b);NN(b);ON(b);PN(b);QN(b);RN(b);SN(b);TN(b);UN(b);VN(b);WN(b);XN(b);YN(b);ZN(b);_N(b);$N(b);aO(b);bO(b);cO(b);dO(b);eO(b);fO(b);gO(b);hO(b);iO(b);jO(b);kO(b);lO(b);mO(b);nO(b);oO(b);pO(b);qO(b);rO(b);sO(b);tO(b);uO(b);vO(b);wO(b);xO(b);yO(b);zO(b);AO(b);BO(b);CO(b);DO(b);EO(b);FO(b);GO(b);HO(b);IO(b);JO(b);KO(b);LO(b);MO(b);NO(b);OO(b);PO(b);QO(b);RO(b);SO(b);TO(b);UO(b);VO(b);WO(b);XO(b);YO(b);ZO(b);_O(b);$O(b);aP(b);bP(b);cP(b);dP(b);eP(b);fP(b);gP(b);hP(b);iP(b);jP(b);kP(b);lP(b);mP(b);nP(b);oP(b);pP(b);qP(b);rP(b);sP(b);tP(b);uP(b);vP(b);wP(b);xP(b);yP(b);zP(b);AP(b);BP(b);CP(b);DP(b);EP(b);FP(b);GP(b);HP(b);IP(b);JP(b);KP(b);LP(b);MP(b);NP(b);OP(b);PP(b);QP(b);RP(b);SP(b);TP(b);UP(b);VP(b);WP(b);XP(b);YP(b);ZP(b);_P(b);$P(b);aQ(b);bQ(b);cQ(b);dQ(b);eQ(b);fQ(b);gQ(b);hQ(b);iQ(b);jQ(b);kQ(b);lQ(b);mQ(b);nQ(b);oQ(b);pQ(b);qQ(b);rQ(b);sQ(b);tQ(b);uQ(b);vQ(b);wQ(b);xQ(b);yQ(b);zQ(b);AQ(b);BQ(b);CQ(b);DQ(b);EQ(b);FQ(b);GQ(b);HQ(b);IQ(b);JQ(b);KQ(b);LQ(b);MQ(b);NQ(b);OQ(b);PQ(b);QQ(b);RQ(b);SQ(b);TQ(b);UQ(b);VQ(b);WQ(b);XQ(b);YQ(b);ZQ(b);_Q(b);$Q(b);aR(b);bR(b);cR(b);dR(b);eR(b);fR(b);gR(b);hR(b);iR(b);jR(b);kR(b);lR(b);mR(b);nR(b);oR(b);pR(b);qR(b);rR(b);sR(b);tR(b);uR(b);vR(b);wR(b);xR(b);yR(b);zR(b);AR(b);BR(b);CR(b);DR(b);ER(b);FR(b);GR(b);HR(b);IR(b);JR(b);KR(b);LR(b);MR(b);NR(b);OR(b);PR(b);QR(b);RR(b);SR(b);TR(b);UR(b);VR(b);WR(b);XR(b);YR(b);ZR(b);_R(b);$R(b);aS(b);bS(b);cS(b);dS(b);eS(b);fS(b);gS(b);hS(b);iS(b);jS(b);kS(b);lS(b);mS(b);nS(b);oS(b);pS(b);qS(b);rS(b);sS(b);tS(b);uS(b);vS(b);wS(b);xS(b);yS(b);zS(b);AS(b);BS(b);CS(b);DS(b);ES(b);FS(b);GS(b);HS(b);IS(b);JS(b);KS(b);LS(b);MS(b);NS(b);OS(b);PS(b);QS(b);RS(b);SS(b);TS(b);US(b);VS(b);WS(b);XS(b);YS(b);ZS(b);_S(b);$S(b);aT(b);bT(b);cT(b);dT(b);eT(b);fT(b);gT(b);hT(b);iT(b);jT(b);kT(b);lT(b);mT(b);nT(b);oT(b);pT(b);qT(b);rT(b);sT(b);tT(b);uT(b);vT(b);wT(b);xT(b);yT(b);zT(b);AT(b);BT(b);CT(b);DT(b);ET(b);FT(b);GT(b);HT(b);IT(b);JT(b);KT(b);LT(b);MT(b);NT(b);OT(b);PT(b);QT(b);RT(b);ST(b);TT(b);UT(b);VT(b);WT(b);XT(b);YT(b);ZT(b);_T(b);$T(b);aU(b);bU(b);cU(b);dU(b);eU(b);fU(b);gU(b);hU(b);iU(b);jU(b);kU(b);lU(b);mU(b);nU(b);oU(b);pU(b);qU(b);rU(b);sU(b);tU(b);uU(b);vU(b);wU(b);xU(b);yU(b);zU(b);AU(b);BU(b);CU(b);DU(b);EU(b);FU(b);GU(b);HU(b);IU(b);JU(b);KU(b);LU(b);MU(b);NU(b);OU(b);PU(b);QU(b);RU(b);SU(b);TU(b);UU(b);VU(b);WU(b);XU(b);YU(b);ZU(b);_U(b);$U(b);aV(b);bV(b);cV(b);dV(b);eV(b);fV(b);gV(b);hV(b);iV(b);jV(b);kV(b);lV(b);mV(b);nV(b);oV(b);pV(b);qV(b);rV(b);sV(b);tV(b);uV(b);vV(b);wV(b);xV(b);yV(b);zV(b);AV(b);BV(b);CV(b);DV(b);EV(b);FV(b);GV(b);HV(b);IV(b);JV(b);KV(b);LV(b);MV(b);NV(b);OV(b);PV(b);QV(b);RV(b);SV(b);TV(b);UV(b);VV(b);WV(b);XV(b);YV(b);ZV(b);_V(b);$V(b);aW(b);bW(b);cW(b);dW(b);eW(b);fW(b);gW(b);hW(b);iW(b);jW(b);kW(b);lW(b);mW(b);nW(b);oW(b);pW(b);qW(b);rW(b);sW(b);tW(b);uW(b);vW(b);wW(b);xW(b);yW(b);zW(b);AW(b);BW(b);CW(b);DW(b);EW(b);FW(b);GW(b);HW(b);IW(b);JW(b);KW(b);LW(b);MW(b);NW(b);OW(b);PW(b);QW(b);RW(b);SW(b);TW(b);UW(b);VW(b);WW(b);XW(b);YW(b);ZW(b);_W(b);$W(b);aX(b);bX(b);cX(b);dX(b);eX(b);fX(b);gX(b);hX(b);iX(b);jX(b);kX(b);lX(b);mX(b);nX(b);oX(b);pX(b);qX(b);rX(b);sX(b);tX(b);uX(b);vX(b);wX(b);xX(b);yX(b);zX(b);AX(b);BX(b);CX(b);DX(b);EX(b);FX(b);GX(b);HX(b);IX(b);JX(b);KX(b);LX(b);MX(b);NX(b);OX(b);PX(b);QX(b);RX(b);SX(b);TX(b);UX(b);VX(b);WX(b);XX(b);YX(b);ZX(b);_X(b);$X(b);aY(b);bY(b);cY(b);dY(b);eY(b);fY(b);gY(b);hY(b);iY(b);jY(b);kY(b);lY(b);mY(b);nY(b);oY(b);pY(b);qY(b);rY(b);sY(b);tY(b);uY(b);vY(b);wY(b);xY(b);yY(b);zY(b);AY(b);BY(b);CY(b);DY(b);EY(b);FY(b);GY(b);HY(b);IY(b);JY(b);KY(b);LY(b);MY(b);NY(b);OY(b);PY(b);QY(b);RY(b);SY(b);TY(b);UY(b);VY(b);WY(b);XY(b);YY(b);ZY(b);_Y(b);$Y(b);aZ(b);bZ(b);cZ(b);dZ(b);eZ(b);fZ(b);gZ(b);hZ(b);iZ(b);jZ(b);kZ(b);lZ(b);mZ(b);nZ(b);oZ(b);pZ(b);qZ(b);rZ(b);sZ(b);tZ(b);uZ(b);vZ(b);wZ(b);xZ(b);yZ(b);zZ(b);AZ(b);BZ(b);CZ(b);DZ(b);EZ(b);FZ(b);GZ(b);HZ(b);IZ(b);JZ(b);KZ(b);LZ(b);MZ(b);NZ(b);OZ(b);PZ(b);QZ(b);RZ(b);SZ(b);TZ(b);UZ(b);VZ(b);WZ(b);XZ(b);YZ(b);ZZ(b);_Z(b);$Z(b);a_(b);b_(b);c_(b);d_(b);e_(b);f_(b);g_(b);h_(b);i_(b);j_(b);k_(b);l_(b);m_(b);n_(b);o_(b);p_(b);q_(b);r_(b);s_(b);t_(b);u_(b);v_(b);w_(b);x_(b);y_(b);z_(b);A_(b);B_(b);C_(b);D_(b);E_(b);F_(b);G_(b);H_(b);I_(b);J_(b);K_(b);L_(b);M_(b);N_(b);O_(b);P_(b);Q_(b);R_(b);S_(b);T_(b);U_(b);V_(b);W_(b);X_(b);Y_(b);Z_(b);__(b);$_(b);a$(b);b$(b);c$(b);d$(b);e$(b);f$(b);g$(b);h$(b);i$(b);j$(b);k$(b);l$(b);m$(b);n$(b);o$(b);p$(b);q$(b);r$(b);s$(b);t$(b);u$(b);v$(b);w$(b);x$(b);y$(b);z$(b);A$(b);B$(b);C$(b);D$(b);E$(b);F$(b);G$(b);H$(b);I$(b);J$(b);K$(b);L$(b);M$(b);N$(b);O$(b);P$(b);Q$(b);R$(b);S$(b);T$(b);U$(b);V$(b);W$(b);X$(b);Y$(b);Z$(b);_$(b);$$(b);a0(b);b0(b);c0(b);d0(b);e0(b);f0(b);g0(b);h0(b);i0(b);j0(b);k0(b);l0(b);m0(b);n0(b);o0(b);p0(b);q0(b);r0(b);s0(b);t0(b);u0(b);v0(b);w0(b);x0(b);y0(b);z0(b);A0(b);B0(b);C0(b);D0(b);E0(b);F0(b);G0(b);H0(b);I0(b);J0(b);K0(b);L0(b);M0(b);N0(b);O0(b);P0(b);Q0(b);R0(b);S0(b);T0(b);U0(b);V0(b);W0(b);X0(b);Y0(b);Z0(b);_0(b);$0(b);a1(b);b1(b);c1(b);d1(b);e1(b);f1(b);g1(b);h1(b);i1(b);j1(b);k1(b);l1(b);m1(b);n1(b);o1(b);p1(b);q1(b);r1(b);s1(b);t1(b);u1(b);v1(b);w1(b);x1(b);y1(b);z1(b);A1(b);B1(b);C1(b);D1(b);E1(b);F1(b);G1(b);H1(b);I1(b);J1(b);K1(b);L1(b);M1(b);N1(b);O1(b);P1(b);Q1(b);R1(b);S1(b);T1(b);U1(b);V1(b);W1(b);X1(b);Y1(b);Z1(b);_1(b);$1(b);a2(b);b2(b);c2(b);d2(b);e2(b);f2(b);g2(b);h2(b);i2(b);j2(b);k2(b);l2(b);m2(b);n2(b);o2(b);p2(b);q2(b);r2(b);s2(b);t2(b);u2(b);v2(b);w2(b);x2(b);y2(b);z2(b);A2(b);B2(b);C2(b);D2(b);E2(b);F2(b);G2(b);H2(b);I2(b);J2(b);K2(b);L2(b);M2(b);N2(b);O2(b);P2(b);Q2(b);R2(b);S2(b);T2(b);U2(b);V2(b);W2(b);X2(b);Y2(b);Z2(b);_2(b);$2(b);a3(b);b3(b);c3(b);d3(b);e3(b);f3(b);g3(b);h3(b);i3(b);j3(b);k3(b);l3(b);m3(b);n3(b);o3(b);p3(b);q3(b);r3(b);s3(b);t3(b);u3(b);v3(b);w3(b);x3(b);y3(b);z3(b);A3(b);B3(b);C3(b);D3(b);E3(b);F3(b);G3(b);H3(b);I3(b);J3(b);K3(b);L3(b);M3(b);N3(b);O3(b);P3(b);Q3(b);R3(b);S3(b);T3(b);U3(b);V3(b);W3(b);X3(b);Y3(b);Z3(b);_3(b);$3(b);a4(b);b4(b);c4(b);d4(b);e4(b);f4(b);g4(b);h4(b);i4(b);j4(b);k4(b);l4(b);m4(b);n4(b);o4(b);p4(b);q4(b);r4(b);s4(b);t4(b);u4(b);v4(b);w4(b);x4(b);y4(b);z4(b);A4(b);B4(b);C4(b);D4(b);E4(b);F4(b);G4(b);H4(b);I4(b);J4(b);K4(b);L4(b);M4(b);N4(b);O4(b);P4(b);Q4(b);R4(b);S4(b);T4(b);U4(b);V4(b);W4(b);X4(b);Y4(b);Z4(b);_4(b);$4(b);a5(b);b5(b);c5(b);d5(b);e5(b);f5(b);g5(b);h5(b);i5(b);j5(b);k5(b);l5(b);m5(b);n5(b);o5(b);a[d]=0;i=c;return 0}function q5(a){a=a|0;i=i;return}function r5(a){a=a|0;i=i;return 0}function s5(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=+h[(c[a+416>>2]|0)+12584>>3];i=i;return}function t5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+32>>3]=+h[(c[a+416>>2]|0)+11960>>3];i=i;return}function u5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+64>>3]=+h[(c[a+416>>2]|0)+11336>>3];i=i;return}function v5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+120>>3]=+h[(c[a+416>>2]|0)+10664>>3];i=i;return}function w5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+168>>3]=+h[(c[a+416>>2]|0)+9976>>3];i=i;return}function x5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+216>>3]=+h[(c[a+416>>2]|0)+9288>>3];i=i;return}function y5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+632>>3]=+h[(c[a+416>>2]|0)+4648>>3];i=i;return}function z5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+624>>3]=+h[(c[a+416>>2]|0)+4640>>3];i=i;return}function A5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+616>>3]=+h[(c[a+416>>2]|0)+4632>>3];i=i;return}function B5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+752>>3]=+h[(c[a+416>>2]|0)+5256>>3];i=i;return}function C5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+744>>3]=+h[(c[a+416>>2]|0)+5248>>3];i=i;return}function D5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+736>>3]=+h[(c[a+416>>2]|0)+5240>>3];i=i;return}function E5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1040>>3]=+h[(c[a+416>>2]|0)+4016>>3];i=i;return}function F5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1032>>3]=+h[(c[a+416>>2]|0)+4008>>3];i=i;return}function G5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1024>>3]=+h[(c[a+416>>2]|0)+4e3>>3];i=i;return}function H5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1064>>3]=+h[(c[a+416>>2]|0)+3992>>3];i=i;return}function I5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1056>>3]=+h[(c[a+416>>2]|0)+3984>>3];i=i;return}function J5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1048>>3]=+h[(c[a+416>>2]|0)+3976>>3];i=i;return}function K5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1320>>3]=+h[(c[a+416>>2]|0)+3384>>3];i=i;return}function L5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1312>>3]=+h[(c[a+416>>2]|0)+3376>>3];i=i;return}function M5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1304>>3]=+h[(c[a+416>>2]|0)+3368>>3];i=i;return}function N5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1344>>3]=+h[(c[a+416>>2]|0)+3360>>3];i=i;return}function O5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1336>>3]=+h[(c[a+416>>2]|0)+3352>>3];i=i;return}function P5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1328>>3]=+h[(c[a+416>>2]|0)+3344>>3];i=i;return}function Q5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1600>>3]=+h[(c[a+416>>2]|0)+2752>>3];i=i;return}function R5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1592>>3]=+h[(c[a+416>>2]|0)+2744>>3];i=i;return}function S5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1584>>3]=+h[(c[a+416>>2]|0)+2736>>3];i=i;return}function T5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1624>>3]=+h[(c[a+416>>2]|0)+2728>>3];i=i;return}function U5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1616>>3]=+h[(c[a+416>>2]|0)+2720>>3];i=i;return}function V5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1608>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function W5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1840>>3]=+h[(c[a+416>>2]|0)+2120>>3];i=i;return}function X5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1848>>3]=+h[(c[a+416>>2]|0)+2112>>3];i=i;return}function Y5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1856>>3]=+h[(c[a+416>>2]|0)+2096>>3];i=i;return}function Z5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1864>>3]=+h[(c[a+416>>2]|0)+2088>>3];i=i;return}function _5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+272>>3]=+h[(c[a+416>>2]|0)+2080>>3];i=i;return}function $5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+280>>3]=+h[(c[a+416>>2]|0)+1456>>3];i=i;return}function a6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8744>>3]=+h[(c[a+416>>2]|0)+1480>>3];i=i;return}function b6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8752>>3]=+h[(c[a+416>>2]|0)+2104>>3];i=i;return}function c6(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+10752>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+104>>3]=!(b>=1.0e-15)?1.0:b;i=i;return}function d6(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+10064>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+152>>3]=!(b>=1.0e-15)?1.0:b;i=i;return}function e6(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+9376>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+200>>3]=!(b>=1.0e-15)?1.0:b;i=i;return}function f6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+8|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;SMa(9,1,19576,Y);if((c[118228>>2]|0)!=0){fe[c[29686]&511](9)}SMa(9,1,19600,X);if((c[118228>>2]|0)!=0){fe[c[29686]&511](9)}c6(a);d6(a);e6(a);SMa(9,1,19624,W);W=a+4|0;Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+104>>3];X=a+8|0;Y=c[X>>2]|0;h[Y+1536>>3]=Z;c[V>>2]=c[Y+1460>>2];Y=V+4|0;h[k>>3]=Z;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];SMa(9,0,19648,V);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+152>>3];V=c[X>>2]|0;h[V+2208>>3]=Z;c[U>>2]=c[V+2132>>2];V=U+4|0;h[k>>3]=Z;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];SMa(9,0,19648,U);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+200>>3];U=c[X>>2]|0;h[U+2880>>3]=Z;c[T>>2]=c[U+2804>>2];U=T+4|0;h[k>>3]=Z;c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];SMa(9,0,19648,T);if((c[118228>>2]|0)!=0){fe[c[29686]&511](9)}s5(a);t5(a);u5(a);v5(a);w5(a);x5(a);y5(a);z5(a);A5(a);B5(a);C5(a);D5(a);E5(a);F5(a);G5(a);H5(a);I5(a);J5(a);K5(a);L5(a);M5(a);N5(a);O5(a);P5(a);Q5(a);R5(a);S5(a);T5(a);U5(a);V5(a);W5(a);X5(a);Y5(a);Z5(a);_5(a);$5(a);a6(a);b6(a);SMa(9,1,19664,S);Z=+h[c[(c[c[W>>2]>>2]|0)+8>>2]>>3];S=c[X>>2]|0;h[S+96>>3]=Z;c[R>>2]=c[S+4>>2];S=R+4|0;h[k>>3]=Z;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];SMa(9,0,19688,R);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+32>>3];R=c[X>>2]|0;h[R+544>>3]=Z;c[Q>>2]=c[R+452>>2];R=Q+4|0;h[k>>3]=Z;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];SMa(9,0,19688,Q);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+64>>3];Q=c[X>>2]|0;h[Q+992>>3]=Z;c[P>>2]=c[Q+900>>2];Q=P+4|0;h[k>>3]=Z;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];SMa(9,0,19688,P);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+120>>3];P=c[X>>2]|0;h[P+1776>>3]=Z;c[O>>2]=c[P+1684>>2];P=O+4|0;h[k>>3]=Z;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];SMa(9,0,19688,O);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+168>>3];O=c[X>>2]|0;h[O+2448>>3]=Z;c[N>>2]=c[O+2356>>2];O=N+4|0;h[k>>3]=Z;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];SMa(9,0,19688,N);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+216>>3];N=c[X>>2]|0;h[N+3120>>3]=Z;c[M>>2]=c[N+3028>>2];N=M+4|0;h[k>>3]=Z;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];SMa(9,0,19688,M);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+632>>3];M=c[X>>2]|0;h[M+8944>>3]=Z;c[L>>2]=c[M+8852>>2];M=L+4|0;h[k>>3]=Z;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];SMa(9,0,19688,L);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+624>>3];L=c[X>>2]|0;h[L+8832>>3]=Z;c[K>>2]=c[L+8740>>2];L=K+4|0;h[k>>3]=Z;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];SMa(9,0,19688,K);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+616>>3];K=c[X>>2]|0;h[K+8720>>3]=Z;c[J>>2]=c[K+8628>>2];K=J+4|0;h[k>>3]=Z;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];SMa(9,0,19688,J);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+752>>3];J=c[X>>2]|0;h[J+10624>>3]=Z;c[I>>2]=c[J+10532>>2];J=I+4|0;h[k>>3]=Z;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];SMa(9,0,19688,I);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+744>>3];I=c[X>>2]|0;h[I+10512>>3]=Z;c[H>>2]=c[I+10420>>2];I=H+4|0;h[k>>3]=Z;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];SMa(9,0,19688,H);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+736>>3];H=c[X>>2]|0;h[H+10400>>3]=Z;c[G>>2]=c[H+10308>>2];H=G+4|0;h[k>>3]=Z;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];SMa(9,0,19688,G);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1040>>3];G=c[X>>2]|0;h[G+14656>>3]=Z;c[F>>2]=c[G+14564>>2];G=F+4|0;h[k>>3]=Z;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];SMa(9,0,19688,F);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1032>>3];F=c[X>>2]|0;h[F+14544>>3]=Z;c[E>>2]=c[F+14452>>2];F=E+4|0;h[k>>3]=Z;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];SMa(9,0,19688,E);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1024>>3];E=c[X>>2]|0;h[E+14432>>3]=Z;c[D>>2]=c[E+14340>>2];E=D+4|0;h[k>>3]=Z;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];SMa(9,0,19688,D);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1064>>3];D=c[X>>2]|0;h[D+14992>>3]=Z;c[C>>2]=c[D+14900>>2];D=C+4|0;h[k>>3]=Z;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];SMa(9,0,19688,C);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1056>>3];C=c[X>>2]|0;h[C+14880>>3]=Z;c[B>>2]=c[C+14788>>2];C=B+4|0;h[k>>3]=Z;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];SMa(9,0,19688,B);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1048>>3];B=c[X>>2]|0;h[B+14768>>3]=Z;c[A>>2]=c[B+14676>>2];B=A+4|0;h[k>>3]=Z;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];SMa(9,0,19688,A);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1320>>3];A=c[X>>2]|0;h[A+18576>>3]=Z;c[z>>2]=c[A+18484>>2];A=z+4|0;h[k>>3]=Z;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];SMa(9,0,19688,z);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1312>>3];z=c[X>>2]|0;h[z+18464>>3]=Z;c[y>>2]=c[z+18372>>2];z=y+4|0;h[k>>3]=Z;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];SMa(9,0,19688,y);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1304>>3];y=c[X>>2]|0;h[y+18352>>3]=Z;c[x>>2]=c[y+18260>>2];y=x+4|0;h[k>>3]=Z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];SMa(9,0,19688,x);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1344>>3];x=c[X>>2]|0;h[x+18912>>3]=Z;c[w>>2]=c[x+18820>>2];x=w+4|0;h[k>>3]=Z;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];SMa(9,0,19688,w);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1336>>3];w=c[X>>2]|0;h[w+18800>>3]=Z;c[v>>2]=c[w+18708>>2];w=v+4|0;h[k>>3]=Z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];SMa(9,0,19688,v);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1328>>3];v=c[X>>2]|0;h[v+18688>>3]=Z;c[u>>2]=c[v+18596>>2];v=u+4|0;h[k>>3]=Z;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];SMa(9,0,19688,u);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1600>>3];u=c[X>>2]|0;h[u+22496>>3]=Z;c[t>>2]=c[u+22404>>2];u=t+4|0;h[k>>3]=Z;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];SMa(9,0,19688,t);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1592>>3];t=c[X>>2]|0;h[t+22384>>3]=Z;c[s>>2]=c[t+22292>>2];t=s+4|0;h[k>>3]=Z;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];SMa(9,0,19688,s);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1584>>3];s=c[X>>2]|0;h[s+22272>>3]=Z;c[r>>2]=c[s+22180>>2];s=r+4|0;h[k>>3]=Z;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];SMa(9,0,19688,r);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1624>>3];r=c[X>>2]|0;h[r+22832>>3]=Z;c[q>>2]=c[r+22740>>2];r=q+4|0;h[k>>3]=Z;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];SMa(9,0,19688,q);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1616>>3];q=c[X>>2]|0;h[q+22720>>3]=Z;c[p>>2]=c[q+22628>>2];q=p+4|0;h[k>>3]=Z;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];SMa(9,0,19688,p);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1608>>3];p=c[X>>2]|0;h[p+22608>>3]=Z;c[o>>2]=c[p+22516>>2];p=o+4|0;h[k>>3]=Z;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];SMa(9,0,19688,o);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1840>>3];o=c[X>>2]|0;h[o+25856>>3]=Z;c[n>>2]=c[o+25764>>2];o=n+4|0;h[k>>3]=Z;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];SMa(9,0,19688,n);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1848>>3];n=c[X>>2]|0;h[n+25968>>3]=Z;c[m>>2]=c[n+25876>>2];n=m+4|0;h[k>>3]=Z;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];SMa(9,0,19688,m);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1856>>3];m=c[X>>2]|0;h[m+26080>>3]=Z;c[l>>2]=c[m+25988>>2];m=l+4|0;h[k>>3]=Z;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];SMa(9,0,19688,l);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+1864>>3];l=c[X>>2]|0;h[l+26192>>3]=Z;c[j>>2]=c[l+26100>>2];l=j+4|0;h[k>>3]=Z;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];SMa(9,0,19688,j);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+272>>3];j=c[X>>2]|0;h[j+3904>>3]=Z;c[g>>2]=c[j+3812>>2];j=g+4|0;h[k>>3]=Z;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];SMa(9,0,19688,g);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+280>>3];g=c[X>>2]|0;h[g+4016>>3]=Z;c[f>>2]=c[g+3924>>2];g=f+4|0;h[k>>3]=Z;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];SMa(9,0,19688,f);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+8744>>3];f=c[X>>2]|0;h[f+122512>>3]=Z;c[e>>2]=c[f+122420>>2];f=e+4|0;h[k>>3]=Z;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];SMa(9,0,19688,e);Z=+h[(c[(c[c[W>>2]>>2]|0)+8>>2]|0)+8752>>3];W=c[X>>2]|0;h[W+122624>>3]=Z;c[d>>2]=c[W+122532>>2];W=d+4|0;h[k>>3]=Z;c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];SMa(9,0,19688,d);if((c[118228>>2]|0)==0){i=b;return 0}fe[c[29686]&511](9);i=b;return 0}function g6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2920>>3]=0.0;i=i;return}function h6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2888>>3]=0.0;i=i;return}function i6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2904>>3]=0.0;i=i;return}function j6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2936>>3]=0.0;i=i;return}function k6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2928>>3]=0.0;i=i;return}function l6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2944>>3]=0.0;i=i;return}function m6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2952>>3]=0.0;i=i;return}function n6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2976>>3]=0.0;i=i;return}function o6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2960>>3]=0.0;i=i;return}function p6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2984>>3]=0.0;i=i;return}function q6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2968>>3]=0.0;i=i;return}function r6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2992>>3]=0.0;i=i;return}function s6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3008>>3]=0.0;i=i;return}function t6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3024>>3]=0.0;i=i;return}function u6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3040>>3]=0.0;i=i;return}function v6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3048>>3]=0.0;i=i;return}function w6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3056>>3]=0.0;i=i;return}function x6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3064>>3]=0.0;i=i;return}function y6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3072>>3]=0.0;i=i;return}function z6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8864>>3]=0.0;i=i;return}function A6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8872>>3]=0.0;i=i;return}function B6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8880>>3]=0.0;i=i;return}function C6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8888>>3]=0.0;i=i;return}function D6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8896>>3]=0.0;i=i;return}function E6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8904>>3]=0.0;i=i;return}function F6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8912>>3]=0.0;i=i;return}function G6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8920>>3]=0.0;i=i;return}function H6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8928>>3]=0.0;i=i;return}function I6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8936>>3]=0.0;i=i;return}function J6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8944>>3]=0.0;i=i;return}function K6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8976>>3]=0.0;i=i;return}function L6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8984>>3]=0.0;i=i;return}function M6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9024>>3]=0.0;i=i;return}function N6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9032>>3]=0.0;i=i;return}function O6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9040>>3]=0.0;i=i;return}function P6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9048>>3]=0.0;i=i;return}function Q6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9056>>3]=0.0;i=i;return}function R6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9064>>3]=0.0;i=i;return}function S6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9072>>3]=0.0;i=i;return}function T6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9080>>3]=0.0;i=i;return}function U6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9088>>3]=0.0;i=i;return}function V6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3088>>3]=0.0;i=i;return}function W6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3104>>3]=0.0;i=i;return}function X6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3112>>3]=0.0;i=i;return}function Y6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3120>>3]=0.0;i=i;return}function Z6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3128>>3]=0.0;i=i;return}function _6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3136>>3]=0.0;i=i;return}function $6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9136>>3]=0.0;i=i;return}function a7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9144>>3]=0.0;i=i;return}function b7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9152>>3]=0.0;i=i;return}function c7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9160>>3]=0.0;i=i;return}function d7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9168>>3]=0.0;i=i;return}function e7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9176>>3]=0.0;i=i;return}function f7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9184>>3]=0.0;i=i;return}function g7(a){a=a|0;c[c[(c[c[a+4>>2]>>2]|0)+12>>2]>>2]=0;i=i;return}function h7(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+4>>2]=230;i=i;return}function i7(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+8>>2]=0;i=i;return}function j7(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+12>>2]=0;i=i;return}function k7(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+16>>2]=230;i=i;return}function l7(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+20>>2]=0;i=i;return}function m7(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+24>>2]=0;i=i;return}function n7(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+28>>2]=0;i=i;return}function o7(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+32>>2]=0;i=i;return}function p7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3168>>3]=0.0;i=i;return}function q7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3184>>3]=0.0;i=i;return}function r7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3192>>3]=0.0;i=i;return}function s7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3200>>3]=1.0;i=i;return}function t7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3208>>3]=0.0;i=i;return}function u7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3216>>3]=0.0;i=i;return}function v7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3224>>3]=1.0;i=i;return}function w7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3232>>3]=0.0;i=i;return}function x7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3256>>3]=0.0;i=i;return}function y7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3248>>3]=0.0;i=i;return}function z7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3240>>3]=255.0;i=i;return}function A7(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+36>>2]=255;i=i;return}function B7(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+40>>2]=0;i=i;return}function C7(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+44>>2]=0;i=i;return}function D7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3272>>3]=0.0;i=i;return}function E7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3280>>3]=0.0;i=i;return}function F7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3288>>3]=1.0;i=i;return}function G7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3296>>3]=0.0;i=i;return}function H7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3304>>3]=0.0;i=i;return}function I7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3312>>3]=0.0;i=i;return}function J7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3320>>3]=1.0;i=i;return}function K7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3328>>3]=0.0;i=i;return}function L7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3352>>3]=0.0;i=i;return}function M7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3344>>3]=0.0;i=i;return}function N7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3336>>3]=255.0;i=i;return}function O7(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+48>>2]=255;i=i;return}function P7(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+52>>2]=0;i=i;return}function Q7(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+56>>2]=0;i=i;return}function R7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3368>>3]=0.0;i=i;return}function S7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3376>>3]=0.0;i=i;return}function T7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3384>>3]=1.0;i=i;return}function U7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3392>>3]=0.0;i=i;return}function V7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3400>>3]=0.0;i=i;return}function W7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3408>>3]=0.0;i=i;return}function X7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3416>>3]=1.0;i=i;return}function Y7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3424>>3]=0.0;i=i;return}function Z7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3448>>3]=0.0;i=i;return}function _7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3440>>3]=0.0;i=i;return}function $7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3432>>3]=255.0;i=i;return}function a8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+60>>2]=255;i=i;return}function b8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+64>>2]=0;i=i;return}function c8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+68>>2]=0;i=i;return}function d8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3456>>3]=0.0;i=i;return}function e8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3472>>3]=0.0;i=i;return}function f8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3480>>3]=0.0;i=i;return}function g8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3488>>3]=1.0;i=i;return}function h8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3496>>3]=0.0;i=i;return}function i8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3504>>3]=0.0;i=i;return}function j8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3512>>3]=1.0;i=i;return}function k8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3520>>3]=0.0;i=i;return}function l8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3544>>3]=0.0;i=i;return}function m8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3536>>3]=0.0;i=i;return}function n8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3528>>3]=255.0;i=i;return}function o8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+72>>2]=255;i=i;return}function p8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+76>>2]=0;i=i;return}function q8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+80>>2]=0;i=i;return}function r8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3560>>3]=0.0;i=i;return}function s8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3568>>3]=0.0;i=i;return}function t8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3576>>3]=1.0;i=i;return}function u8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3584>>3]=0.0;i=i;return}function v8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3592>>3]=0.0;i=i;return}function w8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3600>>3]=0.0;i=i;return}function x8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3608>>3]=1.0;i=i;return}function y8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3616>>3]=0.0;i=i;return}function z8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3640>>3]=0.0;i=i;return}function A8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3632>>3]=0.0;i=i;return}function B8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3624>>3]=255.0;i=i;return}function C8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+84>>2]=255;i=i;return}function D8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+88>>2]=0;i=i;return}function E8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+92>>2]=0;i=i;return}function F8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3648>>3]=0.0;i=i;return}function G8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3664>>3]=0.0;i=i;return}function H8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3672>>3]=0.0;i=i;return}function I8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3680>>3]=1.0;i=i;return}function J8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3688>>3]=0.0;i=i;return}function K8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3696>>3]=0.0;i=i;return}function L8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3704>>3]=1.0;i=i;return}function M8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3712>>3]=0.0;i=i;return}function N8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3736>>3]=0.0;i=i;return}function O8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3728>>3]=0.0;i=i;return}function P8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3720>>3]=255.0;i=i;return}function Q8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+96>>2]=255;i=i;return}function R8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+100>>2]=0;i=i;return}function S8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+104>>2]=0;i=i;return}function T8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+108>>2]=155;i=i;return}function U8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+112>>2]=155;i=i;return}function V8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+116>>2]=155;i=i;return}function W8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+120>>2]=0;i=i;return}function X8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+124>>2]=128;i=i;return}function Y8(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+128>>2]=255;i=i;return}function Z8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3744>>3]=0.0;i=i;return}function _8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3752>>3]=0.0;i=i;return}function $8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3760>>3]=0.0;i=i;return}function a9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3768>>3]=1.0;i=i;return}function b9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3776>>3]=0.0;i=i;return}function c9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3784>>3]=0.0;i=i;return}function d9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3792>>3]=0.0;i=i;return}function e9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3800>>3]=0.0;i=i;return}function f9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3808>>3]=0.0;i=i;return}function g9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3816>>3]=0.0;i=i;return}function h9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3824>>3]=0.0;i=i;return}function i9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3832>>3]=0.0;i=i;return}function j9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3840>>3]=0.0;i=i;return}function k9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3848>>3]=1.0;i=i;return}function l9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3856>>3]=0.0;i=i;return}function m9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3864>>3]=0.0;i=i;return}function n9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3872>>3]=0.0;i=i;return}function o9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3880>>3]=1.0;i=i;return}function p9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3888>>3]=0.0;i=i;return}function q9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3912>>3]=255.0;i=i;return}function r9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3904>>3]=0.0;i=i;return}function s9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3896>>3]=0.0;i=i;return}function t9(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+132>>2]=0;i=i;return}function u9(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+136>>2]=0;i=i;return}function v9(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+140>>2]=255;i=i;return}function w9(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+144>>2]=155;i=i;return}function x9(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+148>>2]=155;i=i;return}function y9(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+152>>2]=155;i=i;return}function z9(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+156>>2]=0;i=i;return}function A9(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+160>>2]=128;i=i;return}function B9(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+164>>2]=255;i=i;return}function C9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3920>>3]=0.0;i=i;return}function D9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3928>>3]=0.0;i=i;return}function E9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3936>>3]=0.0;i=i;return}function F9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3944>>3]=1.0;i=i;return}function G9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3952>>3]=0.0;i=i;return}function H9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3960>>3]=0.0;i=i;return}function I9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3968>>3]=0.0;i=i;return}function J9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3976>>3]=0.0;i=i;return}function K9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3984>>3]=0.0;i=i;return}function L9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3992>>3]=0.0;i=i;return}function M9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4e3>>3]=0.0;i=i;return}function N9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4008>>3]=0.0;i=i;return}function O9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4016>>3]=0.0;i=i;return}function P9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4024>>3]=1.0;i=i;return}function Q9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4032>>3]=0.0;i=i;return}function R9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4040>>3]=0.0;i=i;return}function S9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4048>>3]=0.0;i=i;return}function T9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4056>>3]=1.0;i=i;return}function U9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4064>>3]=0.0;i=i;return}function V9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4088>>3]=0.0;i=i;return}function W9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4080>>3]=0.0;i=i;return}function X9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4072>>3]=255.0;i=i;return}function Y9(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+168>>2]=255;i=i;return}function Z9(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+172>>2]=0;i=i;return}function _9(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+176>>2]=0;i=i;return}function $9(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+180>>2]=155;i=i;return}function aaa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+184>>2]=155;i=i;return}function baa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+188>>2]=155;i=i;return}function caa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+192>>2]=0;i=i;return}function daa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+196>>2]=128;i=i;return}function eaa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+200>>2]=255;i=i;return}function faa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4096>>3]=0.0;i=i;return}function gaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4104>>3]=0.0;i=i;return}function haa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4112>>3]=0.0;i=i;return}function iaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4120>>3]=1.0;i=i;return}function jaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4128>>3]=0.0;i=i;return}function kaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4136>>3]=0.0;i=i;return}function laa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4144>>3]=0.0;i=i;return}function maa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4152>>3]=0.0;i=i;return}function naa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4160>>3]=0.0;i=i;return}function oaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4168>>3]=0.0;i=i;return}function paa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4176>>3]=0.0;i=i;return}function qaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4184>>3]=0.0;i=i;return}function raa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4192>>3]=0.0;i=i;return}function saa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4200>>3]=1.0;i=i;return}function taa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4208>>3]=0.0;i=i;return}function uaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4216>>3]=0.0;i=i;return}function vaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4224>>3]=0.0;i=i;return}function waa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4232>>3]=1.0;i=i;return}function xaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4240>>3]=0.0;i=i;return}function yaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4264>>3]=0.0;i=i;return}function zaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4256>>3]=178.0;i=i;return}function Aaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4248>>3]=255.0;i=i;return}function Baa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+204>>2]=255;i=i;return}function Caa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+208>>2]=178;i=i;return}function Daa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+212>>2]=0;i=i;return}function Eaa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+216>>2]=155;i=i;return}function Faa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+220>>2]=155;i=i;return}function Gaa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+224>>2]=155;i=i;return}function Haa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+228>>2]=0;i=i;return}function Iaa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+232>>2]=128;i=i;return}function Jaa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+236>>2]=255;i=i;return}function Kaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4272>>3]=0.0;i=i;return}function Laa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4280>>3]=0.0;i=i;return}function Maa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4288>>3]=0.0;i=i;return}function Naa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4296>>3]=1.0;i=i;return}function Oaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4304>>3]=0.0;i=i;return}function Paa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4312>>3]=0.0;i=i;return}function Qaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4320>>3]=0.0;i=i;return}function Raa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4328>>3]=0.0;i=i;return}function Saa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4336>>3]=0.0;i=i;return}function Taa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4344>>3]=0.0;i=i;return}function Uaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4352>>3]=0.0;i=i;return}function Vaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4360>>3]=0.0;i=i;return}function Waa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4368>>3]=0.0;i=i;return}function Xaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4376>>3]=1.0;i=i;return}function Yaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4384>>3]=0.0;i=i;return}function Zaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4392>>3]=0.0;i=i;return}function _aa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4400>>3]=0.0;i=i;return}function $aa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4408>>3]=1.0;i=i;return}function aba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4416>>3]=0.0;i=i;return}function bba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4440>>3]=0.0;i=i;return}function cba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4432>>3]=0.0;i=i;return}function dba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4424>>3]=255.0;i=i;return}function eba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+240>>2]=255;i=i;return}function fba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+244>>2]=0;i=i;return}function gba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+248>>2]=0;i=i;return}function hba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+252>>2]=155;i=i;return}function iba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+256>>2]=155;i=i;return}function jba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+260>>2]=155;i=i;return}function kba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+264>>2]=0;i=i;return}function lba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+268>>2]=128;i=i;return}function mba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+272>>2]=255;i=i;return}function nba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4448>>3]=0.0;i=i;return}function oba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4456>>3]=0.0;i=i;return}function pba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4464>>3]=0.0;i=i;return}function qba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4472>>3]=1.0;i=i;return}function rba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4480>>3]=0.0;i=i;return}function sba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4488>>3]=0.0;i=i;return}function tba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4496>>3]=0.0;i=i;return}function uba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4504>>3]=0.0;i=i;return}function vba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4512>>3]=0.0;i=i;return}function wba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4520>>3]=0.0;i=i;return}function xba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4528>>3]=0.0;i=i;return}function yba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4536>>3]=0.0;i=i;return}function zba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4544>>3]=0.0;i=i;return}function Aba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4552>>3]=1.0;i=i;return}function Bba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4560>>3]=0.0;i=i;return}function Cba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4568>>3]=0.0;i=i;return}function Dba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4576>>3]=0.0;i=i;return}function Eba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4584>>3]=1.0;i=i;return}function Fba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4592>>3]=0.0;i=i;return}function Gba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4616>>3]=0.0;i=i;return}function Hba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4608>>3]=178.0;i=i;return}function Iba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4600>>3]=255.0;i=i;return}function Jba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+276>>2]=255;i=i;return}function Kba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+280>>2]=178;i=i;return}function Lba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+284>>2]=0;i=i;return}function Mba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+288>>2]=155;i=i;return}function Nba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+292>>2]=155;i=i;return}function Oba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+296>>2]=155;i=i;return}function Pba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+300>>2]=0;i=i;return}function Qba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+304>>2]=128;i=i;return}function Rba(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+308>>2]=255;i=i;return}function Sba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4624>>3]=0.0;i=i;return}function Tba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4632>>3]=0.0;i=i;return}function Uba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4640>>3]=0.0;i=i;return}function Vba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4648>>3]=1.0;i=i;return}function Wba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4656>>3]=0.0;i=i;return}function Xba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4664>>3]=0.0;i=i;return}function Yba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4672>>3]=0.0;i=i;return}function Zba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4680>>3]=0.0;i=i;return}function _ba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4688>>3]=0.0;i=i;return}function $ba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4696>>3]=0.0;i=i;return}function aca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4704>>3]=0.0;i=i;return}function bca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4712>>3]=0.0;i=i;return}function cca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4720>>3]=0.0;i=i;return}function dca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4728>>3]=1.0;i=i;return}function eca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4736>>3]=0.0;i=i;return}function fca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4744>>3]=0.0;i=i;return}function gca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4752>>3]=0.0;i=i;return}function hca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4760>>3]=1.0;i=i;return}function ica(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4768>>3]=0.0;i=i;return}function jca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4792>>3]=255.0;i=i;return}function kca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4784>>3]=0.0;i=i;return}function lca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4776>>3]=0.0;i=i;return}function mca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+312>>2]=0;i=i;return}function nca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+316>>2]=0;i=i;return}function oca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+320>>2]=255;i=i;return}function pca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+324>>2]=155;i=i;return}function qca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+328>>2]=155;i=i;return}function rca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+332>>2]=155;i=i;return}function sca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+336>>2]=0;i=i;return}function tca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+340>>2]=128;i=i;return}function uca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+344>>2]=255;i=i;return}function vca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4800>>3]=0.0;i=i;return}function wca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4808>>3]=0.0;i=i;return}function xca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4816>>3]=0.0;i=i;return}function yca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4824>>3]=1.0;i=i;return}function zca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4832>>3]=0.0;i=i;return}function Aca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4840>>3]=0.0;i=i;return}function Bca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4848>>3]=0.0;i=i;return}function Cca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4856>>3]=0.0;i=i;return}function Dca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4864>>3]=0.0;i=i;return}function Eca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4872>>3]=0.0;i=i;return}function Fca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4880>>3]=0.0;i=i;return}function Gca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4888>>3]=0.0;i=i;return}function Hca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4896>>3]=0.0;i=i;return}function Ica(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4904>>3]=1.0;i=i;return}function Jca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4912>>3]=0.0;i=i;return}function Kca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4920>>3]=0.0;i=i;return}function Lca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4928>>3]=0.0;i=i;return}function Mca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4936>>3]=1.0;i=i;return}function Nca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4944>>3]=0.0;i=i;return}function Oca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4968>>3]=255.0;i=i;return}function Pca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4960>>3]=0.0;i=i;return}function Qca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4952>>3]=0.0;i=i;return}function Rca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+348>>2]=0;i=i;return}function Sca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+352>>2]=0;i=i;return}function Tca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+356>>2]=255;i=i;return}function Uca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+360>>2]=155;i=i;return}function Vca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+364>>2]=155;i=i;return}function Wca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+368>>2]=155;i=i;return}function Xca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+372>>2]=0;i=i;return}function Yca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+376>>2]=128;i=i;return}function Zca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+380>>2]=255;i=i;return}function _ca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4976>>3]=0.0;i=i;return}function $ca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4984>>3]=0.0;i=i;return}function ada(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4992>>3]=0.0;i=i;return}function bda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5e3>>3]=1.0;i=i;return}function cda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5008>>3]=0.0;i=i;return}function dda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5016>>3]=0.0;i=i;return}function eda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5024>>3]=0.0;i=i;return}function fda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5032>>3]=0.0;i=i;return}function gda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5040>>3]=0.0;i=i;return}function hda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5048>>3]=0.0;i=i;return}function ida(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5056>>3]=0.0;i=i;return}function jda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5064>>3]=0.0;i=i;return}function kda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5072>>3]=0.0;i=i;return}function lda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5080>>3]=.1;i=i;return}function mda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5088>>3]=.25;i=i;return}function nda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5096>>3]=.1;i=i;return}function oda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5104>>3]=1.0;i=i;return}function pda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5112>>3]=0.0;i=i;return}function qda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5120>>3]=0.0;i=i;return}function rda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5136>>3]=1.0;i=i;return}function sda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5144>>3]=0.0;i=i;return}function tda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5152>>3]=0.0;i=i;return}function uda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5160>>3]=0.0;i=i;return}function vda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5168>>3]=1.0;i=i;return}



function sGa(a){a=a|0;var b=0;b=i;g6(a);h6(a);i6(a);j6(a);k6(a);l6(a);m6(a);n6(a);o6(a);p6(a);q6(a);r6(a);s6(a);t6(a);u6(a);v6(a);w6(a);x6(a);y6(a);z6(a);A6(a);B6(a);C6(a);D6(a);E6(a);F6(a);G6(a);H6(a);I6(a);J6(a);K6(a);L6(a);M6(a);N6(a);O6(a);P6(a);Q6(a);R6(a);S6(a);T6(a);U6(a);V6(a);W6(a);X6(a);Y6(a);Z6(a);_6(a);$6(a);a7(a);b7(a);c7(a);d7(a);e7(a);f7(a);g7(a);h7(a);i7(a);j7(a);k7(a);l7(a);m7(a);n7(a);o7(a);p7(a);q7(a);r7(a);s7(a);t7(a);u7(a);v7(a);w7(a);x7(a);y7(a);z7(a);A7(a);B7(a);C7(a);D7(a);E7(a);F7(a);G7(a);H7(a);I7(a);J7(a);K7(a);L7(a);M7(a);N7(a);O7(a);P7(a);Q7(a);R7(a);S7(a);T7(a);U7(a);V7(a);W7(a);X7(a);Y7(a);Z7(a);_7(a);$7(a);a8(a);b8(a);c8(a);d8(a);e8(a);f8(a);g8(a);h8(a);i8(a);j8(a);k8(a);l8(a);m8(a);n8(a);o8(a);p8(a);q8(a);r8(a);s8(a);t8(a);u8(a);v8(a);w8(a);x8(a);y8(a);z8(a);A8(a);B8(a);C8(a);D8(a);E8(a);F8(a);G8(a);H8(a);I8(a);J8(a);K8(a);L8(a);M8(a);N8(a);O8(a);P8(a);Q8(a);R8(a);S8(a);T8(a);U8(a);V8(a);W8(a);X8(a);Y8(a);Z8(a);_8(a);$8(a);a9(a);b9(a);c9(a);d9(a);e9(a);f9(a);g9(a);h9(a);i9(a);j9(a);k9(a);l9(a);m9(a);n9(a);o9(a);p9(a);q9(a);r9(a);s9(a);t9(a);u9(a);v9(a);w9(a);x9(a);y9(a);z9(a);A9(a);B9(a);C9(a);D9(a);E9(a);F9(a);G9(a);H9(a);I9(a);J9(a);K9(a);L9(a);M9(a);N9(a);O9(a);P9(a);Q9(a);R9(a);S9(a);T9(a);U9(a);V9(a);W9(a);X9(a);Y9(a);Z9(a);_9(a);$9(a);aaa(a);baa(a);caa(a);daa(a);eaa(a);faa(a);gaa(a);haa(a);iaa(a);jaa(a);kaa(a);laa(a);maa(a);naa(a);oaa(a);paa(a);qaa(a);raa(a);saa(a);taa(a);uaa(a);vaa(a);waa(a);xaa(a);yaa(a);zaa(a);Aaa(a);Baa(a);Caa(a);Daa(a);Eaa(a);Faa(a);Gaa(a);Haa(a);Iaa(a);Jaa(a);Kaa(a);Laa(a);Maa(a);Naa(a);Oaa(a);Paa(a);Qaa(a);Raa(a);Saa(a);Taa(a);Uaa(a);Vaa(a);Waa(a);Xaa(a);Yaa(a);Zaa(a);_aa(a);$aa(a);aba(a);bba(a);cba(a);dba(a);eba(a);fba(a);gba(a);hba(a);iba(a);jba(a);kba(a);lba(a);mba(a);nba(a);oba(a);pba(a);qba(a);rba(a);sba(a);tba(a);uba(a);vba(a);wba(a);xba(a);yba(a);zba(a);Aba(a);Bba(a);Cba(a);Dba(a);Eba(a);Fba(a);Gba(a);Hba(a);Iba(a);Jba(a);Kba(a);Lba(a);Mba(a);Nba(a);Oba(a);Pba(a);Qba(a);Rba(a);Sba(a);Tba(a);Uba(a);Vba(a);Wba(a);Xba(a);Yba(a);Zba(a);_ba(a);$ba(a);aca(a);bca(a);cca(a);dca(a);eca(a);fca(a);gca(a);hca(a);ica(a);jca(a);kca(a);lca(a);mca(a);nca(a);oca(a);pca(a);qca(a);rca(a);sca(a);tca(a);uca(a);vca(a);wca(a);xca(a);yca(a);zca(a);Aca(a);Bca(a);Cca(a);Dca(a);Eca(a);Fca(a);Gca(a);Hca(a);Ica(a);Jca(a);Kca(a);Lca(a);Mca(a);Nca(a);Oca(a);Pca(a);Qca(a);Rca(a);Sca(a);Tca(a);Uca(a);Vca(a);Wca(a);Xca(a);Yca(a);Zca(a);_ca(a);$ca(a);ada(a);bda(a);cda(a);dda(a);eda(a);fda(a);gda(a);hda(a);ida(a);jda(a);kda(a);lda(a);mda(a);nda(a);oda(a);pda(a);qda(a);rda(a);sda(a);tda(a);uda(a);vda(a);wda(a);xda(a);yda(a);zda(a);Ada(a);Bda(a);Cda(a);Dda(a);Eda(a);Fda(a);Gda(a);Hda(a);Ida(a);Jda(a);Kda(a);Lda(a);Mda(a);Nda(a);Oda(a);Pda(a);Qda(a);Rda(a);Sda(a);Tda(a);Uda(a);Vda(a);Wda(a);Xda(a);Yda(a);Zda(a);_da(a);$da(a);aea(a);bea(a);cea(a);dea(a);eea(a);fea(a);gea(a);hea(a);iea(a);jea(a);kea(a);lea(a);mea(a);nea(a);oea(a);pea(a);qea(a);rea(a);sea(a);tea(a);uea(a);vea(a);wea(a);xea(a);yea(a);zea(a);Aea(a);Bea(a);Cea(a);Dea(a);Eea(a);Fea(a);Gea(a);Hea(a);Iea(a);Jea(a);Kea(a);Lea(a);Mea(a);Nea(a);Oea(a);Pea(a);Qea(a);Rea(a);Sea(a);Tea(a);Uea(a);Vea(a);Wea(a);Xea(a);Yea(a);Zea(a);_ea(a);$ea(a);afa(a);bfa(a);cfa(a);dfa(a);efa(a);ffa(a);gfa(a);hfa(a);ifa(a);jfa(a);kfa(a);lfa(a);mfa(a);nfa(a);ofa(a);pfa(a);qfa(a);rfa(a);sfa(a);tfa(a);ufa(a);vfa(a);wfa(a);xfa(a);yfa(a);zfa(a);Afa(a);Bfa(a);Cfa(a);Dfa(a);Efa(a);Ffa(a);Gfa(a);Hfa(a);Ifa(a);Jfa(a);Kfa(a);Lfa(a);Mfa(a);Nfa(a);Ofa(a);Pfa(a);Qfa(a);Rfa(a);Sfa(a);Tfa(a);Ufa(a);Vfa(a);Wfa(a);Xfa(a);Yfa(a);Zfa(a);_fa(a);$fa(a);aga(a);bga(a);cga(a);dga(a);ega(a);fga(a);gga(a);hga(a);iga(a);jga(a);kga(a);lga(a);mga(a);nga(a);oga(a);pga(a);qga(a);rga(a);sga(a);tga(a);uga(a);vga(a);wga(a);xga(a);yga(a);zga(a);Aga(a);Bga(a);Cga(a);Dga(a);Ega(a);Fga(a);Gga(a);Hga(a);Iga(a);Jga(a);Kga(a);Lga(a);Mga(a);Nga(a);Oga(a);Pga(a);Qga(a);Rga(a);Sga(a);Tga(a);Uga(a);Vga(a);Wga(a);Xga(a);Yga(a);Zga(a);_ga(a);$ga(a);aha(a);bha(a);cha(a);dha(a);eha(a);fha(a);gha(a);hha(a);iha(a);jha(a);kha(a);lha(a);mha(a);nha(a);oha(a);pha(a);qha(a);rha(a);sha(a);tha(a);uha(a);vha(a);wha(a);xha(a);yha(a);zha(a);Aha(a);Bha(a);Cha(a);Dha(a);Eha(a);Fha(a);Gha(a);Hha(a);Iha(a);Jha(a);Kha(a);Lha(a);Mha(a);Nha(a);Oha(a);Pha(a);Qha(a);Rha(a);Sha(a);Tha(a);Uha(a);Vha(a);Wha(a);Xha(a);Yha(a);Zha(a);_ha(a);$ha(a);aia(a);bia(a);cia(a);dia(a);eia(a);fia(a);gia(a);hia(a);iia(a);jia(a);kia(a);lia(a);mia(a);nia(a);oia(a);pia(a);qia(a);ria(a);sia(a);tia(a);uia(a);via(a);wia(a);xia(a);yia(a);zia(a);Aia(a);Bia(a);Cia(a);Dia(a);Eia(a);Fia(a);Gia(a);Hia(a);Iia(a);Jia(a);Kia(a);Lia(a);Mia(a);Nia(a);Oia(a);Pia(a);Qia(a);Ria(a);Sia(a);Tia(a);Uia(a);Via(a);Wia(a);Xia(a);Yia(a);Zia(a);_ia(a);$ia(a);aja(a);bja(a);cja(a);dja(a);eja(a);fja(a);gja(a);hja(a);ija(a);jja(a);kja(a);lja(a);mja(a);nja(a);oja(a);pja(a);qja(a);rja(a);sja(a);tja(a);uja(a);vja(a);wja(a);xja(a);yja(a);zja(a);Aja(a);Bja(a);Cja(a);Dja(a);Eja(a);Fja(a);Gja(a);Hja(a);Ija(a);Jja(a);Kja(a);Lja(a);Mja(a);Nja(a);Oja(a);Pja(a);Qja(a);Rja(a);Sja(a);Tja(a);Uja(a);Vja(a);Wja(a);Xja(a);Yja(a);Zja(a);_ja(a);$ja(a);aka(a);bka(a);cka(a);dka(a);eka(a);fka(a);gka(a);hka(a);ika(a);jka(a);kka(a);lka(a);mka(a);nka(a);oka(a);pka(a);qka(a);rka(a);ska(a);tka(a);uka(a);vka(a);wka(a);xka(a);yka(a);zka(a);Aka(a);Bka(a);Cka(a);Dka(a);Eka(a);Fka(a);Gka(a);Hka(a);Ika(a);Jka(a);Kka(a);Lka(a);Mka(a);Nka(a);Oka(a);Pka(a);Qka(a);Rka(a);Ska(a);Tka(a);Uka(a);Vka(a);Wka(a);Xka(a);Yka(a);Zka(a);_ka(a);$ka(a);ala(a);bla(a);cla(a);dla(a);ela(a);fla(a);gla(a);hla(a);ila(a);jla(a);kla(a);lla(a);mla(a);nla(a);ola(a);pla(a);qla(a);rla(a);sla(a);tla(a);ula(a);vla(a);wla(a);xla(a);yla(a);zla(a);Ala(a);Bla(a);Cla(a);Dla(a);Ela(a);Fla(a);Gla(a);Hla(a);Ila(a);Jla(a);Kla(a);Lla(a);Mla(a);Nla(a);Ola(a);Pla(a);Qla(a);Rla(a);Sla(a);Tla(a);Ula(a);Vla(a);Wla(a);Xla(a);Yla(a);Zla(a);_la(a);$la(a);ama(a);bma(a);cma(a);dma(a);ema(a);fma(a);gma(a);hma(a);ima(a);jma(a);kma(a);lma(a);mma(a);nma(a);oma(a);pma(a);qma(a);rma(a);sma(a);tma(a);uma(a);vma(a);wma(a);xma(a);yma(a);zma(a);Ama(a);Bma(a);Cma(a);Dma(a);Ema(a);Fma(a);Gma(a);Hma(a);Ima(a);Jma(a);Kma(a);Lma(a);Mma(a);Nma(a);Oma(a);Pma(a);Qma(a);Rma(a);Sma(a);Tma(a);Uma(a);Vma(a);Wma(a);Xma(a);Yma(a);Zma(a);_ma(a);$ma(a);ana(a);bna(a);cna(a);dna(a);ena(a);fna(a);gna(a);hna(a);ina(a);jna(a);kna(a);lna(a);mna(a);nna(a);ona(a);pna(a);qna(a);rna(a);sna(a);tna(a);una(a);vna(a);wna(a);xna(a);yna(a);zna(a);Ana(a);Bna(a);Cna(a);Dna(a);Ena(a);Fna(a);Gna(a);Hna(a);Ina(a);Jna(a);Kna(a);Lna(a);Mna(a);Nna(a);Ona(a);Pna(a);Qna(a);Rna(a);Sna(a);Tna(a);Una(a);Vna(a);Wna(a);Xna(a);Yna(a);Zna(a);_na(a);$na(a);aoa(a);boa(a);coa(a);doa(a);eoa(a);foa(a);goa(a);hoa(a);ioa(a);joa(a);koa(a);loa(a);moa(a);noa(a);ooa(a);poa(a);qoa(a);roa(a);soa(a);toa(a);uoa(a);voa(a);woa(a);xoa(a);yoa(a);zoa(a);Aoa(a);Boa(a);Coa(a);Doa(a);Eoa(a);Foa(a);Goa(a);Hoa(a);Ioa(a);Joa(a);Koa(a);Loa(a);Moa(a);Noa(a);Ooa(a);Poa(a);Qoa(a);Roa(a);Soa(a);Toa(a);Uoa(a);Voa(a);Woa(a);Xoa(a);Yoa(a);Zoa(a);_oa(a);$oa(a);apa(a);bpa(a);cpa(a);dpa(a);epa(a);fpa(a);gpa(a);hpa(a);ipa(a);jpa(a);kpa(a);lpa(a);mpa(a);npa(a);opa(a);ppa(a);qpa(a);rpa(a);spa(a);tpa(a);upa(a);vpa(a);wpa(a);xpa(a);ypa(a);zpa(a);Apa(a);Bpa(a);Cpa(a);Dpa(a);Epa(a);Fpa(a);Gpa(a);Hpa(a);Ipa(a);Jpa(a);Kpa(a);Lpa(a);Mpa(a);Npa(a);Opa(a);Ppa(a);Qpa(a);Rpa(a);Spa(a);Tpa(a);Upa(a);Vpa(a);Wpa(a);Xpa(a);Ypa(a);Zpa(a);_pa(a);$pa(a);aqa(a);bqa(a);cqa(a);dqa(a);eqa(a);fqa(a);gqa(a);hqa(a);iqa(a);jqa(a);kqa(a);lqa(a);mqa(a);nqa(a);oqa(a);pqa(a);qqa(a);rqa(a);sqa(a);tqa(a);uqa(a);vqa(a);wqa(a);xqa(a);yqa(a);zqa(a);Aqa(a);Bqa(a);Cqa(a);Dqa(a);Eqa(a);Fqa(a);Gqa(a);Hqa(a);Iqa(a);Jqa(a);Kqa(a);Lqa(a);Mqa(a);Nqa(a);Oqa(a);Pqa(a);Qqa(a);Rqa(a);Sqa(a);Tqa(a);Uqa(a);Vqa(a);Wqa(a);Xqa(a);Yqa(a);Zqa(a);_qa(a);$qa(a);ara(a);bra(a);cra(a);dra(a);era(a);fra(a);gra(a);hra(a);ira(a);jra(a);kra(a);lra(a);mra(a);nra(a);ora(a);pra(a);qra(a);rra(a);sra(a);tra(a);ura(a);vra(a);wra(a);xra(a);yra(a);zra(a);Ara(a);Bra(a);Cra(a);Dra(a);Era(a);Fra(a);Gra(a);Hra(a);Ira(a);Jra(a);Kra(a);Lra(a);Mra(a);Nra(a);Ora(a);Pra(a);Qra(a);Rra(a);Sra(a);Tra(a);Ura(a);Vra(a);Wra(a);Xra(a);Yra(a);Zra(a);_ra(a);$ra(a);asa(a);bsa(a);csa(a);dsa(a);esa(a);fsa(a);gsa(a);hsa(a);isa(a);jsa(a);ksa(a);lsa(a);msa(a);nsa(a);osa(a);psa(a);qsa(a);rsa(a);ssa(a);tsa(a);usa(a);vsa(a);wsa(a);xsa(a);ysa(a);zsa(a);Asa(a);Bsa(a);Csa(a);Dsa(a);Esa(a);Fsa(a);Gsa(a);Hsa(a);Isa(a);Jsa(a);Ksa(a);Lsa(a);Msa(a);Nsa(a);Osa(a);Psa(a);Qsa(a);Rsa(a);Ssa(a);Tsa(a);Usa(a);Vsa(a);Wsa(a);Xsa(a);Ysa(a);Zsa(a);_sa(a);$sa(a);ata(a);bta(a);cta(a);dta(a);eta(a);fta(a);gta(a);hta(a);ita(a);jta(a);kta(a);lta(a);mta(a);nta(a);ota(a);pta(a);qta(a);rta(a);sta(a);tta(a);uta(a);vta(a);wta(a);xta(a);yta(a);zta(a);Ata(a);Bta(a);Cta(a);Dta(a);Eta(a);Fta(a);Gta(a);Hta(a);Ita(a);Jta(a);Kta(a);Lta(a);Mta(a);Nta(a);Ota(a);Pta(a);Qta(a);Rta(a);Sta(a);Tta(a);Uta(a);Vta(a);Wta(a);Xta(a);Yta(a);Zta(a);_ta(a);$ta(a);aua(a);bua(a);cua(a);dua(a);eua(a);fua(a);gua(a);hua(a);iua(a);jua(a);kua(a);lua(a);mua(a);nua(a);oua(a);pua(a);qua(a);rua(a);sua(a);tua(a);uua(a);vua(a);wua(a);xua(a);yua(a);zua(a);Aua(a);Bua(a);Cua(a);Dua(a);Eua(a);Fua(a);Gua(a);Hua(a);Iua(a);Jua(a);Kua(a);Lua(a);Mua(a);Nua(a);Oua(a);Pua(a);Qua(a);Rua(a);Sua(a);Tua(a);Uua(a);Vua(a);Wua(a);Xua(a);Yua(a);Zua(a);_ua(a);$ua(a);ava(a);bva(a);cva(a);dva(a);eva(a);fva(a);gva(a);hva(a);iva(a);jva(a);kva(a);lva(a);mva(a);nva(a);ova(a);pva(a);qva(a);rva(a);sva(a);tva(a);uva(a);vva(a);wva(a);xva(a);yva(a);zva(a);Ava(a);Bva(a);Cva(a);Dva(a);Eva(a);Fva(a);Gva(a);Hva(a);Iva(a);Jva(a);Kva(a);Lva(a);Mva(a);Nva(a);Ova(a);Pva(a);Qva(a);Rva(a);Sva(a);Tva(a);Uva(a);Vva(a);Wva(a);Xva(a);Yva(a);Zva(a);_va(a);$va(a);awa(a);bwa(a);cwa(a);dwa(a);ewa(a);fwa(a);gwa(a);hwa(a);iwa(a);jwa(a);kwa(a);lwa(a);mwa(a);nwa(a);owa(a);pwa(a);qwa(a);rwa(a);swa(a);twa(a);uwa(a);vwa(a);wwa(a);xwa(a);ywa(a);zwa(a);Awa(a);Bwa(a);Cwa(a);Dwa(a);Ewa(a);Fwa(a);Gwa(a);Hwa(a);Iwa(a);Jwa(a);Kwa(a);Lwa(a);Mwa(a);Nwa(a);Owa(a);Pwa(a);Qwa(a);Rwa(a);Swa(a);Twa(a);Uwa(a);Vwa(a);Wwa(a);Xwa(a);Ywa(a);Zwa(a);_wa(a);$wa(a);axa(a);bxa(a);cxa(a);dxa(a);exa(a);fxa(a);gxa(a);hxa(a);ixa(a);jxa(a);kxa(a);lxa(a);mxa(a);nxa(a);oxa(a);pxa(a);qxa(a);rxa(a);sxa(a);txa(a);uxa(a);vxa(a);wxa(a);xxa(a);yxa(a);zxa(a);Axa(a);Bxa(a);Cxa(a);Dxa(a);Exa(a);Fxa(a);Gxa(a);Hxa(a);Ixa(a);Jxa(a);Kxa(a);Lxa(a);Mxa(a);Nxa(a);Oxa(a);Pxa(a);Qxa(a);Rxa(a);Sxa(a);Txa(a);Uxa(a);Vxa(a);Wxa(a);Xxa(a);Yxa(a);Zxa(a);_xa(a);$xa(a);aya(a);bya(a);cya(a);dya(a);eya(a);fya(a);gya(a);hya(a);iya(a);jya(a);kya(a);lya(a);mya(a);nya(a);oya(a);pya(a);qya(a);rya(a);sya(a);tya(a);uya(a);vya(a);wya(a);xya(a);yya(a);zya(a);Aya(a);Bya(a);Cya(a);Dya(a);Eya(a);Fya(a);Gya(a);Hya(a);Iya(a);Jya(a);Kya(a);Lya(a);Mya(a);Nya(a);Oya(a);Pya(a);Qya(a);Rya(a);Sya(a);Tya(a);Uya(a);Vya(a);Wya(a);Xya(a);Yya(a);Zya(a);_ya(a);$ya(a);aza(a);bza(a);cza(a);dza(a);eza(a);fza(a);gza(a);hza(a);iza(a);jza(a);kza(a);lza(a);mza(a);nza(a);oza(a);pza(a);qza(a);rza(a);sza(a);tza(a);uza(a);vza(a);wza(a);xza(a);yza(a);zza(a);Aza(a);Bza(a);Cza(a);Dza(a);Eza(a);Fza(a);Gza(a);Hza(a);Iza(a);Jza(a);Kza(a);Lza(a);Mza(a);Nza(a);Oza(a);Pza(a);Qza(a);Rza(a);Sza(a);Tza(a);Uza(a);Vza(a);Wza(a);Xza(a);Yza(a);Zza(a);_za(a);$za(a);aAa(a);bAa(a);cAa(a);dAa(a);eAa(a);fAa(a);gAa(a);hAa(a);iAa(a);jAa(a);kAa(a);lAa(a);mAa(a);nAa(a);oAa(a);pAa(a);qAa(a);rAa(a);sAa(a);tAa(a);uAa(a);vAa(a);wAa(a);xAa(a);yAa(a);zAa(a);AAa(a);BAa(a);CAa(a);DAa(a);EAa(a);FAa(a);GAa(a);HAa(a);IAa(a);JAa(a);KAa(a);LAa(a);MAa(a);NAa(a);OAa(a);PAa(a);QAa(a);RAa(a);SAa(a);TAa(a);UAa(a);VAa(a);WAa(a);XAa(a);YAa(a);ZAa(a);_Aa(a);$Aa(a);aBa(a);bBa(a);cBa(a);dBa(a);eBa(a);fBa(a);gBa(a);hBa(a);iBa(a);jBa(a);kBa(a);lBa(a);mBa(a);nBa(a);oBa(a);pBa(a);qBa(a);rBa(a);sBa(a);tBa(a);uBa(a);vBa(a);wBa(a);xBa(a);yBa(a);zBa(a);ABa(a);BBa(a);CBa(a);DBa(a);EBa(a);FBa(a);GBa(a);HBa(a);IBa(a);JBa(a);KBa(a);LBa(a);MBa(a);NBa(a);OBa(a);PBa(a);QBa(a);RBa(a);SBa(a);TBa(a);UBa(a);VBa(a);WBa(a);XBa(a);YBa(a);ZBa(a);_Ba(a);$Ba(a);aCa(a);bCa(a);cCa(a);dCa(a);eCa(a);fCa(a);gCa(a);hCa(a);iCa(a);jCa(a);kCa(a);lCa(a);mCa(a);nCa(a);oCa(a);pCa(a);qCa(a);rCa(a);sCa(a);tCa(a);uCa(a);vCa(a);wCa(a);xCa(a);yCa(a);zCa(a);ACa(a);BCa(a);CCa(a);DCa(a);ECa(a);FCa(a);GCa(a);HCa(a);ICa(a);JCa(a);KCa(a);LCa(a);MCa(a);NCa(a);OCa(a);PCa(a);QCa(a);RCa(a);SCa(a);TCa(a);UCa(a);VCa(a);WCa(a);XCa(a);YCa(a);ZCa(a);_Ca(a);$Ca(a);aDa(a);bDa(a);cDa(a);dDa(a);eDa(a);fDa(a);gDa(a);hDa(a);iDa(a);jDa(a);kDa(a);lDa(a);mDa(a);nDa(a);oDa(a);pDa(a);qDa(a);rDa(a);sDa(a);tDa(a);uDa(a);vDa(a);wDa(a);xDa(a);yDa(a);zDa(a);ADa(a);BDa(a);CDa(a);DDa(a);EDa(a);FDa(a);GDa(a);HDa(a);IDa(a);JDa(a);KDa(a);LDa(a);MDa(a);NDa(a);ODa(a);PDa(a);QDa(a);RDa(a);SDa(a);TDa(a);UDa(a);VDa(a);WDa(a);XDa(a);YDa(a);ZDa(a);_Da(a);$Da(a);aEa(a);bEa(a);cEa(a);dEa(a);eEa(a);fEa(a);gEa(a);hEa(a);iEa(a);jEa(a);kEa(a);lEa(a);mEa(a);nEa(a);oEa(a);pEa(a);qEa(a);rEa(a);sEa(a);tEa(a);uEa(a);vEa(a);wEa(a);xEa(a);yEa(a);zEa(a);AEa(a);BEa(a);CEa(a);DEa(a);EEa(a);FEa(a);GEa(a);HEa(a);IEa(a);JEa(a);KEa(a);LEa(a);MEa(a);NEa(a);OEa(a);PEa(a);QEa(a);REa(a);SEa(a);TEa(a);UEa(a);VEa(a);WEa(a);XEa(a);YEa(a);ZEa(a);_Ea(a);$Ea(a);aFa(a);bFa(a);cFa(a);dFa(a);eFa(a);fFa(a);gFa(a);hFa(a);iFa(a);jFa(a);kFa(a);lFa(a);mFa(a);nFa(a);oFa(a);pFa(a);qFa(a);rFa(a);sFa(a);tFa(a);uFa(a);vFa(a);wFa(a);xFa(a);yFa(a);zFa(a);AFa(a);BFa(a);CFa(a);DFa(a);EFa(a);FFa(a);GFa(a);HFa(a);IFa(a);JFa(a);KFa(a);LFa(a);MFa(a);NFa(a);OFa(a);PFa(a);QFa(a);RFa(a);SFa(a);TFa(a);UFa(a);VFa(a);WFa(a);XFa(a);YFa(a);ZFa(a);_Fa(a);$Fa(a);aGa(a);bGa(a);cGa(a);dGa(a);eGa(a);fGa(a);gGa(a);hGa(a);iGa(a);jGa(a);kGa(a);lGa(a);mGa(a);nGa(a);oGa(a);pGa(a);qGa(a);rGa(a);i=b;return 0}function tGa(b){b=b|0;var c=0;c=i;a[b+314|0]=0;uGa(b);i=c;return 0}function uGa(a){a=a|0;var b=0;b=i;zo(a);yo(a);xo(a);wo(a);vo(a);uo(a);to(a);cf(a);df(a);ef(a);ff(a);gf(a);hf(a);jf(a);uf(a);Hf(a);Kf(a);Mf(a);Of(a);Pf(a);Tf(a);Wf(a);Xf(a);$f(a);eg(a);gg(a);hg(a);lg(a);og(a);pg(a);tg(a);yg(a);Ag(a);Bg(a);Fg(a);Ig(a);Jg(a);Ng(a);Sg(a);Ug(a);Vg(a);Zg(a);ah(a);bh(a);eh(a);gh(a);hh(a);lh(a);oh(a);ph(a);sh(a);uh(a);vh(a);zh(a);Ch(a);Dh(a);Fh(a);Gh(a);Hh(a);$h(a);ai(a);bi(a);ci(a);ji(a);ki(a);li(a);mi(a);ti(a);ui(a);vi(a);wi(a);Ei(a);Fi(a);Ni(a);Oi(a);Wi(a);Xi(a);aj(a);bj(a);dj(a);ej(a);fj(a);gj(a);hj(a);ij(a);kj(a);xj(a);yj(a);zj(a);Aj(a);Bj(a);Jj(a);Lj(a);Oj(a);Pj(a);Rj(a);Sj(a);Tj(a);Uj(a);Vj(a);Wj(a);Xj(a);Yj(a);Zj(a);_j(a);ak(a);nk(a);ok(a);pk(a);qk(a);rk(a);Mk(a);Pk(a);Sk(a);Vk(a);Wk(a);Xk(a);Yk(a);Zk(a);_k(a);al(a);dl(a);gl(a);jl(a);kl(a);ll(a);ml(a);nl(a);ol(a);ql(a);tl(a);wl(a);zl(a);Al(a);Bl(a);Cl(a);Dl(a);El(a);Gl(a);Hl(a);Jl(a);Kl(a);Ml(a);Nl(a);Tl(a);Ul(a);Zl(a);_l(a);$l(a);am(a);bm(a);cm(a);dm(a);em(a);fm(a);gm(a);mm(a);nm(a);om(a);pm(a);qm(a);rm(a);sm(a);tm(a);um(a);vm(a);wm(a);xm(a);ym(a);zm(a);Am(a);Bm(a);Cm(a);Dm(a);Em(a);Fm(a);Gm(a);Hm(a);Im(a);Jm(a);Km(a);Lm(a);Mm(a);Nm(a);Om(a);Pm(a);Qm(a);Rm(a);Sm(a);Tm(a);Um(a);Vm(a);Wm(a);Ym(a);kn(a);ln(a);mn(a);nn(a);on(a);qn(a);Dn(a);En(a);Fn(a);Gn(a);Hn(a);Jn(a);Wn(a);Xn(a);Yn(a);Zn(a);_n(a);ao(a);oo(a);po(a);qo(a);ro(a);so(a);Ao(a);Bo(a);Co(a);Do(a);Eo(a);Fo(a);Go(a);Ho(a);Io(a);Jo(a);Ko(a);Lo(a);Mo(a);No(a);Oo(a);Po(a);Qo(a);Ro(a);So(a);To(a);Uo(a);Vo(a);Wo(a);Xo(a);Yo(a);Zo(a);_o(a);$o(a);ap(a);bp(a);cp(a);dp(a);ep(a);fp(a);gp(a);hp(a);ip(a);jp(a);kp(a);lp(a);mp(a);np(a);op(a);pp(a);qp(a);rp(a);sp(a);tp(a);i=b;return}function vGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103616]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+416>>2]|0),-1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+416>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(103632,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+416>>2]|0,103624)|0)|0;g=c[41886]|0;h=e;j=104712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[103616]=1;i=d;return}function wGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103872]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+412>>2]|0),-1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+412>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(103880,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+412>>2]|0,103624)|0)|0;g=c[41886]|0;h=e;j=104712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[103872]=1;i=d;return}function xGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104040]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+408>>2]|0),-1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+408>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(104048,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+408>>2]|0,103624)|0)|0;g=c[41886]|0;h=e;j=104712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[104040]=1;i=d;return}function yGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104208]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+404>>2]|0),-1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+404>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(104216,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+404>>2]|0,103624)|0)|0;g=c[41886]|0;h=e;j=104712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[104208]=1;i=d;return}function zGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104376]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+400>>2]|0),-1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+400>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(104384,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+400>>2]|0,103624)|0)|0;g=c[41886]|0;h=e;j=104712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[104376]=1;i=d;return}function AGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104544]&1){i=d;return}g=b+4|0;b=fQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+396>>2]|0),-1.0)|0;if(!(b<<24>>24==0|(dQa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+396>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=uNa(104552,sNa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+396>>2]|0,103624)|0)|0;g=c[41886]|0;h=e;j=104712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[104544]=1;i=d;return}function BGa(a){a=a|0;var b=0;b=i;vGa(a);wGa(a);xGa(a);yGa(a);zGa(a);AGa(a);i=b;return 0}function CGa(a){a=a|0;i=i;return 1}function DGa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=36;c[a+48>>2]=36;c[a+72>>2]=zfb(36,8)|0;a=zfb(36,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=zfb(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=xfb(144)|0;c[(c[d>>2]|0)+52>>2]=a;a=xfb(1080)|0;c[(c[d>>2]|0)+56>>2]=a;a=xfb(144)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=22;c[a+84>>2]=0;a=c[d>>2]|0;e=c[a+52>>2]|0;c[e+140>>2]=13;c[e+136>>2]=13;c[e+132>>2]=13;c[e+128>>2]=13;c[e+124>>2]=13;c[e+120>>2]=13;c[e+116>>2]=3;c[e+112>>2]=1;c[e+108>>2]=1;c[e+104>>2]=11;c[e+100>>2]=11;c[e+96>>2]=13;c[e+92>>2]=3;c[e+88>>2]=1;c[e+84>>2]=1;c[e+80>>2]=11;c[e+76>>2]=11;c[e+72>>2]=13;c[e+68>>2]=3;c[e+64>>2]=1;c[e+60>>2]=1;c[e+56>>2]=11;c[e+52>>2]=11;c[e+48>>2]=13;c[e+44>>2]=11;c[e+40>>2]=11;c[e+36>>2]=1;c[e+32>>2]=1;c[e+28>>2]=11;c[e+24>>2]=11;c[e+20>>2]=1;c[e+16>>2]=1;c[e+12>>2]=11;c[e+8>>2]=11;c[e+4>>2]=1;c[e>>2]=1;f=1;g=1;h=1;while(1){j=f+g|0;c[e+(h<<2)>>2]=j;k=h+1|0;if((k|0)>=36){break}f=c[e+(k<<2)>>2]|0;h=k;g=j}EGa(e,c[a+56>>2]|0);a=c[d>>2]|0;FGa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;GGa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;HGa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;IGa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;JGa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;KGa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;LGa(c[(c[a+52>>2]|0)+112>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;MGa(c[(c[a+52>>2]|0)+108>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;NGa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;OGa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;PGa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;QGa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;RGa(c[(c[a+52>>2]|0)+88>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;SGa(c[(c[a+52>>2]|0)+84>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;TGa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;UGa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;VGa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;WGa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;XGa(c[(c[a+52>>2]|0)+64>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;YGa(c[(c[a+52>>2]|0)+60>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;ZGa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;_Ga(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;$Ga(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;aHa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;bHa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;cHa(c[(c[a+52>>2]|0)+36>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;dHa(c[(c[a+52>>2]|0)+32>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;eHa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;fHa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;gHa(c[(c[a+52>>2]|0)+20>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;hHa(c[(c[a+52>>2]|0)+16>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;iHa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;jHa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;kHa(c[(c[a+52>>2]|0)+4>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;lHa(c[c[a+52>>2]>>2]|0,c[a+56>>2]|0);a=c[(c[d>>2]|0)+64>>2]|0;c[a+140>>2]=1;c[a+88>>2]=1;c[a+84>>2]=1;c[a+64>>2]=1;c[a+60>>2]=1;c[a+36>>2]=1;c[a+32>>2]=1;c[a+20>>2]=1;c[a+16>>2]=1;c[a+4>>2]=1;c[a>>2]=1;c[a+136>>2]=2;c[a+112>>2]=2;c[a+108>>2]=2;c[a+132>>2]=3;c[a+128>>2]=4;c[a+124>>2]=5;c[a+120>>2]=6;c[a+116>>2]=7;c[a+92>>2]=7;c[a+68>>2]=7;c[a+104>>2]=8;c[a+100>>2]=9;c[a+96>>2]=10;c[a+80>>2]=11;c[a+76>>2]=12;c[a+72>>2]=13;c[a+56>>2]=14;c[a+52>>2]=15;c[a+48>>2]=16;c[a+44>>2]=17;c[a+40>>2]=18;c[a+28>>2]=19;c[a+24>>2]=20;c[a+12>>2]=21;c[a+8>>2]=22;i=b;return 0}function EGa(a,b){a=a|0;b=b|0;var d=0;d=a+140|0;c[b+((c[d>>2]|0)+ -13<<2)>>2]=12;c[b+((c[d>>2]|0)+ -12<<2)>>2]=18;c[b+((c[d>>2]|0)+ -11<<2)>>2]=24;c[b+((c[d>>2]|0)+ -10<<2)>>2]=26;c[b+((c[d>>2]|0)+ -9<<2)>>2]=27;c[b+((c[d>>2]|0)+ -8<<2)>>2]=28;c[b+((c[d>>2]|0)+ -7<<2)>>2]=29;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function FGa(a,b){a=a|0;b=b|0;var d=0;d=a+136|0;c[b+((c[d>>2]|0)+ -13<<2)>>2]=12;c[b+((c[d>>2]|0)+ -12<<2)>>2]=18;c[b+((c[d>>2]|0)+ -11<<2)>>2]=20;c[b+((c[d>>2]|0)+ -10<<2)>>2]=21;c[b+((c[d>>2]|0)+ -9<<2)>>2]=22;c[b+((c[d>>2]|0)+ -8<<2)>>2]=23;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function GGa(a,b){a=a|0;b=b|0;var d=0;d=a+132|0;c[b+((c[d>>2]|0)+ -13<<2)>>2]=12;c[b+((c[d>>2]|0)+ -12<<2)>>2]=14;c[b+((c[d>>2]|0)+ -11<<2)>>2]=15;c[b+((c[d>>2]|0)+ -10<<2)>>2]=16;c[b+((c[d>>2]|0)+ -9<<2)>>2]=17;c[b+((c[d>>2]|0)+ -8<<2)>>2]=18;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function HGa(a,b){a=a|0;b=b|0;var d=0;d=a+128|0;c[b+((c[d>>2]|0)+ -13<<2)>>2]=8;c[b+((c[d>>2]|0)+ -12<<2)>>2]=9;c[b+((c[d>>2]|0)+ -11<<2)>>2]=10;c[b+((c[d>>2]|0)+ -10<<2)>>2]=11;c[b+((c[d>>2]|0)+ -9<<2)>>2]=12;c[b+((c[d>>2]|0)+ -8<<2)>>2]=18;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function IGa(a,b){a=a|0;b=b|0;var d=0;d=a+124|0;c[b+((c[d>>2]|0)+ -13<<2)>>2]=4;c[b+((c[d>>2]|0)+ -12<<2)>>2]=5;c[b+((c[d>>2]|0)+ -11<<2)>>2]=6;c[b+((c[d>>2]|0)+ -10<<2)>>2]=7;c[b+((c[d>>2]|0)+ -9<<2)>>2]=12;c[b+((c[d>>2]|0)+ -8<<2)>>2]=18;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function JGa(a,b){a=a|0;b=b|0;var d=0;d=a+120|0;c[b+((c[d>>2]|0)+ -13<<2)>>2]=0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=1;c[b+((c[d>>2]|0)+ -11<<2)>>2]=2;c[b+((c[d>>2]|0)+ -10<<2)>>2]=3;c[b+((c[d>>2]|0)+ -9<<2)>>2]=12;c[b+((c[d>>2]|0)+ -8<<2)>>2]=18;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function KGa(a,b){a=a|0;b=b|0;var d=0;d=a+116|0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=24;c[b+((c[d>>2]|0)+ -2<<2)>>2]=28;c[b+((c[d>>2]|0)+ -1<<2)>>2]=29;i=i;return}function LGa(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=29;i=i;return}function MGa(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=28;i=i;return}function NGa(a,b){a=a|0;b=b|0;var d=0;d=a+104|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=12;c[b+((c[d>>2]|0)+ -10<<2)>>2]=18;c[b+((c[d>>2]|0)+ -9<<2)>>2]=24;c[b+((c[d>>2]|0)+ -8<<2)>>2]=27;c[b+((c[d>>2]|0)+ -7<<2)>>2]=28;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function OGa(a,b){a=a|0;b=b|0;var d=0;d=a+100|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=12;c[b+((c[d>>2]|0)+ -10<<2)>>2]=18;c[b+((c[d>>2]|0)+ -9<<2)>>2]=24;c[b+((c[d>>2]|0)+ -8<<2)>>2]=27;c[b+((c[d>>2]|0)+ -7<<2)>>2]=28;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function PGa(a,b){a=a|0;b=b|0;var d=0;d=a+96|0;c[b+((c[d>>2]|0)+ -13<<2)>>2]=12;c[b+((c[d>>2]|0)+ -12<<2)>>2]=18;c[b+((c[d>>2]|0)+ -11<<2)>>2]=24;c[b+((c[d>>2]|0)+ -10<<2)>>2]=25;c[b+((c[d>>2]|0)+ -9<<2)>>2]=27;c[b+((c[d>>2]|0)+ -8<<2)>>2]=28;c[b+((c[d>>2]|0)+ -7<<2)>>2]=29;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function QGa(a,b){a=a|0;b=b|0;var d=0;d=a+92|0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=18;c[b+((c[d>>2]|0)+ -2<<2)>>2]=22;c[b+((c[d>>2]|0)+ -1<<2)>>2]=23;i=i;return}function RGa(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=23;i=i;return}function SGa(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=22;i=i;return}function TGa(a,b){a=a|0;b=b|0;var d=0;d=a+80|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=12;c[b+((c[d>>2]|0)+ -10<<2)>>2]=18;c[b+((c[d>>2]|0)+ -9<<2)>>2]=21;c[b+((c[d>>2]|0)+ -8<<2)>>2]=22;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function UGa(a,b){a=a|0;b=b|0;var d=0;d=a+76|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=12;c[b+((c[d>>2]|0)+ -10<<2)>>2]=18;c[b+((c[d>>2]|0)+ -9<<2)>>2]=21;c[b+((c[d>>2]|0)+ -8<<2)>>2]=22;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function VGa(a,b){a=a|0;b=b|0;var d=0;d=a+72|0;c[b+((c[d>>2]|0)+ -13<<2)>>2]=12;c[b+((c[d>>2]|0)+ -12<<2)>>2]=18;c[b+((c[d>>2]|0)+ -11<<2)>>2]=19;c[b+((c[d>>2]|0)+ -10<<2)>>2]=21;c[b+((c[d>>2]|0)+ -9<<2)>>2]=22;c[b+((c[d>>2]|0)+ -8<<2)>>2]=23;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function WGa(a,b){a=a|0;b=b|0;var d=0;d=a+68|0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=12;c[b+((c[d>>2]|0)+ -2<<2)>>2]=16;c[b+((c[d>>2]|0)+ -1<<2)>>2]=17;i=i;return}function XGa(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=17;i=i;return}function YGa(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=16;i=i;return}function ZGa(a,b){a=a|0;b=b|0;var d=0;d=a+56|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=12;c[b+((c[d>>2]|0)+ -10<<2)>>2]=15;c[b+((c[d>>2]|0)+ -9<<2)>>2]=16;c[b+((c[d>>2]|0)+ -8<<2)>>2]=18;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function _Ga(a,b){a=a|0;b=b|0;var d=0;d=a+52|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=12;c[b+((c[d>>2]|0)+ -10<<2)>>2]=15;c[b+((c[d>>2]|0)+ -9<<2)>>2]=16;c[b+((c[d>>2]|0)+ -8<<2)>>2]=18;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function $Ga(a,b){a=a|0;b=b|0;var d=0;d=a+48|0;c[b+((c[d>>2]|0)+ -13<<2)>>2]=12;c[b+((c[d>>2]|0)+ -12<<2)>>2]=13;c[b+((c[d>>2]|0)+ -11<<2)>>2]=15;c[b+((c[d>>2]|0)+ -10<<2)>>2]=16;c[b+((c[d>>2]|0)+ -9<<2)>>2]=17;c[b+((c[d>>2]|0)+ -8<<2)>>2]=18;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function aHa(a,b){a=a|0;b=b|0;var d=0;d=a+44|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=8;c[b+((c[d>>2]|0)+ -10<<2)>>2]=9;c[b+((c[d>>2]|0)+ -9<<2)>>2]=12;c[b+((c[d>>2]|0)+ -8<<2)>>2]=18;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function bHa(a,b){a=a|0;b=b|0;var d=0;d=a+40|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=9;c[b+((c[d>>2]|0)+ -10<<2)>>2]=10;c[b+((c[d>>2]|0)+ -9<<2)>>2]=12;c[b+((c[d>>2]|0)+ -8<<2)>>2]=18;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function cHa(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=10;i=i;return}function dHa(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=9;i=i;return}function eHa(a,b){a=a|0;b=b|0;var d=0;d=a+28|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=4;c[b+((c[d>>2]|0)+ -10<<2)>>2]=5;c[b+((c[d>>2]|0)+ -9<<2)>>2]=12;c[b+((c[d>>2]|0)+ -8<<2)>>2]=18;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function fHa(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=5;c[b+((c[d>>2]|0)+ -10<<2)>>2]=6;c[b+((c[d>>2]|0)+ -9<<2)>>2]=12;c[b+((c[d>>2]|0)+ -8<<2)>>2]=18;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function gHa(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=6;i=i;return}function hHa(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=5;i=i;return}function iHa(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=0;c[b+((c[d>>2]|0)+ -10<<2)>>2]=1;c[b+((c[d>>2]|0)+ -9<<2)>>2]=12;c[b+((c[d>>2]|0)+ -8<<2)>>2]=18;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function jHa(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=1;c[b+((c[d>>2]|0)+ -10<<2)>>2]=2;c[b+((c[d>>2]|0)+ -9<<2)>>2]=12;c[b+((c[d>>2]|0)+ -8<<2)>>2]=18;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function kHa(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=2;i=i;return}function lHa(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=1;i=i;return}function mHa(a){a=a|0;i=i;return 1}function nHa(a){a=a|0;i=i;return 1}function oHa(a){a=a|0;i=i;return 1}function pHa(a){a=a|0;i=i;return 0}function qHa(a){a=a|0;i=i;return 0}function rHa(a){a=a|0;i=i;return 0}function sHa(a){a=a|0;i=i;return 0}function tHa(a){a=a|0;i=i;return 0}function uHa(a,b){a=a|0;b=b|0;i=i;return-1}function vHa(a,b){a=a|0;b=b|0;i=i;return-1}function wHa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function xHa(){i=i;return 104736}function yHa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function zHa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function AHa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function BHa(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);Ab(106824,n|0)|0;i=m;return 0}function CHa(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=WOa(a,106832)|0;z=WOa(b,106832)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((WOa(a,106840)|0)!=0){C=5;break}if((WOa(a,106848)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((WOa(b,106840)|0)!=0){break}if((WOa(b,106848)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){dgb(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}dgb(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}dgb(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);Ab(106856,r|0)|0;i=q;return 0}function DHa(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(WOa(a,106864)|0)!=0;v=c[(u?f:g)>>2]|0;w=WOa(e,106872)|0;x=WOa(b,106880)|0;c[p>>2]=0;do{if(u){y=4}else{if((WOa(a,106888)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((WOa(b,106864)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((WOa(d,106872)|0)==0){if((WOa(d,106896)|0)!=0){break}if((WOa(d,106904)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((WOa(e,106880)|0)==0){if((WOa(e,106872)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){dgb(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(WOa(d,106872)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);Ab(106912,p|0)|0;i=o;return 0}function EHa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}GHa(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}HHa(106928,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;Ab(106920,l|0)|0;i=k;return 0}function FHa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+DOa(106952);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(yHa(l,z,106960)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){AHa(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;zHa(l,n,d+(x-o+v<<3)|0,106960)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;BHa(l,m,106968,d+(B+y<<3)|0,106960,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;Ab(106944,k|0)|0;i=j;return 0}function GHa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=107e3;u=JHa(106984,106976,106992,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;FHa(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;IHa(k,d,e,m,l,f,106984)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;IHa(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,106984)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;DHa(107008,107016,107024,107040,n,k,107048,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=107024;CHa(H,H,k,l,n,107056,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,107048,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);FHa(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;Ab(106976,j|0)|0;i=h;return 0}function HHa(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(WOa(a,107064)|0)!=0;do{if(n){o=5}else{if((WOa(a,107072)|0)!=0){o=5;break}if((WOa(a,107080)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=107096;IHa(d,h,j,q,b,g,q)|0;DHa(107104,107112,107120,107136,b,d,107144,e,f,h,j)|0;DHa(107104,107152,107120,107160,b,d,107144,e,f,h,j)|0;i=l;return 0}else{DHa(107104,107152,107176,107160,b,d,107144,e,f,h,j)|0;DHa(107104,107112,107176,107136,b,d,107144,e,f,h,j)|0;IHa(d,h,j,107096,b,g,107192)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;Ab(107088,m|0)|0;i=l;return 0}function IHa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}




// EMSCRIPTEN_END_FUNCS
var be=[chb,lPa,nPa,sPa,A2a,chb,chb,chb];var ce=[dhb,PJa,QJa,tKa,uKa,YKa,ZKa,uLa,vLa,wLa,tfb,sfb,rfb,QNa,hJa,iJa,TMa,RMa,dhb,dhb,dhb,dhb,dhb,dhb,dhb,dhb,dhb,dhb,dhb,dhb,dhb,dhb];var de=[ehb,aRa];var ee=[fhb,ZPa];var fe=[ghb,Dp,Ep,Dt,mu,q5,ou,OMa,mTa,pTa,oTa,qTa,y7a,x7a,A7a,z7a,rTa,tTa,FWa,bXa,cXa,dXa,j7a,i7a,l7a,k7a,Y1a,j2a,k2a,l2a,n2a,p2a,f4a,g4a,m4a,n4a,t4a,u4a,A4a,B4a,N4a,M4a,S4a,R4a,U4a,V4a,c5a,b5a,j6a,i6a,s6a,r6a,W6a,V6a,s7a,r7a,u7a,t7a,M7a,L7a,O7a,N7a,U7a,T7a,h6a,V7a,S7a,W7a,Y7a,X7a,ecb,c8a,b8a,h8a,g8a,G8a,F8a,i9a,h9a,w9a,v9a,K9a,J9a,Y9a,X9a,jab,iab,mab,lab,qab,pab,Bab,Aab,Mab,Lab,Xab,Wab,gbb,fbb,qbb,pbb,ybb,xbb,Ebb,Dbb,Kbb,Jbb,Pbb,Obb,Ybb,Xbb,ucb,tcb,Tbb,Lcb,qdb,pdb,sdb,rdb,Z7a,dcb,gcb,Dcb,Tcb,cdb,ndb,odb,efb,dfb,gfb,jfb,hfb,ifb,kfb,lfb,Ifb,Hfb,yp,hhb,Fp,Gp,Hp,Kp,Lp,Mp,Pp,Qp,Rp,Up,Vp,Wp,Zp,_p,$p,cq,dq,eq,zo,yo,xo,wo,vo,uo,to,cf,df,ef,ff,gf,hf,jf,uf,Hf,Kf,Mf,Of,Pf,Tf,Wf,Xf,$f,eg,gg,hg,lg,og,pg,tg,yg,Ag,Bg,Fg,Ig,Jg,Ng,Sg,Ug,Vg,Zg,ah,bh,eh,gh,hh,lh,oh,ph,sh,uh,vh,zh,Ch,Dh,Fh,Gh,Hh,$h,ai,bi,ci,ji,ki,li,mi,ti,ui,vi,wi,Ei,Fi,Ni,Oi,Wi,Xi,aj,bj,dj,ej,fj,gj,hj,ij,kj,xj,yj,zj,Aj,Bj,Jj,Lj,Oj,Pj,Rj,Sj,Tj,Uj,Vj,Wj,Xj,Yj,Zj,_j,ak,nk,ok,pk,qk,rk,Mk,Pk,Sk,Vk,Wk,Xk,Yk,Zk,_k,al,dl,gl,jl,kl,ll,ml,nl,ol,ql,tl,wl,zl,Al,Bl,Cl,Dl,El,Gl,Hl,Jl,Kl,Ml,Nl,Tl,Ul,Zl,_l,$l,am,bm,cm,dm,em,fm,gm,mm,nm,om,pm,qm,rm,sm,tm,um,vm,wm,xm,ym,zm,Am,Bm,Cm,Dm,Em,Fm,Gm,Hm,Im,Jm,Km,Lm,Mm,Nm,Om,Pm,Qm,Rm,Sm,Tm,Um,Vm,Wm,Ym,kn,ln,mn,nn,on,qn,Dn,En,Fn,Gn,Hn,Jn,Wn,Xn,Yn,Zn,_n,ao,oo,po,qo,ro,so,Ao,Bo,Co,Do,Eo,Fo,Go,Ho,Io,Jo,Ko,Lo,Mo,No,Oo,Po,Qo,Ro,So,To,Uo,Vo,Wo,Xo,Yo,Zo,_o,$o,ap,bp,cp,dp,ep,fp,gp,hp,ip,jp,kp,lp,mp,np,op,pp,qp,rp,sp,tp,yfb,QMa,Ze,JPa,NPa,IPa,dRa,PPa,bRa,lOa,SPa,QPa,RPa,OPa,UPa,cRa,VPa,KPa,XPa,H1a,YPa,F3a,e4a,fcb,_db,ibb,feb,eeb,deb,ceb,beb,aeb,s5a,W5a,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb,ghb];var ge=[ihb,nu,KRa,uTa,J6a,h4a,o4a,v4a,C4a,X6a,tab,uab,vab,wab,yab,zab,Eab,Fab,Gab,Hab,Jab,Kab,Pab,Qab,Rab,Sab,Uab,Vab,_ab,$ab,abb,bbb,dbb,ebb,Nbb,Sbb,xdb,zdb,Bdb,ydb,Adb,Cdb,APa,Ip,Np,Sp,Xp,aq,fq,hq,pq,rq,zq,Bq,Jq,Bt,Et,Ft,Gt,Ht,It,Jt,Kt,Lt,Mt,Nt,Ot,Pt,Qt,Rt,St,Tt,Ut,Vt,Wt,Xt,Yt,Zt,_t,$t,au,bu,cu,du,eu,fu,gu,hu,iu,ju,ku,lu,TPa,lWa,MRa,LRa,NRa,TRa,dSa,ORa,bSa,AVa,MVa,LVa,NVa,vVa,tVa,xVa,O2a,ihb,ihb,ihb,ihb,ihb,ihb,ihb,ihb,ihb,ihb,ihb,ihb,ihb,ihb,ihb,ihb,ihb,ihb,ihb];var he=[jhb,wJa,pJa,mPa,oPa,pPa,qPa,rPa];var ie=[khb,vp,tGa,up,$e,af,bf,r5,f6,uu,p5,sGa,BGa,tu,ru,CGa,DGa,mHa,nHa,oHa,pHa,qHa,rHa,sHa,tHa,lhb,mhb,nhb,iNa,xfb,ohb,yTa,O6a,zTa,R6a,N6a,s2a,i4a,a7a,c7a,d7a,$6a,p4a,q4a,w4a,Q6a,D4a,E4a,O4a,T4a,Q7a,L9a,Ddb,Fdb,Hdb,Ndb,Pdb,Jdb,Ldb,Z9a,Edb,Gdb,Idb,Odb,Qdb,Kdb,Mdb,rab,sab,xab,Cab,Dab,Iab,Nab,Oab,Tab,Yab,Zab,cbb,Pcb,Qcb,Scb,tdb,vdb,udb,wdb,Hcb,Icb,Kcb,Zcb,_cb,bdb,idb,jdb,mdb,ffb,Jfb,kRa,phb,qhb,iRa,jRa,rhb,A1a,b2a,gQa,oQa,AQa,hQa,rQa,BQa,Y3a,Sfb,khb,khb,khb,khb,khb,khb,khb,khb,khb,khb,khb,khb,khb,khb,khb];var je=[shb,ONa];var ke=[thb,XOa];var le=[uhb,qu,GJa,MJa,kKa,qKa,PKa,VKa,vTa,P6a,T6a,K6a,Y6a,b7a,j4a,f7a,x4a,Y4a,Z4a,a8a,f8a,Lbb,Qbb,wcb,ycb,Bcb,hcb,mcb,ocb,rcb,mfb,J1a,PNa,tJa,kJa,rJa,xJa,vhb,whb,xhb,eRa,G1a,C1a,yhb,Q3a,zhb,uhb,uhb,uhb,uhb,uhb,uhb,uhb,uhb,uhb,uhb,uhb,uhb,uhb,uhb,uhb,uhb,uhb,uhb];var me=[Ahb,$Oa];var ne=[Bhb,tOa];var oe=[Chb,q9a,t9a,E9a,G9a,Chb,Chb,Chb];var pe=[Dhb,kab,nab,hbb,lbb,rbb,tbb,Dhb];var qe=[Ehb,VOa];var re=[Fhb,LMa,wTa,q2a,Z6a,L6a,j9a,k9a,o9a,u9a,x9a,y9a,C9a,H9a,Mbb,Rbb,wfb,vfb,ufb,MMa,Fhb,Fhb,Fhb,Fhb,Fhb,Fhb,Fhb,Fhb,Fhb,Fhb,Fhb,Fhb];var se=[Ghb,pQa,qQa,Ghb];var te=[Hhb,xp];var ue=[Ihb,i8a,k8a,m8a,o8a,q8a,s8a,u8a,w8a,y8a,A8a,C8a,H8a,J8a,L8a,N8a,P8a,R8a,T8a,V8a,X8a,Z8a,$8a,n9a,p9a,B9a,D9a,M9a,N9a,O9a,P9a,Q9a,_9a,$9a,aab,bab,cab,Cbb,Ibb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb,Ihb];var ve=[Jhb,zbb,Fbb,Jhb];var we=[Khb,R9a,dab,Khb];var xe=[Lhb,_e,vu,su,pu,uHa,vHa,IJa,JJa,LJa,mKa,nKa,pKa,RKa,SKa,UKa,_Ka,$Ka,aLa,bLa,cLa,dLa,eLa,fLa,ATa,BTa,t2a,u2a,e7a,k4a,r4a,g7a,S6a,y4a,F4a,U6a,vcb,xcb,zcb,lcb,ncb,pcb,UQa,DQa,tQa,iQa,sQa,CQa,Mhb,Afb,eJa,fJa,gJa,Nhb,vNa,wQa,zQa,lQa,QQa,HQa,nQa,Ohb,Reb,Lhb];var ye=[Phb,_7a,d8a,Ccb,Ocb,Rcb,scb,Gcb,Jcb,Ycb,$cb,hdb,kdb,CLa,tMa,uMa,HLa,ELa,rMa,sMa,ILa,JLa,KLa,LLa,MLa,hMa,iMa,_La,TLa,OLa,NLa,PLa,QLa,SLa,RLa,FLa,DLa,ULa,VLa,WLa,XLa,YLa,ZLa,$La,aMa,bMa,cMa,gMa,eMa,dMa,fMa,nMa,jMa,kMa,lMa,mMa,oMa,pMa,qMa,vMa,wMa,xMa,yMa,l9a];var ze=[Qhb,pRa];var Ae=[Rhb,EQa];var Be=[Shb,DOa];var Ce=[Thb,xHa,Uhb,jNa,b4a,c4a,$3a,Thb];var De=[Vhb,_Oa];var Ee=[Whb,L1a,M1a,X4a,R7a,JNa,WMa,FRa,HRa,kWa,N2a,Whb,Whb,Whb,Whb,Whb];var Fe=[Xhb,Yhb,hNa,BMa,Ap,Xhb,Xhb,Xhb];var Ge=[Zhb,wHa,Mcb,Ncb,Ecb,Fcb,Ucb,Wcb,ddb,fdb,IQa,Zhb,Zhb,Zhb,Zhb,Zhb];var He=[_hb,AJa,BJa,CJa,DJa,EJa,FJa,HJa,KJa,OJa,eKa,fKa,gKa,hKa,iKa,jKa,lKa,oKa,sKa,JKa,KKa,LKa,MKa,NKa,OKa,QKa,TKa,XKa,Acb,icb,jcb,kcb,qcb,CPa,$hb,WOa,YIa,$Ha,uIa,DIa,pIa,MIa,RIa,PIa,SIa,yJa,cJa,mJa,nJa,uJa,vJa,E8a,r9a,aib,_hb,_hb,_hb,_hb,_hb,_hb,_hb,_hb,_hb,_hb];var Ie=[bib,NJa,rKa,WKa,xTa,K1a,r2a,_6a,M6a,$7a,e8a,nfb,ofb,pfb,UMa,SMa,EPa,VMa,Jp,Op,Tp,Yp,bq,gq,iq,qq,sq,Aq,Cq,Kq,Ct,g3a,oJa,XMa,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib,bib];return{_testSetjmp:mgb,_saveSetjmp:_fb,_free:yfb,_main:zp,_rand_r:ggb,_realloc:Afb,_i64Add:jgb,_memmove:cgb,_bitshift64Ashr:agb,_memset:dgb,_malloc:xfb,_strncpy:kgb,_memcpy:bgb,_strlen:$fb,_bitshift64Lshr:lgb,_bitshift64Shl:egb,_i64Subtract:igb,_strcpy:fgb,_calloc:zfb,_rand:hgb,__GLOBAL__I_a:H4a,runPostSets:Zfb,stackAlloc:Je,stackSave:Ke,stackRestore:Le,setThrew:Me,setTempRet0:Pe,setTempRet1:Qe,setTempRet2:Re,setTempRet3:Se,setTempRet4:Te,setTempRet5:Ue,setTempRet6:Ve,setTempRet7:We,setTempRet8:Xe,setTempRet9:Ye,dynCall_iiiiiiii:wgb,dynCall_viiiii:xgb,dynCall_iiiiidiii:ygb,dynCall_vd:zgb,dynCall_vi:Agb,dynCall_vii:Bgb,dynCall_iiiiiiiiiii:Cgb,dynCall_ii:Dgb,dynCall_viidi:Egb,dynCall_iiiiiiiiiiiiii:Fgb,dynCall_iiii:Ggb,dynCall_iiiiiiiiiiiiiiiiiiiiiii:Hgb,dynCall_iiiiiiiiiiiiiiiiiiiii:Igb,dynCall_viiiiid:Jgb,dynCall_viiiiiiii:Kgb,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:Lgb,dynCall_viiiiii:Mgb,dynCall_viidii:Ngb,dynCall_iid:Ogb,dynCall_viiiiiii:Pgb,dynCall_viiiiiid:Qgb,dynCall_viiiiiiiii:Rgb,dynCall_iii:Sgb,dynCall_iiiiii:Tgb,dynCall_iiiiidi:Ugb,dynCall_didd:Vgb,dynCall_dii:Wgb,dynCall_i:Xgb,dynCall_iiiiiiiiii:Ygb,dynCall_viii:Zgb,dynCall_v:_gb,dynCall_iiiiiiiii:$gb,dynCall_iiiii:ahb,dynCall_viiii:bhb}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_lis_matrix_assemble": _lis_matrix_assemble, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "__reallyNegative": __reallyNegative, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_get_values": _lis_vector_get_values, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_lis_matrix_set_size": _lis_matrix_set_size, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_lis_solve": _lis_solve, "_strtoull_l": _strtoull_l, "_mkport": _mkport, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_lis_matrix_set_type": _lis_matrix_set_type, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "_vsnprintf": _vsnprintf, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_lis_vector_set_value": _lis_vector_set_value, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_lis_matrix_destroy": _lis_matrix_destroy, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "___cxa_is_number_type": ___cxa_is_number_type, "_ungetc": _ungetc, "_system": _system, "_fmin": _fmin, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_lis_solver_destroy": _lis_solver_destroy, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_fscanf": _fscanf, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_matrix_create": _lis_matrix_create, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






